#!/usr/bin/python
#
#   splbuild.pl
#
#   SPL component builder: Main module
#
#   $Date: 2008/03/02 22:41:06 $
#   $Revision: 1.12 $
#   $Author: akapusti $
#
#   Copyright (C) 2007-2008 Cybernetic Intelligence GmbH
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   as published by the Free Software Foundation; either version 2
#   of the License, or (at your option) any later version.
#   
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#   
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software Foundation,
#   Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##########
import sys, os
from splbuild_project import *
from splbuild_project_reader import *
from splbuild_builder import *

#   Helpers
def buildProjectAndDependencies(projectFileName):
    """Builds this project along with all its dependencies"""
    #   Read this project
    project = ProjectReader.readProjectFile(projectFileName)
    #   Build all dependencies
    for dependencyFileName in project.dependencies:
        buildProjectAndDependencies(dependencyFileName)
    #   Build this project
    projectClosure = ProjectReader.readProjectClosure(project.projectFileName)
    project.builder.build(project, projectClosure)

#   Program's entry point
if __name__ == "__main__":
    if len(sys.argv) <= 1:
        print "Usage:"
        print "    python " + sys.argv[0] + " <project file> ..."
        sys.exit(0)
    #   Load plug-ins
    for root, dirs, files in os.walk(os.path.join(os.path.dirname(sys.argv[0]), "plugins")):
        for file in files:
            if file.endswith(".py"):
                if root not in sys.path:
                    sys.path.append(root)
                __import__(file[0:-3])
    #   Go!
    for projectFile in sys.argv[1:]:
        buildProjectAndDependencies(projectFile)

#   End of splbuild.pl
