//
//  CriticalSection.cpp - Implementation of the carl::CriticalSection class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:51 $
//  $Revision: 1.5 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "CriticalSectionImpl.hpp"

//////////
//  Construction
CriticalSection::CriticalSection()
{
    _pImpl = (_impl::_CriticalSectionImpl*)malloc(sizeof(_impl::_CriticalSectionImpl));
    if (_pImpl == NULL)
    {
        throw OutOfMemoryError(sizeof(_impl::_CriticalSectionImpl));
    }
    _pImpl->initialize();
}

CriticalSection::~CriticalSection()
{
    _pImpl->deinitialize();
    free(_pImpl);
}

//////////
//  Operations
void CriticalSection::enter()
{
    _pImpl->enter();
}

void CriticalSection::leave()
{
    _pImpl->leave();
}

//  End of CriticalSection.cpp
