//
//  DateTimeFormatManager.cpp - Implementation of the carl::_impl::_DateTimeFormatManager class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.8 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "DateTimeFormatImpl.hpp"

//////////
//  Resource keys
const char * _impl::_DateTimeFormatManager::ShortDateTimeFormatStringMinutes = "ShortDateTimeFormatStringMinutes";
const char * _impl::_DateTimeFormatManager::MediumDateTimeFormatStringMinutes = "MediumDateTimeFormatStringMinutes";
const char * _impl::_DateTimeFormatManager::LongDateTimeFormatStringMinutes = "LongDateTimeFormatStringMinutes";
const char * _impl::_DateTimeFormatManager::FullDateTimeFormatStringMinutes = "FullDateTimeFormatStringMinutes";

const char * _impl::_DateTimeFormatManager::ShortDateTimeFormatStringSeconds = "ShortDateTimeFormatStringSeconds";
const char * _impl::_DateTimeFormatManager::MediumDateTimeFormatStringSeconds = "MediumDateTimeFormatStringSeconds";
const char * _impl::_DateTimeFormatManager::LongDateTimeFormatStringSeconds = "LongDateTimeFormatStringSeconds";
const char * _impl::_DateTimeFormatManager::FullDateTimeFormatStringSeconds = "FullDateTimeFormatStringSeconds";

const char * _impl::_DateTimeFormatManager::ShortDateTimeFormatStringMilliseconds = "ShortDateTimeFormatStringMilliseconds";
const char * _impl::_DateTimeFormatManager::MediumDateTimeFormatStringMilliseconds = "MediumDateTimeFormatStringMilliseconds";
const char * _impl::_DateTimeFormatManager::LongDateTimeFormatStringMilliseconds = "LongDateTimeFormatStringMilliseconds";
const char * _impl::_DateTimeFormatManager::FullDateTimeFormatStringMilliseconds = "FullDateTimeFormatStringMilliseconds";

const char * _impl::_DateTimeFormatManager::ShortDateTimeFormatStringMicroseconds = "ShortDateTimeFormatStringMicroseconds";
const char * _impl::_DateTimeFormatManager::MediumDateTimeFormatStringMicroseconds = "MediumDateTimeFormatStringMicroseconds";
const char * _impl::_DateTimeFormatManager::LongDateTimeFormatStringMicroseconds = "LongDateTimeFormatStringMicroseconds";
const char * _impl::_DateTimeFormatManager::FullDateTimeFormatStringMicroseconds = "FullDateTimeFormatStringMicroseconds";

const char * _impl::_DateTimeFormatManager::ShortDateTimeFormatStringNanoseconds = "ShortDateTimeFormatStringNanoseconds";
const char * _impl::_DateTimeFormatManager::MediumDateTimeFormatStringNanoseconds = "MediumDateTimeFormatStringNanoseconds";
const char * _impl::_DateTimeFormatManager::LongDateTimeFormatStringNanoseconds = "LongDateTimeFormatStringNanoseconds";
const char * _impl::_DateTimeFormatManager::FullDateTimeFormatStringNanoseconds = "FullDateTimeFormatStringNanoseconds";

const char * _impl::_DateTimeFormatManager::ShortDateFormatString = "ShortDateFormatString";
const char * _impl::_DateTimeFormatManager::MediumDateFormatString = "MediumDateFormatString";
const char * _impl::_DateTimeFormatManager::LongDateFormatString = "LongDateFormatString";
const char * _impl::_DateTimeFormatManager::FullDateFormatString = "FullDateFormatString";

const char * _impl::_DateTimeFormatManager::TimeFormatStringMinutes = "TimeFormatStringMinutes";
const char * _impl::_DateTimeFormatManager::TimeFormatStringSeconds = "TimeFormatStringSeconds";
const char * _impl::_DateTimeFormatManager::TimeFormatStringMilliseconds = "TimeFormatStringMilliseconds";
const char * _impl::_DateTimeFormatManager::TimeFormatStringMicroseconds = "TimeFormatStringMicroseconds";
const char * _impl::_DateTimeFormatManager::TimeFormatStringNanoseconds = "TimeFormatStringNanoseconds";

const char * _impl::_DateTimeFormatManager::ShortJanuaryMonthName = "ShortJanuaryMonthName";
const char * _impl::_DateTimeFormatManager::ShortFebruaryMonthName = "ShortFebruaryMonthName";
const char * _impl::_DateTimeFormatManager::ShortMarchMonthName = "ShortMarchMonthName";
const char * _impl::_DateTimeFormatManager::ShortAprilMonthName = "ShortAprilMonthName";
const char * _impl::_DateTimeFormatManager::ShortMayMonthName = "ShortMayMonthName";
const char * _impl::_DateTimeFormatManager::ShortJuneMonthName = "ShortJuneMonthName";
const char * _impl::_DateTimeFormatManager::ShortJulyMonthName = "ShortJulyMonthName";
const char * _impl::_DateTimeFormatManager::ShortAugustMonthName = "ShortAugustMonthName";
const char * _impl::_DateTimeFormatManager::ShortSeptemberMonthName = "ShortSeptemberMonthName";
const char * _impl::_DateTimeFormatManager::ShortOctoberMonthName = "ShortOctoberMonthName";
const char * _impl::_DateTimeFormatManager::ShortNovemberMonthName = "ShortNovemberMonthName";
const char * _impl::_DateTimeFormatManager::ShortDecemberMonthName = "ShortDecemberMonthName";

const char * _impl::_DateTimeFormatManager::LongJanuaryMonthName = "LongJanuaryMonthName";
const char * _impl::_DateTimeFormatManager::LongFebruaryMonthName = "LongFebruaryMonthName";
const char * _impl::_DateTimeFormatManager::LongMarchMonthName = "LongMarchMonthName";
const char * _impl::_DateTimeFormatManager::LongAprilMonthName = "LongAprilMonthName";
const char * _impl::_DateTimeFormatManager::LongMayMonthName = "LongMayMonthName";
const char * _impl::_DateTimeFormatManager::LongJuneMonthName = "LongJuneMonthName";
const char * _impl::_DateTimeFormatManager::LongJulyMonthName = "LongJulyMonthName";
const char * _impl::_DateTimeFormatManager::LongAugustMonthName = "LongAugustMonthName";
const char * _impl::_DateTimeFormatManager::LongSeptemberMonthName = "LongSeptemberMonthName";
const char * _impl::_DateTimeFormatManager::LongOctoberMonthName = "LongOctoberMonthName";
const char * _impl::_DateTimeFormatManager::LongNovemberMonthName = "LongNovemberMonthName";
const char * _impl::_DateTimeFormatManager::LongDecemberMonthName = "LongDecemberMonthName";

const char * _impl::_DateTimeFormatManager::ShortSundayWeekdayName = "ShortSundayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortMondayWeekdayName = "ShortMondayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortTuesdayWeekdayName = "ShortTuesdayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortWednesdayWeekdayName = "ShortWednesdayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortThursdayWeekdayName = "ShortThursdayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortFridayWeekdayName = "ShortFridayWeekdayName";
const char * _impl::_DateTimeFormatManager::ShortSaturdayWeekdayName = "ShortSaturdayWeekdayName";

const char * _impl::_DateTimeFormatManager::LongSundayWeekdayName = "LongSundayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongMondayWeekdayName = "LongMondayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongTuesdayWeekdayName = "LongTuesdayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongWednesdayWeekdayName = "LongWednesdayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongThursdayWeekdayName = "LongThursdayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongFridayWeekdayName = "LongFridayWeekdayName";
const char * _impl::_DateTimeFormatManager::LongSaturdayWeekdayName = "LongSaturdayWeekdayName";

const char * _impl::_DateTimeFormatManager::AmString = "AmString";
const char * _impl::_DateTimeFormatManager::PmString = "PmString";

//////////
//  Singleton
_impl::_DateTimeFormatManager::_DateTimeFormatManager()
    :   _resourceFactory(new _DateTimeFormatResourceMap_en(), carl::String("CARL_DATETIMEFORMAT")),
        _mapLocalesToDateTimeFormats(StandardHashFunctions::hashLocale),
        _mapLocalesToDateFormats(StandardHashFunctions::hashLocale),
        _mapLocalesToTimeFormats(StandardHashFunctions::hashLocale),
        _mapLocalesToDateTimeParses(StandardHashFunctions::hashLocale),
        _mapLocalesToDateParses(StandardHashFunctions::hashLocale),
        _mapLocalesToTimeParses(StandardHashFunctions::hashLocale)
{
}

_impl::_DateTimeFormatManager::~_DateTimeFormatManager()
{
    for (UIntSize i = 0; i < _autoDeletedDateTimeFormats.size(); i++)
    {
        delete _autoDeletedDateTimeFormats[i];
    }
    for (UIntSize i = 0; i < _autoDeletedDateFormats.size(); i++)
    {
        delete _autoDeletedDateFormats[i];
    }
    for (UIntSize i = 0; i < _autoDeletedTimeFormats.size(); i++)
    {
        delete _autoDeletedTimeFormats[i];
    }
    for (UIntSize i = 0; i < _autoDeletedDateTimeParses.size(); i++)
    {
        delete _autoDeletedDateTimeParses[i];
    }
    for (UIntSize i = 0; i < _autoDeletedDateParses.size(); i++)
    {
        delete _autoDeletedDateParses[i];
    }
    for (UIntSize i = 0; i < _autoDeletedTimeParses.size(); i++)
    {
        delete _autoDeletedTimeParses[i];
    }
}

_impl::_DateTimeFormatManager * _impl::_DateTimeFormatManager::getInstance()
{
    static _DateTimeFormatManager instance;
    return &instance;
}

//////////
//  Operations
MapResourceFactory * _impl::_DateTimeFormatManager::getResourceFactory() const
{
    return &_resourceFactory;
}

DateTimeFormat * _impl::_DateTimeFormatManager::getDateTimeFormat(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToDateTimeFormats.containsKey(locale))
        {
            return _mapLocalesToDateTimeFormats.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultDateTimeFormat * pDefaultDateTimeFormat = new _DefaultDateTimeFormat(forLocale);
    _autoDeletedDateTimeFormats.append(pDefaultDateTimeFormat);
    _mapLocalesToDateTimeFormats.insert(forLocale, pDefaultDateTimeFormat);
    return pDefaultDateTimeFormat;
}

DateFormat * _impl::_DateTimeFormatManager::getDateFormat(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToDateFormats.containsKey(locale))
        {
            return _mapLocalesToDateFormats.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultDateFormat * pDefaultDateFormat = new _DefaultDateFormat(forLocale);
    _autoDeletedDateFormats.append(pDefaultDateFormat);
    _mapLocalesToDateFormats.insert(forLocale, pDefaultDateFormat);
    return pDefaultDateFormat;
}

TimeFormat * _impl::_DateTimeFormatManager::getTimeFormat(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToTimeFormats.containsKey(locale))
        {
            return _mapLocalesToTimeFormats.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultTimeFormat * pDefaultTimeFormat = new _DefaultTimeFormat(forLocale);
    _autoDeletedTimeFormats.append(pDefaultTimeFormat);
    _mapLocalesToTimeFormats.insert(forLocale, pDefaultTimeFormat);
    return pDefaultTimeFormat;
}

DateTimeParse * _impl::_DateTimeFormatManager::getDateTimeParse(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToDateTimeParses.containsKey(locale))
        {
            return _mapLocalesToDateTimeParses.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultDateTimeParse * pDefaultDateTimeParse = new _DefaultDateTimeParse(forLocale);
    _autoDeletedDateTimeParses.append(pDefaultDateTimeParse);
    _mapLocalesToDateTimeParses.insert(forLocale, pDefaultDateTimeParse);
    return pDefaultDateTimeParse;
}

DateParse * _impl::_DateTimeFormatManager::getDateParse(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToDateParses.containsKey(locale))
        {
            return _mapLocalesToDateParses.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultDateParse * pDefaultDateParse = new _DefaultDateParse(forLocale);
    _autoDeletedDateParses.append(pDefaultDateParse);
    _mapLocalesToDateParses.insert(forLocale, pDefaultDateParse);
    return pDefaultDateParse;
}

TimeParse * _impl::_DateTimeFormatManager::getTimeParse(const Locale & forLocale)
{
    CriticalSectionLock lock(_guard);
    for (Locale locale = forLocale; ; locale = locale.getParent())
    {
        if (_mapLocalesToTimeParses.containsKey(locale))
        {
            return _mapLocalesToTimeParses.get(locale);
        }
        if (locale.isInvariant())
        {
            break;
        }
    }
    _DefaultTimeParse * pDefaultTimeParse = new _DefaultTimeParse(forLocale);
    _autoDeletedTimeParses.append(pDefaultTimeParse);
    _mapLocalesToTimeParses.insert(forLocale, pDefaultTimeParse);
    return pDefaultTimeParse;
}

void _impl::_DateTimeFormatManager::registerDateTimeFormat(const Locale & forLocale, DateTimeFormat * pDateTimeFormat)
{
    require(pDateTimeFormat != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToDateTimeFormats.insert(forLocale, pDateTimeFormat);
}

void _impl::_DateTimeFormatManager::registerDateFormat(const Locale & forLocale, DateFormat * pDateFormat)
{
    require(pDateFormat != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToDateFormats.insert(forLocale, pDateFormat);
}

void _impl::_DateTimeFormatManager::registerTimeFormat(const Locale & forLocale, TimeFormat * pTimeFormat)
{
    require(pTimeFormat != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToTimeFormats.insert(forLocale, pTimeFormat);
}

void _impl::_DateTimeFormatManager::registerDateTimeParse(const Locale & forLocale, DateTimeParse * pDateTimeParse)
{
    require(pDateTimeParse != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToDateTimeParses.insert(forLocale, pDateTimeParse);
}

void _impl::_DateTimeFormatManager::registerDateParse(const Locale & forLocale, DateParse * pDateParse)
{
    require(pDateParse != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToDateParses.insert(forLocale, pDateParse);
}

void _impl::_DateTimeFormatManager::registerTimeParse(const Locale & forLocale, TimeParse * pTimeParse)
{
    require(pTimeParse != NULL);

    CriticalSectionLock lock(_guard);
    _mapLocalesToTimeParses.insert(forLocale, pTimeParse);
}

//  End of DateTimeFormatManager.cpp
