//
//  DateTimeFormatResourceMap_en.cpp - Implementation of the carl::_DateTimeFormatResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.4 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "DateTimeFormatImpl.hpp"

//////////
//  Construction/destruction
_impl::_DateTimeFormatResourceMap_en::_DateTimeFormatResourceMap_en()
    :   _mapKeysToValues(StandardHashFunctions::hashString)
{
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateTimeFormatStringMinutes), String("{day:short}/{month:short}/{year:short}, {hour24:short}:{minute:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateTimeFormatStringMinutes), String("{day:short}/{month:full}/{year:full}, {hour24:full}:{minute:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateTimeFormatStringMinutes), String("{day:short} {month_name:short} {year:full}, {hour24:full}:{minute:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateTimeFormatStringMinutes), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}, {hour24:full}:{minute:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateTimeFormatStringSeconds), String("{day:short}/{month:short}/{year:short}, {hour24:short}:{minute:full}:{second:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateTimeFormatStringSeconds), String("{day:short}/{month:full}/{year:full}, {hour24:full}:{minute:full}:{second:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateTimeFormatStringSeconds), String("{day:short} {month_name:short} {year:full}, {hour24:full}:{minute:full}:{second:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateTimeFormatStringSeconds), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}, {hour24:full}:{minute:full}:{second:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateTimeFormatStringMilliseconds), String("{day:short}/{month:short}/{year:short}, {hour24:short}:{minute:full}:{second:full}.{millisecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateTimeFormatStringMilliseconds), String("{day:short}/{month:full}/{year:full}, {hour24:full}:{minute:full}:{second:full}.{millisecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateTimeFormatStringMilliseconds), String("{day:short} {month_name:short} {year:full}, {hour24:full}:{minute:full}:{second:full}.{millisecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateTimeFormatStringMilliseconds), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}, {hour24:full}:{minute:full}:{second:full}.{millisecond:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateTimeFormatStringMicroseconds), String("{day:short}/{month:short}/{year:short}, {hour24:short}:{minute:full}:{second:full}.{microsecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateTimeFormatStringMicroseconds), String("{day:short}/{month:full}/{year:full}, {hour24:full}:{minute:full}:{second:full}.{microsecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateTimeFormatStringMicroseconds), String("{day:short} {month_name:short} {year:full}, {hour24:full}:{minute:full}:{second:full}.{microsecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateTimeFormatStringMicroseconds), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}, {hour24:full}:{minute:full}:{second:full}.{microsecond:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateTimeFormatStringNanoseconds), String("{day:short}/{month:short}/{year:short}, {hour24:short}:{minute:full}:{second:full}.{nanosecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateTimeFormatStringNanoseconds), String("{day:short}/{month:full}/{year:full}, {hour24:full}:{minute:full}:{second:full}.{nanosecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateTimeFormatStringNanoseconds), String("{day:short} {month_name:short} {year:full}, {hour24:full}:{minute:full}:{second:full}.{nanosecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateTimeFormatStringNanoseconds), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}, {hour24:full}:{minute:full}:{second:full}.{nanosecond:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDateFormatString), String("{day:short}/{month:short}/{year:short}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::MediumDateFormatString), String("{day:short}/{month:full}/{year:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDateFormatString), String("{day:short} {month_name:short} {year:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::FullDateFormatString), String("{day_of_week_name:full} {day:full} {month_name:full} {year:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::TimeFormatStringMinutes), String("{hour24:short}:{minute:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::TimeFormatStringSeconds), String("{hour24:short}:{minute:full}:{second:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::TimeFormatStringMilliseconds), String("{hour24:short}:{minute:full}:{second:full}.{millisecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::TimeFormatStringMicroseconds), String("{hour24:short}:{minute:full}:{second:full}.{microsecond:full}"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::TimeFormatStringNanoseconds), String("{hour24:short}:{minute:full}:{second:full}.{nanosecond:full}"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortJanuaryMonthName), String("Jan"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortFebruaryMonthName), String("Feb"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortMarchMonthName), String("Mar"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortAprilMonthName), String("Apr"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortMayMonthName), String("May"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortJuneMonthName), String("Jun"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortJulyMonthName), String("Jul"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortAugustMonthName), String("Aug"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortSeptemberMonthName), String("Sep"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortOctoberMonthName), String("Oct"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortNovemberMonthName), String("Nov"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortDecemberMonthName), String("Dec"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongJanuaryMonthName), String("January"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongFebruaryMonthName), String("February"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongMarchMonthName), String("March"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongAprilMonthName), String("April"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongMayMonthName), String("May"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongJuneMonthName), String("June"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongJulyMonthName), String("July"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongAugustMonthName), String("August"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongSeptemberMonthName), String("September"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongOctoberMonthName), String("October"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongNovemberMonthName), String("November"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongDecemberMonthName), String("December"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortSundayWeekdayName), String("Sun"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortMondayWeekdayName), String("Mon"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortTuesdayWeekdayName), String("Tue"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortWednesdayWeekdayName), String("Wed"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortThursdayWeekdayName), String("Thu"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortFridayWeekdayName), String("Fri"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::ShortSaturdayWeekdayName), String("Sat"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongSundayWeekdayName), String("Sunday"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongMondayWeekdayName), String("Monady"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongTuesdayWeekdayName), String("Tuesday"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongWednesdayWeekdayName), String("Wednesday"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongThursdayWeekdayName), String("Thursday"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongFridayWeekdayName), String("Friday"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::LongSaturdayWeekdayName), String("Saturday"));

    _mapKeysToValues.insert(String(_DateTimeFormatManager::AmString), String("AM"));
    _mapKeysToValues.insert(String(_DateTimeFormatManager::PmString), String("PM"));
}

_impl::_DateTimeFormatResourceMap_en::~_DateTimeFormatResourceMap_en()
{
}

//////////
//  Operations
String _impl::_DateTimeFormatResourceMap_en::getString(const String & key)
{
    if (_mapKeysToValues.containsKey(key))
    {
        return _mapKeysToValues.get(key);
    }
    throw MissingResourceError(key);
}

//  End of DateTimeFormatResourceMap_en.cpp
