//
//  DateTimeResourceMap_en.cpp - Implementation of the carl::_DateTimeResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.7 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "DateTimeImpl.hpp"

//////////
//  Construction/destruction
_impl::_DateTimeResourceMap_en::_DateTimeResourceMap_en()
    :   _mapKeysToValues(StandardHashFunctions::hashString)
{
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SundayShortDisplayName), String("Sun"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MondayShortDisplayName), String("Mon"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::TuesdayShortDisplayName), String("Tue"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::WednesdayShortDisplayName), String("Wed"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::ThursdayShortDisplayName), String("Thu"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::FridayShortDisplayName), String("Fri"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SaturdayShortDisplayName), String("Sat"));

    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SundayLongDisplayName), String("Sunday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MondayLongDisplayName), String("Monday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::TuesdayLongDisplayName), String("Tuesday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::WednesdayLongDisplayName), String("Wednesday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::ThursdayLongDisplayName), String("Thursday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::FridayLongDisplayName), String("Friday"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SaturdayLongDisplayName), String("Saturday"));

    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JanuaryShortDisplayName), String("Jan"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::FebruaryShortDisplayName), String("Feb"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MarchShortDisplayName), String("Mar"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::AprilShortDisplayName), String("Apr"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MayShortDisplayName), String("May"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JuneShortDisplayName), String("Jun"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JulyShortDisplayName), String("Jul"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::AugustShortDisplayName), String("Aug"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SeptemberShortDisplayName), String("Sep"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::OctoberShortDisplayName), String("Oct"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::NovemberShortDisplayName), String("Nov"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::DecemberShortDisplayName), String("Dec"));

    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JanuaryLongDisplayName), String("January"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::FebruaryLongDisplayName), String("February"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MarchLongDisplayName), String("March"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::AprilLongDisplayName), String("April"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::MayLongDisplayName), String("May"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JuneLongDisplayName), String("June"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::JulyLongDisplayName), String("July"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::AugustLongDisplayName), String("August"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::SeptemberLongDisplayName), String("September"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::OctoberLongDisplayName), String("October"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::NovemberLongDisplayName), String("November"));
    _mapKeysToValues.insert(String(_DateTimeManagerImpl::DecemberLongDisplayName), String("December"));

    _mapKeysToValues.insert(String("Afghanistan Standard Time"), String("(GMT+04:30) Kabul"));
    _mapKeysToValues.insert(String("Afghanistan Standard Time:Standard"), String("Afghanistan Standard Time"));
    _mapKeysToValues.insert(String("Afghanistan Standard Time:Daylight"), String("Afghanistan Daylight Time"));
    _mapKeysToValues.insert(String("Alaskan Standard Time"), String("(GMT-09:00) Alaska"));
    _mapKeysToValues.insert(String("Alaskan Standard Time:Standard"), String("Alaskan Standard Time"));
    _mapKeysToValues.insert(String("Alaskan Standard Time:Daylight"), String("Alaskan Daylight Time"));
    _mapKeysToValues.insert(String("Arab Standard Time"), String("(GMT+03:00) Kuwait"));
    _mapKeysToValues.insert(String("Arab Standard Time:Standard"), String("Arab Standard Time"));
    _mapKeysToValues.insert(String("Arab Standard Time:Daylight"), String("Arab Daylight Time"));
    _mapKeysToValues.insert(String("Arabian Standard Time"), String("(GMT+04:00) Abu Dhabi, Muscat"));
    _mapKeysToValues.insert(String("Arabian Standard Time:Standard"), String("Arabian Standard Time"));
    _mapKeysToValues.insert(String("Arabian Standard Time:Daylight"), String("Arabian Standard Time"));
    _mapKeysToValues.insert(String("Arabic Standard Time"), String("(GMT+03:00) Baghdad"));
    _mapKeysToValues.insert(String("Arabic Standard Time:Standard"), String("Arabic Standard Time"));
    _mapKeysToValues.insert(String("Arabic Standard Time:Daylight"), String("Arabic Daylight Time"));
    _mapKeysToValues.insert(String("Atlantic Standard Time"), String("(GMT-04:00) Atlantic Time (Canada)"));
    _mapKeysToValues.insert(String("Atlantic Standard Time:Standard"), String("Atlantic Standard Time"));
    _mapKeysToValues.insert(String("Atlantic Standard Time:Daylight"), String("Atlantic Daylight Time"));
    _mapKeysToValues.insert(String("AUS Central Standard Time"), String("(GMT+09:30) Darwin"));
    _mapKeysToValues.insert(String("AUS Central Standard Time:Standard"), String("AUS Central Standard Time"));
    _mapKeysToValues.insert(String("AUS Central Standard Time:Daylight"), String("AUS Central Daylight Time"));
    _mapKeysToValues.insert(String("AUS Eastern Standard Time"), String("(GMT+10:00) Canberra, Melbourne, Sydney"));
    _mapKeysToValues.insert(String("AUS Eastern Standard Time:Standard"), String("AUS Eastern Standard Time"));
    _mapKeysToValues.insert(String("AUS Eastern Standard Time:Daylight"), String("AUS Eastern Daylight Time"));
    _mapKeysToValues.insert(String("Azores Standard Time"), String("(GMT-01:00) Azores"));
    _mapKeysToValues.insert(String("Azores Standard Time:Standard"), String("Azores Standard Time"));
    _mapKeysToValues.insert(String("Azores Standard Time:Daylight"), String("Azores Daylight Time"));
    _mapKeysToValues.insert(String("Canada Central Standard Time"), String("(GMT-06:00) Saskatchewan"));
    _mapKeysToValues.insert(String("Canada Central Standard Time:Standard"), String("Canada Central Standard Time"));
    _mapKeysToValues.insert(String("Canada Central Standard Time:Daylight"), String("Canada Central Daylight Time"));
    _mapKeysToValues.insert(String("Cape Verde Standard Time"), String("(GMT-01:00) Cape Verde Is."));
    _mapKeysToValues.insert(String("Cape Verde Standard Time:Standard"), String("Cape Verde Standard Time"));
    _mapKeysToValues.insert(String("Cape Verde Standard Time:Daylight"), String("Cape Verde Daylight Time"));
    _mapKeysToValues.insert(String("Caucasus Standard Time"), String("(GMT+04:00) Baku, Tbilisi, Yerevan"));
    _mapKeysToValues.insert(String("Caucasus Standard Time:Standard"), String("Caucasus Standard Time"));
    _mapKeysToValues.insert(String("Caucasus Standard Time:Daylight"), String("Caucasus Daylight Time"));
    _mapKeysToValues.insert(String("Cen. Australia Standard Time"), String("(GMT+09:30) Adelaide"));
    _mapKeysToValues.insert(String("Cen. Australia Standard Time:Standard"), String("Cen. Australia Standard Time"));
    _mapKeysToValues.insert(String("Cen. Australia Standard Time:Daylight"), String("Cen. Australia Daylight Time"));
    _mapKeysToValues.insert(String("Central America Standard Time"), String("(GMT-06:00) Central America"));
    _mapKeysToValues.insert(String("Central America Standard Time:Standard"), String("Central America Standard Time"));
    _mapKeysToValues.insert(String("Central America Standard Time:Daylight"), String("Central America Daylight Time"));
    _mapKeysToValues.insert(String("Central Asia Standard Time"), String("(GMT+06:00) Astana, Dhaka"));
    _mapKeysToValues.insert(String("Central Asia Standard Time:Standard"), String("Central Asia Standard Time"));
    _mapKeysToValues.insert(String("Central Asia Standard Time:Daylight"), String("Central Asia Daylight Time"));
    _mapKeysToValues.insert(String("Central Europe Time"), String("(GMT+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague"));
    _mapKeysToValues.insert(String("Central Europe Time:Standard"), String("Central Europe Standard Time"));
    _mapKeysToValues.insert(String("Central Europe Time:Daylight"), String("Central Europe Daylight Time"));
    _mapKeysToValues.insert(String("Central European Time"), String("(GMT+01:00) Sarajevo, Skopje, Warsaw, Zagreb"));
    _mapKeysToValues.insert(String("Central European Time:Standard"), String("Central European Standard Time"));
    _mapKeysToValues.insert(String("Central European Time:Daylight"), String("Central European Daylight Time"));
    _mapKeysToValues.insert(String("Central Pacific Standard Time"), String("(GMT+11:00) Magadan, Solomon Is."));
    _mapKeysToValues.insert(String("Central Pacific Standard Time:Standard"), String("Central Pacific Standard Time"));
    _mapKeysToValues.insert(String("Central Pacific Standard Time:Daylight"), String("Central Pacific Daylight Time"));
    _mapKeysToValues.insert(String("Central Standard Time"), String("(GMT-06:00) Central Time (US & Canada)"));
    _mapKeysToValues.insert(String("Central Standard Time:Standard"), String("Central Standard Time"));
    _mapKeysToValues.insert(String("Central Standard Time:Daylight"), String("Central Daylight Time"));
    _mapKeysToValues.insert(String("China Standard Time"), String("(GMT+08:00) Beijing, Chongqing, Hong Kong, Urumqi"));
    _mapKeysToValues.insert(String("China Standard Time:Standard"), String("China Standard Time"));
    _mapKeysToValues.insert(String("China Standard Time:Daylight"), String("China Daylight Time"));
    _mapKeysToValues.insert(String("Dateline Standard Time"), String("(GMT-12:00) International Date Line West"));
    _mapKeysToValues.insert(String("Dateline Standard Time:Standard"), String("Dateline Standard Time"));
    _mapKeysToValues.insert(String("Dateline Standard Time:Daylight"), String("Dateline Daylight Time"));
    _mapKeysToValues.insert(String("E. Africa Standard Time"), String("(GMT+03:00) Nairobi"));
    _mapKeysToValues.insert(String("E. Africa Standard Time:Standard"), String("E. Africa Standard Time"));
    _mapKeysToValues.insert(String("E. Africa Standard Time:Daylight"), String("E. Africa Daylight Time"));
    _mapKeysToValues.insert(String("E. Australia Standard Time"), String("(GMT+10:00) Brisbane"));
    _mapKeysToValues.insert(String("E. Australia Standard Time:Standard"), String("E. Australia Standard Time"));
    _mapKeysToValues.insert(String("E. Australia Standard Time:Daylight"), String("E. Australia Daylight Time"));
    _mapKeysToValues.insert(String("E. Europe Standard Time"), String("(GMT+02:00) Bucharest"));
    _mapKeysToValues.insert(String("E. Europe Standard Time:Standard"), String("E. Europe Standard Time"));
    _mapKeysToValues.insert(String("E. Europe Standard Time:Daylight"), String("E. Europe Daylight Time"));
    _mapKeysToValues.insert(String("E. South America Standard Time"), String("(GMT-03:00) Brasilia"));
    _mapKeysToValues.insert(String("E. South America Standard Time:Standard"), String("E. South America Standard Time"));
    _mapKeysToValues.insert(String("E. South America Standard Time:Daylight"), String("E. South America Daylight Time"));
    _mapKeysToValues.insert(String("Eastern Standard Time"), String("(GMT-05:00) Eastern Time (US & Canada)"));
    _mapKeysToValues.insert(String("Eastern Standard Time:Standard"), String("Eastern Standard Time"));
    _mapKeysToValues.insert(String("Eastern Standard Time:Daylight"), String("Eastern Daylight Time"));
    _mapKeysToValues.insert(String("Egypt Standard Time"), String("(GMT+02:00) Cairo"));
    _mapKeysToValues.insert(String("Egypt Standard Time:Standard"), String("Egypt Standard Time"));
    _mapKeysToValues.insert(String("Egypt Standard Time:Daylight"), String("Egypt Daylight Time"));
    _mapKeysToValues.insert(String("Ekaterinburg Standard Time"), String("(GMT+05:00) Ekaterinburg"));
    _mapKeysToValues.insert(String("Ekaterinburg Standard Time:Standard"), String("Ekaterinburg Standard Time"));
    _mapKeysToValues.insert(String("Ekaterinburg Standard Time:Daylight"), String("Ekaterinburg Daylight Time"));
    _mapKeysToValues.insert(String("Fiji Standard Time"), String("(GMT+12:00) Fiji, Kamchatka, Marshall Is."));
    _mapKeysToValues.insert(String("Fiji Standard Time:Standard"), String("Fiji Standard Time"));
    _mapKeysToValues.insert(String("Fiji Standard Time:Daylight"), String("Fiji Daylight Time"));
    _mapKeysToValues.insert(String("FLE Standard Time"), String("(GMT+02:00) Helsinki, Kyiv, Riga, Sofia, Tallinn, Vilnius"));
    _mapKeysToValues.insert(String("FLE Standard Time:Standard"), String("FLE Standard Time"));
    _mapKeysToValues.insert(String("FLE Standard Time:Daylight"), String("FLE Daylight Time"));
    _mapKeysToValues.insert(String("GMT Standard Time"), String("(GMT) Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London"));
    _mapKeysToValues.insert(String("GMT Standard Time:Standard"), String("GMT Standard Time"));
    _mapKeysToValues.insert(String("GMT Standard Time:Daylight"), String("GMT Daylight Time"));
    _mapKeysToValues.insert(String("Greenland Standard Time"), String("(GMT-03:00) Greenland"));
    _mapKeysToValues.insert(String("Greenland Standard Time:Standard"), String("Greenland Standard Time"));
    _mapKeysToValues.insert(String("Greenland Standard Time:Daylight"), String("Greenland Daylight Time"));
    _mapKeysToValues.insert(String("Greenwich Standard Time"), String("(GMT) Casablanca"));
    _mapKeysToValues.insert(String("Greenwich Standard Time:Standard"), String("Greenwich Standard Time"));
    _mapKeysToValues.insert(String("Greenwich Standard Time:Daylight"), String("Greenwich Daylight Time"));
    _mapKeysToValues.insert(String("GTB Standard Time"), String("(GMT+02:00) Athens, Beirut, Istanbul, Minsk"));
    _mapKeysToValues.insert(String("GTB Standard Time:Standard"), String("GTB Standard Time"));
    _mapKeysToValues.insert(String("GTB Standard Time:Daylight"), String("GTB Daylight Time"));
    _mapKeysToValues.insert(String("Hawaiian Standard Time"), String("(GMT-10:00) Hawaii"));
    _mapKeysToValues.insert(String("Hawaiian Standard Time:Standard"), String("Hawaiian Standard Time"));
    _mapKeysToValues.insert(String("Hawaiian Standard Time:Daylight"), String("Hawaiian Daylight Time"));
    _mapKeysToValues.insert(String("India Standard Time"), String("(GMT+05:30) Chennai, Kolkata, Mumbai, New Delhi"));
    _mapKeysToValues.insert(String("India Standard Time:Standard"), String("India Standard Time"));
    _mapKeysToValues.insert(String("India Standard Time:Daylight"), String("India Daylight Time"));
    _mapKeysToValues.insert(String("Iran Standard Time"), String("(GMT+03:30) Tehran"));
    _mapKeysToValues.insert(String("Iran Standard Time:Standard"), String("Iran Standard Time"));
    _mapKeysToValues.insert(String("Iran Standard Time:Daylight"), String("Iran Daylight Time"));
    _mapKeysToValues.insert(String("Israel Standard Time"), String("(GMT+02:00) Jerusalem"));
    _mapKeysToValues.insert(String("Israel Standard Time:Standard"), String("Israel Standard Time"));
    _mapKeysToValues.insert(String("Israel Standard Time:Daylight"), String("Israel Daylight Time"));
    _mapKeysToValues.insert(String("Korea Standard Time"), String("(GMT+09:00) Seoul"));
    _mapKeysToValues.insert(String("Korea Standard Time:Standard"), String("Korea Standard Time"));
    _mapKeysToValues.insert(String("Korea Standard Time:Daylight"), String("Korea Daylight Time"));
    _mapKeysToValues.insert(String("Mexico Standard Time"), String("(GMT-06:00) Guadalajara, Mexico City, Monterrey"));
    _mapKeysToValues.insert(String("Mexico Standard Time:Standard"), String("Mexico Standard Time"));
    _mapKeysToValues.insert(String("Mexico Standard Time:Daylight"), String("Mexico Daylight Time"));
    _mapKeysToValues.insert(String("Mexico Standard Time 2"), String("(GMT-07:00) Chihuahua, La Paz, Mazatlan"));
    _mapKeysToValues.insert(String("Mexico Standard Time 2:Standard"), String("Mexico Standard Time 2"));
    _mapKeysToValues.insert(String("Mexico Standard Time 2:Daylight"), String("Mexico Daylight Time 2"));
    _mapKeysToValues.insert(String("Mid-Atlantic Standard Time"), String("(GMT-02:00) Mid-Atlantic"));
    _mapKeysToValues.insert(String("Mid-Atlantic Standard Time:Standard"), String("Mid-Atlantic Standard Time"));
    _mapKeysToValues.insert(String("Mid-Atlantic Standard Time:Daylight"), String("Mid-Atlantic Daylight Time"));
    _mapKeysToValues.insert(String("Mountain Standard Time"), String("(GMT-07:00) Mountain Time (US & Canada)"));
    _mapKeysToValues.insert(String("Mountain Standard Time:Standard"), String("Mountain Standard Time"));
    _mapKeysToValues.insert(String("Mountain Standard Time:Daylight"), String("Mountain Daylight Time"));
    _mapKeysToValues.insert(String("Myanmar Standard Time"), String("(GMT+06:30) Rangoon"));
    _mapKeysToValues.insert(String("Myanmar Standard Time:Standard"), String("Myanmar Standard Time"));
    _mapKeysToValues.insert(String("Myanmar Standard Time:Daylight"), String("Myanmar Daylight Time"));
    _mapKeysToValues.insert(String("N. Central Asia Standard Time"), String("(GMT+06:00) Almaty, Novosibirsk"));
    _mapKeysToValues.insert(String("N. Central Asia Standard Time:Standard"), String("N. Central Asia Standard Time"));
    _mapKeysToValues.insert(String("N. Central Asia Standard Time:Daylight"), String("N. Central Asia Daylight Time"));
    _mapKeysToValues.insert(String("Nepal Standard Time"), String("(GMT+05:45) Kathmandu"));
    _mapKeysToValues.insert(String("Nepal Standard Time:Standard"), String("Nepal Standard Time"));
    _mapKeysToValues.insert(String("Nepal Standard Time:Daylight"), String("Nepal Daylight Time"));
    _mapKeysToValues.insert(String("New Zealand Standard Time"), String("(GMT+12:00) Auckland, Wellington"));
    _mapKeysToValues.insert(String("New Zealand Standard Time:Standard"), String("New Zealand Standard Time"));
    _mapKeysToValues.insert(String("New Zealand Standard Time:Daylight"), String("New Zealand Daylight Time"));
    _mapKeysToValues.insert(String("Newfoundland Standard Time"), String("(GMT-03:30) Newfoundland"));
    _mapKeysToValues.insert(String("Newfoundland Standard Time:Standard"), String("Newfoundland Standard Time"));
    _mapKeysToValues.insert(String("Newfoundland Standard Time:Daylight"), String("Newfoundland Daylight Time"));
    _mapKeysToValues.insert(String("North Asia East Standard Time"), String("(GMT+08:00) Irkutsk, Ulaan Bataar"));
    _mapKeysToValues.insert(String("North Asia East Standard Time:Standard"), String("North Asia East Standard Time"));
    _mapKeysToValues.insert(String("North Asia East Standard Time:Daylight"), String("North Asia East Daylight Time"));
    _mapKeysToValues.insert(String("North Asia Standard Time"), String("(GMT+07:00) Krasnoyarsk"));
    _mapKeysToValues.insert(String("North Asia Standard Time:Standard"), String("North Asia Standard Time"));
    _mapKeysToValues.insert(String("North Asia Standard Time:Daylight"), String("North Asia Daylight Time"));
    _mapKeysToValues.insert(String("Pacific SA Standard Time"), String("(GMT-04:00) Santiago"));
    _mapKeysToValues.insert(String("Pacific SA Standard Time:Standard"), String("Pacific SA Standard Time"));
    _mapKeysToValues.insert(String("Pacific SA Standard Time:Daylight"), String("Pacific SA Daylight Time"));
    _mapKeysToValues.insert(String("Pacific Standard Time"), String("(GMT-08:00) Pacific Time (US & Canada); Tijuana"));
    _mapKeysToValues.insert(String("Pacific Standard Time:Standard"), String("Pacific Standard Time"));
    _mapKeysToValues.insert(String("Pacific Standard Time:Daylight"), String("Pacific Daylight Time"));
    _mapKeysToValues.insert(String("Romance Standard Time"), String("(GMT+01:00) Brussels, Copenhagen, Madrid, Paris"));
    _mapKeysToValues.insert(String("Romance Standard Time:Standard"), String("Romance Standard Time"));
    _mapKeysToValues.insert(String("Romance Standard Time:Daylight"), String("Romance Daylight Time"));
    _mapKeysToValues.insert(String("Russian Standard Time"), String("(GMT+03:00) Moscow, St. Petersburg, Volgograd"));
    _mapKeysToValues.insert(String("Russian Standard Time:Standard"), String("Russian Standard Time"));
    _mapKeysToValues.insert(String("Russian Standard Time:Daylight"), String("Russian Daylight Time"));
    _mapKeysToValues.insert(String("SA Eastern Standard Time"), String("(GMT-03:00) Buenos Aires, Georgetown"));
    _mapKeysToValues.insert(String("SA Eastern Standard Time:Standard"), String("SA Eastern Standard Time"));
    _mapKeysToValues.insert(String("SA Eastern Standard Time:Daylight"), String("SA Eastern Daylight Time"));
    _mapKeysToValues.insert(String("SA Pacific Standard Time"), String("(GMT-05:00) Bogota, Lima, Quito"));
    _mapKeysToValues.insert(String("SA Pacific Standard Time:Standard"), String("SA Pacific Standard Time"));
    _mapKeysToValues.insert(String("SA Pacific Standard Time:Daylight"), String("SA Pacific Daylight Time"));
    _mapKeysToValues.insert(String("SA Western Standard Time"), String("(GMT-04:00) Caracas, La Paz"));
    _mapKeysToValues.insert(String("SA Western Standard Time:Standard"), String("SA Western Standard Time"));
    _mapKeysToValues.insert(String("SA Western Standard Time:Daylight"), String("SA Western Daylight Time"));
    _mapKeysToValues.insert(String("Samoa Standard Time"), String("(GMT-11:00) Midway Island, Samoa"));
    _mapKeysToValues.insert(String("Samoa Standard Time:Standard"), String("Samoa Standard Time"));
    _mapKeysToValues.insert(String("Samoa Standard Time:Daylight"), String("Samoa Daylight Time"));
    _mapKeysToValues.insert(String("SE Asia Standard Time"), String("(GMT+07:00) Bangkok, Hanoi, Jakarta"));
    _mapKeysToValues.insert(String("SE Asia Standard Time:Standard"), String("SE Asia Standard Time"));
    _mapKeysToValues.insert(String("SE Asia Standard Time:Daylight"), String("SE Asia Daylight Time"));
    _mapKeysToValues.insert(String("Singapore Standard Time"), String("(GMT+08:00) Kuala Lumpur, Singapore"));
    _mapKeysToValues.insert(String("Singapore Standard Time:Standard"), String("Singapore Standard Time"));
    _mapKeysToValues.insert(String("Singapore Standard Time:Daylight"), String("Singapore Daylight Time"));
    _mapKeysToValues.insert(String("South Africa Standard Time"), String("(GMT+02:00) Harare, Pretoria"));
    _mapKeysToValues.insert(String("South Africa Standard Time:Standard"), String("South Africa Standard Time"));
    _mapKeysToValues.insert(String("South Africa Standard Time:Daylight"), String("South Africa Daylight Time"));
    _mapKeysToValues.insert(String("Sri Lanka Standard Time"), String("(GMT+06:00) Sri Jayawardenepura"));
    _mapKeysToValues.insert(String("Sri Lanka Standard Time:Standard"), String("Sri Lanka Standard Time"));
    _mapKeysToValues.insert(String("Sri Lanka Standard Time:Daylight"), String("Sri Lanka Daylight Time"));
    _mapKeysToValues.insert(String("Taipei Standard Time"), String("(GMT+08:00) Taipei"));
    _mapKeysToValues.insert(String("Taipei Standard Time:Standard"), String("Taipei Standard Time"));
    _mapKeysToValues.insert(String("Taipei Standard Time:Daylight"), String("Taipei Daylight Time"));
    _mapKeysToValues.insert(String("Tasmania Standard Time"), String("(GMT+10:00) Hobart"));
    _mapKeysToValues.insert(String("Tasmania Standard Time:Standard"), String("Tasmania Standard Time"));
    _mapKeysToValues.insert(String("Tasmania Standard Time:Daylight"), String("Tasmania Daylight Time"));
    _mapKeysToValues.insert(String("Tokyo Standard Time"), String("(GMT+09:00) Osaka, Sapporo, Tokyo"));
    _mapKeysToValues.insert(String("Tokyo Standard Time:Standard"), String("Tokyo Standard Time"));
    _mapKeysToValues.insert(String("Tokyo Standard Time:Daylight"), String("Tokyo Daylight Time"));
    _mapKeysToValues.insert(String("Tonga Standard Time"), String("(GMT+13:00) Nuku'alofa"));
    _mapKeysToValues.insert(String("Tonga Standard Time:Standard"), String("Tonga Standard Time"));
    _mapKeysToValues.insert(String("Tonga Standard Time:Daylight"), String("Tonga Daylight Time"));
    _mapKeysToValues.insert(String("US Eastern Standard Time"), String("(GMT-05:00) Indiana (East)"));
    _mapKeysToValues.insert(String("US Eastern Standard Time:Standard"), String("US Eastern Standard Time"));
    _mapKeysToValues.insert(String("US Eastern Standard Time:Daylight"), String("US Eastern Daylight Time"));
    _mapKeysToValues.insert(String("US Mountain Standard Time"), String("(GMT-07:00) Arizona"));
    _mapKeysToValues.insert(String("US Mountain Standard Time:Standard"), String("US Mountain Standard Time"));
    _mapKeysToValues.insert(String("US Mountain Standard Time:Daylight"), String("US Mountain Daylight Time"));
    _mapKeysToValues.insert(String("Vladivostok Standard Time"), String("(GMT+10:00) Vladivostok"));
    _mapKeysToValues.insert(String("Vladivostok Standard Time:Standard"), String("Vladivostok Standard Time"));
    _mapKeysToValues.insert(String("Vladivostok Standard Time:Daylight"), String("Vladivostok Daylight Time"));
    _mapKeysToValues.insert(String("W. Australia Standard Time"), String("(GMT+08:00) Perth"));
    _mapKeysToValues.insert(String("W. Australia Standard Time:Standard"), String("W. Australia Standard Time"));
    _mapKeysToValues.insert(String("W. Australia Standard Time:Daylight"), String("W. Australia Daylight Time"));
    _mapKeysToValues.insert(String("W. Central Africa Standard Time"), String("(GMT+01:00) West Central Africa"));
    _mapKeysToValues.insert(String("W. Central Africa Standard Time:Standard"), String("W. Central Africa Standard Time"));
    _mapKeysToValues.insert(String("W. Central Africa Standard Time:Daylight"), String("W. Central Africa Daylight Time"));
    _mapKeysToValues.insert(String("W. Europe Standard Time"), String("(GMT+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna"));
    _mapKeysToValues.insert(String("W. Europe Standard Time:Standard"), String("W. Europe Standard Time"));
    _mapKeysToValues.insert(String("W. Europe Standard Time:Daylight"), String("W. Europe Daylight Time"));
    _mapKeysToValues.insert(String("West Asia Standard Time"), String("(GMT+05:00) Islamabad, Karachi, Tashkent"));
    _mapKeysToValues.insert(String("West Asia Standard Time:Standard"), String("West Asia Standard Time"));
    _mapKeysToValues.insert(String("West Asia Standard Time:Daylight"), String("West Asia Daylight Time"));
    _mapKeysToValues.insert(String("West Pacific Standard Time"), String("(GMT+10:00) Guam, Port Moresby"));
    _mapKeysToValues.insert(String("West Pacific Standard Time:Standard"), String("West Pacific Standard Time"));
    _mapKeysToValues.insert(String("West Pacific Standard Time:Daylight"), String("West Pacific Daylight Time"));
    _mapKeysToValues.insert(String("Yakutsk Standard Time"), String("(GMT+09:00) Yakutsk"));
    _mapKeysToValues.insert(String("Yakutsk Standard Time:Standard"), String("Yakutsk Standard Time"));
    _mapKeysToValues.insert(String("Yakutsk Standard Time:Daylight"), String("Yakutsk Daylight Time"));
    _mapKeysToValues.insert(String("UTC"), String("Universal Coordinated Time"));
    _mapKeysToValues.insert(String("UTC:Standard"), String("Universal Coordinated Time"));
    _mapKeysToValues.insert(String("UTC:Daylight"), String("Universal Coordinated Time"));
}

_impl::_DateTimeResourceMap_en::~_DateTimeResourceMap_en()
{
}

//////////
//  Operations
String _impl::_DateTimeResourceMap_en::getString(const String & key)
{
    if (_mapKeysToValues.containsKey(key))
    {
        return _mapKeysToValues.get(key);
    }
    throw MissingResourceError(key);
}

//  End of DateTimeResourceMap_en.cpp
