//
//  DirectoryEntry.cpp - Implementation of the carl::DirectoryEntry class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.5 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;

//////////
//  Construction/destruction/assignment
DirectoryEntry::DirectoryEntry()
{
    _isDirectory = false;
    _size = 0;
}

DirectoryEntry::DirectoryEntry(bool isDirectory, const String & shortName, const String & fullName, UInt64 size, const TimeStamp & creationTime, const TimeStamp & lastAccessTime, const TimeStamp & lastWriteTime)
    :   _isDirectory(isDirectory),
        _shortName(shortName),
        _fullName(fullName),
        _size(size),
        _creationTime(creationTime),
        _lastAccessTime(lastAccessTime),
        _lastWriteTime(lastWriteTime)
{
}

DirectoryEntry::DirectoryEntry(const DirectoryEntry & src)
    :   _isDirectory(src._isDirectory),
        _shortName(src._shortName),
        _fullName(src._fullName),
        _size(src._size),
        _creationTime(src._creationTime),
        _lastAccessTime(src._lastAccessTime),
        _lastWriteTime(src._lastWriteTime)
{
}

DirectoryEntry & DirectoryEntry::operator = (const DirectoryEntry & src)
{
    if (this != (&src))
    {
        _isDirectory = src._isDirectory;
        _shortName = src._shortName;
        _fullName = src._fullName;
        _size = src._size;
        _creationTime = src._creationTime;
        _lastAccessTime = src._lastAccessTime;
        _lastWriteTime = src._lastWriteTime;
    }
    return *this;
}

//  End of DirectoryEntry.cpp
