//
//  EbcdicCharacterSetFamily.cpp - Implementation of the carl::_impl::_EbcdicCharacterSetFamily class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.6 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "CharsetImpl.hpp"

//////////
//  Singleton
_impl::_EbcdicCharacterSetFamily::_EbcdicCharacterSetFamily()
{
    _names.append(String("EBCDIC"));
}

_impl::_EbcdicCharacterSetFamily::~_EbcdicCharacterSetFamily()
{
}

_impl::_EbcdicCharacterSetFamily * _impl::_EbcdicCharacterSetFamily::getInstance()
{
    static _EbcdicCharacterSetFamily instance;
    return &instance;
}

//////////
//  Operations
Array<String> _impl::_EbcdicCharacterSetFamily::getAllNames() const
{
    return _names;
}

String _impl::_EbcdicCharacterSetFamily::getCanonicalName() const
{
    return String("EBCDIC");
}

String _impl::_EbcdicCharacterSetFamily::getPreferredName() const
{
    return String("EBCDIC");
}

String _impl::_EbcdicCharacterSetFamily::getDisplayName() const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), Locale::getDefault());
}

String _impl::_EbcdicCharacterSetFamily::getDisplayName(const Locale & forLocale) const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), forLocale);
}

//  End of EbcdicCharacterSetFamily.cpp
