//
//  EmulatedSettingsValue.cpp - Implementation of the carl::_impl::_EmulatedSettingsValue class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.7 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "EmulatedSettingsImpl.hpp"

#if defined(CARL_CPU_IA32) && defined(CARL_OS_WIN32) && defined(CARL_TOOLCHAIN_MSVC)
#elif (defined(CARL_CPU_IA32) && defined(CARL_OS_CYGWIN32) && defined(CARL_TOOLCHAIN_GCC)) || \
      (defined(CARL_CPU_IA32) && defined(CARL_OS_LINUX32) && defined(CARL_TOOLCHAIN_GCC))
//////////
//  Construction/destruction
_impl::_EmulatedSettingsValue::_EmulatedSettingsValue(const String & name, const String & value)
    :   _name(name), _value(value)
{
}

_impl::_EmulatedSettingsValue::~_EmulatedSettingsValue()
{
}

//////////
//  Operations
String _impl::_EmulatedSettingsValue::getName() const
{
    return _name;
}

String _impl::_EmulatedSettingsValue::getValue() const
{
    return _value;
}

void _impl::_EmulatedSettingsValue::setValue(const String & value)
{
    _value = value;
}

void _impl::_EmulatedSettingsValue::write(IDataOutput & dos) const throw(IOException)
{
    dos << _name;
    dos << _value;
}

void _impl::_EmulatedSettingsValue::read(IDataInput & dis) throw(IOException)
{
    dis >> _name;
    dis >> _value;
}

#else
    #error Unsupported platform
#endif

//  End of EmulatedSettingsValue.cpp
