//
//  EncryptionResourceMap_en.cpp - Implementation of the carl::_EncryptionResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.6 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "EncryptionImpl.hpp"

//////////
//  Construction/destruction
_impl::_EncryptionResourceMap_en::_EncryptionResourceMap_en()
    :   _mapKeysToValues(StandardHashFunctions::hashString)
{
    //  Ciphers
    _mapKeysToValues.insert(_NullCipher::getInstance()->getCanonicalName(), String("No encryption"));
    _mapKeysToValues.insert(_BlowfishCipher::getInstance()->getCanonicalName(), String("Blowfish"));
    _mapKeysToValues.insert(_RsaCipher::getInstance()->getCanonicalName(), String("RSA"));

    //  Padding algorithms
    _mapKeysToValues.insert(_Pkcs5PaddingAlgorithm::getInstance()->getCanonicalName(), String("PKCS5"));
}

_impl::_EncryptionResourceMap_en::~_EncryptionResourceMap_en()
{
}

//////////
//  Operations
String _impl::_EncryptionResourceMap_en::getString(const String & key)
{
    if (_mapKeysToValues.containsKey(key))
    {
        return _mapKeysToValues.get(key);
    }
    throw MissingResourceError(key);
}

//  End of EncryptionResourceMap_en.cpp
