//
//  ExceptionImpl.hpp - Exception helpers
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.4 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#ifndef __ExceptionImpl_hpp_included__
#define __ExceptionImpl_hpp_included__

namespace carl
{
    namespace _impl
    {
        //////////
        //  Exception resources
        class CARL_PUBLIC _ExceptionResourceMap_en : public ResourceMap
        {
            //////////
            //  Can't assign or copy construct
        private:
            _ExceptionResourceMap_en(const _ExceptionResourceMap_en &);
            void                        operator = (const _ExceptionResourceMap_en &);

            //////////
            //  Construction/destruction
        public:
            _ExceptionResourceMap_en();
            virtual ~_ExceptionResourceMap_en();

            //////////
            //  Operations
        public:
            virtual String              getString(const String & key);

            //////////
            //  Implementation
        private:
            HashMap<String, String>     _mapKeysToValues;
        };

        //////////
        //  An exception manager
        class CARL_PUBLIC _ExceptionManagerImpl
        {
            //////////
            //  Can't assign or copy construct
        private:
            _ExceptionManagerImpl(const _ExceptionManagerImpl &);
            void                            operator = (const _ExceptionManagerImpl &);

            //////////
            //  Singleton
        private:
            _ExceptionManagerImpl();
            ~_ExceptionManagerImpl();
        public:
            static _ExceptionManagerImpl *  getInstance();

            //////////
            //  Operations
        public:
            MapResourceFactory *            getResourceFactory() const;

            //////////
            //  Implementation
        private:
            mutable FrameworkResourceFactory    _resourceFactory;
        };
    }
}

#endif  //  __CharsetImpl_hpp_included__
//  End of CharsetImpl.hpp
