//
//  ExceptionResourceMap_en.cpp - Implementation of the carl::_ExceptionResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:52 $
//  $Revision: 1.6 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "ExceptionImpl.hpp"

//////////
//  Construction/destruction
_impl::_ExceptionResourceMap_en::_ExceptionResourceMap_en()
    :   _mapKeysToValues(StandardHashFunctions::hashString)
{
    _mapKeysToValues.insert(String("AssertionError"), String("Assertion '$0' failed at $1($2)"));
    _mapKeysToValues.insert(String("CompressedDataCorruptException"), String("Compressed data is corrupt"));
    _mapKeysToValues.insert(String("DuplicateCharacterSetException"), String("Character set already exists"));
    _mapKeysToValues.insert(String("DuplicateCharacterSetFamilyException"), String("Character set family already exists"));
    _mapKeysToValues.insert(String("DuplicateCipherException"), String("Cipher already exists"));
    _mapKeysToValues.insert(String("DuplicateCompressionAlgorithmException"), String("Compression algorithm already exists"));
    _mapKeysToValues.insert(String("DuplicatePaddingAlgorithmException"), String("Padding algorithm already exists"));
    _mapKeysToValues.insert(String("DuplicateTimeZoneException"), String("Time zone already exists"));
    _mapKeysToValues.insert(String("EncryptedDataCorruptException"), String("Encrypted data is corrupt"));
    _mapKeysToValues.insert(String("EOFException"), String("I/O error: unexpected EOF"));
    _mapKeysToValues.insert(String("Error"), String("Runtime error"));
    _mapKeysToValues.insert(String("Exception"), String("Runtime exception"));
    _mapKeysToValues.insert(String("FileNotFoundException"), String("I/O error: the file '$0' does not exist"));
    _mapKeysToValues.insert(String("FixedPointDivisionByZeroError"), String("Division by zero"));
    _mapKeysToValues.insert(String("HeapBlockCorruptError"), String("Heap block $0 is corrupt at $1($2)"));
    _mapKeysToValues.insert(String("InconsistentCharacterSetException"), String("Inconsistent character set"));
    _mapKeysToValues.insert(String("InconsistentCharacterSetFamilyException"), String("Inconsistent character set family"));
    _mapKeysToValues.insert(String("InconsistentCipherException"), String("Inconsistent cipher"));
    _mapKeysToValues.insert(String("InconsistentCompressionAlgorithmException"), String("Inconsistent compression algorithm"));
    _mapKeysToValues.insert(String("InconsistentPaddingAlgorithmException"), String("Inconsistent padding algorithm"));
    _mapKeysToValues.insert(String("InconsistentTimeZoneException"), String("Inconsistent time zone"));
    _mapKeysToValues.insert(String("InvalidCiphertextBlockSizeError"), String("Invalid input block size for a decryption algorithm"));
    _mapKeysToValues.insert(String("InvalidCleartextBlockSizeError"), String("Invalid input block size for an encryption algorithm"));
    _mapKeysToValues.insert(String("InvalidDataException"), String("I/O error: input stream contains invalid data"));
    _mapKeysToValues.insert(String("InvalidKeyLengthError"), String("Invalid crypto key length"));
    _mapKeysToValues.insert(String("IOException"), String("I/O error"));
    _mapKeysToValues.insert(String("MissingResourceError"), String("Resource '$0' does not exist"));
    _mapKeysToValues.insert(String("NoSuchElementError"), String("Accessing nonexistent object"));
    _mapKeysToValues.insert(String("NoSuchHeapBlockError"), String("Heap block $0 does not exist at $1($2)"));
    _mapKeysToValues.insert(String("PaddedDataCorruptException"), String("The data padding is corrupt"));
    _mapKeysToValues.insert(String("ParseException"), String("Error parsing string '$0' (position $1)"));
    _mapKeysToValues.insert(String("ProgramError"), String("Program error"));
    _mapKeysToValues.insert(String("SignalingNanOperandError"), String("Signaling NaN used as an operand"));
    _mapKeysToValues.insert(String("SystemError"), String("System error"));
    _mapKeysToValues.insert(String("Throwable"), String("Runtime error"));
    _mapKeysToValues.insert(String("ValueNotRepresentableAsFixedPointError"), String("Conversion of an infinite of NaN foating-point value to a fixed-point type"));
    _mapKeysToValues.insert(String("VersionCompatibilityError"), String("Using incompatible CARL version"));
}

_impl::_ExceptionResourceMap_en::~_ExceptionResourceMap_en()
{
}

//////////
//  Operations
String _impl::_ExceptionResourceMap_en::getString(const String & key)
{
    if (_mapKeysToValues.containsKey(key))
    {
        return _mapKeysToValues.get(key);
    }
    throw MissingResourceError(key);
}

//  End of ExceptionResourceMap_en.cpp
