//
//  Iso10646CharacterSetFamily.cpp - Implementation of the carl::_impl::_Iso10646CharacterSetFamily class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.6 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "CharsetImpl.hpp"

//////////
//  Singleton
_impl::_Iso10646CharacterSetFamily::_Iso10646CharacterSetFamily()
{
    _names.append(String("ISO_10646"));
    _names.append(String("ISO-10646"));
}

_impl::_Iso10646CharacterSetFamily::~_Iso10646CharacterSetFamily()
{
}

_impl::_Iso10646CharacterSetFamily * _impl::_Iso10646CharacterSetFamily::getInstance()
{
    static _Iso10646CharacterSetFamily instance;
    return &instance;
}

//////////
//  Operations
Array<String> _impl::_Iso10646CharacterSetFamily::getAllNames() const
{
    return _names;
}

String _impl::_Iso10646CharacterSetFamily::getCanonicalName() const
{
    return String("ISO_10646");
}

String _impl::_Iso10646CharacterSetFamily::getPreferredName() const
{
    return String("ISO-10646");
}

String _impl::_Iso10646CharacterSetFamily::getDisplayName() const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), Locale::getDefault());
}

String _impl::_Iso10646CharacterSetFamily::getDisplayName(const Locale & forLocale) const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), forLocale);
}

//  End of Iso10646CharacterSetFamily.cpp
