//
//  Iso3166Code3.cpp - Implementation of the carl::_impl::_Iso3166Code3 class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.4 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "Iso3166Impl.hpp"
#include <stdlib.h>

//////////
//  Construction/destruction/assignment
_impl::_Iso3166Code3::_Iso3166Code3()
{
    _code3[0] = _code3[1] = _code3[2] = ' ';
}

_impl::_Iso3166Code3::_Iso3166Code3(Char ch1, Char ch2, Char ch3)
{
    _code3[0] = Iso10646::toUpper(ch1);
    _code3[1] = Iso10646::toUpper(ch2);
    _code3[2] = Iso10646::toUpper(ch3);
}

_impl::_Iso3166Code3::_Iso3166Code3(const _Iso3166Code3 & src)
{
    _code3[0] = src._code3[0];
    _code3[1] = src._code3[1];
    _code3[2] = src._code3[2];
}

_impl::_Iso3166Code3::~_Iso3166Code3()
{
}

_impl::_Iso3166Code3 & _impl::_Iso3166Code3::operator = (const _Iso3166Code3 & src)
{
    if (this != (&src))
    {
        _code3[0] = src._code3[0];
        _code3[1] = src._code3[1];
        _code3[2] = src._code3[2];
    }
    return *this;
}

//////////
//  Operations
bool _impl::_Iso3166Code3::operator == (const _Iso3166Code3 & code3) const
{
    return _code3[0] == code3._code3[0] && _code3[1] == code3._code3[1] && _code3[2] == code3._code3[2];
}

bool _impl::_Iso3166Code3::operator != (const _Iso3166Code3 & code3) const
{
    return _code3[0] != code3._code3[0] || _code3[1] != code3._code3[1] || _code3[2] != code3._code3[2];
}

UIntSize _impl::_Iso3166Code3::hashCode() const
{
    return _code3[0] * 31 * 31 + _code3[1] * 31 + _code3[2];
}

//////////
//  Hashing
UIntSize _impl::_hashIso3166Code3(const _Iso3166Code3 & key)
{
    return key.hashCode();
}

//  End of Iso3166Code3.cpp
