//
//  Iso3166ResourceMap_en.cpp - Implementation of the carl::_Iso3166ResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.5 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "Iso3166Impl.hpp"

//////////
//  Construction/destruction
_impl::_Iso3166ResourceMap_en::_Iso3166ResourceMap_en()
    :   _mapCodes2ToCountryDisplayNames(StandardHashFunctions::hashString)
{
    _mapCodes2ToCountryDisplayNames.insert(String("AF"), String("Afghanistan"));
    _mapCodes2ToCountryDisplayNames.insert(String("AL"), String("Albania"));
    _mapCodes2ToCountryDisplayNames.insert(String("DZ"), String("Algeria"));
    _mapCodes2ToCountryDisplayNames.insert(String("AS"), String("American Samoa"));
    _mapCodes2ToCountryDisplayNames.insert(String("AD"), String("Andorra"));
    _mapCodes2ToCountryDisplayNames.insert(String("AO"), String("Angola"));
    _mapCodes2ToCountryDisplayNames.insert(String("AI"), String("Anguilla"));
    _mapCodes2ToCountryDisplayNames.insert(String("AQ"), String("Antarctica"));
    _mapCodes2ToCountryDisplayNames.insert(String("AG"), String("Antigua and Barbuda"));
    _mapCodes2ToCountryDisplayNames.insert(String("AR"), String("Argentina"));
    _mapCodes2ToCountryDisplayNames.insert(String("AM"), String("Armenia"));
    _mapCodes2ToCountryDisplayNames.insert(String("AW"), String("Aruba"));
    _mapCodes2ToCountryDisplayNames.insert(String("AU"), String("Australia"));
    _mapCodes2ToCountryDisplayNames.insert(String("AT"), String("Austria"));
    _mapCodes2ToCountryDisplayNames.insert(String("AZ"), String("Azerbaijan"));
    _mapCodes2ToCountryDisplayNames.insert(String("BS"), String("Bahamas"));
    _mapCodes2ToCountryDisplayNames.insert(String("BH"), String("Bahrain"));
    _mapCodes2ToCountryDisplayNames.insert(String("BD"), String("Bangladesh"));
    _mapCodes2ToCountryDisplayNames.insert(String("BB"), String("Barbados"));
    _mapCodes2ToCountryDisplayNames.insert(String("BY"), String("Belarus"));
    _mapCodes2ToCountryDisplayNames.insert(String("BE"), String("Belgium"));
    _mapCodes2ToCountryDisplayNames.insert(String("BZ"), String("Belize"));
    _mapCodes2ToCountryDisplayNames.insert(String("BJ"), String("Benin"));
    _mapCodes2ToCountryDisplayNames.insert(String("BM"), String("Bermuda"));
    _mapCodes2ToCountryDisplayNames.insert(String("BT"), String("Bhutan"));
    _mapCodes2ToCountryDisplayNames.insert(String("BO"), String("Bolivia"));
    _mapCodes2ToCountryDisplayNames.insert(String("BA"), String("Bosnia and Herzegowina"));
    _mapCodes2ToCountryDisplayNames.insert(String("BW"), String("Botswana"));
    _mapCodes2ToCountryDisplayNames.insert(String("BV"), String("Bouvet island"));
    _mapCodes2ToCountryDisplayNames.insert(String("BR"), String("Brazil"));
    _mapCodes2ToCountryDisplayNames.insert(String("IO"), String("British Indian ocean territory"));
    _mapCodes2ToCountryDisplayNames.insert(String("BN"), String("Brunei Darussalam"));
    _mapCodes2ToCountryDisplayNames.insert(String("BG"), String("Bulgaria"));
    _mapCodes2ToCountryDisplayNames.insert(String("BF"), String("Burkina Faso"));
    _mapCodes2ToCountryDisplayNames.insert(String("BI"), String("Burundi"));
    _mapCodes2ToCountryDisplayNames.insert(String("KH"), String("Cambodia"));
    _mapCodes2ToCountryDisplayNames.insert(String("CM"), String("Cameroon"));
    _mapCodes2ToCountryDisplayNames.insert(String("CA"), String("Canada"));
    _mapCodes2ToCountryDisplayNames.insert(String("CV"), String("Cape Verde"));
    _mapCodes2ToCountryDisplayNames.insert(String("KY"), String("Cayman islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("CF"), String("Central African Republic"));
    _mapCodes2ToCountryDisplayNames.insert(String("TD"), String("Chad"));
    _mapCodes2ToCountryDisplayNames.insert(String("CL"), String("Chile"));
    _mapCodes2ToCountryDisplayNames.insert(String("CN"), String("China"));
    _mapCodes2ToCountryDisplayNames.insert(String("CX"), String("Christmas island"));
    _mapCodes2ToCountryDisplayNames.insert(String("CC"), String("Cocos (Keeling) islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("CO"), String("Colombia"));
    _mapCodes2ToCountryDisplayNames.insert(String("KM"), String("Comoros"));
    _mapCodes2ToCountryDisplayNames.insert(String("CG"), String("Congo"));
    _mapCodes2ToCountryDisplayNames.insert(String("CD"), String("Congo, the democratic republic of the"));
    _mapCodes2ToCountryDisplayNames.insert(String("CK"), String("Cook islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("CR"), String("Costa Rica"));
    _mapCodes2ToCountryDisplayNames.insert(String("CI"), String("Cote d'Ivoire"));
    _mapCodes2ToCountryDisplayNames.insert(String("HR"), String("Croatia"));
    _mapCodes2ToCountryDisplayNames.insert(String("CU"), String("Cuba"));
    _mapCodes2ToCountryDisplayNames.insert(String("CY"), String("Cyprus"));
    _mapCodes2ToCountryDisplayNames.insert(String("CZ"), String("Czech republic"));
    _mapCodes2ToCountryDisplayNames.insert(String("DK"), String("Denmark"));
    _mapCodes2ToCountryDisplayNames.insert(String("DJ"), String("Djibouti"));
    _mapCodes2ToCountryDisplayNames.insert(String("DM"), String("Dominica"));
    _mapCodes2ToCountryDisplayNames.insert(String("DO"), String("Dominican republic"));
    _mapCodes2ToCountryDisplayNames.insert(String("TP"), String("East Timor"));
    _mapCodes2ToCountryDisplayNames.insert(String("EC"), String("Ecuador"));
    _mapCodes2ToCountryDisplayNames.insert(String("EG"), String("Egypt"));
    _mapCodes2ToCountryDisplayNames.insert(String("SV"), String("El Salvador"));
    _mapCodes2ToCountryDisplayNames.insert(String("GQ"), String("Equatorial Guinea"));
    _mapCodes2ToCountryDisplayNames.insert(String("ER"), String("Eritrea"));
    _mapCodes2ToCountryDisplayNames.insert(String("EE"), String("Estonia"));
    _mapCodes2ToCountryDisplayNames.insert(String("ET"), String("Ethiopia"));
    _mapCodes2ToCountryDisplayNames.insert(String("FK"), String("Falkland islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("FO"), String("Faroe islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("FJ"), String("Fiji"));
    _mapCodes2ToCountryDisplayNames.insert(String("FI"), String("Finland"));
    _mapCodes2ToCountryDisplayNames.insert(String("FR"), String("France"));
    _mapCodes2ToCountryDisplayNames.insert(String("FX"), String("France, metropolitan"));
    _mapCodes2ToCountryDisplayNames.insert(String("GF"), String("French Guiana"));
    _mapCodes2ToCountryDisplayNames.insert(String("PF"), String("French Polynesia"));
    _mapCodes2ToCountryDisplayNames.insert(String("TF"), String("French Southern Territories"));
    _mapCodes2ToCountryDisplayNames.insert(String("GA"), String("Gabon"));
    _mapCodes2ToCountryDisplayNames.insert(String("GM"), String("Gambia"));
    _mapCodes2ToCountryDisplayNames.insert(String("GE"), String("Georgia"));
    _mapCodes2ToCountryDisplayNames.insert(String("DE"), String("Germany"));
    _mapCodes2ToCountryDisplayNames.insert(String("GH"), String("Ghana"));
    _mapCodes2ToCountryDisplayNames.insert(String("GI"), String("Gibraltar"));
    _mapCodes2ToCountryDisplayNames.insert(String("GR"), String("Greece"));
    _mapCodes2ToCountryDisplayNames.insert(String("GL"), String("Greenland"));
    _mapCodes2ToCountryDisplayNames.insert(String("GD"), String("Grenada"));
    _mapCodes2ToCountryDisplayNames.insert(String("GP"), String("Guadeloupe"));
    _mapCodes2ToCountryDisplayNames.insert(String("GU"), String("Guam"));
    _mapCodes2ToCountryDisplayNames.insert(String("GT"), String("Guatemala"));
    _mapCodes2ToCountryDisplayNames.insert(String("GN"), String("Guinea"));
    _mapCodes2ToCountryDisplayNames.insert(String("GW"), String("Guinea-Bissau"));
    _mapCodes2ToCountryDisplayNames.insert(String("GY"), String("Guyana"));
    _mapCodes2ToCountryDisplayNames.insert(String("HT"), String("Haiti"));
    _mapCodes2ToCountryDisplayNames.insert(String("HM"), String("Heard and Mc Donald islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("VA"), String("Vatican"));
    _mapCodes2ToCountryDisplayNames.insert(String("HN"), String("Honduras"));
    _mapCodes2ToCountryDisplayNames.insert(String("HK"), String("Hong Kong"));
    _mapCodes2ToCountryDisplayNames.insert(String("HU"), String("Hungary"));
    _mapCodes2ToCountryDisplayNames.insert(String("IS"), String("Iceland"));
    _mapCodes2ToCountryDisplayNames.insert(String("IN"), String("India"));
    _mapCodes2ToCountryDisplayNames.insert(String("ID"), String("Indonesia"));
    _mapCodes2ToCountryDisplayNames.insert(String("IR"), String("Iran"));
    _mapCodes2ToCountryDisplayNames.insert(String("IQ"), String("Iraq"));
    _mapCodes2ToCountryDisplayNames.insert(String("IE"), String("Ireland"));
    _mapCodes2ToCountryDisplayNames.insert(String("IL"), String("Israel"));
    _mapCodes2ToCountryDisplayNames.insert(String("IT"), String("Italy"));
    _mapCodes2ToCountryDisplayNames.insert(String("JM"), String("Jamaica"));
    _mapCodes2ToCountryDisplayNames.insert(String("JP"), String("Japan"));
    _mapCodes2ToCountryDisplayNames.insert(String("JO"), String("Jordan"));
    _mapCodes2ToCountryDisplayNames.insert(String("KZ"), String("Kazakhstan"));
    _mapCodes2ToCountryDisplayNames.insert(String("KE"), String("Kenya"));
    _mapCodes2ToCountryDisplayNames.insert(String("KI"), String("Kiribati"));
    _mapCodes2ToCountryDisplayNames.insert(String("KP"), String("Korea, democratic people's republic of"));
    _mapCodes2ToCountryDisplayNames.insert(String("KR"), String("Korea, republic of"));
    _mapCodes2ToCountryDisplayNames.insert(String("KW"), String("Kuwait"));
    _mapCodes2ToCountryDisplayNames.insert(String("KG"), String("Kyrgyzstan"));
    _mapCodes2ToCountryDisplayNames.insert(String("LA"), String("Lao people's democratic republic"));
    _mapCodes2ToCountryDisplayNames.insert(String("LV"), String("Latvia"));
    _mapCodes2ToCountryDisplayNames.insert(String("LB"), String("Lebanon"));
    _mapCodes2ToCountryDisplayNames.insert(String("LS"), String("Lesotho"));
    _mapCodes2ToCountryDisplayNames.insert(String("LR"), String("Liberia"));
    _mapCodes2ToCountryDisplayNames.insert(String("LY"), String("Libyan Arab Jamahiriya"));
    _mapCodes2ToCountryDisplayNames.insert(String("LI"), String("Liechtenstein"));
    _mapCodes2ToCountryDisplayNames.insert(String("LT"), String("Lithuania"));
    _mapCodes2ToCountryDisplayNames.insert(String("LU"), String("Luxembourg"));
    _mapCodes2ToCountryDisplayNames.insert(String("MO"), String("Macau"));
    _mapCodes2ToCountryDisplayNames.insert(String("MK"), String("Macedonia"));
    _mapCodes2ToCountryDisplayNames.insert(String("MG"), String("Madagascar"));
    _mapCodes2ToCountryDisplayNames.insert(String("MW"), String("Malawi"));
    _mapCodes2ToCountryDisplayNames.insert(String("MY"), String("Malaysia"));
    _mapCodes2ToCountryDisplayNames.insert(String("MV"), String("Maldives"));
    _mapCodes2ToCountryDisplayNames.insert(String("ML"), String("Mali"));
    _mapCodes2ToCountryDisplayNames.insert(String("MT"), String("Malta"));
    _mapCodes2ToCountryDisplayNames.insert(String("MH"), String("Marshall islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("MQ"), String("Martinique"));
    _mapCodes2ToCountryDisplayNames.insert(String("MR"), String("Mauritania"));
    _mapCodes2ToCountryDisplayNames.insert(String("MU"), String("Mauritius"));
    _mapCodes2ToCountryDisplayNames.insert(String("YT"), String("Mayotte"));
    _mapCodes2ToCountryDisplayNames.insert(String("MX"), String("Mexico"));
    _mapCodes2ToCountryDisplayNames.insert(String("FM"), String("Micronesia, federated states of"));
    _mapCodes2ToCountryDisplayNames.insert(String("MD"), String("Moldova, republic of"));
    _mapCodes2ToCountryDisplayNames.insert(String("MC"), String("Monaco"));
    _mapCodes2ToCountryDisplayNames.insert(String("MN"), String("Mongolia"));
    _mapCodes2ToCountryDisplayNames.insert(String("MS"), String("Montserrat"));
    _mapCodes2ToCountryDisplayNames.insert(String("MA"), String("Morocco"));
    _mapCodes2ToCountryDisplayNames.insert(String("MZ"), String("Mozambique"));
    _mapCodes2ToCountryDisplayNames.insert(String("MM"), String("Myanmar"));
    _mapCodes2ToCountryDisplayNames.insert(String("NA"), String("Namibia"));
    _mapCodes2ToCountryDisplayNames.insert(String("NR"), String("Nauru"));
    _mapCodes2ToCountryDisplayNames.insert(String("NP"), String("Nepal"));
    _mapCodes2ToCountryDisplayNames.insert(String("NL"), String("Netherlands"));
    _mapCodes2ToCountryDisplayNames.insert(String("AN"), String("Netherlands Antilles"));
    _mapCodes2ToCountryDisplayNames.insert(String("NC"), String("New Caledonia"));
    _mapCodes2ToCountryDisplayNames.insert(String("NZ"), String("New Zealand"));
    _mapCodes2ToCountryDisplayNames.insert(String("NI"), String("Nicaragua"));
    _mapCodes2ToCountryDisplayNames.insert(String("NE"), String("Niger"));
    _mapCodes2ToCountryDisplayNames.insert(String("NG"), String("Nigeria"));
    _mapCodes2ToCountryDisplayNames.insert(String("NU"), String("Niue"));
    _mapCodes2ToCountryDisplayNames.insert(String("NF"), String("Norfolk island"));
    _mapCodes2ToCountryDisplayNames.insert(String("MP"), String("Northern Mariana islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("NO"), String("Norway"));
    _mapCodes2ToCountryDisplayNames.insert(String("OM"), String("Oman"));
    _mapCodes2ToCountryDisplayNames.insert(String("PK"), String("Pakistan"));
    _mapCodes2ToCountryDisplayNames.insert(String("PW"), String("Palau"));
    _mapCodes2ToCountryDisplayNames.insert(String("PA"), String("Panama"));
    _mapCodes2ToCountryDisplayNames.insert(String("PG"), String("Papua New Guinea"));
    _mapCodes2ToCountryDisplayNames.insert(String("PY"), String("Paraguay"));
    _mapCodes2ToCountryDisplayNames.insert(String("PE"), String("Peru"));
    _mapCodes2ToCountryDisplayNames.insert(String("PH"), String("Philippines"));
    _mapCodes2ToCountryDisplayNames.insert(String("PN"), String("Pitcairn"));
    _mapCodes2ToCountryDisplayNames.insert(String("PL"), String("Poland"));
    _mapCodes2ToCountryDisplayNames.insert(String("PT"), String("Portugal"));
    _mapCodes2ToCountryDisplayNames.insert(String("PR"), String("Puerto Rico"));
    _mapCodes2ToCountryDisplayNames.insert(String("QA"), String("Qatar"));
    _mapCodes2ToCountryDisplayNames.insert(String("RE"), String("Reunion"));
    _mapCodes2ToCountryDisplayNames.insert(String("RO"), String("Romania"));
    _mapCodes2ToCountryDisplayNames.insert(String("RU"), String("Russian federation"));
    _mapCodes2ToCountryDisplayNames.insert(String("RW"), String("Rwanda"));
    _mapCodes2ToCountryDisplayNames.insert(String("KN"), String("Saint Kitts and Nevis"));
    _mapCodes2ToCountryDisplayNames.insert(String("LC"), String("Saint Lucia"));
    _mapCodes2ToCountryDisplayNames.insert(String("VC"), String("Saint Vincent and the Grenadines"));
    _mapCodes2ToCountryDisplayNames.insert(String("WS"), String("Samoa"));
    _mapCodes2ToCountryDisplayNames.insert(String("SM"), String("San Marino"));
    _mapCodes2ToCountryDisplayNames.insert(String("ST"), String("Sao Tome and Principe"));
    _mapCodes2ToCountryDisplayNames.insert(String("SA"), String("Saudi Arabia"));
    _mapCodes2ToCountryDisplayNames.insert(String("SN"), String("Senegal"));
    _mapCodes2ToCountryDisplayNames.insert(String("SC"), String("Seychelles"));
    _mapCodes2ToCountryDisplayNames.insert(String("SL"), String("Sierra Leone"));
    _mapCodes2ToCountryDisplayNames.insert(String("SG"), String("Singapore"));
    _mapCodes2ToCountryDisplayNames.insert(String("SK"), String("Slovakia"));
    _mapCodes2ToCountryDisplayNames.insert(String("SI"), String("Slovenia"));
    _mapCodes2ToCountryDisplayNames.insert(String("SB"), String("Solomon islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("SO"), String("Somalia"));
    _mapCodes2ToCountryDisplayNames.insert(String("ZA"), String("South Africa"));
    _mapCodes2ToCountryDisplayNames.insert(String("GS"), String("South Georgia and the South Sandwich islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("ES"), String("Spain"));
    _mapCodes2ToCountryDisplayNames.insert(String("LK"), String("Sri Lanka"));
    _mapCodes2ToCountryDisplayNames.insert(String("SH"), String("St. Helena"));
    _mapCodes2ToCountryDisplayNames.insert(String("PM"), String("St. Pierre and Miquelon"));
    _mapCodes2ToCountryDisplayNames.insert(String("SD"), String("Sudan"));
    _mapCodes2ToCountryDisplayNames.insert(String("SR"), String("Suriname"));
    _mapCodes2ToCountryDisplayNames.insert(String("SJ"), String("Svalbard and Jan Mayen islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("SZ"), String("Swaziland"));
    _mapCodes2ToCountryDisplayNames.insert(String("SE"), String("Sweden"));
    _mapCodes2ToCountryDisplayNames.insert(String("CH"), String("Switzerland"));
    _mapCodes2ToCountryDisplayNames.insert(String("SY"), String("Syrian Arab republic"));
    _mapCodes2ToCountryDisplayNames.insert(String("TW"), String("Taiwan"));
    _mapCodes2ToCountryDisplayNames.insert(String("TJ"), String("Tajikistan"));
    _mapCodes2ToCountryDisplayNames.insert(String("TZ"), String("Tanzania, united republic of"));
    _mapCodes2ToCountryDisplayNames.insert(String("TH"), String("Thailand"));
    _mapCodes2ToCountryDisplayNames.insert(String("TG"), String("Togo"));
    _mapCodes2ToCountryDisplayNames.insert(String("TK"), String("Tokelau"));
    _mapCodes2ToCountryDisplayNames.insert(String("TO"), String("Tonga"));
    _mapCodes2ToCountryDisplayNames.insert(String("TT"), String("Trinidad and Tobago"));
    _mapCodes2ToCountryDisplayNames.insert(String("TN"), String("Tunisia"));
    _mapCodes2ToCountryDisplayNames.insert(String("TR"), String("Turkey"));
    _mapCodes2ToCountryDisplayNames.insert(String("TM"), String("Turkmenistan"));
    _mapCodes2ToCountryDisplayNames.insert(String("TC"), String("Turks and Caicos islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("TV"), String("Tuvalu"));
    _mapCodes2ToCountryDisplayNames.insert(String("UG"), String("Uganda"));
    _mapCodes2ToCountryDisplayNames.insert(String("UA"), String("Ukraine"));
    _mapCodes2ToCountryDisplayNames.insert(String("AE"), String("United Arab Emirates"));
    _mapCodes2ToCountryDisplayNames.insert(String("GB"), String("United Kingdom"));
    _mapCodes2ToCountryDisplayNames.insert(String("US"), String("United States"));
    _mapCodes2ToCountryDisplayNames.insert(String("UM"), String("United States minor outlying islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("UY"), String("Uruguay"));
    _mapCodes2ToCountryDisplayNames.insert(String("UZ"), String("Uzbekistan"));
    _mapCodes2ToCountryDisplayNames.insert(String("VU"), String("Vanuatu"));
    _mapCodes2ToCountryDisplayNames.insert(String("VE"), String("Venezuela"));
    _mapCodes2ToCountryDisplayNames.insert(String("VN"), String("Viet Nam"));
    _mapCodes2ToCountryDisplayNames.insert(String("VG"), String("Virgin islands (British)"));
    _mapCodes2ToCountryDisplayNames.insert(String("VI"), String("Virgin islands (U.S.)"));
    _mapCodes2ToCountryDisplayNames.insert(String("WF"), String("Wallis and Futuna islands"));
    _mapCodes2ToCountryDisplayNames.insert(String("EH"), String("Western Sahara"));
    _mapCodes2ToCountryDisplayNames.insert(String("YE"), String("Yemen"));
    _mapCodes2ToCountryDisplayNames.insert(String("YU"), String("Yugoslavia"));
    _mapCodes2ToCountryDisplayNames.insert(String("ZM"), String("Zambia"));
    _mapCodes2ToCountryDisplayNames.insert(String("ZW"), String("Zimbabwe"));
}

_impl::_Iso3166ResourceMap_en::~_Iso3166ResourceMap_en()
{
}

//////////
//  Operations
String _impl::_Iso3166ResourceMap_en::getString(const String & key)
{
    if (_mapCodes2ToCountryDisplayNames.containsKey(key))
    {
        return _mapCodes2ToCountryDisplayNames.get(key);
    }
    throw MissingResourceError(key);
}

//  End of Iso3166ResourceMap_en.cpp
