//
//  Iso639Impl.cpp - Implementation of the carl::_impl::_Iso639Impl class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.7 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "Iso639Impl.hpp"
#include <stdlib.h>

//////////
//  Singleton
_impl::_Iso639Impl::_Iso639Impl()
    :   _mapCode2ToLanguage(_impl::_hashIso639Code2),
        _resourceFactory(new _Iso639ResourceMap_en(), carl::String("CARL_ISO639"))
{
    //  Set up the languages
    _registerLanguage(new Iso639::Language("aa"));
    _registerLanguage(new Iso639::Language("ab"));
    _registerLanguage(new Iso639::Language("af"));
    _registerLanguage(new Iso639::Language("am"));
    _registerLanguage(new Iso639::Language("ar"));
    _registerLanguage(new Iso639::Language("as"));
    _registerLanguage(new Iso639::Language("ay"));
    _registerLanguage(new Iso639::Language("az"));
    _registerLanguage(new Iso639::Language("ba"));
    _registerLanguage(new Iso639::Language("be"));
    _registerLanguage(new Iso639::Language("bg"));
    _registerLanguage(new Iso639::Language("bh"));
    _registerLanguage(new Iso639::Language("bi"));
    _registerLanguage(new Iso639::Language("bn"));
    _registerLanguage(new Iso639::Language("bo"));
    _registerLanguage(new Iso639::Language("br"));
    _registerLanguage(new Iso639::Language("ca"));
    _registerLanguage(new Iso639::Language("co"));
    _registerLanguage(new Iso639::Language("cs"));
    _registerLanguage(new Iso639::Language("cy"));
    _registerLanguage(new Iso639::Language("da"));
    _registerLanguage(new Iso639::Language("de"));
    _registerLanguage(new Iso639::Language("dz"));
    _registerLanguage(new Iso639::Language("el"));
    _registerLanguage(new Iso639::Language("en"));
    _registerLanguage(new Iso639::Language("eo"));
    _registerLanguage(new Iso639::Language("es"));
    _registerLanguage(new Iso639::Language("et"));
    _registerLanguage(new Iso639::Language("eu"));
    _registerLanguage(new Iso639::Language("fa"));
    _registerLanguage(new Iso639::Language("fi"));
    _registerLanguage(new Iso639::Language("fj"));
    _registerLanguage(new Iso639::Language("fo"));
    _registerLanguage(new Iso639::Language("fr"));
    _registerLanguage(new Iso639::Language("fy"));
    _registerLanguage(new Iso639::Language("ga"));
    _registerLanguage(new Iso639::Language("gd"));
    _registerLanguage(new Iso639::Language("gl"));
    _registerLanguage(new Iso639::Language("gn"));
    _registerLanguage(new Iso639::Language("gu"));
    _registerLanguage(new Iso639::Language("ha"));
    _registerLanguage(new Iso639::Language("hi"));
    _registerLanguage(new Iso639::Language("hr"));
    _registerLanguage(new Iso639::Language("hu"));
    _registerLanguage(new Iso639::Language("hy"));
    _registerLanguage(new Iso639::Language("ia"));
    _registerLanguage(new Iso639::Language("id"));
    _registerLanguage(new Iso639::Language("ie"));
    _registerLanguage(new Iso639::Language("ik"));
    _registerLanguage(new Iso639::Language("is"));
    _registerLanguage(new Iso639::Language("it"));
    _registerLanguage(new Iso639::Language("iu"));
    _registerLanguage(new Iso639::Language("iw"));
    _registerLanguage(new Iso639::Language("ja"));
    _registerLanguage(new Iso639::Language("jw"));
    _registerLanguage(new Iso639::Language("ka"));
    _registerLanguage(new Iso639::Language("kk"));
    _registerLanguage(new Iso639::Language("kl"));
    _registerLanguage(new Iso639::Language("km"));
    _registerLanguage(new Iso639::Language("kn"));
    _registerLanguage(new Iso639::Language("ko"));
    _registerLanguage(new Iso639::Language("ks"));
    _registerLanguage(new Iso639::Language("ku"));
    _registerLanguage(new Iso639::Language("ky"));
    _registerLanguage(new Iso639::Language("la"));
    _registerLanguage(new Iso639::Language("ln"));
    _registerLanguage(new Iso639::Language("lo"));
    _registerLanguage(new Iso639::Language("lt"));
    _registerLanguage(new Iso639::Language("lv"));
    _registerLanguage(new Iso639::Language("mg"));
    _registerLanguage(new Iso639::Language("mi"));
    _registerLanguage(new Iso639::Language("mk"));
    _registerLanguage(new Iso639::Language("ml"));
    _registerLanguage(new Iso639::Language("mn"));
    _registerLanguage(new Iso639::Language("mo"));
    _registerLanguage(new Iso639::Language("mr"));
    _registerLanguage(new Iso639::Language("ms"));
    _registerLanguage(new Iso639::Language("mt"));
    _registerLanguage(new Iso639::Language("my"));
    _registerLanguage(new Iso639::Language("na"));
    _registerLanguage(new Iso639::Language("ne"));
    _registerLanguage(new Iso639::Language("nl"));
    _registerLanguage(new Iso639::Language("no"));
    _registerLanguage(new Iso639::Language("oc"));
    _registerLanguage(new Iso639::Language("om"));
    _registerLanguage(new Iso639::Language("or"));
    _registerLanguage(new Iso639::Language("pa"));
    _registerLanguage(new Iso639::Language("pl"));
    _registerLanguage(new Iso639::Language("ps"));
    _registerLanguage(new Iso639::Language("pt"));
    _registerLanguage(new Iso639::Language("qu"));
    _registerLanguage(new Iso639::Language("rm"));
    _registerLanguage(new Iso639::Language("rn"));
    _registerLanguage(new Iso639::Language("ro"));
    _registerLanguage(new Iso639::Language("ru"));
    _registerLanguage(new Iso639::Language("rw"));
    _registerLanguage(new Iso639::Language("sa"));
    _registerLanguage(new Iso639::Language("sd"));
    _registerLanguage(new Iso639::Language("sg"));
    _registerLanguage(new Iso639::Language("sh"));
    _registerLanguage(new Iso639::Language("si"));
    _registerLanguage(new Iso639::Language("sk"));
    _registerLanguage(new Iso639::Language("sl"));
    _registerLanguage(new Iso639::Language("sm"));
    _registerLanguage(new Iso639::Language("sn"));
    _registerLanguage(new Iso639::Language("so"));
    _registerLanguage(new Iso639::Language("sq"));
    _registerLanguage(new Iso639::Language("sr"));
    _registerLanguage(new Iso639::Language("ss"));
    _registerLanguage(new Iso639::Language("st"));
    _registerLanguage(new Iso639::Language("su"));
    _registerLanguage(new Iso639::Language("sv"));
    _registerLanguage(new Iso639::Language("sw"));
    _registerLanguage(new Iso639::Language("ta"));
    _registerLanguage(new Iso639::Language("te"));
    _registerLanguage(new Iso639::Language("tg"));
    _registerLanguage(new Iso639::Language("th"));
    _registerLanguage(new Iso639::Language("ti"));
    _registerLanguage(new Iso639::Language("tk"));
    _registerLanguage(new Iso639::Language("tl"));
    _registerLanguage(new Iso639::Language("tn"));
    _registerLanguage(new Iso639::Language("to"));
    _registerLanguage(new Iso639::Language("tr"));
    _registerLanguage(new Iso639::Language("ts"));
    _registerLanguage(new Iso639::Language("tt"));
    _registerLanguage(new Iso639::Language("tw"));
    _registerLanguage(new Iso639::Language("ug"));
    _registerLanguage(new Iso639::Language("uk"));
    _registerLanguage(new Iso639::Language("ur"));
    _registerLanguage(new Iso639::Language("uz"));
    _registerLanguage(new Iso639::Language("vi"));
    _registerLanguage(new Iso639::Language("vo"));
    _registerLanguage(new Iso639::Language("wo"));
    _registerLanguage(new Iso639::Language("xh"));
    _registerLanguage(new Iso639::Language("yi"));
    _registerLanguage(new Iso639::Language("yo"));
    _registerLanguage(new Iso639::Language("za"));
    _registerLanguage(new Iso639::Language("zh"));
    _registerLanguage(new Iso639::Language("zu"));
}

_impl::_Iso639Impl::~_Iso639Impl()
{
    for (UIntSize i = 0; i < _languages.size(); i++)
    {
        delete _languages[i];
    }
}

_impl::_Iso639Impl * _impl::_Iso639Impl::getInstance()
{
    static _Iso639Impl instance;
    return &instance;
}

//////////
//  Operations
Array<const Iso639::Language*> _impl::_Iso639Impl::getAllLanguages()
{
    return _languages;
}

const Iso639::Language * _impl::_Iso639Impl::findLanguageByCode2(const _Iso639Code2 & code2) const
{
    if (_mapCode2ToLanguage.containsKey(code2))
    {
        return _mapCode2ToLanguage.get(code2);
    }
    else
    {
        return NULL;
    }
}

MapResourceFactory * _impl::_Iso639Impl::getResourceFactory() const
{
    return &_resourceFactory;
}

//////////
//  Implementation helpers
void _impl::_Iso639Impl::_registerLanguage(const Iso639::Language * pLanguage)
{
    require(pLanguage != NULL);

    String code2String = pLanguage->getCode2();
    _Iso639Code2 code2(code2String[0], code2String[1]);
    require(!_mapCode2ToLanguage.containsKey(code2));
    _languages.append(pLanguage);
    _mapCode2ToLanguage.insert(code2, pLanguage);
}

//  End of Iso639Impl.cpp
