//
//  Iso639ResourceMap_en.cpp - Implementation of the carl::_Iso639ResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.5 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "Iso639Impl.hpp"

//////////
//  Construction/destruction
_impl::_Iso639ResourceMap_en::_Iso639ResourceMap_en()
    :   _mapCodes2ToLanguageDisplayNames(StandardHashFunctions::hashString)
{
    _mapCodes2ToLanguageDisplayNames.insert(String("aa"), String("Afar"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ab"), String("Abkhazian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("af"), String("Afrikaans"));
    _mapCodes2ToLanguageDisplayNames.insert(String("am"), String("Amharic"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ar"), String("Arabic"));
    _mapCodes2ToLanguageDisplayNames.insert(String("as"), String("Assamese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ay"), String("Aymara"));
    _mapCodes2ToLanguageDisplayNames.insert(String("az"), String("Azerbaijani"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ba"), String("Bashkir"));
    _mapCodes2ToLanguageDisplayNames.insert(String("be"), String("Byelorussian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("bg"), String("Bulgarian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("bh"), String("Bihari"));
    _mapCodes2ToLanguageDisplayNames.insert(String("bi"), String("Bislama"));
    _mapCodes2ToLanguageDisplayNames.insert(String("bn"), String("Bengali"));
    _mapCodes2ToLanguageDisplayNames.insert(String("bo"), String("Tibetan"));
    _mapCodes2ToLanguageDisplayNames.insert(String("br"), String("Breton"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ca"), String("Catalan"));
    _mapCodes2ToLanguageDisplayNames.insert(String("co"), String("Corsican"));
    _mapCodes2ToLanguageDisplayNames.insert(String("cs"), String("Czech"));
    _mapCodes2ToLanguageDisplayNames.insert(String("cy"), String("Welsh"));
    _mapCodes2ToLanguageDisplayNames.insert(String("da"), String("Danish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("de"), String("German"));
    _mapCodes2ToLanguageDisplayNames.insert(String("dz"), String("Bhutani"));
    _mapCodes2ToLanguageDisplayNames.insert(String("el"), String("Greek"));
    _mapCodes2ToLanguageDisplayNames.insert(String("en"), String("English"));
    _mapCodes2ToLanguageDisplayNames.insert(String("eo"), String("Esperanto"));
    _mapCodes2ToLanguageDisplayNames.insert(String("es"), String("Spanish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("et"), String("Estonian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("eu"), String("Basque"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fa"), String("Persian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fi"), String("Finnish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fj"), String("Fiji"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fo"), String("Faroese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fr"), String("French"));
    _mapCodes2ToLanguageDisplayNames.insert(String("fy"), String("Frisian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ga"), String("Irish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("gd"), String("Scots Gaelic"));
    _mapCodes2ToLanguageDisplayNames.insert(String("gl"), String("Galician"));
    _mapCodes2ToLanguageDisplayNames.insert(String("gn"), String("Guarani"));
    _mapCodes2ToLanguageDisplayNames.insert(String("gu"), String("Gujarati"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ha"), String("Hausa"));
    _mapCodes2ToLanguageDisplayNames.insert(String("he"), String("Hebrew"));
    _mapCodes2ToLanguageDisplayNames.insert(String("hi"), String("Hindi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("hr"), String("Croatian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("hu"), String("Hungarian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("hy"), String("Armenian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ia"), String("Interlingua"));
    _mapCodes2ToLanguageDisplayNames.insert(String("id"), String("Indonesian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ie"), String("Interlingue"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ik"), String("Inupiak"));
    _mapCodes2ToLanguageDisplayNames.insert(String("is"), String("Icelandic"));
    _mapCodes2ToLanguageDisplayNames.insert(String("it"), String("Italian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("iu"), String("Eskimo Inuktitut CA"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ja"), String("Japanese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("jw"), String("Javanese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ka"), String("Georgian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("kk"), String("Kazakh"));
    _mapCodes2ToLanguageDisplayNames.insert(String("kl"), String("Greenlandic"));
    _mapCodes2ToLanguageDisplayNames.insert(String("km"), String("Cambodian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("kn"), String("Kannada"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ko"), String("Korean"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ks"), String("Kashmiri"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ku"), String("Kurdish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ky"), String("Kirghiz"));
    _mapCodes2ToLanguageDisplayNames.insert(String("la"), String("Latin"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ln"), String("Lingala"));
    _mapCodes2ToLanguageDisplayNames.insert(String("lo"), String("Laothian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("lt"), String("Lithuanian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("lv"), String("Latvian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mg"), String("Malagasy"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mi"), String("Maori"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mk"), String("Macedonian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ml"), String("Malayalam"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mn"), String("Mongolian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mo"), String("Moldavian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mr"), String("Marathi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ms"), String("Malay"));
    _mapCodes2ToLanguageDisplayNames.insert(String("mt"), String("Maltese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("my"), String("Burmese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("na"), String("Nauru"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ne"), String("Nepali"));
    _mapCodes2ToLanguageDisplayNames.insert(String("nl"), String("Dutch"));
    _mapCodes2ToLanguageDisplayNames.insert(String("no"), String("Norwegian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("oc"), String("Occitan"));
    _mapCodes2ToLanguageDisplayNames.insert(String("om"), String("Oromo"));
    _mapCodes2ToLanguageDisplayNames.insert(String("or"), String("Oriya"));
    _mapCodes2ToLanguageDisplayNames.insert(String("pa"), String("Punjabi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("pl"), String("Polish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ps"), String("Pashto"));
    _mapCodes2ToLanguageDisplayNames.insert(String("pt"), String("Portuguese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("qu"), String("Quechua"));
    _mapCodes2ToLanguageDisplayNames.insert(String("rm"), String("Rhaeto-Romance"));
    _mapCodes2ToLanguageDisplayNames.insert(String("rn"), String("Kirundi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ro"), String("Romanian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ru"), String("Russian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("rw"), String("Kinyarwanda"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sa"), String("Sanskrit"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sd"), String("Sindhi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sg"), String("Sangro"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sh"), String("Serbo-Croatian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("si"), String("Singhalese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sk"), String("Slovak"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sl"), String("Slovenian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sm"), String("Samoan"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sn"), String("Shona"));
    _mapCodes2ToLanguageDisplayNames.insert(String("so"), String("Somali"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sq"), String("Albanian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sr"), String("Serbian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ss"), String("Siswati"));
    _mapCodes2ToLanguageDisplayNames.insert(String("st"), String("Sesotho"));
    _mapCodes2ToLanguageDisplayNames.insert(String("su"), String("Sudanese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sv"), String("Swedish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("sw"), String("Swahili"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ta"), String("Tamil"));
    _mapCodes2ToLanguageDisplayNames.insert(String("te"), String("Tegulu"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tg"), String("Tajik"));
    _mapCodes2ToLanguageDisplayNames.insert(String("th"), String("Thai"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ti"), String("Tigrinya"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tk"), String("Turkmen"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tl"), String("Tagalog"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tn"), String("Setswana"));
    _mapCodes2ToLanguageDisplayNames.insert(String("to"), String("Tonga"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tr"), String("Turkish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ts"), String("Tsonga"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tt"), String("Tatar"));
    _mapCodes2ToLanguageDisplayNames.insert(String("tw"), String("Twi"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ug"), String("Uigur"));
    _mapCodes2ToLanguageDisplayNames.insert(String("uk"), String("Ukrainian"));
    _mapCodes2ToLanguageDisplayNames.insert(String("ur"), String("Urdu"));
    _mapCodes2ToLanguageDisplayNames.insert(String("uz"), String("Uzbek"));
    _mapCodes2ToLanguageDisplayNames.insert(String("vi"), String("Vietnamese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("vo"), String("Volapuk"));
    _mapCodes2ToLanguageDisplayNames.insert(String("wo"), String("Wolof"));
    _mapCodes2ToLanguageDisplayNames.insert(String("xh"), String("Xhosa"));
    _mapCodes2ToLanguageDisplayNames.insert(String("yi"), String("Yiddish"));
    _mapCodes2ToLanguageDisplayNames.insert(String("yo"), String("Yoruba"));
    _mapCodes2ToLanguageDisplayNames.insert(String("za"), String("Zhuang"));
    _mapCodes2ToLanguageDisplayNames.insert(String("zh"), String("Chinese"));
    _mapCodes2ToLanguageDisplayNames.insert(String("zu"), String("Zulu"));
}

_impl::_Iso639ResourceMap_en::~_Iso639ResourceMap_en()
{
}

//////////
//  Operations
String _impl::_Iso639ResourceMap_en::getString(const String & key)
{
    if (_mapCodes2ToLanguageDisplayNames.containsKey(key))
    {
        return _mapCodes2ToLanguageDisplayNames.get(key);
    }
    throw MissingResourceError(key);
}

//  End of Iso639ResourceMap_en.cpp
