//
//  KoiCharacterSetFamily.cpp - Implementation of the carl::_impl::_KoiCharacterSetFamily class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/08/03 02:13:39 $
//  $Revision: 1.1 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "CharsetImpl.hpp"

//////////
//  Singleton
_impl::_KoiCharacterSetFamily::_KoiCharacterSetFamily()
{
    _names.append(String("KOI"));
}

_impl::_KoiCharacterSetFamily::~_KoiCharacterSetFamily()
{
}

_impl::_KoiCharacterSetFamily * _impl::_KoiCharacterSetFamily::getInstance()
{
    static _KoiCharacterSetFamily instance;
    return &instance;
}

//////////
//  Operations
Array<String> _impl::_KoiCharacterSetFamily::getAllNames() const
{
    return _names;
}

String _impl::_KoiCharacterSetFamily::getCanonicalName() const
{
    return String("KOI");
}

String _impl::_KoiCharacterSetFamily::getPreferredName() const
{
    return String("KOI");
}

String _impl::_KoiCharacterSetFamily::getDisplayName() const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), Locale::getDefault());
}

String _impl::_KoiCharacterSetFamily::getDisplayName(const Locale & forLocale) const
{
    return _CharsetManagerImpl::getInstance()->getResourceFactory()->getString("CSF:" + getCanonicalName(), forLocale);
}

//  End of KoiCharacterSetFamily.cpp
