//
//  LocaleResourceMap_en.cpp - Implementation of the carl::_LocaleResourceMap_en class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.7 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "LocaleImpl.hpp"

//////////
//  Construction/destruction
_impl::_LocaleResourceMap_en::_LocaleResourceMap_en()
    :   _mapKeysToValues(StandardHashFunctions::hashString)
{
    _mapKeysToValues.insert(String(_LocaleManagerImpl::InvariantLocaleDisplayName), String("Invariant locale"));
}

_impl::_LocaleResourceMap_en::~_LocaleResourceMap_en()
{
}

//////////
//  Operations
String _impl::_LocaleResourceMap_en::getString(const String & key)
{
    if (_mapKeysToValues.containsKey(key))
    {
        return _mapKeysToValues.get(key);
    }
    throw MissingResourceError(key);
}

//  End of LocaleResourceMap_en.cpp
