//
//  NullCompressor.cpp - Implementation of the carl::_impl::_NullCompressor class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.6 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;
#include "CompressionImpl.hpp"

//////////
//  Singleton
_impl::_NullCompressor::_NullCompressor()
{
}

_impl::_NullCompressor::~_NullCompressor()
{
}

_impl::_NullCompressor * _impl::_NullCompressor::getInstance()
{
    static _NullCompressor instance;
    return &instance;
}

//////////
//  Operations
CompressionAlgorithm * _impl::_NullCompressor::getCompressionAlgorithm()
{
    return _NullCompressionAlgorithm::getInstance();
}

UIntSize _impl::_NullCompressor::getRequiredOutputBufferSize(const void * /*pUncompressedData*/, UIntSize uncompressedDataSize)
{
    return uncompressedDataSize;
}

UIntSize _impl::_NullCompressor::compress(const void * pUncompressedData, UIntSize uncompressedDataSize, void * pCompressedData)
{
    Memory::copy(pCompressedData, pUncompressedData, uncompressedDataSize);
    return uncompressedDataSize;
}

//  End of NullCompressor.cpp
