//
//  OutOfMemoryError.cpp - Implementation of the carl::OutOfMemoryError class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:53 $
//  $Revision: 1.8 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;

//////////
//  Construction/destruction/assignment
OutOfMemoryError::OutOfMemoryError(UIntSize allocationRequestSize)
    :   _allocationRequestSize(allocationRequestSize)
{
}

OutOfMemoryError::OutOfMemoryError(const OutOfMemoryError & src)
    :   _allocationRequestSize(src._allocationRequestSize)
{
}

OutOfMemoryError::~OutOfMemoryError()
{
}

OutOfMemoryError & OutOfMemoryError::operator = (const OutOfMemoryError & src)
{
    if (this != (&src))
    {
        _allocationRequestSize = src._allocationRequestSize;
    }
    return *this;
}

//////////
//  Operations
UIntSize OutOfMemoryError::getAllocationRequestSize() const
{
    return _allocationRequestSize;
}

String OutOfMemoryError::toString() const
{
    return *_getErrorMessageString();
}

String OutOfMemoryError::toString(const Locale & /*forLocale*/) const
{
    return *_getErrorMessageString();
}

//////////
//  Implementation helpers
String * OutOfMemoryError::_getErrorMessageString()
{
    static String message("Out of memory");
    return &message;
}

//  End of OutOfMemoryError.cpp
