//
//  ResourceFactory.cpp - Implementation of the carl::ResourceFactory class
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:54 $
//  $Revision: 1.7 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;

//////////
//  Operations
String ResourceFactory::getParameterizedString(const char * pKey, const Array<String> & params)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), params);
}

String ResourceFactory::getParameterizedString(const char * pKey, const Array<String> & params, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), params, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, forLocale);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, param9);
}

String ResourceFactory::getParameterizedString(const char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, param9, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const Array<String> & params)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), params);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const Array<String> & params, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), params, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, forLocale);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, param9);
}

String ResourceFactory::getParameterizedString(const Char * pKey, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9, const Locale & forLocale)
{
    require(pKey != NULL);

    return getParameterizedString(String(pKey), param0, param1, param2, param3, param4, param5, param6, param7, param8, param9, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const Array<String> & params)
{
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const Array<String> & params, const Locale & forLocale)
{
    String result;
    String format = getString(key, forLocale);
    for (UIntSize i = 0; i < format.length(); )
    {
        if (i + 1 < format.length() && format[i] == '$' && format[i + 1] == '$')
        {
            i += 2;
            result += '$';
        }
        else if (i + 1 < format.length() && format[i] == '$' && Iso10646::isDecimalDigit(format[i + 1]))
        {
            UIntSize paramNo = format[i + 1] - '0';
            i += 2;
            if (paramNo < params.size())
            {
                result += params[paramNo];
            }
        }
        else
        {
            result += format[i++];
        }
    }
    return result;
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0)
{
    Array<String> params;
    params.append(param0);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    params.append(param8);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    params.append(param8);
    return getParameterizedString(key, params, forLocale);
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    params.append(param8);
    params.append(param9);
    return getParameterizedString(key, params, Locale::getDefault());
}

String ResourceFactory::getParameterizedString(const String & key, const String & param0, const String & param1, const String & param2, const String & param3, const String & param4, const String & param5, const String & param6, const String & param7, const String & param8, const String & param9, const Locale & forLocale)
{
    Array<String> params;
    params.append(param0);
    params.append(param1);
    params.append(param2);
    params.append(param3);
    params.append(param4);
    params.append(param5);
    params.append(param6);
    params.append(param7);
    params.append(param8);
    params.append(param9);
    return getParameterizedString(key, params, forLocale);
}

//  End of ResourceFactory.cpp
