//
//  StandardHashFunctions.cpp - Implementation of the carl::StandardHashFunctions namespace
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:55 $
//  $Revision: 1.4 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#include "CARL.hpp"
using namespace carl;

//////////
//  Hashing platform-specific types
UIntSize CARL_CALLBACK StandardHashFunctions::hashPlainChar(const char & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashSignedChar(const signed char & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUnsignedChar(const unsigned char & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashSignedShort(const signed short & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUnsignedShort(const unsigned short & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashSignedInt(const signed int & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUnsignedInt(const unsigned int & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashSignedLong(const signed long & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUnsignedLong(const unsigned long & key)
{
    return static_cast<UIntSize>(key);
}

//////////
//  Hashing platform-independent types
UIntSize CARL_CALLBACK StandardHashFunctions::hashChar(const Char & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashInt8(const Int8 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashInt16(const Int16 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashInt32(const Int32 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashInt64(const Int64 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUInt8(const UInt8 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUInt16(const UInt16 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUInt32(const UInt32 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUInt64(const UInt64 & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUIntSize(const UIntSize & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashUIntPtr(const UIntPtr & key)
{
    return static_cast<UIntSize>(key);
}

UIntSize CARL_CALLBACK StandardHashFunctions::hashIntPtrDiff(const IntPtrDiff & key)
{
    return static_cast<UIntSize>(key);
}

//  End of StandardHashFunctions.cpp
