//
//  Main.cpp
//
//  The CARL Pair test.
//
//  $Date: 2008/02/29 11:24:50 $
//  $Revision: 1.1 $
//  $Author: akapusti $
//
//  Copyright (C) 2008 Cybernetic Intelligence GmbH
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////
#include "CARL.hpp"
using namespace carl;

class MyApp : public Application
{
    //////////
    //  Can't assign or copy construct
private:
    MyApp(const MyApp &);
    void                        operator = (const MyApp &);

    //////////
    //  Construction/destruction
public:
    MyApp() {}
    virtual ~MyApp() {}

    //////////
    //  Operations
public:
    virtual int run(const Array<String> & args);
};

MyApp theApp;

#define CHECK(condition) if (!(condition)) { exitCode = Process::ExitCode_Failure; }

int MyApp::run(const Array<String> & /*args*/)
{
    Process::ExitCode exitCode = Process::ExitCode_Success;

    const int Iterations = 1000;
    Random r;
    for (int i = 0; i < Iterations; i++)
    {
        Int32 first = r.nextInt32();
        Int32 second = r.nextInt32();
        Pair<Int32, Int32> p1(first, second);
        CHECK(p1.first() == first)
        CHECK(p1.second() == second)
        Pair<Int32, Int32> p2(p1);
        CHECK(p2.first() == first)
        CHECK(p2.second() == second)
        Pair<Int32, Int32> p3;
        p3 = p2;
        CHECK(p3.first() == first)
        CHECK(p3.second() == second)
    }
    return exitCode;
}

//  End of Main.cpp
