//
//  Main.cpp
//
//  The CARL System test.
//
//  $Date: 2007/07/18 16:12:29 $
//  $Revision: 1.1 $
//  $Author: akapusti $
//
//  Copyright (C) 2006 Cybernetic Intelligence GmbH
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////
#include "CARL.hpp"
using namespace carl;
#include <stdio.h>

class MyApp : public Application
{
    //////////
    //  Can't assign or copy construct
private:
    MyApp(const MyApp &);
    void                        operator = (const MyApp &);

    //////////
    //  Construction/destruction
public:
    MyApp() {}
    virtual ~MyApp() {}

    //////////
    //  Operations
public:
    virtual int run(const Array<String> & args);
};

MyApp theApp;

#define CHECK(x) if (!(x)) { exitCode = Process::ExitCode_Failure; }

int MyApp::run(const Array<String> & /*args*/)
{
    Process::ExitCode exitCode = Process::ExitCode_Success;

    CHECK(System::HostByteOrder == ByteOrder_LittleEndian || System::HostByteOrder == ByteOrder_BigEndian)
    if (System::HostByteOrder == ByteOrder_LittleEndian)
    {
        int x = 1;
        UInt8 *pBytes = reinterpret_cast<UInt8*>(&x);
        for (UIntSize i = 0; i < sizeof(int); i++)
        {
            CHECK(pBytes[i] == ((i == 0) ? 1 : 0))
        }
    }
    else
    {
        int x = 1;
        UInt8 *pBytes = reinterpret_cast<UInt8*>(&x);
        for (UIntSize i = 0; i < sizeof(int); i++)
        {
            CHECK(pBytes[i] == ((i == sizeof(int) - 1) ? 1 : 0))
        }
    }
    CHECK(System::BitsPerByte == 8)
    CHECK(System::BitsPerWord == 8 || System::BitsPerWord == 16 || System::BitsPerWord == 32 || System::BitsPerWord == 64)
    CHECK(System::VersionMajor >= 1)
    CHECK(System::VersionMinor >= 0)
    CHECK(System::PatchLevel >= 0)
    CHECK(System::getBuildKey() != NULL)

    //  Done
    return exitCode;
}

//  End of Main.cpp
