//
//  UnicodeData.hpp - Unicode character tables
//
//  Copyright (C) 2006-2008, Cybernetic Intelligence GmbH
//
//  $Date: 2008/02/22 11:54:56 $
//  $Revision: 1.5 $
//  $Author: akapusti $
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//////////
#ifndef __UnicodeData_hpp_included__
#define __UnicodeData_hpp_included__

namespace
{
    struct _CharacterInfo
    {
        Char                                charCode;
        Iso10646::GeneralCategory           generalCategory;
        UInt8                               canonicalCombiningClass;
        Iso10646::BidirectionalCategory     bidirectionalCategory;
        Iso10646::DecompositionMappingTag   decompositionMappingTag;
        UInt8                               decompositionMappingSize;
        Char *                              pDecompositionMapping;
        bool                                hasDecimalDigitValue;
        UInt8                               decimalDigitValue;
        bool                                hasDigitValue;
        Int64                               digitValue;
        bool                                hasNumericValue;
        Int64                               numericValueNumerator;
        Int64                               numericValueDenominator;
        bool                                mirrored;
        Char                                uppercaseMapping;
        Char                                lowercaseMapping;
        Char                                titlecaseMapping;
    };

    static _CharacterInfo _character00000000 =
    {
        0x00000000,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000000,
        0x00000000,
        0x00000000
    };

    static _CharacterInfo _character00000001 =
    {
        0x00000001,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000001,
        0x00000001,
        0x00000001
    };

    static _CharacterInfo _character00000002 =
    {
        0x00000002,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000002,
        0x00000002,
        0x00000002
    };

    static _CharacterInfo _character00000003 =
    {
        0x00000003,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000003,
        0x00000003,
        0x00000003
    };

    static _CharacterInfo _character00000004 =
    {
        0x00000004,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000004,
        0x00000004,
        0x00000004
    };

    static _CharacterInfo _character00000005 =
    {
        0x00000005,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000005,
        0x00000005,
        0x00000005
    };

    static _CharacterInfo _character00000006 =
    {
        0x00000006,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000006,
        0x00000006,
        0x00000006
    };

    static _CharacterInfo _character00000007 =
    {
        0x00000007,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000007,
        0x00000007,
        0x00000007
    };

    static _CharacterInfo _character00000008 =
    {
        0x00000008,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000008,
        0x00000008,
        0x00000008
    };

    static _CharacterInfo _character00000009 =
    {
        0x00000009,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_S,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000009,
        0x00000009,
        0x00000009
    };

    static _CharacterInfo _character0000000A =
    {
        0x0000000A,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000A,
        0x0000000A,
        0x0000000A
    };

    static _CharacterInfo _character0000000B =
    {
        0x0000000B,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_S,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000B,
        0x0000000B,
        0x0000000B
    };

    static _CharacterInfo _character0000000C =
    {
        0x0000000C,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000C,
        0x0000000C,
        0x0000000C
    };

    static _CharacterInfo _character0000000D =
    {
        0x0000000D,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000D,
        0x0000000D,
        0x0000000D
    };

    static _CharacterInfo _character0000000E =
    {
        0x0000000E,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000E,
        0x0000000E,
        0x0000000E
    };

    static _CharacterInfo _character0000000F =
    {
        0x0000000F,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000000F,
        0x0000000F,
        0x0000000F
    };

    static _CharacterInfo _character00000010 =
    {
        0x00000010,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000010,
        0x00000010,
        0x00000010
    };

    static _CharacterInfo _character00000011 =
    {
        0x00000011,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000011,
        0x00000011,
        0x00000011
    };

    static _CharacterInfo _character00000012 =
    {
        0x00000012,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000012,
        0x00000012,
        0x00000012
    };

    static _CharacterInfo _character00000013 =
    {
        0x00000013,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000013,
        0x00000013,
        0x00000013
    };

    static _CharacterInfo _character00000014 =
    {
        0x00000014,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000014,
        0x00000014,
        0x00000014
    };

    static _CharacterInfo _character00000015 =
    {
        0x00000015,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000015,
        0x00000015,
        0x00000015
    };

    static _CharacterInfo _character00000016 =
    {
        0x00000016,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000016,
        0x00000016,
        0x00000016
    };

    static _CharacterInfo _character00000017 =
    {
        0x00000017,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000017,
        0x00000017,
        0x00000017
    };

    static _CharacterInfo _character00000018 =
    {
        0x00000018,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000018,
        0x00000018,
        0x00000018
    };

    static _CharacterInfo _character00000019 =
    {
        0x00000019,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000019,
        0x00000019,
        0x00000019
    };

    static _CharacterInfo _character0000001A =
    {
        0x0000001A,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001A,
        0x0000001A,
        0x0000001A
    };

    static _CharacterInfo _character0000001B =
    {
        0x0000001B,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001B,
        0x0000001B,
        0x0000001B
    };

    static _CharacterInfo _character0000001C =
    {
        0x0000001C,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001C,
        0x0000001C,
        0x0000001C
    };

    static _CharacterInfo _character0000001D =
    {
        0x0000001D,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001D,
        0x0000001D,
        0x0000001D
    };

    static _CharacterInfo _character0000001E =
    {
        0x0000001E,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001E,
        0x0000001E,
        0x0000001E
    };

    static _CharacterInfo _character0000001F =
    {
        0x0000001F,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_S,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000001F,
        0x0000001F,
        0x0000001F
    };

    static _CharacterInfo _character00000020 =
    {
        0x00000020,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000020,
        0x00000020,
        0x00000020
    };

    static _CharacterInfo _character00000021 =
    {
        0x00000021,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000021,
        0x00000021,
        0x00000021
    };

    static _CharacterInfo _character00000022 =
    {
        0x00000022,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000022,
        0x00000022,
        0x00000022
    };

    static _CharacterInfo _character00000023 =
    {
        0x00000023,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000023,
        0x00000023,
        0x00000023
    };

    static _CharacterInfo _character00000024 =
    {
        0x00000024,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000024,
        0x00000024,
        0x00000024
    };

    static _CharacterInfo _character00000025 =
    {
        0x00000025,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000025,
        0x00000025,
        0x00000025
    };

    static _CharacterInfo _character00000026 =
    {
        0x00000026,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000026,
        0x00000026,
        0x00000026
    };

    static _CharacterInfo _character00000027 =
    {
        0x00000027,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000027,
        0x00000027,
        0x00000027
    };

    static _CharacterInfo _character00000028 =
    {
        0x00000028,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000028,
        0x00000028,
        0x00000028
    };

    static _CharacterInfo _character00000029 =
    {
        0x00000029,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000029,
        0x00000029,
        0x00000029
    };

    static _CharacterInfo _character0000002A =
    {
        0x0000002A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002A,
        0x0000002A,
        0x0000002A
    };

    static _CharacterInfo _character0000002B =
    {
        0x0000002B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002B,
        0x0000002B,
        0x0000002B
    };

    static _CharacterInfo _character0000002C =
    {
        0x0000002C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002C,
        0x0000002C,
        0x0000002C
    };

    static _CharacterInfo _character0000002D =
    {
        0x0000002D,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002D,
        0x0000002D,
        0x0000002D
    };

    static _CharacterInfo _character0000002E =
    {
        0x0000002E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002E,
        0x0000002E,
        0x0000002E
    };

    static _CharacterInfo _character0000002F =
    {
        0x0000002F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000002F,
        0x0000002F,
        0x0000002F
    };

    static _CharacterInfo _character00000030 =
    {
        0x00000030,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000030,
        0x00000030,
        0x00000030
    };

    static _CharacterInfo _character00000031 =
    {
        0x00000031,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000031,
        0x00000031,
        0x00000031
    };

    static _CharacterInfo _character00000032 =
    {
        0x00000032,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000032,
        0x00000032,
        0x00000032
    };

    static _CharacterInfo _character00000033 =
    {
        0x00000033,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000033,
        0x00000033,
        0x00000033
    };

    static _CharacterInfo _character00000034 =
    {
        0x00000034,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000034,
        0x00000034,
        0x00000034
    };

    static _CharacterInfo _character00000035 =
    {
        0x00000035,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000035,
        0x00000035,
        0x00000035
    };

    static _CharacterInfo _character00000036 =
    {
        0x00000036,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000036,
        0x00000036,
        0x00000036
    };

    static _CharacterInfo _character00000037 =
    {
        0x00000037,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000037,
        0x00000037,
        0x00000037
    };

    static _CharacterInfo _character00000038 =
    {
        0x00000038,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000038,
        0x00000038,
        0x00000038
    };

    static _CharacterInfo _character00000039 =
    {
        0x00000039,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000039,
        0x00000039,
        0x00000039
    };

    static _CharacterInfo _character0000003A =
    {
        0x0000003A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000003A,
        0x0000003A,
        0x0000003A
    };

    static _CharacterInfo _character0000003B =
    {
        0x0000003B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000003B,
        0x0000003B,
        0x0000003B
    };

    static _CharacterInfo _character0000003C =
    {
        0x0000003C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000003C,
        0x0000003C,
        0x0000003C
    };

    static _CharacterInfo _character0000003D =
    {
        0x0000003D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000003D,
        0x0000003D,
        0x0000003D
    };

    static _CharacterInfo _character0000003E =
    {
        0x0000003E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000003E,
        0x0000003E,
        0x0000003E
    };

    static _CharacterInfo _character0000003F =
    {
        0x0000003F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000003F,
        0x0000003F,
        0x0000003F
    };

    static _CharacterInfo _character00000040 =
    {
        0x00000040,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000040,
        0x00000040,
        0x00000040
    };

    static _CharacterInfo _character00000041 =
    {
        0x00000041,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000041,
        0x00000061,
        0x00000041
    };

    static _CharacterInfo _character00000042 =
    {
        0x00000042,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000042,
        0x00000062,
        0x00000042
    };

    static _CharacterInfo _character00000043 =
    {
        0x00000043,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000043,
        0x00000063,
        0x00000043
    };

    static _CharacterInfo _character00000044 =
    {
        0x00000044,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000044,
        0x00000064,
        0x00000044
    };

    static _CharacterInfo _character00000045 =
    {
        0x00000045,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000045,
        0x00000065,
        0x00000045
    };

    static _CharacterInfo _character00000046 =
    {
        0x00000046,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000046,
        0x00000066,
        0x00000046
    };

    static _CharacterInfo _character00000047 =
    {
        0x00000047,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000047,
        0x00000067,
        0x00000047
    };

    static _CharacterInfo _character00000048 =
    {
        0x00000048,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000048,
        0x00000068,
        0x00000048
    };

    static _CharacterInfo _character00000049 =
    {
        0x00000049,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000049,
        0x00000069,
        0x00000049
    };

    static _CharacterInfo _character0000004A =
    {
        0x0000004A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004A,
        0x0000006A,
        0x0000004A
    };

    static _CharacterInfo _character0000004B =
    {
        0x0000004B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004B,
        0x0000006B,
        0x0000004B
    };

    static _CharacterInfo _character0000004C =
    {
        0x0000004C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004C,
        0x0000006C,
        0x0000004C
    };

    static _CharacterInfo _character0000004D =
    {
        0x0000004D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004D,
        0x0000006D,
        0x0000004D
    };

    static _CharacterInfo _character0000004E =
    {
        0x0000004E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004E,
        0x0000006E,
        0x0000004E
    };

    static _CharacterInfo _character0000004F =
    {
        0x0000004F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004F,
        0x0000006F,
        0x0000004F
    };

    static _CharacterInfo _character00000050 =
    {
        0x00000050,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000050,
        0x00000070,
        0x00000050
    };

    static _CharacterInfo _character00000051 =
    {
        0x00000051,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000051,
        0x00000071,
        0x00000051
    };

    static _CharacterInfo _character00000052 =
    {
        0x00000052,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000052,
        0x00000072,
        0x00000052
    };

    static _CharacterInfo _character00000053 =
    {
        0x00000053,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000053,
        0x00000073,
        0x00000053
    };

    static _CharacterInfo _character00000054 =
    {
        0x00000054,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000054,
        0x00000074,
        0x00000054
    };

    static _CharacterInfo _character00000055 =
    {
        0x00000055,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000055,
        0x00000075,
        0x00000055
    };

    static _CharacterInfo _character00000056 =
    {
        0x00000056,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000056,
        0x00000076,
        0x00000056
    };

    static _CharacterInfo _character00000057 =
    {
        0x00000057,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000057,
        0x00000077,
        0x00000057
    };

    static _CharacterInfo _character00000058 =
    {
        0x00000058,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000058,
        0x00000078,
        0x00000058
    };

    static _CharacterInfo _character00000059 =
    {
        0x00000059,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000059,
        0x00000079,
        0x00000059
    };

    static _CharacterInfo _character0000005A =
    {
        0x0000005A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000005A,
        0x0000007A,
        0x0000005A
    };

    static _CharacterInfo _character0000005B =
    {
        0x0000005B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000005B,
        0x0000005B,
        0x0000005B
    };

    static _CharacterInfo _character0000005C =
    {
        0x0000005C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000005C,
        0x0000005C,
        0x0000005C
    };

    static _CharacterInfo _character0000005D =
    {
        0x0000005D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000005D,
        0x0000005D,
        0x0000005D
    };

    static _CharacterInfo _character0000005E =
    {
        0x0000005E,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000005E,
        0x0000005E,
        0x0000005E
    };

    static _CharacterInfo _character0000005F =
    {
        0x0000005F,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000005F,
        0x0000005F,
        0x0000005F
    };

    static _CharacterInfo _character00000060 =
    {
        0x00000060,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000060,
        0x00000060,
        0x00000060
    };

    static _CharacterInfo _character00000061 =
    {
        0x00000061,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000041,
        0x00000061,
        0x00000041
    };

    static _CharacterInfo _character00000062 =
    {
        0x00000062,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000042,
        0x00000062,
        0x00000042
    };

    static _CharacterInfo _character00000063 =
    {
        0x00000063,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000043,
        0x00000063,
        0x00000043
    };

    static _CharacterInfo _character00000064 =
    {
        0x00000064,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000044,
        0x00000064,
        0x00000044
    };

    static _CharacterInfo _character00000065 =
    {
        0x00000065,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000045,
        0x00000065,
        0x00000045
    };

    static _CharacterInfo _character00000066 =
    {
        0x00000066,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000046,
        0x00000066,
        0x00000046
    };

    static _CharacterInfo _character00000067 =
    {
        0x00000067,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000047,
        0x00000067,
        0x00000047
    };

    static _CharacterInfo _character00000068 =
    {
        0x00000068,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000048,
        0x00000068,
        0x00000048
    };

    static _CharacterInfo _character00000069 =
    {
        0x00000069,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000049,
        0x00000069,
        0x00000049
    };

    static _CharacterInfo _character0000006A =
    {
        0x0000006A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004A,
        0x0000006A,
        0x0000004A
    };

    static _CharacterInfo _character0000006B =
    {
        0x0000006B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004B,
        0x0000006B,
        0x0000004B
    };

    static _CharacterInfo _character0000006C =
    {
        0x0000006C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004C,
        0x0000006C,
        0x0000004C
    };

    static _CharacterInfo _character0000006D =
    {
        0x0000006D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004D,
        0x0000006D,
        0x0000004D
    };

    static _CharacterInfo _character0000006E =
    {
        0x0000006E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004E,
        0x0000006E,
        0x0000004E
    };

    static _CharacterInfo _character0000006F =
    {
        0x0000006F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000004F,
        0x0000006F,
        0x0000004F
    };

    static _CharacterInfo _character00000070 =
    {
        0x00000070,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000050,
        0x00000070,
        0x00000050
    };

    static _CharacterInfo _character00000071 =
    {
        0x00000071,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000051,
        0x00000071,
        0x00000051
    };

    static _CharacterInfo _character00000072 =
    {
        0x00000072,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000052,
        0x00000072,
        0x00000052
    };

    static _CharacterInfo _character00000073 =
    {
        0x00000073,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000053,
        0x00000073,
        0x00000053
    };

    static _CharacterInfo _character00000074 =
    {
        0x00000074,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000054,
        0x00000074,
        0x00000054
    };

    static _CharacterInfo _character00000075 =
    {
        0x00000075,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000055,
        0x00000075,
        0x00000055
    };

    static _CharacterInfo _character00000076 =
    {
        0x00000076,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000056,
        0x00000076,
        0x00000056
    };

    static _CharacterInfo _character00000077 =
    {
        0x00000077,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000057,
        0x00000077,
        0x00000057
    };

    static _CharacterInfo _character00000078 =
    {
        0x00000078,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000058,
        0x00000078,
        0x00000058
    };

    static _CharacterInfo _character00000079 =
    {
        0x00000079,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000059,
        0x00000079,
        0x00000059
    };

    static _CharacterInfo _character0000007A =
    {
        0x0000007A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000005A,
        0x0000007A,
        0x0000005A
    };

    static _CharacterInfo _character0000007B =
    {
        0x0000007B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000007B,
        0x0000007B,
        0x0000007B
    };

    static _CharacterInfo _character0000007C =
    {
        0x0000007C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000007C,
        0x0000007C,
        0x0000007C
    };

    static _CharacterInfo _character0000007D =
    {
        0x0000007D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000007D,
        0x0000007D,
        0x0000007D
    };

    static _CharacterInfo _character0000007E =
    {
        0x0000007E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000007E,
        0x0000007E,
        0x0000007E
    };

    static _CharacterInfo _character0000007F =
    {
        0x0000007F,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000007F,
        0x0000007F,
        0x0000007F
    };

    static _CharacterInfo _character00000080 =
    {
        0x00000080,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000080,
        0x00000080,
        0x00000080
    };

    static _CharacterInfo _character00000081 =
    {
        0x00000081,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000081,
        0x00000081,
        0x00000081
    };

    static _CharacterInfo _character00000082 =
    {
        0x00000082,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000082,
        0x00000082,
        0x00000082
    };

    static _CharacterInfo _character00000083 =
    {
        0x00000083,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000083,
        0x00000083,
        0x00000083
    };

    static _CharacterInfo _character00000084 =
    {
        0x00000084,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000084,
        0x00000084,
        0x00000084
    };

    static _CharacterInfo _character00000085 =
    {
        0x00000085,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000085,
        0x00000085,
        0x00000085
    };

    static _CharacterInfo _character00000086 =
    {
        0x00000086,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000086,
        0x00000086,
        0x00000086
    };

    static _CharacterInfo _character00000087 =
    {
        0x00000087,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000087,
        0x00000087,
        0x00000087
    };

    static _CharacterInfo _character00000088 =
    {
        0x00000088,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000088,
        0x00000088,
        0x00000088
    };

    static _CharacterInfo _character00000089 =
    {
        0x00000089,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000089,
        0x00000089,
        0x00000089
    };

    static _CharacterInfo _character0000008A =
    {
        0x0000008A,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008A,
        0x0000008A,
        0x0000008A
    };

    static _CharacterInfo _character0000008B =
    {
        0x0000008B,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008B,
        0x0000008B,
        0x0000008B
    };

    static _CharacterInfo _character0000008C =
    {
        0x0000008C,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008C,
        0x0000008C,
        0x0000008C
    };

    static _CharacterInfo _character0000008D =
    {
        0x0000008D,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008D,
        0x0000008D,
        0x0000008D
    };

    static _CharacterInfo _character0000008E =
    {
        0x0000008E,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008E,
        0x0000008E,
        0x0000008E
    };

    static _CharacterInfo _character0000008F =
    {
        0x0000008F,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000008F,
        0x0000008F,
        0x0000008F
    };

    static _CharacterInfo _character00000090 =
    {
        0x00000090,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000090,
        0x00000090,
        0x00000090
    };

    static _CharacterInfo _character00000091 =
    {
        0x00000091,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000091,
        0x00000091,
        0x00000091
    };

    static _CharacterInfo _character00000092 =
    {
        0x00000092,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000092,
        0x00000092,
        0x00000092
    };

    static _CharacterInfo _character00000093 =
    {
        0x00000093,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000093,
        0x00000093,
        0x00000093
    };

    static _CharacterInfo _character00000094 =
    {
        0x00000094,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000094,
        0x00000094,
        0x00000094
    };

    static _CharacterInfo _character00000095 =
    {
        0x00000095,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000095,
        0x00000095,
        0x00000095
    };

    static _CharacterInfo _character00000096 =
    {
        0x00000096,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000096,
        0x00000096,
        0x00000096
    };

    static _CharacterInfo _character00000097 =
    {
        0x00000097,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000097,
        0x00000097,
        0x00000097
    };

    static _CharacterInfo _character00000098 =
    {
        0x00000098,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000098,
        0x00000098,
        0x00000098
    };

    static _CharacterInfo _character00000099 =
    {
        0x00000099,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000099,
        0x00000099,
        0x00000099
    };

    static _CharacterInfo _character0000009A =
    {
        0x0000009A,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009A,
        0x0000009A,
        0x0000009A
    };

    static _CharacterInfo _character0000009B =
    {
        0x0000009B,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009B,
        0x0000009B,
        0x0000009B
    };

    static _CharacterInfo _character0000009C =
    {
        0x0000009C,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009C,
        0x0000009C,
        0x0000009C
    };

    static _CharacterInfo _character0000009D =
    {
        0x0000009D,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009D,
        0x0000009D,
        0x0000009D
    };

    static _CharacterInfo _character0000009E =
    {
        0x0000009E,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009E,
        0x0000009E,
        0x0000009E
    };

    static _CharacterInfo _character0000009F =
    {
        0x0000009F,
        Iso10646::GeneralCategory_Cc,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000009F,
        0x0000009F,
        0x0000009F
    };

    static Char _decompositionMapping000000A0[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character000000A0 =
    {
        0x000000A0,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_noBreak,
        1,
        _decompositionMapping000000A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A0,
        0x000000A0,
        0x000000A0
    };

    static _CharacterInfo _character000000A1 =
    {
        0x000000A1,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A1,
        0x000000A1,
        0x000000A1
    };

    static _CharacterInfo _character000000A2 =
    {
        0x000000A2,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A2,
        0x000000A2,
        0x000000A2
    };

    static _CharacterInfo _character000000A3 =
    {
        0x000000A3,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A3,
        0x000000A3,
        0x000000A3
    };

    static _CharacterInfo _character000000A4 =
    {
        0x000000A4,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A4,
        0x000000A4,
        0x000000A4
    };

    static _CharacterInfo _character000000A5 =
    {
        0x000000A5,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A5,
        0x000000A5,
        0x000000A5
    };

    static _CharacterInfo _character000000A6 =
    {
        0x000000A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A6,
        0x000000A6,
        0x000000A6
    };

    static _CharacterInfo _character000000A7 =
    {
        0x000000A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A7,
        0x000000A7,
        0x000000A7
    };

    static Char _decompositionMapping000000A8[] = 
    {
        0x00000020,
        0x00000308
    };

    static _CharacterInfo _character000000A8 =
    {
        0x000000A8,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000000A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A8,
        0x000000A8,
        0x000000A8
    };

    static _CharacterInfo _character000000A9 =
    {
        0x000000A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000A9,
        0x000000A9,
        0x000000A9
    };

    static Char _decompositionMapping000000AA[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character000000AA =
    {
        0x000000AA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000000AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000AA,
        0x000000AA,
        0x000000AA
    };

    static _CharacterInfo _character000000AB =
    {
        0x000000AB,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000000AB,
        0x000000AB,
        0x000000AB
    };

    static _CharacterInfo _character000000AC =
    {
        0x000000AC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000AC,
        0x000000AC,
        0x000000AC
    };

    static _CharacterInfo _character000000AD =
    {
        0x000000AD,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000AD,
        0x000000AD,
        0x000000AD
    };

    static _CharacterInfo _character000000AE =
    {
        0x000000AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000AE,
        0x000000AE,
        0x000000AE
    };

    static Char _decompositionMapping000000AF[] = 
    {
        0x00000020,
        0x00000304
    };

    static _CharacterInfo _character000000AF =
    {
        0x000000AF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000000AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000AF,
        0x000000AF,
        0x000000AF
    };

    static _CharacterInfo _character000000B0 =
    {
        0x000000B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B0,
        0x000000B0,
        0x000000B0
    };

    static _CharacterInfo _character000000B1 =
    {
        0x000000B1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B1,
        0x000000B1,
        0x000000B1
    };

    static Char _decompositionMapping000000B2[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character000000B2 =
    {
        0x000000B2,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000000B2,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000000B2,
        0x000000B2,
        0x000000B2
    };

    static Char _decompositionMapping000000B3[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character000000B3 =
    {
        0x000000B3,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000000B3,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000000B3,
        0x000000B3,
        0x000000B3
    };

    static Char _decompositionMapping000000B4[] = 
    {
        0x00000020,
        0x00000301
    };

    static _CharacterInfo _character000000B4 =
    {
        0x000000B4,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000000B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B4,
        0x000000B4,
        0x000000B4
    };

    static Char _decompositionMapping000000B5[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character000000B5 =
    {
        0x000000B5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000000B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039C,
        0x000000B5,
        0x0000039C
    };

    static _CharacterInfo _character000000B6 =
    {
        0x000000B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B6,
        0x000000B6,
        0x000000B6
    };

    static _CharacterInfo _character000000B7 =
    {
        0x000000B7,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B7,
        0x000000B7,
        0x000000B7
    };

    static Char _decompositionMapping000000B8[] = 
    {
        0x00000020,
        0x00000327
    };

    static _CharacterInfo _character000000B8 =
    {
        0x000000B8,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000000B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000B8,
        0x000000B8,
        0x000000B8
    };

    static Char _decompositionMapping000000B9[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character000000B9 =
    {
        0x000000B9,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000000B9,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000000B9,
        0x000000B9,
        0x000000B9
    };

    static Char _decompositionMapping000000BA[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character000000BA =
    {
        0x000000BA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000000BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000BA,
        0x000000BA,
        0x000000BA
    };

    static _CharacterInfo _character000000BB =
    {
        0x000000BB,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000000BB,
        0x000000BB,
        0x000000BB
    };

    static Char _decompositionMapping000000BC[] = 
    {
        0x00000031,
        0x00002044,
        0x00000034
    };

    static _CharacterInfo _character000000BC =
    {
        0x000000BC,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping000000BC,
        false,
        0,
        false,
        0,
        true,
        1,
        4,
        false,
        0x000000BC,
        0x000000BC,
        0x000000BC
    };

    static Char _decompositionMapping000000BD[] = 
    {
        0x00000031,
        0x00002044,
        0x00000032
    };

    static _CharacterInfo _character000000BD =
    {
        0x000000BD,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping000000BD,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x000000BD,
        0x000000BD,
        0x000000BD
    };

    static Char _decompositionMapping000000BE[] = 
    {
        0x00000033,
        0x00002044,
        0x00000034
    };

    static _CharacterInfo _character000000BE =
    {
        0x000000BE,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping000000BE,
        false,
        0,
        false,
        0,
        true,
        3,
        4,
        false,
        0x000000BE,
        0x000000BE,
        0x000000BE
    };

    static _CharacterInfo _character000000BF =
    {
        0x000000BF,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000BF,
        0x000000BF,
        0x000000BF
    };

    static Char _decompositionMapping000000C0[] = 
    {
        0x00000041,
        0x00000300
    };

    static _CharacterInfo _character000000C0 =
    {
        0x000000C0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C0,
        0x000000E0,
        0x000000C0
    };

    static Char _decompositionMapping000000C1[] = 
    {
        0x00000041,
        0x00000301
    };

    static _CharacterInfo _character000000C1 =
    {
        0x000000C1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C1,
        0x000000E1,
        0x000000C1
    };

    static Char _decompositionMapping000000C2[] = 
    {
        0x00000041,
        0x00000302
    };

    static _CharacterInfo _character000000C2 =
    {
        0x000000C2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C2,
        0x000000E2,
        0x000000C2
    };

    static Char _decompositionMapping000000C3[] = 
    {
        0x00000041,
        0x00000303
    };

    static _CharacterInfo _character000000C3 =
    {
        0x000000C3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C3,
        0x000000E3,
        0x000000C3
    };

    static Char _decompositionMapping000000C4[] = 
    {
        0x00000041,
        0x00000308
    };

    static _CharacterInfo _character000000C4 =
    {
        0x000000C4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C4,
        0x000000E4,
        0x000000C4
    };

    static Char _decompositionMapping000000C5[] = 
    {
        0x00000041,
        0x0000030A
    };

    static _CharacterInfo _character000000C5 =
    {
        0x000000C5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C5,
        0x000000E5,
        0x000000C5
    };

    static _CharacterInfo _character000000C6 =
    {
        0x000000C6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C6,
        0x000000E6,
        0x000000C6
    };

    static Char _decompositionMapping000000C7[] = 
    {
        0x00000043,
        0x00000327
    };

    static _CharacterInfo _character000000C7 =
    {
        0x000000C7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C7,
        0x000000E7,
        0x000000C7
    };

    static Char _decompositionMapping000000C8[] = 
    {
        0x00000045,
        0x00000300
    };

    static _CharacterInfo _character000000C8 =
    {
        0x000000C8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C8,
        0x000000E8,
        0x000000C8
    };

    static Char _decompositionMapping000000C9[] = 
    {
        0x00000045,
        0x00000301
    };

    static _CharacterInfo _character000000C9 =
    {
        0x000000C9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C9,
        0x000000E9,
        0x000000C9
    };

    static Char _decompositionMapping000000CA[] = 
    {
        0x00000045,
        0x00000302
    };

    static _CharacterInfo _character000000CA =
    {
        0x000000CA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CA,
        0x000000EA,
        0x000000CA
    };

    static Char _decompositionMapping000000CB[] = 
    {
        0x00000045,
        0x00000308
    };

    static _CharacterInfo _character000000CB =
    {
        0x000000CB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CB,
        0x000000EB,
        0x000000CB
    };

    static Char _decompositionMapping000000CC[] = 
    {
        0x00000049,
        0x00000300
    };

    static _CharacterInfo _character000000CC =
    {
        0x000000CC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CC,
        0x000000EC,
        0x000000CC
    };

    static Char _decompositionMapping000000CD[] = 
    {
        0x00000049,
        0x00000301
    };

    static _CharacterInfo _character000000CD =
    {
        0x000000CD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CD,
        0x000000ED,
        0x000000CD
    };

    static Char _decompositionMapping000000CE[] = 
    {
        0x00000049,
        0x00000302
    };

    static _CharacterInfo _character000000CE =
    {
        0x000000CE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CE,
        0x000000EE,
        0x000000CE
    };

    static Char _decompositionMapping000000CF[] = 
    {
        0x00000049,
        0x00000308
    };

    static _CharacterInfo _character000000CF =
    {
        0x000000CF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CF,
        0x000000EF,
        0x000000CF
    };

    static _CharacterInfo _character000000D0 =
    {
        0x000000D0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D0,
        0x000000F0,
        0x000000D0
    };

    static Char _decompositionMapping000000D1[] = 
    {
        0x0000004E,
        0x00000303
    };

    static _CharacterInfo _character000000D1 =
    {
        0x000000D1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D1,
        0x000000F1,
        0x000000D1
    };

    static Char _decompositionMapping000000D2[] = 
    {
        0x0000004F,
        0x00000300
    };

    static _CharacterInfo _character000000D2 =
    {
        0x000000D2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D2,
        0x000000F2,
        0x000000D2
    };

    static Char _decompositionMapping000000D3[] = 
    {
        0x0000004F,
        0x00000301
    };

    static _CharacterInfo _character000000D3 =
    {
        0x000000D3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D3,
        0x000000F3,
        0x000000D3
    };

    static Char _decompositionMapping000000D4[] = 
    {
        0x0000004F,
        0x00000302
    };

    static _CharacterInfo _character000000D4 =
    {
        0x000000D4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D4,
        0x000000F4,
        0x000000D4
    };

    static Char _decompositionMapping000000D5[] = 
    {
        0x0000004F,
        0x00000303
    };

    static _CharacterInfo _character000000D5 =
    {
        0x000000D5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D5,
        0x000000F5,
        0x000000D5
    };

    static Char _decompositionMapping000000D6[] = 
    {
        0x0000004F,
        0x00000308
    };

    static _CharacterInfo _character000000D6 =
    {
        0x000000D6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D6,
        0x000000F6,
        0x000000D6
    };

    static _CharacterInfo _character000000D7 =
    {
        0x000000D7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D7,
        0x000000D7,
        0x000000D7
    };

    static _CharacterInfo _character000000D8 =
    {
        0x000000D8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D8,
        0x000000F8,
        0x000000D8
    };

    static Char _decompositionMapping000000D9[] = 
    {
        0x00000055,
        0x00000300
    };

    static _CharacterInfo _character000000D9 =
    {
        0x000000D9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D9,
        0x000000F9,
        0x000000D9
    };

    static Char _decompositionMapping000000DA[] = 
    {
        0x00000055,
        0x00000301
    };

    static _CharacterInfo _character000000DA =
    {
        0x000000DA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DA,
        0x000000FA,
        0x000000DA
    };

    static Char _decompositionMapping000000DB[] = 
    {
        0x00000055,
        0x00000302
    };

    static _CharacterInfo _character000000DB =
    {
        0x000000DB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DB,
        0x000000FB,
        0x000000DB
    };

    static Char _decompositionMapping000000DC[] = 
    {
        0x00000055,
        0x00000308
    };

    static _CharacterInfo _character000000DC =
    {
        0x000000DC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DC,
        0x000000FC,
        0x000000DC
    };

    static Char _decompositionMapping000000DD[] = 
    {
        0x00000059,
        0x00000301
    };

    static _CharacterInfo _character000000DD =
    {
        0x000000DD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DD,
        0x000000FD,
        0x000000DD
    };

    static _CharacterInfo _character000000DE =
    {
        0x000000DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DE,
        0x000000FE,
        0x000000DE
    };

    static _CharacterInfo _character000000DF =
    {
        0x000000DF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DF,
        0x000000DF,
        0x000000DF
    };

    static Char _decompositionMapping000000E0[] = 
    {
        0x00000061,
        0x00000300
    };

    static _CharacterInfo _character000000E0 =
    {
        0x000000E0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C0,
        0x000000E0,
        0x000000C0
    };

    static Char _decompositionMapping000000E1[] = 
    {
        0x00000061,
        0x00000301
    };

    static _CharacterInfo _character000000E1 =
    {
        0x000000E1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C1,
        0x000000E1,
        0x000000C1
    };

    static Char _decompositionMapping000000E2[] = 
    {
        0x00000061,
        0x00000302
    };

    static _CharacterInfo _character000000E2 =
    {
        0x000000E2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C2,
        0x000000E2,
        0x000000C2
    };

    static Char _decompositionMapping000000E3[] = 
    {
        0x00000061,
        0x00000303
    };

    static _CharacterInfo _character000000E3 =
    {
        0x000000E3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C3,
        0x000000E3,
        0x000000C3
    };

    static Char _decompositionMapping000000E4[] = 
    {
        0x00000061,
        0x00000308
    };

    static _CharacterInfo _character000000E4 =
    {
        0x000000E4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C4,
        0x000000E4,
        0x000000C4
    };

    static Char _decompositionMapping000000E5[] = 
    {
        0x00000061,
        0x0000030A
    };

    static _CharacterInfo _character000000E5 =
    {
        0x000000E5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C5,
        0x000000E5,
        0x000000C5
    };

    static _CharacterInfo _character000000E6 =
    {
        0x000000E6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C6,
        0x000000E6,
        0x000000C6
    };

    static Char _decompositionMapping000000E7[] = 
    {
        0x00000063,
        0x00000327
    };

    static _CharacterInfo _character000000E7 =
    {
        0x000000E7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C7,
        0x000000E7,
        0x000000C7
    };

    static Char _decompositionMapping000000E8[] = 
    {
        0x00000065,
        0x00000300
    };

    static _CharacterInfo _character000000E8 =
    {
        0x000000E8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C8,
        0x000000E8,
        0x000000C8
    };

    static Char _decompositionMapping000000E9[] = 
    {
        0x00000065,
        0x00000301
    };

    static _CharacterInfo _character000000E9 =
    {
        0x000000E9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000C9,
        0x000000E9,
        0x000000C9
    };

    static Char _decompositionMapping000000EA[] = 
    {
        0x00000065,
        0x00000302
    };

    static _CharacterInfo _character000000EA =
    {
        0x000000EA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CA,
        0x000000EA,
        0x000000CA
    };

    static Char _decompositionMapping000000EB[] = 
    {
        0x00000065,
        0x00000308
    };

    static _CharacterInfo _character000000EB =
    {
        0x000000EB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CB,
        0x000000EB,
        0x000000CB
    };

    static Char _decompositionMapping000000EC[] = 
    {
        0x00000069,
        0x00000300
    };

    static _CharacterInfo _character000000EC =
    {
        0x000000EC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CC,
        0x000000EC,
        0x000000CC
    };

    static Char _decompositionMapping000000ED[] = 
    {
        0x00000069,
        0x00000301
    };

    static _CharacterInfo _character000000ED =
    {
        0x000000ED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CD,
        0x000000ED,
        0x000000CD
    };

    static Char _decompositionMapping000000EE[] = 
    {
        0x00000069,
        0x00000302
    };

    static _CharacterInfo _character000000EE =
    {
        0x000000EE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CE,
        0x000000EE,
        0x000000CE
    };

    static Char _decompositionMapping000000EF[] = 
    {
        0x00000069,
        0x00000308
    };

    static _CharacterInfo _character000000EF =
    {
        0x000000EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000CF,
        0x000000EF,
        0x000000CF
    };

    static _CharacterInfo _character000000F0 =
    {
        0x000000F0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D0,
        0x000000F0,
        0x000000D0
    };

    static Char _decompositionMapping000000F1[] = 
    {
        0x0000006E,
        0x00000303
    };

    static _CharacterInfo _character000000F1 =
    {
        0x000000F1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D1,
        0x000000F1,
        0x000000D1
    };

    static Char _decompositionMapping000000F2[] = 
    {
        0x0000006F,
        0x00000300
    };

    static _CharacterInfo _character000000F2 =
    {
        0x000000F2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D2,
        0x000000F2,
        0x000000D2
    };

    static Char _decompositionMapping000000F3[] = 
    {
        0x0000006F,
        0x00000301
    };

    static _CharacterInfo _character000000F3 =
    {
        0x000000F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D3,
        0x000000F3,
        0x000000D3
    };

    static Char _decompositionMapping000000F4[] = 
    {
        0x0000006F,
        0x00000302
    };

    static _CharacterInfo _character000000F4 =
    {
        0x000000F4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D4,
        0x000000F4,
        0x000000D4
    };

    static Char _decompositionMapping000000F5[] = 
    {
        0x0000006F,
        0x00000303
    };

    static _CharacterInfo _character000000F5 =
    {
        0x000000F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D5,
        0x000000F5,
        0x000000D5
    };

    static Char _decompositionMapping000000F6[] = 
    {
        0x0000006F,
        0x00000308
    };

    static _CharacterInfo _character000000F6 =
    {
        0x000000F6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D6,
        0x000000F6,
        0x000000D6
    };

    static _CharacterInfo _character000000F7 =
    {
        0x000000F7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000F7,
        0x000000F7,
        0x000000F7
    };

    static _CharacterInfo _character000000F8 =
    {
        0x000000F8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D8,
        0x000000F8,
        0x000000D8
    };

    static Char _decompositionMapping000000F9[] = 
    {
        0x00000075,
        0x00000300
    };

    static _CharacterInfo _character000000F9 =
    {
        0x000000F9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000D9,
        0x000000F9,
        0x000000D9
    };

    static Char _decompositionMapping000000FA[] = 
    {
        0x00000075,
        0x00000301
    };

    static _CharacterInfo _character000000FA =
    {
        0x000000FA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DA,
        0x000000FA,
        0x000000DA
    };

    static Char _decompositionMapping000000FB[] = 
    {
        0x00000075,
        0x00000302
    };

    static _CharacterInfo _character000000FB =
    {
        0x000000FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DB,
        0x000000FB,
        0x000000DB
    };

    static Char _decompositionMapping000000FC[] = 
    {
        0x00000075,
        0x00000308
    };

    static _CharacterInfo _character000000FC =
    {
        0x000000FC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DC,
        0x000000FC,
        0x000000DC
    };

    static Char _decompositionMapping000000FD[] = 
    {
        0x00000079,
        0x00000301
    };

    static _CharacterInfo _character000000FD =
    {
        0x000000FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DD,
        0x000000FD,
        0x000000DD
    };

    static _CharacterInfo _character000000FE =
    {
        0x000000FE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000000DE,
        0x000000FE,
        0x000000DE
    };

    static Char _decompositionMapping000000FF[] = 
    {
        0x00000079,
        0x00000308
    };

    static _CharacterInfo _character000000FF =
    {
        0x000000FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000000FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000178,
        0x000000FF,
        0x00000178
    };

    static Char _decompositionMapping00000100[] = 
    {
        0x00000041,
        0x00000304
    };

    static _CharacterInfo _character00000100 =
    {
        0x00000100,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000100,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000100,
        0x00000101,
        0x00000100
    };

    static Char _decompositionMapping00000101[] = 
    {
        0x00000061,
        0x00000304
    };

    static _CharacterInfo _character00000101 =
    {
        0x00000101,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000101,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000100,
        0x00000101,
        0x00000100
    };

    static Char _decompositionMapping00000102[] = 
    {
        0x00000041,
        0x00000306
    };

    static _CharacterInfo _character00000102 =
    {
        0x00000102,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000102,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000102,
        0x00000103,
        0x00000102
    };

    static Char _decompositionMapping00000103[] = 
    {
        0x00000061,
        0x00000306
    };

    static _CharacterInfo _character00000103 =
    {
        0x00000103,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000103,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000102,
        0x00000103,
        0x00000102
    };

    static Char _decompositionMapping00000104[] = 
    {
        0x00000041,
        0x00000328
    };

    static _CharacterInfo _character00000104 =
    {
        0x00000104,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000104,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000104,
        0x00000105,
        0x00000104
    };

    static Char _decompositionMapping00000105[] = 
    {
        0x00000061,
        0x00000328
    };

    static _CharacterInfo _character00000105 =
    {
        0x00000105,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000105,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000104,
        0x00000105,
        0x00000104
    };

    static Char _decompositionMapping00000106[] = 
    {
        0x00000043,
        0x00000301
    };

    static _CharacterInfo _character00000106 =
    {
        0x00000106,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000106,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000106,
        0x00000107,
        0x00000106
    };

    static Char _decompositionMapping00000107[] = 
    {
        0x00000063,
        0x00000301
    };

    static _CharacterInfo _character00000107 =
    {
        0x00000107,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000107,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000106,
        0x00000107,
        0x00000106
    };

    static Char _decompositionMapping00000108[] = 
    {
        0x00000043,
        0x00000302
    };

    static _CharacterInfo _character00000108 =
    {
        0x00000108,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000108,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000108,
        0x00000109,
        0x00000108
    };

    static Char _decompositionMapping00000109[] = 
    {
        0x00000063,
        0x00000302
    };

    static _CharacterInfo _character00000109 =
    {
        0x00000109,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000109,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000108,
        0x00000109,
        0x00000108
    };

    static Char _decompositionMapping0000010A[] = 
    {
        0x00000043,
        0x00000307
    };

    static _CharacterInfo _character0000010A =
    {
        0x0000010A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010A,
        0x0000010B,
        0x0000010A
    };

    static Char _decompositionMapping0000010B[] = 
    {
        0x00000063,
        0x00000307
    };

    static _CharacterInfo _character0000010B =
    {
        0x0000010B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010A,
        0x0000010B,
        0x0000010A
    };

    static Char _decompositionMapping0000010C[] = 
    {
        0x00000043,
        0x0000030C
    };

    static _CharacterInfo _character0000010C =
    {
        0x0000010C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010C,
        0x0000010D,
        0x0000010C
    };

    static Char _decompositionMapping0000010D[] = 
    {
        0x00000063,
        0x0000030C
    };

    static _CharacterInfo _character0000010D =
    {
        0x0000010D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010C,
        0x0000010D,
        0x0000010C
    };

    static Char _decompositionMapping0000010E[] = 
    {
        0x00000044,
        0x0000030C
    };

    static _CharacterInfo _character0000010E =
    {
        0x0000010E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010E,
        0x0000010F,
        0x0000010E
    };

    static Char _decompositionMapping0000010F[] = 
    {
        0x00000064,
        0x0000030C
    };

    static _CharacterInfo _character0000010F =
    {
        0x0000010F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000010F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000010E,
        0x0000010F,
        0x0000010E
    };

    static _CharacterInfo _character00000110 =
    {
        0x00000110,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000110,
        0x00000111,
        0x00000110
    };

    static _CharacterInfo _character00000111 =
    {
        0x00000111,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000110,
        0x00000111,
        0x00000110
    };

    static Char _decompositionMapping00000112[] = 
    {
        0x00000045,
        0x00000304
    };

    static _CharacterInfo _character00000112 =
    {
        0x00000112,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000112,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000112,
        0x00000113,
        0x00000112
    };

    static Char _decompositionMapping00000113[] = 
    {
        0x00000065,
        0x00000304
    };

    static _CharacterInfo _character00000113 =
    {
        0x00000113,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000113,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000112,
        0x00000113,
        0x00000112
    };

    static Char _decompositionMapping00000114[] = 
    {
        0x00000045,
        0x00000306
    };

    static _CharacterInfo _character00000114 =
    {
        0x00000114,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000114,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000114,
        0x00000115,
        0x00000114
    };

    static Char _decompositionMapping00000115[] = 
    {
        0x00000065,
        0x00000306
    };

    static _CharacterInfo _character00000115 =
    {
        0x00000115,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000115,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000114,
        0x00000115,
        0x00000114
    };

    static Char _decompositionMapping00000116[] = 
    {
        0x00000045,
        0x00000307
    };

    static _CharacterInfo _character00000116 =
    {
        0x00000116,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000116,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000116,
        0x00000117,
        0x00000116
    };

    static Char _decompositionMapping00000117[] = 
    {
        0x00000065,
        0x00000307
    };

    static _CharacterInfo _character00000117 =
    {
        0x00000117,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000117,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000116,
        0x00000117,
        0x00000116
    };

    static Char _decompositionMapping00000118[] = 
    {
        0x00000045,
        0x00000328
    };

    static _CharacterInfo _character00000118 =
    {
        0x00000118,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000118,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000118,
        0x00000119,
        0x00000118
    };

    static Char _decompositionMapping00000119[] = 
    {
        0x00000065,
        0x00000328
    };

    static _CharacterInfo _character00000119 =
    {
        0x00000119,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000119,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000118,
        0x00000119,
        0x00000118
    };

    static Char _decompositionMapping0000011A[] = 
    {
        0x00000045,
        0x0000030C
    };

    static _CharacterInfo _character0000011A =
    {
        0x0000011A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011A,
        0x0000011B,
        0x0000011A
    };

    static Char _decompositionMapping0000011B[] = 
    {
        0x00000065,
        0x0000030C
    };

    static _CharacterInfo _character0000011B =
    {
        0x0000011B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011A,
        0x0000011B,
        0x0000011A
    };

    static Char _decompositionMapping0000011C[] = 
    {
        0x00000047,
        0x00000302
    };

    static _CharacterInfo _character0000011C =
    {
        0x0000011C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011C,
        0x0000011D,
        0x0000011C
    };

    static Char _decompositionMapping0000011D[] = 
    {
        0x00000067,
        0x00000302
    };

    static _CharacterInfo _character0000011D =
    {
        0x0000011D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011C,
        0x0000011D,
        0x0000011C
    };

    static Char _decompositionMapping0000011E[] = 
    {
        0x00000047,
        0x00000306
    };

    static _CharacterInfo _character0000011E =
    {
        0x0000011E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011E,
        0x0000011F,
        0x0000011E
    };

    static Char _decompositionMapping0000011F[] = 
    {
        0x00000067,
        0x00000306
    };

    static _CharacterInfo _character0000011F =
    {
        0x0000011F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000011F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000011E,
        0x0000011F,
        0x0000011E
    };

    static Char _decompositionMapping00000120[] = 
    {
        0x00000047,
        0x00000307
    };

    static _CharacterInfo _character00000120 =
    {
        0x00000120,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000120,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000120,
        0x00000121,
        0x00000120
    };

    static Char _decompositionMapping00000121[] = 
    {
        0x00000067,
        0x00000307
    };

    static _CharacterInfo _character00000121 =
    {
        0x00000121,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000121,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000120,
        0x00000121,
        0x00000120
    };

    static Char _decompositionMapping00000122[] = 
    {
        0x00000047,
        0x00000327
    };

    static _CharacterInfo _character00000122 =
    {
        0x00000122,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000122,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000122,
        0x00000123,
        0x00000122
    };

    static Char _decompositionMapping00000123[] = 
    {
        0x00000067,
        0x00000327
    };

    static _CharacterInfo _character00000123 =
    {
        0x00000123,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000123,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000122,
        0x00000123,
        0x00000122
    };

    static Char _decompositionMapping00000124[] = 
    {
        0x00000048,
        0x00000302
    };

    static _CharacterInfo _character00000124 =
    {
        0x00000124,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000124,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000124,
        0x00000125,
        0x00000124
    };

    static Char _decompositionMapping00000125[] = 
    {
        0x00000068,
        0x00000302
    };

    static _CharacterInfo _character00000125 =
    {
        0x00000125,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000125,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000124,
        0x00000125,
        0x00000124
    };

    static _CharacterInfo _character00000126 =
    {
        0x00000126,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000126,
        0x00000127,
        0x00000126
    };

    static _CharacterInfo _character00000127 =
    {
        0x00000127,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000126,
        0x00000127,
        0x00000126
    };

    static Char _decompositionMapping00000128[] = 
    {
        0x00000049,
        0x00000303
    };

    static _CharacterInfo _character00000128 =
    {
        0x00000128,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000128,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000128,
        0x00000129,
        0x00000128
    };

    static Char _decompositionMapping00000129[] = 
    {
        0x00000069,
        0x00000303
    };

    static _CharacterInfo _character00000129 =
    {
        0x00000129,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000129,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000128,
        0x00000129,
        0x00000128
    };

    static Char _decompositionMapping0000012A[] = 
    {
        0x00000049,
        0x00000304
    };

    static _CharacterInfo _character0000012A =
    {
        0x0000012A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012A,
        0x0000012B,
        0x0000012A
    };

    static Char _decompositionMapping0000012B[] = 
    {
        0x00000069,
        0x00000304
    };

    static _CharacterInfo _character0000012B =
    {
        0x0000012B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012A,
        0x0000012B,
        0x0000012A
    };

    static Char _decompositionMapping0000012C[] = 
    {
        0x00000049,
        0x00000306
    };

    static _CharacterInfo _character0000012C =
    {
        0x0000012C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012C,
        0x0000012D,
        0x0000012C
    };

    static Char _decompositionMapping0000012D[] = 
    {
        0x00000069,
        0x00000306
    };

    static _CharacterInfo _character0000012D =
    {
        0x0000012D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012C,
        0x0000012D,
        0x0000012C
    };

    static Char _decompositionMapping0000012E[] = 
    {
        0x00000049,
        0x00000328
    };

    static _CharacterInfo _character0000012E =
    {
        0x0000012E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012E,
        0x0000012F,
        0x0000012E
    };

    static Char _decompositionMapping0000012F[] = 
    {
        0x00000069,
        0x00000328
    };

    static _CharacterInfo _character0000012F =
    {
        0x0000012F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000012F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000012E,
        0x0000012F,
        0x0000012E
    };

    static Char _decompositionMapping00000130[] = 
    {
        0x00000049,
        0x00000307
    };

    static _CharacterInfo _character00000130 =
    {
        0x00000130,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000130,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000130,
        0x00000069,
        0x00000130
    };

    static _CharacterInfo _character00000131 =
    {
        0x00000131,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000049,
        0x00000131,
        0x00000049
    };

    static Char _decompositionMapping00000132[] = 
    {
        0x00000049,
        0x0000004A
    };

    static _CharacterInfo _character00000132 =
    {
        0x00000132,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000132,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000132,
        0x00000133,
        0x00000132
    };

    static Char _decompositionMapping00000133[] = 
    {
        0x00000069,
        0x0000006A
    };

    static _CharacterInfo _character00000133 =
    {
        0x00000133,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000133,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000132,
        0x00000133,
        0x00000132
    };

    static Char _decompositionMapping00000134[] = 
    {
        0x0000004A,
        0x00000302
    };

    static _CharacterInfo _character00000134 =
    {
        0x00000134,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000134,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000134,
        0x00000135,
        0x00000134
    };

    static Char _decompositionMapping00000135[] = 
    {
        0x0000006A,
        0x00000302
    };

    static _CharacterInfo _character00000135 =
    {
        0x00000135,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000135,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000134,
        0x00000135,
        0x00000134
    };

    static Char _decompositionMapping00000136[] = 
    {
        0x0000004B,
        0x00000327
    };

    static _CharacterInfo _character00000136 =
    {
        0x00000136,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000136,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000136,
        0x00000137,
        0x00000136
    };

    static Char _decompositionMapping00000137[] = 
    {
        0x0000006B,
        0x00000327
    };

    static _CharacterInfo _character00000137 =
    {
        0x00000137,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000137,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000136,
        0x00000137,
        0x00000136
    };

    static _CharacterInfo _character00000138 =
    {
        0x00000138,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000138,
        0x00000138,
        0x00000138
    };

    static Char _decompositionMapping00000139[] = 
    {
        0x0000004C,
        0x00000301
    };

    static _CharacterInfo _character00000139 =
    {
        0x00000139,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000139,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000139,
        0x0000013A,
        0x00000139
    };

    static Char _decompositionMapping0000013A[] = 
    {
        0x0000006C,
        0x00000301
    };

    static _CharacterInfo _character0000013A =
    {
        0x0000013A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000013A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000139,
        0x0000013A,
        0x00000139
    };

    static Char _decompositionMapping0000013B[] = 
    {
        0x0000004C,
        0x00000327
    };

    static _CharacterInfo _character0000013B =
    {
        0x0000013B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000013B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013B,
        0x0000013C,
        0x0000013B
    };

    static Char _decompositionMapping0000013C[] = 
    {
        0x0000006C,
        0x00000327
    };

    static _CharacterInfo _character0000013C =
    {
        0x0000013C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000013C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013B,
        0x0000013C,
        0x0000013B
    };

    static Char _decompositionMapping0000013D[] = 
    {
        0x0000004C,
        0x0000030C
    };

    static _CharacterInfo _character0000013D =
    {
        0x0000013D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000013D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013D,
        0x0000013E,
        0x0000013D
    };

    static Char _decompositionMapping0000013E[] = 
    {
        0x0000006C,
        0x0000030C
    };

    static _CharacterInfo _character0000013E =
    {
        0x0000013E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000013E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013D,
        0x0000013E,
        0x0000013D
    };

    static Char _decompositionMapping0000013F[] = 
    {
        0x0000004C,
        0x000000B7
    };

    static _CharacterInfo _character0000013F =
    {
        0x0000013F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000013F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013F,
        0x00000140,
        0x0000013F
    };

    static Char _decompositionMapping00000140[] = 
    {
        0x0000006C,
        0x000000B7
    };

    static _CharacterInfo _character00000140 =
    {
        0x00000140,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000140,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000013F,
        0x00000140,
        0x0000013F
    };

    static _CharacterInfo _character00000141 =
    {
        0x00000141,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000141,
        0x00000142,
        0x00000141
    };

    static _CharacterInfo _character00000142 =
    {
        0x00000142,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000141,
        0x00000142,
        0x00000141
    };

    static Char _decompositionMapping00000143[] = 
    {
        0x0000004E,
        0x00000301
    };

    static _CharacterInfo _character00000143 =
    {
        0x00000143,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000143,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000143,
        0x00000144,
        0x00000143
    };

    static Char _decompositionMapping00000144[] = 
    {
        0x0000006E,
        0x00000301
    };

    static _CharacterInfo _character00000144 =
    {
        0x00000144,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000144,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000143,
        0x00000144,
        0x00000143
    };

    static Char _decompositionMapping00000145[] = 
    {
        0x0000004E,
        0x00000327
    };

    static _CharacterInfo _character00000145 =
    {
        0x00000145,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000145,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000145,
        0x00000146,
        0x00000145
    };

    static Char _decompositionMapping00000146[] = 
    {
        0x0000006E,
        0x00000327
    };

    static _CharacterInfo _character00000146 =
    {
        0x00000146,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000146,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000145,
        0x00000146,
        0x00000145
    };

    static Char _decompositionMapping00000147[] = 
    {
        0x0000004E,
        0x0000030C
    };

    static _CharacterInfo _character00000147 =
    {
        0x00000147,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000147,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000147,
        0x00000148,
        0x00000147
    };

    static Char _decompositionMapping00000148[] = 
    {
        0x0000006E,
        0x0000030C
    };

    static _CharacterInfo _character00000148 =
    {
        0x00000148,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000148,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000147,
        0x00000148,
        0x00000147
    };

    static Char _decompositionMapping00000149[] = 
    {
        0x000002BC,
        0x0000006E
    };

    static _CharacterInfo _character00000149 =
    {
        0x00000149,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000149,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000149,
        0x00000149,
        0x00000149
    };

    static _CharacterInfo _character0000014A =
    {
        0x0000014A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014A,
        0x0000014B,
        0x0000014A
    };

    static _CharacterInfo _character0000014B =
    {
        0x0000014B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014A,
        0x0000014B,
        0x0000014A
    };

    static Char _decompositionMapping0000014C[] = 
    {
        0x0000004F,
        0x00000304
    };

    static _CharacterInfo _character0000014C =
    {
        0x0000014C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000014C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014C,
        0x0000014D,
        0x0000014C
    };

    static Char _decompositionMapping0000014D[] = 
    {
        0x0000006F,
        0x00000304
    };

    static _CharacterInfo _character0000014D =
    {
        0x0000014D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000014D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014C,
        0x0000014D,
        0x0000014C
    };

    static Char _decompositionMapping0000014E[] = 
    {
        0x0000004F,
        0x00000306
    };

    static _CharacterInfo _character0000014E =
    {
        0x0000014E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000014E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014E,
        0x0000014F,
        0x0000014E
    };

    static Char _decompositionMapping0000014F[] = 
    {
        0x0000006F,
        0x00000306
    };

    static _CharacterInfo _character0000014F =
    {
        0x0000014F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000014F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000014E,
        0x0000014F,
        0x0000014E
    };

    static Char _decompositionMapping00000150[] = 
    {
        0x0000004F,
        0x0000030B
    };

    static _CharacterInfo _character00000150 =
    {
        0x00000150,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000150,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000150,
        0x00000151,
        0x00000150
    };

    static Char _decompositionMapping00000151[] = 
    {
        0x0000006F,
        0x0000030B
    };

    static _CharacterInfo _character00000151 =
    {
        0x00000151,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000151,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000150,
        0x00000151,
        0x00000150
    };

    static _CharacterInfo _character00000152 =
    {
        0x00000152,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000152,
        0x00000153,
        0x00000152
    };

    static _CharacterInfo _character00000153 =
    {
        0x00000153,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000152,
        0x00000153,
        0x00000152
    };

    static Char _decompositionMapping00000154[] = 
    {
        0x00000052,
        0x00000301
    };

    static _CharacterInfo _character00000154 =
    {
        0x00000154,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000154,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000154,
        0x00000155,
        0x00000154
    };

    static Char _decompositionMapping00000155[] = 
    {
        0x00000072,
        0x00000301
    };

    static _CharacterInfo _character00000155 =
    {
        0x00000155,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000155,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000154,
        0x00000155,
        0x00000154
    };

    static Char _decompositionMapping00000156[] = 
    {
        0x00000052,
        0x00000327
    };

    static _CharacterInfo _character00000156 =
    {
        0x00000156,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000156,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000156,
        0x00000157,
        0x00000156
    };

    static Char _decompositionMapping00000157[] = 
    {
        0x00000072,
        0x00000327
    };

    static _CharacterInfo _character00000157 =
    {
        0x00000157,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000157,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000156,
        0x00000157,
        0x00000156
    };

    static Char _decompositionMapping00000158[] = 
    {
        0x00000052,
        0x0000030C
    };

    static _CharacterInfo _character00000158 =
    {
        0x00000158,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000158,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000158,
        0x00000159,
        0x00000158
    };

    static Char _decompositionMapping00000159[] = 
    {
        0x00000072,
        0x0000030C
    };

    static _CharacterInfo _character00000159 =
    {
        0x00000159,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000159,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000158,
        0x00000159,
        0x00000158
    };

    static Char _decompositionMapping0000015A[] = 
    {
        0x00000053,
        0x00000301
    };

    static _CharacterInfo _character0000015A =
    {
        0x0000015A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015A,
        0x0000015B,
        0x0000015A
    };

    static Char _decompositionMapping0000015B[] = 
    {
        0x00000073,
        0x00000301
    };

    static _CharacterInfo _character0000015B =
    {
        0x0000015B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015A,
        0x0000015B,
        0x0000015A
    };

    static Char _decompositionMapping0000015C[] = 
    {
        0x00000053,
        0x00000302
    };

    static _CharacterInfo _character0000015C =
    {
        0x0000015C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015C,
        0x0000015D,
        0x0000015C
    };

    static Char _decompositionMapping0000015D[] = 
    {
        0x00000073,
        0x00000302
    };

    static _CharacterInfo _character0000015D =
    {
        0x0000015D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015C,
        0x0000015D,
        0x0000015C
    };

    static Char _decompositionMapping0000015E[] = 
    {
        0x00000053,
        0x00000327
    };

    static _CharacterInfo _character0000015E =
    {
        0x0000015E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015E,
        0x0000015F,
        0x0000015E
    };

    static Char _decompositionMapping0000015F[] = 
    {
        0x00000073,
        0x00000327
    };

    static _CharacterInfo _character0000015F =
    {
        0x0000015F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000015F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000015E,
        0x0000015F,
        0x0000015E
    };

    static Char _decompositionMapping00000160[] = 
    {
        0x00000053,
        0x0000030C
    };

    static _CharacterInfo _character00000160 =
    {
        0x00000160,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000160,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000160,
        0x00000161,
        0x00000160
    };

    static Char _decompositionMapping00000161[] = 
    {
        0x00000073,
        0x0000030C
    };

    static _CharacterInfo _character00000161 =
    {
        0x00000161,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000161,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000160,
        0x00000161,
        0x00000160
    };

    static Char _decompositionMapping00000162[] = 
    {
        0x00000054,
        0x00000327
    };

    static _CharacterInfo _character00000162 =
    {
        0x00000162,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000162,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000162,
        0x00000163,
        0x00000162
    };

    static Char _decompositionMapping00000163[] = 
    {
        0x00000074,
        0x00000327
    };

    static _CharacterInfo _character00000163 =
    {
        0x00000163,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000163,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000162,
        0x00000163,
        0x00000162
    };

    static Char _decompositionMapping00000164[] = 
    {
        0x00000054,
        0x0000030C
    };

    static _CharacterInfo _character00000164 =
    {
        0x00000164,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000164,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000164,
        0x00000165,
        0x00000164
    };

    static Char _decompositionMapping00000165[] = 
    {
        0x00000074,
        0x0000030C
    };

    static _CharacterInfo _character00000165 =
    {
        0x00000165,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000165,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000164,
        0x00000165,
        0x00000164
    };

    static _CharacterInfo _character00000166 =
    {
        0x00000166,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000166,
        0x00000167,
        0x00000166
    };

    static _CharacterInfo _character00000167 =
    {
        0x00000167,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000166,
        0x00000167,
        0x00000166
    };

    static Char _decompositionMapping00000168[] = 
    {
        0x00000055,
        0x00000303
    };

    static _CharacterInfo _character00000168 =
    {
        0x00000168,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000168,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000168,
        0x00000169,
        0x00000168
    };

    static Char _decompositionMapping00000169[] = 
    {
        0x00000075,
        0x00000303
    };

    static _CharacterInfo _character00000169 =
    {
        0x00000169,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000169,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000168,
        0x00000169,
        0x00000168
    };

    static Char _decompositionMapping0000016A[] = 
    {
        0x00000055,
        0x00000304
    };

    static _CharacterInfo _character0000016A =
    {
        0x0000016A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016A,
        0x0000016B,
        0x0000016A
    };

    static Char _decompositionMapping0000016B[] = 
    {
        0x00000075,
        0x00000304
    };

    static _CharacterInfo _character0000016B =
    {
        0x0000016B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016A,
        0x0000016B,
        0x0000016A
    };

    static Char _decompositionMapping0000016C[] = 
    {
        0x00000055,
        0x00000306
    };

    static _CharacterInfo _character0000016C =
    {
        0x0000016C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016C,
        0x0000016D,
        0x0000016C
    };

    static Char _decompositionMapping0000016D[] = 
    {
        0x00000075,
        0x00000306
    };

    static _CharacterInfo _character0000016D =
    {
        0x0000016D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016C,
        0x0000016D,
        0x0000016C
    };

    static Char _decompositionMapping0000016E[] = 
    {
        0x00000055,
        0x0000030A
    };

    static _CharacterInfo _character0000016E =
    {
        0x0000016E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016E,
        0x0000016F,
        0x0000016E
    };

    static Char _decompositionMapping0000016F[] = 
    {
        0x00000075,
        0x0000030A
    };

    static _CharacterInfo _character0000016F =
    {
        0x0000016F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000016F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000016E,
        0x0000016F,
        0x0000016E
    };

    static Char _decompositionMapping00000170[] = 
    {
        0x00000055,
        0x0000030B
    };

    static _CharacterInfo _character00000170 =
    {
        0x00000170,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000170,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000170,
        0x00000171,
        0x00000170
    };

    static Char _decompositionMapping00000171[] = 
    {
        0x00000075,
        0x0000030B
    };

    static _CharacterInfo _character00000171 =
    {
        0x00000171,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000171,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000170,
        0x00000171,
        0x00000170
    };

    static Char _decompositionMapping00000172[] = 
    {
        0x00000055,
        0x00000328
    };

    static _CharacterInfo _character00000172 =
    {
        0x00000172,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000172,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000172,
        0x00000173,
        0x00000172
    };

    static Char _decompositionMapping00000173[] = 
    {
        0x00000075,
        0x00000328
    };

    static _CharacterInfo _character00000173 =
    {
        0x00000173,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000173,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000172,
        0x00000173,
        0x00000172
    };

    static Char _decompositionMapping00000174[] = 
    {
        0x00000057,
        0x00000302
    };

    static _CharacterInfo _character00000174 =
    {
        0x00000174,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000174,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000174,
        0x00000175,
        0x00000174
    };

    static Char _decompositionMapping00000175[] = 
    {
        0x00000077,
        0x00000302
    };

    static _CharacterInfo _character00000175 =
    {
        0x00000175,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000175,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000174,
        0x00000175,
        0x00000174
    };

    static Char _decompositionMapping00000176[] = 
    {
        0x00000059,
        0x00000302
    };

    static _CharacterInfo _character00000176 =
    {
        0x00000176,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000176,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000176,
        0x00000177,
        0x00000176
    };

    static Char _decompositionMapping00000177[] = 
    {
        0x00000079,
        0x00000302
    };

    static _CharacterInfo _character00000177 =
    {
        0x00000177,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000177,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000176,
        0x00000177,
        0x00000176
    };

    static Char _decompositionMapping00000178[] = 
    {
        0x00000059,
        0x00000308
    };

    static _CharacterInfo _character00000178 =
    {
        0x00000178,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000178,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000178,
        0x000000FF,
        0x00000178
    };

    static Char _decompositionMapping00000179[] = 
    {
        0x0000005A,
        0x00000301
    };

    static _CharacterInfo _character00000179 =
    {
        0x00000179,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000179,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000179,
        0x0000017A,
        0x00000179
    };

    static Char _decompositionMapping0000017A[] = 
    {
        0x0000007A,
        0x00000301
    };

    static _CharacterInfo _character0000017A =
    {
        0x0000017A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000017A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000179,
        0x0000017A,
        0x00000179
    };

    static Char _decompositionMapping0000017B[] = 
    {
        0x0000005A,
        0x00000307
    };

    static _CharacterInfo _character0000017B =
    {
        0x0000017B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000017B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000017B,
        0x0000017C,
        0x0000017B
    };

    static Char _decompositionMapping0000017C[] = 
    {
        0x0000007A,
        0x00000307
    };

    static _CharacterInfo _character0000017C =
    {
        0x0000017C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000017C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000017B,
        0x0000017C,
        0x0000017B
    };

    static Char _decompositionMapping0000017D[] = 
    {
        0x0000005A,
        0x0000030C
    };

    static _CharacterInfo _character0000017D =
    {
        0x0000017D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000017D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000017D,
        0x0000017E,
        0x0000017D
    };

    static Char _decompositionMapping0000017E[] = 
    {
        0x0000007A,
        0x0000030C
    };

    static _CharacterInfo _character0000017E =
    {
        0x0000017E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000017E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000017D,
        0x0000017E,
        0x0000017D
    };

    static Char _decompositionMapping0000017F[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0000017F =
    {
        0x0000017F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000017F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000053,
        0x0000017F,
        0x00000053
    };

    static _CharacterInfo _character00000180 =
    {
        0x00000180,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000243,
        0x00000180,
        0x00000243
    };

    static _CharacterInfo _character00000181 =
    {
        0x00000181,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000181,
        0x00000253,
        0x00000181
    };

    static _CharacterInfo _character00000182 =
    {
        0x00000182,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000182,
        0x00000183,
        0x00000182
    };

    static _CharacterInfo _character00000183 =
    {
        0x00000183,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000182,
        0x00000183,
        0x00000182
    };

    static _CharacterInfo _character00000184 =
    {
        0x00000184,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000184,
        0x00000185,
        0x00000184
    };

    static _CharacterInfo _character00000185 =
    {
        0x00000185,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000184,
        0x00000185,
        0x00000184
    };

    static _CharacterInfo _character00000186 =
    {
        0x00000186,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000186,
        0x00000254,
        0x00000186
    };

    static _CharacterInfo _character00000187 =
    {
        0x00000187,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000187,
        0x00000188,
        0x00000187
    };

    static _CharacterInfo _character00000188 =
    {
        0x00000188,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000187,
        0x00000188,
        0x00000187
    };

    static _CharacterInfo _character00000189 =
    {
        0x00000189,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000189,
        0x00000256,
        0x00000189
    };

    static _CharacterInfo _character0000018A =
    {
        0x0000018A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018A,
        0x00000257,
        0x0000018A
    };

    static _CharacterInfo _character0000018B =
    {
        0x0000018B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018B,
        0x0000018C,
        0x0000018B
    };

    static _CharacterInfo _character0000018C =
    {
        0x0000018C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018B,
        0x0000018C,
        0x0000018B
    };

    static _CharacterInfo _character0000018D =
    {
        0x0000018D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018D,
        0x0000018D,
        0x0000018D
    };

    static _CharacterInfo _character0000018E =
    {
        0x0000018E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018E,
        0x000001DD,
        0x0000018E
    };

    static _CharacterInfo _character0000018F =
    {
        0x0000018F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018F,
        0x00000259,
        0x0000018F
    };

    static _CharacterInfo _character00000190 =
    {
        0x00000190,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000190,
        0x0000025B,
        0x00000190
    };

    static _CharacterInfo _character00000191 =
    {
        0x00000191,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000191,
        0x00000192,
        0x00000191
    };

    static _CharacterInfo _character00000192 =
    {
        0x00000192,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000191,
        0x00000192,
        0x00000191
    };

    static _CharacterInfo _character00000193 =
    {
        0x00000193,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000193,
        0x00000260,
        0x00000193
    };

    static _CharacterInfo _character00000194 =
    {
        0x00000194,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000194,
        0x00000263,
        0x00000194
    };

    static _CharacterInfo _character00000195 =
    {
        0x00000195,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F6,
        0x00000195,
        0x000001F6
    };

    static _CharacterInfo _character00000196 =
    {
        0x00000196,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000196,
        0x00000269,
        0x00000196
    };

    static _CharacterInfo _character00000197 =
    {
        0x00000197,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000197,
        0x00000268,
        0x00000197
    };

    static _CharacterInfo _character00000198 =
    {
        0x00000198,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000198,
        0x00000199,
        0x00000198
    };

    static _CharacterInfo _character00000199 =
    {
        0x00000199,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000198,
        0x00000199,
        0x00000198
    };

    static _CharacterInfo _character0000019A =
    {
        0x0000019A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023D,
        0x0000019A,
        0x0000023D
    };

    static _CharacterInfo _character0000019B =
    {
        0x0000019B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019B,
        0x0000019B,
        0x0000019B
    };

    static _CharacterInfo _character0000019C =
    {
        0x0000019C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019C,
        0x0000026F,
        0x0000019C
    };

    static _CharacterInfo _character0000019D =
    {
        0x0000019D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019D,
        0x00000272,
        0x0000019D
    };

    static _CharacterInfo _character0000019E =
    {
        0x0000019E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000220,
        0x0000019E,
        0x00000220
    };

    static _CharacterInfo _character0000019F =
    {
        0x0000019F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019F,
        0x00000275,
        0x0000019F
    };

    static Char _decompositionMapping000001A0[] = 
    {
        0x0000004F,
        0x0000031B
    };

    static _CharacterInfo _character000001A0 =
    {
        0x000001A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A0,
        0x000001A1,
        0x000001A0
    };

    static Char _decompositionMapping000001A1[] = 
    {
        0x0000006F,
        0x0000031B
    };

    static _CharacterInfo _character000001A1 =
    {
        0x000001A1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A0,
        0x000001A1,
        0x000001A0
    };

    static _CharacterInfo _character000001A2 =
    {
        0x000001A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A2,
        0x000001A3,
        0x000001A2
    };

    static _CharacterInfo _character000001A3 =
    {
        0x000001A3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A2,
        0x000001A3,
        0x000001A2
    };

    static _CharacterInfo _character000001A4 =
    {
        0x000001A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A4,
        0x000001A5,
        0x000001A4
    };

    static _CharacterInfo _character000001A5 =
    {
        0x000001A5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A4,
        0x000001A5,
        0x000001A4
    };

    static _CharacterInfo _character000001A6 =
    {
        0x000001A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A6,
        0x00000280,
        0x000001A6
    };

    static _CharacterInfo _character000001A7 =
    {
        0x000001A7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A7,
        0x000001A8,
        0x000001A7
    };

    static _CharacterInfo _character000001A8 =
    {
        0x000001A8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A7,
        0x000001A8,
        0x000001A7
    };

    static _CharacterInfo _character000001A9 =
    {
        0x000001A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A9,
        0x00000283,
        0x000001A9
    };

    static _CharacterInfo _character000001AA =
    {
        0x000001AA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AA,
        0x000001AA,
        0x000001AA
    };

    static _CharacterInfo _character000001AB =
    {
        0x000001AB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AB,
        0x000001AB,
        0x000001AB
    };

    static _CharacterInfo _character000001AC =
    {
        0x000001AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AC,
        0x000001AD,
        0x000001AC
    };

    static _CharacterInfo _character000001AD =
    {
        0x000001AD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AC,
        0x000001AD,
        0x000001AC
    };

    static _CharacterInfo _character000001AE =
    {
        0x000001AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AE,
        0x00000288,
        0x000001AE
    };

    static Char _decompositionMapping000001AF[] = 
    {
        0x00000055,
        0x0000031B
    };

    static _CharacterInfo _character000001AF =
    {
        0x000001AF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AF,
        0x000001B0,
        0x000001AF
    };

    static Char _decompositionMapping000001B0[] = 
    {
        0x00000075,
        0x0000031B
    };

    static _CharacterInfo _character000001B0 =
    {
        0x000001B0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AF,
        0x000001B0,
        0x000001AF
    };

    static _CharacterInfo _character000001B1 =
    {
        0x000001B1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B1,
        0x0000028A,
        0x000001B1
    };

    static _CharacterInfo _character000001B2 =
    {
        0x000001B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B2,
        0x0000028B,
        0x000001B2
    };

    static _CharacterInfo _character000001B3 =
    {
        0x000001B3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B3,
        0x000001B4,
        0x000001B3
    };

    static _CharacterInfo _character000001B4 =
    {
        0x000001B4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B3,
        0x000001B4,
        0x000001B3
    };

    static _CharacterInfo _character000001B5 =
    {
        0x000001B5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B5,
        0x000001B6,
        0x000001B5
    };

    static _CharacterInfo _character000001B6 =
    {
        0x000001B6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B5,
        0x000001B6,
        0x000001B5
    };

    static _CharacterInfo _character000001B7 =
    {
        0x000001B7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B7,
        0x00000292,
        0x000001B7
    };

    static _CharacterInfo _character000001B8 =
    {
        0x000001B8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B8,
        0x000001B9,
        0x000001B8
    };

    static _CharacterInfo _character000001B9 =
    {
        0x000001B9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B8,
        0x000001B9,
        0x000001B8
    };

    static _CharacterInfo _character000001BA =
    {
        0x000001BA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001BA,
        0x000001BA,
        0x000001BA
    };

    static _CharacterInfo _character000001BB =
    {
        0x000001BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001BB,
        0x000001BB,
        0x000001BB
    };

    static _CharacterInfo _character000001BC =
    {
        0x000001BC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001BC,
        0x000001BD,
        0x000001BC
    };

    static _CharacterInfo _character000001BD =
    {
        0x000001BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001BC,
        0x000001BD,
        0x000001BC
    };

    static _CharacterInfo _character000001BE =
    {
        0x000001BE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001BE,
        0x000001BE,
        0x000001BE
    };

    static _CharacterInfo _character000001BF =
    {
        0x000001BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F7,
        0x000001BF,
        0x000001F7
    };

    static _CharacterInfo _character000001C0 =
    {
        0x000001C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C0,
        0x000001C0,
        0x000001C0
    };

    static _CharacterInfo _character000001C1 =
    {
        0x000001C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C1,
        0x000001C1,
        0x000001C1
    };

    static _CharacterInfo _character000001C2 =
    {
        0x000001C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C2,
        0x000001C2,
        0x000001C2
    };

    static _CharacterInfo _character000001C3 =
    {
        0x000001C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C3,
        0x000001C3,
        0x000001C3
    };

    static Char _decompositionMapping000001C4[] = 
    {
        0x00000044,
        0x0000017D
    };

    static _CharacterInfo _character000001C4 =
    {
        0x000001C4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C4,
        0x000001C6,
        0x000001C5
    };

    static Char _decompositionMapping000001C5[] = 
    {
        0x00000044,
        0x0000017E
    };

    static _CharacterInfo _character000001C5 =
    {
        0x000001C5,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C4,
        0x000001C6,
        0x000001C5
    };

    static Char _decompositionMapping000001C6[] = 
    {
        0x00000064,
        0x0000017E
    };

    static _CharacterInfo _character000001C6 =
    {
        0x000001C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C4,
        0x000001C6,
        0x000001C5
    };

    static Char _decompositionMapping000001C7[] = 
    {
        0x0000004C,
        0x0000004A
    };

    static _CharacterInfo _character000001C7 =
    {
        0x000001C7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C7,
        0x000001C9,
        0x000001C8
    };

    static Char _decompositionMapping000001C8[] = 
    {
        0x0000004C,
        0x0000006A
    };

    static _CharacterInfo _character000001C8 =
    {
        0x000001C8,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C7,
        0x000001C9,
        0x000001C8
    };

    static Char _decompositionMapping000001C9[] = 
    {
        0x0000006C,
        0x0000006A
    };

    static _CharacterInfo _character000001C9 =
    {
        0x000001C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001C7,
        0x000001C9,
        0x000001C8
    };

    static Char _decompositionMapping000001CA[] = 
    {
        0x0000004E,
        0x0000004A
    };

    static _CharacterInfo _character000001CA =
    {
        0x000001CA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CA,
        0x000001CC,
        0x000001CB
    };

    static Char _decompositionMapping000001CB[] = 
    {
        0x0000004E,
        0x0000006A
    };

    static _CharacterInfo _character000001CB =
    {
        0x000001CB,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CA,
        0x000001CC,
        0x000001CB
    };

    static Char _decompositionMapping000001CC[] = 
    {
        0x0000006E,
        0x0000006A
    };

    static _CharacterInfo _character000001CC =
    {
        0x000001CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CA,
        0x000001CC,
        0x000001CB
    };

    static Char _decompositionMapping000001CD[] = 
    {
        0x00000041,
        0x0000030C
    };

    static _CharacterInfo _character000001CD =
    {
        0x000001CD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CD,
        0x000001CE,
        0x000001CD
    };

    static Char _decompositionMapping000001CE[] = 
    {
        0x00000061,
        0x0000030C
    };

    static _CharacterInfo _character000001CE =
    {
        0x000001CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CD,
        0x000001CE,
        0x000001CD
    };

    static Char _decompositionMapping000001CF[] = 
    {
        0x00000049,
        0x0000030C
    };

    static _CharacterInfo _character000001CF =
    {
        0x000001CF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CF,
        0x000001D0,
        0x000001CF
    };

    static Char _decompositionMapping000001D0[] = 
    {
        0x00000069,
        0x0000030C
    };

    static _CharacterInfo _character000001D0 =
    {
        0x000001D0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001CF,
        0x000001D0,
        0x000001CF
    };

    static Char _decompositionMapping000001D1[] = 
    {
        0x0000004F,
        0x0000030C
    };

    static _CharacterInfo _character000001D1 =
    {
        0x000001D1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D1,
        0x000001D2,
        0x000001D1
    };

    static Char _decompositionMapping000001D2[] = 
    {
        0x0000006F,
        0x0000030C
    };

    static _CharacterInfo _character000001D2 =
    {
        0x000001D2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D1,
        0x000001D2,
        0x000001D1
    };

    static Char _decompositionMapping000001D3[] = 
    {
        0x00000055,
        0x0000030C
    };

    static _CharacterInfo _character000001D3 =
    {
        0x000001D3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D3,
        0x000001D4,
        0x000001D3
    };

    static Char _decompositionMapping000001D4[] = 
    {
        0x00000075,
        0x0000030C
    };

    static _CharacterInfo _character000001D4 =
    {
        0x000001D4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D3,
        0x000001D4,
        0x000001D3
    };

    static Char _decompositionMapping000001D5[] = 
    {
        0x000000DC,
        0x00000304
    };

    static _CharacterInfo _character000001D5 =
    {
        0x000001D5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D5,
        0x000001D6,
        0x000001D5
    };

    static Char _decompositionMapping000001D6[] = 
    {
        0x000000FC,
        0x00000304
    };

    static _CharacterInfo _character000001D6 =
    {
        0x000001D6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D5,
        0x000001D6,
        0x000001D5
    };

    static Char _decompositionMapping000001D7[] = 
    {
        0x000000DC,
        0x00000301
    };

    static _CharacterInfo _character000001D7 =
    {
        0x000001D7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D7,
        0x000001D8,
        0x000001D7
    };

    static Char _decompositionMapping000001D8[] = 
    {
        0x000000FC,
        0x00000301
    };

    static _CharacterInfo _character000001D8 =
    {
        0x000001D8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D7,
        0x000001D8,
        0x000001D7
    };

    static Char _decompositionMapping000001D9[] = 
    {
        0x000000DC,
        0x0000030C
    };

    static _CharacterInfo _character000001D9 =
    {
        0x000001D9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D9,
        0x000001DA,
        0x000001D9
    };

    static Char _decompositionMapping000001DA[] = 
    {
        0x000000FC,
        0x0000030C
    };

    static _CharacterInfo _character000001DA =
    {
        0x000001DA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001D9,
        0x000001DA,
        0x000001D9
    };

    static Char _decompositionMapping000001DB[] = 
    {
        0x000000DC,
        0x00000300
    };

    static _CharacterInfo _character000001DB =
    {
        0x000001DB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001DB,
        0x000001DC,
        0x000001DB
    };

    static Char _decompositionMapping000001DC[] = 
    {
        0x000000FC,
        0x00000300
    };

    static _CharacterInfo _character000001DC =
    {
        0x000001DC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001DB,
        0x000001DC,
        0x000001DB
    };

    static _CharacterInfo _character000001DD =
    {
        0x000001DD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018E,
        0x000001DD,
        0x0000018E
    };

    static Char _decompositionMapping000001DE[] = 
    {
        0x000000C4,
        0x00000304
    };

    static _CharacterInfo _character000001DE =
    {
        0x000001DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001DE,
        0x000001DF,
        0x000001DE
    };

    static Char _decompositionMapping000001DF[] = 
    {
        0x000000E4,
        0x00000304
    };

    static _CharacterInfo _character000001DF =
    {
        0x000001DF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001DE,
        0x000001DF,
        0x000001DE
    };

    static Char _decompositionMapping000001E0[] = 
    {
        0x00000226,
        0x00000304
    };

    static _CharacterInfo _character000001E0 =
    {
        0x000001E0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E0,
        0x000001E1,
        0x000001E0
    };

    static Char _decompositionMapping000001E1[] = 
    {
        0x00000227,
        0x00000304
    };

    static _CharacterInfo _character000001E1 =
    {
        0x000001E1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E0,
        0x000001E1,
        0x000001E0
    };

    static Char _decompositionMapping000001E2[] = 
    {
        0x000000C6,
        0x00000304
    };

    static _CharacterInfo _character000001E2 =
    {
        0x000001E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E2,
        0x000001E3,
        0x000001E2
    };

    static Char _decompositionMapping000001E3[] = 
    {
        0x000000E6,
        0x00000304
    };

    static _CharacterInfo _character000001E3 =
    {
        0x000001E3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E2,
        0x000001E3,
        0x000001E2
    };

    static _CharacterInfo _character000001E4 =
    {
        0x000001E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E4,
        0x000001E5,
        0x000001E4
    };

    static _CharacterInfo _character000001E5 =
    {
        0x000001E5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E4,
        0x000001E5,
        0x000001E4
    };

    static Char _decompositionMapping000001E6[] = 
    {
        0x00000047,
        0x0000030C
    };

    static _CharacterInfo _character000001E6 =
    {
        0x000001E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E6,
        0x000001E7,
        0x000001E6
    };

    static Char _decompositionMapping000001E7[] = 
    {
        0x00000067,
        0x0000030C
    };

    static _CharacterInfo _character000001E7 =
    {
        0x000001E7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E6,
        0x000001E7,
        0x000001E6
    };

    static Char _decompositionMapping000001E8[] = 
    {
        0x0000004B,
        0x0000030C
    };

    static _CharacterInfo _character000001E8 =
    {
        0x000001E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E8,
        0x000001E9,
        0x000001E8
    };

    static Char _decompositionMapping000001E9[] = 
    {
        0x0000006B,
        0x0000030C
    };

    static _CharacterInfo _character000001E9 =
    {
        0x000001E9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001E8,
        0x000001E9,
        0x000001E8
    };

    static Char _decompositionMapping000001EA[] = 
    {
        0x0000004F,
        0x00000328
    };

    static _CharacterInfo _character000001EA =
    {
        0x000001EA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EA,
        0x000001EB,
        0x000001EA
    };

    static Char _decompositionMapping000001EB[] = 
    {
        0x0000006F,
        0x00000328
    };

    static _CharacterInfo _character000001EB =
    {
        0x000001EB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EA,
        0x000001EB,
        0x000001EA
    };

    static Char _decompositionMapping000001EC[] = 
    {
        0x000001EA,
        0x00000304
    };

    static _CharacterInfo _character000001EC =
    {
        0x000001EC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EC,
        0x000001ED,
        0x000001EC
    };

    static Char _decompositionMapping000001ED[] = 
    {
        0x000001EB,
        0x00000304
    };

    static _CharacterInfo _character000001ED =
    {
        0x000001ED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EC,
        0x000001ED,
        0x000001EC
    };

    static Char _decompositionMapping000001EE[] = 
    {
        0x000001B7,
        0x0000030C
    };

    static _CharacterInfo _character000001EE =
    {
        0x000001EE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EE,
        0x000001EF,
        0x000001EE
    };

    static Char _decompositionMapping000001EF[] = 
    {
        0x00000292,
        0x0000030C
    };

    static _CharacterInfo _character000001EF =
    {
        0x000001EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001EE,
        0x000001EF,
        0x000001EE
    };

    static Char _decompositionMapping000001F0[] = 
    {
        0x0000006A,
        0x0000030C
    };

    static _CharacterInfo _character000001F0 =
    {
        0x000001F0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F0,
        0x000001F0,
        0x000001F0
    };

    static Char _decompositionMapping000001F1[] = 
    {
        0x00000044,
        0x0000005A
    };

    static _CharacterInfo _character000001F1 =
    {
        0x000001F1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F1,
        0x000001F3,
        0x000001F2
    };

    static Char _decompositionMapping000001F2[] = 
    {
        0x00000044,
        0x0000007A
    };

    static _CharacterInfo _character000001F2 =
    {
        0x000001F2,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F1,
        0x000001F3,
        0x000001F2
    };

    static Char _decompositionMapping000001F3[] = 
    {
        0x00000064,
        0x0000007A
    };

    static _CharacterInfo _character000001F3 =
    {
        0x000001F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000001F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F1,
        0x000001F3,
        0x000001F2
    };

    static Char _decompositionMapping000001F4[] = 
    {
        0x00000047,
        0x00000301
    };

    static _CharacterInfo _character000001F4 =
    {
        0x000001F4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F4,
        0x000001F5,
        0x000001F4
    };

    static Char _decompositionMapping000001F5[] = 
    {
        0x00000067,
        0x00000301
    };

    static _CharacterInfo _character000001F5 =
    {
        0x000001F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F4,
        0x000001F5,
        0x000001F4
    };

    static _CharacterInfo _character000001F6 =
    {
        0x000001F6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F6,
        0x00000195,
        0x000001F6
    };

    static _CharacterInfo _character000001F7 =
    {
        0x000001F7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F7,
        0x000001BF,
        0x000001F7
    };

    static Char _decompositionMapping000001F8[] = 
    {
        0x0000004E,
        0x00000300
    };

    static _CharacterInfo _character000001F8 =
    {
        0x000001F8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F8,
        0x000001F9,
        0x000001F8
    };

    static Char _decompositionMapping000001F9[] = 
    {
        0x0000006E,
        0x00000300
    };

    static _CharacterInfo _character000001F9 =
    {
        0x000001F9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001F8,
        0x000001F9,
        0x000001F8
    };

    static Char _decompositionMapping000001FA[] = 
    {
        0x000000C5,
        0x00000301
    };

    static _CharacterInfo _character000001FA =
    {
        0x000001FA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FA,
        0x000001FB,
        0x000001FA
    };

    static Char _decompositionMapping000001FB[] = 
    {
        0x000000E5,
        0x00000301
    };

    static _CharacterInfo _character000001FB =
    {
        0x000001FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FA,
        0x000001FB,
        0x000001FA
    };

    static Char _decompositionMapping000001FC[] = 
    {
        0x000000C6,
        0x00000301
    };

    static _CharacterInfo _character000001FC =
    {
        0x000001FC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FC,
        0x000001FD,
        0x000001FC
    };

    static Char _decompositionMapping000001FD[] = 
    {
        0x000000E6,
        0x00000301
    };

    static _CharacterInfo _character000001FD =
    {
        0x000001FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FC,
        0x000001FD,
        0x000001FC
    };

    static Char _decompositionMapping000001FE[] = 
    {
        0x000000D8,
        0x00000301
    };

    static _CharacterInfo _character000001FE =
    {
        0x000001FE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FE,
        0x000001FF,
        0x000001FE
    };

    static Char _decompositionMapping000001FF[] = 
    {
        0x000000F8,
        0x00000301
    };

    static _CharacterInfo _character000001FF =
    {
        0x000001FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000001FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001FE,
        0x000001FF,
        0x000001FE
    };

    static Char _decompositionMapping00000200[] = 
    {
        0x00000041,
        0x0000030F
    };

    static _CharacterInfo _character00000200 =
    {
        0x00000200,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000200,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000200,
        0x00000201,
        0x00000200
    };

    static Char _decompositionMapping00000201[] = 
    {
        0x00000061,
        0x0000030F
    };

    static _CharacterInfo _character00000201 =
    {
        0x00000201,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000201,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000200,
        0x00000201,
        0x00000200
    };

    static Char _decompositionMapping00000202[] = 
    {
        0x00000041,
        0x00000311
    };

    static _CharacterInfo _character00000202 =
    {
        0x00000202,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000202,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000202,
        0x00000203,
        0x00000202
    };

    static Char _decompositionMapping00000203[] = 
    {
        0x00000061,
        0x00000311
    };

    static _CharacterInfo _character00000203 =
    {
        0x00000203,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000203,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000202,
        0x00000203,
        0x00000202
    };

    static Char _decompositionMapping00000204[] = 
    {
        0x00000045,
        0x0000030F
    };

    static _CharacterInfo _character00000204 =
    {
        0x00000204,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000204,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000204,
        0x00000205,
        0x00000204
    };

    static Char _decompositionMapping00000205[] = 
    {
        0x00000065,
        0x0000030F
    };

    static _CharacterInfo _character00000205 =
    {
        0x00000205,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000205,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000204,
        0x00000205,
        0x00000204
    };

    static Char _decompositionMapping00000206[] = 
    {
        0x00000045,
        0x00000311
    };

    static _CharacterInfo _character00000206 =
    {
        0x00000206,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000206,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000206,
        0x00000207,
        0x00000206
    };

    static Char _decompositionMapping00000207[] = 
    {
        0x00000065,
        0x00000311
    };

    static _CharacterInfo _character00000207 =
    {
        0x00000207,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000207,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000206,
        0x00000207,
        0x00000206
    };

    static Char _decompositionMapping00000208[] = 
    {
        0x00000049,
        0x0000030F
    };

    static _CharacterInfo _character00000208 =
    {
        0x00000208,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000208,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000208,
        0x00000209,
        0x00000208
    };

    static Char _decompositionMapping00000209[] = 
    {
        0x00000069,
        0x0000030F
    };

    static _CharacterInfo _character00000209 =
    {
        0x00000209,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000209,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000208,
        0x00000209,
        0x00000208
    };

    static Char _decompositionMapping0000020A[] = 
    {
        0x00000049,
        0x00000311
    };

    static _CharacterInfo _character0000020A =
    {
        0x0000020A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020A,
        0x0000020B,
        0x0000020A
    };

    static Char _decompositionMapping0000020B[] = 
    {
        0x00000069,
        0x00000311
    };

    static _CharacterInfo _character0000020B =
    {
        0x0000020B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020A,
        0x0000020B,
        0x0000020A
    };

    static Char _decompositionMapping0000020C[] = 
    {
        0x0000004F,
        0x0000030F
    };

    static _CharacterInfo _character0000020C =
    {
        0x0000020C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020C,
        0x0000020D,
        0x0000020C
    };

    static Char _decompositionMapping0000020D[] = 
    {
        0x0000006F,
        0x0000030F
    };

    static _CharacterInfo _character0000020D =
    {
        0x0000020D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020C,
        0x0000020D,
        0x0000020C
    };

    static Char _decompositionMapping0000020E[] = 
    {
        0x0000004F,
        0x00000311
    };

    static _CharacterInfo _character0000020E =
    {
        0x0000020E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020E,
        0x0000020F,
        0x0000020E
    };

    static Char _decompositionMapping0000020F[] = 
    {
        0x0000006F,
        0x00000311
    };

    static _CharacterInfo _character0000020F =
    {
        0x0000020F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000020F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000020E,
        0x0000020F,
        0x0000020E
    };

    static Char _decompositionMapping00000210[] = 
    {
        0x00000052,
        0x0000030F
    };

    static _CharacterInfo _character00000210 =
    {
        0x00000210,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000210,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000210,
        0x00000211,
        0x00000210
    };

    static Char _decompositionMapping00000211[] = 
    {
        0x00000072,
        0x0000030F
    };

    static _CharacterInfo _character00000211 =
    {
        0x00000211,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000211,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000210,
        0x00000211,
        0x00000210
    };

    static Char _decompositionMapping00000212[] = 
    {
        0x00000052,
        0x00000311
    };

    static _CharacterInfo _character00000212 =
    {
        0x00000212,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000212,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000212,
        0x00000213,
        0x00000212
    };

    static Char _decompositionMapping00000213[] = 
    {
        0x00000072,
        0x00000311
    };

    static _CharacterInfo _character00000213 =
    {
        0x00000213,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000213,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000212,
        0x00000213,
        0x00000212
    };

    static Char _decompositionMapping00000214[] = 
    {
        0x00000055,
        0x0000030F
    };

    static _CharacterInfo _character00000214 =
    {
        0x00000214,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000214,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000214,
        0x00000215,
        0x00000214
    };

    static Char _decompositionMapping00000215[] = 
    {
        0x00000075,
        0x0000030F
    };

    static _CharacterInfo _character00000215 =
    {
        0x00000215,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000215,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000214,
        0x00000215,
        0x00000214
    };

    static Char _decompositionMapping00000216[] = 
    {
        0x00000055,
        0x00000311
    };

    static _CharacterInfo _character00000216 =
    {
        0x00000216,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000216,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000216,
        0x00000217,
        0x00000216
    };

    static Char _decompositionMapping00000217[] = 
    {
        0x00000075,
        0x00000311
    };

    static _CharacterInfo _character00000217 =
    {
        0x00000217,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000217,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000216,
        0x00000217,
        0x00000216
    };

    static Char _decompositionMapping00000218[] = 
    {
        0x00000053,
        0x00000326
    };

    static _CharacterInfo _character00000218 =
    {
        0x00000218,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000218,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000218,
        0x00000219,
        0x00000218
    };

    static Char _decompositionMapping00000219[] = 
    {
        0x00000073,
        0x00000326
    };

    static _CharacterInfo _character00000219 =
    {
        0x00000219,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000219,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000218,
        0x00000219,
        0x00000218
    };

    static Char _decompositionMapping0000021A[] = 
    {
        0x00000054,
        0x00000326
    };

    static _CharacterInfo _character0000021A =
    {
        0x0000021A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000021A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021A,
        0x0000021B,
        0x0000021A
    };

    static Char _decompositionMapping0000021B[] = 
    {
        0x00000074,
        0x00000326
    };

    static _CharacterInfo _character0000021B =
    {
        0x0000021B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000021B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021A,
        0x0000021B,
        0x0000021A
    };

    static _CharacterInfo _character0000021C =
    {
        0x0000021C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021C,
        0x0000021D,
        0x0000021C
    };

    static _CharacterInfo _character0000021D =
    {
        0x0000021D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021C,
        0x0000021D,
        0x0000021C
    };

    static Char _decompositionMapping0000021E[] = 
    {
        0x00000048,
        0x0000030C
    };

    static _CharacterInfo _character0000021E =
    {
        0x0000021E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000021E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021E,
        0x0000021F,
        0x0000021E
    };

    static Char _decompositionMapping0000021F[] = 
    {
        0x00000068,
        0x0000030C
    };

    static _CharacterInfo _character0000021F =
    {
        0x0000021F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000021F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000021E,
        0x0000021F,
        0x0000021E
    };

    static _CharacterInfo _character00000220 =
    {
        0x00000220,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000220,
        0x0000019E,
        0x00000220
    };

    static _CharacterInfo _character00000221 =
    {
        0x00000221,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000221,
        0x00000221,
        0x00000221
    };

    static _CharacterInfo _character00000222 =
    {
        0x00000222,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000222,
        0x00000223,
        0x00000222
    };

    static _CharacterInfo _character00000223 =
    {
        0x00000223,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000222,
        0x00000223,
        0x00000222
    };

    static _CharacterInfo _character00000224 =
    {
        0x00000224,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000224,
        0x00000225,
        0x00000224
    };

    static _CharacterInfo _character00000225 =
    {
        0x00000225,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000224,
        0x00000225,
        0x00000224
    };

    static Char _decompositionMapping00000226[] = 
    {
        0x00000041,
        0x00000307
    };

    static _CharacterInfo _character00000226 =
    {
        0x00000226,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000226,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000226,
        0x00000227,
        0x00000226
    };

    static Char _decompositionMapping00000227[] = 
    {
        0x00000061,
        0x00000307
    };

    static _CharacterInfo _character00000227 =
    {
        0x00000227,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000227,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000226,
        0x00000227,
        0x00000226
    };

    static Char _decompositionMapping00000228[] = 
    {
        0x00000045,
        0x00000327
    };

    static _CharacterInfo _character00000228 =
    {
        0x00000228,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000228,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000228,
        0x00000229,
        0x00000228
    };

    static Char _decompositionMapping00000229[] = 
    {
        0x00000065,
        0x00000327
    };

    static _CharacterInfo _character00000229 =
    {
        0x00000229,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000229,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000228,
        0x00000229,
        0x00000228
    };

    static Char _decompositionMapping0000022A[] = 
    {
        0x000000D6,
        0x00000304
    };

    static _CharacterInfo _character0000022A =
    {
        0x0000022A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022A,
        0x0000022B,
        0x0000022A
    };

    static Char _decompositionMapping0000022B[] = 
    {
        0x000000F6,
        0x00000304
    };

    static _CharacterInfo _character0000022B =
    {
        0x0000022B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022A,
        0x0000022B,
        0x0000022A
    };

    static Char _decompositionMapping0000022C[] = 
    {
        0x000000D5,
        0x00000304
    };

    static _CharacterInfo _character0000022C =
    {
        0x0000022C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022C,
        0x0000022D,
        0x0000022C
    };

    static Char _decompositionMapping0000022D[] = 
    {
        0x000000F5,
        0x00000304
    };

    static _CharacterInfo _character0000022D =
    {
        0x0000022D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022C,
        0x0000022D,
        0x0000022C
    };

    static Char _decompositionMapping0000022E[] = 
    {
        0x0000004F,
        0x00000307
    };

    static _CharacterInfo _character0000022E =
    {
        0x0000022E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022E,
        0x0000022F,
        0x0000022E
    };

    static Char _decompositionMapping0000022F[] = 
    {
        0x0000006F,
        0x00000307
    };

    static _CharacterInfo _character0000022F =
    {
        0x0000022F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000022F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000022E,
        0x0000022F,
        0x0000022E
    };

    static Char _decompositionMapping00000230[] = 
    {
        0x0000022E,
        0x00000304
    };

    static _CharacterInfo _character00000230 =
    {
        0x00000230,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000230,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000230,
        0x00000231,
        0x00000230
    };

    static Char _decompositionMapping00000231[] = 
    {
        0x0000022F,
        0x00000304
    };

    static _CharacterInfo _character00000231 =
    {
        0x00000231,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000231,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000230,
        0x00000231,
        0x00000230
    };

    static Char _decompositionMapping00000232[] = 
    {
        0x00000059,
        0x00000304
    };

    static _CharacterInfo _character00000232 =
    {
        0x00000232,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000232,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000232,
        0x00000233,
        0x00000232
    };

    static Char _decompositionMapping00000233[] = 
    {
        0x00000079,
        0x00000304
    };

    static _CharacterInfo _character00000233 =
    {
        0x00000233,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000233,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000232,
        0x00000233,
        0x00000232
    };

    static _CharacterInfo _character00000234 =
    {
        0x00000234,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000234,
        0x00000234,
        0x00000234
    };

    static _CharacterInfo _character00000235 =
    {
        0x00000235,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000235,
        0x00000235,
        0x00000235
    };

    static _CharacterInfo _character00000236 =
    {
        0x00000236,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000236,
        0x00000236,
        0x00000236
    };

    static _CharacterInfo _character00000237 =
    {
        0x00000237,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000237,
        0x00000237,
        0x00000237
    };

    static _CharacterInfo _character00000238 =
    {
        0x00000238,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000238,
        0x00000238,
        0x00000238
    };

    static _CharacterInfo _character00000239 =
    {
        0x00000239,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000239,
        0x00000239,
        0x00000239
    };

    static _CharacterInfo _character0000023A =
    {
        0x0000023A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023A,
        0x00002C65,
        0x0000023A
    };

    static _CharacterInfo _character0000023B =
    {
        0x0000023B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023B,
        0x0000023C,
        0x0000023B
    };

    static _CharacterInfo _character0000023C =
    {
        0x0000023C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023B,
        0x0000023C,
        0x0000023B
    };

    static _CharacterInfo _character0000023D =
    {
        0x0000023D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023D,
        0x0000019A,
        0x0000023D
    };

    static _CharacterInfo _character0000023E =
    {
        0x0000023E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023E,
        0x00002C66,
        0x0000023E
    };

    static _CharacterInfo _character0000023F =
    {
        0x0000023F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023F,
        0x0000023F,
        0x0000023F
    };

    static _CharacterInfo _character00000240 =
    {
        0x00000240,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000240,
        0x00000240,
        0x00000240
    };

    static _CharacterInfo _character00000241 =
    {
        0x00000241,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000241,
        0x00000242,
        0x00000241
    };

    static _CharacterInfo _character00000242 =
    {
        0x00000242,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000241,
        0x00000242,
        0x00000241
    };

    static _CharacterInfo _character00000243 =
    {
        0x00000243,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000243,
        0x00000180,
        0x00000243
    };

    static _CharacterInfo _character00000244 =
    {
        0x00000244,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000244,
        0x00000289,
        0x00000244
    };

    static _CharacterInfo _character00000245 =
    {
        0x00000245,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000245,
        0x0000028C,
        0x00000245
    };

    static _CharacterInfo _character00000246 =
    {
        0x00000246,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000246,
        0x00000247,
        0x00000246
    };

    static _CharacterInfo _character00000247 =
    {
        0x00000247,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000246,
        0x00000247,
        0x00000246
    };

    static _CharacterInfo _character00000248 =
    {
        0x00000248,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000248,
        0x00000249,
        0x00000248
    };

    static _CharacterInfo _character00000249 =
    {
        0x00000249,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000248,
        0x00000249,
        0x00000248
    };

    static _CharacterInfo _character0000024A =
    {
        0x0000024A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024A,
        0x0000024B,
        0x0000024A
    };

    static _CharacterInfo _character0000024B =
    {
        0x0000024B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024A,
        0x0000024B,
        0x0000024A
    };

    static _CharacterInfo _character0000024C =
    {
        0x0000024C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024C,
        0x0000024D,
        0x0000024C
    };

    static _CharacterInfo _character0000024D =
    {
        0x0000024D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024C,
        0x0000024D,
        0x0000024C
    };

    static _CharacterInfo _character0000024E =
    {
        0x0000024E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024E,
        0x0000024F,
        0x0000024E
    };

    static _CharacterInfo _character0000024F =
    {
        0x0000024F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000024E,
        0x0000024F,
        0x0000024E
    };

    static _CharacterInfo _character00000250 =
    {
        0x00000250,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000250,
        0x00000250,
        0x00000250
    };

    static _CharacterInfo _character00000251 =
    {
        0x00000251,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000251,
        0x00000251,
        0x00000251
    };

    static _CharacterInfo _character00000252 =
    {
        0x00000252,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000252,
        0x00000252,
        0x00000252
    };

    static _CharacterInfo _character00000253 =
    {
        0x00000253,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000181,
        0x00000253,
        0x00000181
    };

    static _CharacterInfo _character00000254 =
    {
        0x00000254,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000186,
        0x00000254,
        0x00000186
    };

    static _CharacterInfo _character00000255 =
    {
        0x00000255,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000255,
        0x00000255,
        0x00000255
    };

    static _CharacterInfo _character00000256 =
    {
        0x00000256,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000189,
        0x00000256,
        0x00000189
    };

    static _CharacterInfo _character00000257 =
    {
        0x00000257,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018A,
        0x00000257,
        0x0000018A
    };

    static _CharacterInfo _character00000258 =
    {
        0x00000258,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000258,
        0x00000258,
        0x00000258
    };

    static _CharacterInfo _character00000259 =
    {
        0x00000259,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000018F,
        0x00000259,
        0x0000018F
    };

    static _CharacterInfo _character0000025A =
    {
        0x0000025A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000025A,
        0x0000025A,
        0x0000025A
    };

    static _CharacterInfo _character0000025B =
    {
        0x0000025B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000190,
        0x0000025B,
        0x00000190
    };

    static _CharacterInfo _character0000025C =
    {
        0x0000025C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000025C,
        0x0000025C,
        0x0000025C
    };

    static _CharacterInfo _character0000025D =
    {
        0x0000025D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000025D,
        0x0000025D,
        0x0000025D
    };

    static _CharacterInfo _character0000025E =
    {
        0x0000025E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000025E,
        0x0000025E,
        0x0000025E
    };

    static _CharacterInfo _character0000025F =
    {
        0x0000025F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000025F,
        0x0000025F,
        0x0000025F
    };

    static _CharacterInfo _character00000260 =
    {
        0x00000260,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000193,
        0x00000260,
        0x00000193
    };

    static _CharacterInfo _character00000261 =
    {
        0x00000261,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000261,
        0x00000261,
        0x00000261
    };

    static _CharacterInfo _character00000262 =
    {
        0x00000262,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000262,
        0x00000262,
        0x00000262
    };

    static _CharacterInfo _character00000263 =
    {
        0x00000263,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000194,
        0x00000263,
        0x00000194
    };

    static _CharacterInfo _character00000264 =
    {
        0x00000264,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000264,
        0x00000264,
        0x00000264
    };

    static _CharacterInfo _character00000265 =
    {
        0x00000265,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000265,
        0x00000265,
        0x00000265
    };

    static _CharacterInfo _character00000266 =
    {
        0x00000266,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000266,
        0x00000266,
        0x00000266
    };

    static _CharacterInfo _character00000267 =
    {
        0x00000267,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000267,
        0x00000267,
        0x00000267
    };

    static _CharacterInfo _character00000268 =
    {
        0x00000268,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000197,
        0x00000268,
        0x00000197
    };

    static _CharacterInfo _character00000269 =
    {
        0x00000269,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000196,
        0x00000269,
        0x00000196
    };

    static _CharacterInfo _character0000026A =
    {
        0x0000026A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000026A,
        0x0000026A,
        0x0000026A
    };

    static _CharacterInfo _character0000026B =
    {
        0x0000026B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C62,
        0x0000026B,
        0x00002C62
    };

    static _CharacterInfo _character0000026C =
    {
        0x0000026C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000026C,
        0x0000026C,
        0x0000026C
    };

    static _CharacterInfo _character0000026D =
    {
        0x0000026D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000026D,
        0x0000026D,
        0x0000026D
    };

    static _CharacterInfo _character0000026E =
    {
        0x0000026E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000026E,
        0x0000026E,
        0x0000026E
    };

    static _CharacterInfo _character0000026F =
    {
        0x0000026F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019C,
        0x0000026F,
        0x0000019C
    };

    static _CharacterInfo _character00000270 =
    {
        0x00000270,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000270,
        0x00000270,
        0x00000270
    };

    static _CharacterInfo _character00000271 =
    {
        0x00000271,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000271,
        0x00000271,
        0x00000271
    };

    static _CharacterInfo _character00000272 =
    {
        0x00000272,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019D,
        0x00000272,
        0x0000019D
    };

    static _CharacterInfo _character00000273 =
    {
        0x00000273,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000273,
        0x00000273,
        0x00000273
    };

    static _CharacterInfo _character00000274 =
    {
        0x00000274,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000274,
        0x00000274,
        0x00000274
    };

    static _CharacterInfo _character00000275 =
    {
        0x00000275,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000019F,
        0x00000275,
        0x0000019F
    };

    static _CharacterInfo _character00000276 =
    {
        0x00000276,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000276,
        0x00000276,
        0x00000276
    };

    static _CharacterInfo _character00000277 =
    {
        0x00000277,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000277,
        0x00000277,
        0x00000277
    };

    static _CharacterInfo _character00000278 =
    {
        0x00000278,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000278,
        0x00000278,
        0x00000278
    };

    static _CharacterInfo _character00000279 =
    {
        0x00000279,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000279,
        0x00000279,
        0x00000279
    };

    static _CharacterInfo _character0000027A =
    {
        0x0000027A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000027A,
        0x0000027A,
        0x0000027A
    };

    static _CharacterInfo _character0000027B =
    {
        0x0000027B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000027B,
        0x0000027B,
        0x0000027B
    };

    static _CharacterInfo _character0000027C =
    {
        0x0000027C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000027C,
        0x0000027C,
        0x0000027C
    };

    static _CharacterInfo _character0000027D =
    {
        0x0000027D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C64,
        0x0000027D,
        0x00002C64
    };

    static _CharacterInfo _character0000027E =
    {
        0x0000027E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000027E,
        0x0000027E,
        0x0000027E
    };

    static _CharacterInfo _character0000027F =
    {
        0x0000027F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000027F,
        0x0000027F,
        0x0000027F
    };

    static _CharacterInfo _character00000280 =
    {
        0x00000280,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A6,
        0x00000280,
        0x000001A6
    };

    static _CharacterInfo _character00000281 =
    {
        0x00000281,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000281,
        0x00000281,
        0x00000281
    };

    static _CharacterInfo _character00000282 =
    {
        0x00000282,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000282,
        0x00000282,
        0x00000282
    };

    static _CharacterInfo _character00000283 =
    {
        0x00000283,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001A9,
        0x00000283,
        0x000001A9
    };

    static _CharacterInfo _character00000284 =
    {
        0x00000284,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000284,
        0x00000284,
        0x00000284
    };

    static _CharacterInfo _character00000285 =
    {
        0x00000285,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000285,
        0x00000285,
        0x00000285
    };

    static _CharacterInfo _character00000286 =
    {
        0x00000286,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000286,
        0x00000286,
        0x00000286
    };

    static _CharacterInfo _character00000287 =
    {
        0x00000287,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000287,
        0x00000287,
        0x00000287
    };

    static _CharacterInfo _character00000288 =
    {
        0x00000288,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001AE,
        0x00000288,
        0x000001AE
    };

    static _CharacterInfo _character00000289 =
    {
        0x00000289,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000244,
        0x00000289,
        0x00000244
    };

    static _CharacterInfo _character0000028A =
    {
        0x0000028A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B1,
        0x0000028A,
        0x000001B1
    };

    static _CharacterInfo _character0000028B =
    {
        0x0000028B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B2,
        0x0000028B,
        0x000001B2
    };

    static _CharacterInfo _character0000028C =
    {
        0x0000028C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000245,
        0x0000028C,
        0x00000245
    };

    static _CharacterInfo _character0000028D =
    {
        0x0000028D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000028D,
        0x0000028D,
        0x0000028D
    };

    static _CharacterInfo _character0000028E =
    {
        0x0000028E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000028E,
        0x0000028E,
        0x0000028E
    };

    static _CharacterInfo _character0000028F =
    {
        0x0000028F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000028F,
        0x0000028F,
        0x0000028F
    };

    static _CharacterInfo _character00000290 =
    {
        0x00000290,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000290,
        0x00000290,
        0x00000290
    };

    static _CharacterInfo _character00000291 =
    {
        0x00000291,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000291,
        0x00000291,
        0x00000291
    };

    static _CharacterInfo _character00000292 =
    {
        0x00000292,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000001B7,
        0x00000292,
        0x000001B7
    };

    static _CharacterInfo _character00000293 =
    {
        0x00000293,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000293,
        0x00000293,
        0x00000293
    };

    static _CharacterInfo _character00000294 =
    {
        0x00000294,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000294,
        0x00000294,
        0x00000294
    };

    static _CharacterInfo _character00000295 =
    {
        0x00000295,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000295,
        0x00000295,
        0x00000295
    };

    static _CharacterInfo _character00000296 =
    {
        0x00000296,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000296,
        0x00000296,
        0x00000296
    };

    static _CharacterInfo _character00000297 =
    {
        0x00000297,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000297,
        0x00000297,
        0x00000297
    };

    static _CharacterInfo _character00000298 =
    {
        0x00000298,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000298,
        0x00000298,
        0x00000298
    };

    static _CharacterInfo _character00000299 =
    {
        0x00000299,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000299,
        0x00000299,
        0x00000299
    };

    static _CharacterInfo _character0000029A =
    {
        0x0000029A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029A,
        0x0000029A,
        0x0000029A
    };

    static _CharacterInfo _character0000029B =
    {
        0x0000029B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029B,
        0x0000029B,
        0x0000029B
    };

    static _CharacterInfo _character0000029C =
    {
        0x0000029C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029C,
        0x0000029C,
        0x0000029C
    };

    static _CharacterInfo _character0000029D =
    {
        0x0000029D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029D,
        0x0000029D,
        0x0000029D
    };

    static _CharacterInfo _character0000029E =
    {
        0x0000029E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029E,
        0x0000029E,
        0x0000029E
    };

    static _CharacterInfo _character0000029F =
    {
        0x0000029F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000029F,
        0x0000029F,
        0x0000029F
    };

    static _CharacterInfo _character000002A0 =
    {
        0x000002A0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A0,
        0x000002A0,
        0x000002A0
    };

    static _CharacterInfo _character000002A1 =
    {
        0x000002A1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A1,
        0x000002A1,
        0x000002A1
    };

    static _CharacterInfo _character000002A2 =
    {
        0x000002A2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A2,
        0x000002A2,
        0x000002A2
    };

    static _CharacterInfo _character000002A3 =
    {
        0x000002A3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A3,
        0x000002A3,
        0x000002A3
    };

    static _CharacterInfo _character000002A4 =
    {
        0x000002A4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A4,
        0x000002A4,
        0x000002A4
    };

    static _CharacterInfo _character000002A5 =
    {
        0x000002A5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A5,
        0x000002A5,
        0x000002A5
    };

    static _CharacterInfo _character000002A6 =
    {
        0x000002A6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A6,
        0x000002A6,
        0x000002A6
    };

    static _CharacterInfo _character000002A7 =
    {
        0x000002A7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A7,
        0x000002A7,
        0x000002A7
    };

    static _CharacterInfo _character000002A8 =
    {
        0x000002A8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A8,
        0x000002A8,
        0x000002A8
    };

    static _CharacterInfo _character000002A9 =
    {
        0x000002A9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002A9,
        0x000002A9,
        0x000002A9
    };

    static _CharacterInfo _character000002AA =
    {
        0x000002AA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AA,
        0x000002AA,
        0x000002AA
    };

    static _CharacterInfo _character000002AB =
    {
        0x000002AB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AB,
        0x000002AB,
        0x000002AB
    };

    static _CharacterInfo _character000002AC =
    {
        0x000002AC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AC,
        0x000002AC,
        0x000002AC
    };

    static _CharacterInfo _character000002AD =
    {
        0x000002AD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AD,
        0x000002AD,
        0x000002AD
    };

    static _CharacterInfo _character000002AE =
    {
        0x000002AE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AE,
        0x000002AE,
        0x000002AE
    };

    static _CharacterInfo _character000002AF =
    {
        0x000002AF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002AF,
        0x000002AF,
        0x000002AF
    };

    static Char _decompositionMapping000002B0[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character000002B0 =
    {
        0x000002B0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B0,
        0x000002B0,
        0x000002B0
    };

    static Char _decompositionMapping000002B1[] = 
    {
        0x00000266
    };

    static _CharacterInfo _character000002B1 =
    {
        0x000002B1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B1,
        0x000002B1,
        0x000002B1
    };

    static Char _decompositionMapping000002B2[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character000002B2 =
    {
        0x000002B2,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B2,
        0x000002B2,
        0x000002B2
    };

    static Char _decompositionMapping000002B3[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character000002B3 =
    {
        0x000002B3,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B3,
        0x000002B3,
        0x000002B3
    };

    static Char _decompositionMapping000002B4[] = 
    {
        0x00000279
    };

    static _CharacterInfo _character000002B4 =
    {
        0x000002B4,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B4,
        0x000002B4,
        0x000002B4
    };

    static Char _decompositionMapping000002B5[] = 
    {
        0x0000027B
    };

    static _CharacterInfo _character000002B5 =
    {
        0x000002B5,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B5,
        0x000002B5,
        0x000002B5
    };

    static Char _decompositionMapping000002B6[] = 
    {
        0x00000281
    };

    static _CharacterInfo _character000002B6 =
    {
        0x000002B6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B6,
        0x000002B6,
        0x000002B6
    };

    static Char _decompositionMapping000002B7[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character000002B7 =
    {
        0x000002B7,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B7,
        0x000002B7,
        0x000002B7
    };

    static Char _decompositionMapping000002B8[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character000002B8 =
    {
        0x000002B8,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B8,
        0x000002B8,
        0x000002B8
    };

    static _CharacterInfo _character000002B9 =
    {
        0x000002B9,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002B9,
        0x000002B9,
        0x000002B9
    };

    static _CharacterInfo _character000002BA =
    {
        0x000002BA,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BA,
        0x000002BA,
        0x000002BA
    };

    static _CharacterInfo _character000002BB =
    {
        0x000002BB,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BB,
        0x000002BB,
        0x000002BB
    };

    static _CharacterInfo _character000002BC =
    {
        0x000002BC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BC,
        0x000002BC,
        0x000002BC
    };

    static _CharacterInfo _character000002BD =
    {
        0x000002BD,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BD,
        0x000002BD,
        0x000002BD
    };

    static _CharacterInfo _character000002BE =
    {
        0x000002BE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BE,
        0x000002BE,
        0x000002BE
    };

    static _CharacterInfo _character000002BF =
    {
        0x000002BF,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002BF,
        0x000002BF,
        0x000002BF
    };

    static _CharacterInfo _character000002C0 =
    {
        0x000002C0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C0,
        0x000002C0,
        0x000002C0
    };

    static _CharacterInfo _character000002C1 =
    {
        0x000002C1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C1,
        0x000002C1,
        0x000002C1
    };

    static _CharacterInfo _character000002C2 =
    {
        0x000002C2,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C2,
        0x000002C2,
        0x000002C2
    };

    static _CharacterInfo _character000002C3 =
    {
        0x000002C3,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C3,
        0x000002C3,
        0x000002C3
    };

    static _CharacterInfo _character000002C4 =
    {
        0x000002C4,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C4,
        0x000002C4,
        0x000002C4
    };

    static _CharacterInfo _character000002C5 =
    {
        0x000002C5,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C5,
        0x000002C5,
        0x000002C5
    };

    static _CharacterInfo _character000002C6 =
    {
        0x000002C6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C6,
        0x000002C6,
        0x000002C6
    };

    static _CharacterInfo _character000002C7 =
    {
        0x000002C7,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C7,
        0x000002C7,
        0x000002C7
    };

    static _CharacterInfo _character000002C8 =
    {
        0x000002C8,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C8,
        0x000002C8,
        0x000002C8
    };

    static _CharacterInfo _character000002C9 =
    {
        0x000002C9,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002C9,
        0x000002C9,
        0x000002C9
    };

    static _CharacterInfo _character000002CA =
    {
        0x000002CA,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CA,
        0x000002CA,
        0x000002CA
    };

    static _CharacterInfo _character000002CB =
    {
        0x000002CB,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CB,
        0x000002CB,
        0x000002CB
    };

    static _CharacterInfo _character000002CC =
    {
        0x000002CC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CC,
        0x000002CC,
        0x000002CC
    };

    static _CharacterInfo _character000002CD =
    {
        0x000002CD,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CD,
        0x000002CD,
        0x000002CD
    };

    static _CharacterInfo _character000002CE =
    {
        0x000002CE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CE,
        0x000002CE,
        0x000002CE
    };

    static _CharacterInfo _character000002CF =
    {
        0x000002CF,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002CF,
        0x000002CF,
        0x000002CF
    };

    static _CharacterInfo _character000002D0 =
    {
        0x000002D0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D0,
        0x000002D0,
        0x000002D0
    };

    static _CharacterInfo _character000002D1 =
    {
        0x000002D1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D1,
        0x000002D1,
        0x000002D1
    };

    static _CharacterInfo _character000002D2 =
    {
        0x000002D2,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D2,
        0x000002D2,
        0x000002D2
    };

    static _CharacterInfo _character000002D3 =
    {
        0x000002D3,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D3,
        0x000002D3,
        0x000002D3
    };

    static _CharacterInfo _character000002D4 =
    {
        0x000002D4,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D4,
        0x000002D4,
        0x000002D4
    };

    static _CharacterInfo _character000002D5 =
    {
        0x000002D5,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D5,
        0x000002D5,
        0x000002D5
    };

    static _CharacterInfo _character000002D6 =
    {
        0x000002D6,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D6,
        0x000002D6,
        0x000002D6
    };

    static _CharacterInfo _character000002D7 =
    {
        0x000002D7,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D7,
        0x000002D7,
        0x000002D7
    };

    static Char _decompositionMapping000002D8[] = 
    {
        0x00000020,
        0x00000306
    };

    static _CharacterInfo _character000002D8 =
    {
        0x000002D8,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D8,
        0x000002D8,
        0x000002D8
    };

    static Char _decompositionMapping000002D9[] = 
    {
        0x00000020,
        0x00000307
    };

    static _CharacterInfo _character000002D9 =
    {
        0x000002D9,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002D9,
        0x000002D9,
        0x000002D9
    };

    static Char _decompositionMapping000002DA[] = 
    {
        0x00000020,
        0x0000030A
    };

    static _CharacterInfo _character000002DA =
    {
        0x000002DA,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DA,
        0x000002DA,
        0x000002DA
    };

    static Char _decompositionMapping000002DB[] = 
    {
        0x00000020,
        0x00000328
    };

    static _CharacterInfo _character000002DB =
    {
        0x000002DB,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DB,
        0x000002DB,
        0x000002DB
    };

    static Char _decompositionMapping000002DC[] = 
    {
        0x00000020,
        0x00000303
    };

    static _CharacterInfo _character000002DC =
    {
        0x000002DC,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DC,
        0x000002DC,
        0x000002DC
    };

    static Char _decompositionMapping000002DD[] = 
    {
        0x00000020,
        0x0000030B
    };

    static _CharacterInfo _character000002DD =
    {
        0x000002DD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000002DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DD,
        0x000002DD,
        0x000002DD
    };

    static _CharacterInfo _character000002DE =
    {
        0x000002DE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DE,
        0x000002DE,
        0x000002DE
    };

    static _CharacterInfo _character000002DF =
    {
        0x000002DF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002DF,
        0x000002DF,
        0x000002DF
    };

    static Char _decompositionMapping000002E0[] = 
    {
        0x00000263
    };

    static _CharacterInfo _character000002E0 =
    {
        0x000002E0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E0,
        0x000002E0,
        0x000002E0
    };

    static Char _decompositionMapping000002E1[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character000002E1 =
    {
        0x000002E1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E1,
        0x000002E1,
        0x000002E1
    };

    static Char _decompositionMapping000002E2[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character000002E2 =
    {
        0x000002E2,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E2,
        0x000002E2,
        0x000002E2
    };

    static Char _decompositionMapping000002E3[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character000002E3 =
    {
        0x000002E3,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E3,
        0x000002E3,
        0x000002E3
    };

    static Char _decompositionMapping000002E4[] = 
    {
        0x00000295
    };

    static _CharacterInfo _character000002E4 =
    {
        0x000002E4,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000002E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E4,
        0x000002E4,
        0x000002E4
    };

    static _CharacterInfo _character000002E5 =
    {
        0x000002E5,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E5,
        0x000002E5,
        0x000002E5
    };

    static _CharacterInfo _character000002E6 =
    {
        0x000002E6,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E6,
        0x000002E6,
        0x000002E6
    };

    static _CharacterInfo _character000002E7 =
    {
        0x000002E7,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E7,
        0x000002E7,
        0x000002E7
    };

    static _CharacterInfo _character000002E8 =
    {
        0x000002E8,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E8,
        0x000002E8,
        0x000002E8
    };

    static _CharacterInfo _character000002E9 =
    {
        0x000002E9,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002E9,
        0x000002E9,
        0x000002E9
    };

    static _CharacterInfo _character000002EA =
    {
        0x000002EA,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002EA,
        0x000002EA,
        0x000002EA
    };

    static _CharacterInfo _character000002EB =
    {
        0x000002EB,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002EB,
        0x000002EB,
        0x000002EB
    };

    static _CharacterInfo _character000002EC =
    {
        0x000002EC,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002EC,
        0x000002EC,
        0x000002EC
    };

    static _CharacterInfo _character000002ED =
    {
        0x000002ED,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002ED,
        0x000002ED,
        0x000002ED
    };

    static _CharacterInfo _character000002EE =
    {
        0x000002EE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002EE,
        0x000002EE,
        0x000002EE
    };

    static _CharacterInfo _character000002EF =
    {
        0x000002EF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002EF,
        0x000002EF,
        0x000002EF
    };

    static _CharacterInfo _character000002F0 =
    {
        0x000002F0,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F0,
        0x000002F0,
        0x000002F0
    };

    static _CharacterInfo _character000002F1 =
    {
        0x000002F1,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F1,
        0x000002F1,
        0x000002F1
    };

    static _CharacterInfo _character000002F2 =
    {
        0x000002F2,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F2,
        0x000002F2,
        0x000002F2
    };

    static _CharacterInfo _character000002F3 =
    {
        0x000002F3,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F3,
        0x000002F3,
        0x000002F3
    };

    static _CharacterInfo _character000002F4 =
    {
        0x000002F4,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F4,
        0x000002F4,
        0x000002F4
    };

    static _CharacterInfo _character000002F5 =
    {
        0x000002F5,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F5,
        0x000002F5,
        0x000002F5
    };

    static _CharacterInfo _character000002F6 =
    {
        0x000002F6,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F6,
        0x000002F6,
        0x000002F6
    };

    static _CharacterInfo _character000002F7 =
    {
        0x000002F7,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F7,
        0x000002F7,
        0x000002F7
    };

    static _CharacterInfo _character000002F8 =
    {
        0x000002F8,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F8,
        0x000002F8,
        0x000002F8
    };

    static _CharacterInfo _character000002F9 =
    {
        0x000002F9,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002F9,
        0x000002F9,
        0x000002F9
    };

    static _CharacterInfo _character000002FA =
    {
        0x000002FA,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FA,
        0x000002FA,
        0x000002FA
    };

    static _CharacterInfo _character000002FB =
    {
        0x000002FB,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FB,
        0x000002FB,
        0x000002FB
    };

    static _CharacterInfo _character000002FC =
    {
        0x000002FC,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FC,
        0x000002FC,
        0x000002FC
    };

    static _CharacterInfo _character000002FD =
    {
        0x000002FD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FD,
        0x000002FD,
        0x000002FD
    };

    static _CharacterInfo _character000002FE =
    {
        0x000002FE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FE,
        0x000002FE,
        0x000002FE
    };

    static _CharacterInfo _character000002FF =
    {
        0x000002FF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000002FF,
        0x000002FF,
        0x000002FF
    };

    static _CharacterInfo _character00000300 =
    {
        0x00000300,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000300,
        0x00000300,
        0x00000300
    };

    static _CharacterInfo _character00000301 =
    {
        0x00000301,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000301,
        0x00000301,
        0x00000301
    };

    static _CharacterInfo _character00000302 =
    {
        0x00000302,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000302,
        0x00000302,
        0x00000302
    };

    static _CharacterInfo _character00000303 =
    {
        0x00000303,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000303,
        0x00000303,
        0x00000303
    };

    static _CharacterInfo _character00000304 =
    {
        0x00000304,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000304,
        0x00000304,
        0x00000304
    };

    static _CharacterInfo _character00000305 =
    {
        0x00000305,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000305,
        0x00000305,
        0x00000305
    };

    static _CharacterInfo _character00000306 =
    {
        0x00000306,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000306,
        0x00000306,
        0x00000306
    };

    static _CharacterInfo _character00000307 =
    {
        0x00000307,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000307,
        0x00000307,
        0x00000307
    };

    static _CharacterInfo _character00000308 =
    {
        0x00000308,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000308,
        0x00000308,
        0x00000308
    };

    static _CharacterInfo _character00000309 =
    {
        0x00000309,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000309,
        0x00000309,
        0x00000309
    };

    static _CharacterInfo _character0000030A =
    {
        0x0000030A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030A,
        0x0000030A,
        0x0000030A
    };

    static _CharacterInfo _character0000030B =
    {
        0x0000030B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030B,
        0x0000030B,
        0x0000030B
    };

    static _CharacterInfo _character0000030C =
    {
        0x0000030C,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030C,
        0x0000030C,
        0x0000030C
    };

    static _CharacterInfo _character0000030D =
    {
        0x0000030D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030D,
        0x0000030D,
        0x0000030D
    };

    static _CharacterInfo _character0000030E =
    {
        0x0000030E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030E,
        0x0000030E,
        0x0000030E
    };

    static _CharacterInfo _character0000030F =
    {
        0x0000030F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000030F,
        0x0000030F,
        0x0000030F
    };

    static _CharacterInfo _character00000310 =
    {
        0x00000310,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000310,
        0x00000310,
        0x00000310
    };

    static _CharacterInfo _character00000311 =
    {
        0x00000311,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000311,
        0x00000311,
        0x00000311
    };

    static _CharacterInfo _character00000312 =
    {
        0x00000312,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000312,
        0x00000312,
        0x00000312
    };

    static _CharacterInfo _character00000313 =
    {
        0x00000313,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000313,
        0x00000313,
        0x00000313
    };

    static _CharacterInfo _character00000314 =
    {
        0x00000314,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000314,
        0x00000314,
        0x00000314
    };

    static _CharacterInfo _character00000315 =
    {
        0x00000315,
        Iso10646::GeneralCategory_Mn,
        232,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000315,
        0x00000315,
        0x00000315
    };

    static _CharacterInfo _character00000316 =
    {
        0x00000316,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000316,
        0x00000316,
        0x00000316
    };

    static _CharacterInfo _character00000317 =
    {
        0x00000317,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000317,
        0x00000317,
        0x00000317
    };

    static _CharacterInfo _character00000318 =
    {
        0x00000318,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000318,
        0x00000318,
        0x00000318
    };

    static _CharacterInfo _character00000319 =
    {
        0x00000319,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000319,
        0x00000319,
        0x00000319
    };

    static _CharacterInfo _character0000031A =
    {
        0x0000031A,
        Iso10646::GeneralCategory_Mn,
        232,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031A,
        0x0000031A,
        0x0000031A
    };

    static _CharacterInfo _character0000031B =
    {
        0x0000031B,
        Iso10646::GeneralCategory_Mn,
        216,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031B,
        0x0000031B,
        0x0000031B
    };

    static _CharacterInfo _character0000031C =
    {
        0x0000031C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031C,
        0x0000031C,
        0x0000031C
    };

    static _CharacterInfo _character0000031D =
    {
        0x0000031D,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031D,
        0x0000031D,
        0x0000031D
    };

    static _CharacterInfo _character0000031E =
    {
        0x0000031E,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031E,
        0x0000031E,
        0x0000031E
    };

    static _CharacterInfo _character0000031F =
    {
        0x0000031F,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000031F,
        0x0000031F,
        0x0000031F
    };

    static _CharacterInfo _character00000320 =
    {
        0x00000320,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000320,
        0x00000320,
        0x00000320
    };

    static _CharacterInfo _character00000321 =
    {
        0x00000321,
        Iso10646::GeneralCategory_Mn,
        202,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000321,
        0x00000321,
        0x00000321
    };

    static _CharacterInfo _character00000322 =
    {
        0x00000322,
        Iso10646::GeneralCategory_Mn,
        202,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000322,
        0x00000322,
        0x00000322
    };

    static _CharacterInfo _character00000323 =
    {
        0x00000323,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000323,
        0x00000323,
        0x00000323
    };

    static _CharacterInfo _character00000324 =
    {
        0x00000324,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000324,
        0x00000324,
        0x00000324
    };

    static _CharacterInfo _character00000325 =
    {
        0x00000325,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000325,
        0x00000325,
        0x00000325
    };

    static _CharacterInfo _character00000326 =
    {
        0x00000326,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000326,
        0x00000326,
        0x00000326
    };

    static _CharacterInfo _character00000327 =
    {
        0x00000327,
        Iso10646::GeneralCategory_Mn,
        202,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000327,
        0x00000327,
        0x00000327
    };

    static _CharacterInfo _character00000328 =
    {
        0x00000328,
        Iso10646::GeneralCategory_Mn,
        202,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000328,
        0x00000328,
        0x00000328
    };

    static _CharacterInfo _character00000329 =
    {
        0x00000329,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000329,
        0x00000329,
        0x00000329
    };

    static _CharacterInfo _character0000032A =
    {
        0x0000032A,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032A,
        0x0000032A,
        0x0000032A
    };

    static _CharacterInfo _character0000032B =
    {
        0x0000032B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032B,
        0x0000032B,
        0x0000032B
    };

    static _CharacterInfo _character0000032C =
    {
        0x0000032C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032C,
        0x0000032C,
        0x0000032C
    };

    static _CharacterInfo _character0000032D =
    {
        0x0000032D,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032D,
        0x0000032D,
        0x0000032D
    };

    static _CharacterInfo _character0000032E =
    {
        0x0000032E,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032E,
        0x0000032E,
        0x0000032E
    };

    static _CharacterInfo _character0000032F =
    {
        0x0000032F,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000032F,
        0x0000032F,
        0x0000032F
    };

    static _CharacterInfo _character00000330 =
    {
        0x00000330,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000330,
        0x00000330,
        0x00000330
    };

    static _CharacterInfo _character00000331 =
    {
        0x00000331,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000331,
        0x00000331,
        0x00000331
    };

    static _CharacterInfo _character00000332 =
    {
        0x00000332,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000332,
        0x00000332,
        0x00000332
    };

    static _CharacterInfo _character00000333 =
    {
        0x00000333,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000333,
        0x00000333,
        0x00000333
    };

    static _CharacterInfo _character00000334 =
    {
        0x00000334,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000334,
        0x00000334,
        0x00000334
    };

    static _CharacterInfo _character00000335 =
    {
        0x00000335,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000335,
        0x00000335,
        0x00000335
    };

    static _CharacterInfo _character00000336 =
    {
        0x00000336,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000336,
        0x00000336,
        0x00000336
    };

    static _CharacterInfo _character00000337 =
    {
        0x00000337,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000337,
        0x00000337,
        0x00000337
    };

    static _CharacterInfo _character00000338 =
    {
        0x00000338,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000338,
        0x00000338,
        0x00000338
    };

    static _CharacterInfo _character00000339 =
    {
        0x00000339,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000339,
        0x00000339,
        0x00000339
    };

    static _CharacterInfo _character0000033A =
    {
        0x0000033A,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033A,
        0x0000033A,
        0x0000033A
    };

    static _CharacterInfo _character0000033B =
    {
        0x0000033B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033B,
        0x0000033B,
        0x0000033B
    };

    static _CharacterInfo _character0000033C =
    {
        0x0000033C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033C,
        0x0000033C,
        0x0000033C
    };

    static _CharacterInfo _character0000033D =
    {
        0x0000033D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033D,
        0x0000033D,
        0x0000033D
    };

    static _CharacterInfo _character0000033E =
    {
        0x0000033E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033E,
        0x0000033E,
        0x0000033E
    };

    static _CharacterInfo _character0000033F =
    {
        0x0000033F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000033F,
        0x0000033F,
        0x0000033F
    };

    static Char _decompositionMapping00000340[] = 
    {
        0x00000300
    };

    static _CharacterInfo _character00000340 =
    {
        0x00000340,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00000340,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000340,
        0x00000340,
        0x00000340
    };

    static Char _decompositionMapping00000341[] = 
    {
        0x00000301
    };

    static _CharacterInfo _character00000341 =
    {
        0x00000341,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00000341,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000341,
        0x00000341,
        0x00000341
    };

    static _CharacterInfo _character00000342 =
    {
        0x00000342,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000342,
        0x00000342,
        0x00000342
    };

    static Char _decompositionMapping00000343[] = 
    {
        0x00000313
    };

    static _CharacterInfo _character00000343 =
    {
        0x00000343,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00000343,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000343,
        0x00000343,
        0x00000343
    };

    static Char _decompositionMapping00000344[] = 
    {
        0x00000308,
        0x00000301
    };

    static _CharacterInfo _character00000344 =
    {
        0x00000344,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000344,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000344,
        0x00000344,
        0x00000344
    };

    static _CharacterInfo _character00000345 =
    {
        0x00000345,
        Iso10646::GeneralCategory_Mn,
        240,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000399,
        0x00000345,
        0x00000399
    };

    static _CharacterInfo _character00000346 =
    {
        0x00000346,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000346,
        0x00000346,
        0x00000346
    };

    static _CharacterInfo _character00000347 =
    {
        0x00000347,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000347,
        0x00000347,
        0x00000347
    };

    static _CharacterInfo _character00000348 =
    {
        0x00000348,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000348,
        0x00000348,
        0x00000348
    };

    static _CharacterInfo _character00000349 =
    {
        0x00000349,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000349,
        0x00000349,
        0x00000349
    };

    static _CharacterInfo _character0000034A =
    {
        0x0000034A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034A,
        0x0000034A,
        0x0000034A
    };

    static _CharacterInfo _character0000034B =
    {
        0x0000034B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034B,
        0x0000034B,
        0x0000034B
    };

    static _CharacterInfo _character0000034C =
    {
        0x0000034C,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034C,
        0x0000034C,
        0x0000034C
    };

    static _CharacterInfo _character0000034D =
    {
        0x0000034D,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034D,
        0x0000034D,
        0x0000034D
    };

    static _CharacterInfo _character0000034E =
    {
        0x0000034E,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034E,
        0x0000034E,
        0x0000034E
    };

    static _CharacterInfo _character0000034F =
    {
        0x0000034F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000034F,
        0x0000034F,
        0x0000034F
    };

    static _CharacterInfo _character00000350 =
    {
        0x00000350,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000350,
        0x00000350,
        0x00000350
    };

    static _CharacterInfo _character00000351 =
    {
        0x00000351,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000351,
        0x00000351,
        0x00000351
    };

    static _CharacterInfo _character00000352 =
    {
        0x00000352,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000352,
        0x00000352,
        0x00000352
    };

    static _CharacterInfo _character00000353 =
    {
        0x00000353,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000353,
        0x00000353,
        0x00000353
    };

    static _CharacterInfo _character00000354 =
    {
        0x00000354,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000354,
        0x00000354,
        0x00000354
    };

    static _CharacterInfo _character00000355 =
    {
        0x00000355,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000355,
        0x00000355,
        0x00000355
    };

    static _CharacterInfo _character00000356 =
    {
        0x00000356,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000356,
        0x00000356,
        0x00000356
    };

    static _CharacterInfo _character00000357 =
    {
        0x00000357,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000357,
        0x00000357,
        0x00000357
    };

    static _CharacterInfo _character00000358 =
    {
        0x00000358,
        Iso10646::GeneralCategory_Mn,
        232,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000358,
        0x00000358,
        0x00000358
    };

    static _CharacterInfo _character00000359 =
    {
        0x00000359,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000359,
        0x00000359,
        0x00000359
    };

    static _CharacterInfo _character0000035A =
    {
        0x0000035A,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035A,
        0x0000035A,
        0x0000035A
    };

    static _CharacterInfo _character0000035B =
    {
        0x0000035B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035B,
        0x0000035B,
        0x0000035B
    };

    static _CharacterInfo _character0000035C =
    {
        0x0000035C,
        Iso10646::GeneralCategory_Mn,
        233,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035C,
        0x0000035C,
        0x0000035C
    };

    static _CharacterInfo _character0000035D =
    {
        0x0000035D,
        Iso10646::GeneralCategory_Mn,
        234,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035D,
        0x0000035D,
        0x0000035D
    };

    static _CharacterInfo _character0000035E =
    {
        0x0000035E,
        Iso10646::GeneralCategory_Mn,
        234,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035E,
        0x0000035E,
        0x0000035E
    };

    static _CharacterInfo _character0000035F =
    {
        0x0000035F,
        Iso10646::GeneralCategory_Mn,
        233,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000035F,
        0x0000035F,
        0x0000035F
    };

    static _CharacterInfo _character00000360 =
    {
        0x00000360,
        Iso10646::GeneralCategory_Mn,
        234,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000360,
        0x00000360,
        0x00000360
    };

    static _CharacterInfo _character00000361 =
    {
        0x00000361,
        Iso10646::GeneralCategory_Mn,
        234,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000361,
        0x00000361,
        0x00000361
    };

    static _CharacterInfo _character00000362 =
    {
        0x00000362,
        Iso10646::GeneralCategory_Mn,
        233,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000362,
        0x00000362,
        0x00000362
    };

    static _CharacterInfo _character00000363 =
    {
        0x00000363,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000363,
        0x00000363,
        0x00000363
    };

    static _CharacterInfo _character00000364 =
    {
        0x00000364,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000364,
        0x00000364,
        0x00000364
    };

    static _CharacterInfo _character00000365 =
    {
        0x00000365,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000365,
        0x00000365,
        0x00000365
    };

    static _CharacterInfo _character00000366 =
    {
        0x00000366,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000366,
        0x00000366,
        0x00000366
    };

    static _CharacterInfo _character00000367 =
    {
        0x00000367,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000367,
        0x00000367,
        0x00000367
    };

    static _CharacterInfo _character00000368 =
    {
        0x00000368,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000368,
        0x00000368,
        0x00000368
    };

    static _CharacterInfo _character00000369 =
    {
        0x00000369,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000369,
        0x00000369,
        0x00000369
    };

    static _CharacterInfo _character0000036A =
    {
        0x0000036A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036A,
        0x0000036A,
        0x0000036A
    };

    static _CharacterInfo _character0000036B =
    {
        0x0000036B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036B,
        0x0000036B,
        0x0000036B
    };

    static _CharacterInfo _character0000036C =
    {
        0x0000036C,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036C,
        0x0000036C,
        0x0000036C
    };

    static _CharacterInfo _character0000036D =
    {
        0x0000036D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036D,
        0x0000036D,
        0x0000036D
    };

    static _CharacterInfo _character0000036E =
    {
        0x0000036E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036E,
        0x0000036E,
        0x0000036E
    };

    static _CharacterInfo _character0000036F =
    {
        0x0000036F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000036F,
        0x0000036F,
        0x0000036F
    };

    static Char _decompositionMapping00000374[] = 
    {
        0x000002B9
    };

    static _CharacterInfo _character00000374 =
    {
        0x00000374,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00000374,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000374,
        0x00000374,
        0x00000374
    };

    static _CharacterInfo _character00000375 =
    {
        0x00000375,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000375,
        0x00000375,
        0x00000375
    };

    static Char _decompositionMapping0000037A[] = 
    {
        0x00000020,
        0x00000345
    };

    static _CharacterInfo _character0000037A =
    {
        0x0000037A,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000037A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000037A,
        0x0000037A,
        0x0000037A
    };

    static _CharacterInfo _character0000037B =
    {
        0x0000037B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FD,
        0x0000037B,
        0x000003FD
    };

    static _CharacterInfo _character0000037C =
    {
        0x0000037C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FE,
        0x0000037C,
        0x000003FE
    };

    static _CharacterInfo _character0000037D =
    {
        0x0000037D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FF,
        0x0000037D,
        0x000003FF
    };

    static Char _decompositionMapping0000037E[] = 
    {
        0x0000003B
    };

    static _CharacterInfo _character0000037E =
    {
        0x0000037E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000037E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000037E,
        0x0000037E,
        0x0000037E
    };

    static Char _decompositionMapping00000384[] = 
    {
        0x00000020,
        0x00000301
    };

    static _CharacterInfo _character00000384 =
    {
        0x00000384,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000384,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000384,
        0x00000384,
        0x00000384
    };

    static Char _decompositionMapping00000385[] = 
    {
        0x000000A8,
        0x00000301
    };

    static _CharacterInfo _character00000385 =
    {
        0x00000385,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000385,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000385,
        0x00000385,
        0x00000385
    };

    static Char _decompositionMapping00000386[] = 
    {
        0x00000391,
        0x00000301
    };

    static _CharacterInfo _character00000386 =
    {
        0x00000386,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000386,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000386,
        0x000003AC,
        0x00000386
    };

    static Char _decompositionMapping00000387[] = 
    {
        0x000000B7
    };

    static _CharacterInfo _character00000387 =
    {
        0x00000387,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00000387,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000387,
        0x00000387,
        0x00000387
    };

    static Char _decompositionMapping00000388[] = 
    {
        0x00000395,
        0x00000301
    };

    static _CharacterInfo _character00000388 =
    {
        0x00000388,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000388,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000388,
        0x000003AD,
        0x00000388
    };

    static Char _decompositionMapping00000389[] = 
    {
        0x00000397,
        0x00000301
    };

    static _CharacterInfo _character00000389 =
    {
        0x00000389,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000389,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000389,
        0x000003AE,
        0x00000389
    };

    static Char _decompositionMapping0000038A[] = 
    {
        0x00000399,
        0x00000301
    };

    static _CharacterInfo _character0000038A =
    {
        0x0000038A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000038A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038A,
        0x000003AF,
        0x0000038A
    };

    static Char _decompositionMapping0000038C[] = 
    {
        0x0000039F,
        0x00000301
    };

    static _CharacterInfo _character0000038C =
    {
        0x0000038C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000038C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038C,
        0x000003CC,
        0x0000038C
    };

    static Char _decompositionMapping0000038E[] = 
    {
        0x000003A5,
        0x00000301
    };

    static _CharacterInfo _character0000038E =
    {
        0x0000038E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000038E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038E,
        0x000003CD,
        0x0000038E
    };

    static Char _decompositionMapping0000038F[] = 
    {
        0x000003A9,
        0x00000301
    };

    static _CharacterInfo _character0000038F =
    {
        0x0000038F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000038F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038F,
        0x000003CE,
        0x0000038F
    };

    static Char _decompositionMapping00000390[] = 
    {
        0x000003CA,
        0x00000301
    };

    static _CharacterInfo _character00000390 =
    {
        0x00000390,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000390,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000390,
        0x00000390,
        0x00000390
    };

    static _CharacterInfo _character00000391 =
    {
        0x00000391,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000391,
        0x000003B1,
        0x00000391
    };

    static _CharacterInfo _character00000392 =
    {
        0x00000392,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000392,
        0x000003B2,
        0x00000392
    };

    static _CharacterInfo _character00000393 =
    {
        0x00000393,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000393,
        0x000003B3,
        0x00000393
    };

    static _CharacterInfo _character00000394 =
    {
        0x00000394,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000394,
        0x000003B4,
        0x00000394
    };

    static _CharacterInfo _character00000395 =
    {
        0x00000395,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000395,
        0x000003B5,
        0x00000395
    };

    static _CharacterInfo _character00000396 =
    {
        0x00000396,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000396,
        0x000003B6,
        0x00000396
    };

    static _CharacterInfo _character00000397 =
    {
        0x00000397,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000397,
        0x000003B7,
        0x00000397
    };

    static _CharacterInfo _character00000398 =
    {
        0x00000398,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000398,
        0x000003B8,
        0x00000398
    };

    static _CharacterInfo _character00000399 =
    {
        0x00000399,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000399,
        0x000003B9,
        0x00000399
    };

    static _CharacterInfo _character0000039A =
    {
        0x0000039A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039A,
        0x000003BA,
        0x0000039A
    };

    static _CharacterInfo _character0000039B =
    {
        0x0000039B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039B,
        0x000003BB,
        0x0000039B
    };

    static _CharacterInfo _character0000039C =
    {
        0x0000039C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039C,
        0x000003BC,
        0x0000039C
    };

    static _CharacterInfo _character0000039D =
    {
        0x0000039D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039D,
        0x000003BD,
        0x0000039D
    };

    static _CharacterInfo _character0000039E =
    {
        0x0000039E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039E,
        0x000003BE,
        0x0000039E
    };

    static _CharacterInfo _character0000039F =
    {
        0x0000039F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039F,
        0x000003BF,
        0x0000039F
    };

    static _CharacterInfo _character000003A0 =
    {
        0x000003A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A0,
        0x000003C0,
        0x000003A0
    };

    static _CharacterInfo _character000003A1 =
    {
        0x000003A1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A1,
        0x000003C1,
        0x000003A1
    };

    static _CharacterInfo _character000003A3 =
    {
        0x000003A3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A3,
        0x000003C3,
        0x000003A3
    };

    static _CharacterInfo _character000003A4 =
    {
        0x000003A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A4,
        0x000003C4,
        0x000003A4
    };

    static _CharacterInfo _character000003A5 =
    {
        0x000003A5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A5,
        0x000003C5,
        0x000003A5
    };

    static _CharacterInfo _character000003A6 =
    {
        0x000003A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A6,
        0x000003C6,
        0x000003A6
    };

    static _CharacterInfo _character000003A7 =
    {
        0x000003A7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A7,
        0x000003C7,
        0x000003A7
    };

    static _CharacterInfo _character000003A8 =
    {
        0x000003A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A8,
        0x000003C8,
        0x000003A8
    };

    static _CharacterInfo _character000003A9 =
    {
        0x000003A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A9,
        0x000003C9,
        0x000003A9
    };

    static Char _decompositionMapping000003AA[] = 
    {
        0x00000399,
        0x00000308
    };

    static _CharacterInfo _character000003AA =
    {
        0x000003AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003AA,
        0x000003CA,
        0x000003AA
    };

    static Char _decompositionMapping000003AB[] = 
    {
        0x000003A5,
        0x00000308
    };

    static _CharacterInfo _character000003AB =
    {
        0x000003AB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003AB,
        0x000003CB,
        0x000003AB
    };

    static Char _decompositionMapping000003AC[] = 
    {
        0x000003B1,
        0x00000301
    };

    static _CharacterInfo _character000003AC =
    {
        0x000003AC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000386,
        0x000003AC,
        0x00000386
    };

    static Char _decompositionMapping000003AD[] = 
    {
        0x000003B5,
        0x00000301
    };

    static _CharacterInfo _character000003AD =
    {
        0x000003AD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000388,
        0x000003AD,
        0x00000388
    };

    static Char _decompositionMapping000003AE[] = 
    {
        0x000003B7,
        0x00000301
    };

    static _CharacterInfo _character000003AE =
    {
        0x000003AE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000389,
        0x000003AE,
        0x00000389
    };

    static Char _decompositionMapping000003AF[] = 
    {
        0x000003B9,
        0x00000301
    };

    static _CharacterInfo _character000003AF =
    {
        0x000003AF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038A,
        0x000003AF,
        0x0000038A
    };

    static Char _decompositionMapping000003B0[] = 
    {
        0x000003CB,
        0x00000301
    };

    static _CharacterInfo _character000003B0 =
    {
        0x000003B0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003B0,
        0x000003B0,
        0x000003B0
    };

    static _CharacterInfo _character000003B1 =
    {
        0x000003B1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000391,
        0x000003B1,
        0x00000391
    };

    static _CharacterInfo _character000003B2 =
    {
        0x000003B2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000392,
        0x000003B2,
        0x00000392
    };

    static _CharacterInfo _character000003B3 =
    {
        0x000003B3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000393,
        0x000003B3,
        0x00000393
    };

    static _CharacterInfo _character000003B4 =
    {
        0x000003B4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000394,
        0x000003B4,
        0x00000394
    };

    static _CharacterInfo _character000003B5 =
    {
        0x000003B5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000395,
        0x000003B5,
        0x00000395
    };

    static _CharacterInfo _character000003B6 =
    {
        0x000003B6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000396,
        0x000003B6,
        0x00000396
    };

    static _CharacterInfo _character000003B7 =
    {
        0x000003B7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000397,
        0x000003B7,
        0x00000397
    };

    static _CharacterInfo _character000003B8 =
    {
        0x000003B8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000398,
        0x000003B8,
        0x00000398
    };

    static _CharacterInfo _character000003B9 =
    {
        0x000003B9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000399,
        0x000003B9,
        0x00000399
    };

    static _CharacterInfo _character000003BA =
    {
        0x000003BA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039A,
        0x000003BA,
        0x0000039A
    };

    static _CharacterInfo _character000003BB =
    {
        0x000003BB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039B,
        0x000003BB,
        0x0000039B
    };

    static _CharacterInfo _character000003BC =
    {
        0x000003BC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039C,
        0x000003BC,
        0x0000039C
    };

    static _CharacterInfo _character000003BD =
    {
        0x000003BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039D,
        0x000003BD,
        0x0000039D
    };

    static _CharacterInfo _character000003BE =
    {
        0x000003BE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039E,
        0x000003BE,
        0x0000039E
    };

    static _CharacterInfo _character000003BF =
    {
        0x000003BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039F,
        0x000003BF,
        0x0000039F
    };

    static _CharacterInfo _character000003C0 =
    {
        0x000003C0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A0,
        0x000003C0,
        0x000003A0
    };

    static _CharacterInfo _character000003C1 =
    {
        0x000003C1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A1,
        0x000003C1,
        0x000003A1
    };

    static _CharacterInfo _character000003C2 =
    {
        0x000003C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A3,
        0x000003C2,
        0x000003A3
    };

    static _CharacterInfo _character000003C3 =
    {
        0x000003C3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A3,
        0x000003C3,
        0x000003A3
    };

    static _CharacterInfo _character000003C4 =
    {
        0x000003C4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A4,
        0x000003C4,
        0x000003A4
    };

    static _CharacterInfo _character000003C5 =
    {
        0x000003C5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A5,
        0x000003C5,
        0x000003A5
    };

    static _CharacterInfo _character000003C6 =
    {
        0x000003C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A6,
        0x000003C6,
        0x000003A6
    };

    static _CharacterInfo _character000003C7 =
    {
        0x000003C7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A7,
        0x000003C7,
        0x000003A7
    };

    static _CharacterInfo _character000003C8 =
    {
        0x000003C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A8,
        0x000003C8,
        0x000003A8
    };

    static _CharacterInfo _character000003C9 =
    {
        0x000003C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A9,
        0x000003C9,
        0x000003A9
    };

    static Char _decompositionMapping000003CA[] = 
    {
        0x000003B9,
        0x00000308
    };

    static _CharacterInfo _character000003CA =
    {
        0x000003CA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003AA,
        0x000003CA,
        0x000003AA
    };

    static Char _decompositionMapping000003CB[] = 
    {
        0x000003C5,
        0x00000308
    };

    static _CharacterInfo _character000003CB =
    {
        0x000003CB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003AB,
        0x000003CB,
        0x000003AB
    };

    static Char _decompositionMapping000003CC[] = 
    {
        0x000003BF,
        0x00000301
    };

    static _CharacterInfo _character000003CC =
    {
        0x000003CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038C,
        0x000003CC,
        0x0000038C
    };

    static Char _decompositionMapping000003CD[] = 
    {
        0x000003C5,
        0x00000301
    };

    static _CharacterInfo _character000003CD =
    {
        0x000003CD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038E,
        0x000003CD,
        0x0000038E
    };

    static Char _decompositionMapping000003CE[] = 
    {
        0x000003C9,
        0x00000301
    };

    static _CharacterInfo _character000003CE =
    {
        0x000003CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000038F,
        0x000003CE,
        0x0000038F
    };

    static Char _decompositionMapping000003D0[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character000003D0 =
    {
        0x000003D0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000392,
        0x000003D0,
        0x00000392
    };

    static Char _decompositionMapping000003D1[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character000003D1 =
    {
        0x000003D1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000398,
        0x000003D1,
        0x00000398
    };

    static Char _decompositionMapping000003D2[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character000003D2 =
    {
        0x000003D2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D2,
        0x000003D2,
        0x000003D2
    };

    static Char _decompositionMapping000003D3[] = 
    {
        0x000003D2,
        0x00000301
    };

    static _CharacterInfo _character000003D3 =
    {
        0x000003D3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D3,
        0x000003D3,
        0x000003D3
    };

    static Char _decompositionMapping000003D4[] = 
    {
        0x000003D2,
        0x00000308
    };

    static _CharacterInfo _character000003D4 =
    {
        0x000003D4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000003D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D4,
        0x000003D4,
        0x000003D4
    };

    static Char _decompositionMapping000003D5[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character000003D5 =
    {
        0x000003D5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A6,
        0x000003D5,
        0x000003A6
    };

    static Char _decompositionMapping000003D6[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character000003D6 =
    {
        0x000003D6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A0,
        0x000003D6,
        0x000003A0
    };

    static _CharacterInfo _character000003D7 =
    {
        0x000003D7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D7,
        0x000003D7,
        0x000003D7
    };

    static _CharacterInfo _character000003D8 =
    {
        0x000003D8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D8,
        0x000003D9,
        0x000003D8
    };

    static _CharacterInfo _character000003D9 =
    {
        0x000003D9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003D8,
        0x000003D9,
        0x000003D8
    };

    static _CharacterInfo _character000003DA =
    {
        0x000003DA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DA,
        0x000003DB,
        0x000003DA
    };

    static _CharacterInfo _character000003DB =
    {
        0x000003DB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DA,
        0x000003DB,
        0x000003DA
    };

    static _CharacterInfo _character000003DC =
    {
        0x000003DC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DC,
        0x000003DD,
        0x000003DC
    };

    static _CharacterInfo _character000003DD =
    {
        0x000003DD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DC,
        0x000003DD,
        0x000003DC
    };

    static _CharacterInfo _character000003DE =
    {
        0x000003DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DE,
        0x000003DF,
        0x000003DE
    };

    static _CharacterInfo _character000003DF =
    {
        0x000003DF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003DE,
        0x000003DF,
        0x000003DE
    };

    static _CharacterInfo _character000003E0 =
    {
        0x000003E0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E0,
        0x000003E1,
        0x000003E0
    };

    static _CharacterInfo _character000003E1 =
    {
        0x000003E1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E0,
        0x000003E1,
        0x000003E0
    };

    static _CharacterInfo _character000003E2 =
    {
        0x000003E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E2,
        0x000003E3,
        0x000003E2
    };

    static _CharacterInfo _character000003E3 =
    {
        0x000003E3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E2,
        0x000003E3,
        0x000003E2
    };

    static _CharacterInfo _character000003E4 =
    {
        0x000003E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E4,
        0x000003E5,
        0x000003E4
    };

    static _CharacterInfo _character000003E5 =
    {
        0x000003E5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E4,
        0x000003E5,
        0x000003E4
    };

    static _CharacterInfo _character000003E6 =
    {
        0x000003E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E6,
        0x000003E7,
        0x000003E6
    };

    static _CharacterInfo _character000003E7 =
    {
        0x000003E7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E6,
        0x000003E7,
        0x000003E6
    };

    static _CharacterInfo _character000003E8 =
    {
        0x000003E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E8,
        0x000003E9,
        0x000003E8
    };

    static _CharacterInfo _character000003E9 =
    {
        0x000003E9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003E8,
        0x000003E9,
        0x000003E8
    };

    static _CharacterInfo _character000003EA =
    {
        0x000003EA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EA,
        0x000003EB,
        0x000003EA
    };

    static _CharacterInfo _character000003EB =
    {
        0x000003EB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EA,
        0x000003EB,
        0x000003EA
    };

    static _CharacterInfo _character000003EC =
    {
        0x000003EC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EC,
        0x000003ED,
        0x000003EC
    };

    static _CharacterInfo _character000003ED =
    {
        0x000003ED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EC,
        0x000003ED,
        0x000003EC
    };

    static _CharacterInfo _character000003EE =
    {
        0x000003EE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EE,
        0x000003EF,
        0x000003EE
    };

    static _CharacterInfo _character000003EF =
    {
        0x000003EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003EE,
        0x000003EF,
        0x000003EE
    };

    static Char _decompositionMapping000003F0[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character000003F0 =
    {
        0x000003F0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000039A,
        0x000003F0,
        0x0000039A
    };

    static Char _decompositionMapping000003F1[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character000003F1 =
    {
        0x000003F1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003A1,
        0x000003F1,
        0x000003A1
    };

    static Char _decompositionMapping000003F2[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character000003F2 =
    {
        0x000003F2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F9,
        0x000003F2,
        0x000003F9
    };

    static _CharacterInfo _character000003F3 =
    {
        0x000003F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F3,
        0x000003F3,
        0x000003F3
    };

    static Char _decompositionMapping000003F4[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character000003F4 =
    {
        0x000003F4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F4,
        0x000003B8,
        0x000003F4
    };

    static Char _decompositionMapping000003F5[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character000003F5 =
    {
        0x000003F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000395,
        0x000003F5,
        0x00000395
    };

    static _CharacterInfo _character000003F6 =
    {
        0x000003F6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F6,
        0x000003F6,
        0x000003F6
    };

    static _CharacterInfo _character000003F7 =
    {
        0x000003F7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F7,
        0x000003F8,
        0x000003F7
    };

    static _CharacterInfo _character000003F8 =
    {
        0x000003F8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F7,
        0x000003F8,
        0x000003F7
    };

    static Char _decompositionMapping000003F9[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character000003F9 =
    {
        0x000003F9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping000003F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003F9,
        0x000003F2,
        0x000003F9
    };

    static _CharacterInfo _character000003FA =
    {
        0x000003FA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FA,
        0x000003FB,
        0x000003FA
    };

    static _CharacterInfo _character000003FB =
    {
        0x000003FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FA,
        0x000003FB,
        0x000003FA
    };

    static _CharacterInfo _character000003FC =
    {
        0x000003FC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FC,
        0x000003FC,
        0x000003FC
    };

    static _CharacterInfo _character000003FD =
    {
        0x000003FD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FD,
        0x0000037B,
        0x000003FD
    };

    static _CharacterInfo _character000003FE =
    {
        0x000003FE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FE,
        0x0000037C,
        0x000003FE
    };

    static _CharacterInfo _character000003FF =
    {
        0x000003FF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000003FF,
        0x0000037D,
        0x000003FF
    };

    static Char _decompositionMapping00000400[] = 
    {
        0x00000415,
        0x00000300
    };

    static _CharacterInfo _character00000400 =
    {
        0x00000400,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000400,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000400,
        0x00000450,
        0x00000400
    };

    static Char _decompositionMapping00000401[] = 
    {
        0x00000415,
        0x00000308
    };

    static _CharacterInfo _character00000401 =
    {
        0x00000401,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000401,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000401,
        0x00000451,
        0x00000401
    };

    static _CharacterInfo _character00000402 =
    {
        0x00000402,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000402,
        0x00000452,
        0x00000402
    };

    static Char _decompositionMapping00000403[] = 
    {
        0x00000413,
        0x00000301
    };

    static _CharacterInfo _character00000403 =
    {
        0x00000403,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000403,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000403,
        0x00000453,
        0x00000403
    };

    static _CharacterInfo _character00000404 =
    {
        0x00000404,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000404,
        0x00000454,
        0x00000404
    };

    static _CharacterInfo _character00000405 =
    {
        0x00000405,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000405,
        0x00000455,
        0x00000405
    };

    static _CharacterInfo _character00000406 =
    {
        0x00000406,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000406,
        0x00000456,
        0x00000406
    };

    static Char _decompositionMapping00000407[] = 
    {
        0x00000406,
        0x00000308
    };

    static _CharacterInfo _character00000407 =
    {
        0x00000407,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000407,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000407,
        0x00000457,
        0x00000407
    };

    static _CharacterInfo _character00000408 =
    {
        0x00000408,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000408,
        0x00000458,
        0x00000408
    };

    static _CharacterInfo _character00000409 =
    {
        0x00000409,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000409,
        0x00000459,
        0x00000409
    };

    static _CharacterInfo _character0000040A =
    {
        0x0000040A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040A,
        0x0000045A,
        0x0000040A
    };

    static _CharacterInfo _character0000040B =
    {
        0x0000040B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040B,
        0x0000045B,
        0x0000040B
    };

    static Char _decompositionMapping0000040C[] = 
    {
        0x0000041A,
        0x00000301
    };

    static _CharacterInfo _character0000040C =
    {
        0x0000040C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000040C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040C,
        0x0000045C,
        0x0000040C
    };

    static Char _decompositionMapping0000040D[] = 
    {
        0x00000418,
        0x00000300
    };

    static _CharacterInfo _character0000040D =
    {
        0x0000040D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000040D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040D,
        0x0000045D,
        0x0000040D
    };

    static Char _decompositionMapping0000040E[] = 
    {
        0x00000423,
        0x00000306
    };

    static _CharacterInfo _character0000040E =
    {
        0x0000040E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000040E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040E,
        0x0000045E,
        0x0000040E
    };

    static _CharacterInfo _character0000040F =
    {
        0x0000040F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040F,
        0x0000045F,
        0x0000040F
    };

    static _CharacterInfo _character00000410 =
    {
        0x00000410,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000410,
        0x00000430,
        0x00000410
    };

    static _CharacterInfo _character00000411 =
    {
        0x00000411,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000411,
        0x00000431,
        0x00000411
    };

    static _CharacterInfo _character00000412 =
    {
        0x00000412,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000412,
        0x00000432,
        0x00000412
    };

    static _CharacterInfo _character00000413 =
    {
        0x00000413,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000413,
        0x00000433,
        0x00000413
    };

    static _CharacterInfo _character00000414 =
    {
        0x00000414,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000414,
        0x00000434,
        0x00000414
    };

    static _CharacterInfo _character00000415 =
    {
        0x00000415,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000415,
        0x00000435,
        0x00000415
    };

    static _CharacterInfo _character00000416 =
    {
        0x00000416,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000416,
        0x00000436,
        0x00000416
    };

    static _CharacterInfo _character00000417 =
    {
        0x00000417,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000417,
        0x00000437,
        0x00000417
    };

    static _CharacterInfo _character00000418 =
    {
        0x00000418,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000418,
        0x00000438,
        0x00000418
    };

    static Char _decompositionMapping00000419[] = 
    {
        0x00000418,
        0x00000306
    };

    static _CharacterInfo _character00000419 =
    {
        0x00000419,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000419,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000419,
        0x00000439,
        0x00000419
    };

    static _CharacterInfo _character0000041A =
    {
        0x0000041A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041A,
        0x0000043A,
        0x0000041A
    };

    static _CharacterInfo _character0000041B =
    {
        0x0000041B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041B,
        0x0000043B,
        0x0000041B
    };

    static _CharacterInfo _character0000041C =
    {
        0x0000041C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041C,
        0x0000043C,
        0x0000041C
    };

    static _CharacterInfo _character0000041D =
    {
        0x0000041D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041D,
        0x0000043D,
        0x0000041D
    };

    static _CharacterInfo _character0000041E =
    {
        0x0000041E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041E,
        0x0000043E,
        0x0000041E
    };

    static _CharacterInfo _character0000041F =
    {
        0x0000041F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041F,
        0x0000043F,
        0x0000041F
    };

    static _CharacterInfo _character00000420 =
    {
        0x00000420,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000420,
        0x00000440,
        0x00000420
    };

    static _CharacterInfo _character00000421 =
    {
        0x00000421,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000421,
        0x00000441,
        0x00000421
    };

    static _CharacterInfo _character00000422 =
    {
        0x00000422,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000422,
        0x00000442,
        0x00000422
    };

    static _CharacterInfo _character00000423 =
    {
        0x00000423,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000423,
        0x00000443,
        0x00000423
    };

    static _CharacterInfo _character00000424 =
    {
        0x00000424,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000424,
        0x00000444,
        0x00000424
    };

    static _CharacterInfo _character00000425 =
    {
        0x00000425,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000425,
        0x00000445,
        0x00000425
    };

    static _CharacterInfo _character00000426 =
    {
        0x00000426,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000426,
        0x00000446,
        0x00000426
    };

    static _CharacterInfo _character00000427 =
    {
        0x00000427,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000427,
        0x00000447,
        0x00000427
    };

    static _CharacterInfo _character00000428 =
    {
        0x00000428,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000428,
        0x00000448,
        0x00000428
    };

    static _CharacterInfo _character00000429 =
    {
        0x00000429,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000429,
        0x00000449,
        0x00000429
    };

    static _CharacterInfo _character0000042A =
    {
        0x0000042A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042A,
        0x0000044A,
        0x0000042A
    };

    static _CharacterInfo _character0000042B =
    {
        0x0000042B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042B,
        0x0000044B,
        0x0000042B
    };

    static _CharacterInfo _character0000042C =
    {
        0x0000042C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042C,
        0x0000044C,
        0x0000042C
    };

    static _CharacterInfo _character0000042D =
    {
        0x0000042D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042D,
        0x0000044D,
        0x0000042D
    };

    static _CharacterInfo _character0000042E =
    {
        0x0000042E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042E,
        0x0000044E,
        0x0000042E
    };

    static _CharacterInfo _character0000042F =
    {
        0x0000042F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042F,
        0x0000044F,
        0x0000042F
    };

    static _CharacterInfo _character00000430 =
    {
        0x00000430,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000410,
        0x00000430,
        0x00000410
    };

    static _CharacterInfo _character00000431 =
    {
        0x00000431,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000411,
        0x00000431,
        0x00000411
    };

    static _CharacterInfo _character00000432 =
    {
        0x00000432,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000412,
        0x00000432,
        0x00000412
    };

    static _CharacterInfo _character00000433 =
    {
        0x00000433,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000413,
        0x00000433,
        0x00000413
    };

    static _CharacterInfo _character00000434 =
    {
        0x00000434,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000414,
        0x00000434,
        0x00000414
    };

    static _CharacterInfo _character00000435 =
    {
        0x00000435,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000415,
        0x00000435,
        0x00000415
    };

    static _CharacterInfo _character00000436 =
    {
        0x00000436,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000416,
        0x00000436,
        0x00000416
    };

    static _CharacterInfo _character00000437 =
    {
        0x00000437,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000417,
        0x00000437,
        0x00000417
    };

    static _CharacterInfo _character00000438 =
    {
        0x00000438,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000418,
        0x00000438,
        0x00000418
    };

    static Char _decompositionMapping00000439[] = 
    {
        0x00000438,
        0x00000306
    };

    static _CharacterInfo _character00000439 =
    {
        0x00000439,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000439,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000419,
        0x00000439,
        0x00000419
    };

    static _CharacterInfo _character0000043A =
    {
        0x0000043A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041A,
        0x0000043A,
        0x0000041A
    };

    static _CharacterInfo _character0000043B =
    {
        0x0000043B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041B,
        0x0000043B,
        0x0000041B
    };

    static _CharacterInfo _character0000043C =
    {
        0x0000043C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041C,
        0x0000043C,
        0x0000041C
    };

    static _CharacterInfo _character0000043D =
    {
        0x0000043D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041D,
        0x0000043D,
        0x0000041D
    };

    static _CharacterInfo _character0000043E =
    {
        0x0000043E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041E,
        0x0000043E,
        0x0000041E
    };

    static _CharacterInfo _character0000043F =
    {
        0x0000043F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000041F,
        0x0000043F,
        0x0000041F
    };

    static _CharacterInfo _character00000440 =
    {
        0x00000440,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000420,
        0x00000440,
        0x00000420
    };

    static _CharacterInfo _character00000441 =
    {
        0x00000441,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000421,
        0x00000441,
        0x00000421
    };

    static _CharacterInfo _character00000442 =
    {
        0x00000442,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000422,
        0x00000442,
        0x00000422
    };

    static _CharacterInfo _character00000443 =
    {
        0x00000443,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000423,
        0x00000443,
        0x00000423
    };

    static _CharacterInfo _character00000444 =
    {
        0x00000444,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000424,
        0x00000444,
        0x00000424
    };

    static _CharacterInfo _character00000445 =
    {
        0x00000445,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000425,
        0x00000445,
        0x00000425
    };

    static _CharacterInfo _character00000446 =
    {
        0x00000446,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000426,
        0x00000446,
        0x00000426
    };

    static _CharacterInfo _character00000447 =
    {
        0x00000447,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000427,
        0x00000447,
        0x00000427
    };

    static _CharacterInfo _character00000448 =
    {
        0x00000448,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000428,
        0x00000448,
        0x00000428
    };

    static _CharacterInfo _character00000449 =
    {
        0x00000449,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000429,
        0x00000449,
        0x00000429
    };

    static _CharacterInfo _character0000044A =
    {
        0x0000044A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042A,
        0x0000044A,
        0x0000042A
    };

    static _CharacterInfo _character0000044B =
    {
        0x0000044B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042B,
        0x0000044B,
        0x0000042B
    };

    static _CharacterInfo _character0000044C =
    {
        0x0000044C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042C,
        0x0000044C,
        0x0000042C
    };

    static _CharacterInfo _character0000044D =
    {
        0x0000044D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042D,
        0x0000044D,
        0x0000042D
    };

    static _CharacterInfo _character0000044E =
    {
        0x0000044E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042E,
        0x0000044E,
        0x0000042E
    };

    static _CharacterInfo _character0000044F =
    {
        0x0000044F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000042F,
        0x0000044F,
        0x0000042F
    };

    static Char _decompositionMapping00000450[] = 
    {
        0x00000435,
        0x00000300
    };

    static _CharacterInfo _character00000450 =
    {
        0x00000450,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000450,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000400,
        0x00000450,
        0x00000400
    };

    static Char _decompositionMapping00000451[] = 
    {
        0x00000435,
        0x00000308
    };

    static _CharacterInfo _character00000451 =
    {
        0x00000451,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000451,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000401,
        0x00000451,
        0x00000401
    };

    static _CharacterInfo _character00000452 =
    {
        0x00000452,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000402,
        0x00000452,
        0x00000402
    };

    static Char _decompositionMapping00000453[] = 
    {
        0x00000433,
        0x00000301
    };

    static _CharacterInfo _character00000453 =
    {
        0x00000453,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000453,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000403,
        0x00000453,
        0x00000403
    };

    static _CharacterInfo _character00000454 =
    {
        0x00000454,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000404,
        0x00000454,
        0x00000404
    };

    static _CharacterInfo _character00000455 =
    {
        0x00000455,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000405,
        0x00000455,
        0x00000405
    };

    static _CharacterInfo _character00000456 =
    {
        0x00000456,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000406,
        0x00000456,
        0x00000406
    };

    static Char _decompositionMapping00000457[] = 
    {
        0x00000456,
        0x00000308
    };

    static _CharacterInfo _character00000457 =
    {
        0x00000457,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000457,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000407,
        0x00000457,
        0x00000407
    };

    static _CharacterInfo _character00000458 =
    {
        0x00000458,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000408,
        0x00000458,
        0x00000408
    };

    static _CharacterInfo _character00000459 =
    {
        0x00000459,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000409,
        0x00000459,
        0x00000409
    };

    static _CharacterInfo _character0000045A =
    {
        0x0000045A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040A,
        0x0000045A,
        0x0000040A
    };

    static _CharacterInfo _character0000045B =
    {
        0x0000045B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040B,
        0x0000045B,
        0x0000040B
    };

    static Char _decompositionMapping0000045C[] = 
    {
        0x0000043A,
        0x00000301
    };

    static _CharacterInfo _character0000045C =
    {
        0x0000045C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000045C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040C,
        0x0000045C,
        0x0000040C
    };

    static Char _decompositionMapping0000045D[] = 
    {
        0x00000438,
        0x00000300
    };

    static _CharacterInfo _character0000045D =
    {
        0x0000045D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000045D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040D,
        0x0000045D,
        0x0000040D
    };

    static Char _decompositionMapping0000045E[] = 
    {
        0x00000443,
        0x00000306
    };

    static _CharacterInfo _character0000045E =
    {
        0x0000045E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000045E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040E,
        0x0000045E,
        0x0000040E
    };

    static _CharacterInfo _character0000045F =
    {
        0x0000045F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000040F,
        0x0000045F,
        0x0000040F
    };

    static _CharacterInfo _character00000460 =
    {
        0x00000460,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000460,
        0x00000461,
        0x00000460
    };

    static _CharacterInfo _character00000461 =
    {
        0x00000461,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000460,
        0x00000461,
        0x00000460
    };

    static _CharacterInfo _character00000462 =
    {
        0x00000462,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000462,
        0x00000463,
        0x00000462
    };

    static _CharacterInfo _character00000463 =
    {
        0x00000463,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000462,
        0x00000463,
        0x00000462
    };

    static _CharacterInfo _character00000464 =
    {
        0x00000464,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000464,
        0x00000465,
        0x00000464
    };

    static _CharacterInfo _character00000465 =
    {
        0x00000465,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000464,
        0x00000465,
        0x00000464
    };

    static _CharacterInfo _character00000466 =
    {
        0x00000466,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000466,
        0x00000467,
        0x00000466
    };

    static _CharacterInfo _character00000467 =
    {
        0x00000467,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000466,
        0x00000467,
        0x00000466
    };

    static _CharacterInfo _character00000468 =
    {
        0x00000468,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000468,
        0x00000469,
        0x00000468
    };

    static _CharacterInfo _character00000469 =
    {
        0x00000469,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000468,
        0x00000469,
        0x00000468
    };

    static _CharacterInfo _character0000046A =
    {
        0x0000046A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046A,
        0x0000046B,
        0x0000046A
    };

    static _CharacterInfo _character0000046B =
    {
        0x0000046B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046A,
        0x0000046B,
        0x0000046A
    };

    static _CharacterInfo _character0000046C =
    {
        0x0000046C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046C,
        0x0000046D,
        0x0000046C
    };

    static _CharacterInfo _character0000046D =
    {
        0x0000046D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046C,
        0x0000046D,
        0x0000046C
    };

    static _CharacterInfo _character0000046E =
    {
        0x0000046E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046E,
        0x0000046F,
        0x0000046E
    };

    static _CharacterInfo _character0000046F =
    {
        0x0000046F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000046E,
        0x0000046F,
        0x0000046E
    };

    static _CharacterInfo _character00000470 =
    {
        0x00000470,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000470,
        0x00000471,
        0x00000470
    };

    static _CharacterInfo _character00000471 =
    {
        0x00000471,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000470,
        0x00000471,
        0x00000470
    };

    static _CharacterInfo _character00000472 =
    {
        0x00000472,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000472,
        0x00000473,
        0x00000472
    };

    static _CharacterInfo _character00000473 =
    {
        0x00000473,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000472,
        0x00000473,
        0x00000472
    };

    static _CharacterInfo _character00000474 =
    {
        0x00000474,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000474,
        0x00000475,
        0x00000474
    };

    static _CharacterInfo _character00000475 =
    {
        0x00000475,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000474,
        0x00000475,
        0x00000474
    };

    static Char _decompositionMapping00000476[] = 
    {
        0x00000474,
        0x0000030F
    };

    static _CharacterInfo _character00000476 =
    {
        0x00000476,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000476,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000476,
        0x00000477,
        0x00000476
    };

    static Char _decompositionMapping00000477[] = 
    {
        0x00000475,
        0x0000030F
    };

    static _CharacterInfo _character00000477 =
    {
        0x00000477,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000477,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000476,
        0x00000477,
        0x00000476
    };

    static _CharacterInfo _character00000478 =
    {
        0x00000478,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000478,
        0x00000479,
        0x00000478
    };

    static _CharacterInfo _character00000479 =
    {
        0x00000479,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000478,
        0x00000479,
        0x00000478
    };

    static _CharacterInfo _character0000047A =
    {
        0x0000047A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047A,
        0x0000047B,
        0x0000047A
    };

    static _CharacterInfo _character0000047B =
    {
        0x0000047B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047A,
        0x0000047B,
        0x0000047A
    };

    static _CharacterInfo _character0000047C =
    {
        0x0000047C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047C,
        0x0000047D,
        0x0000047C
    };

    static _CharacterInfo _character0000047D =
    {
        0x0000047D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047C,
        0x0000047D,
        0x0000047C
    };

    static _CharacterInfo _character0000047E =
    {
        0x0000047E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047E,
        0x0000047F,
        0x0000047E
    };

    static _CharacterInfo _character0000047F =
    {
        0x0000047F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000047E,
        0x0000047F,
        0x0000047E
    };

    static _CharacterInfo _character00000480 =
    {
        0x00000480,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000480,
        0x00000481,
        0x00000480
    };

    static _CharacterInfo _character00000481 =
    {
        0x00000481,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000480,
        0x00000481,
        0x00000480
    };

    static _CharacterInfo _character00000482 =
    {
        0x00000482,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000482,
        0x00000482,
        0x00000482
    };

    static _CharacterInfo _character00000483 =
    {
        0x00000483,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000483,
        0x00000483,
        0x00000483
    };

    static _CharacterInfo _character00000484 =
    {
        0x00000484,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000484,
        0x00000484,
        0x00000484
    };

    static _CharacterInfo _character00000485 =
    {
        0x00000485,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000485,
        0x00000485,
        0x00000485
    };

    static _CharacterInfo _character00000486 =
    {
        0x00000486,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000486,
        0x00000486,
        0x00000486
    };

    static _CharacterInfo _character00000488 =
    {
        0x00000488,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000488,
        0x00000488,
        0x00000488
    };

    static _CharacterInfo _character00000489 =
    {
        0x00000489,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000489,
        0x00000489,
        0x00000489
    };

    static _CharacterInfo _character0000048A =
    {
        0x0000048A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048A,
        0x0000048B,
        0x0000048A
    };

    static _CharacterInfo _character0000048B =
    {
        0x0000048B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048A,
        0x0000048B,
        0x0000048A
    };

    static _CharacterInfo _character0000048C =
    {
        0x0000048C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048C,
        0x0000048D,
        0x0000048C
    };

    static _CharacterInfo _character0000048D =
    {
        0x0000048D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048C,
        0x0000048D,
        0x0000048C
    };

    static _CharacterInfo _character0000048E =
    {
        0x0000048E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048E,
        0x0000048F,
        0x0000048E
    };

    static _CharacterInfo _character0000048F =
    {
        0x0000048F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000048E,
        0x0000048F,
        0x0000048E
    };

    static _CharacterInfo _character00000490 =
    {
        0x00000490,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000490,
        0x00000491,
        0x00000490
    };

    static _CharacterInfo _character00000491 =
    {
        0x00000491,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000490,
        0x00000491,
        0x00000490
    };

    static _CharacterInfo _character00000492 =
    {
        0x00000492,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000492,
        0x00000493,
        0x00000492
    };

    static _CharacterInfo _character00000493 =
    {
        0x00000493,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000492,
        0x00000493,
        0x00000492
    };

    static _CharacterInfo _character00000494 =
    {
        0x00000494,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000494,
        0x00000495,
        0x00000494
    };

    static _CharacterInfo _character00000495 =
    {
        0x00000495,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000494,
        0x00000495,
        0x00000494
    };

    static _CharacterInfo _character00000496 =
    {
        0x00000496,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000496,
        0x00000497,
        0x00000496
    };

    static _CharacterInfo _character00000497 =
    {
        0x00000497,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000496,
        0x00000497,
        0x00000496
    };

    static _CharacterInfo _character00000498 =
    {
        0x00000498,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000498,
        0x00000499,
        0x00000498
    };

    static _CharacterInfo _character00000499 =
    {
        0x00000499,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000498,
        0x00000499,
        0x00000498
    };

    static _CharacterInfo _character0000049A =
    {
        0x0000049A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049A,
        0x0000049B,
        0x0000049A
    };

    static _CharacterInfo _character0000049B =
    {
        0x0000049B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049A,
        0x0000049B,
        0x0000049A
    };

    static _CharacterInfo _character0000049C =
    {
        0x0000049C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049C,
        0x0000049D,
        0x0000049C
    };

    static _CharacterInfo _character0000049D =
    {
        0x0000049D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049C,
        0x0000049D,
        0x0000049C
    };

    static _CharacterInfo _character0000049E =
    {
        0x0000049E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049E,
        0x0000049F,
        0x0000049E
    };

    static _CharacterInfo _character0000049F =
    {
        0x0000049F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000049E,
        0x0000049F,
        0x0000049E
    };

    static _CharacterInfo _character000004A0 =
    {
        0x000004A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A0,
        0x000004A1,
        0x000004A0
    };

    static _CharacterInfo _character000004A1 =
    {
        0x000004A1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A0,
        0x000004A1,
        0x000004A0
    };

    static _CharacterInfo _character000004A2 =
    {
        0x000004A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A2,
        0x000004A3,
        0x000004A2
    };

    static _CharacterInfo _character000004A3 =
    {
        0x000004A3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A2,
        0x000004A3,
        0x000004A2
    };

    static _CharacterInfo _character000004A4 =
    {
        0x000004A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A4,
        0x000004A5,
        0x000004A4
    };

    static _CharacterInfo _character000004A5 =
    {
        0x000004A5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A4,
        0x000004A5,
        0x000004A4
    };

    static _CharacterInfo _character000004A6 =
    {
        0x000004A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A6,
        0x000004A7,
        0x000004A6
    };

    static _CharacterInfo _character000004A7 =
    {
        0x000004A7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A6,
        0x000004A7,
        0x000004A6
    };

    static _CharacterInfo _character000004A8 =
    {
        0x000004A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A8,
        0x000004A9,
        0x000004A8
    };

    static _CharacterInfo _character000004A9 =
    {
        0x000004A9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004A8,
        0x000004A9,
        0x000004A8
    };

    static _CharacterInfo _character000004AA =
    {
        0x000004AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AA,
        0x000004AB,
        0x000004AA
    };

    static _CharacterInfo _character000004AB =
    {
        0x000004AB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AA,
        0x000004AB,
        0x000004AA
    };

    static _CharacterInfo _character000004AC =
    {
        0x000004AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AC,
        0x000004AD,
        0x000004AC
    };

    static _CharacterInfo _character000004AD =
    {
        0x000004AD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AC,
        0x000004AD,
        0x000004AC
    };

    static _CharacterInfo _character000004AE =
    {
        0x000004AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AE,
        0x000004AF,
        0x000004AE
    };

    static _CharacterInfo _character000004AF =
    {
        0x000004AF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004AE,
        0x000004AF,
        0x000004AE
    };

    static _CharacterInfo _character000004B0 =
    {
        0x000004B0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B0,
        0x000004B1,
        0x000004B0
    };

    static _CharacterInfo _character000004B1 =
    {
        0x000004B1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B0,
        0x000004B1,
        0x000004B0
    };

    static _CharacterInfo _character000004B2 =
    {
        0x000004B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B2,
        0x000004B3,
        0x000004B2
    };

    static _CharacterInfo _character000004B3 =
    {
        0x000004B3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B2,
        0x000004B3,
        0x000004B2
    };

    static _CharacterInfo _character000004B4 =
    {
        0x000004B4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B4,
        0x000004B5,
        0x000004B4
    };

    static _CharacterInfo _character000004B5 =
    {
        0x000004B5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B4,
        0x000004B5,
        0x000004B4
    };

    static _CharacterInfo _character000004B6 =
    {
        0x000004B6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B6,
        0x000004B7,
        0x000004B6
    };

    static _CharacterInfo _character000004B7 =
    {
        0x000004B7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B6,
        0x000004B7,
        0x000004B6
    };

    static _CharacterInfo _character000004B8 =
    {
        0x000004B8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B8,
        0x000004B9,
        0x000004B8
    };

    static _CharacterInfo _character000004B9 =
    {
        0x000004B9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004B8,
        0x000004B9,
        0x000004B8
    };

    static _CharacterInfo _character000004BA =
    {
        0x000004BA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BA,
        0x000004BB,
        0x000004BA
    };

    static _CharacterInfo _character000004BB =
    {
        0x000004BB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BA,
        0x000004BB,
        0x000004BA
    };

    static _CharacterInfo _character000004BC =
    {
        0x000004BC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BC,
        0x000004BD,
        0x000004BC
    };

    static _CharacterInfo _character000004BD =
    {
        0x000004BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BC,
        0x000004BD,
        0x000004BC
    };

    static _CharacterInfo _character000004BE =
    {
        0x000004BE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BE,
        0x000004BF,
        0x000004BE
    };

    static _CharacterInfo _character000004BF =
    {
        0x000004BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004BE,
        0x000004BF,
        0x000004BE
    };

    static _CharacterInfo _character000004C0 =
    {
        0x000004C0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C0,
        0x000004CF,
        0x000004C0
    };

    static Char _decompositionMapping000004C1[] = 
    {
        0x00000416,
        0x00000306
    };

    static _CharacterInfo _character000004C1 =
    {
        0x000004C1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C1,
        0x000004C2,
        0x000004C1
    };

    static Char _decompositionMapping000004C2[] = 
    {
        0x00000436,
        0x00000306
    };

    static _CharacterInfo _character000004C2 =
    {
        0x000004C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C1,
        0x000004C2,
        0x000004C1
    };

    static _CharacterInfo _character000004C3 =
    {
        0x000004C3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C3,
        0x000004C4,
        0x000004C3
    };

    static _CharacterInfo _character000004C4 =
    {
        0x000004C4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C3,
        0x000004C4,
        0x000004C3
    };

    static _CharacterInfo _character000004C5 =
    {
        0x000004C5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C5,
        0x000004C6,
        0x000004C5
    };

    static _CharacterInfo _character000004C6 =
    {
        0x000004C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C5,
        0x000004C6,
        0x000004C5
    };

    static _CharacterInfo _character000004C7 =
    {
        0x000004C7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C7,
        0x000004C8,
        0x000004C7
    };

    static _CharacterInfo _character000004C8 =
    {
        0x000004C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C7,
        0x000004C8,
        0x000004C7
    };

    static _CharacterInfo _character000004C9 =
    {
        0x000004C9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C9,
        0x000004CA,
        0x000004C9
    };

    static _CharacterInfo _character000004CA =
    {
        0x000004CA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C9,
        0x000004CA,
        0x000004C9
    };

    static _CharacterInfo _character000004CB =
    {
        0x000004CB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004CB,
        0x000004CC,
        0x000004CB
    };

    static _CharacterInfo _character000004CC =
    {
        0x000004CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004CB,
        0x000004CC,
        0x000004CB
    };

    static _CharacterInfo _character000004CD =
    {
        0x000004CD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004CD,
        0x000004CE,
        0x000004CD
    };

    static _CharacterInfo _character000004CE =
    {
        0x000004CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004CD,
        0x000004CE,
        0x000004CD
    };

    static _CharacterInfo _character000004CF =
    {
        0x000004CF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004C0,
        0x000004CF,
        0x000004C0
    };

    static Char _decompositionMapping000004D0[] = 
    {
        0x00000410,
        0x00000306
    };

    static _CharacterInfo _character000004D0 =
    {
        0x000004D0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D0,
        0x000004D1,
        0x000004D0
    };

    static Char _decompositionMapping000004D1[] = 
    {
        0x00000430,
        0x00000306
    };

    static _CharacterInfo _character000004D1 =
    {
        0x000004D1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D0,
        0x000004D1,
        0x000004D0
    };

    static Char _decompositionMapping000004D2[] = 
    {
        0x00000410,
        0x00000308
    };

    static _CharacterInfo _character000004D2 =
    {
        0x000004D2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D2,
        0x000004D3,
        0x000004D2
    };

    static Char _decompositionMapping000004D3[] = 
    {
        0x00000430,
        0x00000308
    };

    static _CharacterInfo _character000004D3 =
    {
        0x000004D3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D2,
        0x000004D3,
        0x000004D2
    };

    static _CharacterInfo _character000004D4 =
    {
        0x000004D4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D4,
        0x000004D5,
        0x000004D4
    };

    static _CharacterInfo _character000004D5 =
    {
        0x000004D5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D4,
        0x000004D5,
        0x000004D4
    };

    static Char _decompositionMapping000004D6[] = 
    {
        0x00000415,
        0x00000306
    };

    static _CharacterInfo _character000004D6 =
    {
        0x000004D6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D6,
        0x000004D7,
        0x000004D6
    };

    static Char _decompositionMapping000004D7[] = 
    {
        0x00000435,
        0x00000306
    };

    static _CharacterInfo _character000004D7 =
    {
        0x000004D7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D6,
        0x000004D7,
        0x000004D6
    };

    static _CharacterInfo _character000004D8 =
    {
        0x000004D8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D8,
        0x000004D9,
        0x000004D8
    };

    static _CharacterInfo _character000004D9 =
    {
        0x000004D9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004D8,
        0x000004D9,
        0x000004D8
    };

    static Char _decompositionMapping000004DA[] = 
    {
        0x000004D8,
        0x00000308
    };

    static _CharacterInfo _character000004DA =
    {
        0x000004DA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DA,
        0x000004DB,
        0x000004DA
    };

    static Char _decompositionMapping000004DB[] = 
    {
        0x000004D9,
        0x00000308
    };

    static _CharacterInfo _character000004DB =
    {
        0x000004DB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DA,
        0x000004DB,
        0x000004DA
    };

    static Char _decompositionMapping000004DC[] = 
    {
        0x00000416,
        0x00000308
    };

    static _CharacterInfo _character000004DC =
    {
        0x000004DC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DC,
        0x000004DD,
        0x000004DC
    };

    static Char _decompositionMapping000004DD[] = 
    {
        0x00000436,
        0x00000308
    };

    static _CharacterInfo _character000004DD =
    {
        0x000004DD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DC,
        0x000004DD,
        0x000004DC
    };

    static Char _decompositionMapping000004DE[] = 
    {
        0x00000417,
        0x00000308
    };

    static _CharacterInfo _character000004DE =
    {
        0x000004DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DE,
        0x000004DF,
        0x000004DE
    };

    static Char _decompositionMapping000004DF[] = 
    {
        0x00000437,
        0x00000308
    };

    static _CharacterInfo _character000004DF =
    {
        0x000004DF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004DE,
        0x000004DF,
        0x000004DE
    };

    static _CharacterInfo _character000004E0 =
    {
        0x000004E0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E0,
        0x000004E1,
        0x000004E0
    };

    static _CharacterInfo _character000004E1 =
    {
        0x000004E1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E0,
        0x000004E1,
        0x000004E0
    };

    static Char _decompositionMapping000004E2[] = 
    {
        0x00000418,
        0x00000304
    };

    static _CharacterInfo _character000004E2 =
    {
        0x000004E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E2,
        0x000004E3,
        0x000004E2
    };

    static Char _decompositionMapping000004E3[] = 
    {
        0x00000438,
        0x00000304
    };

    static _CharacterInfo _character000004E3 =
    {
        0x000004E3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E2,
        0x000004E3,
        0x000004E2
    };

    static Char _decompositionMapping000004E4[] = 
    {
        0x00000418,
        0x00000308
    };

    static _CharacterInfo _character000004E4 =
    {
        0x000004E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E4,
        0x000004E5,
        0x000004E4
    };

    static Char _decompositionMapping000004E5[] = 
    {
        0x00000438,
        0x00000308
    };

    static _CharacterInfo _character000004E5 =
    {
        0x000004E5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E4,
        0x000004E5,
        0x000004E4
    };

    static Char _decompositionMapping000004E6[] = 
    {
        0x0000041E,
        0x00000308
    };

    static _CharacterInfo _character000004E6 =
    {
        0x000004E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E6,
        0x000004E7,
        0x000004E6
    };

    static Char _decompositionMapping000004E7[] = 
    {
        0x0000043E,
        0x00000308
    };

    static _CharacterInfo _character000004E7 =
    {
        0x000004E7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E6,
        0x000004E7,
        0x000004E6
    };

    static _CharacterInfo _character000004E8 =
    {
        0x000004E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E8,
        0x000004E9,
        0x000004E8
    };

    static _CharacterInfo _character000004E9 =
    {
        0x000004E9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004E8,
        0x000004E9,
        0x000004E8
    };

    static Char _decompositionMapping000004EA[] = 
    {
        0x000004E8,
        0x00000308
    };

    static _CharacterInfo _character000004EA =
    {
        0x000004EA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EA,
        0x000004EB,
        0x000004EA
    };

    static Char _decompositionMapping000004EB[] = 
    {
        0x000004E9,
        0x00000308
    };

    static _CharacterInfo _character000004EB =
    {
        0x000004EB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EA,
        0x000004EB,
        0x000004EA
    };

    static Char _decompositionMapping000004EC[] = 
    {
        0x0000042D,
        0x00000308
    };

    static _CharacterInfo _character000004EC =
    {
        0x000004EC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EC,
        0x000004ED,
        0x000004EC
    };

    static Char _decompositionMapping000004ED[] = 
    {
        0x0000044D,
        0x00000308
    };

    static _CharacterInfo _character000004ED =
    {
        0x000004ED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EC,
        0x000004ED,
        0x000004EC
    };

    static Char _decompositionMapping000004EE[] = 
    {
        0x00000423,
        0x00000304
    };

    static _CharacterInfo _character000004EE =
    {
        0x000004EE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EE,
        0x000004EF,
        0x000004EE
    };

    static Char _decompositionMapping000004EF[] = 
    {
        0x00000443,
        0x00000304
    };

    static _CharacterInfo _character000004EF =
    {
        0x000004EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004EE,
        0x000004EF,
        0x000004EE
    };

    static Char _decompositionMapping000004F0[] = 
    {
        0x00000423,
        0x00000308
    };

    static _CharacterInfo _character000004F0 =
    {
        0x000004F0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F0,
        0x000004F1,
        0x000004F0
    };

    static Char _decompositionMapping000004F1[] = 
    {
        0x00000443,
        0x00000308
    };

    static _CharacterInfo _character000004F1 =
    {
        0x000004F1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F0,
        0x000004F1,
        0x000004F0
    };

    static Char _decompositionMapping000004F2[] = 
    {
        0x00000423,
        0x0000030B
    };

    static _CharacterInfo _character000004F2 =
    {
        0x000004F2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F2,
        0x000004F3,
        0x000004F2
    };

    static Char _decompositionMapping000004F3[] = 
    {
        0x00000443,
        0x0000030B
    };

    static _CharacterInfo _character000004F3 =
    {
        0x000004F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F2,
        0x000004F3,
        0x000004F2
    };

    static Char _decompositionMapping000004F4[] = 
    {
        0x00000427,
        0x00000308
    };

    static _CharacterInfo _character000004F4 =
    {
        0x000004F4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F4,
        0x000004F5,
        0x000004F4
    };

    static Char _decompositionMapping000004F5[] = 
    {
        0x00000447,
        0x00000308
    };

    static _CharacterInfo _character000004F5 =
    {
        0x000004F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F4,
        0x000004F5,
        0x000004F4
    };

    static _CharacterInfo _character000004F6 =
    {
        0x000004F6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F6,
        0x000004F7,
        0x000004F6
    };

    static _CharacterInfo _character000004F7 =
    {
        0x000004F7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F6,
        0x000004F7,
        0x000004F6
    };

    static Char _decompositionMapping000004F8[] = 
    {
        0x0000042B,
        0x00000308
    };

    static _CharacterInfo _character000004F8 =
    {
        0x000004F8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F8,
        0x000004F9,
        0x000004F8
    };

    static Char _decompositionMapping000004F9[] = 
    {
        0x0000044B,
        0x00000308
    };

    static _CharacterInfo _character000004F9 =
    {
        0x000004F9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000004F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004F8,
        0x000004F9,
        0x000004F8
    };

    static _CharacterInfo _character000004FA =
    {
        0x000004FA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FA,
        0x000004FB,
        0x000004FA
    };

    static _CharacterInfo _character000004FB =
    {
        0x000004FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FA,
        0x000004FB,
        0x000004FA
    };

    static _CharacterInfo _character000004FC =
    {
        0x000004FC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FC,
        0x000004FD,
        0x000004FC
    };

    static _CharacterInfo _character000004FD =
    {
        0x000004FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FC,
        0x000004FD,
        0x000004FC
    };

    static _CharacterInfo _character000004FE =
    {
        0x000004FE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FE,
        0x000004FF,
        0x000004FE
    };

    static _CharacterInfo _character000004FF =
    {
        0x000004FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000004FE,
        0x000004FF,
        0x000004FE
    };

    static _CharacterInfo _character00000500 =
    {
        0x00000500,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000500,
        0x00000501,
        0x00000500
    };

    static _CharacterInfo _character00000501 =
    {
        0x00000501,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000500,
        0x00000501,
        0x00000500
    };

    static _CharacterInfo _character00000502 =
    {
        0x00000502,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000502,
        0x00000503,
        0x00000502
    };

    static _CharacterInfo _character00000503 =
    {
        0x00000503,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000502,
        0x00000503,
        0x00000502
    };

    static _CharacterInfo _character00000504 =
    {
        0x00000504,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000504,
        0x00000505,
        0x00000504
    };

    static _CharacterInfo _character00000505 =
    {
        0x00000505,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000504,
        0x00000505,
        0x00000504
    };

    static _CharacterInfo _character00000506 =
    {
        0x00000506,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000506,
        0x00000507,
        0x00000506
    };

    static _CharacterInfo _character00000507 =
    {
        0x00000507,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000506,
        0x00000507,
        0x00000506
    };

    static _CharacterInfo _character00000508 =
    {
        0x00000508,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000508,
        0x00000509,
        0x00000508
    };

    static _CharacterInfo _character00000509 =
    {
        0x00000509,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000508,
        0x00000509,
        0x00000508
    };

    static _CharacterInfo _character0000050A =
    {
        0x0000050A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050A,
        0x0000050B,
        0x0000050A
    };

    static _CharacterInfo _character0000050B =
    {
        0x0000050B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050A,
        0x0000050B,
        0x0000050A
    };

    static _CharacterInfo _character0000050C =
    {
        0x0000050C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050C,
        0x0000050D,
        0x0000050C
    };

    static _CharacterInfo _character0000050D =
    {
        0x0000050D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050C,
        0x0000050D,
        0x0000050C
    };

    static _CharacterInfo _character0000050E =
    {
        0x0000050E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050E,
        0x0000050F,
        0x0000050E
    };

    static _CharacterInfo _character0000050F =
    {
        0x0000050F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000050E,
        0x0000050F,
        0x0000050E
    };

    static _CharacterInfo _character00000510 =
    {
        0x00000510,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000510,
        0x00000511,
        0x00000510
    };

    static _CharacterInfo _character00000511 =
    {
        0x00000511,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000510,
        0x00000511,
        0x00000510
    };

    static _CharacterInfo _character00000512 =
    {
        0x00000512,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000512,
        0x00000513,
        0x00000512
    };

    static _CharacterInfo _character00000513 =
    {
        0x00000513,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000512,
        0x00000513,
        0x00000512
    };

    static _CharacterInfo _character00000531 =
    {
        0x00000531,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000531,
        0x00000561,
        0x00000531
    };

    static _CharacterInfo _character00000532 =
    {
        0x00000532,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000532,
        0x00000562,
        0x00000532
    };

    static _CharacterInfo _character00000533 =
    {
        0x00000533,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000533,
        0x00000563,
        0x00000533
    };

    static _CharacterInfo _character00000534 =
    {
        0x00000534,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000534,
        0x00000564,
        0x00000534
    };

    static _CharacterInfo _character00000535 =
    {
        0x00000535,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000535,
        0x00000565,
        0x00000535
    };

    static _CharacterInfo _character00000536 =
    {
        0x00000536,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000536,
        0x00000566,
        0x00000536
    };

    static _CharacterInfo _character00000537 =
    {
        0x00000537,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000537,
        0x00000567,
        0x00000537
    };

    static _CharacterInfo _character00000538 =
    {
        0x00000538,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000538,
        0x00000568,
        0x00000538
    };

    static _CharacterInfo _character00000539 =
    {
        0x00000539,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000539,
        0x00000569,
        0x00000539
    };

    static _CharacterInfo _character0000053A =
    {
        0x0000053A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053A,
        0x0000056A,
        0x0000053A
    };

    static _CharacterInfo _character0000053B =
    {
        0x0000053B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053B,
        0x0000056B,
        0x0000053B
    };

    static _CharacterInfo _character0000053C =
    {
        0x0000053C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053C,
        0x0000056C,
        0x0000053C
    };

    static _CharacterInfo _character0000053D =
    {
        0x0000053D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053D,
        0x0000056D,
        0x0000053D
    };

    static _CharacterInfo _character0000053E =
    {
        0x0000053E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053E,
        0x0000056E,
        0x0000053E
    };

    static _CharacterInfo _character0000053F =
    {
        0x0000053F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053F,
        0x0000056F,
        0x0000053F
    };

    static _CharacterInfo _character00000540 =
    {
        0x00000540,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000540,
        0x00000570,
        0x00000540
    };

    static _CharacterInfo _character00000541 =
    {
        0x00000541,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000541,
        0x00000571,
        0x00000541
    };

    static _CharacterInfo _character00000542 =
    {
        0x00000542,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000542,
        0x00000572,
        0x00000542
    };

    static _CharacterInfo _character00000543 =
    {
        0x00000543,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000543,
        0x00000573,
        0x00000543
    };

    static _CharacterInfo _character00000544 =
    {
        0x00000544,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000544,
        0x00000574,
        0x00000544
    };

    static _CharacterInfo _character00000545 =
    {
        0x00000545,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000545,
        0x00000575,
        0x00000545
    };

    static _CharacterInfo _character00000546 =
    {
        0x00000546,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000546,
        0x00000576,
        0x00000546
    };

    static _CharacterInfo _character00000547 =
    {
        0x00000547,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000547,
        0x00000577,
        0x00000547
    };

    static _CharacterInfo _character00000548 =
    {
        0x00000548,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000548,
        0x00000578,
        0x00000548
    };

    static _CharacterInfo _character00000549 =
    {
        0x00000549,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000549,
        0x00000579,
        0x00000549
    };

    static _CharacterInfo _character0000054A =
    {
        0x0000054A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054A,
        0x0000057A,
        0x0000054A
    };

    static _CharacterInfo _character0000054B =
    {
        0x0000054B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054B,
        0x0000057B,
        0x0000054B
    };

    static _CharacterInfo _character0000054C =
    {
        0x0000054C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054C,
        0x0000057C,
        0x0000054C
    };

    static _CharacterInfo _character0000054D =
    {
        0x0000054D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054D,
        0x0000057D,
        0x0000054D
    };

    static _CharacterInfo _character0000054E =
    {
        0x0000054E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054E,
        0x0000057E,
        0x0000054E
    };

    static _CharacterInfo _character0000054F =
    {
        0x0000054F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054F,
        0x0000057F,
        0x0000054F
    };

    static _CharacterInfo _character00000550 =
    {
        0x00000550,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000550,
        0x00000580,
        0x00000550
    };

    static _CharacterInfo _character00000551 =
    {
        0x00000551,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000551,
        0x00000581,
        0x00000551
    };

    static _CharacterInfo _character00000552 =
    {
        0x00000552,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000552,
        0x00000582,
        0x00000552
    };

    static _CharacterInfo _character00000553 =
    {
        0x00000553,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000553,
        0x00000583,
        0x00000553
    };

    static _CharacterInfo _character00000554 =
    {
        0x00000554,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000554,
        0x00000584,
        0x00000554
    };

    static _CharacterInfo _character00000555 =
    {
        0x00000555,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000555,
        0x00000585,
        0x00000555
    };

    static _CharacterInfo _character00000556 =
    {
        0x00000556,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000556,
        0x00000586,
        0x00000556
    };

    static _CharacterInfo _character00000559 =
    {
        0x00000559,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000559,
        0x00000559,
        0x00000559
    };

    static _CharacterInfo _character0000055A =
    {
        0x0000055A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055A,
        0x0000055A,
        0x0000055A
    };

    static _CharacterInfo _character0000055B =
    {
        0x0000055B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055B,
        0x0000055B,
        0x0000055B
    };

    static _CharacterInfo _character0000055C =
    {
        0x0000055C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055C,
        0x0000055C,
        0x0000055C
    };

    static _CharacterInfo _character0000055D =
    {
        0x0000055D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055D,
        0x0000055D,
        0x0000055D
    };

    static _CharacterInfo _character0000055E =
    {
        0x0000055E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055E,
        0x0000055E,
        0x0000055E
    };

    static _CharacterInfo _character0000055F =
    {
        0x0000055F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000055F,
        0x0000055F,
        0x0000055F
    };

    static _CharacterInfo _character00000561 =
    {
        0x00000561,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000531,
        0x00000561,
        0x00000531
    };

    static _CharacterInfo _character00000562 =
    {
        0x00000562,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000532,
        0x00000562,
        0x00000532
    };

    static _CharacterInfo _character00000563 =
    {
        0x00000563,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000533,
        0x00000563,
        0x00000533
    };

    static _CharacterInfo _character00000564 =
    {
        0x00000564,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000534,
        0x00000564,
        0x00000534
    };

    static _CharacterInfo _character00000565 =
    {
        0x00000565,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000535,
        0x00000565,
        0x00000535
    };

    static _CharacterInfo _character00000566 =
    {
        0x00000566,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000536,
        0x00000566,
        0x00000536
    };

    static _CharacterInfo _character00000567 =
    {
        0x00000567,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000537,
        0x00000567,
        0x00000537
    };

    static _CharacterInfo _character00000568 =
    {
        0x00000568,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000538,
        0x00000568,
        0x00000538
    };

    static _CharacterInfo _character00000569 =
    {
        0x00000569,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000539,
        0x00000569,
        0x00000539
    };

    static _CharacterInfo _character0000056A =
    {
        0x0000056A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053A,
        0x0000056A,
        0x0000053A
    };

    static _CharacterInfo _character0000056B =
    {
        0x0000056B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053B,
        0x0000056B,
        0x0000053B
    };

    static _CharacterInfo _character0000056C =
    {
        0x0000056C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053C,
        0x0000056C,
        0x0000053C
    };

    static _CharacterInfo _character0000056D =
    {
        0x0000056D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053D,
        0x0000056D,
        0x0000053D
    };

    static _CharacterInfo _character0000056E =
    {
        0x0000056E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053E,
        0x0000056E,
        0x0000053E
    };

    static _CharacterInfo _character0000056F =
    {
        0x0000056F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000053F,
        0x0000056F,
        0x0000053F
    };

    static _CharacterInfo _character00000570 =
    {
        0x00000570,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000540,
        0x00000570,
        0x00000540
    };

    static _CharacterInfo _character00000571 =
    {
        0x00000571,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000541,
        0x00000571,
        0x00000541
    };

    static _CharacterInfo _character00000572 =
    {
        0x00000572,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000542,
        0x00000572,
        0x00000542
    };

    static _CharacterInfo _character00000573 =
    {
        0x00000573,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000543,
        0x00000573,
        0x00000543
    };

    static _CharacterInfo _character00000574 =
    {
        0x00000574,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000544,
        0x00000574,
        0x00000544
    };

    static _CharacterInfo _character00000575 =
    {
        0x00000575,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000545,
        0x00000575,
        0x00000545
    };

    static _CharacterInfo _character00000576 =
    {
        0x00000576,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000546,
        0x00000576,
        0x00000546
    };

    static _CharacterInfo _character00000577 =
    {
        0x00000577,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000547,
        0x00000577,
        0x00000547
    };

    static _CharacterInfo _character00000578 =
    {
        0x00000578,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000548,
        0x00000578,
        0x00000548
    };

    static _CharacterInfo _character00000579 =
    {
        0x00000579,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000549,
        0x00000579,
        0x00000549
    };

    static _CharacterInfo _character0000057A =
    {
        0x0000057A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054A,
        0x0000057A,
        0x0000054A
    };

    static _CharacterInfo _character0000057B =
    {
        0x0000057B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054B,
        0x0000057B,
        0x0000054B
    };

    static _CharacterInfo _character0000057C =
    {
        0x0000057C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054C,
        0x0000057C,
        0x0000054C
    };

    static _CharacterInfo _character0000057D =
    {
        0x0000057D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054D,
        0x0000057D,
        0x0000054D
    };

    static _CharacterInfo _character0000057E =
    {
        0x0000057E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054E,
        0x0000057E,
        0x0000054E
    };

    static _CharacterInfo _character0000057F =
    {
        0x0000057F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000054F,
        0x0000057F,
        0x0000054F
    };

    static _CharacterInfo _character00000580 =
    {
        0x00000580,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000550,
        0x00000580,
        0x00000550
    };

    static _CharacterInfo _character00000581 =
    {
        0x00000581,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000551,
        0x00000581,
        0x00000551
    };

    static _CharacterInfo _character00000582 =
    {
        0x00000582,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000552,
        0x00000582,
        0x00000552
    };

    static _CharacterInfo _character00000583 =
    {
        0x00000583,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000553,
        0x00000583,
        0x00000553
    };

    static _CharacterInfo _character00000584 =
    {
        0x00000584,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000554,
        0x00000584,
        0x00000554
    };

    static _CharacterInfo _character00000585 =
    {
        0x00000585,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000555,
        0x00000585,
        0x00000555
    };

    static _CharacterInfo _character00000586 =
    {
        0x00000586,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000556,
        0x00000586,
        0x00000556
    };

    static Char _decompositionMapping00000587[] = 
    {
        0x00000565,
        0x00000582
    };

    static _CharacterInfo _character00000587 =
    {
        0x00000587,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000587,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000587,
        0x00000587,
        0x00000587
    };

    static _CharacterInfo _character00000589 =
    {
        0x00000589,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000589,
        0x00000589,
        0x00000589
    };

    static _CharacterInfo _character0000058A =
    {
        0x0000058A,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000058A,
        0x0000058A,
        0x0000058A
    };

    static _CharacterInfo _character00000591 =
    {
        0x00000591,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000591,
        0x00000591,
        0x00000591
    };

    static _CharacterInfo _character00000592 =
    {
        0x00000592,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000592,
        0x00000592,
        0x00000592
    };

    static _CharacterInfo _character00000593 =
    {
        0x00000593,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000593,
        0x00000593,
        0x00000593
    };

    static _CharacterInfo _character00000594 =
    {
        0x00000594,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000594,
        0x00000594,
        0x00000594
    };

    static _CharacterInfo _character00000595 =
    {
        0x00000595,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000595,
        0x00000595,
        0x00000595
    };

    static _CharacterInfo _character00000596 =
    {
        0x00000596,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000596,
        0x00000596,
        0x00000596
    };

    static _CharacterInfo _character00000597 =
    {
        0x00000597,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000597,
        0x00000597,
        0x00000597
    };

    static _CharacterInfo _character00000598 =
    {
        0x00000598,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000598,
        0x00000598,
        0x00000598
    };

    static _CharacterInfo _character00000599 =
    {
        0x00000599,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000599,
        0x00000599,
        0x00000599
    };

    static _CharacterInfo _character0000059A =
    {
        0x0000059A,
        Iso10646::GeneralCategory_Mn,
        222,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059A,
        0x0000059A,
        0x0000059A
    };

    static _CharacterInfo _character0000059B =
    {
        0x0000059B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059B,
        0x0000059B,
        0x0000059B
    };

    static _CharacterInfo _character0000059C =
    {
        0x0000059C,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059C,
        0x0000059C,
        0x0000059C
    };

    static _CharacterInfo _character0000059D =
    {
        0x0000059D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059D,
        0x0000059D,
        0x0000059D
    };

    static _CharacterInfo _character0000059E =
    {
        0x0000059E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059E,
        0x0000059E,
        0x0000059E
    };

    static _CharacterInfo _character0000059F =
    {
        0x0000059F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000059F,
        0x0000059F,
        0x0000059F
    };

    static _CharacterInfo _character000005A0 =
    {
        0x000005A0,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A0,
        0x000005A0,
        0x000005A0
    };

    static _CharacterInfo _character000005A1 =
    {
        0x000005A1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A1,
        0x000005A1,
        0x000005A1
    };

    static _CharacterInfo _character000005A2 =
    {
        0x000005A2,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A2,
        0x000005A2,
        0x000005A2
    };

    static _CharacterInfo _character000005A3 =
    {
        0x000005A3,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A3,
        0x000005A3,
        0x000005A3
    };

    static _CharacterInfo _character000005A4 =
    {
        0x000005A4,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A4,
        0x000005A4,
        0x000005A4
    };

    static _CharacterInfo _character000005A5 =
    {
        0x000005A5,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A5,
        0x000005A5,
        0x000005A5
    };

    static _CharacterInfo _character000005A6 =
    {
        0x000005A6,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A6,
        0x000005A6,
        0x000005A6
    };

    static _CharacterInfo _character000005A7 =
    {
        0x000005A7,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A7,
        0x000005A7,
        0x000005A7
    };

    static _CharacterInfo _character000005A8 =
    {
        0x000005A8,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A8,
        0x000005A8,
        0x000005A8
    };

    static _CharacterInfo _character000005A9 =
    {
        0x000005A9,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005A9,
        0x000005A9,
        0x000005A9
    };

    static _CharacterInfo _character000005AA =
    {
        0x000005AA,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AA,
        0x000005AA,
        0x000005AA
    };

    static _CharacterInfo _character000005AB =
    {
        0x000005AB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AB,
        0x000005AB,
        0x000005AB
    };

    static _CharacterInfo _character000005AC =
    {
        0x000005AC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AC,
        0x000005AC,
        0x000005AC
    };

    static _CharacterInfo _character000005AD =
    {
        0x000005AD,
        Iso10646::GeneralCategory_Mn,
        222,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AD,
        0x000005AD,
        0x000005AD
    };

    static _CharacterInfo _character000005AE =
    {
        0x000005AE,
        Iso10646::GeneralCategory_Mn,
        228,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AE,
        0x000005AE,
        0x000005AE
    };

    static _CharacterInfo _character000005AF =
    {
        0x000005AF,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005AF,
        0x000005AF,
        0x000005AF
    };

    static _CharacterInfo _character000005B0 =
    {
        0x000005B0,
        Iso10646::GeneralCategory_Mn,
        10,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B0,
        0x000005B0,
        0x000005B0
    };

    static _CharacterInfo _character000005B1 =
    {
        0x000005B1,
        Iso10646::GeneralCategory_Mn,
        11,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B1,
        0x000005B1,
        0x000005B1
    };

    static _CharacterInfo _character000005B2 =
    {
        0x000005B2,
        Iso10646::GeneralCategory_Mn,
        12,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B2,
        0x000005B2,
        0x000005B2
    };

    static _CharacterInfo _character000005B3 =
    {
        0x000005B3,
        Iso10646::GeneralCategory_Mn,
        13,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B3,
        0x000005B3,
        0x000005B3
    };

    static _CharacterInfo _character000005B4 =
    {
        0x000005B4,
        Iso10646::GeneralCategory_Mn,
        14,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B4,
        0x000005B4,
        0x000005B4
    };

    static _CharacterInfo _character000005B5 =
    {
        0x000005B5,
        Iso10646::GeneralCategory_Mn,
        15,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B5,
        0x000005B5,
        0x000005B5
    };

    static _CharacterInfo _character000005B6 =
    {
        0x000005B6,
        Iso10646::GeneralCategory_Mn,
        16,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B6,
        0x000005B6,
        0x000005B6
    };

    static _CharacterInfo _character000005B7 =
    {
        0x000005B7,
        Iso10646::GeneralCategory_Mn,
        17,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B7,
        0x000005B7,
        0x000005B7
    };

    static _CharacterInfo _character000005B8 =
    {
        0x000005B8,
        Iso10646::GeneralCategory_Mn,
        18,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B8,
        0x000005B8,
        0x000005B8
    };

    static _CharacterInfo _character000005B9 =
    {
        0x000005B9,
        Iso10646::GeneralCategory_Mn,
        19,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005B9,
        0x000005B9,
        0x000005B9
    };

    static _CharacterInfo _character000005BA =
    {
        0x000005BA,
        Iso10646::GeneralCategory_Mn,
        19,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BA,
        0x000005BA,
        0x000005BA
    };

    static _CharacterInfo _character000005BB =
    {
        0x000005BB,
        Iso10646::GeneralCategory_Mn,
        20,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BB,
        0x000005BB,
        0x000005BB
    };

    static _CharacterInfo _character000005BC =
    {
        0x000005BC,
        Iso10646::GeneralCategory_Mn,
        21,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BC,
        0x000005BC,
        0x000005BC
    };

    static _CharacterInfo _character000005BD =
    {
        0x000005BD,
        Iso10646::GeneralCategory_Mn,
        22,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BD,
        0x000005BD,
        0x000005BD
    };

    static _CharacterInfo _character000005BE =
    {
        0x000005BE,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BE,
        0x000005BE,
        0x000005BE
    };

    static _CharacterInfo _character000005BF =
    {
        0x000005BF,
        Iso10646::GeneralCategory_Mn,
        23,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005BF,
        0x000005BF,
        0x000005BF
    };

    static _CharacterInfo _character000005C0 =
    {
        0x000005C0,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C0,
        0x000005C0,
        0x000005C0
    };

    static _CharacterInfo _character000005C1 =
    {
        0x000005C1,
        Iso10646::GeneralCategory_Mn,
        24,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C1,
        0x000005C1,
        0x000005C1
    };

    static _CharacterInfo _character000005C2 =
    {
        0x000005C2,
        Iso10646::GeneralCategory_Mn,
        25,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C2,
        0x000005C2,
        0x000005C2
    };

    static _CharacterInfo _character000005C3 =
    {
        0x000005C3,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C3,
        0x000005C3,
        0x000005C3
    };

    static _CharacterInfo _character000005C4 =
    {
        0x000005C4,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C4,
        0x000005C4,
        0x000005C4
    };

    static _CharacterInfo _character000005C5 =
    {
        0x000005C5,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C5,
        0x000005C5,
        0x000005C5
    };

    static _CharacterInfo _character000005C6 =
    {
        0x000005C6,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C6,
        0x000005C6,
        0x000005C6
    };

    static _CharacterInfo _character000005C7 =
    {
        0x000005C7,
        Iso10646::GeneralCategory_Mn,
        18,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005C7,
        0x000005C7,
        0x000005C7
    };

    static _CharacterInfo _character000005D0 =
    {
        0x000005D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D0,
        0x000005D0,
        0x000005D0
    };

    static _CharacterInfo _character000005D1 =
    {
        0x000005D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D1,
        0x000005D1,
        0x000005D1
    };

    static _CharacterInfo _character000005D2 =
    {
        0x000005D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D2,
        0x000005D2,
        0x000005D2
    };

    static _CharacterInfo _character000005D3 =
    {
        0x000005D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D3,
        0x000005D3,
        0x000005D3
    };

    static _CharacterInfo _character000005D4 =
    {
        0x000005D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D4,
        0x000005D4,
        0x000005D4
    };

    static _CharacterInfo _character000005D5 =
    {
        0x000005D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D5,
        0x000005D5,
        0x000005D5
    };

    static _CharacterInfo _character000005D6 =
    {
        0x000005D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D6,
        0x000005D6,
        0x000005D6
    };

    static _CharacterInfo _character000005D7 =
    {
        0x000005D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D7,
        0x000005D7,
        0x000005D7
    };

    static _CharacterInfo _character000005D8 =
    {
        0x000005D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D8,
        0x000005D8,
        0x000005D8
    };

    static _CharacterInfo _character000005D9 =
    {
        0x000005D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005D9,
        0x000005D9,
        0x000005D9
    };

    static _CharacterInfo _character000005DA =
    {
        0x000005DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DA,
        0x000005DA,
        0x000005DA
    };

    static _CharacterInfo _character000005DB =
    {
        0x000005DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DB,
        0x000005DB,
        0x000005DB
    };

    static _CharacterInfo _character000005DC =
    {
        0x000005DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DC,
        0x000005DC,
        0x000005DC
    };

    static _CharacterInfo _character000005DD =
    {
        0x000005DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DD,
        0x000005DD,
        0x000005DD
    };

    static _CharacterInfo _character000005DE =
    {
        0x000005DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DE,
        0x000005DE,
        0x000005DE
    };

    static _CharacterInfo _character000005DF =
    {
        0x000005DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005DF,
        0x000005DF,
        0x000005DF
    };

    static _CharacterInfo _character000005E0 =
    {
        0x000005E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E0,
        0x000005E0,
        0x000005E0
    };

    static _CharacterInfo _character000005E1 =
    {
        0x000005E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E1,
        0x000005E1,
        0x000005E1
    };

    static _CharacterInfo _character000005E2 =
    {
        0x000005E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E2,
        0x000005E2,
        0x000005E2
    };

    static _CharacterInfo _character000005E3 =
    {
        0x000005E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E3,
        0x000005E3,
        0x000005E3
    };

    static _CharacterInfo _character000005E4 =
    {
        0x000005E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E4,
        0x000005E4,
        0x000005E4
    };

    static _CharacterInfo _character000005E5 =
    {
        0x000005E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E5,
        0x000005E5,
        0x000005E5
    };

    static _CharacterInfo _character000005E6 =
    {
        0x000005E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E6,
        0x000005E6,
        0x000005E6
    };

    static _CharacterInfo _character000005E7 =
    {
        0x000005E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E7,
        0x000005E7,
        0x000005E7
    };

    static _CharacterInfo _character000005E8 =
    {
        0x000005E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E8,
        0x000005E8,
        0x000005E8
    };

    static _CharacterInfo _character000005E9 =
    {
        0x000005E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005E9,
        0x000005E9,
        0x000005E9
    };

    static _CharacterInfo _character000005EA =
    {
        0x000005EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005EA,
        0x000005EA,
        0x000005EA
    };

    static _CharacterInfo _character000005F0 =
    {
        0x000005F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005F0,
        0x000005F0,
        0x000005F0
    };

    static _CharacterInfo _character000005F1 =
    {
        0x000005F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005F1,
        0x000005F1,
        0x000005F1
    };

    static _CharacterInfo _character000005F2 =
    {
        0x000005F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005F2,
        0x000005F2,
        0x000005F2
    };

    static _CharacterInfo _character000005F3 =
    {
        0x000005F3,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005F3,
        0x000005F3,
        0x000005F3
    };

    static _CharacterInfo _character000005F4 =
    {
        0x000005F4,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000005F4,
        0x000005F4,
        0x000005F4
    };

    static _CharacterInfo _character00000600 =
    {
        0x00000600,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000600,
        0x00000600,
        0x00000600
    };

    static _CharacterInfo _character00000601 =
    {
        0x00000601,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000601,
        0x00000601,
        0x00000601
    };

    static _CharacterInfo _character00000602 =
    {
        0x00000602,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000602,
        0x00000602,
        0x00000602
    };

    static _CharacterInfo _character00000603 =
    {
        0x00000603,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000603,
        0x00000603,
        0x00000603
    };

    static _CharacterInfo _character0000060B =
    {
        0x0000060B,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000060B,
        0x0000060B,
        0x0000060B
    };

    static _CharacterInfo _character0000060C =
    {
        0x0000060C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000060C,
        0x0000060C,
        0x0000060C
    };

    static _CharacterInfo _character0000060D =
    {
        0x0000060D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000060D,
        0x0000060D,
        0x0000060D
    };

    static _CharacterInfo _character0000060E =
    {
        0x0000060E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000060E,
        0x0000060E,
        0x0000060E
    };

    static _CharacterInfo _character0000060F =
    {
        0x0000060F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000060F,
        0x0000060F,
        0x0000060F
    };

    static _CharacterInfo _character00000610 =
    {
        0x00000610,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000610,
        0x00000610,
        0x00000610
    };

    static _CharacterInfo _character00000611 =
    {
        0x00000611,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000611,
        0x00000611,
        0x00000611
    };

    static _CharacterInfo _character00000612 =
    {
        0x00000612,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000612,
        0x00000612,
        0x00000612
    };

    static _CharacterInfo _character00000613 =
    {
        0x00000613,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000613,
        0x00000613,
        0x00000613
    };

    static _CharacterInfo _character00000614 =
    {
        0x00000614,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000614,
        0x00000614,
        0x00000614
    };

    static _CharacterInfo _character00000615 =
    {
        0x00000615,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000615,
        0x00000615,
        0x00000615
    };

    static _CharacterInfo _character0000061B =
    {
        0x0000061B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000061B,
        0x0000061B,
        0x0000061B
    };

    static _CharacterInfo _character0000061E =
    {
        0x0000061E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000061E,
        0x0000061E,
        0x0000061E
    };

    static _CharacterInfo _character0000061F =
    {
        0x0000061F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000061F,
        0x0000061F,
        0x0000061F
    };

    static _CharacterInfo _character00000621 =
    {
        0x00000621,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000621,
        0x00000621,
        0x00000621
    };

    static Char _decompositionMapping00000622[] = 
    {
        0x00000627,
        0x00000653
    };

    static _CharacterInfo _character00000622 =
    {
        0x00000622,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000622,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000622,
        0x00000622,
        0x00000622
    };

    static Char _decompositionMapping00000623[] = 
    {
        0x00000627,
        0x00000654
    };

    static _CharacterInfo _character00000623 =
    {
        0x00000623,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000623,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000623,
        0x00000623,
        0x00000623
    };

    static Char _decompositionMapping00000624[] = 
    {
        0x00000648,
        0x00000654
    };

    static _CharacterInfo _character00000624 =
    {
        0x00000624,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000624,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000624,
        0x00000624,
        0x00000624
    };

    static Char _decompositionMapping00000625[] = 
    {
        0x00000627,
        0x00000655
    };

    static _CharacterInfo _character00000625 =
    {
        0x00000625,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000625,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000625,
        0x00000625,
        0x00000625
    };

    static Char _decompositionMapping00000626[] = 
    {
        0x0000064A,
        0x00000654
    };

    static _CharacterInfo _character00000626 =
    {
        0x00000626,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000626,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000626,
        0x00000626,
        0x00000626
    };

    static _CharacterInfo _character00000627 =
    {
        0x00000627,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000627,
        0x00000627,
        0x00000627
    };

    static _CharacterInfo _character00000628 =
    {
        0x00000628,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000628,
        0x00000628,
        0x00000628
    };

    static _CharacterInfo _character00000629 =
    {
        0x00000629,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000629,
        0x00000629,
        0x00000629
    };

    static _CharacterInfo _character0000062A =
    {
        0x0000062A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062A,
        0x0000062A,
        0x0000062A
    };

    static _CharacterInfo _character0000062B =
    {
        0x0000062B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062B,
        0x0000062B,
        0x0000062B
    };

    static _CharacterInfo _character0000062C =
    {
        0x0000062C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062C,
        0x0000062C,
        0x0000062C
    };

    static _CharacterInfo _character0000062D =
    {
        0x0000062D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062D,
        0x0000062D,
        0x0000062D
    };

    static _CharacterInfo _character0000062E =
    {
        0x0000062E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062E,
        0x0000062E,
        0x0000062E
    };

    static _CharacterInfo _character0000062F =
    {
        0x0000062F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000062F,
        0x0000062F,
        0x0000062F
    };

    static _CharacterInfo _character00000630 =
    {
        0x00000630,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000630,
        0x00000630,
        0x00000630
    };

    static _CharacterInfo _character00000631 =
    {
        0x00000631,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000631,
        0x00000631,
        0x00000631
    };

    static _CharacterInfo _character00000632 =
    {
        0x00000632,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000632,
        0x00000632,
        0x00000632
    };

    static _CharacterInfo _character00000633 =
    {
        0x00000633,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000633,
        0x00000633,
        0x00000633
    };

    static _CharacterInfo _character00000634 =
    {
        0x00000634,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000634,
        0x00000634,
        0x00000634
    };

    static _CharacterInfo _character00000635 =
    {
        0x00000635,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000635,
        0x00000635,
        0x00000635
    };

    static _CharacterInfo _character00000636 =
    {
        0x00000636,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000636,
        0x00000636,
        0x00000636
    };

    static _CharacterInfo _character00000637 =
    {
        0x00000637,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000637,
        0x00000637,
        0x00000637
    };

    static _CharacterInfo _character00000638 =
    {
        0x00000638,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000638,
        0x00000638,
        0x00000638
    };

    static _CharacterInfo _character00000639 =
    {
        0x00000639,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000639,
        0x00000639,
        0x00000639
    };

    static _CharacterInfo _character0000063A =
    {
        0x0000063A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000063A,
        0x0000063A,
        0x0000063A
    };

    static _CharacterInfo _character00000640 =
    {
        0x00000640,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000640,
        0x00000640,
        0x00000640
    };

    static _CharacterInfo _character00000641 =
    {
        0x00000641,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000641,
        0x00000641,
        0x00000641
    };

    static _CharacterInfo _character00000642 =
    {
        0x00000642,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000642,
        0x00000642,
        0x00000642
    };

    static _CharacterInfo _character00000643 =
    {
        0x00000643,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000643,
        0x00000643,
        0x00000643
    };

    static _CharacterInfo _character00000644 =
    {
        0x00000644,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000644,
        0x00000644,
        0x00000644
    };

    static _CharacterInfo _character00000645 =
    {
        0x00000645,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000645,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character00000646 =
    {
        0x00000646,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000646,
        0x00000646,
        0x00000646
    };

    static _CharacterInfo _character00000647 =
    {
        0x00000647,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000647,
        0x00000647,
        0x00000647
    };

    static _CharacterInfo _character00000648 =
    {
        0x00000648,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000648,
        0x00000648,
        0x00000648
    };

    static _CharacterInfo _character00000649 =
    {
        0x00000649,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000649,
        0x00000649,
        0x00000649
    };

    static _CharacterInfo _character0000064A =
    {
        0x0000064A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064A,
        0x0000064A,
        0x0000064A
    };

    static _CharacterInfo _character0000064B =
    {
        0x0000064B,
        Iso10646::GeneralCategory_Mn,
        27,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064B,
        0x0000064B,
        0x0000064B
    };

    static _CharacterInfo _character0000064C =
    {
        0x0000064C,
        Iso10646::GeneralCategory_Mn,
        28,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064C,
        0x0000064C,
        0x0000064C
    };

    static _CharacterInfo _character0000064D =
    {
        0x0000064D,
        Iso10646::GeneralCategory_Mn,
        29,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064D,
        0x0000064D,
        0x0000064D
    };

    static _CharacterInfo _character0000064E =
    {
        0x0000064E,
        Iso10646::GeneralCategory_Mn,
        30,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064E,
        0x0000064E,
        0x0000064E
    };

    static _CharacterInfo _character0000064F =
    {
        0x0000064F,
        Iso10646::GeneralCategory_Mn,
        31,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000064F,
        0x0000064F,
        0x0000064F
    };

    static _CharacterInfo _character00000650 =
    {
        0x00000650,
        Iso10646::GeneralCategory_Mn,
        32,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000650,
        0x00000650,
        0x00000650
    };

    static _CharacterInfo _character00000651 =
    {
        0x00000651,
        Iso10646::GeneralCategory_Mn,
        33,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000651,
        0x00000651,
        0x00000651
    };

    static _CharacterInfo _character00000652 =
    {
        0x00000652,
        Iso10646::GeneralCategory_Mn,
        34,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000652,
        0x00000652,
        0x00000652
    };

    static _CharacterInfo _character00000653 =
    {
        0x00000653,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000653,
        0x00000653,
        0x00000653
    };

    static _CharacterInfo _character00000654 =
    {
        0x00000654,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000654,
        0x00000654,
        0x00000654
    };

    static _CharacterInfo _character00000655 =
    {
        0x00000655,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000655,
        0x00000655,
        0x00000655
    };

    static _CharacterInfo _character00000656 =
    {
        0x00000656,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000656,
        0x00000656,
        0x00000656
    };

    static _CharacterInfo _character00000657 =
    {
        0x00000657,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000657,
        0x00000657,
        0x00000657
    };

    static _CharacterInfo _character00000658 =
    {
        0x00000658,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000658,
        0x00000658,
        0x00000658
    };

    static _CharacterInfo _character00000659 =
    {
        0x00000659,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000659,
        0x00000659,
        0x00000659
    };

    static _CharacterInfo _character0000065A =
    {
        0x0000065A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000065A,
        0x0000065A,
        0x0000065A
    };

    static _CharacterInfo _character0000065B =
    {
        0x0000065B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000065B,
        0x0000065B,
        0x0000065B
    };

    static _CharacterInfo _character0000065C =
    {
        0x0000065C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000065C,
        0x0000065C,
        0x0000065C
    };

    static _CharacterInfo _character0000065D =
    {
        0x0000065D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000065D,
        0x0000065D,
        0x0000065D
    };

    static _CharacterInfo _character0000065E =
    {
        0x0000065E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000065E,
        0x0000065E,
        0x0000065E
    };

    static _CharacterInfo _character00000660 =
    {
        0x00000660,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000660,
        0x00000660,
        0x00000660
    };

    static _CharacterInfo _character00000661 =
    {
        0x00000661,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000661,
        0x00000661,
        0x00000661
    };

    static _CharacterInfo _character00000662 =
    {
        0x00000662,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000662,
        0x00000662,
        0x00000662
    };

    static _CharacterInfo _character00000663 =
    {
        0x00000663,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000663,
        0x00000663,
        0x00000663
    };

    static _CharacterInfo _character00000664 =
    {
        0x00000664,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000664,
        0x00000664,
        0x00000664
    };

    static _CharacterInfo _character00000665 =
    {
        0x00000665,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000665,
        0x00000665,
        0x00000665
    };

    static _CharacterInfo _character00000666 =
    {
        0x00000666,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000666,
        0x00000666,
        0x00000666
    };

    static _CharacterInfo _character00000667 =
    {
        0x00000667,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000667,
        0x00000667,
        0x00000667
    };

    static _CharacterInfo _character00000668 =
    {
        0x00000668,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000668,
        0x00000668,
        0x00000668
    };

    static _CharacterInfo _character00000669 =
    {
        0x00000669,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000669,
        0x00000669,
        0x00000669
    };

    static _CharacterInfo _character0000066A =
    {
        0x0000066A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066A,
        0x0000066A,
        0x0000066A
    };

    static _CharacterInfo _character0000066B =
    {
        0x0000066B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066B,
        0x0000066B,
        0x0000066B
    };

    static _CharacterInfo _character0000066C =
    {
        0x0000066C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066C,
        0x0000066C,
        0x0000066C
    };

    static _CharacterInfo _character0000066D =
    {
        0x0000066D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066D,
        0x0000066D,
        0x0000066D
    };

    static _CharacterInfo _character0000066E =
    {
        0x0000066E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066E,
        0x0000066E,
        0x0000066E
    };

    static _CharacterInfo _character0000066F =
    {
        0x0000066F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000066F,
        0x0000066F,
        0x0000066F
    };

    static _CharacterInfo _character00000670 =
    {
        0x00000670,
        Iso10646::GeneralCategory_Mn,
        35,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000670,
        0x00000670,
        0x00000670
    };

    static _CharacterInfo _character00000671 =
    {
        0x00000671,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000671,
        0x00000671,
        0x00000671
    };

    static _CharacterInfo _character00000672 =
    {
        0x00000672,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000672,
        0x00000672,
        0x00000672
    };

    static _CharacterInfo _character00000673 =
    {
        0x00000673,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000673,
        0x00000673,
        0x00000673
    };

    static _CharacterInfo _character00000674 =
    {
        0x00000674,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000674,
        0x00000674,
        0x00000674
    };

    static Char _decompositionMapping00000675[] = 
    {
        0x00000627,
        0x00000674
    };

    static _CharacterInfo _character00000675 =
    {
        0x00000675,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000675,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000675,
        0x00000675,
        0x00000675
    };

    static Char _decompositionMapping00000676[] = 
    {
        0x00000648,
        0x00000674
    };

    static _CharacterInfo _character00000676 =
    {
        0x00000676,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000676,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000676,
        0x00000676,
        0x00000676
    };

    static Char _decompositionMapping00000677[] = 
    {
        0x000006C7,
        0x00000674
    };

    static _CharacterInfo _character00000677 =
    {
        0x00000677,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000677,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000677,
        0x00000677,
        0x00000677
    };

    static Char _decompositionMapping00000678[] = 
    {
        0x0000064A,
        0x00000674
    };

    static _CharacterInfo _character00000678 =
    {
        0x00000678,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000678,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000678,
        0x00000678,
        0x00000678
    };

    static _CharacterInfo _character00000679 =
    {
        0x00000679,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000679,
        0x00000679,
        0x00000679
    };

    static _CharacterInfo _character0000067A =
    {
        0x0000067A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067A,
        0x0000067A,
        0x0000067A
    };

    static _CharacterInfo _character0000067B =
    {
        0x0000067B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067B,
        0x0000067B,
        0x0000067B
    };

    static _CharacterInfo _character0000067C =
    {
        0x0000067C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067C,
        0x0000067C,
        0x0000067C
    };

    static _CharacterInfo _character0000067D =
    {
        0x0000067D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067D,
        0x0000067D,
        0x0000067D
    };

    static _CharacterInfo _character0000067E =
    {
        0x0000067E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067E,
        0x0000067E,
        0x0000067E
    };

    static _CharacterInfo _character0000067F =
    {
        0x0000067F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000067F,
        0x0000067F,
        0x0000067F
    };

    static _CharacterInfo _character00000680 =
    {
        0x00000680,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000680,
        0x00000680,
        0x00000680
    };

    static _CharacterInfo _character00000681 =
    {
        0x00000681,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000681,
        0x00000681,
        0x00000681
    };

    static _CharacterInfo _character00000682 =
    {
        0x00000682,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000682,
        0x00000682,
        0x00000682
    };

    static _CharacterInfo _character00000683 =
    {
        0x00000683,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000683,
        0x00000683,
        0x00000683
    };

    static _CharacterInfo _character00000684 =
    {
        0x00000684,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000684,
        0x00000684,
        0x00000684
    };

    static _CharacterInfo _character00000685 =
    {
        0x00000685,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000685,
        0x00000685,
        0x00000685
    };

    static _CharacterInfo _character00000686 =
    {
        0x00000686,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000686,
        0x00000686,
        0x00000686
    };

    static _CharacterInfo _character00000687 =
    {
        0x00000687,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000687,
        0x00000687,
        0x00000687
    };

    static _CharacterInfo _character00000688 =
    {
        0x00000688,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000688,
        0x00000688,
        0x00000688
    };

    static _CharacterInfo _character00000689 =
    {
        0x00000689,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000689,
        0x00000689,
        0x00000689
    };

    static _CharacterInfo _character0000068A =
    {
        0x0000068A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068A,
        0x0000068A,
        0x0000068A
    };

    static _CharacterInfo _character0000068B =
    {
        0x0000068B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068B,
        0x0000068B,
        0x0000068B
    };

    static _CharacterInfo _character0000068C =
    {
        0x0000068C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068C,
        0x0000068C,
        0x0000068C
    };

    static _CharacterInfo _character0000068D =
    {
        0x0000068D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068D,
        0x0000068D,
        0x0000068D
    };

    static _CharacterInfo _character0000068E =
    {
        0x0000068E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068E,
        0x0000068E,
        0x0000068E
    };

    static _CharacterInfo _character0000068F =
    {
        0x0000068F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000068F,
        0x0000068F,
        0x0000068F
    };

    static _CharacterInfo _character00000690 =
    {
        0x00000690,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000690,
        0x00000690,
        0x00000690
    };

    static _CharacterInfo _character00000691 =
    {
        0x00000691,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000691,
        0x00000691,
        0x00000691
    };

    static _CharacterInfo _character00000692 =
    {
        0x00000692,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000692,
        0x00000692,
        0x00000692
    };

    static _CharacterInfo _character00000693 =
    {
        0x00000693,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000693,
        0x00000693,
        0x00000693
    };

    static _CharacterInfo _character00000694 =
    {
        0x00000694,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000694,
        0x00000694,
        0x00000694
    };

    static _CharacterInfo _character00000695 =
    {
        0x00000695,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000695,
        0x00000695,
        0x00000695
    };

    static _CharacterInfo _character00000696 =
    {
        0x00000696,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000696,
        0x00000696,
        0x00000696
    };

    static _CharacterInfo _character00000697 =
    {
        0x00000697,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000697,
        0x00000697,
        0x00000697
    };

    static _CharacterInfo _character00000698 =
    {
        0x00000698,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000698,
        0x00000698,
        0x00000698
    };

    static _CharacterInfo _character00000699 =
    {
        0x00000699,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000699,
        0x00000699,
        0x00000699
    };

    static _CharacterInfo _character0000069A =
    {
        0x0000069A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069A,
        0x0000069A,
        0x0000069A
    };

    static _CharacterInfo _character0000069B =
    {
        0x0000069B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069B,
        0x0000069B,
        0x0000069B
    };

    static _CharacterInfo _character0000069C =
    {
        0x0000069C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069C,
        0x0000069C,
        0x0000069C
    };

    static _CharacterInfo _character0000069D =
    {
        0x0000069D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069D,
        0x0000069D,
        0x0000069D
    };

    static _CharacterInfo _character0000069E =
    {
        0x0000069E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069E,
        0x0000069E,
        0x0000069E
    };

    static _CharacterInfo _character0000069F =
    {
        0x0000069F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000069F,
        0x0000069F,
        0x0000069F
    };

    static _CharacterInfo _character000006A0 =
    {
        0x000006A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A0,
        0x000006A0,
        0x000006A0
    };

    static _CharacterInfo _character000006A1 =
    {
        0x000006A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A1,
        0x000006A1,
        0x000006A1
    };

    static _CharacterInfo _character000006A2 =
    {
        0x000006A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A2,
        0x000006A2,
        0x000006A2
    };

    static _CharacterInfo _character000006A3 =
    {
        0x000006A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A3,
        0x000006A3,
        0x000006A3
    };

    static _CharacterInfo _character000006A4 =
    {
        0x000006A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A4,
        0x000006A4,
        0x000006A4
    };

    static _CharacterInfo _character000006A5 =
    {
        0x000006A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A5,
        0x000006A5,
        0x000006A5
    };

    static _CharacterInfo _character000006A6 =
    {
        0x000006A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A6,
        0x000006A6,
        0x000006A6
    };

    static _CharacterInfo _character000006A7 =
    {
        0x000006A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A7,
        0x000006A7,
        0x000006A7
    };

    static _CharacterInfo _character000006A8 =
    {
        0x000006A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A8,
        0x000006A8,
        0x000006A8
    };

    static _CharacterInfo _character000006A9 =
    {
        0x000006A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006A9,
        0x000006A9,
        0x000006A9
    };

    static _CharacterInfo _character000006AA =
    {
        0x000006AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AA,
        0x000006AA,
        0x000006AA
    };

    static _CharacterInfo _character000006AB =
    {
        0x000006AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AB,
        0x000006AB,
        0x000006AB
    };

    static _CharacterInfo _character000006AC =
    {
        0x000006AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AC,
        0x000006AC,
        0x000006AC
    };

    static _CharacterInfo _character000006AD =
    {
        0x000006AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AD,
        0x000006AD,
        0x000006AD
    };

    static _CharacterInfo _character000006AE =
    {
        0x000006AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AE,
        0x000006AE,
        0x000006AE
    };

    static _CharacterInfo _character000006AF =
    {
        0x000006AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006AF,
        0x000006AF,
        0x000006AF
    };

    static _CharacterInfo _character000006B0 =
    {
        0x000006B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B0,
        0x000006B0,
        0x000006B0
    };

    static _CharacterInfo _character000006B1 =
    {
        0x000006B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B1,
        0x000006B1,
        0x000006B1
    };

    static _CharacterInfo _character000006B2 =
    {
        0x000006B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B2,
        0x000006B2,
        0x000006B2
    };

    static _CharacterInfo _character000006B3 =
    {
        0x000006B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B3,
        0x000006B3,
        0x000006B3
    };

    static _CharacterInfo _character000006B4 =
    {
        0x000006B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B4,
        0x000006B4,
        0x000006B4
    };

    static _CharacterInfo _character000006B5 =
    {
        0x000006B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B5,
        0x000006B5,
        0x000006B5
    };

    static _CharacterInfo _character000006B6 =
    {
        0x000006B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B6,
        0x000006B6,
        0x000006B6
    };

    static _CharacterInfo _character000006B7 =
    {
        0x000006B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B7,
        0x000006B7,
        0x000006B7
    };

    static _CharacterInfo _character000006B8 =
    {
        0x000006B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B8,
        0x000006B8,
        0x000006B8
    };

    static _CharacterInfo _character000006B9 =
    {
        0x000006B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006B9,
        0x000006B9,
        0x000006B9
    };

    static _CharacterInfo _character000006BA =
    {
        0x000006BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BA,
        0x000006BA,
        0x000006BA
    };

    static _CharacterInfo _character000006BB =
    {
        0x000006BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BB,
        0x000006BB,
        0x000006BB
    };

    static _CharacterInfo _character000006BC =
    {
        0x000006BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BC,
        0x000006BC,
        0x000006BC
    };

    static _CharacterInfo _character000006BD =
    {
        0x000006BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BD,
        0x000006BD,
        0x000006BD
    };

    static _CharacterInfo _character000006BE =
    {
        0x000006BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BE,
        0x000006BE,
        0x000006BE
    };

    static _CharacterInfo _character000006BF =
    {
        0x000006BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006BF,
        0x000006BF,
        0x000006BF
    };

    static Char _decompositionMapping000006C0[] = 
    {
        0x000006D5,
        0x00000654
    };

    static _CharacterInfo _character000006C0 =
    {
        0x000006C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000006C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C0,
        0x000006C0,
        0x000006C0
    };

    static _CharacterInfo _character000006C1 =
    {
        0x000006C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C1,
        0x000006C1,
        0x000006C1
    };

    static Char _decompositionMapping000006C2[] = 
    {
        0x000006C1,
        0x00000654
    };

    static _CharacterInfo _character000006C2 =
    {
        0x000006C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000006C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C2,
        0x000006C2,
        0x000006C2
    };

    static _CharacterInfo _character000006C3 =
    {
        0x000006C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C3,
        0x000006C3,
        0x000006C3
    };

    static _CharacterInfo _character000006C4 =
    {
        0x000006C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C4,
        0x000006C4,
        0x000006C4
    };

    static _CharacterInfo _character000006C5 =
    {
        0x000006C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C5,
        0x000006C5,
        0x000006C5
    };

    static _CharacterInfo _character000006C6 =
    {
        0x000006C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C6,
        0x000006C6,
        0x000006C6
    };

    static _CharacterInfo _character000006C7 =
    {
        0x000006C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C7,
        0x000006C7,
        0x000006C7
    };

    static _CharacterInfo _character000006C8 =
    {
        0x000006C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C8,
        0x000006C8,
        0x000006C8
    };

    static _CharacterInfo _character000006C9 =
    {
        0x000006C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006C9,
        0x000006C9,
        0x000006C9
    };

    static _CharacterInfo _character000006CA =
    {
        0x000006CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CA,
        0x000006CA,
        0x000006CA
    };

    static _CharacterInfo _character000006CB =
    {
        0x000006CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CB,
        0x000006CB,
        0x000006CB
    };

    static _CharacterInfo _character000006CC =
    {
        0x000006CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CC,
        0x000006CC,
        0x000006CC
    };

    static _CharacterInfo _character000006CD =
    {
        0x000006CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CD,
        0x000006CD,
        0x000006CD
    };

    static _CharacterInfo _character000006CE =
    {
        0x000006CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CE,
        0x000006CE,
        0x000006CE
    };

    static _CharacterInfo _character000006CF =
    {
        0x000006CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006CF,
        0x000006CF,
        0x000006CF
    };

    static _CharacterInfo _character000006D0 =
    {
        0x000006D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D0,
        0x000006D0,
        0x000006D0
    };

    static _CharacterInfo _character000006D1 =
    {
        0x000006D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D1,
        0x000006D1,
        0x000006D1
    };

    static _CharacterInfo _character000006D2 =
    {
        0x000006D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D2,
        0x000006D2,
        0x000006D2
    };

    static Char _decompositionMapping000006D3[] = 
    {
        0x000006D2,
        0x00000654
    };

    static _CharacterInfo _character000006D3 =
    {
        0x000006D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000006D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D3,
        0x000006D3,
        0x000006D3
    };

    static _CharacterInfo _character000006D4 =
    {
        0x000006D4,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D4,
        0x000006D4,
        0x000006D4
    };

    static _CharacterInfo _character000006D5 =
    {
        0x000006D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D5,
        0x000006D5,
        0x000006D5
    };

    static _CharacterInfo _character000006D6 =
    {
        0x000006D6,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D6,
        0x000006D6,
        0x000006D6
    };

    static _CharacterInfo _character000006D7 =
    {
        0x000006D7,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D7,
        0x000006D7,
        0x000006D7
    };

    static _CharacterInfo _character000006D8 =
    {
        0x000006D8,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D8,
        0x000006D8,
        0x000006D8
    };

    static _CharacterInfo _character000006D9 =
    {
        0x000006D9,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006D9,
        0x000006D9,
        0x000006D9
    };

    static _CharacterInfo _character000006DA =
    {
        0x000006DA,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DA,
        0x000006DA,
        0x000006DA
    };

    static _CharacterInfo _character000006DB =
    {
        0x000006DB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DB,
        0x000006DB,
        0x000006DB
    };

    static _CharacterInfo _character000006DC =
    {
        0x000006DC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DC,
        0x000006DC,
        0x000006DC
    };

    static _CharacterInfo _character000006DD =
    {
        0x000006DD,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DD,
        0x000006DD,
        0x000006DD
    };

    static _CharacterInfo _character000006DE =
    {
        0x000006DE,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DE,
        0x000006DE,
        0x000006DE
    };

    static _CharacterInfo _character000006DF =
    {
        0x000006DF,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006DF,
        0x000006DF,
        0x000006DF
    };

    static _CharacterInfo _character000006E0 =
    {
        0x000006E0,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E0,
        0x000006E0,
        0x000006E0
    };

    static _CharacterInfo _character000006E1 =
    {
        0x000006E1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E1,
        0x000006E1,
        0x000006E1
    };

    static _CharacterInfo _character000006E2 =
    {
        0x000006E2,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E2,
        0x000006E2,
        0x000006E2
    };

    static _CharacterInfo _character000006E3 =
    {
        0x000006E3,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E3,
        0x000006E3,
        0x000006E3
    };

    static _CharacterInfo _character000006E4 =
    {
        0x000006E4,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E4,
        0x000006E4,
        0x000006E4
    };

    static _CharacterInfo _character000006E5 =
    {
        0x000006E5,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E5,
        0x000006E5,
        0x000006E5
    };

    static _CharacterInfo _character000006E6 =
    {
        0x000006E6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E6,
        0x000006E6,
        0x000006E6
    };

    static _CharacterInfo _character000006E7 =
    {
        0x000006E7,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E7,
        0x000006E7,
        0x000006E7
    };

    static _CharacterInfo _character000006E8 =
    {
        0x000006E8,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E8,
        0x000006E8,
        0x000006E8
    };

    static _CharacterInfo _character000006E9 =
    {
        0x000006E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006E9,
        0x000006E9,
        0x000006E9
    };

    static _CharacterInfo _character000006EA =
    {
        0x000006EA,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006EA,
        0x000006EA,
        0x000006EA
    };

    static _CharacterInfo _character000006EB =
    {
        0x000006EB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006EB,
        0x000006EB,
        0x000006EB
    };

    static _CharacterInfo _character000006EC =
    {
        0x000006EC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006EC,
        0x000006EC,
        0x000006EC
    };

    static _CharacterInfo _character000006ED =
    {
        0x000006ED,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006ED,
        0x000006ED,
        0x000006ED
    };

    static _CharacterInfo _character000006EE =
    {
        0x000006EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006EE,
        0x000006EE,
        0x000006EE
    };

    static _CharacterInfo _character000006EF =
    {
        0x000006EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006EF,
        0x000006EF,
        0x000006EF
    };

    static _CharacterInfo _character000006F0 =
    {
        0x000006F0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000006F0,
        0x000006F0,
        0x000006F0
    };

    static _CharacterInfo _character000006F1 =
    {
        0x000006F1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000006F1,
        0x000006F1,
        0x000006F1
    };

    static _CharacterInfo _character000006F2 =
    {
        0x000006F2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000006F2,
        0x000006F2,
        0x000006F2
    };

    static _CharacterInfo _character000006F3 =
    {
        0x000006F3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000006F3,
        0x000006F3,
        0x000006F3
    };

    static _CharacterInfo _character000006F4 =
    {
        0x000006F4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000006F4,
        0x000006F4,
        0x000006F4
    };

    static _CharacterInfo _character000006F5 =
    {
        0x000006F5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000006F5,
        0x000006F5,
        0x000006F5
    };

    static _CharacterInfo _character000006F6 =
    {
        0x000006F6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000006F6,
        0x000006F6,
        0x000006F6
    };

    static _CharacterInfo _character000006F7 =
    {
        0x000006F7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000006F7,
        0x000006F7,
        0x000006F7
    };

    static _CharacterInfo _character000006F8 =
    {
        0x000006F8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000006F8,
        0x000006F8,
        0x000006F8
    };

    static _CharacterInfo _character000006F9 =
    {
        0x000006F9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000006F9,
        0x000006F9,
        0x000006F9
    };

    static _CharacterInfo _character000006FA =
    {
        0x000006FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FA,
        0x000006FA,
        0x000006FA
    };

    static _CharacterInfo _character000006FB =
    {
        0x000006FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FB,
        0x000006FB,
        0x000006FB
    };

    static _CharacterInfo _character000006FC =
    {
        0x000006FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FC,
        0x000006FC,
        0x000006FC
    };

    static _CharacterInfo _character000006FD =
    {
        0x000006FD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FD,
        0x000006FD,
        0x000006FD
    };

    static _CharacterInfo _character000006FE =
    {
        0x000006FE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FE,
        0x000006FE,
        0x000006FE
    };

    static _CharacterInfo _character000006FF =
    {
        0x000006FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000006FF,
        0x000006FF,
        0x000006FF
    };

    static _CharacterInfo _character00000700 =
    {
        0x00000700,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000700,
        0x00000700,
        0x00000700
    };

    static _CharacterInfo _character00000701 =
    {
        0x00000701,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000701,
        0x00000701,
        0x00000701
    };

    static _CharacterInfo _character00000702 =
    {
        0x00000702,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000702,
        0x00000702,
        0x00000702
    };

    static _CharacterInfo _character00000703 =
    {
        0x00000703,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000703,
        0x00000703,
        0x00000703
    };

    static _CharacterInfo _character00000704 =
    {
        0x00000704,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000704,
        0x00000704,
        0x00000704
    };

    static _CharacterInfo _character00000705 =
    {
        0x00000705,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000705,
        0x00000705,
        0x00000705
    };

    static _CharacterInfo _character00000706 =
    {
        0x00000706,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000706,
        0x00000706,
        0x00000706
    };

    static _CharacterInfo _character00000707 =
    {
        0x00000707,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000707,
        0x00000707,
        0x00000707
    };

    static _CharacterInfo _character00000708 =
    {
        0x00000708,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000708,
        0x00000708,
        0x00000708
    };

    static _CharacterInfo _character00000709 =
    {
        0x00000709,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000709,
        0x00000709,
        0x00000709
    };

    static _CharacterInfo _character0000070A =
    {
        0x0000070A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000070A,
        0x0000070A,
        0x0000070A
    };

    static _CharacterInfo _character0000070B =
    {
        0x0000070B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000070B,
        0x0000070B,
        0x0000070B
    };

    static _CharacterInfo _character0000070C =
    {
        0x0000070C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000070C,
        0x0000070C,
        0x0000070C
    };

    static _CharacterInfo _character0000070D =
    {
        0x0000070D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000070D,
        0x0000070D,
        0x0000070D
    };

    static _CharacterInfo _character0000070F =
    {
        0x0000070F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000070F,
        0x0000070F,
        0x0000070F
    };

    static _CharacterInfo _character00000710 =
    {
        0x00000710,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000710,
        0x00000710,
        0x00000710
    };

    static _CharacterInfo _character00000711 =
    {
        0x00000711,
        Iso10646::GeneralCategory_Mn,
        36,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000711,
        0x00000711,
        0x00000711
    };

    static _CharacterInfo _character00000712 =
    {
        0x00000712,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000712,
        0x00000712,
        0x00000712
    };

    static _CharacterInfo _character00000713 =
    {
        0x00000713,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000713,
        0x00000713,
        0x00000713
    };

    static _CharacterInfo _character00000714 =
    {
        0x00000714,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000714,
        0x00000714,
        0x00000714
    };

    static _CharacterInfo _character00000715 =
    {
        0x00000715,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000715,
        0x00000715,
        0x00000715
    };

    static _CharacterInfo _character00000716 =
    {
        0x00000716,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000716,
        0x00000716,
        0x00000716
    };

    static _CharacterInfo _character00000717 =
    {
        0x00000717,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000717,
        0x00000717,
        0x00000717
    };

    static _CharacterInfo _character00000718 =
    {
        0x00000718,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000718,
        0x00000718,
        0x00000718
    };

    static _CharacterInfo _character00000719 =
    {
        0x00000719,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000719,
        0x00000719,
        0x00000719
    };

    static _CharacterInfo _character0000071A =
    {
        0x0000071A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071A,
        0x0000071A,
        0x0000071A
    };

    static _CharacterInfo _character0000071B =
    {
        0x0000071B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071B,
        0x0000071B,
        0x0000071B
    };

    static _CharacterInfo _character0000071C =
    {
        0x0000071C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071C,
        0x0000071C,
        0x0000071C
    };

    static _CharacterInfo _character0000071D =
    {
        0x0000071D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071D,
        0x0000071D,
        0x0000071D
    };

    static _CharacterInfo _character0000071E =
    {
        0x0000071E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071E,
        0x0000071E,
        0x0000071E
    };

    static _CharacterInfo _character0000071F =
    {
        0x0000071F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000071F,
        0x0000071F,
        0x0000071F
    };

    static _CharacterInfo _character00000720 =
    {
        0x00000720,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000720,
        0x00000720,
        0x00000720
    };

    static _CharacterInfo _character00000721 =
    {
        0x00000721,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000721,
        0x00000721,
        0x00000721
    };

    static _CharacterInfo _character00000722 =
    {
        0x00000722,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000722,
        0x00000722,
        0x00000722
    };

    static _CharacterInfo _character00000723 =
    {
        0x00000723,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000723,
        0x00000723,
        0x00000723
    };

    static _CharacterInfo _character00000724 =
    {
        0x00000724,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000724,
        0x00000724,
        0x00000724
    };

    static _CharacterInfo _character00000725 =
    {
        0x00000725,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000725,
        0x00000725,
        0x00000725
    };

    static _CharacterInfo _character00000726 =
    {
        0x00000726,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000726,
        0x00000726,
        0x00000726
    };

    static _CharacterInfo _character00000727 =
    {
        0x00000727,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000727,
        0x00000727,
        0x00000727
    };

    static _CharacterInfo _character00000728 =
    {
        0x00000728,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000728,
        0x00000728,
        0x00000728
    };

    static _CharacterInfo _character00000729 =
    {
        0x00000729,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000729,
        0x00000729,
        0x00000729
    };

    static _CharacterInfo _character0000072A =
    {
        0x0000072A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072A,
        0x0000072A,
        0x0000072A
    };

    static _CharacterInfo _character0000072B =
    {
        0x0000072B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072B,
        0x0000072B,
        0x0000072B
    };

    static _CharacterInfo _character0000072C =
    {
        0x0000072C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072C,
        0x0000072C,
        0x0000072C
    };

    static _CharacterInfo _character0000072D =
    {
        0x0000072D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072D,
        0x0000072D,
        0x0000072D
    };

    static _CharacterInfo _character0000072E =
    {
        0x0000072E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072E,
        0x0000072E,
        0x0000072E
    };

    static _CharacterInfo _character0000072F =
    {
        0x0000072F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000072F,
        0x0000072F,
        0x0000072F
    };

    static _CharacterInfo _character00000730 =
    {
        0x00000730,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000730,
        0x00000730,
        0x00000730
    };

    static _CharacterInfo _character00000731 =
    {
        0x00000731,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000731,
        0x00000731,
        0x00000731
    };

    static _CharacterInfo _character00000732 =
    {
        0x00000732,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000732,
        0x00000732,
        0x00000732
    };

    static _CharacterInfo _character00000733 =
    {
        0x00000733,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000733,
        0x00000733,
        0x00000733
    };

    static _CharacterInfo _character00000734 =
    {
        0x00000734,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000734,
        0x00000734,
        0x00000734
    };

    static _CharacterInfo _character00000735 =
    {
        0x00000735,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000735,
        0x00000735,
        0x00000735
    };

    static _CharacterInfo _character00000736 =
    {
        0x00000736,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000736,
        0x00000736,
        0x00000736
    };

    static _CharacterInfo _character00000737 =
    {
        0x00000737,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000737,
        0x00000737,
        0x00000737
    };

    static _CharacterInfo _character00000738 =
    {
        0x00000738,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000738,
        0x00000738,
        0x00000738
    };

    static _CharacterInfo _character00000739 =
    {
        0x00000739,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000739,
        0x00000739,
        0x00000739
    };

    static _CharacterInfo _character0000073A =
    {
        0x0000073A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073A,
        0x0000073A,
        0x0000073A
    };

    static _CharacterInfo _character0000073B =
    {
        0x0000073B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073B,
        0x0000073B,
        0x0000073B
    };

    static _CharacterInfo _character0000073C =
    {
        0x0000073C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073C,
        0x0000073C,
        0x0000073C
    };

    static _CharacterInfo _character0000073D =
    {
        0x0000073D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073D,
        0x0000073D,
        0x0000073D
    };

    static _CharacterInfo _character0000073E =
    {
        0x0000073E,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073E,
        0x0000073E,
        0x0000073E
    };

    static _CharacterInfo _character0000073F =
    {
        0x0000073F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000073F,
        0x0000073F,
        0x0000073F
    };

    static _CharacterInfo _character00000740 =
    {
        0x00000740,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000740,
        0x00000740,
        0x00000740
    };

    static _CharacterInfo _character00000741 =
    {
        0x00000741,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000741,
        0x00000741,
        0x00000741
    };

    static _CharacterInfo _character00000742 =
    {
        0x00000742,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000742,
        0x00000742,
        0x00000742
    };

    static _CharacterInfo _character00000743 =
    {
        0x00000743,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000743,
        0x00000743,
        0x00000743
    };

    static _CharacterInfo _character00000744 =
    {
        0x00000744,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000744,
        0x00000744,
        0x00000744
    };

    static _CharacterInfo _character00000745 =
    {
        0x00000745,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000745,
        0x00000745,
        0x00000745
    };

    static _CharacterInfo _character00000746 =
    {
        0x00000746,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000746,
        0x00000746,
        0x00000746
    };

    static _CharacterInfo _character00000747 =
    {
        0x00000747,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000747,
        0x00000747,
        0x00000747
    };

    static _CharacterInfo _character00000748 =
    {
        0x00000748,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000748,
        0x00000748,
        0x00000748
    };

    static _CharacterInfo _character00000749 =
    {
        0x00000749,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000749,
        0x00000749,
        0x00000749
    };

    static _CharacterInfo _character0000074A =
    {
        0x0000074A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000074A,
        0x0000074A,
        0x0000074A
    };

    static _CharacterInfo _character0000074D =
    {
        0x0000074D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000074D,
        0x0000074D,
        0x0000074D
    };

    static _CharacterInfo _character0000074E =
    {
        0x0000074E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000074E,
        0x0000074E,
        0x0000074E
    };

    static _CharacterInfo _character0000074F =
    {
        0x0000074F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000074F,
        0x0000074F,
        0x0000074F
    };

    static _CharacterInfo _character00000750 =
    {
        0x00000750,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000750,
        0x00000750,
        0x00000750
    };

    static _CharacterInfo _character00000751 =
    {
        0x00000751,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000751,
        0x00000751,
        0x00000751
    };

    static _CharacterInfo _character00000752 =
    {
        0x00000752,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000752,
        0x00000752,
        0x00000752
    };

    static _CharacterInfo _character00000753 =
    {
        0x00000753,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000753,
        0x00000753,
        0x00000753
    };

    static _CharacterInfo _character00000754 =
    {
        0x00000754,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000754,
        0x00000754,
        0x00000754
    };

    static _CharacterInfo _character00000755 =
    {
        0x00000755,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000755,
        0x00000755,
        0x00000755
    };

    static _CharacterInfo _character00000756 =
    {
        0x00000756,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000756,
        0x00000756,
        0x00000756
    };

    static _CharacterInfo _character00000757 =
    {
        0x00000757,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000757,
        0x00000757,
        0x00000757
    };

    static _CharacterInfo _character00000758 =
    {
        0x00000758,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000758,
        0x00000758,
        0x00000758
    };

    static _CharacterInfo _character00000759 =
    {
        0x00000759,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000759,
        0x00000759,
        0x00000759
    };

    static _CharacterInfo _character0000075A =
    {
        0x0000075A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075A,
        0x0000075A,
        0x0000075A
    };

    static _CharacterInfo _character0000075B =
    {
        0x0000075B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075B,
        0x0000075B,
        0x0000075B
    };

    static _CharacterInfo _character0000075C =
    {
        0x0000075C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075C,
        0x0000075C,
        0x0000075C
    };

    static _CharacterInfo _character0000075D =
    {
        0x0000075D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075D,
        0x0000075D,
        0x0000075D
    };

    static _CharacterInfo _character0000075E =
    {
        0x0000075E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075E,
        0x0000075E,
        0x0000075E
    };

    static _CharacterInfo _character0000075F =
    {
        0x0000075F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000075F,
        0x0000075F,
        0x0000075F
    };

    static _CharacterInfo _character00000760 =
    {
        0x00000760,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000760,
        0x00000760,
        0x00000760
    };

    static _CharacterInfo _character00000761 =
    {
        0x00000761,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000761,
        0x00000761,
        0x00000761
    };

    static _CharacterInfo _character00000762 =
    {
        0x00000762,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000762,
        0x00000762,
        0x00000762
    };

    static _CharacterInfo _character00000763 =
    {
        0x00000763,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000763,
        0x00000763,
        0x00000763
    };

    static _CharacterInfo _character00000764 =
    {
        0x00000764,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000764,
        0x00000764,
        0x00000764
    };

    static _CharacterInfo _character00000765 =
    {
        0x00000765,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000765,
        0x00000765,
        0x00000765
    };

    static _CharacterInfo _character00000766 =
    {
        0x00000766,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000766,
        0x00000766,
        0x00000766
    };

    static _CharacterInfo _character00000767 =
    {
        0x00000767,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000767,
        0x00000767,
        0x00000767
    };

    static _CharacterInfo _character00000768 =
    {
        0x00000768,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000768,
        0x00000768,
        0x00000768
    };

    static _CharacterInfo _character00000769 =
    {
        0x00000769,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000769,
        0x00000769,
        0x00000769
    };

    static _CharacterInfo _character0000076A =
    {
        0x0000076A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000076A,
        0x0000076A,
        0x0000076A
    };

    static _CharacterInfo _character0000076B =
    {
        0x0000076B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000076B,
        0x0000076B,
        0x0000076B
    };

    static _CharacterInfo _character0000076C =
    {
        0x0000076C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000076C,
        0x0000076C,
        0x0000076C
    };

    static _CharacterInfo _character0000076D =
    {
        0x0000076D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000076D,
        0x0000076D,
        0x0000076D
    };

    static _CharacterInfo _character00000780 =
    {
        0x00000780,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000780,
        0x00000780,
        0x00000780
    };

    static _CharacterInfo _character00000781 =
    {
        0x00000781,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000781,
        0x00000781,
        0x00000781
    };

    static _CharacterInfo _character00000782 =
    {
        0x00000782,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000782,
        0x00000782,
        0x00000782
    };

    static _CharacterInfo _character00000783 =
    {
        0x00000783,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000783,
        0x00000783,
        0x00000783
    };

    static _CharacterInfo _character00000784 =
    {
        0x00000784,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000784,
        0x00000784,
        0x00000784
    };

    static _CharacterInfo _character00000785 =
    {
        0x00000785,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000785,
        0x00000785,
        0x00000785
    };

    static _CharacterInfo _character00000786 =
    {
        0x00000786,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000786,
        0x00000786,
        0x00000786
    };

    static _CharacterInfo _character00000787 =
    {
        0x00000787,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000787,
        0x00000787,
        0x00000787
    };

    static _CharacterInfo _character00000788 =
    {
        0x00000788,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000788,
        0x00000788,
        0x00000788
    };

    static _CharacterInfo _character00000789 =
    {
        0x00000789,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000789,
        0x00000789,
        0x00000789
    };

    static _CharacterInfo _character0000078A =
    {
        0x0000078A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078A,
        0x0000078A,
        0x0000078A
    };

    static _CharacterInfo _character0000078B =
    {
        0x0000078B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078B,
        0x0000078B,
        0x0000078B
    };

    static _CharacterInfo _character0000078C =
    {
        0x0000078C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078C,
        0x0000078C,
        0x0000078C
    };

    static _CharacterInfo _character0000078D =
    {
        0x0000078D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078D,
        0x0000078D,
        0x0000078D
    };

    static _CharacterInfo _character0000078E =
    {
        0x0000078E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078E,
        0x0000078E,
        0x0000078E
    };

    static _CharacterInfo _character0000078F =
    {
        0x0000078F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000078F,
        0x0000078F,
        0x0000078F
    };

    static _CharacterInfo _character00000790 =
    {
        0x00000790,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000790,
        0x00000790,
        0x00000790
    };

    static _CharacterInfo _character00000791 =
    {
        0x00000791,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000791,
        0x00000791,
        0x00000791
    };

    static _CharacterInfo _character00000792 =
    {
        0x00000792,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000792,
        0x00000792,
        0x00000792
    };

    static _CharacterInfo _character00000793 =
    {
        0x00000793,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000793,
        0x00000793,
        0x00000793
    };

    static _CharacterInfo _character00000794 =
    {
        0x00000794,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000794,
        0x00000794,
        0x00000794
    };

    static _CharacterInfo _character00000795 =
    {
        0x00000795,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000795,
        0x00000795,
        0x00000795
    };

    static _CharacterInfo _character00000796 =
    {
        0x00000796,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000796,
        0x00000796,
        0x00000796
    };

    static _CharacterInfo _character00000797 =
    {
        0x00000797,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000797,
        0x00000797,
        0x00000797
    };

    static _CharacterInfo _character00000798 =
    {
        0x00000798,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000798,
        0x00000798,
        0x00000798
    };

    static _CharacterInfo _character00000799 =
    {
        0x00000799,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000799,
        0x00000799,
        0x00000799
    };

    static _CharacterInfo _character0000079A =
    {
        0x0000079A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079A,
        0x0000079A,
        0x0000079A
    };

    static _CharacterInfo _character0000079B =
    {
        0x0000079B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079B,
        0x0000079B,
        0x0000079B
    };

    static _CharacterInfo _character0000079C =
    {
        0x0000079C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079C,
        0x0000079C,
        0x0000079C
    };

    static _CharacterInfo _character0000079D =
    {
        0x0000079D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079D,
        0x0000079D,
        0x0000079D
    };

    static _CharacterInfo _character0000079E =
    {
        0x0000079E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079E,
        0x0000079E,
        0x0000079E
    };

    static _CharacterInfo _character0000079F =
    {
        0x0000079F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000079F,
        0x0000079F,
        0x0000079F
    };

    static _CharacterInfo _character000007A0 =
    {
        0x000007A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A0,
        0x000007A0,
        0x000007A0
    };

    static _CharacterInfo _character000007A1 =
    {
        0x000007A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A1,
        0x000007A1,
        0x000007A1
    };

    static _CharacterInfo _character000007A2 =
    {
        0x000007A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A2,
        0x000007A2,
        0x000007A2
    };

    static _CharacterInfo _character000007A3 =
    {
        0x000007A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A3,
        0x000007A3,
        0x000007A3
    };

    static _CharacterInfo _character000007A4 =
    {
        0x000007A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A4,
        0x000007A4,
        0x000007A4
    };

    static _CharacterInfo _character000007A5 =
    {
        0x000007A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A5,
        0x000007A5,
        0x000007A5
    };

    static _CharacterInfo _character000007A6 =
    {
        0x000007A6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A6,
        0x000007A6,
        0x000007A6
    };

    static _CharacterInfo _character000007A7 =
    {
        0x000007A7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A7,
        0x000007A7,
        0x000007A7
    };

    static _CharacterInfo _character000007A8 =
    {
        0x000007A8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A8,
        0x000007A8,
        0x000007A8
    };

    static _CharacterInfo _character000007A9 =
    {
        0x000007A9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007A9,
        0x000007A9,
        0x000007A9
    };

    static _CharacterInfo _character000007AA =
    {
        0x000007AA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AA,
        0x000007AA,
        0x000007AA
    };

    static _CharacterInfo _character000007AB =
    {
        0x000007AB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AB,
        0x000007AB,
        0x000007AB
    };

    static _CharacterInfo _character000007AC =
    {
        0x000007AC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AC,
        0x000007AC,
        0x000007AC
    };

    static _CharacterInfo _character000007AD =
    {
        0x000007AD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AD,
        0x000007AD,
        0x000007AD
    };

    static _CharacterInfo _character000007AE =
    {
        0x000007AE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AE,
        0x000007AE,
        0x000007AE
    };

    static _CharacterInfo _character000007AF =
    {
        0x000007AF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007AF,
        0x000007AF,
        0x000007AF
    };

    static _CharacterInfo _character000007B0 =
    {
        0x000007B0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007B0,
        0x000007B0,
        0x000007B0
    };

    static _CharacterInfo _character000007B1 =
    {
        0x000007B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007B1,
        0x000007B1,
        0x000007B1
    };

    static _CharacterInfo _character000007C0 =
    {
        0x000007C0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000007C0,
        0x000007C0,
        0x000007C0
    };

    static _CharacterInfo _character000007C1 =
    {
        0x000007C1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000007C1,
        0x000007C1,
        0x000007C1
    };

    static _CharacterInfo _character000007C2 =
    {
        0x000007C2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000007C2,
        0x000007C2,
        0x000007C2
    };

    static _CharacterInfo _character000007C3 =
    {
        0x000007C3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000007C3,
        0x000007C3,
        0x000007C3
    };

    static _CharacterInfo _character000007C4 =
    {
        0x000007C4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000007C4,
        0x000007C4,
        0x000007C4
    };

    static _CharacterInfo _character000007C5 =
    {
        0x000007C5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000007C5,
        0x000007C5,
        0x000007C5
    };

    static _CharacterInfo _character000007C6 =
    {
        0x000007C6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000007C6,
        0x000007C6,
        0x000007C6
    };

    static _CharacterInfo _character000007C7 =
    {
        0x000007C7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000007C7,
        0x000007C7,
        0x000007C7
    };

    static _CharacterInfo _character000007C8 =
    {
        0x000007C8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000007C8,
        0x000007C8,
        0x000007C8
    };

    static _CharacterInfo _character000007C9 =
    {
        0x000007C9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000007C9,
        0x000007C9,
        0x000007C9
    };

    static _CharacterInfo _character000007CA =
    {
        0x000007CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CA,
        0x000007CA,
        0x000007CA
    };

    static _CharacterInfo _character000007CB =
    {
        0x000007CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CB,
        0x000007CB,
        0x000007CB
    };

    static _CharacterInfo _character000007CC =
    {
        0x000007CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CC,
        0x000007CC,
        0x000007CC
    };

    static _CharacterInfo _character000007CD =
    {
        0x000007CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CD,
        0x000007CD,
        0x000007CD
    };

    static _CharacterInfo _character000007CE =
    {
        0x000007CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CE,
        0x000007CE,
        0x000007CE
    };

    static _CharacterInfo _character000007CF =
    {
        0x000007CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007CF,
        0x000007CF,
        0x000007CF
    };

    static _CharacterInfo _character000007D0 =
    {
        0x000007D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D0,
        0x000007D0,
        0x000007D0
    };

    static _CharacterInfo _character000007D1 =
    {
        0x000007D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D1,
        0x000007D1,
        0x000007D1
    };

    static _CharacterInfo _character000007D2 =
    {
        0x000007D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D2,
        0x000007D2,
        0x000007D2
    };

    static _CharacterInfo _character000007D3 =
    {
        0x000007D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D3,
        0x000007D3,
        0x000007D3
    };

    static _CharacterInfo _character000007D4 =
    {
        0x000007D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D4,
        0x000007D4,
        0x000007D4
    };

    static _CharacterInfo _character000007D5 =
    {
        0x000007D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D5,
        0x000007D5,
        0x000007D5
    };

    static _CharacterInfo _character000007D6 =
    {
        0x000007D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D6,
        0x000007D6,
        0x000007D6
    };

    static _CharacterInfo _character000007D7 =
    {
        0x000007D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D7,
        0x000007D7,
        0x000007D7
    };

    static _CharacterInfo _character000007D8 =
    {
        0x000007D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D8,
        0x000007D8,
        0x000007D8
    };

    static _CharacterInfo _character000007D9 =
    {
        0x000007D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007D9,
        0x000007D9,
        0x000007D9
    };

    static _CharacterInfo _character000007DA =
    {
        0x000007DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DA,
        0x000007DA,
        0x000007DA
    };

    static _CharacterInfo _character000007DB =
    {
        0x000007DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DB,
        0x000007DB,
        0x000007DB
    };

    static _CharacterInfo _character000007DC =
    {
        0x000007DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DC,
        0x000007DC,
        0x000007DC
    };

    static _CharacterInfo _character000007DD =
    {
        0x000007DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DD,
        0x000007DD,
        0x000007DD
    };

    static _CharacterInfo _character000007DE =
    {
        0x000007DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DE,
        0x000007DE,
        0x000007DE
    };

    static _CharacterInfo _character000007DF =
    {
        0x000007DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007DF,
        0x000007DF,
        0x000007DF
    };

    static _CharacterInfo _character000007E0 =
    {
        0x000007E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E0,
        0x000007E0,
        0x000007E0
    };

    static _CharacterInfo _character000007E1 =
    {
        0x000007E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E1,
        0x000007E1,
        0x000007E1
    };

    static _CharacterInfo _character000007E2 =
    {
        0x000007E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E2,
        0x000007E2,
        0x000007E2
    };

    static _CharacterInfo _character000007E3 =
    {
        0x000007E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E3,
        0x000007E3,
        0x000007E3
    };

    static _CharacterInfo _character000007E4 =
    {
        0x000007E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E4,
        0x000007E4,
        0x000007E4
    };

    static _CharacterInfo _character000007E5 =
    {
        0x000007E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E5,
        0x000007E5,
        0x000007E5
    };

    static _CharacterInfo _character000007E6 =
    {
        0x000007E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E6,
        0x000007E6,
        0x000007E6
    };

    static _CharacterInfo _character000007E7 =
    {
        0x000007E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E7,
        0x000007E7,
        0x000007E7
    };

    static _CharacterInfo _character000007E8 =
    {
        0x000007E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E8,
        0x000007E8,
        0x000007E8
    };

    static _CharacterInfo _character000007E9 =
    {
        0x000007E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007E9,
        0x000007E9,
        0x000007E9
    };

    static _CharacterInfo _character000007EA =
    {
        0x000007EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007EA,
        0x000007EA,
        0x000007EA
    };

    static _CharacterInfo _character000007EB =
    {
        0x000007EB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007EB,
        0x000007EB,
        0x000007EB
    };

    static _CharacterInfo _character000007EC =
    {
        0x000007EC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007EC,
        0x000007EC,
        0x000007EC
    };

    static _CharacterInfo _character000007ED =
    {
        0x000007ED,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007ED,
        0x000007ED,
        0x000007ED
    };

    static _CharacterInfo _character000007EE =
    {
        0x000007EE,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007EE,
        0x000007EE,
        0x000007EE
    };

    static _CharacterInfo _character000007EF =
    {
        0x000007EF,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007EF,
        0x000007EF,
        0x000007EF
    };

    static _CharacterInfo _character000007F0 =
    {
        0x000007F0,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F0,
        0x000007F0,
        0x000007F0
    };

    static _CharacterInfo _character000007F1 =
    {
        0x000007F1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F1,
        0x000007F1,
        0x000007F1
    };

    static _CharacterInfo _character000007F2 =
    {
        0x000007F2,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F2,
        0x000007F2,
        0x000007F2
    };

    static _CharacterInfo _character000007F3 =
    {
        0x000007F3,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F3,
        0x000007F3,
        0x000007F3
    };

    static _CharacterInfo _character000007F4 =
    {
        0x000007F4,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F4,
        0x000007F4,
        0x000007F4
    };

    static _CharacterInfo _character000007F5 =
    {
        0x000007F5,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F5,
        0x000007F5,
        0x000007F5
    };

    static _CharacterInfo _character000007F6 =
    {
        0x000007F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F6,
        0x000007F6,
        0x000007F6
    };

    static _CharacterInfo _character000007F7 =
    {
        0x000007F7,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F7,
        0x000007F7,
        0x000007F7
    };

    static _CharacterInfo _character000007F8 =
    {
        0x000007F8,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F8,
        0x000007F8,
        0x000007F8
    };

    static _CharacterInfo _character000007F9 =
    {
        0x000007F9,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007F9,
        0x000007F9,
        0x000007F9
    };

    static _CharacterInfo _character000007FA =
    {
        0x000007FA,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000007FA,
        0x000007FA,
        0x000007FA
    };

    static _CharacterInfo _character00000901 =
    {
        0x00000901,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000901,
        0x00000901,
        0x00000901
    };

    static _CharacterInfo _character00000902 =
    {
        0x00000902,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000902,
        0x00000902,
        0x00000902
    };

    static _CharacterInfo _character00000903 =
    {
        0x00000903,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000903,
        0x00000903,
        0x00000903
    };

    static _CharacterInfo _character00000904 =
    {
        0x00000904,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000904,
        0x00000904,
        0x00000904
    };

    static _CharacterInfo _character00000905 =
    {
        0x00000905,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000905,
        0x00000905,
        0x00000905
    };

    static _CharacterInfo _character00000906 =
    {
        0x00000906,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000906,
        0x00000906,
        0x00000906
    };

    static _CharacterInfo _character00000907 =
    {
        0x00000907,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000907,
        0x00000907,
        0x00000907
    };

    static _CharacterInfo _character00000908 =
    {
        0x00000908,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000908,
        0x00000908,
        0x00000908
    };

    static _CharacterInfo _character00000909 =
    {
        0x00000909,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000909,
        0x00000909,
        0x00000909
    };

    static _CharacterInfo _character0000090A =
    {
        0x0000090A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090A,
        0x0000090A,
        0x0000090A
    };

    static _CharacterInfo _character0000090B =
    {
        0x0000090B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090B,
        0x0000090B,
        0x0000090B
    };

    static _CharacterInfo _character0000090C =
    {
        0x0000090C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090C,
        0x0000090C,
        0x0000090C
    };

    static _CharacterInfo _character0000090D =
    {
        0x0000090D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090D,
        0x0000090D,
        0x0000090D
    };

    static _CharacterInfo _character0000090E =
    {
        0x0000090E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090E,
        0x0000090E,
        0x0000090E
    };

    static _CharacterInfo _character0000090F =
    {
        0x0000090F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000090F,
        0x0000090F,
        0x0000090F
    };

    static _CharacterInfo _character00000910 =
    {
        0x00000910,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000910,
        0x00000910,
        0x00000910
    };

    static _CharacterInfo _character00000911 =
    {
        0x00000911,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000911,
        0x00000911,
        0x00000911
    };

    static _CharacterInfo _character00000912 =
    {
        0x00000912,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000912,
        0x00000912,
        0x00000912
    };

    static _CharacterInfo _character00000913 =
    {
        0x00000913,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000913,
        0x00000913,
        0x00000913
    };

    static _CharacterInfo _character00000914 =
    {
        0x00000914,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000914,
        0x00000914,
        0x00000914
    };

    static _CharacterInfo _character00000915 =
    {
        0x00000915,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000915,
        0x00000915,
        0x00000915
    };

    static _CharacterInfo _character00000916 =
    {
        0x00000916,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000916,
        0x00000916,
        0x00000916
    };

    static _CharacterInfo _character00000917 =
    {
        0x00000917,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000917,
        0x00000917,
        0x00000917
    };

    static _CharacterInfo _character00000918 =
    {
        0x00000918,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000918,
        0x00000918,
        0x00000918
    };

    static _CharacterInfo _character00000919 =
    {
        0x00000919,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000919,
        0x00000919,
        0x00000919
    };

    static _CharacterInfo _character0000091A =
    {
        0x0000091A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091A,
        0x0000091A,
        0x0000091A
    };

    static _CharacterInfo _character0000091B =
    {
        0x0000091B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091B,
        0x0000091B,
        0x0000091B
    };

    static _CharacterInfo _character0000091C =
    {
        0x0000091C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091C,
        0x0000091C,
        0x0000091C
    };

    static _CharacterInfo _character0000091D =
    {
        0x0000091D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091D,
        0x0000091D,
        0x0000091D
    };

    static _CharacterInfo _character0000091E =
    {
        0x0000091E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091E,
        0x0000091E,
        0x0000091E
    };

    static _CharacterInfo _character0000091F =
    {
        0x0000091F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000091F,
        0x0000091F,
        0x0000091F
    };

    static _CharacterInfo _character00000920 =
    {
        0x00000920,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000920,
        0x00000920,
        0x00000920
    };

    static _CharacterInfo _character00000921 =
    {
        0x00000921,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000921,
        0x00000921,
        0x00000921
    };

    static _CharacterInfo _character00000922 =
    {
        0x00000922,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000922,
        0x00000922,
        0x00000922
    };

    static _CharacterInfo _character00000923 =
    {
        0x00000923,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000923,
        0x00000923,
        0x00000923
    };

    static _CharacterInfo _character00000924 =
    {
        0x00000924,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000924,
        0x00000924,
        0x00000924
    };

    static _CharacterInfo _character00000925 =
    {
        0x00000925,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000925,
        0x00000925,
        0x00000925
    };

    static _CharacterInfo _character00000926 =
    {
        0x00000926,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000926,
        0x00000926,
        0x00000926
    };

    static _CharacterInfo _character00000927 =
    {
        0x00000927,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000927,
        0x00000927,
        0x00000927
    };

    static _CharacterInfo _character00000928 =
    {
        0x00000928,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000928,
        0x00000928,
        0x00000928
    };

    static Char _decompositionMapping00000929[] = 
    {
        0x00000928,
        0x0000093C
    };

    static _CharacterInfo _character00000929 =
    {
        0x00000929,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000929,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000929,
        0x00000929,
        0x00000929
    };

    static _CharacterInfo _character0000092A =
    {
        0x0000092A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092A,
        0x0000092A,
        0x0000092A
    };

    static _CharacterInfo _character0000092B =
    {
        0x0000092B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092B,
        0x0000092B,
        0x0000092B
    };

    static _CharacterInfo _character0000092C =
    {
        0x0000092C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092C,
        0x0000092C,
        0x0000092C
    };

    static _CharacterInfo _character0000092D =
    {
        0x0000092D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092D,
        0x0000092D,
        0x0000092D
    };

    static _CharacterInfo _character0000092E =
    {
        0x0000092E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092E,
        0x0000092E,
        0x0000092E
    };

    static _CharacterInfo _character0000092F =
    {
        0x0000092F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000092F,
        0x0000092F,
        0x0000092F
    };

    static _CharacterInfo _character00000930 =
    {
        0x00000930,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000930,
        0x00000930,
        0x00000930
    };

    static Char _decompositionMapping00000931[] = 
    {
        0x00000930,
        0x0000093C
    };

    static _CharacterInfo _character00000931 =
    {
        0x00000931,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000931,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000931,
        0x00000931,
        0x00000931
    };

    static _CharacterInfo _character00000932 =
    {
        0x00000932,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000932,
        0x00000932,
        0x00000932
    };

    static _CharacterInfo _character00000933 =
    {
        0x00000933,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000933,
        0x00000933,
        0x00000933
    };

    static Char _decompositionMapping00000934[] = 
    {
        0x00000933,
        0x0000093C
    };

    static _CharacterInfo _character00000934 =
    {
        0x00000934,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000934,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000934,
        0x00000934,
        0x00000934
    };

    static _CharacterInfo _character00000935 =
    {
        0x00000935,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000935,
        0x00000935,
        0x00000935
    };

    static _CharacterInfo _character00000936 =
    {
        0x00000936,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000936,
        0x00000936,
        0x00000936
    };

    static _CharacterInfo _character00000937 =
    {
        0x00000937,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000937,
        0x00000937,
        0x00000937
    };

    static _CharacterInfo _character00000938 =
    {
        0x00000938,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000938,
        0x00000938,
        0x00000938
    };

    static _CharacterInfo _character00000939 =
    {
        0x00000939,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000939,
        0x00000939,
        0x00000939
    };

    static _CharacterInfo _character0000093C =
    {
        0x0000093C,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000093C,
        0x0000093C,
        0x0000093C
    };

    static _CharacterInfo _character0000093D =
    {
        0x0000093D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000093D,
        0x0000093D,
        0x0000093D
    };

    static _CharacterInfo _character0000093E =
    {
        0x0000093E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000093E,
        0x0000093E,
        0x0000093E
    };

    static _CharacterInfo _character0000093F =
    {
        0x0000093F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000093F,
        0x0000093F,
        0x0000093F
    };

    static _CharacterInfo _character00000940 =
    {
        0x00000940,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000940,
        0x00000940,
        0x00000940
    };

    static _CharacterInfo _character00000941 =
    {
        0x00000941,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000941,
        0x00000941,
        0x00000941
    };

    static _CharacterInfo _character00000942 =
    {
        0x00000942,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000942,
        0x00000942,
        0x00000942
    };

    static _CharacterInfo _character00000943 =
    {
        0x00000943,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000943,
        0x00000943,
        0x00000943
    };

    static _CharacterInfo _character00000944 =
    {
        0x00000944,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000944,
        0x00000944,
        0x00000944
    };

    static _CharacterInfo _character00000945 =
    {
        0x00000945,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000945,
        0x00000945,
        0x00000945
    };

    static _CharacterInfo _character00000946 =
    {
        0x00000946,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000946,
        0x00000946,
        0x00000946
    };

    static _CharacterInfo _character00000947 =
    {
        0x00000947,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000947,
        0x00000947,
        0x00000947
    };

    static _CharacterInfo _character00000948 =
    {
        0x00000948,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000948,
        0x00000948,
        0x00000948
    };

    static _CharacterInfo _character00000949 =
    {
        0x00000949,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000949,
        0x00000949,
        0x00000949
    };

    static _CharacterInfo _character0000094A =
    {
        0x0000094A,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000094A,
        0x0000094A,
        0x0000094A
    };

    static _CharacterInfo _character0000094B =
    {
        0x0000094B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000094B,
        0x0000094B,
        0x0000094B
    };

    static _CharacterInfo _character0000094C =
    {
        0x0000094C,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000094C,
        0x0000094C,
        0x0000094C
    };

    static _CharacterInfo _character0000094D =
    {
        0x0000094D,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000094D,
        0x0000094D,
        0x0000094D
    };

    static _CharacterInfo _character00000950 =
    {
        0x00000950,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000950,
        0x00000950,
        0x00000950
    };

    static _CharacterInfo _character00000951 =
    {
        0x00000951,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000951,
        0x00000951,
        0x00000951
    };

    static _CharacterInfo _character00000952 =
    {
        0x00000952,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000952,
        0x00000952,
        0x00000952
    };

    static _CharacterInfo _character00000953 =
    {
        0x00000953,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000953,
        0x00000953,
        0x00000953
    };

    static _CharacterInfo _character00000954 =
    {
        0x00000954,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000954,
        0x00000954,
        0x00000954
    };

    static Char _decompositionMapping00000958[] = 
    {
        0x00000915,
        0x0000093C
    };

    static _CharacterInfo _character00000958 =
    {
        0x00000958,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000958,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000958,
        0x00000958,
        0x00000958
    };

    static Char _decompositionMapping00000959[] = 
    {
        0x00000916,
        0x0000093C
    };

    static _CharacterInfo _character00000959 =
    {
        0x00000959,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000959,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000959,
        0x00000959,
        0x00000959
    };

    static Char _decompositionMapping0000095A[] = 
    {
        0x00000917,
        0x0000093C
    };

    static _CharacterInfo _character0000095A =
    {
        0x0000095A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095A,
        0x0000095A,
        0x0000095A
    };

    static Char _decompositionMapping0000095B[] = 
    {
        0x0000091C,
        0x0000093C
    };

    static _CharacterInfo _character0000095B =
    {
        0x0000095B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095B,
        0x0000095B,
        0x0000095B
    };

    static Char _decompositionMapping0000095C[] = 
    {
        0x00000921,
        0x0000093C
    };

    static _CharacterInfo _character0000095C =
    {
        0x0000095C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095C,
        0x0000095C,
        0x0000095C
    };

    static Char _decompositionMapping0000095D[] = 
    {
        0x00000922,
        0x0000093C
    };

    static _CharacterInfo _character0000095D =
    {
        0x0000095D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095D,
        0x0000095D,
        0x0000095D
    };

    static Char _decompositionMapping0000095E[] = 
    {
        0x0000092B,
        0x0000093C
    };

    static _CharacterInfo _character0000095E =
    {
        0x0000095E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095E,
        0x0000095E,
        0x0000095E
    };

    static Char _decompositionMapping0000095F[] = 
    {
        0x0000092F,
        0x0000093C
    };

    static _CharacterInfo _character0000095F =
    {
        0x0000095F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000095F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000095F,
        0x0000095F,
        0x0000095F
    };

    static _CharacterInfo _character00000960 =
    {
        0x00000960,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000960,
        0x00000960,
        0x00000960
    };

    static _CharacterInfo _character00000961 =
    {
        0x00000961,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000961,
        0x00000961,
        0x00000961
    };

    static _CharacterInfo _character00000962 =
    {
        0x00000962,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000962,
        0x00000962,
        0x00000962
    };

    static _CharacterInfo _character00000963 =
    {
        0x00000963,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000963,
        0x00000963,
        0x00000963
    };

    static _CharacterInfo _character00000964 =
    {
        0x00000964,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000964,
        0x00000964,
        0x00000964
    };

    static _CharacterInfo _character00000965 =
    {
        0x00000965,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000965,
        0x00000965,
        0x00000965
    };

    static _CharacterInfo _character00000966 =
    {
        0x00000966,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000966,
        0x00000966,
        0x00000966
    };

    static _CharacterInfo _character00000967 =
    {
        0x00000967,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000967,
        0x00000967,
        0x00000967
    };

    static _CharacterInfo _character00000968 =
    {
        0x00000968,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000968,
        0x00000968,
        0x00000968
    };

    static _CharacterInfo _character00000969 =
    {
        0x00000969,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000969,
        0x00000969,
        0x00000969
    };

    static _CharacterInfo _character0000096A =
    {
        0x0000096A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000096A,
        0x0000096A,
        0x0000096A
    };

    static _CharacterInfo _character0000096B =
    {
        0x0000096B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000096B,
        0x0000096B,
        0x0000096B
    };

    static _CharacterInfo _character0000096C =
    {
        0x0000096C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000096C,
        0x0000096C,
        0x0000096C
    };

    static _CharacterInfo _character0000096D =
    {
        0x0000096D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000096D,
        0x0000096D,
        0x0000096D
    };

    static _CharacterInfo _character0000096E =
    {
        0x0000096E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000096E,
        0x0000096E,
        0x0000096E
    };

    static _CharacterInfo _character0000096F =
    {
        0x0000096F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0000096F,
        0x0000096F,
        0x0000096F
    };

    static _CharacterInfo _character00000970 =
    {
        0x00000970,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000970,
        0x00000970,
        0x00000970
    };

    static _CharacterInfo _character0000097B =
    {
        0x0000097B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000097B,
        0x0000097B,
        0x0000097B
    };

    static _CharacterInfo _character0000097C =
    {
        0x0000097C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000097C,
        0x0000097C,
        0x0000097C
    };

    static _CharacterInfo _character0000097D =
    {
        0x0000097D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000097D,
        0x0000097D,
        0x0000097D
    };

    static _CharacterInfo _character0000097E =
    {
        0x0000097E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000097E,
        0x0000097E,
        0x0000097E
    };

    static _CharacterInfo _character0000097F =
    {
        0x0000097F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000097F,
        0x0000097F,
        0x0000097F
    };

    static _CharacterInfo _character00000981 =
    {
        0x00000981,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000981,
        0x00000981,
        0x00000981
    };

    static _CharacterInfo _character00000982 =
    {
        0x00000982,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000982,
        0x00000982,
        0x00000982
    };

    static _CharacterInfo _character00000983 =
    {
        0x00000983,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000983,
        0x00000983,
        0x00000983
    };

    static _CharacterInfo _character00000985 =
    {
        0x00000985,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000985,
        0x00000985,
        0x00000985
    };

    static _CharacterInfo _character00000986 =
    {
        0x00000986,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000986,
        0x00000986,
        0x00000986
    };

    static _CharacterInfo _character00000987 =
    {
        0x00000987,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000987,
        0x00000987,
        0x00000987
    };

    static _CharacterInfo _character00000988 =
    {
        0x00000988,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000988,
        0x00000988,
        0x00000988
    };

    static _CharacterInfo _character00000989 =
    {
        0x00000989,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000989,
        0x00000989,
        0x00000989
    };

    static _CharacterInfo _character0000098A =
    {
        0x0000098A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000098A,
        0x0000098A,
        0x0000098A
    };

    static _CharacterInfo _character0000098B =
    {
        0x0000098B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000098B,
        0x0000098B,
        0x0000098B
    };

    static _CharacterInfo _character0000098C =
    {
        0x0000098C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000098C,
        0x0000098C,
        0x0000098C
    };

    static _CharacterInfo _character0000098F =
    {
        0x0000098F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000098F,
        0x0000098F,
        0x0000098F
    };

    static _CharacterInfo _character00000990 =
    {
        0x00000990,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000990,
        0x00000990,
        0x00000990
    };

    static _CharacterInfo _character00000993 =
    {
        0x00000993,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000993,
        0x00000993,
        0x00000993
    };

    static _CharacterInfo _character00000994 =
    {
        0x00000994,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000994,
        0x00000994,
        0x00000994
    };

    static _CharacterInfo _character00000995 =
    {
        0x00000995,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000995,
        0x00000995,
        0x00000995
    };

    static _CharacterInfo _character00000996 =
    {
        0x00000996,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000996,
        0x00000996,
        0x00000996
    };

    static _CharacterInfo _character00000997 =
    {
        0x00000997,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000997,
        0x00000997,
        0x00000997
    };

    static _CharacterInfo _character00000998 =
    {
        0x00000998,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000998,
        0x00000998,
        0x00000998
    };

    static _CharacterInfo _character00000999 =
    {
        0x00000999,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000999,
        0x00000999,
        0x00000999
    };

    static _CharacterInfo _character0000099A =
    {
        0x0000099A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099A,
        0x0000099A,
        0x0000099A
    };

    static _CharacterInfo _character0000099B =
    {
        0x0000099B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099B,
        0x0000099B,
        0x0000099B
    };

    static _CharacterInfo _character0000099C =
    {
        0x0000099C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099C,
        0x0000099C,
        0x0000099C
    };

    static _CharacterInfo _character0000099D =
    {
        0x0000099D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099D,
        0x0000099D,
        0x0000099D
    };

    static _CharacterInfo _character0000099E =
    {
        0x0000099E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099E,
        0x0000099E,
        0x0000099E
    };

    static _CharacterInfo _character0000099F =
    {
        0x0000099F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000099F,
        0x0000099F,
        0x0000099F
    };

    static _CharacterInfo _character000009A0 =
    {
        0x000009A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A0,
        0x000009A0,
        0x000009A0
    };

    static _CharacterInfo _character000009A1 =
    {
        0x000009A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A1,
        0x000009A1,
        0x000009A1
    };

    static _CharacterInfo _character000009A2 =
    {
        0x000009A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A2,
        0x000009A2,
        0x000009A2
    };

    static _CharacterInfo _character000009A3 =
    {
        0x000009A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A3,
        0x000009A3,
        0x000009A3
    };

    static _CharacterInfo _character000009A4 =
    {
        0x000009A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A4,
        0x000009A4,
        0x000009A4
    };

    static _CharacterInfo _character000009A5 =
    {
        0x000009A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A5,
        0x000009A5,
        0x000009A5
    };

    static _CharacterInfo _character000009A6 =
    {
        0x000009A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A6,
        0x000009A6,
        0x000009A6
    };

    static _CharacterInfo _character000009A7 =
    {
        0x000009A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A7,
        0x000009A7,
        0x000009A7
    };

    static _CharacterInfo _character000009A8 =
    {
        0x000009A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009A8,
        0x000009A8,
        0x000009A8
    };

    static _CharacterInfo _character000009AA =
    {
        0x000009AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AA,
        0x000009AA,
        0x000009AA
    };

    static _CharacterInfo _character000009AB =
    {
        0x000009AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AB,
        0x000009AB,
        0x000009AB
    };

    static _CharacterInfo _character000009AC =
    {
        0x000009AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AC,
        0x000009AC,
        0x000009AC
    };

    static _CharacterInfo _character000009AD =
    {
        0x000009AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AD,
        0x000009AD,
        0x000009AD
    };

    static _CharacterInfo _character000009AE =
    {
        0x000009AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AE,
        0x000009AE,
        0x000009AE
    };

    static _CharacterInfo _character000009AF =
    {
        0x000009AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009AF,
        0x000009AF,
        0x000009AF
    };

    static _CharacterInfo _character000009B0 =
    {
        0x000009B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B0,
        0x000009B0,
        0x000009B0
    };

    static _CharacterInfo _character000009B2 =
    {
        0x000009B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B2,
        0x000009B2,
        0x000009B2
    };

    static _CharacterInfo _character000009B6 =
    {
        0x000009B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B6,
        0x000009B6,
        0x000009B6
    };

    static _CharacterInfo _character000009B7 =
    {
        0x000009B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B7,
        0x000009B7,
        0x000009B7
    };

    static _CharacterInfo _character000009B8 =
    {
        0x000009B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B8,
        0x000009B8,
        0x000009B8
    };

    static _CharacterInfo _character000009B9 =
    {
        0x000009B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009B9,
        0x000009B9,
        0x000009B9
    };

    static _CharacterInfo _character000009BC =
    {
        0x000009BC,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009BC,
        0x000009BC,
        0x000009BC
    };

    static _CharacterInfo _character000009BD =
    {
        0x000009BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009BD,
        0x000009BD,
        0x000009BD
    };

    static _CharacterInfo _character000009BE =
    {
        0x000009BE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009BE,
        0x000009BE,
        0x000009BE
    };

    static _CharacterInfo _character000009BF =
    {
        0x000009BF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009BF,
        0x000009BF,
        0x000009BF
    };

    static _CharacterInfo _character000009C0 =
    {
        0x000009C0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C0,
        0x000009C0,
        0x000009C0
    };

    static _CharacterInfo _character000009C1 =
    {
        0x000009C1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C1,
        0x000009C1,
        0x000009C1
    };

    static _CharacterInfo _character000009C2 =
    {
        0x000009C2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C2,
        0x000009C2,
        0x000009C2
    };

    static _CharacterInfo _character000009C3 =
    {
        0x000009C3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C3,
        0x000009C3,
        0x000009C3
    };

    static _CharacterInfo _character000009C4 =
    {
        0x000009C4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C4,
        0x000009C4,
        0x000009C4
    };

    static _CharacterInfo _character000009C7 =
    {
        0x000009C7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C7,
        0x000009C7,
        0x000009C7
    };

    static _CharacterInfo _character000009C8 =
    {
        0x000009C8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009C8,
        0x000009C8,
        0x000009C8
    };

    static Char _decompositionMapping000009CB[] = 
    {
        0x000009C7,
        0x000009BE
    };

    static _CharacterInfo _character000009CB =
    {
        0x000009CB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000009CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009CB,
        0x000009CB,
        0x000009CB
    };

    static Char _decompositionMapping000009CC[] = 
    {
        0x000009C7,
        0x000009D7
    };

    static _CharacterInfo _character000009CC =
    {
        0x000009CC,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000009CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009CC,
        0x000009CC,
        0x000009CC
    };

    static _CharacterInfo _character000009CD =
    {
        0x000009CD,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009CD,
        0x000009CD,
        0x000009CD
    };

    static _CharacterInfo _character000009CE =
    {
        0x000009CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009CE,
        0x000009CE,
        0x000009CE
    };

    static _CharacterInfo _character000009D7 =
    {
        0x000009D7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009D7,
        0x000009D7,
        0x000009D7
    };

    static Char _decompositionMapping000009DC[] = 
    {
        0x000009A1,
        0x000009BC
    };

    static _CharacterInfo _character000009DC =
    {
        0x000009DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000009DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009DC,
        0x000009DC,
        0x000009DC
    };

    static Char _decompositionMapping000009DD[] = 
    {
        0x000009A2,
        0x000009BC
    };

    static _CharacterInfo _character000009DD =
    {
        0x000009DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000009DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009DD,
        0x000009DD,
        0x000009DD
    };

    static Char _decompositionMapping000009DF[] = 
    {
        0x000009AF,
        0x000009BC
    };

    static _CharacterInfo _character000009DF =
    {
        0x000009DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000009DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009DF,
        0x000009DF,
        0x000009DF
    };

    static _CharacterInfo _character000009E0 =
    {
        0x000009E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009E0,
        0x000009E0,
        0x000009E0
    };

    static _CharacterInfo _character000009E1 =
    {
        0x000009E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009E1,
        0x000009E1,
        0x000009E1
    };

    static _CharacterInfo _character000009E2 =
    {
        0x000009E2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009E2,
        0x000009E2,
        0x000009E2
    };

    static _CharacterInfo _character000009E3 =
    {
        0x000009E3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009E3,
        0x000009E3,
        0x000009E3
    };

    static _CharacterInfo _character000009E6 =
    {
        0x000009E6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000009E6,
        0x000009E6,
        0x000009E6
    };

    static _CharacterInfo _character000009E7 =
    {
        0x000009E7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000009E7,
        0x000009E7,
        0x000009E7
    };

    static _CharacterInfo _character000009E8 =
    {
        0x000009E8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000009E8,
        0x000009E8,
        0x000009E8
    };

    static _CharacterInfo _character000009E9 =
    {
        0x000009E9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000009E9,
        0x000009E9,
        0x000009E9
    };

    static _CharacterInfo _character000009EA =
    {
        0x000009EA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000009EA,
        0x000009EA,
        0x000009EA
    };

    static _CharacterInfo _character000009EB =
    {
        0x000009EB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000009EB,
        0x000009EB,
        0x000009EB
    };

    static _CharacterInfo _character000009EC =
    {
        0x000009EC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000009EC,
        0x000009EC,
        0x000009EC
    };

    static _CharacterInfo _character000009ED =
    {
        0x000009ED,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000009ED,
        0x000009ED,
        0x000009ED
    };

    static _CharacterInfo _character000009EE =
    {
        0x000009EE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000009EE,
        0x000009EE,
        0x000009EE
    };

    static _CharacterInfo _character000009EF =
    {
        0x000009EF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000009EF,
        0x000009EF,
        0x000009EF
    };

    static _CharacterInfo _character000009F0 =
    {
        0x000009F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009F0,
        0x000009F0,
        0x000009F0
    };

    static _CharacterInfo _character000009F1 =
    {
        0x000009F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009F1,
        0x000009F1,
        0x000009F1
    };

    static _CharacterInfo _character000009F2 =
    {
        0x000009F2,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009F2,
        0x000009F2,
        0x000009F2
    };

    static _CharacterInfo _character000009F3 =
    {
        0x000009F3,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009F3,
        0x000009F3,
        0x000009F3
    };

    static _CharacterInfo _character000009F4 =
    {
        0x000009F4,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x000009F4,
        0x000009F4,
        0x000009F4
    };

    static _CharacterInfo _character000009F5 =
    {
        0x000009F5,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x000009F5,
        0x000009F5,
        0x000009F5
    };

    static _CharacterInfo _character000009F6 =
    {
        0x000009F6,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x000009F6,
        0x000009F6,
        0x000009F6
    };

    static _CharacterInfo _character000009F7 =
    {
        0x000009F7,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x000009F7,
        0x000009F7,
        0x000009F7
    };

    static _CharacterInfo _character000009F8 =
    {
        0x000009F8,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009F8,
        0x000009F8,
        0x000009F8
    };

    static _CharacterInfo _character000009F9 =
    {
        0x000009F9,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        16,
        1,
        false,
        0x000009F9,
        0x000009F9,
        0x000009F9
    };

    static _CharacterInfo _character000009FA =
    {
        0x000009FA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000009FA,
        0x000009FA,
        0x000009FA
    };

    static _CharacterInfo _character00000A01 =
    {
        0x00000A01,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A01,
        0x00000A01,
        0x00000A01
    };

    static _CharacterInfo _character00000A02 =
    {
        0x00000A02,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A02,
        0x00000A02,
        0x00000A02
    };

    static _CharacterInfo _character00000A03 =
    {
        0x00000A03,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A03,
        0x00000A03,
        0x00000A03
    };

    static _CharacterInfo _character00000A05 =
    {
        0x00000A05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A05,
        0x00000A05,
        0x00000A05
    };

    static _CharacterInfo _character00000A06 =
    {
        0x00000A06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A06,
        0x00000A06,
        0x00000A06
    };

    static _CharacterInfo _character00000A07 =
    {
        0x00000A07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A07,
        0x00000A07,
        0x00000A07
    };

    static _CharacterInfo _character00000A08 =
    {
        0x00000A08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A08,
        0x00000A08,
        0x00000A08
    };

    static _CharacterInfo _character00000A09 =
    {
        0x00000A09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A09,
        0x00000A09,
        0x00000A09
    };

    static _CharacterInfo _character00000A0A =
    {
        0x00000A0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A0A,
        0x00000A0A,
        0x00000A0A
    };

    static _CharacterInfo _character00000A0F =
    {
        0x00000A0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A0F,
        0x00000A0F,
        0x00000A0F
    };

    static _CharacterInfo _character00000A10 =
    {
        0x00000A10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A10,
        0x00000A10,
        0x00000A10
    };

    static _CharacterInfo _character00000A13 =
    {
        0x00000A13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A13,
        0x00000A13,
        0x00000A13
    };

    static _CharacterInfo _character00000A14 =
    {
        0x00000A14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A14,
        0x00000A14,
        0x00000A14
    };

    static _CharacterInfo _character00000A15 =
    {
        0x00000A15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A15,
        0x00000A15,
        0x00000A15
    };

    static _CharacterInfo _character00000A16 =
    {
        0x00000A16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A16,
        0x00000A16,
        0x00000A16
    };

    static _CharacterInfo _character00000A17 =
    {
        0x00000A17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A17,
        0x00000A17,
        0x00000A17
    };

    static _CharacterInfo _character00000A18 =
    {
        0x00000A18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A18,
        0x00000A18,
        0x00000A18
    };

    static _CharacterInfo _character00000A19 =
    {
        0x00000A19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A19,
        0x00000A19,
        0x00000A19
    };

    static _CharacterInfo _character00000A1A =
    {
        0x00000A1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1A,
        0x00000A1A,
        0x00000A1A
    };

    static _CharacterInfo _character00000A1B =
    {
        0x00000A1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1B,
        0x00000A1B,
        0x00000A1B
    };

    static _CharacterInfo _character00000A1C =
    {
        0x00000A1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1C,
        0x00000A1C,
        0x00000A1C
    };

    static _CharacterInfo _character00000A1D =
    {
        0x00000A1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1D,
        0x00000A1D,
        0x00000A1D
    };

    static _CharacterInfo _character00000A1E =
    {
        0x00000A1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1E,
        0x00000A1E,
        0x00000A1E
    };

    static _CharacterInfo _character00000A1F =
    {
        0x00000A1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A1F,
        0x00000A1F,
        0x00000A1F
    };

    static _CharacterInfo _character00000A20 =
    {
        0x00000A20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A20,
        0x00000A20,
        0x00000A20
    };

    static _CharacterInfo _character00000A21 =
    {
        0x00000A21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A21,
        0x00000A21,
        0x00000A21
    };

    static _CharacterInfo _character00000A22 =
    {
        0x00000A22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A22,
        0x00000A22,
        0x00000A22
    };

    static _CharacterInfo _character00000A23 =
    {
        0x00000A23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A23,
        0x00000A23,
        0x00000A23
    };

    static _CharacterInfo _character00000A24 =
    {
        0x00000A24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A24,
        0x00000A24,
        0x00000A24
    };

    static _CharacterInfo _character00000A25 =
    {
        0x00000A25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A25,
        0x00000A25,
        0x00000A25
    };

    static _CharacterInfo _character00000A26 =
    {
        0x00000A26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A26,
        0x00000A26,
        0x00000A26
    };

    static _CharacterInfo _character00000A27 =
    {
        0x00000A27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A27,
        0x00000A27,
        0x00000A27
    };

    static _CharacterInfo _character00000A28 =
    {
        0x00000A28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A28,
        0x00000A28,
        0x00000A28
    };

    static _CharacterInfo _character00000A2A =
    {
        0x00000A2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2A,
        0x00000A2A,
        0x00000A2A
    };

    static _CharacterInfo _character00000A2B =
    {
        0x00000A2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2B,
        0x00000A2B,
        0x00000A2B
    };

    static _CharacterInfo _character00000A2C =
    {
        0x00000A2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2C,
        0x00000A2C,
        0x00000A2C
    };

    static _CharacterInfo _character00000A2D =
    {
        0x00000A2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2D,
        0x00000A2D,
        0x00000A2D
    };

    static _CharacterInfo _character00000A2E =
    {
        0x00000A2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2E,
        0x00000A2E,
        0x00000A2E
    };

    static _CharacterInfo _character00000A2F =
    {
        0x00000A2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A2F,
        0x00000A2F,
        0x00000A2F
    };

    static _CharacterInfo _character00000A30 =
    {
        0x00000A30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A30,
        0x00000A30,
        0x00000A30
    };

    static _CharacterInfo _character00000A32 =
    {
        0x00000A32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A32,
        0x00000A32,
        0x00000A32
    };

    static Char _decompositionMapping00000A33[] = 
    {
        0x00000A32,
        0x00000A3C
    };

    static _CharacterInfo _character00000A33 =
    {
        0x00000A33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A33,
        0x00000A33,
        0x00000A33
    };

    static _CharacterInfo _character00000A35 =
    {
        0x00000A35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A35,
        0x00000A35,
        0x00000A35
    };

    static Char _decompositionMapping00000A36[] = 
    {
        0x00000A38,
        0x00000A3C
    };

    static _CharacterInfo _character00000A36 =
    {
        0x00000A36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A36,
        0x00000A36,
        0x00000A36
    };

    static _CharacterInfo _character00000A38 =
    {
        0x00000A38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A38,
        0x00000A38,
        0x00000A38
    };

    static _CharacterInfo _character00000A39 =
    {
        0x00000A39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A39,
        0x00000A39,
        0x00000A39
    };

    static _CharacterInfo _character00000A3C =
    {
        0x00000A3C,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A3C,
        0x00000A3C,
        0x00000A3C
    };

    static _CharacterInfo _character00000A3E =
    {
        0x00000A3E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A3E,
        0x00000A3E,
        0x00000A3E
    };

    static _CharacterInfo _character00000A3F =
    {
        0x00000A3F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A3F,
        0x00000A3F,
        0x00000A3F
    };

    static _CharacterInfo _character00000A40 =
    {
        0x00000A40,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A40,
        0x00000A40,
        0x00000A40
    };

    static _CharacterInfo _character00000A41 =
    {
        0x00000A41,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A41,
        0x00000A41,
        0x00000A41
    };

    static _CharacterInfo _character00000A42 =
    {
        0x00000A42,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A42,
        0x00000A42,
        0x00000A42
    };

    static _CharacterInfo _character00000A47 =
    {
        0x00000A47,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A47,
        0x00000A47,
        0x00000A47
    };

    static _CharacterInfo _character00000A48 =
    {
        0x00000A48,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A48,
        0x00000A48,
        0x00000A48
    };

    static _CharacterInfo _character00000A4B =
    {
        0x00000A4B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A4B,
        0x00000A4B,
        0x00000A4B
    };

    static _CharacterInfo _character00000A4C =
    {
        0x00000A4C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A4C,
        0x00000A4C,
        0x00000A4C
    };

    static _CharacterInfo _character00000A4D =
    {
        0x00000A4D,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A4D,
        0x00000A4D,
        0x00000A4D
    };

    static Char _decompositionMapping00000A59[] = 
    {
        0x00000A16,
        0x00000A3C
    };

    static _CharacterInfo _character00000A59 =
    {
        0x00000A59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A59,
        0x00000A59,
        0x00000A59
    };

    static Char _decompositionMapping00000A5A[] = 
    {
        0x00000A17,
        0x00000A3C
    };

    static _CharacterInfo _character00000A5A =
    {
        0x00000A5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A5A,
        0x00000A5A,
        0x00000A5A
    };

    static Char _decompositionMapping00000A5B[] = 
    {
        0x00000A1C,
        0x00000A3C
    };

    static _CharacterInfo _character00000A5B =
    {
        0x00000A5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A5B,
        0x00000A5B,
        0x00000A5B
    };

    static _CharacterInfo _character00000A5C =
    {
        0x00000A5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A5C,
        0x00000A5C,
        0x00000A5C
    };

    static Char _decompositionMapping00000A5E[] = 
    {
        0x00000A2B,
        0x00000A3C
    };

    static _CharacterInfo _character00000A5E =
    {
        0x00000A5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000A5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A5E,
        0x00000A5E,
        0x00000A5E
    };

    static _CharacterInfo _character00000A66 =
    {
        0x00000A66,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000A66,
        0x00000A66,
        0x00000A66
    };

    static _CharacterInfo _character00000A67 =
    {
        0x00000A67,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000A67,
        0x00000A67,
        0x00000A67
    };

    static _CharacterInfo _character00000A68 =
    {
        0x00000A68,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000A68,
        0x00000A68,
        0x00000A68
    };

    static _CharacterInfo _character00000A69 =
    {
        0x00000A69,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000A69,
        0x00000A69,
        0x00000A69
    };

    static _CharacterInfo _character00000A6A =
    {
        0x00000A6A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000A6A,
        0x00000A6A,
        0x00000A6A
    };

    static _CharacterInfo _character00000A6B =
    {
        0x00000A6B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000A6B,
        0x00000A6B,
        0x00000A6B
    };

    static _CharacterInfo _character00000A6C =
    {
        0x00000A6C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000A6C,
        0x00000A6C,
        0x00000A6C
    };

    static _CharacterInfo _character00000A6D =
    {
        0x00000A6D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000A6D,
        0x00000A6D,
        0x00000A6D
    };

    static _CharacterInfo _character00000A6E =
    {
        0x00000A6E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000A6E,
        0x00000A6E,
        0x00000A6E
    };

    static _CharacterInfo _character00000A6F =
    {
        0x00000A6F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000A6F,
        0x00000A6F,
        0x00000A6F
    };

    static _CharacterInfo _character00000A70 =
    {
        0x00000A70,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A70,
        0x00000A70,
        0x00000A70
    };

    static _CharacterInfo _character00000A71 =
    {
        0x00000A71,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A71,
        0x00000A71,
        0x00000A71
    };

    static _CharacterInfo _character00000A72 =
    {
        0x00000A72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A72,
        0x00000A72,
        0x00000A72
    };

    static _CharacterInfo _character00000A73 =
    {
        0x00000A73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A73,
        0x00000A73,
        0x00000A73
    };

    static _CharacterInfo _character00000A74 =
    {
        0x00000A74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A74,
        0x00000A74,
        0x00000A74
    };

    static _CharacterInfo _character00000A81 =
    {
        0x00000A81,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A81,
        0x00000A81,
        0x00000A81
    };

    static _CharacterInfo _character00000A82 =
    {
        0x00000A82,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A82,
        0x00000A82,
        0x00000A82
    };

    static _CharacterInfo _character00000A83 =
    {
        0x00000A83,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A83,
        0x00000A83,
        0x00000A83
    };

    static _CharacterInfo _character00000A85 =
    {
        0x00000A85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A85,
        0x00000A85,
        0x00000A85
    };

    static _CharacterInfo _character00000A86 =
    {
        0x00000A86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A86,
        0x00000A86,
        0x00000A86
    };

    static _CharacterInfo _character00000A87 =
    {
        0x00000A87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A87,
        0x00000A87,
        0x00000A87
    };

    static _CharacterInfo _character00000A88 =
    {
        0x00000A88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A88,
        0x00000A88,
        0x00000A88
    };

    static _CharacterInfo _character00000A89 =
    {
        0x00000A89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A89,
        0x00000A89,
        0x00000A89
    };

    static _CharacterInfo _character00000A8A =
    {
        0x00000A8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A8A,
        0x00000A8A,
        0x00000A8A
    };

    static _CharacterInfo _character00000A8B =
    {
        0x00000A8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A8B,
        0x00000A8B,
        0x00000A8B
    };

    static _CharacterInfo _character00000A8C =
    {
        0x00000A8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A8C,
        0x00000A8C,
        0x00000A8C
    };

    static _CharacterInfo _character00000A8D =
    {
        0x00000A8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A8D,
        0x00000A8D,
        0x00000A8D
    };

    static _CharacterInfo _character00000A8F =
    {
        0x00000A8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A8F,
        0x00000A8F,
        0x00000A8F
    };

    static _CharacterInfo _character00000A90 =
    {
        0x00000A90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A90,
        0x00000A90,
        0x00000A90
    };

    static _CharacterInfo _character00000A91 =
    {
        0x00000A91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A91,
        0x00000A91,
        0x00000A91
    };

    static _CharacterInfo _character00000A93 =
    {
        0x00000A93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A93,
        0x00000A93,
        0x00000A93
    };

    static _CharacterInfo _character00000A94 =
    {
        0x00000A94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A94,
        0x00000A94,
        0x00000A94
    };

    static _CharacterInfo _character00000A95 =
    {
        0x00000A95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A95,
        0x00000A95,
        0x00000A95
    };

    static _CharacterInfo _character00000A96 =
    {
        0x00000A96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A96,
        0x00000A96,
        0x00000A96
    };

    static _CharacterInfo _character00000A97 =
    {
        0x00000A97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A97,
        0x00000A97,
        0x00000A97
    };

    static _CharacterInfo _character00000A98 =
    {
        0x00000A98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A98,
        0x00000A98,
        0x00000A98
    };

    static _CharacterInfo _character00000A99 =
    {
        0x00000A99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A99,
        0x00000A99,
        0x00000A99
    };

    static _CharacterInfo _character00000A9A =
    {
        0x00000A9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9A,
        0x00000A9A,
        0x00000A9A
    };

    static _CharacterInfo _character00000A9B =
    {
        0x00000A9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9B,
        0x00000A9B,
        0x00000A9B
    };

    static _CharacterInfo _character00000A9C =
    {
        0x00000A9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9C,
        0x00000A9C,
        0x00000A9C
    };

    static _CharacterInfo _character00000A9D =
    {
        0x00000A9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9D,
        0x00000A9D,
        0x00000A9D
    };

    static _CharacterInfo _character00000A9E =
    {
        0x00000A9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9E,
        0x00000A9E,
        0x00000A9E
    };

    static _CharacterInfo _character00000A9F =
    {
        0x00000A9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000A9F,
        0x00000A9F,
        0x00000A9F
    };

    static _CharacterInfo _character00000AA0 =
    {
        0x00000AA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA0,
        0x00000AA0,
        0x00000AA0
    };

    static _CharacterInfo _character00000AA1 =
    {
        0x00000AA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA1,
        0x00000AA1,
        0x00000AA1
    };

    static _CharacterInfo _character00000AA2 =
    {
        0x00000AA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA2,
        0x00000AA2,
        0x00000AA2
    };

    static _CharacterInfo _character00000AA3 =
    {
        0x00000AA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA3,
        0x00000AA3,
        0x00000AA3
    };

    static _CharacterInfo _character00000AA4 =
    {
        0x00000AA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA4,
        0x00000AA4,
        0x00000AA4
    };

    static _CharacterInfo _character00000AA5 =
    {
        0x00000AA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA5,
        0x00000AA5,
        0x00000AA5
    };

    static _CharacterInfo _character00000AA6 =
    {
        0x00000AA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA6,
        0x00000AA6,
        0x00000AA6
    };

    static _CharacterInfo _character00000AA7 =
    {
        0x00000AA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA7,
        0x00000AA7,
        0x00000AA7
    };

    static _CharacterInfo _character00000AA8 =
    {
        0x00000AA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AA8,
        0x00000AA8,
        0x00000AA8
    };

    static _CharacterInfo _character00000AAA =
    {
        0x00000AAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAA,
        0x00000AAA,
        0x00000AAA
    };

    static _CharacterInfo _character00000AAB =
    {
        0x00000AAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAB,
        0x00000AAB,
        0x00000AAB
    };

    static _CharacterInfo _character00000AAC =
    {
        0x00000AAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAC,
        0x00000AAC,
        0x00000AAC
    };

    static _CharacterInfo _character00000AAD =
    {
        0x00000AAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAD,
        0x00000AAD,
        0x00000AAD
    };

    static _CharacterInfo _character00000AAE =
    {
        0x00000AAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAE,
        0x00000AAE,
        0x00000AAE
    };

    static _CharacterInfo _character00000AAF =
    {
        0x00000AAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AAF,
        0x00000AAF,
        0x00000AAF
    };

    static _CharacterInfo _character00000AB0 =
    {
        0x00000AB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB0,
        0x00000AB0,
        0x00000AB0
    };

    static _CharacterInfo _character00000AB2 =
    {
        0x00000AB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB2,
        0x00000AB2,
        0x00000AB2
    };

    static _CharacterInfo _character00000AB3 =
    {
        0x00000AB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB3,
        0x00000AB3,
        0x00000AB3
    };

    static _CharacterInfo _character00000AB5 =
    {
        0x00000AB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB5,
        0x00000AB5,
        0x00000AB5
    };

    static _CharacterInfo _character00000AB6 =
    {
        0x00000AB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB6,
        0x00000AB6,
        0x00000AB6
    };

    static _CharacterInfo _character00000AB7 =
    {
        0x00000AB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB7,
        0x00000AB7,
        0x00000AB7
    };

    static _CharacterInfo _character00000AB8 =
    {
        0x00000AB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB8,
        0x00000AB8,
        0x00000AB8
    };

    static _CharacterInfo _character00000AB9 =
    {
        0x00000AB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AB9,
        0x00000AB9,
        0x00000AB9
    };

    static _CharacterInfo _character00000ABC =
    {
        0x00000ABC,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ABC,
        0x00000ABC,
        0x00000ABC
    };

    static _CharacterInfo _character00000ABD =
    {
        0x00000ABD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ABD,
        0x00000ABD,
        0x00000ABD
    };

    static _CharacterInfo _character00000ABE =
    {
        0x00000ABE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ABE,
        0x00000ABE,
        0x00000ABE
    };

    static _CharacterInfo _character00000ABF =
    {
        0x00000ABF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ABF,
        0x00000ABF,
        0x00000ABF
    };

    static _CharacterInfo _character00000AC0 =
    {
        0x00000AC0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC0,
        0x00000AC0,
        0x00000AC0
    };

    static _CharacterInfo _character00000AC1 =
    {
        0x00000AC1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC1,
        0x00000AC1,
        0x00000AC1
    };

    static _CharacterInfo _character00000AC2 =
    {
        0x00000AC2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC2,
        0x00000AC2,
        0x00000AC2
    };

    static _CharacterInfo _character00000AC3 =
    {
        0x00000AC3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC3,
        0x00000AC3,
        0x00000AC3
    };

    static _CharacterInfo _character00000AC4 =
    {
        0x00000AC4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC4,
        0x00000AC4,
        0x00000AC4
    };

    static _CharacterInfo _character00000AC5 =
    {
        0x00000AC5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC5,
        0x00000AC5,
        0x00000AC5
    };

    static _CharacterInfo _character00000AC7 =
    {
        0x00000AC7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC7,
        0x00000AC7,
        0x00000AC7
    };

    static _CharacterInfo _character00000AC8 =
    {
        0x00000AC8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC8,
        0x00000AC8,
        0x00000AC8
    };

    static _CharacterInfo _character00000AC9 =
    {
        0x00000AC9,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AC9,
        0x00000AC9,
        0x00000AC9
    };

    static _CharacterInfo _character00000ACB =
    {
        0x00000ACB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ACB,
        0x00000ACB,
        0x00000ACB
    };

    static _CharacterInfo _character00000ACC =
    {
        0x00000ACC,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ACC,
        0x00000ACC,
        0x00000ACC
    };

    static _CharacterInfo _character00000ACD =
    {
        0x00000ACD,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ACD,
        0x00000ACD,
        0x00000ACD
    };

    static _CharacterInfo _character00000AD0 =
    {
        0x00000AD0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AD0,
        0x00000AD0,
        0x00000AD0
    };

    static _CharacterInfo _character00000AE0 =
    {
        0x00000AE0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AE0,
        0x00000AE0,
        0x00000AE0
    };

    static _CharacterInfo _character00000AE1 =
    {
        0x00000AE1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AE1,
        0x00000AE1,
        0x00000AE1
    };

    static _CharacterInfo _character00000AE2 =
    {
        0x00000AE2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AE2,
        0x00000AE2,
        0x00000AE2
    };

    static _CharacterInfo _character00000AE3 =
    {
        0x00000AE3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AE3,
        0x00000AE3,
        0x00000AE3
    };

    static _CharacterInfo _character00000AE6 =
    {
        0x00000AE6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000AE6,
        0x00000AE6,
        0x00000AE6
    };

    static _CharacterInfo _character00000AE7 =
    {
        0x00000AE7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000AE7,
        0x00000AE7,
        0x00000AE7
    };

    static _CharacterInfo _character00000AE8 =
    {
        0x00000AE8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000AE8,
        0x00000AE8,
        0x00000AE8
    };

    static _CharacterInfo _character00000AE9 =
    {
        0x00000AE9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000AE9,
        0x00000AE9,
        0x00000AE9
    };

    static _CharacterInfo _character00000AEA =
    {
        0x00000AEA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000AEA,
        0x00000AEA,
        0x00000AEA
    };

    static _CharacterInfo _character00000AEB =
    {
        0x00000AEB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000AEB,
        0x00000AEB,
        0x00000AEB
    };

    static _CharacterInfo _character00000AEC =
    {
        0x00000AEC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000AEC,
        0x00000AEC,
        0x00000AEC
    };

    static _CharacterInfo _character00000AED =
    {
        0x00000AED,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000AED,
        0x00000AED,
        0x00000AED
    };

    static _CharacterInfo _character00000AEE =
    {
        0x00000AEE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000AEE,
        0x00000AEE,
        0x00000AEE
    };

    static _CharacterInfo _character00000AEF =
    {
        0x00000AEF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000AEF,
        0x00000AEF,
        0x00000AEF
    };

    static _CharacterInfo _character00000AF1 =
    {
        0x00000AF1,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000AF1,
        0x00000AF1,
        0x00000AF1
    };

    static _CharacterInfo _character00000B01 =
    {
        0x00000B01,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B01,
        0x00000B01,
        0x00000B01
    };

    static _CharacterInfo _character00000B02 =
    {
        0x00000B02,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B02,
        0x00000B02,
        0x00000B02
    };

    static _CharacterInfo _character00000B03 =
    {
        0x00000B03,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B03,
        0x00000B03,
        0x00000B03
    };

    static _CharacterInfo _character00000B05 =
    {
        0x00000B05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B05,
        0x00000B05,
        0x00000B05
    };

    static _CharacterInfo _character00000B06 =
    {
        0x00000B06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B06,
        0x00000B06,
        0x00000B06
    };

    static _CharacterInfo _character00000B07 =
    {
        0x00000B07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B07,
        0x00000B07,
        0x00000B07
    };

    static _CharacterInfo _character00000B08 =
    {
        0x00000B08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B08,
        0x00000B08,
        0x00000B08
    };

    static _CharacterInfo _character00000B09 =
    {
        0x00000B09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B09,
        0x00000B09,
        0x00000B09
    };

    static _CharacterInfo _character00000B0A =
    {
        0x00000B0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B0A,
        0x00000B0A,
        0x00000B0A
    };

    static _CharacterInfo _character00000B0B =
    {
        0x00000B0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B0B,
        0x00000B0B,
        0x00000B0B
    };

    static _CharacterInfo _character00000B0C =
    {
        0x00000B0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B0C,
        0x00000B0C,
        0x00000B0C
    };

    static _CharacterInfo _character00000B0F =
    {
        0x00000B0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B0F,
        0x00000B0F,
        0x00000B0F
    };

    static _CharacterInfo _character00000B10 =
    {
        0x00000B10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B10,
        0x00000B10,
        0x00000B10
    };

    static _CharacterInfo _character00000B13 =
    {
        0x00000B13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B13,
        0x00000B13,
        0x00000B13
    };

    static _CharacterInfo _character00000B14 =
    {
        0x00000B14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B14,
        0x00000B14,
        0x00000B14
    };

    static _CharacterInfo _character00000B15 =
    {
        0x00000B15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B15,
        0x00000B15,
        0x00000B15
    };

    static _CharacterInfo _character00000B16 =
    {
        0x00000B16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B16,
        0x00000B16,
        0x00000B16
    };

    static _CharacterInfo _character00000B17 =
    {
        0x00000B17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B17,
        0x00000B17,
        0x00000B17
    };

    static _CharacterInfo _character00000B18 =
    {
        0x00000B18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B18,
        0x00000B18,
        0x00000B18
    };

    static _CharacterInfo _character00000B19 =
    {
        0x00000B19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B19,
        0x00000B19,
        0x00000B19
    };

    static _CharacterInfo _character00000B1A =
    {
        0x00000B1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1A,
        0x00000B1A,
        0x00000B1A
    };

    static _CharacterInfo _character00000B1B =
    {
        0x00000B1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1B,
        0x00000B1B,
        0x00000B1B
    };

    static _CharacterInfo _character00000B1C =
    {
        0x00000B1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1C,
        0x00000B1C,
        0x00000B1C
    };

    static _CharacterInfo _character00000B1D =
    {
        0x00000B1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1D,
        0x00000B1D,
        0x00000B1D
    };

    static _CharacterInfo _character00000B1E =
    {
        0x00000B1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1E,
        0x00000B1E,
        0x00000B1E
    };

    static _CharacterInfo _character00000B1F =
    {
        0x00000B1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B1F,
        0x00000B1F,
        0x00000B1F
    };

    static _CharacterInfo _character00000B20 =
    {
        0x00000B20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B20,
        0x00000B20,
        0x00000B20
    };

    static _CharacterInfo _character00000B21 =
    {
        0x00000B21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B21,
        0x00000B21,
        0x00000B21
    };

    static _CharacterInfo _character00000B22 =
    {
        0x00000B22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B22,
        0x00000B22,
        0x00000B22
    };

    static _CharacterInfo _character00000B23 =
    {
        0x00000B23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B23,
        0x00000B23,
        0x00000B23
    };

    static _CharacterInfo _character00000B24 =
    {
        0x00000B24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B24,
        0x00000B24,
        0x00000B24
    };

    static _CharacterInfo _character00000B25 =
    {
        0x00000B25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B25,
        0x00000B25,
        0x00000B25
    };

    static _CharacterInfo _character00000B26 =
    {
        0x00000B26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B26,
        0x00000B26,
        0x00000B26
    };

    static _CharacterInfo _character00000B27 =
    {
        0x00000B27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B27,
        0x00000B27,
        0x00000B27
    };

    static _CharacterInfo _character00000B28 =
    {
        0x00000B28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B28,
        0x00000B28,
        0x00000B28
    };

    static _CharacterInfo _character00000B2A =
    {
        0x00000B2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2A,
        0x00000B2A,
        0x00000B2A
    };

    static _CharacterInfo _character00000B2B =
    {
        0x00000B2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2B,
        0x00000B2B,
        0x00000B2B
    };

    static _CharacterInfo _character00000B2C =
    {
        0x00000B2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2C,
        0x00000B2C,
        0x00000B2C
    };

    static _CharacterInfo _character00000B2D =
    {
        0x00000B2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2D,
        0x00000B2D,
        0x00000B2D
    };

    static _CharacterInfo _character00000B2E =
    {
        0x00000B2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2E,
        0x00000B2E,
        0x00000B2E
    };

    static _CharacterInfo _character00000B2F =
    {
        0x00000B2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B2F,
        0x00000B2F,
        0x00000B2F
    };

    static _CharacterInfo _character00000B30 =
    {
        0x00000B30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B30,
        0x00000B30,
        0x00000B30
    };

    static _CharacterInfo _character00000B32 =
    {
        0x00000B32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B32,
        0x00000B32,
        0x00000B32
    };

    static _CharacterInfo _character00000B33 =
    {
        0x00000B33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B33,
        0x00000B33,
        0x00000B33
    };

    static _CharacterInfo _character00000B35 =
    {
        0x00000B35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B35,
        0x00000B35,
        0x00000B35
    };

    static _CharacterInfo _character00000B36 =
    {
        0x00000B36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B36,
        0x00000B36,
        0x00000B36
    };

    static _CharacterInfo _character00000B37 =
    {
        0x00000B37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B37,
        0x00000B37,
        0x00000B37
    };

    static _CharacterInfo _character00000B38 =
    {
        0x00000B38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B38,
        0x00000B38,
        0x00000B38
    };

    static _CharacterInfo _character00000B39 =
    {
        0x00000B39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B39,
        0x00000B39,
        0x00000B39
    };

    static _CharacterInfo _character00000B3C =
    {
        0x00000B3C,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B3C,
        0x00000B3C,
        0x00000B3C
    };

    static _CharacterInfo _character00000B3D =
    {
        0x00000B3D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B3D,
        0x00000B3D,
        0x00000B3D
    };

    static _CharacterInfo _character00000B3E =
    {
        0x00000B3E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B3E,
        0x00000B3E,
        0x00000B3E
    };

    static _CharacterInfo _character00000B3F =
    {
        0x00000B3F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B3F,
        0x00000B3F,
        0x00000B3F
    };

    static _CharacterInfo _character00000B40 =
    {
        0x00000B40,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B40,
        0x00000B40,
        0x00000B40
    };

    static _CharacterInfo _character00000B41 =
    {
        0x00000B41,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B41,
        0x00000B41,
        0x00000B41
    };

    static _CharacterInfo _character00000B42 =
    {
        0x00000B42,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B42,
        0x00000B42,
        0x00000B42
    };

    static _CharacterInfo _character00000B43 =
    {
        0x00000B43,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B43,
        0x00000B43,
        0x00000B43
    };

    static _CharacterInfo _character00000B47 =
    {
        0x00000B47,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B47,
        0x00000B47,
        0x00000B47
    };

    static Char _decompositionMapping00000B48[] = 
    {
        0x00000B47,
        0x00000B56
    };

    static _CharacterInfo _character00000B48 =
    {
        0x00000B48,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B48,
        0x00000B48,
        0x00000B48
    };

    static Char _decompositionMapping00000B4B[] = 
    {
        0x00000B47,
        0x00000B3E
    };

    static _CharacterInfo _character00000B4B =
    {
        0x00000B4B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B4B,
        0x00000B4B,
        0x00000B4B
    };

    static Char _decompositionMapping00000B4C[] = 
    {
        0x00000B47,
        0x00000B57
    };

    static _CharacterInfo _character00000B4C =
    {
        0x00000B4C,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B4C,
        0x00000B4C,
        0x00000B4C
    };

    static _CharacterInfo _character00000B4D =
    {
        0x00000B4D,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B4D,
        0x00000B4D,
        0x00000B4D
    };

    static _CharacterInfo _character00000B56 =
    {
        0x00000B56,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B56,
        0x00000B56,
        0x00000B56
    };

    static _CharacterInfo _character00000B57 =
    {
        0x00000B57,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B57,
        0x00000B57,
        0x00000B57
    };

    static Char _decompositionMapping00000B5C[] = 
    {
        0x00000B21,
        0x00000B3C
    };

    static _CharacterInfo _character00000B5C =
    {
        0x00000B5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B5C,
        0x00000B5C,
        0x00000B5C
    };

    static Char _decompositionMapping00000B5D[] = 
    {
        0x00000B22,
        0x00000B3C
    };

    static _CharacterInfo _character00000B5D =
    {
        0x00000B5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B5D,
        0x00000B5D,
        0x00000B5D
    };

    static _CharacterInfo _character00000B5F =
    {
        0x00000B5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B5F,
        0x00000B5F,
        0x00000B5F
    };

    static _CharacterInfo _character00000B60 =
    {
        0x00000B60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B60,
        0x00000B60,
        0x00000B60
    };

    static _CharacterInfo _character00000B61 =
    {
        0x00000B61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B61,
        0x00000B61,
        0x00000B61
    };

    static _CharacterInfo _character00000B66 =
    {
        0x00000B66,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000B66,
        0x00000B66,
        0x00000B66
    };

    static _CharacterInfo _character00000B67 =
    {
        0x00000B67,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000B67,
        0x00000B67,
        0x00000B67
    };

    static _CharacterInfo _character00000B68 =
    {
        0x00000B68,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000B68,
        0x00000B68,
        0x00000B68
    };

    static _CharacterInfo _character00000B69 =
    {
        0x00000B69,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000B69,
        0x00000B69,
        0x00000B69
    };

    static _CharacterInfo _character00000B6A =
    {
        0x00000B6A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000B6A,
        0x00000B6A,
        0x00000B6A
    };

    static _CharacterInfo _character00000B6B =
    {
        0x00000B6B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000B6B,
        0x00000B6B,
        0x00000B6B
    };

    static _CharacterInfo _character00000B6C =
    {
        0x00000B6C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000B6C,
        0x00000B6C,
        0x00000B6C
    };

    static _CharacterInfo _character00000B6D =
    {
        0x00000B6D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000B6D,
        0x00000B6D,
        0x00000B6D
    };

    static _CharacterInfo _character00000B6E =
    {
        0x00000B6E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000B6E,
        0x00000B6E,
        0x00000B6E
    };

    static _CharacterInfo _character00000B6F =
    {
        0x00000B6F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000B6F,
        0x00000B6F,
        0x00000B6F
    };

    static _CharacterInfo _character00000B70 =
    {
        0x00000B70,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B70,
        0x00000B70,
        0x00000B70
    };

    static _CharacterInfo _character00000B71 =
    {
        0x00000B71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B71,
        0x00000B71,
        0x00000B71
    };

    static _CharacterInfo _character00000B82 =
    {
        0x00000B82,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B82,
        0x00000B82,
        0x00000B82
    };

    static _CharacterInfo _character00000B83 =
    {
        0x00000B83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B83,
        0x00000B83,
        0x00000B83
    };

    static _CharacterInfo _character00000B85 =
    {
        0x00000B85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B85,
        0x00000B85,
        0x00000B85
    };

    static _CharacterInfo _character00000B86 =
    {
        0x00000B86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B86,
        0x00000B86,
        0x00000B86
    };

    static _CharacterInfo _character00000B87 =
    {
        0x00000B87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B87,
        0x00000B87,
        0x00000B87
    };

    static _CharacterInfo _character00000B88 =
    {
        0x00000B88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B88,
        0x00000B88,
        0x00000B88
    };

    static _CharacterInfo _character00000B89 =
    {
        0x00000B89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B89,
        0x00000B89,
        0x00000B89
    };

    static _CharacterInfo _character00000B8A =
    {
        0x00000B8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B8A,
        0x00000B8A,
        0x00000B8A
    };

    static _CharacterInfo _character00000B8E =
    {
        0x00000B8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B8E,
        0x00000B8E,
        0x00000B8E
    };

    static _CharacterInfo _character00000B8F =
    {
        0x00000B8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B8F,
        0x00000B8F,
        0x00000B8F
    };

    static _CharacterInfo _character00000B90 =
    {
        0x00000B90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B90,
        0x00000B90,
        0x00000B90
    };

    static _CharacterInfo _character00000B92 =
    {
        0x00000B92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B92,
        0x00000B92,
        0x00000B92
    };

    static _CharacterInfo _character00000B93 =
    {
        0x00000B93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B93,
        0x00000B93,
        0x00000B93
    };

    static Char _decompositionMapping00000B94[] = 
    {
        0x00000B92,
        0x00000BD7
    };

    static _CharacterInfo _character00000B94 =
    {
        0x00000B94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000B94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B94,
        0x00000B94,
        0x00000B94
    };

    static _CharacterInfo _character00000B95 =
    {
        0x00000B95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B95,
        0x00000B95,
        0x00000B95
    };

    static _CharacterInfo _character00000B99 =
    {
        0x00000B99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B99,
        0x00000B99,
        0x00000B99
    };

    static _CharacterInfo _character00000B9A =
    {
        0x00000B9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B9A,
        0x00000B9A,
        0x00000B9A
    };

    static _CharacterInfo _character00000B9C =
    {
        0x00000B9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B9C,
        0x00000B9C,
        0x00000B9C
    };

    static _CharacterInfo _character00000B9E =
    {
        0x00000B9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B9E,
        0x00000B9E,
        0x00000B9E
    };

    static _CharacterInfo _character00000B9F =
    {
        0x00000B9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000B9F,
        0x00000B9F,
        0x00000B9F
    };

    static _CharacterInfo _character00000BA3 =
    {
        0x00000BA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BA3,
        0x00000BA3,
        0x00000BA3
    };

    static _CharacterInfo _character00000BA4 =
    {
        0x00000BA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BA4,
        0x00000BA4,
        0x00000BA4
    };

    static _CharacterInfo _character00000BA8 =
    {
        0x00000BA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BA8,
        0x00000BA8,
        0x00000BA8
    };

    static _CharacterInfo _character00000BA9 =
    {
        0x00000BA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BA9,
        0x00000BA9,
        0x00000BA9
    };

    static _CharacterInfo _character00000BAA =
    {
        0x00000BAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BAA,
        0x00000BAA,
        0x00000BAA
    };

    static _CharacterInfo _character00000BAE =
    {
        0x00000BAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BAE,
        0x00000BAE,
        0x00000BAE
    };

    static _CharacterInfo _character00000BAF =
    {
        0x00000BAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BAF,
        0x00000BAF,
        0x00000BAF
    };

    static _CharacterInfo _character00000BB0 =
    {
        0x00000BB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB0,
        0x00000BB0,
        0x00000BB0
    };

    static _CharacterInfo _character00000BB1 =
    {
        0x00000BB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB1,
        0x00000BB1,
        0x00000BB1
    };

    static _CharacterInfo _character00000BB2 =
    {
        0x00000BB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB2,
        0x00000BB2,
        0x00000BB2
    };

    static _CharacterInfo _character00000BB3 =
    {
        0x00000BB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB3,
        0x00000BB3,
        0x00000BB3
    };

    static _CharacterInfo _character00000BB4 =
    {
        0x00000BB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB4,
        0x00000BB4,
        0x00000BB4
    };

    static _CharacterInfo _character00000BB5 =
    {
        0x00000BB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB5,
        0x00000BB5,
        0x00000BB5
    };

    static _CharacterInfo _character00000BB6 =
    {
        0x00000BB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB6,
        0x00000BB6,
        0x00000BB6
    };

    static _CharacterInfo _character00000BB7 =
    {
        0x00000BB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB7,
        0x00000BB7,
        0x00000BB7
    };

    static _CharacterInfo _character00000BB8 =
    {
        0x00000BB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB8,
        0x00000BB8,
        0x00000BB8
    };

    static _CharacterInfo _character00000BB9 =
    {
        0x00000BB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BB9,
        0x00000BB9,
        0x00000BB9
    };

    static _CharacterInfo _character00000BBE =
    {
        0x00000BBE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BBE,
        0x00000BBE,
        0x00000BBE
    };

    static _CharacterInfo _character00000BBF =
    {
        0x00000BBF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BBF,
        0x00000BBF,
        0x00000BBF
    };

    static _CharacterInfo _character00000BC0 =
    {
        0x00000BC0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC0,
        0x00000BC0,
        0x00000BC0
    };

    static _CharacterInfo _character00000BC1 =
    {
        0x00000BC1,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC1,
        0x00000BC1,
        0x00000BC1
    };

    static _CharacterInfo _character00000BC2 =
    {
        0x00000BC2,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC2,
        0x00000BC2,
        0x00000BC2
    };

    static _CharacterInfo _character00000BC6 =
    {
        0x00000BC6,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC6,
        0x00000BC6,
        0x00000BC6
    };

    static _CharacterInfo _character00000BC7 =
    {
        0x00000BC7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC7,
        0x00000BC7,
        0x00000BC7
    };

    static _CharacterInfo _character00000BC8 =
    {
        0x00000BC8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BC8,
        0x00000BC8,
        0x00000BC8
    };

    static Char _decompositionMapping00000BCA[] = 
    {
        0x00000BC6,
        0x00000BBE
    };

    static _CharacterInfo _character00000BCA =
    {
        0x00000BCA,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000BCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BCA,
        0x00000BCA,
        0x00000BCA
    };

    static Char _decompositionMapping00000BCB[] = 
    {
        0x00000BC7,
        0x00000BBE
    };

    static _CharacterInfo _character00000BCB =
    {
        0x00000BCB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000BCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BCB,
        0x00000BCB,
        0x00000BCB
    };

    static Char _decompositionMapping00000BCC[] = 
    {
        0x00000BC6,
        0x00000BD7
    };

    static _CharacterInfo _character00000BCC =
    {
        0x00000BCC,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000BCC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BCC,
        0x00000BCC,
        0x00000BCC
    };

    static _CharacterInfo _character00000BCD =
    {
        0x00000BCD,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BCD,
        0x00000BCD,
        0x00000BCD
    };

    static _CharacterInfo _character00000BD7 =
    {
        0x00000BD7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BD7,
        0x00000BD7,
        0x00000BD7
    };

    static _CharacterInfo _character00000BE6 =
    {
        0x00000BE6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000BE6,
        0x00000BE6,
        0x00000BE6
    };

    static _CharacterInfo _character00000BE7 =
    {
        0x00000BE7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000BE7,
        0x00000BE7,
        0x00000BE7
    };

    static _CharacterInfo _character00000BE8 =
    {
        0x00000BE8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000BE8,
        0x00000BE8,
        0x00000BE8
    };

    static _CharacterInfo _character00000BE9 =
    {
        0x00000BE9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000BE9,
        0x00000BE9,
        0x00000BE9
    };

    static _CharacterInfo _character00000BEA =
    {
        0x00000BEA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000BEA,
        0x00000BEA,
        0x00000BEA
    };

    static _CharacterInfo _character00000BEB =
    {
        0x00000BEB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000BEB,
        0x00000BEB,
        0x00000BEB
    };

    static _CharacterInfo _character00000BEC =
    {
        0x00000BEC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000BEC,
        0x00000BEC,
        0x00000BEC
    };

    static _CharacterInfo _character00000BED =
    {
        0x00000BED,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000BED,
        0x00000BED,
        0x00000BED
    };

    static _CharacterInfo _character00000BEE =
    {
        0x00000BEE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000BEE,
        0x00000BEE,
        0x00000BEE
    };

    static _CharacterInfo _character00000BEF =
    {
        0x00000BEF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000BEF,
        0x00000BEF,
        0x00000BEF
    };

    static _CharacterInfo _character00000BF0 =
    {
        0x00000BF0,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00000BF0,
        0x00000BF0,
        0x00000BF0
    };

    static _CharacterInfo _character00000BF1 =
    {
        0x00000BF1,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x00000BF1,
        0x00000BF1,
        0x00000BF1
    };

    static _CharacterInfo _character00000BF2 =
    {
        0x00000BF2,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00000BF2,
        0x00000BF2,
        0x00000BF2
    };

    static _CharacterInfo _character00000BF3 =
    {
        0x00000BF3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF3,
        0x00000BF3,
        0x00000BF3
    };

    static _CharacterInfo _character00000BF4 =
    {
        0x00000BF4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF4,
        0x00000BF4,
        0x00000BF4
    };

    static _CharacterInfo _character00000BF5 =
    {
        0x00000BF5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF5,
        0x00000BF5,
        0x00000BF5
    };

    static _CharacterInfo _character00000BF6 =
    {
        0x00000BF6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF6,
        0x00000BF6,
        0x00000BF6
    };

    static _CharacterInfo _character00000BF7 =
    {
        0x00000BF7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF7,
        0x00000BF7,
        0x00000BF7
    };

    static _CharacterInfo _character00000BF8 =
    {
        0x00000BF8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF8,
        0x00000BF8,
        0x00000BF8
    };

    static _CharacterInfo _character00000BF9 =
    {
        0x00000BF9,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BF9,
        0x00000BF9,
        0x00000BF9
    };

    static _CharacterInfo _character00000BFA =
    {
        0x00000BFA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000BFA,
        0x00000BFA,
        0x00000BFA
    };

    static _CharacterInfo _character00000C01 =
    {
        0x00000C01,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C01,
        0x00000C01,
        0x00000C01
    };

    static _CharacterInfo _character00000C02 =
    {
        0x00000C02,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C02,
        0x00000C02,
        0x00000C02
    };

    static _CharacterInfo _character00000C03 =
    {
        0x00000C03,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C03,
        0x00000C03,
        0x00000C03
    };

    static _CharacterInfo _character00000C05 =
    {
        0x00000C05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C05,
        0x00000C05,
        0x00000C05
    };

    static _CharacterInfo _character00000C06 =
    {
        0x00000C06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C06,
        0x00000C06,
        0x00000C06
    };

    static _CharacterInfo _character00000C07 =
    {
        0x00000C07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C07,
        0x00000C07,
        0x00000C07
    };

    static _CharacterInfo _character00000C08 =
    {
        0x00000C08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C08,
        0x00000C08,
        0x00000C08
    };

    static _CharacterInfo _character00000C09 =
    {
        0x00000C09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C09,
        0x00000C09,
        0x00000C09
    };

    static _CharacterInfo _character00000C0A =
    {
        0x00000C0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C0A,
        0x00000C0A,
        0x00000C0A
    };

    static _CharacterInfo _character00000C0B =
    {
        0x00000C0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C0B,
        0x00000C0B,
        0x00000C0B
    };

    static _CharacterInfo _character00000C0C =
    {
        0x00000C0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C0C,
        0x00000C0C,
        0x00000C0C
    };

    static _CharacterInfo _character00000C0E =
    {
        0x00000C0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C0E,
        0x00000C0E,
        0x00000C0E
    };

    static _CharacterInfo _character00000C0F =
    {
        0x00000C0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C0F,
        0x00000C0F,
        0x00000C0F
    };

    static _CharacterInfo _character00000C10 =
    {
        0x00000C10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C10,
        0x00000C10,
        0x00000C10
    };

    static _CharacterInfo _character00000C12 =
    {
        0x00000C12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C12,
        0x00000C12,
        0x00000C12
    };

    static _CharacterInfo _character00000C13 =
    {
        0x00000C13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C13,
        0x00000C13,
        0x00000C13
    };

    static _CharacterInfo _character00000C14 =
    {
        0x00000C14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C14,
        0x00000C14,
        0x00000C14
    };

    static _CharacterInfo _character00000C15 =
    {
        0x00000C15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C15,
        0x00000C15,
        0x00000C15
    };

    static _CharacterInfo _character00000C16 =
    {
        0x00000C16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C16,
        0x00000C16,
        0x00000C16
    };

    static _CharacterInfo _character00000C17 =
    {
        0x00000C17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C17,
        0x00000C17,
        0x00000C17
    };

    static _CharacterInfo _character00000C18 =
    {
        0x00000C18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C18,
        0x00000C18,
        0x00000C18
    };

    static _CharacterInfo _character00000C19 =
    {
        0x00000C19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C19,
        0x00000C19,
        0x00000C19
    };

    static _CharacterInfo _character00000C1A =
    {
        0x00000C1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1A,
        0x00000C1A,
        0x00000C1A
    };

    static _CharacterInfo _character00000C1B =
    {
        0x00000C1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1B,
        0x00000C1B,
        0x00000C1B
    };

    static _CharacterInfo _character00000C1C =
    {
        0x00000C1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1C,
        0x00000C1C,
        0x00000C1C
    };

    static _CharacterInfo _character00000C1D =
    {
        0x00000C1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1D,
        0x00000C1D,
        0x00000C1D
    };

    static _CharacterInfo _character00000C1E =
    {
        0x00000C1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1E,
        0x00000C1E,
        0x00000C1E
    };

    static _CharacterInfo _character00000C1F =
    {
        0x00000C1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C1F,
        0x00000C1F,
        0x00000C1F
    };

    static _CharacterInfo _character00000C20 =
    {
        0x00000C20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C20,
        0x00000C20,
        0x00000C20
    };

    static _CharacterInfo _character00000C21 =
    {
        0x00000C21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C21,
        0x00000C21,
        0x00000C21
    };

    static _CharacterInfo _character00000C22 =
    {
        0x00000C22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C22,
        0x00000C22,
        0x00000C22
    };

    static _CharacterInfo _character00000C23 =
    {
        0x00000C23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C23,
        0x00000C23,
        0x00000C23
    };

    static _CharacterInfo _character00000C24 =
    {
        0x00000C24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C24,
        0x00000C24,
        0x00000C24
    };

    static _CharacterInfo _character00000C25 =
    {
        0x00000C25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C25,
        0x00000C25,
        0x00000C25
    };

    static _CharacterInfo _character00000C26 =
    {
        0x00000C26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C26,
        0x00000C26,
        0x00000C26
    };

    static _CharacterInfo _character00000C27 =
    {
        0x00000C27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C27,
        0x00000C27,
        0x00000C27
    };

    static _CharacterInfo _character00000C28 =
    {
        0x00000C28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C28,
        0x00000C28,
        0x00000C28
    };

    static _CharacterInfo _character00000C2A =
    {
        0x00000C2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2A,
        0x00000C2A,
        0x00000C2A
    };

    static _CharacterInfo _character00000C2B =
    {
        0x00000C2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2B,
        0x00000C2B,
        0x00000C2B
    };

    static _CharacterInfo _character00000C2C =
    {
        0x00000C2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2C,
        0x00000C2C,
        0x00000C2C
    };

    static _CharacterInfo _character00000C2D =
    {
        0x00000C2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2D,
        0x00000C2D,
        0x00000C2D
    };

    static _CharacterInfo _character00000C2E =
    {
        0x00000C2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2E,
        0x00000C2E,
        0x00000C2E
    };

    static _CharacterInfo _character00000C2F =
    {
        0x00000C2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C2F,
        0x00000C2F,
        0x00000C2F
    };

    static _CharacterInfo _character00000C30 =
    {
        0x00000C30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C30,
        0x00000C30,
        0x00000C30
    };

    static _CharacterInfo _character00000C31 =
    {
        0x00000C31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C31,
        0x00000C31,
        0x00000C31
    };

    static _CharacterInfo _character00000C32 =
    {
        0x00000C32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C32,
        0x00000C32,
        0x00000C32
    };

    static _CharacterInfo _character00000C33 =
    {
        0x00000C33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C33,
        0x00000C33,
        0x00000C33
    };

    static _CharacterInfo _character00000C35 =
    {
        0x00000C35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C35,
        0x00000C35,
        0x00000C35
    };

    static _CharacterInfo _character00000C36 =
    {
        0x00000C36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C36,
        0x00000C36,
        0x00000C36
    };

    static _CharacterInfo _character00000C37 =
    {
        0x00000C37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C37,
        0x00000C37,
        0x00000C37
    };

    static _CharacterInfo _character00000C38 =
    {
        0x00000C38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C38,
        0x00000C38,
        0x00000C38
    };

    static _CharacterInfo _character00000C39 =
    {
        0x00000C39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C39,
        0x00000C39,
        0x00000C39
    };

    static _CharacterInfo _character00000C3E =
    {
        0x00000C3E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C3E,
        0x00000C3E,
        0x00000C3E
    };

    static _CharacterInfo _character00000C3F =
    {
        0x00000C3F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C3F,
        0x00000C3F,
        0x00000C3F
    };

    static _CharacterInfo _character00000C40 =
    {
        0x00000C40,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C40,
        0x00000C40,
        0x00000C40
    };

    static _CharacterInfo _character00000C41 =
    {
        0x00000C41,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C41,
        0x00000C41,
        0x00000C41
    };

    static _CharacterInfo _character00000C42 =
    {
        0x00000C42,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C42,
        0x00000C42,
        0x00000C42
    };

    static _CharacterInfo _character00000C43 =
    {
        0x00000C43,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C43,
        0x00000C43,
        0x00000C43
    };

    static _CharacterInfo _character00000C44 =
    {
        0x00000C44,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C44,
        0x00000C44,
        0x00000C44
    };

    static _CharacterInfo _character00000C46 =
    {
        0x00000C46,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C46,
        0x00000C46,
        0x00000C46
    };

    static _CharacterInfo _character00000C47 =
    {
        0x00000C47,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C47,
        0x00000C47,
        0x00000C47
    };

    static Char _decompositionMapping00000C48[] = 
    {
        0x00000C46,
        0x00000C56
    };

    static _CharacterInfo _character00000C48 =
    {
        0x00000C48,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000C48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C48,
        0x00000C48,
        0x00000C48
    };

    static _CharacterInfo _character00000C4A =
    {
        0x00000C4A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C4A,
        0x00000C4A,
        0x00000C4A
    };

    static _CharacterInfo _character00000C4B =
    {
        0x00000C4B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C4B,
        0x00000C4B,
        0x00000C4B
    };

    static _CharacterInfo _character00000C4C =
    {
        0x00000C4C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C4C,
        0x00000C4C,
        0x00000C4C
    };

    static _CharacterInfo _character00000C4D =
    {
        0x00000C4D,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C4D,
        0x00000C4D,
        0x00000C4D
    };

    static _CharacterInfo _character00000C55 =
    {
        0x00000C55,
        Iso10646::GeneralCategory_Mn,
        84,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C55,
        0x00000C55,
        0x00000C55
    };

    static _CharacterInfo _character00000C56 =
    {
        0x00000C56,
        Iso10646::GeneralCategory_Mn,
        91,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C56,
        0x00000C56,
        0x00000C56
    };

    static _CharacterInfo _character00000C60 =
    {
        0x00000C60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C60,
        0x00000C60,
        0x00000C60
    };

    static _CharacterInfo _character00000C61 =
    {
        0x00000C61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C61,
        0x00000C61,
        0x00000C61
    };

    static _CharacterInfo _character00000C66 =
    {
        0x00000C66,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000C66,
        0x00000C66,
        0x00000C66
    };

    static _CharacterInfo _character00000C67 =
    {
        0x00000C67,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000C67,
        0x00000C67,
        0x00000C67
    };

    static _CharacterInfo _character00000C68 =
    {
        0x00000C68,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000C68,
        0x00000C68,
        0x00000C68
    };

    static _CharacterInfo _character00000C69 =
    {
        0x00000C69,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000C69,
        0x00000C69,
        0x00000C69
    };

    static _CharacterInfo _character00000C6A =
    {
        0x00000C6A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000C6A,
        0x00000C6A,
        0x00000C6A
    };

    static _CharacterInfo _character00000C6B =
    {
        0x00000C6B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000C6B,
        0x00000C6B,
        0x00000C6B
    };

    static _CharacterInfo _character00000C6C =
    {
        0x00000C6C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000C6C,
        0x00000C6C,
        0x00000C6C
    };

    static _CharacterInfo _character00000C6D =
    {
        0x00000C6D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000C6D,
        0x00000C6D,
        0x00000C6D
    };

    static _CharacterInfo _character00000C6E =
    {
        0x00000C6E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000C6E,
        0x00000C6E,
        0x00000C6E
    };

    static _CharacterInfo _character00000C6F =
    {
        0x00000C6F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000C6F,
        0x00000C6F,
        0x00000C6F
    };

    static _CharacterInfo _character00000C82 =
    {
        0x00000C82,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C82,
        0x00000C82,
        0x00000C82
    };

    static _CharacterInfo _character00000C83 =
    {
        0x00000C83,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C83,
        0x00000C83,
        0x00000C83
    };

    static _CharacterInfo _character00000C85 =
    {
        0x00000C85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C85,
        0x00000C85,
        0x00000C85
    };

    static _CharacterInfo _character00000C86 =
    {
        0x00000C86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C86,
        0x00000C86,
        0x00000C86
    };

    static _CharacterInfo _character00000C87 =
    {
        0x00000C87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C87,
        0x00000C87,
        0x00000C87
    };

    static _CharacterInfo _character00000C88 =
    {
        0x00000C88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C88,
        0x00000C88,
        0x00000C88
    };

    static _CharacterInfo _character00000C89 =
    {
        0x00000C89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C89,
        0x00000C89,
        0x00000C89
    };

    static _CharacterInfo _character00000C8A =
    {
        0x00000C8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C8A,
        0x00000C8A,
        0x00000C8A
    };

    static _CharacterInfo _character00000C8B =
    {
        0x00000C8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C8B,
        0x00000C8B,
        0x00000C8B
    };

    static _CharacterInfo _character00000C8C =
    {
        0x00000C8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C8C,
        0x00000C8C,
        0x00000C8C
    };

    static _CharacterInfo _character00000C8E =
    {
        0x00000C8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C8E,
        0x00000C8E,
        0x00000C8E
    };

    static _CharacterInfo _character00000C8F =
    {
        0x00000C8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C8F,
        0x00000C8F,
        0x00000C8F
    };

    static _CharacterInfo _character00000C90 =
    {
        0x00000C90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C90,
        0x00000C90,
        0x00000C90
    };

    static _CharacterInfo _character00000C92 =
    {
        0x00000C92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C92,
        0x00000C92,
        0x00000C92
    };

    static _CharacterInfo _character00000C93 =
    {
        0x00000C93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C93,
        0x00000C93,
        0x00000C93
    };

    static _CharacterInfo _character00000C94 =
    {
        0x00000C94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C94,
        0x00000C94,
        0x00000C94
    };

    static _CharacterInfo _character00000C95 =
    {
        0x00000C95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C95,
        0x00000C95,
        0x00000C95
    };

    static _CharacterInfo _character00000C96 =
    {
        0x00000C96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C96,
        0x00000C96,
        0x00000C96
    };

    static _CharacterInfo _character00000C97 =
    {
        0x00000C97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C97,
        0x00000C97,
        0x00000C97
    };

    static _CharacterInfo _character00000C98 =
    {
        0x00000C98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C98,
        0x00000C98,
        0x00000C98
    };

    static _CharacterInfo _character00000C99 =
    {
        0x00000C99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C99,
        0x00000C99,
        0x00000C99
    };

    static _CharacterInfo _character00000C9A =
    {
        0x00000C9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9A,
        0x00000C9A,
        0x00000C9A
    };

    static _CharacterInfo _character00000C9B =
    {
        0x00000C9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9B,
        0x00000C9B,
        0x00000C9B
    };

    static _CharacterInfo _character00000C9C =
    {
        0x00000C9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9C,
        0x00000C9C,
        0x00000C9C
    };

    static _CharacterInfo _character00000C9D =
    {
        0x00000C9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9D,
        0x00000C9D,
        0x00000C9D
    };

    static _CharacterInfo _character00000C9E =
    {
        0x00000C9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9E,
        0x00000C9E,
        0x00000C9E
    };

    static _CharacterInfo _character00000C9F =
    {
        0x00000C9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000C9F,
        0x00000C9F,
        0x00000C9F
    };

    static _CharacterInfo _character00000CA0 =
    {
        0x00000CA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA0,
        0x00000CA0,
        0x00000CA0
    };

    static _CharacterInfo _character00000CA1 =
    {
        0x00000CA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA1,
        0x00000CA1,
        0x00000CA1
    };

    static _CharacterInfo _character00000CA2 =
    {
        0x00000CA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA2,
        0x00000CA2,
        0x00000CA2
    };

    static _CharacterInfo _character00000CA3 =
    {
        0x00000CA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA3,
        0x00000CA3,
        0x00000CA3
    };

    static _CharacterInfo _character00000CA4 =
    {
        0x00000CA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA4,
        0x00000CA4,
        0x00000CA4
    };

    static _CharacterInfo _character00000CA5 =
    {
        0x00000CA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA5,
        0x00000CA5,
        0x00000CA5
    };

    static _CharacterInfo _character00000CA6 =
    {
        0x00000CA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA6,
        0x00000CA6,
        0x00000CA6
    };

    static _CharacterInfo _character00000CA7 =
    {
        0x00000CA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA7,
        0x00000CA7,
        0x00000CA7
    };

    static _CharacterInfo _character00000CA8 =
    {
        0x00000CA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CA8,
        0x00000CA8,
        0x00000CA8
    };

    static _CharacterInfo _character00000CAA =
    {
        0x00000CAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAA,
        0x00000CAA,
        0x00000CAA
    };

    static _CharacterInfo _character00000CAB =
    {
        0x00000CAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAB,
        0x00000CAB,
        0x00000CAB
    };

    static _CharacterInfo _character00000CAC =
    {
        0x00000CAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAC,
        0x00000CAC,
        0x00000CAC
    };

    static _CharacterInfo _character00000CAD =
    {
        0x00000CAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAD,
        0x00000CAD,
        0x00000CAD
    };

    static _CharacterInfo _character00000CAE =
    {
        0x00000CAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAE,
        0x00000CAE,
        0x00000CAE
    };

    static _CharacterInfo _character00000CAF =
    {
        0x00000CAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CAF,
        0x00000CAF,
        0x00000CAF
    };

    static _CharacterInfo _character00000CB0 =
    {
        0x00000CB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB0,
        0x00000CB0,
        0x00000CB0
    };

    static _CharacterInfo _character00000CB1 =
    {
        0x00000CB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB1,
        0x00000CB1,
        0x00000CB1
    };

    static _CharacterInfo _character00000CB2 =
    {
        0x00000CB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB2,
        0x00000CB2,
        0x00000CB2
    };

    static _CharacterInfo _character00000CB3 =
    {
        0x00000CB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB3,
        0x00000CB3,
        0x00000CB3
    };

    static _CharacterInfo _character00000CB5 =
    {
        0x00000CB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB5,
        0x00000CB5,
        0x00000CB5
    };

    static _CharacterInfo _character00000CB6 =
    {
        0x00000CB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB6,
        0x00000CB6,
        0x00000CB6
    };

    static _CharacterInfo _character00000CB7 =
    {
        0x00000CB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB7,
        0x00000CB7,
        0x00000CB7
    };

    static _CharacterInfo _character00000CB8 =
    {
        0x00000CB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB8,
        0x00000CB8,
        0x00000CB8
    };

    static _CharacterInfo _character00000CB9 =
    {
        0x00000CB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CB9,
        0x00000CB9,
        0x00000CB9
    };

    static _CharacterInfo _character00000CBC =
    {
        0x00000CBC,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CBC,
        0x00000CBC,
        0x00000CBC
    };

    static _CharacterInfo _character00000CBD =
    {
        0x00000CBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CBD,
        0x00000CBD,
        0x00000CBD
    };

    static _CharacterInfo _character00000CBE =
    {
        0x00000CBE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CBE,
        0x00000CBE,
        0x00000CBE
    };

    static _CharacterInfo _character00000CBF =
    {
        0x00000CBF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CBF,
        0x00000CBF,
        0x00000CBF
    };

    static Char _decompositionMapping00000CC0[] = 
    {
        0x00000CBF,
        0x00000CD5
    };

    static _CharacterInfo _character00000CC0 =
    {
        0x00000CC0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000CC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC0,
        0x00000CC0,
        0x00000CC0
    };

    static _CharacterInfo _character00000CC1 =
    {
        0x00000CC1,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC1,
        0x00000CC1,
        0x00000CC1
    };

    static _CharacterInfo _character00000CC2 =
    {
        0x00000CC2,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC2,
        0x00000CC2,
        0x00000CC2
    };

    static _CharacterInfo _character00000CC3 =
    {
        0x00000CC3,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC3,
        0x00000CC3,
        0x00000CC3
    };

    static _CharacterInfo _character00000CC4 =
    {
        0x00000CC4,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC4,
        0x00000CC4,
        0x00000CC4
    };

    static _CharacterInfo _character00000CC6 =
    {
        0x00000CC6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC6,
        0x00000CC6,
        0x00000CC6
    };

    static Char _decompositionMapping00000CC7[] = 
    {
        0x00000CC6,
        0x00000CD5
    };

    static _CharacterInfo _character00000CC7 =
    {
        0x00000CC7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000CC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC7,
        0x00000CC7,
        0x00000CC7
    };

    static Char _decompositionMapping00000CC8[] = 
    {
        0x00000CC6,
        0x00000CD6
    };

    static _CharacterInfo _character00000CC8 =
    {
        0x00000CC8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000CC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CC8,
        0x00000CC8,
        0x00000CC8
    };

    static Char _decompositionMapping00000CCA[] = 
    {
        0x00000CC6,
        0x00000CC2
    };

    static _CharacterInfo _character00000CCA =
    {
        0x00000CCA,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000CCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CCA,
        0x00000CCA,
        0x00000CCA
    };

    static Char _decompositionMapping00000CCB[] = 
    {
        0x00000CCA,
        0x00000CD5
    };

    static _CharacterInfo _character00000CCB =
    {
        0x00000CCB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000CCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CCB,
        0x00000CCB,
        0x00000CCB
    };

    static _CharacterInfo _character00000CCC =
    {
        0x00000CCC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CCC,
        0x00000CCC,
        0x00000CCC
    };

    static _CharacterInfo _character00000CCD =
    {
        0x00000CCD,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CCD,
        0x00000CCD,
        0x00000CCD
    };

    static _CharacterInfo _character00000CD5 =
    {
        0x00000CD5,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CD5,
        0x00000CD5,
        0x00000CD5
    };

    static _CharacterInfo _character00000CD6 =
    {
        0x00000CD6,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CD6,
        0x00000CD6,
        0x00000CD6
    };

    static _CharacterInfo _character00000CDE =
    {
        0x00000CDE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CDE,
        0x00000CDE,
        0x00000CDE
    };

    static _CharacterInfo _character00000CE0 =
    {
        0x00000CE0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CE0,
        0x00000CE0,
        0x00000CE0
    };

    static _CharacterInfo _character00000CE1 =
    {
        0x00000CE1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CE1,
        0x00000CE1,
        0x00000CE1
    };

    static _CharacterInfo _character00000CE2 =
    {
        0x00000CE2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CE2,
        0x00000CE2,
        0x00000CE2
    };

    static _CharacterInfo _character00000CE3 =
    {
        0x00000CE3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CE3,
        0x00000CE3,
        0x00000CE3
    };

    static _CharacterInfo _character00000CE6 =
    {
        0x00000CE6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000CE6,
        0x00000CE6,
        0x00000CE6
    };

    static _CharacterInfo _character00000CE7 =
    {
        0x00000CE7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000CE7,
        0x00000CE7,
        0x00000CE7
    };

    static _CharacterInfo _character00000CE8 =
    {
        0x00000CE8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000CE8,
        0x00000CE8,
        0x00000CE8
    };

    static _CharacterInfo _character00000CE9 =
    {
        0x00000CE9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000CE9,
        0x00000CE9,
        0x00000CE9
    };

    static _CharacterInfo _character00000CEA =
    {
        0x00000CEA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000CEA,
        0x00000CEA,
        0x00000CEA
    };

    static _CharacterInfo _character00000CEB =
    {
        0x00000CEB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000CEB,
        0x00000CEB,
        0x00000CEB
    };

    static _CharacterInfo _character00000CEC =
    {
        0x00000CEC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000CEC,
        0x00000CEC,
        0x00000CEC
    };

    static _CharacterInfo _character00000CED =
    {
        0x00000CED,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000CED,
        0x00000CED,
        0x00000CED
    };

    static _CharacterInfo _character00000CEE =
    {
        0x00000CEE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000CEE,
        0x00000CEE,
        0x00000CEE
    };

    static _CharacterInfo _character00000CEF =
    {
        0x00000CEF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000CEF,
        0x00000CEF,
        0x00000CEF
    };

    static _CharacterInfo _character00000CF1 =
    {
        0x00000CF1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CF1,
        0x00000CF1,
        0x00000CF1
    };

    static _CharacterInfo _character00000CF2 =
    {
        0x00000CF2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000CF2,
        0x00000CF2,
        0x00000CF2
    };

    static _CharacterInfo _character00000D02 =
    {
        0x00000D02,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D02,
        0x00000D02,
        0x00000D02
    };

    static _CharacterInfo _character00000D03 =
    {
        0x00000D03,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D03,
        0x00000D03,
        0x00000D03
    };

    static _CharacterInfo _character00000D05 =
    {
        0x00000D05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D05,
        0x00000D05,
        0x00000D05
    };

    static _CharacterInfo _character00000D06 =
    {
        0x00000D06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D06,
        0x00000D06,
        0x00000D06
    };

    static _CharacterInfo _character00000D07 =
    {
        0x00000D07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D07,
        0x00000D07,
        0x00000D07
    };

    static _CharacterInfo _character00000D08 =
    {
        0x00000D08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D08,
        0x00000D08,
        0x00000D08
    };

    static _CharacterInfo _character00000D09 =
    {
        0x00000D09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D09,
        0x00000D09,
        0x00000D09
    };

    static _CharacterInfo _character00000D0A =
    {
        0x00000D0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D0A,
        0x00000D0A,
        0x00000D0A
    };

    static _CharacterInfo _character00000D0B =
    {
        0x00000D0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D0B,
        0x00000D0B,
        0x00000D0B
    };

    static _CharacterInfo _character00000D0C =
    {
        0x00000D0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D0C,
        0x00000D0C,
        0x00000D0C
    };

    static _CharacterInfo _character00000D0E =
    {
        0x00000D0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D0E,
        0x00000D0E,
        0x00000D0E
    };

    static _CharacterInfo _character00000D0F =
    {
        0x00000D0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D0F,
        0x00000D0F,
        0x00000D0F
    };

    static _CharacterInfo _character00000D10 =
    {
        0x00000D10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D10,
        0x00000D10,
        0x00000D10
    };

    static _CharacterInfo _character00000D12 =
    {
        0x00000D12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D12,
        0x00000D12,
        0x00000D12
    };

    static _CharacterInfo _character00000D13 =
    {
        0x00000D13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D13,
        0x00000D13,
        0x00000D13
    };

    static _CharacterInfo _character00000D14 =
    {
        0x00000D14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D14,
        0x00000D14,
        0x00000D14
    };

    static _CharacterInfo _character00000D15 =
    {
        0x00000D15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D15,
        0x00000D15,
        0x00000D15
    };

    static _CharacterInfo _character00000D16 =
    {
        0x00000D16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D16,
        0x00000D16,
        0x00000D16
    };

    static _CharacterInfo _character00000D17 =
    {
        0x00000D17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D17,
        0x00000D17,
        0x00000D17
    };

    static _CharacterInfo _character00000D18 =
    {
        0x00000D18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D18,
        0x00000D18,
        0x00000D18
    };

    static _CharacterInfo _character00000D19 =
    {
        0x00000D19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D19,
        0x00000D19,
        0x00000D19
    };

    static _CharacterInfo _character00000D1A =
    {
        0x00000D1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1A,
        0x00000D1A,
        0x00000D1A
    };

    static _CharacterInfo _character00000D1B =
    {
        0x00000D1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1B,
        0x00000D1B,
        0x00000D1B
    };

    static _CharacterInfo _character00000D1C =
    {
        0x00000D1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1C,
        0x00000D1C,
        0x00000D1C
    };

    static _CharacterInfo _character00000D1D =
    {
        0x00000D1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1D,
        0x00000D1D,
        0x00000D1D
    };

    static _CharacterInfo _character00000D1E =
    {
        0x00000D1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1E,
        0x00000D1E,
        0x00000D1E
    };

    static _CharacterInfo _character00000D1F =
    {
        0x00000D1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D1F,
        0x00000D1F,
        0x00000D1F
    };

    static _CharacterInfo _character00000D20 =
    {
        0x00000D20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D20,
        0x00000D20,
        0x00000D20
    };

    static _CharacterInfo _character00000D21 =
    {
        0x00000D21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D21,
        0x00000D21,
        0x00000D21
    };

    static _CharacterInfo _character00000D22 =
    {
        0x00000D22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D22,
        0x00000D22,
        0x00000D22
    };

    static _CharacterInfo _character00000D23 =
    {
        0x00000D23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D23,
        0x00000D23,
        0x00000D23
    };

    static _CharacterInfo _character00000D24 =
    {
        0x00000D24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D24,
        0x00000D24,
        0x00000D24
    };

    static _CharacterInfo _character00000D25 =
    {
        0x00000D25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D25,
        0x00000D25,
        0x00000D25
    };

    static _CharacterInfo _character00000D26 =
    {
        0x00000D26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D26,
        0x00000D26,
        0x00000D26
    };

    static _CharacterInfo _character00000D27 =
    {
        0x00000D27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D27,
        0x00000D27,
        0x00000D27
    };

    static _CharacterInfo _character00000D28 =
    {
        0x00000D28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D28,
        0x00000D28,
        0x00000D28
    };

    static _CharacterInfo _character00000D2A =
    {
        0x00000D2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2A,
        0x00000D2A,
        0x00000D2A
    };

    static _CharacterInfo _character00000D2B =
    {
        0x00000D2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2B,
        0x00000D2B,
        0x00000D2B
    };

    static _CharacterInfo _character00000D2C =
    {
        0x00000D2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2C,
        0x00000D2C,
        0x00000D2C
    };

    static _CharacterInfo _character00000D2D =
    {
        0x00000D2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2D,
        0x00000D2D,
        0x00000D2D
    };

    static _CharacterInfo _character00000D2E =
    {
        0x00000D2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2E,
        0x00000D2E,
        0x00000D2E
    };

    static _CharacterInfo _character00000D2F =
    {
        0x00000D2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D2F,
        0x00000D2F,
        0x00000D2F
    };

    static _CharacterInfo _character00000D30 =
    {
        0x00000D30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D30,
        0x00000D30,
        0x00000D30
    };

    static _CharacterInfo _character00000D31 =
    {
        0x00000D31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D31,
        0x00000D31,
        0x00000D31
    };

    static _CharacterInfo _character00000D32 =
    {
        0x00000D32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D32,
        0x00000D32,
        0x00000D32
    };

    static _CharacterInfo _character00000D33 =
    {
        0x00000D33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D33,
        0x00000D33,
        0x00000D33
    };

    static _CharacterInfo _character00000D34 =
    {
        0x00000D34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D34,
        0x00000D34,
        0x00000D34
    };

    static _CharacterInfo _character00000D35 =
    {
        0x00000D35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D35,
        0x00000D35,
        0x00000D35
    };

    static _CharacterInfo _character00000D36 =
    {
        0x00000D36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D36,
        0x00000D36,
        0x00000D36
    };

    static _CharacterInfo _character00000D37 =
    {
        0x00000D37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D37,
        0x00000D37,
        0x00000D37
    };

    static _CharacterInfo _character00000D38 =
    {
        0x00000D38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D38,
        0x00000D38,
        0x00000D38
    };

    static _CharacterInfo _character00000D39 =
    {
        0x00000D39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D39,
        0x00000D39,
        0x00000D39
    };

    static _CharacterInfo _character00000D3E =
    {
        0x00000D3E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D3E,
        0x00000D3E,
        0x00000D3E
    };

    static _CharacterInfo _character00000D3F =
    {
        0x00000D3F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D3F,
        0x00000D3F,
        0x00000D3F
    };

    static _CharacterInfo _character00000D40 =
    {
        0x00000D40,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D40,
        0x00000D40,
        0x00000D40
    };

    static _CharacterInfo _character00000D41 =
    {
        0x00000D41,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D41,
        0x00000D41,
        0x00000D41
    };

    static _CharacterInfo _character00000D42 =
    {
        0x00000D42,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D42,
        0x00000D42,
        0x00000D42
    };

    static _CharacterInfo _character00000D43 =
    {
        0x00000D43,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D43,
        0x00000D43,
        0x00000D43
    };

    static _CharacterInfo _character00000D46 =
    {
        0x00000D46,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D46,
        0x00000D46,
        0x00000D46
    };

    static _CharacterInfo _character00000D47 =
    {
        0x00000D47,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D47,
        0x00000D47,
        0x00000D47
    };

    static _CharacterInfo _character00000D48 =
    {
        0x00000D48,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D48,
        0x00000D48,
        0x00000D48
    };

    static Char _decompositionMapping00000D4A[] = 
    {
        0x00000D46,
        0x00000D3E
    };

    static _CharacterInfo _character00000D4A =
    {
        0x00000D4A,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000D4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D4A,
        0x00000D4A,
        0x00000D4A
    };

    static Char _decompositionMapping00000D4B[] = 
    {
        0x00000D47,
        0x00000D3E
    };

    static _CharacterInfo _character00000D4B =
    {
        0x00000D4B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000D4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D4B,
        0x00000D4B,
        0x00000D4B
    };

    static Char _decompositionMapping00000D4C[] = 
    {
        0x00000D46,
        0x00000D57
    };

    static _CharacterInfo _character00000D4C =
    {
        0x00000D4C,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000D4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D4C,
        0x00000D4C,
        0x00000D4C
    };

    static _CharacterInfo _character00000D4D =
    {
        0x00000D4D,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D4D,
        0x00000D4D,
        0x00000D4D
    };

    static _CharacterInfo _character00000D57 =
    {
        0x00000D57,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D57,
        0x00000D57,
        0x00000D57
    };

    static _CharacterInfo _character00000D60 =
    {
        0x00000D60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D60,
        0x00000D60,
        0x00000D60
    };

    static _CharacterInfo _character00000D61 =
    {
        0x00000D61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D61,
        0x00000D61,
        0x00000D61
    };

    static _CharacterInfo _character00000D66 =
    {
        0x00000D66,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000D66,
        0x00000D66,
        0x00000D66
    };

    static _CharacterInfo _character00000D67 =
    {
        0x00000D67,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000D67,
        0x00000D67,
        0x00000D67
    };

    static _CharacterInfo _character00000D68 =
    {
        0x00000D68,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000D68,
        0x00000D68,
        0x00000D68
    };

    static _CharacterInfo _character00000D69 =
    {
        0x00000D69,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000D69,
        0x00000D69,
        0x00000D69
    };

    static _CharacterInfo _character00000D6A =
    {
        0x00000D6A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000D6A,
        0x00000D6A,
        0x00000D6A
    };

    static _CharacterInfo _character00000D6B =
    {
        0x00000D6B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000D6B,
        0x00000D6B,
        0x00000D6B
    };

    static _CharacterInfo _character00000D6C =
    {
        0x00000D6C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000D6C,
        0x00000D6C,
        0x00000D6C
    };

    static _CharacterInfo _character00000D6D =
    {
        0x00000D6D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000D6D,
        0x00000D6D,
        0x00000D6D
    };

    static _CharacterInfo _character00000D6E =
    {
        0x00000D6E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000D6E,
        0x00000D6E,
        0x00000D6E
    };

    static _CharacterInfo _character00000D6F =
    {
        0x00000D6F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000D6F,
        0x00000D6F,
        0x00000D6F
    };

    static _CharacterInfo _character00000D82 =
    {
        0x00000D82,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D82,
        0x00000D82,
        0x00000D82
    };

    static _CharacterInfo _character00000D83 =
    {
        0x00000D83,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D83,
        0x00000D83,
        0x00000D83
    };

    static _CharacterInfo _character00000D85 =
    {
        0x00000D85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D85,
        0x00000D85,
        0x00000D85
    };

    static _CharacterInfo _character00000D86 =
    {
        0x00000D86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D86,
        0x00000D86,
        0x00000D86
    };

    static _CharacterInfo _character00000D87 =
    {
        0x00000D87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D87,
        0x00000D87,
        0x00000D87
    };

    static _CharacterInfo _character00000D88 =
    {
        0x00000D88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D88,
        0x00000D88,
        0x00000D88
    };

    static _CharacterInfo _character00000D89 =
    {
        0x00000D89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D89,
        0x00000D89,
        0x00000D89
    };

    static _CharacterInfo _character00000D8A =
    {
        0x00000D8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8A,
        0x00000D8A,
        0x00000D8A
    };

    static _CharacterInfo _character00000D8B =
    {
        0x00000D8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8B,
        0x00000D8B,
        0x00000D8B
    };

    static _CharacterInfo _character00000D8C =
    {
        0x00000D8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8C,
        0x00000D8C,
        0x00000D8C
    };

    static _CharacterInfo _character00000D8D =
    {
        0x00000D8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8D,
        0x00000D8D,
        0x00000D8D
    };

    static _CharacterInfo _character00000D8E =
    {
        0x00000D8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8E,
        0x00000D8E,
        0x00000D8E
    };

    static _CharacterInfo _character00000D8F =
    {
        0x00000D8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D8F,
        0x00000D8F,
        0x00000D8F
    };

    static _CharacterInfo _character00000D90 =
    {
        0x00000D90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D90,
        0x00000D90,
        0x00000D90
    };

    static _CharacterInfo _character00000D91 =
    {
        0x00000D91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D91,
        0x00000D91,
        0x00000D91
    };

    static _CharacterInfo _character00000D92 =
    {
        0x00000D92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D92,
        0x00000D92,
        0x00000D92
    };

    static _CharacterInfo _character00000D93 =
    {
        0x00000D93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D93,
        0x00000D93,
        0x00000D93
    };

    static _CharacterInfo _character00000D94 =
    {
        0x00000D94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D94,
        0x00000D94,
        0x00000D94
    };

    static _CharacterInfo _character00000D95 =
    {
        0x00000D95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D95,
        0x00000D95,
        0x00000D95
    };

    static _CharacterInfo _character00000D96 =
    {
        0x00000D96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D96,
        0x00000D96,
        0x00000D96
    };

    static _CharacterInfo _character00000D9A =
    {
        0x00000D9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9A,
        0x00000D9A,
        0x00000D9A
    };

    static _CharacterInfo _character00000D9B =
    {
        0x00000D9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9B,
        0x00000D9B,
        0x00000D9B
    };

    static _CharacterInfo _character00000D9C =
    {
        0x00000D9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9C,
        0x00000D9C,
        0x00000D9C
    };

    static _CharacterInfo _character00000D9D =
    {
        0x00000D9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9D,
        0x00000D9D,
        0x00000D9D
    };

    static _CharacterInfo _character00000D9E =
    {
        0x00000D9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9E,
        0x00000D9E,
        0x00000D9E
    };

    static _CharacterInfo _character00000D9F =
    {
        0x00000D9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000D9F,
        0x00000D9F,
        0x00000D9F
    };

    static _CharacterInfo _character00000DA0 =
    {
        0x00000DA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA0,
        0x00000DA0,
        0x00000DA0
    };

    static _CharacterInfo _character00000DA1 =
    {
        0x00000DA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA1,
        0x00000DA1,
        0x00000DA1
    };

    static _CharacterInfo _character00000DA2 =
    {
        0x00000DA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA2,
        0x00000DA2,
        0x00000DA2
    };

    static _CharacterInfo _character00000DA3 =
    {
        0x00000DA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA3,
        0x00000DA3,
        0x00000DA3
    };

    static _CharacterInfo _character00000DA4 =
    {
        0x00000DA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA4,
        0x00000DA4,
        0x00000DA4
    };

    static _CharacterInfo _character00000DA5 =
    {
        0x00000DA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA5,
        0x00000DA5,
        0x00000DA5
    };

    static _CharacterInfo _character00000DA6 =
    {
        0x00000DA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA6,
        0x00000DA6,
        0x00000DA6
    };

    static _CharacterInfo _character00000DA7 =
    {
        0x00000DA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA7,
        0x00000DA7,
        0x00000DA7
    };

    static _CharacterInfo _character00000DA8 =
    {
        0x00000DA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA8,
        0x00000DA8,
        0x00000DA8
    };

    static _CharacterInfo _character00000DA9 =
    {
        0x00000DA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DA9,
        0x00000DA9,
        0x00000DA9
    };

    static _CharacterInfo _character00000DAA =
    {
        0x00000DAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAA,
        0x00000DAA,
        0x00000DAA
    };

    static _CharacterInfo _character00000DAB =
    {
        0x00000DAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAB,
        0x00000DAB,
        0x00000DAB
    };

    static _CharacterInfo _character00000DAC =
    {
        0x00000DAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAC,
        0x00000DAC,
        0x00000DAC
    };

    static _CharacterInfo _character00000DAD =
    {
        0x00000DAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAD,
        0x00000DAD,
        0x00000DAD
    };

    static _CharacterInfo _character00000DAE =
    {
        0x00000DAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAE,
        0x00000DAE,
        0x00000DAE
    };

    static _CharacterInfo _character00000DAF =
    {
        0x00000DAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DAF,
        0x00000DAF,
        0x00000DAF
    };

    static _CharacterInfo _character00000DB0 =
    {
        0x00000DB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB0,
        0x00000DB0,
        0x00000DB0
    };

    static _CharacterInfo _character00000DB1 =
    {
        0x00000DB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB1,
        0x00000DB1,
        0x00000DB1
    };

    static _CharacterInfo _character00000DB3 =
    {
        0x00000DB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB3,
        0x00000DB3,
        0x00000DB3
    };

    static _CharacterInfo _character00000DB4 =
    {
        0x00000DB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB4,
        0x00000DB4,
        0x00000DB4
    };

    static _CharacterInfo _character00000DB5 =
    {
        0x00000DB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB5,
        0x00000DB5,
        0x00000DB5
    };

    static _CharacterInfo _character00000DB6 =
    {
        0x00000DB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB6,
        0x00000DB6,
        0x00000DB6
    };

    static _CharacterInfo _character00000DB7 =
    {
        0x00000DB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB7,
        0x00000DB7,
        0x00000DB7
    };

    static _CharacterInfo _character00000DB8 =
    {
        0x00000DB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB8,
        0x00000DB8,
        0x00000DB8
    };

    static _CharacterInfo _character00000DB9 =
    {
        0x00000DB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DB9,
        0x00000DB9,
        0x00000DB9
    };

    static _CharacterInfo _character00000DBA =
    {
        0x00000DBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DBA,
        0x00000DBA,
        0x00000DBA
    };

    static _CharacterInfo _character00000DBB =
    {
        0x00000DBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DBB,
        0x00000DBB,
        0x00000DBB
    };

    static _CharacterInfo _character00000DBD =
    {
        0x00000DBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DBD,
        0x00000DBD,
        0x00000DBD
    };

    static _CharacterInfo _character00000DC0 =
    {
        0x00000DC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC0,
        0x00000DC0,
        0x00000DC0
    };

    static _CharacterInfo _character00000DC1 =
    {
        0x00000DC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC1,
        0x00000DC1,
        0x00000DC1
    };

    static _CharacterInfo _character00000DC2 =
    {
        0x00000DC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC2,
        0x00000DC2,
        0x00000DC2
    };

    static _CharacterInfo _character00000DC3 =
    {
        0x00000DC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC3,
        0x00000DC3,
        0x00000DC3
    };

    static _CharacterInfo _character00000DC4 =
    {
        0x00000DC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC4,
        0x00000DC4,
        0x00000DC4
    };

    static _CharacterInfo _character00000DC5 =
    {
        0x00000DC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC5,
        0x00000DC5,
        0x00000DC5
    };

    static _CharacterInfo _character00000DC6 =
    {
        0x00000DC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DC6,
        0x00000DC6,
        0x00000DC6
    };

    static _CharacterInfo _character00000DCA =
    {
        0x00000DCA,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DCA,
        0x00000DCA,
        0x00000DCA
    };

    static _CharacterInfo _character00000DCF =
    {
        0x00000DCF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DCF,
        0x00000DCF,
        0x00000DCF
    };

    static _CharacterInfo _character00000DD0 =
    {
        0x00000DD0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD0,
        0x00000DD0,
        0x00000DD0
    };

    static _CharacterInfo _character00000DD1 =
    {
        0x00000DD1,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD1,
        0x00000DD1,
        0x00000DD1
    };

    static _CharacterInfo _character00000DD2 =
    {
        0x00000DD2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD2,
        0x00000DD2,
        0x00000DD2
    };

    static _CharacterInfo _character00000DD3 =
    {
        0x00000DD3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD3,
        0x00000DD3,
        0x00000DD3
    };

    static _CharacterInfo _character00000DD4 =
    {
        0x00000DD4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD4,
        0x00000DD4,
        0x00000DD4
    };

    static _CharacterInfo _character00000DD6 =
    {
        0x00000DD6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD6,
        0x00000DD6,
        0x00000DD6
    };

    static _CharacterInfo _character00000DD8 =
    {
        0x00000DD8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD8,
        0x00000DD8,
        0x00000DD8
    };

    static _CharacterInfo _character00000DD9 =
    {
        0x00000DD9,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DD9,
        0x00000DD9,
        0x00000DD9
    };

    static Char _decompositionMapping00000DDA[] = 
    {
        0x00000DD9,
        0x00000DCA
    };

    static _CharacterInfo _character00000DDA =
    {
        0x00000DDA,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000DDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDA,
        0x00000DDA,
        0x00000DDA
    };

    static _CharacterInfo _character00000DDB =
    {
        0x00000DDB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDB,
        0x00000DDB,
        0x00000DDB
    };

    static Char _decompositionMapping00000DDC[] = 
    {
        0x00000DD9,
        0x00000DCF
    };

    static _CharacterInfo _character00000DDC =
    {
        0x00000DDC,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000DDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDC,
        0x00000DDC,
        0x00000DDC
    };

    static Char _decompositionMapping00000DDD[] = 
    {
        0x00000DDC,
        0x00000DCA
    };

    static _CharacterInfo _character00000DDD =
    {
        0x00000DDD,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000DDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDD,
        0x00000DDD,
        0x00000DDD
    };

    static Char _decompositionMapping00000DDE[] = 
    {
        0x00000DD9,
        0x00000DDF
    };

    static _CharacterInfo _character00000DDE =
    {
        0x00000DDE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000DDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDE,
        0x00000DDE,
        0x00000DDE
    };

    static _CharacterInfo _character00000DDF =
    {
        0x00000DDF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DDF,
        0x00000DDF,
        0x00000DDF
    };

    static _CharacterInfo _character00000DF2 =
    {
        0x00000DF2,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DF2,
        0x00000DF2,
        0x00000DF2
    };

    static _CharacterInfo _character00000DF3 =
    {
        0x00000DF3,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DF3,
        0x00000DF3,
        0x00000DF3
    };

    static _CharacterInfo _character00000DF4 =
    {
        0x00000DF4,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000DF4,
        0x00000DF4,
        0x00000DF4
    };

    static _CharacterInfo _character00000E01 =
    {
        0x00000E01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E01,
        0x00000E01,
        0x00000E01
    };

    static _CharacterInfo _character00000E02 =
    {
        0x00000E02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E02,
        0x00000E02,
        0x00000E02
    };

    static _CharacterInfo _character00000E03 =
    {
        0x00000E03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E03,
        0x00000E03,
        0x00000E03
    };

    static _CharacterInfo _character00000E04 =
    {
        0x00000E04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E04,
        0x00000E04,
        0x00000E04
    };

    static _CharacterInfo _character00000E05 =
    {
        0x00000E05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E05,
        0x00000E05,
        0x00000E05
    };

    static _CharacterInfo _character00000E06 =
    {
        0x00000E06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E06,
        0x00000E06,
        0x00000E06
    };

    static _CharacterInfo _character00000E07 =
    {
        0x00000E07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E07,
        0x00000E07,
        0x00000E07
    };

    static _CharacterInfo _character00000E08 =
    {
        0x00000E08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E08,
        0x00000E08,
        0x00000E08
    };

    static _CharacterInfo _character00000E09 =
    {
        0x00000E09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E09,
        0x00000E09,
        0x00000E09
    };

    static _CharacterInfo _character00000E0A =
    {
        0x00000E0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0A,
        0x00000E0A,
        0x00000E0A
    };

    static _CharacterInfo _character00000E0B =
    {
        0x00000E0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0B,
        0x00000E0B,
        0x00000E0B
    };

    static _CharacterInfo _character00000E0C =
    {
        0x00000E0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0C,
        0x00000E0C,
        0x00000E0C
    };

    static _CharacterInfo _character00000E0D =
    {
        0x00000E0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0D,
        0x00000E0D,
        0x00000E0D
    };

    static _CharacterInfo _character00000E0E =
    {
        0x00000E0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0E,
        0x00000E0E,
        0x00000E0E
    };

    static _CharacterInfo _character00000E0F =
    {
        0x00000E0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E0F,
        0x00000E0F,
        0x00000E0F
    };

    static _CharacterInfo _character00000E10 =
    {
        0x00000E10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E10,
        0x00000E10,
        0x00000E10
    };

    static _CharacterInfo _character00000E11 =
    {
        0x00000E11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E11,
        0x00000E11,
        0x00000E11
    };

    static _CharacterInfo _character00000E12 =
    {
        0x00000E12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E12,
        0x00000E12,
        0x00000E12
    };

    static _CharacterInfo _character00000E13 =
    {
        0x00000E13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E13,
        0x00000E13,
        0x00000E13
    };

    static _CharacterInfo _character00000E14 =
    {
        0x00000E14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E14,
        0x00000E14,
        0x00000E14
    };

    static _CharacterInfo _character00000E15 =
    {
        0x00000E15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E15,
        0x00000E15,
        0x00000E15
    };

    static _CharacterInfo _character00000E16 =
    {
        0x00000E16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E16,
        0x00000E16,
        0x00000E16
    };

    static _CharacterInfo _character00000E17 =
    {
        0x00000E17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E17,
        0x00000E17,
        0x00000E17
    };

    static _CharacterInfo _character00000E18 =
    {
        0x00000E18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E18,
        0x00000E18,
        0x00000E18
    };

    static _CharacterInfo _character00000E19 =
    {
        0x00000E19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E19,
        0x00000E19,
        0x00000E19
    };

    static _CharacterInfo _character00000E1A =
    {
        0x00000E1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1A,
        0x00000E1A,
        0x00000E1A
    };

    static _CharacterInfo _character00000E1B =
    {
        0x00000E1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1B,
        0x00000E1B,
        0x00000E1B
    };

    static _CharacterInfo _character00000E1C =
    {
        0x00000E1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1C,
        0x00000E1C,
        0x00000E1C
    };

    static _CharacterInfo _character00000E1D =
    {
        0x00000E1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1D,
        0x00000E1D,
        0x00000E1D
    };

    static _CharacterInfo _character00000E1E =
    {
        0x00000E1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1E,
        0x00000E1E,
        0x00000E1E
    };

    static _CharacterInfo _character00000E1F =
    {
        0x00000E1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E1F,
        0x00000E1F,
        0x00000E1F
    };

    static _CharacterInfo _character00000E20 =
    {
        0x00000E20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E20,
        0x00000E20,
        0x00000E20
    };

    static _CharacterInfo _character00000E21 =
    {
        0x00000E21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E21,
        0x00000E21,
        0x00000E21
    };

    static _CharacterInfo _character00000E22 =
    {
        0x00000E22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E22,
        0x00000E22,
        0x00000E22
    };

    static _CharacterInfo _character00000E23 =
    {
        0x00000E23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E23,
        0x00000E23,
        0x00000E23
    };

    static _CharacterInfo _character00000E24 =
    {
        0x00000E24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E24,
        0x00000E24,
        0x00000E24
    };

    static _CharacterInfo _character00000E25 =
    {
        0x00000E25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E25,
        0x00000E25,
        0x00000E25
    };

    static _CharacterInfo _character00000E26 =
    {
        0x00000E26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E26,
        0x00000E26,
        0x00000E26
    };

    static _CharacterInfo _character00000E27 =
    {
        0x00000E27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E27,
        0x00000E27,
        0x00000E27
    };

    static _CharacterInfo _character00000E28 =
    {
        0x00000E28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E28,
        0x00000E28,
        0x00000E28
    };

    static _CharacterInfo _character00000E29 =
    {
        0x00000E29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E29,
        0x00000E29,
        0x00000E29
    };

    static _CharacterInfo _character00000E2A =
    {
        0x00000E2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2A,
        0x00000E2A,
        0x00000E2A
    };

    static _CharacterInfo _character00000E2B =
    {
        0x00000E2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2B,
        0x00000E2B,
        0x00000E2B
    };

    static _CharacterInfo _character00000E2C =
    {
        0x00000E2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2C,
        0x00000E2C,
        0x00000E2C
    };

    static _CharacterInfo _character00000E2D =
    {
        0x00000E2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2D,
        0x00000E2D,
        0x00000E2D
    };

    static _CharacterInfo _character00000E2E =
    {
        0x00000E2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2E,
        0x00000E2E,
        0x00000E2E
    };

    static _CharacterInfo _character00000E2F =
    {
        0x00000E2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E2F,
        0x00000E2F,
        0x00000E2F
    };

    static _CharacterInfo _character00000E30 =
    {
        0x00000E30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E30,
        0x00000E30,
        0x00000E30
    };

    static _CharacterInfo _character00000E31 =
    {
        0x00000E31,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E31,
        0x00000E31,
        0x00000E31
    };

    static _CharacterInfo _character00000E32 =
    {
        0x00000E32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E32,
        0x00000E32,
        0x00000E32
    };

    static Char _decompositionMapping00000E33[] = 
    {
        0x00000E4D,
        0x00000E32
    };

    static _CharacterInfo _character00000E33 =
    {
        0x00000E33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000E33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E33,
        0x00000E33,
        0x00000E33
    };

    static _CharacterInfo _character00000E34 =
    {
        0x00000E34,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E34,
        0x00000E34,
        0x00000E34
    };

    static _CharacterInfo _character00000E35 =
    {
        0x00000E35,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E35,
        0x00000E35,
        0x00000E35
    };

    static _CharacterInfo _character00000E36 =
    {
        0x00000E36,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E36,
        0x00000E36,
        0x00000E36
    };

    static _CharacterInfo _character00000E37 =
    {
        0x00000E37,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E37,
        0x00000E37,
        0x00000E37
    };

    static _CharacterInfo _character00000E38 =
    {
        0x00000E38,
        Iso10646::GeneralCategory_Mn,
        103,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E38,
        0x00000E38,
        0x00000E38
    };

    static _CharacterInfo _character00000E39 =
    {
        0x00000E39,
        Iso10646::GeneralCategory_Mn,
        103,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E39,
        0x00000E39,
        0x00000E39
    };

    static _CharacterInfo _character00000E3A =
    {
        0x00000E3A,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E3A,
        0x00000E3A,
        0x00000E3A
    };

    static _CharacterInfo _character00000E3F =
    {
        0x00000E3F,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E3F,
        0x00000E3F,
        0x00000E3F
    };

    static _CharacterInfo _character00000E40 =
    {
        0x00000E40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E40,
        0x00000E40,
        0x00000E40
    };

    static _CharacterInfo _character00000E41 =
    {
        0x00000E41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E41,
        0x00000E41,
        0x00000E41
    };

    static _CharacterInfo _character00000E42 =
    {
        0x00000E42,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E42,
        0x00000E42,
        0x00000E42
    };

    static _CharacterInfo _character00000E43 =
    {
        0x00000E43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E43,
        0x00000E43,
        0x00000E43
    };

    static _CharacterInfo _character00000E44 =
    {
        0x00000E44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E44,
        0x00000E44,
        0x00000E44
    };

    static _CharacterInfo _character00000E45 =
    {
        0x00000E45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E45,
        0x00000E45,
        0x00000E45
    };

    static _CharacterInfo _character00000E46 =
    {
        0x00000E46,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E46,
        0x00000E46,
        0x00000E46
    };

    static _CharacterInfo _character00000E47 =
    {
        0x00000E47,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E47,
        0x00000E47,
        0x00000E47
    };

    static _CharacterInfo _character00000E48 =
    {
        0x00000E48,
        Iso10646::GeneralCategory_Mn,
        107,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E48,
        0x00000E48,
        0x00000E48
    };

    static _CharacterInfo _character00000E49 =
    {
        0x00000E49,
        Iso10646::GeneralCategory_Mn,
        107,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E49,
        0x00000E49,
        0x00000E49
    };

    static _CharacterInfo _character00000E4A =
    {
        0x00000E4A,
        Iso10646::GeneralCategory_Mn,
        107,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4A,
        0x00000E4A,
        0x00000E4A
    };

    static _CharacterInfo _character00000E4B =
    {
        0x00000E4B,
        Iso10646::GeneralCategory_Mn,
        107,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4B,
        0x00000E4B,
        0x00000E4B
    };

    static _CharacterInfo _character00000E4C =
    {
        0x00000E4C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4C,
        0x00000E4C,
        0x00000E4C
    };

    static _CharacterInfo _character00000E4D =
    {
        0x00000E4D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4D,
        0x00000E4D,
        0x00000E4D
    };

    static _CharacterInfo _character00000E4E =
    {
        0x00000E4E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4E,
        0x00000E4E,
        0x00000E4E
    };

    static _CharacterInfo _character00000E4F =
    {
        0x00000E4F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E4F,
        0x00000E4F,
        0x00000E4F
    };

    static _CharacterInfo _character00000E50 =
    {
        0x00000E50,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000E50,
        0x00000E50,
        0x00000E50
    };

    static _CharacterInfo _character00000E51 =
    {
        0x00000E51,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000E51,
        0x00000E51,
        0x00000E51
    };

    static _CharacterInfo _character00000E52 =
    {
        0x00000E52,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000E52,
        0x00000E52,
        0x00000E52
    };

    static _CharacterInfo _character00000E53 =
    {
        0x00000E53,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000E53,
        0x00000E53,
        0x00000E53
    };

    static _CharacterInfo _character00000E54 =
    {
        0x00000E54,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000E54,
        0x00000E54,
        0x00000E54
    };

    static _CharacterInfo _character00000E55 =
    {
        0x00000E55,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000E55,
        0x00000E55,
        0x00000E55
    };

    static _CharacterInfo _character00000E56 =
    {
        0x00000E56,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000E56,
        0x00000E56,
        0x00000E56
    };

    static _CharacterInfo _character00000E57 =
    {
        0x00000E57,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000E57,
        0x00000E57,
        0x00000E57
    };

    static _CharacterInfo _character00000E58 =
    {
        0x00000E58,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000E58,
        0x00000E58,
        0x00000E58
    };

    static _CharacterInfo _character00000E59 =
    {
        0x00000E59,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000E59,
        0x00000E59,
        0x00000E59
    };

    static _CharacterInfo _character00000E5A =
    {
        0x00000E5A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E5A,
        0x00000E5A,
        0x00000E5A
    };

    static _CharacterInfo _character00000E5B =
    {
        0x00000E5B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E5B,
        0x00000E5B,
        0x00000E5B
    };

    static _CharacterInfo _character00000E81 =
    {
        0x00000E81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E81,
        0x00000E81,
        0x00000E81
    };

    static _CharacterInfo _character00000E82 =
    {
        0x00000E82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E82,
        0x00000E82,
        0x00000E82
    };

    static _CharacterInfo _character00000E84 =
    {
        0x00000E84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E84,
        0x00000E84,
        0x00000E84
    };

    static _CharacterInfo _character00000E87 =
    {
        0x00000E87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E87,
        0x00000E87,
        0x00000E87
    };

    static _CharacterInfo _character00000E88 =
    {
        0x00000E88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E88,
        0x00000E88,
        0x00000E88
    };

    static _CharacterInfo _character00000E8A =
    {
        0x00000E8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E8A,
        0x00000E8A,
        0x00000E8A
    };

    static _CharacterInfo _character00000E8D =
    {
        0x00000E8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E8D,
        0x00000E8D,
        0x00000E8D
    };

    static _CharacterInfo _character00000E94 =
    {
        0x00000E94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E94,
        0x00000E94,
        0x00000E94
    };

    static _CharacterInfo _character00000E95 =
    {
        0x00000E95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E95,
        0x00000E95,
        0x00000E95
    };

    static _CharacterInfo _character00000E96 =
    {
        0x00000E96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E96,
        0x00000E96,
        0x00000E96
    };

    static _CharacterInfo _character00000E97 =
    {
        0x00000E97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E97,
        0x00000E97,
        0x00000E97
    };

    static _CharacterInfo _character00000E99 =
    {
        0x00000E99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E99,
        0x00000E99,
        0x00000E99
    };

    static _CharacterInfo _character00000E9A =
    {
        0x00000E9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9A,
        0x00000E9A,
        0x00000E9A
    };

    static _CharacterInfo _character00000E9B =
    {
        0x00000E9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9B,
        0x00000E9B,
        0x00000E9B
    };

    static _CharacterInfo _character00000E9C =
    {
        0x00000E9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9C,
        0x00000E9C,
        0x00000E9C
    };

    static _CharacterInfo _character00000E9D =
    {
        0x00000E9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9D,
        0x00000E9D,
        0x00000E9D
    };

    static _CharacterInfo _character00000E9E =
    {
        0x00000E9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9E,
        0x00000E9E,
        0x00000E9E
    };

    static _CharacterInfo _character00000E9F =
    {
        0x00000E9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000E9F,
        0x00000E9F,
        0x00000E9F
    };

    static _CharacterInfo _character00000EA1 =
    {
        0x00000EA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EA1,
        0x00000EA1,
        0x00000EA1
    };

    static _CharacterInfo _character00000EA2 =
    {
        0x00000EA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EA2,
        0x00000EA2,
        0x00000EA2
    };

    static _CharacterInfo _character00000EA3 =
    {
        0x00000EA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EA3,
        0x00000EA3,
        0x00000EA3
    };

    static _CharacterInfo _character00000EA5 =
    {
        0x00000EA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EA5,
        0x00000EA5,
        0x00000EA5
    };

    static _CharacterInfo _character00000EA7 =
    {
        0x00000EA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EA7,
        0x00000EA7,
        0x00000EA7
    };

    static _CharacterInfo _character00000EAA =
    {
        0x00000EAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EAA,
        0x00000EAA,
        0x00000EAA
    };

    static _CharacterInfo _character00000EAB =
    {
        0x00000EAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EAB,
        0x00000EAB,
        0x00000EAB
    };

    static _CharacterInfo _character00000EAD =
    {
        0x00000EAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EAD,
        0x00000EAD,
        0x00000EAD
    };

    static _CharacterInfo _character00000EAE =
    {
        0x00000EAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EAE,
        0x00000EAE,
        0x00000EAE
    };

    static _CharacterInfo _character00000EAF =
    {
        0x00000EAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EAF,
        0x00000EAF,
        0x00000EAF
    };

    static _CharacterInfo _character00000EB0 =
    {
        0x00000EB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB0,
        0x00000EB0,
        0x00000EB0
    };

    static _CharacterInfo _character00000EB1 =
    {
        0x00000EB1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB1,
        0x00000EB1,
        0x00000EB1
    };

    static _CharacterInfo _character00000EB2 =
    {
        0x00000EB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB2,
        0x00000EB2,
        0x00000EB2
    };

    static Char _decompositionMapping00000EB3[] = 
    {
        0x00000ECD,
        0x00000EB2
    };

    static _CharacterInfo _character00000EB3 =
    {
        0x00000EB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000EB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB3,
        0x00000EB3,
        0x00000EB3
    };

    static _CharacterInfo _character00000EB4 =
    {
        0x00000EB4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB4,
        0x00000EB4,
        0x00000EB4
    };

    static _CharacterInfo _character00000EB5 =
    {
        0x00000EB5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB5,
        0x00000EB5,
        0x00000EB5
    };

    static _CharacterInfo _character00000EB6 =
    {
        0x00000EB6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB6,
        0x00000EB6,
        0x00000EB6
    };

    static _CharacterInfo _character00000EB7 =
    {
        0x00000EB7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB7,
        0x00000EB7,
        0x00000EB7
    };

    static _CharacterInfo _character00000EB8 =
    {
        0x00000EB8,
        Iso10646::GeneralCategory_Mn,
        118,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB8,
        0x00000EB8,
        0x00000EB8
    };

    static _CharacterInfo _character00000EB9 =
    {
        0x00000EB9,
        Iso10646::GeneralCategory_Mn,
        118,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EB9,
        0x00000EB9,
        0x00000EB9
    };

    static _CharacterInfo _character00000EBB =
    {
        0x00000EBB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EBB,
        0x00000EBB,
        0x00000EBB
    };

    static _CharacterInfo _character00000EBC =
    {
        0x00000EBC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EBC,
        0x00000EBC,
        0x00000EBC
    };

    static _CharacterInfo _character00000EBD =
    {
        0x00000EBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EBD,
        0x00000EBD,
        0x00000EBD
    };

    static _CharacterInfo _character00000EC0 =
    {
        0x00000EC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC0,
        0x00000EC0,
        0x00000EC0
    };

    static _CharacterInfo _character00000EC1 =
    {
        0x00000EC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC1,
        0x00000EC1,
        0x00000EC1
    };

    static _CharacterInfo _character00000EC2 =
    {
        0x00000EC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC2,
        0x00000EC2,
        0x00000EC2
    };

    static _CharacterInfo _character00000EC3 =
    {
        0x00000EC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC3,
        0x00000EC3,
        0x00000EC3
    };

    static _CharacterInfo _character00000EC4 =
    {
        0x00000EC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC4,
        0x00000EC4,
        0x00000EC4
    };

    static _CharacterInfo _character00000EC6 =
    {
        0x00000EC6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC6,
        0x00000EC6,
        0x00000EC6
    };

    static _CharacterInfo _character00000EC8 =
    {
        0x00000EC8,
        Iso10646::GeneralCategory_Mn,
        122,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC8,
        0x00000EC8,
        0x00000EC8
    };

    static _CharacterInfo _character00000EC9 =
    {
        0x00000EC9,
        Iso10646::GeneralCategory_Mn,
        122,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EC9,
        0x00000EC9,
        0x00000EC9
    };

    static _CharacterInfo _character00000ECA =
    {
        0x00000ECA,
        Iso10646::GeneralCategory_Mn,
        122,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ECA,
        0x00000ECA,
        0x00000ECA
    };

    static _CharacterInfo _character00000ECB =
    {
        0x00000ECB,
        Iso10646::GeneralCategory_Mn,
        122,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ECB,
        0x00000ECB,
        0x00000ECB
    };

    static _CharacterInfo _character00000ECC =
    {
        0x00000ECC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ECC,
        0x00000ECC,
        0x00000ECC
    };

    static _CharacterInfo _character00000ECD =
    {
        0x00000ECD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000ECD,
        0x00000ECD,
        0x00000ECD
    };

    static _CharacterInfo _character00000ED0 =
    {
        0x00000ED0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000ED0,
        0x00000ED0,
        0x00000ED0
    };

    static _CharacterInfo _character00000ED1 =
    {
        0x00000ED1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000ED1,
        0x00000ED1,
        0x00000ED1
    };

    static _CharacterInfo _character00000ED2 =
    {
        0x00000ED2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000ED2,
        0x00000ED2,
        0x00000ED2
    };

    static _CharacterInfo _character00000ED3 =
    {
        0x00000ED3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000ED3,
        0x00000ED3,
        0x00000ED3
    };

    static _CharacterInfo _character00000ED4 =
    {
        0x00000ED4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000ED4,
        0x00000ED4,
        0x00000ED4
    };

    static _CharacterInfo _character00000ED5 =
    {
        0x00000ED5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000ED5,
        0x00000ED5,
        0x00000ED5
    };

    static _CharacterInfo _character00000ED6 =
    {
        0x00000ED6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000ED6,
        0x00000ED6,
        0x00000ED6
    };

    static _CharacterInfo _character00000ED7 =
    {
        0x00000ED7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000ED7,
        0x00000ED7,
        0x00000ED7
    };

    static _CharacterInfo _character00000ED8 =
    {
        0x00000ED8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000ED8,
        0x00000ED8,
        0x00000ED8
    };

    static _CharacterInfo _character00000ED9 =
    {
        0x00000ED9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000ED9,
        0x00000ED9,
        0x00000ED9
    };

    static Char _decompositionMapping00000EDC[] = 
    {
        0x00000EAB,
        0x00000E99
    };

    static _CharacterInfo _character00000EDC =
    {
        0x00000EDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000EDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EDC,
        0x00000EDC,
        0x00000EDC
    };

    static Char _decompositionMapping00000EDD[] = 
    {
        0x00000EAB,
        0x00000EA1
    };

    static _CharacterInfo _character00000EDD =
    {
        0x00000EDD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000EDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000EDD,
        0x00000EDD,
        0x00000EDD
    };

    static _CharacterInfo _character00000F00 =
    {
        0x00000F00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F00,
        0x00000F00,
        0x00000F00
    };

    static _CharacterInfo _character00000F01 =
    {
        0x00000F01,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F01,
        0x00000F01,
        0x00000F01
    };

    static _CharacterInfo _character00000F02 =
    {
        0x00000F02,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F02,
        0x00000F02,
        0x00000F02
    };

    static _CharacterInfo _character00000F03 =
    {
        0x00000F03,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F03,
        0x00000F03,
        0x00000F03
    };

    static _CharacterInfo _character00000F04 =
    {
        0x00000F04,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F04,
        0x00000F04,
        0x00000F04
    };

    static _CharacterInfo _character00000F05 =
    {
        0x00000F05,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F05,
        0x00000F05,
        0x00000F05
    };

    static _CharacterInfo _character00000F06 =
    {
        0x00000F06,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F06,
        0x00000F06,
        0x00000F06
    };

    static _CharacterInfo _character00000F07 =
    {
        0x00000F07,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F07,
        0x00000F07,
        0x00000F07
    };

    static _CharacterInfo _character00000F08 =
    {
        0x00000F08,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F08,
        0x00000F08,
        0x00000F08
    };

    static _CharacterInfo _character00000F09 =
    {
        0x00000F09,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F09,
        0x00000F09,
        0x00000F09
    };

    static _CharacterInfo _character00000F0A =
    {
        0x00000F0A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0A,
        0x00000F0A,
        0x00000F0A
    };

    static _CharacterInfo _character00000F0B =
    {
        0x00000F0B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0B,
        0x00000F0B,
        0x00000F0B
    };

    static Char _decompositionMapping00000F0C[] = 
    {
        0x00000F0B
    };

    static _CharacterInfo _character00000F0C =
    {
        0x00000F0C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_noBreak,
        1,
        _decompositionMapping00000F0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0C,
        0x00000F0C,
        0x00000F0C
    };

    static _CharacterInfo _character00000F0D =
    {
        0x00000F0D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0D,
        0x00000F0D,
        0x00000F0D
    };

    static _CharacterInfo _character00000F0E =
    {
        0x00000F0E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0E,
        0x00000F0E,
        0x00000F0E
    };

    static _CharacterInfo _character00000F0F =
    {
        0x00000F0F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F0F,
        0x00000F0F,
        0x00000F0F
    };

    static _CharacterInfo _character00000F10 =
    {
        0x00000F10,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F10,
        0x00000F10,
        0x00000F10
    };

    static _CharacterInfo _character00000F11 =
    {
        0x00000F11,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F11,
        0x00000F11,
        0x00000F11
    };

    static _CharacterInfo _character00000F12 =
    {
        0x00000F12,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F12,
        0x00000F12,
        0x00000F12
    };

    static _CharacterInfo _character00000F13 =
    {
        0x00000F13,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F13,
        0x00000F13,
        0x00000F13
    };

    static _CharacterInfo _character00000F14 =
    {
        0x00000F14,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F14,
        0x00000F14,
        0x00000F14
    };

    static _CharacterInfo _character00000F15 =
    {
        0x00000F15,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F15,
        0x00000F15,
        0x00000F15
    };

    static _CharacterInfo _character00000F16 =
    {
        0x00000F16,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F16,
        0x00000F16,
        0x00000F16
    };

    static _CharacterInfo _character00000F17 =
    {
        0x00000F17,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F17,
        0x00000F17,
        0x00000F17
    };

    static _CharacterInfo _character00000F18 =
    {
        0x00000F18,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F18,
        0x00000F18,
        0x00000F18
    };

    static _CharacterInfo _character00000F19 =
    {
        0x00000F19,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F19,
        0x00000F19,
        0x00000F19
    };

    static _CharacterInfo _character00000F1A =
    {
        0x00000F1A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1A,
        0x00000F1A,
        0x00000F1A
    };

    static _CharacterInfo _character00000F1B =
    {
        0x00000F1B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1B,
        0x00000F1B,
        0x00000F1B
    };

    static _CharacterInfo _character00000F1C =
    {
        0x00000F1C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1C,
        0x00000F1C,
        0x00000F1C
    };

    static _CharacterInfo _character00000F1D =
    {
        0x00000F1D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1D,
        0x00000F1D,
        0x00000F1D
    };

    static _CharacterInfo _character00000F1E =
    {
        0x00000F1E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1E,
        0x00000F1E,
        0x00000F1E
    };

    static _CharacterInfo _character00000F1F =
    {
        0x00000F1F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F1F,
        0x00000F1F,
        0x00000F1F
    };

    static _CharacterInfo _character00000F20 =
    {
        0x00000F20,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00000F20,
        0x00000F20,
        0x00000F20
    };

    static _CharacterInfo _character00000F21 =
    {
        0x00000F21,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00000F21,
        0x00000F21,
        0x00000F21
    };

    static _CharacterInfo _character00000F22 =
    {
        0x00000F22,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00000F22,
        0x00000F22,
        0x00000F22
    };

    static _CharacterInfo _character00000F23 =
    {
        0x00000F23,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00000F23,
        0x00000F23,
        0x00000F23
    };

    static _CharacterInfo _character00000F24 =
    {
        0x00000F24,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00000F24,
        0x00000F24,
        0x00000F24
    };

    static _CharacterInfo _character00000F25 =
    {
        0x00000F25,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00000F25,
        0x00000F25,
        0x00000F25
    };

    static _CharacterInfo _character00000F26 =
    {
        0x00000F26,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00000F26,
        0x00000F26,
        0x00000F26
    };

    static _CharacterInfo _character00000F27 =
    {
        0x00000F27,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00000F27,
        0x00000F27,
        0x00000F27
    };

    static _CharacterInfo _character00000F28 =
    {
        0x00000F28,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00000F28,
        0x00000F28,
        0x00000F28
    };

    static _CharacterInfo _character00000F29 =
    {
        0x00000F29,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00000F29,
        0x00000F29,
        0x00000F29
    };

    static _CharacterInfo _character00000F2A =
    {
        0x00000F2A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x00000F2A,
        0x00000F2A,
        0x00000F2A
    };

    static _CharacterInfo _character00000F2B =
    {
        0x00000F2B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        2,
        false,
        0x00000F2B,
        0x00000F2B,
        0x00000F2B
    };

    static _CharacterInfo _character00000F2C =
    {
        0x00000F2C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        2,
        false,
        0x00000F2C,
        0x00000F2C,
        0x00000F2C
    };

    static _CharacterInfo _character00000F2D =
    {
        0x00000F2D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        2,
        false,
        0x00000F2D,
        0x00000F2D,
        0x00000F2D
    };

    static _CharacterInfo _character00000F2E =
    {
        0x00000F2E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        2,
        false,
        0x00000F2E,
        0x00000F2E,
        0x00000F2E
    };

    static _CharacterInfo _character00000F2F =
    {
        0x00000F2F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        11,
        2,
        false,
        0x00000F2F,
        0x00000F2F,
        0x00000F2F
    };

    static _CharacterInfo _character00000F30 =
    {
        0x00000F30,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        13,
        2,
        false,
        0x00000F30,
        0x00000F30,
        0x00000F30
    };

    static _CharacterInfo _character00000F31 =
    {
        0x00000F31,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        15,
        2,
        false,
        0x00000F31,
        0x00000F31,
        0x00000F31
    };

    static _CharacterInfo _character00000F32 =
    {
        0x00000F32,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        17,
        2,
        false,
        0x00000F32,
        0x00000F32,
        0x00000F32
    };

    static _CharacterInfo _character00000F33 =
    {
        0x00000F33,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        -1,
        2,
        false,
        0x00000F33,
        0x00000F33,
        0x00000F33
    };

    static _CharacterInfo _character00000F34 =
    {
        0x00000F34,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F34,
        0x00000F34,
        0x00000F34
    };

    static _CharacterInfo _character00000F35 =
    {
        0x00000F35,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F35,
        0x00000F35,
        0x00000F35
    };

    static _CharacterInfo _character00000F36 =
    {
        0x00000F36,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F36,
        0x00000F36,
        0x00000F36
    };

    static _CharacterInfo _character00000F37 =
    {
        0x00000F37,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F37,
        0x00000F37,
        0x00000F37
    };

    static _CharacterInfo _character00000F38 =
    {
        0x00000F38,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F38,
        0x00000F38,
        0x00000F38
    };

    static _CharacterInfo _character00000F39 =
    {
        0x00000F39,
        Iso10646::GeneralCategory_Mn,
        216,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F39,
        0x00000F39,
        0x00000F39
    };

    static _CharacterInfo _character00000F3A =
    {
        0x00000F3A,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000F3A,
        0x00000F3A,
        0x00000F3A
    };

    static _CharacterInfo _character00000F3B =
    {
        0x00000F3B,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000F3B,
        0x00000F3B,
        0x00000F3B
    };

    static _CharacterInfo _character00000F3C =
    {
        0x00000F3C,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000F3C,
        0x00000F3C,
        0x00000F3C
    };

    static _CharacterInfo _character00000F3D =
    {
        0x00000F3D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00000F3D,
        0x00000F3D,
        0x00000F3D
    };

    static _CharacterInfo _character00000F3E =
    {
        0x00000F3E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F3E,
        0x00000F3E,
        0x00000F3E
    };

    static _CharacterInfo _character00000F3F =
    {
        0x00000F3F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F3F,
        0x00000F3F,
        0x00000F3F
    };

    static _CharacterInfo _character00000F40 =
    {
        0x00000F40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F40,
        0x00000F40,
        0x00000F40
    };

    static _CharacterInfo _character00000F41 =
    {
        0x00000F41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F41,
        0x00000F41,
        0x00000F41
    };

    static _CharacterInfo _character00000F42 =
    {
        0x00000F42,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F42,
        0x00000F42,
        0x00000F42
    };

    static Char _decompositionMapping00000F43[] = 
    {
        0x00000F42,
        0x00000FB7
    };

    static _CharacterInfo _character00000F43 =
    {
        0x00000F43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F43,
        0x00000F43,
        0x00000F43
    };

    static _CharacterInfo _character00000F44 =
    {
        0x00000F44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F44,
        0x00000F44,
        0x00000F44
    };

    static _CharacterInfo _character00000F45 =
    {
        0x00000F45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F45,
        0x00000F45,
        0x00000F45
    };

    static _CharacterInfo _character00000F46 =
    {
        0x00000F46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F46,
        0x00000F46,
        0x00000F46
    };

    static _CharacterInfo _character00000F47 =
    {
        0x00000F47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F47,
        0x00000F47,
        0x00000F47
    };

    static _CharacterInfo _character00000F49 =
    {
        0x00000F49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F49,
        0x00000F49,
        0x00000F49
    };

    static _CharacterInfo _character00000F4A =
    {
        0x00000F4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4A,
        0x00000F4A,
        0x00000F4A
    };

    static _CharacterInfo _character00000F4B =
    {
        0x00000F4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4B,
        0x00000F4B,
        0x00000F4B
    };

    static _CharacterInfo _character00000F4C =
    {
        0x00000F4C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4C,
        0x00000F4C,
        0x00000F4C
    };

    static Char _decompositionMapping00000F4D[] = 
    {
        0x00000F4C,
        0x00000FB7
    };

    static _CharacterInfo _character00000F4D =
    {
        0x00000F4D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4D,
        0x00000F4D,
        0x00000F4D
    };

    static _CharacterInfo _character00000F4E =
    {
        0x00000F4E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4E,
        0x00000F4E,
        0x00000F4E
    };

    static _CharacterInfo _character00000F4F =
    {
        0x00000F4F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F4F,
        0x00000F4F,
        0x00000F4F
    };

    static _CharacterInfo _character00000F50 =
    {
        0x00000F50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F50,
        0x00000F50,
        0x00000F50
    };

    static _CharacterInfo _character00000F51 =
    {
        0x00000F51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F51,
        0x00000F51,
        0x00000F51
    };

    static Char _decompositionMapping00000F52[] = 
    {
        0x00000F51,
        0x00000FB7
    };

    static _CharacterInfo _character00000F52 =
    {
        0x00000F52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F52,
        0x00000F52,
        0x00000F52
    };

    static _CharacterInfo _character00000F53 =
    {
        0x00000F53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F53,
        0x00000F53,
        0x00000F53
    };

    static _CharacterInfo _character00000F54 =
    {
        0x00000F54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F54,
        0x00000F54,
        0x00000F54
    };

    static _CharacterInfo _character00000F55 =
    {
        0x00000F55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F55,
        0x00000F55,
        0x00000F55
    };

    static _CharacterInfo _character00000F56 =
    {
        0x00000F56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F56,
        0x00000F56,
        0x00000F56
    };

    static Char _decompositionMapping00000F57[] = 
    {
        0x00000F56,
        0x00000FB7
    };

    static _CharacterInfo _character00000F57 =
    {
        0x00000F57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F57,
        0x00000F57,
        0x00000F57
    };

    static _CharacterInfo _character00000F58 =
    {
        0x00000F58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F58,
        0x00000F58,
        0x00000F58
    };

    static _CharacterInfo _character00000F59 =
    {
        0x00000F59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F59,
        0x00000F59,
        0x00000F59
    };

    static _CharacterInfo _character00000F5A =
    {
        0x00000F5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5A,
        0x00000F5A,
        0x00000F5A
    };

    static _CharacterInfo _character00000F5B =
    {
        0x00000F5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5B,
        0x00000F5B,
        0x00000F5B
    };

    static Char _decompositionMapping00000F5C[] = 
    {
        0x00000F5B,
        0x00000FB7
    };

    static _CharacterInfo _character00000F5C =
    {
        0x00000F5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5C,
        0x00000F5C,
        0x00000F5C
    };

    static _CharacterInfo _character00000F5D =
    {
        0x00000F5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5D,
        0x00000F5D,
        0x00000F5D
    };

    static _CharacterInfo _character00000F5E =
    {
        0x00000F5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5E,
        0x00000F5E,
        0x00000F5E
    };

    static _CharacterInfo _character00000F5F =
    {
        0x00000F5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F5F,
        0x00000F5F,
        0x00000F5F
    };

    static _CharacterInfo _character00000F60 =
    {
        0x00000F60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F60,
        0x00000F60,
        0x00000F60
    };

    static _CharacterInfo _character00000F61 =
    {
        0x00000F61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F61,
        0x00000F61,
        0x00000F61
    };

    static _CharacterInfo _character00000F62 =
    {
        0x00000F62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F62,
        0x00000F62,
        0x00000F62
    };

    static _CharacterInfo _character00000F63 =
    {
        0x00000F63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F63,
        0x00000F63,
        0x00000F63
    };

    static _CharacterInfo _character00000F64 =
    {
        0x00000F64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F64,
        0x00000F64,
        0x00000F64
    };

    static _CharacterInfo _character00000F65 =
    {
        0x00000F65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F65,
        0x00000F65,
        0x00000F65
    };

    static _CharacterInfo _character00000F66 =
    {
        0x00000F66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F66,
        0x00000F66,
        0x00000F66
    };

    static _CharacterInfo _character00000F67 =
    {
        0x00000F67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F67,
        0x00000F67,
        0x00000F67
    };

    static _CharacterInfo _character00000F68 =
    {
        0x00000F68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F68,
        0x00000F68,
        0x00000F68
    };

    static Char _decompositionMapping00000F69[] = 
    {
        0x00000F40,
        0x00000FB5
    };

    static _CharacterInfo _character00000F69 =
    {
        0x00000F69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F69,
        0x00000F69,
        0x00000F69
    };

    static _CharacterInfo _character00000F6A =
    {
        0x00000F6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F6A,
        0x00000F6A,
        0x00000F6A
    };

    static _CharacterInfo _character00000F71 =
    {
        0x00000F71,
        Iso10646::GeneralCategory_Mn,
        129,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F71,
        0x00000F71,
        0x00000F71
    };

    static _CharacterInfo _character00000F72 =
    {
        0x00000F72,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F72,
        0x00000F72,
        0x00000F72
    };

    static Char _decompositionMapping00000F73[] = 
    {
        0x00000F71,
        0x00000F72
    };

    static _CharacterInfo _character00000F73 =
    {
        0x00000F73,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F73,
        0x00000F73,
        0x00000F73
    };

    static _CharacterInfo _character00000F74 =
    {
        0x00000F74,
        Iso10646::GeneralCategory_Mn,
        132,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F74,
        0x00000F74,
        0x00000F74
    };

    static Char _decompositionMapping00000F75[] = 
    {
        0x00000F71,
        0x00000F74
    };

    static _CharacterInfo _character00000F75 =
    {
        0x00000F75,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F75,
        0x00000F75,
        0x00000F75
    };

    static Char _decompositionMapping00000F76[] = 
    {
        0x00000FB2,
        0x00000F80
    };

    static _CharacterInfo _character00000F76 =
    {
        0x00000F76,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F76,
        0x00000F76,
        0x00000F76
    };

    static Char _decompositionMapping00000F77[] = 
    {
        0x00000FB2,
        0x00000F81
    };

    static _CharacterInfo _character00000F77 =
    {
        0x00000F77,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000F77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F77,
        0x00000F77,
        0x00000F77
    };

    static Char _decompositionMapping00000F78[] = 
    {
        0x00000FB3,
        0x00000F80
    };

    static _CharacterInfo _character00000F78 =
    {
        0x00000F78,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F78,
        0x00000F78,
        0x00000F78
    };

    static Char _decompositionMapping00000F79[] = 
    {
        0x00000FB3,
        0x00000F81
    };

    static _CharacterInfo _character00000F79 =
    {
        0x00000F79,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00000F79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F79,
        0x00000F79,
        0x00000F79
    };

    static _CharacterInfo _character00000F7A =
    {
        0x00000F7A,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7A,
        0x00000F7A,
        0x00000F7A
    };

    static _CharacterInfo _character00000F7B =
    {
        0x00000F7B,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7B,
        0x00000F7B,
        0x00000F7B
    };

    static _CharacterInfo _character00000F7C =
    {
        0x00000F7C,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7C,
        0x00000F7C,
        0x00000F7C
    };

    static _CharacterInfo _character00000F7D =
    {
        0x00000F7D,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7D,
        0x00000F7D,
        0x00000F7D
    };

    static _CharacterInfo _character00000F7E =
    {
        0x00000F7E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7E,
        0x00000F7E,
        0x00000F7E
    };

    static _CharacterInfo _character00000F7F =
    {
        0x00000F7F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F7F,
        0x00000F7F,
        0x00000F7F
    };

    static _CharacterInfo _character00000F80 =
    {
        0x00000F80,
        Iso10646::GeneralCategory_Mn,
        130,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F80,
        0x00000F80,
        0x00000F80
    };

    static Char _decompositionMapping00000F81[] = 
    {
        0x00000F71,
        0x00000F80
    };

    static _CharacterInfo _character00000F81 =
    {
        0x00000F81,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F81,
        0x00000F81,
        0x00000F81
    };

    static _CharacterInfo _character00000F82 =
    {
        0x00000F82,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F82,
        0x00000F82,
        0x00000F82
    };

    static _CharacterInfo _character00000F83 =
    {
        0x00000F83,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F83,
        0x00000F83,
        0x00000F83
    };

    static _CharacterInfo _character00000F84 =
    {
        0x00000F84,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F84,
        0x00000F84,
        0x00000F84
    };

    static _CharacterInfo _character00000F85 =
    {
        0x00000F85,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F85,
        0x00000F85,
        0x00000F85
    };

    static _CharacterInfo _character00000F86 =
    {
        0x00000F86,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F86,
        0x00000F86,
        0x00000F86
    };

    static _CharacterInfo _character00000F87 =
    {
        0x00000F87,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F87,
        0x00000F87,
        0x00000F87
    };

    static _CharacterInfo _character00000F88 =
    {
        0x00000F88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F88,
        0x00000F88,
        0x00000F88
    };

    static _CharacterInfo _character00000F89 =
    {
        0x00000F89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F89,
        0x00000F89,
        0x00000F89
    };

    static _CharacterInfo _character00000F8A =
    {
        0x00000F8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F8A,
        0x00000F8A,
        0x00000F8A
    };

    static _CharacterInfo _character00000F8B =
    {
        0x00000F8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F8B,
        0x00000F8B,
        0x00000F8B
    };

    static _CharacterInfo _character00000F90 =
    {
        0x00000F90,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F90,
        0x00000F90,
        0x00000F90
    };

    static _CharacterInfo _character00000F91 =
    {
        0x00000F91,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F91,
        0x00000F91,
        0x00000F91
    };

    static _CharacterInfo _character00000F92 =
    {
        0x00000F92,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F92,
        0x00000F92,
        0x00000F92
    };

    static Char _decompositionMapping00000F93[] = 
    {
        0x00000F92,
        0x00000FB7
    };

    static _CharacterInfo _character00000F93 =
    {
        0x00000F93,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F93,
        0x00000F93,
        0x00000F93
    };

    static _CharacterInfo _character00000F94 =
    {
        0x00000F94,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F94,
        0x00000F94,
        0x00000F94
    };

    static _CharacterInfo _character00000F95 =
    {
        0x00000F95,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F95,
        0x00000F95,
        0x00000F95
    };

    static _CharacterInfo _character00000F96 =
    {
        0x00000F96,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F96,
        0x00000F96,
        0x00000F96
    };

    static _CharacterInfo _character00000F97 =
    {
        0x00000F97,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F97,
        0x00000F97,
        0x00000F97
    };

    static _CharacterInfo _character00000F99 =
    {
        0x00000F99,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F99,
        0x00000F99,
        0x00000F99
    };

    static _CharacterInfo _character00000F9A =
    {
        0x00000F9A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9A,
        0x00000F9A,
        0x00000F9A
    };

    static _CharacterInfo _character00000F9B =
    {
        0x00000F9B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9B,
        0x00000F9B,
        0x00000F9B
    };

    static _CharacterInfo _character00000F9C =
    {
        0x00000F9C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9C,
        0x00000F9C,
        0x00000F9C
    };

    static Char _decompositionMapping00000F9D[] = 
    {
        0x00000F9C,
        0x00000FB7
    };

    static _CharacterInfo _character00000F9D =
    {
        0x00000F9D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000F9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9D,
        0x00000F9D,
        0x00000F9D
    };

    static _CharacterInfo _character00000F9E =
    {
        0x00000F9E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9E,
        0x00000F9E,
        0x00000F9E
    };

    static _CharacterInfo _character00000F9F =
    {
        0x00000F9F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000F9F,
        0x00000F9F,
        0x00000F9F
    };

    static _CharacterInfo _character00000FA0 =
    {
        0x00000FA0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA0,
        0x00000FA0,
        0x00000FA0
    };

    static _CharacterInfo _character00000FA1 =
    {
        0x00000FA1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA1,
        0x00000FA1,
        0x00000FA1
    };

    static Char _decompositionMapping00000FA2[] = 
    {
        0x00000FA1,
        0x00000FB7
    };

    static _CharacterInfo _character00000FA2 =
    {
        0x00000FA2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000FA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA2,
        0x00000FA2,
        0x00000FA2
    };

    static _CharacterInfo _character00000FA3 =
    {
        0x00000FA3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA3,
        0x00000FA3,
        0x00000FA3
    };

    static _CharacterInfo _character00000FA4 =
    {
        0x00000FA4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA4,
        0x00000FA4,
        0x00000FA4
    };

    static _CharacterInfo _character00000FA5 =
    {
        0x00000FA5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA5,
        0x00000FA5,
        0x00000FA5
    };

    static _CharacterInfo _character00000FA6 =
    {
        0x00000FA6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA6,
        0x00000FA6,
        0x00000FA6
    };

    static Char _decompositionMapping00000FA7[] = 
    {
        0x00000FA6,
        0x00000FB7
    };

    static _CharacterInfo _character00000FA7 =
    {
        0x00000FA7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000FA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA7,
        0x00000FA7,
        0x00000FA7
    };

    static _CharacterInfo _character00000FA8 =
    {
        0x00000FA8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA8,
        0x00000FA8,
        0x00000FA8
    };

    static _CharacterInfo _character00000FA9 =
    {
        0x00000FA9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FA9,
        0x00000FA9,
        0x00000FA9
    };

    static _CharacterInfo _character00000FAA =
    {
        0x00000FAA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAA,
        0x00000FAA,
        0x00000FAA
    };

    static _CharacterInfo _character00000FAB =
    {
        0x00000FAB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAB,
        0x00000FAB,
        0x00000FAB
    };

    static Char _decompositionMapping00000FAC[] = 
    {
        0x00000FAB,
        0x00000FB7
    };

    static _CharacterInfo _character00000FAC =
    {
        0x00000FAC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000FAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAC,
        0x00000FAC,
        0x00000FAC
    };

    static _CharacterInfo _character00000FAD =
    {
        0x00000FAD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAD,
        0x00000FAD,
        0x00000FAD
    };

    static _CharacterInfo _character00000FAE =
    {
        0x00000FAE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAE,
        0x00000FAE,
        0x00000FAE
    };

    static _CharacterInfo _character00000FAF =
    {
        0x00000FAF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FAF,
        0x00000FAF,
        0x00000FAF
    };

    static _CharacterInfo _character00000FB0 =
    {
        0x00000FB0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB0,
        0x00000FB0,
        0x00000FB0
    };

    static _CharacterInfo _character00000FB1 =
    {
        0x00000FB1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB1,
        0x00000FB1,
        0x00000FB1
    };

    static _CharacterInfo _character00000FB2 =
    {
        0x00000FB2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB2,
        0x00000FB2,
        0x00000FB2
    };

    static _CharacterInfo _character00000FB3 =
    {
        0x00000FB3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB3,
        0x00000FB3,
        0x00000FB3
    };

    static _CharacterInfo _character00000FB4 =
    {
        0x00000FB4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB4,
        0x00000FB4,
        0x00000FB4
    };

    static _CharacterInfo _character00000FB5 =
    {
        0x00000FB5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB5,
        0x00000FB5,
        0x00000FB5
    };

    static _CharacterInfo _character00000FB6 =
    {
        0x00000FB6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB6,
        0x00000FB6,
        0x00000FB6
    };

    static _CharacterInfo _character00000FB7 =
    {
        0x00000FB7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB7,
        0x00000FB7,
        0x00000FB7
    };

    static _CharacterInfo _character00000FB8 =
    {
        0x00000FB8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB8,
        0x00000FB8,
        0x00000FB8
    };

    static Char _decompositionMapping00000FB9[] = 
    {
        0x00000F90,
        0x00000FB5
    };

    static _CharacterInfo _character00000FB9 =
    {
        0x00000FB9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00000FB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FB9,
        0x00000FB9,
        0x00000FB9
    };

    static _CharacterInfo _character00000FBA =
    {
        0x00000FBA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FBA,
        0x00000FBA,
        0x00000FBA
    };

    static _CharacterInfo _character00000FBB =
    {
        0x00000FBB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FBB,
        0x00000FBB,
        0x00000FBB
    };

    static _CharacterInfo _character00000FBC =
    {
        0x00000FBC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FBC,
        0x00000FBC,
        0x00000FBC
    };

    static _CharacterInfo _character00000FBE =
    {
        0x00000FBE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FBE,
        0x00000FBE,
        0x00000FBE
    };

    static _CharacterInfo _character00000FBF =
    {
        0x00000FBF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FBF,
        0x00000FBF,
        0x00000FBF
    };

    static _CharacterInfo _character00000FC0 =
    {
        0x00000FC0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC0,
        0x00000FC0,
        0x00000FC0
    };

    static _CharacterInfo _character00000FC1 =
    {
        0x00000FC1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC1,
        0x00000FC1,
        0x00000FC1
    };

    static _CharacterInfo _character00000FC2 =
    {
        0x00000FC2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC2,
        0x00000FC2,
        0x00000FC2
    };

    static _CharacterInfo _character00000FC3 =
    {
        0x00000FC3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC3,
        0x00000FC3,
        0x00000FC3
    };

    static _CharacterInfo _character00000FC4 =
    {
        0x00000FC4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC4,
        0x00000FC4,
        0x00000FC4
    };

    static _CharacterInfo _character00000FC5 =
    {
        0x00000FC5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC5,
        0x00000FC5,
        0x00000FC5
    };

    static _CharacterInfo _character00000FC6 =
    {
        0x00000FC6,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC6,
        0x00000FC6,
        0x00000FC6
    };

    static _CharacterInfo _character00000FC7 =
    {
        0x00000FC7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC7,
        0x00000FC7,
        0x00000FC7
    };

    static _CharacterInfo _character00000FC8 =
    {
        0x00000FC8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC8,
        0x00000FC8,
        0x00000FC8
    };

    static _CharacterInfo _character00000FC9 =
    {
        0x00000FC9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FC9,
        0x00000FC9,
        0x00000FC9
    };

    static _CharacterInfo _character00000FCA =
    {
        0x00000FCA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FCA,
        0x00000FCA,
        0x00000FCA
    };

    static _CharacterInfo _character00000FCB =
    {
        0x00000FCB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FCB,
        0x00000FCB,
        0x00000FCB
    };

    static _CharacterInfo _character00000FCC =
    {
        0x00000FCC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FCC,
        0x00000FCC,
        0x00000FCC
    };

    static _CharacterInfo _character00000FCF =
    {
        0x00000FCF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FCF,
        0x00000FCF,
        0x00000FCF
    };

    static _CharacterInfo _character00000FD0 =
    {
        0x00000FD0,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FD0,
        0x00000FD0,
        0x00000FD0
    };

    static _CharacterInfo _character00000FD1 =
    {
        0x00000FD1,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000FD1,
        0x00000FD1,
        0x00000FD1
    };

    static _CharacterInfo _character00001000 =
    {
        0x00001000,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001000,
        0x00001000,
        0x00001000
    };

    static _CharacterInfo _character00001001 =
    {
        0x00001001,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001001,
        0x00001001,
        0x00001001
    };

    static _CharacterInfo _character00001002 =
    {
        0x00001002,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001002,
        0x00001002,
        0x00001002
    };

    static _CharacterInfo _character00001003 =
    {
        0x00001003,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001003,
        0x00001003,
        0x00001003
    };

    static _CharacterInfo _character00001004 =
    {
        0x00001004,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001004,
        0x00001004,
        0x00001004
    };

    static _CharacterInfo _character00001005 =
    {
        0x00001005,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001005,
        0x00001005,
        0x00001005
    };

    static _CharacterInfo _character00001006 =
    {
        0x00001006,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001006,
        0x00001006,
        0x00001006
    };

    static _CharacterInfo _character00001007 =
    {
        0x00001007,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001007,
        0x00001007,
        0x00001007
    };

    static _CharacterInfo _character00001008 =
    {
        0x00001008,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001008,
        0x00001008,
        0x00001008
    };

    static _CharacterInfo _character00001009 =
    {
        0x00001009,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001009,
        0x00001009,
        0x00001009
    };

    static _CharacterInfo _character0000100A =
    {
        0x0000100A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100A,
        0x0000100A,
        0x0000100A
    };

    static _CharacterInfo _character0000100B =
    {
        0x0000100B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100B,
        0x0000100B,
        0x0000100B
    };

    static _CharacterInfo _character0000100C =
    {
        0x0000100C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100C,
        0x0000100C,
        0x0000100C
    };

    static _CharacterInfo _character0000100D =
    {
        0x0000100D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100D,
        0x0000100D,
        0x0000100D
    };

    static _CharacterInfo _character0000100E =
    {
        0x0000100E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100E,
        0x0000100E,
        0x0000100E
    };

    static _CharacterInfo _character0000100F =
    {
        0x0000100F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000100F,
        0x0000100F,
        0x0000100F
    };

    static _CharacterInfo _character00001010 =
    {
        0x00001010,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001010,
        0x00001010,
        0x00001010
    };

    static _CharacterInfo _character00001011 =
    {
        0x00001011,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001011,
        0x00001011,
        0x00001011
    };

    static _CharacterInfo _character00001012 =
    {
        0x00001012,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001012,
        0x00001012,
        0x00001012
    };

    static _CharacterInfo _character00001013 =
    {
        0x00001013,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001013,
        0x00001013,
        0x00001013
    };

    static _CharacterInfo _character00001014 =
    {
        0x00001014,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001014,
        0x00001014,
        0x00001014
    };

    static _CharacterInfo _character00001015 =
    {
        0x00001015,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001015,
        0x00001015,
        0x00001015
    };

    static _CharacterInfo _character00001016 =
    {
        0x00001016,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001016,
        0x00001016,
        0x00001016
    };

    static _CharacterInfo _character00001017 =
    {
        0x00001017,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001017,
        0x00001017,
        0x00001017
    };

    static _CharacterInfo _character00001018 =
    {
        0x00001018,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001018,
        0x00001018,
        0x00001018
    };

    static _CharacterInfo _character00001019 =
    {
        0x00001019,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001019,
        0x00001019,
        0x00001019
    };

    static _CharacterInfo _character0000101A =
    {
        0x0000101A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101A,
        0x0000101A,
        0x0000101A
    };

    static _CharacterInfo _character0000101B =
    {
        0x0000101B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101B,
        0x0000101B,
        0x0000101B
    };

    static _CharacterInfo _character0000101C =
    {
        0x0000101C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101C,
        0x0000101C,
        0x0000101C
    };

    static _CharacterInfo _character0000101D =
    {
        0x0000101D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101D,
        0x0000101D,
        0x0000101D
    };

    static _CharacterInfo _character0000101E =
    {
        0x0000101E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101E,
        0x0000101E,
        0x0000101E
    };

    static _CharacterInfo _character0000101F =
    {
        0x0000101F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000101F,
        0x0000101F,
        0x0000101F
    };

    static _CharacterInfo _character00001020 =
    {
        0x00001020,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001020,
        0x00001020,
        0x00001020
    };

    static _CharacterInfo _character00001021 =
    {
        0x00001021,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001021,
        0x00001021,
        0x00001021
    };

    static _CharacterInfo _character00001023 =
    {
        0x00001023,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001023,
        0x00001023,
        0x00001023
    };

    static _CharacterInfo _character00001024 =
    {
        0x00001024,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001024,
        0x00001024,
        0x00001024
    };

    static _CharacterInfo _character00001025 =
    {
        0x00001025,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001025,
        0x00001025,
        0x00001025
    };

    static Char _decompositionMapping00001026[] = 
    {
        0x00001025,
        0x0000102E
    };

    static _CharacterInfo _character00001026 =
    {
        0x00001026,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001026,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001026,
        0x00001026,
        0x00001026
    };

    static _CharacterInfo _character00001027 =
    {
        0x00001027,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001027,
        0x00001027,
        0x00001027
    };

    static _CharacterInfo _character00001029 =
    {
        0x00001029,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001029,
        0x00001029,
        0x00001029
    };

    static _CharacterInfo _character0000102A =
    {
        0x0000102A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000102A,
        0x0000102A,
        0x0000102A
    };

    static _CharacterInfo _character0000102C =
    {
        0x0000102C,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000102C,
        0x0000102C,
        0x0000102C
    };

    static _CharacterInfo _character0000102D =
    {
        0x0000102D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000102D,
        0x0000102D,
        0x0000102D
    };

    static _CharacterInfo _character0000102E =
    {
        0x0000102E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000102E,
        0x0000102E,
        0x0000102E
    };

    static _CharacterInfo _character0000102F =
    {
        0x0000102F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000102F,
        0x0000102F,
        0x0000102F
    };

    static _CharacterInfo _character00001030 =
    {
        0x00001030,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001030,
        0x00001030,
        0x00001030
    };

    static _CharacterInfo _character00001031 =
    {
        0x00001031,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001031,
        0x00001031,
        0x00001031
    };

    static _CharacterInfo _character00001032 =
    {
        0x00001032,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001032,
        0x00001032,
        0x00001032
    };

    static _CharacterInfo _character00001036 =
    {
        0x00001036,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001036,
        0x00001036,
        0x00001036
    };

    static _CharacterInfo _character00001037 =
    {
        0x00001037,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001037,
        0x00001037,
        0x00001037
    };

    static _CharacterInfo _character00001038 =
    {
        0x00001038,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001038,
        0x00001038,
        0x00001038
    };

    static _CharacterInfo _character00001039 =
    {
        0x00001039,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001039,
        0x00001039,
        0x00001039
    };

    static _CharacterInfo _character00001040 =
    {
        0x00001040,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00001040,
        0x00001040,
        0x00001040
    };

    static _CharacterInfo _character00001041 =
    {
        0x00001041,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00001041,
        0x00001041,
        0x00001041
    };

    static _CharacterInfo _character00001042 =
    {
        0x00001042,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00001042,
        0x00001042,
        0x00001042
    };

    static _CharacterInfo _character00001043 =
    {
        0x00001043,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00001043,
        0x00001043,
        0x00001043
    };

    static _CharacterInfo _character00001044 =
    {
        0x00001044,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00001044,
        0x00001044,
        0x00001044
    };

    static _CharacterInfo _character00001045 =
    {
        0x00001045,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00001045,
        0x00001045,
        0x00001045
    };

    static _CharacterInfo _character00001046 =
    {
        0x00001046,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00001046,
        0x00001046,
        0x00001046
    };

    static _CharacterInfo _character00001047 =
    {
        0x00001047,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00001047,
        0x00001047,
        0x00001047
    };

    static _CharacterInfo _character00001048 =
    {
        0x00001048,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00001048,
        0x00001048,
        0x00001048
    };

    static _CharacterInfo _character00001049 =
    {
        0x00001049,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00001049,
        0x00001049,
        0x00001049
    };

    static _CharacterInfo _character0000104A =
    {
        0x0000104A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104A,
        0x0000104A,
        0x0000104A
    };

    static _CharacterInfo _character0000104B =
    {
        0x0000104B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104B,
        0x0000104B,
        0x0000104B
    };

    static _CharacterInfo _character0000104C =
    {
        0x0000104C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104C,
        0x0000104C,
        0x0000104C
    };

    static _CharacterInfo _character0000104D =
    {
        0x0000104D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104D,
        0x0000104D,
        0x0000104D
    };

    static _CharacterInfo _character0000104E =
    {
        0x0000104E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104E,
        0x0000104E,
        0x0000104E
    };

    static _CharacterInfo _character0000104F =
    {
        0x0000104F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000104F,
        0x0000104F,
        0x0000104F
    };

    static _CharacterInfo _character00001050 =
    {
        0x00001050,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001050,
        0x00001050,
        0x00001050
    };

    static _CharacterInfo _character00001051 =
    {
        0x00001051,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001051,
        0x00001051,
        0x00001051
    };

    static _CharacterInfo _character00001052 =
    {
        0x00001052,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001052,
        0x00001052,
        0x00001052
    };

    static _CharacterInfo _character00001053 =
    {
        0x00001053,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001053,
        0x00001053,
        0x00001053
    };

    static _CharacterInfo _character00001054 =
    {
        0x00001054,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001054,
        0x00001054,
        0x00001054
    };

    static _CharacterInfo _character00001055 =
    {
        0x00001055,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001055,
        0x00001055,
        0x00001055
    };

    static _CharacterInfo _character00001056 =
    {
        0x00001056,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001056,
        0x00001056,
        0x00001056
    };

    static _CharacterInfo _character00001057 =
    {
        0x00001057,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001057,
        0x00001057,
        0x00001057
    };

    static _CharacterInfo _character00001058 =
    {
        0x00001058,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001058,
        0x00001058,
        0x00001058
    };

    static _CharacterInfo _character00001059 =
    {
        0x00001059,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001059,
        0x00001059,
        0x00001059
    };

    static _CharacterInfo _character000010A0 =
    {
        0x000010A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A0,
        0x00002D00,
        0x000010A0
    };

    static _CharacterInfo _character000010A1 =
    {
        0x000010A1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A1,
        0x00002D01,
        0x000010A1
    };

    static _CharacterInfo _character000010A2 =
    {
        0x000010A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A2,
        0x00002D02,
        0x000010A2
    };

    static _CharacterInfo _character000010A3 =
    {
        0x000010A3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A3,
        0x00002D03,
        0x000010A3
    };

    static _CharacterInfo _character000010A4 =
    {
        0x000010A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A4,
        0x00002D04,
        0x000010A4
    };

    static _CharacterInfo _character000010A5 =
    {
        0x000010A5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A5,
        0x00002D05,
        0x000010A5
    };

    static _CharacterInfo _character000010A6 =
    {
        0x000010A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A6,
        0x00002D06,
        0x000010A6
    };

    static _CharacterInfo _character000010A7 =
    {
        0x000010A7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A7,
        0x00002D07,
        0x000010A7
    };

    static _CharacterInfo _character000010A8 =
    {
        0x000010A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A8,
        0x00002D08,
        0x000010A8
    };

    static _CharacterInfo _character000010A9 =
    {
        0x000010A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A9,
        0x00002D09,
        0x000010A9
    };

    static _CharacterInfo _character000010AA =
    {
        0x000010AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AA,
        0x00002D0A,
        0x000010AA
    };

    static _CharacterInfo _character000010AB =
    {
        0x000010AB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AB,
        0x00002D0B,
        0x000010AB
    };

    static _CharacterInfo _character000010AC =
    {
        0x000010AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AC,
        0x00002D0C,
        0x000010AC
    };

    static _CharacterInfo _character000010AD =
    {
        0x000010AD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AD,
        0x00002D0D,
        0x000010AD
    };

    static _CharacterInfo _character000010AE =
    {
        0x000010AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AE,
        0x00002D0E,
        0x000010AE
    };

    static _CharacterInfo _character000010AF =
    {
        0x000010AF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AF,
        0x00002D0F,
        0x000010AF
    };

    static _CharacterInfo _character000010B0 =
    {
        0x000010B0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B0,
        0x00002D10,
        0x000010B0
    };

    static _CharacterInfo _character000010B1 =
    {
        0x000010B1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B1,
        0x00002D11,
        0x000010B1
    };

    static _CharacterInfo _character000010B2 =
    {
        0x000010B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B2,
        0x00002D12,
        0x000010B2
    };

    static _CharacterInfo _character000010B3 =
    {
        0x000010B3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B3,
        0x00002D13,
        0x000010B3
    };

    static _CharacterInfo _character000010B4 =
    {
        0x000010B4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B4,
        0x00002D14,
        0x000010B4
    };

    static _CharacterInfo _character000010B5 =
    {
        0x000010B5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B5,
        0x00002D15,
        0x000010B5
    };

    static _CharacterInfo _character000010B6 =
    {
        0x000010B6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B6,
        0x00002D16,
        0x000010B6
    };

    static _CharacterInfo _character000010B7 =
    {
        0x000010B7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B7,
        0x00002D17,
        0x000010B7
    };

    static _CharacterInfo _character000010B8 =
    {
        0x000010B8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B8,
        0x00002D18,
        0x000010B8
    };

    static _CharacterInfo _character000010B9 =
    {
        0x000010B9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B9,
        0x00002D19,
        0x000010B9
    };

    static _CharacterInfo _character000010BA =
    {
        0x000010BA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BA,
        0x00002D1A,
        0x000010BA
    };

    static _CharacterInfo _character000010BB =
    {
        0x000010BB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BB,
        0x00002D1B,
        0x000010BB
    };

    static _CharacterInfo _character000010BC =
    {
        0x000010BC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BC,
        0x00002D1C,
        0x000010BC
    };

    static _CharacterInfo _character000010BD =
    {
        0x000010BD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BD,
        0x00002D1D,
        0x000010BD
    };

    static _CharacterInfo _character000010BE =
    {
        0x000010BE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BE,
        0x00002D1E,
        0x000010BE
    };

    static _CharacterInfo _character000010BF =
    {
        0x000010BF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BF,
        0x00002D1F,
        0x000010BF
    };

    static _CharacterInfo _character000010C0 =
    {
        0x000010C0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C0,
        0x00002D20,
        0x000010C0
    };

    static _CharacterInfo _character000010C1 =
    {
        0x000010C1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C1,
        0x00002D21,
        0x000010C1
    };

    static _CharacterInfo _character000010C2 =
    {
        0x000010C2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C2,
        0x00002D22,
        0x000010C2
    };

    static _CharacterInfo _character000010C3 =
    {
        0x000010C3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C3,
        0x00002D23,
        0x000010C3
    };

    static _CharacterInfo _character000010C4 =
    {
        0x000010C4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C4,
        0x00002D24,
        0x000010C4
    };

    static _CharacterInfo _character000010C5 =
    {
        0x000010C5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C5,
        0x00002D25,
        0x000010C5
    };

    static _CharacterInfo _character000010D0 =
    {
        0x000010D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D0,
        0x000010D0,
        0x000010D0
    };

    static _CharacterInfo _character000010D1 =
    {
        0x000010D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D1,
        0x000010D1,
        0x000010D1
    };

    static _CharacterInfo _character000010D2 =
    {
        0x000010D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D2,
        0x000010D2,
        0x000010D2
    };

    static _CharacterInfo _character000010D3 =
    {
        0x000010D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D3,
        0x000010D3,
        0x000010D3
    };

    static _CharacterInfo _character000010D4 =
    {
        0x000010D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D4,
        0x000010D4,
        0x000010D4
    };

    static _CharacterInfo _character000010D5 =
    {
        0x000010D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D5,
        0x000010D5,
        0x000010D5
    };

    static _CharacterInfo _character000010D6 =
    {
        0x000010D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D6,
        0x000010D6,
        0x000010D6
    };

    static _CharacterInfo _character000010D7 =
    {
        0x000010D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D7,
        0x000010D7,
        0x000010D7
    };

    static _CharacterInfo _character000010D8 =
    {
        0x000010D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D8,
        0x000010D8,
        0x000010D8
    };

    static _CharacterInfo _character000010D9 =
    {
        0x000010D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010D9,
        0x000010D9,
        0x000010D9
    };

    static _CharacterInfo _character000010DA =
    {
        0x000010DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DA,
        0x000010DA,
        0x000010DA
    };

    static _CharacterInfo _character000010DB =
    {
        0x000010DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DB,
        0x000010DB,
        0x000010DB
    };

    static _CharacterInfo _character000010DC =
    {
        0x000010DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DC,
        0x000010DC,
        0x000010DC
    };

    static _CharacterInfo _character000010DD =
    {
        0x000010DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DD,
        0x000010DD,
        0x000010DD
    };

    static _CharacterInfo _character000010DE =
    {
        0x000010DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DE,
        0x000010DE,
        0x000010DE
    };

    static _CharacterInfo _character000010DF =
    {
        0x000010DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010DF,
        0x000010DF,
        0x000010DF
    };

    static _CharacterInfo _character000010E0 =
    {
        0x000010E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E0,
        0x000010E0,
        0x000010E0
    };

    static _CharacterInfo _character000010E1 =
    {
        0x000010E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E1,
        0x000010E1,
        0x000010E1
    };

    static _CharacterInfo _character000010E2 =
    {
        0x000010E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E2,
        0x000010E2,
        0x000010E2
    };

    static _CharacterInfo _character000010E3 =
    {
        0x000010E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E3,
        0x000010E3,
        0x000010E3
    };

    static _CharacterInfo _character000010E4 =
    {
        0x000010E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E4,
        0x000010E4,
        0x000010E4
    };

    static _CharacterInfo _character000010E5 =
    {
        0x000010E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E5,
        0x000010E5,
        0x000010E5
    };

    static _CharacterInfo _character000010E6 =
    {
        0x000010E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E6,
        0x000010E6,
        0x000010E6
    };

    static _CharacterInfo _character000010E7 =
    {
        0x000010E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E7,
        0x000010E7,
        0x000010E7
    };

    static _CharacterInfo _character000010E8 =
    {
        0x000010E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E8,
        0x000010E8,
        0x000010E8
    };

    static _CharacterInfo _character000010E9 =
    {
        0x000010E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010E9,
        0x000010E9,
        0x000010E9
    };

    static _CharacterInfo _character000010EA =
    {
        0x000010EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010EA,
        0x000010EA,
        0x000010EA
    };

    static _CharacterInfo _character000010EB =
    {
        0x000010EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010EB,
        0x000010EB,
        0x000010EB
    };

    static _CharacterInfo _character000010EC =
    {
        0x000010EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010EC,
        0x000010EC,
        0x000010EC
    };

    static _CharacterInfo _character000010ED =
    {
        0x000010ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010ED,
        0x000010ED,
        0x000010ED
    };

    static _CharacterInfo _character000010EE =
    {
        0x000010EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010EE,
        0x000010EE,
        0x000010EE
    };

    static _CharacterInfo _character000010EF =
    {
        0x000010EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010EF,
        0x000010EF,
        0x000010EF
    };

    static _CharacterInfo _character000010F0 =
    {
        0x000010F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F0,
        0x000010F0,
        0x000010F0
    };

    static _CharacterInfo _character000010F1 =
    {
        0x000010F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F1,
        0x000010F1,
        0x000010F1
    };

    static _CharacterInfo _character000010F2 =
    {
        0x000010F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F2,
        0x000010F2,
        0x000010F2
    };

    static _CharacterInfo _character000010F3 =
    {
        0x000010F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F3,
        0x000010F3,
        0x000010F3
    };

    static _CharacterInfo _character000010F4 =
    {
        0x000010F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F4,
        0x000010F4,
        0x000010F4
    };

    static _CharacterInfo _character000010F5 =
    {
        0x000010F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F5,
        0x000010F5,
        0x000010F5
    };

    static _CharacterInfo _character000010F6 =
    {
        0x000010F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F6,
        0x000010F6,
        0x000010F6
    };

    static _CharacterInfo _character000010F7 =
    {
        0x000010F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F7,
        0x000010F7,
        0x000010F7
    };

    static _CharacterInfo _character000010F8 =
    {
        0x000010F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F8,
        0x000010F8,
        0x000010F8
    };

    static _CharacterInfo _character000010F9 =
    {
        0x000010F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010F9,
        0x000010F9,
        0x000010F9
    };

    static _CharacterInfo _character000010FA =
    {
        0x000010FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010FA,
        0x000010FA,
        0x000010FA
    };

    static _CharacterInfo _character000010FB =
    {
        0x000010FB,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010FB,
        0x000010FB,
        0x000010FB
    };

    static Char _decompositionMapping000010FC[] = 
    {
        0x000010DC
    };

    static _CharacterInfo _character000010FC =
    {
        0x000010FC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping000010FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010FC,
        0x000010FC,
        0x000010FC
    };

    static _CharacterInfo _character00001100 =
    {
        0x00001100,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001100,
        0x00001100,
        0x00001100
    };

    static _CharacterInfo _character00001101 =
    {
        0x00001101,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001101,
        0x00001101,
        0x00001101
    };

    static _CharacterInfo _character00001102 =
    {
        0x00001102,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001102,
        0x00001102,
        0x00001102
    };

    static _CharacterInfo _character00001103 =
    {
        0x00001103,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001103,
        0x00001103,
        0x00001103
    };

    static _CharacterInfo _character00001104 =
    {
        0x00001104,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001104,
        0x00001104,
        0x00001104
    };

    static _CharacterInfo _character00001105 =
    {
        0x00001105,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001105,
        0x00001105,
        0x00001105
    };

    static _CharacterInfo _character00001106 =
    {
        0x00001106,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001106,
        0x00001106,
        0x00001106
    };

    static _CharacterInfo _character00001107 =
    {
        0x00001107,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001107,
        0x00001107,
        0x00001107
    };

    static _CharacterInfo _character00001108 =
    {
        0x00001108,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001108,
        0x00001108,
        0x00001108
    };

    static _CharacterInfo _character00001109 =
    {
        0x00001109,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001109,
        0x00001109,
        0x00001109
    };

    static _CharacterInfo _character0000110A =
    {
        0x0000110A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110A,
        0x0000110A,
        0x0000110A
    };

    static _CharacterInfo _character0000110B =
    {
        0x0000110B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110B,
        0x0000110B,
        0x0000110B
    };

    static _CharacterInfo _character0000110C =
    {
        0x0000110C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110C,
        0x0000110C,
        0x0000110C
    };

    static _CharacterInfo _character0000110D =
    {
        0x0000110D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110D,
        0x0000110D,
        0x0000110D
    };

    static _CharacterInfo _character0000110E =
    {
        0x0000110E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110E,
        0x0000110E,
        0x0000110E
    };

    static _CharacterInfo _character0000110F =
    {
        0x0000110F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000110F,
        0x0000110F,
        0x0000110F
    };

    static _CharacterInfo _character00001110 =
    {
        0x00001110,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001110,
        0x00001110,
        0x00001110
    };

    static _CharacterInfo _character00001111 =
    {
        0x00001111,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001111,
        0x00001111,
        0x00001111
    };

    static _CharacterInfo _character00001112 =
    {
        0x00001112,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001112,
        0x00001112,
        0x00001112
    };

    static _CharacterInfo _character00001113 =
    {
        0x00001113,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001113,
        0x00001113,
        0x00001113
    };

    static _CharacterInfo _character00001114 =
    {
        0x00001114,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001114,
        0x00001114,
        0x00001114
    };

    static _CharacterInfo _character00001115 =
    {
        0x00001115,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001115,
        0x00001115,
        0x00001115
    };

    static _CharacterInfo _character00001116 =
    {
        0x00001116,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001116,
        0x00001116,
        0x00001116
    };

    static _CharacterInfo _character00001117 =
    {
        0x00001117,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001117,
        0x00001117,
        0x00001117
    };

    static _CharacterInfo _character00001118 =
    {
        0x00001118,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001118,
        0x00001118,
        0x00001118
    };

    static _CharacterInfo _character00001119 =
    {
        0x00001119,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001119,
        0x00001119,
        0x00001119
    };

    static _CharacterInfo _character0000111A =
    {
        0x0000111A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111A,
        0x0000111A,
        0x0000111A
    };

    static _CharacterInfo _character0000111B =
    {
        0x0000111B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111B,
        0x0000111B,
        0x0000111B
    };

    static _CharacterInfo _character0000111C =
    {
        0x0000111C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111C,
        0x0000111C,
        0x0000111C
    };

    static _CharacterInfo _character0000111D =
    {
        0x0000111D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111D,
        0x0000111D,
        0x0000111D
    };

    static _CharacterInfo _character0000111E =
    {
        0x0000111E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111E,
        0x0000111E,
        0x0000111E
    };

    static _CharacterInfo _character0000111F =
    {
        0x0000111F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000111F,
        0x0000111F,
        0x0000111F
    };

    static _CharacterInfo _character00001120 =
    {
        0x00001120,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001120,
        0x00001120,
        0x00001120
    };

    static _CharacterInfo _character00001121 =
    {
        0x00001121,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001121,
        0x00001121,
        0x00001121
    };

    static _CharacterInfo _character00001122 =
    {
        0x00001122,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001122,
        0x00001122,
        0x00001122
    };

    static _CharacterInfo _character00001123 =
    {
        0x00001123,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001123,
        0x00001123,
        0x00001123
    };

    static _CharacterInfo _character00001124 =
    {
        0x00001124,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001124,
        0x00001124,
        0x00001124
    };

    static _CharacterInfo _character00001125 =
    {
        0x00001125,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001125,
        0x00001125,
        0x00001125
    };

    static _CharacterInfo _character00001126 =
    {
        0x00001126,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001126,
        0x00001126,
        0x00001126
    };

    static _CharacterInfo _character00001127 =
    {
        0x00001127,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001127,
        0x00001127,
        0x00001127
    };

    static _CharacterInfo _character00001128 =
    {
        0x00001128,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001128,
        0x00001128,
        0x00001128
    };

    static _CharacterInfo _character00001129 =
    {
        0x00001129,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001129,
        0x00001129,
        0x00001129
    };

    static _CharacterInfo _character0000112A =
    {
        0x0000112A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112A,
        0x0000112A,
        0x0000112A
    };

    static _CharacterInfo _character0000112B =
    {
        0x0000112B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112B,
        0x0000112B,
        0x0000112B
    };

    static _CharacterInfo _character0000112C =
    {
        0x0000112C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112C,
        0x0000112C,
        0x0000112C
    };

    static _CharacterInfo _character0000112D =
    {
        0x0000112D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112D,
        0x0000112D,
        0x0000112D
    };

    static _CharacterInfo _character0000112E =
    {
        0x0000112E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112E,
        0x0000112E,
        0x0000112E
    };

    static _CharacterInfo _character0000112F =
    {
        0x0000112F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000112F,
        0x0000112F,
        0x0000112F
    };

    static _CharacterInfo _character00001130 =
    {
        0x00001130,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001130,
        0x00001130,
        0x00001130
    };

    static _CharacterInfo _character00001131 =
    {
        0x00001131,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001131,
        0x00001131,
        0x00001131
    };

    static _CharacterInfo _character00001132 =
    {
        0x00001132,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001132,
        0x00001132,
        0x00001132
    };

    static _CharacterInfo _character00001133 =
    {
        0x00001133,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001133,
        0x00001133,
        0x00001133
    };

    static _CharacterInfo _character00001134 =
    {
        0x00001134,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001134,
        0x00001134,
        0x00001134
    };

    static _CharacterInfo _character00001135 =
    {
        0x00001135,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001135,
        0x00001135,
        0x00001135
    };

    static _CharacterInfo _character00001136 =
    {
        0x00001136,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001136,
        0x00001136,
        0x00001136
    };

    static _CharacterInfo _character00001137 =
    {
        0x00001137,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001137,
        0x00001137,
        0x00001137
    };

    static _CharacterInfo _character00001138 =
    {
        0x00001138,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001138,
        0x00001138,
        0x00001138
    };

    static _CharacterInfo _character00001139 =
    {
        0x00001139,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001139,
        0x00001139,
        0x00001139
    };

    static _CharacterInfo _character0000113A =
    {
        0x0000113A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113A,
        0x0000113A,
        0x0000113A
    };

    static _CharacterInfo _character0000113B =
    {
        0x0000113B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113B,
        0x0000113B,
        0x0000113B
    };

    static _CharacterInfo _character0000113C =
    {
        0x0000113C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113C,
        0x0000113C,
        0x0000113C
    };

    static _CharacterInfo _character0000113D =
    {
        0x0000113D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113D,
        0x0000113D,
        0x0000113D
    };

    static _CharacterInfo _character0000113E =
    {
        0x0000113E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113E,
        0x0000113E,
        0x0000113E
    };

    static _CharacterInfo _character0000113F =
    {
        0x0000113F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000113F,
        0x0000113F,
        0x0000113F
    };

    static _CharacterInfo _character00001140 =
    {
        0x00001140,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001140,
        0x00001140,
        0x00001140
    };

    static _CharacterInfo _character00001141 =
    {
        0x00001141,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001141,
        0x00001141,
        0x00001141
    };

    static _CharacterInfo _character00001142 =
    {
        0x00001142,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001142,
        0x00001142,
        0x00001142
    };

    static _CharacterInfo _character00001143 =
    {
        0x00001143,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001143,
        0x00001143,
        0x00001143
    };

    static _CharacterInfo _character00001144 =
    {
        0x00001144,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001144,
        0x00001144,
        0x00001144
    };

    static _CharacterInfo _character00001145 =
    {
        0x00001145,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001145,
        0x00001145,
        0x00001145
    };

    static _CharacterInfo _character00001146 =
    {
        0x00001146,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001146,
        0x00001146,
        0x00001146
    };

    static _CharacterInfo _character00001147 =
    {
        0x00001147,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001147,
        0x00001147,
        0x00001147
    };

    static _CharacterInfo _character00001148 =
    {
        0x00001148,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001148,
        0x00001148,
        0x00001148
    };

    static _CharacterInfo _character00001149 =
    {
        0x00001149,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001149,
        0x00001149,
        0x00001149
    };

    static _CharacterInfo _character0000114A =
    {
        0x0000114A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114A,
        0x0000114A,
        0x0000114A
    };

    static _CharacterInfo _character0000114B =
    {
        0x0000114B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114B,
        0x0000114B,
        0x0000114B
    };

    static _CharacterInfo _character0000114C =
    {
        0x0000114C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114C,
        0x0000114C,
        0x0000114C
    };

    static _CharacterInfo _character0000114D =
    {
        0x0000114D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114D,
        0x0000114D,
        0x0000114D
    };

    static _CharacterInfo _character0000114E =
    {
        0x0000114E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114E,
        0x0000114E,
        0x0000114E
    };

    static _CharacterInfo _character0000114F =
    {
        0x0000114F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000114F,
        0x0000114F,
        0x0000114F
    };

    static _CharacterInfo _character00001150 =
    {
        0x00001150,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001150,
        0x00001150,
        0x00001150
    };

    static _CharacterInfo _character00001151 =
    {
        0x00001151,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001151,
        0x00001151,
        0x00001151
    };

    static _CharacterInfo _character00001152 =
    {
        0x00001152,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001152,
        0x00001152,
        0x00001152
    };

    static _CharacterInfo _character00001153 =
    {
        0x00001153,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001153,
        0x00001153,
        0x00001153
    };

    static _CharacterInfo _character00001154 =
    {
        0x00001154,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001154,
        0x00001154,
        0x00001154
    };

    static _CharacterInfo _character00001155 =
    {
        0x00001155,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001155,
        0x00001155,
        0x00001155
    };

    static _CharacterInfo _character00001156 =
    {
        0x00001156,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001156,
        0x00001156,
        0x00001156
    };

    static _CharacterInfo _character00001157 =
    {
        0x00001157,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001157,
        0x00001157,
        0x00001157
    };

    static _CharacterInfo _character00001158 =
    {
        0x00001158,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001158,
        0x00001158,
        0x00001158
    };

    static _CharacterInfo _character00001159 =
    {
        0x00001159,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001159,
        0x00001159,
        0x00001159
    };

    static _CharacterInfo _character0000115F =
    {
        0x0000115F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000115F,
        0x0000115F,
        0x0000115F
    };

    static _CharacterInfo _character00001160 =
    {
        0x00001160,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001160,
        0x00001160,
        0x00001160
    };

    static _CharacterInfo _character00001161 =
    {
        0x00001161,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001161,
        0x00001161,
        0x00001161
    };

    static _CharacterInfo _character00001162 =
    {
        0x00001162,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001162,
        0x00001162,
        0x00001162
    };

    static _CharacterInfo _character00001163 =
    {
        0x00001163,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001163,
        0x00001163,
        0x00001163
    };

    static _CharacterInfo _character00001164 =
    {
        0x00001164,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001164,
        0x00001164,
        0x00001164
    };

    static _CharacterInfo _character00001165 =
    {
        0x00001165,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001165,
        0x00001165,
        0x00001165
    };

    static _CharacterInfo _character00001166 =
    {
        0x00001166,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001166,
        0x00001166,
        0x00001166
    };

    static _CharacterInfo _character00001167 =
    {
        0x00001167,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001167,
        0x00001167,
        0x00001167
    };

    static _CharacterInfo _character00001168 =
    {
        0x00001168,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001168,
        0x00001168,
        0x00001168
    };

    static _CharacterInfo _character00001169 =
    {
        0x00001169,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001169,
        0x00001169,
        0x00001169
    };

    static _CharacterInfo _character0000116A =
    {
        0x0000116A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116A,
        0x0000116A,
        0x0000116A
    };

    static _CharacterInfo _character0000116B =
    {
        0x0000116B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116B,
        0x0000116B,
        0x0000116B
    };

    static _CharacterInfo _character0000116C =
    {
        0x0000116C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116C,
        0x0000116C,
        0x0000116C
    };

    static _CharacterInfo _character0000116D =
    {
        0x0000116D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116D,
        0x0000116D,
        0x0000116D
    };

    static _CharacterInfo _character0000116E =
    {
        0x0000116E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116E,
        0x0000116E,
        0x0000116E
    };

    static _CharacterInfo _character0000116F =
    {
        0x0000116F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000116F,
        0x0000116F,
        0x0000116F
    };

    static _CharacterInfo _character00001170 =
    {
        0x00001170,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001170,
        0x00001170,
        0x00001170
    };

    static _CharacterInfo _character00001171 =
    {
        0x00001171,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001171,
        0x00001171,
        0x00001171
    };

    static _CharacterInfo _character00001172 =
    {
        0x00001172,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001172,
        0x00001172,
        0x00001172
    };

    static _CharacterInfo _character00001173 =
    {
        0x00001173,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001173,
        0x00001173,
        0x00001173
    };

    static _CharacterInfo _character00001174 =
    {
        0x00001174,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001174,
        0x00001174,
        0x00001174
    };

    static _CharacterInfo _character00001175 =
    {
        0x00001175,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001175,
        0x00001175,
        0x00001175
    };

    static _CharacterInfo _character00001176 =
    {
        0x00001176,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001176,
        0x00001176,
        0x00001176
    };

    static _CharacterInfo _character00001177 =
    {
        0x00001177,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001177,
        0x00001177,
        0x00001177
    };

    static _CharacterInfo _character00001178 =
    {
        0x00001178,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001178,
        0x00001178,
        0x00001178
    };

    static _CharacterInfo _character00001179 =
    {
        0x00001179,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001179,
        0x00001179,
        0x00001179
    };

    static _CharacterInfo _character0000117A =
    {
        0x0000117A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117A,
        0x0000117A,
        0x0000117A
    };

    static _CharacterInfo _character0000117B =
    {
        0x0000117B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117B,
        0x0000117B,
        0x0000117B
    };

    static _CharacterInfo _character0000117C =
    {
        0x0000117C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117C,
        0x0000117C,
        0x0000117C
    };

    static _CharacterInfo _character0000117D =
    {
        0x0000117D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117D,
        0x0000117D,
        0x0000117D
    };

    static _CharacterInfo _character0000117E =
    {
        0x0000117E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117E,
        0x0000117E,
        0x0000117E
    };

    static _CharacterInfo _character0000117F =
    {
        0x0000117F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000117F,
        0x0000117F,
        0x0000117F
    };

    static _CharacterInfo _character00001180 =
    {
        0x00001180,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001180,
        0x00001180,
        0x00001180
    };

    static _CharacterInfo _character00001181 =
    {
        0x00001181,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001181,
        0x00001181,
        0x00001181
    };

    static _CharacterInfo _character00001182 =
    {
        0x00001182,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001182,
        0x00001182,
        0x00001182
    };

    static _CharacterInfo _character00001183 =
    {
        0x00001183,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001183,
        0x00001183,
        0x00001183
    };

    static _CharacterInfo _character00001184 =
    {
        0x00001184,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001184,
        0x00001184,
        0x00001184
    };

    static _CharacterInfo _character00001185 =
    {
        0x00001185,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001185,
        0x00001185,
        0x00001185
    };

    static _CharacterInfo _character00001186 =
    {
        0x00001186,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001186,
        0x00001186,
        0x00001186
    };

    static _CharacterInfo _character00001187 =
    {
        0x00001187,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001187,
        0x00001187,
        0x00001187
    };

    static _CharacterInfo _character00001188 =
    {
        0x00001188,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001188,
        0x00001188,
        0x00001188
    };

    static _CharacterInfo _character00001189 =
    {
        0x00001189,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001189,
        0x00001189,
        0x00001189
    };

    static _CharacterInfo _character0000118A =
    {
        0x0000118A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118A,
        0x0000118A,
        0x0000118A
    };

    static _CharacterInfo _character0000118B =
    {
        0x0000118B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118B,
        0x0000118B,
        0x0000118B
    };

    static _CharacterInfo _character0000118C =
    {
        0x0000118C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118C,
        0x0000118C,
        0x0000118C
    };

    static _CharacterInfo _character0000118D =
    {
        0x0000118D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118D,
        0x0000118D,
        0x0000118D
    };

    static _CharacterInfo _character0000118E =
    {
        0x0000118E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118E,
        0x0000118E,
        0x0000118E
    };

    static _CharacterInfo _character0000118F =
    {
        0x0000118F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000118F,
        0x0000118F,
        0x0000118F
    };

    static _CharacterInfo _character00001190 =
    {
        0x00001190,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001190,
        0x00001190,
        0x00001190
    };

    static _CharacterInfo _character00001191 =
    {
        0x00001191,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001191,
        0x00001191,
        0x00001191
    };

    static _CharacterInfo _character00001192 =
    {
        0x00001192,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001192,
        0x00001192,
        0x00001192
    };

    static _CharacterInfo _character00001193 =
    {
        0x00001193,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001193,
        0x00001193,
        0x00001193
    };

    static _CharacterInfo _character00001194 =
    {
        0x00001194,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001194,
        0x00001194,
        0x00001194
    };

    static _CharacterInfo _character00001195 =
    {
        0x00001195,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001195,
        0x00001195,
        0x00001195
    };

    static _CharacterInfo _character00001196 =
    {
        0x00001196,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001196,
        0x00001196,
        0x00001196
    };

    static _CharacterInfo _character00001197 =
    {
        0x00001197,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001197,
        0x00001197,
        0x00001197
    };

    static _CharacterInfo _character00001198 =
    {
        0x00001198,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001198,
        0x00001198,
        0x00001198
    };

    static _CharacterInfo _character00001199 =
    {
        0x00001199,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001199,
        0x00001199,
        0x00001199
    };

    static _CharacterInfo _character0000119A =
    {
        0x0000119A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119A,
        0x0000119A,
        0x0000119A
    };

    static _CharacterInfo _character0000119B =
    {
        0x0000119B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119B,
        0x0000119B,
        0x0000119B
    };

    static _CharacterInfo _character0000119C =
    {
        0x0000119C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119C,
        0x0000119C,
        0x0000119C
    };

    static _CharacterInfo _character0000119D =
    {
        0x0000119D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119D,
        0x0000119D,
        0x0000119D
    };

    static _CharacterInfo _character0000119E =
    {
        0x0000119E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119E,
        0x0000119E,
        0x0000119E
    };

    static _CharacterInfo _character0000119F =
    {
        0x0000119F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000119F,
        0x0000119F,
        0x0000119F
    };

    static _CharacterInfo _character000011A0 =
    {
        0x000011A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011A0,
        0x000011A0,
        0x000011A0
    };

    static _CharacterInfo _character000011A1 =
    {
        0x000011A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011A1,
        0x000011A1,
        0x000011A1
    };

    static _CharacterInfo _character000011A2 =
    {
        0x000011A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011A2,
        0x000011A2,
        0x000011A2
    };

    static _CharacterInfo _character000011A8 =
    {
        0x000011A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011A8,
        0x000011A8,
        0x000011A8
    };

    static _CharacterInfo _character000011A9 =
    {
        0x000011A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011A9,
        0x000011A9,
        0x000011A9
    };

    static _CharacterInfo _character000011AA =
    {
        0x000011AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AA,
        0x000011AA,
        0x000011AA
    };

    static _CharacterInfo _character000011AB =
    {
        0x000011AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AB,
        0x000011AB,
        0x000011AB
    };

    static _CharacterInfo _character000011AC =
    {
        0x000011AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AC,
        0x000011AC,
        0x000011AC
    };

    static _CharacterInfo _character000011AD =
    {
        0x000011AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AD,
        0x000011AD,
        0x000011AD
    };

    static _CharacterInfo _character000011AE =
    {
        0x000011AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AE,
        0x000011AE,
        0x000011AE
    };

    static _CharacterInfo _character000011AF =
    {
        0x000011AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011AF,
        0x000011AF,
        0x000011AF
    };

    static _CharacterInfo _character000011B0 =
    {
        0x000011B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B0,
        0x000011B0,
        0x000011B0
    };

    static _CharacterInfo _character000011B1 =
    {
        0x000011B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B1,
        0x000011B1,
        0x000011B1
    };

    static _CharacterInfo _character000011B2 =
    {
        0x000011B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B2,
        0x000011B2,
        0x000011B2
    };

    static _CharacterInfo _character000011B3 =
    {
        0x000011B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B3,
        0x000011B3,
        0x000011B3
    };

    static _CharacterInfo _character000011B4 =
    {
        0x000011B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B4,
        0x000011B4,
        0x000011B4
    };

    static _CharacterInfo _character000011B5 =
    {
        0x000011B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B5,
        0x000011B5,
        0x000011B5
    };

    static _CharacterInfo _character000011B6 =
    {
        0x000011B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B6,
        0x000011B6,
        0x000011B6
    };

    static _CharacterInfo _character000011B7 =
    {
        0x000011B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B7,
        0x000011B7,
        0x000011B7
    };

    static _CharacterInfo _character000011B8 =
    {
        0x000011B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B8,
        0x000011B8,
        0x000011B8
    };

    static _CharacterInfo _character000011B9 =
    {
        0x000011B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011B9,
        0x000011B9,
        0x000011B9
    };

    static _CharacterInfo _character000011BA =
    {
        0x000011BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BA,
        0x000011BA,
        0x000011BA
    };

    static _CharacterInfo _character000011BB =
    {
        0x000011BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BB,
        0x000011BB,
        0x000011BB
    };

    static _CharacterInfo _character000011BC =
    {
        0x000011BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BC,
        0x000011BC,
        0x000011BC
    };

    static _CharacterInfo _character000011BD =
    {
        0x000011BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BD,
        0x000011BD,
        0x000011BD
    };

    static _CharacterInfo _character000011BE =
    {
        0x000011BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BE,
        0x000011BE,
        0x000011BE
    };

    static _CharacterInfo _character000011BF =
    {
        0x000011BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011BF,
        0x000011BF,
        0x000011BF
    };

    static _CharacterInfo _character000011C0 =
    {
        0x000011C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C0,
        0x000011C0,
        0x000011C0
    };

    static _CharacterInfo _character000011C1 =
    {
        0x000011C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C1,
        0x000011C1,
        0x000011C1
    };

    static _CharacterInfo _character000011C2 =
    {
        0x000011C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C2,
        0x000011C2,
        0x000011C2
    };

    static _CharacterInfo _character000011C3 =
    {
        0x000011C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C3,
        0x000011C3,
        0x000011C3
    };

    static _CharacterInfo _character000011C4 =
    {
        0x000011C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C4,
        0x000011C4,
        0x000011C4
    };

    static _CharacterInfo _character000011C5 =
    {
        0x000011C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C5,
        0x000011C5,
        0x000011C5
    };

    static _CharacterInfo _character000011C6 =
    {
        0x000011C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C6,
        0x000011C6,
        0x000011C6
    };

    static _CharacterInfo _character000011C7 =
    {
        0x000011C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C7,
        0x000011C7,
        0x000011C7
    };

    static _CharacterInfo _character000011C8 =
    {
        0x000011C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C8,
        0x000011C8,
        0x000011C8
    };

    static _CharacterInfo _character000011C9 =
    {
        0x000011C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011C9,
        0x000011C9,
        0x000011C9
    };

    static _CharacterInfo _character000011CA =
    {
        0x000011CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CA,
        0x000011CA,
        0x000011CA
    };

    static _CharacterInfo _character000011CB =
    {
        0x000011CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CB,
        0x000011CB,
        0x000011CB
    };

    static _CharacterInfo _character000011CC =
    {
        0x000011CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CC,
        0x000011CC,
        0x000011CC
    };

    static _CharacterInfo _character000011CD =
    {
        0x000011CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CD,
        0x000011CD,
        0x000011CD
    };

    static _CharacterInfo _character000011CE =
    {
        0x000011CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CE,
        0x000011CE,
        0x000011CE
    };

    static _CharacterInfo _character000011CF =
    {
        0x000011CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011CF,
        0x000011CF,
        0x000011CF
    };

    static _CharacterInfo _character000011D0 =
    {
        0x000011D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D0,
        0x000011D0,
        0x000011D0
    };

    static _CharacterInfo _character000011D1 =
    {
        0x000011D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D1,
        0x000011D1,
        0x000011D1
    };

    static _CharacterInfo _character000011D2 =
    {
        0x000011D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D2,
        0x000011D2,
        0x000011D2
    };

    static _CharacterInfo _character000011D3 =
    {
        0x000011D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D3,
        0x000011D3,
        0x000011D3
    };

    static _CharacterInfo _character000011D4 =
    {
        0x000011D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D4,
        0x000011D4,
        0x000011D4
    };

    static _CharacterInfo _character000011D5 =
    {
        0x000011D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D5,
        0x000011D5,
        0x000011D5
    };

    static _CharacterInfo _character000011D6 =
    {
        0x000011D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D6,
        0x000011D6,
        0x000011D6
    };

    static _CharacterInfo _character000011D7 =
    {
        0x000011D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D7,
        0x000011D7,
        0x000011D7
    };

    static _CharacterInfo _character000011D8 =
    {
        0x000011D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D8,
        0x000011D8,
        0x000011D8
    };

    static _CharacterInfo _character000011D9 =
    {
        0x000011D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011D9,
        0x000011D9,
        0x000011D9
    };

    static _CharacterInfo _character000011DA =
    {
        0x000011DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DA,
        0x000011DA,
        0x000011DA
    };

    static _CharacterInfo _character000011DB =
    {
        0x000011DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DB,
        0x000011DB,
        0x000011DB
    };

    static _CharacterInfo _character000011DC =
    {
        0x000011DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DC,
        0x000011DC,
        0x000011DC
    };

    static _CharacterInfo _character000011DD =
    {
        0x000011DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DD,
        0x000011DD,
        0x000011DD
    };

    static _CharacterInfo _character000011DE =
    {
        0x000011DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DE,
        0x000011DE,
        0x000011DE
    };

    static _CharacterInfo _character000011DF =
    {
        0x000011DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011DF,
        0x000011DF,
        0x000011DF
    };

    static _CharacterInfo _character000011E0 =
    {
        0x000011E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E0,
        0x000011E0,
        0x000011E0
    };

    static _CharacterInfo _character000011E1 =
    {
        0x000011E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E1,
        0x000011E1,
        0x000011E1
    };

    static _CharacterInfo _character000011E2 =
    {
        0x000011E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E2,
        0x000011E2,
        0x000011E2
    };

    static _CharacterInfo _character000011E3 =
    {
        0x000011E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E3,
        0x000011E3,
        0x000011E3
    };

    static _CharacterInfo _character000011E4 =
    {
        0x000011E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E4,
        0x000011E4,
        0x000011E4
    };

    static _CharacterInfo _character000011E5 =
    {
        0x000011E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E5,
        0x000011E5,
        0x000011E5
    };

    static _CharacterInfo _character000011E6 =
    {
        0x000011E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E6,
        0x000011E6,
        0x000011E6
    };

    static _CharacterInfo _character000011E7 =
    {
        0x000011E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E7,
        0x000011E7,
        0x000011E7
    };

    static _CharacterInfo _character000011E8 =
    {
        0x000011E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E8,
        0x000011E8,
        0x000011E8
    };

    static _CharacterInfo _character000011E9 =
    {
        0x000011E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011E9,
        0x000011E9,
        0x000011E9
    };

    static _CharacterInfo _character000011EA =
    {
        0x000011EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011EA,
        0x000011EA,
        0x000011EA
    };

    static _CharacterInfo _character000011EB =
    {
        0x000011EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011EB,
        0x000011EB,
        0x000011EB
    };

    static _CharacterInfo _character000011EC =
    {
        0x000011EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011EC,
        0x000011EC,
        0x000011EC
    };

    static _CharacterInfo _character000011ED =
    {
        0x000011ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011ED,
        0x000011ED,
        0x000011ED
    };

    static _CharacterInfo _character000011EE =
    {
        0x000011EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011EE,
        0x000011EE,
        0x000011EE
    };

    static _CharacterInfo _character000011EF =
    {
        0x000011EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011EF,
        0x000011EF,
        0x000011EF
    };

    static _CharacterInfo _character000011F0 =
    {
        0x000011F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F0,
        0x000011F0,
        0x000011F0
    };

    static _CharacterInfo _character000011F1 =
    {
        0x000011F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F1,
        0x000011F1,
        0x000011F1
    };

    static _CharacterInfo _character000011F2 =
    {
        0x000011F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F2,
        0x000011F2,
        0x000011F2
    };

    static _CharacterInfo _character000011F3 =
    {
        0x000011F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F3,
        0x000011F3,
        0x000011F3
    };

    static _CharacterInfo _character000011F4 =
    {
        0x000011F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F4,
        0x000011F4,
        0x000011F4
    };

    static _CharacterInfo _character000011F5 =
    {
        0x000011F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F5,
        0x000011F5,
        0x000011F5
    };

    static _CharacterInfo _character000011F6 =
    {
        0x000011F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F6,
        0x000011F6,
        0x000011F6
    };

    static _CharacterInfo _character000011F7 =
    {
        0x000011F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F7,
        0x000011F7,
        0x000011F7
    };

    static _CharacterInfo _character000011F8 =
    {
        0x000011F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F8,
        0x000011F8,
        0x000011F8
    };

    static _CharacterInfo _character000011F9 =
    {
        0x000011F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000011F9,
        0x000011F9,
        0x000011F9
    };

    static _CharacterInfo _character00001200 =
    {
        0x00001200,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001200,
        0x00001200,
        0x00001200
    };

    static _CharacterInfo _character00001201 =
    {
        0x00001201,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001201,
        0x00001201,
        0x00001201
    };

    static _CharacterInfo _character00001202 =
    {
        0x00001202,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001202,
        0x00001202,
        0x00001202
    };

    static _CharacterInfo _character00001203 =
    {
        0x00001203,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001203,
        0x00001203,
        0x00001203
    };

    static _CharacterInfo _character00001204 =
    {
        0x00001204,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001204,
        0x00001204,
        0x00001204
    };

    static _CharacterInfo _character00001205 =
    {
        0x00001205,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001205,
        0x00001205,
        0x00001205
    };

    static _CharacterInfo _character00001206 =
    {
        0x00001206,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001206,
        0x00001206,
        0x00001206
    };

    static _CharacterInfo _character00001207 =
    {
        0x00001207,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001207,
        0x00001207,
        0x00001207
    };

    static _CharacterInfo _character00001208 =
    {
        0x00001208,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001208,
        0x00001208,
        0x00001208
    };

    static _CharacterInfo _character00001209 =
    {
        0x00001209,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001209,
        0x00001209,
        0x00001209
    };

    static _CharacterInfo _character0000120A =
    {
        0x0000120A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120A,
        0x0000120A,
        0x0000120A
    };

    static _CharacterInfo _character0000120B =
    {
        0x0000120B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120B,
        0x0000120B,
        0x0000120B
    };

    static _CharacterInfo _character0000120C =
    {
        0x0000120C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120C,
        0x0000120C,
        0x0000120C
    };

    static _CharacterInfo _character0000120D =
    {
        0x0000120D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120D,
        0x0000120D,
        0x0000120D
    };

    static _CharacterInfo _character0000120E =
    {
        0x0000120E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120E,
        0x0000120E,
        0x0000120E
    };

    static _CharacterInfo _character0000120F =
    {
        0x0000120F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000120F,
        0x0000120F,
        0x0000120F
    };

    static _CharacterInfo _character00001210 =
    {
        0x00001210,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001210,
        0x00001210,
        0x00001210
    };

    static _CharacterInfo _character00001211 =
    {
        0x00001211,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001211,
        0x00001211,
        0x00001211
    };

    static _CharacterInfo _character00001212 =
    {
        0x00001212,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001212,
        0x00001212,
        0x00001212
    };

    static _CharacterInfo _character00001213 =
    {
        0x00001213,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001213,
        0x00001213,
        0x00001213
    };

    static _CharacterInfo _character00001214 =
    {
        0x00001214,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001214,
        0x00001214,
        0x00001214
    };

    static _CharacterInfo _character00001215 =
    {
        0x00001215,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001215,
        0x00001215,
        0x00001215
    };

    static _CharacterInfo _character00001216 =
    {
        0x00001216,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001216,
        0x00001216,
        0x00001216
    };

    static _CharacterInfo _character00001217 =
    {
        0x00001217,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001217,
        0x00001217,
        0x00001217
    };

    static _CharacterInfo _character00001218 =
    {
        0x00001218,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001218,
        0x00001218,
        0x00001218
    };

    static _CharacterInfo _character00001219 =
    {
        0x00001219,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001219,
        0x00001219,
        0x00001219
    };

    static _CharacterInfo _character0000121A =
    {
        0x0000121A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121A,
        0x0000121A,
        0x0000121A
    };

    static _CharacterInfo _character0000121B =
    {
        0x0000121B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121B,
        0x0000121B,
        0x0000121B
    };

    static _CharacterInfo _character0000121C =
    {
        0x0000121C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121C,
        0x0000121C,
        0x0000121C
    };

    static _CharacterInfo _character0000121D =
    {
        0x0000121D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121D,
        0x0000121D,
        0x0000121D
    };

    static _CharacterInfo _character0000121E =
    {
        0x0000121E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121E,
        0x0000121E,
        0x0000121E
    };

    static _CharacterInfo _character0000121F =
    {
        0x0000121F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000121F,
        0x0000121F,
        0x0000121F
    };

    static _CharacterInfo _character00001220 =
    {
        0x00001220,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001220,
        0x00001220,
        0x00001220
    };

    static _CharacterInfo _character00001221 =
    {
        0x00001221,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001221,
        0x00001221,
        0x00001221
    };

    static _CharacterInfo _character00001222 =
    {
        0x00001222,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001222,
        0x00001222,
        0x00001222
    };

    static _CharacterInfo _character00001223 =
    {
        0x00001223,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001223,
        0x00001223,
        0x00001223
    };

    static _CharacterInfo _character00001224 =
    {
        0x00001224,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001224,
        0x00001224,
        0x00001224
    };

    static _CharacterInfo _character00001225 =
    {
        0x00001225,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001225,
        0x00001225,
        0x00001225
    };

    static _CharacterInfo _character00001226 =
    {
        0x00001226,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001226,
        0x00001226,
        0x00001226
    };

    static _CharacterInfo _character00001227 =
    {
        0x00001227,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001227,
        0x00001227,
        0x00001227
    };

    static _CharacterInfo _character00001228 =
    {
        0x00001228,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001228,
        0x00001228,
        0x00001228
    };

    static _CharacterInfo _character00001229 =
    {
        0x00001229,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001229,
        0x00001229,
        0x00001229
    };

    static _CharacterInfo _character0000122A =
    {
        0x0000122A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122A,
        0x0000122A,
        0x0000122A
    };

    static _CharacterInfo _character0000122B =
    {
        0x0000122B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122B,
        0x0000122B,
        0x0000122B
    };

    static _CharacterInfo _character0000122C =
    {
        0x0000122C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122C,
        0x0000122C,
        0x0000122C
    };

    static _CharacterInfo _character0000122D =
    {
        0x0000122D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122D,
        0x0000122D,
        0x0000122D
    };

    static _CharacterInfo _character0000122E =
    {
        0x0000122E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122E,
        0x0000122E,
        0x0000122E
    };

    static _CharacterInfo _character0000122F =
    {
        0x0000122F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000122F,
        0x0000122F,
        0x0000122F
    };

    static _CharacterInfo _character00001230 =
    {
        0x00001230,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001230,
        0x00001230,
        0x00001230
    };

    static _CharacterInfo _character00001231 =
    {
        0x00001231,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001231,
        0x00001231,
        0x00001231
    };

    static _CharacterInfo _character00001232 =
    {
        0x00001232,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001232,
        0x00001232,
        0x00001232
    };

    static _CharacterInfo _character00001233 =
    {
        0x00001233,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001233,
        0x00001233,
        0x00001233
    };

    static _CharacterInfo _character00001234 =
    {
        0x00001234,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001234,
        0x00001234,
        0x00001234
    };

    static _CharacterInfo _character00001235 =
    {
        0x00001235,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001235,
        0x00001235,
        0x00001235
    };

    static _CharacterInfo _character00001236 =
    {
        0x00001236,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001236,
        0x00001236,
        0x00001236
    };

    static _CharacterInfo _character00001237 =
    {
        0x00001237,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001237,
        0x00001237,
        0x00001237
    };

    static _CharacterInfo _character00001238 =
    {
        0x00001238,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001238,
        0x00001238,
        0x00001238
    };

    static _CharacterInfo _character00001239 =
    {
        0x00001239,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001239,
        0x00001239,
        0x00001239
    };

    static _CharacterInfo _character0000123A =
    {
        0x0000123A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123A,
        0x0000123A,
        0x0000123A
    };

    static _CharacterInfo _character0000123B =
    {
        0x0000123B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123B,
        0x0000123B,
        0x0000123B
    };

    static _CharacterInfo _character0000123C =
    {
        0x0000123C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123C,
        0x0000123C,
        0x0000123C
    };

    static _CharacterInfo _character0000123D =
    {
        0x0000123D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123D,
        0x0000123D,
        0x0000123D
    };

    static _CharacterInfo _character0000123E =
    {
        0x0000123E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123E,
        0x0000123E,
        0x0000123E
    };

    static _CharacterInfo _character0000123F =
    {
        0x0000123F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000123F,
        0x0000123F,
        0x0000123F
    };

    static _CharacterInfo _character00001240 =
    {
        0x00001240,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001240,
        0x00001240,
        0x00001240
    };

    static _CharacterInfo _character00001241 =
    {
        0x00001241,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001241,
        0x00001241,
        0x00001241
    };

    static _CharacterInfo _character00001242 =
    {
        0x00001242,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001242,
        0x00001242,
        0x00001242
    };

    static _CharacterInfo _character00001243 =
    {
        0x00001243,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001243,
        0x00001243,
        0x00001243
    };

    static _CharacterInfo _character00001244 =
    {
        0x00001244,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001244,
        0x00001244,
        0x00001244
    };

    static _CharacterInfo _character00001245 =
    {
        0x00001245,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001245,
        0x00001245,
        0x00001245
    };

    static _CharacterInfo _character00001246 =
    {
        0x00001246,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001246,
        0x00001246,
        0x00001246
    };

    static _CharacterInfo _character00001247 =
    {
        0x00001247,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001247,
        0x00001247,
        0x00001247
    };

    static _CharacterInfo _character00001248 =
    {
        0x00001248,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001248,
        0x00001248,
        0x00001248
    };

    static _CharacterInfo _character0000124A =
    {
        0x0000124A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000124A,
        0x0000124A,
        0x0000124A
    };

    static _CharacterInfo _character0000124B =
    {
        0x0000124B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000124B,
        0x0000124B,
        0x0000124B
    };

    static _CharacterInfo _character0000124C =
    {
        0x0000124C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000124C,
        0x0000124C,
        0x0000124C
    };

    static _CharacterInfo _character0000124D =
    {
        0x0000124D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000124D,
        0x0000124D,
        0x0000124D
    };

    static _CharacterInfo _character00001250 =
    {
        0x00001250,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001250,
        0x00001250,
        0x00001250
    };

    static _CharacterInfo _character00001251 =
    {
        0x00001251,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001251,
        0x00001251,
        0x00001251
    };

    static _CharacterInfo _character00001252 =
    {
        0x00001252,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001252,
        0x00001252,
        0x00001252
    };

    static _CharacterInfo _character00001253 =
    {
        0x00001253,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001253,
        0x00001253,
        0x00001253
    };

    static _CharacterInfo _character00001254 =
    {
        0x00001254,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001254,
        0x00001254,
        0x00001254
    };

    static _CharacterInfo _character00001255 =
    {
        0x00001255,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001255,
        0x00001255,
        0x00001255
    };

    static _CharacterInfo _character00001256 =
    {
        0x00001256,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001256,
        0x00001256,
        0x00001256
    };

    static _CharacterInfo _character00001258 =
    {
        0x00001258,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001258,
        0x00001258,
        0x00001258
    };

    static _CharacterInfo _character0000125A =
    {
        0x0000125A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000125A,
        0x0000125A,
        0x0000125A
    };

    static _CharacterInfo _character0000125B =
    {
        0x0000125B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000125B,
        0x0000125B,
        0x0000125B
    };

    static _CharacterInfo _character0000125C =
    {
        0x0000125C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000125C,
        0x0000125C,
        0x0000125C
    };

    static _CharacterInfo _character0000125D =
    {
        0x0000125D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000125D,
        0x0000125D,
        0x0000125D
    };

    static _CharacterInfo _character00001260 =
    {
        0x00001260,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001260,
        0x00001260,
        0x00001260
    };

    static _CharacterInfo _character00001261 =
    {
        0x00001261,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001261,
        0x00001261,
        0x00001261
    };

    static _CharacterInfo _character00001262 =
    {
        0x00001262,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001262,
        0x00001262,
        0x00001262
    };

    static _CharacterInfo _character00001263 =
    {
        0x00001263,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001263,
        0x00001263,
        0x00001263
    };

    static _CharacterInfo _character00001264 =
    {
        0x00001264,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001264,
        0x00001264,
        0x00001264
    };

    static _CharacterInfo _character00001265 =
    {
        0x00001265,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001265,
        0x00001265,
        0x00001265
    };

    static _CharacterInfo _character00001266 =
    {
        0x00001266,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001266,
        0x00001266,
        0x00001266
    };

    static _CharacterInfo _character00001267 =
    {
        0x00001267,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001267,
        0x00001267,
        0x00001267
    };

    static _CharacterInfo _character00001268 =
    {
        0x00001268,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001268,
        0x00001268,
        0x00001268
    };

    static _CharacterInfo _character00001269 =
    {
        0x00001269,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001269,
        0x00001269,
        0x00001269
    };

    static _CharacterInfo _character0000126A =
    {
        0x0000126A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126A,
        0x0000126A,
        0x0000126A
    };

    static _CharacterInfo _character0000126B =
    {
        0x0000126B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126B,
        0x0000126B,
        0x0000126B
    };

    static _CharacterInfo _character0000126C =
    {
        0x0000126C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126C,
        0x0000126C,
        0x0000126C
    };

    static _CharacterInfo _character0000126D =
    {
        0x0000126D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126D,
        0x0000126D,
        0x0000126D
    };

    static _CharacterInfo _character0000126E =
    {
        0x0000126E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126E,
        0x0000126E,
        0x0000126E
    };

    static _CharacterInfo _character0000126F =
    {
        0x0000126F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000126F,
        0x0000126F,
        0x0000126F
    };

    static _CharacterInfo _character00001270 =
    {
        0x00001270,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001270,
        0x00001270,
        0x00001270
    };

    static _CharacterInfo _character00001271 =
    {
        0x00001271,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001271,
        0x00001271,
        0x00001271
    };

    static _CharacterInfo _character00001272 =
    {
        0x00001272,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001272,
        0x00001272,
        0x00001272
    };

    static _CharacterInfo _character00001273 =
    {
        0x00001273,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001273,
        0x00001273,
        0x00001273
    };

    static _CharacterInfo _character00001274 =
    {
        0x00001274,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001274,
        0x00001274,
        0x00001274
    };

    static _CharacterInfo _character00001275 =
    {
        0x00001275,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001275,
        0x00001275,
        0x00001275
    };

    static _CharacterInfo _character00001276 =
    {
        0x00001276,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001276,
        0x00001276,
        0x00001276
    };

    static _CharacterInfo _character00001277 =
    {
        0x00001277,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001277,
        0x00001277,
        0x00001277
    };

    static _CharacterInfo _character00001278 =
    {
        0x00001278,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001278,
        0x00001278,
        0x00001278
    };

    static _CharacterInfo _character00001279 =
    {
        0x00001279,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001279,
        0x00001279,
        0x00001279
    };

    static _CharacterInfo _character0000127A =
    {
        0x0000127A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127A,
        0x0000127A,
        0x0000127A
    };

    static _CharacterInfo _character0000127B =
    {
        0x0000127B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127B,
        0x0000127B,
        0x0000127B
    };

    static _CharacterInfo _character0000127C =
    {
        0x0000127C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127C,
        0x0000127C,
        0x0000127C
    };

    static _CharacterInfo _character0000127D =
    {
        0x0000127D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127D,
        0x0000127D,
        0x0000127D
    };

    static _CharacterInfo _character0000127E =
    {
        0x0000127E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127E,
        0x0000127E,
        0x0000127E
    };

    static _CharacterInfo _character0000127F =
    {
        0x0000127F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000127F,
        0x0000127F,
        0x0000127F
    };

    static _CharacterInfo _character00001280 =
    {
        0x00001280,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001280,
        0x00001280,
        0x00001280
    };

    static _CharacterInfo _character00001281 =
    {
        0x00001281,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001281,
        0x00001281,
        0x00001281
    };

    static _CharacterInfo _character00001282 =
    {
        0x00001282,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001282,
        0x00001282,
        0x00001282
    };

    static _CharacterInfo _character00001283 =
    {
        0x00001283,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001283,
        0x00001283,
        0x00001283
    };

    static _CharacterInfo _character00001284 =
    {
        0x00001284,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001284,
        0x00001284,
        0x00001284
    };

    static _CharacterInfo _character00001285 =
    {
        0x00001285,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001285,
        0x00001285,
        0x00001285
    };

    static _CharacterInfo _character00001286 =
    {
        0x00001286,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001286,
        0x00001286,
        0x00001286
    };

    static _CharacterInfo _character00001287 =
    {
        0x00001287,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001287,
        0x00001287,
        0x00001287
    };

    static _CharacterInfo _character00001288 =
    {
        0x00001288,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001288,
        0x00001288,
        0x00001288
    };

    static _CharacterInfo _character0000128A =
    {
        0x0000128A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000128A,
        0x0000128A,
        0x0000128A
    };

    static _CharacterInfo _character0000128B =
    {
        0x0000128B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000128B,
        0x0000128B,
        0x0000128B
    };

    static _CharacterInfo _character0000128C =
    {
        0x0000128C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000128C,
        0x0000128C,
        0x0000128C
    };

    static _CharacterInfo _character0000128D =
    {
        0x0000128D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000128D,
        0x0000128D,
        0x0000128D
    };

    static _CharacterInfo _character00001290 =
    {
        0x00001290,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001290,
        0x00001290,
        0x00001290
    };

    static _CharacterInfo _character00001291 =
    {
        0x00001291,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001291,
        0x00001291,
        0x00001291
    };

    static _CharacterInfo _character00001292 =
    {
        0x00001292,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001292,
        0x00001292,
        0x00001292
    };

    static _CharacterInfo _character00001293 =
    {
        0x00001293,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001293,
        0x00001293,
        0x00001293
    };

    static _CharacterInfo _character00001294 =
    {
        0x00001294,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001294,
        0x00001294,
        0x00001294
    };

    static _CharacterInfo _character00001295 =
    {
        0x00001295,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001295,
        0x00001295,
        0x00001295
    };

    static _CharacterInfo _character00001296 =
    {
        0x00001296,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001296,
        0x00001296,
        0x00001296
    };

    static _CharacterInfo _character00001297 =
    {
        0x00001297,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001297,
        0x00001297,
        0x00001297
    };

    static _CharacterInfo _character00001298 =
    {
        0x00001298,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001298,
        0x00001298,
        0x00001298
    };

    static _CharacterInfo _character00001299 =
    {
        0x00001299,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001299,
        0x00001299,
        0x00001299
    };

    static _CharacterInfo _character0000129A =
    {
        0x0000129A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129A,
        0x0000129A,
        0x0000129A
    };

    static _CharacterInfo _character0000129B =
    {
        0x0000129B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129B,
        0x0000129B,
        0x0000129B
    };

    static _CharacterInfo _character0000129C =
    {
        0x0000129C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129C,
        0x0000129C,
        0x0000129C
    };

    static _CharacterInfo _character0000129D =
    {
        0x0000129D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129D,
        0x0000129D,
        0x0000129D
    };

    static _CharacterInfo _character0000129E =
    {
        0x0000129E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129E,
        0x0000129E,
        0x0000129E
    };

    static _CharacterInfo _character0000129F =
    {
        0x0000129F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000129F,
        0x0000129F,
        0x0000129F
    };

    static _CharacterInfo _character000012A0 =
    {
        0x000012A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A0,
        0x000012A0,
        0x000012A0
    };

    static _CharacterInfo _character000012A1 =
    {
        0x000012A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A1,
        0x000012A1,
        0x000012A1
    };

    static _CharacterInfo _character000012A2 =
    {
        0x000012A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A2,
        0x000012A2,
        0x000012A2
    };

    static _CharacterInfo _character000012A3 =
    {
        0x000012A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A3,
        0x000012A3,
        0x000012A3
    };

    static _CharacterInfo _character000012A4 =
    {
        0x000012A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A4,
        0x000012A4,
        0x000012A4
    };

    static _CharacterInfo _character000012A5 =
    {
        0x000012A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A5,
        0x000012A5,
        0x000012A5
    };

    static _CharacterInfo _character000012A6 =
    {
        0x000012A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A6,
        0x000012A6,
        0x000012A6
    };

    static _CharacterInfo _character000012A7 =
    {
        0x000012A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A7,
        0x000012A7,
        0x000012A7
    };

    static _CharacterInfo _character000012A8 =
    {
        0x000012A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A8,
        0x000012A8,
        0x000012A8
    };

    static _CharacterInfo _character000012A9 =
    {
        0x000012A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012A9,
        0x000012A9,
        0x000012A9
    };

    static _CharacterInfo _character000012AA =
    {
        0x000012AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AA,
        0x000012AA,
        0x000012AA
    };

    static _CharacterInfo _character000012AB =
    {
        0x000012AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AB,
        0x000012AB,
        0x000012AB
    };

    static _CharacterInfo _character000012AC =
    {
        0x000012AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AC,
        0x000012AC,
        0x000012AC
    };

    static _CharacterInfo _character000012AD =
    {
        0x000012AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AD,
        0x000012AD,
        0x000012AD
    };

    static _CharacterInfo _character000012AE =
    {
        0x000012AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AE,
        0x000012AE,
        0x000012AE
    };

    static _CharacterInfo _character000012AF =
    {
        0x000012AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012AF,
        0x000012AF,
        0x000012AF
    };

    static _CharacterInfo _character000012B0 =
    {
        0x000012B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B0,
        0x000012B0,
        0x000012B0
    };

    static _CharacterInfo _character000012B2 =
    {
        0x000012B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B2,
        0x000012B2,
        0x000012B2
    };

    static _CharacterInfo _character000012B3 =
    {
        0x000012B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B3,
        0x000012B3,
        0x000012B3
    };

    static _CharacterInfo _character000012B4 =
    {
        0x000012B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B4,
        0x000012B4,
        0x000012B4
    };

    static _CharacterInfo _character000012B5 =
    {
        0x000012B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B5,
        0x000012B5,
        0x000012B5
    };

    static _CharacterInfo _character000012B8 =
    {
        0x000012B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B8,
        0x000012B8,
        0x000012B8
    };

    static _CharacterInfo _character000012B9 =
    {
        0x000012B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012B9,
        0x000012B9,
        0x000012B9
    };

    static _CharacterInfo _character000012BA =
    {
        0x000012BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012BA,
        0x000012BA,
        0x000012BA
    };

    static _CharacterInfo _character000012BB =
    {
        0x000012BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012BB,
        0x000012BB,
        0x000012BB
    };

    static _CharacterInfo _character000012BC =
    {
        0x000012BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012BC,
        0x000012BC,
        0x000012BC
    };

    static _CharacterInfo _character000012BD =
    {
        0x000012BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012BD,
        0x000012BD,
        0x000012BD
    };

    static _CharacterInfo _character000012BE =
    {
        0x000012BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012BE,
        0x000012BE,
        0x000012BE
    };

    static _CharacterInfo _character000012C0 =
    {
        0x000012C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C0,
        0x000012C0,
        0x000012C0
    };

    static _CharacterInfo _character000012C2 =
    {
        0x000012C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C2,
        0x000012C2,
        0x000012C2
    };

    static _CharacterInfo _character000012C3 =
    {
        0x000012C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C3,
        0x000012C3,
        0x000012C3
    };

    static _CharacterInfo _character000012C4 =
    {
        0x000012C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C4,
        0x000012C4,
        0x000012C4
    };

    static _CharacterInfo _character000012C5 =
    {
        0x000012C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C5,
        0x000012C5,
        0x000012C5
    };

    static _CharacterInfo _character000012C8 =
    {
        0x000012C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C8,
        0x000012C8,
        0x000012C8
    };

    static _CharacterInfo _character000012C9 =
    {
        0x000012C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012C9,
        0x000012C9,
        0x000012C9
    };

    static _CharacterInfo _character000012CA =
    {
        0x000012CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CA,
        0x000012CA,
        0x000012CA
    };

    static _CharacterInfo _character000012CB =
    {
        0x000012CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CB,
        0x000012CB,
        0x000012CB
    };

    static _CharacterInfo _character000012CC =
    {
        0x000012CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CC,
        0x000012CC,
        0x000012CC
    };

    static _CharacterInfo _character000012CD =
    {
        0x000012CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CD,
        0x000012CD,
        0x000012CD
    };

    static _CharacterInfo _character000012CE =
    {
        0x000012CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CE,
        0x000012CE,
        0x000012CE
    };

    static _CharacterInfo _character000012CF =
    {
        0x000012CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012CF,
        0x000012CF,
        0x000012CF
    };

    static _CharacterInfo _character000012D0 =
    {
        0x000012D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D0,
        0x000012D0,
        0x000012D0
    };

    static _CharacterInfo _character000012D1 =
    {
        0x000012D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D1,
        0x000012D1,
        0x000012D1
    };

    static _CharacterInfo _character000012D2 =
    {
        0x000012D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D2,
        0x000012D2,
        0x000012D2
    };

    static _CharacterInfo _character000012D3 =
    {
        0x000012D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D3,
        0x000012D3,
        0x000012D3
    };

    static _CharacterInfo _character000012D4 =
    {
        0x000012D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D4,
        0x000012D4,
        0x000012D4
    };

    static _CharacterInfo _character000012D5 =
    {
        0x000012D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D5,
        0x000012D5,
        0x000012D5
    };

    static _CharacterInfo _character000012D6 =
    {
        0x000012D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D6,
        0x000012D6,
        0x000012D6
    };

    static _CharacterInfo _character000012D8 =
    {
        0x000012D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D8,
        0x000012D8,
        0x000012D8
    };

    static _CharacterInfo _character000012D9 =
    {
        0x000012D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012D9,
        0x000012D9,
        0x000012D9
    };

    static _CharacterInfo _character000012DA =
    {
        0x000012DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DA,
        0x000012DA,
        0x000012DA
    };

    static _CharacterInfo _character000012DB =
    {
        0x000012DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DB,
        0x000012DB,
        0x000012DB
    };

    static _CharacterInfo _character000012DC =
    {
        0x000012DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DC,
        0x000012DC,
        0x000012DC
    };

    static _CharacterInfo _character000012DD =
    {
        0x000012DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DD,
        0x000012DD,
        0x000012DD
    };

    static _CharacterInfo _character000012DE =
    {
        0x000012DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DE,
        0x000012DE,
        0x000012DE
    };

    static _CharacterInfo _character000012DF =
    {
        0x000012DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012DF,
        0x000012DF,
        0x000012DF
    };

    static _CharacterInfo _character000012E0 =
    {
        0x000012E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E0,
        0x000012E0,
        0x000012E0
    };

    static _CharacterInfo _character000012E1 =
    {
        0x000012E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E1,
        0x000012E1,
        0x000012E1
    };

    static _CharacterInfo _character000012E2 =
    {
        0x000012E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E2,
        0x000012E2,
        0x000012E2
    };

    static _CharacterInfo _character000012E3 =
    {
        0x000012E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E3,
        0x000012E3,
        0x000012E3
    };

    static _CharacterInfo _character000012E4 =
    {
        0x000012E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E4,
        0x000012E4,
        0x000012E4
    };

    static _CharacterInfo _character000012E5 =
    {
        0x000012E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E5,
        0x000012E5,
        0x000012E5
    };

    static _CharacterInfo _character000012E6 =
    {
        0x000012E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E6,
        0x000012E6,
        0x000012E6
    };

    static _CharacterInfo _character000012E7 =
    {
        0x000012E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E7,
        0x000012E7,
        0x000012E7
    };

    static _CharacterInfo _character000012E8 =
    {
        0x000012E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E8,
        0x000012E8,
        0x000012E8
    };

    static _CharacterInfo _character000012E9 =
    {
        0x000012E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012E9,
        0x000012E9,
        0x000012E9
    };

    static _CharacterInfo _character000012EA =
    {
        0x000012EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012EA,
        0x000012EA,
        0x000012EA
    };

    static _CharacterInfo _character000012EB =
    {
        0x000012EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012EB,
        0x000012EB,
        0x000012EB
    };

    static _CharacterInfo _character000012EC =
    {
        0x000012EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012EC,
        0x000012EC,
        0x000012EC
    };

    static _CharacterInfo _character000012ED =
    {
        0x000012ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012ED,
        0x000012ED,
        0x000012ED
    };

    static _CharacterInfo _character000012EE =
    {
        0x000012EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012EE,
        0x000012EE,
        0x000012EE
    };

    static _CharacterInfo _character000012EF =
    {
        0x000012EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012EF,
        0x000012EF,
        0x000012EF
    };

    static _CharacterInfo _character000012F0 =
    {
        0x000012F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F0,
        0x000012F0,
        0x000012F0
    };

    static _CharacterInfo _character000012F1 =
    {
        0x000012F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F1,
        0x000012F1,
        0x000012F1
    };

    static _CharacterInfo _character000012F2 =
    {
        0x000012F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F2,
        0x000012F2,
        0x000012F2
    };

    static _CharacterInfo _character000012F3 =
    {
        0x000012F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F3,
        0x000012F3,
        0x000012F3
    };

    static _CharacterInfo _character000012F4 =
    {
        0x000012F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F4,
        0x000012F4,
        0x000012F4
    };

    static _CharacterInfo _character000012F5 =
    {
        0x000012F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F5,
        0x000012F5,
        0x000012F5
    };

    static _CharacterInfo _character000012F6 =
    {
        0x000012F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F6,
        0x000012F6,
        0x000012F6
    };

    static _CharacterInfo _character000012F7 =
    {
        0x000012F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F7,
        0x000012F7,
        0x000012F7
    };

    static _CharacterInfo _character000012F8 =
    {
        0x000012F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F8,
        0x000012F8,
        0x000012F8
    };

    static _CharacterInfo _character000012F9 =
    {
        0x000012F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012F9,
        0x000012F9,
        0x000012F9
    };

    static _CharacterInfo _character000012FA =
    {
        0x000012FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FA,
        0x000012FA,
        0x000012FA
    };

    static _CharacterInfo _character000012FB =
    {
        0x000012FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FB,
        0x000012FB,
        0x000012FB
    };

    static _CharacterInfo _character000012FC =
    {
        0x000012FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FC,
        0x000012FC,
        0x000012FC
    };

    static _CharacterInfo _character000012FD =
    {
        0x000012FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FD,
        0x000012FD,
        0x000012FD
    };

    static _CharacterInfo _character000012FE =
    {
        0x000012FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FE,
        0x000012FE,
        0x000012FE
    };

    static _CharacterInfo _character000012FF =
    {
        0x000012FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000012FF,
        0x000012FF,
        0x000012FF
    };

    static _CharacterInfo _character00001300 =
    {
        0x00001300,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001300,
        0x00001300,
        0x00001300
    };

    static _CharacterInfo _character00001301 =
    {
        0x00001301,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001301,
        0x00001301,
        0x00001301
    };

    static _CharacterInfo _character00001302 =
    {
        0x00001302,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001302,
        0x00001302,
        0x00001302
    };

    static _CharacterInfo _character00001303 =
    {
        0x00001303,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001303,
        0x00001303,
        0x00001303
    };

    static _CharacterInfo _character00001304 =
    {
        0x00001304,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001304,
        0x00001304,
        0x00001304
    };

    static _CharacterInfo _character00001305 =
    {
        0x00001305,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001305,
        0x00001305,
        0x00001305
    };

    static _CharacterInfo _character00001306 =
    {
        0x00001306,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001306,
        0x00001306,
        0x00001306
    };

    static _CharacterInfo _character00001307 =
    {
        0x00001307,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001307,
        0x00001307,
        0x00001307
    };

    static _CharacterInfo _character00001308 =
    {
        0x00001308,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001308,
        0x00001308,
        0x00001308
    };

    static _CharacterInfo _character00001309 =
    {
        0x00001309,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001309,
        0x00001309,
        0x00001309
    };

    static _CharacterInfo _character0000130A =
    {
        0x0000130A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130A,
        0x0000130A,
        0x0000130A
    };

    static _CharacterInfo _character0000130B =
    {
        0x0000130B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130B,
        0x0000130B,
        0x0000130B
    };

    static _CharacterInfo _character0000130C =
    {
        0x0000130C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130C,
        0x0000130C,
        0x0000130C
    };

    static _CharacterInfo _character0000130D =
    {
        0x0000130D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130D,
        0x0000130D,
        0x0000130D
    };

    static _CharacterInfo _character0000130E =
    {
        0x0000130E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130E,
        0x0000130E,
        0x0000130E
    };

    static _CharacterInfo _character0000130F =
    {
        0x0000130F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000130F,
        0x0000130F,
        0x0000130F
    };

    static _CharacterInfo _character00001310 =
    {
        0x00001310,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001310,
        0x00001310,
        0x00001310
    };

    static _CharacterInfo _character00001312 =
    {
        0x00001312,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001312,
        0x00001312,
        0x00001312
    };

    static _CharacterInfo _character00001313 =
    {
        0x00001313,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001313,
        0x00001313,
        0x00001313
    };

    static _CharacterInfo _character00001314 =
    {
        0x00001314,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001314,
        0x00001314,
        0x00001314
    };

    static _CharacterInfo _character00001315 =
    {
        0x00001315,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001315,
        0x00001315,
        0x00001315
    };

    static _CharacterInfo _character00001318 =
    {
        0x00001318,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001318,
        0x00001318,
        0x00001318
    };

    static _CharacterInfo _character00001319 =
    {
        0x00001319,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001319,
        0x00001319,
        0x00001319
    };

    static _CharacterInfo _character0000131A =
    {
        0x0000131A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131A,
        0x0000131A,
        0x0000131A
    };

    static _CharacterInfo _character0000131B =
    {
        0x0000131B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131B,
        0x0000131B,
        0x0000131B
    };

    static _CharacterInfo _character0000131C =
    {
        0x0000131C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131C,
        0x0000131C,
        0x0000131C
    };

    static _CharacterInfo _character0000131D =
    {
        0x0000131D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131D,
        0x0000131D,
        0x0000131D
    };

    static _CharacterInfo _character0000131E =
    {
        0x0000131E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131E,
        0x0000131E,
        0x0000131E
    };

    static _CharacterInfo _character0000131F =
    {
        0x0000131F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000131F,
        0x0000131F,
        0x0000131F
    };

    static _CharacterInfo _character00001320 =
    {
        0x00001320,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001320,
        0x00001320,
        0x00001320
    };

    static _CharacterInfo _character00001321 =
    {
        0x00001321,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001321,
        0x00001321,
        0x00001321
    };

    static _CharacterInfo _character00001322 =
    {
        0x00001322,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001322,
        0x00001322,
        0x00001322
    };

    static _CharacterInfo _character00001323 =
    {
        0x00001323,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001323,
        0x00001323,
        0x00001323
    };

    static _CharacterInfo _character00001324 =
    {
        0x00001324,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001324,
        0x00001324,
        0x00001324
    };

    static _CharacterInfo _character00001325 =
    {
        0x00001325,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001325,
        0x00001325,
        0x00001325
    };

    static _CharacterInfo _character00001326 =
    {
        0x00001326,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001326,
        0x00001326,
        0x00001326
    };

    static _CharacterInfo _character00001327 =
    {
        0x00001327,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001327,
        0x00001327,
        0x00001327
    };

    static _CharacterInfo _character00001328 =
    {
        0x00001328,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001328,
        0x00001328,
        0x00001328
    };

    static _CharacterInfo _character00001329 =
    {
        0x00001329,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001329,
        0x00001329,
        0x00001329
    };

    static _CharacterInfo _character0000132A =
    {
        0x0000132A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132A,
        0x0000132A,
        0x0000132A
    };

    static _CharacterInfo _character0000132B =
    {
        0x0000132B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132B,
        0x0000132B,
        0x0000132B
    };

    static _CharacterInfo _character0000132C =
    {
        0x0000132C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132C,
        0x0000132C,
        0x0000132C
    };

    static _CharacterInfo _character0000132D =
    {
        0x0000132D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132D,
        0x0000132D,
        0x0000132D
    };

    static _CharacterInfo _character0000132E =
    {
        0x0000132E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132E,
        0x0000132E,
        0x0000132E
    };

    static _CharacterInfo _character0000132F =
    {
        0x0000132F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000132F,
        0x0000132F,
        0x0000132F
    };

    static _CharacterInfo _character00001330 =
    {
        0x00001330,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001330,
        0x00001330,
        0x00001330
    };

    static _CharacterInfo _character00001331 =
    {
        0x00001331,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001331,
        0x00001331,
        0x00001331
    };

    static _CharacterInfo _character00001332 =
    {
        0x00001332,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001332,
        0x00001332,
        0x00001332
    };

    static _CharacterInfo _character00001333 =
    {
        0x00001333,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001333,
        0x00001333,
        0x00001333
    };

    static _CharacterInfo _character00001334 =
    {
        0x00001334,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001334,
        0x00001334,
        0x00001334
    };

    static _CharacterInfo _character00001335 =
    {
        0x00001335,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001335,
        0x00001335,
        0x00001335
    };

    static _CharacterInfo _character00001336 =
    {
        0x00001336,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001336,
        0x00001336,
        0x00001336
    };

    static _CharacterInfo _character00001337 =
    {
        0x00001337,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001337,
        0x00001337,
        0x00001337
    };

    static _CharacterInfo _character00001338 =
    {
        0x00001338,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001338,
        0x00001338,
        0x00001338
    };

    static _CharacterInfo _character00001339 =
    {
        0x00001339,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001339,
        0x00001339,
        0x00001339
    };

    static _CharacterInfo _character0000133A =
    {
        0x0000133A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133A,
        0x0000133A,
        0x0000133A
    };

    static _CharacterInfo _character0000133B =
    {
        0x0000133B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133B,
        0x0000133B,
        0x0000133B
    };

    static _CharacterInfo _character0000133C =
    {
        0x0000133C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133C,
        0x0000133C,
        0x0000133C
    };

    static _CharacterInfo _character0000133D =
    {
        0x0000133D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133D,
        0x0000133D,
        0x0000133D
    };

    static _CharacterInfo _character0000133E =
    {
        0x0000133E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133E,
        0x0000133E,
        0x0000133E
    };

    static _CharacterInfo _character0000133F =
    {
        0x0000133F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000133F,
        0x0000133F,
        0x0000133F
    };

    static _CharacterInfo _character00001340 =
    {
        0x00001340,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001340,
        0x00001340,
        0x00001340
    };

    static _CharacterInfo _character00001341 =
    {
        0x00001341,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001341,
        0x00001341,
        0x00001341
    };

    static _CharacterInfo _character00001342 =
    {
        0x00001342,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001342,
        0x00001342,
        0x00001342
    };

    static _CharacterInfo _character00001343 =
    {
        0x00001343,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001343,
        0x00001343,
        0x00001343
    };

    static _CharacterInfo _character00001344 =
    {
        0x00001344,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001344,
        0x00001344,
        0x00001344
    };

    static _CharacterInfo _character00001345 =
    {
        0x00001345,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001345,
        0x00001345,
        0x00001345
    };

    static _CharacterInfo _character00001346 =
    {
        0x00001346,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001346,
        0x00001346,
        0x00001346
    };

    static _CharacterInfo _character00001347 =
    {
        0x00001347,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001347,
        0x00001347,
        0x00001347
    };

    static _CharacterInfo _character00001348 =
    {
        0x00001348,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001348,
        0x00001348,
        0x00001348
    };

    static _CharacterInfo _character00001349 =
    {
        0x00001349,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001349,
        0x00001349,
        0x00001349
    };

    static _CharacterInfo _character0000134A =
    {
        0x0000134A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134A,
        0x0000134A,
        0x0000134A
    };

    static _CharacterInfo _character0000134B =
    {
        0x0000134B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134B,
        0x0000134B,
        0x0000134B
    };

    static _CharacterInfo _character0000134C =
    {
        0x0000134C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134C,
        0x0000134C,
        0x0000134C
    };

    static _CharacterInfo _character0000134D =
    {
        0x0000134D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134D,
        0x0000134D,
        0x0000134D
    };

    static _CharacterInfo _character0000134E =
    {
        0x0000134E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134E,
        0x0000134E,
        0x0000134E
    };

    static _CharacterInfo _character0000134F =
    {
        0x0000134F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000134F,
        0x0000134F,
        0x0000134F
    };

    static _CharacterInfo _character00001350 =
    {
        0x00001350,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001350,
        0x00001350,
        0x00001350
    };

    static _CharacterInfo _character00001351 =
    {
        0x00001351,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001351,
        0x00001351,
        0x00001351
    };

    static _CharacterInfo _character00001352 =
    {
        0x00001352,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001352,
        0x00001352,
        0x00001352
    };

    static _CharacterInfo _character00001353 =
    {
        0x00001353,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001353,
        0x00001353,
        0x00001353
    };

    static _CharacterInfo _character00001354 =
    {
        0x00001354,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001354,
        0x00001354,
        0x00001354
    };

    static _CharacterInfo _character00001355 =
    {
        0x00001355,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001355,
        0x00001355,
        0x00001355
    };

    static _CharacterInfo _character00001356 =
    {
        0x00001356,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001356,
        0x00001356,
        0x00001356
    };

    static _CharacterInfo _character00001357 =
    {
        0x00001357,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001357,
        0x00001357,
        0x00001357
    };

    static _CharacterInfo _character00001358 =
    {
        0x00001358,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001358,
        0x00001358,
        0x00001358
    };

    static _CharacterInfo _character00001359 =
    {
        0x00001359,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001359,
        0x00001359,
        0x00001359
    };

    static _CharacterInfo _character0000135A =
    {
        0x0000135A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000135A,
        0x0000135A,
        0x0000135A
    };

    static _CharacterInfo _character0000135F =
    {
        0x0000135F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000135F,
        0x0000135F,
        0x0000135F
    };

    static _CharacterInfo _character00001360 =
    {
        0x00001360,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001360,
        0x00001360,
        0x00001360
    };

    static _CharacterInfo _character00001361 =
    {
        0x00001361,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001361,
        0x00001361,
        0x00001361
    };

    static _CharacterInfo _character00001362 =
    {
        0x00001362,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001362,
        0x00001362,
        0x00001362
    };

    static _CharacterInfo _character00001363 =
    {
        0x00001363,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001363,
        0x00001363,
        0x00001363
    };

    static _CharacterInfo _character00001364 =
    {
        0x00001364,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001364,
        0x00001364,
        0x00001364
    };

    static _CharacterInfo _character00001365 =
    {
        0x00001365,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001365,
        0x00001365,
        0x00001365
    };

    static _CharacterInfo _character00001366 =
    {
        0x00001366,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001366,
        0x00001366,
        0x00001366
    };

    static _CharacterInfo _character00001367 =
    {
        0x00001367,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001367,
        0x00001367,
        0x00001367
    };

    static _CharacterInfo _character00001368 =
    {
        0x00001368,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001368,
        0x00001368,
        0x00001368
    };

    static _CharacterInfo _character00001369 =
    {
        0x00001369,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00001369,
        0x00001369,
        0x00001369
    };

    static _CharacterInfo _character0000136A =
    {
        0x0000136A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0000136A,
        0x0000136A,
        0x0000136A
    };

    static _CharacterInfo _character0000136B =
    {
        0x0000136B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0000136B,
        0x0000136B,
        0x0000136B
    };

    static _CharacterInfo _character0000136C =
    {
        0x0000136C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000136C,
        0x0000136C,
        0x0000136C
    };

    static _CharacterInfo _character0000136D =
    {
        0x0000136D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000136D,
        0x0000136D,
        0x0000136D
    };

    static _CharacterInfo _character0000136E =
    {
        0x0000136E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000136E,
        0x0000136E,
        0x0000136E
    };

    static _CharacterInfo _character0000136F =
    {
        0x0000136F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000136F,
        0x0000136F,
        0x0000136F
    };

    static _CharacterInfo _character00001370 =
    {
        0x00001370,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00001370,
        0x00001370,
        0x00001370
    };

    static _CharacterInfo _character00001371 =
    {
        0x00001371,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00001371,
        0x00001371,
        0x00001371
    };

    static _CharacterInfo _character00001372 =
    {
        0x00001372,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00001372,
        0x00001372,
        0x00001372
    };

    static _CharacterInfo _character00001373 =
    {
        0x00001373,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00001373,
        0x00001373,
        0x00001373
    };

    static _CharacterInfo _character00001374 =
    {
        0x00001374,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x00001374,
        0x00001374,
        0x00001374
    };

    static _CharacterInfo _character00001375 =
    {
        0x00001375,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        40,
        1,
        false,
        0x00001375,
        0x00001375,
        0x00001375
    };

    static _CharacterInfo _character00001376 =
    {
        0x00001376,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00001376,
        0x00001376,
        0x00001376
    };

    static _CharacterInfo _character00001377 =
    {
        0x00001377,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        60,
        1,
        false,
        0x00001377,
        0x00001377,
        0x00001377
    };

    static _CharacterInfo _character00001378 =
    {
        0x00001378,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        70,
        1,
        false,
        0x00001378,
        0x00001378,
        0x00001378
    };

    static _CharacterInfo _character00001379 =
    {
        0x00001379,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        80,
        1,
        false,
        0x00001379,
        0x00001379,
        0x00001379
    };

    static _CharacterInfo _character0000137A =
    {
        0x0000137A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        90,
        1,
        false,
        0x0000137A,
        0x0000137A,
        0x0000137A
    };

    static _CharacterInfo _character0000137B =
    {
        0x0000137B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x0000137B,
        0x0000137B,
        0x0000137B
    };

    static _CharacterInfo _character0000137C =
    {
        0x0000137C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10000,
        1,
        false,
        0x0000137C,
        0x0000137C,
        0x0000137C
    };

    static _CharacterInfo _character00001380 =
    {
        0x00001380,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001380,
        0x00001380,
        0x00001380
    };

    static _CharacterInfo _character00001381 =
    {
        0x00001381,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001381,
        0x00001381,
        0x00001381
    };

    static _CharacterInfo _character00001382 =
    {
        0x00001382,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001382,
        0x00001382,
        0x00001382
    };

    static _CharacterInfo _character00001383 =
    {
        0x00001383,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001383,
        0x00001383,
        0x00001383
    };

    static _CharacterInfo _character00001384 =
    {
        0x00001384,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001384,
        0x00001384,
        0x00001384
    };

    static _CharacterInfo _character00001385 =
    {
        0x00001385,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001385,
        0x00001385,
        0x00001385
    };

    static _CharacterInfo _character00001386 =
    {
        0x00001386,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001386,
        0x00001386,
        0x00001386
    };

    static _CharacterInfo _character00001387 =
    {
        0x00001387,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001387,
        0x00001387,
        0x00001387
    };

    static _CharacterInfo _character00001388 =
    {
        0x00001388,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001388,
        0x00001388,
        0x00001388
    };

    static _CharacterInfo _character00001389 =
    {
        0x00001389,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001389,
        0x00001389,
        0x00001389
    };

    static _CharacterInfo _character0000138A =
    {
        0x0000138A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138A,
        0x0000138A,
        0x0000138A
    };

    static _CharacterInfo _character0000138B =
    {
        0x0000138B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138B,
        0x0000138B,
        0x0000138B
    };

    static _CharacterInfo _character0000138C =
    {
        0x0000138C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138C,
        0x0000138C,
        0x0000138C
    };

    static _CharacterInfo _character0000138D =
    {
        0x0000138D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138D,
        0x0000138D,
        0x0000138D
    };

    static _CharacterInfo _character0000138E =
    {
        0x0000138E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138E,
        0x0000138E,
        0x0000138E
    };

    static _CharacterInfo _character0000138F =
    {
        0x0000138F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000138F,
        0x0000138F,
        0x0000138F
    };

    static _CharacterInfo _character00001390 =
    {
        0x00001390,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001390,
        0x00001390,
        0x00001390
    };

    static _CharacterInfo _character00001391 =
    {
        0x00001391,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001391,
        0x00001391,
        0x00001391
    };

    static _CharacterInfo _character00001392 =
    {
        0x00001392,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001392,
        0x00001392,
        0x00001392
    };

    static _CharacterInfo _character00001393 =
    {
        0x00001393,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001393,
        0x00001393,
        0x00001393
    };

    static _CharacterInfo _character00001394 =
    {
        0x00001394,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001394,
        0x00001394,
        0x00001394
    };

    static _CharacterInfo _character00001395 =
    {
        0x00001395,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001395,
        0x00001395,
        0x00001395
    };

    static _CharacterInfo _character00001396 =
    {
        0x00001396,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001396,
        0x00001396,
        0x00001396
    };

    static _CharacterInfo _character00001397 =
    {
        0x00001397,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001397,
        0x00001397,
        0x00001397
    };

    static _CharacterInfo _character00001398 =
    {
        0x00001398,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001398,
        0x00001398,
        0x00001398
    };

    static _CharacterInfo _character00001399 =
    {
        0x00001399,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001399,
        0x00001399,
        0x00001399
    };

    static _CharacterInfo _character000013A0 =
    {
        0x000013A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A0,
        0x000013A0,
        0x000013A0
    };

    static _CharacterInfo _character000013A1 =
    {
        0x000013A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A1,
        0x000013A1,
        0x000013A1
    };

    static _CharacterInfo _character000013A2 =
    {
        0x000013A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A2,
        0x000013A2,
        0x000013A2
    };

    static _CharacterInfo _character000013A3 =
    {
        0x000013A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A3,
        0x000013A3,
        0x000013A3
    };

    static _CharacterInfo _character000013A4 =
    {
        0x000013A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A4,
        0x000013A4,
        0x000013A4
    };

    static _CharacterInfo _character000013A5 =
    {
        0x000013A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A5,
        0x000013A5,
        0x000013A5
    };

    static _CharacterInfo _character000013A6 =
    {
        0x000013A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A6,
        0x000013A6,
        0x000013A6
    };

    static _CharacterInfo _character000013A7 =
    {
        0x000013A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A7,
        0x000013A7,
        0x000013A7
    };

    static _CharacterInfo _character000013A8 =
    {
        0x000013A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A8,
        0x000013A8,
        0x000013A8
    };

    static _CharacterInfo _character000013A9 =
    {
        0x000013A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013A9,
        0x000013A9,
        0x000013A9
    };

    static _CharacterInfo _character000013AA =
    {
        0x000013AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AA,
        0x000013AA,
        0x000013AA
    };

    static _CharacterInfo _character000013AB =
    {
        0x000013AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AB,
        0x000013AB,
        0x000013AB
    };

    static _CharacterInfo _character000013AC =
    {
        0x000013AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AC,
        0x000013AC,
        0x000013AC
    };

    static _CharacterInfo _character000013AD =
    {
        0x000013AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AD,
        0x000013AD,
        0x000013AD
    };

    static _CharacterInfo _character000013AE =
    {
        0x000013AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AE,
        0x000013AE,
        0x000013AE
    };

    static _CharacterInfo _character000013AF =
    {
        0x000013AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013AF,
        0x000013AF,
        0x000013AF
    };

    static _CharacterInfo _character000013B0 =
    {
        0x000013B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B0,
        0x000013B0,
        0x000013B0
    };

    static _CharacterInfo _character000013B1 =
    {
        0x000013B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B1,
        0x000013B1,
        0x000013B1
    };

    static _CharacterInfo _character000013B2 =
    {
        0x000013B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B2,
        0x000013B2,
        0x000013B2
    };

    static _CharacterInfo _character000013B3 =
    {
        0x000013B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B3,
        0x000013B3,
        0x000013B3
    };

    static _CharacterInfo _character000013B4 =
    {
        0x000013B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B4,
        0x000013B4,
        0x000013B4
    };

    static _CharacterInfo _character000013B5 =
    {
        0x000013B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B5,
        0x000013B5,
        0x000013B5
    };

    static _CharacterInfo _character000013B6 =
    {
        0x000013B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B6,
        0x000013B6,
        0x000013B6
    };

    static _CharacterInfo _character000013B7 =
    {
        0x000013B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B7,
        0x000013B7,
        0x000013B7
    };

    static _CharacterInfo _character000013B8 =
    {
        0x000013B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B8,
        0x000013B8,
        0x000013B8
    };

    static _CharacterInfo _character000013B9 =
    {
        0x000013B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013B9,
        0x000013B9,
        0x000013B9
    };

    static _CharacterInfo _character000013BA =
    {
        0x000013BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BA,
        0x000013BA,
        0x000013BA
    };

    static _CharacterInfo _character000013BB =
    {
        0x000013BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BB,
        0x000013BB,
        0x000013BB
    };

    static _CharacterInfo _character000013BC =
    {
        0x000013BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BC,
        0x000013BC,
        0x000013BC
    };

    static _CharacterInfo _character000013BD =
    {
        0x000013BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BD,
        0x000013BD,
        0x000013BD
    };

    static _CharacterInfo _character000013BE =
    {
        0x000013BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BE,
        0x000013BE,
        0x000013BE
    };

    static _CharacterInfo _character000013BF =
    {
        0x000013BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013BF,
        0x000013BF,
        0x000013BF
    };

    static _CharacterInfo _character000013C0 =
    {
        0x000013C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C0,
        0x000013C0,
        0x000013C0
    };

    static _CharacterInfo _character000013C1 =
    {
        0x000013C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C1,
        0x000013C1,
        0x000013C1
    };

    static _CharacterInfo _character000013C2 =
    {
        0x000013C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C2,
        0x000013C2,
        0x000013C2
    };

    static _CharacterInfo _character000013C3 =
    {
        0x000013C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C3,
        0x000013C3,
        0x000013C3
    };

    static _CharacterInfo _character000013C4 =
    {
        0x000013C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C4,
        0x000013C4,
        0x000013C4
    };

    static _CharacterInfo _character000013C5 =
    {
        0x000013C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C5,
        0x000013C5,
        0x000013C5
    };

    static _CharacterInfo _character000013C6 =
    {
        0x000013C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C6,
        0x000013C6,
        0x000013C6
    };

    static _CharacterInfo _character000013C7 =
    {
        0x000013C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C7,
        0x000013C7,
        0x000013C7
    };

    static _CharacterInfo _character000013C8 =
    {
        0x000013C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C8,
        0x000013C8,
        0x000013C8
    };

    static _CharacterInfo _character000013C9 =
    {
        0x000013C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013C9,
        0x000013C9,
        0x000013C9
    };

    static _CharacterInfo _character000013CA =
    {
        0x000013CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CA,
        0x000013CA,
        0x000013CA
    };

    static _CharacterInfo _character000013CB =
    {
        0x000013CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CB,
        0x000013CB,
        0x000013CB
    };

    static _CharacterInfo _character000013CC =
    {
        0x000013CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CC,
        0x000013CC,
        0x000013CC
    };

    static _CharacterInfo _character000013CD =
    {
        0x000013CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CD,
        0x000013CD,
        0x000013CD
    };

    static _CharacterInfo _character000013CE =
    {
        0x000013CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CE,
        0x000013CE,
        0x000013CE
    };

    static _CharacterInfo _character000013CF =
    {
        0x000013CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013CF,
        0x000013CF,
        0x000013CF
    };

    static _CharacterInfo _character000013D0 =
    {
        0x000013D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D0,
        0x000013D0,
        0x000013D0
    };

    static _CharacterInfo _character000013D1 =
    {
        0x000013D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D1,
        0x000013D1,
        0x000013D1
    };

    static _CharacterInfo _character000013D2 =
    {
        0x000013D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D2,
        0x000013D2,
        0x000013D2
    };

    static _CharacterInfo _character000013D3 =
    {
        0x000013D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D3,
        0x000013D3,
        0x000013D3
    };

    static _CharacterInfo _character000013D4 =
    {
        0x000013D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D4,
        0x000013D4,
        0x000013D4
    };

    static _CharacterInfo _character000013D5 =
    {
        0x000013D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D5,
        0x000013D5,
        0x000013D5
    };

    static _CharacterInfo _character000013D6 =
    {
        0x000013D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D6,
        0x000013D6,
        0x000013D6
    };

    static _CharacterInfo _character000013D7 =
    {
        0x000013D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D7,
        0x000013D7,
        0x000013D7
    };

    static _CharacterInfo _character000013D8 =
    {
        0x000013D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D8,
        0x000013D8,
        0x000013D8
    };

    static _CharacterInfo _character000013D9 =
    {
        0x000013D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013D9,
        0x000013D9,
        0x000013D9
    };

    static _CharacterInfo _character000013DA =
    {
        0x000013DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DA,
        0x000013DA,
        0x000013DA
    };

    static _CharacterInfo _character000013DB =
    {
        0x000013DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DB,
        0x000013DB,
        0x000013DB
    };

    static _CharacterInfo _character000013DC =
    {
        0x000013DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DC,
        0x000013DC,
        0x000013DC
    };

    static _CharacterInfo _character000013DD =
    {
        0x000013DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DD,
        0x000013DD,
        0x000013DD
    };

    static _CharacterInfo _character000013DE =
    {
        0x000013DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DE,
        0x000013DE,
        0x000013DE
    };

    static _CharacterInfo _character000013DF =
    {
        0x000013DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013DF,
        0x000013DF,
        0x000013DF
    };

    static _CharacterInfo _character000013E0 =
    {
        0x000013E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E0,
        0x000013E0,
        0x000013E0
    };

    static _CharacterInfo _character000013E1 =
    {
        0x000013E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E1,
        0x000013E1,
        0x000013E1
    };

    static _CharacterInfo _character000013E2 =
    {
        0x000013E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E2,
        0x000013E2,
        0x000013E2
    };

    static _CharacterInfo _character000013E3 =
    {
        0x000013E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E3,
        0x000013E3,
        0x000013E3
    };

    static _CharacterInfo _character000013E4 =
    {
        0x000013E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E4,
        0x000013E4,
        0x000013E4
    };

    static _CharacterInfo _character000013E5 =
    {
        0x000013E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E5,
        0x000013E5,
        0x000013E5
    };

    static _CharacterInfo _character000013E6 =
    {
        0x000013E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E6,
        0x000013E6,
        0x000013E6
    };

    static _CharacterInfo _character000013E7 =
    {
        0x000013E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E7,
        0x000013E7,
        0x000013E7
    };

    static _CharacterInfo _character000013E8 =
    {
        0x000013E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E8,
        0x000013E8,
        0x000013E8
    };

    static _CharacterInfo _character000013E9 =
    {
        0x000013E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013E9,
        0x000013E9,
        0x000013E9
    };

    static _CharacterInfo _character000013EA =
    {
        0x000013EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013EA,
        0x000013EA,
        0x000013EA
    };

    static _CharacterInfo _character000013EB =
    {
        0x000013EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013EB,
        0x000013EB,
        0x000013EB
    };

    static _CharacterInfo _character000013EC =
    {
        0x000013EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013EC,
        0x000013EC,
        0x000013EC
    };

    static _CharacterInfo _character000013ED =
    {
        0x000013ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013ED,
        0x000013ED,
        0x000013ED
    };

    static _CharacterInfo _character000013EE =
    {
        0x000013EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013EE,
        0x000013EE,
        0x000013EE
    };

    static _CharacterInfo _character000013EF =
    {
        0x000013EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013EF,
        0x000013EF,
        0x000013EF
    };

    static _CharacterInfo _character000013F0 =
    {
        0x000013F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013F0,
        0x000013F0,
        0x000013F0
    };

    static _CharacterInfo _character000013F1 =
    {
        0x000013F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013F1,
        0x000013F1,
        0x000013F1
    };

    static _CharacterInfo _character000013F2 =
    {
        0x000013F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013F2,
        0x000013F2,
        0x000013F2
    };

    static _CharacterInfo _character000013F3 =
    {
        0x000013F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013F3,
        0x000013F3,
        0x000013F3
    };

    static _CharacterInfo _character000013F4 =
    {
        0x000013F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000013F4,
        0x000013F4,
        0x000013F4
    };

    static _CharacterInfo _character00001401 =
    {
        0x00001401,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001401,
        0x00001401,
        0x00001401
    };

    static _CharacterInfo _character00001402 =
    {
        0x00001402,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001402,
        0x00001402,
        0x00001402
    };

    static _CharacterInfo _character00001403 =
    {
        0x00001403,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001403,
        0x00001403,
        0x00001403
    };

    static _CharacterInfo _character00001404 =
    {
        0x00001404,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001404,
        0x00001404,
        0x00001404
    };

    static _CharacterInfo _character00001405 =
    {
        0x00001405,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001405,
        0x00001405,
        0x00001405
    };

    static _CharacterInfo _character00001406 =
    {
        0x00001406,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001406,
        0x00001406,
        0x00001406
    };

    static _CharacterInfo _character00001407 =
    {
        0x00001407,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001407,
        0x00001407,
        0x00001407
    };

    static _CharacterInfo _character00001408 =
    {
        0x00001408,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001408,
        0x00001408,
        0x00001408
    };

    static _CharacterInfo _character00001409 =
    {
        0x00001409,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001409,
        0x00001409,
        0x00001409
    };

    static _CharacterInfo _character0000140A =
    {
        0x0000140A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140A,
        0x0000140A,
        0x0000140A
    };

    static _CharacterInfo _character0000140B =
    {
        0x0000140B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140B,
        0x0000140B,
        0x0000140B
    };

    static _CharacterInfo _character0000140C =
    {
        0x0000140C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140C,
        0x0000140C,
        0x0000140C
    };

    static _CharacterInfo _character0000140D =
    {
        0x0000140D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140D,
        0x0000140D,
        0x0000140D
    };

    static _CharacterInfo _character0000140E =
    {
        0x0000140E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140E,
        0x0000140E,
        0x0000140E
    };

    static _CharacterInfo _character0000140F =
    {
        0x0000140F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000140F,
        0x0000140F,
        0x0000140F
    };

    static _CharacterInfo _character00001410 =
    {
        0x00001410,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001410,
        0x00001410,
        0x00001410
    };

    static _CharacterInfo _character00001411 =
    {
        0x00001411,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001411,
        0x00001411,
        0x00001411
    };

    static _CharacterInfo _character00001412 =
    {
        0x00001412,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001412,
        0x00001412,
        0x00001412
    };

    static _CharacterInfo _character00001413 =
    {
        0x00001413,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001413,
        0x00001413,
        0x00001413
    };

    static _CharacterInfo _character00001414 =
    {
        0x00001414,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001414,
        0x00001414,
        0x00001414
    };

    static _CharacterInfo _character00001415 =
    {
        0x00001415,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001415,
        0x00001415,
        0x00001415
    };

    static _CharacterInfo _character00001416 =
    {
        0x00001416,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001416,
        0x00001416,
        0x00001416
    };

    static _CharacterInfo _character00001417 =
    {
        0x00001417,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001417,
        0x00001417,
        0x00001417
    };

    static _CharacterInfo _character00001418 =
    {
        0x00001418,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001418,
        0x00001418,
        0x00001418
    };

    static _CharacterInfo _character00001419 =
    {
        0x00001419,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001419,
        0x00001419,
        0x00001419
    };

    static _CharacterInfo _character0000141A =
    {
        0x0000141A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141A,
        0x0000141A,
        0x0000141A
    };

    static _CharacterInfo _character0000141B =
    {
        0x0000141B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141B,
        0x0000141B,
        0x0000141B
    };

    static _CharacterInfo _character0000141C =
    {
        0x0000141C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141C,
        0x0000141C,
        0x0000141C
    };

    static _CharacterInfo _character0000141D =
    {
        0x0000141D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141D,
        0x0000141D,
        0x0000141D
    };

    static _CharacterInfo _character0000141E =
    {
        0x0000141E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141E,
        0x0000141E,
        0x0000141E
    };

    static _CharacterInfo _character0000141F =
    {
        0x0000141F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000141F,
        0x0000141F,
        0x0000141F
    };

    static _CharacterInfo _character00001420 =
    {
        0x00001420,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001420,
        0x00001420,
        0x00001420
    };

    static _CharacterInfo _character00001421 =
    {
        0x00001421,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001421,
        0x00001421,
        0x00001421
    };

    static _CharacterInfo _character00001422 =
    {
        0x00001422,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001422,
        0x00001422,
        0x00001422
    };

    static _CharacterInfo _character00001423 =
    {
        0x00001423,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001423,
        0x00001423,
        0x00001423
    };

    static _CharacterInfo _character00001424 =
    {
        0x00001424,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001424,
        0x00001424,
        0x00001424
    };

    static _CharacterInfo _character00001425 =
    {
        0x00001425,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001425,
        0x00001425,
        0x00001425
    };

    static _CharacterInfo _character00001426 =
    {
        0x00001426,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001426,
        0x00001426,
        0x00001426
    };

    static _CharacterInfo _character00001427 =
    {
        0x00001427,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001427,
        0x00001427,
        0x00001427
    };

    static _CharacterInfo _character00001428 =
    {
        0x00001428,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001428,
        0x00001428,
        0x00001428
    };

    static _CharacterInfo _character00001429 =
    {
        0x00001429,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001429,
        0x00001429,
        0x00001429
    };

    static _CharacterInfo _character0000142A =
    {
        0x0000142A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142A,
        0x0000142A,
        0x0000142A
    };

    static _CharacterInfo _character0000142B =
    {
        0x0000142B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142B,
        0x0000142B,
        0x0000142B
    };

    static _CharacterInfo _character0000142C =
    {
        0x0000142C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142C,
        0x0000142C,
        0x0000142C
    };

    static _CharacterInfo _character0000142D =
    {
        0x0000142D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142D,
        0x0000142D,
        0x0000142D
    };

    static _CharacterInfo _character0000142E =
    {
        0x0000142E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142E,
        0x0000142E,
        0x0000142E
    };

    static _CharacterInfo _character0000142F =
    {
        0x0000142F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000142F,
        0x0000142F,
        0x0000142F
    };

    static _CharacterInfo _character00001430 =
    {
        0x00001430,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001430,
        0x00001430,
        0x00001430
    };

    static _CharacterInfo _character00001431 =
    {
        0x00001431,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001431,
        0x00001431,
        0x00001431
    };

    static _CharacterInfo _character00001432 =
    {
        0x00001432,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001432,
        0x00001432,
        0x00001432
    };

    static _CharacterInfo _character00001433 =
    {
        0x00001433,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001433,
        0x00001433,
        0x00001433
    };

    static _CharacterInfo _character00001434 =
    {
        0x00001434,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001434,
        0x00001434,
        0x00001434
    };

    static _CharacterInfo _character00001435 =
    {
        0x00001435,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001435,
        0x00001435,
        0x00001435
    };

    static _CharacterInfo _character00001436 =
    {
        0x00001436,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001436,
        0x00001436,
        0x00001436
    };

    static _CharacterInfo _character00001437 =
    {
        0x00001437,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001437,
        0x00001437,
        0x00001437
    };

    static _CharacterInfo _character00001438 =
    {
        0x00001438,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001438,
        0x00001438,
        0x00001438
    };

    static _CharacterInfo _character00001439 =
    {
        0x00001439,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001439,
        0x00001439,
        0x00001439
    };

    static _CharacterInfo _character0000143A =
    {
        0x0000143A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143A,
        0x0000143A,
        0x0000143A
    };

    static _CharacterInfo _character0000143B =
    {
        0x0000143B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143B,
        0x0000143B,
        0x0000143B
    };

    static _CharacterInfo _character0000143C =
    {
        0x0000143C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143C,
        0x0000143C,
        0x0000143C
    };

    static _CharacterInfo _character0000143D =
    {
        0x0000143D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143D,
        0x0000143D,
        0x0000143D
    };

    static _CharacterInfo _character0000143E =
    {
        0x0000143E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143E,
        0x0000143E,
        0x0000143E
    };

    static _CharacterInfo _character0000143F =
    {
        0x0000143F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000143F,
        0x0000143F,
        0x0000143F
    };

    static _CharacterInfo _character00001440 =
    {
        0x00001440,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001440,
        0x00001440,
        0x00001440
    };

    static _CharacterInfo _character00001441 =
    {
        0x00001441,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001441,
        0x00001441,
        0x00001441
    };

    static _CharacterInfo _character00001442 =
    {
        0x00001442,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001442,
        0x00001442,
        0x00001442
    };

    static _CharacterInfo _character00001443 =
    {
        0x00001443,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001443,
        0x00001443,
        0x00001443
    };

    static _CharacterInfo _character00001444 =
    {
        0x00001444,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001444,
        0x00001444,
        0x00001444
    };

    static _CharacterInfo _character00001445 =
    {
        0x00001445,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001445,
        0x00001445,
        0x00001445
    };

    static _CharacterInfo _character00001446 =
    {
        0x00001446,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001446,
        0x00001446,
        0x00001446
    };

    static _CharacterInfo _character00001447 =
    {
        0x00001447,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001447,
        0x00001447,
        0x00001447
    };

    static _CharacterInfo _character00001448 =
    {
        0x00001448,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001448,
        0x00001448,
        0x00001448
    };

    static _CharacterInfo _character00001449 =
    {
        0x00001449,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001449,
        0x00001449,
        0x00001449
    };

    static _CharacterInfo _character0000144A =
    {
        0x0000144A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144A,
        0x0000144A,
        0x0000144A
    };

    static _CharacterInfo _character0000144B =
    {
        0x0000144B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144B,
        0x0000144B,
        0x0000144B
    };

    static _CharacterInfo _character0000144C =
    {
        0x0000144C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144C,
        0x0000144C,
        0x0000144C
    };

    static _CharacterInfo _character0000144D =
    {
        0x0000144D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144D,
        0x0000144D,
        0x0000144D
    };

    static _CharacterInfo _character0000144E =
    {
        0x0000144E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144E,
        0x0000144E,
        0x0000144E
    };

    static _CharacterInfo _character0000144F =
    {
        0x0000144F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000144F,
        0x0000144F,
        0x0000144F
    };

    static _CharacterInfo _character00001450 =
    {
        0x00001450,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001450,
        0x00001450,
        0x00001450
    };

    static _CharacterInfo _character00001451 =
    {
        0x00001451,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001451,
        0x00001451,
        0x00001451
    };

    static _CharacterInfo _character00001452 =
    {
        0x00001452,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001452,
        0x00001452,
        0x00001452
    };

    static _CharacterInfo _character00001453 =
    {
        0x00001453,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001453,
        0x00001453,
        0x00001453
    };

    static _CharacterInfo _character00001454 =
    {
        0x00001454,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001454,
        0x00001454,
        0x00001454
    };

    static _CharacterInfo _character00001455 =
    {
        0x00001455,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001455,
        0x00001455,
        0x00001455
    };

    static _CharacterInfo _character00001456 =
    {
        0x00001456,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001456,
        0x00001456,
        0x00001456
    };

    static _CharacterInfo _character00001457 =
    {
        0x00001457,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001457,
        0x00001457,
        0x00001457
    };

    static _CharacterInfo _character00001458 =
    {
        0x00001458,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001458,
        0x00001458,
        0x00001458
    };

    static _CharacterInfo _character00001459 =
    {
        0x00001459,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001459,
        0x00001459,
        0x00001459
    };

    static _CharacterInfo _character0000145A =
    {
        0x0000145A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145A,
        0x0000145A,
        0x0000145A
    };

    static _CharacterInfo _character0000145B =
    {
        0x0000145B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145B,
        0x0000145B,
        0x0000145B
    };

    static _CharacterInfo _character0000145C =
    {
        0x0000145C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145C,
        0x0000145C,
        0x0000145C
    };

    static _CharacterInfo _character0000145D =
    {
        0x0000145D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145D,
        0x0000145D,
        0x0000145D
    };

    static _CharacterInfo _character0000145E =
    {
        0x0000145E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145E,
        0x0000145E,
        0x0000145E
    };

    static _CharacterInfo _character0000145F =
    {
        0x0000145F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000145F,
        0x0000145F,
        0x0000145F
    };

    static _CharacterInfo _character00001460 =
    {
        0x00001460,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001460,
        0x00001460,
        0x00001460
    };

    static _CharacterInfo _character00001461 =
    {
        0x00001461,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001461,
        0x00001461,
        0x00001461
    };

    static _CharacterInfo _character00001462 =
    {
        0x00001462,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001462,
        0x00001462,
        0x00001462
    };

    static _CharacterInfo _character00001463 =
    {
        0x00001463,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001463,
        0x00001463,
        0x00001463
    };

    static _CharacterInfo _character00001464 =
    {
        0x00001464,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001464,
        0x00001464,
        0x00001464
    };

    static _CharacterInfo _character00001465 =
    {
        0x00001465,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001465,
        0x00001465,
        0x00001465
    };

    static _CharacterInfo _character00001466 =
    {
        0x00001466,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001466,
        0x00001466,
        0x00001466
    };

    static _CharacterInfo _character00001467 =
    {
        0x00001467,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001467,
        0x00001467,
        0x00001467
    };

    static _CharacterInfo _character00001468 =
    {
        0x00001468,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001468,
        0x00001468,
        0x00001468
    };

    static _CharacterInfo _character00001469 =
    {
        0x00001469,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001469,
        0x00001469,
        0x00001469
    };

    static _CharacterInfo _character0000146A =
    {
        0x0000146A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146A,
        0x0000146A,
        0x0000146A
    };

    static _CharacterInfo _character0000146B =
    {
        0x0000146B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146B,
        0x0000146B,
        0x0000146B
    };

    static _CharacterInfo _character0000146C =
    {
        0x0000146C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146C,
        0x0000146C,
        0x0000146C
    };

    static _CharacterInfo _character0000146D =
    {
        0x0000146D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146D,
        0x0000146D,
        0x0000146D
    };

    static _CharacterInfo _character0000146E =
    {
        0x0000146E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146E,
        0x0000146E,
        0x0000146E
    };

    static _CharacterInfo _character0000146F =
    {
        0x0000146F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000146F,
        0x0000146F,
        0x0000146F
    };

    static _CharacterInfo _character00001470 =
    {
        0x00001470,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001470,
        0x00001470,
        0x00001470
    };

    static _CharacterInfo _character00001471 =
    {
        0x00001471,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001471,
        0x00001471,
        0x00001471
    };

    static _CharacterInfo _character00001472 =
    {
        0x00001472,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001472,
        0x00001472,
        0x00001472
    };

    static _CharacterInfo _character00001473 =
    {
        0x00001473,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001473,
        0x00001473,
        0x00001473
    };

    static _CharacterInfo _character00001474 =
    {
        0x00001474,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001474,
        0x00001474,
        0x00001474
    };

    static _CharacterInfo _character00001475 =
    {
        0x00001475,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001475,
        0x00001475,
        0x00001475
    };

    static _CharacterInfo _character00001476 =
    {
        0x00001476,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001476,
        0x00001476,
        0x00001476
    };

    static _CharacterInfo _character00001477 =
    {
        0x00001477,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001477,
        0x00001477,
        0x00001477
    };

    static _CharacterInfo _character00001478 =
    {
        0x00001478,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001478,
        0x00001478,
        0x00001478
    };

    static _CharacterInfo _character00001479 =
    {
        0x00001479,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001479,
        0x00001479,
        0x00001479
    };

    static _CharacterInfo _character0000147A =
    {
        0x0000147A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147A,
        0x0000147A,
        0x0000147A
    };

    static _CharacterInfo _character0000147B =
    {
        0x0000147B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147B,
        0x0000147B,
        0x0000147B
    };

    static _CharacterInfo _character0000147C =
    {
        0x0000147C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147C,
        0x0000147C,
        0x0000147C
    };

    static _CharacterInfo _character0000147D =
    {
        0x0000147D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147D,
        0x0000147D,
        0x0000147D
    };

    static _CharacterInfo _character0000147E =
    {
        0x0000147E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147E,
        0x0000147E,
        0x0000147E
    };

    static _CharacterInfo _character0000147F =
    {
        0x0000147F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000147F,
        0x0000147F,
        0x0000147F
    };

    static _CharacterInfo _character00001480 =
    {
        0x00001480,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001480,
        0x00001480,
        0x00001480
    };

    static _CharacterInfo _character00001481 =
    {
        0x00001481,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001481,
        0x00001481,
        0x00001481
    };

    static _CharacterInfo _character00001482 =
    {
        0x00001482,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001482,
        0x00001482,
        0x00001482
    };

    static _CharacterInfo _character00001483 =
    {
        0x00001483,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001483,
        0x00001483,
        0x00001483
    };

    static _CharacterInfo _character00001484 =
    {
        0x00001484,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001484,
        0x00001484,
        0x00001484
    };

    static _CharacterInfo _character00001485 =
    {
        0x00001485,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001485,
        0x00001485,
        0x00001485
    };

    static _CharacterInfo _character00001486 =
    {
        0x00001486,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001486,
        0x00001486,
        0x00001486
    };

    static _CharacterInfo _character00001487 =
    {
        0x00001487,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001487,
        0x00001487,
        0x00001487
    };

    static _CharacterInfo _character00001488 =
    {
        0x00001488,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001488,
        0x00001488,
        0x00001488
    };

    static _CharacterInfo _character00001489 =
    {
        0x00001489,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001489,
        0x00001489,
        0x00001489
    };

    static _CharacterInfo _character0000148A =
    {
        0x0000148A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148A,
        0x0000148A,
        0x0000148A
    };

    static _CharacterInfo _character0000148B =
    {
        0x0000148B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148B,
        0x0000148B,
        0x0000148B
    };

    static _CharacterInfo _character0000148C =
    {
        0x0000148C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148C,
        0x0000148C,
        0x0000148C
    };

    static _CharacterInfo _character0000148D =
    {
        0x0000148D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148D,
        0x0000148D,
        0x0000148D
    };

    static _CharacterInfo _character0000148E =
    {
        0x0000148E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148E,
        0x0000148E,
        0x0000148E
    };

    static _CharacterInfo _character0000148F =
    {
        0x0000148F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000148F,
        0x0000148F,
        0x0000148F
    };

    static _CharacterInfo _character00001490 =
    {
        0x00001490,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001490,
        0x00001490,
        0x00001490
    };

    static _CharacterInfo _character00001491 =
    {
        0x00001491,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001491,
        0x00001491,
        0x00001491
    };

    static _CharacterInfo _character00001492 =
    {
        0x00001492,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001492,
        0x00001492,
        0x00001492
    };

    static _CharacterInfo _character00001493 =
    {
        0x00001493,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001493,
        0x00001493,
        0x00001493
    };

    static _CharacterInfo _character00001494 =
    {
        0x00001494,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001494,
        0x00001494,
        0x00001494
    };

    static _CharacterInfo _character00001495 =
    {
        0x00001495,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001495,
        0x00001495,
        0x00001495
    };

    static _CharacterInfo _character00001496 =
    {
        0x00001496,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001496,
        0x00001496,
        0x00001496
    };

    static _CharacterInfo _character00001497 =
    {
        0x00001497,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001497,
        0x00001497,
        0x00001497
    };

    static _CharacterInfo _character00001498 =
    {
        0x00001498,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001498,
        0x00001498,
        0x00001498
    };

    static _CharacterInfo _character00001499 =
    {
        0x00001499,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001499,
        0x00001499,
        0x00001499
    };

    static _CharacterInfo _character0000149A =
    {
        0x0000149A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149A,
        0x0000149A,
        0x0000149A
    };

    static _CharacterInfo _character0000149B =
    {
        0x0000149B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149B,
        0x0000149B,
        0x0000149B
    };

    static _CharacterInfo _character0000149C =
    {
        0x0000149C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149C,
        0x0000149C,
        0x0000149C
    };

    static _CharacterInfo _character0000149D =
    {
        0x0000149D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149D,
        0x0000149D,
        0x0000149D
    };

    static _CharacterInfo _character0000149E =
    {
        0x0000149E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149E,
        0x0000149E,
        0x0000149E
    };

    static _CharacterInfo _character0000149F =
    {
        0x0000149F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000149F,
        0x0000149F,
        0x0000149F
    };

    static _CharacterInfo _character000014A0 =
    {
        0x000014A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A0,
        0x000014A0,
        0x000014A0
    };

    static _CharacterInfo _character000014A1 =
    {
        0x000014A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A1,
        0x000014A1,
        0x000014A1
    };

    static _CharacterInfo _character000014A2 =
    {
        0x000014A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A2,
        0x000014A2,
        0x000014A2
    };

    static _CharacterInfo _character000014A3 =
    {
        0x000014A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A3,
        0x000014A3,
        0x000014A3
    };

    static _CharacterInfo _character000014A4 =
    {
        0x000014A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A4,
        0x000014A4,
        0x000014A4
    };

    static _CharacterInfo _character000014A5 =
    {
        0x000014A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A5,
        0x000014A5,
        0x000014A5
    };

    static _CharacterInfo _character000014A6 =
    {
        0x000014A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A6,
        0x000014A6,
        0x000014A6
    };

    static _CharacterInfo _character000014A7 =
    {
        0x000014A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A7,
        0x000014A7,
        0x000014A7
    };

    static _CharacterInfo _character000014A8 =
    {
        0x000014A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A8,
        0x000014A8,
        0x000014A8
    };

    static _CharacterInfo _character000014A9 =
    {
        0x000014A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014A9,
        0x000014A9,
        0x000014A9
    };

    static _CharacterInfo _character000014AA =
    {
        0x000014AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AA,
        0x000014AA,
        0x000014AA
    };

    static _CharacterInfo _character000014AB =
    {
        0x000014AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AB,
        0x000014AB,
        0x000014AB
    };

    static _CharacterInfo _character000014AC =
    {
        0x000014AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AC,
        0x000014AC,
        0x000014AC
    };

    static _CharacterInfo _character000014AD =
    {
        0x000014AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AD,
        0x000014AD,
        0x000014AD
    };

    static _CharacterInfo _character000014AE =
    {
        0x000014AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AE,
        0x000014AE,
        0x000014AE
    };

    static _CharacterInfo _character000014AF =
    {
        0x000014AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014AF,
        0x000014AF,
        0x000014AF
    };

    static _CharacterInfo _character000014B0 =
    {
        0x000014B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B0,
        0x000014B0,
        0x000014B0
    };

    static _CharacterInfo _character000014B1 =
    {
        0x000014B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B1,
        0x000014B1,
        0x000014B1
    };

    static _CharacterInfo _character000014B2 =
    {
        0x000014B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B2,
        0x000014B2,
        0x000014B2
    };

    static _CharacterInfo _character000014B3 =
    {
        0x000014B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B3,
        0x000014B3,
        0x000014B3
    };

    static _CharacterInfo _character000014B4 =
    {
        0x000014B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B4,
        0x000014B4,
        0x000014B4
    };

    static _CharacterInfo _character000014B5 =
    {
        0x000014B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B5,
        0x000014B5,
        0x000014B5
    };

    static _CharacterInfo _character000014B6 =
    {
        0x000014B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B6,
        0x000014B6,
        0x000014B6
    };

    static _CharacterInfo _character000014B7 =
    {
        0x000014B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B7,
        0x000014B7,
        0x000014B7
    };

    static _CharacterInfo _character000014B8 =
    {
        0x000014B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B8,
        0x000014B8,
        0x000014B8
    };

    static _CharacterInfo _character000014B9 =
    {
        0x000014B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014B9,
        0x000014B9,
        0x000014B9
    };

    static _CharacterInfo _character000014BA =
    {
        0x000014BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BA,
        0x000014BA,
        0x000014BA
    };

    static _CharacterInfo _character000014BB =
    {
        0x000014BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BB,
        0x000014BB,
        0x000014BB
    };

    static _CharacterInfo _character000014BC =
    {
        0x000014BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BC,
        0x000014BC,
        0x000014BC
    };

    static _CharacterInfo _character000014BD =
    {
        0x000014BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BD,
        0x000014BD,
        0x000014BD
    };

    static _CharacterInfo _character000014BE =
    {
        0x000014BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BE,
        0x000014BE,
        0x000014BE
    };

    static _CharacterInfo _character000014BF =
    {
        0x000014BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014BF,
        0x000014BF,
        0x000014BF
    };

    static _CharacterInfo _character000014C0 =
    {
        0x000014C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C0,
        0x000014C0,
        0x000014C0
    };

    static _CharacterInfo _character000014C1 =
    {
        0x000014C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C1,
        0x000014C1,
        0x000014C1
    };

    static _CharacterInfo _character000014C2 =
    {
        0x000014C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C2,
        0x000014C2,
        0x000014C2
    };

    static _CharacterInfo _character000014C3 =
    {
        0x000014C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C3,
        0x000014C3,
        0x000014C3
    };

    static _CharacterInfo _character000014C4 =
    {
        0x000014C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C4,
        0x000014C4,
        0x000014C4
    };

    static _CharacterInfo _character000014C5 =
    {
        0x000014C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C5,
        0x000014C5,
        0x000014C5
    };

    static _CharacterInfo _character000014C6 =
    {
        0x000014C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C6,
        0x000014C6,
        0x000014C6
    };

    static _CharacterInfo _character000014C7 =
    {
        0x000014C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C7,
        0x000014C7,
        0x000014C7
    };

    static _CharacterInfo _character000014C8 =
    {
        0x000014C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C8,
        0x000014C8,
        0x000014C8
    };

    static _CharacterInfo _character000014C9 =
    {
        0x000014C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014C9,
        0x000014C9,
        0x000014C9
    };

    static _CharacterInfo _character000014CA =
    {
        0x000014CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CA,
        0x000014CA,
        0x000014CA
    };

    static _CharacterInfo _character000014CB =
    {
        0x000014CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CB,
        0x000014CB,
        0x000014CB
    };

    static _CharacterInfo _character000014CC =
    {
        0x000014CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CC,
        0x000014CC,
        0x000014CC
    };

    static _CharacterInfo _character000014CD =
    {
        0x000014CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CD,
        0x000014CD,
        0x000014CD
    };

    static _CharacterInfo _character000014CE =
    {
        0x000014CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CE,
        0x000014CE,
        0x000014CE
    };

    static _CharacterInfo _character000014CF =
    {
        0x000014CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014CF,
        0x000014CF,
        0x000014CF
    };

    static _CharacterInfo _character000014D0 =
    {
        0x000014D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D0,
        0x000014D0,
        0x000014D0
    };

    static _CharacterInfo _character000014D1 =
    {
        0x000014D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D1,
        0x000014D1,
        0x000014D1
    };

    static _CharacterInfo _character000014D2 =
    {
        0x000014D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D2,
        0x000014D2,
        0x000014D2
    };

    static _CharacterInfo _character000014D3 =
    {
        0x000014D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D3,
        0x000014D3,
        0x000014D3
    };

    static _CharacterInfo _character000014D4 =
    {
        0x000014D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D4,
        0x000014D4,
        0x000014D4
    };

    static _CharacterInfo _character000014D5 =
    {
        0x000014D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D5,
        0x000014D5,
        0x000014D5
    };

    static _CharacterInfo _character000014D6 =
    {
        0x000014D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D6,
        0x000014D6,
        0x000014D6
    };

    static _CharacterInfo _character000014D7 =
    {
        0x000014D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D7,
        0x000014D7,
        0x000014D7
    };

    static _CharacterInfo _character000014D8 =
    {
        0x000014D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D8,
        0x000014D8,
        0x000014D8
    };

    static _CharacterInfo _character000014D9 =
    {
        0x000014D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014D9,
        0x000014D9,
        0x000014D9
    };

    static _CharacterInfo _character000014DA =
    {
        0x000014DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DA,
        0x000014DA,
        0x000014DA
    };

    static _CharacterInfo _character000014DB =
    {
        0x000014DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DB,
        0x000014DB,
        0x000014DB
    };

    static _CharacterInfo _character000014DC =
    {
        0x000014DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DC,
        0x000014DC,
        0x000014DC
    };

    static _CharacterInfo _character000014DD =
    {
        0x000014DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DD,
        0x000014DD,
        0x000014DD
    };

    static _CharacterInfo _character000014DE =
    {
        0x000014DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DE,
        0x000014DE,
        0x000014DE
    };

    static _CharacterInfo _character000014DF =
    {
        0x000014DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014DF,
        0x000014DF,
        0x000014DF
    };

    static _CharacterInfo _character000014E0 =
    {
        0x000014E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E0,
        0x000014E0,
        0x000014E0
    };

    static _CharacterInfo _character000014E1 =
    {
        0x000014E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E1,
        0x000014E1,
        0x000014E1
    };

    static _CharacterInfo _character000014E2 =
    {
        0x000014E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E2,
        0x000014E2,
        0x000014E2
    };

    static _CharacterInfo _character000014E3 =
    {
        0x000014E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E3,
        0x000014E3,
        0x000014E3
    };

    static _CharacterInfo _character000014E4 =
    {
        0x000014E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E4,
        0x000014E4,
        0x000014E4
    };

    static _CharacterInfo _character000014E5 =
    {
        0x000014E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E5,
        0x000014E5,
        0x000014E5
    };

    static _CharacterInfo _character000014E6 =
    {
        0x000014E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E6,
        0x000014E6,
        0x000014E6
    };

    static _CharacterInfo _character000014E7 =
    {
        0x000014E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E7,
        0x000014E7,
        0x000014E7
    };

    static _CharacterInfo _character000014E8 =
    {
        0x000014E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E8,
        0x000014E8,
        0x000014E8
    };

    static _CharacterInfo _character000014E9 =
    {
        0x000014E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014E9,
        0x000014E9,
        0x000014E9
    };

    static _CharacterInfo _character000014EA =
    {
        0x000014EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014EA,
        0x000014EA,
        0x000014EA
    };

    static _CharacterInfo _character000014EB =
    {
        0x000014EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014EB,
        0x000014EB,
        0x000014EB
    };

    static _CharacterInfo _character000014EC =
    {
        0x000014EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014EC,
        0x000014EC,
        0x000014EC
    };

    static _CharacterInfo _character000014ED =
    {
        0x000014ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014ED,
        0x000014ED,
        0x000014ED
    };

    static _CharacterInfo _character000014EE =
    {
        0x000014EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014EE,
        0x000014EE,
        0x000014EE
    };

    static _CharacterInfo _character000014EF =
    {
        0x000014EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014EF,
        0x000014EF,
        0x000014EF
    };

    static _CharacterInfo _character000014F0 =
    {
        0x000014F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F0,
        0x000014F0,
        0x000014F0
    };

    static _CharacterInfo _character000014F1 =
    {
        0x000014F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F1,
        0x000014F1,
        0x000014F1
    };

    static _CharacterInfo _character000014F2 =
    {
        0x000014F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F2,
        0x000014F2,
        0x000014F2
    };

    static _CharacterInfo _character000014F3 =
    {
        0x000014F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F3,
        0x000014F3,
        0x000014F3
    };

    static _CharacterInfo _character000014F4 =
    {
        0x000014F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F4,
        0x000014F4,
        0x000014F4
    };

    static _CharacterInfo _character000014F5 =
    {
        0x000014F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F5,
        0x000014F5,
        0x000014F5
    };

    static _CharacterInfo _character000014F6 =
    {
        0x000014F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F6,
        0x000014F6,
        0x000014F6
    };

    static _CharacterInfo _character000014F7 =
    {
        0x000014F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F7,
        0x000014F7,
        0x000014F7
    };

    static _CharacterInfo _character000014F8 =
    {
        0x000014F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F8,
        0x000014F8,
        0x000014F8
    };

    static _CharacterInfo _character000014F9 =
    {
        0x000014F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014F9,
        0x000014F9,
        0x000014F9
    };

    static _CharacterInfo _character000014FA =
    {
        0x000014FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FA,
        0x000014FA,
        0x000014FA
    };

    static _CharacterInfo _character000014FB =
    {
        0x000014FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FB,
        0x000014FB,
        0x000014FB
    };

    static _CharacterInfo _character000014FC =
    {
        0x000014FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FC,
        0x000014FC,
        0x000014FC
    };

    static _CharacterInfo _character000014FD =
    {
        0x000014FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FD,
        0x000014FD,
        0x000014FD
    };

    static _CharacterInfo _character000014FE =
    {
        0x000014FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FE,
        0x000014FE,
        0x000014FE
    };

    static _CharacterInfo _character000014FF =
    {
        0x000014FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000014FF,
        0x000014FF,
        0x000014FF
    };

    static _CharacterInfo _character00001500 =
    {
        0x00001500,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001500,
        0x00001500,
        0x00001500
    };

    static _CharacterInfo _character00001501 =
    {
        0x00001501,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001501,
        0x00001501,
        0x00001501
    };

    static _CharacterInfo _character00001502 =
    {
        0x00001502,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001502,
        0x00001502,
        0x00001502
    };

    static _CharacterInfo _character00001503 =
    {
        0x00001503,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001503,
        0x00001503,
        0x00001503
    };

    static _CharacterInfo _character00001504 =
    {
        0x00001504,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001504,
        0x00001504,
        0x00001504
    };

    static _CharacterInfo _character00001505 =
    {
        0x00001505,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001505,
        0x00001505,
        0x00001505
    };

    static _CharacterInfo _character00001506 =
    {
        0x00001506,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001506,
        0x00001506,
        0x00001506
    };

    static _CharacterInfo _character00001507 =
    {
        0x00001507,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001507,
        0x00001507,
        0x00001507
    };

    static _CharacterInfo _character00001508 =
    {
        0x00001508,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001508,
        0x00001508,
        0x00001508
    };

    static _CharacterInfo _character00001509 =
    {
        0x00001509,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001509,
        0x00001509,
        0x00001509
    };

    static _CharacterInfo _character0000150A =
    {
        0x0000150A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150A,
        0x0000150A,
        0x0000150A
    };

    static _CharacterInfo _character0000150B =
    {
        0x0000150B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150B,
        0x0000150B,
        0x0000150B
    };

    static _CharacterInfo _character0000150C =
    {
        0x0000150C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150C,
        0x0000150C,
        0x0000150C
    };

    static _CharacterInfo _character0000150D =
    {
        0x0000150D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150D,
        0x0000150D,
        0x0000150D
    };

    static _CharacterInfo _character0000150E =
    {
        0x0000150E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150E,
        0x0000150E,
        0x0000150E
    };

    static _CharacterInfo _character0000150F =
    {
        0x0000150F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000150F,
        0x0000150F,
        0x0000150F
    };

    static _CharacterInfo _character00001510 =
    {
        0x00001510,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001510,
        0x00001510,
        0x00001510
    };

    static _CharacterInfo _character00001511 =
    {
        0x00001511,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001511,
        0x00001511,
        0x00001511
    };

    static _CharacterInfo _character00001512 =
    {
        0x00001512,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001512,
        0x00001512,
        0x00001512
    };

    static _CharacterInfo _character00001513 =
    {
        0x00001513,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001513,
        0x00001513,
        0x00001513
    };

    static _CharacterInfo _character00001514 =
    {
        0x00001514,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001514,
        0x00001514,
        0x00001514
    };

    static _CharacterInfo _character00001515 =
    {
        0x00001515,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001515,
        0x00001515,
        0x00001515
    };

    static _CharacterInfo _character00001516 =
    {
        0x00001516,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001516,
        0x00001516,
        0x00001516
    };

    static _CharacterInfo _character00001517 =
    {
        0x00001517,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001517,
        0x00001517,
        0x00001517
    };

    static _CharacterInfo _character00001518 =
    {
        0x00001518,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001518,
        0x00001518,
        0x00001518
    };

    static _CharacterInfo _character00001519 =
    {
        0x00001519,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001519,
        0x00001519,
        0x00001519
    };

    static _CharacterInfo _character0000151A =
    {
        0x0000151A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151A,
        0x0000151A,
        0x0000151A
    };

    static _CharacterInfo _character0000151B =
    {
        0x0000151B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151B,
        0x0000151B,
        0x0000151B
    };

    static _CharacterInfo _character0000151C =
    {
        0x0000151C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151C,
        0x0000151C,
        0x0000151C
    };

    static _CharacterInfo _character0000151D =
    {
        0x0000151D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151D,
        0x0000151D,
        0x0000151D
    };

    static _CharacterInfo _character0000151E =
    {
        0x0000151E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151E,
        0x0000151E,
        0x0000151E
    };

    static _CharacterInfo _character0000151F =
    {
        0x0000151F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000151F,
        0x0000151F,
        0x0000151F
    };

    static _CharacterInfo _character00001520 =
    {
        0x00001520,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001520,
        0x00001520,
        0x00001520
    };

    static _CharacterInfo _character00001521 =
    {
        0x00001521,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001521,
        0x00001521,
        0x00001521
    };

    static _CharacterInfo _character00001522 =
    {
        0x00001522,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001522,
        0x00001522,
        0x00001522
    };

    static _CharacterInfo _character00001523 =
    {
        0x00001523,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001523,
        0x00001523,
        0x00001523
    };

    static _CharacterInfo _character00001524 =
    {
        0x00001524,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001524,
        0x00001524,
        0x00001524
    };

    static _CharacterInfo _character00001525 =
    {
        0x00001525,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001525,
        0x00001525,
        0x00001525
    };

    static _CharacterInfo _character00001526 =
    {
        0x00001526,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001526,
        0x00001526,
        0x00001526
    };

    static _CharacterInfo _character00001527 =
    {
        0x00001527,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001527,
        0x00001527,
        0x00001527
    };

    static _CharacterInfo _character00001528 =
    {
        0x00001528,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001528,
        0x00001528,
        0x00001528
    };

    static _CharacterInfo _character00001529 =
    {
        0x00001529,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001529,
        0x00001529,
        0x00001529
    };

    static _CharacterInfo _character0000152A =
    {
        0x0000152A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152A,
        0x0000152A,
        0x0000152A
    };

    static _CharacterInfo _character0000152B =
    {
        0x0000152B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152B,
        0x0000152B,
        0x0000152B
    };

    static _CharacterInfo _character0000152C =
    {
        0x0000152C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152C,
        0x0000152C,
        0x0000152C
    };

    static _CharacterInfo _character0000152D =
    {
        0x0000152D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152D,
        0x0000152D,
        0x0000152D
    };

    static _CharacterInfo _character0000152E =
    {
        0x0000152E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152E,
        0x0000152E,
        0x0000152E
    };

    static _CharacterInfo _character0000152F =
    {
        0x0000152F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000152F,
        0x0000152F,
        0x0000152F
    };

    static _CharacterInfo _character00001530 =
    {
        0x00001530,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001530,
        0x00001530,
        0x00001530
    };

    static _CharacterInfo _character00001531 =
    {
        0x00001531,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001531,
        0x00001531,
        0x00001531
    };

    static _CharacterInfo _character00001532 =
    {
        0x00001532,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001532,
        0x00001532,
        0x00001532
    };

    static _CharacterInfo _character00001533 =
    {
        0x00001533,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001533,
        0x00001533,
        0x00001533
    };

    static _CharacterInfo _character00001534 =
    {
        0x00001534,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001534,
        0x00001534,
        0x00001534
    };

    static _CharacterInfo _character00001535 =
    {
        0x00001535,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001535,
        0x00001535,
        0x00001535
    };

    static _CharacterInfo _character00001536 =
    {
        0x00001536,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001536,
        0x00001536,
        0x00001536
    };

    static _CharacterInfo _character00001537 =
    {
        0x00001537,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001537,
        0x00001537,
        0x00001537
    };

    static _CharacterInfo _character00001538 =
    {
        0x00001538,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001538,
        0x00001538,
        0x00001538
    };

    static _CharacterInfo _character00001539 =
    {
        0x00001539,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001539,
        0x00001539,
        0x00001539
    };

    static _CharacterInfo _character0000153A =
    {
        0x0000153A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153A,
        0x0000153A,
        0x0000153A
    };

    static _CharacterInfo _character0000153B =
    {
        0x0000153B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153B,
        0x0000153B,
        0x0000153B
    };

    static _CharacterInfo _character0000153C =
    {
        0x0000153C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153C,
        0x0000153C,
        0x0000153C
    };

    static _CharacterInfo _character0000153D =
    {
        0x0000153D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153D,
        0x0000153D,
        0x0000153D
    };

    static _CharacterInfo _character0000153E =
    {
        0x0000153E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153E,
        0x0000153E,
        0x0000153E
    };

    static _CharacterInfo _character0000153F =
    {
        0x0000153F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000153F,
        0x0000153F,
        0x0000153F
    };

    static _CharacterInfo _character00001540 =
    {
        0x00001540,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001540,
        0x00001540,
        0x00001540
    };

    static _CharacterInfo _character00001541 =
    {
        0x00001541,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001541,
        0x00001541,
        0x00001541
    };

    static _CharacterInfo _character00001542 =
    {
        0x00001542,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001542,
        0x00001542,
        0x00001542
    };

    static _CharacterInfo _character00001543 =
    {
        0x00001543,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001543,
        0x00001543,
        0x00001543
    };

    static _CharacterInfo _character00001544 =
    {
        0x00001544,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001544,
        0x00001544,
        0x00001544
    };

    static _CharacterInfo _character00001545 =
    {
        0x00001545,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001545,
        0x00001545,
        0x00001545
    };

    static _CharacterInfo _character00001546 =
    {
        0x00001546,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001546,
        0x00001546,
        0x00001546
    };

    static _CharacterInfo _character00001547 =
    {
        0x00001547,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001547,
        0x00001547,
        0x00001547
    };

    static _CharacterInfo _character00001548 =
    {
        0x00001548,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001548,
        0x00001548,
        0x00001548
    };

    static _CharacterInfo _character00001549 =
    {
        0x00001549,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001549,
        0x00001549,
        0x00001549
    };

    static _CharacterInfo _character0000154A =
    {
        0x0000154A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154A,
        0x0000154A,
        0x0000154A
    };

    static _CharacterInfo _character0000154B =
    {
        0x0000154B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154B,
        0x0000154B,
        0x0000154B
    };

    static _CharacterInfo _character0000154C =
    {
        0x0000154C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154C,
        0x0000154C,
        0x0000154C
    };

    static _CharacterInfo _character0000154D =
    {
        0x0000154D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154D,
        0x0000154D,
        0x0000154D
    };

    static _CharacterInfo _character0000154E =
    {
        0x0000154E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154E,
        0x0000154E,
        0x0000154E
    };

    static _CharacterInfo _character0000154F =
    {
        0x0000154F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000154F,
        0x0000154F,
        0x0000154F
    };

    static _CharacterInfo _character00001550 =
    {
        0x00001550,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001550,
        0x00001550,
        0x00001550
    };

    static _CharacterInfo _character00001551 =
    {
        0x00001551,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001551,
        0x00001551,
        0x00001551
    };

    static _CharacterInfo _character00001552 =
    {
        0x00001552,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001552,
        0x00001552,
        0x00001552
    };

    static _CharacterInfo _character00001553 =
    {
        0x00001553,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001553,
        0x00001553,
        0x00001553
    };

    static _CharacterInfo _character00001554 =
    {
        0x00001554,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001554,
        0x00001554,
        0x00001554
    };

    static _CharacterInfo _character00001555 =
    {
        0x00001555,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001555,
        0x00001555,
        0x00001555
    };

    static _CharacterInfo _character00001556 =
    {
        0x00001556,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001556,
        0x00001556,
        0x00001556
    };

    static _CharacterInfo _character00001557 =
    {
        0x00001557,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001557,
        0x00001557,
        0x00001557
    };

    static _CharacterInfo _character00001558 =
    {
        0x00001558,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001558,
        0x00001558,
        0x00001558
    };

    static _CharacterInfo _character00001559 =
    {
        0x00001559,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001559,
        0x00001559,
        0x00001559
    };

    static _CharacterInfo _character0000155A =
    {
        0x0000155A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155A,
        0x0000155A,
        0x0000155A
    };

    static _CharacterInfo _character0000155B =
    {
        0x0000155B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155B,
        0x0000155B,
        0x0000155B
    };

    static _CharacterInfo _character0000155C =
    {
        0x0000155C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155C,
        0x0000155C,
        0x0000155C
    };

    static _CharacterInfo _character0000155D =
    {
        0x0000155D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155D,
        0x0000155D,
        0x0000155D
    };

    static _CharacterInfo _character0000155E =
    {
        0x0000155E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155E,
        0x0000155E,
        0x0000155E
    };

    static _CharacterInfo _character0000155F =
    {
        0x0000155F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000155F,
        0x0000155F,
        0x0000155F
    };

    static _CharacterInfo _character00001560 =
    {
        0x00001560,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001560,
        0x00001560,
        0x00001560
    };

    static _CharacterInfo _character00001561 =
    {
        0x00001561,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001561,
        0x00001561,
        0x00001561
    };

    static _CharacterInfo _character00001562 =
    {
        0x00001562,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001562,
        0x00001562,
        0x00001562
    };

    static _CharacterInfo _character00001563 =
    {
        0x00001563,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001563,
        0x00001563,
        0x00001563
    };

    static _CharacterInfo _character00001564 =
    {
        0x00001564,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001564,
        0x00001564,
        0x00001564
    };

    static _CharacterInfo _character00001565 =
    {
        0x00001565,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001565,
        0x00001565,
        0x00001565
    };

    static _CharacterInfo _character00001566 =
    {
        0x00001566,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001566,
        0x00001566,
        0x00001566
    };

    static _CharacterInfo _character00001567 =
    {
        0x00001567,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001567,
        0x00001567,
        0x00001567
    };

    static _CharacterInfo _character00001568 =
    {
        0x00001568,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001568,
        0x00001568,
        0x00001568
    };

    static _CharacterInfo _character00001569 =
    {
        0x00001569,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001569,
        0x00001569,
        0x00001569
    };

    static _CharacterInfo _character0000156A =
    {
        0x0000156A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156A,
        0x0000156A,
        0x0000156A
    };

    static _CharacterInfo _character0000156B =
    {
        0x0000156B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156B,
        0x0000156B,
        0x0000156B
    };

    static _CharacterInfo _character0000156C =
    {
        0x0000156C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156C,
        0x0000156C,
        0x0000156C
    };

    static _CharacterInfo _character0000156D =
    {
        0x0000156D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156D,
        0x0000156D,
        0x0000156D
    };

    static _CharacterInfo _character0000156E =
    {
        0x0000156E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156E,
        0x0000156E,
        0x0000156E
    };

    static _CharacterInfo _character0000156F =
    {
        0x0000156F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000156F,
        0x0000156F,
        0x0000156F
    };

    static _CharacterInfo _character00001570 =
    {
        0x00001570,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001570,
        0x00001570,
        0x00001570
    };

    static _CharacterInfo _character00001571 =
    {
        0x00001571,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001571,
        0x00001571,
        0x00001571
    };

    static _CharacterInfo _character00001572 =
    {
        0x00001572,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001572,
        0x00001572,
        0x00001572
    };

    static _CharacterInfo _character00001573 =
    {
        0x00001573,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001573,
        0x00001573,
        0x00001573
    };

    static _CharacterInfo _character00001574 =
    {
        0x00001574,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001574,
        0x00001574,
        0x00001574
    };

    static _CharacterInfo _character00001575 =
    {
        0x00001575,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001575,
        0x00001575,
        0x00001575
    };

    static _CharacterInfo _character00001576 =
    {
        0x00001576,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001576,
        0x00001576,
        0x00001576
    };

    static _CharacterInfo _character00001577 =
    {
        0x00001577,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001577,
        0x00001577,
        0x00001577
    };

    static _CharacterInfo _character00001578 =
    {
        0x00001578,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001578,
        0x00001578,
        0x00001578
    };

    static _CharacterInfo _character00001579 =
    {
        0x00001579,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001579,
        0x00001579,
        0x00001579
    };

    static _CharacterInfo _character0000157A =
    {
        0x0000157A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157A,
        0x0000157A,
        0x0000157A
    };

    static _CharacterInfo _character0000157B =
    {
        0x0000157B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157B,
        0x0000157B,
        0x0000157B
    };

    static _CharacterInfo _character0000157C =
    {
        0x0000157C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157C,
        0x0000157C,
        0x0000157C
    };

    static _CharacterInfo _character0000157D =
    {
        0x0000157D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157D,
        0x0000157D,
        0x0000157D
    };

    static _CharacterInfo _character0000157E =
    {
        0x0000157E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157E,
        0x0000157E,
        0x0000157E
    };

    static _CharacterInfo _character0000157F =
    {
        0x0000157F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000157F,
        0x0000157F,
        0x0000157F
    };

    static _CharacterInfo _character00001580 =
    {
        0x00001580,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001580,
        0x00001580,
        0x00001580
    };

    static _CharacterInfo _character00001581 =
    {
        0x00001581,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001581,
        0x00001581,
        0x00001581
    };

    static _CharacterInfo _character00001582 =
    {
        0x00001582,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001582,
        0x00001582,
        0x00001582
    };

    static _CharacterInfo _character00001583 =
    {
        0x00001583,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001583,
        0x00001583,
        0x00001583
    };

    static _CharacterInfo _character00001584 =
    {
        0x00001584,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001584,
        0x00001584,
        0x00001584
    };

    static _CharacterInfo _character00001585 =
    {
        0x00001585,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001585,
        0x00001585,
        0x00001585
    };

    static _CharacterInfo _character00001586 =
    {
        0x00001586,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001586,
        0x00001586,
        0x00001586
    };

    static _CharacterInfo _character00001587 =
    {
        0x00001587,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001587,
        0x00001587,
        0x00001587
    };

    static _CharacterInfo _character00001588 =
    {
        0x00001588,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001588,
        0x00001588,
        0x00001588
    };

    static _CharacterInfo _character00001589 =
    {
        0x00001589,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001589,
        0x00001589,
        0x00001589
    };

    static _CharacterInfo _character0000158A =
    {
        0x0000158A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158A,
        0x0000158A,
        0x0000158A
    };

    static _CharacterInfo _character0000158B =
    {
        0x0000158B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158B,
        0x0000158B,
        0x0000158B
    };

    static _CharacterInfo _character0000158C =
    {
        0x0000158C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158C,
        0x0000158C,
        0x0000158C
    };

    static _CharacterInfo _character0000158D =
    {
        0x0000158D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158D,
        0x0000158D,
        0x0000158D
    };

    static _CharacterInfo _character0000158E =
    {
        0x0000158E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158E,
        0x0000158E,
        0x0000158E
    };

    static _CharacterInfo _character0000158F =
    {
        0x0000158F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000158F,
        0x0000158F,
        0x0000158F
    };

    static _CharacterInfo _character00001590 =
    {
        0x00001590,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001590,
        0x00001590,
        0x00001590
    };

    static _CharacterInfo _character00001591 =
    {
        0x00001591,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001591,
        0x00001591,
        0x00001591
    };

    static _CharacterInfo _character00001592 =
    {
        0x00001592,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001592,
        0x00001592,
        0x00001592
    };

    static _CharacterInfo _character00001593 =
    {
        0x00001593,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001593,
        0x00001593,
        0x00001593
    };

    static _CharacterInfo _character00001594 =
    {
        0x00001594,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001594,
        0x00001594,
        0x00001594
    };

    static _CharacterInfo _character00001595 =
    {
        0x00001595,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001595,
        0x00001595,
        0x00001595
    };

    static _CharacterInfo _character00001596 =
    {
        0x00001596,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001596,
        0x00001596,
        0x00001596
    };

    static _CharacterInfo _character00001597 =
    {
        0x00001597,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001597,
        0x00001597,
        0x00001597
    };

    static _CharacterInfo _character00001598 =
    {
        0x00001598,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001598,
        0x00001598,
        0x00001598
    };

    static _CharacterInfo _character00001599 =
    {
        0x00001599,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001599,
        0x00001599,
        0x00001599
    };

    static _CharacterInfo _character0000159A =
    {
        0x0000159A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159A,
        0x0000159A,
        0x0000159A
    };

    static _CharacterInfo _character0000159B =
    {
        0x0000159B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159B,
        0x0000159B,
        0x0000159B
    };

    static _CharacterInfo _character0000159C =
    {
        0x0000159C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159C,
        0x0000159C,
        0x0000159C
    };

    static _CharacterInfo _character0000159D =
    {
        0x0000159D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159D,
        0x0000159D,
        0x0000159D
    };

    static _CharacterInfo _character0000159E =
    {
        0x0000159E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159E,
        0x0000159E,
        0x0000159E
    };

    static _CharacterInfo _character0000159F =
    {
        0x0000159F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000159F,
        0x0000159F,
        0x0000159F
    };

    static _CharacterInfo _character000015A0 =
    {
        0x000015A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A0,
        0x000015A0,
        0x000015A0
    };

    static _CharacterInfo _character000015A1 =
    {
        0x000015A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A1,
        0x000015A1,
        0x000015A1
    };

    static _CharacterInfo _character000015A2 =
    {
        0x000015A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A2,
        0x000015A2,
        0x000015A2
    };

    static _CharacterInfo _character000015A3 =
    {
        0x000015A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A3,
        0x000015A3,
        0x000015A3
    };

    static _CharacterInfo _character000015A4 =
    {
        0x000015A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A4,
        0x000015A4,
        0x000015A4
    };

    static _CharacterInfo _character000015A5 =
    {
        0x000015A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A5,
        0x000015A5,
        0x000015A5
    };

    static _CharacterInfo _character000015A6 =
    {
        0x000015A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A6,
        0x000015A6,
        0x000015A6
    };

    static _CharacterInfo _character000015A7 =
    {
        0x000015A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A7,
        0x000015A7,
        0x000015A7
    };

    static _CharacterInfo _character000015A8 =
    {
        0x000015A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A8,
        0x000015A8,
        0x000015A8
    };

    static _CharacterInfo _character000015A9 =
    {
        0x000015A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015A9,
        0x000015A9,
        0x000015A9
    };

    static _CharacterInfo _character000015AA =
    {
        0x000015AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AA,
        0x000015AA,
        0x000015AA
    };

    static _CharacterInfo _character000015AB =
    {
        0x000015AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AB,
        0x000015AB,
        0x000015AB
    };

    static _CharacterInfo _character000015AC =
    {
        0x000015AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AC,
        0x000015AC,
        0x000015AC
    };

    static _CharacterInfo _character000015AD =
    {
        0x000015AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AD,
        0x000015AD,
        0x000015AD
    };

    static _CharacterInfo _character000015AE =
    {
        0x000015AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AE,
        0x000015AE,
        0x000015AE
    };

    static _CharacterInfo _character000015AF =
    {
        0x000015AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015AF,
        0x000015AF,
        0x000015AF
    };

    static _CharacterInfo _character000015B0 =
    {
        0x000015B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B0,
        0x000015B0,
        0x000015B0
    };

    static _CharacterInfo _character000015B1 =
    {
        0x000015B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B1,
        0x000015B1,
        0x000015B1
    };

    static _CharacterInfo _character000015B2 =
    {
        0x000015B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B2,
        0x000015B2,
        0x000015B2
    };

    static _CharacterInfo _character000015B3 =
    {
        0x000015B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B3,
        0x000015B3,
        0x000015B3
    };

    static _CharacterInfo _character000015B4 =
    {
        0x000015B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B4,
        0x000015B4,
        0x000015B4
    };

    static _CharacterInfo _character000015B5 =
    {
        0x000015B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B5,
        0x000015B5,
        0x000015B5
    };

    static _CharacterInfo _character000015B6 =
    {
        0x000015B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B6,
        0x000015B6,
        0x000015B6
    };

    static _CharacterInfo _character000015B7 =
    {
        0x000015B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B7,
        0x000015B7,
        0x000015B7
    };

    static _CharacterInfo _character000015B8 =
    {
        0x000015B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B8,
        0x000015B8,
        0x000015B8
    };

    static _CharacterInfo _character000015B9 =
    {
        0x000015B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015B9,
        0x000015B9,
        0x000015B9
    };

    static _CharacterInfo _character000015BA =
    {
        0x000015BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BA,
        0x000015BA,
        0x000015BA
    };

    static _CharacterInfo _character000015BB =
    {
        0x000015BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BB,
        0x000015BB,
        0x000015BB
    };

    static _CharacterInfo _character000015BC =
    {
        0x000015BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BC,
        0x000015BC,
        0x000015BC
    };

    static _CharacterInfo _character000015BD =
    {
        0x000015BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BD,
        0x000015BD,
        0x000015BD
    };

    static _CharacterInfo _character000015BE =
    {
        0x000015BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BE,
        0x000015BE,
        0x000015BE
    };

    static _CharacterInfo _character000015BF =
    {
        0x000015BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015BF,
        0x000015BF,
        0x000015BF
    };

    static _CharacterInfo _character000015C0 =
    {
        0x000015C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C0,
        0x000015C0,
        0x000015C0
    };

    static _CharacterInfo _character000015C1 =
    {
        0x000015C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C1,
        0x000015C1,
        0x000015C1
    };

    static _CharacterInfo _character000015C2 =
    {
        0x000015C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C2,
        0x000015C2,
        0x000015C2
    };

    static _CharacterInfo _character000015C3 =
    {
        0x000015C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C3,
        0x000015C3,
        0x000015C3
    };

    static _CharacterInfo _character000015C4 =
    {
        0x000015C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C4,
        0x000015C4,
        0x000015C4
    };

    static _CharacterInfo _character000015C5 =
    {
        0x000015C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C5,
        0x000015C5,
        0x000015C5
    };

    static _CharacterInfo _character000015C6 =
    {
        0x000015C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C6,
        0x000015C6,
        0x000015C6
    };

    static _CharacterInfo _character000015C7 =
    {
        0x000015C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C7,
        0x000015C7,
        0x000015C7
    };

    static _CharacterInfo _character000015C8 =
    {
        0x000015C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C8,
        0x000015C8,
        0x000015C8
    };

    static _CharacterInfo _character000015C9 =
    {
        0x000015C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015C9,
        0x000015C9,
        0x000015C9
    };

    static _CharacterInfo _character000015CA =
    {
        0x000015CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CA,
        0x000015CA,
        0x000015CA
    };

    static _CharacterInfo _character000015CB =
    {
        0x000015CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CB,
        0x000015CB,
        0x000015CB
    };

    static _CharacterInfo _character000015CC =
    {
        0x000015CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CC,
        0x000015CC,
        0x000015CC
    };

    static _CharacterInfo _character000015CD =
    {
        0x000015CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CD,
        0x000015CD,
        0x000015CD
    };

    static _CharacterInfo _character000015CE =
    {
        0x000015CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CE,
        0x000015CE,
        0x000015CE
    };

    static _CharacterInfo _character000015CF =
    {
        0x000015CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015CF,
        0x000015CF,
        0x000015CF
    };

    static _CharacterInfo _character000015D0 =
    {
        0x000015D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D0,
        0x000015D0,
        0x000015D0
    };

    static _CharacterInfo _character000015D1 =
    {
        0x000015D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D1,
        0x000015D1,
        0x000015D1
    };

    static _CharacterInfo _character000015D2 =
    {
        0x000015D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D2,
        0x000015D2,
        0x000015D2
    };

    static _CharacterInfo _character000015D3 =
    {
        0x000015D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D3,
        0x000015D3,
        0x000015D3
    };

    static _CharacterInfo _character000015D4 =
    {
        0x000015D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D4,
        0x000015D4,
        0x000015D4
    };

    static _CharacterInfo _character000015D5 =
    {
        0x000015D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D5,
        0x000015D5,
        0x000015D5
    };

    static _CharacterInfo _character000015D6 =
    {
        0x000015D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D6,
        0x000015D6,
        0x000015D6
    };

    static _CharacterInfo _character000015D7 =
    {
        0x000015D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D7,
        0x000015D7,
        0x000015D7
    };

    static _CharacterInfo _character000015D8 =
    {
        0x000015D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D8,
        0x000015D8,
        0x000015D8
    };

    static _CharacterInfo _character000015D9 =
    {
        0x000015D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015D9,
        0x000015D9,
        0x000015D9
    };

    static _CharacterInfo _character000015DA =
    {
        0x000015DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DA,
        0x000015DA,
        0x000015DA
    };

    static _CharacterInfo _character000015DB =
    {
        0x000015DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DB,
        0x000015DB,
        0x000015DB
    };

    static _CharacterInfo _character000015DC =
    {
        0x000015DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DC,
        0x000015DC,
        0x000015DC
    };

    static _CharacterInfo _character000015DD =
    {
        0x000015DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DD,
        0x000015DD,
        0x000015DD
    };

    static _CharacterInfo _character000015DE =
    {
        0x000015DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DE,
        0x000015DE,
        0x000015DE
    };

    static _CharacterInfo _character000015DF =
    {
        0x000015DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015DF,
        0x000015DF,
        0x000015DF
    };

    static _CharacterInfo _character000015E0 =
    {
        0x000015E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E0,
        0x000015E0,
        0x000015E0
    };

    static _CharacterInfo _character000015E1 =
    {
        0x000015E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E1,
        0x000015E1,
        0x000015E1
    };

    static _CharacterInfo _character000015E2 =
    {
        0x000015E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E2,
        0x000015E2,
        0x000015E2
    };

    static _CharacterInfo _character000015E3 =
    {
        0x000015E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E3,
        0x000015E3,
        0x000015E3
    };

    static _CharacterInfo _character000015E4 =
    {
        0x000015E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E4,
        0x000015E4,
        0x000015E4
    };

    static _CharacterInfo _character000015E5 =
    {
        0x000015E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E5,
        0x000015E5,
        0x000015E5
    };

    static _CharacterInfo _character000015E6 =
    {
        0x000015E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E6,
        0x000015E6,
        0x000015E6
    };

    static _CharacterInfo _character000015E7 =
    {
        0x000015E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E7,
        0x000015E7,
        0x000015E7
    };

    static _CharacterInfo _character000015E8 =
    {
        0x000015E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E8,
        0x000015E8,
        0x000015E8
    };

    static _CharacterInfo _character000015E9 =
    {
        0x000015E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015E9,
        0x000015E9,
        0x000015E9
    };

    static _CharacterInfo _character000015EA =
    {
        0x000015EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015EA,
        0x000015EA,
        0x000015EA
    };

    static _CharacterInfo _character000015EB =
    {
        0x000015EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015EB,
        0x000015EB,
        0x000015EB
    };

    static _CharacterInfo _character000015EC =
    {
        0x000015EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015EC,
        0x000015EC,
        0x000015EC
    };

    static _CharacterInfo _character000015ED =
    {
        0x000015ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015ED,
        0x000015ED,
        0x000015ED
    };

    static _CharacterInfo _character000015EE =
    {
        0x000015EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015EE,
        0x000015EE,
        0x000015EE
    };

    static _CharacterInfo _character000015EF =
    {
        0x000015EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015EF,
        0x000015EF,
        0x000015EF
    };

    static _CharacterInfo _character000015F0 =
    {
        0x000015F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F0,
        0x000015F0,
        0x000015F0
    };

    static _CharacterInfo _character000015F1 =
    {
        0x000015F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F1,
        0x000015F1,
        0x000015F1
    };

    static _CharacterInfo _character000015F2 =
    {
        0x000015F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F2,
        0x000015F2,
        0x000015F2
    };

    static _CharacterInfo _character000015F3 =
    {
        0x000015F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F3,
        0x000015F3,
        0x000015F3
    };

    static _CharacterInfo _character000015F4 =
    {
        0x000015F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F4,
        0x000015F4,
        0x000015F4
    };

    static _CharacterInfo _character000015F5 =
    {
        0x000015F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F5,
        0x000015F5,
        0x000015F5
    };

    static _CharacterInfo _character000015F6 =
    {
        0x000015F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F6,
        0x000015F6,
        0x000015F6
    };

    static _CharacterInfo _character000015F7 =
    {
        0x000015F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F7,
        0x000015F7,
        0x000015F7
    };

    static _CharacterInfo _character000015F8 =
    {
        0x000015F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F8,
        0x000015F8,
        0x000015F8
    };

    static _CharacterInfo _character000015F9 =
    {
        0x000015F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015F9,
        0x000015F9,
        0x000015F9
    };

    static _CharacterInfo _character000015FA =
    {
        0x000015FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FA,
        0x000015FA,
        0x000015FA
    };

    static _CharacterInfo _character000015FB =
    {
        0x000015FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FB,
        0x000015FB,
        0x000015FB
    };

    static _CharacterInfo _character000015FC =
    {
        0x000015FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FC,
        0x000015FC,
        0x000015FC
    };

    static _CharacterInfo _character000015FD =
    {
        0x000015FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FD,
        0x000015FD,
        0x000015FD
    };

    static _CharacterInfo _character000015FE =
    {
        0x000015FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FE,
        0x000015FE,
        0x000015FE
    };

    static _CharacterInfo _character000015FF =
    {
        0x000015FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000015FF,
        0x000015FF,
        0x000015FF
    };

    static _CharacterInfo _character00001600 =
    {
        0x00001600,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001600,
        0x00001600,
        0x00001600
    };

    static _CharacterInfo _character00001601 =
    {
        0x00001601,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001601,
        0x00001601,
        0x00001601
    };

    static _CharacterInfo _character00001602 =
    {
        0x00001602,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001602,
        0x00001602,
        0x00001602
    };

    static _CharacterInfo _character00001603 =
    {
        0x00001603,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001603,
        0x00001603,
        0x00001603
    };

    static _CharacterInfo _character00001604 =
    {
        0x00001604,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001604,
        0x00001604,
        0x00001604
    };

    static _CharacterInfo _character00001605 =
    {
        0x00001605,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001605,
        0x00001605,
        0x00001605
    };

    static _CharacterInfo _character00001606 =
    {
        0x00001606,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001606,
        0x00001606,
        0x00001606
    };

    static _CharacterInfo _character00001607 =
    {
        0x00001607,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001607,
        0x00001607,
        0x00001607
    };

    static _CharacterInfo _character00001608 =
    {
        0x00001608,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001608,
        0x00001608,
        0x00001608
    };

    static _CharacterInfo _character00001609 =
    {
        0x00001609,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001609,
        0x00001609,
        0x00001609
    };

    static _CharacterInfo _character0000160A =
    {
        0x0000160A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160A,
        0x0000160A,
        0x0000160A
    };

    static _CharacterInfo _character0000160B =
    {
        0x0000160B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160B,
        0x0000160B,
        0x0000160B
    };

    static _CharacterInfo _character0000160C =
    {
        0x0000160C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160C,
        0x0000160C,
        0x0000160C
    };

    static _CharacterInfo _character0000160D =
    {
        0x0000160D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160D,
        0x0000160D,
        0x0000160D
    };

    static _CharacterInfo _character0000160E =
    {
        0x0000160E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160E,
        0x0000160E,
        0x0000160E
    };

    static _CharacterInfo _character0000160F =
    {
        0x0000160F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000160F,
        0x0000160F,
        0x0000160F
    };

    static _CharacterInfo _character00001610 =
    {
        0x00001610,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001610,
        0x00001610,
        0x00001610
    };

    static _CharacterInfo _character00001611 =
    {
        0x00001611,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001611,
        0x00001611,
        0x00001611
    };

    static _CharacterInfo _character00001612 =
    {
        0x00001612,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001612,
        0x00001612,
        0x00001612
    };

    static _CharacterInfo _character00001613 =
    {
        0x00001613,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001613,
        0x00001613,
        0x00001613
    };

    static _CharacterInfo _character00001614 =
    {
        0x00001614,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001614,
        0x00001614,
        0x00001614
    };

    static _CharacterInfo _character00001615 =
    {
        0x00001615,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001615,
        0x00001615,
        0x00001615
    };

    static _CharacterInfo _character00001616 =
    {
        0x00001616,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001616,
        0x00001616,
        0x00001616
    };

    static _CharacterInfo _character00001617 =
    {
        0x00001617,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001617,
        0x00001617,
        0x00001617
    };

    static _CharacterInfo _character00001618 =
    {
        0x00001618,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001618,
        0x00001618,
        0x00001618
    };

    static _CharacterInfo _character00001619 =
    {
        0x00001619,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001619,
        0x00001619,
        0x00001619
    };

    static _CharacterInfo _character0000161A =
    {
        0x0000161A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161A,
        0x0000161A,
        0x0000161A
    };

    static _CharacterInfo _character0000161B =
    {
        0x0000161B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161B,
        0x0000161B,
        0x0000161B
    };

    static _CharacterInfo _character0000161C =
    {
        0x0000161C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161C,
        0x0000161C,
        0x0000161C
    };

    static _CharacterInfo _character0000161D =
    {
        0x0000161D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161D,
        0x0000161D,
        0x0000161D
    };

    static _CharacterInfo _character0000161E =
    {
        0x0000161E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161E,
        0x0000161E,
        0x0000161E
    };

    static _CharacterInfo _character0000161F =
    {
        0x0000161F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000161F,
        0x0000161F,
        0x0000161F
    };

    static _CharacterInfo _character00001620 =
    {
        0x00001620,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001620,
        0x00001620,
        0x00001620
    };

    static _CharacterInfo _character00001621 =
    {
        0x00001621,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001621,
        0x00001621,
        0x00001621
    };

    static _CharacterInfo _character00001622 =
    {
        0x00001622,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001622,
        0x00001622,
        0x00001622
    };

    static _CharacterInfo _character00001623 =
    {
        0x00001623,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001623,
        0x00001623,
        0x00001623
    };

    static _CharacterInfo _character00001624 =
    {
        0x00001624,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001624,
        0x00001624,
        0x00001624
    };

    static _CharacterInfo _character00001625 =
    {
        0x00001625,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001625,
        0x00001625,
        0x00001625
    };

    static _CharacterInfo _character00001626 =
    {
        0x00001626,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001626,
        0x00001626,
        0x00001626
    };

    static _CharacterInfo _character00001627 =
    {
        0x00001627,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001627,
        0x00001627,
        0x00001627
    };

    static _CharacterInfo _character00001628 =
    {
        0x00001628,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001628,
        0x00001628,
        0x00001628
    };

    static _CharacterInfo _character00001629 =
    {
        0x00001629,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001629,
        0x00001629,
        0x00001629
    };

    static _CharacterInfo _character0000162A =
    {
        0x0000162A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162A,
        0x0000162A,
        0x0000162A
    };

    static _CharacterInfo _character0000162B =
    {
        0x0000162B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162B,
        0x0000162B,
        0x0000162B
    };

    static _CharacterInfo _character0000162C =
    {
        0x0000162C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162C,
        0x0000162C,
        0x0000162C
    };

    static _CharacterInfo _character0000162D =
    {
        0x0000162D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162D,
        0x0000162D,
        0x0000162D
    };

    static _CharacterInfo _character0000162E =
    {
        0x0000162E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162E,
        0x0000162E,
        0x0000162E
    };

    static _CharacterInfo _character0000162F =
    {
        0x0000162F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000162F,
        0x0000162F,
        0x0000162F
    };

    static _CharacterInfo _character00001630 =
    {
        0x00001630,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001630,
        0x00001630,
        0x00001630
    };

    static _CharacterInfo _character00001631 =
    {
        0x00001631,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001631,
        0x00001631,
        0x00001631
    };

    static _CharacterInfo _character00001632 =
    {
        0x00001632,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001632,
        0x00001632,
        0x00001632
    };

    static _CharacterInfo _character00001633 =
    {
        0x00001633,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001633,
        0x00001633,
        0x00001633
    };

    static _CharacterInfo _character00001634 =
    {
        0x00001634,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001634,
        0x00001634,
        0x00001634
    };

    static _CharacterInfo _character00001635 =
    {
        0x00001635,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001635,
        0x00001635,
        0x00001635
    };

    static _CharacterInfo _character00001636 =
    {
        0x00001636,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001636,
        0x00001636,
        0x00001636
    };

    static _CharacterInfo _character00001637 =
    {
        0x00001637,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001637,
        0x00001637,
        0x00001637
    };

    static _CharacterInfo _character00001638 =
    {
        0x00001638,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001638,
        0x00001638,
        0x00001638
    };

    static _CharacterInfo _character00001639 =
    {
        0x00001639,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001639,
        0x00001639,
        0x00001639
    };

    static _CharacterInfo _character0000163A =
    {
        0x0000163A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163A,
        0x0000163A,
        0x0000163A
    };

    static _CharacterInfo _character0000163B =
    {
        0x0000163B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163B,
        0x0000163B,
        0x0000163B
    };

    static _CharacterInfo _character0000163C =
    {
        0x0000163C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163C,
        0x0000163C,
        0x0000163C
    };

    static _CharacterInfo _character0000163D =
    {
        0x0000163D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163D,
        0x0000163D,
        0x0000163D
    };

    static _CharacterInfo _character0000163E =
    {
        0x0000163E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163E,
        0x0000163E,
        0x0000163E
    };

    static _CharacterInfo _character0000163F =
    {
        0x0000163F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000163F,
        0x0000163F,
        0x0000163F
    };

    static _CharacterInfo _character00001640 =
    {
        0x00001640,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001640,
        0x00001640,
        0x00001640
    };

    static _CharacterInfo _character00001641 =
    {
        0x00001641,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001641,
        0x00001641,
        0x00001641
    };

    static _CharacterInfo _character00001642 =
    {
        0x00001642,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001642,
        0x00001642,
        0x00001642
    };

    static _CharacterInfo _character00001643 =
    {
        0x00001643,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001643,
        0x00001643,
        0x00001643
    };

    static _CharacterInfo _character00001644 =
    {
        0x00001644,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001644,
        0x00001644,
        0x00001644
    };

    static _CharacterInfo _character00001645 =
    {
        0x00001645,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001645,
        0x00001645,
        0x00001645
    };

    static _CharacterInfo _character00001646 =
    {
        0x00001646,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001646,
        0x00001646,
        0x00001646
    };

    static _CharacterInfo _character00001647 =
    {
        0x00001647,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001647,
        0x00001647,
        0x00001647
    };

    static _CharacterInfo _character00001648 =
    {
        0x00001648,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001648,
        0x00001648,
        0x00001648
    };

    static _CharacterInfo _character00001649 =
    {
        0x00001649,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001649,
        0x00001649,
        0x00001649
    };

    static _CharacterInfo _character0000164A =
    {
        0x0000164A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164A,
        0x0000164A,
        0x0000164A
    };

    static _CharacterInfo _character0000164B =
    {
        0x0000164B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164B,
        0x0000164B,
        0x0000164B
    };

    static _CharacterInfo _character0000164C =
    {
        0x0000164C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164C,
        0x0000164C,
        0x0000164C
    };

    static _CharacterInfo _character0000164D =
    {
        0x0000164D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164D,
        0x0000164D,
        0x0000164D
    };

    static _CharacterInfo _character0000164E =
    {
        0x0000164E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164E,
        0x0000164E,
        0x0000164E
    };

    static _CharacterInfo _character0000164F =
    {
        0x0000164F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000164F,
        0x0000164F,
        0x0000164F
    };

    static _CharacterInfo _character00001650 =
    {
        0x00001650,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001650,
        0x00001650,
        0x00001650
    };

    static _CharacterInfo _character00001651 =
    {
        0x00001651,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001651,
        0x00001651,
        0x00001651
    };

    static _CharacterInfo _character00001652 =
    {
        0x00001652,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001652,
        0x00001652,
        0x00001652
    };

    static _CharacterInfo _character00001653 =
    {
        0x00001653,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001653,
        0x00001653,
        0x00001653
    };

    static _CharacterInfo _character00001654 =
    {
        0x00001654,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001654,
        0x00001654,
        0x00001654
    };

    static _CharacterInfo _character00001655 =
    {
        0x00001655,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001655,
        0x00001655,
        0x00001655
    };

    static _CharacterInfo _character00001656 =
    {
        0x00001656,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001656,
        0x00001656,
        0x00001656
    };

    static _CharacterInfo _character00001657 =
    {
        0x00001657,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001657,
        0x00001657,
        0x00001657
    };

    static _CharacterInfo _character00001658 =
    {
        0x00001658,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001658,
        0x00001658,
        0x00001658
    };

    static _CharacterInfo _character00001659 =
    {
        0x00001659,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001659,
        0x00001659,
        0x00001659
    };

    static _CharacterInfo _character0000165A =
    {
        0x0000165A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165A,
        0x0000165A,
        0x0000165A
    };

    static _CharacterInfo _character0000165B =
    {
        0x0000165B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165B,
        0x0000165B,
        0x0000165B
    };

    static _CharacterInfo _character0000165C =
    {
        0x0000165C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165C,
        0x0000165C,
        0x0000165C
    };

    static _CharacterInfo _character0000165D =
    {
        0x0000165D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165D,
        0x0000165D,
        0x0000165D
    };

    static _CharacterInfo _character0000165E =
    {
        0x0000165E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165E,
        0x0000165E,
        0x0000165E
    };

    static _CharacterInfo _character0000165F =
    {
        0x0000165F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000165F,
        0x0000165F,
        0x0000165F
    };

    static _CharacterInfo _character00001660 =
    {
        0x00001660,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001660,
        0x00001660,
        0x00001660
    };

    static _CharacterInfo _character00001661 =
    {
        0x00001661,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001661,
        0x00001661,
        0x00001661
    };

    static _CharacterInfo _character00001662 =
    {
        0x00001662,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001662,
        0x00001662,
        0x00001662
    };

    static _CharacterInfo _character00001663 =
    {
        0x00001663,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001663,
        0x00001663,
        0x00001663
    };

    static _CharacterInfo _character00001664 =
    {
        0x00001664,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001664,
        0x00001664,
        0x00001664
    };

    static _CharacterInfo _character00001665 =
    {
        0x00001665,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001665,
        0x00001665,
        0x00001665
    };

    static _CharacterInfo _character00001666 =
    {
        0x00001666,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001666,
        0x00001666,
        0x00001666
    };

    static _CharacterInfo _character00001667 =
    {
        0x00001667,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001667,
        0x00001667,
        0x00001667
    };

    static _CharacterInfo _character00001668 =
    {
        0x00001668,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001668,
        0x00001668,
        0x00001668
    };

    static _CharacterInfo _character00001669 =
    {
        0x00001669,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001669,
        0x00001669,
        0x00001669
    };

    static _CharacterInfo _character0000166A =
    {
        0x0000166A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166A,
        0x0000166A,
        0x0000166A
    };

    static _CharacterInfo _character0000166B =
    {
        0x0000166B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166B,
        0x0000166B,
        0x0000166B
    };

    static _CharacterInfo _character0000166C =
    {
        0x0000166C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166C,
        0x0000166C,
        0x0000166C
    };

    static _CharacterInfo _character0000166D =
    {
        0x0000166D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166D,
        0x0000166D,
        0x0000166D
    };

    static _CharacterInfo _character0000166E =
    {
        0x0000166E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166E,
        0x0000166E,
        0x0000166E
    };

    static _CharacterInfo _character0000166F =
    {
        0x0000166F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000166F,
        0x0000166F,
        0x0000166F
    };

    static _CharacterInfo _character00001670 =
    {
        0x00001670,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001670,
        0x00001670,
        0x00001670
    };

    static _CharacterInfo _character00001671 =
    {
        0x00001671,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001671,
        0x00001671,
        0x00001671
    };

    static _CharacterInfo _character00001672 =
    {
        0x00001672,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001672,
        0x00001672,
        0x00001672
    };

    static _CharacterInfo _character00001673 =
    {
        0x00001673,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001673,
        0x00001673,
        0x00001673
    };

    static _CharacterInfo _character00001674 =
    {
        0x00001674,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001674,
        0x00001674,
        0x00001674
    };

    static _CharacterInfo _character00001675 =
    {
        0x00001675,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001675,
        0x00001675,
        0x00001675
    };

    static _CharacterInfo _character00001676 =
    {
        0x00001676,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001676,
        0x00001676,
        0x00001676
    };

    static _CharacterInfo _character00001680 =
    {
        0x00001680,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001680,
        0x00001680,
        0x00001680
    };

    static _CharacterInfo _character00001681 =
    {
        0x00001681,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001681,
        0x00001681,
        0x00001681
    };

    static _CharacterInfo _character00001682 =
    {
        0x00001682,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001682,
        0x00001682,
        0x00001682
    };

    static _CharacterInfo _character00001683 =
    {
        0x00001683,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001683,
        0x00001683,
        0x00001683
    };

    static _CharacterInfo _character00001684 =
    {
        0x00001684,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001684,
        0x00001684,
        0x00001684
    };

    static _CharacterInfo _character00001685 =
    {
        0x00001685,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001685,
        0x00001685,
        0x00001685
    };

    static _CharacterInfo _character00001686 =
    {
        0x00001686,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001686,
        0x00001686,
        0x00001686
    };

    static _CharacterInfo _character00001687 =
    {
        0x00001687,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001687,
        0x00001687,
        0x00001687
    };

    static _CharacterInfo _character00001688 =
    {
        0x00001688,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001688,
        0x00001688,
        0x00001688
    };

    static _CharacterInfo _character00001689 =
    {
        0x00001689,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001689,
        0x00001689,
        0x00001689
    };

    static _CharacterInfo _character0000168A =
    {
        0x0000168A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168A,
        0x0000168A,
        0x0000168A
    };

    static _CharacterInfo _character0000168B =
    {
        0x0000168B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168B,
        0x0000168B,
        0x0000168B
    };

    static _CharacterInfo _character0000168C =
    {
        0x0000168C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168C,
        0x0000168C,
        0x0000168C
    };

    static _CharacterInfo _character0000168D =
    {
        0x0000168D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168D,
        0x0000168D,
        0x0000168D
    };

    static _CharacterInfo _character0000168E =
    {
        0x0000168E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168E,
        0x0000168E,
        0x0000168E
    };

    static _CharacterInfo _character0000168F =
    {
        0x0000168F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000168F,
        0x0000168F,
        0x0000168F
    };

    static _CharacterInfo _character00001690 =
    {
        0x00001690,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001690,
        0x00001690,
        0x00001690
    };

    static _CharacterInfo _character00001691 =
    {
        0x00001691,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001691,
        0x00001691,
        0x00001691
    };

    static _CharacterInfo _character00001692 =
    {
        0x00001692,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001692,
        0x00001692,
        0x00001692
    };

    static _CharacterInfo _character00001693 =
    {
        0x00001693,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001693,
        0x00001693,
        0x00001693
    };

    static _CharacterInfo _character00001694 =
    {
        0x00001694,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001694,
        0x00001694,
        0x00001694
    };

    static _CharacterInfo _character00001695 =
    {
        0x00001695,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001695,
        0x00001695,
        0x00001695
    };

    static _CharacterInfo _character00001696 =
    {
        0x00001696,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001696,
        0x00001696,
        0x00001696
    };

    static _CharacterInfo _character00001697 =
    {
        0x00001697,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001697,
        0x00001697,
        0x00001697
    };

    static _CharacterInfo _character00001698 =
    {
        0x00001698,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001698,
        0x00001698,
        0x00001698
    };

    static _CharacterInfo _character00001699 =
    {
        0x00001699,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001699,
        0x00001699,
        0x00001699
    };

    static _CharacterInfo _character0000169A =
    {
        0x0000169A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000169A,
        0x0000169A,
        0x0000169A
    };

    static _CharacterInfo _character0000169B =
    {
        0x0000169B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000169B,
        0x0000169B,
        0x0000169B
    };

    static _CharacterInfo _character0000169C =
    {
        0x0000169C,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000169C,
        0x0000169C,
        0x0000169C
    };

    static _CharacterInfo _character000016A0 =
    {
        0x000016A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A0,
        0x000016A0,
        0x000016A0
    };

    static _CharacterInfo _character000016A1 =
    {
        0x000016A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A1,
        0x000016A1,
        0x000016A1
    };

    static _CharacterInfo _character000016A2 =
    {
        0x000016A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A2,
        0x000016A2,
        0x000016A2
    };

    static _CharacterInfo _character000016A3 =
    {
        0x000016A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A3,
        0x000016A3,
        0x000016A3
    };

    static _CharacterInfo _character000016A4 =
    {
        0x000016A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A4,
        0x000016A4,
        0x000016A4
    };

    static _CharacterInfo _character000016A5 =
    {
        0x000016A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A5,
        0x000016A5,
        0x000016A5
    };

    static _CharacterInfo _character000016A6 =
    {
        0x000016A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A6,
        0x000016A6,
        0x000016A6
    };

    static _CharacterInfo _character000016A7 =
    {
        0x000016A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A7,
        0x000016A7,
        0x000016A7
    };

    static _CharacterInfo _character000016A8 =
    {
        0x000016A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A8,
        0x000016A8,
        0x000016A8
    };

    static _CharacterInfo _character000016A9 =
    {
        0x000016A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016A9,
        0x000016A9,
        0x000016A9
    };

    static _CharacterInfo _character000016AA =
    {
        0x000016AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AA,
        0x000016AA,
        0x000016AA
    };

    static _CharacterInfo _character000016AB =
    {
        0x000016AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AB,
        0x000016AB,
        0x000016AB
    };

    static _CharacterInfo _character000016AC =
    {
        0x000016AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AC,
        0x000016AC,
        0x000016AC
    };

    static _CharacterInfo _character000016AD =
    {
        0x000016AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AD,
        0x000016AD,
        0x000016AD
    };

    static _CharacterInfo _character000016AE =
    {
        0x000016AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AE,
        0x000016AE,
        0x000016AE
    };

    static _CharacterInfo _character000016AF =
    {
        0x000016AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016AF,
        0x000016AF,
        0x000016AF
    };

    static _CharacterInfo _character000016B0 =
    {
        0x000016B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B0,
        0x000016B0,
        0x000016B0
    };

    static _CharacterInfo _character000016B1 =
    {
        0x000016B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B1,
        0x000016B1,
        0x000016B1
    };

    static _CharacterInfo _character000016B2 =
    {
        0x000016B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B2,
        0x000016B2,
        0x000016B2
    };

    static _CharacterInfo _character000016B3 =
    {
        0x000016B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B3,
        0x000016B3,
        0x000016B3
    };

    static _CharacterInfo _character000016B4 =
    {
        0x000016B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B4,
        0x000016B4,
        0x000016B4
    };

    static _CharacterInfo _character000016B5 =
    {
        0x000016B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B5,
        0x000016B5,
        0x000016B5
    };

    static _CharacterInfo _character000016B6 =
    {
        0x000016B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B6,
        0x000016B6,
        0x000016B6
    };

    static _CharacterInfo _character000016B7 =
    {
        0x000016B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B7,
        0x000016B7,
        0x000016B7
    };

    static _CharacterInfo _character000016B8 =
    {
        0x000016B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B8,
        0x000016B8,
        0x000016B8
    };

    static _CharacterInfo _character000016B9 =
    {
        0x000016B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016B9,
        0x000016B9,
        0x000016B9
    };

    static _CharacterInfo _character000016BA =
    {
        0x000016BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BA,
        0x000016BA,
        0x000016BA
    };

    static _CharacterInfo _character000016BB =
    {
        0x000016BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BB,
        0x000016BB,
        0x000016BB
    };

    static _CharacterInfo _character000016BC =
    {
        0x000016BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BC,
        0x000016BC,
        0x000016BC
    };

    static _CharacterInfo _character000016BD =
    {
        0x000016BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BD,
        0x000016BD,
        0x000016BD
    };

    static _CharacterInfo _character000016BE =
    {
        0x000016BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BE,
        0x000016BE,
        0x000016BE
    };

    static _CharacterInfo _character000016BF =
    {
        0x000016BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016BF,
        0x000016BF,
        0x000016BF
    };

    static _CharacterInfo _character000016C0 =
    {
        0x000016C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C0,
        0x000016C0,
        0x000016C0
    };

    static _CharacterInfo _character000016C1 =
    {
        0x000016C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C1,
        0x000016C1,
        0x000016C1
    };

    static _CharacterInfo _character000016C2 =
    {
        0x000016C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C2,
        0x000016C2,
        0x000016C2
    };

    static _CharacterInfo _character000016C3 =
    {
        0x000016C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C3,
        0x000016C3,
        0x000016C3
    };

    static _CharacterInfo _character000016C4 =
    {
        0x000016C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C4,
        0x000016C4,
        0x000016C4
    };

    static _CharacterInfo _character000016C5 =
    {
        0x000016C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C5,
        0x000016C5,
        0x000016C5
    };

    static _CharacterInfo _character000016C6 =
    {
        0x000016C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C6,
        0x000016C6,
        0x000016C6
    };

    static _CharacterInfo _character000016C7 =
    {
        0x000016C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C7,
        0x000016C7,
        0x000016C7
    };

    static _CharacterInfo _character000016C8 =
    {
        0x000016C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C8,
        0x000016C8,
        0x000016C8
    };

    static _CharacterInfo _character000016C9 =
    {
        0x000016C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016C9,
        0x000016C9,
        0x000016C9
    };

    static _CharacterInfo _character000016CA =
    {
        0x000016CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CA,
        0x000016CA,
        0x000016CA
    };

    static _CharacterInfo _character000016CB =
    {
        0x000016CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CB,
        0x000016CB,
        0x000016CB
    };

    static _CharacterInfo _character000016CC =
    {
        0x000016CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CC,
        0x000016CC,
        0x000016CC
    };

    static _CharacterInfo _character000016CD =
    {
        0x000016CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CD,
        0x000016CD,
        0x000016CD
    };

    static _CharacterInfo _character000016CE =
    {
        0x000016CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CE,
        0x000016CE,
        0x000016CE
    };

    static _CharacterInfo _character000016CF =
    {
        0x000016CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016CF,
        0x000016CF,
        0x000016CF
    };

    static _CharacterInfo _character000016D0 =
    {
        0x000016D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D0,
        0x000016D0,
        0x000016D0
    };

    static _CharacterInfo _character000016D1 =
    {
        0x000016D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D1,
        0x000016D1,
        0x000016D1
    };

    static _CharacterInfo _character000016D2 =
    {
        0x000016D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D2,
        0x000016D2,
        0x000016D2
    };

    static _CharacterInfo _character000016D3 =
    {
        0x000016D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D3,
        0x000016D3,
        0x000016D3
    };

    static _CharacterInfo _character000016D4 =
    {
        0x000016D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D4,
        0x000016D4,
        0x000016D4
    };

    static _CharacterInfo _character000016D5 =
    {
        0x000016D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D5,
        0x000016D5,
        0x000016D5
    };

    static _CharacterInfo _character000016D6 =
    {
        0x000016D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D6,
        0x000016D6,
        0x000016D6
    };

    static _CharacterInfo _character000016D7 =
    {
        0x000016D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D7,
        0x000016D7,
        0x000016D7
    };

    static _CharacterInfo _character000016D8 =
    {
        0x000016D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D8,
        0x000016D8,
        0x000016D8
    };

    static _CharacterInfo _character000016D9 =
    {
        0x000016D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016D9,
        0x000016D9,
        0x000016D9
    };

    static _CharacterInfo _character000016DA =
    {
        0x000016DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DA,
        0x000016DA,
        0x000016DA
    };

    static _CharacterInfo _character000016DB =
    {
        0x000016DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DB,
        0x000016DB,
        0x000016DB
    };

    static _CharacterInfo _character000016DC =
    {
        0x000016DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DC,
        0x000016DC,
        0x000016DC
    };

    static _CharacterInfo _character000016DD =
    {
        0x000016DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DD,
        0x000016DD,
        0x000016DD
    };

    static _CharacterInfo _character000016DE =
    {
        0x000016DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DE,
        0x000016DE,
        0x000016DE
    };

    static _CharacterInfo _character000016DF =
    {
        0x000016DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016DF,
        0x000016DF,
        0x000016DF
    };

    static _CharacterInfo _character000016E0 =
    {
        0x000016E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E0,
        0x000016E0,
        0x000016E0
    };

    static _CharacterInfo _character000016E1 =
    {
        0x000016E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E1,
        0x000016E1,
        0x000016E1
    };

    static _CharacterInfo _character000016E2 =
    {
        0x000016E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E2,
        0x000016E2,
        0x000016E2
    };

    static _CharacterInfo _character000016E3 =
    {
        0x000016E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E3,
        0x000016E3,
        0x000016E3
    };

    static _CharacterInfo _character000016E4 =
    {
        0x000016E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E4,
        0x000016E4,
        0x000016E4
    };

    static _CharacterInfo _character000016E5 =
    {
        0x000016E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E5,
        0x000016E5,
        0x000016E5
    };

    static _CharacterInfo _character000016E6 =
    {
        0x000016E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E6,
        0x000016E6,
        0x000016E6
    };

    static _CharacterInfo _character000016E7 =
    {
        0x000016E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E7,
        0x000016E7,
        0x000016E7
    };

    static _CharacterInfo _character000016E8 =
    {
        0x000016E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E8,
        0x000016E8,
        0x000016E8
    };

    static _CharacterInfo _character000016E9 =
    {
        0x000016E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016E9,
        0x000016E9,
        0x000016E9
    };

    static _CharacterInfo _character000016EA =
    {
        0x000016EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016EA,
        0x000016EA,
        0x000016EA
    };

    static _CharacterInfo _character000016EB =
    {
        0x000016EB,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016EB,
        0x000016EB,
        0x000016EB
    };

    static _CharacterInfo _character000016EC =
    {
        0x000016EC,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016EC,
        0x000016EC,
        0x000016EC
    };

    static _CharacterInfo _character000016ED =
    {
        0x000016ED,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000016ED,
        0x000016ED,
        0x000016ED
    };

    static _CharacterInfo _character000016EE =
    {
        0x000016EE,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        17,
        1,
        false,
        0x000016EE,
        0x000016EE,
        0x000016EE
    };

    static _CharacterInfo _character000016EF =
    {
        0x000016EF,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        18,
        1,
        false,
        0x000016EF,
        0x000016EF,
        0x000016EF
    };

    static _CharacterInfo _character000016F0 =
    {
        0x000016F0,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        19,
        1,
        false,
        0x000016F0,
        0x000016F0,
        0x000016F0
    };

    static _CharacterInfo _character00001700 =
    {
        0x00001700,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001700,
        0x00001700,
        0x00001700
    };

    static _CharacterInfo _character00001701 =
    {
        0x00001701,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001701,
        0x00001701,
        0x00001701
    };

    static _CharacterInfo _character00001702 =
    {
        0x00001702,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001702,
        0x00001702,
        0x00001702
    };

    static _CharacterInfo _character00001703 =
    {
        0x00001703,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001703,
        0x00001703,
        0x00001703
    };

    static _CharacterInfo _character00001704 =
    {
        0x00001704,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001704,
        0x00001704,
        0x00001704
    };

    static _CharacterInfo _character00001705 =
    {
        0x00001705,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001705,
        0x00001705,
        0x00001705
    };

    static _CharacterInfo _character00001706 =
    {
        0x00001706,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001706,
        0x00001706,
        0x00001706
    };

    static _CharacterInfo _character00001707 =
    {
        0x00001707,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001707,
        0x00001707,
        0x00001707
    };

    static _CharacterInfo _character00001708 =
    {
        0x00001708,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001708,
        0x00001708,
        0x00001708
    };

    static _CharacterInfo _character00001709 =
    {
        0x00001709,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001709,
        0x00001709,
        0x00001709
    };

    static _CharacterInfo _character0000170A =
    {
        0x0000170A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000170A,
        0x0000170A,
        0x0000170A
    };

    static _CharacterInfo _character0000170B =
    {
        0x0000170B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000170B,
        0x0000170B,
        0x0000170B
    };

    static _CharacterInfo _character0000170C =
    {
        0x0000170C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000170C,
        0x0000170C,
        0x0000170C
    };

    static _CharacterInfo _character0000170E =
    {
        0x0000170E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000170E,
        0x0000170E,
        0x0000170E
    };

    static _CharacterInfo _character0000170F =
    {
        0x0000170F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000170F,
        0x0000170F,
        0x0000170F
    };

    static _CharacterInfo _character00001710 =
    {
        0x00001710,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001710,
        0x00001710,
        0x00001710
    };

    static _CharacterInfo _character00001711 =
    {
        0x00001711,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001711,
        0x00001711,
        0x00001711
    };

    static _CharacterInfo _character00001712 =
    {
        0x00001712,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001712,
        0x00001712,
        0x00001712
    };

    static _CharacterInfo _character00001713 =
    {
        0x00001713,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001713,
        0x00001713,
        0x00001713
    };

    static _CharacterInfo _character00001714 =
    {
        0x00001714,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001714,
        0x00001714,
        0x00001714
    };

    static _CharacterInfo _character00001720 =
    {
        0x00001720,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001720,
        0x00001720,
        0x00001720
    };

    static _CharacterInfo _character00001721 =
    {
        0x00001721,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001721,
        0x00001721,
        0x00001721
    };

    static _CharacterInfo _character00001722 =
    {
        0x00001722,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001722,
        0x00001722,
        0x00001722
    };

    static _CharacterInfo _character00001723 =
    {
        0x00001723,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001723,
        0x00001723,
        0x00001723
    };

    static _CharacterInfo _character00001724 =
    {
        0x00001724,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001724,
        0x00001724,
        0x00001724
    };

    static _CharacterInfo _character00001725 =
    {
        0x00001725,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001725,
        0x00001725,
        0x00001725
    };

    static _CharacterInfo _character00001726 =
    {
        0x00001726,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001726,
        0x00001726,
        0x00001726
    };

    static _CharacterInfo _character00001727 =
    {
        0x00001727,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001727,
        0x00001727,
        0x00001727
    };

    static _CharacterInfo _character00001728 =
    {
        0x00001728,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001728,
        0x00001728,
        0x00001728
    };

    static _CharacterInfo _character00001729 =
    {
        0x00001729,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001729,
        0x00001729,
        0x00001729
    };

    static _CharacterInfo _character0000172A =
    {
        0x0000172A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172A,
        0x0000172A,
        0x0000172A
    };

    static _CharacterInfo _character0000172B =
    {
        0x0000172B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172B,
        0x0000172B,
        0x0000172B
    };

    static _CharacterInfo _character0000172C =
    {
        0x0000172C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172C,
        0x0000172C,
        0x0000172C
    };

    static _CharacterInfo _character0000172D =
    {
        0x0000172D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172D,
        0x0000172D,
        0x0000172D
    };

    static _CharacterInfo _character0000172E =
    {
        0x0000172E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172E,
        0x0000172E,
        0x0000172E
    };

    static _CharacterInfo _character0000172F =
    {
        0x0000172F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000172F,
        0x0000172F,
        0x0000172F
    };

    static _CharacterInfo _character00001730 =
    {
        0x00001730,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001730,
        0x00001730,
        0x00001730
    };

    static _CharacterInfo _character00001731 =
    {
        0x00001731,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001731,
        0x00001731,
        0x00001731
    };

    static _CharacterInfo _character00001732 =
    {
        0x00001732,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001732,
        0x00001732,
        0x00001732
    };

    static _CharacterInfo _character00001733 =
    {
        0x00001733,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001733,
        0x00001733,
        0x00001733
    };

    static _CharacterInfo _character00001734 =
    {
        0x00001734,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001734,
        0x00001734,
        0x00001734
    };

    static _CharacterInfo _character00001735 =
    {
        0x00001735,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001735,
        0x00001735,
        0x00001735
    };

    static _CharacterInfo _character00001736 =
    {
        0x00001736,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001736,
        0x00001736,
        0x00001736
    };

    static _CharacterInfo _character00001740 =
    {
        0x00001740,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001740,
        0x00001740,
        0x00001740
    };

    static _CharacterInfo _character00001741 =
    {
        0x00001741,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001741,
        0x00001741,
        0x00001741
    };

    static _CharacterInfo _character00001742 =
    {
        0x00001742,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001742,
        0x00001742,
        0x00001742
    };

    static _CharacterInfo _character00001743 =
    {
        0x00001743,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001743,
        0x00001743,
        0x00001743
    };

    static _CharacterInfo _character00001744 =
    {
        0x00001744,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001744,
        0x00001744,
        0x00001744
    };

    static _CharacterInfo _character00001745 =
    {
        0x00001745,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001745,
        0x00001745,
        0x00001745
    };

    static _CharacterInfo _character00001746 =
    {
        0x00001746,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001746,
        0x00001746,
        0x00001746
    };

    static _CharacterInfo _character00001747 =
    {
        0x00001747,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001747,
        0x00001747,
        0x00001747
    };

    static _CharacterInfo _character00001748 =
    {
        0x00001748,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001748,
        0x00001748,
        0x00001748
    };

    static _CharacterInfo _character00001749 =
    {
        0x00001749,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001749,
        0x00001749,
        0x00001749
    };

    static _CharacterInfo _character0000174A =
    {
        0x0000174A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174A,
        0x0000174A,
        0x0000174A
    };

    static _CharacterInfo _character0000174B =
    {
        0x0000174B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174B,
        0x0000174B,
        0x0000174B
    };

    static _CharacterInfo _character0000174C =
    {
        0x0000174C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174C,
        0x0000174C,
        0x0000174C
    };

    static _CharacterInfo _character0000174D =
    {
        0x0000174D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174D,
        0x0000174D,
        0x0000174D
    };

    static _CharacterInfo _character0000174E =
    {
        0x0000174E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174E,
        0x0000174E,
        0x0000174E
    };

    static _CharacterInfo _character0000174F =
    {
        0x0000174F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000174F,
        0x0000174F,
        0x0000174F
    };

    static _CharacterInfo _character00001750 =
    {
        0x00001750,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001750,
        0x00001750,
        0x00001750
    };

    static _CharacterInfo _character00001751 =
    {
        0x00001751,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001751,
        0x00001751,
        0x00001751
    };

    static _CharacterInfo _character00001752 =
    {
        0x00001752,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001752,
        0x00001752,
        0x00001752
    };

    static _CharacterInfo _character00001753 =
    {
        0x00001753,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001753,
        0x00001753,
        0x00001753
    };

    static _CharacterInfo _character00001760 =
    {
        0x00001760,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001760,
        0x00001760,
        0x00001760
    };

    static _CharacterInfo _character00001761 =
    {
        0x00001761,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001761,
        0x00001761,
        0x00001761
    };

    static _CharacterInfo _character00001762 =
    {
        0x00001762,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001762,
        0x00001762,
        0x00001762
    };

    static _CharacterInfo _character00001763 =
    {
        0x00001763,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001763,
        0x00001763,
        0x00001763
    };

    static _CharacterInfo _character00001764 =
    {
        0x00001764,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001764,
        0x00001764,
        0x00001764
    };

    static _CharacterInfo _character00001765 =
    {
        0x00001765,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001765,
        0x00001765,
        0x00001765
    };

    static _CharacterInfo _character00001766 =
    {
        0x00001766,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001766,
        0x00001766,
        0x00001766
    };

    static _CharacterInfo _character00001767 =
    {
        0x00001767,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001767,
        0x00001767,
        0x00001767
    };

    static _CharacterInfo _character00001768 =
    {
        0x00001768,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001768,
        0x00001768,
        0x00001768
    };

    static _CharacterInfo _character00001769 =
    {
        0x00001769,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001769,
        0x00001769,
        0x00001769
    };

    static _CharacterInfo _character0000176A =
    {
        0x0000176A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000176A,
        0x0000176A,
        0x0000176A
    };

    static _CharacterInfo _character0000176B =
    {
        0x0000176B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000176B,
        0x0000176B,
        0x0000176B
    };

    static _CharacterInfo _character0000176C =
    {
        0x0000176C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000176C,
        0x0000176C,
        0x0000176C
    };

    static _CharacterInfo _character0000176E =
    {
        0x0000176E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000176E,
        0x0000176E,
        0x0000176E
    };

    static _CharacterInfo _character0000176F =
    {
        0x0000176F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000176F,
        0x0000176F,
        0x0000176F
    };

    static _CharacterInfo _character00001770 =
    {
        0x00001770,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001770,
        0x00001770,
        0x00001770
    };

    static _CharacterInfo _character00001772 =
    {
        0x00001772,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001772,
        0x00001772,
        0x00001772
    };

    static _CharacterInfo _character00001773 =
    {
        0x00001773,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001773,
        0x00001773,
        0x00001773
    };

    static _CharacterInfo _character00001780 =
    {
        0x00001780,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001780,
        0x00001780,
        0x00001780
    };

    static _CharacterInfo _character00001781 =
    {
        0x00001781,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001781,
        0x00001781,
        0x00001781
    };

    static _CharacterInfo _character00001782 =
    {
        0x00001782,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001782,
        0x00001782,
        0x00001782
    };

    static _CharacterInfo _character00001783 =
    {
        0x00001783,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001783,
        0x00001783,
        0x00001783
    };

    static _CharacterInfo _character00001784 =
    {
        0x00001784,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001784,
        0x00001784,
        0x00001784
    };

    static _CharacterInfo _character00001785 =
    {
        0x00001785,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001785,
        0x00001785,
        0x00001785
    };

    static _CharacterInfo _character00001786 =
    {
        0x00001786,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001786,
        0x00001786,
        0x00001786
    };

    static _CharacterInfo _character00001787 =
    {
        0x00001787,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001787,
        0x00001787,
        0x00001787
    };

    static _CharacterInfo _character00001788 =
    {
        0x00001788,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001788,
        0x00001788,
        0x00001788
    };

    static _CharacterInfo _character00001789 =
    {
        0x00001789,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001789,
        0x00001789,
        0x00001789
    };

    static _CharacterInfo _character0000178A =
    {
        0x0000178A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178A,
        0x0000178A,
        0x0000178A
    };

    static _CharacterInfo _character0000178B =
    {
        0x0000178B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178B,
        0x0000178B,
        0x0000178B
    };

    static _CharacterInfo _character0000178C =
    {
        0x0000178C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178C,
        0x0000178C,
        0x0000178C
    };

    static _CharacterInfo _character0000178D =
    {
        0x0000178D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178D,
        0x0000178D,
        0x0000178D
    };

    static _CharacterInfo _character0000178E =
    {
        0x0000178E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178E,
        0x0000178E,
        0x0000178E
    };

    static _CharacterInfo _character0000178F =
    {
        0x0000178F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000178F,
        0x0000178F,
        0x0000178F
    };

    static _CharacterInfo _character00001790 =
    {
        0x00001790,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001790,
        0x00001790,
        0x00001790
    };

    static _CharacterInfo _character00001791 =
    {
        0x00001791,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001791,
        0x00001791,
        0x00001791
    };

    static _CharacterInfo _character00001792 =
    {
        0x00001792,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001792,
        0x00001792,
        0x00001792
    };

    static _CharacterInfo _character00001793 =
    {
        0x00001793,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001793,
        0x00001793,
        0x00001793
    };

    static _CharacterInfo _character00001794 =
    {
        0x00001794,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001794,
        0x00001794,
        0x00001794
    };

    static _CharacterInfo _character00001795 =
    {
        0x00001795,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001795,
        0x00001795,
        0x00001795
    };

    static _CharacterInfo _character00001796 =
    {
        0x00001796,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001796,
        0x00001796,
        0x00001796
    };

    static _CharacterInfo _character00001797 =
    {
        0x00001797,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001797,
        0x00001797,
        0x00001797
    };

    static _CharacterInfo _character00001798 =
    {
        0x00001798,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001798,
        0x00001798,
        0x00001798
    };

    static _CharacterInfo _character00001799 =
    {
        0x00001799,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001799,
        0x00001799,
        0x00001799
    };

    static _CharacterInfo _character0000179A =
    {
        0x0000179A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179A,
        0x0000179A,
        0x0000179A
    };

    static _CharacterInfo _character0000179B =
    {
        0x0000179B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179B,
        0x0000179B,
        0x0000179B
    };

    static _CharacterInfo _character0000179C =
    {
        0x0000179C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179C,
        0x0000179C,
        0x0000179C
    };

    static _CharacterInfo _character0000179D =
    {
        0x0000179D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179D,
        0x0000179D,
        0x0000179D
    };

    static _CharacterInfo _character0000179E =
    {
        0x0000179E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179E,
        0x0000179E,
        0x0000179E
    };

    static _CharacterInfo _character0000179F =
    {
        0x0000179F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000179F,
        0x0000179F,
        0x0000179F
    };

    static _CharacterInfo _character000017A0 =
    {
        0x000017A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A0,
        0x000017A0,
        0x000017A0
    };

    static _CharacterInfo _character000017A1 =
    {
        0x000017A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A1,
        0x000017A1,
        0x000017A1
    };

    static _CharacterInfo _character000017A2 =
    {
        0x000017A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A2,
        0x000017A2,
        0x000017A2
    };

    static _CharacterInfo _character000017A3 =
    {
        0x000017A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A3,
        0x000017A3,
        0x000017A3
    };

    static _CharacterInfo _character000017A4 =
    {
        0x000017A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A4,
        0x000017A4,
        0x000017A4
    };

    static _CharacterInfo _character000017A5 =
    {
        0x000017A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A5,
        0x000017A5,
        0x000017A5
    };

    static _CharacterInfo _character000017A6 =
    {
        0x000017A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A6,
        0x000017A6,
        0x000017A6
    };

    static _CharacterInfo _character000017A7 =
    {
        0x000017A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A7,
        0x000017A7,
        0x000017A7
    };

    static _CharacterInfo _character000017A8 =
    {
        0x000017A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A8,
        0x000017A8,
        0x000017A8
    };

    static _CharacterInfo _character000017A9 =
    {
        0x000017A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017A9,
        0x000017A9,
        0x000017A9
    };

    static _CharacterInfo _character000017AA =
    {
        0x000017AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AA,
        0x000017AA,
        0x000017AA
    };

    static _CharacterInfo _character000017AB =
    {
        0x000017AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AB,
        0x000017AB,
        0x000017AB
    };

    static _CharacterInfo _character000017AC =
    {
        0x000017AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AC,
        0x000017AC,
        0x000017AC
    };

    static _CharacterInfo _character000017AD =
    {
        0x000017AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AD,
        0x000017AD,
        0x000017AD
    };

    static _CharacterInfo _character000017AE =
    {
        0x000017AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AE,
        0x000017AE,
        0x000017AE
    };

    static _CharacterInfo _character000017AF =
    {
        0x000017AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017AF,
        0x000017AF,
        0x000017AF
    };

    static _CharacterInfo _character000017B0 =
    {
        0x000017B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B0,
        0x000017B0,
        0x000017B0
    };

    static _CharacterInfo _character000017B1 =
    {
        0x000017B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B1,
        0x000017B1,
        0x000017B1
    };

    static _CharacterInfo _character000017B2 =
    {
        0x000017B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B2,
        0x000017B2,
        0x000017B2
    };

    static _CharacterInfo _character000017B3 =
    {
        0x000017B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B3,
        0x000017B3,
        0x000017B3
    };

    static _CharacterInfo _character000017B4 =
    {
        0x000017B4,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B4,
        0x000017B4,
        0x000017B4
    };

    static _CharacterInfo _character000017B5 =
    {
        0x000017B5,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B5,
        0x000017B5,
        0x000017B5
    };

    static _CharacterInfo _character000017B6 =
    {
        0x000017B6,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B6,
        0x000017B6,
        0x000017B6
    };

    static _CharacterInfo _character000017B7 =
    {
        0x000017B7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B7,
        0x000017B7,
        0x000017B7
    };

    static _CharacterInfo _character000017B8 =
    {
        0x000017B8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B8,
        0x000017B8,
        0x000017B8
    };

    static _CharacterInfo _character000017B9 =
    {
        0x000017B9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017B9,
        0x000017B9,
        0x000017B9
    };

    static _CharacterInfo _character000017BA =
    {
        0x000017BA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BA,
        0x000017BA,
        0x000017BA
    };

    static _CharacterInfo _character000017BB =
    {
        0x000017BB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BB,
        0x000017BB,
        0x000017BB
    };

    static _CharacterInfo _character000017BC =
    {
        0x000017BC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BC,
        0x000017BC,
        0x000017BC
    };

    static _CharacterInfo _character000017BD =
    {
        0x000017BD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BD,
        0x000017BD,
        0x000017BD
    };

    static _CharacterInfo _character000017BE =
    {
        0x000017BE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BE,
        0x000017BE,
        0x000017BE
    };

    static _CharacterInfo _character000017BF =
    {
        0x000017BF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017BF,
        0x000017BF,
        0x000017BF
    };

    static _CharacterInfo _character000017C0 =
    {
        0x000017C0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C0,
        0x000017C0,
        0x000017C0
    };

    static _CharacterInfo _character000017C1 =
    {
        0x000017C1,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C1,
        0x000017C1,
        0x000017C1
    };

    static _CharacterInfo _character000017C2 =
    {
        0x000017C2,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C2,
        0x000017C2,
        0x000017C2
    };

    static _CharacterInfo _character000017C3 =
    {
        0x000017C3,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C3,
        0x000017C3,
        0x000017C3
    };

    static _CharacterInfo _character000017C4 =
    {
        0x000017C4,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C4,
        0x000017C4,
        0x000017C4
    };

    static _CharacterInfo _character000017C5 =
    {
        0x000017C5,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C5,
        0x000017C5,
        0x000017C5
    };

    static _CharacterInfo _character000017C6 =
    {
        0x000017C6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C6,
        0x000017C6,
        0x000017C6
    };

    static _CharacterInfo _character000017C7 =
    {
        0x000017C7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C7,
        0x000017C7,
        0x000017C7
    };

    static _CharacterInfo _character000017C8 =
    {
        0x000017C8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C8,
        0x000017C8,
        0x000017C8
    };

    static _CharacterInfo _character000017C9 =
    {
        0x000017C9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017C9,
        0x000017C9,
        0x000017C9
    };

    static _CharacterInfo _character000017CA =
    {
        0x000017CA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CA,
        0x000017CA,
        0x000017CA
    };

    static _CharacterInfo _character000017CB =
    {
        0x000017CB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CB,
        0x000017CB,
        0x000017CB
    };

    static _CharacterInfo _character000017CC =
    {
        0x000017CC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CC,
        0x000017CC,
        0x000017CC
    };

    static _CharacterInfo _character000017CD =
    {
        0x000017CD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CD,
        0x000017CD,
        0x000017CD
    };

    static _CharacterInfo _character000017CE =
    {
        0x000017CE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CE,
        0x000017CE,
        0x000017CE
    };

    static _CharacterInfo _character000017CF =
    {
        0x000017CF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017CF,
        0x000017CF,
        0x000017CF
    };

    static _CharacterInfo _character000017D0 =
    {
        0x000017D0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D0,
        0x000017D0,
        0x000017D0
    };

    static _CharacterInfo _character000017D1 =
    {
        0x000017D1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D1,
        0x000017D1,
        0x000017D1
    };

    static _CharacterInfo _character000017D2 =
    {
        0x000017D2,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D2,
        0x000017D2,
        0x000017D2
    };

    static _CharacterInfo _character000017D3 =
    {
        0x000017D3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D3,
        0x000017D3,
        0x000017D3
    };

    static _CharacterInfo _character000017D4 =
    {
        0x000017D4,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D4,
        0x000017D4,
        0x000017D4
    };

    static _CharacterInfo _character000017D5 =
    {
        0x000017D5,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D5,
        0x000017D5,
        0x000017D5
    };

    static _CharacterInfo _character000017D6 =
    {
        0x000017D6,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D6,
        0x000017D6,
        0x000017D6
    };

    static _CharacterInfo _character000017D7 =
    {
        0x000017D7,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D7,
        0x000017D7,
        0x000017D7
    };

    static _CharacterInfo _character000017D8 =
    {
        0x000017D8,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D8,
        0x000017D8,
        0x000017D8
    };

    static _CharacterInfo _character000017D9 =
    {
        0x000017D9,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017D9,
        0x000017D9,
        0x000017D9
    };

    static _CharacterInfo _character000017DA =
    {
        0x000017DA,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017DA,
        0x000017DA,
        0x000017DA
    };

    static _CharacterInfo _character000017DB =
    {
        0x000017DB,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017DB,
        0x000017DB,
        0x000017DB
    };

    static _CharacterInfo _character000017DC =
    {
        0x000017DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017DC,
        0x000017DC,
        0x000017DC
    };

    static _CharacterInfo _character000017DD =
    {
        0x000017DD,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000017DD,
        0x000017DD,
        0x000017DD
    };

    static _CharacterInfo _character000017E0 =
    {
        0x000017E0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000017E0,
        0x000017E0,
        0x000017E0
    };

    static _CharacterInfo _character000017E1 =
    {
        0x000017E1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000017E1,
        0x000017E1,
        0x000017E1
    };

    static _CharacterInfo _character000017E2 =
    {
        0x000017E2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000017E2,
        0x000017E2,
        0x000017E2
    };

    static _CharacterInfo _character000017E3 =
    {
        0x000017E3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000017E3,
        0x000017E3,
        0x000017E3
    };

    static _CharacterInfo _character000017E4 =
    {
        0x000017E4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000017E4,
        0x000017E4,
        0x000017E4
    };

    static _CharacterInfo _character000017E5 =
    {
        0x000017E5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000017E5,
        0x000017E5,
        0x000017E5
    };

    static _CharacterInfo _character000017E6 =
    {
        0x000017E6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000017E6,
        0x000017E6,
        0x000017E6
    };

    static _CharacterInfo _character000017E7 =
    {
        0x000017E7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000017E7,
        0x000017E7,
        0x000017E7
    };

    static _CharacterInfo _character000017E8 =
    {
        0x000017E8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000017E8,
        0x000017E8,
        0x000017E8
    };

    static _CharacterInfo _character000017E9 =
    {
        0x000017E9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000017E9,
        0x000017E9,
        0x000017E9
    };

    static _CharacterInfo _character000017F0 =
    {
        0x000017F0,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        0,
        1,
        false,
        0x000017F0,
        0x000017F0,
        0x000017F0
    };

    static _CharacterInfo _character000017F1 =
    {
        0x000017F1,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x000017F1,
        0x000017F1,
        0x000017F1
    };

    static _CharacterInfo _character000017F2 =
    {
        0x000017F2,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x000017F2,
        0x000017F2,
        0x000017F2
    };

    static _CharacterInfo _character000017F3 =
    {
        0x000017F3,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x000017F3,
        0x000017F3,
        0x000017F3
    };

    static _CharacterInfo _character000017F4 =
    {
        0x000017F4,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x000017F4,
        0x000017F4,
        0x000017F4
    };

    static _CharacterInfo _character000017F5 =
    {
        0x000017F5,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x000017F5,
        0x000017F5,
        0x000017F5
    };

    static _CharacterInfo _character000017F6 =
    {
        0x000017F6,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x000017F6,
        0x000017F6,
        0x000017F6
    };

    static _CharacterInfo _character000017F7 =
    {
        0x000017F7,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x000017F7,
        0x000017F7,
        0x000017F7
    };

    static _CharacterInfo _character000017F8 =
    {
        0x000017F8,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x000017F8,
        0x000017F8,
        0x000017F8
    };

    static _CharacterInfo _character000017F9 =
    {
        0x000017F9,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x000017F9,
        0x000017F9,
        0x000017F9
    };

    static _CharacterInfo _character00001800 =
    {
        0x00001800,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001800,
        0x00001800,
        0x00001800
    };

    static _CharacterInfo _character00001801 =
    {
        0x00001801,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001801,
        0x00001801,
        0x00001801
    };

    static _CharacterInfo _character00001802 =
    {
        0x00001802,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001802,
        0x00001802,
        0x00001802
    };

    static _CharacterInfo _character00001803 =
    {
        0x00001803,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001803,
        0x00001803,
        0x00001803
    };

    static _CharacterInfo _character00001804 =
    {
        0x00001804,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001804,
        0x00001804,
        0x00001804
    };

    static _CharacterInfo _character00001805 =
    {
        0x00001805,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001805,
        0x00001805,
        0x00001805
    };

    static _CharacterInfo _character00001806 =
    {
        0x00001806,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001806,
        0x00001806,
        0x00001806
    };

    static _CharacterInfo _character00001807 =
    {
        0x00001807,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001807,
        0x00001807,
        0x00001807
    };

    static _CharacterInfo _character00001808 =
    {
        0x00001808,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001808,
        0x00001808,
        0x00001808
    };

    static _CharacterInfo _character00001809 =
    {
        0x00001809,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001809,
        0x00001809,
        0x00001809
    };

    static _CharacterInfo _character0000180A =
    {
        0x0000180A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000180A,
        0x0000180A,
        0x0000180A
    };

    static _CharacterInfo _character0000180B =
    {
        0x0000180B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000180B,
        0x0000180B,
        0x0000180B
    };

    static _CharacterInfo _character0000180C =
    {
        0x0000180C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000180C,
        0x0000180C,
        0x0000180C
    };

    static _CharacterInfo _character0000180D =
    {
        0x0000180D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000180D,
        0x0000180D,
        0x0000180D
    };

    static _CharacterInfo _character0000180E =
    {
        0x0000180E,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000180E,
        0x0000180E,
        0x0000180E
    };

    static _CharacterInfo _character00001810 =
    {
        0x00001810,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00001810,
        0x00001810,
        0x00001810
    };

    static _CharacterInfo _character00001811 =
    {
        0x00001811,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00001811,
        0x00001811,
        0x00001811
    };

    static _CharacterInfo _character00001812 =
    {
        0x00001812,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00001812,
        0x00001812,
        0x00001812
    };

    static _CharacterInfo _character00001813 =
    {
        0x00001813,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00001813,
        0x00001813,
        0x00001813
    };

    static _CharacterInfo _character00001814 =
    {
        0x00001814,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00001814,
        0x00001814,
        0x00001814
    };

    static _CharacterInfo _character00001815 =
    {
        0x00001815,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00001815,
        0x00001815,
        0x00001815
    };

    static _CharacterInfo _character00001816 =
    {
        0x00001816,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00001816,
        0x00001816,
        0x00001816
    };

    static _CharacterInfo _character00001817 =
    {
        0x00001817,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00001817,
        0x00001817,
        0x00001817
    };

    static _CharacterInfo _character00001818 =
    {
        0x00001818,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00001818,
        0x00001818,
        0x00001818
    };

    static _CharacterInfo _character00001819 =
    {
        0x00001819,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00001819,
        0x00001819,
        0x00001819
    };

    static _CharacterInfo _character00001820 =
    {
        0x00001820,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001820,
        0x00001820,
        0x00001820
    };

    static _CharacterInfo _character00001821 =
    {
        0x00001821,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001821,
        0x00001821,
        0x00001821
    };

    static _CharacterInfo _character00001822 =
    {
        0x00001822,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001822,
        0x00001822,
        0x00001822
    };

    static _CharacterInfo _character00001823 =
    {
        0x00001823,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001823,
        0x00001823,
        0x00001823
    };

    static _CharacterInfo _character00001824 =
    {
        0x00001824,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001824,
        0x00001824,
        0x00001824
    };

    static _CharacterInfo _character00001825 =
    {
        0x00001825,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001825,
        0x00001825,
        0x00001825
    };

    static _CharacterInfo _character00001826 =
    {
        0x00001826,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001826,
        0x00001826,
        0x00001826
    };

    static _CharacterInfo _character00001827 =
    {
        0x00001827,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001827,
        0x00001827,
        0x00001827
    };

    static _CharacterInfo _character00001828 =
    {
        0x00001828,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001828,
        0x00001828,
        0x00001828
    };

    static _CharacterInfo _character00001829 =
    {
        0x00001829,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001829,
        0x00001829,
        0x00001829
    };

    static _CharacterInfo _character0000182A =
    {
        0x0000182A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182A,
        0x0000182A,
        0x0000182A
    };

    static _CharacterInfo _character0000182B =
    {
        0x0000182B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182B,
        0x0000182B,
        0x0000182B
    };

    static _CharacterInfo _character0000182C =
    {
        0x0000182C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182C,
        0x0000182C,
        0x0000182C
    };

    static _CharacterInfo _character0000182D =
    {
        0x0000182D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182D,
        0x0000182D,
        0x0000182D
    };

    static _CharacterInfo _character0000182E =
    {
        0x0000182E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182E,
        0x0000182E,
        0x0000182E
    };

    static _CharacterInfo _character0000182F =
    {
        0x0000182F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000182F,
        0x0000182F,
        0x0000182F
    };

    static _CharacterInfo _character00001830 =
    {
        0x00001830,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001830,
        0x00001830,
        0x00001830
    };

    static _CharacterInfo _character00001831 =
    {
        0x00001831,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001831,
        0x00001831,
        0x00001831
    };

    static _CharacterInfo _character00001832 =
    {
        0x00001832,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001832,
        0x00001832,
        0x00001832
    };

    static _CharacterInfo _character00001833 =
    {
        0x00001833,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001833,
        0x00001833,
        0x00001833
    };

    static _CharacterInfo _character00001834 =
    {
        0x00001834,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001834,
        0x00001834,
        0x00001834
    };

    static _CharacterInfo _character00001835 =
    {
        0x00001835,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001835,
        0x00001835,
        0x00001835
    };

    static _CharacterInfo _character00001836 =
    {
        0x00001836,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001836,
        0x00001836,
        0x00001836
    };

    static _CharacterInfo _character00001837 =
    {
        0x00001837,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001837,
        0x00001837,
        0x00001837
    };

    static _CharacterInfo _character00001838 =
    {
        0x00001838,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001838,
        0x00001838,
        0x00001838
    };

    static _CharacterInfo _character00001839 =
    {
        0x00001839,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001839,
        0x00001839,
        0x00001839
    };

    static _CharacterInfo _character0000183A =
    {
        0x0000183A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183A,
        0x0000183A,
        0x0000183A
    };

    static _CharacterInfo _character0000183B =
    {
        0x0000183B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183B,
        0x0000183B,
        0x0000183B
    };

    static _CharacterInfo _character0000183C =
    {
        0x0000183C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183C,
        0x0000183C,
        0x0000183C
    };

    static _CharacterInfo _character0000183D =
    {
        0x0000183D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183D,
        0x0000183D,
        0x0000183D
    };

    static _CharacterInfo _character0000183E =
    {
        0x0000183E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183E,
        0x0000183E,
        0x0000183E
    };

    static _CharacterInfo _character0000183F =
    {
        0x0000183F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000183F,
        0x0000183F,
        0x0000183F
    };

    static _CharacterInfo _character00001840 =
    {
        0x00001840,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001840,
        0x00001840,
        0x00001840
    };

    static _CharacterInfo _character00001841 =
    {
        0x00001841,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001841,
        0x00001841,
        0x00001841
    };

    static _CharacterInfo _character00001842 =
    {
        0x00001842,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001842,
        0x00001842,
        0x00001842
    };

    static _CharacterInfo _character00001843 =
    {
        0x00001843,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001843,
        0x00001843,
        0x00001843
    };

    static _CharacterInfo _character00001844 =
    {
        0x00001844,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001844,
        0x00001844,
        0x00001844
    };

    static _CharacterInfo _character00001845 =
    {
        0x00001845,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001845,
        0x00001845,
        0x00001845
    };

    static _CharacterInfo _character00001846 =
    {
        0x00001846,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001846,
        0x00001846,
        0x00001846
    };

    static _CharacterInfo _character00001847 =
    {
        0x00001847,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001847,
        0x00001847,
        0x00001847
    };

    static _CharacterInfo _character00001848 =
    {
        0x00001848,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001848,
        0x00001848,
        0x00001848
    };

    static _CharacterInfo _character00001849 =
    {
        0x00001849,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001849,
        0x00001849,
        0x00001849
    };

    static _CharacterInfo _character0000184A =
    {
        0x0000184A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184A,
        0x0000184A,
        0x0000184A
    };

    static _CharacterInfo _character0000184B =
    {
        0x0000184B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184B,
        0x0000184B,
        0x0000184B
    };

    static _CharacterInfo _character0000184C =
    {
        0x0000184C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184C,
        0x0000184C,
        0x0000184C
    };

    static _CharacterInfo _character0000184D =
    {
        0x0000184D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184D,
        0x0000184D,
        0x0000184D
    };

    static _CharacterInfo _character0000184E =
    {
        0x0000184E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184E,
        0x0000184E,
        0x0000184E
    };

    static _CharacterInfo _character0000184F =
    {
        0x0000184F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000184F,
        0x0000184F,
        0x0000184F
    };

    static _CharacterInfo _character00001850 =
    {
        0x00001850,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001850,
        0x00001850,
        0x00001850
    };

    static _CharacterInfo _character00001851 =
    {
        0x00001851,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001851,
        0x00001851,
        0x00001851
    };

    static _CharacterInfo _character00001852 =
    {
        0x00001852,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001852,
        0x00001852,
        0x00001852
    };

    static _CharacterInfo _character00001853 =
    {
        0x00001853,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001853,
        0x00001853,
        0x00001853
    };

    static _CharacterInfo _character00001854 =
    {
        0x00001854,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001854,
        0x00001854,
        0x00001854
    };

    static _CharacterInfo _character00001855 =
    {
        0x00001855,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001855,
        0x00001855,
        0x00001855
    };

    static _CharacterInfo _character00001856 =
    {
        0x00001856,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001856,
        0x00001856,
        0x00001856
    };

    static _CharacterInfo _character00001857 =
    {
        0x00001857,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001857,
        0x00001857,
        0x00001857
    };

    static _CharacterInfo _character00001858 =
    {
        0x00001858,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001858,
        0x00001858,
        0x00001858
    };

    static _CharacterInfo _character00001859 =
    {
        0x00001859,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001859,
        0x00001859,
        0x00001859
    };

    static _CharacterInfo _character0000185A =
    {
        0x0000185A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185A,
        0x0000185A,
        0x0000185A
    };

    static _CharacterInfo _character0000185B =
    {
        0x0000185B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185B,
        0x0000185B,
        0x0000185B
    };

    static _CharacterInfo _character0000185C =
    {
        0x0000185C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185C,
        0x0000185C,
        0x0000185C
    };

    static _CharacterInfo _character0000185D =
    {
        0x0000185D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185D,
        0x0000185D,
        0x0000185D
    };

    static _CharacterInfo _character0000185E =
    {
        0x0000185E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185E,
        0x0000185E,
        0x0000185E
    };

    static _CharacterInfo _character0000185F =
    {
        0x0000185F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000185F,
        0x0000185F,
        0x0000185F
    };

    static _CharacterInfo _character00001860 =
    {
        0x00001860,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001860,
        0x00001860,
        0x00001860
    };

    static _CharacterInfo _character00001861 =
    {
        0x00001861,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001861,
        0x00001861,
        0x00001861
    };

    static _CharacterInfo _character00001862 =
    {
        0x00001862,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001862,
        0x00001862,
        0x00001862
    };

    static _CharacterInfo _character00001863 =
    {
        0x00001863,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001863,
        0x00001863,
        0x00001863
    };

    static _CharacterInfo _character00001864 =
    {
        0x00001864,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001864,
        0x00001864,
        0x00001864
    };

    static _CharacterInfo _character00001865 =
    {
        0x00001865,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001865,
        0x00001865,
        0x00001865
    };

    static _CharacterInfo _character00001866 =
    {
        0x00001866,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001866,
        0x00001866,
        0x00001866
    };

    static _CharacterInfo _character00001867 =
    {
        0x00001867,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001867,
        0x00001867,
        0x00001867
    };

    static _CharacterInfo _character00001868 =
    {
        0x00001868,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001868,
        0x00001868,
        0x00001868
    };

    static _CharacterInfo _character00001869 =
    {
        0x00001869,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001869,
        0x00001869,
        0x00001869
    };

    static _CharacterInfo _character0000186A =
    {
        0x0000186A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186A,
        0x0000186A,
        0x0000186A
    };

    static _CharacterInfo _character0000186B =
    {
        0x0000186B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186B,
        0x0000186B,
        0x0000186B
    };

    static _CharacterInfo _character0000186C =
    {
        0x0000186C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186C,
        0x0000186C,
        0x0000186C
    };

    static _CharacterInfo _character0000186D =
    {
        0x0000186D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186D,
        0x0000186D,
        0x0000186D
    };

    static _CharacterInfo _character0000186E =
    {
        0x0000186E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186E,
        0x0000186E,
        0x0000186E
    };

    static _CharacterInfo _character0000186F =
    {
        0x0000186F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000186F,
        0x0000186F,
        0x0000186F
    };

    static _CharacterInfo _character00001870 =
    {
        0x00001870,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001870,
        0x00001870,
        0x00001870
    };

    static _CharacterInfo _character00001871 =
    {
        0x00001871,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001871,
        0x00001871,
        0x00001871
    };

    static _CharacterInfo _character00001872 =
    {
        0x00001872,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001872,
        0x00001872,
        0x00001872
    };

    static _CharacterInfo _character00001873 =
    {
        0x00001873,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001873,
        0x00001873,
        0x00001873
    };

    static _CharacterInfo _character00001874 =
    {
        0x00001874,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001874,
        0x00001874,
        0x00001874
    };

    static _CharacterInfo _character00001875 =
    {
        0x00001875,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001875,
        0x00001875,
        0x00001875
    };

    static _CharacterInfo _character00001876 =
    {
        0x00001876,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001876,
        0x00001876,
        0x00001876
    };

    static _CharacterInfo _character00001877 =
    {
        0x00001877,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001877,
        0x00001877,
        0x00001877
    };

    static _CharacterInfo _character00001880 =
    {
        0x00001880,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001880,
        0x00001880,
        0x00001880
    };

    static _CharacterInfo _character00001881 =
    {
        0x00001881,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001881,
        0x00001881,
        0x00001881
    };

    static _CharacterInfo _character00001882 =
    {
        0x00001882,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001882,
        0x00001882,
        0x00001882
    };

    static _CharacterInfo _character00001883 =
    {
        0x00001883,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001883,
        0x00001883,
        0x00001883
    };

    static _CharacterInfo _character00001884 =
    {
        0x00001884,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001884,
        0x00001884,
        0x00001884
    };

    static _CharacterInfo _character00001885 =
    {
        0x00001885,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001885,
        0x00001885,
        0x00001885
    };

    static _CharacterInfo _character00001886 =
    {
        0x00001886,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001886,
        0x00001886,
        0x00001886
    };

    static _CharacterInfo _character00001887 =
    {
        0x00001887,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001887,
        0x00001887,
        0x00001887
    };

    static _CharacterInfo _character00001888 =
    {
        0x00001888,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001888,
        0x00001888,
        0x00001888
    };

    static _CharacterInfo _character00001889 =
    {
        0x00001889,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001889,
        0x00001889,
        0x00001889
    };

    static _CharacterInfo _character0000188A =
    {
        0x0000188A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188A,
        0x0000188A,
        0x0000188A
    };

    static _CharacterInfo _character0000188B =
    {
        0x0000188B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188B,
        0x0000188B,
        0x0000188B
    };

    static _CharacterInfo _character0000188C =
    {
        0x0000188C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188C,
        0x0000188C,
        0x0000188C
    };

    static _CharacterInfo _character0000188D =
    {
        0x0000188D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188D,
        0x0000188D,
        0x0000188D
    };

    static _CharacterInfo _character0000188E =
    {
        0x0000188E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188E,
        0x0000188E,
        0x0000188E
    };

    static _CharacterInfo _character0000188F =
    {
        0x0000188F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000188F,
        0x0000188F,
        0x0000188F
    };

    static _CharacterInfo _character00001890 =
    {
        0x00001890,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001890,
        0x00001890,
        0x00001890
    };

    static _CharacterInfo _character00001891 =
    {
        0x00001891,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001891,
        0x00001891,
        0x00001891
    };

    static _CharacterInfo _character00001892 =
    {
        0x00001892,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001892,
        0x00001892,
        0x00001892
    };

    static _CharacterInfo _character00001893 =
    {
        0x00001893,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001893,
        0x00001893,
        0x00001893
    };

    static _CharacterInfo _character00001894 =
    {
        0x00001894,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001894,
        0x00001894,
        0x00001894
    };

    static _CharacterInfo _character00001895 =
    {
        0x00001895,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001895,
        0x00001895,
        0x00001895
    };

    static _CharacterInfo _character00001896 =
    {
        0x00001896,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001896,
        0x00001896,
        0x00001896
    };

    static _CharacterInfo _character00001897 =
    {
        0x00001897,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001897,
        0x00001897,
        0x00001897
    };

    static _CharacterInfo _character00001898 =
    {
        0x00001898,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001898,
        0x00001898,
        0x00001898
    };

    static _CharacterInfo _character00001899 =
    {
        0x00001899,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001899,
        0x00001899,
        0x00001899
    };

    static _CharacterInfo _character0000189A =
    {
        0x0000189A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189A,
        0x0000189A,
        0x0000189A
    };

    static _CharacterInfo _character0000189B =
    {
        0x0000189B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189B,
        0x0000189B,
        0x0000189B
    };

    static _CharacterInfo _character0000189C =
    {
        0x0000189C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189C,
        0x0000189C,
        0x0000189C
    };

    static _CharacterInfo _character0000189D =
    {
        0x0000189D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189D,
        0x0000189D,
        0x0000189D
    };

    static _CharacterInfo _character0000189E =
    {
        0x0000189E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189E,
        0x0000189E,
        0x0000189E
    };

    static _CharacterInfo _character0000189F =
    {
        0x0000189F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000189F,
        0x0000189F,
        0x0000189F
    };

    static _CharacterInfo _character000018A0 =
    {
        0x000018A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A0,
        0x000018A0,
        0x000018A0
    };

    static _CharacterInfo _character000018A1 =
    {
        0x000018A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A1,
        0x000018A1,
        0x000018A1
    };

    static _CharacterInfo _character000018A2 =
    {
        0x000018A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A2,
        0x000018A2,
        0x000018A2
    };

    static _CharacterInfo _character000018A3 =
    {
        0x000018A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A3,
        0x000018A3,
        0x000018A3
    };

    static _CharacterInfo _character000018A4 =
    {
        0x000018A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A4,
        0x000018A4,
        0x000018A4
    };

    static _CharacterInfo _character000018A5 =
    {
        0x000018A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A5,
        0x000018A5,
        0x000018A5
    };

    static _CharacterInfo _character000018A6 =
    {
        0x000018A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A6,
        0x000018A6,
        0x000018A6
    };

    static _CharacterInfo _character000018A7 =
    {
        0x000018A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A7,
        0x000018A7,
        0x000018A7
    };

    static _CharacterInfo _character000018A8 =
    {
        0x000018A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A8,
        0x000018A8,
        0x000018A8
    };

    static _CharacterInfo _character000018A9 =
    {
        0x000018A9,
        Iso10646::GeneralCategory_Mn,
        228,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000018A9,
        0x000018A9,
        0x000018A9
    };

    static _CharacterInfo _character00001900 =
    {
        0x00001900,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001900,
        0x00001900,
        0x00001900
    };

    static _CharacterInfo _character00001901 =
    {
        0x00001901,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001901,
        0x00001901,
        0x00001901
    };

    static _CharacterInfo _character00001902 =
    {
        0x00001902,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001902,
        0x00001902,
        0x00001902
    };

    static _CharacterInfo _character00001903 =
    {
        0x00001903,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001903,
        0x00001903,
        0x00001903
    };

    static _CharacterInfo _character00001904 =
    {
        0x00001904,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001904,
        0x00001904,
        0x00001904
    };

    static _CharacterInfo _character00001905 =
    {
        0x00001905,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001905,
        0x00001905,
        0x00001905
    };

    static _CharacterInfo _character00001906 =
    {
        0x00001906,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001906,
        0x00001906,
        0x00001906
    };

    static _CharacterInfo _character00001907 =
    {
        0x00001907,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001907,
        0x00001907,
        0x00001907
    };

    static _CharacterInfo _character00001908 =
    {
        0x00001908,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001908,
        0x00001908,
        0x00001908
    };

    static _CharacterInfo _character00001909 =
    {
        0x00001909,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001909,
        0x00001909,
        0x00001909
    };

    static _CharacterInfo _character0000190A =
    {
        0x0000190A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190A,
        0x0000190A,
        0x0000190A
    };

    static _CharacterInfo _character0000190B =
    {
        0x0000190B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190B,
        0x0000190B,
        0x0000190B
    };

    static _CharacterInfo _character0000190C =
    {
        0x0000190C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190C,
        0x0000190C,
        0x0000190C
    };

    static _CharacterInfo _character0000190D =
    {
        0x0000190D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190D,
        0x0000190D,
        0x0000190D
    };

    static _CharacterInfo _character0000190E =
    {
        0x0000190E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190E,
        0x0000190E,
        0x0000190E
    };

    static _CharacterInfo _character0000190F =
    {
        0x0000190F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000190F,
        0x0000190F,
        0x0000190F
    };

    static _CharacterInfo _character00001910 =
    {
        0x00001910,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001910,
        0x00001910,
        0x00001910
    };

    static _CharacterInfo _character00001911 =
    {
        0x00001911,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001911,
        0x00001911,
        0x00001911
    };

    static _CharacterInfo _character00001912 =
    {
        0x00001912,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001912,
        0x00001912,
        0x00001912
    };

    static _CharacterInfo _character00001913 =
    {
        0x00001913,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001913,
        0x00001913,
        0x00001913
    };

    static _CharacterInfo _character00001914 =
    {
        0x00001914,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001914,
        0x00001914,
        0x00001914
    };

    static _CharacterInfo _character00001915 =
    {
        0x00001915,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001915,
        0x00001915,
        0x00001915
    };

    static _CharacterInfo _character00001916 =
    {
        0x00001916,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001916,
        0x00001916,
        0x00001916
    };

    static _CharacterInfo _character00001917 =
    {
        0x00001917,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001917,
        0x00001917,
        0x00001917
    };

    static _CharacterInfo _character00001918 =
    {
        0x00001918,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001918,
        0x00001918,
        0x00001918
    };

    static _CharacterInfo _character00001919 =
    {
        0x00001919,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001919,
        0x00001919,
        0x00001919
    };

    static _CharacterInfo _character0000191A =
    {
        0x0000191A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000191A,
        0x0000191A,
        0x0000191A
    };

    static _CharacterInfo _character0000191B =
    {
        0x0000191B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000191B,
        0x0000191B,
        0x0000191B
    };

    static _CharacterInfo _character0000191C =
    {
        0x0000191C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000191C,
        0x0000191C,
        0x0000191C
    };

    static _CharacterInfo _character00001920 =
    {
        0x00001920,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001920,
        0x00001920,
        0x00001920
    };

    static _CharacterInfo _character00001921 =
    {
        0x00001921,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001921,
        0x00001921,
        0x00001921
    };

    static _CharacterInfo _character00001922 =
    {
        0x00001922,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001922,
        0x00001922,
        0x00001922
    };

    static _CharacterInfo _character00001923 =
    {
        0x00001923,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001923,
        0x00001923,
        0x00001923
    };

    static _CharacterInfo _character00001924 =
    {
        0x00001924,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001924,
        0x00001924,
        0x00001924
    };

    static _CharacterInfo _character00001925 =
    {
        0x00001925,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001925,
        0x00001925,
        0x00001925
    };

    static _CharacterInfo _character00001926 =
    {
        0x00001926,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001926,
        0x00001926,
        0x00001926
    };

    static _CharacterInfo _character00001927 =
    {
        0x00001927,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001927,
        0x00001927,
        0x00001927
    };

    static _CharacterInfo _character00001928 =
    {
        0x00001928,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001928,
        0x00001928,
        0x00001928
    };

    static _CharacterInfo _character00001929 =
    {
        0x00001929,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001929,
        0x00001929,
        0x00001929
    };

    static _CharacterInfo _character0000192A =
    {
        0x0000192A,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000192A,
        0x0000192A,
        0x0000192A
    };

    static _CharacterInfo _character0000192B =
    {
        0x0000192B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000192B,
        0x0000192B,
        0x0000192B
    };

    static _CharacterInfo _character00001930 =
    {
        0x00001930,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001930,
        0x00001930,
        0x00001930
    };

    static _CharacterInfo _character00001931 =
    {
        0x00001931,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001931,
        0x00001931,
        0x00001931
    };

    static _CharacterInfo _character00001932 =
    {
        0x00001932,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001932,
        0x00001932,
        0x00001932
    };

    static _CharacterInfo _character00001933 =
    {
        0x00001933,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001933,
        0x00001933,
        0x00001933
    };

    static _CharacterInfo _character00001934 =
    {
        0x00001934,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001934,
        0x00001934,
        0x00001934
    };

    static _CharacterInfo _character00001935 =
    {
        0x00001935,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001935,
        0x00001935,
        0x00001935
    };

    static _CharacterInfo _character00001936 =
    {
        0x00001936,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001936,
        0x00001936,
        0x00001936
    };

    static _CharacterInfo _character00001937 =
    {
        0x00001937,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001937,
        0x00001937,
        0x00001937
    };

    static _CharacterInfo _character00001938 =
    {
        0x00001938,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001938,
        0x00001938,
        0x00001938
    };

    static _CharacterInfo _character00001939 =
    {
        0x00001939,
        Iso10646::GeneralCategory_Mn,
        222,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001939,
        0x00001939,
        0x00001939
    };

    static _CharacterInfo _character0000193A =
    {
        0x0000193A,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000193A,
        0x0000193A,
        0x0000193A
    };

    static _CharacterInfo _character0000193B =
    {
        0x0000193B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000193B,
        0x0000193B,
        0x0000193B
    };

    static _CharacterInfo _character00001940 =
    {
        0x00001940,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001940,
        0x00001940,
        0x00001940
    };

    static _CharacterInfo _character00001944 =
    {
        0x00001944,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001944,
        0x00001944,
        0x00001944
    };

    static _CharacterInfo _character00001945 =
    {
        0x00001945,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001945,
        0x00001945,
        0x00001945
    };

    static _CharacterInfo _character00001946 =
    {
        0x00001946,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00001946,
        0x00001946,
        0x00001946
    };

    static _CharacterInfo _character00001947 =
    {
        0x00001947,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00001947,
        0x00001947,
        0x00001947
    };

    static _CharacterInfo _character00001948 =
    {
        0x00001948,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00001948,
        0x00001948,
        0x00001948
    };

    static _CharacterInfo _character00001949 =
    {
        0x00001949,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00001949,
        0x00001949,
        0x00001949
    };

    static _CharacterInfo _character0000194A =
    {
        0x0000194A,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000194A,
        0x0000194A,
        0x0000194A
    };

    static _CharacterInfo _character0000194B =
    {
        0x0000194B,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000194B,
        0x0000194B,
        0x0000194B
    };

    static _CharacterInfo _character0000194C =
    {
        0x0000194C,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000194C,
        0x0000194C,
        0x0000194C
    };

    static _CharacterInfo _character0000194D =
    {
        0x0000194D,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000194D,
        0x0000194D,
        0x0000194D
    };

    static _CharacterInfo _character0000194E =
    {
        0x0000194E,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000194E,
        0x0000194E,
        0x0000194E
    };

    static _CharacterInfo _character0000194F =
    {
        0x0000194F,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0000194F,
        0x0000194F,
        0x0000194F
    };

    static _CharacterInfo _character00001950 =
    {
        0x00001950,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001950,
        0x00001950,
        0x00001950
    };

    static _CharacterInfo _character00001951 =
    {
        0x00001951,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001951,
        0x00001951,
        0x00001951
    };

    static _CharacterInfo _character00001952 =
    {
        0x00001952,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001952,
        0x00001952,
        0x00001952
    };

    static _CharacterInfo _character00001953 =
    {
        0x00001953,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001953,
        0x00001953,
        0x00001953
    };

    static _CharacterInfo _character00001954 =
    {
        0x00001954,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001954,
        0x00001954,
        0x00001954
    };

    static _CharacterInfo _character00001955 =
    {
        0x00001955,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001955,
        0x00001955,
        0x00001955
    };

    static _CharacterInfo _character00001956 =
    {
        0x00001956,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001956,
        0x00001956,
        0x00001956
    };

    static _CharacterInfo _character00001957 =
    {
        0x00001957,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001957,
        0x00001957,
        0x00001957
    };

    static _CharacterInfo _character00001958 =
    {
        0x00001958,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001958,
        0x00001958,
        0x00001958
    };

    static _CharacterInfo _character00001959 =
    {
        0x00001959,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001959,
        0x00001959,
        0x00001959
    };

    static _CharacterInfo _character0000195A =
    {
        0x0000195A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195A,
        0x0000195A,
        0x0000195A
    };

    static _CharacterInfo _character0000195B =
    {
        0x0000195B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195B,
        0x0000195B,
        0x0000195B
    };

    static _CharacterInfo _character0000195C =
    {
        0x0000195C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195C,
        0x0000195C,
        0x0000195C
    };

    static _CharacterInfo _character0000195D =
    {
        0x0000195D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195D,
        0x0000195D,
        0x0000195D
    };

    static _CharacterInfo _character0000195E =
    {
        0x0000195E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195E,
        0x0000195E,
        0x0000195E
    };

    static _CharacterInfo _character0000195F =
    {
        0x0000195F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000195F,
        0x0000195F,
        0x0000195F
    };

    static _CharacterInfo _character00001960 =
    {
        0x00001960,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001960,
        0x00001960,
        0x00001960
    };

    static _CharacterInfo _character00001961 =
    {
        0x00001961,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001961,
        0x00001961,
        0x00001961
    };

    static _CharacterInfo _character00001962 =
    {
        0x00001962,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001962,
        0x00001962,
        0x00001962
    };

    static _CharacterInfo _character00001963 =
    {
        0x00001963,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001963,
        0x00001963,
        0x00001963
    };

    static _CharacterInfo _character00001964 =
    {
        0x00001964,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001964,
        0x00001964,
        0x00001964
    };

    static _CharacterInfo _character00001965 =
    {
        0x00001965,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001965,
        0x00001965,
        0x00001965
    };

    static _CharacterInfo _character00001966 =
    {
        0x00001966,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001966,
        0x00001966,
        0x00001966
    };

    static _CharacterInfo _character00001967 =
    {
        0x00001967,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001967,
        0x00001967,
        0x00001967
    };

    static _CharacterInfo _character00001968 =
    {
        0x00001968,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001968,
        0x00001968,
        0x00001968
    };

    static _CharacterInfo _character00001969 =
    {
        0x00001969,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001969,
        0x00001969,
        0x00001969
    };

    static _CharacterInfo _character0000196A =
    {
        0x0000196A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000196A,
        0x0000196A,
        0x0000196A
    };

    static _CharacterInfo _character0000196B =
    {
        0x0000196B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000196B,
        0x0000196B,
        0x0000196B
    };

    static _CharacterInfo _character0000196C =
    {
        0x0000196C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000196C,
        0x0000196C,
        0x0000196C
    };

    static _CharacterInfo _character0000196D =
    {
        0x0000196D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000196D,
        0x0000196D,
        0x0000196D
    };

    static _CharacterInfo _character00001970 =
    {
        0x00001970,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001970,
        0x00001970,
        0x00001970
    };

    static _CharacterInfo _character00001971 =
    {
        0x00001971,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001971,
        0x00001971,
        0x00001971
    };

    static _CharacterInfo _character00001972 =
    {
        0x00001972,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001972,
        0x00001972,
        0x00001972
    };

    static _CharacterInfo _character00001973 =
    {
        0x00001973,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001973,
        0x00001973,
        0x00001973
    };

    static _CharacterInfo _character00001974 =
    {
        0x00001974,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001974,
        0x00001974,
        0x00001974
    };

    static _CharacterInfo _character00001980 =
    {
        0x00001980,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001980,
        0x00001980,
        0x00001980
    };

    static _CharacterInfo _character00001981 =
    {
        0x00001981,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001981,
        0x00001981,
        0x00001981
    };

    static _CharacterInfo _character00001982 =
    {
        0x00001982,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001982,
        0x00001982,
        0x00001982
    };

    static _CharacterInfo _character00001983 =
    {
        0x00001983,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001983,
        0x00001983,
        0x00001983
    };

    static _CharacterInfo _character00001984 =
    {
        0x00001984,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001984,
        0x00001984,
        0x00001984
    };

    static _CharacterInfo _character00001985 =
    {
        0x00001985,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001985,
        0x00001985,
        0x00001985
    };

    static _CharacterInfo _character00001986 =
    {
        0x00001986,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001986,
        0x00001986,
        0x00001986
    };

    static _CharacterInfo _character00001987 =
    {
        0x00001987,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001987,
        0x00001987,
        0x00001987
    };

    static _CharacterInfo _character00001988 =
    {
        0x00001988,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001988,
        0x00001988,
        0x00001988
    };

    static _CharacterInfo _character00001989 =
    {
        0x00001989,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001989,
        0x00001989,
        0x00001989
    };

    static _CharacterInfo _character0000198A =
    {
        0x0000198A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198A,
        0x0000198A,
        0x0000198A
    };

    static _CharacterInfo _character0000198B =
    {
        0x0000198B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198B,
        0x0000198B,
        0x0000198B
    };

    static _CharacterInfo _character0000198C =
    {
        0x0000198C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198C,
        0x0000198C,
        0x0000198C
    };

    static _CharacterInfo _character0000198D =
    {
        0x0000198D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198D,
        0x0000198D,
        0x0000198D
    };

    static _CharacterInfo _character0000198E =
    {
        0x0000198E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198E,
        0x0000198E,
        0x0000198E
    };

    static _CharacterInfo _character0000198F =
    {
        0x0000198F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000198F,
        0x0000198F,
        0x0000198F
    };

    static _CharacterInfo _character00001990 =
    {
        0x00001990,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001990,
        0x00001990,
        0x00001990
    };

    static _CharacterInfo _character00001991 =
    {
        0x00001991,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001991,
        0x00001991,
        0x00001991
    };

    static _CharacterInfo _character00001992 =
    {
        0x00001992,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001992,
        0x00001992,
        0x00001992
    };

    static _CharacterInfo _character00001993 =
    {
        0x00001993,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001993,
        0x00001993,
        0x00001993
    };

    static _CharacterInfo _character00001994 =
    {
        0x00001994,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001994,
        0x00001994,
        0x00001994
    };

    static _CharacterInfo _character00001995 =
    {
        0x00001995,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001995,
        0x00001995,
        0x00001995
    };

    static _CharacterInfo _character00001996 =
    {
        0x00001996,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001996,
        0x00001996,
        0x00001996
    };

    static _CharacterInfo _character00001997 =
    {
        0x00001997,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001997,
        0x00001997,
        0x00001997
    };

    static _CharacterInfo _character00001998 =
    {
        0x00001998,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001998,
        0x00001998,
        0x00001998
    };

    static _CharacterInfo _character00001999 =
    {
        0x00001999,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001999,
        0x00001999,
        0x00001999
    };

    static _CharacterInfo _character0000199A =
    {
        0x0000199A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199A,
        0x0000199A,
        0x0000199A
    };

    static _CharacterInfo _character0000199B =
    {
        0x0000199B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199B,
        0x0000199B,
        0x0000199B
    };

    static _CharacterInfo _character0000199C =
    {
        0x0000199C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199C,
        0x0000199C,
        0x0000199C
    };

    static _CharacterInfo _character0000199D =
    {
        0x0000199D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199D,
        0x0000199D,
        0x0000199D
    };

    static _CharacterInfo _character0000199E =
    {
        0x0000199E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199E,
        0x0000199E,
        0x0000199E
    };

    static _CharacterInfo _character0000199F =
    {
        0x0000199F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000199F,
        0x0000199F,
        0x0000199F
    };

    static _CharacterInfo _character000019A0 =
    {
        0x000019A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A0,
        0x000019A0,
        0x000019A0
    };

    static _CharacterInfo _character000019A1 =
    {
        0x000019A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A1,
        0x000019A1,
        0x000019A1
    };

    static _CharacterInfo _character000019A2 =
    {
        0x000019A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A2,
        0x000019A2,
        0x000019A2
    };

    static _CharacterInfo _character000019A3 =
    {
        0x000019A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A3,
        0x000019A3,
        0x000019A3
    };

    static _CharacterInfo _character000019A4 =
    {
        0x000019A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A4,
        0x000019A4,
        0x000019A4
    };

    static _CharacterInfo _character000019A5 =
    {
        0x000019A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A5,
        0x000019A5,
        0x000019A5
    };

    static _CharacterInfo _character000019A6 =
    {
        0x000019A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A6,
        0x000019A6,
        0x000019A6
    };

    static _CharacterInfo _character000019A7 =
    {
        0x000019A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A7,
        0x000019A7,
        0x000019A7
    };

    static _CharacterInfo _character000019A8 =
    {
        0x000019A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A8,
        0x000019A8,
        0x000019A8
    };

    static _CharacterInfo _character000019A9 =
    {
        0x000019A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019A9,
        0x000019A9,
        0x000019A9
    };

    static _CharacterInfo _character000019B0 =
    {
        0x000019B0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B0,
        0x000019B0,
        0x000019B0
    };

    static _CharacterInfo _character000019B1 =
    {
        0x000019B1,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B1,
        0x000019B1,
        0x000019B1
    };

    static _CharacterInfo _character000019B2 =
    {
        0x000019B2,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B2,
        0x000019B2,
        0x000019B2
    };

    static _CharacterInfo _character000019B3 =
    {
        0x000019B3,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B3,
        0x000019B3,
        0x000019B3
    };

    static _CharacterInfo _character000019B4 =
    {
        0x000019B4,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B4,
        0x000019B4,
        0x000019B4
    };

    static _CharacterInfo _character000019B5 =
    {
        0x000019B5,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B5,
        0x000019B5,
        0x000019B5
    };

    static _CharacterInfo _character000019B6 =
    {
        0x000019B6,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B6,
        0x000019B6,
        0x000019B6
    };

    static _CharacterInfo _character000019B7 =
    {
        0x000019B7,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B7,
        0x000019B7,
        0x000019B7
    };

    static _CharacterInfo _character000019B8 =
    {
        0x000019B8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B8,
        0x000019B8,
        0x000019B8
    };

    static _CharacterInfo _character000019B9 =
    {
        0x000019B9,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019B9,
        0x000019B9,
        0x000019B9
    };

    static _CharacterInfo _character000019BA =
    {
        0x000019BA,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BA,
        0x000019BA,
        0x000019BA
    };

    static _CharacterInfo _character000019BB =
    {
        0x000019BB,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BB,
        0x000019BB,
        0x000019BB
    };

    static _CharacterInfo _character000019BC =
    {
        0x000019BC,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BC,
        0x000019BC,
        0x000019BC
    };

    static _CharacterInfo _character000019BD =
    {
        0x000019BD,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BD,
        0x000019BD,
        0x000019BD
    };

    static _CharacterInfo _character000019BE =
    {
        0x000019BE,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BE,
        0x000019BE,
        0x000019BE
    };

    static _CharacterInfo _character000019BF =
    {
        0x000019BF,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019BF,
        0x000019BF,
        0x000019BF
    };

    static _CharacterInfo _character000019C0 =
    {
        0x000019C0,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C0,
        0x000019C0,
        0x000019C0
    };

    static _CharacterInfo _character000019C1 =
    {
        0x000019C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C1,
        0x000019C1,
        0x000019C1
    };

    static _CharacterInfo _character000019C2 =
    {
        0x000019C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C2,
        0x000019C2,
        0x000019C2
    };

    static _CharacterInfo _character000019C3 =
    {
        0x000019C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C3,
        0x000019C3,
        0x000019C3
    };

    static _CharacterInfo _character000019C4 =
    {
        0x000019C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C4,
        0x000019C4,
        0x000019C4
    };

    static _CharacterInfo _character000019C5 =
    {
        0x000019C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C5,
        0x000019C5,
        0x000019C5
    };

    static _CharacterInfo _character000019C6 =
    {
        0x000019C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C6,
        0x000019C6,
        0x000019C6
    };

    static _CharacterInfo _character000019C7 =
    {
        0x000019C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C7,
        0x000019C7,
        0x000019C7
    };

    static _CharacterInfo _character000019C8 =
    {
        0x000019C8,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C8,
        0x000019C8,
        0x000019C8
    };

    static _CharacterInfo _character000019C9 =
    {
        0x000019C9,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019C9,
        0x000019C9,
        0x000019C9
    };

    static _CharacterInfo _character000019D0 =
    {
        0x000019D0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000019D0,
        0x000019D0,
        0x000019D0
    };

    static _CharacterInfo _character000019D1 =
    {
        0x000019D1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000019D1,
        0x000019D1,
        0x000019D1
    };

    static _CharacterInfo _character000019D2 =
    {
        0x000019D2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000019D2,
        0x000019D2,
        0x000019D2
    };

    static _CharacterInfo _character000019D3 =
    {
        0x000019D3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000019D3,
        0x000019D3,
        0x000019D3
    };

    static _CharacterInfo _character000019D4 =
    {
        0x000019D4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000019D4,
        0x000019D4,
        0x000019D4
    };

    static _CharacterInfo _character000019D5 =
    {
        0x000019D5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000019D5,
        0x000019D5,
        0x000019D5
    };

    static _CharacterInfo _character000019D6 =
    {
        0x000019D6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000019D6,
        0x000019D6,
        0x000019D6
    };

    static _CharacterInfo _character000019D7 =
    {
        0x000019D7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000019D7,
        0x000019D7,
        0x000019D7
    };

    static _CharacterInfo _character000019D8 =
    {
        0x000019D8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000019D8,
        0x000019D8,
        0x000019D8
    };

    static _CharacterInfo _character000019D9 =
    {
        0x000019D9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000019D9,
        0x000019D9,
        0x000019D9
    };

    static _CharacterInfo _character000019DE =
    {
        0x000019DE,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019DE,
        0x000019DE,
        0x000019DE
    };

    static _CharacterInfo _character000019DF =
    {
        0x000019DF,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019DF,
        0x000019DF,
        0x000019DF
    };

    static _CharacterInfo _character000019E0 =
    {
        0x000019E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E0,
        0x000019E0,
        0x000019E0
    };

    static _CharacterInfo _character000019E1 =
    {
        0x000019E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E1,
        0x000019E1,
        0x000019E1
    };

    static _CharacterInfo _character000019E2 =
    {
        0x000019E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E2,
        0x000019E2,
        0x000019E2
    };

    static _CharacterInfo _character000019E3 =
    {
        0x000019E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E3,
        0x000019E3,
        0x000019E3
    };

    static _CharacterInfo _character000019E4 =
    {
        0x000019E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E4,
        0x000019E4,
        0x000019E4
    };

    static _CharacterInfo _character000019E5 =
    {
        0x000019E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E5,
        0x000019E5,
        0x000019E5
    };

    static _CharacterInfo _character000019E6 =
    {
        0x000019E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E6,
        0x000019E6,
        0x000019E6
    };

    static _CharacterInfo _character000019E7 =
    {
        0x000019E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E7,
        0x000019E7,
        0x000019E7
    };

    static _CharacterInfo _character000019E8 =
    {
        0x000019E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E8,
        0x000019E8,
        0x000019E8
    };

    static _CharacterInfo _character000019E9 =
    {
        0x000019E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019E9,
        0x000019E9,
        0x000019E9
    };

    static _CharacterInfo _character000019EA =
    {
        0x000019EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019EA,
        0x000019EA,
        0x000019EA
    };

    static _CharacterInfo _character000019EB =
    {
        0x000019EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019EB,
        0x000019EB,
        0x000019EB
    };

    static _CharacterInfo _character000019EC =
    {
        0x000019EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019EC,
        0x000019EC,
        0x000019EC
    };

    static _CharacterInfo _character000019ED =
    {
        0x000019ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019ED,
        0x000019ED,
        0x000019ED
    };

    static _CharacterInfo _character000019EE =
    {
        0x000019EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019EE,
        0x000019EE,
        0x000019EE
    };

    static _CharacterInfo _character000019EF =
    {
        0x000019EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019EF,
        0x000019EF,
        0x000019EF
    };

    static _CharacterInfo _character000019F0 =
    {
        0x000019F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F0,
        0x000019F0,
        0x000019F0
    };

    static _CharacterInfo _character000019F1 =
    {
        0x000019F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F1,
        0x000019F1,
        0x000019F1
    };

    static _CharacterInfo _character000019F2 =
    {
        0x000019F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F2,
        0x000019F2,
        0x000019F2
    };

    static _CharacterInfo _character000019F3 =
    {
        0x000019F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F3,
        0x000019F3,
        0x000019F3
    };

    static _CharacterInfo _character000019F4 =
    {
        0x000019F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F4,
        0x000019F4,
        0x000019F4
    };

    static _CharacterInfo _character000019F5 =
    {
        0x000019F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F5,
        0x000019F5,
        0x000019F5
    };

    static _CharacterInfo _character000019F6 =
    {
        0x000019F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F6,
        0x000019F6,
        0x000019F6
    };

    static _CharacterInfo _character000019F7 =
    {
        0x000019F7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F7,
        0x000019F7,
        0x000019F7
    };

    static _CharacterInfo _character000019F8 =
    {
        0x000019F8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F8,
        0x000019F8,
        0x000019F8
    };

    static _CharacterInfo _character000019F9 =
    {
        0x000019F9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019F9,
        0x000019F9,
        0x000019F9
    };

    static _CharacterInfo _character000019FA =
    {
        0x000019FA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FA,
        0x000019FA,
        0x000019FA
    };

    static _CharacterInfo _character000019FB =
    {
        0x000019FB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FB,
        0x000019FB,
        0x000019FB
    };

    static _CharacterInfo _character000019FC =
    {
        0x000019FC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FC,
        0x000019FC,
        0x000019FC
    };

    static _CharacterInfo _character000019FD =
    {
        0x000019FD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FD,
        0x000019FD,
        0x000019FD
    };

    static _CharacterInfo _character000019FE =
    {
        0x000019FE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FE,
        0x000019FE,
        0x000019FE
    };

    static _CharacterInfo _character000019FF =
    {
        0x000019FF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000019FF,
        0x000019FF,
        0x000019FF
    };

    static _CharacterInfo _character00001A00 =
    {
        0x00001A00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A00,
        0x00001A00,
        0x00001A00
    };

    static _CharacterInfo _character00001A01 =
    {
        0x00001A01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A01,
        0x00001A01,
        0x00001A01
    };

    static _CharacterInfo _character00001A02 =
    {
        0x00001A02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A02,
        0x00001A02,
        0x00001A02
    };

    static _CharacterInfo _character00001A03 =
    {
        0x00001A03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A03,
        0x00001A03,
        0x00001A03
    };

    static _CharacterInfo _character00001A04 =
    {
        0x00001A04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A04,
        0x00001A04,
        0x00001A04
    };

    static _CharacterInfo _character00001A05 =
    {
        0x00001A05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A05,
        0x00001A05,
        0x00001A05
    };

    static _CharacterInfo _character00001A06 =
    {
        0x00001A06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A06,
        0x00001A06,
        0x00001A06
    };

    static _CharacterInfo _character00001A07 =
    {
        0x00001A07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A07,
        0x00001A07,
        0x00001A07
    };

    static _CharacterInfo _character00001A08 =
    {
        0x00001A08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A08,
        0x00001A08,
        0x00001A08
    };

    static _CharacterInfo _character00001A09 =
    {
        0x00001A09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A09,
        0x00001A09,
        0x00001A09
    };

    static _CharacterInfo _character00001A0A =
    {
        0x00001A0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0A,
        0x00001A0A,
        0x00001A0A
    };

    static _CharacterInfo _character00001A0B =
    {
        0x00001A0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0B,
        0x00001A0B,
        0x00001A0B
    };

    static _CharacterInfo _character00001A0C =
    {
        0x00001A0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0C,
        0x00001A0C,
        0x00001A0C
    };

    static _CharacterInfo _character00001A0D =
    {
        0x00001A0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0D,
        0x00001A0D,
        0x00001A0D
    };

    static _CharacterInfo _character00001A0E =
    {
        0x00001A0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0E,
        0x00001A0E,
        0x00001A0E
    };

    static _CharacterInfo _character00001A0F =
    {
        0x00001A0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A0F,
        0x00001A0F,
        0x00001A0F
    };

    static _CharacterInfo _character00001A10 =
    {
        0x00001A10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A10,
        0x00001A10,
        0x00001A10
    };

    static _CharacterInfo _character00001A11 =
    {
        0x00001A11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A11,
        0x00001A11,
        0x00001A11
    };

    static _CharacterInfo _character00001A12 =
    {
        0x00001A12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A12,
        0x00001A12,
        0x00001A12
    };

    static _CharacterInfo _character00001A13 =
    {
        0x00001A13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A13,
        0x00001A13,
        0x00001A13
    };

    static _CharacterInfo _character00001A14 =
    {
        0x00001A14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A14,
        0x00001A14,
        0x00001A14
    };

    static _CharacterInfo _character00001A15 =
    {
        0x00001A15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A15,
        0x00001A15,
        0x00001A15
    };

    static _CharacterInfo _character00001A16 =
    {
        0x00001A16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A16,
        0x00001A16,
        0x00001A16
    };

    static _CharacterInfo _character00001A17 =
    {
        0x00001A17,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A17,
        0x00001A17,
        0x00001A17
    };

    static _CharacterInfo _character00001A18 =
    {
        0x00001A18,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A18,
        0x00001A18,
        0x00001A18
    };

    static _CharacterInfo _character00001A19 =
    {
        0x00001A19,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A19,
        0x00001A19,
        0x00001A19
    };

    static _CharacterInfo _character00001A1A =
    {
        0x00001A1A,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A1A,
        0x00001A1A,
        0x00001A1A
    };

    static _CharacterInfo _character00001A1B =
    {
        0x00001A1B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A1B,
        0x00001A1B,
        0x00001A1B
    };

    static _CharacterInfo _character00001A1E =
    {
        0x00001A1E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A1E,
        0x00001A1E,
        0x00001A1E
    };

    static _CharacterInfo _character00001A1F =
    {
        0x00001A1F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001A1F,
        0x00001A1F,
        0x00001A1F
    };

    static _CharacterInfo _character00001B00 =
    {
        0x00001B00,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B00,
        0x00001B00,
        0x00001B00
    };

    static _CharacterInfo _character00001B01 =
    {
        0x00001B01,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B01,
        0x00001B01,
        0x00001B01
    };

    static _CharacterInfo _character00001B02 =
    {
        0x00001B02,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B02,
        0x00001B02,
        0x00001B02
    };

    static _CharacterInfo _character00001B03 =
    {
        0x00001B03,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B03,
        0x00001B03,
        0x00001B03
    };

    static _CharacterInfo _character00001B04 =
    {
        0x00001B04,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B04,
        0x00001B04,
        0x00001B04
    };

    static _CharacterInfo _character00001B05 =
    {
        0x00001B05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B05,
        0x00001B05,
        0x00001B05
    };

    static Char _decompositionMapping00001B06[] = 
    {
        0x00001B05,
        0x00001B35
    };

    static _CharacterInfo _character00001B06 =
    {
        0x00001B06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B06,
        0x00001B06,
        0x00001B06
    };

    static _CharacterInfo _character00001B07 =
    {
        0x00001B07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B07,
        0x00001B07,
        0x00001B07
    };

    static Char _decompositionMapping00001B08[] = 
    {
        0x00001B07,
        0x00001B35
    };

    static _CharacterInfo _character00001B08 =
    {
        0x00001B08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B08,
        0x00001B08,
        0x00001B08
    };

    static _CharacterInfo _character00001B09 =
    {
        0x00001B09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B09,
        0x00001B09,
        0x00001B09
    };

    static Char _decompositionMapping00001B0A[] = 
    {
        0x00001B09,
        0x00001B35
    };

    static _CharacterInfo _character00001B0A =
    {
        0x00001B0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0A,
        0x00001B0A,
        0x00001B0A
    };

    static _CharacterInfo _character00001B0B =
    {
        0x00001B0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0B,
        0x00001B0B,
        0x00001B0B
    };

    static Char _decompositionMapping00001B0C[] = 
    {
        0x00001B0B,
        0x00001B35
    };

    static _CharacterInfo _character00001B0C =
    {
        0x00001B0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0C,
        0x00001B0C,
        0x00001B0C
    };

    static _CharacterInfo _character00001B0D =
    {
        0x00001B0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0D,
        0x00001B0D,
        0x00001B0D
    };

    static Char _decompositionMapping00001B0E[] = 
    {
        0x00001B0D,
        0x00001B35
    };

    static _CharacterInfo _character00001B0E =
    {
        0x00001B0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0E,
        0x00001B0E,
        0x00001B0E
    };

    static _CharacterInfo _character00001B0F =
    {
        0x00001B0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B0F,
        0x00001B0F,
        0x00001B0F
    };

    static _CharacterInfo _character00001B10 =
    {
        0x00001B10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B10,
        0x00001B10,
        0x00001B10
    };

    static _CharacterInfo _character00001B11 =
    {
        0x00001B11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B11,
        0x00001B11,
        0x00001B11
    };

    static Char _decompositionMapping00001B12[] = 
    {
        0x00001B11,
        0x00001B35
    };

    static _CharacterInfo _character00001B12 =
    {
        0x00001B12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B12,
        0x00001B12,
        0x00001B12
    };

    static _CharacterInfo _character00001B13 =
    {
        0x00001B13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B13,
        0x00001B13,
        0x00001B13
    };

    static _CharacterInfo _character00001B14 =
    {
        0x00001B14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B14,
        0x00001B14,
        0x00001B14
    };

    static _CharacterInfo _character00001B15 =
    {
        0x00001B15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B15,
        0x00001B15,
        0x00001B15
    };

    static _CharacterInfo _character00001B16 =
    {
        0x00001B16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B16,
        0x00001B16,
        0x00001B16
    };

    static _CharacterInfo _character00001B17 =
    {
        0x00001B17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B17,
        0x00001B17,
        0x00001B17
    };

    static _CharacterInfo _character00001B18 =
    {
        0x00001B18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B18,
        0x00001B18,
        0x00001B18
    };

    static _CharacterInfo _character00001B19 =
    {
        0x00001B19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B19,
        0x00001B19,
        0x00001B19
    };

    static _CharacterInfo _character00001B1A =
    {
        0x00001B1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1A,
        0x00001B1A,
        0x00001B1A
    };

    static _CharacterInfo _character00001B1B =
    {
        0x00001B1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1B,
        0x00001B1B,
        0x00001B1B
    };

    static _CharacterInfo _character00001B1C =
    {
        0x00001B1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1C,
        0x00001B1C,
        0x00001B1C
    };

    static _CharacterInfo _character00001B1D =
    {
        0x00001B1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1D,
        0x00001B1D,
        0x00001B1D
    };

    static _CharacterInfo _character00001B1E =
    {
        0x00001B1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1E,
        0x00001B1E,
        0x00001B1E
    };

    static _CharacterInfo _character00001B1F =
    {
        0x00001B1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B1F,
        0x00001B1F,
        0x00001B1F
    };

    static _CharacterInfo _character00001B20 =
    {
        0x00001B20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B20,
        0x00001B20,
        0x00001B20
    };

    static _CharacterInfo _character00001B21 =
    {
        0x00001B21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B21,
        0x00001B21,
        0x00001B21
    };

    static _CharacterInfo _character00001B22 =
    {
        0x00001B22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B22,
        0x00001B22,
        0x00001B22
    };

    static _CharacterInfo _character00001B23 =
    {
        0x00001B23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B23,
        0x00001B23,
        0x00001B23
    };

    static _CharacterInfo _character00001B24 =
    {
        0x00001B24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B24,
        0x00001B24,
        0x00001B24
    };

    static _CharacterInfo _character00001B25 =
    {
        0x00001B25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B25,
        0x00001B25,
        0x00001B25
    };

    static _CharacterInfo _character00001B26 =
    {
        0x00001B26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B26,
        0x00001B26,
        0x00001B26
    };

    static _CharacterInfo _character00001B27 =
    {
        0x00001B27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B27,
        0x00001B27,
        0x00001B27
    };

    static _CharacterInfo _character00001B28 =
    {
        0x00001B28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B28,
        0x00001B28,
        0x00001B28
    };

    static _CharacterInfo _character00001B29 =
    {
        0x00001B29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B29,
        0x00001B29,
        0x00001B29
    };

    static _CharacterInfo _character00001B2A =
    {
        0x00001B2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2A,
        0x00001B2A,
        0x00001B2A
    };

    static _CharacterInfo _character00001B2B =
    {
        0x00001B2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2B,
        0x00001B2B,
        0x00001B2B
    };

    static _CharacterInfo _character00001B2C =
    {
        0x00001B2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2C,
        0x00001B2C,
        0x00001B2C
    };

    static _CharacterInfo _character00001B2D =
    {
        0x00001B2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2D,
        0x00001B2D,
        0x00001B2D
    };

    static _CharacterInfo _character00001B2E =
    {
        0x00001B2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2E,
        0x00001B2E,
        0x00001B2E
    };

    static _CharacterInfo _character00001B2F =
    {
        0x00001B2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B2F,
        0x00001B2F,
        0x00001B2F
    };

    static _CharacterInfo _character00001B30 =
    {
        0x00001B30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B30,
        0x00001B30,
        0x00001B30
    };

    static _CharacterInfo _character00001B31 =
    {
        0x00001B31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B31,
        0x00001B31,
        0x00001B31
    };

    static _CharacterInfo _character00001B32 =
    {
        0x00001B32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B32,
        0x00001B32,
        0x00001B32
    };

    static _CharacterInfo _character00001B33 =
    {
        0x00001B33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B33,
        0x00001B33,
        0x00001B33
    };

    static _CharacterInfo _character00001B34 =
    {
        0x00001B34,
        Iso10646::GeneralCategory_Mn,
        7,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B34,
        0x00001B34,
        0x00001B34
    };

    static _CharacterInfo _character00001B35 =
    {
        0x00001B35,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B35,
        0x00001B35,
        0x00001B35
    };

    static _CharacterInfo _character00001B36 =
    {
        0x00001B36,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B36,
        0x00001B36,
        0x00001B36
    };

    static _CharacterInfo _character00001B37 =
    {
        0x00001B37,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B37,
        0x00001B37,
        0x00001B37
    };

    static _CharacterInfo _character00001B38 =
    {
        0x00001B38,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B38,
        0x00001B38,
        0x00001B38
    };

    static _CharacterInfo _character00001B39 =
    {
        0x00001B39,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B39,
        0x00001B39,
        0x00001B39
    };

    static _CharacterInfo _character00001B3A =
    {
        0x00001B3A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3A,
        0x00001B3A,
        0x00001B3A
    };

    static Char _decompositionMapping00001B3B[] = 
    {
        0x00001B3A,
        0x00001B35
    };

    static _CharacterInfo _character00001B3B =
    {
        0x00001B3B,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3B,
        0x00001B3B,
        0x00001B3B
    };

    static _CharacterInfo _character00001B3C =
    {
        0x00001B3C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3C,
        0x00001B3C,
        0x00001B3C
    };

    static Char _decompositionMapping00001B3D[] = 
    {
        0x00001B3C,
        0x00001B35
    };

    static _CharacterInfo _character00001B3D =
    {
        0x00001B3D,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3D,
        0x00001B3D,
        0x00001B3D
    };

    static _CharacterInfo _character00001B3E =
    {
        0x00001B3E,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3E,
        0x00001B3E,
        0x00001B3E
    };

    static _CharacterInfo _character00001B3F =
    {
        0x00001B3F,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B3F,
        0x00001B3F,
        0x00001B3F
    };

    static Char _decompositionMapping00001B40[] = 
    {
        0x00001B3E,
        0x00001B35
    };

    static _CharacterInfo _character00001B40 =
    {
        0x00001B40,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B40,
        0x00001B40,
        0x00001B40
    };

    static Char _decompositionMapping00001B41[] = 
    {
        0x00001B3F,
        0x00001B35
    };

    static _CharacterInfo _character00001B41 =
    {
        0x00001B41,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B41,
        0x00001B41,
        0x00001B41
    };

    static _CharacterInfo _character00001B42 =
    {
        0x00001B42,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B42,
        0x00001B42,
        0x00001B42
    };

    static Char _decompositionMapping00001B43[] = 
    {
        0x00001B42,
        0x00001B35
    };

    static _CharacterInfo _character00001B43 =
    {
        0x00001B43,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001B43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B43,
        0x00001B43,
        0x00001B43
    };

    static _CharacterInfo _character00001B44 =
    {
        0x00001B44,
        Iso10646::GeneralCategory_Mc,
        9,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B44,
        0x00001B44,
        0x00001B44
    };

    static _CharacterInfo _character00001B45 =
    {
        0x00001B45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B45,
        0x00001B45,
        0x00001B45
    };

    static _CharacterInfo _character00001B46 =
    {
        0x00001B46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B46,
        0x00001B46,
        0x00001B46
    };

    static _CharacterInfo _character00001B47 =
    {
        0x00001B47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B47,
        0x00001B47,
        0x00001B47
    };

    static _CharacterInfo _character00001B48 =
    {
        0x00001B48,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B48,
        0x00001B48,
        0x00001B48
    };

    static _CharacterInfo _character00001B49 =
    {
        0x00001B49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B49,
        0x00001B49,
        0x00001B49
    };

    static _CharacterInfo _character00001B4A =
    {
        0x00001B4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B4A,
        0x00001B4A,
        0x00001B4A
    };

    static _CharacterInfo _character00001B4B =
    {
        0x00001B4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B4B,
        0x00001B4B,
        0x00001B4B
    };

    static _CharacterInfo _character00001B50 =
    {
        0x00001B50,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00001B50,
        0x00001B50,
        0x00001B50
    };

    static _CharacterInfo _character00001B51 =
    {
        0x00001B51,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00001B51,
        0x00001B51,
        0x00001B51
    };

    static _CharacterInfo _character00001B52 =
    {
        0x00001B52,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00001B52,
        0x00001B52,
        0x00001B52
    };

    static _CharacterInfo _character00001B53 =
    {
        0x00001B53,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00001B53,
        0x00001B53,
        0x00001B53
    };

    static _CharacterInfo _character00001B54 =
    {
        0x00001B54,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00001B54,
        0x00001B54,
        0x00001B54
    };

    static _CharacterInfo _character00001B55 =
    {
        0x00001B55,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00001B55,
        0x00001B55,
        0x00001B55
    };

    static _CharacterInfo _character00001B56 =
    {
        0x00001B56,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00001B56,
        0x00001B56,
        0x00001B56
    };

    static _CharacterInfo _character00001B57 =
    {
        0x00001B57,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00001B57,
        0x00001B57,
        0x00001B57
    };

    static _CharacterInfo _character00001B58 =
    {
        0x00001B58,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00001B58,
        0x00001B58,
        0x00001B58
    };

    static _CharacterInfo _character00001B59 =
    {
        0x00001B59,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00001B59,
        0x00001B59,
        0x00001B59
    };

    static _CharacterInfo _character00001B5A =
    {
        0x00001B5A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5A,
        0x00001B5A,
        0x00001B5A
    };

    static _CharacterInfo _character00001B5B =
    {
        0x00001B5B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5B,
        0x00001B5B,
        0x00001B5B
    };

    static _CharacterInfo _character00001B5C =
    {
        0x00001B5C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5C,
        0x00001B5C,
        0x00001B5C
    };

    static _CharacterInfo _character00001B5D =
    {
        0x00001B5D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5D,
        0x00001B5D,
        0x00001B5D
    };

    static _CharacterInfo _character00001B5E =
    {
        0x00001B5E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5E,
        0x00001B5E,
        0x00001B5E
    };

    static _CharacterInfo _character00001B5F =
    {
        0x00001B5F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B5F,
        0x00001B5F,
        0x00001B5F
    };

    static _CharacterInfo _character00001B60 =
    {
        0x00001B60,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B60,
        0x00001B60,
        0x00001B60
    };

    static _CharacterInfo _character00001B61 =
    {
        0x00001B61,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B61,
        0x00001B61,
        0x00001B61
    };

    static _CharacterInfo _character00001B62 =
    {
        0x00001B62,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B62,
        0x00001B62,
        0x00001B62
    };

    static _CharacterInfo _character00001B63 =
    {
        0x00001B63,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B63,
        0x00001B63,
        0x00001B63
    };

    static _CharacterInfo _character00001B64 =
    {
        0x00001B64,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B64,
        0x00001B64,
        0x00001B64
    };

    static _CharacterInfo _character00001B65 =
    {
        0x00001B65,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B65,
        0x00001B65,
        0x00001B65
    };

    static _CharacterInfo _character00001B66 =
    {
        0x00001B66,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B66,
        0x00001B66,
        0x00001B66
    };

    static _CharacterInfo _character00001B67 =
    {
        0x00001B67,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B67,
        0x00001B67,
        0x00001B67
    };

    static _CharacterInfo _character00001B68 =
    {
        0x00001B68,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B68,
        0x00001B68,
        0x00001B68
    };

    static _CharacterInfo _character00001B69 =
    {
        0x00001B69,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B69,
        0x00001B69,
        0x00001B69
    };

    static _CharacterInfo _character00001B6A =
    {
        0x00001B6A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6A,
        0x00001B6A,
        0x00001B6A
    };

    static _CharacterInfo _character00001B6B =
    {
        0x00001B6B,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6B,
        0x00001B6B,
        0x00001B6B
    };

    static _CharacterInfo _character00001B6C =
    {
        0x00001B6C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6C,
        0x00001B6C,
        0x00001B6C
    };

    static _CharacterInfo _character00001B6D =
    {
        0x00001B6D,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6D,
        0x00001B6D,
        0x00001B6D
    };

    static _CharacterInfo _character00001B6E =
    {
        0x00001B6E,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6E,
        0x00001B6E,
        0x00001B6E
    };

    static _CharacterInfo _character00001B6F =
    {
        0x00001B6F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B6F,
        0x00001B6F,
        0x00001B6F
    };

    static _CharacterInfo _character00001B70 =
    {
        0x00001B70,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B70,
        0x00001B70,
        0x00001B70
    };

    static _CharacterInfo _character00001B71 =
    {
        0x00001B71,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B71,
        0x00001B71,
        0x00001B71
    };

    static _CharacterInfo _character00001B72 =
    {
        0x00001B72,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B72,
        0x00001B72,
        0x00001B72
    };

    static _CharacterInfo _character00001B73 =
    {
        0x00001B73,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B73,
        0x00001B73,
        0x00001B73
    };

    static _CharacterInfo _character00001B74 =
    {
        0x00001B74,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B74,
        0x00001B74,
        0x00001B74
    };

    static _CharacterInfo _character00001B75 =
    {
        0x00001B75,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B75,
        0x00001B75,
        0x00001B75
    };

    static _CharacterInfo _character00001B76 =
    {
        0x00001B76,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B76,
        0x00001B76,
        0x00001B76
    };

    static _CharacterInfo _character00001B77 =
    {
        0x00001B77,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B77,
        0x00001B77,
        0x00001B77
    };

    static _CharacterInfo _character00001B78 =
    {
        0x00001B78,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B78,
        0x00001B78,
        0x00001B78
    };

    static _CharacterInfo _character00001B79 =
    {
        0x00001B79,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B79,
        0x00001B79,
        0x00001B79
    };

    static _CharacterInfo _character00001B7A =
    {
        0x00001B7A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B7A,
        0x00001B7A,
        0x00001B7A
    };

    static _CharacterInfo _character00001B7B =
    {
        0x00001B7B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B7B,
        0x00001B7B,
        0x00001B7B
    };

    static _CharacterInfo _character00001B7C =
    {
        0x00001B7C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001B7C,
        0x00001B7C,
        0x00001B7C
    };

    static _CharacterInfo _character00001D00 =
    {
        0x00001D00,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D00,
        0x00001D00,
        0x00001D00
    };

    static _CharacterInfo _character00001D01 =
    {
        0x00001D01,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D01,
        0x00001D01,
        0x00001D01
    };

    static _CharacterInfo _character00001D02 =
    {
        0x00001D02,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D02,
        0x00001D02,
        0x00001D02
    };

    static _CharacterInfo _character00001D03 =
    {
        0x00001D03,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D03,
        0x00001D03,
        0x00001D03
    };

    static _CharacterInfo _character00001D04 =
    {
        0x00001D04,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D04,
        0x00001D04,
        0x00001D04
    };

    static _CharacterInfo _character00001D05 =
    {
        0x00001D05,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D05,
        0x00001D05,
        0x00001D05
    };

    static _CharacterInfo _character00001D06 =
    {
        0x00001D06,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D06,
        0x00001D06,
        0x00001D06
    };

    static _CharacterInfo _character00001D07 =
    {
        0x00001D07,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D07,
        0x00001D07,
        0x00001D07
    };

    static _CharacterInfo _character00001D08 =
    {
        0x00001D08,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D08,
        0x00001D08,
        0x00001D08
    };

    static _CharacterInfo _character00001D09 =
    {
        0x00001D09,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D09,
        0x00001D09,
        0x00001D09
    };

    static _CharacterInfo _character00001D0A =
    {
        0x00001D0A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0A,
        0x00001D0A,
        0x00001D0A
    };

    static _CharacterInfo _character00001D0B =
    {
        0x00001D0B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0B,
        0x00001D0B,
        0x00001D0B
    };

    static _CharacterInfo _character00001D0C =
    {
        0x00001D0C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0C,
        0x00001D0C,
        0x00001D0C
    };

    static _CharacterInfo _character00001D0D =
    {
        0x00001D0D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0D,
        0x00001D0D,
        0x00001D0D
    };

    static _CharacterInfo _character00001D0E =
    {
        0x00001D0E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0E,
        0x00001D0E,
        0x00001D0E
    };

    static _CharacterInfo _character00001D0F =
    {
        0x00001D0F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D0F,
        0x00001D0F,
        0x00001D0F
    };

    static _CharacterInfo _character00001D10 =
    {
        0x00001D10,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D10,
        0x00001D10,
        0x00001D10
    };

    static _CharacterInfo _character00001D11 =
    {
        0x00001D11,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D11,
        0x00001D11,
        0x00001D11
    };

    static _CharacterInfo _character00001D12 =
    {
        0x00001D12,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D12,
        0x00001D12,
        0x00001D12
    };

    static _CharacterInfo _character00001D13 =
    {
        0x00001D13,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D13,
        0x00001D13,
        0x00001D13
    };

    static _CharacterInfo _character00001D14 =
    {
        0x00001D14,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D14,
        0x00001D14,
        0x00001D14
    };

    static _CharacterInfo _character00001D15 =
    {
        0x00001D15,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D15,
        0x00001D15,
        0x00001D15
    };

    static _CharacterInfo _character00001D16 =
    {
        0x00001D16,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D16,
        0x00001D16,
        0x00001D16
    };

    static _CharacterInfo _character00001D17 =
    {
        0x00001D17,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D17,
        0x00001D17,
        0x00001D17
    };

    static _CharacterInfo _character00001D18 =
    {
        0x00001D18,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D18,
        0x00001D18,
        0x00001D18
    };

    static _CharacterInfo _character00001D19 =
    {
        0x00001D19,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D19,
        0x00001D19,
        0x00001D19
    };

    static _CharacterInfo _character00001D1A =
    {
        0x00001D1A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1A,
        0x00001D1A,
        0x00001D1A
    };

    static _CharacterInfo _character00001D1B =
    {
        0x00001D1B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1B,
        0x00001D1B,
        0x00001D1B
    };

    static _CharacterInfo _character00001D1C =
    {
        0x00001D1C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1C,
        0x00001D1C,
        0x00001D1C
    };

    static _CharacterInfo _character00001D1D =
    {
        0x00001D1D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1D,
        0x00001D1D,
        0x00001D1D
    };

    static _CharacterInfo _character00001D1E =
    {
        0x00001D1E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1E,
        0x00001D1E,
        0x00001D1E
    };

    static _CharacterInfo _character00001D1F =
    {
        0x00001D1F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D1F,
        0x00001D1F,
        0x00001D1F
    };

    static _CharacterInfo _character00001D20 =
    {
        0x00001D20,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D20,
        0x00001D20,
        0x00001D20
    };

    static _CharacterInfo _character00001D21 =
    {
        0x00001D21,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D21,
        0x00001D21,
        0x00001D21
    };

    static _CharacterInfo _character00001D22 =
    {
        0x00001D22,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D22,
        0x00001D22,
        0x00001D22
    };

    static _CharacterInfo _character00001D23 =
    {
        0x00001D23,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D23,
        0x00001D23,
        0x00001D23
    };

    static _CharacterInfo _character00001D24 =
    {
        0x00001D24,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D24,
        0x00001D24,
        0x00001D24
    };

    static _CharacterInfo _character00001D25 =
    {
        0x00001D25,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D25,
        0x00001D25,
        0x00001D25
    };

    static _CharacterInfo _character00001D26 =
    {
        0x00001D26,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D26,
        0x00001D26,
        0x00001D26
    };

    static _CharacterInfo _character00001D27 =
    {
        0x00001D27,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D27,
        0x00001D27,
        0x00001D27
    };

    static _CharacterInfo _character00001D28 =
    {
        0x00001D28,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D28,
        0x00001D28,
        0x00001D28
    };

    static _CharacterInfo _character00001D29 =
    {
        0x00001D29,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D29,
        0x00001D29,
        0x00001D29
    };

    static _CharacterInfo _character00001D2A =
    {
        0x00001D2A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2A,
        0x00001D2A,
        0x00001D2A
    };

    static _CharacterInfo _character00001D2B =
    {
        0x00001D2B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2B,
        0x00001D2B,
        0x00001D2B
    };

    static Char _decompositionMapping00001D2C[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character00001D2C =
    {
        0x00001D2C,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2C,
        0x00001D2C,
        0x00001D2C
    };

    static Char _decompositionMapping00001D2D[] = 
    {
        0x000000C6
    };

    static _CharacterInfo _character00001D2D =
    {
        0x00001D2D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2D,
        0x00001D2D,
        0x00001D2D
    };

    static Char _decompositionMapping00001D2E[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character00001D2E =
    {
        0x00001D2E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2E,
        0x00001D2E,
        0x00001D2E
    };

    static _CharacterInfo _character00001D2F =
    {
        0x00001D2F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D2F,
        0x00001D2F,
        0x00001D2F
    };

    static Char _decompositionMapping00001D30[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character00001D30 =
    {
        0x00001D30,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D30,
        0x00001D30,
        0x00001D30
    };

    static Char _decompositionMapping00001D31[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character00001D31 =
    {
        0x00001D31,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D31,
        0x00001D31,
        0x00001D31
    };

    static Char _decompositionMapping00001D32[] = 
    {
        0x0000018E
    };

    static _CharacterInfo _character00001D32 =
    {
        0x00001D32,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D32,
        0x00001D32,
        0x00001D32
    };

    static Char _decompositionMapping00001D33[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character00001D33 =
    {
        0x00001D33,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D33,
        0x00001D33,
        0x00001D33
    };

    static Char _decompositionMapping00001D34[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character00001D34 =
    {
        0x00001D34,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D34,
        0x00001D34,
        0x00001D34
    };

    static Char _decompositionMapping00001D35[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character00001D35 =
    {
        0x00001D35,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D35,
        0x00001D35,
        0x00001D35
    };

    static Char _decompositionMapping00001D36[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character00001D36 =
    {
        0x00001D36,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D36,
        0x00001D36,
        0x00001D36
    };

    static Char _decompositionMapping00001D37[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character00001D37 =
    {
        0x00001D37,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D37,
        0x00001D37,
        0x00001D37
    };

    static Char _decompositionMapping00001D38[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character00001D38 =
    {
        0x00001D38,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D38,
        0x00001D38,
        0x00001D38
    };

    static Char _decompositionMapping00001D39[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character00001D39 =
    {
        0x00001D39,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D39,
        0x00001D39,
        0x00001D39
    };

    static Char _decompositionMapping00001D3A[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character00001D3A =
    {
        0x00001D3A,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3A,
        0x00001D3A,
        0x00001D3A
    };

    static _CharacterInfo _character00001D3B =
    {
        0x00001D3B,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3B,
        0x00001D3B,
        0x00001D3B
    };

    static Char _decompositionMapping00001D3C[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character00001D3C =
    {
        0x00001D3C,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3C,
        0x00001D3C,
        0x00001D3C
    };

    static Char _decompositionMapping00001D3D[] = 
    {
        0x00000222
    };

    static _CharacterInfo _character00001D3D =
    {
        0x00001D3D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3D,
        0x00001D3D,
        0x00001D3D
    };

    static Char _decompositionMapping00001D3E[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character00001D3E =
    {
        0x00001D3E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3E,
        0x00001D3E,
        0x00001D3E
    };

    static Char _decompositionMapping00001D3F[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character00001D3F =
    {
        0x00001D3F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D3F,
        0x00001D3F,
        0x00001D3F
    };

    static Char _decompositionMapping00001D40[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character00001D40 =
    {
        0x00001D40,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D40,
        0x00001D40,
        0x00001D40
    };

    static Char _decompositionMapping00001D41[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character00001D41 =
    {
        0x00001D41,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D41,
        0x00001D41,
        0x00001D41
    };

    static Char _decompositionMapping00001D42[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character00001D42 =
    {
        0x00001D42,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D42,
        0x00001D42,
        0x00001D42
    };

    static Char _decompositionMapping00001D43[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character00001D43 =
    {
        0x00001D43,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D43,
        0x00001D43,
        0x00001D43
    };

    static Char _decompositionMapping00001D44[] = 
    {
        0x00000250
    };

    static _CharacterInfo _character00001D44 =
    {
        0x00001D44,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D44,
        0x00001D44,
        0x00001D44
    };

    static Char _decompositionMapping00001D45[] = 
    {
        0x00000251
    };

    static _CharacterInfo _character00001D45 =
    {
        0x00001D45,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D45,
        0x00001D45,
        0x00001D45
    };

    static Char _decompositionMapping00001D46[] = 
    {
        0x00001D02
    };

    static _CharacterInfo _character00001D46 =
    {
        0x00001D46,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D46,
        0x00001D46,
        0x00001D46
    };

    static Char _decompositionMapping00001D47[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character00001D47 =
    {
        0x00001D47,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D47,
        0x00001D47,
        0x00001D47
    };

    static Char _decompositionMapping00001D48[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character00001D48 =
    {
        0x00001D48,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D48,
        0x00001D48,
        0x00001D48
    };

    static Char _decompositionMapping00001D49[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character00001D49 =
    {
        0x00001D49,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D49,
        0x00001D49,
        0x00001D49
    };

    static Char _decompositionMapping00001D4A[] = 
    {
        0x00000259
    };

    static _CharacterInfo _character00001D4A =
    {
        0x00001D4A,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4A,
        0x00001D4A,
        0x00001D4A
    };

    static Char _decompositionMapping00001D4B[] = 
    {
        0x0000025B
    };

    static _CharacterInfo _character00001D4B =
    {
        0x00001D4B,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4B,
        0x00001D4B,
        0x00001D4B
    };

    static Char _decompositionMapping00001D4C[] = 
    {
        0x0000025C
    };

    static _CharacterInfo _character00001D4C =
    {
        0x00001D4C,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4C,
        0x00001D4C,
        0x00001D4C
    };

    static Char _decompositionMapping00001D4D[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character00001D4D =
    {
        0x00001D4D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4D,
        0x00001D4D,
        0x00001D4D
    };

    static _CharacterInfo _character00001D4E =
    {
        0x00001D4E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4E,
        0x00001D4E,
        0x00001D4E
    };

    static Char _decompositionMapping00001D4F[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character00001D4F =
    {
        0x00001D4F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D4F,
        0x00001D4F,
        0x00001D4F
    };

    static Char _decompositionMapping00001D50[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character00001D50 =
    {
        0x00001D50,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D50,
        0x00001D50,
        0x00001D50
    };

    static Char _decompositionMapping00001D51[] = 
    {
        0x0000014B
    };

    static _CharacterInfo _character00001D51 =
    {
        0x00001D51,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D51,
        0x00001D51,
        0x00001D51
    };

    static Char _decompositionMapping00001D52[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character00001D52 =
    {
        0x00001D52,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D52,
        0x00001D52,
        0x00001D52
    };

    static Char _decompositionMapping00001D53[] = 
    {
        0x00000254
    };

    static _CharacterInfo _character00001D53 =
    {
        0x00001D53,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D53,
        0x00001D53,
        0x00001D53
    };

    static Char _decompositionMapping00001D54[] = 
    {
        0x00001D16
    };

    static _CharacterInfo _character00001D54 =
    {
        0x00001D54,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D54,
        0x00001D54,
        0x00001D54
    };

    static Char _decompositionMapping00001D55[] = 
    {
        0x00001D17
    };

    static _CharacterInfo _character00001D55 =
    {
        0x00001D55,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D55,
        0x00001D55,
        0x00001D55
    };

    static Char _decompositionMapping00001D56[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character00001D56 =
    {
        0x00001D56,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D56,
        0x00001D56,
        0x00001D56
    };

    static Char _decompositionMapping00001D57[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character00001D57 =
    {
        0x00001D57,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D57,
        0x00001D57,
        0x00001D57
    };

    static Char _decompositionMapping00001D58[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character00001D58 =
    {
        0x00001D58,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D58,
        0x00001D58,
        0x00001D58
    };

    static Char _decompositionMapping00001D59[] = 
    {
        0x00001D1D
    };

    static _CharacterInfo _character00001D59 =
    {
        0x00001D59,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D59,
        0x00001D59,
        0x00001D59
    };

    static Char _decompositionMapping00001D5A[] = 
    {
        0x0000026F
    };

    static _CharacterInfo _character00001D5A =
    {
        0x00001D5A,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5A,
        0x00001D5A,
        0x00001D5A
    };

    static Char _decompositionMapping00001D5B[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character00001D5B =
    {
        0x00001D5B,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5B,
        0x00001D5B,
        0x00001D5B
    };

    static Char _decompositionMapping00001D5C[] = 
    {
        0x00001D25
    };

    static _CharacterInfo _character00001D5C =
    {
        0x00001D5C,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5C,
        0x00001D5C,
        0x00001D5C
    };

    static Char _decompositionMapping00001D5D[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character00001D5D =
    {
        0x00001D5D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5D,
        0x00001D5D,
        0x00001D5D
    };

    static Char _decompositionMapping00001D5E[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character00001D5E =
    {
        0x00001D5E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5E,
        0x00001D5E,
        0x00001D5E
    };

    static Char _decompositionMapping00001D5F[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character00001D5F =
    {
        0x00001D5F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D5F,
        0x00001D5F,
        0x00001D5F
    };

    static Char _decompositionMapping00001D60[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character00001D60 =
    {
        0x00001D60,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D60,
        0x00001D60,
        0x00001D60
    };

    static Char _decompositionMapping00001D61[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character00001D61 =
    {
        0x00001D61,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D61,
        0x00001D61,
        0x00001D61
    };

    static Char _decompositionMapping00001D62[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character00001D62 =
    {
        0x00001D62,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D62,
        0x00001D62,
        0x00001D62
    };

    static Char _decompositionMapping00001D63[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character00001D63 =
    {
        0x00001D63,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D63,
        0x00001D63,
        0x00001D63
    };

    static Char _decompositionMapping00001D64[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character00001D64 =
    {
        0x00001D64,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D64,
        0x00001D64,
        0x00001D64
    };

    static Char _decompositionMapping00001D65[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character00001D65 =
    {
        0x00001D65,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D65,
        0x00001D65,
        0x00001D65
    };

    static Char _decompositionMapping00001D66[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character00001D66 =
    {
        0x00001D66,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D66,
        0x00001D66,
        0x00001D66
    };

    static Char _decompositionMapping00001D67[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character00001D67 =
    {
        0x00001D67,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D67,
        0x00001D67,
        0x00001D67
    };

    static Char _decompositionMapping00001D68[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character00001D68 =
    {
        0x00001D68,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D68,
        0x00001D68,
        0x00001D68
    };

    static Char _decompositionMapping00001D69[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character00001D69 =
    {
        0x00001D69,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D69,
        0x00001D69,
        0x00001D69
    };

    static Char _decompositionMapping00001D6A[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character00001D6A =
    {
        0x00001D6A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00001D6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6A,
        0x00001D6A,
        0x00001D6A
    };

    static _CharacterInfo _character00001D6B =
    {
        0x00001D6B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6B,
        0x00001D6B,
        0x00001D6B
    };

    static _CharacterInfo _character00001D6C =
    {
        0x00001D6C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6C,
        0x00001D6C,
        0x00001D6C
    };

    static _CharacterInfo _character00001D6D =
    {
        0x00001D6D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6D,
        0x00001D6D,
        0x00001D6D
    };

    static _CharacterInfo _character00001D6E =
    {
        0x00001D6E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6E,
        0x00001D6E,
        0x00001D6E
    };

    static _CharacterInfo _character00001D6F =
    {
        0x00001D6F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D6F,
        0x00001D6F,
        0x00001D6F
    };

    static _CharacterInfo _character00001D70 =
    {
        0x00001D70,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D70,
        0x00001D70,
        0x00001D70
    };

    static _CharacterInfo _character00001D71 =
    {
        0x00001D71,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D71,
        0x00001D71,
        0x00001D71
    };

    static _CharacterInfo _character00001D72 =
    {
        0x00001D72,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D72,
        0x00001D72,
        0x00001D72
    };

    static _CharacterInfo _character00001D73 =
    {
        0x00001D73,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D73,
        0x00001D73,
        0x00001D73
    };

    static _CharacterInfo _character00001D74 =
    {
        0x00001D74,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D74,
        0x00001D74,
        0x00001D74
    };

    static _CharacterInfo _character00001D75 =
    {
        0x00001D75,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D75,
        0x00001D75,
        0x00001D75
    };

    static _CharacterInfo _character00001D76 =
    {
        0x00001D76,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D76,
        0x00001D76,
        0x00001D76
    };

    static _CharacterInfo _character00001D77 =
    {
        0x00001D77,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D77,
        0x00001D77,
        0x00001D77
    };

    static Char _decompositionMapping00001D78[] = 
    {
        0x0000043D
    };

    static _CharacterInfo _character00001D78 =
    {
        0x00001D78,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D78,
        0x00001D78,
        0x00001D78
    };

    static _CharacterInfo _character00001D79 =
    {
        0x00001D79,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D79,
        0x00001D79,
        0x00001D79
    };

    static _CharacterInfo _character00001D7A =
    {
        0x00001D7A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D7A,
        0x00001D7A,
        0x00001D7A
    };

    static _CharacterInfo _character00001D7B =
    {
        0x00001D7B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D7B,
        0x00001D7B,
        0x00001D7B
    };

    static _CharacterInfo _character00001D7C =
    {
        0x00001D7C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D7C,
        0x00001D7C,
        0x00001D7C
    };

    static _CharacterInfo _character00001D7D =
    {
        0x00001D7D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C63,
        0x00001D7D,
        0x00002C63
    };

    static _CharacterInfo _character00001D7E =
    {
        0x00001D7E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D7E,
        0x00001D7E,
        0x00001D7E
    };

    static _CharacterInfo _character00001D7F =
    {
        0x00001D7F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D7F,
        0x00001D7F,
        0x00001D7F
    };

    static _CharacterInfo _character00001D80 =
    {
        0x00001D80,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D80,
        0x00001D80,
        0x00001D80
    };

    static _CharacterInfo _character00001D81 =
    {
        0x00001D81,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D81,
        0x00001D81,
        0x00001D81
    };

    static _CharacterInfo _character00001D82 =
    {
        0x00001D82,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D82,
        0x00001D82,
        0x00001D82
    };

    static _CharacterInfo _character00001D83 =
    {
        0x00001D83,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D83,
        0x00001D83,
        0x00001D83
    };

    static _CharacterInfo _character00001D84 =
    {
        0x00001D84,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D84,
        0x00001D84,
        0x00001D84
    };

    static _CharacterInfo _character00001D85 =
    {
        0x00001D85,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D85,
        0x00001D85,
        0x00001D85
    };

    static _CharacterInfo _character00001D86 =
    {
        0x00001D86,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D86,
        0x00001D86,
        0x00001D86
    };

    static _CharacterInfo _character00001D87 =
    {
        0x00001D87,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D87,
        0x00001D87,
        0x00001D87
    };

    static _CharacterInfo _character00001D88 =
    {
        0x00001D88,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D88,
        0x00001D88,
        0x00001D88
    };

    static _CharacterInfo _character00001D89 =
    {
        0x00001D89,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D89,
        0x00001D89,
        0x00001D89
    };

    static _CharacterInfo _character00001D8A =
    {
        0x00001D8A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8A,
        0x00001D8A,
        0x00001D8A
    };

    static _CharacterInfo _character00001D8B =
    {
        0x00001D8B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8B,
        0x00001D8B,
        0x00001D8B
    };

    static _CharacterInfo _character00001D8C =
    {
        0x00001D8C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8C,
        0x00001D8C,
        0x00001D8C
    };

    static _CharacterInfo _character00001D8D =
    {
        0x00001D8D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8D,
        0x00001D8D,
        0x00001D8D
    };

    static _CharacterInfo _character00001D8E =
    {
        0x00001D8E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8E,
        0x00001D8E,
        0x00001D8E
    };

    static _CharacterInfo _character00001D8F =
    {
        0x00001D8F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D8F,
        0x00001D8F,
        0x00001D8F
    };

    static _CharacterInfo _character00001D90 =
    {
        0x00001D90,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D90,
        0x00001D90,
        0x00001D90
    };

    static _CharacterInfo _character00001D91 =
    {
        0x00001D91,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D91,
        0x00001D91,
        0x00001D91
    };

    static _CharacterInfo _character00001D92 =
    {
        0x00001D92,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D92,
        0x00001D92,
        0x00001D92
    };

    static _CharacterInfo _character00001D93 =
    {
        0x00001D93,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D93,
        0x00001D93,
        0x00001D93
    };

    static _CharacterInfo _character00001D94 =
    {
        0x00001D94,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D94,
        0x00001D94,
        0x00001D94
    };

    static _CharacterInfo _character00001D95 =
    {
        0x00001D95,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D95,
        0x00001D95,
        0x00001D95
    };

    static _CharacterInfo _character00001D96 =
    {
        0x00001D96,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D96,
        0x00001D96,
        0x00001D96
    };

    static _CharacterInfo _character00001D97 =
    {
        0x00001D97,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D97,
        0x00001D97,
        0x00001D97
    };

    static _CharacterInfo _character00001D98 =
    {
        0x00001D98,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D98,
        0x00001D98,
        0x00001D98
    };

    static _CharacterInfo _character00001D99 =
    {
        0x00001D99,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D99,
        0x00001D99,
        0x00001D99
    };

    static _CharacterInfo _character00001D9A =
    {
        0x00001D9A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9A,
        0x00001D9A,
        0x00001D9A
    };

    static Char _decompositionMapping00001D9B[] = 
    {
        0x00000252
    };

    static _CharacterInfo _character00001D9B =
    {
        0x00001D9B,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9B,
        0x00001D9B,
        0x00001D9B
    };

    static Char _decompositionMapping00001D9C[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character00001D9C =
    {
        0x00001D9C,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9C,
        0x00001D9C,
        0x00001D9C
    };

    static Char _decompositionMapping00001D9D[] = 
    {
        0x00000255
    };

    static _CharacterInfo _character00001D9D =
    {
        0x00001D9D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9D,
        0x00001D9D,
        0x00001D9D
    };

    static Char _decompositionMapping00001D9E[] = 
    {
        0x000000F0
    };

    static _CharacterInfo _character00001D9E =
    {
        0x00001D9E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9E,
        0x00001D9E,
        0x00001D9E
    };

    static Char _decompositionMapping00001D9F[] = 
    {
        0x0000025C
    };

    static _CharacterInfo _character00001D9F =
    {
        0x00001D9F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001D9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001D9F,
        0x00001D9F,
        0x00001D9F
    };

    static Char _decompositionMapping00001DA0[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character00001DA0 =
    {
        0x00001DA0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA0,
        0x00001DA0,
        0x00001DA0
    };

    static Char _decompositionMapping00001DA1[] = 
    {
        0x0000025F
    };

    static _CharacterInfo _character00001DA1 =
    {
        0x00001DA1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA1,
        0x00001DA1,
        0x00001DA1
    };

    static Char _decompositionMapping00001DA2[] = 
    {
        0x00000261
    };

    static _CharacterInfo _character00001DA2 =
    {
        0x00001DA2,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA2,
        0x00001DA2,
        0x00001DA2
    };

    static Char _decompositionMapping00001DA3[] = 
    {
        0x00000265
    };

    static _CharacterInfo _character00001DA3 =
    {
        0x00001DA3,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA3,
        0x00001DA3,
        0x00001DA3
    };

    static Char _decompositionMapping00001DA4[] = 
    {
        0x00000268
    };

    static _CharacterInfo _character00001DA4 =
    {
        0x00001DA4,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA4,
        0x00001DA4,
        0x00001DA4
    };

    static Char _decompositionMapping00001DA5[] = 
    {
        0x00000269
    };

    static _CharacterInfo _character00001DA5 =
    {
        0x00001DA5,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA5,
        0x00001DA5,
        0x00001DA5
    };

    static Char _decompositionMapping00001DA6[] = 
    {
        0x0000026A
    };

    static _CharacterInfo _character00001DA6 =
    {
        0x00001DA6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA6,
        0x00001DA6,
        0x00001DA6
    };

    static Char _decompositionMapping00001DA7[] = 
    {
        0x00001D7B
    };

    static _CharacterInfo _character00001DA7 =
    {
        0x00001DA7,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA7,
        0x00001DA7,
        0x00001DA7
    };

    static Char _decompositionMapping00001DA8[] = 
    {
        0x0000029D
    };

    static _CharacterInfo _character00001DA8 =
    {
        0x00001DA8,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA8,
        0x00001DA8,
        0x00001DA8
    };

    static Char _decompositionMapping00001DA9[] = 
    {
        0x0000026D
    };

    static _CharacterInfo _character00001DA9 =
    {
        0x00001DA9,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DA9,
        0x00001DA9,
        0x00001DA9
    };

    static Char _decompositionMapping00001DAA[] = 
    {
        0x00001D85
    };

    static _CharacterInfo _character00001DAA =
    {
        0x00001DAA,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAA,
        0x00001DAA,
        0x00001DAA
    };

    static Char _decompositionMapping00001DAB[] = 
    {
        0x0000029F
    };

    static _CharacterInfo _character00001DAB =
    {
        0x00001DAB,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAB,
        0x00001DAB,
        0x00001DAB
    };

    static Char _decompositionMapping00001DAC[] = 
    {
        0x00000271
    };

    static _CharacterInfo _character00001DAC =
    {
        0x00001DAC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAC,
        0x00001DAC,
        0x00001DAC
    };

    static Char _decompositionMapping00001DAD[] = 
    {
        0x00000270
    };

    static _CharacterInfo _character00001DAD =
    {
        0x00001DAD,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAD,
        0x00001DAD,
        0x00001DAD
    };

    static Char _decompositionMapping00001DAE[] = 
    {
        0x00000272
    };

    static _CharacterInfo _character00001DAE =
    {
        0x00001DAE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAE,
        0x00001DAE,
        0x00001DAE
    };

    static Char _decompositionMapping00001DAF[] = 
    {
        0x00000273
    };

    static _CharacterInfo _character00001DAF =
    {
        0x00001DAF,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DAF,
        0x00001DAF,
        0x00001DAF
    };

    static Char _decompositionMapping00001DB0[] = 
    {
        0x00000274
    };

    static _CharacterInfo _character00001DB0 =
    {
        0x00001DB0,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB0,
        0x00001DB0,
        0x00001DB0
    };

    static Char _decompositionMapping00001DB1[] = 
    {
        0x00000275
    };

    static _CharacterInfo _character00001DB1 =
    {
        0x00001DB1,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB1,
        0x00001DB1,
        0x00001DB1
    };

    static Char _decompositionMapping00001DB2[] = 
    {
        0x00000278
    };

    static _CharacterInfo _character00001DB2 =
    {
        0x00001DB2,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB2,
        0x00001DB2,
        0x00001DB2
    };

    static Char _decompositionMapping00001DB3[] = 
    {
        0x00000282
    };

    static _CharacterInfo _character00001DB3 =
    {
        0x00001DB3,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB3,
        0x00001DB3,
        0x00001DB3
    };

    static Char _decompositionMapping00001DB4[] = 
    {
        0x00000283
    };

    static _CharacterInfo _character00001DB4 =
    {
        0x00001DB4,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB4,
        0x00001DB4,
        0x00001DB4
    };

    static Char _decompositionMapping00001DB5[] = 
    {
        0x000001AB
    };

    static _CharacterInfo _character00001DB5 =
    {
        0x00001DB5,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB5,
        0x00001DB5,
        0x00001DB5
    };

    static Char _decompositionMapping00001DB6[] = 
    {
        0x00000289
    };

    static _CharacterInfo _character00001DB6 =
    {
        0x00001DB6,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB6,
        0x00001DB6,
        0x00001DB6
    };

    static Char _decompositionMapping00001DB7[] = 
    {
        0x0000028A
    };

    static _CharacterInfo _character00001DB7 =
    {
        0x00001DB7,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB7,
        0x00001DB7,
        0x00001DB7
    };

    static Char _decompositionMapping00001DB8[] = 
    {
        0x00001D1C
    };

    static _CharacterInfo _character00001DB8 =
    {
        0x00001DB8,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB8,
        0x00001DB8,
        0x00001DB8
    };

    static Char _decompositionMapping00001DB9[] = 
    {
        0x0000028B
    };

    static _CharacterInfo _character00001DB9 =
    {
        0x00001DB9,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DB9,
        0x00001DB9,
        0x00001DB9
    };

    static Char _decompositionMapping00001DBA[] = 
    {
        0x0000028C
    };

    static _CharacterInfo _character00001DBA =
    {
        0x00001DBA,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBA,
        0x00001DBA,
        0x00001DBA
    };

    static Char _decompositionMapping00001DBB[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character00001DBB =
    {
        0x00001DBB,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBB,
        0x00001DBB,
        0x00001DBB
    };

    static Char _decompositionMapping00001DBC[] = 
    {
        0x00000290
    };

    static _CharacterInfo _character00001DBC =
    {
        0x00001DBC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBC,
        0x00001DBC,
        0x00001DBC
    };

    static Char _decompositionMapping00001DBD[] = 
    {
        0x00000291
    };

    static _CharacterInfo _character00001DBD =
    {
        0x00001DBD,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBD,
        0x00001DBD,
        0x00001DBD
    };

    static Char _decompositionMapping00001DBE[] = 
    {
        0x00000292
    };

    static _CharacterInfo _character00001DBE =
    {
        0x00001DBE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBE,
        0x00001DBE,
        0x00001DBE
    };

    static Char _decompositionMapping00001DBF[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character00001DBF =
    {
        0x00001DBF,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00001DBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DBF,
        0x00001DBF,
        0x00001DBF
    };

    static _CharacterInfo _character00001DC0 =
    {
        0x00001DC0,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC0,
        0x00001DC0,
        0x00001DC0
    };

    static _CharacterInfo _character00001DC1 =
    {
        0x00001DC1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC1,
        0x00001DC1,
        0x00001DC1
    };

    static _CharacterInfo _character00001DC2 =
    {
        0x00001DC2,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC2,
        0x00001DC2,
        0x00001DC2
    };

    static _CharacterInfo _character00001DC3 =
    {
        0x00001DC3,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC3,
        0x00001DC3,
        0x00001DC3
    };

    static _CharacterInfo _character00001DC4 =
    {
        0x00001DC4,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC4,
        0x00001DC4,
        0x00001DC4
    };

    static _CharacterInfo _character00001DC5 =
    {
        0x00001DC5,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC5,
        0x00001DC5,
        0x00001DC5
    };

    static _CharacterInfo _character00001DC6 =
    {
        0x00001DC6,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC6,
        0x00001DC6,
        0x00001DC6
    };

    static _CharacterInfo _character00001DC7 =
    {
        0x00001DC7,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC7,
        0x00001DC7,
        0x00001DC7
    };

    static _CharacterInfo _character00001DC8 =
    {
        0x00001DC8,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC8,
        0x00001DC8,
        0x00001DC8
    };

    static _CharacterInfo _character00001DC9 =
    {
        0x00001DC9,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DC9,
        0x00001DC9,
        0x00001DC9
    };

    static _CharacterInfo _character00001DCA =
    {
        0x00001DCA,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DCA,
        0x00001DCA,
        0x00001DCA
    };

    static _CharacterInfo _character00001DFE =
    {
        0x00001DFE,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DFE,
        0x00001DFE,
        0x00001DFE
    };

    static _CharacterInfo _character00001DFF =
    {
        0x00001DFF,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001DFF,
        0x00001DFF,
        0x00001DFF
    };

    static Char _decompositionMapping00001E00[] = 
    {
        0x00000041,
        0x00000325
    };

    static _CharacterInfo _character00001E00 =
    {
        0x00001E00,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E00,
        0x00001E01,
        0x00001E00
    };

    static Char _decompositionMapping00001E01[] = 
    {
        0x00000061,
        0x00000325
    };

    static _CharacterInfo _character00001E01 =
    {
        0x00001E01,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E00,
        0x00001E01,
        0x00001E00
    };

    static Char _decompositionMapping00001E02[] = 
    {
        0x00000042,
        0x00000307
    };

    static _CharacterInfo _character00001E02 =
    {
        0x00001E02,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E02,
        0x00001E03,
        0x00001E02
    };

    static Char _decompositionMapping00001E03[] = 
    {
        0x00000062,
        0x00000307
    };

    static _CharacterInfo _character00001E03 =
    {
        0x00001E03,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E02,
        0x00001E03,
        0x00001E02
    };

    static Char _decompositionMapping00001E04[] = 
    {
        0x00000042,
        0x00000323
    };

    static _CharacterInfo _character00001E04 =
    {
        0x00001E04,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E04,
        0x00001E05,
        0x00001E04
    };

    static Char _decompositionMapping00001E05[] = 
    {
        0x00000062,
        0x00000323
    };

    static _CharacterInfo _character00001E05 =
    {
        0x00001E05,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E04,
        0x00001E05,
        0x00001E04
    };

    static Char _decompositionMapping00001E06[] = 
    {
        0x00000042,
        0x00000331
    };

    static _CharacterInfo _character00001E06 =
    {
        0x00001E06,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E06,
        0x00001E07,
        0x00001E06
    };

    static Char _decompositionMapping00001E07[] = 
    {
        0x00000062,
        0x00000331
    };

    static _CharacterInfo _character00001E07 =
    {
        0x00001E07,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E06,
        0x00001E07,
        0x00001E06
    };

    static Char _decompositionMapping00001E08[] = 
    {
        0x000000C7,
        0x00000301
    };

    static _CharacterInfo _character00001E08 =
    {
        0x00001E08,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E08,
        0x00001E09,
        0x00001E08
    };

    static Char _decompositionMapping00001E09[] = 
    {
        0x000000E7,
        0x00000301
    };

    static _CharacterInfo _character00001E09 =
    {
        0x00001E09,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E08,
        0x00001E09,
        0x00001E08
    };

    static Char _decompositionMapping00001E0A[] = 
    {
        0x00000044,
        0x00000307
    };

    static _CharacterInfo _character00001E0A =
    {
        0x00001E0A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0A,
        0x00001E0B,
        0x00001E0A
    };

    static Char _decompositionMapping00001E0B[] = 
    {
        0x00000064,
        0x00000307
    };

    static _CharacterInfo _character00001E0B =
    {
        0x00001E0B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0A,
        0x00001E0B,
        0x00001E0A
    };

    static Char _decompositionMapping00001E0C[] = 
    {
        0x00000044,
        0x00000323
    };

    static _CharacterInfo _character00001E0C =
    {
        0x00001E0C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0C,
        0x00001E0D,
        0x00001E0C
    };

    static Char _decompositionMapping00001E0D[] = 
    {
        0x00000064,
        0x00000323
    };

    static _CharacterInfo _character00001E0D =
    {
        0x00001E0D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0C,
        0x00001E0D,
        0x00001E0C
    };

    static Char _decompositionMapping00001E0E[] = 
    {
        0x00000044,
        0x00000331
    };

    static _CharacterInfo _character00001E0E =
    {
        0x00001E0E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0E,
        0x00001E0F,
        0x00001E0E
    };

    static Char _decompositionMapping00001E0F[] = 
    {
        0x00000064,
        0x00000331
    };

    static _CharacterInfo _character00001E0F =
    {
        0x00001E0F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E0E,
        0x00001E0F,
        0x00001E0E
    };

    static Char _decompositionMapping00001E10[] = 
    {
        0x00000044,
        0x00000327
    };

    static _CharacterInfo _character00001E10 =
    {
        0x00001E10,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E10,
        0x00001E11,
        0x00001E10
    };

    static Char _decompositionMapping00001E11[] = 
    {
        0x00000064,
        0x00000327
    };

    static _CharacterInfo _character00001E11 =
    {
        0x00001E11,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E10,
        0x00001E11,
        0x00001E10
    };

    static Char _decompositionMapping00001E12[] = 
    {
        0x00000044,
        0x0000032D
    };

    static _CharacterInfo _character00001E12 =
    {
        0x00001E12,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E12,
        0x00001E13,
        0x00001E12
    };

    static Char _decompositionMapping00001E13[] = 
    {
        0x00000064,
        0x0000032D
    };

    static _CharacterInfo _character00001E13 =
    {
        0x00001E13,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E12,
        0x00001E13,
        0x00001E12
    };

    static Char _decompositionMapping00001E14[] = 
    {
        0x00000112,
        0x00000300
    };

    static _CharacterInfo _character00001E14 =
    {
        0x00001E14,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E14,
        0x00001E15,
        0x00001E14
    };

    static Char _decompositionMapping00001E15[] = 
    {
        0x00000113,
        0x00000300
    };

    static _CharacterInfo _character00001E15 =
    {
        0x00001E15,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E14,
        0x00001E15,
        0x00001E14
    };

    static Char _decompositionMapping00001E16[] = 
    {
        0x00000112,
        0x00000301
    };

    static _CharacterInfo _character00001E16 =
    {
        0x00001E16,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E16,
        0x00001E17,
        0x00001E16
    };

    static Char _decompositionMapping00001E17[] = 
    {
        0x00000113,
        0x00000301
    };

    static _CharacterInfo _character00001E17 =
    {
        0x00001E17,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E16,
        0x00001E17,
        0x00001E16
    };

    static Char _decompositionMapping00001E18[] = 
    {
        0x00000045,
        0x0000032D
    };

    static _CharacterInfo _character00001E18 =
    {
        0x00001E18,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E18,
        0x00001E19,
        0x00001E18
    };

    static Char _decompositionMapping00001E19[] = 
    {
        0x00000065,
        0x0000032D
    };

    static _CharacterInfo _character00001E19 =
    {
        0x00001E19,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E18,
        0x00001E19,
        0x00001E18
    };

    static Char _decompositionMapping00001E1A[] = 
    {
        0x00000045,
        0x00000330
    };

    static _CharacterInfo _character00001E1A =
    {
        0x00001E1A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1A,
        0x00001E1B,
        0x00001E1A
    };

    static Char _decompositionMapping00001E1B[] = 
    {
        0x00000065,
        0x00000330
    };

    static _CharacterInfo _character00001E1B =
    {
        0x00001E1B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1A,
        0x00001E1B,
        0x00001E1A
    };

    static Char _decompositionMapping00001E1C[] = 
    {
        0x00000228,
        0x00000306
    };

    static _CharacterInfo _character00001E1C =
    {
        0x00001E1C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1C,
        0x00001E1D,
        0x00001E1C
    };

    static Char _decompositionMapping00001E1D[] = 
    {
        0x00000229,
        0x00000306
    };

    static _CharacterInfo _character00001E1D =
    {
        0x00001E1D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1C,
        0x00001E1D,
        0x00001E1C
    };

    static Char _decompositionMapping00001E1E[] = 
    {
        0x00000046,
        0x00000307
    };

    static _CharacterInfo _character00001E1E =
    {
        0x00001E1E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1E,
        0x00001E1F,
        0x00001E1E
    };

    static Char _decompositionMapping00001E1F[] = 
    {
        0x00000066,
        0x00000307
    };

    static _CharacterInfo _character00001E1F =
    {
        0x00001E1F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E1E,
        0x00001E1F,
        0x00001E1E
    };

    static Char _decompositionMapping00001E20[] = 
    {
        0x00000047,
        0x00000304
    };

    static _CharacterInfo _character00001E20 =
    {
        0x00001E20,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E20,
        0x00001E21,
        0x00001E20
    };

    static Char _decompositionMapping00001E21[] = 
    {
        0x00000067,
        0x00000304
    };

    static _CharacterInfo _character00001E21 =
    {
        0x00001E21,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E20,
        0x00001E21,
        0x00001E20
    };

    static Char _decompositionMapping00001E22[] = 
    {
        0x00000048,
        0x00000307
    };

    static _CharacterInfo _character00001E22 =
    {
        0x00001E22,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E22,
        0x00001E23,
        0x00001E22
    };

    static Char _decompositionMapping00001E23[] = 
    {
        0x00000068,
        0x00000307
    };

    static _CharacterInfo _character00001E23 =
    {
        0x00001E23,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E22,
        0x00001E23,
        0x00001E22
    };

    static Char _decompositionMapping00001E24[] = 
    {
        0x00000048,
        0x00000323
    };

    static _CharacterInfo _character00001E24 =
    {
        0x00001E24,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E24,
        0x00001E25,
        0x00001E24
    };

    static Char _decompositionMapping00001E25[] = 
    {
        0x00000068,
        0x00000323
    };

    static _CharacterInfo _character00001E25 =
    {
        0x00001E25,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E24,
        0x00001E25,
        0x00001E24
    };

    static Char _decompositionMapping00001E26[] = 
    {
        0x00000048,
        0x00000308
    };

    static _CharacterInfo _character00001E26 =
    {
        0x00001E26,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E26,
        0x00001E27,
        0x00001E26
    };

    static Char _decompositionMapping00001E27[] = 
    {
        0x00000068,
        0x00000308
    };

    static _CharacterInfo _character00001E27 =
    {
        0x00001E27,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E26,
        0x00001E27,
        0x00001E26
    };

    static Char _decompositionMapping00001E28[] = 
    {
        0x00000048,
        0x00000327
    };

    static _CharacterInfo _character00001E28 =
    {
        0x00001E28,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E28,
        0x00001E29,
        0x00001E28
    };

    static Char _decompositionMapping00001E29[] = 
    {
        0x00000068,
        0x00000327
    };

    static _CharacterInfo _character00001E29 =
    {
        0x00001E29,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E28,
        0x00001E29,
        0x00001E28
    };

    static Char _decompositionMapping00001E2A[] = 
    {
        0x00000048,
        0x0000032E
    };

    static _CharacterInfo _character00001E2A =
    {
        0x00001E2A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2A,
        0x00001E2B,
        0x00001E2A
    };

    static Char _decompositionMapping00001E2B[] = 
    {
        0x00000068,
        0x0000032E
    };

    static _CharacterInfo _character00001E2B =
    {
        0x00001E2B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2A,
        0x00001E2B,
        0x00001E2A
    };

    static Char _decompositionMapping00001E2C[] = 
    {
        0x00000049,
        0x00000330
    };

    static _CharacterInfo _character00001E2C =
    {
        0x00001E2C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2C,
        0x00001E2D,
        0x00001E2C
    };

    static Char _decompositionMapping00001E2D[] = 
    {
        0x00000069,
        0x00000330
    };

    static _CharacterInfo _character00001E2D =
    {
        0x00001E2D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2C,
        0x00001E2D,
        0x00001E2C
    };

    static Char _decompositionMapping00001E2E[] = 
    {
        0x000000CF,
        0x00000301
    };

    static _CharacterInfo _character00001E2E =
    {
        0x00001E2E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2E,
        0x00001E2F,
        0x00001E2E
    };

    static Char _decompositionMapping00001E2F[] = 
    {
        0x000000EF,
        0x00000301
    };

    static _CharacterInfo _character00001E2F =
    {
        0x00001E2F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E2E,
        0x00001E2F,
        0x00001E2E
    };

    static Char _decompositionMapping00001E30[] = 
    {
        0x0000004B,
        0x00000301
    };

    static _CharacterInfo _character00001E30 =
    {
        0x00001E30,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E30,
        0x00001E31,
        0x00001E30
    };

    static Char _decompositionMapping00001E31[] = 
    {
        0x0000006B,
        0x00000301
    };

    static _CharacterInfo _character00001E31 =
    {
        0x00001E31,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E30,
        0x00001E31,
        0x00001E30
    };

    static Char _decompositionMapping00001E32[] = 
    {
        0x0000004B,
        0x00000323
    };

    static _CharacterInfo _character00001E32 =
    {
        0x00001E32,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E32,
        0x00001E33,
        0x00001E32
    };

    static Char _decompositionMapping00001E33[] = 
    {
        0x0000006B,
        0x00000323
    };

    static _CharacterInfo _character00001E33 =
    {
        0x00001E33,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E32,
        0x00001E33,
        0x00001E32
    };

    static Char _decompositionMapping00001E34[] = 
    {
        0x0000004B,
        0x00000331
    };

    static _CharacterInfo _character00001E34 =
    {
        0x00001E34,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E34,
        0x00001E35,
        0x00001E34
    };

    static Char _decompositionMapping00001E35[] = 
    {
        0x0000006B,
        0x00000331
    };

    static _CharacterInfo _character00001E35 =
    {
        0x00001E35,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E34,
        0x00001E35,
        0x00001E34
    };

    static Char _decompositionMapping00001E36[] = 
    {
        0x0000004C,
        0x00000323
    };

    static _CharacterInfo _character00001E36 =
    {
        0x00001E36,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E36,
        0x00001E37,
        0x00001E36
    };

    static Char _decompositionMapping00001E37[] = 
    {
        0x0000006C,
        0x00000323
    };

    static _CharacterInfo _character00001E37 =
    {
        0x00001E37,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E36,
        0x00001E37,
        0x00001E36
    };

    static Char _decompositionMapping00001E38[] = 
    {
        0x00001E36,
        0x00000304
    };

    static _CharacterInfo _character00001E38 =
    {
        0x00001E38,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E38,
        0x00001E39,
        0x00001E38
    };

    static Char _decompositionMapping00001E39[] = 
    {
        0x00001E37,
        0x00000304
    };

    static _CharacterInfo _character00001E39 =
    {
        0x00001E39,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E38,
        0x00001E39,
        0x00001E38
    };

    static Char _decompositionMapping00001E3A[] = 
    {
        0x0000004C,
        0x00000331
    };

    static _CharacterInfo _character00001E3A =
    {
        0x00001E3A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3A,
        0x00001E3B,
        0x00001E3A
    };

    static Char _decompositionMapping00001E3B[] = 
    {
        0x0000006C,
        0x00000331
    };

    static _CharacterInfo _character00001E3B =
    {
        0x00001E3B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3A,
        0x00001E3B,
        0x00001E3A
    };

    static Char _decompositionMapping00001E3C[] = 
    {
        0x0000004C,
        0x0000032D
    };

    static _CharacterInfo _character00001E3C =
    {
        0x00001E3C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3C,
        0x00001E3D,
        0x00001E3C
    };

    static Char _decompositionMapping00001E3D[] = 
    {
        0x0000006C,
        0x0000032D
    };

    static _CharacterInfo _character00001E3D =
    {
        0x00001E3D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3C,
        0x00001E3D,
        0x00001E3C
    };

    static Char _decompositionMapping00001E3E[] = 
    {
        0x0000004D,
        0x00000301
    };

    static _CharacterInfo _character00001E3E =
    {
        0x00001E3E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3E,
        0x00001E3F,
        0x00001E3E
    };

    static Char _decompositionMapping00001E3F[] = 
    {
        0x0000006D,
        0x00000301
    };

    static _CharacterInfo _character00001E3F =
    {
        0x00001E3F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E3E,
        0x00001E3F,
        0x00001E3E
    };

    static Char _decompositionMapping00001E40[] = 
    {
        0x0000004D,
        0x00000307
    };

    static _CharacterInfo _character00001E40 =
    {
        0x00001E40,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E40,
        0x00001E41,
        0x00001E40
    };

    static Char _decompositionMapping00001E41[] = 
    {
        0x0000006D,
        0x00000307
    };

    static _CharacterInfo _character00001E41 =
    {
        0x00001E41,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E40,
        0x00001E41,
        0x00001E40
    };

    static Char _decompositionMapping00001E42[] = 
    {
        0x0000004D,
        0x00000323
    };

    static _CharacterInfo _character00001E42 =
    {
        0x00001E42,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E42,
        0x00001E43,
        0x00001E42
    };

    static Char _decompositionMapping00001E43[] = 
    {
        0x0000006D,
        0x00000323
    };

    static _CharacterInfo _character00001E43 =
    {
        0x00001E43,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E42,
        0x00001E43,
        0x00001E42
    };

    static Char _decompositionMapping00001E44[] = 
    {
        0x0000004E,
        0x00000307
    };

    static _CharacterInfo _character00001E44 =
    {
        0x00001E44,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E44,
        0x00001E45,
        0x00001E44
    };

    static Char _decompositionMapping00001E45[] = 
    {
        0x0000006E,
        0x00000307
    };

    static _CharacterInfo _character00001E45 =
    {
        0x00001E45,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E44,
        0x00001E45,
        0x00001E44
    };

    static Char _decompositionMapping00001E46[] = 
    {
        0x0000004E,
        0x00000323
    };

    static _CharacterInfo _character00001E46 =
    {
        0x00001E46,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E46,
        0x00001E47,
        0x00001E46
    };

    static Char _decompositionMapping00001E47[] = 
    {
        0x0000006E,
        0x00000323
    };

    static _CharacterInfo _character00001E47 =
    {
        0x00001E47,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E46,
        0x00001E47,
        0x00001E46
    };

    static Char _decompositionMapping00001E48[] = 
    {
        0x0000004E,
        0x00000331
    };

    static _CharacterInfo _character00001E48 =
    {
        0x00001E48,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E48,
        0x00001E49,
        0x00001E48
    };

    static Char _decompositionMapping00001E49[] = 
    {
        0x0000006E,
        0x00000331
    };

    static _CharacterInfo _character00001E49 =
    {
        0x00001E49,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E48,
        0x00001E49,
        0x00001E48
    };

    static Char _decompositionMapping00001E4A[] = 
    {
        0x0000004E,
        0x0000032D
    };

    static _CharacterInfo _character00001E4A =
    {
        0x00001E4A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4A,
        0x00001E4B,
        0x00001E4A
    };

    static Char _decompositionMapping00001E4B[] = 
    {
        0x0000006E,
        0x0000032D
    };

    static _CharacterInfo _character00001E4B =
    {
        0x00001E4B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4A,
        0x00001E4B,
        0x00001E4A
    };

    static Char _decompositionMapping00001E4C[] = 
    {
        0x000000D5,
        0x00000301
    };

    static _CharacterInfo _character00001E4C =
    {
        0x00001E4C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4C,
        0x00001E4D,
        0x00001E4C
    };

    static Char _decompositionMapping00001E4D[] = 
    {
        0x000000F5,
        0x00000301
    };

    static _CharacterInfo _character00001E4D =
    {
        0x00001E4D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4C,
        0x00001E4D,
        0x00001E4C
    };

    static Char _decompositionMapping00001E4E[] = 
    {
        0x000000D5,
        0x00000308
    };

    static _CharacterInfo _character00001E4E =
    {
        0x00001E4E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4E,
        0x00001E4F,
        0x00001E4E
    };

    static Char _decompositionMapping00001E4F[] = 
    {
        0x000000F5,
        0x00000308
    };

    static _CharacterInfo _character00001E4F =
    {
        0x00001E4F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E4E,
        0x00001E4F,
        0x00001E4E
    };

    static Char _decompositionMapping00001E50[] = 
    {
        0x0000014C,
        0x00000300
    };

    static _CharacterInfo _character00001E50 =
    {
        0x00001E50,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E50,
        0x00001E51,
        0x00001E50
    };

    static Char _decompositionMapping00001E51[] = 
    {
        0x0000014D,
        0x00000300
    };

    static _CharacterInfo _character00001E51 =
    {
        0x00001E51,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E50,
        0x00001E51,
        0x00001E50
    };

    static Char _decompositionMapping00001E52[] = 
    {
        0x0000014C,
        0x00000301
    };

    static _CharacterInfo _character00001E52 =
    {
        0x00001E52,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E52,
        0x00001E53,
        0x00001E52
    };

    static Char _decompositionMapping00001E53[] = 
    {
        0x0000014D,
        0x00000301
    };

    static _CharacterInfo _character00001E53 =
    {
        0x00001E53,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E52,
        0x00001E53,
        0x00001E52
    };

    static Char _decompositionMapping00001E54[] = 
    {
        0x00000050,
        0x00000301
    };

    static _CharacterInfo _character00001E54 =
    {
        0x00001E54,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E54,
        0x00001E55,
        0x00001E54
    };

    static Char _decompositionMapping00001E55[] = 
    {
        0x00000070,
        0x00000301
    };

    static _CharacterInfo _character00001E55 =
    {
        0x00001E55,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E54,
        0x00001E55,
        0x00001E54
    };

    static Char _decompositionMapping00001E56[] = 
    {
        0x00000050,
        0x00000307
    };

    static _CharacterInfo _character00001E56 =
    {
        0x00001E56,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E56,
        0x00001E57,
        0x00001E56
    };

    static Char _decompositionMapping00001E57[] = 
    {
        0x00000070,
        0x00000307
    };

    static _CharacterInfo _character00001E57 =
    {
        0x00001E57,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E56,
        0x00001E57,
        0x00001E56
    };

    static Char _decompositionMapping00001E58[] = 
    {
        0x00000052,
        0x00000307
    };

    static _CharacterInfo _character00001E58 =
    {
        0x00001E58,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E58,
        0x00001E59,
        0x00001E58
    };

    static Char _decompositionMapping00001E59[] = 
    {
        0x00000072,
        0x00000307
    };

    static _CharacterInfo _character00001E59 =
    {
        0x00001E59,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E58,
        0x00001E59,
        0x00001E58
    };

    static Char _decompositionMapping00001E5A[] = 
    {
        0x00000052,
        0x00000323
    };

    static _CharacterInfo _character00001E5A =
    {
        0x00001E5A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5A,
        0x00001E5B,
        0x00001E5A
    };

    static Char _decompositionMapping00001E5B[] = 
    {
        0x00000072,
        0x00000323
    };

    static _CharacterInfo _character00001E5B =
    {
        0x00001E5B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5A,
        0x00001E5B,
        0x00001E5A
    };

    static Char _decompositionMapping00001E5C[] = 
    {
        0x00001E5A,
        0x00000304
    };

    static _CharacterInfo _character00001E5C =
    {
        0x00001E5C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5C,
        0x00001E5D,
        0x00001E5C
    };

    static Char _decompositionMapping00001E5D[] = 
    {
        0x00001E5B,
        0x00000304
    };

    static _CharacterInfo _character00001E5D =
    {
        0x00001E5D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5C,
        0x00001E5D,
        0x00001E5C
    };

    static Char _decompositionMapping00001E5E[] = 
    {
        0x00000052,
        0x00000331
    };

    static _CharacterInfo _character00001E5E =
    {
        0x00001E5E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5E,
        0x00001E5F,
        0x00001E5E
    };

    static Char _decompositionMapping00001E5F[] = 
    {
        0x00000072,
        0x00000331
    };

    static _CharacterInfo _character00001E5F =
    {
        0x00001E5F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E5E,
        0x00001E5F,
        0x00001E5E
    };

    static Char _decompositionMapping00001E60[] = 
    {
        0x00000053,
        0x00000307
    };

    static _CharacterInfo _character00001E60 =
    {
        0x00001E60,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E60,
        0x00001E61,
        0x00001E60
    };

    static Char _decompositionMapping00001E61[] = 
    {
        0x00000073,
        0x00000307
    };

    static _CharacterInfo _character00001E61 =
    {
        0x00001E61,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E60,
        0x00001E61,
        0x00001E60
    };

    static Char _decompositionMapping00001E62[] = 
    {
        0x00000053,
        0x00000323
    };

    static _CharacterInfo _character00001E62 =
    {
        0x00001E62,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E62,
        0x00001E63,
        0x00001E62
    };

    static Char _decompositionMapping00001E63[] = 
    {
        0x00000073,
        0x00000323
    };

    static _CharacterInfo _character00001E63 =
    {
        0x00001E63,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E62,
        0x00001E63,
        0x00001E62
    };

    static Char _decompositionMapping00001E64[] = 
    {
        0x0000015A,
        0x00000307
    };

    static _CharacterInfo _character00001E64 =
    {
        0x00001E64,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E64,
        0x00001E65,
        0x00001E64
    };

    static Char _decompositionMapping00001E65[] = 
    {
        0x0000015B,
        0x00000307
    };

    static _CharacterInfo _character00001E65 =
    {
        0x00001E65,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E64,
        0x00001E65,
        0x00001E64
    };

    static Char _decompositionMapping00001E66[] = 
    {
        0x00000160,
        0x00000307
    };

    static _CharacterInfo _character00001E66 =
    {
        0x00001E66,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E66,
        0x00001E67,
        0x00001E66
    };

    static Char _decompositionMapping00001E67[] = 
    {
        0x00000161,
        0x00000307
    };

    static _CharacterInfo _character00001E67 =
    {
        0x00001E67,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E66,
        0x00001E67,
        0x00001E66
    };

    static Char _decompositionMapping00001E68[] = 
    {
        0x00001E62,
        0x00000307
    };

    static _CharacterInfo _character00001E68 =
    {
        0x00001E68,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E68,
        0x00001E69,
        0x00001E68
    };

    static Char _decompositionMapping00001E69[] = 
    {
        0x00001E63,
        0x00000307
    };

    static _CharacterInfo _character00001E69 =
    {
        0x00001E69,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E68,
        0x00001E69,
        0x00001E68
    };

    static Char _decompositionMapping00001E6A[] = 
    {
        0x00000054,
        0x00000307
    };

    static _CharacterInfo _character00001E6A =
    {
        0x00001E6A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6A,
        0x00001E6B,
        0x00001E6A
    };

    static Char _decompositionMapping00001E6B[] = 
    {
        0x00000074,
        0x00000307
    };

    static _CharacterInfo _character00001E6B =
    {
        0x00001E6B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6A,
        0x00001E6B,
        0x00001E6A
    };

    static Char _decompositionMapping00001E6C[] = 
    {
        0x00000054,
        0x00000323
    };

    static _CharacterInfo _character00001E6C =
    {
        0x00001E6C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6C,
        0x00001E6D,
        0x00001E6C
    };

    static Char _decompositionMapping00001E6D[] = 
    {
        0x00000074,
        0x00000323
    };

    static _CharacterInfo _character00001E6D =
    {
        0x00001E6D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6C,
        0x00001E6D,
        0x00001E6C
    };

    static Char _decompositionMapping00001E6E[] = 
    {
        0x00000054,
        0x00000331
    };

    static _CharacterInfo _character00001E6E =
    {
        0x00001E6E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6E,
        0x00001E6F,
        0x00001E6E
    };

    static Char _decompositionMapping00001E6F[] = 
    {
        0x00000074,
        0x00000331
    };

    static _CharacterInfo _character00001E6F =
    {
        0x00001E6F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E6E,
        0x00001E6F,
        0x00001E6E
    };

    static Char _decompositionMapping00001E70[] = 
    {
        0x00000054,
        0x0000032D
    };

    static _CharacterInfo _character00001E70 =
    {
        0x00001E70,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E70,
        0x00001E71,
        0x00001E70
    };

    static Char _decompositionMapping00001E71[] = 
    {
        0x00000074,
        0x0000032D
    };

    static _CharacterInfo _character00001E71 =
    {
        0x00001E71,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E70,
        0x00001E71,
        0x00001E70
    };

    static Char _decompositionMapping00001E72[] = 
    {
        0x00000055,
        0x00000324
    };

    static _CharacterInfo _character00001E72 =
    {
        0x00001E72,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E72,
        0x00001E73,
        0x00001E72
    };

    static Char _decompositionMapping00001E73[] = 
    {
        0x00000075,
        0x00000324
    };

    static _CharacterInfo _character00001E73 =
    {
        0x00001E73,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E72,
        0x00001E73,
        0x00001E72
    };

    static Char _decompositionMapping00001E74[] = 
    {
        0x00000055,
        0x00000330
    };

    static _CharacterInfo _character00001E74 =
    {
        0x00001E74,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E74,
        0x00001E75,
        0x00001E74
    };

    static Char _decompositionMapping00001E75[] = 
    {
        0x00000075,
        0x00000330
    };

    static _CharacterInfo _character00001E75 =
    {
        0x00001E75,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E74,
        0x00001E75,
        0x00001E74
    };

    static Char _decompositionMapping00001E76[] = 
    {
        0x00000055,
        0x0000032D
    };

    static _CharacterInfo _character00001E76 =
    {
        0x00001E76,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E76,
        0x00001E77,
        0x00001E76
    };

    static Char _decompositionMapping00001E77[] = 
    {
        0x00000075,
        0x0000032D
    };

    static _CharacterInfo _character00001E77 =
    {
        0x00001E77,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E76,
        0x00001E77,
        0x00001E76
    };

    static Char _decompositionMapping00001E78[] = 
    {
        0x00000168,
        0x00000301
    };

    static _CharacterInfo _character00001E78 =
    {
        0x00001E78,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E78,
        0x00001E79,
        0x00001E78
    };

    static Char _decompositionMapping00001E79[] = 
    {
        0x00000169,
        0x00000301
    };

    static _CharacterInfo _character00001E79 =
    {
        0x00001E79,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E78,
        0x00001E79,
        0x00001E78
    };

    static Char _decompositionMapping00001E7A[] = 
    {
        0x0000016A,
        0x00000308
    };

    static _CharacterInfo _character00001E7A =
    {
        0x00001E7A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7A,
        0x00001E7B,
        0x00001E7A
    };

    static Char _decompositionMapping00001E7B[] = 
    {
        0x0000016B,
        0x00000308
    };

    static _CharacterInfo _character00001E7B =
    {
        0x00001E7B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7A,
        0x00001E7B,
        0x00001E7A
    };

    static Char _decompositionMapping00001E7C[] = 
    {
        0x00000056,
        0x00000303
    };

    static _CharacterInfo _character00001E7C =
    {
        0x00001E7C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7C,
        0x00001E7D,
        0x00001E7C
    };

    static Char _decompositionMapping00001E7D[] = 
    {
        0x00000076,
        0x00000303
    };

    static _CharacterInfo _character00001E7D =
    {
        0x00001E7D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7C,
        0x00001E7D,
        0x00001E7C
    };

    static Char _decompositionMapping00001E7E[] = 
    {
        0x00000056,
        0x00000323
    };

    static _CharacterInfo _character00001E7E =
    {
        0x00001E7E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7E,
        0x00001E7F,
        0x00001E7E
    };

    static Char _decompositionMapping00001E7F[] = 
    {
        0x00000076,
        0x00000323
    };

    static _CharacterInfo _character00001E7F =
    {
        0x00001E7F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E7E,
        0x00001E7F,
        0x00001E7E
    };

    static Char _decompositionMapping00001E80[] = 
    {
        0x00000057,
        0x00000300
    };

    static _CharacterInfo _character00001E80 =
    {
        0x00001E80,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E80,
        0x00001E81,
        0x00001E80
    };

    static Char _decompositionMapping00001E81[] = 
    {
        0x00000077,
        0x00000300
    };

    static _CharacterInfo _character00001E81 =
    {
        0x00001E81,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E80,
        0x00001E81,
        0x00001E80
    };

    static Char _decompositionMapping00001E82[] = 
    {
        0x00000057,
        0x00000301
    };

    static _CharacterInfo _character00001E82 =
    {
        0x00001E82,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E82,
        0x00001E83,
        0x00001E82
    };

    static Char _decompositionMapping00001E83[] = 
    {
        0x00000077,
        0x00000301
    };

    static _CharacterInfo _character00001E83 =
    {
        0x00001E83,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E82,
        0x00001E83,
        0x00001E82
    };

    static Char _decompositionMapping00001E84[] = 
    {
        0x00000057,
        0x00000308
    };

    static _CharacterInfo _character00001E84 =
    {
        0x00001E84,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E84,
        0x00001E85,
        0x00001E84
    };

    static Char _decompositionMapping00001E85[] = 
    {
        0x00000077,
        0x00000308
    };

    static _CharacterInfo _character00001E85 =
    {
        0x00001E85,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E84,
        0x00001E85,
        0x00001E84
    };

    static Char _decompositionMapping00001E86[] = 
    {
        0x00000057,
        0x00000307
    };

    static _CharacterInfo _character00001E86 =
    {
        0x00001E86,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E86,
        0x00001E87,
        0x00001E86
    };

    static Char _decompositionMapping00001E87[] = 
    {
        0x00000077,
        0x00000307
    };

    static _CharacterInfo _character00001E87 =
    {
        0x00001E87,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E86,
        0x00001E87,
        0x00001E86
    };

    static Char _decompositionMapping00001E88[] = 
    {
        0x00000057,
        0x00000323
    };

    static _CharacterInfo _character00001E88 =
    {
        0x00001E88,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E88,
        0x00001E89,
        0x00001E88
    };

    static Char _decompositionMapping00001E89[] = 
    {
        0x00000077,
        0x00000323
    };

    static _CharacterInfo _character00001E89 =
    {
        0x00001E89,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E88,
        0x00001E89,
        0x00001E88
    };

    static Char _decompositionMapping00001E8A[] = 
    {
        0x00000058,
        0x00000307
    };

    static _CharacterInfo _character00001E8A =
    {
        0x00001E8A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8A,
        0x00001E8B,
        0x00001E8A
    };

    static Char _decompositionMapping00001E8B[] = 
    {
        0x00000078,
        0x00000307
    };

    static _CharacterInfo _character00001E8B =
    {
        0x00001E8B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8A,
        0x00001E8B,
        0x00001E8A
    };

    static Char _decompositionMapping00001E8C[] = 
    {
        0x00000058,
        0x00000308
    };

    static _CharacterInfo _character00001E8C =
    {
        0x00001E8C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8C,
        0x00001E8D,
        0x00001E8C
    };

    static Char _decompositionMapping00001E8D[] = 
    {
        0x00000078,
        0x00000308
    };

    static _CharacterInfo _character00001E8D =
    {
        0x00001E8D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8C,
        0x00001E8D,
        0x00001E8C
    };

    static Char _decompositionMapping00001E8E[] = 
    {
        0x00000059,
        0x00000307
    };

    static _CharacterInfo _character00001E8E =
    {
        0x00001E8E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8E,
        0x00001E8F,
        0x00001E8E
    };

    static Char _decompositionMapping00001E8F[] = 
    {
        0x00000079,
        0x00000307
    };

    static _CharacterInfo _character00001E8F =
    {
        0x00001E8F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E8E,
        0x00001E8F,
        0x00001E8E
    };

    static Char _decompositionMapping00001E90[] = 
    {
        0x0000005A,
        0x00000302
    };

    static _CharacterInfo _character00001E90 =
    {
        0x00001E90,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E90,
        0x00001E91,
        0x00001E90
    };

    static Char _decompositionMapping00001E91[] = 
    {
        0x0000007A,
        0x00000302
    };

    static _CharacterInfo _character00001E91 =
    {
        0x00001E91,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E90,
        0x00001E91,
        0x00001E90
    };

    static Char _decompositionMapping00001E92[] = 
    {
        0x0000005A,
        0x00000323
    };

    static _CharacterInfo _character00001E92 =
    {
        0x00001E92,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E92,
        0x00001E93,
        0x00001E92
    };

    static Char _decompositionMapping00001E93[] = 
    {
        0x0000007A,
        0x00000323
    };

    static _CharacterInfo _character00001E93 =
    {
        0x00001E93,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E92,
        0x00001E93,
        0x00001E92
    };

    static Char _decompositionMapping00001E94[] = 
    {
        0x0000005A,
        0x00000331
    };

    static _CharacterInfo _character00001E94 =
    {
        0x00001E94,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E94,
        0x00001E95,
        0x00001E94
    };

    static Char _decompositionMapping00001E95[] = 
    {
        0x0000007A,
        0x00000331
    };

    static _CharacterInfo _character00001E95 =
    {
        0x00001E95,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E94,
        0x00001E95,
        0x00001E94
    };

    static Char _decompositionMapping00001E96[] = 
    {
        0x00000068,
        0x00000331
    };

    static _CharacterInfo _character00001E96 =
    {
        0x00001E96,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E96,
        0x00001E96,
        0x00001E96
    };

    static Char _decompositionMapping00001E97[] = 
    {
        0x00000074,
        0x00000308
    };

    static _CharacterInfo _character00001E97 =
    {
        0x00001E97,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E97,
        0x00001E97,
        0x00001E97
    };

    static Char _decompositionMapping00001E98[] = 
    {
        0x00000077,
        0x0000030A
    };

    static _CharacterInfo _character00001E98 =
    {
        0x00001E98,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E98,
        0x00001E98,
        0x00001E98
    };

    static Char _decompositionMapping00001E99[] = 
    {
        0x00000079,
        0x0000030A
    };

    static _CharacterInfo _character00001E99 =
    {
        0x00001E99,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E99,
        0x00001E99,
        0x00001E99
    };

    static Char _decompositionMapping00001E9A[] = 
    {
        0x00000061,
        0x000002BE
    };

    static _CharacterInfo _character00001E9A =
    {
        0x00001E9A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00001E9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E9A,
        0x00001E9A,
        0x00001E9A
    };

    static Char _decompositionMapping00001E9B[] = 
    {
        0x0000017F,
        0x00000307
    };

    static _CharacterInfo _character00001E9B =
    {
        0x00001E9B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001E9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001E60,
        0x00001E9B,
        0x00001E60
    };

    static Char _decompositionMapping00001EA0[] = 
    {
        0x00000041,
        0x00000323
    };

    static _CharacterInfo _character00001EA0 =
    {
        0x00001EA0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA0,
        0x00001EA1,
        0x00001EA0
    };

    static Char _decompositionMapping00001EA1[] = 
    {
        0x00000061,
        0x00000323
    };

    static _CharacterInfo _character00001EA1 =
    {
        0x00001EA1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA0,
        0x00001EA1,
        0x00001EA0
    };

    static Char _decompositionMapping00001EA2[] = 
    {
        0x00000041,
        0x00000309
    };

    static _CharacterInfo _character00001EA2 =
    {
        0x00001EA2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA2,
        0x00001EA3,
        0x00001EA2
    };

    static Char _decompositionMapping00001EA3[] = 
    {
        0x00000061,
        0x00000309
    };

    static _CharacterInfo _character00001EA3 =
    {
        0x00001EA3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA2,
        0x00001EA3,
        0x00001EA2
    };

    static Char _decompositionMapping00001EA4[] = 
    {
        0x000000C2,
        0x00000301
    };

    static _CharacterInfo _character00001EA4 =
    {
        0x00001EA4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA4,
        0x00001EA5,
        0x00001EA4
    };

    static Char _decompositionMapping00001EA5[] = 
    {
        0x000000E2,
        0x00000301
    };

    static _CharacterInfo _character00001EA5 =
    {
        0x00001EA5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA4,
        0x00001EA5,
        0x00001EA4
    };

    static Char _decompositionMapping00001EA6[] = 
    {
        0x000000C2,
        0x00000300
    };

    static _CharacterInfo _character00001EA6 =
    {
        0x00001EA6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA6,
        0x00001EA7,
        0x00001EA6
    };

    static Char _decompositionMapping00001EA7[] = 
    {
        0x000000E2,
        0x00000300
    };

    static _CharacterInfo _character00001EA7 =
    {
        0x00001EA7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA6,
        0x00001EA7,
        0x00001EA6
    };

    static Char _decompositionMapping00001EA8[] = 
    {
        0x000000C2,
        0x00000309
    };

    static _CharacterInfo _character00001EA8 =
    {
        0x00001EA8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA8,
        0x00001EA9,
        0x00001EA8
    };

    static Char _decompositionMapping00001EA9[] = 
    {
        0x000000E2,
        0x00000309
    };

    static _CharacterInfo _character00001EA9 =
    {
        0x00001EA9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EA8,
        0x00001EA9,
        0x00001EA8
    };

    static Char _decompositionMapping00001EAA[] = 
    {
        0x000000C2,
        0x00000303
    };

    static _CharacterInfo _character00001EAA =
    {
        0x00001EAA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAA,
        0x00001EAB,
        0x00001EAA
    };

    static Char _decompositionMapping00001EAB[] = 
    {
        0x000000E2,
        0x00000303
    };

    static _CharacterInfo _character00001EAB =
    {
        0x00001EAB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAA,
        0x00001EAB,
        0x00001EAA
    };

    static Char _decompositionMapping00001EAC[] = 
    {
        0x00001EA0,
        0x00000302
    };

    static _CharacterInfo _character00001EAC =
    {
        0x00001EAC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAC,
        0x00001EAD,
        0x00001EAC
    };

    static Char _decompositionMapping00001EAD[] = 
    {
        0x00001EA1,
        0x00000302
    };

    static _CharacterInfo _character00001EAD =
    {
        0x00001EAD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAC,
        0x00001EAD,
        0x00001EAC
    };

    static Char _decompositionMapping00001EAE[] = 
    {
        0x00000102,
        0x00000301
    };

    static _CharacterInfo _character00001EAE =
    {
        0x00001EAE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAE,
        0x00001EAF,
        0x00001EAE
    };

    static Char _decompositionMapping00001EAF[] = 
    {
        0x00000103,
        0x00000301
    };

    static _CharacterInfo _character00001EAF =
    {
        0x00001EAF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EAE,
        0x00001EAF,
        0x00001EAE
    };

    static Char _decompositionMapping00001EB0[] = 
    {
        0x00000102,
        0x00000300
    };

    static _CharacterInfo _character00001EB0 =
    {
        0x00001EB0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB0,
        0x00001EB1,
        0x00001EB0
    };

    static Char _decompositionMapping00001EB1[] = 
    {
        0x00000103,
        0x00000300
    };

    static _CharacterInfo _character00001EB1 =
    {
        0x00001EB1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB0,
        0x00001EB1,
        0x00001EB0
    };

    static Char _decompositionMapping00001EB2[] = 
    {
        0x00000102,
        0x00000309
    };

    static _CharacterInfo _character00001EB2 =
    {
        0x00001EB2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB2,
        0x00001EB3,
        0x00001EB2
    };

    static Char _decompositionMapping00001EB3[] = 
    {
        0x00000103,
        0x00000309
    };

    static _CharacterInfo _character00001EB3 =
    {
        0x00001EB3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB2,
        0x00001EB3,
        0x00001EB2
    };

    static Char _decompositionMapping00001EB4[] = 
    {
        0x00000102,
        0x00000303
    };

    static _CharacterInfo _character00001EB4 =
    {
        0x00001EB4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB4,
        0x00001EB5,
        0x00001EB4
    };

    static Char _decompositionMapping00001EB5[] = 
    {
        0x00000103,
        0x00000303
    };

    static _CharacterInfo _character00001EB5 =
    {
        0x00001EB5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB4,
        0x00001EB5,
        0x00001EB4
    };

    static Char _decompositionMapping00001EB6[] = 
    {
        0x00001EA0,
        0x00000306
    };

    static _CharacterInfo _character00001EB6 =
    {
        0x00001EB6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB6,
        0x00001EB7,
        0x00001EB6
    };

    static Char _decompositionMapping00001EB7[] = 
    {
        0x00001EA1,
        0x00000306
    };

    static _CharacterInfo _character00001EB7 =
    {
        0x00001EB7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB6,
        0x00001EB7,
        0x00001EB6
    };

    static Char _decompositionMapping00001EB8[] = 
    {
        0x00000045,
        0x00000323
    };

    static _CharacterInfo _character00001EB8 =
    {
        0x00001EB8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB8,
        0x00001EB9,
        0x00001EB8
    };

    static Char _decompositionMapping00001EB9[] = 
    {
        0x00000065,
        0x00000323
    };

    static _CharacterInfo _character00001EB9 =
    {
        0x00001EB9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EB8,
        0x00001EB9,
        0x00001EB8
    };

    static Char _decompositionMapping00001EBA[] = 
    {
        0x00000045,
        0x00000309
    };

    static _CharacterInfo _character00001EBA =
    {
        0x00001EBA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBA,
        0x00001EBB,
        0x00001EBA
    };

    static Char _decompositionMapping00001EBB[] = 
    {
        0x00000065,
        0x00000309
    };

    static _CharacterInfo _character00001EBB =
    {
        0x00001EBB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBA,
        0x00001EBB,
        0x00001EBA
    };

    static Char _decompositionMapping00001EBC[] = 
    {
        0x00000045,
        0x00000303
    };

    static _CharacterInfo _character00001EBC =
    {
        0x00001EBC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBC,
        0x00001EBD,
        0x00001EBC
    };

    static Char _decompositionMapping00001EBD[] = 
    {
        0x00000065,
        0x00000303
    };

    static _CharacterInfo _character00001EBD =
    {
        0x00001EBD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBC,
        0x00001EBD,
        0x00001EBC
    };

    static Char _decompositionMapping00001EBE[] = 
    {
        0x000000CA,
        0x00000301
    };

    static _CharacterInfo _character00001EBE =
    {
        0x00001EBE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBE,
        0x00001EBF,
        0x00001EBE
    };

    static Char _decompositionMapping00001EBF[] = 
    {
        0x000000EA,
        0x00000301
    };

    static _CharacterInfo _character00001EBF =
    {
        0x00001EBF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EBE,
        0x00001EBF,
        0x00001EBE
    };

    static Char _decompositionMapping00001EC0[] = 
    {
        0x000000CA,
        0x00000300
    };

    static _CharacterInfo _character00001EC0 =
    {
        0x00001EC0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC0,
        0x00001EC1,
        0x00001EC0
    };

    static Char _decompositionMapping00001EC1[] = 
    {
        0x000000EA,
        0x00000300
    };

    static _CharacterInfo _character00001EC1 =
    {
        0x00001EC1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC0,
        0x00001EC1,
        0x00001EC0
    };

    static Char _decompositionMapping00001EC2[] = 
    {
        0x000000CA,
        0x00000309
    };

    static _CharacterInfo _character00001EC2 =
    {
        0x00001EC2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC2,
        0x00001EC3,
        0x00001EC2
    };

    static Char _decompositionMapping00001EC3[] = 
    {
        0x000000EA,
        0x00000309
    };

    static _CharacterInfo _character00001EC3 =
    {
        0x00001EC3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC2,
        0x00001EC3,
        0x00001EC2
    };

    static Char _decompositionMapping00001EC4[] = 
    {
        0x000000CA,
        0x00000303
    };

    static _CharacterInfo _character00001EC4 =
    {
        0x00001EC4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC4,
        0x00001EC5,
        0x00001EC4
    };

    static Char _decompositionMapping00001EC5[] = 
    {
        0x000000EA,
        0x00000303
    };

    static _CharacterInfo _character00001EC5 =
    {
        0x00001EC5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC4,
        0x00001EC5,
        0x00001EC4
    };

    static Char _decompositionMapping00001EC6[] = 
    {
        0x00001EB8,
        0x00000302
    };

    static _CharacterInfo _character00001EC6 =
    {
        0x00001EC6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC6,
        0x00001EC7,
        0x00001EC6
    };

    static Char _decompositionMapping00001EC7[] = 
    {
        0x00001EB9,
        0x00000302
    };

    static _CharacterInfo _character00001EC7 =
    {
        0x00001EC7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC6,
        0x00001EC7,
        0x00001EC6
    };

    static Char _decompositionMapping00001EC8[] = 
    {
        0x00000049,
        0x00000309
    };

    static _CharacterInfo _character00001EC8 =
    {
        0x00001EC8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC8,
        0x00001EC9,
        0x00001EC8
    };

    static Char _decompositionMapping00001EC9[] = 
    {
        0x00000069,
        0x00000309
    };

    static _CharacterInfo _character00001EC9 =
    {
        0x00001EC9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EC8,
        0x00001EC9,
        0x00001EC8
    };

    static Char _decompositionMapping00001ECA[] = 
    {
        0x00000049,
        0x00000323
    };

    static _CharacterInfo _character00001ECA =
    {
        0x00001ECA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECA,
        0x00001ECB,
        0x00001ECA
    };

    static Char _decompositionMapping00001ECB[] = 
    {
        0x00000069,
        0x00000323
    };

    static _CharacterInfo _character00001ECB =
    {
        0x00001ECB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECA,
        0x00001ECB,
        0x00001ECA
    };

    static Char _decompositionMapping00001ECC[] = 
    {
        0x0000004F,
        0x00000323
    };

    static _CharacterInfo _character00001ECC =
    {
        0x00001ECC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECC,
        0x00001ECD,
        0x00001ECC
    };

    static Char _decompositionMapping00001ECD[] = 
    {
        0x0000006F,
        0x00000323
    };

    static _CharacterInfo _character00001ECD =
    {
        0x00001ECD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECC,
        0x00001ECD,
        0x00001ECC
    };

    static Char _decompositionMapping00001ECE[] = 
    {
        0x0000004F,
        0x00000309
    };

    static _CharacterInfo _character00001ECE =
    {
        0x00001ECE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECE,
        0x00001ECF,
        0x00001ECE
    };

    static Char _decompositionMapping00001ECF[] = 
    {
        0x0000006F,
        0x00000309
    };

    static _CharacterInfo _character00001ECF =
    {
        0x00001ECF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ECF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ECE,
        0x00001ECF,
        0x00001ECE
    };

    static Char _decompositionMapping00001ED0[] = 
    {
        0x000000D4,
        0x00000301
    };

    static _CharacterInfo _character00001ED0 =
    {
        0x00001ED0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED0,
        0x00001ED1,
        0x00001ED0
    };

    static Char _decompositionMapping00001ED1[] = 
    {
        0x000000F4,
        0x00000301
    };

    static _CharacterInfo _character00001ED1 =
    {
        0x00001ED1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED0,
        0x00001ED1,
        0x00001ED0
    };

    static Char _decompositionMapping00001ED2[] = 
    {
        0x000000D4,
        0x00000300
    };

    static _CharacterInfo _character00001ED2 =
    {
        0x00001ED2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED2,
        0x00001ED3,
        0x00001ED2
    };

    static Char _decompositionMapping00001ED3[] = 
    {
        0x000000F4,
        0x00000300
    };

    static _CharacterInfo _character00001ED3 =
    {
        0x00001ED3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED2,
        0x00001ED3,
        0x00001ED2
    };

    static Char _decompositionMapping00001ED4[] = 
    {
        0x000000D4,
        0x00000309
    };

    static _CharacterInfo _character00001ED4 =
    {
        0x00001ED4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED4,
        0x00001ED5,
        0x00001ED4
    };

    static Char _decompositionMapping00001ED5[] = 
    {
        0x000000F4,
        0x00000309
    };

    static _CharacterInfo _character00001ED5 =
    {
        0x00001ED5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED4,
        0x00001ED5,
        0x00001ED4
    };

    static Char _decompositionMapping00001ED6[] = 
    {
        0x000000D4,
        0x00000303
    };

    static _CharacterInfo _character00001ED6 =
    {
        0x00001ED6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED6,
        0x00001ED7,
        0x00001ED6
    };

    static Char _decompositionMapping00001ED7[] = 
    {
        0x000000F4,
        0x00000303
    };

    static _CharacterInfo _character00001ED7 =
    {
        0x00001ED7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED6,
        0x00001ED7,
        0x00001ED6
    };

    static Char _decompositionMapping00001ED8[] = 
    {
        0x00001ECC,
        0x00000302
    };

    static _CharacterInfo _character00001ED8 =
    {
        0x00001ED8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED8,
        0x00001ED9,
        0x00001ED8
    };

    static Char _decompositionMapping00001ED9[] = 
    {
        0x00001ECD,
        0x00000302
    };

    static _CharacterInfo _character00001ED9 =
    {
        0x00001ED9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001ED9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001ED8,
        0x00001ED9,
        0x00001ED8
    };

    static Char _decompositionMapping00001EDA[] = 
    {
        0x000001A0,
        0x00000301
    };

    static _CharacterInfo _character00001EDA =
    {
        0x00001EDA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDA,
        0x00001EDB,
        0x00001EDA
    };

    static Char _decompositionMapping00001EDB[] = 
    {
        0x000001A1,
        0x00000301
    };

    static _CharacterInfo _character00001EDB =
    {
        0x00001EDB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDA,
        0x00001EDB,
        0x00001EDA
    };

    static Char _decompositionMapping00001EDC[] = 
    {
        0x000001A0,
        0x00000300
    };

    static _CharacterInfo _character00001EDC =
    {
        0x00001EDC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDC,
        0x00001EDD,
        0x00001EDC
    };

    static Char _decompositionMapping00001EDD[] = 
    {
        0x000001A1,
        0x00000300
    };

    static _CharacterInfo _character00001EDD =
    {
        0x00001EDD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDC,
        0x00001EDD,
        0x00001EDC
    };

    static Char _decompositionMapping00001EDE[] = 
    {
        0x000001A0,
        0x00000309
    };

    static _CharacterInfo _character00001EDE =
    {
        0x00001EDE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDE,
        0x00001EDF,
        0x00001EDE
    };

    static Char _decompositionMapping00001EDF[] = 
    {
        0x000001A1,
        0x00000309
    };

    static _CharacterInfo _character00001EDF =
    {
        0x00001EDF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EDF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EDE,
        0x00001EDF,
        0x00001EDE
    };

    static Char _decompositionMapping00001EE0[] = 
    {
        0x000001A0,
        0x00000303
    };

    static _CharacterInfo _character00001EE0 =
    {
        0x00001EE0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE0,
        0x00001EE1,
        0x00001EE0
    };

    static Char _decompositionMapping00001EE1[] = 
    {
        0x000001A1,
        0x00000303
    };

    static _CharacterInfo _character00001EE1 =
    {
        0x00001EE1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE0,
        0x00001EE1,
        0x00001EE0
    };

    static Char _decompositionMapping00001EE2[] = 
    {
        0x000001A0,
        0x00000323
    };

    static _CharacterInfo _character00001EE2 =
    {
        0x00001EE2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE2,
        0x00001EE3,
        0x00001EE2
    };

    static Char _decompositionMapping00001EE3[] = 
    {
        0x000001A1,
        0x00000323
    };

    static _CharacterInfo _character00001EE3 =
    {
        0x00001EE3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE2,
        0x00001EE3,
        0x00001EE2
    };

    static Char _decompositionMapping00001EE4[] = 
    {
        0x00000055,
        0x00000323
    };

    static _CharacterInfo _character00001EE4 =
    {
        0x00001EE4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE4,
        0x00001EE5,
        0x00001EE4
    };

    static Char _decompositionMapping00001EE5[] = 
    {
        0x00000075,
        0x00000323
    };

    static _CharacterInfo _character00001EE5 =
    {
        0x00001EE5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE4,
        0x00001EE5,
        0x00001EE4
    };

    static Char _decompositionMapping00001EE6[] = 
    {
        0x00000055,
        0x00000309
    };

    static _CharacterInfo _character00001EE6 =
    {
        0x00001EE6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE6,
        0x00001EE7,
        0x00001EE6
    };

    static Char _decompositionMapping00001EE7[] = 
    {
        0x00000075,
        0x00000309
    };

    static _CharacterInfo _character00001EE7 =
    {
        0x00001EE7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE6,
        0x00001EE7,
        0x00001EE6
    };

    static Char _decompositionMapping00001EE8[] = 
    {
        0x000001AF,
        0x00000301
    };

    static _CharacterInfo _character00001EE8 =
    {
        0x00001EE8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE8,
        0x00001EE9,
        0x00001EE8
    };

    static Char _decompositionMapping00001EE9[] = 
    {
        0x000001B0,
        0x00000301
    };

    static _CharacterInfo _character00001EE9 =
    {
        0x00001EE9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EE8,
        0x00001EE9,
        0x00001EE8
    };

    static Char _decompositionMapping00001EEA[] = 
    {
        0x000001AF,
        0x00000300
    };

    static _CharacterInfo _character00001EEA =
    {
        0x00001EEA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEA,
        0x00001EEB,
        0x00001EEA
    };

    static Char _decompositionMapping00001EEB[] = 
    {
        0x000001B0,
        0x00000300
    };

    static _CharacterInfo _character00001EEB =
    {
        0x00001EEB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEA,
        0x00001EEB,
        0x00001EEA
    };

    static Char _decompositionMapping00001EEC[] = 
    {
        0x000001AF,
        0x00000309
    };

    static _CharacterInfo _character00001EEC =
    {
        0x00001EEC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEC,
        0x00001EED,
        0x00001EEC
    };

    static Char _decompositionMapping00001EED[] = 
    {
        0x000001B0,
        0x00000309
    };

    static _CharacterInfo _character00001EED =
    {
        0x00001EED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEC,
        0x00001EED,
        0x00001EEC
    };

    static Char _decompositionMapping00001EEE[] = 
    {
        0x000001AF,
        0x00000303
    };

    static _CharacterInfo _character00001EEE =
    {
        0x00001EEE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEE,
        0x00001EEF,
        0x00001EEE
    };

    static Char _decompositionMapping00001EEF[] = 
    {
        0x000001B0,
        0x00000303
    };

    static _CharacterInfo _character00001EEF =
    {
        0x00001EEF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EEF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EEE,
        0x00001EEF,
        0x00001EEE
    };

    static Char _decompositionMapping00001EF0[] = 
    {
        0x000001AF,
        0x00000323
    };

    static _CharacterInfo _character00001EF0 =
    {
        0x00001EF0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF0,
        0x00001EF1,
        0x00001EF0
    };

    static Char _decompositionMapping00001EF1[] = 
    {
        0x000001B0,
        0x00000323
    };

    static _CharacterInfo _character00001EF1 =
    {
        0x00001EF1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF0,
        0x00001EF1,
        0x00001EF0
    };

    static Char _decompositionMapping00001EF2[] = 
    {
        0x00000059,
        0x00000300
    };

    static _CharacterInfo _character00001EF2 =
    {
        0x00001EF2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF2,
        0x00001EF3,
        0x00001EF2
    };

    static Char _decompositionMapping00001EF3[] = 
    {
        0x00000079,
        0x00000300
    };

    static _CharacterInfo _character00001EF3 =
    {
        0x00001EF3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF2,
        0x00001EF3,
        0x00001EF2
    };

    static Char _decompositionMapping00001EF4[] = 
    {
        0x00000059,
        0x00000323
    };

    static _CharacterInfo _character00001EF4 =
    {
        0x00001EF4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF4,
        0x00001EF5,
        0x00001EF4
    };

    static Char _decompositionMapping00001EF5[] = 
    {
        0x00000079,
        0x00000323
    };

    static _CharacterInfo _character00001EF5 =
    {
        0x00001EF5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF4,
        0x00001EF5,
        0x00001EF4
    };

    static Char _decompositionMapping00001EF6[] = 
    {
        0x00000059,
        0x00000309
    };

    static _CharacterInfo _character00001EF6 =
    {
        0x00001EF6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF6,
        0x00001EF7,
        0x00001EF6
    };

    static Char _decompositionMapping00001EF7[] = 
    {
        0x00000079,
        0x00000309
    };

    static _CharacterInfo _character00001EF7 =
    {
        0x00001EF7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF6,
        0x00001EF7,
        0x00001EF6
    };

    static Char _decompositionMapping00001EF8[] = 
    {
        0x00000059,
        0x00000303
    };

    static _CharacterInfo _character00001EF8 =
    {
        0x00001EF8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF8,
        0x00001EF9,
        0x00001EF8
    };

    static Char _decompositionMapping00001EF9[] = 
    {
        0x00000079,
        0x00000303
    };

    static _CharacterInfo _character00001EF9 =
    {
        0x00001EF9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001EF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001EF8,
        0x00001EF9,
        0x00001EF8
    };

    static Char _decompositionMapping00001F00[] = 
    {
        0x000003B1,
        0x00000313
    };

    static _CharacterInfo _character00001F00 =
    {
        0x00001F00,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F08,
        0x00001F00,
        0x00001F08
    };

    static Char _decompositionMapping00001F01[] = 
    {
        0x000003B1,
        0x00000314
    };

    static _CharacterInfo _character00001F01 =
    {
        0x00001F01,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F09,
        0x00001F01,
        0x00001F09
    };

    static Char _decompositionMapping00001F02[] = 
    {
        0x00001F00,
        0x00000300
    };

    static _CharacterInfo _character00001F02 =
    {
        0x00001F02,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0A,
        0x00001F02,
        0x00001F0A
    };

    static Char _decompositionMapping00001F03[] = 
    {
        0x00001F01,
        0x00000300
    };

    static _CharacterInfo _character00001F03 =
    {
        0x00001F03,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0B,
        0x00001F03,
        0x00001F0B
    };

    static Char _decompositionMapping00001F04[] = 
    {
        0x00001F00,
        0x00000301
    };

    static _CharacterInfo _character00001F04 =
    {
        0x00001F04,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0C,
        0x00001F04,
        0x00001F0C
    };

    static Char _decompositionMapping00001F05[] = 
    {
        0x00001F01,
        0x00000301
    };

    static _CharacterInfo _character00001F05 =
    {
        0x00001F05,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0D,
        0x00001F05,
        0x00001F0D
    };

    static Char _decompositionMapping00001F06[] = 
    {
        0x00001F00,
        0x00000342
    };

    static _CharacterInfo _character00001F06 =
    {
        0x00001F06,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0E,
        0x00001F06,
        0x00001F0E
    };

    static Char _decompositionMapping00001F07[] = 
    {
        0x00001F01,
        0x00000342
    };

    static _CharacterInfo _character00001F07 =
    {
        0x00001F07,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0F,
        0x00001F07,
        0x00001F0F
    };

    static Char _decompositionMapping00001F08[] = 
    {
        0x00000391,
        0x00000313
    };

    static _CharacterInfo _character00001F08 =
    {
        0x00001F08,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F08,
        0x00001F00,
        0x00001F08
    };

    static Char _decompositionMapping00001F09[] = 
    {
        0x00000391,
        0x00000314
    };

    static _CharacterInfo _character00001F09 =
    {
        0x00001F09,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F09,
        0x00001F01,
        0x00001F09
    };

    static Char _decompositionMapping00001F0A[] = 
    {
        0x00001F08,
        0x00000300
    };

    static _CharacterInfo _character00001F0A =
    {
        0x00001F0A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0A,
        0x00001F02,
        0x00001F0A
    };

    static Char _decompositionMapping00001F0B[] = 
    {
        0x00001F09,
        0x00000300
    };

    static _CharacterInfo _character00001F0B =
    {
        0x00001F0B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0B,
        0x00001F03,
        0x00001F0B
    };

    static Char _decompositionMapping00001F0C[] = 
    {
        0x00001F08,
        0x00000301
    };

    static _CharacterInfo _character00001F0C =
    {
        0x00001F0C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0C,
        0x00001F04,
        0x00001F0C
    };

    static Char _decompositionMapping00001F0D[] = 
    {
        0x00001F09,
        0x00000301
    };

    static _CharacterInfo _character00001F0D =
    {
        0x00001F0D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0D,
        0x00001F05,
        0x00001F0D
    };

    static Char _decompositionMapping00001F0E[] = 
    {
        0x00001F08,
        0x00000342
    };

    static _CharacterInfo _character00001F0E =
    {
        0x00001F0E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0E,
        0x00001F06,
        0x00001F0E
    };

    static Char _decompositionMapping00001F0F[] = 
    {
        0x00001F09,
        0x00000342
    };

    static _CharacterInfo _character00001F0F =
    {
        0x00001F0F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F0F,
        0x00001F07,
        0x00001F0F
    };

    static Char _decompositionMapping00001F10[] = 
    {
        0x000003B5,
        0x00000313
    };

    static _CharacterInfo _character00001F10 =
    {
        0x00001F10,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F18,
        0x00001F10,
        0x00001F18
    };

    static Char _decompositionMapping00001F11[] = 
    {
        0x000003B5,
        0x00000314
    };

    static _CharacterInfo _character00001F11 =
    {
        0x00001F11,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F19,
        0x00001F11,
        0x00001F19
    };

    static Char _decompositionMapping00001F12[] = 
    {
        0x00001F10,
        0x00000300
    };

    static _CharacterInfo _character00001F12 =
    {
        0x00001F12,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1A,
        0x00001F12,
        0x00001F1A
    };

    static Char _decompositionMapping00001F13[] = 
    {
        0x00001F11,
        0x00000300
    };

    static _CharacterInfo _character00001F13 =
    {
        0x00001F13,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1B,
        0x00001F13,
        0x00001F1B
    };

    static Char _decompositionMapping00001F14[] = 
    {
        0x00001F10,
        0x00000301
    };

    static _CharacterInfo _character00001F14 =
    {
        0x00001F14,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1C,
        0x00001F14,
        0x00001F1C
    };

    static Char _decompositionMapping00001F15[] = 
    {
        0x00001F11,
        0x00000301
    };

    static _CharacterInfo _character00001F15 =
    {
        0x00001F15,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1D,
        0x00001F15,
        0x00001F1D
    };

    static Char _decompositionMapping00001F18[] = 
    {
        0x00000395,
        0x00000313
    };

    static _CharacterInfo _character00001F18 =
    {
        0x00001F18,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F18,
        0x00001F10,
        0x00001F18
    };

    static Char _decompositionMapping00001F19[] = 
    {
        0x00000395,
        0x00000314
    };

    static _CharacterInfo _character00001F19 =
    {
        0x00001F19,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F19,
        0x00001F11,
        0x00001F19
    };

    static Char _decompositionMapping00001F1A[] = 
    {
        0x00001F18,
        0x00000300
    };

    static _CharacterInfo _character00001F1A =
    {
        0x00001F1A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1A,
        0x00001F12,
        0x00001F1A
    };

    static Char _decompositionMapping00001F1B[] = 
    {
        0x00001F19,
        0x00000300
    };

    static _CharacterInfo _character00001F1B =
    {
        0x00001F1B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1B,
        0x00001F13,
        0x00001F1B
    };

    static Char _decompositionMapping00001F1C[] = 
    {
        0x00001F18,
        0x00000301
    };

    static _CharacterInfo _character00001F1C =
    {
        0x00001F1C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1C,
        0x00001F14,
        0x00001F1C
    };

    static Char _decompositionMapping00001F1D[] = 
    {
        0x00001F19,
        0x00000301
    };

    static _CharacterInfo _character00001F1D =
    {
        0x00001F1D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F1D,
        0x00001F15,
        0x00001F1D
    };

    static Char _decompositionMapping00001F20[] = 
    {
        0x000003B7,
        0x00000313
    };

    static _CharacterInfo _character00001F20 =
    {
        0x00001F20,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F28,
        0x00001F20,
        0x00001F28
    };

    static Char _decompositionMapping00001F21[] = 
    {
        0x000003B7,
        0x00000314
    };

    static _CharacterInfo _character00001F21 =
    {
        0x00001F21,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F29,
        0x00001F21,
        0x00001F29
    };

    static Char _decompositionMapping00001F22[] = 
    {
        0x00001F20,
        0x00000300
    };

    static _CharacterInfo _character00001F22 =
    {
        0x00001F22,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2A,
        0x00001F22,
        0x00001F2A
    };

    static Char _decompositionMapping00001F23[] = 
    {
        0x00001F21,
        0x00000300
    };

    static _CharacterInfo _character00001F23 =
    {
        0x00001F23,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2B,
        0x00001F23,
        0x00001F2B
    };

    static Char _decompositionMapping00001F24[] = 
    {
        0x00001F20,
        0x00000301
    };

    static _CharacterInfo _character00001F24 =
    {
        0x00001F24,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2C,
        0x00001F24,
        0x00001F2C
    };

    static Char _decompositionMapping00001F25[] = 
    {
        0x00001F21,
        0x00000301
    };

    static _CharacterInfo _character00001F25 =
    {
        0x00001F25,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2D,
        0x00001F25,
        0x00001F2D
    };

    static Char _decompositionMapping00001F26[] = 
    {
        0x00001F20,
        0x00000342
    };

    static _CharacterInfo _character00001F26 =
    {
        0x00001F26,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2E,
        0x00001F26,
        0x00001F2E
    };

    static Char _decompositionMapping00001F27[] = 
    {
        0x00001F21,
        0x00000342
    };

    static _CharacterInfo _character00001F27 =
    {
        0x00001F27,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2F,
        0x00001F27,
        0x00001F2F
    };

    static Char _decompositionMapping00001F28[] = 
    {
        0x00000397,
        0x00000313
    };

    static _CharacterInfo _character00001F28 =
    {
        0x00001F28,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F28,
        0x00001F20,
        0x00001F28
    };

    static Char _decompositionMapping00001F29[] = 
    {
        0x00000397,
        0x00000314
    };

    static _CharacterInfo _character00001F29 =
    {
        0x00001F29,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F29,
        0x00001F21,
        0x00001F29
    };

    static Char _decompositionMapping00001F2A[] = 
    {
        0x00001F28,
        0x00000300
    };

    static _CharacterInfo _character00001F2A =
    {
        0x00001F2A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2A,
        0x00001F22,
        0x00001F2A
    };

    static Char _decompositionMapping00001F2B[] = 
    {
        0x00001F29,
        0x00000300
    };

    static _CharacterInfo _character00001F2B =
    {
        0x00001F2B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2B,
        0x00001F23,
        0x00001F2B
    };

    static Char _decompositionMapping00001F2C[] = 
    {
        0x00001F28,
        0x00000301
    };

    static _CharacterInfo _character00001F2C =
    {
        0x00001F2C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2C,
        0x00001F24,
        0x00001F2C
    };

    static Char _decompositionMapping00001F2D[] = 
    {
        0x00001F29,
        0x00000301
    };

    static _CharacterInfo _character00001F2D =
    {
        0x00001F2D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2D,
        0x00001F25,
        0x00001F2D
    };

    static Char _decompositionMapping00001F2E[] = 
    {
        0x00001F28,
        0x00000342
    };

    static _CharacterInfo _character00001F2E =
    {
        0x00001F2E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2E,
        0x00001F26,
        0x00001F2E
    };

    static Char _decompositionMapping00001F2F[] = 
    {
        0x00001F29,
        0x00000342
    };

    static _CharacterInfo _character00001F2F =
    {
        0x00001F2F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F2F,
        0x00001F27,
        0x00001F2F
    };

    static Char _decompositionMapping00001F30[] = 
    {
        0x000003B9,
        0x00000313
    };

    static _CharacterInfo _character00001F30 =
    {
        0x00001F30,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F38,
        0x00001F30,
        0x00001F38
    };

    static Char _decompositionMapping00001F31[] = 
    {
        0x000003B9,
        0x00000314
    };

    static _CharacterInfo _character00001F31 =
    {
        0x00001F31,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F39,
        0x00001F31,
        0x00001F39
    };

    static Char _decompositionMapping00001F32[] = 
    {
        0x00001F30,
        0x00000300
    };

    static _CharacterInfo _character00001F32 =
    {
        0x00001F32,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3A,
        0x00001F32,
        0x00001F3A
    };

    static Char _decompositionMapping00001F33[] = 
    {
        0x00001F31,
        0x00000300
    };

    static _CharacterInfo _character00001F33 =
    {
        0x00001F33,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3B,
        0x00001F33,
        0x00001F3B
    };

    static Char _decompositionMapping00001F34[] = 
    {
        0x00001F30,
        0x00000301
    };

    static _CharacterInfo _character00001F34 =
    {
        0x00001F34,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3C,
        0x00001F34,
        0x00001F3C
    };

    static Char _decompositionMapping00001F35[] = 
    {
        0x00001F31,
        0x00000301
    };

    static _CharacterInfo _character00001F35 =
    {
        0x00001F35,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3D,
        0x00001F35,
        0x00001F3D
    };

    static Char _decompositionMapping00001F36[] = 
    {
        0x00001F30,
        0x00000342
    };

    static _CharacterInfo _character00001F36 =
    {
        0x00001F36,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3E,
        0x00001F36,
        0x00001F3E
    };

    static Char _decompositionMapping00001F37[] = 
    {
        0x00001F31,
        0x00000342
    };

    static _CharacterInfo _character00001F37 =
    {
        0x00001F37,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3F,
        0x00001F37,
        0x00001F3F
    };

    static Char _decompositionMapping00001F38[] = 
    {
        0x00000399,
        0x00000313
    };

    static _CharacterInfo _character00001F38 =
    {
        0x00001F38,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F38,
        0x00001F30,
        0x00001F38
    };

    static Char _decompositionMapping00001F39[] = 
    {
        0x00000399,
        0x00000314
    };

    static _CharacterInfo _character00001F39 =
    {
        0x00001F39,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F39,
        0x00001F31,
        0x00001F39
    };

    static Char _decompositionMapping00001F3A[] = 
    {
        0x00001F38,
        0x00000300
    };

    static _CharacterInfo _character00001F3A =
    {
        0x00001F3A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3A,
        0x00001F32,
        0x00001F3A
    };

    static Char _decompositionMapping00001F3B[] = 
    {
        0x00001F39,
        0x00000300
    };

    static _CharacterInfo _character00001F3B =
    {
        0x00001F3B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3B,
        0x00001F33,
        0x00001F3B
    };

    static Char _decompositionMapping00001F3C[] = 
    {
        0x00001F38,
        0x00000301
    };

    static _CharacterInfo _character00001F3C =
    {
        0x00001F3C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3C,
        0x00001F34,
        0x00001F3C
    };

    static Char _decompositionMapping00001F3D[] = 
    {
        0x00001F39,
        0x00000301
    };

    static _CharacterInfo _character00001F3D =
    {
        0x00001F3D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3D,
        0x00001F35,
        0x00001F3D
    };

    static Char _decompositionMapping00001F3E[] = 
    {
        0x00001F38,
        0x00000342
    };

    static _CharacterInfo _character00001F3E =
    {
        0x00001F3E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3E,
        0x00001F36,
        0x00001F3E
    };

    static Char _decompositionMapping00001F3F[] = 
    {
        0x00001F39,
        0x00000342
    };

    static _CharacterInfo _character00001F3F =
    {
        0x00001F3F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F3F,
        0x00001F37,
        0x00001F3F
    };

    static Char _decompositionMapping00001F40[] = 
    {
        0x000003BF,
        0x00000313
    };

    static _CharacterInfo _character00001F40 =
    {
        0x00001F40,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F48,
        0x00001F40,
        0x00001F48
    };

    static Char _decompositionMapping00001F41[] = 
    {
        0x000003BF,
        0x00000314
    };

    static _CharacterInfo _character00001F41 =
    {
        0x00001F41,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F49,
        0x00001F41,
        0x00001F49
    };

    static Char _decompositionMapping00001F42[] = 
    {
        0x00001F40,
        0x00000300
    };

    static _CharacterInfo _character00001F42 =
    {
        0x00001F42,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4A,
        0x00001F42,
        0x00001F4A
    };

    static Char _decompositionMapping00001F43[] = 
    {
        0x00001F41,
        0x00000300
    };

    static _CharacterInfo _character00001F43 =
    {
        0x00001F43,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4B,
        0x00001F43,
        0x00001F4B
    };

    static Char _decompositionMapping00001F44[] = 
    {
        0x00001F40,
        0x00000301
    };

    static _CharacterInfo _character00001F44 =
    {
        0x00001F44,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4C,
        0x00001F44,
        0x00001F4C
    };

    static Char _decompositionMapping00001F45[] = 
    {
        0x00001F41,
        0x00000301
    };

    static _CharacterInfo _character00001F45 =
    {
        0x00001F45,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4D,
        0x00001F45,
        0x00001F4D
    };

    static Char _decompositionMapping00001F48[] = 
    {
        0x0000039F,
        0x00000313
    };

    static _CharacterInfo _character00001F48 =
    {
        0x00001F48,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F48,
        0x00001F40,
        0x00001F48
    };

    static Char _decompositionMapping00001F49[] = 
    {
        0x0000039F,
        0x00000314
    };

    static _CharacterInfo _character00001F49 =
    {
        0x00001F49,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F49,
        0x00001F41,
        0x00001F49
    };

    static Char _decompositionMapping00001F4A[] = 
    {
        0x00001F48,
        0x00000300
    };

    static _CharacterInfo _character00001F4A =
    {
        0x00001F4A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4A,
        0x00001F42,
        0x00001F4A
    };

    static Char _decompositionMapping00001F4B[] = 
    {
        0x00001F49,
        0x00000300
    };

    static _CharacterInfo _character00001F4B =
    {
        0x00001F4B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4B,
        0x00001F43,
        0x00001F4B
    };

    static Char _decompositionMapping00001F4C[] = 
    {
        0x00001F48,
        0x00000301
    };

    static _CharacterInfo _character00001F4C =
    {
        0x00001F4C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4C,
        0x00001F44,
        0x00001F4C
    };

    static Char _decompositionMapping00001F4D[] = 
    {
        0x00001F49,
        0x00000301
    };

    static _CharacterInfo _character00001F4D =
    {
        0x00001F4D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F4D,
        0x00001F45,
        0x00001F4D
    };

    static Char _decompositionMapping00001F50[] = 
    {
        0x000003C5,
        0x00000313
    };

    static _CharacterInfo _character00001F50 =
    {
        0x00001F50,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F50,
        0x00001F50,
        0x00001F50
    };

    static Char _decompositionMapping00001F51[] = 
    {
        0x000003C5,
        0x00000314
    };

    static _CharacterInfo _character00001F51 =
    {
        0x00001F51,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F59,
        0x00001F51,
        0x00001F59
    };

    static Char _decompositionMapping00001F52[] = 
    {
        0x00001F50,
        0x00000300
    };

    static _CharacterInfo _character00001F52 =
    {
        0x00001F52,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F52,
        0x00001F52,
        0x00001F52
    };

    static Char _decompositionMapping00001F53[] = 
    {
        0x00001F51,
        0x00000300
    };

    static _CharacterInfo _character00001F53 =
    {
        0x00001F53,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5B,
        0x00001F53,
        0x00001F5B
    };

    static Char _decompositionMapping00001F54[] = 
    {
        0x00001F50,
        0x00000301
    };

    static _CharacterInfo _character00001F54 =
    {
        0x00001F54,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F54,
        0x00001F54,
        0x00001F54
    };

    static Char _decompositionMapping00001F55[] = 
    {
        0x00001F51,
        0x00000301
    };

    static _CharacterInfo _character00001F55 =
    {
        0x00001F55,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5D,
        0x00001F55,
        0x00001F5D
    };

    static Char _decompositionMapping00001F56[] = 
    {
        0x00001F50,
        0x00000342
    };

    static _CharacterInfo _character00001F56 =
    {
        0x00001F56,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F56,
        0x00001F56,
        0x00001F56
    };

    static Char _decompositionMapping00001F57[] = 
    {
        0x00001F51,
        0x00000342
    };

    static _CharacterInfo _character00001F57 =
    {
        0x00001F57,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5F,
        0x00001F57,
        0x00001F5F
    };

    static Char _decompositionMapping00001F59[] = 
    {
        0x000003A5,
        0x00000314
    };

    static _CharacterInfo _character00001F59 =
    {
        0x00001F59,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F59,
        0x00001F51,
        0x00001F59
    };

    static Char _decompositionMapping00001F5B[] = 
    {
        0x00001F59,
        0x00000300
    };

    static _CharacterInfo _character00001F5B =
    {
        0x00001F5B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5B,
        0x00001F53,
        0x00001F5B
    };

    static Char _decompositionMapping00001F5D[] = 
    {
        0x00001F59,
        0x00000301
    };

    static _CharacterInfo _character00001F5D =
    {
        0x00001F5D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5D,
        0x00001F55,
        0x00001F5D
    };

    static Char _decompositionMapping00001F5F[] = 
    {
        0x00001F59,
        0x00000342
    };

    static _CharacterInfo _character00001F5F =
    {
        0x00001F5F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F5F,
        0x00001F57,
        0x00001F5F
    };

    static Char _decompositionMapping00001F60[] = 
    {
        0x000003C9,
        0x00000313
    };

    static _CharacterInfo _character00001F60 =
    {
        0x00001F60,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F68,
        0x00001F60,
        0x00001F68
    };

    static Char _decompositionMapping00001F61[] = 
    {
        0x000003C9,
        0x00000314
    };

    static _CharacterInfo _character00001F61 =
    {
        0x00001F61,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F69,
        0x00001F61,
        0x00001F69
    };

    static Char _decompositionMapping00001F62[] = 
    {
        0x00001F60,
        0x00000300
    };

    static _CharacterInfo _character00001F62 =
    {
        0x00001F62,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6A,
        0x00001F62,
        0x00001F6A
    };

    static Char _decompositionMapping00001F63[] = 
    {
        0x00001F61,
        0x00000300
    };

    static _CharacterInfo _character00001F63 =
    {
        0x00001F63,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6B,
        0x00001F63,
        0x00001F6B
    };

    static Char _decompositionMapping00001F64[] = 
    {
        0x00001F60,
        0x00000301
    };

    static _CharacterInfo _character00001F64 =
    {
        0x00001F64,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6C,
        0x00001F64,
        0x00001F6C
    };

    static Char _decompositionMapping00001F65[] = 
    {
        0x00001F61,
        0x00000301
    };

    static _CharacterInfo _character00001F65 =
    {
        0x00001F65,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6D,
        0x00001F65,
        0x00001F6D
    };

    static Char _decompositionMapping00001F66[] = 
    {
        0x00001F60,
        0x00000342
    };

    static _CharacterInfo _character00001F66 =
    {
        0x00001F66,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6E,
        0x00001F66,
        0x00001F6E
    };

    static Char _decompositionMapping00001F67[] = 
    {
        0x00001F61,
        0x00000342
    };

    static _CharacterInfo _character00001F67 =
    {
        0x00001F67,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6F,
        0x00001F67,
        0x00001F6F
    };

    static Char _decompositionMapping00001F68[] = 
    {
        0x000003A9,
        0x00000313
    };

    static _CharacterInfo _character00001F68 =
    {
        0x00001F68,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F68,
        0x00001F60,
        0x00001F68
    };

    static Char _decompositionMapping00001F69[] = 
    {
        0x000003A9,
        0x00000314
    };

    static _CharacterInfo _character00001F69 =
    {
        0x00001F69,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F69,
        0x00001F61,
        0x00001F69
    };

    static Char _decompositionMapping00001F6A[] = 
    {
        0x00001F68,
        0x00000300
    };

    static _CharacterInfo _character00001F6A =
    {
        0x00001F6A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6A,
        0x00001F62,
        0x00001F6A
    };

    static Char _decompositionMapping00001F6B[] = 
    {
        0x00001F69,
        0x00000300
    };

    static _CharacterInfo _character00001F6B =
    {
        0x00001F6B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6B,
        0x00001F63,
        0x00001F6B
    };

    static Char _decompositionMapping00001F6C[] = 
    {
        0x00001F68,
        0x00000301
    };

    static _CharacterInfo _character00001F6C =
    {
        0x00001F6C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6C,
        0x00001F64,
        0x00001F6C
    };

    static Char _decompositionMapping00001F6D[] = 
    {
        0x00001F69,
        0x00000301
    };

    static _CharacterInfo _character00001F6D =
    {
        0x00001F6D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6D,
        0x00001F65,
        0x00001F6D
    };

    static Char _decompositionMapping00001F6E[] = 
    {
        0x00001F68,
        0x00000342
    };

    static _CharacterInfo _character00001F6E =
    {
        0x00001F6E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6E,
        0x00001F66,
        0x00001F6E
    };

    static Char _decompositionMapping00001F6F[] = 
    {
        0x00001F69,
        0x00000342
    };

    static _CharacterInfo _character00001F6F =
    {
        0x00001F6F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F6F,
        0x00001F67,
        0x00001F6F
    };

    static Char _decompositionMapping00001F70[] = 
    {
        0x000003B1,
        0x00000300
    };

    static _CharacterInfo _character00001F70 =
    {
        0x00001F70,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBA,
        0x00001F70,
        0x00001FBA
    };

    static Char _decompositionMapping00001F71[] = 
    {
        0x000003AC
    };

    static _CharacterInfo _character00001F71 =
    {
        0x00001F71,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBB,
        0x00001F71,
        0x00001FBB
    };

    static Char _decompositionMapping00001F72[] = 
    {
        0x000003B5,
        0x00000300
    };

    static _CharacterInfo _character00001F72 =
    {
        0x00001F72,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC8,
        0x00001F72,
        0x00001FC8
    };

    static Char _decompositionMapping00001F73[] = 
    {
        0x000003AD
    };

    static _CharacterInfo _character00001F73 =
    {
        0x00001F73,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC9,
        0x00001F73,
        0x00001FC9
    };

    static Char _decompositionMapping00001F74[] = 
    {
        0x000003B7,
        0x00000300
    };

    static _CharacterInfo _character00001F74 =
    {
        0x00001F74,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCA,
        0x00001F74,
        0x00001FCA
    };

    static Char _decompositionMapping00001F75[] = 
    {
        0x000003AE
    };

    static _CharacterInfo _character00001F75 =
    {
        0x00001F75,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCB,
        0x00001F75,
        0x00001FCB
    };

    static Char _decompositionMapping00001F76[] = 
    {
        0x000003B9,
        0x00000300
    };

    static _CharacterInfo _character00001F76 =
    {
        0x00001F76,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDA,
        0x00001F76,
        0x00001FDA
    };

    static Char _decompositionMapping00001F77[] = 
    {
        0x000003AF
    };

    static _CharacterInfo _character00001F77 =
    {
        0x00001F77,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDB,
        0x00001F77,
        0x00001FDB
    };

    static Char _decompositionMapping00001F78[] = 
    {
        0x000003BF,
        0x00000300
    };

    static _CharacterInfo _character00001F78 =
    {
        0x00001F78,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF8,
        0x00001F78,
        0x00001FF8
    };

    static Char _decompositionMapping00001F79[] = 
    {
        0x000003CC
    };

    static _CharacterInfo _character00001F79 =
    {
        0x00001F79,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF9,
        0x00001F79,
        0x00001FF9
    };

    static Char _decompositionMapping00001F7A[] = 
    {
        0x000003C5,
        0x00000300
    };

    static _CharacterInfo _character00001F7A =
    {
        0x00001F7A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEA,
        0x00001F7A,
        0x00001FEA
    };

    static Char _decompositionMapping00001F7B[] = 
    {
        0x000003CD
    };

    static _CharacterInfo _character00001F7B =
    {
        0x00001F7B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEB,
        0x00001F7B,
        0x00001FEB
    };

    static Char _decompositionMapping00001F7C[] = 
    {
        0x000003C9,
        0x00000300
    };

    static _CharacterInfo _character00001F7C =
    {
        0x00001F7C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFA,
        0x00001F7C,
        0x00001FFA
    };

    static Char _decompositionMapping00001F7D[] = 
    {
        0x000003CE
    };

    static _CharacterInfo _character00001F7D =
    {
        0x00001F7D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001F7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFB,
        0x00001F7D,
        0x00001FFB
    };

    static Char _decompositionMapping00001F80[] = 
    {
        0x00001F00,
        0x00000345
    };

    static _CharacterInfo _character00001F80 =
    {
        0x00001F80,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F88,
        0x00001F80,
        0x00001F88
    };

    static Char _decompositionMapping00001F81[] = 
    {
        0x00001F01,
        0x00000345
    };

    static _CharacterInfo _character00001F81 =
    {
        0x00001F81,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F89,
        0x00001F81,
        0x00001F89
    };

    static Char _decompositionMapping00001F82[] = 
    {
        0x00001F02,
        0x00000345
    };

    static _CharacterInfo _character00001F82 =
    {
        0x00001F82,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8A,
        0x00001F82,
        0x00001F8A
    };

    static Char _decompositionMapping00001F83[] = 
    {
        0x00001F03,
        0x00000345
    };

    static _CharacterInfo _character00001F83 =
    {
        0x00001F83,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8B,
        0x00001F83,
        0x00001F8B
    };

    static Char _decompositionMapping00001F84[] = 
    {
        0x00001F04,
        0x00000345
    };

    static _CharacterInfo _character00001F84 =
    {
        0x00001F84,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8C,
        0x00001F84,
        0x00001F8C
    };

    static Char _decompositionMapping00001F85[] = 
    {
        0x00001F05,
        0x00000345
    };

    static _CharacterInfo _character00001F85 =
    {
        0x00001F85,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8D,
        0x00001F85,
        0x00001F8D
    };

    static Char _decompositionMapping00001F86[] = 
    {
        0x00001F06,
        0x00000345
    };

    static _CharacterInfo _character00001F86 =
    {
        0x00001F86,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8E,
        0x00001F86,
        0x00001F8E
    };

    static Char _decompositionMapping00001F87[] = 
    {
        0x00001F07,
        0x00000345
    };

    static _CharacterInfo _character00001F87 =
    {
        0x00001F87,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8F,
        0x00001F87,
        0x00001F8F
    };

    static Char _decompositionMapping00001F88[] = 
    {
        0x00001F08,
        0x00000345
    };

    static _CharacterInfo _character00001F88 =
    {
        0x00001F88,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F88,
        0x00001F80,
        0x00001F88
    };

    static Char _decompositionMapping00001F89[] = 
    {
        0x00001F09,
        0x00000345
    };

    static _CharacterInfo _character00001F89 =
    {
        0x00001F89,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F89,
        0x00001F81,
        0x00001F89
    };

    static Char _decompositionMapping00001F8A[] = 
    {
        0x00001F0A,
        0x00000345
    };

    static _CharacterInfo _character00001F8A =
    {
        0x00001F8A,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8A,
        0x00001F82,
        0x00001F8A
    };

    static Char _decompositionMapping00001F8B[] = 
    {
        0x00001F0B,
        0x00000345
    };

    static _CharacterInfo _character00001F8B =
    {
        0x00001F8B,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8B,
        0x00001F83,
        0x00001F8B
    };

    static Char _decompositionMapping00001F8C[] = 
    {
        0x00001F0C,
        0x00000345
    };

    static _CharacterInfo _character00001F8C =
    {
        0x00001F8C,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8C,
        0x00001F84,
        0x00001F8C
    };

    static Char _decompositionMapping00001F8D[] = 
    {
        0x00001F0D,
        0x00000345
    };

    static _CharacterInfo _character00001F8D =
    {
        0x00001F8D,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8D,
        0x00001F85,
        0x00001F8D
    };

    static Char _decompositionMapping00001F8E[] = 
    {
        0x00001F0E,
        0x00000345
    };

    static _CharacterInfo _character00001F8E =
    {
        0x00001F8E,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8E,
        0x00001F86,
        0x00001F8E
    };

    static Char _decompositionMapping00001F8F[] = 
    {
        0x00001F0F,
        0x00000345
    };

    static _CharacterInfo _character00001F8F =
    {
        0x00001F8F,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F8F,
        0x00001F87,
        0x00001F8F
    };

    static Char _decompositionMapping00001F90[] = 
    {
        0x00001F20,
        0x00000345
    };

    static _CharacterInfo _character00001F90 =
    {
        0x00001F90,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F98,
        0x00001F90,
        0x00001F98
    };

    static Char _decompositionMapping00001F91[] = 
    {
        0x00001F21,
        0x00000345
    };

    static _CharacterInfo _character00001F91 =
    {
        0x00001F91,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F99,
        0x00001F91,
        0x00001F99
    };

    static Char _decompositionMapping00001F92[] = 
    {
        0x00001F22,
        0x00000345
    };

    static _CharacterInfo _character00001F92 =
    {
        0x00001F92,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9A,
        0x00001F92,
        0x00001F9A
    };

    static Char _decompositionMapping00001F93[] = 
    {
        0x00001F23,
        0x00000345
    };

    static _CharacterInfo _character00001F93 =
    {
        0x00001F93,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9B,
        0x00001F93,
        0x00001F9B
    };

    static Char _decompositionMapping00001F94[] = 
    {
        0x00001F24,
        0x00000345
    };

    static _CharacterInfo _character00001F94 =
    {
        0x00001F94,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9C,
        0x00001F94,
        0x00001F9C
    };

    static Char _decompositionMapping00001F95[] = 
    {
        0x00001F25,
        0x00000345
    };

    static _CharacterInfo _character00001F95 =
    {
        0x00001F95,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9D,
        0x00001F95,
        0x00001F9D
    };

    static Char _decompositionMapping00001F96[] = 
    {
        0x00001F26,
        0x00000345
    };

    static _CharacterInfo _character00001F96 =
    {
        0x00001F96,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9E,
        0x00001F96,
        0x00001F9E
    };

    static Char _decompositionMapping00001F97[] = 
    {
        0x00001F27,
        0x00000345
    };

    static _CharacterInfo _character00001F97 =
    {
        0x00001F97,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9F,
        0x00001F97,
        0x00001F9F
    };

    static Char _decompositionMapping00001F98[] = 
    {
        0x00001F28,
        0x00000345
    };

    static _CharacterInfo _character00001F98 =
    {
        0x00001F98,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F98,
        0x00001F90,
        0x00001F98
    };

    static Char _decompositionMapping00001F99[] = 
    {
        0x00001F29,
        0x00000345
    };

    static _CharacterInfo _character00001F99 =
    {
        0x00001F99,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F99,
        0x00001F91,
        0x00001F99
    };

    static Char _decompositionMapping00001F9A[] = 
    {
        0x00001F2A,
        0x00000345
    };

    static _CharacterInfo _character00001F9A =
    {
        0x00001F9A,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9A,
        0x00001F92,
        0x00001F9A
    };

    static Char _decompositionMapping00001F9B[] = 
    {
        0x00001F2B,
        0x00000345
    };

    static _CharacterInfo _character00001F9B =
    {
        0x00001F9B,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9B,
        0x00001F93,
        0x00001F9B
    };

    static Char _decompositionMapping00001F9C[] = 
    {
        0x00001F2C,
        0x00000345
    };

    static _CharacterInfo _character00001F9C =
    {
        0x00001F9C,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9C,
        0x00001F94,
        0x00001F9C
    };

    static Char _decompositionMapping00001F9D[] = 
    {
        0x00001F2D,
        0x00000345
    };

    static _CharacterInfo _character00001F9D =
    {
        0x00001F9D,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9D,
        0x00001F95,
        0x00001F9D
    };

    static Char _decompositionMapping00001F9E[] = 
    {
        0x00001F2E,
        0x00000345
    };

    static _CharacterInfo _character00001F9E =
    {
        0x00001F9E,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9E,
        0x00001F96,
        0x00001F9E
    };

    static Char _decompositionMapping00001F9F[] = 
    {
        0x00001F2F,
        0x00000345
    };

    static _CharacterInfo _character00001F9F =
    {
        0x00001F9F,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001F9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001F9F,
        0x00001F97,
        0x00001F9F
    };

    static Char _decompositionMapping00001FA0[] = 
    {
        0x00001F60,
        0x00000345
    };

    static _CharacterInfo _character00001FA0 =
    {
        0x00001FA0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FA8,
        0x00001FA0,
        0x00001FA8
    };

    static Char _decompositionMapping00001FA1[] = 
    {
        0x00001F61,
        0x00000345
    };

    static _CharacterInfo _character00001FA1 =
    {
        0x00001FA1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FA9,
        0x00001FA1,
        0x00001FA9
    };

    static Char _decompositionMapping00001FA2[] = 
    {
        0x00001F62,
        0x00000345
    };

    static _CharacterInfo _character00001FA2 =
    {
        0x00001FA2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAA,
        0x00001FA2,
        0x00001FAA
    };

    static Char _decompositionMapping00001FA3[] = 
    {
        0x00001F63,
        0x00000345
    };

    static _CharacterInfo _character00001FA3 =
    {
        0x00001FA3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAB,
        0x00001FA3,
        0x00001FAB
    };

    static Char _decompositionMapping00001FA4[] = 
    {
        0x00001F64,
        0x00000345
    };

    static _CharacterInfo _character00001FA4 =
    {
        0x00001FA4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAC,
        0x00001FA4,
        0x00001FAC
    };

    static Char _decompositionMapping00001FA5[] = 
    {
        0x00001F65,
        0x00000345
    };

    static _CharacterInfo _character00001FA5 =
    {
        0x00001FA5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAD,
        0x00001FA5,
        0x00001FAD
    };

    static Char _decompositionMapping00001FA6[] = 
    {
        0x00001F66,
        0x00000345
    };

    static _CharacterInfo _character00001FA6 =
    {
        0x00001FA6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAE,
        0x00001FA6,
        0x00001FAE
    };

    static Char _decompositionMapping00001FA7[] = 
    {
        0x00001F67,
        0x00000345
    };

    static _CharacterInfo _character00001FA7 =
    {
        0x00001FA7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAF,
        0x00001FA7,
        0x00001FAF
    };

    static Char _decompositionMapping00001FA8[] = 
    {
        0x00001F68,
        0x00000345
    };

    static _CharacterInfo _character00001FA8 =
    {
        0x00001FA8,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FA8,
        0x00001FA0,
        0x00001FA8
    };

    static Char _decompositionMapping00001FA9[] = 
    {
        0x00001F69,
        0x00000345
    };

    static _CharacterInfo _character00001FA9 =
    {
        0x00001FA9,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FA9,
        0x00001FA1,
        0x00001FA9
    };

    static Char _decompositionMapping00001FAA[] = 
    {
        0x00001F6A,
        0x00000345
    };

    static _CharacterInfo _character00001FAA =
    {
        0x00001FAA,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAA,
        0x00001FA2,
        0x00001FAA
    };

    static Char _decompositionMapping00001FAB[] = 
    {
        0x00001F6B,
        0x00000345
    };

    static _CharacterInfo _character00001FAB =
    {
        0x00001FAB,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAB,
        0x00001FA3,
        0x00001FAB
    };

    static Char _decompositionMapping00001FAC[] = 
    {
        0x00001F6C,
        0x00000345
    };

    static _CharacterInfo _character00001FAC =
    {
        0x00001FAC,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAC,
        0x00001FA4,
        0x00001FAC
    };

    static Char _decompositionMapping00001FAD[] = 
    {
        0x00001F6D,
        0x00000345
    };

    static _CharacterInfo _character00001FAD =
    {
        0x00001FAD,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAD,
        0x00001FA5,
        0x00001FAD
    };

    static Char _decompositionMapping00001FAE[] = 
    {
        0x00001F6E,
        0x00000345
    };

    static _CharacterInfo _character00001FAE =
    {
        0x00001FAE,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAE,
        0x00001FA6,
        0x00001FAE
    };

    static Char _decompositionMapping00001FAF[] = 
    {
        0x00001F6F,
        0x00000345
    };

    static _CharacterInfo _character00001FAF =
    {
        0x00001FAF,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FAF,
        0x00001FA7,
        0x00001FAF
    };

    static Char _decompositionMapping00001FB0[] = 
    {
        0x000003B1,
        0x00000306
    };

    static _CharacterInfo _character00001FB0 =
    {
        0x00001FB0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB8,
        0x00001FB0,
        0x00001FB8
    };

    static Char _decompositionMapping00001FB1[] = 
    {
        0x000003B1,
        0x00000304
    };

    static _CharacterInfo _character00001FB1 =
    {
        0x00001FB1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB9,
        0x00001FB1,
        0x00001FB9
    };

    static Char _decompositionMapping00001FB2[] = 
    {
        0x00001F70,
        0x00000345
    };

    static _CharacterInfo _character00001FB2 =
    {
        0x00001FB2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB2,
        0x00001FB2,
        0x00001FB2
    };

    static Char _decompositionMapping00001FB3[] = 
    {
        0x000003B1,
        0x00000345
    };

    static _CharacterInfo _character00001FB3 =
    {
        0x00001FB3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBC,
        0x00001FB3,
        0x00001FBC
    };

    static Char _decompositionMapping00001FB4[] = 
    {
        0x000003AC,
        0x00000345
    };

    static _CharacterInfo _character00001FB4 =
    {
        0x00001FB4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB4,
        0x00001FB4,
        0x00001FB4
    };

    static Char _decompositionMapping00001FB6[] = 
    {
        0x000003B1,
        0x00000342
    };

    static _CharacterInfo _character00001FB6 =
    {
        0x00001FB6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB6,
        0x00001FB6,
        0x00001FB6
    };

    static Char _decompositionMapping00001FB7[] = 
    {
        0x00001FB6,
        0x00000345
    };

    static _CharacterInfo _character00001FB7 =
    {
        0x00001FB7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB7,
        0x00001FB7,
        0x00001FB7
    };

    static Char _decompositionMapping00001FB8[] = 
    {
        0x00000391,
        0x00000306
    };

    static _CharacterInfo _character00001FB8 =
    {
        0x00001FB8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB8,
        0x00001FB0,
        0x00001FB8
    };

    static Char _decompositionMapping00001FB9[] = 
    {
        0x00000391,
        0x00000304
    };

    static _CharacterInfo _character00001FB9 =
    {
        0x00001FB9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FB9,
        0x00001FB1,
        0x00001FB9
    };

    static Char _decompositionMapping00001FBA[] = 
    {
        0x00000391,
        0x00000300
    };

    static _CharacterInfo _character00001FBA =
    {
        0x00001FBA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBA,
        0x00001F70,
        0x00001FBA
    };

    static Char _decompositionMapping00001FBB[] = 
    {
        0x00000386
    };

    static _CharacterInfo _character00001FBB =
    {
        0x00001FBB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBB,
        0x00001F71,
        0x00001FBB
    };

    static Char _decompositionMapping00001FBC[] = 
    {
        0x00000391,
        0x00000345
    };

    static _CharacterInfo _character00001FBC =
    {
        0x00001FBC,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBC,
        0x00001FB3,
        0x00001FBC
    };

    static Char _decompositionMapping00001FBD[] = 
    {
        0x00000020,
        0x00000313
    };

    static _CharacterInfo _character00001FBD =
    {
        0x00001FBD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00001FBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBD,
        0x00001FBD,
        0x00001FBD
    };

    static Char _decompositionMapping00001FBE[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character00001FBE =
    {
        0x00001FBE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00000399,
        0x00001FBE,
        0x00000399
    };

    static Char _decompositionMapping00001FBF[] = 
    {
        0x00000020,
        0x00000313
    };

    static _CharacterInfo _character00001FBF =
    {
        0x00001FBF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00001FBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FBF,
        0x00001FBF,
        0x00001FBF
    };

    static Char _decompositionMapping00001FC0[] = 
    {
        0x00000020,
        0x00000342
    };

    static _CharacterInfo _character00001FC0 =
    {
        0x00001FC0,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00001FC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC0,
        0x00001FC0,
        0x00001FC0
    };

    static Char _decompositionMapping00001FC1[] = 
    {
        0x000000A8,
        0x00000342
    };

    static _CharacterInfo _character00001FC1 =
    {
        0x00001FC1,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC1,
        0x00001FC1,
        0x00001FC1
    };

    static Char _decompositionMapping00001FC2[] = 
    {
        0x00001F74,
        0x00000345
    };

    static _CharacterInfo _character00001FC2 =
    {
        0x00001FC2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC2,
        0x00001FC2,
        0x00001FC2
    };

    static Char _decompositionMapping00001FC3[] = 
    {
        0x000003B7,
        0x00000345
    };

    static _CharacterInfo _character00001FC3 =
    {
        0x00001FC3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCC,
        0x00001FC3,
        0x00001FCC
    };

    static Char _decompositionMapping00001FC4[] = 
    {
        0x000003AE,
        0x00000345
    };

    static _CharacterInfo _character00001FC4 =
    {
        0x00001FC4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC4,
        0x00001FC4,
        0x00001FC4
    };

    static Char _decompositionMapping00001FC6[] = 
    {
        0x000003B7,
        0x00000342
    };

    static _CharacterInfo _character00001FC6 =
    {
        0x00001FC6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC6,
        0x00001FC6,
        0x00001FC6
    };

    static Char _decompositionMapping00001FC7[] = 
    {
        0x00001FC6,
        0x00000345
    };

    static _CharacterInfo _character00001FC7 =
    {
        0x00001FC7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC7,
        0x00001FC7,
        0x00001FC7
    };

    static Char _decompositionMapping00001FC8[] = 
    {
        0x00000395,
        0x00000300
    };

    static _CharacterInfo _character00001FC8 =
    {
        0x00001FC8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC8,
        0x00001F72,
        0x00001FC8
    };

    static Char _decompositionMapping00001FC9[] = 
    {
        0x00000388
    };

    static _CharacterInfo _character00001FC9 =
    {
        0x00001FC9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FC9,
        0x00001F73,
        0x00001FC9
    };

    static Char _decompositionMapping00001FCA[] = 
    {
        0x00000397,
        0x00000300
    };

    static _CharacterInfo _character00001FCA =
    {
        0x00001FCA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCA,
        0x00001F74,
        0x00001FCA
    };

    static Char _decompositionMapping00001FCB[] = 
    {
        0x00000389
    };

    static _CharacterInfo _character00001FCB =
    {
        0x00001FCB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCB,
        0x00001F75,
        0x00001FCB
    };

    static Char _decompositionMapping00001FCC[] = 
    {
        0x00000397,
        0x00000345
    };

    static _CharacterInfo _character00001FCC =
    {
        0x00001FCC,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FCC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCC,
        0x00001FC3,
        0x00001FCC
    };

    static Char _decompositionMapping00001FCD[] = 
    {
        0x00001FBF,
        0x00000300
    };

    static _CharacterInfo _character00001FCD =
    {
        0x00001FCD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FCD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCD,
        0x00001FCD,
        0x00001FCD
    };

    static Char _decompositionMapping00001FCE[] = 
    {
        0x00001FBF,
        0x00000301
    };

    static _CharacterInfo _character00001FCE =
    {
        0x00001FCE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FCE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCE,
        0x00001FCE,
        0x00001FCE
    };

    static Char _decompositionMapping00001FCF[] = 
    {
        0x00001FBF,
        0x00000342
    };

    static _CharacterInfo _character00001FCF =
    {
        0x00001FCF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FCF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FCF,
        0x00001FCF,
        0x00001FCF
    };

    static Char _decompositionMapping00001FD0[] = 
    {
        0x000003B9,
        0x00000306
    };

    static _CharacterInfo _character00001FD0 =
    {
        0x00001FD0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD8,
        0x00001FD0,
        0x00001FD8
    };

    static Char _decompositionMapping00001FD1[] = 
    {
        0x000003B9,
        0x00000304
    };

    static _CharacterInfo _character00001FD1 =
    {
        0x00001FD1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD9,
        0x00001FD1,
        0x00001FD9
    };

    static Char _decompositionMapping00001FD2[] = 
    {
        0x000003CA,
        0x00000300
    };

    static _CharacterInfo _character00001FD2 =
    {
        0x00001FD2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD2,
        0x00001FD2,
        0x00001FD2
    };

    static Char _decompositionMapping00001FD3[] = 
    {
        0x00000390
    };

    static _CharacterInfo _character00001FD3 =
    {
        0x00001FD3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD3,
        0x00001FD3,
        0x00001FD3
    };

    static Char _decompositionMapping00001FD6[] = 
    {
        0x000003B9,
        0x00000342
    };

    static _CharacterInfo _character00001FD6 =
    {
        0x00001FD6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD6,
        0x00001FD6,
        0x00001FD6
    };

    static Char _decompositionMapping00001FD7[] = 
    {
        0x000003CA,
        0x00000342
    };

    static _CharacterInfo _character00001FD7 =
    {
        0x00001FD7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD7,
        0x00001FD7,
        0x00001FD7
    };

    static Char _decompositionMapping00001FD8[] = 
    {
        0x00000399,
        0x00000306
    };

    static _CharacterInfo _character00001FD8 =
    {
        0x00001FD8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD8,
        0x00001FD0,
        0x00001FD8
    };

    static Char _decompositionMapping00001FD9[] = 
    {
        0x00000399,
        0x00000304
    };

    static _CharacterInfo _character00001FD9 =
    {
        0x00001FD9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FD9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FD9,
        0x00001FD1,
        0x00001FD9
    };

    static Char _decompositionMapping00001FDA[] = 
    {
        0x00000399,
        0x00000300
    };

    static _CharacterInfo _character00001FDA =
    {
        0x00001FDA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDA,
        0x00001F76,
        0x00001FDA
    };

    static Char _decompositionMapping00001FDB[] = 
    {
        0x0000038A
    };

    static _CharacterInfo _character00001FDB =
    {
        0x00001FDB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDB,
        0x00001F77,
        0x00001FDB
    };

    static Char _decompositionMapping00001FDD[] = 
    {
        0x00001FFE,
        0x00000300
    };

    static _CharacterInfo _character00001FDD =
    {
        0x00001FDD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDD,
        0x00001FDD,
        0x00001FDD
    };

    static Char _decompositionMapping00001FDE[] = 
    {
        0x00001FFE,
        0x00000301
    };

    static _CharacterInfo _character00001FDE =
    {
        0x00001FDE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDE,
        0x00001FDE,
        0x00001FDE
    };

    static Char _decompositionMapping00001FDF[] = 
    {
        0x00001FFE,
        0x00000342
    };

    static _CharacterInfo _character00001FDF =
    {
        0x00001FDF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FDF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FDF,
        0x00001FDF,
        0x00001FDF
    };

    static Char _decompositionMapping00001FE0[] = 
    {
        0x000003C5,
        0x00000306
    };

    static _CharacterInfo _character00001FE0 =
    {
        0x00001FE0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE8,
        0x00001FE0,
        0x00001FE8
    };

    static Char _decompositionMapping00001FE1[] = 
    {
        0x000003C5,
        0x00000304
    };

    static _CharacterInfo _character00001FE1 =
    {
        0x00001FE1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE9,
        0x00001FE1,
        0x00001FE9
    };

    static Char _decompositionMapping00001FE2[] = 
    {
        0x000003CB,
        0x00000300
    };

    static _CharacterInfo _character00001FE2 =
    {
        0x00001FE2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE2,
        0x00001FE2,
        0x00001FE2
    };

    static Char _decompositionMapping00001FE3[] = 
    {
        0x000003B0
    };

    static _CharacterInfo _character00001FE3 =
    {
        0x00001FE3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE3,
        0x00001FE3,
        0x00001FE3
    };

    static Char _decompositionMapping00001FE4[] = 
    {
        0x000003C1,
        0x00000313
    };

    static _CharacterInfo _character00001FE4 =
    {
        0x00001FE4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE4,
        0x00001FE4,
        0x00001FE4
    };

    static Char _decompositionMapping00001FE5[] = 
    {
        0x000003C1,
        0x00000314
    };

    static _CharacterInfo _character00001FE5 =
    {
        0x00001FE5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEC,
        0x00001FE5,
        0x00001FEC
    };

    static Char _decompositionMapping00001FE6[] = 
    {
        0x000003C5,
        0x00000342
    };

    static _CharacterInfo _character00001FE6 =
    {
        0x00001FE6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE6,
        0x00001FE6,
        0x00001FE6
    };

    static Char _decompositionMapping00001FE7[] = 
    {
        0x000003CB,
        0x00000342
    };

    static _CharacterInfo _character00001FE7 =
    {
        0x00001FE7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE7,
        0x00001FE7,
        0x00001FE7
    };

    static Char _decompositionMapping00001FE8[] = 
    {
        0x000003A5,
        0x00000306
    };

    static _CharacterInfo _character00001FE8 =
    {
        0x00001FE8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE8,
        0x00001FE0,
        0x00001FE8
    };

    static Char _decompositionMapping00001FE9[] = 
    {
        0x000003A5,
        0x00000304
    };

    static _CharacterInfo _character00001FE9 =
    {
        0x00001FE9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FE9,
        0x00001FE1,
        0x00001FE9
    };

    static Char _decompositionMapping00001FEA[] = 
    {
        0x000003A5,
        0x00000300
    };

    static _CharacterInfo _character00001FEA =
    {
        0x00001FEA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEA,
        0x00001F7A,
        0x00001FEA
    };

    static Char _decompositionMapping00001FEB[] = 
    {
        0x0000038E
    };

    static _CharacterInfo _character00001FEB =
    {
        0x00001FEB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEB,
        0x00001F7B,
        0x00001FEB
    };

    static Char _decompositionMapping00001FEC[] = 
    {
        0x000003A1,
        0x00000314
    };

    static _CharacterInfo _character00001FEC =
    {
        0x00001FEC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEC,
        0x00001FE5,
        0x00001FEC
    };

    static Char _decompositionMapping00001FED[] = 
    {
        0x000000A8,
        0x00000300
    };

    static _CharacterInfo _character00001FED =
    {
        0x00001FED,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FED,
        0x00001FED,
        0x00001FED
    };

    static Char _decompositionMapping00001FEE[] = 
    {
        0x00000385
    };

    static _CharacterInfo _character00001FEE =
    {
        0x00001FEE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEE,
        0x00001FEE,
        0x00001FEE
    };

    static Char _decompositionMapping00001FEF[] = 
    {
        0x00000060
    };

    static _CharacterInfo _character00001FEF =
    {
        0x00001FEF,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FEF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FEF,
        0x00001FEF,
        0x00001FEF
    };

    static Char _decompositionMapping00001FF2[] = 
    {
        0x00001F7C,
        0x00000345
    };

    static _CharacterInfo _character00001FF2 =
    {
        0x00001FF2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF2,
        0x00001FF2,
        0x00001FF2
    };

    static Char _decompositionMapping00001FF3[] = 
    {
        0x000003C9,
        0x00000345
    };

    static _CharacterInfo _character00001FF3 =
    {
        0x00001FF3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFC,
        0x00001FF3,
        0x00001FFC
    };

    static Char _decompositionMapping00001FF4[] = 
    {
        0x000003CE,
        0x00000345
    };

    static _CharacterInfo _character00001FF4 =
    {
        0x00001FF4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF4,
        0x00001FF4,
        0x00001FF4
    };

    static Char _decompositionMapping00001FF6[] = 
    {
        0x000003C9,
        0x00000342
    };

    static _CharacterInfo _character00001FF6 =
    {
        0x00001FF6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF6,
        0x00001FF6,
        0x00001FF6
    };

    static Char _decompositionMapping00001FF7[] = 
    {
        0x00001FF6,
        0x00000345
    };

    static _CharacterInfo _character00001FF7 =
    {
        0x00001FF7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF7,
        0x00001FF7,
        0x00001FF7
    };

    static Char _decompositionMapping00001FF8[] = 
    {
        0x0000039F,
        0x00000300
    };

    static _CharacterInfo _character00001FF8 =
    {
        0x00001FF8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF8,
        0x00001F78,
        0x00001FF8
    };

    static Char _decompositionMapping00001FF9[] = 
    {
        0x0000038C
    };

    static _CharacterInfo _character00001FF9 =
    {
        0x00001FF9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FF9,
        0x00001F79,
        0x00001FF9
    };

    static Char _decompositionMapping00001FFA[] = 
    {
        0x000003A9,
        0x00000300
    };

    static _CharacterInfo _character00001FFA =
    {
        0x00001FFA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FFA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFA,
        0x00001F7C,
        0x00001FFA
    };

    static Char _decompositionMapping00001FFB[] = 
    {
        0x0000038F
    };

    static _CharacterInfo _character00001FFB =
    {
        0x00001FFB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FFB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFB,
        0x00001F7D,
        0x00001FFB
    };

    static Char _decompositionMapping00001FFC[] = 
    {
        0x000003A9,
        0x00000345
    };

    static _CharacterInfo _character00001FFC =
    {
        0x00001FFC,
        Iso10646::GeneralCategory_Lt,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00001FFC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFC,
        0x00001FF3,
        0x00001FFC
    };

    static Char _decompositionMapping00001FFD[] = 
    {
        0x000000B4
    };

    static _CharacterInfo _character00001FFD =
    {
        0x00001FFD,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00001FFD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFD,
        0x00001FFD,
        0x00001FFD
    };

    static Char _decompositionMapping00001FFE[] = 
    {
        0x00000020,
        0x00000314
    };

    static _CharacterInfo _character00001FFE =
    {
        0x00001FFE,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00001FFE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00001FFE,
        0x00001FFE,
        0x00001FFE
    };

    static Char _decompositionMapping00002000[] = 
    {
        0x00002002
    };

    static _CharacterInfo _character00002000 =
    {
        0x00002000,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00002000,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002000,
        0x00002000,
        0x00002000
    };

    static Char _decompositionMapping00002001[] = 
    {
        0x00002003
    };

    static _CharacterInfo _character00002001 =
    {
        0x00002001,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00002001,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002001,
        0x00002001,
        0x00002001
    };

    static Char _decompositionMapping00002002[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002002 =
    {
        0x00002002,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002002,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002002,
        0x00002002,
        0x00002002
    };

    static Char _decompositionMapping00002003[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002003 =
    {
        0x00002003,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002003,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002003,
        0x00002003,
        0x00002003
    };

    static Char _decompositionMapping00002004[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002004 =
    {
        0x00002004,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002004,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002004,
        0x00002004,
        0x00002004
    };

    static Char _decompositionMapping00002005[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002005 =
    {
        0x00002005,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002005,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002005,
        0x00002005,
        0x00002005
    };

    static Char _decompositionMapping00002006[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002006 =
    {
        0x00002006,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002006,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002006,
        0x00002006,
        0x00002006
    };

    static Char _decompositionMapping00002007[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002007 =
    {
        0x00002007,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_noBreak,
        1,
        _decompositionMapping00002007,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002007,
        0x00002007,
        0x00002007
    };

    static Char _decompositionMapping00002008[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002008 =
    {
        0x00002008,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002008,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002008,
        0x00002008,
        0x00002008
    };

    static Char _decompositionMapping00002009[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00002009 =
    {
        0x00002009,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002009,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002009,
        0x00002009,
        0x00002009
    };

    static Char _decompositionMapping0000200A[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character0000200A =
    {
        0x0000200A,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000200A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200A,
        0x0000200A,
        0x0000200A
    };

    static _CharacterInfo _character0000200B =
    {
        0x0000200B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200B,
        0x0000200B,
        0x0000200B
    };

    static _CharacterInfo _character0000200C =
    {
        0x0000200C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200C,
        0x0000200C,
        0x0000200C
    };

    static _CharacterInfo _character0000200D =
    {
        0x0000200D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200D,
        0x0000200D,
        0x0000200D
    };

    static _CharacterInfo _character0000200E =
    {
        0x0000200E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200E,
        0x0000200E,
        0x0000200E
    };

    static _CharacterInfo _character0000200F =
    {
        0x0000200F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000200F,
        0x0000200F,
        0x0000200F
    };

    static _CharacterInfo _character00002010 =
    {
        0x00002010,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002010,
        0x00002010,
        0x00002010
    };

    static Char _decompositionMapping00002011[] = 
    {
        0x00002010
    };

    static _CharacterInfo _character00002011 =
    {
        0x00002011,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_noBreak,
        1,
        _decompositionMapping00002011,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002011,
        0x00002011,
        0x00002011
    };

    static _CharacterInfo _character00002012 =
    {
        0x00002012,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002012,
        0x00002012,
        0x00002012
    };

    static _CharacterInfo _character00002013 =
    {
        0x00002013,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002013,
        0x00002013,
        0x00002013
    };

    static _CharacterInfo _character00002014 =
    {
        0x00002014,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002014,
        0x00002014,
        0x00002014
    };

    static _CharacterInfo _character00002015 =
    {
        0x00002015,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002015,
        0x00002015,
        0x00002015
    };

    static _CharacterInfo _character00002016 =
    {
        0x00002016,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002016,
        0x00002016,
        0x00002016
    };

    static Char _decompositionMapping00002017[] = 
    {
        0x00000020,
        0x00000333
    };

    static _CharacterInfo _character00002017 =
    {
        0x00002017,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002017,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002017,
        0x00002017,
        0x00002017
    };

    static _CharacterInfo _character00002018 =
    {
        0x00002018,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002018,
        0x00002018,
        0x00002018
    };

    static _CharacterInfo _character00002019 =
    {
        0x00002019,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002019,
        0x00002019,
        0x00002019
    };

    static _CharacterInfo _character0000201A =
    {
        0x0000201A,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201A,
        0x0000201A,
        0x0000201A
    };

    static _CharacterInfo _character0000201B =
    {
        0x0000201B,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201B,
        0x0000201B,
        0x0000201B
    };

    static _CharacterInfo _character0000201C =
    {
        0x0000201C,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201C,
        0x0000201C,
        0x0000201C
    };

    static _CharacterInfo _character0000201D =
    {
        0x0000201D,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201D,
        0x0000201D,
        0x0000201D
    };

    static _CharacterInfo _character0000201E =
    {
        0x0000201E,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201E,
        0x0000201E,
        0x0000201E
    };

    static _CharacterInfo _character0000201F =
    {
        0x0000201F,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000201F,
        0x0000201F,
        0x0000201F
    };

    static _CharacterInfo _character00002020 =
    {
        0x00002020,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002020,
        0x00002020,
        0x00002020
    };

    static _CharacterInfo _character00002021 =
    {
        0x00002021,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002021,
        0x00002021,
        0x00002021
    };

    static _CharacterInfo _character00002022 =
    {
        0x00002022,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002022,
        0x00002022,
        0x00002022
    };

    static _CharacterInfo _character00002023 =
    {
        0x00002023,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002023,
        0x00002023,
        0x00002023
    };

    static Char _decompositionMapping00002024[] = 
    {
        0x0000002E
    };

    static _CharacterInfo _character00002024 =
    {
        0x00002024,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002024,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002024,
        0x00002024,
        0x00002024
    };

    static Char _decompositionMapping00002025[] = 
    {
        0x0000002E,
        0x0000002E
    };

    static _CharacterInfo _character00002025 =
    {
        0x00002025,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002025,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002025,
        0x00002025,
        0x00002025
    };

    static Char _decompositionMapping00002026[] = 
    {
        0x0000002E,
        0x0000002E,
        0x0000002E
    };

    static _CharacterInfo _character00002026 =
    {
        0x00002026,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002026,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002026,
        0x00002026,
        0x00002026
    };

    static _CharacterInfo _character00002027 =
    {
        0x00002027,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002027,
        0x00002027,
        0x00002027
    };

    static _CharacterInfo _character00002028 =
    {
        0x00002028,
        Iso10646::GeneralCategory_Zl,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002028,
        0x00002028,
        0x00002028
    };

    static _CharacterInfo _character00002029 =
    {
        0x00002029,
        Iso10646::GeneralCategory_Zp,
        0,
        Iso10646::BidirectionalCategory_B,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002029,
        0x00002029,
        0x00002029
    };

    static _CharacterInfo _character0000202A =
    {
        0x0000202A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_LRE,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202A,
        0x0000202A,
        0x0000202A
    };

    static _CharacterInfo _character0000202B =
    {
        0x0000202B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_RLE,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202B,
        0x0000202B,
        0x0000202B
    };

    static _CharacterInfo _character0000202C =
    {
        0x0000202C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_PDF,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202C,
        0x0000202C,
        0x0000202C
    };

    static _CharacterInfo _character0000202D =
    {
        0x0000202D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_LRO,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202D,
        0x0000202D,
        0x0000202D
    };

    static _CharacterInfo _character0000202E =
    {
        0x0000202E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_RLO,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202E,
        0x0000202E,
        0x0000202E
    };

    static Char _decompositionMapping0000202F[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character0000202F =
    {
        0x0000202F,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_noBreak,
        1,
        _decompositionMapping0000202F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000202F,
        0x0000202F,
        0x0000202F
    };

    static _CharacterInfo _character00002030 =
    {
        0x00002030,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002030,
        0x00002030,
        0x00002030
    };

    static _CharacterInfo _character00002031 =
    {
        0x00002031,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002031,
        0x00002031,
        0x00002031
    };

    static _CharacterInfo _character00002032 =
    {
        0x00002032,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002032,
        0x00002032,
        0x00002032
    };

    static Char _decompositionMapping00002033[] = 
    {
        0x00002032,
        0x00002032
    };

    static _CharacterInfo _character00002033 =
    {
        0x00002033,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002033,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002033,
        0x00002033,
        0x00002033
    };

    static Char _decompositionMapping00002034[] = 
    {
        0x00002032,
        0x00002032,
        0x00002032
    };

    static _CharacterInfo _character00002034 =
    {
        0x00002034,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002034,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002034,
        0x00002034,
        0x00002034
    };

    static _CharacterInfo _character00002035 =
    {
        0x00002035,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002035,
        0x00002035,
        0x00002035
    };

    static Char _decompositionMapping00002036[] = 
    {
        0x00002035,
        0x00002035
    };

    static _CharacterInfo _character00002036 =
    {
        0x00002036,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002036,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002036,
        0x00002036,
        0x00002036
    };

    static Char _decompositionMapping00002037[] = 
    {
        0x00002035,
        0x00002035,
        0x00002035
    };

    static _CharacterInfo _character00002037 =
    {
        0x00002037,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002037,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002037,
        0x00002037,
        0x00002037
    };

    static _CharacterInfo _character00002038 =
    {
        0x00002038,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002038,
        0x00002038,
        0x00002038
    };

    static _CharacterInfo _character00002039 =
    {
        0x00002039,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002039,
        0x00002039,
        0x00002039
    };

    static _CharacterInfo _character0000203A =
    {
        0x0000203A,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000203A,
        0x0000203A,
        0x0000203A
    };

    static _CharacterInfo _character0000203B =
    {
        0x0000203B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000203B,
        0x0000203B,
        0x0000203B
    };

    static Char _decompositionMapping0000203C[] = 
    {
        0x00000021,
        0x00000021
    };

    static _CharacterInfo _character0000203C =
    {
        0x0000203C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000203C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000203C,
        0x0000203C,
        0x0000203C
    };

    static _CharacterInfo _character0000203D =
    {
        0x0000203D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000203D,
        0x0000203D,
        0x0000203D
    };

    static Char _decompositionMapping0000203E[] = 
    {
        0x00000020,
        0x00000305
    };

    static _CharacterInfo _character0000203E =
    {
        0x0000203E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000203E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000203E,
        0x0000203E,
        0x0000203E
    };

    static _CharacterInfo _character0000203F =
    {
        0x0000203F,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000203F,
        0x0000203F,
        0x0000203F
    };

    static _CharacterInfo _character00002040 =
    {
        0x00002040,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002040,
        0x00002040,
        0x00002040
    };

    static _CharacterInfo _character00002041 =
    {
        0x00002041,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002041,
        0x00002041,
        0x00002041
    };

    static _CharacterInfo _character00002042 =
    {
        0x00002042,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002042,
        0x00002042,
        0x00002042
    };

    static _CharacterInfo _character00002043 =
    {
        0x00002043,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002043,
        0x00002043,
        0x00002043
    };

    static _CharacterInfo _character00002044 =
    {
        0x00002044,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002044,
        0x00002044,
        0x00002044
    };

    static _CharacterInfo _character00002045 =
    {
        0x00002045,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002045,
        0x00002045,
        0x00002045
    };

    static _CharacterInfo _character00002046 =
    {
        0x00002046,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002046,
        0x00002046,
        0x00002046
    };

    static Char _decompositionMapping00002047[] = 
    {
        0x0000003F,
        0x0000003F
    };

    static _CharacterInfo _character00002047 =
    {
        0x00002047,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002047,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002047,
        0x00002047,
        0x00002047
    };

    static Char _decompositionMapping00002048[] = 
    {
        0x0000003F,
        0x00000021
    };

    static _CharacterInfo _character00002048 =
    {
        0x00002048,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002048,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002048,
        0x00002048,
        0x00002048
    };

    static Char _decompositionMapping00002049[] = 
    {
        0x00000021,
        0x0000003F
    };

    static _CharacterInfo _character00002049 =
    {
        0x00002049,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002049,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002049,
        0x00002049,
        0x00002049
    };

    static _CharacterInfo _character0000204A =
    {
        0x0000204A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204A,
        0x0000204A,
        0x0000204A
    };

    static _CharacterInfo _character0000204B =
    {
        0x0000204B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204B,
        0x0000204B,
        0x0000204B
    };

    static _CharacterInfo _character0000204C =
    {
        0x0000204C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204C,
        0x0000204C,
        0x0000204C
    };

    static _CharacterInfo _character0000204D =
    {
        0x0000204D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204D,
        0x0000204D,
        0x0000204D
    };

    static _CharacterInfo _character0000204E =
    {
        0x0000204E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204E,
        0x0000204E,
        0x0000204E
    };

    static _CharacterInfo _character0000204F =
    {
        0x0000204F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000204F,
        0x0000204F,
        0x0000204F
    };

    static _CharacterInfo _character00002050 =
    {
        0x00002050,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002050,
        0x00002050,
        0x00002050
    };

    static _CharacterInfo _character00002051 =
    {
        0x00002051,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002051,
        0x00002051,
        0x00002051
    };

    static _CharacterInfo _character00002052 =
    {
        0x00002052,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002052,
        0x00002052,
        0x00002052
    };

    static _CharacterInfo _character00002053 =
    {
        0x00002053,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002053,
        0x00002053,
        0x00002053
    };

    static _CharacterInfo _character00002054 =
    {
        0x00002054,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002054,
        0x00002054,
        0x00002054
    };

    static _CharacterInfo _character00002055 =
    {
        0x00002055,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002055,
        0x00002055,
        0x00002055
    };

    static _CharacterInfo _character00002056 =
    {
        0x00002056,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002056,
        0x00002056,
        0x00002056
    };

    static Char _decompositionMapping00002057[] = 
    {
        0x00002032,
        0x00002032,
        0x00002032,
        0x00002032
    };

    static _CharacterInfo _character00002057 =
    {
        0x00002057,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002057,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002057,
        0x00002057,
        0x00002057
    };

    static _CharacterInfo _character00002058 =
    {
        0x00002058,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002058,
        0x00002058,
        0x00002058
    };

    static _CharacterInfo _character00002059 =
    {
        0x00002059,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002059,
        0x00002059,
        0x00002059
    };

    static _CharacterInfo _character0000205A =
    {
        0x0000205A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205A,
        0x0000205A,
        0x0000205A
    };

    static _CharacterInfo _character0000205B =
    {
        0x0000205B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205B,
        0x0000205B,
        0x0000205B
    };

    static _CharacterInfo _character0000205C =
    {
        0x0000205C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205C,
        0x0000205C,
        0x0000205C
    };

    static _CharacterInfo _character0000205D =
    {
        0x0000205D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205D,
        0x0000205D,
        0x0000205D
    };

    static _CharacterInfo _character0000205E =
    {
        0x0000205E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205E,
        0x0000205E,
        0x0000205E
    };

    static Char _decompositionMapping0000205F[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character0000205F =
    {
        0x0000205F,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000205F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000205F,
        0x0000205F,
        0x0000205F
    };

    static _CharacterInfo _character00002060 =
    {
        0x00002060,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002060,
        0x00002060,
        0x00002060
    };

    static _CharacterInfo _character00002061 =
    {
        0x00002061,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002061,
        0x00002061,
        0x00002061
    };

    static _CharacterInfo _character00002062 =
    {
        0x00002062,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002062,
        0x00002062,
        0x00002062
    };

    static _CharacterInfo _character00002063 =
    {
        0x00002063,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002063,
        0x00002063,
        0x00002063
    };

    static _CharacterInfo _character0000206A =
    {
        0x0000206A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206A,
        0x0000206A,
        0x0000206A
    };

    static _CharacterInfo _character0000206B =
    {
        0x0000206B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206B,
        0x0000206B,
        0x0000206B
    };

    static _CharacterInfo _character0000206C =
    {
        0x0000206C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206C,
        0x0000206C,
        0x0000206C
    };

    static _CharacterInfo _character0000206D =
    {
        0x0000206D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206D,
        0x0000206D,
        0x0000206D
    };

    static _CharacterInfo _character0000206E =
    {
        0x0000206E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206E,
        0x0000206E,
        0x0000206E
    };

    static _CharacterInfo _character0000206F =
    {
        0x0000206F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000206F,
        0x0000206F,
        0x0000206F
    };

    static Char _decompositionMapping00002070[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character00002070 =
    {
        0x00002070,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002070,
        false,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00002070,
        0x00002070,
        0x00002070
    };

    static Char _decompositionMapping00002071[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character00002071 =
    {
        0x00002071,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002071,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002071,
        0x00002071,
        0x00002071
    };

    static Char _decompositionMapping00002074[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character00002074 =
    {
        0x00002074,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002074,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002074,
        0x00002074,
        0x00002074
    };

    static Char _decompositionMapping00002075[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character00002075 =
    {
        0x00002075,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002075,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00002075,
        0x00002075,
        0x00002075
    };

    static Char _decompositionMapping00002076[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character00002076 =
    {
        0x00002076,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002076,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00002076,
        0x00002076,
        0x00002076
    };

    static Char _decompositionMapping00002077[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character00002077 =
    {
        0x00002077,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002077,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00002077,
        0x00002077,
        0x00002077
    };

    static Char _decompositionMapping00002078[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character00002078 =
    {
        0x00002078,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002078,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00002078,
        0x00002078,
        0x00002078
    };

    static Char _decompositionMapping00002079[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character00002079 =
    {
        0x00002079,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002079,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002079,
        0x00002079,
        0x00002079
    };

    static Char _decompositionMapping0000207A[] = 
    {
        0x0000002B
    };

    static _CharacterInfo _character0000207A =
    {
        0x0000207A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000207A,
        0x0000207A,
        0x0000207A
    };

    static Char _decompositionMapping0000207B[] = 
    {
        0x00002212
    };

    static _CharacterInfo _character0000207B =
    {
        0x0000207B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000207B,
        0x0000207B,
        0x0000207B
    };

    static Char _decompositionMapping0000207C[] = 
    {
        0x0000003D
    };

    static _CharacterInfo _character0000207C =
    {
        0x0000207C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000207C,
        0x0000207C,
        0x0000207C
    };

    static Char _decompositionMapping0000207D[] = 
    {
        0x00000028
    };

    static _CharacterInfo _character0000207D =
    {
        0x0000207D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000207D,
        0x0000207D,
        0x0000207D
    };

    static Char _decompositionMapping0000207E[] = 
    {
        0x00000029
    };

    static _CharacterInfo _character0000207E =
    {
        0x0000207E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000207E,
        0x0000207E,
        0x0000207E
    };

    static Char _decompositionMapping0000207F[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0000207F =
    {
        0x0000207F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000207F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000207F,
        0x0000207F,
        0x0000207F
    };

    static Char _decompositionMapping00002080[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character00002080 =
    {
        0x00002080,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002080,
        false,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x00002080,
        0x00002080,
        0x00002080
    };

    static Char _decompositionMapping00002081[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character00002081 =
    {
        0x00002081,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002081,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002081,
        0x00002081,
        0x00002081
    };

    static Char _decompositionMapping00002082[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character00002082 =
    {
        0x00002082,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002082,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002082,
        0x00002082,
        0x00002082
    };

    static Char _decompositionMapping00002083[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character00002083 =
    {
        0x00002083,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002083,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00002083,
        0x00002083,
        0x00002083
    };

    static Char _decompositionMapping00002084[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character00002084 =
    {
        0x00002084,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002084,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002084,
        0x00002084,
        0x00002084
    };

    static Char _decompositionMapping00002085[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character00002085 =
    {
        0x00002085,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002085,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00002085,
        0x00002085,
        0x00002085
    };

    static Char _decompositionMapping00002086[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character00002086 =
    {
        0x00002086,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002086,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00002086,
        0x00002086,
        0x00002086
    };

    static Char _decompositionMapping00002087[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character00002087 =
    {
        0x00002087,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002087,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00002087,
        0x00002087,
        0x00002087
    };

    static Char _decompositionMapping00002088[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character00002088 =
    {
        0x00002088,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002088,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00002088,
        0x00002088,
        0x00002088
    };

    static Char _decompositionMapping00002089[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character00002089 =
    {
        0x00002089,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002089,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002089,
        0x00002089,
        0x00002089
    };

    static Char _decompositionMapping0000208A[] = 
    {
        0x0000002B
    };

    static _CharacterInfo _character0000208A =
    {
        0x0000208A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping0000208A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000208A,
        0x0000208A,
        0x0000208A
    };

    static Char _decompositionMapping0000208B[] = 
    {
        0x00002212
    };

    static _CharacterInfo _character0000208B =
    {
        0x0000208B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping0000208B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000208B,
        0x0000208B,
        0x0000208B
    };

    static Char _decompositionMapping0000208C[] = 
    {
        0x0000003D
    };

    static _CharacterInfo _character0000208C =
    {
        0x0000208C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping0000208C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000208C,
        0x0000208C,
        0x0000208C
    };

    static Char _decompositionMapping0000208D[] = 
    {
        0x00000028
    };

    static _CharacterInfo _character0000208D =
    {
        0x0000208D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping0000208D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000208D,
        0x0000208D,
        0x0000208D
    };

    static Char _decompositionMapping0000208E[] = 
    {
        0x00000029
    };

    static _CharacterInfo _character0000208E =
    {
        0x0000208E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping0000208E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000208E,
        0x0000208E,
        0x0000208E
    };

    static Char _decompositionMapping00002090[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character00002090 =
    {
        0x00002090,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002090,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002090,
        0x00002090,
        0x00002090
    };

    static Char _decompositionMapping00002091[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character00002091 =
    {
        0x00002091,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002091,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002091,
        0x00002091,
        0x00002091
    };

    static Char _decompositionMapping00002092[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character00002092 =
    {
        0x00002092,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002092,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002092,
        0x00002092,
        0x00002092
    };

    static Char _decompositionMapping00002093[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character00002093 =
    {
        0x00002093,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002093,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002093,
        0x00002093,
        0x00002093
    };

    static Char _decompositionMapping00002094[] = 
    {
        0x00000259
    };

    static _CharacterInfo _character00002094 =
    {
        0x00002094,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_sub,
        1,
        _decompositionMapping00002094,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002094,
        0x00002094,
        0x00002094
    };

    static _CharacterInfo _character000020A0 =
    {
        0x000020A0,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A0,
        0x000020A0,
        0x000020A0
    };

    static _CharacterInfo _character000020A1 =
    {
        0x000020A1,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A1,
        0x000020A1,
        0x000020A1
    };

    static _CharacterInfo _character000020A2 =
    {
        0x000020A2,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A2,
        0x000020A2,
        0x000020A2
    };

    static _CharacterInfo _character000020A3 =
    {
        0x000020A3,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A3,
        0x000020A3,
        0x000020A3
    };

    static _CharacterInfo _character000020A4 =
    {
        0x000020A4,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A4,
        0x000020A4,
        0x000020A4
    };

    static _CharacterInfo _character000020A5 =
    {
        0x000020A5,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A5,
        0x000020A5,
        0x000020A5
    };

    static _CharacterInfo _character000020A6 =
    {
        0x000020A6,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A6,
        0x000020A6,
        0x000020A6
    };

    static _CharacterInfo _character000020A7 =
    {
        0x000020A7,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A7,
        0x000020A7,
        0x000020A7
    };

    static Char _decompositionMapping000020A8[] = 
    {
        0x00000052,
        0x00000073
    };

    static _CharacterInfo _character000020A8 =
    {
        0x000020A8,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000020A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A8,
        0x000020A8,
        0x000020A8
    };

    static _CharacterInfo _character000020A9 =
    {
        0x000020A9,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020A9,
        0x000020A9,
        0x000020A9
    };

    static _CharacterInfo _character000020AA =
    {
        0x000020AA,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AA,
        0x000020AA,
        0x000020AA
    };

    static _CharacterInfo _character000020AB =
    {
        0x000020AB,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AB,
        0x000020AB,
        0x000020AB
    };

    static _CharacterInfo _character000020AC =
    {
        0x000020AC,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AC,
        0x000020AC,
        0x000020AC
    };

    static _CharacterInfo _character000020AD =
    {
        0x000020AD,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AD,
        0x000020AD,
        0x000020AD
    };

    static _CharacterInfo _character000020AE =
    {
        0x000020AE,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AE,
        0x000020AE,
        0x000020AE
    };

    static _CharacterInfo _character000020AF =
    {
        0x000020AF,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020AF,
        0x000020AF,
        0x000020AF
    };

    static _CharacterInfo _character000020B0 =
    {
        0x000020B0,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B0,
        0x000020B0,
        0x000020B0
    };

    static _CharacterInfo _character000020B1 =
    {
        0x000020B1,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B1,
        0x000020B1,
        0x000020B1
    };

    static _CharacterInfo _character000020B2 =
    {
        0x000020B2,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B2,
        0x000020B2,
        0x000020B2
    };

    static _CharacterInfo _character000020B3 =
    {
        0x000020B3,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B3,
        0x000020B3,
        0x000020B3
    };

    static _CharacterInfo _character000020B4 =
    {
        0x000020B4,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B4,
        0x000020B4,
        0x000020B4
    };

    static _CharacterInfo _character000020B5 =
    {
        0x000020B5,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020B5,
        0x000020B5,
        0x000020B5
    };

    static _CharacterInfo _character000020D0 =
    {
        0x000020D0,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D0,
        0x000020D0,
        0x000020D0
    };

    static _CharacterInfo _character000020D1 =
    {
        0x000020D1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D1,
        0x000020D1,
        0x000020D1
    };

    static _CharacterInfo _character000020D2 =
    {
        0x000020D2,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D2,
        0x000020D2,
        0x000020D2
    };

    static _CharacterInfo _character000020D3 =
    {
        0x000020D3,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D3,
        0x000020D3,
        0x000020D3
    };

    static _CharacterInfo _character000020D4 =
    {
        0x000020D4,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D4,
        0x000020D4,
        0x000020D4
    };

    static _CharacterInfo _character000020D5 =
    {
        0x000020D5,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D5,
        0x000020D5,
        0x000020D5
    };

    static _CharacterInfo _character000020D6 =
    {
        0x000020D6,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D6,
        0x000020D6,
        0x000020D6
    };

    static _CharacterInfo _character000020D7 =
    {
        0x000020D7,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D7,
        0x000020D7,
        0x000020D7
    };

    static _CharacterInfo _character000020D8 =
    {
        0x000020D8,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D8,
        0x000020D8,
        0x000020D8
    };

    static _CharacterInfo _character000020D9 =
    {
        0x000020D9,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020D9,
        0x000020D9,
        0x000020D9
    };

    static _CharacterInfo _character000020DA =
    {
        0x000020DA,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DA,
        0x000020DA,
        0x000020DA
    };

    static _CharacterInfo _character000020DB =
    {
        0x000020DB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DB,
        0x000020DB,
        0x000020DB
    };

    static _CharacterInfo _character000020DC =
    {
        0x000020DC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DC,
        0x000020DC,
        0x000020DC
    };

    static _CharacterInfo _character000020DD =
    {
        0x000020DD,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DD,
        0x000020DD,
        0x000020DD
    };

    static _CharacterInfo _character000020DE =
    {
        0x000020DE,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DE,
        0x000020DE,
        0x000020DE
    };

    static _CharacterInfo _character000020DF =
    {
        0x000020DF,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020DF,
        0x000020DF,
        0x000020DF
    };

    static _CharacterInfo _character000020E0 =
    {
        0x000020E0,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E0,
        0x000020E0,
        0x000020E0
    };

    static _CharacterInfo _character000020E1 =
    {
        0x000020E1,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E1,
        0x000020E1,
        0x000020E1
    };

    static _CharacterInfo _character000020E2 =
    {
        0x000020E2,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E2,
        0x000020E2,
        0x000020E2
    };

    static _CharacterInfo _character000020E3 =
    {
        0x000020E3,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E3,
        0x000020E3,
        0x000020E3
    };

    static _CharacterInfo _character000020E4 =
    {
        0x000020E4,
        Iso10646::GeneralCategory_Me,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E4,
        0x000020E4,
        0x000020E4
    };

    static _CharacterInfo _character000020E5 =
    {
        0x000020E5,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E5,
        0x000020E5,
        0x000020E5
    };

    static _CharacterInfo _character000020E6 =
    {
        0x000020E6,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E6,
        0x000020E6,
        0x000020E6
    };

    static _CharacterInfo _character000020E7 =
    {
        0x000020E7,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E7,
        0x000020E7,
        0x000020E7
    };

    static _CharacterInfo _character000020E8 =
    {
        0x000020E8,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E8,
        0x000020E8,
        0x000020E8
    };

    static _CharacterInfo _character000020E9 =
    {
        0x000020E9,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020E9,
        0x000020E9,
        0x000020E9
    };

    static _CharacterInfo _character000020EA =
    {
        0x000020EA,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020EA,
        0x000020EA,
        0x000020EA
    };

    static _CharacterInfo _character000020EB =
    {
        0x000020EB,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020EB,
        0x000020EB,
        0x000020EB
    };

    static _CharacterInfo _character000020EC =
    {
        0x000020EC,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020EC,
        0x000020EC,
        0x000020EC
    };

    static _CharacterInfo _character000020ED =
    {
        0x000020ED,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020ED,
        0x000020ED,
        0x000020ED
    };

    static _CharacterInfo _character000020EE =
    {
        0x000020EE,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020EE,
        0x000020EE,
        0x000020EE
    };

    static _CharacterInfo _character000020EF =
    {
        0x000020EF,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000020EF,
        0x000020EF,
        0x000020EF
    };

    static Char _decompositionMapping00002100[] = 
    {
        0x00000061,
        0x0000002F,
        0x00000063
    };

    static _CharacterInfo _character00002100 =
    {
        0x00002100,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002100,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002100,
        0x00002100,
        0x00002100
    };

    static Char _decompositionMapping00002101[] = 
    {
        0x00000061,
        0x0000002F,
        0x00000073
    };

    static _CharacterInfo _character00002101 =
    {
        0x00002101,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002101,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002101,
        0x00002101,
        0x00002101
    };

    static Char _decompositionMapping00002102[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character00002102 =
    {
        0x00002102,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002102,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002102,
        0x00002102,
        0x00002102
    };

    static Char _decompositionMapping00002103[] = 
    {
        0x000000B0,
        0x00000043
    };

    static _CharacterInfo _character00002103 =
    {
        0x00002103,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002103,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002103,
        0x00002103,
        0x00002103
    };

    static _CharacterInfo _character00002104 =
    {
        0x00002104,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002104,
        0x00002104,
        0x00002104
    };

    static Char _decompositionMapping00002105[] = 
    {
        0x00000063,
        0x0000002F,
        0x0000006F
    };

    static _CharacterInfo _character00002105 =
    {
        0x00002105,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002105,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002105,
        0x00002105,
        0x00002105
    };

    static Char _decompositionMapping00002106[] = 
    {
        0x00000063,
        0x0000002F,
        0x00000075
    };

    static _CharacterInfo _character00002106 =
    {
        0x00002106,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002106,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002106,
        0x00002106,
        0x00002106
    };

    static Char _decompositionMapping00002107[] = 
    {
        0x00000190
    };

    static _CharacterInfo _character00002107 =
    {
        0x00002107,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002107,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002107,
        0x00002107,
        0x00002107
    };

    static _CharacterInfo _character00002108 =
    {
        0x00002108,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002108,
        0x00002108,
        0x00002108
    };

    static Char _decompositionMapping00002109[] = 
    {
        0x000000B0,
        0x00000046
    };

    static _CharacterInfo _character00002109 =
    {
        0x00002109,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002109,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002109,
        0x00002109,
        0x00002109
    };

    static Char _decompositionMapping0000210A[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0000210A =
    {
        0x0000210A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210A,
        0x0000210A,
        0x0000210A
    };

    static Char _decompositionMapping0000210B[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0000210B =
    {
        0x0000210B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210B,
        0x0000210B,
        0x0000210B
    };

    static Char _decompositionMapping0000210C[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0000210C =
    {
        0x0000210C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210C,
        0x0000210C,
        0x0000210C
    };

    static Char _decompositionMapping0000210D[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0000210D =
    {
        0x0000210D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210D,
        0x0000210D,
        0x0000210D
    };

    static Char _decompositionMapping0000210E[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0000210E =
    {
        0x0000210E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210E,
        0x0000210E,
        0x0000210E
    };

    static Char _decompositionMapping0000210F[] = 
    {
        0x00000127
    };

    static _CharacterInfo _character0000210F =
    {
        0x0000210F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000210F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000210F,
        0x0000210F,
        0x0000210F
    };

    static Char _decompositionMapping00002110[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character00002110 =
    {
        0x00002110,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002110,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002110,
        0x00002110,
        0x00002110
    };

    static Char _decompositionMapping00002111[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character00002111 =
    {
        0x00002111,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002111,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002111,
        0x00002111,
        0x00002111
    };

    static Char _decompositionMapping00002112[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character00002112 =
    {
        0x00002112,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002112,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002112,
        0x00002112,
        0x00002112
    };

    static Char _decompositionMapping00002113[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character00002113 =
    {
        0x00002113,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002113,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002113,
        0x00002113,
        0x00002113
    };

    static _CharacterInfo _character00002114 =
    {
        0x00002114,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002114,
        0x00002114,
        0x00002114
    };

    static Char _decompositionMapping00002115[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character00002115 =
    {
        0x00002115,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002115,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002115,
        0x00002115,
        0x00002115
    };

    static Char _decompositionMapping00002116[] = 
    {
        0x0000004E,
        0x0000006F
    };

    static _CharacterInfo _character00002116 =
    {
        0x00002116,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002116,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002116,
        0x00002116,
        0x00002116
    };

    static _CharacterInfo _character00002117 =
    {
        0x00002117,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002117,
        0x00002117,
        0x00002117
    };

    static _CharacterInfo _character00002118 =
    {
        0x00002118,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002118,
        0x00002118,
        0x00002118
    };

    static Char _decompositionMapping00002119[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character00002119 =
    {
        0x00002119,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002119,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002119,
        0x00002119,
        0x00002119
    };

    static Char _decompositionMapping0000211A[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0000211A =
    {
        0x0000211A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000211A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211A,
        0x0000211A,
        0x0000211A
    };

    static Char _decompositionMapping0000211B[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0000211B =
    {
        0x0000211B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000211B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211B,
        0x0000211B,
        0x0000211B
    };

    static Char _decompositionMapping0000211C[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0000211C =
    {
        0x0000211C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000211C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211C,
        0x0000211C,
        0x0000211C
    };

    static Char _decompositionMapping0000211D[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0000211D =
    {
        0x0000211D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000211D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211D,
        0x0000211D,
        0x0000211D
    };

    static _CharacterInfo _character0000211E =
    {
        0x0000211E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211E,
        0x0000211E,
        0x0000211E
    };

    static _CharacterInfo _character0000211F =
    {
        0x0000211F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000211F,
        0x0000211F,
        0x0000211F
    };

    static Char _decompositionMapping00002120[] = 
    {
        0x00000053,
        0x0000004D
    };

    static _CharacterInfo _character00002120 =
    {
        0x00002120,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_super,
        2,
        _decompositionMapping00002120,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002120,
        0x00002120,
        0x00002120
    };

    static Char _decompositionMapping00002121[] = 
    {
        0x00000054,
        0x00000045,
        0x0000004C
    };

    static _CharacterInfo _character00002121 =
    {
        0x00002121,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002121,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002121,
        0x00002121,
        0x00002121
    };

    static Char _decompositionMapping00002122[] = 
    {
        0x00000054,
        0x0000004D
    };

    static _CharacterInfo _character00002122 =
    {
        0x00002122,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_super,
        2,
        _decompositionMapping00002122,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002122,
        0x00002122,
        0x00002122
    };

    static _CharacterInfo _character00002123 =
    {
        0x00002123,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002123,
        0x00002123,
        0x00002123
    };

    static Char _decompositionMapping00002124[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character00002124 =
    {
        0x00002124,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002124,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002124,
        0x00002124,
        0x00002124
    };

    static _CharacterInfo _character00002125 =
    {
        0x00002125,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002125,
        0x00002125,
        0x00002125
    };

    static Char _decompositionMapping00002126[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character00002126 =
    {
        0x00002126,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00002126,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002126,
        0x000003C9,
        0x00002126
    };

    static _CharacterInfo _character00002127 =
    {
        0x00002127,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002127,
        0x00002127,
        0x00002127
    };

    static Char _decompositionMapping00002128[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character00002128 =
    {
        0x00002128,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002128,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002128,
        0x00002128,
        0x00002128
    };

    static _CharacterInfo _character00002129 =
    {
        0x00002129,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002129,
        0x00002129,
        0x00002129
    };

    static Char _decompositionMapping0000212A[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0000212A =
    {
        0x0000212A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000212A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212A,
        0x0000006B,
        0x0000212A
    };

    static Char _decompositionMapping0000212B[] = 
    {
        0x000000C5
    };

    static _CharacterInfo _character0000212B =
    {
        0x0000212B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000212B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212B,
        0x000000E5,
        0x0000212B
    };

    static Char _decompositionMapping0000212C[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0000212C =
    {
        0x0000212C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000212C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212C,
        0x0000212C,
        0x0000212C
    };

    static Char _decompositionMapping0000212D[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0000212D =
    {
        0x0000212D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000212D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212D,
        0x0000212D,
        0x0000212D
    };

    static _CharacterInfo _character0000212E =
    {
        0x0000212E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212E,
        0x0000212E,
        0x0000212E
    };

    static Char _decompositionMapping0000212F[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0000212F =
    {
        0x0000212F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000212F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000212F,
        0x0000212F,
        0x0000212F
    };

    static Char _decompositionMapping00002130[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character00002130 =
    {
        0x00002130,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002130,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002130,
        0x00002130,
        0x00002130
    };

    static Char _decompositionMapping00002131[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character00002131 =
    {
        0x00002131,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002131,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002131,
        0x00002131,
        0x00002131
    };

    static _CharacterInfo _character00002132 =
    {
        0x00002132,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002132,
        0x0000214E,
        0x00002132
    };

    static Char _decompositionMapping00002133[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character00002133 =
    {
        0x00002133,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002133,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002133,
        0x00002133,
        0x00002133
    };

    static Char _decompositionMapping00002134[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character00002134 =
    {
        0x00002134,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002134,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002134,
        0x00002134,
        0x00002134
    };

    static Char _decompositionMapping00002135[] = 
    {
        0x000005D0
    };

    static _CharacterInfo _character00002135 =
    {
        0x00002135,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002135,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002135,
        0x00002135,
        0x00002135
    };

    static Char _decompositionMapping00002136[] = 
    {
        0x000005D1
    };

    static _CharacterInfo _character00002136 =
    {
        0x00002136,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002136,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002136,
        0x00002136,
        0x00002136
    };

    static Char _decompositionMapping00002137[] = 
    {
        0x000005D2
    };

    static _CharacterInfo _character00002137 =
    {
        0x00002137,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002137,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002137,
        0x00002137,
        0x00002137
    };

    static Char _decompositionMapping00002138[] = 
    {
        0x000005D3
    };

    static _CharacterInfo _character00002138 =
    {
        0x00002138,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002138,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002138,
        0x00002138,
        0x00002138
    };

    static Char _decompositionMapping00002139[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character00002139 =
    {
        0x00002139,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002139,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002139,
        0x00002139,
        0x00002139
    };

    static _CharacterInfo _character0000213A =
    {
        0x0000213A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213A,
        0x0000213A,
        0x0000213A
    };

    static Char _decompositionMapping0000213B[] = 
    {
        0x00000046,
        0x00000041,
        0x00000058
    };

    static _CharacterInfo _character0000213B =
    {
        0x0000213B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000213B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213B,
        0x0000213B,
        0x0000213B
    };

    static Char _decompositionMapping0000213C[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0000213C =
    {
        0x0000213C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000213C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213C,
        0x0000213C,
        0x0000213C
    };

    static Char _decompositionMapping0000213D[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0000213D =
    {
        0x0000213D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000213D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213D,
        0x0000213D,
        0x0000213D
    };

    static Char _decompositionMapping0000213E[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0000213E =
    {
        0x0000213E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000213E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213E,
        0x0000213E,
        0x0000213E
    };

    static Char _decompositionMapping0000213F[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0000213F =
    {
        0x0000213F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000213F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000213F,
        0x0000213F,
        0x0000213F
    };

    static Char _decompositionMapping00002140[] = 
    {
        0x00002211
    };

    static _CharacterInfo _character00002140 =
    {
        0x00002140,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002140,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002140,
        0x00002140,
        0x00002140
    };

    static _CharacterInfo _character00002141 =
    {
        0x00002141,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002141,
        0x00002141,
        0x00002141
    };

    static _CharacterInfo _character00002142 =
    {
        0x00002142,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002142,
        0x00002142,
        0x00002142
    };

    static _CharacterInfo _character00002143 =
    {
        0x00002143,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002143,
        0x00002143,
        0x00002143
    };

    static _CharacterInfo _character00002144 =
    {
        0x00002144,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002144,
        0x00002144,
        0x00002144
    };

    static Char _decompositionMapping00002145[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character00002145 =
    {
        0x00002145,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002145,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002145,
        0x00002145,
        0x00002145
    };

    static Char _decompositionMapping00002146[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character00002146 =
    {
        0x00002146,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002146,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002146,
        0x00002146,
        0x00002146
    };

    static Char _decompositionMapping00002147[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character00002147 =
    {
        0x00002147,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002147,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002147,
        0x00002147,
        0x00002147
    };

    static Char _decompositionMapping00002148[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character00002148 =
    {
        0x00002148,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002148,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002148,
        0x00002148,
        0x00002148
    };

    static Char _decompositionMapping00002149[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character00002149 =
    {
        0x00002149,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping00002149,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002149,
        0x00002149,
        0x00002149
    };

    static _CharacterInfo _character0000214A =
    {
        0x0000214A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000214A,
        0x0000214A,
        0x0000214A
    };

    static _CharacterInfo _character0000214B =
    {
        0x0000214B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000214B,
        0x0000214B,
        0x0000214B
    };

    static _CharacterInfo _character0000214C =
    {
        0x0000214C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000214C,
        0x0000214C,
        0x0000214C
    };

    static _CharacterInfo _character0000214D =
    {
        0x0000214D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000214D,
        0x0000214D,
        0x0000214D
    };

    static _CharacterInfo _character0000214E =
    {
        0x0000214E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002132,
        0x0000214E,
        0x00002132
    };

    static Char _decompositionMapping00002153[] = 
    {
        0x00000031,
        0x00002044,
        0x00000033
    };

    static _CharacterInfo _character00002153 =
    {
        0x00002153,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002153,
        false,
        0,
        false,
        0,
        true,
        1,
        3,
        false,
        0x00002153,
        0x00002153,
        0x00002153
    };

    static Char _decompositionMapping00002154[] = 
    {
        0x00000032,
        0x00002044,
        0x00000033
    };

    static _CharacterInfo _character00002154 =
    {
        0x00002154,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002154,
        false,
        0,
        false,
        0,
        true,
        2,
        3,
        false,
        0x00002154,
        0x00002154,
        0x00002154
    };

    static Char _decompositionMapping00002155[] = 
    {
        0x00000031,
        0x00002044,
        0x00000035
    };

    static _CharacterInfo _character00002155 =
    {
        0x00002155,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002155,
        false,
        0,
        false,
        0,
        true,
        1,
        5,
        false,
        0x00002155,
        0x00002155,
        0x00002155
    };

    static Char _decompositionMapping00002156[] = 
    {
        0x00000032,
        0x00002044,
        0x00000035
    };

    static _CharacterInfo _character00002156 =
    {
        0x00002156,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002156,
        false,
        0,
        false,
        0,
        true,
        2,
        5,
        false,
        0x00002156,
        0x00002156,
        0x00002156
    };

    static Char _decompositionMapping00002157[] = 
    {
        0x00000033,
        0x00002044,
        0x00000035
    };

    static _CharacterInfo _character00002157 =
    {
        0x00002157,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002157,
        false,
        0,
        false,
        0,
        true,
        3,
        5,
        false,
        0x00002157,
        0x00002157,
        0x00002157
    };

    static Char _decompositionMapping00002158[] = 
    {
        0x00000034,
        0x00002044,
        0x00000035
    };

    static _CharacterInfo _character00002158 =
    {
        0x00002158,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002158,
        false,
        0,
        false,
        0,
        true,
        4,
        5,
        false,
        0x00002158,
        0x00002158,
        0x00002158
    };

    static Char _decompositionMapping00002159[] = 
    {
        0x00000031,
        0x00002044,
        0x00000036
    };

    static _CharacterInfo _character00002159 =
    {
        0x00002159,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping00002159,
        false,
        0,
        false,
        0,
        true,
        1,
        6,
        false,
        0x00002159,
        0x00002159,
        0x00002159
    };

    static Char _decompositionMapping0000215A[] = 
    {
        0x00000035,
        0x00002044,
        0x00000036
    };

    static _CharacterInfo _character0000215A =
    {
        0x0000215A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping0000215A,
        false,
        0,
        false,
        0,
        true,
        5,
        6,
        false,
        0x0000215A,
        0x0000215A,
        0x0000215A
    };

    static Char _decompositionMapping0000215B[] = 
    {
        0x00000031,
        0x00002044,
        0x00000038
    };

    static _CharacterInfo _character0000215B =
    {
        0x0000215B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping0000215B,
        false,
        0,
        false,
        0,
        true,
        1,
        8,
        false,
        0x0000215B,
        0x0000215B,
        0x0000215B
    };

    static Char _decompositionMapping0000215C[] = 
    {
        0x00000033,
        0x00002044,
        0x00000038
    };

    static _CharacterInfo _character0000215C =
    {
        0x0000215C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping0000215C,
        false,
        0,
        false,
        0,
        true,
        3,
        8,
        false,
        0x0000215C,
        0x0000215C,
        0x0000215C
    };

    static Char _decompositionMapping0000215D[] = 
    {
        0x00000035,
        0x00002044,
        0x00000038
    };

    static _CharacterInfo _character0000215D =
    {
        0x0000215D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping0000215D,
        false,
        0,
        false,
        0,
        true,
        5,
        8,
        false,
        0x0000215D,
        0x0000215D,
        0x0000215D
    };

    static Char _decompositionMapping0000215E[] = 
    {
        0x00000037,
        0x00002044,
        0x00000038
    };

    static _CharacterInfo _character0000215E =
    {
        0x0000215E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        3,
        _decompositionMapping0000215E,
        false,
        0,
        false,
        0,
        true,
        7,
        8,
        false,
        0x0000215E,
        0x0000215E,
        0x0000215E
    };

    static Char _decompositionMapping0000215F[] = 
    {
        0x00000031,
        0x00002044
    };

    static _CharacterInfo _character0000215F =
    {
        0x0000215F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_fraction,
        2,
        _decompositionMapping0000215F,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0000215F,
        0x0000215F,
        0x0000215F
    };

    static Char _decompositionMapping00002160[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character00002160 =
    {
        0x00002160,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002160,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00002160,
        0x00002170,
        0x00002160
    };

    static Char _decompositionMapping00002161[] = 
    {
        0x00000049,
        0x00000049
    };

    static _CharacterInfo _character00002161 =
    {
        0x00002161,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002161,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00002161,
        0x00002171,
        0x00002161
    };

    static Char _decompositionMapping00002162[] = 
    {
        0x00000049,
        0x00000049,
        0x00000049
    };

    static _CharacterInfo _character00002162 =
    {
        0x00002162,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002162,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00002162,
        0x00002172,
        0x00002162
    };

    static Char _decompositionMapping00002163[] = 
    {
        0x00000049,
        0x00000056
    };

    static _CharacterInfo _character00002163 =
    {
        0x00002163,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002163,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00002163,
        0x00002173,
        0x00002163
    };

    static Char _decompositionMapping00002164[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character00002164 =
    {
        0x00002164,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002164,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00002164,
        0x00002174,
        0x00002164
    };

    static Char _decompositionMapping00002165[] = 
    {
        0x00000056,
        0x00000049
    };

    static _CharacterInfo _character00002165 =
    {
        0x00002165,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002165,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00002165,
        0x00002175,
        0x00002165
    };

    static Char _decompositionMapping00002166[] = 
    {
        0x00000056,
        0x00000049,
        0x00000049
    };

    static _CharacterInfo _character00002166 =
    {
        0x00002166,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002166,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00002166,
        0x00002176,
        0x00002166
    };

    static Char _decompositionMapping00002167[] = 
    {
        0x00000056,
        0x00000049,
        0x00000049,
        0x00000049
    };

    static _CharacterInfo _character00002167 =
    {
        0x00002167,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002167,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00002167,
        0x00002177,
        0x00002167
    };

    static Char _decompositionMapping00002168[] = 
    {
        0x00000049,
        0x00000058
    };

    static _CharacterInfo _character00002168 =
    {
        0x00002168,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002168,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00002168,
        0x00002178,
        0x00002168
    };

    static Char _decompositionMapping00002169[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character00002169 =
    {
        0x00002169,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002169,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002169,
        0x00002179,
        0x00002169
    };

    static Char _decompositionMapping0000216A[] = 
    {
        0x00000058,
        0x00000049
    };

    static _CharacterInfo _character0000216A =
    {
        0x0000216A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000216A,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x0000216A,
        0x0000217A,
        0x0000216A
    };

    static Char _decompositionMapping0000216B[] = 
    {
        0x00000058,
        0x00000049,
        0x00000049
    };

    static _CharacterInfo _character0000216B =
    {
        0x0000216B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000216B,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x0000216B,
        0x0000217B,
        0x0000216B
    };

    static Char _decompositionMapping0000216C[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0000216C =
    {
        0x0000216C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000216C,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x0000216C,
        0x0000217C,
        0x0000216C
    };

    static Char _decompositionMapping0000216D[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0000216D =
    {
        0x0000216D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000216D,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x0000216D,
        0x0000217D,
        0x0000216D
    };

    static Char _decompositionMapping0000216E[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0000216E =
    {
        0x0000216E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000216E,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0000216E,
        0x0000217E,
        0x0000216E
    };

    static Char _decompositionMapping0000216F[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0000216F =
    {
        0x0000216F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000216F,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x0000216F,
        0x0000217F,
        0x0000216F
    };

    static Char _decompositionMapping00002170[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character00002170 =
    {
        0x00002170,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002170,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00002160,
        0x00002170,
        0x00002160
    };

    static Char _decompositionMapping00002171[] = 
    {
        0x00000069,
        0x00000069
    };

    static _CharacterInfo _character00002171 =
    {
        0x00002171,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002171,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00002161,
        0x00002171,
        0x00002161
    };

    static Char _decompositionMapping00002172[] = 
    {
        0x00000069,
        0x00000069,
        0x00000069
    };

    static _CharacterInfo _character00002172 =
    {
        0x00002172,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002172,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00002162,
        0x00002172,
        0x00002162
    };

    static Char _decompositionMapping00002173[] = 
    {
        0x00000069,
        0x00000076
    };

    static _CharacterInfo _character00002173 =
    {
        0x00002173,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002173,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00002163,
        0x00002173,
        0x00002163
    };

    static Char _decompositionMapping00002174[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character00002174 =
    {
        0x00002174,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002174,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00002164,
        0x00002174,
        0x00002164
    };

    static Char _decompositionMapping00002175[] = 
    {
        0x00000076,
        0x00000069
    };

    static _CharacterInfo _character00002175 =
    {
        0x00002175,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002175,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00002165,
        0x00002175,
        0x00002165
    };

    static Char _decompositionMapping00002176[] = 
    {
        0x00000076,
        0x00000069,
        0x00000069
    };

    static _CharacterInfo _character00002176 =
    {
        0x00002176,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002176,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00002166,
        0x00002176,
        0x00002166
    };

    static Char _decompositionMapping00002177[] = 
    {
        0x00000076,
        0x00000069,
        0x00000069,
        0x00000069
    };

    static _CharacterInfo _character00002177 =
    {
        0x00002177,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002177,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00002167,
        0x00002177,
        0x00002167
    };

    static Char _decompositionMapping00002178[] = 
    {
        0x00000069,
        0x00000078
    };

    static _CharacterInfo _character00002178 =
    {
        0x00002178,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002178,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00002168,
        0x00002178,
        0x00002168
    };

    static Char _decompositionMapping00002179[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character00002179 =
    {
        0x00002179,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002179,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002169,
        0x00002179,
        0x00002169
    };

    static Char _decompositionMapping0000217A[] = 
    {
        0x00000078,
        0x00000069
    };

    static _CharacterInfo _character0000217A =
    {
        0x0000217A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000217A,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x0000216A,
        0x0000217A,
        0x0000216A
    };

    static Char _decompositionMapping0000217B[] = 
    {
        0x00000078,
        0x00000069,
        0x00000069
    };

    static _CharacterInfo _character0000217B =
    {
        0x0000217B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000217B,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x0000216B,
        0x0000217B,
        0x0000216B
    };

    static Char _decompositionMapping0000217C[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0000217C =
    {
        0x0000217C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000217C,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x0000216C,
        0x0000217C,
        0x0000216C
    };

    static Char _decompositionMapping0000217D[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0000217D =
    {
        0x0000217D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000217D,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x0000216D,
        0x0000217D,
        0x0000216D
    };

    static Char _decompositionMapping0000217E[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0000217E =
    {
        0x0000217E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000217E,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0000216E,
        0x0000217E,
        0x0000216E
    };

    static Char _decompositionMapping0000217F[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0000217F =
    {
        0x0000217F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000217F,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x0000216F,
        0x0000217F,
        0x0000216F
    };

    static _CharacterInfo _character00002180 =
    {
        0x00002180,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00002180,
        0x00002180,
        0x00002180
    };

    static _CharacterInfo _character00002181 =
    {
        0x00002181,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5000,
        1,
        false,
        0x00002181,
        0x00002181,
        0x00002181
    };

    static _CharacterInfo _character00002182 =
    {
        0x00002182,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10000,
        1,
        false,
        0x00002182,
        0x00002182,
        0x00002182
    };

    static _CharacterInfo _character00002183 =
    {
        0x00002183,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002183,
        0x00002184,
        0x00002183
    };

    static _CharacterInfo _character00002184 =
    {
        0x00002184,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002183,
        0x00002184,
        0x00002183
    };

    static _CharacterInfo _character00002190 =
    {
        0x00002190,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002190,
        0x00002190,
        0x00002190
    };

    static _CharacterInfo _character00002191 =
    {
        0x00002191,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002191,
        0x00002191,
        0x00002191
    };

    static _CharacterInfo _character00002192 =
    {
        0x00002192,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002192,
        0x00002192,
        0x00002192
    };

    static _CharacterInfo _character00002193 =
    {
        0x00002193,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002193,
        0x00002193,
        0x00002193
    };

    static _CharacterInfo _character00002194 =
    {
        0x00002194,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002194,
        0x00002194,
        0x00002194
    };

    static _CharacterInfo _character00002195 =
    {
        0x00002195,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002195,
        0x00002195,
        0x00002195
    };

    static _CharacterInfo _character00002196 =
    {
        0x00002196,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002196,
        0x00002196,
        0x00002196
    };

    static _CharacterInfo _character00002197 =
    {
        0x00002197,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002197,
        0x00002197,
        0x00002197
    };

    static _CharacterInfo _character00002198 =
    {
        0x00002198,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002198,
        0x00002198,
        0x00002198
    };

    static _CharacterInfo _character00002199 =
    {
        0x00002199,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002199,
        0x00002199,
        0x00002199
    };

    static Char _decompositionMapping0000219A[] = 
    {
        0x00002190,
        0x00000338
    };

    static _CharacterInfo _character0000219A =
    {
        0x0000219A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000219A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219A,
        0x0000219A,
        0x0000219A
    };

    static Char _decompositionMapping0000219B[] = 
    {
        0x00002192,
        0x00000338
    };

    static _CharacterInfo _character0000219B =
    {
        0x0000219B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000219B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219B,
        0x0000219B,
        0x0000219B
    };

    static _CharacterInfo _character0000219C =
    {
        0x0000219C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219C,
        0x0000219C,
        0x0000219C
    };

    static _CharacterInfo _character0000219D =
    {
        0x0000219D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219D,
        0x0000219D,
        0x0000219D
    };

    static _CharacterInfo _character0000219E =
    {
        0x0000219E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219E,
        0x0000219E,
        0x0000219E
    };

    static _CharacterInfo _character0000219F =
    {
        0x0000219F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000219F,
        0x0000219F,
        0x0000219F
    };

    static _CharacterInfo _character000021A0 =
    {
        0x000021A0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A0,
        0x000021A0,
        0x000021A0
    };

    static _CharacterInfo _character000021A1 =
    {
        0x000021A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A1,
        0x000021A1,
        0x000021A1
    };

    static _CharacterInfo _character000021A2 =
    {
        0x000021A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A2,
        0x000021A2,
        0x000021A2
    };

    static _CharacterInfo _character000021A3 =
    {
        0x000021A3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A3,
        0x000021A3,
        0x000021A3
    };

    static _CharacterInfo _character000021A4 =
    {
        0x000021A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A4,
        0x000021A4,
        0x000021A4
    };

    static _CharacterInfo _character000021A5 =
    {
        0x000021A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A5,
        0x000021A5,
        0x000021A5
    };

    static _CharacterInfo _character000021A6 =
    {
        0x000021A6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A6,
        0x000021A6,
        0x000021A6
    };

    static _CharacterInfo _character000021A7 =
    {
        0x000021A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A7,
        0x000021A7,
        0x000021A7
    };

    static _CharacterInfo _character000021A8 =
    {
        0x000021A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A8,
        0x000021A8,
        0x000021A8
    };

    static _CharacterInfo _character000021A9 =
    {
        0x000021A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021A9,
        0x000021A9,
        0x000021A9
    };

    static _CharacterInfo _character000021AA =
    {
        0x000021AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AA,
        0x000021AA,
        0x000021AA
    };

    static _CharacterInfo _character000021AB =
    {
        0x000021AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AB,
        0x000021AB,
        0x000021AB
    };

    static _CharacterInfo _character000021AC =
    {
        0x000021AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AC,
        0x000021AC,
        0x000021AC
    };

    static _CharacterInfo _character000021AD =
    {
        0x000021AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AD,
        0x000021AD,
        0x000021AD
    };

    static Char _decompositionMapping000021AE[] = 
    {
        0x00002194,
        0x00000338
    };

    static _CharacterInfo _character000021AE =
    {
        0x000021AE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000021AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AE,
        0x000021AE,
        0x000021AE
    };

    static _CharacterInfo _character000021AF =
    {
        0x000021AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021AF,
        0x000021AF,
        0x000021AF
    };

    static _CharacterInfo _character000021B0 =
    {
        0x000021B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B0,
        0x000021B0,
        0x000021B0
    };

    static _CharacterInfo _character000021B1 =
    {
        0x000021B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B1,
        0x000021B1,
        0x000021B1
    };

    static _CharacterInfo _character000021B2 =
    {
        0x000021B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B2,
        0x000021B2,
        0x000021B2
    };

    static _CharacterInfo _character000021B3 =
    {
        0x000021B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B3,
        0x000021B3,
        0x000021B3
    };

    static _CharacterInfo _character000021B4 =
    {
        0x000021B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B4,
        0x000021B4,
        0x000021B4
    };

    static _CharacterInfo _character000021B5 =
    {
        0x000021B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B5,
        0x000021B5,
        0x000021B5
    };

    static _CharacterInfo _character000021B6 =
    {
        0x000021B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B6,
        0x000021B6,
        0x000021B6
    };

    static _CharacterInfo _character000021B7 =
    {
        0x000021B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B7,
        0x000021B7,
        0x000021B7
    };

    static _CharacterInfo _character000021B8 =
    {
        0x000021B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B8,
        0x000021B8,
        0x000021B8
    };

    static _CharacterInfo _character000021B9 =
    {
        0x000021B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021B9,
        0x000021B9,
        0x000021B9
    };

    static _CharacterInfo _character000021BA =
    {
        0x000021BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BA,
        0x000021BA,
        0x000021BA
    };

    static _CharacterInfo _character000021BB =
    {
        0x000021BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BB,
        0x000021BB,
        0x000021BB
    };

    static _CharacterInfo _character000021BC =
    {
        0x000021BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BC,
        0x000021BC,
        0x000021BC
    };

    static _CharacterInfo _character000021BD =
    {
        0x000021BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BD,
        0x000021BD,
        0x000021BD
    };

    static _CharacterInfo _character000021BE =
    {
        0x000021BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BE,
        0x000021BE,
        0x000021BE
    };

    static _CharacterInfo _character000021BF =
    {
        0x000021BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021BF,
        0x000021BF,
        0x000021BF
    };

    static _CharacterInfo _character000021C0 =
    {
        0x000021C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C0,
        0x000021C0,
        0x000021C0
    };

    static _CharacterInfo _character000021C1 =
    {
        0x000021C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C1,
        0x000021C1,
        0x000021C1
    };

    static _CharacterInfo _character000021C2 =
    {
        0x000021C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C2,
        0x000021C2,
        0x000021C2
    };

    static _CharacterInfo _character000021C3 =
    {
        0x000021C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C3,
        0x000021C3,
        0x000021C3
    };

    static _CharacterInfo _character000021C4 =
    {
        0x000021C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C4,
        0x000021C4,
        0x000021C4
    };

    static _CharacterInfo _character000021C5 =
    {
        0x000021C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C5,
        0x000021C5,
        0x000021C5
    };

    static _CharacterInfo _character000021C6 =
    {
        0x000021C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C6,
        0x000021C6,
        0x000021C6
    };

    static _CharacterInfo _character000021C7 =
    {
        0x000021C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C7,
        0x000021C7,
        0x000021C7
    };

    static _CharacterInfo _character000021C8 =
    {
        0x000021C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C8,
        0x000021C8,
        0x000021C8
    };

    static _CharacterInfo _character000021C9 =
    {
        0x000021C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021C9,
        0x000021C9,
        0x000021C9
    };

    static _CharacterInfo _character000021CA =
    {
        0x000021CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CA,
        0x000021CA,
        0x000021CA
    };

    static _CharacterInfo _character000021CB =
    {
        0x000021CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CB,
        0x000021CB,
        0x000021CB
    };

    static _CharacterInfo _character000021CC =
    {
        0x000021CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CC,
        0x000021CC,
        0x000021CC
    };

    static Char _decompositionMapping000021CD[] = 
    {
        0x000021D0,
        0x00000338
    };

    static _CharacterInfo _character000021CD =
    {
        0x000021CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000021CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CD,
        0x000021CD,
        0x000021CD
    };

    static Char _decompositionMapping000021CE[] = 
    {
        0x000021D4,
        0x00000338
    };

    static _CharacterInfo _character000021CE =
    {
        0x000021CE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000021CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CE,
        0x000021CE,
        0x000021CE
    };

    static Char _decompositionMapping000021CF[] = 
    {
        0x000021D2,
        0x00000338
    };

    static _CharacterInfo _character000021CF =
    {
        0x000021CF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000021CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021CF,
        0x000021CF,
        0x000021CF
    };

    static _CharacterInfo _character000021D0 =
    {
        0x000021D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D0,
        0x000021D0,
        0x000021D0
    };

    static _CharacterInfo _character000021D1 =
    {
        0x000021D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D1,
        0x000021D1,
        0x000021D1
    };

    static _CharacterInfo _character000021D2 =
    {
        0x000021D2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D2,
        0x000021D2,
        0x000021D2
    };

    static _CharacterInfo _character000021D3 =
    {
        0x000021D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D3,
        0x000021D3,
        0x000021D3
    };

    static _CharacterInfo _character000021D4 =
    {
        0x000021D4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D4,
        0x000021D4,
        0x000021D4
    };

    static _CharacterInfo _character000021D5 =
    {
        0x000021D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D5,
        0x000021D5,
        0x000021D5
    };

    static _CharacterInfo _character000021D6 =
    {
        0x000021D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D6,
        0x000021D6,
        0x000021D6
    };

    static _CharacterInfo _character000021D7 =
    {
        0x000021D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D7,
        0x000021D7,
        0x000021D7
    };

    static _CharacterInfo _character000021D8 =
    {
        0x000021D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D8,
        0x000021D8,
        0x000021D8
    };

    static _CharacterInfo _character000021D9 =
    {
        0x000021D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021D9,
        0x000021D9,
        0x000021D9
    };

    static _CharacterInfo _character000021DA =
    {
        0x000021DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DA,
        0x000021DA,
        0x000021DA
    };

    static _CharacterInfo _character000021DB =
    {
        0x000021DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DB,
        0x000021DB,
        0x000021DB
    };

    static _CharacterInfo _character000021DC =
    {
        0x000021DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DC,
        0x000021DC,
        0x000021DC
    };

    static _CharacterInfo _character000021DD =
    {
        0x000021DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DD,
        0x000021DD,
        0x000021DD
    };

    static _CharacterInfo _character000021DE =
    {
        0x000021DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DE,
        0x000021DE,
        0x000021DE
    };

    static _CharacterInfo _character000021DF =
    {
        0x000021DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021DF,
        0x000021DF,
        0x000021DF
    };

    static _CharacterInfo _character000021E0 =
    {
        0x000021E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E0,
        0x000021E0,
        0x000021E0
    };

    static _CharacterInfo _character000021E1 =
    {
        0x000021E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E1,
        0x000021E1,
        0x000021E1
    };

    static _CharacterInfo _character000021E2 =
    {
        0x000021E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E2,
        0x000021E2,
        0x000021E2
    };

    static _CharacterInfo _character000021E3 =
    {
        0x000021E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E3,
        0x000021E3,
        0x000021E3
    };

    static _CharacterInfo _character000021E4 =
    {
        0x000021E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E4,
        0x000021E4,
        0x000021E4
    };

    static _CharacterInfo _character000021E5 =
    {
        0x000021E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E5,
        0x000021E5,
        0x000021E5
    };

    static _CharacterInfo _character000021E6 =
    {
        0x000021E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E6,
        0x000021E6,
        0x000021E6
    };

    static _CharacterInfo _character000021E7 =
    {
        0x000021E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E7,
        0x000021E7,
        0x000021E7
    };

    static _CharacterInfo _character000021E8 =
    {
        0x000021E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E8,
        0x000021E8,
        0x000021E8
    };

    static _CharacterInfo _character000021E9 =
    {
        0x000021E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021E9,
        0x000021E9,
        0x000021E9
    };

    static _CharacterInfo _character000021EA =
    {
        0x000021EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021EA,
        0x000021EA,
        0x000021EA
    };

    static _CharacterInfo _character000021EB =
    {
        0x000021EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021EB,
        0x000021EB,
        0x000021EB
    };

    static _CharacterInfo _character000021EC =
    {
        0x000021EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021EC,
        0x000021EC,
        0x000021EC
    };

    static _CharacterInfo _character000021ED =
    {
        0x000021ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021ED,
        0x000021ED,
        0x000021ED
    };

    static _CharacterInfo _character000021EE =
    {
        0x000021EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021EE,
        0x000021EE,
        0x000021EE
    };

    static _CharacterInfo _character000021EF =
    {
        0x000021EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021EF,
        0x000021EF,
        0x000021EF
    };

    static _CharacterInfo _character000021F0 =
    {
        0x000021F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F0,
        0x000021F0,
        0x000021F0
    };

    static _CharacterInfo _character000021F1 =
    {
        0x000021F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F1,
        0x000021F1,
        0x000021F1
    };

    static _CharacterInfo _character000021F2 =
    {
        0x000021F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F2,
        0x000021F2,
        0x000021F2
    };

    static _CharacterInfo _character000021F3 =
    {
        0x000021F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F3,
        0x000021F3,
        0x000021F3
    };

    static _CharacterInfo _character000021F4 =
    {
        0x000021F4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F4,
        0x000021F4,
        0x000021F4
    };

    static _CharacterInfo _character000021F5 =
    {
        0x000021F5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F5,
        0x000021F5,
        0x000021F5
    };

    static _CharacterInfo _character000021F6 =
    {
        0x000021F6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F6,
        0x000021F6,
        0x000021F6
    };

    static _CharacterInfo _character000021F7 =
    {
        0x000021F7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F7,
        0x000021F7,
        0x000021F7
    };

    static _CharacterInfo _character000021F8 =
    {
        0x000021F8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F8,
        0x000021F8,
        0x000021F8
    };

    static _CharacterInfo _character000021F9 =
    {
        0x000021F9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021F9,
        0x000021F9,
        0x000021F9
    };

    static _CharacterInfo _character000021FA =
    {
        0x000021FA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FA,
        0x000021FA,
        0x000021FA
    };

    static _CharacterInfo _character000021FB =
    {
        0x000021FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FB,
        0x000021FB,
        0x000021FB
    };

    static _CharacterInfo _character000021FC =
    {
        0x000021FC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FC,
        0x000021FC,
        0x000021FC
    };

    static _CharacterInfo _character000021FD =
    {
        0x000021FD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FD,
        0x000021FD,
        0x000021FD
    };

    static _CharacterInfo _character000021FE =
    {
        0x000021FE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FE,
        0x000021FE,
        0x000021FE
    };

    static _CharacterInfo _character000021FF =
    {
        0x000021FF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000021FF,
        0x000021FF,
        0x000021FF
    };

    static _CharacterInfo _character00002200 =
    {
        0x00002200,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002200,
        0x00002200,
        0x00002200
    };

    static _CharacterInfo _character00002201 =
    {
        0x00002201,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002201,
        0x00002201,
        0x00002201
    };

    static _CharacterInfo _character00002202 =
    {
        0x00002202,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002202,
        0x00002202,
        0x00002202
    };

    static _CharacterInfo _character00002203 =
    {
        0x00002203,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002203,
        0x00002203,
        0x00002203
    };

    static Char _decompositionMapping00002204[] = 
    {
        0x00002203,
        0x00000338
    };

    static _CharacterInfo _character00002204 =
    {
        0x00002204,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002204,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002204,
        0x00002204,
        0x00002204
    };

    static _CharacterInfo _character00002205 =
    {
        0x00002205,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002205,
        0x00002205,
        0x00002205
    };

    static _CharacterInfo _character00002206 =
    {
        0x00002206,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002206,
        0x00002206,
        0x00002206
    };

    static _CharacterInfo _character00002207 =
    {
        0x00002207,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002207,
        0x00002207,
        0x00002207
    };

    static _CharacterInfo _character00002208 =
    {
        0x00002208,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002208,
        0x00002208,
        0x00002208
    };

    static Char _decompositionMapping00002209[] = 
    {
        0x00002208,
        0x00000338
    };

    static _CharacterInfo _character00002209 =
    {
        0x00002209,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002209,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002209,
        0x00002209,
        0x00002209
    };

    static _CharacterInfo _character0000220A =
    {
        0x0000220A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000220A,
        0x0000220A,
        0x0000220A
    };

    static _CharacterInfo _character0000220B =
    {
        0x0000220B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000220B,
        0x0000220B,
        0x0000220B
    };

    static Char _decompositionMapping0000220C[] = 
    {
        0x0000220B,
        0x00000338
    };

    static _CharacterInfo _character0000220C =
    {
        0x0000220C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000220C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000220C,
        0x0000220C,
        0x0000220C
    };

    static _CharacterInfo _character0000220D =
    {
        0x0000220D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000220D,
        0x0000220D,
        0x0000220D
    };

    static _CharacterInfo _character0000220E =
    {
        0x0000220E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000220E,
        0x0000220E,
        0x0000220E
    };

    static _CharacterInfo _character0000220F =
    {
        0x0000220F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000220F,
        0x0000220F,
        0x0000220F
    };

    static _CharacterInfo _character00002210 =
    {
        0x00002210,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002210,
        0x00002210,
        0x00002210
    };

    static _CharacterInfo _character00002211 =
    {
        0x00002211,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002211,
        0x00002211,
        0x00002211
    };

    static _CharacterInfo _character00002212 =
    {
        0x00002212,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002212,
        0x00002212,
        0x00002212
    };

    static _CharacterInfo _character00002213 =
    {
        0x00002213,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002213,
        0x00002213,
        0x00002213
    };

    static _CharacterInfo _character00002214 =
    {
        0x00002214,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002214,
        0x00002214,
        0x00002214
    };

    static _CharacterInfo _character00002215 =
    {
        0x00002215,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002215,
        0x00002215,
        0x00002215
    };

    static _CharacterInfo _character00002216 =
    {
        0x00002216,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002216,
        0x00002216,
        0x00002216
    };

    static _CharacterInfo _character00002217 =
    {
        0x00002217,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002217,
        0x00002217,
        0x00002217
    };

    static _CharacterInfo _character00002218 =
    {
        0x00002218,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002218,
        0x00002218,
        0x00002218
    };

    static _CharacterInfo _character00002219 =
    {
        0x00002219,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002219,
        0x00002219,
        0x00002219
    };

    static _CharacterInfo _character0000221A =
    {
        0x0000221A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000221A,
        0x0000221A,
        0x0000221A
    };

    static _CharacterInfo _character0000221B =
    {
        0x0000221B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000221B,
        0x0000221B,
        0x0000221B
    };

    static _CharacterInfo _character0000221C =
    {
        0x0000221C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000221C,
        0x0000221C,
        0x0000221C
    };

    static _CharacterInfo _character0000221D =
    {
        0x0000221D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000221D,
        0x0000221D,
        0x0000221D
    };

    static _CharacterInfo _character0000221E =
    {
        0x0000221E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000221E,
        0x0000221E,
        0x0000221E
    };

    static _CharacterInfo _character0000221F =
    {
        0x0000221F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000221F,
        0x0000221F,
        0x0000221F
    };

    static _CharacterInfo _character00002220 =
    {
        0x00002220,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002220,
        0x00002220,
        0x00002220
    };

    static _CharacterInfo _character00002221 =
    {
        0x00002221,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002221,
        0x00002221,
        0x00002221
    };

    static _CharacterInfo _character00002222 =
    {
        0x00002222,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002222,
        0x00002222,
        0x00002222
    };

    static _CharacterInfo _character00002223 =
    {
        0x00002223,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002223,
        0x00002223,
        0x00002223
    };

    static Char _decompositionMapping00002224[] = 
    {
        0x00002223,
        0x00000338
    };

    static _CharacterInfo _character00002224 =
    {
        0x00002224,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002224,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002224,
        0x00002224,
        0x00002224
    };

    static _CharacterInfo _character00002225 =
    {
        0x00002225,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002225,
        0x00002225,
        0x00002225
    };

    static Char _decompositionMapping00002226[] = 
    {
        0x00002225,
        0x00000338
    };

    static _CharacterInfo _character00002226 =
    {
        0x00002226,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002226,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002226,
        0x00002226,
        0x00002226
    };

    static _CharacterInfo _character00002227 =
    {
        0x00002227,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002227,
        0x00002227,
        0x00002227
    };

    static _CharacterInfo _character00002228 =
    {
        0x00002228,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002228,
        0x00002228,
        0x00002228
    };

    static _CharacterInfo _character00002229 =
    {
        0x00002229,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002229,
        0x00002229,
        0x00002229
    };

    static _CharacterInfo _character0000222A =
    {
        0x0000222A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000222A,
        0x0000222A,
        0x0000222A
    };

    static _CharacterInfo _character0000222B =
    {
        0x0000222B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000222B,
        0x0000222B,
        0x0000222B
    };

    static Char _decompositionMapping0000222C[] = 
    {
        0x0000222B,
        0x0000222B
    };

    static _CharacterInfo _character0000222C =
    {
        0x0000222C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000222C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000222C,
        0x0000222C,
        0x0000222C
    };

    static Char _decompositionMapping0000222D[] = 
    {
        0x0000222B,
        0x0000222B,
        0x0000222B
    };

    static _CharacterInfo _character0000222D =
    {
        0x0000222D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000222D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000222D,
        0x0000222D,
        0x0000222D
    };

    static _CharacterInfo _character0000222E =
    {
        0x0000222E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000222E,
        0x0000222E,
        0x0000222E
    };

    static Char _decompositionMapping0000222F[] = 
    {
        0x0000222E,
        0x0000222E
    };

    static _CharacterInfo _character0000222F =
    {
        0x0000222F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000222F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000222F,
        0x0000222F,
        0x0000222F
    };

    static Char _decompositionMapping00002230[] = 
    {
        0x0000222E,
        0x0000222E,
        0x0000222E
    };

    static _CharacterInfo _character00002230 =
    {
        0x00002230,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002230,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002230,
        0x00002230,
        0x00002230
    };

    static _CharacterInfo _character00002231 =
    {
        0x00002231,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002231,
        0x00002231,
        0x00002231
    };

    static _CharacterInfo _character00002232 =
    {
        0x00002232,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002232,
        0x00002232,
        0x00002232
    };

    static _CharacterInfo _character00002233 =
    {
        0x00002233,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002233,
        0x00002233,
        0x00002233
    };

    static _CharacterInfo _character00002234 =
    {
        0x00002234,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002234,
        0x00002234,
        0x00002234
    };

    static _CharacterInfo _character00002235 =
    {
        0x00002235,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002235,
        0x00002235,
        0x00002235
    };

    static _CharacterInfo _character00002236 =
    {
        0x00002236,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002236,
        0x00002236,
        0x00002236
    };

    static _CharacterInfo _character00002237 =
    {
        0x00002237,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002237,
        0x00002237,
        0x00002237
    };

    static _CharacterInfo _character00002238 =
    {
        0x00002238,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002238,
        0x00002238,
        0x00002238
    };

    static _CharacterInfo _character00002239 =
    {
        0x00002239,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002239,
        0x00002239,
        0x00002239
    };

    static _CharacterInfo _character0000223A =
    {
        0x0000223A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000223A,
        0x0000223A,
        0x0000223A
    };

    static _CharacterInfo _character0000223B =
    {
        0x0000223B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000223B,
        0x0000223B,
        0x0000223B
    };

    static _CharacterInfo _character0000223C =
    {
        0x0000223C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000223C,
        0x0000223C,
        0x0000223C
    };

    static _CharacterInfo _character0000223D =
    {
        0x0000223D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000223D,
        0x0000223D,
        0x0000223D
    };

    static _CharacterInfo _character0000223E =
    {
        0x0000223E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000223E,
        0x0000223E,
        0x0000223E
    };

    static _CharacterInfo _character0000223F =
    {
        0x0000223F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000223F,
        0x0000223F,
        0x0000223F
    };

    static _CharacterInfo _character00002240 =
    {
        0x00002240,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002240,
        0x00002240,
        0x00002240
    };

    static Char _decompositionMapping00002241[] = 
    {
        0x0000223C,
        0x00000338
    };

    static _CharacterInfo _character00002241 =
    {
        0x00002241,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002241,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002241,
        0x00002241,
        0x00002241
    };

    static _CharacterInfo _character00002242 =
    {
        0x00002242,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002242,
        0x00002242,
        0x00002242
    };

    static _CharacterInfo _character00002243 =
    {
        0x00002243,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002243,
        0x00002243,
        0x00002243
    };

    static Char _decompositionMapping00002244[] = 
    {
        0x00002243,
        0x00000338
    };

    static _CharacterInfo _character00002244 =
    {
        0x00002244,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002244,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002244,
        0x00002244,
        0x00002244
    };

    static _CharacterInfo _character00002245 =
    {
        0x00002245,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002245,
        0x00002245,
        0x00002245
    };

    static _CharacterInfo _character00002246 =
    {
        0x00002246,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002246,
        0x00002246,
        0x00002246
    };

    static Char _decompositionMapping00002247[] = 
    {
        0x00002245,
        0x00000338
    };

    static _CharacterInfo _character00002247 =
    {
        0x00002247,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002247,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002247,
        0x00002247,
        0x00002247
    };

    static _CharacterInfo _character00002248 =
    {
        0x00002248,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002248,
        0x00002248,
        0x00002248
    };

    static Char _decompositionMapping00002249[] = 
    {
        0x00002248,
        0x00000338
    };

    static _CharacterInfo _character00002249 =
    {
        0x00002249,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002249,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002249,
        0x00002249,
        0x00002249
    };

    static _CharacterInfo _character0000224A =
    {
        0x0000224A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000224A,
        0x0000224A,
        0x0000224A
    };

    static _CharacterInfo _character0000224B =
    {
        0x0000224B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000224B,
        0x0000224B,
        0x0000224B
    };

    static _CharacterInfo _character0000224C =
    {
        0x0000224C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000224C,
        0x0000224C,
        0x0000224C
    };

    static _CharacterInfo _character0000224D =
    {
        0x0000224D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000224D,
        0x0000224D,
        0x0000224D
    };

    static _CharacterInfo _character0000224E =
    {
        0x0000224E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000224E,
        0x0000224E,
        0x0000224E
    };

    static _CharacterInfo _character0000224F =
    {
        0x0000224F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000224F,
        0x0000224F,
        0x0000224F
    };

    static _CharacterInfo _character00002250 =
    {
        0x00002250,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002250,
        0x00002250,
        0x00002250
    };

    static _CharacterInfo _character00002251 =
    {
        0x00002251,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002251,
        0x00002251,
        0x00002251
    };

    static _CharacterInfo _character00002252 =
    {
        0x00002252,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002252,
        0x00002252,
        0x00002252
    };

    static _CharacterInfo _character00002253 =
    {
        0x00002253,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002253,
        0x00002253,
        0x00002253
    };

    static _CharacterInfo _character00002254 =
    {
        0x00002254,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002254,
        0x00002254,
        0x00002254
    };

    static _CharacterInfo _character00002255 =
    {
        0x00002255,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002255,
        0x00002255,
        0x00002255
    };

    static _CharacterInfo _character00002256 =
    {
        0x00002256,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002256,
        0x00002256,
        0x00002256
    };

    static _CharacterInfo _character00002257 =
    {
        0x00002257,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002257,
        0x00002257,
        0x00002257
    };

    static _CharacterInfo _character00002258 =
    {
        0x00002258,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002258,
        0x00002258,
        0x00002258
    };

    static _CharacterInfo _character00002259 =
    {
        0x00002259,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002259,
        0x00002259,
        0x00002259
    };

    static _CharacterInfo _character0000225A =
    {
        0x0000225A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000225A,
        0x0000225A,
        0x0000225A
    };

    static _CharacterInfo _character0000225B =
    {
        0x0000225B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000225B,
        0x0000225B,
        0x0000225B
    };

    static _CharacterInfo _character0000225C =
    {
        0x0000225C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000225C,
        0x0000225C,
        0x0000225C
    };

    static _CharacterInfo _character0000225D =
    {
        0x0000225D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000225D,
        0x0000225D,
        0x0000225D
    };

    static _CharacterInfo _character0000225E =
    {
        0x0000225E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000225E,
        0x0000225E,
        0x0000225E
    };

    static _CharacterInfo _character0000225F =
    {
        0x0000225F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000225F,
        0x0000225F,
        0x0000225F
    };

    static Char _decompositionMapping00002260[] = 
    {
        0x0000003D,
        0x00000338
    };

    static _CharacterInfo _character00002260 =
    {
        0x00002260,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002260,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002260,
        0x00002260,
        0x00002260
    };

    static _CharacterInfo _character00002261 =
    {
        0x00002261,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002261,
        0x00002261,
        0x00002261
    };

    static Char _decompositionMapping00002262[] = 
    {
        0x00002261,
        0x00000338
    };

    static _CharacterInfo _character00002262 =
    {
        0x00002262,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002262,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002262,
        0x00002262,
        0x00002262
    };

    static _CharacterInfo _character00002263 =
    {
        0x00002263,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002263,
        0x00002263,
        0x00002263
    };

    static _CharacterInfo _character00002264 =
    {
        0x00002264,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002264,
        0x00002264,
        0x00002264
    };

    static _CharacterInfo _character00002265 =
    {
        0x00002265,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002265,
        0x00002265,
        0x00002265
    };

    static _CharacterInfo _character00002266 =
    {
        0x00002266,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002266,
        0x00002266,
        0x00002266
    };

    static _CharacterInfo _character00002267 =
    {
        0x00002267,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002267,
        0x00002267,
        0x00002267
    };

    static _CharacterInfo _character00002268 =
    {
        0x00002268,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002268,
        0x00002268,
        0x00002268
    };

    static _CharacterInfo _character00002269 =
    {
        0x00002269,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002269,
        0x00002269,
        0x00002269
    };

    static _CharacterInfo _character0000226A =
    {
        0x0000226A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000226A,
        0x0000226A,
        0x0000226A
    };

    static _CharacterInfo _character0000226B =
    {
        0x0000226B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000226B,
        0x0000226B,
        0x0000226B
    };

    static _CharacterInfo _character0000226C =
    {
        0x0000226C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000226C,
        0x0000226C,
        0x0000226C
    };

    static Char _decompositionMapping0000226D[] = 
    {
        0x0000224D,
        0x00000338
    };

    static _CharacterInfo _character0000226D =
    {
        0x0000226D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000226D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000226D,
        0x0000226D,
        0x0000226D
    };

    static Char _decompositionMapping0000226E[] = 
    {
        0x0000003C,
        0x00000338
    };

    static _CharacterInfo _character0000226E =
    {
        0x0000226E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000226E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000226E,
        0x0000226E,
        0x0000226E
    };

    static Char _decompositionMapping0000226F[] = 
    {
        0x0000003E,
        0x00000338
    };

    static _CharacterInfo _character0000226F =
    {
        0x0000226F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000226F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000226F,
        0x0000226F,
        0x0000226F
    };

    static Char _decompositionMapping00002270[] = 
    {
        0x00002264,
        0x00000338
    };

    static _CharacterInfo _character00002270 =
    {
        0x00002270,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002270,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002270,
        0x00002270,
        0x00002270
    };

    static Char _decompositionMapping00002271[] = 
    {
        0x00002265,
        0x00000338
    };

    static _CharacterInfo _character00002271 =
    {
        0x00002271,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002271,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002271,
        0x00002271,
        0x00002271
    };

    static _CharacterInfo _character00002272 =
    {
        0x00002272,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002272,
        0x00002272,
        0x00002272
    };

    static _CharacterInfo _character00002273 =
    {
        0x00002273,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002273,
        0x00002273,
        0x00002273
    };

    static Char _decompositionMapping00002274[] = 
    {
        0x00002272,
        0x00000338
    };

    static _CharacterInfo _character00002274 =
    {
        0x00002274,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002274,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002274,
        0x00002274,
        0x00002274
    };

    static Char _decompositionMapping00002275[] = 
    {
        0x00002273,
        0x00000338
    };

    static _CharacterInfo _character00002275 =
    {
        0x00002275,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002275,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002275,
        0x00002275,
        0x00002275
    };

    static _CharacterInfo _character00002276 =
    {
        0x00002276,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002276,
        0x00002276,
        0x00002276
    };

    static _CharacterInfo _character00002277 =
    {
        0x00002277,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002277,
        0x00002277,
        0x00002277
    };

    static Char _decompositionMapping00002278[] = 
    {
        0x00002276,
        0x00000338
    };

    static _CharacterInfo _character00002278 =
    {
        0x00002278,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002278,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002278,
        0x00002278,
        0x00002278
    };

    static Char _decompositionMapping00002279[] = 
    {
        0x00002277,
        0x00000338
    };

    static _CharacterInfo _character00002279 =
    {
        0x00002279,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002279,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002279,
        0x00002279,
        0x00002279
    };

    static _CharacterInfo _character0000227A =
    {
        0x0000227A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227A,
        0x0000227A,
        0x0000227A
    };

    static _CharacterInfo _character0000227B =
    {
        0x0000227B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227B,
        0x0000227B,
        0x0000227B
    };

    static _CharacterInfo _character0000227C =
    {
        0x0000227C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227C,
        0x0000227C,
        0x0000227C
    };

    static _CharacterInfo _character0000227D =
    {
        0x0000227D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227D,
        0x0000227D,
        0x0000227D
    };

    static _CharacterInfo _character0000227E =
    {
        0x0000227E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227E,
        0x0000227E,
        0x0000227E
    };

    static _CharacterInfo _character0000227F =
    {
        0x0000227F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000227F,
        0x0000227F,
        0x0000227F
    };

    static Char _decompositionMapping00002280[] = 
    {
        0x0000227A,
        0x00000338
    };

    static _CharacterInfo _character00002280 =
    {
        0x00002280,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002280,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002280,
        0x00002280,
        0x00002280
    };

    static Char _decompositionMapping00002281[] = 
    {
        0x0000227B,
        0x00000338
    };

    static _CharacterInfo _character00002281 =
    {
        0x00002281,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002281,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002281,
        0x00002281,
        0x00002281
    };

    static _CharacterInfo _character00002282 =
    {
        0x00002282,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002282,
        0x00002282,
        0x00002282
    };

    static _CharacterInfo _character00002283 =
    {
        0x00002283,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002283,
        0x00002283,
        0x00002283
    };

    static Char _decompositionMapping00002284[] = 
    {
        0x00002282,
        0x00000338
    };

    static _CharacterInfo _character00002284 =
    {
        0x00002284,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002284,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002284,
        0x00002284,
        0x00002284
    };

    static Char _decompositionMapping00002285[] = 
    {
        0x00002283,
        0x00000338
    };

    static _CharacterInfo _character00002285 =
    {
        0x00002285,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002285,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002285,
        0x00002285,
        0x00002285
    };

    static _CharacterInfo _character00002286 =
    {
        0x00002286,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002286,
        0x00002286,
        0x00002286
    };

    static _CharacterInfo _character00002287 =
    {
        0x00002287,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002287,
        0x00002287,
        0x00002287
    };

    static Char _decompositionMapping00002288[] = 
    {
        0x00002286,
        0x00000338
    };

    static _CharacterInfo _character00002288 =
    {
        0x00002288,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002288,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002288,
        0x00002288,
        0x00002288
    };

    static Char _decompositionMapping00002289[] = 
    {
        0x00002287,
        0x00000338
    };

    static _CharacterInfo _character00002289 =
    {
        0x00002289,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002289,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002289,
        0x00002289,
        0x00002289
    };

    static _CharacterInfo _character0000228A =
    {
        0x0000228A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000228A,
        0x0000228A,
        0x0000228A
    };

    static _CharacterInfo _character0000228B =
    {
        0x0000228B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000228B,
        0x0000228B,
        0x0000228B
    };

    static _CharacterInfo _character0000228C =
    {
        0x0000228C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000228C,
        0x0000228C,
        0x0000228C
    };

    static _CharacterInfo _character0000228D =
    {
        0x0000228D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000228D,
        0x0000228D,
        0x0000228D
    };

    static _CharacterInfo _character0000228E =
    {
        0x0000228E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000228E,
        0x0000228E,
        0x0000228E
    };

    static _CharacterInfo _character0000228F =
    {
        0x0000228F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000228F,
        0x0000228F,
        0x0000228F
    };

    static _CharacterInfo _character00002290 =
    {
        0x00002290,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002290,
        0x00002290,
        0x00002290
    };

    static _CharacterInfo _character00002291 =
    {
        0x00002291,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002291,
        0x00002291,
        0x00002291
    };

    static _CharacterInfo _character00002292 =
    {
        0x00002292,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002292,
        0x00002292,
        0x00002292
    };

    static _CharacterInfo _character00002293 =
    {
        0x00002293,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002293,
        0x00002293,
        0x00002293
    };

    static _CharacterInfo _character00002294 =
    {
        0x00002294,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002294,
        0x00002294,
        0x00002294
    };

    static _CharacterInfo _character00002295 =
    {
        0x00002295,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002295,
        0x00002295,
        0x00002295
    };

    static _CharacterInfo _character00002296 =
    {
        0x00002296,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002296,
        0x00002296,
        0x00002296
    };

    static _CharacterInfo _character00002297 =
    {
        0x00002297,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002297,
        0x00002297,
        0x00002297
    };

    static _CharacterInfo _character00002298 =
    {
        0x00002298,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002298,
        0x00002298,
        0x00002298
    };

    static _CharacterInfo _character00002299 =
    {
        0x00002299,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002299,
        0x00002299,
        0x00002299
    };

    static _CharacterInfo _character0000229A =
    {
        0x0000229A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229A,
        0x0000229A,
        0x0000229A
    };

    static _CharacterInfo _character0000229B =
    {
        0x0000229B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229B,
        0x0000229B,
        0x0000229B
    };

    static _CharacterInfo _character0000229C =
    {
        0x0000229C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229C,
        0x0000229C,
        0x0000229C
    };

    static _CharacterInfo _character0000229D =
    {
        0x0000229D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229D,
        0x0000229D,
        0x0000229D
    };

    static _CharacterInfo _character0000229E =
    {
        0x0000229E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229E,
        0x0000229E,
        0x0000229E
    };

    static _CharacterInfo _character0000229F =
    {
        0x0000229F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000229F,
        0x0000229F,
        0x0000229F
    };

    static _CharacterInfo _character000022A0 =
    {
        0x000022A0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022A0,
        0x000022A0,
        0x000022A0
    };

    static _CharacterInfo _character000022A1 =
    {
        0x000022A1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022A1,
        0x000022A1,
        0x000022A1
    };

    static _CharacterInfo _character000022A2 =
    {
        0x000022A2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A2,
        0x000022A2,
        0x000022A2
    };

    static _CharacterInfo _character000022A3 =
    {
        0x000022A3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A3,
        0x000022A3,
        0x000022A3
    };

    static _CharacterInfo _character000022A4 =
    {
        0x000022A4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022A4,
        0x000022A4,
        0x000022A4
    };

    static _CharacterInfo _character000022A5 =
    {
        0x000022A5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022A5,
        0x000022A5,
        0x000022A5
    };

    static _CharacterInfo _character000022A6 =
    {
        0x000022A6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A6,
        0x000022A6,
        0x000022A6
    };

    static _CharacterInfo _character000022A7 =
    {
        0x000022A7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A7,
        0x000022A7,
        0x000022A7
    };

    static _CharacterInfo _character000022A8 =
    {
        0x000022A8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A8,
        0x000022A8,
        0x000022A8
    };

    static _CharacterInfo _character000022A9 =
    {
        0x000022A9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022A9,
        0x000022A9,
        0x000022A9
    };

    static _CharacterInfo _character000022AA =
    {
        0x000022AA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AA,
        0x000022AA,
        0x000022AA
    };

    static _CharacterInfo _character000022AB =
    {
        0x000022AB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AB,
        0x000022AB,
        0x000022AB
    };

    static Char _decompositionMapping000022AC[] = 
    {
        0x000022A2,
        0x00000338
    };

    static _CharacterInfo _character000022AC =
    {
        0x000022AC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AC,
        0x000022AC,
        0x000022AC
    };

    static Char _decompositionMapping000022AD[] = 
    {
        0x000022A8,
        0x00000338
    };

    static _CharacterInfo _character000022AD =
    {
        0x000022AD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AD,
        0x000022AD,
        0x000022AD
    };

    static Char _decompositionMapping000022AE[] = 
    {
        0x000022A9,
        0x00000338
    };

    static _CharacterInfo _character000022AE =
    {
        0x000022AE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AE,
        0x000022AE,
        0x000022AE
    };

    static Char _decompositionMapping000022AF[] = 
    {
        0x000022AB,
        0x00000338
    };

    static _CharacterInfo _character000022AF =
    {
        0x000022AF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022AF,
        0x000022AF,
        0x000022AF
    };

    static _CharacterInfo _character000022B0 =
    {
        0x000022B0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B0,
        0x000022B0,
        0x000022B0
    };

    static _CharacterInfo _character000022B1 =
    {
        0x000022B1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B1,
        0x000022B1,
        0x000022B1
    };

    static _CharacterInfo _character000022B2 =
    {
        0x000022B2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B2,
        0x000022B2,
        0x000022B2
    };

    static _CharacterInfo _character000022B3 =
    {
        0x000022B3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B3,
        0x000022B3,
        0x000022B3
    };

    static _CharacterInfo _character000022B4 =
    {
        0x000022B4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B4,
        0x000022B4,
        0x000022B4
    };

    static _CharacterInfo _character000022B5 =
    {
        0x000022B5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B5,
        0x000022B5,
        0x000022B5
    };

    static _CharacterInfo _character000022B6 =
    {
        0x000022B6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B6,
        0x000022B6,
        0x000022B6
    };

    static _CharacterInfo _character000022B7 =
    {
        0x000022B7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B7,
        0x000022B7,
        0x000022B7
    };

    static _CharacterInfo _character000022B8 =
    {
        0x000022B8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022B8,
        0x000022B8,
        0x000022B8
    };

    static _CharacterInfo _character000022B9 =
    {
        0x000022B9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022B9,
        0x000022B9,
        0x000022B9
    };

    static _CharacterInfo _character000022BA =
    {
        0x000022BA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022BA,
        0x000022BA,
        0x000022BA
    };

    static _CharacterInfo _character000022BB =
    {
        0x000022BB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022BB,
        0x000022BB,
        0x000022BB
    };

    static _CharacterInfo _character000022BC =
    {
        0x000022BC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022BC,
        0x000022BC,
        0x000022BC
    };

    static _CharacterInfo _character000022BD =
    {
        0x000022BD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022BD,
        0x000022BD,
        0x000022BD
    };

    static _CharacterInfo _character000022BE =
    {
        0x000022BE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022BE,
        0x000022BE,
        0x000022BE
    };

    static _CharacterInfo _character000022BF =
    {
        0x000022BF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022BF,
        0x000022BF,
        0x000022BF
    };

    static _CharacterInfo _character000022C0 =
    {
        0x000022C0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C0,
        0x000022C0,
        0x000022C0
    };

    static _CharacterInfo _character000022C1 =
    {
        0x000022C1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C1,
        0x000022C1,
        0x000022C1
    };

    static _CharacterInfo _character000022C2 =
    {
        0x000022C2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C2,
        0x000022C2,
        0x000022C2
    };

    static _CharacterInfo _character000022C3 =
    {
        0x000022C3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C3,
        0x000022C3,
        0x000022C3
    };

    static _CharacterInfo _character000022C4 =
    {
        0x000022C4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C4,
        0x000022C4,
        0x000022C4
    };

    static _CharacterInfo _character000022C5 =
    {
        0x000022C5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C5,
        0x000022C5,
        0x000022C5
    };

    static _CharacterInfo _character000022C6 =
    {
        0x000022C6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C6,
        0x000022C6,
        0x000022C6
    };

    static _CharacterInfo _character000022C7 =
    {
        0x000022C7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C7,
        0x000022C7,
        0x000022C7
    };

    static _CharacterInfo _character000022C8 =
    {
        0x000022C8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022C8,
        0x000022C8,
        0x000022C8
    };

    static _CharacterInfo _character000022C9 =
    {
        0x000022C9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022C9,
        0x000022C9,
        0x000022C9
    };

    static _CharacterInfo _character000022CA =
    {
        0x000022CA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022CA,
        0x000022CA,
        0x000022CA
    };

    static _CharacterInfo _character000022CB =
    {
        0x000022CB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022CB,
        0x000022CB,
        0x000022CB
    };

    static _CharacterInfo _character000022CC =
    {
        0x000022CC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022CC,
        0x000022CC,
        0x000022CC
    };

    static _CharacterInfo _character000022CD =
    {
        0x000022CD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022CD,
        0x000022CD,
        0x000022CD
    };

    static _CharacterInfo _character000022CE =
    {
        0x000022CE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022CE,
        0x000022CE,
        0x000022CE
    };

    static _CharacterInfo _character000022CF =
    {
        0x000022CF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022CF,
        0x000022CF,
        0x000022CF
    };

    static _CharacterInfo _character000022D0 =
    {
        0x000022D0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D0,
        0x000022D0,
        0x000022D0
    };

    static _CharacterInfo _character000022D1 =
    {
        0x000022D1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D1,
        0x000022D1,
        0x000022D1
    };

    static _CharacterInfo _character000022D2 =
    {
        0x000022D2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022D2,
        0x000022D2,
        0x000022D2
    };

    static _CharacterInfo _character000022D3 =
    {
        0x000022D3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022D3,
        0x000022D3,
        0x000022D3
    };

    static _CharacterInfo _character000022D4 =
    {
        0x000022D4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022D4,
        0x000022D4,
        0x000022D4
    };

    static _CharacterInfo _character000022D5 =
    {
        0x000022D5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022D5,
        0x000022D5,
        0x000022D5
    };

    static _CharacterInfo _character000022D6 =
    {
        0x000022D6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D6,
        0x000022D6,
        0x000022D6
    };

    static _CharacterInfo _character000022D7 =
    {
        0x000022D7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D7,
        0x000022D7,
        0x000022D7
    };

    static _CharacterInfo _character000022D8 =
    {
        0x000022D8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D8,
        0x000022D8,
        0x000022D8
    };

    static _CharacterInfo _character000022D9 =
    {
        0x000022D9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022D9,
        0x000022D9,
        0x000022D9
    };

    static _CharacterInfo _character000022DA =
    {
        0x000022DA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DA,
        0x000022DA,
        0x000022DA
    };

    static _CharacterInfo _character000022DB =
    {
        0x000022DB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DB,
        0x000022DB,
        0x000022DB
    };

    static _CharacterInfo _character000022DC =
    {
        0x000022DC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DC,
        0x000022DC,
        0x000022DC
    };

    static _CharacterInfo _character000022DD =
    {
        0x000022DD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DD,
        0x000022DD,
        0x000022DD
    };

    static _CharacterInfo _character000022DE =
    {
        0x000022DE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DE,
        0x000022DE,
        0x000022DE
    };

    static _CharacterInfo _character000022DF =
    {
        0x000022DF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022DF,
        0x000022DF,
        0x000022DF
    };

    static Char _decompositionMapping000022E0[] = 
    {
        0x0000227C,
        0x00000338
    };

    static _CharacterInfo _character000022E0 =
    {
        0x000022E0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E0,
        0x000022E0,
        0x000022E0
    };

    static Char _decompositionMapping000022E1[] = 
    {
        0x0000227D,
        0x00000338
    };

    static _CharacterInfo _character000022E1 =
    {
        0x000022E1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E1,
        0x000022E1,
        0x000022E1
    };

    static Char _decompositionMapping000022E2[] = 
    {
        0x00002291,
        0x00000338
    };

    static _CharacterInfo _character000022E2 =
    {
        0x000022E2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E2,
        0x000022E2,
        0x000022E2
    };

    static Char _decompositionMapping000022E3[] = 
    {
        0x00002292,
        0x00000338
    };

    static _CharacterInfo _character000022E3 =
    {
        0x000022E3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E3,
        0x000022E3,
        0x000022E3
    };

    static _CharacterInfo _character000022E4 =
    {
        0x000022E4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E4,
        0x000022E4,
        0x000022E4
    };

    static _CharacterInfo _character000022E5 =
    {
        0x000022E5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E5,
        0x000022E5,
        0x000022E5
    };

    static _CharacterInfo _character000022E6 =
    {
        0x000022E6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E6,
        0x000022E6,
        0x000022E6
    };

    static _CharacterInfo _character000022E7 =
    {
        0x000022E7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E7,
        0x000022E7,
        0x000022E7
    };

    static _CharacterInfo _character000022E8 =
    {
        0x000022E8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E8,
        0x000022E8,
        0x000022E8
    };

    static _CharacterInfo _character000022E9 =
    {
        0x000022E9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022E9,
        0x000022E9,
        0x000022E9
    };

    static Char _decompositionMapping000022EA[] = 
    {
        0x000022B2,
        0x00000338
    };

    static _CharacterInfo _character000022EA =
    {
        0x000022EA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022EA,
        0x000022EA,
        0x000022EA
    };

    static Char _decompositionMapping000022EB[] = 
    {
        0x000022B3,
        0x00000338
    };

    static _CharacterInfo _character000022EB =
    {
        0x000022EB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022EB,
        0x000022EB,
        0x000022EB
    };

    static Char _decompositionMapping000022EC[] = 
    {
        0x000022B4,
        0x00000338
    };

    static _CharacterInfo _character000022EC =
    {
        0x000022EC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022EC,
        0x000022EC,
        0x000022EC
    };

    static Char _decompositionMapping000022ED[] = 
    {
        0x000022B5,
        0x00000338
    };

    static _CharacterInfo _character000022ED =
    {
        0x000022ED,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000022ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022ED,
        0x000022ED,
        0x000022ED
    };

    static _CharacterInfo _character000022EE =
    {
        0x000022EE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022EE,
        0x000022EE,
        0x000022EE
    };

    static _CharacterInfo _character000022EF =
    {
        0x000022EF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000022EF,
        0x000022EF,
        0x000022EF
    };

    static _CharacterInfo _character000022F0 =
    {
        0x000022F0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F0,
        0x000022F0,
        0x000022F0
    };

    static _CharacterInfo _character000022F1 =
    {
        0x000022F1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F1,
        0x000022F1,
        0x000022F1
    };

    static _CharacterInfo _character000022F2 =
    {
        0x000022F2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F2,
        0x000022F2,
        0x000022F2
    };

    static _CharacterInfo _character000022F3 =
    {
        0x000022F3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F3,
        0x000022F3,
        0x000022F3
    };

    static _CharacterInfo _character000022F4 =
    {
        0x000022F4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F4,
        0x000022F4,
        0x000022F4
    };

    static _CharacterInfo _character000022F5 =
    {
        0x000022F5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F5,
        0x000022F5,
        0x000022F5
    };

    static _CharacterInfo _character000022F6 =
    {
        0x000022F6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F6,
        0x000022F6,
        0x000022F6
    };

    static _CharacterInfo _character000022F7 =
    {
        0x000022F7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F7,
        0x000022F7,
        0x000022F7
    };

    static _CharacterInfo _character000022F8 =
    {
        0x000022F8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F8,
        0x000022F8,
        0x000022F8
    };

    static _CharacterInfo _character000022F9 =
    {
        0x000022F9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022F9,
        0x000022F9,
        0x000022F9
    };

    static _CharacterInfo _character000022FA =
    {
        0x000022FA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FA,
        0x000022FA,
        0x000022FA
    };

    static _CharacterInfo _character000022FB =
    {
        0x000022FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FB,
        0x000022FB,
        0x000022FB
    };

    static _CharacterInfo _character000022FC =
    {
        0x000022FC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FC,
        0x000022FC,
        0x000022FC
    };

    static _CharacterInfo _character000022FD =
    {
        0x000022FD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FD,
        0x000022FD,
        0x000022FD
    };

    static _CharacterInfo _character000022FE =
    {
        0x000022FE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FE,
        0x000022FE,
        0x000022FE
    };

    static _CharacterInfo _character000022FF =
    {
        0x000022FF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000022FF,
        0x000022FF,
        0x000022FF
    };

    static _CharacterInfo _character00002300 =
    {
        0x00002300,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002300,
        0x00002300,
        0x00002300
    };

    static _CharacterInfo _character00002301 =
    {
        0x00002301,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002301,
        0x00002301,
        0x00002301
    };

    static _CharacterInfo _character00002302 =
    {
        0x00002302,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002302,
        0x00002302,
        0x00002302
    };

    static _CharacterInfo _character00002303 =
    {
        0x00002303,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002303,
        0x00002303,
        0x00002303
    };

    static _CharacterInfo _character00002304 =
    {
        0x00002304,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002304,
        0x00002304,
        0x00002304
    };

    static _CharacterInfo _character00002305 =
    {
        0x00002305,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002305,
        0x00002305,
        0x00002305
    };

    static _CharacterInfo _character00002306 =
    {
        0x00002306,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002306,
        0x00002306,
        0x00002306
    };

    static _CharacterInfo _character00002307 =
    {
        0x00002307,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002307,
        0x00002307,
        0x00002307
    };

    static _CharacterInfo _character00002308 =
    {
        0x00002308,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002308,
        0x00002308,
        0x00002308
    };

    static _CharacterInfo _character00002309 =
    {
        0x00002309,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002309,
        0x00002309,
        0x00002309
    };

    static _CharacterInfo _character0000230A =
    {
        0x0000230A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000230A,
        0x0000230A,
        0x0000230A
    };

    static _CharacterInfo _character0000230B =
    {
        0x0000230B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000230B,
        0x0000230B,
        0x0000230B
    };

    static _CharacterInfo _character0000230C =
    {
        0x0000230C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000230C,
        0x0000230C,
        0x0000230C
    };

    static _CharacterInfo _character0000230D =
    {
        0x0000230D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000230D,
        0x0000230D,
        0x0000230D
    };

    static _CharacterInfo _character0000230E =
    {
        0x0000230E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000230E,
        0x0000230E,
        0x0000230E
    };

    static _CharacterInfo _character0000230F =
    {
        0x0000230F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000230F,
        0x0000230F,
        0x0000230F
    };

    static _CharacterInfo _character00002310 =
    {
        0x00002310,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002310,
        0x00002310,
        0x00002310
    };

    static _CharacterInfo _character00002311 =
    {
        0x00002311,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002311,
        0x00002311,
        0x00002311
    };

    static _CharacterInfo _character00002312 =
    {
        0x00002312,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002312,
        0x00002312,
        0x00002312
    };

    static _CharacterInfo _character00002313 =
    {
        0x00002313,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002313,
        0x00002313,
        0x00002313
    };

    static _CharacterInfo _character00002314 =
    {
        0x00002314,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002314,
        0x00002314,
        0x00002314
    };

    static _CharacterInfo _character00002315 =
    {
        0x00002315,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002315,
        0x00002315,
        0x00002315
    };

    static _CharacterInfo _character00002316 =
    {
        0x00002316,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002316,
        0x00002316,
        0x00002316
    };

    static _CharacterInfo _character00002317 =
    {
        0x00002317,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002317,
        0x00002317,
        0x00002317
    };

    static _CharacterInfo _character00002318 =
    {
        0x00002318,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002318,
        0x00002318,
        0x00002318
    };

    static _CharacterInfo _character00002319 =
    {
        0x00002319,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002319,
        0x00002319,
        0x00002319
    };

    static _CharacterInfo _character0000231A =
    {
        0x0000231A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231A,
        0x0000231A,
        0x0000231A
    };

    static _CharacterInfo _character0000231B =
    {
        0x0000231B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231B,
        0x0000231B,
        0x0000231B
    };

    static _CharacterInfo _character0000231C =
    {
        0x0000231C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231C,
        0x0000231C,
        0x0000231C
    };

    static _CharacterInfo _character0000231D =
    {
        0x0000231D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231D,
        0x0000231D,
        0x0000231D
    };

    static _CharacterInfo _character0000231E =
    {
        0x0000231E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231E,
        0x0000231E,
        0x0000231E
    };

    static _CharacterInfo _character0000231F =
    {
        0x0000231F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000231F,
        0x0000231F,
        0x0000231F
    };

    static _CharacterInfo _character00002320 =
    {
        0x00002320,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002320,
        0x00002320,
        0x00002320
    };

    static _CharacterInfo _character00002321 =
    {
        0x00002321,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002321,
        0x00002321,
        0x00002321
    };

    static _CharacterInfo _character00002322 =
    {
        0x00002322,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002322,
        0x00002322,
        0x00002322
    };

    static _CharacterInfo _character00002323 =
    {
        0x00002323,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002323,
        0x00002323,
        0x00002323
    };

    static _CharacterInfo _character00002324 =
    {
        0x00002324,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002324,
        0x00002324,
        0x00002324
    };

    static _CharacterInfo _character00002325 =
    {
        0x00002325,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002325,
        0x00002325,
        0x00002325
    };

    static _CharacterInfo _character00002326 =
    {
        0x00002326,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002326,
        0x00002326,
        0x00002326
    };

    static _CharacterInfo _character00002327 =
    {
        0x00002327,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002327,
        0x00002327,
        0x00002327
    };

    static _CharacterInfo _character00002328 =
    {
        0x00002328,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002328,
        0x00002328,
        0x00002328
    };

    static Char _decompositionMapping00002329[] = 
    {
        0x00003008
    };

    static _CharacterInfo _character00002329 =
    {
        0x00002329,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping00002329,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002329,
        0x00002329,
        0x00002329
    };

    static Char _decompositionMapping0000232A[] = 
    {
        0x00003009
    };

    static _CharacterInfo _character0000232A =
    {
        0x0000232A,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000232A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000232A,
        0x0000232A,
        0x0000232A
    };

    static _CharacterInfo _character0000232B =
    {
        0x0000232B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000232B,
        0x0000232B,
        0x0000232B
    };

    static _CharacterInfo _character0000232C =
    {
        0x0000232C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000232C,
        0x0000232C,
        0x0000232C
    };

    static _CharacterInfo _character0000232D =
    {
        0x0000232D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000232D,
        0x0000232D,
        0x0000232D
    };

    static _CharacterInfo _character0000232E =
    {
        0x0000232E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000232E,
        0x0000232E,
        0x0000232E
    };

    static _CharacterInfo _character0000232F =
    {
        0x0000232F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000232F,
        0x0000232F,
        0x0000232F
    };

    static _CharacterInfo _character00002330 =
    {
        0x00002330,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002330,
        0x00002330,
        0x00002330
    };

    static _CharacterInfo _character00002331 =
    {
        0x00002331,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002331,
        0x00002331,
        0x00002331
    };

    static _CharacterInfo _character00002332 =
    {
        0x00002332,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002332,
        0x00002332,
        0x00002332
    };

    static _CharacterInfo _character00002333 =
    {
        0x00002333,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002333,
        0x00002333,
        0x00002333
    };

    static _CharacterInfo _character00002334 =
    {
        0x00002334,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002334,
        0x00002334,
        0x00002334
    };

    static _CharacterInfo _character00002335 =
    {
        0x00002335,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002335,
        0x00002335,
        0x00002335
    };

    static _CharacterInfo _character00002336 =
    {
        0x00002336,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002336,
        0x00002336,
        0x00002336
    };

    static _CharacterInfo _character00002337 =
    {
        0x00002337,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002337,
        0x00002337,
        0x00002337
    };

    static _CharacterInfo _character00002338 =
    {
        0x00002338,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002338,
        0x00002338,
        0x00002338
    };

    static _CharacterInfo _character00002339 =
    {
        0x00002339,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002339,
        0x00002339,
        0x00002339
    };

    static _CharacterInfo _character0000233A =
    {
        0x0000233A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233A,
        0x0000233A,
        0x0000233A
    };

    static _CharacterInfo _character0000233B =
    {
        0x0000233B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233B,
        0x0000233B,
        0x0000233B
    };

    static _CharacterInfo _character0000233C =
    {
        0x0000233C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233C,
        0x0000233C,
        0x0000233C
    };

    static _CharacterInfo _character0000233D =
    {
        0x0000233D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233D,
        0x0000233D,
        0x0000233D
    };

    static _CharacterInfo _character0000233E =
    {
        0x0000233E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233E,
        0x0000233E,
        0x0000233E
    };

    static _CharacterInfo _character0000233F =
    {
        0x0000233F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000233F,
        0x0000233F,
        0x0000233F
    };

    static _CharacterInfo _character00002340 =
    {
        0x00002340,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002340,
        0x00002340,
        0x00002340
    };

    static _CharacterInfo _character00002341 =
    {
        0x00002341,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002341,
        0x00002341,
        0x00002341
    };

    static _CharacterInfo _character00002342 =
    {
        0x00002342,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002342,
        0x00002342,
        0x00002342
    };

    static _CharacterInfo _character00002343 =
    {
        0x00002343,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002343,
        0x00002343,
        0x00002343
    };

    static _CharacterInfo _character00002344 =
    {
        0x00002344,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002344,
        0x00002344,
        0x00002344
    };

    static _CharacterInfo _character00002345 =
    {
        0x00002345,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002345,
        0x00002345,
        0x00002345
    };

    static _CharacterInfo _character00002346 =
    {
        0x00002346,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002346,
        0x00002346,
        0x00002346
    };

    static _CharacterInfo _character00002347 =
    {
        0x00002347,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002347,
        0x00002347,
        0x00002347
    };

    static _CharacterInfo _character00002348 =
    {
        0x00002348,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002348,
        0x00002348,
        0x00002348
    };

    static _CharacterInfo _character00002349 =
    {
        0x00002349,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002349,
        0x00002349,
        0x00002349
    };

    static _CharacterInfo _character0000234A =
    {
        0x0000234A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234A,
        0x0000234A,
        0x0000234A
    };

    static _CharacterInfo _character0000234B =
    {
        0x0000234B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234B,
        0x0000234B,
        0x0000234B
    };

    static _CharacterInfo _character0000234C =
    {
        0x0000234C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234C,
        0x0000234C,
        0x0000234C
    };

    static _CharacterInfo _character0000234D =
    {
        0x0000234D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234D,
        0x0000234D,
        0x0000234D
    };

    static _CharacterInfo _character0000234E =
    {
        0x0000234E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234E,
        0x0000234E,
        0x0000234E
    };

    static _CharacterInfo _character0000234F =
    {
        0x0000234F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000234F,
        0x0000234F,
        0x0000234F
    };

    static _CharacterInfo _character00002350 =
    {
        0x00002350,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002350,
        0x00002350,
        0x00002350
    };

    static _CharacterInfo _character00002351 =
    {
        0x00002351,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002351,
        0x00002351,
        0x00002351
    };

    static _CharacterInfo _character00002352 =
    {
        0x00002352,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002352,
        0x00002352,
        0x00002352
    };

    static _CharacterInfo _character00002353 =
    {
        0x00002353,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002353,
        0x00002353,
        0x00002353
    };

    static _CharacterInfo _character00002354 =
    {
        0x00002354,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002354,
        0x00002354,
        0x00002354
    };

    static _CharacterInfo _character00002355 =
    {
        0x00002355,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002355,
        0x00002355,
        0x00002355
    };

    static _CharacterInfo _character00002356 =
    {
        0x00002356,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002356,
        0x00002356,
        0x00002356
    };

    static _CharacterInfo _character00002357 =
    {
        0x00002357,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002357,
        0x00002357,
        0x00002357
    };

    static _CharacterInfo _character00002358 =
    {
        0x00002358,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002358,
        0x00002358,
        0x00002358
    };

    static _CharacterInfo _character00002359 =
    {
        0x00002359,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002359,
        0x00002359,
        0x00002359
    };

    static _CharacterInfo _character0000235A =
    {
        0x0000235A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235A,
        0x0000235A,
        0x0000235A
    };

    static _CharacterInfo _character0000235B =
    {
        0x0000235B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235B,
        0x0000235B,
        0x0000235B
    };

    static _CharacterInfo _character0000235C =
    {
        0x0000235C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235C,
        0x0000235C,
        0x0000235C
    };

    static _CharacterInfo _character0000235D =
    {
        0x0000235D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235D,
        0x0000235D,
        0x0000235D
    };

    static _CharacterInfo _character0000235E =
    {
        0x0000235E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235E,
        0x0000235E,
        0x0000235E
    };

    static _CharacterInfo _character0000235F =
    {
        0x0000235F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000235F,
        0x0000235F,
        0x0000235F
    };

    static _CharacterInfo _character00002360 =
    {
        0x00002360,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002360,
        0x00002360,
        0x00002360
    };

    static _CharacterInfo _character00002361 =
    {
        0x00002361,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002361,
        0x00002361,
        0x00002361
    };

    static _CharacterInfo _character00002362 =
    {
        0x00002362,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002362,
        0x00002362,
        0x00002362
    };

    static _CharacterInfo _character00002363 =
    {
        0x00002363,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002363,
        0x00002363,
        0x00002363
    };

    static _CharacterInfo _character00002364 =
    {
        0x00002364,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002364,
        0x00002364,
        0x00002364
    };

    static _CharacterInfo _character00002365 =
    {
        0x00002365,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002365,
        0x00002365,
        0x00002365
    };

    static _CharacterInfo _character00002366 =
    {
        0x00002366,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002366,
        0x00002366,
        0x00002366
    };

    static _CharacterInfo _character00002367 =
    {
        0x00002367,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002367,
        0x00002367,
        0x00002367
    };

    static _CharacterInfo _character00002368 =
    {
        0x00002368,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002368,
        0x00002368,
        0x00002368
    };

    static _CharacterInfo _character00002369 =
    {
        0x00002369,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002369,
        0x00002369,
        0x00002369
    };

    static _CharacterInfo _character0000236A =
    {
        0x0000236A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236A,
        0x0000236A,
        0x0000236A
    };

    static _CharacterInfo _character0000236B =
    {
        0x0000236B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236B,
        0x0000236B,
        0x0000236B
    };

    static _CharacterInfo _character0000236C =
    {
        0x0000236C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236C,
        0x0000236C,
        0x0000236C
    };

    static _CharacterInfo _character0000236D =
    {
        0x0000236D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236D,
        0x0000236D,
        0x0000236D
    };

    static _CharacterInfo _character0000236E =
    {
        0x0000236E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236E,
        0x0000236E,
        0x0000236E
    };

    static _CharacterInfo _character0000236F =
    {
        0x0000236F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000236F,
        0x0000236F,
        0x0000236F
    };

    static _CharacterInfo _character00002370 =
    {
        0x00002370,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002370,
        0x00002370,
        0x00002370
    };

    static _CharacterInfo _character00002371 =
    {
        0x00002371,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002371,
        0x00002371,
        0x00002371
    };

    static _CharacterInfo _character00002372 =
    {
        0x00002372,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002372,
        0x00002372,
        0x00002372
    };

    static _CharacterInfo _character00002373 =
    {
        0x00002373,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002373,
        0x00002373,
        0x00002373
    };

    static _CharacterInfo _character00002374 =
    {
        0x00002374,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002374,
        0x00002374,
        0x00002374
    };

    static _CharacterInfo _character00002375 =
    {
        0x00002375,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002375,
        0x00002375,
        0x00002375
    };

    static _CharacterInfo _character00002376 =
    {
        0x00002376,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002376,
        0x00002376,
        0x00002376
    };

    static _CharacterInfo _character00002377 =
    {
        0x00002377,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002377,
        0x00002377,
        0x00002377
    };

    static _CharacterInfo _character00002378 =
    {
        0x00002378,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002378,
        0x00002378,
        0x00002378
    };

    static _CharacterInfo _character00002379 =
    {
        0x00002379,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002379,
        0x00002379,
        0x00002379
    };

    static _CharacterInfo _character0000237A =
    {
        0x0000237A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237A,
        0x0000237A,
        0x0000237A
    };

    static _CharacterInfo _character0000237B =
    {
        0x0000237B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237B,
        0x0000237B,
        0x0000237B
    };

    static _CharacterInfo _character0000237C =
    {
        0x0000237C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237C,
        0x0000237C,
        0x0000237C
    };

    static _CharacterInfo _character0000237D =
    {
        0x0000237D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237D,
        0x0000237D,
        0x0000237D
    };

    static _CharacterInfo _character0000237E =
    {
        0x0000237E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237E,
        0x0000237E,
        0x0000237E
    };

    static _CharacterInfo _character0000237F =
    {
        0x0000237F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000237F,
        0x0000237F,
        0x0000237F
    };

    static _CharacterInfo _character00002380 =
    {
        0x00002380,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002380,
        0x00002380,
        0x00002380
    };

    static _CharacterInfo _character00002381 =
    {
        0x00002381,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002381,
        0x00002381,
        0x00002381
    };

    static _CharacterInfo _character00002382 =
    {
        0x00002382,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002382,
        0x00002382,
        0x00002382
    };

    static _CharacterInfo _character00002383 =
    {
        0x00002383,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002383,
        0x00002383,
        0x00002383
    };

    static _CharacterInfo _character00002384 =
    {
        0x00002384,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002384,
        0x00002384,
        0x00002384
    };

    static _CharacterInfo _character00002385 =
    {
        0x00002385,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002385,
        0x00002385,
        0x00002385
    };

    static _CharacterInfo _character00002386 =
    {
        0x00002386,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002386,
        0x00002386,
        0x00002386
    };

    static _CharacterInfo _character00002387 =
    {
        0x00002387,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002387,
        0x00002387,
        0x00002387
    };

    static _CharacterInfo _character00002388 =
    {
        0x00002388,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002388,
        0x00002388,
        0x00002388
    };

    static _CharacterInfo _character00002389 =
    {
        0x00002389,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002389,
        0x00002389,
        0x00002389
    };

    static _CharacterInfo _character0000238A =
    {
        0x0000238A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238A,
        0x0000238A,
        0x0000238A
    };

    static _CharacterInfo _character0000238B =
    {
        0x0000238B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238B,
        0x0000238B,
        0x0000238B
    };

    static _CharacterInfo _character0000238C =
    {
        0x0000238C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238C,
        0x0000238C,
        0x0000238C
    };

    static _CharacterInfo _character0000238D =
    {
        0x0000238D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238D,
        0x0000238D,
        0x0000238D
    };

    static _CharacterInfo _character0000238E =
    {
        0x0000238E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238E,
        0x0000238E,
        0x0000238E
    };

    static _CharacterInfo _character0000238F =
    {
        0x0000238F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000238F,
        0x0000238F,
        0x0000238F
    };

    static _CharacterInfo _character00002390 =
    {
        0x00002390,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002390,
        0x00002390,
        0x00002390
    };

    static _CharacterInfo _character00002391 =
    {
        0x00002391,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002391,
        0x00002391,
        0x00002391
    };

    static _CharacterInfo _character00002392 =
    {
        0x00002392,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002392,
        0x00002392,
        0x00002392
    };

    static _CharacterInfo _character00002393 =
    {
        0x00002393,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002393,
        0x00002393,
        0x00002393
    };

    static _CharacterInfo _character00002394 =
    {
        0x00002394,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002394,
        0x00002394,
        0x00002394
    };

    static _CharacterInfo _character00002395 =
    {
        0x00002395,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002395,
        0x00002395,
        0x00002395
    };

    static _CharacterInfo _character00002396 =
    {
        0x00002396,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002396,
        0x00002396,
        0x00002396
    };

    static _CharacterInfo _character00002397 =
    {
        0x00002397,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002397,
        0x00002397,
        0x00002397
    };

    static _CharacterInfo _character00002398 =
    {
        0x00002398,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002398,
        0x00002398,
        0x00002398
    };

    static _CharacterInfo _character00002399 =
    {
        0x00002399,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002399,
        0x00002399,
        0x00002399
    };

    static _CharacterInfo _character0000239A =
    {
        0x0000239A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239A,
        0x0000239A,
        0x0000239A
    };

    static _CharacterInfo _character0000239B =
    {
        0x0000239B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239B,
        0x0000239B,
        0x0000239B
    };

    static _CharacterInfo _character0000239C =
    {
        0x0000239C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239C,
        0x0000239C,
        0x0000239C
    };

    static _CharacterInfo _character0000239D =
    {
        0x0000239D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239D,
        0x0000239D,
        0x0000239D
    };

    static _CharacterInfo _character0000239E =
    {
        0x0000239E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239E,
        0x0000239E,
        0x0000239E
    };

    static _CharacterInfo _character0000239F =
    {
        0x0000239F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000239F,
        0x0000239F,
        0x0000239F
    };

    static _CharacterInfo _character000023A0 =
    {
        0x000023A0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A0,
        0x000023A0,
        0x000023A0
    };

    static _CharacterInfo _character000023A1 =
    {
        0x000023A1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A1,
        0x000023A1,
        0x000023A1
    };

    static _CharacterInfo _character000023A2 =
    {
        0x000023A2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A2,
        0x000023A2,
        0x000023A2
    };

    static _CharacterInfo _character000023A3 =
    {
        0x000023A3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A3,
        0x000023A3,
        0x000023A3
    };

    static _CharacterInfo _character000023A4 =
    {
        0x000023A4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A4,
        0x000023A4,
        0x000023A4
    };

    static _CharacterInfo _character000023A5 =
    {
        0x000023A5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A5,
        0x000023A5,
        0x000023A5
    };

    static _CharacterInfo _character000023A6 =
    {
        0x000023A6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A6,
        0x000023A6,
        0x000023A6
    };

    static _CharacterInfo _character000023A7 =
    {
        0x000023A7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A7,
        0x000023A7,
        0x000023A7
    };

    static _CharacterInfo _character000023A8 =
    {
        0x000023A8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A8,
        0x000023A8,
        0x000023A8
    };

    static _CharacterInfo _character000023A9 =
    {
        0x000023A9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023A9,
        0x000023A9,
        0x000023A9
    };

    static _CharacterInfo _character000023AA =
    {
        0x000023AA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AA,
        0x000023AA,
        0x000023AA
    };

    static _CharacterInfo _character000023AB =
    {
        0x000023AB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AB,
        0x000023AB,
        0x000023AB
    };

    static _CharacterInfo _character000023AC =
    {
        0x000023AC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AC,
        0x000023AC,
        0x000023AC
    };

    static _CharacterInfo _character000023AD =
    {
        0x000023AD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AD,
        0x000023AD,
        0x000023AD
    };

    static _CharacterInfo _character000023AE =
    {
        0x000023AE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AE,
        0x000023AE,
        0x000023AE
    };

    static _CharacterInfo _character000023AF =
    {
        0x000023AF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023AF,
        0x000023AF,
        0x000023AF
    };

    static _CharacterInfo _character000023B0 =
    {
        0x000023B0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B0,
        0x000023B0,
        0x000023B0
    };

    static _CharacterInfo _character000023B1 =
    {
        0x000023B1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B1,
        0x000023B1,
        0x000023B1
    };

    static _CharacterInfo _character000023B2 =
    {
        0x000023B2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B2,
        0x000023B2,
        0x000023B2
    };

    static _CharacterInfo _character000023B3 =
    {
        0x000023B3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B3,
        0x000023B3,
        0x000023B3
    };

    static _CharacterInfo _character000023B4 =
    {
        0x000023B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B4,
        0x000023B4,
        0x000023B4
    };

    static _CharacterInfo _character000023B5 =
    {
        0x000023B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B5,
        0x000023B5,
        0x000023B5
    };

    static _CharacterInfo _character000023B6 =
    {
        0x000023B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B6,
        0x000023B6,
        0x000023B6
    };

    static _CharacterInfo _character000023B7 =
    {
        0x000023B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B7,
        0x000023B7,
        0x000023B7
    };

    static _CharacterInfo _character000023B8 =
    {
        0x000023B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B8,
        0x000023B8,
        0x000023B8
    };

    static _CharacterInfo _character000023B9 =
    {
        0x000023B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023B9,
        0x000023B9,
        0x000023B9
    };

    static _CharacterInfo _character000023BA =
    {
        0x000023BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BA,
        0x000023BA,
        0x000023BA
    };

    static _CharacterInfo _character000023BB =
    {
        0x000023BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BB,
        0x000023BB,
        0x000023BB
    };

    static _CharacterInfo _character000023BC =
    {
        0x000023BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BC,
        0x000023BC,
        0x000023BC
    };

    static _CharacterInfo _character000023BD =
    {
        0x000023BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BD,
        0x000023BD,
        0x000023BD
    };

    static _CharacterInfo _character000023BE =
    {
        0x000023BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BE,
        0x000023BE,
        0x000023BE
    };

    static _CharacterInfo _character000023BF =
    {
        0x000023BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023BF,
        0x000023BF,
        0x000023BF
    };

    static _CharacterInfo _character000023C0 =
    {
        0x000023C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C0,
        0x000023C0,
        0x000023C0
    };

    static _CharacterInfo _character000023C1 =
    {
        0x000023C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C1,
        0x000023C1,
        0x000023C1
    };

    static _CharacterInfo _character000023C2 =
    {
        0x000023C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C2,
        0x000023C2,
        0x000023C2
    };

    static _CharacterInfo _character000023C3 =
    {
        0x000023C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C3,
        0x000023C3,
        0x000023C3
    };

    static _CharacterInfo _character000023C4 =
    {
        0x000023C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C4,
        0x000023C4,
        0x000023C4
    };

    static _CharacterInfo _character000023C5 =
    {
        0x000023C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C5,
        0x000023C5,
        0x000023C5
    };

    static _CharacterInfo _character000023C6 =
    {
        0x000023C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C6,
        0x000023C6,
        0x000023C6
    };

    static _CharacterInfo _character000023C7 =
    {
        0x000023C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C7,
        0x000023C7,
        0x000023C7
    };

    static _CharacterInfo _character000023C8 =
    {
        0x000023C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C8,
        0x000023C8,
        0x000023C8
    };

    static _CharacterInfo _character000023C9 =
    {
        0x000023C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023C9,
        0x000023C9,
        0x000023C9
    };

    static _CharacterInfo _character000023CA =
    {
        0x000023CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CA,
        0x000023CA,
        0x000023CA
    };

    static _CharacterInfo _character000023CB =
    {
        0x000023CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CB,
        0x000023CB,
        0x000023CB
    };

    static _CharacterInfo _character000023CC =
    {
        0x000023CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CC,
        0x000023CC,
        0x000023CC
    };

    static _CharacterInfo _character000023CD =
    {
        0x000023CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CD,
        0x000023CD,
        0x000023CD
    };

    static _CharacterInfo _character000023CE =
    {
        0x000023CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CE,
        0x000023CE,
        0x000023CE
    };

    static _CharacterInfo _character000023CF =
    {
        0x000023CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023CF,
        0x000023CF,
        0x000023CF
    };

    static _CharacterInfo _character000023D0 =
    {
        0x000023D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D0,
        0x000023D0,
        0x000023D0
    };

    static _CharacterInfo _character000023D1 =
    {
        0x000023D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D1,
        0x000023D1,
        0x000023D1
    };

    static _CharacterInfo _character000023D2 =
    {
        0x000023D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D2,
        0x000023D2,
        0x000023D2
    };

    static _CharacterInfo _character000023D3 =
    {
        0x000023D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D3,
        0x000023D3,
        0x000023D3
    };

    static _CharacterInfo _character000023D4 =
    {
        0x000023D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D4,
        0x000023D4,
        0x000023D4
    };

    static _CharacterInfo _character000023D5 =
    {
        0x000023D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D5,
        0x000023D5,
        0x000023D5
    };

    static _CharacterInfo _character000023D6 =
    {
        0x000023D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D6,
        0x000023D6,
        0x000023D6
    };

    static _CharacterInfo _character000023D7 =
    {
        0x000023D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D7,
        0x000023D7,
        0x000023D7
    };

    static _CharacterInfo _character000023D8 =
    {
        0x000023D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D8,
        0x000023D8,
        0x000023D8
    };

    static _CharacterInfo _character000023D9 =
    {
        0x000023D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023D9,
        0x000023D9,
        0x000023D9
    };

    static _CharacterInfo _character000023DA =
    {
        0x000023DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DA,
        0x000023DA,
        0x000023DA
    };

    static _CharacterInfo _character000023DB =
    {
        0x000023DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DB,
        0x000023DB,
        0x000023DB
    };

    static _CharacterInfo _character000023DC =
    {
        0x000023DC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DC,
        0x000023DC,
        0x000023DC
    };

    static _CharacterInfo _character000023DD =
    {
        0x000023DD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DD,
        0x000023DD,
        0x000023DD
    };

    static _CharacterInfo _character000023DE =
    {
        0x000023DE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DE,
        0x000023DE,
        0x000023DE
    };

    static _CharacterInfo _character000023DF =
    {
        0x000023DF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023DF,
        0x000023DF,
        0x000023DF
    };

    static _CharacterInfo _character000023E0 =
    {
        0x000023E0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E0,
        0x000023E0,
        0x000023E0
    };

    static _CharacterInfo _character000023E1 =
    {
        0x000023E1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E1,
        0x000023E1,
        0x000023E1
    };

    static _CharacterInfo _character000023E2 =
    {
        0x000023E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E2,
        0x000023E2,
        0x000023E2
    };

    static _CharacterInfo _character000023E3 =
    {
        0x000023E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E3,
        0x000023E3,
        0x000023E3
    };

    static _CharacterInfo _character000023E4 =
    {
        0x000023E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E4,
        0x000023E4,
        0x000023E4
    };

    static _CharacterInfo _character000023E5 =
    {
        0x000023E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E5,
        0x000023E5,
        0x000023E5
    };

    static _CharacterInfo _character000023E6 =
    {
        0x000023E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E6,
        0x000023E6,
        0x000023E6
    };

    static _CharacterInfo _character000023E7 =
    {
        0x000023E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000023E7,
        0x000023E7,
        0x000023E7
    };

    static _CharacterInfo _character00002400 =
    {
        0x00002400,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002400,
        0x00002400,
        0x00002400
    };

    static _CharacterInfo _character00002401 =
    {
        0x00002401,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002401,
        0x00002401,
        0x00002401
    };

    static _CharacterInfo _character00002402 =
    {
        0x00002402,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002402,
        0x00002402,
        0x00002402
    };

    static _CharacterInfo _character00002403 =
    {
        0x00002403,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002403,
        0x00002403,
        0x00002403
    };

    static _CharacterInfo _character00002404 =
    {
        0x00002404,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002404,
        0x00002404,
        0x00002404
    };

    static _CharacterInfo _character00002405 =
    {
        0x00002405,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002405,
        0x00002405,
        0x00002405
    };

    static _CharacterInfo _character00002406 =
    {
        0x00002406,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002406,
        0x00002406,
        0x00002406
    };

    static _CharacterInfo _character00002407 =
    {
        0x00002407,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002407,
        0x00002407,
        0x00002407
    };

    static _CharacterInfo _character00002408 =
    {
        0x00002408,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002408,
        0x00002408,
        0x00002408
    };

    static _CharacterInfo _character00002409 =
    {
        0x00002409,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002409,
        0x00002409,
        0x00002409
    };

    static _CharacterInfo _character0000240A =
    {
        0x0000240A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240A,
        0x0000240A,
        0x0000240A
    };

    static _CharacterInfo _character0000240B =
    {
        0x0000240B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240B,
        0x0000240B,
        0x0000240B
    };

    static _CharacterInfo _character0000240C =
    {
        0x0000240C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240C,
        0x0000240C,
        0x0000240C
    };

    static _CharacterInfo _character0000240D =
    {
        0x0000240D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240D,
        0x0000240D,
        0x0000240D
    };

    static _CharacterInfo _character0000240E =
    {
        0x0000240E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240E,
        0x0000240E,
        0x0000240E
    };

    static _CharacterInfo _character0000240F =
    {
        0x0000240F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000240F,
        0x0000240F,
        0x0000240F
    };

    static _CharacterInfo _character00002410 =
    {
        0x00002410,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002410,
        0x00002410,
        0x00002410
    };

    static _CharacterInfo _character00002411 =
    {
        0x00002411,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002411,
        0x00002411,
        0x00002411
    };

    static _CharacterInfo _character00002412 =
    {
        0x00002412,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002412,
        0x00002412,
        0x00002412
    };

    static _CharacterInfo _character00002413 =
    {
        0x00002413,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002413,
        0x00002413,
        0x00002413
    };

    static _CharacterInfo _character00002414 =
    {
        0x00002414,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002414,
        0x00002414,
        0x00002414
    };

    static _CharacterInfo _character00002415 =
    {
        0x00002415,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002415,
        0x00002415,
        0x00002415
    };

    static _CharacterInfo _character00002416 =
    {
        0x00002416,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002416,
        0x00002416,
        0x00002416
    };

    static _CharacterInfo _character00002417 =
    {
        0x00002417,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002417,
        0x00002417,
        0x00002417
    };

    static _CharacterInfo _character00002418 =
    {
        0x00002418,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002418,
        0x00002418,
        0x00002418
    };

    static _CharacterInfo _character00002419 =
    {
        0x00002419,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002419,
        0x00002419,
        0x00002419
    };

    static _CharacterInfo _character0000241A =
    {
        0x0000241A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241A,
        0x0000241A,
        0x0000241A
    };

    static _CharacterInfo _character0000241B =
    {
        0x0000241B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241B,
        0x0000241B,
        0x0000241B
    };

    static _CharacterInfo _character0000241C =
    {
        0x0000241C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241C,
        0x0000241C,
        0x0000241C
    };

    static _CharacterInfo _character0000241D =
    {
        0x0000241D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241D,
        0x0000241D,
        0x0000241D
    };

    static _CharacterInfo _character0000241E =
    {
        0x0000241E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241E,
        0x0000241E,
        0x0000241E
    };

    static _CharacterInfo _character0000241F =
    {
        0x0000241F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000241F,
        0x0000241F,
        0x0000241F
    };

    static _CharacterInfo _character00002420 =
    {
        0x00002420,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002420,
        0x00002420,
        0x00002420
    };

    static _CharacterInfo _character00002421 =
    {
        0x00002421,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002421,
        0x00002421,
        0x00002421
    };

    static _CharacterInfo _character00002422 =
    {
        0x00002422,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002422,
        0x00002422,
        0x00002422
    };

    static _CharacterInfo _character00002423 =
    {
        0x00002423,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002423,
        0x00002423,
        0x00002423
    };

    static _CharacterInfo _character00002424 =
    {
        0x00002424,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002424,
        0x00002424,
        0x00002424
    };

    static _CharacterInfo _character00002425 =
    {
        0x00002425,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002425,
        0x00002425,
        0x00002425
    };

    static _CharacterInfo _character00002426 =
    {
        0x00002426,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002426,
        0x00002426,
        0x00002426
    };

    static _CharacterInfo _character00002440 =
    {
        0x00002440,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002440,
        0x00002440,
        0x00002440
    };

    static _CharacterInfo _character00002441 =
    {
        0x00002441,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002441,
        0x00002441,
        0x00002441
    };

    static _CharacterInfo _character00002442 =
    {
        0x00002442,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002442,
        0x00002442,
        0x00002442
    };

    static _CharacterInfo _character00002443 =
    {
        0x00002443,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002443,
        0x00002443,
        0x00002443
    };

    static _CharacterInfo _character00002444 =
    {
        0x00002444,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002444,
        0x00002444,
        0x00002444
    };

    static _CharacterInfo _character00002445 =
    {
        0x00002445,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002445,
        0x00002445,
        0x00002445
    };

    static _CharacterInfo _character00002446 =
    {
        0x00002446,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002446,
        0x00002446,
        0x00002446
    };

    static _CharacterInfo _character00002447 =
    {
        0x00002447,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002447,
        0x00002447,
        0x00002447
    };

    static _CharacterInfo _character00002448 =
    {
        0x00002448,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002448,
        0x00002448,
        0x00002448
    };

    static _CharacterInfo _character00002449 =
    {
        0x00002449,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002449,
        0x00002449,
        0x00002449
    };

    static _CharacterInfo _character0000244A =
    {
        0x0000244A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000244A,
        0x0000244A,
        0x0000244A
    };

    static Char _decompositionMapping00002460[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character00002460 =
    {
        0x00002460,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002460,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002460,
        0x00002460,
        0x00002460
    };

    static Char _decompositionMapping00002461[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character00002461 =
    {
        0x00002461,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002461,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002461,
        0x00002461,
        0x00002461
    };

    static Char _decompositionMapping00002462[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character00002462 =
    {
        0x00002462,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002462,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00002462,
        0x00002462,
        0x00002462
    };

    static Char _decompositionMapping00002463[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character00002463 =
    {
        0x00002463,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002463,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002463,
        0x00002463,
        0x00002463
    };

    static Char _decompositionMapping00002464[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character00002464 =
    {
        0x00002464,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002464,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00002464,
        0x00002464,
        0x00002464
    };

    static Char _decompositionMapping00002465[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character00002465 =
    {
        0x00002465,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002465,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00002465,
        0x00002465,
        0x00002465
    };

    static Char _decompositionMapping00002466[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character00002466 =
    {
        0x00002466,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002466,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00002466,
        0x00002466,
        0x00002466
    };

    static Char _decompositionMapping00002467[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character00002467 =
    {
        0x00002467,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002467,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00002467,
        0x00002467,
        0x00002467
    };

    static Char _decompositionMapping00002468[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character00002468 =
    {
        0x00002468,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00002468,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002468,
        0x00002468,
        0x00002468
    };

    static Char _decompositionMapping00002469[] = 
    {
        0x00000031,
        0x00000030
    };

    static _CharacterInfo _character00002469 =
    {
        0x00002469,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00002469,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002469,
        0x00002469,
        0x00002469
    };

    static Char _decompositionMapping0000246A[] = 
    {
        0x00000031,
        0x00000031
    };

    static _CharacterInfo _character0000246A =
    {
        0x0000246A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246A,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x0000246A,
        0x0000246A,
        0x0000246A
    };

    static Char _decompositionMapping0000246B[] = 
    {
        0x00000031,
        0x00000032
    };

    static _CharacterInfo _character0000246B =
    {
        0x0000246B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246B,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x0000246B,
        0x0000246B,
        0x0000246B
    };

    static Char _decompositionMapping0000246C[] = 
    {
        0x00000031,
        0x00000033
    };

    static _CharacterInfo _character0000246C =
    {
        0x0000246C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246C,
        false,
        0,
        false,
        0,
        true,
        13,
        1,
        false,
        0x0000246C,
        0x0000246C,
        0x0000246C
    };

    static Char _decompositionMapping0000246D[] = 
    {
        0x00000031,
        0x00000034
    };

    static _CharacterInfo _character0000246D =
    {
        0x0000246D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246D,
        false,
        0,
        false,
        0,
        true,
        14,
        1,
        false,
        0x0000246D,
        0x0000246D,
        0x0000246D
    };

    static Char _decompositionMapping0000246E[] = 
    {
        0x00000031,
        0x00000035
    };

    static _CharacterInfo _character0000246E =
    {
        0x0000246E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246E,
        false,
        0,
        false,
        0,
        true,
        15,
        1,
        false,
        0x0000246E,
        0x0000246E,
        0x0000246E
    };

    static Char _decompositionMapping0000246F[] = 
    {
        0x00000031,
        0x00000036
    };

    static _CharacterInfo _character0000246F =
    {
        0x0000246F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000246F,
        false,
        0,
        false,
        0,
        true,
        16,
        1,
        false,
        0x0000246F,
        0x0000246F,
        0x0000246F
    };

    static Char _decompositionMapping00002470[] = 
    {
        0x00000031,
        0x00000037
    };

    static _CharacterInfo _character00002470 =
    {
        0x00002470,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00002470,
        false,
        0,
        false,
        0,
        true,
        17,
        1,
        false,
        0x00002470,
        0x00002470,
        0x00002470
    };

    static Char _decompositionMapping00002471[] = 
    {
        0x00000031,
        0x00000038
    };

    static _CharacterInfo _character00002471 =
    {
        0x00002471,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00002471,
        false,
        0,
        false,
        0,
        true,
        18,
        1,
        false,
        0x00002471,
        0x00002471,
        0x00002471
    };

    static Char _decompositionMapping00002472[] = 
    {
        0x00000031,
        0x00000039
    };

    static _CharacterInfo _character00002472 =
    {
        0x00002472,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00002472,
        false,
        0,
        false,
        0,
        true,
        19,
        1,
        false,
        0x00002472,
        0x00002472,
        0x00002472
    };

    static Char _decompositionMapping00002473[] = 
    {
        0x00000032,
        0x00000030
    };

    static _CharacterInfo _character00002473 =
    {
        0x00002473,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00002473,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00002473,
        0x00002473,
        0x00002473
    };

    static Char _decompositionMapping00002474[] = 
    {
        0x00000028,
        0x00000031,
        0x00000029
    };

    static _CharacterInfo _character00002474 =
    {
        0x00002474,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002474,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002474,
        0x00002474,
        0x00002474
    };

    static Char _decompositionMapping00002475[] = 
    {
        0x00000028,
        0x00000032,
        0x00000029
    };

    static _CharacterInfo _character00002475 =
    {
        0x00002475,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002475,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002475,
        0x00002475,
        0x00002475
    };

    static Char _decompositionMapping00002476[] = 
    {
        0x00000028,
        0x00000033,
        0x00000029
    };

    static _CharacterInfo _character00002476 =
    {
        0x00002476,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002476,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00002476,
        0x00002476,
        0x00002476
    };

    static Char _decompositionMapping00002477[] = 
    {
        0x00000028,
        0x00000034,
        0x00000029
    };

    static _CharacterInfo _character00002477 =
    {
        0x00002477,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002477,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002477,
        0x00002477,
        0x00002477
    };

    static Char _decompositionMapping00002478[] = 
    {
        0x00000028,
        0x00000035,
        0x00000029
    };

    static _CharacterInfo _character00002478 =
    {
        0x00002478,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002478,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00002478,
        0x00002478,
        0x00002478
    };

    static Char _decompositionMapping00002479[] = 
    {
        0x00000028,
        0x00000036,
        0x00000029
    };

    static _CharacterInfo _character00002479 =
    {
        0x00002479,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002479,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00002479,
        0x00002479,
        0x00002479
    };

    static Char _decompositionMapping0000247A[] = 
    {
        0x00000028,
        0x00000037,
        0x00000029
    };

    static _CharacterInfo _character0000247A =
    {
        0x0000247A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000247A,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000247A,
        0x0000247A,
        0x0000247A
    };

    static Char _decompositionMapping0000247B[] = 
    {
        0x00000028,
        0x00000038,
        0x00000029
    };

    static _CharacterInfo _character0000247B =
    {
        0x0000247B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000247B,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000247B,
        0x0000247B,
        0x0000247B
    };

    static Char _decompositionMapping0000247C[] = 
    {
        0x00000028,
        0x00000039,
        0x00000029
    };

    static _CharacterInfo _character0000247C =
    {
        0x0000247C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000247C,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0000247C,
        0x0000247C,
        0x0000247C
    };

    static Char _decompositionMapping0000247D[] = 
    {
        0x00000028,
        0x00000031,
        0x00000030,
        0x00000029
    };

    static _CharacterInfo _character0000247D =
    {
        0x0000247D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000247D,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x0000247D,
        0x0000247D,
        0x0000247D
    };

    static Char _decompositionMapping0000247E[] = 
    {
        0x00000028,
        0x00000031,
        0x00000031,
        0x00000029
    };

    static _CharacterInfo _character0000247E =
    {
        0x0000247E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000247E,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x0000247E,
        0x0000247E,
        0x0000247E
    };

    static Char _decompositionMapping0000247F[] = 
    {
        0x00000028,
        0x00000031,
        0x00000032,
        0x00000029
    };

    static _CharacterInfo _character0000247F =
    {
        0x0000247F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000247F,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x0000247F,
        0x0000247F,
        0x0000247F
    };

    static Char _decompositionMapping00002480[] = 
    {
        0x00000028,
        0x00000031,
        0x00000033,
        0x00000029
    };

    static _CharacterInfo _character00002480 =
    {
        0x00002480,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002480,
        false,
        0,
        false,
        0,
        true,
        13,
        1,
        false,
        0x00002480,
        0x00002480,
        0x00002480
    };

    static Char _decompositionMapping00002481[] = 
    {
        0x00000028,
        0x00000031,
        0x00000034,
        0x00000029
    };

    static _CharacterInfo _character00002481 =
    {
        0x00002481,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002481,
        false,
        0,
        false,
        0,
        true,
        14,
        1,
        false,
        0x00002481,
        0x00002481,
        0x00002481
    };

    static Char _decompositionMapping00002482[] = 
    {
        0x00000028,
        0x00000031,
        0x00000035,
        0x00000029
    };

    static _CharacterInfo _character00002482 =
    {
        0x00002482,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002482,
        false,
        0,
        false,
        0,
        true,
        15,
        1,
        false,
        0x00002482,
        0x00002482,
        0x00002482
    };

    static Char _decompositionMapping00002483[] = 
    {
        0x00000028,
        0x00000031,
        0x00000036,
        0x00000029
    };

    static _CharacterInfo _character00002483 =
    {
        0x00002483,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002483,
        false,
        0,
        false,
        0,
        true,
        16,
        1,
        false,
        0x00002483,
        0x00002483,
        0x00002483
    };

    static Char _decompositionMapping00002484[] = 
    {
        0x00000028,
        0x00000031,
        0x00000037,
        0x00000029
    };

    static _CharacterInfo _character00002484 =
    {
        0x00002484,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002484,
        false,
        0,
        false,
        0,
        true,
        17,
        1,
        false,
        0x00002484,
        0x00002484,
        0x00002484
    };

    static Char _decompositionMapping00002485[] = 
    {
        0x00000028,
        0x00000031,
        0x00000038,
        0x00000029
    };

    static _CharacterInfo _character00002485 =
    {
        0x00002485,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002485,
        false,
        0,
        false,
        0,
        true,
        18,
        1,
        false,
        0x00002485,
        0x00002485,
        0x00002485
    };

    static Char _decompositionMapping00002486[] = 
    {
        0x00000028,
        0x00000031,
        0x00000039,
        0x00000029
    };

    static _CharacterInfo _character00002486 =
    {
        0x00002486,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002486,
        false,
        0,
        false,
        0,
        true,
        19,
        1,
        false,
        0x00002486,
        0x00002486,
        0x00002486
    };

    static Char _decompositionMapping00002487[] = 
    {
        0x00000028,
        0x00000032,
        0x00000030,
        0x00000029
    };

    static _CharacterInfo _character00002487 =
    {
        0x00002487,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002487,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00002487,
        0x00002487,
        0x00002487
    };

    static Char _decompositionMapping00002488[] = 
    {
        0x00000031,
        0x0000002E
    };

    static _CharacterInfo _character00002488 =
    {
        0x00002488,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002488,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002488,
        0x00002488,
        0x00002488
    };

    static Char _decompositionMapping00002489[] = 
    {
        0x00000032,
        0x0000002E
    };

    static _CharacterInfo _character00002489 =
    {
        0x00002489,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002489,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002489,
        0x00002489,
        0x00002489
    };

    static Char _decompositionMapping0000248A[] = 
    {
        0x00000033,
        0x0000002E
    };

    static _CharacterInfo _character0000248A =
    {
        0x0000248A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248A,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0000248A,
        0x0000248A,
        0x0000248A
    };

    static Char _decompositionMapping0000248B[] = 
    {
        0x00000034,
        0x0000002E
    };

    static _CharacterInfo _character0000248B =
    {
        0x0000248B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248B,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000248B,
        0x0000248B,
        0x0000248B
    };

    static Char _decompositionMapping0000248C[] = 
    {
        0x00000035,
        0x0000002E
    };

    static _CharacterInfo _character0000248C =
    {
        0x0000248C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248C,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000248C,
        0x0000248C,
        0x0000248C
    };

    static Char _decompositionMapping0000248D[] = 
    {
        0x00000036,
        0x0000002E
    };

    static _CharacterInfo _character0000248D =
    {
        0x0000248D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248D,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000248D,
        0x0000248D,
        0x0000248D
    };

    static Char _decompositionMapping0000248E[] = 
    {
        0x00000037,
        0x0000002E
    };

    static _CharacterInfo _character0000248E =
    {
        0x0000248E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248E,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000248E,
        0x0000248E,
        0x0000248E
    };

    static Char _decompositionMapping0000248F[] = 
    {
        0x00000038,
        0x0000002E
    };

    static _CharacterInfo _character0000248F =
    {
        0x0000248F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000248F,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000248F,
        0x0000248F,
        0x0000248F
    };

    static Char _decompositionMapping00002490[] = 
    {
        0x00000039,
        0x0000002E
    };

    static _CharacterInfo _character00002490 =
    {
        0x00002490,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002490,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002490,
        0x00002490,
        0x00002490
    };

    static Char _decompositionMapping00002491[] = 
    {
        0x00000031,
        0x00000030,
        0x0000002E
    };

    static _CharacterInfo _character00002491 =
    {
        0x00002491,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002491,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002491,
        0x00002491,
        0x00002491
    };

    static Char _decompositionMapping00002492[] = 
    {
        0x00000031,
        0x00000031,
        0x0000002E
    };

    static _CharacterInfo _character00002492 =
    {
        0x00002492,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002492,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x00002492,
        0x00002492,
        0x00002492
    };

    static Char _decompositionMapping00002493[] = 
    {
        0x00000031,
        0x00000032,
        0x0000002E
    };

    static _CharacterInfo _character00002493 =
    {
        0x00002493,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002493,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x00002493,
        0x00002493,
        0x00002493
    };

    static Char _decompositionMapping00002494[] = 
    {
        0x00000031,
        0x00000033,
        0x0000002E
    };

    static _CharacterInfo _character00002494 =
    {
        0x00002494,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002494,
        false,
        0,
        false,
        0,
        true,
        13,
        1,
        false,
        0x00002494,
        0x00002494,
        0x00002494
    };

    static Char _decompositionMapping00002495[] = 
    {
        0x00000031,
        0x00000034,
        0x0000002E
    };

    static _CharacterInfo _character00002495 =
    {
        0x00002495,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002495,
        false,
        0,
        false,
        0,
        true,
        14,
        1,
        false,
        0x00002495,
        0x00002495,
        0x00002495
    };

    static Char _decompositionMapping00002496[] = 
    {
        0x00000031,
        0x00000035,
        0x0000002E
    };

    static _CharacterInfo _character00002496 =
    {
        0x00002496,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002496,
        false,
        0,
        false,
        0,
        true,
        15,
        1,
        false,
        0x00002496,
        0x00002496,
        0x00002496
    };

    static Char _decompositionMapping00002497[] = 
    {
        0x00000031,
        0x00000036,
        0x0000002E
    };

    static _CharacterInfo _character00002497 =
    {
        0x00002497,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002497,
        false,
        0,
        false,
        0,
        true,
        16,
        1,
        false,
        0x00002497,
        0x00002497,
        0x00002497
    };

    static Char _decompositionMapping00002498[] = 
    {
        0x00000031,
        0x00000037,
        0x0000002E
    };

    static _CharacterInfo _character00002498 =
    {
        0x00002498,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002498,
        false,
        0,
        false,
        0,
        true,
        17,
        1,
        false,
        0x00002498,
        0x00002498,
        0x00002498
    };

    static Char _decompositionMapping00002499[] = 
    {
        0x00000031,
        0x00000038,
        0x0000002E
    };

    static _CharacterInfo _character00002499 =
    {
        0x00002499,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002499,
        false,
        0,
        false,
        0,
        true,
        18,
        1,
        false,
        0x00002499,
        0x00002499,
        0x00002499
    };

    static Char _decompositionMapping0000249A[] = 
    {
        0x00000031,
        0x00000039,
        0x0000002E
    };

    static _CharacterInfo _character0000249A =
    {
        0x0000249A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249A,
        false,
        0,
        false,
        0,
        true,
        19,
        1,
        false,
        0x0000249A,
        0x0000249A,
        0x0000249A
    };

    static Char _decompositionMapping0000249B[] = 
    {
        0x00000032,
        0x00000030,
        0x0000002E
    };

    static _CharacterInfo _character0000249B =
    {
        0x0000249B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249B,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x0000249B,
        0x0000249B,
        0x0000249B
    };

    static Char _decompositionMapping0000249C[] = 
    {
        0x00000028,
        0x00000061,
        0x00000029
    };

    static _CharacterInfo _character0000249C =
    {
        0x0000249C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000249C,
        0x0000249C,
        0x0000249C
    };

    static Char _decompositionMapping0000249D[] = 
    {
        0x00000028,
        0x00000062,
        0x00000029
    };

    static _CharacterInfo _character0000249D =
    {
        0x0000249D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000249D,
        0x0000249D,
        0x0000249D
    };

    static Char _decompositionMapping0000249E[] = 
    {
        0x00000028,
        0x00000063,
        0x00000029
    };

    static _CharacterInfo _character0000249E =
    {
        0x0000249E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000249E,
        0x0000249E,
        0x0000249E
    };

    static Char _decompositionMapping0000249F[] = 
    {
        0x00000028,
        0x00000064,
        0x00000029
    };

    static _CharacterInfo _character0000249F =
    {
        0x0000249F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000249F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000249F,
        0x0000249F,
        0x0000249F
    };

    static Char _decompositionMapping000024A0[] = 
    {
        0x00000028,
        0x00000065,
        0x00000029
    };

    static _CharacterInfo _character000024A0 =
    {
        0x000024A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A0,
        0x000024A0,
        0x000024A0
    };

    static Char _decompositionMapping000024A1[] = 
    {
        0x00000028,
        0x00000066,
        0x00000029
    };

    static _CharacterInfo _character000024A1 =
    {
        0x000024A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A1,
        0x000024A1,
        0x000024A1
    };

    static Char _decompositionMapping000024A2[] = 
    {
        0x00000028,
        0x00000067,
        0x00000029
    };

    static _CharacterInfo _character000024A2 =
    {
        0x000024A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A2,
        0x000024A2,
        0x000024A2
    };

    static Char _decompositionMapping000024A3[] = 
    {
        0x00000028,
        0x00000068,
        0x00000029
    };

    static _CharacterInfo _character000024A3 =
    {
        0x000024A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A3,
        0x000024A3,
        0x000024A3
    };

    static Char _decompositionMapping000024A4[] = 
    {
        0x00000028,
        0x00000069,
        0x00000029
    };

    static _CharacterInfo _character000024A4 =
    {
        0x000024A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A4,
        0x000024A4,
        0x000024A4
    };

    static Char _decompositionMapping000024A5[] = 
    {
        0x00000028,
        0x0000006A,
        0x00000029
    };

    static _CharacterInfo _character000024A5 =
    {
        0x000024A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A5,
        0x000024A5,
        0x000024A5
    };

    static Char _decompositionMapping000024A6[] = 
    {
        0x00000028,
        0x0000006B,
        0x00000029
    };

    static _CharacterInfo _character000024A6 =
    {
        0x000024A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A6,
        0x000024A6,
        0x000024A6
    };

    static Char _decompositionMapping000024A7[] = 
    {
        0x00000028,
        0x0000006C,
        0x00000029
    };

    static _CharacterInfo _character000024A7 =
    {
        0x000024A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A7,
        0x000024A7,
        0x000024A7
    };

    static Char _decompositionMapping000024A8[] = 
    {
        0x00000028,
        0x0000006D,
        0x00000029
    };

    static _CharacterInfo _character000024A8 =
    {
        0x000024A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A8,
        0x000024A8,
        0x000024A8
    };

    static Char _decompositionMapping000024A9[] = 
    {
        0x00000028,
        0x0000006E,
        0x00000029
    };

    static _CharacterInfo _character000024A9 =
    {
        0x000024A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024A9,
        0x000024A9,
        0x000024A9
    };

    static Char _decompositionMapping000024AA[] = 
    {
        0x00000028,
        0x0000006F,
        0x00000029
    };

    static _CharacterInfo _character000024AA =
    {
        0x000024AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AA,
        0x000024AA,
        0x000024AA
    };

    static Char _decompositionMapping000024AB[] = 
    {
        0x00000028,
        0x00000070,
        0x00000029
    };

    static _CharacterInfo _character000024AB =
    {
        0x000024AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AB,
        0x000024AB,
        0x000024AB
    };

    static Char _decompositionMapping000024AC[] = 
    {
        0x00000028,
        0x00000071,
        0x00000029
    };

    static _CharacterInfo _character000024AC =
    {
        0x000024AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AC,
        0x000024AC,
        0x000024AC
    };

    static Char _decompositionMapping000024AD[] = 
    {
        0x00000028,
        0x00000072,
        0x00000029
    };

    static _CharacterInfo _character000024AD =
    {
        0x000024AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AD,
        0x000024AD,
        0x000024AD
    };

    static Char _decompositionMapping000024AE[] = 
    {
        0x00000028,
        0x00000073,
        0x00000029
    };

    static _CharacterInfo _character000024AE =
    {
        0x000024AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AE,
        0x000024AE,
        0x000024AE
    };

    static Char _decompositionMapping000024AF[] = 
    {
        0x00000028,
        0x00000074,
        0x00000029
    };

    static _CharacterInfo _character000024AF =
    {
        0x000024AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024AF,
        0x000024AF,
        0x000024AF
    };

    static Char _decompositionMapping000024B0[] = 
    {
        0x00000028,
        0x00000075,
        0x00000029
    };

    static _CharacterInfo _character000024B0 =
    {
        0x000024B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B0,
        0x000024B0,
        0x000024B0
    };

    static Char _decompositionMapping000024B1[] = 
    {
        0x00000028,
        0x00000076,
        0x00000029
    };

    static _CharacterInfo _character000024B1 =
    {
        0x000024B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B1,
        0x000024B1,
        0x000024B1
    };

    static Char _decompositionMapping000024B2[] = 
    {
        0x00000028,
        0x00000077,
        0x00000029
    };

    static _CharacterInfo _character000024B2 =
    {
        0x000024B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B2,
        0x000024B2,
        0x000024B2
    };

    static Char _decompositionMapping000024B3[] = 
    {
        0x00000028,
        0x00000078,
        0x00000029
    };

    static _CharacterInfo _character000024B3 =
    {
        0x000024B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B3,
        0x000024B3,
        0x000024B3
    };

    static Char _decompositionMapping000024B4[] = 
    {
        0x00000028,
        0x00000079,
        0x00000029
    };

    static _CharacterInfo _character000024B4 =
    {
        0x000024B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B4,
        0x000024B4,
        0x000024B4
    };

    static Char _decompositionMapping000024B5[] = 
    {
        0x00000028,
        0x0000007A,
        0x00000029
    };

    static _CharacterInfo _character000024B5 =
    {
        0x000024B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000024B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B5,
        0x000024B5,
        0x000024B5
    };

    static Char _decompositionMapping000024B6[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character000024B6 =
    {
        0x000024B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B6,
        0x000024D0,
        0x000024B6
    };

    static Char _decompositionMapping000024B7[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character000024B7 =
    {
        0x000024B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B7,
        0x000024D1,
        0x000024B7
    };

    static Char _decompositionMapping000024B8[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character000024B8 =
    {
        0x000024B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B8,
        0x000024D2,
        0x000024B8
    };

    static Char _decompositionMapping000024B9[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character000024B9 =
    {
        0x000024B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B9,
        0x000024D3,
        0x000024B9
    };

    static Char _decompositionMapping000024BA[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character000024BA =
    {
        0x000024BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BA,
        0x000024D4,
        0x000024BA
    };

    static Char _decompositionMapping000024BB[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character000024BB =
    {
        0x000024BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BB,
        0x000024D5,
        0x000024BB
    };

    static Char _decompositionMapping000024BC[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character000024BC =
    {
        0x000024BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BC,
        0x000024D6,
        0x000024BC
    };

    static Char _decompositionMapping000024BD[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character000024BD =
    {
        0x000024BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BD,
        0x000024D7,
        0x000024BD
    };

    static Char _decompositionMapping000024BE[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character000024BE =
    {
        0x000024BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BE,
        0x000024D8,
        0x000024BE
    };

    static Char _decompositionMapping000024BF[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character000024BF =
    {
        0x000024BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BF,
        0x000024D9,
        0x000024BF
    };

    static Char _decompositionMapping000024C0[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character000024C0 =
    {
        0x000024C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C0,
        0x000024DA,
        0x000024C0
    };

    static Char _decompositionMapping000024C1[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character000024C1 =
    {
        0x000024C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C1,
        0x000024DB,
        0x000024C1
    };

    static Char _decompositionMapping000024C2[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character000024C2 =
    {
        0x000024C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C2,
        0x000024DC,
        0x000024C2
    };

    static Char _decompositionMapping000024C3[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character000024C3 =
    {
        0x000024C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C3,
        0x000024DD,
        0x000024C3
    };

    static Char _decompositionMapping000024C4[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character000024C4 =
    {
        0x000024C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C4,
        0x000024DE,
        0x000024C4
    };

    static Char _decompositionMapping000024C5[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character000024C5 =
    {
        0x000024C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C5,
        0x000024DF,
        0x000024C5
    };

    static Char _decompositionMapping000024C6[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character000024C6 =
    {
        0x000024C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C6,
        0x000024E0,
        0x000024C6
    };

    static Char _decompositionMapping000024C7[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character000024C7 =
    {
        0x000024C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C7,
        0x000024E1,
        0x000024C7
    };

    static Char _decompositionMapping000024C8[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character000024C8 =
    {
        0x000024C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C8,
        0x000024E2,
        0x000024C8
    };

    static Char _decompositionMapping000024C9[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character000024C9 =
    {
        0x000024C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C9,
        0x000024E3,
        0x000024C9
    };

    static Char _decompositionMapping000024CA[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character000024CA =
    {
        0x000024CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CA,
        0x000024E4,
        0x000024CA
    };

    static Char _decompositionMapping000024CB[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character000024CB =
    {
        0x000024CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CB,
        0x000024E5,
        0x000024CB
    };

    static Char _decompositionMapping000024CC[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character000024CC =
    {
        0x000024CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CC,
        0x000024E6,
        0x000024CC
    };

    static Char _decompositionMapping000024CD[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character000024CD =
    {
        0x000024CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CD,
        0x000024E7,
        0x000024CD
    };

    static Char _decompositionMapping000024CE[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character000024CE =
    {
        0x000024CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CE,
        0x000024E8,
        0x000024CE
    };

    static Char _decompositionMapping000024CF[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character000024CF =
    {
        0x000024CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CF,
        0x000024E9,
        0x000024CF
    };

    static Char _decompositionMapping000024D0[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character000024D0 =
    {
        0x000024D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B6,
        0x000024D0,
        0x000024B6
    };

    static Char _decompositionMapping000024D1[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character000024D1 =
    {
        0x000024D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B7,
        0x000024D1,
        0x000024B7
    };

    static Char _decompositionMapping000024D2[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character000024D2 =
    {
        0x000024D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B8,
        0x000024D2,
        0x000024B8
    };

    static Char _decompositionMapping000024D3[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character000024D3 =
    {
        0x000024D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024B9,
        0x000024D3,
        0x000024B9
    };

    static Char _decompositionMapping000024D4[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character000024D4 =
    {
        0x000024D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BA,
        0x000024D4,
        0x000024BA
    };

    static Char _decompositionMapping000024D5[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character000024D5 =
    {
        0x000024D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BB,
        0x000024D5,
        0x000024BB
    };

    static Char _decompositionMapping000024D6[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character000024D6 =
    {
        0x000024D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BC,
        0x000024D6,
        0x000024BC
    };

    static Char _decompositionMapping000024D7[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character000024D7 =
    {
        0x000024D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BD,
        0x000024D7,
        0x000024BD
    };

    static Char _decompositionMapping000024D8[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character000024D8 =
    {
        0x000024D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BE,
        0x000024D8,
        0x000024BE
    };

    static Char _decompositionMapping000024D9[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character000024D9 =
    {
        0x000024D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024BF,
        0x000024D9,
        0x000024BF
    };

    static Char _decompositionMapping000024DA[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character000024DA =
    {
        0x000024DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C0,
        0x000024DA,
        0x000024C0
    };

    static Char _decompositionMapping000024DB[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character000024DB =
    {
        0x000024DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C1,
        0x000024DB,
        0x000024C1
    };

    static Char _decompositionMapping000024DC[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character000024DC =
    {
        0x000024DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C2,
        0x000024DC,
        0x000024C2
    };

    static Char _decompositionMapping000024DD[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character000024DD =
    {
        0x000024DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C3,
        0x000024DD,
        0x000024C3
    };

    static Char _decompositionMapping000024DE[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character000024DE =
    {
        0x000024DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C4,
        0x000024DE,
        0x000024C4
    };

    static Char _decompositionMapping000024DF[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character000024DF =
    {
        0x000024DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C5,
        0x000024DF,
        0x000024C5
    };

    static Char _decompositionMapping000024E0[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character000024E0 =
    {
        0x000024E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C6,
        0x000024E0,
        0x000024C6
    };

    static Char _decompositionMapping000024E1[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character000024E1 =
    {
        0x000024E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C7,
        0x000024E1,
        0x000024C7
    };

    static Char _decompositionMapping000024E2[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character000024E2 =
    {
        0x000024E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C8,
        0x000024E2,
        0x000024C8
    };

    static Char _decompositionMapping000024E3[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character000024E3 =
    {
        0x000024E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024C9,
        0x000024E3,
        0x000024C9
    };

    static Char _decompositionMapping000024E4[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character000024E4 =
    {
        0x000024E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CA,
        0x000024E4,
        0x000024CA
    };

    static Char _decompositionMapping000024E5[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character000024E5 =
    {
        0x000024E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CB,
        0x000024E5,
        0x000024CB
    };

    static Char _decompositionMapping000024E6[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character000024E6 =
    {
        0x000024E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CC,
        0x000024E6,
        0x000024CC
    };

    static Char _decompositionMapping000024E7[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character000024E7 =
    {
        0x000024E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CD,
        0x000024E7,
        0x000024CD
    };

    static Char _decompositionMapping000024E8[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character000024E8 =
    {
        0x000024E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CE,
        0x000024E8,
        0x000024CE
    };

    static Char _decompositionMapping000024E9[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character000024E9 =
    {
        0x000024E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000024CF,
        0x000024E9,
        0x000024CF
    };

    static Char _decompositionMapping000024EA[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character000024EA =
    {
        0x000024EA,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000024EA,
        false,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000024EA,
        0x000024EA,
        0x000024EA
    };

    static _CharacterInfo _character000024EB =
    {
        0x000024EB,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        11,
        1,
        false,
        0x000024EB,
        0x000024EB,
        0x000024EB
    };

    static _CharacterInfo _character000024EC =
    {
        0x000024EC,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        12,
        1,
        false,
        0x000024EC,
        0x000024EC,
        0x000024EC
    };

    static _CharacterInfo _character000024ED =
    {
        0x000024ED,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        13,
        1,
        false,
        0x000024ED,
        0x000024ED,
        0x000024ED
    };

    static _CharacterInfo _character000024EE =
    {
        0x000024EE,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        14,
        1,
        false,
        0x000024EE,
        0x000024EE,
        0x000024EE
    };

    static _CharacterInfo _character000024EF =
    {
        0x000024EF,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        15,
        1,
        false,
        0x000024EF,
        0x000024EF,
        0x000024EF
    };

    static _CharacterInfo _character000024F0 =
    {
        0x000024F0,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        16,
        1,
        false,
        0x000024F0,
        0x000024F0,
        0x000024F0
    };

    static _CharacterInfo _character000024F1 =
    {
        0x000024F1,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        17,
        1,
        false,
        0x000024F1,
        0x000024F1,
        0x000024F1
    };

    static _CharacterInfo _character000024F2 =
    {
        0x000024F2,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        18,
        1,
        false,
        0x000024F2,
        0x000024F2,
        0x000024F2
    };

    static _CharacterInfo _character000024F3 =
    {
        0x000024F3,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        19,
        1,
        false,
        0x000024F3,
        0x000024F3,
        0x000024F3
    };

    static _CharacterInfo _character000024F4 =
    {
        0x000024F4,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x000024F4,
        0x000024F4,
        0x000024F4
    };

    static _CharacterInfo _character000024F5 =
    {
        0x000024F5,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000024F5,
        0x000024F5,
        0x000024F5
    };

    static _CharacterInfo _character000024F6 =
    {
        0x000024F6,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000024F6,
        0x000024F6,
        0x000024F6
    };

    static _CharacterInfo _character000024F7 =
    {
        0x000024F7,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000024F7,
        0x000024F7,
        0x000024F7
    };

    static _CharacterInfo _character000024F8 =
    {
        0x000024F8,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000024F8,
        0x000024F8,
        0x000024F8
    };

    static _CharacterInfo _character000024F9 =
    {
        0x000024F9,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000024F9,
        0x000024F9,
        0x000024F9
    };

    static _CharacterInfo _character000024FA =
    {
        0x000024FA,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000024FA,
        0x000024FA,
        0x000024FA
    };

    static _CharacterInfo _character000024FB =
    {
        0x000024FB,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000024FB,
        0x000024FB,
        0x000024FB
    };

    static _CharacterInfo _character000024FC =
    {
        0x000024FC,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000024FC,
        0x000024FC,
        0x000024FC
    };

    static _CharacterInfo _character000024FD =
    {
        0x000024FD,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000024FD,
        0x000024FD,
        0x000024FD
    };

    static _CharacterInfo _character000024FE =
    {
        0x000024FE,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x000024FE,
        0x000024FE,
        0x000024FE
    };

    static _CharacterInfo _character000024FF =
    {
        0x000024FF,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000024FF,
        0x000024FF,
        0x000024FF
    };

    static _CharacterInfo _character00002500 =
    {
        0x00002500,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002500,
        0x00002500,
        0x00002500
    };

    static _CharacterInfo _character00002501 =
    {
        0x00002501,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002501,
        0x00002501,
        0x00002501
    };

    static _CharacterInfo _character00002502 =
    {
        0x00002502,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002502,
        0x00002502,
        0x00002502
    };

    static _CharacterInfo _character00002503 =
    {
        0x00002503,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002503,
        0x00002503,
        0x00002503
    };

    static _CharacterInfo _character00002504 =
    {
        0x00002504,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002504,
        0x00002504,
        0x00002504
    };

    static _CharacterInfo _character00002505 =
    {
        0x00002505,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002505,
        0x00002505,
        0x00002505
    };

    static _CharacterInfo _character00002506 =
    {
        0x00002506,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002506,
        0x00002506,
        0x00002506
    };

    static _CharacterInfo _character00002507 =
    {
        0x00002507,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002507,
        0x00002507,
        0x00002507
    };

    static _CharacterInfo _character00002508 =
    {
        0x00002508,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002508,
        0x00002508,
        0x00002508
    };

    static _CharacterInfo _character00002509 =
    {
        0x00002509,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002509,
        0x00002509,
        0x00002509
    };

    static _CharacterInfo _character0000250A =
    {
        0x0000250A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250A,
        0x0000250A,
        0x0000250A
    };

    static _CharacterInfo _character0000250B =
    {
        0x0000250B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250B,
        0x0000250B,
        0x0000250B
    };

    static _CharacterInfo _character0000250C =
    {
        0x0000250C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250C,
        0x0000250C,
        0x0000250C
    };

    static _CharacterInfo _character0000250D =
    {
        0x0000250D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250D,
        0x0000250D,
        0x0000250D
    };

    static _CharacterInfo _character0000250E =
    {
        0x0000250E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250E,
        0x0000250E,
        0x0000250E
    };

    static _CharacterInfo _character0000250F =
    {
        0x0000250F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000250F,
        0x0000250F,
        0x0000250F
    };

    static _CharacterInfo _character00002510 =
    {
        0x00002510,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002510,
        0x00002510,
        0x00002510
    };

    static _CharacterInfo _character00002511 =
    {
        0x00002511,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002511,
        0x00002511,
        0x00002511
    };

    static _CharacterInfo _character00002512 =
    {
        0x00002512,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002512,
        0x00002512,
        0x00002512
    };

    static _CharacterInfo _character00002513 =
    {
        0x00002513,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002513,
        0x00002513,
        0x00002513
    };

    static _CharacterInfo _character00002514 =
    {
        0x00002514,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002514,
        0x00002514,
        0x00002514
    };

    static _CharacterInfo _character00002515 =
    {
        0x00002515,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002515,
        0x00002515,
        0x00002515
    };

    static _CharacterInfo _character00002516 =
    {
        0x00002516,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002516,
        0x00002516,
        0x00002516
    };

    static _CharacterInfo _character00002517 =
    {
        0x00002517,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002517,
        0x00002517,
        0x00002517
    };

    static _CharacterInfo _character00002518 =
    {
        0x00002518,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002518,
        0x00002518,
        0x00002518
    };

    static _CharacterInfo _character00002519 =
    {
        0x00002519,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002519,
        0x00002519,
        0x00002519
    };

    static _CharacterInfo _character0000251A =
    {
        0x0000251A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251A,
        0x0000251A,
        0x0000251A
    };

    static _CharacterInfo _character0000251B =
    {
        0x0000251B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251B,
        0x0000251B,
        0x0000251B
    };

    static _CharacterInfo _character0000251C =
    {
        0x0000251C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251C,
        0x0000251C,
        0x0000251C
    };

    static _CharacterInfo _character0000251D =
    {
        0x0000251D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251D,
        0x0000251D,
        0x0000251D
    };

    static _CharacterInfo _character0000251E =
    {
        0x0000251E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251E,
        0x0000251E,
        0x0000251E
    };

    static _CharacterInfo _character0000251F =
    {
        0x0000251F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000251F,
        0x0000251F,
        0x0000251F
    };

    static _CharacterInfo _character00002520 =
    {
        0x00002520,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002520,
        0x00002520,
        0x00002520
    };

    static _CharacterInfo _character00002521 =
    {
        0x00002521,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002521,
        0x00002521,
        0x00002521
    };

    static _CharacterInfo _character00002522 =
    {
        0x00002522,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002522,
        0x00002522,
        0x00002522
    };

    static _CharacterInfo _character00002523 =
    {
        0x00002523,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002523,
        0x00002523,
        0x00002523
    };

    static _CharacterInfo _character00002524 =
    {
        0x00002524,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002524,
        0x00002524,
        0x00002524
    };

    static _CharacterInfo _character00002525 =
    {
        0x00002525,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002525,
        0x00002525,
        0x00002525
    };

    static _CharacterInfo _character00002526 =
    {
        0x00002526,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002526,
        0x00002526,
        0x00002526
    };

    static _CharacterInfo _character00002527 =
    {
        0x00002527,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002527,
        0x00002527,
        0x00002527
    };

    static _CharacterInfo _character00002528 =
    {
        0x00002528,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002528,
        0x00002528,
        0x00002528
    };

    static _CharacterInfo _character00002529 =
    {
        0x00002529,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002529,
        0x00002529,
        0x00002529
    };

    static _CharacterInfo _character0000252A =
    {
        0x0000252A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252A,
        0x0000252A,
        0x0000252A
    };

    static _CharacterInfo _character0000252B =
    {
        0x0000252B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252B,
        0x0000252B,
        0x0000252B
    };

    static _CharacterInfo _character0000252C =
    {
        0x0000252C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252C,
        0x0000252C,
        0x0000252C
    };

    static _CharacterInfo _character0000252D =
    {
        0x0000252D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252D,
        0x0000252D,
        0x0000252D
    };

    static _CharacterInfo _character0000252E =
    {
        0x0000252E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252E,
        0x0000252E,
        0x0000252E
    };

    static _CharacterInfo _character0000252F =
    {
        0x0000252F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000252F,
        0x0000252F,
        0x0000252F
    };

    static _CharacterInfo _character00002530 =
    {
        0x00002530,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002530,
        0x00002530,
        0x00002530
    };

    static _CharacterInfo _character00002531 =
    {
        0x00002531,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002531,
        0x00002531,
        0x00002531
    };

    static _CharacterInfo _character00002532 =
    {
        0x00002532,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002532,
        0x00002532,
        0x00002532
    };

    static _CharacterInfo _character00002533 =
    {
        0x00002533,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002533,
        0x00002533,
        0x00002533
    };

    static _CharacterInfo _character00002534 =
    {
        0x00002534,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002534,
        0x00002534,
        0x00002534
    };

    static _CharacterInfo _character00002535 =
    {
        0x00002535,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002535,
        0x00002535,
        0x00002535
    };

    static _CharacterInfo _character00002536 =
    {
        0x00002536,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002536,
        0x00002536,
        0x00002536
    };

    static _CharacterInfo _character00002537 =
    {
        0x00002537,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002537,
        0x00002537,
        0x00002537
    };

    static _CharacterInfo _character00002538 =
    {
        0x00002538,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002538,
        0x00002538,
        0x00002538
    };

    static _CharacterInfo _character00002539 =
    {
        0x00002539,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002539,
        0x00002539,
        0x00002539
    };

    static _CharacterInfo _character0000253A =
    {
        0x0000253A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253A,
        0x0000253A,
        0x0000253A
    };

    static _CharacterInfo _character0000253B =
    {
        0x0000253B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253B,
        0x0000253B,
        0x0000253B
    };

    static _CharacterInfo _character0000253C =
    {
        0x0000253C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253C,
        0x0000253C,
        0x0000253C
    };

    static _CharacterInfo _character0000253D =
    {
        0x0000253D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253D,
        0x0000253D,
        0x0000253D
    };

    static _CharacterInfo _character0000253E =
    {
        0x0000253E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253E,
        0x0000253E,
        0x0000253E
    };

    static _CharacterInfo _character0000253F =
    {
        0x0000253F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000253F,
        0x0000253F,
        0x0000253F
    };

    static _CharacterInfo _character00002540 =
    {
        0x00002540,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002540,
        0x00002540,
        0x00002540
    };

    static _CharacterInfo _character00002541 =
    {
        0x00002541,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002541,
        0x00002541,
        0x00002541
    };

    static _CharacterInfo _character00002542 =
    {
        0x00002542,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002542,
        0x00002542,
        0x00002542
    };

    static _CharacterInfo _character00002543 =
    {
        0x00002543,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002543,
        0x00002543,
        0x00002543
    };

    static _CharacterInfo _character00002544 =
    {
        0x00002544,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002544,
        0x00002544,
        0x00002544
    };

    static _CharacterInfo _character00002545 =
    {
        0x00002545,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002545,
        0x00002545,
        0x00002545
    };

    static _CharacterInfo _character00002546 =
    {
        0x00002546,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002546,
        0x00002546,
        0x00002546
    };

    static _CharacterInfo _character00002547 =
    {
        0x00002547,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002547,
        0x00002547,
        0x00002547
    };

    static _CharacterInfo _character00002548 =
    {
        0x00002548,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002548,
        0x00002548,
        0x00002548
    };

    static _CharacterInfo _character00002549 =
    {
        0x00002549,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002549,
        0x00002549,
        0x00002549
    };

    static _CharacterInfo _character0000254A =
    {
        0x0000254A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254A,
        0x0000254A,
        0x0000254A
    };

    static _CharacterInfo _character0000254B =
    {
        0x0000254B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254B,
        0x0000254B,
        0x0000254B
    };

    static _CharacterInfo _character0000254C =
    {
        0x0000254C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254C,
        0x0000254C,
        0x0000254C
    };

    static _CharacterInfo _character0000254D =
    {
        0x0000254D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254D,
        0x0000254D,
        0x0000254D
    };

    static _CharacterInfo _character0000254E =
    {
        0x0000254E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254E,
        0x0000254E,
        0x0000254E
    };

    static _CharacterInfo _character0000254F =
    {
        0x0000254F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000254F,
        0x0000254F,
        0x0000254F
    };

    static _CharacterInfo _character00002550 =
    {
        0x00002550,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002550,
        0x00002550,
        0x00002550
    };

    static _CharacterInfo _character00002551 =
    {
        0x00002551,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002551,
        0x00002551,
        0x00002551
    };

    static _CharacterInfo _character00002552 =
    {
        0x00002552,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002552,
        0x00002552,
        0x00002552
    };

    static _CharacterInfo _character00002553 =
    {
        0x00002553,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002553,
        0x00002553,
        0x00002553
    };

    static _CharacterInfo _character00002554 =
    {
        0x00002554,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002554,
        0x00002554,
        0x00002554
    };

    static _CharacterInfo _character00002555 =
    {
        0x00002555,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002555,
        0x00002555,
        0x00002555
    };

    static _CharacterInfo _character00002556 =
    {
        0x00002556,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002556,
        0x00002556,
        0x00002556
    };

    static _CharacterInfo _character00002557 =
    {
        0x00002557,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002557,
        0x00002557,
        0x00002557
    };

    static _CharacterInfo _character00002558 =
    {
        0x00002558,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002558,
        0x00002558,
        0x00002558
    };

    static _CharacterInfo _character00002559 =
    {
        0x00002559,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002559,
        0x00002559,
        0x00002559
    };

    static _CharacterInfo _character0000255A =
    {
        0x0000255A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255A,
        0x0000255A,
        0x0000255A
    };

    static _CharacterInfo _character0000255B =
    {
        0x0000255B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255B,
        0x0000255B,
        0x0000255B
    };

    static _CharacterInfo _character0000255C =
    {
        0x0000255C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255C,
        0x0000255C,
        0x0000255C
    };

    static _CharacterInfo _character0000255D =
    {
        0x0000255D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255D,
        0x0000255D,
        0x0000255D
    };

    static _CharacterInfo _character0000255E =
    {
        0x0000255E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255E,
        0x0000255E,
        0x0000255E
    };

    static _CharacterInfo _character0000255F =
    {
        0x0000255F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000255F,
        0x0000255F,
        0x0000255F
    };

    static _CharacterInfo _character00002560 =
    {
        0x00002560,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002560,
        0x00002560,
        0x00002560
    };

    static _CharacterInfo _character00002561 =
    {
        0x00002561,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002561,
        0x00002561,
        0x00002561
    };

    static _CharacterInfo _character00002562 =
    {
        0x00002562,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002562,
        0x00002562,
        0x00002562
    };

    static _CharacterInfo _character00002563 =
    {
        0x00002563,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002563,
        0x00002563,
        0x00002563
    };

    static _CharacterInfo _character00002564 =
    {
        0x00002564,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002564,
        0x00002564,
        0x00002564
    };

    static _CharacterInfo _character00002565 =
    {
        0x00002565,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002565,
        0x00002565,
        0x00002565
    };

    static _CharacterInfo _character00002566 =
    {
        0x00002566,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002566,
        0x00002566,
        0x00002566
    };

    static _CharacterInfo _character00002567 =
    {
        0x00002567,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002567,
        0x00002567,
        0x00002567
    };

    static _CharacterInfo _character00002568 =
    {
        0x00002568,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002568,
        0x00002568,
        0x00002568
    };

    static _CharacterInfo _character00002569 =
    {
        0x00002569,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002569,
        0x00002569,
        0x00002569
    };

    static _CharacterInfo _character0000256A =
    {
        0x0000256A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256A,
        0x0000256A,
        0x0000256A
    };

    static _CharacterInfo _character0000256B =
    {
        0x0000256B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256B,
        0x0000256B,
        0x0000256B
    };

    static _CharacterInfo _character0000256C =
    {
        0x0000256C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256C,
        0x0000256C,
        0x0000256C
    };

    static _CharacterInfo _character0000256D =
    {
        0x0000256D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256D,
        0x0000256D,
        0x0000256D
    };

    static _CharacterInfo _character0000256E =
    {
        0x0000256E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256E,
        0x0000256E,
        0x0000256E
    };

    static _CharacterInfo _character0000256F =
    {
        0x0000256F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000256F,
        0x0000256F,
        0x0000256F
    };

    static _CharacterInfo _character00002570 =
    {
        0x00002570,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002570,
        0x00002570,
        0x00002570
    };

    static _CharacterInfo _character00002571 =
    {
        0x00002571,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002571,
        0x00002571,
        0x00002571
    };

    static _CharacterInfo _character00002572 =
    {
        0x00002572,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002572,
        0x00002572,
        0x00002572
    };

    static _CharacterInfo _character00002573 =
    {
        0x00002573,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002573,
        0x00002573,
        0x00002573
    };

    static _CharacterInfo _character00002574 =
    {
        0x00002574,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002574,
        0x00002574,
        0x00002574
    };

    static _CharacterInfo _character00002575 =
    {
        0x00002575,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002575,
        0x00002575,
        0x00002575
    };

    static _CharacterInfo _character00002576 =
    {
        0x00002576,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002576,
        0x00002576,
        0x00002576
    };

    static _CharacterInfo _character00002577 =
    {
        0x00002577,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002577,
        0x00002577,
        0x00002577
    };

    static _CharacterInfo _character00002578 =
    {
        0x00002578,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002578,
        0x00002578,
        0x00002578
    };

    static _CharacterInfo _character00002579 =
    {
        0x00002579,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002579,
        0x00002579,
        0x00002579
    };

    static _CharacterInfo _character0000257A =
    {
        0x0000257A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257A,
        0x0000257A,
        0x0000257A
    };

    static _CharacterInfo _character0000257B =
    {
        0x0000257B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257B,
        0x0000257B,
        0x0000257B
    };

    static _CharacterInfo _character0000257C =
    {
        0x0000257C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257C,
        0x0000257C,
        0x0000257C
    };

    static _CharacterInfo _character0000257D =
    {
        0x0000257D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257D,
        0x0000257D,
        0x0000257D
    };

    static _CharacterInfo _character0000257E =
    {
        0x0000257E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257E,
        0x0000257E,
        0x0000257E
    };

    static _CharacterInfo _character0000257F =
    {
        0x0000257F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000257F,
        0x0000257F,
        0x0000257F
    };

    static _CharacterInfo _character00002580 =
    {
        0x00002580,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002580,
        0x00002580,
        0x00002580
    };

    static _CharacterInfo _character00002581 =
    {
        0x00002581,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002581,
        0x00002581,
        0x00002581
    };

    static _CharacterInfo _character00002582 =
    {
        0x00002582,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002582,
        0x00002582,
        0x00002582
    };

    static _CharacterInfo _character00002583 =
    {
        0x00002583,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002583,
        0x00002583,
        0x00002583
    };

    static _CharacterInfo _character00002584 =
    {
        0x00002584,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002584,
        0x00002584,
        0x00002584
    };

    static _CharacterInfo _character00002585 =
    {
        0x00002585,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002585,
        0x00002585,
        0x00002585
    };

    static _CharacterInfo _character00002586 =
    {
        0x00002586,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002586,
        0x00002586,
        0x00002586
    };

    static _CharacterInfo _character00002587 =
    {
        0x00002587,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002587,
        0x00002587,
        0x00002587
    };

    static _CharacterInfo _character00002588 =
    {
        0x00002588,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002588,
        0x00002588,
        0x00002588
    };

    static _CharacterInfo _character00002589 =
    {
        0x00002589,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002589,
        0x00002589,
        0x00002589
    };

    static _CharacterInfo _character0000258A =
    {
        0x0000258A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258A,
        0x0000258A,
        0x0000258A
    };

    static _CharacterInfo _character0000258B =
    {
        0x0000258B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258B,
        0x0000258B,
        0x0000258B
    };

    static _CharacterInfo _character0000258C =
    {
        0x0000258C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258C,
        0x0000258C,
        0x0000258C
    };

    static _CharacterInfo _character0000258D =
    {
        0x0000258D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258D,
        0x0000258D,
        0x0000258D
    };

    static _CharacterInfo _character0000258E =
    {
        0x0000258E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258E,
        0x0000258E,
        0x0000258E
    };

    static _CharacterInfo _character0000258F =
    {
        0x0000258F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000258F,
        0x0000258F,
        0x0000258F
    };

    static _CharacterInfo _character00002590 =
    {
        0x00002590,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002590,
        0x00002590,
        0x00002590
    };

    static _CharacterInfo _character00002591 =
    {
        0x00002591,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002591,
        0x00002591,
        0x00002591
    };

    static _CharacterInfo _character00002592 =
    {
        0x00002592,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002592,
        0x00002592,
        0x00002592
    };

    static _CharacterInfo _character00002593 =
    {
        0x00002593,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002593,
        0x00002593,
        0x00002593
    };

    static _CharacterInfo _character00002594 =
    {
        0x00002594,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002594,
        0x00002594,
        0x00002594
    };

    static _CharacterInfo _character00002595 =
    {
        0x00002595,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002595,
        0x00002595,
        0x00002595
    };

    static _CharacterInfo _character00002596 =
    {
        0x00002596,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002596,
        0x00002596,
        0x00002596
    };

    static _CharacterInfo _character00002597 =
    {
        0x00002597,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002597,
        0x00002597,
        0x00002597
    };

    static _CharacterInfo _character00002598 =
    {
        0x00002598,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002598,
        0x00002598,
        0x00002598
    };

    static _CharacterInfo _character00002599 =
    {
        0x00002599,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002599,
        0x00002599,
        0x00002599
    };

    static _CharacterInfo _character0000259A =
    {
        0x0000259A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259A,
        0x0000259A,
        0x0000259A
    };

    static _CharacterInfo _character0000259B =
    {
        0x0000259B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259B,
        0x0000259B,
        0x0000259B
    };

    static _CharacterInfo _character0000259C =
    {
        0x0000259C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259C,
        0x0000259C,
        0x0000259C
    };

    static _CharacterInfo _character0000259D =
    {
        0x0000259D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259D,
        0x0000259D,
        0x0000259D
    };

    static _CharacterInfo _character0000259E =
    {
        0x0000259E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259E,
        0x0000259E,
        0x0000259E
    };

    static _CharacterInfo _character0000259F =
    {
        0x0000259F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000259F,
        0x0000259F,
        0x0000259F
    };

    static _CharacterInfo _character000025A0 =
    {
        0x000025A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A0,
        0x000025A0,
        0x000025A0
    };

    static _CharacterInfo _character000025A1 =
    {
        0x000025A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A1,
        0x000025A1,
        0x000025A1
    };

    static _CharacterInfo _character000025A2 =
    {
        0x000025A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A2,
        0x000025A2,
        0x000025A2
    };

    static _CharacterInfo _character000025A3 =
    {
        0x000025A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A3,
        0x000025A3,
        0x000025A3
    };

    static _CharacterInfo _character000025A4 =
    {
        0x000025A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A4,
        0x000025A4,
        0x000025A4
    };

    static _CharacterInfo _character000025A5 =
    {
        0x000025A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A5,
        0x000025A5,
        0x000025A5
    };

    static _CharacterInfo _character000025A6 =
    {
        0x000025A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A6,
        0x000025A6,
        0x000025A6
    };

    static _CharacterInfo _character000025A7 =
    {
        0x000025A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A7,
        0x000025A7,
        0x000025A7
    };

    static _CharacterInfo _character000025A8 =
    {
        0x000025A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A8,
        0x000025A8,
        0x000025A8
    };

    static _CharacterInfo _character000025A9 =
    {
        0x000025A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025A9,
        0x000025A9,
        0x000025A9
    };

    static _CharacterInfo _character000025AA =
    {
        0x000025AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AA,
        0x000025AA,
        0x000025AA
    };

    static _CharacterInfo _character000025AB =
    {
        0x000025AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AB,
        0x000025AB,
        0x000025AB
    };

    static _CharacterInfo _character000025AC =
    {
        0x000025AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AC,
        0x000025AC,
        0x000025AC
    };

    static _CharacterInfo _character000025AD =
    {
        0x000025AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AD,
        0x000025AD,
        0x000025AD
    };

    static _CharacterInfo _character000025AE =
    {
        0x000025AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AE,
        0x000025AE,
        0x000025AE
    };

    static _CharacterInfo _character000025AF =
    {
        0x000025AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025AF,
        0x000025AF,
        0x000025AF
    };

    static _CharacterInfo _character000025B0 =
    {
        0x000025B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B0,
        0x000025B0,
        0x000025B0
    };

    static _CharacterInfo _character000025B1 =
    {
        0x000025B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B1,
        0x000025B1,
        0x000025B1
    };

    static _CharacterInfo _character000025B2 =
    {
        0x000025B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B2,
        0x000025B2,
        0x000025B2
    };

    static _CharacterInfo _character000025B3 =
    {
        0x000025B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B3,
        0x000025B3,
        0x000025B3
    };

    static _CharacterInfo _character000025B4 =
    {
        0x000025B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B4,
        0x000025B4,
        0x000025B4
    };

    static _CharacterInfo _character000025B5 =
    {
        0x000025B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B5,
        0x000025B5,
        0x000025B5
    };

    static _CharacterInfo _character000025B6 =
    {
        0x000025B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B6,
        0x000025B6,
        0x000025B6
    };

    static _CharacterInfo _character000025B7 =
    {
        0x000025B7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B7,
        0x000025B7,
        0x000025B7
    };

    static _CharacterInfo _character000025B8 =
    {
        0x000025B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B8,
        0x000025B8,
        0x000025B8
    };

    static _CharacterInfo _character000025B9 =
    {
        0x000025B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025B9,
        0x000025B9,
        0x000025B9
    };

    static _CharacterInfo _character000025BA =
    {
        0x000025BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BA,
        0x000025BA,
        0x000025BA
    };

    static _CharacterInfo _character000025BB =
    {
        0x000025BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BB,
        0x000025BB,
        0x000025BB
    };

    static _CharacterInfo _character000025BC =
    {
        0x000025BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BC,
        0x000025BC,
        0x000025BC
    };

    static _CharacterInfo _character000025BD =
    {
        0x000025BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BD,
        0x000025BD,
        0x000025BD
    };

    static _CharacterInfo _character000025BE =
    {
        0x000025BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BE,
        0x000025BE,
        0x000025BE
    };

    static _CharacterInfo _character000025BF =
    {
        0x000025BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025BF,
        0x000025BF,
        0x000025BF
    };

    static _CharacterInfo _character000025C0 =
    {
        0x000025C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C0,
        0x000025C0,
        0x000025C0
    };

    static _CharacterInfo _character000025C1 =
    {
        0x000025C1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C1,
        0x000025C1,
        0x000025C1
    };

    static _CharacterInfo _character000025C2 =
    {
        0x000025C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C2,
        0x000025C2,
        0x000025C2
    };

    static _CharacterInfo _character000025C3 =
    {
        0x000025C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C3,
        0x000025C3,
        0x000025C3
    };

    static _CharacterInfo _character000025C4 =
    {
        0x000025C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C4,
        0x000025C4,
        0x000025C4
    };

    static _CharacterInfo _character000025C5 =
    {
        0x000025C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C5,
        0x000025C5,
        0x000025C5
    };

    static _CharacterInfo _character000025C6 =
    {
        0x000025C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C6,
        0x000025C6,
        0x000025C6
    };

    static _CharacterInfo _character000025C7 =
    {
        0x000025C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C7,
        0x000025C7,
        0x000025C7
    };

    static _CharacterInfo _character000025C8 =
    {
        0x000025C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C8,
        0x000025C8,
        0x000025C8
    };

    static _CharacterInfo _character000025C9 =
    {
        0x000025C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025C9,
        0x000025C9,
        0x000025C9
    };

    static _CharacterInfo _character000025CA =
    {
        0x000025CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CA,
        0x000025CA,
        0x000025CA
    };

    static _CharacterInfo _character000025CB =
    {
        0x000025CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CB,
        0x000025CB,
        0x000025CB
    };

    static _CharacterInfo _character000025CC =
    {
        0x000025CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CC,
        0x000025CC,
        0x000025CC
    };

    static _CharacterInfo _character000025CD =
    {
        0x000025CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CD,
        0x000025CD,
        0x000025CD
    };

    static _CharacterInfo _character000025CE =
    {
        0x000025CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CE,
        0x000025CE,
        0x000025CE
    };

    static _CharacterInfo _character000025CF =
    {
        0x000025CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025CF,
        0x000025CF,
        0x000025CF
    };

    static _CharacterInfo _character000025D0 =
    {
        0x000025D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D0,
        0x000025D0,
        0x000025D0
    };

    static _CharacterInfo _character000025D1 =
    {
        0x000025D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D1,
        0x000025D1,
        0x000025D1
    };

    static _CharacterInfo _character000025D2 =
    {
        0x000025D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D2,
        0x000025D2,
        0x000025D2
    };

    static _CharacterInfo _character000025D3 =
    {
        0x000025D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D3,
        0x000025D3,
        0x000025D3
    };

    static _CharacterInfo _character000025D4 =
    {
        0x000025D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D4,
        0x000025D4,
        0x000025D4
    };

    static _CharacterInfo _character000025D5 =
    {
        0x000025D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D5,
        0x000025D5,
        0x000025D5
    };

    static _CharacterInfo _character000025D6 =
    {
        0x000025D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D6,
        0x000025D6,
        0x000025D6
    };

    static _CharacterInfo _character000025D7 =
    {
        0x000025D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D7,
        0x000025D7,
        0x000025D7
    };

    static _CharacterInfo _character000025D8 =
    {
        0x000025D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D8,
        0x000025D8,
        0x000025D8
    };

    static _CharacterInfo _character000025D9 =
    {
        0x000025D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025D9,
        0x000025D9,
        0x000025D9
    };

    static _CharacterInfo _character000025DA =
    {
        0x000025DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DA,
        0x000025DA,
        0x000025DA
    };

    static _CharacterInfo _character000025DB =
    {
        0x000025DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DB,
        0x000025DB,
        0x000025DB
    };

    static _CharacterInfo _character000025DC =
    {
        0x000025DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DC,
        0x000025DC,
        0x000025DC
    };

    static _CharacterInfo _character000025DD =
    {
        0x000025DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DD,
        0x000025DD,
        0x000025DD
    };

    static _CharacterInfo _character000025DE =
    {
        0x000025DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DE,
        0x000025DE,
        0x000025DE
    };

    static _CharacterInfo _character000025DF =
    {
        0x000025DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025DF,
        0x000025DF,
        0x000025DF
    };

    static _CharacterInfo _character000025E0 =
    {
        0x000025E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E0,
        0x000025E0,
        0x000025E0
    };

    static _CharacterInfo _character000025E1 =
    {
        0x000025E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E1,
        0x000025E1,
        0x000025E1
    };

    static _CharacterInfo _character000025E2 =
    {
        0x000025E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E2,
        0x000025E2,
        0x000025E2
    };

    static _CharacterInfo _character000025E3 =
    {
        0x000025E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E3,
        0x000025E3,
        0x000025E3
    };

    static _CharacterInfo _character000025E4 =
    {
        0x000025E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E4,
        0x000025E4,
        0x000025E4
    };

    static _CharacterInfo _character000025E5 =
    {
        0x000025E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E5,
        0x000025E5,
        0x000025E5
    };

    static _CharacterInfo _character000025E6 =
    {
        0x000025E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E6,
        0x000025E6,
        0x000025E6
    };

    static _CharacterInfo _character000025E7 =
    {
        0x000025E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E7,
        0x000025E7,
        0x000025E7
    };

    static _CharacterInfo _character000025E8 =
    {
        0x000025E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E8,
        0x000025E8,
        0x000025E8
    };

    static _CharacterInfo _character000025E9 =
    {
        0x000025E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025E9,
        0x000025E9,
        0x000025E9
    };

    static _CharacterInfo _character000025EA =
    {
        0x000025EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025EA,
        0x000025EA,
        0x000025EA
    };

    static _CharacterInfo _character000025EB =
    {
        0x000025EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025EB,
        0x000025EB,
        0x000025EB
    };

    static _CharacterInfo _character000025EC =
    {
        0x000025EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025EC,
        0x000025EC,
        0x000025EC
    };

    static _CharacterInfo _character000025ED =
    {
        0x000025ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025ED,
        0x000025ED,
        0x000025ED
    };

    static _CharacterInfo _character000025EE =
    {
        0x000025EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025EE,
        0x000025EE,
        0x000025EE
    };

    static _CharacterInfo _character000025EF =
    {
        0x000025EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025EF,
        0x000025EF,
        0x000025EF
    };

    static _CharacterInfo _character000025F0 =
    {
        0x000025F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F0,
        0x000025F0,
        0x000025F0
    };

    static _CharacterInfo _character000025F1 =
    {
        0x000025F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F1,
        0x000025F1,
        0x000025F1
    };

    static _CharacterInfo _character000025F2 =
    {
        0x000025F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F2,
        0x000025F2,
        0x000025F2
    };

    static _CharacterInfo _character000025F3 =
    {
        0x000025F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F3,
        0x000025F3,
        0x000025F3
    };

    static _CharacterInfo _character000025F4 =
    {
        0x000025F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F4,
        0x000025F4,
        0x000025F4
    };

    static _CharacterInfo _character000025F5 =
    {
        0x000025F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F5,
        0x000025F5,
        0x000025F5
    };

    static _CharacterInfo _character000025F6 =
    {
        0x000025F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F6,
        0x000025F6,
        0x000025F6
    };

    static _CharacterInfo _character000025F7 =
    {
        0x000025F7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F7,
        0x000025F7,
        0x000025F7
    };

    static _CharacterInfo _character000025F8 =
    {
        0x000025F8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F8,
        0x000025F8,
        0x000025F8
    };

    static _CharacterInfo _character000025F9 =
    {
        0x000025F9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025F9,
        0x000025F9,
        0x000025F9
    };

    static _CharacterInfo _character000025FA =
    {
        0x000025FA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FA,
        0x000025FA,
        0x000025FA
    };

    static _CharacterInfo _character000025FB =
    {
        0x000025FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FB,
        0x000025FB,
        0x000025FB
    };

    static _CharacterInfo _character000025FC =
    {
        0x000025FC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FC,
        0x000025FC,
        0x000025FC
    };

    static _CharacterInfo _character000025FD =
    {
        0x000025FD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FD,
        0x000025FD,
        0x000025FD
    };

    static _CharacterInfo _character000025FE =
    {
        0x000025FE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FE,
        0x000025FE,
        0x000025FE
    };

    static _CharacterInfo _character000025FF =
    {
        0x000025FF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000025FF,
        0x000025FF,
        0x000025FF
    };

    static _CharacterInfo _character00002600 =
    {
        0x00002600,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002600,
        0x00002600,
        0x00002600
    };

    static _CharacterInfo _character00002601 =
    {
        0x00002601,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002601,
        0x00002601,
        0x00002601
    };

    static _CharacterInfo _character00002602 =
    {
        0x00002602,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002602,
        0x00002602,
        0x00002602
    };

    static _CharacterInfo _character00002603 =
    {
        0x00002603,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002603,
        0x00002603,
        0x00002603
    };

    static _CharacterInfo _character00002604 =
    {
        0x00002604,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002604,
        0x00002604,
        0x00002604
    };

    static _CharacterInfo _character00002605 =
    {
        0x00002605,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002605,
        0x00002605,
        0x00002605
    };

    static _CharacterInfo _character00002606 =
    {
        0x00002606,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002606,
        0x00002606,
        0x00002606
    };

    static _CharacterInfo _character00002607 =
    {
        0x00002607,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002607,
        0x00002607,
        0x00002607
    };

    static _CharacterInfo _character00002608 =
    {
        0x00002608,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002608,
        0x00002608,
        0x00002608
    };

    static _CharacterInfo _character00002609 =
    {
        0x00002609,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002609,
        0x00002609,
        0x00002609
    };

    static _CharacterInfo _character0000260A =
    {
        0x0000260A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260A,
        0x0000260A,
        0x0000260A
    };

    static _CharacterInfo _character0000260B =
    {
        0x0000260B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260B,
        0x0000260B,
        0x0000260B
    };

    static _CharacterInfo _character0000260C =
    {
        0x0000260C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260C,
        0x0000260C,
        0x0000260C
    };

    static _CharacterInfo _character0000260D =
    {
        0x0000260D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260D,
        0x0000260D,
        0x0000260D
    };

    static _CharacterInfo _character0000260E =
    {
        0x0000260E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260E,
        0x0000260E,
        0x0000260E
    };

    static _CharacterInfo _character0000260F =
    {
        0x0000260F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000260F,
        0x0000260F,
        0x0000260F
    };

    static _CharacterInfo _character00002610 =
    {
        0x00002610,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002610,
        0x00002610,
        0x00002610
    };

    static _CharacterInfo _character00002611 =
    {
        0x00002611,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002611,
        0x00002611,
        0x00002611
    };

    static _CharacterInfo _character00002612 =
    {
        0x00002612,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002612,
        0x00002612,
        0x00002612
    };

    static _CharacterInfo _character00002613 =
    {
        0x00002613,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002613,
        0x00002613,
        0x00002613
    };

    static _CharacterInfo _character00002614 =
    {
        0x00002614,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002614,
        0x00002614,
        0x00002614
    };

    static _CharacterInfo _character00002615 =
    {
        0x00002615,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002615,
        0x00002615,
        0x00002615
    };

    static _CharacterInfo _character00002616 =
    {
        0x00002616,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002616,
        0x00002616,
        0x00002616
    };

    static _CharacterInfo _character00002617 =
    {
        0x00002617,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002617,
        0x00002617,
        0x00002617
    };

    static _CharacterInfo _character00002618 =
    {
        0x00002618,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002618,
        0x00002618,
        0x00002618
    };

    static _CharacterInfo _character00002619 =
    {
        0x00002619,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002619,
        0x00002619,
        0x00002619
    };

    static _CharacterInfo _character0000261A =
    {
        0x0000261A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261A,
        0x0000261A,
        0x0000261A
    };

    static _CharacterInfo _character0000261B =
    {
        0x0000261B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261B,
        0x0000261B,
        0x0000261B
    };

    static _CharacterInfo _character0000261C =
    {
        0x0000261C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261C,
        0x0000261C,
        0x0000261C
    };

    static _CharacterInfo _character0000261D =
    {
        0x0000261D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261D,
        0x0000261D,
        0x0000261D
    };

    static _CharacterInfo _character0000261E =
    {
        0x0000261E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261E,
        0x0000261E,
        0x0000261E
    };

    static _CharacterInfo _character0000261F =
    {
        0x0000261F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000261F,
        0x0000261F,
        0x0000261F
    };

    static _CharacterInfo _character00002620 =
    {
        0x00002620,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002620,
        0x00002620,
        0x00002620
    };

    static _CharacterInfo _character00002621 =
    {
        0x00002621,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002621,
        0x00002621,
        0x00002621
    };

    static _CharacterInfo _character00002622 =
    {
        0x00002622,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002622,
        0x00002622,
        0x00002622
    };

    static _CharacterInfo _character00002623 =
    {
        0x00002623,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002623,
        0x00002623,
        0x00002623
    };

    static _CharacterInfo _character00002624 =
    {
        0x00002624,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002624,
        0x00002624,
        0x00002624
    };

    static _CharacterInfo _character00002625 =
    {
        0x00002625,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002625,
        0x00002625,
        0x00002625
    };

    static _CharacterInfo _character00002626 =
    {
        0x00002626,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002626,
        0x00002626,
        0x00002626
    };

    static _CharacterInfo _character00002627 =
    {
        0x00002627,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002627,
        0x00002627,
        0x00002627
    };

    static _CharacterInfo _character00002628 =
    {
        0x00002628,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002628,
        0x00002628,
        0x00002628
    };

    static _CharacterInfo _character00002629 =
    {
        0x00002629,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002629,
        0x00002629,
        0x00002629
    };

    static _CharacterInfo _character0000262A =
    {
        0x0000262A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262A,
        0x0000262A,
        0x0000262A
    };

    static _CharacterInfo _character0000262B =
    {
        0x0000262B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262B,
        0x0000262B,
        0x0000262B
    };

    static _CharacterInfo _character0000262C =
    {
        0x0000262C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262C,
        0x0000262C,
        0x0000262C
    };

    static _CharacterInfo _character0000262D =
    {
        0x0000262D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262D,
        0x0000262D,
        0x0000262D
    };

    static _CharacterInfo _character0000262E =
    {
        0x0000262E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262E,
        0x0000262E,
        0x0000262E
    };

    static _CharacterInfo _character0000262F =
    {
        0x0000262F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000262F,
        0x0000262F,
        0x0000262F
    };

    static _CharacterInfo _character00002630 =
    {
        0x00002630,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002630,
        0x00002630,
        0x00002630
    };

    static _CharacterInfo _character00002631 =
    {
        0x00002631,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002631,
        0x00002631,
        0x00002631
    };

    static _CharacterInfo _character00002632 =
    {
        0x00002632,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002632,
        0x00002632,
        0x00002632
    };

    static _CharacterInfo _character00002633 =
    {
        0x00002633,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002633,
        0x00002633,
        0x00002633
    };

    static _CharacterInfo _character00002634 =
    {
        0x00002634,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002634,
        0x00002634,
        0x00002634
    };

    static _CharacterInfo _character00002635 =
    {
        0x00002635,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002635,
        0x00002635,
        0x00002635
    };

    static _CharacterInfo _character00002636 =
    {
        0x00002636,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002636,
        0x00002636,
        0x00002636
    };

    static _CharacterInfo _character00002637 =
    {
        0x00002637,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002637,
        0x00002637,
        0x00002637
    };

    static _CharacterInfo _character00002638 =
    {
        0x00002638,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002638,
        0x00002638,
        0x00002638
    };

    static _CharacterInfo _character00002639 =
    {
        0x00002639,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002639,
        0x00002639,
        0x00002639
    };

    static _CharacterInfo _character0000263A =
    {
        0x0000263A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263A,
        0x0000263A,
        0x0000263A
    };

    static _CharacterInfo _character0000263B =
    {
        0x0000263B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263B,
        0x0000263B,
        0x0000263B
    };

    static _CharacterInfo _character0000263C =
    {
        0x0000263C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263C,
        0x0000263C,
        0x0000263C
    };

    static _CharacterInfo _character0000263D =
    {
        0x0000263D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263D,
        0x0000263D,
        0x0000263D
    };

    static _CharacterInfo _character0000263E =
    {
        0x0000263E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263E,
        0x0000263E,
        0x0000263E
    };

    static _CharacterInfo _character0000263F =
    {
        0x0000263F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000263F,
        0x0000263F,
        0x0000263F
    };

    static _CharacterInfo _character00002640 =
    {
        0x00002640,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002640,
        0x00002640,
        0x00002640
    };

    static _CharacterInfo _character00002641 =
    {
        0x00002641,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002641,
        0x00002641,
        0x00002641
    };

    static _CharacterInfo _character00002642 =
    {
        0x00002642,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002642,
        0x00002642,
        0x00002642
    };

    static _CharacterInfo _character00002643 =
    {
        0x00002643,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002643,
        0x00002643,
        0x00002643
    };

    static _CharacterInfo _character00002644 =
    {
        0x00002644,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002644,
        0x00002644,
        0x00002644
    };

    static _CharacterInfo _character00002645 =
    {
        0x00002645,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002645,
        0x00002645,
        0x00002645
    };

    static _CharacterInfo _character00002646 =
    {
        0x00002646,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002646,
        0x00002646,
        0x00002646
    };

    static _CharacterInfo _character00002647 =
    {
        0x00002647,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002647,
        0x00002647,
        0x00002647
    };

    static _CharacterInfo _character00002648 =
    {
        0x00002648,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002648,
        0x00002648,
        0x00002648
    };

    static _CharacterInfo _character00002649 =
    {
        0x00002649,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002649,
        0x00002649,
        0x00002649
    };

    static _CharacterInfo _character0000264A =
    {
        0x0000264A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264A,
        0x0000264A,
        0x0000264A
    };

    static _CharacterInfo _character0000264B =
    {
        0x0000264B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264B,
        0x0000264B,
        0x0000264B
    };

    static _CharacterInfo _character0000264C =
    {
        0x0000264C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264C,
        0x0000264C,
        0x0000264C
    };

    static _CharacterInfo _character0000264D =
    {
        0x0000264D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264D,
        0x0000264D,
        0x0000264D
    };

    static _CharacterInfo _character0000264E =
    {
        0x0000264E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264E,
        0x0000264E,
        0x0000264E
    };

    static _CharacterInfo _character0000264F =
    {
        0x0000264F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000264F,
        0x0000264F,
        0x0000264F
    };

    static _CharacterInfo _character00002650 =
    {
        0x00002650,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002650,
        0x00002650,
        0x00002650
    };

    static _CharacterInfo _character00002651 =
    {
        0x00002651,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002651,
        0x00002651,
        0x00002651
    };

    static _CharacterInfo _character00002652 =
    {
        0x00002652,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002652,
        0x00002652,
        0x00002652
    };

    static _CharacterInfo _character00002653 =
    {
        0x00002653,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002653,
        0x00002653,
        0x00002653
    };

    static _CharacterInfo _character00002654 =
    {
        0x00002654,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002654,
        0x00002654,
        0x00002654
    };

    static _CharacterInfo _character00002655 =
    {
        0x00002655,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002655,
        0x00002655,
        0x00002655
    };

    static _CharacterInfo _character00002656 =
    {
        0x00002656,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002656,
        0x00002656,
        0x00002656
    };

    static _CharacterInfo _character00002657 =
    {
        0x00002657,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002657,
        0x00002657,
        0x00002657
    };

    static _CharacterInfo _character00002658 =
    {
        0x00002658,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002658,
        0x00002658,
        0x00002658
    };

    static _CharacterInfo _character00002659 =
    {
        0x00002659,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002659,
        0x00002659,
        0x00002659
    };

    static _CharacterInfo _character0000265A =
    {
        0x0000265A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265A,
        0x0000265A,
        0x0000265A
    };

    static _CharacterInfo _character0000265B =
    {
        0x0000265B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265B,
        0x0000265B,
        0x0000265B
    };

    static _CharacterInfo _character0000265C =
    {
        0x0000265C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265C,
        0x0000265C,
        0x0000265C
    };

    static _CharacterInfo _character0000265D =
    {
        0x0000265D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265D,
        0x0000265D,
        0x0000265D
    };

    static _CharacterInfo _character0000265E =
    {
        0x0000265E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265E,
        0x0000265E,
        0x0000265E
    };

    static _CharacterInfo _character0000265F =
    {
        0x0000265F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000265F,
        0x0000265F,
        0x0000265F
    };

    static _CharacterInfo _character00002660 =
    {
        0x00002660,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002660,
        0x00002660,
        0x00002660
    };

    static _CharacterInfo _character00002661 =
    {
        0x00002661,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002661,
        0x00002661,
        0x00002661
    };

    static _CharacterInfo _character00002662 =
    {
        0x00002662,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002662,
        0x00002662,
        0x00002662
    };

    static _CharacterInfo _character00002663 =
    {
        0x00002663,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002663,
        0x00002663,
        0x00002663
    };

    static _CharacterInfo _character00002664 =
    {
        0x00002664,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002664,
        0x00002664,
        0x00002664
    };

    static _CharacterInfo _character00002665 =
    {
        0x00002665,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002665,
        0x00002665,
        0x00002665
    };

    static _CharacterInfo _character00002666 =
    {
        0x00002666,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002666,
        0x00002666,
        0x00002666
    };

    static _CharacterInfo _character00002667 =
    {
        0x00002667,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002667,
        0x00002667,
        0x00002667
    };

    static _CharacterInfo _character00002668 =
    {
        0x00002668,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002668,
        0x00002668,
        0x00002668
    };

    static _CharacterInfo _character00002669 =
    {
        0x00002669,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002669,
        0x00002669,
        0x00002669
    };

    static _CharacterInfo _character0000266A =
    {
        0x0000266A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266A,
        0x0000266A,
        0x0000266A
    };

    static _CharacterInfo _character0000266B =
    {
        0x0000266B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266B,
        0x0000266B,
        0x0000266B
    };

    static _CharacterInfo _character0000266C =
    {
        0x0000266C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266C,
        0x0000266C,
        0x0000266C
    };

    static _CharacterInfo _character0000266D =
    {
        0x0000266D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266D,
        0x0000266D,
        0x0000266D
    };

    static _CharacterInfo _character0000266E =
    {
        0x0000266E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266E,
        0x0000266E,
        0x0000266E
    };

    static _CharacterInfo _character0000266F =
    {
        0x0000266F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000266F,
        0x0000266F,
        0x0000266F
    };

    static _CharacterInfo _character00002670 =
    {
        0x00002670,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002670,
        0x00002670,
        0x00002670
    };

    static _CharacterInfo _character00002671 =
    {
        0x00002671,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002671,
        0x00002671,
        0x00002671
    };

    static _CharacterInfo _character00002672 =
    {
        0x00002672,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002672,
        0x00002672,
        0x00002672
    };

    static _CharacterInfo _character00002673 =
    {
        0x00002673,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002673,
        0x00002673,
        0x00002673
    };

    static _CharacterInfo _character00002674 =
    {
        0x00002674,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002674,
        0x00002674,
        0x00002674
    };

    static _CharacterInfo _character00002675 =
    {
        0x00002675,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002675,
        0x00002675,
        0x00002675
    };

    static _CharacterInfo _character00002676 =
    {
        0x00002676,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002676,
        0x00002676,
        0x00002676
    };

    static _CharacterInfo _character00002677 =
    {
        0x00002677,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002677,
        0x00002677,
        0x00002677
    };

    static _CharacterInfo _character00002678 =
    {
        0x00002678,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002678,
        0x00002678,
        0x00002678
    };

    static _CharacterInfo _character00002679 =
    {
        0x00002679,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002679,
        0x00002679,
        0x00002679
    };

    static _CharacterInfo _character0000267A =
    {
        0x0000267A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267A,
        0x0000267A,
        0x0000267A
    };

    static _CharacterInfo _character0000267B =
    {
        0x0000267B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267B,
        0x0000267B,
        0x0000267B
    };

    static _CharacterInfo _character0000267C =
    {
        0x0000267C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267C,
        0x0000267C,
        0x0000267C
    };

    static _CharacterInfo _character0000267D =
    {
        0x0000267D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267D,
        0x0000267D,
        0x0000267D
    };

    static _CharacterInfo _character0000267E =
    {
        0x0000267E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267E,
        0x0000267E,
        0x0000267E
    };

    static _CharacterInfo _character0000267F =
    {
        0x0000267F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000267F,
        0x0000267F,
        0x0000267F
    };

    static _CharacterInfo _character00002680 =
    {
        0x00002680,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002680,
        0x00002680,
        0x00002680
    };

    static _CharacterInfo _character00002681 =
    {
        0x00002681,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002681,
        0x00002681,
        0x00002681
    };

    static _CharacterInfo _character00002682 =
    {
        0x00002682,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002682,
        0x00002682,
        0x00002682
    };

    static _CharacterInfo _character00002683 =
    {
        0x00002683,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002683,
        0x00002683,
        0x00002683
    };

    static _CharacterInfo _character00002684 =
    {
        0x00002684,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002684,
        0x00002684,
        0x00002684
    };

    static _CharacterInfo _character00002685 =
    {
        0x00002685,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002685,
        0x00002685,
        0x00002685
    };

    static _CharacterInfo _character00002686 =
    {
        0x00002686,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002686,
        0x00002686,
        0x00002686
    };

    static _CharacterInfo _character00002687 =
    {
        0x00002687,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002687,
        0x00002687,
        0x00002687
    };

    static _CharacterInfo _character00002688 =
    {
        0x00002688,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002688,
        0x00002688,
        0x00002688
    };

    static _CharacterInfo _character00002689 =
    {
        0x00002689,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002689,
        0x00002689,
        0x00002689
    };

    static _CharacterInfo _character0000268A =
    {
        0x0000268A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268A,
        0x0000268A,
        0x0000268A
    };

    static _CharacterInfo _character0000268B =
    {
        0x0000268B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268B,
        0x0000268B,
        0x0000268B
    };

    static _CharacterInfo _character0000268C =
    {
        0x0000268C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268C,
        0x0000268C,
        0x0000268C
    };

    static _CharacterInfo _character0000268D =
    {
        0x0000268D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268D,
        0x0000268D,
        0x0000268D
    };

    static _CharacterInfo _character0000268E =
    {
        0x0000268E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268E,
        0x0000268E,
        0x0000268E
    };

    static _CharacterInfo _character0000268F =
    {
        0x0000268F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000268F,
        0x0000268F,
        0x0000268F
    };

    static _CharacterInfo _character00002690 =
    {
        0x00002690,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002690,
        0x00002690,
        0x00002690
    };

    static _CharacterInfo _character00002691 =
    {
        0x00002691,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002691,
        0x00002691,
        0x00002691
    };

    static _CharacterInfo _character00002692 =
    {
        0x00002692,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002692,
        0x00002692,
        0x00002692
    };

    static _CharacterInfo _character00002693 =
    {
        0x00002693,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002693,
        0x00002693,
        0x00002693
    };

    static _CharacterInfo _character00002694 =
    {
        0x00002694,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002694,
        0x00002694,
        0x00002694
    };

    static _CharacterInfo _character00002695 =
    {
        0x00002695,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002695,
        0x00002695,
        0x00002695
    };

    static _CharacterInfo _character00002696 =
    {
        0x00002696,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002696,
        0x00002696,
        0x00002696
    };

    static _CharacterInfo _character00002697 =
    {
        0x00002697,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002697,
        0x00002697,
        0x00002697
    };

    static _CharacterInfo _character00002698 =
    {
        0x00002698,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002698,
        0x00002698,
        0x00002698
    };

    static _CharacterInfo _character00002699 =
    {
        0x00002699,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002699,
        0x00002699,
        0x00002699
    };

    static _CharacterInfo _character0000269A =
    {
        0x0000269A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000269A,
        0x0000269A,
        0x0000269A
    };

    static _CharacterInfo _character0000269B =
    {
        0x0000269B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000269B,
        0x0000269B,
        0x0000269B
    };

    static _CharacterInfo _character0000269C =
    {
        0x0000269C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000269C,
        0x0000269C,
        0x0000269C
    };

    static _CharacterInfo _character000026A0 =
    {
        0x000026A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A0,
        0x000026A0,
        0x000026A0
    };

    static _CharacterInfo _character000026A1 =
    {
        0x000026A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A1,
        0x000026A1,
        0x000026A1
    };

    static _CharacterInfo _character000026A2 =
    {
        0x000026A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A2,
        0x000026A2,
        0x000026A2
    };

    static _CharacterInfo _character000026A3 =
    {
        0x000026A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A3,
        0x000026A3,
        0x000026A3
    };

    static _CharacterInfo _character000026A4 =
    {
        0x000026A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A4,
        0x000026A4,
        0x000026A4
    };

    static _CharacterInfo _character000026A5 =
    {
        0x000026A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A5,
        0x000026A5,
        0x000026A5
    };

    static _CharacterInfo _character000026A6 =
    {
        0x000026A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A6,
        0x000026A6,
        0x000026A6
    };

    static _CharacterInfo _character000026A7 =
    {
        0x000026A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A7,
        0x000026A7,
        0x000026A7
    };

    static _CharacterInfo _character000026A8 =
    {
        0x000026A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A8,
        0x000026A8,
        0x000026A8
    };

    static _CharacterInfo _character000026A9 =
    {
        0x000026A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026A9,
        0x000026A9,
        0x000026A9
    };

    static _CharacterInfo _character000026AA =
    {
        0x000026AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AA,
        0x000026AA,
        0x000026AA
    };

    static _CharacterInfo _character000026AB =
    {
        0x000026AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AB,
        0x000026AB,
        0x000026AB
    };

    static _CharacterInfo _character000026AC =
    {
        0x000026AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AC,
        0x000026AC,
        0x000026AC
    };

    static _CharacterInfo _character000026AD =
    {
        0x000026AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AD,
        0x000026AD,
        0x000026AD
    };

    static _CharacterInfo _character000026AE =
    {
        0x000026AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AE,
        0x000026AE,
        0x000026AE
    };

    static _CharacterInfo _character000026AF =
    {
        0x000026AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026AF,
        0x000026AF,
        0x000026AF
    };

    static _CharacterInfo _character000026B0 =
    {
        0x000026B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026B0,
        0x000026B0,
        0x000026B0
    };

    static _CharacterInfo _character000026B1 =
    {
        0x000026B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026B1,
        0x000026B1,
        0x000026B1
    };

    static _CharacterInfo _character000026B2 =
    {
        0x000026B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000026B2,
        0x000026B2,
        0x000026B2
    };

    static _CharacterInfo _character00002701 =
    {
        0x00002701,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002701,
        0x00002701,
        0x00002701
    };

    static _CharacterInfo _character00002702 =
    {
        0x00002702,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002702,
        0x00002702,
        0x00002702
    };

    static _CharacterInfo _character00002703 =
    {
        0x00002703,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002703,
        0x00002703,
        0x00002703
    };

    static _CharacterInfo _character00002704 =
    {
        0x00002704,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002704,
        0x00002704,
        0x00002704
    };

    static _CharacterInfo _character00002706 =
    {
        0x00002706,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002706,
        0x00002706,
        0x00002706
    };

    static _CharacterInfo _character00002707 =
    {
        0x00002707,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002707,
        0x00002707,
        0x00002707
    };

    static _CharacterInfo _character00002708 =
    {
        0x00002708,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002708,
        0x00002708,
        0x00002708
    };

    static _CharacterInfo _character00002709 =
    {
        0x00002709,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002709,
        0x00002709,
        0x00002709
    };

    static _CharacterInfo _character0000270C =
    {
        0x0000270C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000270C,
        0x0000270C,
        0x0000270C
    };

    static _CharacterInfo _character0000270D =
    {
        0x0000270D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000270D,
        0x0000270D,
        0x0000270D
    };

    static _CharacterInfo _character0000270E =
    {
        0x0000270E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000270E,
        0x0000270E,
        0x0000270E
    };

    static _CharacterInfo _character0000270F =
    {
        0x0000270F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000270F,
        0x0000270F,
        0x0000270F
    };

    static _CharacterInfo _character00002710 =
    {
        0x00002710,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002710,
        0x00002710,
        0x00002710
    };

    static _CharacterInfo _character00002711 =
    {
        0x00002711,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002711,
        0x00002711,
        0x00002711
    };

    static _CharacterInfo _character00002712 =
    {
        0x00002712,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002712,
        0x00002712,
        0x00002712
    };

    static _CharacterInfo _character00002713 =
    {
        0x00002713,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002713,
        0x00002713,
        0x00002713
    };

    static _CharacterInfo _character00002714 =
    {
        0x00002714,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002714,
        0x00002714,
        0x00002714
    };

    static _CharacterInfo _character00002715 =
    {
        0x00002715,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002715,
        0x00002715,
        0x00002715
    };

    static _CharacterInfo _character00002716 =
    {
        0x00002716,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002716,
        0x00002716,
        0x00002716
    };

    static _CharacterInfo _character00002717 =
    {
        0x00002717,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002717,
        0x00002717,
        0x00002717
    };

    static _CharacterInfo _character00002718 =
    {
        0x00002718,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002718,
        0x00002718,
        0x00002718
    };

    static _CharacterInfo _character00002719 =
    {
        0x00002719,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002719,
        0x00002719,
        0x00002719
    };

    static _CharacterInfo _character0000271A =
    {
        0x0000271A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271A,
        0x0000271A,
        0x0000271A
    };

    static _CharacterInfo _character0000271B =
    {
        0x0000271B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271B,
        0x0000271B,
        0x0000271B
    };

    static _CharacterInfo _character0000271C =
    {
        0x0000271C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271C,
        0x0000271C,
        0x0000271C
    };

    static _CharacterInfo _character0000271D =
    {
        0x0000271D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271D,
        0x0000271D,
        0x0000271D
    };

    static _CharacterInfo _character0000271E =
    {
        0x0000271E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271E,
        0x0000271E,
        0x0000271E
    };

    static _CharacterInfo _character0000271F =
    {
        0x0000271F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000271F,
        0x0000271F,
        0x0000271F
    };

    static _CharacterInfo _character00002720 =
    {
        0x00002720,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002720,
        0x00002720,
        0x00002720
    };

    static _CharacterInfo _character00002721 =
    {
        0x00002721,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002721,
        0x00002721,
        0x00002721
    };

    static _CharacterInfo _character00002722 =
    {
        0x00002722,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002722,
        0x00002722,
        0x00002722
    };

    static _CharacterInfo _character00002723 =
    {
        0x00002723,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002723,
        0x00002723,
        0x00002723
    };

    static _CharacterInfo _character00002724 =
    {
        0x00002724,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002724,
        0x00002724,
        0x00002724
    };

    static _CharacterInfo _character00002725 =
    {
        0x00002725,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002725,
        0x00002725,
        0x00002725
    };

    static _CharacterInfo _character00002726 =
    {
        0x00002726,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002726,
        0x00002726,
        0x00002726
    };

    static _CharacterInfo _character00002727 =
    {
        0x00002727,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002727,
        0x00002727,
        0x00002727
    };

    static _CharacterInfo _character00002729 =
    {
        0x00002729,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002729,
        0x00002729,
        0x00002729
    };

    static _CharacterInfo _character0000272A =
    {
        0x0000272A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272A,
        0x0000272A,
        0x0000272A
    };

    static _CharacterInfo _character0000272B =
    {
        0x0000272B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272B,
        0x0000272B,
        0x0000272B
    };

    static _CharacterInfo _character0000272C =
    {
        0x0000272C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272C,
        0x0000272C,
        0x0000272C
    };

    static _CharacterInfo _character0000272D =
    {
        0x0000272D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272D,
        0x0000272D,
        0x0000272D
    };

    static _CharacterInfo _character0000272E =
    {
        0x0000272E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272E,
        0x0000272E,
        0x0000272E
    };

    static _CharacterInfo _character0000272F =
    {
        0x0000272F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000272F,
        0x0000272F,
        0x0000272F
    };

    static _CharacterInfo _character00002730 =
    {
        0x00002730,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002730,
        0x00002730,
        0x00002730
    };

    static _CharacterInfo _character00002731 =
    {
        0x00002731,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002731,
        0x00002731,
        0x00002731
    };

    static _CharacterInfo _character00002732 =
    {
        0x00002732,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002732,
        0x00002732,
        0x00002732
    };

    static _CharacterInfo _character00002733 =
    {
        0x00002733,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002733,
        0x00002733,
        0x00002733
    };

    static _CharacterInfo _character00002734 =
    {
        0x00002734,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002734,
        0x00002734,
        0x00002734
    };

    static _CharacterInfo _character00002735 =
    {
        0x00002735,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002735,
        0x00002735,
        0x00002735
    };

    static _CharacterInfo _character00002736 =
    {
        0x00002736,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002736,
        0x00002736,
        0x00002736
    };

    static _CharacterInfo _character00002737 =
    {
        0x00002737,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002737,
        0x00002737,
        0x00002737
    };

    static _CharacterInfo _character00002738 =
    {
        0x00002738,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002738,
        0x00002738,
        0x00002738
    };

    static _CharacterInfo _character00002739 =
    {
        0x00002739,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002739,
        0x00002739,
        0x00002739
    };

    static _CharacterInfo _character0000273A =
    {
        0x0000273A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273A,
        0x0000273A,
        0x0000273A
    };

    static _CharacterInfo _character0000273B =
    {
        0x0000273B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273B,
        0x0000273B,
        0x0000273B
    };

    static _CharacterInfo _character0000273C =
    {
        0x0000273C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273C,
        0x0000273C,
        0x0000273C
    };

    static _CharacterInfo _character0000273D =
    {
        0x0000273D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273D,
        0x0000273D,
        0x0000273D
    };

    static _CharacterInfo _character0000273E =
    {
        0x0000273E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273E,
        0x0000273E,
        0x0000273E
    };

    static _CharacterInfo _character0000273F =
    {
        0x0000273F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000273F,
        0x0000273F,
        0x0000273F
    };

    static _CharacterInfo _character00002740 =
    {
        0x00002740,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002740,
        0x00002740,
        0x00002740
    };

    static _CharacterInfo _character00002741 =
    {
        0x00002741,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002741,
        0x00002741,
        0x00002741
    };

    static _CharacterInfo _character00002742 =
    {
        0x00002742,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002742,
        0x00002742,
        0x00002742
    };

    static _CharacterInfo _character00002743 =
    {
        0x00002743,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002743,
        0x00002743,
        0x00002743
    };

    static _CharacterInfo _character00002744 =
    {
        0x00002744,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002744,
        0x00002744,
        0x00002744
    };

    static _CharacterInfo _character00002745 =
    {
        0x00002745,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002745,
        0x00002745,
        0x00002745
    };

    static _CharacterInfo _character00002746 =
    {
        0x00002746,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002746,
        0x00002746,
        0x00002746
    };

    static _CharacterInfo _character00002747 =
    {
        0x00002747,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002747,
        0x00002747,
        0x00002747
    };

    static _CharacterInfo _character00002748 =
    {
        0x00002748,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002748,
        0x00002748,
        0x00002748
    };

    static _CharacterInfo _character00002749 =
    {
        0x00002749,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002749,
        0x00002749,
        0x00002749
    };

    static _CharacterInfo _character0000274A =
    {
        0x0000274A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000274A,
        0x0000274A,
        0x0000274A
    };

    static _CharacterInfo _character0000274B =
    {
        0x0000274B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000274B,
        0x0000274B,
        0x0000274B
    };

    static _CharacterInfo _character0000274D =
    {
        0x0000274D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000274D,
        0x0000274D,
        0x0000274D
    };

    static _CharacterInfo _character0000274F =
    {
        0x0000274F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000274F,
        0x0000274F,
        0x0000274F
    };

    static _CharacterInfo _character00002750 =
    {
        0x00002750,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002750,
        0x00002750,
        0x00002750
    };

    static _CharacterInfo _character00002751 =
    {
        0x00002751,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002751,
        0x00002751,
        0x00002751
    };

    static _CharacterInfo _character00002752 =
    {
        0x00002752,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002752,
        0x00002752,
        0x00002752
    };

    static _CharacterInfo _character00002756 =
    {
        0x00002756,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002756,
        0x00002756,
        0x00002756
    };

    static _CharacterInfo _character00002758 =
    {
        0x00002758,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002758,
        0x00002758,
        0x00002758
    };

    static _CharacterInfo _character00002759 =
    {
        0x00002759,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002759,
        0x00002759,
        0x00002759
    };

    static _CharacterInfo _character0000275A =
    {
        0x0000275A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000275A,
        0x0000275A,
        0x0000275A
    };

    static _CharacterInfo _character0000275B =
    {
        0x0000275B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000275B,
        0x0000275B,
        0x0000275B
    };

    static _CharacterInfo _character0000275C =
    {
        0x0000275C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000275C,
        0x0000275C,
        0x0000275C
    };

    static _CharacterInfo _character0000275D =
    {
        0x0000275D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000275D,
        0x0000275D,
        0x0000275D
    };

    static _CharacterInfo _character0000275E =
    {
        0x0000275E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000275E,
        0x0000275E,
        0x0000275E
    };

    static _CharacterInfo _character00002761 =
    {
        0x00002761,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002761,
        0x00002761,
        0x00002761
    };

    static _CharacterInfo _character00002762 =
    {
        0x00002762,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002762,
        0x00002762,
        0x00002762
    };

    static _CharacterInfo _character00002763 =
    {
        0x00002763,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002763,
        0x00002763,
        0x00002763
    };

    static _CharacterInfo _character00002764 =
    {
        0x00002764,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002764,
        0x00002764,
        0x00002764
    };

    static _CharacterInfo _character00002765 =
    {
        0x00002765,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002765,
        0x00002765,
        0x00002765
    };

    static _CharacterInfo _character00002766 =
    {
        0x00002766,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002766,
        0x00002766,
        0x00002766
    };

    static _CharacterInfo _character00002767 =
    {
        0x00002767,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002767,
        0x00002767,
        0x00002767
    };

    static _CharacterInfo _character00002768 =
    {
        0x00002768,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002768,
        0x00002768,
        0x00002768
    };

    static _CharacterInfo _character00002769 =
    {
        0x00002769,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002769,
        0x00002769,
        0x00002769
    };

    static _CharacterInfo _character0000276A =
    {
        0x0000276A,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276A,
        0x0000276A,
        0x0000276A
    };

    static _CharacterInfo _character0000276B =
    {
        0x0000276B,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276B,
        0x0000276B,
        0x0000276B
    };

    static _CharacterInfo _character0000276C =
    {
        0x0000276C,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276C,
        0x0000276C,
        0x0000276C
    };

    static _CharacterInfo _character0000276D =
    {
        0x0000276D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276D,
        0x0000276D,
        0x0000276D
    };

    static _CharacterInfo _character0000276E =
    {
        0x0000276E,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276E,
        0x0000276E,
        0x0000276E
    };

    static _CharacterInfo _character0000276F =
    {
        0x0000276F,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000276F,
        0x0000276F,
        0x0000276F
    };

    static _CharacterInfo _character00002770 =
    {
        0x00002770,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002770,
        0x00002770,
        0x00002770
    };

    static _CharacterInfo _character00002771 =
    {
        0x00002771,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002771,
        0x00002771,
        0x00002771
    };

    static _CharacterInfo _character00002772 =
    {
        0x00002772,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002772,
        0x00002772,
        0x00002772
    };

    static _CharacterInfo _character00002773 =
    {
        0x00002773,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002773,
        0x00002773,
        0x00002773
    };

    static _CharacterInfo _character00002774 =
    {
        0x00002774,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002774,
        0x00002774,
        0x00002774
    };

    static _CharacterInfo _character00002775 =
    {
        0x00002775,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002775,
        0x00002775,
        0x00002775
    };

    static _CharacterInfo _character00002776 =
    {
        0x00002776,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002776,
        0x00002776,
        0x00002776
    };

    static _CharacterInfo _character00002777 =
    {
        0x00002777,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002777,
        0x00002777,
        0x00002777
    };

    static _CharacterInfo _character00002778 =
    {
        0x00002778,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00002778,
        0x00002778,
        0x00002778
    };

    static _CharacterInfo _character00002779 =
    {
        0x00002779,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002779,
        0x00002779,
        0x00002779
    };

    static _CharacterInfo _character0000277A =
    {
        0x0000277A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000277A,
        0x0000277A,
        0x0000277A
    };

    static _CharacterInfo _character0000277B =
    {
        0x0000277B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000277B,
        0x0000277B,
        0x0000277B
    };

    static _CharacterInfo _character0000277C =
    {
        0x0000277C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000277C,
        0x0000277C,
        0x0000277C
    };

    static _CharacterInfo _character0000277D =
    {
        0x0000277D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000277D,
        0x0000277D,
        0x0000277D
    };

    static _CharacterInfo _character0000277E =
    {
        0x0000277E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0000277E,
        0x0000277E,
        0x0000277E
    };

    static _CharacterInfo _character0000277F =
    {
        0x0000277F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x0000277F,
        0x0000277F,
        0x0000277F
    };

    static _CharacterInfo _character00002780 =
    {
        0x00002780,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00002780,
        0x00002780,
        0x00002780
    };

    static _CharacterInfo _character00002781 =
    {
        0x00002781,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00002781,
        0x00002781,
        0x00002781
    };

    static _CharacterInfo _character00002782 =
    {
        0x00002782,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00002782,
        0x00002782,
        0x00002782
    };

    static _CharacterInfo _character00002783 =
    {
        0x00002783,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00002783,
        0x00002783,
        0x00002783
    };

    static _CharacterInfo _character00002784 =
    {
        0x00002784,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x00002784,
        0x00002784,
        0x00002784
    };

    static _CharacterInfo _character00002785 =
    {
        0x00002785,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x00002785,
        0x00002785,
        0x00002785
    };

    static _CharacterInfo _character00002786 =
    {
        0x00002786,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00002786,
        0x00002786,
        0x00002786
    };

    static _CharacterInfo _character00002787 =
    {
        0x00002787,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00002787,
        0x00002787,
        0x00002787
    };

    static _CharacterInfo _character00002788 =
    {
        0x00002788,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002788,
        0x00002788,
        0x00002788
    };

    static _CharacterInfo _character00002789 =
    {
        0x00002789,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002789,
        0x00002789,
        0x00002789
    };

    static _CharacterInfo _character0000278A =
    {
        0x0000278A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0000278A,
        0x0000278A,
        0x0000278A
    };

    static _CharacterInfo _character0000278B =
    {
        0x0000278B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0000278B,
        0x0000278B,
        0x0000278B
    };

    static _CharacterInfo _character0000278C =
    {
        0x0000278C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0000278C,
        0x0000278C,
        0x0000278C
    };

    static _CharacterInfo _character0000278D =
    {
        0x0000278D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000278D,
        0x0000278D,
        0x0000278D
    };

    static _CharacterInfo _character0000278E =
    {
        0x0000278E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000278E,
        0x0000278E,
        0x0000278E
    };

    static _CharacterInfo _character0000278F =
    {
        0x0000278F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000278F,
        0x0000278F,
        0x0000278F
    };

    static _CharacterInfo _character00002790 =
    {
        0x00002790,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        7,
        true,
        7,
        1,
        false,
        0x00002790,
        0x00002790,
        0x00002790
    };

    static _CharacterInfo _character00002791 =
    {
        0x00002791,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        8,
        true,
        8,
        1,
        false,
        0x00002791,
        0x00002791,
        0x00002791
    };

    static _CharacterInfo _character00002792 =
    {
        0x00002792,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        9,
        true,
        9,
        1,
        false,
        0x00002792,
        0x00002792,
        0x00002792
    };

    static _CharacterInfo _character00002793 =
    {
        0x00002793,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00002793,
        0x00002793,
        0x00002793
    };

    static _CharacterInfo _character00002794 =
    {
        0x00002794,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002794,
        0x00002794,
        0x00002794
    };

    static _CharacterInfo _character00002798 =
    {
        0x00002798,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002798,
        0x00002798,
        0x00002798
    };

    static _CharacterInfo _character00002799 =
    {
        0x00002799,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002799,
        0x00002799,
        0x00002799
    };

    static _CharacterInfo _character0000279A =
    {
        0x0000279A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279A,
        0x0000279A,
        0x0000279A
    };

    static _CharacterInfo _character0000279B =
    {
        0x0000279B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279B,
        0x0000279B,
        0x0000279B
    };

    static _CharacterInfo _character0000279C =
    {
        0x0000279C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279C,
        0x0000279C,
        0x0000279C
    };

    static _CharacterInfo _character0000279D =
    {
        0x0000279D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279D,
        0x0000279D,
        0x0000279D
    };

    static _CharacterInfo _character0000279E =
    {
        0x0000279E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279E,
        0x0000279E,
        0x0000279E
    };

    static _CharacterInfo _character0000279F =
    {
        0x0000279F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000279F,
        0x0000279F,
        0x0000279F
    };

    static _CharacterInfo _character000027A0 =
    {
        0x000027A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A0,
        0x000027A0,
        0x000027A0
    };

    static _CharacterInfo _character000027A1 =
    {
        0x000027A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A1,
        0x000027A1,
        0x000027A1
    };

    static _CharacterInfo _character000027A2 =
    {
        0x000027A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A2,
        0x000027A2,
        0x000027A2
    };

    static _CharacterInfo _character000027A3 =
    {
        0x000027A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A3,
        0x000027A3,
        0x000027A3
    };

    static _CharacterInfo _character000027A4 =
    {
        0x000027A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A4,
        0x000027A4,
        0x000027A4
    };

    static _CharacterInfo _character000027A5 =
    {
        0x000027A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A5,
        0x000027A5,
        0x000027A5
    };

    static _CharacterInfo _character000027A6 =
    {
        0x000027A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A6,
        0x000027A6,
        0x000027A6
    };

    static _CharacterInfo _character000027A7 =
    {
        0x000027A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A7,
        0x000027A7,
        0x000027A7
    };

    static _CharacterInfo _character000027A8 =
    {
        0x000027A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A8,
        0x000027A8,
        0x000027A8
    };

    static _CharacterInfo _character000027A9 =
    {
        0x000027A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027A9,
        0x000027A9,
        0x000027A9
    };

    static _CharacterInfo _character000027AA =
    {
        0x000027AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AA,
        0x000027AA,
        0x000027AA
    };

    static _CharacterInfo _character000027AB =
    {
        0x000027AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AB,
        0x000027AB,
        0x000027AB
    };

    static _CharacterInfo _character000027AC =
    {
        0x000027AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AC,
        0x000027AC,
        0x000027AC
    };

    static _CharacterInfo _character000027AD =
    {
        0x000027AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AD,
        0x000027AD,
        0x000027AD
    };

    static _CharacterInfo _character000027AE =
    {
        0x000027AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AE,
        0x000027AE,
        0x000027AE
    };

    static _CharacterInfo _character000027AF =
    {
        0x000027AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027AF,
        0x000027AF,
        0x000027AF
    };

    static _CharacterInfo _character000027B1 =
    {
        0x000027B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B1,
        0x000027B1,
        0x000027B1
    };

    static _CharacterInfo _character000027B2 =
    {
        0x000027B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B2,
        0x000027B2,
        0x000027B2
    };

    static _CharacterInfo _character000027B3 =
    {
        0x000027B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B3,
        0x000027B3,
        0x000027B3
    };

    static _CharacterInfo _character000027B4 =
    {
        0x000027B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B4,
        0x000027B4,
        0x000027B4
    };

    static _CharacterInfo _character000027B5 =
    {
        0x000027B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B5,
        0x000027B5,
        0x000027B5
    };

    static _CharacterInfo _character000027B6 =
    {
        0x000027B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B6,
        0x000027B6,
        0x000027B6
    };

    static _CharacterInfo _character000027B7 =
    {
        0x000027B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B7,
        0x000027B7,
        0x000027B7
    };

    static _CharacterInfo _character000027B8 =
    {
        0x000027B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B8,
        0x000027B8,
        0x000027B8
    };

    static _CharacterInfo _character000027B9 =
    {
        0x000027B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027B9,
        0x000027B9,
        0x000027B9
    };

    static _CharacterInfo _character000027BA =
    {
        0x000027BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027BA,
        0x000027BA,
        0x000027BA
    };

    static _CharacterInfo _character000027BB =
    {
        0x000027BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027BB,
        0x000027BB,
        0x000027BB
    };

    static _CharacterInfo _character000027BC =
    {
        0x000027BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027BC,
        0x000027BC,
        0x000027BC
    };

    static _CharacterInfo _character000027BD =
    {
        0x000027BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027BD,
        0x000027BD,
        0x000027BD
    };

    static _CharacterInfo _character000027BE =
    {
        0x000027BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027BE,
        0x000027BE,
        0x000027BE
    };

    static _CharacterInfo _character000027C0 =
    {
        0x000027C0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027C0,
        0x000027C0,
        0x000027C0
    };

    static _CharacterInfo _character000027C1 =
    {
        0x000027C1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027C1,
        0x000027C1,
        0x000027C1
    };

    static _CharacterInfo _character000027C2 =
    {
        0x000027C2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027C2,
        0x000027C2,
        0x000027C2
    };

    static _CharacterInfo _character000027C3 =
    {
        0x000027C3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027C3,
        0x000027C3,
        0x000027C3
    };

    static _CharacterInfo _character000027C4 =
    {
        0x000027C4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027C4,
        0x000027C4,
        0x000027C4
    };

    static _CharacterInfo _character000027C5 =
    {
        0x000027C5,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027C5,
        0x000027C5,
        0x000027C5
    };

    static _CharacterInfo _character000027C6 =
    {
        0x000027C6,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027C6,
        0x000027C6,
        0x000027C6
    };

    static _CharacterInfo _character000027C7 =
    {
        0x000027C7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027C7,
        0x000027C7,
        0x000027C7
    };

    static _CharacterInfo _character000027C8 =
    {
        0x000027C8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027C8,
        0x000027C8,
        0x000027C8
    };

    static _CharacterInfo _character000027C9 =
    {
        0x000027C9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027C9,
        0x000027C9,
        0x000027C9
    };

    static _CharacterInfo _character000027CA =
    {
        0x000027CA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027CA,
        0x000027CA,
        0x000027CA
    };

    static _CharacterInfo _character000027D0 =
    {
        0x000027D0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D0,
        0x000027D0,
        0x000027D0
    };

    static _CharacterInfo _character000027D1 =
    {
        0x000027D1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D1,
        0x000027D1,
        0x000027D1
    };

    static _CharacterInfo _character000027D2 =
    {
        0x000027D2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D2,
        0x000027D2,
        0x000027D2
    };

    static _CharacterInfo _character000027D3 =
    {
        0x000027D3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027D3,
        0x000027D3,
        0x000027D3
    };

    static _CharacterInfo _character000027D4 =
    {
        0x000027D4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027D4,
        0x000027D4,
        0x000027D4
    };

    static _CharacterInfo _character000027D5 =
    {
        0x000027D5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027D5,
        0x000027D5,
        0x000027D5
    };

    static _CharacterInfo _character000027D6 =
    {
        0x000027D6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027D6,
        0x000027D6,
        0x000027D6
    };

    static _CharacterInfo _character000027D7 =
    {
        0x000027D7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D7,
        0x000027D7,
        0x000027D7
    };

    static _CharacterInfo _character000027D8 =
    {
        0x000027D8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D8,
        0x000027D8,
        0x000027D8
    };

    static _CharacterInfo _character000027D9 =
    {
        0x000027D9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027D9,
        0x000027D9,
        0x000027D9
    };

    static _CharacterInfo _character000027DA =
    {
        0x000027DA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027DA,
        0x000027DA,
        0x000027DA
    };

    static _CharacterInfo _character000027DB =
    {
        0x000027DB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027DB,
        0x000027DB,
        0x000027DB
    };

    static _CharacterInfo _character000027DC =
    {
        0x000027DC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027DC,
        0x000027DC,
        0x000027DC
    };

    static _CharacterInfo _character000027DD =
    {
        0x000027DD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027DD,
        0x000027DD,
        0x000027DD
    };

    static _CharacterInfo _character000027DE =
    {
        0x000027DE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027DE,
        0x000027DE,
        0x000027DE
    };

    static _CharacterInfo _character000027DF =
    {
        0x000027DF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027DF,
        0x000027DF,
        0x000027DF
    };

    static _CharacterInfo _character000027E0 =
    {
        0x000027E0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027E0,
        0x000027E0,
        0x000027E0
    };

    static _CharacterInfo _character000027E1 =
    {
        0x000027E1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027E1,
        0x000027E1,
        0x000027E1
    };

    static _CharacterInfo _character000027E2 =
    {
        0x000027E2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E2,
        0x000027E2,
        0x000027E2
    };

    static _CharacterInfo _character000027E3 =
    {
        0x000027E3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E3,
        0x000027E3,
        0x000027E3
    };

    static _CharacterInfo _character000027E4 =
    {
        0x000027E4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E4,
        0x000027E4,
        0x000027E4
    };

    static _CharacterInfo _character000027E5 =
    {
        0x000027E5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E5,
        0x000027E5,
        0x000027E5
    };

    static _CharacterInfo _character000027E6 =
    {
        0x000027E6,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E6,
        0x000027E6,
        0x000027E6
    };

    static _CharacterInfo _character000027E7 =
    {
        0x000027E7,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E7,
        0x000027E7,
        0x000027E7
    };

    static _CharacterInfo _character000027E8 =
    {
        0x000027E8,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E8,
        0x000027E8,
        0x000027E8
    };

    static _CharacterInfo _character000027E9 =
    {
        0x000027E9,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027E9,
        0x000027E9,
        0x000027E9
    };

    static _CharacterInfo _character000027EA =
    {
        0x000027EA,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027EA,
        0x000027EA,
        0x000027EA
    };

    static _CharacterInfo _character000027EB =
    {
        0x000027EB,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000027EB,
        0x000027EB,
        0x000027EB
    };

    static _CharacterInfo _character000027F0 =
    {
        0x000027F0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F0,
        0x000027F0,
        0x000027F0
    };

    static _CharacterInfo _character000027F1 =
    {
        0x000027F1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F1,
        0x000027F1,
        0x000027F1
    };

    static _CharacterInfo _character000027F2 =
    {
        0x000027F2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F2,
        0x000027F2,
        0x000027F2
    };

    static _CharacterInfo _character000027F3 =
    {
        0x000027F3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F3,
        0x000027F3,
        0x000027F3
    };

    static _CharacterInfo _character000027F4 =
    {
        0x000027F4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F4,
        0x000027F4,
        0x000027F4
    };

    static _CharacterInfo _character000027F5 =
    {
        0x000027F5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F5,
        0x000027F5,
        0x000027F5
    };

    static _CharacterInfo _character000027F6 =
    {
        0x000027F6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F6,
        0x000027F6,
        0x000027F6
    };

    static _CharacterInfo _character000027F7 =
    {
        0x000027F7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F7,
        0x000027F7,
        0x000027F7
    };

    static _CharacterInfo _character000027F8 =
    {
        0x000027F8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F8,
        0x000027F8,
        0x000027F8
    };

    static _CharacterInfo _character000027F9 =
    {
        0x000027F9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027F9,
        0x000027F9,
        0x000027F9
    };

    static _CharacterInfo _character000027FA =
    {
        0x000027FA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FA,
        0x000027FA,
        0x000027FA
    };

    static _CharacterInfo _character000027FB =
    {
        0x000027FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FB,
        0x000027FB,
        0x000027FB
    };

    static _CharacterInfo _character000027FC =
    {
        0x000027FC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FC,
        0x000027FC,
        0x000027FC
    };

    static _CharacterInfo _character000027FD =
    {
        0x000027FD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FD,
        0x000027FD,
        0x000027FD
    };

    static _CharacterInfo _character000027FE =
    {
        0x000027FE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FE,
        0x000027FE,
        0x000027FE
    };

    static _CharacterInfo _character000027FF =
    {
        0x000027FF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000027FF,
        0x000027FF,
        0x000027FF
    };

    static _CharacterInfo _character00002800 =
    {
        0x00002800,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002800,
        0x00002800,
        0x00002800
    };

    static _CharacterInfo _character00002801 =
    {
        0x00002801,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002801,
        0x00002801,
        0x00002801
    };

    static _CharacterInfo _character00002802 =
    {
        0x00002802,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002802,
        0x00002802,
        0x00002802
    };

    static _CharacterInfo _character00002803 =
    {
        0x00002803,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002803,
        0x00002803,
        0x00002803
    };

    static _CharacterInfo _character00002804 =
    {
        0x00002804,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002804,
        0x00002804,
        0x00002804
    };

    static _CharacterInfo _character00002805 =
    {
        0x00002805,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002805,
        0x00002805,
        0x00002805
    };

    static _CharacterInfo _character00002806 =
    {
        0x00002806,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002806,
        0x00002806,
        0x00002806
    };

    static _CharacterInfo _character00002807 =
    {
        0x00002807,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002807,
        0x00002807,
        0x00002807
    };

    static _CharacterInfo _character00002808 =
    {
        0x00002808,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002808,
        0x00002808,
        0x00002808
    };

    static _CharacterInfo _character00002809 =
    {
        0x00002809,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002809,
        0x00002809,
        0x00002809
    };

    static _CharacterInfo _character0000280A =
    {
        0x0000280A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280A,
        0x0000280A,
        0x0000280A
    };

    static _CharacterInfo _character0000280B =
    {
        0x0000280B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280B,
        0x0000280B,
        0x0000280B
    };

    static _CharacterInfo _character0000280C =
    {
        0x0000280C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280C,
        0x0000280C,
        0x0000280C
    };

    static _CharacterInfo _character0000280D =
    {
        0x0000280D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280D,
        0x0000280D,
        0x0000280D
    };

    static _CharacterInfo _character0000280E =
    {
        0x0000280E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280E,
        0x0000280E,
        0x0000280E
    };

    static _CharacterInfo _character0000280F =
    {
        0x0000280F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000280F,
        0x0000280F,
        0x0000280F
    };

    static _CharacterInfo _character00002810 =
    {
        0x00002810,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002810,
        0x00002810,
        0x00002810
    };

    static _CharacterInfo _character00002811 =
    {
        0x00002811,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002811,
        0x00002811,
        0x00002811
    };

    static _CharacterInfo _character00002812 =
    {
        0x00002812,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002812,
        0x00002812,
        0x00002812
    };

    static _CharacterInfo _character00002813 =
    {
        0x00002813,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002813,
        0x00002813,
        0x00002813
    };

    static _CharacterInfo _character00002814 =
    {
        0x00002814,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002814,
        0x00002814,
        0x00002814
    };

    static _CharacterInfo _character00002815 =
    {
        0x00002815,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002815,
        0x00002815,
        0x00002815
    };

    static _CharacterInfo _character00002816 =
    {
        0x00002816,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002816,
        0x00002816,
        0x00002816
    };

    static _CharacterInfo _character00002817 =
    {
        0x00002817,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002817,
        0x00002817,
        0x00002817
    };

    static _CharacterInfo _character00002818 =
    {
        0x00002818,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002818,
        0x00002818,
        0x00002818
    };

    static _CharacterInfo _character00002819 =
    {
        0x00002819,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002819,
        0x00002819,
        0x00002819
    };

    static _CharacterInfo _character0000281A =
    {
        0x0000281A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281A,
        0x0000281A,
        0x0000281A
    };

    static _CharacterInfo _character0000281B =
    {
        0x0000281B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281B,
        0x0000281B,
        0x0000281B
    };

    static _CharacterInfo _character0000281C =
    {
        0x0000281C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281C,
        0x0000281C,
        0x0000281C
    };

    static _CharacterInfo _character0000281D =
    {
        0x0000281D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281D,
        0x0000281D,
        0x0000281D
    };

    static _CharacterInfo _character0000281E =
    {
        0x0000281E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281E,
        0x0000281E,
        0x0000281E
    };

    static _CharacterInfo _character0000281F =
    {
        0x0000281F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000281F,
        0x0000281F,
        0x0000281F
    };

    static _CharacterInfo _character00002820 =
    {
        0x00002820,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002820,
        0x00002820,
        0x00002820
    };

    static _CharacterInfo _character00002821 =
    {
        0x00002821,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002821,
        0x00002821,
        0x00002821
    };

    static _CharacterInfo _character00002822 =
    {
        0x00002822,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002822,
        0x00002822,
        0x00002822
    };

    static _CharacterInfo _character00002823 =
    {
        0x00002823,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002823,
        0x00002823,
        0x00002823
    };

    static _CharacterInfo _character00002824 =
    {
        0x00002824,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002824,
        0x00002824,
        0x00002824
    };

    static _CharacterInfo _character00002825 =
    {
        0x00002825,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002825,
        0x00002825,
        0x00002825
    };

    static _CharacterInfo _character00002826 =
    {
        0x00002826,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002826,
        0x00002826,
        0x00002826
    };

    static _CharacterInfo _character00002827 =
    {
        0x00002827,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002827,
        0x00002827,
        0x00002827
    };

    static _CharacterInfo _character00002828 =
    {
        0x00002828,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002828,
        0x00002828,
        0x00002828
    };

    static _CharacterInfo _character00002829 =
    {
        0x00002829,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002829,
        0x00002829,
        0x00002829
    };

    static _CharacterInfo _character0000282A =
    {
        0x0000282A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282A,
        0x0000282A,
        0x0000282A
    };

    static _CharacterInfo _character0000282B =
    {
        0x0000282B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282B,
        0x0000282B,
        0x0000282B
    };

    static _CharacterInfo _character0000282C =
    {
        0x0000282C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282C,
        0x0000282C,
        0x0000282C
    };

    static _CharacterInfo _character0000282D =
    {
        0x0000282D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282D,
        0x0000282D,
        0x0000282D
    };

    static _CharacterInfo _character0000282E =
    {
        0x0000282E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282E,
        0x0000282E,
        0x0000282E
    };

    static _CharacterInfo _character0000282F =
    {
        0x0000282F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000282F,
        0x0000282F,
        0x0000282F
    };

    static _CharacterInfo _character00002830 =
    {
        0x00002830,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002830,
        0x00002830,
        0x00002830
    };

    static _CharacterInfo _character00002831 =
    {
        0x00002831,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002831,
        0x00002831,
        0x00002831
    };

    static _CharacterInfo _character00002832 =
    {
        0x00002832,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002832,
        0x00002832,
        0x00002832
    };

    static _CharacterInfo _character00002833 =
    {
        0x00002833,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002833,
        0x00002833,
        0x00002833
    };

    static _CharacterInfo _character00002834 =
    {
        0x00002834,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002834,
        0x00002834,
        0x00002834
    };

    static _CharacterInfo _character00002835 =
    {
        0x00002835,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002835,
        0x00002835,
        0x00002835
    };

    static _CharacterInfo _character00002836 =
    {
        0x00002836,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002836,
        0x00002836,
        0x00002836
    };

    static _CharacterInfo _character00002837 =
    {
        0x00002837,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002837,
        0x00002837,
        0x00002837
    };

    static _CharacterInfo _character00002838 =
    {
        0x00002838,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002838,
        0x00002838,
        0x00002838
    };

    static _CharacterInfo _character00002839 =
    {
        0x00002839,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002839,
        0x00002839,
        0x00002839
    };

    static _CharacterInfo _character0000283A =
    {
        0x0000283A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283A,
        0x0000283A,
        0x0000283A
    };

    static _CharacterInfo _character0000283B =
    {
        0x0000283B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283B,
        0x0000283B,
        0x0000283B
    };

    static _CharacterInfo _character0000283C =
    {
        0x0000283C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283C,
        0x0000283C,
        0x0000283C
    };

    static _CharacterInfo _character0000283D =
    {
        0x0000283D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283D,
        0x0000283D,
        0x0000283D
    };

    static _CharacterInfo _character0000283E =
    {
        0x0000283E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283E,
        0x0000283E,
        0x0000283E
    };

    static _CharacterInfo _character0000283F =
    {
        0x0000283F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000283F,
        0x0000283F,
        0x0000283F
    };

    static _CharacterInfo _character00002840 =
    {
        0x00002840,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002840,
        0x00002840,
        0x00002840
    };

    static _CharacterInfo _character00002841 =
    {
        0x00002841,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002841,
        0x00002841,
        0x00002841
    };

    static _CharacterInfo _character00002842 =
    {
        0x00002842,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002842,
        0x00002842,
        0x00002842
    };

    static _CharacterInfo _character00002843 =
    {
        0x00002843,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002843,
        0x00002843,
        0x00002843
    };

    static _CharacterInfo _character00002844 =
    {
        0x00002844,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002844,
        0x00002844,
        0x00002844
    };

    static _CharacterInfo _character00002845 =
    {
        0x00002845,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002845,
        0x00002845,
        0x00002845
    };

    static _CharacterInfo _character00002846 =
    {
        0x00002846,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002846,
        0x00002846,
        0x00002846
    };

    static _CharacterInfo _character00002847 =
    {
        0x00002847,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002847,
        0x00002847,
        0x00002847
    };

    static _CharacterInfo _character00002848 =
    {
        0x00002848,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002848,
        0x00002848,
        0x00002848
    };

    static _CharacterInfo _character00002849 =
    {
        0x00002849,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002849,
        0x00002849,
        0x00002849
    };

    static _CharacterInfo _character0000284A =
    {
        0x0000284A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284A,
        0x0000284A,
        0x0000284A
    };

    static _CharacterInfo _character0000284B =
    {
        0x0000284B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284B,
        0x0000284B,
        0x0000284B
    };

    static _CharacterInfo _character0000284C =
    {
        0x0000284C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284C,
        0x0000284C,
        0x0000284C
    };

    static _CharacterInfo _character0000284D =
    {
        0x0000284D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284D,
        0x0000284D,
        0x0000284D
    };

    static _CharacterInfo _character0000284E =
    {
        0x0000284E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284E,
        0x0000284E,
        0x0000284E
    };

    static _CharacterInfo _character0000284F =
    {
        0x0000284F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000284F,
        0x0000284F,
        0x0000284F
    };

    static _CharacterInfo _character00002850 =
    {
        0x00002850,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002850,
        0x00002850,
        0x00002850
    };

    static _CharacterInfo _character00002851 =
    {
        0x00002851,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002851,
        0x00002851,
        0x00002851
    };

    static _CharacterInfo _character00002852 =
    {
        0x00002852,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002852,
        0x00002852,
        0x00002852
    };

    static _CharacterInfo _character00002853 =
    {
        0x00002853,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002853,
        0x00002853,
        0x00002853
    };

    static _CharacterInfo _character00002854 =
    {
        0x00002854,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002854,
        0x00002854,
        0x00002854
    };

    static _CharacterInfo _character00002855 =
    {
        0x00002855,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002855,
        0x00002855,
        0x00002855
    };

    static _CharacterInfo _character00002856 =
    {
        0x00002856,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002856,
        0x00002856,
        0x00002856
    };

    static _CharacterInfo _character00002857 =
    {
        0x00002857,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002857,
        0x00002857,
        0x00002857
    };

    static _CharacterInfo _character00002858 =
    {
        0x00002858,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002858,
        0x00002858,
        0x00002858
    };

    static _CharacterInfo _character00002859 =
    {
        0x00002859,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002859,
        0x00002859,
        0x00002859
    };

    static _CharacterInfo _character0000285A =
    {
        0x0000285A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285A,
        0x0000285A,
        0x0000285A
    };

    static _CharacterInfo _character0000285B =
    {
        0x0000285B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285B,
        0x0000285B,
        0x0000285B
    };

    static _CharacterInfo _character0000285C =
    {
        0x0000285C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285C,
        0x0000285C,
        0x0000285C
    };

    static _CharacterInfo _character0000285D =
    {
        0x0000285D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285D,
        0x0000285D,
        0x0000285D
    };

    static _CharacterInfo _character0000285E =
    {
        0x0000285E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285E,
        0x0000285E,
        0x0000285E
    };

    static _CharacterInfo _character0000285F =
    {
        0x0000285F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000285F,
        0x0000285F,
        0x0000285F
    };

    static _CharacterInfo _character00002860 =
    {
        0x00002860,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002860,
        0x00002860,
        0x00002860
    };

    static _CharacterInfo _character00002861 =
    {
        0x00002861,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002861,
        0x00002861,
        0x00002861
    };

    static _CharacterInfo _character00002862 =
    {
        0x00002862,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002862,
        0x00002862,
        0x00002862
    };

    static _CharacterInfo _character00002863 =
    {
        0x00002863,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002863,
        0x00002863,
        0x00002863
    };

    static _CharacterInfo _character00002864 =
    {
        0x00002864,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002864,
        0x00002864,
        0x00002864
    };

    static _CharacterInfo _character00002865 =
    {
        0x00002865,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002865,
        0x00002865,
        0x00002865
    };

    static _CharacterInfo _character00002866 =
    {
        0x00002866,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002866,
        0x00002866,
        0x00002866
    };

    static _CharacterInfo _character00002867 =
    {
        0x00002867,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002867,
        0x00002867,
        0x00002867
    };

    static _CharacterInfo _character00002868 =
    {
        0x00002868,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002868,
        0x00002868,
        0x00002868
    };

    static _CharacterInfo _character00002869 =
    {
        0x00002869,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002869,
        0x00002869,
        0x00002869
    };

    static _CharacterInfo _character0000286A =
    {
        0x0000286A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286A,
        0x0000286A,
        0x0000286A
    };

    static _CharacterInfo _character0000286B =
    {
        0x0000286B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286B,
        0x0000286B,
        0x0000286B
    };

    static _CharacterInfo _character0000286C =
    {
        0x0000286C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286C,
        0x0000286C,
        0x0000286C
    };

    static _CharacterInfo _character0000286D =
    {
        0x0000286D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286D,
        0x0000286D,
        0x0000286D
    };

    static _CharacterInfo _character0000286E =
    {
        0x0000286E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286E,
        0x0000286E,
        0x0000286E
    };

    static _CharacterInfo _character0000286F =
    {
        0x0000286F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000286F,
        0x0000286F,
        0x0000286F
    };

    static _CharacterInfo _character00002870 =
    {
        0x00002870,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002870,
        0x00002870,
        0x00002870
    };

    static _CharacterInfo _character00002871 =
    {
        0x00002871,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002871,
        0x00002871,
        0x00002871
    };

    static _CharacterInfo _character00002872 =
    {
        0x00002872,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002872,
        0x00002872,
        0x00002872
    };

    static _CharacterInfo _character00002873 =
    {
        0x00002873,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002873,
        0x00002873,
        0x00002873
    };

    static _CharacterInfo _character00002874 =
    {
        0x00002874,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002874,
        0x00002874,
        0x00002874
    };

    static _CharacterInfo _character00002875 =
    {
        0x00002875,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002875,
        0x00002875,
        0x00002875
    };

    static _CharacterInfo _character00002876 =
    {
        0x00002876,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002876,
        0x00002876,
        0x00002876
    };

    static _CharacterInfo _character00002877 =
    {
        0x00002877,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002877,
        0x00002877,
        0x00002877
    };

    static _CharacterInfo _character00002878 =
    {
        0x00002878,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002878,
        0x00002878,
        0x00002878
    };

    static _CharacterInfo _character00002879 =
    {
        0x00002879,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002879,
        0x00002879,
        0x00002879
    };

    static _CharacterInfo _character0000287A =
    {
        0x0000287A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287A,
        0x0000287A,
        0x0000287A
    };

    static _CharacterInfo _character0000287B =
    {
        0x0000287B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287B,
        0x0000287B,
        0x0000287B
    };

    static _CharacterInfo _character0000287C =
    {
        0x0000287C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287C,
        0x0000287C,
        0x0000287C
    };

    static _CharacterInfo _character0000287D =
    {
        0x0000287D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287D,
        0x0000287D,
        0x0000287D
    };

    static _CharacterInfo _character0000287E =
    {
        0x0000287E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287E,
        0x0000287E,
        0x0000287E
    };

    static _CharacterInfo _character0000287F =
    {
        0x0000287F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000287F,
        0x0000287F,
        0x0000287F
    };

    static _CharacterInfo _character00002880 =
    {
        0x00002880,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002880,
        0x00002880,
        0x00002880
    };

    static _CharacterInfo _character00002881 =
    {
        0x00002881,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002881,
        0x00002881,
        0x00002881
    };

    static _CharacterInfo _character00002882 =
    {
        0x00002882,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002882,
        0x00002882,
        0x00002882
    };

    static _CharacterInfo _character00002883 =
    {
        0x00002883,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002883,
        0x00002883,
        0x00002883
    };

    static _CharacterInfo _character00002884 =
    {
        0x00002884,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002884,
        0x00002884,
        0x00002884
    };

    static _CharacterInfo _character00002885 =
    {
        0x00002885,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002885,
        0x00002885,
        0x00002885
    };

    static _CharacterInfo _character00002886 =
    {
        0x00002886,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002886,
        0x00002886,
        0x00002886
    };

    static _CharacterInfo _character00002887 =
    {
        0x00002887,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002887,
        0x00002887,
        0x00002887
    };

    static _CharacterInfo _character00002888 =
    {
        0x00002888,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002888,
        0x00002888,
        0x00002888
    };

    static _CharacterInfo _character00002889 =
    {
        0x00002889,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002889,
        0x00002889,
        0x00002889
    };

    static _CharacterInfo _character0000288A =
    {
        0x0000288A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288A,
        0x0000288A,
        0x0000288A
    };

    static _CharacterInfo _character0000288B =
    {
        0x0000288B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288B,
        0x0000288B,
        0x0000288B
    };

    static _CharacterInfo _character0000288C =
    {
        0x0000288C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288C,
        0x0000288C,
        0x0000288C
    };

    static _CharacterInfo _character0000288D =
    {
        0x0000288D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288D,
        0x0000288D,
        0x0000288D
    };

    static _CharacterInfo _character0000288E =
    {
        0x0000288E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288E,
        0x0000288E,
        0x0000288E
    };

    static _CharacterInfo _character0000288F =
    {
        0x0000288F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000288F,
        0x0000288F,
        0x0000288F
    };

    static _CharacterInfo _character00002890 =
    {
        0x00002890,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002890,
        0x00002890,
        0x00002890
    };

    static _CharacterInfo _character00002891 =
    {
        0x00002891,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002891,
        0x00002891,
        0x00002891
    };

    static _CharacterInfo _character00002892 =
    {
        0x00002892,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002892,
        0x00002892,
        0x00002892
    };

    static _CharacterInfo _character00002893 =
    {
        0x00002893,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002893,
        0x00002893,
        0x00002893
    };

    static _CharacterInfo _character00002894 =
    {
        0x00002894,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002894,
        0x00002894,
        0x00002894
    };

    static _CharacterInfo _character00002895 =
    {
        0x00002895,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002895,
        0x00002895,
        0x00002895
    };

    static _CharacterInfo _character00002896 =
    {
        0x00002896,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002896,
        0x00002896,
        0x00002896
    };

    static _CharacterInfo _character00002897 =
    {
        0x00002897,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002897,
        0x00002897,
        0x00002897
    };

    static _CharacterInfo _character00002898 =
    {
        0x00002898,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002898,
        0x00002898,
        0x00002898
    };

    static _CharacterInfo _character00002899 =
    {
        0x00002899,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002899,
        0x00002899,
        0x00002899
    };

    static _CharacterInfo _character0000289A =
    {
        0x0000289A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289A,
        0x0000289A,
        0x0000289A
    };

    static _CharacterInfo _character0000289B =
    {
        0x0000289B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289B,
        0x0000289B,
        0x0000289B
    };

    static _CharacterInfo _character0000289C =
    {
        0x0000289C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289C,
        0x0000289C,
        0x0000289C
    };

    static _CharacterInfo _character0000289D =
    {
        0x0000289D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289D,
        0x0000289D,
        0x0000289D
    };

    static _CharacterInfo _character0000289E =
    {
        0x0000289E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289E,
        0x0000289E,
        0x0000289E
    };

    static _CharacterInfo _character0000289F =
    {
        0x0000289F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000289F,
        0x0000289F,
        0x0000289F
    };

    static _CharacterInfo _character000028A0 =
    {
        0x000028A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A0,
        0x000028A0,
        0x000028A0
    };

    static _CharacterInfo _character000028A1 =
    {
        0x000028A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A1,
        0x000028A1,
        0x000028A1
    };

    static _CharacterInfo _character000028A2 =
    {
        0x000028A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A2,
        0x000028A2,
        0x000028A2
    };

    static _CharacterInfo _character000028A3 =
    {
        0x000028A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A3,
        0x000028A3,
        0x000028A3
    };

    static _CharacterInfo _character000028A4 =
    {
        0x000028A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A4,
        0x000028A4,
        0x000028A4
    };

    static _CharacterInfo _character000028A5 =
    {
        0x000028A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A5,
        0x000028A5,
        0x000028A5
    };

    static _CharacterInfo _character000028A6 =
    {
        0x000028A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A6,
        0x000028A6,
        0x000028A6
    };

    static _CharacterInfo _character000028A7 =
    {
        0x000028A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A7,
        0x000028A7,
        0x000028A7
    };

    static _CharacterInfo _character000028A8 =
    {
        0x000028A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A8,
        0x000028A8,
        0x000028A8
    };

    static _CharacterInfo _character000028A9 =
    {
        0x000028A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028A9,
        0x000028A9,
        0x000028A9
    };

    static _CharacterInfo _character000028AA =
    {
        0x000028AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AA,
        0x000028AA,
        0x000028AA
    };

    static _CharacterInfo _character000028AB =
    {
        0x000028AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AB,
        0x000028AB,
        0x000028AB
    };

    static _CharacterInfo _character000028AC =
    {
        0x000028AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AC,
        0x000028AC,
        0x000028AC
    };

    static _CharacterInfo _character000028AD =
    {
        0x000028AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AD,
        0x000028AD,
        0x000028AD
    };

    static _CharacterInfo _character000028AE =
    {
        0x000028AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AE,
        0x000028AE,
        0x000028AE
    };

    static _CharacterInfo _character000028AF =
    {
        0x000028AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028AF,
        0x000028AF,
        0x000028AF
    };

    static _CharacterInfo _character000028B0 =
    {
        0x000028B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B0,
        0x000028B0,
        0x000028B0
    };

    static _CharacterInfo _character000028B1 =
    {
        0x000028B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B1,
        0x000028B1,
        0x000028B1
    };

    static _CharacterInfo _character000028B2 =
    {
        0x000028B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B2,
        0x000028B2,
        0x000028B2
    };

    static _CharacterInfo _character000028B3 =
    {
        0x000028B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B3,
        0x000028B3,
        0x000028B3
    };

    static _CharacterInfo _character000028B4 =
    {
        0x000028B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B4,
        0x000028B4,
        0x000028B4
    };

    static _CharacterInfo _character000028B5 =
    {
        0x000028B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B5,
        0x000028B5,
        0x000028B5
    };

    static _CharacterInfo _character000028B6 =
    {
        0x000028B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B6,
        0x000028B6,
        0x000028B6
    };

    static _CharacterInfo _character000028B7 =
    {
        0x000028B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B7,
        0x000028B7,
        0x000028B7
    };

    static _CharacterInfo _character000028B8 =
    {
        0x000028B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B8,
        0x000028B8,
        0x000028B8
    };

    static _CharacterInfo _character000028B9 =
    {
        0x000028B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028B9,
        0x000028B9,
        0x000028B9
    };

    static _CharacterInfo _character000028BA =
    {
        0x000028BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BA,
        0x000028BA,
        0x000028BA
    };

    static _CharacterInfo _character000028BB =
    {
        0x000028BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BB,
        0x000028BB,
        0x000028BB
    };

    static _CharacterInfo _character000028BC =
    {
        0x000028BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BC,
        0x000028BC,
        0x000028BC
    };

    static _CharacterInfo _character000028BD =
    {
        0x000028BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BD,
        0x000028BD,
        0x000028BD
    };

    static _CharacterInfo _character000028BE =
    {
        0x000028BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BE,
        0x000028BE,
        0x000028BE
    };

    static _CharacterInfo _character000028BF =
    {
        0x000028BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028BF,
        0x000028BF,
        0x000028BF
    };

    static _CharacterInfo _character000028C0 =
    {
        0x000028C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C0,
        0x000028C0,
        0x000028C0
    };

    static _CharacterInfo _character000028C1 =
    {
        0x000028C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C1,
        0x000028C1,
        0x000028C1
    };

    static _CharacterInfo _character000028C2 =
    {
        0x000028C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C2,
        0x000028C2,
        0x000028C2
    };

    static _CharacterInfo _character000028C3 =
    {
        0x000028C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C3,
        0x000028C3,
        0x000028C3
    };

    static _CharacterInfo _character000028C4 =
    {
        0x000028C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C4,
        0x000028C4,
        0x000028C4
    };

    static _CharacterInfo _character000028C5 =
    {
        0x000028C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C5,
        0x000028C5,
        0x000028C5
    };

    static _CharacterInfo _character000028C6 =
    {
        0x000028C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C6,
        0x000028C6,
        0x000028C6
    };

    static _CharacterInfo _character000028C7 =
    {
        0x000028C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C7,
        0x000028C7,
        0x000028C7
    };

    static _CharacterInfo _character000028C8 =
    {
        0x000028C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C8,
        0x000028C8,
        0x000028C8
    };

    static _CharacterInfo _character000028C9 =
    {
        0x000028C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028C9,
        0x000028C9,
        0x000028C9
    };

    static _CharacterInfo _character000028CA =
    {
        0x000028CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CA,
        0x000028CA,
        0x000028CA
    };

    static _CharacterInfo _character000028CB =
    {
        0x000028CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CB,
        0x000028CB,
        0x000028CB
    };

    static _CharacterInfo _character000028CC =
    {
        0x000028CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CC,
        0x000028CC,
        0x000028CC
    };

    static _CharacterInfo _character000028CD =
    {
        0x000028CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CD,
        0x000028CD,
        0x000028CD
    };

    static _CharacterInfo _character000028CE =
    {
        0x000028CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CE,
        0x000028CE,
        0x000028CE
    };

    static _CharacterInfo _character000028CF =
    {
        0x000028CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028CF,
        0x000028CF,
        0x000028CF
    };

    static _CharacterInfo _character000028D0 =
    {
        0x000028D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D0,
        0x000028D0,
        0x000028D0
    };

    static _CharacterInfo _character000028D1 =
    {
        0x000028D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D1,
        0x000028D1,
        0x000028D1
    };

    static _CharacterInfo _character000028D2 =
    {
        0x000028D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D2,
        0x000028D2,
        0x000028D2
    };

    static _CharacterInfo _character000028D3 =
    {
        0x000028D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D3,
        0x000028D3,
        0x000028D3
    };

    static _CharacterInfo _character000028D4 =
    {
        0x000028D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D4,
        0x000028D4,
        0x000028D4
    };

    static _CharacterInfo _character000028D5 =
    {
        0x000028D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D5,
        0x000028D5,
        0x000028D5
    };

    static _CharacterInfo _character000028D6 =
    {
        0x000028D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D6,
        0x000028D6,
        0x000028D6
    };

    static _CharacterInfo _character000028D7 =
    {
        0x000028D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D7,
        0x000028D7,
        0x000028D7
    };

    static _CharacterInfo _character000028D8 =
    {
        0x000028D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D8,
        0x000028D8,
        0x000028D8
    };

    static _CharacterInfo _character000028D9 =
    {
        0x000028D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028D9,
        0x000028D9,
        0x000028D9
    };

    static _CharacterInfo _character000028DA =
    {
        0x000028DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DA,
        0x000028DA,
        0x000028DA
    };

    static _CharacterInfo _character000028DB =
    {
        0x000028DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DB,
        0x000028DB,
        0x000028DB
    };

    static _CharacterInfo _character000028DC =
    {
        0x000028DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DC,
        0x000028DC,
        0x000028DC
    };

    static _CharacterInfo _character000028DD =
    {
        0x000028DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DD,
        0x000028DD,
        0x000028DD
    };

    static _CharacterInfo _character000028DE =
    {
        0x000028DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DE,
        0x000028DE,
        0x000028DE
    };

    static _CharacterInfo _character000028DF =
    {
        0x000028DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028DF,
        0x000028DF,
        0x000028DF
    };

    static _CharacterInfo _character000028E0 =
    {
        0x000028E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E0,
        0x000028E0,
        0x000028E0
    };

    static _CharacterInfo _character000028E1 =
    {
        0x000028E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E1,
        0x000028E1,
        0x000028E1
    };

    static _CharacterInfo _character000028E2 =
    {
        0x000028E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E2,
        0x000028E2,
        0x000028E2
    };

    static _CharacterInfo _character000028E3 =
    {
        0x000028E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E3,
        0x000028E3,
        0x000028E3
    };

    static _CharacterInfo _character000028E4 =
    {
        0x000028E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E4,
        0x000028E4,
        0x000028E4
    };

    static _CharacterInfo _character000028E5 =
    {
        0x000028E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E5,
        0x000028E5,
        0x000028E5
    };

    static _CharacterInfo _character000028E6 =
    {
        0x000028E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E6,
        0x000028E6,
        0x000028E6
    };

    static _CharacterInfo _character000028E7 =
    {
        0x000028E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E7,
        0x000028E7,
        0x000028E7
    };

    static _CharacterInfo _character000028E8 =
    {
        0x000028E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E8,
        0x000028E8,
        0x000028E8
    };

    static _CharacterInfo _character000028E9 =
    {
        0x000028E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028E9,
        0x000028E9,
        0x000028E9
    };

    static _CharacterInfo _character000028EA =
    {
        0x000028EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028EA,
        0x000028EA,
        0x000028EA
    };

    static _CharacterInfo _character000028EB =
    {
        0x000028EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028EB,
        0x000028EB,
        0x000028EB
    };

    static _CharacterInfo _character000028EC =
    {
        0x000028EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028EC,
        0x000028EC,
        0x000028EC
    };

    static _CharacterInfo _character000028ED =
    {
        0x000028ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028ED,
        0x000028ED,
        0x000028ED
    };

    static _CharacterInfo _character000028EE =
    {
        0x000028EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028EE,
        0x000028EE,
        0x000028EE
    };

    static _CharacterInfo _character000028EF =
    {
        0x000028EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028EF,
        0x000028EF,
        0x000028EF
    };

    static _CharacterInfo _character000028F0 =
    {
        0x000028F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F0,
        0x000028F0,
        0x000028F0
    };

    static _CharacterInfo _character000028F1 =
    {
        0x000028F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F1,
        0x000028F1,
        0x000028F1
    };

    static _CharacterInfo _character000028F2 =
    {
        0x000028F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F2,
        0x000028F2,
        0x000028F2
    };

    static _CharacterInfo _character000028F3 =
    {
        0x000028F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F3,
        0x000028F3,
        0x000028F3
    };

    static _CharacterInfo _character000028F4 =
    {
        0x000028F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F4,
        0x000028F4,
        0x000028F4
    };

    static _CharacterInfo _character000028F5 =
    {
        0x000028F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F5,
        0x000028F5,
        0x000028F5
    };

    static _CharacterInfo _character000028F6 =
    {
        0x000028F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F6,
        0x000028F6,
        0x000028F6
    };

    static _CharacterInfo _character000028F7 =
    {
        0x000028F7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F7,
        0x000028F7,
        0x000028F7
    };

    static _CharacterInfo _character000028F8 =
    {
        0x000028F8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F8,
        0x000028F8,
        0x000028F8
    };

    static _CharacterInfo _character000028F9 =
    {
        0x000028F9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028F9,
        0x000028F9,
        0x000028F9
    };

    static _CharacterInfo _character000028FA =
    {
        0x000028FA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FA,
        0x000028FA,
        0x000028FA
    };

    static _CharacterInfo _character000028FB =
    {
        0x000028FB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FB,
        0x000028FB,
        0x000028FB
    };

    static _CharacterInfo _character000028FC =
    {
        0x000028FC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FC,
        0x000028FC,
        0x000028FC
    };

    static _CharacterInfo _character000028FD =
    {
        0x000028FD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FD,
        0x000028FD,
        0x000028FD
    };

    static _CharacterInfo _character000028FE =
    {
        0x000028FE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FE,
        0x000028FE,
        0x000028FE
    };

    static _CharacterInfo _character000028FF =
    {
        0x000028FF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000028FF,
        0x000028FF,
        0x000028FF
    };

    static _CharacterInfo _character00002900 =
    {
        0x00002900,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002900,
        0x00002900,
        0x00002900
    };

    static _CharacterInfo _character00002901 =
    {
        0x00002901,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002901,
        0x00002901,
        0x00002901
    };

    static _CharacterInfo _character00002902 =
    {
        0x00002902,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002902,
        0x00002902,
        0x00002902
    };

    static _CharacterInfo _character00002903 =
    {
        0x00002903,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002903,
        0x00002903,
        0x00002903
    };

    static _CharacterInfo _character00002904 =
    {
        0x00002904,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002904,
        0x00002904,
        0x00002904
    };

    static _CharacterInfo _character00002905 =
    {
        0x00002905,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002905,
        0x00002905,
        0x00002905
    };

    static _CharacterInfo _character00002906 =
    {
        0x00002906,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002906,
        0x00002906,
        0x00002906
    };

    static _CharacterInfo _character00002907 =
    {
        0x00002907,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002907,
        0x00002907,
        0x00002907
    };

    static _CharacterInfo _character00002908 =
    {
        0x00002908,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002908,
        0x00002908,
        0x00002908
    };

    static _CharacterInfo _character00002909 =
    {
        0x00002909,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002909,
        0x00002909,
        0x00002909
    };

    static _CharacterInfo _character0000290A =
    {
        0x0000290A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290A,
        0x0000290A,
        0x0000290A
    };

    static _CharacterInfo _character0000290B =
    {
        0x0000290B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290B,
        0x0000290B,
        0x0000290B
    };

    static _CharacterInfo _character0000290C =
    {
        0x0000290C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290C,
        0x0000290C,
        0x0000290C
    };

    static _CharacterInfo _character0000290D =
    {
        0x0000290D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290D,
        0x0000290D,
        0x0000290D
    };

    static _CharacterInfo _character0000290E =
    {
        0x0000290E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290E,
        0x0000290E,
        0x0000290E
    };

    static _CharacterInfo _character0000290F =
    {
        0x0000290F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000290F,
        0x0000290F,
        0x0000290F
    };

    static _CharacterInfo _character00002910 =
    {
        0x00002910,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002910,
        0x00002910,
        0x00002910
    };

    static _CharacterInfo _character00002911 =
    {
        0x00002911,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002911,
        0x00002911,
        0x00002911
    };

    static _CharacterInfo _character00002912 =
    {
        0x00002912,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002912,
        0x00002912,
        0x00002912
    };

    static _CharacterInfo _character00002913 =
    {
        0x00002913,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002913,
        0x00002913,
        0x00002913
    };

    static _CharacterInfo _character00002914 =
    {
        0x00002914,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002914,
        0x00002914,
        0x00002914
    };

    static _CharacterInfo _character00002915 =
    {
        0x00002915,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002915,
        0x00002915,
        0x00002915
    };

    static _CharacterInfo _character00002916 =
    {
        0x00002916,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002916,
        0x00002916,
        0x00002916
    };

    static _CharacterInfo _character00002917 =
    {
        0x00002917,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002917,
        0x00002917,
        0x00002917
    };

    static _CharacterInfo _character00002918 =
    {
        0x00002918,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002918,
        0x00002918,
        0x00002918
    };

    static _CharacterInfo _character00002919 =
    {
        0x00002919,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002919,
        0x00002919,
        0x00002919
    };

    static _CharacterInfo _character0000291A =
    {
        0x0000291A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291A,
        0x0000291A,
        0x0000291A
    };

    static _CharacterInfo _character0000291B =
    {
        0x0000291B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291B,
        0x0000291B,
        0x0000291B
    };

    static _CharacterInfo _character0000291C =
    {
        0x0000291C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291C,
        0x0000291C,
        0x0000291C
    };

    static _CharacterInfo _character0000291D =
    {
        0x0000291D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291D,
        0x0000291D,
        0x0000291D
    };

    static _CharacterInfo _character0000291E =
    {
        0x0000291E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291E,
        0x0000291E,
        0x0000291E
    };

    static _CharacterInfo _character0000291F =
    {
        0x0000291F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000291F,
        0x0000291F,
        0x0000291F
    };

    static _CharacterInfo _character00002920 =
    {
        0x00002920,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002920,
        0x00002920,
        0x00002920
    };

    static _CharacterInfo _character00002921 =
    {
        0x00002921,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002921,
        0x00002921,
        0x00002921
    };

    static _CharacterInfo _character00002922 =
    {
        0x00002922,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002922,
        0x00002922,
        0x00002922
    };

    static _CharacterInfo _character00002923 =
    {
        0x00002923,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002923,
        0x00002923,
        0x00002923
    };

    static _CharacterInfo _character00002924 =
    {
        0x00002924,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002924,
        0x00002924,
        0x00002924
    };

    static _CharacterInfo _character00002925 =
    {
        0x00002925,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002925,
        0x00002925,
        0x00002925
    };

    static _CharacterInfo _character00002926 =
    {
        0x00002926,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002926,
        0x00002926,
        0x00002926
    };

    static _CharacterInfo _character00002927 =
    {
        0x00002927,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002927,
        0x00002927,
        0x00002927
    };

    static _CharacterInfo _character00002928 =
    {
        0x00002928,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002928,
        0x00002928,
        0x00002928
    };

    static _CharacterInfo _character00002929 =
    {
        0x00002929,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002929,
        0x00002929,
        0x00002929
    };

    static _CharacterInfo _character0000292A =
    {
        0x0000292A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292A,
        0x0000292A,
        0x0000292A
    };

    static _CharacterInfo _character0000292B =
    {
        0x0000292B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292B,
        0x0000292B,
        0x0000292B
    };

    static _CharacterInfo _character0000292C =
    {
        0x0000292C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292C,
        0x0000292C,
        0x0000292C
    };

    static _CharacterInfo _character0000292D =
    {
        0x0000292D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292D,
        0x0000292D,
        0x0000292D
    };

    static _CharacterInfo _character0000292E =
    {
        0x0000292E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292E,
        0x0000292E,
        0x0000292E
    };

    static _CharacterInfo _character0000292F =
    {
        0x0000292F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000292F,
        0x0000292F,
        0x0000292F
    };

    static _CharacterInfo _character00002930 =
    {
        0x00002930,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002930,
        0x00002930,
        0x00002930
    };

    static _CharacterInfo _character00002931 =
    {
        0x00002931,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002931,
        0x00002931,
        0x00002931
    };

    static _CharacterInfo _character00002932 =
    {
        0x00002932,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002932,
        0x00002932,
        0x00002932
    };

    static _CharacterInfo _character00002933 =
    {
        0x00002933,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002933,
        0x00002933,
        0x00002933
    };

    static _CharacterInfo _character00002934 =
    {
        0x00002934,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002934,
        0x00002934,
        0x00002934
    };

    static _CharacterInfo _character00002935 =
    {
        0x00002935,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002935,
        0x00002935,
        0x00002935
    };

    static _CharacterInfo _character00002936 =
    {
        0x00002936,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002936,
        0x00002936,
        0x00002936
    };

    static _CharacterInfo _character00002937 =
    {
        0x00002937,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002937,
        0x00002937,
        0x00002937
    };

    static _CharacterInfo _character00002938 =
    {
        0x00002938,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002938,
        0x00002938,
        0x00002938
    };

    static _CharacterInfo _character00002939 =
    {
        0x00002939,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002939,
        0x00002939,
        0x00002939
    };

    static _CharacterInfo _character0000293A =
    {
        0x0000293A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293A,
        0x0000293A,
        0x0000293A
    };

    static _CharacterInfo _character0000293B =
    {
        0x0000293B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293B,
        0x0000293B,
        0x0000293B
    };

    static _CharacterInfo _character0000293C =
    {
        0x0000293C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293C,
        0x0000293C,
        0x0000293C
    };

    static _CharacterInfo _character0000293D =
    {
        0x0000293D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293D,
        0x0000293D,
        0x0000293D
    };

    static _CharacterInfo _character0000293E =
    {
        0x0000293E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293E,
        0x0000293E,
        0x0000293E
    };

    static _CharacterInfo _character0000293F =
    {
        0x0000293F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000293F,
        0x0000293F,
        0x0000293F
    };

    static _CharacterInfo _character00002940 =
    {
        0x00002940,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002940,
        0x00002940,
        0x00002940
    };

    static _CharacterInfo _character00002941 =
    {
        0x00002941,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002941,
        0x00002941,
        0x00002941
    };

    static _CharacterInfo _character00002942 =
    {
        0x00002942,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002942,
        0x00002942,
        0x00002942
    };

    static _CharacterInfo _character00002943 =
    {
        0x00002943,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002943,
        0x00002943,
        0x00002943
    };

    static _CharacterInfo _character00002944 =
    {
        0x00002944,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002944,
        0x00002944,
        0x00002944
    };

    static _CharacterInfo _character00002945 =
    {
        0x00002945,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002945,
        0x00002945,
        0x00002945
    };

    static _CharacterInfo _character00002946 =
    {
        0x00002946,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002946,
        0x00002946,
        0x00002946
    };

    static _CharacterInfo _character00002947 =
    {
        0x00002947,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002947,
        0x00002947,
        0x00002947
    };

    static _CharacterInfo _character00002948 =
    {
        0x00002948,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002948,
        0x00002948,
        0x00002948
    };

    static _CharacterInfo _character00002949 =
    {
        0x00002949,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002949,
        0x00002949,
        0x00002949
    };

    static _CharacterInfo _character0000294A =
    {
        0x0000294A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294A,
        0x0000294A,
        0x0000294A
    };

    static _CharacterInfo _character0000294B =
    {
        0x0000294B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294B,
        0x0000294B,
        0x0000294B
    };

    static _CharacterInfo _character0000294C =
    {
        0x0000294C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294C,
        0x0000294C,
        0x0000294C
    };

    static _CharacterInfo _character0000294D =
    {
        0x0000294D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294D,
        0x0000294D,
        0x0000294D
    };

    static _CharacterInfo _character0000294E =
    {
        0x0000294E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294E,
        0x0000294E,
        0x0000294E
    };

    static _CharacterInfo _character0000294F =
    {
        0x0000294F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000294F,
        0x0000294F,
        0x0000294F
    };

    static _CharacterInfo _character00002950 =
    {
        0x00002950,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002950,
        0x00002950,
        0x00002950
    };

    static _CharacterInfo _character00002951 =
    {
        0x00002951,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002951,
        0x00002951,
        0x00002951
    };

    static _CharacterInfo _character00002952 =
    {
        0x00002952,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002952,
        0x00002952,
        0x00002952
    };

    static _CharacterInfo _character00002953 =
    {
        0x00002953,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002953,
        0x00002953,
        0x00002953
    };

    static _CharacterInfo _character00002954 =
    {
        0x00002954,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002954,
        0x00002954,
        0x00002954
    };

    static _CharacterInfo _character00002955 =
    {
        0x00002955,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002955,
        0x00002955,
        0x00002955
    };

    static _CharacterInfo _character00002956 =
    {
        0x00002956,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002956,
        0x00002956,
        0x00002956
    };

    static _CharacterInfo _character00002957 =
    {
        0x00002957,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002957,
        0x00002957,
        0x00002957
    };

    static _CharacterInfo _character00002958 =
    {
        0x00002958,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002958,
        0x00002958,
        0x00002958
    };

    static _CharacterInfo _character00002959 =
    {
        0x00002959,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002959,
        0x00002959,
        0x00002959
    };

    static _CharacterInfo _character0000295A =
    {
        0x0000295A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295A,
        0x0000295A,
        0x0000295A
    };

    static _CharacterInfo _character0000295B =
    {
        0x0000295B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295B,
        0x0000295B,
        0x0000295B
    };

    static _CharacterInfo _character0000295C =
    {
        0x0000295C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295C,
        0x0000295C,
        0x0000295C
    };

    static _CharacterInfo _character0000295D =
    {
        0x0000295D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295D,
        0x0000295D,
        0x0000295D
    };

    static _CharacterInfo _character0000295E =
    {
        0x0000295E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295E,
        0x0000295E,
        0x0000295E
    };

    static _CharacterInfo _character0000295F =
    {
        0x0000295F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000295F,
        0x0000295F,
        0x0000295F
    };

    static _CharacterInfo _character00002960 =
    {
        0x00002960,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002960,
        0x00002960,
        0x00002960
    };

    static _CharacterInfo _character00002961 =
    {
        0x00002961,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002961,
        0x00002961,
        0x00002961
    };

    static _CharacterInfo _character00002962 =
    {
        0x00002962,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002962,
        0x00002962,
        0x00002962
    };

    static _CharacterInfo _character00002963 =
    {
        0x00002963,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002963,
        0x00002963,
        0x00002963
    };

    static _CharacterInfo _character00002964 =
    {
        0x00002964,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002964,
        0x00002964,
        0x00002964
    };

    static _CharacterInfo _character00002965 =
    {
        0x00002965,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002965,
        0x00002965,
        0x00002965
    };

    static _CharacterInfo _character00002966 =
    {
        0x00002966,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002966,
        0x00002966,
        0x00002966
    };

    static _CharacterInfo _character00002967 =
    {
        0x00002967,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002967,
        0x00002967,
        0x00002967
    };

    static _CharacterInfo _character00002968 =
    {
        0x00002968,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002968,
        0x00002968,
        0x00002968
    };

    static _CharacterInfo _character00002969 =
    {
        0x00002969,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002969,
        0x00002969,
        0x00002969
    };

    static _CharacterInfo _character0000296A =
    {
        0x0000296A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296A,
        0x0000296A,
        0x0000296A
    };

    static _CharacterInfo _character0000296B =
    {
        0x0000296B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296B,
        0x0000296B,
        0x0000296B
    };

    static _CharacterInfo _character0000296C =
    {
        0x0000296C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296C,
        0x0000296C,
        0x0000296C
    };

    static _CharacterInfo _character0000296D =
    {
        0x0000296D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296D,
        0x0000296D,
        0x0000296D
    };

    static _CharacterInfo _character0000296E =
    {
        0x0000296E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296E,
        0x0000296E,
        0x0000296E
    };

    static _CharacterInfo _character0000296F =
    {
        0x0000296F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000296F,
        0x0000296F,
        0x0000296F
    };

    static _CharacterInfo _character00002970 =
    {
        0x00002970,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002970,
        0x00002970,
        0x00002970
    };

    static _CharacterInfo _character00002971 =
    {
        0x00002971,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002971,
        0x00002971,
        0x00002971
    };

    static _CharacterInfo _character00002972 =
    {
        0x00002972,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002972,
        0x00002972,
        0x00002972
    };

    static _CharacterInfo _character00002973 =
    {
        0x00002973,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002973,
        0x00002973,
        0x00002973
    };

    static _CharacterInfo _character00002974 =
    {
        0x00002974,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002974,
        0x00002974,
        0x00002974
    };

    static _CharacterInfo _character00002975 =
    {
        0x00002975,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002975,
        0x00002975,
        0x00002975
    };

    static _CharacterInfo _character00002976 =
    {
        0x00002976,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002976,
        0x00002976,
        0x00002976
    };

    static _CharacterInfo _character00002977 =
    {
        0x00002977,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002977,
        0x00002977,
        0x00002977
    };

    static _CharacterInfo _character00002978 =
    {
        0x00002978,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002978,
        0x00002978,
        0x00002978
    };

    static _CharacterInfo _character00002979 =
    {
        0x00002979,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002979,
        0x00002979,
        0x00002979
    };

    static _CharacterInfo _character0000297A =
    {
        0x0000297A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297A,
        0x0000297A,
        0x0000297A
    };

    static _CharacterInfo _character0000297B =
    {
        0x0000297B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297B,
        0x0000297B,
        0x0000297B
    };

    static _CharacterInfo _character0000297C =
    {
        0x0000297C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297C,
        0x0000297C,
        0x0000297C
    };

    static _CharacterInfo _character0000297D =
    {
        0x0000297D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297D,
        0x0000297D,
        0x0000297D
    };

    static _CharacterInfo _character0000297E =
    {
        0x0000297E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297E,
        0x0000297E,
        0x0000297E
    };

    static _CharacterInfo _character0000297F =
    {
        0x0000297F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000297F,
        0x0000297F,
        0x0000297F
    };

    static _CharacterInfo _character00002980 =
    {
        0x00002980,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002980,
        0x00002980,
        0x00002980
    };

    static _CharacterInfo _character00002981 =
    {
        0x00002981,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002981,
        0x00002981,
        0x00002981
    };

    static _CharacterInfo _character00002982 =
    {
        0x00002982,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002982,
        0x00002982,
        0x00002982
    };

    static _CharacterInfo _character00002983 =
    {
        0x00002983,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002983,
        0x00002983,
        0x00002983
    };

    static _CharacterInfo _character00002984 =
    {
        0x00002984,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002984,
        0x00002984,
        0x00002984
    };

    static _CharacterInfo _character00002985 =
    {
        0x00002985,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002985,
        0x00002985,
        0x00002985
    };

    static _CharacterInfo _character00002986 =
    {
        0x00002986,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002986,
        0x00002986,
        0x00002986
    };

    static _CharacterInfo _character00002987 =
    {
        0x00002987,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002987,
        0x00002987,
        0x00002987
    };

    static _CharacterInfo _character00002988 =
    {
        0x00002988,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002988,
        0x00002988,
        0x00002988
    };

    static _CharacterInfo _character00002989 =
    {
        0x00002989,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002989,
        0x00002989,
        0x00002989
    };

    static _CharacterInfo _character0000298A =
    {
        0x0000298A,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298A,
        0x0000298A,
        0x0000298A
    };

    static _CharacterInfo _character0000298B =
    {
        0x0000298B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298B,
        0x0000298B,
        0x0000298B
    };

    static _CharacterInfo _character0000298C =
    {
        0x0000298C,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298C,
        0x0000298C,
        0x0000298C
    };

    static _CharacterInfo _character0000298D =
    {
        0x0000298D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298D,
        0x0000298D,
        0x0000298D
    };

    static _CharacterInfo _character0000298E =
    {
        0x0000298E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298E,
        0x0000298E,
        0x0000298E
    };

    static _CharacterInfo _character0000298F =
    {
        0x0000298F,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000298F,
        0x0000298F,
        0x0000298F
    };

    static _CharacterInfo _character00002990 =
    {
        0x00002990,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002990,
        0x00002990,
        0x00002990
    };

    static _CharacterInfo _character00002991 =
    {
        0x00002991,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002991,
        0x00002991,
        0x00002991
    };

    static _CharacterInfo _character00002992 =
    {
        0x00002992,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002992,
        0x00002992,
        0x00002992
    };

    static _CharacterInfo _character00002993 =
    {
        0x00002993,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002993,
        0x00002993,
        0x00002993
    };

    static _CharacterInfo _character00002994 =
    {
        0x00002994,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002994,
        0x00002994,
        0x00002994
    };

    static _CharacterInfo _character00002995 =
    {
        0x00002995,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002995,
        0x00002995,
        0x00002995
    };

    static _CharacterInfo _character00002996 =
    {
        0x00002996,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002996,
        0x00002996,
        0x00002996
    };

    static _CharacterInfo _character00002997 =
    {
        0x00002997,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002997,
        0x00002997,
        0x00002997
    };

    static _CharacterInfo _character00002998 =
    {
        0x00002998,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002998,
        0x00002998,
        0x00002998
    };

    static _CharacterInfo _character00002999 =
    {
        0x00002999,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002999,
        0x00002999,
        0x00002999
    };

    static _CharacterInfo _character0000299A =
    {
        0x0000299A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000299A,
        0x0000299A,
        0x0000299A
    };

    static _CharacterInfo _character0000299B =
    {
        0x0000299B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000299B,
        0x0000299B,
        0x0000299B
    };

    static _CharacterInfo _character0000299C =
    {
        0x0000299C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000299C,
        0x0000299C,
        0x0000299C
    };

    static _CharacterInfo _character0000299D =
    {
        0x0000299D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000299D,
        0x0000299D,
        0x0000299D
    };

    static _CharacterInfo _character0000299E =
    {
        0x0000299E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000299E,
        0x0000299E,
        0x0000299E
    };

    static _CharacterInfo _character0000299F =
    {
        0x0000299F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000299F,
        0x0000299F,
        0x0000299F
    };

    static _CharacterInfo _character000029A0 =
    {
        0x000029A0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A0,
        0x000029A0,
        0x000029A0
    };

    static _CharacterInfo _character000029A1 =
    {
        0x000029A1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A1,
        0x000029A1,
        0x000029A1
    };

    static _CharacterInfo _character000029A2 =
    {
        0x000029A2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A2,
        0x000029A2,
        0x000029A2
    };

    static _CharacterInfo _character000029A3 =
    {
        0x000029A3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A3,
        0x000029A3,
        0x000029A3
    };

    static _CharacterInfo _character000029A4 =
    {
        0x000029A4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A4,
        0x000029A4,
        0x000029A4
    };

    static _CharacterInfo _character000029A5 =
    {
        0x000029A5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A5,
        0x000029A5,
        0x000029A5
    };

    static _CharacterInfo _character000029A6 =
    {
        0x000029A6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A6,
        0x000029A6,
        0x000029A6
    };

    static _CharacterInfo _character000029A7 =
    {
        0x000029A7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A7,
        0x000029A7,
        0x000029A7
    };

    static _CharacterInfo _character000029A8 =
    {
        0x000029A8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A8,
        0x000029A8,
        0x000029A8
    };

    static _CharacterInfo _character000029A9 =
    {
        0x000029A9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029A9,
        0x000029A9,
        0x000029A9
    };

    static _CharacterInfo _character000029AA =
    {
        0x000029AA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AA,
        0x000029AA,
        0x000029AA
    };

    static _CharacterInfo _character000029AB =
    {
        0x000029AB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AB,
        0x000029AB,
        0x000029AB
    };

    static _CharacterInfo _character000029AC =
    {
        0x000029AC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AC,
        0x000029AC,
        0x000029AC
    };

    static _CharacterInfo _character000029AD =
    {
        0x000029AD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AD,
        0x000029AD,
        0x000029AD
    };

    static _CharacterInfo _character000029AE =
    {
        0x000029AE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AE,
        0x000029AE,
        0x000029AE
    };

    static _CharacterInfo _character000029AF =
    {
        0x000029AF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029AF,
        0x000029AF,
        0x000029AF
    };

    static _CharacterInfo _character000029B0 =
    {
        0x000029B0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B0,
        0x000029B0,
        0x000029B0
    };

    static _CharacterInfo _character000029B1 =
    {
        0x000029B1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B1,
        0x000029B1,
        0x000029B1
    };

    static _CharacterInfo _character000029B2 =
    {
        0x000029B2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B2,
        0x000029B2,
        0x000029B2
    };

    static _CharacterInfo _character000029B3 =
    {
        0x000029B3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B3,
        0x000029B3,
        0x000029B3
    };

    static _CharacterInfo _character000029B4 =
    {
        0x000029B4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B4,
        0x000029B4,
        0x000029B4
    };

    static _CharacterInfo _character000029B5 =
    {
        0x000029B5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B5,
        0x000029B5,
        0x000029B5
    };

    static _CharacterInfo _character000029B6 =
    {
        0x000029B6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B6,
        0x000029B6,
        0x000029B6
    };

    static _CharacterInfo _character000029B7 =
    {
        0x000029B7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B7,
        0x000029B7,
        0x000029B7
    };

    static _CharacterInfo _character000029B8 =
    {
        0x000029B8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029B8,
        0x000029B8,
        0x000029B8
    };

    static _CharacterInfo _character000029B9 =
    {
        0x000029B9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029B9,
        0x000029B9,
        0x000029B9
    };

    static _CharacterInfo _character000029BA =
    {
        0x000029BA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BA,
        0x000029BA,
        0x000029BA
    };

    static _CharacterInfo _character000029BB =
    {
        0x000029BB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BB,
        0x000029BB,
        0x000029BB
    };

    static _CharacterInfo _character000029BC =
    {
        0x000029BC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BC,
        0x000029BC,
        0x000029BC
    };

    static _CharacterInfo _character000029BD =
    {
        0x000029BD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BD,
        0x000029BD,
        0x000029BD
    };

    static _CharacterInfo _character000029BE =
    {
        0x000029BE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BE,
        0x000029BE,
        0x000029BE
    };

    static _CharacterInfo _character000029BF =
    {
        0x000029BF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029BF,
        0x000029BF,
        0x000029BF
    };

    static _CharacterInfo _character000029C0 =
    {
        0x000029C0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C0,
        0x000029C0,
        0x000029C0
    };

    static _CharacterInfo _character000029C1 =
    {
        0x000029C1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C1,
        0x000029C1,
        0x000029C1
    };

    static _CharacterInfo _character000029C2 =
    {
        0x000029C2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C2,
        0x000029C2,
        0x000029C2
    };

    static _CharacterInfo _character000029C3 =
    {
        0x000029C3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C3,
        0x000029C3,
        0x000029C3
    };

    static _CharacterInfo _character000029C4 =
    {
        0x000029C4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C4,
        0x000029C4,
        0x000029C4
    };

    static _CharacterInfo _character000029C5 =
    {
        0x000029C5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C5,
        0x000029C5,
        0x000029C5
    };

    static _CharacterInfo _character000029C6 =
    {
        0x000029C6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029C6,
        0x000029C6,
        0x000029C6
    };

    static _CharacterInfo _character000029C7 =
    {
        0x000029C7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029C7,
        0x000029C7,
        0x000029C7
    };

    static _CharacterInfo _character000029C8 =
    {
        0x000029C8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029C8,
        0x000029C8,
        0x000029C8
    };

    static _CharacterInfo _character000029C9 =
    {
        0x000029C9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029C9,
        0x000029C9,
        0x000029C9
    };

    static _CharacterInfo _character000029CA =
    {
        0x000029CA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029CA,
        0x000029CA,
        0x000029CA
    };

    static _CharacterInfo _character000029CB =
    {
        0x000029CB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029CB,
        0x000029CB,
        0x000029CB
    };

    static _CharacterInfo _character000029CC =
    {
        0x000029CC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029CC,
        0x000029CC,
        0x000029CC
    };

    static _CharacterInfo _character000029CD =
    {
        0x000029CD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029CD,
        0x000029CD,
        0x000029CD
    };

    static _CharacterInfo _character000029CE =
    {
        0x000029CE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029CE,
        0x000029CE,
        0x000029CE
    };

    static _CharacterInfo _character000029CF =
    {
        0x000029CF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029CF,
        0x000029CF,
        0x000029CF
    };

    static _CharacterInfo _character000029D0 =
    {
        0x000029D0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D0,
        0x000029D0,
        0x000029D0
    };

    static _CharacterInfo _character000029D1 =
    {
        0x000029D1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D1,
        0x000029D1,
        0x000029D1
    };

    static _CharacterInfo _character000029D2 =
    {
        0x000029D2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D2,
        0x000029D2,
        0x000029D2
    };

    static _CharacterInfo _character000029D3 =
    {
        0x000029D3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029D3,
        0x000029D3,
        0x000029D3
    };

    static _CharacterInfo _character000029D4 =
    {
        0x000029D4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D4,
        0x000029D4,
        0x000029D4
    };

    static _CharacterInfo _character000029D5 =
    {
        0x000029D5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D5,
        0x000029D5,
        0x000029D5
    };

    static _CharacterInfo _character000029D6 =
    {
        0x000029D6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029D6,
        0x000029D6,
        0x000029D6
    };

    static _CharacterInfo _character000029D7 =
    {
        0x000029D7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029D7,
        0x000029D7,
        0x000029D7
    };

    static _CharacterInfo _character000029D8 =
    {
        0x000029D8,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D8,
        0x000029D8,
        0x000029D8
    };

    static _CharacterInfo _character000029D9 =
    {
        0x000029D9,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029D9,
        0x000029D9,
        0x000029D9
    };

    static _CharacterInfo _character000029DA =
    {
        0x000029DA,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029DA,
        0x000029DA,
        0x000029DA
    };

    static _CharacterInfo _character000029DB =
    {
        0x000029DB,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029DB,
        0x000029DB,
        0x000029DB
    };

    static _CharacterInfo _character000029DC =
    {
        0x000029DC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029DC,
        0x000029DC,
        0x000029DC
    };

    static _CharacterInfo _character000029DD =
    {
        0x000029DD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029DD,
        0x000029DD,
        0x000029DD
    };

    static _CharacterInfo _character000029DE =
    {
        0x000029DE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029DE,
        0x000029DE,
        0x000029DE
    };

    static _CharacterInfo _character000029DF =
    {
        0x000029DF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029DF,
        0x000029DF,
        0x000029DF
    };

    static _CharacterInfo _character000029E0 =
    {
        0x000029E0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029E0,
        0x000029E0,
        0x000029E0
    };

    static _CharacterInfo _character000029E1 =
    {
        0x000029E1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E1,
        0x000029E1,
        0x000029E1
    };

    static _CharacterInfo _character000029E2 =
    {
        0x000029E2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029E2,
        0x000029E2,
        0x000029E2
    };

    static _CharacterInfo _character000029E3 =
    {
        0x000029E3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E3,
        0x000029E3,
        0x000029E3
    };

    static _CharacterInfo _character000029E4 =
    {
        0x000029E4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E4,
        0x000029E4,
        0x000029E4
    };

    static _CharacterInfo _character000029E5 =
    {
        0x000029E5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E5,
        0x000029E5,
        0x000029E5
    };

    static _CharacterInfo _character000029E6 =
    {
        0x000029E6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029E6,
        0x000029E6,
        0x000029E6
    };

    static _CharacterInfo _character000029E7 =
    {
        0x000029E7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029E7,
        0x000029E7,
        0x000029E7
    };

    static _CharacterInfo _character000029E8 =
    {
        0x000029E8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E8,
        0x000029E8,
        0x000029E8
    };

    static _CharacterInfo _character000029E9 =
    {
        0x000029E9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029E9,
        0x000029E9,
        0x000029E9
    };

    static _CharacterInfo _character000029EA =
    {
        0x000029EA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029EA,
        0x000029EA,
        0x000029EA
    };

    static _CharacterInfo _character000029EB =
    {
        0x000029EB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029EB,
        0x000029EB,
        0x000029EB
    };

    static _CharacterInfo _character000029EC =
    {
        0x000029EC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029EC,
        0x000029EC,
        0x000029EC
    };

    static _CharacterInfo _character000029ED =
    {
        0x000029ED,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029ED,
        0x000029ED,
        0x000029ED
    };

    static _CharacterInfo _character000029EE =
    {
        0x000029EE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029EE,
        0x000029EE,
        0x000029EE
    };

    static _CharacterInfo _character000029EF =
    {
        0x000029EF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029EF,
        0x000029EF,
        0x000029EF
    };

    static _CharacterInfo _character000029F0 =
    {
        0x000029F0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029F0,
        0x000029F0,
        0x000029F0
    };

    static _CharacterInfo _character000029F1 =
    {
        0x000029F1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029F1,
        0x000029F1,
        0x000029F1
    };

    static _CharacterInfo _character000029F2 =
    {
        0x000029F2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029F2,
        0x000029F2,
        0x000029F2
    };

    static _CharacterInfo _character000029F3 =
    {
        0x000029F3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029F3,
        0x000029F3,
        0x000029F3
    };

    static _CharacterInfo _character000029F4 =
    {
        0x000029F4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F4,
        0x000029F4,
        0x000029F4
    };

    static _CharacterInfo _character000029F5 =
    {
        0x000029F5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F5,
        0x000029F5,
        0x000029F5
    };

    static _CharacterInfo _character000029F6 =
    {
        0x000029F6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F6,
        0x000029F6,
        0x000029F6
    };

    static _CharacterInfo _character000029F7 =
    {
        0x000029F7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F7,
        0x000029F7,
        0x000029F7
    };

    static _CharacterInfo _character000029F8 =
    {
        0x000029F8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F8,
        0x000029F8,
        0x000029F8
    };

    static _CharacterInfo _character000029F9 =
    {
        0x000029F9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029F9,
        0x000029F9,
        0x000029F9
    };

    static _CharacterInfo _character000029FA =
    {
        0x000029FA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029FA,
        0x000029FA,
        0x000029FA
    };

    static _CharacterInfo _character000029FB =
    {
        0x000029FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029FB,
        0x000029FB,
        0x000029FB
    };

    static _CharacterInfo _character000029FC =
    {
        0x000029FC,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029FC,
        0x000029FC,
        0x000029FC
    };

    static _CharacterInfo _character000029FD =
    {
        0x000029FD,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x000029FD,
        0x000029FD,
        0x000029FD
    };

    static _CharacterInfo _character000029FE =
    {
        0x000029FE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029FE,
        0x000029FE,
        0x000029FE
    };

    static _CharacterInfo _character000029FF =
    {
        0x000029FF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000029FF,
        0x000029FF,
        0x000029FF
    };

    static _CharacterInfo _character00002A00 =
    {
        0x00002A00,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A00,
        0x00002A00,
        0x00002A00
    };

    static _CharacterInfo _character00002A01 =
    {
        0x00002A01,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A01,
        0x00002A01,
        0x00002A01
    };

    static _CharacterInfo _character00002A02 =
    {
        0x00002A02,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A02,
        0x00002A02,
        0x00002A02
    };

    static _CharacterInfo _character00002A03 =
    {
        0x00002A03,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A03,
        0x00002A03,
        0x00002A03
    };

    static _CharacterInfo _character00002A04 =
    {
        0x00002A04,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A04,
        0x00002A04,
        0x00002A04
    };

    static _CharacterInfo _character00002A05 =
    {
        0x00002A05,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A05,
        0x00002A05,
        0x00002A05
    };

    static _CharacterInfo _character00002A06 =
    {
        0x00002A06,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A06,
        0x00002A06,
        0x00002A06
    };

    static _CharacterInfo _character00002A07 =
    {
        0x00002A07,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A07,
        0x00002A07,
        0x00002A07
    };

    static _CharacterInfo _character00002A08 =
    {
        0x00002A08,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A08,
        0x00002A08,
        0x00002A08
    };

    static _CharacterInfo _character00002A09 =
    {
        0x00002A09,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A09,
        0x00002A09,
        0x00002A09
    };

    static _CharacterInfo _character00002A0A =
    {
        0x00002A0A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0A,
        0x00002A0A,
        0x00002A0A
    };

    static _CharacterInfo _character00002A0B =
    {
        0x00002A0B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0B,
        0x00002A0B,
        0x00002A0B
    };

    static Char _decompositionMapping00002A0C[] = 
    {
        0x0000222B,
        0x0000222B,
        0x0000222B,
        0x0000222B
    };

    static _CharacterInfo _character00002A0C =
    {
        0x00002A0C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00002A0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0C,
        0x00002A0C,
        0x00002A0C
    };

    static _CharacterInfo _character00002A0D =
    {
        0x00002A0D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0D,
        0x00002A0D,
        0x00002A0D
    };

    static _CharacterInfo _character00002A0E =
    {
        0x00002A0E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0E,
        0x00002A0E,
        0x00002A0E
    };

    static _CharacterInfo _character00002A0F =
    {
        0x00002A0F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A0F,
        0x00002A0F,
        0x00002A0F
    };

    static _CharacterInfo _character00002A10 =
    {
        0x00002A10,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A10,
        0x00002A10,
        0x00002A10
    };

    static _CharacterInfo _character00002A11 =
    {
        0x00002A11,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A11,
        0x00002A11,
        0x00002A11
    };

    static _CharacterInfo _character00002A12 =
    {
        0x00002A12,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A12,
        0x00002A12,
        0x00002A12
    };

    static _CharacterInfo _character00002A13 =
    {
        0x00002A13,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A13,
        0x00002A13,
        0x00002A13
    };

    static _CharacterInfo _character00002A14 =
    {
        0x00002A14,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A14,
        0x00002A14,
        0x00002A14
    };

    static _CharacterInfo _character00002A15 =
    {
        0x00002A15,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A15,
        0x00002A15,
        0x00002A15
    };

    static _CharacterInfo _character00002A16 =
    {
        0x00002A16,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A16,
        0x00002A16,
        0x00002A16
    };

    static _CharacterInfo _character00002A17 =
    {
        0x00002A17,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A17,
        0x00002A17,
        0x00002A17
    };

    static _CharacterInfo _character00002A18 =
    {
        0x00002A18,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A18,
        0x00002A18,
        0x00002A18
    };

    static _CharacterInfo _character00002A19 =
    {
        0x00002A19,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A19,
        0x00002A19,
        0x00002A19
    };

    static _CharacterInfo _character00002A1A =
    {
        0x00002A1A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A1A,
        0x00002A1A,
        0x00002A1A
    };

    static _CharacterInfo _character00002A1B =
    {
        0x00002A1B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A1B,
        0x00002A1B,
        0x00002A1B
    };

    static _CharacterInfo _character00002A1C =
    {
        0x00002A1C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A1C,
        0x00002A1C,
        0x00002A1C
    };

    static _CharacterInfo _character00002A1D =
    {
        0x00002A1D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A1D,
        0x00002A1D,
        0x00002A1D
    };

    static _CharacterInfo _character00002A1E =
    {
        0x00002A1E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A1E,
        0x00002A1E,
        0x00002A1E
    };

    static _CharacterInfo _character00002A1F =
    {
        0x00002A1F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A1F,
        0x00002A1F,
        0x00002A1F
    };

    static _CharacterInfo _character00002A20 =
    {
        0x00002A20,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A20,
        0x00002A20,
        0x00002A20
    };

    static _CharacterInfo _character00002A21 =
    {
        0x00002A21,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A21,
        0x00002A21,
        0x00002A21
    };

    static _CharacterInfo _character00002A22 =
    {
        0x00002A22,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A22,
        0x00002A22,
        0x00002A22
    };

    static _CharacterInfo _character00002A23 =
    {
        0x00002A23,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A23,
        0x00002A23,
        0x00002A23
    };

    static _CharacterInfo _character00002A24 =
    {
        0x00002A24,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A24,
        0x00002A24,
        0x00002A24
    };

    static _CharacterInfo _character00002A25 =
    {
        0x00002A25,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A25,
        0x00002A25,
        0x00002A25
    };

    static _CharacterInfo _character00002A26 =
    {
        0x00002A26,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A26,
        0x00002A26,
        0x00002A26
    };

    static _CharacterInfo _character00002A27 =
    {
        0x00002A27,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A27,
        0x00002A27,
        0x00002A27
    };

    static _CharacterInfo _character00002A28 =
    {
        0x00002A28,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A28,
        0x00002A28,
        0x00002A28
    };

    static _CharacterInfo _character00002A29 =
    {
        0x00002A29,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A29,
        0x00002A29,
        0x00002A29
    };

    static _CharacterInfo _character00002A2A =
    {
        0x00002A2A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A2A,
        0x00002A2A,
        0x00002A2A
    };

    static _CharacterInfo _character00002A2B =
    {
        0x00002A2B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A2B,
        0x00002A2B,
        0x00002A2B
    };

    static _CharacterInfo _character00002A2C =
    {
        0x00002A2C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A2C,
        0x00002A2C,
        0x00002A2C
    };

    static _CharacterInfo _character00002A2D =
    {
        0x00002A2D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A2D,
        0x00002A2D,
        0x00002A2D
    };

    static _CharacterInfo _character00002A2E =
    {
        0x00002A2E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A2E,
        0x00002A2E,
        0x00002A2E
    };

    static _CharacterInfo _character00002A2F =
    {
        0x00002A2F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A2F,
        0x00002A2F,
        0x00002A2F
    };

    static _CharacterInfo _character00002A30 =
    {
        0x00002A30,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A30,
        0x00002A30,
        0x00002A30
    };

    static _CharacterInfo _character00002A31 =
    {
        0x00002A31,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A31,
        0x00002A31,
        0x00002A31
    };

    static _CharacterInfo _character00002A32 =
    {
        0x00002A32,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A32,
        0x00002A32,
        0x00002A32
    };

    static _CharacterInfo _character00002A33 =
    {
        0x00002A33,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A33,
        0x00002A33,
        0x00002A33
    };

    static _CharacterInfo _character00002A34 =
    {
        0x00002A34,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A34,
        0x00002A34,
        0x00002A34
    };

    static _CharacterInfo _character00002A35 =
    {
        0x00002A35,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A35,
        0x00002A35,
        0x00002A35
    };

    static _CharacterInfo _character00002A36 =
    {
        0x00002A36,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A36,
        0x00002A36,
        0x00002A36
    };

    static _CharacterInfo _character00002A37 =
    {
        0x00002A37,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A37,
        0x00002A37,
        0x00002A37
    };

    static _CharacterInfo _character00002A38 =
    {
        0x00002A38,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A38,
        0x00002A38,
        0x00002A38
    };

    static _CharacterInfo _character00002A39 =
    {
        0x00002A39,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A39,
        0x00002A39,
        0x00002A39
    };

    static _CharacterInfo _character00002A3A =
    {
        0x00002A3A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A3A,
        0x00002A3A,
        0x00002A3A
    };

    static _CharacterInfo _character00002A3B =
    {
        0x00002A3B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A3B,
        0x00002A3B,
        0x00002A3B
    };

    static _CharacterInfo _character00002A3C =
    {
        0x00002A3C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A3C,
        0x00002A3C,
        0x00002A3C
    };

    static _CharacterInfo _character00002A3D =
    {
        0x00002A3D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A3D,
        0x00002A3D,
        0x00002A3D
    };

    static _CharacterInfo _character00002A3E =
    {
        0x00002A3E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A3E,
        0x00002A3E,
        0x00002A3E
    };

    static _CharacterInfo _character00002A3F =
    {
        0x00002A3F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A3F,
        0x00002A3F,
        0x00002A3F
    };

    static _CharacterInfo _character00002A40 =
    {
        0x00002A40,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A40,
        0x00002A40,
        0x00002A40
    };

    static _CharacterInfo _character00002A41 =
    {
        0x00002A41,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A41,
        0x00002A41,
        0x00002A41
    };

    static _CharacterInfo _character00002A42 =
    {
        0x00002A42,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A42,
        0x00002A42,
        0x00002A42
    };

    static _CharacterInfo _character00002A43 =
    {
        0x00002A43,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A43,
        0x00002A43,
        0x00002A43
    };

    static _CharacterInfo _character00002A44 =
    {
        0x00002A44,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A44,
        0x00002A44,
        0x00002A44
    };

    static _CharacterInfo _character00002A45 =
    {
        0x00002A45,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A45,
        0x00002A45,
        0x00002A45
    };

    static _CharacterInfo _character00002A46 =
    {
        0x00002A46,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A46,
        0x00002A46,
        0x00002A46
    };

    static _CharacterInfo _character00002A47 =
    {
        0x00002A47,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A47,
        0x00002A47,
        0x00002A47
    };

    static _CharacterInfo _character00002A48 =
    {
        0x00002A48,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A48,
        0x00002A48,
        0x00002A48
    };

    static _CharacterInfo _character00002A49 =
    {
        0x00002A49,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A49,
        0x00002A49,
        0x00002A49
    };

    static _CharacterInfo _character00002A4A =
    {
        0x00002A4A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4A,
        0x00002A4A,
        0x00002A4A
    };

    static _CharacterInfo _character00002A4B =
    {
        0x00002A4B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4B,
        0x00002A4B,
        0x00002A4B
    };

    static _CharacterInfo _character00002A4C =
    {
        0x00002A4C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4C,
        0x00002A4C,
        0x00002A4C
    };

    static _CharacterInfo _character00002A4D =
    {
        0x00002A4D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4D,
        0x00002A4D,
        0x00002A4D
    };

    static _CharacterInfo _character00002A4E =
    {
        0x00002A4E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4E,
        0x00002A4E,
        0x00002A4E
    };

    static _CharacterInfo _character00002A4F =
    {
        0x00002A4F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A4F,
        0x00002A4F,
        0x00002A4F
    };

    static _CharacterInfo _character00002A50 =
    {
        0x00002A50,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A50,
        0x00002A50,
        0x00002A50
    };

    static _CharacterInfo _character00002A51 =
    {
        0x00002A51,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A51,
        0x00002A51,
        0x00002A51
    };

    static _CharacterInfo _character00002A52 =
    {
        0x00002A52,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A52,
        0x00002A52,
        0x00002A52
    };

    static _CharacterInfo _character00002A53 =
    {
        0x00002A53,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A53,
        0x00002A53,
        0x00002A53
    };

    static _CharacterInfo _character00002A54 =
    {
        0x00002A54,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A54,
        0x00002A54,
        0x00002A54
    };

    static _CharacterInfo _character00002A55 =
    {
        0x00002A55,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A55,
        0x00002A55,
        0x00002A55
    };

    static _CharacterInfo _character00002A56 =
    {
        0x00002A56,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A56,
        0x00002A56,
        0x00002A56
    };

    static _CharacterInfo _character00002A57 =
    {
        0x00002A57,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A57,
        0x00002A57,
        0x00002A57
    };

    static _CharacterInfo _character00002A58 =
    {
        0x00002A58,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A58,
        0x00002A58,
        0x00002A58
    };

    static _CharacterInfo _character00002A59 =
    {
        0x00002A59,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A59,
        0x00002A59,
        0x00002A59
    };

    static _CharacterInfo _character00002A5A =
    {
        0x00002A5A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5A,
        0x00002A5A,
        0x00002A5A
    };

    static _CharacterInfo _character00002A5B =
    {
        0x00002A5B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5B,
        0x00002A5B,
        0x00002A5B
    };

    static _CharacterInfo _character00002A5C =
    {
        0x00002A5C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5C,
        0x00002A5C,
        0x00002A5C
    };

    static _CharacterInfo _character00002A5D =
    {
        0x00002A5D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5D,
        0x00002A5D,
        0x00002A5D
    };

    static _CharacterInfo _character00002A5E =
    {
        0x00002A5E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5E,
        0x00002A5E,
        0x00002A5E
    };

    static _CharacterInfo _character00002A5F =
    {
        0x00002A5F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A5F,
        0x00002A5F,
        0x00002A5F
    };

    static _CharacterInfo _character00002A60 =
    {
        0x00002A60,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A60,
        0x00002A60,
        0x00002A60
    };

    static _CharacterInfo _character00002A61 =
    {
        0x00002A61,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A61,
        0x00002A61,
        0x00002A61
    };

    static _CharacterInfo _character00002A62 =
    {
        0x00002A62,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A62,
        0x00002A62,
        0x00002A62
    };

    static _CharacterInfo _character00002A63 =
    {
        0x00002A63,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A63,
        0x00002A63,
        0x00002A63
    };

    static _CharacterInfo _character00002A64 =
    {
        0x00002A64,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A64,
        0x00002A64,
        0x00002A64
    };

    static _CharacterInfo _character00002A65 =
    {
        0x00002A65,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A65,
        0x00002A65,
        0x00002A65
    };

    static _CharacterInfo _character00002A66 =
    {
        0x00002A66,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A66,
        0x00002A66,
        0x00002A66
    };

    static _CharacterInfo _character00002A67 =
    {
        0x00002A67,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A67,
        0x00002A67,
        0x00002A67
    };

    static _CharacterInfo _character00002A68 =
    {
        0x00002A68,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A68,
        0x00002A68,
        0x00002A68
    };

    static _CharacterInfo _character00002A69 =
    {
        0x00002A69,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A69,
        0x00002A69,
        0x00002A69
    };

    static _CharacterInfo _character00002A6A =
    {
        0x00002A6A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A6A,
        0x00002A6A,
        0x00002A6A
    };

    static _CharacterInfo _character00002A6B =
    {
        0x00002A6B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A6B,
        0x00002A6B,
        0x00002A6B
    };

    static _CharacterInfo _character00002A6C =
    {
        0x00002A6C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A6C,
        0x00002A6C,
        0x00002A6C
    };

    static _CharacterInfo _character00002A6D =
    {
        0x00002A6D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A6D,
        0x00002A6D,
        0x00002A6D
    };

    static _CharacterInfo _character00002A6E =
    {
        0x00002A6E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A6E,
        0x00002A6E,
        0x00002A6E
    };

    static _CharacterInfo _character00002A6F =
    {
        0x00002A6F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A6F,
        0x00002A6F,
        0x00002A6F
    };

    static _CharacterInfo _character00002A70 =
    {
        0x00002A70,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A70,
        0x00002A70,
        0x00002A70
    };

    static _CharacterInfo _character00002A71 =
    {
        0x00002A71,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A71,
        0x00002A71,
        0x00002A71
    };

    static _CharacterInfo _character00002A72 =
    {
        0x00002A72,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A72,
        0x00002A72,
        0x00002A72
    };

    static _CharacterInfo _character00002A73 =
    {
        0x00002A73,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A73,
        0x00002A73,
        0x00002A73
    };

    static Char _decompositionMapping00002A74[] = 
    {
        0x0000003A,
        0x0000003A,
        0x0000003D
    };

    static _CharacterInfo _character00002A74 =
    {
        0x00002A74,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002A74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A74,
        0x00002A74,
        0x00002A74
    };

    static Char _decompositionMapping00002A75[] = 
    {
        0x0000003D,
        0x0000003D
    };

    static _CharacterInfo _character00002A75 =
    {
        0x00002A75,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00002A75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A75,
        0x00002A75,
        0x00002A75
    };

    static Char _decompositionMapping00002A76[] = 
    {
        0x0000003D,
        0x0000003D,
        0x0000003D
    };

    static _CharacterInfo _character00002A76 =
    {
        0x00002A76,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00002A76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A76,
        0x00002A76,
        0x00002A76
    };

    static _CharacterInfo _character00002A77 =
    {
        0x00002A77,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A77,
        0x00002A77,
        0x00002A77
    };

    static _CharacterInfo _character00002A78 =
    {
        0x00002A78,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002A78,
        0x00002A78,
        0x00002A78
    };

    static _CharacterInfo _character00002A79 =
    {
        0x00002A79,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A79,
        0x00002A79,
        0x00002A79
    };

    static _CharacterInfo _character00002A7A =
    {
        0x00002A7A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7A,
        0x00002A7A,
        0x00002A7A
    };

    static _CharacterInfo _character00002A7B =
    {
        0x00002A7B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7B,
        0x00002A7B,
        0x00002A7B
    };

    static _CharacterInfo _character00002A7C =
    {
        0x00002A7C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7C,
        0x00002A7C,
        0x00002A7C
    };

    static _CharacterInfo _character00002A7D =
    {
        0x00002A7D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7D,
        0x00002A7D,
        0x00002A7D
    };

    static _CharacterInfo _character00002A7E =
    {
        0x00002A7E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7E,
        0x00002A7E,
        0x00002A7E
    };

    static _CharacterInfo _character00002A7F =
    {
        0x00002A7F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A7F,
        0x00002A7F,
        0x00002A7F
    };

    static _CharacterInfo _character00002A80 =
    {
        0x00002A80,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A80,
        0x00002A80,
        0x00002A80
    };

    static _CharacterInfo _character00002A81 =
    {
        0x00002A81,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A81,
        0x00002A81,
        0x00002A81
    };

    static _CharacterInfo _character00002A82 =
    {
        0x00002A82,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A82,
        0x00002A82,
        0x00002A82
    };

    static _CharacterInfo _character00002A83 =
    {
        0x00002A83,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A83,
        0x00002A83,
        0x00002A83
    };

    static _CharacterInfo _character00002A84 =
    {
        0x00002A84,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A84,
        0x00002A84,
        0x00002A84
    };

    static _CharacterInfo _character00002A85 =
    {
        0x00002A85,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A85,
        0x00002A85,
        0x00002A85
    };

    static _CharacterInfo _character00002A86 =
    {
        0x00002A86,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A86,
        0x00002A86,
        0x00002A86
    };

    static _CharacterInfo _character00002A87 =
    {
        0x00002A87,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A87,
        0x00002A87,
        0x00002A87
    };

    static _CharacterInfo _character00002A88 =
    {
        0x00002A88,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A88,
        0x00002A88,
        0x00002A88
    };

    static _CharacterInfo _character00002A89 =
    {
        0x00002A89,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A89,
        0x00002A89,
        0x00002A89
    };

    static _CharacterInfo _character00002A8A =
    {
        0x00002A8A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8A,
        0x00002A8A,
        0x00002A8A
    };

    static _CharacterInfo _character00002A8B =
    {
        0x00002A8B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8B,
        0x00002A8B,
        0x00002A8B
    };

    static _CharacterInfo _character00002A8C =
    {
        0x00002A8C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8C,
        0x00002A8C,
        0x00002A8C
    };

    static _CharacterInfo _character00002A8D =
    {
        0x00002A8D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8D,
        0x00002A8D,
        0x00002A8D
    };

    static _CharacterInfo _character00002A8E =
    {
        0x00002A8E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8E,
        0x00002A8E,
        0x00002A8E
    };

    static _CharacterInfo _character00002A8F =
    {
        0x00002A8F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A8F,
        0x00002A8F,
        0x00002A8F
    };

    static _CharacterInfo _character00002A90 =
    {
        0x00002A90,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A90,
        0x00002A90,
        0x00002A90
    };

    static _CharacterInfo _character00002A91 =
    {
        0x00002A91,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A91,
        0x00002A91,
        0x00002A91
    };

    static _CharacterInfo _character00002A92 =
    {
        0x00002A92,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A92,
        0x00002A92,
        0x00002A92
    };

    static _CharacterInfo _character00002A93 =
    {
        0x00002A93,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A93,
        0x00002A93,
        0x00002A93
    };

    static _CharacterInfo _character00002A94 =
    {
        0x00002A94,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A94,
        0x00002A94,
        0x00002A94
    };

    static _CharacterInfo _character00002A95 =
    {
        0x00002A95,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A95,
        0x00002A95,
        0x00002A95
    };

    static _CharacterInfo _character00002A96 =
    {
        0x00002A96,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A96,
        0x00002A96,
        0x00002A96
    };

    static _CharacterInfo _character00002A97 =
    {
        0x00002A97,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A97,
        0x00002A97,
        0x00002A97
    };

    static _CharacterInfo _character00002A98 =
    {
        0x00002A98,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A98,
        0x00002A98,
        0x00002A98
    };

    static _CharacterInfo _character00002A99 =
    {
        0x00002A99,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A99,
        0x00002A99,
        0x00002A99
    };

    static _CharacterInfo _character00002A9A =
    {
        0x00002A9A,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9A,
        0x00002A9A,
        0x00002A9A
    };

    static _CharacterInfo _character00002A9B =
    {
        0x00002A9B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9B,
        0x00002A9B,
        0x00002A9B
    };

    static _CharacterInfo _character00002A9C =
    {
        0x00002A9C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9C,
        0x00002A9C,
        0x00002A9C
    };

    static _CharacterInfo _character00002A9D =
    {
        0x00002A9D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9D,
        0x00002A9D,
        0x00002A9D
    };

    static _CharacterInfo _character00002A9E =
    {
        0x00002A9E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9E,
        0x00002A9E,
        0x00002A9E
    };

    static _CharacterInfo _character00002A9F =
    {
        0x00002A9F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002A9F,
        0x00002A9F,
        0x00002A9F
    };

    static _CharacterInfo _character00002AA0 =
    {
        0x00002AA0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA0,
        0x00002AA0,
        0x00002AA0
    };

    static _CharacterInfo _character00002AA1 =
    {
        0x00002AA1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA1,
        0x00002AA1,
        0x00002AA1
    };

    static _CharacterInfo _character00002AA2 =
    {
        0x00002AA2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA2,
        0x00002AA2,
        0x00002AA2
    };

    static _CharacterInfo _character00002AA3 =
    {
        0x00002AA3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA3,
        0x00002AA3,
        0x00002AA3
    };

    static _CharacterInfo _character00002AA4 =
    {
        0x00002AA4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AA4,
        0x00002AA4,
        0x00002AA4
    };

    static _CharacterInfo _character00002AA5 =
    {
        0x00002AA5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AA5,
        0x00002AA5,
        0x00002AA5
    };

    static _CharacterInfo _character00002AA6 =
    {
        0x00002AA6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA6,
        0x00002AA6,
        0x00002AA6
    };

    static _CharacterInfo _character00002AA7 =
    {
        0x00002AA7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA7,
        0x00002AA7,
        0x00002AA7
    };

    static _CharacterInfo _character00002AA8 =
    {
        0x00002AA8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA8,
        0x00002AA8,
        0x00002AA8
    };

    static _CharacterInfo _character00002AA9 =
    {
        0x00002AA9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AA9,
        0x00002AA9,
        0x00002AA9
    };

    static _CharacterInfo _character00002AAA =
    {
        0x00002AAA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AAA,
        0x00002AAA,
        0x00002AAA
    };

    static _CharacterInfo _character00002AAB =
    {
        0x00002AAB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AAB,
        0x00002AAB,
        0x00002AAB
    };

    static _CharacterInfo _character00002AAC =
    {
        0x00002AAC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AAC,
        0x00002AAC,
        0x00002AAC
    };

    static _CharacterInfo _character00002AAD =
    {
        0x00002AAD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AAD,
        0x00002AAD,
        0x00002AAD
    };

    static _CharacterInfo _character00002AAE =
    {
        0x00002AAE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AAE,
        0x00002AAE,
        0x00002AAE
    };

    static _CharacterInfo _character00002AAF =
    {
        0x00002AAF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AAF,
        0x00002AAF,
        0x00002AAF
    };

    static _CharacterInfo _character00002AB0 =
    {
        0x00002AB0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB0,
        0x00002AB0,
        0x00002AB0
    };

    static _CharacterInfo _character00002AB1 =
    {
        0x00002AB1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB1,
        0x00002AB1,
        0x00002AB1
    };

    static _CharacterInfo _character00002AB2 =
    {
        0x00002AB2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB2,
        0x00002AB2,
        0x00002AB2
    };

    static _CharacterInfo _character00002AB3 =
    {
        0x00002AB3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB3,
        0x00002AB3,
        0x00002AB3
    };

    static _CharacterInfo _character00002AB4 =
    {
        0x00002AB4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB4,
        0x00002AB4,
        0x00002AB4
    };

    static _CharacterInfo _character00002AB5 =
    {
        0x00002AB5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB5,
        0x00002AB5,
        0x00002AB5
    };

    static _CharacterInfo _character00002AB6 =
    {
        0x00002AB6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB6,
        0x00002AB6,
        0x00002AB6
    };

    static _CharacterInfo _character00002AB7 =
    {
        0x00002AB7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB7,
        0x00002AB7,
        0x00002AB7
    };

    static _CharacterInfo _character00002AB8 =
    {
        0x00002AB8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB8,
        0x00002AB8,
        0x00002AB8
    };

    static _CharacterInfo _character00002AB9 =
    {
        0x00002AB9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AB9,
        0x00002AB9,
        0x00002AB9
    };

    static _CharacterInfo _character00002ABA =
    {
        0x00002ABA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABA,
        0x00002ABA,
        0x00002ABA
    };

    static _CharacterInfo _character00002ABB =
    {
        0x00002ABB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABB,
        0x00002ABB,
        0x00002ABB
    };

    static _CharacterInfo _character00002ABC =
    {
        0x00002ABC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABC,
        0x00002ABC,
        0x00002ABC
    };

    static _CharacterInfo _character00002ABD =
    {
        0x00002ABD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABD,
        0x00002ABD,
        0x00002ABD
    };

    static _CharacterInfo _character00002ABE =
    {
        0x00002ABE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABE,
        0x00002ABE,
        0x00002ABE
    };

    static _CharacterInfo _character00002ABF =
    {
        0x00002ABF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ABF,
        0x00002ABF,
        0x00002ABF
    };

    static _CharacterInfo _character00002AC0 =
    {
        0x00002AC0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC0,
        0x00002AC0,
        0x00002AC0
    };

    static _CharacterInfo _character00002AC1 =
    {
        0x00002AC1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC1,
        0x00002AC1,
        0x00002AC1
    };

    static _CharacterInfo _character00002AC2 =
    {
        0x00002AC2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC2,
        0x00002AC2,
        0x00002AC2
    };

    static _CharacterInfo _character00002AC3 =
    {
        0x00002AC3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC3,
        0x00002AC3,
        0x00002AC3
    };

    static _CharacterInfo _character00002AC4 =
    {
        0x00002AC4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC4,
        0x00002AC4,
        0x00002AC4
    };

    static _CharacterInfo _character00002AC5 =
    {
        0x00002AC5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC5,
        0x00002AC5,
        0x00002AC5
    };

    static _CharacterInfo _character00002AC6 =
    {
        0x00002AC6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC6,
        0x00002AC6,
        0x00002AC6
    };

    static _CharacterInfo _character00002AC7 =
    {
        0x00002AC7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC7,
        0x00002AC7,
        0x00002AC7
    };

    static _CharacterInfo _character00002AC8 =
    {
        0x00002AC8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC8,
        0x00002AC8,
        0x00002AC8
    };

    static _CharacterInfo _character00002AC9 =
    {
        0x00002AC9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AC9,
        0x00002AC9,
        0x00002AC9
    };

    static _CharacterInfo _character00002ACA =
    {
        0x00002ACA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACA,
        0x00002ACA,
        0x00002ACA
    };

    static _CharacterInfo _character00002ACB =
    {
        0x00002ACB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACB,
        0x00002ACB,
        0x00002ACB
    };

    static _CharacterInfo _character00002ACC =
    {
        0x00002ACC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACC,
        0x00002ACC,
        0x00002ACC
    };

    static _CharacterInfo _character00002ACD =
    {
        0x00002ACD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACD,
        0x00002ACD,
        0x00002ACD
    };

    static _CharacterInfo _character00002ACE =
    {
        0x00002ACE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACE,
        0x00002ACE,
        0x00002ACE
    };

    static _CharacterInfo _character00002ACF =
    {
        0x00002ACF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ACF,
        0x00002ACF,
        0x00002ACF
    };

    static _CharacterInfo _character00002AD0 =
    {
        0x00002AD0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD0,
        0x00002AD0,
        0x00002AD0
    };

    static _CharacterInfo _character00002AD1 =
    {
        0x00002AD1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD1,
        0x00002AD1,
        0x00002AD1
    };

    static _CharacterInfo _character00002AD2 =
    {
        0x00002AD2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD2,
        0x00002AD2,
        0x00002AD2
    };

    static _CharacterInfo _character00002AD3 =
    {
        0x00002AD3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD3,
        0x00002AD3,
        0x00002AD3
    };

    static _CharacterInfo _character00002AD4 =
    {
        0x00002AD4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD4,
        0x00002AD4,
        0x00002AD4
    };

    static _CharacterInfo _character00002AD5 =
    {
        0x00002AD5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD5,
        0x00002AD5,
        0x00002AD5
    };

    static _CharacterInfo _character00002AD6 =
    {
        0x00002AD6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AD6,
        0x00002AD6,
        0x00002AD6
    };

    static _CharacterInfo _character00002AD7 =
    {
        0x00002AD7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AD7,
        0x00002AD7,
        0x00002AD7
    };

    static _CharacterInfo _character00002AD8 =
    {
        0x00002AD8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AD8,
        0x00002AD8,
        0x00002AD8
    };

    static _CharacterInfo _character00002AD9 =
    {
        0x00002AD9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AD9,
        0x00002AD9,
        0x00002AD9
    };

    static _CharacterInfo _character00002ADA =
    {
        0x00002ADA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ADA,
        0x00002ADA,
        0x00002ADA
    };

    static _CharacterInfo _character00002ADB =
    {
        0x00002ADB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ADB,
        0x00002ADB,
        0x00002ADB
    };

    static Char _decompositionMapping00002ADC[] = 
    {
        0x00002ADD,
        0x00000338
    };

    static _CharacterInfo _character00002ADC =
    {
        0x00002ADC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00002ADC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ADC,
        0x00002ADC,
        0x00002ADC
    };

    static _CharacterInfo _character00002ADD =
    {
        0x00002ADD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ADD,
        0x00002ADD,
        0x00002ADD
    };

    static _CharacterInfo _character00002ADE =
    {
        0x00002ADE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002ADE,
        0x00002ADE,
        0x00002ADE
    };

    static _CharacterInfo _character00002ADF =
    {
        0x00002ADF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ADF,
        0x00002ADF,
        0x00002ADF
    };

    static _CharacterInfo _character00002AE0 =
    {
        0x00002AE0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AE0,
        0x00002AE0,
        0x00002AE0
    };

    static _CharacterInfo _character00002AE1 =
    {
        0x00002AE1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AE1,
        0x00002AE1,
        0x00002AE1
    };

    static _CharacterInfo _character00002AE2 =
    {
        0x00002AE2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AE2,
        0x00002AE2,
        0x00002AE2
    };

    static _CharacterInfo _character00002AE3 =
    {
        0x00002AE3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AE3,
        0x00002AE3,
        0x00002AE3
    };

    static _CharacterInfo _character00002AE4 =
    {
        0x00002AE4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AE4,
        0x00002AE4,
        0x00002AE4
    };

    static _CharacterInfo _character00002AE5 =
    {
        0x00002AE5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AE5,
        0x00002AE5,
        0x00002AE5
    };

    static _CharacterInfo _character00002AE6 =
    {
        0x00002AE6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AE6,
        0x00002AE6,
        0x00002AE6
    };

    static _CharacterInfo _character00002AE7 =
    {
        0x00002AE7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AE7,
        0x00002AE7,
        0x00002AE7
    };

    static _CharacterInfo _character00002AE8 =
    {
        0x00002AE8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AE8,
        0x00002AE8,
        0x00002AE8
    };

    static _CharacterInfo _character00002AE9 =
    {
        0x00002AE9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AE9,
        0x00002AE9,
        0x00002AE9
    };

    static _CharacterInfo _character00002AEA =
    {
        0x00002AEA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AEA,
        0x00002AEA,
        0x00002AEA
    };

    static _CharacterInfo _character00002AEB =
    {
        0x00002AEB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AEB,
        0x00002AEB,
        0x00002AEB
    };

    static _CharacterInfo _character00002AEC =
    {
        0x00002AEC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AEC,
        0x00002AEC,
        0x00002AEC
    };

    static _CharacterInfo _character00002AED =
    {
        0x00002AED,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AED,
        0x00002AED,
        0x00002AED
    };

    static _CharacterInfo _character00002AEE =
    {
        0x00002AEE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AEE,
        0x00002AEE,
        0x00002AEE
    };

    static _CharacterInfo _character00002AEF =
    {
        0x00002AEF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AEF,
        0x00002AEF,
        0x00002AEF
    };

    static _CharacterInfo _character00002AF0 =
    {
        0x00002AF0,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF0,
        0x00002AF0,
        0x00002AF0
    };

    static _CharacterInfo _character00002AF1 =
    {
        0x00002AF1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF1,
        0x00002AF1,
        0x00002AF1
    };

    static _CharacterInfo _character00002AF2 =
    {
        0x00002AF2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF2,
        0x00002AF2,
        0x00002AF2
    };

    static _CharacterInfo _character00002AF3 =
    {
        0x00002AF3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AF3,
        0x00002AF3,
        0x00002AF3
    };

    static _CharacterInfo _character00002AF4 =
    {
        0x00002AF4,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF4,
        0x00002AF4,
        0x00002AF4
    };

    static _CharacterInfo _character00002AF5 =
    {
        0x00002AF5,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF5,
        0x00002AF5,
        0x00002AF5
    };

    static _CharacterInfo _character00002AF6 =
    {
        0x00002AF6,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AF6,
        0x00002AF6,
        0x00002AF6
    };

    static _CharacterInfo _character00002AF7 =
    {
        0x00002AF7,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AF7,
        0x00002AF7,
        0x00002AF7
    };

    static _CharacterInfo _character00002AF8 =
    {
        0x00002AF8,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AF8,
        0x00002AF8,
        0x00002AF8
    };

    static _CharacterInfo _character00002AF9 =
    {
        0x00002AF9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AF9,
        0x00002AF9,
        0x00002AF9
    };

    static _CharacterInfo _character00002AFA =
    {
        0x00002AFA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AFA,
        0x00002AFA,
        0x00002AFA
    };

    static _CharacterInfo _character00002AFB =
    {
        0x00002AFB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AFB,
        0x00002AFB,
        0x00002AFB
    };

    static _CharacterInfo _character00002AFC =
    {
        0x00002AFC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AFC,
        0x00002AFC,
        0x00002AFC
    };

    static _CharacterInfo _character00002AFD =
    {
        0x00002AFD,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002AFD,
        0x00002AFD,
        0x00002AFD
    };

    static _CharacterInfo _character00002AFE =
    {
        0x00002AFE,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AFE,
        0x00002AFE,
        0x00002AFE
    };

    static _CharacterInfo _character00002AFF =
    {
        0x00002AFF,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002AFF,
        0x00002AFF,
        0x00002AFF
    };

    static _CharacterInfo _character00002B00 =
    {
        0x00002B00,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B00,
        0x00002B00,
        0x00002B00
    };

    static _CharacterInfo _character00002B01 =
    {
        0x00002B01,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B01,
        0x00002B01,
        0x00002B01
    };

    static _CharacterInfo _character00002B02 =
    {
        0x00002B02,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B02,
        0x00002B02,
        0x00002B02
    };

    static _CharacterInfo _character00002B03 =
    {
        0x00002B03,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B03,
        0x00002B03,
        0x00002B03
    };

    static _CharacterInfo _character00002B04 =
    {
        0x00002B04,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B04,
        0x00002B04,
        0x00002B04
    };

    static _CharacterInfo _character00002B05 =
    {
        0x00002B05,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B05,
        0x00002B05,
        0x00002B05
    };

    static _CharacterInfo _character00002B06 =
    {
        0x00002B06,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B06,
        0x00002B06,
        0x00002B06
    };

    static _CharacterInfo _character00002B07 =
    {
        0x00002B07,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B07,
        0x00002B07,
        0x00002B07
    };

    static _CharacterInfo _character00002B08 =
    {
        0x00002B08,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B08,
        0x00002B08,
        0x00002B08
    };

    static _CharacterInfo _character00002B09 =
    {
        0x00002B09,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B09,
        0x00002B09,
        0x00002B09
    };

    static _CharacterInfo _character00002B0A =
    {
        0x00002B0A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0A,
        0x00002B0A,
        0x00002B0A
    };

    static _CharacterInfo _character00002B0B =
    {
        0x00002B0B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0B,
        0x00002B0B,
        0x00002B0B
    };

    static _CharacterInfo _character00002B0C =
    {
        0x00002B0C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0C,
        0x00002B0C,
        0x00002B0C
    };

    static _CharacterInfo _character00002B0D =
    {
        0x00002B0D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0D,
        0x00002B0D,
        0x00002B0D
    };

    static _CharacterInfo _character00002B0E =
    {
        0x00002B0E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0E,
        0x00002B0E,
        0x00002B0E
    };

    static _CharacterInfo _character00002B0F =
    {
        0x00002B0F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B0F,
        0x00002B0F,
        0x00002B0F
    };

    static _CharacterInfo _character00002B10 =
    {
        0x00002B10,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B10,
        0x00002B10,
        0x00002B10
    };

    static _CharacterInfo _character00002B11 =
    {
        0x00002B11,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B11,
        0x00002B11,
        0x00002B11
    };

    static _CharacterInfo _character00002B12 =
    {
        0x00002B12,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B12,
        0x00002B12,
        0x00002B12
    };

    static _CharacterInfo _character00002B13 =
    {
        0x00002B13,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B13,
        0x00002B13,
        0x00002B13
    };

    static _CharacterInfo _character00002B14 =
    {
        0x00002B14,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B14,
        0x00002B14,
        0x00002B14
    };

    static _CharacterInfo _character00002B15 =
    {
        0x00002B15,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B15,
        0x00002B15,
        0x00002B15
    };

    static _CharacterInfo _character00002B16 =
    {
        0x00002B16,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B16,
        0x00002B16,
        0x00002B16
    };

    static _CharacterInfo _character00002B17 =
    {
        0x00002B17,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B17,
        0x00002B17,
        0x00002B17
    };

    static _CharacterInfo _character00002B18 =
    {
        0x00002B18,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B18,
        0x00002B18,
        0x00002B18
    };

    static _CharacterInfo _character00002B19 =
    {
        0x00002B19,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B19,
        0x00002B19,
        0x00002B19
    };

    static _CharacterInfo _character00002B1A =
    {
        0x00002B1A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B1A,
        0x00002B1A,
        0x00002B1A
    };

    static _CharacterInfo _character00002B20 =
    {
        0x00002B20,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B20,
        0x00002B20,
        0x00002B20
    };

    static _CharacterInfo _character00002B21 =
    {
        0x00002B21,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B21,
        0x00002B21,
        0x00002B21
    };

    static _CharacterInfo _character00002B22 =
    {
        0x00002B22,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B22,
        0x00002B22,
        0x00002B22
    };

    static _CharacterInfo _character00002B23 =
    {
        0x00002B23,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002B23,
        0x00002B23,
        0x00002B23
    };

    static _CharacterInfo _character00002C00 =
    {
        0x00002C00,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C00,
        0x00002C30,
        0x00002C00
    };

    static _CharacterInfo _character00002C01 =
    {
        0x00002C01,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C01,
        0x00002C31,
        0x00002C01
    };

    static _CharacterInfo _character00002C02 =
    {
        0x00002C02,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C02,
        0x00002C32,
        0x00002C02
    };

    static _CharacterInfo _character00002C03 =
    {
        0x00002C03,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C03,
        0x00002C33,
        0x00002C03
    };

    static _CharacterInfo _character00002C04 =
    {
        0x00002C04,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C04,
        0x00002C34,
        0x00002C04
    };

    static _CharacterInfo _character00002C05 =
    {
        0x00002C05,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C05,
        0x00002C35,
        0x00002C05
    };

    static _CharacterInfo _character00002C06 =
    {
        0x00002C06,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C06,
        0x00002C36,
        0x00002C06
    };

    static _CharacterInfo _character00002C07 =
    {
        0x00002C07,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C07,
        0x00002C37,
        0x00002C07
    };

    static _CharacterInfo _character00002C08 =
    {
        0x00002C08,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C08,
        0x00002C38,
        0x00002C08
    };

    static _CharacterInfo _character00002C09 =
    {
        0x00002C09,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C09,
        0x00002C39,
        0x00002C09
    };

    static _CharacterInfo _character00002C0A =
    {
        0x00002C0A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0A,
        0x00002C3A,
        0x00002C0A
    };

    static _CharacterInfo _character00002C0B =
    {
        0x00002C0B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0B,
        0x00002C3B,
        0x00002C0B
    };

    static _CharacterInfo _character00002C0C =
    {
        0x00002C0C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0C,
        0x00002C3C,
        0x00002C0C
    };

    static _CharacterInfo _character00002C0D =
    {
        0x00002C0D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0D,
        0x00002C3D,
        0x00002C0D
    };

    static _CharacterInfo _character00002C0E =
    {
        0x00002C0E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0E,
        0x00002C3E,
        0x00002C0E
    };

    static _CharacterInfo _character00002C0F =
    {
        0x00002C0F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0F,
        0x00002C3F,
        0x00002C0F
    };

    static _CharacterInfo _character00002C10 =
    {
        0x00002C10,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C10,
        0x00002C40,
        0x00002C10
    };

    static _CharacterInfo _character00002C11 =
    {
        0x00002C11,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C11,
        0x00002C41,
        0x00002C11
    };

    static _CharacterInfo _character00002C12 =
    {
        0x00002C12,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C12,
        0x00002C42,
        0x00002C12
    };

    static _CharacterInfo _character00002C13 =
    {
        0x00002C13,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C13,
        0x00002C43,
        0x00002C13
    };

    static _CharacterInfo _character00002C14 =
    {
        0x00002C14,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C14,
        0x00002C44,
        0x00002C14
    };

    static _CharacterInfo _character00002C15 =
    {
        0x00002C15,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C15,
        0x00002C45,
        0x00002C15
    };

    static _CharacterInfo _character00002C16 =
    {
        0x00002C16,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C16,
        0x00002C46,
        0x00002C16
    };

    static _CharacterInfo _character00002C17 =
    {
        0x00002C17,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C17,
        0x00002C47,
        0x00002C17
    };

    static _CharacterInfo _character00002C18 =
    {
        0x00002C18,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C18,
        0x00002C48,
        0x00002C18
    };

    static _CharacterInfo _character00002C19 =
    {
        0x00002C19,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C19,
        0x00002C49,
        0x00002C19
    };

    static _CharacterInfo _character00002C1A =
    {
        0x00002C1A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1A,
        0x00002C4A,
        0x00002C1A
    };

    static _CharacterInfo _character00002C1B =
    {
        0x00002C1B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1B,
        0x00002C4B,
        0x00002C1B
    };

    static _CharacterInfo _character00002C1C =
    {
        0x00002C1C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1C,
        0x00002C4C,
        0x00002C1C
    };

    static _CharacterInfo _character00002C1D =
    {
        0x00002C1D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1D,
        0x00002C4D,
        0x00002C1D
    };

    static _CharacterInfo _character00002C1E =
    {
        0x00002C1E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1E,
        0x00002C4E,
        0x00002C1E
    };

    static _CharacterInfo _character00002C1F =
    {
        0x00002C1F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1F,
        0x00002C4F,
        0x00002C1F
    };

    static _CharacterInfo _character00002C20 =
    {
        0x00002C20,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C20,
        0x00002C50,
        0x00002C20
    };

    static _CharacterInfo _character00002C21 =
    {
        0x00002C21,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C21,
        0x00002C51,
        0x00002C21
    };

    static _CharacterInfo _character00002C22 =
    {
        0x00002C22,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C22,
        0x00002C52,
        0x00002C22
    };

    static _CharacterInfo _character00002C23 =
    {
        0x00002C23,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C23,
        0x00002C53,
        0x00002C23
    };

    static _CharacterInfo _character00002C24 =
    {
        0x00002C24,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C24,
        0x00002C54,
        0x00002C24
    };

    static _CharacterInfo _character00002C25 =
    {
        0x00002C25,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C25,
        0x00002C55,
        0x00002C25
    };

    static _CharacterInfo _character00002C26 =
    {
        0x00002C26,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C26,
        0x00002C56,
        0x00002C26
    };

    static _CharacterInfo _character00002C27 =
    {
        0x00002C27,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C27,
        0x00002C57,
        0x00002C27
    };

    static _CharacterInfo _character00002C28 =
    {
        0x00002C28,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C28,
        0x00002C58,
        0x00002C28
    };

    static _CharacterInfo _character00002C29 =
    {
        0x00002C29,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C29,
        0x00002C59,
        0x00002C29
    };

    static _CharacterInfo _character00002C2A =
    {
        0x00002C2A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2A,
        0x00002C5A,
        0x00002C2A
    };

    static _CharacterInfo _character00002C2B =
    {
        0x00002C2B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2B,
        0x00002C5B,
        0x00002C2B
    };

    static _CharacterInfo _character00002C2C =
    {
        0x00002C2C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2C,
        0x00002C5C,
        0x00002C2C
    };

    static _CharacterInfo _character00002C2D =
    {
        0x00002C2D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2D,
        0x00002C5D,
        0x00002C2D
    };

    static _CharacterInfo _character00002C2E =
    {
        0x00002C2E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2E,
        0x00002C5E,
        0x00002C2E
    };

    static _CharacterInfo _character00002C30 =
    {
        0x00002C30,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C00,
        0x00002C30,
        0x00002C00
    };

    static _CharacterInfo _character00002C31 =
    {
        0x00002C31,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C01,
        0x00002C31,
        0x00002C01
    };

    static _CharacterInfo _character00002C32 =
    {
        0x00002C32,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C02,
        0x00002C32,
        0x00002C02
    };

    static _CharacterInfo _character00002C33 =
    {
        0x00002C33,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C03,
        0x00002C33,
        0x00002C03
    };

    static _CharacterInfo _character00002C34 =
    {
        0x00002C34,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C04,
        0x00002C34,
        0x00002C04
    };

    static _CharacterInfo _character00002C35 =
    {
        0x00002C35,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C05,
        0x00002C35,
        0x00002C05
    };

    static _CharacterInfo _character00002C36 =
    {
        0x00002C36,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C06,
        0x00002C36,
        0x00002C06
    };

    static _CharacterInfo _character00002C37 =
    {
        0x00002C37,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C07,
        0x00002C37,
        0x00002C07
    };

    static _CharacterInfo _character00002C38 =
    {
        0x00002C38,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C08,
        0x00002C38,
        0x00002C08
    };

    static _CharacterInfo _character00002C39 =
    {
        0x00002C39,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C09,
        0x00002C39,
        0x00002C09
    };

    static _CharacterInfo _character00002C3A =
    {
        0x00002C3A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0A,
        0x00002C3A,
        0x00002C0A
    };

    static _CharacterInfo _character00002C3B =
    {
        0x00002C3B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0B,
        0x00002C3B,
        0x00002C0B
    };

    static _CharacterInfo _character00002C3C =
    {
        0x00002C3C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0C,
        0x00002C3C,
        0x00002C0C
    };

    static _CharacterInfo _character00002C3D =
    {
        0x00002C3D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0D,
        0x00002C3D,
        0x00002C0D
    };

    static _CharacterInfo _character00002C3E =
    {
        0x00002C3E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0E,
        0x00002C3E,
        0x00002C0E
    };

    static _CharacterInfo _character00002C3F =
    {
        0x00002C3F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C0F,
        0x00002C3F,
        0x00002C0F
    };

    static _CharacterInfo _character00002C40 =
    {
        0x00002C40,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C10,
        0x00002C40,
        0x00002C10
    };

    static _CharacterInfo _character00002C41 =
    {
        0x00002C41,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C11,
        0x00002C41,
        0x00002C11
    };

    static _CharacterInfo _character00002C42 =
    {
        0x00002C42,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C12,
        0x00002C42,
        0x00002C12
    };

    static _CharacterInfo _character00002C43 =
    {
        0x00002C43,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C13,
        0x00002C43,
        0x00002C13
    };

    static _CharacterInfo _character00002C44 =
    {
        0x00002C44,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C14,
        0x00002C44,
        0x00002C14
    };

    static _CharacterInfo _character00002C45 =
    {
        0x00002C45,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C15,
        0x00002C45,
        0x00002C15
    };

    static _CharacterInfo _character00002C46 =
    {
        0x00002C46,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C16,
        0x00002C46,
        0x00002C16
    };

    static _CharacterInfo _character00002C47 =
    {
        0x00002C47,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C17,
        0x00002C47,
        0x00002C17
    };

    static _CharacterInfo _character00002C48 =
    {
        0x00002C48,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C18,
        0x00002C48,
        0x00002C18
    };

    static _CharacterInfo _character00002C49 =
    {
        0x00002C49,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C19,
        0x00002C49,
        0x00002C19
    };

    static _CharacterInfo _character00002C4A =
    {
        0x00002C4A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1A,
        0x00002C4A,
        0x00002C1A
    };

    static _CharacterInfo _character00002C4B =
    {
        0x00002C4B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1B,
        0x00002C4B,
        0x00002C1B
    };

    static _CharacterInfo _character00002C4C =
    {
        0x00002C4C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1C,
        0x00002C4C,
        0x00002C1C
    };

    static _CharacterInfo _character00002C4D =
    {
        0x00002C4D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1D,
        0x00002C4D,
        0x00002C1D
    };

    static _CharacterInfo _character00002C4E =
    {
        0x00002C4E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1E,
        0x00002C4E,
        0x00002C1E
    };

    static _CharacterInfo _character00002C4F =
    {
        0x00002C4F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C1F,
        0x00002C4F,
        0x00002C1F
    };

    static _CharacterInfo _character00002C50 =
    {
        0x00002C50,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C20,
        0x00002C50,
        0x00002C20
    };

    static _CharacterInfo _character00002C51 =
    {
        0x00002C51,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C21,
        0x00002C51,
        0x00002C21
    };

    static _CharacterInfo _character00002C52 =
    {
        0x00002C52,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C22,
        0x00002C52,
        0x00002C22
    };

    static _CharacterInfo _character00002C53 =
    {
        0x00002C53,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C23,
        0x00002C53,
        0x00002C23
    };

    static _CharacterInfo _character00002C54 =
    {
        0x00002C54,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C24,
        0x00002C54,
        0x00002C24
    };

    static _CharacterInfo _character00002C55 =
    {
        0x00002C55,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C25,
        0x00002C55,
        0x00002C25
    };

    static _CharacterInfo _character00002C56 =
    {
        0x00002C56,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C26,
        0x00002C56,
        0x00002C26
    };

    static _CharacterInfo _character00002C57 =
    {
        0x00002C57,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C27,
        0x00002C57,
        0x00002C27
    };

    static _CharacterInfo _character00002C58 =
    {
        0x00002C58,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C28,
        0x00002C58,
        0x00002C28
    };

    static _CharacterInfo _character00002C59 =
    {
        0x00002C59,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C29,
        0x00002C59,
        0x00002C29
    };

    static _CharacterInfo _character00002C5A =
    {
        0x00002C5A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2A,
        0x00002C5A,
        0x00002C2A
    };

    static _CharacterInfo _character00002C5B =
    {
        0x00002C5B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2B,
        0x00002C5B,
        0x00002C2B
    };

    static _CharacterInfo _character00002C5C =
    {
        0x00002C5C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2C,
        0x00002C5C,
        0x00002C2C
    };

    static _CharacterInfo _character00002C5D =
    {
        0x00002C5D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2D,
        0x00002C5D,
        0x00002C2D
    };

    static _CharacterInfo _character00002C5E =
    {
        0x00002C5E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C2E,
        0x00002C5E,
        0x00002C2E
    };

    static _CharacterInfo _character00002C60 =
    {
        0x00002C60,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C60,
        0x00002C61,
        0x00002C60
    };

    static _CharacterInfo _character00002C61 =
    {
        0x00002C61,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C60,
        0x00002C61,
        0x00002C60
    };

    static _CharacterInfo _character00002C62 =
    {
        0x00002C62,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C62,
        0x0000026B,
        0x00002C62
    };

    static _CharacterInfo _character00002C63 =
    {
        0x00002C63,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C63,
        0x00001D7D,
        0x00002C63
    };

    static _CharacterInfo _character00002C64 =
    {
        0x00002C64,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C64,
        0x0000027D,
        0x00002C64
    };

    static _CharacterInfo _character00002C65 =
    {
        0x00002C65,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023A,
        0x00002C65,
        0x0000023A
    };

    static _CharacterInfo _character00002C66 =
    {
        0x00002C66,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000023E,
        0x00002C66,
        0x0000023E
    };

    static _CharacterInfo _character00002C67 =
    {
        0x00002C67,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C67,
        0x00002C68,
        0x00002C67
    };

    static _CharacterInfo _character00002C68 =
    {
        0x00002C68,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C67,
        0x00002C68,
        0x00002C67
    };

    static _CharacterInfo _character00002C69 =
    {
        0x00002C69,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C69,
        0x00002C6A,
        0x00002C69
    };

    static _CharacterInfo _character00002C6A =
    {
        0x00002C6A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C69,
        0x00002C6A,
        0x00002C69
    };

    static _CharacterInfo _character00002C6B =
    {
        0x00002C6B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C6B,
        0x00002C6C,
        0x00002C6B
    };

    static _CharacterInfo _character00002C6C =
    {
        0x00002C6C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C6B,
        0x00002C6C,
        0x00002C6B
    };

    static _CharacterInfo _character00002C74 =
    {
        0x00002C74,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C74,
        0x00002C74,
        0x00002C74
    };

    static _CharacterInfo _character00002C75 =
    {
        0x00002C75,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C75,
        0x00002C76,
        0x00002C75
    };

    static _CharacterInfo _character00002C76 =
    {
        0x00002C76,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C75,
        0x00002C76,
        0x00002C75
    };

    static _CharacterInfo _character00002C77 =
    {
        0x00002C77,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C77,
        0x00002C77,
        0x00002C77
    };

    static _CharacterInfo _character00002C80 =
    {
        0x00002C80,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C80,
        0x00002C81,
        0x00002C80
    };

    static _CharacterInfo _character00002C81 =
    {
        0x00002C81,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C80,
        0x00002C81,
        0x00002C80
    };

    static _CharacterInfo _character00002C82 =
    {
        0x00002C82,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C82,
        0x00002C83,
        0x00002C82
    };

    static _CharacterInfo _character00002C83 =
    {
        0x00002C83,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C82,
        0x00002C83,
        0x00002C82
    };

    static _CharacterInfo _character00002C84 =
    {
        0x00002C84,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C84,
        0x00002C85,
        0x00002C84
    };

    static _CharacterInfo _character00002C85 =
    {
        0x00002C85,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C84,
        0x00002C85,
        0x00002C84
    };

    static _CharacterInfo _character00002C86 =
    {
        0x00002C86,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C86,
        0x00002C87,
        0x00002C86
    };

    static _CharacterInfo _character00002C87 =
    {
        0x00002C87,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C86,
        0x00002C87,
        0x00002C86
    };

    static _CharacterInfo _character00002C88 =
    {
        0x00002C88,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C88,
        0x00002C89,
        0x00002C88
    };

    static _CharacterInfo _character00002C89 =
    {
        0x00002C89,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C88,
        0x00002C89,
        0x00002C88
    };

    static _CharacterInfo _character00002C8A =
    {
        0x00002C8A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8A,
        0x00002C8B,
        0x00002C8A
    };

    static _CharacterInfo _character00002C8B =
    {
        0x00002C8B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8A,
        0x00002C8B,
        0x00002C8A
    };

    static _CharacterInfo _character00002C8C =
    {
        0x00002C8C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8C,
        0x00002C8D,
        0x00002C8C
    };

    static _CharacterInfo _character00002C8D =
    {
        0x00002C8D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8C,
        0x00002C8D,
        0x00002C8C
    };

    static _CharacterInfo _character00002C8E =
    {
        0x00002C8E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8E,
        0x00002C8F,
        0x00002C8E
    };

    static _CharacterInfo _character00002C8F =
    {
        0x00002C8F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C8E,
        0x00002C8F,
        0x00002C8E
    };

    static _CharacterInfo _character00002C90 =
    {
        0x00002C90,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C90,
        0x00002C91,
        0x00002C90
    };

    static _CharacterInfo _character00002C91 =
    {
        0x00002C91,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C90,
        0x00002C91,
        0x00002C90
    };

    static _CharacterInfo _character00002C92 =
    {
        0x00002C92,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C92,
        0x00002C93,
        0x00002C92
    };

    static _CharacterInfo _character00002C93 =
    {
        0x00002C93,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C92,
        0x00002C93,
        0x00002C92
    };

    static _CharacterInfo _character00002C94 =
    {
        0x00002C94,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C94,
        0x00002C95,
        0x00002C94
    };

    static _CharacterInfo _character00002C95 =
    {
        0x00002C95,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C94,
        0x00002C95,
        0x00002C94
    };

    static _CharacterInfo _character00002C96 =
    {
        0x00002C96,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C96,
        0x00002C97,
        0x00002C96
    };

    static _CharacterInfo _character00002C97 =
    {
        0x00002C97,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C96,
        0x00002C97,
        0x00002C96
    };

    static _CharacterInfo _character00002C98 =
    {
        0x00002C98,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C98,
        0x00002C99,
        0x00002C98
    };

    static _CharacterInfo _character00002C99 =
    {
        0x00002C99,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C98,
        0x00002C99,
        0x00002C98
    };

    static _CharacterInfo _character00002C9A =
    {
        0x00002C9A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9A,
        0x00002C9B,
        0x00002C9A
    };

    static _CharacterInfo _character00002C9B =
    {
        0x00002C9B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9A,
        0x00002C9B,
        0x00002C9A
    };

    static _CharacterInfo _character00002C9C =
    {
        0x00002C9C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9C,
        0x00002C9D,
        0x00002C9C
    };

    static _CharacterInfo _character00002C9D =
    {
        0x00002C9D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9C,
        0x00002C9D,
        0x00002C9C
    };

    static _CharacterInfo _character00002C9E =
    {
        0x00002C9E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9E,
        0x00002C9F,
        0x00002C9E
    };

    static _CharacterInfo _character00002C9F =
    {
        0x00002C9F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002C9E,
        0x00002C9F,
        0x00002C9E
    };

    static _CharacterInfo _character00002CA0 =
    {
        0x00002CA0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA0,
        0x00002CA1,
        0x00002CA0
    };

    static _CharacterInfo _character00002CA1 =
    {
        0x00002CA1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA0,
        0x00002CA1,
        0x00002CA0
    };

    static _CharacterInfo _character00002CA2 =
    {
        0x00002CA2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA2,
        0x00002CA3,
        0x00002CA2
    };

    static _CharacterInfo _character00002CA3 =
    {
        0x00002CA3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA2,
        0x00002CA3,
        0x00002CA2
    };

    static _CharacterInfo _character00002CA4 =
    {
        0x00002CA4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA4,
        0x00002CA5,
        0x00002CA4
    };

    static _CharacterInfo _character00002CA5 =
    {
        0x00002CA5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA4,
        0x00002CA5,
        0x00002CA4
    };

    static _CharacterInfo _character00002CA6 =
    {
        0x00002CA6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA6,
        0x00002CA7,
        0x00002CA6
    };

    static _CharacterInfo _character00002CA7 =
    {
        0x00002CA7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA6,
        0x00002CA7,
        0x00002CA6
    };

    static _CharacterInfo _character00002CA8 =
    {
        0x00002CA8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA8,
        0x00002CA9,
        0x00002CA8
    };

    static _CharacterInfo _character00002CA9 =
    {
        0x00002CA9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CA8,
        0x00002CA9,
        0x00002CA8
    };

    static _CharacterInfo _character00002CAA =
    {
        0x00002CAA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAA,
        0x00002CAB,
        0x00002CAA
    };

    static _CharacterInfo _character00002CAB =
    {
        0x00002CAB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAA,
        0x00002CAB,
        0x00002CAA
    };

    static _CharacterInfo _character00002CAC =
    {
        0x00002CAC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAC,
        0x00002CAD,
        0x00002CAC
    };

    static _CharacterInfo _character00002CAD =
    {
        0x00002CAD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAC,
        0x00002CAD,
        0x00002CAC
    };

    static _CharacterInfo _character00002CAE =
    {
        0x00002CAE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAE,
        0x00002CAF,
        0x00002CAE
    };

    static _CharacterInfo _character00002CAF =
    {
        0x00002CAF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CAE,
        0x00002CAF,
        0x00002CAE
    };

    static _CharacterInfo _character00002CB0 =
    {
        0x00002CB0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB0,
        0x00002CB1,
        0x00002CB0
    };

    static _CharacterInfo _character00002CB1 =
    {
        0x00002CB1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB0,
        0x00002CB1,
        0x00002CB0
    };

    static _CharacterInfo _character00002CB2 =
    {
        0x00002CB2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB2,
        0x00002CB3,
        0x00002CB2
    };

    static _CharacterInfo _character00002CB3 =
    {
        0x00002CB3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB2,
        0x00002CB3,
        0x00002CB2
    };

    static _CharacterInfo _character00002CB4 =
    {
        0x00002CB4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB4,
        0x00002CB5,
        0x00002CB4
    };

    static _CharacterInfo _character00002CB5 =
    {
        0x00002CB5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB4,
        0x00002CB5,
        0x00002CB4
    };

    static _CharacterInfo _character00002CB6 =
    {
        0x00002CB6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB6,
        0x00002CB7,
        0x00002CB6
    };

    static _CharacterInfo _character00002CB7 =
    {
        0x00002CB7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB6,
        0x00002CB7,
        0x00002CB6
    };

    static _CharacterInfo _character00002CB8 =
    {
        0x00002CB8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB8,
        0x00002CB9,
        0x00002CB8
    };

    static _CharacterInfo _character00002CB9 =
    {
        0x00002CB9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CB8,
        0x00002CB9,
        0x00002CB8
    };

    static _CharacterInfo _character00002CBA =
    {
        0x00002CBA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBA,
        0x00002CBB,
        0x00002CBA
    };

    static _CharacterInfo _character00002CBB =
    {
        0x00002CBB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBA,
        0x00002CBB,
        0x00002CBA
    };

    static _CharacterInfo _character00002CBC =
    {
        0x00002CBC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBC,
        0x00002CBD,
        0x00002CBC
    };

    static _CharacterInfo _character00002CBD =
    {
        0x00002CBD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBC,
        0x00002CBD,
        0x00002CBC
    };

    static _CharacterInfo _character00002CBE =
    {
        0x00002CBE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBE,
        0x00002CBF,
        0x00002CBE
    };

    static _CharacterInfo _character00002CBF =
    {
        0x00002CBF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CBE,
        0x00002CBF,
        0x00002CBE
    };

    static _CharacterInfo _character00002CC0 =
    {
        0x00002CC0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC0,
        0x00002CC1,
        0x00002CC0
    };

    static _CharacterInfo _character00002CC1 =
    {
        0x00002CC1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC0,
        0x00002CC1,
        0x00002CC0
    };

    static _CharacterInfo _character00002CC2 =
    {
        0x00002CC2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC2,
        0x00002CC3,
        0x00002CC2
    };

    static _CharacterInfo _character00002CC3 =
    {
        0x00002CC3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC2,
        0x00002CC3,
        0x00002CC2
    };

    static _CharacterInfo _character00002CC4 =
    {
        0x00002CC4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC4,
        0x00002CC5,
        0x00002CC4
    };

    static _CharacterInfo _character00002CC5 =
    {
        0x00002CC5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC4,
        0x00002CC5,
        0x00002CC4
    };

    static _CharacterInfo _character00002CC6 =
    {
        0x00002CC6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC6,
        0x00002CC7,
        0x00002CC6
    };

    static _CharacterInfo _character00002CC7 =
    {
        0x00002CC7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC6,
        0x00002CC7,
        0x00002CC6
    };

    static _CharacterInfo _character00002CC8 =
    {
        0x00002CC8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC8,
        0x00002CC9,
        0x00002CC8
    };

    static _CharacterInfo _character00002CC9 =
    {
        0x00002CC9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CC8,
        0x00002CC9,
        0x00002CC8
    };

    static _CharacterInfo _character00002CCA =
    {
        0x00002CCA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCA,
        0x00002CCB,
        0x00002CCA
    };

    static _CharacterInfo _character00002CCB =
    {
        0x00002CCB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCA,
        0x00002CCB,
        0x00002CCA
    };

    static _CharacterInfo _character00002CCC =
    {
        0x00002CCC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCC,
        0x00002CCD,
        0x00002CCC
    };

    static _CharacterInfo _character00002CCD =
    {
        0x00002CCD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCC,
        0x00002CCD,
        0x00002CCC
    };

    static _CharacterInfo _character00002CCE =
    {
        0x00002CCE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCE,
        0x00002CCF,
        0x00002CCE
    };

    static _CharacterInfo _character00002CCF =
    {
        0x00002CCF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CCE,
        0x00002CCF,
        0x00002CCE
    };

    static _CharacterInfo _character00002CD0 =
    {
        0x00002CD0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD0,
        0x00002CD1,
        0x00002CD0
    };

    static _CharacterInfo _character00002CD1 =
    {
        0x00002CD1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD0,
        0x00002CD1,
        0x00002CD0
    };

    static _CharacterInfo _character00002CD2 =
    {
        0x00002CD2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD2,
        0x00002CD3,
        0x00002CD2
    };

    static _CharacterInfo _character00002CD3 =
    {
        0x00002CD3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD2,
        0x00002CD3,
        0x00002CD2
    };

    static _CharacterInfo _character00002CD4 =
    {
        0x00002CD4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD4,
        0x00002CD5,
        0x00002CD4
    };

    static _CharacterInfo _character00002CD5 =
    {
        0x00002CD5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD4,
        0x00002CD5,
        0x00002CD4
    };

    static _CharacterInfo _character00002CD6 =
    {
        0x00002CD6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD6,
        0x00002CD7,
        0x00002CD6
    };

    static _CharacterInfo _character00002CD7 =
    {
        0x00002CD7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD6,
        0x00002CD7,
        0x00002CD6
    };

    static _CharacterInfo _character00002CD8 =
    {
        0x00002CD8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD8,
        0x00002CD9,
        0x00002CD8
    };

    static _CharacterInfo _character00002CD9 =
    {
        0x00002CD9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CD8,
        0x00002CD9,
        0x00002CD8
    };

    static _CharacterInfo _character00002CDA =
    {
        0x00002CDA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDA,
        0x00002CDB,
        0x00002CDA
    };

    static _CharacterInfo _character00002CDB =
    {
        0x00002CDB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDA,
        0x00002CDB,
        0x00002CDA
    };

    static _CharacterInfo _character00002CDC =
    {
        0x00002CDC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDC,
        0x00002CDD,
        0x00002CDC
    };

    static _CharacterInfo _character00002CDD =
    {
        0x00002CDD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDC,
        0x00002CDD,
        0x00002CDC
    };

    static _CharacterInfo _character00002CDE =
    {
        0x00002CDE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDE,
        0x00002CDF,
        0x00002CDE
    };

    static _CharacterInfo _character00002CDF =
    {
        0x00002CDF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CDE,
        0x00002CDF,
        0x00002CDE
    };

    static _CharacterInfo _character00002CE0 =
    {
        0x00002CE0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE0,
        0x00002CE1,
        0x00002CE0
    };

    static _CharacterInfo _character00002CE1 =
    {
        0x00002CE1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE0,
        0x00002CE1,
        0x00002CE0
    };

    static _CharacterInfo _character00002CE2 =
    {
        0x00002CE2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE2,
        0x00002CE3,
        0x00002CE2
    };

    static _CharacterInfo _character00002CE3 =
    {
        0x00002CE3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE2,
        0x00002CE3,
        0x00002CE2
    };

    static _CharacterInfo _character00002CE4 =
    {
        0x00002CE4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE4,
        0x00002CE4,
        0x00002CE4
    };

    static _CharacterInfo _character00002CE5 =
    {
        0x00002CE5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE5,
        0x00002CE5,
        0x00002CE5
    };

    static _CharacterInfo _character00002CE6 =
    {
        0x00002CE6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE6,
        0x00002CE6,
        0x00002CE6
    };

    static _CharacterInfo _character00002CE7 =
    {
        0x00002CE7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE7,
        0x00002CE7,
        0x00002CE7
    };

    static _CharacterInfo _character00002CE8 =
    {
        0x00002CE8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE8,
        0x00002CE8,
        0x00002CE8
    };

    static _CharacterInfo _character00002CE9 =
    {
        0x00002CE9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CE9,
        0x00002CE9,
        0x00002CE9
    };

    static _CharacterInfo _character00002CEA =
    {
        0x00002CEA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CEA,
        0x00002CEA,
        0x00002CEA
    };

    static _CharacterInfo _character00002CF9 =
    {
        0x00002CF9,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CF9,
        0x00002CF9,
        0x00002CF9
    };

    static _CharacterInfo _character00002CFA =
    {
        0x00002CFA,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CFA,
        0x00002CFA,
        0x00002CFA
    };

    static _CharacterInfo _character00002CFB =
    {
        0x00002CFB,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CFB,
        0x00002CFB,
        0x00002CFB
    };

    static _CharacterInfo _character00002CFC =
    {
        0x00002CFC,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CFC,
        0x00002CFC,
        0x00002CFC
    };

    static _CharacterInfo _character00002CFD =
    {
        0x00002CFD,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x00002CFD,
        0x00002CFD,
        0x00002CFD
    };

    static _CharacterInfo _character00002CFE =
    {
        0x00002CFE,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CFE,
        0x00002CFE,
        0x00002CFE
    };

    static _CharacterInfo _character00002CFF =
    {
        0x00002CFF,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002CFF,
        0x00002CFF,
        0x00002CFF
    };

    static _CharacterInfo _character00002D00 =
    {
        0x00002D00,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A0,
        0x00002D00,
        0x000010A0
    };

    static _CharacterInfo _character00002D01 =
    {
        0x00002D01,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A1,
        0x00002D01,
        0x000010A1
    };

    static _CharacterInfo _character00002D02 =
    {
        0x00002D02,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A2,
        0x00002D02,
        0x000010A2
    };

    static _CharacterInfo _character00002D03 =
    {
        0x00002D03,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A3,
        0x00002D03,
        0x000010A3
    };

    static _CharacterInfo _character00002D04 =
    {
        0x00002D04,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A4,
        0x00002D04,
        0x000010A4
    };

    static _CharacterInfo _character00002D05 =
    {
        0x00002D05,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A5,
        0x00002D05,
        0x000010A5
    };

    static _CharacterInfo _character00002D06 =
    {
        0x00002D06,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A6,
        0x00002D06,
        0x000010A6
    };

    static _CharacterInfo _character00002D07 =
    {
        0x00002D07,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A7,
        0x00002D07,
        0x000010A7
    };

    static _CharacterInfo _character00002D08 =
    {
        0x00002D08,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A8,
        0x00002D08,
        0x000010A8
    };

    static _CharacterInfo _character00002D09 =
    {
        0x00002D09,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010A9,
        0x00002D09,
        0x000010A9
    };

    static _CharacterInfo _character00002D0A =
    {
        0x00002D0A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AA,
        0x00002D0A,
        0x000010AA
    };

    static _CharacterInfo _character00002D0B =
    {
        0x00002D0B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AB,
        0x00002D0B,
        0x000010AB
    };

    static _CharacterInfo _character00002D0C =
    {
        0x00002D0C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AC,
        0x00002D0C,
        0x000010AC
    };

    static _CharacterInfo _character00002D0D =
    {
        0x00002D0D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AD,
        0x00002D0D,
        0x000010AD
    };

    static _CharacterInfo _character00002D0E =
    {
        0x00002D0E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AE,
        0x00002D0E,
        0x000010AE
    };

    static _CharacterInfo _character00002D0F =
    {
        0x00002D0F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010AF,
        0x00002D0F,
        0x000010AF
    };

    static _CharacterInfo _character00002D10 =
    {
        0x00002D10,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B0,
        0x00002D10,
        0x000010B0
    };

    static _CharacterInfo _character00002D11 =
    {
        0x00002D11,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B1,
        0x00002D11,
        0x000010B1
    };

    static _CharacterInfo _character00002D12 =
    {
        0x00002D12,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B2,
        0x00002D12,
        0x000010B2
    };

    static _CharacterInfo _character00002D13 =
    {
        0x00002D13,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B3,
        0x00002D13,
        0x000010B3
    };

    static _CharacterInfo _character00002D14 =
    {
        0x00002D14,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B4,
        0x00002D14,
        0x000010B4
    };

    static _CharacterInfo _character00002D15 =
    {
        0x00002D15,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B5,
        0x00002D15,
        0x000010B5
    };

    static _CharacterInfo _character00002D16 =
    {
        0x00002D16,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B6,
        0x00002D16,
        0x000010B6
    };

    static _CharacterInfo _character00002D17 =
    {
        0x00002D17,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B7,
        0x00002D17,
        0x000010B7
    };

    static _CharacterInfo _character00002D18 =
    {
        0x00002D18,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B8,
        0x00002D18,
        0x000010B8
    };

    static _CharacterInfo _character00002D19 =
    {
        0x00002D19,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010B9,
        0x00002D19,
        0x000010B9
    };

    static _CharacterInfo _character00002D1A =
    {
        0x00002D1A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BA,
        0x00002D1A,
        0x000010BA
    };

    static _CharacterInfo _character00002D1B =
    {
        0x00002D1B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BB,
        0x00002D1B,
        0x000010BB
    };

    static _CharacterInfo _character00002D1C =
    {
        0x00002D1C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BC,
        0x00002D1C,
        0x000010BC
    };

    static _CharacterInfo _character00002D1D =
    {
        0x00002D1D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BD,
        0x00002D1D,
        0x000010BD
    };

    static _CharacterInfo _character00002D1E =
    {
        0x00002D1E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BE,
        0x00002D1E,
        0x000010BE
    };

    static _CharacterInfo _character00002D1F =
    {
        0x00002D1F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010BF,
        0x00002D1F,
        0x000010BF
    };

    static _CharacterInfo _character00002D20 =
    {
        0x00002D20,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C0,
        0x00002D20,
        0x000010C0
    };

    static _CharacterInfo _character00002D21 =
    {
        0x00002D21,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C1,
        0x00002D21,
        0x000010C1
    };

    static _CharacterInfo _character00002D22 =
    {
        0x00002D22,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C2,
        0x00002D22,
        0x000010C2
    };

    static _CharacterInfo _character00002D23 =
    {
        0x00002D23,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C3,
        0x00002D23,
        0x000010C3
    };

    static _CharacterInfo _character00002D24 =
    {
        0x00002D24,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C4,
        0x00002D24,
        0x000010C4
    };

    static _CharacterInfo _character00002D25 =
    {
        0x00002D25,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000010C5,
        0x00002D25,
        0x000010C5
    };

    static _CharacterInfo _character00002D30 =
    {
        0x00002D30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D30,
        0x00002D30,
        0x00002D30
    };

    static _CharacterInfo _character00002D31 =
    {
        0x00002D31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D31,
        0x00002D31,
        0x00002D31
    };

    static _CharacterInfo _character00002D32 =
    {
        0x00002D32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D32,
        0x00002D32,
        0x00002D32
    };

    static _CharacterInfo _character00002D33 =
    {
        0x00002D33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D33,
        0x00002D33,
        0x00002D33
    };

    static _CharacterInfo _character00002D34 =
    {
        0x00002D34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D34,
        0x00002D34,
        0x00002D34
    };

    static _CharacterInfo _character00002D35 =
    {
        0x00002D35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D35,
        0x00002D35,
        0x00002D35
    };

    static _CharacterInfo _character00002D36 =
    {
        0x00002D36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D36,
        0x00002D36,
        0x00002D36
    };

    static _CharacterInfo _character00002D37 =
    {
        0x00002D37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D37,
        0x00002D37,
        0x00002D37
    };

    static _CharacterInfo _character00002D38 =
    {
        0x00002D38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D38,
        0x00002D38,
        0x00002D38
    };

    static _CharacterInfo _character00002D39 =
    {
        0x00002D39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D39,
        0x00002D39,
        0x00002D39
    };

    static _CharacterInfo _character00002D3A =
    {
        0x00002D3A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3A,
        0x00002D3A,
        0x00002D3A
    };

    static _CharacterInfo _character00002D3B =
    {
        0x00002D3B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3B,
        0x00002D3B,
        0x00002D3B
    };

    static _CharacterInfo _character00002D3C =
    {
        0x00002D3C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3C,
        0x00002D3C,
        0x00002D3C
    };

    static _CharacterInfo _character00002D3D =
    {
        0x00002D3D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3D,
        0x00002D3D,
        0x00002D3D
    };

    static _CharacterInfo _character00002D3E =
    {
        0x00002D3E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3E,
        0x00002D3E,
        0x00002D3E
    };

    static _CharacterInfo _character00002D3F =
    {
        0x00002D3F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D3F,
        0x00002D3F,
        0x00002D3F
    };

    static _CharacterInfo _character00002D40 =
    {
        0x00002D40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D40,
        0x00002D40,
        0x00002D40
    };

    static _CharacterInfo _character00002D41 =
    {
        0x00002D41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D41,
        0x00002D41,
        0x00002D41
    };

    static _CharacterInfo _character00002D42 =
    {
        0x00002D42,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D42,
        0x00002D42,
        0x00002D42
    };

    static _CharacterInfo _character00002D43 =
    {
        0x00002D43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D43,
        0x00002D43,
        0x00002D43
    };

    static _CharacterInfo _character00002D44 =
    {
        0x00002D44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D44,
        0x00002D44,
        0x00002D44
    };

    static _CharacterInfo _character00002D45 =
    {
        0x00002D45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D45,
        0x00002D45,
        0x00002D45
    };

    static _CharacterInfo _character00002D46 =
    {
        0x00002D46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D46,
        0x00002D46,
        0x00002D46
    };

    static _CharacterInfo _character00002D47 =
    {
        0x00002D47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D47,
        0x00002D47,
        0x00002D47
    };

    static _CharacterInfo _character00002D48 =
    {
        0x00002D48,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D48,
        0x00002D48,
        0x00002D48
    };

    static _CharacterInfo _character00002D49 =
    {
        0x00002D49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D49,
        0x00002D49,
        0x00002D49
    };

    static _CharacterInfo _character00002D4A =
    {
        0x00002D4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4A,
        0x00002D4A,
        0x00002D4A
    };

    static _CharacterInfo _character00002D4B =
    {
        0x00002D4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4B,
        0x00002D4B,
        0x00002D4B
    };

    static _CharacterInfo _character00002D4C =
    {
        0x00002D4C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4C,
        0x00002D4C,
        0x00002D4C
    };

    static _CharacterInfo _character00002D4D =
    {
        0x00002D4D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4D,
        0x00002D4D,
        0x00002D4D
    };

    static _CharacterInfo _character00002D4E =
    {
        0x00002D4E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4E,
        0x00002D4E,
        0x00002D4E
    };

    static _CharacterInfo _character00002D4F =
    {
        0x00002D4F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D4F,
        0x00002D4F,
        0x00002D4F
    };

    static _CharacterInfo _character00002D50 =
    {
        0x00002D50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D50,
        0x00002D50,
        0x00002D50
    };

    static _CharacterInfo _character00002D51 =
    {
        0x00002D51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D51,
        0x00002D51,
        0x00002D51
    };

    static _CharacterInfo _character00002D52 =
    {
        0x00002D52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D52,
        0x00002D52,
        0x00002D52
    };

    static _CharacterInfo _character00002D53 =
    {
        0x00002D53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D53,
        0x00002D53,
        0x00002D53
    };

    static _CharacterInfo _character00002D54 =
    {
        0x00002D54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D54,
        0x00002D54,
        0x00002D54
    };

    static _CharacterInfo _character00002D55 =
    {
        0x00002D55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D55,
        0x00002D55,
        0x00002D55
    };

    static _CharacterInfo _character00002D56 =
    {
        0x00002D56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D56,
        0x00002D56,
        0x00002D56
    };

    static _CharacterInfo _character00002D57 =
    {
        0x00002D57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D57,
        0x00002D57,
        0x00002D57
    };

    static _CharacterInfo _character00002D58 =
    {
        0x00002D58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D58,
        0x00002D58,
        0x00002D58
    };

    static _CharacterInfo _character00002D59 =
    {
        0x00002D59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D59,
        0x00002D59,
        0x00002D59
    };

    static _CharacterInfo _character00002D5A =
    {
        0x00002D5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5A,
        0x00002D5A,
        0x00002D5A
    };

    static _CharacterInfo _character00002D5B =
    {
        0x00002D5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5B,
        0x00002D5B,
        0x00002D5B
    };

    static _CharacterInfo _character00002D5C =
    {
        0x00002D5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5C,
        0x00002D5C,
        0x00002D5C
    };

    static _CharacterInfo _character00002D5D =
    {
        0x00002D5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5D,
        0x00002D5D,
        0x00002D5D
    };

    static _CharacterInfo _character00002D5E =
    {
        0x00002D5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5E,
        0x00002D5E,
        0x00002D5E
    };

    static _CharacterInfo _character00002D5F =
    {
        0x00002D5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D5F,
        0x00002D5F,
        0x00002D5F
    };

    static _CharacterInfo _character00002D60 =
    {
        0x00002D60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D60,
        0x00002D60,
        0x00002D60
    };

    static _CharacterInfo _character00002D61 =
    {
        0x00002D61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D61,
        0x00002D61,
        0x00002D61
    };

    static _CharacterInfo _character00002D62 =
    {
        0x00002D62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D62,
        0x00002D62,
        0x00002D62
    };

    static _CharacterInfo _character00002D63 =
    {
        0x00002D63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D63,
        0x00002D63,
        0x00002D63
    };

    static _CharacterInfo _character00002D64 =
    {
        0x00002D64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D64,
        0x00002D64,
        0x00002D64
    };

    static _CharacterInfo _character00002D65 =
    {
        0x00002D65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D65,
        0x00002D65,
        0x00002D65
    };

    static Char _decompositionMapping00002D6F[] = 
    {
        0x00002D61
    };

    static _CharacterInfo _character00002D6F =
    {
        0x00002D6F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00002D6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D6F,
        0x00002D6F,
        0x00002D6F
    };

    static _CharacterInfo _character00002D80 =
    {
        0x00002D80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D80,
        0x00002D80,
        0x00002D80
    };

    static _CharacterInfo _character00002D81 =
    {
        0x00002D81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D81,
        0x00002D81,
        0x00002D81
    };

    static _CharacterInfo _character00002D82 =
    {
        0x00002D82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D82,
        0x00002D82,
        0x00002D82
    };

    static _CharacterInfo _character00002D83 =
    {
        0x00002D83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D83,
        0x00002D83,
        0x00002D83
    };

    static _CharacterInfo _character00002D84 =
    {
        0x00002D84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D84,
        0x00002D84,
        0x00002D84
    };

    static _CharacterInfo _character00002D85 =
    {
        0x00002D85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D85,
        0x00002D85,
        0x00002D85
    };

    static _CharacterInfo _character00002D86 =
    {
        0x00002D86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D86,
        0x00002D86,
        0x00002D86
    };

    static _CharacterInfo _character00002D87 =
    {
        0x00002D87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D87,
        0x00002D87,
        0x00002D87
    };

    static _CharacterInfo _character00002D88 =
    {
        0x00002D88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D88,
        0x00002D88,
        0x00002D88
    };

    static _CharacterInfo _character00002D89 =
    {
        0x00002D89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D89,
        0x00002D89,
        0x00002D89
    };

    static _CharacterInfo _character00002D8A =
    {
        0x00002D8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8A,
        0x00002D8A,
        0x00002D8A
    };

    static _CharacterInfo _character00002D8B =
    {
        0x00002D8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8B,
        0x00002D8B,
        0x00002D8B
    };

    static _CharacterInfo _character00002D8C =
    {
        0x00002D8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8C,
        0x00002D8C,
        0x00002D8C
    };

    static _CharacterInfo _character00002D8D =
    {
        0x00002D8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8D,
        0x00002D8D,
        0x00002D8D
    };

    static _CharacterInfo _character00002D8E =
    {
        0x00002D8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8E,
        0x00002D8E,
        0x00002D8E
    };

    static _CharacterInfo _character00002D8F =
    {
        0x00002D8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D8F,
        0x00002D8F,
        0x00002D8F
    };

    static _CharacterInfo _character00002D90 =
    {
        0x00002D90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D90,
        0x00002D90,
        0x00002D90
    };

    static _CharacterInfo _character00002D91 =
    {
        0x00002D91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D91,
        0x00002D91,
        0x00002D91
    };

    static _CharacterInfo _character00002D92 =
    {
        0x00002D92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D92,
        0x00002D92,
        0x00002D92
    };

    static _CharacterInfo _character00002D93 =
    {
        0x00002D93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D93,
        0x00002D93,
        0x00002D93
    };

    static _CharacterInfo _character00002D94 =
    {
        0x00002D94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D94,
        0x00002D94,
        0x00002D94
    };

    static _CharacterInfo _character00002D95 =
    {
        0x00002D95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D95,
        0x00002D95,
        0x00002D95
    };

    static _CharacterInfo _character00002D96 =
    {
        0x00002D96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002D96,
        0x00002D96,
        0x00002D96
    };

    static _CharacterInfo _character00002DA0 =
    {
        0x00002DA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA0,
        0x00002DA0,
        0x00002DA0
    };

    static _CharacterInfo _character00002DA1 =
    {
        0x00002DA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA1,
        0x00002DA1,
        0x00002DA1
    };

    static _CharacterInfo _character00002DA2 =
    {
        0x00002DA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA2,
        0x00002DA2,
        0x00002DA2
    };

    static _CharacterInfo _character00002DA3 =
    {
        0x00002DA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA3,
        0x00002DA3,
        0x00002DA3
    };

    static _CharacterInfo _character00002DA4 =
    {
        0x00002DA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA4,
        0x00002DA4,
        0x00002DA4
    };

    static _CharacterInfo _character00002DA5 =
    {
        0x00002DA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA5,
        0x00002DA5,
        0x00002DA5
    };

    static _CharacterInfo _character00002DA6 =
    {
        0x00002DA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA6,
        0x00002DA6,
        0x00002DA6
    };

    static _CharacterInfo _character00002DA8 =
    {
        0x00002DA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA8,
        0x00002DA8,
        0x00002DA8
    };

    static _CharacterInfo _character00002DA9 =
    {
        0x00002DA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DA9,
        0x00002DA9,
        0x00002DA9
    };

    static _CharacterInfo _character00002DAA =
    {
        0x00002DAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DAA,
        0x00002DAA,
        0x00002DAA
    };

    static _CharacterInfo _character00002DAB =
    {
        0x00002DAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DAB,
        0x00002DAB,
        0x00002DAB
    };

    static _CharacterInfo _character00002DAC =
    {
        0x00002DAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DAC,
        0x00002DAC,
        0x00002DAC
    };

    static _CharacterInfo _character00002DAD =
    {
        0x00002DAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DAD,
        0x00002DAD,
        0x00002DAD
    };

    static _CharacterInfo _character00002DAE =
    {
        0x00002DAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DAE,
        0x00002DAE,
        0x00002DAE
    };

    static _CharacterInfo _character00002DB0 =
    {
        0x00002DB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB0,
        0x00002DB0,
        0x00002DB0
    };

    static _CharacterInfo _character00002DB1 =
    {
        0x00002DB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB1,
        0x00002DB1,
        0x00002DB1
    };

    static _CharacterInfo _character00002DB2 =
    {
        0x00002DB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB2,
        0x00002DB2,
        0x00002DB2
    };

    static _CharacterInfo _character00002DB3 =
    {
        0x00002DB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB3,
        0x00002DB3,
        0x00002DB3
    };

    static _CharacterInfo _character00002DB4 =
    {
        0x00002DB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB4,
        0x00002DB4,
        0x00002DB4
    };

    static _CharacterInfo _character00002DB5 =
    {
        0x00002DB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB5,
        0x00002DB5,
        0x00002DB5
    };

    static _CharacterInfo _character00002DB6 =
    {
        0x00002DB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB6,
        0x00002DB6,
        0x00002DB6
    };

    static _CharacterInfo _character00002DB8 =
    {
        0x00002DB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB8,
        0x00002DB8,
        0x00002DB8
    };

    static _CharacterInfo _character00002DB9 =
    {
        0x00002DB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DB9,
        0x00002DB9,
        0x00002DB9
    };

    static _CharacterInfo _character00002DBA =
    {
        0x00002DBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DBA,
        0x00002DBA,
        0x00002DBA
    };

    static _CharacterInfo _character00002DBB =
    {
        0x00002DBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DBB,
        0x00002DBB,
        0x00002DBB
    };

    static _CharacterInfo _character00002DBC =
    {
        0x00002DBC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DBC,
        0x00002DBC,
        0x00002DBC
    };

    static _CharacterInfo _character00002DBD =
    {
        0x00002DBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DBD,
        0x00002DBD,
        0x00002DBD
    };

    static _CharacterInfo _character00002DBE =
    {
        0x00002DBE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DBE,
        0x00002DBE,
        0x00002DBE
    };

    static _CharacterInfo _character00002DC0 =
    {
        0x00002DC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC0,
        0x00002DC0,
        0x00002DC0
    };

    static _CharacterInfo _character00002DC1 =
    {
        0x00002DC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC1,
        0x00002DC1,
        0x00002DC1
    };

    static _CharacterInfo _character00002DC2 =
    {
        0x00002DC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC2,
        0x00002DC2,
        0x00002DC2
    };

    static _CharacterInfo _character00002DC3 =
    {
        0x00002DC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC3,
        0x00002DC3,
        0x00002DC3
    };

    static _CharacterInfo _character00002DC4 =
    {
        0x00002DC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC4,
        0x00002DC4,
        0x00002DC4
    };

    static _CharacterInfo _character00002DC5 =
    {
        0x00002DC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC5,
        0x00002DC5,
        0x00002DC5
    };

    static _CharacterInfo _character00002DC6 =
    {
        0x00002DC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC6,
        0x00002DC6,
        0x00002DC6
    };

    static _CharacterInfo _character00002DC8 =
    {
        0x00002DC8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC8,
        0x00002DC8,
        0x00002DC8
    };

    static _CharacterInfo _character00002DC9 =
    {
        0x00002DC9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DC9,
        0x00002DC9,
        0x00002DC9
    };

    static _CharacterInfo _character00002DCA =
    {
        0x00002DCA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DCA,
        0x00002DCA,
        0x00002DCA
    };

    static _CharacterInfo _character00002DCB =
    {
        0x00002DCB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DCB,
        0x00002DCB,
        0x00002DCB
    };

    static _CharacterInfo _character00002DCC =
    {
        0x00002DCC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DCC,
        0x00002DCC,
        0x00002DCC
    };

    static _CharacterInfo _character00002DCD =
    {
        0x00002DCD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DCD,
        0x00002DCD,
        0x00002DCD
    };

    static _CharacterInfo _character00002DCE =
    {
        0x00002DCE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DCE,
        0x00002DCE,
        0x00002DCE
    };

    static _CharacterInfo _character00002DD0 =
    {
        0x00002DD0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD0,
        0x00002DD0,
        0x00002DD0
    };

    static _CharacterInfo _character00002DD1 =
    {
        0x00002DD1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD1,
        0x00002DD1,
        0x00002DD1
    };

    static _CharacterInfo _character00002DD2 =
    {
        0x00002DD2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD2,
        0x00002DD2,
        0x00002DD2
    };

    static _CharacterInfo _character00002DD3 =
    {
        0x00002DD3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD3,
        0x00002DD3,
        0x00002DD3
    };

    static _CharacterInfo _character00002DD4 =
    {
        0x00002DD4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD4,
        0x00002DD4,
        0x00002DD4
    };

    static _CharacterInfo _character00002DD5 =
    {
        0x00002DD5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD5,
        0x00002DD5,
        0x00002DD5
    };

    static _CharacterInfo _character00002DD6 =
    {
        0x00002DD6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD6,
        0x00002DD6,
        0x00002DD6
    };

    static _CharacterInfo _character00002DD8 =
    {
        0x00002DD8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD8,
        0x00002DD8,
        0x00002DD8
    };

    static _CharacterInfo _character00002DD9 =
    {
        0x00002DD9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DD9,
        0x00002DD9,
        0x00002DD9
    };

    static _CharacterInfo _character00002DDA =
    {
        0x00002DDA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DDA,
        0x00002DDA,
        0x00002DDA
    };

    static _CharacterInfo _character00002DDB =
    {
        0x00002DDB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DDB,
        0x00002DDB,
        0x00002DDB
    };

    static _CharacterInfo _character00002DDC =
    {
        0x00002DDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DDC,
        0x00002DDC,
        0x00002DDC
    };

    static _CharacterInfo _character00002DDD =
    {
        0x00002DDD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DDD,
        0x00002DDD,
        0x00002DDD
    };

    static _CharacterInfo _character00002DDE =
    {
        0x00002DDE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002DDE,
        0x00002DDE,
        0x00002DDE
    };

    static _CharacterInfo _character00002E00 =
    {
        0x00002E00,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E00,
        0x00002E00,
        0x00002E00
    };

    static _CharacterInfo _character00002E01 =
    {
        0x00002E01,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E01,
        0x00002E01,
        0x00002E01
    };

    static _CharacterInfo _character00002E02 =
    {
        0x00002E02,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E02,
        0x00002E02,
        0x00002E02
    };

    static _CharacterInfo _character00002E03 =
    {
        0x00002E03,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E03,
        0x00002E03,
        0x00002E03
    };

    static _CharacterInfo _character00002E04 =
    {
        0x00002E04,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E04,
        0x00002E04,
        0x00002E04
    };

    static _CharacterInfo _character00002E05 =
    {
        0x00002E05,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E05,
        0x00002E05,
        0x00002E05
    };

    static _CharacterInfo _character00002E06 =
    {
        0x00002E06,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E06,
        0x00002E06,
        0x00002E06
    };

    static _CharacterInfo _character00002E07 =
    {
        0x00002E07,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E07,
        0x00002E07,
        0x00002E07
    };

    static _CharacterInfo _character00002E08 =
    {
        0x00002E08,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E08,
        0x00002E08,
        0x00002E08
    };

    static _CharacterInfo _character00002E09 =
    {
        0x00002E09,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E09,
        0x00002E09,
        0x00002E09
    };

    static _CharacterInfo _character00002E0A =
    {
        0x00002E0A,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E0A,
        0x00002E0A,
        0x00002E0A
    };

    static _CharacterInfo _character00002E0B =
    {
        0x00002E0B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E0B,
        0x00002E0B,
        0x00002E0B
    };

    static _CharacterInfo _character00002E0C =
    {
        0x00002E0C,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E0C,
        0x00002E0C,
        0x00002E0C
    };

    static _CharacterInfo _character00002E0D =
    {
        0x00002E0D,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E0D,
        0x00002E0D,
        0x00002E0D
    };

    static _CharacterInfo _character00002E0E =
    {
        0x00002E0E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E0E,
        0x00002E0E,
        0x00002E0E
    };

    static _CharacterInfo _character00002E0F =
    {
        0x00002E0F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E0F,
        0x00002E0F,
        0x00002E0F
    };

    static _CharacterInfo _character00002E10 =
    {
        0x00002E10,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E10,
        0x00002E10,
        0x00002E10
    };

    static _CharacterInfo _character00002E11 =
    {
        0x00002E11,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E11,
        0x00002E11,
        0x00002E11
    };

    static _CharacterInfo _character00002E12 =
    {
        0x00002E12,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E12,
        0x00002E12,
        0x00002E12
    };

    static _CharacterInfo _character00002E13 =
    {
        0x00002E13,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E13,
        0x00002E13,
        0x00002E13
    };

    static _CharacterInfo _character00002E14 =
    {
        0x00002E14,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E14,
        0x00002E14,
        0x00002E14
    };

    static _CharacterInfo _character00002E15 =
    {
        0x00002E15,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E15,
        0x00002E15,
        0x00002E15
    };

    static _CharacterInfo _character00002E16 =
    {
        0x00002E16,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E16,
        0x00002E16,
        0x00002E16
    };

    static _CharacterInfo _character00002E17 =
    {
        0x00002E17,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E17,
        0x00002E17,
        0x00002E17
    };

    static _CharacterInfo _character00002E1C =
    {
        0x00002E1C,
        Iso10646::GeneralCategory_Pi,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E1C,
        0x00002E1C,
        0x00002E1C
    };

    static _CharacterInfo _character00002E1D =
    {
        0x00002E1D,
        Iso10646::GeneralCategory_Pf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00002E1D,
        0x00002E1D,
        0x00002E1D
    };

    static _CharacterInfo _character00002E80 =
    {
        0x00002E80,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E80,
        0x00002E80,
        0x00002E80
    };

    static _CharacterInfo _character00002E81 =
    {
        0x00002E81,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E81,
        0x00002E81,
        0x00002E81
    };

    static _CharacterInfo _character00002E82 =
    {
        0x00002E82,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E82,
        0x00002E82,
        0x00002E82
    };

    static _CharacterInfo _character00002E83 =
    {
        0x00002E83,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E83,
        0x00002E83,
        0x00002E83
    };

    static _CharacterInfo _character00002E84 =
    {
        0x00002E84,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E84,
        0x00002E84,
        0x00002E84
    };

    static _CharacterInfo _character00002E85 =
    {
        0x00002E85,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E85,
        0x00002E85,
        0x00002E85
    };

    static _CharacterInfo _character00002E86 =
    {
        0x00002E86,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E86,
        0x00002E86,
        0x00002E86
    };

    static _CharacterInfo _character00002E87 =
    {
        0x00002E87,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E87,
        0x00002E87,
        0x00002E87
    };

    static _CharacterInfo _character00002E88 =
    {
        0x00002E88,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E88,
        0x00002E88,
        0x00002E88
    };

    static _CharacterInfo _character00002E89 =
    {
        0x00002E89,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E89,
        0x00002E89,
        0x00002E89
    };

    static _CharacterInfo _character00002E8A =
    {
        0x00002E8A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8A,
        0x00002E8A,
        0x00002E8A
    };

    static _CharacterInfo _character00002E8B =
    {
        0x00002E8B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8B,
        0x00002E8B,
        0x00002E8B
    };

    static _CharacterInfo _character00002E8C =
    {
        0x00002E8C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8C,
        0x00002E8C,
        0x00002E8C
    };

    static _CharacterInfo _character00002E8D =
    {
        0x00002E8D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8D,
        0x00002E8D,
        0x00002E8D
    };

    static _CharacterInfo _character00002E8E =
    {
        0x00002E8E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8E,
        0x00002E8E,
        0x00002E8E
    };

    static _CharacterInfo _character00002E8F =
    {
        0x00002E8F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E8F,
        0x00002E8F,
        0x00002E8F
    };

    static _CharacterInfo _character00002E90 =
    {
        0x00002E90,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E90,
        0x00002E90,
        0x00002E90
    };

    static _CharacterInfo _character00002E91 =
    {
        0x00002E91,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E91,
        0x00002E91,
        0x00002E91
    };

    static _CharacterInfo _character00002E92 =
    {
        0x00002E92,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E92,
        0x00002E92,
        0x00002E92
    };

    static _CharacterInfo _character00002E93 =
    {
        0x00002E93,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E93,
        0x00002E93,
        0x00002E93
    };

    static _CharacterInfo _character00002E94 =
    {
        0x00002E94,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E94,
        0x00002E94,
        0x00002E94
    };

    static _CharacterInfo _character00002E95 =
    {
        0x00002E95,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E95,
        0x00002E95,
        0x00002E95
    };

    static _CharacterInfo _character00002E96 =
    {
        0x00002E96,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E96,
        0x00002E96,
        0x00002E96
    };

    static _CharacterInfo _character00002E97 =
    {
        0x00002E97,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E97,
        0x00002E97,
        0x00002E97
    };

    static _CharacterInfo _character00002E98 =
    {
        0x00002E98,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E98,
        0x00002E98,
        0x00002E98
    };

    static _CharacterInfo _character00002E99 =
    {
        0x00002E99,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E99,
        0x00002E99,
        0x00002E99
    };

    static _CharacterInfo _character00002E9B =
    {
        0x00002E9B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E9B,
        0x00002E9B,
        0x00002E9B
    };

    static _CharacterInfo _character00002E9C =
    {
        0x00002E9C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E9C,
        0x00002E9C,
        0x00002E9C
    };

    static _CharacterInfo _character00002E9D =
    {
        0x00002E9D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E9D,
        0x00002E9D,
        0x00002E9D
    };

    static _CharacterInfo _character00002E9E =
    {
        0x00002E9E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E9E,
        0x00002E9E,
        0x00002E9E
    };

    static Char _decompositionMapping00002E9F[] = 
    {
        0x00006BCD
    };

    static _CharacterInfo _character00002E9F =
    {
        0x00002E9F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002E9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002E9F,
        0x00002E9F,
        0x00002E9F
    };

    static _CharacterInfo _character00002EA0 =
    {
        0x00002EA0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA0,
        0x00002EA0,
        0x00002EA0
    };

    static _CharacterInfo _character00002EA1 =
    {
        0x00002EA1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA1,
        0x00002EA1,
        0x00002EA1
    };

    static _CharacterInfo _character00002EA2 =
    {
        0x00002EA2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA2,
        0x00002EA2,
        0x00002EA2
    };

    static _CharacterInfo _character00002EA3 =
    {
        0x00002EA3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA3,
        0x00002EA3,
        0x00002EA3
    };

    static _CharacterInfo _character00002EA4 =
    {
        0x00002EA4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA4,
        0x00002EA4,
        0x00002EA4
    };

    static _CharacterInfo _character00002EA5 =
    {
        0x00002EA5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA5,
        0x00002EA5,
        0x00002EA5
    };

    static _CharacterInfo _character00002EA6 =
    {
        0x00002EA6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA6,
        0x00002EA6,
        0x00002EA6
    };

    static _CharacterInfo _character00002EA7 =
    {
        0x00002EA7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA7,
        0x00002EA7,
        0x00002EA7
    };

    static _CharacterInfo _character00002EA8 =
    {
        0x00002EA8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA8,
        0x00002EA8,
        0x00002EA8
    };

    static _CharacterInfo _character00002EA9 =
    {
        0x00002EA9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EA9,
        0x00002EA9,
        0x00002EA9
    };

    static _CharacterInfo _character00002EAA =
    {
        0x00002EAA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAA,
        0x00002EAA,
        0x00002EAA
    };

    static _CharacterInfo _character00002EAB =
    {
        0x00002EAB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAB,
        0x00002EAB,
        0x00002EAB
    };

    static _CharacterInfo _character00002EAC =
    {
        0x00002EAC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAC,
        0x00002EAC,
        0x00002EAC
    };

    static _CharacterInfo _character00002EAD =
    {
        0x00002EAD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAD,
        0x00002EAD,
        0x00002EAD
    };

    static _CharacterInfo _character00002EAE =
    {
        0x00002EAE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAE,
        0x00002EAE,
        0x00002EAE
    };

    static _CharacterInfo _character00002EAF =
    {
        0x00002EAF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EAF,
        0x00002EAF,
        0x00002EAF
    };

    static _CharacterInfo _character00002EB0 =
    {
        0x00002EB0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB0,
        0x00002EB0,
        0x00002EB0
    };

    static _CharacterInfo _character00002EB1 =
    {
        0x00002EB1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB1,
        0x00002EB1,
        0x00002EB1
    };

    static _CharacterInfo _character00002EB2 =
    {
        0x00002EB2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB2,
        0x00002EB2,
        0x00002EB2
    };

    static _CharacterInfo _character00002EB3 =
    {
        0x00002EB3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB3,
        0x00002EB3,
        0x00002EB3
    };

    static _CharacterInfo _character00002EB4 =
    {
        0x00002EB4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB4,
        0x00002EB4,
        0x00002EB4
    };

    static _CharacterInfo _character00002EB5 =
    {
        0x00002EB5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB5,
        0x00002EB5,
        0x00002EB5
    };

    static _CharacterInfo _character00002EB6 =
    {
        0x00002EB6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB6,
        0x00002EB6,
        0x00002EB6
    };

    static _CharacterInfo _character00002EB7 =
    {
        0x00002EB7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB7,
        0x00002EB7,
        0x00002EB7
    };

    static _CharacterInfo _character00002EB8 =
    {
        0x00002EB8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB8,
        0x00002EB8,
        0x00002EB8
    };

    static _CharacterInfo _character00002EB9 =
    {
        0x00002EB9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EB9,
        0x00002EB9,
        0x00002EB9
    };

    static _CharacterInfo _character00002EBA =
    {
        0x00002EBA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBA,
        0x00002EBA,
        0x00002EBA
    };

    static _CharacterInfo _character00002EBB =
    {
        0x00002EBB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBB,
        0x00002EBB,
        0x00002EBB
    };

    static _CharacterInfo _character00002EBC =
    {
        0x00002EBC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBC,
        0x00002EBC,
        0x00002EBC
    };

    static _CharacterInfo _character00002EBD =
    {
        0x00002EBD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBD,
        0x00002EBD,
        0x00002EBD
    };

    static _CharacterInfo _character00002EBE =
    {
        0x00002EBE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBE,
        0x00002EBE,
        0x00002EBE
    };

    static _CharacterInfo _character00002EBF =
    {
        0x00002EBF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EBF,
        0x00002EBF,
        0x00002EBF
    };

    static _CharacterInfo _character00002EC0 =
    {
        0x00002EC0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC0,
        0x00002EC0,
        0x00002EC0
    };

    static _CharacterInfo _character00002EC1 =
    {
        0x00002EC1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC1,
        0x00002EC1,
        0x00002EC1
    };

    static _CharacterInfo _character00002EC2 =
    {
        0x00002EC2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC2,
        0x00002EC2,
        0x00002EC2
    };

    static _CharacterInfo _character00002EC3 =
    {
        0x00002EC3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC3,
        0x00002EC3,
        0x00002EC3
    };

    static _CharacterInfo _character00002EC4 =
    {
        0x00002EC4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC4,
        0x00002EC4,
        0x00002EC4
    };

    static _CharacterInfo _character00002EC5 =
    {
        0x00002EC5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC5,
        0x00002EC5,
        0x00002EC5
    };

    static _CharacterInfo _character00002EC6 =
    {
        0x00002EC6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC6,
        0x00002EC6,
        0x00002EC6
    };

    static _CharacterInfo _character00002EC7 =
    {
        0x00002EC7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC7,
        0x00002EC7,
        0x00002EC7
    };

    static _CharacterInfo _character00002EC8 =
    {
        0x00002EC8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC8,
        0x00002EC8,
        0x00002EC8
    };

    static _CharacterInfo _character00002EC9 =
    {
        0x00002EC9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EC9,
        0x00002EC9,
        0x00002EC9
    };

    static _CharacterInfo _character00002ECA =
    {
        0x00002ECA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECA,
        0x00002ECA,
        0x00002ECA
    };

    static _CharacterInfo _character00002ECB =
    {
        0x00002ECB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECB,
        0x00002ECB,
        0x00002ECB
    };

    static _CharacterInfo _character00002ECC =
    {
        0x00002ECC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECC,
        0x00002ECC,
        0x00002ECC
    };

    static _CharacterInfo _character00002ECD =
    {
        0x00002ECD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECD,
        0x00002ECD,
        0x00002ECD
    };

    static _CharacterInfo _character00002ECE =
    {
        0x00002ECE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECE,
        0x00002ECE,
        0x00002ECE
    };

    static _CharacterInfo _character00002ECF =
    {
        0x00002ECF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ECF,
        0x00002ECF,
        0x00002ECF
    };

    static _CharacterInfo _character00002ED0 =
    {
        0x00002ED0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED0,
        0x00002ED0,
        0x00002ED0
    };

    static _CharacterInfo _character00002ED1 =
    {
        0x00002ED1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED1,
        0x00002ED1,
        0x00002ED1
    };

    static _CharacterInfo _character00002ED2 =
    {
        0x00002ED2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED2,
        0x00002ED2,
        0x00002ED2
    };

    static _CharacterInfo _character00002ED3 =
    {
        0x00002ED3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED3,
        0x00002ED3,
        0x00002ED3
    };

    static _CharacterInfo _character00002ED4 =
    {
        0x00002ED4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED4,
        0x00002ED4,
        0x00002ED4
    };

    static _CharacterInfo _character00002ED5 =
    {
        0x00002ED5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED5,
        0x00002ED5,
        0x00002ED5
    };

    static _CharacterInfo _character00002ED6 =
    {
        0x00002ED6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED6,
        0x00002ED6,
        0x00002ED6
    };

    static _CharacterInfo _character00002ED7 =
    {
        0x00002ED7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED7,
        0x00002ED7,
        0x00002ED7
    };

    static _CharacterInfo _character00002ED8 =
    {
        0x00002ED8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED8,
        0x00002ED8,
        0x00002ED8
    };

    static _CharacterInfo _character00002ED9 =
    {
        0x00002ED9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002ED9,
        0x00002ED9,
        0x00002ED9
    };

    static _CharacterInfo _character00002EDA =
    {
        0x00002EDA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDA,
        0x00002EDA,
        0x00002EDA
    };

    static _CharacterInfo _character00002EDB =
    {
        0x00002EDB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDB,
        0x00002EDB,
        0x00002EDB
    };

    static _CharacterInfo _character00002EDC =
    {
        0x00002EDC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDC,
        0x00002EDC,
        0x00002EDC
    };

    static _CharacterInfo _character00002EDD =
    {
        0x00002EDD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDD,
        0x00002EDD,
        0x00002EDD
    };

    static _CharacterInfo _character00002EDE =
    {
        0x00002EDE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDE,
        0x00002EDE,
        0x00002EDE
    };

    static _CharacterInfo _character00002EDF =
    {
        0x00002EDF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EDF,
        0x00002EDF,
        0x00002EDF
    };

    static _CharacterInfo _character00002EE0 =
    {
        0x00002EE0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE0,
        0x00002EE0,
        0x00002EE0
    };

    static _CharacterInfo _character00002EE1 =
    {
        0x00002EE1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE1,
        0x00002EE1,
        0x00002EE1
    };

    static _CharacterInfo _character00002EE2 =
    {
        0x00002EE2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE2,
        0x00002EE2,
        0x00002EE2
    };

    static _CharacterInfo _character00002EE3 =
    {
        0x00002EE3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE3,
        0x00002EE3,
        0x00002EE3
    };

    static _CharacterInfo _character00002EE4 =
    {
        0x00002EE4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE4,
        0x00002EE4,
        0x00002EE4
    };

    static _CharacterInfo _character00002EE5 =
    {
        0x00002EE5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE5,
        0x00002EE5,
        0x00002EE5
    };

    static _CharacterInfo _character00002EE6 =
    {
        0x00002EE6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE6,
        0x00002EE6,
        0x00002EE6
    };

    static _CharacterInfo _character00002EE7 =
    {
        0x00002EE7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE7,
        0x00002EE7,
        0x00002EE7
    };

    static _CharacterInfo _character00002EE8 =
    {
        0x00002EE8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE8,
        0x00002EE8,
        0x00002EE8
    };

    static _CharacterInfo _character00002EE9 =
    {
        0x00002EE9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EE9,
        0x00002EE9,
        0x00002EE9
    };

    static _CharacterInfo _character00002EEA =
    {
        0x00002EEA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EEA,
        0x00002EEA,
        0x00002EEA
    };

    static _CharacterInfo _character00002EEB =
    {
        0x00002EEB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EEB,
        0x00002EEB,
        0x00002EEB
    };

    static _CharacterInfo _character00002EEC =
    {
        0x00002EEC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EEC,
        0x00002EEC,
        0x00002EEC
    };

    static _CharacterInfo _character00002EED =
    {
        0x00002EED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EED,
        0x00002EED,
        0x00002EED
    };

    static _CharacterInfo _character00002EEE =
    {
        0x00002EEE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EEE,
        0x00002EEE,
        0x00002EEE
    };

    static _CharacterInfo _character00002EEF =
    {
        0x00002EEF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EEF,
        0x00002EEF,
        0x00002EEF
    };

    static _CharacterInfo _character00002EF0 =
    {
        0x00002EF0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EF0,
        0x00002EF0,
        0x00002EF0
    };

    static _CharacterInfo _character00002EF1 =
    {
        0x00002EF1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EF1,
        0x00002EF1,
        0x00002EF1
    };

    static _CharacterInfo _character00002EF2 =
    {
        0x00002EF2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EF2,
        0x00002EF2,
        0x00002EF2
    };

    static Char _decompositionMapping00002EF3[] = 
    {
        0x00009F9F
    };

    static _CharacterInfo _character00002EF3 =
    {
        0x00002EF3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002EF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002EF3,
        0x00002EF3,
        0x00002EF3
    };

    static Char _decompositionMapping00002F00[] = 
    {
        0x00004E00
    };

    static _CharacterInfo _character00002F00 =
    {
        0x00002F00,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F00,
        0x00002F00,
        0x00002F00
    };

    static Char _decompositionMapping00002F01[] = 
    {
        0x00004E28
    };

    static _CharacterInfo _character00002F01 =
    {
        0x00002F01,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F01,
        0x00002F01,
        0x00002F01
    };

    static Char _decompositionMapping00002F02[] = 
    {
        0x00004E36
    };

    static _CharacterInfo _character00002F02 =
    {
        0x00002F02,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F02,
        0x00002F02,
        0x00002F02
    };

    static Char _decompositionMapping00002F03[] = 
    {
        0x00004E3F
    };

    static _CharacterInfo _character00002F03 =
    {
        0x00002F03,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F03,
        0x00002F03,
        0x00002F03
    };

    static Char _decompositionMapping00002F04[] = 
    {
        0x00004E59
    };

    static _CharacterInfo _character00002F04 =
    {
        0x00002F04,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F04,
        0x00002F04,
        0x00002F04
    };

    static Char _decompositionMapping00002F05[] = 
    {
        0x00004E85
    };

    static _CharacterInfo _character00002F05 =
    {
        0x00002F05,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F05,
        0x00002F05,
        0x00002F05
    };

    static Char _decompositionMapping00002F06[] = 
    {
        0x00004E8C
    };

    static _CharacterInfo _character00002F06 =
    {
        0x00002F06,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F06,
        0x00002F06,
        0x00002F06
    };

    static Char _decompositionMapping00002F07[] = 
    {
        0x00004EA0
    };

    static _CharacterInfo _character00002F07 =
    {
        0x00002F07,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F07,
        0x00002F07,
        0x00002F07
    };

    static Char _decompositionMapping00002F08[] = 
    {
        0x00004EBA
    };

    static _CharacterInfo _character00002F08 =
    {
        0x00002F08,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F08,
        0x00002F08,
        0x00002F08
    };

    static Char _decompositionMapping00002F09[] = 
    {
        0x0000513F
    };

    static _CharacterInfo _character00002F09 =
    {
        0x00002F09,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F09,
        0x00002F09,
        0x00002F09
    };

    static Char _decompositionMapping00002F0A[] = 
    {
        0x00005165
    };

    static _CharacterInfo _character00002F0A =
    {
        0x00002F0A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0A,
        0x00002F0A,
        0x00002F0A
    };

    static Char _decompositionMapping00002F0B[] = 
    {
        0x0000516B
    };

    static _CharacterInfo _character00002F0B =
    {
        0x00002F0B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0B,
        0x00002F0B,
        0x00002F0B
    };

    static Char _decompositionMapping00002F0C[] = 
    {
        0x00005182
    };

    static _CharacterInfo _character00002F0C =
    {
        0x00002F0C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0C,
        0x00002F0C,
        0x00002F0C
    };

    static Char _decompositionMapping00002F0D[] = 
    {
        0x00005196
    };

    static _CharacterInfo _character00002F0D =
    {
        0x00002F0D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0D,
        0x00002F0D,
        0x00002F0D
    };

    static Char _decompositionMapping00002F0E[] = 
    {
        0x000051AB
    };

    static _CharacterInfo _character00002F0E =
    {
        0x00002F0E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0E,
        0x00002F0E,
        0x00002F0E
    };

    static Char _decompositionMapping00002F0F[] = 
    {
        0x000051E0
    };

    static _CharacterInfo _character00002F0F =
    {
        0x00002F0F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F0F,
        0x00002F0F,
        0x00002F0F
    };

    static Char _decompositionMapping00002F10[] = 
    {
        0x000051F5
    };

    static _CharacterInfo _character00002F10 =
    {
        0x00002F10,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F10,
        0x00002F10,
        0x00002F10
    };

    static Char _decompositionMapping00002F11[] = 
    {
        0x00005200
    };

    static _CharacterInfo _character00002F11 =
    {
        0x00002F11,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F11,
        0x00002F11,
        0x00002F11
    };

    static Char _decompositionMapping00002F12[] = 
    {
        0x0000529B
    };

    static _CharacterInfo _character00002F12 =
    {
        0x00002F12,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F12,
        0x00002F12,
        0x00002F12
    };

    static Char _decompositionMapping00002F13[] = 
    {
        0x000052F9
    };

    static _CharacterInfo _character00002F13 =
    {
        0x00002F13,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F13,
        0x00002F13,
        0x00002F13
    };

    static Char _decompositionMapping00002F14[] = 
    {
        0x00005315
    };

    static _CharacterInfo _character00002F14 =
    {
        0x00002F14,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F14,
        0x00002F14,
        0x00002F14
    };

    static Char _decompositionMapping00002F15[] = 
    {
        0x0000531A
    };

    static _CharacterInfo _character00002F15 =
    {
        0x00002F15,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F15,
        0x00002F15,
        0x00002F15
    };

    static Char _decompositionMapping00002F16[] = 
    {
        0x00005338
    };

    static _CharacterInfo _character00002F16 =
    {
        0x00002F16,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F16,
        0x00002F16,
        0x00002F16
    };

    static Char _decompositionMapping00002F17[] = 
    {
        0x00005341
    };

    static _CharacterInfo _character00002F17 =
    {
        0x00002F17,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F17,
        0x00002F17,
        0x00002F17
    };

    static Char _decompositionMapping00002F18[] = 
    {
        0x0000535C
    };

    static _CharacterInfo _character00002F18 =
    {
        0x00002F18,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F18,
        0x00002F18,
        0x00002F18
    };

    static Char _decompositionMapping00002F19[] = 
    {
        0x00005369
    };

    static _CharacterInfo _character00002F19 =
    {
        0x00002F19,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F19,
        0x00002F19,
        0x00002F19
    };

    static Char _decompositionMapping00002F1A[] = 
    {
        0x00005382
    };

    static _CharacterInfo _character00002F1A =
    {
        0x00002F1A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1A,
        0x00002F1A,
        0x00002F1A
    };

    static Char _decompositionMapping00002F1B[] = 
    {
        0x000053B6
    };

    static _CharacterInfo _character00002F1B =
    {
        0x00002F1B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1B,
        0x00002F1B,
        0x00002F1B
    };

    static Char _decompositionMapping00002F1C[] = 
    {
        0x000053C8
    };

    static _CharacterInfo _character00002F1C =
    {
        0x00002F1C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1C,
        0x00002F1C,
        0x00002F1C
    };

    static Char _decompositionMapping00002F1D[] = 
    {
        0x000053E3
    };

    static _CharacterInfo _character00002F1D =
    {
        0x00002F1D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1D,
        0x00002F1D,
        0x00002F1D
    };

    static Char _decompositionMapping00002F1E[] = 
    {
        0x000056D7
    };

    static _CharacterInfo _character00002F1E =
    {
        0x00002F1E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1E,
        0x00002F1E,
        0x00002F1E
    };

    static Char _decompositionMapping00002F1F[] = 
    {
        0x0000571F
    };

    static _CharacterInfo _character00002F1F =
    {
        0x00002F1F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F1F,
        0x00002F1F,
        0x00002F1F
    };

    static Char _decompositionMapping00002F20[] = 
    {
        0x000058EB
    };

    static _CharacterInfo _character00002F20 =
    {
        0x00002F20,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F20,
        0x00002F20,
        0x00002F20
    };

    static Char _decompositionMapping00002F21[] = 
    {
        0x00005902
    };

    static _CharacterInfo _character00002F21 =
    {
        0x00002F21,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F21,
        0x00002F21,
        0x00002F21
    };

    static Char _decompositionMapping00002F22[] = 
    {
        0x0000590A
    };

    static _CharacterInfo _character00002F22 =
    {
        0x00002F22,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F22,
        0x00002F22,
        0x00002F22
    };

    static Char _decompositionMapping00002F23[] = 
    {
        0x00005915
    };

    static _CharacterInfo _character00002F23 =
    {
        0x00002F23,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F23,
        0x00002F23,
        0x00002F23
    };

    static Char _decompositionMapping00002F24[] = 
    {
        0x00005927
    };

    static _CharacterInfo _character00002F24 =
    {
        0x00002F24,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F24,
        0x00002F24,
        0x00002F24
    };

    static Char _decompositionMapping00002F25[] = 
    {
        0x00005973
    };

    static _CharacterInfo _character00002F25 =
    {
        0x00002F25,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F25,
        0x00002F25,
        0x00002F25
    };

    static Char _decompositionMapping00002F26[] = 
    {
        0x00005B50
    };

    static _CharacterInfo _character00002F26 =
    {
        0x00002F26,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F26,
        0x00002F26,
        0x00002F26
    };

    static Char _decompositionMapping00002F27[] = 
    {
        0x00005B80
    };

    static _CharacterInfo _character00002F27 =
    {
        0x00002F27,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F27,
        0x00002F27,
        0x00002F27
    };

    static Char _decompositionMapping00002F28[] = 
    {
        0x00005BF8
    };

    static _CharacterInfo _character00002F28 =
    {
        0x00002F28,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F28,
        0x00002F28,
        0x00002F28
    };

    static Char _decompositionMapping00002F29[] = 
    {
        0x00005C0F
    };

    static _CharacterInfo _character00002F29 =
    {
        0x00002F29,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F29,
        0x00002F29,
        0x00002F29
    };

    static Char _decompositionMapping00002F2A[] = 
    {
        0x00005C22
    };

    static _CharacterInfo _character00002F2A =
    {
        0x00002F2A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2A,
        0x00002F2A,
        0x00002F2A
    };

    static Char _decompositionMapping00002F2B[] = 
    {
        0x00005C38
    };

    static _CharacterInfo _character00002F2B =
    {
        0x00002F2B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2B,
        0x00002F2B,
        0x00002F2B
    };

    static Char _decompositionMapping00002F2C[] = 
    {
        0x00005C6E
    };

    static _CharacterInfo _character00002F2C =
    {
        0x00002F2C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2C,
        0x00002F2C,
        0x00002F2C
    };

    static Char _decompositionMapping00002F2D[] = 
    {
        0x00005C71
    };

    static _CharacterInfo _character00002F2D =
    {
        0x00002F2D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2D,
        0x00002F2D,
        0x00002F2D
    };

    static Char _decompositionMapping00002F2E[] = 
    {
        0x00005DDB
    };

    static _CharacterInfo _character00002F2E =
    {
        0x00002F2E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2E,
        0x00002F2E,
        0x00002F2E
    };

    static Char _decompositionMapping00002F2F[] = 
    {
        0x00005DE5
    };

    static _CharacterInfo _character00002F2F =
    {
        0x00002F2F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F2F,
        0x00002F2F,
        0x00002F2F
    };

    static Char _decompositionMapping00002F30[] = 
    {
        0x00005DF1
    };

    static _CharacterInfo _character00002F30 =
    {
        0x00002F30,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F30,
        0x00002F30,
        0x00002F30
    };

    static Char _decompositionMapping00002F31[] = 
    {
        0x00005DFE
    };

    static _CharacterInfo _character00002F31 =
    {
        0x00002F31,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F31,
        0x00002F31,
        0x00002F31
    };

    static Char _decompositionMapping00002F32[] = 
    {
        0x00005E72
    };

    static _CharacterInfo _character00002F32 =
    {
        0x00002F32,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F32,
        0x00002F32,
        0x00002F32
    };

    static Char _decompositionMapping00002F33[] = 
    {
        0x00005E7A
    };

    static _CharacterInfo _character00002F33 =
    {
        0x00002F33,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F33,
        0x00002F33,
        0x00002F33
    };

    static Char _decompositionMapping00002F34[] = 
    {
        0x00005E7F
    };

    static _CharacterInfo _character00002F34 =
    {
        0x00002F34,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F34,
        0x00002F34,
        0x00002F34
    };

    static Char _decompositionMapping00002F35[] = 
    {
        0x00005EF4
    };

    static _CharacterInfo _character00002F35 =
    {
        0x00002F35,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F35,
        0x00002F35,
        0x00002F35
    };

    static Char _decompositionMapping00002F36[] = 
    {
        0x00005EFE
    };

    static _CharacterInfo _character00002F36 =
    {
        0x00002F36,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F36,
        0x00002F36,
        0x00002F36
    };

    static Char _decompositionMapping00002F37[] = 
    {
        0x00005F0B
    };

    static _CharacterInfo _character00002F37 =
    {
        0x00002F37,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F37,
        0x00002F37,
        0x00002F37
    };

    static Char _decompositionMapping00002F38[] = 
    {
        0x00005F13
    };

    static _CharacterInfo _character00002F38 =
    {
        0x00002F38,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F38,
        0x00002F38,
        0x00002F38
    };

    static Char _decompositionMapping00002F39[] = 
    {
        0x00005F50
    };

    static _CharacterInfo _character00002F39 =
    {
        0x00002F39,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F39,
        0x00002F39,
        0x00002F39
    };

    static Char _decompositionMapping00002F3A[] = 
    {
        0x00005F61
    };

    static _CharacterInfo _character00002F3A =
    {
        0x00002F3A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3A,
        0x00002F3A,
        0x00002F3A
    };

    static Char _decompositionMapping00002F3B[] = 
    {
        0x00005F73
    };

    static _CharacterInfo _character00002F3B =
    {
        0x00002F3B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3B,
        0x00002F3B,
        0x00002F3B
    };

    static Char _decompositionMapping00002F3C[] = 
    {
        0x00005FC3
    };

    static _CharacterInfo _character00002F3C =
    {
        0x00002F3C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3C,
        0x00002F3C,
        0x00002F3C
    };

    static Char _decompositionMapping00002F3D[] = 
    {
        0x00006208
    };

    static _CharacterInfo _character00002F3D =
    {
        0x00002F3D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3D,
        0x00002F3D,
        0x00002F3D
    };

    static Char _decompositionMapping00002F3E[] = 
    {
        0x00006236
    };

    static _CharacterInfo _character00002F3E =
    {
        0x00002F3E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3E,
        0x00002F3E,
        0x00002F3E
    };

    static Char _decompositionMapping00002F3F[] = 
    {
        0x0000624B
    };

    static _CharacterInfo _character00002F3F =
    {
        0x00002F3F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F3F,
        0x00002F3F,
        0x00002F3F
    };

    static Char _decompositionMapping00002F40[] = 
    {
        0x0000652F
    };

    static _CharacterInfo _character00002F40 =
    {
        0x00002F40,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F40,
        0x00002F40,
        0x00002F40
    };

    static Char _decompositionMapping00002F41[] = 
    {
        0x00006534
    };

    static _CharacterInfo _character00002F41 =
    {
        0x00002F41,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F41,
        0x00002F41,
        0x00002F41
    };

    static Char _decompositionMapping00002F42[] = 
    {
        0x00006587
    };

    static _CharacterInfo _character00002F42 =
    {
        0x00002F42,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F42,
        0x00002F42,
        0x00002F42
    };

    static Char _decompositionMapping00002F43[] = 
    {
        0x00006597
    };

    static _CharacterInfo _character00002F43 =
    {
        0x00002F43,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F43,
        0x00002F43,
        0x00002F43
    };

    static Char _decompositionMapping00002F44[] = 
    {
        0x000065A4
    };

    static _CharacterInfo _character00002F44 =
    {
        0x00002F44,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F44,
        0x00002F44,
        0x00002F44
    };

    static Char _decompositionMapping00002F45[] = 
    {
        0x000065B9
    };

    static _CharacterInfo _character00002F45 =
    {
        0x00002F45,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F45,
        0x00002F45,
        0x00002F45
    };

    static Char _decompositionMapping00002F46[] = 
    {
        0x000065E0
    };

    static _CharacterInfo _character00002F46 =
    {
        0x00002F46,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F46,
        0x00002F46,
        0x00002F46
    };

    static Char _decompositionMapping00002F47[] = 
    {
        0x000065E5
    };

    static _CharacterInfo _character00002F47 =
    {
        0x00002F47,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F47,
        0x00002F47,
        0x00002F47
    };

    static Char _decompositionMapping00002F48[] = 
    {
        0x000066F0
    };

    static _CharacterInfo _character00002F48 =
    {
        0x00002F48,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F48,
        0x00002F48,
        0x00002F48
    };

    static Char _decompositionMapping00002F49[] = 
    {
        0x00006708
    };

    static _CharacterInfo _character00002F49 =
    {
        0x00002F49,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F49,
        0x00002F49,
        0x00002F49
    };

    static Char _decompositionMapping00002F4A[] = 
    {
        0x00006728
    };

    static _CharacterInfo _character00002F4A =
    {
        0x00002F4A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4A,
        0x00002F4A,
        0x00002F4A
    };

    static Char _decompositionMapping00002F4B[] = 
    {
        0x00006B20
    };

    static _CharacterInfo _character00002F4B =
    {
        0x00002F4B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4B,
        0x00002F4B,
        0x00002F4B
    };

    static Char _decompositionMapping00002F4C[] = 
    {
        0x00006B62
    };

    static _CharacterInfo _character00002F4C =
    {
        0x00002F4C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4C,
        0x00002F4C,
        0x00002F4C
    };

    static Char _decompositionMapping00002F4D[] = 
    {
        0x00006B79
    };

    static _CharacterInfo _character00002F4D =
    {
        0x00002F4D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4D,
        0x00002F4D,
        0x00002F4D
    };

    static Char _decompositionMapping00002F4E[] = 
    {
        0x00006BB3
    };

    static _CharacterInfo _character00002F4E =
    {
        0x00002F4E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4E,
        0x00002F4E,
        0x00002F4E
    };

    static Char _decompositionMapping00002F4F[] = 
    {
        0x00006BCB
    };

    static _CharacterInfo _character00002F4F =
    {
        0x00002F4F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F4F,
        0x00002F4F,
        0x00002F4F
    };

    static Char _decompositionMapping00002F50[] = 
    {
        0x00006BD4
    };

    static _CharacterInfo _character00002F50 =
    {
        0x00002F50,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F50,
        0x00002F50,
        0x00002F50
    };

    static Char _decompositionMapping00002F51[] = 
    {
        0x00006BDB
    };

    static _CharacterInfo _character00002F51 =
    {
        0x00002F51,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F51,
        0x00002F51,
        0x00002F51
    };

    static Char _decompositionMapping00002F52[] = 
    {
        0x00006C0F
    };

    static _CharacterInfo _character00002F52 =
    {
        0x00002F52,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F52,
        0x00002F52,
        0x00002F52
    };

    static Char _decompositionMapping00002F53[] = 
    {
        0x00006C14
    };

    static _CharacterInfo _character00002F53 =
    {
        0x00002F53,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F53,
        0x00002F53,
        0x00002F53
    };

    static Char _decompositionMapping00002F54[] = 
    {
        0x00006C34
    };

    static _CharacterInfo _character00002F54 =
    {
        0x00002F54,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F54,
        0x00002F54,
        0x00002F54
    };

    static Char _decompositionMapping00002F55[] = 
    {
        0x0000706B
    };

    static _CharacterInfo _character00002F55 =
    {
        0x00002F55,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F55,
        0x00002F55,
        0x00002F55
    };

    static Char _decompositionMapping00002F56[] = 
    {
        0x0000722A
    };

    static _CharacterInfo _character00002F56 =
    {
        0x00002F56,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F56,
        0x00002F56,
        0x00002F56
    };

    static Char _decompositionMapping00002F57[] = 
    {
        0x00007236
    };

    static _CharacterInfo _character00002F57 =
    {
        0x00002F57,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F57,
        0x00002F57,
        0x00002F57
    };

    static Char _decompositionMapping00002F58[] = 
    {
        0x0000723B
    };

    static _CharacterInfo _character00002F58 =
    {
        0x00002F58,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F58,
        0x00002F58,
        0x00002F58
    };

    static Char _decompositionMapping00002F59[] = 
    {
        0x0000723F
    };

    static _CharacterInfo _character00002F59 =
    {
        0x00002F59,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F59,
        0x00002F59,
        0x00002F59
    };

    static Char _decompositionMapping00002F5A[] = 
    {
        0x00007247
    };

    static _CharacterInfo _character00002F5A =
    {
        0x00002F5A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5A,
        0x00002F5A,
        0x00002F5A
    };

    static Char _decompositionMapping00002F5B[] = 
    {
        0x00007259
    };

    static _CharacterInfo _character00002F5B =
    {
        0x00002F5B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5B,
        0x00002F5B,
        0x00002F5B
    };

    static Char _decompositionMapping00002F5C[] = 
    {
        0x0000725B
    };

    static _CharacterInfo _character00002F5C =
    {
        0x00002F5C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5C,
        0x00002F5C,
        0x00002F5C
    };

    static Char _decompositionMapping00002F5D[] = 
    {
        0x000072AC
    };

    static _CharacterInfo _character00002F5D =
    {
        0x00002F5D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5D,
        0x00002F5D,
        0x00002F5D
    };

    static Char _decompositionMapping00002F5E[] = 
    {
        0x00007384
    };

    static _CharacterInfo _character00002F5E =
    {
        0x00002F5E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5E,
        0x00002F5E,
        0x00002F5E
    };

    static Char _decompositionMapping00002F5F[] = 
    {
        0x00007389
    };

    static _CharacterInfo _character00002F5F =
    {
        0x00002F5F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F5F,
        0x00002F5F,
        0x00002F5F
    };

    static Char _decompositionMapping00002F60[] = 
    {
        0x000074DC
    };

    static _CharacterInfo _character00002F60 =
    {
        0x00002F60,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F60,
        0x00002F60,
        0x00002F60
    };

    static Char _decompositionMapping00002F61[] = 
    {
        0x000074E6
    };

    static _CharacterInfo _character00002F61 =
    {
        0x00002F61,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F61,
        0x00002F61,
        0x00002F61
    };

    static Char _decompositionMapping00002F62[] = 
    {
        0x00007518
    };

    static _CharacterInfo _character00002F62 =
    {
        0x00002F62,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F62,
        0x00002F62,
        0x00002F62
    };

    static Char _decompositionMapping00002F63[] = 
    {
        0x0000751F
    };

    static _CharacterInfo _character00002F63 =
    {
        0x00002F63,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F63,
        0x00002F63,
        0x00002F63
    };

    static Char _decompositionMapping00002F64[] = 
    {
        0x00007528
    };

    static _CharacterInfo _character00002F64 =
    {
        0x00002F64,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F64,
        0x00002F64,
        0x00002F64
    };

    static Char _decompositionMapping00002F65[] = 
    {
        0x00007530
    };

    static _CharacterInfo _character00002F65 =
    {
        0x00002F65,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F65,
        0x00002F65,
        0x00002F65
    };

    static Char _decompositionMapping00002F66[] = 
    {
        0x0000758B
    };

    static _CharacterInfo _character00002F66 =
    {
        0x00002F66,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F66,
        0x00002F66,
        0x00002F66
    };

    static Char _decompositionMapping00002F67[] = 
    {
        0x00007592
    };

    static _CharacterInfo _character00002F67 =
    {
        0x00002F67,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F67,
        0x00002F67,
        0x00002F67
    };

    static Char _decompositionMapping00002F68[] = 
    {
        0x00007676
    };

    static _CharacterInfo _character00002F68 =
    {
        0x00002F68,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F68,
        0x00002F68,
        0x00002F68
    };

    static Char _decompositionMapping00002F69[] = 
    {
        0x0000767D
    };

    static _CharacterInfo _character00002F69 =
    {
        0x00002F69,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F69,
        0x00002F69,
        0x00002F69
    };

    static Char _decompositionMapping00002F6A[] = 
    {
        0x000076AE
    };

    static _CharacterInfo _character00002F6A =
    {
        0x00002F6A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6A,
        0x00002F6A,
        0x00002F6A
    };

    static Char _decompositionMapping00002F6B[] = 
    {
        0x000076BF
    };

    static _CharacterInfo _character00002F6B =
    {
        0x00002F6B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6B,
        0x00002F6B,
        0x00002F6B
    };

    static Char _decompositionMapping00002F6C[] = 
    {
        0x000076EE
    };

    static _CharacterInfo _character00002F6C =
    {
        0x00002F6C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6C,
        0x00002F6C,
        0x00002F6C
    };

    static Char _decompositionMapping00002F6D[] = 
    {
        0x000077DB
    };

    static _CharacterInfo _character00002F6D =
    {
        0x00002F6D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6D,
        0x00002F6D,
        0x00002F6D
    };

    static Char _decompositionMapping00002F6E[] = 
    {
        0x000077E2
    };

    static _CharacterInfo _character00002F6E =
    {
        0x00002F6E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6E,
        0x00002F6E,
        0x00002F6E
    };

    static Char _decompositionMapping00002F6F[] = 
    {
        0x000077F3
    };

    static _CharacterInfo _character00002F6F =
    {
        0x00002F6F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F6F,
        0x00002F6F,
        0x00002F6F
    };

    static Char _decompositionMapping00002F70[] = 
    {
        0x0000793A
    };

    static _CharacterInfo _character00002F70 =
    {
        0x00002F70,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F70,
        0x00002F70,
        0x00002F70
    };

    static Char _decompositionMapping00002F71[] = 
    {
        0x000079B8
    };

    static _CharacterInfo _character00002F71 =
    {
        0x00002F71,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F71,
        0x00002F71,
        0x00002F71
    };

    static Char _decompositionMapping00002F72[] = 
    {
        0x000079BE
    };

    static _CharacterInfo _character00002F72 =
    {
        0x00002F72,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F72,
        0x00002F72,
        0x00002F72
    };

    static Char _decompositionMapping00002F73[] = 
    {
        0x00007A74
    };

    static _CharacterInfo _character00002F73 =
    {
        0x00002F73,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F73,
        0x00002F73,
        0x00002F73
    };

    static Char _decompositionMapping00002F74[] = 
    {
        0x00007ACB
    };

    static _CharacterInfo _character00002F74 =
    {
        0x00002F74,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F74,
        0x00002F74,
        0x00002F74
    };

    static Char _decompositionMapping00002F75[] = 
    {
        0x00007AF9
    };

    static _CharacterInfo _character00002F75 =
    {
        0x00002F75,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F75,
        0x00002F75,
        0x00002F75
    };

    static Char _decompositionMapping00002F76[] = 
    {
        0x00007C73
    };

    static _CharacterInfo _character00002F76 =
    {
        0x00002F76,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F76,
        0x00002F76,
        0x00002F76
    };

    static Char _decompositionMapping00002F77[] = 
    {
        0x00007CF8
    };

    static _CharacterInfo _character00002F77 =
    {
        0x00002F77,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F77,
        0x00002F77,
        0x00002F77
    };

    static Char _decompositionMapping00002F78[] = 
    {
        0x00007F36
    };

    static _CharacterInfo _character00002F78 =
    {
        0x00002F78,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F78,
        0x00002F78,
        0x00002F78
    };

    static Char _decompositionMapping00002F79[] = 
    {
        0x00007F51
    };

    static _CharacterInfo _character00002F79 =
    {
        0x00002F79,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F79,
        0x00002F79,
        0x00002F79
    };

    static Char _decompositionMapping00002F7A[] = 
    {
        0x00007F8A
    };

    static _CharacterInfo _character00002F7A =
    {
        0x00002F7A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7A,
        0x00002F7A,
        0x00002F7A
    };

    static Char _decompositionMapping00002F7B[] = 
    {
        0x00007FBD
    };

    static _CharacterInfo _character00002F7B =
    {
        0x00002F7B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7B,
        0x00002F7B,
        0x00002F7B
    };

    static Char _decompositionMapping00002F7C[] = 
    {
        0x00008001
    };

    static _CharacterInfo _character00002F7C =
    {
        0x00002F7C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7C,
        0x00002F7C,
        0x00002F7C
    };

    static Char _decompositionMapping00002F7D[] = 
    {
        0x0000800C
    };

    static _CharacterInfo _character00002F7D =
    {
        0x00002F7D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7D,
        0x00002F7D,
        0x00002F7D
    };

    static Char _decompositionMapping00002F7E[] = 
    {
        0x00008012
    };

    static _CharacterInfo _character00002F7E =
    {
        0x00002F7E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7E,
        0x00002F7E,
        0x00002F7E
    };

    static Char _decompositionMapping00002F7F[] = 
    {
        0x00008033
    };

    static _CharacterInfo _character00002F7F =
    {
        0x00002F7F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F7F,
        0x00002F7F,
        0x00002F7F
    };

    static Char _decompositionMapping00002F80[] = 
    {
        0x0000807F
    };

    static _CharacterInfo _character00002F80 =
    {
        0x00002F80,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F80,
        0x00002F80,
        0x00002F80
    };

    static Char _decompositionMapping00002F81[] = 
    {
        0x00008089
    };

    static _CharacterInfo _character00002F81 =
    {
        0x00002F81,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F81,
        0x00002F81,
        0x00002F81
    };

    static Char _decompositionMapping00002F82[] = 
    {
        0x000081E3
    };

    static _CharacterInfo _character00002F82 =
    {
        0x00002F82,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F82,
        0x00002F82,
        0x00002F82
    };

    static Char _decompositionMapping00002F83[] = 
    {
        0x000081EA
    };

    static _CharacterInfo _character00002F83 =
    {
        0x00002F83,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F83,
        0x00002F83,
        0x00002F83
    };

    static Char _decompositionMapping00002F84[] = 
    {
        0x000081F3
    };

    static _CharacterInfo _character00002F84 =
    {
        0x00002F84,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F84,
        0x00002F84,
        0x00002F84
    };

    static Char _decompositionMapping00002F85[] = 
    {
        0x000081FC
    };

    static _CharacterInfo _character00002F85 =
    {
        0x00002F85,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F85,
        0x00002F85,
        0x00002F85
    };

    static Char _decompositionMapping00002F86[] = 
    {
        0x0000820C
    };

    static _CharacterInfo _character00002F86 =
    {
        0x00002F86,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F86,
        0x00002F86,
        0x00002F86
    };

    static Char _decompositionMapping00002F87[] = 
    {
        0x0000821B
    };

    static _CharacterInfo _character00002F87 =
    {
        0x00002F87,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F87,
        0x00002F87,
        0x00002F87
    };

    static Char _decompositionMapping00002F88[] = 
    {
        0x0000821F
    };

    static _CharacterInfo _character00002F88 =
    {
        0x00002F88,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F88,
        0x00002F88,
        0x00002F88
    };

    static Char _decompositionMapping00002F89[] = 
    {
        0x0000826E
    };

    static _CharacterInfo _character00002F89 =
    {
        0x00002F89,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F89,
        0x00002F89,
        0x00002F89
    };

    static Char _decompositionMapping00002F8A[] = 
    {
        0x00008272
    };

    static _CharacterInfo _character00002F8A =
    {
        0x00002F8A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8A,
        0x00002F8A,
        0x00002F8A
    };

    static Char _decompositionMapping00002F8B[] = 
    {
        0x00008278
    };

    static _CharacterInfo _character00002F8B =
    {
        0x00002F8B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8B,
        0x00002F8B,
        0x00002F8B
    };

    static Char _decompositionMapping00002F8C[] = 
    {
        0x0000864D
    };

    static _CharacterInfo _character00002F8C =
    {
        0x00002F8C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8C,
        0x00002F8C,
        0x00002F8C
    };

    static Char _decompositionMapping00002F8D[] = 
    {
        0x0000866B
    };

    static _CharacterInfo _character00002F8D =
    {
        0x00002F8D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8D,
        0x00002F8D,
        0x00002F8D
    };

    static Char _decompositionMapping00002F8E[] = 
    {
        0x00008840
    };

    static _CharacterInfo _character00002F8E =
    {
        0x00002F8E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8E,
        0x00002F8E,
        0x00002F8E
    };

    static Char _decompositionMapping00002F8F[] = 
    {
        0x0000884C
    };

    static _CharacterInfo _character00002F8F =
    {
        0x00002F8F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F8F,
        0x00002F8F,
        0x00002F8F
    };

    static Char _decompositionMapping00002F90[] = 
    {
        0x00008863
    };

    static _CharacterInfo _character00002F90 =
    {
        0x00002F90,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F90,
        0x00002F90,
        0x00002F90
    };

    static Char _decompositionMapping00002F91[] = 
    {
        0x0000897E
    };

    static _CharacterInfo _character00002F91 =
    {
        0x00002F91,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F91,
        0x00002F91,
        0x00002F91
    };

    static Char _decompositionMapping00002F92[] = 
    {
        0x0000898B
    };

    static _CharacterInfo _character00002F92 =
    {
        0x00002F92,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F92,
        0x00002F92,
        0x00002F92
    };

    static Char _decompositionMapping00002F93[] = 
    {
        0x000089D2
    };

    static _CharacterInfo _character00002F93 =
    {
        0x00002F93,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F93,
        0x00002F93,
        0x00002F93
    };

    static Char _decompositionMapping00002F94[] = 
    {
        0x00008A00
    };

    static _CharacterInfo _character00002F94 =
    {
        0x00002F94,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F94,
        0x00002F94,
        0x00002F94
    };

    static Char _decompositionMapping00002F95[] = 
    {
        0x00008C37
    };

    static _CharacterInfo _character00002F95 =
    {
        0x00002F95,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F95,
        0x00002F95,
        0x00002F95
    };

    static Char _decompositionMapping00002F96[] = 
    {
        0x00008C46
    };

    static _CharacterInfo _character00002F96 =
    {
        0x00002F96,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F96,
        0x00002F96,
        0x00002F96
    };

    static Char _decompositionMapping00002F97[] = 
    {
        0x00008C55
    };

    static _CharacterInfo _character00002F97 =
    {
        0x00002F97,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F97,
        0x00002F97,
        0x00002F97
    };

    static Char _decompositionMapping00002F98[] = 
    {
        0x00008C78
    };

    static _CharacterInfo _character00002F98 =
    {
        0x00002F98,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F98,
        0x00002F98,
        0x00002F98
    };

    static Char _decompositionMapping00002F99[] = 
    {
        0x00008C9D
    };

    static _CharacterInfo _character00002F99 =
    {
        0x00002F99,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F99,
        0x00002F99,
        0x00002F99
    };

    static Char _decompositionMapping00002F9A[] = 
    {
        0x00008D64
    };

    static _CharacterInfo _character00002F9A =
    {
        0x00002F9A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9A,
        0x00002F9A,
        0x00002F9A
    };

    static Char _decompositionMapping00002F9B[] = 
    {
        0x00008D70
    };

    static _CharacterInfo _character00002F9B =
    {
        0x00002F9B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9B,
        0x00002F9B,
        0x00002F9B
    };

    static Char _decompositionMapping00002F9C[] = 
    {
        0x00008DB3
    };

    static _CharacterInfo _character00002F9C =
    {
        0x00002F9C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9C,
        0x00002F9C,
        0x00002F9C
    };

    static Char _decompositionMapping00002F9D[] = 
    {
        0x00008EAB
    };

    static _CharacterInfo _character00002F9D =
    {
        0x00002F9D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9D,
        0x00002F9D,
        0x00002F9D
    };

    static Char _decompositionMapping00002F9E[] = 
    {
        0x00008ECA
    };

    static _CharacterInfo _character00002F9E =
    {
        0x00002F9E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9E,
        0x00002F9E,
        0x00002F9E
    };

    static Char _decompositionMapping00002F9F[] = 
    {
        0x00008F9B
    };

    static _CharacterInfo _character00002F9F =
    {
        0x00002F9F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002F9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002F9F,
        0x00002F9F,
        0x00002F9F
    };

    static Char _decompositionMapping00002FA0[] = 
    {
        0x00008FB0
    };

    static _CharacterInfo _character00002FA0 =
    {
        0x00002FA0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA0,
        0x00002FA0,
        0x00002FA0
    };

    static Char _decompositionMapping00002FA1[] = 
    {
        0x00008FB5
    };

    static _CharacterInfo _character00002FA1 =
    {
        0x00002FA1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA1,
        0x00002FA1,
        0x00002FA1
    };

    static Char _decompositionMapping00002FA2[] = 
    {
        0x00009091
    };

    static _CharacterInfo _character00002FA2 =
    {
        0x00002FA2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA2,
        0x00002FA2,
        0x00002FA2
    };

    static Char _decompositionMapping00002FA3[] = 
    {
        0x00009149
    };

    static _CharacterInfo _character00002FA3 =
    {
        0x00002FA3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA3,
        0x00002FA3,
        0x00002FA3
    };

    static Char _decompositionMapping00002FA4[] = 
    {
        0x000091C6
    };

    static _CharacterInfo _character00002FA4 =
    {
        0x00002FA4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA4,
        0x00002FA4,
        0x00002FA4
    };

    static Char _decompositionMapping00002FA5[] = 
    {
        0x000091CC
    };

    static _CharacterInfo _character00002FA5 =
    {
        0x00002FA5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA5,
        0x00002FA5,
        0x00002FA5
    };

    static Char _decompositionMapping00002FA6[] = 
    {
        0x000091D1
    };

    static _CharacterInfo _character00002FA6 =
    {
        0x00002FA6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA6,
        0x00002FA6,
        0x00002FA6
    };

    static Char _decompositionMapping00002FA7[] = 
    {
        0x00009577
    };

    static _CharacterInfo _character00002FA7 =
    {
        0x00002FA7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA7,
        0x00002FA7,
        0x00002FA7
    };

    static Char _decompositionMapping00002FA8[] = 
    {
        0x00009580
    };

    static _CharacterInfo _character00002FA8 =
    {
        0x00002FA8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA8,
        0x00002FA8,
        0x00002FA8
    };

    static Char _decompositionMapping00002FA9[] = 
    {
        0x0000961C
    };

    static _CharacterInfo _character00002FA9 =
    {
        0x00002FA9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FA9,
        0x00002FA9,
        0x00002FA9
    };

    static Char _decompositionMapping00002FAA[] = 
    {
        0x000096B6
    };

    static _CharacterInfo _character00002FAA =
    {
        0x00002FAA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAA,
        0x00002FAA,
        0x00002FAA
    };

    static Char _decompositionMapping00002FAB[] = 
    {
        0x000096B9
    };

    static _CharacterInfo _character00002FAB =
    {
        0x00002FAB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAB,
        0x00002FAB,
        0x00002FAB
    };

    static Char _decompositionMapping00002FAC[] = 
    {
        0x000096E8
    };

    static _CharacterInfo _character00002FAC =
    {
        0x00002FAC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAC,
        0x00002FAC,
        0x00002FAC
    };

    static Char _decompositionMapping00002FAD[] = 
    {
        0x00009751
    };

    static _CharacterInfo _character00002FAD =
    {
        0x00002FAD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAD,
        0x00002FAD,
        0x00002FAD
    };

    static Char _decompositionMapping00002FAE[] = 
    {
        0x0000975E
    };

    static _CharacterInfo _character00002FAE =
    {
        0x00002FAE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAE,
        0x00002FAE,
        0x00002FAE
    };

    static Char _decompositionMapping00002FAF[] = 
    {
        0x00009762
    };

    static _CharacterInfo _character00002FAF =
    {
        0x00002FAF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FAF,
        0x00002FAF,
        0x00002FAF
    };

    static Char _decompositionMapping00002FB0[] = 
    {
        0x00009769
    };

    static _CharacterInfo _character00002FB0 =
    {
        0x00002FB0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB0,
        0x00002FB0,
        0x00002FB0
    };

    static Char _decompositionMapping00002FB1[] = 
    {
        0x000097CB
    };

    static _CharacterInfo _character00002FB1 =
    {
        0x00002FB1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB1,
        0x00002FB1,
        0x00002FB1
    };

    static Char _decompositionMapping00002FB2[] = 
    {
        0x000097ED
    };

    static _CharacterInfo _character00002FB2 =
    {
        0x00002FB2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB2,
        0x00002FB2,
        0x00002FB2
    };

    static Char _decompositionMapping00002FB3[] = 
    {
        0x000097F3
    };

    static _CharacterInfo _character00002FB3 =
    {
        0x00002FB3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB3,
        0x00002FB3,
        0x00002FB3
    };

    static Char _decompositionMapping00002FB4[] = 
    {
        0x00009801
    };

    static _CharacterInfo _character00002FB4 =
    {
        0x00002FB4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB4,
        0x00002FB4,
        0x00002FB4
    };

    static Char _decompositionMapping00002FB5[] = 
    {
        0x000098A8
    };

    static _CharacterInfo _character00002FB5 =
    {
        0x00002FB5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB5,
        0x00002FB5,
        0x00002FB5
    };

    static Char _decompositionMapping00002FB6[] = 
    {
        0x000098DB
    };

    static _CharacterInfo _character00002FB6 =
    {
        0x00002FB6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB6,
        0x00002FB6,
        0x00002FB6
    };

    static Char _decompositionMapping00002FB7[] = 
    {
        0x000098DF
    };

    static _CharacterInfo _character00002FB7 =
    {
        0x00002FB7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB7,
        0x00002FB7,
        0x00002FB7
    };

    static Char _decompositionMapping00002FB8[] = 
    {
        0x00009996
    };

    static _CharacterInfo _character00002FB8 =
    {
        0x00002FB8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB8,
        0x00002FB8,
        0x00002FB8
    };

    static Char _decompositionMapping00002FB9[] = 
    {
        0x00009999
    };

    static _CharacterInfo _character00002FB9 =
    {
        0x00002FB9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FB9,
        0x00002FB9,
        0x00002FB9
    };

    static Char _decompositionMapping00002FBA[] = 
    {
        0x000099AC
    };

    static _CharacterInfo _character00002FBA =
    {
        0x00002FBA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBA,
        0x00002FBA,
        0x00002FBA
    };

    static Char _decompositionMapping00002FBB[] = 
    {
        0x00009AA8
    };

    static _CharacterInfo _character00002FBB =
    {
        0x00002FBB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBB,
        0x00002FBB,
        0x00002FBB
    };

    static Char _decompositionMapping00002FBC[] = 
    {
        0x00009AD8
    };

    static _CharacterInfo _character00002FBC =
    {
        0x00002FBC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBC,
        0x00002FBC,
        0x00002FBC
    };

    static Char _decompositionMapping00002FBD[] = 
    {
        0x00009ADF
    };

    static _CharacterInfo _character00002FBD =
    {
        0x00002FBD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBD,
        0x00002FBD,
        0x00002FBD
    };

    static Char _decompositionMapping00002FBE[] = 
    {
        0x00009B25
    };

    static _CharacterInfo _character00002FBE =
    {
        0x00002FBE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBE,
        0x00002FBE,
        0x00002FBE
    };

    static Char _decompositionMapping00002FBF[] = 
    {
        0x00009B2F
    };

    static _CharacterInfo _character00002FBF =
    {
        0x00002FBF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FBF,
        0x00002FBF,
        0x00002FBF
    };

    static Char _decompositionMapping00002FC0[] = 
    {
        0x00009B32
    };

    static _CharacterInfo _character00002FC0 =
    {
        0x00002FC0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC0,
        0x00002FC0,
        0x00002FC0
    };

    static Char _decompositionMapping00002FC1[] = 
    {
        0x00009B3C
    };

    static _CharacterInfo _character00002FC1 =
    {
        0x00002FC1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC1,
        0x00002FC1,
        0x00002FC1
    };

    static Char _decompositionMapping00002FC2[] = 
    {
        0x00009B5A
    };

    static _CharacterInfo _character00002FC2 =
    {
        0x00002FC2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC2,
        0x00002FC2,
        0x00002FC2
    };

    static Char _decompositionMapping00002FC3[] = 
    {
        0x00009CE5
    };

    static _CharacterInfo _character00002FC3 =
    {
        0x00002FC3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC3,
        0x00002FC3,
        0x00002FC3
    };

    static Char _decompositionMapping00002FC4[] = 
    {
        0x00009E75
    };

    static _CharacterInfo _character00002FC4 =
    {
        0x00002FC4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC4,
        0x00002FC4,
        0x00002FC4
    };

    static Char _decompositionMapping00002FC5[] = 
    {
        0x00009E7F
    };

    static _CharacterInfo _character00002FC5 =
    {
        0x00002FC5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC5,
        0x00002FC5,
        0x00002FC5
    };

    static Char _decompositionMapping00002FC6[] = 
    {
        0x00009EA5
    };

    static _CharacterInfo _character00002FC6 =
    {
        0x00002FC6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC6,
        0x00002FC6,
        0x00002FC6
    };

    static Char _decompositionMapping00002FC7[] = 
    {
        0x00009EBB
    };

    static _CharacterInfo _character00002FC7 =
    {
        0x00002FC7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC7,
        0x00002FC7,
        0x00002FC7
    };

    static Char _decompositionMapping00002FC8[] = 
    {
        0x00009EC3
    };

    static _CharacterInfo _character00002FC8 =
    {
        0x00002FC8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC8,
        0x00002FC8,
        0x00002FC8
    };

    static Char _decompositionMapping00002FC9[] = 
    {
        0x00009ECD
    };

    static _CharacterInfo _character00002FC9 =
    {
        0x00002FC9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FC9,
        0x00002FC9,
        0x00002FC9
    };

    static Char _decompositionMapping00002FCA[] = 
    {
        0x00009ED1
    };

    static _CharacterInfo _character00002FCA =
    {
        0x00002FCA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCA,
        0x00002FCA,
        0x00002FCA
    };

    static Char _decompositionMapping00002FCB[] = 
    {
        0x00009EF9
    };

    static _CharacterInfo _character00002FCB =
    {
        0x00002FCB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCB,
        0x00002FCB,
        0x00002FCB
    };

    static Char _decompositionMapping00002FCC[] = 
    {
        0x00009EFD
    };

    static _CharacterInfo _character00002FCC =
    {
        0x00002FCC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCC,
        0x00002FCC,
        0x00002FCC
    };

    static Char _decompositionMapping00002FCD[] = 
    {
        0x00009F0E
    };

    static _CharacterInfo _character00002FCD =
    {
        0x00002FCD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCD,
        0x00002FCD,
        0x00002FCD
    };

    static Char _decompositionMapping00002FCE[] = 
    {
        0x00009F13
    };

    static _CharacterInfo _character00002FCE =
    {
        0x00002FCE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCE,
        0x00002FCE,
        0x00002FCE
    };

    static Char _decompositionMapping00002FCF[] = 
    {
        0x00009F20
    };

    static _CharacterInfo _character00002FCF =
    {
        0x00002FCF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FCF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FCF,
        0x00002FCF,
        0x00002FCF
    };

    static Char _decompositionMapping00002FD0[] = 
    {
        0x00009F3B
    };

    static _CharacterInfo _character00002FD0 =
    {
        0x00002FD0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD0,
        0x00002FD0,
        0x00002FD0
    };

    static Char _decompositionMapping00002FD1[] = 
    {
        0x00009F4A
    };

    static _CharacterInfo _character00002FD1 =
    {
        0x00002FD1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD1,
        0x00002FD1,
        0x00002FD1
    };

    static Char _decompositionMapping00002FD2[] = 
    {
        0x00009F52
    };

    static _CharacterInfo _character00002FD2 =
    {
        0x00002FD2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD2,
        0x00002FD2,
        0x00002FD2
    };

    static Char _decompositionMapping00002FD3[] = 
    {
        0x00009F8D
    };

    static _CharacterInfo _character00002FD3 =
    {
        0x00002FD3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD3,
        0x00002FD3,
        0x00002FD3
    };

    static Char _decompositionMapping00002FD4[] = 
    {
        0x00009F9C
    };

    static _CharacterInfo _character00002FD4 =
    {
        0x00002FD4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD4,
        0x00002FD4,
        0x00002FD4
    };

    static Char _decompositionMapping00002FD5[] = 
    {
        0x00009FA0
    };

    static _CharacterInfo _character00002FD5 =
    {
        0x00002FD5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00002FD5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FD5,
        0x00002FD5,
        0x00002FD5
    };

    static _CharacterInfo _character00002FF0 =
    {
        0x00002FF0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF0,
        0x00002FF0,
        0x00002FF0
    };

    static _CharacterInfo _character00002FF1 =
    {
        0x00002FF1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF1,
        0x00002FF1,
        0x00002FF1
    };

    static _CharacterInfo _character00002FF2 =
    {
        0x00002FF2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF2,
        0x00002FF2,
        0x00002FF2
    };

    static _CharacterInfo _character00002FF3 =
    {
        0x00002FF3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF3,
        0x00002FF3,
        0x00002FF3
    };

    static _CharacterInfo _character00002FF4 =
    {
        0x00002FF4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF4,
        0x00002FF4,
        0x00002FF4
    };

    static _CharacterInfo _character00002FF5 =
    {
        0x00002FF5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF5,
        0x00002FF5,
        0x00002FF5
    };

    static _CharacterInfo _character00002FF6 =
    {
        0x00002FF6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF6,
        0x00002FF6,
        0x00002FF6
    };

    static _CharacterInfo _character00002FF7 =
    {
        0x00002FF7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF7,
        0x00002FF7,
        0x00002FF7
    };

    static _CharacterInfo _character00002FF8 =
    {
        0x00002FF8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF8,
        0x00002FF8,
        0x00002FF8
    };

    static _CharacterInfo _character00002FF9 =
    {
        0x00002FF9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FF9,
        0x00002FF9,
        0x00002FF9
    };

    static _CharacterInfo _character00002FFA =
    {
        0x00002FFA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FFA,
        0x00002FFA,
        0x00002FFA
    };

    static _CharacterInfo _character00002FFB =
    {
        0x00002FFB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00002FFB,
        0x00002FFB,
        0x00002FFB
    };

    static Char _decompositionMapping00003000[] = 
    {
        0x00000020
    };

    static _CharacterInfo _character00003000 =
    {
        0x00003000,
        Iso10646::GeneralCategory_Zs,
        0,
        Iso10646::BidirectionalCategory_WS,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping00003000,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003000,
        0x00003000,
        0x00003000
    };

    static _CharacterInfo _character00003001 =
    {
        0x00003001,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003001,
        0x00003001,
        0x00003001
    };

    static _CharacterInfo _character00003002 =
    {
        0x00003002,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003002,
        0x00003002,
        0x00003002
    };

    static _CharacterInfo _character00003003 =
    {
        0x00003003,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003003,
        0x00003003,
        0x00003003
    };

    static _CharacterInfo _character00003004 =
    {
        0x00003004,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003004,
        0x00003004,
        0x00003004
    };

    static _CharacterInfo _character00003005 =
    {
        0x00003005,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003005,
        0x00003005,
        0x00003005
    };

    static _CharacterInfo _character00003006 =
    {
        0x00003006,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003006,
        0x00003006,
        0x00003006
    };

    static _CharacterInfo _character00003007 =
    {
        0x00003007,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        0,
        1,
        false,
        0x00003007,
        0x00003007,
        0x00003007
    };

    static _CharacterInfo _character00003008 =
    {
        0x00003008,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003008,
        0x00003008,
        0x00003008
    };

    static _CharacterInfo _character00003009 =
    {
        0x00003009,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003009,
        0x00003009,
        0x00003009
    };

    static _CharacterInfo _character0000300A =
    {
        0x0000300A,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300A,
        0x0000300A,
        0x0000300A
    };

    static _CharacterInfo _character0000300B =
    {
        0x0000300B,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300B,
        0x0000300B,
        0x0000300B
    };

    static _CharacterInfo _character0000300C =
    {
        0x0000300C,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300C,
        0x0000300C,
        0x0000300C
    };

    static _CharacterInfo _character0000300D =
    {
        0x0000300D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300D,
        0x0000300D,
        0x0000300D
    };

    static _CharacterInfo _character0000300E =
    {
        0x0000300E,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300E,
        0x0000300E,
        0x0000300E
    };

    static _CharacterInfo _character0000300F =
    {
        0x0000300F,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000300F,
        0x0000300F,
        0x0000300F
    };

    static _CharacterInfo _character00003010 =
    {
        0x00003010,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003010,
        0x00003010,
        0x00003010
    };

    static _CharacterInfo _character00003011 =
    {
        0x00003011,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003011,
        0x00003011,
        0x00003011
    };

    static _CharacterInfo _character00003012 =
    {
        0x00003012,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003012,
        0x00003012,
        0x00003012
    };

    static _CharacterInfo _character00003013 =
    {
        0x00003013,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003013,
        0x00003013,
        0x00003013
    };

    static _CharacterInfo _character00003014 =
    {
        0x00003014,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003014,
        0x00003014,
        0x00003014
    };

    static _CharacterInfo _character00003015 =
    {
        0x00003015,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003015,
        0x00003015,
        0x00003015
    };

    static _CharacterInfo _character00003016 =
    {
        0x00003016,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003016,
        0x00003016,
        0x00003016
    };

    static _CharacterInfo _character00003017 =
    {
        0x00003017,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003017,
        0x00003017,
        0x00003017
    };

    static _CharacterInfo _character00003018 =
    {
        0x00003018,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003018,
        0x00003018,
        0x00003018
    };

    static _CharacterInfo _character00003019 =
    {
        0x00003019,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x00003019,
        0x00003019,
        0x00003019
    };

    static _CharacterInfo _character0000301A =
    {
        0x0000301A,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000301A,
        0x0000301A,
        0x0000301A
    };

    static _CharacterInfo _character0000301B =
    {
        0x0000301B,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000301B,
        0x0000301B,
        0x0000301B
    };

    static _CharacterInfo _character0000301C =
    {
        0x0000301C,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000301C,
        0x0000301C,
        0x0000301C
    };

    static _CharacterInfo _character0000301D =
    {
        0x0000301D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000301D,
        0x0000301D,
        0x0000301D
    };

    static _CharacterInfo _character0000301E =
    {
        0x0000301E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000301E,
        0x0000301E,
        0x0000301E
    };

    static _CharacterInfo _character0000301F =
    {
        0x0000301F,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000301F,
        0x0000301F,
        0x0000301F
    };

    static _CharacterInfo _character00003020 =
    {
        0x00003020,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003020,
        0x00003020,
        0x00003020
    };

    static _CharacterInfo _character00003021 =
    {
        0x00003021,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00003021,
        0x00003021,
        0x00003021
    };

    static _CharacterInfo _character00003022 =
    {
        0x00003022,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00003022,
        0x00003022,
        0x00003022
    };

    static _CharacterInfo _character00003023 =
    {
        0x00003023,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00003023,
        0x00003023,
        0x00003023
    };

    static _CharacterInfo _character00003024 =
    {
        0x00003024,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00003024,
        0x00003024,
        0x00003024
    };

    static _CharacterInfo _character00003025 =
    {
        0x00003025,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00003025,
        0x00003025,
        0x00003025
    };

    static _CharacterInfo _character00003026 =
    {
        0x00003026,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00003026,
        0x00003026,
        0x00003026
    };

    static _CharacterInfo _character00003027 =
    {
        0x00003027,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00003027,
        0x00003027,
        0x00003027
    };

    static _CharacterInfo _character00003028 =
    {
        0x00003028,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00003028,
        0x00003028,
        0x00003028
    };

    static _CharacterInfo _character00003029 =
    {
        0x00003029,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00003029,
        0x00003029,
        0x00003029
    };

    static _CharacterInfo _character0000302A =
    {
        0x0000302A,
        Iso10646::GeneralCategory_Mn,
        218,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302A,
        0x0000302A,
        0x0000302A
    };

    static _CharacterInfo _character0000302B =
    {
        0x0000302B,
        Iso10646::GeneralCategory_Mn,
        228,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302B,
        0x0000302B,
        0x0000302B
    };

    static _CharacterInfo _character0000302C =
    {
        0x0000302C,
        Iso10646::GeneralCategory_Mn,
        232,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302C,
        0x0000302C,
        0x0000302C
    };

    static _CharacterInfo _character0000302D =
    {
        0x0000302D,
        Iso10646::GeneralCategory_Mn,
        222,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302D,
        0x0000302D,
        0x0000302D
    };

    static _CharacterInfo _character0000302E =
    {
        0x0000302E,
        Iso10646::GeneralCategory_Mn,
        224,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302E,
        0x0000302E,
        0x0000302E
    };

    static _CharacterInfo _character0000302F =
    {
        0x0000302F,
        Iso10646::GeneralCategory_Mn,
        224,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000302F,
        0x0000302F,
        0x0000302F
    };

    static _CharacterInfo _character00003030 =
    {
        0x00003030,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003030,
        0x00003030,
        0x00003030
    };

    static _CharacterInfo _character00003031 =
    {
        0x00003031,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003031,
        0x00003031,
        0x00003031
    };

    static _CharacterInfo _character00003032 =
    {
        0x00003032,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003032,
        0x00003032,
        0x00003032
    };

    static _CharacterInfo _character00003033 =
    {
        0x00003033,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003033,
        0x00003033,
        0x00003033
    };

    static _CharacterInfo _character00003034 =
    {
        0x00003034,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003034,
        0x00003034,
        0x00003034
    };

    static _CharacterInfo _character00003035 =
    {
        0x00003035,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003035,
        0x00003035,
        0x00003035
    };

    static Char _decompositionMapping00003036[] = 
    {
        0x00003012
    };

    static _CharacterInfo _character00003036 =
    {
        0x00003036,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003036,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003036,
        0x00003036,
        0x00003036
    };

    static _CharacterInfo _character00003037 =
    {
        0x00003037,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003037,
        0x00003037,
        0x00003037
    };

    static Char _decompositionMapping00003038[] = 
    {
        0x00005341
    };

    static _CharacterInfo _character00003038 =
    {
        0x00003038,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003038,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00003038,
        0x00003038,
        0x00003038
    };

    static Char _decompositionMapping00003039[] = 
    {
        0x00005344
    };

    static _CharacterInfo _character00003039 =
    {
        0x00003039,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003039,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00003039,
        0x00003039,
        0x00003039
    };

    static Char _decompositionMapping0000303A[] = 
    {
        0x00005345
    };

    static _CharacterInfo _character0000303A =
    {
        0x0000303A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000303A,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x0000303A,
        0x0000303A,
        0x0000303A
    };

    static _CharacterInfo _character0000303B =
    {
        0x0000303B,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000303B,
        0x0000303B,
        0x0000303B
    };

    static _CharacterInfo _character0000303C =
    {
        0x0000303C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000303C,
        0x0000303C,
        0x0000303C
    };

    static _CharacterInfo _character0000303D =
    {
        0x0000303D,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000303D,
        0x0000303D,
        0x0000303D
    };

    static _CharacterInfo _character0000303E =
    {
        0x0000303E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000303E,
        0x0000303E,
        0x0000303E
    };

    static _CharacterInfo _character0000303F =
    {
        0x0000303F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000303F,
        0x0000303F,
        0x0000303F
    };

    static _CharacterInfo _character00003041 =
    {
        0x00003041,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003041,
        0x00003041,
        0x00003041
    };

    static _CharacterInfo _character00003042 =
    {
        0x00003042,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003042,
        0x00003042,
        0x00003042
    };

    static _CharacterInfo _character00003043 =
    {
        0x00003043,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003043,
        0x00003043,
        0x00003043
    };

    static _CharacterInfo _character00003044 =
    {
        0x00003044,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003044,
        0x00003044,
        0x00003044
    };

    static _CharacterInfo _character00003045 =
    {
        0x00003045,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003045,
        0x00003045,
        0x00003045
    };

    static _CharacterInfo _character00003046 =
    {
        0x00003046,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003046,
        0x00003046,
        0x00003046
    };

    static _CharacterInfo _character00003047 =
    {
        0x00003047,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003047,
        0x00003047,
        0x00003047
    };

    static _CharacterInfo _character00003048 =
    {
        0x00003048,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003048,
        0x00003048,
        0x00003048
    };

    static _CharacterInfo _character00003049 =
    {
        0x00003049,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003049,
        0x00003049,
        0x00003049
    };

    static _CharacterInfo _character0000304A =
    {
        0x0000304A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304A,
        0x0000304A,
        0x0000304A
    };

    static _CharacterInfo _character0000304B =
    {
        0x0000304B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304B,
        0x0000304B,
        0x0000304B
    };

    static Char _decompositionMapping0000304C[] = 
    {
        0x0000304B,
        0x00003099
    };

    static _CharacterInfo _character0000304C =
    {
        0x0000304C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000304C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304C,
        0x0000304C,
        0x0000304C
    };

    static _CharacterInfo _character0000304D =
    {
        0x0000304D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304D,
        0x0000304D,
        0x0000304D
    };

    static Char _decompositionMapping0000304E[] = 
    {
        0x0000304D,
        0x00003099
    };

    static _CharacterInfo _character0000304E =
    {
        0x0000304E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000304E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304E,
        0x0000304E,
        0x0000304E
    };

    static _CharacterInfo _character0000304F =
    {
        0x0000304F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000304F,
        0x0000304F,
        0x0000304F
    };

    static Char _decompositionMapping00003050[] = 
    {
        0x0000304F,
        0x00003099
    };

    static _CharacterInfo _character00003050 =
    {
        0x00003050,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003050,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003050,
        0x00003050,
        0x00003050
    };

    static _CharacterInfo _character00003051 =
    {
        0x00003051,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003051,
        0x00003051,
        0x00003051
    };

    static Char _decompositionMapping00003052[] = 
    {
        0x00003051,
        0x00003099
    };

    static _CharacterInfo _character00003052 =
    {
        0x00003052,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003052,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003052,
        0x00003052,
        0x00003052
    };

    static _CharacterInfo _character00003053 =
    {
        0x00003053,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003053,
        0x00003053,
        0x00003053
    };

    static Char _decompositionMapping00003054[] = 
    {
        0x00003053,
        0x00003099
    };

    static _CharacterInfo _character00003054 =
    {
        0x00003054,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003054,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003054,
        0x00003054,
        0x00003054
    };

    static _CharacterInfo _character00003055 =
    {
        0x00003055,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003055,
        0x00003055,
        0x00003055
    };

    static Char _decompositionMapping00003056[] = 
    {
        0x00003055,
        0x00003099
    };

    static _CharacterInfo _character00003056 =
    {
        0x00003056,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003056,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003056,
        0x00003056,
        0x00003056
    };

    static _CharacterInfo _character00003057 =
    {
        0x00003057,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003057,
        0x00003057,
        0x00003057
    };

    static Char _decompositionMapping00003058[] = 
    {
        0x00003057,
        0x00003099
    };

    static _CharacterInfo _character00003058 =
    {
        0x00003058,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003058,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003058,
        0x00003058,
        0x00003058
    };

    static _CharacterInfo _character00003059 =
    {
        0x00003059,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003059,
        0x00003059,
        0x00003059
    };

    static Char _decompositionMapping0000305A[] = 
    {
        0x00003059,
        0x00003099
    };

    static _CharacterInfo _character0000305A =
    {
        0x0000305A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000305A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305A,
        0x0000305A,
        0x0000305A
    };

    static _CharacterInfo _character0000305B =
    {
        0x0000305B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305B,
        0x0000305B,
        0x0000305B
    };

    static Char _decompositionMapping0000305C[] = 
    {
        0x0000305B,
        0x00003099
    };

    static _CharacterInfo _character0000305C =
    {
        0x0000305C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000305C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305C,
        0x0000305C,
        0x0000305C
    };

    static _CharacterInfo _character0000305D =
    {
        0x0000305D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305D,
        0x0000305D,
        0x0000305D
    };

    static Char _decompositionMapping0000305E[] = 
    {
        0x0000305D,
        0x00003099
    };

    static _CharacterInfo _character0000305E =
    {
        0x0000305E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000305E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305E,
        0x0000305E,
        0x0000305E
    };

    static _CharacterInfo _character0000305F =
    {
        0x0000305F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000305F,
        0x0000305F,
        0x0000305F
    };

    static Char _decompositionMapping00003060[] = 
    {
        0x0000305F,
        0x00003099
    };

    static _CharacterInfo _character00003060 =
    {
        0x00003060,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003060,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003060,
        0x00003060,
        0x00003060
    };

    static _CharacterInfo _character00003061 =
    {
        0x00003061,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003061,
        0x00003061,
        0x00003061
    };

    static Char _decompositionMapping00003062[] = 
    {
        0x00003061,
        0x00003099
    };

    static _CharacterInfo _character00003062 =
    {
        0x00003062,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003062,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003062,
        0x00003062,
        0x00003062
    };

    static _CharacterInfo _character00003063 =
    {
        0x00003063,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003063,
        0x00003063,
        0x00003063
    };

    static _CharacterInfo _character00003064 =
    {
        0x00003064,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003064,
        0x00003064,
        0x00003064
    };

    static Char _decompositionMapping00003065[] = 
    {
        0x00003064,
        0x00003099
    };

    static _CharacterInfo _character00003065 =
    {
        0x00003065,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003065,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003065,
        0x00003065,
        0x00003065
    };

    static _CharacterInfo _character00003066 =
    {
        0x00003066,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003066,
        0x00003066,
        0x00003066
    };

    static Char _decompositionMapping00003067[] = 
    {
        0x00003066,
        0x00003099
    };

    static _CharacterInfo _character00003067 =
    {
        0x00003067,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003067,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003067,
        0x00003067,
        0x00003067
    };

    static _CharacterInfo _character00003068 =
    {
        0x00003068,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003068,
        0x00003068,
        0x00003068
    };

    static Char _decompositionMapping00003069[] = 
    {
        0x00003068,
        0x00003099
    };

    static _CharacterInfo _character00003069 =
    {
        0x00003069,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003069,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003069,
        0x00003069,
        0x00003069
    };

    static _CharacterInfo _character0000306A =
    {
        0x0000306A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306A,
        0x0000306A,
        0x0000306A
    };

    static _CharacterInfo _character0000306B =
    {
        0x0000306B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306B,
        0x0000306B,
        0x0000306B
    };

    static _CharacterInfo _character0000306C =
    {
        0x0000306C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306C,
        0x0000306C,
        0x0000306C
    };

    static _CharacterInfo _character0000306D =
    {
        0x0000306D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306D,
        0x0000306D,
        0x0000306D
    };

    static _CharacterInfo _character0000306E =
    {
        0x0000306E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306E,
        0x0000306E,
        0x0000306E
    };

    static _CharacterInfo _character0000306F =
    {
        0x0000306F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000306F,
        0x0000306F,
        0x0000306F
    };

    static Char _decompositionMapping00003070[] = 
    {
        0x0000306F,
        0x00003099
    };

    static _CharacterInfo _character00003070 =
    {
        0x00003070,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003070,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003070,
        0x00003070,
        0x00003070
    };

    static Char _decompositionMapping00003071[] = 
    {
        0x0000306F,
        0x0000309A
    };

    static _CharacterInfo _character00003071 =
    {
        0x00003071,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003071,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003071,
        0x00003071,
        0x00003071
    };

    static _CharacterInfo _character00003072 =
    {
        0x00003072,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003072,
        0x00003072,
        0x00003072
    };

    static Char _decompositionMapping00003073[] = 
    {
        0x00003072,
        0x00003099
    };

    static _CharacterInfo _character00003073 =
    {
        0x00003073,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003073,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003073,
        0x00003073,
        0x00003073
    };

    static Char _decompositionMapping00003074[] = 
    {
        0x00003072,
        0x0000309A
    };

    static _CharacterInfo _character00003074 =
    {
        0x00003074,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003074,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003074,
        0x00003074,
        0x00003074
    };

    static _CharacterInfo _character00003075 =
    {
        0x00003075,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003075,
        0x00003075,
        0x00003075
    };

    static Char _decompositionMapping00003076[] = 
    {
        0x00003075,
        0x00003099
    };

    static _CharacterInfo _character00003076 =
    {
        0x00003076,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003076,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003076,
        0x00003076,
        0x00003076
    };

    static Char _decompositionMapping00003077[] = 
    {
        0x00003075,
        0x0000309A
    };

    static _CharacterInfo _character00003077 =
    {
        0x00003077,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003077,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003077,
        0x00003077,
        0x00003077
    };

    static _CharacterInfo _character00003078 =
    {
        0x00003078,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003078,
        0x00003078,
        0x00003078
    };

    static Char _decompositionMapping00003079[] = 
    {
        0x00003078,
        0x00003099
    };

    static _CharacterInfo _character00003079 =
    {
        0x00003079,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003079,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003079,
        0x00003079,
        0x00003079
    };

    static Char _decompositionMapping0000307A[] = 
    {
        0x00003078,
        0x0000309A
    };

    static _CharacterInfo _character0000307A =
    {
        0x0000307A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000307A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307A,
        0x0000307A,
        0x0000307A
    };

    static _CharacterInfo _character0000307B =
    {
        0x0000307B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307B,
        0x0000307B,
        0x0000307B
    };

    static Char _decompositionMapping0000307C[] = 
    {
        0x0000307B,
        0x00003099
    };

    static _CharacterInfo _character0000307C =
    {
        0x0000307C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000307C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307C,
        0x0000307C,
        0x0000307C
    };

    static Char _decompositionMapping0000307D[] = 
    {
        0x0000307B,
        0x0000309A
    };

    static _CharacterInfo _character0000307D =
    {
        0x0000307D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000307D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307D,
        0x0000307D,
        0x0000307D
    };

    static _CharacterInfo _character0000307E =
    {
        0x0000307E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307E,
        0x0000307E,
        0x0000307E
    };

    static _CharacterInfo _character0000307F =
    {
        0x0000307F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000307F,
        0x0000307F,
        0x0000307F
    };

    static _CharacterInfo _character00003080 =
    {
        0x00003080,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003080,
        0x00003080,
        0x00003080
    };

    static _CharacterInfo _character00003081 =
    {
        0x00003081,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003081,
        0x00003081,
        0x00003081
    };

    static _CharacterInfo _character00003082 =
    {
        0x00003082,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003082,
        0x00003082,
        0x00003082
    };

    static _CharacterInfo _character00003083 =
    {
        0x00003083,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003083,
        0x00003083,
        0x00003083
    };

    static _CharacterInfo _character00003084 =
    {
        0x00003084,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003084,
        0x00003084,
        0x00003084
    };

    static _CharacterInfo _character00003085 =
    {
        0x00003085,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003085,
        0x00003085,
        0x00003085
    };

    static _CharacterInfo _character00003086 =
    {
        0x00003086,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003086,
        0x00003086,
        0x00003086
    };

    static _CharacterInfo _character00003087 =
    {
        0x00003087,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003087,
        0x00003087,
        0x00003087
    };

    static _CharacterInfo _character00003088 =
    {
        0x00003088,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003088,
        0x00003088,
        0x00003088
    };

    static _CharacterInfo _character00003089 =
    {
        0x00003089,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003089,
        0x00003089,
        0x00003089
    };

    static _CharacterInfo _character0000308A =
    {
        0x0000308A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308A,
        0x0000308A,
        0x0000308A
    };

    static _CharacterInfo _character0000308B =
    {
        0x0000308B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308B,
        0x0000308B,
        0x0000308B
    };

    static _CharacterInfo _character0000308C =
    {
        0x0000308C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308C,
        0x0000308C,
        0x0000308C
    };

    static _CharacterInfo _character0000308D =
    {
        0x0000308D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308D,
        0x0000308D,
        0x0000308D
    };

    static _CharacterInfo _character0000308E =
    {
        0x0000308E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308E,
        0x0000308E,
        0x0000308E
    };

    static _CharacterInfo _character0000308F =
    {
        0x0000308F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000308F,
        0x0000308F,
        0x0000308F
    };

    static _CharacterInfo _character00003090 =
    {
        0x00003090,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003090,
        0x00003090,
        0x00003090
    };

    static _CharacterInfo _character00003091 =
    {
        0x00003091,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003091,
        0x00003091,
        0x00003091
    };

    static _CharacterInfo _character00003092 =
    {
        0x00003092,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003092,
        0x00003092,
        0x00003092
    };

    static _CharacterInfo _character00003093 =
    {
        0x00003093,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003093,
        0x00003093,
        0x00003093
    };

    static Char _decompositionMapping00003094[] = 
    {
        0x00003046,
        0x00003099
    };

    static _CharacterInfo _character00003094 =
    {
        0x00003094,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping00003094,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003094,
        0x00003094,
        0x00003094
    };

    static _CharacterInfo _character00003095 =
    {
        0x00003095,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003095,
        0x00003095,
        0x00003095
    };

    static _CharacterInfo _character00003096 =
    {
        0x00003096,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003096,
        0x00003096,
        0x00003096
    };

    static _CharacterInfo _character00003099 =
    {
        0x00003099,
        Iso10646::GeneralCategory_Mn,
        8,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003099,
        0x00003099,
        0x00003099
    };

    static _CharacterInfo _character0000309A =
    {
        0x0000309A,
        Iso10646::GeneralCategory_Mn,
        8,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309A,
        0x0000309A,
        0x0000309A
    };

    static Char _decompositionMapping0000309B[] = 
    {
        0x00000020,
        0x00003099
    };

    static _CharacterInfo _character0000309B =
    {
        0x0000309B,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000309B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309B,
        0x0000309B,
        0x0000309B
    };

    static Char _decompositionMapping0000309C[] = 
    {
        0x00000020,
        0x0000309A
    };

    static _CharacterInfo _character0000309C =
    {
        0x0000309C,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000309C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309C,
        0x0000309C,
        0x0000309C
    };

    static _CharacterInfo _character0000309D =
    {
        0x0000309D,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309D,
        0x0000309D,
        0x0000309D
    };

    static Char _decompositionMapping0000309E[] = 
    {
        0x0000309D,
        0x00003099
    };

    static _CharacterInfo _character0000309E =
    {
        0x0000309E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000309E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309E,
        0x0000309E,
        0x0000309E
    };

    static Char _decompositionMapping0000309F[] = 
    {
        0x00003088,
        0x0000308A
    };

    static _CharacterInfo _character0000309F =
    {
        0x0000309F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_vertical,
        2,
        _decompositionMapping0000309F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000309F,
        0x0000309F,
        0x0000309F
    };

    static _CharacterInfo _character000030A0 =
    {
        0x000030A0,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A0,
        0x000030A0,
        0x000030A0
    };

    static _CharacterInfo _character000030A1 =
    {
        0x000030A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A1,
        0x000030A1,
        0x000030A1
    };

    static _CharacterInfo _character000030A2 =
    {
        0x000030A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A2,
        0x000030A2,
        0x000030A2
    };

    static _CharacterInfo _character000030A3 =
    {
        0x000030A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A3,
        0x000030A3,
        0x000030A3
    };

    static _CharacterInfo _character000030A4 =
    {
        0x000030A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A4,
        0x000030A4,
        0x000030A4
    };

    static _CharacterInfo _character000030A5 =
    {
        0x000030A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A5,
        0x000030A5,
        0x000030A5
    };

    static _CharacterInfo _character000030A6 =
    {
        0x000030A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A6,
        0x000030A6,
        0x000030A6
    };

    static _CharacterInfo _character000030A7 =
    {
        0x000030A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A7,
        0x000030A7,
        0x000030A7
    };

    static _CharacterInfo _character000030A8 =
    {
        0x000030A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A8,
        0x000030A8,
        0x000030A8
    };

    static _CharacterInfo _character000030A9 =
    {
        0x000030A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030A9,
        0x000030A9,
        0x000030A9
    };

    static _CharacterInfo _character000030AA =
    {
        0x000030AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AA,
        0x000030AA,
        0x000030AA
    };

    static _CharacterInfo _character000030AB =
    {
        0x000030AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AB,
        0x000030AB,
        0x000030AB
    };

    static Char _decompositionMapping000030AC[] = 
    {
        0x000030AB,
        0x00003099
    };

    static _CharacterInfo _character000030AC =
    {
        0x000030AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AC,
        0x000030AC,
        0x000030AC
    };

    static _CharacterInfo _character000030AD =
    {
        0x000030AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AD,
        0x000030AD,
        0x000030AD
    };

    static Char _decompositionMapping000030AE[] = 
    {
        0x000030AD,
        0x00003099
    };

    static _CharacterInfo _character000030AE =
    {
        0x000030AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AE,
        0x000030AE,
        0x000030AE
    };

    static _CharacterInfo _character000030AF =
    {
        0x000030AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030AF,
        0x000030AF,
        0x000030AF
    };

    static Char _decompositionMapping000030B0[] = 
    {
        0x000030AF,
        0x00003099
    };

    static _CharacterInfo _character000030B0 =
    {
        0x000030B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B0,
        0x000030B0,
        0x000030B0
    };

    static _CharacterInfo _character000030B1 =
    {
        0x000030B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B1,
        0x000030B1,
        0x000030B1
    };

    static Char _decompositionMapping000030B2[] = 
    {
        0x000030B1,
        0x00003099
    };

    static _CharacterInfo _character000030B2 =
    {
        0x000030B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B2,
        0x000030B2,
        0x000030B2
    };

    static _CharacterInfo _character000030B3 =
    {
        0x000030B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B3,
        0x000030B3,
        0x000030B3
    };

    static Char _decompositionMapping000030B4[] = 
    {
        0x000030B3,
        0x00003099
    };

    static _CharacterInfo _character000030B4 =
    {
        0x000030B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B4,
        0x000030B4,
        0x000030B4
    };

    static _CharacterInfo _character000030B5 =
    {
        0x000030B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B5,
        0x000030B5,
        0x000030B5
    };

    static Char _decompositionMapping000030B6[] = 
    {
        0x000030B5,
        0x00003099
    };

    static _CharacterInfo _character000030B6 =
    {
        0x000030B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B6,
        0x000030B6,
        0x000030B6
    };

    static _CharacterInfo _character000030B7 =
    {
        0x000030B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B7,
        0x000030B7,
        0x000030B7
    };

    static Char _decompositionMapping000030B8[] = 
    {
        0x000030B7,
        0x00003099
    };

    static _CharacterInfo _character000030B8 =
    {
        0x000030B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B8,
        0x000030B8,
        0x000030B8
    };

    static _CharacterInfo _character000030B9 =
    {
        0x000030B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030B9,
        0x000030B9,
        0x000030B9
    };

    static Char _decompositionMapping000030BA[] = 
    {
        0x000030B9,
        0x00003099
    };

    static _CharacterInfo _character000030BA =
    {
        0x000030BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BA,
        0x000030BA,
        0x000030BA
    };

    static _CharacterInfo _character000030BB =
    {
        0x000030BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BB,
        0x000030BB,
        0x000030BB
    };

    static Char _decompositionMapping000030BC[] = 
    {
        0x000030BB,
        0x00003099
    };

    static _CharacterInfo _character000030BC =
    {
        0x000030BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BC,
        0x000030BC,
        0x000030BC
    };

    static _CharacterInfo _character000030BD =
    {
        0x000030BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BD,
        0x000030BD,
        0x000030BD
    };

    static Char _decompositionMapping000030BE[] = 
    {
        0x000030BD,
        0x00003099
    };

    static _CharacterInfo _character000030BE =
    {
        0x000030BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BE,
        0x000030BE,
        0x000030BE
    };

    static _CharacterInfo _character000030BF =
    {
        0x000030BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030BF,
        0x000030BF,
        0x000030BF
    };

    static Char _decompositionMapping000030C0[] = 
    {
        0x000030BF,
        0x00003099
    };

    static _CharacterInfo _character000030C0 =
    {
        0x000030C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C0,
        0x000030C0,
        0x000030C0
    };

    static _CharacterInfo _character000030C1 =
    {
        0x000030C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C1,
        0x000030C1,
        0x000030C1
    };

    static Char _decompositionMapping000030C2[] = 
    {
        0x000030C1,
        0x00003099
    };

    static _CharacterInfo _character000030C2 =
    {
        0x000030C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C2,
        0x000030C2,
        0x000030C2
    };

    static _CharacterInfo _character000030C3 =
    {
        0x000030C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C3,
        0x000030C3,
        0x000030C3
    };

    static _CharacterInfo _character000030C4 =
    {
        0x000030C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C4,
        0x000030C4,
        0x000030C4
    };

    static Char _decompositionMapping000030C5[] = 
    {
        0x000030C4,
        0x00003099
    };

    static _CharacterInfo _character000030C5 =
    {
        0x000030C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C5,
        0x000030C5,
        0x000030C5
    };

    static _CharacterInfo _character000030C6 =
    {
        0x000030C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C6,
        0x000030C6,
        0x000030C6
    };

    static Char _decompositionMapping000030C7[] = 
    {
        0x000030C6,
        0x00003099
    };

    static _CharacterInfo _character000030C7 =
    {
        0x000030C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C7,
        0x000030C7,
        0x000030C7
    };

    static _CharacterInfo _character000030C8 =
    {
        0x000030C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C8,
        0x000030C8,
        0x000030C8
    };

    static Char _decompositionMapping000030C9[] = 
    {
        0x000030C8,
        0x00003099
    };

    static _CharacterInfo _character000030C9 =
    {
        0x000030C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030C9,
        0x000030C9,
        0x000030C9
    };

    static _CharacterInfo _character000030CA =
    {
        0x000030CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CA,
        0x000030CA,
        0x000030CA
    };

    static _CharacterInfo _character000030CB =
    {
        0x000030CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CB,
        0x000030CB,
        0x000030CB
    };

    static _CharacterInfo _character000030CC =
    {
        0x000030CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CC,
        0x000030CC,
        0x000030CC
    };

    static _CharacterInfo _character000030CD =
    {
        0x000030CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CD,
        0x000030CD,
        0x000030CD
    };

    static _CharacterInfo _character000030CE =
    {
        0x000030CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CE,
        0x000030CE,
        0x000030CE
    };

    static _CharacterInfo _character000030CF =
    {
        0x000030CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030CF,
        0x000030CF,
        0x000030CF
    };

    static Char _decompositionMapping000030D0[] = 
    {
        0x000030CF,
        0x00003099
    };

    static _CharacterInfo _character000030D0 =
    {
        0x000030D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D0,
        0x000030D0,
        0x000030D0
    };

    static Char _decompositionMapping000030D1[] = 
    {
        0x000030CF,
        0x0000309A
    };

    static _CharacterInfo _character000030D1 =
    {
        0x000030D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D1,
        0x000030D1,
        0x000030D1
    };

    static _CharacterInfo _character000030D2 =
    {
        0x000030D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D2,
        0x000030D2,
        0x000030D2
    };

    static Char _decompositionMapping000030D3[] = 
    {
        0x000030D2,
        0x00003099
    };

    static _CharacterInfo _character000030D3 =
    {
        0x000030D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D3,
        0x000030D3,
        0x000030D3
    };

    static Char _decompositionMapping000030D4[] = 
    {
        0x000030D2,
        0x0000309A
    };

    static _CharacterInfo _character000030D4 =
    {
        0x000030D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D4,
        0x000030D4,
        0x000030D4
    };

    static _CharacterInfo _character000030D5 =
    {
        0x000030D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D5,
        0x000030D5,
        0x000030D5
    };

    static Char _decompositionMapping000030D6[] = 
    {
        0x000030D5,
        0x00003099
    };

    static _CharacterInfo _character000030D6 =
    {
        0x000030D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D6,
        0x000030D6,
        0x000030D6
    };

    static Char _decompositionMapping000030D7[] = 
    {
        0x000030D5,
        0x0000309A
    };

    static _CharacterInfo _character000030D7 =
    {
        0x000030D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D7,
        0x000030D7,
        0x000030D7
    };

    static _CharacterInfo _character000030D8 =
    {
        0x000030D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D8,
        0x000030D8,
        0x000030D8
    };

    static Char _decompositionMapping000030D9[] = 
    {
        0x000030D8,
        0x00003099
    };

    static _CharacterInfo _character000030D9 =
    {
        0x000030D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030D9,
        0x000030D9,
        0x000030D9
    };

    static Char _decompositionMapping000030DA[] = 
    {
        0x000030D8,
        0x0000309A
    };

    static _CharacterInfo _character000030DA =
    {
        0x000030DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DA,
        0x000030DA,
        0x000030DA
    };

    static _CharacterInfo _character000030DB =
    {
        0x000030DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DB,
        0x000030DB,
        0x000030DB
    };

    static Char _decompositionMapping000030DC[] = 
    {
        0x000030DB,
        0x00003099
    };

    static _CharacterInfo _character000030DC =
    {
        0x000030DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DC,
        0x000030DC,
        0x000030DC
    };

    static Char _decompositionMapping000030DD[] = 
    {
        0x000030DB,
        0x0000309A
    };

    static _CharacterInfo _character000030DD =
    {
        0x000030DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DD,
        0x000030DD,
        0x000030DD
    };

    static _CharacterInfo _character000030DE =
    {
        0x000030DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DE,
        0x000030DE,
        0x000030DE
    };

    static _CharacterInfo _character000030DF =
    {
        0x000030DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030DF,
        0x000030DF,
        0x000030DF
    };

    static _CharacterInfo _character000030E0 =
    {
        0x000030E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E0,
        0x000030E0,
        0x000030E0
    };

    static _CharacterInfo _character000030E1 =
    {
        0x000030E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E1,
        0x000030E1,
        0x000030E1
    };

    static _CharacterInfo _character000030E2 =
    {
        0x000030E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E2,
        0x000030E2,
        0x000030E2
    };

    static _CharacterInfo _character000030E3 =
    {
        0x000030E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E3,
        0x000030E3,
        0x000030E3
    };

    static _CharacterInfo _character000030E4 =
    {
        0x000030E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E4,
        0x000030E4,
        0x000030E4
    };

    static _CharacterInfo _character000030E5 =
    {
        0x000030E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E5,
        0x000030E5,
        0x000030E5
    };

    static _CharacterInfo _character000030E6 =
    {
        0x000030E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E6,
        0x000030E6,
        0x000030E6
    };

    static _CharacterInfo _character000030E7 =
    {
        0x000030E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E7,
        0x000030E7,
        0x000030E7
    };

    static _CharacterInfo _character000030E8 =
    {
        0x000030E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E8,
        0x000030E8,
        0x000030E8
    };

    static _CharacterInfo _character000030E9 =
    {
        0x000030E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030E9,
        0x000030E9,
        0x000030E9
    };

    static _CharacterInfo _character000030EA =
    {
        0x000030EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030EA,
        0x000030EA,
        0x000030EA
    };

    static _CharacterInfo _character000030EB =
    {
        0x000030EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030EB,
        0x000030EB,
        0x000030EB
    };

    static _CharacterInfo _character000030EC =
    {
        0x000030EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030EC,
        0x000030EC,
        0x000030EC
    };

    static _CharacterInfo _character000030ED =
    {
        0x000030ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030ED,
        0x000030ED,
        0x000030ED
    };

    static _CharacterInfo _character000030EE =
    {
        0x000030EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030EE,
        0x000030EE,
        0x000030EE
    };

    static _CharacterInfo _character000030EF =
    {
        0x000030EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030EF,
        0x000030EF,
        0x000030EF
    };

    static _CharacterInfo _character000030F0 =
    {
        0x000030F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F0,
        0x000030F0,
        0x000030F0
    };

    static _CharacterInfo _character000030F1 =
    {
        0x000030F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F1,
        0x000030F1,
        0x000030F1
    };

    static _CharacterInfo _character000030F2 =
    {
        0x000030F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F2,
        0x000030F2,
        0x000030F2
    };

    static _CharacterInfo _character000030F3 =
    {
        0x000030F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F3,
        0x000030F3,
        0x000030F3
    };

    static Char _decompositionMapping000030F4[] = 
    {
        0x000030A6,
        0x00003099
    };

    static _CharacterInfo _character000030F4 =
    {
        0x000030F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F4,
        0x000030F4,
        0x000030F4
    };

    static _CharacterInfo _character000030F5 =
    {
        0x000030F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F5,
        0x000030F5,
        0x000030F5
    };

    static _CharacterInfo _character000030F6 =
    {
        0x000030F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F6,
        0x000030F6,
        0x000030F6
    };

    static Char _decompositionMapping000030F7[] = 
    {
        0x000030EF,
        0x00003099
    };

    static _CharacterInfo _character000030F7 =
    {
        0x000030F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F7,
        0x000030F7,
        0x000030F7
    };

    static Char _decompositionMapping000030F8[] = 
    {
        0x000030F0,
        0x00003099
    };

    static _CharacterInfo _character000030F8 =
    {
        0x000030F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F8,
        0x000030F8,
        0x000030F8
    };

    static Char _decompositionMapping000030F9[] = 
    {
        0x000030F1,
        0x00003099
    };

    static _CharacterInfo _character000030F9 =
    {
        0x000030F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030F9,
        0x000030F9,
        0x000030F9
    };

    static Char _decompositionMapping000030FA[] = 
    {
        0x000030F2,
        0x00003099
    };

    static _CharacterInfo _character000030FA =
    {
        0x000030FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FA,
        0x000030FA,
        0x000030FA
    };

    static _CharacterInfo _character000030FB =
    {
        0x000030FB,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FB,
        0x000030FB,
        0x000030FB
    };

    static _CharacterInfo _character000030FC =
    {
        0x000030FC,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FC,
        0x000030FC,
        0x000030FC
    };

    static _CharacterInfo _character000030FD =
    {
        0x000030FD,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FD,
        0x000030FD,
        0x000030FD
    };

    static Char _decompositionMapping000030FE[] = 
    {
        0x000030FD,
        0x00003099
    };

    static _CharacterInfo _character000030FE =
    {
        0x000030FE,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping000030FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FE,
        0x000030FE,
        0x000030FE
    };

    static Char _decompositionMapping000030FF[] = 
    {
        0x000030B3,
        0x000030C8
    };

    static _CharacterInfo _character000030FF =
    {
        0x000030FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_vertical,
        2,
        _decompositionMapping000030FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000030FF,
        0x000030FF,
        0x000030FF
    };

    static _CharacterInfo _character00003105 =
    {
        0x00003105,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003105,
        0x00003105,
        0x00003105
    };

    static _CharacterInfo _character00003106 =
    {
        0x00003106,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003106,
        0x00003106,
        0x00003106
    };

    static _CharacterInfo _character00003107 =
    {
        0x00003107,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003107,
        0x00003107,
        0x00003107
    };

    static _CharacterInfo _character00003108 =
    {
        0x00003108,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003108,
        0x00003108,
        0x00003108
    };

    static _CharacterInfo _character00003109 =
    {
        0x00003109,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003109,
        0x00003109,
        0x00003109
    };

    static _CharacterInfo _character0000310A =
    {
        0x0000310A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310A,
        0x0000310A,
        0x0000310A
    };

    static _CharacterInfo _character0000310B =
    {
        0x0000310B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310B,
        0x0000310B,
        0x0000310B
    };

    static _CharacterInfo _character0000310C =
    {
        0x0000310C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310C,
        0x0000310C,
        0x0000310C
    };

    static _CharacterInfo _character0000310D =
    {
        0x0000310D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310D,
        0x0000310D,
        0x0000310D
    };

    static _CharacterInfo _character0000310E =
    {
        0x0000310E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310E,
        0x0000310E,
        0x0000310E
    };

    static _CharacterInfo _character0000310F =
    {
        0x0000310F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000310F,
        0x0000310F,
        0x0000310F
    };

    static _CharacterInfo _character00003110 =
    {
        0x00003110,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003110,
        0x00003110,
        0x00003110
    };

    static _CharacterInfo _character00003111 =
    {
        0x00003111,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003111,
        0x00003111,
        0x00003111
    };

    static _CharacterInfo _character00003112 =
    {
        0x00003112,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003112,
        0x00003112,
        0x00003112
    };

    static _CharacterInfo _character00003113 =
    {
        0x00003113,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003113,
        0x00003113,
        0x00003113
    };

    static _CharacterInfo _character00003114 =
    {
        0x00003114,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003114,
        0x00003114,
        0x00003114
    };

    static _CharacterInfo _character00003115 =
    {
        0x00003115,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003115,
        0x00003115,
        0x00003115
    };

    static _CharacterInfo _character00003116 =
    {
        0x00003116,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003116,
        0x00003116,
        0x00003116
    };

    static _CharacterInfo _character00003117 =
    {
        0x00003117,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003117,
        0x00003117,
        0x00003117
    };

    static _CharacterInfo _character00003118 =
    {
        0x00003118,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003118,
        0x00003118,
        0x00003118
    };

    static _CharacterInfo _character00003119 =
    {
        0x00003119,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003119,
        0x00003119,
        0x00003119
    };

    static _CharacterInfo _character0000311A =
    {
        0x0000311A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311A,
        0x0000311A,
        0x0000311A
    };

    static _CharacterInfo _character0000311B =
    {
        0x0000311B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311B,
        0x0000311B,
        0x0000311B
    };

    static _CharacterInfo _character0000311C =
    {
        0x0000311C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311C,
        0x0000311C,
        0x0000311C
    };

    static _CharacterInfo _character0000311D =
    {
        0x0000311D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311D,
        0x0000311D,
        0x0000311D
    };

    static _CharacterInfo _character0000311E =
    {
        0x0000311E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311E,
        0x0000311E,
        0x0000311E
    };

    static _CharacterInfo _character0000311F =
    {
        0x0000311F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000311F,
        0x0000311F,
        0x0000311F
    };

    static _CharacterInfo _character00003120 =
    {
        0x00003120,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003120,
        0x00003120,
        0x00003120
    };

    static _CharacterInfo _character00003121 =
    {
        0x00003121,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003121,
        0x00003121,
        0x00003121
    };

    static _CharacterInfo _character00003122 =
    {
        0x00003122,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003122,
        0x00003122,
        0x00003122
    };

    static _CharacterInfo _character00003123 =
    {
        0x00003123,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003123,
        0x00003123,
        0x00003123
    };

    static _CharacterInfo _character00003124 =
    {
        0x00003124,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003124,
        0x00003124,
        0x00003124
    };

    static _CharacterInfo _character00003125 =
    {
        0x00003125,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003125,
        0x00003125,
        0x00003125
    };

    static _CharacterInfo _character00003126 =
    {
        0x00003126,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003126,
        0x00003126,
        0x00003126
    };

    static _CharacterInfo _character00003127 =
    {
        0x00003127,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003127,
        0x00003127,
        0x00003127
    };

    static _CharacterInfo _character00003128 =
    {
        0x00003128,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003128,
        0x00003128,
        0x00003128
    };

    static _CharacterInfo _character00003129 =
    {
        0x00003129,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003129,
        0x00003129,
        0x00003129
    };

    static _CharacterInfo _character0000312A =
    {
        0x0000312A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000312A,
        0x0000312A,
        0x0000312A
    };

    static _CharacterInfo _character0000312B =
    {
        0x0000312B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000312B,
        0x0000312B,
        0x0000312B
    };

    static _CharacterInfo _character0000312C =
    {
        0x0000312C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000312C,
        0x0000312C,
        0x0000312C
    };

    static Char _decompositionMapping00003131[] = 
    {
        0x00001100
    };

    static _CharacterInfo _character00003131 =
    {
        0x00003131,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003131,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003131,
        0x00003131,
        0x00003131
    };

    static Char _decompositionMapping00003132[] = 
    {
        0x00001101
    };

    static _CharacterInfo _character00003132 =
    {
        0x00003132,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003132,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003132,
        0x00003132,
        0x00003132
    };

    static Char _decompositionMapping00003133[] = 
    {
        0x000011AA
    };

    static _CharacterInfo _character00003133 =
    {
        0x00003133,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003133,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003133,
        0x00003133,
        0x00003133
    };

    static Char _decompositionMapping00003134[] = 
    {
        0x00001102
    };

    static _CharacterInfo _character00003134 =
    {
        0x00003134,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003134,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003134,
        0x00003134,
        0x00003134
    };

    static Char _decompositionMapping00003135[] = 
    {
        0x000011AC
    };

    static _CharacterInfo _character00003135 =
    {
        0x00003135,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003135,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003135,
        0x00003135,
        0x00003135
    };

    static Char _decompositionMapping00003136[] = 
    {
        0x000011AD
    };

    static _CharacterInfo _character00003136 =
    {
        0x00003136,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003136,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003136,
        0x00003136,
        0x00003136
    };

    static Char _decompositionMapping00003137[] = 
    {
        0x00001103
    };

    static _CharacterInfo _character00003137 =
    {
        0x00003137,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003137,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003137,
        0x00003137,
        0x00003137
    };

    static Char _decompositionMapping00003138[] = 
    {
        0x00001104
    };

    static _CharacterInfo _character00003138 =
    {
        0x00003138,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003138,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003138,
        0x00003138,
        0x00003138
    };

    static Char _decompositionMapping00003139[] = 
    {
        0x00001105
    };

    static _CharacterInfo _character00003139 =
    {
        0x00003139,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003139,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003139,
        0x00003139,
        0x00003139
    };

    static Char _decompositionMapping0000313A[] = 
    {
        0x000011B0
    };

    static _CharacterInfo _character0000313A =
    {
        0x0000313A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313A,
        0x0000313A,
        0x0000313A
    };

    static Char _decompositionMapping0000313B[] = 
    {
        0x000011B1
    };

    static _CharacterInfo _character0000313B =
    {
        0x0000313B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313B,
        0x0000313B,
        0x0000313B
    };

    static Char _decompositionMapping0000313C[] = 
    {
        0x000011B2
    };

    static _CharacterInfo _character0000313C =
    {
        0x0000313C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313C,
        0x0000313C,
        0x0000313C
    };

    static Char _decompositionMapping0000313D[] = 
    {
        0x000011B3
    };

    static _CharacterInfo _character0000313D =
    {
        0x0000313D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313D,
        0x0000313D,
        0x0000313D
    };

    static Char _decompositionMapping0000313E[] = 
    {
        0x000011B4
    };

    static _CharacterInfo _character0000313E =
    {
        0x0000313E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313E,
        0x0000313E,
        0x0000313E
    };

    static Char _decompositionMapping0000313F[] = 
    {
        0x000011B5
    };

    static _CharacterInfo _character0000313F =
    {
        0x0000313F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000313F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000313F,
        0x0000313F,
        0x0000313F
    };

    static Char _decompositionMapping00003140[] = 
    {
        0x0000111A
    };

    static _CharacterInfo _character00003140 =
    {
        0x00003140,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003140,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003140,
        0x00003140,
        0x00003140
    };

    static Char _decompositionMapping00003141[] = 
    {
        0x00001106
    };

    static _CharacterInfo _character00003141 =
    {
        0x00003141,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003141,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003141,
        0x00003141,
        0x00003141
    };

    static Char _decompositionMapping00003142[] = 
    {
        0x00001107
    };

    static _CharacterInfo _character00003142 =
    {
        0x00003142,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003142,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003142,
        0x00003142,
        0x00003142
    };

    static Char _decompositionMapping00003143[] = 
    {
        0x00001108
    };

    static _CharacterInfo _character00003143 =
    {
        0x00003143,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003143,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003143,
        0x00003143,
        0x00003143
    };

    static Char _decompositionMapping00003144[] = 
    {
        0x00001121
    };

    static _CharacterInfo _character00003144 =
    {
        0x00003144,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003144,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003144,
        0x00003144,
        0x00003144
    };

    static Char _decompositionMapping00003145[] = 
    {
        0x00001109
    };

    static _CharacterInfo _character00003145 =
    {
        0x00003145,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003145,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003145,
        0x00003145,
        0x00003145
    };

    static Char _decompositionMapping00003146[] = 
    {
        0x0000110A
    };

    static _CharacterInfo _character00003146 =
    {
        0x00003146,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003146,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003146,
        0x00003146,
        0x00003146
    };

    static Char _decompositionMapping00003147[] = 
    {
        0x0000110B
    };

    static _CharacterInfo _character00003147 =
    {
        0x00003147,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003147,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003147,
        0x00003147,
        0x00003147
    };

    static Char _decompositionMapping00003148[] = 
    {
        0x0000110C
    };

    static _CharacterInfo _character00003148 =
    {
        0x00003148,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003148,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003148,
        0x00003148,
        0x00003148
    };

    static Char _decompositionMapping00003149[] = 
    {
        0x0000110D
    };

    static _CharacterInfo _character00003149 =
    {
        0x00003149,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003149,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003149,
        0x00003149,
        0x00003149
    };

    static Char _decompositionMapping0000314A[] = 
    {
        0x0000110E
    };

    static _CharacterInfo _character0000314A =
    {
        0x0000314A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314A,
        0x0000314A,
        0x0000314A
    };

    static Char _decompositionMapping0000314B[] = 
    {
        0x0000110F
    };

    static _CharacterInfo _character0000314B =
    {
        0x0000314B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314B,
        0x0000314B,
        0x0000314B
    };

    static Char _decompositionMapping0000314C[] = 
    {
        0x00001110
    };

    static _CharacterInfo _character0000314C =
    {
        0x0000314C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314C,
        0x0000314C,
        0x0000314C
    };

    static Char _decompositionMapping0000314D[] = 
    {
        0x00001111
    };

    static _CharacterInfo _character0000314D =
    {
        0x0000314D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314D,
        0x0000314D,
        0x0000314D
    };

    static Char _decompositionMapping0000314E[] = 
    {
        0x00001112
    };

    static _CharacterInfo _character0000314E =
    {
        0x0000314E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314E,
        0x0000314E,
        0x0000314E
    };

    static Char _decompositionMapping0000314F[] = 
    {
        0x00001161
    };

    static _CharacterInfo _character0000314F =
    {
        0x0000314F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000314F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000314F,
        0x0000314F,
        0x0000314F
    };

    static Char _decompositionMapping00003150[] = 
    {
        0x00001162
    };

    static _CharacterInfo _character00003150 =
    {
        0x00003150,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003150,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003150,
        0x00003150,
        0x00003150
    };

    static Char _decompositionMapping00003151[] = 
    {
        0x00001163
    };

    static _CharacterInfo _character00003151 =
    {
        0x00003151,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003151,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003151,
        0x00003151,
        0x00003151
    };

    static Char _decompositionMapping00003152[] = 
    {
        0x00001164
    };

    static _CharacterInfo _character00003152 =
    {
        0x00003152,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003152,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003152,
        0x00003152,
        0x00003152
    };

    static Char _decompositionMapping00003153[] = 
    {
        0x00001165
    };

    static _CharacterInfo _character00003153 =
    {
        0x00003153,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003153,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003153,
        0x00003153,
        0x00003153
    };

    static Char _decompositionMapping00003154[] = 
    {
        0x00001166
    };

    static _CharacterInfo _character00003154 =
    {
        0x00003154,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003154,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003154,
        0x00003154,
        0x00003154
    };

    static Char _decompositionMapping00003155[] = 
    {
        0x00001167
    };

    static _CharacterInfo _character00003155 =
    {
        0x00003155,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003155,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003155,
        0x00003155,
        0x00003155
    };

    static Char _decompositionMapping00003156[] = 
    {
        0x00001168
    };

    static _CharacterInfo _character00003156 =
    {
        0x00003156,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003156,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003156,
        0x00003156,
        0x00003156
    };

    static Char _decompositionMapping00003157[] = 
    {
        0x00001169
    };

    static _CharacterInfo _character00003157 =
    {
        0x00003157,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003157,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003157,
        0x00003157,
        0x00003157
    };

    static Char _decompositionMapping00003158[] = 
    {
        0x0000116A
    };

    static _CharacterInfo _character00003158 =
    {
        0x00003158,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003158,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003158,
        0x00003158,
        0x00003158
    };

    static Char _decompositionMapping00003159[] = 
    {
        0x0000116B
    };

    static _CharacterInfo _character00003159 =
    {
        0x00003159,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003159,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003159,
        0x00003159,
        0x00003159
    };

    static Char _decompositionMapping0000315A[] = 
    {
        0x0000116C
    };

    static _CharacterInfo _character0000315A =
    {
        0x0000315A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315A,
        0x0000315A,
        0x0000315A
    };

    static Char _decompositionMapping0000315B[] = 
    {
        0x0000116D
    };

    static _CharacterInfo _character0000315B =
    {
        0x0000315B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315B,
        0x0000315B,
        0x0000315B
    };

    static Char _decompositionMapping0000315C[] = 
    {
        0x0000116E
    };

    static _CharacterInfo _character0000315C =
    {
        0x0000315C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315C,
        0x0000315C,
        0x0000315C
    };

    static Char _decompositionMapping0000315D[] = 
    {
        0x0000116F
    };

    static _CharacterInfo _character0000315D =
    {
        0x0000315D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315D,
        0x0000315D,
        0x0000315D
    };

    static Char _decompositionMapping0000315E[] = 
    {
        0x00001170
    };

    static _CharacterInfo _character0000315E =
    {
        0x0000315E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315E,
        0x0000315E,
        0x0000315E
    };

    static Char _decompositionMapping0000315F[] = 
    {
        0x00001171
    };

    static _CharacterInfo _character0000315F =
    {
        0x0000315F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000315F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000315F,
        0x0000315F,
        0x0000315F
    };

    static Char _decompositionMapping00003160[] = 
    {
        0x00001172
    };

    static _CharacterInfo _character00003160 =
    {
        0x00003160,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003160,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003160,
        0x00003160,
        0x00003160
    };

    static Char _decompositionMapping00003161[] = 
    {
        0x00001173
    };

    static _CharacterInfo _character00003161 =
    {
        0x00003161,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003161,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003161,
        0x00003161,
        0x00003161
    };

    static Char _decompositionMapping00003162[] = 
    {
        0x00001174
    };

    static _CharacterInfo _character00003162 =
    {
        0x00003162,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003162,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003162,
        0x00003162,
        0x00003162
    };

    static Char _decompositionMapping00003163[] = 
    {
        0x00001175
    };

    static _CharacterInfo _character00003163 =
    {
        0x00003163,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003163,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003163,
        0x00003163,
        0x00003163
    };

    static Char _decompositionMapping00003164[] = 
    {
        0x00001160
    };

    static _CharacterInfo _character00003164 =
    {
        0x00003164,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003164,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003164,
        0x00003164,
        0x00003164
    };

    static Char _decompositionMapping00003165[] = 
    {
        0x00001114
    };

    static _CharacterInfo _character00003165 =
    {
        0x00003165,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003165,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003165,
        0x00003165,
        0x00003165
    };

    static Char _decompositionMapping00003166[] = 
    {
        0x00001115
    };

    static _CharacterInfo _character00003166 =
    {
        0x00003166,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003166,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003166,
        0x00003166,
        0x00003166
    };

    static Char _decompositionMapping00003167[] = 
    {
        0x000011C7
    };

    static _CharacterInfo _character00003167 =
    {
        0x00003167,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003167,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003167,
        0x00003167,
        0x00003167
    };

    static Char _decompositionMapping00003168[] = 
    {
        0x000011C8
    };

    static _CharacterInfo _character00003168 =
    {
        0x00003168,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003168,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003168,
        0x00003168,
        0x00003168
    };

    static Char _decompositionMapping00003169[] = 
    {
        0x000011CC
    };

    static _CharacterInfo _character00003169 =
    {
        0x00003169,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003169,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003169,
        0x00003169,
        0x00003169
    };

    static Char _decompositionMapping0000316A[] = 
    {
        0x000011CE
    };

    static _CharacterInfo _character0000316A =
    {
        0x0000316A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316A,
        0x0000316A,
        0x0000316A
    };

    static Char _decompositionMapping0000316B[] = 
    {
        0x000011D3
    };

    static _CharacterInfo _character0000316B =
    {
        0x0000316B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316B,
        0x0000316B,
        0x0000316B
    };

    static Char _decompositionMapping0000316C[] = 
    {
        0x000011D7
    };

    static _CharacterInfo _character0000316C =
    {
        0x0000316C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316C,
        0x0000316C,
        0x0000316C
    };

    static Char _decompositionMapping0000316D[] = 
    {
        0x000011D9
    };

    static _CharacterInfo _character0000316D =
    {
        0x0000316D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316D,
        0x0000316D,
        0x0000316D
    };

    static Char _decompositionMapping0000316E[] = 
    {
        0x0000111C
    };

    static _CharacterInfo _character0000316E =
    {
        0x0000316E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316E,
        0x0000316E,
        0x0000316E
    };

    static Char _decompositionMapping0000316F[] = 
    {
        0x000011DD
    };

    static _CharacterInfo _character0000316F =
    {
        0x0000316F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000316F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000316F,
        0x0000316F,
        0x0000316F
    };

    static Char _decompositionMapping00003170[] = 
    {
        0x000011DF
    };

    static _CharacterInfo _character00003170 =
    {
        0x00003170,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003170,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003170,
        0x00003170,
        0x00003170
    };

    static Char _decompositionMapping00003171[] = 
    {
        0x0000111D
    };

    static _CharacterInfo _character00003171 =
    {
        0x00003171,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003171,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003171,
        0x00003171,
        0x00003171
    };

    static Char _decompositionMapping00003172[] = 
    {
        0x0000111E
    };

    static _CharacterInfo _character00003172 =
    {
        0x00003172,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003172,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003172,
        0x00003172,
        0x00003172
    };

    static Char _decompositionMapping00003173[] = 
    {
        0x00001120
    };

    static _CharacterInfo _character00003173 =
    {
        0x00003173,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003173,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003173,
        0x00003173,
        0x00003173
    };

    static Char _decompositionMapping00003174[] = 
    {
        0x00001122
    };

    static _CharacterInfo _character00003174 =
    {
        0x00003174,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003174,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003174,
        0x00003174,
        0x00003174
    };

    static Char _decompositionMapping00003175[] = 
    {
        0x00001123
    };

    static _CharacterInfo _character00003175 =
    {
        0x00003175,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003175,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003175,
        0x00003175,
        0x00003175
    };

    static Char _decompositionMapping00003176[] = 
    {
        0x00001127
    };

    static _CharacterInfo _character00003176 =
    {
        0x00003176,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003176,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003176,
        0x00003176,
        0x00003176
    };

    static Char _decompositionMapping00003177[] = 
    {
        0x00001129
    };

    static _CharacterInfo _character00003177 =
    {
        0x00003177,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003177,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003177,
        0x00003177,
        0x00003177
    };

    static Char _decompositionMapping00003178[] = 
    {
        0x0000112B
    };

    static _CharacterInfo _character00003178 =
    {
        0x00003178,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003178,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003178,
        0x00003178,
        0x00003178
    };

    static Char _decompositionMapping00003179[] = 
    {
        0x0000112C
    };

    static _CharacterInfo _character00003179 =
    {
        0x00003179,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003179,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003179,
        0x00003179,
        0x00003179
    };

    static Char _decompositionMapping0000317A[] = 
    {
        0x0000112D
    };

    static _CharacterInfo _character0000317A =
    {
        0x0000317A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317A,
        0x0000317A,
        0x0000317A
    };

    static Char _decompositionMapping0000317B[] = 
    {
        0x0000112E
    };

    static _CharacterInfo _character0000317B =
    {
        0x0000317B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317B,
        0x0000317B,
        0x0000317B
    };

    static Char _decompositionMapping0000317C[] = 
    {
        0x0000112F
    };

    static _CharacterInfo _character0000317C =
    {
        0x0000317C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317C,
        0x0000317C,
        0x0000317C
    };

    static Char _decompositionMapping0000317D[] = 
    {
        0x00001132
    };

    static _CharacterInfo _character0000317D =
    {
        0x0000317D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317D,
        0x0000317D,
        0x0000317D
    };

    static Char _decompositionMapping0000317E[] = 
    {
        0x00001136
    };

    static _CharacterInfo _character0000317E =
    {
        0x0000317E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317E,
        0x0000317E,
        0x0000317E
    };

    static Char _decompositionMapping0000317F[] = 
    {
        0x00001140
    };

    static _CharacterInfo _character0000317F =
    {
        0x0000317F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000317F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000317F,
        0x0000317F,
        0x0000317F
    };

    static Char _decompositionMapping00003180[] = 
    {
        0x00001147
    };

    static _CharacterInfo _character00003180 =
    {
        0x00003180,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003180,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003180,
        0x00003180,
        0x00003180
    };

    static Char _decompositionMapping00003181[] = 
    {
        0x0000114C
    };

    static _CharacterInfo _character00003181 =
    {
        0x00003181,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003181,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003181,
        0x00003181,
        0x00003181
    };

    static Char _decompositionMapping00003182[] = 
    {
        0x000011F1
    };

    static _CharacterInfo _character00003182 =
    {
        0x00003182,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003182,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003182,
        0x00003182,
        0x00003182
    };

    static Char _decompositionMapping00003183[] = 
    {
        0x000011F2
    };

    static _CharacterInfo _character00003183 =
    {
        0x00003183,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003183,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003183,
        0x00003183,
        0x00003183
    };

    static Char _decompositionMapping00003184[] = 
    {
        0x00001157
    };

    static _CharacterInfo _character00003184 =
    {
        0x00003184,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003184,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003184,
        0x00003184,
        0x00003184
    };

    static Char _decompositionMapping00003185[] = 
    {
        0x00001158
    };

    static _CharacterInfo _character00003185 =
    {
        0x00003185,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003185,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003185,
        0x00003185,
        0x00003185
    };

    static Char _decompositionMapping00003186[] = 
    {
        0x00001159
    };

    static _CharacterInfo _character00003186 =
    {
        0x00003186,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003186,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003186,
        0x00003186,
        0x00003186
    };

    static Char _decompositionMapping00003187[] = 
    {
        0x00001184
    };

    static _CharacterInfo _character00003187 =
    {
        0x00003187,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003187,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003187,
        0x00003187,
        0x00003187
    };

    static Char _decompositionMapping00003188[] = 
    {
        0x00001185
    };

    static _CharacterInfo _character00003188 =
    {
        0x00003188,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003188,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003188,
        0x00003188,
        0x00003188
    };

    static Char _decompositionMapping00003189[] = 
    {
        0x00001188
    };

    static _CharacterInfo _character00003189 =
    {
        0x00003189,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping00003189,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003189,
        0x00003189,
        0x00003189
    };

    static Char _decompositionMapping0000318A[] = 
    {
        0x00001191
    };

    static _CharacterInfo _character0000318A =
    {
        0x0000318A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000318A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000318A,
        0x0000318A,
        0x0000318A
    };

    static Char _decompositionMapping0000318B[] = 
    {
        0x00001192
    };

    static _CharacterInfo _character0000318B =
    {
        0x0000318B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000318B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000318B,
        0x0000318B,
        0x0000318B
    };

    static Char _decompositionMapping0000318C[] = 
    {
        0x00001194
    };

    static _CharacterInfo _character0000318C =
    {
        0x0000318C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000318C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000318C,
        0x0000318C,
        0x0000318C
    };

    static Char _decompositionMapping0000318D[] = 
    {
        0x0000119E
    };

    static _CharacterInfo _character0000318D =
    {
        0x0000318D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000318D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000318D,
        0x0000318D,
        0x0000318D
    };

    static Char _decompositionMapping0000318E[] = 
    {
        0x000011A1
    };

    static _CharacterInfo _character0000318E =
    {
        0x0000318E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000318E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000318E,
        0x0000318E,
        0x0000318E
    };

    static _CharacterInfo _character00003190 =
    {
        0x00003190,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003190,
        0x00003190,
        0x00003190
    };

    static _CharacterInfo _character00003191 =
    {
        0x00003191,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003191,
        0x00003191,
        0x00003191
    };

    static Char _decompositionMapping00003192[] = 
    {
        0x00004E00
    };

    static _CharacterInfo _character00003192 =
    {
        0x00003192,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003192,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00003192,
        0x00003192,
        0x00003192
    };

    static Char _decompositionMapping00003193[] = 
    {
        0x00004E8C
    };

    static _CharacterInfo _character00003193 =
    {
        0x00003193,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003193,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00003193,
        0x00003193,
        0x00003193
    };

    static Char _decompositionMapping00003194[] = 
    {
        0x00004E09
    };

    static _CharacterInfo _character00003194 =
    {
        0x00003194,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003194,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00003194,
        0x00003194,
        0x00003194
    };

    static Char _decompositionMapping00003195[] = 
    {
        0x000056DB
    };

    static _CharacterInfo _character00003195 =
    {
        0x00003195,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003195,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00003195,
        0x00003195,
        0x00003195
    };

    static Char _decompositionMapping00003196[] = 
    {
        0x00004E0A
    };

    static _CharacterInfo _character00003196 =
    {
        0x00003196,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003196,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003196,
        0x00003196,
        0x00003196
    };

    static Char _decompositionMapping00003197[] = 
    {
        0x00004E2D
    };

    static _CharacterInfo _character00003197 =
    {
        0x00003197,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003197,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003197,
        0x00003197,
        0x00003197
    };

    static Char _decompositionMapping00003198[] = 
    {
        0x00004E0B
    };

    static _CharacterInfo _character00003198 =
    {
        0x00003198,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003198,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003198,
        0x00003198,
        0x00003198
    };

    static Char _decompositionMapping00003199[] = 
    {
        0x00007532
    };

    static _CharacterInfo _character00003199 =
    {
        0x00003199,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping00003199,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003199,
        0x00003199,
        0x00003199
    };

    static Char _decompositionMapping0000319A[] = 
    {
        0x00004E59
    };

    static _CharacterInfo _character0000319A =
    {
        0x0000319A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319A,
        0x0000319A,
        0x0000319A
    };

    static Char _decompositionMapping0000319B[] = 
    {
        0x00004E19
    };

    static _CharacterInfo _character0000319B =
    {
        0x0000319B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319B,
        0x0000319B,
        0x0000319B
    };

    static Char _decompositionMapping0000319C[] = 
    {
        0x00004E01
    };

    static _CharacterInfo _character0000319C =
    {
        0x0000319C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319C,
        0x0000319C,
        0x0000319C
    };

    static Char _decompositionMapping0000319D[] = 
    {
        0x00005929
    };

    static _CharacterInfo _character0000319D =
    {
        0x0000319D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319D,
        0x0000319D,
        0x0000319D
    };

    static Char _decompositionMapping0000319E[] = 
    {
        0x00005730
    };

    static _CharacterInfo _character0000319E =
    {
        0x0000319E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319E,
        0x0000319E,
        0x0000319E
    };

    static Char _decompositionMapping0000319F[] = 
    {
        0x00004EBA
    };

    static _CharacterInfo _character0000319F =
    {
        0x0000319F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_super,
        1,
        _decompositionMapping0000319F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000319F,
        0x0000319F,
        0x0000319F
    };

    static _CharacterInfo _character000031A0 =
    {
        0x000031A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A0,
        0x000031A0,
        0x000031A0
    };

    static _CharacterInfo _character000031A1 =
    {
        0x000031A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A1,
        0x000031A1,
        0x000031A1
    };

    static _CharacterInfo _character000031A2 =
    {
        0x000031A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A2,
        0x000031A2,
        0x000031A2
    };

    static _CharacterInfo _character000031A3 =
    {
        0x000031A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A3,
        0x000031A3,
        0x000031A3
    };

    static _CharacterInfo _character000031A4 =
    {
        0x000031A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A4,
        0x000031A4,
        0x000031A4
    };

    static _CharacterInfo _character000031A5 =
    {
        0x000031A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A5,
        0x000031A5,
        0x000031A5
    };

    static _CharacterInfo _character000031A6 =
    {
        0x000031A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A6,
        0x000031A6,
        0x000031A6
    };

    static _CharacterInfo _character000031A7 =
    {
        0x000031A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A7,
        0x000031A7,
        0x000031A7
    };

    static _CharacterInfo _character000031A8 =
    {
        0x000031A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A8,
        0x000031A8,
        0x000031A8
    };

    static _CharacterInfo _character000031A9 =
    {
        0x000031A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031A9,
        0x000031A9,
        0x000031A9
    };

    static _CharacterInfo _character000031AA =
    {
        0x000031AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AA,
        0x000031AA,
        0x000031AA
    };

    static _CharacterInfo _character000031AB =
    {
        0x000031AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AB,
        0x000031AB,
        0x000031AB
    };

    static _CharacterInfo _character000031AC =
    {
        0x000031AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AC,
        0x000031AC,
        0x000031AC
    };

    static _CharacterInfo _character000031AD =
    {
        0x000031AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AD,
        0x000031AD,
        0x000031AD
    };

    static _CharacterInfo _character000031AE =
    {
        0x000031AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AE,
        0x000031AE,
        0x000031AE
    };

    static _CharacterInfo _character000031AF =
    {
        0x000031AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031AF,
        0x000031AF,
        0x000031AF
    };

    static _CharacterInfo _character000031B0 =
    {
        0x000031B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B0,
        0x000031B0,
        0x000031B0
    };

    static _CharacterInfo _character000031B1 =
    {
        0x000031B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B1,
        0x000031B1,
        0x000031B1
    };

    static _CharacterInfo _character000031B2 =
    {
        0x000031B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B2,
        0x000031B2,
        0x000031B2
    };

    static _CharacterInfo _character000031B3 =
    {
        0x000031B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B3,
        0x000031B3,
        0x000031B3
    };

    static _CharacterInfo _character000031B4 =
    {
        0x000031B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B4,
        0x000031B4,
        0x000031B4
    };

    static _CharacterInfo _character000031B5 =
    {
        0x000031B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B5,
        0x000031B5,
        0x000031B5
    };

    static _CharacterInfo _character000031B6 =
    {
        0x000031B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B6,
        0x000031B6,
        0x000031B6
    };

    static _CharacterInfo _character000031B7 =
    {
        0x000031B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031B7,
        0x000031B7,
        0x000031B7
    };

    static _CharacterInfo _character000031C0 =
    {
        0x000031C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C0,
        0x000031C0,
        0x000031C0
    };

    static _CharacterInfo _character000031C1 =
    {
        0x000031C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C1,
        0x000031C1,
        0x000031C1
    };

    static _CharacterInfo _character000031C2 =
    {
        0x000031C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C2,
        0x000031C2,
        0x000031C2
    };

    static _CharacterInfo _character000031C3 =
    {
        0x000031C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C3,
        0x000031C3,
        0x000031C3
    };

    static _CharacterInfo _character000031C4 =
    {
        0x000031C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C4,
        0x000031C4,
        0x000031C4
    };

    static _CharacterInfo _character000031C5 =
    {
        0x000031C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C5,
        0x000031C5,
        0x000031C5
    };

    static _CharacterInfo _character000031C6 =
    {
        0x000031C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C6,
        0x000031C6,
        0x000031C6
    };

    static _CharacterInfo _character000031C7 =
    {
        0x000031C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C7,
        0x000031C7,
        0x000031C7
    };

    static _CharacterInfo _character000031C8 =
    {
        0x000031C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C8,
        0x000031C8,
        0x000031C8
    };

    static _CharacterInfo _character000031C9 =
    {
        0x000031C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031C9,
        0x000031C9,
        0x000031C9
    };

    static _CharacterInfo _character000031CA =
    {
        0x000031CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CA,
        0x000031CA,
        0x000031CA
    };

    static _CharacterInfo _character000031CB =
    {
        0x000031CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CB,
        0x000031CB,
        0x000031CB
    };

    static _CharacterInfo _character000031CC =
    {
        0x000031CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CC,
        0x000031CC,
        0x000031CC
    };

    static _CharacterInfo _character000031CD =
    {
        0x000031CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CD,
        0x000031CD,
        0x000031CD
    };

    static _CharacterInfo _character000031CE =
    {
        0x000031CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CE,
        0x000031CE,
        0x000031CE
    };

    static _CharacterInfo _character000031CF =
    {
        0x000031CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031CF,
        0x000031CF,
        0x000031CF
    };

    static _CharacterInfo _character000031F0 =
    {
        0x000031F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F0,
        0x000031F0,
        0x000031F0
    };

    static _CharacterInfo _character000031F1 =
    {
        0x000031F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F1,
        0x000031F1,
        0x000031F1
    };

    static _CharacterInfo _character000031F2 =
    {
        0x000031F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F2,
        0x000031F2,
        0x000031F2
    };

    static _CharacterInfo _character000031F3 =
    {
        0x000031F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F3,
        0x000031F3,
        0x000031F3
    };

    static _CharacterInfo _character000031F4 =
    {
        0x000031F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F4,
        0x000031F4,
        0x000031F4
    };

    static _CharacterInfo _character000031F5 =
    {
        0x000031F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F5,
        0x000031F5,
        0x000031F5
    };

    static _CharacterInfo _character000031F6 =
    {
        0x000031F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F6,
        0x000031F6,
        0x000031F6
    };

    static _CharacterInfo _character000031F7 =
    {
        0x000031F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F7,
        0x000031F7,
        0x000031F7
    };

    static _CharacterInfo _character000031F8 =
    {
        0x000031F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F8,
        0x000031F8,
        0x000031F8
    };

    static _CharacterInfo _character000031F9 =
    {
        0x000031F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031F9,
        0x000031F9,
        0x000031F9
    };

    static _CharacterInfo _character000031FA =
    {
        0x000031FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FA,
        0x000031FA,
        0x000031FA
    };

    static _CharacterInfo _character000031FB =
    {
        0x000031FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FB,
        0x000031FB,
        0x000031FB
    };

    static _CharacterInfo _character000031FC =
    {
        0x000031FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FC,
        0x000031FC,
        0x000031FC
    };

    static _CharacterInfo _character000031FD =
    {
        0x000031FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FD,
        0x000031FD,
        0x000031FD
    };

    static _CharacterInfo _character000031FE =
    {
        0x000031FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FE,
        0x000031FE,
        0x000031FE
    };

    static _CharacterInfo _character000031FF =
    {
        0x000031FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000031FF,
        0x000031FF,
        0x000031FF
    };

    static Char _decompositionMapping00003200[] = 
    {
        0x00000028,
        0x00001100,
        0x00000029
    };

    static _CharacterInfo _character00003200 =
    {
        0x00003200,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003200,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003200,
        0x00003200,
        0x00003200
    };

    static Char _decompositionMapping00003201[] = 
    {
        0x00000028,
        0x00001102,
        0x00000029
    };

    static _CharacterInfo _character00003201 =
    {
        0x00003201,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003201,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003201,
        0x00003201,
        0x00003201
    };

    static Char _decompositionMapping00003202[] = 
    {
        0x00000028,
        0x00001103,
        0x00000029
    };

    static _CharacterInfo _character00003202 =
    {
        0x00003202,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003202,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003202,
        0x00003202,
        0x00003202
    };

    static Char _decompositionMapping00003203[] = 
    {
        0x00000028,
        0x00001105,
        0x00000029
    };

    static _CharacterInfo _character00003203 =
    {
        0x00003203,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003203,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003203,
        0x00003203,
        0x00003203
    };

    static Char _decompositionMapping00003204[] = 
    {
        0x00000028,
        0x00001106,
        0x00000029
    };

    static _CharacterInfo _character00003204 =
    {
        0x00003204,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003204,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003204,
        0x00003204,
        0x00003204
    };

    static Char _decompositionMapping00003205[] = 
    {
        0x00000028,
        0x00001107,
        0x00000029
    };

    static _CharacterInfo _character00003205 =
    {
        0x00003205,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003205,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003205,
        0x00003205,
        0x00003205
    };

    static Char _decompositionMapping00003206[] = 
    {
        0x00000028,
        0x00001109,
        0x00000029
    };

    static _CharacterInfo _character00003206 =
    {
        0x00003206,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003206,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003206,
        0x00003206,
        0x00003206
    };

    static Char _decompositionMapping00003207[] = 
    {
        0x00000028,
        0x0000110B,
        0x00000029
    };

    static _CharacterInfo _character00003207 =
    {
        0x00003207,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003207,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003207,
        0x00003207,
        0x00003207
    };

    static Char _decompositionMapping00003208[] = 
    {
        0x00000028,
        0x0000110C,
        0x00000029
    };

    static _CharacterInfo _character00003208 =
    {
        0x00003208,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003208,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003208,
        0x00003208,
        0x00003208
    };

    static Char _decompositionMapping00003209[] = 
    {
        0x00000028,
        0x0000110E,
        0x00000029
    };

    static _CharacterInfo _character00003209 =
    {
        0x00003209,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003209,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003209,
        0x00003209,
        0x00003209
    };

    static Char _decompositionMapping0000320A[] = 
    {
        0x00000028,
        0x0000110F,
        0x00000029
    };

    static _CharacterInfo _character0000320A =
    {
        0x0000320A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000320A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320A,
        0x0000320A,
        0x0000320A
    };

    static Char _decompositionMapping0000320B[] = 
    {
        0x00000028,
        0x00001110,
        0x00000029
    };

    static _CharacterInfo _character0000320B =
    {
        0x0000320B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000320B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320B,
        0x0000320B,
        0x0000320B
    };

    static Char _decompositionMapping0000320C[] = 
    {
        0x00000028,
        0x00001111,
        0x00000029
    };

    static _CharacterInfo _character0000320C =
    {
        0x0000320C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000320C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320C,
        0x0000320C,
        0x0000320C
    };

    static Char _decompositionMapping0000320D[] = 
    {
        0x00000028,
        0x00001112,
        0x00000029
    };

    static _CharacterInfo _character0000320D =
    {
        0x0000320D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000320D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320D,
        0x0000320D,
        0x0000320D
    };

    static Char _decompositionMapping0000320E[] = 
    {
        0x00000028,
        0x00001100,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character0000320E =
    {
        0x0000320E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000320E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320E,
        0x0000320E,
        0x0000320E
    };

    static Char _decompositionMapping0000320F[] = 
    {
        0x00000028,
        0x00001102,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character0000320F =
    {
        0x0000320F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000320F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000320F,
        0x0000320F,
        0x0000320F
    };

    static Char _decompositionMapping00003210[] = 
    {
        0x00000028,
        0x00001103,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003210 =
    {
        0x00003210,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003210,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003210,
        0x00003210,
        0x00003210
    };

    static Char _decompositionMapping00003211[] = 
    {
        0x00000028,
        0x00001105,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003211 =
    {
        0x00003211,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003211,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003211,
        0x00003211,
        0x00003211
    };

    static Char _decompositionMapping00003212[] = 
    {
        0x00000028,
        0x00001106,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003212 =
    {
        0x00003212,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003212,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003212,
        0x00003212,
        0x00003212
    };

    static Char _decompositionMapping00003213[] = 
    {
        0x00000028,
        0x00001107,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003213 =
    {
        0x00003213,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003213,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003213,
        0x00003213,
        0x00003213
    };

    static Char _decompositionMapping00003214[] = 
    {
        0x00000028,
        0x00001109,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003214 =
    {
        0x00003214,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003214,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003214,
        0x00003214,
        0x00003214
    };

    static Char _decompositionMapping00003215[] = 
    {
        0x00000028,
        0x0000110B,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003215 =
    {
        0x00003215,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003215,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003215,
        0x00003215,
        0x00003215
    };

    static Char _decompositionMapping00003216[] = 
    {
        0x00000028,
        0x0000110C,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003216 =
    {
        0x00003216,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003216,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003216,
        0x00003216,
        0x00003216
    };

    static Char _decompositionMapping00003217[] = 
    {
        0x00000028,
        0x0000110E,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003217 =
    {
        0x00003217,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003217,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003217,
        0x00003217,
        0x00003217
    };

    static Char _decompositionMapping00003218[] = 
    {
        0x00000028,
        0x0000110F,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003218 =
    {
        0x00003218,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003218,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003218,
        0x00003218,
        0x00003218
    };

    static Char _decompositionMapping00003219[] = 
    {
        0x00000028,
        0x00001110,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character00003219 =
    {
        0x00003219,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping00003219,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003219,
        0x00003219,
        0x00003219
    };

    static Char _decompositionMapping0000321A[] = 
    {
        0x00000028,
        0x00001111,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character0000321A =
    {
        0x0000321A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000321A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000321A,
        0x0000321A,
        0x0000321A
    };

    static Char _decompositionMapping0000321B[] = 
    {
        0x00000028,
        0x00001112,
        0x00001161,
        0x00000029
    };

    static _CharacterInfo _character0000321B =
    {
        0x0000321B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000321B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000321B,
        0x0000321B,
        0x0000321B
    };

    static Char _decompositionMapping0000321C[] = 
    {
        0x00000028,
        0x0000110C,
        0x0000116E,
        0x00000029
    };

    static _CharacterInfo _character0000321C =
    {
        0x0000321C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        4,
        _decompositionMapping0000321C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000321C,
        0x0000321C,
        0x0000321C
    };

    static Char _decompositionMapping0000321D[] = 
    {
        0x00000028,
        0x0000110B,
        0x00001169,
        0x0000110C,
        0x00001165,
        0x000011AB,
        0x00000000
    };

    static _CharacterInfo _character0000321D =
    {
        0x0000321D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        7,
        _decompositionMapping0000321D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000321D,
        0x0000321D,
        0x0000321D
    };

    static Char _decompositionMapping0000321E[] = 
    {
        0x00000028,
        0x0000110B,
        0x00001169,
        0x00001112,
        0x0000116E,
        0x00000029
    };

    static _CharacterInfo _character0000321E =
    {
        0x0000321E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        6,
        _decompositionMapping0000321E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000321E,
        0x0000321E,
        0x0000321E
    };

    static Char _decompositionMapping00003220[] = 
    {
        0x00000028,
        0x00004E00,
        0x00000029
    };

    static _CharacterInfo _character00003220 =
    {
        0x00003220,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003220,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00003220,
        0x00003220,
        0x00003220
    };

    static Char _decompositionMapping00003221[] = 
    {
        0x00000028,
        0x00004E8C,
        0x00000029
    };

    static _CharacterInfo _character00003221 =
    {
        0x00003221,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003221,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00003221,
        0x00003221,
        0x00003221
    };

    static Char _decompositionMapping00003222[] = 
    {
        0x00000028,
        0x00004E09,
        0x00000029
    };

    static _CharacterInfo _character00003222 =
    {
        0x00003222,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003222,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00003222,
        0x00003222,
        0x00003222
    };

    static Char _decompositionMapping00003223[] = 
    {
        0x00000028,
        0x000056DB,
        0x00000029
    };

    static _CharacterInfo _character00003223 =
    {
        0x00003223,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003223,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00003223,
        0x00003223,
        0x00003223
    };

    static Char _decompositionMapping00003224[] = 
    {
        0x00000028,
        0x00004E94,
        0x00000029
    };

    static _CharacterInfo _character00003224 =
    {
        0x00003224,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003224,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00003224,
        0x00003224,
        0x00003224
    };

    static Char _decompositionMapping00003225[] = 
    {
        0x00000028,
        0x0000516D,
        0x00000029
    };

    static _CharacterInfo _character00003225 =
    {
        0x00003225,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003225,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00003225,
        0x00003225,
        0x00003225
    };

    static Char _decompositionMapping00003226[] = 
    {
        0x00000028,
        0x00004E03,
        0x00000029
    };

    static _CharacterInfo _character00003226 =
    {
        0x00003226,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003226,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00003226,
        0x00003226,
        0x00003226
    };

    static Char _decompositionMapping00003227[] = 
    {
        0x00000028,
        0x0000516B,
        0x00000029
    };

    static _CharacterInfo _character00003227 =
    {
        0x00003227,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003227,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00003227,
        0x00003227,
        0x00003227
    };

    static Char _decompositionMapping00003228[] = 
    {
        0x00000028,
        0x00004E5D,
        0x00000029
    };

    static _CharacterInfo _character00003228 =
    {
        0x00003228,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003228,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00003228,
        0x00003228,
        0x00003228
    };

    static Char _decompositionMapping00003229[] = 
    {
        0x00000028,
        0x00005341,
        0x00000029
    };

    static _CharacterInfo _character00003229 =
    {
        0x00003229,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003229,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00003229,
        0x00003229,
        0x00003229
    };

    static Char _decompositionMapping0000322A[] = 
    {
        0x00000028,
        0x00006708,
        0x00000029
    };

    static _CharacterInfo _character0000322A =
    {
        0x0000322A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322A,
        0x0000322A,
        0x0000322A
    };

    static Char _decompositionMapping0000322B[] = 
    {
        0x00000028,
        0x0000706B,
        0x00000029
    };

    static _CharacterInfo _character0000322B =
    {
        0x0000322B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322B,
        0x0000322B,
        0x0000322B
    };

    static Char _decompositionMapping0000322C[] = 
    {
        0x00000028,
        0x00006C34,
        0x00000029
    };

    static _CharacterInfo _character0000322C =
    {
        0x0000322C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322C,
        0x0000322C,
        0x0000322C
    };

    static Char _decompositionMapping0000322D[] = 
    {
        0x00000028,
        0x00006728,
        0x00000029
    };

    static _CharacterInfo _character0000322D =
    {
        0x0000322D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322D,
        0x0000322D,
        0x0000322D
    };

    static Char _decompositionMapping0000322E[] = 
    {
        0x00000028,
        0x000091D1,
        0x00000029
    };

    static _CharacterInfo _character0000322E =
    {
        0x0000322E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322E,
        0x0000322E,
        0x0000322E
    };

    static Char _decompositionMapping0000322F[] = 
    {
        0x00000028,
        0x0000571F,
        0x00000029
    };

    static _CharacterInfo _character0000322F =
    {
        0x0000322F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000322F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000322F,
        0x0000322F,
        0x0000322F
    };

    static Char _decompositionMapping00003230[] = 
    {
        0x00000028,
        0x000065E5,
        0x00000029
    };

    static _CharacterInfo _character00003230 =
    {
        0x00003230,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003230,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003230,
        0x00003230,
        0x00003230
    };

    static Char _decompositionMapping00003231[] = 
    {
        0x00000028,
        0x0000682A,
        0x00000029
    };

    static _CharacterInfo _character00003231 =
    {
        0x00003231,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003231,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003231,
        0x00003231,
        0x00003231
    };

    static Char _decompositionMapping00003232[] = 
    {
        0x00000028,
        0x00006709,
        0x00000029
    };

    static _CharacterInfo _character00003232 =
    {
        0x00003232,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003232,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003232,
        0x00003232,
        0x00003232
    };

    static Char _decompositionMapping00003233[] = 
    {
        0x00000028,
        0x0000793E,
        0x00000029
    };

    static _CharacterInfo _character00003233 =
    {
        0x00003233,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003233,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003233,
        0x00003233,
        0x00003233
    };

    static Char _decompositionMapping00003234[] = 
    {
        0x00000028,
        0x0000540D,
        0x00000029
    };

    static _CharacterInfo _character00003234 =
    {
        0x00003234,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003234,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003234,
        0x00003234,
        0x00003234
    };

    static Char _decompositionMapping00003235[] = 
    {
        0x00000028,
        0x00007279,
        0x00000029
    };

    static _CharacterInfo _character00003235 =
    {
        0x00003235,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003235,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003235,
        0x00003235,
        0x00003235
    };

    static Char _decompositionMapping00003236[] = 
    {
        0x00000028,
        0x00008CA1,
        0x00000029
    };

    static _CharacterInfo _character00003236 =
    {
        0x00003236,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003236,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003236,
        0x00003236,
        0x00003236
    };

    static Char _decompositionMapping00003237[] = 
    {
        0x00000028,
        0x0000795D,
        0x00000029
    };

    static _CharacterInfo _character00003237 =
    {
        0x00003237,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003237,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003237,
        0x00003237,
        0x00003237
    };

    static Char _decompositionMapping00003238[] = 
    {
        0x00000028,
        0x000052B4,
        0x00000029
    };

    static _CharacterInfo _character00003238 =
    {
        0x00003238,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003238,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003238,
        0x00003238,
        0x00003238
    };

    static Char _decompositionMapping00003239[] = 
    {
        0x00000028,
        0x00004EE3,
        0x00000029
    };

    static _CharacterInfo _character00003239 =
    {
        0x00003239,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003239,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003239,
        0x00003239,
        0x00003239
    };

    static Char _decompositionMapping0000323A[] = 
    {
        0x00000028,
        0x0000547C,
        0x00000029
    };

    static _CharacterInfo _character0000323A =
    {
        0x0000323A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323A,
        0x0000323A,
        0x0000323A
    };

    static Char _decompositionMapping0000323B[] = 
    {
        0x00000028,
        0x00005B66,
        0x00000029
    };

    static _CharacterInfo _character0000323B =
    {
        0x0000323B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323B,
        0x0000323B,
        0x0000323B
    };

    static Char _decompositionMapping0000323C[] = 
    {
        0x00000028,
        0x000076E3,
        0x00000029
    };

    static _CharacterInfo _character0000323C =
    {
        0x0000323C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323C,
        0x0000323C,
        0x0000323C
    };

    static Char _decompositionMapping0000323D[] = 
    {
        0x00000028,
        0x00004F01,
        0x00000029
    };

    static _CharacterInfo _character0000323D =
    {
        0x0000323D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323D,
        0x0000323D,
        0x0000323D
    };

    static Char _decompositionMapping0000323E[] = 
    {
        0x00000028,
        0x00008CC7,
        0x00000029
    };

    static _CharacterInfo _character0000323E =
    {
        0x0000323E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323E,
        0x0000323E,
        0x0000323E
    };

    static Char _decompositionMapping0000323F[] = 
    {
        0x00000028,
        0x00005354,
        0x00000029
    };

    static _CharacterInfo _character0000323F =
    {
        0x0000323F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000323F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000323F,
        0x0000323F,
        0x0000323F
    };

    static Char _decompositionMapping00003240[] = 
    {
        0x00000028,
        0x0000796D,
        0x00000029
    };

    static _CharacterInfo _character00003240 =
    {
        0x00003240,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003240,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003240,
        0x00003240,
        0x00003240
    };

    static Char _decompositionMapping00003241[] = 
    {
        0x00000028,
        0x00004F11,
        0x00000029
    };

    static _CharacterInfo _character00003241 =
    {
        0x00003241,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003241,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003241,
        0x00003241,
        0x00003241
    };

    static Char _decompositionMapping00003242[] = 
    {
        0x00000028,
        0x000081EA,
        0x00000029
    };

    static _CharacterInfo _character00003242 =
    {
        0x00003242,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003242,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003242,
        0x00003242,
        0x00003242
    };

    static Char _decompositionMapping00003243[] = 
    {
        0x00000028,
        0x000081F3,
        0x00000029
    };

    static _CharacterInfo _character00003243 =
    {
        0x00003243,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003243,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003243,
        0x00003243,
        0x00003243
    };

    static Char _decompositionMapping00003250[] = 
    {
        0x00000050,
        0x00000054,
        0x00000045
    };

    static _CharacterInfo _character00003250 =
    {
        0x00003250,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003250,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003250,
        0x00003250,
        0x00003250
    };

    static Char _decompositionMapping00003251[] = 
    {
        0x00000032,
        0x00000031
    };

    static _CharacterInfo _character00003251 =
    {
        0x00003251,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003251,
        false,
        0,
        false,
        0,
        true,
        21,
        1,
        false,
        0x00003251,
        0x00003251,
        0x00003251
    };

    static Char _decompositionMapping00003252[] = 
    {
        0x00000032,
        0x00000032
    };

    static _CharacterInfo _character00003252 =
    {
        0x00003252,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003252,
        false,
        0,
        false,
        0,
        true,
        22,
        1,
        false,
        0x00003252,
        0x00003252,
        0x00003252
    };

    static Char _decompositionMapping00003253[] = 
    {
        0x00000032,
        0x00000033
    };

    static _CharacterInfo _character00003253 =
    {
        0x00003253,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003253,
        false,
        0,
        false,
        0,
        true,
        23,
        1,
        false,
        0x00003253,
        0x00003253,
        0x00003253
    };

    static Char _decompositionMapping00003254[] = 
    {
        0x00000032,
        0x00000034
    };

    static _CharacterInfo _character00003254 =
    {
        0x00003254,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003254,
        false,
        0,
        false,
        0,
        true,
        24,
        1,
        false,
        0x00003254,
        0x00003254,
        0x00003254
    };

    static Char _decompositionMapping00003255[] = 
    {
        0x00000032,
        0x00000035
    };

    static _CharacterInfo _character00003255 =
    {
        0x00003255,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003255,
        false,
        0,
        false,
        0,
        true,
        25,
        1,
        false,
        0x00003255,
        0x00003255,
        0x00003255
    };

    static Char _decompositionMapping00003256[] = 
    {
        0x00000032,
        0x00000036
    };

    static _CharacterInfo _character00003256 =
    {
        0x00003256,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003256,
        false,
        0,
        false,
        0,
        true,
        26,
        1,
        false,
        0x00003256,
        0x00003256,
        0x00003256
    };

    static Char _decompositionMapping00003257[] = 
    {
        0x00000032,
        0x00000037
    };

    static _CharacterInfo _character00003257 =
    {
        0x00003257,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003257,
        false,
        0,
        false,
        0,
        true,
        27,
        1,
        false,
        0x00003257,
        0x00003257,
        0x00003257
    };

    static Char _decompositionMapping00003258[] = 
    {
        0x00000032,
        0x00000038
    };

    static _CharacterInfo _character00003258 =
    {
        0x00003258,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003258,
        false,
        0,
        false,
        0,
        true,
        28,
        1,
        false,
        0x00003258,
        0x00003258,
        0x00003258
    };

    static Char _decompositionMapping00003259[] = 
    {
        0x00000032,
        0x00000039
    };

    static _CharacterInfo _character00003259 =
    {
        0x00003259,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003259,
        false,
        0,
        false,
        0,
        true,
        29,
        1,
        false,
        0x00003259,
        0x00003259,
        0x00003259
    };

    static Char _decompositionMapping0000325A[] = 
    {
        0x00000033,
        0x00000030
    };

    static _CharacterInfo _character0000325A =
    {
        0x0000325A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325A,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x0000325A,
        0x0000325A,
        0x0000325A
    };

    static Char _decompositionMapping0000325B[] = 
    {
        0x00000033,
        0x00000031
    };

    static _CharacterInfo _character0000325B =
    {
        0x0000325B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325B,
        false,
        0,
        false,
        0,
        true,
        31,
        1,
        false,
        0x0000325B,
        0x0000325B,
        0x0000325B
    };

    static Char _decompositionMapping0000325C[] = 
    {
        0x00000033,
        0x00000032
    };

    static _CharacterInfo _character0000325C =
    {
        0x0000325C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325C,
        false,
        0,
        false,
        0,
        true,
        32,
        1,
        false,
        0x0000325C,
        0x0000325C,
        0x0000325C
    };

    static Char _decompositionMapping0000325D[] = 
    {
        0x00000033,
        0x00000033
    };

    static _CharacterInfo _character0000325D =
    {
        0x0000325D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325D,
        false,
        0,
        false,
        0,
        true,
        33,
        1,
        false,
        0x0000325D,
        0x0000325D,
        0x0000325D
    };

    static Char _decompositionMapping0000325E[] = 
    {
        0x00000033,
        0x00000034
    };

    static _CharacterInfo _character0000325E =
    {
        0x0000325E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325E,
        false,
        0,
        false,
        0,
        true,
        34,
        1,
        false,
        0x0000325E,
        0x0000325E,
        0x0000325E
    };

    static Char _decompositionMapping0000325F[] = 
    {
        0x00000033,
        0x00000035
    };

    static _CharacterInfo _character0000325F =
    {
        0x0000325F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000325F,
        false,
        0,
        false,
        0,
        true,
        35,
        1,
        false,
        0x0000325F,
        0x0000325F,
        0x0000325F
    };

    static Char _decompositionMapping00003260[] = 
    {
        0x00001100
    };

    static _CharacterInfo _character00003260 =
    {
        0x00003260,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003260,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003260,
        0x00003260,
        0x00003260
    };

    static Char _decompositionMapping00003261[] = 
    {
        0x00001102
    };

    static _CharacterInfo _character00003261 =
    {
        0x00003261,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003261,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003261,
        0x00003261,
        0x00003261
    };

    static Char _decompositionMapping00003262[] = 
    {
        0x00001103
    };

    static _CharacterInfo _character00003262 =
    {
        0x00003262,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003262,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003262,
        0x00003262,
        0x00003262
    };

    static Char _decompositionMapping00003263[] = 
    {
        0x00001105
    };

    static _CharacterInfo _character00003263 =
    {
        0x00003263,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003263,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003263,
        0x00003263,
        0x00003263
    };

    static Char _decompositionMapping00003264[] = 
    {
        0x00001106
    };

    static _CharacterInfo _character00003264 =
    {
        0x00003264,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003264,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003264,
        0x00003264,
        0x00003264
    };

    static Char _decompositionMapping00003265[] = 
    {
        0x00001107
    };

    static _CharacterInfo _character00003265 =
    {
        0x00003265,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003265,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003265,
        0x00003265,
        0x00003265
    };

    static Char _decompositionMapping00003266[] = 
    {
        0x00001109
    };

    static _CharacterInfo _character00003266 =
    {
        0x00003266,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003266,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003266,
        0x00003266,
        0x00003266
    };

    static Char _decompositionMapping00003267[] = 
    {
        0x0000110B
    };

    static _CharacterInfo _character00003267 =
    {
        0x00003267,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003267,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003267,
        0x00003267,
        0x00003267
    };

    static Char _decompositionMapping00003268[] = 
    {
        0x0000110C
    };

    static _CharacterInfo _character00003268 =
    {
        0x00003268,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003268,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003268,
        0x00003268,
        0x00003268
    };

    static Char _decompositionMapping00003269[] = 
    {
        0x0000110E
    };

    static _CharacterInfo _character00003269 =
    {
        0x00003269,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003269,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003269,
        0x00003269,
        0x00003269
    };

    static Char _decompositionMapping0000326A[] = 
    {
        0x0000110F
    };

    static _CharacterInfo _character0000326A =
    {
        0x0000326A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000326A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326A,
        0x0000326A,
        0x0000326A
    };

    static Char _decompositionMapping0000326B[] = 
    {
        0x00001110
    };

    static _CharacterInfo _character0000326B =
    {
        0x0000326B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000326B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326B,
        0x0000326B,
        0x0000326B
    };

    static Char _decompositionMapping0000326C[] = 
    {
        0x00001111
    };

    static _CharacterInfo _character0000326C =
    {
        0x0000326C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000326C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326C,
        0x0000326C,
        0x0000326C
    };

    static Char _decompositionMapping0000326D[] = 
    {
        0x00001112
    };

    static _CharacterInfo _character0000326D =
    {
        0x0000326D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000326D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326D,
        0x0000326D,
        0x0000326D
    };

    static Char _decompositionMapping0000326E[] = 
    {
        0x00001100,
        0x00001161
    };

    static _CharacterInfo _character0000326E =
    {
        0x0000326E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000326E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326E,
        0x0000326E,
        0x0000326E
    };

    static Char _decompositionMapping0000326F[] = 
    {
        0x00001102,
        0x00001161
    };

    static _CharacterInfo _character0000326F =
    {
        0x0000326F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000326F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000326F,
        0x0000326F,
        0x0000326F
    };

    static Char _decompositionMapping00003270[] = 
    {
        0x00001103,
        0x00001161
    };

    static _CharacterInfo _character00003270 =
    {
        0x00003270,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003270,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003270,
        0x00003270,
        0x00003270
    };

    static Char _decompositionMapping00003271[] = 
    {
        0x00001105,
        0x00001161
    };

    static _CharacterInfo _character00003271 =
    {
        0x00003271,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003271,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003271,
        0x00003271,
        0x00003271
    };

    static Char _decompositionMapping00003272[] = 
    {
        0x00001106,
        0x00001161
    };

    static _CharacterInfo _character00003272 =
    {
        0x00003272,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003272,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003272,
        0x00003272,
        0x00003272
    };

    static Char _decompositionMapping00003273[] = 
    {
        0x00001107,
        0x00001161
    };

    static _CharacterInfo _character00003273 =
    {
        0x00003273,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003273,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003273,
        0x00003273,
        0x00003273
    };

    static Char _decompositionMapping00003274[] = 
    {
        0x00001109,
        0x00001161
    };

    static _CharacterInfo _character00003274 =
    {
        0x00003274,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003274,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003274,
        0x00003274,
        0x00003274
    };

    static Char _decompositionMapping00003275[] = 
    {
        0x0000110B,
        0x00001161
    };

    static _CharacterInfo _character00003275 =
    {
        0x00003275,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003275,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003275,
        0x00003275,
        0x00003275
    };

    static Char _decompositionMapping00003276[] = 
    {
        0x0000110C,
        0x00001161
    };

    static _CharacterInfo _character00003276 =
    {
        0x00003276,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003276,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003276,
        0x00003276,
        0x00003276
    };

    static Char _decompositionMapping00003277[] = 
    {
        0x0000110E,
        0x00001161
    };

    static _CharacterInfo _character00003277 =
    {
        0x00003277,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003277,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003277,
        0x00003277,
        0x00003277
    };

    static Char _decompositionMapping00003278[] = 
    {
        0x0000110F,
        0x00001161
    };

    static _CharacterInfo _character00003278 =
    {
        0x00003278,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003278,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003278,
        0x00003278,
        0x00003278
    };

    static Char _decompositionMapping00003279[] = 
    {
        0x00001110,
        0x00001161
    };

    static _CharacterInfo _character00003279 =
    {
        0x00003279,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping00003279,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003279,
        0x00003279,
        0x00003279
    };

    static Char _decompositionMapping0000327A[] = 
    {
        0x00001111,
        0x00001161
    };

    static _CharacterInfo _character0000327A =
    {
        0x0000327A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000327A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327A,
        0x0000327A,
        0x0000327A
    };

    static Char _decompositionMapping0000327B[] = 
    {
        0x00001112,
        0x00001161
    };

    static _CharacterInfo _character0000327B =
    {
        0x0000327B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000327B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327B,
        0x0000327B,
        0x0000327B
    };

    static Char _decompositionMapping0000327C[] = 
    {
        0x0000110E,
        0x00001161,
        0x000011B7,
        0x00001100,
        0x00001169
    };

    static _CharacterInfo _character0000327C =
    {
        0x0000327C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        5,
        _decompositionMapping0000327C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327C,
        0x0000327C,
        0x0000327C
    };

    static Char _decompositionMapping0000327D[] = 
    {
        0x0000110C,
        0x0000116E,
        0x0000110B,
        0x00001174
    };

    static _CharacterInfo _character0000327D =
    {
        0x0000327D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        4,
        _decompositionMapping0000327D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327D,
        0x0000327D,
        0x0000327D
    };

    static Char _decompositionMapping0000327E[] = 
    {
        0x0000110B,
        0x0000116E
    };

    static _CharacterInfo _character0000327E =
    {
        0x0000327E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping0000327E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327E,
        0x0000327E,
        0x0000327E
    };

    static _CharacterInfo _character0000327F =
    {
        0x0000327F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000327F,
        0x0000327F,
        0x0000327F
    };

    static Char _decompositionMapping00003280[] = 
    {
        0x00004E00
    };

    static _CharacterInfo _character00003280 =
    {
        0x00003280,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003280,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00003280,
        0x00003280,
        0x00003280
    };

    static Char _decompositionMapping00003281[] = 
    {
        0x00004E8C
    };

    static _CharacterInfo _character00003281 =
    {
        0x00003281,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003281,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00003281,
        0x00003281,
        0x00003281
    };

    static Char _decompositionMapping00003282[] = 
    {
        0x00004E09
    };

    static _CharacterInfo _character00003282 =
    {
        0x00003282,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003282,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00003282,
        0x00003282,
        0x00003282
    };

    static Char _decompositionMapping00003283[] = 
    {
        0x000056DB
    };

    static _CharacterInfo _character00003283 =
    {
        0x00003283,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003283,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00003283,
        0x00003283,
        0x00003283
    };

    static Char _decompositionMapping00003284[] = 
    {
        0x00004E94
    };

    static _CharacterInfo _character00003284 =
    {
        0x00003284,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003284,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00003284,
        0x00003284,
        0x00003284
    };

    static Char _decompositionMapping00003285[] = 
    {
        0x0000516D
    };

    static _CharacterInfo _character00003285 =
    {
        0x00003285,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003285,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00003285,
        0x00003285,
        0x00003285
    };

    static Char _decompositionMapping00003286[] = 
    {
        0x00004E03
    };

    static _CharacterInfo _character00003286 =
    {
        0x00003286,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003286,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00003286,
        0x00003286,
        0x00003286
    };

    static Char _decompositionMapping00003287[] = 
    {
        0x0000516B
    };

    static _CharacterInfo _character00003287 =
    {
        0x00003287,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003287,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00003287,
        0x00003287,
        0x00003287
    };

    static Char _decompositionMapping00003288[] = 
    {
        0x00004E5D
    };

    static _CharacterInfo _character00003288 =
    {
        0x00003288,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003288,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00003288,
        0x00003288,
        0x00003288
    };

    static Char _decompositionMapping00003289[] = 
    {
        0x00005341
    };

    static _CharacterInfo _character00003289 =
    {
        0x00003289,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003289,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00003289,
        0x00003289,
        0x00003289
    };

    static Char _decompositionMapping0000328A[] = 
    {
        0x00006708
    };

    static _CharacterInfo _character0000328A =
    {
        0x0000328A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328A,
        0x0000328A,
        0x0000328A
    };

    static Char _decompositionMapping0000328B[] = 
    {
        0x0000706B
    };

    static _CharacterInfo _character0000328B =
    {
        0x0000328B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328B,
        0x0000328B,
        0x0000328B
    };

    static Char _decompositionMapping0000328C[] = 
    {
        0x00006C34
    };

    static _CharacterInfo _character0000328C =
    {
        0x0000328C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328C,
        0x0000328C,
        0x0000328C
    };

    static Char _decompositionMapping0000328D[] = 
    {
        0x00006728
    };

    static _CharacterInfo _character0000328D =
    {
        0x0000328D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328D,
        0x0000328D,
        0x0000328D
    };

    static Char _decompositionMapping0000328E[] = 
    {
        0x000091D1
    };

    static _CharacterInfo _character0000328E =
    {
        0x0000328E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328E,
        0x0000328E,
        0x0000328E
    };

    static Char _decompositionMapping0000328F[] = 
    {
        0x0000571F
    };

    static _CharacterInfo _character0000328F =
    {
        0x0000328F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000328F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000328F,
        0x0000328F,
        0x0000328F
    };

    static Char _decompositionMapping00003290[] = 
    {
        0x000065E5
    };

    static _CharacterInfo _character00003290 =
    {
        0x00003290,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003290,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003290,
        0x00003290,
        0x00003290
    };

    static Char _decompositionMapping00003291[] = 
    {
        0x0000682A
    };

    static _CharacterInfo _character00003291 =
    {
        0x00003291,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003291,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003291,
        0x00003291,
        0x00003291
    };

    static Char _decompositionMapping00003292[] = 
    {
        0x00006709
    };

    static _CharacterInfo _character00003292 =
    {
        0x00003292,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003292,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003292,
        0x00003292,
        0x00003292
    };

    static Char _decompositionMapping00003293[] = 
    {
        0x0000793E
    };

    static _CharacterInfo _character00003293 =
    {
        0x00003293,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003293,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003293,
        0x00003293,
        0x00003293
    };

    static Char _decompositionMapping00003294[] = 
    {
        0x0000540D
    };

    static _CharacterInfo _character00003294 =
    {
        0x00003294,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003294,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003294,
        0x00003294,
        0x00003294
    };

    static Char _decompositionMapping00003295[] = 
    {
        0x00007279
    };

    static _CharacterInfo _character00003295 =
    {
        0x00003295,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003295,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003295,
        0x00003295,
        0x00003295
    };

    static Char _decompositionMapping00003296[] = 
    {
        0x00008CA1
    };

    static _CharacterInfo _character00003296 =
    {
        0x00003296,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003296,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003296,
        0x00003296,
        0x00003296
    };

    static Char _decompositionMapping00003297[] = 
    {
        0x0000795D
    };

    static _CharacterInfo _character00003297 =
    {
        0x00003297,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003297,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003297,
        0x00003297,
        0x00003297
    };

    static Char _decompositionMapping00003298[] = 
    {
        0x000052B4
    };

    static _CharacterInfo _character00003298 =
    {
        0x00003298,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003298,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003298,
        0x00003298,
        0x00003298
    };

    static Char _decompositionMapping00003299[] = 
    {
        0x000079D8
    };

    static _CharacterInfo _character00003299 =
    {
        0x00003299,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping00003299,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003299,
        0x00003299,
        0x00003299
    };

    static Char _decompositionMapping0000329A[] = 
    {
        0x00007537
    };

    static _CharacterInfo _character0000329A =
    {
        0x0000329A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329A,
        0x0000329A,
        0x0000329A
    };

    static Char _decompositionMapping0000329B[] = 
    {
        0x00005973
    };

    static _CharacterInfo _character0000329B =
    {
        0x0000329B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329B,
        0x0000329B,
        0x0000329B
    };

    static Char _decompositionMapping0000329C[] = 
    {
        0x00009069
    };

    static _CharacterInfo _character0000329C =
    {
        0x0000329C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329C,
        0x0000329C,
        0x0000329C
    };

    static Char _decompositionMapping0000329D[] = 
    {
        0x0000512A
    };

    static _CharacterInfo _character0000329D =
    {
        0x0000329D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329D,
        0x0000329D,
        0x0000329D
    };

    static Char _decompositionMapping0000329E[] = 
    {
        0x00005370
    };

    static _CharacterInfo _character0000329E =
    {
        0x0000329E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329E,
        0x0000329E,
        0x0000329E
    };

    static Char _decompositionMapping0000329F[] = 
    {
        0x00006CE8
    };

    static _CharacterInfo _character0000329F =
    {
        0x0000329F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping0000329F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000329F,
        0x0000329F,
        0x0000329F
    };

    static Char _decompositionMapping000032A0[] = 
    {
        0x00009805
    };

    static _CharacterInfo _character000032A0 =
    {
        0x000032A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A0,
        0x000032A0,
        0x000032A0
    };

    static Char _decompositionMapping000032A1[] = 
    {
        0x00004F11
    };

    static _CharacterInfo _character000032A1 =
    {
        0x000032A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A1,
        0x000032A1,
        0x000032A1
    };

    static Char _decompositionMapping000032A2[] = 
    {
        0x00005199
    };

    static _CharacterInfo _character000032A2 =
    {
        0x000032A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A2,
        0x000032A2,
        0x000032A2
    };

    static Char _decompositionMapping000032A3[] = 
    {
        0x00006B63
    };

    static _CharacterInfo _character000032A3 =
    {
        0x000032A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A3,
        0x000032A3,
        0x000032A3
    };

    static Char _decompositionMapping000032A4[] = 
    {
        0x00004E0A
    };

    static _CharacterInfo _character000032A4 =
    {
        0x000032A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A4,
        0x000032A4,
        0x000032A4
    };

    static Char _decompositionMapping000032A5[] = 
    {
        0x00004E2D
    };

    static _CharacterInfo _character000032A5 =
    {
        0x000032A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A5,
        0x000032A5,
        0x000032A5
    };

    static Char _decompositionMapping000032A6[] = 
    {
        0x00004E0B
    };

    static _CharacterInfo _character000032A6 =
    {
        0x000032A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A6,
        0x000032A6,
        0x000032A6
    };

    static Char _decompositionMapping000032A7[] = 
    {
        0x00005DE6
    };

    static _CharacterInfo _character000032A7 =
    {
        0x000032A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A7,
        0x000032A7,
        0x000032A7
    };

    static Char _decompositionMapping000032A8[] = 
    {
        0x000053F3
    };

    static _CharacterInfo _character000032A8 =
    {
        0x000032A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A8,
        0x000032A8,
        0x000032A8
    };

    static Char _decompositionMapping000032A9[] = 
    {
        0x0000533B
    };

    static _CharacterInfo _character000032A9 =
    {
        0x000032A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032A9,
        0x000032A9,
        0x000032A9
    };

    static Char _decompositionMapping000032AA[] = 
    {
        0x00005B97
    };

    static _CharacterInfo _character000032AA =
    {
        0x000032AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AA,
        0x000032AA,
        0x000032AA
    };

    static Char _decompositionMapping000032AB[] = 
    {
        0x00005B66
    };

    static _CharacterInfo _character000032AB =
    {
        0x000032AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AB,
        0x000032AB,
        0x000032AB
    };

    static Char _decompositionMapping000032AC[] = 
    {
        0x000076E3
    };

    static _CharacterInfo _character000032AC =
    {
        0x000032AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AC,
        0x000032AC,
        0x000032AC
    };

    static Char _decompositionMapping000032AD[] = 
    {
        0x00004F01
    };

    static _CharacterInfo _character000032AD =
    {
        0x000032AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AD,
        0x000032AD,
        0x000032AD
    };

    static Char _decompositionMapping000032AE[] = 
    {
        0x00008CC7
    };

    static _CharacterInfo _character000032AE =
    {
        0x000032AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AE,
        0x000032AE,
        0x000032AE
    };

    static Char _decompositionMapping000032AF[] = 
    {
        0x00005354
    };

    static _CharacterInfo _character000032AF =
    {
        0x000032AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032AF,
        0x000032AF,
        0x000032AF
    };

    static Char _decompositionMapping000032B0[] = 
    {
        0x0000591C
    };

    static _CharacterInfo _character000032B0 =
    {
        0x000032B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032B0,
        0x000032B0,
        0x000032B0
    };

    static Char _decompositionMapping000032B1[] = 
    {
        0x00000033,
        0x00000036
    };

    static _CharacterInfo _character000032B1 =
    {
        0x000032B1,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B1,
        false,
        0,
        false,
        0,
        true,
        36,
        1,
        false,
        0x000032B1,
        0x000032B1,
        0x000032B1
    };

    static Char _decompositionMapping000032B2[] = 
    {
        0x00000033,
        0x00000037
    };

    static _CharacterInfo _character000032B2 =
    {
        0x000032B2,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B2,
        false,
        0,
        false,
        0,
        true,
        37,
        1,
        false,
        0x000032B2,
        0x000032B2,
        0x000032B2
    };

    static Char _decompositionMapping000032B3[] = 
    {
        0x00000033,
        0x00000038
    };

    static _CharacterInfo _character000032B3 =
    {
        0x000032B3,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B3,
        false,
        0,
        false,
        0,
        true,
        38,
        1,
        false,
        0x000032B3,
        0x000032B3,
        0x000032B3
    };

    static Char _decompositionMapping000032B4[] = 
    {
        0x00000033,
        0x00000039
    };

    static _CharacterInfo _character000032B4 =
    {
        0x000032B4,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B4,
        false,
        0,
        false,
        0,
        true,
        39,
        1,
        false,
        0x000032B4,
        0x000032B4,
        0x000032B4
    };

    static Char _decompositionMapping000032B5[] = 
    {
        0x00000034,
        0x00000030
    };

    static _CharacterInfo _character000032B5 =
    {
        0x000032B5,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B5,
        false,
        0,
        false,
        0,
        true,
        40,
        1,
        false,
        0x000032B5,
        0x000032B5,
        0x000032B5
    };

    static Char _decompositionMapping000032B6[] = 
    {
        0x00000034,
        0x00000031
    };

    static _CharacterInfo _character000032B6 =
    {
        0x000032B6,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B6,
        false,
        0,
        false,
        0,
        true,
        41,
        1,
        false,
        0x000032B6,
        0x000032B6,
        0x000032B6
    };

    static Char _decompositionMapping000032B7[] = 
    {
        0x00000034,
        0x00000032
    };

    static _CharacterInfo _character000032B7 =
    {
        0x000032B7,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B7,
        false,
        0,
        false,
        0,
        true,
        42,
        1,
        false,
        0x000032B7,
        0x000032B7,
        0x000032B7
    };

    static Char _decompositionMapping000032B8[] = 
    {
        0x00000034,
        0x00000033
    };

    static _CharacterInfo _character000032B8 =
    {
        0x000032B8,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B8,
        false,
        0,
        false,
        0,
        true,
        43,
        1,
        false,
        0x000032B8,
        0x000032B8,
        0x000032B8
    };

    static Char _decompositionMapping000032B9[] = 
    {
        0x00000034,
        0x00000034
    };

    static _CharacterInfo _character000032B9 =
    {
        0x000032B9,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032B9,
        false,
        0,
        false,
        0,
        true,
        44,
        1,
        false,
        0x000032B9,
        0x000032B9,
        0x000032B9
    };

    static Char _decompositionMapping000032BA[] = 
    {
        0x00000034,
        0x00000035
    };

    static _CharacterInfo _character000032BA =
    {
        0x000032BA,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BA,
        false,
        0,
        false,
        0,
        true,
        45,
        1,
        false,
        0x000032BA,
        0x000032BA,
        0x000032BA
    };

    static Char _decompositionMapping000032BB[] = 
    {
        0x00000034,
        0x00000036
    };

    static _CharacterInfo _character000032BB =
    {
        0x000032BB,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BB,
        false,
        0,
        false,
        0,
        true,
        46,
        1,
        false,
        0x000032BB,
        0x000032BB,
        0x000032BB
    };

    static Char _decompositionMapping000032BC[] = 
    {
        0x00000034,
        0x00000037
    };

    static _CharacterInfo _character000032BC =
    {
        0x000032BC,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BC,
        false,
        0,
        false,
        0,
        true,
        47,
        1,
        false,
        0x000032BC,
        0x000032BC,
        0x000032BC
    };

    static Char _decompositionMapping000032BD[] = 
    {
        0x00000034,
        0x00000038
    };

    static _CharacterInfo _character000032BD =
    {
        0x000032BD,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BD,
        false,
        0,
        false,
        0,
        true,
        48,
        1,
        false,
        0x000032BD,
        0x000032BD,
        0x000032BD
    };

    static Char _decompositionMapping000032BE[] = 
    {
        0x00000034,
        0x00000039
    };

    static _CharacterInfo _character000032BE =
    {
        0x000032BE,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BE,
        false,
        0,
        false,
        0,
        true,
        49,
        1,
        false,
        0x000032BE,
        0x000032BE,
        0x000032BE
    };

    static Char _decompositionMapping000032BF[] = 
    {
        0x00000035,
        0x00000030
    };

    static _CharacterInfo _character000032BF =
    {
        0x000032BF,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_circle,
        2,
        _decompositionMapping000032BF,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x000032BF,
        0x000032BF,
        0x000032BF
    };

    static Char _decompositionMapping000032C0[] = 
    {
        0x00000031,
        0x00006708
    };

    static _CharacterInfo _character000032C0 =
    {
        0x000032C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C0,
        0x000032C0,
        0x000032C0
    };

    static Char _decompositionMapping000032C1[] = 
    {
        0x00000032,
        0x00006708
    };

    static _CharacterInfo _character000032C1 =
    {
        0x000032C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C1,
        0x000032C1,
        0x000032C1
    };

    static Char _decompositionMapping000032C2[] = 
    {
        0x00000033,
        0x00006708
    };

    static _CharacterInfo _character000032C2 =
    {
        0x000032C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C2,
        0x000032C2,
        0x000032C2
    };

    static Char _decompositionMapping000032C3[] = 
    {
        0x00000034,
        0x00006708
    };

    static _CharacterInfo _character000032C3 =
    {
        0x000032C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C3,
        0x000032C3,
        0x000032C3
    };

    static Char _decompositionMapping000032C4[] = 
    {
        0x00000035,
        0x00006708
    };

    static _CharacterInfo _character000032C4 =
    {
        0x000032C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C4,
        0x000032C4,
        0x000032C4
    };

    static Char _decompositionMapping000032C5[] = 
    {
        0x00000036,
        0x00006708
    };

    static _CharacterInfo _character000032C5 =
    {
        0x000032C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C5,
        0x000032C5,
        0x000032C5
    };

    static Char _decompositionMapping000032C6[] = 
    {
        0x00000037,
        0x00006708
    };

    static _CharacterInfo _character000032C6 =
    {
        0x000032C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C6,
        0x000032C6,
        0x000032C6
    };

    static Char _decompositionMapping000032C7[] = 
    {
        0x00000038,
        0x00006708
    };

    static _CharacterInfo _character000032C7 =
    {
        0x000032C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C7,
        0x000032C7,
        0x000032C7
    };

    static Char _decompositionMapping000032C8[] = 
    {
        0x00000039,
        0x00006708
    };

    static _CharacterInfo _character000032C8 =
    {
        0x000032C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000032C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C8,
        0x000032C8,
        0x000032C8
    };

    static Char _decompositionMapping000032C9[] = 
    {
        0x00000031,
        0x00000030,
        0x00006708
    };

    static _CharacterInfo _character000032C9 =
    {
        0x000032C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000032C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032C9,
        0x000032C9,
        0x000032C9
    };

    static Char _decompositionMapping000032CA[] = 
    {
        0x00000031,
        0x00000031,
        0x00006708
    };

    static _CharacterInfo _character000032CA =
    {
        0x000032CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000032CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CA,
        0x000032CA,
        0x000032CA
    };

    static Char _decompositionMapping000032CB[] = 
    {
        0x00000031,
        0x00000032,
        0x00006708
    };

    static _CharacterInfo _character000032CB =
    {
        0x000032CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000032CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CB,
        0x000032CB,
        0x000032CB
    };

    static Char _decompositionMapping000032CC[] = 
    {
        0x00000048,
        0x00000067
    };

    static _CharacterInfo _character000032CC =
    {
        0x000032CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000032CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CC,
        0x000032CC,
        0x000032CC
    };

    static Char _decompositionMapping000032CD[] = 
    {
        0x00000065,
        0x00000072,
        0x00000067
    };

    static _CharacterInfo _character000032CD =
    {
        0x000032CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000032CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CD,
        0x000032CD,
        0x000032CD
    };

    static Char _decompositionMapping000032CE[] = 
    {
        0x00000065,
        0x00000056
    };

    static _CharacterInfo _character000032CE =
    {
        0x000032CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000032CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CE,
        0x000032CE,
        0x000032CE
    };

    static Char _decompositionMapping000032CF[] = 
    {
        0x0000004C,
        0x00000054,
        0x00000044
    };

    static _CharacterInfo _character000032CF =
    {
        0x000032CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000032CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032CF,
        0x000032CF,
        0x000032CF
    };

    static Char _decompositionMapping000032D0[] = 
    {
        0x000030A2
    };

    static _CharacterInfo _character000032D0 =
    {
        0x000032D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D0,
        0x000032D0,
        0x000032D0
    };

    static Char _decompositionMapping000032D1[] = 
    {
        0x000030A4
    };

    static _CharacterInfo _character000032D1 =
    {
        0x000032D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D1,
        0x000032D1,
        0x000032D1
    };

    static Char _decompositionMapping000032D2[] = 
    {
        0x000030A6
    };

    static _CharacterInfo _character000032D2 =
    {
        0x000032D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D2,
        0x000032D2,
        0x000032D2
    };

    static Char _decompositionMapping000032D3[] = 
    {
        0x000030A8
    };

    static _CharacterInfo _character000032D3 =
    {
        0x000032D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D3,
        0x000032D3,
        0x000032D3
    };

    static Char _decompositionMapping000032D4[] = 
    {
        0x000030AA
    };

    static _CharacterInfo _character000032D4 =
    {
        0x000032D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D4,
        0x000032D4,
        0x000032D4
    };

    static Char _decompositionMapping000032D5[] = 
    {
        0x000030AB
    };

    static _CharacterInfo _character000032D5 =
    {
        0x000032D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D5,
        0x000032D5,
        0x000032D5
    };

    static Char _decompositionMapping000032D6[] = 
    {
        0x000030AD
    };

    static _CharacterInfo _character000032D6 =
    {
        0x000032D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D6,
        0x000032D6,
        0x000032D6
    };

    static Char _decompositionMapping000032D7[] = 
    {
        0x000030AF
    };

    static _CharacterInfo _character000032D7 =
    {
        0x000032D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D7,
        0x000032D7,
        0x000032D7
    };

    static Char _decompositionMapping000032D8[] = 
    {
        0x000030B1
    };

    static _CharacterInfo _character000032D8 =
    {
        0x000032D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D8,
        0x000032D8,
        0x000032D8
    };

    static Char _decompositionMapping000032D9[] = 
    {
        0x000030B3
    };

    static _CharacterInfo _character000032D9 =
    {
        0x000032D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032D9,
        0x000032D9,
        0x000032D9
    };

    static Char _decompositionMapping000032DA[] = 
    {
        0x000030B5
    };

    static _CharacterInfo _character000032DA =
    {
        0x000032DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DA,
        0x000032DA,
        0x000032DA
    };

    static Char _decompositionMapping000032DB[] = 
    {
        0x000030B7
    };

    static _CharacterInfo _character000032DB =
    {
        0x000032DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DB,
        0x000032DB,
        0x000032DB
    };

    static Char _decompositionMapping000032DC[] = 
    {
        0x000030B9
    };

    static _CharacterInfo _character000032DC =
    {
        0x000032DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DC,
        0x000032DC,
        0x000032DC
    };

    static Char _decompositionMapping000032DD[] = 
    {
        0x000030BB
    };

    static _CharacterInfo _character000032DD =
    {
        0x000032DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DD,
        0x000032DD,
        0x000032DD
    };

    static Char _decompositionMapping000032DE[] = 
    {
        0x000030BD
    };

    static _CharacterInfo _character000032DE =
    {
        0x000032DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DE,
        0x000032DE,
        0x000032DE
    };

    static Char _decompositionMapping000032DF[] = 
    {
        0x000030BF
    };

    static _CharacterInfo _character000032DF =
    {
        0x000032DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032DF,
        0x000032DF,
        0x000032DF
    };

    static Char _decompositionMapping000032E0[] = 
    {
        0x000030C1
    };

    static _CharacterInfo _character000032E0 =
    {
        0x000032E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E0,
        0x000032E0,
        0x000032E0
    };

    static Char _decompositionMapping000032E1[] = 
    {
        0x000030C4
    };

    static _CharacterInfo _character000032E1 =
    {
        0x000032E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E1,
        0x000032E1,
        0x000032E1
    };

    static Char _decompositionMapping000032E2[] = 
    {
        0x000030C6
    };

    static _CharacterInfo _character000032E2 =
    {
        0x000032E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E2,
        0x000032E2,
        0x000032E2
    };

    static Char _decompositionMapping000032E3[] = 
    {
        0x000030C8
    };

    static _CharacterInfo _character000032E3 =
    {
        0x000032E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E3,
        0x000032E3,
        0x000032E3
    };

    static Char _decompositionMapping000032E4[] = 
    {
        0x000030CA
    };

    static _CharacterInfo _character000032E4 =
    {
        0x000032E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E4,
        0x000032E4,
        0x000032E4
    };

    static Char _decompositionMapping000032E5[] = 
    {
        0x000030CB
    };

    static _CharacterInfo _character000032E5 =
    {
        0x000032E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E5,
        0x000032E5,
        0x000032E5
    };

    static Char _decompositionMapping000032E6[] = 
    {
        0x000030CC
    };

    static _CharacterInfo _character000032E6 =
    {
        0x000032E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E6,
        0x000032E6,
        0x000032E6
    };

    static Char _decompositionMapping000032E7[] = 
    {
        0x000030CD
    };

    static _CharacterInfo _character000032E7 =
    {
        0x000032E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E7,
        0x000032E7,
        0x000032E7
    };

    static Char _decompositionMapping000032E8[] = 
    {
        0x000030CE
    };

    static _CharacterInfo _character000032E8 =
    {
        0x000032E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E8,
        0x000032E8,
        0x000032E8
    };

    static Char _decompositionMapping000032E9[] = 
    {
        0x000030CF
    };

    static _CharacterInfo _character000032E9 =
    {
        0x000032E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032E9,
        0x000032E9,
        0x000032E9
    };

    static Char _decompositionMapping000032EA[] = 
    {
        0x000030D2
    };

    static _CharacterInfo _character000032EA =
    {
        0x000032EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032EA,
        0x000032EA,
        0x000032EA
    };

    static Char _decompositionMapping000032EB[] = 
    {
        0x000030D5
    };

    static _CharacterInfo _character000032EB =
    {
        0x000032EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032EB,
        0x000032EB,
        0x000032EB
    };

    static Char _decompositionMapping000032EC[] = 
    {
        0x000030D8
    };

    static _CharacterInfo _character000032EC =
    {
        0x000032EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032EC,
        0x000032EC,
        0x000032EC
    };

    static Char _decompositionMapping000032ED[] = 
    {
        0x000030DB
    };

    static _CharacterInfo _character000032ED =
    {
        0x000032ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032ED,
        0x000032ED,
        0x000032ED
    };

    static Char _decompositionMapping000032EE[] = 
    {
        0x000030DE
    };

    static _CharacterInfo _character000032EE =
    {
        0x000032EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032EE,
        0x000032EE,
        0x000032EE
    };

    static Char _decompositionMapping000032EF[] = 
    {
        0x000030DF
    };

    static _CharacterInfo _character000032EF =
    {
        0x000032EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032EF,
        0x000032EF,
        0x000032EF
    };

    static Char _decompositionMapping000032F0[] = 
    {
        0x000030E0
    };

    static _CharacterInfo _character000032F0 =
    {
        0x000032F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F0,
        0x000032F0,
        0x000032F0
    };

    static Char _decompositionMapping000032F1[] = 
    {
        0x000030E1
    };

    static _CharacterInfo _character000032F1 =
    {
        0x000032F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F1,
        0x000032F1,
        0x000032F1
    };

    static Char _decompositionMapping000032F2[] = 
    {
        0x000030E2
    };

    static _CharacterInfo _character000032F2 =
    {
        0x000032F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F2,
        0x000032F2,
        0x000032F2
    };

    static Char _decompositionMapping000032F3[] = 
    {
        0x000030E4
    };

    static _CharacterInfo _character000032F3 =
    {
        0x000032F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F3,
        0x000032F3,
        0x000032F3
    };

    static Char _decompositionMapping000032F4[] = 
    {
        0x000030E6
    };

    static _CharacterInfo _character000032F4 =
    {
        0x000032F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F4,
        0x000032F4,
        0x000032F4
    };

    static Char _decompositionMapping000032F5[] = 
    {
        0x000030E8
    };

    static _CharacterInfo _character000032F5 =
    {
        0x000032F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F5,
        0x000032F5,
        0x000032F5
    };

    static Char _decompositionMapping000032F6[] = 
    {
        0x000030E9
    };

    static _CharacterInfo _character000032F6 =
    {
        0x000032F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F6,
        0x000032F6,
        0x000032F6
    };

    static Char _decompositionMapping000032F7[] = 
    {
        0x000030EA
    };

    static _CharacterInfo _character000032F7 =
    {
        0x000032F7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F7,
        0x000032F7,
        0x000032F7
    };

    static Char _decompositionMapping000032F8[] = 
    {
        0x000030EB
    };

    static _CharacterInfo _character000032F8 =
    {
        0x000032F8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F8,
        0x000032F8,
        0x000032F8
    };

    static Char _decompositionMapping000032F9[] = 
    {
        0x000030EC
    };

    static _CharacterInfo _character000032F9 =
    {
        0x000032F9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032F9,
        0x000032F9,
        0x000032F9
    };

    static Char _decompositionMapping000032FA[] = 
    {
        0x000030ED
    };

    static _CharacterInfo _character000032FA =
    {
        0x000032FA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032FA,
        0x000032FA,
        0x000032FA
    };

    static Char _decompositionMapping000032FB[] = 
    {
        0x000030EF
    };

    static _CharacterInfo _character000032FB =
    {
        0x000032FB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032FB,
        0x000032FB,
        0x000032FB
    };

    static Char _decompositionMapping000032FC[] = 
    {
        0x000030F0
    };

    static _CharacterInfo _character000032FC =
    {
        0x000032FC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032FC,
        0x000032FC,
        0x000032FC
    };

    static Char _decompositionMapping000032FD[] = 
    {
        0x000030F1
    };

    static _CharacterInfo _character000032FD =
    {
        0x000032FD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032FD,
        0x000032FD,
        0x000032FD
    };

    static Char _decompositionMapping000032FE[] = 
    {
        0x000030F2
    };

    static _CharacterInfo _character000032FE =
    {
        0x000032FE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_circle,
        1,
        _decompositionMapping000032FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000032FE,
        0x000032FE,
        0x000032FE
    };

    static Char _decompositionMapping00003300[] = 
    {
        0x000030A2,
        0x000030D1,
        0x000030FC,
        0x000030C8
    };

    static _CharacterInfo _character00003300 =
    {
        0x00003300,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003300,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003300,
        0x00003300,
        0x00003300
    };

    static Char _decompositionMapping00003301[] = 
    {
        0x000030A2,
        0x000030EB,
        0x000030D5,
        0x000030A1
    };

    static _CharacterInfo _character00003301 =
    {
        0x00003301,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003301,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003301,
        0x00003301,
        0x00003301
    };

    static Char _decompositionMapping00003302[] = 
    {
        0x000030A2,
        0x000030F3,
        0x000030DA,
        0x000030A2
    };

    static _CharacterInfo _character00003302 =
    {
        0x00003302,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003302,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003302,
        0x00003302,
        0x00003302
    };

    static Char _decompositionMapping00003303[] = 
    {
        0x000030A2,
        0x000030FC,
        0x000030EB
    };

    static _CharacterInfo _character00003303 =
    {
        0x00003303,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003303,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003303,
        0x00003303,
        0x00003303
    };

    static Char _decompositionMapping00003304[] = 
    {
        0x000030A4,
        0x000030CB,
        0x000030F3,
        0x000030B0
    };

    static _CharacterInfo _character00003304 =
    {
        0x00003304,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003304,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003304,
        0x00003304,
        0x00003304
    };

    static Char _decompositionMapping00003305[] = 
    {
        0x000030A4,
        0x000030F3,
        0x000030C1
    };

    static _CharacterInfo _character00003305 =
    {
        0x00003305,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003305,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003305,
        0x00003305,
        0x00003305
    };

    static Char _decompositionMapping00003306[] = 
    {
        0x000030A6,
        0x000030A9,
        0x000030F3
    };

    static _CharacterInfo _character00003306 =
    {
        0x00003306,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003306,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003306,
        0x00003306,
        0x00003306
    };

    static Char _decompositionMapping00003307[] = 
    {
        0x000030A8,
        0x000030B9,
        0x000030AF,
        0x000030FC,
        0x000030C9
    };

    static _CharacterInfo _character00003307 =
    {
        0x00003307,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003307,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003307,
        0x00003307,
        0x00003307
    };

    static Char _decompositionMapping00003308[] = 
    {
        0x000030A8,
        0x000030FC,
        0x000030AB,
        0x000030FC
    };

    static _CharacterInfo _character00003308 =
    {
        0x00003308,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003308,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003308,
        0x00003308,
        0x00003308
    };

    static Char _decompositionMapping00003309[] = 
    {
        0x000030AA,
        0x000030F3,
        0x000030B9
    };

    static _CharacterInfo _character00003309 =
    {
        0x00003309,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003309,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003309,
        0x00003309,
        0x00003309
    };

    static Char _decompositionMapping0000330A[] = 
    {
        0x000030AA,
        0x000030FC,
        0x000030E0
    };

    static _CharacterInfo _character0000330A =
    {
        0x0000330A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000330A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330A,
        0x0000330A,
        0x0000330A
    };

    static Char _decompositionMapping0000330B[] = 
    {
        0x000030AB,
        0x000030A4,
        0x000030EA
    };

    static _CharacterInfo _character0000330B =
    {
        0x0000330B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000330B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330B,
        0x0000330B,
        0x0000330B
    };

    static Char _decompositionMapping0000330C[] = 
    {
        0x000030AB,
        0x000030E9,
        0x000030C3,
        0x000030C8
    };

    static _CharacterInfo _character0000330C =
    {
        0x0000330C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000330C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330C,
        0x0000330C,
        0x0000330C
    };

    static Char _decompositionMapping0000330D[] = 
    {
        0x000030AB,
        0x000030ED,
        0x000030EA,
        0x000030FC
    };

    static _CharacterInfo _character0000330D =
    {
        0x0000330D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000330D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330D,
        0x0000330D,
        0x0000330D
    };

    static Char _decompositionMapping0000330E[] = 
    {
        0x000030AC,
        0x000030ED,
        0x000030F3
    };

    static _CharacterInfo _character0000330E =
    {
        0x0000330E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000330E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330E,
        0x0000330E,
        0x0000330E
    };

    static Char _decompositionMapping0000330F[] = 
    {
        0x000030AC,
        0x000030F3,
        0x000030DE
    };

    static _CharacterInfo _character0000330F =
    {
        0x0000330F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000330F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000330F,
        0x0000330F,
        0x0000330F
    };

    static Char _decompositionMapping00003310[] = 
    {
        0x000030AE,
        0x000030AC
    };

    static _CharacterInfo _character00003310 =
    {
        0x00003310,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003310,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003310,
        0x00003310,
        0x00003310
    };

    static Char _decompositionMapping00003311[] = 
    {
        0x000030AE,
        0x000030CB,
        0x000030FC
    };

    static _CharacterInfo _character00003311 =
    {
        0x00003311,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003311,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003311,
        0x00003311,
        0x00003311
    };

    static Char _decompositionMapping00003312[] = 
    {
        0x000030AD,
        0x000030E5,
        0x000030EA,
        0x000030FC
    };

    static _CharacterInfo _character00003312 =
    {
        0x00003312,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003312,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003312,
        0x00003312,
        0x00003312
    };

    static Char _decompositionMapping00003313[] = 
    {
        0x000030AE,
        0x000030EB,
        0x000030C0,
        0x000030FC
    };

    static _CharacterInfo _character00003313 =
    {
        0x00003313,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003313,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003313,
        0x00003313,
        0x00003313
    };

    static Char _decompositionMapping00003314[] = 
    {
        0x000030AD,
        0x000030ED
    };

    static _CharacterInfo _character00003314 =
    {
        0x00003314,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003314,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003314,
        0x00003314,
        0x00003314
    };

    static Char _decompositionMapping00003315[] = 
    {
        0x000030AD,
        0x000030ED,
        0x000030B0,
        0x000030E9,
        0x000030E0
    };

    static _CharacterInfo _character00003315 =
    {
        0x00003315,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003315,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003315,
        0x00003315,
        0x00003315
    };

    static Char _decompositionMapping00003316[] = 
    {
        0x000030AD,
        0x000030ED,
        0x000030E1,
        0x000030FC,
        0x000030C8,
        0x000030EB
    };

    static _CharacterInfo _character00003316 =
    {
        0x00003316,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        6,
        _decompositionMapping00003316,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003316,
        0x00003316,
        0x00003316
    };

    static Char _decompositionMapping00003317[] = 
    {
        0x000030AD,
        0x000030ED,
        0x000030EF,
        0x000030C3,
        0x000030C8
    };

    static _CharacterInfo _character00003317 =
    {
        0x00003317,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003317,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003317,
        0x00003317,
        0x00003317
    };

    static Char _decompositionMapping00003318[] = 
    {
        0x000030B0,
        0x000030E9,
        0x000030E0
    };

    static _CharacterInfo _character00003318 =
    {
        0x00003318,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003318,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003318,
        0x00003318,
        0x00003318
    };

    static Char _decompositionMapping00003319[] = 
    {
        0x000030B0,
        0x000030E9,
        0x000030E0,
        0x000030C8,
        0x000030F3
    };

    static _CharacterInfo _character00003319 =
    {
        0x00003319,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003319,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003319,
        0x00003319,
        0x00003319
    };

    static Char _decompositionMapping0000331A[] = 
    {
        0x000030AF,
        0x000030EB,
        0x000030BC,
        0x000030A4,
        0x000030ED
    };

    static _CharacterInfo _character0000331A =
    {
        0x0000331A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping0000331A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331A,
        0x0000331A,
        0x0000331A
    };

    static Char _decompositionMapping0000331B[] = 
    {
        0x000030AF,
        0x000030ED,
        0x000030FC,
        0x000030CD
    };

    static _CharacterInfo _character0000331B =
    {
        0x0000331B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000331B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331B,
        0x0000331B,
        0x0000331B
    };

    static Char _decompositionMapping0000331C[] = 
    {
        0x000030B1,
        0x000030FC,
        0x000030B9
    };

    static _CharacterInfo _character0000331C =
    {
        0x0000331C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000331C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331C,
        0x0000331C,
        0x0000331C
    };

    static Char _decompositionMapping0000331D[] = 
    {
        0x000030B3,
        0x000030EB,
        0x000030CA
    };

    static _CharacterInfo _character0000331D =
    {
        0x0000331D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000331D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331D,
        0x0000331D,
        0x0000331D
    };

    static Char _decompositionMapping0000331E[] = 
    {
        0x000030B3,
        0x000030FC,
        0x000030DD
    };

    static _CharacterInfo _character0000331E =
    {
        0x0000331E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000331E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331E,
        0x0000331E,
        0x0000331E
    };

    static Char _decompositionMapping0000331F[] = 
    {
        0x000030B5,
        0x000030A4,
        0x000030AF,
        0x000030EB
    };

    static _CharacterInfo _character0000331F =
    {
        0x0000331F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000331F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000331F,
        0x0000331F,
        0x0000331F
    };

    static Char _decompositionMapping00003320[] = 
    {
        0x000030B5,
        0x000030F3,
        0x000030C1,
        0x000030FC,
        0x000030E0
    };

    static _CharacterInfo _character00003320 =
    {
        0x00003320,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003320,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003320,
        0x00003320,
        0x00003320
    };

    static Char _decompositionMapping00003321[] = 
    {
        0x000030B7,
        0x000030EA,
        0x000030F3,
        0x000030B0
    };

    static _CharacterInfo _character00003321 =
    {
        0x00003321,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003321,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003321,
        0x00003321,
        0x00003321
    };

    static Char _decompositionMapping00003322[] = 
    {
        0x000030BB,
        0x000030F3,
        0x000030C1
    };

    static _CharacterInfo _character00003322 =
    {
        0x00003322,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003322,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003322,
        0x00003322,
        0x00003322
    };

    static Char _decompositionMapping00003323[] = 
    {
        0x000030BB,
        0x000030F3,
        0x000030C8
    };

    static _CharacterInfo _character00003323 =
    {
        0x00003323,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003323,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003323,
        0x00003323,
        0x00003323
    };

    static Char _decompositionMapping00003324[] = 
    {
        0x000030C0,
        0x000030FC,
        0x000030B9
    };

    static _CharacterInfo _character00003324 =
    {
        0x00003324,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003324,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003324,
        0x00003324,
        0x00003324
    };

    static Char _decompositionMapping00003325[] = 
    {
        0x000030C7,
        0x000030B7
    };

    static _CharacterInfo _character00003325 =
    {
        0x00003325,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003325,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003325,
        0x00003325,
        0x00003325
    };

    static Char _decompositionMapping00003326[] = 
    {
        0x000030C9,
        0x000030EB
    };

    static _CharacterInfo _character00003326 =
    {
        0x00003326,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003326,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003326,
        0x00003326,
        0x00003326
    };

    static Char _decompositionMapping00003327[] = 
    {
        0x000030C8,
        0x000030F3
    };

    static _CharacterInfo _character00003327 =
    {
        0x00003327,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003327,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003327,
        0x00003327,
        0x00003327
    };

    static Char _decompositionMapping00003328[] = 
    {
        0x000030CA,
        0x000030CE
    };

    static _CharacterInfo _character00003328 =
    {
        0x00003328,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003328,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003328,
        0x00003328,
        0x00003328
    };

    static Char _decompositionMapping00003329[] = 
    {
        0x000030CE,
        0x000030C3,
        0x000030C8
    };

    static _CharacterInfo _character00003329 =
    {
        0x00003329,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003329,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003329,
        0x00003329,
        0x00003329
    };

    static Char _decompositionMapping0000332A[] = 
    {
        0x000030CF,
        0x000030A4,
        0x000030C4
    };

    static _CharacterInfo _character0000332A =
    {
        0x0000332A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000332A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332A,
        0x0000332A,
        0x0000332A
    };

    static Char _decompositionMapping0000332B[] = 
    {
        0x000030D1,
        0x000030FC,
        0x000030BB,
        0x000030F3,
        0x000030C8
    };

    static _CharacterInfo _character0000332B =
    {
        0x0000332B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping0000332B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332B,
        0x0000332B,
        0x0000332B
    };

    static Char _decompositionMapping0000332C[] = 
    {
        0x000030D1,
        0x000030FC,
        0x000030C4
    };

    static _CharacterInfo _character0000332C =
    {
        0x0000332C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000332C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332C,
        0x0000332C,
        0x0000332C
    };

    static Char _decompositionMapping0000332D[] = 
    {
        0x000030D0,
        0x000030FC,
        0x000030EC,
        0x000030EB
    };

    static _CharacterInfo _character0000332D =
    {
        0x0000332D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000332D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332D,
        0x0000332D,
        0x0000332D
    };

    static Char _decompositionMapping0000332E[] = 
    {
        0x000030D4,
        0x000030A2,
        0x000030B9,
        0x000030C8,
        0x000030EB
    };

    static _CharacterInfo _character0000332E =
    {
        0x0000332E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping0000332E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332E,
        0x0000332E,
        0x0000332E
    };

    static Char _decompositionMapping0000332F[] = 
    {
        0x000030D4,
        0x000030AF,
        0x000030EB
    };

    static _CharacterInfo _character0000332F =
    {
        0x0000332F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000332F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000332F,
        0x0000332F,
        0x0000332F
    };

    static Char _decompositionMapping00003330[] = 
    {
        0x000030D4,
        0x000030B3
    };

    static _CharacterInfo _character00003330 =
    {
        0x00003330,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003330,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003330,
        0x00003330,
        0x00003330
    };

    static Char _decompositionMapping00003331[] = 
    {
        0x000030D3,
        0x000030EB
    };

    static _CharacterInfo _character00003331 =
    {
        0x00003331,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003331,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003331,
        0x00003331,
        0x00003331
    };

    static Char _decompositionMapping00003332[] = 
    {
        0x000030D5,
        0x000030A1,
        0x000030E9,
        0x000030C3,
        0x000030C9
    };

    static _CharacterInfo _character00003332 =
    {
        0x00003332,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003332,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003332,
        0x00003332,
        0x00003332
    };

    static Char _decompositionMapping00003333[] = 
    {
        0x000030D5,
        0x000030A3,
        0x000030FC,
        0x000030C8
    };

    static _CharacterInfo _character00003333 =
    {
        0x00003333,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003333,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003333,
        0x00003333,
        0x00003333
    };

    static Char _decompositionMapping00003334[] = 
    {
        0x000030D6,
        0x000030C3,
        0x000030B7,
        0x000030A7,
        0x000030EB
    };

    static _CharacterInfo _character00003334 =
    {
        0x00003334,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003334,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003334,
        0x00003334,
        0x00003334
    };

    static Char _decompositionMapping00003335[] = 
    {
        0x000030D5,
        0x000030E9,
        0x000030F3
    };

    static _CharacterInfo _character00003335 =
    {
        0x00003335,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003335,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003335,
        0x00003335,
        0x00003335
    };

    static Char _decompositionMapping00003336[] = 
    {
        0x000030D8,
        0x000030AF,
        0x000030BF,
        0x000030FC,
        0x000030EB
    };

    static _CharacterInfo _character00003336 =
    {
        0x00003336,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003336,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003336,
        0x00003336,
        0x00003336
    };

    static Char _decompositionMapping00003337[] = 
    {
        0x000030DA,
        0x000030BD
    };

    static _CharacterInfo _character00003337 =
    {
        0x00003337,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003337,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003337,
        0x00003337,
        0x00003337
    };

    static Char _decompositionMapping00003338[] = 
    {
        0x000030DA,
        0x000030CB,
        0x000030D2
    };

    static _CharacterInfo _character00003338 =
    {
        0x00003338,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003338,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003338,
        0x00003338,
        0x00003338
    };

    static Char _decompositionMapping00003339[] = 
    {
        0x000030D8,
        0x000030EB,
        0x000030C4
    };

    static _CharacterInfo _character00003339 =
    {
        0x00003339,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003339,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003339,
        0x00003339,
        0x00003339
    };

    static Char _decompositionMapping0000333A[] = 
    {
        0x000030DA,
        0x000030F3,
        0x000030B9
    };

    static _CharacterInfo _character0000333A =
    {
        0x0000333A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000333A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333A,
        0x0000333A,
        0x0000333A
    };

    static Char _decompositionMapping0000333B[] = 
    {
        0x000030DA,
        0x000030FC,
        0x000030B8
    };

    static _CharacterInfo _character0000333B =
    {
        0x0000333B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000333B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333B,
        0x0000333B,
        0x0000333B
    };

    static Char _decompositionMapping0000333C[] = 
    {
        0x000030D9,
        0x000030FC,
        0x000030BF
    };

    static _CharacterInfo _character0000333C =
    {
        0x0000333C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000333C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333C,
        0x0000333C,
        0x0000333C
    };

    static Char _decompositionMapping0000333D[] = 
    {
        0x000030DD,
        0x000030A4,
        0x000030F3,
        0x000030C8
    };

    static _CharacterInfo _character0000333D =
    {
        0x0000333D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000333D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333D,
        0x0000333D,
        0x0000333D
    };

    static Char _decompositionMapping0000333E[] = 
    {
        0x000030DC,
        0x000030EB,
        0x000030C8
    };

    static _CharacterInfo _character0000333E =
    {
        0x0000333E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000333E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333E,
        0x0000333E,
        0x0000333E
    };

    static Char _decompositionMapping0000333F[] = 
    {
        0x000030DB,
        0x000030F3
    };

    static _CharacterInfo _character0000333F =
    {
        0x0000333F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000333F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000333F,
        0x0000333F,
        0x0000333F
    };

    static Char _decompositionMapping00003340[] = 
    {
        0x000030DD,
        0x000030F3,
        0x000030C9
    };

    static _CharacterInfo _character00003340 =
    {
        0x00003340,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003340,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003340,
        0x00003340,
        0x00003340
    };

    static Char _decompositionMapping00003341[] = 
    {
        0x000030DB,
        0x000030FC,
        0x000030EB
    };

    static _CharacterInfo _character00003341 =
    {
        0x00003341,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003341,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003341,
        0x00003341,
        0x00003341
    };

    static Char _decompositionMapping00003342[] = 
    {
        0x000030DB,
        0x000030FC,
        0x000030F3
    };

    static _CharacterInfo _character00003342 =
    {
        0x00003342,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003342,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003342,
        0x00003342,
        0x00003342
    };

    static Char _decompositionMapping00003343[] = 
    {
        0x000030DE,
        0x000030A4,
        0x000030AF,
        0x000030ED
    };

    static _CharacterInfo _character00003343 =
    {
        0x00003343,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003343,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003343,
        0x00003343,
        0x00003343
    };

    static Char _decompositionMapping00003344[] = 
    {
        0x000030DE,
        0x000030A4,
        0x000030EB
    };

    static _CharacterInfo _character00003344 =
    {
        0x00003344,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003344,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003344,
        0x00003344,
        0x00003344
    };

    static Char _decompositionMapping00003345[] = 
    {
        0x000030DE,
        0x000030C3,
        0x000030CF
    };

    static _CharacterInfo _character00003345 =
    {
        0x00003345,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003345,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003345,
        0x00003345,
        0x00003345
    };

    static Char _decompositionMapping00003346[] = 
    {
        0x000030DE,
        0x000030EB,
        0x000030AF
    };

    static _CharacterInfo _character00003346 =
    {
        0x00003346,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003346,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003346,
        0x00003346,
        0x00003346
    };

    static Char _decompositionMapping00003347[] = 
    {
        0x000030DE,
        0x000030F3,
        0x000030B7,
        0x000030E7,
        0x000030F3
    };

    static _CharacterInfo _character00003347 =
    {
        0x00003347,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003347,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003347,
        0x00003347,
        0x00003347
    };

    static Char _decompositionMapping00003348[] = 
    {
        0x000030DF,
        0x000030AF,
        0x000030ED,
        0x000030F3
    };

    static _CharacterInfo _character00003348 =
    {
        0x00003348,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003348,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003348,
        0x00003348,
        0x00003348
    };

    static Char _decompositionMapping00003349[] = 
    {
        0x000030DF,
        0x000030EA
    };

    static _CharacterInfo _character00003349 =
    {
        0x00003349,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003349,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003349,
        0x00003349,
        0x00003349
    };

    static Char _decompositionMapping0000334A[] = 
    {
        0x000030DF,
        0x000030EA,
        0x000030D0,
        0x000030FC,
        0x000030EB
    };

    static _CharacterInfo _character0000334A =
    {
        0x0000334A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping0000334A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334A,
        0x0000334A,
        0x0000334A
    };

    static Char _decompositionMapping0000334B[] = 
    {
        0x000030E1,
        0x000030AC
    };

    static _CharacterInfo _character0000334B =
    {
        0x0000334B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000334B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334B,
        0x0000334B,
        0x0000334B
    };

    static Char _decompositionMapping0000334C[] = 
    {
        0x000030E1,
        0x000030AC,
        0x000030C8,
        0x000030F3
    };

    static _CharacterInfo _character0000334C =
    {
        0x0000334C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000334C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334C,
        0x0000334C,
        0x0000334C
    };

    static Char _decompositionMapping0000334D[] = 
    {
        0x000030E1,
        0x000030FC,
        0x000030C8,
        0x000030EB
    };

    static _CharacterInfo _character0000334D =
    {
        0x0000334D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000334D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334D,
        0x0000334D,
        0x0000334D
    };

    static Char _decompositionMapping0000334E[] = 
    {
        0x000030E4,
        0x000030FC,
        0x000030C9
    };

    static _CharacterInfo _character0000334E =
    {
        0x0000334E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000334E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334E,
        0x0000334E,
        0x0000334E
    };

    static Char _decompositionMapping0000334F[] = 
    {
        0x000030E4,
        0x000030FC,
        0x000030EB
    };

    static _CharacterInfo _character0000334F =
    {
        0x0000334F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000334F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000334F,
        0x0000334F,
        0x0000334F
    };

    static Char _decompositionMapping00003350[] = 
    {
        0x000030E6,
        0x000030A2,
        0x000030F3
    };

    static _CharacterInfo _character00003350 =
    {
        0x00003350,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003350,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003350,
        0x00003350,
        0x00003350
    };

    static Char _decompositionMapping00003351[] = 
    {
        0x000030EA,
        0x000030C3,
        0x000030C8,
        0x000030EB
    };

    static _CharacterInfo _character00003351 =
    {
        0x00003351,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003351,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003351,
        0x00003351,
        0x00003351
    };

    static Char _decompositionMapping00003352[] = 
    {
        0x000030EA,
        0x000030E9
    };

    static _CharacterInfo _character00003352 =
    {
        0x00003352,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003352,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003352,
        0x00003352,
        0x00003352
    };

    static Char _decompositionMapping00003353[] = 
    {
        0x000030EB,
        0x000030D4,
        0x000030FC
    };

    static _CharacterInfo _character00003353 =
    {
        0x00003353,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003353,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003353,
        0x00003353,
        0x00003353
    };

    static Char _decompositionMapping00003354[] = 
    {
        0x000030EB,
        0x000030FC,
        0x000030D6,
        0x000030EB
    };

    static _CharacterInfo _character00003354 =
    {
        0x00003354,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003354,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003354,
        0x00003354,
        0x00003354
    };

    static Char _decompositionMapping00003355[] = 
    {
        0x000030EC,
        0x000030E0
    };

    static _CharacterInfo _character00003355 =
    {
        0x00003355,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003355,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003355,
        0x00003355,
        0x00003355
    };

    static Char _decompositionMapping00003356[] = 
    {
        0x000030EC,
        0x000030F3,
        0x000030C8,
        0x000030B2,
        0x000030F3
    };

    static _CharacterInfo _character00003356 =
    {
        0x00003356,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping00003356,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003356,
        0x00003356,
        0x00003356
    };

    static Char _decompositionMapping00003357[] = 
    {
        0x000030EF,
        0x000030C3,
        0x000030C8
    };

    static _CharacterInfo _character00003357 =
    {
        0x00003357,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003357,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003357,
        0x00003357,
        0x00003357
    };

    static Char _decompositionMapping00003358[] = 
    {
        0x00000030,
        0x000070B9
    };

    static _CharacterInfo _character00003358 =
    {
        0x00003358,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00003358,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003358,
        0x00003358,
        0x00003358
    };

    static Char _decompositionMapping00003359[] = 
    {
        0x00000031,
        0x000070B9
    };

    static _CharacterInfo _character00003359 =
    {
        0x00003359,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00003359,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003359,
        0x00003359,
        0x00003359
    };

    static Char _decompositionMapping0000335A[] = 
    {
        0x00000032,
        0x000070B9
    };

    static _CharacterInfo _character0000335A =
    {
        0x0000335A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335A,
        0x0000335A,
        0x0000335A
    };

    static Char _decompositionMapping0000335B[] = 
    {
        0x00000033,
        0x000070B9
    };

    static _CharacterInfo _character0000335B =
    {
        0x0000335B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335B,
        0x0000335B,
        0x0000335B
    };

    static Char _decompositionMapping0000335C[] = 
    {
        0x00000034,
        0x000070B9
    };

    static _CharacterInfo _character0000335C =
    {
        0x0000335C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335C,
        0x0000335C,
        0x0000335C
    };

    static Char _decompositionMapping0000335D[] = 
    {
        0x00000035,
        0x000070B9
    };

    static _CharacterInfo _character0000335D =
    {
        0x0000335D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335D,
        0x0000335D,
        0x0000335D
    };

    static Char _decompositionMapping0000335E[] = 
    {
        0x00000036,
        0x000070B9
    };

    static _CharacterInfo _character0000335E =
    {
        0x0000335E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335E,
        0x0000335E,
        0x0000335E
    };

    static Char _decompositionMapping0000335F[] = 
    {
        0x00000037,
        0x000070B9
    };

    static _CharacterInfo _character0000335F =
    {
        0x0000335F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000335F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000335F,
        0x0000335F,
        0x0000335F
    };

    static Char _decompositionMapping00003360[] = 
    {
        0x00000038,
        0x000070B9
    };

    static _CharacterInfo _character00003360 =
    {
        0x00003360,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00003360,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003360,
        0x00003360,
        0x00003360
    };

    static Char _decompositionMapping00003361[] = 
    {
        0x00000039,
        0x000070B9
    };

    static _CharacterInfo _character00003361 =
    {
        0x00003361,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping00003361,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003361,
        0x00003361,
        0x00003361
    };

    static Char _decompositionMapping00003362[] = 
    {
        0x00000031,
        0x00000030,
        0x000070B9
    };

    static _CharacterInfo _character00003362 =
    {
        0x00003362,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003362,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003362,
        0x00003362,
        0x00003362
    };

    static Char _decompositionMapping00003363[] = 
    {
        0x00000031,
        0x00000031,
        0x000070B9
    };

    static _CharacterInfo _character00003363 =
    {
        0x00003363,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003363,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003363,
        0x00003363,
        0x00003363
    };

    static Char _decompositionMapping00003364[] = 
    {
        0x00000031,
        0x00000032,
        0x000070B9
    };

    static _CharacterInfo _character00003364 =
    {
        0x00003364,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003364,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003364,
        0x00003364,
        0x00003364
    };

    static Char _decompositionMapping00003365[] = 
    {
        0x00000031,
        0x00000033,
        0x000070B9
    };

    static _CharacterInfo _character00003365 =
    {
        0x00003365,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003365,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003365,
        0x00003365,
        0x00003365
    };

    static Char _decompositionMapping00003366[] = 
    {
        0x00000031,
        0x00000034,
        0x000070B9
    };

    static _CharacterInfo _character00003366 =
    {
        0x00003366,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003366,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003366,
        0x00003366,
        0x00003366
    };

    static Char _decompositionMapping00003367[] = 
    {
        0x00000031,
        0x00000035,
        0x000070B9
    };

    static _CharacterInfo _character00003367 =
    {
        0x00003367,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003367,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003367,
        0x00003367,
        0x00003367
    };

    static Char _decompositionMapping00003368[] = 
    {
        0x00000031,
        0x00000036,
        0x000070B9
    };

    static _CharacterInfo _character00003368 =
    {
        0x00003368,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003368,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003368,
        0x00003368,
        0x00003368
    };

    static Char _decompositionMapping00003369[] = 
    {
        0x00000031,
        0x00000037,
        0x000070B9
    };

    static _CharacterInfo _character00003369 =
    {
        0x00003369,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003369,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003369,
        0x00003369,
        0x00003369
    };

    static Char _decompositionMapping0000336A[] = 
    {
        0x00000031,
        0x00000038,
        0x000070B9
    };

    static _CharacterInfo _character0000336A =
    {
        0x0000336A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336A,
        0x0000336A,
        0x0000336A
    };

    static Char _decompositionMapping0000336B[] = 
    {
        0x00000031,
        0x00000039,
        0x000070B9
    };

    static _CharacterInfo _character0000336B =
    {
        0x0000336B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336B,
        0x0000336B,
        0x0000336B
    };

    static Char _decompositionMapping0000336C[] = 
    {
        0x00000032,
        0x00000030,
        0x000070B9
    };

    static _CharacterInfo _character0000336C =
    {
        0x0000336C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336C,
        0x0000336C,
        0x0000336C
    };

    static Char _decompositionMapping0000336D[] = 
    {
        0x00000032,
        0x00000031,
        0x000070B9
    };

    static _CharacterInfo _character0000336D =
    {
        0x0000336D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336D,
        0x0000336D,
        0x0000336D
    };

    static Char _decompositionMapping0000336E[] = 
    {
        0x00000032,
        0x00000032,
        0x000070B9
    };

    static _CharacterInfo _character0000336E =
    {
        0x0000336E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336E,
        0x0000336E,
        0x0000336E
    };

    static Char _decompositionMapping0000336F[] = 
    {
        0x00000032,
        0x00000033,
        0x000070B9
    };

    static _CharacterInfo _character0000336F =
    {
        0x0000336F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000336F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000336F,
        0x0000336F,
        0x0000336F
    };

    static Char _decompositionMapping00003370[] = 
    {
        0x00000032,
        0x00000034,
        0x000070B9
    };

    static _CharacterInfo _character00003370 =
    {
        0x00003370,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping00003370,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003370,
        0x00003370,
        0x00003370
    };

    static Char _decompositionMapping00003371[] = 
    {
        0x00000068,
        0x00000050,
        0x00000061
    };

    static _CharacterInfo _character00003371 =
    {
        0x00003371,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003371,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003371,
        0x00003371,
        0x00003371
    };

    static Char _decompositionMapping00003372[] = 
    {
        0x00000064,
        0x00000061
    };

    static _CharacterInfo _character00003372 =
    {
        0x00003372,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003372,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003372,
        0x00003372,
        0x00003372
    };

    static Char _decompositionMapping00003373[] = 
    {
        0x00000041,
        0x00000055
    };

    static _CharacterInfo _character00003373 =
    {
        0x00003373,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003373,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003373,
        0x00003373,
        0x00003373
    };

    static Char _decompositionMapping00003374[] = 
    {
        0x00000062,
        0x00000061,
        0x00000072
    };

    static _CharacterInfo _character00003374 =
    {
        0x00003374,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003374,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003374,
        0x00003374,
        0x00003374
    };

    static Char _decompositionMapping00003375[] = 
    {
        0x0000006F,
        0x00000056
    };

    static _CharacterInfo _character00003375 =
    {
        0x00003375,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003375,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003375,
        0x00003375,
        0x00003375
    };

    static Char _decompositionMapping00003376[] = 
    {
        0x00000070,
        0x00000063
    };

    static _CharacterInfo _character00003376 =
    {
        0x00003376,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003376,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003376,
        0x00003376,
        0x00003376
    };

    static Char _decompositionMapping00003377[] = 
    {
        0x00000064,
        0x0000006D
    };

    static _CharacterInfo _character00003377 =
    {
        0x00003377,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003377,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003377,
        0x00003377,
        0x00003377
    };

    static Char _decompositionMapping00003378[] = 
    {
        0x00000064,
        0x0000006D,
        0x000000B2
    };

    static _CharacterInfo _character00003378 =
    {
        0x00003378,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003378,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003378,
        0x00003378,
        0x00003378
    };

    static Char _decompositionMapping00003379[] = 
    {
        0x00000064,
        0x0000006D,
        0x000000B3
    };

    static _CharacterInfo _character00003379 =
    {
        0x00003379,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003379,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003379,
        0x00003379,
        0x00003379
    };

    static Char _decompositionMapping0000337A[] = 
    {
        0x00000049,
        0x00000055
    };

    static _CharacterInfo _character0000337A =
    {
        0x0000337A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000337A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337A,
        0x0000337A,
        0x0000337A
    };

    static Char _decompositionMapping0000337B[] = 
    {
        0x00005E73,
        0x00006210
    };

    static _CharacterInfo _character0000337B =
    {
        0x0000337B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000337B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337B,
        0x0000337B,
        0x0000337B
    };

    static Char _decompositionMapping0000337C[] = 
    {
        0x0000662D,
        0x0000548C
    };

    static _CharacterInfo _character0000337C =
    {
        0x0000337C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000337C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337C,
        0x0000337C,
        0x0000337C
    };

    static Char _decompositionMapping0000337D[] = 
    {
        0x00005927,
        0x00006B63
    };

    static _CharacterInfo _character0000337D =
    {
        0x0000337D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000337D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337D,
        0x0000337D,
        0x0000337D
    };

    static Char _decompositionMapping0000337E[] = 
    {
        0x0000660E,
        0x00006CBB
    };

    static _CharacterInfo _character0000337E =
    {
        0x0000337E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000337E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337E,
        0x0000337E,
        0x0000337E
    };

    static Char _decompositionMapping0000337F[] = 
    {
        0x0000682A,
        0x00005F0F,
        0x00004F1A,
        0x0000793E
    };

    static _CharacterInfo _character0000337F =
    {
        0x0000337F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping0000337F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000337F,
        0x0000337F,
        0x0000337F
    };

    static Char _decompositionMapping00003380[] = 
    {
        0x00000070,
        0x00000041
    };

    static _CharacterInfo _character00003380 =
    {
        0x00003380,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003380,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003380,
        0x00003380,
        0x00003380
    };

    static Char _decompositionMapping00003381[] = 
    {
        0x0000006E,
        0x00000041
    };

    static _CharacterInfo _character00003381 =
    {
        0x00003381,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003381,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003381,
        0x00003381,
        0x00003381
    };

    static Char _decompositionMapping00003382[] = 
    {
        0x000003BC,
        0x00000041
    };

    static _CharacterInfo _character00003382 =
    {
        0x00003382,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003382,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003382,
        0x00003382,
        0x00003382
    };

    static Char _decompositionMapping00003383[] = 
    {
        0x0000006D,
        0x00000041
    };

    static _CharacterInfo _character00003383 =
    {
        0x00003383,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003383,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003383,
        0x00003383,
        0x00003383
    };

    static Char _decompositionMapping00003384[] = 
    {
        0x0000006B,
        0x00000041
    };

    static _CharacterInfo _character00003384 =
    {
        0x00003384,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003384,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003384,
        0x00003384,
        0x00003384
    };

    static Char _decompositionMapping00003385[] = 
    {
        0x0000004B,
        0x00000042
    };

    static _CharacterInfo _character00003385 =
    {
        0x00003385,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003385,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003385,
        0x00003385,
        0x00003385
    };

    static Char _decompositionMapping00003386[] = 
    {
        0x0000004D,
        0x00000042
    };

    static _CharacterInfo _character00003386 =
    {
        0x00003386,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003386,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003386,
        0x00003386,
        0x00003386
    };

    static Char _decompositionMapping00003387[] = 
    {
        0x00000047,
        0x00000042
    };

    static _CharacterInfo _character00003387 =
    {
        0x00003387,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003387,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003387,
        0x00003387,
        0x00003387
    };

    static Char _decompositionMapping00003388[] = 
    {
        0x00000063,
        0x00000061,
        0x0000006C
    };

    static _CharacterInfo _character00003388 =
    {
        0x00003388,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003388,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003388,
        0x00003388,
        0x00003388
    };

    static Char _decompositionMapping00003389[] = 
    {
        0x0000006B,
        0x00000063,
        0x00000061,
        0x0000006C
    };

    static _CharacterInfo _character00003389 =
    {
        0x00003389,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping00003389,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003389,
        0x00003389,
        0x00003389
    };

    static Char _decompositionMapping0000338A[] = 
    {
        0x00000070,
        0x00000046
    };

    static _CharacterInfo _character0000338A =
    {
        0x0000338A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338A,
        0x0000338A,
        0x0000338A
    };

    static Char _decompositionMapping0000338B[] = 
    {
        0x0000006E,
        0x00000046
    };

    static _CharacterInfo _character0000338B =
    {
        0x0000338B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338B,
        0x0000338B,
        0x0000338B
    };

    static Char _decompositionMapping0000338C[] = 
    {
        0x000003BC,
        0x00000046
    };

    static _CharacterInfo _character0000338C =
    {
        0x0000338C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338C,
        0x0000338C,
        0x0000338C
    };

    static Char _decompositionMapping0000338D[] = 
    {
        0x000003BC,
        0x00000067
    };

    static _CharacterInfo _character0000338D =
    {
        0x0000338D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338D,
        0x0000338D,
        0x0000338D
    };

    static Char _decompositionMapping0000338E[] = 
    {
        0x0000006D,
        0x00000067
    };

    static _CharacterInfo _character0000338E =
    {
        0x0000338E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338E,
        0x0000338E,
        0x0000338E
    };

    static Char _decompositionMapping0000338F[] = 
    {
        0x0000006B,
        0x00000067
    };

    static _CharacterInfo _character0000338F =
    {
        0x0000338F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000338F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000338F,
        0x0000338F,
        0x0000338F
    };

    static Char _decompositionMapping00003390[] = 
    {
        0x00000048,
        0x0000007A
    };

    static _CharacterInfo _character00003390 =
    {
        0x00003390,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003390,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003390,
        0x00003390,
        0x00003390
    };

    static Char _decompositionMapping00003391[] = 
    {
        0x0000006B,
        0x00000048,
        0x0000007A
    };

    static _CharacterInfo _character00003391 =
    {
        0x00003391,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003391,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003391,
        0x00003391,
        0x00003391
    };

    static Char _decompositionMapping00003392[] = 
    {
        0x0000004D,
        0x00000048,
        0x0000007A
    };

    static _CharacterInfo _character00003392 =
    {
        0x00003392,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003392,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003392,
        0x00003392,
        0x00003392
    };

    static Char _decompositionMapping00003393[] = 
    {
        0x00000047,
        0x00000048,
        0x0000007A
    };

    static _CharacterInfo _character00003393 =
    {
        0x00003393,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003393,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003393,
        0x00003393,
        0x00003393
    };

    static Char _decompositionMapping00003394[] = 
    {
        0x00000054,
        0x00000048,
        0x0000007A
    };

    static _CharacterInfo _character00003394 =
    {
        0x00003394,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping00003394,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003394,
        0x00003394,
        0x00003394
    };

    static Char _decompositionMapping00003395[] = 
    {
        0x000003BC,
        0x00002113
    };

    static _CharacterInfo _character00003395 =
    {
        0x00003395,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003395,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003395,
        0x00003395,
        0x00003395
    };

    static Char _decompositionMapping00003396[] = 
    {
        0x0000006D,
        0x00002113
    };

    static _CharacterInfo _character00003396 =
    {
        0x00003396,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003396,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003396,
        0x00003396,
        0x00003396
    };

    static Char _decompositionMapping00003397[] = 
    {
        0x00000064,
        0x00002113
    };

    static _CharacterInfo _character00003397 =
    {
        0x00003397,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003397,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003397,
        0x00003397,
        0x00003397
    };

    static Char _decompositionMapping00003398[] = 
    {
        0x0000006B,
        0x00002113
    };

    static _CharacterInfo _character00003398 =
    {
        0x00003398,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003398,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003398,
        0x00003398,
        0x00003398
    };

    static Char _decompositionMapping00003399[] = 
    {
        0x00000066,
        0x0000006D
    };

    static _CharacterInfo _character00003399 =
    {
        0x00003399,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping00003399,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003399,
        0x00003399,
        0x00003399
    };

    static Char _decompositionMapping0000339A[] = 
    {
        0x0000006E,
        0x0000006D
    };

    static _CharacterInfo _character0000339A =
    {
        0x0000339A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000339A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339A,
        0x0000339A,
        0x0000339A
    };

    static Char _decompositionMapping0000339B[] = 
    {
        0x000003BC,
        0x0000006D
    };

    static _CharacterInfo _character0000339B =
    {
        0x0000339B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000339B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339B,
        0x0000339B,
        0x0000339B
    };

    static Char _decompositionMapping0000339C[] = 
    {
        0x0000006D,
        0x0000006D
    };

    static _CharacterInfo _character0000339C =
    {
        0x0000339C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000339C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339C,
        0x0000339C,
        0x0000339C
    };

    static Char _decompositionMapping0000339D[] = 
    {
        0x00000063,
        0x0000006D
    };

    static _CharacterInfo _character0000339D =
    {
        0x0000339D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000339D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339D,
        0x0000339D,
        0x0000339D
    };

    static Char _decompositionMapping0000339E[] = 
    {
        0x0000006B,
        0x0000006D
    };

    static _CharacterInfo _character0000339E =
    {
        0x0000339E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping0000339E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339E,
        0x0000339E,
        0x0000339E
    };

    static Char _decompositionMapping0000339F[] = 
    {
        0x0000006D,
        0x0000006D,
        0x000000B2
    };

    static _CharacterInfo _character0000339F =
    {
        0x0000339F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping0000339F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000339F,
        0x0000339F,
        0x0000339F
    };

    static Char _decompositionMapping000033A0[] = 
    {
        0x00000063,
        0x0000006D,
        0x000000B2
    };

    static _CharacterInfo _character000033A0 =
    {
        0x000033A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A0,
        0x000033A0,
        0x000033A0
    };

    static Char _decompositionMapping000033A1[] = 
    {
        0x0000006D,
        0x000000B2
    };

    static _CharacterInfo _character000033A1 =
    {
        0x000033A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A1,
        0x000033A1,
        0x000033A1
    };

    static Char _decompositionMapping000033A2[] = 
    {
        0x0000006B,
        0x0000006D,
        0x000000B2
    };

    static _CharacterInfo _character000033A2 =
    {
        0x000033A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A2,
        0x000033A2,
        0x000033A2
    };

    static Char _decompositionMapping000033A3[] = 
    {
        0x0000006D,
        0x0000006D,
        0x000000B3
    };

    static _CharacterInfo _character000033A3 =
    {
        0x000033A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A3,
        0x000033A3,
        0x000033A3
    };

    static Char _decompositionMapping000033A4[] = 
    {
        0x00000063,
        0x0000006D,
        0x000000B3
    };

    static _CharacterInfo _character000033A4 =
    {
        0x000033A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A4,
        0x000033A4,
        0x000033A4
    };

    static Char _decompositionMapping000033A5[] = 
    {
        0x0000006D,
        0x000000B3
    };

    static _CharacterInfo _character000033A5 =
    {
        0x000033A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A5,
        0x000033A5,
        0x000033A5
    };

    static Char _decompositionMapping000033A6[] = 
    {
        0x0000006B,
        0x0000006D,
        0x000000B3
    };

    static _CharacterInfo _character000033A6 =
    {
        0x000033A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A6,
        0x000033A6,
        0x000033A6
    };

    static Char _decompositionMapping000033A7[] = 
    {
        0x0000006D,
        0x00002215,
        0x00000073
    };

    static _CharacterInfo _character000033A7 =
    {
        0x000033A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A7,
        0x000033A7,
        0x000033A7
    };

    static Char _decompositionMapping000033A8[] = 
    {
        0x0000006D,
        0x00002215,
        0x00000073,
        0x000000B2
    };

    static _CharacterInfo _character000033A8 =
    {
        0x000033A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping000033A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A8,
        0x000033A8,
        0x000033A8
    };

    static Char _decompositionMapping000033A9[] = 
    {
        0x00000050,
        0x00000061
    };

    static _CharacterInfo _character000033A9 =
    {
        0x000033A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033A9,
        0x000033A9,
        0x000033A9
    };

    static Char _decompositionMapping000033AA[] = 
    {
        0x0000006B,
        0x00000050,
        0x00000061
    };

    static _CharacterInfo _character000033AA =
    {
        0x000033AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AA,
        0x000033AA,
        0x000033AA
    };

    static Char _decompositionMapping000033AB[] = 
    {
        0x0000004D,
        0x00000050,
        0x00000061
    };

    static _CharacterInfo _character000033AB =
    {
        0x000033AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AB,
        0x000033AB,
        0x000033AB
    };

    static Char _decompositionMapping000033AC[] = 
    {
        0x00000047,
        0x00000050,
        0x00000061
    };

    static _CharacterInfo _character000033AC =
    {
        0x000033AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AC,
        0x000033AC,
        0x000033AC
    };

    static Char _decompositionMapping000033AD[] = 
    {
        0x00000072,
        0x00000061,
        0x00000064
    };

    static _CharacterInfo _character000033AD =
    {
        0x000033AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AD,
        0x000033AD,
        0x000033AD
    };

    static Char _decompositionMapping000033AE[] = 
    {
        0x00000072,
        0x00000061,
        0x00000064,
        0x00002215,
        0x00000073
    };

    static _CharacterInfo _character000033AE =
    {
        0x000033AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        5,
        _decompositionMapping000033AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AE,
        0x000033AE,
        0x000033AE
    };

    static Char _decompositionMapping000033AF[] = 
    {
        0x00000072,
        0x00000061,
        0x00000064,
        0x00002215,
        0x00000073,
        0x000000B2
    };

    static _CharacterInfo _character000033AF =
    {
        0x000033AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        6,
        _decompositionMapping000033AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033AF,
        0x000033AF,
        0x000033AF
    };

    static Char _decompositionMapping000033B0[] = 
    {
        0x00000070,
        0x00000073
    };

    static _CharacterInfo _character000033B0 =
    {
        0x000033B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B0,
        0x000033B0,
        0x000033B0
    };

    static Char _decompositionMapping000033B1[] = 
    {
        0x0000006E,
        0x00000073
    };

    static _CharacterInfo _character000033B1 =
    {
        0x000033B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B1,
        0x000033B1,
        0x000033B1
    };

    static Char _decompositionMapping000033B2[] = 
    {
        0x000003BC,
        0x00000073
    };

    static _CharacterInfo _character000033B2 =
    {
        0x000033B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B2,
        0x000033B2,
        0x000033B2
    };

    static Char _decompositionMapping000033B3[] = 
    {
        0x0000006D,
        0x00000073
    };

    static _CharacterInfo _character000033B3 =
    {
        0x000033B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B3,
        0x000033B3,
        0x000033B3
    };

    static Char _decompositionMapping000033B4[] = 
    {
        0x00000070,
        0x00000056
    };

    static _CharacterInfo _character000033B4 =
    {
        0x000033B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B4,
        0x000033B4,
        0x000033B4
    };

    static Char _decompositionMapping000033B5[] = 
    {
        0x0000006E,
        0x00000056
    };

    static _CharacterInfo _character000033B5 =
    {
        0x000033B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B5,
        0x000033B5,
        0x000033B5
    };

    static Char _decompositionMapping000033B6[] = 
    {
        0x000003BC,
        0x00000056
    };

    static _CharacterInfo _character000033B6 =
    {
        0x000033B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B6,
        0x000033B6,
        0x000033B6
    };

    static Char _decompositionMapping000033B7[] = 
    {
        0x0000006D,
        0x00000056
    };

    static _CharacterInfo _character000033B7 =
    {
        0x000033B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B7,
        0x000033B7,
        0x000033B7
    };

    static Char _decompositionMapping000033B8[] = 
    {
        0x0000006B,
        0x00000056
    };

    static _CharacterInfo _character000033B8 =
    {
        0x000033B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B8,
        0x000033B8,
        0x000033B8
    };

    static Char _decompositionMapping000033B9[] = 
    {
        0x0000004D,
        0x00000056
    };

    static _CharacterInfo _character000033B9 =
    {
        0x000033B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033B9,
        0x000033B9,
        0x000033B9
    };

    static Char _decompositionMapping000033BA[] = 
    {
        0x00000070,
        0x00000057
    };

    static _CharacterInfo _character000033BA =
    {
        0x000033BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BA,
        0x000033BA,
        0x000033BA
    };

    static Char _decompositionMapping000033BB[] = 
    {
        0x0000006E,
        0x00000057
    };

    static _CharacterInfo _character000033BB =
    {
        0x000033BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BB,
        0x000033BB,
        0x000033BB
    };

    static Char _decompositionMapping000033BC[] = 
    {
        0x000003BC,
        0x00000057
    };

    static _CharacterInfo _character000033BC =
    {
        0x000033BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BC,
        0x000033BC,
        0x000033BC
    };

    static Char _decompositionMapping000033BD[] = 
    {
        0x0000006D,
        0x00000057
    };

    static _CharacterInfo _character000033BD =
    {
        0x000033BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BD,
        0x000033BD,
        0x000033BD
    };

    static Char _decompositionMapping000033BE[] = 
    {
        0x0000006B,
        0x00000057
    };

    static _CharacterInfo _character000033BE =
    {
        0x000033BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BE,
        0x000033BE,
        0x000033BE
    };

    static Char _decompositionMapping000033BF[] = 
    {
        0x0000004D,
        0x00000057
    };

    static _CharacterInfo _character000033BF =
    {
        0x000033BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033BF,
        0x000033BF,
        0x000033BF
    };

    static Char _decompositionMapping000033C0[] = 
    {
        0x0000006B,
        0x000003A9
    };

    static _CharacterInfo _character000033C0 =
    {
        0x000033C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C0,
        0x000033C0,
        0x000033C0
    };

    static Char _decompositionMapping000033C1[] = 
    {
        0x0000004D,
        0x000003A9
    };

    static _CharacterInfo _character000033C1 =
    {
        0x000033C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C1,
        0x000033C1,
        0x000033C1
    };

    static Char _decompositionMapping000033C2[] = 
    {
        0x00000061,
        0x0000002E,
        0x0000006D,
        0x0000002E
    };

    static _CharacterInfo _character000033C2 =
    {
        0x000033C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping000033C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C2,
        0x000033C2,
        0x000033C2
    };

    static Char _decompositionMapping000033C3[] = 
    {
        0x00000042,
        0x00000071
    };

    static _CharacterInfo _character000033C3 =
    {
        0x000033C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C3,
        0x000033C3,
        0x000033C3
    };

    static Char _decompositionMapping000033C4[] = 
    {
        0x00000063,
        0x00000063
    };

    static _CharacterInfo _character000033C4 =
    {
        0x000033C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C4,
        0x000033C4,
        0x000033C4
    };

    static Char _decompositionMapping000033C5[] = 
    {
        0x00000063,
        0x00000064
    };

    static _CharacterInfo _character000033C5 =
    {
        0x000033C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C5,
        0x000033C5,
        0x000033C5
    };

    static Char _decompositionMapping000033C6[] = 
    {
        0x00000043,
        0x00002215,
        0x0000006B,
        0x00000067
    };

    static _CharacterInfo _character000033C6 =
    {
        0x000033C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping000033C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C6,
        0x000033C6,
        0x000033C6
    };

    static Char _decompositionMapping000033C7[] = 
    {
        0x00000043,
        0x0000006F,
        0x0000002E
    };

    static _CharacterInfo _character000033C7 =
    {
        0x000033C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C7,
        0x000033C7,
        0x000033C7
    };

    static Char _decompositionMapping000033C8[] = 
    {
        0x00000064,
        0x00000042
    };

    static _CharacterInfo _character000033C8 =
    {
        0x000033C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C8,
        0x000033C8,
        0x000033C8
    };

    static Char _decompositionMapping000033C9[] = 
    {
        0x00000047,
        0x00000079
    };

    static _CharacterInfo _character000033C9 =
    {
        0x000033C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033C9,
        0x000033C9,
        0x000033C9
    };

    static Char _decompositionMapping000033CA[] = 
    {
        0x00000068,
        0x00000061
    };

    static _CharacterInfo _character000033CA =
    {
        0x000033CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CA,
        0x000033CA,
        0x000033CA
    };

    static Char _decompositionMapping000033CB[] = 
    {
        0x00000048,
        0x00000050
    };

    static _CharacterInfo _character000033CB =
    {
        0x000033CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CB,
        0x000033CB,
        0x000033CB
    };

    static Char _decompositionMapping000033CC[] = 
    {
        0x00000069,
        0x0000006E
    };

    static _CharacterInfo _character000033CC =
    {
        0x000033CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CC,
        0x000033CC,
        0x000033CC
    };

    static Char _decompositionMapping000033CD[] = 
    {
        0x0000004B,
        0x0000004B
    };

    static _CharacterInfo _character000033CD =
    {
        0x000033CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CD,
        0x000033CD,
        0x000033CD
    };

    static Char _decompositionMapping000033CE[] = 
    {
        0x0000004B,
        0x0000004D
    };

    static _CharacterInfo _character000033CE =
    {
        0x000033CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CE,
        0x000033CE,
        0x000033CE
    };

    static Char _decompositionMapping000033CF[] = 
    {
        0x0000006B,
        0x00000074
    };

    static _CharacterInfo _character000033CF =
    {
        0x000033CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033CF,
        0x000033CF,
        0x000033CF
    };

    static Char _decompositionMapping000033D0[] = 
    {
        0x0000006C,
        0x0000006D
    };

    static _CharacterInfo _character000033D0 =
    {
        0x000033D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D0,
        0x000033D0,
        0x000033D0
    };

    static Char _decompositionMapping000033D1[] = 
    {
        0x0000006C,
        0x0000006E
    };

    static _CharacterInfo _character000033D1 =
    {
        0x000033D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D1,
        0x000033D1,
        0x000033D1
    };

    static Char _decompositionMapping000033D2[] = 
    {
        0x0000006C,
        0x0000006F,
        0x00000067
    };

    static _CharacterInfo _character000033D2 =
    {
        0x000033D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D2,
        0x000033D2,
        0x000033D2
    };

    static Char _decompositionMapping000033D3[] = 
    {
        0x0000006C,
        0x00000078
    };

    static _CharacterInfo _character000033D3 =
    {
        0x000033D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D3,
        0x000033D3,
        0x000033D3
    };

    static Char _decompositionMapping000033D4[] = 
    {
        0x0000006D,
        0x00000062
    };

    static _CharacterInfo _character000033D4 =
    {
        0x000033D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D4,
        0x000033D4,
        0x000033D4
    };

    static Char _decompositionMapping000033D5[] = 
    {
        0x0000006D,
        0x00000069,
        0x0000006C
    };

    static _CharacterInfo _character000033D5 =
    {
        0x000033D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D5,
        0x000033D5,
        0x000033D5
    };

    static Char _decompositionMapping000033D6[] = 
    {
        0x0000006D,
        0x0000006F,
        0x0000006C
    };

    static _CharacterInfo _character000033D6 =
    {
        0x000033D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D6,
        0x000033D6,
        0x000033D6
    };

    static Char _decompositionMapping000033D7[] = 
    {
        0x00000050,
        0x00000048
    };

    static _CharacterInfo _character000033D7 =
    {
        0x000033D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D7,
        0x000033D7,
        0x000033D7
    };

    static Char _decompositionMapping000033D8[] = 
    {
        0x00000070,
        0x0000002E,
        0x0000006D,
        0x0000002E
    };

    static _CharacterInfo _character000033D8 =
    {
        0x000033D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        4,
        _decompositionMapping000033D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D8,
        0x000033D8,
        0x000033D8
    };

    static Char _decompositionMapping000033D9[] = 
    {
        0x00000050,
        0x00000050,
        0x0000004D
    };

    static _CharacterInfo _character000033D9 =
    {
        0x000033D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033D9,
        0x000033D9,
        0x000033D9
    };

    static Char _decompositionMapping000033DA[] = 
    {
        0x00000050,
        0x00000052
    };

    static _CharacterInfo _character000033DA =
    {
        0x000033DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DA,
        0x000033DA,
        0x000033DA
    };

    static Char _decompositionMapping000033DB[] = 
    {
        0x00000073,
        0x00000072
    };

    static _CharacterInfo _character000033DB =
    {
        0x000033DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DB,
        0x000033DB,
        0x000033DB
    };

    static Char _decompositionMapping000033DC[] = 
    {
        0x00000053,
        0x00000076
    };

    static _CharacterInfo _character000033DC =
    {
        0x000033DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DC,
        0x000033DC,
        0x000033DC
    };

    static Char _decompositionMapping000033DD[] = 
    {
        0x00000057,
        0x00000062
    };

    static _CharacterInfo _character000033DD =
    {
        0x000033DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_square,
        2,
        _decompositionMapping000033DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DD,
        0x000033DD,
        0x000033DD
    };

    static Char _decompositionMapping000033DE[] = 
    {
        0x00000056,
        0x00002215,
        0x0000006D
    };

    static _CharacterInfo _character000033DE =
    {
        0x000033DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DE,
        0x000033DE,
        0x000033DE
    };

    static Char _decompositionMapping000033DF[] = 
    {
        0x00000041,
        0x00002215,
        0x0000006D
    };

    static _CharacterInfo _character000033DF =
    {
        0x000033DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033DF,
        0x000033DF,
        0x000033DF
    };

    static Char _decompositionMapping000033E0[] = 
    {
        0x00000031,
        0x000065E5
    };

    static _CharacterInfo _character000033E0 =
    {
        0x000033E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E0,
        0x000033E0,
        0x000033E0
    };

    static Char _decompositionMapping000033E1[] = 
    {
        0x00000032,
        0x000065E5
    };

    static _CharacterInfo _character000033E1 =
    {
        0x000033E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E1,
        0x000033E1,
        0x000033E1
    };

    static Char _decompositionMapping000033E2[] = 
    {
        0x00000033,
        0x000065E5
    };

    static _CharacterInfo _character000033E2 =
    {
        0x000033E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E2,
        0x000033E2,
        0x000033E2
    };

    static Char _decompositionMapping000033E3[] = 
    {
        0x00000034,
        0x000065E5
    };

    static _CharacterInfo _character000033E3 =
    {
        0x000033E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E3,
        0x000033E3,
        0x000033E3
    };

    static Char _decompositionMapping000033E4[] = 
    {
        0x00000035,
        0x000065E5
    };

    static _CharacterInfo _character000033E4 =
    {
        0x000033E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E4,
        0x000033E4,
        0x000033E4
    };

    static Char _decompositionMapping000033E5[] = 
    {
        0x00000036,
        0x000065E5
    };

    static _CharacterInfo _character000033E5 =
    {
        0x000033E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E5,
        0x000033E5,
        0x000033E5
    };

    static Char _decompositionMapping000033E6[] = 
    {
        0x00000037,
        0x000065E5
    };

    static _CharacterInfo _character000033E6 =
    {
        0x000033E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E6,
        0x000033E6,
        0x000033E6
    };

    static Char _decompositionMapping000033E7[] = 
    {
        0x00000038,
        0x000065E5
    };

    static _CharacterInfo _character000033E7 =
    {
        0x000033E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E7,
        0x000033E7,
        0x000033E7
    };

    static Char _decompositionMapping000033E8[] = 
    {
        0x00000039,
        0x000065E5
    };

    static _CharacterInfo _character000033E8 =
    {
        0x000033E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping000033E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E8,
        0x000033E8,
        0x000033E8
    };

    static Char _decompositionMapping000033E9[] = 
    {
        0x00000031,
        0x00000030,
        0x000065E5
    };

    static _CharacterInfo _character000033E9 =
    {
        0x000033E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033E9,
        0x000033E9,
        0x000033E9
    };

    static Char _decompositionMapping000033EA[] = 
    {
        0x00000031,
        0x00000031,
        0x000065E5
    };

    static _CharacterInfo _character000033EA =
    {
        0x000033EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033EA,
        0x000033EA,
        0x000033EA
    };

    static Char _decompositionMapping000033EB[] = 
    {
        0x00000031,
        0x00000032,
        0x000065E5
    };

    static _CharacterInfo _character000033EB =
    {
        0x000033EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033EB,
        0x000033EB,
        0x000033EB
    };

    static Char _decompositionMapping000033EC[] = 
    {
        0x00000031,
        0x00000033,
        0x000065E5
    };

    static _CharacterInfo _character000033EC =
    {
        0x000033EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033EC,
        0x000033EC,
        0x000033EC
    };

    static Char _decompositionMapping000033ED[] = 
    {
        0x00000031,
        0x00000034,
        0x000065E5
    };

    static _CharacterInfo _character000033ED =
    {
        0x000033ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033ED,
        0x000033ED,
        0x000033ED
    };

    static Char _decompositionMapping000033EE[] = 
    {
        0x00000031,
        0x00000035,
        0x000065E5
    };

    static _CharacterInfo _character000033EE =
    {
        0x000033EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033EE,
        0x000033EE,
        0x000033EE
    };

    static Char _decompositionMapping000033EF[] = 
    {
        0x00000031,
        0x00000036,
        0x000065E5
    };

    static _CharacterInfo _character000033EF =
    {
        0x000033EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033EF,
        0x000033EF,
        0x000033EF
    };

    static Char _decompositionMapping000033F0[] = 
    {
        0x00000031,
        0x00000037,
        0x000065E5
    };

    static _CharacterInfo _character000033F0 =
    {
        0x000033F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F0,
        0x000033F0,
        0x000033F0
    };

    static Char _decompositionMapping000033F1[] = 
    {
        0x00000031,
        0x00000038,
        0x000065E5
    };

    static _CharacterInfo _character000033F1 =
    {
        0x000033F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F1,
        0x000033F1,
        0x000033F1
    };

    static Char _decompositionMapping000033F2[] = 
    {
        0x00000031,
        0x00000039,
        0x000065E5
    };

    static _CharacterInfo _character000033F2 =
    {
        0x000033F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F2,
        0x000033F2,
        0x000033F2
    };

    static Char _decompositionMapping000033F3[] = 
    {
        0x00000032,
        0x00000030,
        0x000065E5
    };

    static _CharacterInfo _character000033F3 =
    {
        0x000033F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F3,
        0x000033F3,
        0x000033F3
    };

    static Char _decompositionMapping000033F4[] = 
    {
        0x00000032,
        0x00000031,
        0x000065E5
    };

    static _CharacterInfo _character000033F4 =
    {
        0x000033F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F4,
        0x000033F4,
        0x000033F4
    };

    static Char _decompositionMapping000033F5[] = 
    {
        0x00000032,
        0x00000032,
        0x000065E5
    };

    static _CharacterInfo _character000033F5 =
    {
        0x000033F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F5,
        0x000033F5,
        0x000033F5
    };

    static Char _decompositionMapping000033F6[] = 
    {
        0x00000032,
        0x00000033,
        0x000065E5
    };

    static _CharacterInfo _character000033F6 =
    {
        0x000033F6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F6,
        0x000033F6,
        0x000033F6
    };

    static Char _decompositionMapping000033F7[] = 
    {
        0x00000032,
        0x00000034,
        0x000065E5
    };

    static _CharacterInfo _character000033F7 =
    {
        0x000033F7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F7,
        0x000033F7,
        0x000033F7
    };

    static Char _decompositionMapping000033F8[] = 
    {
        0x00000032,
        0x00000035,
        0x000065E5
    };

    static _CharacterInfo _character000033F8 =
    {
        0x000033F8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F8,
        0x000033F8,
        0x000033F8
    };

    static Char _decompositionMapping000033F9[] = 
    {
        0x00000032,
        0x00000036,
        0x000065E5
    };

    static _CharacterInfo _character000033F9 =
    {
        0x000033F9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033F9,
        0x000033F9,
        0x000033F9
    };

    static Char _decompositionMapping000033FA[] = 
    {
        0x00000032,
        0x00000037,
        0x000065E5
    };

    static _CharacterInfo _character000033FA =
    {
        0x000033FA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FA,
        0x000033FA,
        0x000033FA
    };

    static Char _decompositionMapping000033FB[] = 
    {
        0x00000032,
        0x00000038,
        0x000065E5
    };

    static _CharacterInfo _character000033FB =
    {
        0x000033FB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FB,
        0x000033FB,
        0x000033FB
    };

    static Char _decompositionMapping000033FC[] = 
    {
        0x00000032,
        0x00000039,
        0x000065E5
    };

    static _CharacterInfo _character000033FC =
    {
        0x000033FC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FC,
        0x000033FC,
        0x000033FC
    };

    static Char _decompositionMapping000033FD[] = 
    {
        0x00000033,
        0x00000030,
        0x000065E5
    };

    static _CharacterInfo _character000033FD =
    {
        0x000033FD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FD,
        0x000033FD,
        0x000033FD
    };

    static Char _decompositionMapping000033FE[] = 
    {
        0x00000033,
        0x00000031,
        0x000065E5
    };

    static _CharacterInfo _character000033FE =
    {
        0x000033FE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping000033FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FE,
        0x000033FE,
        0x000033FE
    };

    static Char _decompositionMapping000033FF[] = 
    {
        0x00000067,
        0x00000061,
        0x0000006C
    };

    static _CharacterInfo _character000033FF =
    {
        0x000033FF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_square,
        3,
        _decompositionMapping000033FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000033FF,
        0x000033FF,
        0x000033FF
    };

    static _CharacterInfo _character00003400 =
    {
        0x00003400,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00003400,
        0x00003400,
        0x00003400
    };

    static _CharacterInfo _character00004DB5 =
    {
        0x00004DB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DB5,
        0x00004DB5,
        0x00004DB5
    };

    static _CharacterInfo _character00004DC0 =
    {
        0x00004DC0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC0,
        0x00004DC0,
        0x00004DC0
    };

    static _CharacterInfo _character00004DC1 =
    {
        0x00004DC1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC1,
        0x00004DC1,
        0x00004DC1
    };

    static _CharacterInfo _character00004DC2 =
    {
        0x00004DC2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC2,
        0x00004DC2,
        0x00004DC2
    };

    static _CharacterInfo _character00004DC3 =
    {
        0x00004DC3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC3,
        0x00004DC3,
        0x00004DC3
    };

    static _CharacterInfo _character00004DC4 =
    {
        0x00004DC4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC4,
        0x00004DC4,
        0x00004DC4
    };

    static _CharacterInfo _character00004DC5 =
    {
        0x00004DC5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC5,
        0x00004DC5,
        0x00004DC5
    };

    static _CharacterInfo _character00004DC6 =
    {
        0x00004DC6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC6,
        0x00004DC6,
        0x00004DC6
    };

    static _CharacterInfo _character00004DC7 =
    {
        0x00004DC7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC7,
        0x00004DC7,
        0x00004DC7
    };

    static _CharacterInfo _character00004DC8 =
    {
        0x00004DC8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC8,
        0x00004DC8,
        0x00004DC8
    };

    static _CharacterInfo _character00004DC9 =
    {
        0x00004DC9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DC9,
        0x00004DC9,
        0x00004DC9
    };

    static _CharacterInfo _character00004DCA =
    {
        0x00004DCA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCA,
        0x00004DCA,
        0x00004DCA
    };

    static _CharacterInfo _character00004DCB =
    {
        0x00004DCB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCB,
        0x00004DCB,
        0x00004DCB
    };

    static _CharacterInfo _character00004DCC =
    {
        0x00004DCC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCC,
        0x00004DCC,
        0x00004DCC
    };

    static _CharacterInfo _character00004DCD =
    {
        0x00004DCD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCD,
        0x00004DCD,
        0x00004DCD
    };

    static _CharacterInfo _character00004DCE =
    {
        0x00004DCE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCE,
        0x00004DCE,
        0x00004DCE
    };

    static _CharacterInfo _character00004DCF =
    {
        0x00004DCF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DCF,
        0x00004DCF,
        0x00004DCF
    };

    static _CharacterInfo _character00004DD0 =
    {
        0x00004DD0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD0,
        0x00004DD0,
        0x00004DD0
    };

    static _CharacterInfo _character00004DD1 =
    {
        0x00004DD1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD1,
        0x00004DD1,
        0x00004DD1
    };

    static _CharacterInfo _character00004DD2 =
    {
        0x00004DD2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD2,
        0x00004DD2,
        0x00004DD2
    };

    static _CharacterInfo _character00004DD3 =
    {
        0x00004DD3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD3,
        0x00004DD3,
        0x00004DD3
    };

    static _CharacterInfo _character00004DD4 =
    {
        0x00004DD4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD4,
        0x00004DD4,
        0x00004DD4
    };

    static _CharacterInfo _character00004DD5 =
    {
        0x00004DD5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD5,
        0x00004DD5,
        0x00004DD5
    };

    static _CharacterInfo _character00004DD6 =
    {
        0x00004DD6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD6,
        0x00004DD6,
        0x00004DD6
    };

    static _CharacterInfo _character00004DD7 =
    {
        0x00004DD7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD7,
        0x00004DD7,
        0x00004DD7
    };

    static _CharacterInfo _character00004DD8 =
    {
        0x00004DD8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD8,
        0x00004DD8,
        0x00004DD8
    };

    static _CharacterInfo _character00004DD9 =
    {
        0x00004DD9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DD9,
        0x00004DD9,
        0x00004DD9
    };

    static _CharacterInfo _character00004DDA =
    {
        0x00004DDA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDA,
        0x00004DDA,
        0x00004DDA
    };

    static _CharacterInfo _character00004DDB =
    {
        0x00004DDB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDB,
        0x00004DDB,
        0x00004DDB
    };

    static _CharacterInfo _character00004DDC =
    {
        0x00004DDC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDC,
        0x00004DDC,
        0x00004DDC
    };

    static _CharacterInfo _character00004DDD =
    {
        0x00004DDD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDD,
        0x00004DDD,
        0x00004DDD
    };

    static _CharacterInfo _character00004DDE =
    {
        0x00004DDE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDE,
        0x00004DDE,
        0x00004DDE
    };

    static _CharacterInfo _character00004DDF =
    {
        0x00004DDF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DDF,
        0x00004DDF,
        0x00004DDF
    };

    static _CharacterInfo _character00004DE0 =
    {
        0x00004DE0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE0,
        0x00004DE0,
        0x00004DE0
    };

    static _CharacterInfo _character00004DE1 =
    {
        0x00004DE1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE1,
        0x00004DE1,
        0x00004DE1
    };

    static _CharacterInfo _character00004DE2 =
    {
        0x00004DE2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE2,
        0x00004DE2,
        0x00004DE2
    };

    static _CharacterInfo _character00004DE3 =
    {
        0x00004DE3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE3,
        0x00004DE3,
        0x00004DE3
    };

    static _CharacterInfo _character00004DE4 =
    {
        0x00004DE4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE4,
        0x00004DE4,
        0x00004DE4
    };

    static _CharacterInfo _character00004DE5 =
    {
        0x00004DE5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE5,
        0x00004DE5,
        0x00004DE5
    };

    static _CharacterInfo _character00004DE6 =
    {
        0x00004DE6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE6,
        0x00004DE6,
        0x00004DE6
    };

    static _CharacterInfo _character00004DE7 =
    {
        0x00004DE7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE7,
        0x00004DE7,
        0x00004DE7
    };

    static _CharacterInfo _character00004DE8 =
    {
        0x00004DE8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE8,
        0x00004DE8,
        0x00004DE8
    };

    static _CharacterInfo _character00004DE9 =
    {
        0x00004DE9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DE9,
        0x00004DE9,
        0x00004DE9
    };

    static _CharacterInfo _character00004DEA =
    {
        0x00004DEA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DEA,
        0x00004DEA,
        0x00004DEA
    };

    static _CharacterInfo _character00004DEB =
    {
        0x00004DEB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DEB,
        0x00004DEB,
        0x00004DEB
    };

    static _CharacterInfo _character00004DEC =
    {
        0x00004DEC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DEC,
        0x00004DEC,
        0x00004DEC
    };

    static _CharacterInfo _character00004DED =
    {
        0x00004DED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DED,
        0x00004DED,
        0x00004DED
    };

    static _CharacterInfo _character00004DEE =
    {
        0x00004DEE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DEE,
        0x00004DEE,
        0x00004DEE
    };

    static _CharacterInfo _character00004DEF =
    {
        0x00004DEF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DEF,
        0x00004DEF,
        0x00004DEF
    };

    static _CharacterInfo _character00004DF0 =
    {
        0x00004DF0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF0,
        0x00004DF0,
        0x00004DF0
    };

    static _CharacterInfo _character00004DF1 =
    {
        0x00004DF1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF1,
        0x00004DF1,
        0x00004DF1
    };

    static _CharacterInfo _character00004DF2 =
    {
        0x00004DF2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF2,
        0x00004DF2,
        0x00004DF2
    };

    static _CharacterInfo _character00004DF3 =
    {
        0x00004DF3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF3,
        0x00004DF3,
        0x00004DF3
    };

    static _CharacterInfo _character00004DF4 =
    {
        0x00004DF4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF4,
        0x00004DF4,
        0x00004DF4
    };

    static _CharacterInfo _character00004DF5 =
    {
        0x00004DF5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF5,
        0x00004DF5,
        0x00004DF5
    };

    static _CharacterInfo _character00004DF6 =
    {
        0x00004DF6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF6,
        0x00004DF6,
        0x00004DF6
    };

    static _CharacterInfo _character00004DF7 =
    {
        0x00004DF7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF7,
        0x00004DF7,
        0x00004DF7
    };

    static _CharacterInfo _character00004DF8 =
    {
        0x00004DF8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF8,
        0x00004DF8,
        0x00004DF8
    };

    static _CharacterInfo _character00004DF9 =
    {
        0x00004DF9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DF9,
        0x00004DF9,
        0x00004DF9
    };

    static _CharacterInfo _character00004DFA =
    {
        0x00004DFA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFA,
        0x00004DFA,
        0x00004DFA
    };

    static _CharacterInfo _character00004DFB =
    {
        0x00004DFB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFB,
        0x00004DFB,
        0x00004DFB
    };

    static _CharacterInfo _character00004DFC =
    {
        0x00004DFC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFC,
        0x00004DFC,
        0x00004DFC
    };

    static _CharacterInfo _character00004DFD =
    {
        0x00004DFD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFD,
        0x00004DFD,
        0x00004DFD
    };

    static _CharacterInfo _character00004DFE =
    {
        0x00004DFE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFE,
        0x00004DFE,
        0x00004DFE
    };

    static _CharacterInfo _character00004DFF =
    {
        0x00004DFF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004DFF,
        0x00004DFF,
        0x00004DFF
    };

    static _CharacterInfo _character00004E00 =
    {
        0x00004E00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00004E00,
        0x00004E00,
        0x00004E00
    };

    static _CharacterInfo _character00009FBB =
    {
        0x00009FBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00009FBB,
        0x00009FBB,
        0x00009FBB
    };

    static _CharacterInfo _character0000A000 =
    {
        0x0000A000,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A000,
        0x0000A000,
        0x0000A000
    };

    static _CharacterInfo _character0000A001 =
    {
        0x0000A001,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A001,
        0x0000A001,
        0x0000A001
    };

    static _CharacterInfo _character0000A002 =
    {
        0x0000A002,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A002,
        0x0000A002,
        0x0000A002
    };

    static _CharacterInfo _character0000A003 =
    {
        0x0000A003,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A003,
        0x0000A003,
        0x0000A003
    };

    static _CharacterInfo _character0000A004 =
    {
        0x0000A004,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A004,
        0x0000A004,
        0x0000A004
    };

    static _CharacterInfo _character0000A005 =
    {
        0x0000A005,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A005,
        0x0000A005,
        0x0000A005
    };

    static _CharacterInfo _character0000A006 =
    {
        0x0000A006,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A006,
        0x0000A006,
        0x0000A006
    };

    static _CharacterInfo _character0000A007 =
    {
        0x0000A007,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A007,
        0x0000A007,
        0x0000A007
    };

    static _CharacterInfo _character0000A008 =
    {
        0x0000A008,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A008,
        0x0000A008,
        0x0000A008
    };

    static _CharacterInfo _character0000A009 =
    {
        0x0000A009,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A009,
        0x0000A009,
        0x0000A009
    };

    static _CharacterInfo _character0000A00A =
    {
        0x0000A00A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00A,
        0x0000A00A,
        0x0000A00A
    };

    static _CharacterInfo _character0000A00B =
    {
        0x0000A00B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00B,
        0x0000A00B,
        0x0000A00B
    };

    static _CharacterInfo _character0000A00C =
    {
        0x0000A00C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00C,
        0x0000A00C,
        0x0000A00C
    };

    static _CharacterInfo _character0000A00D =
    {
        0x0000A00D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00D,
        0x0000A00D,
        0x0000A00D
    };

    static _CharacterInfo _character0000A00E =
    {
        0x0000A00E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00E,
        0x0000A00E,
        0x0000A00E
    };

    static _CharacterInfo _character0000A00F =
    {
        0x0000A00F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A00F,
        0x0000A00F,
        0x0000A00F
    };

    static _CharacterInfo _character0000A010 =
    {
        0x0000A010,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A010,
        0x0000A010,
        0x0000A010
    };

    static _CharacterInfo _character0000A011 =
    {
        0x0000A011,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A011,
        0x0000A011,
        0x0000A011
    };

    static _CharacterInfo _character0000A012 =
    {
        0x0000A012,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A012,
        0x0000A012,
        0x0000A012
    };

    static _CharacterInfo _character0000A013 =
    {
        0x0000A013,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A013,
        0x0000A013,
        0x0000A013
    };

    static _CharacterInfo _character0000A014 =
    {
        0x0000A014,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A014,
        0x0000A014,
        0x0000A014
    };

    static _CharacterInfo _character0000A015 =
    {
        0x0000A015,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A015,
        0x0000A015,
        0x0000A015
    };

    static _CharacterInfo _character0000A016 =
    {
        0x0000A016,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A016,
        0x0000A016,
        0x0000A016
    };

    static _CharacterInfo _character0000A017 =
    {
        0x0000A017,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A017,
        0x0000A017,
        0x0000A017
    };

    static _CharacterInfo _character0000A018 =
    {
        0x0000A018,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A018,
        0x0000A018,
        0x0000A018
    };

    static _CharacterInfo _character0000A019 =
    {
        0x0000A019,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A019,
        0x0000A019,
        0x0000A019
    };

    static _CharacterInfo _character0000A01A =
    {
        0x0000A01A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01A,
        0x0000A01A,
        0x0000A01A
    };

    static _CharacterInfo _character0000A01B =
    {
        0x0000A01B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01B,
        0x0000A01B,
        0x0000A01B
    };

    static _CharacterInfo _character0000A01C =
    {
        0x0000A01C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01C,
        0x0000A01C,
        0x0000A01C
    };

    static _CharacterInfo _character0000A01D =
    {
        0x0000A01D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01D,
        0x0000A01D,
        0x0000A01D
    };

    static _CharacterInfo _character0000A01E =
    {
        0x0000A01E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01E,
        0x0000A01E,
        0x0000A01E
    };

    static _CharacterInfo _character0000A01F =
    {
        0x0000A01F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A01F,
        0x0000A01F,
        0x0000A01F
    };

    static _CharacterInfo _character0000A020 =
    {
        0x0000A020,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A020,
        0x0000A020,
        0x0000A020
    };

    static _CharacterInfo _character0000A021 =
    {
        0x0000A021,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A021,
        0x0000A021,
        0x0000A021
    };

    static _CharacterInfo _character0000A022 =
    {
        0x0000A022,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A022,
        0x0000A022,
        0x0000A022
    };

    static _CharacterInfo _character0000A023 =
    {
        0x0000A023,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A023,
        0x0000A023,
        0x0000A023
    };

    static _CharacterInfo _character0000A024 =
    {
        0x0000A024,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A024,
        0x0000A024,
        0x0000A024
    };

    static _CharacterInfo _character0000A025 =
    {
        0x0000A025,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A025,
        0x0000A025,
        0x0000A025
    };

    static _CharacterInfo _character0000A026 =
    {
        0x0000A026,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A026,
        0x0000A026,
        0x0000A026
    };

    static _CharacterInfo _character0000A027 =
    {
        0x0000A027,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A027,
        0x0000A027,
        0x0000A027
    };

    static _CharacterInfo _character0000A028 =
    {
        0x0000A028,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A028,
        0x0000A028,
        0x0000A028
    };

    static _CharacterInfo _character0000A029 =
    {
        0x0000A029,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A029,
        0x0000A029,
        0x0000A029
    };

    static _CharacterInfo _character0000A02A =
    {
        0x0000A02A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02A,
        0x0000A02A,
        0x0000A02A
    };

    static _CharacterInfo _character0000A02B =
    {
        0x0000A02B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02B,
        0x0000A02B,
        0x0000A02B
    };

    static _CharacterInfo _character0000A02C =
    {
        0x0000A02C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02C,
        0x0000A02C,
        0x0000A02C
    };

    static _CharacterInfo _character0000A02D =
    {
        0x0000A02D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02D,
        0x0000A02D,
        0x0000A02D
    };

    static _CharacterInfo _character0000A02E =
    {
        0x0000A02E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02E,
        0x0000A02E,
        0x0000A02E
    };

    static _CharacterInfo _character0000A02F =
    {
        0x0000A02F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A02F,
        0x0000A02F,
        0x0000A02F
    };

    static _CharacterInfo _character0000A030 =
    {
        0x0000A030,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A030,
        0x0000A030,
        0x0000A030
    };

    static _CharacterInfo _character0000A031 =
    {
        0x0000A031,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A031,
        0x0000A031,
        0x0000A031
    };

    static _CharacterInfo _character0000A032 =
    {
        0x0000A032,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A032,
        0x0000A032,
        0x0000A032
    };

    static _CharacterInfo _character0000A033 =
    {
        0x0000A033,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A033,
        0x0000A033,
        0x0000A033
    };

    static _CharacterInfo _character0000A034 =
    {
        0x0000A034,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A034,
        0x0000A034,
        0x0000A034
    };

    static _CharacterInfo _character0000A035 =
    {
        0x0000A035,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A035,
        0x0000A035,
        0x0000A035
    };

    static _CharacterInfo _character0000A036 =
    {
        0x0000A036,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A036,
        0x0000A036,
        0x0000A036
    };

    static _CharacterInfo _character0000A037 =
    {
        0x0000A037,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A037,
        0x0000A037,
        0x0000A037
    };

    static _CharacterInfo _character0000A038 =
    {
        0x0000A038,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A038,
        0x0000A038,
        0x0000A038
    };

    static _CharacterInfo _character0000A039 =
    {
        0x0000A039,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A039,
        0x0000A039,
        0x0000A039
    };

    static _CharacterInfo _character0000A03A =
    {
        0x0000A03A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03A,
        0x0000A03A,
        0x0000A03A
    };

    static _CharacterInfo _character0000A03B =
    {
        0x0000A03B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03B,
        0x0000A03B,
        0x0000A03B
    };

    static _CharacterInfo _character0000A03C =
    {
        0x0000A03C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03C,
        0x0000A03C,
        0x0000A03C
    };

    static _CharacterInfo _character0000A03D =
    {
        0x0000A03D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03D,
        0x0000A03D,
        0x0000A03D
    };

    static _CharacterInfo _character0000A03E =
    {
        0x0000A03E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03E,
        0x0000A03E,
        0x0000A03E
    };

    static _CharacterInfo _character0000A03F =
    {
        0x0000A03F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A03F,
        0x0000A03F,
        0x0000A03F
    };

    static _CharacterInfo _character0000A040 =
    {
        0x0000A040,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A040,
        0x0000A040,
        0x0000A040
    };

    static _CharacterInfo _character0000A041 =
    {
        0x0000A041,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A041,
        0x0000A041,
        0x0000A041
    };

    static _CharacterInfo _character0000A042 =
    {
        0x0000A042,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A042,
        0x0000A042,
        0x0000A042
    };

    static _CharacterInfo _character0000A043 =
    {
        0x0000A043,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A043,
        0x0000A043,
        0x0000A043
    };

    static _CharacterInfo _character0000A044 =
    {
        0x0000A044,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A044,
        0x0000A044,
        0x0000A044
    };

    static _CharacterInfo _character0000A045 =
    {
        0x0000A045,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A045,
        0x0000A045,
        0x0000A045
    };

    static _CharacterInfo _character0000A046 =
    {
        0x0000A046,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A046,
        0x0000A046,
        0x0000A046
    };

    static _CharacterInfo _character0000A047 =
    {
        0x0000A047,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A047,
        0x0000A047,
        0x0000A047
    };

    static _CharacterInfo _character0000A048 =
    {
        0x0000A048,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A048,
        0x0000A048,
        0x0000A048
    };

    static _CharacterInfo _character0000A049 =
    {
        0x0000A049,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A049,
        0x0000A049,
        0x0000A049
    };

    static _CharacterInfo _character0000A04A =
    {
        0x0000A04A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04A,
        0x0000A04A,
        0x0000A04A
    };

    static _CharacterInfo _character0000A04B =
    {
        0x0000A04B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04B,
        0x0000A04B,
        0x0000A04B
    };

    static _CharacterInfo _character0000A04C =
    {
        0x0000A04C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04C,
        0x0000A04C,
        0x0000A04C
    };

    static _CharacterInfo _character0000A04D =
    {
        0x0000A04D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04D,
        0x0000A04D,
        0x0000A04D
    };

    static _CharacterInfo _character0000A04E =
    {
        0x0000A04E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04E,
        0x0000A04E,
        0x0000A04E
    };

    static _CharacterInfo _character0000A04F =
    {
        0x0000A04F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A04F,
        0x0000A04F,
        0x0000A04F
    };

    static _CharacterInfo _character0000A050 =
    {
        0x0000A050,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A050,
        0x0000A050,
        0x0000A050
    };

    static _CharacterInfo _character0000A051 =
    {
        0x0000A051,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A051,
        0x0000A051,
        0x0000A051
    };

    static _CharacterInfo _character0000A052 =
    {
        0x0000A052,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A052,
        0x0000A052,
        0x0000A052
    };

    static _CharacterInfo _character0000A053 =
    {
        0x0000A053,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A053,
        0x0000A053,
        0x0000A053
    };

    static _CharacterInfo _character0000A054 =
    {
        0x0000A054,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A054,
        0x0000A054,
        0x0000A054
    };

    static _CharacterInfo _character0000A055 =
    {
        0x0000A055,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A055,
        0x0000A055,
        0x0000A055
    };

    static _CharacterInfo _character0000A056 =
    {
        0x0000A056,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A056,
        0x0000A056,
        0x0000A056
    };

    static _CharacterInfo _character0000A057 =
    {
        0x0000A057,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A057,
        0x0000A057,
        0x0000A057
    };

    static _CharacterInfo _character0000A058 =
    {
        0x0000A058,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A058,
        0x0000A058,
        0x0000A058
    };

    static _CharacterInfo _character0000A059 =
    {
        0x0000A059,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A059,
        0x0000A059,
        0x0000A059
    };

    static _CharacterInfo _character0000A05A =
    {
        0x0000A05A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05A,
        0x0000A05A,
        0x0000A05A
    };

    static _CharacterInfo _character0000A05B =
    {
        0x0000A05B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05B,
        0x0000A05B,
        0x0000A05B
    };

    static _CharacterInfo _character0000A05C =
    {
        0x0000A05C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05C,
        0x0000A05C,
        0x0000A05C
    };

    static _CharacterInfo _character0000A05D =
    {
        0x0000A05D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05D,
        0x0000A05D,
        0x0000A05D
    };

    static _CharacterInfo _character0000A05E =
    {
        0x0000A05E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05E,
        0x0000A05E,
        0x0000A05E
    };

    static _CharacterInfo _character0000A05F =
    {
        0x0000A05F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A05F,
        0x0000A05F,
        0x0000A05F
    };

    static _CharacterInfo _character0000A060 =
    {
        0x0000A060,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A060,
        0x0000A060,
        0x0000A060
    };

    static _CharacterInfo _character0000A061 =
    {
        0x0000A061,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A061,
        0x0000A061,
        0x0000A061
    };

    static _CharacterInfo _character0000A062 =
    {
        0x0000A062,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A062,
        0x0000A062,
        0x0000A062
    };

    static _CharacterInfo _character0000A063 =
    {
        0x0000A063,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A063,
        0x0000A063,
        0x0000A063
    };

    static _CharacterInfo _character0000A064 =
    {
        0x0000A064,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A064,
        0x0000A064,
        0x0000A064
    };

    static _CharacterInfo _character0000A065 =
    {
        0x0000A065,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A065,
        0x0000A065,
        0x0000A065
    };

    static _CharacterInfo _character0000A066 =
    {
        0x0000A066,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A066,
        0x0000A066,
        0x0000A066
    };

    static _CharacterInfo _character0000A067 =
    {
        0x0000A067,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A067,
        0x0000A067,
        0x0000A067
    };

    static _CharacterInfo _character0000A068 =
    {
        0x0000A068,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A068,
        0x0000A068,
        0x0000A068
    };

    static _CharacterInfo _character0000A069 =
    {
        0x0000A069,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A069,
        0x0000A069,
        0x0000A069
    };

    static _CharacterInfo _character0000A06A =
    {
        0x0000A06A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06A,
        0x0000A06A,
        0x0000A06A
    };

    static _CharacterInfo _character0000A06B =
    {
        0x0000A06B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06B,
        0x0000A06B,
        0x0000A06B
    };

    static _CharacterInfo _character0000A06C =
    {
        0x0000A06C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06C,
        0x0000A06C,
        0x0000A06C
    };

    static _CharacterInfo _character0000A06D =
    {
        0x0000A06D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06D,
        0x0000A06D,
        0x0000A06D
    };

    static _CharacterInfo _character0000A06E =
    {
        0x0000A06E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06E,
        0x0000A06E,
        0x0000A06E
    };

    static _CharacterInfo _character0000A06F =
    {
        0x0000A06F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A06F,
        0x0000A06F,
        0x0000A06F
    };

    static _CharacterInfo _character0000A070 =
    {
        0x0000A070,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A070,
        0x0000A070,
        0x0000A070
    };

    static _CharacterInfo _character0000A071 =
    {
        0x0000A071,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A071,
        0x0000A071,
        0x0000A071
    };

    static _CharacterInfo _character0000A072 =
    {
        0x0000A072,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A072,
        0x0000A072,
        0x0000A072
    };

    static _CharacterInfo _character0000A073 =
    {
        0x0000A073,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A073,
        0x0000A073,
        0x0000A073
    };

    static _CharacterInfo _character0000A074 =
    {
        0x0000A074,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A074,
        0x0000A074,
        0x0000A074
    };

    static _CharacterInfo _character0000A075 =
    {
        0x0000A075,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A075,
        0x0000A075,
        0x0000A075
    };

    static _CharacterInfo _character0000A076 =
    {
        0x0000A076,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A076,
        0x0000A076,
        0x0000A076
    };

    static _CharacterInfo _character0000A077 =
    {
        0x0000A077,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A077,
        0x0000A077,
        0x0000A077
    };

    static _CharacterInfo _character0000A078 =
    {
        0x0000A078,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A078,
        0x0000A078,
        0x0000A078
    };

    static _CharacterInfo _character0000A079 =
    {
        0x0000A079,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A079,
        0x0000A079,
        0x0000A079
    };

    static _CharacterInfo _character0000A07A =
    {
        0x0000A07A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07A,
        0x0000A07A,
        0x0000A07A
    };

    static _CharacterInfo _character0000A07B =
    {
        0x0000A07B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07B,
        0x0000A07B,
        0x0000A07B
    };

    static _CharacterInfo _character0000A07C =
    {
        0x0000A07C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07C,
        0x0000A07C,
        0x0000A07C
    };

    static _CharacterInfo _character0000A07D =
    {
        0x0000A07D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07D,
        0x0000A07D,
        0x0000A07D
    };

    static _CharacterInfo _character0000A07E =
    {
        0x0000A07E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07E,
        0x0000A07E,
        0x0000A07E
    };

    static _CharacterInfo _character0000A07F =
    {
        0x0000A07F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A07F,
        0x0000A07F,
        0x0000A07F
    };

    static _CharacterInfo _character0000A080 =
    {
        0x0000A080,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A080,
        0x0000A080,
        0x0000A080
    };

    static _CharacterInfo _character0000A081 =
    {
        0x0000A081,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A081,
        0x0000A081,
        0x0000A081
    };

    static _CharacterInfo _character0000A082 =
    {
        0x0000A082,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A082,
        0x0000A082,
        0x0000A082
    };

    static _CharacterInfo _character0000A083 =
    {
        0x0000A083,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A083,
        0x0000A083,
        0x0000A083
    };

    static _CharacterInfo _character0000A084 =
    {
        0x0000A084,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A084,
        0x0000A084,
        0x0000A084
    };

    static _CharacterInfo _character0000A085 =
    {
        0x0000A085,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A085,
        0x0000A085,
        0x0000A085
    };

    static _CharacterInfo _character0000A086 =
    {
        0x0000A086,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A086,
        0x0000A086,
        0x0000A086
    };

    static _CharacterInfo _character0000A087 =
    {
        0x0000A087,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A087,
        0x0000A087,
        0x0000A087
    };

    static _CharacterInfo _character0000A088 =
    {
        0x0000A088,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A088,
        0x0000A088,
        0x0000A088
    };

    static _CharacterInfo _character0000A089 =
    {
        0x0000A089,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A089,
        0x0000A089,
        0x0000A089
    };

    static _CharacterInfo _character0000A08A =
    {
        0x0000A08A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08A,
        0x0000A08A,
        0x0000A08A
    };

    static _CharacterInfo _character0000A08B =
    {
        0x0000A08B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08B,
        0x0000A08B,
        0x0000A08B
    };

    static _CharacterInfo _character0000A08C =
    {
        0x0000A08C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08C,
        0x0000A08C,
        0x0000A08C
    };

    static _CharacterInfo _character0000A08D =
    {
        0x0000A08D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08D,
        0x0000A08D,
        0x0000A08D
    };

    static _CharacterInfo _character0000A08E =
    {
        0x0000A08E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08E,
        0x0000A08E,
        0x0000A08E
    };

    static _CharacterInfo _character0000A08F =
    {
        0x0000A08F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A08F,
        0x0000A08F,
        0x0000A08F
    };

    static _CharacterInfo _character0000A090 =
    {
        0x0000A090,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A090,
        0x0000A090,
        0x0000A090
    };

    static _CharacterInfo _character0000A091 =
    {
        0x0000A091,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A091,
        0x0000A091,
        0x0000A091
    };

    static _CharacterInfo _character0000A092 =
    {
        0x0000A092,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A092,
        0x0000A092,
        0x0000A092
    };

    static _CharacterInfo _character0000A093 =
    {
        0x0000A093,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A093,
        0x0000A093,
        0x0000A093
    };

    static _CharacterInfo _character0000A094 =
    {
        0x0000A094,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A094,
        0x0000A094,
        0x0000A094
    };

    static _CharacterInfo _character0000A095 =
    {
        0x0000A095,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A095,
        0x0000A095,
        0x0000A095
    };

    static _CharacterInfo _character0000A096 =
    {
        0x0000A096,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A096,
        0x0000A096,
        0x0000A096
    };

    static _CharacterInfo _character0000A097 =
    {
        0x0000A097,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A097,
        0x0000A097,
        0x0000A097
    };

    static _CharacterInfo _character0000A098 =
    {
        0x0000A098,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A098,
        0x0000A098,
        0x0000A098
    };

    static _CharacterInfo _character0000A099 =
    {
        0x0000A099,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A099,
        0x0000A099,
        0x0000A099
    };

    static _CharacterInfo _character0000A09A =
    {
        0x0000A09A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09A,
        0x0000A09A,
        0x0000A09A
    };

    static _CharacterInfo _character0000A09B =
    {
        0x0000A09B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09B,
        0x0000A09B,
        0x0000A09B
    };

    static _CharacterInfo _character0000A09C =
    {
        0x0000A09C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09C,
        0x0000A09C,
        0x0000A09C
    };

    static _CharacterInfo _character0000A09D =
    {
        0x0000A09D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09D,
        0x0000A09D,
        0x0000A09D
    };

    static _CharacterInfo _character0000A09E =
    {
        0x0000A09E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09E,
        0x0000A09E,
        0x0000A09E
    };

    static _CharacterInfo _character0000A09F =
    {
        0x0000A09F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A09F,
        0x0000A09F,
        0x0000A09F
    };

    static _CharacterInfo _character0000A0A0 =
    {
        0x0000A0A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A0,
        0x0000A0A0,
        0x0000A0A0
    };

    static _CharacterInfo _character0000A0A1 =
    {
        0x0000A0A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A1,
        0x0000A0A1,
        0x0000A0A1
    };

    static _CharacterInfo _character0000A0A2 =
    {
        0x0000A0A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A2,
        0x0000A0A2,
        0x0000A0A2
    };

    static _CharacterInfo _character0000A0A3 =
    {
        0x0000A0A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A3,
        0x0000A0A3,
        0x0000A0A3
    };

    static _CharacterInfo _character0000A0A4 =
    {
        0x0000A0A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A4,
        0x0000A0A4,
        0x0000A0A4
    };

    static _CharacterInfo _character0000A0A5 =
    {
        0x0000A0A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A5,
        0x0000A0A5,
        0x0000A0A5
    };

    static _CharacterInfo _character0000A0A6 =
    {
        0x0000A0A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A6,
        0x0000A0A6,
        0x0000A0A6
    };

    static _CharacterInfo _character0000A0A7 =
    {
        0x0000A0A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A7,
        0x0000A0A7,
        0x0000A0A7
    };

    static _CharacterInfo _character0000A0A8 =
    {
        0x0000A0A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A8,
        0x0000A0A8,
        0x0000A0A8
    };

    static _CharacterInfo _character0000A0A9 =
    {
        0x0000A0A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0A9,
        0x0000A0A9,
        0x0000A0A9
    };

    static _CharacterInfo _character0000A0AA =
    {
        0x0000A0AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AA,
        0x0000A0AA,
        0x0000A0AA
    };

    static _CharacterInfo _character0000A0AB =
    {
        0x0000A0AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AB,
        0x0000A0AB,
        0x0000A0AB
    };

    static _CharacterInfo _character0000A0AC =
    {
        0x0000A0AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AC,
        0x0000A0AC,
        0x0000A0AC
    };

    static _CharacterInfo _character0000A0AD =
    {
        0x0000A0AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AD,
        0x0000A0AD,
        0x0000A0AD
    };

    static _CharacterInfo _character0000A0AE =
    {
        0x0000A0AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AE,
        0x0000A0AE,
        0x0000A0AE
    };

    static _CharacterInfo _character0000A0AF =
    {
        0x0000A0AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0AF,
        0x0000A0AF,
        0x0000A0AF
    };

    static _CharacterInfo _character0000A0B0 =
    {
        0x0000A0B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B0,
        0x0000A0B0,
        0x0000A0B0
    };

    static _CharacterInfo _character0000A0B1 =
    {
        0x0000A0B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B1,
        0x0000A0B1,
        0x0000A0B1
    };

    static _CharacterInfo _character0000A0B2 =
    {
        0x0000A0B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B2,
        0x0000A0B2,
        0x0000A0B2
    };

    static _CharacterInfo _character0000A0B3 =
    {
        0x0000A0B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B3,
        0x0000A0B3,
        0x0000A0B3
    };

    static _CharacterInfo _character0000A0B4 =
    {
        0x0000A0B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B4,
        0x0000A0B4,
        0x0000A0B4
    };

    static _CharacterInfo _character0000A0B5 =
    {
        0x0000A0B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B5,
        0x0000A0B5,
        0x0000A0B5
    };

    static _CharacterInfo _character0000A0B6 =
    {
        0x0000A0B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B6,
        0x0000A0B6,
        0x0000A0B6
    };

    static _CharacterInfo _character0000A0B7 =
    {
        0x0000A0B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B7,
        0x0000A0B7,
        0x0000A0B7
    };

    static _CharacterInfo _character0000A0B8 =
    {
        0x0000A0B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B8,
        0x0000A0B8,
        0x0000A0B8
    };

    static _CharacterInfo _character0000A0B9 =
    {
        0x0000A0B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0B9,
        0x0000A0B9,
        0x0000A0B9
    };

    static _CharacterInfo _character0000A0BA =
    {
        0x0000A0BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BA,
        0x0000A0BA,
        0x0000A0BA
    };

    static _CharacterInfo _character0000A0BB =
    {
        0x0000A0BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BB,
        0x0000A0BB,
        0x0000A0BB
    };

    static _CharacterInfo _character0000A0BC =
    {
        0x0000A0BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BC,
        0x0000A0BC,
        0x0000A0BC
    };

    static _CharacterInfo _character0000A0BD =
    {
        0x0000A0BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BD,
        0x0000A0BD,
        0x0000A0BD
    };

    static _CharacterInfo _character0000A0BE =
    {
        0x0000A0BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BE,
        0x0000A0BE,
        0x0000A0BE
    };

    static _CharacterInfo _character0000A0BF =
    {
        0x0000A0BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0BF,
        0x0000A0BF,
        0x0000A0BF
    };

    static _CharacterInfo _character0000A0C0 =
    {
        0x0000A0C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C0,
        0x0000A0C0,
        0x0000A0C0
    };

    static _CharacterInfo _character0000A0C1 =
    {
        0x0000A0C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C1,
        0x0000A0C1,
        0x0000A0C1
    };

    static _CharacterInfo _character0000A0C2 =
    {
        0x0000A0C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C2,
        0x0000A0C2,
        0x0000A0C2
    };

    static _CharacterInfo _character0000A0C3 =
    {
        0x0000A0C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C3,
        0x0000A0C3,
        0x0000A0C3
    };

    static _CharacterInfo _character0000A0C4 =
    {
        0x0000A0C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C4,
        0x0000A0C4,
        0x0000A0C4
    };

    static _CharacterInfo _character0000A0C5 =
    {
        0x0000A0C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C5,
        0x0000A0C5,
        0x0000A0C5
    };

    static _CharacterInfo _character0000A0C6 =
    {
        0x0000A0C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C6,
        0x0000A0C6,
        0x0000A0C6
    };

    static _CharacterInfo _character0000A0C7 =
    {
        0x0000A0C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C7,
        0x0000A0C7,
        0x0000A0C7
    };

    static _CharacterInfo _character0000A0C8 =
    {
        0x0000A0C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C8,
        0x0000A0C8,
        0x0000A0C8
    };

    static _CharacterInfo _character0000A0C9 =
    {
        0x0000A0C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0C9,
        0x0000A0C9,
        0x0000A0C9
    };

    static _CharacterInfo _character0000A0CA =
    {
        0x0000A0CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CA,
        0x0000A0CA,
        0x0000A0CA
    };

    static _CharacterInfo _character0000A0CB =
    {
        0x0000A0CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CB,
        0x0000A0CB,
        0x0000A0CB
    };

    static _CharacterInfo _character0000A0CC =
    {
        0x0000A0CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CC,
        0x0000A0CC,
        0x0000A0CC
    };

    static _CharacterInfo _character0000A0CD =
    {
        0x0000A0CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CD,
        0x0000A0CD,
        0x0000A0CD
    };

    static _CharacterInfo _character0000A0CE =
    {
        0x0000A0CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CE,
        0x0000A0CE,
        0x0000A0CE
    };

    static _CharacterInfo _character0000A0CF =
    {
        0x0000A0CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0CF,
        0x0000A0CF,
        0x0000A0CF
    };

    static _CharacterInfo _character0000A0D0 =
    {
        0x0000A0D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D0,
        0x0000A0D0,
        0x0000A0D0
    };

    static _CharacterInfo _character0000A0D1 =
    {
        0x0000A0D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D1,
        0x0000A0D1,
        0x0000A0D1
    };

    static _CharacterInfo _character0000A0D2 =
    {
        0x0000A0D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D2,
        0x0000A0D2,
        0x0000A0D2
    };

    static _CharacterInfo _character0000A0D3 =
    {
        0x0000A0D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D3,
        0x0000A0D3,
        0x0000A0D3
    };

    static _CharacterInfo _character0000A0D4 =
    {
        0x0000A0D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D4,
        0x0000A0D4,
        0x0000A0D4
    };

    static _CharacterInfo _character0000A0D5 =
    {
        0x0000A0D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D5,
        0x0000A0D5,
        0x0000A0D5
    };

    static _CharacterInfo _character0000A0D6 =
    {
        0x0000A0D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D6,
        0x0000A0D6,
        0x0000A0D6
    };

    static _CharacterInfo _character0000A0D7 =
    {
        0x0000A0D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D7,
        0x0000A0D7,
        0x0000A0D7
    };

    static _CharacterInfo _character0000A0D8 =
    {
        0x0000A0D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D8,
        0x0000A0D8,
        0x0000A0D8
    };

    static _CharacterInfo _character0000A0D9 =
    {
        0x0000A0D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0D9,
        0x0000A0D9,
        0x0000A0D9
    };

    static _CharacterInfo _character0000A0DA =
    {
        0x0000A0DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DA,
        0x0000A0DA,
        0x0000A0DA
    };

    static _CharacterInfo _character0000A0DB =
    {
        0x0000A0DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DB,
        0x0000A0DB,
        0x0000A0DB
    };

    static _CharacterInfo _character0000A0DC =
    {
        0x0000A0DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DC,
        0x0000A0DC,
        0x0000A0DC
    };

    static _CharacterInfo _character0000A0DD =
    {
        0x0000A0DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DD,
        0x0000A0DD,
        0x0000A0DD
    };

    static _CharacterInfo _character0000A0DE =
    {
        0x0000A0DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DE,
        0x0000A0DE,
        0x0000A0DE
    };

    static _CharacterInfo _character0000A0DF =
    {
        0x0000A0DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0DF,
        0x0000A0DF,
        0x0000A0DF
    };

    static _CharacterInfo _character0000A0E0 =
    {
        0x0000A0E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E0,
        0x0000A0E0,
        0x0000A0E0
    };

    static _CharacterInfo _character0000A0E1 =
    {
        0x0000A0E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E1,
        0x0000A0E1,
        0x0000A0E1
    };

    static _CharacterInfo _character0000A0E2 =
    {
        0x0000A0E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E2,
        0x0000A0E2,
        0x0000A0E2
    };

    static _CharacterInfo _character0000A0E3 =
    {
        0x0000A0E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E3,
        0x0000A0E3,
        0x0000A0E3
    };

    static _CharacterInfo _character0000A0E4 =
    {
        0x0000A0E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E4,
        0x0000A0E4,
        0x0000A0E4
    };

    static _CharacterInfo _character0000A0E5 =
    {
        0x0000A0E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E5,
        0x0000A0E5,
        0x0000A0E5
    };

    static _CharacterInfo _character0000A0E6 =
    {
        0x0000A0E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E6,
        0x0000A0E6,
        0x0000A0E6
    };

    static _CharacterInfo _character0000A0E7 =
    {
        0x0000A0E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E7,
        0x0000A0E7,
        0x0000A0E7
    };

    static _CharacterInfo _character0000A0E8 =
    {
        0x0000A0E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E8,
        0x0000A0E8,
        0x0000A0E8
    };

    static _CharacterInfo _character0000A0E9 =
    {
        0x0000A0E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0E9,
        0x0000A0E9,
        0x0000A0E9
    };

    static _CharacterInfo _character0000A0EA =
    {
        0x0000A0EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0EA,
        0x0000A0EA,
        0x0000A0EA
    };

    static _CharacterInfo _character0000A0EB =
    {
        0x0000A0EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0EB,
        0x0000A0EB,
        0x0000A0EB
    };

    static _CharacterInfo _character0000A0EC =
    {
        0x0000A0EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0EC,
        0x0000A0EC,
        0x0000A0EC
    };

    static _CharacterInfo _character0000A0ED =
    {
        0x0000A0ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0ED,
        0x0000A0ED,
        0x0000A0ED
    };

    static _CharacterInfo _character0000A0EE =
    {
        0x0000A0EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0EE,
        0x0000A0EE,
        0x0000A0EE
    };

    static _CharacterInfo _character0000A0EF =
    {
        0x0000A0EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0EF,
        0x0000A0EF,
        0x0000A0EF
    };

    static _CharacterInfo _character0000A0F0 =
    {
        0x0000A0F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F0,
        0x0000A0F0,
        0x0000A0F0
    };

    static _CharacterInfo _character0000A0F1 =
    {
        0x0000A0F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F1,
        0x0000A0F1,
        0x0000A0F1
    };

    static _CharacterInfo _character0000A0F2 =
    {
        0x0000A0F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F2,
        0x0000A0F2,
        0x0000A0F2
    };

    static _CharacterInfo _character0000A0F3 =
    {
        0x0000A0F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F3,
        0x0000A0F3,
        0x0000A0F3
    };

    static _CharacterInfo _character0000A0F4 =
    {
        0x0000A0F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F4,
        0x0000A0F4,
        0x0000A0F4
    };

    static _CharacterInfo _character0000A0F5 =
    {
        0x0000A0F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F5,
        0x0000A0F5,
        0x0000A0F5
    };

    static _CharacterInfo _character0000A0F6 =
    {
        0x0000A0F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F6,
        0x0000A0F6,
        0x0000A0F6
    };

    static _CharacterInfo _character0000A0F7 =
    {
        0x0000A0F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F7,
        0x0000A0F7,
        0x0000A0F7
    };

    static _CharacterInfo _character0000A0F8 =
    {
        0x0000A0F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F8,
        0x0000A0F8,
        0x0000A0F8
    };

    static _CharacterInfo _character0000A0F9 =
    {
        0x0000A0F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0F9,
        0x0000A0F9,
        0x0000A0F9
    };

    static _CharacterInfo _character0000A0FA =
    {
        0x0000A0FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FA,
        0x0000A0FA,
        0x0000A0FA
    };

    static _CharacterInfo _character0000A0FB =
    {
        0x0000A0FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FB,
        0x0000A0FB,
        0x0000A0FB
    };

    static _CharacterInfo _character0000A0FC =
    {
        0x0000A0FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FC,
        0x0000A0FC,
        0x0000A0FC
    };

    static _CharacterInfo _character0000A0FD =
    {
        0x0000A0FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FD,
        0x0000A0FD,
        0x0000A0FD
    };

    static _CharacterInfo _character0000A0FE =
    {
        0x0000A0FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FE,
        0x0000A0FE,
        0x0000A0FE
    };

    static _CharacterInfo _character0000A0FF =
    {
        0x0000A0FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A0FF,
        0x0000A0FF,
        0x0000A0FF
    };

    static _CharacterInfo _character0000A100 =
    {
        0x0000A100,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A100,
        0x0000A100,
        0x0000A100
    };

    static _CharacterInfo _character0000A101 =
    {
        0x0000A101,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A101,
        0x0000A101,
        0x0000A101
    };

    static _CharacterInfo _character0000A102 =
    {
        0x0000A102,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A102,
        0x0000A102,
        0x0000A102
    };

    static _CharacterInfo _character0000A103 =
    {
        0x0000A103,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A103,
        0x0000A103,
        0x0000A103
    };

    static _CharacterInfo _character0000A104 =
    {
        0x0000A104,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A104,
        0x0000A104,
        0x0000A104
    };

    static _CharacterInfo _character0000A105 =
    {
        0x0000A105,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A105,
        0x0000A105,
        0x0000A105
    };

    static _CharacterInfo _character0000A106 =
    {
        0x0000A106,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A106,
        0x0000A106,
        0x0000A106
    };

    static _CharacterInfo _character0000A107 =
    {
        0x0000A107,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A107,
        0x0000A107,
        0x0000A107
    };

    static _CharacterInfo _character0000A108 =
    {
        0x0000A108,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A108,
        0x0000A108,
        0x0000A108
    };

    static _CharacterInfo _character0000A109 =
    {
        0x0000A109,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A109,
        0x0000A109,
        0x0000A109
    };

    static _CharacterInfo _character0000A10A =
    {
        0x0000A10A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10A,
        0x0000A10A,
        0x0000A10A
    };

    static _CharacterInfo _character0000A10B =
    {
        0x0000A10B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10B,
        0x0000A10B,
        0x0000A10B
    };

    static _CharacterInfo _character0000A10C =
    {
        0x0000A10C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10C,
        0x0000A10C,
        0x0000A10C
    };

    static _CharacterInfo _character0000A10D =
    {
        0x0000A10D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10D,
        0x0000A10D,
        0x0000A10D
    };

    static _CharacterInfo _character0000A10E =
    {
        0x0000A10E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10E,
        0x0000A10E,
        0x0000A10E
    };

    static _CharacterInfo _character0000A10F =
    {
        0x0000A10F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A10F,
        0x0000A10F,
        0x0000A10F
    };

    static _CharacterInfo _character0000A110 =
    {
        0x0000A110,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A110,
        0x0000A110,
        0x0000A110
    };

    static _CharacterInfo _character0000A111 =
    {
        0x0000A111,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A111,
        0x0000A111,
        0x0000A111
    };

    static _CharacterInfo _character0000A112 =
    {
        0x0000A112,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A112,
        0x0000A112,
        0x0000A112
    };

    static _CharacterInfo _character0000A113 =
    {
        0x0000A113,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A113,
        0x0000A113,
        0x0000A113
    };

    static _CharacterInfo _character0000A114 =
    {
        0x0000A114,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A114,
        0x0000A114,
        0x0000A114
    };

    static _CharacterInfo _character0000A115 =
    {
        0x0000A115,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A115,
        0x0000A115,
        0x0000A115
    };

    static _CharacterInfo _character0000A116 =
    {
        0x0000A116,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A116,
        0x0000A116,
        0x0000A116
    };

    static _CharacterInfo _character0000A117 =
    {
        0x0000A117,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A117,
        0x0000A117,
        0x0000A117
    };

    static _CharacterInfo _character0000A118 =
    {
        0x0000A118,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A118,
        0x0000A118,
        0x0000A118
    };

    static _CharacterInfo _character0000A119 =
    {
        0x0000A119,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A119,
        0x0000A119,
        0x0000A119
    };

    static _CharacterInfo _character0000A11A =
    {
        0x0000A11A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11A,
        0x0000A11A,
        0x0000A11A
    };

    static _CharacterInfo _character0000A11B =
    {
        0x0000A11B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11B,
        0x0000A11B,
        0x0000A11B
    };

    static _CharacterInfo _character0000A11C =
    {
        0x0000A11C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11C,
        0x0000A11C,
        0x0000A11C
    };

    static _CharacterInfo _character0000A11D =
    {
        0x0000A11D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11D,
        0x0000A11D,
        0x0000A11D
    };

    static _CharacterInfo _character0000A11E =
    {
        0x0000A11E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11E,
        0x0000A11E,
        0x0000A11E
    };

    static _CharacterInfo _character0000A11F =
    {
        0x0000A11F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A11F,
        0x0000A11F,
        0x0000A11F
    };

    static _CharacterInfo _character0000A120 =
    {
        0x0000A120,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A120,
        0x0000A120,
        0x0000A120
    };

    static _CharacterInfo _character0000A121 =
    {
        0x0000A121,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A121,
        0x0000A121,
        0x0000A121
    };

    static _CharacterInfo _character0000A122 =
    {
        0x0000A122,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A122,
        0x0000A122,
        0x0000A122
    };

    static _CharacterInfo _character0000A123 =
    {
        0x0000A123,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A123,
        0x0000A123,
        0x0000A123
    };

    static _CharacterInfo _character0000A124 =
    {
        0x0000A124,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A124,
        0x0000A124,
        0x0000A124
    };

    static _CharacterInfo _character0000A125 =
    {
        0x0000A125,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A125,
        0x0000A125,
        0x0000A125
    };

    static _CharacterInfo _character0000A126 =
    {
        0x0000A126,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A126,
        0x0000A126,
        0x0000A126
    };

    static _CharacterInfo _character0000A127 =
    {
        0x0000A127,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A127,
        0x0000A127,
        0x0000A127
    };

    static _CharacterInfo _character0000A128 =
    {
        0x0000A128,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A128,
        0x0000A128,
        0x0000A128
    };

    static _CharacterInfo _character0000A129 =
    {
        0x0000A129,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A129,
        0x0000A129,
        0x0000A129
    };

    static _CharacterInfo _character0000A12A =
    {
        0x0000A12A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12A,
        0x0000A12A,
        0x0000A12A
    };

    static _CharacterInfo _character0000A12B =
    {
        0x0000A12B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12B,
        0x0000A12B,
        0x0000A12B
    };

    static _CharacterInfo _character0000A12C =
    {
        0x0000A12C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12C,
        0x0000A12C,
        0x0000A12C
    };

    static _CharacterInfo _character0000A12D =
    {
        0x0000A12D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12D,
        0x0000A12D,
        0x0000A12D
    };

    static _CharacterInfo _character0000A12E =
    {
        0x0000A12E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12E,
        0x0000A12E,
        0x0000A12E
    };

    static _CharacterInfo _character0000A12F =
    {
        0x0000A12F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A12F,
        0x0000A12F,
        0x0000A12F
    };

    static _CharacterInfo _character0000A130 =
    {
        0x0000A130,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A130,
        0x0000A130,
        0x0000A130
    };

    static _CharacterInfo _character0000A131 =
    {
        0x0000A131,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A131,
        0x0000A131,
        0x0000A131
    };

    static _CharacterInfo _character0000A132 =
    {
        0x0000A132,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A132,
        0x0000A132,
        0x0000A132
    };

    static _CharacterInfo _character0000A133 =
    {
        0x0000A133,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A133,
        0x0000A133,
        0x0000A133
    };

    static _CharacterInfo _character0000A134 =
    {
        0x0000A134,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A134,
        0x0000A134,
        0x0000A134
    };

    static _CharacterInfo _character0000A135 =
    {
        0x0000A135,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A135,
        0x0000A135,
        0x0000A135
    };

    static _CharacterInfo _character0000A136 =
    {
        0x0000A136,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A136,
        0x0000A136,
        0x0000A136
    };

    static _CharacterInfo _character0000A137 =
    {
        0x0000A137,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A137,
        0x0000A137,
        0x0000A137
    };

    static _CharacterInfo _character0000A138 =
    {
        0x0000A138,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A138,
        0x0000A138,
        0x0000A138
    };

    static _CharacterInfo _character0000A139 =
    {
        0x0000A139,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A139,
        0x0000A139,
        0x0000A139
    };

    static _CharacterInfo _character0000A13A =
    {
        0x0000A13A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13A,
        0x0000A13A,
        0x0000A13A
    };

    static _CharacterInfo _character0000A13B =
    {
        0x0000A13B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13B,
        0x0000A13B,
        0x0000A13B
    };

    static _CharacterInfo _character0000A13C =
    {
        0x0000A13C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13C,
        0x0000A13C,
        0x0000A13C
    };

    static _CharacterInfo _character0000A13D =
    {
        0x0000A13D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13D,
        0x0000A13D,
        0x0000A13D
    };

    static _CharacterInfo _character0000A13E =
    {
        0x0000A13E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13E,
        0x0000A13E,
        0x0000A13E
    };

    static _CharacterInfo _character0000A13F =
    {
        0x0000A13F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A13F,
        0x0000A13F,
        0x0000A13F
    };

    static _CharacterInfo _character0000A140 =
    {
        0x0000A140,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A140,
        0x0000A140,
        0x0000A140
    };

    static _CharacterInfo _character0000A141 =
    {
        0x0000A141,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A141,
        0x0000A141,
        0x0000A141
    };

    static _CharacterInfo _character0000A142 =
    {
        0x0000A142,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A142,
        0x0000A142,
        0x0000A142
    };

    static _CharacterInfo _character0000A143 =
    {
        0x0000A143,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A143,
        0x0000A143,
        0x0000A143
    };

    static _CharacterInfo _character0000A144 =
    {
        0x0000A144,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A144,
        0x0000A144,
        0x0000A144
    };

    static _CharacterInfo _character0000A145 =
    {
        0x0000A145,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A145,
        0x0000A145,
        0x0000A145
    };

    static _CharacterInfo _character0000A146 =
    {
        0x0000A146,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A146,
        0x0000A146,
        0x0000A146
    };

    static _CharacterInfo _character0000A147 =
    {
        0x0000A147,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A147,
        0x0000A147,
        0x0000A147
    };

    static _CharacterInfo _character0000A148 =
    {
        0x0000A148,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A148,
        0x0000A148,
        0x0000A148
    };

    static _CharacterInfo _character0000A149 =
    {
        0x0000A149,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A149,
        0x0000A149,
        0x0000A149
    };

    static _CharacterInfo _character0000A14A =
    {
        0x0000A14A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14A,
        0x0000A14A,
        0x0000A14A
    };

    static _CharacterInfo _character0000A14B =
    {
        0x0000A14B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14B,
        0x0000A14B,
        0x0000A14B
    };

    static _CharacterInfo _character0000A14C =
    {
        0x0000A14C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14C,
        0x0000A14C,
        0x0000A14C
    };

    static _CharacterInfo _character0000A14D =
    {
        0x0000A14D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14D,
        0x0000A14D,
        0x0000A14D
    };

    static _CharacterInfo _character0000A14E =
    {
        0x0000A14E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14E,
        0x0000A14E,
        0x0000A14E
    };

    static _CharacterInfo _character0000A14F =
    {
        0x0000A14F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A14F,
        0x0000A14F,
        0x0000A14F
    };

    static _CharacterInfo _character0000A150 =
    {
        0x0000A150,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A150,
        0x0000A150,
        0x0000A150
    };

    static _CharacterInfo _character0000A151 =
    {
        0x0000A151,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A151,
        0x0000A151,
        0x0000A151
    };

    static _CharacterInfo _character0000A152 =
    {
        0x0000A152,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A152,
        0x0000A152,
        0x0000A152
    };

    static _CharacterInfo _character0000A153 =
    {
        0x0000A153,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A153,
        0x0000A153,
        0x0000A153
    };

    static _CharacterInfo _character0000A154 =
    {
        0x0000A154,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A154,
        0x0000A154,
        0x0000A154
    };

    static _CharacterInfo _character0000A155 =
    {
        0x0000A155,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A155,
        0x0000A155,
        0x0000A155
    };

    static _CharacterInfo _character0000A156 =
    {
        0x0000A156,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A156,
        0x0000A156,
        0x0000A156
    };

    static _CharacterInfo _character0000A157 =
    {
        0x0000A157,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A157,
        0x0000A157,
        0x0000A157
    };

    static _CharacterInfo _character0000A158 =
    {
        0x0000A158,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A158,
        0x0000A158,
        0x0000A158
    };

    static _CharacterInfo _character0000A159 =
    {
        0x0000A159,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A159,
        0x0000A159,
        0x0000A159
    };

    static _CharacterInfo _character0000A15A =
    {
        0x0000A15A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15A,
        0x0000A15A,
        0x0000A15A
    };

    static _CharacterInfo _character0000A15B =
    {
        0x0000A15B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15B,
        0x0000A15B,
        0x0000A15B
    };

    static _CharacterInfo _character0000A15C =
    {
        0x0000A15C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15C,
        0x0000A15C,
        0x0000A15C
    };

    static _CharacterInfo _character0000A15D =
    {
        0x0000A15D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15D,
        0x0000A15D,
        0x0000A15D
    };

    static _CharacterInfo _character0000A15E =
    {
        0x0000A15E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15E,
        0x0000A15E,
        0x0000A15E
    };

    static _CharacterInfo _character0000A15F =
    {
        0x0000A15F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A15F,
        0x0000A15F,
        0x0000A15F
    };

    static _CharacterInfo _character0000A160 =
    {
        0x0000A160,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A160,
        0x0000A160,
        0x0000A160
    };

    static _CharacterInfo _character0000A161 =
    {
        0x0000A161,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A161,
        0x0000A161,
        0x0000A161
    };

    static _CharacterInfo _character0000A162 =
    {
        0x0000A162,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A162,
        0x0000A162,
        0x0000A162
    };

    static _CharacterInfo _character0000A163 =
    {
        0x0000A163,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A163,
        0x0000A163,
        0x0000A163
    };

    static _CharacterInfo _character0000A164 =
    {
        0x0000A164,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A164,
        0x0000A164,
        0x0000A164
    };

    static _CharacterInfo _character0000A165 =
    {
        0x0000A165,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A165,
        0x0000A165,
        0x0000A165
    };

    static _CharacterInfo _character0000A166 =
    {
        0x0000A166,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A166,
        0x0000A166,
        0x0000A166
    };

    static _CharacterInfo _character0000A167 =
    {
        0x0000A167,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A167,
        0x0000A167,
        0x0000A167
    };

    static _CharacterInfo _character0000A168 =
    {
        0x0000A168,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A168,
        0x0000A168,
        0x0000A168
    };

    static _CharacterInfo _character0000A169 =
    {
        0x0000A169,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A169,
        0x0000A169,
        0x0000A169
    };

    static _CharacterInfo _character0000A16A =
    {
        0x0000A16A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16A,
        0x0000A16A,
        0x0000A16A
    };

    static _CharacterInfo _character0000A16B =
    {
        0x0000A16B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16B,
        0x0000A16B,
        0x0000A16B
    };

    static _CharacterInfo _character0000A16C =
    {
        0x0000A16C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16C,
        0x0000A16C,
        0x0000A16C
    };

    static _CharacterInfo _character0000A16D =
    {
        0x0000A16D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16D,
        0x0000A16D,
        0x0000A16D
    };

    static _CharacterInfo _character0000A16E =
    {
        0x0000A16E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16E,
        0x0000A16E,
        0x0000A16E
    };

    static _CharacterInfo _character0000A16F =
    {
        0x0000A16F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A16F,
        0x0000A16F,
        0x0000A16F
    };

    static _CharacterInfo _character0000A170 =
    {
        0x0000A170,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A170,
        0x0000A170,
        0x0000A170
    };

    static _CharacterInfo _character0000A171 =
    {
        0x0000A171,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A171,
        0x0000A171,
        0x0000A171
    };

    static _CharacterInfo _character0000A172 =
    {
        0x0000A172,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A172,
        0x0000A172,
        0x0000A172
    };

    static _CharacterInfo _character0000A173 =
    {
        0x0000A173,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A173,
        0x0000A173,
        0x0000A173
    };

    static _CharacterInfo _character0000A174 =
    {
        0x0000A174,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A174,
        0x0000A174,
        0x0000A174
    };

    static _CharacterInfo _character0000A175 =
    {
        0x0000A175,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A175,
        0x0000A175,
        0x0000A175
    };

    static _CharacterInfo _character0000A176 =
    {
        0x0000A176,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A176,
        0x0000A176,
        0x0000A176
    };

    static _CharacterInfo _character0000A177 =
    {
        0x0000A177,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A177,
        0x0000A177,
        0x0000A177
    };

    static _CharacterInfo _character0000A178 =
    {
        0x0000A178,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A178,
        0x0000A178,
        0x0000A178
    };

    static _CharacterInfo _character0000A179 =
    {
        0x0000A179,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A179,
        0x0000A179,
        0x0000A179
    };

    static _CharacterInfo _character0000A17A =
    {
        0x0000A17A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17A,
        0x0000A17A,
        0x0000A17A
    };

    static _CharacterInfo _character0000A17B =
    {
        0x0000A17B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17B,
        0x0000A17B,
        0x0000A17B
    };

    static _CharacterInfo _character0000A17C =
    {
        0x0000A17C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17C,
        0x0000A17C,
        0x0000A17C
    };

    static _CharacterInfo _character0000A17D =
    {
        0x0000A17D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17D,
        0x0000A17D,
        0x0000A17D
    };

    static _CharacterInfo _character0000A17E =
    {
        0x0000A17E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17E,
        0x0000A17E,
        0x0000A17E
    };

    static _CharacterInfo _character0000A17F =
    {
        0x0000A17F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A17F,
        0x0000A17F,
        0x0000A17F
    };

    static _CharacterInfo _character0000A180 =
    {
        0x0000A180,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A180,
        0x0000A180,
        0x0000A180
    };

    static _CharacterInfo _character0000A181 =
    {
        0x0000A181,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A181,
        0x0000A181,
        0x0000A181
    };

    static _CharacterInfo _character0000A182 =
    {
        0x0000A182,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A182,
        0x0000A182,
        0x0000A182
    };

    static _CharacterInfo _character0000A183 =
    {
        0x0000A183,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A183,
        0x0000A183,
        0x0000A183
    };

    static _CharacterInfo _character0000A184 =
    {
        0x0000A184,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A184,
        0x0000A184,
        0x0000A184
    };

    static _CharacterInfo _character0000A185 =
    {
        0x0000A185,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A185,
        0x0000A185,
        0x0000A185
    };

    static _CharacterInfo _character0000A186 =
    {
        0x0000A186,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A186,
        0x0000A186,
        0x0000A186
    };

    static _CharacterInfo _character0000A187 =
    {
        0x0000A187,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A187,
        0x0000A187,
        0x0000A187
    };

    static _CharacterInfo _character0000A188 =
    {
        0x0000A188,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A188,
        0x0000A188,
        0x0000A188
    };

    static _CharacterInfo _character0000A189 =
    {
        0x0000A189,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A189,
        0x0000A189,
        0x0000A189
    };

    static _CharacterInfo _character0000A18A =
    {
        0x0000A18A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18A,
        0x0000A18A,
        0x0000A18A
    };

    static _CharacterInfo _character0000A18B =
    {
        0x0000A18B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18B,
        0x0000A18B,
        0x0000A18B
    };

    static _CharacterInfo _character0000A18C =
    {
        0x0000A18C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18C,
        0x0000A18C,
        0x0000A18C
    };

    static _CharacterInfo _character0000A18D =
    {
        0x0000A18D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18D,
        0x0000A18D,
        0x0000A18D
    };

    static _CharacterInfo _character0000A18E =
    {
        0x0000A18E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18E,
        0x0000A18E,
        0x0000A18E
    };

    static _CharacterInfo _character0000A18F =
    {
        0x0000A18F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A18F,
        0x0000A18F,
        0x0000A18F
    };

    static _CharacterInfo _character0000A190 =
    {
        0x0000A190,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A190,
        0x0000A190,
        0x0000A190
    };

    static _CharacterInfo _character0000A191 =
    {
        0x0000A191,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A191,
        0x0000A191,
        0x0000A191
    };

    static _CharacterInfo _character0000A192 =
    {
        0x0000A192,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A192,
        0x0000A192,
        0x0000A192
    };

    static _CharacterInfo _character0000A193 =
    {
        0x0000A193,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A193,
        0x0000A193,
        0x0000A193
    };

    static _CharacterInfo _character0000A194 =
    {
        0x0000A194,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A194,
        0x0000A194,
        0x0000A194
    };

    static _CharacterInfo _character0000A195 =
    {
        0x0000A195,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A195,
        0x0000A195,
        0x0000A195
    };

    static _CharacterInfo _character0000A196 =
    {
        0x0000A196,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A196,
        0x0000A196,
        0x0000A196
    };

    static _CharacterInfo _character0000A197 =
    {
        0x0000A197,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A197,
        0x0000A197,
        0x0000A197
    };

    static _CharacterInfo _character0000A198 =
    {
        0x0000A198,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A198,
        0x0000A198,
        0x0000A198
    };

    static _CharacterInfo _character0000A199 =
    {
        0x0000A199,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A199,
        0x0000A199,
        0x0000A199
    };

    static _CharacterInfo _character0000A19A =
    {
        0x0000A19A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19A,
        0x0000A19A,
        0x0000A19A
    };

    static _CharacterInfo _character0000A19B =
    {
        0x0000A19B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19B,
        0x0000A19B,
        0x0000A19B
    };

    static _CharacterInfo _character0000A19C =
    {
        0x0000A19C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19C,
        0x0000A19C,
        0x0000A19C
    };

    static _CharacterInfo _character0000A19D =
    {
        0x0000A19D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19D,
        0x0000A19D,
        0x0000A19D
    };

    static _CharacterInfo _character0000A19E =
    {
        0x0000A19E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19E,
        0x0000A19E,
        0x0000A19E
    };

    static _CharacterInfo _character0000A19F =
    {
        0x0000A19F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A19F,
        0x0000A19F,
        0x0000A19F
    };

    static _CharacterInfo _character0000A1A0 =
    {
        0x0000A1A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A0,
        0x0000A1A0,
        0x0000A1A0
    };

    static _CharacterInfo _character0000A1A1 =
    {
        0x0000A1A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A1,
        0x0000A1A1,
        0x0000A1A1
    };

    static _CharacterInfo _character0000A1A2 =
    {
        0x0000A1A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A2,
        0x0000A1A2,
        0x0000A1A2
    };

    static _CharacterInfo _character0000A1A3 =
    {
        0x0000A1A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A3,
        0x0000A1A3,
        0x0000A1A3
    };

    static _CharacterInfo _character0000A1A4 =
    {
        0x0000A1A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A4,
        0x0000A1A4,
        0x0000A1A4
    };

    static _CharacterInfo _character0000A1A5 =
    {
        0x0000A1A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A5,
        0x0000A1A5,
        0x0000A1A5
    };

    static _CharacterInfo _character0000A1A6 =
    {
        0x0000A1A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A6,
        0x0000A1A6,
        0x0000A1A6
    };

    static _CharacterInfo _character0000A1A7 =
    {
        0x0000A1A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A7,
        0x0000A1A7,
        0x0000A1A7
    };

    static _CharacterInfo _character0000A1A8 =
    {
        0x0000A1A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A8,
        0x0000A1A8,
        0x0000A1A8
    };

    static _CharacterInfo _character0000A1A9 =
    {
        0x0000A1A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1A9,
        0x0000A1A9,
        0x0000A1A9
    };

    static _CharacterInfo _character0000A1AA =
    {
        0x0000A1AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AA,
        0x0000A1AA,
        0x0000A1AA
    };

    static _CharacterInfo _character0000A1AB =
    {
        0x0000A1AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AB,
        0x0000A1AB,
        0x0000A1AB
    };

    static _CharacterInfo _character0000A1AC =
    {
        0x0000A1AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AC,
        0x0000A1AC,
        0x0000A1AC
    };

    static _CharacterInfo _character0000A1AD =
    {
        0x0000A1AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AD,
        0x0000A1AD,
        0x0000A1AD
    };

    static _CharacterInfo _character0000A1AE =
    {
        0x0000A1AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AE,
        0x0000A1AE,
        0x0000A1AE
    };

    static _CharacterInfo _character0000A1AF =
    {
        0x0000A1AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1AF,
        0x0000A1AF,
        0x0000A1AF
    };

    static _CharacterInfo _character0000A1B0 =
    {
        0x0000A1B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B0,
        0x0000A1B0,
        0x0000A1B0
    };

    static _CharacterInfo _character0000A1B1 =
    {
        0x0000A1B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B1,
        0x0000A1B1,
        0x0000A1B1
    };

    static _CharacterInfo _character0000A1B2 =
    {
        0x0000A1B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B2,
        0x0000A1B2,
        0x0000A1B2
    };

    static _CharacterInfo _character0000A1B3 =
    {
        0x0000A1B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B3,
        0x0000A1B3,
        0x0000A1B3
    };

    static _CharacterInfo _character0000A1B4 =
    {
        0x0000A1B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B4,
        0x0000A1B4,
        0x0000A1B4
    };

    static _CharacterInfo _character0000A1B5 =
    {
        0x0000A1B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B5,
        0x0000A1B5,
        0x0000A1B5
    };

    static _CharacterInfo _character0000A1B6 =
    {
        0x0000A1B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B6,
        0x0000A1B6,
        0x0000A1B6
    };

    static _CharacterInfo _character0000A1B7 =
    {
        0x0000A1B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B7,
        0x0000A1B7,
        0x0000A1B7
    };

    static _CharacterInfo _character0000A1B8 =
    {
        0x0000A1B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B8,
        0x0000A1B8,
        0x0000A1B8
    };

    static _CharacterInfo _character0000A1B9 =
    {
        0x0000A1B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1B9,
        0x0000A1B9,
        0x0000A1B9
    };

    static _CharacterInfo _character0000A1BA =
    {
        0x0000A1BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BA,
        0x0000A1BA,
        0x0000A1BA
    };

    static _CharacterInfo _character0000A1BB =
    {
        0x0000A1BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BB,
        0x0000A1BB,
        0x0000A1BB
    };

    static _CharacterInfo _character0000A1BC =
    {
        0x0000A1BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BC,
        0x0000A1BC,
        0x0000A1BC
    };

    static _CharacterInfo _character0000A1BD =
    {
        0x0000A1BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BD,
        0x0000A1BD,
        0x0000A1BD
    };

    static _CharacterInfo _character0000A1BE =
    {
        0x0000A1BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BE,
        0x0000A1BE,
        0x0000A1BE
    };

    static _CharacterInfo _character0000A1BF =
    {
        0x0000A1BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1BF,
        0x0000A1BF,
        0x0000A1BF
    };

    static _CharacterInfo _character0000A1C0 =
    {
        0x0000A1C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C0,
        0x0000A1C0,
        0x0000A1C0
    };

    static _CharacterInfo _character0000A1C1 =
    {
        0x0000A1C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C1,
        0x0000A1C1,
        0x0000A1C1
    };

    static _CharacterInfo _character0000A1C2 =
    {
        0x0000A1C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C2,
        0x0000A1C2,
        0x0000A1C2
    };

    static _CharacterInfo _character0000A1C3 =
    {
        0x0000A1C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C3,
        0x0000A1C3,
        0x0000A1C3
    };

    static _CharacterInfo _character0000A1C4 =
    {
        0x0000A1C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C4,
        0x0000A1C4,
        0x0000A1C4
    };

    static _CharacterInfo _character0000A1C5 =
    {
        0x0000A1C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C5,
        0x0000A1C5,
        0x0000A1C5
    };

    static _CharacterInfo _character0000A1C6 =
    {
        0x0000A1C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C6,
        0x0000A1C6,
        0x0000A1C6
    };

    static _CharacterInfo _character0000A1C7 =
    {
        0x0000A1C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C7,
        0x0000A1C7,
        0x0000A1C7
    };

    static _CharacterInfo _character0000A1C8 =
    {
        0x0000A1C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C8,
        0x0000A1C8,
        0x0000A1C8
    };

    static _CharacterInfo _character0000A1C9 =
    {
        0x0000A1C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1C9,
        0x0000A1C9,
        0x0000A1C9
    };

    static _CharacterInfo _character0000A1CA =
    {
        0x0000A1CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CA,
        0x0000A1CA,
        0x0000A1CA
    };

    static _CharacterInfo _character0000A1CB =
    {
        0x0000A1CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CB,
        0x0000A1CB,
        0x0000A1CB
    };

    static _CharacterInfo _character0000A1CC =
    {
        0x0000A1CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CC,
        0x0000A1CC,
        0x0000A1CC
    };

    static _CharacterInfo _character0000A1CD =
    {
        0x0000A1CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CD,
        0x0000A1CD,
        0x0000A1CD
    };

    static _CharacterInfo _character0000A1CE =
    {
        0x0000A1CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CE,
        0x0000A1CE,
        0x0000A1CE
    };

    static _CharacterInfo _character0000A1CF =
    {
        0x0000A1CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1CF,
        0x0000A1CF,
        0x0000A1CF
    };

    static _CharacterInfo _character0000A1D0 =
    {
        0x0000A1D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D0,
        0x0000A1D0,
        0x0000A1D0
    };

    static _CharacterInfo _character0000A1D1 =
    {
        0x0000A1D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D1,
        0x0000A1D1,
        0x0000A1D1
    };

    static _CharacterInfo _character0000A1D2 =
    {
        0x0000A1D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D2,
        0x0000A1D2,
        0x0000A1D2
    };

    static _CharacterInfo _character0000A1D3 =
    {
        0x0000A1D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D3,
        0x0000A1D3,
        0x0000A1D3
    };

    static _CharacterInfo _character0000A1D4 =
    {
        0x0000A1D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D4,
        0x0000A1D4,
        0x0000A1D4
    };

    static _CharacterInfo _character0000A1D5 =
    {
        0x0000A1D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D5,
        0x0000A1D5,
        0x0000A1D5
    };

    static _CharacterInfo _character0000A1D6 =
    {
        0x0000A1D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D6,
        0x0000A1D6,
        0x0000A1D6
    };

    static _CharacterInfo _character0000A1D7 =
    {
        0x0000A1D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D7,
        0x0000A1D7,
        0x0000A1D7
    };

    static _CharacterInfo _character0000A1D8 =
    {
        0x0000A1D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D8,
        0x0000A1D8,
        0x0000A1D8
    };

    static _CharacterInfo _character0000A1D9 =
    {
        0x0000A1D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1D9,
        0x0000A1D9,
        0x0000A1D9
    };

    static _CharacterInfo _character0000A1DA =
    {
        0x0000A1DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DA,
        0x0000A1DA,
        0x0000A1DA
    };

    static _CharacterInfo _character0000A1DB =
    {
        0x0000A1DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DB,
        0x0000A1DB,
        0x0000A1DB
    };

    static _CharacterInfo _character0000A1DC =
    {
        0x0000A1DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DC,
        0x0000A1DC,
        0x0000A1DC
    };

    static _CharacterInfo _character0000A1DD =
    {
        0x0000A1DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DD,
        0x0000A1DD,
        0x0000A1DD
    };

    static _CharacterInfo _character0000A1DE =
    {
        0x0000A1DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DE,
        0x0000A1DE,
        0x0000A1DE
    };

    static _CharacterInfo _character0000A1DF =
    {
        0x0000A1DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1DF,
        0x0000A1DF,
        0x0000A1DF
    };

    static _CharacterInfo _character0000A1E0 =
    {
        0x0000A1E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E0,
        0x0000A1E0,
        0x0000A1E0
    };

    static _CharacterInfo _character0000A1E1 =
    {
        0x0000A1E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E1,
        0x0000A1E1,
        0x0000A1E1
    };

    static _CharacterInfo _character0000A1E2 =
    {
        0x0000A1E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E2,
        0x0000A1E2,
        0x0000A1E2
    };

    static _CharacterInfo _character0000A1E3 =
    {
        0x0000A1E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E3,
        0x0000A1E3,
        0x0000A1E3
    };

    static _CharacterInfo _character0000A1E4 =
    {
        0x0000A1E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E4,
        0x0000A1E4,
        0x0000A1E4
    };

    static _CharacterInfo _character0000A1E5 =
    {
        0x0000A1E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E5,
        0x0000A1E5,
        0x0000A1E5
    };

    static _CharacterInfo _character0000A1E6 =
    {
        0x0000A1E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E6,
        0x0000A1E6,
        0x0000A1E6
    };

    static _CharacterInfo _character0000A1E7 =
    {
        0x0000A1E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E7,
        0x0000A1E7,
        0x0000A1E7
    };

    static _CharacterInfo _character0000A1E8 =
    {
        0x0000A1E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E8,
        0x0000A1E8,
        0x0000A1E8
    };

    static _CharacterInfo _character0000A1E9 =
    {
        0x0000A1E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1E9,
        0x0000A1E9,
        0x0000A1E9
    };

    static _CharacterInfo _character0000A1EA =
    {
        0x0000A1EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1EA,
        0x0000A1EA,
        0x0000A1EA
    };

    static _CharacterInfo _character0000A1EB =
    {
        0x0000A1EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1EB,
        0x0000A1EB,
        0x0000A1EB
    };

    static _CharacterInfo _character0000A1EC =
    {
        0x0000A1EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1EC,
        0x0000A1EC,
        0x0000A1EC
    };

    static _CharacterInfo _character0000A1ED =
    {
        0x0000A1ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1ED,
        0x0000A1ED,
        0x0000A1ED
    };

    static _CharacterInfo _character0000A1EE =
    {
        0x0000A1EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1EE,
        0x0000A1EE,
        0x0000A1EE
    };

    static _CharacterInfo _character0000A1EF =
    {
        0x0000A1EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1EF,
        0x0000A1EF,
        0x0000A1EF
    };

    static _CharacterInfo _character0000A1F0 =
    {
        0x0000A1F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F0,
        0x0000A1F0,
        0x0000A1F0
    };

    static _CharacterInfo _character0000A1F1 =
    {
        0x0000A1F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F1,
        0x0000A1F1,
        0x0000A1F1
    };

    static _CharacterInfo _character0000A1F2 =
    {
        0x0000A1F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F2,
        0x0000A1F2,
        0x0000A1F2
    };

    static _CharacterInfo _character0000A1F3 =
    {
        0x0000A1F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F3,
        0x0000A1F3,
        0x0000A1F3
    };

    static _CharacterInfo _character0000A1F4 =
    {
        0x0000A1F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F4,
        0x0000A1F4,
        0x0000A1F4
    };

    static _CharacterInfo _character0000A1F5 =
    {
        0x0000A1F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F5,
        0x0000A1F5,
        0x0000A1F5
    };

    static _CharacterInfo _character0000A1F6 =
    {
        0x0000A1F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F6,
        0x0000A1F6,
        0x0000A1F6
    };

    static _CharacterInfo _character0000A1F7 =
    {
        0x0000A1F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F7,
        0x0000A1F7,
        0x0000A1F7
    };

    static _CharacterInfo _character0000A1F8 =
    {
        0x0000A1F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F8,
        0x0000A1F8,
        0x0000A1F8
    };

    static _CharacterInfo _character0000A1F9 =
    {
        0x0000A1F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1F9,
        0x0000A1F9,
        0x0000A1F9
    };

    static _CharacterInfo _character0000A1FA =
    {
        0x0000A1FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FA,
        0x0000A1FA,
        0x0000A1FA
    };

    static _CharacterInfo _character0000A1FB =
    {
        0x0000A1FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FB,
        0x0000A1FB,
        0x0000A1FB
    };

    static _CharacterInfo _character0000A1FC =
    {
        0x0000A1FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FC,
        0x0000A1FC,
        0x0000A1FC
    };

    static _CharacterInfo _character0000A1FD =
    {
        0x0000A1FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FD,
        0x0000A1FD,
        0x0000A1FD
    };

    static _CharacterInfo _character0000A1FE =
    {
        0x0000A1FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FE,
        0x0000A1FE,
        0x0000A1FE
    };

    static _CharacterInfo _character0000A1FF =
    {
        0x0000A1FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A1FF,
        0x0000A1FF,
        0x0000A1FF
    };

    static _CharacterInfo _character0000A200 =
    {
        0x0000A200,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A200,
        0x0000A200,
        0x0000A200
    };

    static _CharacterInfo _character0000A201 =
    {
        0x0000A201,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A201,
        0x0000A201,
        0x0000A201
    };

    static _CharacterInfo _character0000A202 =
    {
        0x0000A202,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A202,
        0x0000A202,
        0x0000A202
    };

    static _CharacterInfo _character0000A203 =
    {
        0x0000A203,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A203,
        0x0000A203,
        0x0000A203
    };

    static _CharacterInfo _character0000A204 =
    {
        0x0000A204,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A204,
        0x0000A204,
        0x0000A204
    };

    static _CharacterInfo _character0000A205 =
    {
        0x0000A205,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A205,
        0x0000A205,
        0x0000A205
    };

    static _CharacterInfo _character0000A206 =
    {
        0x0000A206,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A206,
        0x0000A206,
        0x0000A206
    };

    static _CharacterInfo _character0000A207 =
    {
        0x0000A207,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A207,
        0x0000A207,
        0x0000A207
    };

    static _CharacterInfo _character0000A208 =
    {
        0x0000A208,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A208,
        0x0000A208,
        0x0000A208
    };

    static _CharacterInfo _character0000A209 =
    {
        0x0000A209,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A209,
        0x0000A209,
        0x0000A209
    };

    static _CharacterInfo _character0000A20A =
    {
        0x0000A20A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20A,
        0x0000A20A,
        0x0000A20A
    };

    static _CharacterInfo _character0000A20B =
    {
        0x0000A20B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20B,
        0x0000A20B,
        0x0000A20B
    };

    static _CharacterInfo _character0000A20C =
    {
        0x0000A20C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20C,
        0x0000A20C,
        0x0000A20C
    };

    static _CharacterInfo _character0000A20D =
    {
        0x0000A20D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20D,
        0x0000A20D,
        0x0000A20D
    };

    static _CharacterInfo _character0000A20E =
    {
        0x0000A20E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20E,
        0x0000A20E,
        0x0000A20E
    };

    static _CharacterInfo _character0000A20F =
    {
        0x0000A20F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A20F,
        0x0000A20F,
        0x0000A20F
    };

    static _CharacterInfo _character0000A210 =
    {
        0x0000A210,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A210,
        0x0000A210,
        0x0000A210
    };

    static _CharacterInfo _character0000A211 =
    {
        0x0000A211,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A211,
        0x0000A211,
        0x0000A211
    };

    static _CharacterInfo _character0000A212 =
    {
        0x0000A212,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A212,
        0x0000A212,
        0x0000A212
    };

    static _CharacterInfo _character0000A213 =
    {
        0x0000A213,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A213,
        0x0000A213,
        0x0000A213
    };

    static _CharacterInfo _character0000A214 =
    {
        0x0000A214,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A214,
        0x0000A214,
        0x0000A214
    };

    static _CharacterInfo _character0000A215 =
    {
        0x0000A215,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A215,
        0x0000A215,
        0x0000A215
    };

    static _CharacterInfo _character0000A216 =
    {
        0x0000A216,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A216,
        0x0000A216,
        0x0000A216
    };

    static _CharacterInfo _character0000A217 =
    {
        0x0000A217,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A217,
        0x0000A217,
        0x0000A217
    };

    static _CharacterInfo _character0000A218 =
    {
        0x0000A218,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A218,
        0x0000A218,
        0x0000A218
    };

    static _CharacterInfo _character0000A219 =
    {
        0x0000A219,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A219,
        0x0000A219,
        0x0000A219
    };

    static _CharacterInfo _character0000A21A =
    {
        0x0000A21A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21A,
        0x0000A21A,
        0x0000A21A
    };

    static _CharacterInfo _character0000A21B =
    {
        0x0000A21B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21B,
        0x0000A21B,
        0x0000A21B
    };

    static _CharacterInfo _character0000A21C =
    {
        0x0000A21C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21C,
        0x0000A21C,
        0x0000A21C
    };

    static _CharacterInfo _character0000A21D =
    {
        0x0000A21D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21D,
        0x0000A21D,
        0x0000A21D
    };

    static _CharacterInfo _character0000A21E =
    {
        0x0000A21E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21E,
        0x0000A21E,
        0x0000A21E
    };

    static _CharacterInfo _character0000A21F =
    {
        0x0000A21F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A21F,
        0x0000A21F,
        0x0000A21F
    };

    static _CharacterInfo _character0000A220 =
    {
        0x0000A220,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A220,
        0x0000A220,
        0x0000A220
    };

    static _CharacterInfo _character0000A221 =
    {
        0x0000A221,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A221,
        0x0000A221,
        0x0000A221
    };

    static _CharacterInfo _character0000A222 =
    {
        0x0000A222,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A222,
        0x0000A222,
        0x0000A222
    };

    static _CharacterInfo _character0000A223 =
    {
        0x0000A223,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A223,
        0x0000A223,
        0x0000A223
    };

    static _CharacterInfo _character0000A224 =
    {
        0x0000A224,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A224,
        0x0000A224,
        0x0000A224
    };

    static _CharacterInfo _character0000A225 =
    {
        0x0000A225,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A225,
        0x0000A225,
        0x0000A225
    };

    static _CharacterInfo _character0000A226 =
    {
        0x0000A226,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A226,
        0x0000A226,
        0x0000A226
    };

    static _CharacterInfo _character0000A227 =
    {
        0x0000A227,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A227,
        0x0000A227,
        0x0000A227
    };

    static _CharacterInfo _character0000A228 =
    {
        0x0000A228,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A228,
        0x0000A228,
        0x0000A228
    };

    static _CharacterInfo _character0000A229 =
    {
        0x0000A229,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A229,
        0x0000A229,
        0x0000A229
    };

    static _CharacterInfo _character0000A22A =
    {
        0x0000A22A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22A,
        0x0000A22A,
        0x0000A22A
    };

    static _CharacterInfo _character0000A22B =
    {
        0x0000A22B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22B,
        0x0000A22B,
        0x0000A22B
    };

    static _CharacterInfo _character0000A22C =
    {
        0x0000A22C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22C,
        0x0000A22C,
        0x0000A22C
    };

    static _CharacterInfo _character0000A22D =
    {
        0x0000A22D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22D,
        0x0000A22D,
        0x0000A22D
    };

    static _CharacterInfo _character0000A22E =
    {
        0x0000A22E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22E,
        0x0000A22E,
        0x0000A22E
    };

    static _CharacterInfo _character0000A22F =
    {
        0x0000A22F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A22F,
        0x0000A22F,
        0x0000A22F
    };

    static _CharacterInfo _character0000A230 =
    {
        0x0000A230,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A230,
        0x0000A230,
        0x0000A230
    };

    static _CharacterInfo _character0000A231 =
    {
        0x0000A231,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A231,
        0x0000A231,
        0x0000A231
    };

    static _CharacterInfo _character0000A232 =
    {
        0x0000A232,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A232,
        0x0000A232,
        0x0000A232
    };

    static _CharacterInfo _character0000A233 =
    {
        0x0000A233,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A233,
        0x0000A233,
        0x0000A233
    };

    static _CharacterInfo _character0000A234 =
    {
        0x0000A234,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A234,
        0x0000A234,
        0x0000A234
    };

    static _CharacterInfo _character0000A235 =
    {
        0x0000A235,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A235,
        0x0000A235,
        0x0000A235
    };

    static _CharacterInfo _character0000A236 =
    {
        0x0000A236,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A236,
        0x0000A236,
        0x0000A236
    };

    static _CharacterInfo _character0000A237 =
    {
        0x0000A237,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A237,
        0x0000A237,
        0x0000A237
    };

    static _CharacterInfo _character0000A238 =
    {
        0x0000A238,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A238,
        0x0000A238,
        0x0000A238
    };

    static _CharacterInfo _character0000A239 =
    {
        0x0000A239,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A239,
        0x0000A239,
        0x0000A239
    };

    static _CharacterInfo _character0000A23A =
    {
        0x0000A23A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23A,
        0x0000A23A,
        0x0000A23A
    };

    static _CharacterInfo _character0000A23B =
    {
        0x0000A23B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23B,
        0x0000A23B,
        0x0000A23B
    };

    static _CharacterInfo _character0000A23C =
    {
        0x0000A23C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23C,
        0x0000A23C,
        0x0000A23C
    };

    static _CharacterInfo _character0000A23D =
    {
        0x0000A23D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23D,
        0x0000A23D,
        0x0000A23D
    };

    static _CharacterInfo _character0000A23E =
    {
        0x0000A23E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23E,
        0x0000A23E,
        0x0000A23E
    };

    static _CharacterInfo _character0000A23F =
    {
        0x0000A23F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A23F,
        0x0000A23F,
        0x0000A23F
    };

    static _CharacterInfo _character0000A240 =
    {
        0x0000A240,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A240,
        0x0000A240,
        0x0000A240
    };

    static _CharacterInfo _character0000A241 =
    {
        0x0000A241,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A241,
        0x0000A241,
        0x0000A241
    };

    static _CharacterInfo _character0000A242 =
    {
        0x0000A242,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A242,
        0x0000A242,
        0x0000A242
    };

    static _CharacterInfo _character0000A243 =
    {
        0x0000A243,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A243,
        0x0000A243,
        0x0000A243
    };

    static _CharacterInfo _character0000A244 =
    {
        0x0000A244,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A244,
        0x0000A244,
        0x0000A244
    };

    static _CharacterInfo _character0000A245 =
    {
        0x0000A245,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A245,
        0x0000A245,
        0x0000A245
    };

    static _CharacterInfo _character0000A246 =
    {
        0x0000A246,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A246,
        0x0000A246,
        0x0000A246
    };

    static _CharacterInfo _character0000A247 =
    {
        0x0000A247,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A247,
        0x0000A247,
        0x0000A247
    };

    static _CharacterInfo _character0000A248 =
    {
        0x0000A248,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A248,
        0x0000A248,
        0x0000A248
    };

    static _CharacterInfo _character0000A249 =
    {
        0x0000A249,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A249,
        0x0000A249,
        0x0000A249
    };

    static _CharacterInfo _character0000A24A =
    {
        0x0000A24A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24A,
        0x0000A24A,
        0x0000A24A
    };

    static _CharacterInfo _character0000A24B =
    {
        0x0000A24B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24B,
        0x0000A24B,
        0x0000A24B
    };

    static _CharacterInfo _character0000A24C =
    {
        0x0000A24C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24C,
        0x0000A24C,
        0x0000A24C
    };

    static _CharacterInfo _character0000A24D =
    {
        0x0000A24D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24D,
        0x0000A24D,
        0x0000A24D
    };

    static _CharacterInfo _character0000A24E =
    {
        0x0000A24E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24E,
        0x0000A24E,
        0x0000A24E
    };

    static _CharacterInfo _character0000A24F =
    {
        0x0000A24F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A24F,
        0x0000A24F,
        0x0000A24F
    };

    static _CharacterInfo _character0000A250 =
    {
        0x0000A250,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A250,
        0x0000A250,
        0x0000A250
    };

    static _CharacterInfo _character0000A251 =
    {
        0x0000A251,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A251,
        0x0000A251,
        0x0000A251
    };

    static _CharacterInfo _character0000A252 =
    {
        0x0000A252,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A252,
        0x0000A252,
        0x0000A252
    };

    static _CharacterInfo _character0000A253 =
    {
        0x0000A253,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A253,
        0x0000A253,
        0x0000A253
    };

    static _CharacterInfo _character0000A254 =
    {
        0x0000A254,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A254,
        0x0000A254,
        0x0000A254
    };

    static _CharacterInfo _character0000A255 =
    {
        0x0000A255,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A255,
        0x0000A255,
        0x0000A255
    };

    static _CharacterInfo _character0000A256 =
    {
        0x0000A256,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A256,
        0x0000A256,
        0x0000A256
    };

    static _CharacterInfo _character0000A257 =
    {
        0x0000A257,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A257,
        0x0000A257,
        0x0000A257
    };

    static _CharacterInfo _character0000A258 =
    {
        0x0000A258,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A258,
        0x0000A258,
        0x0000A258
    };

    static _CharacterInfo _character0000A259 =
    {
        0x0000A259,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A259,
        0x0000A259,
        0x0000A259
    };

    static _CharacterInfo _character0000A25A =
    {
        0x0000A25A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25A,
        0x0000A25A,
        0x0000A25A
    };

    static _CharacterInfo _character0000A25B =
    {
        0x0000A25B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25B,
        0x0000A25B,
        0x0000A25B
    };

    static _CharacterInfo _character0000A25C =
    {
        0x0000A25C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25C,
        0x0000A25C,
        0x0000A25C
    };

    static _CharacterInfo _character0000A25D =
    {
        0x0000A25D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25D,
        0x0000A25D,
        0x0000A25D
    };

    static _CharacterInfo _character0000A25E =
    {
        0x0000A25E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25E,
        0x0000A25E,
        0x0000A25E
    };

    static _CharacterInfo _character0000A25F =
    {
        0x0000A25F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A25F,
        0x0000A25F,
        0x0000A25F
    };

    static _CharacterInfo _character0000A260 =
    {
        0x0000A260,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A260,
        0x0000A260,
        0x0000A260
    };

    static _CharacterInfo _character0000A261 =
    {
        0x0000A261,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A261,
        0x0000A261,
        0x0000A261
    };

    static _CharacterInfo _character0000A262 =
    {
        0x0000A262,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A262,
        0x0000A262,
        0x0000A262
    };

    static _CharacterInfo _character0000A263 =
    {
        0x0000A263,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A263,
        0x0000A263,
        0x0000A263
    };

    static _CharacterInfo _character0000A264 =
    {
        0x0000A264,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A264,
        0x0000A264,
        0x0000A264
    };

    static _CharacterInfo _character0000A265 =
    {
        0x0000A265,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A265,
        0x0000A265,
        0x0000A265
    };

    static _CharacterInfo _character0000A266 =
    {
        0x0000A266,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A266,
        0x0000A266,
        0x0000A266
    };

    static _CharacterInfo _character0000A267 =
    {
        0x0000A267,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A267,
        0x0000A267,
        0x0000A267
    };

    static _CharacterInfo _character0000A268 =
    {
        0x0000A268,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A268,
        0x0000A268,
        0x0000A268
    };

    static _CharacterInfo _character0000A269 =
    {
        0x0000A269,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A269,
        0x0000A269,
        0x0000A269
    };

    static _CharacterInfo _character0000A26A =
    {
        0x0000A26A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26A,
        0x0000A26A,
        0x0000A26A
    };

    static _CharacterInfo _character0000A26B =
    {
        0x0000A26B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26B,
        0x0000A26B,
        0x0000A26B
    };

    static _CharacterInfo _character0000A26C =
    {
        0x0000A26C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26C,
        0x0000A26C,
        0x0000A26C
    };

    static _CharacterInfo _character0000A26D =
    {
        0x0000A26D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26D,
        0x0000A26D,
        0x0000A26D
    };

    static _CharacterInfo _character0000A26E =
    {
        0x0000A26E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26E,
        0x0000A26E,
        0x0000A26E
    };

    static _CharacterInfo _character0000A26F =
    {
        0x0000A26F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A26F,
        0x0000A26F,
        0x0000A26F
    };

    static _CharacterInfo _character0000A270 =
    {
        0x0000A270,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A270,
        0x0000A270,
        0x0000A270
    };

    static _CharacterInfo _character0000A271 =
    {
        0x0000A271,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A271,
        0x0000A271,
        0x0000A271
    };

    static _CharacterInfo _character0000A272 =
    {
        0x0000A272,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A272,
        0x0000A272,
        0x0000A272
    };

    static _CharacterInfo _character0000A273 =
    {
        0x0000A273,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A273,
        0x0000A273,
        0x0000A273
    };

    static _CharacterInfo _character0000A274 =
    {
        0x0000A274,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A274,
        0x0000A274,
        0x0000A274
    };

    static _CharacterInfo _character0000A275 =
    {
        0x0000A275,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A275,
        0x0000A275,
        0x0000A275
    };

    static _CharacterInfo _character0000A276 =
    {
        0x0000A276,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A276,
        0x0000A276,
        0x0000A276
    };

    static _CharacterInfo _character0000A277 =
    {
        0x0000A277,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A277,
        0x0000A277,
        0x0000A277
    };

    static _CharacterInfo _character0000A278 =
    {
        0x0000A278,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A278,
        0x0000A278,
        0x0000A278
    };

    static _CharacterInfo _character0000A279 =
    {
        0x0000A279,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A279,
        0x0000A279,
        0x0000A279
    };

    static _CharacterInfo _character0000A27A =
    {
        0x0000A27A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27A,
        0x0000A27A,
        0x0000A27A
    };

    static _CharacterInfo _character0000A27B =
    {
        0x0000A27B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27B,
        0x0000A27B,
        0x0000A27B
    };

    static _CharacterInfo _character0000A27C =
    {
        0x0000A27C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27C,
        0x0000A27C,
        0x0000A27C
    };

    static _CharacterInfo _character0000A27D =
    {
        0x0000A27D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27D,
        0x0000A27D,
        0x0000A27D
    };

    static _CharacterInfo _character0000A27E =
    {
        0x0000A27E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27E,
        0x0000A27E,
        0x0000A27E
    };

    static _CharacterInfo _character0000A27F =
    {
        0x0000A27F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A27F,
        0x0000A27F,
        0x0000A27F
    };

    static _CharacterInfo _character0000A280 =
    {
        0x0000A280,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A280,
        0x0000A280,
        0x0000A280
    };

    static _CharacterInfo _character0000A281 =
    {
        0x0000A281,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A281,
        0x0000A281,
        0x0000A281
    };

    static _CharacterInfo _character0000A282 =
    {
        0x0000A282,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A282,
        0x0000A282,
        0x0000A282
    };

    static _CharacterInfo _character0000A283 =
    {
        0x0000A283,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A283,
        0x0000A283,
        0x0000A283
    };

    static _CharacterInfo _character0000A284 =
    {
        0x0000A284,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A284,
        0x0000A284,
        0x0000A284
    };

    static _CharacterInfo _character0000A285 =
    {
        0x0000A285,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A285,
        0x0000A285,
        0x0000A285
    };

    static _CharacterInfo _character0000A286 =
    {
        0x0000A286,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A286,
        0x0000A286,
        0x0000A286
    };

    static _CharacterInfo _character0000A287 =
    {
        0x0000A287,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A287,
        0x0000A287,
        0x0000A287
    };

    static _CharacterInfo _character0000A288 =
    {
        0x0000A288,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A288,
        0x0000A288,
        0x0000A288
    };

    static _CharacterInfo _character0000A289 =
    {
        0x0000A289,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A289,
        0x0000A289,
        0x0000A289
    };

    static _CharacterInfo _character0000A28A =
    {
        0x0000A28A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28A,
        0x0000A28A,
        0x0000A28A
    };

    static _CharacterInfo _character0000A28B =
    {
        0x0000A28B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28B,
        0x0000A28B,
        0x0000A28B
    };

    static _CharacterInfo _character0000A28C =
    {
        0x0000A28C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28C,
        0x0000A28C,
        0x0000A28C
    };

    static _CharacterInfo _character0000A28D =
    {
        0x0000A28D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28D,
        0x0000A28D,
        0x0000A28D
    };

    static _CharacterInfo _character0000A28E =
    {
        0x0000A28E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28E,
        0x0000A28E,
        0x0000A28E
    };

    static _CharacterInfo _character0000A28F =
    {
        0x0000A28F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A28F,
        0x0000A28F,
        0x0000A28F
    };

    static _CharacterInfo _character0000A290 =
    {
        0x0000A290,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A290,
        0x0000A290,
        0x0000A290
    };

    static _CharacterInfo _character0000A291 =
    {
        0x0000A291,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A291,
        0x0000A291,
        0x0000A291
    };

    static _CharacterInfo _character0000A292 =
    {
        0x0000A292,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A292,
        0x0000A292,
        0x0000A292
    };

    static _CharacterInfo _character0000A293 =
    {
        0x0000A293,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A293,
        0x0000A293,
        0x0000A293
    };

    static _CharacterInfo _character0000A294 =
    {
        0x0000A294,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A294,
        0x0000A294,
        0x0000A294
    };

    static _CharacterInfo _character0000A295 =
    {
        0x0000A295,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A295,
        0x0000A295,
        0x0000A295
    };

    static _CharacterInfo _character0000A296 =
    {
        0x0000A296,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A296,
        0x0000A296,
        0x0000A296
    };

    static _CharacterInfo _character0000A297 =
    {
        0x0000A297,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A297,
        0x0000A297,
        0x0000A297
    };

    static _CharacterInfo _character0000A298 =
    {
        0x0000A298,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A298,
        0x0000A298,
        0x0000A298
    };

    static _CharacterInfo _character0000A299 =
    {
        0x0000A299,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A299,
        0x0000A299,
        0x0000A299
    };

    static _CharacterInfo _character0000A29A =
    {
        0x0000A29A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29A,
        0x0000A29A,
        0x0000A29A
    };

    static _CharacterInfo _character0000A29B =
    {
        0x0000A29B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29B,
        0x0000A29B,
        0x0000A29B
    };

    static _CharacterInfo _character0000A29C =
    {
        0x0000A29C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29C,
        0x0000A29C,
        0x0000A29C
    };

    static _CharacterInfo _character0000A29D =
    {
        0x0000A29D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29D,
        0x0000A29D,
        0x0000A29D
    };

    static _CharacterInfo _character0000A29E =
    {
        0x0000A29E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29E,
        0x0000A29E,
        0x0000A29E
    };

    static _CharacterInfo _character0000A29F =
    {
        0x0000A29F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A29F,
        0x0000A29F,
        0x0000A29F
    };

    static _CharacterInfo _character0000A2A0 =
    {
        0x0000A2A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A0,
        0x0000A2A0,
        0x0000A2A0
    };

    static _CharacterInfo _character0000A2A1 =
    {
        0x0000A2A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A1,
        0x0000A2A1,
        0x0000A2A1
    };

    static _CharacterInfo _character0000A2A2 =
    {
        0x0000A2A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A2,
        0x0000A2A2,
        0x0000A2A2
    };

    static _CharacterInfo _character0000A2A3 =
    {
        0x0000A2A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A3,
        0x0000A2A3,
        0x0000A2A3
    };

    static _CharacterInfo _character0000A2A4 =
    {
        0x0000A2A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A4,
        0x0000A2A4,
        0x0000A2A4
    };

    static _CharacterInfo _character0000A2A5 =
    {
        0x0000A2A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A5,
        0x0000A2A5,
        0x0000A2A5
    };

    static _CharacterInfo _character0000A2A6 =
    {
        0x0000A2A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A6,
        0x0000A2A6,
        0x0000A2A6
    };

    static _CharacterInfo _character0000A2A7 =
    {
        0x0000A2A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A7,
        0x0000A2A7,
        0x0000A2A7
    };

    static _CharacterInfo _character0000A2A8 =
    {
        0x0000A2A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A8,
        0x0000A2A8,
        0x0000A2A8
    };

    static _CharacterInfo _character0000A2A9 =
    {
        0x0000A2A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2A9,
        0x0000A2A9,
        0x0000A2A9
    };

    static _CharacterInfo _character0000A2AA =
    {
        0x0000A2AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AA,
        0x0000A2AA,
        0x0000A2AA
    };

    static _CharacterInfo _character0000A2AB =
    {
        0x0000A2AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AB,
        0x0000A2AB,
        0x0000A2AB
    };

    static _CharacterInfo _character0000A2AC =
    {
        0x0000A2AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AC,
        0x0000A2AC,
        0x0000A2AC
    };

    static _CharacterInfo _character0000A2AD =
    {
        0x0000A2AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AD,
        0x0000A2AD,
        0x0000A2AD
    };

    static _CharacterInfo _character0000A2AE =
    {
        0x0000A2AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AE,
        0x0000A2AE,
        0x0000A2AE
    };

    static _CharacterInfo _character0000A2AF =
    {
        0x0000A2AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2AF,
        0x0000A2AF,
        0x0000A2AF
    };

    static _CharacterInfo _character0000A2B0 =
    {
        0x0000A2B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B0,
        0x0000A2B0,
        0x0000A2B0
    };

    static _CharacterInfo _character0000A2B1 =
    {
        0x0000A2B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B1,
        0x0000A2B1,
        0x0000A2B1
    };

    static _CharacterInfo _character0000A2B2 =
    {
        0x0000A2B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B2,
        0x0000A2B2,
        0x0000A2B2
    };

    static _CharacterInfo _character0000A2B3 =
    {
        0x0000A2B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B3,
        0x0000A2B3,
        0x0000A2B3
    };

    static _CharacterInfo _character0000A2B4 =
    {
        0x0000A2B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B4,
        0x0000A2B4,
        0x0000A2B4
    };

    static _CharacterInfo _character0000A2B5 =
    {
        0x0000A2B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B5,
        0x0000A2B5,
        0x0000A2B5
    };

    static _CharacterInfo _character0000A2B6 =
    {
        0x0000A2B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B6,
        0x0000A2B6,
        0x0000A2B6
    };

    static _CharacterInfo _character0000A2B7 =
    {
        0x0000A2B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B7,
        0x0000A2B7,
        0x0000A2B7
    };

    static _CharacterInfo _character0000A2B8 =
    {
        0x0000A2B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B8,
        0x0000A2B8,
        0x0000A2B8
    };

    static _CharacterInfo _character0000A2B9 =
    {
        0x0000A2B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2B9,
        0x0000A2B9,
        0x0000A2B9
    };

    static _CharacterInfo _character0000A2BA =
    {
        0x0000A2BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BA,
        0x0000A2BA,
        0x0000A2BA
    };

    static _CharacterInfo _character0000A2BB =
    {
        0x0000A2BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BB,
        0x0000A2BB,
        0x0000A2BB
    };

    static _CharacterInfo _character0000A2BC =
    {
        0x0000A2BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BC,
        0x0000A2BC,
        0x0000A2BC
    };

    static _CharacterInfo _character0000A2BD =
    {
        0x0000A2BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BD,
        0x0000A2BD,
        0x0000A2BD
    };

    static _CharacterInfo _character0000A2BE =
    {
        0x0000A2BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BE,
        0x0000A2BE,
        0x0000A2BE
    };

    static _CharacterInfo _character0000A2BF =
    {
        0x0000A2BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2BF,
        0x0000A2BF,
        0x0000A2BF
    };

    static _CharacterInfo _character0000A2C0 =
    {
        0x0000A2C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C0,
        0x0000A2C0,
        0x0000A2C0
    };

    static _CharacterInfo _character0000A2C1 =
    {
        0x0000A2C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C1,
        0x0000A2C1,
        0x0000A2C1
    };

    static _CharacterInfo _character0000A2C2 =
    {
        0x0000A2C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C2,
        0x0000A2C2,
        0x0000A2C2
    };

    static _CharacterInfo _character0000A2C3 =
    {
        0x0000A2C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C3,
        0x0000A2C3,
        0x0000A2C3
    };

    static _CharacterInfo _character0000A2C4 =
    {
        0x0000A2C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C4,
        0x0000A2C4,
        0x0000A2C4
    };

    static _CharacterInfo _character0000A2C5 =
    {
        0x0000A2C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C5,
        0x0000A2C5,
        0x0000A2C5
    };

    static _CharacterInfo _character0000A2C6 =
    {
        0x0000A2C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C6,
        0x0000A2C6,
        0x0000A2C6
    };

    static _CharacterInfo _character0000A2C7 =
    {
        0x0000A2C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C7,
        0x0000A2C7,
        0x0000A2C7
    };

    static _CharacterInfo _character0000A2C8 =
    {
        0x0000A2C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C8,
        0x0000A2C8,
        0x0000A2C8
    };

    static _CharacterInfo _character0000A2C9 =
    {
        0x0000A2C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2C9,
        0x0000A2C9,
        0x0000A2C9
    };

    static _CharacterInfo _character0000A2CA =
    {
        0x0000A2CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CA,
        0x0000A2CA,
        0x0000A2CA
    };

    static _CharacterInfo _character0000A2CB =
    {
        0x0000A2CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CB,
        0x0000A2CB,
        0x0000A2CB
    };

    static _CharacterInfo _character0000A2CC =
    {
        0x0000A2CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CC,
        0x0000A2CC,
        0x0000A2CC
    };

    static _CharacterInfo _character0000A2CD =
    {
        0x0000A2CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CD,
        0x0000A2CD,
        0x0000A2CD
    };

    static _CharacterInfo _character0000A2CE =
    {
        0x0000A2CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CE,
        0x0000A2CE,
        0x0000A2CE
    };

    static _CharacterInfo _character0000A2CF =
    {
        0x0000A2CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2CF,
        0x0000A2CF,
        0x0000A2CF
    };

    static _CharacterInfo _character0000A2D0 =
    {
        0x0000A2D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D0,
        0x0000A2D0,
        0x0000A2D0
    };

    static _CharacterInfo _character0000A2D1 =
    {
        0x0000A2D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D1,
        0x0000A2D1,
        0x0000A2D1
    };

    static _CharacterInfo _character0000A2D2 =
    {
        0x0000A2D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D2,
        0x0000A2D2,
        0x0000A2D2
    };

    static _CharacterInfo _character0000A2D3 =
    {
        0x0000A2D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D3,
        0x0000A2D3,
        0x0000A2D3
    };

    static _CharacterInfo _character0000A2D4 =
    {
        0x0000A2D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D4,
        0x0000A2D4,
        0x0000A2D4
    };

    static _CharacterInfo _character0000A2D5 =
    {
        0x0000A2D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D5,
        0x0000A2D5,
        0x0000A2D5
    };

    static _CharacterInfo _character0000A2D6 =
    {
        0x0000A2D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D6,
        0x0000A2D6,
        0x0000A2D6
    };

    static _CharacterInfo _character0000A2D7 =
    {
        0x0000A2D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D7,
        0x0000A2D7,
        0x0000A2D7
    };

    static _CharacterInfo _character0000A2D8 =
    {
        0x0000A2D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D8,
        0x0000A2D8,
        0x0000A2D8
    };

    static _CharacterInfo _character0000A2D9 =
    {
        0x0000A2D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2D9,
        0x0000A2D9,
        0x0000A2D9
    };

    static _CharacterInfo _character0000A2DA =
    {
        0x0000A2DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DA,
        0x0000A2DA,
        0x0000A2DA
    };

    static _CharacterInfo _character0000A2DB =
    {
        0x0000A2DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DB,
        0x0000A2DB,
        0x0000A2DB
    };

    static _CharacterInfo _character0000A2DC =
    {
        0x0000A2DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DC,
        0x0000A2DC,
        0x0000A2DC
    };

    static _CharacterInfo _character0000A2DD =
    {
        0x0000A2DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DD,
        0x0000A2DD,
        0x0000A2DD
    };

    static _CharacterInfo _character0000A2DE =
    {
        0x0000A2DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DE,
        0x0000A2DE,
        0x0000A2DE
    };

    static _CharacterInfo _character0000A2DF =
    {
        0x0000A2DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2DF,
        0x0000A2DF,
        0x0000A2DF
    };

    static _CharacterInfo _character0000A2E0 =
    {
        0x0000A2E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E0,
        0x0000A2E0,
        0x0000A2E0
    };

    static _CharacterInfo _character0000A2E1 =
    {
        0x0000A2E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E1,
        0x0000A2E1,
        0x0000A2E1
    };

    static _CharacterInfo _character0000A2E2 =
    {
        0x0000A2E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E2,
        0x0000A2E2,
        0x0000A2E2
    };

    static _CharacterInfo _character0000A2E3 =
    {
        0x0000A2E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E3,
        0x0000A2E3,
        0x0000A2E3
    };

    static _CharacterInfo _character0000A2E4 =
    {
        0x0000A2E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E4,
        0x0000A2E4,
        0x0000A2E4
    };

    static _CharacterInfo _character0000A2E5 =
    {
        0x0000A2E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E5,
        0x0000A2E5,
        0x0000A2E5
    };

    static _CharacterInfo _character0000A2E6 =
    {
        0x0000A2E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E6,
        0x0000A2E6,
        0x0000A2E6
    };

    static _CharacterInfo _character0000A2E7 =
    {
        0x0000A2E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E7,
        0x0000A2E7,
        0x0000A2E7
    };

    static _CharacterInfo _character0000A2E8 =
    {
        0x0000A2E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E8,
        0x0000A2E8,
        0x0000A2E8
    };

    static _CharacterInfo _character0000A2E9 =
    {
        0x0000A2E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2E9,
        0x0000A2E9,
        0x0000A2E9
    };

    static _CharacterInfo _character0000A2EA =
    {
        0x0000A2EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2EA,
        0x0000A2EA,
        0x0000A2EA
    };

    static _CharacterInfo _character0000A2EB =
    {
        0x0000A2EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2EB,
        0x0000A2EB,
        0x0000A2EB
    };

    static _CharacterInfo _character0000A2EC =
    {
        0x0000A2EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2EC,
        0x0000A2EC,
        0x0000A2EC
    };

    static _CharacterInfo _character0000A2ED =
    {
        0x0000A2ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2ED,
        0x0000A2ED,
        0x0000A2ED
    };

    static _CharacterInfo _character0000A2EE =
    {
        0x0000A2EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2EE,
        0x0000A2EE,
        0x0000A2EE
    };

    static _CharacterInfo _character0000A2EF =
    {
        0x0000A2EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2EF,
        0x0000A2EF,
        0x0000A2EF
    };

    static _CharacterInfo _character0000A2F0 =
    {
        0x0000A2F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F0,
        0x0000A2F0,
        0x0000A2F0
    };

    static _CharacterInfo _character0000A2F1 =
    {
        0x0000A2F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F1,
        0x0000A2F1,
        0x0000A2F1
    };

    static _CharacterInfo _character0000A2F2 =
    {
        0x0000A2F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F2,
        0x0000A2F2,
        0x0000A2F2
    };

    static _CharacterInfo _character0000A2F3 =
    {
        0x0000A2F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F3,
        0x0000A2F3,
        0x0000A2F3
    };

    static _CharacterInfo _character0000A2F4 =
    {
        0x0000A2F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F4,
        0x0000A2F4,
        0x0000A2F4
    };

    static _CharacterInfo _character0000A2F5 =
    {
        0x0000A2F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F5,
        0x0000A2F5,
        0x0000A2F5
    };

    static _CharacterInfo _character0000A2F6 =
    {
        0x0000A2F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F6,
        0x0000A2F6,
        0x0000A2F6
    };

    static _CharacterInfo _character0000A2F7 =
    {
        0x0000A2F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F7,
        0x0000A2F7,
        0x0000A2F7
    };

    static _CharacterInfo _character0000A2F8 =
    {
        0x0000A2F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F8,
        0x0000A2F8,
        0x0000A2F8
    };

    static _CharacterInfo _character0000A2F9 =
    {
        0x0000A2F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2F9,
        0x0000A2F9,
        0x0000A2F9
    };

    static _CharacterInfo _character0000A2FA =
    {
        0x0000A2FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FA,
        0x0000A2FA,
        0x0000A2FA
    };

    static _CharacterInfo _character0000A2FB =
    {
        0x0000A2FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FB,
        0x0000A2FB,
        0x0000A2FB
    };

    static _CharacterInfo _character0000A2FC =
    {
        0x0000A2FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FC,
        0x0000A2FC,
        0x0000A2FC
    };

    static _CharacterInfo _character0000A2FD =
    {
        0x0000A2FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FD,
        0x0000A2FD,
        0x0000A2FD
    };

    static _CharacterInfo _character0000A2FE =
    {
        0x0000A2FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FE,
        0x0000A2FE,
        0x0000A2FE
    };

    static _CharacterInfo _character0000A2FF =
    {
        0x0000A2FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A2FF,
        0x0000A2FF,
        0x0000A2FF
    };

    static _CharacterInfo _character0000A300 =
    {
        0x0000A300,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A300,
        0x0000A300,
        0x0000A300
    };

    static _CharacterInfo _character0000A301 =
    {
        0x0000A301,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A301,
        0x0000A301,
        0x0000A301
    };

    static _CharacterInfo _character0000A302 =
    {
        0x0000A302,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A302,
        0x0000A302,
        0x0000A302
    };

    static _CharacterInfo _character0000A303 =
    {
        0x0000A303,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A303,
        0x0000A303,
        0x0000A303
    };

    static _CharacterInfo _character0000A304 =
    {
        0x0000A304,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A304,
        0x0000A304,
        0x0000A304
    };

    static _CharacterInfo _character0000A305 =
    {
        0x0000A305,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A305,
        0x0000A305,
        0x0000A305
    };

    static _CharacterInfo _character0000A306 =
    {
        0x0000A306,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A306,
        0x0000A306,
        0x0000A306
    };

    static _CharacterInfo _character0000A307 =
    {
        0x0000A307,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A307,
        0x0000A307,
        0x0000A307
    };

    static _CharacterInfo _character0000A308 =
    {
        0x0000A308,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A308,
        0x0000A308,
        0x0000A308
    };

    static _CharacterInfo _character0000A309 =
    {
        0x0000A309,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A309,
        0x0000A309,
        0x0000A309
    };

    static _CharacterInfo _character0000A30A =
    {
        0x0000A30A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30A,
        0x0000A30A,
        0x0000A30A
    };

    static _CharacterInfo _character0000A30B =
    {
        0x0000A30B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30B,
        0x0000A30B,
        0x0000A30B
    };

    static _CharacterInfo _character0000A30C =
    {
        0x0000A30C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30C,
        0x0000A30C,
        0x0000A30C
    };

    static _CharacterInfo _character0000A30D =
    {
        0x0000A30D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30D,
        0x0000A30D,
        0x0000A30D
    };

    static _CharacterInfo _character0000A30E =
    {
        0x0000A30E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30E,
        0x0000A30E,
        0x0000A30E
    };

    static _CharacterInfo _character0000A30F =
    {
        0x0000A30F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A30F,
        0x0000A30F,
        0x0000A30F
    };

    static _CharacterInfo _character0000A310 =
    {
        0x0000A310,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A310,
        0x0000A310,
        0x0000A310
    };

    static _CharacterInfo _character0000A311 =
    {
        0x0000A311,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A311,
        0x0000A311,
        0x0000A311
    };

    static _CharacterInfo _character0000A312 =
    {
        0x0000A312,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A312,
        0x0000A312,
        0x0000A312
    };

    static _CharacterInfo _character0000A313 =
    {
        0x0000A313,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A313,
        0x0000A313,
        0x0000A313
    };

    static _CharacterInfo _character0000A314 =
    {
        0x0000A314,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A314,
        0x0000A314,
        0x0000A314
    };

    static _CharacterInfo _character0000A315 =
    {
        0x0000A315,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A315,
        0x0000A315,
        0x0000A315
    };

    static _CharacterInfo _character0000A316 =
    {
        0x0000A316,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A316,
        0x0000A316,
        0x0000A316
    };

    static _CharacterInfo _character0000A317 =
    {
        0x0000A317,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A317,
        0x0000A317,
        0x0000A317
    };

    static _CharacterInfo _character0000A318 =
    {
        0x0000A318,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A318,
        0x0000A318,
        0x0000A318
    };

    static _CharacterInfo _character0000A319 =
    {
        0x0000A319,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A319,
        0x0000A319,
        0x0000A319
    };

    static _CharacterInfo _character0000A31A =
    {
        0x0000A31A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31A,
        0x0000A31A,
        0x0000A31A
    };

    static _CharacterInfo _character0000A31B =
    {
        0x0000A31B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31B,
        0x0000A31B,
        0x0000A31B
    };

    static _CharacterInfo _character0000A31C =
    {
        0x0000A31C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31C,
        0x0000A31C,
        0x0000A31C
    };

    static _CharacterInfo _character0000A31D =
    {
        0x0000A31D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31D,
        0x0000A31D,
        0x0000A31D
    };

    static _CharacterInfo _character0000A31E =
    {
        0x0000A31E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31E,
        0x0000A31E,
        0x0000A31E
    };

    static _CharacterInfo _character0000A31F =
    {
        0x0000A31F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A31F,
        0x0000A31F,
        0x0000A31F
    };

    static _CharacterInfo _character0000A320 =
    {
        0x0000A320,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A320,
        0x0000A320,
        0x0000A320
    };

    static _CharacterInfo _character0000A321 =
    {
        0x0000A321,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A321,
        0x0000A321,
        0x0000A321
    };

    static _CharacterInfo _character0000A322 =
    {
        0x0000A322,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A322,
        0x0000A322,
        0x0000A322
    };

    static _CharacterInfo _character0000A323 =
    {
        0x0000A323,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A323,
        0x0000A323,
        0x0000A323
    };

    static _CharacterInfo _character0000A324 =
    {
        0x0000A324,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A324,
        0x0000A324,
        0x0000A324
    };

    static _CharacterInfo _character0000A325 =
    {
        0x0000A325,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A325,
        0x0000A325,
        0x0000A325
    };

    static _CharacterInfo _character0000A326 =
    {
        0x0000A326,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A326,
        0x0000A326,
        0x0000A326
    };

    static _CharacterInfo _character0000A327 =
    {
        0x0000A327,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A327,
        0x0000A327,
        0x0000A327
    };

    static _CharacterInfo _character0000A328 =
    {
        0x0000A328,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A328,
        0x0000A328,
        0x0000A328
    };

    static _CharacterInfo _character0000A329 =
    {
        0x0000A329,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A329,
        0x0000A329,
        0x0000A329
    };

    static _CharacterInfo _character0000A32A =
    {
        0x0000A32A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32A,
        0x0000A32A,
        0x0000A32A
    };

    static _CharacterInfo _character0000A32B =
    {
        0x0000A32B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32B,
        0x0000A32B,
        0x0000A32B
    };

    static _CharacterInfo _character0000A32C =
    {
        0x0000A32C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32C,
        0x0000A32C,
        0x0000A32C
    };

    static _CharacterInfo _character0000A32D =
    {
        0x0000A32D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32D,
        0x0000A32D,
        0x0000A32D
    };

    static _CharacterInfo _character0000A32E =
    {
        0x0000A32E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32E,
        0x0000A32E,
        0x0000A32E
    };

    static _CharacterInfo _character0000A32F =
    {
        0x0000A32F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A32F,
        0x0000A32F,
        0x0000A32F
    };

    static _CharacterInfo _character0000A330 =
    {
        0x0000A330,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A330,
        0x0000A330,
        0x0000A330
    };

    static _CharacterInfo _character0000A331 =
    {
        0x0000A331,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A331,
        0x0000A331,
        0x0000A331
    };

    static _CharacterInfo _character0000A332 =
    {
        0x0000A332,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A332,
        0x0000A332,
        0x0000A332
    };

    static _CharacterInfo _character0000A333 =
    {
        0x0000A333,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A333,
        0x0000A333,
        0x0000A333
    };

    static _CharacterInfo _character0000A334 =
    {
        0x0000A334,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A334,
        0x0000A334,
        0x0000A334
    };

    static _CharacterInfo _character0000A335 =
    {
        0x0000A335,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A335,
        0x0000A335,
        0x0000A335
    };

    static _CharacterInfo _character0000A336 =
    {
        0x0000A336,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A336,
        0x0000A336,
        0x0000A336
    };

    static _CharacterInfo _character0000A337 =
    {
        0x0000A337,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A337,
        0x0000A337,
        0x0000A337
    };

    static _CharacterInfo _character0000A338 =
    {
        0x0000A338,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A338,
        0x0000A338,
        0x0000A338
    };

    static _CharacterInfo _character0000A339 =
    {
        0x0000A339,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A339,
        0x0000A339,
        0x0000A339
    };

    static _CharacterInfo _character0000A33A =
    {
        0x0000A33A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33A,
        0x0000A33A,
        0x0000A33A
    };

    static _CharacterInfo _character0000A33B =
    {
        0x0000A33B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33B,
        0x0000A33B,
        0x0000A33B
    };

    static _CharacterInfo _character0000A33C =
    {
        0x0000A33C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33C,
        0x0000A33C,
        0x0000A33C
    };

    static _CharacterInfo _character0000A33D =
    {
        0x0000A33D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33D,
        0x0000A33D,
        0x0000A33D
    };

    static _CharacterInfo _character0000A33E =
    {
        0x0000A33E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33E,
        0x0000A33E,
        0x0000A33E
    };

    static _CharacterInfo _character0000A33F =
    {
        0x0000A33F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A33F,
        0x0000A33F,
        0x0000A33F
    };

    static _CharacterInfo _character0000A340 =
    {
        0x0000A340,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A340,
        0x0000A340,
        0x0000A340
    };

    static _CharacterInfo _character0000A341 =
    {
        0x0000A341,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A341,
        0x0000A341,
        0x0000A341
    };

    static _CharacterInfo _character0000A342 =
    {
        0x0000A342,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A342,
        0x0000A342,
        0x0000A342
    };

    static _CharacterInfo _character0000A343 =
    {
        0x0000A343,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A343,
        0x0000A343,
        0x0000A343
    };

    static _CharacterInfo _character0000A344 =
    {
        0x0000A344,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A344,
        0x0000A344,
        0x0000A344
    };

    static _CharacterInfo _character0000A345 =
    {
        0x0000A345,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A345,
        0x0000A345,
        0x0000A345
    };

    static _CharacterInfo _character0000A346 =
    {
        0x0000A346,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A346,
        0x0000A346,
        0x0000A346
    };

    static _CharacterInfo _character0000A347 =
    {
        0x0000A347,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A347,
        0x0000A347,
        0x0000A347
    };

    static _CharacterInfo _character0000A348 =
    {
        0x0000A348,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A348,
        0x0000A348,
        0x0000A348
    };

    static _CharacterInfo _character0000A349 =
    {
        0x0000A349,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A349,
        0x0000A349,
        0x0000A349
    };

    static _CharacterInfo _character0000A34A =
    {
        0x0000A34A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34A,
        0x0000A34A,
        0x0000A34A
    };

    static _CharacterInfo _character0000A34B =
    {
        0x0000A34B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34B,
        0x0000A34B,
        0x0000A34B
    };

    static _CharacterInfo _character0000A34C =
    {
        0x0000A34C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34C,
        0x0000A34C,
        0x0000A34C
    };

    static _CharacterInfo _character0000A34D =
    {
        0x0000A34D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34D,
        0x0000A34D,
        0x0000A34D
    };

    static _CharacterInfo _character0000A34E =
    {
        0x0000A34E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34E,
        0x0000A34E,
        0x0000A34E
    };

    static _CharacterInfo _character0000A34F =
    {
        0x0000A34F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A34F,
        0x0000A34F,
        0x0000A34F
    };

    static _CharacterInfo _character0000A350 =
    {
        0x0000A350,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A350,
        0x0000A350,
        0x0000A350
    };

    static _CharacterInfo _character0000A351 =
    {
        0x0000A351,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A351,
        0x0000A351,
        0x0000A351
    };

    static _CharacterInfo _character0000A352 =
    {
        0x0000A352,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A352,
        0x0000A352,
        0x0000A352
    };

    static _CharacterInfo _character0000A353 =
    {
        0x0000A353,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A353,
        0x0000A353,
        0x0000A353
    };

    static _CharacterInfo _character0000A354 =
    {
        0x0000A354,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A354,
        0x0000A354,
        0x0000A354
    };

    static _CharacterInfo _character0000A355 =
    {
        0x0000A355,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A355,
        0x0000A355,
        0x0000A355
    };

    static _CharacterInfo _character0000A356 =
    {
        0x0000A356,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A356,
        0x0000A356,
        0x0000A356
    };

    static _CharacterInfo _character0000A357 =
    {
        0x0000A357,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A357,
        0x0000A357,
        0x0000A357
    };

    static _CharacterInfo _character0000A358 =
    {
        0x0000A358,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A358,
        0x0000A358,
        0x0000A358
    };

    static _CharacterInfo _character0000A359 =
    {
        0x0000A359,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A359,
        0x0000A359,
        0x0000A359
    };

    static _CharacterInfo _character0000A35A =
    {
        0x0000A35A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35A,
        0x0000A35A,
        0x0000A35A
    };

    static _CharacterInfo _character0000A35B =
    {
        0x0000A35B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35B,
        0x0000A35B,
        0x0000A35B
    };

    static _CharacterInfo _character0000A35C =
    {
        0x0000A35C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35C,
        0x0000A35C,
        0x0000A35C
    };

    static _CharacterInfo _character0000A35D =
    {
        0x0000A35D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35D,
        0x0000A35D,
        0x0000A35D
    };

    static _CharacterInfo _character0000A35E =
    {
        0x0000A35E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35E,
        0x0000A35E,
        0x0000A35E
    };

    static _CharacterInfo _character0000A35F =
    {
        0x0000A35F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A35F,
        0x0000A35F,
        0x0000A35F
    };

    static _CharacterInfo _character0000A360 =
    {
        0x0000A360,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A360,
        0x0000A360,
        0x0000A360
    };

    static _CharacterInfo _character0000A361 =
    {
        0x0000A361,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A361,
        0x0000A361,
        0x0000A361
    };

    static _CharacterInfo _character0000A362 =
    {
        0x0000A362,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A362,
        0x0000A362,
        0x0000A362
    };

    static _CharacterInfo _character0000A363 =
    {
        0x0000A363,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A363,
        0x0000A363,
        0x0000A363
    };

    static _CharacterInfo _character0000A364 =
    {
        0x0000A364,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A364,
        0x0000A364,
        0x0000A364
    };

    static _CharacterInfo _character0000A365 =
    {
        0x0000A365,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A365,
        0x0000A365,
        0x0000A365
    };

    static _CharacterInfo _character0000A366 =
    {
        0x0000A366,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A366,
        0x0000A366,
        0x0000A366
    };

    static _CharacterInfo _character0000A367 =
    {
        0x0000A367,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A367,
        0x0000A367,
        0x0000A367
    };

    static _CharacterInfo _character0000A368 =
    {
        0x0000A368,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A368,
        0x0000A368,
        0x0000A368
    };

    static _CharacterInfo _character0000A369 =
    {
        0x0000A369,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A369,
        0x0000A369,
        0x0000A369
    };

    static _CharacterInfo _character0000A36A =
    {
        0x0000A36A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36A,
        0x0000A36A,
        0x0000A36A
    };

    static _CharacterInfo _character0000A36B =
    {
        0x0000A36B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36B,
        0x0000A36B,
        0x0000A36B
    };

    static _CharacterInfo _character0000A36C =
    {
        0x0000A36C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36C,
        0x0000A36C,
        0x0000A36C
    };

    static _CharacterInfo _character0000A36D =
    {
        0x0000A36D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36D,
        0x0000A36D,
        0x0000A36D
    };

    static _CharacterInfo _character0000A36E =
    {
        0x0000A36E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36E,
        0x0000A36E,
        0x0000A36E
    };

    static _CharacterInfo _character0000A36F =
    {
        0x0000A36F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A36F,
        0x0000A36F,
        0x0000A36F
    };

    static _CharacterInfo _character0000A370 =
    {
        0x0000A370,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A370,
        0x0000A370,
        0x0000A370
    };

    static _CharacterInfo _character0000A371 =
    {
        0x0000A371,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A371,
        0x0000A371,
        0x0000A371
    };

    static _CharacterInfo _character0000A372 =
    {
        0x0000A372,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A372,
        0x0000A372,
        0x0000A372
    };

    static _CharacterInfo _character0000A373 =
    {
        0x0000A373,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A373,
        0x0000A373,
        0x0000A373
    };

    static _CharacterInfo _character0000A374 =
    {
        0x0000A374,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A374,
        0x0000A374,
        0x0000A374
    };

    static _CharacterInfo _character0000A375 =
    {
        0x0000A375,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A375,
        0x0000A375,
        0x0000A375
    };

    static _CharacterInfo _character0000A376 =
    {
        0x0000A376,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A376,
        0x0000A376,
        0x0000A376
    };

    static _CharacterInfo _character0000A377 =
    {
        0x0000A377,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A377,
        0x0000A377,
        0x0000A377
    };

    static _CharacterInfo _character0000A378 =
    {
        0x0000A378,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A378,
        0x0000A378,
        0x0000A378
    };

    static _CharacterInfo _character0000A379 =
    {
        0x0000A379,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A379,
        0x0000A379,
        0x0000A379
    };

    static _CharacterInfo _character0000A37A =
    {
        0x0000A37A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37A,
        0x0000A37A,
        0x0000A37A
    };

    static _CharacterInfo _character0000A37B =
    {
        0x0000A37B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37B,
        0x0000A37B,
        0x0000A37B
    };

    static _CharacterInfo _character0000A37C =
    {
        0x0000A37C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37C,
        0x0000A37C,
        0x0000A37C
    };

    static _CharacterInfo _character0000A37D =
    {
        0x0000A37D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37D,
        0x0000A37D,
        0x0000A37D
    };

    static _CharacterInfo _character0000A37E =
    {
        0x0000A37E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37E,
        0x0000A37E,
        0x0000A37E
    };

    static _CharacterInfo _character0000A37F =
    {
        0x0000A37F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A37F,
        0x0000A37F,
        0x0000A37F
    };

    static _CharacterInfo _character0000A380 =
    {
        0x0000A380,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A380,
        0x0000A380,
        0x0000A380
    };

    static _CharacterInfo _character0000A381 =
    {
        0x0000A381,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A381,
        0x0000A381,
        0x0000A381
    };

    static _CharacterInfo _character0000A382 =
    {
        0x0000A382,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A382,
        0x0000A382,
        0x0000A382
    };

    static _CharacterInfo _character0000A383 =
    {
        0x0000A383,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A383,
        0x0000A383,
        0x0000A383
    };

    static _CharacterInfo _character0000A384 =
    {
        0x0000A384,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A384,
        0x0000A384,
        0x0000A384
    };

    static _CharacterInfo _character0000A385 =
    {
        0x0000A385,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A385,
        0x0000A385,
        0x0000A385
    };

    static _CharacterInfo _character0000A386 =
    {
        0x0000A386,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A386,
        0x0000A386,
        0x0000A386
    };

    static _CharacterInfo _character0000A387 =
    {
        0x0000A387,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A387,
        0x0000A387,
        0x0000A387
    };

    static _CharacterInfo _character0000A388 =
    {
        0x0000A388,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A388,
        0x0000A388,
        0x0000A388
    };

    static _CharacterInfo _character0000A389 =
    {
        0x0000A389,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A389,
        0x0000A389,
        0x0000A389
    };

    static _CharacterInfo _character0000A38A =
    {
        0x0000A38A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38A,
        0x0000A38A,
        0x0000A38A
    };

    static _CharacterInfo _character0000A38B =
    {
        0x0000A38B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38B,
        0x0000A38B,
        0x0000A38B
    };

    static _CharacterInfo _character0000A38C =
    {
        0x0000A38C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38C,
        0x0000A38C,
        0x0000A38C
    };

    static _CharacterInfo _character0000A38D =
    {
        0x0000A38D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38D,
        0x0000A38D,
        0x0000A38D
    };

    static _CharacterInfo _character0000A38E =
    {
        0x0000A38E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38E,
        0x0000A38E,
        0x0000A38E
    };

    static _CharacterInfo _character0000A38F =
    {
        0x0000A38F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A38F,
        0x0000A38F,
        0x0000A38F
    };

    static _CharacterInfo _character0000A390 =
    {
        0x0000A390,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A390,
        0x0000A390,
        0x0000A390
    };

    static _CharacterInfo _character0000A391 =
    {
        0x0000A391,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A391,
        0x0000A391,
        0x0000A391
    };

    static _CharacterInfo _character0000A392 =
    {
        0x0000A392,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A392,
        0x0000A392,
        0x0000A392
    };

    static _CharacterInfo _character0000A393 =
    {
        0x0000A393,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A393,
        0x0000A393,
        0x0000A393
    };

    static _CharacterInfo _character0000A394 =
    {
        0x0000A394,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A394,
        0x0000A394,
        0x0000A394
    };

    static _CharacterInfo _character0000A395 =
    {
        0x0000A395,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A395,
        0x0000A395,
        0x0000A395
    };

    static _CharacterInfo _character0000A396 =
    {
        0x0000A396,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A396,
        0x0000A396,
        0x0000A396
    };

    static _CharacterInfo _character0000A397 =
    {
        0x0000A397,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A397,
        0x0000A397,
        0x0000A397
    };

    static _CharacterInfo _character0000A398 =
    {
        0x0000A398,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A398,
        0x0000A398,
        0x0000A398
    };

    static _CharacterInfo _character0000A399 =
    {
        0x0000A399,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A399,
        0x0000A399,
        0x0000A399
    };

    static _CharacterInfo _character0000A39A =
    {
        0x0000A39A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39A,
        0x0000A39A,
        0x0000A39A
    };

    static _CharacterInfo _character0000A39B =
    {
        0x0000A39B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39B,
        0x0000A39B,
        0x0000A39B
    };

    static _CharacterInfo _character0000A39C =
    {
        0x0000A39C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39C,
        0x0000A39C,
        0x0000A39C
    };

    static _CharacterInfo _character0000A39D =
    {
        0x0000A39D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39D,
        0x0000A39D,
        0x0000A39D
    };

    static _CharacterInfo _character0000A39E =
    {
        0x0000A39E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39E,
        0x0000A39E,
        0x0000A39E
    };

    static _CharacterInfo _character0000A39F =
    {
        0x0000A39F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A39F,
        0x0000A39F,
        0x0000A39F
    };

    static _CharacterInfo _character0000A3A0 =
    {
        0x0000A3A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A0,
        0x0000A3A0,
        0x0000A3A0
    };

    static _CharacterInfo _character0000A3A1 =
    {
        0x0000A3A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A1,
        0x0000A3A1,
        0x0000A3A1
    };

    static _CharacterInfo _character0000A3A2 =
    {
        0x0000A3A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A2,
        0x0000A3A2,
        0x0000A3A2
    };

    static _CharacterInfo _character0000A3A3 =
    {
        0x0000A3A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A3,
        0x0000A3A3,
        0x0000A3A3
    };

    static _CharacterInfo _character0000A3A4 =
    {
        0x0000A3A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A4,
        0x0000A3A4,
        0x0000A3A4
    };

    static _CharacterInfo _character0000A3A5 =
    {
        0x0000A3A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A5,
        0x0000A3A5,
        0x0000A3A5
    };

    static _CharacterInfo _character0000A3A6 =
    {
        0x0000A3A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A6,
        0x0000A3A6,
        0x0000A3A6
    };

    static _CharacterInfo _character0000A3A7 =
    {
        0x0000A3A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A7,
        0x0000A3A7,
        0x0000A3A7
    };

    static _CharacterInfo _character0000A3A8 =
    {
        0x0000A3A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A8,
        0x0000A3A8,
        0x0000A3A8
    };

    static _CharacterInfo _character0000A3A9 =
    {
        0x0000A3A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3A9,
        0x0000A3A9,
        0x0000A3A9
    };

    static _CharacterInfo _character0000A3AA =
    {
        0x0000A3AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AA,
        0x0000A3AA,
        0x0000A3AA
    };

    static _CharacterInfo _character0000A3AB =
    {
        0x0000A3AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AB,
        0x0000A3AB,
        0x0000A3AB
    };

    static _CharacterInfo _character0000A3AC =
    {
        0x0000A3AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AC,
        0x0000A3AC,
        0x0000A3AC
    };

    static _CharacterInfo _character0000A3AD =
    {
        0x0000A3AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AD,
        0x0000A3AD,
        0x0000A3AD
    };

    static _CharacterInfo _character0000A3AE =
    {
        0x0000A3AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AE,
        0x0000A3AE,
        0x0000A3AE
    };

    static _CharacterInfo _character0000A3AF =
    {
        0x0000A3AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3AF,
        0x0000A3AF,
        0x0000A3AF
    };

    static _CharacterInfo _character0000A3B0 =
    {
        0x0000A3B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B0,
        0x0000A3B0,
        0x0000A3B0
    };

    static _CharacterInfo _character0000A3B1 =
    {
        0x0000A3B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B1,
        0x0000A3B1,
        0x0000A3B1
    };

    static _CharacterInfo _character0000A3B2 =
    {
        0x0000A3B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B2,
        0x0000A3B2,
        0x0000A3B2
    };

    static _CharacterInfo _character0000A3B3 =
    {
        0x0000A3B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B3,
        0x0000A3B3,
        0x0000A3B3
    };

    static _CharacterInfo _character0000A3B4 =
    {
        0x0000A3B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B4,
        0x0000A3B4,
        0x0000A3B4
    };

    static _CharacterInfo _character0000A3B5 =
    {
        0x0000A3B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B5,
        0x0000A3B5,
        0x0000A3B5
    };

    static _CharacterInfo _character0000A3B6 =
    {
        0x0000A3B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B6,
        0x0000A3B6,
        0x0000A3B6
    };

    static _CharacterInfo _character0000A3B7 =
    {
        0x0000A3B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B7,
        0x0000A3B7,
        0x0000A3B7
    };

    static _CharacterInfo _character0000A3B8 =
    {
        0x0000A3B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B8,
        0x0000A3B8,
        0x0000A3B8
    };

    static _CharacterInfo _character0000A3B9 =
    {
        0x0000A3B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3B9,
        0x0000A3B9,
        0x0000A3B9
    };

    static _CharacterInfo _character0000A3BA =
    {
        0x0000A3BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BA,
        0x0000A3BA,
        0x0000A3BA
    };

    static _CharacterInfo _character0000A3BB =
    {
        0x0000A3BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BB,
        0x0000A3BB,
        0x0000A3BB
    };

    static _CharacterInfo _character0000A3BC =
    {
        0x0000A3BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BC,
        0x0000A3BC,
        0x0000A3BC
    };

    static _CharacterInfo _character0000A3BD =
    {
        0x0000A3BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BD,
        0x0000A3BD,
        0x0000A3BD
    };

    static _CharacterInfo _character0000A3BE =
    {
        0x0000A3BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BE,
        0x0000A3BE,
        0x0000A3BE
    };

    static _CharacterInfo _character0000A3BF =
    {
        0x0000A3BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3BF,
        0x0000A3BF,
        0x0000A3BF
    };

    static _CharacterInfo _character0000A3C0 =
    {
        0x0000A3C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C0,
        0x0000A3C0,
        0x0000A3C0
    };

    static _CharacterInfo _character0000A3C1 =
    {
        0x0000A3C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C1,
        0x0000A3C1,
        0x0000A3C1
    };

    static _CharacterInfo _character0000A3C2 =
    {
        0x0000A3C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C2,
        0x0000A3C2,
        0x0000A3C2
    };

    static _CharacterInfo _character0000A3C3 =
    {
        0x0000A3C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C3,
        0x0000A3C3,
        0x0000A3C3
    };

    static _CharacterInfo _character0000A3C4 =
    {
        0x0000A3C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C4,
        0x0000A3C4,
        0x0000A3C4
    };

    static _CharacterInfo _character0000A3C5 =
    {
        0x0000A3C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C5,
        0x0000A3C5,
        0x0000A3C5
    };

    static _CharacterInfo _character0000A3C6 =
    {
        0x0000A3C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C6,
        0x0000A3C6,
        0x0000A3C6
    };

    static _CharacterInfo _character0000A3C7 =
    {
        0x0000A3C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C7,
        0x0000A3C7,
        0x0000A3C7
    };

    static _CharacterInfo _character0000A3C8 =
    {
        0x0000A3C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C8,
        0x0000A3C8,
        0x0000A3C8
    };

    static _CharacterInfo _character0000A3C9 =
    {
        0x0000A3C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3C9,
        0x0000A3C9,
        0x0000A3C9
    };

    static _CharacterInfo _character0000A3CA =
    {
        0x0000A3CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CA,
        0x0000A3CA,
        0x0000A3CA
    };

    static _CharacterInfo _character0000A3CB =
    {
        0x0000A3CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CB,
        0x0000A3CB,
        0x0000A3CB
    };

    static _CharacterInfo _character0000A3CC =
    {
        0x0000A3CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CC,
        0x0000A3CC,
        0x0000A3CC
    };

    static _CharacterInfo _character0000A3CD =
    {
        0x0000A3CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CD,
        0x0000A3CD,
        0x0000A3CD
    };

    static _CharacterInfo _character0000A3CE =
    {
        0x0000A3CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CE,
        0x0000A3CE,
        0x0000A3CE
    };

    static _CharacterInfo _character0000A3CF =
    {
        0x0000A3CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3CF,
        0x0000A3CF,
        0x0000A3CF
    };

    static _CharacterInfo _character0000A3D0 =
    {
        0x0000A3D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D0,
        0x0000A3D0,
        0x0000A3D0
    };

    static _CharacterInfo _character0000A3D1 =
    {
        0x0000A3D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D1,
        0x0000A3D1,
        0x0000A3D1
    };

    static _CharacterInfo _character0000A3D2 =
    {
        0x0000A3D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D2,
        0x0000A3D2,
        0x0000A3D2
    };

    static _CharacterInfo _character0000A3D3 =
    {
        0x0000A3D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D3,
        0x0000A3D3,
        0x0000A3D3
    };

    static _CharacterInfo _character0000A3D4 =
    {
        0x0000A3D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D4,
        0x0000A3D4,
        0x0000A3D4
    };

    static _CharacterInfo _character0000A3D5 =
    {
        0x0000A3D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D5,
        0x0000A3D5,
        0x0000A3D5
    };

    static _CharacterInfo _character0000A3D6 =
    {
        0x0000A3D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D6,
        0x0000A3D6,
        0x0000A3D6
    };

    static _CharacterInfo _character0000A3D7 =
    {
        0x0000A3D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D7,
        0x0000A3D7,
        0x0000A3D7
    };

    static _CharacterInfo _character0000A3D8 =
    {
        0x0000A3D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D8,
        0x0000A3D8,
        0x0000A3D8
    };

    static _CharacterInfo _character0000A3D9 =
    {
        0x0000A3D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3D9,
        0x0000A3D9,
        0x0000A3D9
    };

    static _CharacterInfo _character0000A3DA =
    {
        0x0000A3DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DA,
        0x0000A3DA,
        0x0000A3DA
    };

    static _CharacterInfo _character0000A3DB =
    {
        0x0000A3DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DB,
        0x0000A3DB,
        0x0000A3DB
    };

    static _CharacterInfo _character0000A3DC =
    {
        0x0000A3DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DC,
        0x0000A3DC,
        0x0000A3DC
    };

    static _CharacterInfo _character0000A3DD =
    {
        0x0000A3DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DD,
        0x0000A3DD,
        0x0000A3DD
    };

    static _CharacterInfo _character0000A3DE =
    {
        0x0000A3DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DE,
        0x0000A3DE,
        0x0000A3DE
    };

    static _CharacterInfo _character0000A3DF =
    {
        0x0000A3DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3DF,
        0x0000A3DF,
        0x0000A3DF
    };

    static _CharacterInfo _character0000A3E0 =
    {
        0x0000A3E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E0,
        0x0000A3E0,
        0x0000A3E0
    };

    static _CharacterInfo _character0000A3E1 =
    {
        0x0000A3E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E1,
        0x0000A3E1,
        0x0000A3E1
    };

    static _CharacterInfo _character0000A3E2 =
    {
        0x0000A3E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E2,
        0x0000A3E2,
        0x0000A3E2
    };

    static _CharacterInfo _character0000A3E3 =
    {
        0x0000A3E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E3,
        0x0000A3E3,
        0x0000A3E3
    };

    static _CharacterInfo _character0000A3E4 =
    {
        0x0000A3E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E4,
        0x0000A3E4,
        0x0000A3E4
    };

    static _CharacterInfo _character0000A3E5 =
    {
        0x0000A3E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E5,
        0x0000A3E5,
        0x0000A3E5
    };

    static _CharacterInfo _character0000A3E6 =
    {
        0x0000A3E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E6,
        0x0000A3E6,
        0x0000A3E6
    };

    static _CharacterInfo _character0000A3E7 =
    {
        0x0000A3E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E7,
        0x0000A3E7,
        0x0000A3E7
    };

    static _CharacterInfo _character0000A3E8 =
    {
        0x0000A3E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E8,
        0x0000A3E8,
        0x0000A3E8
    };

    static _CharacterInfo _character0000A3E9 =
    {
        0x0000A3E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3E9,
        0x0000A3E9,
        0x0000A3E9
    };

    static _CharacterInfo _character0000A3EA =
    {
        0x0000A3EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3EA,
        0x0000A3EA,
        0x0000A3EA
    };

    static _CharacterInfo _character0000A3EB =
    {
        0x0000A3EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3EB,
        0x0000A3EB,
        0x0000A3EB
    };

    static _CharacterInfo _character0000A3EC =
    {
        0x0000A3EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3EC,
        0x0000A3EC,
        0x0000A3EC
    };

    static _CharacterInfo _character0000A3ED =
    {
        0x0000A3ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3ED,
        0x0000A3ED,
        0x0000A3ED
    };

    static _CharacterInfo _character0000A3EE =
    {
        0x0000A3EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3EE,
        0x0000A3EE,
        0x0000A3EE
    };

    static _CharacterInfo _character0000A3EF =
    {
        0x0000A3EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3EF,
        0x0000A3EF,
        0x0000A3EF
    };

    static _CharacterInfo _character0000A3F0 =
    {
        0x0000A3F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F0,
        0x0000A3F0,
        0x0000A3F0
    };

    static _CharacterInfo _character0000A3F1 =
    {
        0x0000A3F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F1,
        0x0000A3F1,
        0x0000A3F1
    };

    static _CharacterInfo _character0000A3F2 =
    {
        0x0000A3F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F2,
        0x0000A3F2,
        0x0000A3F2
    };

    static _CharacterInfo _character0000A3F3 =
    {
        0x0000A3F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F3,
        0x0000A3F3,
        0x0000A3F3
    };

    static _CharacterInfo _character0000A3F4 =
    {
        0x0000A3F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F4,
        0x0000A3F4,
        0x0000A3F4
    };

    static _CharacterInfo _character0000A3F5 =
    {
        0x0000A3F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F5,
        0x0000A3F5,
        0x0000A3F5
    };

    static _CharacterInfo _character0000A3F6 =
    {
        0x0000A3F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F6,
        0x0000A3F6,
        0x0000A3F6
    };

    static _CharacterInfo _character0000A3F7 =
    {
        0x0000A3F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F7,
        0x0000A3F7,
        0x0000A3F7
    };

    static _CharacterInfo _character0000A3F8 =
    {
        0x0000A3F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F8,
        0x0000A3F8,
        0x0000A3F8
    };

    static _CharacterInfo _character0000A3F9 =
    {
        0x0000A3F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3F9,
        0x0000A3F9,
        0x0000A3F9
    };

    static _CharacterInfo _character0000A3FA =
    {
        0x0000A3FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FA,
        0x0000A3FA,
        0x0000A3FA
    };

    static _CharacterInfo _character0000A3FB =
    {
        0x0000A3FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FB,
        0x0000A3FB,
        0x0000A3FB
    };

    static _CharacterInfo _character0000A3FC =
    {
        0x0000A3FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FC,
        0x0000A3FC,
        0x0000A3FC
    };

    static _CharacterInfo _character0000A3FD =
    {
        0x0000A3FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FD,
        0x0000A3FD,
        0x0000A3FD
    };

    static _CharacterInfo _character0000A3FE =
    {
        0x0000A3FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FE,
        0x0000A3FE,
        0x0000A3FE
    };

    static _CharacterInfo _character0000A3FF =
    {
        0x0000A3FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A3FF,
        0x0000A3FF,
        0x0000A3FF
    };

    static _CharacterInfo _character0000A400 =
    {
        0x0000A400,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A400,
        0x0000A400,
        0x0000A400
    };

    static _CharacterInfo _character0000A401 =
    {
        0x0000A401,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A401,
        0x0000A401,
        0x0000A401
    };

    static _CharacterInfo _character0000A402 =
    {
        0x0000A402,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A402,
        0x0000A402,
        0x0000A402
    };

    static _CharacterInfo _character0000A403 =
    {
        0x0000A403,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A403,
        0x0000A403,
        0x0000A403
    };

    static _CharacterInfo _character0000A404 =
    {
        0x0000A404,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A404,
        0x0000A404,
        0x0000A404
    };

    static _CharacterInfo _character0000A405 =
    {
        0x0000A405,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A405,
        0x0000A405,
        0x0000A405
    };

    static _CharacterInfo _character0000A406 =
    {
        0x0000A406,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A406,
        0x0000A406,
        0x0000A406
    };

    static _CharacterInfo _character0000A407 =
    {
        0x0000A407,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A407,
        0x0000A407,
        0x0000A407
    };

    static _CharacterInfo _character0000A408 =
    {
        0x0000A408,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A408,
        0x0000A408,
        0x0000A408
    };

    static _CharacterInfo _character0000A409 =
    {
        0x0000A409,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A409,
        0x0000A409,
        0x0000A409
    };

    static _CharacterInfo _character0000A40A =
    {
        0x0000A40A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40A,
        0x0000A40A,
        0x0000A40A
    };

    static _CharacterInfo _character0000A40B =
    {
        0x0000A40B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40B,
        0x0000A40B,
        0x0000A40B
    };

    static _CharacterInfo _character0000A40C =
    {
        0x0000A40C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40C,
        0x0000A40C,
        0x0000A40C
    };

    static _CharacterInfo _character0000A40D =
    {
        0x0000A40D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40D,
        0x0000A40D,
        0x0000A40D
    };

    static _CharacterInfo _character0000A40E =
    {
        0x0000A40E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40E,
        0x0000A40E,
        0x0000A40E
    };

    static _CharacterInfo _character0000A40F =
    {
        0x0000A40F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A40F,
        0x0000A40F,
        0x0000A40F
    };

    static _CharacterInfo _character0000A410 =
    {
        0x0000A410,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A410,
        0x0000A410,
        0x0000A410
    };

    static _CharacterInfo _character0000A411 =
    {
        0x0000A411,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A411,
        0x0000A411,
        0x0000A411
    };

    static _CharacterInfo _character0000A412 =
    {
        0x0000A412,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A412,
        0x0000A412,
        0x0000A412
    };

    static _CharacterInfo _character0000A413 =
    {
        0x0000A413,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A413,
        0x0000A413,
        0x0000A413
    };

    static _CharacterInfo _character0000A414 =
    {
        0x0000A414,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A414,
        0x0000A414,
        0x0000A414
    };

    static _CharacterInfo _character0000A415 =
    {
        0x0000A415,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A415,
        0x0000A415,
        0x0000A415
    };

    static _CharacterInfo _character0000A416 =
    {
        0x0000A416,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A416,
        0x0000A416,
        0x0000A416
    };

    static _CharacterInfo _character0000A417 =
    {
        0x0000A417,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A417,
        0x0000A417,
        0x0000A417
    };

    static _CharacterInfo _character0000A418 =
    {
        0x0000A418,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A418,
        0x0000A418,
        0x0000A418
    };

    static _CharacterInfo _character0000A419 =
    {
        0x0000A419,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A419,
        0x0000A419,
        0x0000A419
    };

    static _CharacterInfo _character0000A41A =
    {
        0x0000A41A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41A,
        0x0000A41A,
        0x0000A41A
    };

    static _CharacterInfo _character0000A41B =
    {
        0x0000A41B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41B,
        0x0000A41B,
        0x0000A41B
    };

    static _CharacterInfo _character0000A41C =
    {
        0x0000A41C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41C,
        0x0000A41C,
        0x0000A41C
    };

    static _CharacterInfo _character0000A41D =
    {
        0x0000A41D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41D,
        0x0000A41D,
        0x0000A41D
    };

    static _CharacterInfo _character0000A41E =
    {
        0x0000A41E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41E,
        0x0000A41E,
        0x0000A41E
    };

    static _CharacterInfo _character0000A41F =
    {
        0x0000A41F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A41F,
        0x0000A41F,
        0x0000A41F
    };

    static _CharacterInfo _character0000A420 =
    {
        0x0000A420,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A420,
        0x0000A420,
        0x0000A420
    };

    static _CharacterInfo _character0000A421 =
    {
        0x0000A421,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A421,
        0x0000A421,
        0x0000A421
    };

    static _CharacterInfo _character0000A422 =
    {
        0x0000A422,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A422,
        0x0000A422,
        0x0000A422
    };

    static _CharacterInfo _character0000A423 =
    {
        0x0000A423,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A423,
        0x0000A423,
        0x0000A423
    };

    static _CharacterInfo _character0000A424 =
    {
        0x0000A424,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A424,
        0x0000A424,
        0x0000A424
    };

    static _CharacterInfo _character0000A425 =
    {
        0x0000A425,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A425,
        0x0000A425,
        0x0000A425
    };

    static _CharacterInfo _character0000A426 =
    {
        0x0000A426,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A426,
        0x0000A426,
        0x0000A426
    };

    static _CharacterInfo _character0000A427 =
    {
        0x0000A427,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A427,
        0x0000A427,
        0x0000A427
    };

    static _CharacterInfo _character0000A428 =
    {
        0x0000A428,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A428,
        0x0000A428,
        0x0000A428
    };

    static _CharacterInfo _character0000A429 =
    {
        0x0000A429,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A429,
        0x0000A429,
        0x0000A429
    };

    static _CharacterInfo _character0000A42A =
    {
        0x0000A42A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42A,
        0x0000A42A,
        0x0000A42A
    };

    static _CharacterInfo _character0000A42B =
    {
        0x0000A42B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42B,
        0x0000A42B,
        0x0000A42B
    };

    static _CharacterInfo _character0000A42C =
    {
        0x0000A42C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42C,
        0x0000A42C,
        0x0000A42C
    };

    static _CharacterInfo _character0000A42D =
    {
        0x0000A42D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42D,
        0x0000A42D,
        0x0000A42D
    };

    static _CharacterInfo _character0000A42E =
    {
        0x0000A42E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42E,
        0x0000A42E,
        0x0000A42E
    };

    static _CharacterInfo _character0000A42F =
    {
        0x0000A42F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A42F,
        0x0000A42F,
        0x0000A42F
    };

    static _CharacterInfo _character0000A430 =
    {
        0x0000A430,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A430,
        0x0000A430,
        0x0000A430
    };

    static _CharacterInfo _character0000A431 =
    {
        0x0000A431,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A431,
        0x0000A431,
        0x0000A431
    };

    static _CharacterInfo _character0000A432 =
    {
        0x0000A432,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A432,
        0x0000A432,
        0x0000A432
    };

    static _CharacterInfo _character0000A433 =
    {
        0x0000A433,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A433,
        0x0000A433,
        0x0000A433
    };

    static _CharacterInfo _character0000A434 =
    {
        0x0000A434,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A434,
        0x0000A434,
        0x0000A434
    };

    static _CharacterInfo _character0000A435 =
    {
        0x0000A435,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A435,
        0x0000A435,
        0x0000A435
    };

    static _CharacterInfo _character0000A436 =
    {
        0x0000A436,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A436,
        0x0000A436,
        0x0000A436
    };

    static _CharacterInfo _character0000A437 =
    {
        0x0000A437,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A437,
        0x0000A437,
        0x0000A437
    };

    static _CharacterInfo _character0000A438 =
    {
        0x0000A438,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A438,
        0x0000A438,
        0x0000A438
    };

    static _CharacterInfo _character0000A439 =
    {
        0x0000A439,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A439,
        0x0000A439,
        0x0000A439
    };

    static _CharacterInfo _character0000A43A =
    {
        0x0000A43A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43A,
        0x0000A43A,
        0x0000A43A
    };

    static _CharacterInfo _character0000A43B =
    {
        0x0000A43B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43B,
        0x0000A43B,
        0x0000A43B
    };

    static _CharacterInfo _character0000A43C =
    {
        0x0000A43C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43C,
        0x0000A43C,
        0x0000A43C
    };

    static _CharacterInfo _character0000A43D =
    {
        0x0000A43D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43D,
        0x0000A43D,
        0x0000A43D
    };

    static _CharacterInfo _character0000A43E =
    {
        0x0000A43E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43E,
        0x0000A43E,
        0x0000A43E
    };

    static _CharacterInfo _character0000A43F =
    {
        0x0000A43F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A43F,
        0x0000A43F,
        0x0000A43F
    };

    static _CharacterInfo _character0000A440 =
    {
        0x0000A440,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A440,
        0x0000A440,
        0x0000A440
    };

    static _CharacterInfo _character0000A441 =
    {
        0x0000A441,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A441,
        0x0000A441,
        0x0000A441
    };

    static _CharacterInfo _character0000A442 =
    {
        0x0000A442,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A442,
        0x0000A442,
        0x0000A442
    };

    static _CharacterInfo _character0000A443 =
    {
        0x0000A443,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A443,
        0x0000A443,
        0x0000A443
    };

    static _CharacterInfo _character0000A444 =
    {
        0x0000A444,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A444,
        0x0000A444,
        0x0000A444
    };

    static _CharacterInfo _character0000A445 =
    {
        0x0000A445,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A445,
        0x0000A445,
        0x0000A445
    };

    static _CharacterInfo _character0000A446 =
    {
        0x0000A446,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A446,
        0x0000A446,
        0x0000A446
    };

    static _CharacterInfo _character0000A447 =
    {
        0x0000A447,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A447,
        0x0000A447,
        0x0000A447
    };

    static _CharacterInfo _character0000A448 =
    {
        0x0000A448,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A448,
        0x0000A448,
        0x0000A448
    };

    static _CharacterInfo _character0000A449 =
    {
        0x0000A449,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A449,
        0x0000A449,
        0x0000A449
    };

    static _CharacterInfo _character0000A44A =
    {
        0x0000A44A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44A,
        0x0000A44A,
        0x0000A44A
    };

    static _CharacterInfo _character0000A44B =
    {
        0x0000A44B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44B,
        0x0000A44B,
        0x0000A44B
    };

    static _CharacterInfo _character0000A44C =
    {
        0x0000A44C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44C,
        0x0000A44C,
        0x0000A44C
    };

    static _CharacterInfo _character0000A44D =
    {
        0x0000A44D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44D,
        0x0000A44D,
        0x0000A44D
    };

    static _CharacterInfo _character0000A44E =
    {
        0x0000A44E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44E,
        0x0000A44E,
        0x0000A44E
    };

    static _CharacterInfo _character0000A44F =
    {
        0x0000A44F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A44F,
        0x0000A44F,
        0x0000A44F
    };

    static _CharacterInfo _character0000A450 =
    {
        0x0000A450,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A450,
        0x0000A450,
        0x0000A450
    };

    static _CharacterInfo _character0000A451 =
    {
        0x0000A451,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A451,
        0x0000A451,
        0x0000A451
    };

    static _CharacterInfo _character0000A452 =
    {
        0x0000A452,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A452,
        0x0000A452,
        0x0000A452
    };

    static _CharacterInfo _character0000A453 =
    {
        0x0000A453,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A453,
        0x0000A453,
        0x0000A453
    };

    static _CharacterInfo _character0000A454 =
    {
        0x0000A454,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A454,
        0x0000A454,
        0x0000A454
    };

    static _CharacterInfo _character0000A455 =
    {
        0x0000A455,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A455,
        0x0000A455,
        0x0000A455
    };

    static _CharacterInfo _character0000A456 =
    {
        0x0000A456,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A456,
        0x0000A456,
        0x0000A456
    };

    static _CharacterInfo _character0000A457 =
    {
        0x0000A457,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A457,
        0x0000A457,
        0x0000A457
    };

    static _CharacterInfo _character0000A458 =
    {
        0x0000A458,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A458,
        0x0000A458,
        0x0000A458
    };

    static _CharacterInfo _character0000A459 =
    {
        0x0000A459,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A459,
        0x0000A459,
        0x0000A459
    };

    static _CharacterInfo _character0000A45A =
    {
        0x0000A45A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45A,
        0x0000A45A,
        0x0000A45A
    };

    static _CharacterInfo _character0000A45B =
    {
        0x0000A45B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45B,
        0x0000A45B,
        0x0000A45B
    };

    static _CharacterInfo _character0000A45C =
    {
        0x0000A45C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45C,
        0x0000A45C,
        0x0000A45C
    };

    static _CharacterInfo _character0000A45D =
    {
        0x0000A45D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45D,
        0x0000A45D,
        0x0000A45D
    };

    static _CharacterInfo _character0000A45E =
    {
        0x0000A45E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45E,
        0x0000A45E,
        0x0000A45E
    };

    static _CharacterInfo _character0000A45F =
    {
        0x0000A45F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A45F,
        0x0000A45F,
        0x0000A45F
    };

    static _CharacterInfo _character0000A460 =
    {
        0x0000A460,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A460,
        0x0000A460,
        0x0000A460
    };

    static _CharacterInfo _character0000A461 =
    {
        0x0000A461,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A461,
        0x0000A461,
        0x0000A461
    };

    static _CharacterInfo _character0000A462 =
    {
        0x0000A462,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A462,
        0x0000A462,
        0x0000A462
    };

    static _CharacterInfo _character0000A463 =
    {
        0x0000A463,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A463,
        0x0000A463,
        0x0000A463
    };

    static _CharacterInfo _character0000A464 =
    {
        0x0000A464,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A464,
        0x0000A464,
        0x0000A464
    };

    static _CharacterInfo _character0000A465 =
    {
        0x0000A465,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A465,
        0x0000A465,
        0x0000A465
    };

    static _CharacterInfo _character0000A466 =
    {
        0x0000A466,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A466,
        0x0000A466,
        0x0000A466
    };

    static _CharacterInfo _character0000A467 =
    {
        0x0000A467,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A467,
        0x0000A467,
        0x0000A467
    };

    static _CharacterInfo _character0000A468 =
    {
        0x0000A468,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A468,
        0x0000A468,
        0x0000A468
    };

    static _CharacterInfo _character0000A469 =
    {
        0x0000A469,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A469,
        0x0000A469,
        0x0000A469
    };

    static _CharacterInfo _character0000A46A =
    {
        0x0000A46A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46A,
        0x0000A46A,
        0x0000A46A
    };

    static _CharacterInfo _character0000A46B =
    {
        0x0000A46B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46B,
        0x0000A46B,
        0x0000A46B
    };

    static _CharacterInfo _character0000A46C =
    {
        0x0000A46C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46C,
        0x0000A46C,
        0x0000A46C
    };

    static _CharacterInfo _character0000A46D =
    {
        0x0000A46D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46D,
        0x0000A46D,
        0x0000A46D
    };

    static _CharacterInfo _character0000A46E =
    {
        0x0000A46E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46E,
        0x0000A46E,
        0x0000A46E
    };

    static _CharacterInfo _character0000A46F =
    {
        0x0000A46F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A46F,
        0x0000A46F,
        0x0000A46F
    };

    static _CharacterInfo _character0000A470 =
    {
        0x0000A470,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A470,
        0x0000A470,
        0x0000A470
    };

    static _CharacterInfo _character0000A471 =
    {
        0x0000A471,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A471,
        0x0000A471,
        0x0000A471
    };

    static _CharacterInfo _character0000A472 =
    {
        0x0000A472,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A472,
        0x0000A472,
        0x0000A472
    };

    static _CharacterInfo _character0000A473 =
    {
        0x0000A473,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A473,
        0x0000A473,
        0x0000A473
    };

    static _CharacterInfo _character0000A474 =
    {
        0x0000A474,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A474,
        0x0000A474,
        0x0000A474
    };

    static _CharacterInfo _character0000A475 =
    {
        0x0000A475,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A475,
        0x0000A475,
        0x0000A475
    };

    static _CharacterInfo _character0000A476 =
    {
        0x0000A476,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A476,
        0x0000A476,
        0x0000A476
    };

    static _CharacterInfo _character0000A477 =
    {
        0x0000A477,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A477,
        0x0000A477,
        0x0000A477
    };

    static _CharacterInfo _character0000A478 =
    {
        0x0000A478,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A478,
        0x0000A478,
        0x0000A478
    };

    static _CharacterInfo _character0000A479 =
    {
        0x0000A479,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A479,
        0x0000A479,
        0x0000A479
    };

    static _CharacterInfo _character0000A47A =
    {
        0x0000A47A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47A,
        0x0000A47A,
        0x0000A47A
    };

    static _CharacterInfo _character0000A47B =
    {
        0x0000A47B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47B,
        0x0000A47B,
        0x0000A47B
    };

    static _CharacterInfo _character0000A47C =
    {
        0x0000A47C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47C,
        0x0000A47C,
        0x0000A47C
    };

    static _CharacterInfo _character0000A47D =
    {
        0x0000A47D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47D,
        0x0000A47D,
        0x0000A47D
    };

    static _CharacterInfo _character0000A47E =
    {
        0x0000A47E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47E,
        0x0000A47E,
        0x0000A47E
    };

    static _CharacterInfo _character0000A47F =
    {
        0x0000A47F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A47F,
        0x0000A47F,
        0x0000A47F
    };

    static _CharacterInfo _character0000A480 =
    {
        0x0000A480,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A480,
        0x0000A480,
        0x0000A480
    };

    static _CharacterInfo _character0000A481 =
    {
        0x0000A481,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A481,
        0x0000A481,
        0x0000A481
    };

    static _CharacterInfo _character0000A482 =
    {
        0x0000A482,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A482,
        0x0000A482,
        0x0000A482
    };

    static _CharacterInfo _character0000A483 =
    {
        0x0000A483,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A483,
        0x0000A483,
        0x0000A483
    };

    static _CharacterInfo _character0000A484 =
    {
        0x0000A484,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A484,
        0x0000A484,
        0x0000A484
    };

    static _CharacterInfo _character0000A485 =
    {
        0x0000A485,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A485,
        0x0000A485,
        0x0000A485
    };

    static _CharacterInfo _character0000A486 =
    {
        0x0000A486,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A486,
        0x0000A486,
        0x0000A486
    };

    static _CharacterInfo _character0000A487 =
    {
        0x0000A487,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A487,
        0x0000A487,
        0x0000A487
    };

    static _CharacterInfo _character0000A488 =
    {
        0x0000A488,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A488,
        0x0000A488,
        0x0000A488
    };

    static _CharacterInfo _character0000A489 =
    {
        0x0000A489,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A489,
        0x0000A489,
        0x0000A489
    };

    static _CharacterInfo _character0000A48A =
    {
        0x0000A48A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A48A,
        0x0000A48A,
        0x0000A48A
    };

    static _CharacterInfo _character0000A48B =
    {
        0x0000A48B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A48B,
        0x0000A48B,
        0x0000A48B
    };

    static _CharacterInfo _character0000A48C =
    {
        0x0000A48C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A48C,
        0x0000A48C,
        0x0000A48C
    };

    static _CharacterInfo _character0000A490 =
    {
        0x0000A490,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A490,
        0x0000A490,
        0x0000A490
    };

    static _CharacterInfo _character0000A491 =
    {
        0x0000A491,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A491,
        0x0000A491,
        0x0000A491
    };

    static _CharacterInfo _character0000A492 =
    {
        0x0000A492,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A492,
        0x0000A492,
        0x0000A492
    };

    static _CharacterInfo _character0000A493 =
    {
        0x0000A493,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A493,
        0x0000A493,
        0x0000A493
    };

    static _CharacterInfo _character0000A494 =
    {
        0x0000A494,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A494,
        0x0000A494,
        0x0000A494
    };

    static _CharacterInfo _character0000A495 =
    {
        0x0000A495,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A495,
        0x0000A495,
        0x0000A495
    };

    static _CharacterInfo _character0000A496 =
    {
        0x0000A496,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A496,
        0x0000A496,
        0x0000A496
    };

    static _CharacterInfo _character0000A497 =
    {
        0x0000A497,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A497,
        0x0000A497,
        0x0000A497
    };

    static _CharacterInfo _character0000A498 =
    {
        0x0000A498,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A498,
        0x0000A498,
        0x0000A498
    };

    static _CharacterInfo _character0000A499 =
    {
        0x0000A499,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A499,
        0x0000A499,
        0x0000A499
    };

    static _CharacterInfo _character0000A49A =
    {
        0x0000A49A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49A,
        0x0000A49A,
        0x0000A49A
    };

    static _CharacterInfo _character0000A49B =
    {
        0x0000A49B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49B,
        0x0000A49B,
        0x0000A49B
    };

    static _CharacterInfo _character0000A49C =
    {
        0x0000A49C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49C,
        0x0000A49C,
        0x0000A49C
    };

    static _CharacterInfo _character0000A49D =
    {
        0x0000A49D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49D,
        0x0000A49D,
        0x0000A49D
    };

    static _CharacterInfo _character0000A49E =
    {
        0x0000A49E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49E,
        0x0000A49E,
        0x0000A49E
    };

    static _CharacterInfo _character0000A49F =
    {
        0x0000A49F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A49F,
        0x0000A49F,
        0x0000A49F
    };

    static _CharacterInfo _character0000A4A0 =
    {
        0x0000A4A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A0,
        0x0000A4A0,
        0x0000A4A0
    };

    static _CharacterInfo _character0000A4A1 =
    {
        0x0000A4A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A1,
        0x0000A4A1,
        0x0000A4A1
    };

    static _CharacterInfo _character0000A4A2 =
    {
        0x0000A4A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A2,
        0x0000A4A2,
        0x0000A4A2
    };

    static _CharacterInfo _character0000A4A3 =
    {
        0x0000A4A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A3,
        0x0000A4A3,
        0x0000A4A3
    };

    static _CharacterInfo _character0000A4A4 =
    {
        0x0000A4A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A4,
        0x0000A4A4,
        0x0000A4A4
    };

    static _CharacterInfo _character0000A4A5 =
    {
        0x0000A4A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A5,
        0x0000A4A5,
        0x0000A4A5
    };

    static _CharacterInfo _character0000A4A6 =
    {
        0x0000A4A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A6,
        0x0000A4A6,
        0x0000A4A6
    };

    static _CharacterInfo _character0000A4A7 =
    {
        0x0000A4A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A7,
        0x0000A4A7,
        0x0000A4A7
    };

    static _CharacterInfo _character0000A4A8 =
    {
        0x0000A4A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A8,
        0x0000A4A8,
        0x0000A4A8
    };

    static _CharacterInfo _character0000A4A9 =
    {
        0x0000A4A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4A9,
        0x0000A4A9,
        0x0000A4A9
    };

    static _CharacterInfo _character0000A4AA =
    {
        0x0000A4AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AA,
        0x0000A4AA,
        0x0000A4AA
    };

    static _CharacterInfo _character0000A4AB =
    {
        0x0000A4AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AB,
        0x0000A4AB,
        0x0000A4AB
    };

    static _CharacterInfo _character0000A4AC =
    {
        0x0000A4AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AC,
        0x0000A4AC,
        0x0000A4AC
    };

    static _CharacterInfo _character0000A4AD =
    {
        0x0000A4AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AD,
        0x0000A4AD,
        0x0000A4AD
    };

    static _CharacterInfo _character0000A4AE =
    {
        0x0000A4AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AE,
        0x0000A4AE,
        0x0000A4AE
    };

    static _CharacterInfo _character0000A4AF =
    {
        0x0000A4AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4AF,
        0x0000A4AF,
        0x0000A4AF
    };

    static _CharacterInfo _character0000A4B0 =
    {
        0x0000A4B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B0,
        0x0000A4B0,
        0x0000A4B0
    };

    static _CharacterInfo _character0000A4B1 =
    {
        0x0000A4B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B1,
        0x0000A4B1,
        0x0000A4B1
    };

    static _CharacterInfo _character0000A4B2 =
    {
        0x0000A4B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B2,
        0x0000A4B2,
        0x0000A4B2
    };

    static _CharacterInfo _character0000A4B3 =
    {
        0x0000A4B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B3,
        0x0000A4B3,
        0x0000A4B3
    };

    static _CharacterInfo _character0000A4B4 =
    {
        0x0000A4B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B4,
        0x0000A4B4,
        0x0000A4B4
    };

    static _CharacterInfo _character0000A4B5 =
    {
        0x0000A4B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B5,
        0x0000A4B5,
        0x0000A4B5
    };

    static _CharacterInfo _character0000A4B6 =
    {
        0x0000A4B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B6,
        0x0000A4B6,
        0x0000A4B6
    };

    static _CharacterInfo _character0000A4B7 =
    {
        0x0000A4B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B7,
        0x0000A4B7,
        0x0000A4B7
    };

    static _CharacterInfo _character0000A4B8 =
    {
        0x0000A4B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B8,
        0x0000A4B8,
        0x0000A4B8
    };

    static _CharacterInfo _character0000A4B9 =
    {
        0x0000A4B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4B9,
        0x0000A4B9,
        0x0000A4B9
    };

    static _CharacterInfo _character0000A4BA =
    {
        0x0000A4BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BA,
        0x0000A4BA,
        0x0000A4BA
    };

    static _CharacterInfo _character0000A4BB =
    {
        0x0000A4BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BB,
        0x0000A4BB,
        0x0000A4BB
    };

    static _CharacterInfo _character0000A4BC =
    {
        0x0000A4BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BC,
        0x0000A4BC,
        0x0000A4BC
    };

    static _CharacterInfo _character0000A4BD =
    {
        0x0000A4BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BD,
        0x0000A4BD,
        0x0000A4BD
    };

    static _CharacterInfo _character0000A4BE =
    {
        0x0000A4BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BE,
        0x0000A4BE,
        0x0000A4BE
    };

    static _CharacterInfo _character0000A4BF =
    {
        0x0000A4BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4BF,
        0x0000A4BF,
        0x0000A4BF
    };

    static _CharacterInfo _character0000A4C0 =
    {
        0x0000A4C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C0,
        0x0000A4C0,
        0x0000A4C0
    };

    static _CharacterInfo _character0000A4C1 =
    {
        0x0000A4C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C1,
        0x0000A4C1,
        0x0000A4C1
    };

    static _CharacterInfo _character0000A4C2 =
    {
        0x0000A4C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C2,
        0x0000A4C2,
        0x0000A4C2
    };

    static _CharacterInfo _character0000A4C3 =
    {
        0x0000A4C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C3,
        0x0000A4C3,
        0x0000A4C3
    };

    static _CharacterInfo _character0000A4C4 =
    {
        0x0000A4C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C4,
        0x0000A4C4,
        0x0000A4C4
    };

    static _CharacterInfo _character0000A4C5 =
    {
        0x0000A4C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C5,
        0x0000A4C5,
        0x0000A4C5
    };

    static _CharacterInfo _character0000A4C6 =
    {
        0x0000A4C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A4C6,
        0x0000A4C6,
        0x0000A4C6
    };

    static _CharacterInfo _character0000A700 =
    {
        0x0000A700,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A700,
        0x0000A700,
        0x0000A700
    };

    static _CharacterInfo _character0000A701 =
    {
        0x0000A701,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A701,
        0x0000A701,
        0x0000A701
    };

    static _CharacterInfo _character0000A702 =
    {
        0x0000A702,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A702,
        0x0000A702,
        0x0000A702
    };

    static _CharacterInfo _character0000A703 =
    {
        0x0000A703,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A703,
        0x0000A703,
        0x0000A703
    };

    static _CharacterInfo _character0000A704 =
    {
        0x0000A704,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A704,
        0x0000A704,
        0x0000A704
    };

    static _CharacterInfo _character0000A705 =
    {
        0x0000A705,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A705,
        0x0000A705,
        0x0000A705
    };

    static _CharacterInfo _character0000A706 =
    {
        0x0000A706,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A706,
        0x0000A706,
        0x0000A706
    };

    static _CharacterInfo _character0000A707 =
    {
        0x0000A707,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A707,
        0x0000A707,
        0x0000A707
    };

    static _CharacterInfo _character0000A708 =
    {
        0x0000A708,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A708,
        0x0000A708,
        0x0000A708
    };

    static _CharacterInfo _character0000A709 =
    {
        0x0000A709,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A709,
        0x0000A709,
        0x0000A709
    };

    static _CharacterInfo _character0000A70A =
    {
        0x0000A70A,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70A,
        0x0000A70A,
        0x0000A70A
    };

    static _CharacterInfo _character0000A70B =
    {
        0x0000A70B,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70B,
        0x0000A70B,
        0x0000A70B
    };

    static _CharacterInfo _character0000A70C =
    {
        0x0000A70C,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70C,
        0x0000A70C,
        0x0000A70C
    };

    static _CharacterInfo _character0000A70D =
    {
        0x0000A70D,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70D,
        0x0000A70D,
        0x0000A70D
    };

    static _CharacterInfo _character0000A70E =
    {
        0x0000A70E,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70E,
        0x0000A70E,
        0x0000A70E
    };

    static _CharacterInfo _character0000A70F =
    {
        0x0000A70F,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A70F,
        0x0000A70F,
        0x0000A70F
    };

    static _CharacterInfo _character0000A710 =
    {
        0x0000A710,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A710,
        0x0000A710,
        0x0000A710
    };

    static _CharacterInfo _character0000A711 =
    {
        0x0000A711,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A711,
        0x0000A711,
        0x0000A711
    };

    static _CharacterInfo _character0000A712 =
    {
        0x0000A712,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A712,
        0x0000A712,
        0x0000A712
    };

    static _CharacterInfo _character0000A713 =
    {
        0x0000A713,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A713,
        0x0000A713,
        0x0000A713
    };

    static _CharacterInfo _character0000A714 =
    {
        0x0000A714,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A714,
        0x0000A714,
        0x0000A714
    };

    static _CharacterInfo _character0000A715 =
    {
        0x0000A715,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A715,
        0x0000A715,
        0x0000A715
    };

    static _CharacterInfo _character0000A716 =
    {
        0x0000A716,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A716,
        0x0000A716,
        0x0000A716
    };

    static _CharacterInfo _character0000A717 =
    {
        0x0000A717,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A717,
        0x0000A717,
        0x0000A717
    };

    static _CharacterInfo _character0000A718 =
    {
        0x0000A718,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A718,
        0x0000A718,
        0x0000A718
    };

    static _CharacterInfo _character0000A719 =
    {
        0x0000A719,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A719,
        0x0000A719,
        0x0000A719
    };

    static _CharacterInfo _character0000A71A =
    {
        0x0000A71A,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A71A,
        0x0000A71A,
        0x0000A71A
    };

    static _CharacterInfo _character0000A720 =
    {
        0x0000A720,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A720,
        0x0000A720,
        0x0000A720
    };

    static _CharacterInfo _character0000A721 =
    {
        0x0000A721,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A721,
        0x0000A721,
        0x0000A721
    };

    static _CharacterInfo _character0000A800 =
    {
        0x0000A800,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A800,
        0x0000A800,
        0x0000A800
    };

    static _CharacterInfo _character0000A801 =
    {
        0x0000A801,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A801,
        0x0000A801,
        0x0000A801
    };

    static _CharacterInfo _character0000A802 =
    {
        0x0000A802,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A802,
        0x0000A802,
        0x0000A802
    };

    static _CharacterInfo _character0000A803 =
    {
        0x0000A803,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A803,
        0x0000A803,
        0x0000A803
    };

    static _CharacterInfo _character0000A804 =
    {
        0x0000A804,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A804,
        0x0000A804,
        0x0000A804
    };

    static _CharacterInfo _character0000A805 =
    {
        0x0000A805,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A805,
        0x0000A805,
        0x0000A805
    };

    static _CharacterInfo _character0000A806 =
    {
        0x0000A806,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A806,
        0x0000A806,
        0x0000A806
    };

    static _CharacterInfo _character0000A807 =
    {
        0x0000A807,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A807,
        0x0000A807,
        0x0000A807
    };

    static _CharacterInfo _character0000A808 =
    {
        0x0000A808,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A808,
        0x0000A808,
        0x0000A808
    };

    static _CharacterInfo _character0000A809 =
    {
        0x0000A809,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A809,
        0x0000A809,
        0x0000A809
    };

    static _CharacterInfo _character0000A80A =
    {
        0x0000A80A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80A,
        0x0000A80A,
        0x0000A80A
    };

    static _CharacterInfo _character0000A80B =
    {
        0x0000A80B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80B,
        0x0000A80B,
        0x0000A80B
    };

    static _CharacterInfo _character0000A80C =
    {
        0x0000A80C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80C,
        0x0000A80C,
        0x0000A80C
    };

    static _CharacterInfo _character0000A80D =
    {
        0x0000A80D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80D,
        0x0000A80D,
        0x0000A80D
    };

    static _CharacterInfo _character0000A80E =
    {
        0x0000A80E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80E,
        0x0000A80E,
        0x0000A80E
    };

    static _CharacterInfo _character0000A80F =
    {
        0x0000A80F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A80F,
        0x0000A80F,
        0x0000A80F
    };

    static _CharacterInfo _character0000A810 =
    {
        0x0000A810,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A810,
        0x0000A810,
        0x0000A810
    };

    static _CharacterInfo _character0000A811 =
    {
        0x0000A811,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A811,
        0x0000A811,
        0x0000A811
    };

    static _CharacterInfo _character0000A812 =
    {
        0x0000A812,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A812,
        0x0000A812,
        0x0000A812
    };

    static _CharacterInfo _character0000A813 =
    {
        0x0000A813,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A813,
        0x0000A813,
        0x0000A813
    };

    static _CharacterInfo _character0000A814 =
    {
        0x0000A814,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A814,
        0x0000A814,
        0x0000A814
    };

    static _CharacterInfo _character0000A815 =
    {
        0x0000A815,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A815,
        0x0000A815,
        0x0000A815
    };

    static _CharacterInfo _character0000A816 =
    {
        0x0000A816,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A816,
        0x0000A816,
        0x0000A816
    };

    static _CharacterInfo _character0000A817 =
    {
        0x0000A817,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A817,
        0x0000A817,
        0x0000A817
    };

    static _CharacterInfo _character0000A818 =
    {
        0x0000A818,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A818,
        0x0000A818,
        0x0000A818
    };

    static _CharacterInfo _character0000A819 =
    {
        0x0000A819,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A819,
        0x0000A819,
        0x0000A819
    };

    static _CharacterInfo _character0000A81A =
    {
        0x0000A81A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81A,
        0x0000A81A,
        0x0000A81A
    };

    static _CharacterInfo _character0000A81B =
    {
        0x0000A81B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81B,
        0x0000A81B,
        0x0000A81B
    };

    static _CharacterInfo _character0000A81C =
    {
        0x0000A81C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81C,
        0x0000A81C,
        0x0000A81C
    };

    static _CharacterInfo _character0000A81D =
    {
        0x0000A81D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81D,
        0x0000A81D,
        0x0000A81D
    };

    static _CharacterInfo _character0000A81E =
    {
        0x0000A81E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81E,
        0x0000A81E,
        0x0000A81E
    };

    static _CharacterInfo _character0000A81F =
    {
        0x0000A81F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A81F,
        0x0000A81F,
        0x0000A81F
    };

    static _CharacterInfo _character0000A820 =
    {
        0x0000A820,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A820,
        0x0000A820,
        0x0000A820
    };

    static _CharacterInfo _character0000A821 =
    {
        0x0000A821,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A821,
        0x0000A821,
        0x0000A821
    };

    static _CharacterInfo _character0000A822 =
    {
        0x0000A822,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A822,
        0x0000A822,
        0x0000A822
    };

    static _CharacterInfo _character0000A823 =
    {
        0x0000A823,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A823,
        0x0000A823,
        0x0000A823
    };

    static _CharacterInfo _character0000A824 =
    {
        0x0000A824,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A824,
        0x0000A824,
        0x0000A824
    };

    static _CharacterInfo _character0000A825 =
    {
        0x0000A825,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A825,
        0x0000A825,
        0x0000A825
    };

    static _CharacterInfo _character0000A826 =
    {
        0x0000A826,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A826,
        0x0000A826,
        0x0000A826
    };

    static _CharacterInfo _character0000A827 =
    {
        0x0000A827,
        Iso10646::GeneralCategory_Mc,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A827,
        0x0000A827,
        0x0000A827
    };

    static _CharacterInfo _character0000A828 =
    {
        0x0000A828,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A828,
        0x0000A828,
        0x0000A828
    };

    static _CharacterInfo _character0000A829 =
    {
        0x0000A829,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A829,
        0x0000A829,
        0x0000A829
    };

    static _CharacterInfo _character0000A82A =
    {
        0x0000A82A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A82A,
        0x0000A82A,
        0x0000A82A
    };

    static _CharacterInfo _character0000A82B =
    {
        0x0000A82B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A82B,
        0x0000A82B,
        0x0000A82B
    };

    static _CharacterInfo _character0000A840 =
    {
        0x0000A840,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A840,
        0x0000A840,
        0x0000A840
    };

    static _CharacterInfo _character0000A841 =
    {
        0x0000A841,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A841,
        0x0000A841,
        0x0000A841
    };

    static _CharacterInfo _character0000A842 =
    {
        0x0000A842,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A842,
        0x0000A842,
        0x0000A842
    };

    static _CharacterInfo _character0000A843 =
    {
        0x0000A843,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A843,
        0x0000A843,
        0x0000A843
    };

    static _CharacterInfo _character0000A844 =
    {
        0x0000A844,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A844,
        0x0000A844,
        0x0000A844
    };

    static _CharacterInfo _character0000A845 =
    {
        0x0000A845,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A845,
        0x0000A845,
        0x0000A845
    };

    static _CharacterInfo _character0000A846 =
    {
        0x0000A846,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A846,
        0x0000A846,
        0x0000A846
    };

    static _CharacterInfo _character0000A847 =
    {
        0x0000A847,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A847,
        0x0000A847,
        0x0000A847
    };

    static _CharacterInfo _character0000A848 =
    {
        0x0000A848,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A848,
        0x0000A848,
        0x0000A848
    };

    static _CharacterInfo _character0000A849 =
    {
        0x0000A849,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A849,
        0x0000A849,
        0x0000A849
    };

    static _CharacterInfo _character0000A84A =
    {
        0x0000A84A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84A,
        0x0000A84A,
        0x0000A84A
    };

    static _CharacterInfo _character0000A84B =
    {
        0x0000A84B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84B,
        0x0000A84B,
        0x0000A84B
    };

    static _CharacterInfo _character0000A84C =
    {
        0x0000A84C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84C,
        0x0000A84C,
        0x0000A84C
    };

    static _CharacterInfo _character0000A84D =
    {
        0x0000A84D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84D,
        0x0000A84D,
        0x0000A84D
    };

    static _CharacterInfo _character0000A84E =
    {
        0x0000A84E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84E,
        0x0000A84E,
        0x0000A84E
    };

    static _CharacterInfo _character0000A84F =
    {
        0x0000A84F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A84F,
        0x0000A84F,
        0x0000A84F
    };

    static _CharacterInfo _character0000A850 =
    {
        0x0000A850,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A850,
        0x0000A850,
        0x0000A850
    };

    static _CharacterInfo _character0000A851 =
    {
        0x0000A851,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A851,
        0x0000A851,
        0x0000A851
    };

    static _CharacterInfo _character0000A852 =
    {
        0x0000A852,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A852,
        0x0000A852,
        0x0000A852
    };

    static _CharacterInfo _character0000A853 =
    {
        0x0000A853,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A853,
        0x0000A853,
        0x0000A853
    };

    static _CharacterInfo _character0000A854 =
    {
        0x0000A854,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A854,
        0x0000A854,
        0x0000A854
    };

    static _CharacterInfo _character0000A855 =
    {
        0x0000A855,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A855,
        0x0000A855,
        0x0000A855
    };

    static _CharacterInfo _character0000A856 =
    {
        0x0000A856,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A856,
        0x0000A856,
        0x0000A856
    };

    static _CharacterInfo _character0000A857 =
    {
        0x0000A857,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A857,
        0x0000A857,
        0x0000A857
    };

    static _CharacterInfo _character0000A858 =
    {
        0x0000A858,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A858,
        0x0000A858,
        0x0000A858
    };

    static _CharacterInfo _character0000A859 =
    {
        0x0000A859,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A859,
        0x0000A859,
        0x0000A859
    };

    static _CharacterInfo _character0000A85A =
    {
        0x0000A85A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85A,
        0x0000A85A,
        0x0000A85A
    };

    static _CharacterInfo _character0000A85B =
    {
        0x0000A85B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85B,
        0x0000A85B,
        0x0000A85B
    };

    static _CharacterInfo _character0000A85C =
    {
        0x0000A85C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85C,
        0x0000A85C,
        0x0000A85C
    };

    static _CharacterInfo _character0000A85D =
    {
        0x0000A85D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85D,
        0x0000A85D,
        0x0000A85D
    };

    static _CharacterInfo _character0000A85E =
    {
        0x0000A85E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85E,
        0x0000A85E,
        0x0000A85E
    };

    static _CharacterInfo _character0000A85F =
    {
        0x0000A85F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A85F,
        0x0000A85F,
        0x0000A85F
    };

    static _CharacterInfo _character0000A860 =
    {
        0x0000A860,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A860,
        0x0000A860,
        0x0000A860
    };

    static _CharacterInfo _character0000A861 =
    {
        0x0000A861,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A861,
        0x0000A861,
        0x0000A861
    };

    static _CharacterInfo _character0000A862 =
    {
        0x0000A862,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A862,
        0x0000A862,
        0x0000A862
    };

    static _CharacterInfo _character0000A863 =
    {
        0x0000A863,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A863,
        0x0000A863,
        0x0000A863
    };

    static _CharacterInfo _character0000A864 =
    {
        0x0000A864,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A864,
        0x0000A864,
        0x0000A864
    };

    static _CharacterInfo _character0000A865 =
    {
        0x0000A865,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A865,
        0x0000A865,
        0x0000A865
    };

    static _CharacterInfo _character0000A866 =
    {
        0x0000A866,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A866,
        0x0000A866,
        0x0000A866
    };

    static _CharacterInfo _character0000A867 =
    {
        0x0000A867,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A867,
        0x0000A867,
        0x0000A867
    };

    static _CharacterInfo _character0000A868 =
    {
        0x0000A868,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A868,
        0x0000A868,
        0x0000A868
    };

    static _CharacterInfo _character0000A869 =
    {
        0x0000A869,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A869,
        0x0000A869,
        0x0000A869
    };

    static _CharacterInfo _character0000A86A =
    {
        0x0000A86A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86A,
        0x0000A86A,
        0x0000A86A
    };

    static _CharacterInfo _character0000A86B =
    {
        0x0000A86B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86B,
        0x0000A86B,
        0x0000A86B
    };

    static _CharacterInfo _character0000A86C =
    {
        0x0000A86C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86C,
        0x0000A86C,
        0x0000A86C
    };

    static _CharacterInfo _character0000A86D =
    {
        0x0000A86D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86D,
        0x0000A86D,
        0x0000A86D
    };

    static _CharacterInfo _character0000A86E =
    {
        0x0000A86E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86E,
        0x0000A86E,
        0x0000A86E
    };

    static _CharacterInfo _character0000A86F =
    {
        0x0000A86F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A86F,
        0x0000A86F,
        0x0000A86F
    };

    static _CharacterInfo _character0000A870 =
    {
        0x0000A870,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A870,
        0x0000A870,
        0x0000A870
    };

    static _CharacterInfo _character0000A871 =
    {
        0x0000A871,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A871,
        0x0000A871,
        0x0000A871
    };

    static _CharacterInfo _character0000A872 =
    {
        0x0000A872,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A872,
        0x0000A872,
        0x0000A872
    };

    static _CharacterInfo _character0000A873 =
    {
        0x0000A873,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A873,
        0x0000A873,
        0x0000A873
    };

    static _CharacterInfo _character0000A874 =
    {
        0x0000A874,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A874,
        0x0000A874,
        0x0000A874
    };

    static _CharacterInfo _character0000A875 =
    {
        0x0000A875,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A875,
        0x0000A875,
        0x0000A875
    };

    static _CharacterInfo _character0000A876 =
    {
        0x0000A876,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A876,
        0x0000A876,
        0x0000A876
    };

    static _CharacterInfo _character0000A877 =
    {
        0x0000A877,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000A877,
        0x0000A877,
        0x0000A877
    };

    static _CharacterInfo _character0000AC00 =
    {
        0x0000AC00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000AC00,
        0x0000AC00,
        0x0000AC00
    };

    static _CharacterInfo _character0000D7A3 =
    {
        0x0000D7A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000D7A3,
        0x0000D7A3,
        0x0000D7A3
    };

    static _CharacterInfo _character0000D800 =
    {
        0x0000D800,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000D800,
        0x0000D800,
        0x0000D800
    };

    static _CharacterInfo _character0000DB7F =
    {
        0x0000DB7F,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000DB7F,
        0x0000DB7F,
        0x0000DB7F
    };

    static _CharacterInfo _character0000DB80 =
    {
        0x0000DB80,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000DB80,
        0x0000DB80,
        0x0000DB80
    };

    static _CharacterInfo _character0000DBFF =
    {
        0x0000DBFF,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000DBFF,
        0x0000DBFF,
        0x0000DBFF
    };

    static _CharacterInfo _character0000DC00 =
    {
        0x0000DC00,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000DC00,
        0x0000DC00,
        0x0000DC00
    };

    static _CharacterInfo _character0000DFFF =
    {
        0x0000DFFF,
        Iso10646::GeneralCategory_Cs,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000DFFF,
        0x0000DFFF,
        0x0000DFFF
    };

    static _CharacterInfo _character0000E000 =
    {
        0x0000E000,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000E000,
        0x0000E000,
        0x0000E000
    };

    static _CharacterInfo _character0000F8FF =
    {
        0x0000F8FF,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F8FF,
        0x0000F8FF,
        0x0000F8FF
    };

    static Char _decompositionMapping0000F900[] = 
    {
        0x00008C48
    };

    static _CharacterInfo _character0000F900 =
    {
        0x0000F900,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F900,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F900,
        0x0000F900,
        0x0000F900
    };

    static Char _decompositionMapping0000F901[] = 
    {
        0x000066F4
    };

    static _CharacterInfo _character0000F901 =
    {
        0x0000F901,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F901,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F901,
        0x0000F901,
        0x0000F901
    };

    static Char _decompositionMapping0000F902[] = 
    {
        0x00008ECA
    };

    static _CharacterInfo _character0000F902 =
    {
        0x0000F902,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F902,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F902,
        0x0000F902,
        0x0000F902
    };

    static Char _decompositionMapping0000F903[] = 
    {
        0x00008CC8
    };

    static _CharacterInfo _character0000F903 =
    {
        0x0000F903,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F903,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F903,
        0x0000F903,
        0x0000F903
    };

    static Char _decompositionMapping0000F904[] = 
    {
        0x00006ED1
    };

    static _CharacterInfo _character0000F904 =
    {
        0x0000F904,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F904,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F904,
        0x0000F904,
        0x0000F904
    };

    static Char _decompositionMapping0000F905[] = 
    {
        0x00004E32
    };

    static _CharacterInfo _character0000F905 =
    {
        0x0000F905,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F905,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F905,
        0x0000F905,
        0x0000F905
    };

    static Char _decompositionMapping0000F906[] = 
    {
        0x000053E5
    };

    static _CharacterInfo _character0000F906 =
    {
        0x0000F906,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F906,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F906,
        0x0000F906,
        0x0000F906
    };

    static Char _decompositionMapping0000F907[] = 
    {
        0x00009F9C
    };

    static _CharacterInfo _character0000F907 =
    {
        0x0000F907,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F907,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F907,
        0x0000F907,
        0x0000F907
    };

    static Char _decompositionMapping0000F908[] = 
    {
        0x00009F9C
    };

    static _CharacterInfo _character0000F908 =
    {
        0x0000F908,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F908,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F908,
        0x0000F908,
        0x0000F908
    };

    static Char _decompositionMapping0000F909[] = 
    {
        0x00005951
    };

    static _CharacterInfo _character0000F909 =
    {
        0x0000F909,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F909,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F909,
        0x0000F909,
        0x0000F909
    };

    static Char _decompositionMapping0000F90A[] = 
    {
        0x000091D1
    };

    static _CharacterInfo _character0000F90A =
    {
        0x0000F90A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90A,
        0x0000F90A,
        0x0000F90A
    };

    static Char _decompositionMapping0000F90B[] = 
    {
        0x00005587
    };

    static _CharacterInfo _character0000F90B =
    {
        0x0000F90B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90B,
        0x0000F90B,
        0x0000F90B
    };

    static Char _decompositionMapping0000F90C[] = 
    {
        0x00005948
    };

    static _CharacterInfo _character0000F90C =
    {
        0x0000F90C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90C,
        0x0000F90C,
        0x0000F90C
    };

    static Char _decompositionMapping0000F90D[] = 
    {
        0x000061F6
    };

    static _CharacterInfo _character0000F90D =
    {
        0x0000F90D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90D,
        0x0000F90D,
        0x0000F90D
    };

    static Char _decompositionMapping0000F90E[] = 
    {
        0x00007669
    };

    static _CharacterInfo _character0000F90E =
    {
        0x0000F90E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90E,
        0x0000F90E,
        0x0000F90E
    };

    static Char _decompositionMapping0000F90F[] = 
    {
        0x00007F85
    };

    static _CharacterInfo _character0000F90F =
    {
        0x0000F90F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F90F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F90F,
        0x0000F90F,
        0x0000F90F
    };

    static Char _decompositionMapping0000F910[] = 
    {
        0x0000863F
    };

    static _CharacterInfo _character0000F910 =
    {
        0x0000F910,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F910,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F910,
        0x0000F910,
        0x0000F910
    };

    static Char _decompositionMapping0000F911[] = 
    {
        0x000087BA
    };

    static _CharacterInfo _character0000F911 =
    {
        0x0000F911,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F911,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F911,
        0x0000F911,
        0x0000F911
    };

    static Char _decompositionMapping0000F912[] = 
    {
        0x000088F8
    };

    static _CharacterInfo _character0000F912 =
    {
        0x0000F912,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F912,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F912,
        0x0000F912,
        0x0000F912
    };

    static Char _decompositionMapping0000F913[] = 
    {
        0x0000908F
    };

    static _CharacterInfo _character0000F913 =
    {
        0x0000F913,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F913,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F913,
        0x0000F913,
        0x0000F913
    };

    static Char _decompositionMapping0000F914[] = 
    {
        0x00006A02
    };

    static _CharacterInfo _character0000F914 =
    {
        0x0000F914,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F914,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F914,
        0x0000F914,
        0x0000F914
    };

    static Char _decompositionMapping0000F915[] = 
    {
        0x00006D1B
    };

    static _CharacterInfo _character0000F915 =
    {
        0x0000F915,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F915,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F915,
        0x0000F915,
        0x0000F915
    };

    static Char _decompositionMapping0000F916[] = 
    {
        0x000070D9
    };

    static _CharacterInfo _character0000F916 =
    {
        0x0000F916,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F916,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F916,
        0x0000F916,
        0x0000F916
    };

    static Char _decompositionMapping0000F917[] = 
    {
        0x000073DE
    };

    static _CharacterInfo _character0000F917 =
    {
        0x0000F917,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F917,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F917,
        0x0000F917,
        0x0000F917
    };

    static Char _decompositionMapping0000F918[] = 
    {
        0x0000843D
    };

    static _CharacterInfo _character0000F918 =
    {
        0x0000F918,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F918,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F918,
        0x0000F918,
        0x0000F918
    };

    static Char _decompositionMapping0000F919[] = 
    {
        0x0000916A
    };

    static _CharacterInfo _character0000F919 =
    {
        0x0000F919,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F919,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F919,
        0x0000F919,
        0x0000F919
    };

    static Char _decompositionMapping0000F91A[] = 
    {
        0x000099F1
    };

    static _CharacterInfo _character0000F91A =
    {
        0x0000F91A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91A,
        0x0000F91A,
        0x0000F91A
    };

    static Char _decompositionMapping0000F91B[] = 
    {
        0x00004E82
    };

    static _CharacterInfo _character0000F91B =
    {
        0x0000F91B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91B,
        0x0000F91B,
        0x0000F91B
    };

    static Char _decompositionMapping0000F91C[] = 
    {
        0x00005375
    };

    static _CharacterInfo _character0000F91C =
    {
        0x0000F91C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91C,
        0x0000F91C,
        0x0000F91C
    };

    static Char _decompositionMapping0000F91D[] = 
    {
        0x00006B04
    };

    static _CharacterInfo _character0000F91D =
    {
        0x0000F91D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91D,
        0x0000F91D,
        0x0000F91D
    };

    static Char _decompositionMapping0000F91E[] = 
    {
        0x0000721B
    };

    static _CharacterInfo _character0000F91E =
    {
        0x0000F91E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91E,
        0x0000F91E,
        0x0000F91E
    };

    static Char _decompositionMapping0000F91F[] = 
    {
        0x0000862D
    };

    static _CharacterInfo _character0000F91F =
    {
        0x0000F91F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F91F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F91F,
        0x0000F91F,
        0x0000F91F
    };

    static Char _decompositionMapping0000F920[] = 
    {
        0x00009E1E
    };

    static _CharacterInfo _character0000F920 =
    {
        0x0000F920,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F920,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F920,
        0x0000F920,
        0x0000F920
    };

    static Char _decompositionMapping0000F921[] = 
    {
        0x00005D50
    };

    static _CharacterInfo _character0000F921 =
    {
        0x0000F921,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F921,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F921,
        0x0000F921,
        0x0000F921
    };

    static Char _decompositionMapping0000F922[] = 
    {
        0x00006FEB
    };

    static _CharacterInfo _character0000F922 =
    {
        0x0000F922,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F922,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F922,
        0x0000F922,
        0x0000F922
    };

    static Char _decompositionMapping0000F923[] = 
    {
        0x000085CD
    };

    static _CharacterInfo _character0000F923 =
    {
        0x0000F923,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F923,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F923,
        0x0000F923,
        0x0000F923
    };

    static Char _decompositionMapping0000F924[] = 
    {
        0x00008964
    };

    static _CharacterInfo _character0000F924 =
    {
        0x0000F924,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F924,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F924,
        0x0000F924,
        0x0000F924
    };

    static Char _decompositionMapping0000F925[] = 
    {
        0x000062C9
    };

    static _CharacterInfo _character0000F925 =
    {
        0x0000F925,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F925,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F925,
        0x0000F925,
        0x0000F925
    };

    static Char _decompositionMapping0000F926[] = 
    {
        0x000081D8
    };

    static _CharacterInfo _character0000F926 =
    {
        0x0000F926,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F926,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F926,
        0x0000F926,
        0x0000F926
    };

    static Char _decompositionMapping0000F927[] = 
    {
        0x0000881F
    };

    static _CharacterInfo _character0000F927 =
    {
        0x0000F927,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F927,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F927,
        0x0000F927,
        0x0000F927
    };

    static Char _decompositionMapping0000F928[] = 
    {
        0x00005ECA
    };

    static _CharacterInfo _character0000F928 =
    {
        0x0000F928,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F928,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F928,
        0x0000F928,
        0x0000F928
    };

    static Char _decompositionMapping0000F929[] = 
    {
        0x00006717
    };

    static _CharacterInfo _character0000F929 =
    {
        0x0000F929,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F929,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F929,
        0x0000F929,
        0x0000F929
    };

    static Char _decompositionMapping0000F92A[] = 
    {
        0x00006D6A
    };

    static _CharacterInfo _character0000F92A =
    {
        0x0000F92A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92A,
        0x0000F92A,
        0x0000F92A
    };

    static Char _decompositionMapping0000F92B[] = 
    {
        0x000072FC
    };

    static _CharacterInfo _character0000F92B =
    {
        0x0000F92B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92B,
        0x0000F92B,
        0x0000F92B
    };

    static Char _decompositionMapping0000F92C[] = 
    {
        0x000090CE
    };

    static _CharacterInfo _character0000F92C =
    {
        0x0000F92C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92C,
        0x0000F92C,
        0x0000F92C
    };

    static Char _decompositionMapping0000F92D[] = 
    {
        0x00004F86
    };

    static _CharacterInfo _character0000F92D =
    {
        0x0000F92D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92D,
        0x0000F92D,
        0x0000F92D
    };

    static Char _decompositionMapping0000F92E[] = 
    {
        0x000051B7
    };

    static _CharacterInfo _character0000F92E =
    {
        0x0000F92E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92E,
        0x0000F92E,
        0x0000F92E
    };

    static Char _decompositionMapping0000F92F[] = 
    {
        0x000052DE
    };

    static _CharacterInfo _character0000F92F =
    {
        0x0000F92F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F92F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F92F,
        0x0000F92F,
        0x0000F92F
    };

    static Char _decompositionMapping0000F930[] = 
    {
        0x000064C4
    };

    static _CharacterInfo _character0000F930 =
    {
        0x0000F930,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F930,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F930,
        0x0000F930,
        0x0000F930
    };

    static Char _decompositionMapping0000F931[] = 
    {
        0x00006AD3
    };

    static _CharacterInfo _character0000F931 =
    {
        0x0000F931,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F931,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F931,
        0x0000F931,
        0x0000F931
    };

    static Char _decompositionMapping0000F932[] = 
    {
        0x00007210
    };

    static _CharacterInfo _character0000F932 =
    {
        0x0000F932,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F932,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F932,
        0x0000F932,
        0x0000F932
    };

    static Char _decompositionMapping0000F933[] = 
    {
        0x000076E7
    };

    static _CharacterInfo _character0000F933 =
    {
        0x0000F933,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F933,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F933,
        0x0000F933,
        0x0000F933
    };

    static Char _decompositionMapping0000F934[] = 
    {
        0x00008001
    };

    static _CharacterInfo _character0000F934 =
    {
        0x0000F934,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F934,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F934,
        0x0000F934,
        0x0000F934
    };

    static Char _decompositionMapping0000F935[] = 
    {
        0x00008606
    };

    static _CharacterInfo _character0000F935 =
    {
        0x0000F935,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F935,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F935,
        0x0000F935,
        0x0000F935
    };

    static Char _decompositionMapping0000F936[] = 
    {
        0x0000865C
    };

    static _CharacterInfo _character0000F936 =
    {
        0x0000F936,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F936,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F936,
        0x0000F936,
        0x0000F936
    };

    static Char _decompositionMapping0000F937[] = 
    {
        0x00008DEF
    };

    static _CharacterInfo _character0000F937 =
    {
        0x0000F937,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F937,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F937,
        0x0000F937,
        0x0000F937
    };

    static Char _decompositionMapping0000F938[] = 
    {
        0x00009732
    };

    static _CharacterInfo _character0000F938 =
    {
        0x0000F938,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F938,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F938,
        0x0000F938,
        0x0000F938
    };

    static Char _decompositionMapping0000F939[] = 
    {
        0x00009B6F
    };

    static _CharacterInfo _character0000F939 =
    {
        0x0000F939,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F939,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F939,
        0x0000F939,
        0x0000F939
    };

    static Char _decompositionMapping0000F93A[] = 
    {
        0x00009DFA
    };

    static _CharacterInfo _character0000F93A =
    {
        0x0000F93A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93A,
        0x0000F93A,
        0x0000F93A
    };

    static Char _decompositionMapping0000F93B[] = 
    {
        0x0000788C
    };

    static _CharacterInfo _character0000F93B =
    {
        0x0000F93B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93B,
        0x0000F93B,
        0x0000F93B
    };

    static Char _decompositionMapping0000F93C[] = 
    {
        0x0000797F
    };

    static _CharacterInfo _character0000F93C =
    {
        0x0000F93C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93C,
        0x0000F93C,
        0x0000F93C
    };

    static Char _decompositionMapping0000F93D[] = 
    {
        0x00007DA0
    };

    static _CharacterInfo _character0000F93D =
    {
        0x0000F93D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93D,
        0x0000F93D,
        0x0000F93D
    };

    static Char _decompositionMapping0000F93E[] = 
    {
        0x000083C9
    };

    static _CharacterInfo _character0000F93E =
    {
        0x0000F93E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93E,
        0x0000F93E,
        0x0000F93E
    };

    static Char _decompositionMapping0000F93F[] = 
    {
        0x00009304
    };

    static _CharacterInfo _character0000F93F =
    {
        0x0000F93F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F93F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F93F,
        0x0000F93F,
        0x0000F93F
    };

    static Char _decompositionMapping0000F940[] = 
    {
        0x00009E7F
    };

    static _CharacterInfo _character0000F940 =
    {
        0x0000F940,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F940,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F940,
        0x0000F940,
        0x0000F940
    };

    static Char _decompositionMapping0000F941[] = 
    {
        0x00008AD6
    };

    static _CharacterInfo _character0000F941 =
    {
        0x0000F941,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F941,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F941,
        0x0000F941,
        0x0000F941
    };

    static Char _decompositionMapping0000F942[] = 
    {
        0x000058DF
    };

    static _CharacterInfo _character0000F942 =
    {
        0x0000F942,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F942,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F942,
        0x0000F942,
        0x0000F942
    };

    static Char _decompositionMapping0000F943[] = 
    {
        0x00005F04
    };

    static _CharacterInfo _character0000F943 =
    {
        0x0000F943,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F943,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F943,
        0x0000F943,
        0x0000F943
    };

    static Char _decompositionMapping0000F944[] = 
    {
        0x00007C60
    };

    static _CharacterInfo _character0000F944 =
    {
        0x0000F944,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F944,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F944,
        0x0000F944,
        0x0000F944
    };

    static Char _decompositionMapping0000F945[] = 
    {
        0x0000807E
    };

    static _CharacterInfo _character0000F945 =
    {
        0x0000F945,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F945,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F945,
        0x0000F945,
        0x0000F945
    };

    static Char _decompositionMapping0000F946[] = 
    {
        0x00007262
    };

    static _CharacterInfo _character0000F946 =
    {
        0x0000F946,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F946,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F946,
        0x0000F946,
        0x0000F946
    };

    static Char _decompositionMapping0000F947[] = 
    {
        0x000078CA
    };

    static _CharacterInfo _character0000F947 =
    {
        0x0000F947,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F947,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F947,
        0x0000F947,
        0x0000F947
    };

    static Char _decompositionMapping0000F948[] = 
    {
        0x00008CC2
    };

    static _CharacterInfo _character0000F948 =
    {
        0x0000F948,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F948,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F948,
        0x0000F948,
        0x0000F948
    };

    static Char _decompositionMapping0000F949[] = 
    {
        0x000096F7
    };

    static _CharacterInfo _character0000F949 =
    {
        0x0000F949,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F949,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F949,
        0x0000F949,
        0x0000F949
    };

    static Char _decompositionMapping0000F94A[] = 
    {
        0x000058D8
    };

    static _CharacterInfo _character0000F94A =
    {
        0x0000F94A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94A,
        0x0000F94A,
        0x0000F94A
    };

    static Char _decompositionMapping0000F94B[] = 
    {
        0x00005C62
    };

    static _CharacterInfo _character0000F94B =
    {
        0x0000F94B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94B,
        0x0000F94B,
        0x0000F94B
    };

    static Char _decompositionMapping0000F94C[] = 
    {
        0x00006A13
    };

    static _CharacterInfo _character0000F94C =
    {
        0x0000F94C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94C,
        0x0000F94C,
        0x0000F94C
    };

    static Char _decompositionMapping0000F94D[] = 
    {
        0x00006DDA
    };

    static _CharacterInfo _character0000F94D =
    {
        0x0000F94D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94D,
        0x0000F94D,
        0x0000F94D
    };

    static Char _decompositionMapping0000F94E[] = 
    {
        0x00006F0F
    };

    static _CharacterInfo _character0000F94E =
    {
        0x0000F94E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94E,
        0x0000F94E,
        0x0000F94E
    };

    static Char _decompositionMapping0000F94F[] = 
    {
        0x00007D2F
    };

    static _CharacterInfo _character0000F94F =
    {
        0x0000F94F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F94F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F94F,
        0x0000F94F,
        0x0000F94F
    };

    static Char _decompositionMapping0000F950[] = 
    {
        0x00007E37
    };

    static _CharacterInfo _character0000F950 =
    {
        0x0000F950,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F950,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F950,
        0x0000F950,
        0x0000F950
    };

    static Char _decompositionMapping0000F951[] = 
    {
        0x0000964B
    };

    static _CharacterInfo _character0000F951 =
    {
        0x0000F951,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F951,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F951,
        0x0000F951,
        0x0000F951
    };

    static Char _decompositionMapping0000F952[] = 
    {
        0x000052D2
    };

    static _CharacterInfo _character0000F952 =
    {
        0x0000F952,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F952,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F952,
        0x0000F952,
        0x0000F952
    };

    static Char _decompositionMapping0000F953[] = 
    {
        0x0000808B
    };

    static _CharacterInfo _character0000F953 =
    {
        0x0000F953,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F953,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F953,
        0x0000F953,
        0x0000F953
    };

    static Char _decompositionMapping0000F954[] = 
    {
        0x000051DC
    };

    static _CharacterInfo _character0000F954 =
    {
        0x0000F954,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F954,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F954,
        0x0000F954,
        0x0000F954
    };

    static Char _decompositionMapping0000F955[] = 
    {
        0x000051CC
    };

    static _CharacterInfo _character0000F955 =
    {
        0x0000F955,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F955,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F955,
        0x0000F955,
        0x0000F955
    };

    static Char _decompositionMapping0000F956[] = 
    {
        0x00007A1C
    };

    static _CharacterInfo _character0000F956 =
    {
        0x0000F956,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F956,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F956,
        0x0000F956,
        0x0000F956
    };

    static Char _decompositionMapping0000F957[] = 
    {
        0x00007DBE
    };

    static _CharacterInfo _character0000F957 =
    {
        0x0000F957,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F957,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F957,
        0x0000F957,
        0x0000F957
    };

    static Char _decompositionMapping0000F958[] = 
    {
        0x000083F1
    };

    static _CharacterInfo _character0000F958 =
    {
        0x0000F958,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F958,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F958,
        0x0000F958,
        0x0000F958
    };

    static Char _decompositionMapping0000F959[] = 
    {
        0x00009675
    };

    static _CharacterInfo _character0000F959 =
    {
        0x0000F959,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F959,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F959,
        0x0000F959,
        0x0000F959
    };

    static Char _decompositionMapping0000F95A[] = 
    {
        0x00008B80
    };

    static _CharacterInfo _character0000F95A =
    {
        0x0000F95A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95A,
        0x0000F95A,
        0x0000F95A
    };

    static Char _decompositionMapping0000F95B[] = 
    {
        0x000062CF
    };

    static _CharacterInfo _character0000F95B =
    {
        0x0000F95B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95B,
        0x0000F95B,
        0x0000F95B
    };

    static Char _decompositionMapping0000F95C[] = 
    {
        0x00006A02
    };

    static _CharacterInfo _character0000F95C =
    {
        0x0000F95C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95C,
        0x0000F95C,
        0x0000F95C
    };

    static Char _decompositionMapping0000F95D[] = 
    {
        0x00008AFE
    };

    static _CharacterInfo _character0000F95D =
    {
        0x0000F95D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95D,
        0x0000F95D,
        0x0000F95D
    };

    static Char _decompositionMapping0000F95E[] = 
    {
        0x00004E39
    };

    static _CharacterInfo _character0000F95E =
    {
        0x0000F95E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95E,
        0x0000F95E,
        0x0000F95E
    };

    static Char _decompositionMapping0000F95F[] = 
    {
        0x00005BE7
    };

    static _CharacterInfo _character0000F95F =
    {
        0x0000F95F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F95F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F95F,
        0x0000F95F,
        0x0000F95F
    };

    static Char _decompositionMapping0000F960[] = 
    {
        0x00006012
    };

    static _CharacterInfo _character0000F960 =
    {
        0x0000F960,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F960,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F960,
        0x0000F960,
        0x0000F960
    };

    static Char _decompositionMapping0000F961[] = 
    {
        0x00007387
    };

    static _CharacterInfo _character0000F961 =
    {
        0x0000F961,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F961,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F961,
        0x0000F961,
        0x0000F961
    };

    static Char _decompositionMapping0000F962[] = 
    {
        0x00007570
    };

    static _CharacterInfo _character0000F962 =
    {
        0x0000F962,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F962,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F962,
        0x0000F962,
        0x0000F962
    };

    static Char _decompositionMapping0000F963[] = 
    {
        0x00005317
    };

    static _CharacterInfo _character0000F963 =
    {
        0x0000F963,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F963,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F963,
        0x0000F963,
        0x0000F963
    };

    static Char _decompositionMapping0000F964[] = 
    {
        0x000078FB
    };

    static _CharacterInfo _character0000F964 =
    {
        0x0000F964,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F964,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F964,
        0x0000F964,
        0x0000F964
    };

    static Char _decompositionMapping0000F965[] = 
    {
        0x00004FBF
    };

    static _CharacterInfo _character0000F965 =
    {
        0x0000F965,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F965,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F965,
        0x0000F965,
        0x0000F965
    };

    static Char _decompositionMapping0000F966[] = 
    {
        0x00005FA9
    };

    static _CharacterInfo _character0000F966 =
    {
        0x0000F966,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F966,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F966,
        0x0000F966,
        0x0000F966
    };

    static Char _decompositionMapping0000F967[] = 
    {
        0x00004E0D
    };

    static _CharacterInfo _character0000F967 =
    {
        0x0000F967,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F967,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F967,
        0x0000F967,
        0x0000F967
    };

    static Char _decompositionMapping0000F968[] = 
    {
        0x00006CCC
    };

    static _CharacterInfo _character0000F968 =
    {
        0x0000F968,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F968,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F968,
        0x0000F968,
        0x0000F968
    };

    static Char _decompositionMapping0000F969[] = 
    {
        0x00006578
    };

    static _CharacterInfo _character0000F969 =
    {
        0x0000F969,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F969,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F969,
        0x0000F969,
        0x0000F969
    };

    static Char _decompositionMapping0000F96A[] = 
    {
        0x00007D22
    };

    static _CharacterInfo _character0000F96A =
    {
        0x0000F96A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96A,
        0x0000F96A,
        0x0000F96A
    };

    static Char _decompositionMapping0000F96B[] = 
    {
        0x000053C3
    };

    static _CharacterInfo _character0000F96B =
    {
        0x0000F96B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96B,
        0x0000F96B,
        0x0000F96B
    };

    static Char _decompositionMapping0000F96C[] = 
    {
        0x0000585E
    };

    static _CharacterInfo _character0000F96C =
    {
        0x0000F96C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96C,
        0x0000F96C,
        0x0000F96C
    };

    static Char _decompositionMapping0000F96D[] = 
    {
        0x00007701
    };

    static _CharacterInfo _character0000F96D =
    {
        0x0000F96D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96D,
        0x0000F96D,
        0x0000F96D
    };

    static Char _decompositionMapping0000F96E[] = 
    {
        0x00008449
    };

    static _CharacterInfo _character0000F96E =
    {
        0x0000F96E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96E,
        0x0000F96E,
        0x0000F96E
    };

    static Char _decompositionMapping0000F96F[] = 
    {
        0x00008AAA
    };

    static _CharacterInfo _character0000F96F =
    {
        0x0000F96F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F96F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F96F,
        0x0000F96F,
        0x0000F96F
    };

    static Char _decompositionMapping0000F970[] = 
    {
        0x00006BBA
    };

    static _CharacterInfo _character0000F970 =
    {
        0x0000F970,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F970,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F970,
        0x0000F970,
        0x0000F970
    };

    static Char _decompositionMapping0000F971[] = 
    {
        0x00008FB0
    };

    static _CharacterInfo _character0000F971 =
    {
        0x0000F971,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F971,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F971,
        0x0000F971,
        0x0000F971
    };

    static Char _decompositionMapping0000F972[] = 
    {
        0x00006C88
    };

    static _CharacterInfo _character0000F972 =
    {
        0x0000F972,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F972,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F972,
        0x0000F972,
        0x0000F972
    };

    static Char _decompositionMapping0000F973[] = 
    {
        0x000062FE
    };

    static _CharacterInfo _character0000F973 =
    {
        0x0000F973,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F973,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F973,
        0x0000F973,
        0x0000F973
    };

    static Char _decompositionMapping0000F974[] = 
    {
        0x000082E5
    };

    static _CharacterInfo _character0000F974 =
    {
        0x0000F974,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F974,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F974,
        0x0000F974,
        0x0000F974
    };

    static Char _decompositionMapping0000F975[] = 
    {
        0x000063A0
    };

    static _CharacterInfo _character0000F975 =
    {
        0x0000F975,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F975,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F975,
        0x0000F975,
        0x0000F975
    };

    static Char _decompositionMapping0000F976[] = 
    {
        0x00007565
    };

    static _CharacterInfo _character0000F976 =
    {
        0x0000F976,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F976,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F976,
        0x0000F976,
        0x0000F976
    };

    static Char _decompositionMapping0000F977[] = 
    {
        0x00004EAE
    };

    static _CharacterInfo _character0000F977 =
    {
        0x0000F977,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F977,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F977,
        0x0000F977,
        0x0000F977
    };

    static Char _decompositionMapping0000F978[] = 
    {
        0x00005169
    };

    static _CharacterInfo _character0000F978 =
    {
        0x0000F978,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F978,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F978,
        0x0000F978,
        0x0000F978
    };

    static Char _decompositionMapping0000F979[] = 
    {
        0x000051C9
    };

    static _CharacterInfo _character0000F979 =
    {
        0x0000F979,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F979,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F979,
        0x0000F979,
        0x0000F979
    };

    static Char _decompositionMapping0000F97A[] = 
    {
        0x00006881
    };

    static _CharacterInfo _character0000F97A =
    {
        0x0000F97A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97A,
        0x0000F97A,
        0x0000F97A
    };

    static Char _decompositionMapping0000F97B[] = 
    {
        0x00007CE7
    };

    static _CharacterInfo _character0000F97B =
    {
        0x0000F97B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97B,
        0x0000F97B,
        0x0000F97B
    };

    static Char _decompositionMapping0000F97C[] = 
    {
        0x0000826F
    };

    static _CharacterInfo _character0000F97C =
    {
        0x0000F97C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97C,
        0x0000F97C,
        0x0000F97C
    };

    static Char _decompositionMapping0000F97D[] = 
    {
        0x00008AD2
    };

    static _CharacterInfo _character0000F97D =
    {
        0x0000F97D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97D,
        0x0000F97D,
        0x0000F97D
    };

    static Char _decompositionMapping0000F97E[] = 
    {
        0x000091CF
    };

    static _CharacterInfo _character0000F97E =
    {
        0x0000F97E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97E,
        0x0000F97E,
        0x0000F97E
    };

    static Char _decompositionMapping0000F97F[] = 
    {
        0x000052F5
    };

    static _CharacterInfo _character0000F97F =
    {
        0x0000F97F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F97F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F97F,
        0x0000F97F,
        0x0000F97F
    };

    static Char _decompositionMapping0000F980[] = 
    {
        0x00005442
    };

    static _CharacterInfo _character0000F980 =
    {
        0x0000F980,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F980,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F980,
        0x0000F980,
        0x0000F980
    };

    static Char _decompositionMapping0000F981[] = 
    {
        0x00005973
    };

    static _CharacterInfo _character0000F981 =
    {
        0x0000F981,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F981,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F981,
        0x0000F981,
        0x0000F981
    };

    static Char _decompositionMapping0000F982[] = 
    {
        0x00005EEC
    };

    static _CharacterInfo _character0000F982 =
    {
        0x0000F982,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F982,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F982,
        0x0000F982,
        0x0000F982
    };

    static Char _decompositionMapping0000F983[] = 
    {
        0x000065C5
    };

    static _CharacterInfo _character0000F983 =
    {
        0x0000F983,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F983,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F983,
        0x0000F983,
        0x0000F983
    };

    static Char _decompositionMapping0000F984[] = 
    {
        0x00006FFE
    };

    static _CharacterInfo _character0000F984 =
    {
        0x0000F984,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F984,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F984,
        0x0000F984,
        0x0000F984
    };

    static Char _decompositionMapping0000F985[] = 
    {
        0x0000792A
    };

    static _CharacterInfo _character0000F985 =
    {
        0x0000F985,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F985,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F985,
        0x0000F985,
        0x0000F985
    };

    static Char _decompositionMapping0000F986[] = 
    {
        0x000095AD
    };

    static _CharacterInfo _character0000F986 =
    {
        0x0000F986,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F986,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F986,
        0x0000F986,
        0x0000F986
    };

    static Char _decompositionMapping0000F987[] = 
    {
        0x00009A6A
    };

    static _CharacterInfo _character0000F987 =
    {
        0x0000F987,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F987,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F987,
        0x0000F987,
        0x0000F987
    };

    static Char _decompositionMapping0000F988[] = 
    {
        0x00009E97
    };

    static _CharacterInfo _character0000F988 =
    {
        0x0000F988,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F988,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F988,
        0x0000F988,
        0x0000F988
    };

    static Char _decompositionMapping0000F989[] = 
    {
        0x00009ECE
    };

    static _CharacterInfo _character0000F989 =
    {
        0x0000F989,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F989,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F989,
        0x0000F989,
        0x0000F989
    };

    static Char _decompositionMapping0000F98A[] = 
    {
        0x0000529B
    };

    static _CharacterInfo _character0000F98A =
    {
        0x0000F98A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98A,
        0x0000F98A,
        0x0000F98A
    };

    static Char _decompositionMapping0000F98B[] = 
    {
        0x000066C6
    };

    static _CharacterInfo _character0000F98B =
    {
        0x0000F98B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98B,
        0x0000F98B,
        0x0000F98B
    };

    static Char _decompositionMapping0000F98C[] = 
    {
        0x00006B77
    };

    static _CharacterInfo _character0000F98C =
    {
        0x0000F98C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98C,
        0x0000F98C,
        0x0000F98C
    };

    static Char _decompositionMapping0000F98D[] = 
    {
        0x00008F62
    };

    static _CharacterInfo _character0000F98D =
    {
        0x0000F98D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98D,
        0x0000F98D,
        0x0000F98D
    };

    static Char _decompositionMapping0000F98E[] = 
    {
        0x00005E74
    };

    static _CharacterInfo _character0000F98E =
    {
        0x0000F98E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98E,
        0x0000F98E,
        0x0000F98E
    };

    static Char _decompositionMapping0000F98F[] = 
    {
        0x00006190
    };

    static _CharacterInfo _character0000F98F =
    {
        0x0000F98F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F98F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F98F,
        0x0000F98F,
        0x0000F98F
    };

    static Char _decompositionMapping0000F990[] = 
    {
        0x00006200
    };

    static _CharacterInfo _character0000F990 =
    {
        0x0000F990,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F990,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F990,
        0x0000F990,
        0x0000F990
    };

    static Char _decompositionMapping0000F991[] = 
    {
        0x0000649A
    };

    static _CharacterInfo _character0000F991 =
    {
        0x0000F991,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F991,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F991,
        0x0000F991,
        0x0000F991
    };

    static Char _decompositionMapping0000F992[] = 
    {
        0x00006F23
    };

    static _CharacterInfo _character0000F992 =
    {
        0x0000F992,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F992,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F992,
        0x0000F992,
        0x0000F992
    };

    static Char _decompositionMapping0000F993[] = 
    {
        0x00007149
    };

    static _CharacterInfo _character0000F993 =
    {
        0x0000F993,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F993,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F993,
        0x0000F993,
        0x0000F993
    };

    static Char _decompositionMapping0000F994[] = 
    {
        0x00007489
    };

    static _CharacterInfo _character0000F994 =
    {
        0x0000F994,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F994,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F994,
        0x0000F994,
        0x0000F994
    };

    static Char _decompositionMapping0000F995[] = 
    {
        0x000079CA
    };

    static _CharacterInfo _character0000F995 =
    {
        0x0000F995,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F995,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F995,
        0x0000F995,
        0x0000F995
    };

    static Char _decompositionMapping0000F996[] = 
    {
        0x00007DF4
    };

    static _CharacterInfo _character0000F996 =
    {
        0x0000F996,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F996,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F996,
        0x0000F996,
        0x0000F996
    };

    static Char _decompositionMapping0000F997[] = 
    {
        0x0000806F
    };

    static _CharacterInfo _character0000F997 =
    {
        0x0000F997,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F997,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F997,
        0x0000F997,
        0x0000F997
    };

    static Char _decompositionMapping0000F998[] = 
    {
        0x00008F26
    };

    static _CharacterInfo _character0000F998 =
    {
        0x0000F998,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F998,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F998,
        0x0000F998,
        0x0000F998
    };

    static Char _decompositionMapping0000F999[] = 
    {
        0x000084EE
    };

    static _CharacterInfo _character0000F999 =
    {
        0x0000F999,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F999,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F999,
        0x0000F999,
        0x0000F999
    };

    static Char _decompositionMapping0000F99A[] = 
    {
        0x00009023
    };

    static _CharacterInfo _character0000F99A =
    {
        0x0000F99A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99A,
        0x0000F99A,
        0x0000F99A
    };

    static Char _decompositionMapping0000F99B[] = 
    {
        0x0000934A
    };

    static _CharacterInfo _character0000F99B =
    {
        0x0000F99B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99B,
        0x0000F99B,
        0x0000F99B
    };

    static Char _decompositionMapping0000F99C[] = 
    {
        0x00005217
    };

    static _CharacterInfo _character0000F99C =
    {
        0x0000F99C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99C,
        0x0000F99C,
        0x0000F99C
    };

    static Char _decompositionMapping0000F99D[] = 
    {
        0x000052A3
    };

    static _CharacterInfo _character0000F99D =
    {
        0x0000F99D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99D,
        0x0000F99D,
        0x0000F99D
    };

    static Char _decompositionMapping0000F99E[] = 
    {
        0x000054BD
    };

    static _CharacterInfo _character0000F99E =
    {
        0x0000F99E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99E,
        0x0000F99E,
        0x0000F99E
    };

    static Char _decompositionMapping0000F99F[] = 
    {
        0x000070C8
    };

    static _CharacterInfo _character0000F99F =
    {
        0x0000F99F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F99F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F99F,
        0x0000F99F,
        0x0000F99F
    };

    static Char _decompositionMapping0000F9A0[] = 
    {
        0x000088C2
    };

    static _CharacterInfo _character0000F9A0 =
    {
        0x0000F9A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A0,
        0x0000F9A0,
        0x0000F9A0
    };

    static Char _decompositionMapping0000F9A1[] = 
    {
        0x00008AAA
    };

    static _CharacterInfo _character0000F9A1 =
    {
        0x0000F9A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A1,
        0x0000F9A1,
        0x0000F9A1
    };

    static Char _decompositionMapping0000F9A2[] = 
    {
        0x00005EC9
    };

    static _CharacterInfo _character0000F9A2 =
    {
        0x0000F9A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A2,
        0x0000F9A2,
        0x0000F9A2
    };

    static Char _decompositionMapping0000F9A3[] = 
    {
        0x00005FF5
    };

    static _CharacterInfo _character0000F9A3 =
    {
        0x0000F9A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A3,
        0x0000F9A3,
        0x0000F9A3
    };

    static Char _decompositionMapping0000F9A4[] = 
    {
        0x0000637B
    };

    static _CharacterInfo _character0000F9A4 =
    {
        0x0000F9A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A4,
        0x0000F9A4,
        0x0000F9A4
    };

    static Char _decompositionMapping0000F9A5[] = 
    {
        0x00006BAE
    };

    static _CharacterInfo _character0000F9A5 =
    {
        0x0000F9A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A5,
        0x0000F9A5,
        0x0000F9A5
    };

    static Char _decompositionMapping0000F9A6[] = 
    {
        0x00007C3E
    };

    static _CharacterInfo _character0000F9A6 =
    {
        0x0000F9A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A6,
        0x0000F9A6,
        0x0000F9A6
    };

    static Char _decompositionMapping0000F9A7[] = 
    {
        0x00007375
    };

    static _CharacterInfo _character0000F9A7 =
    {
        0x0000F9A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A7,
        0x0000F9A7,
        0x0000F9A7
    };

    static Char _decompositionMapping0000F9A8[] = 
    {
        0x00004EE4
    };

    static _CharacterInfo _character0000F9A8 =
    {
        0x0000F9A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A8,
        0x0000F9A8,
        0x0000F9A8
    };

    static Char _decompositionMapping0000F9A9[] = 
    {
        0x000056F9
    };

    static _CharacterInfo _character0000F9A9 =
    {
        0x0000F9A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9A9,
        0x0000F9A9,
        0x0000F9A9
    };

    static Char _decompositionMapping0000F9AA[] = 
    {
        0x00005BE7
    };

    static _CharacterInfo _character0000F9AA =
    {
        0x0000F9AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AA,
        0x0000F9AA,
        0x0000F9AA
    };

    static Char _decompositionMapping0000F9AB[] = 
    {
        0x00005DBA
    };

    static _CharacterInfo _character0000F9AB =
    {
        0x0000F9AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AB,
        0x0000F9AB,
        0x0000F9AB
    };

    static Char _decompositionMapping0000F9AC[] = 
    {
        0x0000601C
    };

    static _CharacterInfo _character0000F9AC =
    {
        0x0000F9AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AC,
        0x0000F9AC,
        0x0000F9AC
    };

    static Char _decompositionMapping0000F9AD[] = 
    {
        0x000073B2
    };

    static _CharacterInfo _character0000F9AD =
    {
        0x0000F9AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AD,
        0x0000F9AD,
        0x0000F9AD
    };

    static Char _decompositionMapping0000F9AE[] = 
    {
        0x00007469
    };

    static _CharacterInfo _character0000F9AE =
    {
        0x0000F9AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AE,
        0x0000F9AE,
        0x0000F9AE
    };

    static Char _decompositionMapping0000F9AF[] = 
    {
        0x00007F9A
    };

    static _CharacterInfo _character0000F9AF =
    {
        0x0000F9AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9AF,
        0x0000F9AF,
        0x0000F9AF
    };

    static Char _decompositionMapping0000F9B0[] = 
    {
        0x00008046
    };

    static _CharacterInfo _character0000F9B0 =
    {
        0x0000F9B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B0,
        0x0000F9B0,
        0x0000F9B0
    };

    static Char _decompositionMapping0000F9B1[] = 
    {
        0x00009234
    };

    static _CharacterInfo _character0000F9B1 =
    {
        0x0000F9B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B1,
        0x0000F9B1,
        0x0000F9B1
    };

    static Char _decompositionMapping0000F9B2[] = 
    {
        0x000096F6
    };

    static _CharacterInfo _character0000F9B2 =
    {
        0x0000F9B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B2,
        0x0000F9B2,
        0x0000F9B2
    };

    static Char _decompositionMapping0000F9B3[] = 
    {
        0x00009748
    };

    static _CharacterInfo _character0000F9B3 =
    {
        0x0000F9B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B3,
        0x0000F9B3,
        0x0000F9B3
    };

    static Char _decompositionMapping0000F9B4[] = 
    {
        0x00009818
    };

    static _CharacterInfo _character0000F9B4 =
    {
        0x0000F9B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B4,
        0x0000F9B4,
        0x0000F9B4
    };

    static Char _decompositionMapping0000F9B5[] = 
    {
        0x00004F8B
    };

    static _CharacterInfo _character0000F9B5 =
    {
        0x0000F9B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B5,
        0x0000F9B5,
        0x0000F9B5
    };

    static Char _decompositionMapping0000F9B6[] = 
    {
        0x000079AE
    };

    static _CharacterInfo _character0000F9B6 =
    {
        0x0000F9B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B6,
        0x0000F9B6,
        0x0000F9B6
    };

    static Char _decompositionMapping0000F9B7[] = 
    {
        0x000091B4
    };

    static _CharacterInfo _character0000F9B7 =
    {
        0x0000F9B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B7,
        0x0000F9B7,
        0x0000F9B7
    };

    static Char _decompositionMapping0000F9B8[] = 
    {
        0x000096B8
    };

    static _CharacterInfo _character0000F9B8 =
    {
        0x0000F9B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B8,
        0x0000F9B8,
        0x0000F9B8
    };

    static Char _decompositionMapping0000F9B9[] = 
    {
        0x000060E1
    };

    static _CharacterInfo _character0000F9B9 =
    {
        0x0000F9B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9B9,
        0x0000F9B9,
        0x0000F9B9
    };

    static Char _decompositionMapping0000F9BA[] = 
    {
        0x00004E86
    };

    static _CharacterInfo _character0000F9BA =
    {
        0x0000F9BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BA,
        0x0000F9BA,
        0x0000F9BA
    };

    static Char _decompositionMapping0000F9BB[] = 
    {
        0x000050DA
    };

    static _CharacterInfo _character0000F9BB =
    {
        0x0000F9BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BB,
        0x0000F9BB,
        0x0000F9BB
    };

    static Char _decompositionMapping0000F9BC[] = 
    {
        0x00005BEE
    };

    static _CharacterInfo _character0000F9BC =
    {
        0x0000F9BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BC,
        0x0000F9BC,
        0x0000F9BC
    };

    static Char _decompositionMapping0000F9BD[] = 
    {
        0x00005C3F
    };

    static _CharacterInfo _character0000F9BD =
    {
        0x0000F9BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BD,
        0x0000F9BD,
        0x0000F9BD
    };

    static Char _decompositionMapping0000F9BE[] = 
    {
        0x00006599
    };

    static _CharacterInfo _character0000F9BE =
    {
        0x0000F9BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BE,
        0x0000F9BE,
        0x0000F9BE
    };

    static Char _decompositionMapping0000F9BF[] = 
    {
        0x00006A02
    };

    static _CharacterInfo _character0000F9BF =
    {
        0x0000F9BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9BF,
        0x0000F9BF,
        0x0000F9BF
    };

    static Char _decompositionMapping0000F9C0[] = 
    {
        0x000071CE
    };

    static _CharacterInfo _character0000F9C0 =
    {
        0x0000F9C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C0,
        0x0000F9C0,
        0x0000F9C0
    };

    static Char _decompositionMapping0000F9C1[] = 
    {
        0x00007642
    };

    static _CharacterInfo _character0000F9C1 =
    {
        0x0000F9C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C1,
        0x0000F9C1,
        0x0000F9C1
    };

    static Char _decompositionMapping0000F9C2[] = 
    {
        0x000084FC
    };

    static _CharacterInfo _character0000F9C2 =
    {
        0x0000F9C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C2,
        0x0000F9C2,
        0x0000F9C2
    };

    static Char _decompositionMapping0000F9C3[] = 
    {
        0x0000907C
    };

    static _CharacterInfo _character0000F9C3 =
    {
        0x0000F9C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C3,
        0x0000F9C3,
        0x0000F9C3
    };

    static Char _decompositionMapping0000F9C4[] = 
    {
        0x00009F8D
    };

    static _CharacterInfo _character0000F9C4 =
    {
        0x0000F9C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C4,
        0x0000F9C4,
        0x0000F9C4
    };

    static Char _decompositionMapping0000F9C5[] = 
    {
        0x00006688
    };

    static _CharacterInfo _character0000F9C5 =
    {
        0x0000F9C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C5,
        0x0000F9C5,
        0x0000F9C5
    };

    static Char _decompositionMapping0000F9C6[] = 
    {
        0x0000962E
    };

    static _CharacterInfo _character0000F9C6 =
    {
        0x0000F9C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C6,
        0x0000F9C6,
        0x0000F9C6
    };

    static Char _decompositionMapping0000F9C7[] = 
    {
        0x00005289
    };

    static _CharacterInfo _character0000F9C7 =
    {
        0x0000F9C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C7,
        0x0000F9C7,
        0x0000F9C7
    };

    static Char _decompositionMapping0000F9C8[] = 
    {
        0x0000677B
    };

    static _CharacterInfo _character0000F9C8 =
    {
        0x0000F9C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C8,
        0x0000F9C8,
        0x0000F9C8
    };

    static Char _decompositionMapping0000F9C9[] = 
    {
        0x000067F3
    };

    static _CharacterInfo _character0000F9C9 =
    {
        0x0000F9C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9C9,
        0x0000F9C9,
        0x0000F9C9
    };

    static Char _decompositionMapping0000F9CA[] = 
    {
        0x00006D41
    };

    static _CharacterInfo _character0000F9CA =
    {
        0x0000F9CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CA,
        0x0000F9CA,
        0x0000F9CA
    };

    static Char _decompositionMapping0000F9CB[] = 
    {
        0x00006E9C
    };

    static _CharacterInfo _character0000F9CB =
    {
        0x0000F9CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CB,
        0x0000F9CB,
        0x0000F9CB
    };

    static Char _decompositionMapping0000F9CC[] = 
    {
        0x00007409
    };

    static _CharacterInfo _character0000F9CC =
    {
        0x0000F9CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CC,
        0x0000F9CC,
        0x0000F9CC
    };

    static Char _decompositionMapping0000F9CD[] = 
    {
        0x00007559
    };

    static _CharacterInfo _character0000F9CD =
    {
        0x0000F9CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CD,
        0x0000F9CD,
        0x0000F9CD
    };

    static Char _decompositionMapping0000F9CE[] = 
    {
        0x0000786B
    };

    static _CharacterInfo _character0000F9CE =
    {
        0x0000F9CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CE,
        0x0000F9CE,
        0x0000F9CE
    };

    static Char _decompositionMapping0000F9CF[] = 
    {
        0x00007D10
    };

    static _CharacterInfo _character0000F9CF =
    {
        0x0000F9CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9CF,
        0x0000F9CF,
        0x0000F9CF
    };

    static Char _decompositionMapping0000F9D0[] = 
    {
        0x0000985E
    };

    static _CharacterInfo _character0000F9D0 =
    {
        0x0000F9D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D0,
        0x0000F9D0,
        0x0000F9D0
    };

    static Char _decompositionMapping0000F9D1[] = 
    {
        0x0000516D
    };

    static _CharacterInfo _character0000F9D1 =
    {
        0x0000F9D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D1,
        0x0000F9D1,
        0x0000F9D1
    };

    static Char _decompositionMapping0000F9D2[] = 
    {
        0x0000622E
    };

    static _CharacterInfo _character0000F9D2 =
    {
        0x0000F9D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D2,
        0x0000F9D2,
        0x0000F9D2
    };

    static Char _decompositionMapping0000F9D3[] = 
    {
        0x00009678
    };

    static _CharacterInfo _character0000F9D3 =
    {
        0x0000F9D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D3,
        0x0000F9D3,
        0x0000F9D3
    };

    static Char _decompositionMapping0000F9D4[] = 
    {
        0x0000502B
    };

    static _CharacterInfo _character0000F9D4 =
    {
        0x0000F9D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D4,
        0x0000F9D4,
        0x0000F9D4
    };

    static Char _decompositionMapping0000F9D5[] = 
    {
        0x00005D19
    };

    static _CharacterInfo _character0000F9D5 =
    {
        0x0000F9D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D5,
        0x0000F9D5,
        0x0000F9D5
    };

    static Char _decompositionMapping0000F9D6[] = 
    {
        0x00006DEA
    };

    static _CharacterInfo _character0000F9D6 =
    {
        0x0000F9D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D6,
        0x0000F9D6,
        0x0000F9D6
    };

    static Char _decompositionMapping0000F9D7[] = 
    {
        0x00008F2A
    };

    static _CharacterInfo _character0000F9D7 =
    {
        0x0000F9D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D7,
        0x0000F9D7,
        0x0000F9D7
    };

    static Char _decompositionMapping0000F9D8[] = 
    {
        0x00005F8B
    };

    static _CharacterInfo _character0000F9D8 =
    {
        0x0000F9D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D8,
        0x0000F9D8,
        0x0000F9D8
    };

    static Char _decompositionMapping0000F9D9[] = 
    {
        0x00006144
    };

    static _CharacterInfo _character0000F9D9 =
    {
        0x0000F9D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9D9,
        0x0000F9D9,
        0x0000F9D9
    };

    static Char _decompositionMapping0000F9DA[] = 
    {
        0x00006817
    };

    static _CharacterInfo _character0000F9DA =
    {
        0x0000F9DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DA,
        0x0000F9DA,
        0x0000F9DA
    };

    static Char _decompositionMapping0000F9DB[] = 
    {
        0x00007387
    };

    static _CharacterInfo _character0000F9DB =
    {
        0x0000F9DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DB,
        0x0000F9DB,
        0x0000F9DB
    };

    static Char _decompositionMapping0000F9DC[] = 
    {
        0x00009686
    };

    static _CharacterInfo _character0000F9DC =
    {
        0x0000F9DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DC,
        0x0000F9DC,
        0x0000F9DC
    };

    static Char _decompositionMapping0000F9DD[] = 
    {
        0x00005229
    };

    static _CharacterInfo _character0000F9DD =
    {
        0x0000F9DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DD,
        0x0000F9DD,
        0x0000F9DD
    };

    static Char _decompositionMapping0000F9DE[] = 
    {
        0x0000540F
    };

    static _CharacterInfo _character0000F9DE =
    {
        0x0000F9DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DE,
        0x0000F9DE,
        0x0000F9DE
    };

    static Char _decompositionMapping0000F9DF[] = 
    {
        0x00005C65
    };

    static _CharacterInfo _character0000F9DF =
    {
        0x0000F9DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9DF,
        0x0000F9DF,
        0x0000F9DF
    };

    static Char _decompositionMapping0000F9E0[] = 
    {
        0x00006613
    };

    static _CharacterInfo _character0000F9E0 =
    {
        0x0000F9E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E0,
        0x0000F9E0,
        0x0000F9E0
    };

    static Char _decompositionMapping0000F9E1[] = 
    {
        0x0000674E
    };

    static _CharacterInfo _character0000F9E1 =
    {
        0x0000F9E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E1,
        0x0000F9E1,
        0x0000F9E1
    };

    static Char _decompositionMapping0000F9E2[] = 
    {
        0x000068A8
    };

    static _CharacterInfo _character0000F9E2 =
    {
        0x0000F9E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E2,
        0x0000F9E2,
        0x0000F9E2
    };

    static Char _decompositionMapping0000F9E3[] = 
    {
        0x00006CE5
    };

    static _CharacterInfo _character0000F9E3 =
    {
        0x0000F9E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E3,
        0x0000F9E3,
        0x0000F9E3
    };

    static Char _decompositionMapping0000F9E4[] = 
    {
        0x00007406
    };

    static _CharacterInfo _character0000F9E4 =
    {
        0x0000F9E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E4,
        0x0000F9E4,
        0x0000F9E4
    };

    static Char _decompositionMapping0000F9E5[] = 
    {
        0x000075E2
    };

    static _CharacterInfo _character0000F9E5 =
    {
        0x0000F9E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E5,
        0x0000F9E5,
        0x0000F9E5
    };

    static Char _decompositionMapping0000F9E6[] = 
    {
        0x00007F79
    };

    static _CharacterInfo _character0000F9E6 =
    {
        0x0000F9E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E6,
        0x0000F9E6,
        0x0000F9E6
    };

    static Char _decompositionMapping0000F9E7[] = 
    {
        0x000088CF
    };

    static _CharacterInfo _character0000F9E7 =
    {
        0x0000F9E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E7,
        0x0000F9E7,
        0x0000F9E7
    };

    static Char _decompositionMapping0000F9E8[] = 
    {
        0x000088E1
    };

    static _CharacterInfo _character0000F9E8 =
    {
        0x0000F9E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E8,
        0x0000F9E8,
        0x0000F9E8
    };

    static Char _decompositionMapping0000F9E9[] = 
    {
        0x000091CC
    };

    static _CharacterInfo _character0000F9E9 =
    {
        0x0000F9E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9E9,
        0x0000F9E9,
        0x0000F9E9
    };

    static Char _decompositionMapping0000F9EA[] = 
    {
        0x000096E2
    };

    static _CharacterInfo _character0000F9EA =
    {
        0x0000F9EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9EA,
        0x0000F9EA,
        0x0000F9EA
    };

    static Char _decompositionMapping0000F9EB[] = 
    {
        0x0000533F
    };

    static _CharacterInfo _character0000F9EB =
    {
        0x0000F9EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9EB,
        0x0000F9EB,
        0x0000F9EB
    };

    static Char _decompositionMapping0000F9EC[] = 
    {
        0x00006EBA
    };

    static _CharacterInfo _character0000F9EC =
    {
        0x0000F9EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9EC,
        0x0000F9EC,
        0x0000F9EC
    };

    static Char _decompositionMapping0000F9ED[] = 
    {
        0x0000541D
    };

    static _CharacterInfo _character0000F9ED =
    {
        0x0000F9ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9ED,
        0x0000F9ED,
        0x0000F9ED
    };

    static Char _decompositionMapping0000F9EE[] = 
    {
        0x000071D0
    };

    static _CharacterInfo _character0000F9EE =
    {
        0x0000F9EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9EE,
        0x0000F9EE,
        0x0000F9EE
    };

    static Char _decompositionMapping0000F9EF[] = 
    {
        0x00007498
    };

    static _CharacterInfo _character0000F9EF =
    {
        0x0000F9EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9EF,
        0x0000F9EF,
        0x0000F9EF
    };

    static Char _decompositionMapping0000F9F0[] = 
    {
        0x000085FA
    };

    static _CharacterInfo _character0000F9F0 =
    {
        0x0000F9F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F0,
        0x0000F9F0,
        0x0000F9F0
    };

    static Char _decompositionMapping0000F9F1[] = 
    {
        0x000096A3
    };

    static _CharacterInfo _character0000F9F1 =
    {
        0x0000F9F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F1,
        0x0000F9F1,
        0x0000F9F1
    };

    static Char _decompositionMapping0000F9F2[] = 
    {
        0x00009C57
    };

    static _CharacterInfo _character0000F9F2 =
    {
        0x0000F9F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F2,
        0x0000F9F2,
        0x0000F9F2
    };

    static Char _decompositionMapping0000F9F3[] = 
    {
        0x00009E9F
    };

    static _CharacterInfo _character0000F9F3 =
    {
        0x0000F9F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F3,
        0x0000F9F3,
        0x0000F9F3
    };

    static Char _decompositionMapping0000F9F4[] = 
    {
        0x00006797
    };

    static _CharacterInfo _character0000F9F4 =
    {
        0x0000F9F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F4,
        0x0000F9F4,
        0x0000F9F4
    };

    static Char _decompositionMapping0000F9F5[] = 
    {
        0x00006DCB
    };

    static _CharacterInfo _character0000F9F5 =
    {
        0x0000F9F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F5,
        0x0000F9F5,
        0x0000F9F5
    };

    static Char _decompositionMapping0000F9F6[] = 
    {
        0x000081E8
    };

    static _CharacterInfo _character0000F9F6 =
    {
        0x0000F9F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F6,
        0x0000F9F6,
        0x0000F9F6
    };

    static Char _decompositionMapping0000F9F7[] = 
    {
        0x00007ACB
    };

    static _CharacterInfo _character0000F9F7 =
    {
        0x0000F9F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F7,
        0x0000F9F7,
        0x0000F9F7
    };

    static Char _decompositionMapping0000F9F8[] = 
    {
        0x00007B20
    };

    static _CharacterInfo _character0000F9F8 =
    {
        0x0000F9F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F8,
        0x0000F9F8,
        0x0000F9F8
    };

    static Char _decompositionMapping0000F9F9[] = 
    {
        0x00007C92
    };

    static _CharacterInfo _character0000F9F9 =
    {
        0x0000F9F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9F9,
        0x0000F9F9,
        0x0000F9F9
    };

    static Char _decompositionMapping0000F9FA[] = 
    {
        0x000072C0
    };

    static _CharacterInfo _character0000F9FA =
    {
        0x0000F9FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FA,
        0x0000F9FA,
        0x0000F9FA
    };

    static Char _decompositionMapping0000F9FB[] = 
    {
        0x00007099
    };

    static _CharacterInfo _character0000F9FB =
    {
        0x0000F9FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FB,
        0x0000F9FB,
        0x0000F9FB
    };

    static Char _decompositionMapping0000F9FC[] = 
    {
        0x00008B58
    };

    static _CharacterInfo _character0000F9FC =
    {
        0x0000F9FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FC,
        0x0000F9FC,
        0x0000F9FC
    };

    static Char _decompositionMapping0000F9FD[] = 
    {
        0x00004EC0
    };

    static _CharacterInfo _character0000F9FD =
    {
        0x0000F9FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FD,
        0x0000F9FD,
        0x0000F9FD
    };

    static Char _decompositionMapping0000F9FE[] = 
    {
        0x00008336
    };

    static _CharacterInfo _character0000F9FE =
    {
        0x0000F9FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FE,
        0x0000F9FE,
        0x0000F9FE
    };

    static Char _decompositionMapping0000F9FF[] = 
    {
        0x0000523A
    };

    static _CharacterInfo _character0000F9FF =
    {
        0x0000F9FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000F9FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000F9FF,
        0x0000F9FF,
        0x0000F9FF
    };

    static Char _decompositionMapping0000FA00[] = 
    {
        0x00005207
    };

    static _CharacterInfo _character0000FA00 =
    {
        0x0000FA00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA00,
        0x0000FA00,
        0x0000FA00
    };

    static Char _decompositionMapping0000FA01[] = 
    {
        0x00005EA6
    };

    static _CharacterInfo _character0000FA01 =
    {
        0x0000FA01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA01,
        0x0000FA01,
        0x0000FA01
    };

    static Char _decompositionMapping0000FA02[] = 
    {
        0x000062D3
    };

    static _CharacterInfo _character0000FA02 =
    {
        0x0000FA02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA02,
        0x0000FA02,
        0x0000FA02
    };

    static Char _decompositionMapping0000FA03[] = 
    {
        0x00007CD6
    };

    static _CharacterInfo _character0000FA03 =
    {
        0x0000FA03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA03,
        0x0000FA03,
        0x0000FA03
    };

    static Char _decompositionMapping0000FA04[] = 
    {
        0x00005B85
    };

    static _CharacterInfo _character0000FA04 =
    {
        0x0000FA04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA04,
        0x0000FA04,
        0x0000FA04
    };

    static Char _decompositionMapping0000FA05[] = 
    {
        0x00006D1E
    };

    static _CharacterInfo _character0000FA05 =
    {
        0x0000FA05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA05,
        0x0000FA05,
        0x0000FA05
    };

    static Char _decompositionMapping0000FA06[] = 
    {
        0x000066B4
    };

    static _CharacterInfo _character0000FA06 =
    {
        0x0000FA06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA06,
        0x0000FA06,
        0x0000FA06
    };

    static Char _decompositionMapping0000FA07[] = 
    {
        0x00008F3B
    };

    static _CharacterInfo _character0000FA07 =
    {
        0x0000FA07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA07,
        0x0000FA07,
        0x0000FA07
    };

    static Char _decompositionMapping0000FA08[] = 
    {
        0x0000884C
    };

    static _CharacterInfo _character0000FA08 =
    {
        0x0000FA08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA08,
        0x0000FA08,
        0x0000FA08
    };

    static Char _decompositionMapping0000FA09[] = 
    {
        0x0000964D
    };

    static _CharacterInfo _character0000FA09 =
    {
        0x0000FA09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA09,
        0x0000FA09,
        0x0000FA09
    };

    static Char _decompositionMapping0000FA0A[] = 
    {
        0x0000898B
    };

    static _CharacterInfo _character0000FA0A =
    {
        0x0000FA0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0A,
        0x0000FA0A,
        0x0000FA0A
    };

    static Char _decompositionMapping0000FA0B[] = 
    {
        0x00005ED3
    };

    static _CharacterInfo _character0000FA0B =
    {
        0x0000FA0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0B,
        0x0000FA0B,
        0x0000FA0B
    };

    static Char _decompositionMapping0000FA0C[] = 
    {
        0x00005140
    };

    static _CharacterInfo _character0000FA0C =
    {
        0x0000FA0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0C,
        0x0000FA0C,
        0x0000FA0C
    };

    static Char _decompositionMapping0000FA0D[] = 
    {
        0x000055C0
    };

    static _CharacterInfo _character0000FA0D =
    {
        0x0000FA0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0D,
        0x0000FA0D,
        0x0000FA0D
    };

    static _CharacterInfo _character0000FA0E =
    {
        0x0000FA0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0E,
        0x0000FA0E,
        0x0000FA0E
    };

    static _CharacterInfo _character0000FA0F =
    {
        0x0000FA0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA0F,
        0x0000FA0F,
        0x0000FA0F
    };

    static Char _decompositionMapping0000FA10[] = 
    {
        0x0000585A
    };

    static _CharacterInfo _character0000FA10 =
    {
        0x0000FA10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA10,
        0x0000FA10,
        0x0000FA10
    };

    static _CharacterInfo _character0000FA11 =
    {
        0x0000FA11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA11,
        0x0000FA11,
        0x0000FA11
    };

    static Char _decompositionMapping0000FA12[] = 
    {
        0x00006674
    };

    static _CharacterInfo _character0000FA12 =
    {
        0x0000FA12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA12,
        0x0000FA12,
        0x0000FA12
    };

    static _CharacterInfo _character0000FA13 =
    {
        0x0000FA13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA13,
        0x0000FA13,
        0x0000FA13
    };

    static _CharacterInfo _character0000FA14 =
    {
        0x0000FA14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA14,
        0x0000FA14,
        0x0000FA14
    };

    static Char _decompositionMapping0000FA15[] = 
    {
        0x000051DE
    };

    static _CharacterInfo _character0000FA15 =
    {
        0x0000FA15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA15,
        0x0000FA15,
        0x0000FA15
    };

    static Char _decompositionMapping0000FA16[] = 
    {
        0x0000732A
    };

    static _CharacterInfo _character0000FA16 =
    {
        0x0000FA16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA16,
        0x0000FA16,
        0x0000FA16
    };

    static Char _decompositionMapping0000FA17[] = 
    {
        0x000076CA
    };

    static _CharacterInfo _character0000FA17 =
    {
        0x0000FA17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA17,
        0x0000FA17,
        0x0000FA17
    };

    static Char _decompositionMapping0000FA18[] = 
    {
        0x0000793C
    };

    static _CharacterInfo _character0000FA18 =
    {
        0x0000FA18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA18,
        0x0000FA18,
        0x0000FA18
    };

    static Char _decompositionMapping0000FA19[] = 
    {
        0x0000795E
    };

    static _CharacterInfo _character0000FA19 =
    {
        0x0000FA19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA19,
        0x0000FA19,
        0x0000FA19
    };

    static Char _decompositionMapping0000FA1A[] = 
    {
        0x00007965
    };

    static _CharacterInfo _character0000FA1A =
    {
        0x0000FA1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1A,
        0x0000FA1A,
        0x0000FA1A
    };

    static Char _decompositionMapping0000FA1B[] = 
    {
        0x0000798F
    };

    static _CharacterInfo _character0000FA1B =
    {
        0x0000FA1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1B,
        0x0000FA1B,
        0x0000FA1B
    };

    static Char _decompositionMapping0000FA1C[] = 
    {
        0x00009756
    };

    static _CharacterInfo _character0000FA1C =
    {
        0x0000FA1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1C,
        0x0000FA1C,
        0x0000FA1C
    };

    static Char _decompositionMapping0000FA1D[] = 
    {
        0x00007CBE
    };

    static _CharacterInfo _character0000FA1D =
    {
        0x0000FA1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1D,
        0x0000FA1D,
        0x0000FA1D
    };

    static Char _decompositionMapping0000FA1E[] = 
    {
        0x00007FBD
    };

    static _CharacterInfo _character0000FA1E =
    {
        0x0000FA1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1E,
        0x0000FA1E,
        0x0000FA1E
    };

    static _CharacterInfo _character0000FA1F =
    {
        0x0000FA1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA1F,
        0x0000FA1F,
        0x0000FA1F
    };

    static Char _decompositionMapping0000FA20[] = 
    {
        0x00008612
    };

    static _CharacterInfo _character0000FA20 =
    {
        0x0000FA20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA20,
        0x0000FA20,
        0x0000FA20
    };

    static _CharacterInfo _character0000FA21 =
    {
        0x0000FA21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA21,
        0x0000FA21,
        0x0000FA21
    };

    static Char _decompositionMapping0000FA22[] = 
    {
        0x00008AF8
    };

    static _CharacterInfo _character0000FA22 =
    {
        0x0000FA22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA22,
        0x0000FA22,
        0x0000FA22
    };

    static _CharacterInfo _character0000FA23 =
    {
        0x0000FA23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA23,
        0x0000FA23,
        0x0000FA23
    };

    static _CharacterInfo _character0000FA24 =
    {
        0x0000FA24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA24,
        0x0000FA24,
        0x0000FA24
    };

    static Char _decompositionMapping0000FA25[] = 
    {
        0x00009038
    };

    static _CharacterInfo _character0000FA25 =
    {
        0x0000FA25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA25,
        0x0000FA25,
        0x0000FA25
    };

    static Char _decompositionMapping0000FA26[] = 
    {
        0x000090FD
    };

    static _CharacterInfo _character0000FA26 =
    {
        0x0000FA26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA26,
        0x0000FA26,
        0x0000FA26
    };

    static _CharacterInfo _character0000FA27 =
    {
        0x0000FA27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA27,
        0x0000FA27,
        0x0000FA27
    };

    static _CharacterInfo _character0000FA28 =
    {
        0x0000FA28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA28,
        0x0000FA28,
        0x0000FA28
    };

    static _CharacterInfo _character0000FA29 =
    {
        0x0000FA29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA29,
        0x0000FA29,
        0x0000FA29
    };

    static Char _decompositionMapping0000FA2A[] = 
    {
        0x000098EF
    };

    static _CharacterInfo _character0000FA2A =
    {
        0x0000FA2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA2A,
        0x0000FA2A,
        0x0000FA2A
    };

    static Char _decompositionMapping0000FA2B[] = 
    {
        0x000098FC
    };

    static _CharacterInfo _character0000FA2B =
    {
        0x0000FA2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA2B,
        0x0000FA2B,
        0x0000FA2B
    };

    static Char _decompositionMapping0000FA2C[] = 
    {
        0x00009928
    };

    static _CharacterInfo _character0000FA2C =
    {
        0x0000FA2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA2C,
        0x0000FA2C,
        0x0000FA2C
    };

    static Char _decompositionMapping0000FA2D[] = 
    {
        0x00009DB4
    };

    static _CharacterInfo _character0000FA2D =
    {
        0x0000FA2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA2D,
        0x0000FA2D,
        0x0000FA2D
    };

    static Char _decompositionMapping0000FA30[] = 
    {
        0x00004FAE
    };

    static _CharacterInfo _character0000FA30 =
    {
        0x0000FA30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA30,
        0x0000FA30,
        0x0000FA30
    };

    static Char _decompositionMapping0000FA31[] = 
    {
        0x000050E7
    };

    static _CharacterInfo _character0000FA31 =
    {
        0x0000FA31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA31,
        0x0000FA31,
        0x0000FA31
    };

    static Char _decompositionMapping0000FA32[] = 
    {
        0x0000514D
    };

    static _CharacterInfo _character0000FA32 =
    {
        0x0000FA32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA32,
        0x0000FA32,
        0x0000FA32
    };

    static Char _decompositionMapping0000FA33[] = 
    {
        0x000052C9
    };

    static _CharacterInfo _character0000FA33 =
    {
        0x0000FA33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA33,
        0x0000FA33,
        0x0000FA33
    };

    static Char _decompositionMapping0000FA34[] = 
    {
        0x000052E4
    };

    static _CharacterInfo _character0000FA34 =
    {
        0x0000FA34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA34,
        0x0000FA34,
        0x0000FA34
    };

    static Char _decompositionMapping0000FA35[] = 
    {
        0x00005351
    };

    static _CharacterInfo _character0000FA35 =
    {
        0x0000FA35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA35,
        0x0000FA35,
        0x0000FA35
    };

    static Char _decompositionMapping0000FA36[] = 
    {
        0x0000559D
    };

    static _CharacterInfo _character0000FA36 =
    {
        0x0000FA36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA36,
        0x0000FA36,
        0x0000FA36
    };

    static Char _decompositionMapping0000FA37[] = 
    {
        0x00005606
    };

    static _CharacterInfo _character0000FA37 =
    {
        0x0000FA37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA37,
        0x0000FA37,
        0x0000FA37
    };

    static Char _decompositionMapping0000FA38[] = 
    {
        0x00005668
    };

    static _CharacterInfo _character0000FA38 =
    {
        0x0000FA38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA38,
        0x0000FA38,
        0x0000FA38
    };

    static Char _decompositionMapping0000FA39[] = 
    {
        0x00005840
    };

    static _CharacterInfo _character0000FA39 =
    {
        0x0000FA39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA39,
        0x0000FA39,
        0x0000FA39
    };

    static Char _decompositionMapping0000FA3A[] = 
    {
        0x000058A8
    };

    static _CharacterInfo _character0000FA3A =
    {
        0x0000FA3A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3A,
        0x0000FA3A,
        0x0000FA3A
    };

    static Char _decompositionMapping0000FA3B[] = 
    {
        0x00005C64
    };

    static _CharacterInfo _character0000FA3B =
    {
        0x0000FA3B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3B,
        0x0000FA3B,
        0x0000FA3B
    };

    static Char _decompositionMapping0000FA3C[] = 
    {
        0x00005C6E
    };

    static _CharacterInfo _character0000FA3C =
    {
        0x0000FA3C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3C,
        0x0000FA3C,
        0x0000FA3C
    };

    static Char _decompositionMapping0000FA3D[] = 
    {
        0x00006094
    };

    static _CharacterInfo _character0000FA3D =
    {
        0x0000FA3D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3D,
        0x0000FA3D,
        0x0000FA3D
    };

    static Char _decompositionMapping0000FA3E[] = 
    {
        0x00006168
    };

    static _CharacterInfo _character0000FA3E =
    {
        0x0000FA3E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3E,
        0x0000FA3E,
        0x0000FA3E
    };

    static Char _decompositionMapping0000FA3F[] = 
    {
        0x0000618E
    };

    static _CharacterInfo _character0000FA3F =
    {
        0x0000FA3F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA3F,
        0x0000FA3F,
        0x0000FA3F
    };

    static Char _decompositionMapping0000FA40[] = 
    {
        0x000061F2
    };

    static _CharacterInfo _character0000FA40 =
    {
        0x0000FA40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA40,
        0x0000FA40,
        0x0000FA40
    };

    static Char _decompositionMapping0000FA41[] = 
    {
        0x0000654F
    };

    static _CharacterInfo _character0000FA41 =
    {
        0x0000FA41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA41,
        0x0000FA41,
        0x0000FA41
    };

    static Char _decompositionMapping0000FA42[] = 
    {
        0x000065E2
    };

    static _CharacterInfo _character0000FA42 =
    {
        0x0000FA42,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA42,
        0x0000FA42,
        0x0000FA42
    };

    static Char _decompositionMapping0000FA43[] = 
    {
        0x00006691
    };

    static _CharacterInfo _character0000FA43 =
    {
        0x0000FA43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA43,
        0x0000FA43,
        0x0000FA43
    };

    static Char _decompositionMapping0000FA44[] = 
    {
        0x00006885
    };

    static _CharacterInfo _character0000FA44 =
    {
        0x0000FA44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA44,
        0x0000FA44,
        0x0000FA44
    };

    static Char _decompositionMapping0000FA45[] = 
    {
        0x00006D77
    };

    static _CharacterInfo _character0000FA45 =
    {
        0x0000FA45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA45,
        0x0000FA45,
        0x0000FA45
    };

    static Char _decompositionMapping0000FA46[] = 
    {
        0x00006E1A
    };

    static _CharacterInfo _character0000FA46 =
    {
        0x0000FA46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA46,
        0x0000FA46,
        0x0000FA46
    };

    static Char _decompositionMapping0000FA47[] = 
    {
        0x00006F22
    };

    static _CharacterInfo _character0000FA47 =
    {
        0x0000FA47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA47,
        0x0000FA47,
        0x0000FA47
    };

    static Char _decompositionMapping0000FA48[] = 
    {
        0x0000716E
    };

    static _CharacterInfo _character0000FA48 =
    {
        0x0000FA48,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA48,
        0x0000FA48,
        0x0000FA48
    };

    static Char _decompositionMapping0000FA49[] = 
    {
        0x0000722B
    };

    static _CharacterInfo _character0000FA49 =
    {
        0x0000FA49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA49,
        0x0000FA49,
        0x0000FA49
    };

    static Char _decompositionMapping0000FA4A[] = 
    {
        0x00007422
    };

    static _CharacterInfo _character0000FA4A =
    {
        0x0000FA4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4A,
        0x0000FA4A,
        0x0000FA4A
    };

    static Char _decompositionMapping0000FA4B[] = 
    {
        0x00007891
    };

    static _CharacterInfo _character0000FA4B =
    {
        0x0000FA4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4B,
        0x0000FA4B,
        0x0000FA4B
    };

    static Char _decompositionMapping0000FA4C[] = 
    {
        0x0000793E
    };

    static _CharacterInfo _character0000FA4C =
    {
        0x0000FA4C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4C,
        0x0000FA4C,
        0x0000FA4C
    };

    static Char _decompositionMapping0000FA4D[] = 
    {
        0x00007949
    };

    static _CharacterInfo _character0000FA4D =
    {
        0x0000FA4D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4D,
        0x0000FA4D,
        0x0000FA4D
    };

    static Char _decompositionMapping0000FA4E[] = 
    {
        0x00007948
    };

    static _CharacterInfo _character0000FA4E =
    {
        0x0000FA4E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4E,
        0x0000FA4E,
        0x0000FA4E
    };

    static Char _decompositionMapping0000FA4F[] = 
    {
        0x00007950
    };

    static _CharacterInfo _character0000FA4F =
    {
        0x0000FA4F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA4F,
        0x0000FA4F,
        0x0000FA4F
    };

    static Char _decompositionMapping0000FA50[] = 
    {
        0x00007956
    };

    static _CharacterInfo _character0000FA50 =
    {
        0x0000FA50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA50,
        0x0000FA50,
        0x0000FA50
    };

    static Char _decompositionMapping0000FA51[] = 
    {
        0x0000795D
    };

    static _CharacterInfo _character0000FA51 =
    {
        0x0000FA51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA51,
        0x0000FA51,
        0x0000FA51
    };

    static Char _decompositionMapping0000FA52[] = 
    {
        0x0000798D
    };

    static _CharacterInfo _character0000FA52 =
    {
        0x0000FA52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA52,
        0x0000FA52,
        0x0000FA52
    };

    static Char _decompositionMapping0000FA53[] = 
    {
        0x0000798E
    };

    static _CharacterInfo _character0000FA53 =
    {
        0x0000FA53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA53,
        0x0000FA53,
        0x0000FA53
    };

    static Char _decompositionMapping0000FA54[] = 
    {
        0x00007A40
    };

    static _CharacterInfo _character0000FA54 =
    {
        0x0000FA54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA54,
        0x0000FA54,
        0x0000FA54
    };

    static Char _decompositionMapping0000FA55[] = 
    {
        0x00007A81
    };

    static _CharacterInfo _character0000FA55 =
    {
        0x0000FA55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA55,
        0x0000FA55,
        0x0000FA55
    };

    static Char _decompositionMapping0000FA56[] = 
    {
        0x00007BC0
    };

    static _CharacterInfo _character0000FA56 =
    {
        0x0000FA56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA56,
        0x0000FA56,
        0x0000FA56
    };

    static Char _decompositionMapping0000FA57[] = 
    {
        0x00007DF4
    };

    static _CharacterInfo _character0000FA57 =
    {
        0x0000FA57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA57,
        0x0000FA57,
        0x0000FA57
    };

    static Char _decompositionMapping0000FA58[] = 
    {
        0x00007E09
    };

    static _CharacterInfo _character0000FA58 =
    {
        0x0000FA58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA58,
        0x0000FA58,
        0x0000FA58
    };

    static Char _decompositionMapping0000FA59[] = 
    {
        0x00007E41
    };

    static _CharacterInfo _character0000FA59 =
    {
        0x0000FA59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA59,
        0x0000FA59,
        0x0000FA59
    };

    static Char _decompositionMapping0000FA5A[] = 
    {
        0x00007F72
    };

    static _CharacterInfo _character0000FA5A =
    {
        0x0000FA5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5A,
        0x0000FA5A,
        0x0000FA5A
    };

    static Char _decompositionMapping0000FA5B[] = 
    {
        0x00008005
    };

    static _CharacterInfo _character0000FA5B =
    {
        0x0000FA5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5B,
        0x0000FA5B,
        0x0000FA5B
    };

    static Char _decompositionMapping0000FA5C[] = 
    {
        0x000081ED
    };

    static _CharacterInfo _character0000FA5C =
    {
        0x0000FA5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5C,
        0x0000FA5C,
        0x0000FA5C
    };

    static Char _decompositionMapping0000FA5D[] = 
    {
        0x00008279
    };

    static _CharacterInfo _character0000FA5D =
    {
        0x0000FA5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5D,
        0x0000FA5D,
        0x0000FA5D
    };

    static Char _decompositionMapping0000FA5E[] = 
    {
        0x00008279
    };

    static _CharacterInfo _character0000FA5E =
    {
        0x0000FA5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5E,
        0x0000FA5E,
        0x0000FA5E
    };

    static Char _decompositionMapping0000FA5F[] = 
    {
        0x00008457
    };

    static _CharacterInfo _character0000FA5F =
    {
        0x0000FA5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA5F,
        0x0000FA5F,
        0x0000FA5F
    };

    static Char _decompositionMapping0000FA60[] = 
    {
        0x00008910
    };

    static _CharacterInfo _character0000FA60 =
    {
        0x0000FA60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA60,
        0x0000FA60,
        0x0000FA60
    };

    static Char _decompositionMapping0000FA61[] = 
    {
        0x00008996
    };

    static _CharacterInfo _character0000FA61 =
    {
        0x0000FA61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA61,
        0x0000FA61,
        0x0000FA61
    };

    static Char _decompositionMapping0000FA62[] = 
    {
        0x00008B01
    };

    static _CharacterInfo _character0000FA62 =
    {
        0x0000FA62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA62,
        0x0000FA62,
        0x0000FA62
    };

    static Char _decompositionMapping0000FA63[] = 
    {
        0x00008B39
    };

    static _CharacterInfo _character0000FA63 =
    {
        0x0000FA63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA63,
        0x0000FA63,
        0x0000FA63
    };

    static Char _decompositionMapping0000FA64[] = 
    {
        0x00008CD3
    };

    static _CharacterInfo _character0000FA64 =
    {
        0x0000FA64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA64,
        0x0000FA64,
        0x0000FA64
    };

    static Char _decompositionMapping0000FA65[] = 
    {
        0x00008D08
    };

    static _CharacterInfo _character0000FA65 =
    {
        0x0000FA65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA65,
        0x0000FA65,
        0x0000FA65
    };

    static Char _decompositionMapping0000FA66[] = 
    {
        0x00008FB6
    };

    static _CharacterInfo _character0000FA66 =
    {
        0x0000FA66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA66,
        0x0000FA66,
        0x0000FA66
    };

    static Char _decompositionMapping0000FA67[] = 
    {
        0x00009038
    };

    static _CharacterInfo _character0000FA67 =
    {
        0x0000FA67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA67,
        0x0000FA67,
        0x0000FA67
    };

    static Char _decompositionMapping0000FA68[] = 
    {
        0x000096E3
    };

    static _CharacterInfo _character0000FA68 =
    {
        0x0000FA68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA68,
        0x0000FA68,
        0x0000FA68
    };

    static Char _decompositionMapping0000FA69[] = 
    {
        0x000097FF
    };

    static _CharacterInfo _character0000FA69 =
    {
        0x0000FA69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA69,
        0x0000FA69,
        0x0000FA69
    };

    static Char _decompositionMapping0000FA6A[] = 
    {
        0x0000983B
    };

    static _CharacterInfo _character0000FA6A =
    {
        0x0000FA6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA6A,
        0x0000FA6A,
        0x0000FA6A
    };

    static Char _decompositionMapping0000FA70[] = 
    {
        0x00004E26
    };

    static _CharacterInfo _character0000FA70 =
    {
        0x0000FA70,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA70,
        0x0000FA70,
        0x0000FA70
    };

    static Char _decompositionMapping0000FA71[] = 
    {
        0x000051B5
    };

    static _CharacterInfo _character0000FA71 =
    {
        0x0000FA71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA71,
        0x0000FA71,
        0x0000FA71
    };

    static Char _decompositionMapping0000FA72[] = 
    {
        0x00005168
    };

    static _CharacterInfo _character0000FA72 =
    {
        0x0000FA72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA72,
        0x0000FA72,
        0x0000FA72
    };

    static Char _decompositionMapping0000FA73[] = 
    {
        0x00004F80
    };

    static _CharacterInfo _character0000FA73 =
    {
        0x0000FA73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA73,
        0x0000FA73,
        0x0000FA73
    };

    static Char _decompositionMapping0000FA74[] = 
    {
        0x00005145
    };

    static _CharacterInfo _character0000FA74 =
    {
        0x0000FA74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA74,
        0x0000FA74,
        0x0000FA74
    };

    static Char _decompositionMapping0000FA75[] = 
    {
        0x00005180
    };

    static _CharacterInfo _character0000FA75 =
    {
        0x0000FA75,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA75,
        0x0000FA75,
        0x0000FA75
    };

    static Char _decompositionMapping0000FA76[] = 
    {
        0x000052C7
    };

    static _CharacterInfo _character0000FA76 =
    {
        0x0000FA76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA76,
        0x0000FA76,
        0x0000FA76
    };

    static Char _decompositionMapping0000FA77[] = 
    {
        0x000052FA
    };

    static _CharacterInfo _character0000FA77 =
    {
        0x0000FA77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA77,
        0x0000FA77,
        0x0000FA77
    };

    static Char _decompositionMapping0000FA78[] = 
    {
        0x0000559D
    };

    static _CharacterInfo _character0000FA78 =
    {
        0x0000FA78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA78,
        0x0000FA78,
        0x0000FA78
    };

    static Char _decompositionMapping0000FA79[] = 
    {
        0x00005555
    };

    static _CharacterInfo _character0000FA79 =
    {
        0x0000FA79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA79,
        0x0000FA79,
        0x0000FA79
    };

    static Char _decompositionMapping0000FA7A[] = 
    {
        0x00005599
    };

    static _CharacterInfo _character0000FA7A =
    {
        0x0000FA7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7A,
        0x0000FA7A,
        0x0000FA7A
    };

    static Char _decompositionMapping0000FA7B[] = 
    {
        0x000055E2
    };

    static _CharacterInfo _character0000FA7B =
    {
        0x0000FA7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7B,
        0x0000FA7B,
        0x0000FA7B
    };

    static Char _decompositionMapping0000FA7C[] = 
    {
        0x0000585A
    };

    static _CharacterInfo _character0000FA7C =
    {
        0x0000FA7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7C,
        0x0000FA7C,
        0x0000FA7C
    };

    static Char _decompositionMapping0000FA7D[] = 
    {
        0x000058B3
    };

    static _CharacterInfo _character0000FA7D =
    {
        0x0000FA7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7D,
        0x0000FA7D,
        0x0000FA7D
    };

    static Char _decompositionMapping0000FA7E[] = 
    {
        0x00005944
    };

    static _CharacterInfo _character0000FA7E =
    {
        0x0000FA7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7E,
        0x0000FA7E,
        0x0000FA7E
    };

    static Char _decompositionMapping0000FA7F[] = 
    {
        0x00005954
    };

    static _CharacterInfo _character0000FA7F =
    {
        0x0000FA7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA7F,
        0x0000FA7F,
        0x0000FA7F
    };

    static Char _decompositionMapping0000FA80[] = 
    {
        0x00005A62
    };

    static _CharacterInfo _character0000FA80 =
    {
        0x0000FA80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA80,
        0x0000FA80,
        0x0000FA80
    };

    static Char _decompositionMapping0000FA81[] = 
    {
        0x00005B28
    };

    static _CharacterInfo _character0000FA81 =
    {
        0x0000FA81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA81,
        0x0000FA81,
        0x0000FA81
    };

    static Char _decompositionMapping0000FA82[] = 
    {
        0x00005ED2
    };

    static _CharacterInfo _character0000FA82 =
    {
        0x0000FA82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA82,
        0x0000FA82,
        0x0000FA82
    };

    static Char _decompositionMapping0000FA83[] = 
    {
        0x00005ED9
    };

    static _CharacterInfo _character0000FA83 =
    {
        0x0000FA83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA83,
        0x0000FA83,
        0x0000FA83
    };

    static Char _decompositionMapping0000FA84[] = 
    {
        0x00005F69
    };

    static _CharacterInfo _character0000FA84 =
    {
        0x0000FA84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA84,
        0x0000FA84,
        0x0000FA84
    };

    static Char _decompositionMapping0000FA85[] = 
    {
        0x00005FAD
    };

    static _CharacterInfo _character0000FA85 =
    {
        0x0000FA85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA85,
        0x0000FA85,
        0x0000FA85
    };

    static Char _decompositionMapping0000FA86[] = 
    {
        0x000060D8
    };

    static _CharacterInfo _character0000FA86 =
    {
        0x0000FA86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA86,
        0x0000FA86,
        0x0000FA86
    };

    static Char _decompositionMapping0000FA87[] = 
    {
        0x0000614E
    };

    static _CharacterInfo _character0000FA87 =
    {
        0x0000FA87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA87,
        0x0000FA87,
        0x0000FA87
    };

    static Char _decompositionMapping0000FA88[] = 
    {
        0x00006108
    };

    static _CharacterInfo _character0000FA88 =
    {
        0x0000FA88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA88,
        0x0000FA88,
        0x0000FA88
    };

    static Char _decompositionMapping0000FA89[] = 
    {
        0x0000618E
    };

    static _CharacterInfo _character0000FA89 =
    {
        0x0000FA89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA89,
        0x0000FA89,
        0x0000FA89
    };

    static Char _decompositionMapping0000FA8A[] = 
    {
        0x00006160
    };

    static _CharacterInfo _character0000FA8A =
    {
        0x0000FA8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8A,
        0x0000FA8A,
        0x0000FA8A
    };

    static Char _decompositionMapping0000FA8B[] = 
    {
        0x000061F2
    };

    static _CharacterInfo _character0000FA8B =
    {
        0x0000FA8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8B,
        0x0000FA8B,
        0x0000FA8B
    };

    static Char _decompositionMapping0000FA8C[] = 
    {
        0x00006234
    };

    static _CharacterInfo _character0000FA8C =
    {
        0x0000FA8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8C,
        0x0000FA8C,
        0x0000FA8C
    };

    static Char _decompositionMapping0000FA8D[] = 
    {
        0x000063C4
    };

    static _CharacterInfo _character0000FA8D =
    {
        0x0000FA8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8D,
        0x0000FA8D,
        0x0000FA8D
    };

    static Char _decompositionMapping0000FA8E[] = 
    {
        0x0000641C
    };

    static _CharacterInfo _character0000FA8E =
    {
        0x0000FA8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8E,
        0x0000FA8E,
        0x0000FA8E
    };

    static Char _decompositionMapping0000FA8F[] = 
    {
        0x00006452
    };

    static _CharacterInfo _character0000FA8F =
    {
        0x0000FA8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA8F,
        0x0000FA8F,
        0x0000FA8F
    };

    static Char _decompositionMapping0000FA90[] = 
    {
        0x00006556
    };

    static _CharacterInfo _character0000FA90 =
    {
        0x0000FA90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA90,
        0x0000FA90,
        0x0000FA90
    };

    static Char _decompositionMapping0000FA91[] = 
    {
        0x00006674
    };

    static _CharacterInfo _character0000FA91 =
    {
        0x0000FA91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA91,
        0x0000FA91,
        0x0000FA91
    };

    static Char _decompositionMapping0000FA92[] = 
    {
        0x00006717
    };

    static _CharacterInfo _character0000FA92 =
    {
        0x0000FA92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA92,
        0x0000FA92,
        0x0000FA92
    };

    static Char _decompositionMapping0000FA93[] = 
    {
        0x0000671B
    };

    static _CharacterInfo _character0000FA93 =
    {
        0x0000FA93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA93,
        0x0000FA93,
        0x0000FA93
    };

    static Char _decompositionMapping0000FA94[] = 
    {
        0x00006756
    };

    static _CharacterInfo _character0000FA94 =
    {
        0x0000FA94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA94,
        0x0000FA94,
        0x0000FA94
    };

    static Char _decompositionMapping0000FA95[] = 
    {
        0x00006B79
    };

    static _CharacterInfo _character0000FA95 =
    {
        0x0000FA95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA95,
        0x0000FA95,
        0x0000FA95
    };

    static Char _decompositionMapping0000FA96[] = 
    {
        0x00006BBA
    };

    static _CharacterInfo _character0000FA96 =
    {
        0x0000FA96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA96,
        0x0000FA96,
        0x0000FA96
    };

    static Char _decompositionMapping0000FA97[] = 
    {
        0x00006D41
    };

    static _CharacterInfo _character0000FA97 =
    {
        0x0000FA97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA97,
        0x0000FA97,
        0x0000FA97
    };

    static Char _decompositionMapping0000FA98[] = 
    {
        0x00006EDB
    };

    static _CharacterInfo _character0000FA98 =
    {
        0x0000FA98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA98,
        0x0000FA98,
        0x0000FA98
    };

    static Char _decompositionMapping0000FA99[] = 
    {
        0x00006ECB
    };

    static _CharacterInfo _character0000FA99 =
    {
        0x0000FA99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA99,
        0x0000FA99,
        0x0000FA99
    };

    static Char _decompositionMapping0000FA9A[] = 
    {
        0x00006F22
    };

    static _CharacterInfo _character0000FA9A =
    {
        0x0000FA9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9A,
        0x0000FA9A,
        0x0000FA9A
    };

    static Char _decompositionMapping0000FA9B[] = 
    {
        0x0000701E
    };

    static _CharacterInfo _character0000FA9B =
    {
        0x0000FA9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9B,
        0x0000FA9B,
        0x0000FA9B
    };

    static Char _decompositionMapping0000FA9C[] = 
    {
        0x0000716E
    };

    static _CharacterInfo _character0000FA9C =
    {
        0x0000FA9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9C,
        0x0000FA9C,
        0x0000FA9C
    };

    static Char _decompositionMapping0000FA9D[] = 
    {
        0x000077A7
    };

    static _CharacterInfo _character0000FA9D =
    {
        0x0000FA9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9D,
        0x0000FA9D,
        0x0000FA9D
    };

    static Char _decompositionMapping0000FA9E[] = 
    {
        0x00007235
    };

    static _CharacterInfo _character0000FA9E =
    {
        0x0000FA9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9E,
        0x0000FA9E,
        0x0000FA9E
    };

    static Char _decompositionMapping0000FA9F[] = 
    {
        0x000072AF
    };

    static _CharacterInfo _character0000FA9F =
    {
        0x0000FA9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FA9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FA9F,
        0x0000FA9F,
        0x0000FA9F
    };

    static Char _decompositionMapping0000FAA0[] = 
    {
        0x0000732A
    };

    static _CharacterInfo _character0000FAA0 =
    {
        0x0000FAA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA0,
        0x0000FAA0,
        0x0000FAA0
    };

    static Char _decompositionMapping0000FAA1[] = 
    {
        0x00007471
    };

    static _CharacterInfo _character0000FAA1 =
    {
        0x0000FAA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA1,
        0x0000FAA1,
        0x0000FAA1
    };

    static Char _decompositionMapping0000FAA2[] = 
    {
        0x00007506
    };

    static _CharacterInfo _character0000FAA2 =
    {
        0x0000FAA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA2,
        0x0000FAA2,
        0x0000FAA2
    };

    static Char _decompositionMapping0000FAA3[] = 
    {
        0x0000753B
    };

    static _CharacterInfo _character0000FAA3 =
    {
        0x0000FAA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA3,
        0x0000FAA3,
        0x0000FAA3
    };

    static Char _decompositionMapping0000FAA4[] = 
    {
        0x0000761D
    };

    static _CharacterInfo _character0000FAA4 =
    {
        0x0000FAA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA4,
        0x0000FAA4,
        0x0000FAA4
    };

    static Char _decompositionMapping0000FAA5[] = 
    {
        0x0000761F
    };

    static _CharacterInfo _character0000FAA5 =
    {
        0x0000FAA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA5,
        0x0000FAA5,
        0x0000FAA5
    };

    static Char _decompositionMapping0000FAA6[] = 
    {
        0x000076CA
    };

    static _CharacterInfo _character0000FAA6 =
    {
        0x0000FAA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA6,
        0x0000FAA6,
        0x0000FAA6
    };

    static Char _decompositionMapping0000FAA7[] = 
    {
        0x000076DB
    };

    static _CharacterInfo _character0000FAA7 =
    {
        0x0000FAA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA7,
        0x0000FAA7,
        0x0000FAA7
    };

    static Char _decompositionMapping0000FAA8[] = 
    {
        0x000076F4
    };

    static _CharacterInfo _character0000FAA8 =
    {
        0x0000FAA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA8,
        0x0000FAA8,
        0x0000FAA8
    };

    static Char _decompositionMapping0000FAA9[] = 
    {
        0x0000774A
    };

    static _CharacterInfo _character0000FAA9 =
    {
        0x0000FAA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAA9,
        0x0000FAA9,
        0x0000FAA9
    };

    static Char _decompositionMapping0000FAAA[] = 
    {
        0x00007740
    };

    static _CharacterInfo _character0000FAAA =
    {
        0x0000FAAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAA,
        0x0000FAAA,
        0x0000FAAA
    };

    static Char _decompositionMapping0000FAAB[] = 
    {
        0x000078CC
    };

    static _CharacterInfo _character0000FAAB =
    {
        0x0000FAAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAB,
        0x0000FAAB,
        0x0000FAAB
    };

    static Char _decompositionMapping0000FAAC[] = 
    {
        0x00007AB1
    };

    static _CharacterInfo _character0000FAAC =
    {
        0x0000FAAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAC,
        0x0000FAAC,
        0x0000FAAC
    };

    static Char _decompositionMapping0000FAAD[] = 
    {
        0x00007BC0
    };

    static _CharacterInfo _character0000FAAD =
    {
        0x0000FAAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAD,
        0x0000FAAD,
        0x0000FAAD
    };

    static Char _decompositionMapping0000FAAE[] = 
    {
        0x00007C7B
    };

    static _CharacterInfo _character0000FAAE =
    {
        0x0000FAAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAE,
        0x0000FAAE,
        0x0000FAAE
    };

    static Char _decompositionMapping0000FAAF[] = 
    {
        0x00007D5B
    };

    static _CharacterInfo _character0000FAAF =
    {
        0x0000FAAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAAF,
        0x0000FAAF,
        0x0000FAAF
    };

    static Char _decompositionMapping0000FAB0[] = 
    {
        0x00007DF4
    };

    static _CharacterInfo _character0000FAB0 =
    {
        0x0000FAB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB0,
        0x0000FAB0,
        0x0000FAB0
    };

    static Char _decompositionMapping0000FAB1[] = 
    {
        0x00007F3E
    };

    static _CharacterInfo _character0000FAB1 =
    {
        0x0000FAB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB1,
        0x0000FAB1,
        0x0000FAB1
    };

    static Char _decompositionMapping0000FAB2[] = 
    {
        0x00008005
    };

    static _CharacterInfo _character0000FAB2 =
    {
        0x0000FAB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB2,
        0x0000FAB2,
        0x0000FAB2
    };

    static Char _decompositionMapping0000FAB3[] = 
    {
        0x00008352
    };

    static _CharacterInfo _character0000FAB3 =
    {
        0x0000FAB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB3,
        0x0000FAB3,
        0x0000FAB3
    };

    static Char _decompositionMapping0000FAB4[] = 
    {
        0x000083EF
    };

    static _CharacterInfo _character0000FAB4 =
    {
        0x0000FAB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB4,
        0x0000FAB4,
        0x0000FAB4
    };

    static Char _decompositionMapping0000FAB5[] = 
    {
        0x00008779
    };

    static _CharacterInfo _character0000FAB5 =
    {
        0x0000FAB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB5,
        0x0000FAB5,
        0x0000FAB5
    };

    static Char _decompositionMapping0000FAB6[] = 
    {
        0x00008941
    };

    static _CharacterInfo _character0000FAB6 =
    {
        0x0000FAB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB6,
        0x0000FAB6,
        0x0000FAB6
    };

    static Char _decompositionMapping0000FAB7[] = 
    {
        0x00008986
    };

    static _CharacterInfo _character0000FAB7 =
    {
        0x0000FAB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB7,
        0x0000FAB7,
        0x0000FAB7
    };

    static Char _decompositionMapping0000FAB8[] = 
    {
        0x00008996
    };

    static _CharacterInfo _character0000FAB8 =
    {
        0x0000FAB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB8,
        0x0000FAB8,
        0x0000FAB8
    };

    static Char _decompositionMapping0000FAB9[] = 
    {
        0x00008ABF
    };

    static _CharacterInfo _character0000FAB9 =
    {
        0x0000FAB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAB9,
        0x0000FAB9,
        0x0000FAB9
    };

    static Char _decompositionMapping0000FABA[] = 
    {
        0x00008AF8
    };

    static _CharacterInfo _character0000FABA =
    {
        0x0000FABA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABA,
        0x0000FABA,
        0x0000FABA
    };

    static Char _decompositionMapping0000FABB[] = 
    {
        0x00008ACB
    };

    static _CharacterInfo _character0000FABB =
    {
        0x0000FABB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABB,
        0x0000FABB,
        0x0000FABB
    };

    static Char _decompositionMapping0000FABC[] = 
    {
        0x00008B01
    };

    static _CharacterInfo _character0000FABC =
    {
        0x0000FABC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABC,
        0x0000FABC,
        0x0000FABC
    };

    static Char _decompositionMapping0000FABD[] = 
    {
        0x00008AFE
    };

    static _CharacterInfo _character0000FABD =
    {
        0x0000FABD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABD,
        0x0000FABD,
        0x0000FABD
    };

    static Char _decompositionMapping0000FABE[] = 
    {
        0x00008AED
    };

    static _CharacterInfo _character0000FABE =
    {
        0x0000FABE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABE,
        0x0000FABE,
        0x0000FABE
    };

    static Char _decompositionMapping0000FABF[] = 
    {
        0x00008B39
    };

    static _CharacterInfo _character0000FABF =
    {
        0x0000FABF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FABF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FABF,
        0x0000FABF,
        0x0000FABF
    };

    static Char _decompositionMapping0000FAC0[] = 
    {
        0x00008B8A
    };

    static _CharacterInfo _character0000FAC0 =
    {
        0x0000FAC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC0,
        0x0000FAC0,
        0x0000FAC0
    };

    static Char _decompositionMapping0000FAC1[] = 
    {
        0x00008D08
    };

    static _CharacterInfo _character0000FAC1 =
    {
        0x0000FAC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC1,
        0x0000FAC1,
        0x0000FAC1
    };

    static Char _decompositionMapping0000FAC2[] = 
    {
        0x00008F38
    };

    static _CharacterInfo _character0000FAC2 =
    {
        0x0000FAC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC2,
        0x0000FAC2,
        0x0000FAC2
    };

    static Char _decompositionMapping0000FAC3[] = 
    {
        0x00009072
    };

    static _CharacterInfo _character0000FAC3 =
    {
        0x0000FAC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC3,
        0x0000FAC3,
        0x0000FAC3
    };

    static Char _decompositionMapping0000FAC4[] = 
    {
        0x00009199
    };

    static _CharacterInfo _character0000FAC4 =
    {
        0x0000FAC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC4,
        0x0000FAC4,
        0x0000FAC4
    };

    static Char _decompositionMapping0000FAC5[] = 
    {
        0x00009276
    };

    static _CharacterInfo _character0000FAC5 =
    {
        0x0000FAC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC5,
        0x0000FAC5,
        0x0000FAC5
    };

    static Char _decompositionMapping0000FAC6[] = 
    {
        0x0000967C
    };

    static _CharacterInfo _character0000FAC6 =
    {
        0x0000FAC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC6,
        0x0000FAC6,
        0x0000FAC6
    };

    static Char _decompositionMapping0000FAC7[] = 
    {
        0x000096E3
    };

    static _CharacterInfo _character0000FAC7 =
    {
        0x0000FAC7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC7,
        0x0000FAC7,
        0x0000FAC7
    };

    static Char _decompositionMapping0000FAC8[] = 
    {
        0x00009756
    };

    static _CharacterInfo _character0000FAC8 =
    {
        0x0000FAC8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC8,
        0x0000FAC8,
        0x0000FAC8
    };

    static Char _decompositionMapping0000FAC9[] = 
    {
        0x000097DB
    };

    static _CharacterInfo _character0000FAC9 =
    {
        0x0000FAC9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAC9,
        0x0000FAC9,
        0x0000FAC9
    };

    static Char _decompositionMapping0000FACA[] = 
    {
        0x000097FF
    };

    static _CharacterInfo _character0000FACA =
    {
        0x0000FACA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACA,
        0x0000FACA,
        0x0000FACA
    };

    static Char _decompositionMapping0000FACB[] = 
    {
        0x0000980B
    };

    static _CharacterInfo _character0000FACB =
    {
        0x0000FACB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACB,
        0x0000FACB,
        0x0000FACB
    };

    static Char _decompositionMapping0000FACC[] = 
    {
        0x0000983B
    };

    static _CharacterInfo _character0000FACC =
    {
        0x0000FACC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACC,
        0x0000FACC,
        0x0000FACC
    };

    static Char _decompositionMapping0000FACD[] = 
    {
        0x00009B12
    };

    static _CharacterInfo _character0000FACD =
    {
        0x0000FACD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACD,
        0x0000FACD,
        0x0000FACD
    };

    static Char _decompositionMapping0000FACE[] = 
    {
        0x00009F9C
    };

    static _CharacterInfo _character0000FACE =
    {
        0x0000FACE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACE,
        0x0000FACE,
        0x0000FACE
    };

    static Char _decompositionMapping0000FACF[] = 
    {
        0x0002284A
    };

    static _CharacterInfo _character0000FACF =
    {
        0x0000FACF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FACF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FACF,
        0x0000FACF,
        0x0000FACF
    };

    static Char _decompositionMapping0000FAD0[] = 
    {
        0x00022844
    };

    static _CharacterInfo _character0000FAD0 =
    {
        0x0000FAD0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD0,
        0x0000FAD0,
        0x0000FAD0
    };

    static Char _decompositionMapping0000FAD1[] = 
    {
        0x000233D5
    };

    static _CharacterInfo _character0000FAD1 =
    {
        0x0000FAD1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD1,
        0x0000FAD1,
        0x0000FAD1
    };

    static Char _decompositionMapping0000FAD2[] = 
    {
        0x00003B9D
    };

    static _CharacterInfo _character0000FAD2 =
    {
        0x0000FAD2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD2,
        0x0000FAD2,
        0x0000FAD2
    };

    static Char _decompositionMapping0000FAD3[] = 
    {
        0x00004018
    };

    static _CharacterInfo _character0000FAD3 =
    {
        0x0000FAD3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD3,
        0x0000FAD3,
        0x0000FAD3
    };

    static Char _decompositionMapping0000FAD4[] = 
    {
        0x00004039
    };

    static _CharacterInfo _character0000FAD4 =
    {
        0x0000FAD4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD4,
        0x0000FAD4,
        0x0000FAD4
    };

    static Char _decompositionMapping0000FAD5[] = 
    {
        0x00025249
    };

    static _CharacterInfo _character0000FAD5 =
    {
        0x0000FAD5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD5,
        0x0000FAD5,
        0x0000FAD5
    };

    static Char _decompositionMapping0000FAD6[] = 
    {
        0x00025CD0
    };

    static _CharacterInfo _character0000FAD6 =
    {
        0x0000FAD6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD6,
        0x0000FAD6,
        0x0000FAD6
    };

    static Char _decompositionMapping0000FAD7[] = 
    {
        0x00027ED3
    };

    static _CharacterInfo _character0000FAD7 =
    {
        0x0000FAD7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD7,
        0x0000FAD7,
        0x0000FAD7
    };

    static Char _decompositionMapping0000FAD8[] = 
    {
        0x00009F43
    };

    static _CharacterInfo _character0000FAD8 =
    {
        0x0000FAD8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD8,
        0x0000FAD8,
        0x0000FAD8
    };

    static Char _decompositionMapping0000FAD9[] = 
    {
        0x00009F8E
    };

    static _CharacterInfo _character0000FAD9 =
    {
        0x0000FAD9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0000FAD9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FAD9,
        0x0000FAD9,
        0x0000FAD9
    };

    static Char _decompositionMapping0000FB00[] = 
    {
        0x00000066,
        0x00000066
    };

    static _CharacterInfo _character0000FB00 =
    {
        0x0000FB00,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB00,
        0x0000FB00,
        0x0000FB00
    };

    static Char _decompositionMapping0000FB01[] = 
    {
        0x00000066,
        0x00000069
    };

    static _CharacterInfo _character0000FB01 =
    {
        0x0000FB01,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB01,
        0x0000FB01,
        0x0000FB01
    };

    static Char _decompositionMapping0000FB02[] = 
    {
        0x00000066,
        0x0000006C
    };

    static _CharacterInfo _character0000FB02 =
    {
        0x0000FB02,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB02,
        0x0000FB02,
        0x0000FB02
    };

    static Char _decompositionMapping0000FB03[] = 
    {
        0x00000066,
        0x00000066,
        0x00000069
    };

    static _CharacterInfo _character0000FB03 =
    {
        0x0000FB03,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000FB03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB03,
        0x0000FB03,
        0x0000FB03
    };

    static Char _decompositionMapping0000FB04[] = 
    {
        0x00000066,
        0x00000066,
        0x0000006C
    };

    static _CharacterInfo _character0000FB04 =
    {
        0x0000FB04,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        3,
        _decompositionMapping0000FB04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB04,
        0x0000FB04,
        0x0000FB04
    };

    static Char _decompositionMapping0000FB05[] = 
    {
        0x0000017F,
        0x00000074
    };

    static _CharacterInfo _character0000FB05 =
    {
        0x0000FB05,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB05,
        0x0000FB05,
        0x0000FB05
    };

    static Char _decompositionMapping0000FB06[] = 
    {
        0x00000073,
        0x00000074
    };

    static _CharacterInfo _character0000FB06 =
    {
        0x0000FB06,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB06,
        0x0000FB06,
        0x0000FB06
    };

    static Char _decompositionMapping0000FB13[] = 
    {
        0x00000574,
        0x00000576
    };

    static _CharacterInfo _character0000FB13 =
    {
        0x0000FB13,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB13,
        0x0000FB13,
        0x0000FB13
    };

    static Char _decompositionMapping0000FB14[] = 
    {
        0x00000574,
        0x00000565
    };

    static _CharacterInfo _character0000FB14 =
    {
        0x0000FB14,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB14,
        0x0000FB14,
        0x0000FB14
    };

    static Char _decompositionMapping0000FB15[] = 
    {
        0x00000574,
        0x0000056B
    };

    static _CharacterInfo _character0000FB15 =
    {
        0x0000FB15,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB15,
        0x0000FB15,
        0x0000FB15
    };

    static Char _decompositionMapping0000FB16[] = 
    {
        0x0000057E,
        0x00000576
    };

    static _CharacterInfo _character0000FB16 =
    {
        0x0000FB16,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB16,
        0x0000FB16,
        0x0000FB16
    };

    static Char _decompositionMapping0000FB17[] = 
    {
        0x00000574,
        0x0000056D
    };

    static _CharacterInfo _character0000FB17 =
    {
        0x0000FB17,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB17,
        0x0000FB17,
        0x0000FB17
    };

    static Char _decompositionMapping0000FB1D[] = 
    {
        0x000005D9,
        0x000005B4
    };

    static _CharacterInfo _character0000FB1D =
    {
        0x0000FB1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB1D,
        0x0000FB1D,
        0x0000FB1D
    };

    static _CharacterInfo _character0000FB1E =
    {
        0x0000FB1E,
        Iso10646::GeneralCategory_Mn,
        26,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB1E,
        0x0000FB1E,
        0x0000FB1E
    };

    static Char _decompositionMapping0000FB1F[] = 
    {
        0x000005F2,
        0x000005B7
    };

    static _CharacterInfo _character0000FB1F =
    {
        0x0000FB1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB1F,
        0x0000FB1F,
        0x0000FB1F
    };

    static Char _decompositionMapping0000FB20[] = 
    {
        0x000005E2
    };

    static _CharacterInfo _character0000FB20 =
    {
        0x0000FB20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB20,
        0x0000FB20,
        0x0000FB20
    };

    static Char _decompositionMapping0000FB21[] = 
    {
        0x000005D0
    };

    static _CharacterInfo _character0000FB21 =
    {
        0x0000FB21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB21,
        0x0000FB21,
        0x0000FB21
    };

    static Char _decompositionMapping0000FB22[] = 
    {
        0x000005D3
    };

    static _CharacterInfo _character0000FB22 =
    {
        0x0000FB22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB22,
        0x0000FB22,
        0x0000FB22
    };

    static Char _decompositionMapping0000FB23[] = 
    {
        0x000005D4
    };

    static _CharacterInfo _character0000FB23 =
    {
        0x0000FB23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB23,
        0x0000FB23,
        0x0000FB23
    };

    static Char _decompositionMapping0000FB24[] = 
    {
        0x000005DB
    };

    static _CharacterInfo _character0000FB24 =
    {
        0x0000FB24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB24,
        0x0000FB24,
        0x0000FB24
    };

    static Char _decompositionMapping0000FB25[] = 
    {
        0x000005DC
    };

    static _CharacterInfo _character0000FB25 =
    {
        0x0000FB25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB25,
        0x0000FB25,
        0x0000FB25
    };

    static Char _decompositionMapping0000FB26[] = 
    {
        0x000005DD
    };

    static _CharacterInfo _character0000FB26 =
    {
        0x0000FB26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB26,
        0x0000FB26,
        0x0000FB26
    };

    static Char _decompositionMapping0000FB27[] = 
    {
        0x000005E8
    };

    static _CharacterInfo _character0000FB27 =
    {
        0x0000FB27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB27,
        0x0000FB27,
        0x0000FB27
    };

    static Char _decompositionMapping0000FB28[] = 
    {
        0x000005EA
    };

    static _CharacterInfo _character0000FB28 =
    {
        0x0000FB28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB28,
        0x0000FB28,
        0x0000FB28
    };

    static Char _decompositionMapping0000FB29[] = 
    {
        0x0000002B
    };

    static _CharacterInfo _character0000FB29 =
    {
        0x0000FB29,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0000FB29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB29,
        0x0000FB29,
        0x0000FB29
    };

    static Char _decompositionMapping0000FB2A[] = 
    {
        0x000005E9,
        0x000005C1
    };

    static _CharacterInfo _character0000FB2A =
    {
        0x0000FB2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2A,
        0x0000FB2A,
        0x0000FB2A
    };

    static Char _decompositionMapping0000FB2B[] = 
    {
        0x000005E9,
        0x000005C2
    };

    static _CharacterInfo _character0000FB2B =
    {
        0x0000FB2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2B,
        0x0000FB2B,
        0x0000FB2B
    };

    static Char _decompositionMapping0000FB2C[] = 
    {
        0x0000FB49,
        0x000005C1
    };

    static _CharacterInfo _character0000FB2C =
    {
        0x0000FB2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2C,
        0x0000FB2C,
        0x0000FB2C
    };

    static Char _decompositionMapping0000FB2D[] = 
    {
        0x0000FB49,
        0x000005C2
    };

    static _CharacterInfo _character0000FB2D =
    {
        0x0000FB2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2D,
        0x0000FB2D,
        0x0000FB2D
    };

    static Char _decompositionMapping0000FB2E[] = 
    {
        0x000005D0,
        0x000005B7
    };

    static _CharacterInfo _character0000FB2E =
    {
        0x0000FB2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2E,
        0x0000FB2E,
        0x0000FB2E
    };

    static Char _decompositionMapping0000FB2F[] = 
    {
        0x000005D0,
        0x000005B8
    };

    static _CharacterInfo _character0000FB2F =
    {
        0x0000FB2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB2F,
        0x0000FB2F,
        0x0000FB2F
    };

    static Char _decompositionMapping0000FB30[] = 
    {
        0x000005D0,
        0x000005BC
    };

    static _CharacterInfo _character0000FB30 =
    {
        0x0000FB30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB30,
        0x0000FB30,
        0x0000FB30
    };

    static Char _decompositionMapping0000FB31[] = 
    {
        0x000005D1,
        0x000005BC
    };

    static _CharacterInfo _character0000FB31 =
    {
        0x0000FB31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB31,
        0x0000FB31,
        0x0000FB31
    };

    static Char _decompositionMapping0000FB32[] = 
    {
        0x000005D2,
        0x000005BC
    };

    static _CharacterInfo _character0000FB32 =
    {
        0x0000FB32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB32,
        0x0000FB32,
        0x0000FB32
    };

    static Char _decompositionMapping0000FB33[] = 
    {
        0x000005D3,
        0x000005BC
    };

    static _CharacterInfo _character0000FB33 =
    {
        0x0000FB33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB33,
        0x0000FB33,
        0x0000FB33
    };

    static Char _decompositionMapping0000FB34[] = 
    {
        0x000005D4,
        0x000005BC
    };

    static _CharacterInfo _character0000FB34 =
    {
        0x0000FB34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB34,
        0x0000FB34,
        0x0000FB34
    };

    static Char _decompositionMapping0000FB35[] = 
    {
        0x000005D5,
        0x000005BC
    };

    static _CharacterInfo _character0000FB35 =
    {
        0x0000FB35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB35,
        0x0000FB35,
        0x0000FB35
    };

    static Char _decompositionMapping0000FB36[] = 
    {
        0x000005D6,
        0x000005BC
    };

    static _CharacterInfo _character0000FB36 =
    {
        0x0000FB36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB36,
        0x0000FB36,
        0x0000FB36
    };

    static Char _decompositionMapping0000FB38[] = 
    {
        0x000005D8,
        0x000005BC
    };

    static _CharacterInfo _character0000FB38 =
    {
        0x0000FB38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB38,
        0x0000FB38,
        0x0000FB38
    };

    static Char _decompositionMapping0000FB39[] = 
    {
        0x000005D9,
        0x000005BC
    };

    static _CharacterInfo _character0000FB39 =
    {
        0x0000FB39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB39,
        0x0000FB39,
        0x0000FB39
    };

    static Char _decompositionMapping0000FB3A[] = 
    {
        0x000005DA,
        0x000005BC
    };

    static _CharacterInfo _character0000FB3A =
    {
        0x0000FB3A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB3A,
        0x0000FB3A,
        0x0000FB3A
    };

    static Char _decompositionMapping0000FB3B[] = 
    {
        0x000005DB,
        0x000005BC
    };

    static _CharacterInfo _character0000FB3B =
    {
        0x0000FB3B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB3B,
        0x0000FB3B,
        0x0000FB3B
    };

    static Char _decompositionMapping0000FB3C[] = 
    {
        0x000005DC,
        0x000005BC
    };

    static _CharacterInfo _character0000FB3C =
    {
        0x0000FB3C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB3C,
        0x0000FB3C,
        0x0000FB3C
    };

    static Char _decompositionMapping0000FB3E[] = 
    {
        0x000005DE,
        0x000005BC
    };

    static _CharacterInfo _character0000FB3E =
    {
        0x0000FB3E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB3E,
        0x0000FB3E,
        0x0000FB3E
    };

    static Char _decompositionMapping0000FB40[] = 
    {
        0x000005E0,
        0x000005BC
    };

    static _CharacterInfo _character0000FB40 =
    {
        0x0000FB40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB40,
        0x0000FB40,
        0x0000FB40
    };

    static Char _decompositionMapping0000FB41[] = 
    {
        0x000005E1,
        0x000005BC
    };

    static _CharacterInfo _character0000FB41 =
    {
        0x0000FB41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB41,
        0x0000FB41,
        0x0000FB41
    };

    static Char _decompositionMapping0000FB43[] = 
    {
        0x000005E3,
        0x000005BC
    };

    static _CharacterInfo _character0000FB43 =
    {
        0x0000FB43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB43,
        0x0000FB43,
        0x0000FB43
    };

    static Char _decompositionMapping0000FB44[] = 
    {
        0x000005E4,
        0x000005BC
    };

    static _CharacterInfo _character0000FB44 =
    {
        0x0000FB44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB44,
        0x0000FB44,
        0x0000FB44
    };

    static Char _decompositionMapping0000FB46[] = 
    {
        0x000005E6,
        0x000005BC
    };

    static _CharacterInfo _character0000FB46 =
    {
        0x0000FB46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB46,
        0x0000FB46,
        0x0000FB46
    };

    static Char _decompositionMapping0000FB47[] = 
    {
        0x000005E7,
        0x000005BC
    };

    static _CharacterInfo _character0000FB47 =
    {
        0x0000FB47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB47,
        0x0000FB47,
        0x0000FB47
    };

    static Char _decompositionMapping0000FB48[] = 
    {
        0x000005E8,
        0x000005BC
    };

    static _CharacterInfo _character0000FB48 =
    {
        0x0000FB48,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB48,
        0x0000FB48,
        0x0000FB48
    };

    static Char _decompositionMapping0000FB49[] = 
    {
        0x000005E9,
        0x000005BC
    };

    static _CharacterInfo _character0000FB49 =
    {
        0x0000FB49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB49,
        0x0000FB49,
        0x0000FB49
    };

    static Char _decompositionMapping0000FB4A[] = 
    {
        0x000005EA,
        0x000005BC
    };

    static _CharacterInfo _character0000FB4A =
    {
        0x0000FB4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4A,
        0x0000FB4A,
        0x0000FB4A
    };

    static Char _decompositionMapping0000FB4B[] = 
    {
        0x000005D5,
        0x000005B9
    };

    static _CharacterInfo _character0000FB4B =
    {
        0x0000FB4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4B,
        0x0000FB4B,
        0x0000FB4B
    };

    static Char _decompositionMapping0000FB4C[] = 
    {
        0x000005D1,
        0x000005BF
    };

    static _CharacterInfo _character0000FB4C =
    {
        0x0000FB4C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4C,
        0x0000FB4C,
        0x0000FB4C
    };

    static Char _decompositionMapping0000FB4D[] = 
    {
        0x000005DB,
        0x000005BF
    };

    static _CharacterInfo _character0000FB4D =
    {
        0x0000FB4D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4D,
        0x0000FB4D,
        0x0000FB4D
    };

    static Char _decompositionMapping0000FB4E[] = 
    {
        0x000005E4,
        0x000005BF
    };

    static _CharacterInfo _character0000FB4E =
    {
        0x0000FB4E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0000FB4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4E,
        0x0000FB4E,
        0x0000FB4E
    };

    static Char _decompositionMapping0000FB4F[] = 
    {
        0x000005D0,
        0x000005DC
    };

    static _CharacterInfo _character0000FB4F =
    {
        0x0000FB4F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_compat,
        2,
        _decompositionMapping0000FB4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB4F,
        0x0000FB4F,
        0x0000FB4F
    };

    static Char _decompositionMapping0000FB50[] = 
    {
        0x00000671
    };

    static _CharacterInfo _character0000FB50 =
    {
        0x0000FB50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB50,
        0x0000FB50,
        0x0000FB50
    };

    static Char _decompositionMapping0000FB51[] = 
    {
        0x00000671
    };

    static _CharacterInfo _character0000FB51 =
    {
        0x0000FB51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB51,
        0x0000FB51,
        0x0000FB51
    };

    static Char _decompositionMapping0000FB52[] = 
    {
        0x0000067B
    };

    static _CharacterInfo _character0000FB52 =
    {
        0x0000FB52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB52,
        0x0000FB52,
        0x0000FB52
    };

    static Char _decompositionMapping0000FB53[] = 
    {
        0x0000067B
    };

    static _CharacterInfo _character0000FB53 =
    {
        0x0000FB53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB53,
        0x0000FB53,
        0x0000FB53
    };

    static Char _decompositionMapping0000FB54[] = 
    {
        0x0000067B
    };

    static _CharacterInfo _character0000FB54 =
    {
        0x0000FB54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB54,
        0x0000FB54,
        0x0000FB54
    };

    static Char _decompositionMapping0000FB55[] = 
    {
        0x0000067B
    };

    static _CharacterInfo _character0000FB55 =
    {
        0x0000FB55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB55,
        0x0000FB55,
        0x0000FB55
    };

    static Char _decompositionMapping0000FB56[] = 
    {
        0x0000067E
    };

    static _CharacterInfo _character0000FB56 =
    {
        0x0000FB56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB56,
        0x0000FB56,
        0x0000FB56
    };

    static Char _decompositionMapping0000FB57[] = 
    {
        0x0000067E
    };

    static _CharacterInfo _character0000FB57 =
    {
        0x0000FB57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB57,
        0x0000FB57,
        0x0000FB57
    };

    static Char _decompositionMapping0000FB58[] = 
    {
        0x0000067E
    };

    static _CharacterInfo _character0000FB58 =
    {
        0x0000FB58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB58,
        0x0000FB58,
        0x0000FB58
    };

    static Char _decompositionMapping0000FB59[] = 
    {
        0x0000067E
    };

    static _CharacterInfo _character0000FB59 =
    {
        0x0000FB59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB59,
        0x0000FB59,
        0x0000FB59
    };

    static Char _decompositionMapping0000FB5A[] = 
    {
        0x00000680
    };

    static _CharacterInfo _character0000FB5A =
    {
        0x0000FB5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5A,
        0x0000FB5A,
        0x0000FB5A
    };

    static Char _decompositionMapping0000FB5B[] = 
    {
        0x00000680
    };

    static _CharacterInfo _character0000FB5B =
    {
        0x0000FB5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5B,
        0x0000FB5B,
        0x0000FB5B
    };

    static Char _decompositionMapping0000FB5C[] = 
    {
        0x00000680
    };

    static _CharacterInfo _character0000FB5C =
    {
        0x0000FB5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5C,
        0x0000FB5C,
        0x0000FB5C
    };

    static Char _decompositionMapping0000FB5D[] = 
    {
        0x00000680
    };

    static _CharacterInfo _character0000FB5D =
    {
        0x0000FB5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5D,
        0x0000FB5D,
        0x0000FB5D
    };

    static Char _decompositionMapping0000FB5E[] = 
    {
        0x0000067A
    };

    static _CharacterInfo _character0000FB5E =
    {
        0x0000FB5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5E,
        0x0000FB5E,
        0x0000FB5E
    };

    static Char _decompositionMapping0000FB5F[] = 
    {
        0x0000067A
    };

    static _CharacterInfo _character0000FB5F =
    {
        0x0000FB5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB5F,
        0x0000FB5F,
        0x0000FB5F
    };

    static Char _decompositionMapping0000FB60[] = 
    {
        0x0000067A
    };

    static _CharacterInfo _character0000FB60 =
    {
        0x0000FB60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB60,
        0x0000FB60,
        0x0000FB60
    };

    static Char _decompositionMapping0000FB61[] = 
    {
        0x0000067A
    };

    static _CharacterInfo _character0000FB61 =
    {
        0x0000FB61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB61,
        0x0000FB61,
        0x0000FB61
    };

    static Char _decompositionMapping0000FB62[] = 
    {
        0x0000067F
    };

    static _CharacterInfo _character0000FB62 =
    {
        0x0000FB62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB62,
        0x0000FB62,
        0x0000FB62
    };

    static Char _decompositionMapping0000FB63[] = 
    {
        0x0000067F
    };

    static _CharacterInfo _character0000FB63 =
    {
        0x0000FB63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB63,
        0x0000FB63,
        0x0000FB63
    };

    static Char _decompositionMapping0000FB64[] = 
    {
        0x0000067F
    };

    static _CharacterInfo _character0000FB64 =
    {
        0x0000FB64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB64,
        0x0000FB64,
        0x0000FB64
    };

    static Char _decompositionMapping0000FB65[] = 
    {
        0x0000067F
    };

    static _CharacterInfo _character0000FB65 =
    {
        0x0000FB65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB65,
        0x0000FB65,
        0x0000FB65
    };

    static Char _decompositionMapping0000FB66[] = 
    {
        0x00000679
    };

    static _CharacterInfo _character0000FB66 =
    {
        0x0000FB66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB66,
        0x0000FB66,
        0x0000FB66
    };

    static Char _decompositionMapping0000FB67[] = 
    {
        0x00000679
    };

    static _CharacterInfo _character0000FB67 =
    {
        0x0000FB67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB67,
        0x0000FB67,
        0x0000FB67
    };

    static Char _decompositionMapping0000FB68[] = 
    {
        0x00000679
    };

    static _CharacterInfo _character0000FB68 =
    {
        0x0000FB68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB68,
        0x0000FB68,
        0x0000FB68
    };

    static Char _decompositionMapping0000FB69[] = 
    {
        0x00000679
    };

    static _CharacterInfo _character0000FB69 =
    {
        0x0000FB69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB69,
        0x0000FB69,
        0x0000FB69
    };

    static Char _decompositionMapping0000FB6A[] = 
    {
        0x000006A4
    };

    static _CharacterInfo _character0000FB6A =
    {
        0x0000FB6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6A,
        0x0000FB6A,
        0x0000FB6A
    };

    static Char _decompositionMapping0000FB6B[] = 
    {
        0x000006A4
    };

    static _CharacterInfo _character0000FB6B =
    {
        0x0000FB6B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6B,
        0x0000FB6B,
        0x0000FB6B
    };

    static Char _decompositionMapping0000FB6C[] = 
    {
        0x000006A4
    };

    static _CharacterInfo _character0000FB6C =
    {
        0x0000FB6C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6C,
        0x0000FB6C,
        0x0000FB6C
    };

    static Char _decompositionMapping0000FB6D[] = 
    {
        0x000006A4
    };

    static _CharacterInfo _character0000FB6D =
    {
        0x0000FB6D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6D,
        0x0000FB6D,
        0x0000FB6D
    };

    static Char _decompositionMapping0000FB6E[] = 
    {
        0x000006A6
    };

    static _CharacterInfo _character0000FB6E =
    {
        0x0000FB6E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6E,
        0x0000FB6E,
        0x0000FB6E
    };

    static Char _decompositionMapping0000FB6F[] = 
    {
        0x000006A6
    };

    static _CharacterInfo _character0000FB6F =
    {
        0x0000FB6F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB6F,
        0x0000FB6F,
        0x0000FB6F
    };

    static Char _decompositionMapping0000FB70[] = 
    {
        0x000006A6
    };

    static _CharacterInfo _character0000FB70 =
    {
        0x0000FB70,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB70,
        0x0000FB70,
        0x0000FB70
    };

    static Char _decompositionMapping0000FB71[] = 
    {
        0x000006A6
    };

    static _CharacterInfo _character0000FB71 =
    {
        0x0000FB71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB71,
        0x0000FB71,
        0x0000FB71
    };

    static Char _decompositionMapping0000FB72[] = 
    {
        0x00000684
    };

    static _CharacterInfo _character0000FB72 =
    {
        0x0000FB72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB72,
        0x0000FB72,
        0x0000FB72
    };

    static Char _decompositionMapping0000FB73[] = 
    {
        0x00000684
    };

    static _CharacterInfo _character0000FB73 =
    {
        0x0000FB73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB73,
        0x0000FB73,
        0x0000FB73
    };

    static Char _decompositionMapping0000FB74[] = 
    {
        0x00000684
    };

    static _CharacterInfo _character0000FB74 =
    {
        0x0000FB74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB74,
        0x0000FB74,
        0x0000FB74
    };

    static Char _decompositionMapping0000FB75[] = 
    {
        0x00000684
    };

    static _CharacterInfo _character0000FB75 =
    {
        0x0000FB75,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB75,
        0x0000FB75,
        0x0000FB75
    };

    static Char _decompositionMapping0000FB76[] = 
    {
        0x00000683
    };

    static _CharacterInfo _character0000FB76 =
    {
        0x0000FB76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB76,
        0x0000FB76,
        0x0000FB76
    };

    static Char _decompositionMapping0000FB77[] = 
    {
        0x00000683
    };

    static _CharacterInfo _character0000FB77 =
    {
        0x0000FB77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB77,
        0x0000FB77,
        0x0000FB77
    };

    static Char _decompositionMapping0000FB78[] = 
    {
        0x00000683
    };

    static _CharacterInfo _character0000FB78 =
    {
        0x0000FB78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB78,
        0x0000FB78,
        0x0000FB78
    };

    static Char _decompositionMapping0000FB79[] = 
    {
        0x00000683
    };

    static _CharacterInfo _character0000FB79 =
    {
        0x0000FB79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB79,
        0x0000FB79,
        0x0000FB79
    };

    static Char _decompositionMapping0000FB7A[] = 
    {
        0x00000686
    };

    static _CharacterInfo _character0000FB7A =
    {
        0x0000FB7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7A,
        0x0000FB7A,
        0x0000FB7A
    };

    static Char _decompositionMapping0000FB7B[] = 
    {
        0x00000686
    };

    static _CharacterInfo _character0000FB7B =
    {
        0x0000FB7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7B,
        0x0000FB7B,
        0x0000FB7B
    };

    static Char _decompositionMapping0000FB7C[] = 
    {
        0x00000686
    };

    static _CharacterInfo _character0000FB7C =
    {
        0x0000FB7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7C,
        0x0000FB7C,
        0x0000FB7C
    };

    static Char _decompositionMapping0000FB7D[] = 
    {
        0x00000686
    };

    static _CharacterInfo _character0000FB7D =
    {
        0x0000FB7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7D,
        0x0000FB7D,
        0x0000FB7D
    };

    static Char _decompositionMapping0000FB7E[] = 
    {
        0x00000687
    };

    static _CharacterInfo _character0000FB7E =
    {
        0x0000FB7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7E,
        0x0000FB7E,
        0x0000FB7E
    };

    static Char _decompositionMapping0000FB7F[] = 
    {
        0x00000687
    };

    static _CharacterInfo _character0000FB7F =
    {
        0x0000FB7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB7F,
        0x0000FB7F,
        0x0000FB7F
    };

    static Char _decompositionMapping0000FB80[] = 
    {
        0x00000687
    };

    static _CharacterInfo _character0000FB80 =
    {
        0x0000FB80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB80,
        0x0000FB80,
        0x0000FB80
    };

    static Char _decompositionMapping0000FB81[] = 
    {
        0x00000687
    };

    static _CharacterInfo _character0000FB81 =
    {
        0x0000FB81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB81,
        0x0000FB81,
        0x0000FB81
    };

    static Char _decompositionMapping0000FB82[] = 
    {
        0x0000068D
    };

    static _CharacterInfo _character0000FB82 =
    {
        0x0000FB82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB82,
        0x0000FB82,
        0x0000FB82
    };

    static Char _decompositionMapping0000FB83[] = 
    {
        0x0000068D
    };

    static _CharacterInfo _character0000FB83 =
    {
        0x0000FB83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB83,
        0x0000FB83,
        0x0000FB83
    };

    static Char _decompositionMapping0000FB84[] = 
    {
        0x0000068C
    };

    static _CharacterInfo _character0000FB84 =
    {
        0x0000FB84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB84,
        0x0000FB84,
        0x0000FB84
    };

    static Char _decompositionMapping0000FB85[] = 
    {
        0x0000068C
    };

    static _CharacterInfo _character0000FB85 =
    {
        0x0000FB85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB85,
        0x0000FB85,
        0x0000FB85
    };

    static Char _decompositionMapping0000FB86[] = 
    {
        0x0000068E
    };

    static _CharacterInfo _character0000FB86 =
    {
        0x0000FB86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB86,
        0x0000FB86,
        0x0000FB86
    };

    static Char _decompositionMapping0000FB87[] = 
    {
        0x0000068E
    };

    static _CharacterInfo _character0000FB87 =
    {
        0x0000FB87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB87,
        0x0000FB87,
        0x0000FB87
    };

    static Char _decompositionMapping0000FB88[] = 
    {
        0x00000688
    };

    static _CharacterInfo _character0000FB88 =
    {
        0x0000FB88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB88,
        0x0000FB88,
        0x0000FB88
    };

    static Char _decompositionMapping0000FB89[] = 
    {
        0x00000688
    };

    static _CharacterInfo _character0000FB89 =
    {
        0x0000FB89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB89,
        0x0000FB89,
        0x0000FB89
    };

    static Char _decompositionMapping0000FB8A[] = 
    {
        0x00000698
    };

    static _CharacterInfo _character0000FB8A =
    {
        0x0000FB8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8A,
        0x0000FB8A,
        0x0000FB8A
    };

    static Char _decompositionMapping0000FB8B[] = 
    {
        0x00000698
    };

    static _CharacterInfo _character0000FB8B =
    {
        0x0000FB8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8B,
        0x0000FB8B,
        0x0000FB8B
    };

    static Char _decompositionMapping0000FB8C[] = 
    {
        0x00000691
    };

    static _CharacterInfo _character0000FB8C =
    {
        0x0000FB8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8C,
        0x0000FB8C,
        0x0000FB8C
    };

    static Char _decompositionMapping0000FB8D[] = 
    {
        0x00000691
    };

    static _CharacterInfo _character0000FB8D =
    {
        0x0000FB8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8D,
        0x0000FB8D,
        0x0000FB8D
    };

    static Char _decompositionMapping0000FB8E[] = 
    {
        0x000006A9
    };

    static _CharacterInfo _character0000FB8E =
    {
        0x0000FB8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8E,
        0x0000FB8E,
        0x0000FB8E
    };

    static Char _decompositionMapping0000FB8F[] = 
    {
        0x000006A9
    };

    static _CharacterInfo _character0000FB8F =
    {
        0x0000FB8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB8F,
        0x0000FB8F,
        0x0000FB8F
    };

    static Char _decompositionMapping0000FB90[] = 
    {
        0x000006A9
    };

    static _CharacterInfo _character0000FB90 =
    {
        0x0000FB90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB90,
        0x0000FB90,
        0x0000FB90
    };

    static Char _decompositionMapping0000FB91[] = 
    {
        0x000006A9
    };

    static _CharacterInfo _character0000FB91 =
    {
        0x0000FB91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB91,
        0x0000FB91,
        0x0000FB91
    };

    static Char _decompositionMapping0000FB92[] = 
    {
        0x000006AF
    };

    static _CharacterInfo _character0000FB92 =
    {
        0x0000FB92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB92,
        0x0000FB92,
        0x0000FB92
    };

    static Char _decompositionMapping0000FB93[] = 
    {
        0x000006AF
    };

    static _CharacterInfo _character0000FB93 =
    {
        0x0000FB93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB93,
        0x0000FB93,
        0x0000FB93
    };

    static Char _decompositionMapping0000FB94[] = 
    {
        0x000006AF
    };

    static _CharacterInfo _character0000FB94 =
    {
        0x0000FB94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB94,
        0x0000FB94,
        0x0000FB94
    };

    static Char _decompositionMapping0000FB95[] = 
    {
        0x000006AF
    };

    static _CharacterInfo _character0000FB95 =
    {
        0x0000FB95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB95,
        0x0000FB95,
        0x0000FB95
    };

    static Char _decompositionMapping0000FB96[] = 
    {
        0x000006B3
    };

    static _CharacterInfo _character0000FB96 =
    {
        0x0000FB96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB96,
        0x0000FB96,
        0x0000FB96
    };

    static Char _decompositionMapping0000FB97[] = 
    {
        0x000006B3
    };

    static _CharacterInfo _character0000FB97 =
    {
        0x0000FB97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB97,
        0x0000FB97,
        0x0000FB97
    };

    static Char _decompositionMapping0000FB98[] = 
    {
        0x000006B3
    };

    static _CharacterInfo _character0000FB98 =
    {
        0x0000FB98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB98,
        0x0000FB98,
        0x0000FB98
    };

    static Char _decompositionMapping0000FB99[] = 
    {
        0x000006B3
    };

    static _CharacterInfo _character0000FB99 =
    {
        0x0000FB99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB99,
        0x0000FB99,
        0x0000FB99
    };

    static Char _decompositionMapping0000FB9A[] = 
    {
        0x000006B1
    };

    static _CharacterInfo _character0000FB9A =
    {
        0x0000FB9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9A,
        0x0000FB9A,
        0x0000FB9A
    };

    static Char _decompositionMapping0000FB9B[] = 
    {
        0x000006B1
    };

    static _CharacterInfo _character0000FB9B =
    {
        0x0000FB9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9B,
        0x0000FB9B,
        0x0000FB9B
    };

    static Char _decompositionMapping0000FB9C[] = 
    {
        0x000006B1
    };

    static _CharacterInfo _character0000FB9C =
    {
        0x0000FB9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FB9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9C,
        0x0000FB9C,
        0x0000FB9C
    };

    static Char _decompositionMapping0000FB9D[] = 
    {
        0x000006B1
    };

    static _CharacterInfo _character0000FB9D =
    {
        0x0000FB9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FB9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9D,
        0x0000FB9D,
        0x0000FB9D
    };

    static Char _decompositionMapping0000FB9E[] = 
    {
        0x000006BA
    };

    static _CharacterInfo _character0000FB9E =
    {
        0x0000FB9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FB9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9E,
        0x0000FB9E,
        0x0000FB9E
    };

    static Char _decompositionMapping0000FB9F[] = 
    {
        0x000006BA
    };

    static _CharacterInfo _character0000FB9F =
    {
        0x0000FB9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FB9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FB9F,
        0x0000FB9F,
        0x0000FB9F
    };

    static Char _decompositionMapping0000FBA0[] = 
    {
        0x000006BB
    };

    static _CharacterInfo _character0000FBA0 =
    {
        0x0000FBA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA0,
        0x0000FBA0,
        0x0000FBA0
    };

    static Char _decompositionMapping0000FBA1[] = 
    {
        0x000006BB
    };

    static _CharacterInfo _character0000FBA1 =
    {
        0x0000FBA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA1,
        0x0000FBA1,
        0x0000FBA1
    };

    static Char _decompositionMapping0000FBA2[] = 
    {
        0x000006BB
    };

    static _CharacterInfo _character0000FBA2 =
    {
        0x0000FBA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA2,
        0x0000FBA2,
        0x0000FBA2
    };

    static Char _decompositionMapping0000FBA3[] = 
    {
        0x000006BB
    };

    static _CharacterInfo _character0000FBA3 =
    {
        0x0000FBA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA3,
        0x0000FBA3,
        0x0000FBA3
    };

    static Char _decompositionMapping0000FBA4[] = 
    {
        0x000006C0
    };

    static _CharacterInfo _character0000FBA4 =
    {
        0x0000FBA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA4,
        0x0000FBA4,
        0x0000FBA4
    };

    static Char _decompositionMapping0000FBA5[] = 
    {
        0x000006C0
    };

    static _CharacterInfo _character0000FBA5 =
    {
        0x0000FBA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA5,
        0x0000FBA5,
        0x0000FBA5
    };

    static Char _decompositionMapping0000FBA6[] = 
    {
        0x000006C1
    };

    static _CharacterInfo _character0000FBA6 =
    {
        0x0000FBA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA6,
        0x0000FBA6,
        0x0000FBA6
    };

    static Char _decompositionMapping0000FBA7[] = 
    {
        0x000006C1
    };

    static _CharacterInfo _character0000FBA7 =
    {
        0x0000FBA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA7,
        0x0000FBA7,
        0x0000FBA7
    };

    static Char _decompositionMapping0000FBA8[] = 
    {
        0x000006C1
    };

    static _CharacterInfo _character0000FBA8 =
    {
        0x0000FBA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA8,
        0x0000FBA8,
        0x0000FBA8
    };

    static Char _decompositionMapping0000FBA9[] = 
    {
        0x000006C1
    };

    static _CharacterInfo _character0000FBA9 =
    {
        0x0000FBA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBA9,
        0x0000FBA9,
        0x0000FBA9
    };

    static Char _decompositionMapping0000FBAA[] = 
    {
        0x000006BE
    };

    static _CharacterInfo _character0000FBAA =
    {
        0x0000FBAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAA,
        0x0000FBAA,
        0x0000FBAA
    };

    static Char _decompositionMapping0000FBAB[] = 
    {
        0x000006BE
    };

    static _CharacterInfo _character0000FBAB =
    {
        0x0000FBAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAB,
        0x0000FBAB,
        0x0000FBAB
    };

    static Char _decompositionMapping0000FBAC[] = 
    {
        0x000006BE
    };

    static _CharacterInfo _character0000FBAC =
    {
        0x0000FBAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAC,
        0x0000FBAC,
        0x0000FBAC
    };

    static Char _decompositionMapping0000FBAD[] = 
    {
        0x000006BE
    };

    static _CharacterInfo _character0000FBAD =
    {
        0x0000FBAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAD,
        0x0000FBAD,
        0x0000FBAD
    };

    static Char _decompositionMapping0000FBAE[] = 
    {
        0x000006D2
    };

    static _CharacterInfo _character0000FBAE =
    {
        0x0000FBAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAE,
        0x0000FBAE,
        0x0000FBAE
    };

    static Char _decompositionMapping0000FBAF[] = 
    {
        0x000006D2
    };

    static _CharacterInfo _character0000FBAF =
    {
        0x0000FBAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBAF,
        0x0000FBAF,
        0x0000FBAF
    };

    static Char _decompositionMapping0000FBB0[] = 
    {
        0x000006D3
    };

    static _CharacterInfo _character0000FBB0 =
    {
        0x0000FBB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBB0,
        0x0000FBB0,
        0x0000FBB0
    };

    static Char _decompositionMapping0000FBB1[] = 
    {
        0x000006D3
    };

    static _CharacterInfo _character0000FBB1 =
    {
        0x0000FBB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBB1,
        0x0000FBB1,
        0x0000FBB1
    };

    static Char _decompositionMapping0000FBD3[] = 
    {
        0x000006AD
    };

    static _CharacterInfo _character0000FBD3 =
    {
        0x0000FBD3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD3,
        0x0000FBD3,
        0x0000FBD3
    };

    static Char _decompositionMapping0000FBD4[] = 
    {
        0x000006AD
    };

    static _CharacterInfo _character0000FBD4 =
    {
        0x0000FBD4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBD4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD4,
        0x0000FBD4,
        0x0000FBD4
    };

    static Char _decompositionMapping0000FBD5[] = 
    {
        0x000006AD
    };

    static _CharacterInfo _character0000FBD5 =
    {
        0x0000FBD5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBD5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD5,
        0x0000FBD5,
        0x0000FBD5
    };

    static Char _decompositionMapping0000FBD6[] = 
    {
        0x000006AD
    };

    static _CharacterInfo _character0000FBD6 =
    {
        0x0000FBD6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBD6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD6,
        0x0000FBD6,
        0x0000FBD6
    };

    static Char _decompositionMapping0000FBD7[] = 
    {
        0x000006C7
    };

    static _CharacterInfo _character0000FBD7 =
    {
        0x0000FBD7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBD7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD7,
        0x0000FBD7,
        0x0000FBD7
    };

    static Char _decompositionMapping0000FBD8[] = 
    {
        0x000006C7
    };

    static _CharacterInfo _character0000FBD8 =
    {
        0x0000FBD8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBD8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD8,
        0x0000FBD8,
        0x0000FBD8
    };

    static Char _decompositionMapping0000FBD9[] = 
    {
        0x000006C6
    };

    static _CharacterInfo _character0000FBD9 =
    {
        0x0000FBD9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBD9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBD9,
        0x0000FBD9,
        0x0000FBD9
    };

    static Char _decompositionMapping0000FBDA[] = 
    {
        0x000006C6
    };

    static _CharacterInfo _character0000FBDA =
    {
        0x0000FBDA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDA,
        0x0000FBDA,
        0x0000FBDA
    };

    static Char _decompositionMapping0000FBDB[] = 
    {
        0x000006C8
    };

    static _CharacterInfo _character0000FBDB =
    {
        0x0000FBDB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDB,
        0x0000FBDB,
        0x0000FBDB
    };

    static Char _decompositionMapping0000FBDC[] = 
    {
        0x000006C8
    };

    static _CharacterInfo _character0000FBDC =
    {
        0x0000FBDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDC,
        0x0000FBDC,
        0x0000FBDC
    };

    static Char _decompositionMapping0000FBDD[] = 
    {
        0x00000677
    };

    static _CharacterInfo _character0000FBDD =
    {
        0x0000FBDD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDD,
        0x0000FBDD,
        0x0000FBDD
    };

    static Char _decompositionMapping0000FBDE[] = 
    {
        0x000006CB
    };

    static _CharacterInfo _character0000FBDE =
    {
        0x0000FBDE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDE,
        0x0000FBDE,
        0x0000FBDE
    };

    static Char _decompositionMapping0000FBDF[] = 
    {
        0x000006CB
    };

    static _CharacterInfo _character0000FBDF =
    {
        0x0000FBDF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBDF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBDF,
        0x0000FBDF,
        0x0000FBDF
    };

    static Char _decompositionMapping0000FBE0[] = 
    {
        0x000006C5
    };

    static _CharacterInfo _character0000FBE0 =
    {
        0x0000FBE0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE0,
        0x0000FBE0,
        0x0000FBE0
    };

    static Char _decompositionMapping0000FBE1[] = 
    {
        0x000006C5
    };

    static _CharacterInfo _character0000FBE1 =
    {
        0x0000FBE1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE1,
        0x0000FBE1,
        0x0000FBE1
    };

    static Char _decompositionMapping0000FBE2[] = 
    {
        0x000006C9
    };

    static _CharacterInfo _character0000FBE2 =
    {
        0x0000FBE2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE2,
        0x0000FBE2,
        0x0000FBE2
    };

    static Char _decompositionMapping0000FBE3[] = 
    {
        0x000006C9
    };

    static _CharacterInfo _character0000FBE3 =
    {
        0x0000FBE3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE3,
        0x0000FBE3,
        0x0000FBE3
    };

    static Char _decompositionMapping0000FBE4[] = 
    {
        0x000006D0
    };

    static _CharacterInfo _character0000FBE4 =
    {
        0x0000FBE4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE4,
        0x0000FBE4,
        0x0000FBE4
    };

    static Char _decompositionMapping0000FBE5[] = 
    {
        0x000006D0
    };

    static _CharacterInfo _character0000FBE5 =
    {
        0x0000FBE5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE5,
        0x0000FBE5,
        0x0000FBE5
    };

    static Char _decompositionMapping0000FBE6[] = 
    {
        0x000006D0
    };

    static _CharacterInfo _character0000FBE6 =
    {
        0x0000FBE6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE6,
        0x0000FBE6,
        0x0000FBE6
    };

    static Char _decompositionMapping0000FBE7[] = 
    {
        0x000006D0
    };

    static _CharacterInfo _character0000FBE7 =
    {
        0x0000FBE7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBE7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE7,
        0x0000FBE7,
        0x0000FBE7
    };

    static Char _decompositionMapping0000FBE8[] = 
    {
        0x00000649
    };

    static _CharacterInfo _character0000FBE8 =
    {
        0x0000FBE8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE8,
        0x0000FBE8,
        0x0000FBE8
    };

    static Char _decompositionMapping0000FBE9[] = 
    {
        0x00000649
    };

    static _CharacterInfo _character0000FBE9 =
    {
        0x0000FBE9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBE9,
        0x0000FBE9,
        0x0000FBE9
    };

    static Char _decompositionMapping0000FBEA[] = 
    {
        0x00000626,
        0x00000627
    };

    static _CharacterInfo _character0000FBEA =
    {
        0x0000FBEA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBEA,
        0x0000FBEA,
        0x0000FBEA
    };

    static Char _decompositionMapping0000FBEB[] = 
    {
        0x00000626,
        0x00000627
    };

    static _CharacterInfo _character0000FBEB =
    {
        0x0000FBEB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBEB,
        0x0000FBEB,
        0x0000FBEB
    };

    static Char _decompositionMapping0000FBEC[] = 
    {
        0x00000626,
        0x000006D5
    };

    static _CharacterInfo _character0000FBEC =
    {
        0x0000FBEC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBEC,
        0x0000FBEC,
        0x0000FBEC
    };

    static Char _decompositionMapping0000FBED[] = 
    {
        0x00000626,
        0x000006D5
    };

    static _CharacterInfo _character0000FBED =
    {
        0x0000FBED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBED,
        0x0000FBED,
        0x0000FBED
    };

    static Char _decompositionMapping0000FBEE[] = 
    {
        0x00000626,
        0x00000648
    };

    static _CharacterInfo _character0000FBEE =
    {
        0x0000FBEE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBEE,
        0x0000FBEE,
        0x0000FBEE
    };

    static Char _decompositionMapping0000FBEF[] = 
    {
        0x00000626,
        0x00000648
    };

    static _CharacterInfo _character0000FBEF =
    {
        0x0000FBEF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBEF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBEF,
        0x0000FBEF,
        0x0000FBEF
    };

    static Char _decompositionMapping0000FBF0[] = 
    {
        0x00000626,
        0x000006C7
    };

    static _CharacterInfo _character0000FBF0 =
    {
        0x0000FBF0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBF0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF0,
        0x0000FBF0,
        0x0000FBF0
    };

    static Char _decompositionMapping0000FBF1[] = 
    {
        0x00000626,
        0x000006C7
    };

    static _CharacterInfo _character0000FBF1 =
    {
        0x0000FBF1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBF1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF1,
        0x0000FBF1,
        0x0000FBF1
    };

    static Char _decompositionMapping0000FBF2[] = 
    {
        0x00000626,
        0x000006C6
    };

    static _CharacterInfo _character0000FBF2 =
    {
        0x0000FBF2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF2,
        0x0000FBF2,
        0x0000FBF2
    };

    static Char _decompositionMapping0000FBF3[] = 
    {
        0x00000626,
        0x000006C6
    };

    static _CharacterInfo _character0000FBF3 =
    {
        0x0000FBF3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF3,
        0x0000FBF3,
        0x0000FBF3
    };

    static Char _decompositionMapping0000FBF4[] = 
    {
        0x00000626,
        0x000006C8
    };

    static _CharacterInfo _character0000FBF4 =
    {
        0x0000FBF4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF4,
        0x0000FBF4,
        0x0000FBF4
    };

    static Char _decompositionMapping0000FBF5[] = 
    {
        0x00000626,
        0x000006C8
    };

    static _CharacterInfo _character0000FBF5 =
    {
        0x0000FBF5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBF5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF5,
        0x0000FBF5,
        0x0000FBF5
    };

    static Char _decompositionMapping0000FBF6[] = 
    {
        0x00000626,
        0x000006D0
    };

    static _CharacterInfo _character0000FBF6 =
    {
        0x0000FBF6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF6,
        0x0000FBF6,
        0x0000FBF6
    };

    static Char _decompositionMapping0000FBF7[] = 
    {
        0x00000626,
        0x000006D0
    };

    static _CharacterInfo _character0000FBF7 =
    {
        0x0000FBF7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF7,
        0x0000FBF7,
        0x0000FBF7
    };

    static Char _decompositionMapping0000FBF8[] = 
    {
        0x00000626,
        0x000006D0
    };

    static _CharacterInfo _character0000FBF8 =
    {
        0x0000FBF8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FBF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF8,
        0x0000FBF8,
        0x0000FBF8
    };

    static Char _decompositionMapping0000FBF9[] = 
    {
        0x00000626,
        0x00000649
    };

    static _CharacterInfo _character0000FBF9 =
    {
        0x0000FBF9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FBF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBF9,
        0x0000FBF9,
        0x0000FBF9
    };

    static Char _decompositionMapping0000FBFA[] = 
    {
        0x00000626,
        0x00000649
    };

    static _CharacterInfo _character0000FBFA =
    {
        0x0000FBFA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FBFA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFA,
        0x0000FBFA,
        0x0000FBFA
    };

    static Char _decompositionMapping0000FBFB[] = 
    {
        0x00000626,
        0x00000649
    };

    static _CharacterInfo _character0000FBFB =
    {
        0x0000FBFB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FBFB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFB,
        0x0000FBFB,
        0x0000FBFB
    };

    static Char _decompositionMapping0000FBFC[] = 
    {
        0x000006CC
    };

    static _CharacterInfo _character0000FBFC =
    {
        0x0000FBFC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FBFC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFC,
        0x0000FBFC,
        0x0000FBFC
    };

    static Char _decompositionMapping0000FBFD[] = 
    {
        0x000006CC
    };

    static _CharacterInfo _character0000FBFD =
    {
        0x0000FBFD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FBFD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFD,
        0x0000FBFD,
        0x0000FBFD
    };

    static Char _decompositionMapping0000FBFE[] = 
    {
        0x000006CC
    };

    static _CharacterInfo _character0000FBFE =
    {
        0x0000FBFE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FBFE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFE,
        0x0000FBFE,
        0x0000FBFE
    };

    static Char _decompositionMapping0000FBFF[] = 
    {
        0x000006CC
    };

    static _CharacterInfo _character0000FBFF =
    {
        0x0000FBFF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FBFF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FBFF,
        0x0000FBFF,
        0x0000FBFF
    };

    static Char _decompositionMapping0000FC00[] = 
    {
        0x00000626,
        0x0000062C
    };

    static _CharacterInfo _character0000FC00 =
    {
        0x0000FC00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC00,
        0x0000FC00,
        0x0000FC00
    };

    static Char _decompositionMapping0000FC01[] = 
    {
        0x00000626,
        0x0000062D
    };

    static _CharacterInfo _character0000FC01 =
    {
        0x0000FC01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC01,
        0x0000FC01,
        0x0000FC01
    };

    static Char _decompositionMapping0000FC02[] = 
    {
        0x00000626,
        0x00000645
    };

    static _CharacterInfo _character0000FC02 =
    {
        0x0000FC02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC02,
        0x0000FC02,
        0x0000FC02
    };

    static Char _decompositionMapping0000FC03[] = 
    {
        0x00000626,
        0x00000649
    };

    static _CharacterInfo _character0000FC03 =
    {
        0x0000FC03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC03,
        0x0000FC03,
        0x0000FC03
    };

    static Char _decompositionMapping0000FC04[] = 
    {
        0x00000626,
        0x0000064A
    };

    static _CharacterInfo _character0000FC04 =
    {
        0x0000FC04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC04,
        0x0000FC04,
        0x0000FC04
    };

    static Char _decompositionMapping0000FC05[] = 
    {
        0x00000628,
        0x0000062C
    };

    static _CharacterInfo _character0000FC05 =
    {
        0x0000FC05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC05,
        0x0000FC05,
        0x0000FC05
    };

    static Char _decompositionMapping0000FC06[] = 
    {
        0x00000628,
        0x0000062D
    };

    static _CharacterInfo _character0000FC06 =
    {
        0x0000FC06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC06,
        0x0000FC06,
        0x0000FC06
    };

    static Char _decompositionMapping0000FC07[] = 
    {
        0x00000628,
        0x0000062E
    };

    static _CharacterInfo _character0000FC07 =
    {
        0x0000FC07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC07,
        0x0000FC07,
        0x0000FC07
    };

    static Char _decompositionMapping0000FC08[] = 
    {
        0x00000628,
        0x00000645
    };

    static _CharacterInfo _character0000FC08 =
    {
        0x0000FC08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC08,
        0x0000FC08,
        0x0000FC08
    };

    static Char _decompositionMapping0000FC09[] = 
    {
        0x00000628,
        0x00000649
    };

    static _CharacterInfo _character0000FC09 =
    {
        0x0000FC09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC09,
        0x0000FC09,
        0x0000FC09
    };

    static Char _decompositionMapping0000FC0A[] = 
    {
        0x00000628,
        0x0000064A
    };

    static _CharacterInfo _character0000FC0A =
    {
        0x0000FC0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0A,
        0x0000FC0A,
        0x0000FC0A
    };

    static Char _decompositionMapping0000FC0B[] = 
    {
        0x0000062A,
        0x0000062C
    };

    static _CharacterInfo _character0000FC0B =
    {
        0x0000FC0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0B,
        0x0000FC0B,
        0x0000FC0B
    };

    static Char _decompositionMapping0000FC0C[] = 
    {
        0x0000062A,
        0x0000062D
    };

    static _CharacterInfo _character0000FC0C =
    {
        0x0000FC0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0C,
        0x0000FC0C,
        0x0000FC0C
    };

    static Char _decompositionMapping0000FC0D[] = 
    {
        0x0000062A,
        0x0000062E
    };

    static _CharacterInfo _character0000FC0D =
    {
        0x0000FC0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0D,
        0x0000FC0D,
        0x0000FC0D
    };

    static Char _decompositionMapping0000FC0E[] = 
    {
        0x0000062A,
        0x00000645
    };

    static _CharacterInfo _character0000FC0E =
    {
        0x0000FC0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0E,
        0x0000FC0E,
        0x0000FC0E
    };

    static Char _decompositionMapping0000FC0F[] = 
    {
        0x0000062A,
        0x00000649
    };

    static _CharacterInfo _character0000FC0F =
    {
        0x0000FC0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC0F,
        0x0000FC0F,
        0x0000FC0F
    };

    static Char _decompositionMapping0000FC10[] = 
    {
        0x0000062A,
        0x0000064A
    };

    static _CharacterInfo _character0000FC10 =
    {
        0x0000FC10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC10,
        0x0000FC10,
        0x0000FC10
    };

    static Char _decompositionMapping0000FC11[] = 
    {
        0x0000062B,
        0x0000062C
    };

    static _CharacterInfo _character0000FC11 =
    {
        0x0000FC11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC11,
        0x0000FC11,
        0x0000FC11
    };

    static Char _decompositionMapping0000FC12[] = 
    {
        0x0000062B,
        0x00000645
    };

    static _CharacterInfo _character0000FC12 =
    {
        0x0000FC12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC12,
        0x0000FC12,
        0x0000FC12
    };

    static Char _decompositionMapping0000FC13[] = 
    {
        0x0000062B,
        0x00000649
    };

    static _CharacterInfo _character0000FC13 =
    {
        0x0000FC13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC13,
        0x0000FC13,
        0x0000FC13
    };

    static Char _decompositionMapping0000FC14[] = 
    {
        0x0000062B,
        0x0000064A
    };

    static _CharacterInfo _character0000FC14 =
    {
        0x0000FC14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC14,
        0x0000FC14,
        0x0000FC14
    };

    static Char _decompositionMapping0000FC15[] = 
    {
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FC15 =
    {
        0x0000FC15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC15,
        0x0000FC15,
        0x0000FC15
    };

    static Char _decompositionMapping0000FC16[] = 
    {
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FC16 =
    {
        0x0000FC16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC16,
        0x0000FC16,
        0x0000FC16
    };

    static Char _decompositionMapping0000FC17[] = 
    {
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FC17 =
    {
        0x0000FC17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC17,
        0x0000FC17,
        0x0000FC17
    };

    static Char _decompositionMapping0000FC18[] = 
    {
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FC18 =
    {
        0x0000FC18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC18,
        0x0000FC18,
        0x0000FC18
    };

    static Char _decompositionMapping0000FC19[] = 
    {
        0x0000062E,
        0x0000062C
    };

    static _CharacterInfo _character0000FC19 =
    {
        0x0000FC19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC19,
        0x0000FC19,
        0x0000FC19
    };

    static Char _decompositionMapping0000FC1A[] = 
    {
        0x0000062E,
        0x0000062D
    };

    static _CharacterInfo _character0000FC1A =
    {
        0x0000FC1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1A,
        0x0000FC1A,
        0x0000FC1A
    };

    static Char _decompositionMapping0000FC1B[] = 
    {
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FC1B =
    {
        0x0000FC1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1B,
        0x0000FC1B,
        0x0000FC1B
    };

    static Char _decompositionMapping0000FC1C[] = 
    {
        0x00000633,
        0x0000062C
    };

    static _CharacterInfo _character0000FC1C =
    {
        0x0000FC1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1C,
        0x0000FC1C,
        0x0000FC1C
    };

    static Char _decompositionMapping0000FC1D[] = 
    {
        0x00000633,
        0x0000062D
    };

    static _CharacterInfo _character0000FC1D =
    {
        0x0000FC1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1D,
        0x0000FC1D,
        0x0000FC1D
    };

    static Char _decompositionMapping0000FC1E[] = 
    {
        0x00000633,
        0x0000062E
    };

    static _CharacterInfo _character0000FC1E =
    {
        0x0000FC1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1E,
        0x0000FC1E,
        0x0000FC1E
    };

    static Char _decompositionMapping0000FC1F[] = 
    {
        0x00000633,
        0x00000645
    };

    static _CharacterInfo _character0000FC1F =
    {
        0x0000FC1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC1F,
        0x0000FC1F,
        0x0000FC1F
    };

    static Char _decompositionMapping0000FC20[] = 
    {
        0x00000635,
        0x0000062D
    };

    static _CharacterInfo _character0000FC20 =
    {
        0x0000FC20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC20,
        0x0000FC20,
        0x0000FC20
    };

    static Char _decompositionMapping0000FC21[] = 
    {
        0x00000635,
        0x00000645
    };

    static _CharacterInfo _character0000FC21 =
    {
        0x0000FC21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC21,
        0x0000FC21,
        0x0000FC21
    };

    static Char _decompositionMapping0000FC22[] = 
    {
        0x00000636,
        0x0000062C
    };

    static _CharacterInfo _character0000FC22 =
    {
        0x0000FC22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC22,
        0x0000FC22,
        0x0000FC22
    };

    static Char _decompositionMapping0000FC23[] = 
    {
        0x00000636,
        0x0000062D
    };

    static _CharacterInfo _character0000FC23 =
    {
        0x0000FC23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC23,
        0x0000FC23,
        0x0000FC23
    };

    static Char _decompositionMapping0000FC24[] = 
    {
        0x00000636,
        0x0000062E
    };

    static _CharacterInfo _character0000FC24 =
    {
        0x0000FC24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC24,
        0x0000FC24,
        0x0000FC24
    };

    static Char _decompositionMapping0000FC25[] = 
    {
        0x00000636,
        0x00000645
    };

    static _CharacterInfo _character0000FC25 =
    {
        0x0000FC25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC25,
        0x0000FC25,
        0x0000FC25
    };

    static Char _decompositionMapping0000FC26[] = 
    {
        0x00000637,
        0x0000062D
    };

    static _CharacterInfo _character0000FC26 =
    {
        0x0000FC26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC26,
        0x0000FC26,
        0x0000FC26
    };

    static Char _decompositionMapping0000FC27[] = 
    {
        0x00000637,
        0x00000645
    };

    static _CharacterInfo _character0000FC27 =
    {
        0x0000FC27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC27,
        0x0000FC27,
        0x0000FC27
    };

    static Char _decompositionMapping0000FC28[] = 
    {
        0x00000638,
        0x00000645
    };

    static _CharacterInfo _character0000FC28 =
    {
        0x0000FC28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC28,
        0x0000FC28,
        0x0000FC28
    };

    static Char _decompositionMapping0000FC29[] = 
    {
        0x00000639,
        0x0000062C
    };

    static _CharacterInfo _character0000FC29 =
    {
        0x0000FC29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC29,
        0x0000FC29,
        0x0000FC29
    };

    static Char _decompositionMapping0000FC2A[] = 
    {
        0x00000639,
        0x00000645
    };

    static _CharacterInfo _character0000FC2A =
    {
        0x0000FC2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2A,
        0x0000FC2A,
        0x0000FC2A
    };

    static Char _decompositionMapping0000FC2B[] = 
    {
        0x0000063A,
        0x0000062C
    };

    static _CharacterInfo _character0000FC2B =
    {
        0x0000FC2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2B,
        0x0000FC2B,
        0x0000FC2B
    };

    static Char _decompositionMapping0000FC2C[] = 
    {
        0x0000063A,
        0x00000645
    };

    static _CharacterInfo _character0000FC2C =
    {
        0x0000FC2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2C,
        0x0000FC2C,
        0x0000FC2C
    };

    static Char _decompositionMapping0000FC2D[] = 
    {
        0x00000641,
        0x0000062C
    };

    static _CharacterInfo _character0000FC2D =
    {
        0x0000FC2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2D,
        0x0000FC2D,
        0x0000FC2D
    };

    static Char _decompositionMapping0000FC2E[] = 
    {
        0x00000641,
        0x0000062D
    };

    static _CharacterInfo _character0000FC2E =
    {
        0x0000FC2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2E,
        0x0000FC2E,
        0x0000FC2E
    };

    static Char _decompositionMapping0000FC2F[] = 
    {
        0x00000641,
        0x0000062E
    };

    static _CharacterInfo _character0000FC2F =
    {
        0x0000FC2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC2F,
        0x0000FC2F,
        0x0000FC2F
    };

    static Char _decompositionMapping0000FC30[] = 
    {
        0x00000641,
        0x00000645
    };

    static _CharacterInfo _character0000FC30 =
    {
        0x0000FC30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC30,
        0x0000FC30,
        0x0000FC30
    };

    static Char _decompositionMapping0000FC31[] = 
    {
        0x00000641,
        0x00000649
    };

    static _CharacterInfo _character0000FC31 =
    {
        0x0000FC31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC31,
        0x0000FC31,
        0x0000FC31
    };

    static Char _decompositionMapping0000FC32[] = 
    {
        0x00000641,
        0x0000064A
    };

    static _CharacterInfo _character0000FC32 =
    {
        0x0000FC32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC32,
        0x0000FC32,
        0x0000FC32
    };

    static Char _decompositionMapping0000FC33[] = 
    {
        0x00000642,
        0x0000062D
    };

    static _CharacterInfo _character0000FC33 =
    {
        0x0000FC33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC33,
        0x0000FC33,
        0x0000FC33
    };

    static Char _decompositionMapping0000FC34[] = 
    {
        0x00000642,
        0x00000645
    };

    static _CharacterInfo _character0000FC34 =
    {
        0x0000FC34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC34,
        0x0000FC34,
        0x0000FC34
    };

    static Char _decompositionMapping0000FC35[] = 
    {
        0x00000642,
        0x00000649
    };

    static _CharacterInfo _character0000FC35 =
    {
        0x0000FC35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC35,
        0x0000FC35,
        0x0000FC35
    };

    static Char _decompositionMapping0000FC36[] = 
    {
        0x00000642,
        0x0000064A
    };

    static _CharacterInfo _character0000FC36 =
    {
        0x0000FC36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC36,
        0x0000FC36,
        0x0000FC36
    };

    static Char _decompositionMapping0000FC37[] = 
    {
        0x00000643,
        0x00000627
    };

    static _CharacterInfo _character0000FC37 =
    {
        0x0000FC37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC37,
        0x0000FC37,
        0x0000FC37
    };

    static Char _decompositionMapping0000FC38[] = 
    {
        0x00000643,
        0x0000062C
    };

    static _CharacterInfo _character0000FC38 =
    {
        0x0000FC38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC38,
        0x0000FC38,
        0x0000FC38
    };

    static Char _decompositionMapping0000FC39[] = 
    {
        0x00000643,
        0x0000062D
    };

    static _CharacterInfo _character0000FC39 =
    {
        0x0000FC39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC39,
        0x0000FC39,
        0x0000FC39
    };

    static Char _decompositionMapping0000FC3A[] = 
    {
        0x00000643,
        0x0000062E
    };

    static _CharacterInfo _character0000FC3A =
    {
        0x0000FC3A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3A,
        0x0000FC3A,
        0x0000FC3A
    };

    static Char _decompositionMapping0000FC3B[] = 
    {
        0x00000643,
        0x00000644
    };

    static _CharacterInfo _character0000FC3B =
    {
        0x0000FC3B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3B,
        0x0000FC3B,
        0x0000FC3B
    };

    static Char _decompositionMapping0000FC3C[] = 
    {
        0x00000643,
        0x00000645
    };

    static _CharacterInfo _character0000FC3C =
    {
        0x0000FC3C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3C,
        0x0000FC3C,
        0x0000FC3C
    };

    static Char _decompositionMapping0000FC3D[] = 
    {
        0x00000643,
        0x00000649
    };

    static _CharacterInfo _character0000FC3D =
    {
        0x0000FC3D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3D,
        0x0000FC3D,
        0x0000FC3D
    };

    static Char _decompositionMapping0000FC3E[] = 
    {
        0x00000643,
        0x0000064A
    };

    static _CharacterInfo _character0000FC3E =
    {
        0x0000FC3E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3E,
        0x0000FC3E,
        0x0000FC3E
    };

    static Char _decompositionMapping0000FC3F[] = 
    {
        0x00000644,
        0x0000062C
    };

    static _CharacterInfo _character0000FC3F =
    {
        0x0000FC3F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC3F,
        0x0000FC3F,
        0x0000FC3F
    };

    static Char _decompositionMapping0000FC40[] = 
    {
        0x00000644,
        0x0000062D
    };

    static _CharacterInfo _character0000FC40 =
    {
        0x0000FC40,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC40,
        0x0000FC40,
        0x0000FC40
    };

    static Char _decompositionMapping0000FC41[] = 
    {
        0x00000644,
        0x0000062E
    };

    static _CharacterInfo _character0000FC41 =
    {
        0x0000FC41,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC41,
        0x0000FC41,
        0x0000FC41
    };

    static Char _decompositionMapping0000FC42[] = 
    {
        0x00000644,
        0x00000645
    };

    static _CharacterInfo _character0000FC42 =
    {
        0x0000FC42,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC42,
        0x0000FC42,
        0x0000FC42
    };

    static Char _decompositionMapping0000FC43[] = 
    {
        0x00000644,
        0x00000649
    };

    static _CharacterInfo _character0000FC43 =
    {
        0x0000FC43,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC43,
        0x0000FC43,
        0x0000FC43
    };

    static Char _decompositionMapping0000FC44[] = 
    {
        0x00000644,
        0x0000064A
    };

    static _CharacterInfo _character0000FC44 =
    {
        0x0000FC44,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC44,
        0x0000FC44,
        0x0000FC44
    };

    static Char _decompositionMapping0000FC45[] = 
    {
        0x00000645,
        0x0000062C
    };

    static _CharacterInfo _character0000FC45 =
    {
        0x0000FC45,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC45,
        0x0000FC45,
        0x0000FC45
    };

    static Char _decompositionMapping0000FC46[] = 
    {
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FC46 =
    {
        0x0000FC46,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC46,
        0x0000FC46,
        0x0000FC46
    };

    static Char _decompositionMapping0000FC47[] = 
    {
        0x00000645,
        0x0000062E
    };

    static _CharacterInfo _character0000FC47 =
    {
        0x0000FC47,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC47,
        0x0000FC47,
        0x0000FC47
    };

    static Char _decompositionMapping0000FC48[] = 
    {
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FC48 =
    {
        0x0000FC48,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC48,
        0x0000FC48,
        0x0000FC48
    };

    static Char _decompositionMapping0000FC49[] = 
    {
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FC49 =
    {
        0x0000FC49,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC49,
        0x0000FC49,
        0x0000FC49
    };

    static Char _decompositionMapping0000FC4A[] = 
    {
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FC4A =
    {
        0x0000FC4A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4A,
        0x0000FC4A,
        0x0000FC4A
    };

    static Char _decompositionMapping0000FC4B[] = 
    {
        0x00000646,
        0x0000062C
    };

    static _CharacterInfo _character0000FC4B =
    {
        0x0000FC4B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4B,
        0x0000FC4B,
        0x0000FC4B
    };

    static Char _decompositionMapping0000FC4C[] = 
    {
        0x00000646,
        0x0000062D
    };

    static _CharacterInfo _character0000FC4C =
    {
        0x0000FC4C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4C,
        0x0000FC4C,
        0x0000FC4C
    };

    static Char _decompositionMapping0000FC4D[] = 
    {
        0x00000646,
        0x0000062E
    };

    static _CharacterInfo _character0000FC4D =
    {
        0x0000FC4D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4D,
        0x0000FC4D,
        0x0000FC4D
    };

    static Char _decompositionMapping0000FC4E[] = 
    {
        0x00000646,
        0x00000645
    };

    static _CharacterInfo _character0000FC4E =
    {
        0x0000FC4E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4E,
        0x0000FC4E,
        0x0000FC4E
    };

    static Char _decompositionMapping0000FC4F[] = 
    {
        0x00000646,
        0x00000649
    };

    static _CharacterInfo _character0000FC4F =
    {
        0x0000FC4F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC4F,
        0x0000FC4F,
        0x0000FC4F
    };

    static Char _decompositionMapping0000FC50[] = 
    {
        0x00000646,
        0x0000064A
    };

    static _CharacterInfo _character0000FC50 =
    {
        0x0000FC50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC50,
        0x0000FC50,
        0x0000FC50
    };

    static Char _decompositionMapping0000FC51[] = 
    {
        0x00000647,
        0x0000062C
    };

    static _CharacterInfo _character0000FC51 =
    {
        0x0000FC51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC51,
        0x0000FC51,
        0x0000FC51
    };

    static Char _decompositionMapping0000FC52[] = 
    {
        0x00000647,
        0x00000645
    };

    static _CharacterInfo _character0000FC52 =
    {
        0x0000FC52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC52,
        0x0000FC52,
        0x0000FC52
    };

    static Char _decompositionMapping0000FC53[] = 
    {
        0x00000647,
        0x00000649
    };

    static _CharacterInfo _character0000FC53 =
    {
        0x0000FC53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC53,
        0x0000FC53,
        0x0000FC53
    };

    static Char _decompositionMapping0000FC54[] = 
    {
        0x00000647,
        0x0000064A
    };

    static _CharacterInfo _character0000FC54 =
    {
        0x0000FC54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC54,
        0x0000FC54,
        0x0000FC54
    };

    static Char _decompositionMapping0000FC55[] = 
    {
        0x0000064A,
        0x0000062C
    };

    static _CharacterInfo _character0000FC55 =
    {
        0x0000FC55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC55,
        0x0000FC55,
        0x0000FC55
    };

    static Char _decompositionMapping0000FC56[] = 
    {
        0x0000064A,
        0x0000062D
    };

    static _CharacterInfo _character0000FC56 =
    {
        0x0000FC56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC56,
        0x0000FC56,
        0x0000FC56
    };

    static Char _decompositionMapping0000FC57[] = 
    {
        0x0000064A,
        0x0000062E
    };

    static _CharacterInfo _character0000FC57 =
    {
        0x0000FC57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC57,
        0x0000FC57,
        0x0000FC57
    };

    static Char _decompositionMapping0000FC58[] = 
    {
        0x0000064A,
        0x00000645
    };

    static _CharacterInfo _character0000FC58 =
    {
        0x0000FC58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC58,
        0x0000FC58,
        0x0000FC58
    };

    static Char _decompositionMapping0000FC59[] = 
    {
        0x0000064A,
        0x00000649
    };

    static _CharacterInfo _character0000FC59 =
    {
        0x0000FC59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC59,
        0x0000FC59,
        0x0000FC59
    };

    static Char _decompositionMapping0000FC5A[] = 
    {
        0x0000064A,
        0x0000064A
    };

    static _CharacterInfo _character0000FC5A =
    {
        0x0000FC5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5A,
        0x0000FC5A,
        0x0000FC5A
    };

    static Char _decompositionMapping0000FC5B[] = 
    {
        0x00000630,
        0x00000670
    };

    static _CharacterInfo _character0000FC5B =
    {
        0x0000FC5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5B,
        0x0000FC5B,
        0x0000FC5B
    };

    static Char _decompositionMapping0000FC5C[] = 
    {
        0x00000631,
        0x00000670
    };

    static _CharacterInfo _character0000FC5C =
    {
        0x0000FC5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5C,
        0x0000FC5C,
        0x0000FC5C
    };

    static Char _decompositionMapping0000FC5D[] = 
    {
        0x00000649,
        0x00000670
    };

    static _CharacterInfo _character0000FC5D =
    {
        0x0000FC5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FC5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5D,
        0x0000FC5D,
        0x0000FC5D
    };

    static Char _decompositionMapping0000FC5E[] = 
    {
        0x00000020,
        0x0000064C,
        0x00000651
    };

    static _CharacterInfo _character0000FC5E =
    {
        0x0000FC5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5E,
        0x0000FC5E,
        0x0000FC5E
    };

    static Char _decompositionMapping0000FC5F[] = 
    {
        0x00000020,
        0x0000064D,
        0x00000651
    };

    static _CharacterInfo _character0000FC5F =
    {
        0x0000FC5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC5F,
        0x0000FC5F,
        0x0000FC5F
    };

    static Char _decompositionMapping0000FC60[] = 
    {
        0x00000020,
        0x0000064E,
        0x00000651
    };

    static _CharacterInfo _character0000FC60 =
    {
        0x0000FC60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC60,
        0x0000FC60,
        0x0000FC60
    };

    static Char _decompositionMapping0000FC61[] = 
    {
        0x00000020,
        0x0000064F,
        0x00000651
    };

    static _CharacterInfo _character0000FC61 =
    {
        0x0000FC61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC61,
        0x0000FC61,
        0x0000FC61
    };

    static Char _decompositionMapping0000FC62[] = 
    {
        0x00000020,
        0x00000650,
        0x00000651
    };

    static _CharacterInfo _character0000FC62 =
    {
        0x0000FC62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC62,
        0x0000FC62,
        0x0000FC62
    };

    static Char _decompositionMapping0000FC63[] = 
    {
        0x00000020,
        0x00000651,
        0x00000670
    };

    static _CharacterInfo _character0000FC63 =
    {
        0x0000FC63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FC63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC63,
        0x0000FC63,
        0x0000FC63
    };

    static Char _decompositionMapping0000FC64[] = 
    {
        0x00000626,
        0x00000631
    };

    static _CharacterInfo _character0000FC64 =
    {
        0x0000FC64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC64,
        0x0000FC64,
        0x0000FC64
    };

    static Char _decompositionMapping0000FC65[] = 
    {
        0x00000626,
        0x00000632
    };

    static _CharacterInfo _character0000FC65 =
    {
        0x0000FC65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC65,
        0x0000FC65,
        0x0000FC65
    };

    static Char _decompositionMapping0000FC66[] = 
    {
        0x00000626,
        0x00000645
    };

    static _CharacterInfo _character0000FC66 =
    {
        0x0000FC66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC66,
        0x0000FC66,
        0x0000FC66
    };

    static Char _decompositionMapping0000FC67[] = 
    {
        0x00000626,
        0x00000646
    };

    static _CharacterInfo _character0000FC67 =
    {
        0x0000FC67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC67,
        0x0000FC67,
        0x0000FC67
    };

    static Char _decompositionMapping0000FC68[] = 
    {
        0x00000626,
        0x00000649
    };

    static _CharacterInfo _character0000FC68 =
    {
        0x0000FC68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC68,
        0x0000FC68,
        0x0000FC68
    };

    static Char _decompositionMapping0000FC69[] = 
    {
        0x00000626,
        0x0000064A
    };

    static _CharacterInfo _character0000FC69 =
    {
        0x0000FC69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC69,
        0x0000FC69,
        0x0000FC69
    };

    static Char _decompositionMapping0000FC6A[] = 
    {
        0x00000628,
        0x00000631
    };

    static _CharacterInfo _character0000FC6A =
    {
        0x0000FC6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6A,
        0x0000FC6A,
        0x0000FC6A
    };

    static Char _decompositionMapping0000FC6B[] = 
    {
        0x00000628,
        0x00000632
    };

    static _CharacterInfo _character0000FC6B =
    {
        0x0000FC6B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6B,
        0x0000FC6B,
        0x0000FC6B
    };

    static Char _decompositionMapping0000FC6C[] = 
    {
        0x00000628,
        0x00000645
    };

    static _CharacterInfo _character0000FC6C =
    {
        0x0000FC6C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6C,
        0x0000FC6C,
        0x0000FC6C
    };

    static Char _decompositionMapping0000FC6D[] = 
    {
        0x00000628,
        0x00000646
    };

    static _CharacterInfo _character0000FC6D =
    {
        0x0000FC6D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6D,
        0x0000FC6D,
        0x0000FC6D
    };

    static Char _decompositionMapping0000FC6E[] = 
    {
        0x00000628,
        0x00000649
    };

    static _CharacterInfo _character0000FC6E =
    {
        0x0000FC6E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6E,
        0x0000FC6E,
        0x0000FC6E
    };

    static Char _decompositionMapping0000FC6F[] = 
    {
        0x00000628,
        0x0000064A
    };

    static _CharacterInfo _character0000FC6F =
    {
        0x0000FC6F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC6F,
        0x0000FC6F,
        0x0000FC6F
    };

    static Char _decompositionMapping0000FC70[] = 
    {
        0x0000062A,
        0x00000631
    };

    static _CharacterInfo _character0000FC70 =
    {
        0x0000FC70,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC70,
        0x0000FC70,
        0x0000FC70
    };

    static Char _decompositionMapping0000FC71[] = 
    {
        0x0000062A,
        0x00000632
    };

    static _CharacterInfo _character0000FC71 =
    {
        0x0000FC71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC71,
        0x0000FC71,
        0x0000FC71
    };

    static Char _decompositionMapping0000FC72[] = 
    {
        0x0000062A,
        0x00000645
    };

    static _CharacterInfo _character0000FC72 =
    {
        0x0000FC72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC72,
        0x0000FC72,
        0x0000FC72
    };

    static Char _decompositionMapping0000FC73[] = 
    {
        0x0000062A,
        0x00000646
    };

    static _CharacterInfo _character0000FC73 =
    {
        0x0000FC73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC73,
        0x0000FC73,
        0x0000FC73
    };

    static Char _decompositionMapping0000FC74[] = 
    {
        0x0000062A,
        0x00000649
    };

    static _CharacterInfo _character0000FC74 =
    {
        0x0000FC74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC74,
        0x0000FC74,
        0x0000FC74
    };

    static Char _decompositionMapping0000FC75[] = 
    {
        0x0000062A,
        0x0000064A
    };

    static _CharacterInfo _character0000FC75 =
    {
        0x0000FC75,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC75,
        0x0000FC75,
        0x0000FC75
    };

    static Char _decompositionMapping0000FC76[] = 
    {
        0x0000062B,
        0x00000631
    };

    static _CharacterInfo _character0000FC76 =
    {
        0x0000FC76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC76,
        0x0000FC76,
        0x0000FC76
    };

    static Char _decompositionMapping0000FC77[] = 
    {
        0x0000062B,
        0x00000632
    };

    static _CharacterInfo _character0000FC77 =
    {
        0x0000FC77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC77,
        0x0000FC77,
        0x0000FC77
    };

    static Char _decompositionMapping0000FC78[] = 
    {
        0x0000062B,
        0x00000645
    };

    static _CharacterInfo _character0000FC78 =
    {
        0x0000FC78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC78,
        0x0000FC78,
        0x0000FC78
    };

    static Char _decompositionMapping0000FC79[] = 
    {
        0x0000062B,
        0x00000646
    };

    static _CharacterInfo _character0000FC79 =
    {
        0x0000FC79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC79,
        0x0000FC79,
        0x0000FC79
    };

    static Char _decompositionMapping0000FC7A[] = 
    {
        0x0000062B,
        0x00000649
    };

    static _CharacterInfo _character0000FC7A =
    {
        0x0000FC7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7A,
        0x0000FC7A,
        0x0000FC7A
    };

    static Char _decompositionMapping0000FC7B[] = 
    {
        0x0000062B,
        0x0000064A
    };

    static _CharacterInfo _character0000FC7B =
    {
        0x0000FC7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7B,
        0x0000FC7B,
        0x0000FC7B
    };

    static Char _decompositionMapping0000FC7C[] = 
    {
        0x00000641,
        0x00000649
    };

    static _CharacterInfo _character0000FC7C =
    {
        0x0000FC7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7C,
        0x0000FC7C,
        0x0000FC7C
    };

    static Char _decompositionMapping0000FC7D[] = 
    {
        0x00000641,
        0x0000064A
    };

    static _CharacterInfo _character0000FC7D =
    {
        0x0000FC7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7D,
        0x0000FC7D,
        0x0000FC7D
    };

    static Char _decompositionMapping0000FC7E[] = 
    {
        0x00000642,
        0x00000649
    };

    static _CharacterInfo _character0000FC7E =
    {
        0x0000FC7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7E,
        0x0000FC7E,
        0x0000FC7E
    };

    static Char _decompositionMapping0000FC7F[] = 
    {
        0x00000642,
        0x0000064A
    };

    static _CharacterInfo _character0000FC7F =
    {
        0x0000FC7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC7F,
        0x0000FC7F,
        0x0000FC7F
    };

    static Char _decompositionMapping0000FC80[] = 
    {
        0x00000643,
        0x00000627
    };

    static _CharacterInfo _character0000FC80 =
    {
        0x0000FC80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC80,
        0x0000FC80,
        0x0000FC80
    };

    static Char _decompositionMapping0000FC81[] = 
    {
        0x00000643,
        0x00000644
    };

    static _CharacterInfo _character0000FC81 =
    {
        0x0000FC81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC81,
        0x0000FC81,
        0x0000FC81
    };

    static Char _decompositionMapping0000FC82[] = 
    {
        0x00000643,
        0x00000645
    };

    static _CharacterInfo _character0000FC82 =
    {
        0x0000FC82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC82,
        0x0000FC82,
        0x0000FC82
    };

    static Char _decompositionMapping0000FC83[] = 
    {
        0x00000643,
        0x00000649
    };

    static _CharacterInfo _character0000FC83 =
    {
        0x0000FC83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC83,
        0x0000FC83,
        0x0000FC83
    };

    static Char _decompositionMapping0000FC84[] = 
    {
        0x00000643,
        0x0000064A
    };

    static _CharacterInfo _character0000FC84 =
    {
        0x0000FC84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC84,
        0x0000FC84,
        0x0000FC84
    };

    static Char _decompositionMapping0000FC85[] = 
    {
        0x00000644,
        0x00000645
    };

    static _CharacterInfo _character0000FC85 =
    {
        0x0000FC85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC85,
        0x0000FC85,
        0x0000FC85
    };

    static Char _decompositionMapping0000FC86[] = 
    {
        0x00000644,
        0x00000649
    };

    static _CharacterInfo _character0000FC86 =
    {
        0x0000FC86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC86,
        0x0000FC86,
        0x0000FC86
    };

    static Char _decompositionMapping0000FC87[] = 
    {
        0x00000644,
        0x0000064A
    };

    static _CharacterInfo _character0000FC87 =
    {
        0x0000FC87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC87,
        0x0000FC87,
        0x0000FC87
    };

    static Char _decompositionMapping0000FC88[] = 
    {
        0x00000645,
        0x00000627
    };

    static _CharacterInfo _character0000FC88 =
    {
        0x0000FC88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC88,
        0x0000FC88,
        0x0000FC88
    };

    static Char _decompositionMapping0000FC89[] = 
    {
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FC89 =
    {
        0x0000FC89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC89,
        0x0000FC89,
        0x0000FC89
    };

    static Char _decompositionMapping0000FC8A[] = 
    {
        0x00000646,
        0x00000631
    };

    static _CharacterInfo _character0000FC8A =
    {
        0x0000FC8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8A,
        0x0000FC8A,
        0x0000FC8A
    };

    static Char _decompositionMapping0000FC8B[] = 
    {
        0x00000646,
        0x00000632
    };

    static _CharacterInfo _character0000FC8B =
    {
        0x0000FC8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8B,
        0x0000FC8B,
        0x0000FC8B
    };

    static Char _decompositionMapping0000FC8C[] = 
    {
        0x00000646,
        0x00000645
    };

    static _CharacterInfo _character0000FC8C =
    {
        0x0000FC8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8C,
        0x0000FC8C,
        0x0000FC8C
    };

    static Char _decompositionMapping0000FC8D[] = 
    {
        0x00000646,
        0x00000646
    };

    static _CharacterInfo _character0000FC8D =
    {
        0x0000FC8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8D,
        0x0000FC8D,
        0x0000FC8D
    };

    static Char _decompositionMapping0000FC8E[] = 
    {
        0x00000646,
        0x00000649
    };

    static _CharacterInfo _character0000FC8E =
    {
        0x0000FC8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8E,
        0x0000FC8E,
        0x0000FC8E
    };

    static Char _decompositionMapping0000FC8F[] = 
    {
        0x00000646,
        0x0000064A
    };

    static _CharacterInfo _character0000FC8F =
    {
        0x0000FC8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC8F,
        0x0000FC8F,
        0x0000FC8F
    };

    static Char _decompositionMapping0000FC90[] = 
    {
        0x00000649,
        0x00000670
    };

    static _CharacterInfo _character0000FC90 =
    {
        0x0000FC90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC90,
        0x0000FC90,
        0x0000FC90
    };

    static Char _decompositionMapping0000FC91[] = 
    {
        0x0000064A,
        0x00000631
    };

    static _CharacterInfo _character0000FC91 =
    {
        0x0000FC91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC91,
        0x0000FC91,
        0x0000FC91
    };

    static Char _decompositionMapping0000FC92[] = 
    {
        0x0000064A,
        0x00000632
    };

    static _CharacterInfo _character0000FC92 =
    {
        0x0000FC92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC92,
        0x0000FC92,
        0x0000FC92
    };

    static Char _decompositionMapping0000FC93[] = 
    {
        0x0000064A,
        0x00000645
    };

    static _CharacterInfo _character0000FC93 =
    {
        0x0000FC93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC93,
        0x0000FC93,
        0x0000FC93
    };

    static Char _decompositionMapping0000FC94[] = 
    {
        0x0000064A,
        0x00000646
    };

    static _CharacterInfo _character0000FC94 =
    {
        0x0000FC94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC94,
        0x0000FC94,
        0x0000FC94
    };

    static Char _decompositionMapping0000FC95[] = 
    {
        0x0000064A,
        0x00000649
    };

    static _CharacterInfo _character0000FC95 =
    {
        0x0000FC95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC95,
        0x0000FC95,
        0x0000FC95
    };

    static Char _decompositionMapping0000FC96[] = 
    {
        0x0000064A,
        0x0000064A
    };

    static _CharacterInfo _character0000FC96 =
    {
        0x0000FC96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FC96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC96,
        0x0000FC96,
        0x0000FC96
    };

    static Char _decompositionMapping0000FC97[] = 
    {
        0x00000626,
        0x0000062C
    };

    static _CharacterInfo _character0000FC97 =
    {
        0x0000FC97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC97,
        0x0000FC97,
        0x0000FC97
    };

    static Char _decompositionMapping0000FC98[] = 
    {
        0x00000626,
        0x0000062D
    };

    static _CharacterInfo _character0000FC98 =
    {
        0x0000FC98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC98,
        0x0000FC98,
        0x0000FC98
    };

    static Char _decompositionMapping0000FC99[] = 
    {
        0x00000626,
        0x0000062E
    };

    static _CharacterInfo _character0000FC99 =
    {
        0x0000FC99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC99,
        0x0000FC99,
        0x0000FC99
    };

    static Char _decompositionMapping0000FC9A[] = 
    {
        0x00000626,
        0x00000645
    };

    static _CharacterInfo _character0000FC9A =
    {
        0x0000FC9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9A,
        0x0000FC9A,
        0x0000FC9A
    };

    static Char _decompositionMapping0000FC9B[] = 
    {
        0x00000626,
        0x00000647
    };

    static _CharacterInfo _character0000FC9B =
    {
        0x0000FC9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9B,
        0x0000FC9B,
        0x0000FC9B
    };

    static Char _decompositionMapping0000FC9C[] = 
    {
        0x00000628,
        0x0000062C
    };

    static _CharacterInfo _character0000FC9C =
    {
        0x0000FC9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9C,
        0x0000FC9C,
        0x0000FC9C
    };

    static Char _decompositionMapping0000FC9D[] = 
    {
        0x00000628,
        0x0000062D
    };

    static _CharacterInfo _character0000FC9D =
    {
        0x0000FC9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9D,
        0x0000FC9D,
        0x0000FC9D
    };

    static Char _decompositionMapping0000FC9E[] = 
    {
        0x00000628,
        0x0000062E
    };

    static _CharacterInfo _character0000FC9E =
    {
        0x0000FC9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9E,
        0x0000FC9E,
        0x0000FC9E
    };

    static Char _decompositionMapping0000FC9F[] = 
    {
        0x00000628,
        0x00000645
    };

    static _CharacterInfo _character0000FC9F =
    {
        0x0000FC9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FC9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FC9F,
        0x0000FC9F,
        0x0000FC9F
    };

    static Char _decompositionMapping0000FCA0[] = 
    {
        0x00000628,
        0x00000647
    };

    static _CharacterInfo _character0000FCA0 =
    {
        0x0000FCA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA0,
        0x0000FCA0,
        0x0000FCA0
    };

    static Char _decompositionMapping0000FCA1[] = 
    {
        0x0000062A,
        0x0000062C
    };

    static _CharacterInfo _character0000FCA1 =
    {
        0x0000FCA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA1,
        0x0000FCA1,
        0x0000FCA1
    };

    static Char _decompositionMapping0000FCA2[] = 
    {
        0x0000062A,
        0x0000062D
    };

    static _CharacterInfo _character0000FCA2 =
    {
        0x0000FCA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA2,
        0x0000FCA2,
        0x0000FCA2
    };

    static Char _decompositionMapping0000FCA3[] = 
    {
        0x0000062A,
        0x0000062E
    };

    static _CharacterInfo _character0000FCA3 =
    {
        0x0000FCA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA3,
        0x0000FCA3,
        0x0000FCA3
    };

    static Char _decompositionMapping0000FCA4[] = 
    {
        0x0000062A,
        0x00000645
    };

    static _CharacterInfo _character0000FCA4 =
    {
        0x0000FCA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA4,
        0x0000FCA4,
        0x0000FCA4
    };

    static Char _decompositionMapping0000FCA5[] = 
    {
        0x0000062A,
        0x00000647
    };

    static _CharacterInfo _character0000FCA5 =
    {
        0x0000FCA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA5,
        0x0000FCA5,
        0x0000FCA5
    };

    static Char _decompositionMapping0000FCA6[] = 
    {
        0x0000062B,
        0x00000645
    };

    static _CharacterInfo _character0000FCA6 =
    {
        0x0000FCA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA6,
        0x0000FCA6,
        0x0000FCA6
    };

    static Char _decompositionMapping0000FCA7[] = 
    {
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FCA7 =
    {
        0x0000FCA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA7,
        0x0000FCA7,
        0x0000FCA7
    };

    static Char _decompositionMapping0000FCA8[] = 
    {
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FCA8 =
    {
        0x0000FCA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA8,
        0x0000FCA8,
        0x0000FCA8
    };

    static Char _decompositionMapping0000FCA9[] = 
    {
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FCA9 =
    {
        0x0000FCA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCA9,
        0x0000FCA9,
        0x0000FCA9
    };

    static Char _decompositionMapping0000FCAA[] = 
    {
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FCAA =
    {
        0x0000FCAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAA,
        0x0000FCAA,
        0x0000FCAA
    };

    static Char _decompositionMapping0000FCAB[] = 
    {
        0x0000062E,
        0x0000062C
    };

    static _CharacterInfo _character0000FCAB =
    {
        0x0000FCAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAB,
        0x0000FCAB,
        0x0000FCAB
    };

    static Char _decompositionMapping0000FCAC[] = 
    {
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FCAC =
    {
        0x0000FCAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAC,
        0x0000FCAC,
        0x0000FCAC
    };

    static Char _decompositionMapping0000FCAD[] = 
    {
        0x00000633,
        0x0000062C
    };

    static _CharacterInfo _character0000FCAD =
    {
        0x0000FCAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAD,
        0x0000FCAD,
        0x0000FCAD
    };

    static Char _decompositionMapping0000FCAE[] = 
    {
        0x00000633,
        0x0000062D
    };

    static _CharacterInfo _character0000FCAE =
    {
        0x0000FCAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAE,
        0x0000FCAE,
        0x0000FCAE
    };

    static Char _decompositionMapping0000FCAF[] = 
    {
        0x00000633,
        0x0000062E
    };

    static _CharacterInfo _character0000FCAF =
    {
        0x0000FCAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCAF,
        0x0000FCAF,
        0x0000FCAF
    };

    static Char _decompositionMapping0000FCB0[] = 
    {
        0x00000633,
        0x00000645
    };

    static _CharacterInfo _character0000FCB0 =
    {
        0x0000FCB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB0,
        0x0000FCB0,
        0x0000FCB0
    };

    static Char _decompositionMapping0000FCB1[] = 
    {
        0x00000635,
        0x0000062D
    };

    static _CharacterInfo _character0000FCB1 =
    {
        0x0000FCB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB1,
        0x0000FCB1,
        0x0000FCB1
    };

    static Char _decompositionMapping0000FCB2[] = 
    {
        0x00000635,
        0x0000062E
    };

    static _CharacterInfo _character0000FCB2 =
    {
        0x0000FCB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB2,
        0x0000FCB2,
        0x0000FCB2
    };

    static Char _decompositionMapping0000FCB3[] = 
    {
        0x00000635,
        0x00000645
    };

    static _CharacterInfo _character0000FCB3 =
    {
        0x0000FCB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB3,
        0x0000FCB3,
        0x0000FCB3
    };

    static Char _decompositionMapping0000FCB4[] = 
    {
        0x00000636,
        0x0000062C
    };

    static _CharacterInfo _character0000FCB4 =
    {
        0x0000FCB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB4,
        0x0000FCB4,
        0x0000FCB4
    };

    static Char _decompositionMapping0000FCB5[] = 
    {
        0x00000636,
        0x0000062D
    };

    static _CharacterInfo _character0000FCB5 =
    {
        0x0000FCB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB5,
        0x0000FCB5,
        0x0000FCB5
    };

    static Char _decompositionMapping0000FCB6[] = 
    {
        0x00000636,
        0x0000062E
    };

    static _CharacterInfo _character0000FCB6 =
    {
        0x0000FCB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB6,
        0x0000FCB6,
        0x0000FCB6
    };

    static Char _decompositionMapping0000FCB7[] = 
    {
        0x00000636,
        0x00000645
    };

    static _CharacterInfo _character0000FCB7 =
    {
        0x0000FCB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB7,
        0x0000FCB7,
        0x0000FCB7
    };

    static Char _decompositionMapping0000FCB8[] = 
    {
        0x00000637,
        0x0000062D
    };

    static _CharacterInfo _character0000FCB8 =
    {
        0x0000FCB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB8,
        0x0000FCB8,
        0x0000FCB8
    };

    static Char _decompositionMapping0000FCB9[] = 
    {
        0x00000638,
        0x00000645
    };

    static _CharacterInfo _character0000FCB9 =
    {
        0x0000FCB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCB9,
        0x0000FCB9,
        0x0000FCB9
    };

    static Char _decompositionMapping0000FCBA[] = 
    {
        0x00000639,
        0x0000062C
    };

    static _CharacterInfo _character0000FCBA =
    {
        0x0000FCBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBA,
        0x0000FCBA,
        0x0000FCBA
    };

    static Char _decompositionMapping0000FCBB[] = 
    {
        0x00000639,
        0x00000645
    };

    static _CharacterInfo _character0000FCBB =
    {
        0x0000FCBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBB,
        0x0000FCBB,
        0x0000FCBB
    };

    static Char _decompositionMapping0000FCBC[] = 
    {
        0x0000063A,
        0x0000062C
    };

    static _CharacterInfo _character0000FCBC =
    {
        0x0000FCBC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBC,
        0x0000FCBC,
        0x0000FCBC
    };

    static Char _decompositionMapping0000FCBD[] = 
    {
        0x0000063A,
        0x00000645
    };

    static _CharacterInfo _character0000FCBD =
    {
        0x0000FCBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBD,
        0x0000FCBD,
        0x0000FCBD
    };

    static Char _decompositionMapping0000FCBE[] = 
    {
        0x00000641,
        0x0000062C
    };

    static _CharacterInfo _character0000FCBE =
    {
        0x0000FCBE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBE,
        0x0000FCBE,
        0x0000FCBE
    };

    static Char _decompositionMapping0000FCBF[] = 
    {
        0x00000641,
        0x0000062D
    };

    static _CharacterInfo _character0000FCBF =
    {
        0x0000FCBF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCBF,
        0x0000FCBF,
        0x0000FCBF
    };

    static Char _decompositionMapping0000FCC0[] = 
    {
        0x00000641,
        0x0000062E
    };

    static _CharacterInfo _character0000FCC0 =
    {
        0x0000FCC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC0,
        0x0000FCC0,
        0x0000FCC0
    };

    static Char _decompositionMapping0000FCC1[] = 
    {
        0x00000641,
        0x00000645
    };

    static _CharacterInfo _character0000FCC1 =
    {
        0x0000FCC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC1,
        0x0000FCC1,
        0x0000FCC1
    };

    static Char _decompositionMapping0000FCC2[] = 
    {
        0x00000642,
        0x0000062D
    };

    static _CharacterInfo _character0000FCC2 =
    {
        0x0000FCC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC2,
        0x0000FCC2,
        0x0000FCC2
    };

    static Char _decompositionMapping0000FCC3[] = 
    {
        0x00000642,
        0x00000645
    };

    static _CharacterInfo _character0000FCC3 =
    {
        0x0000FCC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC3,
        0x0000FCC3,
        0x0000FCC3
    };

    static Char _decompositionMapping0000FCC4[] = 
    {
        0x00000643,
        0x0000062C
    };

    static _CharacterInfo _character0000FCC4 =
    {
        0x0000FCC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC4,
        0x0000FCC4,
        0x0000FCC4
    };

    static Char _decompositionMapping0000FCC5[] = 
    {
        0x00000643,
        0x0000062D
    };

    static _CharacterInfo _character0000FCC5 =
    {
        0x0000FCC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC5,
        0x0000FCC5,
        0x0000FCC5
    };

    static Char _decompositionMapping0000FCC6[] = 
    {
        0x00000643,
        0x0000062E
    };

    static _CharacterInfo _character0000FCC6 =
    {
        0x0000FCC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC6,
        0x0000FCC6,
        0x0000FCC6
    };

    static Char _decompositionMapping0000FCC7[] = 
    {
        0x00000643,
        0x00000644
    };

    static _CharacterInfo _character0000FCC7 =
    {
        0x0000FCC7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC7,
        0x0000FCC7,
        0x0000FCC7
    };

    static Char _decompositionMapping0000FCC8[] = 
    {
        0x00000643,
        0x00000645
    };

    static _CharacterInfo _character0000FCC8 =
    {
        0x0000FCC8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC8,
        0x0000FCC8,
        0x0000FCC8
    };

    static Char _decompositionMapping0000FCC9[] = 
    {
        0x00000644,
        0x0000062C
    };

    static _CharacterInfo _character0000FCC9 =
    {
        0x0000FCC9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCC9,
        0x0000FCC9,
        0x0000FCC9
    };

    static Char _decompositionMapping0000FCCA[] = 
    {
        0x00000644,
        0x0000062D
    };

    static _CharacterInfo _character0000FCCA =
    {
        0x0000FCCA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCA,
        0x0000FCCA,
        0x0000FCCA
    };

    static Char _decompositionMapping0000FCCB[] = 
    {
        0x00000644,
        0x0000062E
    };

    static _CharacterInfo _character0000FCCB =
    {
        0x0000FCCB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCB,
        0x0000FCCB,
        0x0000FCCB
    };

    static Char _decompositionMapping0000FCCC[] = 
    {
        0x00000644,
        0x00000645
    };

    static _CharacterInfo _character0000FCCC =
    {
        0x0000FCCC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCC,
        0x0000FCCC,
        0x0000FCCC
    };

    static Char _decompositionMapping0000FCCD[] = 
    {
        0x00000644,
        0x00000647
    };

    static _CharacterInfo _character0000FCCD =
    {
        0x0000FCCD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCD,
        0x0000FCCD,
        0x0000FCCD
    };

    static Char _decompositionMapping0000FCCE[] = 
    {
        0x00000645,
        0x0000062C
    };

    static _CharacterInfo _character0000FCCE =
    {
        0x0000FCCE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCE,
        0x0000FCCE,
        0x0000FCCE
    };

    static Char _decompositionMapping0000FCCF[] = 
    {
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FCCF =
    {
        0x0000FCCF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCCF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCCF,
        0x0000FCCF,
        0x0000FCCF
    };

    static Char _decompositionMapping0000FCD0[] = 
    {
        0x00000645,
        0x0000062E
    };

    static _CharacterInfo _character0000FCD0 =
    {
        0x0000FCD0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD0,
        0x0000FCD0,
        0x0000FCD0
    };

    static Char _decompositionMapping0000FCD1[] = 
    {
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FCD1 =
    {
        0x0000FCD1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD1,
        0x0000FCD1,
        0x0000FCD1
    };

    static Char _decompositionMapping0000FCD2[] = 
    {
        0x00000646,
        0x0000062C
    };

    static _CharacterInfo _character0000FCD2 =
    {
        0x0000FCD2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD2,
        0x0000FCD2,
        0x0000FCD2
    };

    static Char _decompositionMapping0000FCD3[] = 
    {
        0x00000646,
        0x0000062D
    };

    static _CharacterInfo _character0000FCD3 =
    {
        0x0000FCD3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD3,
        0x0000FCD3,
        0x0000FCD3
    };

    static Char _decompositionMapping0000FCD4[] = 
    {
        0x00000646,
        0x0000062E
    };

    static _CharacterInfo _character0000FCD4 =
    {
        0x0000FCD4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD4,
        0x0000FCD4,
        0x0000FCD4
    };

    static Char _decompositionMapping0000FCD5[] = 
    {
        0x00000646,
        0x00000645
    };

    static _CharacterInfo _character0000FCD5 =
    {
        0x0000FCD5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD5,
        0x0000FCD5,
        0x0000FCD5
    };

    static Char _decompositionMapping0000FCD6[] = 
    {
        0x00000646,
        0x00000647
    };

    static _CharacterInfo _character0000FCD6 =
    {
        0x0000FCD6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD6,
        0x0000FCD6,
        0x0000FCD6
    };

    static Char _decompositionMapping0000FCD7[] = 
    {
        0x00000647,
        0x0000062C
    };

    static _CharacterInfo _character0000FCD7 =
    {
        0x0000FCD7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD7,
        0x0000FCD7,
        0x0000FCD7
    };

    static Char _decompositionMapping0000FCD8[] = 
    {
        0x00000647,
        0x00000645
    };

    static _CharacterInfo _character0000FCD8 =
    {
        0x0000FCD8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD8,
        0x0000FCD8,
        0x0000FCD8
    };

    static Char _decompositionMapping0000FCD9[] = 
    {
        0x00000647,
        0x00000670
    };

    static _CharacterInfo _character0000FCD9 =
    {
        0x0000FCD9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCD9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCD9,
        0x0000FCD9,
        0x0000FCD9
    };

    static Char _decompositionMapping0000FCDA[] = 
    {
        0x0000064A,
        0x0000062C
    };

    static _CharacterInfo _character0000FCDA =
    {
        0x0000FCDA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDA,
        0x0000FCDA,
        0x0000FCDA
    };

    static Char _decompositionMapping0000FCDB[] = 
    {
        0x0000064A,
        0x0000062D
    };

    static _CharacterInfo _character0000FCDB =
    {
        0x0000FCDB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDB,
        0x0000FCDB,
        0x0000FCDB
    };

    static Char _decompositionMapping0000FCDC[] = 
    {
        0x0000064A,
        0x0000062E
    };

    static _CharacterInfo _character0000FCDC =
    {
        0x0000FCDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDC,
        0x0000FCDC,
        0x0000FCDC
    };

    static Char _decompositionMapping0000FCDD[] = 
    {
        0x0000064A,
        0x00000645
    };

    static _CharacterInfo _character0000FCDD =
    {
        0x0000FCDD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDD,
        0x0000FCDD,
        0x0000FCDD
    };

    static Char _decompositionMapping0000FCDE[] = 
    {
        0x0000064A,
        0x00000647
    };

    static _CharacterInfo _character0000FCDE =
    {
        0x0000FCDE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FCDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDE,
        0x0000FCDE,
        0x0000FCDE
    };

    static Char _decompositionMapping0000FCDF[] = 
    {
        0x00000626,
        0x00000645
    };

    static _CharacterInfo _character0000FCDF =
    {
        0x0000FCDF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCDF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCDF,
        0x0000FCDF,
        0x0000FCDF
    };

    static Char _decompositionMapping0000FCE0[] = 
    {
        0x00000626,
        0x00000647
    };

    static _CharacterInfo _character0000FCE0 =
    {
        0x0000FCE0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE0,
        0x0000FCE0,
        0x0000FCE0
    };

    static Char _decompositionMapping0000FCE1[] = 
    {
        0x00000628,
        0x00000645
    };

    static _CharacterInfo _character0000FCE1 =
    {
        0x0000FCE1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE1,
        0x0000FCE1,
        0x0000FCE1
    };

    static Char _decompositionMapping0000FCE2[] = 
    {
        0x00000628,
        0x00000647
    };

    static _CharacterInfo _character0000FCE2 =
    {
        0x0000FCE2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE2,
        0x0000FCE2,
        0x0000FCE2
    };

    static Char _decompositionMapping0000FCE3[] = 
    {
        0x0000062A,
        0x00000645
    };

    static _CharacterInfo _character0000FCE3 =
    {
        0x0000FCE3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE3,
        0x0000FCE3,
        0x0000FCE3
    };

    static Char _decompositionMapping0000FCE4[] = 
    {
        0x0000062A,
        0x00000647
    };

    static _CharacterInfo _character0000FCE4 =
    {
        0x0000FCE4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE4,
        0x0000FCE4,
        0x0000FCE4
    };

    static Char _decompositionMapping0000FCE5[] = 
    {
        0x0000062B,
        0x00000645
    };

    static _CharacterInfo _character0000FCE5 =
    {
        0x0000FCE5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE5,
        0x0000FCE5,
        0x0000FCE5
    };

    static Char _decompositionMapping0000FCE6[] = 
    {
        0x0000062B,
        0x00000647
    };

    static _CharacterInfo _character0000FCE6 =
    {
        0x0000FCE6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE6,
        0x0000FCE6,
        0x0000FCE6
    };

    static Char _decompositionMapping0000FCE7[] = 
    {
        0x00000633,
        0x00000645
    };

    static _CharacterInfo _character0000FCE7 =
    {
        0x0000FCE7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE7,
        0x0000FCE7,
        0x0000FCE7
    };

    static Char _decompositionMapping0000FCE8[] = 
    {
        0x00000633,
        0x00000647
    };

    static _CharacterInfo _character0000FCE8 =
    {
        0x0000FCE8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE8,
        0x0000FCE8,
        0x0000FCE8
    };

    static Char _decompositionMapping0000FCE9[] = 
    {
        0x00000634,
        0x00000645
    };

    static _CharacterInfo _character0000FCE9 =
    {
        0x0000FCE9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCE9,
        0x0000FCE9,
        0x0000FCE9
    };

    static Char _decompositionMapping0000FCEA[] = 
    {
        0x00000634,
        0x00000647
    };

    static _CharacterInfo _character0000FCEA =
    {
        0x0000FCEA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCEA,
        0x0000FCEA,
        0x0000FCEA
    };

    static Char _decompositionMapping0000FCEB[] = 
    {
        0x00000643,
        0x00000644
    };

    static _CharacterInfo _character0000FCEB =
    {
        0x0000FCEB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCEB,
        0x0000FCEB,
        0x0000FCEB
    };

    static Char _decompositionMapping0000FCEC[] = 
    {
        0x00000643,
        0x00000645
    };

    static _CharacterInfo _character0000FCEC =
    {
        0x0000FCEC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCEC,
        0x0000FCEC,
        0x0000FCEC
    };

    static Char _decompositionMapping0000FCED[] = 
    {
        0x00000644,
        0x00000645
    };

    static _CharacterInfo _character0000FCED =
    {
        0x0000FCED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCED,
        0x0000FCED,
        0x0000FCED
    };

    static Char _decompositionMapping0000FCEE[] = 
    {
        0x00000646,
        0x00000645
    };

    static _CharacterInfo _character0000FCEE =
    {
        0x0000FCEE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCEE,
        0x0000FCEE,
        0x0000FCEE
    };

    static Char _decompositionMapping0000FCEF[] = 
    {
        0x00000646,
        0x00000647
    };

    static _CharacterInfo _character0000FCEF =
    {
        0x0000FCEF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCEF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCEF,
        0x0000FCEF,
        0x0000FCEF
    };

    static Char _decompositionMapping0000FCF0[] = 
    {
        0x0000064A,
        0x00000645
    };

    static _CharacterInfo _character0000FCF0 =
    {
        0x0000FCF0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCF0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF0,
        0x0000FCF0,
        0x0000FCF0
    };

    static Char _decompositionMapping0000FCF1[] = 
    {
        0x0000064A,
        0x00000647
    };

    static _CharacterInfo _character0000FCF1 =
    {
        0x0000FCF1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FCF1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF1,
        0x0000FCF1,
        0x0000FCF1
    };

    static Char _decompositionMapping0000FCF2[] = 
    {
        0x00000640,
        0x0000064E,
        0x00000651
    };

    static _CharacterInfo _character0000FCF2 =
    {
        0x0000FCF2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        3,
        _decompositionMapping0000FCF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF2,
        0x0000FCF2,
        0x0000FCF2
    };

    static Char _decompositionMapping0000FCF3[] = 
    {
        0x00000640,
        0x0000064F,
        0x00000651
    };

    static _CharacterInfo _character0000FCF3 =
    {
        0x0000FCF3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        3,
        _decompositionMapping0000FCF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF3,
        0x0000FCF3,
        0x0000FCF3
    };

    static Char _decompositionMapping0000FCF4[] = 
    {
        0x00000640,
        0x00000650,
        0x00000651
    };

    static _CharacterInfo _character0000FCF4 =
    {
        0x0000FCF4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        3,
        _decompositionMapping0000FCF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF4,
        0x0000FCF4,
        0x0000FCF4
    };

    static Char _decompositionMapping0000FCF5[] = 
    {
        0x00000637,
        0x00000649
    };

    static _CharacterInfo _character0000FCF5 =
    {
        0x0000FCF5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCF5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF5,
        0x0000FCF5,
        0x0000FCF5
    };

    static Char _decompositionMapping0000FCF6[] = 
    {
        0x00000637,
        0x0000064A
    };

    static _CharacterInfo _character0000FCF6 =
    {
        0x0000FCF6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF6,
        0x0000FCF6,
        0x0000FCF6
    };

    static Char _decompositionMapping0000FCF7[] = 
    {
        0x00000639,
        0x00000649
    };

    static _CharacterInfo _character0000FCF7 =
    {
        0x0000FCF7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF7,
        0x0000FCF7,
        0x0000FCF7
    };

    static Char _decompositionMapping0000FCF8[] = 
    {
        0x00000639,
        0x0000064A
    };

    static _CharacterInfo _character0000FCF8 =
    {
        0x0000FCF8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF8,
        0x0000FCF8,
        0x0000FCF8
    };

    static Char _decompositionMapping0000FCF9[] = 
    {
        0x0000063A,
        0x00000649
    };

    static _CharacterInfo _character0000FCF9 =
    {
        0x0000FCF9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCF9,
        0x0000FCF9,
        0x0000FCF9
    };

    static Char _decompositionMapping0000FCFA[] = 
    {
        0x0000063A,
        0x0000064A
    };

    static _CharacterInfo _character0000FCFA =
    {
        0x0000FCFA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFA,
        0x0000FCFA,
        0x0000FCFA
    };

    static Char _decompositionMapping0000FCFB[] = 
    {
        0x00000633,
        0x00000649
    };

    static _CharacterInfo _character0000FCFB =
    {
        0x0000FCFB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFB,
        0x0000FCFB,
        0x0000FCFB
    };

    static Char _decompositionMapping0000FCFC[] = 
    {
        0x00000633,
        0x0000064A
    };

    static _CharacterInfo _character0000FCFC =
    {
        0x0000FCFC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFC,
        0x0000FCFC,
        0x0000FCFC
    };

    static Char _decompositionMapping0000FCFD[] = 
    {
        0x00000634,
        0x00000649
    };

    static _CharacterInfo _character0000FCFD =
    {
        0x0000FCFD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFD,
        0x0000FCFD,
        0x0000FCFD
    };

    static Char _decompositionMapping0000FCFE[] = 
    {
        0x00000634,
        0x0000064A
    };

    static _CharacterInfo _character0000FCFE =
    {
        0x0000FCFE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFE,
        0x0000FCFE,
        0x0000FCFE
    };

    static Char _decompositionMapping0000FCFF[] = 
    {
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FCFF =
    {
        0x0000FCFF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FCFF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FCFF,
        0x0000FCFF,
        0x0000FCFF
    };

    static Char _decompositionMapping0000FD00[] = 
    {
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FD00 =
    {
        0x0000FD00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD00,
        0x0000FD00,
        0x0000FD00
    };

    static Char _decompositionMapping0000FD01[] = 
    {
        0x0000062C,
        0x00000649
    };

    static _CharacterInfo _character0000FD01 =
    {
        0x0000FD01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD01,
        0x0000FD01,
        0x0000FD01
    };

    static Char _decompositionMapping0000FD02[] = 
    {
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FD02 =
    {
        0x0000FD02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD02,
        0x0000FD02,
        0x0000FD02
    };

    static Char _decompositionMapping0000FD03[] = 
    {
        0x0000062E,
        0x00000649
    };

    static _CharacterInfo _character0000FD03 =
    {
        0x0000FD03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD03,
        0x0000FD03,
        0x0000FD03
    };

    static Char _decompositionMapping0000FD04[] = 
    {
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FD04 =
    {
        0x0000FD04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD04,
        0x0000FD04,
        0x0000FD04
    };

    static Char _decompositionMapping0000FD05[] = 
    {
        0x00000635,
        0x00000649
    };

    static _CharacterInfo _character0000FD05 =
    {
        0x0000FD05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD05,
        0x0000FD05,
        0x0000FD05
    };

    static Char _decompositionMapping0000FD06[] = 
    {
        0x00000635,
        0x0000064A
    };

    static _CharacterInfo _character0000FD06 =
    {
        0x0000FD06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD06,
        0x0000FD06,
        0x0000FD06
    };

    static Char _decompositionMapping0000FD07[] = 
    {
        0x00000636,
        0x00000649
    };

    static _CharacterInfo _character0000FD07 =
    {
        0x0000FD07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD07,
        0x0000FD07,
        0x0000FD07
    };

    static Char _decompositionMapping0000FD08[] = 
    {
        0x00000636,
        0x0000064A
    };

    static _CharacterInfo _character0000FD08 =
    {
        0x0000FD08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD08,
        0x0000FD08,
        0x0000FD08
    };

    static Char _decompositionMapping0000FD09[] = 
    {
        0x00000634,
        0x0000062C
    };

    static _CharacterInfo _character0000FD09 =
    {
        0x0000FD09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD09,
        0x0000FD09,
        0x0000FD09
    };

    static Char _decompositionMapping0000FD0A[] = 
    {
        0x00000634,
        0x0000062D
    };

    static _CharacterInfo _character0000FD0A =
    {
        0x0000FD0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0A,
        0x0000FD0A,
        0x0000FD0A
    };

    static Char _decompositionMapping0000FD0B[] = 
    {
        0x00000634,
        0x0000062E
    };

    static _CharacterInfo _character0000FD0B =
    {
        0x0000FD0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0B,
        0x0000FD0B,
        0x0000FD0B
    };

    static Char _decompositionMapping0000FD0C[] = 
    {
        0x00000634,
        0x00000645
    };

    static _CharacterInfo _character0000FD0C =
    {
        0x0000FD0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0C,
        0x0000FD0C,
        0x0000FD0C
    };

    static Char _decompositionMapping0000FD0D[] = 
    {
        0x00000634,
        0x00000631
    };

    static _CharacterInfo _character0000FD0D =
    {
        0x0000FD0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0D,
        0x0000FD0D,
        0x0000FD0D
    };

    static Char _decompositionMapping0000FD0E[] = 
    {
        0x00000633,
        0x00000631
    };

    static _CharacterInfo _character0000FD0E =
    {
        0x0000FD0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0E,
        0x0000FD0E,
        0x0000FD0E
    };

    static Char _decompositionMapping0000FD0F[] = 
    {
        0x00000635,
        0x00000631
    };

    static _CharacterInfo _character0000FD0F =
    {
        0x0000FD0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD0F,
        0x0000FD0F,
        0x0000FD0F
    };

    static Char _decompositionMapping0000FD10[] = 
    {
        0x00000636,
        0x00000631
    };

    static _CharacterInfo _character0000FD10 =
    {
        0x0000FD10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD10,
        0x0000FD10,
        0x0000FD10
    };

    static Char _decompositionMapping0000FD11[] = 
    {
        0x00000637,
        0x00000649
    };

    static _CharacterInfo _character0000FD11 =
    {
        0x0000FD11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD11,
        0x0000FD11,
        0x0000FD11
    };

    static Char _decompositionMapping0000FD12[] = 
    {
        0x00000637,
        0x0000064A
    };

    static _CharacterInfo _character0000FD12 =
    {
        0x0000FD12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD12,
        0x0000FD12,
        0x0000FD12
    };

    static Char _decompositionMapping0000FD13[] = 
    {
        0x00000639,
        0x00000649
    };

    static _CharacterInfo _character0000FD13 =
    {
        0x0000FD13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD13,
        0x0000FD13,
        0x0000FD13
    };

    static Char _decompositionMapping0000FD14[] = 
    {
        0x00000639,
        0x0000064A
    };

    static _CharacterInfo _character0000FD14 =
    {
        0x0000FD14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD14,
        0x0000FD14,
        0x0000FD14
    };

    static Char _decompositionMapping0000FD15[] = 
    {
        0x0000063A,
        0x00000649
    };

    static _CharacterInfo _character0000FD15 =
    {
        0x0000FD15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD15,
        0x0000FD15,
        0x0000FD15
    };

    static Char _decompositionMapping0000FD16[] = 
    {
        0x0000063A,
        0x0000064A
    };

    static _CharacterInfo _character0000FD16 =
    {
        0x0000FD16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD16,
        0x0000FD16,
        0x0000FD16
    };

    static Char _decompositionMapping0000FD17[] = 
    {
        0x00000633,
        0x00000649
    };

    static _CharacterInfo _character0000FD17 =
    {
        0x0000FD17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD17,
        0x0000FD17,
        0x0000FD17
    };

    static Char _decompositionMapping0000FD18[] = 
    {
        0x00000633,
        0x0000064A
    };

    static _CharacterInfo _character0000FD18 =
    {
        0x0000FD18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD18,
        0x0000FD18,
        0x0000FD18
    };

    static Char _decompositionMapping0000FD19[] = 
    {
        0x00000634,
        0x00000649
    };

    static _CharacterInfo _character0000FD19 =
    {
        0x0000FD19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD19,
        0x0000FD19,
        0x0000FD19
    };

    static Char _decompositionMapping0000FD1A[] = 
    {
        0x00000634,
        0x0000064A
    };

    static _CharacterInfo _character0000FD1A =
    {
        0x0000FD1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1A,
        0x0000FD1A,
        0x0000FD1A
    };

    static Char _decompositionMapping0000FD1B[] = 
    {
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FD1B =
    {
        0x0000FD1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1B,
        0x0000FD1B,
        0x0000FD1B
    };

    static Char _decompositionMapping0000FD1C[] = 
    {
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FD1C =
    {
        0x0000FD1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1C,
        0x0000FD1C,
        0x0000FD1C
    };

    static Char _decompositionMapping0000FD1D[] = 
    {
        0x0000062C,
        0x00000649
    };

    static _CharacterInfo _character0000FD1D =
    {
        0x0000FD1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1D,
        0x0000FD1D,
        0x0000FD1D
    };

    static Char _decompositionMapping0000FD1E[] = 
    {
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FD1E =
    {
        0x0000FD1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1E,
        0x0000FD1E,
        0x0000FD1E
    };

    static Char _decompositionMapping0000FD1F[] = 
    {
        0x0000062E,
        0x00000649
    };

    static _CharacterInfo _character0000FD1F =
    {
        0x0000FD1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD1F,
        0x0000FD1F,
        0x0000FD1F
    };

    static Char _decompositionMapping0000FD20[] = 
    {
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FD20 =
    {
        0x0000FD20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD20,
        0x0000FD20,
        0x0000FD20
    };

    static Char _decompositionMapping0000FD21[] = 
    {
        0x00000635,
        0x00000649
    };

    static _CharacterInfo _character0000FD21 =
    {
        0x0000FD21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD21,
        0x0000FD21,
        0x0000FD21
    };

    static Char _decompositionMapping0000FD22[] = 
    {
        0x00000635,
        0x0000064A
    };

    static _CharacterInfo _character0000FD22 =
    {
        0x0000FD22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD22,
        0x0000FD22,
        0x0000FD22
    };

    static Char _decompositionMapping0000FD23[] = 
    {
        0x00000636,
        0x00000649
    };

    static _CharacterInfo _character0000FD23 =
    {
        0x0000FD23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD23,
        0x0000FD23,
        0x0000FD23
    };

    static Char _decompositionMapping0000FD24[] = 
    {
        0x00000636,
        0x0000064A
    };

    static _CharacterInfo _character0000FD24 =
    {
        0x0000FD24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD24,
        0x0000FD24,
        0x0000FD24
    };

    static Char _decompositionMapping0000FD25[] = 
    {
        0x00000634,
        0x0000062C
    };

    static _CharacterInfo _character0000FD25 =
    {
        0x0000FD25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD25,
        0x0000FD25,
        0x0000FD25
    };

    static Char _decompositionMapping0000FD26[] = 
    {
        0x00000634,
        0x0000062D
    };

    static _CharacterInfo _character0000FD26 =
    {
        0x0000FD26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD26,
        0x0000FD26,
        0x0000FD26
    };

    static Char _decompositionMapping0000FD27[] = 
    {
        0x00000634,
        0x0000062E
    };

    static _CharacterInfo _character0000FD27 =
    {
        0x0000FD27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD27,
        0x0000FD27,
        0x0000FD27
    };

    static Char _decompositionMapping0000FD28[] = 
    {
        0x00000634,
        0x00000645
    };

    static _CharacterInfo _character0000FD28 =
    {
        0x0000FD28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD28,
        0x0000FD28,
        0x0000FD28
    };

    static Char _decompositionMapping0000FD29[] = 
    {
        0x00000634,
        0x00000631
    };

    static _CharacterInfo _character0000FD29 =
    {
        0x0000FD29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD29,
        0x0000FD29,
        0x0000FD29
    };

    static Char _decompositionMapping0000FD2A[] = 
    {
        0x00000633,
        0x00000631
    };

    static _CharacterInfo _character0000FD2A =
    {
        0x0000FD2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2A,
        0x0000FD2A,
        0x0000FD2A
    };

    static Char _decompositionMapping0000FD2B[] = 
    {
        0x00000635,
        0x00000631
    };

    static _CharacterInfo _character0000FD2B =
    {
        0x0000FD2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2B,
        0x0000FD2B,
        0x0000FD2B
    };

    static Char _decompositionMapping0000FD2C[] = 
    {
        0x00000636,
        0x00000631
    };

    static _CharacterInfo _character0000FD2C =
    {
        0x0000FD2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2C,
        0x0000FD2C,
        0x0000FD2C
    };

    static Char _decompositionMapping0000FD2D[] = 
    {
        0x00000634,
        0x0000062C
    };

    static _CharacterInfo _character0000FD2D =
    {
        0x0000FD2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2D,
        0x0000FD2D,
        0x0000FD2D
    };

    static Char _decompositionMapping0000FD2E[] = 
    {
        0x00000634,
        0x0000062D
    };

    static _CharacterInfo _character0000FD2E =
    {
        0x0000FD2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2E,
        0x0000FD2E,
        0x0000FD2E
    };

    static Char _decompositionMapping0000FD2F[] = 
    {
        0x00000634,
        0x0000062E
    };

    static _CharacterInfo _character0000FD2F =
    {
        0x0000FD2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD2F,
        0x0000FD2F,
        0x0000FD2F
    };

    static Char _decompositionMapping0000FD30[] = 
    {
        0x00000634,
        0x00000645
    };

    static _CharacterInfo _character0000FD30 =
    {
        0x0000FD30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD30,
        0x0000FD30,
        0x0000FD30
    };

    static Char _decompositionMapping0000FD31[] = 
    {
        0x00000633,
        0x00000647
    };

    static _CharacterInfo _character0000FD31 =
    {
        0x0000FD31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD31,
        0x0000FD31,
        0x0000FD31
    };

    static Char _decompositionMapping0000FD32[] = 
    {
        0x00000634,
        0x00000647
    };

    static _CharacterInfo _character0000FD32 =
    {
        0x0000FD32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD32,
        0x0000FD32,
        0x0000FD32
    };

    static Char _decompositionMapping0000FD33[] = 
    {
        0x00000637,
        0x00000645
    };

    static _CharacterInfo _character0000FD33 =
    {
        0x0000FD33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        2,
        _decompositionMapping0000FD33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD33,
        0x0000FD33,
        0x0000FD33
    };

    static Char _decompositionMapping0000FD34[] = 
    {
        0x00000633,
        0x0000062C
    };

    static _CharacterInfo _character0000FD34 =
    {
        0x0000FD34,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD34,
        0x0000FD34,
        0x0000FD34
    };

    static Char _decompositionMapping0000FD35[] = 
    {
        0x00000633,
        0x0000062D
    };

    static _CharacterInfo _character0000FD35 =
    {
        0x0000FD35,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD35,
        0x0000FD35,
        0x0000FD35
    };

    static Char _decompositionMapping0000FD36[] = 
    {
        0x00000633,
        0x0000062E
    };

    static _CharacterInfo _character0000FD36 =
    {
        0x0000FD36,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD36,
        0x0000FD36,
        0x0000FD36
    };

    static Char _decompositionMapping0000FD37[] = 
    {
        0x00000634,
        0x0000062C
    };

    static _CharacterInfo _character0000FD37 =
    {
        0x0000FD37,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD37,
        0x0000FD37,
        0x0000FD37
    };

    static Char _decompositionMapping0000FD38[] = 
    {
        0x00000634,
        0x0000062D
    };

    static _CharacterInfo _character0000FD38 =
    {
        0x0000FD38,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD38,
        0x0000FD38,
        0x0000FD38
    };

    static Char _decompositionMapping0000FD39[] = 
    {
        0x00000634,
        0x0000062E
    };

    static _CharacterInfo _character0000FD39 =
    {
        0x0000FD39,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD39,
        0x0000FD39,
        0x0000FD39
    };

    static Char _decompositionMapping0000FD3A[] = 
    {
        0x00000637,
        0x00000645
    };

    static _CharacterInfo _character0000FD3A =
    {
        0x0000FD3A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3A,
        0x0000FD3A,
        0x0000FD3A
    };

    static Char _decompositionMapping0000FD3B[] = 
    {
        0x00000638,
        0x00000645
    };

    static _CharacterInfo _character0000FD3B =
    {
        0x0000FD3B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FD3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3B,
        0x0000FD3B,
        0x0000FD3B
    };

    static Char _decompositionMapping0000FD3C[] = 
    {
        0x00000627,
        0x0000064B
    };

    static _CharacterInfo _character0000FD3C =
    {
        0x0000FD3C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FD3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3C,
        0x0000FD3C,
        0x0000FD3C
    };

    static Char _decompositionMapping0000FD3D[] = 
    {
        0x00000627,
        0x0000064B
    };

    static _CharacterInfo _character0000FD3D =
    {
        0x0000FD3D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FD3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3D,
        0x0000FD3D,
        0x0000FD3D
    };

    static _CharacterInfo _character0000FD3E =
    {
        0x0000FD3E,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3E,
        0x0000FD3E,
        0x0000FD3E
    };

    static _CharacterInfo _character0000FD3F =
    {
        0x0000FD3F,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD3F,
        0x0000FD3F,
        0x0000FD3F
    };

    static Char _decompositionMapping0000FD50[] = 
    {
        0x0000062A,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FD50 =
    {
        0x0000FD50,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD50,
        0x0000FD50,
        0x0000FD50
    };

    static Char _decompositionMapping0000FD51[] = 
    {
        0x0000062A,
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FD51 =
    {
        0x0000FD51,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD51,
        0x0000FD51,
        0x0000FD51
    };

    static Char _decompositionMapping0000FD52[] = 
    {
        0x0000062A,
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FD52 =
    {
        0x0000FD52,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD52,
        0x0000FD52,
        0x0000FD52
    };

    static Char _decompositionMapping0000FD53[] = 
    {
        0x0000062A,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD53 =
    {
        0x0000FD53,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD53,
        0x0000FD53,
        0x0000FD53
    };

    static Char _decompositionMapping0000FD54[] = 
    {
        0x0000062A,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD54 =
    {
        0x0000FD54,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD54,
        0x0000FD54,
        0x0000FD54
    };

    static Char _decompositionMapping0000FD55[] = 
    {
        0x0000062A,
        0x00000645,
        0x0000062C
    };

    static _CharacterInfo _character0000FD55 =
    {
        0x0000FD55,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD55,
        0x0000FD55,
        0x0000FD55
    };

    static Char _decompositionMapping0000FD56[] = 
    {
        0x0000062A,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD56 =
    {
        0x0000FD56,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD56,
        0x0000FD56,
        0x0000FD56
    };

    static Char _decompositionMapping0000FD57[] = 
    {
        0x0000062A,
        0x00000645,
        0x0000062E
    };

    static _CharacterInfo _character0000FD57 =
    {
        0x0000FD57,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD57,
        0x0000FD57,
        0x0000FD57
    };

    static Char _decompositionMapping0000FD58[] = 
    {
        0x0000062C,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD58 =
    {
        0x0000FD58,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD58,
        0x0000FD58,
        0x0000FD58
    };

    static Char _decompositionMapping0000FD59[] = 
    {
        0x0000062C,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD59 =
    {
        0x0000FD59,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD59,
        0x0000FD59,
        0x0000FD59
    };

    static Char _decompositionMapping0000FD5A[] = 
    {
        0x0000062D,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FD5A =
    {
        0x0000FD5A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5A,
        0x0000FD5A,
        0x0000FD5A
    };

    static Char _decompositionMapping0000FD5B[] = 
    {
        0x0000062D,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FD5B =
    {
        0x0000FD5B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5B,
        0x0000FD5B,
        0x0000FD5B
    };

    static Char _decompositionMapping0000FD5C[] = 
    {
        0x00000633,
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FD5C =
    {
        0x0000FD5C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5C,
        0x0000FD5C,
        0x0000FD5C
    };

    static Char _decompositionMapping0000FD5D[] = 
    {
        0x00000633,
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FD5D =
    {
        0x0000FD5D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5D,
        0x0000FD5D,
        0x0000FD5D
    };

    static Char _decompositionMapping0000FD5E[] = 
    {
        0x00000633,
        0x0000062C,
        0x00000649
    };

    static _CharacterInfo _character0000FD5E =
    {
        0x0000FD5E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5E,
        0x0000FD5E,
        0x0000FD5E
    };

    static Char _decompositionMapping0000FD5F[] = 
    {
        0x00000633,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD5F =
    {
        0x0000FD5F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD5F,
        0x0000FD5F,
        0x0000FD5F
    };

    static Char _decompositionMapping0000FD60[] = 
    {
        0x00000633,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD60 =
    {
        0x0000FD60,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD60,
        0x0000FD60,
        0x0000FD60
    };

    static Char _decompositionMapping0000FD61[] = 
    {
        0x00000633,
        0x00000645,
        0x0000062C
    };

    static _CharacterInfo _character0000FD61 =
    {
        0x0000FD61,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD61,
        0x0000FD61,
        0x0000FD61
    };

    static Char _decompositionMapping0000FD62[] = 
    {
        0x00000633,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD62 =
    {
        0x0000FD62,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD62,
        0x0000FD62,
        0x0000FD62
    };

    static Char _decompositionMapping0000FD63[] = 
    {
        0x00000633,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD63 =
    {
        0x0000FD63,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD63,
        0x0000FD63,
        0x0000FD63
    };

    static Char _decompositionMapping0000FD64[] = 
    {
        0x00000635,
        0x0000062D,
        0x0000062D
    };

    static _CharacterInfo _character0000FD64 =
    {
        0x0000FD64,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD64,
        0x0000FD64,
        0x0000FD64
    };

    static Char _decompositionMapping0000FD65[] = 
    {
        0x00000635,
        0x0000062D,
        0x0000062D
    };

    static _CharacterInfo _character0000FD65 =
    {
        0x0000FD65,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD65,
        0x0000FD65,
        0x0000FD65
    };

    static Char _decompositionMapping0000FD66[] = 
    {
        0x00000635,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD66 =
    {
        0x0000FD66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD66,
        0x0000FD66,
        0x0000FD66
    };

    static Char _decompositionMapping0000FD67[] = 
    {
        0x00000634,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD67 =
    {
        0x0000FD67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD67,
        0x0000FD67,
        0x0000FD67
    };

    static Char _decompositionMapping0000FD68[] = 
    {
        0x00000634,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD68 =
    {
        0x0000FD68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD68,
        0x0000FD68,
        0x0000FD68
    };

    static Char _decompositionMapping0000FD69[] = 
    {
        0x00000634,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FD69 =
    {
        0x0000FD69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD69,
        0x0000FD69,
        0x0000FD69
    };

    static Char _decompositionMapping0000FD6A[] = 
    {
        0x00000634,
        0x00000645,
        0x0000062E
    };

    static _CharacterInfo _character0000FD6A =
    {
        0x0000FD6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6A,
        0x0000FD6A,
        0x0000FD6A
    };

    static Char _decompositionMapping0000FD6B[] = 
    {
        0x00000634,
        0x00000645,
        0x0000062E
    };

    static _CharacterInfo _character0000FD6B =
    {
        0x0000FD6B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6B,
        0x0000FD6B,
        0x0000FD6B
    };

    static Char _decompositionMapping0000FD6C[] = 
    {
        0x00000634,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD6C =
    {
        0x0000FD6C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6C,
        0x0000FD6C,
        0x0000FD6C
    };

    static Char _decompositionMapping0000FD6D[] = 
    {
        0x00000634,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD6D =
    {
        0x0000FD6D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6D,
        0x0000FD6D,
        0x0000FD6D
    };

    static Char _decompositionMapping0000FD6E[] = 
    {
        0x00000636,
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FD6E =
    {
        0x0000FD6E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6E,
        0x0000FD6E,
        0x0000FD6E
    };

    static Char _decompositionMapping0000FD6F[] = 
    {
        0x00000636,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD6F =
    {
        0x0000FD6F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD6F,
        0x0000FD6F,
        0x0000FD6F
    };

    static Char _decompositionMapping0000FD70[] = 
    {
        0x00000636,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD70 =
    {
        0x0000FD70,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD70,
        0x0000FD70,
        0x0000FD70
    };

    static Char _decompositionMapping0000FD71[] = 
    {
        0x00000637,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD71 =
    {
        0x0000FD71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD71,
        0x0000FD71,
        0x0000FD71
    };

    static Char _decompositionMapping0000FD72[] = 
    {
        0x00000637,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD72 =
    {
        0x0000FD72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD72,
        0x0000FD72,
        0x0000FD72
    };

    static Char _decompositionMapping0000FD73[] = 
    {
        0x00000637,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD73 =
    {
        0x0000FD73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD73,
        0x0000FD73,
        0x0000FD73
    };

    static Char _decompositionMapping0000FD74[] = 
    {
        0x00000637,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FD74 =
    {
        0x0000FD74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD74,
        0x0000FD74,
        0x0000FD74
    };

    static Char _decompositionMapping0000FD75[] = 
    {
        0x00000639,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FD75 =
    {
        0x0000FD75,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD75,
        0x0000FD75,
        0x0000FD75
    };

    static Char _decompositionMapping0000FD76[] = 
    {
        0x00000639,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD76 =
    {
        0x0000FD76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD76,
        0x0000FD76,
        0x0000FD76
    };

    static Char _decompositionMapping0000FD77[] = 
    {
        0x00000639,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD77 =
    {
        0x0000FD77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD77,
        0x0000FD77,
        0x0000FD77
    };

    static Char _decompositionMapping0000FD78[] = 
    {
        0x00000639,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FD78 =
    {
        0x0000FD78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD78,
        0x0000FD78,
        0x0000FD78
    };

    static Char _decompositionMapping0000FD79[] = 
    {
        0x0000063A,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD79 =
    {
        0x0000FD79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD79,
        0x0000FD79,
        0x0000FD79
    };

    static Char _decompositionMapping0000FD7A[] = 
    {
        0x0000063A,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FD7A =
    {
        0x0000FD7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7A,
        0x0000FD7A,
        0x0000FD7A
    };

    static Char _decompositionMapping0000FD7B[] = 
    {
        0x0000063A,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FD7B =
    {
        0x0000FD7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7B,
        0x0000FD7B,
        0x0000FD7B
    };

    static Char _decompositionMapping0000FD7C[] = 
    {
        0x00000641,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD7C =
    {
        0x0000FD7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7C,
        0x0000FD7C,
        0x0000FD7C
    };

    static Char _decompositionMapping0000FD7D[] = 
    {
        0x00000641,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD7D =
    {
        0x0000FD7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7D,
        0x0000FD7D,
        0x0000FD7D
    };

    static Char _decompositionMapping0000FD7E[] = 
    {
        0x00000642,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD7E =
    {
        0x0000FD7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7E,
        0x0000FD7E,
        0x0000FD7E
    };

    static Char _decompositionMapping0000FD7F[] = 
    {
        0x00000642,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD7F =
    {
        0x0000FD7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD7F,
        0x0000FD7F,
        0x0000FD7F
    };

    static Char _decompositionMapping0000FD80[] = 
    {
        0x00000644,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD80 =
    {
        0x0000FD80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD80,
        0x0000FD80,
        0x0000FD80
    };

    static Char _decompositionMapping0000FD81[] = 
    {
        0x00000644,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FD81 =
    {
        0x0000FD81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD81,
        0x0000FD81,
        0x0000FD81
    };

    static Char _decompositionMapping0000FD82[] = 
    {
        0x00000644,
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FD82 =
    {
        0x0000FD82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD82,
        0x0000FD82,
        0x0000FD82
    };

    static Char _decompositionMapping0000FD83[] = 
    {
        0x00000644,
        0x0000062C,
        0x0000062C
    };

    static _CharacterInfo _character0000FD83 =
    {
        0x0000FD83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD83,
        0x0000FD83,
        0x0000FD83
    };

    static Char _decompositionMapping0000FD84[] = 
    {
        0x00000644,
        0x0000062C,
        0x0000062C
    };

    static _CharacterInfo _character0000FD84 =
    {
        0x0000FD84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD84,
        0x0000FD84,
        0x0000FD84
    };

    static Char _decompositionMapping0000FD85[] = 
    {
        0x00000644,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD85 =
    {
        0x0000FD85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD85,
        0x0000FD85,
        0x0000FD85
    };

    static Char _decompositionMapping0000FD86[] = 
    {
        0x00000644,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD86 =
    {
        0x0000FD86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD86,
        0x0000FD86,
        0x0000FD86
    };

    static Char _decompositionMapping0000FD87[] = 
    {
        0x00000644,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD87 =
    {
        0x0000FD87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD87,
        0x0000FD87,
        0x0000FD87
    };

    static Char _decompositionMapping0000FD88[] = 
    {
        0x00000644,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FD88 =
    {
        0x0000FD88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD88,
        0x0000FD88,
        0x0000FD88
    };

    static Char _decompositionMapping0000FD89[] = 
    {
        0x00000645,
        0x0000062D,
        0x0000062C
    };

    static _CharacterInfo _character0000FD89 =
    {
        0x0000FD89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD89,
        0x0000FD89,
        0x0000FD89
    };

    static Char _decompositionMapping0000FD8A[] = 
    {
        0x00000645,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD8A =
    {
        0x0000FD8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8A,
        0x0000FD8A,
        0x0000FD8A
    };

    static Char _decompositionMapping0000FD8B[] = 
    {
        0x00000645,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FD8B =
    {
        0x0000FD8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8B,
        0x0000FD8B,
        0x0000FD8B
    };

    static Char _decompositionMapping0000FD8C[] = 
    {
        0x00000645,
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FD8C =
    {
        0x0000FD8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8C,
        0x0000FD8C,
        0x0000FD8C
    };

    static Char _decompositionMapping0000FD8D[] = 
    {
        0x00000645,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FD8D =
    {
        0x0000FD8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8D,
        0x0000FD8D,
        0x0000FD8D
    };

    static Char _decompositionMapping0000FD8E[] = 
    {
        0x00000645,
        0x0000062E,
        0x0000062C
    };

    static _CharacterInfo _character0000FD8E =
    {
        0x0000FD8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8E,
        0x0000FD8E,
        0x0000FD8E
    };

    static Char _decompositionMapping0000FD8F[] = 
    {
        0x00000645,
        0x0000062E,
        0x00000645
    };

    static _CharacterInfo _character0000FD8F =
    {
        0x0000FD8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD8F,
        0x0000FD8F,
        0x0000FD8F
    };

    static Char _decompositionMapping0000FD92[] = 
    {
        0x00000645,
        0x0000062C,
        0x0000062E
    };

    static _CharacterInfo _character0000FD92 =
    {
        0x0000FD92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD92,
        0x0000FD92,
        0x0000FD92
    };

    static Char _decompositionMapping0000FD93[] = 
    {
        0x00000647,
        0x00000645,
        0x0000062C
    };

    static _CharacterInfo _character0000FD93 =
    {
        0x0000FD93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD93,
        0x0000FD93,
        0x0000FD93
    };

    static Char _decompositionMapping0000FD94[] = 
    {
        0x00000647,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD94 =
    {
        0x0000FD94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD94,
        0x0000FD94,
        0x0000FD94
    };

    static Char _decompositionMapping0000FD95[] = 
    {
        0x00000646,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FD95 =
    {
        0x0000FD95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD95,
        0x0000FD95,
        0x0000FD95
    };

    static Char _decompositionMapping0000FD96[] = 
    {
        0x00000646,
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FD96 =
    {
        0x0000FD96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD96,
        0x0000FD96,
        0x0000FD96
    };

    static Char _decompositionMapping0000FD97[] = 
    {
        0x00000646,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FD97 =
    {
        0x0000FD97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD97,
        0x0000FD97,
        0x0000FD97
    };

    static Char _decompositionMapping0000FD98[] = 
    {
        0x00000646,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FD98 =
    {
        0x0000FD98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD98,
        0x0000FD98,
        0x0000FD98
    };

    static Char _decompositionMapping0000FD99[] = 
    {
        0x00000646,
        0x0000062C,
        0x00000649
    };

    static _CharacterInfo _character0000FD99 =
    {
        0x0000FD99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD99,
        0x0000FD99,
        0x0000FD99
    };

    static Char _decompositionMapping0000FD9A[] = 
    {
        0x00000646,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FD9A =
    {
        0x0000FD9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9A,
        0x0000FD9A,
        0x0000FD9A
    };

    static Char _decompositionMapping0000FD9B[] = 
    {
        0x00000646,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FD9B =
    {
        0x0000FD9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9B,
        0x0000FD9B,
        0x0000FD9B
    };

    static Char _decompositionMapping0000FD9C[] = 
    {
        0x0000064A,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD9C =
    {
        0x0000FD9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9C,
        0x0000FD9C,
        0x0000FD9C
    };

    static Char _decompositionMapping0000FD9D[] = 
    {
        0x0000064A,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FD9D =
    {
        0x0000FD9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FD9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9D,
        0x0000FD9D,
        0x0000FD9D
    };

    static Char _decompositionMapping0000FD9E[] = 
    {
        0x00000628,
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FD9E =
    {
        0x0000FD9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9E,
        0x0000FD9E,
        0x0000FD9E
    };

    static Char _decompositionMapping0000FD9F[] = 
    {
        0x0000062A,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FD9F =
    {
        0x0000FD9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FD9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FD9F,
        0x0000FD9F,
        0x0000FD9F
    };

    static Char _decompositionMapping0000FDA0[] = 
    {
        0x0000062A,
        0x0000062C,
        0x00000649
    };

    static _CharacterInfo _character0000FDA0 =
    {
        0x0000FDA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA0,
        0x0000FDA0,
        0x0000FDA0
    };

    static Char _decompositionMapping0000FDA1[] = 
    {
        0x0000062A,
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FDA1 =
    {
        0x0000FDA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA1,
        0x0000FDA1,
        0x0000FDA1
    };

    static Char _decompositionMapping0000FDA2[] = 
    {
        0x0000062A,
        0x0000062E,
        0x00000649
    };

    static _CharacterInfo _character0000FDA2 =
    {
        0x0000FDA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA2,
        0x0000FDA2,
        0x0000FDA2
    };

    static Char _decompositionMapping0000FDA3[] = 
    {
        0x0000062A,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDA3 =
    {
        0x0000FDA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA3,
        0x0000FDA3,
        0x0000FDA3
    };

    static Char _decompositionMapping0000FDA4[] = 
    {
        0x0000062A,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FDA4 =
    {
        0x0000FDA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA4,
        0x0000FDA4,
        0x0000FDA4
    };

    static Char _decompositionMapping0000FDA5[] = 
    {
        0x0000062C,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDA5 =
    {
        0x0000FDA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA5,
        0x0000FDA5,
        0x0000FDA5
    };

    static Char _decompositionMapping0000FDA6[] = 
    {
        0x0000062C,
        0x0000062D,
        0x00000649
    };

    static _CharacterInfo _character0000FDA6 =
    {
        0x0000FDA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA6,
        0x0000FDA6,
        0x0000FDA6
    };

    static Char _decompositionMapping0000FDA7[] = 
    {
        0x0000062C,
        0x00000645,
        0x00000649
    };

    static _CharacterInfo _character0000FDA7 =
    {
        0x0000FDA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA7,
        0x0000FDA7,
        0x0000FDA7
    };

    static Char _decompositionMapping0000FDA8[] = 
    {
        0x00000633,
        0x0000062E,
        0x00000649
    };

    static _CharacterInfo _character0000FDA8 =
    {
        0x0000FDA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA8,
        0x0000FDA8,
        0x0000FDA8
    };

    static Char _decompositionMapping0000FDA9[] = 
    {
        0x00000635,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDA9 =
    {
        0x0000FDA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDA9,
        0x0000FDA9,
        0x0000FDA9
    };

    static Char _decompositionMapping0000FDAA[] = 
    {
        0x00000634,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAA =
    {
        0x0000FDAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAA,
        0x0000FDAA,
        0x0000FDAA
    };

    static Char _decompositionMapping0000FDAB[] = 
    {
        0x00000636,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAB =
    {
        0x0000FDAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAB,
        0x0000FDAB,
        0x0000FDAB
    };

    static Char _decompositionMapping0000FDAC[] = 
    {
        0x00000644,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAC =
    {
        0x0000FDAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAC,
        0x0000FDAC,
        0x0000FDAC
    };

    static Char _decompositionMapping0000FDAD[] = 
    {
        0x00000644,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAD =
    {
        0x0000FDAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAD,
        0x0000FDAD,
        0x0000FDAD
    };

    static Char _decompositionMapping0000FDAE[] = 
    {
        0x0000064A,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAE =
    {
        0x0000FDAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAE,
        0x0000FDAE,
        0x0000FDAE
    };

    static Char _decompositionMapping0000FDAF[] = 
    {
        0x0000064A,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FDAF =
    {
        0x0000FDAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDAF,
        0x0000FDAF,
        0x0000FDAF
    };

    static Char _decompositionMapping0000FDB0[] = 
    {
        0x0000064A,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB0 =
    {
        0x0000FDB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB0,
        0x0000FDB0,
        0x0000FDB0
    };

    static Char _decompositionMapping0000FDB1[] = 
    {
        0x00000645,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB1 =
    {
        0x0000FDB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB1,
        0x0000FDB1,
        0x0000FDB1
    };

    static Char _decompositionMapping0000FDB2[] = 
    {
        0x00000642,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB2 =
    {
        0x0000FDB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB2,
        0x0000FDB2,
        0x0000FDB2
    };

    static Char _decompositionMapping0000FDB3[] = 
    {
        0x00000646,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB3 =
    {
        0x0000FDB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB3,
        0x0000FDB3,
        0x0000FDB3
    };

    static Char _decompositionMapping0000FDB4[] = 
    {
        0x00000642,
        0x00000645,
        0x0000062D
    };

    static _CharacterInfo _character0000FDB4 =
    {
        0x0000FDB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB4,
        0x0000FDB4,
        0x0000FDB4
    };

    static Char _decompositionMapping0000FDB5[] = 
    {
        0x00000644,
        0x0000062D,
        0x00000645
    };

    static _CharacterInfo _character0000FDB5 =
    {
        0x0000FDB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB5,
        0x0000FDB5,
        0x0000FDB5
    };

    static Char _decompositionMapping0000FDB6[] = 
    {
        0x00000639,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB6 =
    {
        0x0000FDB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB6,
        0x0000FDB6,
        0x0000FDB6
    };

    static Char _decompositionMapping0000FDB7[] = 
    {
        0x00000643,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB7 =
    {
        0x0000FDB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB7,
        0x0000FDB7,
        0x0000FDB7
    };

    static Char _decompositionMapping0000FDB8[] = 
    {
        0x00000646,
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FDB8 =
    {
        0x0000FDB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB8,
        0x0000FDB8,
        0x0000FDB8
    };

    static Char _decompositionMapping0000FDB9[] = 
    {
        0x00000645,
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FDB9 =
    {
        0x0000FDB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDB9,
        0x0000FDB9,
        0x0000FDB9
    };

    static Char _decompositionMapping0000FDBA[] = 
    {
        0x00000644,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FDBA =
    {
        0x0000FDBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBA,
        0x0000FDBA,
        0x0000FDBA
    };

    static Char _decompositionMapping0000FDBB[] = 
    {
        0x00000643,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FDBB =
    {
        0x0000FDBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBB,
        0x0000FDBB,
        0x0000FDBB
    };

    static Char _decompositionMapping0000FDBC[] = 
    {
        0x00000644,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FDBC =
    {
        0x0000FDBC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBC,
        0x0000FDBC,
        0x0000FDBC
    };

    static Char _decompositionMapping0000FDBD[] = 
    {
        0x00000646,
        0x0000062C,
        0x0000062D
    };

    static _CharacterInfo _character0000FDBD =
    {
        0x0000FDBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBD,
        0x0000FDBD,
        0x0000FDBD
    };

    static Char _decompositionMapping0000FDBE[] = 
    {
        0x0000062C,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDBE =
    {
        0x0000FDBE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBE,
        0x0000FDBE,
        0x0000FDBE
    };

    static Char _decompositionMapping0000FDBF[] = 
    {
        0x0000062D,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FDBF =
    {
        0x0000FDBF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDBF,
        0x0000FDBF,
        0x0000FDBF
    };

    static Char _decompositionMapping0000FDC0[] = 
    {
        0x00000645,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FDC0 =
    {
        0x0000FDC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC0,
        0x0000FDC0,
        0x0000FDC0
    };

    static Char _decompositionMapping0000FDC1[] = 
    {
        0x00000641,
        0x00000645,
        0x0000064A
    };

    static _CharacterInfo _character0000FDC1 =
    {
        0x0000FDC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC1,
        0x0000FDC1,
        0x0000FDC1
    };

    static Char _decompositionMapping0000FDC2[] = 
    {
        0x00000628,
        0x0000062D,
        0x0000064A
    };

    static _CharacterInfo _character0000FDC2 =
    {
        0x0000FDC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC2,
        0x0000FDC2,
        0x0000FDC2
    };

    static Char _decompositionMapping0000FDC3[] = 
    {
        0x00000643,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FDC3 =
    {
        0x0000FDC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC3,
        0x0000FDC3,
        0x0000FDC3
    };

    static Char _decompositionMapping0000FDC4[] = 
    {
        0x00000639,
        0x0000062C,
        0x00000645
    };

    static _CharacterInfo _character0000FDC4 =
    {
        0x0000FDC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC4,
        0x0000FDC4,
        0x0000FDC4
    };

    static Char _decompositionMapping0000FDC5[] = 
    {
        0x00000635,
        0x00000645,
        0x00000645
    };

    static _CharacterInfo _character0000FDC5 =
    {
        0x0000FDC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        3,
        _decompositionMapping0000FDC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC5,
        0x0000FDC5,
        0x0000FDC5
    };

    static Char _decompositionMapping0000FDC6[] = 
    {
        0x00000633,
        0x0000062E,
        0x0000064A
    };

    static _CharacterInfo _character0000FDC6 =
    {
        0x0000FDC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC6,
        0x0000FDC6,
        0x0000FDC6
    };

    static Char _decompositionMapping0000FDC7[] = 
    {
        0x00000646,
        0x0000062C,
        0x0000064A
    };

    static _CharacterInfo _character0000FDC7 =
    {
        0x0000FDC7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        3,
        _decompositionMapping0000FDC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDC7,
        0x0000FDC7,
        0x0000FDC7
    };

    static Char _decompositionMapping0000FDF0[] = 
    {
        0x00000635,
        0x00000644,
        0x000006D2
    };

    static _CharacterInfo _character0000FDF0 =
    {
        0x0000FDF0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FDF0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF0,
        0x0000FDF0,
        0x0000FDF0
    };

    static Char _decompositionMapping0000FDF1[] = 
    {
        0x00000642,
        0x00000644,
        0x000006D2
    };

    static _CharacterInfo _character0000FDF1 =
    {
        0x0000FDF1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FDF1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF1,
        0x0000FDF1,
        0x0000FDF1
    };

    static Char _decompositionMapping0000FDF2[] = 
    {
        0x00000627,
        0x00000644,
        0x00000644,
        0x00000647
    };

    static _CharacterInfo _character0000FDF2 =
    {
        0x0000FDF2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF2,
        0x0000FDF2,
        0x0000FDF2
    };

    static Char _decompositionMapping0000FDF3[] = 
    {
        0x00000627,
        0x00000643,
        0x00000628,
        0x00000631
    };

    static _CharacterInfo _character0000FDF3 =
    {
        0x0000FDF3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF3,
        0x0000FDF3,
        0x0000FDF3
    };

    static Char _decompositionMapping0000FDF4[] = 
    {
        0x00000645,
        0x0000062D,
        0x00000645,
        0x0000062F
    };

    static _CharacterInfo _character0000FDF4 =
    {
        0x0000FDF4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF4,
        0x0000FDF4,
        0x0000FDF4
    };

    static Char _decompositionMapping0000FDF5[] = 
    {
        0x00000635,
        0x00000644,
        0x00000639,
        0x00000645
    };

    static _CharacterInfo _character0000FDF5 =
    {
        0x0000FDF5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF5,
        0x0000FDF5,
        0x0000FDF5
    };

    static Char _decompositionMapping0000FDF6[] = 
    {
        0x00000631,
        0x00000633,
        0x00000648,
        0x00000644
    };

    static _CharacterInfo _character0000FDF6 =
    {
        0x0000FDF6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF6,
        0x0000FDF6,
        0x0000FDF6
    };

    static Char _decompositionMapping0000FDF7[] = 
    {
        0x00000639,
        0x00000644,
        0x0000064A,
        0x00000647
    };

    static _CharacterInfo _character0000FDF7 =
    {
        0x0000FDF7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF7,
        0x0000FDF7,
        0x0000FDF7
    };

    static Char _decompositionMapping0000FDF8[] = 
    {
        0x00000648,
        0x00000633,
        0x00000644,
        0x00000645
    };

    static _CharacterInfo _character0000FDF8 =
    {
        0x0000FDF8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF8,
        0x0000FDF8,
        0x0000FDF8
    };

    static Char _decompositionMapping0000FDF9[] = 
    {
        0x00000635,
        0x00000644,
        0x00000649
    };

    static _CharacterInfo _character0000FDF9 =
    {
        0x0000FDF9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        3,
        _decompositionMapping0000FDF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDF9,
        0x0000FDF9,
        0x0000FDF9
    };

    static Char _decompositionMapping0000FDFA[] = 
    {
        0x00000635,
        0x00000644,
        0x00000649,
        0x00000020,
        0x00000627,
        0x00000644,
        0x00000000,
        0x00000000,
        0x00000000,
        0x00000600,
        0x00000644,
        0x00000000,
        0x00000000,
        0x00000000,
        0x00000000,
        0x00000600,
        0x0000FDFA,
        0x0000FDFA
    };

    static _CharacterInfo _character0000FDFA =
    {
        0x0000FDFA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        18,
        _decompositionMapping0000FDFA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDFA,
        0x0000FDFA,
        0x0000FDFA
    };

    static Char _decompositionMapping0000FDFB[] = 
    {
        0x0000062C,
        0x00000644,
        0x00000020,
        0x0000062C,
        0x00000644,
        0x00000627,
        0x00000000,
        0x00000000
    };

    static _CharacterInfo _character0000FDFB =
    {
        0x0000FDFB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        8,
        _decompositionMapping0000FDFB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDFB,
        0x0000FDFB,
        0x0000FDFB
    };

    static Char _decompositionMapping0000FDFC[] = 
    {
        0x00000631,
        0x000006CC,
        0x00000627,
        0x00000644
    };

    static _CharacterInfo _character0000FDFC =
    {
        0x0000FDFC,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        4,
        _decompositionMapping0000FDFC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDFC,
        0x0000FDFC,
        0x0000FDFC
    };

    static _CharacterInfo _character0000FDFD =
    {
        0x0000FDFD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FDFD,
        0x0000FDFD,
        0x0000FDFD
    };

    static _CharacterInfo _character0000FE00 =
    {
        0x0000FE00,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE00,
        0x0000FE00,
        0x0000FE00
    };

    static _CharacterInfo _character0000FE01 =
    {
        0x0000FE01,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE01,
        0x0000FE01,
        0x0000FE01
    };

    static _CharacterInfo _character0000FE02 =
    {
        0x0000FE02,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE02,
        0x0000FE02,
        0x0000FE02
    };

    static _CharacterInfo _character0000FE03 =
    {
        0x0000FE03,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE03,
        0x0000FE03,
        0x0000FE03
    };

    static _CharacterInfo _character0000FE04 =
    {
        0x0000FE04,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE04,
        0x0000FE04,
        0x0000FE04
    };

    static _CharacterInfo _character0000FE05 =
    {
        0x0000FE05,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE05,
        0x0000FE05,
        0x0000FE05
    };

    static _CharacterInfo _character0000FE06 =
    {
        0x0000FE06,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE06,
        0x0000FE06,
        0x0000FE06
    };

    static _CharacterInfo _character0000FE07 =
    {
        0x0000FE07,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE07,
        0x0000FE07,
        0x0000FE07
    };

    static _CharacterInfo _character0000FE08 =
    {
        0x0000FE08,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE08,
        0x0000FE08,
        0x0000FE08
    };

    static _CharacterInfo _character0000FE09 =
    {
        0x0000FE09,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE09,
        0x0000FE09,
        0x0000FE09
    };

    static _CharacterInfo _character0000FE0A =
    {
        0x0000FE0A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0A,
        0x0000FE0A,
        0x0000FE0A
    };

    static _CharacterInfo _character0000FE0B =
    {
        0x0000FE0B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0B,
        0x0000FE0B,
        0x0000FE0B
    };

    static _CharacterInfo _character0000FE0C =
    {
        0x0000FE0C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0C,
        0x0000FE0C,
        0x0000FE0C
    };

    static _CharacterInfo _character0000FE0D =
    {
        0x0000FE0D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0D,
        0x0000FE0D,
        0x0000FE0D
    };

    static _CharacterInfo _character0000FE0E =
    {
        0x0000FE0E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0E,
        0x0000FE0E,
        0x0000FE0E
    };

    static _CharacterInfo _character0000FE0F =
    {
        0x0000FE0F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE0F,
        0x0000FE0F,
        0x0000FE0F
    };

    static Char _decompositionMapping0000FE10[] = 
    {
        0x0000002C
    };

    static _CharacterInfo _character0000FE10 =
    {
        0x0000FE10,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE10,
        0x0000FE10,
        0x0000FE10
    };

    static Char _decompositionMapping0000FE11[] = 
    {
        0x00003001
    };

    static _CharacterInfo _character0000FE11 =
    {
        0x0000FE11,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE11,
        0x0000FE11,
        0x0000FE11
    };

    static Char _decompositionMapping0000FE12[] = 
    {
        0x00003002
    };

    static _CharacterInfo _character0000FE12 =
    {
        0x0000FE12,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE12,
        0x0000FE12,
        0x0000FE12
    };

    static Char _decompositionMapping0000FE13[] = 
    {
        0x0000003A
    };

    static _CharacterInfo _character0000FE13 =
    {
        0x0000FE13,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE13,
        0x0000FE13,
        0x0000FE13
    };

    static Char _decompositionMapping0000FE14[] = 
    {
        0x0000003B
    };

    static _CharacterInfo _character0000FE14 =
    {
        0x0000FE14,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE14,
        0x0000FE14,
        0x0000FE14
    };

    static Char _decompositionMapping0000FE15[] = 
    {
        0x00000021
    };

    static _CharacterInfo _character0000FE15 =
    {
        0x0000FE15,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE15,
        0x0000FE15,
        0x0000FE15
    };

    static Char _decompositionMapping0000FE16[] = 
    {
        0x0000003F
    };

    static _CharacterInfo _character0000FE16 =
    {
        0x0000FE16,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE16,
        0x0000FE16,
        0x0000FE16
    };

    static Char _decompositionMapping0000FE17[] = 
    {
        0x00003016
    };

    static _CharacterInfo _character0000FE17 =
    {
        0x0000FE17,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE17,
        0x0000FE17,
        0x0000FE17
    };

    static Char _decompositionMapping0000FE18[] = 
    {
        0x00003017
    };

    static _CharacterInfo _character0000FE18 =
    {
        0x0000FE18,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE18,
        0x0000FE18,
        0x0000FE18
    };

    static Char _decompositionMapping0000FE19[] = 
    {
        0x00002026
    };

    static _CharacterInfo _character0000FE19 =
    {
        0x0000FE19,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE19,
        0x0000FE19,
        0x0000FE19
    };

    static _CharacterInfo _character0000FE20 =
    {
        0x0000FE20,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE20,
        0x0000FE20,
        0x0000FE20
    };

    static _CharacterInfo _character0000FE21 =
    {
        0x0000FE21,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE21,
        0x0000FE21,
        0x0000FE21
    };

    static _CharacterInfo _character0000FE22 =
    {
        0x0000FE22,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE22,
        0x0000FE22,
        0x0000FE22
    };

    static _CharacterInfo _character0000FE23 =
    {
        0x0000FE23,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE23,
        0x0000FE23,
        0x0000FE23
    };

    static Char _decompositionMapping0000FE30[] = 
    {
        0x00002025
    };

    static _CharacterInfo _character0000FE30 =
    {
        0x0000FE30,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE30,
        0x0000FE30,
        0x0000FE30
    };

    static Char _decompositionMapping0000FE31[] = 
    {
        0x00002014
    };

    static _CharacterInfo _character0000FE31 =
    {
        0x0000FE31,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE31,
        0x0000FE31,
        0x0000FE31
    };

    static Char _decompositionMapping0000FE32[] = 
    {
        0x00002013
    };

    static _CharacterInfo _character0000FE32 =
    {
        0x0000FE32,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE32,
        0x0000FE32,
        0x0000FE32
    };

    static Char _decompositionMapping0000FE33[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FE33 =
    {
        0x0000FE33,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE33,
        0x0000FE33,
        0x0000FE33
    };

    static Char _decompositionMapping0000FE34[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FE34 =
    {
        0x0000FE34,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE34,
        0x0000FE34,
        0x0000FE34
    };

    static Char _decompositionMapping0000FE35[] = 
    {
        0x00000028
    };

    static _CharacterInfo _character0000FE35 =
    {
        0x0000FE35,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE35,
        0x0000FE35,
        0x0000FE35
    };

    static Char _decompositionMapping0000FE36[] = 
    {
        0x00000029
    };

    static _CharacterInfo _character0000FE36 =
    {
        0x0000FE36,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE36,
        0x0000FE36,
        0x0000FE36
    };

    static Char _decompositionMapping0000FE37[] = 
    {
        0x0000007B
    };

    static _CharacterInfo _character0000FE37 =
    {
        0x0000FE37,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE37,
        0x0000FE37,
        0x0000FE37
    };

    static Char _decompositionMapping0000FE38[] = 
    {
        0x0000007D
    };

    static _CharacterInfo _character0000FE38 =
    {
        0x0000FE38,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE38,
        0x0000FE38,
        0x0000FE38
    };

    static Char _decompositionMapping0000FE39[] = 
    {
        0x00003014
    };

    static _CharacterInfo _character0000FE39 =
    {
        0x0000FE39,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE39,
        0x0000FE39,
        0x0000FE39
    };

    static Char _decompositionMapping0000FE3A[] = 
    {
        0x00003015
    };

    static _CharacterInfo _character0000FE3A =
    {
        0x0000FE3A,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3A,
        0x0000FE3A,
        0x0000FE3A
    };

    static Char _decompositionMapping0000FE3B[] = 
    {
        0x00003010
    };

    static _CharacterInfo _character0000FE3B =
    {
        0x0000FE3B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3B,
        0x0000FE3B,
        0x0000FE3B
    };

    static Char _decompositionMapping0000FE3C[] = 
    {
        0x00003011
    };

    static _CharacterInfo _character0000FE3C =
    {
        0x0000FE3C,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3C,
        0x0000FE3C,
        0x0000FE3C
    };

    static Char _decompositionMapping0000FE3D[] = 
    {
        0x0000300A
    };

    static _CharacterInfo _character0000FE3D =
    {
        0x0000FE3D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3D,
        0x0000FE3D,
        0x0000FE3D
    };

    static Char _decompositionMapping0000FE3E[] = 
    {
        0x0000300B
    };

    static _CharacterInfo _character0000FE3E =
    {
        0x0000FE3E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3E,
        0x0000FE3E,
        0x0000FE3E
    };

    static Char _decompositionMapping0000FE3F[] = 
    {
        0x00003008
    };

    static _CharacterInfo _character0000FE3F =
    {
        0x0000FE3F,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE3F,
        0x0000FE3F,
        0x0000FE3F
    };

    static Char _decompositionMapping0000FE40[] = 
    {
        0x00003009
    };

    static _CharacterInfo _character0000FE40 =
    {
        0x0000FE40,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE40,
        0x0000FE40,
        0x0000FE40
    };

    static Char _decompositionMapping0000FE41[] = 
    {
        0x0000300C
    };

    static _CharacterInfo _character0000FE41 =
    {
        0x0000FE41,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE41,
        0x0000FE41,
        0x0000FE41
    };

    static Char _decompositionMapping0000FE42[] = 
    {
        0x0000300D
    };

    static _CharacterInfo _character0000FE42 =
    {
        0x0000FE42,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE42,
        0x0000FE42,
        0x0000FE42
    };

    static Char _decompositionMapping0000FE43[] = 
    {
        0x0000300E
    };

    static _CharacterInfo _character0000FE43 =
    {
        0x0000FE43,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE43,
        0x0000FE43,
        0x0000FE43
    };

    static Char _decompositionMapping0000FE44[] = 
    {
        0x0000300F
    };

    static _CharacterInfo _character0000FE44 =
    {
        0x0000FE44,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE44,
        0x0000FE44,
        0x0000FE44
    };

    static _CharacterInfo _character0000FE45 =
    {
        0x0000FE45,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE45,
        0x0000FE45,
        0x0000FE45
    };

    static _CharacterInfo _character0000FE46 =
    {
        0x0000FE46,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE46,
        0x0000FE46,
        0x0000FE46
    };

    static Char _decompositionMapping0000FE47[] = 
    {
        0x0000005B
    };

    static _CharacterInfo _character0000FE47 =
    {
        0x0000FE47,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE47,
        0x0000FE47,
        0x0000FE47
    };

    static Char _decompositionMapping0000FE48[] = 
    {
        0x0000005D
    };

    static _CharacterInfo _character0000FE48 =
    {
        0x0000FE48,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_vertical,
        1,
        _decompositionMapping0000FE48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE48,
        0x0000FE48,
        0x0000FE48
    };

    static Char _decompositionMapping0000FE49[] = 
    {
        0x0000203E
    };

    static _CharacterInfo _character0000FE49 =
    {
        0x0000FE49,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE49,
        0x0000FE49,
        0x0000FE49
    };

    static Char _decompositionMapping0000FE4A[] = 
    {
        0x0000203E
    };

    static _CharacterInfo _character0000FE4A =
    {
        0x0000FE4A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4A,
        0x0000FE4A,
        0x0000FE4A
    };

    static Char _decompositionMapping0000FE4B[] = 
    {
        0x0000203E
    };

    static _CharacterInfo _character0000FE4B =
    {
        0x0000FE4B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4B,
        0x0000FE4B,
        0x0000FE4B
    };

    static Char _decompositionMapping0000FE4C[] = 
    {
        0x0000203E
    };

    static _CharacterInfo _character0000FE4C =
    {
        0x0000FE4C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4C,
        0x0000FE4C,
        0x0000FE4C
    };

    static Char _decompositionMapping0000FE4D[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FE4D =
    {
        0x0000FE4D,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4D,
        0x0000FE4D,
        0x0000FE4D
    };

    static Char _decompositionMapping0000FE4E[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FE4E =
    {
        0x0000FE4E,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4E,
        0x0000FE4E,
        0x0000FE4E
    };

    static Char _decompositionMapping0000FE4F[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FE4F =
    {
        0x0000FE4F,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_compat,
        1,
        _decompositionMapping0000FE4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE4F,
        0x0000FE4F,
        0x0000FE4F
    };

    static Char _decompositionMapping0000FE50[] = 
    {
        0x0000002C
    };

    static _CharacterInfo _character0000FE50 =
    {
        0x0000FE50,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE50,
        0x0000FE50,
        0x0000FE50
    };

    static Char _decompositionMapping0000FE51[] = 
    {
        0x00003001
    };

    static _CharacterInfo _character0000FE51 =
    {
        0x0000FE51,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE51,
        0x0000FE51,
        0x0000FE51
    };

    static Char _decompositionMapping0000FE52[] = 
    {
        0x0000002E
    };

    static _CharacterInfo _character0000FE52 =
    {
        0x0000FE52,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE52,
        0x0000FE52,
        0x0000FE52
    };

    static Char _decompositionMapping0000FE54[] = 
    {
        0x0000003B
    };

    static _CharacterInfo _character0000FE54 =
    {
        0x0000FE54,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE54,
        0x0000FE54,
        0x0000FE54
    };

    static Char _decompositionMapping0000FE55[] = 
    {
        0x0000003A
    };

    static _CharacterInfo _character0000FE55 =
    {
        0x0000FE55,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE55,
        0x0000FE55,
        0x0000FE55
    };

    static Char _decompositionMapping0000FE56[] = 
    {
        0x0000003F
    };

    static _CharacterInfo _character0000FE56 =
    {
        0x0000FE56,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE56,
        0x0000FE56,
        0x0000FE56
    };

    static Char _decompositionMapping0000FE57[] = 
    {
        0x00000021
    };

    static _CharacterInfo _character0000FE57 =
    {
        0x0000FE57,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE57,
        0x0000FE57,
        0x0000FE57
    };

    static Char _decompositionMapping0000FE58[] = 
    {
        0x00002014
    };

    static _CharacterInfo _character0000FE58 =
    {
        0x0000FE58,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE58,
        0x0000FE58,
        0x0000FE58
    };

    static Char _decompositionMapping0000FE59[] = 
    {
        0x00000028
    };

    static _CharacterInfo _character0000FE59 =
    {
        0x0000FE59,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE59,
        0x0000FE59,
        0x0000FE59
    };

    static Char _decompositionMapping0000FE5A[] = 
    {
        0x00000029
    };

    static _CharacterInfo _character0000FE5A =
    {
        0x0000FE5A,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE5A,
        0x0000FE5A,
        0x0000FE5A
    };

    static Char _decompositionMapping0000FE5B[] = 
    {
        0x0000007B
    };

    static _CharacterInfo _character0000FE5B =
    {
        0x0000FE5B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE5B,
        0x0000FE5B,
        0x0000FE5B
    };

    static Char _decompositionMapping0000FE5C[] = 
    {
        0x0000007D
    };

    static _CharacterInfo _character0000FE5C =
    {
        0x0000FE5C,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE5C,
        0x0000FE5C,
        0x0000FE5C
    };

    static Char _decompositionMapping0000FE5D[] = 
    {
        0x00003014
    };

    static _CharacterInfo _character0000FE5D =
    {
        0x0000FE5D,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE5D,
        0x0000FE5D,
        0x0000FE5D
    };

    static Char _decompositionMapping0000FE5E[] = 
    {
        0x00003015
    };

    static _CharacterInfo _character0000FE5E =
    {
        0x0000FE5E,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE5E,
        0x0000FE5E,
        0x0000FE5E
    };

    static Char _decompositionMapping0000FE5F[] = 
    {
        0x00000023
    };

    static _CharacterInfo _character0000FE5F =
    {
        0x0000FE5F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE5F,
        0x0000FE5F,
        0x0000FE5F
    };

    static Char _decompositionMapping0000FE60[] = 
    {
        0x00000026
    };

    static _CharacterInfo _character0000FE60 =
    {
        0x0000FE60,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE60,
        0x0000FE60,
        0x0000FE60
    };

    static Char _decompositionMapping0000FE61[] = 
    {
        0x0000002A
    };

    static _CharacterInfo _character0000FE61 =
    {
        0x0000FE61,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE61,
        0x0000FE61,
        0x0000FE61
    };

    static Char _decompositionMapping0000FE62[] = 
    {
        0x0000002B
    };

    static _CharacterInfo _character0000FE62 =
    {
        0x0000FE62,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE62,
        0x0000FE62,
        0x0000FE62
    };

    static Char _decompositionMapping0000FE63[] = 
    {
        0x0000002D
    };

    static _CharacterInfo _character0000FE63 =
    {
        0x0000FE63,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE63,
        0x0000FE63,
        0x0000FE63
    };

    static Char _decompositionMapping0000FE64[] = 
    {
        0x0000003C
    };

    static _CharacterInfo _character0000FE64 =
    {
        0x0000FE64,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE64,
        0x0000FE64,
        0x0000FE64
    };

    static Char _decompositionMapping0000FE65[] = 
    {
        0x0000003E
    };

    static _CharacterInfo _character0000FE65 =
    {
        0x0000FE65,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FE65,
        0x0000FE65,
        0x0000FE65
    };

    static Char _decompositionMapping0000FE66[] = 
    {
        0x0000003D
    };

    static _CharacterInfo _character0000FE66 =
    {
        0x0000FE66,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE66,
        0x0000FE66,
        0x0000FE66
    };

    static Char _decompositionMapping0000FE68[] = 
    {
        0x0000005C
    };

    static _CharacterInfo _character0000FE68 =
    {
        0x0000FE68,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE68,
        0x0000FE68,
        0x0000FE68
    };

    static Char _decompositionMapping0000FE69[] = 
    {
        0x00000024
    };

    static _CharacterInfo _character0000FE69 =
    {
        0x0000FE69,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE69,
        0x0000FE69,
        0x0000FE69
    };

    static Char _decompositionMapping0000FE6A[] = 
    {
        0x00000025
    };

    static _CharacterInfo _character0000FE6A =
    {
        0x0000FE6A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE6A,
        0x0000FE6A,
        0x0000FE6A
    };

    static Char _decompositionMapping0000FE6B[] = 
    {
        0x00000040
    };

    static _CharacterInfo _character0000FE6B =
    {
        0x0000FE6B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_small,
        1,
        _decompositionMapping0000FE6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE6B,
        0x0000FE6B,
        0x0000FE6B
    };

    static Char _decompositionMapping0000FE70[] = 
    {
        0x00000020,
        0x0000064B
    };

    static _CharacterInfo _character0000FE70 =
    {
        0x0000FE70,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE70,
        0x0000FE70,
        0x0000FE70
    };

    static Char _decompositionMapping0000FE71[] = 
    {
        0x00000640,
        0x0000064B
    };

    static _CharacterInfo _character0000FE71 =
    {
        0x0000FE71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE71,
        0x0000FE71,
        0x0000FE71
    };

    static Char _decompositionMapping0000FE72[] = 
    {
        0x00000020,
        0x0000064C
    };

    static _CharacterInfo _character0000FE72 =
    {
        0x0000FE72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE72,
        0x0000FE72,
        0x0000FE72
    };

    static _CharacterInfo _character0000FE73 =
    {
        0x0000FE73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE73,
        0x0000FE73,
        0x0000FE73
    };

    static Char _decompositionMapping0000FE74[] = 
    {
        0x00000020,
        0x0000064D
    };

    static _CharacterInfo _character0000FE74 =
    {
        0x0000FE74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE74,
        0x0000FE74,
        0x0000FE74
    };

    static Char _decompositionMapping0000FE76[] = 
    {
        0x00000020,
        0x0000064E
    };

    static _CharacterInfo _character0000FE76 =
    {
        0x0000FE76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE76,
        0x0000FE76,
        0x0000FE76
    };

    static Char _decompositionMapping0000FE77[] = 
    {
        0x00000640,
        0x0000064E
    };

    static _CharacterInfo _character0000FE77 =
    {
        0x0000FE77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE77,
        0x0000FE77,
        0x0000FE77
    };

    static Char _decompositionMapping0000FE78[] = 
    {
        0x00000020,
        0x0000064F
    };

    static _CharacterInfo _character0000FE78 =
    {
        0x0000FE78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE78,
        0x0000FE78,
        0x0000FE78
    };

    static Char _decompositionMapping0000FE79[] = 
    {
        0x00000640,
        0x0000064F
    };

    static _CharacterInfo _character0000FE79 =
    {
        0x0000FE79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE79,
        0x0000FE79,
        0x0000FE79
    };

    static Char _decompositionMapping0000FE7A[] = 
    {
        0x00000020,
        0x00000650
    };

    static _CharacterInfo _character0000FE7A =
    {
        0x0000FE7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7A,
        0x0000FE7A,
        0x0000FE7A
    };

    static Char _decompositionMapping0000FE7B[] = 
    {
        0x00000640,
        0x00000650
    };

    static _CharacterInfo _character0000FE7B =
    {
        0x0000FE7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7B,
        0x0000FE7B,
        0x0000FE7B
    };

    static Char _decompositionMapping0000FE7C[] = 
    {
        0x00000020,
        0x00000651
    };

    static _CharacterInfo _character0000FE7C =
    {
        0x0000FE7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7C,
        0x0000FE7C,
        0x0000FE7C
    };

    static Char _decompositionMapping0000FE7D[] = 
    {
        0x00000640,
        0x00000651
    };

    static _CharacterInfo _character0000FE7D =
    {
        0x0000FE7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7D,
        0x0000FE7D,
        0x0000FE7D
    };

    static Char _decompositionMapping0000FE7E[] = 
    {
        0x00000020,
        0x00000652
    };

    static _CharacterInfo _character0000FE7E =
    {
        0x0000FE7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FE7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7E,
        0x0000FE7E,
        0x0000FE7E
    };

    static Char _decompositionMapping0000FE7F[] = 
    {
        0x00000640,
        0x00000652
    };

    static _CharacterInfo _character0000FE7F =
    {
        0x0000FE7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        2,
        _decompositionMapping0000FE7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE7F,
        0x0000FE7F,
        0x0000FE7F
    };

    static Char _decompositionMapping0000FE80[] = 
    {
        0x00000621
    };

    static _CharacterInfo _character0000FE80 =
    {
        0x0000FE80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE80,
        0x0000FE80,
        0x0000FE80
    };

    static Char _decompositionMapping0000FE81[] = 
    {
        0x00000622
    };

    static _CharacterInfo _character0000FE81 =
    {
        0x0000FE81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE81,
        0x0000FE81,
        0x0000FE81
    };

    static Char _decompositionMapping0000FE82[] = 
    {
        0x00000622
    };

    static _CharacterInfo _character0000FE82 =
    {
        0x0000FE82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE82,
        0x0000FE82,
        0x0000FE82
    };

    static Char _decompositionMapping0000FE83[] = 
    {
        0x00000623
    };

    static _CharacterInfo _character0000FE83 =
    {
        0x0000FE83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE83,
        0x0000FE83,
        0x0000FE83
    };

    static Char _decompositionMapping0000FE84[] = 
    {
        0x00000623
    };

    static _CharacterInfo _character0000FE84 =
    {
        0x0000FE84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE84,
        0x0000FE84,
        0x0000FE84
    };

    static Char _decompositionMapping0000FE85[] = 
    {
        0x00000624
    };

    static _CharacterInfo _character0000FE85 =
    {
        0x0000FE85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE85,
        0x0000FE85,
        0x0000FE85
    };

    static Char _decompositionMapping0000FE86[] = 
    {
        0x00000624
    };

    static _CharacterInfo _character0000FE86 =
    {
        0x0000FE86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE86,
        0x0000FE86,
        0x0000FE86
    };

    static Char _decompositionMapping0000FE87[] = 
    {
        0x00000625
    };

    static _CharacterInfo _character0000FE87 =
    {
        0x0000FE87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE87,
        0x0000FE87,
        0x0000FE87
    };

    static Char _decompositionMapping0000FE88[] = 
    {
        0x00000625
    };

    static _CharacterInfo _character0000FE88 =
    {
        0x0000FE88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE88,
        0x0000FE88,
        0x0000FE88
    };

    static Char _decompositionMapping0000FE89[] = 
    {
        0x00000626
    };

    static _CharacterInfo _character0000FE89 =
    {
        0x0000FE89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE89,
        0x0000FE89,
        0x0000FE89
    };

    static Char _decompositionMapping0000FE8A[] = 
    {
        0x00000626
    };

    static _CharacterInfo _character0000FE8A =
    {
        0x0000FE8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8A,
        0x0000FE8A,
        0x0000FE8A
    };

    static Char _decompositionMapping0000FE8B[] = 
    {
        0x00000626
    };

    static _CharacterInfo _character0000FE8B =
    {
        0x0000FE8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FE8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8B,
        0x0000FE8B,
        0x0000FE8B
    };

    static Char _decompositionMapping0000FE8C[] = 
    {
        0x00000626
    };

    static _CharacterInfo _character0000FE8C =
    {
        0x0000FE8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FE8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8C,
        0x0000FE8C,
        0x0000FE8C
    };

    static Char _decompositionMapping0000FE8D[] = 
    {
        0x00000627
    };

    static _CharacterInfo _character0000FE8D =
    {
        0x0000FE8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8D,
        0x0000FE8D,
        0x0000FE8D
    };

    static Char _decompositionMapping0000FE8E[] = 
    {
        0x00000627
    };

    static _CharacterInfo _character0000FE8E =
    {
        0x0000FE8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8E,
        0x0000FE8E,
        0x0000FE8E
    };

    static Char _decompositionMapping0000FE8F[] = 
    {
        0x00000628
    };

    static _CharacterInfo _character0000FE8F =
    {
        0x0000FE8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE8F,
        0x0000FE8F,
        0x0000FE8F
    };

    static Char _decompositionMapping0000FE90[] = 
    {
        0x00000628
    };

    static _CharacterInfo _character0000FE90 =
    {
        0x0000FE90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE90,
        0x0000FE90,
        0x0000FE90
    };

    static Char _decompositionMapping0000FE91[] = 
    {
        0x00000628
    };

    static _CharacterInfo _character0000FE91 =
    {
        0x0000FE91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FE91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE91,
        0x0000FE91,
        0x0000FE91
    };

    static Char _decompositionMapping0000FE92[] = 
    {
        0x00000628
    };

    static _CharacterInfo _character0000FE92 =
    {
        0x0000FE92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FE92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE92,
        0x0000FE92,
        0x0000FE92
    };

    static Char _decompositionMapping0000FE93[] = 
    {
        0x00000629
    };

    static _CharacterInfo _character0000FE93 =
    {
        0x0000FE93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE93,
        0x0000FE93,
        0x0000FE93
    };

    static Char _decompositionMapping0000FE94[] = 
    {
        0x00000629
    };

    static _CharacterInfo _character0000FE94 =
    {
        0x0000FE94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE94,
        0x0000FE94,
        0x0000FE94
    };

    static Char _decompositionMapping0000FE95[] = 
    {
        0x0000062A
    };

    static _CharacterInfo _character0000FE95 =
    {
        0x0000FE95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE95,
        0x0000FE95,
        0x0000FE95
    };

    static Char _decompositionMapping0000FE96[] = 
    {
        0x0000062A
    };

    static _CharacterInfo _character0000FE96 =
    {
        0x0000FE96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE96,
        0x0000FE96,
        0x0000FE96
    };

    static Char _decompositionMapping0000FE97[] = 
    {
        0x0000062A
    };

    static _CharacterInfo _character0000FE97 =
    {
        0x0000FE97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FE97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE97,
        0x0000FE97,
        0x0000FE97
    };

    static Char _decompositionMapping0000FE98[] = 
    {
        0x0000062A
    };

    static _CharacterInfo _character0000FE98 =
    {
        0x0000FE98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FE98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE98,
        0x0000FE98,
        0x0000FE98
    };

    static Char _decompositionMapping0000FE99[] = 
    {
        0x0000062B
    };

    static _CharacterInfo _character0000FE99 =
    {
        0x0000FE99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE99,
        0x0000FE99,
        0x0000FE99
    };

    static Char _decompositionMapping0000FE9A[] = 
    {
        0x0000062B
    };

    static _CharacterInfo _character0000FE9A =
    {
        0x0000FE9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9A,
        0x0000FE9A,
        0x0000FE9A
    };

    static Char _decompositionMapping0000FE9B[] = 
    {
        0x0000062B
    };

    static _CharacterInfo _character0000FE9B =
    {
        0x0000FE9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FE9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9B,
        0x0000FE9B,
        0x0000FE9B
    };

    static Char _decompositionMapping0000FE9C[] = 
    {
        0x0000062B
    };

    static _CharacterInfo _character0000FE9C =
    {
        0x0000FE9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FE9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9C,
        0x0000FE9C,
        0x0000FE9C
    };

    static Char _decompositionMapping0000FE9D[] = 
    {
        0x0000062C
    };

    static _CharacterInfo _character0000FE9D =
    {
        0x0000FE9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FE9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9D,
        0x0000FE9D,
        0x0000FE9D
    };

    static Char _decompositionMapping0000FE9E[] = 
    {
        0x0000062C
    };

    static _CharacterInfo _character0000FE9E =
    {
        0x0000FE9E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FE9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9E,
        0x0000FE9E,
        0x0000FE9E
    };

    static Char _decompositionMapping0000FE9F[] = 
    {
        0x0000062C
    };

    static _CharacterInfo _character0000FE9F =
    {
        0x0000FE9F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FE9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FE9F,
        0x0000FE9F,
        0x0000FE9F
    };

    static Char _decompositionMapping0000FEA0[] = 
    {
        0x0000062C
    };

    static _CharacterInfo _character0000FEA0 =
    {
        0x0000FEA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA0,
        0x0000FEA0,
        0x0000FEA0
    };

    static Char _decompositionMapping0000FEA1[] = 
    {
        0x0000062D
    };

    static _CharacterInfo _character0000FEA1 =
    {
        0x0000FEA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA1,
        0x0000FEA1,
        0x0000FEA1
    };

    static Char _decompositionMapping0000FEA2[] = 
    {
        0x0000062D
    };

    static _CharacterInfo _character0000FEA2 =
    {
        0x0000FEA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA2,
        0x0000FEA2,
        0x0000FEA2
    };

    static Char _decompositionMapping0000FEA3[] = 
    {
        0x0000062D
    };

    static _CharacterInfo _character0000FEA3 =
    {
        0x0000FEA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA3,
        0x0000FEA3,
        0x0000FEA3
    };

    static Char _decompositionMapping0000FEA4[] = 
    {
        0x0000062D
    };

    static _CharacterInfo _character0000FEA4 =
    {
        0x0000FEA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA4,
        0x0000FEA4,
        0x0000FEA4
    };

    static Char _decompositionMapping0000FEA5[] = 
    {
        0x0000062E
    };

    static _CharacterInfo _character0000FEA5 =
    {
        0x0000FEA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA5,
        0x0000FEA5,
        0x0000FEA5
    };

    static Char _decompositionMapping0000FEA6[] = 
    {
        0x0000062E
    };

    static _CharacterInfo _character0000FEA6 =
    {
        0x0000FEA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA6,
        0x0000FEA6,
        0x0000FEA6
    };

    static Char _decompositionMapping0000FEA7[] = 
    {
        0x0000062E
    };

    static _CharacterInfo _character0000FEA7 =
    {
        0x0000FEA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA7,
        0x0000FEA7,
        0x0000FEA7
    };

    static Char _decompositionMapping0000FEA8[] = 
    {
        0x0000062E
    };

    static _CharacterInfo _character0000FEA8 =
    {
        0x0000FEA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA8,
        0x0000FEA8,
        0x0000FEA8
    };

    static Char _decompositionMapping0000FEA9[] = 
    {
        0x0000062F
    };

    static _CharacterInfo _character0000FEA9 =
    {
        0x0000FEA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEA9,
        0x0000FEA9,
        0x0000FEA9
    };

    static Char _decompositionMapping0000FEAA[] = 
    {
        0x0000062F
    };

    static _CharacterInfo _character0000FEAA =
    {
        0x0000FEAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAA,
        0x0000FEAA,
        0x0000FEAA
    };

    static Char _decompositionMapping0000FEAB[] = 
    {
        0x00000630
    };

    static _CharacterInfo _character0000FEAB =
    {
        0x0000FEAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAB,
        0x0000FEAB,
        0x0000FEAB
    };

    static Char _decompositionMapping0000FEAC[] = 
    {
        0x00000630
    };

    static _CharacterInfo _character0000FEAC =
    {
        0x0000FEAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAC,
        0x0000FEAC,
        0x0000FEAC
    };

    static Char _decompositionMapping0000FEAD[] = 
    {
        0x00000631
    };

    static _CharacterInfo _character0000FEAD =
    {
        0x0000FEAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAD,
        0x0000FEAD,
        0x0000FEAD
    };

    static Char _decompositionMapping0000FEAE[] = 
    {
        0x00000631
    };

    static _CharacterInfo _character0000FEAE =
    {
        0x0000FEAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAE,
        0x0000FEAE,
        0x0000FEAE
    };

    static Char _decompositionMapping0000FEAF[] = 
    {
        0x00000632
    };

    static _CharacterInfo _character0000FEAF =
    {
        0x0000FEAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEAF,
        0x0000FEAF,
        0x0000FEAF
    };

    static Char _decompositionMapping0000FEB0[] = 
    {
        0x00000632
    };

    static _CharacterInfo _character0000FEB0 =
    {
        0x0000FEB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB0,
        0x0000FEB0,
        0x0000FEB0
    };

    static Char _decompositionMapping0000FEB1[] = 
    {
        0x00000633
    };

    static _CharacterInfo _character0000FEB1 =
    {
        0x0000FEB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB1,
        0x0000FEB1,
        0x0000FEB1
    };

    static Char _decompositionMapping0000FEB2[] = 
    {
        0x00000633
    };

    static _CharacterInfo _character0000FEB2 =
    {
        0x0000FEB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB2,
        0x0000FEB2,
        0x0000FEB2
    };

    static Char _decompositionMapping0000FEB3[] = 
    {
        0x00000633
    };

    static _CharacterInfo _character0000FEB3 =
    {
        0x0000FEB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB3,
        0x0000FEB3,
        0x0000FEB3
    };

    static Char _decompositionMapping0000FEB4[] = 
    {
        0x00000633
    };

    static _CharacterInfo _character0000FEB4 =
    {
        0x0000FEB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB4,
        0x0000FEB4,
        0x0000FEB4
    };

    static Char _decompositionMapping0000FEB5[] = 
    {
        0x00000634
    };

    static _CharacterInfo _character0000FEB5 =
    {
        0x0000FEB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB5,
        0x0000FEB5,
        0x0000FEB5
    };

    static Char _decompositionMapping0000FEB6[] = 
    {
        0x00000634
    };

    static _CharacterInfo _character0000FEB6 =
    {
        0x0000FEB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB6,
        0x0000FEB6,
        0x0000FEB6
    };

    static Char _decompositionMapping0000FEB7[] = 
    {
        0x00000634
    };

    static _CharacterInfo _character0000FEB7 =
    {
        0x0000FEB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB7,
        0x0000FEB7,
        0x0000FEB7
    };

    static Char _decompositionMapping0000FEB8[] = 
    {
        0x00000634
    };

    static _CharacterInfo _character0000FEB8 =
    {
        0x0000FEB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB8,
        0x0000FEB8,
        0x0000FEB8
    };

    static Char _decompositionMapping0000FEB9[] = 
    {
        0x00000635
    };

    static _CharacterInfo _character0000FEB9 =
    {
        0x0000FEB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEB9,
        0x0000FEB9,
        0x0000FEB9
    };

    static Char _decompositionMapping0000FEBA[] = 
    {
        0x00000635
    };

    static _CharacterInfo _character0000FEBA =
    {
        0x0000FEBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBA,
        0x0000FEBA,
        0x0000FEBA
    };

    static Char _decompositionMapping0000FEBB[] = 
    {
        0x00000635
    };

    static _CharacterInfo _character0000FEBB =
    {
        0x0000FEBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBB,
        0x0000FEBB,
        0x0000FEBB
    };

    static Char _decompositionMapping0000FEBC[] = 
    {
        0x00000635
    };

    static _CharacterInfo _character0000FEBC =
    {
        0x0000FEBC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBC,
        0x0000FEBC,
        0x0000FEBC
    };

    static Char _decompositionMapping0000FEBD[] = 
    {
        0x00000636
    };

    static _CharacterInfo _character0000FEBD =
    {
        0x0000FEBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBD,
        0x0000FEBD,
        0x0000FEBD
    };

    static Char _decompositionMapping0000FEBE[] = 
    {
        0x00000636
    };

    static _CharacterInfo _character0000FEBE =
    {
        0x0000FEBE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBE,
        0x0000FEBE,
        0x0000FEBE
    };

    static Char _decompositionMapping0000FEBF[] = 
    {
        0x00000636
    };

    static _CharacterInfo _character0000FEBF =
    {
        0x0000FEBF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEBF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEBF,
        0x0000FEBF,
        0x0000FEBF
    };

    static Char _decompositionMapping0000FEC0[] = 
    {
        0x00000636
    };

    static _CharacterInfo _character0000FEC0 =
    {
        0x0000FEC0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEC0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC0,
        0x0000FEC0,
        0x0000FEC0
    };

    static Char _decompositionMapping0000FEC1[] = 
    {
        0x00000637
    };

    static _CharacterInfo _character0000FEC1 =
    {
        0x0000FEC1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEC1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC1,
        0x0000FEC1,
        0x0000FEC1
    };

    static Char _decompositionMapping0000FEC2[] = 
    {
        0x00000637
    };

    static _CharacterInfo _character0000FEC2 =
    {
        0x0000FEC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC2,
        0x0000FEC2,
        0x0000FEC2
    };

    static Char _decompositionMapping0000FEC3[] = 
    {
        0x00000637
    };

    static _CharacterInfo _character0000FEC3 =
    {
        0x0000FEC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC3,
        0x0000FEC3,
        0x0000FEC3
    };

    static Char _decompositionMapping0000FEC4[] = 
    {
        0x00000637
    };

    static _CharacterInfo _character0000FEC4 =
    {
        0x0000FEC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC4,
        0x0000FEC4,
        0x0000FEC4
    };

    static Char _decompositionMapping0000FEC5[] = 
    {
        0x00000638
    };

    static _CharacterInfo _character0000FEC5 =
    {
        0x0000FEC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC5,
        0x0000FEC5,
        0x0000FEC5
    };

    static Char _decompositionMapping0000FEC6[] = 
    {
        0x00000638
    };

    static _CharacterInfo _character0000FEC6 =
    {
        0x0000FEC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC6,
        0x0000FEC6,
        0x0000FEC6
    };

    static Char _decompositionMapping0000FEC7[] = 
    {
        0x00000638
    };

    static _CharacterInfo _character0000FEC7 =
    {
        0x0000FEC7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC7,
        0x0000FEC7,
        0x0000FEC7
    };

    static Char _decompositionMapping0000FEC8[] = 
    {
        0x00000638
    };

    static _CharacterInfo _character0000FEC8 =
    {
        0x0000FEC8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEC8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC8,
        0x0000FEC8,
        0x0000FEC8
    };

    static Char _decompositionMapping0000FEC9[] = 
    {
        0x00000639
    };

    static _CharacterInfo _character0000FEC9 =
    {
        0x0000FEC9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEC9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEC9,
        0x0000FEC9,
        0x0000FEC9
    };

    static Char _decompositionMapping0000FECA[] = 
    {
        0x00000639
    };

    static _CharacterInfo _character0000FECA =
    {
        0x0000FECA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FECA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECA,
        0x0000FECA,
        0x0000FECA
    };

    static Char _decompositionMapping0000FECB[] = 
    {
        0x00000639
    };

    static _CharacterInfo _character0000FECB =
    {
        0x0000FECB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FECB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECB,
        0x0000FECB,
        0x0000FECB
    };

    static Char _decompositionMapping0000FECC[] = 
    {
        0x00000639
    };

    static _CharacterInfo _character0000FECC =
    {
        0x0000FECC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FECC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECC,
        0x0000FECC,
        0x0000FECC
    };

    static Char _decompositionMapping0000FECD[] = 
    {
        0x0000063A
    };

    static _CharacterInfo _character0000FECD =
    {
        0x0000FECD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FECD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECD,
        0x0000FECD,
        0x0000FECD
    };

    static Char _decompositionMapping0000FECE[] = 
    {
        0x0000063A
    };

    static _CharacterInfo _character0000FECE =
    {
        0x0000FECE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FECE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECE,
        0x0000FECE,
        0x0000FECE
    };

    static Char _decompositionMapping0000FECF[] = 
    {
        0x0000063A
    };

    static _CharacterInfo _character0000FECF =
    {
        0x0000FECF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FECF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FECF,
        0x0000FECF,
        0x0000FECF
    };

    static Char _decompositionMapping0000FED0[] = 
    {
        0x0000063A
    };

    static _CharacterInfo _character0000FED0 =
    {
        0x0000FED0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FED0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED0,
        0x0000FED0,
        0x0000FED0
    };

    static Char _decompositionMapping0000FED1[] = 
    {
        0x00000641
    };

    static _CharacterInfo _character0000FED1 =
    {
        0x0000FED1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FED1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED1,
        0x0000FED1,
        0x0000FED1
    };

    static Char _decompositionMapping0000FED2[] = 
    {
        0x00000641
    };

    static _CharacterInfo _character0000FED2 =
    {
        0x0000FED2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FED2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED2,
        0x0000FED2,
        0x0000FED2
    };

    static Char _decompositionMapping0000FED3[] = 
    {
        0x00000641
    };

    static _CharacterInfo _character0000FED3 =
    {
        0x0000FED3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FED3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED3,
        0x0000FED3,
        0x0000FED3
    };

    static Char _decompositionMapping0000FED4[] = 
    {
        0x00000641
    };

    static _CharacterInfo _character0000FED4 =
    {
        0x0000FED4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FED4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED4,
        0x0000FED4,
        0x0000FED4
    };

    static Char _decompositionMapping0000FED5[] = 
    {
        0x00000642
    };

    static _CharacterInfo _character0000FED5 =
    {
        0x0000FED5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FED5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED5,
        0x0000FED5,
        0x0000FED5
    };

    static Char _decompositionMapping0000FED6[] = 
    {
        0x00000642
    };

    static _CharacterInfo _character0000FED6 =
    {
        0x0000FED6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FED6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED6,
        0x0000FED6,
        0x0000FED6
    };

    static Char _decompositionMapping0000FED7[] = 
    {
        0x00000642
    };

    static _CharacterInfo _character0000FED7 =
    {
        0x0000FED7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FED7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED7,
        0x0000FED7,
        0x0000FED7
    };

    static Char _decompositionMapping0000FED8[] = 
    {
        0x00000642
    };

    static _CharacterInfo _character0000FED8 =
    {
        0x0000FED8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FED8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED8,
        0x0000FED8,
        0x0000FED8
    };

    static Char _decompositionMapping0000FED9[] = 
    {
        0x00000643
    };

    static _CharacterInfo _character0000FED9 =
    {
        0x0000FED9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FED9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FED9,
        0x0000FED9,
        0x0000FED9
    };

    static Char _decompositionMapping0000FEDA[] = 
    {
        0x00000643
    };

    static _CharacterInfo _character0000FEDA =
    {
        0x0000FEDA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDA,
        0x0000FEDA,
        0x0000FEDA
    };

    static Char _decompositionMapping0000FEDB[] = 
    {
        0x00000643
    };

    static _CharacterInfo _character0000FEDB =
    {
        0x0000FEDB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDB,
        0x0000FEDB,
        0x0000FEDB
    };

    static Char _decompositionMapping0000FEDC[] = 
    {
        0x00000643
    };

    static _CharacterInfo _character0000FEDC =
    {
        0x0000FEDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDC,
        0x0000FEDC,
        0x0000FEDC
    };

    static Char _decompositionMapping0000FEDD[] = 
    {
        0x00000644
    };

    static _CharacterInfo _character0000FEDD =
    {
        0x0000FEDD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEDD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDD,
        0x0000FEDD,
        0x0000FEDD
    };

    static Char _decompositionMapping0000FEDE[] = 
    {
        0x00000644
    };

    static _CharacterInfo _character0000FEDE =
    {
        0x0000FEDE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEDE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDE,
        0x0000FEDE,
        0x0000FEDE
    };

    static Char _decompositionMapping0000FEDF[] = 
    {
        0x00000644
    };

    static _CharacterInfo _character0000FEDF =
    {
        0x0000FEDF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEDF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEDF,
        0x0000FEDF,
        0x0000FEDF
    };

    static Char _decompositionMapping0000FEE0[] = 
    {
        0x00000644
    };

    static _CharacterInfo _character0000FEE0 =
    {
        0x0000FEE0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE0,
        0x0000FEE0,
        0x0000FEE0
    };

    static Char _decompositionMapping0000FEE1[] = 
    {
        0x00000645
    };

    static _CharacterInfo _character0000FEE1 =
    {
        0x0000FEE1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE1,
        0x0000FEE1,
        0x0000FEE1
    };

    static Char _decompositionMapping0000FEE2[] = 
    {
        0x00000645
    };

    static _CharacterInfo _character0000FEE2 =
    {
        0x0000FEE2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE2,
        0x0000FEE2,
        0x0000FEE2
    };

    static Char _decompositionMapping0000FEE3[] = 
    {
        0x00000645
    };

    static _CharacterInfo _character0000FEE3 =
    {
        0x0000FEE3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE3,
        0x0000FEE3,
        0x0000FEE3
    };

    static Char _decompositionMapping0000FEE4[] = 
    {
        0x00000645
    };

    static _CharacterInfo _character0000FEE4 =
    {
        0x0000FEE4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE4,
        0x0000FEE4,
        0x0000FEE4
    };

    static Char _decompositionMapping0000FEE5[] = 
    {
        0x00000646
    };

    static _CharacterInfo _character0000FEE5 =
    {
        0x0000FEE5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE5,
        0x0000FEE5,
        0x0000FEE5
    };

    static Char _decompositionMapping0000FEE6[] = 
    {
        0x00000646
    };

    static _CharacterInfo _character0000FEE6 =
    {
        0x0000FEE6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE6,
        0x0000FEE6,
        0x0000FEE6
    };

    static Char _decompositionMapping0000FEE7[] = 
    {
        0x00000646
    };

    static _CharacterInfo _character0000FEE7 =
    {
        0x0000FEE7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEE7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE7,
        0x0000FEE7,
        0x0000FEE7
    };

    static Char _decompositionMapping0000FEE8[] = 
    {
        0x00000646
    };

    static _CharacterInfo _character0000FEE8 =
    {
        0x0000FEE8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE8,
        0x0000FEE8,
        0x0000FEE8
    };

    static Char _decompositionMapping0000FEE9[] = 
    {
        0x00000647
    };

    static _CharacterInfo _character0000FEE9 =
    {
        0x0000FEE9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEE9,
        0x0000FEE9,
        0x0000FEE9
    };

    static Char _decompositionMapping0000FEEA[] = 
    {
        0x00000647
    };

    static _CharacterInfo _character0000FEEA =
    {
        0x0000FEEA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEEA,
        0x0000FEEA,
        0x0000FEEA
    };

    static Char _decompositionMapping0000FEEB[] = 
    {
        0x00000647
    };

    static _CharacterInfo _character0000FEEB =
    {
        0x0000FEEB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEEB,
        0x0000FEEB,
        0x0000FEEB
    };

    static Char _decompositionMapping0000FEEC[] = 
    {
        0x00000647
    };

    static _CharacterInfo _character0000FEEC =
    {
        0x0000FEEC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEEC,
        0x0000FEEC,
        0x0000FEEC
    };

    static Char _decompositionMapping0000FEED[] = 
    {
        0x00000648
    };

    static _CharacterInfo _character0000FEED =
    {
        0x0000FEED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEED,
        0x0000FEED,
        0x0000FEED
    };

    static Char _decompositionMapping0000FEEE[] = 
    {
        0x00000648
    };

    static _CharacterInfo _character0000FEEE =
    {
        0x0000FEEE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEEE,
        0x0000FEEE,
        0x0000FEEE
    };

    static Char _decompositionMapping0000FEEF[] = 
    {
        0x00000649
    };

    static _CharacterInfo _character0000FEEF =
    {
        0x0000FEEF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEEF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEEF,
        0x0000FEEF,
        0x0000FEEF
    };

    static Char _decompositionMapping0000FEF0[] = 
    {
        0x00000649
    };

    static _CharacterInfo _character0000FEF0 =
    {
        0x0000FEF0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEF0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF0,
        0x0000FEF0,
        0x0000FEF0
    };

    static Char _decompositionMapping0000FEF1[] = 
    {
        0x0000064A
    };

    static _CharacterInfo _character0000FEF1 =
    {
        0x0000FEF1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        1,
        _decompositionMapping0000FEF1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF1,
        0x0000FEF1,
        0x0000FEF1
    };

    static Char _decompositionMapping0000FEF2[] = 
    {
        0x0000064A
    };

    static _CharacterInfo _character0000FEF2 =
    {
        0x0000FEF2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        1,
        _decompositionMapping0000FEF2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF2,
        0x0000FEF2,
        0x0000FEF2
    };

    static Char _decompositionMapping0000FEF3[] = 
    {
        0x0000064A
    };

    static _CharacterInfo _character0000FEF3 =
    {
        0x0000FEF3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_initial,
        1,
        _decompositionMapping0000FEF3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF3,
        0x0000FEF3,
        0x0000FEF3
    };

    static Char _decompositionMapping0000FEF4[] = 
    {
        0x0000064A
    };

    static _CharacterInfo _character0000FEF4 =
    {
        0x0000FEF4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_medial,
        1,
        _decompositionMapping0000FEF4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF4,
        0x0000FEF4,
        0x0000FEF4
    };

    static Char _decompositionMapping0000FEF5[] = 
    {
        0x00000644,
        0x00000622
    };

    static _CharacterInfo _character0000FEF5 =
    {
        0x0000FEF5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FEF5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF5,
        0x0000FEF5,
        0x0000FEF5
    };

    static Char _decompositionMapping0000FEF6[] = 
    {
        0x00000644,
        0x00000622
    };

    static _CharacterInfo _character0000FEF6 =
    {
        0x0000FEF6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FEF6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF6,
        0x0000FEF6,
        0x0000FEF6
    };

    static Char _decompositionMapping0000FEF7[] = 
    {
        0x00000644,
        0x00000623
    };

    static _CharacterInfo _character0000FEF7 =
    {
        0x0000FEF7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FEF7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF7,
        0x0000FEF7,
        0x0000FEF7
    };

    static Char _decompositionMapping0000FEF8[] = 
    {
        0x00000644,
        0x00000623
    };

    static _CharacterInfo _character0000FEF8 =
    {
        0x0000FEF8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FEF8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF8,
        0x0000FEF8,
        0x0000FEF8
    };

    static Char _decompositionMapping0000FEF9[] = 
    {
        0x00000644,
        0x00000625
    };

    static _CharacterInfo _character0000FEF9 =
    {
        0x0000FEF9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FEF9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEF9,
        0x0000FEF9,
        0x0000FEF9
    };

    static Char _decompositionMapping0000FEFA[] = 
    {
        0x00000644,
        0x00000625
    };

    static _CharacterInfo _character0000FEFA =
    {
        0x0000FEFA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FEFA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEFA,
        0x0000FEFA,
        0x0000FEFA
    };

    static Char _decompositionMapping0000FEFB[] = 
    {
        0x00000644,
        0x00000627
    };

    static _CharacterInfo _character0000FEFB =
    {
        0x0000FEFB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_isolated,
        2,
        _decompositionMapping0000FEFB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEFB,
        0x0000FEFB,
        0x0000FEFB
    };

    static Char _decompositionMapping0000FEFC[] = 
    {
        0x00000644,
        0x00000627
    };

    static _CharacterInfo _character0000FEFC =
    {
        0x0000FEFC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_AL,
        Iso10646::DecompositionMappingTag_final,
        2,
        _decompositionMapping0000FEFC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEFC,
        0x0000FEFC,
        0x0000FEFC
    };

    static _CharacterInfo _character0000FEFF =
    {
        0x0000FEFF,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FEFF,
        0x0000FEFF,
        0x0000FEFF
    };

    static Char _decompositionMapping0000FF01[] = 
    {
        0x00000021
    };

    static _CharacterInfo _character0000FF01 =
    {
        0x0000FF01,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF01,
        0x0000FF01,
        0x0000FF01
    };

    static Char _decompositionMapping0000FF02[] = 
    {
        0x00000022
    };

    static _CharacterInfo _character0000FF02 =
    {
        0x0000FF02,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF02,
        0x0000FF02,
        0x0000FF02
    };

    static Char _decompositionMapping0000FF03[] = 
    {
        0x00000023
    };

    static _CharacterInfo _character0000FF03 =
    {
        0x0000FF03,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF03,
        0x0000FF03,
        0x0000FF03
    };

    static Char _decompositionMapping0000FF04[] = 
    {
        0x00000024
    };

    static _CharacterInfo _character0000FF04 =
    {
        0x0000FF04,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF04,
        0x0000FF04,
        0x0000FF04
    };

    static Char _decompositionMapping0000FF05[] = 
    {
        0x00000025
    };

    static _CharacterInfo _character0000FF05 =
    {
        0x0000FF05,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF05,
        0x0000FF05,
        0x0000FF05
    };

    static Char _decompositionMapping0000FF06[] = 
    {
        0x00000026
    };

    static _CharacterInfo _character0000FF06 =
    {
        0x0000FF06,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF06,
        0x0000FF06,
        0x0000FF06
    };

    static Char _decompositionMapping0000FF07[] = 
    {
        0x00000027
    };

    static _CharacterInfo _character0000FF07 =
    {
        0x0000FF07,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF07,
        0x0000FF07,
        0x0000FF07
    };

    static Char _decompositionMapping0000FF08[] = 
    {
        0x00000028
    };

    static _CharacterInfo _character0000FF08 =
    {
        0x0000FF08,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF08,
        0x0000FF08,
        0x0000FF08
    };

    static Char _decompositionMapping0000FF09[] = 
    {
        0x00000029
    };

    static _CharacterInfo _character0000FF09 =
    {
        0x0000FF09,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF09,
        0x0000FF09,
        0x0000FF09
    };

    static Char _decompositionMapping0000FF0A[] = 
    {
        0x0000002A
    };

    static _CharacterInfo _character0000FF0A =
    {
        0x0000FF0A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0A,
        0x0000FF0A,
        0x0000FF0A
    };

    static Char _decompositionMapping0000FF0B[] = 
    {
        0x0000002B
    };

    static _CharacterInfo _character0000FF0B =
    {
        0x0000FF0B,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0B,
        0x0000FF0B,
        0x0000FF0B
    };

    static Char _decompositionMapping0000FF0C[] = 
    {
        0x0000002C
    };

    static _CharacterInfo _character0000FF0C =
    {
        0x0000FF0C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0C,
        0x0000FF0C,
        0x0000FF0C
    };

    static Char _decompositionMapping0000FF0D[] = 
    {
        0x0000002D
    };

    static _CharacterInfo _character0000FF0D =
    {
        0x0000FF0D,
        Iso10646::GeneralCategory_Pd,
        0,
        Iso10646::BidirectionalCategory_ES,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0D,
        0x0000FF0D,
        0x0000FF0D
    };

    static Char _decompositionMapping0000FF0E[] = 
    {
        0x0000002E
    };

    static _CharacterInfo _character0000FF0E =
    {
        0x0000FF0E,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0E,
        0x0000FF0E,
        0x0000FF0E
    };

    static Char _decompositionMapping0000FF0F[] = 
    {
        0x0000002F
    };

    static _CharacterInfo _character0000FF0F =
    {
        0x0000FF0F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF0F,
        0x0000FF0F,
        0x0000FF0F
    };

    static Char _decompositionMapping0000FF10[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0000FF10 =
    {
        0x0000FF10,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF10,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0000FF10,
        0x0000FF10,
        0x0000FF10
    };

    static Char _decompositionMapping0000FF11[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0000FF11 =
    {
        0x0000FF11,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF11,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0000FF11,
        0x0000FF11,
        0x0000FF11
    };

    static Char _decompositionMapping0000FF12[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0000FF12 =
    {
        0x0000FF12,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF12,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0000FF12,
        0x0000FF12,
        0x0000FF12
    };

    static Char _decompositionMapping0000FF13[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0000FF13 =
    {
        0x0000FF13,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF13,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0000FF13,
        0x0000FF13,
        0x0000FF13
    };

    static Char _decompositionMapping0000FF14[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0000FF14 =
    {
        0x0000FF14,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF14,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0000FF14,
        0x0000FF14,
        0x0000FF14
    };

    static Char _decompositionMapping0000FF15[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0000FF15 =
    {
        0x0000FF15,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF15,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0000FF15,
        0x0000FF15,
        0x0000FF15
    };

    static Char _decompositionMapping0000FF16[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0000FF16 =
    {
        0x0000FF16,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF16,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0000FF16,
        0x0000FF16,
        0x0000FF16
    };

    static Char _decompositionMapping0000FF17[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0000FF17 =
    {
        0x0000FF17,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF17,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0000FF17,
        0x0000FF17,
        0x0000FF17
    };

    static Char _decompositionMapping0000FF18[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0000FF18 =
    {
        0x0000FF18,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF18,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0000FF18,
        0x0000FF18,
        0x0000FF18
    };

    static Char _decompositionMapping0000FF19[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0000FF19 =
    {
        0x0000FF19,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF19,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0000FF19,
        0x0000FF19,
        0x0000FF19
    };

    static Char _decompositionMapping0000FF1A[] = 
    {
        0x0000003A
    };

    static _CharacterInfo _character0000FF1A =
    {
        0x0000FF1A,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_CS,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF1A,
        0x0000FF1A,
        0x0000FF1A
    };

    static Char _decompositionMapping0000FF1B[] = 
    {
        0x0000003B
    };

    static _CharacterInfo _character0000FF1B =
    {
        0x0000FF1B,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF1B,
        0x0000FF1B,
        0x0000FF1B
    };

    static Char _decompositionMapping0000FF1C[] = 
    {
        0x0000003C
    };

    static _CharacterInfo _character0000FF1C =
    {
        0x0000FF1C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF1C,
        0x0000FF1C,
        0x0000FF1C
    };

    static Char _decompositionMapping0000FF1D[] = 
    {
        0x0000003D
    };

    static _CharacterInfo _character0000FF1D =
    {
        0x0000FF1D,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF1D,
        0x0000FF1D,
        0x0000FF1D
    };

    static Char _decompositionMapping0000FF1E[] = 
    {
        0x0000003E
    };

    static _CharacterInfo _character0000FF1E =
    {
        0x0000FF1E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF1E,
        0x0000FF1E,
        0x0000FF1E
    };

    static Char _decompositionMapping0000FF1F[] = 
    {
        0x0000003F
    };

    static _CharacterInfo _character0000FF1F =
    {
        0x0000FF1F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF1F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF1F,
        0x0000FF1F,
        0x0000FF1F
    };

    static Char _decompositionMapping0000FF20[] = 
    {
        0x00000040
    };

    static _CharacterInfo _character0000FF20 =
    {
        0x0000FF20,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF20,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF20,
        0x0000FF20,
        0x0000FF20
    };

    static Char _decompositionMapping0000FF21[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0000FF21 =
    {
        0x0000FF21,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF21,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF21,
        0x0000FF41,
        0x0000FF21
    };

    static Char _decompositionMapping0000FF22[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0000FF22 =
    {
        0x0000FF22,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF22,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF22,
        0x0000FF42,
        0x0000FF22
    };

    static Char _decompositionMapping0000FF23[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0000FF23 =
    {
        0x0000FF23,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF23,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF23,
        0x0000FF43,
        0x0000FF23
    };

    static Char _decompositionMapping0000FF24[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0000FF24 =
    {
        0x0000FF24,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF24,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF24,
        0x0000FF44,
        0x0000FF24
    };

    static Char _decompositionMapping0000FF25[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0000FF25 =
    {
        0x0000FF25,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF25,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF25,
        0x0000FF45,
        0x0000FF25
    };

    static Char _decompositionMapping0000FF26[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0000FF26 =
    {
        0x0000FF26,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF26,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF26,
        0x0000FF46,
        0x0000FF26
    };

    static Char _decompositionMapping0000FF27[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0000FF27 =
    {
        0x0000FF27,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF27,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF27,
        0x0000FF47,
        0x0000FF27
    };

    static Char _decompositionMapping0000FF28[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0000FF28 =
    {
        0x0000FF28,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF28,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF28,
        0x0000FF48,
        0x0000FF28
    };

    static Char _decompositionMapping0000FF29[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0000FF29 =
    {
        0x0000FF29,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF29,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF29,
        0x0000FF49,
        0x0000FF29
    };

    static Char _decompositionMapping0000FF2A[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0000FF2A =
    {
        0x0000FF2A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2A,
        0x0000FF4A,
        0x0000FF2A
    };

    static Char _decompositionMapping0000FF2B[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0000FF2B =
    {
        0x0000FF2B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2B,
        0x0000FF4B,
        0x0000FF2B
    };

    static Char _decompositionMapping0000FF2C[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0000FF2C =
    {
        0x0000FF2C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2C,
        0x0000FF4C,
        0x0000FF2C
    };

    static Char _decompositionMapping0000FF2D[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0000FF2D =
    {
        0x0000FF2D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2D,
        0x0000FF4D,
        0x0000FF2D
    };

    static Char _decompositionMapping0000FF2E[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0000FF2E =
    {
        0x0000FF2E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2E,
        0x0000FF4E,
        0x0000FF2E
    };

    static Char _decompositionMapping0000FF2F[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0000FF2F =
    {
        0x0000FF2F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF2F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2F,
        0x0000FF4F,
        0x0000FF2F
    };

    static Char _decompositionMapping0000FF30[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0000FF30 =
    {
        0x0000FF30,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF30,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF30,
        0x0000FF50,
        0x0000FF30
    };

    static Char _decompositionMapping0000FF31[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0000FF31 =
    {
        0x0000FF31,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF31,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF31,
        0x0000FF51,
        0x0000FF31
    };

    static Char _decompositionMapping0000FF32[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0000FF32 =
    {
        0x0000FF32,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF32,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF32,
        0x0000FF52,
        0x0000FF32
    };

    static Char _decompositionMapping0000FF33[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0000FF33 =
    {
        0x0000FF33,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF33,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF33,
        0x0000FF53,
        0x0000FF33
    };

    static Char _decompositionMapping0000FF34[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0000FF34 =
    {
        0x0000FF34,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF34,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF34,
        0x0000FF54,
        0x0000FF34
    };

    static Char _decompositionMapping0000FF35[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0000FF35 =
    {
        0x0000FF35,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF35,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF35,
        0x0000FF55,
        0x0000FF35
    };

    static Char _decompositionMapping0000FF36[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0000FF36 =
    {
        0x0000FF36,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF36,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF36,
        0x0000FF56,
        0x0000FF36
    };

    static Char _decompositionMapping0000FF37[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0000FF37 =
    {
        0x0000FF37,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF37,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF37,
        0x0000FF57,
        0x0000FF37
    };

    static Char _decompositionMapping0000FF38[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0000FF38 =
    {
        0x0000FF38,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF38,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF38,
        0x0000FF58,
        0x0000FF38
    };

    static Char _decompositionMapping0000FF39[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0000FF39 =
    {
        0x0000FF39,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF39,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF39,
        0x0000FF59,
        0x0000FF39
    };

    static Char _decompositionMapping0000FF3A[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0000FF3A =
    {
        0x0000FF3A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF3A,
        0x0000FF5A,
        0x0000FF3A
    };

    static Char _decompositionMapping0000FF3B[] = 
    {
        0x0000005B
    };

    static _CharacterInfo _character0000FF3B =
    {
        0x0000FF3B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF3B,
        0x0000FF3B,
        0x0000FF3B
    };

    static Char _decompositionMapping0000FF3C[] = 
    {
        0x0000005C
    };

    static _CharacterInfo _character0000FF3C =
    {
        0x0000FF3C,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF3C,
        0x0000FF3C,
        0x0000FF3C
    };

    static Char _decompositionMapping0000FF3D[] = 
    {
        0x0000005D
    };

    static _CharacterInfo _character0000FF3D =
    {
        0x0000FF3D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF3D,
        0x0000FF3D,
        0x0000FF3D
    };

    static Char _decompositionMapping0000FF3E[] = 
    {
        0x0000005E
    };

    static _CharacterInfo _character0000FF3E =
    {
        0x0000FF3E,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF3E,
        0x0000FF3E,
        0x0000FF3E
    };

    static Char _decompositionMapping0000FF3F[] = 
    {
        0x0000005F
    };

    static _CharacterInfo _character0000FF3F =
    {
        0x0000FF3F,
        Iso10646::GeneralCategory_Pc,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF3F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF3F,
        0x0000FF3F,
        0x0000FF3F
    };

    static Char _decompositionMapping0000FF40[] = 
    {
        0x00000060
    };

    static _CharacterInfo _character0000FF40 =
    {
        0x0000FF40,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF40,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF40,
        0x0000FF40,
        0x0000FF40
    };

    static Char _decompositionMapping0000FF41[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0000FF41 =
    {
        0x0000FF41,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF41,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF21,
        0x0000FF41,
        0x0000FF21
    };

    static Char _decompositionMapping0000FF42[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0000FF42 =
    {
        0x0000FF42,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF42,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF22,
        0x0000FF42,
        0x0000FF22
    };

    static Char _decompositionMapping0000FF43[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0000FF43 =
    {
        0x0000FF43,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF43,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF23,
        0x0000FF43,
        0x0000FF23
    };

    static Char _decompositionMapping0000FF44[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0000FF44 =
    {
        0x0000FF44,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF44,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF24,
        0x0000FF44,
        0x0000FF24
    };

    static Char _decompositionMapping0000FF45[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0000FF45 =
    {
        0x0000FF45,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF45,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF25,
        0x0000FF45,
        0x0000FF25
    };

    static Char _decompositionMapping0000FF46[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0000FF46 =
    {
        0x0000FF46,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF46,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF26,
        0x0000FF46,
        0x0000FF26
    };

    static Char _decompositionMapping0000FF47[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0000FF47 =
    {
        0x0000FF47,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF47,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF27,
        0x0000FF47,
        0x0000FF27
    };

    static Char _decompositionMapping0000FF48[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0000FF48 =
    {
        0x0000FF48,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF48,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF28,
        0x0000FF48,
        0x0000FF28
    };

    static Char _decompositionMapping0000FF49[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0000FF49 =
    {
        0x0000FF49,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF49,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF29,
        0x0000FF49,
        0x0000FF29
    };

    static Char _decompositionMapping0000FF4A[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0000FF4A =
    {
        0x0000FF4A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2A,
        0x0000FF4A,
        0x0000FF2A
    };

    static Char _decompositionMapping0000FF4B[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0000FF4B =
    {
        0x0000FF4B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2B,
        0x0000FF4B,
        0x0000FF2B
    };

    static Char _decompositionMapping0000FF4C[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0000FF4C =
    {
        0x0000FF4C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2C,
        0x0000FF4C,
        0x0000FF2C
    };

    static Char _decompositionMapping0000FF4D[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0000FF4D =
    {
        0x0000FF4D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2D,
        0x0000FF4D,
        0x0000FF2D
    };

    static Char _decompositionMapping0000FF4E[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0000FF4E =
    {
        0x0000FF4E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2E,
        0x0000FF4E,
        0x0000FF2E
    };

    static Char _decompositionMapping0000FF4F[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0000FF4F =
    {
        0x0000FF4F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF4F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF2F,
        0x0000FF4F,
        0x0000FF2F
    };

    static Char _decompositionMapping0000FF50[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0000FF50 =
    {
        0x0000FF50,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF50,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF30,
        0x0000FF50,
        0x0000FF30
    };

    static Char _decompositionMapping0000FF51[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0000FF51 =
    {
        0x0000FF51,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF51,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF31,
        0x0000FF51,
        0x0000FF31
    };

    static Char _decompositionMapping0000FF52[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0000FF52 =
    {
        0x0000FF52,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF52,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF32,
        0x0000FF52,
        0x0000FF32
    };

    static Char _decompositionMapping0000FF53[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0000FF53 =
    {
        0x0000FF53,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF53,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF33,
        0x0000FF53,
        0x0000FF33
    };

    static Char _decompositionMapping0000FF54[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0000FF54 =
    {
        0x0000FF54,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF54,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF34,
        0x0000FF54,
        0x0000FF34
    };

    static Char _decompositionMapping0000FF55[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0000FF55 =
    {
        0x0000FF55,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF55,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF35,
        0x0000FF55,
        0x0000FF35
    };

    static Char _decompositionMapping0000FF56[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0000FF56 =
    {
        0x0000FF56,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF56,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF36,
        0x0000FF56,
        0x0000FF36
    };

    static Char _decompositionMapping0000FF57[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0000FF57 =
    {
        0x0000FF57,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF57,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF37,
        0x0000FF57,
        0x0000FF37
    };

    static Char _decompositionMapping0000FF58[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0000FF58 =
    {
        0x0000FF58,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF58,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF38,
        0x0000FF58,
        0x0000FF38
    };

    static Char _decompositionMapping0000FF59[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0000FF59 =
    {
        0x0000FF59,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF59,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF39,
        0x0000FF59,
        0x0000FF39
    };

    static Char _decompositionMapping0000FF5A[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0000FF5A =
    {
        0x0000FF5A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF3A,
        0x0000FF5A,
        0x0000FF3A
    };

    static Char _decompositionMapping0000FF5B[] = 
    {
        0x0000007B
    };

    static _CharacterInfo _character0000FF5B =
    {
        0x0000FF5B,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF5B,
        0x0000FF5B,
        0x0000FF5B
    };

    static Char _decompositionMapping0000FF5C[] = 
    {
        0x0000007C
    };

    static _CharacterInfo _character0000FF5C =
    {
        0x0000FF5C,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF5C,
        0x0000FF5C,
        0x0000FF5C
    };

    static Char _decompositionMapping0000FF5D[] = 
    {
        0x0000007D
    };

    static _CharacterInfo _character0000FF5D =
    {
        0x0000FF5D,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF5D,
        0x0000FF5D,
        0x0000FF5D
    };

    static Char _decompositionMapping0000FF5E[] = 
    {
        0x0000007E
    };

    static _CharacterInfo _character0000FF5E =
    {
        0x0000FF5E,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF5E,
        0x0000FF5E,
        0x0000FF5E
    };

    static Char _decompositionMapping0000FF5F[] = 
    {
        0x00002985
    };

    static _CharacterInfo _character0000FF5F =
    {
        0x0000FF5F,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF5F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF5F,
        0x0000FF5F,
        0x0000FF5F
    };

    static Char _decompositionMapping0000FF60[] = 
    {
        0x00002986
    };

    static _CharacterInfo _character0000FF60 =
    {
        0x0000FF60,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FF60,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF60,
        0x0000FF60,
        0x0000FF60
    };

    static Char _decompositionMapping0000FF61[] = 
    {
        0x00003002
    };

    static _CharacterInfo _character0000FF61 =
    {
        0x0000FF61,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF61,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF61,
        0x0000FF61,
        0x0000FF61
    };

    static Char _decompositionMapping0000FF62[] = 
    {
        0x0000300C
    };

    static _CharacterInfo _character0000FF62 =
    {
        0x0000FF62,
        Iso10646::GeneralCategory_Ps,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF62,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF62,
        0x0000FF62,
        0x0000FF62
    };

    static Char _decompositionMapping0000FF63[] = 
    {
        0x0000300D
    };

    static _CharacterInfo _character0000FF63 =
    {
        0x0000FF63,
        Iso10646::GeneralCategory_Pe,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF63,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0000FF63,
        0x0000FF63,
        0x0000FF63
    };

    static Char _decompositionMapping0000FF64[] = 
    {
        0x00003001
    };

    static _CharacterInfo _character0000FF64 =
    {
        0x0000FF64,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF64,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF64,
        0x0000FF64,
        0x0000FF64
    };

    static Char _decompositionMapping0000FF65[] = 
    {
        0x000030FB
    };

    static _CharacterInfo _character0000FF65 =
    {
        0x0000FF65,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF65,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF65,
        0x0000FF65,
        0x0000FF65
    };

    static Char _decompositionMapping0000FF66[] = 
    {
        0x000030F2
    };

    static _CharacterInfo _character0000FF66 =
    {
        0x0000FF66,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF66,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF66,
        0x0000FF66,
        0x0000FF66
    };

    static Char _decompositionMapping0000FF67[] = 
    {
        0x000030A1
    };

    static _CharacterInfo _character0000FF67 =
    {
        0x0000FF67,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF67,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF67,
        0x0000FF67,
        0x0000FF67
    };

    static Char _decompositionMapping0000FF68[] = 
    {
        0x000030A3
    };

    static _CharacterInfo _character0000FF68 =
    {
        0x0000FF68,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF68,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF68,
        0x0000FF68,
        0x0000FF68
    };

    static Char _decompositionMapping0000FF69[] = 
    {
        0x000030A5
    };

    static _CharacterInfo _character0000FF69 =
    {
        0x0000FF69,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF69,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF69,
        0x0000FF69,
        0x0000FF69
    };

    static Char _decompositionMapping0000FF6A[] = 
    {
        0x000030A7
    };

    static _CharacterInfo _character0000FF6A =
    {
        0x0000FF6A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6A,
        0x0000FF6A,
        0x0000FF6A
    };

    static Char _decompositionMapping0000FF6B[] = 
    {
        0x000030A9
    };

    static _CharacterInfo _character0000FF6B =
    {
        0x0000FF6B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6B,
        0x0000FF6B,
        0x0000FF6B
    };

    static Char _decompositionMapping0000FF6C[] = 
    {
        0x000030E3
    };

    static _CharacterInfo _character0000FF6C =
    {
        0x0000FF6C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6C,
        0x0000FF6C,
        0x0000FF6C
    };

    static Char _decompositionMapping0000FF6D[] = 
    {
        0x000030E5
    };

    static _CharacterInfo _character0000FF6D =
    {
        0x0000FF6D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6D,
        0x0000FF6D,
        0x0000FF6D
    };

    static Char _decompositionMapping0000FF6E[] = 
    {
        0x000030E7
    };

    static _CharacterInfo _character0000FF6E =
    {
        0x0000FF6E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6E,
        0x0000FF6E,
        0x0000FF6E
    };

    static Char _decompositionMapping0000FF6F[] = 
    {
        0x000030C3
    };

    static _CharacterInfo _character0000FF6F =
    {
        0x0000FF6F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF6F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF6F,
        0x0000FF6F,
        0x0000FF6F
    };

    static Char _decompositionMapping0000FF70[] = 
    {
        0x000030FC
    };

    static _CharacterInfo _character0000FF70 =
    {
        0x0000FF70,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF70,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF70,
        0x0000FF70,
        0x0000FF70
    };

    static Char _decompositionMapping0000FF71[] = 
    {
        0x000030A2
    };

    static _CharacterInfo _character0000FF71 =
    {
        0x0000FF71,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF71,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF71,
        0x0000FF71,
        0x0000FF71
    };

    static Char _decompositionMapping0000FF72[] = 
    {
        0x000030A4
    };

    static _CharacterInfo _character0000FF72 =
    {
        0x0000FF72,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF72,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF72,
        0x0000FF72,
        0x0000FF72
    };

    static Char _decompositionMapping0000FF73[] = 
    {
        0x000030A6
    };

    static _CharacterInfo _character0000FF73 =
    {
        0x0000FF73,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF73,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF73,
        0x0000FF73,
        0x0000FF73
    };

    static Char _decompositionMapping0000FF74[] = 
    {
        0x000030A8
    };

    static _CharacterInfo _character0000FF74 =
    {
        0x0000FF74,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF74,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF74,
        0x0000FF74,
        0x0000FF74
    };

    static Char _decompositionMapping0000FF75[] = 
    {
        0x000030AA
    };

    static _CharacterInfo _character0000FF75 =
    {
        0x0000FF75,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF75,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF75,
        0x0000FF75,
        0x0000FF75
    };

    static Char _decompositionMapping0000FF76[] = 
    {
        0x000030AB
    };

    static _CharacterInfo _character0000FF76 =
    {
        0x0000FF76,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF76,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF76,
        0x0000FF76,
        0x0000FF76
    };

    static Char _decompositionMapping0000FF77[] = 
    {
        0x000030AD
    };

    static _CharacterInfo _character0000FF77 =
    {
        0x0000FF77,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF77,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF77,
        0x0000FF77,
        0x0000FF77
    };

    static Char _decompositionMapping0000FF78[] = 
    {
        0x000030AF
    };

    static _CharacterInfo _character0000FF78 =
    {
        0x0000FF78,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF78,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF78,
        0x0000FF78,
        0x0000FF78
    };

    static Char _decompositionMapping0000FF79[] = 
    {
        0x000030B1
    };

    static _CharacterInfo _character0000FF79 =
    {
        0x0000FF79,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF79,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF79,
        0x0000FF79,
        0x0000FF79
    };

    static Char _decompositionMapping0000FF7A[] = 
    {
        0x000030B3
    };

    static _CharacterInfo _character0000FF7A =
    {
        0x0000FF7A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7A,
        0x0000FF7A,
        0x0000FF7A
    };

    static Char _decompositionMapping0000FF7B[] = 
    {
        0x000030B5
    };

    static _CharacterInfo _character0000FF7B =
    {
        0x0000FF7B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7B,
        0x0000FF7B,
        0x0000FF7B
    };

    static Char _decompositionMapping0000FF7C[] = 
    {
        0x000030B7
    };

    static _CharacterInfo _character0000FF7C =
    {
        0x0000FF7C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7C,
        0x0000FF7C,
        0x0000FF7C
    };

    static Char _decompositionMapping0000FF7D[] = 
    {
        0x000030B9
    };

    static _CharacterInfo _character0000FF7D =
    {
        0x0000FF7D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7D,
        0x0000FF7D,
        0x0000FF7D
    };

    static Char _decompositionMapping0000FF7E[] = 
    {
        0x000030BB
    };

    static _CharacterInfo _character0000FF7E =
    {
        0x0000FF7E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7E,
        0x0000FF7E,
        0x0000FF7E
    };

    static Char _decompositionMapping0000FF7F[] = 
    {
        0x000030BD
    };

    static _CharacterInfo _character0000FF7F =
    {
        0x0000FF7F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF7F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF7F,
        0x0000FF7F,
        0x0000FF7F
    };

    static Char _decompositionMapping0000FF80[] = 
    {
        0x000030BF
    };

    static _CharacterInfo _character0000FF80 =
    {
        0x0000FF80,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF80,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF80,
        0x0000FF80,
        0x0000FF80
    };

    static Char _decompositionMapping0000FF81[] = 
    {
        0x000030C1
    };

    static _CharacterInfo _character0000FF81 =
    {
        0x0000FF81,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF81,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF81,
        0x0000FF81,
        0x0000FF81
    };

    static Char _decompositionMapping0000FF82[] = 
    {
        0x000030C4
    };

    static _CharacterInfo _character0000FF82 =
    {
        0x0000FF82,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF82,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF82,
        0x0000FF82,
        0x0000FF82
    };

    static Char _decompositionMapping0000FF83[] = 
    {
        0x000030C6
    };

    static _CharacterInfo _character0000FF83 =
    {
        0x0000FF83,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF83,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF83,
        0x0000FF83,
        0x0000FF83
    };

    static Char _decompositionMapping0000FF84[] = 
    {
        0x000030C8
    };

    static _CharacterInfo _character0000FF84 =
    {
        0x0000FF84,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF84,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF84,
        0x0000FF84,
        0x0000FF84
    };

    static Char _decompositionMapping0000FF85[] = 
    {
        0x000030CA
    };

    static _CharacterInfo _character0000FF85 =
    {
        0x0000FF85,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF85,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF85,
        0x0000FF85,
        0x0000FF85
    };

    static Char _decompositionMapping0000FF86[] = 
    {
        0x000030CB
    };

    static _CharacterInfo _character0000FF86 =
    {
        0x0000FF86,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF86,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF86,
        0x0000FF86,
        0x0000FF86
    };

    static Char _decompositionMapping0000FF87[] = 
    {
        0x000030CC
    };

    static _CharacterInfo _character0000FF87 =
    {
        0x0000FF87,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF87,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF87,
        0x0000FF87,
        0x0000FF87
    };

    static Char _decompositionMapping0000FF88[] = 
    {
        0x000030CD
    };

    static _CharacterInfo _character0000FF88 =
    {
        0x0000FF88,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF88,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF88,
        0x0000FF88,
        0x0000FF88
    };

    static Char _decompositionMapping0000FF89[] = 
    {
        0x000030CE
    };

    static _CharacterInfo _character0000FF89 =
    {
        0x0000FF89,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF89,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF89,
        0x0000FF89,
        0x0000FF89
    };

    static Char _decompositionMapping0000FF8A[] = 
    {
        0x000030CF
    };

    static _CharacterInfo _character0000FF8A =
    {
        0x0000FF8A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8A,
        0x0000FF8A,
        0x0000FF8A
    };

    static Char _decompositionMapping0000FF8B[] = 
    {
        0x000030D2
    };

    static _CharacterInfo _character0000FF8B =
    {
        0x0000FF8B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8B,
        0x0000FF8B,
        0x0000FF8B
    };

    static Char _decompositionMapping0000FF8C[] = 
    {
        0x000030D5
    };

    static _CharacterInfo _character0000FF8C =
    {
        0x0000FF8C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8C,
        0x0000FF8C,
        0x0000FF8C
    };

    static Char _decompositionMapping0000FF8D[] = 
    {
        0x000030D8
    };

    static _CharacterInfo _character0000FF8D =
    {
        0x0000FF8D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8D,
        0x0000FF8D,
        0x0000FF8D
    };

    static Char _decompositionMapping0000FF8E[] = 
    {
        0x000030DB
    };

    static _CharacterInfo _character0000FF8E =
    {
        0x0000FF8E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8E,
        0x0000FF8E,
        0x0000FF8E
    };

    static Char _decompositionMapping0000FF8F[] = 
    {
        0x000030DE
    };

    static _CharacterInfo _character0000FF8F =
    {
        0x0000FF8F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF8F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF8F,
        0x0000FF8F,
        0x0000FF8F
    };

    static Char _decompositionMapping0000FF90[] = 
    {
        0x000030DF
    };

    static _CharacterInfo _character0000FF90 =
    {
        0x0000FF90,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF90,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF90,
        0x0000FF90,
        0x0000FF90
    };

    static Char _decompositionMapping0000FF91[] = 
    {
        0x000030E0
    };

    static _CharacterInfo _character0000FF91 =
    {
        0x0000FF91,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF91,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF91,
        0x0000FF91,
        0x0000FF91
    };

    static Char _decompositionMapping0000FF92[] = 
    {
        0x000030E1
    };

    static _CharacterInfo _character0000FF92 =
    {
        0x0000FF92,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF92,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF92,
        0x0000FF92,
        0x0000FF92
    };

    static Char _decompositionMapping0000FF93[] = 
    {
        0x000030E2
    };

    static _CharacterInfo _character0000FF93 =
    {
        0x0000FF93,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF93,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF93,
        0x0000FF93,
        0x0000FF93
    };

    static Char _decompositionMapping0000FF94[] = 
    {
        0x000030E4
    };

    static _CharacterInfo _character0000FF94 =
    {
        0x0000FF94,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF94,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF94,
        0x0000FF94,
        0x0000FF94
    };

    static Char _decompositionMapping0000FF95[] = 
    {
        0x000030E6
    };

    static _CharacterInfo _character0000FF95 =
    {
        0x0000FF95,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF95,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF95,
        0x0000FF95,
        0x0000FF95
    };

    static Char _decompositionMapping0000FF96[] = 
    {
        0x000030E8
    };

    static _CharacterInfo _character0000FF96 =
    {
        0x0000FF96,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF96,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF96,
        0x0000FF96,
        0x0000FF96
    };

    static Char _decompositionMapping0000FF97[] = 
    {
        0x000030E9
    };

    static _CharacterInfo _character0000FF97 =
    {
        0x0000FF97,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF97,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF97,
        0x0000FF97,
        0x0000FF97
    };

    static Char _decompositionMapping0000FF98[] = 
    {
        0x000030EA
    };

    static _CharacterInfo _character0000FF98 =
    {
        0x0000FF98,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF98,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF98,
        0x0000FF98,
        0x0000FF98
    };

    static Char _decompositionMapping0000FF99[] = 
    {
        0x000030EB
    };

    static _CharacterInfo _character0000FF99 =
    {
        0x0000FF99,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF99,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF99,
        0x0000FF99,
        0x0000FF99
    };

    static Char _decompositionMapping0000FF9A[] = 
    {
        0x000030EC
    };

    static _CharacterInfo _character0000FF9A =
    {
        0x0000FF9A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9A,
        0x0000FF9A,
        0x0000FF9A
    };

    static Char _decompositionMapping0000FF9B[] = 
    {
        0x000030ED
    };

    static _CharacterInfo _character0000FF9B =
    {
        0x0000FF9B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9B,
        0x0000FF9B,
        0x0000FF9B
    };

    static Char _decompositionMapping0000FF9C[] = 
    {
        0x000030EF
    };

    static _CharacterInfo _character0000FF9C =
    {
        0x0000FF9C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9C,
        0x0000FF9C,
        0x0000FF9C
    };

    static Char _decompositionMapping0000FF9D[] = 
    {
        0x000030F3
    };

    static _CharacterInfo _character0000FF9D =
    {
        0x0000FF9D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9D,
        0x0000FF9D,
        0x0000FF9D
    };

    static Char _decompositionMapping0000FF9E[] = 
    {
        0x00003099
    };

    static _CharacterInfo _character0000FF9E =
    {
        0x0000FF9E,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9E,
        0x0000FF9E,
        0x0000FF9E
    };

    static Char _decompositionMapping0000FF9F[] = 
    {
        0x0000309A
    };

    static _CharacterInfo _character0000FF9F =
    {
        0x0000FF9F,
        Iso10646::GeneralCategory_Lm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FF9F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FF9F,
        0x0000FF9F,
        0x0000FF9F
    };

    static Char _decompositionMapping0000FFA0[] = 
    {
        0x00003164
    };

    static _CharacterInfo _character0000FFA0 =
    {
        0x0000FFA0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA0,
        0x0000FFA0,
        0x0000FFA0
    };

    static Char _decompositionMapping0000FFA1[] = 
    {
        0x00003131
    };

    static _CharacterInfo _character0000FFA1 =
    {
        0x0000FFA1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA1,
        0x0000FFA1,
        0x0000FFA1
    };

    static Char _decompositionMapping0000FFA2[] = 
    {
        0x00003132
    };

    static _CharacterInfo _character0000FFA2 =
    {
        0x0000FFA2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA2,
        0x0000FFA2,
        0x0000FFA2
    };

    static Char _decompositionMapping0000FFA3[] = 
    {
        0x00003133
    };

    static _CharacterInfo _character0000FFA3 =
    {
        0x0000FFA3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA3,
        0x0000FFA3,
        0x0000FFA3
    };

    static Char _decompositionMapping0000FFA4[] = 
    {
        0x00003134
    };

    static _CharacterInfo _character0000FFA4 =
    {
        0x0000FFA4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA4,
        0x0000FFA4,
        0x0000FFA4
    };

    static Char _decompositionMapping0000FFA5[] = 
    {
        0x00003135
    };

    static _CharacterInfo _character0000FFA5 =
    {
        0x0000FFA5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA5,
        0x0000FFA5,
        0x0000FFA5
    };

    static Char _decompositionMapping0000FFA6[] = 
    {
        0x00003136
    };

    static _CharacterInfo _character0000FFA6 =
    {
        0x0000FFA6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA6,
        0x0000FFA6,
        0x0000FFA6
    };

    static Char _decompositionMapping0000FFA7[] = 
    {
        0x00003137
    };

    static _CharacterInfo _character0000FFA7 =
    {
        0x0000FFA7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA7,
        0x0000FFA7,
        0x0000FFA7
    };

    static Char _decompositionMapping0000FFA8[] = 
    {
        0x00003138
    };

    static _CharacterInfo _character0000FFA8 =
    {
        0x0000FFA8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA8,
        0x0000FFA8,
        0x0000FFA8
    };

    static Char _decompositionMapping0000FFA9[] = 
    {
        0x00003139
    };

    static _CharacterInfo _character0000FFA9 =
    {
        0x0000FFA9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFA9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFA9,
        0x0000FFA9,
        0x0000FFA9
    };

    static Char _decompositionMapping0000FFAA[] = 
    {
        0x0000313A
    };

    static _CharacterInfo _character0000FFAA =
    {
        0x0000FFAA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAA,
        0x0000FFAA,
        0x0000FFAA
    };

    static Char _decompositionMapping0000FFAB[] = 
    {
        0x0000313B
    };

    static _CharacterInfo _character0000FFAB =
    {
        0x0000FFAB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAB,
        0x0000FFAB,
        0x0000FFAB
    };

    static Char _decompositionMapping0000FFAC[] = 
    {
        0x0000313C
    };

    static _CharacterInfo _character0000FFAC =
    {
        0x0000FFAC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAC,
        0x0000FFAC,
        0x0000FFAC
    };

    static Char _decompositionMapping0000FFAD[] = 
    {
        0x0000313D
    };

    static _CharacterInfo _character0000FFAD =
    {
        0x0000FFAD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAD,
        0x0000FFAD,
        0x0000FFAD
    };

    static Char _decompositionMapping0000FFAE[] = 
    {
        0x0000313E
    };

    static _CharacterInfo _character0000FFAE =
    {
        0x0000FFAE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAE,
        0x0000FFAE,
        0x0000FFAE
    };

    static Char _decompositionMapping0000FFAF[] = 
    {
        0x0000313F
    };

    static _CharacterInfo _character0000FFAF =
    {
        0x0000FFAF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFAF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFAF,
        0x0000FFAF,
        0x0000FFAF
    };

    static Char _decompositionMapping0000FFB0[] = 
    {
        0x00003140
    };

    static _CharacterInfo _character0000FFB0 =
    {
        0x0000FFB0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB0,
        0x0000FFB0,
        0x0000FFB0
    };

    static Char _decompositionMapping0000FFB1[] = 
    {
        0x00003141
    };

    static _CharacterInfo _character0000FFB1 =
    {
        0x0000FFB1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB1,
        0x0000FFB1,
        0x0000FFB1
    };

    static Char _decompositionMapping0000FFB2[] = 
    {
        0x00003142
    };

    static _CharacterInfo _character0000FFB2 =
    {
        0x0000FFB2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB2,
        0x0000FFB2,
        0x0000FFB2
    };

    static Char _decompositionMapping0000FFB3[] = 
    {
        0x00003143
    };

    static _CharacterInfo _character0000FFB3 =
    {
        0x0000FFB3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB3,
        0x0000FFB3,
        0x0000FFB3
    };

    static Char _decompositionMapping0000FFB4[] = 
    {
        0x00003144
    };

    static _CharacterInfo _character0000FFB4 =
    {
        0x0000FFB4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB4,
        0x0000FFB4,
        0x0000FFB4
    };

    static Char _decompositionMapping0000FFB5[] = 
    {
        0x00003145
    };

    static _CharacterInfo _character0000FFB5 =
    {
        0x0000FFB5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB5,
        0x0000FFB5,
        0x0000FFB5
    };

    static Char _decompositionMapping0000FFB6[] = 
    {
        0x00003146
    };

    static _CharacterInfo _character0000FFB6 =
    {
        0x0000FFB6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB6,
        0x0000FFB6,
        0x0000FFB6
    };

    static Char _decompositionMapping0000FFB7[] = 
    {
        0x00003147
    };

    static _CharacterInfo _character0000FFB7 =
    {
        0x0000FFB7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB7,
        0x0000FFB7,
        0x0000FFB7
    };

    static Char _decompositionMapping0000FFB8[] = 
    {
        0x00003148
    };

    static _CharacterInfo _character0000FFB8 =
    {
        0x0000FFB8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB8,
        0x0000FFB8,
        0x0000FFB8
    };

    static Char _decompositionMapping0000FFB9[] = 
    {
        0x00003149
    };

    static _CharacterInfo _character0000FFB9 =
    {
        0x0000FFB9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFB9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFB9,
        0x0000FFB9,
        0x0000FFB9
    };

    static Char _decompositionMapping0000FFBA[] = 
    {
        0x0000314A
    };

    static _CharacterInfo _character0000FFBA =
    {
        0x0000FFBA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFBA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFBA,
        0x0000FFBA,
        0x0000FFBA
    };

    static Char _decompositionMapping0000FFBB[] = 
    {
        0x0000314B
    };

    static _CharacterInfo _character0000FFBB =
    {
        0x0000FFBB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFBB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFBB,
        0x0000FFBB,
        0x0000FFBB
    };

    static Char _decompositionMapping0000FFBC[] = 
    {
        0x0000314C
    };

    static _CharacterInfo _character0000FFBC =
    {
        0x0000FFBC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFBC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFBC,
        0x0000FFBC,
        0x0000FFBC
    };

    static Char _decompositionMapping0000FFBD[] = 
    {
        0x0000314D
    };

    static _CharacterInfo _character0000FFBD =
    {
        0x0000FFBD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFBD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFBD,
        0x0000FFBD,
        0x0000FFBD
    };

    static Char _decompositionMapping0000FFBE[] = 
    {
        0x0000314E
    };

    static _CharacterInfo _character0000FFBE =
    {
        0x0000FFBE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFBE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFBE,
        0x0000FFBE,
        0x0000FFBE
    };

    static Char _decompositionMapping0000FFC2[] = 
    {
        0x0000314F
    };

    static _CharacterInfo _character0000FFC2 =
    {
        0x0000FFC2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC2,
        0x0000FFC2,
        0x0000FFC2
    };

    static Char _decompositionMapping0000FFC3[] = 
    {
        0x00003150
    };

    static _CharacterInfo _character0000FFC3 =
    {
        0x0000FFC3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC3,
        0x0000FFC3,
        0x0000FFC3
    };

    static Char _decompositionMapping0000FFC4[] = 
    {
        0x00003151
    };

    static _CharacterInfo _character0000FFC4 =
    {
        0x0000FFC4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC4,
        0x0000FFC4,
        0x0000FFC4
    };

    static Char _decompositionMapping0000FFC5[] = 
    {
        0x00003152
    };

    static _CharacterInfo _character0000FFC5 =
    {
        0x0000FFC5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC5,
        0x0000FFC5,
        0x0000FFC5
    };

    static Char _decompositionMapping0000FFC6[] = 
    {
        0x00003153
    };

    static _CharacterInfo _character0000FFC6 =
    {
        0x0000FFC6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC6,
        0x0000FFC6,
        0x0000FFC6
    };

    static Char _decompositionMapping0000FFC7[] = 
    {
        0x00003154
    };

    static _CharacterInfo _character0000FFC7 =
    {
        0x0000FFC7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFC7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFC7,
        0x0000FFC7,
        0x0000FFC7
    };

    static Char _decompositionMapping0000FFCA[] = 
    {
        0x00003155
    };

    static _CharacterInfo _character0000FFCA =
    {
        0x0000FFCA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCA,
        0x0000FFCA,
        0x0000FFCA
    };

    static Char _decompositionMapping0000FFCB[] = 
    {
        0x00003156
    };

    static _CharacterInfo _character0000FFCB =
    {
        0x0000FFCB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCB,
        0x0000FFCB,
        0x0000FFCB
    };

    static Char _decompositionMapping0000FFCC[] = 
    {
        0x00003157
    };

    static _CharacterInfo _character0000FFCC =
    {
        0x0000FFCC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCC,
        0x0000FFCC,
        0x0000FFCC
    };

    static Char _decompositionMapping0000FFCD[] = 
    {
        0x00003158
    };

    static _CharacterInfo _character0000FFCD =
    {
        0x0000FFCD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCD,
        0x0000FFCD,
        0x0000FFCD
    };

    static Char _decompositionMapping0000FFCE[] = 
    {
        0x00003159
    };

    static _CharacterInfo _character0000FFCE =
    {
        0x0000FFCE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCE,
        0x0000FFCE,
        0x0000FFCE
    };

    static Char _decompositionMapping0000FFCF[] = 
    {
        0x0000315A
    };

    static _CharacterInfo _character0000FFCF =
    {
        0x0000FFCF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFCF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFCF,
        0x0000FFCF,
        0x0000FFCF
    };

    static Char _decompositionMapping0000FFD2[] = 
    {
        0x0000315B
    };

    static _CharacterInfo _character0000FFD2 =
    {
        0x0000FFD2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD2,
        0x0000FFD2,
        0x0000FFD2
    };

    static Char _decompositionMapping0000FFD3[] = 
    {
        0x0000315C
    };

    static _CharacterInfo _character0000FFD3 =
    {
        0x0000FFD3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD3,
        0x0000FFD3,
        0x0000FFD3
    };

    static Char _decompositionMapping0000FFD4[] = 
    {
        0x0000315D
    };

    static _CharacterInfo _character0000FFD4 =
    {
        0x0000FFD4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD4,
        0x0000FFD4,
        0x0000FFD4
    };

    static Char _decompositionMapping0000FFD5[] = 
    {
        0x0000315E
    };

    static _CharacterInfo _character0000FFD5 =
    {
        0x0000FFD5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD5,
        0x0000FFD5,
        0x0000FFD5
    };

    static Char _decompositionMapping0000FFD6[] = 
    {
        0x0000315F
    };

    static _CharacterInfo _character0000FFD6 =
    {
        0x0000FFD6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD6,
        0x0000FFD6,
        0x0000FFD6
    };

    static Char _decompositionMapping0000FFD7[] = 
    {
        0x00003160
    };

    static _CharacterInfo _character0000FFD7 =
    {
        0x0000FFD7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFD7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFD7,
        0x0000FFD7,
        0x0000FFD7
    };

    static Char _decompositionMapping0000FFDA[] = 
    {
        0x00003161
    };

    static _CharacterInfo _character0000FFDA =
    {
        0x0000FFDA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFDA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFDA,
        0x0000FFDA,
        0x0000FFDA
    };

    static Char _decompositionMapping0000FFDB[] = 
    {
        0x00003162
    };

    static _CharacterInfo _character0000FFDB =
    {
        0x0000FFDB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFDB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFDB,
        0x0000FFDB,
        0x0000FFDB
    };

    static Char _decompositionMapping0000FFDC[] = 
    {
        0x00003163
    };

    static _CharacterInfo _character0000FFDC =
    {
        0x0000FFDC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFDC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFDC,
        0x0000FFDC,
        0x0000FFDC
    };

    static Char _decompositionMapping0000FFE0[] = 
    {
        0x000000A2
    };

    static _CharacterInfo _character0000FFE0 =
    {
        0x0000FFE0,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE0,
        0x0000FFE0,
        0x0000FFE0
    };

    static Char _decompositionMapping0000FFE1[] = 
    {
        0x000000A3
    };

    static _CharacterInfo _character0000FFE1 =
    {
        0x0000FFE1,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE1,
        0x0000FFE1,
        0x0000FFE1
    };

    static Char _decompositionMapping0000FFE2[] = 
    {
        0x000000AC
    };

    static _CharacterInfo _character0000FFE2 =
    {
        0x0000FFE2,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE2,
        0x0000FFE2,
        0x0000FFE2
    };

    static Char _decompositionMapping0000FFE3[] = 
    {
        0x000000AF
    };

    static _CharacterInfo _character0000FFE3 =
    {
        0x0000FFE3,
        Iso10646::GeneralCategory_Sk,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE3,
        0x0000FFE3,
        0x0000FFE3
    };

    static Char _decompositionMapping0000FFE4[] = 
    {
        0x000000A6
    };

    static _CharacterInfo _character0000FFE4 =
    {
        0x0000FFE4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE4,
        0x0000FFE4,
        0x0000FFE4
    };

    static Char _decompositionMapping0000FFE5[] = 
    {
        0x000000A5
    };

    static _CharacterInfo _character0000FFE5 =
    {
        0x0000FFE5,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE5,
        0x0000FFE5,
        0x0000FFE5
    };

    static Char _decompositionMapping0000FFE6[] = 
    {
        0x000020A9
    };

    static _CharacterInfo _character0000FFE6 =
    {
        0x0000FFE6,
        Iso10646::GeneralCategory_Sc,
        0,
        Iso10646::BidirectionalCategory_ET,
        Iso10646::DecompositionMappingTag_wide,
        1,
        _decompositionMapping0000FFE6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE6,
        0x0000FFE6,
        0x0000FFE6
    };

    static Char _decompositionMapping0000FFE8[] = 
    {
        0x00002502
    };

    static _CharacterInfo _character0000FFE8 =
    {
        0x0000FFE8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFE8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE8,
        0x0000FFE8,
        0x0000FFE8
    };

    static Char _decompositionMapping0000FFE9[] = 
    {
        0x00002190
    };

    static _CharacterInfo _character0000FFE9 =
    {
        0x0000FFE9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFE9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFE9,
        0x0000FFE9,
        0x0000FFE9
    };

    static Char _decompositionMapping0000FFEA[] = 
    {
        0x00002191
    };

    static _CharacterInfo _character0000FFEA =
    {
        0x0000FFEA,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFEA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFEA,
        0x0000FFEA,
        0x0000FFEA
    };

    static Char _decompositionMapping0000FFEB[] = 
    {
        0x00002192
    };

    static _CharacterInfo _character0000FFEB =
    {
        0x0000FFEB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFEB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFEB,
        0x0000FFEB,
        0x0000FFEB
    };

    static Char _decompositionMapping0000FFEC[] = 
    {
        0x00002193
    };

    static _CharacterInfo _character0000FFEC =
    {
        0x0000FFEC,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFEC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFEC,
        0x0000FFEC,
        0x0000FFEC
    };

    static Char _decompositionMapping0000FFED[] = 
    {
        0x000025A0
    };

    static _CharacterInfo _character0000FFED =
    {
        0x0000FFED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFED,
        0x0000FFED,
        0x0000FFED
    };

    static Char _decompositionMapping0000FFEE[] = 
    {
        0x000025CB
    };

    static _CharacterInfo _character0000FFEE =
    {
        0x0000FFEE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_narrow,
        1,
        _decompositionMapping0000FFEE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFEE,
        0x0000FFEE,
        0x0000FFEE
    };

    static _CharacterInfo _character0000FFF9 =
    {
        0x0000FFF9,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFF9,
        0x0000FFF9,
        0x0000FFF9
    };

    static _CharacterInfo _character0000FFFA =
    {
        0x0000FFFA,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFFA,
        0x0000FFFA,
        0x0000FFFA
    };

    static _CharacterInfo _character0000FFFB =
    {
        0x0000FFFB,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFFB,
        0x0000FFFB,
        0x0000FFFB
    };

    static _CharacterInfo _character0000FFFC =
    {
        0x0000FFFC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFFC,
        0x0000FFFC,
        0x0000FFFC
    };

    static _CharacterInfo _character0000FFFD =
    {
        0x0000FFFD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0000FFFD,
        0x0000FFFD,
        0x0000FFFD
    };

    static _CharacterInfo _character00010000 =
    {
        0x00010000,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010000,
        0x00010000,
        0x00010000
    };

    static _CharacterInfo _character00010001 =
    {
        0x00010001,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010001,
        0x00010001,
        0x00010001
    };

    static _CharacterInfo _character00010002 =
    {
        0x00010002,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010002,
        0x00010002,
        0x00010002
    };

    static _CharacterInfo _character00010003 =
    {
        0x00010003,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010003,
        0x00010003,
        0x00010003
    };

    static _CharacterInfo _character00010004 =
    {
        0x00010004,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010004,
        0x00010004,
        0x00010004
    };

    static _CharacterInfo _character00010005 =
    {
        0x00010005,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010005,
        0x00010005,
        0x00010005
    };

    static _CharacterInfo _character00010006 =
    {
        0x00010006,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010006,
        0x00010006,
        0x00010006
    };

    static _CharacterInfo _character00010007 =
    {
        0x00010007,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010007,
        0x00010007,
        0x00010007
    };

    static _CharacterInfo _character00010008 =
    {
        0x00010008,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010008,
        0x00010008,
        0x00010008
    };

    static _CharacterInfo _character00010009 =
    {
        0x00010009,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010009,
        0x00010009,
        0x00010009
    };

    static _CharacterInfo _character0001000A =
    {
        0x0001000A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001000A,
        0x0001000A,
        0x0001000A
    };

    static _CharacterInfo _character0001000B =
    {
        0x0001000B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001000B,
        0x0001000B,
        0x0001000B
    };

    static _CharacterInfo _character0001000D =
    {
        0x0001000D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001000D,
        0x0001000D,
        0x0001000D
    };

    static _CharacterInfo _character0001000E =
    {
        0x0001000E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001000E,
        0x0001000E,
        0x0001000E
    };

    static _CharacterInfo _character0001000F =
    {
        0x0001000F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001000F,
        0x0001000F,
        0x0001000F
    };

    static _CharacterInfo _character00010010 =
    {
        0x00010010,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010010,
        0x00010010,
        0x00010010
    };

    static _CharacterInfo _character00010011 =
    {
        0x00010011,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010011,
        0x00010011,
        0x00010011
    };

    static _CharacterInfo _character00010012 =
    {
        0x00010012,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010012,
        0x00010012,
        0x00010012
    };

    static _CharacterInfo _character00010013 =
    {
        0x00010013,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010013,
        0x00010013,
        0x00010013
    };

    static _CharacterInfo _character00010014 =
    {
        0x00010014,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010014,
        0x00010014,
        0x00010014
    };

    static _CharacterInfo _character00010015 =
    {
        0x00010015,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010015,
        0x00010015,
        0x00010015
    };

    static _CharacterInfo _character00010016 =
    {
        0x00010016,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010016,
        0x00010016,
        0x00010016
    };

    static _CharacterInfo _character00010017 =
    {
        0x00010017,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010017,
        0x00010017,
        0x00010017
    };

    static _CharacterInfo _character00010018 =
    {
        0x00010018,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010018,
        0x00010018,
        0x00010018
    };

    static _CharacterInfo _character00010019 =
    {
        0x00010019,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010019,
        0x00010019,
        0x00010019
    };

    static _CharacterInfo _character0001001A =
    {
        0x0001001A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001A,
        0x0001001A,
        0x0001001A
    };

    static _CharacterInfo _character0001001B =
    {
        0x0001001B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001B,
        0x0001001B,
        0x0001001B
    };

    static _CharacterInfo _character0001001C =
    {
        0x0001001C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001C,
        0x0001001C,
        0x0001001C
    };

    static _CharacterInfo _character0001001D =
    {
        0x0001001D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001D,
        0x0001001D,
        0x0001001D
    };

    static _CharacterInfo _character0001001E =
    {
        0x0001001E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001E,
        0x0001001E,
        0x0001001E
    };

    static _CharacterInfo _character0001001F =
    {
        0x0001001F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001001F,
        0x0001001F,
        0x0001001F
    };

    static _CharacterInfo _character00010020 =
    {
        0x00010020,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010020,
        0x00010020,
        0x00010020
    };

    static _CharacterInfo _character00010021 =
    {
        0x00010021,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010021,
        0x00010021,
        0x00010021
    };

    static _CharacterInfo _character00010022 =
    {
        0x00010022,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010022,
        0x00010022,
        0x00010022
    };

    static _CharacterInfo _character00010023 =
    {
        0x00010023,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010023,
        0x00010023,
        0x00010023
    };

    static _CharacterInfo _character00010024 =
    {
        0x00010024,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010024,
        0x00010024,
        0x00010024
    };

    static _CharacterInfo _character00010025 =
    {
        0x00010025,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010025,
        0x00010025,
        0x00010025
    };

    static _CharacterInfo _character00010026 =
    {
        0x00010026,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010026,
        0x00010026,
        0x00010026
    };

    static _CharacterInfo _character00010028 =
    {
        0x00010028,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010028,
        0x00010028,
        0x00010028
    };

    static _CharacterInfo _character00010029 =
    {
        0x00010029,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010029,
        0x00010029,
        0x00010029
    };

    static _CharacterInfo _character0001002A =
    {
        0x0001002A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002A,
        0x0001002A,
        0x0001002A
    };

    static _CharacterInfo _character0001002B =
    {
        0x0001002B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002B,
        0x0001002B,
        0x0001002B
    };

    static _CharacterInfo _character0001002C =
    {
        0x0001002C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002C,
        0x0001002C,
        0x0001002C
    };

    static _CharacterInfo _character0001002D =
    {
        0x0001002D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002D,
        0x0001002D,
        0x0001002D
    };

    static _CharacterInfo _character0001002E =
    {
        0x0001002E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002E,
        0x0001002E,
        0x0001002E
    };

    static _CharacterInfo _character0001002F =
    {
        0x0001002F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001002F,
        0x0001002F,
        0x0001002F
    };

    static _CharacterInfo _character00010030 =
    {
        0x00010030,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010030,
        0x00010030,
        0x00010030
    };

    static _CharacterInfo _character00010031 =
    {
        0x00010031,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010031,
        0x00010031,
        0x00010031
    };

    static _CharacterInfo _character00010032 =
    {
        0x00010032,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010032,
        0x00010032,
        0x00010032
    };

    static _CharacterInfo _character00010033 =
    {
        0x00010033,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010033,
        0x00010033,
        0x00010033
    };

    static _CharacterInfo _character00010034 =
    {
        0x00010034,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010034,
        0x00010034,
        0x00010034
    };

    static _CharacterInfo _character00010035 =
    {
        0x00010035,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010035,
        0x00010035,
        0x00010035
    };

    static _CharacterInfo _character00010036 =
    {
        0x00010036,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010036,
        0x00010036,
        0x00010036
    };

    static _CharacterInfo _character00010037 =
    {
        0x00010037,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010037,
        0x00010037,
        0x00010037
    };

    static _CharacterInfo _character00010038 =
    {
        0x00010038,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010038,
        0x00010038,
        0x00010038
    };

    static _CharacterInfo _character00010039 =
    {
        0x00010039,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010039,
        0x00010039,
        0x00010039
    };

    static _CharacterInfo _character0001003A =
    {
        0x0001003A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001003A,
        0x0001003A,
        0x0001003A
    };

    static _CharacterInfo _character0001003C =
    {
        0x0001003C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001003C,
        0x0001003C,
        0x0001003C
    };

    static _CharacterInfo _character0001003D =
    {
        0x0001003D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001003D,
        0x0001003D,
        0x0001003D
    };

    static _CharacterInfo _character0001003F =
    {
        0x0001003F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001003F,
        0x0001003F,
        0x0001003F
    };

    static _CharacterInfo _character00010040 =
    {
        0x00010040,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010040,
        0x00010040,
        0x00010040
    };

    static _CharacterInfo _character00010041 =
    {
        0x00010041,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010041,
        0x00010041,
        0x00010041
    };

    static _CharacterInfo _character00010042 =
    {
        0x00010042,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010042,
        0x00010042,
        0x00010042
    };

    static _CharacterInfo _character00010043 =
    {
        0x00010043,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010043,
        0x00010043,
        0x00010043
    };

    static _CharacterInfo _character00010044 =
    {
        0x00010044,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010044,
        0x00010044,
        0x00010044
    };

    static _CharacterInfo _character00010045 =
    {
        0x00010045,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010045,
        0x00010045,
        0x00010045
    };

    static _CharacterInfo _character00010046 =
    {
        0x00010046,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010046,
        0x00010046,
        0x00010046
    };

    static _CharacterInfo _character00010047 =
    {
        0x00010047,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010047,
        0x00010047,
        0x00010047
    };

    static _CharacterInfo _character00010048 =
    {
        0x00010048,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010048,
        0x00010048,
        0x00010048
    };

    static _CharacterInfo _character00010049 =
    {
        0x00010049,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010049,
        0x00010049,
        0x00010049
    };

    static _CharacterInfo _character0001004A =
    {
        0x0001004A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001004A,
        0x0001004A,
        0x0001004A
    };

    static _CharacterInfo _character0001004B =
    {
        0x0001004B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001004B,
        0x0001004B,
        0x0001004B
    };

    static _CharacterInfo _character0001004C =
    {
        0x0001004C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001004C,
        0x0001004C,
        0x0001004C
    };

    static _CharacterInfo _character0001004D =
    {
        0x0001004D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001004D,
        0x0001004D,
        0x0001004D
    };

    static _CharacterInfo _character00010050 =
    {
        0x00010050,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010050,
        0x00010050,
        0x00010050
    };

    static _CharacterInfo _character00010051 =
    {
        0x00010051,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010051,
        0x00010051,
        0x00010051
    };

    static _CharacterInfo _character00010052 =
    {
        0x00010052,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010052,
        0x00010052,
        0x00010052
    };

    static _CharacterInfo _character00010053 =
    {
        0x00010053,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010053,
        0x00010053,
        0x00010053
    };

    static _CharacterInfo _character00010054 =
    {
        0x00010054,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010054,
        0x00010054,
        0x00010054
    };

    static _CharacterInfo _character00010055 =
    {
        0x00010055,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010055,
        0x00010055,
        0x00010055
    };

    static _CharacterInfo _character00010056 =
    {
        0x00010056,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010056,
        0x00010056,
        0x00010056
    };

    static _CharacterInfo _character00010057 =
    {
        0x00010057,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010057,
        0x00010057,
        0x00010057
    };

    static _CharacterInfo _character00010058 =
    {
        0x00010058,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010058,
        0x00010058,
        0x00010058
    };

    static _CharacterInfo _character00010059 =
    {
        0x00010059,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010059,
        0x00010059,
        0x00010059
    };

    static _CharacterInfo _character0001005A =
    {
        0x0001005A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001005A,
        0x0001005A,
        0x0001005A
    };

    static _CharacterInfo _character0001005B =
    {
        0x0001005B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001005B,
        0x0001005B,
        0x0001005B
    };

    static _CharacterInfo _character0001005C =
    {
        0x0001005C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001005C,
        0x0001005C,
        0x0001005C
    };

    static _CharacterInfo _character0001005D =
    {
        0x0001005D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001005D,
        0x0001005D,
        0x0001005D
    };

    static _CharacterInfo _character00010080 =
    {
        0x00010080,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010080,
        0x00010080,
        0x00010080
    };

    static _CharacterInfo _character00010081 =
    {
        0x00010081,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010081,
        0x00010081,
        0x00010081
    };

    static _CharacterInfo _character00010082 =
    {
        0x00010082,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010082,
        0x00010082,
        0x00010082
    };

    static _CharacterInfo _character00010083 =
    {
        0x00010083,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010083,
        0x00010083,
        0x00010083
    };

    static _CharacterInfo _character00010084 =
    {
        0x00010084,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010084,
        0x00010084,
        0x00010084
    };

    static _CharacterInfo _character00010085 =
    {
        0x00010085,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010085,
        0x00010085,
        0x00010085
    };

    static _CharacterInfo _character00010086 =
    {
        0x00010086,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010086,
        0x00010086,
        0x00010086
    };

    static _CharacterInfo _character00010087 =
    {
        0x00010087,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010087,
        0x00010087,
        0x00010087
    };

    static _CharacterInfo _character00010088 =
    {
        0x00010088,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010088,
        0x00010088,
        0x00010088
    };

    static _CharacterInfo _character00010089 =
    {
        0x00010089,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010089,
        0x00010089,
        0x00010089
    };

    static _CharacterInfo _character0001008A =
    {
        0x0001008A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008A,
        0x0001008A,
        0x0001008A
    };

    static _CharacterInfo _character0001008B =
    {
        0x0001008B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008B,
        0x0001008B,
        0x0001008B
    };

    static _CharacterInfo _character0001008C =
    {
        0x0001008C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008C,
        0x0001008C,
        0x0001008C
    };

    static _CharacterInfo _character0001008D =
    {
        0x0001008D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008D,
        0x0001008D,
        0x0001008D
    };

    static _CharacterInfo _character0001008E =
    {
        0x0001008E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008E,
        0x0001008E,
        0x0001008E
    };

    static _CharacterInfo _character0001008F =
    {
        0x0001008F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001008F,
        0x0001008F,
        0x0001008F
    };

    static _CharacterInfo _character00010090 =
    {
        0x00010090,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010090,
        0x00010090,
        0x00010090
    };

    static _CharacterInfo _character00010091 =
    {
        0x00010091,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010091,
        0x00010091,
        0x00010091
    };

    static _CharacterInfo _character00010092 =
    {
        0x00010092,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010092,
        0x00010092,
        0x00010092
    };

    static _CharacterInfo _character00010093 =
    {
        0x00010093,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010093,
        0x00010093,
        0x00010093
    };

    static _CharacterInfo _character00010094 =
    {
        0x00010094,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010094,
        0x00010094,
        0x00010094
    };

    static _CharacterInfo _character00010095 =
    {
        0x00010095,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010095,
        0x00010095,
        0x00010095
    };

    static _CharacterInfo _character00010096 =
    {
        0x00010096,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010096,
        0x00010096,
        0x00010096
    };

    static _CharacterInfo _character00010097 =
    {
        0x00010097,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010097,
        0x00010097,
        0x00010097
    };

    static _CharacterInfo _character00010098 =
    {
        0x00010098,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010098,
        0x00010098,
        0x00010098
    };

    static _CharacterInfo _character00010099 =
    {
        0x00010099,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010099,
        0x00010099,
        0x00010099
    };

    static _CharacterInfo _character0001009A =
    {
        0x0001009A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009A,
        0x0001009A,
        0x0001009A
    };

    static _CharacterInfo _character0001009B =
    {
        0x0001009B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009B,
        0x0001009B,
        0x0001009B
    };

    static _CharacterInfo _character0001009C =
    {
        0x0001009C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009C,
        0x0001009C,
        0x0001009C
    };

    static _CharacterInfo _character0001009D =
    {
        0x0001009D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009D,
        0x0001009D,
        0x0001009D
    };

    static _CharacterInfo _character0001009E =
    {
        0x0001009E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009E,
        0x0001009E,
        0x0001009E
    };

    static _CharacterInfo _character0001009F =
    {
        0x0001009F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001009F,
        0x0001009F,
        0x0001009F
    };

    static _CharacterInfo _character000100A0 =
    {
        0x000100A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A0,
        0x000100A0,
        0x000100A0
    };

    static _CharacterInfo _character000100A1 =
    {
        0x000100A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A1,
        0x000100A1,
        0x000100A1
    };

    static _CharacterInfo _character000100A2 =
    {
        0x000100A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A2,
        0x000100A2,
        0x000100A2
    };

    static _CharacterInfo _character000100A3 =
    {
        0x000100A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A3,
        0x000100A3,
        0x000100A3
    };

    static _CharacterInfo _character000100A4 =
    {
        0x000100A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A4,
        0x000100A4,
        0x000100A4
    };

    static _CharacterInfo _character000100A5 =
    {
        0x000100A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A5,
        0x000100A5,
        0x000100A5
    };

    static _CharacterInfo _character000100A6 =
    {
        0x000100A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A6,
        0x000100A6,
        0x000100A6
    };

    static _CharacterInfo _character000100A7 =
    {
        0x000100A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A7,
        0x000100A7,
        0x000100A7
    };

    static _CharacterInfo _character000100A8 =
    {
        0x000100A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A8,
        0x000100A8,
        0x000100A8
    };

    static _CharacterInfo _character000100A9 =
    {
        0x000100A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100A9,
        0x000100A9,
        0x000100A9
    };

    static _CharacterInfo _character000100AA =
    {
        0x000100AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AA,
        0x000100AA,
        0x000100AA
    };

    static _CharacterInfo _character000100AB =
    {
        0x000100AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AB,
        0x000100AB,
        0x000100AB
    };

    static _CharacterInfo _character000100AC =
    {
        0x000100AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AC,
        0x000100AC,
        0x000100AC
    };

    static _CharacterInfo _character000100AD =
    {
        0x000100AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AD,
        0x000100AD,
        0x000100AD
    };

    static _CharacterInfo _character000100AE =
    {
        0x000100AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AE,
        0x000100AE,
        0x000100AE
    };

    static _CharacterInfo _character000100AF =
    {
        0x000100AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100AF,
        0x000100AF,
        0x000100AF
    };

    static _CharacterInfo _character000100B0 =
    {
        0x000100B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B0,
        0x000100B0,
        0x000100B0
    };

    static _CharacterInfo _character000100B1 =
    {
        0x000100B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B1,
        0x000100B1,
        0x000100B1
    };

    static _CharacterInfo _character000100B2 =
    {
        0x000100B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B2,
        0x000100B2,
        0x000100B2
    };

    static _CharacterInfo _character000100B3 =
    {
        0x000100B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B3,
        0x000100B3,
        0x000100B3
    };

    static _CharacterInfo _character000100B4 =
    {
        0x000100B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B4,
        0x000100B4,
        0x000100B4
    };

    static _CharacterInfo _character000100B5 =
    {
        0x000100B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B5,
        0x000100B5,
        0x000100B5
    };

    static _CharacterInfo _character000100B6 =
    {
        0x000100B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B6,
        0x000100B6,
        0x000100B6
    };

    static _CharacterInfo _character000100B7 =
    {
        0x000100B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B7,
        0x000100B7,
        0x000100B7
    };

    static _CharacterInfo _character000100B8 =
    {
        0x000100B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B8,
        0x000100B8,
        0x000100B8
    };

    static _CharacterInfo _character000100B9 =
    {
        0x000100B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100B9,
        0x000100B9,
        0x000100B9
    };

    static _CharacterInfo _character000100BA =
    {
        0x000100BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BA,
        0x000100BA,
        0x000100BA
    };

    static _CharacterInfo _character000100BB =
    {
        0x000100BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BB,
        0x000100BB,
        0x000100BB
    };

    static _CharacterInfo _character000100BC =
    {
        0x000100BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BC,
        0x000100BC,
        0x000100BC
    };

    static _CharacterInfo _character000100BD =
    {
        0x000100BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BD,
        0x000100BD,
        0x000100BD
    };

    static _CharacterInfo _character000100BE =
    {
        0x000100BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BE,
        0x000100BE,
        0x000100BE
    };

    static _CharacterInfo _character000100BF =
    {
        0x000100BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100BF,
        0x000100BF,
        0x000100BF
    };

    static _CharacterInfo _character000100C0 =
    {
        0x000100C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C0,
        0x000100C0,
        0x000100C0
    };

    static _CharacterInfo _character000100C1 =
    {
        0x000100C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C1,
        0x000100C1,
        0x000100C1
    };

    static _CharacterInfo _character000100C2 =
    {
        0x000100C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C2,
        0x000100C2,
        0x000100C2
    };

    static _CharacterInfo _character000100C3 =
    {
        0x000100C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C3,
        0x000100C3,
        0x000100C3
    };

    static _CharacterInfo _character000100C4 =
    {
        0x000100C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C4,
        0x000100C4,
        0x000100C4
    };

    static _CharacterInfo _character000100C5 =
    {
        0x000100C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C5,
        0x000100C5,
        0x000100C5
    };

    static _CharacterInfo _character000100C6 =
    {
        0x000100C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C6,
        0x000100C6,
        0x000100C6
    };

    static _CharacterInfo _character000100C7 =
    {
        0x000100C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C7,
        0x000100C7,
        0x000100C7
    };

    static _CharacterInfo _character000100C8 =
    {
        0x000100C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C8,
        0x000100C8,
        0x000100C8
    };

    static _CharacterInfo _character000100C9 =
    {
        0x000100C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100C9,
        0x000100C9,
        0x000100C9
    };

    static _CharacterInfo _character000100CA =
    {
        0x000100CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CA,
        0x000100CA,
        0x000100CA
    };

    static _CharacterInfo _character000100CB =
    {
        0x000100CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CB,
        0x000100CB,
        0x000100CB
    };

    static _CharacterInfo _character000100CC =
    {
        0x000100CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CC,
        0x000100CC,
        0x000100CC
    };

    static _CharacterInfo _character000100CD =
    {
        0x000100CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CD,
        0x000100CD,
        0x000100CD
    };

    static _CharacterInfo _character000100CE =
    {
        0x000100CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CE,
        0x000100CE,
        0x000100CE
    };

    static _CharacterInfo _character000100CF =
    {
        0x000100CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100CF,
        0x000100CF,
        0x000100CF
    };

    static _CharacterInfo _character000100D0 =
    {
        0x000100D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D0,
        0x000100D0,
        0x000100D0
    };

    static _CharacterInfo _character000100D1 =
    {
        0x000100D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D1,
        0x000100D1,
        0x000100D1
    };

    static _CharacterInfo _character000100D2 =
    {
        0x000100D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D2,
        0x000100D2,
        0x000100D2
    };

    static _CharacterInfo _character000100D3 =
    {
        0x000100D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D3,
        0x000100D3,
        0x000100D3
    };

    static _CharacterInfo _character000100D4 =
    {
        0x000100D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D4,
        0x000100D4,
        0x000100D4
    };

    static _CharacterInfo _character000100D5 =
    {
        0x000100D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D5,
        0x000100D5,
        0x000100D5
    };

    static _CharacterInfo _character000100D6 =
    {
        0x000100D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D6,
        0x000100D6,
        0x000100D6
    };

    static _CharacterInfo _character000100D7 =
    {
        0x000100D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D7,
        0x000100D7,
        0x000100D7
    };

    static _CharacterInfo _character000100D8 =
    {
        0x000100D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D8,
        0x000100D8,
        0x000100D8
    };

    static _CharacterInfo _character000100D9 =
    {
        0x000100D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100D9,
        0x000100D9,
        0x000100D9
    };

    static _CharacterInfo _character000100DA =
    {
        0x000100DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DA,
        0x000100DA,
        0x000100DA
    };

    static _CharacterInfo _character000100DB =
    {
        0x000100DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DB,
        0x000100DB,
        0x000100DB
    };

    static _CharacterInfo _character000100DC =
    {
        0x000100DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DC,
        0x000100DC,
        0x000100DC
    };

    static _CharacterInfo _character000100DD =
    {
        0x000100DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DD,
        0x000100DD,
        0x000100DD
    };

    static _CharacterInfo _character000100DE =
    {
        0x000100DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DE,
        0x000100DE,
        0x000100DE
    };

    static _CharacterInfo _character000100DF =
    {
        0x000100DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100DF,
        0x000100DF,
        0x000100DF
    };

    static _CharacterInfo _character000100E0 =
    {
        0x000100E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E0,
        0x000100E0,
        0x000100E0
    };

    static _CharacterInfo _character000100E1 =
    {
        0x000100E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E1,
        0x000100E1,
        0x000100E1
    };

    static _CharacterInfo _character000100E2 =
    {
        0x000100E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E2,
        0x000100E2,
        0x000100E2
    };

    static _CharacterInfo _character000100E3 =
    {
        0x000100E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E3,
        0x000100E3,
        0x000100E3
    };

    static _CharacterInfo _character000100E4 =
    {
        0x000100E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E4,
        0x000100E4,
        0x000100E4
    };

    static _CharacterInfo _character000100E5 =
    {
        0x000100E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E5,
        0x000100E5,
        0x000100E5
    };

    static _CharacterInfo _character000100E6 =
    {
        0x000100E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E6,
        0x000100E6,
        0x000100E6
    };

    static _CharacterInfo _character000100E7 =
    {
        0x000100E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E7,
        0x000100E7,
        0x000100E7
    };

    static _CharacterInfo _character000100E8 =
    {
        0x000100E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E8,
        0x000100E8,
        0x000100E8
    };

    static _CharacterInfo _character000100E9 =
    {
        0x000100E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100E9,
        0x000100E9,
        0x000100E9
    };

    static _CharacterInfo _character000100EA =
    {
        0x000100EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100EA,
        0x000100EA,
        0x000100EA
    };

    static _CharacterInfo _character000100EB =
    {
        0x000100EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100EB,
        0x000100EB,
        0x000100EB
    };

    static _CharacterInfo _character000100EC =
    {
        0x000100EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100EC,
        0x000100EC,
        0x000100EC
    };

    static _CharacterInfo _character000100ED =
    {
        0x000100ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100ED,
        0x000100ED,
        0x000100ED
    };

    static _CharacterInfo _character000100EE =
    {
        0x000100EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100EE,
        0x000100EE,
        0x000100EE
    };

    static _CharacterInfo _character000100EF =
    {
        0x000100EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100EF,
        0x000100EF,
        0x000100EF
    };

    static _CharacterInfo _character000100F0 =
    {
        0x000100F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F0,
        0x000100F0,
        0x000100F0
    };

    static _CharacterInfo _character000100F1 =
    {
        0x000100F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F1,
        0x000100F1,
        0x000100F1
    };

    static _CharacterInfo _character000100F2 =
    {
        0x000100F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F2,
        0x000100F2,
        0x000100F2
    };

    static _CharacterInfo _character000100F3 =
    {
        0x000100F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F3,
        0x000100F3,
        0x000100F3
    };

    static _CharacterInfo _character000100F4 =
    {
        0x000100F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F4,
        0x000100F4,
        0x000100F4
    };

    static _CharacterInfo _character000100F5 =
    {
        0x000100F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F5,
        0x000100F5,
        0x000100F5
    };

    static _CharacterInfo _character000100F6 =
    {
        0x000100F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F6,
        0x000100F6,
        0x000100F6
    };

    static _CharacterInfo _character000100F7 =
    {
        0x000100F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F7,
        0x000100F7,
        0x000100F7
    };

    static _CharacterInfo _character000100F8 =
    {
        0x000100F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F8,
        0x000100F8,
        0x000100F8
    };

    static _CharacterInfo _character000100F9 =
    {
        0x000100F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100F9,
        0x000100F9,
        0x000100F9
    };

    static _CharacterInfo _character000100FA =
    {
        0x000100FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000100FA,
        0x000100FA,
        0x000100FA
    };

    static _CharacterInfo _character00010100 =
    {
        0x00010100,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010100,
        0x00010100,
        0x00010100
    };

    static _CharacterInfo _character00010101 =
    {
        0x00010101,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010101,
        0x00010101,
        0x00010101
    };

    static _CharacterInfo _character00010102 =
    {
        0x00010102,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010102,
        0x00010102,
        0x00010102
    };

    static _CharacterInfo _character00010107 =
    {
        0x00010107,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010107,
        0x00010107,
        0x00010107
    };

    static _CharacterInfo _character00010108 =
    {
        0x00010108,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00010108,
        0x00010108,
        0x00010108
    };

    static _CharacterInfo _character00010109 =
    {
        0x00010109,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00010109,
        0x00010109,
        0x00010109
    };

    static _CharacterInfo _character0001010A =
    {
        0x0001010A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001010A,
        0x0001010A,
        0x0001010A
    };

    static _CharacterInfo _character0001010B =
    {
        0x0001010B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001010B,
        0x0001010B,
        0x0001010B
    };

    static _CharacterInfo _character0001010C =
    {
        0x0001010C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x0001010C,
        0x0001010C,
        0x0001010C
    };

    static _CharacterInfo _character0001010D =
    {
        0x0001010D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x0001010D,
        0x0001010D,
        0x0001010D
    };

    static _CharacterInfo _character0001010E =
    {
        0x0001010E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x0001010E,
        0x0001010E,
        0x0001010E
    };

    static _CharacterInfo _character0001010F =
    {
        0x0001010F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x0001010F,
        0x0001010F,
        0x0001010F
    };

    static _CharacterInfo _character00010110 =
    {
        0x00010110,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010110,
        0x00010110,
        0x00010110
    };

    static _CharacterInfo _character00010111 =
    {
        0x00010111,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00010111,
        0x00010111,
        0x00010111
    };

    static _CharacterInfo _character00010112 =
    {
        0x00010112,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x00010112,
        0x00010112,
        0x00010112
    };

    static _CharacterInfo _character00010113 =
    {
        0x00010113,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        40,
        1,
        false,
        0x00010113,
        0x00010113,
        0x00010113
    };

    static _CharacterInfo _character00010114 =
    {
        0x00010114,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010114,
        0x00010114,
        0x00010114
    };

    static _CharacterInfo _character00010115 =
    {
        0x00010115,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        60,
        1,
        false,
        0x00010115,
        0x00010115,
        0x00010115
    };

    static _CharacterInfo _character00010116 =
    {
        0x00010116,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        70,
        1,
        false,
        0x00010116,
        0x00010116,
        0x00010116
    };

    static _CharacterInfo _character00010117 =
    {
        0x00010117,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        80,
        1,
        false,
        0x00010117,
        0x00010117,
        0x00010117
    };

    static _CharacterInfo _character00010118 =
    {
        0x00010118,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        90,
        1,
        false,
        0x00010118,
        0x00010118,
        0x00010118
    };

    static _CharacterInfo _character00010119 =
    {
        0x00010119,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x00010119,
        0x00010119,
        0x00010119
    };

    static _CharacterInfo _character0001011A =
    {
        0x0001011A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        200,
        1,
        false,
        0x0001011A,
        0x0001011A,
        0x0001011A
    };

    static _CharacterInfo _character0001011B =
    {
        0x0001011B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        300,
        1,
        false,
        0x0001011B,
        0x0001011B,
        0x0001011B
    };

    static _CharacterInfo _character0001011C =
    {
        0x0001011C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        400,
        1,
        false,
        0x0001011C,
        0x0001011C,
        0x0001011C
    };

    static _CharacterInfo _character0001011D =
    {
        0x0001011D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001011D,
        0x0001011D,
        0x0001011D
    };

    static _CharacterInfo _character0001011E =
    {
        0x0001011E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        600,
        1,
        false,
        0x0001011E,
        0x0001011E,
        0x0001011E
    };

    static _CharacterInfo _character0001011F =
    {
        0x0001011F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        700,
        1,
        false,
        0x0001011F,
        0x0001011F,
        0x0001011F
    };

    static _CharacterInfo _character00010120 =
    {
        0x00010120,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        800,
        1,
        false,
        0x00010120,
        0x00010120,
        0x00010120
    };

    static _CharacterInfo _character00010121 =
    {
        0x00010121,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        900,
        1,
        false,
        0x00010121,
        0x00010121,
        0x00010121
    };

    static _CharacterInfo _character00010122 =
    {
        0x00010122,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00010122,
        0x00010122,
        0x00010122
    };

    static _CharacterInfo _character00010123 =
    {
        0x00010123,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2000,
        1,
        false,
        0x00010123,
        0x00010123,
        0x00010123
    };

    static _CharacterInfo _character00010124 =
    {
        0x00010124,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3000,
        1,
        false,
        0x00010124,
        0x00010124,
        0x00010124
    };

    static _CharacterInfo _character00010125 =
    {
        0x00010125,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4000,
        1,
        false,
        0x00010125,
        0x00010125,
        0x00010125
    };

    static _CharacterInfo _character00010126 =
    {
        0x00010126,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5000,
        1,
        false,
        0x00010126,
        0x00010126,
        0x00010126
    };

    static _CharacterInfo _character00010127 =
    {
        0x00010127,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6000,
        1,
        false,
        0x00010127,
        0x00010127,
        0x00010127
    };

    static _CharacterInfo _character00010128 =
    {
        0x00010128,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7000,
        1,
        false,
        0x00010128,
        0x00010128,
        0x00010128
    };

    static _CharacterInfo _character00010129 =
    {
        0x00010129,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8000,
        1,
        false,
        0x00010129,
        0x00010129,
        0x00010129
    };

    static _CharacterInfo _character0001012A =
    {
        0x0001012A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9000,
        1,
        false,
        0x0001012A,
        0x0001012A,
        0x0001012A
    };

    static _CharacterInfo _character0001012B =
    {
        0x0001012B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10000,
        1,
        false,
        0x0001012B,
        0x0001012B,
        0x0001012B
    };

    static _CharacterInfo _character0001012C =
    {
        0x0001012C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20000,
        1,
        false,
        0x0001012C,
        0x0001012C,
        0x0001012C
    };

    static _CharacterInfo _character0001012D =
    {
        0x0001012D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        30000,
        1,
        false,
        0x0001012D,
        0x0001012D,
        0x0001012D
    };

    static _CharacterInfo _character0001012E =
    {
        0x0001012E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        40000,
        1,
        false,
        0x0001012E,
        0x0001012E,
        0x0001012E
    };

    static _CharacterInfo _character0001012F =
    {
        0x0001012F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50000,
        1,
        false,
        0x0001012F,
        0x0001012F,
        0x0001012F
    };

    static _CharacterInfo _character00010130 =
    {
        0x00010130,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        60000,
        1,
        false,
        0x00010130,
        0x00010130,
        0x00010130
    };

    static _CharacterInfo _character00010131 =
    {
        0x00010131,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        70000,
        1,
        false,
        0x00010131,
        0x00010131,
        0x00010131
    };

    static _CharacterInfo _character00010132 =
    {
        0x00010132,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        80000,
        1,
        false,
        0x00010132,
        0x00010132,
        0x00010132
    };

    static _CharacterInfo _character00010133 =
    {
        0x00010133,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        90000,
        1,
        false,
        0x00010133,
        0x00010133,
        0x00010133
    };

    static _CharacterInfo _character00010137 =
    {
        0x00010137,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010137,
        0x00010137,
        0x00010137
    };

    static _CharacterInfo _character00010138 =
    {
        0x00010138,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010138,
        0x00010138,
        0x00010138
    };

    static _CharacterInfo _character00010139 =
    {
        0x00010139,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010139,
        0x00010139,
        0x00010139
    };

    static _CharacterInfo _character0001013A =
    {
        0x0001013A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013A,
        0x0001013A,
        0x0001013A
    };

    static _CharacterInfo _character0001013B =
    {
        0x0001013B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013B,
        0x0001013B,
        0x0001013B
    };

    static _CharacterInfo _character0001013C =
    {
        0x0001013C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013C,
        0x0001013C,
        0x0001013C
    };

    static _CharacterInfo _character0001013D =
    {
        0x0001013D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013D,
        0x0001013D,
        0x0001013D
    };

    static _CharacterInfo _character0001013E =
    {
        0x0001013E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013E,
        0x0001013E,
        0x0001013E
    };

    static _CharacterInfo _character0001013F =
    {
        0x0001013F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001013F,
        0x0001013F,
        0x0001013F
    };

    static _CharacterInfo _character00010140 =
    {
        0x00010140,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        4,
        false,
        0x00010140,
        0x00010140,
        0x00010140
    };

    static _CharacterInfo _character00010141 =
    {
        0x00010141,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x00010141,
        0x00010141,
        0x00010141
    };

    static _CharacterInfo _character00010142 =
    {
        0x00010142,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010142,
        0x00010142,
        0x00010142
    };

    static _CharacterInfo _character00010143 =
    {
        0x00010143,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00010143,
        0x00010143,
        0x00010143
    };

    static _CharacterInfo _character00010144 =
    {
        0x00010144,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010144,
        0x00010144,
        0x00010144
    };

    static _CharacterInfo _character00010145 =
    {
        0x00010145,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x00010145,
        0x00010145,
        0x00010145
    };

    static _CharacterInfo _character00010146 =
    {
        0x00010146,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5000,
        1,
        false,
        0x00010146,
        0x00010146,
        0x00010146
    };

    static _CharacterInfo _character00010147 =
    {
        0x00010147,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50000,
        1,
        false,
        0x00010147,
        0x00010147,
        0x00010147
    };

    static _CharacterInfo _character00010148 =
    {
        0x00010148,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00010148,
        0x00010148,
        0x00010148
    };

    static _CharacterInfo _character00010149 =
    {
        0x00010149,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010149,
        0x00010149,
        0x00010149
    };

    static _CharacterInfo _character0001014A =
    {
        0x0001014A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x0001014A,
        0x0001014A,
        0x0001014A
    };

    static _CharacterInfo _character0001014B =
    {
        0x0001014B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x0001014B,
        0x0001014B,
        0x0001014B
    };

    static _CharacterInfo _character0001014C =
    {
        0x0001014C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001014C,
        0x0001014C,
        0x0001014C
    };

    static _CharacterInfo _character0001014D =
    {
        0x0001014D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x0001014D,
        0x0001014D,
        0x0001014D
    };

    static _CharacterInfo _character0001014E =
    {
        0x0001014E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5000,
        1,
        false,
        0x0001014E,
        0x0001014E,
        0x0001014E
    };

    static _CharacterInfo _character0001014F =
    {
        0x0001014F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001014F,
        0x0001014F,
        0x0001014F
    };

    static _CharacterInfo _character00010150 =
    {
        0x00010150,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010150,
        0x00010150,
        0x00010150
    };

    static _CharacterInfo _character00010151 =
    {
        0x00010151,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010151,
        0x00010151,
        0x00010151
    };

    static _CharacterInfo _character00010152 =
    {
        0x00010152,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x00010152,
        0x00010152,
        0x00010152
    };

    static _CharacterInfo _character00010153 =
    {
        0x00010153,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x00010153,
        0x00010153,
        0x00010153
    };

    static _CharacterInfo _character00010154 =
    {
        0x00010154,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00010154,
        0x00010154,
        0x00010154
    };

    static _CharacterInfo _character00010155 =
    {
        0x00010155,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10000,
        1,
        false,
        0x00010155,
        0x00010155,
        0x00010155
    };

    static _CharacterInfo _character00010156 =
    {
        0x00010156,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50000,
        1,
        false,
        0x00010156,
        0x00010156,
        0x00010156
    };

    static _CharacterInfo _character00010157 =
    {
        0x00010157,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010157,
        0x00010157,
        0x00010157
    };

    static _CharacterInfo _character00010158 =
    {
        0x00010158,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010158,
        0x00010158,
        0x00010158
    };

    static _CharacterInfo _character00010159 =
    {
        0x00010159,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010159,
        0x00010159,
        0x00010159
    };

    static _CharacterInfo _character0001015A =
    {
        0x0001015A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0001015A,
        0x0001015A,
        0x0001015A
    };

    static _CharacterInfo _character0001015B =
    {
        0x0001015B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001015B,
        0x0001015B,
        0x0001015B
    };

    static _CharacterInfo _character0001015C =
    {
        0x0001015C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001015C,
        0x0001015C,
        0x0001015C
    };

    static _CharacterInfo _character0001015D =
    {
        0x0001015D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001015D,
        0x0001015D,
        0x0001015D
    };

    static _CharacterInfo _character0001015E =
    {
        0x0001015E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001015E,
        0x0001015E,
        0x0001015E
    };

    static _CharacterInfo _character0001015F =
    {
        0x0001015F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001015F,
        0x0001015F,
        0x0001015F
    };

    static _CharacterInfo _character00010160 =
    {
        0x00010160,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010160,
        0x00010160,
        0x00010160
    };

    static _CharacterInfo _character00010161 =
    {
        0x00010161,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010161,
        0x00010161,
        0x00010161
    };

    static _CharacterInfo _character00010162 =
    {
        0x00010162,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010162,
        0x00010162,
        0x00010162
    };

    static _CharacterInfo _character00010163 =
    {
        0x00010163,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010163,
        0x00010163,
        0x00010163
    };

    static _CharacterInfo _character00010164 =
    {
        0x00010164,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010164,
        0x00010164,
        0x00010164
    };

    static _CharacterInfo _character00010165 =
    {
        0x00010165,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x00010165,
        0x00010165,
        0x00010165
    };

    static _CharacterInfo _character00010166 =
    {
        0x00010166,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010166,
        0x00010166,
        0x00010166
    };

    static _CharacterInfo _character00010167 =
    {
        0x00010167,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010167,
        0x00010167,
        0x00010167
    };

    static _CharacterInfo _character00010168 =
    {
        0x00010168,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010168,
        0x00010168,
        0x00010168
    };

    static _CharacterInfo _character00010169 =
    {
        0x00010169,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010169,
        0x00010169,
        0x00010169
    };

    static _CharacterInfo _character0001016A =
    {
        0x0001016A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x0001016A,
        0x0001016A,
        0x0001016A
    };

    static _CharacterInfo _character0001016B =
    {
        0x0001016B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        300,
        1,
        false,
        0x0001016B,
        0x0001016B,
        0x0001016B
    };

    static _CharacterInfo _character0001016C =
    {
        0x0001016C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001016C,
        0x0001016C,
        0x0001016C
    };

    static _CharacterInfo _character0001016D =
    {
        0x0001016D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001016D,
        0x0001016D,
        0x0001016D
    };

    static _CharacterInfo _character0001016E =
    {
        0x0001016E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001016E,
        0x0001016E,
        0x0001016E
    };

    static _CharacterInfo _character0001016F =
    {
        0x0001016F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x0001016F,
        0x0001016F,
        0x0001016F
    };

    static _CharacterInfo _character00010170 =
    {
        0x00010170,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        500,
        1,
        false,
        0x00010170,
        0x00010170,
        0x00010170
    };

    static _CharacterInfo _character00010171 =
    {
        0x00010171,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00010171,
        0x00010171,
        0x00010171
    };

    static _CharacterInfo _character00010172 =
    {
        0x00010172,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5000,
        1,
        false,
        0x00010172,
        0x00010172,
        0x00010172
    };

    static _CharacterInfo _character00010173 =
    {
        0x00010173,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00010173,
        0x00010173,
        0x00010173
    };

    static _CharacterInfo _character00010174 =
    {
        0x00010174,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010174,
        0x00010174,
        0x00010174
    };

    static _CharacterInfo _character00010175 =
    {
        0x00010175,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x00010175,
        0x00010175,
        0x00010175
    };

    static _CharacterInfo _character00010176 =
    {
        0x00010176,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        2,
        false,
        0x00010176,
        0x00010176,
        0x00010176
    };

    static _CharacterInfo _character00010177 =
    {
        0x00010177,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        3,
        false,
        0x00010177,
        0x00010177,
        0x00010177
    };

    static _CharacterInfo _character00010178 =
    {
        0x00010178,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        4,
        false,
        0x00010178,
        0x00010178,
        0x00010178
    };

    static _CharacterInfo _character00010179 =
    {
        0x00010179,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010179,
        0x00010179,
        0x00010179
    };

    static _CharacterInfo _character0001017A =
    {
        0x0001017A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017A,
        0x0001017A,
        0x0001017A
    };

    static _CharacterInfo _character0001017B =
    {
        0x0001017B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017B,
        0x0001017B,
        0x0001017B
    };

    static _CharacterInfo _character0001017C =
    {
        0x0001017C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017C,
        0x0001017C,
        0x0001017C
    };

    static _CharacterInfo _character0001017D =
    {
        0x0001017D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017D,
        0x0001017D,
        0x0001017D
    };

    static _CharacterInfo _character0001017E =
    {
        0x0001017E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017E,
        0x0001017E,
        0x0001017E
    };

    static _CharacterInfo _character0001017F =
    {
        0x0001017F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001017F,
        0x0001017F,
        0x0001017F
    };

    static _CharacterInfo _character00010180 =
    {
        0x00010180,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010180,
        0x00010180,
        0x00010180
    };

    static _CharacterInfo _character00010181 =
    {
        0x00010181,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010181,
        0x00010181,
        0x00010181
    };

    static _CharacterInfo _character00010182 =
    {
        0x00010182,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010182,
        0x00010182,
        0x00010182
    };

    static _CharacterInfo _character00010183 =
    {
        0x00010183,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010183,
        0x00010183,
        0x00010183
    };

    static _CharacterInfo _character00010184 =
    {
        0x00010184,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010184,
        0x00010184,
        0x00010184
    };

    static _CharacterInfo _character00010185 =
    {
        0x00010185,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010185,
        0x00010185,
        0x00010185
    };

    static _CharacterInfo _character00010186 =
    {
        0x00010186,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010186,
        0x00010186,
        0x00010186
    };

    static _CharacterInfo _character00010187 =
    {
        0x00010187,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010187,
        0x00010187,
        0x00010187
    };

    static _CharacterInfo _character00010188 =
    {
        0x00010188,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010188,
        0x00010188,
        0x00010188
    };

    static _CharacterInfo _character00010189 =
    {
        0x00010189,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010189,
        0x00010189,
        0x00010189
    };

    static _CharacterInfo _character0001018A =
    {
        0x0001018A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        0,
        1,
        false,
        0x0001018A,
        0x0001018A,
        0x0001018A
    };

    static _CharacterInfo _character00010300 =
    {
        0x00010300,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010300,
        0x00010300,
        0x00010300
    };

    static _CharacterInfo _character00010301 =
    {
        0x00010301,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010301,
        0x00010301,
        0x00010301
    };

    static _CharacterInfo _character00010302 =
    {
        0x00010302,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010302,
        0x00010302,
        0x00010302
    };

    static _CharacterInfo _character00010303 =
    {
        0x00010303,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010303,
        0x00010303,
        0x00010303
    };

    static _CharacterInfo _character00010304 =
    {
        0x00010304,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010304,
        0x00010304,
        0x00010304
    };

    static _CharacterInfo _character00010305 =
    {
        0x00010305,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010305,
        0x00010305,
        0x00010305
    };

    static _CharacterInfo _character00010306 =
    {
        0x00010306,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010306,
        0x00010306,
        0x00010306
    };

    static _CharacterInfo _character00010307 =
    {
        0x00010307,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010307,
        0x00010307,
        0x00010307
    };

    static _CharacterInfo _character00010308 =
    {
        0x00010308,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010308,
        0x00010308,
        0x00010308
    };

    static _CharacterInfo _character00010309 =
    {
        0x00010309,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010309,
        0x00010309,
        0x00010309
    };

    static _CharacterInfo _character0001030A =
    {
        0x0001030A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030A,
        0x0001030A,
        0x0001030A
    };

    static _CharacterInfo _character0001030B =
    {
        0x0001030B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030B,
        0x0001030B,
        0x0001030B
    };

    static _CharacterInfo _character0001030C =
    {
        0x0001030C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030C,
        0x0001030C,
        0x0001030C
    };

    static _CharacterInfo _character0001030D =
    {
        0x0001030D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030D,
        0x0001030D,
        0x0001030D
    };

    static _CharacterInfo _character0001030E =
    {
        0x0001030E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030E,
        0x0001030E,
        0x0001030E
    };

    static _CharacterInfo _character0001030F =
    {
        0x0001030F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001030F,
        0x0001030F,
        0x0001030F
    };

    static _CharacterInfo _character00010310 =
    {
        0x00010310,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010310,
        0x00010310,
        0x00010310
    };

    static _CharacterInfo _character00010311 =
    {
        0x00010311,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010311,
        0x00010311,
        0x00010311
    };

    static _CharacterInfo _character00010312 =
    {
        0x00010312,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010312,
        0x00010312,
        0x00010312
    };

    static _CharacterInfo _character00010313 =
    {
        0x00010313,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010313,
        0x00010313,
        0x00010313
    };

    static _CharacterInfo _character00010314 =
    {
        0x00010314,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010314,
        0x00010314,
        0x00010314
    };

    static _CharacterInfo _character00010315 =
    {
        0x00010315,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010315,
        0x00010315,
        0x00010315
    };

    static _CharacterInfo _character00010316 =
    {
        0x00010316,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010316,
        0x00010316,
        0x00010316
    };

    static _CharacterInfo _character00010317 =
    {
        0x00010317,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010317,
        0x00010317,
        0x00010317
    };

    static _CharacterInfo _character00010318 =
    {
        0x00010318,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010318,
        0x00010318,
        0x00010318
    };

    static _CharacterInfo _character00010319 =
    {
        0x00010319,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010319,
        0x00010319,
        0x00010319
    };

    static _CharacterInfo _character0001031A =
    {
        0x0001031A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001031A,
        0x0001031A,
        0x0001031A
    };

    static _CharacterInfo _character0001031B =
    {
        0x0001031B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001031B,
        0x0001031B,
        0x0001031B
    };

    static _CharacterInfo _character0001031C =
    {
        0x0001031C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001031C,
        0x0001031C,
        0x0001031C
    };

    static _CharacterInfo _character0001031D =
    {
        0x0001031D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001031D,
        0x0001031D,
        0x0001031D
    };

    static _CharacterInfo _character0001031E =
    {
        0x0001031E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001031E,
        0x0001031E,
        0x0001031E
    };

    static _CharacterInfo _character00010320 =
    {
        0x00010320,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010320,
        0x00010320,
        0x00010320
    };

    static _CharacterInfo _character00010321 =
    {
        0x00010321,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00010321,
        0x00010321,
        0x00010321
    };

    static _CharacterInfo _character00010322 =
    {
        0x00010322,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010322,
        0x00010322,
        0x00010322
    };

    static _CharacterInfo _character00010323 =
    {
        0x00010323,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x00010323,
        0x00010323,
        0x00010323
    };

    static _CharacterInfo _character00010330 =
    {
        0x00010330,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010330,
        0x00010330,
        0x00010330
    };

    static _CharacterInfo _character00010331 =
    {
        0x00010331,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010331,
        0x00010331,
        0x00010331
    };

    static _CharacterInfo _character00010332 =
    {
        0x00010332,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010332,
        0x00010332,
        0x00010332
    };

    static _CharacterInfo _character00010333 =
    {
        0x00010333,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010333,
        0x00010333,
        0x00010333
    };

    static _CharacterInfo _character00010334 =
    {
        0x00010334,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010334,
        0x00010334,
        0x00010334
    };

    static _CharacterInfo _character00010335 =
    {
        0x00010335,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010335,
        0x00010335,
        0x00010335
    };

    static _CharacterInfo _character00010336 =
    {
        0x00010336,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010336,
        0x00010336,
        0x00010336
    };

    static _CharacterInfo _character00010337 =
    {
        0x00010337,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010337,
        0x00010337,
        0x00010337
    };

    static _CharacterInfo _character00010338 =
    {
        0x00010338,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010338,
        0x00010338,
        0x00010338
    };

    static _CharacterInfo _character00010339 =
    {
        0x00010339,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010339,
        0x00010339,
        0x00010339
    };

    static _CharacterInfo _character0001033A =
    {
        0x0001033A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033A,
        0x0001033A,
        0x0001033A
    };

    static _CharacterInfo _character0001033B =
    {
        0x0001033B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033B,
        0x0001033B,
        0x0001033B
    };

    static _CharacterInfo _character0001033C =
    {
        0x0001033C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033C,
        0x0001033C,
        0x0001033C
    };

    static _CharacterInfo _character0001033D =
    {
        0x0001033D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033D,
        0x0001033D,
        0x0001033D
    };

    static _CharacterInfo _character0001033E =
    {
        0x0001033E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033E,
        0x0001033E,
        0x0001033E
    };

    static _CharacterInfo _character0001033F =
    {
        0x0001033F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001033F,
        0x0001033F,
        0x0001033F
    };

    static _CharacterInfo _character00010340 =
    {
        0x00010340,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010340,
        0x00010340,
        0x00010340
    };

    static _CharacterInfo _character00010341 =
    {
        0x00010341,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        90,
        1,
        false,
        0x00010341,
        0x00010341,
        0x00010341
    };

    static _CharacterInfo _character00010342 =
    {
        0x00010342,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010342,
        0x00010342,
        0x00010342
    };

    static _CharacterInfo _character00010343 =
    {
        0x00010343,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010343,
        0x00010343,
        0x00010343
    };

    static _CharacterInfo _character00010344 =
    {
        0x00010344,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010344,
        0x00010344,
        0x00010344
    };

    static _CharacterInfo _character00010345 =
    {
        0x00010345,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010345,
        0x00010345,
        0x00010345
    };

    static _CharacterInfo _character00010346 =
    {
        0x00010346,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010346,
        0x00010346,
        0x00010346
    };

    static _CharacterInfo _character00010347 =
    {
        0x00010347,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010347,
        0x00010347,
        0x00010347
    };

    static _CharacterInfo _character00010348 =
    {
        0x00010348,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010348,
        0x00010348,
        0x00010348
    };

    static _CharacterInfo _character00010349 =
    {
        0x00010349,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010349,
        0x00010349,
        0x00010349
    };

    static _CharacterInfo _character0001034A =
    {
        0x0001034A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        900,
        1,
        false,
        0x0001034A,
        0x0001034A,
        0x0001034A
    };

    static _CharacterInfo _character00010380 =
    {
        0x00010380,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010380,
        0x00010380,
        0x00010380
    };

    static _CharacterInfo _character00010381 =
    {
        0x00010381,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010381,
        0x00010381,
        0x00010381
    };

    static _CharacterInfo _character00010382 =
    {
        0x00010382,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010382,
        0x00010382,
        0x00010382
    };

    static _CharacterInfo _character00010383 =
    {
        0x00010383,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010383,
        0x00010383,
        0x00010383
    };

    static _CharacterInfo _character00010384 =
    {
        0x00010384,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010384,
        0x00010384,
        0x00010384
    };

    static _CharacterInfo _character00010385 =
    {
        0x00010385,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010385,
        0x00010385,
        0x00010385
    };

    static _CharacterInfo _character00010386 =
    {
        0x00010386,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010386,
        0x00010386,
        0x00010386
    };

    static _CharacterInfo _character00010387 =
    {
        0x00010387,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010387,
        0x00010387,
        0x00010387
    };

    static _CharacterInfo _character00010388 =
    {
        0x00010388,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010388,
        0x00010388,
        0x00010388
    };

    static _CharacterInfo _character00010389 =
    {
        0x00010389,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010389,
        0x00010389,
        0x00010389
    };

    static _CharacterInfo _character0001038A =
    {
        0x0001038A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038A,
        0x0001038A,
        0x0001038A
    };

    static _CharacterInfo _character0001038B =
    {
        0x0001038B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038B,
        0x0001038B,
        0x0001038B
    };

    static _CharacterInfo _character0001038C =
    {
        0x0001038C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038C,
        0x0001038C,
        0x0001038C
    };

    static _CharacterInfo _character0001038D =
    {
        0x0001038D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038D,
        0x0001038D,
        0x0001038D
    };

    static _CharacterInfo _character0001038E =
    {
        0x0001038E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038E,
        0x0001038E,
        0x0001038E
    };

    static _CharacterInfo _character0001038F =
    {
        0x0001038F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001038F,
        0x0001038F,
        0x0001038F
    };

    static _CharacterInfo _character00010390 =
    {
        0x00010390,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010390,
        0x00010390,
        0x00010390
    };

    static _CharacterInfo _character00010391 =
    {
        0x00010391,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010391,
        0x00010391,
        0x00010391
    };

    static _CharacterInfo _character00010392 =
    {
        0x00010392,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010392,
        0x00010392,
        0x00010392
    };

    static _CharacterInfo _character00010393 =
    {
        0x00010393,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010393,
        0x00010393,
        0x00010393
    };

    static _CharacterInfo _character00010394 =
    {
        0x00010394,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010394,
        0x00010394,
        0x00010394
    };

    static _CharacterInfo _character00010395 =
    {
        0x00010395,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010395,
        0x00010395,
        0x00010395
    };

    static _CharacterInfo _character00010396 =
    {
        0x00010396,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010396,
        0x00010396,
        0x00010396
    };

    static _CharacterInfo _character00010397 =
    {
        0x00010397,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010397,
        0x00010397,
        0x00010397
    };

    static _CharacterInfo _character00010398 =
    {
        0x00010398,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010398,
        0x00010398,
        0x00010398
    };

    static _CharacterInfo _character00010399 =
    {
        0x00010399,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010399,
        0x00010399,
        0x00010399
    };

    static _CharacterInfo _character0001039A =
    {
        0x0001039A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001039A,
        0x0001039A,
        0x0001039A
    };

    static _CharacterInfo _character0001039B =
    {
        0x0001039B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001039B,
        0x0001039B,
        0x0001039B
    };

    static _CharacterInfo _character0001039C =
    {
        0x0001039C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001039C,
        0x0001039C,
        0x0001039C
    };

    static _CharacterInfo _character0001039D =
    {
        0x0001039D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001039D,
        0x0001039D,
        0x0001039D
    };

    static _CharacterInfo _character0001039F =
    {
        0x0001039F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001039F,
        0x0001039F,
        0x0001039F
    };

    static _CharacterInfo _character000103A0 =
    {
        0x000103A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A0,
        0x000103A0,
        0x000103A0
    };

    static _CharacterInfo _character000103A1 =
    {
        0x000103A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A1,
        0x000103A1,
        0x000103A1
    };

    static _CharacterInfo _character000103A2 =
    {
        0x000103A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A2,
        0x000103A2,
        0x000103A2
    };

    static _CharacterInfo _character000103A3 =
    {
        0x000103A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A3,
        0x000103A3,
        0x000103A3
    };

    static _CharacterInfo _character000103A4 =
    {
        0x000103A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A4,
        0x000103A4,
        0x000103A4
    };

    static _CharacterInfo _character000103A5 =
    {
        0x000103A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A5,
        0x000103A5,
        0x000103A5
    };

    static _CharacterInfo _character000103A6 =
    {
        0x000103A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A6,
        0x000103A6,
        0x000103A6
    };

    static _CharacterInfo _character000103A7 =
    {
        0x000103A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A7,
        0x000103A7,
        0x000103A7
    };

    static _CharacterInfo _character000103A8 =
    {
        0x000103A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A8,
        0x000103A8,
        0x000103A8
    };

    static _CharacterInfo _character000103A9 =
    {
        0x000103A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103A9,
        0x000103A9,
        0x000103A9
    };

    static _CharacterInfo _character000103AA =
    {
        0x000103AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AA,
        0x000103AA,
        0x000103AA
    };

    static _CharacterInfo _character000103AB =
    {
        0x000103AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AB,
        0x000103AB,
        0x000103AB
    };

    static _CharacterInfo _character000103AC =
    {
        0x000103AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AC,
        0x000103AC,
        0x000103AC
    };

    static _CharacterInfo _character000103AD =
    {
        0x000103AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AD,
        0x000103AD,
        0x000103AD
    };

    static _CharacterInfo _character000103AE =
    {
        0x000103AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AE,
        0x000103AE,
        0x000103AE
    };

    static _CharacterInfo _character000103AF =
    {
        0x000103AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103AF,
        0x000103AF,
        0x000103AF
    };

    static _CharacterInfo _character000103B0 =
    {
        0x000103B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B0,
        0x000103B0,
        0x000103B0
    };

    static _CharacterInfo _character000103B1 =
    {
        0x000103B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B1,
        0x000103B1,
        0x000103B1
    };

    static _CharacterInfo _character000103B2 =
    {
        0x000103B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B2,
        0x000103B2,
        0x000103B2
    };

    static _CharacterInfo _character000103B3 =
    {
        0x000103B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B3,
        0x000103B3,
        0x000103B3
    };

    static _CharacterInfo _character000103B4 =
    {
        0x000103B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B4,
        0x000103B4,
        0x000103B4
    };

    static _CharacterInfo _character000103B5 =
    {
        0x000103B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B5,
        0x000103B5,
        0x000103B5
    };

    static _CharacterInfo _character000103B6 =
    {
        0x000103B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B6,
        0x000103B6,
        0x000103B6
    };

    static _CharacterInfo _character000103B7 =
    {
        0x000103B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B7,
        0x000103B7,
        0x000103B7
    };

    static _CharacterInfo _character000103B8 =
    {
        0x000103B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B8,
        0x000103B8,
        0x000103B8
    };

    static _CharacterInfo _character000103B9 =
    {
        0x000103B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103B9,
        0x000103B9,
        0x000103B9
    };

    static _CharacterInfo _character000103BA =
    {
        0x000103BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BA,
        0x000103BA,
        0x000103BA
    };

    static _CharacterInfo _character000103BB =
    {
        0x000103BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BB,
        0x000103BB,
        0x000103BB
    };

    static _CharacterInfo _character000103BC =
    {
        0x000103BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BC,
        0x000103BC,
        0x000103BC
    };

    static _CharacterInfo _character000103BD =
    {
        0x000103BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BD,
        0x000103BD,
        0x000103BD
    };

    static _CharacterInfo _character000103BE =
    {
        0x000103BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BE,
        0x000103BE,
        0x000103BE
    };

    static _CharacterInfo _character000103BF =
    {
        0x000103BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103BF,
        0x000103BF,
        0x000103BF
    };

    static _CharacterInfo _character000103C0 =
    {
        0x000103C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C0,
        0x000103C0,
        0x000103C0
    };

    static _CharacterInfo _character000103C1 =
    {
        0x000103C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C1,
        0x000103C1,
        0x000103C1
    };

    static _CharacterInfo _character000103C2 =
    {
        0x000103C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C2,
        0x000103C2,
        0x000103C2
    };

    static _CharacterInfo _character000103C3 =
    {
        0x000103C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C3,
        0x000103C3,
        0x000103C3
    };

    static _CharacterInfo _character000103C8 =
    {
        0x000103C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C8,
        0x000103C8,
        0x000103C8
    };

    static _CharacterInfo _character000103C9 =
    {
        0x000103C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103C9,
        0x000103C9,
        0x000103C9
    };

    static _CharacterInfo _character000103CA =
    {
        0x000103CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CA,
        0x000103CA,
        0x000103CA
    };

    static _CharacterInfo _character000103CB =
    {
        0x000103CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CB,
        0x000103CB,
        0x000103CB
    };

    static _CharacterInfo _character000103CC =
    {
        0x000103CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CC,
        0x000103CC,
        0x000103CC
    };

    static _CharacterInfo _character000103CD =
    {
        0x000103CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CD,
        0x000103CD,
        0x000103CD
    };

    static _CharacterInfo _character000103CE =
    {
        0x000103CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CE,
        0x000103CE,
        0x000103CE
    };

    static _CharacterInfo _character000103CF =
    {
        0x000103CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103CF,
        0x000103CF,
        0x000103CF
    };

    static _CharacterInfo _character000103D0 =
    {
        0x000103D0,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000103D0,
        0x000103D0,
        0x000103D0
    };

    static _CharacterInfo _character000103D1 =
    {
        0x000103D1,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x000103D1,
        0x000103D1,
        0x000103D1
    };

    static _CharacterInfo _character000103D2 =
    {
        0x000103D2,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x000103D2,
        0x000103D2,
        0x000103D2
    };

    static _CharacterInfo _character000103D3 =
    {
        0x000103D3,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x000103D3,
        0x000103D3,
        0x000103D3
    };

    static _CharacterInfo _character000103D4 =
    {
        0x000103D4,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x000103D4,
        0x000103D4,
        0x000103D4
    };

    static _CharacterInfo _character000103D5 =
    {
        0x000103D5,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x000103D5,
        0x000103D5,
        0x000103D5
    };

    static _CharacterInfo _character00010400 =
    {
        0x00010400,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010400,
        0x00010428,
        0x00010400
    };

    static _CharacterInfo _character00010401 =
    {
        0x00010401,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010401,
        0x00010429,
        0x00010401
    };

    static _CharacterInfo _character00010402 =
    {
        0x00010402,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010402,
        0x0001042A,
        0x00010402
    };

    static _CharacterInfo _character00010403 =
    {
        0x00010403,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010403,
        0x0001042B,
        0x00010403
    };

    static _CharacterInfo _character00010404 =
    {
        0x00010404,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010404,
        0x0001042C,
        0x00010404
    };

    static _CharacterInfo _character00010405 =
    {
        0x00010405,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010405,
        0x0001042D,
        0x00010405
    };

    static _CharacterInfo _character00010406 =
    {
        0x00010406,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010406,
        0x0001042E,
        0x00010406
    };

    static _CharacterInfo _character00010407 =
    {
        0x00010407,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010407,
        0x0001042F,
        0x00010407
    };

    static _CharacterInfo _character00010408 =
    {
        0x00010408,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010408,
        0x00010430,
        0x00010408
    };

    static _CharacterInfo _character00010409 =
    {
        0x00010409,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010409,
        0x00010431,
        0x00010409
    };

    static _CharacterInfo _character0001040A =
    {
        0x0001040A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040A,
        0x00010432,
        0x0001040A
    };

    static _CharacterInfo _character0001040B =
    {
        0x0001040B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040B,
        0x00010433,
        0x0001040B
    };

    static _CharacterInfo _character0001040C =
    {
        0x0001040C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040C,
        0x00010434,
        0x0001040C
    };

    static _CharacterInfo _character0001040D =
    {
        0x0001040D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040D,
        0x00010435,
        0x0001040D
    };

    static _CharacterInfo _character0001040E =
    {
        0x0001040E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040E,
        0x00010436,
        0x0001040E
    };

    static _CharacterInfo _character0001040F =
    {
        0x0001040F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040F,
        0x00010437,
        0x0001040F
    };

    static _CharacterInfo _character00010410 =
    {
        0x00010410,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010410,
        0x00010438,
        0x00010410
    };

    static _CharacterInfo _character00010411 =
    {
        0x00010411,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010411,
        0x00010439,
        0x00010411
    };

    static _CharacterInfo _character00010412 =
    {
        0x00010412,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010412,
        0x0001043A,
        0x00010412
    };

    static _CharacterInfo _character00010413 =
    {
        0x00010413,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010413,
        0x0001043B,
        0x00010413
    };

    static _CharacterInfo _character00010414 =
    {
        0x00010414,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010414,
        0x0001043C,
        0x00010414
    };

    static _CharacterInfo _character00010415 =
    {
        0x00010415,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010415,
        0x0001043D,
        0x00010415
    };

    static _CharacterInfo _character00010416 =
    {
        0x00010416,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010416,
        0x0001043E,
        0x00010416
    };

    static _CharacterInfo _character00010417 =
    {
        0x00010417,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010417,
        0x0001043F,
        0x00010417
    };

    static _CharacterInfo _character00010418 =
    {
        0x00010418,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010418,
        0x00010440,
        0x00010418
    };

    static _CharacterInfo _character00010419 =
    {
        0x00010419,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010419,
        0x00010441,
        0x00010419
    };

    static _CharacterInfo _character0001041A =
    {
        0x0001041A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041A,
        0x00010442,
        0x0001041A
    };

    static _CharacterInfo _character0001041B =
    {
        0x0001041B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041B,
        0x00010443,
        0x0001041B
    };

    static _CharacterInfo _character0001041C =
    {
        0x0001041C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041C,
        0x00010444,
        0x0001041C
    };

    static _CharacterInfo _character0001041D =
    {
        0x0001041D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041D,
        0x00010445,
        0x0001041D
    };

    static _CharacterInfo _character0001041E =
    {
        0x0001041E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041E,
        0x00010446,
        0x0001041E
    };

    static _CharacterInfo _character0001041F =
    {
        0x0001041F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041F,
        0x00010447,
        0x0001041F
    };

    static _CharacterInfo _character00010420 =
    {
        0x00010420,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010420,
        0x00010448,
        0x00010420
    };

    static _CharacterInfo _character00010421 =
    {
        0x00010421,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010421,
        0x00010449,
        0x00010421
    };

    static _CharacterInfo _character00010422 =
    {
        0x00010422,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010422,
        0x0001044A,
        0x00010422
    };

    static _CharacterInfo _character00010423 =
    {
        0x00010423,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010423,
        0x0001044B,
        0x00010423
    };

    static _CharacterInfo _character00010424 =
    {
        0x00010424,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010424,
        0x0001044C,
        0x00010424
    };

    static _CharacterInfo _character00010425 =
    {
        0x00010425,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010425,
        0x0001044D,
        0x00010425
    };

    static _CharacterInfo _character00010426 =
    {
        0x00010426,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010426,
        0x0001044E,
        0x00010426
    };

    static _CharacterInfo _character00010427 =
    {
        0x00010427,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010427,
        0x0001044F,
        0x00010427
    };

    static _CharacterInfo _character00010428 =
    {
        0x00010428,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010400,
        0x00010428,
        0x00010400
    };

    static _CharacterInfo _character00010429 =
    {
        0x00010429,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010401,
        0x00010429,
        0x00010401
    };

    static _CharacterInfo _character0001042A =
    {
        0x0001042A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010402,
        0x0001042A,
        0x00010402
    };

    static _CharacterInfo _character0001042B =
    {
        0x0001042B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010403,
        0x0001042B,
        0x00010403
    };

    static _CharacterInfo _character0001042C =
    {
        0x0001042C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010404,
        0x0001042C,
        0x00010404
    };

    static _CharacterInfo _character0001042D =
    {
        0x0001042D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010405,
        0x0001042D,
        0x00010405
    };

    static _CharacterInfo _character0001042E =
    {
        0x0001042E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010406,
        0x0001042E,
        0x00010406
    };

    static _CharacterInfo _character0001042F =
    {
        0x0001042F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010407,
        0x0001042F,
        0x00010407
    };

    static _CharacterInfo _character00010430 =
    {
        0x00010430,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010408,
        0x00010430,
        0x00010408
    };

    static _CharacterInfo _character00010431 =
    {
        0x00010431,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010409,
        0x00010431,
        0x00010409
    };

    static _CharacterInfo _character00010432 =
    {
        0x00010432,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040A,
        0x00010432,
        0x0001040A
    };

    static _CharacterInfo _character00010433 =
    {
        0x00010433,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040B,
        0x00010433,
        0x0001040B
    };

    static _CharacterInfo _character00010434 =
    {
        0x00010434,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040C,
        0x00010434,
        0x0001040C
    };

    static _CharacterInfo _character00010435 =
    {
        0x00010435,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040D,
        0x00010435,
        0x0001040D
    };

    static _CharacterInfo _character00010436 =
    {
        0x00010436,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040E,
        0x00010436,
        0x0001040E
    };

    static _CharacterInfo _character00010437 =
    {
        0x00010437,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001040F,
        0x00010437,
        0x0001040F
    };

    static _CharacterInfo _character00010438 =
    {
        0x00010438,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010410,
        0x00010438,
        0x00010410
    };

    static _CharacterInfo _character00010439 =
    {
        0x00010439,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010411,
        0x00010439,
        0x00010411
    };

    static _CharacterInfo _character0001043A =
    {
        0x0001043A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010412,
        0x0001043A,
        0x00010412
    };

    static _CharacterInfo _character0001043B =
    {
        0x0001043B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010413,
        0x0001043B,
        0x00010413
    };

    static _CharacterInfo _character0001043C =
    {
        0x0001043C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010414,
        0x0001043C,
        0x00010414
    };

    static _CharacterInfo _character0001043D =
    {
        0x0001043D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010415,
        0x0001043D,
        0x00010415
    };

    static _CharacterInfo _character0001043E =
    {
        0x0001043E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010416,
        0x0001043E,
        0x00010416
    };

    static _CharacterInfo _character0001043F =
    {
        0x0001043F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010417,
        0x0001043F,
        0x00010417
    };

    static _CharacterInfo _character00010440 =
    {
        0x00010440,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010418,
        0x00010440,
        0x00010418
    };

    static _CharacterInfo _character00010441 =
    {
        0x00010441,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010419,
        0x00010441,
        0x00010419
    };

    static _CharacterInfo _character00010442 =
    {
        0x00010442,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041A,
        0x00010442,
        0x0001041A
    };

    static _CharacterInfo _character00010443 =
    {
        0x00010443,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041B,
        0x00010443,
        0x0001041B
    };

    static _CharacterInfo _character00010444 =
    {
        0x00010444,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041C,
        0x00010444,
        0x0001041C
    };

    static _CharacterInfo _character00010445 =
    {
        0x00010445,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041D,
        0x00010445,
        0x0001041D
    };

    static _CharacterInfo _character00010446 =
    {
        0x00010446,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041E,
        0x00010446,
        0x0001041E
    };

    static _CharacterInfo _character00010447 =
    {
        0x00010447,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001041F,
        0x00010447,
        0x0001041F
    };

    static _CharacterInfo _character00010448 =
    {
        0x00010448,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010420,
        0x00010448,
        0x00010420
    };

    static _CharacterInfo _character00010449 =
    {
        0x00010449,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010421,
        0x00010449,
        0x00010421
    };

    static _CharacterInfo _character0001044A =
    {
        0x0001044A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010422,
        0x0001044A,
        0x00010422
    };

    static _CharacterInfo _character0001044B =
    {
        0x0001044B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010423,
        0x0001044B,
        0x00010423
    };

    static _CharacterInfo _character0001044C =
    {
        0x0001044C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010424,
        0x0001044C,
        0x00010424
    };

    static _CharacterInfo _character0001044D =
    {
        0x0001044D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010425,
        0x0001044D,
        0x00010425
    };

    static _CharacterInfo _character0001044E =
    {
        0x0001044E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010426,
        0x0001044E,
        0x00010426
    };

    static _CharacterInfo _character0001044F =
    {
        0x0001044F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010427,
        0x0001044F,
        0x00010427
    };

    static _CharacterInfo _character00010450 =
    {
        0x00010450,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010450,
        0x00010450,
        0x00010450
    };

    static _CharacterInfo _character00010451 =
    {
        0x00010451,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010451,
        0x00010451,
        0x00010451
    };

    static _CharacterInfo _character00010452 =
    {
        0x00010452,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010452,
        0x00010452,
        0x00010452
    };

    static _CharacterInfo _character00010453 =
    {
        0x00010453,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010453,
        0x00010453,
        0x00010453
    };

    static _CharacterInfo _character00010454 =
    {
        0x00010454,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010454,
        0x00010454,
        0x00010454
    };

    static _CharacterInfo _character00010455 =
    {
        0x00010455,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010455,
        0x00010455,
        0x00010455
    };

    static _CharacterInfo _character00010456 =
    {
        0x00010456,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010456,
        0x00010456,
        0x00010456
    };

    static _CharacterInfo _character00010457 =
    {
        0x00010457,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010457,
        0x00010457,
        0x00010457
    };

    static _CharacterInfo _character00010458 =
    {
        0x00010458,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010458,
        0x00010458,
        0x00010458
    };

    static _CharacterInfo _character00010459 =
    {
        0x00010459,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010459,
        0x00010459,
        0x00010459
    };

    static _CharacterInfo _character0001045A =
    {
        0x0001045A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045A,
        0x0001045A,
        0x0001045A
    };

    static _CharacterInfo _character0001045B =
    {
        0x0001045B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045B,
        0x0001045B,
        0x0001045B
    };

    static _CharacterInfo _character0001045C =
    {
        0x0001045C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045C,
        0x0001045C,
        0x0001045C
    };

    static _CharacterInfo _character0001045D =
    {
        0x0001045D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045D,
        0x0001045D,
        0x0001045D
    };

    static _CharacterInfo _character0001045E =
    {
        0x0001045E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045E,
        0x0001045E,
        0x0001045E
    };

    static _CharacterInfo _character0001045F =
    {
        0x0001045F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001045F,
        0x0001045F,
        0x0001045F
    };

    static _CharacterInfo _character00010460 =
    {
        0x00010460,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010460,
        0x00010460,
        0x00010460
    };

    static _CharacterInfo _character00010461 =
    {
        0x00010461,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010461,
        0x00010461,
        0x00010461
    };

    static _CharacterInfo _character00010462 =
    {
        0x00010462,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010462,
        0x00010462,
        0x00010462
    };

    static _CharacterInfo _character00010463 =
    {
        0x00010463,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010463,
        0x00010463,
        0x00010463
    };

    static _CharacterInfo _character00010464 =
    {
        0x00010464,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010464,
        0x00010464,
        0x00010464
    };

    static _CharacterInfo _character00010465 =
    {
        0x00010465,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010465,
        0x00010465,
        0x00010465
    };

    static _CharacterInfo _character00010466 =
    {
        0x00010466,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010466,
        0x00010466,
        0x00010466
    };

    static _CharacterInfo _character00010467 =
    {
        0x00010467,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010467,
        0x00010467,
        0x00010467
    };

    static _CharacterInfo _character00010468 =
    {
        0x00010468,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010468,
        0x00010468,
        0x00010468
    };

    static _CharacterInfo _character00010469 =
    {
        0x00010469,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010469,
        0x00010469,
        0x00010469
    };

    static _CharacterInfo _character0001046A =
    {
        0x0001046A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046A,
        0x0001046A,
        0x0001046A
    };

    static _CharacterInfo _character0001046B =
    {
        0x0001046B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046B,
        0x0001046B,
        0x0001046B
    };

    static _CharacterInfo _character0001046C =
    {
        0x0001046C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046C,
        0x0001046C,
        0x0001046C
    };

    static _CharacterInfo _character0001046D =
    {
        0x0001046D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046D,
        0x0001046D,
        0x0001046D
    };

    static _CharacterInfo _character0001046E =
    {
        0x0001046E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046E,
        0x0001046E,
        0x0001046E
    };

    static _CharacterInfo _character0001046F =
    {
        0x0001046F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001046F,
        0x0001046F,
        0x0001046F
    };

    static _CharacterInfo _character00010470 =
    {
        0x00010470,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010470,
        0x00010470,
        0x00010470
    };

    static _CharacterInfo _character00010471 =
    {
        0x00010471,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010471,
        0x00010471,
        0x00010471
    };

    static _CharacterInfo _character00010472 =
    {
        0x00010472,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010472,
        0x00010472,
        0x00010472
    };

    static _CharacterInfo _character00010473 =
    {
        0x00010473,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010473,
        0x00010473,
        0x00010473
    };

    static _CharacterInfo _character00010474 =
    {
        0x00010474,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010474,
        0x00010474,
        0x00010474
    };

    static _CharacterInfo _character00010475 =
    {
        0x00010475,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010475,
        0x00010475,
        0x00010475
    };

    static _CharacterInfo _character00010476 =
    {
        0x00010476,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010476,
        0x00010476,
        0x00010476
    };

    static _CharacterInfo _character00010477 =
    {
        0x00010477,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010477,
        0x00010477,
        0x00010477
    };

    static _CharacterInfo _character00010478 =
    {
        0x00010478,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010478,
        0x00010478,
        0x00010478
    };

    static _CharacterInfo _character00010479 =
    {
        0x00010479,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010479,
        0x00010479,
        0x00010479
    };

    static _CharacterInfo _character0001047A =
    {
        0x0001047A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047A,
        0x0001047A,
        0x0001047A
    };

    static _CharacterInfo _character0001047B =
    {
        0x0001047B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047B,
        0x0001047B,
        0x0001047B
    };

    static _CharacterInfo _character0001047C =
    {
        0x0001047C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047C,
        0x0001047C,
        0x0001047C
    };

    static _CharacterInfo _character0001047D =
    {
        0x0001047D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047D,
        0x0001047D,
        0x0001047D
    };

    static _CharacterInfo _character0001047E =
    {
        0x0001047E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047E,
        0x0001047E,
        0x0001047E
    };

    static _CharacterInfo _character0001047F =
    {
        0x0001047F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001047F,
        0x0001047F,
        0x0001047F
    };

    static _CharacterInfo _character00010480 =
    {
        0x00010480,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010480,
        0x00010480,
        0x00010480
    };

    static _CharacterInfo _character00010481 =
    {
        0x00010481,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010481,
        0x00010481,
        0x00010481
    };

    static _CharacterInfo _character00010482 =
    {
        0x00010482,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010482,
        0x00010482,
        0x00010482
    };

    static _CharacterInfo _character00010483 =
    {
        0x00010483,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010483,
        0x00010483,
        0x00010483
    };

    static _CharacterInfo _character00010484 =
    {
        0x00010484,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010484,
        0x00010484,
        0x00010484
    };

    static _CharacterInfo _character00010485 =
    {
        0x00010485,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010485,
        0x00010485,
        0x00010485
    };

    static _CharacterInfo _character00010486 =
    {
        0x00010486,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010486,
        0x00010486,
        0x00010486
    };

    static _CharacterInfo _character00010487 =
    {
        0x00010487,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010487,
        0x00010487,
        0x00010487
    };

    static _CharacterInfo _character00010488 =
    {
        0x00010488,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010488,
        0x00010488,
        0x00010488
    };

    static _CharacterInfo _character00010489 =
    {
        0x00010489,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010489,
        0x00010489,
        0x00010489
    };

    static _CharacterInfo _character0001048A =
    {
        0x0001048A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048A,
        0x0001048A,
        0x0001048A
    };

    static _CharacterInfo _character0001048B =
    {
        0x0001048B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048B,
        0x0001048B,
        0x0001048B
    };

    static _CharacterInfo _character0001048C =
    {
        0x0001048C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048C,
        0x0001048C,
        0x0001048C
    };

    static _CharacterInfo _character0001048D =
    {
        0x0001048D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048D,
        0x0001048D,
        0x0001048D
    };

    static _CharacterInfo _character0001048E =
    {
        0x0001048E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048E,
        0x0001048E,
        0x0001048E
    };

    static _CharacterInfo _character0001048F =
    {
        0x0001048F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001048F,
        0x0001048F,
        0x0001048F
    };

    static _CharacterInfo _character00010490 =
    {
        0x00010490,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010490,
        0x00010490,
        0x00010490
    };

    static _CharacterInfo _character00010491 =
    {
        0x00010491,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010491,
        0x00010491,
        0x00010491
    };

    static _CharacterInfo _character00010492 =
    {
        0x00010492,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010492,
        0x00010492,
        0x00010492
    };

    static _CharacterInfo _character00010493 =
    {
        0x00010493,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010493,
        0x00010493,
        0x00010493
    };

    static _CharacterInfo _character00010494 =
    {
        0x00010494,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010494,
        0x00010494,
        0x00010494
    };

    static _CharacterInfo _character00010495 =
    {
        0x00010495,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010495,
        0x00010495,
        0x00010495
    };

    static _CharacterInfo _character00010496 =
    {
        0x00010496,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010496,
        0x00010496,
        0x00010496
    };

    static _CharacterInfo _character00010497 =
    {
        0x00010497,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010497,
        0x00010497,
        0x00010497
    };

    static _CharacterInfo _character00010498 =
    {
        0x00010498,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010498,
        0x00010498,
        0x00010498
    };

    static _CharacterInfo _character00010499 =
    {
        0x00010499,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010499,
        0x00010499,
        0x00010499
    };

    static _CharacterInfo _character0001049A =
    {
        0x0001049A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001049A,
        0x0001049A,
        0x0001049A
    };

    static _CharacterInfo _character0001049B =
    {
        0x0001049B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001049B,
        0x0001049B,
        0x0001049B
    };

    static _CharacterInfo _character0001049C =
    {
        0x0001049C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001049C,
        0x0001049C,
        0x0001049C
    };

    static _CharacterInfo _character0001049D =
    {
        0x0001049D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001049D,
        0x0001049D,
        0x0001049D
    };

    static _CharacterInfo _character000104A0 =
    {
        0x000104A0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x000104A0,
        0x000104A0,
        0x000104A0
    };

    static _CharacterInfo _character000104A1 =
    {
        0x000104A1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x000104A1,
        0x000104A1,
        0x000104A1
    };

    static _CharacterInfo _character000104A2 =
    {
        0x000104A2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x000104A2,
        0x000104A2,
        0x000104A2
    };

    static _CharacterInfo _character000104A3 =
    {
        0x000104A3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x000104A3,
        0x000104A3,
        0x000104A3
    };

    static _CharacterInfo _character000104A4 =
    {
        0x000104A4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x000104A4,
        0x000104A4,
        0x000104A4
    };

    static _CharacterInfo _character000104A5 =
    {
        0x000104A5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x000104A5,
        0x000104A5,
        0x000104A5
    };

    static _CharacterInfo _character000104A6 =
    {
        0x000104A6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x000104A6,
        0x000104A6,
        0x000104A6
    };

    static _CharacterInfo _character000104A7 =
    {
        0x000104A7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x000104A7,
        0x000104A7,
        0x000104A7
    };

    static _CharacterInfo _character000104A8 =
    {
        0x000104A8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x000104A8,
        0x000104A8,
        0x000104A8
    };

    static _CharacterInfo _character000104A9 =
    {
        0x000104A9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x000104A9,
        0x000104A9,
        0x000104A9
    };

    static _CharacterInfo _character00010800 =
    {
        0x00010800,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010800,
        0x00010800,
        0x00010800
    };

    static _CharacterInfo _character00010801 =
    {
        0x00010801,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010801,
        0x00010801,
        0x00010801
    };

    static _CharacterInfo _character00010802 =
    {
        0x00010802,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010802,
        0x00010802,
        0x00010802
    };

    static _CharacterInfo _character00010803 =
    {
        0x00010803,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010803,
        0x00010803,
        0x00010803
    };

    static _CharacterInfo _character00010804 =
    {
        0x00010804,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010804,
        0x00010804,
        0x00010804
    };

    static _CharacterInfo _character00010805 =
    {
        0x00010805,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010805,
        0x00010805,
        0x00010805
    };

    static _CharacterInfo _character00010808 =
    {
        0x00010808,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010808,
        0x00010808,
        0x00010808
    };

    static _CharacterInfo _character0001080A =
    {
        0x0001080A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080A,
        0x0001080A,
        0x0001080A
    };

    static _CharacterInfo _character0001080B =
    {
        0x0001080B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080B,
        0x0001080B,
        0x0001080B
    };

    static _CharacterInfo _character0001080C =
    {
        0x0001080C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080C,
        0x0001080C,
        0x0001080C
    };

    static _CharacterInfo _character0001080D =
    {
        0x0001080D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080D,
        0x0001080D,
        0x0001080D
    };

    static _CharacterInfo _character0001080E =
    {
        0x0001080E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080E,
        0x0001080E,
        0x0001080E
    };

    static _CharacterInfo _character0001080F =
    {
        0x0001080F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001080F,
        0x0001080F,
        0x0001080F
    };

    static _CharacterInfo _character00010810 =
    {
        0x00010810,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010810,
        0x00010810,
        0x00010810
    };

    static _CharacterInfo _character00010811 =
    {
        0x00010811,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010811,
        0x00010811,
        0x00010811
    };

    static _CharacterInfo _character00010812 =
    {
        0x00010812,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010812,
        0x00010812,
        0x00010812
    };

    static _CharacterInfo _character00010813 =
    {
        0x00010813,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010813,
        0x00010813,
        0x00010813
    };

    static _CharacterInfo _character00010814 =
    {
        0x00010814,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010814,
        0x00010814,
        0x00010814
    };

    static _CharacterInfo _character00010815 =
    {
        0x00010815,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010815,
        0x00010815,
        0x00010815
    };

    static _CharacterInfo _character00010816 =
    {
        0x00010816,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010816,
        0x00010816,
        0x00010816
    };

    static _CharacterInfo _character00010817 =
    {
        0x00010817,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010817,
        0x00010817,
        0x00010817
    };

    static _CharacterInfo _character00010818 =
    {
        0x00010818,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010818,
        0x00010818,
        0x00010818
    };

    static _CharacterInfo _character00010819 =
    {
        0x00010819,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010819,
        0x00010819,
        0x00010819
    };

    static _CharacterInfo _character0001081A =
    {
        0x0001081A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081A,
        0x0001081A,
        0x0001081A
    };

    static _CharacterInfo _character0001081B =
    {
        0x0001081B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081B,
        0x0001081B,
        0x0001081B
    };

    static _CharacterInfo _character0001081C =
    {
        0x0001081C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081C,
        0x0001081C,
        0x0001081C
    };

    static _CharacterInfo _character0001081D =
    {
        0x0001081D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081D,
        0x0001081D,
        0x0001081D
    };

    static _CharacterInfo _character0001081E =
    {
        0x0001081E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081E,
        0x0001081E,
        0x0001081E
    };

    static _CharacterInfo _character0001081F =
    {
        0x0001081F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001081F,
        0x0001081F,
        0x0001081F
    };

    static _CharacterInfo _character00010820 =
    {
        0x00010820,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010820,
        0x00010820,
        0x00010820
    };

    static _CharacterInfo _character00010821 =
    {
        0x00010821,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010821,
        0x00010821,
        0x00010821
    };

    static _CharacterInfo _character00010822 =
    {
        0x00010822,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010822,
        0x00010822,
        0x00010822
    };

    static _CharacterInfo _character00010823 =
    {
        0x00010823,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010823,
        0x00010823,
        0x00010823
    };

    static _CharacterInfo _character00010824 =
    {
        0x00010824,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010824,
        0x00010824,
        0x00010824
    };

    static _CharacterInfo _character00010825 =
    {
        0x00010825,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010825,
        0x00010825,
        0x00010825
    };

    static _CharacterInfo _character00010826 =
    {
        0x00010826,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010826,
        0x00010826,
        0x00010826
    };

    static _CharacterInfo _character00010827 =
    {
        0x00010827,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010827,
        0x00010827,
        0x00010827
    };

    static _CharacterInfo _character00010828 =
    {
        0x00010828,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010828,
        0x00010828,
        0x00010828
    };

    static _CharacterInfo _character00010829 =
    {
        0x00010829,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010829,
        0x00010829,
        0x00010829
    };

    static _CharacterInfo _character0001082A =
    {
        0x0001082A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082A,
        0x0001082A,
        0x0001082A
    };

    static _CharacterInfo _character0001082B =
    {
        0x0001082B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082B,
        0x0001082B,
        0x0001082B
    };

    static _CharacterInfo _character0001082C =
    {
        0x0001082C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082C,
        0x0001082C,
        0x0001082C
    };

    static _CharacterInfo _character0001082D =
    {
        0x0001082D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082D,
        0x0001082D,
        0x0001082D
    };

    static _CharacterInfo _character0001082E =
    {
        0x0001082E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082E,
        0x0001082E,
        0x0001082E
    };

    static _CharacterInfo _character0001082F =
    {
        0x0001082F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001082F,
        0x0001082F,
        0x0001082F
    };

    static _CharacterInfo _character00010830 =
    {
        0x00010830,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010830,
        0x00010830,
        0x00010830
    };

    static _CharacterInfo _character00010831 =
    {
        0x00010831,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010831,
        0x00010831,
        0x00010831
    };

    static _CharacterInfo _character00010832 =
    {
        0x00010832,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010832,
        0x00010832,
        0x00010832
    };

    static _CharacterInfo _character00010833 =
    {
        0x00010833,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010833,
        0x00010833,
        0x00010833
    };

    static _CharacterInfo _character00010834 =
    {
        0x00010834,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010834,
        0x00010834,
        0x00010834
    };

    static _CharacterInfo _character00010835 =
    {
        0x00010835,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010835,
        0x00010835,
        0x00010835
    };

    static _CharacterInfo _character00010837 =
    {
        0x00010837,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010837,
        0x00010837,
        0x00010837
    };

    static _CharacterInfo _character00010838 =
    {
        0x00010838,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010838,
        0x00010838,
        0x00010838
    };

    static _CharacterInfo _character0001083C =
    {
        0x0001083C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001083C,
        0x0001083C,
        0x0001083C
    };

    static _CharacterInfo _character0001083F =
    {
        0x0001083F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001083F,
        0x0001083F,
        0x0001083F
    };

    static _CharacterInfo _character00010900 =
    {
        0x00010900,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010900,
        0x00010900,
        0x00010900
    };

    static _CharacterInfo _character00010901 =
    {
        0x00010901,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010901,
        0x00010901,
        0x00010901
    };

    static _CharacterInfo _character00010902 =
    {
        0x00010902,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010902,
        0x00010902,
        0x00010902
    };

    static _CharacterInfo _character00010903 =
    {
        0x00010903,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010903,
        0x00010903,
        0x00010903
    };

    static _CharacterInfo _character00010904 =
    {
        0x00010904,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010904,
        0x00010904,
        0x00010904
    };

    static _CharacterInfo _character00010905 =
    {
        0x00010905,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010905,
        0x00010905,
        0x00010905
    };

    static _CharacterInfo _character00010906 =
    {
        0x00010906,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010906,
        0x00010906,
        0x00010906
    };

    static _CharacterInfo _character00010907 =
    {
        0x00010907,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010907,
        0x00010907,
        0x00010907
    };

    static _CharacterInfo _character00010908 =
    {
        0x00010908,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010908,
        0x00010908,
        0x00010908
    };

    static _CharacterInfo _character00010909 =
    {
        0x00010909,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010909,
        0x00010909,
        0x00010909
    };

    static _CharacterInfo _character0001090A =
    {
        0x0001090A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090A,
        0x0001090A,
        0x0001090A
    };

    static _CharacterInfo _character0001090B =
    {
        0x0001090B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090B,
        0x0001090B,
        0x0001090B
    };

    static _CharacterInfo _character0001090C =
    {
        0x0001090C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090C,
        0x0001090C,
        0x0001090C
    };

    static _CharacterInfo _character0001090D =
    {
        0x0001090D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090D,
        0x0001090D,
        0x0001090D
    };

    static _CharacterInfo _character0001090E =
    {
        0x0001090E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090E,
        0x0001090E,
        0x0001090E
    };

    static _CharacterInfo _character0001090F =
    {
        0x0001090F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001090F,
        0x0001090F,
        0x0001090F
    };

    static _CharacterInfo _character00010910 =
    {
        0x00010910,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010910,
        0x00010910,
        0x00010910
    };

    static _CharacterInfo _character00010911 =
    {
        0x00010911,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010911,
        0x00010911,
        0x00010911
    };

    static _CharacterInfo _character00010912 =
    {
        0x00010912,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010912,
        0x00010912,
        0x00010912
    };

    static _CharacterInfo _character00010913 =
    {
        0x00010913,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010913,
        0x00010913,
        0x00010913
    };

    static _CharacterInfo _character00010914 =
    {
        0x00010914,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010914,
        0x00010914,
        0x00010914
    };

    static _CharacterInfo _character00010915 =
    {
        0x00010915,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010915,
        0x00010915,
        0x00010915
    };

    static _CharacterInfo _character00010916 =
    {
        0x00010916,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00010916,
        0x00010916,
        0x00010916
    };

    static _CharacterInfo _character00010917 =
    {
        0x00010917,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010917,
        0x00010917,
        0x00010917
    };

    static _CharacterInfo _character00010918 =
    {
        0x00010918,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00010918,
        0x00010918,
        0x00010918
    };

    static _CharacterInfo _character00010919 =
    {
        0x00010919,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x00010919,
        0x00010919,
        0x00010919
    };

    static _CharacterInfo _character0001091F =
    {
        0x0001091F,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001091F,
        0x0001091F,
        0x0001091F
    };

    static _CharacterInfo _character00010A00 =
    {
        0x00010A00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A00,
        0x00010A00,
        0x00010A00
    };

    static _CharacterInfo _character00010A01 =
    {
        0x00010A01,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A01,
        0x00010A01,
        0x00010A01
    };

    static _CharacterInfo _character00010A02 =
    {
        0x00010A02,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A02,
        0x00010A02,
        0x00010A02
    };

    static _CharacterInfo _character00010A03 =
    {
        0x00010A03,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A03,
        0x00010A03,
        0x00010A03
    };

    static _CharacterInfo _character00010A05 =
    {
        0x00010A05,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A05,
        0x00010A05,
        0x00010A05
    };

    static _CharacterInfo _character00010A06 =
    {
        0x00010A06,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A06,
        0x00010A06,
        0x00010A06
    };

    static _CharacterInfo _character00010A0C =
    {
        0x00010A0C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A0C,
        0x00010A0C,
        0x00010A0C
    };

    static _CharacterInfo _character00010A0D =
    {
        0x00010A0D,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A0D,
        0x00010A0D,
        0x00010A0D
    };

    static _CharacterInfo _character00010A0E =
    {
        0x00010A0E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A0E,
        0x00010A0E,
        0x00010A0E
    };

    static _CharacterInfo _character00010A0F =
    {
        0x00010A0F,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A0F,
        0x00010A0F,
        0x00010A0F
    };

    static _CharacterInfo _character00010A10 =
    {
        0x00010A10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A10,
        0x00010A10,
        0x00010A10
    };

    static _CharacterInfo _character00010A11 =
    {
        0x00010A11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A11,
        0x00010A11,
        0x00010A11
    };

    static _CharacterInfo _character00010A12 =
    {
        0x00010A12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A12,
        0x00010A12,
        0x00010A12
    };

    static _CharacterInfo _character00010A13 =
    {
        0x00010A13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A13,
        0x00010A13,
        0x00010A13
    };

    static _CharacterInfo _character00010A15 =
    {
        0x00010A15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A15,
        0x00010A15,
        0x00010A15
    };

    static _CharacterInfo _character00010A16 =
    {
        0x00010A16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A16,
        0x00010A16,
        0x00010A16
    };

    static _CharacterInfo _character00010A17 =
    {
        0x00010A17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A17,
        0x00010A17,
        0x00010A17
    };

    static _CharacterInfo _character00010A19 =
    {
        0x00010A19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A19,
        0x00010A19,
        0x00010A19
    };

    static _CharacterInfo _character00010A1A =
    {
        0x00010A1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1A,
        0x00010A1A,
        0x00010A1A
    };

    static _CharacterInfo _character00010A1B =
    {
        0x00010A1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1B,
        0x00010A1B,
        0x00010A1B
    };

    static _CharacterInfo _character00010A1C =
    {
        0x00010A1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1C,
        0x00010A1C,
        0x00010A1C
    };

    static _CharacterInfo _character00010A1D =
    {
        0x00010A1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1D,
        0x00010A1D,
        0x00010A1D
    };

    static _CharacterInfo _character00010A1E =
    {
        0x00010A1E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1E,
        0x00010A1E,
        0x00010A1E
    };

    static _CharacterInfo _character00010A1F =
    {
        0x00010A1F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A1F,
        0x00010A1F,
        0x00010A1F
    };

    static _CharacterInfo _character00010A20 =
    {
        0x00010A20,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A20,
        0x00010A20,
        0x00010A20
    };

    static _CharacterInfo _character00010A21 =
    {
        0x00010A21,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A21,
        0x00010A21,
        0x00010A21
    };

    static _CharacterInfo _character00010A22 =
    {
        0x00010A22,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A22,
        0x00010A22,
        0x00010A22
    };

    static _CharacterInfo _character00010A23 =
    {
        0x00010A23,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A23,
        0x00010A23,
        0x00010A23
    };

    static _CharacterInfo _character00010A24 =
    {
        0x00010A24,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A24,
        0x00010A24,
        0x00010A24
    };

    static _CharacterInfo _character00010A25 =
    {
        0x00010A25,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A25,
        0x00010A25,
        0x00010A25
    };

    static _CharacterInfo _character00010A26 =
    {
        0x00010A26,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A26,
        0x00010A26,
        0x00010A26
    };

    static _CharacterInfo _character00010A27 =
    {
        0x00010A27,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A27,
        0x00010A27,
        0x00010A27
    };

    static _CharacterInfo _character00010A28 =
    {
        0x00010A28,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A28,
        0x00010A28,
        0x00010A28
    };

    static _CharacterInfo _character00010A29 =
    {
        0x00010A29,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A29,
        0x00010A29,
        0x00010A29
    };

    static _CharacterInfo _character00010A2A =
    {
        0x00010A2A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2A,
        0x00010A2A,
        0x00010A2A
    };

    static _CharacterInfo _character00010A2B =
    {
        0x00010A2B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2B,
        0x00010A2B,
        0x00010A2B
    };

    static _CharacterInfo _character00010A2C =
    {
        0x00010A2C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2C,
        0x00010A2C,
        0x00010A2C
    };

    static _CharacterInfo _character00010A2D =
    {
        0x00010A2D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2D,
        0x00010A2D,
        0x00010A2D
    };

    static _CharacterInfo _character00010A2E =
    {
        0x00010A2E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2E,
        0x00010A2E,
        0x00010A2E
    };

    static _CharacterInfo _character00010A2F =
    {
        0x00010A2F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A2F,
        0x00010A2F,
        0x00010A2F
    };

    static _CharacterInfo _character00010A30 =
    {
        0x00010A30,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A30,
        0x00010A30,
        0x00010A30
    };

    static _CharacterInfo _character00010A31 =
    {
        0x00010A31,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A31,
        0x00010A31,
        0x00010A31
    };

    static _CharacterInfo _character00010A32 =
    {
        0x00010A32,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A32,
        0x00010A32,
        0x00010A32
    };

    static _CharacterInfo _character00010A33 =
    {
        0x00010A33,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A33,
        0x00010A33,
        0x00010A33
    };

    static _CharacterInfo _character00010A38 =
    {
        0x00010A38,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A38,
        0x00010A38,
        0x00010A38
    };

    static _CharacterInfo _character00010A39 =
    {
        0x00010A39,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A39,
        0x00010A39,
        0x00010A39
    };

    static _CharacterInfo _character00010A3A =
    {
        0x00010A3A,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A3A,
        0x00010A3A,
        0x00010A3A
    };

    static _CharacterInfo _character00010A3F =
    {
        0x00010A3F,
        Iso10646::GeneralCategory_Mn,
        9,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A3F,
        0x00010A3F,
        0x00010A3F
    };

    static _CharacterInfo _character00010A40 =
    {
        0x00010A40,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        1,
        true,
        1,
        1,
        false,
        0x00010A40,
        0x00010A40,
        0x00010A40
    };

    static _CharacterInfo _character00010A41 =
    {
        0x00010A41,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        2,
        true,
        2,
        1,
        false,
        0x00010A41,
        0x00010A41,
        0x00010A41
    };

    static _CharacterInfo _character00010A42 =
    {
        0x00010A42,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        3,
        true,
        3,
        1,
        false,
        0x00010A42,
        0x00010A42,
        0x00010A42
    };

    static _CharacterInfo _character00010A43 =
    {
        0x00010A43,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        true,
        4,
        true,
        4,
        1,
        false,
        0x00010A43,
        0x00010A43,
        0x00010A43
    };

    static _CharacterInfo _character00010A44 =
    {
        0x00010A44,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x00010A44,
        0x00010A44,
        0x00010A44
    };

    static _CharacterInfo _character00010A45 =
    {
        0x00010A45,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x00010A45,
        0x00010A45,
        0x00010A45
    };

    static _CharacterInfo _character00010A46 =
    {
        0x00010A46,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        100,
        1,
        false,
        0x00010A46,
        0x00010A46,
        0x00010A46
    };

    static _CharacterInfo _character00010A47 =
    {
        0x00010A47,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1000,
        1,
        false,
        0x00010A47,
        0x00010A47,
        0x00010A47
    };

    static _CharacterInfo _character00010A50 =
    {
        0x00010A50,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A50,
        0x00010A50,
        0x00010A50
    };

    static _CharacterInfo _character00010A51 =
    {
        0x00010A51,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A51,
        0x00010A51,
        0x00010A51
    };

    static _CharacterInfo _character00010A52 =
    {
        0x00010A52,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A52,
        0x00010A52,
        0x00010A52
    };

    static _CharacterInfo _character00010A53 =
    {
        0x00010A53,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A53,
        0x00010A53,
        0x00010A53
    };

    static _CharacterInfo _character00010A54 =
    {
        0x00010A54,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A54,
        0x00010A54,
        0x00010A54
    };

    static _CharacterInfo _character00010A55 =
    {
        0x00010A55,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A55,
        0x00010A55,
        0x00010A55
    };

    static _CharacterInfo _character00010A56 =
    {
        0x00010A56,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A56,
        0x00010A56,
        0x00010A56
    };

    static _CharacterInfo _character00010A57 =
    {
        0x00010A57,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A57,
        0x00010A57,
        0x00010A57
    };

    static _CharacterInfo _character00010A58 =
    {
        0x00010A58,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_R,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00010A58,
        0x00010A58,
        0x00010A58
    };

    static _CharacterInfo _character00012000 =
    {
        0x00012000,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012000,
        0x00012000,
        0x00012000
    };

    static _CharacterInfo _character00012001 =
    {
        0x00012001,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012001,
        0x00012001,
        0x00012001
    };

    static _CharacterInfo _character00012002 =
    {
        0x00012002,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012002,
        0x00012002,
        0x00012002
    };

    static _CharacterInfo _character00012003 =
    {
        0x00012003,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012003,
        0x00012003,
        0x00012003
    };

    static _CharacterInfo _character00012004 =
    {
        0x00012004,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012004,
        0x00012004,
        0x00012004
    };

    static _CharacterInfo _character00012005 =
    {
        0x00012005,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012005,
        0x00012005,
        0x00012005
    };

    static _CharacterInfo _character00012006 =
    {
        0x00012006,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012006,
        0x00012006,
        0x00012006
    };

    static _CharacterInfo _character00012007 =
    {
        0x00012007,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012007,
        0x00012007,
        0x00012007
    };

    static _CharacterInfo _character00012008 =
    {
        0x00012008,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012008,
        0x00012008,
        0x00012008
    };

    static _CharacterInfo _character00012009 =
    {
        0x00012009,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012009,
        0x00012009,
        0x00012009
    };

    static _CharacterInfo _character0001200A =
    {
        0x0001200A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200A,
        0x0001200A,
        0x0001200A
    };

    static _CharacterInfo _character0001200B =
    {
        0x0001200B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200B,
        0x0001200B,
        0x0001200B
    };

    static _CharacterInfo _character0001200C =
    {
        0x0001200C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200C,
        0x0001200C,
        0x0001200C
    };

    static _CharacterInfo _character0001200D =
    {
        0x0001200D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200D,
        0x0001200D,
        0x0001200D
    };

    static _CharacterInfo _character0001200E =
    {
        0x0001200E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200E,
        0x0001200E,
        0x0001200E
    };

    static _CharacterInfo _character0001200F =
    {
        0x0001200F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001200F,
        0x0001200F,
        0x0001200F
    };

    static _CharacterInfo _character00012010 =
    {
        0x00012010,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012010,
        0x00012010,
        0x00012010
    };

    static _CharacterInfo _character00012011 =
    {
        0x00012011,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012011,
        0x00012011,
        0x00012011
    };

    static _CharacterInfo _character00012012 =
    {
        0x00012012,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012012,
        0x00012012,
        0x00012012
    };

    static _CharacterInfo _character00012013 =
    {
        0x00012013,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012013,
        0x00012013,
        0x00012013
    };

    static _CharacterInfo _character00012014 =
    {
        0x00012014,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012014,
        0x00012014,
        0x00012014
    };

    static _CharacterInfo _character00012015 =
    {
        0x00012015,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012015,
        0x00012015,
        0x00012015
    };

    static _CharacterInfo _character00012016 =
    {
        0x00012016,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012016,
        0x00012016,
        0x00012016
    };

    static _CharacterInfo _character00012017 =
    {
        0x00012017,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012017,
        0x00012017,
        0x00012017
    };

    static _CharacterInfo _character00012018 =
    {
        0x00012018,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012018,
        0x00012018,
        0x00012018
    };

    static _CharacterInfo _character00012019 =
    {
        0x00012019,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012019,
        0x00012019,
        0x00012019
    };

    static _CharacterInfo _character0001201A =
    {
        0x0001201A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201A,
        0x0001201A,
        0x0001201A
    };

    static _CharacterInfo _character0001201B =
    {
        0x0001201B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201B,
        0x0001201B,
        0x0001201B
    };

    static _CharacterInfo _character0001201C =
    {
        0x0001201C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201C,
        0x0001201C,
        0x0001201C
    };

    static _CharacterInfo _character0001201D =
    {
        0x0001201D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201D,
        0x0001201D,
        0x0001201D
    };

    static _CharacterInfo _character0001201E =
    {
        0x0001201E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201E,
        0x0001201E,
        0x0001201E
    };

    static _CharacterInfo _character0001201F =
    {
        0x0001201F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001201F,
        0x0001201F,
        0x0001201F
    };

    static _CharacterInfo _character00012020 =
    {
        0x00012020,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012020,
        0x00012020,
        0x00012020
    };

    static _CharacterInfo _character00012021 =
    {
        0x00012021,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012021,
        0x00012021,
        0x00012021
    };

    static _CharacterInfo _character00012022 =
    {
        0x00012022,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012022,
        0x00012022,
        0x00012022
    };

    static _CharacterInfo _character00012023 =
    {
        0x00012023,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012023,
        0x00012023,
        0x00012023
    };

    static _CharacterInfo _character00012024 =
    {
        0x00012024,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012024,
        0x00012024,
        0x00012024
    };

    static _CharacterInfo _character00012025 =
    {
        0x00012025,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012025,
        0x00012025,
        0x00012025
    };

    static _CharacterInfo _character00012026 =
    {
        0x00012026,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012026,
        0x00012026,
        0x00012026
    };

    static _CharacterInfo _character00012027 =
    {
        0x00012027,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012027,
        0x00012027,
        0x00012027
    };

    static _CharacterInfo _character00012028 =
    {
        0x00012028,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012028,
        0x00012028,
        0x00012028
    };

    static _CharacterInfo _character00012029 =
    {
        0x00012029,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012029,
        0x00012029,
        0x00012029
    };

    static _CharacterInfo _character0001202A =
    {
        0x0001202A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202A,
        0x0001202A,
        0x0001202A
    };

    static _CharacterInfo _character0001202B =
    {
        0x0001202B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202B,
        0x0001202B,
        0x0001202B
    };

    static _CharacterInfo _character0001202C =
    {
        0x0001202C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202C,
        0x0001202C,
        0x0001202C
    };

    static _CharacterInfo _character0001202D =
    {
        0x0001202D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202D,
        0x0001202D,
        0x0001202D
    };

    static _CharacterInfo _character0001202E =
    {
        0x0001202E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202E,
        0x0001202E,
        0x0001202E
    };

    static _CharacterInfo _character0001202F =
    {
        0x0001202F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001202F,
        0x0001202F,
        0x0001202F
    };

    static _CharacterInfo _character00012030 =
    {
        0x00012030,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012030,
        0x00012030,
        0x00012030
    };

    static _CharacterInfo _character00012031 =
    {
        0x00012031,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012031,
        0x00012031,
        0x00012031
    };

    static _CharacterInfo _character00012032 =
    {
        0x00012032,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012032,
        0x00012032,
        0x00012032
    };

    static _CharacterInfo _character00012033 =
    {
        0x00012033,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012033,
        0x00012033,
        0x00012033
    };

    static _CharacterInfo _character00012034 =
    {
        0x00012034,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012034,
        0x00012034,
        0x00012034
    };

    static _CharacterInfo _character00012035 =
    {
        0x00012035,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012035,
        0x00012035,
        0x00012035
    };

    static _CharacterInfo _character00012036 =
    {
        0x00012036,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012036,
        0x00012036,
        0x00012036
    };

    static _CharacterInfo _character00012037 =
    {
        0x00012037,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012037,
        0x00012037,
        0x00012037
    };

    static _CharacterInfo _character00012038 =
    {
        0x00012038,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012038,
        0x00012038,
        0x00012038
    };

    static _CharacterInfo _character00012039 =
    {
        0x00012039,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012039,
        0x00012039,
        0x00012039
    };

    static _CharacterInfo _character0001203A =
    {
        0x0001203A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203A,
        0x0001203A,
        0x0001203A
    };

    static _CharacterInfo _character0001203B =
    {
        0x0001203B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203B,
        0x0001203B,
        0x0001203B
    };

    static _CharacterInfo _character0001203C =
    {
        0x0001203C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203C,
        0x0001203C,
        0x0001203C
    };

    static _CharacterInfo _character0001203D =
    {
        0x0001203D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203D,
        0x0001203D,
        0x0001203D
    };

    static _CharacterInfo _character0001203E =
    {
        0x0001203E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203E,
        0x0001203E,
        0x0001203E
    };

    static _CharacterInfo _character0001203F =
    {
        0x0001203F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001203F,
        0x0001203F,
        0x0001203F
    };

    static _CharacterInfo _character00012040 =
    {
        0x00012040,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012040,
        0x00012040,
        0x00012040
    };

    static _CharacterInfo _character00012041 =
    {
        0x00012041,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012041,
        0x00012041,
        0x00012041
    };

    static _CharacterInfo _character00012042 =
    {
        0x00012042,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012042,
        0x00012042,
        0x00012042
    };

    static _CharacterInfo _character00012043 =
    {
        0x00012043,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012043,
        0x00012043,
        0x00012043
    };

    static _CharacterInfo _character00012044 =
    {
        0x00012044,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012044,
        0x00012044,
        0x00012044
    };

    static _CharacterInfo _character00012045 =
    {
        0x00012045,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012045,
        0x00012045,
        0x00012045
    };

    static _CharacterInfo _character00012046 =
    {
        0x00012046,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012046,
        0x00012046,
        0x00012046
    };

    static _CharacterInfo _character00012047 =
    {
        0x00012047,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012047,
        0x00012047,
        0x00012047
    };

    static _CharacterInfo _character00012048 =
    {
        0x00012048,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012048,
        0x00012048,
        0x00012048
    };

    static _CharacterInfo _character00012049 =
    {
        0x00012049,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012049,
        0x00012049,
        0x00012049
    };

    static _CharacterInfo _character0001204A =
    {
        0x0001204A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204A,
        0x0001204A,
        0x0001204A
    };

    static _CharacterInfo _character0001204B =
    {
        0x0001204B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204B,
        0x0001204B,
        0x0001204B
    };

    static _CharacterInfo _character0001204C =
    {
        0x0001204C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204C,
        0x0001204C,
        0x0001204C
    };

    static _CharacterInfo _character0001204D =
    {
        0x0001204D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204D,
        0x0001204D,
        0x0001204D
    };

    static _CharacterInfo _character0001204E =
    {
        0x0001204E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204E,
        0x0001204E,
        0x0001204E
    };

    static _CharacterInfo _character0001204F =
    {
        0x0001204F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001204F,
        0x0001204F,
        0x0001204F
    };

    static _CharacterInfo _character00012050 =
    {
        0x00012050,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012050,
        0x00012050,
        0x00012050
    };

    static _CharacterInfo _character00012051 =
    {
        0x00012051,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012051,
        0x00012051,
        0x00012051
    };

    static _CharacterInfo _character00012052 =
    {
        0x00012052,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012052,
        0x00012052,
        0x00012052
    };

    static _CharacterInfo _character00012053 =
    {
        0x00012053,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012053,
        0x00012053,
        0x00012053
    };

    static _CharacterInfo _character00012054 =
    {
        0x00012054,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012054,
        0x00012054,
        0x00012054
    };

    static _CharacterInfo _character00012055 =
    {
        0x00012055,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012055,
        0x00012055,
        0x00012055
    };

    static _CharacterInfo _character00012056 =
    {
        0x00012056,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012056,
        0x00012056,
        0x00012056
    };

    static _CharacterInfo _character00012057 =
    {
        0x00012057,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012057,
        0x00012057,
        0x00012057
    };

    static _CharacterInfo _character00012058 =
    {
        0x00012058,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012058,
        0x00012058,
        0x00012058
    };

    static _CharacterInfo _character00012059 =
    {
        0x00012059,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012059,
        0x00012059,
        0x00012059
    };

    static _CharacterInfo _character0001205A =
    {
        0x0001205A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205A,
        0x0001205A,
        0x0001205A
    };

    static _CharacterInfo _character0001205B =
    {
        0x0001205B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205B,
        0x0001205B,
        0x0001205B
    };

    static _CharacterInfo _character0001205C =
    {
        0x0001205C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205C,
        0x0001205C,
        0x0001205C
    };

    static _CharacterInfo _character0001205D =
    {
        0x0001205D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205D,
        0x0001205D,
        0x0001205D
    };

    static _CharacterInfo _character0001205E =
    {
        0x0001205E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205E,
        0x0001205E,
        0x0001205E
    };

    static _CharacterInfo _character0001205F =
    {
        0x0001205F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001205F,
        0x0001205F,
        0x0001205F
    };

    static _CharacterInfo _character00012060 =
    {
        0x00012060,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012060,
        0x00012060,
        0x00012060
    };

    static _CharacterInfo _character00012061 =
    {
        0x00012061,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012061,
        0x00012061,
        0x00012061
    };

    static _CharacterInfo _character00012062 =
    {
        0x00012062,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012062,
        0x00012062,
        0x00012062
    };

    static _CharacterInfo _character00012063 =
    {
        0x00012063,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012063,
        0x00012063,
        0x00012063
    };

    static _CharacterInfo _character00012064 =
    {
        0x00012064,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012064,
        0x00012064,
        0x00012064
    };

    static _CharacterInfo _character00012065 =
    {
        0x00012065,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012065,
        0x00012065,
        0x00012065
    };

    static _CharacterInfo _character00012066 =
    {
        0x00012066,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012066,
        0x00012066,
        0x00012066
    };

    static _CharacterInfo _character00012067 =
    {
        0x00012067,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012067,
        0x00012067,
        0x00012067
    };

    static _CharacterInfo _character00012068 =
    {
        0x00012068,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012068,
        0x00012068,
        0x00012068
    };

    static _CharacterInfo _character00012069 =
    {
        0x00012069,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012069,
        0x00012069,
        0x00012069
    };

    static _CharacterInfo _character0001206A =
    {
        0x0001206A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206A,
        0x0001206A,
        0x0001206A
    };

    static _CharacterInfo _character0001206B =
    {
        0x0001206B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206B,
        0x0001206B,
        0x0001206B
    };

    static _CharacterInfo _character0001206C =
    {
        0x0001206C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206C,
        0x0001206C,
        0x0001206C
    };

    static _CharacterInfo _character0001206D =
    {
        0x0001206D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206D,
        0x0001206D,
        0x0001206D
    };

    static _CharacterInfo _character0001206E =
    {
        0x0001206E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206E,
        0x0001206E,
        0x0001206E
    };

    static _CharacterInfo _character0001206F =
    {
        0x0001206F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001206F,
        0x0001206F,
        0x0001206F
    };

    static _CharacterInfo _character00012070 =
    {
        0x00012070,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012070,
        0x00012070,
        0x00012070
    };

    static _CharacterInfo _character00012071 =
    {
        0x00012071,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012071,
        0x00012071,
        0x00012071
    };

    static _CharacterInfo _character00012072 =
    {
        0x00012072,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012072,
        0x00012072,
        0x00012072
    };

    static _CharacterInfo _character00012073 =
    {
        0x00012073,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012073,
        0x00012073,
        0x00012073
    };

    static _CharacterInfo _character00012074 =
    {
        0x00012074,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012074,
        0x00012074,
        0x00012074
    };

    static _CharacterInfo _character00012075 =
    {
        0x00012075,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012075,
        0x00012075,
        0x00012075
    };

    static _CharacterInfo _character00012076 =
    {
        0x00012076,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012076,
        0x00012076,
        0x00012076
    };

    static _CharacterInfo _character00012077 =
    {
        0x00012077,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012077,
        0x00012077,
        0x00012077
    };

    static _CharacterInfo _character00012078 =
    {
        0x00012078,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012078,
        0x00012078,
        0x00012078
    };

    static _CharacterInfo _character00012079 =
    {
        0x00012079,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012079,
        0x00012079,
        0x00012079
    };

    static _CharacterInfo _character0001207A =
    {
        0x0001207A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207A,
        0x0001207A,
        0x0001207A
    };

    static _CharacterInfo _character0001207B =
    {
        0x0001207B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207B,
        0x0001207B,
        0x0001207B
    };

    static _CharacterInfo _character0001207C =
    {
        0x0001207C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207C,
        0x0001207C,
        0x0001207C
    };

    static _CharacterInfo _character0001207D =
    {
        0x0001207D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207D,
        0x0001207D,
        0x0001207D
    };

    static _CharacterInfo _character0001207E =
    {
        0x0001207E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207E,
        0x0001207E,
        0x0001207E
    };

    static _CharacterInfo _character0001207F =
    {
        0x0001207F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001207F,
        0x0001207F,
        0x0001207F
    };

    static _CharacterInfo _character00012080 =
    {
        0x00012080,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012080,
        0x00012080,
        0x00012080
    };

    static _CharacterInfo _character00012081 =
    {
        0x00012081,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012081,
        0x00012081,
        0x00012081
    };

    static _CharacterInfo _character00012082 =
    {
        0x00012082,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012082,
        0x00012082,
        0x00012082
    };

    static _CharacterInfo _character00012083 =
    {
        0x00012083,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012083,
        0x00012083,
        0x00012083
    };

    static _CharacterInfo _character00012084 =
    {
        0x00012084,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012084,
        0x00012084,
        0x00012084
    };

    static _CharacterInfo _character00012085 =
    {
        0x00012085,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012085,
        0x00012085,
        0x00012085
    };

    static _CharacterInfo _character00012086 =
    {
        0x00012086,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012086,
        0x00012086,
        0x00012086
    };

    static _CharacterInfo _character00012087 =
    {
        0x00012087,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012087,
        0x00012087,
        0x00012087
    };

    static _CharacterInfo _character00012088 =
    {
        0x00012088,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012088,
        0x00012088,
        0x00012088
    };

    static _CharacterInfo _character00012089 =
    {
        0x00012089,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012089,
        0x00012089,
        0x00012089
    };

    static _CharacterInfo _character0001208A =
    {
        0x0001208A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208A,
        0x0001208A,
        0x0001208A
    };

    static _CharacterInfo _character0001208B =
    {
        0x0001208B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208B,
        0x0001208B,
        0x0001208B
    };

    static _CharacterInfo _character0001208C =
    {
        0x0001208C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208C,
        0x0001208C,
        0x0001208C
    };

    static _CharacterInfo _character0001208D =
    {
        0x0001208D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208D,
        0x0001208D,
        0x0001208D
    };

    static _CharacterInfo _character0001208E =
    {
        0x0001208E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208E,
        0x0001208E,
        0x0001208E
    };

    static _CharacterInfo _character0001208F =
    {
        0x0001208F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001208F,
        0x0001208F,
        0x0001208F
    };

    static _CharacterInfo _character00012090 =
    {
        0x00012090,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012090,
        0x00012090,
        0x00012090
    };

    static _CharacterInfo _character00012091 =
    {
        0x00012091,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012091,
        0x00012091,
        0x00012091
    };

    static _CharacterInfo _character00012092 =
    {
        0x00012092,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012092,
        0x00012092,
        0x00012092
    };

    static _CharacterInfo _character00012093 =
    {
        0x00012093,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012093,
        0x00012093,
        0x00012093
    };

    static _CharacterInfo _character00012094 =
    {
        0x00012094,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012094,
        0x00012094,
        0x00012094
    };

    static _CharacterInfo _character00012095 =
    {
        0x00012095,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012095,
        0x00012095,
        0x00012095
    };

    static _CharacterInfo _character00012096 =
    {
        0x00012096,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012096,
        0x00012096,
        0x00012096
    };

    static _CharacterInfo _character00012097 =
    {
        0x00012097,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012097,
        0x00012097,
        0x00012097
    };

    static _CharacterInfo _character00012098 =
    {
        0x00012098,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012098,
        0x00012098,
        0x00012098
    };

    static _CharacterInfo _character00012099 =
    {
        0x00012099,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012099,
        0x00012099,
        0x00012099
    };

    static _CharacterInfo _character0001209A =
    {
        0x0001209A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209A,
        0x0001209A,
        0x0001209A
    };

    static _CharacterInfo _character0001209B =
    {
        0x0001209B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209B,
        0x0001209B,
        0x0001209B
    };

    static _CharacterInfo _character0001209C =
    {
        0x0001209C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209C,
        0x0001209C,
        0x0001209C
    };

    static _CharacterInfo _character0001209D =
    {
        0x0001209D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209D,
        0x0001209D,
        0x0001209D
    };

    static _CharacterInfo _character0001209E =
    {
        0x0001209E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209E,
        0x0001209E,
        0x0001209E
    };

    static _CharacterInfo _character0001209F =
    {
        0x0001209F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001209F,
        0x0001209F,
        0x0001209F
    };

    static _CharacterInfo _character000120A0 =
    {
        0x000120A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A0,
        0x000120A0,
        0x000120A0
    };

    static _CharacterInfo _character000120A1 =
    {
        0x000120A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A1,
        0x000120A1,
        0x000120A1
    };

    static _CharacterInfo _character000120A2 =
    {
        0x000120A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A2,
        0x000120A2,
        0x000120A2
    };

    static _CharacterInfo _character000120A3 =
    {
        0x000120A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A3,
        0x000120A3,
        0x000120A3
    };

    static _CharacterInfo _character000120A4 =
    {
        0x000120A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A4,
        0x000120A4,
        0x000120A4
    };

    static _CharacterInfo _character000120A5 =
    {
        0x000120A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A5,
        0x000120A5,
        0x000120A5
    };

    static _CharacterInfo _character000120A6 =
    {
        0x000120A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A6,
        0x000120A6,
        0x000120A6
    };

    static _CharacterInfo _character000120A7 =
    {
        0x000120A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A7,
        0x000120A7,
        0x000120A7
    };

    static _CharacterInfo _character000120A8 =
    {
        0x000120A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A8,
        0x000120A8,
        0x000120A8
    };

    static _CharacterInfo _character000120A9 =
    {
        0x000120A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120A9,
        0x000120A9,
        0x000120A9
    };

    static _CharacterInfo _character000120AA =
    {
        0x000120AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AA,
        0x000120AA,
        0x000120AA
    };

    static _CharacterInfo _character000120AB =
    {
        0x000120AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AB,
        0x000120AB,
        0x000120AB
    };

    static _CharacterInfo _character000120AC =
    {
        0x000120AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AC,
        0x000120AC,
        0x000120AC
    };

    static _CharacterInfo _character000120AD =
    {
        0x000120AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AD,
        0x000120AD,
        0x000120AD
    };

    static _CharacterInfo _character000120AE =
    {
        0x000120AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AE,
        0x000120AE,
        0x000120AE
    };

    static _CharacterInfo _character000120AF =
    {
        0x000120AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120AF,
        0x000120AF,
        0x000120AF
    };

    static _CharacterInfo _character000120B0 =
    {
        0x000120B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B0,
        0x000120B0,
        0x000120B0
    };

    static _CharacterInfo _character000120B1 =
    {
        0x000120B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B1,
        0x000120B1,
        0x000120B1
    };

    static _CharacterInfo _character000120B2 =
    {
        0x000120B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B2,
        0x000120B2,
        0x000120B2
    };

    static _CharacterInfo _character000120B3 =
    {
        0x000120B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B3,
        0x000120B3,
        0x000120B3
    };

    static _CharacterInfo _character000120B4 =
    {
        0x000120B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B4,
        0x000120B4,
        0x000120B4
    };

    static _CharacterInfo _character000120B5 =
    {
        0x000120B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B5,
        0x000120B5,
        0x000120B5
    };

    static _CharacterInfo _character000120B6 =
    {
        0x000120B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B6,
        0x000120B6,
        0x000120B6
    };

    static _CharacterInfo _character000120B7 =
    {
        0x000120B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B7,
        0x000120B7,
        0x000120B7
    };

    static _CharacterInfo _character000120B8 =
    {
        0x000120B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B8,
        0x000120B8,
        0x000120B8
    };

    static _CharacterInfo _character000120B9 =
    {
        0x000120B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120B9,
        0x000120B9,
        0x000120B9
    };

    static _CharacterInfo _character000120BA =
    {
        0x000120BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BA,
        0x000120BA,
        0x000120BA
    };

    static _CharacterInfo _character000120BB =
    {
        0x000120BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BB,
        0x000120BB,
        0x000120BB
    };

    static _CharacterInfo _character000120BC =
    {
        0x000120BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BC,
        0x000120BC,
        0x000120BC
    };

    static _CharacterInfo _character000120BD =
    {
        0x000120BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BD,
        0x000120BD,
        0x000120BD
    };

    static _CharacterInfo _character000120BE =
    {
        0x000120BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BE,
        0x000120BE,
        0x000120BE
    };

    static _CharacterInfo _character000120BF =
    {
        0x000120BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120BF,
        0x000120BF,
        0x000120BF
    };

    static _CharacterInfo _character000120C0 =
    {
        0x000120C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C0,
        0x000120C0,
        0x000120C0
    };

    static _CharacterInfo _character000120C1 =
    {
        0x000120C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C1,
        0x000120C1,
        0x000120C1
    };

    static _CharacterInfo _character000120C2 =
    {
        0x000120C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C2,
        0x000120C2,
        0x000120C2
    };

    static _CharacterInfo _character000120C3 =
    {
        0x000120C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C3,
        0x000120C3,
        0x000120C3
    };

    static _CharacterInfo _character000120C4 =
    {
        0x000120C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C4,
        0x000120C4,
        0x000120C4
    };

    static _CharacterInfo _character000120C5 =
    {
        0x000120C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C5,
        0x000120C5,
        0x000120C5
    };

    static _CharacterInfo _character000120C6 =
    {
        0x000120C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C6,
        0x000120C6,
        0x000120C6
    };

    static _CharacterInfo _character000120C7 =
    {
        0x000120C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C7,
        0x000120C7,
        0x000120C7
    };

    static _CharacterInfo _character000120C8 =
    {
        0x000120C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C8,
        0x000120C8,
        0x000120C8
    };

    static _CharacterInfo _character000120C9 =
    {
        0x000120C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120C9,
        0x000120C9,
        0x000120C9
    };

    static _CharacterInfo _character000120CA =
    {
        0x000120CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CA,
        0x000120CA,
        0x000120CA
    };

    static _CharacterInfo _character000120CB =
    {
        0x000120CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CB,
        0x000120CB,
        0x000120CB
    };

    static _CharacterInfo _character000120CC =
    {
        0x000120CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CC,
        0x000120CC,
        0x000120CC
    };

    static _CharacterInfo _character000120CD =
    {
        0x000120CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CD,
        0x000120CD,
        0x000120CD
    };

    static _CharacterInfo _character000120CE =
    {
        0x000120CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CE,
        0x000120CE,
        0x000120CE
    };

    static _CharacterInfo _character000120CF =
    {
        0x000120CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120CF,
        0x000120CF,
        0x000120CF
    };

    static _CharacterInfo _character000120D0 =
    {
        0x000120D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D0,
        0x000120D0,
        0x000120D0
    };

    static _CharacterInfo _character000120D1 =
    {
        0x000120D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D1,
        0x000120D1,
        0x000120D1
    };

    static _CharacterInfo _character000120D2 =
    {
        0x000120D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D2,
        0x000120D2,
        0x000120D2
    };

    static _CharacterInfo _character000120D3 =
    {
        0x000120D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D3,
        0x000120D3,
        0x000120D3
    };

    static _CharacterInfo _character000120D4 =
    {
        0x000120D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D4,
        0x000120D4,
        0x000120D4
    };

    static _CharacterInfo _character000120D5 =
    {
        0x000120D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D5,
        0x000120D5,
        0x000120D5
    };

    static _CharacterInfo _character000120D6 =
    {
        0x000120D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D6,
        0x000120D6,
        0x000120D6
    };

    static _CharacterInfo _character000120D7 =
    {
        0x000120D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D7,
        0x000120D7,
        0x000120D7
    };

    static _CharacterInfo _character000120D8 =
    {
        0x000120D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D8,
        0x000120D8,
        0x000120D8
    };

    static _CharacterInfo _character000120D9 =
    {
        0x000120D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120D9,
        0x000120D9,
        0x000120D9
    };

    static _CharacterInfo _character000120DA =
    {
        0x000120DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DA,
        0x000120DA,
        0x000120DA
    };

    static _CharacterInfo _character000120DB =
    {
        0x000120DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DB,
        0x000120DB,
        0x000120DB
    };

    static _CharacterInfo _character000120DC =
    {
        0x000120DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DC,
        0x000120DC,
        0x000120DC
    };

    static _CharacterInfo _character000120DD =
    {
        0x000120DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DD,
        0x000120DD,
        0x000120DD
    };

    static _CharacterInfo _character000120DE =
    {
        0x000120DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DE,
        0x000120DE,
        0x000120DE
    };

    static _CharacterInfo _character000120DF =
    {
        0x000120DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120DF,
        0x000120DF,
        0x000120DF
    };

    static _CharacterInfo _character000120E0 =
    {
        0x000120E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E0,
        0x000120E0,
        0x000120E0
    };

    static _CharacterInfo _character000120E1 =
    {
        0x000120E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E1,
        0x000120E1,
        0x000120E1
    };

    static _CharacterInfo _character000120E2 =
    {
        0x000120E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E2,
        0x000120E2,
        0x000120E2
    };

    static _CharacterInfo _character000120E3 =
    {
        0x000120E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E3,
        0x000120E3,
        0x000120E3
    };

    static _CharacterInfo _character000120E4 =
    {
        0x000120E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E4,
        0x000120E4,
        0x000120E4
    };

    static _CharacterInfo _character000120E5 =
    {
        0x000120E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E5,
        0x000120E5,
        0x000120E5
    };

    static _CharacterInfo _character000120E6 =
    {
        0x000120E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E6,
        0x000120E6,
        0x000120E6
    };

    static _CharacterInfo _character000120E7 =
    {
        0x000120E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E7,
        0x000120E7,
        0x000120E7
    };

    static _CharacterInfo _character000120E8 =
    {
        0x000120E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E8,
        0x000120E8,
        0x000120E8
    };

    static _CharacterInfo _character000120E9 =
    {
        0x000120E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120E9,
        0x000120E9,
        0x000120E9
    };

    static _CharacterInfo _character000120EA =
    {
        0x000120EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120EA,
        0x000120EA,
        0x000120EA
    };

    static _CharacterInfo _character000120EB =
    {
        0x000120EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120EB,
        0x000120EB,
        0x000120EB
    };

    static _CharacterInfo _character000120EC =
    {
        0x000120EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120EC,
        0x000120EC,
        0x000120EC
    };

    static _CharacterInfo _character000120ED =
    {
        0x000120ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120ED,
        0x000120ED,
        0x000120ED
    };

    static _CharacterInfo _character000120EE =
    {
        0x000120EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120EE,
        0x000120EE,
        0x000120EE
    };

    static _CharacterInfo _character000120EF =
    {
        0x000120EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120EF,
        0x000120EF,
        0x000120EF
    };

    static _CharacterInfo _character000120F0 =
    {
        0x000120F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F0,
        0x000120F0,
        0x000120F0
    };

    static _CharacterInfo _character000120F1 =
    {
        0x000120F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F1,
        0x000120F1,
        0x000120F1
    };

    static _CharacterInfo _character000120F2 =
    {
        0x000120F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F2,
        0x000120F2,
        0x000120F2
    };

    static _CharacterInfo _character000120F3 =
    {
        0x000120F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F3,
        0x000120F3,
        0x000120F3
    };

    static _CharacterInfo _character000120F4 =
    {
        0x000120F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F4,
        0x000120F4,
        0x000120F4
    };

    static _CharacterInfo _character000120F5 =
    {
        0x000120F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F5,
        0x000120F5,
        0x000120F5
    };

    static _CharacterInfo _character000120F6 =
    {
        0x000120F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F6,
        0x000120F6,
        0x000120F6
    };

    static _CharacterInfo _character000120F7 =
    {
        0x000120F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F7,
        0x000120F7,
        0x000120F7
    };

    static _CharacterInfo _character000120F8 =
    {
        0x000120F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F8,
        0x000120F8,
        0x000120F8
    };

    static _CharacterInfo _character000120F9 =
    {
        0x000120F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120F9,
        0x000120F9,
        0x000120F9
    };

    static _CharacterInfo _character000120FA =
    {
        0x000120FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FA,
        0x000120FA,
        0x000120FA
    };

    static _CharacterInfo _character000120FB =
    {
        0x000120FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FB,
        0x000120FB,
        0x000120FB
    };

    static _CharacterInfo _character000120FC =
    {
        0x000120FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FC,
        0x000120FC,
        0x000120FC
    };

    static _CharacterInfo _character000120FD =
    {
        0x000120FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FD,
        0x000120FD,
        0x000120FD
    };

    static _CharacterInfo _character000120FE =
    {
        0x000120FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FE,
        0x000120FE,
        0x000120FE
    };

    static _CharacterInfo _character000120FF =
    {
        0x000120FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000120FF,
        0x000120FF,
        0x000120FF
    };

    static _CharacterInfo _character00012100 =
    {
        0x00012100,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012100,
        0x00012100,
        0x00012100
    };

    static _CharacterInfo _character00012101 =
    {
        0x00012101,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012101,
        0x00012101,
        0x00012101
    };

    static _CharacterInfo _character00012102 =
    {
        0x00012102,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012102,
        0x00012102,
        0x00012102
    };

    static _CharacterInfo _character00012103 =
    {
        0x00012103,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012103,
        0x00012103,
        0x00012103
    };

    static _CharacterInfo _character00012104 =
    {
        0x00012104,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012104,
        0x00012104,
        0x00012104
    };

    static _CharacterInfo _character00012105 =
    {
        0x00012105,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012105,
        0x00012105,
        0x00012105
    };

    static _CharacterInfo _character00012106 =
    {
        0x00012106,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012106,
        0x00012106,
        0x00012106
    };

    static _CharacterInfo _character00012107 =
    {
        0x00012107,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012107,
        0x00012107,
        0x00012107
    };

    static _CharacterInfo _character00012108 =
    {
        0x00012108,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012108,
        0x00012108,
        0x00012108
    };

    static _CharacterInfo _character00012109 =
    {
        0x00012109,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012109,
        0x00012109,
        0x00012109
    };

    static _CharacterInfo _character0001210A =
    {
        0x0001210A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210A,
        0x0001210A,
        0x0001210A
    };

    static _CharacterInfo _character0001210B =
    {
        0x0001210B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210B,
        0x0001210B,
        0x0001210B
    };

    static _CharacterInfo _character0001210C =
    {
        0x0001210C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210C,
        0x0001210C,
        0x0001210C
    };

    static _CharacterInfo _character0001210D =
    {
        0x0001210D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210D,
        0x0001210D,
        0x0001210D
    };

    static _CharacterInfo _character0001210E =
    {
        0x0001210E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210E,
        0x0001210E,
        0x0001210E
    };

    static _CharacterInfo _character0001210F =
    {
        0x0001210F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001210F,
        0x0001210F,
        0x0001210F
    };

    static _CharacterInfo _character00012110 =
    {
        0x00012110,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012110,
        0x00012110,
        0x00012110
    };

    static _CharacterInfo _character00012111 =
    {
        0x00012111,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012111,
        0x00012111,
        0x00012111
    };

    static _CharacterInfo _character00012112 =
    {
        0x00012112,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012112,
        0x00012112,
        0x00012112
    };

    static _CharacterInfo _character00012113 =
    {
        0x00012113,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012113,
        0x00012113,
        0x00012113
    };

    static _CharacterInfo _character00012114 =
    {
        0x00012114,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012114,
        0x00012114,
        0x00012114
    };

    static _CharacterInfo _character00012115 =
    {
        0x00012115,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012115,
        0x00012115,
        0x00012115
    };

    static _CharacterInfo _character00012116 =
    {
        0x00012116,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012116,
        0x00012116,
        0x00012116
    };

    static _CharacterInfo _character00012117 =
    {
        0x00012117,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012117,
        0x00012117,
        0x00012117
    };

    static _CharacterInfo _character00012118 =
    {
        0x00012118,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012118,
        0x00012118,
        0x00012118
    };

    static _CharacterInfo _character00012119 =
    {
        0x00012119,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012119,
        0x00012119,
        0x00012119
    };

    static _CharacterInfo _character0001211A =
    {
        0x0001211A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211A,
        0x0001211A,
        0x0001211A
    };

    static _CharacterInfo _character0001211B =
    {
        0x0001211B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211B,
        0x0001211B,
        0x0001211B
    };

    static _CharacterInfo _character0001211C =
    {
        0x0001211C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211C,
        0x0001211C,
        0x0001211C
    };

    static _CharacterInfo _character0001211D =
    {
        0x0001211D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211D,
        0x0001211D,
        0x0001211D
    };

    static _CharacterInfo _character0001211E =
    {
        0x0001211E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211E,
        0x0001211E,
        0x0001211E
    };

    static _CharacterInfo _character0001211F =
    {
        0x0001211F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001211F,
        0x0001211F,
        0x0001211F
    };

    static _CharacterInfo _character00012120 =
    {
        0x00012120,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012120,
        0x00012120,
        0x00012120
    };

    static _CharacterInfo _character00012121 =
    {
        0x00012121,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012121,
        0x00012121,
        0x00012121
    };

    static _CharacterInfo _character00012122 =
    {
        0x00012122,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012122,
        0x00012122,
        0x00012122
    };

    static _CharacterInfo _character00012123 =
    {
        0x00012123,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012123,
        0x00012123,
        0x00012123
    };

    static _CharacterInfo _character00012124 =
    {
        0x00012124,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012124,
        0x00012124,
        0x00012124
    };

    static _CharacterInfo _character00012125 =
    {
        0x00012125,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012125,
        0x00012125,
        0x00012125
    };

    static _CharacterInfo _character00012126 =
    {
        0x00012126,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012126,
        0x00012126,
        0x00012126
    };

    static _CharacterInfo _character00012127 =
    {
        0x00012127,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012127,
        0x00012127,
        0x00012127
    };

    static _CharacterInfo _character00012128 =
    {
        0x00012128,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012128,
        0x00012128,
        0x00012128
    };

    static _CharacterInfo _character00012129 =
    {
        0x00012129,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012129,
        0x00012129,
        0x00012129
    };

    static _CharacterInfo _character0001212A =
    {
        0x0001212A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212A,
        0x0001212A,
        0x0001212A
    };

    static _CharacterInfo _character0001212B =
    {
        0x0001212B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212B,
        0x0001212B,
        0x0001212B
    };

    static _CharacterInfo _character0001212C =
    {
        0x0001212C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212C,
        0x0001212C,
        0x0001212C
    };

    static _CharacterInfo _character0001212D =
    {
        0x0001212D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212D,
        0x0001212D,
        0x0001212D
    };

    static _CharacterInfo _character0001212E =
    {
        0x0001212E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212E,
        0x0001212E,
        0x0001212E
    };

    static _CharacterInfo _character0001212F =
    {
        0x0001212F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001212F,
        0x0001212F,
        0x0001212F
    };

    static _CharacterInfo _character00012130 =
    {
        0x00012130,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012130,
        0x00012130,
        0x00012130
    };

    static _CharacterInfo _character00012131 =
    {
        0x00012131,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012131,
        0x00012131,
        0x00012131
    };

    static _CharacterInfo _character00012132 =
    {
        0x00012132,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012132,
        0x00012132,
        0x00012132
    };

    static _CharacterInfo _character00012133 =
    {
        0x00012133,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012133,
        0x00012133,
        0x00012133
    };

    static _CharacterInfo _character00012134 =
    {
        0x00012134,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012134,
        0x00012134,
        0x00012134
    };

    static _CharacterInfo _character00012135 =
    {
        0x00012135,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012135,
        0x00012135,
        0x00012135
    };

    static _CharacterInfo _character00012136 =
    {
        0x00012136,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012136,
        0x00012136,
        0x00012136
    };

    static _CharacterInfo _character00012137 =
    {
        0x00012137,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012137,
        0x00012137,
        0x00012137
    };

    static _CharacterInfo _character00012138 =
    {
        0x00012138,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012138,
        0x00012138,
        0x00012138
    };

    static _CharacterInfo _character00012139 =
    {
        0x00012139,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012139,
        0x00012139,
        0x00012139
    };

    static _CharacterInfo _character0001213A =
    {
        0x0001213A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213A,
        0x0001213A,
        0x0001213A
    };

    static _CharacterInfo _character0001213B =
    {
        0x0001213B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213B,
        0x0001213B,
        0x0001213B
    };

    static _CharacterInfo _character0001213C =
    {
        0x0001213C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213C,
        0x0001213C,
        0x0001213C
    };

    static _CharacterInfo _character0001213D =
    {
        0x0001213D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213D,
        0x0001213D,
        0x0001213D
    };

    static _CharacterInfo _character0001213E =
    {
        0x0001213E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213E,
        0x0001213E,
        0x0001213E
    };

    static _CharacterInfo _character0001213F =
    {
        0x0001213F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001213F,
        0x0001213F,
        0x0001213F
    };

    static _CharacterInfo _character00012140 =
    {
        0x00012140,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012140,
        0x00012140,
        0x00012140
    };

    static _CharacterInfo _character00012141 =
    {
        0x00012141,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012141,
        0x00012141,
        0x00012141
    };

    static _CharacterInfo _character00012142 =
    {
        0x00012142,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012142,
        0x00012142,
        0x00012142
    };

    static _CharacterInfo _character00012143 =
    {
        0x00012143,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012143,
        0x00012143,
        0x00012143
    };

    static _CharacterInfo _character00012144 =
    {
        0x00012144,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012144,
        0x00012144,
        0x00012144
    };

    static _CharacterInfo _character00012145 =
    {
        0x00012145,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012145,
        0x00012145,
        0x00012145
    };

    static _CharacterInfo _character00012146 =
    {
        0x00012146,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012146,
        0x00012146,
        0x00012146
    };

    static _CharacterInfo _character00012147 =
    {
        0x00012147,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012147,
        0x00012147,
        0x00012147
    };

    static _CharacterInfo _character00012148 =
    {
        0x00012148,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012148,
        0x00012148,
        0x00012148
    };

    static _CharacterInfo _character00012149 =
    {
        0x00012149,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012149,
        0x00012149,
        0x00012149
    };

    static _CharacterInfo _character0001214A =
    {
        0x0001214A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214A,
        0x0001214A,
        0x0001214A
    };

    static _CharacterInfo _character0001214B =
    {
        0x0001214B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214B,
        0x0001214B,
        0x0001214B
    };

    static _CharacterInfo _character0001214C =
    {
        0x0001214C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214C,
        0x0001214C,
        0x0001214C
    };

    static _CharacterInfo _character0001214D =
    {
        0x0001214D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214D,
        0x0001214D,
        0x0001214D
    };

    static _CharacterInfo _character0001214E =
    {
        0x0001214E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214E,
        0x0001214E,
        0x0001214E
    };

    static _CharacterInfo _character0001214F =
    {
        0x0001214F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001214F,
        0x0001214F,
        0x0001214F
    };

    static _CharacterInfo _character00012150 =
    {
        0x00012150,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012150,
        0x00012150,
        0x00012150
    };

    static _CharacterInfo _character00012151 =
    {
        0x00012151,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012151,
        0x00012151,
        0x00012151
    };

    static _CharacterInfo _character00012152 =
    {
        0x00012152,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012152,
        0x00012152,
        0x00012152
    };

    static _CharacterInfo _character00012153 =
    {
        0x00012153,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012153,
        0x00012153,
        0x00012153
    };

    static _CharacterInfo _character00012154 =
    {
        0x00012154,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012154,
        0x00012154,
        0x00012154
    };

    static _CharacterInfo _character00012155 =
    {
        0x00012155,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012155,
        0x00012155,
        0x00012155
    };

    static _CharacterInfo _character00012156 =
    {
        0x00012156,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012156,
        0x00012156,
        0x00012156
    };

    static _CharacterInfo _character00012157 =
    {
        0x00012157,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012157,
        0x00012157,
        0x00012157
    };

    static _CharacterInfo _character00012158 =
    {
        0x00012158,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012158,
        0x00012158,
        0x00012158
    };

    static _CharacterInfo _character00012159 =
    {
        0x00012159,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012159,
        0x00012159,
        0x00012159
    };

    static _CharacterInfo _character0001215A =
    {
        0x0001215A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215A,
        0x0001215A,
        0x0001215A
    };

    static _CharacterInfo _character0001215B =
    {
        0x0001215B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215B,
        0x0001215B,
        0x0001215B
    };

    static _CharacterInfo _character0001215C =
    {
        0x0001215C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215C,
        0x0001215C,
        0x0001215C
    };

    static _CharacterInfo _character0001215D =
    {
        0x0001215D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215D,
        0x0001215D,
        0x0001215D
    };

    static _CharacterInfo _character0001215E =
    {
        0x0001215E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215E,
        0x0001215E,
        0x0001215E
    };

    static _CharacterInfo _character0001215F =
    {
        0x0001215F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001215F,
        0x0001215F,
        0x0001215F
    };

    static _CharacterInfo _character00012160 =
    {
        0x00012160,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012160,
        0x00012160,
        0x00012160
    };

    static _CharacterInfo _character00012161 =
    {
        0x00012161,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012161,
        0x00012161,
        0x00012161
    };

    static _CharacterInfo _character00012162 =
    {
        0x00012162,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012162,
        0x00012162,
        0x00012162
    };

    static _CharacterInfo _character00012163 =
    {
        0x00012163,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012163,
        0x00012163,
        0x00012163
    };

    static _CharacterInfo _character00012164 =
    {
        0x00012164,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012164,
        0x00012164,
        0x00012164
    };

    static _CharacterInfo _character00012165 =
    {
        0x00012165,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012165,
        0x00012165,
        0x00012165
    };

    static _CharacterInfo _character00012166 =
    {
        0x00012166,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012166,
        0x00012166,
        0x00012166
    };

    static _CharacterInfo _character00012167 =
    {
        0x00012167,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012167,
        0x00012167,
        0x00012167
    };

    static _CharacterInfo _character00012168 =
    {
        0x00012168,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012168,
        0x00012168,
        0x00012168
    };

    static _CharacterInfo _character00012169 =
    {
        0x00012169,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012169,
        0x00012169,
        0x00012169
    };

    static _CharacterInfo _character0001216A =
    {
        0x0001216A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216A,
        0x0001216A,
        0x0001216A
    };

    static _CharacterInfo _character0001216B =
    {
        0x0001216B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216B,
        0x0001216B,
        0x0001216B
    };

    static _CharacterInfo _character0001216C =
    {
        0x0001216C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216C,
        0x0001216C,
        0x0001216C
    };

    static _CharacterInfo _character0001216D =
    {
        0x0001216D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216D,
        0x0001216D,
        0x0001216D
    };

    static _CharacterInfo _character0001216E =
    {
        0x0001216E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216E,
        0x0001216E,
        0x0001216E
    };

    static _CharacterInfo _character0001216F =
    {
        0x0001216F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001216F,
        0x0001216F,
        0x0001216F
    };

    static _CharacterInfo _character00012170 =
    {
        0x00012170,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012170,
        0x00012170,
        0x00012170
    };

    static _CharacterInfo _character00012171 =
    {
        0x00012171,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012171,
        0x00012171,
        0x00012171
    };

    static _CharacterInfo _character00012172 =
    {
        0x00012172,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012172,
        0x00012172,
        0x00012172
    };

    static _CharacterInfo _character00012173 =
    {
        0x00012173,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012173,
        0x00012173,
        0x00012173
    };

    static _CharacterInfo _character00012174 =
    {
        0x00012174,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012174,
        0x00012174,
        0x00012174
    };

    static _CharacterInfo _character00012175 =
    {
        0x00012175,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012175,
        0x00012175,
        0x00012175
    };

    static _CharacterInfo _character00012176 =
    {
        0x00012176,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012176,
        0x00012176,
        0x00012176
    };

    static _CharacterInfo _character00012177 =
    {
        0x00012177,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012177,
        0x00012177,
        0x00012177
    };

    static _CharacterInfo _character00012178 =
    {
        0x00012178,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012178,
        0x00012178,
        0x00012178
    };

    static _CharacterInfo _character00012179 =
    {
        0x00012179,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012179,
        0x00012179,
        0x00012179
    };

    static _CharacterInfo _character0001217A =
    {
        0x0001217A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217A,
        0x0001217A,
        0x0001217A
    };

    static _CharacterInfo _character0001217B =
    {
        0x0001217B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217B,
        0x0001217B,
        0x0001217B
    };

    static _CharacterInfo _character0001217C =
    {
        0x0001217C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217C,
        0x0001217C,
        0x0001217C
    };

    static _CharacterInfo _character0001217D =
    {
        0x0001217D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217D,
        0x0001217D,
        0x0001217D
    };

    static _CharacterInfo _character0001217E =
    {
        0x0001217E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217E,
        0x0001217E,
        0x0001217E
    };

    static _CharacterInfo _character0001217F =
    {
        0x0001217F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001217F,
        0x0001217F,
        0x0001217F
    };

    static _CharacterInfo _character00012180 =
    {
        0x00012180,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012180,
        0x00012180,
        0x00012180
    };

    static _CharacterInfo _character00012181 =
    {
        0x00012181,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012181,
        0x00012181,
        0x00012181
    };

    static _CharacterInfo _character00012182 =
    {
        0x00012182,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012182,
        0x00012182,
        0x00012182
    };

    static _CharacterInfo _character00012183 =
    {
        0x00012183,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012183,
        0x00012183,
        0x00012183
    };

    static _CharacterInfo _character00012184 =
    {
        0x00012184,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012184,
        0x00012184,
        0x00012184
    };

    static _CharacterInfo _character00012185 =
    {
        0x00012185,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012185,
        0x00012185,
        0x00012185
    };

    static _CharacterInfo _character00012186 =
    {
        0x00012186,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012186,
        0x00012186,
        0x00012186
    };

    static _CharacterInfo _character00012187 =
    {
        0x00012187,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012187,
        0x00012187,
        0x00012187
    };

    static _CharacterInfo _character00012188 =
    {
        0x00012188,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012188,
        0x00012188,
        0x00012188
    };

    static _CharacterInfo _character00012189 =
    {
        0x00012189,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012189,
        0x00012189,
        0x00012189
    };

    static _CharacterInfo _character0001218A =
    {
        0x0001218A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218A,
        0x0001218A,
        0x0001218A
    };

    static _CharacterInfo _character0001218B =
    {
        0x0001218B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218B,
        0x0001218B,
        0x0001218B
    };

    static _CharacterInfo _character0001218C =
    {
        0x0001218C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218C,
        0x0001218C,
        0x0001218C
    };

    static _CharacterInfo _character0001218D =
    {
        0x0001218D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218D,
        0x0001218D,
        0x0001218D
    };

    static _CharacterInfo _character0001218E =
    {
        0x0001218E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218E,
        0x0001218E,
        0x0001218E
    };

    static _CharacterInfo _character0001218F =
    {
        0x0001218F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001218F,
        0x0001218F,
        0x0001218F
    };

    static _CharacterInfo _character00012190 =
    {
        0x00012190,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012190,
        0x00012190,
        0x00012190
    };

    static _CharacterInfo _character00012191 =
    {
        0x00012191,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012191,
        0x00012191,
        0x00012191
    };

    static _CharacterInfo _character00012192 =
    {
        0x00012192,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012192,
        0x00012192,
        0x00012192
    };

    static _CharacterInfo _character00012193 =
    {
        0x00012193,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012193,
        0x00012193,
        0x00012193
    };

    static _CharacterInfo _character00012194 =
    {
        0x00012194,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012194,
        0x00012194,
        0x00012194
    };

    static _CharacterInfo _character00012195 =
    {
        0x00012195,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012195,
        0x00012195,
        0x00012195
    };

    static _CharacterInfo _character00012196 =
    {
        0x00012196,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012196,
        0x00012196,
        0x00012196
    };

    static _CharacterInfo _character00012197 =
    {
        0x00012197,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012197,
        0x00012197,
        0x00012197
    };

    static _CharacterInfo _character00012198 =
    {
        0x00012198,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012198,
        0x00012198,
        0x00012198
    };

    static _CharacterInfo _character00012199 =
    {
        0x00012199,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012199,
        0x00012199,
        0x00012199
    };

    static _CharacterInfo _character0001219A =
    {
        0x0001219A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219A,
        0x0001219A,
        0x0001219A
    };

    static _CharacterInfo _character0001219B =
    {
        0x0001219B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219B,
        0x0001219B,
        0x0001219B
    };

    static _CharacterInfo _character0001219C =
    {
        0x0001219C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219C,
        0x0001219C,
        0x0001219C
    };

    static _CharacterInfo _character0001219D =
    {
        0x0001219D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219D,
        0x0001219D,
        0x0001219D
    };

    static _CharacterInfo _character0001219E =
    {
        0x0001219E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219E,
        0x0001219E,
        0x0001219E
    };

    static _CharacterInfo _character0001219F =
    {
        0x0001219F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001219F,
        0x0001219F,
        0x0001219F
    };

    static _CharacterInfo _character000121A0 =
    {
        0x000121A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A0,
        0x000121A0,
        0x000121A0
    };

    static _CharacterInfo _character000121A1 =
    {
        0x000121A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A1,
        0x000121A1,
        0x000121A1
    };

    static _CharacterInfo _character000121A2 =
    {
        0x000121A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A2,
        0x000121A2,
        0x000121A2
    };

    static _CharacterInfo _character000121A3 =
    {
        0x000121A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A3,
        0x000121A3,
        0x000121A3
    };

    static _CharacterInfo _character000121A4 =
    {
        0x000121A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A4,
        0x000121A4,
        0x000121A4
    };

    static _CharacterInfo _character000121A5 =
    {
        0x000121A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A5,
        0x000121A5,
        0x000121A5
    };

    static _CharacterInfo _character000121A6 =
    {
        0x000121A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A6,
        0x000121A6,
        0x000121A6
    };

    static _CharacterInfo _character000121A7 =
    {
        0x000121A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A7,
        0x000121A7,
        0x000121A7
    };

    static _CharacterInfo _character000121A8 =
    {
        0x000121A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A8,
        0x000121A8,
        0x000121A8
    };

    static _CharacterInfo _character000121A9 =
    {
        0x000121A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121A9,
        0x000121A9,
        0x000121A9
    };

    static _CharacterInfo _character000121AA =
    {
        0x000121AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AA,
        0x000121AA,
        0x000121AA
    };

    static _CharacterInfo _character000121AB =
    {
        0x000121AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AB,
        0x000121AB,
        0x000121AB
    };

    static _CharacterInfo _character000121AC =
    {
        0x000121AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AC,
        0x000121AC,
        0x000121AC
    };

    static _CharacterInfo _character000121AD =
    {
        0x000121AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AD,
        0x000121AD,
        0x000121AD
    };

    static _CharacterInfo _character000121AE =
    {
        0x000121AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AE,
        0x000121AE,
        0x000121AE
    };

    static _CharacterInfo _character000121AF =
    {
        0x000121AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121AF,
        0x000121AF,
        0x000121AF
    };

    static _CharacterInfo _character000121B0 =
    {
        0x000121B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B0,
        0x000121B0,
        0x000121B0
    };

    static _CharacterInfo _character000121B1 =
    {
        0x000121B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B1,
        0x000121B1,
        0x000121B1
    };

    static _CharacterInfo _character000121B2 =
    {
        0x000121B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B2,
        0x000121B2,
        0x000121B2
    };

    static _CharacterInfo _character000121B3 =
    {
        0x000121B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B3,
        0x000121B3,
        0x000121B3
    };

    static _CharacterInfo _character000121B4 =
    {
        0x000121B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B4,
        0x000121B4,
        0x000121B4
    };

    static _CharacterInfo _character000121B5 =
    {
        0x000121B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B5,
        0x000121B5,
        0x000121B5
    };

    static _CharacterInfo _character000121B6 =
    {
        0x000121B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B6,
        0x000121B6,
        0x000121B6
    };

    static _CharacterInfo _character000121B7 =
    {
        0x000121B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B7,
        0x000121B7,
        0x000121B7
    };

    static _CharacterInfo _character000121B8 =
    {
        0x000121B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B8,
        0x000121B8,
        0x000121B8
    };

    static _CharacterInfo _character000121B9 =
    {
        0x000121B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121B9,
        0x000121B9,
        0x000121B9
    };

    static _CharacterInfo _character000121BA =
    {
        0x000121BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BA,
        0x000121BA,
        0x000121BA
    };

    static _CharacterInfo _character000121BB =
    {
        0x000121BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BB,
        0x000121BB,
        0x000121BB
    };

    static _CharacterInfo _character000121BC =
    {
        0x000121BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BC,
        0x000121BC,
        0x000121BC
    };

    static _CharacterInfo _character000121BD =
    {
        0x000121BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BD,
        0x000121BD,
        0x000121BD
    };

    static _CharacterInfo _character000121BE =
    {
        0x000121BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BE,
        0x000121BE,
        0x000121BE
    };

    static _CharacterInfo _character000121BF =
    {
        0x000121BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121BF,
        0x000121BF,
        0x000121BF
    };

    static _CharacterInfo _character000121C0 =
    {
        0x000121C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C0,
        0x000121C0,
        0x000121C0
    };

    static _CharacterInfo _character000121C1 =
    {
        0x000121C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C1,
        0x000121C1,
        0x000121C1
    };

    static _CharacterInfo _character000121C2 =
    {
        0x000121C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C2,
        0x000121C2,
        0x000121C2
    };

    static _CharacterInfo _character000121C3 =
    {
        0x000121C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C3,
        0x000121C3,
        0x000121C3
    };

    static _CharacterInfo _character000121C4 =
    {
        0x000121C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C4,
        0x000121C4,
        0x000121C4
    };

    static _CharacterInfo _character000121C5 =
    {
        0x000121C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C5,
        0x000121C5,
        0x000121C5
    };

    static _CharacterInfo _character000121C6 =
    {
        0x000121C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C6,
        0x000121C6,
        0x000121C6
    };

    static _CharacterInfo _character000121C7 =
    {
        0x000121C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C7,
        0x000121C7,
        0x000121C7
    };

    static _CharacterInfo _character000121C8 =
    {
        0x000121C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C8,
        0x000121C8,
        0x000121C8
    };

    static _CharacterInfo _character000121C9 =
    {
        0x000121C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121C9,
        0x000121C9,
        0x000121C9
    };

    static _CharacterInfo _character000121CA =
    {
        0x000121CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CA,
        0x000121CA,
        0x000121CA
    };

    static _CharacterInfo _character000121CB =
    {
        0x000121CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CB,
        0x000121CB,
        0x000121CB
    };

    static _CharacterInfo _character000121CC =
    {
        0x000121CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CC,
        0x000121CC,
        0x000121CC
    };

    static _CharacterInfo _character000121CD =
    {
        0x000121CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CD,
        0x000121CD,
        0x000121CD
    };

    static _CharacterInfo _character000121CE =
    {
        0x000121CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CE,
        0x000121CE,
        0x000121CE
    };

    static _CharacterInfo _character000121CF =
    {
        0x000121CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121CF,
        0x000121CF,
        0x000121CF
    };

    static _CharacterInfo _character000121D0 =
    {
        0x000121D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D0,
        0x000121D0,
        0x000121D0
    };

    static _CharacterInfo _character000121D1 =
    {
        0x000121D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D1,
        0x000121D1,
        0x000121D1
    };

    static _CharacterInfo _character000121D2 =
    {
        0x000121D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D2,
        0x000121D2,
        0x000121D2
    };

    static _CharacterInfo _character000121D3 =
    {
        0x000121D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D3,
        0x000121D3,
        0x000121D3
    };

    static _CharacterInfo _character000121D4 =
    {
        0x000121D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D4,
        0x000121D4,
        0x000121D4
    };

    static _CharacterInfo _character000121D5 =
    {
        0x000121D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D5,
        0x000121D5,
        0x000121D5
    };

    static _CharacterInfo _character000121D6 =
    {
        0x000121D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D6,
        0x000121D6,
        0x000121D6
    };

    static _CharacterInfo _character000121D7 =
    {
        0x000121D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D7,
        0x000121D7,
        0x000121D7
    };

    static _CharacterInfo _character000121D8 =
    {
        0x000121D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D8,
        0x000121D8,
        0x000121D8
    };

    static _CharacterInfo _character000121D9 =
    {
        0x000121D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121D9,
        0x000121D9,
        0x000121D9
    };

    static _CharacterInfo _character000121DA =
    {
        0x000121DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DA,
        0x000121DA,
        0x000121DA
    };

    static _CharacterInfo _character000121DB =
    {
        0x000121DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DB,
        0x000121DB,
        0x000121DB
    };

    static _CharacterInfo _character000121DC =
    {
        0x000121DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DC,
        0x000121DC,
        0x000121DC
    };

    static _CharacterInfo _character000121DD =
    {
        0x000121DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DD,
        0x000121DD,
        0x000121DD
    };

    static _CharacterInfo _character000121DE =
    {
        0x000121DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DE,
        0x000121DE,
        0x000121DE
    };

    static _CharacterInfo _character000121DF =
    {
        0x000121DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121DF,
        0x000121DF,
        0x000121DF
    };

    static _CharacterInfo _character000121E0 =
    {
        0x000121E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E0,
        0x000121E0,
        0x000121E0
    };

    static _CharacterInfo _character000121E1 =
    {
        0x000121E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E1,
        0x000121E1,
        0x000121E1
    };

    static _CharacterInfo _character000121E2 =
    {
        0x000121E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E2,
        0x000121E2,
        0x000121E2
    };

    static _CharacterInfo _character000121E3 =
    {
        0x000121E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E3,
        0x000121E3,
        0x000121E3
    };

    static _CharacterInfo _character000121E4 =
    {
        0x000121E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E4,
        0x000121E4,
        0x000121E4
    };

    static _CharacterInfo _character000121E5 =
    {
        0x000121E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E5,
        0x000121E5,
        0x000121E5
    };

    static _CharacterInfo _character000121E6 =
    {
        0x000121E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E6,
        0x000121E6,
        0x000121E6
    };

    static _CharacterInfo _character000121E7 =
    {
        0x000121E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E7,
        0x000121E7,
        0x000121E7
    };

    static _CharacterInfo _character000121E8 =
    {
        0x000121E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E8,
        0x000121E8,
        0x000121E8
    };

    static _CharacterInfo _character000121E9 =
    {
        0x000121E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121E9,
        0x000121E9,
        0x000121E9
    };

    static _CharacterInfo _character000121EA =
    {
        0x000121EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121EA,
        0x000121EA,
        0x000121EA
    };

    static _CharacterInfo _character000121EB =
    {
        0x000121EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121EB,
        0x000121EB,
        0x000121EB
    };

    static _CharacterInfo _character000121EC =
    {
        0x000121EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121EC,
        0x000121EC,
        0x000121EC
    };

    static _CharacterInfo _character000121ED =
    {
        0x000121ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121ED,
        0x000121ED,
        0x000121ED
    };

    static _CharacterInfo _character000121EE =
    {
        0x000121EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121EE,
        0x000121EE,
        0x000121EE
    };

    static _CharacterInfo _character000121EF =
    {
        0x000121EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121EF,
        0x000121EF,
        0x000121EF
    };

    static _CharacterInfo _character000121F0 =
    {
        0x000121F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F0,
        0x000121F0,
        0x000121F0
    };

    static _CharacterInfo _character000121F1 =
    {
        0x000121F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F1,
        0x000121F1,
        0x000121F1
    };

    static _CharacterInfo _character000121F2 =
    {
        0x000121F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F2,
        0x000121F2,
        0x000121F2
    };

    static _CharacterInfo _character000121F3 =
    {
        0x000121F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F3,
        0x000121F3,
        0x000121F3
    };

    static _CharacterInfo _character000121F4 =
    {
        0x000121F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F4,
        0x000121F4,
        0x000121F4
    };

    static _CharacterInfo _character000121F5 =
    {
        0x000121F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F5,
        0x000121F5,
        0x000121F5
    };

    static _CharacterInfo _character000121F6 =
    {
        0x000121F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F6,
        0x000121F6,
        0x000121F6
    };

    static _CharacterInfo _character000121F7 =
    {
        0x000121F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F7,
        0x000121F7,
        0x000121F7
    };

    static _CharacterInfo _character000121F8 =
    {
        0x000121F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F8,
        0x000121F8,
        0x000121F8
    };

    static _CharacterInfo _character000121F9 =
    {
        0x000121F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121F9,
        0x000121F9,
        0x000121F9
    };

    static _CharacterInfo _character000121FA =
    {
        0x000121FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FA,
        0x000121FA,
        0x000121FA
    };

    static _CharacterInfo _character000121FB =
    {
        0x000121FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FB,
        0x000121FB,
        0x000121FB
    };

    static _CharacterInfo _character000121FC =
    {
        0x000121FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FC,
        0x000121FC,
        0x000121FC
    };

    static _CharacterInfo _character000121FD =
    {
        0x000121FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FD,
        0x000121FD,
        0x000121FD
    };

    static _CharacterInfo _character000121FE =
    {
        0x000121FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FE,
        0x000121FE,
        0x000121FE
    };

    static _CharacterInfo _character000121FF =
    {
        0x000121FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000121FF,
        0x000121FF,
        0x000121FF
    };

    static _CharacterInfo _character00012200 =
    {
        0x00012200,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012200,
        0x00012200,
        0x00012200
    };

    static _CharacterInfo _character00012201 =
    {
        0x00012201,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012201,
        0x00012201,
        0x00012201
    };

    static _CharacterInfo _character00012202 =
    {
        0x00012202,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012202,
        0x00012202,
        0x00012202
    };

    static _CharacterInfo _character00012203 =
    {
        0x00012203,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012203,
        0x00012203,
        0x00012203
    };

    static _CharacterInfo _character00012204 =
    {
        0x00012204,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012204,
        0x00012204,
        0x00012204
    };

    static _CharacterInfo _character00012205 =
    {
        0x00012205,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012205,
        0x00012205,
        0x00012205
    };

    static _CharacterInfo _character00012206 =
    {
        0x00012206,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012206,
        0x00012206,
        0x00012206
    };

    static _CharacterInfo _character00012207 =
    {
        0x00012207,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012207,
        0x00012207,
        0x00012207
    };

    static _CharacterInfo _character00012208 =
    {
        0x00012208,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012208,
        0x00012208,
        0x00012208
    };

    static _CharacterInfo _character00012209 =
    {
        0x00012209,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012209,
        0x00012209,
        0x00012209
    };

    static _CharacterInfo _character0001220A =
    {
        0x0001220A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220A,
        0x0001220A,
        0x0001220A
    };

    static _CharacterInfo _character0001220B =
    {
        0x0001220B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220B,
        0x0001220B,
        0x0001220B
    };

    static _CharacterInfo _character0001220C =
    {
        0x0001220C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220C,
        0x0001220C,
        0x0001220C
    };

    static _CharacterInfo _character0001220D =
    {
        0x0001220D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220D,
        0x0001220D,
        0x0001220D
    };

    static _CharacterInfo _character0001220E =
    {
        0x0001220E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220E,
        0x0001220E,
        0x0001220E
    };

    static _CharacterInfo _character0001220F =
    {
        0x0001220F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001220F,
        0x0001220F,
        0x0001220F
    };

    static _CharacterInfo _character00012210 =
    {
        0x00012210,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012210,
        0x00012210,
        0x00012210
    };

    static _CharacterInfo _character00012211 =
    {
        0x00012211,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012211,
        0x00012211,
        0x00012211
    };

    static _CharacterInfo _character00012212 =
    {
        0x00012212,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012212,
        0x00012212,
        0x00012212
    };

    static _CharacterInfo _character00012213 =
    {
        0x00012213,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012213,
        0x00012213,
        0x00012213
    };

    static _CharacterInfo _character00012214 =
    {
        0x00012214,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012214,
        0x00012214,
        0x00012214
    };

    static _CharacterInfo _character00012215 =
    {
        0x00012215,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012215,
        0x00012215,
        0x00012215
    };

    static _CharacterInfo _character00012216 =
    {
        0x00012216,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012216,
        0x00012216,
        0x00012216
    };

    static _CharacterInfo _character00012217 =
    {
        0x00012217,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012217,
        0x00012217,
        0x00012217
    };

    static _CharacterInfo _character00012218 =
    {
        0x00012218,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012218,
        0x00012218,
        0x00012218
    };

    static _CharacterInfo _character00012219 =
    {
        0x00012219,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012219,
        0x00012219,
        0x00012219
    };

    static _CharacterInfo _character0001221A =
    {
        0x0001221A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221A,
        0x0001221A,
        0x0001221A
    };

    static _CharacterInfo _character0001221B =
    {
        0x0001221B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221B,
        0x0001221B,
        0x0001221B
    };

    static _CharacterInfo _character0001221C =
    {
        0x0001221C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221C,
        0x0001221C,
        0x0001221C
    };

    static _CharacterInfo _character0001221D =
    {
        0x0001221D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221D,
        0x0001221D,
        0x0001221D
    };

    static _CharacterInfo _character0001221E =
    {
        0x0001221E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221E,
        0x0001221E,
        0x0001221E
    };

    static _CharacterInfo _character0001221F =
    {
        0x0001221F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001221F,
        0x0001221F,
        0x0001221F
    };

    static _CharacterInfo _character00012220 =
    {
        0x00012220,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012220,
        0x00012220,
        0x00012220
    };

    static _CharacterInfo _character00012221 =
    {
        0x00012221,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012221,
        0x00012221,
        0x00012221
    };

    static _CharacterInfo _character00012222 =
    {
        0x00012222,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012222,
        0x00012222,
        0x00012222
    };

    static _CharacterInfo _character00012223 =
    {
        0x00012223,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012223,
        0x00012223,
        0x00012223
    };

    static _CharacterInfo _character00012224 =
    {
        0x00012224,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012224,
        0x00012224,
        0x00012224
    };

    static _CharacterInfo _character00012225 =
    {
        0x00012225,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012225,
        0x00012225,
        0x00012225
    };

    static _CharacterInfo _character00012226 =
    {
        0x00012226,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012226,
        0x00012226,
        0x00012226
    };

    static _CharacterInfo _character00012227 =
    {
        0x00012227,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012227,
        0x00012227,
        0x00012227
    };

    static _CharacterInfo _character00012228 =
    {
        0x00012228,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012228,
        0x00012228,
        0x00012228
    };

    static _CharacterInfo _character00012229 =
    {
        0x00012229,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012229,
        0x00012229,
        0x00012229
    };

    static _CharacterInfo _character0001222A =
    {
        0x0001222A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222A,
        0x0001222A,
        0x0001222A
    };

    static _CharacterInfo _character0001222B =
    {
        0x0001222B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222B,
        0x0001222B,
        0x0001222B
    };

    static _CharacterInfo _character0001222C =
    {
        0x0001222C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222C,
        0x0001222C,
        0x0001222C
    };

    static _CharacterInfo _character0001222D =
    {
        0x0001222D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222D,
        0x0001222D,
        0x0001222D
    };

    static _CharacterInfo _character0001222E =
    {
        0x0001222E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222E,
        0x0001222E,
        0x0001222E
    };

    static _CharacterInfo _character0001222F =
    {
        0x0001222F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001222F,
        0x0001222F,
        0x0001222F
    };

    static _CharacterInfo _character00012230 =
    {
        0x00012230,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012230,
        0x00012230,
        0x00012230
    };

    static _CharacterInfo _character00012231 =
    {
        0x00012231,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012231,
        0x00012231,
        0x00012231
    };

    static _CharacterInfo _character00012232 =
    {
        0x00012232,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012232,
        0x00012232,
        0x00012232
    };

    static _CharacterInfo _character00012233 =
    {
        0x00012233,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012233,
        0x00012233,
        0x00012233
    };

    static _CharacterInfo _character00012234 =
    {
        0x00012234,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012234,
        0x00012234,
        0x00012234
    };

    static _CharacterInfo _character00012235 =
    {
        0x00012235,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012235,
        0x00012235,
        0x00012235
    };

    static _CharacterInfo _character00012236 =
    {
        0x00012236,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012236,
        0x00012236,
        0x00012236
    };

    static _CharacterInfo _character00012237 =
    {
        0x00012237,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012237,
        0x00012237,
        0x00012237
    };

    static _CharacterInfo _character00012238 =
    {
        0x00012238,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012238,
        0x00012238,
        0x00012238
    };

    static _CharacterInfo _character00012239 =
    {
        0x00012239,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012239,
        0x00012239,
        0x00012239
    };

    static _CharacterInfo _character0001223A =
    {
        0x0001223A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223A,
        0x0001223A,
        0x0001223A
    };

    static _CharacterInfo _character0001223B =
    {
        0x0001223B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223B,
        0x0001223B,
        0x0001223B
    };

    static _CharacterInfo _character0001223C =
    {
        0x0001223C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223C,
        0x0001223C,
        0x0001223C
    };

    static _CharacterInfo _character0001223D =
    {
        0x0001223D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223D,
        0x0001223D,
        0x0001223D
    };

    static _CharacterInfo _character0001223E =
    {
        0x0001223E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223E,
        0x0001223E,
        0x0001223E
    };

    static _CharacterInfo _character0001223F =
    {
        0x0001223F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001223F,
        0x0001223F,
        0x0001223F
    };

    static _CharacterInfo _character00012240 =
    {
        0x00012240,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012240,
        0x00012240,
        0x00012240
    };

    static _CharacterInfo _character00012241 =
    {
        0x00012241,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012241,
        0x00012241,
        0x00012241
    };

    static _CharacterInfo _character00012242 =
    {
        0x00012242,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012242,
        0x00012242,
        0x00012242
    };

    static _CharacterInfo _character00012243 =
    {
        0x00012243,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012243,
        0x00012243,
        0x00012243
    };

    static _CharacterInfo _character00012244 =
    {
        0x00012244,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012244,
        0x00012244,
        0x00012244
    };

    static _CharacterInfo _character00012245 =
    {
        0x00012245,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012245,
        0x00012245,
        0x00012245
    };

    static _CharacterInfo _character00012246 =
    {
        0x00012246,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012246,
        0x00012246,
        0x00012246
    };

    static _CharacterInfo _character00012247 =
    {
        0x00012247,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012247,
        0x00012247,
        0x00012247
    };

    static _CharacterInfo _character00012248 =
    {
        0x00012248,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012248,
        0x00012248,
        0x00012248
    };

    static _CharacterInfo _character00012249 =
    {
        0x00012249,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012249,
        0x00012249,
        0x00012249
    };

    static _CharacterInfo _character0001224A =
    {
        0x0001224A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224A,
        0x0001224A,
        0x0001224A
    };

    static _CharacterInfo _character0001224B =
    {
        0x0001224B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224B,
        0x0001224B,
        0x0001224B
    };

    static _CharacterInfo _character0001224C =
    {
        0x0001224C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224C,
        0x0001224C,
        0x0001224C
    };

    static _CharacterInfo _character0001224D =
    {
        0x0001224D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224D,
        0x0001224D,
        0x0001224D
    };

    static _CharacterInfo _character0001224E =
    {
        0x0001224E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224E,
        0x0001224E,
        0x0001224E
    };

    static _CharacterInfo _character0001224F =
    {
        0x0001224F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001224F,
        0x0001224F,
        0x0001224F
    };

    static _CharacterInfo _character00012250 =
    {
        0x00012250,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012250,
        0x00012250,
        0x00012250
    };

    static _CharacterInfo _character00012251 =
    {
        0x00012251,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012251,
        0x00012251,
        0x00012251
    };

    static _CharacterInfo _character00012252 =
    {
        0x00012252,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012252,
        0x00012252,
        0x00012252
    };

    static _CharacterInfo _character00012253 =
    {
        0x00012253,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012253,
        0x00012253,
        0x00012253
    };

    static _CharacterInfo _character00012254 =
    {
        0x00012254,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012254,
        0x00012254,
        0x00012254
    };

    static _CharacterInfo _character00012255 =
    {
        0x00012255,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012255,
        0x00012255,
        0x00012255
    };

    static _CharacterInfo _character00012256 =
    {
        0x00012256,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012256,
        0x00012256,
        0x00012256
    };

    static _CharacterInfo _character00012257 =
    {
        0x00012257,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012257,
        0x00012257,
        0x00012257
    };

    static _CharacterInfo _character00012258 =
    {
        0x00012258,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012258,
        0x00012258,
        0x00012258
    };

    static _CharacterInfo _character00012259 =
    {
        0x00012259,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012259,
        0x00012259,
        0x00012259
    };

    static _CharacterInfo _character0001225A =
    {
        0x0001225A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225A,
        0x0001225A,
        0x0001225A
    };

    static _CharacterInfo _character0001225B =
    {
        0x0001225B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225B,
        0x0001225B,
        0x0001225B
    };

    static _CharacterInfo _character0001225C =
    {
        0x0001225C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225C,
        0x0001225C,
        0x0001225C
    };

    static _CharacterInfo _character0001225D =
    {
        0x0001225D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225D,
        0x0001225D,
        0x0001225D
    };

    static _CharacterInfo _character0001225E =
    {
        0x0001225E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225E,
        0x0001225E,
        0x0001225E
    };

    static _CharacterInfo _character0001225F =
    {
        0x0001225F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001225F,
        0x0001225F,
        0x0001225F
    };

    static _CharacterInfo _character00012260 =
    {
        0x00012260,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012260,
        0x00012260,
        0x00012260
    };

    static _CharacterInfo _character00012261 =
    {
        0x00012261,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012261,
        0x00012261,
        0x00012261
    };

    static _CharacterInfo _character00012262 =
    {
        0x00012262,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012262,
        0x00012262,
        0x00012262
    };

    static _CharacterInfo _character00012263 =
    {
        0x00012263,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012263,
        0x00012263,
        0x00012263
    };

    static _CharacterInfo _character00012264 =
    {
        0x00012264,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012264,
        0x00012264,
        0x00012264
    };

    static _CharacterInfo _character00012265 =
    {
        0x00012265,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012265,
        0x00012265,
        0x00012265
    };

    static _CharacterInfo _character00012266 =
    {
        0x00012266,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012266,
        0x00012266,
        0x00012266
    };

    static _CharacterInfo _character00012267 =
    {
        0x00012267,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012267,
        0x00012267,
        0x00012267
    };

    static _CharacterInfo _character00012268 =
    {
        0x00012268,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012268,
        0x00012268,
        0x00012268
    };

    static _CharacterInfo _character00012269 =
    {
        0x00012269,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012269,
        0x00012269,
        0x00012269
    };

    static _CharacterInfo _character0001226A =
    {
        0x0001226A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226A,
        0x0001226A,
        0x0001226A
    };

    static _CharacterInfo _character0001226B =
    {
        0x0001226B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226B,
        0x0001226B,
        0x0001226B
    };

    static _CharacterInfo _character0001226C =
    {
        0x0001226C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226C,
        0x0001226C,
        0x0001226C
    };

    static _CharacterInfo _character0001226D =
    {
        0x0001226D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226D,
        0x0001226D,
        0x0001226D
    };

    static _CharacterInfo _character0001226E =
    {
        0x0001226E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226E,
        0x0001226E,
        0x0001226E
    };

    static _CharacterInfo _character0001226F =
    {
        0x0001226F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001226F,
        0x0001226F,
        0x0001226F
    };

    static _CharacterInfo _character00012270 =
    {
        0x00012270,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012270,
        0x00012270,
        0x00012270
    };

    static _CharacterInfo _character00012271 =
    {
        0x00012271,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012271,
        0x00012271,
        0x00012271
    };

    static _CharacterInfo _character00012272 =
    {
        0x00012272,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012272,
        0x00012272,
        0x00012272
    };

    static _CharacterInfo _character00012273 =
    {
        0x00012273,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012273,
        0x00012273,
        0x00012273
    };

    static _CharacterInfo _character00012274 =
    {
        0x00012274,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012274,
        0x00012274,
        0x00012274
    };

    static _CharacterInfo _character00012275 =
    {
        0x00012275,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012275,
        0x00012275,
        0x00012275
    };

    static _CharacterInfo _character00012276 =
    {
        0x00012276,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012276,
        0x00012276,
        0x00012276
    };

    static _CharacterInfo _character00012277 =
    {
        0x00012277,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012277,
        0x00012277,
        0x00012277
    };

    static _CharacterInfo _character00012278 =
    {
        0x00012278,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012278,
        0x00012278,
        0x00012278
    };

    static _CharacterInfo _character00012279 =
    {
        0x00012279,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012279,
        0x00012279,
        0x00012279
    };

    static _CharacterInfo _character0001227A =
    {
        0x0001227A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227A,
        0x0001227A,
        0x0001227A
    };

    static _CharacterInfo _character0001227B =
    {
        0x0001227B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227B,
        0x0001227B,
        0x0001227B
    };

    static _CharacterInfo _character0001227C =
    {
        0x0001227C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227C,
        0x0001227C,
        0x0001227C
    };

    static _CharacterInfo _character0001227D =
    {
        0x0001227D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227D,
        0x0001227D,
        0x0001227D
    };

    static _CharacterInfo _character0001227E =
    {
        0x0001227E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227E,
        0x0001227E,
        0x0001227E
    };

    static _CharacterInfo _character0001227F =
    {
        0x0001227F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001227F,
        0x0001227F,
        0x0001227F
    };

    static _CharacterInfo _character00012280 =
    {
        0x00012280,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012280,
        0x00012280,
        0x00012280
    };

    static _CharacterInfo _character00012281 =
    {
        0x00012281,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012281,
        0x00012281,
        0x00012281
    };

    static _CharacterInfo _character00012282 =
    {
        0x00012282,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012282,
        0x00012282,
        0x00012282
    };

    static _CharacterInfo _character00012283 =
    {
        0x00012283,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012283,
        0x00012283,
        0x00012283
    };

    static _CharacterInfo _character00012284 =
    {
        0x00012284,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012284,
        0x00012284,
        0x00012284
    };

    static _CharacterInfo _character00012285 =
    {
        0x00012285,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012285,
        0x00012285,
        0x00012285
    };

    static _CharacterInfo _character00012286 =
    {
        0x00012286,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012286,
        0x00012286,
        0x00012286
    };

    static _CharacterInfo _character00012287 =
    {
        0x00012287,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012287,
        0x00012287,
        0x00012287
    };

    static _CharacterInfo _character00012288 =
    {
        0x00012288,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012288,
        0x00012288,
        0x00012288
    };

    static _CharacterInfo _character00012289 =
    {
        0x00012289,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012289,
        0x00012289,
        0x00012289
    };

    static _CharacterInfo _character0001228A =
    {
        0x0001228A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228A,
        0x0001228A,
        0x0001228A
    };

    static _CharacterInfo _character0001228B =
    {
        0x0001228B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228B,
        0x0001228B,
        0x0001228B
    };

    static _CharacterInfo _character0001228C =
    {
        0x0001228C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228C,
        0x0001228C,
        0x0001228C
    };

    static _CharacterInfo _character0001228D =
    {
        0x0001228D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228D,
        0x0001228D,
        0x0001228D
    };

    static _CharacterInfo _character0001228E =
    {
        0x0001228E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228E,
        0x0001228E,
        0x0001228E
    };

    static _CharacterInfo _character0001228F =
    {
        0x0001228F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001228F,
        0x0001228F,
        0x0001228F
    };

    static _CharacterInfo _character00012290 =
    {
        0x00012290,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012290,
        0x00012290,
        0x00012290
    };

    static _CharacterInfo _character00012291 =
    {
        0x00012291,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012291,
        0x00012291,
        0x00012291
    };

    static _CharacterInfo _character00012292 =
    {
        0x00012292,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012292,
        0x00012292,
        0x00012292
    };

    static _CharacterInfo _character00012293 =
    {
        0x00012293,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012293,
        0x00012293,
        0x00012293
    };

    static _CharacterInfo _character00012294 =
    {
        0x00012294,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012294,
        0x00012294,
        0x00012294
    };

    static _CharacterInfo _character00012295 =
    {
        0x00012295,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012295,
        0x00012295,
        0x00012295
    };

    static _CharacterInfo _character00012296 =
    {
        0x00012296,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012296,
        0x00012296,
        0x00012296
    };

    static _CharacterInfo _character00012297 =
    {
        0x00012297,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012297,
        0x00012297,
        0x00012297
    };

    static _CharacterInfo _character00012298 =
    {
        0x00012298,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012298,
        0x00012298,
        0x00012298
    };

    static _CharacterInfo _character00012299 =
    {
        0x00012299,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012299,
        0x00012299,
        0x00012299
    };

    static _CharacterInfo _character0001229A =
    {
        0x0001229A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229A,
        0x0001229A,
        0x0001229A
    };

    static _CharacterInfo _character0001229B =
    {
        0x0001229B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229B,
        0x0001229B,
        0x0001229B
    };

    static _CharacterInfo _character0001229C =
    {
        0x0001229C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229C,
        0x0001229C,
        0x0001229C
    };

    static _CharacterInfo _character0001229D =
    {
        0x0001229D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229D,
        0x0001229D,
        0x0001229D
    };

    static _CharacterInfo _character0001229E =
    {
        0x0001229E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229E,
        0x0001229E,
        0x0001229E
    };

    static _CharacterInfo _character0001229F =
    {
        0x0001229F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001229F,
        0x0001229F,
        0x0001229F
    };

    static _CharacterInfo _character000122A0 =
    {
        0x000122A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A0,
        0x000122A0,
        0x000122A0
    };

    static _CharacterInfo _character000122A1 =
    {
        0x000122A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A1,
        0x000122A1,
        0x000122A1
    };

    static _CharacterInfo _character000122A2 =
    {
        0x000122A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A2,
        0x000122A2,
        0x000122A2
    };

    static _CharacterInfo _character000122A3 =
    {
        0x000122A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A3,
        0x000122A3,
        0x000122A3
    };

    static _CharacterInfo _character000122A4 =
    {
        0x000122A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A4,
        0x000122A4,
        0x000122A4
    };

    static _CharacterInfo _character000122A5 =
    {
        0x000122A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A5,
        0x000122A5,
        0x000122A5
    };

    static _CharacterInfo _character000122A6 =
    {
        0x000122A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A6,
        0x000122A6,
        0x000122A6
    };

    static _CharacterInfo _character000122A7 =
    {
        0x000122A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A7,
        0x000122A7,
        0x000122A7
    };

    static _CharacterInfo _character000122A8 =
    {
        0x000122A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A8,
        0x000122A8,
        0x000122A8
    };

    static _CharacterInfo _character000122A9 =
    {
        0x000122A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122A9,
        0x000122A9,
        0x000122A9
    };

    static _CharacterInfo _character000122AA =
    {
        0x000122AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AA,
        0x000122AA,
        0x000122AA
    };

    static _CharacterInfo _character000122AB =
    {
        0x000122AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AB,
        0x000122AB,
        0x000122AB
    };

    static _CharacterInfo _character000122AC =
    {
        0x000122AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AC,
        0x000122AC,
        0x000122AC
    };

    static _CharacterInfo _character000122AD =
    {
        0x000122AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AD,
        0x000122AD,
        0x000122AD
    };

    static _CharacterInfo _character000122AE =
    {
        0x000122AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AE,
        0x000122AE,
        0x000122AE
    };

    static _CharacterInfo _character000122AF =
    {
        0x000122AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122AF,
        0x000122AF,
        0x000122AF
    };

    static _CharacterInfo _character000122B0 =
    {
        0x000122B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B0,
        0x000122B0,
        0x000122B0
    };

    static _CharacterInfo _character000122B1 =
    {
        0x000122B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B1,
        0x000122B1,
        0x000122B1
    };

    static _CharacterInfo _character000122B2 =
    {
        0x000122B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B2,
        0x000122B2,
        0x000122B2
    };

    static _CharacterInfo _character000122B3 =
    {
        0x000122B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B3,
        0x000122B3,
        0x000122B3
    };

    static _CharacterInfo _character000122B4 =
    {
        0x000122B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B4,
        0x000122B4,
        0x000122B4
    };

    static _CharacterInfo _character000122B5 =
    {
        0x000122B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B5,
        0x000122B5,
        0x000122B5
    };

    static _CharacterInfo _character000122B6 =
    {
        0x000122B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B6,
        0x000122B6,
        0x000122B6
    };

    static _CharacterInfo _character000122B7 =
    {
        0x000122B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B7,
        0x000122B7,
        0x000122B7
    };

    static _CharacterInfo _character000122B8 =
    {
        0x000122B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B8,
        0x000122B8,
        0x000122B8
    };

    static _CharacterInfo _character000122B9 =
    {
        0x000122B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122B9,
        0x000122B9,
        0x000122B9
    };

    static _CharacterInfo _character000122BA =
    {
        0x000122BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BA,
        0x000122BA,
        0x000122BA
    };

    static _CharacterInfo _character000122BB =
    {
        0x000122BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BB,
        0x000122BB,
        0x000122BB
    };

    static _CharacterInfo _character000122BC =
    {
        0x000122BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BC,
        0x000122BC,
        0x000122BC
    };

    static _CharacterInfo _character000122BD =
    {
        0x000122BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BD,
        0x000122BD,
        0x000122BD
    };

    static _CharacterInfo _character000122BE =
    {
        0x000122BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BE,
        0x000122BE,
        0x000122BE
    };

    static _CharacterInfo _character000122BF =
    {
        0x000122BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122BF,
        0x000122BF,
        0x000122BF
    };

    static _CharacterInfo _character000122C0 =
    {
        0x000122C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C0,
        0x000122C0,
        0x000122C0
    };

    static _CharacterInfo _character000122C1 =
    {
        0x000122C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C1,
        0x000122C1,
        0x000122C1
    };

    static _CharacterInfo _character000122C2 =
    {
        0x000122C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C2,
        0x000122C2,
        0x000122C2
    };

    static _CharacterInfo _character000122C3 =
    {
        0x000122C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C3,
        0x000122C3,
        0x000122C3
    };

    static _CharacterInfo _character000122C4 =
    {
        0x000122C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C4,
        0x000122C4,
        0x000122C4
    };

    static _CharacterInfo _character000122C5 =
    {
        0x000122C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C5,
        0x000122C5,
        0x000122C5
    };

    static _CharacterInfo _character000122C6 =
    {
        0x000122C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C6,
        0x000122C6,
        0x000122C6
    };

    static _CharacterInfo _character000122C7 =
    {
        0x000122C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C7,
        0x000122C7,
        0x000122C7
    };

    static _CharacterInfo _character000122C8 =
    {
        0x000122C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C8,
        0x000122C8,
        0x000122C8
    };

    static _CharacterInfo _character000122C9 =
    {
        0x000122C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122C9,
        0x000122C9,
        0x000122C9
    };

    static _CharacterInfo _character000122CA =
    {
        0x000122CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CA,
        0x000122CA,
        0x000122CA
    };

    static _CharacterInfo _character000122CB =
    {
        0x000122CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CB,
        0x000122CB,
        0x000122CB
    };

    static _CharacterInfo _character000122CC =
    {
        0x000122CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CC,
        0x000122CC,
        0x000122CC
    };

    static _CharacterInfo _character000122CD =
    {
        0x000122CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CD,
        0x000122CD,
        0x000122CD
    };

    static _CharacterInfo _character000122CE =
    {
        0x000122CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CE,
        0x000122CE,
        0x000122CE
    };

    static _CharacterInfo _character000122CF =
    {
        0x000122CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122CF,
        0x000122CF,
        0x000122CF
    };

    static _CharacterInfo _character000122D0 =
    {
        0x000122D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D0,
        0x000122D0,
        0x000122D0
    };

    static _CharacterInfo _character000122D1 =
    {
        0x000122D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D1,
        0x000122D1,
        0x000122D1
    };

    static _CharacterInfo _character000122D2 =
    {
        0x000122D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D2,
        0x000122D2,
        0x000122D2
    };

    static _CharacterInfo _character000122D3 =
    {
        0x000122D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D3,
        0x000122D3,
        0x000122D3
    };

    static _CharacterInfo _character000122D4 =
    {
        0x000122D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D4,
        0x000122D4,
        0x000122D4
    };

    static _CharacterInfo _character000122D5 =
    {
        0x000122D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D5,
        0x000122D5,
        0x000122D5
    };

    static _CharacterInfo _character000122D6 =
    {
        0x000122D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D6,
        0x000122D6,
        0x000122D6
    };

    static _CharacterInfo _character000122D7 =
    {
        0x000122D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D7,
        0x000122D7,
        0x000122D7
    };

    static _CharacterInfo _character000122D8 =
    {
        0x000122D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D8,
        0x000122D8,
        0x000122D8
    };

    static _CharacterInfo _character000122D9 =
    {
        0x000122D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122D9,
        0x000122D9,
        0x000122D9
    };

    static _CharacterInfo _character000122DA =
    {
        0x000122DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DA,
        0x000122DA,
        0x000122DA
    };

    static _CharacterInfo _character000122DB =
    {
        0x000122DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DB,
        0x000122DB,
        0x000122DB
    };

    static _CharacterInfo _character000122DC =
    {
        0x000122DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DC,
        0x000122DC,
        0x000122DC
    };

    static _CharacterInfo _character000122DD =
    {
        0x000122DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DD,
        0x000122DD,
        0x000122DD
    };

    static _CharacterInfo _character000122DE =
    {
        0x000122DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DE,
        0x000122DE,
        0x000122DE
    };

    static _CharacterInfo _character000122DF =
    {
        0x000122DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122DF,
        0x000122DF,
        0x000122DF
    };

    static _CharacterInfo _character000122E0 =
    {
        0x000122E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E0,
        0x000122E0,
        0x000122E0
    };

    static _CharacterInfo _character000122E1 =
    {
        0x000122E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E1,
        0x000122E1,
        0x000122E1
    };

    static _CharacterInfo _character000122E2 =
    {
        0x000122E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E2,
        0x000122E2,
        0x000122E2
    };

    static _CharacterInfo _character000122E3 =
    {
        0x000122E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E3,
        0x000122E3,
        0x000122E3
    };

    static _CharacterInfo _character000122E4 =
    {
        0x000122E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E4,
        0x000122E4,
        0x000122E4
    };

    static _CharacterInfo _character000122E5 =
    {
        0x000122E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E5,
        0x000122E5,
        0x000122E5
    };

    static _CharacterInfo _character000122E6 =
    {
        0x000122E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E6,
        0x000122E6,
        0x000122E6
    };

    static _CharacterInfo _character000122E7 =
    {
        0x000122E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E7,
        0x000122E7,
        0x000122E7
    };

    static _CharacterInfo _character000122E8 =
    {
        0x000122E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E8,
        0x000122E8,
        0x000122E8
    };

    static _CharacterInfo _character000122E9 =
    {
        0x000122E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122E9,
        0x000122E9,
        0x000122E9
    };

    static _CharacterInfo _character000122EA =
    {
        0x000122EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122EA,
        0x000122EA,
        0x000122EA
    };

    static _CharacterInfo _character000122EB =
    {
        0x000122EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122EB,
        0x000122EB,
        0x000122EB
    };

    static _CharacterInfo _character000122EC =
    {
        0x000122EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122EC,
        0x000122EC,
        0x000122EC
    };

    static _CharacterInfo _character000122ED =
    {
        0x000122ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122ED,
        0x000122ED,
        0x000122ED
    };

    static _CharacterInfo _character000122EE =
    {
        0x000122EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122EE,
        0x000122EE,
        0x000122EE
    };

    static _CharacterInfo _character000122EF =
    {
        0x000122EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122EF,
        0x000122EF,
        0x000122EF
    };

    static _CharacterInfo _character000122F0 =
    {
        0x000122F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F0,
        0x000122F0,
        0x000122F0
    };

    static _CharacterInfo _character000122F1 =
    {
        0x000122F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F1,
        0x000122F1,
        0x000122F1
    };

    static _CharacterInfo _character000122F2 =
    {
        0x000122F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F2,
        0x000122F2,
        0x000122F2
    };

    static _CharacterInfo _character000122F3 =
    {
        0x000122F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F3,
        0x000122F3,
        0x000122F3
    };

    static _CharacterInfo _character000122F4 =
    {
        0x000122F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F4,
        0x000122F4,
        0x000122F4
    };

    static _CharacterInfo _character000122F5 =
    {
        0x000122F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F5,
        0x000122F5,
        0x000122F5
    };

    static _CharacterInfo _character000122F6 =
    {
        0x000122F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F6,
        0x000122F6,
        0x000122F6
    };

    static _CharacterInfo _character000122F7 =
    {
        0x000122F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F7,
        0x000122F7,
        0x000122F7
    };

    static _CharacterInfo _character000122F8 =
    {
        0x000122F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F8,
        0x000122F8,
        0x000122F8
    };

    static _CharacterInfo _character000122F9 =
    {
        0x000122F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122F9,
        0x000122F9,
        0x000122F9
    };

    static _CharacterInfo _character000122FA =
    {
        0x000122FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FA,
        0x000122FA,
        0x000122FA
    };

    static _CharacterInfo _character000122FB =
    {
        0x000122FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FB,
        0x000122FB,
        0x000122FB
    };

    static _CharacterInfo _character000122FC =
    {
        0x000122FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FC,
        0x000122FC,
        0x000122FC
    };

    static _CharacterInfo _character000122FD =
    {
        0x000122FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FD,
        0x000122FD,
        0x000122FD
    };

    static _CharacterInfo _character000122FE =
    {
        0x000122FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FE,
        0x000122FE,
        0x000122FE
    };

    static _CharacterInfo _character000122FF =
    {
        0x000122FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000122FF,
        0x000122FF,
        0x000122FF
    };

    static _CharacterInfo _character00012300 =
    {
        0x00012300,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012300,
        0x00012300,
        0x00012300
    };

    static _CharacterInfo _character00012301 =
    {
        0x00012301,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012301,
        0x00012301,
        0x00012301
    };

    static _CharacterInfo _character00012302 =
    {
        0x00012302,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012302,
        0x00012302,
        0x00012302
    };

    static _CharacterInfo _character00012303 =
    {
        0x00012303,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012303,
        0x00012303,
        0x00012303
    };

    static _CharacterInfo _character00012304 =
    {
        0x00012304,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012304,
        0x00012304,
        0x00012304
    };

    static _CharacterInfo _character00012305 =
    {
        0x00012305,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012305,
        0x00012305,
        0x00012305
    };

    static _CharacterInfo _character00012306 =
    {
        0x00012306,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012306,
        0x00012306,
        0x00012306
    };

    static _CharacterInfo _character00012307 =
    {
        0x00012307,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012307,
        0x00012307,
        0x00012307
    };

    static _CharacterInfo _character00012308 =
    {
        0x00012308,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012308,
        0x00012308,
        0x00012308
    };

    static _CharacterInfo _character00012309 =
    {
        0x00012309,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012309,
        0x00012309,
        0x00012309
    };

    static _CharacterInfo _character0001230A =
    {
        0x0001230A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230A,
        0x0001230A,
        0x0001230A
    };

    static _CharacterInfo _character0001230B =
    {
        0x0001230B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230B,
        0x0001230B,
        0x0001230B
    };

    static _CharacterInfo _character0001230C =
    {
        0x0001230C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230C,
        0x0001230C,
        0x0001230C
    };

    static _CharacterInfo _character0001230D =
    {
        0x0001230D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230D,
        0x0001230D,
        0x0001230D
    };

    static _CharacterInfo _character0001230E =
    {
        0x0001230E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230E,
        0x0001230E,
        0x0001230E
    };

    static _CharacterInfo _character0001230F =
    {
        0x0001230F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001230F,
        0x0001230F,
        0x0001230F
    };

    static _CharacterInfo _character00012310 =
    {
        0x00012310,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012310,
        0x00012310,
        0x00012310
    };

    static _CharacterInfo _character00012311 =
    {
        0x00012311,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012311,
        0x00012311,
        0x00012311
    };

    static _CharacterInfo _character00012312 =
    {
        0x00012312,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012312,
        0x00012312,
        0x00012312
    };

    static _CharacterInfo _character00012313 =
    {
        0x00012313,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012313,
        0x00012313,
        0x00012313
    };

    static _CharacterInfo _character00012314 =
    {
        0x00012314,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012314,
        0x00012314,
        0x00012314
    };

    static _CharacterInfo _character00012315 =
    {
        0x00012315,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012315,
        0x00012315,
        0x00012315
    };

    static _CharacterInfo _character00012316 =
    {
        0x00012316,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012316,
        0x00012316,
        0x00012316
    };

    static _CharacterInfo _character00012317 =
    {
        0x00012317,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012317,
        0x00012317,
        0x00012317
    };

    static _CharacterInfo _character00012318 =
    {
        0x00012318,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012318,
        0x00012318,
        0x00012318
    };

    static _CharacterInfo _character00012319 =
    {
        0x00012319,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012319,
        0x00012319,
        0x00012319
    };

    static _CharacterInfo _character0001231A =
    {
        0x0001231A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231A,
        0x0001231A,
        0x0001231A
    };

    static _CharacterInfo _character0001231B =
    {
        0x0001231B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231B,
        0x0001231B,
        0x0001231B
    };

    static _CharacterInfo _character0001231C =
    {
        0x0001231C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231C,
        0x0001231C,
        0x0001231C
    };

    static _CharacterInfo _character0001231D =
    {
        0x0001231D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231D,
        0x0001231D,
        0x0001231D
    };

    static _CharacterInfo _character0001231E =
    {
        0x0001231E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231E,
        0x0001231E,
        0x0001231E
    };

    static _CharacterInfo _character0001231F =
    {
        0x0001231F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001231F,
        0x0001231F,
        0x0001231F
    };

    static _CharacterInfo _character00012320 =
    {
        0x00012320,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012320,
        0x00012320,
        0x00012320
    };

    static _CharacterInfo _character00012321 =
    {
        0x00012321,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012321,
        0x00012321,
        0x00012321
    };

    static _CharacterInfo _character00012322 =
    {
        0x00012322,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012322,
        0x00012322,
        0x00012322
    };

    static _CharacterInfo _character00012323 =
    {
        0x00012323,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012323,
        0x00012323,
        0x00012323
    };

    static _CharacterInfo _character00012324 =
    {
        0x00012324,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012324,
        0x00012324,
        0x00012324
    };

    static _CharacterInfo _character00012325 =
    {
        0x00012325,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012325,
        0x00012325,
        0x00012325
    };

    static _CharacterInfo _character00012326 =
    {
        0x00012326,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012326,
        0x00012326,
        0x00012326
    };

    static _CharacterInfo _character00012327 =
    {
        0x00012327,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012327,
        0x00012327,
        0x00012327
    };

    static _CharacterInfo _character00012328 =
    {
        0x00012328,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012328,
        0x00012328,
        0x00012328
    };

    static _CharacterInfo _character00012329 =
    {
        0x00012329,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012329,
        0x00012329,
        0x00012329
    };

    static _CharacterInfo _character0001232A =
    {
        0x0001232A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232A,
        0x0001232A,
        0x0001232A
    };

    static _CharacterInfo _character0001232B =
    {
        0x0001232B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232B,
        0x0001232B,
        0x0001232B
    };

    static _CharacterInfo _character0001232C =
    {
        0x0001232C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232C,
        0x0001232C,
        0x0001232C
    };

    static _CharacterInfo _character0001232D =
    {
        0x0001232D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232D,
        0x0001232D,
        0x0001232D
    };

    static _CharacterInfo _character0001232E =
    {
        0x0001232E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232E,
        0x0001232E,
        0x0001232E
    };

    static _CharacterInfo _character0001232F =
    {
        0x0001232F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001232F,
        0x0001232F,
        0x0001232F
    };

    static _CharacterInfo _character00012330 =
    {
        0x00012330,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012330,
        0x00012330,
        0x00012330
    };

    static _CharacterInfo _character00012331 =
    {
        0x00012331,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012331,
        0x00012331,
        0x00012331
    };

    static _CharacterInfo _character00012332 =
    {
        0x00012332,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012332,
        0x00012332,
        0x00012332
    };

    static _CharacterInfo _character00012333 =
    {
        0x00012333,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012333,
        0x00012333,
        0x00012333
    };

    static _CharacterInfo _character00012334 =
    {
        0x00012334,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012334,
        0x00012334,
        0x00012334
    };

    static _CharacterInfo _character00012335 =
    {
        0x00012335,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012335,
        0x00012335,
        0x00012335
    };

    static _CharacterInfo _character00012336 =
    {
        0x00012336,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012336,
        0x00012336,
        0x00012336
    };

    static _CharacterInfo _character00012337 =
    {
        0x00012337,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012337,
        0x00012337,
        0x00012337
    };

    static _CharacterInfo _character00012338 =
    {
        0x00012338,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012338,
        0x00012338,
        0x00012338
    };

    static _CharacterInfo _character00012339 =
    {
        0x00012339,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012339,
        0x00012339,
        0x00012339
    };

    static _CharacterInfo _character0001233A =
    {
        0x0001233A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233A,
        0x0001233A,
        0x0001233A
    };

    static _CharacterInfo _character0001233B =
    {
        0x0001233B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233B,
        0x0001233B,
        0x0001233B
    };

    static _CharacterInfo _character0001233C =
    {
        0x0001233C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233C,
        0x0001233C,
        0x0001233C
    };

    static _CharacterInfo _character0001233D =
    {
        0x0001233D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233D,
        0x0001233D,
        0x0001233D
    };

    static _CharacterInfo _character0001233E =
    {
        0x0001233E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233E,
        0x0001233E,
        0x0001233E
    };

    static _CharacterInfo _character0001233F =
    {
        0x0001233F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001233F,
        0x0001233F,
        0x0001233F
    };

    static _CharacterInfo _character00012340 =
    {
        0x00012340,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012340,
        0x00012340,
        0x00012340
    };

    static _CharacterInfo _character00012341 =
    {
        0x00012341,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012341,
        0x00012341,
        0x00012341
    };

    static _CharacterInfo _character00012342 =
    {
        0x00012342,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012342,
        0x00012342,
        0x00012342
    };

    static _CharacterInfo _character00012343 =
    {
        0x00012343,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012343,
        0x00012343,
        0x00012343
    };

    static _CharacterInfo _character00012344 =
    {
        0x00012344,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012344,
        0x00012344,
        0x00012344
    };

    static _CharacterInfo _character00012345 =
    {
        0x00012345,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012345,
        0x00012345,
        0x00012345
    };

    static _CharacterInfo _character00012346 =
    {
        0x00012346,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012346,
        0x00012346,
        0x00012346
    };

    static _CharacterInfo _character00012347 =
    {
        0x00012347,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012347,
        0x00012347,
        0x00012347
    };

    static _CharacterInfo _character00012348 =
    {
        0x00012348,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012348,
        0x00012348,
        0x00012348
    };

    static _CharacterInfo _character00012349 =
    {
        0x00012349,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012349,
        0x00012349,
        0x00012349
    };

    static _CharacterInfo _character0001234A =
    {
        0x0001234A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234A,
        0x0001234A,
        0x0001234A
    };

    static _CharacterInfo _character0001234B =
    {
        0x0001234B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234B,
        0x0001234B,
        0x0001234B
    };

    static _CharacterInfo _character0001234C =
    {
        0x0001234C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234C,
        0x0001234C,
        0x0001234C
    };

    static _CharacterInfo _character0001234D =
    {
        0x0001234D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234D,
        0x0001234D,
        0x0001234D
    };

    static _CharacterInfo _character0001234E =
    {
        0x0001234E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234E,
        0x0001234E,
        0x0001234E
    };

    static _CharacterInfo _character0001234F =
    {
        0x0001234F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001234F,
        0x0001234F,
        0x0001234F
    };

    static _CharacterInfo _character00012350 =
    {
        0x00012350,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012350,
        0x00012350,
        0x00012350
    };

    static _CharacterInfo _character00012351 =
    {
        0x00012351,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012351,
        0x00012351,
        0x00012351
    };

    static _CharacterInfo _character00012352 =
    {
        0x00012352,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012352,
        0x00012352,
        0x00012352
    };

    static _CharacterInfo _character00012353 =
    {
        0x00012353,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012353,
        0x00012353,
        0x00012353
    };

    static _CharacterInfo _character00012354 =
    {
        0x00012354,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012354,
        0x00012354,
        0x00012354
    };

    static _CharacterInfo _character00012355 =
    {
        0x00012355,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012355,
        0x00012355,
        0x00012355
    };

    static _CharacterInfo _character00012356 =
    {
        0x00012356,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012356,
        0x00012356,
        0x00012356
    };

    static _CharacterInfo _character00012357 =
    {
        0x00012357,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012357,
        0x00012357,
        0x00012357
    };

    static _CharacterInfo _character00012358 =
    {
        0x00012358,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012358,
        0x00012358,
        0x00012358
    };

    static _CharacterInfo _character00012359 =
    {
        0x00012359,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012359,
        0x00012359,
        0x00012359
    };

    static _CharacterInfo _character0001235A =
    {
        0x0001235A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235A,
        0x0001235A,
        0x0001235A
    };

    static _CharacterInfo _character0001235B =
    {
        0x0001235B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235B,
        0x0001235B,
        0x0001235B
    };

    static _CharacterInfo _character0001235C =
    {
        0x0001235C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235C,
        0x0001235C,
        0x0001235C
    };

    static _CharacterInfo _character0001235D =
    {
        0x0001235D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235D,
        0x0001235D,
        0x0001235D
    };

    static _CharacterInfo _character0001235E =
    {
        0x0001235E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235E,
        0x0001235E,
        0x0001235E
    };

    static _CharacterInfo _character0001235F =
    {
        0x0001235F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001235F,
        0x0001235F,
        0x0001235F
    };

    static _CharacterInfo _character00012360 =
    {
        0x00012360,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012360,
        0x00012360,
        0x00012360
    };

    static _CharacterInfo _character00012361 =
    {
        0x00012361,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012361,
        0x00012361,
        0x00012361
    };

    static _CharacterInfo _character00012362 =
    {
        0x00012362,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012362,
        0x00012362,
        0x00012362
    };

    static _CharacterInfo _character00012363 =
    {
        0x00012363,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012363,
        0x00012363,
        0x00012363
    };

    static _CharacterInfo _character00012364 =
    {
        0x00012364,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012364,
        0x00012364,
        0x00012364
    };

    static _CharacterInfo _character00012365 =
    {
        0x00012365,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012365,
        0x00012365,
        0x00012365
    };

    static _CharacterInfo _character00012366 =
    {
        0x00012366,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012366,
        0x00012366,
        0x00012366
    };

    static _CharacterInfo _character00012367 =
    {
        0x00012367,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012367,
        0x00012367,
        0x00012367
    };

    static _CharacterInfo _character00012368 =
    {
        0x00012368,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012368,
        0x00012368,
        0x00012368
    };

    static _CharacterInfo _character00012369 =
    {
        0x00012369,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012369,
        0x00012369,
        0x00012369
    };

    static _CharacterInfo _character0001236A =
    {
        0x0001236A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001236A,
        0x0001236A,
        0x0001236A
    };

    static _CharacterInfo _character0001236B =
    {
        0x0001236B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001236B,
        0x0001236B,
        0x0001236B
    };

    static _CharacterInfo _character0001236C =
    {
        0x0001236C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001236C,
        0x0001236C,
        0x0001236C
    };

    static _CharacterInfo _character0001236D =
    {
        0x0001236D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001236D,
        0x0001236D,
        0x0001236D
    };

    static _CharacterInfo _character0001236E =
    {
        0x0001236E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001236E,
        0x0001236E,
        0x0001236E
    };

    static _CharacterInfo _character00012400 =
    {
        0x00012400,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012400,
        0x00012400,
        0x00012400
    };

    static _CharacterInfo _character00012401 =
    {
        0x00012401,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012401,
        0x00012401,
        0x00012401
    };

    static _CharacterInfo _character00012402 =
    {
        0x00012402,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012402,
        0x00012402,
        0x00012402
    };

    static _CharacterInfo _character00012403 =
    {
        0x00012403,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012403,
        0x00012403,
        0x00012403
    };

    static _CharacterInfo _character00012404 =
    {
        0x00012404,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00012404,
        0x00012404,
        0x00012404
    };

    static _CharacterInfo _character00012405 =
    {
        0x00012405,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012405,
        0x00012405,
        0x00012405
    };

    static _CharacterInfo _character00012406 =
    {
        0x00012406,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00012406,
        0x00012406,
        0x00012406
    };

    static _CharacterInfo _character00012407 =
    {
        0x00012407,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012407,
        0x00012407,
        0x00012407
    };

    static _CharacterInfo _character00012408 =
    {
        0x00012408,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012408,
        0x00012408,
        0x00012408
    };

    static _CharacterInfo _character00012409 =
    {
        0x00012409,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012409,
        0x00012409,
        0x00012409
    };

    static _CharacterInfo _character0001240A =
    {
        0x0001240A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001240A,
        0x0001240A,
        0x0001240A
    };

    static _CharacterInfo _character0001240B =
    {
        0x0001240B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x0001240B,
        0x0001240B,
        0x0001240B
    };

    static _CharacterInfo _character0001240C =
    {
        0x0001240C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x0001240C,
        0x0001240C,
        0x0001240C
    };

    static _CharacterInfo _character0001240D =
    {
        0x0001240D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x0001240D,
        0x0001240D,
        0x0001240D
    };

    static _CharacterInfo _character0001240E =
    {
        0x0001240E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x0001240E,
        0x0001240E,
        0x0001240E
    };

    static _CharacterInfo _character0001240F =
    {
        0x0001240F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001240F,
        0x0001240F,
        0x0001240F
    };

    static _CharacterInfo _character00012410 =
    {
        0x00012410,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012410,
        0x00012410,
        0x00012410
    };

    static _CharacterInfo _character00012411 =
    {
        0x00012411,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00012411,
        0x00012411,
        0x00012411
    };

    static _CharacterInfo _character00012412 =
    {
        0x00012412,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012412,
        0x00012412,
        0x00012412
    };

    static _CharacterInfo _character00012413 =
    {
        0x00012413,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00012413,
        0x00012413,
        0x00012413
    };

    static _CharacterInfo _character00012414 =
    {
        0x00012414,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012414,
        0x00012414,
        0x00012414
    };

    static _CharacterInfo _character00012415 =
    {
        0x00012415,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00012415,
        0x00012415,
        0x00012415
    };

    static _CharacterInfo _character00012416 =
    {
        0x00012416,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012416,
        0x00012416,
        0x00012416
    };

    static _CharacterInfo _character00012417 =
    {
        0x00012417,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012417,
        0x00012417,
        0x00012417
    };

    static _CharacterInfo _character00012418 =
    {
        0x00012418,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012418,
        0x00012418,
        0x00012418
    };

    static _CharacterInfo _character00012419 =
    {
        0x00012419,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012419,
        0x00012419,
        0x00012419
    };

    static _CharacterInfo _character0001241A =
    {
        0x0001241A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x0001241A,
        0x0001241A,
        0x0001241A
    };

    static _CharacterInfo _character0001241B =
    {
        0x0001241B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x0001241B,
        0x0001241B,
        0x0001241B
    };

    static _CharacterInfo _character0001241C =
    {
        0x0001241C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x0001241C,
        0x0001241C,
        0x0001241C
    };

    static _CharacterInfo _character0001241D =
    {
        0x0001241D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x0001241D,
        0x0001241D,
        0x0001241D
    };

    static _CharacterInfo _character0001241E =
    {
        0x0001241E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0001241E,
        0x0001241E,
        0x0001241E
    };

    static _CharacterInfo _character0001241F =
    {
        0x0001241F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001241F,
        0x0001241F,
        0x0001241F
    };

    static _CharacterInfo _character00012420 =
    {
        0x00012420,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012420,
        0x00012420,
        0x00012420
    };

    static _CharacterInfo _character00012421 =
    {
        0x00012421,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012421,
        0x00012421,
        0x00012421
    };

    static _CharacterInfo _character00012422 =
    {
        0x00012422,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012422,
        0x00012422,
        0x00012422
    };

    static _CharacterInfo _character00012423 =
    {
        0x00012423,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012423,
        0x00012423,
        0x00012423
    };

    static _CharacterInfo _character00012424 =
    {
        0x00012424,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012424,
        0x00012424,
        0x00012424
    };

    static _CharacterInfo _character00012425 =
    {
        0x00012425,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012425,
        0x00012425,
        0x00012425
    };

    static _CharacterInfo _character00012426 =
    {
        0x00012426,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012426,
        0x00012426,
        0x00012426
    };

    static _CharacterInfo _character00012427 =
    {
        0x00012427,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012427,
        0x00012427,
        0x00012427
    };

    static _CharacterInfo _character00012428 =
    {
        0x00012428,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00012428,
        0x00012428,
        0x00012428
    };

    static _CharacterInfo _character00012429 =
    {
        0x00012429,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012429,
        0x00012429,
        0x00012429
    };

    static _CharacterInfo _character0001242A =
    {
        0x0001242A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x0001242A,
        0x0001242A,
        0x0001242A
    };

    static _CharacterInfo _character0001242B =
    {
        0x0001242B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x0001242B,
        0x0001242B,
        0x0001242B
    };

    static _CharacterInfo _character0001242C =
    {
        0x0001242C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0001242C,
        0x0001242C,
        0x0001242C
    };

    static _CharacterInfo _character0001242D =
    {
        0x0001242D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001242D,
        0x0001242D,
        0x0001242D
    };

    static _CharacterInfo _character0001242E =
    {
        0x0001242E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001242E,
        0x0001242E,
        0x0001242E
    };

    static _CharacterInfo _character0001242F =
    {
        0x0001242F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001242F,
        0x0001242F,
        0x0001242F
    };

    static _CharacterInfo _character00012430 =
    {
        0x00012430,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012430,
        0x00012430,
        0x00012430
    };

    static _CharacterInfo _character00012431 =
    {
        0x00012431,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012431,
        0x00012431,
        0x00012431
    };

    static _CharacterInfo _character00012432 =
    {
        0x00012432,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012432,
        0x00012432,
        0x00012432
    };

    static _CharacterInfo _character00012433 =
    {
        0x00012433,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012433,
        0x00012433,
        0x00012433
    };

    static _CharacterInfo _character00012434 =
    {
        0x00012434,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00012434,
        0x00012434,
        0x00012434
    };

    static _CharacterInfo _character00012435 =
    {
        0x00012435,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012435,
        0x00012435,
        0x00012435
    };

    static _CharacterInfo _character00012436 =
    {
        0x00012436,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012436,
        0x00012436,
        0x00012436
    };

    static _CharacterInfo _character00012437 =
    {
        0x00012437,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012437,
        0x00012437,
        0x00012437
    };

    static _CharacterInfo _character00012438 =
    {
        0x00012438,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012438,
        0x00012438,
        0x00012438
    };

    static _CharacterInfo _character00012439 =
    {
        0x00012439,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012439,
        0x00012439,
        0x00012439
    };

    static _CharacterInfo _character0001243A =
    {
        0x0001243A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001243A,
        0x0001243A,
        0x0001243A
    };

    static _CharacterInfo _character0001243B =
    {
        0x0001243B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001243B,
        0x0001243B,
        0x0001243B
    };

    static _CharacterInfo _character0001243C =
    {
        0x0001243C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001243C,
        0x0001243C,
        0x0001243C
    };

    static _CharacterInfo _character0001243D =
    {
        0x0001243D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001243D,
        0x0001243D,
        0x0001243D
    };

    static _CharacterInfo _character0001243E =
    {
        0x0001243E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001243E,
        0x0001243E,
        0x0001243E
    };

    static _CharacterInfo _character0001243F =
    {
        0x0001243F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001243F,
        0x0001243F,
        0x0001243F
    };

    static _CharacterInfo _character00012440 =
    {
        0x00012440,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x00012440,
        0x00012440,
        0x00012440
    };

    static _CharacterInfo _character00012441 =
    {
        0x00012441,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012441,
        0x00012441,
        0x00012441
    };

    static _CharacterInfo _character00012442 =
    {
        0x00012442,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012442,
        0x00012442,
        0x00012442
    };

    static _CharacterInfo _character00012443 =
    {
        0x00012443,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x00012443,
        0x00012443,
        0x00012443
    };

    static _CharacterInfo _character00012444 =
    {
        0x00012444,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00012444,
        0x00012444,
        0x00012444
    };

    static _CharacterInfo _character00012445 =
    {
        0x00012445,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x00012445,
        0x00012445,
        0x00012445
    };

    static _CharacterInfo _character00012446 =
    {
        0x00012446,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012446,
        0x00012446,
        0x00012446
    };

    static _CharacterInfo _character00012447 =
    {
        0x00012447,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012447,
        0x00012447,
        0x00012447
    };

    static _CharacterInfo _character00012448 =
    {
        0x00012448,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012448,
        0x00012448,
        0x00012448
    };

    static _CharacterInfo _character00012449 =
    {
        0x00012449,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x00012449,
        0x00012449,
        0x00012449
    };

    static _CharacterInfo _character0001244A =
    {
        0x0001244A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001244A,
        0x0001244A,
        0x0001244A
    };

    static _CharacterInfo _character0001244B =
    {
        0x0001244B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001244B,
        0x0001244B,
        0x0001244B
    };

    static _CharacterInfo _character0001244C =
    {
        0x0001244C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001244C,
        0x0001244C,
        0x0001244C
    };

    static _CharacterInfo _character0001244D =
    {
        0x0001244D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001244D,
        0x0001244D,
        0x0001244D
    };

    static _CharacterInfo _character0001244E =
    {
        0x0001244E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x0001244E,
        0x0001244E,
        0x0001244E
    };

    static _CharacterInfo _character0001244F =
    {
        0x0001244F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0001244F,
        0x0001244F,
        0x0001244F
    };

    static _CharacterInfo _character00012450 =
    {
        0x00012450,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012450,
        0x00012450,
        0x00012450
    };

    static _CharacterInfo _character00012451 =
    {
        0x00012451,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x00012451,
        0x00012451,
        0x00012451
    };

    static _CharacterInfo _character00012452 =
    {
        0x00012452,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012452,
        0x00012452,
        0x00012452
    };

    static _CharacterInfo _character00012453 =
    {
        0x00012453,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x00012453,
        0x00012453,
        0x00012453
    };

    static _CharacterInfo _character00012454 =
    {
        0x00012454,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012454,
        0x00012454,
        0x00012454
    };

    static _CharacterInfo _character00012455 =
    {
        0x00012455,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x00012455,
        0x00012455,
        0x00012455
    };

    static _CharacterInfo _character00012456 =
    {
        0x00012456,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012456,
        0x00012456,
        0x00012456
    };

    static _CharacterInfo _character00012457 =
    {
        0x00012457,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012457,
        0x00012457,
        0x00012457
    };

    static _CharacterInfo _character00012458 =
    {
        0x00012458,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x00012458,
        0x00012458,
        0x00012458
    };

    static _CharacterInfo _character00012459 =
    {
        0x00012459,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x00012459,
        0x00012459,
        0x00012459
    };

    static _CharacterInfo _character0001245A =
    {
        0x0001245A,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        3,
        false,
        0x0001245A,
        0x0001245A,
        0x0001245A
    };

    static _CharacterInfo _character0001245B =
    {
        0x0001245B,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        3,
        false,
        0x0001245B,
        0x0001245B,
        0x0001245B
    };

    static _CharacterInfo _character0001245C =
    {
        0x0001245C,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        6,
        false,
        0x0001245C,
        0x0001245C,
        0x0001245C
    };

    static _CharacterInfo _character0001245D =
    {
        0x0001245D,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        3,
        false,
        0x0001245D,
        0x0001245D,
        0x0001245D
    };

    static _CharacterInfo _character0001245E =
    {
        0x0001245E,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        3,
        false,
        0x0001245E,
        0x0001245E,
        0x0001245E
    };

    static _CharacterInfo _character0001245F =
    {
        0x0001245F,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        8,
        false,
        0x0001245F,
        0x0001245F,
        0x0001245F
    };

    static _CharacterInfo _character00012460 =
    {
        0x00012460,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        4,
        false,
        0x00012460,
        0x00012460,
        0x00012460
    };

    static _CharacterInfo _character00012461 =
    {
        0x00012461,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        6,
        false,
        0x00012461,
        0x00012461,
        0x00012461
    };

    static _CharacterInfo _character00012462 =
    {
        0x00012462,
        Iso10646::GeneralCategory_Nl,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        4,
        false,
        0x00012462,
        0x00012462,
        0x00012462
    };

    static _CharacterInfo _character00012470 =
    {
        0x00012470,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012470,
        0x00012470,
        0x00012470
    };

    static _CharacterInfo _character00012471 =
    {
        0x00012471,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012471,
        0x00012471,
        0x00012471
    };

    static _CharacterInfo _character00012472 =
    {
        0x00012472,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012472,
        0x00012472,
        0x00012472
    };

    static _CharacterInfo _character00012473 =
    {
        0x00012473,
        Iso10646::GeneralCategory_Po,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00012473,
        0x00012473,
        0x00012473
    };

    static _CharacterInfo _character0001D000 =
    {
        0x0001D000,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D000,
        0x0001D000,
        0x0001D000
    };

    static _CharacterInfo _character0001D001 =
    {
        0x0001D001,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D001,
        0x0001D001,
        0x0001D001
    };

    static _CharacterInfo _character0001D002 =
    {
        0x0001D002,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D002,
        0x0001D002,
        0x0001D002
    };

    static _CharacterInfo _character0001D003 =
    {
        0x0001D003,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D003,
        0x0001D003,
        0x0001D003
    };

    static _CharacterInfo _character0001D004 =
    {
        0x0001D004,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D004,
        0x0001D004,
        0x0001D004
    };

    static _CharacterInfo _character0001D005 =
    {
        0x0001D005,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D005,
        0x0001D005,
        0x0001D005
    };

    static _CharacterInfo _character0001D006 =
    {
        0x0001D006,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D006,
        0x0001D006,
        0x0001D006
    };

    static _CharacterInfo _character0001D007 =
    {
        0x0001D007,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D007,
        0x0001D007,
        0x0001D007
    };

    static _CharacterInfo _character0001D008 =
    {
        0x0001D008,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D008,
        0x0001D008,
        0x0001D008
    };

    static _CharacterInfo _character0001D009 =
    {
        0x0001D009,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D009,
        0x0001D009,
        0x0001D009
    };

    static _CharacterInfo _character0001D00A =
    {
        0x0001D00A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00A,
        0x0001D00A,
        0x0001D00A
    };

    static _CharacterInfo _character0001D00B =
    {
        0x0001D00B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00B,
        0x0001D00B,
        0x0001D00B
    };

    static _CharacterInfo _character0001D00C =
    {
        0x0001D00C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00C,
        0x0001D00C,
        0x0001D00C
    };

    static _CharacterInfo _character0001D00D =
    {
        0x0001D00D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00D,
        0x0001D00D,
        0x0001D00D
    };

    static _CharacterInfo _character0001D00E =
    {
        0x0001D00E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00E,
        0x0001D00E,
        0x0001D00E
    };

    static _CharacterInfo _character0001D00F =
    {
        0x0001D00F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D00F,
        0x0001D00F,
        0x0001D00F
    };

    static _CharacterInfo _character0001D010 =
    {
        0x0001D010,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D010,
        0x0001D010,
        0x0001D010
    };

    static _CharacterInfo _character0001D011 =
    {
        0x0001D011,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D011,
        0x0001D011,
        0x0001D011
    };

    static _CharacterInfo _character0001D012 =
    {
        0x0001D012,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D012,
        0x0001D012,
        0x0001D012
    };

    static _CharacterInfo _character0001D013 =
    {
        0x0001D013,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D013,
        0x0001D013,
        0x0001D013
    };

    static _CharacterInfo _character0001D014 =
    {
        0x0001D014,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D014,
        0x0001D014,
        0x0001D014
    };

    static _CharacterInfo _character0001D015 =
    {
        0x0001D015,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D015,
        0x0001D015,
        0x0001D015
    };

    static _CharacterInfo _character0001D016 =
    {
        0x0001D016,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D016,
        0x0001D016,
        0x0001D016
    };

    static _CharacterInfo _character0001D017 =
    {
        0x0001D017,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D017,
        0x0001D017,
        0x0001D017
    };

    static _CharacterInfo _character0001D018 =
    {
        0x0001D018,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D018,
        0x0001D018,
        0x0001D018
    };

    static _CharacterInfo _character0001D019 =
    {
        0x0001D019,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D019,
        0x0001D019,
        0x0001D019
    };

    static _CharacterInfo _character0001D01A =
    {
        0x0001D01A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01A,
        0x0001D01A,
        0x0001D01A
    };

    static _CharacterInfo _character0001D01B =
    {
        0x0001D01B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01B,
        0x0001D01B,
        0x0001D01B
    };

    static _CharacterInfo _character0001D01C =
    {
        0x0001D01C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01C,
        0x0001D01C,
        0x0001D01C
    };

    static _CharacterInfo _character0001D01D =
    {
        0x0001D01D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01D,
        0x0001D01D,
        0x0001D01D
    };

    static _CharacterInfo _character0001D01E =
    {
        0x0001D01E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01E,
        0x0001D01E,
        0x0001D01E
    };

    static _CharacterInfo _character0001D01F =
    {
        0x0001D01F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D01F,
        0x0001D01F,
        0x0001D01F
    };

    static _CharacterInfo _character0001D020 =
    {
        0x0001D020,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D020,
        0x0001D020,
        0x0001D020
    };

    static _CharacterInfo _character0001D021 =
    {
        0x0001D021,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D021,
        0x0001D021,
        0x0001D021
    };

    static _CharacterInfo _character0001D022 =
    {
        0x0001D022,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D022,
        0x0001D022,
        0x0001D022
    };

    static _CharacterInfo _character0001D023 =
    {
        0x0001D023,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D023,
        0x0001D023,
        0x0001D023
    };

    static _CharacterInfo _character0001D024 =
    {
        0x0001D024,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D024,
        0x0001D024,
        0x0001D024
    };

    static _CharacterInfo _character0001D025 =
    {
        0x0001D025,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D025,
        0x0001D025,
        0x0001D025
    };

    static _CharacterInfo _character0001D026 =
    {
        0x0001D026,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D026,
        0x0001D026,
        0x0001D026
    };

    static _CharacterInfo _character0001D027 =
    {
        0x0001D027,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D027,
        0x0001D027,
        0x0001D027
    };

    static _CharacterInfo _character0001D028 =
    {
        0x0001D028,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D028,
        0x0001D028,
        0x0001D028
    };

    static _CharacterInfo _character0001D029 =
    {
        0x0001D029,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D029,
        0x0001D029,
        0x0001D029
    };

    static _CharacterInfo _character0001D02A =
    {
        0x0001D02A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02A,
        0x0001D02A,
        0x0001D02A
    };

    static _CharacterInfo _character0001D02B =
    {
        0x0001D02B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02B,
        0x0001D02B,
        0x0001D02B
    };

    static _CharacterInfo _character0001D02C =
    {
        0x0001D02C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02C,
        0x0001D02C,
        0x0001D02C
    };

    static _CharacterInfo _character0001D02D =
    {
        0x0001D02D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02D,
        0x0001D02D,
        0x0001D02D
    };

    static _CharacterInfo _character0001D02E =
    {
        0x0001D02E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02E,
        0x0001D02E,
        0x0001D02E
    };

    static _CharacterInfo _character0001D02F =
    {
        0x0001D02F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D02F,
        0x0001D02F,
        0x0001D02F
    };

    static _CharacterInfo _character0001D030 =
    {
        0x0001D030,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D030,
        0x0001D030,
        0x0001D030
    };

    static _CharacterInfo _character0001D031 =
    {
        0x0001D031,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D031,
        0x0001D031,
        0x0001D031
    };

    static _CharacterInfo _character0001D032 =
    {
        0x0001D032,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D032,
        0x0001D032,
        0x0001D032
    };

    static _CharacterInfo _character0001D033 =
    {
        0x0001D033,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D033,
        0x0001D033,
        0x0001D033
    };

    static _CharacterInfo _character0001D034 =
    {
        0x0001D034,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D034,
        0x0001D034,
        0x0001D034
    };

    static _CharacterInfo _character0001D035 =
    {
        0x0001D035,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D035,
        0x0001D035,
        0x0001D035
    };

    static _CharacterInfo _character0001D036 =
    {
        0x0001D036,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D036,
        0x0001D036,
        0x0001D036
    };

    static _CharacterInfo _character0001D037 =
    {
        0x0001D037,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D037,
        0x0001D037,
        0x0001D037
    };

    static _CharacterInfo _character0001D038 =
    {
        0x0001D038,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D038,
        0x0001D038,
        0x0001D038
    };

    static _CharacterInfo _character0001D039 =
    {
        0x0001D039,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D039,
        0x0001D039,
        0x0001D039
    };

    static _CharacterInfo _character0001D03A =
    {
        0x0001D03A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03A,
        0x0001D03A,
        0x0001D03A
    };

    static _CharacterInfo _character0001D03B =
    {
        0x0001D03B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03B,
        0x0001D03B,
        0x0001D03B
    };

    static _CharacterInfo _character0001D03C =
    {
        0x0001D03C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03C,
        0x0001D03C,
        0x0001D03C
    };

    static _CharacterInfo _character0001D03D =
    {
        0x0001D03D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03D,
        0x0001D03D,
        0x0001D03D
    };

    static _CharacterInfo _character0001D03E =
    {
        0x0001D03E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03E,
        0x0001D03E,
        0x0001D03E
    };

    static _CharacterInfo _character0001D03F =
    {
        0x0001D03F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D03F,
        0x0001D03F,
        0x0001D03F
    };

    static _CharacterInfo _character0001D040 =
    {
        0x0001D040,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D040,
        0x0001D040,
        0x0001D040
    };

    static _CharacterInfo _character0001D041 =
    {
        0x0001D041,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D041,
        0x0001D041,
        0x0001D041
    };

    static _CharacterInfo _character0001D042 =
    {
        0x0001D042,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D042,
        0x0001D042,
        0x0001D042
    };

    static _CharacterInfo _character0001D043 =
    {
        0x0001D043,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D043,
        0x0001D043,
        0x0001D043
    };

    static _CharacterInfo _character0001D044 =
    {
        0x0001D044,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D044,
        0x0001D044,
        0x0001D044
    };

    static _CharacterInfo _character0001D045 =
    {
        0x0001D045,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D045,
        0x0001D045,
        0x0001D045
    };

    static _CharacterInfo _character0001D046 =
    {
        0x0001D046,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D046,
        0x0001D046,
        0x0001D046
    };

    static _CharacterInfo _character0001D047 =
    {
        0x0001D047,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D047,
        0x0001D047,
        0x0001D047
    };

    static _CharacterInfo _character0001D048 =
    {
        0x0001D048,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D048,
        0x0001D048,
        0x0001D048
    };

    static _CharacterInfo _character0001D049 =
    {
        0x0001D049,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D049,
        0x0001D049,
        0x0001D049
    };

    static _CharacterInfo _character0001D04A =
    {
        0x0001D04A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04A,
        0x0001D04A,
        0x0001D04A
    };

    static _CharacterInfo _character0001D04B =
    {
        0x0001D04B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04B,
        0x0001D04B,
        0x0001D04B
    };

    static _CharacterInfo _character0001D04C =
    {
        0x0001D04C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04C,
        0x0001D04C,
        0x0001D04C
    };

    static _CharacterInfo _character0001D04D =
    {
        0x0001D04D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04D,
        0x0001D04D,
        0x0001D04D
    };

    static _CharacterInfo _character0001D04E =
    {
        0x0001D04E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04E,
        0x0001D04E,
        0x0001D04E
    };

    static _CharacterInfo _character0001D04F =
    {
        0x0001D04F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D04F,
        0x0001D04F,
        0x0001D04F
    };

    static _CharacterInfo _character0001D050 =
    {
        0x0001D050,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D050,
        0x0001D050,
        0x0001D050
    };

    static _CharacterInfo _character0001D051 =
    {
        0x0001D051,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D051,
        0x0001D051,
        0x0001D051
    };

    static _CharacterInfo _character0001D052 =
    {
        0x0001D052,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D052,
        0x0001D052,
        0x0001D052
    };

    static _CharacterInfo _character0001D053 =
    {
        0x0001D053,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D053,
        0x0001D053,
        0x0001D053
    };

    static _CharacterInfo _character0001D054 =
    {
        0x0001D054,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D054,
        0x0001D054,
        0x0001D054
    };

    static _CharacterInfo _character0001D055 =
    {
        0x0001D055,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D055,
        0x0001D055,
        0x0001D055
    };

    static _CharacterInfo _character0001D056 =
    {
        0x0001D056,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D056,
        0x0001D056,
        0x0001D056
    };

    static _CharacterInfo _character0001D057 =
    {
        0x0001D057,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D057,
        0x0001D057,
        0x0001D057
    };

    static _CharacterInfo _character0001D058 =
    {
        0x0001D058,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D058,
        0x0001D058,
        0x0001D058
    };

    static _CharacterInfo _character0001D059 =
    {
        0x0001D059,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D059,
        0x0001D059,
        0x0001D059
    };

    static _CharacterInfo _character0001D05A =
    {
        0x0001D05A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05A,
        0x0001D05A,
        0x0001D05A
    };

    static _CharacterInfo _character0001D05B =
    {
        0x0001D05B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05B,
        0x0001D05B,
        0x0001D05B
    };

    static _CharacterInfo _character0001D05C =
    {
        0x0001D05C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05C,
        0x0001D05C,
        0x0001D05C
    };

    static _CharacterInfo _character0001D05D =
    {
        0x0001D05D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05D,
        0x0001D05D,
        0x0001D05D
    };

    static _CharacterInfo _character0001D05E =
    {
        0x0001D05E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05E,
        0x0001D05E,
        0x0001D05E
    };

    static _CharacterInfo _character0001D05F =
    {
        0x0001D05F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D05F,
        0x0001D05F,
        0x0001D05F
    };

    static _CharacterInfo _character0001D060 =
    {
        0x0001D060,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D060,
        0x0001D060,
        0x0001D060
    };

    static _CharacterInfo _character0001D061 =
    {
        0x0001D061,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D061,
        0x0001D061,
        0x0001D061
    };

    static _CharacterInfo _character0001D062 =
    {
        0x0001D062,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D062,
        0x0001D062,
        0x0001D062
    };

    static _CharacterInfo _character0001D063 =
    {
        0x0001D063,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D063,
        0x0001D063,
        0x0001D063
    };

    static _CharacterInfo _character0001D064 =
    {
        0x0001D064,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D064,
        0x0001D064,
        0x0001D064
    };

    static _CharacterInfo _character0001D065 =
    {
        0x0001D065,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D065,
        0x0001D065,
        0x0001D065
    };

    static _CharacterInfo _character0001D066 =
    {
        0x0001D066,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D066,
        0x0001D066,
        0x0001D066
    };

    static _CharacterInfo _character0001D067 =
    {
        0x0001D067,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D067,
        0x0001D067,
        0x0001D067
    };

    static _CharacterInfo _character0001D068 =
    {
        0x0001D068,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D068,
        0x0001D068,
        0x0001D068
    };

    static _CharacterInfo _character0001D069 =
    {
        0x0001D069,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D069,
        0x0001D069,
        0x0001D069
    };

    static _CharacterInfo _character0001D06A =
    {
        0x0001D06A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06A,
        0x0001D06A,
        0x0001D06A
    };

    static _CharacterInfo _character0001D06B =
    {
        0x0001D06B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06B,
        0x0001D06B,
        0x0001D06B
    };

    static _CharacterInfo _character0001D06C =
    {
        0x0001D06C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06C,
        0x0001D06C,
        0x0001D06C
    };

    static _CharacterInfo _character0001D06D =
    {
        0x0001D06D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06D,
        0x0001D06D,
        0x0001D06D
    };

    static _CharacterInfo _character0001D06E =
    {
        0x0001D06E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06E,
        0x0001D06E,
        0x0001D06E
    };

    static _CharacterInfo _character0001D06F =
    {
        0x0001D06F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D06F,
        0x0001D06F,
        0x0001D06F
    };

    static _CharacterInfo _character0001D070 =
    {
        0x0001D070,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D070,
        0x0001D070,
        0x0001D070
    };

    static _CharacterInfo _character0001D071 =
    {
        0x0001D071,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D071,
        0x0001D071,
        0x0001D071
    };

    static _CharacterInfo _character0001D072 =
    {
        0x0001D072,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D072,
        0x0001D072,
        0x0001D072
    };

    static _CharacterInfo _character0001D073 =
    {
        0x0001D073,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D073,
        0x0001D073,
        0x0001D073
    };

    static _CharacterInfo _character0001D074 =
    {
        0x0001D074,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D074,
        0x0001D074,
        0x0001D074
    };

    static _CharacterInfo _character0001D075 =
    {
        0x0001D075,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D075,
        0x0001D075,
        0x0001D075
    };

    static _CharacterInfo _character0001D076 =
    {
        0x0001D076,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D076,
        0x0001D076,
        0x0001D076
    };

    static _CharacterInfo _character0001D077 =
    {
        0x0001D077,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D077,
        0x0001D077,
        0x0001D077
    };

    static _CharacterInfo _character0001D078 =
    {
        0x0001D078,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D078,
        0x0001D078,
        0x0001D078
    };

    static _CharacterInfo _character0001D079 =
    {
        0x0001D079,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D079,
        0x0001D079,
        0x0001D079
    };

    static _CharacterInfo _character0001D07A =
    {
        0x0001D07A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07A,
        0x0001D07A,
        0x0001D07A
    };

    static _CharacterInfo _character0001D07B =
    {
        0x0001D07B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07B,
        0x0001D07B,
        0x0001D07B
    };

    static _CharacterInfo _character0001D07C =
    {
        0x0001D07C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07C,
        0x0001D07C,
        0x0001D07C
    };

    static _CharacterInfo _character0001D07D =
    {
        0x0001D07D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07D,
        0x0001D07D,
        0x0001D07D
    };

    static _CharacterInfo _character0001D07E =
    {
        0x0001D07E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07E,
        0x0001D07E,
        0x0001D07E
    };

    static _CharacterInfo _character0001D07F =
    {
        0x0001D07F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D07F,
        0x0001D07F,
        0x0001D07F
    };

    static _CharacterInfo _character0001D080 =
    {
        0x0001D080,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D080,
        0x0001D080,
        0x0001D080
    };

    static _CharacterInfo _character0001D081 =
    {
        0x0001D081,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D081,
        0x0001D081,
        0x0001D081
    };

    static _CharacterInfo _character0001D082 =
    {
        0x0001D082,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D082,
        0x0001D082,
        0x0001D082
    };

    static _CharacterInfo _character0001D083 =
    {
        0x0001D083,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D083,
        0x0001D083,
        0x0001D083
    };

    static _CharacterInfo _character0001D084 =
    {
        0x0001D084,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D084,
        0x0001D084,
        0x0001D084
    };

    static _CharacterInfo _character0001D085 =
    {
        0x0001D085,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D085,
        0x0001D085,
        0x0001D085
    };

    static _CharacterInfo _character0001D086 =
    {
        0x0001D086,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D086,
        0x0001D086,
        0x0001D086
    };

    static _CharacterInfo _character0001D087 =
    {
        0x0001D087,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D087,
        0x0001D087,
        0x0001D087
    };

    static _CharacterInfo _character0001D088 =
    {
        0x0001D088,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D088,
        0x0001D088,
        0x0001D088
    };

    static _CharacterInfo _character0001D089 =
    {
        0x0001D089,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D089,
        0x0001D089,
        0x0001D089
    };

    static _CharacterInfo _character0001D08A =
    {
        0x0001D08A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08A,
        0x0001D08A,
        0x0001D08A
    };

    static _CharacterInfo _character0001D08B =
    {
        0x0001D08B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08B,
        0x0001D08B,
        0x0001D08B
    };

    static _CharacterInfo _character0001D08C =
    {
        0x0001D08C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08C,
        0x0001D08C,
        0x0001D08C
    };

    static _CharacterInfo _character0001D08D =
    {
        0x0001D08D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08D,
        0x0001D08D,
        0x0001D08D
    };

    static _CharacterInfo _character0001D08E =
    {
        0x0001D08E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08E,
        0x0001D08E,
        0x0001D08E
    };

    static _CharacterInfo _character0001D08F =
    {
        0x0001D08F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D08F,
        0x0001D08F,
        0x0001D08F
    };

    static _CharacterInfo _character0001D090 =
    {
        0x0001D090,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D090,
        0x0001D090,
        0x0001D090
    };

    static _CharacterInfo _character0001D091 =
    {
        0x0001D091,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D091,
        0x0001D091,
        0x0001D091
    };

    static _CharacterInfo _character0001D092 =
    {
        0x0001D092,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D092,
        0x0001D092,
        0x0001D092
    };

    static _CharacterInfo _character0001D093 =
    {
        0x0001D093,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D093,
        0x0001D093,
        0x0001D093
    };

    static _CharacterInfo _character0001D094 =
    {
        0x0001D094,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D094,
        0x0001D094,
        0x0001D094
    };

    static _CharacterInfo _character0001D095 =
    {
        0x0001D095,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D095,
        0x0001D095,
        0x0001D095
    };

    static _CharacterInfo _character0001D096 =
    {
        0x0001D096,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D096,
        0x0001D096,
        0x0001D096
    };

    static _CharacterInfo _character0001D097 =
    {
        0x0001D097,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D097,
        0x0001D097,
        0x0001D097
    };

    static _CharacterInfo _character0001D098 =
    {
        0x0001D098,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D098,
        0x0001D098,
        0x0001D098
    };

    static _CharacterInfo _character0001D099 =
    {
        0x0001D099,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D099,
        0x0001D099,
        0x0001D099
    };

    static _CharacterInfo _character0001D09A =
    {
        0x0001D09A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09A,
        0x0001D09A,
        0x0001D09A
    };

    static _CharacterInfo _character0001D09B =
    {
        0x0001D09B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09B,
        0x0001D09B,
        0x0001D09B
    };

    static _CharacterInfo _character0001D09C =
    {
        0x0001D09C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09C,
        0x0001D09C,
        0x0001D09C
    };

    static _CharacterInfo _character0001D09D =
    {
        0x0001D09D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09D,
        0x0001D09D,
        0x0001D09D
    };

    static _CharacterInfo _character0001D09E =
    {
        0x0001D09E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09E,
        0x0001D09E,
        0x0001D09E
    };

    static _CharacterInfo _character0001D09F =
    {
        0x0001D09F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D09F,
        0x0001D09F,
        0x0001D09F
    };

    static _CharacterInfo _character0001D0A0 =
    {
        0x0001D0A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A0,
        0x0001D0A0,
        0x0001D0A0
    };

    static _CharacterInfo _character0001D0A1 =
    {
        0x0001D0A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A1,
        0x0001D0A1,
        0x0001D0A1
    };

    static _CharacterInfo _character0001D0A2 =
    {
        0x0001D0A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A2,
        0x0001D0A2,
        0x0001D0A2
    };

    static _CharacterInfo _character0001D0A3 =
    {
        0x0001D0A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A3,
        0x0001D0A3,
        0x0001D0A3
    };

    static _CharacterInfo _character0001D0A4 =
    {
        0x0001D0A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A4,
        0x0001D0A4,
        0x0001D0A4
    };

    static _CharacterInfo _character0001D0A5 =
    {
        0x0001D0A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A5,
        0x0001D0A5,
        0x0001D0A5
    };

    static _CharacterInfo _character0001D0A6 =
    {
        0x0001D0A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A6,
        0x0001D0A6,
        0x0001D0A6
    };

    static _CharacterInfo _character0001D0A7 =
    {
        0x0001D0A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A7,
        0x0001D0A7,
        0x0001D0A7
    };

    static _CharacterInfo _character0001D0A8 =
    {
        0x0001D0A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A8,
        0x0001D0A8,
        0x0001D0A8
    };

    static _CharacterInfo _character0001D0A9 =
    {
        0x0001D0A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0A9,
        0x0001D0A9,
        0x0001D0A9
    };

    static _CharacterInfo _character0001D0AA =
    {
        0x0001D0AA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AA,
        0x0001D0AA,
        0x0001D0AA
    };

    static _CharacterInfo _character0001D0AB =
    {
        0x0001D0AB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AB,
        0x0001D0AB,
        0x0001D0AB
    };

    static _CharacterInfo _character0001D0AC =
    {
        0x0001D0AC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AC,
        0x0001D0AC,
        0x0001D0AC
    };

    static _CharacterInfo _character0001D0AD =
    {
        0x0001D0AD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AD,
        0x0001D0AD,
        0x0001D0AD
    };

    static _CharacterInfo _character0001D0AE =
    {
        0x0001D0AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AE,
        0x0001D0AE,
        0x0001D0AE
    };

    static _CharacterInfo _character0001D0AF =
    {
        0x0001D0AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0AF,
        0x0001D0AF,
        0x0001D0AF
    };

    static _CharacterInfo _character0001D0B0 =
    {
        0x0001D0B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B0,
        0x0001D0B0,
        0x0001D0B0
    };

    static _CharacterInfo _character0001D0B1 =
    {
        0x0001D0B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B1,
        0x0001D0B1,
        0x0001D0B1
    };

    static _CharacterInfo _character0001D0B2 =
    {
        0x0001D0B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B2,
        0x0001D0B2,
        0x0001D0B2
    };

    static _CharacterInfo _character0001D0B3 =
    {
        0x0001D0B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B3,
        0x0001D0B3,
        0x0001D0B3
    };

    static _CharacterInfo _character0001D0B4 =
    {
        0x0001D0B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B4,
        0x0001D0B4,
        0x0001D0B4
    };

    static _CharacterInfo _character0001D0B5 =
    {
        0x0001D0B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B5,
        0x0001D0B5,
        0x0001D0B5
    };

    static _CharacterInfo _character0001D0B6 =
    {
        0x0001D0B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B6,
        0x0001D0B6,
        0x0001D0B6
    };

    static _CharacterInfo _character0001D0B7 =
    {
        0x0001D0B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B7,
        0x0001D0B7,
        0x0001D0B7
    };

    static _CharacterInfo _character0001D0B8 =
    {
        0x0001D0B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B8,
        0x0001D0B8,
        0x0001D0B8
    };

    static _CharacterInfo _character0001D0B9 =
    {
        0x0001D0B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0B9,
        0x0001D0B9,
        0x0001D0B9
    };

    static _CharacterInfo _character0001D0BA =
    {
        0x0001D0BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BA,
        0x0001D0BA,
        0x0001D0BA
    };

    static _CharacterInfo _character0001D0BB =
    {
        0x0001D0BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BB,
        0x0001D0BB,
        0x0001D0BB
    };

    static _CharacterInfo _character0001D0BC =
    {
        0x0001D0BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BC,
        0x0001D0BC,
        0x0001D0BC
    };

    static _CharacterInfo _character0001D0BD =
    {
        0x0001D0BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BD,
        0x0001D0BD,
        0x0001D0BD
    };

    static _CharacterInfo _character0001D0BE =
    {
        0x0001D0BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BE,
        0x0001D0BE,
        0x0001D0BE
    };

    static _CharacterInfo _character0001D0BF =
    {
        0x0001D0BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0BF,
        0x0001D0BF,
        0x0001D0BF
    };

    static _CharacterInfo _character0001D0C0 =
    {
        0x0001D0C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C0,
        0x0001D0C0,
        0x0001D0C0
    };

    static _CharacterInfo _character0001D0C1 =
    {
        0x0001D0C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C1,
        0x0001D0C1,
        0x0001D0C1
    };

    static _CharacterInfo _character0001D0C2 =
    {
        0x0001D0C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C2,
        0x0001D0C2,
        0x0001D0C2
    };

    static _CharacterInfo _character0001D0C3 =
    {
        0x0001D0C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C3,
        0x0001D0C3,
        0x0001D0C3
    };

    static _CharacterInfo _character0001D0C4 =
    {
        0x0001D0C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C4,
        0x0001D0C4,
        0x0001D0C4
    };

    static _CharacterInfo _character0001D0C5 =
    {
        0x0001D0C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C5,
        0x0001D0C5,
        0x0001D0C5
    };

    static _CharacterInfo _character0001D0C6 =
    {
        0x0001D0C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C6,
        0x0001D0C6,
        0x0001D0C6
    };

    static _CharacterInfo _character0001D0C7 =
    {
        0x0001D0C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C7,
        0x0001D0C7,
        0x0001D0C7
    };

    static _CharacterInfo _character0001D0C8 =
    {
        0x0001D0C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C8,
        0x0001D0C8,
        0x0001D0C8
    };

    static _CharacterInfo _character0001D0C9 =
    {
        0x0001D0C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0C9,
        0x0001D0C9,
        0x0001D0C9
    };

    static _CharacterInfo _character0001D0CA =
    {
        0x0001D0CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CA,
        0x0001D0CA,
        0x0001D0CA
    };

    static _CharacterInfo _character0001D0CB =
    {
        0x0001D0CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CB,
        0x0001D0CB,
        0x0001D0CB
    };

    static _CharacterInfo _character0001D0CC =
    {
        0x0001D0CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CC,
        0x0001D0CC,
        0x0001D0CC
    };

    static _CharacterInfo _character0001D0CD =
    {
        0x0001D0CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CD,
        0x0001D0CD,
        0x0001D0CD
    };

    static _CharacterInfo _character0001D0CE =
    {
        0x0001D0CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CE,
        0x0001D0CE,
        0x0001D0CE
    };

    static _CharacterInfo _character0001D0CF =
    {
        0x0001D0CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0CF,
        0x0001D0CF,
        0x0001D0CF
    };

    static _CharacterInfo _character0001D0D0 =
    {
        0x0001D0D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D0,
        0x0001D0D0,
        0x0001D0D0
    };

    static _CharacterInfo _character0001D0D1 =
    {
        0x0001D0D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D1,
        0x0001D0D1,
        0x0001D0D1
    };

    static _CharacterInfo _character0001D0D2 =
    {
        0x0001D0D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D2,
        0x0001D0D2,
        0x0001D0D2
    };

    static _CharacterInfo _character0001D0D3 =
    {
        0x0001D0D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D3,
        0x0001D0D3,
        0x0001D0D3
    };

    static _CharacterInfo _character0001D0D4 =
    {
        0x0001D0D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D4,
        0x0001D0D4,
        0x0001D0D4
    };

    static _CharacterInfo _character0001D0D5 =
    {
        0x0001D0D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D5,
        0x0001D0D5,
        0x0001D0D5
    };

    static _CharacterInfo _character0001D0D6 =
    {
        0x0001D0D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D6,
        0x0001D0D6,
        0x0001D0D6
    };

    static _CharacterInfo _character0001D0D7 =
    {
        0x0001D0D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D7,
        0x0001D0D7,
        0x0001D0D7
    };

    static _CharacterInfo _character0001D0D8 =
    {
        0x0001D0D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D8,
        0x0001D0D8,
        0x0001D0D8
    };

    static _CharacterInfo _character0001D0D9 =
    {
        0x0001D0D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0D9,
        0x0001D0D9,
        0x0001D0D9
    };

    static _CharacterInfo _character0001D0DA =
    {
        0x0001D0DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DA,
        0x0001D0DA,
        0x0001D0DA
    };

    static _CharacterInfo _character0001D0DB =
    {
        0x0001D0DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DB,
        0x0001D0DB,
        0x0001D0DB
    };

    static _CharacterInfo _character0001D0DC =
    {
        0x0001D0DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DC,
        0x0001D0DC,
        0x0001D0DC
    };

    static _CharacterInfo _character0001D0DD =
    {
        0x0001D0DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DD,
        0x0001D0DD,
        0x0001D0DD
    };

    static _CharacterInfo _character0001D0DE =
    {
        0x0001D0DE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DE,
        0x0001D0DE,
        0x0001D0DE
    };

    static _CharacterInfo _character0001D0DF =
    {
        0x0001D0DF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0DF,
        0x0001D0DF,
        0x0001D0DF
    };

    static _CharacterInfo _character0001D0E0 =
    {
        0x0001D0E0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E0,
        0x0001D0E0,
        0x0001D0E0
    };

    static _CharacterInfo _character0001D0E1 =
    {
        0x0001D0E1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E1,
        0x0001D0E1,
        0x0001D0E1
    };

    static _CharacterInfo _character0001D0E2 =
    {
        0x0001D0E2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E2,
        0x0001D0E2,
        0x0001D0E2
    };

    static _CharacterInfo _character0001D0E3 =
    {
        0x0001D0E3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E3,
        0x0001D0E3,
        0x0001D0E3
    };

    static _CharacterInfo _character0001D0E4 =
    {
        0x0001D0E4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E4,
        0x0001D0E4,
        0x0001D0E4
    };

    static _CharacterInfo _character0001D0E5 =
    {
        0x0001D0E5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E5,
        0x0001D0E5,
        0x0001D0E5
    };

    static _CharacterInfo _character0001D0E6 =
    {
        0x0001D0E6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E6,
        0x0001D0E6,
        0x0001D0E6
    };

    static _CharacterInfo _character0001D0E7 =
    {
        0x0001D0E7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E7,
        0x0001D0E7,
        0x0001D0E7
    };

    static _CharacterInfo _character0001D0E8 =
    {
        0x0001D0E8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E8,
        0x0001D0E8,
        0x0001D0E8
    };

    static _CharacterInfo _character0001D0E9 =
    {
        0x0001D0E9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0E9,
        0x0001D0E9,
        0x0001D0E9
    };

    static _CharacterInfo _character0001D0EA =
    {
        0x0001D0EA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0EA,
        0x0001D0EA,
        0x0001D0EA
    };

    static _CharacterInfo _character0001D0EB =
    {
        0x0001D0EB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0EB,
        0x0001D0EB,
        0x0001D0EB
    };

    static _CharacterInfo _character0001D0EC =
    {
        0x0001D0EC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0EC,
        0x0001D0EC,
        0x0001D0EC
    };

    static _CharacterInfo _character0001D0ED =
    {
        0x0001D0ED,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0ED,
        0x0001D0ED,
        0x0001D0ED
    };

    static _CharacterInfo _character0001D0EE =
    {
        0x0001D0EE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0EE,
        0x0001D0EE,
        0x0001D0EE
    };

    static _CharacterInfo _character0001D0EF =
    {
        0x0001D0EF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0EF,
        0x0001D0EF,
        0x0001D0EF
    };

    static _CharacterInfo _character0001D0F0 =
    {
        0x0001D0F0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F0,
        0x0001D0F0,
        0x0001D0F0
    };

    static _CharacterInfo _character0001D0F1 =
    {
        0x0001D0F1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F1,
        0x0001D0F1,
        0x0001D0F1
    };

    static _CharacterInfo _character0001D0F2 =
    {
        0x0001D0F2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F2,
        0x0001D0F2,
        0x0001D0F2
    };

    static _CharacterInfo _character0001D0F3 =
    {
        0x0001D0F3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F3,
        0x0001D0F3,
        0x0001D0F3
    };

    static _CharacterInfo _character0001D0F4 =
    {
        0x0001D0F4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F4,
        0x0001D0F4,
        0x0001D0F4
    };

    static _CharacterInfo _character0001D0F5 =
    {
        0x0001D0F5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D0F5,
        0x0001D0F5,
        0x0001D0F5
    };

    static _CharacterInfo _character0001D100 =
    {
        0x0001D100,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D100,
        0x0001D100,
        0x0001D100
    };

    static _CharacterInfo _character0001D101 =
    {
        0x0001D101,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D101,
        0x0001D101,
        0x0001D101
    };

    static _CharacterInfo _character0001D102 =
    {
        0x0001D102,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D102,
        0x0001D102,
        0x0001D102
    };

    static _CharacterInfo _character0001D103 =
    {
        0x0001D103,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D103,
        0x0001D103,
        0x0001D103
    };

    static _CharacterInfo _character0001D104 =
    {
        0x0001D104,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D104,
        0x0001D104,
        0x0001D104
    };

    static _CharacterInfo _character0001D105 =
    {
        0x0001D105,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D105,
        0x0001D105,
        0x0001D105
    };

    static _CharacterInfo _character0001D106 =
    {
        0x0001D106,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D106,
        0x0001D106,
        0x0001D106
    };

    static _CharacterInfo _character0001D107 =
    {
        0x0001D107,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D107,
        0x0001D107,
        0x0001D107
    };

    static _CharacterInfo _character0001D108 =
    {
        0x0001D108,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D108,
        0x0001D108,
        0x0001D108
    };

    static _CharacterInfo _character0001D109 =
    {
        0x0001D109,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D109,
        0x0001D109,
        0x0001D109
    };

    static _CharacterInfo _character0001D10A =
    {
        0x0001D10A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10A,
        0x0001D10A,
        0x0001D10A
    };

    static _CharacterInfo _character0001D10B =
    {
        0x0001D10B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10B,
        0x0001D10B,
        0x0001D10B
    };

    static _CharacterInfo _character0001D10C =
    {
        0x0001D10C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10C,
        0x0001D10C,
        0x0001D10C
    };

    static _CharacterInfo _character0001D10D =
    {
        0x0001D10D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10D,
        0x0001D10D,
        0x0001D10D
    };

    static _CharacterInfo _character0001D10E =
    {
        0x0001D10E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10E,
        0x0001D10E,
        0x0001D10E
    };

    static _CharacterInfo _character0001D10F =
    {
        0x0001D10F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D10F,
        0x0001D10F,
        0x0001D10F
    };

    static _CharacterInfo _character0001D110 =
    {
        0x0001D110,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D110,
        0x0001D110,
        0x0001D110
    };

    static _CharacterInfo _character0001D111 =
    {
        0x0001D111,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D111,
        0x0001D111,
        0x0001D111
    };

    static _CharacterInfo _character0001D112 =
    {
        0x0001D112,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D112,
        0x0001D112,
        0x0001D112
    };

    static _CharacterInfo _character0001D113 =
    {
        0x0001D113,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D113,
        0x0001D113,
        0x0001D113
    };

    static _CharacterInfo _character0001D114 =
    {
        0x0001D114,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D114,
        0x0001D114,
        0x0001D114
    };

    static _CharacterInfo _character0001D115 =
    {
        0x0001D115,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D115,
        0x0001D115,
        0x0001D115
    };

    static _CharacterInfo _character0001D116 =
    {
        0x0001D116,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D116,
        0x0001D116,
        0x0001D116
    };

    static _CharacterInfo _character0001D117 =
    {
        0x0001D117,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D117,
        0x0001D117,
        0x0001D117
    };

    static _CharacterInfo _character0001D118 =
    {
        0x0001D118,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D118,
        0x0001D118,
        0x0001D118
    };

    static _CharacterInfo _character0001D119 =
    {
        0x0001D119,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D119,
        0x0001D119,
        0x0001D119
    };

    static _CharacterInfo _character0001D11A =
    {
        0x0001D11A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11A,
        0x0001D11A,
        0x0001D11A
    };

    static _CharacterInfo _character0001D11B =
    {
        0x0001D11B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11B,
        0x0001D11B,
        0x0001D11B
    };

    static _CharacterInfo _character0001D11C =
    {
        0x0001D11C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11C,
        0x0001D11C,
        0x0001D11C
    };

    static _CharacterInfo _character0001D11D =
    {
        0x0001D11D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11D,
        0x0001D11D,
        0x0001D11D
    };

    static _CharacterInfo _character0001D11E =
    {
        0x0001D11E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11E,
        0x0001D11E,
        0x0001D11E
    };

    static _CharacterInfo _character0001D11F =
    {
        0x0001D11F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D11F,
        0x0001D11F,
        0x0001D11F
    };

    static _CharacterInfo _character0001D120 =
    {
        0x0001D120,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D120,
        0x0001D120,
        0x0001D120
    };

    static _CharacterInfo _character0001D121 =
    {
        0x0001D121,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D121,
        0x0001D121,
        0x0001D121
    };

    static _CharacterInfo _character0001D122 =
    {
        0x0001D122,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D122,
        0x0001D122,
        0x0001D122
    };

    static _CharacterInfo _character0001D123 =
    {
        0x0001D123,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D123,
        0x0001D123,
        0x0001D123
    };

    static _CharacterInfo _character0001D124 =
    {
        0x0001D124,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D124,
        0x0001D124,
        0x0001D124
    };

    static _CharacterInfo _character0001D125 =
    {
        0x0001D125,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D125,
        0x0001D125,
        0x0001D125
    };

    static _CharacterInfo _character0001D126 =
    {
        0x0001D126,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D126,
        0x0001D126,
        0x0001D126
    };

    static _CharacterInfo _character0001D12A =
    {
        0x0001D12A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12A,
        0x0001D12A,
        0x0001D12A
    };

    static _CharacterInfo _character0001D12B =
    {
        0x0001D12B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12B,
        0x0001D12B,
        0x0001D12B
    };

    static _CharacterInfo _character0001D12C =
    {
        0x0001D12C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12C,
        0x0001D12C,
        0x0001D12C
    };

    static _CharacterInfo _character0001D12D =
    {
        0x0001D12D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12D,
        0x0001D12D,
        0x0001D12D
    };

    static _CharacterInfo _character0001D12E =
    {
        0x0001D12E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12E,
        0x0001D12E,
        0x0001D12E
    };

    static _CharacterInfo _character0001D12F =
    {
        0x0001D12F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D12F,
        0x0001D12F,
        0x0001D12F
    };

    static _CharacterInfo _character0001D130 =
    {
        0x0001D130,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D130,
        0x0001D130,
        0x0001D130
    };

    static _CharacterInfo _character0001D131 =
    {
        0x0001D131,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D131,
        0x0001D131,
        0x0001D131
    };

    static _CharacterInfo _character0001D132 =
    {
        0x0001D132,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D132,
        0x0001D132,
        0x0001D132
    };

    static _CharacterInfo _character0001D133 =
    {
        0x0001D133,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D133,
        0x0001D133,
        0x0001D133
    };

    static _CharacterInfo _character0001D134 =
    {
        0x0001D134,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D134,
        0x0001D134,
        0x0001D134
    };

    static _CharacterInfo _character0001D135 =
    {
        0x0001D135,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D135,
        0x0001D135,
        0x0001D135
    };

    static _CharacterInfo _character0001D136 =
    {
        0x0001D136,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D136,
        0x0001D136,
        0x0001D136
    };

    static _CharacterInfo _character0001D137 =
    {
        0x0001D137,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D137,
        0x0001D137,
        0x0001D137
    };

    static _CharacterInfo _character0001D138 =
    {
        0x0001D138,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D138,
        0x0001D138,
        0x0001D138
    };

    static _CharacterInfo _character0001D139 =
    {
        0x0001D139,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D139,
        0x0001D139,
        0x0001D139
    };

    static _CharacterInfo _character0001D13A =
    {
        0x0001D13A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13A,
        0x0001D13A,
        0x0001D13A
    };

    static _CharacterInfo _character0001D13B =
    {
        0x0001D13B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13B,
        0x0001D13B,
        0x0001D13B
    };

    static _CharacterInfo _character0001D13C =
    {
        0x0001D13C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13C,
        0x0001D13C,
        0x0001D13C
    };

    static _CharacterInfo _character0001D13D =
    {
        0x0001D13D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13D,
        0x0001D13D,
        0x0001D13D
    };

    static _CharacterInfo _character0001D13E =
    {
        0x0001D13E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13E,
        0x0001D13E,
        0x0001D13E
    };

    static _CharacterInfo _character0001D13F =
    {
        0x0001D13F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D13F,
        0x0001D13F,
        0x0001D13F
    };

    static _CharacterInfo _character0001D140 =
    {
        0x0001D140,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D140,
        0x0001D140,
        0x0001D140
    };

    static _CharacterInfo _character0001D141 =
    {
        0x0001D141,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D141,
        0x0001D141,
        0x0001D141
    };

    static _CharacterInfo _character0001D142 =
    {
        0x0001D142,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D142,
        0x0001D142,
        0x0001D142
    };

    static _CharacterInfo _character0001D143 =
    {
        0x0001D143,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D143,
        0x0001D143,
        0x0001D143
    };

    static _CharacterInfo _character0001D144 =
    {
        0x0001D144,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D144,
        0x0001D144,
        0x0001D144
    };

    static _CharacterInfo _character0001D145 =
    {
        0x0001D145,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D145,
        0x0001D145,
        0x0001D145
    };

    static _CharacterInfo _character0001D146 =
    {
        0x0001D146,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D146,
        0x0001D146,
        0x0001D146
    };

    static _CharacterInfo _character0001D147 =
    {
        0x0001D147,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D147,
        0x0001D147,
        0x0001D147
    };

    static _CharacterInfo _character0001D148 =
    {
        0x0001D148,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D148,
        0x0001D148,
        0x0001D148
    };

    static _CharacterInfo _character0001D149 =
    {
        0x0001D149,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D149,
        0x0001D149,
        0x0001D149
    };

    static _CharacterInfo _character0001D14A =
    {
        0x0001D14A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14A,
        0x0001D14A,
        0x0001D14A
    };

    static _CharacterInfo _character0001D14B =
    {
        0x0001D14B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14B,
        0x0001D14B,
        0x0001D14B
    };

    static _CharacterInfo _character0001D14C =
    {
        0x0001D14C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14C,
        0x0001D14C,
        0x0001D14C
    };

    static _CharacterInfo _character0001D14D =
    {
        0x0001D14D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14D,
        0x0001D14D,
        0x0001D14D
    };

    static _CharacterInfo _character0001D14E =
    {
        0x0001D14E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14E,
        0x0001D14E,
        0x0001D14E
    };

    static _CharacterInfo _character0001D14F =
    {
        0x0001D14F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D14F,
        0x0001D14F,
        0x0001D14F
    };

    static _CharacterInfo _character0001D150 =
    {
        0x0001D150,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D150,
        0x0001D150,
        0x0001D150
    };

    static _CharacterInfo _character0001D151 =
    {
        0x0001D151,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D151,
        0x0001D151,
        0x0001D151
    };

    static _CharacterInfo _character0001D152 =
    {
        0x0001D152,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D152,
        0x0001D152,
        0x0001D152
    };

    static _CharacterInfo _character0001D153 =
    {
        0x0001D153,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D153,
        0x0001D153,
        0x0001D153
    };

    static _CharacterInfo _character0001D154 =
    {
        0x0001D154,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D154,
        0x0001D154,
        0x0001D154
    };

    static _CharacterInfo _character0001D155 =
    {
        0x0001D155,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D155,
        0x0001D155,
        0x0001D155
    };

    static _CharacterInfo _character0001D156 =
    {
        0x0001D156,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D156,
        0x0001D156,
        0x0001D156
    };

    static _CharacterInfo _character0001D157 =
    {
        0x0001D157,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D157,
        0x0001D157,
        0x0001D157
    };

    static _CharacterInfo _character0001D158 =
    {
        0x0001D158,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D158,
        0x0001D158,
        0x0001D158
    };

    static _CharacterInfo _character0001D159 =
    {
        0x0001D159,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D159,
        0x0001D159,
        0x0001D159
    };

    static _CharacterInfo _character0001D15A =
    {
        0x0001D15A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15A,
        0x0001D15A,
        0x0001D15A
    };

    static _CharacterInfo _character0001D15B =
    {
        0x0001D15B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15B,
        0x0001D15B,
        0x0001D15B
    };

    static _CharacterInfo _character0001D15C =
    {
        0x0001D15C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15C,
        0x0001D15C,
        0x0001D15C
    };

    static _CharacterInfo _character0001D15D =
    {
        0x0001D15D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15D,
        0x0001D15D,
        0x0001D15D
    };

    static Char _decompositionMapping0001D15E[] = 
    {
        0x0001D157,
        0x0001D165
    };

    static _CharacterInfo _character0001D15E =
    {
        0x0001D15E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D15E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15E,
        0x0001D15E,
        0x0001D15E
    };

    static Char _decompositionMapping0001D15F[] = 
    {
        0x0001D158,
        0x0001D165
    };

    static _CharacterInfo _character0001D15F =
    {
        0x0001D15F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D15F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D15F,
        0x0001D15F,
        0x0001D15F
    };

    static Char _decompositionMapping0001D160[] = 
    {
        0x0001D15F,
        0x0001D16E
    };

    static _CharacterInfo _character0001D160 =
    {
        0x0001D160,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D160,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D160,
        0x0001D160,
        0x0001D160
    };

    static Char _decompositionMapping0001D161[] = 
    {
        0x0001D15F,
        0x0001D16F
    };

    static _CharacterInfo _character0001D161 =
    {
        0x0001D161,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D161,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D161,
        0x0001D161,
        0x0001D161
    };

    static Char _decompositionMapping0001D162[] = 
    {
        0x0001D15F,
        0x0001D170
    };

    static _CharacterInfo _character0001D162 =
    {
        0x0001D162,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D162,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D162,
        0x0001D162,
        0x0001D162
    };

    static Char _decompositionMapping0001D163[] = 
    {
        0x0001D15F,
        0x0001D171
    };

    static _CharacterInfo _character0001D163 =
    {
        0x0001D163,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D163,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D163,
        0x0001D163,
        0x0001D163
    };

    static Char _decompositionMapping0001D164[] = 
    {
        0x0001D15F,
        0x0001D172
    };

    static _CharacterInfo _character0001D164 =
    {
        0x0001D164,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D164,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D164,
        0x0001D164,
        0x0001D164
    };

    static _CharacterInfo _character0001D165 =
    {
        0x0001D165,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D165,
        0x0001D165,
        0x0001D165
    };

    static _CharacterInfo _character0001D166 =
    {
        0x0001D166,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D166,
        0x0001D166,
        0x0001D166
    };

    static _CharacterInfo _character0001D167 =
    {
        0x0001D167,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D167,
        0x0001D167,
        0x0001D167
    };

    static _CharacterInfo _character0001D168 =
    {
        0x0001D168,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D168,
        0x0001D168,
        0x0001D168
    };

    static _CharacterInfo _character0001D169 =
    {
        0x0001D169,
        Iso10646::GeneralCategory_Mn,
        1,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D169,
        0x0001D169,
        0x0001D169
    };

    static _CharacterInfo _character0001D16A =
    {
        0x0001D16A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16A,
        0x0001D16A,
        0x0001D16A
    };

    static _CharacterInfo _character0001D16B =
    {
        0x0001D16B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16B,
        0x0001D16B,
        0x0001D16B
    };

    static _CharacterInfo _character0001D16C =
    {
        0x0001D16C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16C,
        0x0001D16C,
        0x0001D16C
    };

    static _CharacterInfo _character0001D16D =
    {
        0x0001D16D,
        Iso10646::GeneralCategory_Mc,
        226,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16D,
        0x0001D16D,
        0x0001D16D
    };

    static _CharacterInfo _character0001D16E =
    {
        0x0001D16E,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16E,
        0x0001D16E,
        0x0001D16E
    };

    static _CharacterInfo _character0001D16F =
    {
        0x0001D16F,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D16F,
        0x0001D16F,
        0x0001D16F
    };

    static _CharacterInfo _character0001D170 =
    {
        0x0001D170,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D170,
        0x0001D170,
        0x0001D170
    };

    static _CharacterInfo _character0001D171 =
    {
        0x0001D171,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D171,
        0x0001D171,
        0x0001D171
    };

    static _CharacterInfo _character0001D172 =
    {
        0x0001D172,
        Iso10646::GeneralCategory_Mc,
        216,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D172,
        0x0001D172,
        0x0001D172
    };

    static _CharacterInfo _character0001D173 =
    {
        0x0001D173,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D173,
        0x0001D173,
        0x0001D173
    };

    static _CharacterInfo _character0001D174 =
    {
        0x0001D174,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D174,
        0x0001D174,
        0x0001D174
    };

    static _CharacterInfo _character0001D175 =
    {
        0x0001D175,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D175,
        0x0001D175,
        0x0001D175
    };

    static _CharacterInfo _character0001D176 =
    {
        0x0001D176,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D176,
        0x0001D176,
        0x0001D176
    };

    static _CharacterInfo _character0001D177 =
    {
        0x0001D177,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D177,
        0x0001D177,
        0x0001D177
    };

    static _CharacterInfo _character0001D178 =
    {
        0x0001D178,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D178,
        0x0001D178,
        0x0001D178
    };

    static _CharacterInfo _character0001D179 =
    {
        0x0001D179,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D179,
        0x0001D179,
        0x0001D179
    };

    static _CharacterInfo _character0001D17A =
    {
        0x0001D17A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17A,
        0x0001D17A,
        0x0001D17A
    };

    static _CharacterInfo _character0001D17B =
    {
        0x0001D17B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17B,
        0x0001D17B,
        0x0001D17B
    };

    static _CharacterInfo _character0001D17C =
    {
        0x0001D17C,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17C,
        0x0001D17C,
        0x0001D17C
    };

    static _CharacterInfo _character0001D17D =
    {
        0x0001D17D,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17D,
        0x0001D17D,
        0x0001D17D
    };

    static _CharacterInfo _character0001D17E =
    {
        0x0001D17E,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17E,
        0x0001D17E,
        0x0001D17E
    };

    static _CharacterInfo _character0001D17F =
    {
        0x0001D17F,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D17F,
        0x0001D17F,
        0x0001D17F
    };

    static _CharacterInfo _character0001D180 =
    {
        0x0001D180,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D180,
        0x0001D180,
        0x0001D180
    };

    static _CharacterInfo _character0001D181 =
    {
        0x0001D181,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D181,
        0x0001D181,
        0x0001D181
    };

    static _CharacterInfo _character0001D182 =
    {
        0x0001D182,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D182,
        0x0001D182,
        0x0001D182
    };

    static _CharacterInfo _character0001D183 =
    {
        0x0001D183,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D183,
        0x0001D183,
        0x0001D183
    };

    static _CharacterInfo _character0001D184 =
    {
        0x0001D184,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D184,
        0x0001D184,
        0x0001D184
    };

    static _CharacterInfo _character0001D185 =
    {
        0x0001D185,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D185,
        0x0001D185,
        0x0001D185
    };

    static _CharacterInfo _character0001D186 =
    {
        0x0001D186,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D186,
        0x0001D186,
        0x0001D186
    };

    static _CharacterInfo _character0001D187 =
    {
        0x0001D187,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D187,
        0x0001D187,
        0x0001D187
    };

    static _CharacterInfo _character0001D188 =
    {
        0x0001D188,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D188,
        0x0001D188,
        0x0001D188
    };

    static _CharacterInfo _character0001D189 =
    {
        0x0001D189,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D189,
        0x0001D189,
        0x0001D189
    };

    static _CharacterInfo _character0001D18A =
    {
        0x0001D18A,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18A,
        0x0001D18A,
        0x0001D18A
    };

    static _CharacterInfo _character0001D18B =
    {
        0x0001D18B,
        Iso10646::GeneralCategory_Mn,
        220,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18B,
        0x0001D18B,
        0x0001D18B
    };

    static _CharacterInfo _character0001D18C =
    {
        0x0001D18C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18C,
        0x0001D18C,
        0x0001D18C
    };

    static _CharacterInfo _character0001D18D =
    {
        0x0001D18D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18D,
        0x0001D18D,
        0x0001D18D
    };

    static _CharacterInfo _character0001D18E =
    {
        0x0001D18E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18E,
        0x0001D18E,
        0x0001D18E
    };

    static _CharacterInfo _character0001D18F =
    {
        0x0001D18F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D18F,
        0x0001D18F,
        0x0001D18F
    };

    static _CharacterInfo _character0001D190 =
    {
        0x0001D190,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D190,
        0x0001D190,
        0x0001D190
    };

    static _CharacterInfo _character0001D191 =
    {
        0x0001D191,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D191,
        0x0001D191,
        0x0001D191
    };

    static _CharacterInfo _character0001D192 =
    {
        0x0001D192,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D192,
        0x0001D192,
        0x0001D192
    };

    static _CharacterInfo _character0001D193 =
    {
        0x0001D193,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D193,
        0x0001D193,
        0x0001D193
    };

    static _CharacterInfo _character0001D194 =
    {
        0x0001D194,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D194,
        0x0001D194,
        0x0001D194
    };

    static _CharacterInfo _character0001D195 =
    {
        0x0001D195,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D195,
        0x0001D195,
        0x0001D195
    };

    static _CharacterInfo _character0001D196 =
    {
        0x0001D196,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D196,
        0x0001D196,
        0x0001D196
    };

    static _CharacterInfo _character0001D197 =
    {
        0x0001D197,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D197,
        0x0001D197,
        0x0001D197
    };

    static _CharacterInfo _character0001D198 =
    {
        0x0001D198,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D198,
        0x0001D198,
        0x0001D198
    };

    static _CharacterInfo _character0001D199 =
    {
        0x0001D199,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D199,
        0x0001D199,
        0x0001D199
    };

    static _CharacterInfo _character0001D19A =
    {
        0x0001D19A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19A,
        0x0001D19A,
        0x0001D19A
    };

    static _CharacterInfo _character0001D19B =
    {
        0x0001D19B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19B,
        0x0001D19B,
        0x0001D19B
    };

    static _CharacterInfo _character0001D19C =
    {
        0x0001D19C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19C,
        0x0001D19C,
        0x0001D19C
    };

    static _CharacterInfo _character0001D19D =
    {
        0x0001D19D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19D,
        0x0001D19D,
        0x0001D19D
    };

    static _CharacterInfo _character0001D19E =
    {
        0x0001D19E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19E,
        0x0001D19E,
        0x0001D19E
    };

    static _CharacterInfo _character0001D19F =
    {
        0x0001D19F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D19F,
        0x0001D19F,
        0x0001D19F
    };

    static _CharacterInfo _character0001D1A0 =
    {
        0x0001D1A0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A0,
        0x0001D1A0,
        0x0001D1A0
    };

    static _CharacterInfo _character0001D1A1 =
    {
        0x0001D1A1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A1,
        0x0001D1A1,
        0x0001D1A1
    };

    static _CharacterInfo _character0001D1A2 =
    {
        0x0001D1A2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A2,
        0x0001D1A2,
        0x0001D1A2
    };

    static _CharacterInfo _character0001D1A3 =
    {
        0x0001D1A3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A3,
        0x0001D1A3,
        0x0001D1A3
    };

    static _CharacterInfo _character0001D1A4 =
    {
        0x0001D1A4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A4,
        0x0001D1A4,
        0x0001D1A4
    };

    static _CharacterInfo _character0001D1A5 =
    {
        0x0001D1A5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A5,
        0x0001D1A5,
        0x0001D1A5
    };

    static _CharacterInfo _character0001D1A6 =
    {
        0x0001D1A6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A6,
        0x0001D1A6,
        0x0001D1A6
    };

    static _CharacterInfo _character0001D1A7 =
    {
        0x0001D1A7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A7,
        0x0001D1A7,
        0x0001D1A7
    };

    static _CharacterInfo _character0001D1A8 =
    {
        0x0001D1A8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A8,
        0x0001D1A8,
        0x0001D1A8
    };

    static _CharacterInfo _character0001D1A9 =
    {
        0x0001D1A9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1A9,
        0x0001D1A9,
        0x0001D1A9
    };

    static _CharacterInfo _character0001D1AA =
    {
        0x0001D1AA,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AA,
        0x0001D1AA,
        0x0001D1AA
    };

    static _CharacterInfo _character0001D1AB =
    {
        0x0001D1AB,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AB,
        0x0001D1AB,
        0x0001D1AB
    };

    static _CharacterInfo _character0001D1AC =
    {
        0x0001D1AC,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AC,
        0x0001D1AC,
        0x0001D1AC
    };

    static _CharacterInfo _character0001D1AD =
    {
        0x0001D1AD,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AD,
        0x0001D1AD,
        0x0001D1AD
    };

    static _CharacterInfo _character0001D1AE =
    {
        0x0001D1AE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AE,
        0x0001D1AE,
        0x0001D1AE
    };

    static _CharacterInfo _character0001D1AF =
    {
        0x0001D1AF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1AF,
        0x0001D1AF,
        0x0001D1AF
    };

    static _CharacterInfo _character0001D1B0 =
    {
        0x0001D1B0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B0,
        0x0001D1B0,
        0x0001D1B0
    };

    static _CharacterInfo _character0001D1B1 =
    {
        0x0001D1B1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B1,
        0x0001D1B1,
        0x0001D1B1
    };

    static _CharacterInfo _character0001D1B2 =
    {
        0x0001D1B2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B2,
        0x0001D1B2,
        0x0001D1B2
    };

    static _CharacterInfo _character0001D1B3 =
    {
        0x0001D1B3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B3,
        0x0001D1B3,
        0x0001D1B3
    };

    static _CharacterInfo _character0001D1B4 =
    {
        0x0001D1B4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B4,
        0x0001D1B4,
        0x0001D1B4
    };

    static _CharacterInfo _character0001D1B5 =
    {
        0x0001D1B5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B5,
        0x0001D1B5,
        0x0001D1B5
    };

    static _CharacterInfo _character0001D1B6 =
    {
        0x0001D1B6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B6,
        0x0001D1B6,
        0x0001D1B6
    };

    static _CharacterInfo _character0001D1B7 =
    {
        0x0001D1B7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B7,
        0x0001D1B7,
        0x0001D1B7
    };

    static _CharacterInfo _character0001D1B8 =
    {
        0x0001D1B8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B8,
        0x0001D1B8,
        0x0001D1B8
    };

    static _CharacterInfo _character0001D1B9 =
    {
        0x0001D1B9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1B9,
        0x0001D1B9,
        0x0001D1B9
    };

    static _CharacterInfo _character0001D1BA =
    {
        0x0001D1BA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BA,
        0x0001D1BA,
        0x0001D1BA
    };

    static Char _decompositionMapping0001D1BB[] = 
    {
        0x0001D1B9,
        0x0001D165
    };

    static _CharacterInfo _character0001D1BB =
    {
        0x0001D1BB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BB,
        0x0001D1BB,
        0x0001D1BB
    };

    static Char _decompositionMapping0001D1BC[] = 
    {
        0x0001D1BA,
        0x0001D165
    };

    static _CharacterInfo _character0001D1BC =
    {
        0x0001D1BC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BC,
        0x0001D1BC,
        0x0001D1BC
    };

    static Char _decompositionMapping0001D1BD[] = 
    {
        0x0001D1BB,
        0x0001D16E
    };

    static _CharacterInfo _character0001D1BD =
    {
        0x0001D1BD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BD,
        0x0001D1BD,
        0x0001D1BD
    };

    static Char _decompositionMapping0001D1BE[] = 
    {
        0x0001D1BC,
        0x0001D16E
    };

    static _CharacterInfo _character0001D1BE =
    {
        0x0001D1BE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BE,
        0x0001D1BE,
        0x0001D1BE
    };

    static Char _decompositionMapping0001D1BF[] = 
    {
        0x0001D1BB,
        0x0001D16F
    };

    static _CharacterInfo _character0001D1BF =
    {
        0x0001D1BF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1BF,
        0x0001D1BF,
        0x0001D1BF
    };

    static Char _decompositionMapping0001D1C0[] = 
    {
        0x0001D1BC,
        0x0001D16F
    };

    static _CharacterInfo _character0001D1C0 =
    {
        0x0001D1C0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        2,
        _decompositionMapping0001D1C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C0,
        0x0001D1C0,
        0x0001D1C0
    };

    static _CharacterInfo _character0001D1C1 =
    {
        0x0001D1C1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C1,
        0x0001D1C1,
        0x0001D1C1
    };

    static _CharacterInfo _character0001D1C2 =
    {
        0x0001D1C2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C2,
        0x0001D1C2,
        0x0001D1C2
    };

    static _CharacterInfo _character0001D1C3 =
    {
        0x0001D1C3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C3,
        0x0001D1C3,
        0x0001D1C3
    };

    static _CharacterInfo _character0001D1C4 =
    {
        0x0001D1C4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C4,
        0x0001D1C4,
        0x0001D1C4
    };

    static _CharacterInfo _character0001D1C5 =
    {
        0x0001D1C5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C5,
        0x0001D1C5,
        0x0001D1C5
    };

    static _CharacterInfo _character0001D1C6 =
    {
        0x0001D1C6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C6,
        0x0001D1C6,
        0x0001D1C6
    };

    static _CharacterInfo _character0001D1C7 =
    {
        0x0001D1C7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C7,
        0x0001D1C7,
        0x0001D1C7
    };

    static _CharacterInfo _character0001D1C8 =
    {
        0x0001D1C8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C8,
        0x0001D1C8,
        0x0001D1C8
    };

    static _CharacterInfo _character0001D1C9 =
    {
        0x0001D1C9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1C9,
        0x0001D1C9,
        0x0001D1C9
    };

    static _CharacterInfo _character0001D1CA =
    {
        0x0001D1CA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CA,
        0x0001D1CA,
        0x0001D1CA
    };

    static _CharacterInfo _character0001D1CB =
    {
        0x0001D1CB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CB,
        0x0001D1CB,
        0x0001D1CB
    };

    static _CharacterInfo _character0001D1CC =
    {
        0x0001D1CC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CC,
        0x0001D1CC,
        0x0001D1CC
    };

    static _CharacterInfo _character0001D1CD =
    {
        0x0001D1CD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CD,
        0x0001D1CD,
        0x0001D1CD
    };

    static _CharacterInfo _character0001D1CE =
    {
        0x0001D1CE,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CE,
        0x0001D1CE,
        0x0001D1CE
    };

    static _CharacterInfo _character0001D1CF =
    {
        0x0001D1CF,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1CF,
        0x0001D1CF,
        0x0001D1CF
    };

    static _CharacterInfo _character0001D1D0 =
    {
        0x0001D1D0,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D0,
        0x0001D1D0,
        0x0001D1D0
    };

    static _CharacterInfo _character0001D1D1 =
    {
        0x0001D1D1,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D1,
        0x0001D1D1,
        0x0001D1D1
    };

    static _CharacterInfo _character0001D1D2 =
    {
        0x0001D1D2,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D2,
        0x0001D1D2,
        0x0001D1D2
    };

    static _CharacterInfo _character0001D1D3 =
    {
        0x0001D1D3,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D3,
        0x0001D1D3,
        0x0001D1D3
    };

    static _CharacterInfo _character0001D1D4 =
    {
        0x0001D1D4,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D4,
        0x0001D1D4,
        0x0001D1D4
    };

    static _CharacterInfo _character0001D1D5 =
    {
        0x0001D1D5,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D5,
        0x0001D1D5,
        0x0001D1D5
    };

    static _CharacterInfo _character0001D1D6 =
    {
        0x0001D1D6,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D6,
        0x0001D1D6,
        0x0001D1D6
    };

    static _CharacterInfo _character0001D1D7 =
    {
        0x0001D1D7,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D7,
        0x0001D1D7,
        0x0001D1D7
    };

    static _CharacterInfo _character0001D1D8 =
    {
        0x0001D1D8,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D8,
        0x0001D1D8,
        0x0001D1D8
    };

    static _CharacterInfo _character0001D1D9 =
    {
        0x0001D1D9,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1D9,
        0x0001D1D9,
        0x0001D1D9
    };

    static _CharacterInfo _character0001D1DA =
    {
        0x0001D1DA,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1DA,
        0x0001D1DA,
        0x0001D1DA
    };

    static _CharacterInfo _character0001D1DB =
    {
        0x0001D1DB,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1DB,
        0x0001D1DB,
        0x0001D1DB
    };

    static _CharacterInfo _character0001D1DC =
    {
        0x0001D1DC,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1DC,
        0x0001D1DC,
        0x0001D1DC
    };

    static _CharacterInfo _character0001D1DD =
    {
        0x0001D1DD,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D1DD,
        0x0001D1DD,
        0x0001D1DD
    };

    static _CharacterInfo _character0001D200 =
    {
        0x0001D200,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D200,
        0x0001D200,
        0x0001D200
    };

    static _CharacterInfo _character0001D201 =
    {
        0x0001D201,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D201,
        0x0001D201,
        0x0001D201
    };

    static _CharacterInfo _character0001D202 =
    {
        0x0001D202,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D202,
        0x0001D202,
        0x0001D202
    };

    static _CharacterInfo _character0001D203 =
    {
        0x0001D203,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D203,
        0x0001D203,
        0x0001D203
    };

    static _CharacterInfo _character0001D204 =
    {
        0x0001D204,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D204,
        0x0001D204,
        0x0001D204
    };

    static _CharacterInfo _character0001D205 =
    {
        0x0001D205,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D205,
        0x0001D205,
        0x0001D205
    };

    static _CharacterInfo _character0001D206 =
    {
        0x0001D206,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D206,
        0x0001D206,
        0x0001D206
    };

    static _CharacterInfo _character0001D207 =
    {
        0x0001D207,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D207,
        0x0001D207,
        0x0001D207
    };

    static _CharacterInfo _character0001D208 =
    {
        0x0001D208,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D208,
        0x0001D208,
        0x0001D208
    };

    static _CharacterInfo _character0001D209 =
    {
        0x0001D209,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D209,
        0x0001D209,
        0x0001D209
    };

    static _CharacterInfo _character0001D20A =
    {
        0x0001D20A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20A,
        0x0001D20A,
        0x0001D20A
    };

    static _CharacterInfo _character0001D20B =
    {
        0x0001D20B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20B,
        0x0001D20B,
        0x0001D20B
    };

    static _CharacterInfo _character0001D20C =
    {
        0x0001D20C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20C,
        0x0001D20C,
        0x0001D20C
    };

    static _CharacterInfo _character0001D20D =
    {
        0x0001D20D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20D,
        0x0001D20D,
        0x0001D20D
    };

    static _CharacterInfo _character0001D20E =
    {
        0x0001D20E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20E,
        0x0001D20E,
        0x0001D20E
    };

    static _CharacterInfo _character0001D20F =
    {
        0x0001D20F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D20F,
        0x0001D20F,
        0x0001D20F
    };

    static _CharacterInfo _character0001D210 =
    {
        0x0001D210,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D210,
        0x0001D210,
        0x0001D210
    };

    static _CharacterInfo _character0001D211 =
    {
        0x0001D211,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D211,
        0x0001D211,
        0x0001D211
    };

    static _CharacterInfo _character0001D212 =
    {
        0x0001D212,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D212,
        0x0001D212,
        0x0001D212
    };

    static _CharacterInfo _character0001D213 =
    {
        0x0001D213,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D213,
        0x0001D213,
        0x0001D213
    };

    static _CharacterInfo _character0001D214 =
    {
        0x0001D214,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D214,
        0x0001D214,
        0x0001D214
    };

    static _CharacterInfo _character0001D215 =
    {
        0x0001D215,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D215,
        0x0001D215,
        0x0001D215
    };

    static _CharacterInfo _character0001D216 =
    {
        0x0001D216,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D216,
        0x0001D216,
        0x0001D216
    };

    static _CharacterInfo _character0001D217 =
    {
        0x0001D217,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D217,
        0x0001D217,
        0x0001D217
    };

    static _CharacterInfo _character0001D218 =
    {
        0x0001D218,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D218,
        0x0001D218,
        0x0001D218
    };

    static _CharacterInfo _character0001D219 =
    {
        0x0001D219,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D219,
        0x0001D219,
        0x0001D219
    };

    static _CharacterInfo _character0001D21A =
    {
        0x0001D21A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21A,
        0x0001D21A,
        0x0001D21A
    };

    static _CharacterInfo _character0001D21B =
    {
        0x0001D21B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21B,
        0x0001D21B,
        0x0001D21B
    };

    static _CharacterInfo _character0001D21C =
    {
        0x0001D21C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21C,
        0x0001D21C,
        0x0001D21C
    };

    static _CharacterInfo _character0001D21D =
    {
        0x0001D21D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21D,
        0x0001D21D,
        0x0001D21D
    };

    static _CharacterInfo _character0001D21E =
    {
        0x0001D21E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21E,
        0x0001D21E,
        0x0001D21E
    };

    static _CharacterInfo _character0001D21F =
    {
        0x0001D21F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D21F,
        0x0001D21F,
        0x0001D21F
    };

    static _CharacterInfo _character0001D220 =
    {
        0x0001D220,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D220,
        0x0001D220,
        0x0001D220
    };

    static _CharacterInfo _character0001D221 =
    {
        0x0001D221,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D221,
        0x0001D221,
        0x0001D221
    };

    static _CharacterInfo _character0001D222 =
    {
        0x0001D222,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D222,
        0x0001D222,
        0x0001D222
    };

    static _CharacterInfo _character0001D223 =
    {
        0x0001D223,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D223,
        0x0001D223,
        0x0001D223
    };

    static _CharacterInfo _character0001D224 =
    {
        0x0001D224,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D224,
        0x0001D224,
        0x0001D224
    };

    static _CharacterInfo _character0001D225 =
    {
        0x0001D225,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D225,
        0x0001D225,
        0x0001D225
    };

    static _CharacterInfo _character0001D226 =
    {
        0x0001D226,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D226,
        0x0001D226,
        0x0001D226
    };

    static _CharacterInfo _character0001D227 =
    {
        0x0001D227,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D227,
        0x0001D227,
        0x0001D227
    };

    static _CharacterInfo _character0001D228 =
    {
        0x0001D228,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D228,
        0x0001D228,
        0x0001D228
    };

    static _CharacterInfo _character0001D229 =
    {
        0x0001D229,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D229,
        0x0001D229,
        0x0001D229
    };

    static _CharacterInfo _character0001D22A =
    {
        0x0001D22A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22A,
        0x0001D22A,
        0x0001D22A
    };

    static _CharacterInfo _character0001D22B =
    {
        0x0001D22B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22B,
        0x0001D22B,
        0x0001D22B
    };

    static _CharacterInfo _character0001D22C =
    {
        0x0001D22C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22C,
        0x0001D22C,
        0x0001D22C
    };

    static _CharacterInfo _character0001D22D =
    {
        0x0001D22D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22D,
        0x0001D22D,
        0x0001D22D
    };

    static _CharacterInfo _character0001D22E =
    {
        0x0001D22E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22E,
        0x0001D22E,
        0x0001D22E
    };

    static _CharacterInfo _character0001D22F =
    {
        0x0001D22F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D22F,
        0x0001D22F,
        0x0001D22F
    };

    static _CharacterInfo _character0001D230 =
    {
        0x0001D230,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D230,
        0x0001D230,
        0x0001D230
    };

    static _CharacterInfo _character0001D231 =
    {
        0x0001D231,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D231,
        0x0001D231,
        0x0001D231
    };

    static _CharacterInfo _character0001D232 =
    {
        0x0001D232,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D232,
        0x0001D232,
        0x0001D232
    };

    static _CharacterInfo _character0001D233 =
    {
        0x0001D233,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D233,
        0x0001D233,
        0x0001D233
    };

    static _CharacterInfo _character0001D234 =
    {
        0x0001D234,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D234,
        0x0001D234,
        0x0001D234
    };

    static _CharacterInfo _character0001D235 =
    {
        0x0001D235,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D235,
        0x0001D235,
        0x0001D235
    };

    static _CharacterInfo _character0001D236 =
    {
        0x0001D236,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D236,
        0x0001D236,
        0x0001D236
    };

    static _CharacterInfo _character0001D237 =
    {
        0x0001D237,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D237,
        0x0001D237,
        0x0001D237
    };

    static _CharacterInfo _character0001D238 =
    {
        0x0001D238,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D238,
        0x0001D238,
        0x0001D238
    };

    static _CharacterInfo _character0001D239 =
    {
        0x0001D239,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D239,
        0x0001D239,
        0x0001D239
    };

    static _CharacterInfo _character0001D23A =
    {
        0x0001D23A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23A,
        0x0001D23A,
        0x0001D23A
    };

    static _CharacterInfo _character0001D23B =
    {
        0x0001D23B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23B,
        0x0001D23B,
        0x0001D23B
    };

    static _CharacterInfo _character0001D23C =
    {
        0x0001D23C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23C,
        0x0001D23C,
        0x0001D23C
    };

    static _CharacterInfo _character0001D23D =
    {
        0x0001D23D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23D,
        0x0001D23D,
        0x0001D23D
    };

    static _CharacterInfo _character0001D23E =
    {
        0x0001D23E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23E,
        0x0001D23E,
        0x0001D23E
    };

    static _CharacterInfo _character0001D23F =
    {
        0x0001D23F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D23F,
        0x0001D23F,
        0x0001D23F
    };

    static _CharacterInfo _character0001D240 =
    {
        0x0001D240,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D240,
        0x0001D240,
        0x0001D240
    };

    static _CharacterInfo _character0001D241 =
    {
        0x0001D241,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D241,
        0x0001D241,
        0x0001D241
    };

    static _CharacterInfo _character0001D242 =
    {
        0x0001D242,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D242,
        0x0001D242,
        0x0001D242
    };

    static _CharacterInfo _character0001D243 =
    {
        0x0001D243,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D243,
        0x0001D243,
        0x0001D243
    };

    static _CharacterInfo _character0001D244 =
    {
        0x0001D244,
        Iso10646::GeneralCategory_Mn,
        230,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D244,
        0x0001D244,
        0x0001D244
    };

    static _CharacterInfo _character0001D245 =
    {
        0x0001D245,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D245,
        0x0001D245,
        0x0001D245
    };

    static _CharacterInfo _character0001D300 =
    {
        0x0001D300,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D300,
        0x0001D300,
        0x0001D300
    };

    static _CharacterInfo _character0001D301 =
    {
        0x0001D301,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D301,
        0x0001D301,
        0x0001D301
    };

    static _CharacterInfo _character0001D302 =
    {
        0x0001D302,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D302,
        0x0001D302,
        0x0001D302
    };

    static _CharacterInfo _character0001D303 =
    {
        0x0001D303,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D303,
        0x0001D303,
        0x0001D303
    };

    static _CharacterInfo _character0001D304 =
    {
        0x0001D304,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D304,
        0x0001D304,
        0x0001D304
    };

    static _CharacterInfo _character0001D305 =
    {
        0x0001D305,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D305,
        0x0001D305,
        0x0001D305
    };

    static _CharacterInfo _character0001D306 =
    {
        0x0001D306,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D306,
        0x0001D306,
        0x0001D306
    };

    static _CharacterInfo _character0001D307 =
    {
        0x0001D307,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D307,
        0x0001D307,
        0x0001D307
    };

    static _CharacterInfo _character0001D308 =
    {
        0x0001D308,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D308,
        0x0001D308,
        0x0001D308
    };

    static _CharacterInfo _character0001D309 =
    {
        0x0001D309,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D309,
        0x0001D309,
        0x0001D309
    };

    static _CharacterInfo _character0001D30A =
    {
        0x0001D30A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30A,
        0x0001D30A,
        0x0001D30A
    };

    static _CharacterInfo _character0001D30B =
    {
        0x0001D30B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30B,
        0x0001D30B,
        0x0001D30B
    };

    static _CharacterInfo _character0001D30C =
    {
        0x0001D30C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30C,
        0x0001D30C,
        0x0001D30C
    };

    static _CharacterInfo _character0001D30D =
    {
        0x0001D30D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30D,
        0x0001D30D,
        0x0001D30D
    };

    static _CharacterInfo _character0001D30E =
    {
        0x0001D30E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30E,
        0x0001D30E,
        0x0001D30E
    };

    static _CharacterInfo _character0001D30F =
    {
        0x0001D30F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D30F,
        0x0001D30F,
        0x0001D30F
    };

    static _CharacterInfo _character0001D310 =
    {
        0x0001D310,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D310,
        0x0001D310,
        0x0001D310
    };

    static _CharacterInfo _character0001D311 =
    {
        0x0001D311,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D311,
        0x0001D311,
        0x0001D311
    };

    static _CharacterInfo _character0001D312 =
    {
        0x0001D312,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D312,
        0x0001D312,
        0x0001D312
    };

    static _CharacterInfo _character0001D313 =
    {
        0x0001D313,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D313,
        0x0001D313,
        0x0001D313
    };

    static _CharacterInfo _character0001D314 =
    {
        0x0001D314,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D314,
        0x0001D314,
        0x0001D314
    };

    static _CharacterInfo _character0001D315 =
    {
        0x0001D315,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D315,
        0x0001D315,
        0x0001D315
    };

    static _CharacterInfo _character0001D316 =
    {
        0x0001D316,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D316,
        0x0001D316,
        0x0001D316
    };

    static _CharacterInfo _character0001D317 =
    {
        0x0001D317,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D317,
        0x0001D317,
        0x0001D317
    };

    static _CharacterInfo _character0001D318 =
    {
        0x0001D318,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D318,
        0x0001D318,
        0x0001D318
    };

    static _CharacterInfo _character0001D319 =
    {
        0x0001D319,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D319,
        0x0001D319,
        0x0001D319
    };

    static _CharacterInfo _character0001D31A =
    {
        0x0001D31A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31A,
        0x0001D31A,
        0x0001D31A
    };

    static _CharacterInfo _character0001D31B =
    {
        0x0001D31B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31B,
        0x0001D31B,
        0x0001D31B
    };

    static _CharacterInfo _character0001D31C =
    {
        0x0001D31C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31C,
        0x0001D31C,
        0x0001D31C
    };

    static _CharacterInfo _character0001D31D =
    {
        0x0001D31D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31D,
        0x0001D31D,
        0x0001D31D
    };

    static _CharacterInfo _character0001D31E =
    {
        0x0001D31E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31E,
        0x0001D31E,
        0x0001D31E
    };

    static _CharacterInfo _character0001D31F =
    {
        0x0001D31F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D31F,
        0x0001D31F,
        0x0001D31F
    };

    static _CharacterInfo _character0001D320 =
    {
        0x0001D320,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D320,
        0x0001D320,
        0x0001D320
    };

    static _CharacterInfo _character0001D321 =
    {
        0x0001D321,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D321,
        0x0001D321,
        0x0001D321
    };

    static _CharacterInfo _character0001D322 =
    {
        0x0001D322,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D322,
        0x0001D322,
        0x0001D322
    };

    static _CharacterInfo _character0001D323 =
    {
        0x0001D323,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D323,
        0x0001D323,
        0x0001D323
    };

    static _CharacterInfo _character0001D324 =
    {
        0x0001D324,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D324,
        0x0001D324,
        0x0001D324
    };

    static _CharacterInfo _character0001D325 =
    {
        0x0001D325,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D325,
        0x0001D325,
        0x0001D325
    };

    static _CharacterInfo _character0001D326 =
    {
        0x0001D326,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D326,
        0x0001D326,
        0x0001D326
    };

    static _CharacterInfo _character0001D327 =
    {
        0x0001D327,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D327,
        0x0001D327,
        0x0001D327
    };

    static _CharacterInfo _character0001D328 =
    {
        0x0001D328,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D328,
        0x0001D328,
        0x0001D328
    };

    static _CharacterInfo _character0001D329 =
    {
        0x0001D329,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D329,
        0x0001D329,
        0x0001D329
    };

    static _CharacterInfo _character0001D32A =
    {
        0x0001D32A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32A,
        0x0001D32A,
        0x0001D32A
    };

    static _CharacterInfo _character0001D32B =
    {
        0x0001D32B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32B,
        0x0001D32B,
        0x0001D32B
    };

    static _CharacterInfo _character0001D32C =
    {
        0x0001D32C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32C,
        0x0001D32C,
        0x0001D32C
    };

    static _CharacterInfo _character0001D32D =
    {
        0x0001D32D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32D,
        0x0001D32D,
        0x0001D32D
    };

    static _CharacterInfo _character0001D32E =
    {
        0x0001D32E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32E,
        0x0001D32E,
        0x0001D32E
    };

    static _CharacterInfo _character0001D32F =
    {
        0x0001D32F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D32F,
        0x0001D32F,
        0x0001D32F
    };

    static _CharacterInfo _character0001D330 =
    {
        0x0001D330,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D330,
        0x0001D330,
        0x0001D330
    };

    static _CharacterInfo _character0001D331 =
    {
        0x0001D331,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D331,
        0x0001D331,
        0x0001D331
    };

    static _CharacterInfo _character0001D332 =
    {
        0x0001D332,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D332,
        0x0001D332,
        0x0001D332
    };

    static _CharacterInfo _character0001D333 =
    {
        0x0001D333,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D333,
        0x0001D333,
        0x0001D333
    };

    static _CharacterInfo _character0001D334 =
    {
        0x0001D334,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D334,
        0x0001D334,
        0x0001D334
    };

    static _CharacterInfo _character0001D335 =
    {
        0x0001D335,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D335,
        0x0001D335,
        0x0001D335
    };

    static _CharacterInfo _character0001D336 =
    {
        0x0001D336,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D336,
        0x0001D336,
        0x0001D336
    };

    static _CharacterInfo _character0001D337 =
    {
        0x0001D337,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D337,
        0x0001D337,
        0x0001D337
    };

    static _CharacterInfo _character0001D338 =
    {
        0x0001D338,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D338,
        0x0001D338,
        0x0001D338
    };

    static _CharacterInfo _character0001D339 =
    {
        0x0001D339,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D339,
        0x0001D339,
        0x0001D339
    };

    static _CharacterInfo _character0001D33A =
    {
        0x0001D33A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33A,
        0x0001D33A,
        0x0001D33A
    };

    static _CharacterInfo _character0001D33B =
    {
        0x0001D33B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33B,
        0x0001D33B,
        0x0001D33B
    };

    static _CharacterInfo _character0001D33C =
    {
        0x0001D33C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33C,
        0x0001D33C,
        0x0001D33C
    };

    static _CharacterInfo _character0001D33D =
    {
        0x0001D33D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33D,
        0x0001D33D,
        0x0001D33D
    };

    static _CharacterInfo _character0001D33E =
    {
        0x0001D33E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33E,
        0x0001D33E,
        0x0001D33E
    };

    static _CharacterInfo _character0001D33F =
    {
        0x0001D33F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D33F,
        0x0001D33F,
        0x0001D33F
    };

    static _CharacterInfo _character0001D340 =
    {
        0x0001D340,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D340,
        0x0001D340,
        0x0001D340
    };

    static _CharacterInfo _character0001D341 =
    {
        0x0001D341,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D341,
        0x0001D341,
        0x0001D341
    };

    static _CharacterInfo _character0001D342 =
    {
        0x0001D342,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D342,
        0x0001D342,
        0x0001D342
    };

    static _CharacterInfo _character0001D343 =
    {
        0x0001D343,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D343,
        0x0001D343,
        0x0001D343
    };

    static _CharacterInfo _character0001D344 =
    {
        0x0001D344,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D344,
        0x0001D344,
        0x0001D344
    };

    static _CharacterInfo _character0001D345 =
    {
        0x0001D345,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D345,
        0x0001D345,
        0x0001D345
    };

    static _CharacterInfo _character0001D346 =
    {
        0x0001D346,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D346,
        0x0001D346,
        0x0001D346
    };

    static _CharacterInfo _character0001D347 =
    {
        0x0001D347,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D347,
        0x0001D347,
        0x0001D347
    };

    static _CharacterInfo _character0001D348 =
    {
        0x0001D348,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D348,
        0x0001D348,
        0x0001D348
    };

    static _CharacterInfo _character0001D349 =
    {
        0x0001D349,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D349,
        0x0001D349,
        0x0001D349
    };

    static _CharacterInfo _character0001D34A =
    {
        0x0001D34A,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34A,
        0x0001D34A,
        0x0001D34A
    };

    static _CharacterInfo _character0001D34B =
    {
        0x0001D34B,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34B,
        0x0001D34B,
        0x0001D34B
    };

    static _CharacterInfo _character0001D34C =
    {
        0x0001D34C,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34C,
        0x0001D34C,
        0x0001D34C
    };

    static _CharacterInfo _character0001D34D =
    {
        0x0001D34D,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34D,
        0x0001D34D,
        0x0001D34D
    };

    static _CharacterInfo _character0001D34E =
    {
        0x0001D34E,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34E,
        0x0001D34E,
        0x0001D34E
    };

    static _CharacterInfo _character0001D34F =
    {
        0x0001D34F,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D34F,
        0x0001D34F,
        0x0001D34F
    };

    static _CharacterInfo _character0001D350 =
    {
        0x0001D350,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D350,
        0x0001D350,
        0x0001D350
    };

    static _CharacterInfo _character0001D351 =
    {
        0x0001D351,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D351,
        0x0001D351,
        0x0001D351
    };

    static _CharacterInfo _character0001D352 =
    {
        0x0001D352,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D352,
        0x0001D352,
        0x0001D352
    };

    static _CharacterInfo _character0001D353 =
    {
        0x0001D353,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D353,
        0x0001D353,
        0x0001D353
    };

    static _CharacterInfo _character0001D354 =
    {
        0x0001D354,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D354,
        0x0001D354,
        0x0001D354
    };

    static _CharacterInfo _character0001D355 =
    {
        0x0001D355,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D355,
        0x0001D355,
        0x0001D355
    };

    static _CharacterInfo _character0001D356 =
    {
        0x0001D356,
        Iso10646::GeneralCategory_So,
        0,
        Iso10646::BidirectionalCategory_ON,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D356,
        0x0001D356,
        0x0001D356
    };

    static _CharacterInfo _character0001D360 =
    {
        0x0001D360,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        1,
        1,
        false,
        0x0001D360,
        0x0001D360,
        0x0001D360
    };

    static _CharacterInfo _character0001D361 =
    {
        0x0001D361,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        2,
        1,
        false,
        0x0001D361,
        0x0001D361,
        0x0001D361
    };

    static _CharacterInfo _character0001D362 =
    {
        0x0001D362,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        3,
        1,
        false,
        0x0001D362,
        0x0001D362,
        0x0001D362
    };

    static _CharacterInfo _character0001D363 =
    {
        0x0001D363,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        4,
        1,
        false,
        0x0001D363,
        0x0001D363,
        0x0001D363
    };

    static _CharacterInfo _character0001D364 =
    {
        0x0001D364,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        5,
        1,
        false,
        0x0001D364,
        0x0001D364,
        0x0001D364
    };

    static _CharacterInfo _character0001D365 =
    {
        0x0001D365,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        6,
        1,
        false,
        0x0001D365,
        0x0001D365,
        0x0001D365
    };

    static _CharacterInfo _character0001D366 =
    {
        0x0001D366,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        7,
        1,
        false,
        0x0001D366,
        0x0001D366,
        0x0001D366
    };

    static _CharacterInfo _character0001D367 =
    {
        0x0001D367,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        8,
        1,
        false,
        0x0001D367,
        0x0001D367,
        0x0001D367
    };

    static _CharacterInfo _character0001D368 =
    {
        0x0001D368,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        9,
        1,
        false,
        0x0001D368,
        0x0001D368,
        0x0001D368
    };

    static _CharacterInfo _character0001D369 =
    {
        0x0001D369,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        10,
        1,
        false,
        0x0001D369,
        0x0001D369,
        0x0001D369
    };

    static _CharacterInfo _character0001D36A =
    {
        0x0001D36A,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        20,
        1,
        false,
        0x0001D36A,
        0x0001D36A,
        0x0001D36A
    };

    static _CharacterInfo _character0001D36B =
    {
        0x0001D36B,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        30,
        1,
        false,
        0x0001D36B,
        0x0001D36B,
        0x0001D36B
    };

    static _CharacterInfo _character0001D36C =
    {
        0x0001D36C,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        40,
        1,
        false,
        0x0001D36C,
        0x0001D36C,
        0x0001D36C
    };

    static _CharacterInfo _character0001D36D =
    {
        0x0001D36D,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        50,
        1,
        false,
        0x0001D36D,
        0x0001D36D,
        0x0001D36D
    };

    static _CharacterInfo _character0001D36E =
    {
        0x0001D36E,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        60,
        1,
        false,
        0x0001D36E,
        0x0001D36E,
        0x0001D36E
    };

    static _CharacterInfo _character0001D36F =
    {
        0x0001D36F,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        70,
        1,
        false,
        0x0001D36F,
        0x0001D36F,
        0x0001D36F
    };

    static _CharacterInfo _character0001D370 =
    {
        0x0001D370,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        80,
        1,
        false,
        0x0001D370,
        0x0001D370,
        0x0001D370
    };

    static _CharacterInfo _character0001D371 =
    {
        0x0001D371,
        Iso10646::GeneralCategory_No,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        true,
        90,
        1,
        false,
        0x0001D371,
        0x0001D371,
        0x0001D371
    };

    static Char _decompositionMapping0001D400[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D400 =
    {
        0x0001D400,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D400,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D400,
        0x0001D400,
        0x0001D400
    };

    static Char _decompositionMapping0001D401[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D401 =
    {
        0x0001D401,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D401,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D401,
        0x0001D401,
        0x0001D401
    };

    static Char _decompositionMapping0001D402[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D402 =
    {
        0x0001D402,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D402,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D402,
        0x0001D402,
        0x0001D402
    };

    static Char _decompositionMapping0001D403[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D403 =
    {
        0x0001D403,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D403,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D403,
        0x0001D403,
        0x0001D403
    };

    static Char _decompositionMapping0001D404[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D404 =
    {
        0x0001D404,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D404,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D404,
        0x0001D404,
        0x0001D404
    };

    static Char _decompositionMapping0001D405[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D405 =
    {
        0x0001D405,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D405,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D405,
        0x0001D405,
        0x0001D405
    };

    static Char _decompositionMapping0001D406[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D406 =
    {
        0x0001D406,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D406,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D406,
        0x0001D406,
        0x0001D406
    };

    static Char _decompositionMapping0001D407[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D407 =
    {
        0x0001D407,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D407,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D407,
        0x0001D407,
        0x0001D407
    };

    static Char _decompositionMapping0001D408[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D408 =
    {
        0x0001D408,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D408,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D408,
        0x0001D408,
        0x0001D408
    };

    static Char _decompositionMapping0001D409[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D409 =
    {
        0x0001D409,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D409,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D409,
        0x0001D409,
        0x0001D409
    };

    static Char _decompositionMapping0001D40A[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D40A =
    {
        0x0001D40A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40A,
        0x0001D40A,
        0x0001D40A
    };

    static Char _decompositionMapping0001D40B[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D40B =
    {
        0x0001D40B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40B,
        0x0001D40B,
        0x0001D40B
    };

    static Char _decompositionMapping0001D40C[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D40C =
    {
        0x0001D40C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40C,
        0x0001D40C,
        0x0001D40C
    };

    static Char _decompositionMapping0001D40D[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D40D =
    {
        0x0001D40D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40D,
        0x0001D40D,
        0x0001D40D
    };

    static Char _decompositionMapping0001D40E[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D40E =
    {
        0x0001D40E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40E,
        0x0001D40E,
        0x0001D40E
    };

    static Char _decompositionMapping0001D40F[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D40F =
    {
        0x0001D40F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D40F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D40F,
        0x0001D40F,
        0x0001D40F
    };

    static Char _decompositionMapping0001D410[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D410 =
    {
        0x0001D410,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D410,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D410,
        0x0001D410,
        0x0001D410
    };

    static Char _decompositionMapping0001D411[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D411 =
    {
        0x0001D411,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D411,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D411,
        0x0001D411,
        0x0001D411
    };

    static Char _decompositionMapping0001D412[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D412 =
    {
        0x0001D412,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D412,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D412,
        0x0001D412,
        0x0001D412
    };

    static Char _decompositionMapping0001D413[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D413 =
    {
        0x0001D413,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D413,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D413,
        0x0001D413,
        0x0001D413
    };

    static Char _decompositionMapping0001D414[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D414 =
    {
        0x0001D414,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D414,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D414,
        0x0001D414,
        0x0001D414
    };

    static Char _decompositionMapping0001D415[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D415 =
    {
        0x0001D415,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D415,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D415,
        0x0001D415,
        0x0001D415
    };

    static Char _decompositionMapping0001D416[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D416 =
    {
        0x0001D416,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D416,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D416,
        0x0001D416,
        0x0001D416
    };

    static Char _decompositionMapping0001D417[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D417 =
    {
        0x0001D417,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D417,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D417,
        0x0001D417,
        0x0001D417
    };

    static Char _decompositionMapping0001D418[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D418 =
    {
        0x0001D418,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D418,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D418,
        0x0001D418,
        0x0001D418
    };

    static Char _decompositionMapping0001D419[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D419 =
    {
        0x0001D419,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D419,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D419,
        0x0001D419,
        0x0001D419
    };

    static Char _decompositionMapping0001D41A[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D41A =
    {
        0x0001D41A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41A,
        0x0001D41A,
        0x0001D41A
    };

    static Char _decompositionMapping0001D41B[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D41B =
    {
        0x0001D41B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41B,
        0x0001D41B,
        0x0001D41B
    };

    static Char _decompositionMapping0001D41C[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D41C =
    {
        0x0001D41C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41C,
        0x0001D41C,
        0x0001D41C
    };

    static Char _decompositionMapping0001D41D[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D41D =
    {
        0x0001D41D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41D,
        0x0001D41D,
        0x0001D41D
    };

    static Char _decompositionMapping0001D41E[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D41E =
    {
        0x0001D41E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41E,
        0x0001D41E,
        0x0001D41E
    };

    static Char _decompositionMapping0001D41F[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D41F =
    {
        0x0001D41F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D41F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D41F,
        0x0001D41F,
        0x0001D41F
    };

    static Char _decompositionMapping0001D420[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D420 =
    {
        0x0001D420,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D420,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D420,
        0x0001D420,
        0x0001D420
    };

    static Char _decompositionMapping0001D421[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D421 =
    {
        0x0001D421,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D421,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D421,
        0x0001D421,
        0x0001D421
    };

    static Char _decompositionMapping0001D422[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D422 =
    {
        0x0001D422,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D422,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D422,
        0x0001D422,
        0x0001D422
    };

    static Char _decompositionMapping0001D423[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D423 =
    {
        0x0001D423,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D423,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D423,
        0x0001D423,
        0x0001D423
    };

    static Char _decompositionMapping0001D424[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D424 =
    {
        0x0001D424,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D424,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D424,
        0x0001D424,
        0x0001D424
    };

    static Char _decompositionMapping0001D425[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D425 =
    {
        0x0001D425,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D425,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D425,
        0x0001D425,
        0x0001D425
    };

    static Char _decompositionMapping0001D426[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D426 =
    {
        0x0001D426,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D426,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D426,
        0x0001D426,
        0x0001D426
    };

    static Char _decompositionMapping0001D427[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D427 =
    {
        0x0001D427,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D427,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D427,
        0x0001D427,
        0x0001D427
    };

    static Char _decompositionMapping0001D428[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D428 =
    {
        0x0001D428,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D428,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D428,
        0x0001D428,
        0x0001D428
    };

    static Char _decompositionMapping0001D429[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D429 =
    {
        0x0001D429,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D429,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D429,
        0x0001D429,
        0x0001D429
    };

    static Char _decompositionMapping0001D42A[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D42A =
    {
        0x0001D42A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42A,
        0x0001D42A,
        0x0001D42A
    };

    static Char _decompositionMapping0001D42B[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D42B =
    {
        0x0001D42B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42B,
        0x0001D42B,
        0x0001D42B
    };

    static Char _decompositionMapping0001D42C[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D42C =
    {
        0x0001D42C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42C,
        0x0001D42C,
        0x0001D42C
    };

    static Char _decompositionMapping0001D42D[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D42D =
    {
        0x0001D42D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42D,
        0x0001D42D,
        0x0001D42D
    };

    static Char _decompositionMapping0001D42E[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D42E =
    {
        0x0001D42E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42E,
        0x0001D42E,
        0x0001D42E
    };

    static Char _decompositionMapping0001D42F[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D42F =
    {
        0x0001D42F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D42F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D42F,
        0x0001D42F,
        0x0001D42F
    };

    static Char _decompositionMapping0001D430[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D430 =
    {
        0x0001D430,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D430,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D430,
        0x0001D430,
        0x0001D430
    };

    static Char _decompositionMapping0001D431[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D431 =
    {
        0x0001D431,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D431,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D431,
        0x0001D431,
        0x0001D431
    };

    static Char _decompositionMapping0001D432[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D432 =
    {
        0x0001D432,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D432,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D432,
        0x0001D432,
        0x0001D432
    };

    static Char _decompositionMapping0001D433[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D433 =
    {
        0x0001D433,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D433,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D433,
        0x0001D433,
        0x0001D433
    };

    static Char _decompositionMapping0001D434[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D434 =
    {
        0x0001D434,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D434,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D434,
        0x0001D434,
        0x0001D434
    };

    static Char _decompositionMapping0001D435[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D435 =
    {
        0x0001D435,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D435,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D435,
        0x0001D435,
        0x0001D435
    };

    static Char _decompositionMapping0001D436[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D436 =
    {
        0x0001D436,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D436,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D436,
        0x0001D436,
        0x0001D436
    };

    static Char _decompositionMapping0001D437[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D437 =
    {
        0x0001D437,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D437,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D437,
        0x0001D437,
        0x0001D437
    };

    static Char _decompositionMapping0001D438[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D438 =
    {
        0x0001D438,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D438,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D438,
        0x0001D438,
        0x0001D438
    };

    static Char _decompositionMapping0001D439[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D439 =
    {
        0x0001D439,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D439,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D439,
        0x0001D439,
        0x0001D439
    };

    static Char _decompositionMapping0001D43A[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D43A =
    {
        0x0001D43A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43A,
        0x0001D43A,
        0x0001D43A
    };

    static Char _decompositionMapping0001D43B[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D43B =
    {
        0x0001D43B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43B,
        0x0001D43B,
        0x0001D43B
    };

    static Char _decompositionMapping0001D43C[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D43C =
    {
        0x0001D43C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43C,
        0x0001D43C,
        0x0001D43C
    };

    static Char _decompositionMapping0001D43D[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D43D =
    {
        0x0001D43D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43D,
        0x0001D43D,
        0x0001D43D
    };

    static Char _decompositionMapping0001D43E[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D43E =
    {
        0x0001D43E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43E,
        0x0001D43E,
        0x0001D43E
    };

    static Char _decompositionMapping0001D43F[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D43F =
    {
        0x0001D43F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D43F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D43F,
        0x0001D43F,
        0x0001D43F
    };

    static Char _decompositionMapping0001D440[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D440 =
    {
        0x0001D440,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D440,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D440,
        0x0001D440,
        0x0001D440
    };

    static Char _decompositionMapping0001D441[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D441 =
    {
        0x0001D441,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D441,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D441,
        0x0001D441,
        0x0001D441
    };

    static Char _decompositionMapping0001D442[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D442 =
    {
        0x0001D442,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D442,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D442,
        0x0001D442,
        0x0001D442
    };

    static Char _decompositionMapping0001D443[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D443 =
    {
        0x0001D443,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D443,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D443,
        0x0001D443,
        0x0001D443
    };

    static Char _decompositionMapping0001D444[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D444 =
    {
        0x0001D444,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D444,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D444,
        0x0001D444,
        0x0001D444
    };

    static Char _decompositionMapping0001D445[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D445 =
    {
        0x0001D445,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D445,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D445,
        0x0001D445,
        0x0001D445
    };

    static Char _decompositionMapping0001D446[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D446 =
    {
        0x0001D446,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D446,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D446,
        0x0001D446,
        0x0001D446
    };

    static Char _decompositionMapping0001D447[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D447 =
    {
        0x0001D447,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D447,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D447,
        0x0001D447,
        0x0001D447
    };

    static Char _decompositionMapping0001D448[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D448 =
    {
        0x0001D448,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D448,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D448,
        0x0001D448,
        0x0001D448
    };

    static Char _decompositionMapping0001D449[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D449 =
    {
        0x0001D449,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D449,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D449,
        0x0001D449,
        0x0001D449
    };

    static Char _decompositionMapping0001D44A[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D44A =
    {
        0x0001D44A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44A,
        0x0001D44A,
        0x0001D44A
    };

    static Char _decompositionMapping0001D44B[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D44B =
    {
        0x0001D44B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44B,
        0x0001D44B,
        0x0001D44B
    };

    static Char _decompositionMapping0001D44C[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D44C =
    {
        0x0001D44C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44C,
        0x0001D44C,
        0x0001D44C
    };

    static Char _decompositionMapping0001D44D[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D44D =
    {
        0x0001D44D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44D,
        0x0001D44D,
        0x0001D44D
    };

    static Char _decompositionMapping0001D44E[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D44E =
    {
        0x0001D44E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44E,
        0x0001D44E,
        0x0001D44E
    };

    static Char _decompositionMapping0001D44F[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D44F =
    {
        0x0001D44F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D44F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D44F,
        0x0001D44F,
        0x0001D44F
    };

    static Char _decompositionMapping0001D450[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D450 =
    {
        0x0001D450,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D450,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D450,
        0x0001D450,
        0x0001D450
    };

    static Char _decompositionMapping0001D451[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D451 =
    {
        0x0001D451,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D451,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D451,
        0x0001D451,
        0x0001D451
    };

    static Char _decompositionMapping0001D452[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D452 =
    {
        0x0001D452,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D452,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D452,
        0x0001D452,
        0x0001D452
    };

    static Char _decompositionMapping0001D453[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D453 =
    {
        0x0001D453,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D453,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D453,
        0x0001D453,
        0x0001D453
    };

    static Char _decompositionMapping0001D454[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D454 =
    {
        0x0001D454,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D454,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D454,
        0x0001D454,
        0x0001D454
    };

    static Char _decompositionMapping0001D456[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D456 =
    {
        0x0001D456,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D456,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D456,
        0x0001D456,
        0x0001D456
    };

    static Char _decompositionMapping0001D457[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D457 =
    {
        0x0001D457,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D457,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D457,
        0x0001D457,
        0x0001D457
    };

    static Char _decompositionMapping0001D458[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D458 =
    {
        0x0001D458,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D458,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D458,
        0x0001D458,
        0x0001D458
    };

    static Char _decompositionMapping0001D459[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D459 =
    {
        0x0001D459,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D459,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D459,
        0x0001D459,
        0x0001D459
    };

    static Char _decompositionMapping0001D45A[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D45A =
    {
        0x0001D45A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45A,
        0x0001D45A,
        0x0001D45A
    };

    static Char _decompositionMapping0001D45B[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D45B =
    {
        0x0001D45B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45B,
        0x0001D45B,
        0x0001D45B
    };

    static Char _decompositionMapping0001D45C[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D45C =
    {
        0x0001D45C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45C,
        0x0001D45C,
        0x0001D45C
    };

    static Char _decompositionMapping0001D45D[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D45D =
    {
        0x0001D45D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45D,
        0x0001D45D,
        0x0001D45D
    };

    static Char _decompositionMapping0001D45E[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D45E =
    {
        0x0001D45E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45E,
        0x0001D45E,
        0x0001D45E
    };

    static Char _decompositionMapping0001D45F[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D45F =
    {
        0x0001D45F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D45F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D45F,
        0x0001D45F,
        0x0001D45F
    };

    static Char _decompositionMapping0001D460[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D460 =
    {
        0x0001D460,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D460,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D460,
        0x0001D460,
        0x0001D460
    };

    static Char _decompositionMapping0001D461[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D461 =
    {
        0x0001D461,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D461,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D461,
        0x0001D461,
        0x0001D461
    };

    static Char _decompositionMapping0001D462[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D462 =
    {
        0x0001D462,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D462,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D462,
        0x0001D462,
        0x0001D462
    };

    static Char _decompositionMapping0001D463[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D463 =
    {
        0x0001D463,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D463,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D463,
        0x0001D463,
        0x0001D463
    };

    static Char _decompositionMapping0001D464[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D464 =
    {
        0x0001D464,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D464,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D464,
        0x0001D464,
        0x0001D464
    };

    static Char _decompositionMapping0001D465[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D465 =
    {
        0x0001D465,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D465,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D465,
        0x0001D465,
        0x0001D465
    };

    static Char _decompositionMapping0001D466[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D466 =
    {
        0x0001D466,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D466,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D466,
        0x0001D466,
        0x0001D466
    };

    static Char _decompositionMapping0001D467[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D467 =
    {
        0x0001D467,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D467,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D467,
        0x0001D467,
        0x0001D467
    };

    static Char _decompositionMapping0001D468[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D468 =
    {
        0x0001D468,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D468,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D468,
        0x0001D468,
        0x0001D468
    };

    static Char _decompositionMapping0001D469[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D469 =
    {
        0x0001D469,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D469,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D469,
        0x0001D469,
        0x0001D469
    };

    static Char _decompositionMapping0001D46A[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D46A =
    {
        0x0001D46A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46A,
        0x0001D46A,
        0x0001D46A
    };

    static Char _decompositionMapping0001D46B[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D46B =
    {
        0x0001D46B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46B,
        0x0001D46B,
        0x0001D46B
    };

    static Char _decompositionMapping0001D46C[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D46C =
    {
        0x0001D46C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46C,
        0x0001D46C,
        0x0001D46C
    };

    static Char _decompositionMapping0001D46D[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D46D =
    {
        0x0001D46D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46D,
        0x0001D46D,
        0x0001D46D
    };

    static Char _decompositionMapping0001D46E[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D46E =
    {
        0x0001D46E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46E,
        0x0001D46E,
        0x0001D46E
    };

    static Char _decompositionMapping0001D46F[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D46F =
    {
        0x0001D46F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D46F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D46F,
        0x0001D46F,
        0x0001D46F
    };

    static Char _decompositionMapping0001D470[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D470 =
    {
        0x0001D470,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D470,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D470,
        0x0001D470,
        0x0001D470
    };

    static Char _decompositionMapping0001D471[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D471 =
    {
        0x0001D471,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D471,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D471,
        0x0001D471,
        0x0001D471
    };

    static Char _decompositionMapping0001D472[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D472 =
    {
        0x0001D472,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D472,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D472,
        0x0001D472,
        0x0001D472
    };

    static Char _decompositionMapping0001D473[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D473 =
    {
        0x0001D473,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D473,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D473,
        0x0001D473,
        0x0001D473
    };

    static Char _decompositionMapping0001D474[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D474 =
    {
        0x0001D474,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D474,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D474,
        0x0001D474,
        0x0001D474
    };

    static Char _decompositionMapping0001D475[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D475 =
    {
        0x0001D475,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D475,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D475,
        0x0001D475,
        0x0001D475
    };

    static Char _decompositionMapping0001D476[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D476 =
    {
        0x0001D476,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D476,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D476,
        0x0001D476,
        0x0001D476
    };

    static Char _decompositionMapping0001D477[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D477 =
    {
        0x0001D477,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D477,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D477,
        0x0001D477,
        0x0001D477
    };

    static Char _decompositionMapping0001D478[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D478 =
    {
        0x0001D478,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D478,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D478,
        0x0001D478,
        0x0001D478
    };

    static Char _decompositionMapping0001D479[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D479 =
    {
        0x0001D479,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D479,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D479,
        0x0001D479,
        0x0001D479
    };

    static Char _decompositionMapping0001D47A[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D47A =
    {
        0x0001D47A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47A,
        0x0001D47A,
        0x0001D47A
    };

    static Char _decompositionMapping0001D47B[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D47B =
    {
        0x0001D47B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47B,
        0x0001D47B,
        0x0001D47B
    };

    static Char _decompositionMapping0001D47C[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D47C =
    {
        0x0001D47C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47C,
        0x0001D47C,
        0x0001D47C
    };

    static Char _decompositionMapping0001D47D[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D47D =
    {
        0x0001D47D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47D,
        0x0001D47D,
        0x0001D47D
    };

    static Char _decompositionMapping0001D47E[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D47E =
    {
        0x0001D47E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47E,
        0x0001D47E,
        0x0001D47E
    };

    static Char _decompositionMapping0001D47F[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D47F =
    {
        0x0001D47F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D47F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D47F,
        0x0001D47F,
        0x0001D47F
    };

    static Char _decompositionMapping0001D480[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D480 =
    {
        0x0001D480,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D480,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D480,
        0x0001D480,
        0x0001D480
    };

    static Char _decompositionMapping0001D481[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D481 =
    {
        0x0001D481,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D481,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D481,
        0x0001D481,
        0x0001D481
    };

    static Char _decompositionMapping0001D482[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D482 =
    {
        0x0001D482,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D482,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D482,
        0x0001D482,
        0x0001D482
    };

    static Char _decompositionMapping0001D483[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D483 =
    {
        0x0001D483,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D483,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D483,
        0x0001D483,
        0x0001D483
    };

    static Char _decompositionMapping0001D484[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D484 =
    {
        0x0001D484,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D484,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D484,
        0x0001D484,
        0x0001D484
    };

    static Char _decompositionMapping0001D485[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D485 =
    {
        0x0001D485,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D485,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D485,
        0x0001D485,
        0x0001D485
    };

    static Char _decompositionMapping0001D486[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D486 =
    {
        0x0001D486,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D486,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D486,
        0x0001D486,
        0x0001D486
    };

    static Char _decompositionMapping0001D487[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D487 =
    {
        0x0001D487,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D487,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D487,
        0x0001D487,
        0x0001D487
    };

    static Char _decompositionMapping0001D488[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D488 =
    {
        0x0001D488,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D488,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D488,
        0x0001D488,
        0x0001D488
    };

    static Char _decompositionMapping0001D489[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D489 =
    {
        0x0001D489,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D489,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D489,
        0x0001D489,
        0x0001D489
    };

    static Char _decompositionMapping0001D48A[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D48A =
    {
        0x0001D48A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48A,
        0x0001D48A,
        0x0001D48A
    };

    static Char _decompositionMapping0001D48B[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D48B =
    {
        0x0001D48B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48B,
        0x0001D48B,
        0x0001D48B
    };

    static Char _decompositionMapping0001D48C[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D48C =
    {
        0x0001D48C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48C,
        0x0001D48C,
        0x0001D48C
    };

    static Char _decompositionMapping0001D48D[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D48D =
    {
        0x0001D48D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48D,
        0x0001D48D,
        0x0001D48D
    };

    static Char _decompositionMapping0001D48E[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D48E =
    {
        0x0001D48E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48E,
        0x0001D48E,
        0x0001D48E
    };

    static Char _decompositionMapping0001D48F[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D48F =
    {
        0x0001D48F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D48F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D48F,
        0x0001D48F,
        0x0001D48F
    };

    static Char _decompositionMapping0001D490[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D490 =
    {
        0x0001D490,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D490,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D490,
        0x0001D490,
        0x0001D490
    };

    static Char _decompositionMapping0001D491[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D491 =
    {
        0x0001D491,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D491,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D491,
        0x0001D491,
        0x0001D491
    };

    static Char _decompositionMapping0001D492[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D492 =
    {
        0x0001D492,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D492,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D492,
        0x0001D492,
        0x0001D492
    };

    static Char _decompositionMapping0001D493[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D493 =
    {
        0x0001D493,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D493,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D493,
        0x0001D493,
        0x0001D493
    };

    static Char _decompositionMapping0001D494[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D494 =
    {
        0x0001D494,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D494,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D494,
        0x0001D494,
        0x0001D494
    };

    static Char _decompositionMapping0001D495[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D495 =
    {
        0x0001D495,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D495,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D495,
        0x0001D495,
        0x0001D495
    };

    static Char _decompositionMapping0001D496[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D496 =
    {
        0x0001D496,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D496,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D496,
        0x0001D496,
        0x0001D496
    };

    static Char _decompositionMapping0001D497[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D497 =
    {
        0x0001D497,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D497,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D497,
        0x0001D497,
        0x0001D497
    };

    static Char _decompositionMapping0001D498[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D498 =
    {
        0x0001D498,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D498,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D498,
        0x0001D498,
        0x0001D498
    };

    static Char _decompositionMapping0001D499[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D499 =
    {
        0x0001D499,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D499,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D499,
        0x0001D499,
        0x0001D499
    };

    static Char _decompositionMapping0001D49A[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D49A =
    {
        0x0001D49A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D49A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D49A,
        0x0001D49A,
        0x0001D49A
    };

    static Char _decompositionMapping0001D49B[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D49B =
    {
        0x0001D49B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D49B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D49B,
        0x0001D49B,
        0x0001D49B
    };

    static Char _decompositionMapping0001D49C[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D49C =
    {
        0x0001D49C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D49C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D49C,
        0x0001D49C,
        0x0001D49C
    };

    static Char _decompositionMapping0001D49E[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D49E =
    {
        0x0001D49E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D49E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D49E,
        0x0001D49E,
        0x0001D49E
    };

    static Char _decompositionMapping0001D49F[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D49F =
    {
        0x0001D49F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D49F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D49F,
        0x0001D49F,
        0x0001D49F
    };

    static Char _decompositionMapping0001D4A2[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D4A2 =
    {
        0x0001D4A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4A2,
        0x0001D4A2,
        0x0001D4A2
    };

    static Char _decompositionMapping0001D4A5[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D4A5 =
    {
        0x0001D4A5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4A5,
        0x0001D4A5,
        0x0001D4A5
    };

    static Char _decompositionMapping0001D4A6[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D4A6 =
    {
        0x0001D4A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4A6,
        0x0001D4A6,
        0x0001D4A6
    };

    static Char _decompositionMapping0001D4A9[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D4A9 =
    {
        0x0001D4A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4A9,
        0x0001D4A9,
        0x0001D4A9
    };

    static Char _decompositionMapping0001D4AA[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D4AA =
    {
        0x0001D4AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4AA,
        0x0001D4AA,
        0x0001D4AA
    };

    static Char _decompositionMapping0001D4AB[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D4AB =
    {
        0x0001D4AB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4AB,
        0x0001D4AB,
        0x0001D4AB
    };

    static Char _decompositionMapping0001D4AC[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D4AC =
    {
        0x0001D4AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4AC,
        0x0001D4AC,
        0x0001D4AC
    };

    static Char _decompositionMapping0001D4AE[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D4AE =
    {
        0x0001D4AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4AE,
        0x0001D4AE,
        0x0001D4AE
    };

    static Char _decompositionMapping0001D4AF[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D4AF =
    {
        0x0001D4AF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4AF,
        0x0001D4AF,
        0x0001D4AF
    };

    static Char _decompositionMapping0001D4B0[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D4B0 =
    {
        0x0001D4B0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B0,
        0x0001D4B0,
        0x0001D4B0
    };

    static Char _decompositionMapping0001D4B1[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D4B1 =
    {
        0x0001D4B1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B1,
        0x0001D4B1,
        0x0001D4B1
    };

    static Char _decompositionMapping0001D4B2[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D4B2 =
    {
        0x0001D4B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B2,
        0x0001D4B2,
        0x0001D4B2
    };

    static Char _decompositionMapping0001D4B3[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D4B3 =
    {
        0x0001D4B3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B3,
        0x0001D4B3,
        0x0001D4B3
    };

    static Char _decompositionMapping0001D4B4[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D4B4 =
    {
        0x0001D4B4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B4,
        0x0001D4B4,
        0x0001D4B4
    };

    static Char _decompositionMapping0001D4B5[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D4B5 =
    {
        0x0001D4B5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B5,
        0x0001D4B5,
        0x0001D4B5
    };

    static Char _decompositionMapping0001D4B6[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D4B6 =
    {
        0x0001D4B6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B6,
        0x0001D4B6,
        0x0001D4B6
    };

    static Char _decompositionMapping0001D4B7[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D4B7 =
    {
        0x0001D4B7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B7,
        0x0001D4B7,
        0x0001D4B7
    };

    static Char _decompositionMapping0001D4B8[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D4B8 =
    {
        0x0001D4B8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B8,
        0x0001D4B8,
        0x0001D4B8
    };

    static Char _decompositionMapping0001D4B9[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D4B9 =
    {
        0x0001D4B9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4B9,
        0x0001D4B9,
        0x0001D4B9
    };

    static Char _decompositionMapping0001D4BB[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D4BB =
    {
        0x0001D4BB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4BB,
        0x0001D4BB,
        0x0001D4BB
    };

    static Char _decompositionMapping0001D4BD[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D4BD =
    {
        0x0001D4BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4BD,
        0x0001D4BD,
        0x0001D4BD
    };

    static Char _decompositionMapping0001D4BE[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D4BE =
    {
        0x0001D4BE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4BE,
        0x0001D4BE,
        0x0001D4BE
    };

    static Char _decompositionMapping0001D4BF[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D4BF =
    {
        0x0001D4BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4BF,
        0x0001D4BF,
        0x0001D4BF
    };

    static Char _decompositionMapping0001D4C0[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D4C0 =
    {
        0x0001D4C0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C0,
        0x0001D4C0,
        0x0001D4C0
    };

    static Char _decompositionMapping0001D4C1[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D4C1 =
    {
        0x0001D4C1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C1,
        0x0001D4C1,
        0x0001D4C1
    };

    static Char _decompositionMapping0001D4C2[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D4C2 =
    {
        0x0001D4C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C2,
        0x0001D4C2,
        0x0001D4C2
    };

    static Char _decompositionMapping0001D4C3[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D4C3 =
    {
        0x0001D4C3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C3,
        0x0001D4C3,
        0x0001D4C3
    };

    static Char _decompositionMapping0001D4C5[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D4C5 =
    {
        0x0001D4C5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C5,
        0x0001D4C5,
        0x0001D4C5
    };

    static Char _decompositionMapping0001D4C6[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D4C6 =
    {
        0x0001D4C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C6,
        0x0001D4C6,
        0x0001D4C6
    };

    static Char _decompositionMapping0001D4C7[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D4C7 =
    {
        0x0001D4C7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C7,
        0x0001D4C7,
        0x0001D4C7
    };

    static Char _decompositionMapping0001D4C8[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D4C8 =
    {
        0x0001D4C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C8,
        0x0001D4C8,
        0x0001D4C8
    };

    static Char _decompositionMapping0001D4C9[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D4C9 =
    {
        0x0001D4C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4C9,
        0x0001D4C9,
        0x0001D4C9
    };

    static Char _decompositionMapping0001D4CA[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D4CA =
    {
        0x0001D4CA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CA,
        0x0001D4CA,
        0x0001D4CA
    };

    static Char _decompositionMapping0001D4CB[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D4CB =
    {
        0x0001D4CB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CB,
        0x0001D4CB,
        0x0001D4CB
    };

    static Char _decompositionMapping0001D4CC[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D4CC =
    {
        0x0001D4CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CC,
        0x0001D4CC,
        0x0001D4CC
    };

    static Char _decompositionMapping0001D4CD[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D4CD =
    {
        0x0001D4CD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CD,
        0x0001D4CD,
        0x0001D4CD
    };

    static Char _decompositionMapping0001D4CE[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D4CE =
    {
        0x0001D4CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CE,
        0x0001D4CE,
        0x0001D4CE
    };

    static Char _decompositionMapping0001D4CF[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D4CF =
    {
        0x0001D4CF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4CF,
        0x0001D4CF,
        0x0001D4CF
    };

    static Char _decompositionMapping0001D4D0[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D4D0 =
    {
        0x0001D4D0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D0,
        0x0001D4D0,
        0x0001D4D0
    };

    static Char _decompositionMapping0001D4D1[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D4D1 =
    {
        0x0001D4D1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D1,
        0x0001D4D1,
        0x0001D4D1
    };

    static Char _decompositionMapping0001D4D2[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D4D2 =
    {
        0x0001D4D2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D2,
        0x0001D4D2,
        0x0001D4D2
    };

    static Char _decompositionMapping0001D4D3[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D4D3 =
    {
        0x0001D4D3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D3,
        0x0001D4D3,
        0x0001D4D3
    };

    static Char _decompositionMapping0001D4D4[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D4D4 =
    {
        0x0001D4D4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D4,
        0x0001D4D4,
        0x0001D4D4
    };

    static Char _decompositionMapping0001D4D5[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D4D5 =
    {
        0x0001D4D5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D5,
        0x0001D4D5,
        0x0001D4D5
    };

    static Char _decompositionMapping0001D4D6[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D4D6 =
    {
        0x0001D4D6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D6,
        0x0001D4D6,
        0x0001D4D6
    };

    static Char _decompositionMapping0001D4D7[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D4D7 =
    {
        0x0001D4D7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D7,
        0x0001D4D7,
        0x0001D4D7
    };

    static Char _decompositionMapping0001D4D8[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D4D8 =
    {
        0x0001D4D8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D8,
        0x0001D4D8,
        0x0001D4D8
    };

    static Char _decompositionMapping0001D4D9[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D4D9 =
    {
        0x0001D4D9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4D9,
        0x0001D4D9,
        0x0001D4D9
    };

    static Char _decompositionMapping0001D4DA[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D4DA =
    {
        0x0001D4DA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DA,
        0x0001D4DA,
        0x0001D4DA
    };

    static Char _decompositionMapping0001D4DB[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D4DB =
    {
        0x0001D4DB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DB,
        0x0001D4DB,
        0x0001D4DB
    };

    static Char _decompositionMapping0001D4DC[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D4DC =
    {
        0x0001D4DC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DC,
        0x0001D4DC,
        0x0001D4DC
    };

    static Char _decompositionMapping0001D4DD[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D4DD =
    {
        0x0001D4DD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DD,
        0x0001D4DD,
        0x0001D4DD
    };

    static Char _decompositionMapping0001D4DE[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D4DE =
    {
        0x0001D4DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DE,
        0x0001D4DE,
        0x0001D4DE
    };

    static Char _decompositionMapping0001D4DF[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D4DF =
    {
        0x0001D4DF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4DF,
        0x0001D4DF,
        0x0001D4DF
    };

    static Char _decompositionMapping0001D4E0[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D4E0 =
    {
        0x0001D4E0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E0,
        0x0001D4E0,
        0x0001D4E0
    };

    static Char _decompositionMapping0001D4E1[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D4E1 =
    {
        0x0001D4E1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E1,
        0x0001D4E1,
        0x0001D4E1
    };

    static Char _decompositionMapping0001D4E2[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D4E2 =
    {
        0x0001D4E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E2,
        0x0001D4E2,
        0x0001D4E2
    };

    static Char _decompositionMapping0001D4E3[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D4E3 =
    {
        0x0001D4E3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E3,
        0x0001D4E3,
        0x0001D4E3
    };

    static Char _decompositionMapping0001D4E4[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D4E4 =
    {
        0x0001D4E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E4,
        0x0001D4E4,
        0x0001D4E4
    };

    static Char _decompositionMapping0001D4E5[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D4E5 =
    {
        0x0001D4E5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E5,
        0x0001D4E5,
        0x0001D4E5
    };

    static Char _decompositionMapping0001D4E6[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D4E6 =
    {
        0x0001D4E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E6,
        0x0001D4E6,
        0x0001D4E6
    };

    static Char _decompositionMapping0001D4E7[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D4E7 =
    {
        0x0001D4E7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E7,
        0x0001D4E7,
        0x0001D4E7
    };

    static Char _decompositionMapping0001D4E8[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D4E8 =
    {
        0x0001D4E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E8,
        0x0001D4E8,
        0x0001D4E8
    };

    static Char _decompositionMapping0001D4E9[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D4E9 =
    {
        0x0001D4E9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4E9,
        0x0001D4E9,
        0x0001D4E9
    };

    static Char _decompositionMapping0001D4EA[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D4EA =
    {
        0x0001D4EA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4EA,
        0x0001D4EA,
        0x0001D4EA
    };

    static Char _decompositionMapping0001D4EB[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D4EB =
    {
        0x0001D4EB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4EB,
        0x0001D4EB,
        0x0001D4EB
    };

    static Char _decompositionMapping0001D4EC[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D4EC =
    {
        0x0001D4EC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4EC,
        0x0001D4EC,
        0x0001D4EC
    };

    static Char _decompositionMapping0001D4ED[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D4ED =
    {
        0x0001D4ED,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4ED,
        0x0001D4ED,
        0x0001D4ED
    };

    static Char _decompositionMapping0001D4EE[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D4EE =
    {
        0x0001D4EE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4EE,
        0x0001D4EE,
        0x0001D4EE
    };

    static Char _decompositionMapping0001D4EF[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D4EF =
    {
        0x0001D4EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4EF,
        0x0001D4EF,
        0x0001D4EF
    };

    static Char _decompositionMapping0001D4F0[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D4F0 =
    {
        0x0001D4F0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F0,
        0x0001D4F0,
        0x0001D4F0
    };

    static Char _decompositionMapping0001D4F1[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D4F1 =
    {
        0x0001D4F1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F1,
        0x0001D4F1,
        0x0001D4F1
    };

    static Char _decompositionMapping0001D4F2[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D4F2 =
    {
        0x0001D4F2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F2,
        0x0001D4F2,
        0x0001D4F2
    };

    static Char _decompositionMapping0001D4F3[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D4F3 =
    {
        0x0001D4F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F3,
        0x0001D4F3,
        0x0001D4F3
    };

    static Char _decompositionMapping0001D4F4[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D4F4 =
    {
        0x0001D4F4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F4,
        0x0001D4F4,
        0x0001D4F4
    };

    static Char _decompositionMapping0001D4F5[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D4F5 =
    {
        0x0001D4F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F5,
        0x0001D4F5,
        0x0001D4F5
    };

    static Char _decompositionMapping0001D4F6[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D4F6 =
    {
        0x0001D4F6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F6,
        0x0001D4F6,
        0x0001D4F6
    };

    static Char _decompositionMapping0001D4F7[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D4F7 =
    {
        0x0001D4F7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F7,
        0x0001D4F7,
        0x0001D4F7
    };

    static Char _decompositionMapping0001D4F8[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D4F8 =
    {
        0x0001D4F8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F8,
        0x0001D4F8,
        0x0001D4F8
    };

    static Char _decompositionMapping0001D4F9[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D4F9 =
    {
        0x0001D4F9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4F9,
        0x0001D4F9,
        0x0001D4F9
    };

    static Char _decompositionMapping0001D4FA[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D4FA =
    {
        0x0001D4FA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FA,
        0x0001D4FA,
        0x0001D4FA
    };

    static Char _decompositionMapping0001D4FB[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D4FB =
    {
        0x0001D4FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FB,
        0x0001D4FB,
        0x0001D4FB
    };

    static Char _decompositionMapping0001D4FC[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D4FC =
    {
        0x0001D4FC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FC,
        0x0001D4FC,
        0x0001D4FC
    };

    static Char _decompositionMapping0001D4FD[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D4FD =
    {
        0x0001D4FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FD,
        0x0001D4FD,
        0x0001D4FD
    };

    static Char _decompositionMapping0001D4FE[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D4FE =
    {
        0x0001D4FE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FE,
        0x0001D4FE,
        0x0001D4FE
    };

    static Char _decompositionMapping0001D4FF[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D4FF =
    {
        0x0001D4FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D4FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D4FF,
        0x0001D4FF,
        0x0001D4FF
    };

    static Char _decompositionMapping0001D500[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D500 =
    {
        0x0001D500,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D500,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D500,
        0x0001D500,
        0x0001D500
    };

    static Char _decompositionMapping0001D501[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D501 =
    {
        0x0001D501,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D501,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D501,
        0x0001D501,
        0x0001D501
    };

    static Char _decompositionMapping0001D502[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D502 =
    {
        0x0001D502,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D502,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D502,
        0x0001D502,
        0x0001D502
    };

    static Char _decompositionMapping0001D503[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D503 =
    {
        0x0001D503,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D503,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D503,
        0x0001D503,
        0x0001D503
    };

    static Char _decompositionMapping0001D504[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D504 =
    {
        0x0001D504,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D504,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D504,
        0x0001D504,
        0x0001D504
    };

    static Char _decompositionMapping0001D505[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D505 =
    {
        0x0001D505,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D505,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D505,
        0x0001D505,
        0x0001D505
    };

    static Char _decompositionMapping0001D507[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D507 =
    {
        0x0001D507,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D507,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D507,
        0x0001D507,
        0x0001D507
    };

    static Char _decompositionMapping0001D508[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D508 =
    {
        0x0001D508,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D508,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D508,
        0x0001D508,
        0x0001D508
    };

    static Char _decompositionMapping0001D509[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D509 =
    {
        0x0001D509,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D509,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D509,
        0x0001D509,
        0x0001D509
    };

    static Char _decompositionMapping0001D50A[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D50A =
    {
        0x0001D50A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D50A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D50A,
        0x0001D50A,
        0x0001D50A
    };

    static Char _decompositionMapping0001D50D[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D50D =
    {
        0x0001D50D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D50D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D50D,
        0x0001D50D,
        0x0001D50D
    };

    static Char _decompositionMapping0001D50E[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D50E =
    {
        0x0001D50E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D50E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D50E,
        0x0001D50E,
        0x0001D50E
    };

    static Char _decompositionMapping0001D50F[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D50F =
    {
        0x0001D50F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D50F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D50F,
        0x0001D50F,
        0x0001D50F
    };

    static Char _decompositionMapping0001D510[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D510 =
    {
        0x0001D510,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D510,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D510,
        0x0001D510,
        0x0001D510
    };

    static Char _decompositionMapping0001D511[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D511 =
    {
        0x0001D511,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D511,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D511,
        0x0001D511,
        0x0001D511
    };

    static Char _decompositionMapping0001D512[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D512 =
    {
        0x0001D512,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D512,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D512,
        0x0001D512,
        0x0001D512
    };

    static Char _decompositionMapping0001D513[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D513 =
    {
        0x0001D513,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D513,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D513,
        0x0001D513,
        0x0001D513
    };

    static Char _decompositionMapping0001D514[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D514 =
    {
        0x0001D514,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D514,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D514,
        0x0001D514,
        0x0001D514
    };

    static Char _decompositionMapping0001D516[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D516 =
    {
        0x0001D516,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D516,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D516,
        0x0001D516,
        0x0001D516
    };

    static Char _decompositionMapping0001D517[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D517 =
    {
        0x0001D517,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D517,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D517,
        0x0001D517,
        0x0001D517
    };

    static Char _decompositionMapping0001D518[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D518 =
    {
        0x0001D518,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D518,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D518,
        0x0001D518,
        0x0001D518
    };

    static Char _decompositionMapping0001D519[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D519 =
    {
        0x0001D519,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D519,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D519,
        0x0001D519,
        0x0001D519
    };

    static Char _decompositionMapping0001D51A[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D51A =
    {
        0x0001D51A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D51A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D51A,
        0x0001D51A,
        0x0001D51A
    };

    static Char _decompositionMapping0001D51B[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D51B =
    {
        0x0001D51B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D51B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D51B,
        0x0001D51B,
        0x0001D51B
    };

    static Char _decompositionMapping0001D51C[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D51C =
    {
        0x0001D51C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D51C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D51C,
        0x0001D51C,
        0x0001D51C
    };

    static Char _decompositionMapping0001D51E[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D51E =
    {
        0x0001D51E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D51E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D51E,
        0x0001D51E,
        0x0001D51E
    };

    static Char _decompositionMapping0001D51F[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D51F =
    {
        0x0001D51F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D51F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D51F,
        0x0001D51F,
        0x0001D51F
    };

    static Char _decompositionMapping0001D520[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D520 =
    {
        0x0001D520,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D520,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D520,
        0x0001D520,
        0x0001D520
    };

    static Char _decompositionMapping0001D521[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D521 =
    {
        0x0001D521,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D521,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D521,
        0x0001D521,
        0x0001D521
    };

    static Char _decompositionMapping0001D522[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D522 =
    {
        0x0001D522,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D522,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D522,
        0x0001D522,
        0x0001D522
    };

    static Char _decompositionMapping0001D523[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D523 =
    {
        0x0001D523,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D523,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D523,
        0x0001D523,
        0x0001D523
    };

    static Char _decompositionMapping0001D524[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D524 =
    {
        0x0001D524,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D524,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D524,
        0x0001D524,
        0x0001D524
    };

    static Char _decompositionMapping0001D525[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D525 =
    {
        0x0001D525,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D525,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D525,
        0x0001D525,
        0x0001D525
    };

    static Char _decompositionMapping0001D526[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D526 =
    {
        0x0001D526,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D526,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D526,
        0x0001D526,
        0x0001D526
    };

    static Char _decompositionMapping0001D527[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D527 =
    {
        0x0001D527,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D527,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D527,
        0x0001D527,
        0x0001D527
    };

    static Char _decompositionMapping0001D528[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D528 =
    {
        0x0001D528,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D528,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D528,
        0x0001D528,
        0x0001D528
    };

    static Char _decompositionMapping0001D529[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D529 =
    {
        0x0001D529,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D529,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D529,
        0x0001D529,
        0x0001D529
    };

    static Char _decompositionMapping0001D52A[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D52A =
    {
        0x0001D52A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52A,
        0x0001D52A,
        0x0001D52A
    };

    static Char _decompositionMapping0001D52B[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D52B =
    {
        0x0001D52B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52B,
        0x0001D52B,
        0x0001D52B
    };

    static Char _decompositionMapping0001D52C[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D52C =
    {
        0x0001D52C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52C,
        0x0001D52C,
        0x0001D52C
    };

    static Char _decompositionMapping0001D52D[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D52D =
    {
        0x0001D52D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52D,
        0x0001D52D,
        0x0001D52D
    };

    static Char _decompositionMapping0001D52E[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D52E =
    {
        0x0001D52E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52E,
        0x0001D52E,
        0x0001D52E
    };

    static Char _decompositionMapping0001D52F[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D52F =
    {
        0x0001D52F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D52F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D52F,
        0x0001D52F,
        0x0001D52F
    };

    static Char _decompositionMapping0001D530[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D530 =
    {
        0x0001D530,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D530,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D530,
        0x0001D530,
        0x0001D530
    };

    static Char _decompositionMapping0001D531[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D531 =
    {
        0x0001D531,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D531,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D531,
        0x0001D531,
        0x0001D531
    };

    static Char _decompositionMapping0001D532[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D532 =
    {
        0x0001D532,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D532,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D532,
        0x0001D532,
        0x0001D532
    };

    static Char _decompositionMapping0001D533[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D533 =
    {
        0x0001D533,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D533,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D533,
        0x0001D533,
        0x0001D533
    };

    static Char _decompositionMapping0001D534[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D534 =
    {
        0x0001D534,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D534,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D534,
        0x0001D534,
        0x0001D534
    };

    static Char _decompositionMapping0001D535[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D535 =
    {
        0x0001D535,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D535,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D535,
        0x0001D535,
        0x0001D535
    };

    static Char _decompositionMapping0001D536[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D536 =
    {
        0x0001D536,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D536,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D536,
        0x0001D536,
        0x0001D536
    };

    static Char _decompositionMapping0001D537[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D537 =
    {
        0x0001D537,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D537,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D537,
        0x0001D537,
        0x0001D537
    };

    static Char _decompositionMapping0001D538[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D538 =
    {
        0x0001D538,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D538,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D538,
        0x0001D538,
        0x0001D538
    };

    static Char _decompositionMapping0001D539[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D539 =
    {
        0x0001D539,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D539,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D539,
        0x0001D539,
        0x0001D539
    };

    static Char _decompositionMapping0001D53B[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D53B =
    {
        0x0001D53B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D53B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D53B,
        0x0001D53B,
        0x0001D53B
    };

    static Char _decompositionMapping0001D53C[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D53C =
    {
        0x0001D53C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D53C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D53C,
        0x0001D53C,
        0x0001D53C
    };

    static Char _decompositionMapping0001D53D[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D53D =
    {
        0x0001D53D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D53D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D53D,
        0x0001D53D,
        0x0001D53D
    };

    static Char _decompositionMapping0001D53E[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D53E =
    {
        0x0001D53E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D53E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D53E,
        0x0001D53E,
        0x0001D53E
    };

    static Char _decompositionMapping0001D540[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D540 =
    {
        0x0001D540,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D540,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D540,
        0x0001D540,
        0x0001D540
    };

    static Char _decompositionMapping0001D541[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D541 =
    {
        0x0001D541,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D541,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D541,
        0x0001D541,
        0x0001D541
    };

    static Char _decompositionMapping0001D542[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D542 =
    {
        0x0001D542,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D542,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D542,
        0x0001D542,
        0x0001D542
    };

    static Char _decompositionMapping0001D543[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D543 =
    {
        0x0001D543,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D543,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D543,
        0x0001D543,
        0x0001D543
    };

    static Char _decompositionMapping0001D544[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D544 =
    {
        0x0001D544,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D544,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D544,
        0x0001D544,
        0x0001D544
    };

    static Char _decompositionMapping0001D546[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D546 =
    {
        0x0001D546,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D546,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D546,
        0x0001D546,
        0x0001D546
    };

    static Char _decompositionMapping0001D54A[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D54A =
    {
        0x0001D54A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54A,
        0x0001D54A,
        0x0001D54A
    };

    static Char _decompositionMapping0001D54B[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D54B =
    {
        0x0001D54B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54B,
        0x0001D54B,
        0x0001D54B
    };

    static Char _decompositionMapping0001D54C[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D54C =
    {
        0x0001D54C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54C,
        0x0001D54C,
        0x0001D54C
    };

    static Char _decompositionMapping0001D54D[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D54D =
    {
        0x0001D54D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54D,
        0x0001D54D,
        0x0001D54D
    };

    static Char _decompositionMapping0001D54E[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D54E =
    {
        0x0001D54E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54E,
        0x0001D54E,
        0x0001D54E
    };

    static Char _decompositionMapping0001D54F[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D54F =
    {
        0x0001D54F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D54F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D54F,
        0x0001D54F,
        0x0001D54F
    };

    static Char _decompositionMapping0001D550[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D550 =
    {
        0x0001D550,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D550,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D550,
        0x0001D550,
        0x0001D550
    };

    static Char _decompositionMapping0001D552[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D552 =
    {
        0x0001D552,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D552,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D552,
        0x0001D552,
        0x0001D552
    };

    static Char _decompositionMapping0001D553[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D553 =
    {
        0x0001D553,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D553,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D553,
        0x0001D553,
        0x0001D553
    };

    static Char _decompositionMapping0001D554[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D554 =
    {
        0x0001D554,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D554,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D554,
        0x0001D554,
        0x0001D554
    };

    static Char _decompositionMapping0001D555[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D555 =
    {
        0x0001D555,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D555,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D555,
        0x0001D555,
        0x0001D555
    };

    static Char _decompositionMapping0001D556[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D556 =
    {
        0x0001D556,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D556,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D556,
        0x0001D556,
        0x0001D556
    };

    static Char _decompositionMapping0001D557[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D557 =
    {
        0x0001D557,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D557,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D557,
        0x0001D557,
        0x0001D557
    };

    static Char _decompositionMapping0001D558[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D558 =
    {
        0x0001D558,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D558,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D558,
        0x0001D558,
        0x0001D558
    };

    static Char _decompositionMapping0001D559[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D559 =
    {
        0x0001D559,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D559,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D559,
        0x0001D559,
        0x0001D559
    };

    static Char _decompositionMapping0001D55A[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D55A =
    {
        0x0001D55A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55A,
        0x0001D55A,
        0x0001D55A
    };

    static Char _decompositionMapping0001D55B[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D55B =
    {
        0x0001D55B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55B,
        0x0001D55B,
        0x0001D55B
    };

    static Char _decompositionMapping0001D55C[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D55C =
    {
        0x0001D55C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55C,
        0x0001D55C,
        0x0001D55C
    };

    static Char _decompositionMapping0001D55D[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D55D =
    {
        0x0001D55D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55D,
        0x0001D55D,
        0x0001D55D
    };

    static Char _decompositionMapping0001D55E[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D55E =
    {
        0x0001D55E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55E,
        0x0001D55E,
        0x0001D55E
    };

    static Char _decompositionMapping0001D55F[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D55F =
    {
        0x0001D55F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D55F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D55F,
        0x0001D55F,
        0x0001D55F
    };

    static Char _decompositionMapping0001D560[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D560 =
    {
        0x0001D560,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D560,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D560,
        0x0001D560,
        0x0001D560
    };

    static Char _decompositionMapping0001D561[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D561 =
    {
        0x0001D561,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D561,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D561,
        0x0001D561,
        0x0001D561
    };

    static Char _decompositionMapping0001D562[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D562 =
    {
        0x0001D562,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D562,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D562,
        0x0001D562,
        0x0001D562
    };

    static Char _decompositionMapping0001D563[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D563 =
    {
        0x0001D563,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D563,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D563,
        0x0001D563,
        0x0001D563
    };

    static Char _decompositionMapping0001D564[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D564 =
    {
        0x0001D564,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D564,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D564,
        0x0001D564,
        0x0001D564
    };

    static Char _decompositionMapping0001D565[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D565 =
    {
        0x0001D565,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D565,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D565,
        0x0001D565,
        0x0001D565
    };

    static Char _decompositionMapping0001D566[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D566 =
    {
        0x0001D566,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D566,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D566,
        0x0001D566,
        0x0001D566
    };

    static Char _decompositionMapping0001D567[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D567 =
    {
        0x0001D567,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D567,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D567,
        0x0001D567,
        0x0001D567
    };

    static Char _decompositionMapping0001D568[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D568 =
    {
        0x0001D568,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D568,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D568,
        0x0001D568,
        0x0001D568
    };

    static Char _decompositionMapping0001D569[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D569 =
    {
        0x0001D569,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D569,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D569,
        0x0001D569,
        0x0001D569
    };

    static Char _decompositionMapping0001D56A[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D56A =
    {
        0x0001D56A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56A,
        0x0001D56A,
        0x0001D56A
    };

    static Char _decompositionMapping0001D56B[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D56B =
    {
        0x0001D56B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56B,
        0x0001D56B,
        0x0001D56B
    };

    static Char _decompositionMapping0001D56C[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D56C =
    {
        0x0001D56C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56C,
        0x0001D56C,
        0x0001D56C
    };

    static Char _decompositionMapping0001D56D[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D56D =
    {
        0x0001D56D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56D,
        0x0001D56D,
        0x0001D56D
    };

    static Char _decompositionMapping0001D56E[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D56E =
    {
        0x0001D56E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56E,
        0x0001D56E,
        0x0001D56E
    };

    static Char _decompositionMapping0001D56F[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D56F =
    {
        0x0001D56F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D56F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D56F,
        0x0001D56F,
        0x0001D56F
    };

    static Char _decompositionMapping0001D570[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D570 =
    {
        0x0001D570,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D570,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D570,
        0x0001D570,
        0x0001D570
    };

    static Char _decompositionMapping0001D571[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D571 =
    {
        0x0001D571,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D571,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D571,
        0x0001D571,
        0x0001D571
    };

    static Char _decompositionMapping0001D572[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D572 =
    {
        0x0001D572,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D572,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D572,
        0x0001D572,
        0x0001D572
    };

    static Char _decompositionMapping0001D573[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D573 =
    {
        0x0001D573,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D573,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D573,
        0x0001D573,
        0x0001D573
    };

    static Char _decompositionMapping0001D574[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D574 =
    {
        0x0001D574,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D574,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D574,
        0x0001D574,
        0x0001D574
    };

    static Char _decompositionMapping0001D575[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D575 =
    {
        0x0001D575,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D575,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D575,
        0x0001D575,
        0x0001D575
    };

    static Char _decompositionMapping0001D576[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D576 =
    {
        0x0001D576,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D576,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D576,
        0x0001D576,
        0x0001D576
    };

    static Char _decompositionMapping0001D577[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D577 =
    {
        0x0001D577,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D577,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D577,
        0x0001D577,
        0x0001D577
    };

    static Char _decompositionMapping0001D578[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D578 =
    {
        0x0001D578,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D578,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D578,
        0x0001D578,
        0x0001D578
    };

    static Char _decompositionMapping0001D579[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D579 =
    {
        0x0001D579,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D579,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D579,
        0x0001D579,
        0x0001D579
    };

    static Char _decompositionMapping0001D57A[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D57A =
    {
        0x0001D57A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57A,
        0x0001D57A,
        0x0001D57A
    };

    static Char _decompositionMapping0001D57B[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D57B =
    {
        0x0001D57B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57B,
        0x0001D57B,
        0x0001D57B
    };

    static Char _decompositionMapping0001D57C[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D57C =
    {
        0x0001D57C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57C,
        0x0001D57C,
        0x0001D57C
    };

    static Char _decompositionMapping0001D57D[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D57D =
    {
        0x0001D57D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57D,
        0x0001D57D,
        0x0001D57D
    };

    static Char _decompositionMapping0001D57E[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D57E =
    {
        0x0001D57E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57E,
        0x0001D57E,
        0x0001D57E
    };

    static Char _decompositionMapping0001D57F[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D57F =
    {
        0x0001D57F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D57F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D57F,
        0x0001D57F,
        0x0001D57F
    };

    static Char _decompositionMapping0001D580[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D580 =
    {
        0x0001D580,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D580,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D580,
        0x0001D580,
        0x0001D580
    };

    static Char _decompositionMapping0001D581[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D581 =
    {
        0x0001D581,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D581,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D581,
        0x0001D581,
        0x0001D581
    };

    static Char _decompositionMapping0001D582[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D582 =
    {
        0x0001D582,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D582,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D582,
        0x0001D582,
        0x0001D582
    };

    static Char _decompositionMapping0001D583[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D583 =
    {
        0x0001D583,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D583,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D583,
        0x0001D583,
        0x0001D583
    };

    static Char _decompositionMapping0001D584[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D584 =
    {
        0x0001D584,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D584,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D584,
        0x0001D584,
        0x0001D584
    };

    static Char _decompositionMapping0001D585[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D585 =
    {
        0x0001D585,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D585,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D585,
        0x0001D585,
        0x0001D585
    };

    static Char _decompositionMapping0001D586[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D586 =
    {
        0x0001D586,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D586,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D586,
        0x0001D586,
        0x0001D586
    };

    static Char _decompositionMapping0001D587[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D587 =
    {
        0x0001D587,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D587,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D587,
        0x0001D587,
        0x0001D587
    };

    static Char _decompositionMapping0001D588[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D588 =
    {
        0x0001D588,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D588,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D588,
        0x0001D588,
        0x0001D588
    };

    static Char _decompositionMapping0001D589[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D589 =
    {
        0x0001D589,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D589,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D589,
        0x0001D589,
        0x0001D589
    };

    static Char _decompositionMapping0001D58A[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D58A =
    {
        0x0001D58A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58A,
        0x0001D58A,
        0x0001D58A
    };

    static Char _decompositionMapping0001D58B[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D58B =
    {
        0x0001D58B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58B,
        0x0001D58B,
        0x0001D58B
    };

    static Char _decompositionMapping0001D58C[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D58C =
    {
        0x0001D58C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58C,
        0x0001D58C,
        0x0001D58C
    };

    static Char _decompositionMapping0001D58D[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D58D =
    {
        0x0001D58D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58D,
        0x0001D58D,
        0x0001D58D
    };

    static Char _decompositionMapping0001D58E[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D58E =
    {
        0x0001D58E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58E,
        0x0001D58E,
        0x0001D58E
    };

    static Char _decompositionMapping0001D58F[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D58F =
    {
        0x0001D58F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D58F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D58F,
        0x0001D58F,
        0x0001D58F
    };

    static Char _decompositionMapping0001D590[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D590 =
    {
        0x0001D590,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D590,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D590,
        0x0001D590,
        0x0001D590
    };

    static Char _decompositionMapping0001D591[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D591 =
    {
        0x0001D591,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D591,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D591,
        0x0001D591,
        0x0001D591
    };

    static Char _decompositionMapping0001D592[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D592 =
    {
        0x0001D592,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D592,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D592,
        0x0001D592,
        0x0001D592
    };

    static Char _decompositionMapping0001D593[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D593 =
    {
        0x0001D593,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D593,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D593,
        0x0001D593,
        0x0001D593
    };

    static Char _decompositionMapping0001D594[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D594 =
    {
        0x0001D594,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D594,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D594,
        0x0001D594,
        0x0001D594
    };

    static Char _decompositionMapping0001D595[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D595 =
    {
        0x0001D595,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D595,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D595,
        0x0001D595,
        0x0001D595
    };

    static Char _decompositionMapping0001D596[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D596 =
    {
        0x0001D596,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D596,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D596,
        0x0001D596,
        0x0001D596
    };

    static Char _decompositionMapping0001D597[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D597 =
    {
        0x0001D597,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D597,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D597,
        0x0001D597,
        0x0001D597
    };

    static Char _decompositionMapping0001D598[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D598 =
    {
        0x0001D598,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D598,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D598,
        0x0001D598,
        0x0001D598
    };

    static Char _decompositionMapping0001D599[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D599 =
    {
        0x0001D599,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D599,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D599,
        0x0001D599,
        0x0001D599
    };

    static Char _decompositionMapping0001D59A[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D59A =
    {
        0x0001D59A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59A,
        0x0001D59A,
        0x0001D59A
    };

    static Char _decompositionMapping0001D59B[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D59B =
    {
        0x0001D59B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59B,
        0x0001D59B,
        0x0001D59B
    };

    static Char _decompositionMapping0001D59C[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D59C =
    {
        0x0001D59C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59C,
        0x0001D59C,
        0x0001D59C
    };

    static Char _decompositionMapping0001D59D[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D59D =
    {
        0x0001D59D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59D,
        0x0001D59D,
        0x0001D59D
    };

    static Char _decompositionMapping0001D59E[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D59E =
    {
        0x0001D59E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59E,
        0x0001D59E,
        0x0001D59E
    };

    static Char _decompositionMapping0001D59F[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D59F =
    {
        0x0001D59F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D59F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D59F,
        0x0001D59F,
        0x0001D59F
    };

    static Char _decompositionMapping0001D5A0[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D5A0 =
    {
        0x0001D5A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A0,
        0x0001D5A0,
        0x0001D5A0
    };

    static Char _decompositionMapping0001D5A1[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D5A1 =
    {
        0x0001D5A1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A1,
        0x0001D5A1,
        0x0001D5A1
    };

    static Char _decompositionMapping0001D5A2[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D5A2 =
    {
        0x0001D5A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A2,
        0x0001D5A2,
        0x0001D5A2
    };

    static Char _decompositionMapping0001D5A3[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D5A3 =
    {
        0x0001D5A3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A3,
        0x0001D5A3,
        0x0001D5A3
    };

    static Char _decompositionMapping0001D5A4[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D5A4 =
    {
        0x0001D5A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A4,
        0x0001D5A4,
        0x0001D5A4
    };

    static Char _decompositionMapping0001D5A5[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D5A5 =
    {
        0x0001D5A5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A5,
        0x0001D5A5,
        0x0001D5A5
    };

    static Char _decompositionMapping0001D5A6[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D5A6 =
    {
        0x0001D5A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A6,
        0x0001D5A6,
        0x0001D5A6
    };

    static Char _decompositionMapping0001D5A7[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D5A7 =
    {
        0x0001D5A7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A7,
        0x0001D5A7,
        0x0001D5A7
    };

    static Char _decompositionMapping0001D5A8[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D5A8 =
    {
        0x0001D5A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A8,
        0x0001D5A8,
        0x0001D5A8
    };

    static Char _decompositionMapping0001D5A9[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D5A9 =
    {
        0x0001D5A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5A9,
        0x0001D5A9,
        0x0001D5A9
    };

    static Char _decompositionMapping0001D5AA[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D5AA =
    {
        0x0001D5AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AA,
        0x0001D5AA,
        0x0001D5AA
    };

    static Char _decompositionMapping0001D5AB[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D5AB =
    {
        0x0001D5AB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AB,
        0x0001D5AB,
        0x0001D5AB
    };

    static Char _decompositionMapping0001D5AC[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D5AC =
    {
        0x0001D5AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AC,
        0x0001D5AC,
        0x0001D5AC
    };

    static Char _decompositionMapping0001D5AD[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D5AD =
    {
        0x0001D5AD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AD,
        0x0001D5AD,
        0x0001D5AD
    };

    static Char _decompositionMapping0001D5AE[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D5AE =
    {
        0x0001D5AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AE,
        0x0001D5AE,
        0x0001D5AE
    };

    static Char _decompositionMapping0001D5AF[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D5AF =
    {
        0x0001D5AF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5AF,
        0x0001D5AF,
        0x0001D5AF
    };

    static Char _decompositionMapping0001D5B0[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D5B0 =
    {
        0x0001D5B0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B0,
        0x0001D5B0,
        0x0001D5B0
    };

    static Char _decompositionMapping0001D5B1[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D5B1 =
    {
        0x0001D5B1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B1,
        0x0001D5B1,
        0x0001D5B1
    };

    static Char _decompositionMapping0001D5B2[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D5B2 =
    {
        0x0001D5B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B2,
        0x0001D5B2,
        0x0001D5B2
    };

    static Char _decompositionMapping0001D5B3[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D5B3 =
    {
        0x0001D5B3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B3,
        0x0001D5B3,
        0x0001D5B3
    };

    static Char _decompositionMapping0001D5B4[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D5B4 =
    {
        0x0001D5B4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B4,
        0x0001D5B4,
        0x0001D5B4
    };

    static Char _decompositionMapping0001D5B5[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D5B5 =
    {
        0x0001D5B5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B5,
        0x0001D5B5,
        0x0001D5B5
    };

    static Char _decompositionMapping0001D5B6[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D5B6 =
    {
        0x0001D5B6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B6,
        0x0001D5B6,
        0x0001D5B6
    };

    static Char _decompositionMapping0001D5B7[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D5B7 =
    {
        0x0001D5B7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B7,
        0x0001D5B7,
        0x0001D5B7
    };

    static Char _decompositionMapping0001D5B8[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D5B8 =
    {
        0x0001D5B8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B8,
        0x0001D5B8,
        0x0001D5B8
    };

    static Char _decompositionMapping0001D5B9[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D5B9 =
    {
        0x0001D5B9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5B9,
        0x0001D5B9,
        0x0001D5B9
    };

    static Char _decompositionMapping0001D5BA[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D5BA =
    {
        0x0001D5BA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BA,
        0x0001D5BA,
        0x0001D5BA
    };

    static Char _decompositionMapping0001D5BB[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D5BB =
    {
        0x0001D5BB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BB,
        0x0001D5BB,
        0x0001D5BB
    };

    static Char _decompositionMapping0001D5BC[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D5BC =
    {
        0x0001D5BC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BC,
        0x0001D5BC,
        0x0001D5BC
    };

    static Char _decompositionMapping0001D5BD[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D5BD =
    {
        0x0001D5BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BD,
        0x0001D5BD,
        0x0001D5BD
    };

    static Char _decompositionMapping0001D5BE[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D5BE =
    {
        0x0001D5BE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BE,
        0x0001D5BE,
        0x0001D5BE
    };

    static Char _decompositionMapping0001D5BF[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D5BF =
    {
        0x0001D5BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5BF,
        0x0001D5BF,
        0x0001D5BF
    };

    static Char _decompositionMapping0001D5C0[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D5C0 =
    {
        0x0001D5C0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C0,
        0x0001D5C0,
        0x0001D5C0
    };

    static Char _decompositionMapping0001D5C1[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D5C1 =
    {
        0x0001D5C1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C1,
        0x0001D5C1,
        0x0001D5C1
    };

    static Char _decompositionMapping0001D5C2[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D5C2 =
    {
        0x0001D5C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C2,
        0x0001D5C2,
        0x0001D5C2
    };

    static Char _decompositionMapping0001D5C3[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D5C3 =
    {
        0x0001D5C3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C3,
        0x0001D5C3,
        0x0001D5C3
    };

    static Char _decompositionMapping0001D5C4[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D5C4 =
    {
        0x0001D5C4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C4,
        0x0001D5C4,
        0x0001D5C4
    };

    static Char _decompositionMapping0001D5C5[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D5C5 =
    {
        0x0001D5C5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C5,
        0x0001D5C5,
        0x0001D5C5
    };

    static Char _decompositionMapping0001D5C6[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D5C6 =
    {
        0x0001D5C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C6,
        0x0001D5C6,
        0x0001D5C6
    };

    static Char _decompositionMapping0001D5C7[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D5C7 =
    {
        0x0001D5C7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C7,
        0x0001D5C7,
        0x0001D5C7
    };

    static Char _decompositionMapping0001D5C8[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D5C8 =
    {
        0x0001D5C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C8,
        0x0001D5C8,
        0x0001D5C8
    };

    static Char _decompositionMapping0001D5C9[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D5C9 =
    {
        0x0001D5C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5C9,
        0x0001D5C9,
        0x0001D5C9
    };

    static Char _decompositionMapping0001D5CA[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D5CA =
    {
        0x0001D5CA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CA,
        0x0001D5CA,
        0x0001D5CA
    };

    static Char _decompositionMapping0001D5CB[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D5CB =
    {
        0x0001D5CB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CB,
        0x0001D5CB,
        0x0001D5CB
    };

    static Char _decompositionMapping0001D5CC[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D5CC =
    {
        0x0001D5CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CC,
        0x0001D5CC,
        0x0001D5CC
    };

    static Char _decompositionMapping0001D5CD[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D5CD =
    {
        0x0001D5CD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CD,
        0x0001D5CD,
        0x0001D5CD
    };

    static Char _decompositionMapping0001D5CE[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D5CE =
    {
        0x0001D5CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CE,
        0x0001D5CE,
        0x0001D5CE
    };

    static Char _decompositionMapping0001D5CF[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D5CF =
    {
        0x0001D5CF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5CF,
        0x0001D5CF,
        0x0001D5CF
    };

    static Char _decompositionMapping0001D5D0[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D5D0 =
    {
        0x0001D5D0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D0,
        0x0001D5D0,
        0x0001D5D0
    };

    static Char _decompositionMapping0001D5D1[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D5D1 =
    {
        0x0001D5D1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D1,
        0x0001D5D1,
        0x0001D5D1
    };

    static Char _decompositionMapping0001D5D2[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D5D2 =
    {
        0x0001D5D2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D2,
        0x0001D5D2,
        0x0001D5D2
    };

    static Char _decompositionMapping0001D5D3[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D5D3 =
    {
        0x0001D5D3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D3,
        0x0001D5D3,
        0x0001D5D3
    };

    static Char _decompositionMapping0001D5D4[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D5D4 =
    {
        0x0001D5D4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D4,
        0x0001D5D4,
        0x0001D5D4
    };

    static Char _decompositionMapping0001D5D5[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D5D5 =
    {
        0x0001D5D5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D5,
        0x0001D5D5,
        0x0001D5D5
    };

    static Char _decompositionMapping0001D5D6[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D5D6 =
    {
        0x0001D5D6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D6,
        0x0001D5D6,
        0x0001D5D6
    };

    static Char _decompositionMapping0001D5D7[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D5D7 =
    {
        0x0001D5D7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D7,
        0x0001D5D7,
        0x0001D5D7
    };

    static Char _decompositionMapping0001D5D8[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D5D8 =
    {
        0x0001D5D8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D8,
        0x0001D5D8,
        0x0001D5D8
    };

    static Char _decompositionMapping0001D5D9[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D5D9 =
    {
        0x0001D5D9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5D9,
        0x0001D5D9,
        0x0001D5D9
    };

    static Char _decompositionMapping0001D5DA[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D5DA =
    {
        0x0001D5DA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DA,
        0x0001D5DA,
        0x0001D5DA
    };

    static Char _decompositionMapping0001D5DB[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D5DB =
    {
        0x0001D5DB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DB,
        0x0001D5DB,
        0x0001D5DB
    };

    static Char _decompositionMapping0001D5DC[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D5DC =
    {
        0x0001D5DC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DC,
        0x0001D5DC,
        0x0001D5DC
    };

    static Char _decompositionMapping0001D5DD[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D5DD =
    {
        0x0001D5DD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DD,
        0x0001D5DD,
        0x0001D5DD
    };

    static Char _decompositionMapping0001D5DE[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D5DE =
    {
        0x0001D5DE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DE,
        0x0001D5DE,
        0x0001D5DE
    };

    static Char _decompositionMapping0001D5DF[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D5DF =
    {
        0x0001D5DF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5DF,
        0x0001D5DF,
        0x0001D5DF
    };

    static Char _decompositionMapping0001D5E0[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D5E0 =
    {
        0x0001D5E0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E0,
        0x0001D5E0,
        0x0001D5E0
    };

    static Char _decompositionMapping0001D5E1[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D5E1 =
    {
        0x0001D5E1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E1,
        0x0001D5E1,
        0x0001D5E1
    };

    static Char _decompositionMapping0001D5E2[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D5E2 =
    {
        0x0001D5E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E2,
        0x0001D5E2,
        0x0001D5E2
    };

    static Char _decompositionMapping0001D5E3[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D5E3 =
    {
        0x0001D5E3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E3,
        0x0001D5E3,
        0x0001D5E3
    };

    static Char _decompositionMapping0001D5E4[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D5E4 =
    {
        0x0001D5E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E4,
        0x0001D5E4,
        0x0001D5E4
    };

    static Char _decompositionMapping0001D5E5[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D5E5 =
    {
        0x0001D5E5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E5,
        0x0001D5E5,
        0x0001D5E5
    };

    static Char _decompositionMapping0001D5E6[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D5E6 =
    {
        0x0001D5E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E6,
        0x0001D5E6,
        0x0001D5E6
    };

    static Char _decompositionMapping0001D5E7[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D5E7 =
    {
        0x0001D5E7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E7,
        0x0001D5E7,
        0x0001D5E7
    };

    static Char _decompositionMapping0001D5E8[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D5E8 =
    {
        0x0001D5E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E8,
        0x0001D5E8,
        0x0001D5E8
    };

    static Char _decompositionMapping0001D5E9[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D5E9 =
    {
        0x0001D5E9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5E9,
        0x0001D5E9,
        0x0001D5E9
    };

    static Char _decompositionMapping0001D5EA[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D5EA =
    {
        0x0001D5EA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5EA,
        0x0001D5EA,
        0x0001D5EA
    };

    static Char _decompositionMapping0001D5EB[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D5EB =
    {
        0x0001D5EB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5EB,
        0x0001D5EB,
        0x0001D5EB
    };

    static Char _decompositionMapping0001D5EC[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D5EC =
    {
        0x0001D5EC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5EC,
        0x0001D5EC,
        0x0001D5EC
    };

    static Char _decompositionMapping0001D5ED[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D5ED =
    {
        0x0001D5ED,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5ED,
        0x0001D5ED,
        0x0001D5ED
    };

    static Char _decompositionMapping0001D5EE[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D5EE =
    {
        0x0001D5EE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5EE,
        0x0001D5EE,
        0x0001D5EE
    };

    static Char _decompositionMapping0001D5EF[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D5EF =
    {
        0x0001D5EF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5EF,
        0x0001D5EF,
        0x0001D5EF
    };

    static Char _decompositionMapping0001D5F0[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D5F0 =
    {
        0x0001D5F0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F0,
        0x0001D5F0,
        0x0001D5F0
    };

    static Char _decompositionMapping0001D5F1[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D5F1 =
    {
        0x0001D5F1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F1,
        0x0001D5F1,
        0x0001D5F1
    };

    static Char _decompositionMapping0001D5F2[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D5F2 =
    {
        0x0001D5F2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F2,
        0x0001D5F2,
        0x0001D5F2
    };

    static Char _decompositionMapping0001D5F3[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D5F3 =
    {
        0x0001D5F3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F3,
        0x0001D5F3,
        0x0001D5F3
    };

    static Char _decompositionMapping0001D5F4[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D5F4 =
    {
        0x0001D5F4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F4,
        0x0001D5F4,
        0x0001D5F4
    };

    static Char _decompositionMapping0001D5F5[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D5F5 =
    {
        0x0001D5F5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F5,
        0x0001D5F5,
        0x0001D5F5
    };

    static Char _decompositionMapping0001D5F6[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D5F6 =
    {
        0x0001D5F6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F6,
        0x0001D5F6,
        0x0001D5F6
    };

    static Char _decompositionMapping0001D5F7[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D5F7 =
    {
        0x0001D5F7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F7,
        0x0001D5F7,
        0x0001D5F7
    };

    static Char _decompositionMapping0001D5F8[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D5F8 =
    {
        0x0001D5F8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F8,
        0x0001D5F8,
        0x0001D5F8
    };

    static Char _decompositionMapping0001D5F9[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D5F9 =
    {
        0x0001D5F9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5F9,
        0x0001D5F9,
        0x0001D5F9
    };

    static Char _decompositionMapping0001D5FA[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D5FA =
    {
        0x0001D5FA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FA,
        0x0001D5FA,
        0x0001D5FA
    };

    static Char _decompositionMapping0001D5FB[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D5FB =
    {
        0x0001D5FB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FB,
        0x0001D5FB,
        0x0001D5FB
    };

    static Char _decompositionMapping0001D5FC[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D5FC =
    {
        0x0001D5FC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FC,
        0x0001D5FC,
        0x0001D5FC
    };

    static Char _decompositionMapping0001D5FD[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D5FD =
    {
        0x0001D5FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FD,
        0x0001D5FD,
        0x0001D5FD
    };

    static Char _decompositionMapping0001D5FE[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D5FE =
    {
        0x0001D5FE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FE,
        0x0001D5FE,
        0x0001D5FE
    };

    static Char _decompositionMapping0001D5FF[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D5FF =
    {
        0x0001D5FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D5FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D5FF,
        0x0001D5FF,
        0x0001D5FF
    };

    static Char _decompositionMapping0001D600[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D600 =
    {
        0x0001D600,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D600,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D600,
        0x0001D600,
        0x0001D600
    };

    static Char _decompositionMapping0001D601[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D601 =
    {
        0x0001D601,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D601,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D601,
        0x0001D601,
        0x0001D601
    };

    static Char _decompositionMapping0001D602[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D602 =
    {
        0x0001D602,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D602,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D602,
        0x0001D602,
        0x0001D602
    };

    static Char _decompositionMapping0001D603[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D603 =
    {
        0x0001D603,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D603,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D603,
        0x0001D603,
        0x0001D603
    };

    static Char _decompositionMapping0001D604[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D604 =
    {
        0x0001D604,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D604,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D604,
        0x0001D604,
        0x0001D604
    };

    static Char _decompositionMapping0001D605[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D605 =
    {
        0x0001D605,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D605,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D605,
        0x0001D605,
        0x0001D605
    };

    static Char _decompositionMapping0001D606[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D606 =
    {
        0x0001D606,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D606,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D606,
        0x0001D606,
        0x0001D606
    };

    static Char _decompositionMapping0001D607[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D607 =
    {
        0x0001D607,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D607,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D607,
        0x0001D607,
        0x0001D607
    };

    static Char _decompositionMapping0001D608[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D608 =
    {
        0x0001D608,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D608,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D608,
        0x0001D608,
        0x0001D608
    };

    static Char _decompositionMapping0001D609[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D609 =
    {
        0x0001D609,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D609,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D609,
        0x0001D609,
        0x0001D609
    };

    static Char _decompositionMapping0001D60A[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D60A =
    {
        0x0001D60A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60A,
        0x0001D60A,
        0x0001D60A
    };

    static Char _decompositionMapping0001D60B[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D60B =
    {
        0x0001D60B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60B,
        0x0001D60B,
        0x0001D60B
    };

    static Char _decompositionMapping0001D60C[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D60C =
    {
        0x0001D60C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60C,
        0x0001D60C,
        0x0001D60C
    };

    static Char _decompositionMapping0001D60D[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D60D =
    {
        0x0001D60D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60D,
        0x0001D60D,
        0x0001D60D
    };

    static Char _decompositionMapping0001D60E[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D60E =
    {
        0x0001D60E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60E,
        0x0001D60E,
        0x0001D60E
    };

    static Char _decompositionMapping0001D60F[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D60F =
    {
        0x0001D60F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D60F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D60F,
        0x0001D60F,
        0x0001D60F
    };

    static Char _decompositionMapping0001D610[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D610 =
    {
        0x0001D610,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D610,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D610,
        0x0001D610,
        0x0001D610
    };

    static Char _decompositionMapping0001D611[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D611 =
    {
        0x0001D611,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D611,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D611,
        0x0001D611,
        0x0001D611
    };

    static Char _decompositionMapping0001D612[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D612 =
    {
        0x0001D612,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D612,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D612,
        0x0001D612,
        0x0001D612
    };

    static Char _decompositionMapping0001D613[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D613 =
    {
        0x0001D613,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D613,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D613,
        0x0001D613,
        0x0001D613
    };

    static Char _decompositionMapping0001D614[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D614 =
    {
        0x0001D614,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D614,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D614,
        0x0001D614,
        0x0001D614
    };

    static Char _decompositionMapping0001D615[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D615 =
    {
        0x0001D615,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D615,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D615,
        0x0001D615,
        0x0001D615
    };

    static Char _decompositionMapping0001D616[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D616 =
    {
        0x0001D616,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D616,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D616,
        0x0001D616,
        0x0001D616
    };

    static Char _decompositionMapping0001D617[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D617 =
    {
        0x0001D617,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D617,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D617,
        0x0001D617,
        0x0001D617
    };

    static Char _decompositionMapping0001D618[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D618 =
    {
        0x0001D618,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D618,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D618,
        0x0001D618,
        0x0001D618
    };

    static Char _decompositionMapping0001D619[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D619 =
    {
        0x0001D619,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D619,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D619,
        0x0001D619,
        0x0001D619
    };

    static Char _decompositionMapping0001D61A[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D61A =
    {
        0x0001D61A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61A,
        0x0001D61A,
        0x0001D61A
    };

    static Char _decompositionMapping0001D61B[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D61B =
    {
        0x0001D61B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61B,
        0x0001D61B,
        0x0001D61B
    };

    static Char _decompositionMapping0001D61C[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D61C =
    {
        0x0001D61C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61C,
        0x0001D61C,
        0x0001D61C
    };

    static Char _decompositionMapping0001D61D[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D61D =
    {
        0x0001D61D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61D,
        0x0001D61D,
        0x0001D61D
    };

    static Char _decompositionMapping0001D61E[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D61E =
    {
        0x0001D61E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61E,
        0x0001D61E,
        0x0001D61E
    };

    static Char _decompositionMapping0001D61F[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D61F =
    {
        0x0001D61F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D61F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D61F,
        0x0001D61F,
        0x0001D61F
    };

    static Char _decompositionMapping0001D620[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D620 =
    {
        0x0001D620,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D620,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D620,
        0x0001D620,
        0x0001D620
    };

    static Char _decompositionMapping0001D621[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D621 =
    {
        0x0001D621,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D621,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D621,
        0x0001D621,
        0x0001D621
    };

    static Char _decompositionMapping0001D622[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D622 =
    {
        0x0001D622,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D622,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D622,
        0x0001D622,
        0x0001D622
    };

    static Char _decompositionMapping0001D623[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D623 =
    {
        0x0001D623,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D623,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D623,
        0x0001D623,
        0x0001D623
    };

    static Char _decompositionMapping0001D624[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D624 =
    {
        0x0001D624,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D624,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D624,
        0x0001D624,
        0x0001D624
    };

    static Char _decompositionMapping0001D625[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D625 =
    {
        0x0001D625,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D625,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D625,
        0x0001D625,
        0x0001D625
    };

    static Char _decompositionMapping0001D626[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D626 =
    {
        0x0001D626,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D626,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D626,
        0x0001D626,
        0x0001D626
    };

    static Char _decompositionMapping0001D627[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D627 =
    {
        0x0001D627,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D627,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D627,
        0x0001D627,
        0x0001D627
    };

    static Char _decompositionMapping0001D628[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D628 =
    {
        0x0001D628,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D628,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D628,
        0x0001D628,
        0x0001D628
    };

    static Char _decompositionMapping0001D629[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D629 =
    {
        0x0001D629,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D629,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D629,
        0x0001D629,
        0x0001D629
    };

    static Char _decompositionMapping0001D62A[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D62A =
    {
        0x0001D62A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62A,
        0x0001D62A,
        0x0001D62A
    };

    static Char _decompositionMapping0001D62B[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D62B =
    {
        0x0001D62B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62B,
        0x0001D62B,
        0x0001D62B
    };

    static Char _decompositionMapping0001D62C[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D62C =
    {
        0x0001D62C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62C,
        0x0001D62C,
        0x0001D62C
    };

    static Char _decompositionMapping0001D62D[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D62D =
    {
        0x0001D62D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62D,
        0x0001D62D,
        0x0001D62D
    };

    static Char _decompositionMapping0001D62E[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D62E =
    {
        0x0001D62E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62E,
        0x0001D62E,
        0x0001D62E
    };

    static Char _decompositionMapping0001D62F[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D62F =
    {
        0x0001D62F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D62F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D62F,
        0x0001D62F,
        0x0001D62F
    };

    static Char _decompositionMapping0001D630[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D630 =
    {
        0x0001D630,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D630,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D630,
        0x0001D630,
        0x0001D630
    };

    static Char _decompositionMapping0001D631[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D631 =
    {
        0x0001D631,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D631,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D631,
        0x0001D631,
        0x0001D631
    };

    static Char _decompositionMapping0001D632[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D632 =
    {
        0x0001D632,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D632,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D632,
        0x0001D632,
        0x0001D632
    };

    static Char _decompositionMapping0001D633[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D633 =
    {
        0x0001D633,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D633,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D633,
        0x0001D633,
        0x0001D633
    };

    static Char _decompositionMapping0001D634[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D634 =
    {
        0x0001D634,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D634,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D634,
        0x0001D634,
        0x0001D634
    };

    static Char _decompositionMapping0001D635[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D635 =
    {
        0x0001D635,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D635,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D635,
        0x0001D635,
        0x0001D635
    };

    static Char _decompositionMapping0001D636[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D636 =
    {
        0x0001D636,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D636,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D636,
        0x0001D636,
        0x0001D636
    };

    static Char _decompositionMapping0001D637[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D637 =
    {
        0x0001D637,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D637,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D637,
        0x0001D637,
        0x0001D637
    };

    static Char _decompositionMapping0001D638[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D638 =
    {
        0x0001D638,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D638,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D638,
        0x0001D638,
        0x0001D638
    };

    static Char _decompositionMapping0001D639[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D639 =
    {
        0x0001D639,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D639,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D639,
        0x0001D639,
        0x0001D639
    };

    static Char _decompositionMapping0001D63A[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D63A =
    {
        0x0001D63A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63A,
        0x0001D63A,
        0x0001D63A
    };

    static Char _decompositionMapping0001D63B[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D63B =
    {
        0x0001D63B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63B,
        0x0001D63B,
        0x0001D63B
    };

    static Char _decompositionMapping0001D63C[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D63C =
    {
        0x0001D63C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63C,
        0x0001D63C,
        0x0001D63C
    };

    static Char _decompositionMapping0001D63D[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D63D =
    {
        0x0001D63D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63D,
        0x0001D63D,
        0x0001D63D
    };

    static Char _decompositionMapping0001D63E[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D63E =
    {
        0x0001D63E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63E,
        0x0001D63E,
        0x0001D63E
    };

    static Char _decompositionMapping0001D63F[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D63F =
    {
        0x0001D63F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D63F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D63F,
        0x0001D63F,
        0x0001D63F
    };

    static Char _decompositionMapping0001D640[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D640 =
    {
        0x0001D640,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D640,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D640,
        0x0001D640,
        0x0001D640
    };

    static Char _decompositionMapping0001D641[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D641 =
    {
        0x0001D641,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D641,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D641,
        0x0001D641,
        0x0001D641
    };

    static Char _decompositionMapping0001D642[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D642 =
    {
        0x0001D642,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D642,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D642,
        0x0001D642,
        0x0001D642
    };

    static Char _decompositionMapping0001D643[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D643 =
    {
        0x0001D643,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D643,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D643,
        0x0001D643,
        0x0001D643
    };

    static Char _decompositionMapping0001D644[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D644 =
    {
        0x0001D644,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D644,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D644,
        0x0001D644,
        0x0001D644
    };

    static Char _decompositionMapping0001D645[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D645 =
    {
        0x0001D645,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D645,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D645,
        0x0001D645,
        0x0001D645
    };

    static Char _decompositionMapping0001D646[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D646 =
    {
        0x0001D646,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D646,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D646,
        0x0001D646,
        0x0001D646
    };

    static Char _decompositionMapping0001D647[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D647 =
    {
        0x0001D647,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D647,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D647,
        0x0001D647,
        0x0001D647
    };

    static Char _decompositionMapping0001D648[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D648 =
    {
        0x0001D648,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D648,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D648,
        0x0001D648,
        0x0001D648
    };

    static Char _decompositionMapping0001D649[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D649 =
    {
        0x0001D649,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D649,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D649,
        0x0001D649,
        0x0001D649
    };

    static Char _decompositionMapping0001D64A[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D64A =
    {
        0x0001D64A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64A,
        0x0001D64A,
        0x0001D64A
    };

    static Char _decompositionMapping0001D64B[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D64B =
    {
        0x0001D64B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64B,
        0x0001D64B,
        0x0001D64B
    };

    static Char _decompositionMapping0001D64C[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D64C =
    {
        0x0001D64C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64C,
        0x0001D64C,
        0x0001D64C
    };

    static Char _decompositionMapping0001D64D[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D64D =
    {
        0x0001D64D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64D,
        0x0001D64D,
        0x0001D64D
    };

    static Char _decompositionMapping0001D64E[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D64E =
    {
        0x0001D64E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64E,
        0x0001D64E,
        0x0001D64E
    };

    static Char _decompositionMapping0001D64F[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D64F =
    {
        0x0001D64F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D64F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D64F,
        0x0001D64F,
        0x0001D64F
    };

    static Char _decompositionMapping0001D650[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D650 =
    {
        0x0001D650,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D650,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D650,
        0x0001D650,
        0x0001D650
    };

    static Char _decompositionMapping0001D651[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D651 =
    {
        0x0001D651,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D651,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D651,
        0x0001D651,
        0x0001D651
    };

    static Char _decompositionMapping0001D652[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D652 =
    {
        0x0001D652,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D652,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D652,
        0x0001D652,
        0x0001D652
    };

    static Char _decompositionMapping0001D653[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D653 =
    {
        0x0001D653,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D653,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D653,
        0x0001D653,
        0x0001D653
    };

    static Char _decompositionMapping0001D654[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D654 =
    {
        0x0001D654,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D654,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D654,
        0x0001D654,
        0x0001D654
    };

    static Char _decompositionMapping0001D655[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D655 =
    {
        0x0001D655,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D655,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D655,
        0x0001D655,
        0x0001D655
    };

    static Char _decompositionMapping0001D656[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D656 =
    {
        0x0001D656,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D656,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D656,
        0x0001D656,
        0x0001D656
    };

    static Char _decompositionMapping0001D657[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D657 =
    {
        0x0001D657,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D657,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D657,
        0x0001D657,
        0x0001D657
    };

    static Char _decompositionMapping0001D658[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D658 =
    {
        0x0001D658,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D658,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D658,
        0x0001D658,
        0x0001D658
    };

    static Char _decompositionMapping0001D659[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D659 =
    {
        0x0001D659,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D659,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D659,
        0x0001D659,
        0x0001D659
    };

    static Char _decompositionMapping0001D65A[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D65A =
    {
        0x0001D65A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65A,
        0x0001D65A,
        0x0001D65A
    };

    static Char _decompositionMapping0001D65B[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D65B =
    {
        0x0001D65B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65B,
        0x0001D65B,
        0x0001D65B
    };

    static Char _decompositionMapping0001D65C[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D65C =
    {
        0x0001D65C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65C,
        0x0001D65C,
        0x0001D65C
    };

    static Char _decompositionMapping0001D65D[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D65D =
    {
        0x0001D65D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65D,
        0x0001D65D,
        0x0001D65D
    };

    static Char _decompositionMapping0001D65E[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D65E =
    {
        0x0001D65E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65E,
        0x0001D65E,
        0x0001D65E
    };

    static Char _decompositionMapping0001D65F[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D65F =
    {
        0x0001D65F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D65F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D65F,
        0x0001D65F,
        0x0001D65F
    };

    static Char _decompositionMapping0001D660[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D660 =
    {
        0x0001D660,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D660,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D660,
        0x0001D660,
        0x0001D660
    };

    static Char _decompositionMapping0001D661[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D661 =
    {
        0x0001D661,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D661,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D661,
        0x0001D661,
        0x0001D661
    };

    static Char _decompositionMapping0001D662[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D662 =
    {
        0x0001D662,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D662,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D662,
        0x0001D662,
        0x0001D662
    };

    static Char _decompositionMapping0001D663[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D663 =
    {
        0x0001D663,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D663,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D663,
        0x0001D663,
        0x0001D663
    };

    static Char _decompositionMapping0001D664[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D664 =
    {
        0x0001D664,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D664,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D664,
        0x0001D664,
        0x0001D664
    };

    static Char _decompositionMapping0001D665[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D665 =
    {
        0x0001D665,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D665,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D665,
        0x0001D665,
        0x0001D665
    };

    static Char _decompositionMapping0001D666[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D666 =
    {
        0x0001D666,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D666,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D666,
        0x0001D666,
        0x0001D666
    };

    static Char _decompositionMapping0001D667[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D667 =
    {
        0x0001D667,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D667,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D667,
        0x0001D667,
        0x0001D667
    };

    static Char _decompositionMapping0001D668[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D668 =
    {
        0x0001D668,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D668,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D668,
        0x0001D668,
        0x0001D668
    };

    static Char _decompositionMapping0001D669[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D669 =
    {
        0x0001D669,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D669,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D669,
        0x0001D669,
        0x0001D669
    };

    static Char _decompositionMapping0001D66A[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D66A =
    {
        0x0001D66A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66A,
        0x0001D66A,
        0x0001D66A
    };

    static Char _decompositionMapping0001D66B[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D66B =
    {
        0x0001D66B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66B,
        0x0001D66B,
        0x0001D66B
    };

    static Char _decompositionMapping0001D66C[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D66C =
    {
        0x0001D66C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66C,
        0x0001D66C,
        0x0001D66C
    };

    static Char _decompositionMapping0001D66D[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D66D =
    {
        0x0001D66D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66D,
        0x0001D66D,
        0x0001D66D
    };

    static Char _decompositionMapping0001D66E[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D66E =
    {
        0x0001D66E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66E,
        0x0001D66E,
        0x0001D66E
    };

    static Char _decompositionMapping0001D66F[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D66F =
    {
        0x0001D66F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D66F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D66F,
        0x0001D66F,
        0x0001D66F
    };

    static Char _decompositionMapping0001D670[] = 
    {
        0x00000041
    };

    static _CharacterInfo _character0001D670 =
    {
        0x0001D670,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D670,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D670,
        0x0001D670,
        0x0001D670
    };

    static Char _decompositionMapping0001D671[] = 
    {
        0x00000042
    };

    static _CharacterInfo _character0001D671 =
    {
        0x0001D671,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D671,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D671,
        0x0001D671,
        0x0001D671
    };

    static Char _decompositionMapping0001D672[] = 
    {
        0x00000043
    };

    static _CharacterInfo _character0001D672 =
    {
        0x0001D672,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D672,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D672,
        0x0001D672,
        0x0001D672
    };

    static Char _decompositionMapping0001D673[] = 
    {
        0x00000044
    };

    static _CharacterInfo _character0001D673 =
    {
        0x0001D673,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D673,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D673,
        0x0001D673,
        0x0001D673
    };

    static Char _decompositionMapping0001D674[] = 
    {
        0x00000045
    };

    static _CharacterInfo _character0001D674 =
    {
        0x0001D674,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D674,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D674,
        0x0001D674,
        0x0001D674
    };

    static Char _decompositionMapping0001D675[] = 
    {
        0x00000046
    };

    static _CharacterInfo _character0001D675 =
    {
        0x0001D675,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D675,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D675,
        0x0001D675,
        0x0001D675
    };

    static Char _decompositionMapping0001D676[] = 
    {
        0x00000047
    };

    static _CharacterInfo _character0001D676 =
    {
        0x0001D676,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D676,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D676,
        0x0001D676,
        0x0001D676
    };

    static Char _decompositionMapping0001D677[] = 
    {
        0x00000048
    };

    static _CharacterInfo _character0001D677 =
    {
        0x0001D677,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D677,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D677,
        0x0001D677,
        0x0001D677
    };

    static Char _decompositionMapping0001D678[] = 
    {
        0x00000049
    };

    static _CharacterInfo _character0001D678 =
    {
        0x0001D678,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D678,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D678,
        0x0001D678,
        0x0001D678
    };

    static Char _decompositionMapping0001D679[] = 
    {
        0x0000004A
    };

    static _CharacterInfo _character0001D679 =
    {
        0x0001D679,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D679,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D679,
        0x0001D679,
        0x0001D679
    };

    static Char _decompositionMapping0001D67A[] = 
    {
        0x0000004B
    };

    static _CharacterInfo _character0001D67A =
    {
        0x0001D67A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67A,
        0x0001D67A,
        0x0001D67A
    };

    static Char _decompositionMapping0001D67B[] = 
    {
        0x0000004C
    };

    static _CharacterInfo _character0001D67B =
    {
        0x0001D67B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67B,
        0x0001D67B,
        0x0001D67B
    };

    static Char _decompositionMapping0001D67C[] = 
    {
        0x0000004D
    };

    static _CharacterInfo _character0001D67C =
    {
        0x0001D67C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67C,
        0x0001D67C,
        0x0001D67C
    };

    static Char _decompositionMapping0001D67D[] = 
    {
        0x0000004E
    };

    static _CharacterInfo _character0001D67D =
    {
        0x0001D67D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67D,
        0x0001D67D,
        0x0001D67D
    };

    static Char _decompositionMapping0001D67E[] = 
    {
        0x0000004F
    };

    static _CharacterInfo _character0001D67E =
    {
        0x0001D67E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67E,
        0x0001D67E,
        0x0001D67E
    };

    static Char _decompositionMapping0001D67F[] = 
    {
        0x00000050
    };

    static _CharacterInfo _character0001D67F =
    {
        0x0001D67F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D67F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D67F,
        0x0001D67F,
        0x0001D67F
    };

    static Char _decompositionMapping0001D680[] = 
    {
        0x00000051
    };

    static _CharacterInfo _character0001D680 =
    {
        0x0001D680,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D680,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D680,
        0x0001D680,
        0x0001D680
    };

    static Char _decompositionMapping0001D681[] = 
    {
        0x00000052
    };

    static _CharacterInfo _character0001D681 =
    {
        0x0001D681,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D681,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D681,
        0x0001D681,
        0x0001D681
    };

    static Char _decompositionMapping0001D682[] = 
    {
        0x00000053
    };

    static _CharacterInfo _character0001D682 =
    {
        0x0001D682,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D682,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D682,
        0x0001D682,
        0x0001D682
    };

    static Char _decompositionMapping0001D683[] = 
    {
        0x00000054
    };

    static _CharacterInfo _character0001D683 =
    {
        0x0001D683,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D683,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D683,
        0x0001D683,
        0x0001D683
    };

    static Char _decompositionMapping0001D684[] = 
    {
        0x00000055
    };

    static _CharacterInfo _character0001D684 =
    {
        0x0001D684,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D684,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D684,
        0x0001D684,
        0x0001D684
    };

    static Char _decompositionMapping0001D685[] = 
    {
        0x00000056
    };

    static _CharacterInfo _character0001D685 =
    {
        0x0001D685,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D685,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D685,
        0x0001D685,
        0x0001D685
    };

    static Char _decompositionMapping0001D686[] = 
    {
        0x00000057
    };

    static _CharacterInfo _character0001D686 =
    {
        0x0001D686,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D686,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D686,
        0x0001D686,
        0x0001D686
    };

    static Char _decompositionMapping0001D687[] = 
    {
        0x00000058
    };

    static _CharacterInfo _character0001D687 =
    {
        0x0001D687,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D687,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D687,
        0x0001D687,
        0x0001D687
    };

    static Char _decompositionMapping0001D688[] = 
    {
        0x00000059
    };

    static _CharacterInfo _character0001D688 =
    {
        0x0001D688,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D688,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D688,
        0x0001D688,
        0x0001D688
    };

    static Char _decompositionMapping0001D689[] = 
    {
        0x0000005A
    };

    static _CharacterInfo _character0001D689 =
    {
        0x0001D689,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D689,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D689,
        0x0001D689,
        0x0001D689
    };

    static Char _decompositionMapping0001D68A[] = 
    {
        0x00000061
    };

    static _CharacterInfo _character0001D68A =
    {
        0x0001D68A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68A,
        0x0001D68A,
        0x0001D68A
    };

    static Char _decompositionMapping0001D68B[] = 
    {
        0x00000062
    };

    static _CharacterInfo _character0001D68B =
    {
        0x0001D68B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68B,
        0x0001D68B,
        0x0001D68B
    };

    static Char _decompositionMapping0001D68C[] = 
    {
        0x00000063
    };

    static _CharacterInfo _character0001D68C =
    {
        0x0001D68C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68C,
        0x0001D68C,
        0x0001D68C
    };

    static Char _decompositionMapping0001D68D[] = 
    {
        0x00000064
    };

    static _CharacterInfo _character0001D68D =
    {
        0x0001D68D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68D,
        0x0001D68D,
        0x0001D68D
    };

    static Char _decompositionMapping0001D68E[] = 
    {
        0x00000065
    };

    static _CharacterInfo _character0001D68E =
    {
        0x0001D68E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68E,
        0x0001D68E,
        0x0001D68E
    };

    static Char _decompositionMapping0001D68F[] = 
    {
        0x00000066
    };

    static _CharacterInfo _character0001D68F =
    {
        0x0001D68F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D68F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D68F,
        0x0001D68F,
        0x0001D68F
    };

    static Char _decompositionMapping0001D690[] = 
    {
        0x00000067
    };

    static _CharacterInfo _character0001D690 =
    {
        0x0001D690,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D690,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D690,
        0x0001D690,
        0x0001D690
    };

    static Char _decompositionMapping0001D691[] = 
    {
        0x00000068
    };

    static _CharacterInfo _character0001D691 =
    {
        0x0001D691,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D691,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D691,
        0x0001D691,
        0x0001D691
    };

    static Char _decompositionMapping0001D692[] = 
    {
        0x00000069
    };

    static _CharacterInfo _character0001D692 =
    {
        0x0001D692,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D692,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D692,
        0x0001D692,
        0x0001D692
    };

    static Char _decompositionMapping0001D693[] = 
    {
        0x0000006A
    };

    static _CharacterInfo _character0001D693 =
    {
        0x0001D693,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D693,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D693,
        0x0001D693,
        0x0001D693
    };

    static Char _decompositionMapping0001D694[] = 
    {
        0x0000006B
    };

    static _CharacterInfo _character0001D694 =
    {
        0x0001D694,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D694,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D694,
        0x0001D694,
        0x0001D694
    };

    static Char _decompositionMapping0001D695[] = 
    {
        0x0000006C
    };

    static _CharacterInfo _character0001D695 =
    {
        0x0001D695,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D695,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D695,
        0x0001D695,
        0x0001D695
    };

    static Char _decompositionMapping0001D696[] = 
    {
        0x0000006D
    };

    static _CharacterInfo _character0001D696 =
    {
        0x0001D696,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D696,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D696,
        0x0001D696,
        0x0001D696
    };

    static Char _decompositionMapping0001D697[] = 
    {
        0x0000006E
    };

    static _CharacterInfo _character0001D697 =
    {
        0x0001D697,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D697,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D697,
        0x0001D697,
        0x0001D697
    };

    static Char _decompositionMapping0001D698[] = 
    {
        0x0000006F
    };

    static _CharacterInfo _character0001D698 =
    {
        0x0001D698,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D698,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D698,
        0x0001D698,
        0x0001D698
    };

    static Char _decompositionMapping0001D699[] = 
    {
        0x00000070
    };

    static _CharacterInfo _character0001D699 =
    {
        0x0001D699,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D699,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D699,
        0x0001D699,
        0x0001D699
    };

    static Char _decompositionMapping0001D69A[] = 
    {
        0x00000071
    };

    static _CharacterInfo _character0001D69A =
    {
        0x0001D69A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69A,
        0x0001D69A,
        0x0001D69A
    };

    static Char _decompositionMapping0001D69B[] = 
    {
        0x00000072
    };

    static _CharacterInfo _character0001D69B =
    {
        0x0001D69B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69B,
        0x0001D69B,
        0x0001D69B
    };

    static Char _decompositionMapping0001D69C[] = 
    {
        0x00000073
    };

    static _CharacterInfo _character0001D69C =
    {
        0x0001D69C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69C,
        0x0001D69C,
        0x0001D69C
    };

    static Char _decompositionMapping0001D69D[] = 
    {
        0x00000074
    };

    static _CharacterInfo _character0001D69D =
    {
        0x0001D69D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69D,
        0x0001D69D,
        0x0001D69D
    };

    static Char _decompositionMapping0001D69E[] = 
    {
        0x00000075
    };

    static _CharacterInfo _character0001D69E =
    {
        0x0001D69E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69E,
        0x0001D69E,
        0x0001D69E
    };

    static Char _decompositionMapping0001D69F[] = 
    {
        0x00000076
    };

    static _CharacterInfo _character0001D69F =
    {
        0x0001D69F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D69F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D69F,
        0x0001D69F,
        0x0001D69F
    };

    static Char _decompositionMapping0001D6A0[] = 
    {
        0x00000077
    };

    static _CharacterInfo _character0001D6A0 =
    {
        0x0001D6A0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A0,
        0x0001D6A0,
        0x0001D6A0
    };

    static Char _decompositionMapping0001D6A1[] = 
    {
        0x00000078
    };

    static _CharacterInfo _character0001D6A1 =
    {
        0x0001D6A1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A1,
        0x0001D6A1,
        0x0001D6A1
    };

    static Char _decompositionMapping0001D6A2[] = 
    {
        0x00000079
    };

    static _CharacterInfo _character0001D6A2 =
    {
        0x0001D6A2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A2,
        0x0001D6A2,
        0x0001D6A2
    };

    static Char _decompositionMapping0001D6A3[] = 
    {
        0x0000007A
    };

    static _CharacterInfo _character0001D6A3 =
    {
        0x0001D6A3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A3,
        0x0001D6A3,
        0x0001D6A3
    };

    static Char _decompositionMapping0001D6A4[] = 
    {
        0x00000131
    };

    static _CharacterInfo _character0001D6A4 =
    {
        0x0001D6A4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A4,
        0x0001D6A4,
        0x0001D6A4
    };

    static Char _decompositionMapping0001D6A5[] = 
    {
        0x00000237
    };

    static _CharacterInfo _character0001D6A5 =
    {
        0x0001D6A5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A5,
        0x0001D6A5,
        0x0001D6A5
    };

    static Char _decompositionMapping0001D6A8[] = 
    {
        0x00000391
    };

    static _CharacterInfo _character0001D6A8 =
    {
        0x0001D6A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A8,
        0x0001D6A8,
        0x0001D6A8
    };

    static Char _decompositionMapping0001D6A9[] = 
    {
        0x00000392
    };

    static _CharacterInfo _character0001D6A9 =
    {
        0x0001D6A9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6A9,
        0x0001D6A9,
        0x0001D6A9
    };

    static Char _decompositionMapping0001D6AA[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0001D6AA =
    {
        0x0001D6AA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AA,
        0x0001D6AA,
        0x0001D6AA
    };

    static Char _decompositionMapping0001D6AB[] = 
    {
        0x00000394
    };

    static _CharacterInfo _character0001D6AB =
    {
        0x0001D6AB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AB,
        0x0001D6AB,
        0x0001D6AB
    };

    static Char _decompositionMapping0001D6AC[] = 
    {
        0x00000395
    };

    static _CharacterInfo _character0001D6AC =
    {
        0x0001D6AC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AC,
        0x0001D6AC,
        0x0001D6AC
    };

    static Char _decompositionMapping0001D6AD[] = 
    {
        0x00000396
    };

    static _CharacterInfo _character0001D6AD =
    {
        0x0001D6AD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AD,
        0x0001D6AD,
        0x0001D6AD
    };

    static Char _decompositionMapping0001D6AE[] = 
    {
        0x00000397
    };

    static _CharacterInfo _character0001D6AE =
    {
        0x0001D6AE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AE,
        0x0001D6AE,
        0x0001D6AE
    };

    static Char _decompositionMapping0001D6AF[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character0001D6AF =
    {
        0x0001D6AF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6AF,
        0x0001D6AF,
        0x0001D6AF
    };

    static Char _decompositionMapping0001D6B0[] = 
    {
        0x00000399
    };

    static _CharacterInfo _character0001D6B0 =
    {
        0x0001D6B0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B0,
        0x0001D6B0,
        0x0001D6B0
    };

    static Char _decompositionMapping0001D6B1[] = 
    {
        0x0000039A
    };

    static _CharacterInfo _character0001D6B1 =
    {
        0x0001D6B1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B1,
        0x0001D6B1,
        0x0001D6B1
    };

    static Char _decompositionMapping0001D6B2[] = 
    {
        0x0000039B
    };

    static _CharacterInfo _character0001D6B2 =
    {
        0x0001D6B2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B2,
        0x0001D6B2,
        0x0001D6B2
    };

    static Char _decompositionMapping0001D6B3[] = 
    {
        0x0000039C
    };

    static _CharacterInfo _character0001D6B3 =
    {
        0x0001D6B3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B3,
        0x0001D6B3,
        0x0001D6B3
    };

    static Char _decompositionMapping0001D6B4[] = 
    {
        0x0000039D
    };

    static _CharacterInfo _character0001D6B4 =
    {
        0x0001D6B4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B4,
        0x0001D6B4,
        0x0001D6B4
    };

    static Char _decompositionMapping0001D6B5[] = 
    {
        0x0000039E
    };

    static _CharacterInfo _character0001D6B5 =
    {
        0x0001D6B5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B5,
        0x0001D6B5,
        0x0001D6B5
    };

    static Char _decompositionMapping0001D6B6[] = 
    {
        0x0000039F
    };

    static _CharacterInfo _character0001D6B6 =
    {
        0x0001D6B6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B6,
        0x0001D6B6,
        0x0001D6B6
    };

    static Char _decompositionMapping0001D6B7[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0001D6B7 =
    {
        0x0001D6B7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B7,
        0x0001D6B7,
        0x0001D6B7
    };

    static Char _decompositionMapping0001D6B8[] = 
    {
        0x000003A1
    };

    static _CharacterInfo _character0001D6B8 =
    {
        0x0001D6B8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B8,
        0x0001D6B8,
        0x0001D6B8
    };

    static Char _decompositionMapping0001D6B9[] = 
    {
        0x000003F4
    };

    static _CharacterInfo _character0001D6B9 =
    {
        0x0001D6B9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6B9,
        0x0001D6B9,
        0x0001D6B9
    };

    static Char _decompositionMapping0001D6BA[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character0001D6BA =
    {
        0x0001D6BA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BA,
        0x0001D6BA,
        0x0001D6BA
    };

    static Char _decompositionMapping0001D6BB[] = 
    {
        0x000003A4
    };

    static _CharacterInfo _character0001D6BB =
    {
        0x0001D6BB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BB,
        0x0001D6BB,
        0x0001D6BB
    };

    static Char _decompositionMapping0001D6BC[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character0001D6BC =
    {
        0x0001D6BC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BC,
        0x0001D6BC,
        0x0001D6BC
    };

    static Char _decompositionMapping0001D6BD[] = 
    {
        0x000003A6
    };

    static _CharacterInfo _character0001D6BD =
    {
        0x0001D6BD,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BD,
        0x0001D6BD,
        0x0001D6BD
    };

    static Char _decompositionMapping0001D6BE[] = 
    {
        0x000003A7
    };

    static _CharacterInfo _character0001D6BE =
    {
        0x0001D6BE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BE,
        0x0001D6BE,
        0x0001D6BE
    };

    static Char _decompositionMapping0001D6BF[] = 
    {
        0x000003A8
    };

    static _CharacterInfo _character0001D6BF =
    {
        0x0001D6BF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6BF,
        0x0001D6BF,
        0x0001D6BF
    };

    static Char _decompositionMapping0001D6C0[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character0001D6C0 =
    {
        0x0001D6C0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C0,
        0x0001D6C0,
        0x0001D6C0
    };

    static Char _decompositionMapping0001D6C1[] = 
    {
        0x00002207
    };

    static _CharacterInfo _character0001D6C1 =
    {
        0x0001D6C1,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C1,
        0x0001D6C1,
        0x0001D6C1
    };

    static Char _decompositionMapping0001D6C2[] = 
    {
        0x000003B1
    };

    static _CharacterInfo _character0001D6C2 =
    {
        0x0001D6C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C2,
        0x0001D6C2,
        0x0001D6C2
    };

    static Char _decompositionMapping0001D6C3[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character0001D6C3 =
    {
        0x0001D6C3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C3,
        0x0001D6C3,
        0x0001D6C3
    };

    static Char _decompositionMapping0001D6C4[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0001D6C4 =
    {
        0x0001D6C4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C4,
        0x0001D6C4,
        0x0001D6C4
    };

    static Char _decompositionMapping0001D6C5[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character0001D6C5 =
    {
        0x0001D6C5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C5,
        0x0001D6C5,
        0x0001D6C5
    };

    static Char _decompositionMapping0001D6C6[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character0001D6C6 =
    {
        0x0001D6C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C6,
        0x0001D6C6,
        0x0001D6C6
    };

    static Char _decompositionMapping0001D6C7[] = 
    {
        0x000003B6
    };

    static _CharacterInfo _character0001D6C7 =
    {
        0x0001D6C7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C7,
        0x0001D6C7,
        0x0001D6C7
    };

    static Char _decompositionMapping0001D6C8[] = 
    {
        0x000003B7
    };

    static _CharacterInfo _character0001D6C8 =
    {
        0x0001D6C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C8,
        0x0001D6C8,
        0x0001D6C8
    };

    static Char _decompositionMapping0001D6C9[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character0001D6C9 =
    {
        0x0001D6C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6C9,
        0x0001D6C9,
        0x0001D6C9
    };

    static Char _decompositionMapping0001D6CA[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character0001D6CA =
    {
        0x0001D6CA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CA,
        0x0001D6CA,
        0x0001D6CA
    };

    static Char _decompositionMapping0001D6CB[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character0001D6CB =
    {
        0x0001D6CB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CB,
        0x0001D6CB,
        0x0001D6CB
    };

    static Char _decompositionMapping0001D6CC[] = 
    {
        0x000003BB
    };

    static _CharacterInfo _character0001D6CC =
    {
        0x0001D6CC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CC,
        0x0001D6CC,
        0x0001D6CC
    };

    static Char _decompositionMapping0001D6CD[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character0001D6CD =
    {
        0x0001D6CD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CD,
        0x0001D6CD,
        0x0001D6CD
    };

    static Char _decompositionMapping0001D6CE[] = 
    {
        0x000003BD
    };

    static _CharacterInfo _character0001D6CE =
    {
        0x0001D6CE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CE,
        0x0001D6CE,
        0x0001D6CE
    };

    static Char _decompositionMapping0001D6CF[] = 
    {
        0x000003BE
    };

    static _CharacterInfo _character0001D6CF =
    {
        0x0001D6CF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6CF,
        0x0001D6CF,
        0x0001D6CF
    };

    static Char _decompositionMapping0001D6D0[] = 
    {
        0x000003BF
    };

    static _CharacterInfo _character0001D6D0 =
    {
        0x0001D6D0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D0,
        0x0001D6D0,
        0x0001D6D0
    };

    static Char _decompositionMapping0001D6D1[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0001D6D1 =
    {
        0x0001D6D1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D1,
        0x0001D6D1,
        0x0001D6D1
    };

    static Char _decompositionMapping0001D6D2[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character0001D6D2 =
    {
        0x0001D6D2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D2,
        0x0001D6D2,
        0x0001D6D2
    };

    static Char _decompositionMapping0001D6D3[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character0001D6D3 =
    {
        0x0001D6D3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D3,
        0x0001D6D3,
        0x0001D6D3
    };

    static Char _decompositionMapping0001D6D4[] = 
    {
        0x000003C3
    };

    static _CharacterInfo _character0001D6D4 =
    {
        0x0001D6D4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D4,
        0x0001D6D4,
        0x0001D6D4
    };

    static Char _decompositionMapping0001D6D5[] = 
    {
        0x000003C4
    };

    static _CharacterInfo _character0001D6D5 =
    {
        0x0001D6D5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D5,
        0x0001D6D5,
        0x0001D6D5
    };

    static Char _decompositionMapping0001D6D6[] = 
    {
        0x000003C5
    };

    static _CharacterInfo _character0001D6D6 =
    {
        0x0001D6D6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D6,
        0x0001D6D6,
        0x0001D6D6
    };

    static Char _decompositionMapping0001D6D7[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character0001D6D7 =
    {
        0x0001D6D7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D7,
        0x0001D6D7,
        0x0001D6D7
    };

    static Char _decompositionMapping0001D6D8[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character0001D6D8 =
    {
        0x0001D6D8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D8,
        0x0001D6D8,
        0x0001D6D8
    };

    static Char _decompositionMapping0001D6D9[] = 
    {
        0x000003C8
    };

    static _CharacterInfo _character0001D6D9 =
    {
        0x0001D6D9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6D9,
        0x0001D6D9,
        0x0001D6D9
    };

    static Char _decompositionMapping0001D6DA[] = 
    {
        0x000003C9
    };

    static _CharacterInfo _character0001D6DA =
    {
        0x0001D6DA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6DA,
        0x0001D6DA,
        0x0001D6DA
    };

    static Char _decompositionMapping0001D6DB[] = 
    {
        0x00002202
    };

    static _CharacterInfo _character0001D6DB =
    {
        0x0001D6DB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0001D6DB,
        0x0001D6DB,
        0x0001D6DB
    };

    static Char _decompositionMapping0001D6DC[] = 
    {
        0x000003F5
    };

    static _CharacterInfo _character0001D6DC =
    {
        0x0001D6DC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6DC,
        0x0001D6DC,
        0x0001D6DC
    };

    static Char _decompositionMapping0001D6DD[] = 
    {
        0x000003D1
    };

    static _CharacterInfo _character0001D6DD =
    {
        0x0001D6DD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6DD,
        0x0001D6DD,
        0x0001D6DD
    };

    static Char _decompositionMapping0001D6DE[] = 
    {
        0x000003F0
    };

    static _CharacterInfo _character0001D6DE =
    {
        0x0001D6DE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6DE,
        0x0001D6DE,
        0x0001D6DE
    };

    static Char _decompositionMapping0001D6DF[] = 
    {
        0x000003D5
    };

    static _CharacterInfo _character0001D6DF =
    {
        0x0001D6DF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6DF,
        0x0001D6DF,
        0x0001D6DF
    };

    static Char _decompositionMapping0001D6E0[] = 
    {
        0x000003F1
    };

    static _CharacterInfo _character0001D6E0 =
    {
        0x0001D6E0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E0,
        0x0001D6E0,
        0x0001D6E0
    };

    static Char _decompositionMapping0001D6E1[] = 
    {
        0x000003D6
    };

    static _CharacterInfo _character0001D6E1 =
    {
        0x0001D6E1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E1,
        0x0001D6E1,
        0x0001D6E1
    };

    static Char _decompositionMapping0001D6E2[] = 
    {
        0x00000391
    };

    static _CharacterInfo _character0001D6E2 =
    {
        0x0001D6E2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E2,
        0x0001D6E2,
        0x0001D6E2
    };

    static Char _decompositionMapping0001D6E3[] = 
    {
        0x00000392
    };

    static _CharacterInfo _character0001D6E3 =
    {
        0x0001D6E3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E3,
        0x0001D6E3,
        0x0001D6E3
    };

    static Char _decompositionMapping0001D6E4[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0001D6E4 =
    {
        0x0001D6E4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E4,
        0x0001D6E4,
        0x0001D6E4
    };

    static Char _decompositionMapping0001D6E5[] = 
    {
        0x00000394
    };

    static _CharacterInfo _character0001D6E5 =
    {
        0x0001D6E5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E5,
        0x0001D6E5,
        0x0001D6E5
    };

    static Char _decompositionMapping0001D6E6[] = 
    {
        0x00000395
    };

    static _CharacterInfo _character0001D6E6 =
    {
        0x0001D6E6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E6,
        0x0001D6E6,
        0x0001D6E6
    };

    static Char _decompositionMapping0001D6E7[] = 
    {
        0x00000396
    };

    static _CharacterInfo _character0001D6E7 =
    {
        0x0001D6E7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E7,
        0x0001D6E7,
        0x0001D6E7
    };

    static Char _decompositionMapping0001D6E8[] = 
    {
        0x00000397
    };

    static _CharacterInfo _character0001D6E8 =
    {
        0x0001D6E8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E8,
        0x0001D6E8,
        0x0001D6E8
    };

    static Char _decompositionMapping0001D6E9[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character0001D6E9 =
    {
        0x0001D6E9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6E9,
        0x0001D6E9,
        0x0001D6E9
    };

    static Char _decompositionMapping0001D6EA[] = 
    {
        0x00000399
    };

    static _CharacterInfo _character0001D6EA =
    {
        0x0001D6EA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6EA,
        0x0001D6EA,
        0x0001D6EA
    };

    static Char _decompositionMapping0001D6EB[] = 
    {
        0x0000039A
    };

    static _CharacterInfo _character0001D6EB =
    {
        0x0001D6EB,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6EB,
        0x0001D6EB,
        0x0001D6EB
    };

    static Char _decompositionMapping0001D6EC[] = 
    {
        0x0000039B
    };

    static _CharacterInfo _character0001D6EC =
    {
        0x0001D6EC,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6EC,
        0x0001D6EC,
        0x0001D6EC
    };

    static Char _decompositionMapping0001D6ED[] = 
    {
        0x0000039C
    };

    static _CharacterInfo _character0001D6ED =
    {
        0x0001D6ED,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6ED,
        0x0001D6ED,
        0x0001D6ED
    };

    static Char _decompositionMapping0001D6EE[] = 
    {
        0x0000039D
    };

    static _CharacterInfo _character0001D6EE =
    {
        0x0001D6EE,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6EE,
        0x0001D6EE,
        0x0001D6EE
    };

    static Char _decompositionMapping0001D6EF[] = 
    {
        0x0000039E
    };

    static _CharacterInfo _character0001D6EF =
    {
        0x0001D6EF,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6EF,
        0x0001D6EF,
        0x0001D6EF
    };

    static Char _decompositionMapping0001D6F0[] = 
    {
        0x0000039F
    };

    static _CharacterInfo _character0001D6F0 =
    {
        0x0001D6F0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F0,
        0x0001D6F0,
        0x0001D6F0
    };

    static Char _decompositionMapping0001D6F1[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0001D6F1 =
    {
        0x0001D6F1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F1,
        0x0001D6F1,
        0x0001D6F1
    };

    static Char _decompositionMapping0001D6F2[] = 
    {
        0x000003A1
    };

    static _CharacterInfo _character0001D6F2 =
    {
        0x0001D6F2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F2,
        0x0001D6F2,
        0x0001D6F2
    };

    static Char _decompositionMapping0001D6F3[] = 
    {
        0x000003F4
    };

    static _CharacterInfo _character0001D6F3 =
    {
        0x0001D6F3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F3,
        0x0001D6F3,
        0x0001D6F3
    };

    static Char _decompositionMapping0001D6F4[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character0001D6F4 =
    {
        0x0001D6F4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F4,
        0x0001D6F4,
        0x0001D6F4
    };

    static Char _decompositionMapping0001D6F5[] = 
    {
        0x000003A4
    };

    static _CharacterInfo _character0001D6F5 =
    {
        0x0001D6F5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F5,
        0x0001D6F5,
        0x0001D6F5
    };

    static Char _decompositionMapping0001D6F6[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character0001D6F6 =
    {
        0x0001D6F6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F6,
        0x0001D6F6,
        0x0001D6F6
    };

    static Char _decompositionMapping0001D6F7[] = 
    {
        0x000003A6
    };

    static _CharacterInfo _character0001D6F7 =
    {
        0x0001D6F7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F7,
        0x0001D6F7,
        0x0001D6F7
    };

    static Char _decompositionMapping0001D6F8[] = 
    {
        0x000003A7
    };

    static _CharacterInfo _character0001D6F8 =
    {
        0x0001D6F8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F8,
        0x0001D6F8,
        0x0001D6F8
    };

    static Char _decompositionMapping0001D6F9[] = 
    {
        0x000003A8
    };

    static _CharacterInfo _character0001D6F9 =
    {
        0x0001D6F9,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6F9,
        0x0001D6F9,
        0x0001D6F9
    };

    static Char _decompositionMapping0001D6FA[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character0001D6FA =
    {
        0x0001D6FA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FA,
        0x0001D6FA,
        0x0001D6FA
    };

    static Char _decompositionMapping0001D6FB[] = 
    {
        0x00002207
    };

    static _CharacterInfo _character0001D6FB =
    {
        0x0001D6FB,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FB,
        0x0001D6FB,
        0x0001D6FB
    };

    static Char _decompositionMapping0001D6FC[] = 
    {
        0x000003B1
    };

    static _CharacterInfo _character0001D6FC =
    {
        0x0001D6FC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FC,
        0x0001D6FC,
        0x0001D6FC
    };

    static Char _decompositionMapping0001D6FD[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character0001D6FD =
    {
        0x0001D6FD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FD,
        0x0001D6FD,
        0x0001D6FD
    };

    static Char _decompositionMapping0001D6FE[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0001D6FE =
    {
        0x0001D6FE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FE,
        0x0001D6FE,
        0x0001D6FE
    };

    static Char _decompositionMapping0001D6FF[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character0001D6FF =
    {
        0x0001D6FF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D6FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D6FF,
        0x0001D6FF,
        0x0001D6FF
    };

    static Char _decompositionMapping0001D700[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character0001D700 =
    {
        0x0001D700,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D700,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D700,
        0x0001D700,
        0x0001D700
    };

    static Char _decompositionMapping0001D701[] = 
    {
        0x000003B6
    };

    static _CharacterInfo _character0001D701 =
    {
        0x0001D701,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D701,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D701,
        0x0001D701,
        0x0001D701
    };

    static Char _decompositionMapping0001D702[] = 
    {
        0x000003B7
    };

    static _CharacterInfo _character0001D702 =
    {
        0x0001D702,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D702,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D702,
        0x0001D702,
        0x0001D702
    };

    static Char _decompositionMapping0001D703[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character0001D703 =
    {
        0x0001D703,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D703,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D703,
        0x0001D703,
        0x0001D703
    };

    static Char _decompositionMapping0001D704[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character0001D704 =
    {
        0x0001D704,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D704,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D704,
        0x0001D704,
        0x0001D704
    };

    static Char _decompositionMapping0001D705[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character0001D705 =
    {
        0x0001D705,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D705,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D705,
        0x0001D705,
        0x0001D705
    };

    static Char _decompositionMapping0001D706[] = 
    {
        0x000003BB
    };

    static _CharacterInfo _character0001D706 =
    {
        0x0001D706,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D706,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D706,
        0x0001D706,
        0x0001D706
    };

    static Char _decompositionMapping0001D707[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character0001D707 =
    {
        0x0001D707,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D707,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D707,
        0x0001D707,
        0x0001D707
    };

    static Char _decompositionMapping0001D708[] = 
    {
        0x000003BD
    };

    static _CharacterInfo _character0001D708 =
    {
        0x0001D708,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D708,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D708,
        0x0001D708,
        0x0001D708
    };

    static Char _decompositionMapping0001D709[] = 
    {
        0x000003BE
    };

    static _CharacterInfo _character0001D709 =
    {
        0x0001D709,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D709,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D709,
        0x0001D709,
        0x0001D709
    };

    static Char _decompositionMapping0001D70A[] = 
    {
        0x000003BF
    };

    static _CharacterInfo _character0001D70A =
    {
        0x0001D70A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70A,
        0x0001D70A,
        0x0001D70A
    };

    static Char _decompositionMapping0001D70B[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0001D70B =
    {
        0x0001D70B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70B,
        0x0001D70B,
        0x0001D70B
    };

    static Char _decompositionMapping0001D70C[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character0001D70C =
    {
        0x0001D70C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70C,
        0x0001D70C,
        0x0001D70C
    };

    static Char _decompositionMapping0001D70D[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character0001D70D =
    {
        0x0001D70D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70D,
        0x0001D70D,
        0x0001D70D
    };

    static Char _decompositionMapping0001D70E[] = 
    {
        0x000003C3
    };

    static _CharacterInfo _character0001D70E =
    {
        0x0001D70E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70E,
        0x0001D70E,
        0x0001D70E
    };

    static Char _decompositionMapping0001D70F[] = 
    {
        0x000003C4
    };

    static _CharacterInfo _character0001D70F =
    {
        0x0001D70F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D70F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D70F,
        0x0001D70F,
        0x0001D70F
    };

    static Char _decompositionMapping0001D710[] = 
    {
        0x000003C5
    };

    static _CharacterInfo _character0001D710 =
    {
        0x0001D710,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D710,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D710,
        0x0001D710,
        0x0001D710
    };

    static Char _decompositionMapping0001D711[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character0001D711 =
    {
        0x0001D711,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D711,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D711,
        0x0001D711,
        0x0001D711
    };

    static Char _decompositionMapping0001D712[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character0001D712 =
    {
        0x0001D712,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D712,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D712,
        0x0001D712,
        0x0001D712
    };

    static Char _decompositionMapping0001D713[] = 
    {
        0x000003C8
    };

    static _CharacterInfo _character0001D713 =
    {
        0x0001D713,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D713,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D713,
        0x0001D713,
        0x0001D713
    };

    static Char _decompositionMapping0001D714[] = 
    {
        0x000003C9
    };

    static _CharacterInfo _character0001D714 =
    {
        0x0001D714,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D714,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D714,
        0x0001D714,
        0x0001D714
    };

    static Char _decompositionMapping0001D715[] = 
    {
        0x00002202
    };

    static _CharacterInfo _character0001D715 =
    {
        0x0001D715,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D715,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0001D715,
        0x0001D715,
        0x0001D715
    };

    static Char _decompositionMapping0001D716[] = 
    {
        0x000003F5
    };

    static _CharacterInfo _character0001D716 =
    {
        0x0001D716,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D716,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D716,
        0x0001D716,
        0x0001D716
    };

    static Char _decompositionMapping0001D717[] = 
    {
        0x000003D1
    };

    static _CharacterInfo _character0001D717 =
    {
        0x0001D717,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D717,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D717,
        0x0001D717,
        0x0001D717
    };

    static Char _decompositionMapping0001D718[] = 
    {
        0x000003F0
    };

    static _CharacterInfo _character0001D718 =
    {
        0x0001D718,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D718,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D718,
        0x0001D718,
        0x0001D718
    };

    static Char _decompositionMapping0001D719[] = 
    {
        0x000003D5
    };

    static _CharacterInfo _character0001D719 =
    {
        0x0001D719,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D719,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D719,
        0x0001D719,
        0x0001D719
    };

    static Char _decompositionMapping0001D71A[] = 
    {
        0x000003F1
    };

    static _CharacterInfo _character0001D71A =
    {
        0x0001D71A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71A,
        0x0001D71A,
        0x0001D71A
    };

    static Char _decompositionMapping0001D71B[] = 
    {
        0x000003D6
    };

    static _CharacterInfo _character0001D71B =
    {
        0x0001D71B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71B,
        0x0001D71B,
        0x0001D71B
    };

    static Char _decompositionMapping0001D71C[] = 
    {
        0x00000391
    };

    static _CharacterInfo _character0001D71C =
    {
        0x0001D71C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71C,
        0x0001D71C,
        0x0001D71C
    };

    static Char _decompositionMapping0001D71D[] = 
    {
        0x00000392
    };

    static _CharacterInfo _character0001D71D =
    {
        0x0001D71D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71D,
        0x0001D71D,
        0x0001D71D
    };

    static Char _decompositionMapping0001D71E[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0001D71E =
    {
        0x0001D71E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71E,
        0x0001D71E,
        0x0001D71E
    };

    static Char _decompositionMapping0001D71F[] = 
    {
        0x00000394
    };

    static _CharacterInfo _character0001D71F =
    {
        0x0001D71F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D71F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D71F,
        0x0001D71F,
        0x0001D71F
    };

    static Char _decompositionMapping0001D720[] = 
    {
        0x00000395
    };

    static _CharacterInfo _character0001D720 =
    {
        0x0001D720,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D720,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D720,
        0x0001D720,
        0x0001D720
    };

    static Char _decompositionMapping0001D721[] = 
    {
        0x00000396
    };

    static _CharacterInfo _character0001D721 =
    {
        0x0001D721,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D721,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D721,
        0x0001D721,
        0x0001D721
    };

    static Char _decompositionMapping0001D722[] = 
    {
        0x00000397
    };

    static _CharacterInfo _character0001D722 =
    {
        0x0001D722,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D722,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D722,
        0x0001D722,
        0x0001D722
    };

    static Char _decompositionMapping0001D723[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character0001D723 =
    {
        0x0001D723,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D723,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D723,
        0x0001D723,
        0x0001D723
    };

    static Char _decompositionMapping0001D724[] = 
    {
        0x00000399
    };

    static _CharacterInfo _character0001D724 =
    {
        0x0001D724,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D724,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D724,
        0x0001D724,
        0x0001D724
    };

    static Char _decompositionMapping0001D725[] = 
    {
        0x0000039A
    };

    static _CharacterInfo _character0001D725 =
    {
        0x0001D725,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D725,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D725,
        0x0001D725,
        0x0001D725
    };

    static Char _decompositionMapping0001D726[] = 
    {
        0x0000039B
    };

    static _CharacterInfo _character0001D726 =
    {
        0x0001D726,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D726,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D726,
        0x0001D726,
        0x0001D726
    };

    static Char _decompositionMapping0001D727[] = 
    {
        0x0000039C
    };

    static _CharacterInfo _character0001D727 =
    {
        0x0001D727,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D727,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D727,
        0x0001D727,
        0x0001D727
    };

    static Char _decompositionMapping0001D728[] = 
    {
        0x0000039D
    };

    static _CharacterInfo _character0001D728 =
    {
        0x0001D728,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D728,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D728,
        0x0001D728,
        0x0001D728
    };

    static Char _decompositionMapping0001D729[] = 
    {
        0x0000039E
    };

    static _CharacterInfo _character0001D729 =
    {
        0x0001D729,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D729,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D729,
        0x0001D729,
        0x0001D729
    };

    static Char _decompositionMapping0001D72A[] = 
    {
        0x0000039F
    };

    static _CharacterInfo _character0001D72A =
    {
        0x0001D72A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72A,
        0x0001D72A,
        0x0001D72A
    };

    static Char _decompositionMapping0001D72B[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0001D72B =
    {
        0x0001D72B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72B,
        0x0001D72B,
        0x0001D72B
    };

    static Char _decompositionMapping0001D72C[] = 
    {
        0x000003A1
    };

    static _CharacterInfo _character0001D72C =
    {
        0x0001D72C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72C,
        0x0001D72C,
        0x0001D72C
    };

    static Char _decompositionMapping0001D72D[] = 
    {
        0x000003F4
    };

    static _CharacterInfo _character0001D72D =
    {
        0x0001D72D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72D,
        0x0001D72D,
        0x0001D72D
    };

    static Char _decompositionMapping0001D72E[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character0001D72E =
    {
        0x0001D72E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72E,
        0x0001D72E,
        0x0001D72E
    };

    static Char _decompositionMapping0001D72F[] = 
    {
        0x000003A4
    };

    static _CharacterInfo _character0001D72F =
    {
        0x0001D72F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D72F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D72F,
        0x0001D72F,
        0x0001D72F
    };

    static Char _decompositionMapping0001D730[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character0001D730 =
    {
        0x0001D730,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D730,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D730,
        0x0001D730,
        0x0001D730
    };

    static Char _decompositionMapping0001D731[] = 
    {
        0x000003A6
    };

    static _CharacterInfo _character0001D731 =
    {
        0x0001D731,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D731,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D731,
        0x0001D731,
        0x0001D731
    };

    static Char _decompositionMapping0001D732[] = 
    {
        0x000003A7
    };

    static _CharacterInfo _character0001D732 =
    {
        0x0001D732,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D732,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D732,
        0x0001D732,
        0x0001D732
    };

    static Char _decompositionMapping0001D733[] = 
    {
        0x000003A8
    };

    static _CharacterInfo _character0001D733 =
    {
        0x0001D733,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D733,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D733,
        0x0001D733,
        0x0001D733
    };

    static Char _decompositionMapping0001D734[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character0001D734 =
    {
        0x0001D734,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D734,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D734,
        0x0001D734,
        0x0001D734
    };

    static Char _decompositionMapping0001D735[] = 
    {
        0x00002207
    };

    static _CharacterInfo _character0001D735 =
    {
        0x0001D735,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D735,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D735,
        0x0001D735,
        0x0001D735
    };

    static Char _decompositionMapping0001D736[] = 
    {
        0x000003B1
    };

    static _CharacterInfo _character0001D736 =
    {
        0x0001D736,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D736,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D736,
        0x0001D736,
        0x0001D736
    };

    static Char _decompositionMapping0001D737[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character0001D737 =
    {
        0x0001D737,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D737,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D737,
        0x0001D737,
        0x0001D737
    };

    static Char _decompositionMapping0001D738[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0001D738 =
    {
        0x0001D738,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D738,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D738,
        0x0001D738,
        0x0001D738
    };

    static Char _decompositionMapping0001D739[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character0001D739 =
    {
        0x0001D739,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D739,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D739,
        0x0001D739,
        0x0001D739
    };

    static Char _decompositionMapping0001D73A[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character0001D73A =
    {
        0x0001D73A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73A,
        0x0001D73A,
        0x0001D73A
    };

    static Char _decompositionMapping0001D73B[] = 
    {
        0x000003B6
    };

    static _CharacterInfo _character0001D73B =
    {
        0x0001D73B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73B,
        0x0001D73B,
        0x0001D73B
    };

    static Char _decompositionMapping0001D73C[] = 
    {
        0x000003B7
    };

    static _CharacterInfo _character0001D73C =
    {
        0x0001D73C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73C,
        0x0001D73C,
        0x0001D73C
    };

    static Char _decompositionMapping0001D73D[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character0001D73D =
    {
        0x0001D73D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73D,
        0x0001D73D,
        0x0001D73D
    };

    static Char _decompositionMapping0001D73E[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character0001D73E =
    {
        0x0001D73E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73E,
        0x0001D73E,
        0x0001D73E
    };

    static Char _decompositionMapping0001D73F[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character0001D73F =
    {
        0x0001D73F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D73F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D73F,
        0x0001D73F,
        0x0001D73F
    };

    static Char _decompositionMapping0001D740[] = 
    {
        0x000003BB
    };

    static _CharacterInfo _character0001D740 =
    {
        0x0001D740,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D740,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D740,
        0x0001D740,
        0x0001D740
    };

    static Char _decompositionMapping0001D741[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character0001D741 =
    {
        0x0001D741,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D741,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D741,
        0x0001D741,
        0x0001D741
    };

    static Char _decompositionMapping0001D742[] = 
    {
        0x000003BD
    };

    static _CharacterInfo _character0001D742 =
    {
        0x0001D742,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D742,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D742,
        0x0001D742,
        0x0001D742
    };

    static Char _decompositionMapping0001D743[] = 
    {
        0x000003BE
    };

    static _CharacterInfo _character0001D743 =
    {
        0x0001D743,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D743,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D743,
        0x0001D743,
        0x0001D743
    };

    static Char _decompositionMapping0001D744[] = 
    {
        0x000003BF
    };

    static _CharacterInfo _character0001D744 =
    {
        0x0001D744,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D744,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D744,
        0x0001D744,
        0x0001D744
    };

    static Char _decompositionMapping0001D745[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0001D745 =
    {
        0x0001D745,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D745,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D745,
        0x0001D745,
        0x0001D745
    };

    static Char _decompositionMapping0001D746[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character0001D746 =
    {
        0x0001D746,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D746,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D746,
        0x0001D746,
        0x0001D746
    };

    static Char _decompositionMapping0001D747[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character0001D747 =
    {
        0x0001D747,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D747,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D747,
        0x0001D747,
        0x0001D747
    };

    static Char _decompositionMapping0001D748[] = 
    {
        0x000003C3
    };

    static _CharacterInfo _character0001D748 =
    {
        0x0001D748,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D748,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D748,
        0x0001D748,
        0x0001D748
    };

    static Char _decompositionMapping0001D749[] = 
    {
        0x000003C4
    };

    static _CharacterInfo _character0001D749 =
    {
        0x0001D749,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D749,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D749,
        0x0001D749,
        0x0001D749
    };

    static Char _decompositionMapping0001D74A[] = 
    {
        0x000003C5
    };

    static _CharacterInfo _character0001D74A =
    {
        0x0001D74A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D74A,
        0x0001D74A,
        0x0001D74A
    };

    static Char _decompositionMapping0001D74B[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character0001D74B =
    {
        0x0001D74B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D74B,
        0x0001D74B,
        0x0001D74B
    };

    static Char _decompositionMapping0001D74C[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character0001D74C =
    {
        0x0001D74C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D74C,
        0x0001D74C,
        0x0001D74C
    };

    static Char _decompositionMapping0001D74D[] = 
    {
        0x000003C8
    };

    static _CharacterInfo _character0001D74D =
    {
        0x0001D74D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D74D,
        0x0001D74D,
        0x0001D74D
    };

    static Char _decompositionMapping0001D74E[] = 
    {
        0x000003C9
    };

    static _CharacterInfo _character0001D74E =
    {
        0x0001D74E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D74E,
        0x0001D74E,
        0x0001D74E
    };

    static Char _decompositionMapping0001D74F[] = 
    {
        0x00002202
    };

    static _CharacterInfo _character0001D74F =
    {
        0x0001D74F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D74F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0001D74F,
        0x0001D74F,
        0x0001D74F
    };

    static Char _decompositionMapping0001D750[] = 
    {
        0x000003F5
    };

    static _CharacterInfo _character0001D750 =
    {
        0x0001D750,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D750,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D750,
        0x0001D750,
        0x0001D750
    };

    static Char _decompositionMapping0001D751[] = 
    {
        0x000003D1
    };

    static _CharacterInfo _character0001D751 =
    {
        0x0001D751,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D751,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D751,
        0x0001D751,
        0x0001D751
    };

    static Char _decompositionMapping0001D752[] = 
    {
        0x000003F0
    };

    static _CharacterInfo _character0001D752 =
    {
        0x0001D752,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D752,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D752,
        0x0001D752,
        0x0001D752
    };

    static Char _decompositionMapping0001D753[] = 
    {
        0x000003D5
    };

    static _CharacterInfo _character0001D753 =
    {
        0x0001D753,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D753,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D753,
        0x0001D753,
        0x0001D753
    };

    static Char _decompositionMapping0001D754[] = 
    {
        0x000003F1
    };

    static _CharacterInfo _character0001D754 =
    {
        0x0001D754,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D754,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D754,
        0x0001D754,
        0x0001D754
    };

    static Char _decompositionMapping0001D755[] = 
    {
        0x000003D6
    };

    static _CharacterInfo _character0001D755 =
    {
        0x0001D755,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D755,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D755,
        0x0001D755,
        0x0001D755
    };

    static Char _decompositionMapping0001D756[] = 
    {
        0x00000391
    };

    static _CharacterInfo _character0001D756 =
    {
        0x0001D756,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D756,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D756,
        0x0001D756,
        0x0001D756
    };

    static Char _decompositionMapping0001D757[] = 
    {
        0x00000392
    };

    static _CharacterInfo _character0001D757 =
    {
        0x0001D757,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D757,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D757,
        0x0001D757,
        0x0001D757
    };

    static Char _decompositionMapping0001D758[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0001D758 =
    {
        0x0001D758,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D758,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D758,
        0x0001D758,
        0x0001D758
    };

    static Char _decompositionMapping0001D759[] = 
    {
        0x00000394
    };

    static _CharacterInfo _character0001D759 =
    {
        0x0001D759,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D759,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D759,
        0x0001D759,
        0x0001D759
    };

    static Char _decompositionMapping0001D75A[] = 
    {
        0x00000395
    };

    static _CharacterInfo _character0001D75A =
    {
        0x0001D75A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75A,
        0x0001D75A,
        0x0001D75A
    };

    static Char _decompositionMapping0001D75B[] = 
    {
        0x00000396
    };

    static _CharacterInfo _character0001D75B =
    {
        0x0001D75B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75B,
        0x0001D75B,
        0x0001D75B
    };

    static Char _decompositionMapping0001D75C[] = 
    {
        0x00000397
    };

    static _CharacterInfo _character0001D75C =
    {
        0x0001D75C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75C,
        0x0001D75C,
        0x0001D75C
    };

    static Char _decompositionMapping0001D75D[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character0001D75D =
    {
        0x0001D75D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75D,
        0x0001D75D,
        0x0001D75D
    };

    static Char _decompositionMapping0001D75E[] = 
    {
        0x00000399
    };

    static _CharacterInfo _character0001D75E =
    {
        0x0001D75E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75E,
        0x0001D75E,
        0x0001D75E
    };

    static Char _decompositionMapping0001D75F[] = 
    {
        0x0000039A
    };

    static _CharacterInfo _character0001D75F =
    {
        0x0001D75F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D75F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D75F,
        0x0001D75F,
        0x0001D75F
    };

    static Char _decompositionMapping0001D760[] = 
    {
        0x0000039B
    };

    static _CharacterInfo _character0001D760 =
    {
        0x0001D760,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D760,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D760,
        0x0001D760,
        0x0001D760
    };

    static Char _decompositionMapping0001D761[] = 
    {
        0x0000039C
    };

    static _CharacterInfo _character0001D761 =
    {
        0x0001D761,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D761,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D761,
        0x0001D761,
        0x0001D761
    };

    static Char _decompositionMapping0001D762[] = 
    {
        0x0000039D
    };

    static _CharacterInfo _character0001D762 =
    {
        0x0001D762,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D762,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D762,
        0x0001D762,
        0x0001D762
    };

    static Char _decompositionMapping0001D763[] = 
    {
        0x0000039E
    };

    static _CharacterInfo _character0001D763 =
    {
        0x0001D763,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D763,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D763,
        0x0001D763,
        0x0001D763
    };

    static Char _decompositionMapping0001D764[] = 
    {
        0x0000039F
    };

    static _CharacterInfo _character0001D764 =
    {
        0x0001D764,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D764,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D764,
        0x0001D764,
        0x0001D764
    };

    static Char _decompositionMapping0001D765[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0001D765 =
    {
        0x0001D765,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D765,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D765,
        0x0001D765,
        0x0001D765
    };

    static Char _decompositionMapping0001D766[] = 
    {
        0x000003A1
    };

    static _CharacterInfo _character0001D766 =
    {
        0x0001D766,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D766,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D766,
        0x0001D766,
        0x0001D766
    };

    static Char _decompositionMapping0001D767[] = 
    {
        0x000003F4
    };

    static _CharacterInfo _character0001D767 =
    {
        0x0001D767,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D767,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D767,
        0x0001D767,
        0x0001D767
    };

    static Char _decompositionMapping0001D768[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character0001D768 =
    {
        0x0001D768,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D768,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D768,
        0x0001D768,
        0x0001D768
    };

    static Char _decompositionMapping0001D769[] = 
    {
        0x000003A4
    };

    static _CharacterInfo _character0001D769 =
    {
        0x0001D769,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D769,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D769,
        0x0001D769,
        0x0001D769
    };

    static Char _decompositionMapping0001D76A[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character0001D76A =
    {
        0x0001D76A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76A,
        0x0001D76A,
        0x0001D76A
    };

    static Char _decompositionMapping0001D76B[] = 
    {
        0x000003A6
    };

    static _CharacterInfo _character0001D76B =
    {
        0x0001D76B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76B,
        0x0001D76B,
        0x0001D76B
    };

    static Char _decompositionMapping0001D76C[] = 
    {
        0x000003A7
    };

    static _CharacterInfo _character0001D76C =
    {
        0x0001D76C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76C,
        0x0001D76C,
        0x0001D76C
    };

    static Char _decompositionMapping0001D76D[] = 
    {
        0x000003A8
    };

    static _CharacterInfo _character0001D76D =
    {
        0x0001D76D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76D,
        0x0001D76D,
        0x0001D76D
    };

    static Char _decompositionMapping0001D76E[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character0001D76E =
    {
        0x0001D76E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76E,
        0x0001D76E,
        0x0001D76E
    };

    static Char _decompositionMapping0001D76F[] = 
    {
        0x00002207
    };

    static _CharacterInfo _character0001D76F =
    {
        0x0001D76F,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D76F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D76F,
        0x0001D76F,
        0x0001D76F
    };

    static Char _decompositionMapping0001D770[] = 
    {
        0x000003B1
    };

    static _CharacterInfo _character0001D770 =
    {
        0x0001D770,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D770,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D770,
        0x0001D770,
        0x0001D770
    };

    static Char _decompositionMapping0001D771[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character0001D771 =
    {
        0x0001D771,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D771,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D771,
        0x0001D771,
        0x0001D771
    };

    static Char _decompositionMapping0001D772[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0001D772 =
    {
        0x0001D772,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D772,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D772,
        0x0001D772,
        0x0001D772
    };

    static Char _decompositionMapping0001D773[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character0001D773 =
    {
        0x0001D773,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D773,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D773,
        0x0001D773,
        0x0001D773
    };

    static Char _decompositionMapping0001D774[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character0001D774 =
    {
        0x0001D774,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D774,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D774,
        0x0001D774,
        0x0001D774
    };

    static Char _decompositionMapping0001D775[] = 
    {
        0x000003B6
    };

    static _CharacterInfo _character0001D775 =
    {
        0x0001D775,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D775,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D775,
        0x0001D775,
        0x0001D775
    };

    static Char _decompositionMapping0001D776[] = 
    {
        0x000003B7
    };

    static _CharacterInfo _character0001D776 =
    {
        0x0001D776,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D776,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D776,
        0x0001D776,
        0x0001D776
    };

    static Char _decompositionMapping0001D777[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character0001D777 =
    {
        0x0001D777,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D777,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D777,
        0x0001D777,
        0x0001D777
    };

    static Char _decompositionMapping0001D778[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character0001D778 =
    {
        0x0001D778,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D778,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D778,
        0x0001D778,
        0x0001D778
    };

    static Char _decompositionMapping0001D779[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character0001D779 =
    {
        0x0001D779,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D779,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D779,
        0x0001D779,
        0x0001D779
    };

    static Char _decompositionMapping0001D77A[] = 
    {
        0x000003BB
    };

    static _CharacterInfo _character0001D77A =
    {
        0x0001D77A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77A,
        0x0001D77A,
        0x0001D77A
    };

    static Char _decompositionMapping0001D77B[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character0001D77B =
    {
        0x0001D77B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77B,
        0x0001D77B,
        0x0001D77B
    };

    static Char _decompositionMapping0001D77C[] = 
    {
        0x000003BD
    };

    static _CharacterInfo _character0001D77C =
    {
        0x0001D77C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77C,
        0x0001D77C,
        0x0001D77C
    };

    static Char _decompositionMapping0001D77D[] = 
    {
        0x000003BE
    };

    static _CharacterInfo _character0001D77D =
    {
        0x0001D77D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77D,
        0x0001D77D,
        0x0001D77D
    };

    static Char _decompositionMapping0001D77E[] = 
    {
        0x000003BF
    };

    static _CharacterInfo _character0001D77E =
    {
        0x0001D77E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77E,
        0x0001D77E,
        0x0001D77E
    };

    static Char _decompositionMapping0001D77F[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0001D77F =
    {
        0x0001D77F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D77F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D77F,
        0x0001D77F,
        0x0001D77F
    };

    static Char _decompositionMapping0001D780[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character0001D780 =
    {
        0x0001D780,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D780,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D780,
        0x0001D780,
        0x0001D780
    };

    static Char _decompositionMapping0001D781[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character0001D781 =
    {
        0x0001D781,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D781,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D781,
        0x0001D781,
        0x0001D781
    };

    static Char _decompositionMapping0001D782[] = 
    {
        0x000003C3
    };

    static _CharacterInfo _character0001D782 =
    {
        0x0001D782,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D782,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D782,
        0x0001D782,
        0x0001D782
    };

    static Char _decompositionMapping0001D783[] = 
    {
        0x000003C4
    };

    static _CharacterInfo _character0001D783 =
    {
        0x0001D783,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D783,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D783,
        0x0001D783,
        0x0001D783
    };

    static Char _decompositionMapping0001D784[] = 
    {
        0x000003C5
    };

    static _CharacterInfo _character0001D784 =
    {
        0x0001D784,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D784,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D784,
        0x0001D784,
        0x0001D784
    };

    static Char _decompositionMapping0001D785[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character0001D785 =
    {
        0x0001D785,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D785,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D785,
        0x0001D785,
        0x0001D785
    };

    static Char _decompositionMapping0001D786[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character0001D786 =
    {
        0x0001D786,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D786,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D786,
        0x0001D786,
        0x0001D786
    };

    static Char _decompositionMapping0001D787[] = 
    {
        0x000003C8
    };

    static _CharacterInfo _character0001D787 =
    {
        0x0001D787,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D787,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D787,
        0x0001D787,
        0x0001D787
    };

    static Char _decompositionMapping0001D788[] = 
    {
        0x000003C9
    };

    static _CharacterInfo _character0001D788 =
    {
        0x0001D788,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D788,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D788,
        0x0001D788,
        0x0001D788
    };

    static Char _decompositionMapping0001D789[] = 
    {
        0x00002202
    };

    static _CharacterInfo _character0001D789 =
    {
        0x0001D789,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D789,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0001D789,
        0x0001D789,
        0x0001D789
    };

    static Char _decompositionMapping0001D78A[] = 
    {
        0x000003F5
    };

    static _CharacterInfo _character0001D78A =
    {
        0x0001D78A,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78A,
        0x0001D78A,
        0x0001D78A
    };

    static Char _decompositionMapping0001D78B[] = 
    {
        0x000003D1
    };

    static _CharacterInfo _character0001D78B =
    {
        0x0001D78B,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78B,
        0x0001D78B,
        0x0001D78B
    };

    static Char _decompositionMapping0001D78C[] = 
    {
        0x000003F0
    };

    static _CharacterInfo _character0001D78C =
    {
        0x0001D78C,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78C,
        0x0001D78C,
        0x0001D78C
    };

    static Char _decompositionMapping0001D78D[] = 
    {
        0x000003D5
    };

    static _CharacterInfo _character0001D78D =
    {
        0x0001D78D,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78D,
        0x0001D78D,
        0x0001D78D
    };

    static Char _decompositionMapping0001D78E[] = 
    {
        0x000003F1
    };

    static _CharacterInfo _character0001D78E =
    {
        0x0001D78E,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78E,
        0x0001D78E,
        0x0001D78E
    };

    static Char _decompositionMapping0001D78F[] = 
    {
        0x000003D6
    };

    static _CharacterInfo _character0001D78F =
    {
        0x0001D78F,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D78F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D78F,
        0x0001D78F,
        0x0001D78F
    };

    static Char _decompositionMapping0001D790[] = 
    {
        0x00000391
    };

    static _CharacterInfo _character0001D790 =
    {
        0x0001D790,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D790,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D790,
        0x0001D790,
        0x0001D790
    };

    static Char _decompositionMapping0001D791[] = 
    {
        0x00000392
    };

    static _CharacterInfo _character0001D791 =
    {
        0x0001D791,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D791,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D791,
        0x0001D791,
        0x0001D791
    };

    static Char _decompositionMapping0001D792[] = 
    {
        0x00000393
    };

    static _CharacterInfo _character0001D792 =
    {
        0x0001D792,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D792,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D792,
        0x0001D792,
        0x0001D792
    };

    static Char _decompositionMapping0001D793[] = 
    {
        0x00000394
    };

    static _CharacterInfo _character0001D793 =
    {
        0x0001D793,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D793,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D793,
        0x0001D793,
        0x0001D793
    };

    static Char _decompositionMapping0001D794[] = 
    {
        0x00000395
    };

    static _CharacterInfo _character0001D794 =
    {
        0x0001D794,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D794,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D794,
        0x0001D794,
        0x0001D794
    };

    static Char _decompositionMapping0001D795[] = 
    {
        0x00000396
    };

    static _CharacterInfo _character0001D795 =
    {
        0x0001D795,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D795,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D795,
        0x0001D795,
        0x0001D795
    };

    static Char _decompositionMapping0001D796[] = 
    {
        0x00000397
    };

    static _CharacterInfo _character0001D796 =
    {
        0x0001D796,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D796,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D796,
        0x0001D796,
        0x0001D796
    };

    static Char _decompositionMapping0001D797[] = 
    {
        0x00000398
    };

    static _CharacterInfo _character0001D797 =
    {
        0x0001D797,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D797,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D797,
        0x0001D797,
        0x0001D797
    };

    static Char _decompositionMapping0001D798[] = 
    {
        0x00000399
    };

    static _CharacterInfo _character0001D798 =
    {
        0x0001D798,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D798,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D798,
        0x0001D798,
        0x0001D798
    };

    static Char _decompositionMapping0001D799[] = 
    {
        0x0000039A
    };

    static _CharacterInfo _character0001D799 =
    {
        0x0001D799,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D799,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D799,
        0x0001D799,
        0x0001D799
    };

    static Char _decompositionMapping0001D79A[] = 
    {
        0x0000039B
    };

    static _CharacterInfo _character0001D79A =
    {
        0x0001D79A,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79A,
        0x0001D79A,
        0x0001D79A
    };

    static Char _decompositionMapping0001D79B[] = 
    {
        0x0000039C
    };

    static _CharacterInfo _character0001D79B =
    {
        0x0001D79B,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79B,
        0x0001D79B,
        0x0001D79B
    };

    static Char _decompositionMapping0001D79C[] = 
    {
        0x0000039D
    };

    static _CharacterInfo _character0001D79C =
    {
        0x0001D79C,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79C,
        0x0001D79C,
        0x0001D79C
    };

    static Char _decompositionMapping0001D79D[] = 
    {
        0x0000039E
    };

    static _CharacterInfo _character0001D79D =
    {
        0x0001D79D,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79D,
        0x0001D79D,
        0x0001D79D
    };

    static Char _decompositionMapping0001D79E[] = 
    {
        0x0000039F
    };

    static _CharacterInfo _character0001D79E =
    {
        0x0001D79E,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79E,
        0x0001D79E,
        0x0001D79E
    };

    static Char _decompositionMapping0001D79F[] = 
    {
        0x000003A0
    };

    static _CharacterInfo _character0001D79F =
    {
        0x0001D79F,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D79F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D79F,
        0x0001D79F,
        0x0001D79F
    };

    static Char _decompositionMapping0001D7A0[] = 
    {
        0x000003A1
    };

    static _CharacterInfo _character0001D7A0 =
    {
        0x0001D7A0,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A0,
        0x0001D7A0,
        0x0001D7A0
    };

    static Char _decompositionMapping0001D7A1[] = 
    {
        0x000003F4
    };

    static _CharacterInfo _character0001D7A1 =
    {
        0x0001D7A1,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A1,
        0x0001D7A1,
        0x0001D7A1
    };

    static Char _decompositionMapping0001D7A2[] = 
    {
        0x000003A3
    };

    static _CharacterInfo _character0001D7A2 =
    {
        0x0001D7A2,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A2,
        0x0001D7A2,
        0x0001D7A2
    };

    static Char _decompositionMapping0001D7A3[] = 
    {
        0x000003A4
    };

    static _CharacterInfo _character0001D7A3 =
    {
        0x0001D7A3,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A3,
        0x0001D7A3,
        0x0001D7A3
    };

    static Char _decompositionMapping0001D7A4[] = 
    {
        0x000003A5
    };

    static _CharacterInfo _character0001D7A4 =
    {
        0x0001D7A4,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A4,
        0x0001D7A4,
        0x0001D7A4
    };

    static Char _decompositionMapping0001D7A5[] = 
    {
        0x000003A6
    };

    static _CharacterInfo _character0001D7A5 =
    {
        0x0001D7A5,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A5,
        0x0001D7A5,
        0x0001D7A5
    };

    static Char _decompositionMapping0001D7A6[] = 
    {
        0x000003A7
    };

    static _CharacterInfo _character0001D7A6 =
    {
        0x0001D7A6,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A6,
        0x0001D7A6,
        0x0001D7A6
    };

    static Char _decompositionMapping0001D7A7[] = 
    {
        0x000003A8
    };

    static _CharacterInfo _character0001D7A7 =
    {
        0x0001D7A7,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A7,
        0x0001D7A7,
        0x0001D7A7
    };

    static Char _decompositionMapping0001D7A8[] = 
    {
        0x000003A9
    };

    static _CharacterInfo _character0001D7A8 =
    {
        0x0001D7A8,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A8,
        0x0001D7A8,
        0x0001D7A8
    };

    static Char _decompositionMapping0001D7A9[] = 
    {
        0x00002207
    };

    static _CharacterInfo _character0001D7A9 =
    {
        0x0001D7A9,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7A9,
        0x0001D7A9,
        0x0001D7A9
    };

    static Char _decompositionMapping0001D7AA[] = 
    {
        0x000003B1
    };

    static _CharacterInfo _character0001D7AA =
    {
        0x0001D7AA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AA,
        0x0001D7AA,
        0x0001D7AA
    };

    static Char _decompositionMapping0001D7AB[] = 
    {
        0x000003B2
    };

    static _CharacterInfo _character0001D7AB =
    {
        0x0001D7AB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AB,
        0x0001D7AB,
        0x0001D7AB
    };

    static Char _decompositionMapping0001D7AC[] = 
    {
        0x000003B3
    };

    static _CharacterInfo _character0001D7AC =
    {
        0x0001D7AC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AC,
        0x0001D7AC,
        0x0001D7AC
    };

    static Char _decompositionMapping0001D7AD[] = 
    {
        0x000003B4
    };

    static _CharacterInfo _character0001D7AD =
    {
        0x0001D7AD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AD,
        0x0001D7AD,
        0x0001D7AD
    };

    static Char _decompositionMapping0001D7AE[] = 
    {
        0x000003B5
    };

    static _CharacterInfo _character0001D7AE =
    {
        0x0001D7AE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AE,
        0x0001D7AE,
        0x0001D7AE
    };

    static Char _decompositionMapping0001D7AF[] = 
    {
        0x000003B6
    };

    static _CharacterInfo _character0001D7AF =
    {
        0x0001D7AF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7AF,
        0x0001D7AF,
        0x0001D7AF
    };

    static Char _decompositionMapping0001D7B0[] = 
    {
        0x000003B7
    };

    static _CharacterInfo _character0001D7B0 =
    {
        0x0001D7B0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B0,
        0x0001D7B0,
        0x0001D7B0
    };

    static Char _decompositionMapping0001D7B1[] = 
    {
        0x000003B8
    };

    static _CharacterInfo _character0001D7B1 =
    {
        0x0001D7B1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B1,
        0x0001D7B1,
        0x0001D7B1
    };

    static Char _decompositionMapping0001D7B2[] = 
    {
        0x000003B9
    };

    static _CharacterInfo _character0001D7B2 =
    {
        0x0001D7B2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B2,
        0x0001D7B2,
        0x0001D7B2
    };

    static Char _decompositionMapping0001D7B3[] = 
    {
        0x000003BA
    };

    static _CharacterInfo _character0001D7B3 =
    {
        0x0001D7B3,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B3,
        0x0001D7B3,
        0x0001D7B3
    };

    static Char _decompositionMapping0001D7B4[] = 
    {
        0x000003BB
    };

    static _CharacterInfo _character0001D7B4 =
    {
        0x0001D7B4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B4,
        0x0001D7B4,
        0x0001D7B4
    };

    static Char _decompositionMapping0001D7B5[] = 
    {
        0x000003BC
    };

    static _CharacterInfo _character0001D7B5 =
    {
        0x0001D7B5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B5,
        0x0001D7B5,
        0x0001D7B5
    };

    static Char _decompositionMapping0001D7B6[] = 
    {
        0x000003BD
    };

    static _CharacterInfo _character0001D7B6 =
    {
        0x0001D7B6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B6,
        0x0001D7B6,
        0x0001D7B6
    };

    static Char _decompositionMapping0001D7B7[] = 
    {
        0x000003BE
    };

    static _CharacterInfo _character0001D7B7 =
    {
        0x0001D7B7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B7,
        0x0001D7B7,
        0x0001D7B7
    };

    static Char _decompositionMapping0001D7B8[] = 
    {
        0x000003BF
    };

    static _CharacterInfo _character0001D7B8 =
    {
        0x0001D7B8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B8,
        0x0001D7B8,
        0x0001D7B8
    };

    static Char _decompositionMapping0001D7B9[] = 
    {
        0x000003C0
    };

    static _CharacterInfo _character0001D7B9 =
    {
        0x0001D7B9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7B9,
        0x0001D7B9,
        0x0001D7B9
    };

    static Char _decompositionMapping0001D7BA[] = 
    {
        0x000003C1
    };

    static _CharacterInfo _character0001D7BA =
    {
        0x0001D7BA,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BA,
        0x0001D7BA,
        0x0001D7BA
    };

    static Char _decompositionMapping0001D7BB[] = 
    {
        0x000003C2
    };

    static _CharacterInfo _character0001D7BB =
    {
        0x0001D7BB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BB,
        0x0001D7BB,
        0x0001D7BB
    };

    static Char _decompositionMapping0001D7BC[] = 
    {
        0x000003C3
    };

    static _CharacterInfo _character0001D7BC =
    {
        0x0001D7BC,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BC,
        0x0001D7BC,
        0x0001D7BC
    };

    static Char _decompositionMapping0001D7BD[] = 
    {
        0x000003C4
    };

    static _CharacterInfo _character0001D7BD =
    {
        0x0001D7BD,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BD,
        0x0001D7BD,
        0x0001D7BD
    };

    static Char _decompositionMapping0001D7BE[] = 
    {
        0x000003C5
    };

    static _CharacterInfo _character0001D7BE =
    {
        0x0001D7BE,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BE,
        0x0001D7BE,
        0x0001D7BE
    };

    static Char _decompositionMapping0001D7BF[] = 
    {
        0x000003C6
    };

    static _CharacterInfo _character0001D7BF =
    {
        0x0001D7BF,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7BF,
        0x0001D7BF,
        0x0001D7BF
    };

    static Char _decompositionMapping0001D7C0[] = 
    {
        0x000003C7
    };

    static _CharacterInfo _character0001D7C0 =
    {
        0x0001D7C0,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C0,
        0x0001D7C0,
        0x0001D7C0
    };

    static Char _decompositionMapping0001D7C1[] = 
    {
        0x000003C8
    };

    static _CharacterInfo _character0001D7C1 =
    {
        0x0001D7C1,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C1,
        0x0001D7C1,
        0x0001D7C1
    };

    static Char _decompositionMapping0001D7C2[] = 
    {
        0x000003C9
    };

    static _CharacterInfo _character0001D7C2 =
    {
        0x0001D7C2,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C2,
        0x0001D7C2,
        0x0001D7C2
    };

    static Char _decompositionMapping0001D7C3[] = 
    {
        0x00002202
    };

    static _CharacterInfo _character0001D7C3 =
    {
        0x0001D7C3,
        Iso10646::GeneralCategory_Sm,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        true,
        0x0001D7C3,
        0x0001D7C3,
        0x0001D7C3
    };

    static Char _decompositionMapping0001D7C4[] = 
    {
        0x000003F5
    };

    static _CharacterInfo _character0001D7C4 =
    {
        0x0001D7C4,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C4,
        0x0001D7C4,
        0x0001D7C4
    };

    static Char _decompositionMapping0001D7C5[] = 
    {
        0x000003D1
    };

    static _CharacterInfo _character0001D7C5 =
    {
        0x0001D7C5,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C5,
        0x0001D7C5,
        0x0001D7C5
    };

    static Char _decompositionMapping0001D7C6[] = 
    {
        0x000003F0
    };

    static _CharacterInfo _character0001D7C6 =
    {
        0x0001D7C6,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C6,
        0x0001D7C6,
        0x0001D7C6
    };

    static Char _decompositionMapping0001D7C7[] = 
    {
        0x000003D5
    };

    static _CharacterInfo _character0001D7C7 =
    {
        0x0001D7C7,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C7,
        0x0001D7C7,
        0x0001D7C7
    };

    static Char _decompositionMapping0001D7C8[] = 
    {
        0x000003F1
    };

    static _CharacterInfo _character0001D7C8 =
    {
        0x0001D7C8,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C8,
        0x0001D7C8,
        0x0001D7C8
    };

    static Char _decompositionMapping0001D7C9[] = 
    {
        0x000003D6
    };

    static _CharacterInfo _character0001D7C9 =
    {
        0x0001D7C9,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7C9,
        0x0001D7C9,
        0x0001D7C9
    };

    static Char _decompositionMapping0001D7CA[] = 
    {
        0x000003DC
    };

    static _CharacterInfo _character0001D7CA =
    {
        0x0001D7CA,
        Iso10646::GeneralCategory_Lu,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7CA,
        0x0001D7CA,
        0x0001D7CA
    };

    static Char _decompositionMapping0001D7CB[] = 
    {
        0x000003DD
    };

    static _CharacterInfo _character0001D7CB =
    {
        0x0001D7CB,
        Iso10646::GeneralCategory_Ll,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0001D7CB,
        0x0001D7CB,
        0x0001D7CB
    };

    static Char _decompositionMapping0001D7CE[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0001D7CE =
    {
        0x0001D7CE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7CE,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0001D7CE,
        0x0001D7CE,
        0x0001D7CE
    };

    static Char _decompositionMapping0001D7CF[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0001D7CF =
    {
        0x0001D7CF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7CF,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0001D7CF,
        0x0001D7CF,
        0x0001D7CF
    };

    static Char _decompositionMapping0001D7D0[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0001D7D0 =
    {
        0x0001D7D0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D0,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0001D7D0,
        0x0001D7D0,
        0x0001D7D0
    };

    static Char _decompositionMapping0001D7D1[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0001D7D1 =
    {
        0x0001D7D1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D1,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0001D7D1,
        0x0001D7D1,
        0x0001D7D1
    };

    static Char _decompositionMapping0001D7D2[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0001D7D2 =
    {
        0x0001D7D2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D2,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0001D7D2,
        0x0001D7D2,
        0x0001D7D2
    };

    static Char _decompositionMapping0001D7D3[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0001D7D3 =
    {
        0x0001D7D3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D3,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0001D7D3,
        0x0001D7D3,
        0x0001D7D3
    };

    static Char _decompositionMapping0001D7D4[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0001D7D4 =
    {
        0x0001D7D4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D4,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0001D7D4,
        0x0001D7D4,
        0x0001D7D4
    };

    static Char _decompositionMapping0001D7D5[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0001D7D5 =
    {
        0x0001D7D5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D5,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0001D7D5,
        0x0001D7D5,
        0x0001D7D5
    };

    static Char _decompositionMapping0001D7D6[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0001D7D6 =
    {
        0x0001D7D6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D6,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0001D7D6,
        0x0001D7D6,
        0x0001D7D6
    };

    static Char _decompositionMapping0001D7D7[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0001D7D7 =
    {
        0x0001D7D7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D7,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0001D7D7,
        0x0001D7D7,
        0x0001D7D7
    };

    static Char _decompositionMapping0001D7D8[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0001D7D8 =
    {
        0x0001D7D8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D8,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0001D7D8,
        0x0001D7D8,
        0x0001D7D8
    };

    static Char _decompositionMapping0001D7D9[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0001D7D9 =
    {
        0x0001D7D9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7D9,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0001D7D9,
        0x0001D7D9,
        0x0001D7D9
    };

    static Char _decompositionMapping0001D7DA[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0001D7DA =
    {
        0x0001D7DA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DA,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0001D7DA,
        0x0001D7DA,
        0x0001D7DA
    };

    static Char _decompositionMapping0001D7DB[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0001D7DB =
    {
        0x0001D7DB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DB,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0001D7DB,
        0x0001D7DB,
        0x0001D7DB
    };

    static Char _decompositionMapping0001D7DC[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0001D7DC =
    {
        0x0001D7DC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DC,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0001D7DC,
        0x0001D7DC,
        0x0001D7DC
    };

    static Char _decompositionMapping0001D7DD[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0001D7DD =
    {
        0x0001D7DD,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DD,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0001D7DD,
        0x0001D7DD,
        0x0001D7DD
    };

    static Char _decompositionMapping0001D7DE[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0001D7DE =
    {
        0x0001D7DE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DE,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0001D7DE,
        0x0001D7DE,
        0x0001D7DE
    };

    static Char _decompositionMapping0001D7DF[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0001D7DF =
    {
        0x0001D7DF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7DF,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0001D7DF,
        0x0001D7DF,
        0x0001D7DF
    };

    static Char _decompositionMapping0001D7E0[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0001D7E0 =
    {
        0x0001D7E0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E0,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0001D7E0,
        0x0001D7E0,
        0x0001D7E0
    };

    static Char _decompositionMapping0001D7E1[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0001D7E1 =
    {
        0x0001D7E1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E1,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0001D7E1,
        0x0001D7E1,
        0x0001D7E1
    };

    static Char _decompositionMapping0001D7E2[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0001D7E2 =
    {
        0x0001D7E2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E2,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0001D7E2,
        0x0001D7E2,
        0x0001D7E2
    };

    static Char _decompositionMapping0001D7E3[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0001D7E3 =
    {
        0x0001D7E3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E3,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0001D7E3,
        0x0001D7E3,
        0x0001D7E3
    };

    static Char _decompositionMapping0001D7E4[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0001D7E4 =
    {
        0x0001D7E4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E4,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0001D7E4,
        0x0001D7E4,
        0x0001D7E4
    };

    static Char _decompositionMapping0001D7E5[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0001D7E5 =
    {
        0x0001D7E5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E5,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0001D7E5,
        0x0001D7E5,
        0x0001D7E5
    };

    static Char _decompositionMapping0001D7E6[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0001D7E6 =
    {
        0x0001D7E6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E6,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0001D7E6,
        0x0001D7E6,
        0x0001D7E6
    };

    static Char _decompositionMapping0001D7E7[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0001D7E7 =
    {
        0x0001D7E7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E7,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0001D7E7,
        0x0001D7E7,
        0x0001D7E7
    };

    static Char _decompositionMapping0001D7E8[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0001D7E8 =
    {
        0x0001D7E8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E8,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0001D7E8,
        0x0001D7E8,
        0x0001D7E8
    };

    static Char _decompositionMapping0001D7E9[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0001D7E9 =
    {
        0x0001D7E9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7E9,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0001D7E9,
        0x0001D7E9,
        0x0001D7E9
    };

    static Char _decompositionMapping0001D7EA[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0001D7EA =
    {
        0x0001D7EA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7EA,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0001D7EA,
        0x0001D7EA,
        0x0001D7EA
    };

    static Char _decompositionMapping0001D7EB[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0001D7EB =
    {
        0x0001D7EB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7EB,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0001D7EB,
        0x0001D7EB,
        0x0001D7EB
    };

    static Char _decompositionMapping0001D7EC[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0001D7EC =
    {
        0x0001D7EC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7EC,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0001D7EC,
        0x0001D7EC,
        0x0001D7EC
    };

    static Char _decompositionMapping0001D7ED[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0001D7ED =
    {
        0x0001D7ED,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7ED,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0001D7ED,
        0x0001D7ED,
        0x0001D7ED
    };

    static Char _decompositionMapping0001D7EE[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0001D7EE =
    {
        0x0001D7EE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7EE,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0001D7EE,
        0x0001D7EE,
        0x0001D7EE
    };

    static Char _decompositionMapping0001D7EF[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0001D7EF =
    {
        0x0001D7EF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7EF,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0001D7EF,
        0x0001D7EF,
        0x0001D7EF
    };

    static Char _decompositionMapping0001D7F0[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0001D7F0 =
    {
        0x0001D7F0,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F0,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0001D7F0,
        0x0001D7F0,
        0x0001D7F0
    };

    static Char _decompositionMapping0001D7F1[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0001D7F1 =
    {
        0x0001D7F1,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F1,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0001D7F1,
        0x0001D7F1,
        0x0001D7F1
    };

    static Char _decompositionMapping0001D7F2[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0001D7F2 =
    {
        0x0001D7F2,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F2,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0001D7F2,
        0x0001D7F2,
        0x0001D7F2
    };

    static Char _decompositionMapping0001D7F3[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0001D7F3 =
    {
        0x0001D7F3,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F3,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0001D7F3,
        0x0001D7F3,
        0x0001D7F3
    };

    static Char _decompositionMapping0001D7F4[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0001D7F4 =
    {
        0x0001D7F4,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F4,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0001D7F4,
        0x0001D7F4,
        0x0001D7F4
    };

    static Char _decompositionMapping0001D7F5[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0001D7F5 =
    {
        0x0001D7F5,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F5,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0001D7F5,
        0x0001D7F5,
        0x0001D7F5
    };

    static Char _decompositionMapping0001D7F6[] = 
    {
        0x00000030
    };

    static _CharacterInfo _character0001D7F6 =
    {
        0x0001D7F6,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F6,
        true,
        0,
        true,
        0,
        true,
        0,
        1,
        false,
        0x0001D7F6,
        0x0001D7F6,
        0x0001D7F6
    };

    static Char _decompositionMapping0001D7F7[] = 
    {
        0x00000031
    };

    static _CharacterInfo _character0001D7F7 =
    {
        0x0001D7F7,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F7,
        true,
        1,
        true,
        1,
        true,
        1,
        1,
        false,
        0x0001D7F7,
        0x0001D7F7,
        0x0001D7F7
    };

    static Char _decompositionMapping0001D7F8[] = 
    {
        0x00000032
    };

    static _CharacterInfo _character0001D7F8 =
    {
        0x0001D7F8,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F8,
        true,
        2,
        true,
        2,
        true,
        2,
        1,
        false,
        0x0001D7F8,
        0x0001D7F8,
        0x0001D7F8
    };

    static Char _decompositionMapping0001D7F9[] = 
    {
        0x00000033
    };

    static _CharacterInfo _character0001D7F9 =
    {
        0x0001D7F9,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7F9,
        true,
        3,
        true,
        3,
        true,
        3,
        1,
        false,
        0x0001D7F9,
        0x0001D7F9,
        0x0001D7F9
    };

    static Char _decompositionMapping0001D7FA[] = 
    {
        0x00000034
    };

    static _CharacterInfo _character0001D7FA =
    {
        0x0001D7FA,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FA,
        true,
        4,
        true,
        4,
        true,
        4,
        1,
        false,
        0x0001D7FA,
        0x0001D7FA,
        0x0001D7FA
    };

    static Char _decompositionMapping0001D7FB[] = 
    {
        0x00000035
    };

    static _CharacterInfo _character0001D7FB =
    {
        0x0001D7FB,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FB,
        true,
        5,
        true,
        5,
        true,
        5,
        1,
        false,
        0x0001D7FB,
        0x0001D7FB,
        0x0001D7FB
    };

    static Char _decompositionMapping0001D7FC[] = 
    {
        0x00000036
    };

    static _CharacterInfo _character0001D7FC =
    {
        0x0001D7FC,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FC,
        true,
        6,
        true,
        6,
        true,
        6,
        1,
        false,
        0x0001D7FC,
        0x0001D7FC,
        0x0001D7FC
    };

    static Char _decompositionMapping0001D7FD[] = 
    {
        0x00000037
    };

    static _CharacterInfo _character0001D7FD =
    {
        0x0001D7FD,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FD,
        true,
        7,
        true,
        7,
        true,
        7,
        1,
        false,
        0x0001D7FD,
        0x0001D7FD,
        0x0001D7FD
    };

    static Char _decompositionMapping0001D7FE[] = 
    {
        0x00000038
    };

    static _CharacterInfo _character0001D7FE =
    {
        0x0001D7FE,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FE,
        true,
        8,
        true,
        8,
        true,
        8,
        1,
        false,
        0x0001D7FE,
        0x0001D7FE,
        0x0001D7FE
    };

    static Char _decompositionMapping0001D7FF[] = 
    {
        0x00000039
    };

    static _CharacterInfo _character0001D7FF =
    {
        0x0001D7FF,
        Iso10646::GeneralCategory_Nd,
        0,
        Iso10646::BidirectionalCategory_EN,
        Iso10646::DecompositionMappingTag_font,
        1,
        _decompositionMapping0001D7FF,
        true,
        9,
        true,
        9,
        true,
        9,
        1,
        false,
        0x0001D7FF,
        0x0001D7FF,
        0x0001D7FF
    };

    static _CharacterInfo _character00020000 =
    {
        0x00020000,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00020000,
        0x00020000,
        0x00020000
    };

    static _CharacterInfo _character0002A6D6 =
    {
        0x0002A6D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002A6D6,
        0x0002A6D6,
        0x0002A6D6
    };

    static Char _decompositionMapping0002F800[] = 
    {
        0x00004E3D
    };

    static _CharacterInfo _character0002F800 =
    {
        0x0002F800,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F800,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F800,
        0x0002F800,
        0x0002F800
    };

    static Char _decompositionMapping0002F801[] = 
    {
        0x00004E38
    };

    static _CharacterInfo _character0002F801 =
    {
        0x0002F801,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F801,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F801,
        0x0002F801,
        0x0002F801
    };

    static Char _decompositionMapping0002F802[] = 
    {
        0x00004E41
    };

    static _CharacterInfo _character0002F802 =
    {
        0x0002F802,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F802,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F802,
        0x0002F802,
        0x0002F802
    };

    static Char _decompositionMapping0002F803[] = 
    {
        0x00020122
    };

    static _CharacterInfo _character0002F803 =
    {
        0x0002F803,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F803,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F803,
        0x0002F803,
        0x0002F803
    };

    static Char _decompositionMapping0002F804[] = 
    {
        0x00004F60
    };

    static _CharacterInfo _character0002F804 =
    {
        0x0002F804,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F804,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F804,
        0x0002F804,
        0x0002F804
    };

    static Char _decompositionMapping0002F805[] = 
    {
        0x00004FAE
    };

    static _CharacterInfo _character0002F805 =
    {
        0x0002F805,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F805,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F805,
        0x0002F805,
        0x0002F805
    };

    static Char _decompositionMapping0002F806[] = 
    {
        0x00004FBB
    };

    static _CharacterInfo _character0002F806 =
    {
        0x0002F806,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F806,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F806,
        0x0002F806,
        0x0002F806
    };

    static Char _decompositionMapping0002F807[] = 
    {
        0x00005002
    };

    static _CharacterInfo _character0002F807 =
    {
        0x0002F807,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F807,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F807,
        0x0002F807,
        0x0002F807
    };

    static Char _decompositionMapping0002F808[] = 
    {
        0x0000507A
    };

    static _CharacterInfo _character0002F808 =
    {
        0x0002F808,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F808,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F808,
        0x0002F808,
        0x0002F808
    };

    static Char _decompositionMapping0002F809[] = 
    {
        0x00005099
    };

    static _CharacterInfo _character0002F809 =
    {
        0x0002F809,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F809,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F809,
        0x0002F809,
        0x0002F809
    };

    static Char _decompositionMapping0002F80A[] = 
    {
        0x000050E7
    };

    static _CharacterInfo _character0002F80A =
    {
        0x0002F80A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80A,
        0x0002F80A,
        0x0002F80A
    };

    static Char _decompositionMapping0002F80B[] = 
    {
        0x000050CF
    };

    static _CharacterInfo _character0002F80B =
    {
        0x0002F80B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80B,
        0x0002F80B,
        0x0002F80B
    };

    static Char _decompositionMapping0002F80C[] = 
    {
        0x0000349E
    };

    static _CharacterInfo _character0002F80C =
    {
        0x0002F80C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80C,
        0x0002F80C,
        0x0002F80C
    };

    static Char _decompositionMapping0002F80D[] = 
    {
        0x0002063A
    };

    static _CharacterInfo _character0002F80D =
    {
        0x0002F80D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80D,
        0x0002F80D,
        0x0002F80D
    };

    static Char _decompositionMapping0002F80E[] = 
    {
        0x0000514D
    };

    static _CharacterInfo _character0002F80E =
    {
        0x0002F80E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80E,
        0x0002F80E,
        0x0002F80E
    };

    static Char _decompositionMapping0002F80F[] = 
    {
        0x00005154
    };

    static _CharacterInfo _character0002F80F =
    {
        0x0002F80F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F80F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F80F,
        0x0002F80F,
        0x0002F80F
    };

    static Char _decompositionMapping0002F810[] = 
    {
        0x00005164
    };

    static _CharacterInfo _character0002F810 =
    {
        0x0002F810,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F810,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F810,
        0x0002F810,
        0x0002F810
    };

    static Char _decompositionMapping0002F811[] = 
    {
        0x00005177
    };

    static _CharacterInfo _character0002F811 =
    {
        0x0002F811,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F811,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F811,
        0x0002F811,
        0x0002F811
    };

    static Char _decompositionMapping0002F812[] = 
    {
        0x0002051C
    };

    static _CharacterInfo _character0002F812 =
    {
        0x0002F812,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F812,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F812,
        0x0002F812,
        0x0002F812
    };

    static Char _decompositionMapping0002F813[] = 
    {
        0x000034B9
    };

    static _CharacterInfo _character0002F813 =
    {
        0x0002F813,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F813,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F813,
        0x0002F813,
        0x0002F813
    };

    static Char _decompositionMapping0002F814[] = 
    {
        0x00005167
    };

    static _CharacterInfo _character0002F814 =
    {
        0x0002F814,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F814,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F814,
        0x0002F814,
        0x0002F814
    };

    static Char _decompositionMapping0002F815[] = 
    {
        0x0000518D
    };

    static _CharacterInfo _character0002F815 =
    {
        0x0002F815,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F815,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F815,
        0x0002F815,
        0x0002F815
    };

    static Char _decompositionMapping0002F816[] = 
    {
        0x0002054B
    };

    static _CharacterInfo _character0002F816 =
    {
        0x0002F816,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F816,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F816,
        0x0002F816,
        0x0002F816
    };

    static Char _decompositionMapping0002F817[] = 
    {
        0x00005197
    };

    static _CharacterInfo _character0002F817 =
    {
        0x0002F817,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F817,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F817,
        0x0002F817,
        0x0002F817
    };

    static Char _decompositionMapping0002F818[] = 
    {
        0x000051A4
    };

    static _CharacterInfo _character0002F818 =
    {
        0x0002F818,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F818,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F818,
        0x0002F818,
        0x0002F818
    };

    static Char _decompositionMapping0002F819[] = 
    {
        0x00004ECC
    };

    static _CharacterInfo _character0002F819 =
    {
        0x0002F819,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F819,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F819,
        0x0002F819,
        0x0002F819
    };

    static Char _decompositionMapping0002F81A[] = 
    {
        0x000051AC
    };

    static _CharacterInfo _character0002F81A =
    {
        0x0002F81A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81A,
        0x0002F81A,
        0x0002F81A
    };

    static Char _decompositionMapping0002F81B[] = 
    {
        0x000051B5
    };

    static _CharacterInfo _character0002F81B =
    {
        0x0002F81B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81B,
        0x0002F81B,
        0x0002F81B
    };

    static Char _decompositionMapping0002F81C[] = 
    {
        0x000291DF
    };

    static _CharacterInfo _character0002F81C =
    {
        0x0002F81C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81C,
        0x0002F81C,
        0x0002F81C
    };

    static Char _decompositionMapping0002F81D[] = 
    {
        0x000051F5
    };

    static _CharacterInfo _character0002F81D =
    {
        0x0002F81D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81D,
        0x0002F81D,
        0x0002F81D
    };

    static Char _decompositionMapping0002F81E[] = 
    {
        0x00005203
    };

    static _CharacterInfo _character0002F81E =
    {
        0x0002F81E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81E,
        0x0002F81E,
        0x0002F81E
    };

    static Char _decompositionMapping0002F81F[] = 
    {
        0x000034DF
    };

    static _CharacterInfo _character0002F81F =
    {
        0x0002F81F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F81F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F81F,
        0x0002F81F,
        0x0002F81F
    };

    static Char _decompositionMapping0002F820[] = 
    {
        0x0000523B
    };

    static _CharacterInfo _character0002F820 =
    {
        0x0002F820,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F820,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F820,
        0x0002F820,
        0x0002F820
    };

    static Char _decompositionMapping0002F821[] = 
    {
        0x00005246
    };

    static _CharacterInfo _character0002F821 =
    {
        0x0002F821,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F821,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F821,
        0x0002F821,
        0x0002F821
    };

    static Char _decompositionMapping0002F822[] = 
    {
        0x00005272
    };

    static _CharacterInfo _character0002F822 =
    {
        0x0002F822,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F822,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F822,
        0x0002F822,
        0x0002F822
    };

    static Char _decompositionMapping0002F823[] = 
    {
        0x00005277
    };

    static _CharacterInfo _character0002F823 =
    {
        0x0002F823,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F823,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F823,
        0x0002F823,
        0x0002F823
    };

    static Char _decompositionMapping0002F824[] = 
    {
        0x00003515
    };

    static _CharacterInfo _character0002F824 =
    {
        0x0002F824,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F824,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F824,
        0x0002F824,
        0x0002F824
    };

    static Char _decompositionMapping0002F825[] = 
    {
        0x000052C7
    };

    static _CharacterInfo _character0002F825 =
    {
        0x0002F825,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F825,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F825,
        0x0002F825,
        0x0002F825
    };

    static Char _decompositionMapping0002F826[] = 
    {
        0x000052C9
    };

    static _CharacterInfo _character0002F826 =
    {
        0x0002F826,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F826,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F826,
        0x0002F826,
        0x0002F826
    };

    static Char _decompositionMapping0002F827[] = 
    {
        0x000052E4
    };

    static _CharacterInfo _character0002F827 =
    {
        0x0002F827,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F827,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F827,
        0x0002F827,
        0x0002F827
    };

    static Char _decompositionMapping0002F828[] = 
    {
        0x000052FA
    };

    static _CharacterInfo _character0002F828 =
    {
        0x0002F828,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F828,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F828,
        0x0002F828,
        0x0002F828
    };

    static Char _decompositionMapping0002F829[] = 
    {
        0x00005305
    };

    static _CharacterInfo _character0002F829 =
    {
        0x0002F829,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F829,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F829,
        0x0002F829,
        0x0002F829
    };

    static Char _decompositionMapping0002F82A[] = 
    {
        0x00005306
    };

    static _CharacterInfo _character0002F82A =
    {
        0x0002F82A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82A,
        0x0002F82A,
        0x0002F82A
    };

    static Char _decompositionMapping0002F82B[] = 
    {
        0x00005317
    };

    static _CharacterInfo _character0002F82B =
    {
        0x0002F82B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82B,
        0x0002F82B,
        0x0002F82B
    };

    static Char _decompositionMapping0002F82C[] = 
    {
        0x00005349
    };

    static _CharacterInfo _character0002F82C =
    {
        0x0002F82C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82C,
        0x0002F82C,
        0x0002F82C
    };

    static Char _decompositionMapping0002F82D[] = 
    {
        0x00005351
    };

    static _CharacterInfo _character0002F82D =
    {
        0x0002F82D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82D,
        0x0002F82D,
        0x0002F82D
    };

    static Char _decompositionMapping0002F82E[] = 
    {
        0x0000535A
    };

    static _CharacterInfo _character0002F82E =
    {
        0x0002F82E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82E,
        0x0002F82E,
        0x0002F82E
    };

    static Char _decompositionMapping0002F82F[] = 
    {
        0x00005373
    };

    static _CharacterInfo _character0002F82F =
    {
        0x0002F82F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F82F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F82F,
        0x0002F82F,
        0x0002F82F
    };

    static Char _decompositionMapping0002F830[] = 
    {
        0x0000537D
    };

    static _CharacterInfo _character0002F830 =
    {
        0x0002F830,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F830,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F830,
        0x0002F830,
        0x0002F830
    };

    static Char _decompositionMapping0002F831[] = 
    {
        0x0000537F
    };

    static _CharacterInfo _character0002F831 =
    {
        0x0002F831,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F831,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F831,
        0x0002F831,
        0x0002F831
    };

    static Char _decompositionMapping0002F832[] = 
    {
        0x0000537F
    };

    static _CharacterInfo _character0002F832 =
    {
        0x0002F832,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F832,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F832,
        0x0002F832,
        0x0002F832
    };

    static Char _decompositionMapping0002F833[] = 
    {
        0x0000537F
    };

    static _CharacterInfo _character0002F833 =
    {
        0x0002F833,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F833,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F833,
        0x0002F833,
        0x0002F833
    };

    static Char _decompositionMapping0002F834[] = 
    {
        0x00020A2C
    };

    static _CharacterInfo _character0002F834 =
    {
        0x0002F834,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F834,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F834,
        0x0002F834,
        0x0002F834
    };

    static Char _decompositionMapping0002F835[] = 
    {
        0x00007070
    };

    static _CharacterInfo _character0002F835 =
    {
        0x0002F835,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F835,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F835,
        0x0002F835,
        0x0002F835
    };

    static Char _decompositionMapping0002F836[] = 
    {
        0x000053CA
    };

    static _CharacterInfo _character0002F836 =
    {
        0x0002F836,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F836,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F836,
        0x0002F836,
        0x0002F836
    };

    static Char _decompositionMapping0002F837[] = 
    {
        0x000053DF
    };

    static _CharacterInfo _character0002F837 =
    {
        0x0002F837,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F837,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F837,
        0x0002F837,
        0x0002F837
    };

    static Char _decompositionMapping0002F838[] = 
    {
        0x00020B63
    };

    static _CharacterInfo _character0002F838 =
    {
        0x0002F838,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F838,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F838,
        0x0002F838,
        0x0002F838
    };

    static Char _decompositionMapping0002F839[] = 
    {
        0x000053EB
    };

    static _CharacterInfo _character0002F839 =
    {
        0x0002F839,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F839,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F839,
        0x0002F839,
        0x0002F839
    };

    static Char _decompositionMapping0002F83A[] = 
    {
        0x000053F1
    };

    static _CharacterInfo _character0002F83A =
    {
        0x0002F83A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83A,
        0x0002F83A,
        0x0002F83A
    };

    static Char _decompositionMapping0002F83B[] = 
    {
        0x00005406
    };

    static _CharacterInfo _character0002F83B =
    {
        0x0002F83B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83B,
        0x0002F83B,
        0x0002F83B
    };

    static Char _decompositionMapping0002F83C[] = 
    {
        0x0000549E
    };

    static _CharacterInfo _character0002F83C =
    {
        0x0002F83C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83C,
        0x0002F83C,
        0x0002F83C
    };

    static Char _decompositionMapping0002F83D[] = 
    {
        0x00005438
    };

    static _CharacterInfo _character0002F83D =
    {
        0x0002F83D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83D,
        0x0002F83D,
        0x0002F83D
    };

    static Char _decompositionMapping0002F83E[] = 
    {
        0x00005448
    };

    static _CharacterInfo _character0002F83E =
    {
        0x0002F83E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83E,
        0x0002F83E,
        0x0002F83E
    };

    static Char _decompositionMapping0002F83F[] = 
    {
        0x00005468
    };

    static _CharacterInfo _character0002F83F =
    {
        0x0002F83F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F83F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F83F,
        0x0002F83F,
        0x0002F83F
    };

    static Char _decompositionMapping0002F840[] = 
    {
        0x000054A2
    };

    static _CharacterInfo _character0002F840 =
    {
        0x0002F840,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F840,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F840,
        0x0002F840,
        0x0002F840
    };

    static Char _decompositionMapping0002F841[] = 
    {
        0x000054F6
    };

    static _CharacterInfo _character0002F841 =
    {
        0x0002F841,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F841,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F841,
        0x0002F841,
        0x0002F841
    };

    static Char _decompositionMapping0002F842[] = 
    {
        0x00005510
    };

    static _CharacterInfo _character0002F842 =
    {
        0x0002F842,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F842,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F842,
        0x0002F842,
        0x0002F842
    };

    static Char _decompositionMapping0002F843[] = 
    {
        0x00005553
    };

    static _CharacterInfo _character0002F843 =
    {
        0x0002F843,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F843,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F843,
        0x0002F843,
        0x0002F843
    };

    static Char _decompositionMapping0002F844[] = 
    {
        0x00005563
    };

    static _CharacterInfo _character0002F844 =
    {
        0x0002F844,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F844,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F844,
        0x0002F844,
        0x0002F844
    };

    static Char _decompositionMapping0002F845[] = 
    {
        0x00005584
    };

    static _CharacterInfo _character0002F845 =
    {
        0x0002F845,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F845,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F845,
        0x0002F845,
        0x0002F845
    };

    static Char _decompositionMapping0002F846[] = 
    {
        0x00005584
    };

    static _CharacterInfo _character0002F846 =
    {
        0x0002F846,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F846,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F846,
        0x0002F846,
        0x0002F846
    };

    static Char _decompositionMapping0002F847[] = 
    {
        0x00005599
    };

    static _CharacterInfo _character0002F847 =
    {
        0x0002F847,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F847,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F847,
        0x0002F847,
        0x0002F847
    };

    static Char _decompositionMapping0002F848[] = 
    {
        0x000055AB
    };

    static _CharacterInfo _character0002F848 =
    {
        0x0002F848,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F848,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F848,
        0x0002F848,
        0x0002F848
    };

    static Char _decompositionMapping0002F849[] = 
    {
        0x000055B3
    };

    static _CharacterInfo _character0002F849 =
    {
        0x0002F849,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F849,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F849,
        0x0002F849,
        0x0002F849
    };

    static Char _decompositionMapping0002F84A[] = 
    {
        0x000055C2
    };

    static _CharacterInfo _character0002F84A =
    {
        0x0002F84A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84A,
        0x0002F84A,
        0x0002F84A
    };

    static Char _decompositionMapping0002F84B[] = 
    {
        0x00005716
    };

    static _CharacterInfo _character0002F84B =
    {
        0x0002F84B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84B,
        0x0002F84B,
        0x0002F84B
    };

    static Char _decompositionMapping0002F84C[] = 
    {
        0x00005606
    };

    static _CharacterInfo _character0002F84C =
    {
        0x0002F84C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84C,
        0x0002F84C,
        0x0002F84C
    };

    static Char _decompositionMapping0002F84D[] = 
    {
        0x00005717
    };

    static _CharacterInfo _character0002F84D =
    {
        0x0002F84D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84D,
        0x0002F84D,
        0x0002F84D
    };

    static Char _decompositionMapping0002F84E[] = 
    {
        0x00005651
    };

    static _CharacterInfo _character0002F84E =
    {
        0x0002F84E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84E,
        0x0002F84E,
        0x0002F84E
    };

    static Char _decompositionMapping0002F84F[] = 
    {
        0x00005674
    };

    static _CharacterInfo _character0002F84F =
    {
        0x0002F84F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F84F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F84F,
        0x0002F84F,
        0x0002F84F
    };

    static Char _decompositionMapping0002F850[] = 
    {
        0x00005207
    };

    static _CharacterInfo _character0002F850 =
    {
        0x0002F850,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F850,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F850,
        0x0002F850,
        0x0002F850
    };

    static Char _decompositionMapping0002F851[] = 
    {
        0x000058EE
    };

    static _CharacterInfo _character0002F851 =
    {
        0x0002F851,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F851,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F851,
        0x0002F851,
        0x0002F851
    };

    static Char _decompositionMapping0002F852[] = 
    {
        0x000057CE
    };

    static _CharacterInfo _character0002F852 =
    {
        0x0002F852,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F852,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F852,
        0x0002F852,
        0x0002F852
    };

    static Char _decompositionMapping0002F853[] = 
    {
        0x000057F4
    };

    static _CharacterInfo _character0002F853 =
    {
        0x0002F853,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F853,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F853,
        0x0002F853,
        0x0002F853
    };

    static Char _decompositionMapping0002F854[] = 
    {
        0x0000580D
    };

    static _CharacterInfo _character0002F854 =
    {
        0x0002F854,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F854,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F854,
        0x0002F854,
        0x0002F854
    };

    static Char _decompositionMapping0002F855[] = 
    {
        0x0000578B
    };

    static _CharacterInfo _character0002F855 =
    {
        0x0002F855,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F855,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F855,
        0x0002F855,
        0x0002F855
    };

    static Char _decompositionMapping0002F856[] = 
    {
        0x00005832
    };

    static _CharacterInfo _character0002F856 =
    {
        0x0002F856,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F856,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F856,
        0x0002F856,
        0x0002F856
    };

    static Char _decompositionMapping0002F857[] = 
    {
        0x00005831
    };

    static _CharacterInfo _character0002F857 =
    {
        0x0002F857,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F857,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F857,
        0x0002F857,
        0x0002F857
    };

    static Char _decompositionMapping0002F858[] = 
    {
        0x000058AC
    };

    static _CharacterInfo _character0002F858 =
    {
        0x0002F858,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F858,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F858,
        0x0002F858,
        0x0002F858
    };

    static Char _decompositionMapping0002F859[] = 
    {
        0x000214E4
    };

    static _CharacterInfo _character0002F859 =
    {
        0x0002F859,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F859,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F859,
        0x0002F859,
        0x0002F859
    };

    static Char _decompositionMapping0002F85A[] = 
    {
        0x000058F2
    };

    static _CharacterInfo _character0002F85A =
    {
        0x0002F85A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85A,
        0x0002F85A,
        0x0002F85A
    };

    static Char _decompositionMapping0002F85B[] = 
    {
        0x000058F7
    };

    static _CharacterInfo _character0002F85B =
    {
        0x0002F85B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85B,
        0x0002F85B,
        0x0002F85B
    };

    static Char _decompositionMapping0002F85C[] = 
    {
        0x00005906
    };

    static _CharacterInfo _character0002F85C =
    {
        0x0002F85C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85C,
        0x0002F85C,
        0x0002F85C
    };

    static Char _decompositionMapping0002F85D[] = 
    {
        0x0000591A
    };

    static _CharacterInfo _character0002F85D =
    {
        0x0002F85D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85D,
        0x0002F85D,
        0x0002F85D
    };

    static Char _decompositionMapping0002F85E[] = 
    {
        0x00005922
    };

    static _CharacterInfo _character0002F85E =
    {
        0x0002F85E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85E,
        0x0002F85E,
        0x0002F85E
    };

    static Char _decompositionMapping0002F85F[] = 
    {
        0x00005962
    };

    static _CharacterInfo _character0002F85F =
    {
        0x0002F85F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F85F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F85F,
        0x0002F85F,
        0x0002F85F
    };

    static Char _decompositionMapping0002F860[] = 
    {
        0x000216A8
    };

    static _CharacterInfo _character0002F860 =
    {
        0x0002F860,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F860,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F860,
        0x0002F860,
        0x0002F860
    };

    static Char _decompositionMapping0002F861[] = 
    {
        0x000216EA
    };

    static _CharacterInfo _character0002F861 =
    {
        0x0002F861,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F861,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F861,
        0x0002F861,
        0x0002F861
    };

    static Char _decompositionMapping0002F862[] = 
    {
        0x000059EC
    };

    static _CharacterInfo _character0002F862 =
    {
        0x0002F862,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F862,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F862,
        0x0002F862,
        0x0002F862
    };

    static Char _decompositionMapping0002F863[] = 
    {
        0x00005A1B
    };

    static _CharacterInfo _character0002F863 =
    {
        0x0002F863,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F863,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F863,
        0x0002F863,
        0x0002F863
    };

    static Char _decompositionMapping0002F864[] = 
    {
        0x00005A27
    };

    static _CharacterInfo _character0002F864 =
    {
        0x0002F864,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F864,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F864,
        0x0002F864,
        0x0002F864
    };

    static Char _decompositionMapping0002F865[] = 
    {
        0x000059D8
    };

    static _CharacterInfo _character0002F865 =
    {
        0x0002F865,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F865,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F865,
        0x0002F865,
        0x0002F865
    };

    static Char _decompositionMapping0002F866[] = 
    {
        0x00005A66
    };

    static _CharacterInfo _character0002F866 =
    {
        0x0002F866,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F866,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F866,
        0x0002F866,
        0x0002F866
    };

    static Char _decompositionMapping0002F867[] = 
    {
        0x000036EE
    };

    static _CharacterInfo _character0002F867 =
    {
        0x0002F867,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F867,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F867,
        0x0002F867,
        0x0002F867
    };

    static Char _decompositionMapping0002F868[] = 
    {
        0x000036FC
    };

    static _CharacterInfo _character0002F868 =
    {
        0x0002F868,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F868,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F868,
        0x0002F868,
        0x0002F868
    };

    static Char _decompositionMapping0002F869[] = 
    {
        0x00005B08
    };

    static _CharacterInfo _character0002F869 =
    {
        0x0002F869,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F869,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F869,
        0x0002F869,
        0x0002F869
    };

    static Char _decompositionMapping0002F86A[] = 
    {
        0x00005B3E
    };

    static _CharacterInfo _character0002F86A =
    {
        0x0002F86A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86A,
        0x0002F86A,
        0x0002F86A
    };

    static Char _decompositionMapping0002F86B[] = 
    {
        0x00005B3E
    };

    static _CharacterInfo _character0002F86B =
    {
        0x0002F86B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86B,
        0x0002F86B,
        0x0002F86B
    };

    static Char _decompositionMapping0002F86C[] = 
    {
        0x000219C8
    };

    static _CharacterInfo _character0002F86C =
    {
        0x0002F86C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86C,
        0x0002F86C,
        0x0002F86C
    };

    static Char _decompositionMapping0002F86D[] = 
    {
        0x00005BC3
    };

    static _CharacterInfo _character0002F86D =
    {
        0x0002F86D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86D,
        0x0002F86D,
        0x0002F86D
    };

    static Char _decompositionMapping0002F86E[] = 
    {
        0x00005BD8
    };

    static _CharacterInfo _character0002F86E =
    {
        0x0002F86E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86E,
        0x0002F86E,
        0x0002F86E
    };

    static Char _decompositionMapping0002F86F[] = 
    {
        0x00005BE7
    };

    static _CharacterInfo _character0002F86F =
    {
        0x0002F86F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F86F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F86F,
        0x0002F86F,
        0x0002F86F
    };

    static Char _decompositionMapping0002F870[] = 
    {
        0x00005BF3
    };

    static _CharacterInfo _character0002F870 =
    {
        0x0002F870,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F870,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F870,
        0x0002F870,
        0x0002F870
    };

    static Char _decompositionMapping0002F871[] = 
    {
        0x00021B18
    };

    static _CharacterInfo _character0002F871 =
    {
        0x0002F871,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F871,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F871,
        0x0002F871,
        0x0002F871
    };

    static Char _decompositionMapping0002F872[] = 
    {
        0x00005BFF
    };

    static _CharacterInfo _character0002F872 =
    {
        0x0002F872,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F872,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F872,
        0x0002F872,
        0x0002F872
    };

    static Char _decompositionMapping0002F873[] = 
    {
        0x00005C06
    };

    static _CharacterInfo _character0002F873 =
    {
        0x0002F873,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F873,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F873,
        0x0002F873,
        0x0002F873
    };

    static Char _decompositionMapping0002F874[] = 
    {
        0x00005F53
    };

    static _CharacterInfo _character0002F874 =
    {
        0x0002F874,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F874,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F874,
        0x0002F874,
        0x0002F874
    };

    static Char _decompositionMapping0002F875[] = 
    {
        0x00005C22
    };

    static _CharacterInfo _character0002F875 =
    {
        0x0002F875,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F875,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F875,
        0x0002F875,
        0x0002F875
    };

    static Char _decompositionMapping0002F876[] = 
    {
        0x00003781
    };

    static _CharacterInfo _character0002F876 =
    {
        0x0002F876,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F876,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F876,
        0x0002F876,
        0x0002F876
    };

    static Char _decompositionMapping0002F877[] = 
    {
        0x00005C60
    };

    static _CharacterInfo _character0002F877 =
    {
        0x0002F877,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F877,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F877,
        0x0002F877,
        0x0002F877
    };

    static Char _decompositionMapping0002F878[] = 
    {
        0x00005C6E
    };

    static _CharacterInfo _character0002F878 =
    {
        0x0002F878,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F878,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F878,
        0x0002F878,
        0x0002F878
    };

    static Char _decompositionMapping0002F879[] = 
    {
        0x00005CC0
    };

    static _CharacterInfo _character0002F879 =
    {
        0x0002F879,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F879,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F879,
        0x0002F879,
        0x0002F879
    };

    static Char _decompositionMapping0002F87A[] = 
    {
        0x00005C8D
    };

    static _CharacterInfo _character0002F87A =
    {
        0x0002F87A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87A,
        0x0002F87A,
        0x0002F87A
    };

    static Char _decompositionMapping0002F87B[] = 
    {
        0x00021DE4
    };

    static _CharacterInfo _character0002F87B =
    {
        0x0002F87B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87B,
        0x0002F87B,
        0x0002F87B
    };

    static Char _decompositionMapping0002F87C[] = 
    {
        0x00005D43
    };

    static _CharacterInfo _character0002F87C =
    {
        0x0002F87C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87C,
        0x0002F87C,
        0x0002F87C
    };

    static Char _decompositionMapping0002F87D[] = 
    {
        0x00021DE6
    };

    static _CharacterInfo _character0002F87D =
    {
        0x0002F87D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87D,
        0x0002F87D,
        0x0002F87D
    };

    static Char _decompositionMapping0002F87E[] = 
    {
        0x00005D6E
    };

    static _CharacterInfo _character0002F87E =
    {
        0x0002F87E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87E,
        0x0002F87E,
        0x0002F87E
    };

    static Char _decompositionMapping0002F87F[] = 
    {
        0x00005D6B
    };

    static _CharacterInfo _character0002F87F =
    {
        0x0002F87F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F87F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F87F,
        0x0002F87F,
        0x0002F87F
    };

    static Char _decompositionMapping0002F880[] = 
    {
        0x00005D7C
    };

    static _CharacterInfo _character0002F880 =
    {
        0x0002F880,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F880,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F880,
        0x0002F880,
        0x0002F880
    };

    static Char _decompositionMapping0002F881[] = 
    {
        0x00005DE1
    };

    static _CharacterInfo _character0002F881 =
    {
        0x0002F881,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F881,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F881,
        0x0002F881,
        0x0002F881
    };

    static Char _decompositionMapping0002F882[] = 
    {
        0x00005DE2
    };

    static _CharacterInfo _character0002F882 =
    {
        0x0002F882,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F882,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F882,
        0x0002F882,
        0x0002F882
    };

    static Char _decompositionMapping0002F883[] = 
    {
        0x0000382F
    };

    static _CharacterInfo _character0002F883 =
    {
        0x0002F883,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F883,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F883,
        0x0002F883,
        0x0002F883
    };

    static Char _decompositionMapping0002F884[] = 
    {
        0x00005DFD
    };

    static _CharacterInfo _character0002F884 =
    {
        0x0002F884,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F884,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F884,
        0x0002F884,
        0x0002F884
    };

    static Char _decompositionMapping0002F885[] = 
    {
        0x00005E28
    };

    static _CharacterInfo _character0002F885 =
    {
        0x0002F885,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F885,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F885,
        0x0002F885,
        0x0002F885
    };

    static Char _decompositionMapping0002F886[] = 
    {
        0x00005E3D
    };

    static _CharacterInfo _character0002F886 =
    {
        0x0002F886,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F886,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F886,
        0x0002F886,
        0x0002F886
    };

    static Char _decompositionMapping0002F887[] = 
    {
        0x00005E69
    };

    static _CharacterInfo _character0002F887 =
    {
        0x0002F887,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F887,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F887,
        0x0002F887,
        0x0002F887
    };

    static Char _decompositionMapping0002F888[] = 
    {
        0x00003862
    };

    static _CharacterInfo _character0002F888 =
    {
        0x0002F888,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F888,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F888,
        0x0002F888,
        0x0002F888
    };

    static Char _decompositionMapping0002F889[] = 
    {
        0x00022183
    };

    static _CharacterInfo _character0002F889 =
    {
        0x0002F889,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F889,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F889,
        0x0002F889,
        0x0002F889
    };

    static Char _decompositionMapping0002F88A[] = 
    {
        0x0000387C
    };

    static _CharacterInfo _character0002F88A =
    {
        0x0002F88A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88A,
        0x0002F88A,
        0x0002F88A
    };

    static Char _decompositionMapping0002F88B[] = 
    {
        0x00005EB0
    };

    static _CharacterInfo _character0002F88B =
    {
        0x0002F88B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88B,
        0x0002F88B,
        0x0002F88B
    };

    static Char _decompositionMapping0002F88C[] = 
    {
        0x00005EB3
    };

    static _CharacterInfo _character0002F88C =
    {
        0x0002F88C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88C,
        0x0002F88C,
        0x0002F88C
    };

    static Char _decompositionMapping0002F88D[] = 
    {
        0x00005EB6
    };

    static _CharacterInfo _character0002F88D =
    {
        0x0002F88D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88D,
        0x0002F88D,
        0x0002F88D
    };

    static Char _decompositionMapping0002F88E[] = 
    {
        0x00005ECA
    };

    static _CharacterInfo _character0002F88E =
    {
        0x0002F88E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88E,
        0x0002F88E,
        0x0002F88E
    };

    static Char _decompositionMapping0002F88F[] = 
    {
        0x0002A392
    };

    static _CharacterInfo _character0002F88F =
    {
        0x0002F88F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F88F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F88F,
        0x0002F88F,
        0x0002F88F
    };

    static Char _decompositionMapping0002F890[] = 
    {
        0x00005EFE
    };

    static _CharacterInfo _character0002F890 =
    {
        0x0002F890,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F890,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F890,
        0x0002F890,
        0x0002F890
    };

    static Char _decompositionMapping0002F891[] = 
    {
        0x00022331
    };

    static _CharacterInfo _character0002F891 =
    {
        0x0002F891,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F891,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F891,
        0x0002F891,
        0x0002F891
    };

    static Char _decompositionMapping0002F892[] = 
    {
        0x00022331
    };

    static _CharacterInfo _character0002F892 =
    {
        0x0002F892,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F892,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F892,
        0x0002F892,
        0x0002F892
    };

    static Char _decompositionMapping0002F893[] = 
    {
        0x00008201
    };

    static _CharacterInfo _character0002F893 =
    {
        0x0002F893,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F893,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F893,
        0x0002F893,
        0x0002F893
    };

    static Char _decompositionMapping0002F894[] = 
    {
        0x00005F22
    };

    static _CharacterInfo _character0002F894 =
    {
        0x0002F894,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F894,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F894,
        0x0002F894,
        0x0002F894
    };

    static Char _decompositionMapping0002F895[] = 
    {
        0x00005F22
    };

    static _CharacterInfo _character0002F895 =
    {
        0x0002F895,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F895,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F895,
        0x0002F895,
        0x0002F895
    };

    static Char _decompositionMapping0002F896[] = 
    {
        0x000038C7
    };

    static _CharacterInfo _character0002F896 =
    {
        0x0002F896,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F896,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F896,
        0x0002F896,
        0x0002F896
    };

    static Char _decompositionMapping0002F897[] = 
    {
        0x000232B8
    };

    static _CharacterInfo _character0002F897 =
    {
        0x0002F897,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F897,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F897,
        0x0002F897,
        0x0002F897
    };

    static Char _decompositionMapping0002F898[] = 
    {
        0x000261DA
    };

    static _CharacterInfo _character0002F898 =
    {
        0x0002F898,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F898,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F898,
        0x0002F898,
        0x0002F898
    };

    static Char _decompositionMapping0002F899[] = 
    {
        0x00005F62
    };

    static _CharacterInfo _character0002F899 =
    {
        0x0002F899,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F899,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F899,
        0x0002F899,
        0x0002F899
    };

    static Char _decompositionMapping0002F89A[] = 
    {
        0x00005F6B
    };

    static _CharacterInfo _character0002F89A =
    {
        0x0002F89A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89A,
        0x0002F89A,
        0x0002F89A
    };

    static Char _decompositionMapping0002F89B[] = 
    {
        0x000038E3
    };

    static _CharacterInfo _character0002F89B =
    {
        0x0002F89B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89B,
        0x0002F89B,
        0x0002F89B
    };

    static Char _decompositionMapping0002F89C[] = 
    {
        0x00005F9A
    };

    static _CharacterInfo _character0002F89C =
    {
        0x0002F89C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89C,
        0x0002F89C,
        0x0002F89C
    };

    static Char _decompositionMapping0002F89D[] = 
    {
        0x00005FCD
    };

    static _CharacterInfo _character0002F89D =
    {
        0x0002F89D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89D,
        0x0002F89D,
        0x0002F89D
    };

    static Char _decompositionMapping0002F89E[] = 
    {
        0x00005FD7
    };

    static _CharacterInfo _character0002F89E =
    {
        0x0002F89E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89E,
        0x0002F89E,
        0x0002F89E
    };

    static Char _decompositionMapping0002F89F[] = 
    {
        0x00005FF9
    };

    static _CharacterInfo _character0002F89F =
    {
        0x0002F89F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F89F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F89F,
        0x0002F89F,
        0x0002F89F
    };

    static Char _decompositionMapping0002F8A0[] = 
    {
        0x00006081
    };

    static _CharacterInfo _character0002F8A0 =
    {
        0x0002F8A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A0,
        0x0002F8A0,
        0x0002F8A0
    };

    static Char _decompositionMapping0002F8A1[] = 
    {
        0x0000393A
    };

    static _CharacterInfo _character0002F8A1 =
    {
        0x0002F8A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A1,
        0x0002F8A1,
        0x0002F8A1
    };

    static Char _decompositionMapping0002F8A2[] = 
    {
        0x0000391C
    };

    static _CharacterInfo _character0002F8A2 =
    {
        0x0002F8A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A2,
        0x0002F8A2,
        0x0002F8A2
    };

    static Char _decompositionMapping0002F8A3[] = 
    {
        0x00006094
    };

    static _CharacterInfo _character0002F8A3 =
    {
        0x0002F8A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A3,
        0x0002F8A3,
        0x0002F8A3
    };

    static Char _decompositionMapping0002F8A4[] = 
    {
        0x000226D4
    };

    static _CharacterInfo _character0002F8A4 =
    {
        0x0002F8A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A4,
        0x0002F8A4,
        0x0002F8A4
    };

    static Char _decompositionMapping0002F8A5[] = 
    {
        0x000060C7
    };

    static _CharacterInfo _character0002F8A5 =
    {
        0x0002F8A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A5,
        0x0002F8A5,
        0x0002F8A5
    };

    static Char _decompositionMapping0002F8A6[] = 
    {
        0x00006148
    };

    static _CharacterInfo _character0002F8A6 =
    {
        0x0002F8A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A6,
        0x0002F8A6,
        0x0002F8A6
    };

    static Char _decompositionMapping0002F8A7[] = 
    {
        0x0000614C
    };

    static _CharacterInfo _character0002F8A7 =
    {
        0x0002F8A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A7,
        0x0002F8A7,
        0x0002F8A7
    };

    static Char _decompositionMapping0002F8A8[] = 
    {
        0x0000614E
    };

    static _CharacterInfo _character0002F8A8 =
    {
        0x0002F8A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A8,
        0x0002F8A8,
        0x0002F8A8
    };

    static Char _decompositionMapping0002F8A9[] = 
    {
        0x0000614C
    };

    static _CharacterInfo _character0002F8A9 =
    {
        0x0002F8A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8A9,
        0x0002F8A9,
        0x0002F8A9
    };

    static Char _decompositionMapping0002F8AA[] = 
    {
        0x0000617A
    };

    static _CharacterInfo _character0002F8AA =
    {
        0x0002F8AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AA,
        0x0002F8AA,
        0x0002F8AA
    };

    static Char _decompositionMapping0002F8AB[] = 
    {
        0x0000618E
    };

    static _CharacterInfo _character0002F8AB =
    {
        0x0002F8AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AB,
        0x0002F8AB,
        0x0002F8AB
    };

    static Char _decompositionMapping0002F8AC[] = 
    {
        0x000061B2
    };

    static _CharacterInfo _character0002F8AC =
    {
        0x0002F8AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AC,
        0x0002F8AC,
        0x0002F8AC
    };

    static Char _decompositionMapping0002F8AD[] = 
    {
        0x000061A4
    };

    static _CharacterInfo _character0002F8AD =
    {
        0x0002F8AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AD,
        0x0002F8AD,
        0x0002F8AD
    };

    static Char _decompositionMapping0002F8AE[] = 
    {
        0x000061AF
    };

    static _CharacterInfo _character0002F8AE =
    {
        0x0002F8AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AE,
        0x0002F8AE,
        0x0002F8AE
    };

    static Char _decompositionMapping0002F8AF[] = 
    {
        0x000061DE
    };

    static _CharacterInfo _character0002F8AF =
    {
        0x0002F8AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8AF,
        0x0002F8AF,
        0x0002F8AF
    };

    static Char _decompositionMapping0002F8B0[] = 
    {
        0x000061F2
    };

    static _CharacterInfo _character0002F8B0 =
    {
        0x0002F8B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B0,
        0x0002F8B0,
        0x0002F8B0
    };

    static Char _decompositionMapping0002F8B1[] = 
    {
        0x000061F6
    };

    static _CharacterInfo _character0002F8B1 =
    {
        0x0002F8B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B1,
        0x0002F8B1,
        0x0002F8B1
    };

    static Char _decompositionMapping0002F8B2[] = 
    {
        0x00006210
    };

    static _CharacterInfo _character0002F8B2 =
    {
        0x0002F8B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B2,
        0x0002F8B2,
        0x0002F8B2
    };

    static Char _decompositionMapping0002F8B3[] = 
    {
        0x0000621B
    };

    static _CharacterInfo _character0002F8B3 =
    {
        0x0002F8B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B3,
        0x0002F8B3,
        0x0002F8B3
    };

    static Char _decompositionMapping0002F8B4[] = 
    {
        0x0000625D
    };

    static _CharacterInfo _character0002F8B4 =
    {
        0x0002F8B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B4,
        0x0002F8B4,
        0x0002F8B4
    };

    static Char _decompositionMapping0002F8B5[] = 
    {
        0x000062B1
    };

    static _CharacterInfo _character0002F8B5 =
    {
        0x0002F8B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B5,
        0x0002F8B5,
        0x0002F8B5
    };

    static Char _decompositionMapping0002F8B6[] = 
    {
        0x000062D4
    };

    static _CharacterInfo _character0002F8B6 =
    {
        0x0002F8B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B6,
        0x0002F8B6,
        0x0002F8B6
    };

    static Char _decompositionMapping0002F8B7[] = 
    {
        0x00006350
    };

    static _CharacterInfo _character0002F8B7 =
    {
        0x0002F8B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B7,
        0x0002F8B7,
        0x0002F8B7
    };

    static Char _decompositionMapping0002F8B8[] = 
    {
        0x00022B0C
    };

    static _CharacterInfo _character0002F8B8 =
    {
        0x0002F8B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B8,
        0x0002F8B8,
        0x0002F8B8
    };

    static Char _decompositionMapping0002F8B9[] = 
    {
        0x0000633D
    };

    static _CharacterInfo _character0002F8B9 =
    {
        0x0002F8B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8B9,
        0x0002F8B9,
        0x0002F8B9
    };

    static Char _decompositionMapping0002F8BA[] = 
    {
        0x000062FC
    };

    static _CharacterInfo _character0002F8BA =
    {
        0x0002F8BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BA,
        0x0002F8BA,
        0x0002F8BA
    };

    static Char _decompositionMapping0002F8BB[] = 
    {
        0x00006368
    };

    static _CharacterInfo _character0002F8BB =
    {
        0x0002F8BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BB,
        0x0002F8BB,
        0x0002F8BB
    };

    static Char _decompositionMapping0002F8BC[] = 
    {
        0x00006383
    };

    static _CharacterInfo _character0002F8BC =
    {
        0x0002F8BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BC,
        0x0002F8BC,
        0x0002F8BC
    };

    static Char _decompositionMapping0002F8BD[] = 
    {
        0x000063E4
    };

    static _CharacterInfo _character0002F8BD =
    {
        0x0002F8BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BD,
        0x0002F8BD,
        0x0002F8BD
    };

    static Char _decompositionMapping0002F8BE[] = 
    {
        0x00022BF1
    };

    static _CharacterInfo _character0002F8BE =
    {
        0x0002F8BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BE,
        0x0002F8BE,
        0x0002F8BE
    };

    static Char _decompositionMapping0002F8BF[] = 
    {
        0x00006422
    };

    static _CharacterInfo _character0002F8BF =
    {
        0x0002F8BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8BF,
        0x0002F8BF,
        0x0002F8BF
    };

    static Char _decompositionMapping0002F8C0[] = 
    {
        0x000063C5
    };

    static _CharacterInfo _character0002F8C0 =
    {
        0x0002F8C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C0,
        0x0002F8C0,
        0x0002F8C0
    };

    static Char _decompositionMapping0002F8C1[] = 
    {
        0x000063A9
    };

    static _CharacterInfo _character0002F8C1 =
    {
        0x0002F8C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C1,
        0x0002F8C1,
        0x0002F8C1
    };

    static Char _decompositionMapping0002F8C2[] = 
    {
        0x00003A2E
    };

    static _CharacterInfo _character0002F8C2 =
    {
        0x0002F8C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C2,
        0x0002F8C2,
        0x0002F8C2
    };

    static Char _decompositionMapping0002F8C3[] = 
    {
        0x00006469
    };

    static _CharacterInfo _character0002F8C3 =
    {
        0x0002F8C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C3,
        0x0002F8C3,
        0x0002F8C3
    };

    static Char _decompositionMapping0002F8C4[] = 
    {
        0x0000647E
    };

    static _CharacterInfo _character0002F8C4 =
    {
        0x0002F8C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C4,
        0x0002F8C4,
        0x0002F8C4
    };

    static Char _decompositionMapping0002F8C5[] = 
    {
        0x0000649D
    };

    static _CharacterInfo _character0002F8C5 =
    {
        0x0002F8C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C5,
        0x0002F8C5,
        0x0002F8C5
    };

    static Char _decompositionMapping0002F8C6[] = 
    {
        0x00006477
    };

    static _CharacterInfo _character0002F8C6 =
    {
        0x0002F8C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C6,
        0x0002F8C6,
        0x0002F8C6
    };

    static Char _decompositionMapping0002F8C7[] = 
    {
        0x00003A6C
    };

    static _CharacterInfo _character0002F8C7 =
    {
        0x0002F8C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C7,
        0x0002F8C7,
        0x0002F8C7
    };

    static Char _decompositionMapping0002F8C8[] = 
    {
        0x0000654F
    };

    static _CharacterInfo _character0002F8C8 =
    {
        0x0002F8C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C8,
        0x0002F8C8,
        0x0002F8C8
    };

    static Char _decompositionMapping0002F8C9[] = 
    {
        0x0000656C
    };

    static _CharacterInfo _character0002F8C9 =
    {
        0x0002F8C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8C9,
        0x0002F8C9,
        0x0002F8C9
    };

    static Char _decompositionMapping0002F8CA[] = 
    {
        0x0002300A
    };

    static _CharacterInfo _character0002F8CA =
    {
        0x0002F8CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CA,
        0x0002F8CA,
        0x0002F8CA
    };

    static Char _decompositionMapping0002F8CB[] = 
    {
        0x000065E3
    };

    static _CharacterInfo _character0002F8CB =
    {
        0x0002F8CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CB,
        0x0002F8CB,
        0x0002F8CB
    };

    static Char _decompositionMapping0002F8CC[] = 
    {
        0x000066F8
    };

    static _CharacterInfo _character0002F8CC =
    {
        0x0002F8CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CC,
        0x0002F8CC,
        0x0002F8CC
    };

    static Char _decompositionMapping0002F8CD[] = 
    {
        0x00006649
    };

    static _CharacterInfo _character0002F8CD =
    {
        0x0002F8CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CD,
        0x0002F8CD,
        0x0002F8CD
    };

    static Char _decompositionMapping0002F8CE[] = 
    {
        0x00003B19
    };

    static _CharacterInfo _character0002F8CE =
    {
        0x0002F8CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CE,
        0x0002F8CE,
        0x0002F8CE
    };

    static Char _decompositionMapping0002F8CF[] = 
    {
        0x00006691
    };

    static _CharacterInfo _character0002F8CF =
    {
        0x0002F8CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8CF,
        0x0002F8CF,
        0x0002F8CF
    };

    static Char _decompositionMapping0002F8D0[] = 
    {
        0x00003B08
    };

    static _CharacterInfo _character0002F8D0 =
    {
        0x0002F8D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D0,
        0x0002F8D0,
        0x0002F8D0
    };

    static Char _decompositionMapping0002F8D1[] = 
    {
        0x00003AE4
    };

    static _CharacterInfo _character0002F8D1 =
    {
        0x0002F8D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D1,
        0x0002F8D1,
        0x0002F8D1
    };

    static Char _decompositionMapping0002F8D2[] = 
    {
        0x00005192
    };

    static _CharacterInfo _character0002F8D2 =
    {
        0x0002F8D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D2,
        0x0002F8D2,
        0x0002F8D2
    };

    static Char _decompositionMapping0002F8D3[] = 
    {
        0x00005195
    };

    static _CharacterInfo _character0002F8D3 =
    {
        0x0002F8D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D3,
        0x0002F8D3,
        0x0002F8D3
    };

    static Char _decompositionMapping0002F8D4[] = 
    {
        0x00006700
    };

    static _CharacterInfo _character0002F8D4 =
    {
        0x0002F8D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D4,
        0x0002F8D4,
        0x0002F8D4
    };

    static Char _decompositionMapping0002F8D5[] = 
    {
        0x0000669C
    };

    static _CharacterInfo _character0002F8D5 =
    {
        0x0002F8D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D5,
        0x0002F8D5,
        0x0002F8D5
    };

    static Char _decompositionMapping0002F8D6[] = 
    {
        0x000080AD
    };

    static _CharacterInfo _character0002F8D6 =
    {
        0x0002F8D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D6,
        0x0002F8D6,
        0x0002F8D6
    };

    static Char _decompositionMapping0002F8D7[] = 
    {
        0x000043D9
    };

    static _CharacterInfo _character0002F8D7 =
    {
        0x0002F8D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D7,
        0x0002F8D7,
        0x0002F8D7
    };

    static Char _decompositionMapping0002F8D8[] = 
    {
        0x00006717
    };

    static _CharacterInfo _character0002F8D8 =
    {
        0x0002F8D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D8,
        0x0002F8D8,
        0x0002F8D8
    };

    static Char _decompositionMapping0002F8D9[] = 
    {
        0x0000671B
    };

    static _CharacterInfo _character0002F8D9 =
    {
        0x0002F8D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8D9,
        0x0002F8D9,
        0x0002F8D9
    };

    static Char _decompositionMapping0002F8DA[] = 
    {
        0x00006721
    };

    static _CharacterInfo _character0002F8DA =
    {
        0x0002F8DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DA,
        0x0002F8DA,
        0x0002F8DA
    };

    static Char _decompositionMapping0002F8DB[] = 
    {
        0x0000675E
    };

    static _CharacterInfo _character0002F8DB =
    {
        0x0002F8DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DB,
        0x0002F8DB,
        0x0002F8DB
    };

    static Char _decompositionMapping0002F8DC[] = 
    {
        0x00006753
    };

    static _CharacterInfo _character0002F8DC =
    {
        0x0002F8DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DC,
        0x0002F8DC,
        0x0002F8DC
    };

    static Char _decompositionMapping0002F8DD[] = 
    {
        0x000233C3
    };

    static _CharacterInfo _character0002F8DD =
    {
        0x0002F8DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DD,
        0x0002F8DD,
        0x0002F8DD
    };

    static Char _decompositionMapping0002F8DE[] = 
    {
        0x00003B49
    };

    static _CharacterInfo _character0002F8DE =
    {
        0x0002F8DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DE,
        0x0002F8DE,
        0x0002F8DE
    };

    static Char _decompositionMapping0002F8DF[] = 
    {
        0x000067FA
    };

    static _CharacterInfo _character0002F8DF =
    {
        0x0002F8DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8DF,
        0x0002F8DF,
        0x0002F8DF
    };

    static Char _decompositionMapping0002F8E0[] = 
    {
        0x00006785
    };

    static _CharacterInfo _character0002F8E0 =
    {
        0x0002F8E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E0,
        0x0002F8E0,
        0x0002F8E0
    };

    static Char _decompositionMapping0002F8E1[] = 
    {
        0x00006852
    };

    static _CharacterInfo _character0002F8E1 =
    {
        0x0002F8E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E1,
        0x0002F8E1,
        0x0002F8E1
    };

    static Char _decompositionMapping0002F8E2[] = 
    {
        0x00006885
    };

    static _CharacterInfo _character0002F8E2 =
    {
        0x0002F8E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E2,
        0x0002F8E2,
        0x0002F8E2
    };

    static Char _decompositionMapping0002F8E3[] = 
    {
        0x0002346D
    };

    static _CharacterInfo _character0002F8E3 =
    {
        0x0002F8E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E3,
        0x0002F8E3,
        0x0002F8E3
    };

    static Char _decompositionMapping0002F8E4[] = 
    {
        0x0000688E
    };

    static _CharacterInfo _character0002F8E4 =
    {
        0x0002F8E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E4,
        0x0002F8E4,
        0x0002F8E4
    };

    static Char _decompositionMapping0002F8E5[] = 
    {
        0x0000681F
    };

    static _CharacterInfo _character0002F8E5 =
    {
        0x0002F8E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E5,
        0x0002F8E5,
        0x0002F8E5
    };

    static Char _decompositionMapping0002F8E6[] = 
    {
        0x00006914
    };

    static _CharacterInfo _character0002F8E6 =
    {
        0x0002F8E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E6,
        0x0002F8E6,
        0x0002F8E6
    };

    static Char _decompositionMapping0002F8E7[] = 
    {
        0x00003B9D
    };

    static _CharacterInfo _character0002F8E7 =
    {
        0x0002F8E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E7,
        0x0002F8E7,
        0x0002F8E7
    };

    static Char _decompositionMapping0002F8E8[] = 
    {
        0x00006942
    };

    static _CharacterInfo _character0002F8E8 =
    {
        0x0002F8E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E8,
        0x0002F8E8,
        0x0002F8E8
    };

    static Char _decompositionMapping0002F8E9[] = 
    {
        0x000069A3
    };

    static _CharacterInfo _character0002F8E9 =
    {
        0x0002F8E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8E9,
        0x0002F8E9,
        0x0002F8E9
    };

    static Char _decompositionMapping0002F8EA[] = 
    {
        0x000069EA
    };

    static _CharacterInfo _character0002F8EA =
    {
        0x0002F8EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8EA,
        0x0002F8EA,
        0x0002F8EA
    };

    static Char _decompositionMapping0002F8EB[] = 
    {
        0x00006AA8
    };

    static _CharacterInfo _character0002F8EB =
    {
        0x0002F8EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8EB,
        0x0002F8EB,
        0x0002F8EB
    };

    static Char _decompositionMapping0002F8EC[] = 
    {
        0x000236A3
    };

    static _CharacterInfo _character0002F8EC =
    {
        0x0002F8EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8EC,
        0x0002F8EC,
        0x0002F8EC
    };

    static Char _decompositionMapping0002F8ED[] = 
    {
        0x00006ADB
    };

    static _CharacterInfo _character0002F8ED =
    {
        0x0002F8ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8ED,
        0x0002F8ED,
        0x0002F8ED
    };

    static Char _decompositionMapping0002F8EE[] = 
    {
        0x00003C18
    };

    static _CharacterInfo _character0002F8EE =
    {
        0x0002F8EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8EE,
        0x0002F8EE,
        0x0002F8EE
    };

    static Char _decompositionMapping0002F8EF[] = 
    {
        0x00006B21
    };

    static _CharacterInfo _character0002F8EF =
    {
        0x0002F8EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8EF,
        0x0002F8EF,
        0x0002F8EF
    };

    static Char _decompositionMapping0002F8F0[] = 
    {
        0x000238A7
    };

    static _CharacterInfo _character0002F8F0 =
    {
        0x0002F8F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F0,
        0x0002F8F0,
        0x0002F8F0
    };

    static Char _decompositionMapping0002F8F1[] = 
    {
        0x00006B54
    };

    static _CharacterInfo _character0002F8F1 =
    {
        0x0002F8F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F1,
        0x0002F8F1,
        0x0002F8F1
    };

    static Char _decompositionMapping0002F8F2[] = 
    {
        0x00003C4E
    };

    static _CharacterInfo _character0002F8F2 =
    {
        0x0002F8F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F2,
        0x0002F8F2,
        0x0002F8F2
    };

    static Char _decompositionMapping0002F8F3[] = 
    {
        0x00006B72
    };

    static _CharacterInfo _character0002F8F3 =
    {
        0x0002F8F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F3,
        0x0002F8F3,
        0x0002F8F3
    };

    static Char _decompositionMapping0002F8F4[] = 
    {
        0x00006B9F
    };

    static _CharacterInfo _character0002F8F4 =
    {
        0x0002F8F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F4,
        0x0002F8F4,
        0x0002F8F4
    };

    static Char _decompositionMapping0002F8F5[] = 
    {
        0x00006BBA
    };

    static _CharacterInfo _character0002F8F5 =
    {
        0x0002F8F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F5,
        0x0002F8F5,
        0x0002F8F5
    };

    static Char _decompositionMapping0002F8F6[] = 
    {
        0x00006BBB
    };

    static _CharacterInfo _character0002F8F6 =
    {
        0x0002F8F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F6,
        0x0002F8F6,
        0x0002F8F6
    };

    static Char _decompositionMapping0002F8F7[] = 
    {
        0x00023A8D
    };

    static _CharacterInfo _character0002F8F7 =
    {
        0x0002F8F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F7,
        0x0002F8F7,
        0x0002F8F7
    };

    static Char _decompositionMapping0002F8F8[] = 
    {
        0x00021D0B
    };

    static _CharacterInfo _character0002F8F8 =
    {
        0x0002F8F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F8,
        0x0002F8F8,
        0x0002F8F8
    };

    static Char _decompositionMapping0002F8F9[] = 
    {
        0x00023AFA
    };

    static _CharacterInfo _character0002F8F9 =
    {
        0x0002F8F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8F9,
        0x0002F8F9,
        0x0002F8F9
    };

    static Char _decompositionMapping0002F8FA[] = 
    {
        0x00006C4E
    };

    static _CharacterInfo _character0002F8FA =
    {
        0x0002F8FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FA,
        0x0002F8FA,
        0x0002F8FA
    };

    static Char _decompositionMapping0002F8FB[] = 
    {
        0x00023CBC
    };

    static _CharacterInfo _character0002F8FB =
    {
        0x0002F8FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FB,
        0x0002F8FB,
        0x0002F8FB
    };

    static Char _decompositionMapping0002F8FC[] = 
    {
        0x00006CBF
    };

    static _CharacterInfo _character0002F8FC =
    {
        0x0002F8FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FC,
        0x0002F8FC,
        0x0002F8FC
    };

    static Char _decompositionMapping0002F8FD[] = 
    {
        0x00006CCD
    };

    static _CharacterInfo _character0002F8FD =
    {
        0x0002F8FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FD,
        0x0002F8FD,
        0x0002F8FD
    };

    static Char _decompositionMapping0002F8FE[] = 
    {
        0x00006C67
    };

    static _CharacterInfo _character0002F8FE =
    {
        0x0002F8FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FE,
        0x0002F8FE,
        0x0002F8FE
    };

    static Char _decompositionMapping0002F8FF[] = 
    {
        0x00006D16
    };

    static _CharacterInfo _character0002F8FF =
    {
        0x0002F8FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F8FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F8FF,
        0x0002F8FF,
        0x0002F8FF
    };

    static Char _decompositionMapping0002F900[] = 
    {
        0x00006D3E
    };

    static _CharacterInfo _character0002F900 =
    {
        0x0002F900,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F900,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F900,
        0x0002F900,
        0x0002F900
    };

    static Char _decompositionMapping0002F901[] = 
    {
        0x00006D77
    };

    static _CharacterInfo _character0002F901 =
    {
        0x0002F901,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F901,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F901,
        0x0002F901,
        0x0002F901
    };

    static Char _decompositionMapping0002F902[] = 
    {
        0x00006D41
    };

    static _CharacterInfo _character0002F902 =
    {
        0x0002F902,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F902,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F902,
        0x0002F902,
        0x0002F902
    };

    static Char _decompositionMapping0002F903[] = 
    {
        0x00006D69
    };

    static _CharacterInfo _character0002F903 =
    {
        0x0002F903,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F903,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F903,
        0x0002F903,
        0x0002F903
    };

    static Char _decompositionMapping0002F904[] = 
    {
        0x00006D78
    };

    static _CharacterInfo _character0002F904 =
    {
        0x0002F904,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F904,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F904,
        0x0002F904,
        0x0002F904
    };

    static Char _decompositionMapping0002F905[] = 
    {
        0x00006D85
    };

    static _CharacterInfo _character0002F905 =
    {
        0x0002F905,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F905,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F905,
        0x0002F905,
        0x0002F905
    };

    static Char _decompositionMapping0002F906[] = 
    {
        0x00023D1E
    };

    static _CharacterInfo _character0002F906 =
    {
        0x0002F906,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F906,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F906,
        0x0002F906,
        0x0002F906
    };

    static Char _decompositionMapping0002F907[] = 
    {
        0x00006D34
    };

    static _CharacterInfo _character0002F907 =
    {
        0x0002F907,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F907,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F907,
        0x0002F907,
        0x0002F907
    };

    static Char _decompositionMapping0002F908[] = 
    {
        0x00006E2F
    };

    static _CharacterInfo _character0002F908 =
    {
        0x0002F908,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F908,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F908,
        0x0002F908,
        0x0002F908
    };

    static Char _decompositionMapping0002F909[] = 
    {
        0x00006E6E
    };

    static _CharacterInfo _character0002F909 =
    {
        0x0002F909,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F909,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F909,
        0x0002F909,
        0x0002F909
    };

    static Char _decompositionMapping0002F90A[] = 
    {
        0x00003D33
    };

    static _CharacterInfo _character0002F90A =
    {
        0x0002F90A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90A,
        0x0002F90A,
        0x0002F90A
    };

    static Char _decompositionMapping0002F90B[] = 
    {
        0x00006ECB
    };

    static _CharacterInfo _character0002F90B =
    {
        0x0002F90B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90B,
        0x0002F90B,
        0x0002F90B
    };

    static Char _decompositionMapping0002F90C[] = 
    {
        0x00006EC7
    };

    static _CharacterInfo _character0002F90C =
    {
        0x0002F90C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90C,
        0x0002F90C,
        0x0002F90C
    };

    static Char _decompositionMapping0002F90D[] = 
    {
        0x00023ED1
    };

    static _CharacterInfo _character0002F90D =
    {
        0x0002F90D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90D,
        0x0002F90D,
        0x0002F90D
    };

    static Char _decompositionMapping0002F90E[] = 
    {
        0x00006DF9
    };

    static _CharacterInfo _character0002F90E =
    {
        0x0002F90E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90E,
        0x0002F90E,
        0x0002F90E
    };

    static Char _decompositionMapping0002F90F[] = 
    {
        0x00006F6E
    };

    static _CharacterInfo _character0002F90F =
    {
        0x0002F90F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F90F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F90F,
        0x0002F90F,
        0x0002F90F
    };

    static Char _decompositionMapping0002F910[] = 
    {
        0x00023F5E
    };

    static _CharacterInfo _character0002F910 =
    {
        0x0002F910,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F910,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F910,
        0x0002F910,
        0x0002F910
    };

    static Char _decompositionMapping0002F911[] = 
    {
        0x00023F8E
    };

    static _CharacterInfo _character0002F911 =
    {
        0x0002F911,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F911,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F911,
        0x0002F911,
        0x0002F911
    };

    static Char _decompositionMapping0002F912[] = 
    {
        0x00006FC6
    };

    static _CharacterInfo _character0002F912 =
    {
        0x0002F912,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F912,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F912,
        0x0002F912,
        0x0002F912
    };

    static Char _decompositionMapping0002F913[] = 
    {
        0x00007039
    };

    static _CharacterInfo _character0002F913 =
    {
        0x0002F913,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F913,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F913,
        0x0002F913,
        0x0002F913
    };

    static Char _decompositionMapping0002F914[] = 
    {
        0x0000701E
    };

    static _CharacterInfo _character0002F914 =
    {
        0x0002F914,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F914,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F914,
        0x0002F914,
        0x0002F914
    };

    static Char _decompositionMapping0002F915[] = 
    {
        0x0000701B
    };

    static _CharacterInfo _character0002F915 =
    {
        0x0002F915,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F915,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F915,
        0x0002F915,
        0x0002F915
    };

    static Char _decompositionMapping0002F916[] = 
    {
        0x00003D96
    };

    static _CharacterInfo _character0002F916 =
    {
        0x0002F916,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F916,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F916,
        0x0002F916,
        0x0002F916
    };

    static Char _decompositionMapping0002F917[] = 
    {
        0x0000704A
    };

    static _CharacterInfo _character0002F917 =
    {
        0x0002F917,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F917,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F917,
        0x0002F917,
        0x0002F917
    };

    static Char _decompositionMapping0002F918[] = 
    {
        0x0000707D
    };

    static _CharacterInfo _character0002F918 =
    {
        0x0002F918,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F918,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F918,
        0x0002F918,
        0x0002F918
    };

    static Char _decompositionMapping0002F919[] = 
    {
        0x00007077
    };

    static _CharacterInfo _character0002F919 =
    {
        0x0002F919,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F919,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F919,
        0x0002F919,
        0x0002F919
    };

    static Char _decompositionMapping0002F91A[] = 
    {
        0x000070AD
    };

    static _CharacterInfo _character0002F91A =
    {
        0x0002F91A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91A,
        0x0002F91A,
        0x0002F91A
    };

    static Char _decompositionMapping0002F91B[] = 
    {
        0x00020525
    };

    static _CharacterInfo _character0002F91B =
    {
        0x0002F91B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91B,
        0x0002F91B,
        0x0002F91B
    };

    static Char _decompositionMapping0002F91C[] = 
    {
        0x00007145
    };

    static _CharacterInfo _character0002F91C =
    {
        0x0002F91C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91C,
        0x0002F91C,
        0x0002F91C
    };

    static Char _decompositionMapping0002F91D[] = 
    {
        0x00024263
    };

    static _CharacterInfo _character0002F91D =
    {
        0x0002F91D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91D,
        0x0002F91D,
        0x0002F91D
    };

    static Char _decompositionMapping0002F91E[] = 
    {
        0x0000719C
    };

    static _CharacterInfo _character0002F91E =
    {
        0x0002F91E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91E,
        0x0002F91E,
        0x0002F91E
    };

    static Char _decompositionMapping0002F91F[] = 
    {
        0x000243AB
    };

    static _CharacterInfo _character0002F91F =
    {
        0x0002F91F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F91F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F91F,
        0x0002F91F,
        0x0002F91F
    };

    static Char _decompositionMapping0002F920[] = 
    {
        0x00007228
    };

    static _CharacterInfo _character0002F920 =
    {
        0x0002F920,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F920,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F920,
        0x0002F920,
        0x0002F920
    };

    static Char _decompositionMapping0002F921[] = 
    {
        0x00007235
    };

    static _CharacterInfo _character0002F921 =
    {
        0x0002F921,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F921,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F921,
        0x0002F921,
        0x0002F921
    };

    static Char _decompositionMapping0002F922[] = 
    {
        0x00007250
    };

    static _CharacterInfo _character0002F922 =
    {
        0x0002F922,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F922,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F922,
        0x0002F922,
        0x0002F922
    };

    static Char _decompositionMapping0002F923[] = 
    {
        0x00024608
    };

    static _CharacterInfo _character0002F923 =
    {
        0x0002F923,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F923,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F923,
        0x0002F923,
        0x0002F923
    };

    static Char _decompositionMapping0002F924[] = 
    {
        0x00007280
    };

    static _CharacterInfo _character0002F924 =
    {
        0x0002F924,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F924,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F924,
        0x0002F924,
        0x0002F924
    };

    static Char _decompositionMapping0002F925[] = 
    {
        0x00007295
    };

    static _CharacterInfo _character0002F925 =
    {
        0x0002F925,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F925,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F925,
        0x0002F925,
        0x0002F925
    };

    static Char _decompositionMapping0002F926[] = 
    {
        0x00024735
    };

    static _CharacterInfo _character0002F926 =
    {
        0x0002F926,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F926,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F926,
        0x0002F926,
        0x0002F926
    };

    static Char _decompositionMapping0002F927[] = 
    {
        0x00024814
    };

    static _CharacterInfo _character0002F927 =
    {
        0x0002F927,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F927,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F927,
        0x0002F927,
        0x0002F927
    };

    static Char _decompositionMapping0002F928[] = 
    {
        0x0000737A
    };

    static _CharacterInfo _character0002F928 =
    {
        0x0002F928,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F928,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F928,
        0x0002F928,
        0x0002F928
    };

    static Char _decompositionMapping0002F929[] = 
    {
        0x0000738B
    };

    static _CharacterInfo _character0002F929 =
    {
        0x0002F929,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F929,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F929,
        0x0002F929,
        0x0002F929
    };

    static Char _decompositionMapping0002F92A[] = 
    {
        0x00003EAC
    };

    static _CharacterInfo _character0002F92A =
    {
        0x0002F92A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92A,
        0x0002F92A,
        0x0002F92A
    };

    static Char _decompositionMapping0002F92B[] = 
    {
        0x000073A5
    };

    static _CharacterInfo _character0002F92B =
    {
        0x0002F92B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92B,
        0x0002F92B,
        0x0002F92B
    };

    static Char _decompositionMapping0002F92C[] = 
    {
        0x00003EB8
    };

    static _CharacterInfo _character0002F92C =
    {
        0x0002F92C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92C,
        0x0002F92C,
        0x0002F92C
    };

    static Char _decompositionMapping0002F92D[] = 
    {
        0x00003EB8
    };

    static _CharacterInfo _character0002F92D =
    {
        0x0002F92D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92D,
        0x0002F92D,
        0x0002F92D
    };

    static Char _decompositionMapping0002F92E[] = 
    {
        0x00007447
    };

    static _CharacterInfo _character0002F92E =
    {
        0x0002F92E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92E,
        0x0002F92E,
        0x0002F92E
    };

    static Char _decompositionMapping0002F92F[] = 
    {
        0x0000745C
    };

    static _CharacterInfo _character0002F92F =
    {
        0x0002F92F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F92F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F92F,
        0x0002F92F,
        0x0002F92F
    };

    static Char _decompositionMapping0002F930[] = 
    {
        0x00007471
    };

    static _CharacterInfo _character0002F930 =
    {
        0x0002F930,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F930,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F930,
        0x0002F930,
        0x0002F930
    };

    static Char _decompositionMapping0002F931[] = 
    {
        0x00007485
    };

    static _CharacterInfo _character0002F931 =
    {
        0x0002F931,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F931,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F931,
        0x0002F931,
        0x0002F931
    };

    static Char _decompositionMapping0002F932[] = 
    {
        0x000074CA
    };

    static _CharacterInfo _character0002F932 =
    {
        0x0002F932,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F932,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F932,
        0x0002F932,
        0x0002F932
    };

    static Char _decompositionMapping0002F933[] = 
    {
        0x00003F1B
    };

    static _CharacterInfo _character0002F933 =
    {
        0x0002F933,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F933,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F933,
        0x0002F933,
        0x0002F933
    };

    static Char _decompositionMapping0002F934[] = 
    {
        0x00007524
    };

    static _CharacterInfo _character0002F934 =
    {
        0x0002F934,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F934,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F934,
        0x0002F934,
        0x0002F934
    };

    static Char _decompositionMapping0002F935[] = 
    {
        0x00024C36
    };

    static _CharacterInfo _character0002F935 =
    {
        0x0002F935,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F935,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F935,
        0x0002F935,
        0x0002F935
    };

    static Char _decompositionMapping0002F936[] = 
    {
        0x0000753E
    };

    static _CharacterInfo _character0002F936 =
    {
        0x0002F936,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F936,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F936,
        0x0002F936,
        0x0002F936
    };

    static Char _decompositionMapping0002F937[] = 
    {
        0x00024C92
    };

    static _CharacterInfo _character0002F937 =
    {
        0x0002F937,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F937,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F937,
        0x0002F937,
        0x0002F937
    };

    static Char _decompositionMapping0002F938[] = 
    {
        0x00007570
    };

    static _CharacterInfo _character0002F938 =
    {
        0x0002F938,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F938,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F938,
        0x0002F938,
        0x0002F938
    };

    static Char _decompositionMapping0002F939[] = 
    {
        0x0002219F
    };

    static _CharacterInfo _character0002F939 =
    {
        0x0002F939,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F939,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F939,
        0x0002F939,
        0x0002F939
    };

    static Char _decompositionMapping0002F93A[] = 
    {
        0x00007610
    };

    static _CharacterInfo _character0002F93A =
    {
        0x0002F93A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93A,
        0x0002F93A,
        0x0002F93A
    };

    static Char _decompositionMapping0002F93B[] = 
    {
        0x00024FA1
    };

    static _CharacterInfo _character0002F93B =
    {
        0x0002F93B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93B,
        0x0002F93B,
        0x0002F93B
    };

    static Char _decompositionMapping0002F93C[] = 
    {
        0x00024FB8
    };

    static _CharacterInfo _character0002F93C =
    {
        0x0002F93C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93C,
        0x0002F93C,
        0x0002F93C
    };

    static Char _decompositionMapping0002F93D[] = 
    {
        0x00025044
    };

    static _CharacterInfo _character0002F93D =
    {
        0x0002F93D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93D,
        0x0002F93D,
        0x0002F93D
    };

    static Char _decompositionMapping0002F93E[] = 
    {
        0x00003FFC
    };

    static _CharacterInfo _character0002F93E =
    {
        0x0002F93E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93E,
        0x0002F93E,
        0x0002F93E
    };

    static Char _decompositionMapping0002F93F[] = 
    {
        0x00004008
    };

    static _CharacterInfo _character0002F93F =
    {
        0x0002F93F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F93F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F93F,
        0x0002F93F,
        0x0002F93F
    };

    static Char _decompositionMapping0002F940[] = 
    {
        0x000076F4
    };

    static _CharacterInfo _character0002F940 =
    {
        0x0002F940,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F940,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F940,
        0x0002F940,
        0x0002F940
    };

    static Char _decompositionMapping0002F941[] = 
    {
        0x000250F3
    };

    static _CharacterInfo _character0002F941 =
    {
        0x0002F941,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F941,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F941,
        0x0002F941,
        0x0002F941
    };

    static Char _decompositionMapping0002F942[] = 
    {
        0x000250F2
    };

    static _CharacterInfo _character0002F942 =
    {
        0x0002F942,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F942,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F942,
        0x0002F942,
        0x0002F942
    };

    static Char _decompositionMapping0002F943[] = 
    {
        0x00025119
    };

    static _CharacterInfo _character0002F943 =
    {
        0x0002F943,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F943,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F943,
        0x0002F943,
        0x0002F943
    };

    static Char _decompositionMapping0002F944[] = 
    {
        0x00025133
    };

    static _CharacterInfo _character0002F944 =
    {
        0x0002F944,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F944,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F944,
        0x0002F944,
        0x0002F944
    };

    static Char _decompositionMapping0002F945[] = 
    {
        0x0000771E
    };

    static _CharacterInfo _character0002F945 =
    {
        0x0002F945,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F945,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F945,
        0x0002F945,
        0x0002F945
    };

    static Char _decompositionMapping0002F946[] = 
    {
        0x0000771F
    };

    static _CharacterInfo _character0002F946 =
    {
        0x0002F946,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F946,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F946,
        0x0002F946,
        0x0002F946
    };

    static Char _decompositionMapping0002F947[] = 
    {
        0x0000771F
    };

    static _CharacterInfo _character0002F947 =
    {
        0x0002F947,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F947,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F947,
        0x0002F947,
        0x0002F947
    };

    static Char _decompositionMapping0002F948[] = 
    {
        0x0000774A
    };

    static _CharacterInfo _character0002F948 =
    {
        0x0002F948,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F948,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F948,
        0x0002F948,
        0x0002F948
    };

    static Char _decompositionMapping0002F949[] = 
    {
        0x00004039
    };

    static _CharacterInfo _character0002F949 =
    {
        0x0002F949,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F949,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F949,
        0x0002F949,
        0x0002F949
    };

    static Char _decompositionMapping0002F94A[] = 
    {
        0x0000778B
    };

    static _CharacterInfo _character0002F94A =
    {
        0x0002F94A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94A,
        0x0002F94A,
        0x0002F94A
    };

    static Char _decompositionMapping0002F94B[] = 
    {
        0x00004046
    };

    static _CharacterInfo _character0002F94B =
    {
        0x0002F94B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94B,
        0x0002F94B,
        0x0002F94B
    };

    static Char _decompositionMapping0002F94C[] = 
    {
        0x00004096
    };

    static _CharacterInfo _character0002F94C =
    {
        0x0002F94C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94C,
        0x0002F94C,
        0x0002F94C
    };

    static Char _decompositionMapping0002F94D[] = 
    {
        0x0002541D
    };

    static _CharacterInfo _character0002F94D =
    {
        0x0002F94D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94D,
        0x0002F94D,
        0x0002F94D
    };

    static Char _decompositionMapping0002F94E[] = 
    {
        0x0000784E
    };

    static _CharacterInfo _character0002F94E =
    {
        0x0002F94E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94E,
        0x0002F94E,
        0x0002F94E
    };

    static Char _decompositionMapping0002F94F[] = 
    {
        0x0000788C
    };

    static _CharacterInfo _character0002F94F =
    {
        0x0002F94F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F94F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F94F,
        0x0002F94F,
        0x0002F94F
    };

    static Char _decompositionMapping0002F950[] = 
    {
        0x000078CC
    };

    static _CharacterInfo _character0002F950 =
    {
        0x0002F950,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F950,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F950,
        0x0002F950,
        0x0002F950
    };

    static Char _decompositionMapping0002F951[] = 
    {
        0x000040E3
    };

    static _CharacterInfo _character0002F951 =
    {
        0x0002F951,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F951,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F951,
        0x0002F951,
        0x0002F951
    };

    static Char _decompositionMapping0002F952[] = 
    {
        0x00025626
    };

    static _CharacterInfo _character0002F952 =
    {
        0x0002F952,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F952,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F952,
        0x0002F952,
        0x0002F952
    };

    static Char _decompositionMapping0002F953[] = 
    {
        0x00007956
    };

    static _CharacterInfo _character0002F953 =
    {
        0x0002F953,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F953,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F953,
        0x0002F953,
        0x0002F953
    };

    static Char _decompositionMapping0002F954[] = 
    {
        0x0002569A
    };

    static _CharacterInfo _character0002F954 =
    {
        0x0002F954,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F954,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F954,
        0x0002F954,
        0x0002F954
    };

    static Char _decompositionMapping0002F955[] = 
    {
        0x000256C5
    };

    static _CharacterInfo _character0002F955 =
    {
        0x0002F955,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F955,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F955,
        0x0002F955,
        0x0002F955
    };

    static Char _decompositionMapping0002F956[] = 
    {
        0x0000798F
    };

    static _CharacterInfo _character0002F956 =
    {
        0x0002F956,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F956,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F956,
        0x0002F956,
        0x0002F956
    };

    static Char _decompositionMapping0002F957[] = 
    {
        0x000079EB
    };

    static _CharacterInfo _character0002F957 =
    {
        0x0002F957,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F957,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F957,
        0x0002F957,
        0x0002F957
    };

    static Char _decompositionMapping0002F958[] = 
    {
        0x0000412F
    };

    static _CharacterInfo _character0002F958 =
    {
        0x0002F958,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F958,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F958,
        0x0002F958,
        0x0002F958
    };

    static Char _decompositionMapping0002F959[] = 
    {
        0x00007A40
    };

    static _CharacterInfo _character0002F959 =
    {
        0x0002F959,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F959,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F959,
        0x0002F959,
        0x0002F959
    };

    static Char _decompositionMapping0002F95A[] = 
    {
        0x00007A4A
    };

    static _CharacterInfo _character0002F95A =
    {
        0x0002F95A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95A,
        0x0002F95A,
        0x0002F95A
    };

    static Char _decompositionMapping0002F95B[] = 
    {
        0x00007A4F
    };

    static _CharacterInfo _character0002F95B =
    {
        0x0002F95B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95B,
        0x0002F95B,
        0x0002F95B
    };

    static Char _decompositionMapping0002F95C[] = 
    {
        0x0002597C
    };

    static _CharacterInfo _character0002F95C =
    {
        0x0002F95C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95C,
        0x0002F95C,
        0x0002F95C
    };

    static Char _decompositionMapping0002F95D[] = 
    {
        0x00025AA7
    };

    static _CharacterInfo _character0002F95D =
    {
        0x0002F95D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95D,
        0x0002F95D,
        0x0002F95D
    };

    static Char _decompositionMapping0002F95E[] = 
    {
        0x00025AA7
    };

    static _CharacterInfo _character0002F95E =
    {
        0x0002F95E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95E,
        0x0002F95E,
        0x0002F95E
    };

    static Char _decompositionMapping0002F95F[] = 
    {
        0x00007AEE
    };

    static _CharacterInfo _character0002F95F =
    {
        0x0002F95F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F95F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F95F,
        0x0002F95F,
        0x0002F95F
    };

    static Char _decompositionMapping0002F960[] = 
    {
        0x00004202
    };

    static _CharacterInfo _character0002F960 =
    {
        0x0002F960,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F960,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F960,
        0x0002F960,
        0x0002F960
    };

    static Char _decompositionMapping0002F961[] = 
    {
        0x00025BAB
    };

    static _CharacterInfo _character0002F961 =
    {
        0x0002F961,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F961,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F961,
        0x0002F961,
        0x0002F961
    };

    static Char _decompositionMapping0002F962[] = 
    {
        0x00007BC6
    };

    static _CharacterInfo _character0002F962 =
    {
        0x0002F962,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F962,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F962,
        0x0002F962,
        0x0002F962
    };

    static Char _decompositionMapping0002F963[] = 
    {
        0x00007BC9
    };

    static _CharacterInfo _character0002F963 =
    {
        0x0002F963,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F963,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F963,
        0x0002F963,
        0x0002F963
    };

    static Char _decompositionMapping0002F964[] = 
    {
        0x00004227
    };

    static _CharacterInfo _character0002F964 =
    {
        0x0002F964,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F964,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F964,
        0x0002F964,
        0x0002F964
    };

    static Char _decompositionMapping0002F965[] = 
    {
        0x00025C80
    };

    static _CharacterInfo _character0002F965 =
    {
        0x0002F965,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F965,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F965,
        0x0002F965,
        0x0002F965
    };

    static Char _decompositionMapping0002F966[] = 
    {
        0x00007CD2
    };

    static _CharacterInfo _character0002F966 =
    {
        0x0002F966,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F966,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F966,
        0x0002F966,
        0x0002F966
    };

    static Char _decompositionMapping0002F967[] = 
    {
        0x000042A0
    };

    static _CharacterInfo _character0002F967 =
    {
        0x0002F967,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F967,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F967,
        0x0002F967,
        0x0002F967
    };

    static Char _decompositionMapping0002F968[] = 
    {
        0x00007CE8
    };

    static _CharacterInfo _character0002F968 =
    {
        0x0002F968,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F968,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F968,
        0x0002F968,
        0x0002F968
    };

    static Char _decompositionMapping0002F969[] = 
    {
        0x00007CE3
    };

    static _CharacterInfo _character0002F969 =
    {
        0x0002F969,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F969,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F969,
        0x0002F969,
        0x0002F969
    };

    static Char _decompositionMapping0002F96A[] = 
    {
        0x00007D00
    };

    static _CharacterInfo _character0002F96A =
    {
        0x0002F96A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96A,
        0x0002F96A,
        0x0002F96A
    };

    static Char _decompositionMapping0002F96B[] = 
    {
        0x00025F86
    };

    static _CharacterInfo _character0002F96B =
    {
        0x0002F96B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96B,
        0x0002F96B,
        0x0002F96B
    };

    static Char _decompositionMapping0002F96C[] = 
    {
        0x00007D63
    };

    static _CharacterInfo _character0002F96C =
    {
        0x0002F96C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96C,
        0x0002F96C,
        0x0002F96C
    };

    static Char _decompositionMapping0002F96D[] = 
    {
        0x00004301
    };

    static _CharacterInfo _character0002F96D =
    {
        0x0002F96D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96D,
        0x0002F96D,
        0x0002F96D
    };

    static Char _decompositionMapping0002F96E[] = 
    {
        0x00007DC7
    };

    static _CharacterInfo _character0002F96E =
    {
        0x0002F96E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96E,
        0x0002F96E,
        0x0002F96E
    };

    static Char _decompositionMapping0002F96F[] = 
    {
        0x00007E02
    };

    static _CharacterInfo _character0002F96F =
    {
        0x0002F96F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F96F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F96F,
        0x0002F96F,
        0x0002F96F
    };

    static Char _decompositionMapping0002F970[] = 
    {
        0x00007E45
    };

    static _CharacterInfo _character0002F970 =
    {
        0x0002F970,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F970,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F970,
        0x0002F970,
        0x0002F970
    };

    static Char _decompositionMapping0002F971[] = 
    {
        0x00004334
    };

    static _CharacterInfo _character0002F971 =
    {
        0x0002F971,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F971,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F971,
        0x0002F971,
        0x0002F971
    };

    static Char _decompositionMapping0002F972[] = 
    {
        0x00026228
    };

    static _CharacterInfo _character0002F972 =
    {
        0x0002F972,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F972,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F972,
        0x0002F972,
        0x0002F972
    };

    static Char _decompositionMapping0002F973[] = 
    {
        0x00026247
    };

    static _CharacterInfo _character0002F973 =
    {
        0x0002F973,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F973,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F973,
        0x0002F973,
        0x0002F973
    };

    static Char _decompositionMapping0002F974[] = 
    {
        0x00004359
    };

    static _CharacterInfo _character0002F974 =
    {
        0x0002F974,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F974,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F974,
        0x0002F974,
        0x0002F974
    };

    static Char _decompositionMapping0002F975[] = 
    {
        0x000262D9
    };

    static _CharacterInfo _character0002F975 =
    {
        0x0002F975,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F975,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F975,
        0x0002F975,
        0x0002F975
    };

    static Char _decompositionMapping0002F976[] = 
    {
        0x00007F7A
    };

    static _CharacterInfo _character0002F976 =
    {
        0x0002F976,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F976,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F976,
        0x0002F976,
        0x0002F976
    };

    static Char _decompositionMapping0002F977[] = 
    {
        0x0002633E
    };

    static _CharacterInfo _character0002F977 =
    {
        0x0002F977,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F977,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F977,
        0x0002F977,
        0x0002F977
    };

    static Char _decompositionMapping0002F978[] = 
    {
        0x00007F95
    };

    static _CharacterInfo _character0002F978 =
    {
        0x0002F978,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F978,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F978,
        0x0002F978,
        0x0002F978
    };

    static Char _decompositionMapping0002F979[] = 
    {
        0x00007FFA
    };

    static _CharacterInfo _character0002F979 =
    {
        0x0002F979,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F979,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F979,
        0x0002F979,
        0x0002F979
    };

    static Char _decompositionMapping0002F97A[] = 
    {
        0x00008005
    };

    static _CharacterInfo _character0002F97A =
    {
        0x0002F97A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97A,
        0x0002F97A,
        0x0002F97A
    };

    static Char _decompositionMapping0002F97B[] = 
    {
        0x000264DA
    };

    static _CharacterInfo _character0002F97B =
    {
        0x0002F97B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97B,
        0x0002F97B,
        0x0002F97B
    };

    static Char _decompositionMapping0002F97C[] = 
    {
        0x00026523
    };

    static _CharacterInfo _character0002F97C =
    {
        0x0002F97C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97C,
        0x0002F97C,
        0x0002F97C
    };

    static Char _decompositionMapping0002F97D[] = 
    {
        0x00008060
    };

    static _CharacterInfo _character0002F97D =
    {
        0x0002F97D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97D,
        0x0002F97D,
        0x0002F97D
    };

    static Char _decompositionMapping0002F97E[] = 
    {
        0x000265A8
    };

    static _CharacterInfo _character0002F97E =
    {
        0x0002F97E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97E,
        0x0002F97E,
        0x0002F97E
    };

    static Char _decompositionMapping0002F97F[] = 
    {
        0x00008070
    };

    static _CharacterInfo _character0002F97F =
    {
        0x0002F97F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F97F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F97F,
        0x0002F97F,
        0x0002F97F
    };

    static Char _decompositionMapping0002F980[] = 
    {
        0x0002335F
    };

    static _CharacterInfo _character0002F980 =
    {
        0x0002F980,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F980,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F980,
        0x0002F980,
        0x0002F980
    };

    static Char _decompositionMapping0002F981[] = 
    {
        0x000043D5
    };

    static _CharacterInfo _character0002F981 =
    {
        0x0002F981,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F981,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F981,
        0x0002F981,
        0x0002F981
    };

    static Char _decompositionMapping0002F982[] = 
    {
        0x000080B2
    };

    static _CharacterInfo _character0002F982 =
    {
        0x0002F982,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F982,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F982,
        0x0002F982,
        0x0002F982
    };

    static Char _decompositionMapping0002F983[] = 
    {
        0x00008103
    };

    static _CharacterInfo _character0002F983 =
    {
        0x0002F983,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F983,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F983,
        0x0002F983,
        0x0002F983
    };

    static Char _decompositionMapping0002F984[] = 
    {
        0x0000440B
    };

    static _CharacterInfo _character0002F984 =
    {
        0x0002F984,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F984,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F984,
        0x0002F984,
        0x0002F984
    };

    static Char _decompositionMapping0002F985[] = 
    {
        0x0000813E
    };

    static _CharacterInfo _character0002F985 =
    {
        0x0002F985,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F985,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F985,
        0x0002F985,
        0x0002F985
    };

    static Char _decompositionMapping0002F986[] = 
    {
        0x00005AB5
    };

    static _CharacterInfo _character0002F986 =
    {
        0x0002F986,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F986,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F986,
        0x0002F986,
        0x0002F986
    };

    static Char _decompositionMapping0002F987[] = 
    {
        0x000267A7
    };

    static _CharacterInfo _character0002F987 =
    {
        0x0002F987,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F987,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F987,
        0x0002F987,
        0x0002F987
    };

    static Char _decompositionMapping0002F988[] = 
    {
        0x000267B5
    };

    static _CharacterInfo _character0002F988 =
    {
        0x0002F988,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F988,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F988,
        0x0002F988,
        0x0002F988
    };

    static Char _decompositionMapping0002F989[] = 
    {
        0x00023393
    };

    static _CharacterInfo _character0002F989 =
    {
        0x0002F989,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F989,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F989,
        0x0002F989,
        0x0002F989
    };

    static Char _decompositionMapping0002F98A[] = 
    {
        0x0002339C
    };

    static _CharacterInfo _character0002F98A =
    {
        0x0002F98A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98A,
        0x0002F98A,
        0x0002F98A
    };

    static Char _decompositionMapping0002F98B[] = 
    {
        0x00008201
    };

    static _CharacterInfo _character0002F98B =
    {
        0x0002F98B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98B,
        0x0002F98B,
        0x0002F98B
    };

    static Char _decompositionMapping0002F98C[] = 
    {
        0x00008204
    };

    static _CharacterInfo _character0002F98C =
    {
        0x0002F98C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98C,
        0x0002F98C,
        0x0002F98C
    };

    static Char _decompositionMapping0002F98D[] = 
    {
        0x00008F9E
    };

    static _CharacterInfo _character0002F98D =
    {
        0x0002F98D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98D,
        0x0002F98D,
        0x0002F98D
    };

    static Char _decompositionMapping0002F98E[] = 
    {
        0x0000446B
    };

    static _CharacterInfo _character0002F98E =
    {
        0x0002F98E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98E,
        0x0002F98E,
        0x0002F98E
    };

    static Char _decompositionMapping0002F98F[] = 
    {
        0x00008291
    };

    static _CharacterInfo _character0002F98F =
    {
        0x0002F98F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F98F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F98F,
        0x0002F98F,
        0x0002F98F
    };

    static Char _decompositionMapping0002F990[] = 
    {
        0x0000828B
    };

    static _CharacterInfo _character0002F990 =
    {
        0x0002F990,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F990,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F990,
        0x0002F990,
        0x0002F990
    };

    static Char _decompositionMapping0002F991[] = 
    {
        0x0000829D
    };

    static _CharacterInfo _character0002F991 =
    {
        0x0002F991,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F991,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F991,
        0x0002F991,
        0x0002F991
    };

    static Char _decompositionMapping0002F992[] = 
    {
        0x000052B3
    };

    static _CharacterInfo _character0002F992 =
    {
        0x0002F992,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F992,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F992,
        0x0002F992,
        0x0002F992
    };

    static Char _decompositionMapping0002F993[] = 
    {
        0x000082B1
    };

    static _CharacterInfo _character0002F993 =
    {
        0x0002F993,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F993,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F993,
        0x0002F993,
        0x0002F993
    };

    static Char _decompositionMapping0002F994[] = 
    {
        0x000082B3
    };

    static _CharacterInfo _character0002F994 =
    {
        0x0002F994,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F994,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F994,
        0x0002F994,
        0x0002F994
    };

    static Char _decompositionMapping0002F995[] = 
    {
        0x000082BD
    };

    static _CharacterInfo _character0002F995 =
    {
        0x0002F995,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F995,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F995,
        0x0002F995,
        0x0002F995
    };

    static Char _decompositionMapping0002F996[] = 
    {
        0x000082E6
    };

    static _CharacterInfo _character0002F996 =
    {
        0x0002F996,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F996,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F996,
        0x0002F996,
        0x0002F996
    };

    static Char _decompositionMapping0002F997[] = 
    {
        0x00026B3C
    };

    static _CharacterInfo _character0002F997 =
    {
        0x0002F997,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F997,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F997,
        0x0002F997,
        0x0002F997
    };

    static Char _decompositionMapping0002F998[] = 
    {
        0x000082E5
    };

    static _CharacterInfo _character0002F998 =
    {
        0x0002F998,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F998,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F998,
        0x0002F998,
        0x0002F998
    };

    static Char _decompositionMapping0002F999[] = 
    {
        0x0000831D
    };

    static _CharacterInfo _character0002F999 =
    {
        0x0002F999,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F999,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F999,
        0x0002F999,
        0x0002F999
    };

    static Char _decompositionMapping0002F99A[] = 
    {
        0x00008363
    };

    static _CharacterInfo _character0002F99A =
    {
        0x0002F99A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99A,
        0x0002F99A,
        0x0002F99A
    };

    static Char _decompositionMapping0002F99B[] = 
    {
        0x000083AD
    };

    static _CharacterInfo _character0002F99B =
    {
        0x0002F99B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99B,
        0x0002F99B,
        0x0002F99B
    };

    static Char _decompositionMapping0002F99C[] = 
    {
        0x00008323
    };

    static _CharacterInfo _character0002F99C =
    {
        0x0002F99C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99C,
        0x0002F99C,
        0x0002F99C
    };

    static Char _decompositionMapping0002F99D[] = 
    {
        0x000083BD
    };

    static _CharacterInfo _character0002F99D =
    {
        0x0002F99D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99D,
        0x0002F99D,
        0x0002F99D
    };

    static Char _decompositionMapping0002F99E[] = 
    {
        0x000083E7
    };

    static _CharacterInfo _character0002F99E =
    {
        0x0002F99E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99E,
        0x0002F99E,
        0x0002F99E
    };

    static Char _decompositionMapping0002F99F[] = 
    {
        0x00008457
    };

    static _CharacterInfo _character0002F99F =
    {
        0x0002F99F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F99F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F99F,
        0x0002F99F,
        0x0002F99F
    };

    static Char _decompositionMapping0002F9A0[] = 
    {
        0x00008353
    };

    static _CharacterInfo _character0002F9A0 =
    {
        0x0002F9A0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A0,
        0x0002F9A0,
        0x0002F9A0
    };

    static Char _decompositionMapping0002F9A1[] = 
    {
        0x000083CA
    };

    static _CharacterInfo _character0002F9A1 =
    {
        0x0002F9A1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A1,
        0x0002F9A1,
        0x0002F9A1
    };

    static Char _decompositionMapping0002F9A2[] = 
    {
        0x000083CC
    };

    static _CharacterInfo _character0002F9A2 =
    {
        0x0002F9A2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A2,
        0x0002F9A2,
        0x0002F9A2
    };

    static Char _decompositionMapping0002F9A3[] = 
    {
        0x000083DC
    };

    static _CharacterInfo _character0002F9A3 =
    {
        0x0002F9A3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A3,
        0x0002F9A3,
        0x0002F9A3
    };

    static Char _decompositionMapping0002F9A4[] = 
    {
        0x00026C36
    };

    static _CharacterInfo _character0002F9A4 =
    {
        0x0002F9A4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A4,
        0x0002F9A4,
        0x0002F9A4
    };

    static Char _decompositionMapping0002F9A5[] = 
    {
        0x00026D6B
    };

    static _CharacterInfo _character0002F9A5 =
    {
        0x0002F9A5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A5,
        0x0002F9A5,
        0x0002F9A5
    };

    static Char _decompositionMapping0002F9A6[] = 
    {
        0x00026CD5
    };

    static _CharacterInfo _character0002F9A6 =
    {
        0x0002F9A6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A6,
        0x0002F9A6,
        0x0002F9A6
    };

    static Char _decompositionMapping0002F9A7[] = 
    {
        0x0000452B
    };

    static _CharacterInfo _character0002F9A7 =
    {
        0x0002F9A7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A7,
        0x0002F9A7,
        0x0002F9A7
    };

    static Char _decompositionMapping0002F9A8[] = 
    {
        0x000084F1
    };

    static _CharacterInfo _character0002F9A8 =
    {
        0x0002F9A8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A8,
        0x0002F9A8,
        0x0002F9A8
    };

    static Char _decompositionMapping0002F9A9[] = 
    {
        0x000084F3
    };

    static _CharacterInfo _character0002F9A9 =
    {
        0x0002F9A9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9A9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9A9,
        0x0002F9A9,
        0x0002F9A9
    };

    static Char _decompositionMapping0002F9AA[] = 
    {
        0x00008516
    };

    static _CharacterInfo _character0002F9AA =
    {
        0x0002F9AA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AA,
        0x0002F9AA,
        0x0002F9AA
    };

    static Char _decompositionMapping0002F9AB[] = 
    {
        0x000273CA
    };

    static _CharacterInfo _character0002F9AB =
    {
        0x0002F9AB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AB,
        0x0002F9AB,
        0x0002F9AB
    };

    static Char _decompositionMapping0002F9AC[] = 
    {
        0x00008564
    };

    static _CharacterInfo _character0002F9AC =
    {
        0x0002F9AC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AC,
        0x0002F9AC,
        0x0002F9AC
    };

    static Char _decompositionMapping0002F9AD[] = 
    {
        0x00026F2C
    };

    static _CharacterInfo _character0002F9AD =
    {
        0x0002F9AD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AD,
        0x0002F9AD,
        0x0002F9AD
    };

    static Char _decompositionMapping0002F9AE[] = 
    {
        0x0000455D
    };

    static _CharacterInfo _character0002F9AE =
    {
        0x0002F9AE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AE,
        0x0002F9AE,
        0x0002F9AE
    };

    static Char _decompositionMapping0002F9AF[] = 
    {
        0x00004561
    };

    static _CharacterInfo _character0002F9AF =
    {
        0x0002F9AF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9AF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9AF,
        0x0002F9AF,
        0x0002F9AF
    };

    static Char _decompositionMapping0002F9B0[] = 
    {
        0x00026FB1
    };

    static _CharacterInfo _character0002F9B0 =
    {
        0x0002F9B0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B0,
        0x0002F9B0,
        0x0002F9B0
    };

    static Char _decompositionMapping0002F9B1[] = 
    {
        0x000270D2
    };

    static _CharacterInfo _character0002F9B1 =
    {
        0x0002F9B1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B1,
        0x0002F9B1,
        0x0002F9B1
    };

    static Char _decompositionMapping0002F9B2[] = 
    {
        0x0000456B
    };

    static _CharacterInfo _character0002F9B2 =
    {
        0x0002F9B2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B2,
        0x0002F9B2,
        0x0002F9B2
    };

    static Char _decompositionMapping0002F9B3[] = 
    {
        0x00008650
    };

    static _CharacterInfo _character0002F9B3 =
    {
        0x0002F9B3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B3,
        0x0002F9B3,
        0x0002F9B3
    };

    static Char _decompositionMapping0002F9B4[] = 
    {
        0x0000865C
    };

    static _CharacterInfo _character0002F9B4 =
    {
        0x0002F9B4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B4,
        0x0002F9B4,
        0x0002F9B4
    };

    static Char _decompositionMapping0002F9B5[] = 
    {
        0x00008667
    };

    static _CharacterInfo _character0002F9B5 =
    {
        0x0002F9B5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B5,
        0x0002F9B5,
        0x0002F9B5
    };

    static Char _decompositionMapping0002F9B6[] = 
    {
        0x00008669
    };

    static _CharacterInfo _character0002F9B6 =
    {
        0x0002F9B6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B6,
        0x0002F9B6,
        0x0002F9B6
    };

    static Char _decompositionMapping0002F9B7[] = 
    {
        0x000086A9
    };

    static _CharacterInfo _character0002F9B7 =
    {
        0x0002F9B7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B7,
        0x0002F9B7,
        0x0002F9B7
    };

    static Char _decompositionMapping0002F9B8[] = 
    {
        0x00008688
    };

    static _CharacterInfo _character0002F9B8 =
    {
        0x0002F9B8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B8,
        0x0002F9B8,
        0x0002F9B8
    };

    static Char _decompositionMapping0002F9B9[] = 
    {
        0x0000870E
    };

    static _CharacterInfo _character0002F9B9 =
    {
        0x0002F9B9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9B9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9B9,
        0x0002F9B9,
        0x0002F9B9
    };

    static Char _decompositionMapping0002F9BA[] = 
    {
        0x000086E2
    };

    static _CharacterInfo _character0002F9BA =
    {
        0x0002F9BA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BA,
        0x0002F9BA,
        0x0002F9BA
    };

    static Char _decompositionMapping0002F9BB[] = 
    {
        0x00008779
    };

    static _CharacterInfo _character0002F9BB =
    {
        0x0002F9BB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BB,
        0x0002F9BB,
        0x0002F9BB
    };

    static Char _decompositionMapping0002F9BC[] = 
    {
        0x00008728
    };

    static _CharacterInfo _character0002F9BC =
    {
        0x0002F9BC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BC,
        0x0002F9BC,
        0x0002F9BC
    };

    static Char _decompositionMapping0002F9BD[] = 
    {
        0x0000876B
    };

    static _CharacterInfo _character0002F9BD =
    {
        0x0002F9BD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BD,
        0x0002F9BD,
        0x0002F9BD
    };

    static Char _decompositionMapping0002F9BE[] = 
    {
        0x00008786
    };

    static _CharacterInfo _character0002F9BE =
    {
        0x0002F9BE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BE,
        0x0002F9BE,
        0x0002F9BE
    };

    static Char _decompositionMapping0002F9BF[] = 
    {
        0x000045D7
    };

    static _CharacterInfo _character0002F9BF =
    {
        0x0002F9BF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9BF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9BF,
        0x0002F9BF,
        0x0002F9BF
    };

    static Char _decompositionMapping0002F9C0[] = 
    {
        0x000087E1
    };

    static _CharacterInfo _character0002F9C0 =
    {
        0x0002F9C0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C0,
        0x0002F9C0,
        0x0002F9C0
    };

    static Char _decompositionMapping0002F9C1[] = 
    {
        0x00008801
    };

    static _CharacterInfo _character0002F9C1 =
    {
        0x0002F9C1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C1,
        0x0002F9C1,
        0x0002F9C1
    };

    static Char _decompositionMapping0002F9C2[] = 
    {
        0x000045F9
    };

    static _CharacterInfo _character0002F9C2 =
    {
        0x0002F9C2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C2,
        0x0002F9C2,
        0x0002F9C2
    };

    static Char _decompositionMapping0002F9C3[] = 
    {
        0x00008860
    };

    static _CharacterInfo _character0002F9C3 =
    {
        0x0002F9C3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C3,
        0x0002F9C3,
        0x0002F9C3
    };

    static Char _decompositionMapping0002F9C4[] = 
    {
        0x00008863
    };

    static _CharacterInfo _character0002F9C4 =
    {
        0x0002F9C4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C4,
        0x0002F9C4,
        0x0002F9C4
    };

    static Char _decompositionMapping0002F9C5[] = 
    {
        0x00027667
    };

    static _CharacterInfo _character0002F9C5 =
    {
        0x0002F9C5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C5,
        0x0002F9C5,
        0x0002F9C5
    };

    static Char _decompositionMapping0002F9C6[] = 
    {
        0x000088D7
    };

    static _CharacterInfo _character0002F9C6 =
    {
        0x0002F9C6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C6,
        0x0002F9C6,
        0x0002F9C6
    };

    static Char _decompositionMapping0002F9C7[] = 
    {
        0x000088DE
    };

    static _CharacterInfo _character0002F9C7 =
    {
        0x0002F9C7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C7,
        0x0002F9C7,
        0x0002F9C7
    };

    static Char _decompositionMapping0002F9C8[] = 
    {
        0x00004635
    };

    static _CharacterInfo _character0002F9C8 =
    {
        0x0002F9C8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C8,
        0x0002F9C8,
        0x0002F9C8
    };

    static Char _decompositionMapping0002F9C9[] = 
    {
        0x000088FA
    };

    static _CharacterInfo _character0002F9C9 =
    {
        0x0002F9C9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9C9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9C9,
        0x0002F9C9,
        0x0002F9C9
    };

    static Char _decompositionMapping0002F9CA[] = 
    {
        0x000034BB
    };

    static _CharacterInfo _character0002F9CA =
    {
        0x0002F9CA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CA,
        0x0002F9CA,
        0x0002F9CA
    };

    static Char _decompositionMapping0002F9CB[] = 
    {
        0x000278AE
    };

    static _CharacterInfo _character0002F9CB =
    {
        0x0002F9CB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CB,
        0x0002F9CB,
        0x0002F9CB
    };

    static Char _decompositionMapping0002F9CC[] = 
    {
        0x00027966
    };

    static _CharacterInfo _character0002F9CC =
    {
        0x0002F9CC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CC,
        0x0002F9CC,
        0x0002F9CC
    };

    static Char _decompositionMapping0002F9CD[] = 
    {
        0x000046BE
    };

    static _CharacterInfo _character0002F9CD =
    {
        0x0002F9CD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CD,
        0x0002F9CD,
        0x0002F9CD
    };

    static Char _decompositionMapping0002F9CE[] = 
    {
        0x000046C7
    };

    static _CharacterInfo _character0002F9CE =
    {
        0x0002F9CE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CE,
        0x0002F9CE,
        0x0002F9CE
    };

    static Char _decompositionMapping0002F9CF[] = 
    {
        0x00008AA0
    };

    static _CharacterInfo _character0002F9CF =
    {
        0x0002F9CF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9CF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9CF,
        0x0002F9CF,
        0x0002F9CF
    };

    static Char _decompositionMapping0002F9D0[] = 
    {
        0x00008AED
    };

    static _CharacterInfo _character0002F9D0 =
    {
        0x0002F9D0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D0,
        0x0002F9D0,
        0x0002F9D0
    };

    static Char _decompositionMapping0002F9D1[] = 
    {
        0x00008B8A
    };

    static _CharacterInfo _character0002F9D1 =
    {
        0x0002F9D1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D1,
        0x0002F9D1,
        0x0002F9D1
    };

    static Char _decompositionMapping0002F9D2[] = 
    {
        0x00008C55
    };

    static _CharacterInfo _character0002F9D2 =
    {
        0x0002F9D2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D2,
        0x0002F9D2,
        0x0002F9D2
    };

    static Char _decompositionMapping0002F9D3[] = 
    {
        0x00027CA8
    };

    static _CharacterInfo _character0002F9D3 =
    {
        0x0002F9D3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D3,
        0x0002F9D3,
        0x0002F9D3
    };

    static Char _decompositionMapping0002F9D4[] = 
    {
        0x00008CAB
    };

    static _CharacterInfo _character0002F9D4 =
    {
        0x0002F9D4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D4,
        0x0002F9D4,
        0x0002F9D4
    };

    static Char _decompositionMapping0002F9D5[] = 
    {
        0x00008CC1
    };

    static _CharacterInfo _character0002F9D5 =
    {
        0x0002F9D5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D5,
        0x0002F9D5,
        0x0002F9D5
    };

    static Char _decompositionMapping0002F9D6[] = 
    {
        0x00008D1B
    };

    static _CharacterInfo _character0002F9D6 =
    {
        0x0002F9D6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D6,
        0x0002F9D6,
        0x0002F9D6
    };

    static Char _decompositionMapping0002F9D7[] = 
    {
        0x00008D77
    };

    static _CharacterInfo _character0002F9D7 =
    {
        0x0002F9D7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D7,
        0x0002F9D7,
        0x0002F9D7
    };

    static Char _decompositionMapping0002F9D8[] = 
    {
        0x00027F2F
    };

    static _CharacterInfo _character0002F9D8 =
    {
        0x0002F9D8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D8,
        0x0002F9D8,
        0x0002F9D8
    };

    static Char _decompositionMapping0002F9D9[] = 
    {
        0x00020804
    };

    static _CharacterInfo _character0002F9D9 =
    {
        0x0002F9D9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9D9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9D9,
        0x0002F9D9,
        0x0002F9D9
    };

    static Char _decompositionMapping0002F9DA[] = 
    {
        0x00008DCB
    };

    static _CharacterInfo _character0002F9DA =
    {
        0x0002F9DA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DA,
        0x0002F9DA,
        0x0002F9DA
    };

    static Char _decompositionMapping0002F9DB[] = 
    {
        0x00008DBC
    };

    static _CharacterInfo _character0002F9DB =
    {
        0x0002F9DB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DB,
        0x0002F9DB,
        0x0002F9DB
    };

    static Char _decompositionMapping0002F9DC[] = 
    {
        0x00008DF0
    };

    static _CharacterInfo _character0002F9DC =
    {
        0x0002F9DC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DC,
        0x0002F9DC,
        0x0002F9DC
    };

    static Char _decompositionMapping0002F9DD[] = 
    {
        0x000208DE
    };

    static _CharacterInfo _character0002F9DD =
    {
        0x0002F9DD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DD,
        0x0002F9DD,
        0x0002F9DD
    };

    static Char _decompositionMapping0002F9DE[] = 
    {
        0x00008ED4
    };

    static _CharacterInfo _character0002F9DE =
    {
        0x0002F9DE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DE,
        0x0002F9DE,
        0x0002F9DE
    };

    static Char _decompositionMapping0002F9DF[] = 
    {
        0x00008F38
    };

    static _CharacterInfo _character0002F9DF =
    {
        0x0002F9DF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9DF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9DF,
        0x0002F9DF,
        0x0002F9DF
    };

    static Char _decompositionMapping0002F9E0[] = 
    {
        0x000285D2
    };

    static _CharacterInfo _character0002F9E0 =
    {
        0x0002F9E0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E0,
        0x0002F9E0,
        0x0002F9E0
    };

    static Char _decompositionMapping0002F9E1[] = 
    {
        0x000285ED
    };

    static _CharacterInfo _character0002F9E1 =
    {
        0x0002F9E1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E1,
        0x0002F9E1,
        0x0002F9E1
    };

    static Char _decompositionMapping0002F9E2[] = 
    {
        0x00009094
    };

    static _CharacterInfo _character0002F9E2 =
    {
        0x0002F9E2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E2,
        0x0002F9E2,
        0x0002F9E2
    };

    static Char _decompositionMapping0002F9E3[] = 
    {
        0x000090F1
    };

    static _CharacterInfo _character0002F9E3 =
    {
        0x0002F9E3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E3,
        0x0002F9E3,
        0x0002F9E3
    };

    static Char _decompositionMapping0002F9E4[] = 
    {
        0x00009111
    };

    static _CharacterInfo _character0002F9E4 =
    {
        0x0002F9E4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E4,
        0x0002F9E4,
        0x0002F9E4
    };

    static Char _decompositionMapping0002F9E5[] = 
    {
        0x0002872E
    };

    static _CharacterInfo _character0002F9E5 =
    {
        0x0002F9E5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E5,
        0x0002F9E5,
        0x0002F9E5
    };

    static Char _decompositionMapping0002F9E6[] = 
    {
        0x0000911B
    };

    static _CharacterInfo _character0002F9E6 =
    {
        0x0002F9E6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E6,
        0x0002F9E6,
        0x0002F9E6
    };

    static Char _decompositionMapping0002F9E7[] = 
    {
        0x00009238
    };

    static _CharacterInfo _character0002F9E7 =
    {
        0x0002F9E7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E7,
        0x0002F9E7,
        0x0002F9E7
    };

    static Char _decompositionMapping0002F9E8[] = 
    {
        0x000092D7
    };

    static _CharacterInfo _character0002F9E8 =
    {
        0x0002F9E8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E8,
        0x0002F9E8,
        0x0002F9E8
    };

    static Char _decompositionMapping0002F9E9[] = 
    {
        0x000092D8
    };

    static _CharacterInfo _character0002F9E9 =
    {
        0x0002F9E9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9E9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9E9,
        0x0002F9E9,
        0x0002F9E9
    };

    static Char _decompositionMapping0002F9EA[] = 
    {
        0x0000927C
    };

    static _CharacterInfo _character0002F9EA =
    {
        0x0002F9EA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9EA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9EA,
        0x0002F9EA,
        0x0002F9EA
    };

    static Char _decompositionMapping0002F9EB[] = 
    {
        0x000093F9
    };

    static _CharacterInfo _character0002F9EB =
    {
        0x0002F9EB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9EB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9EB,
        0x0002F9EB,
        0x0002F9EB
    };

    static Char _decompositionMapping0002F9EC[] = 
    {
        0x00009415
    };

    static _CharacterInfo _character0002F9EC =
    {
        0x0002F9EC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9EC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9EC,
        0x0002F9EC,
        0x0002F9EC
    };

    static Char _decompositionMapping0002F9ED[] = 
    {
        0x00028BFA
    };

    static _CharacterInfo _character0002F9ED =
    {
        0x0002F9ED,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9ED,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9ED,
        0x0002F9ED,
        0x0002F9ED
    };

    static Char _decompositionMapping0002F9EE[] = 
    {
        0x0000958B
    };

    static _CharacterInfo _character0002F9EE =
    {
        0x0002F9EE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9EE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9EE,
        0x0002F9EE,
        0x0002F9EE
    };

    static Char _decompositionMapping0002F9EF[] = 
    {
        0x00004995
    };

    static _CharacterInfo _character0002F9EF =
    {
        0x0002F9EF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9EF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9EF,
        0x0002F9EF,
        0x0002F9EF
    };

    static Char _decompositionMapping0002F9F0[] = 
    {
        0x000095B7
    };

    static _CharacterInfo _character0002F9F0 =
    {
        0x0002F9F0,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F0,
        0x0002F9F0,
        0x0002F9F0
    };

    static Char _decompositionMapping0002F9F1[] = 
    {
        0x00028D77
    };

    static _CharacterInfo _character0002F9F1 =
    {
        0x0002F9F1,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F1,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F1,
        0x0002F9F1,
        0x0002F9F1
    };

    static Char _decompositionMapping0002F9F2[] = 
    {
        0x000049E6
    };

    static _CharacterInfo _character0002F9F2 =
    {
        0x0002F9F2,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F2,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F2,
        0x0002F9F2,
        0x0002F9F2
    };

    static Char _decompositionMapping0002F9F3[] = 
    {
        0x000096C3
    };

    static _CharacterInfo _character0002F9F3 =
    {
        0x0002F9F3,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F3,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F3,
        0x0002F9F3,
        0x0002F9F3
    };

    static Char _decompositionMapping0002F9F4[] = 
    {
        0x00005DB2
    };

    static _CharacterInfo _character0002F9F4 =
    {
        0x0002F9F4,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F4,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F4,
        0x0002F9F4,
        0x0002F9F4
    };

    static Char _decompositionMapping0002F9F5[] = 
    {
        0x00009723
    };

    static _CharacterInfo _character0002F9F5 =
    {
        0x0002F9F5,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F5,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F5,
        0x0002F9F5,
        0x0002F9F5
    };

    static Char _decompositionMapping0002F9F6[] = 
    {
        0x00029145
    };

    static _CharacterInfo _character0002F9F6 =
    {
        0x0002F9F6,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F6,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F6,
        0x0002F9F6,
        0x0002F9F6
    };

    static Char _decompositionMapping0002F9F7[] = 
    {
        0x0002921A
    };

    static _CharacterInfo _character0002F9F7 =
    {
        0x0002F9F7,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F7,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F7,
        0x0002F9F7,
        0x0002F9F7
    };

    static Char _decompositionMapping0002F9F8[] = 
    {
        0x00004A6E
    };

    static _CharacterInfo _character0002F9F8 =
    {
        0x0002F9F8,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F8,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F8,
        0x0002F9F8,
        0x0002F9F8
    };

    static Char _decompositionMapping0002F9F9[] = 
    {
        0x00004A76
    };

    static _CharacterInfo _character0002F9F9 =
    {
        0x0002F9F9,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9F9,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9F9,
        0x0002F9F9,
        0x0002F9F9
    };

    static Char _decompositionMapping0002F9FA[] = 
    {
        0x000097E0
    };

    static _CharacterInfo _character0002F9FA =
    {
        0x0002F9FA,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FA,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FA,
        0x0002F9FA,
        0x0002F9FA
    };

    static Char _decompositionMapping0002F9FB[] = 
    {
        0x0002940A
    };

    static _CharacterInfo _character0002F9FB =
    {
        0x0002F9FB,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FB,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FB,
        0x0002F9FB,
        0x0002F9FB
    };

    static Char _decompositionMapping0002F9FC[] = 
    {
        0x00004AB2
    };

    static _CharacterInfo _character0002F9FC =
    {
        0x0002F9FC,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FC,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FC,
        0x0002F9FC,
        0x0002F9FC
    };

    static Char _decompositionMapping0002F9FD[] = 
    {
        0x00029496
    };

    static _CharacterInfo _character0002F9FD =
    {
        0x0002F9FD,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FD,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FD,
        0x0002F9FD,
        0x0002F9FD
    };

    static Char _decompositionMapping0002F9FE[] = 
    {
        0x0000980B
    };

    static _CharacterInfo _character0002F9FE =
    {
        0x0002F9FE,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FE,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FE,
        0x0002F9FE,
        0x0002F9FE
    };

    static Char _decompositionMapping0002F9FF[] = 
    {
        0x0000980B
    };

    static _CharacterInfo _character0002F9FF =
    {
        0x0002F9FF,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002F9FF,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002F9FF,
        0x0002F9FF,
        0x0002F9FF
    };

    static Char _decompositionMapping0002FA00[] = 
    {
        0x00009829
    };

    static _CharacterInfo _character0002FA00 =
    {
        0x0002FA00,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA00,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA00,
        0x0002FA00,
        0x0002FA00
    };

    static Char _decompositionMapping0002FA01[] = 
    {
        0x000295B6
    };

    static _CharacterInfo _character0002FA01 =
    {
        0x0002FA01,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA01,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA01,
        0x0002FA01,
        0x0002FA01
    };

    static Char _decompositionMapping0002FA02[] = 
    {
        0x000098E2
    };

    static _CharacterInfo _character0002FA02 =
    {
        0x0002FA02,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA02,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA02,
        0x0002FA02,
        0x0002FA02
    };

    static Char _decompositionMapping0002FA03[] = 
    {
        0x00004B33
    };

    static _CharacterInfo _character0002FA03 =
    {
        0x0002FA03,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA03,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA03,
        0x0002FA03,
        0x0002FA03
    };

    static Char _decompositionMapping0002FA04[] = 
    {
        0x00009929
    };

    static _CharacterInfo _character0002FA04 =
    {
        0x0002FA04,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA04,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA04,
        0x0002FA04,
        0x0002FA04
    };

    static Char _decompositionMapping0002FA05[] = 
    {
        0x000099A7
    };

    static _CharacterInfo _character0002FA05 =
    {
        0x0002FA05,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA05,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA05,
        0x0002FA05,
        0x0002FA05
    };

    static Char _decompositionMapping0002FA06[] = 
    {
        0x000099C2
    };

    static _CharacterInfo _character0002FA06 =
    {
        0x0002FA06,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA06,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA06,
        0x0002FA06,
        0x0002FA06
    };

    static Char _decompositionMapping0002FA07[] = 
    {
        0x000099FE
    };

    static _CharacterInfo _character0002FA07 =
    {
        0x0002FA07,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA07,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA07,
        0x0002FA07,
        0x0002FA07
    };

    static Char _decompositionMapping0002FA08[] = 
    {
        0x00004BCE
    };

    static _CharacterInfo _character0002FA08 =
    {
        0x0002FA08,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA08,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA08,
        0x0002FA08,
        0x0002FA08
    };

    static Char _decompositionMapping0002FA09[] = 
    {
        0x00029B30
    };

    static _CharacterInfo _character0002FA09 =
    {
        0x0002FA09,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA09,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA09,
        0x0002FA09,
        0x0002FA09
    };

    static Char _decompositionMapping0002FA0A[] = 
    {
        0x00009B12
    };

    static _CharacterInfo _character0002FA0A =
    {
        0x0002FA0A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0A,
        0x0002FA0A,
        0x0002FA0A
    };

    static Char _decompositionMapping0002FA0B[] = 
    {
        0x00009C40
    };

    static _CharacterInfo _character0002FA0B =
    {
        0x0002FA0B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0B,
        0x0002FA0B,
        0x0002FA0B
    };

    static Char _decompositionMapping0002FA0C[] = 
    {
        0x00009CFD
    };

    static _CharacterInfo _character0002FA0C =
    {
        0x0002FA0C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0C,
        0x0002FA0C,
        0x0002FA0C
    };

    static Char _decompositionMapping0002FA0D[] = 
    {
        0x00004CCE
    };

    static _CharacterInfo _character0002FA0D =
    {
        0x0002FA0D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0D,
        0x0002FA0D,
        0x0002FA0D
    };

    static Char _decompositionMapping0002FA0E[] = 
    {
        0x00004CED
    };

    static _CharacterInfo _character0002FA0E =
    {
        0x0002FA0E,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0E,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0E,
        0x0002FA0E,
        0x0002FA0E
    };

    static Char _decompositionMapping0002FA0F[] = 
    {
        0x00009D67
    };

    static _CharacterInfo _character0002FA0F =
    {
        0x0002FA0F,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA0F,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA0F,
        0x0002FA0F,
        0x0002FA0F
    };

    static Char _decompositionMapping0002FA10[] = 
    {
        0x0002A0CE
    };

    static _CharacterInfo _character0002FA10 =
    {
        0x0002FA10,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA10,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA10,
        0x0002FA10,
        0x0002FA10
    };

    static Char _decompositionMapping0002FA11[] = 
    {
        0x00004CF8
    };

    static _CharacterInfo _character0002FA11 =
    {
        0x0002FA11,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA11,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA11,
        0x0002FA11,
        0x0002FA11
    };

    static Char _decompositionMapping0002FA12[] = 
    {
        0x0002A105
    };

    static _CharacterInfo _character0002FA12 =
    {
        0x0002FA12,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA12,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA12,
        0x0002FA12,
        0x0002FA12
    };

    static Char _decompositionMapping0002FA13[] = 
    {
        0x0002A20E
    };

    static _CharacterInfo _character0002FA13 =
    {
        0x0002FA13,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA13,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA13,
        0x0002FA13,
        0x0002FA13
    };

    static Char _decompositionMapping0002FA14[] = 
    {
        0x0002A291
    };

    static _CharacterInfo _character0002FA14 =
    {
        0x0002FA14,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA14,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA14,
        0x0002FA14,
        0x0002FA14
    };

    static Char _decompositionMapping0002FA15[] = 
    {
        0x00009EBB
    };

    static _CharacterInfo _character0002FA15 =
    {
        0x0002FA15,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA15,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA15,
        0x0002FA15,
        0x0002FA15
    };

    static Char _decompositionMapping0002FA16[] = 
    {
        0x00004D56
    };

    static _CharacterInfo _character0002FA16 =
    {
        0x0002FA16,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA16,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA16,
        0x0002FA16,
        0x0002FA16
    };

    static Char _decompositionMapping0002FA17[] = 
    {
        0x00009EF9
    };

    static _CharacterInfo _character0002FA17 =
    {
        0x0002FA17,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA17,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA17,
        0x0002FA17,
        0x0002FA17
    };

    static Char _decompositionMapping0002FA18[] = 
    {
        0x00009EFE
    };

    static _CharacterInfo _character0002FA18 =
    {
        0x0002FA18,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA18,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA18,
        0x0002FA18,
        0x0002FA18
    };

    static Char _decompositionMapping0002FA19[] = 
    {
        0x00009F05
    };

    static _CharacterInfo _character0002FA19 =
    {
        0x0002FA19,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA19,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA19,
        0x0002FA19,
        0x0002FA19
    };

    static Char _decompositionMapping0002FA1A[] = 
    {
        0x00009F0F
    };

    static _CharacterInfo _character0002FA1A =
    {
        0x0002FA1A,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA1A,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA1A,
        0x0002FA1A,
        0x0002FA1A
    };

    static Char _decompositionMapping0002FA1B[] = 
    {
        0x00009F16
    };

    static _CharacterInfo _character0002FA1B =
    {
        0x0002FA1B,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA1B,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA1B,
        0x0002FA1B,
        0x0002FA1B
    };

    static Char _decompositionMapping0002FA1C[] = 
    {
        0x00009F3B
    };

    static _CharacterInfo _character0002FA1C =
    {
        0x0002FA1C,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA1C,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA1C,
        0x0002FA1C,
        0x0002FA1C
    };

    static Char _decompositionMapping0002FA1D[] = 
    {
        0x0002A600
    };

    static _CharacterInfo _character0002FA1D =
    {
        0x0002FA1D,
        Iso10646::GeneralCategory_Lo,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_canonical,
        1,
        _decompositionMapping0002FA1D,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0002FA1D,
        0x0002FA1D,
        0x0002FA1D
    };

    static _CharacterInfo _character000E0001 =
    {
        0x000E0001,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0001,
        0x000E0001,
        0x000E0001
    };

    static _CharacterInfo _character000E0020 =
    {
        0x000E0020,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0020,
        0x000E0020,
        0x000E0020
    };

    static _CharacterInfo _character000E0021 =
    {
        0x000E0021,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0021,
        0x000E0021,
        0x000E0021
    };

    static _CharacterInfo _character000E0022 =
    {
        0x000E0022,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0022,
        0x000E0022,
        0x000E0022
    };

    static _CharacterInfo _character000E0023 =
    {
        0x000E0023,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0023,
        0x000E0023,
        0x000E0023
    };

    static _CharacterInfo _character000E0024 =
    {
        0x000E0024,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0024,
        0x000E0024,
        0x000E0024
    };

    static _CharacterInfo _character000E0025 =
    {
        0x000E0025,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0025,
        0x000E0025,
        0x000E0025
    };

    static _CharacterInfo _character000E0026 =
    {
        0x000E0026,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0026,
        0x000E0026,
        0x000E0026
    };

    static _CharacterInfo _character000E0027 =
    {
        0x000E0027,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0027,
        0x000E0027,
        0x000E0027
    };

    static _CharacterInfo _character000E0028 =
    {
        0x000E0028,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0028,
        0x000E0028,
        0x000E0028
    };

    static _CharacterInfo _character000E0029 =
    {
        0x000E0029,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0029,
        0x000E0029,
        0x000E0029
    };

    static _CharacterInfo _character000E002A =
    {
        0x000E002A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002A,
        0x000E002A,
        0x000E002A
    };

    static _CharacterInfo _character000E002B =
    {
        0x000E002B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002B,
        0x000E002B,
        0x000E002B
    };

    static _CharacterInfo _character000E002C =
    {
        0x000E002C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002C,
        0x000E002C,
        0x000E002C
    };

    static _CharacterInfo _character000E002D =
    {
        0x000E002D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002D,
        0x000E002D,
        0x000E002D
    };

    static _CharacterInfo _character000E002E =
    {
        0x000E002E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002E,
        0x000E002E,
        0x000E002E
    };

    static _CharacterInfo _character000E002F =
    {
        0x000E002F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E002F,
        0x000E002F,
        0x000E002F
    };

    static _CharacterInfo _character000E0030 =
    {
        0x000E0030,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0030,
        0x000E0030,
        0x000E0030
    };

    static _CharacterInfo _character000E0031 =
    {
        0x000E0031,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0031,
        0x000E0031,
        0x000E0031
    };

    static _CharacterInfo _character000E0032 =
    {
        0x000E0032,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0032,
        0x000E0032,
        0x000E0032
    };

    static _CharacterInfo _character000E0033 =
    {
        0x000E0033,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0033,
        0x000E0033,
        0x000E0033
    };

    static _CharacterInfo _character000E0034 =
    {
        0x000E0034,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0034,
        0x000E0034,
        0x000E0034
    };

    static _CharacterInfo _character000E0035 =
    {
        0x000E0035,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0035,
        0x000E0035,
        0x000E0035
    };

    static _CharacterInfo _character000E0036 =
    {
        0x000E0036,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0036,
        0x000E0036,
        0x000E0036
    };

    static _CharacterInfo _character000E0037 =
    {
        0x000E0037,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0037,
        0x000E0037,
        0x000E0037
    };

    static _CharacterInfo _character000E0038 =
    {
        0x000E0038,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0038,
        0x000E0038,
        0x000E0038
    };

    static _CharacterInfo _character000E0039 =
    {
        0x000E0039,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0039,
        0x000E0039,
        0x000E0039
    };

    static _CharacterInfo _character000E003A =
    {
        0x000E003A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003A,
        0x000E003A,
        0x000E003A
    };

    static _CharacterInfo _character000E003B =
    {
        0x000E003B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003B,
        0x000E003B,
        0x000E003B
    };

    static _CharacterInfo _character000E003C =
    {
        0x000E003C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003C,
        0x000E003C,
        0x000E003C
    };

    static _CharacterInfo _character000E003D =
    {
        0x000E003D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003D,
        0x000E003D,
        0x000E003D
    };

    static _CharacterInfo _character000E003E =
    {
        0x000E003E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003E,
        0x000E003E,
        0x000E003E
    };

    static _CharacterInfo _character000E003F =
    {
        0x000E003F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E003F,
        0x000E003F,
        0x000E003F
    };

    static _CharacterInfo _character000E0040 =
    {
        0x000E0040,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0040,
        0x000E0040,
        0x000E0040
    };

    static _CharacterInfo _character000E0041 =
    {
        0x000E0041,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0041,
        0x000E0041,
        0x000E0041
    };

    static _CharacterInfo _character000E0042 =
    {
        0x000E0042,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0042,
        0x000E0042,
        0x000E0042
    };

    static _CharacterInfo _character000E0043 =
    {
        0x000E0043,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0043,
        0x000E0043,
        0x000E0043
    };

    static _CharacterInfo _character000E0044 =
    {
        0x000E0044,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0044,
        0x000E0044,
        0x000E0044
    };

    static _CharacterInfo _character000E0045 =
    {
        0x000E0045,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0045,
        0x000E0045,
        0x000E0045
    };

    static _CharacterInfo _character000E0046 =
    {
        0x000E0046,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0046,
        0x000E0046,
        0x000E0046
    };

    static _CharacterInfo _character000E0047 =
    {
        0x000E0047,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0047,
        0x000E0047,
        0x000E0047
    };

    static _CharacterInfo _character000E0048 =
    {
        0x000E0048,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0048,
        0x000E0048,
        0x000E0048
    };

    static _CharacterInfo _character000E0049 =
    {
        0x000E0049,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0049,
        0x000E0049,
        0x000E0049
    };

    static _CharacterInfo _character000E004A =
    {
        0x000E004A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004A,
        0x000E004A,
        0x000E004A
    };

    static _CharacterInfo _character000E004B =
    {
        0x000E004B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004B,
        0x000E004B,
        0x000E004B
    };

    static _CharacterInfo _character000E004C =
    {
        0x000E004C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004C,
        0x000E004C,
        0x000E004C
    };

    static _CharacterInfo _character000E004D =
    {
        0x000E004D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004D,
        0x000E004D,
        0x000E004D
    };

    static _CharacterInfo _character000E004E =
    {
        0x000E004E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004E,
        0x000E004E,
        0x000E004E
    };

    static _CharacterInfo _character000E004F =
    {
        0x000E004F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E004F,
        0x000E004F,
        0x000E004F
    };

    static _CharacterInfo _character000E0050 =
    {
        0x000E0050,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0050,
        0x000E0050,
        0x000E0050
    };

    static _CharacterInfo _character000E0051 =
    {
        0x000E0051,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0051,
        0x000E0051,
        0x000E0051
    };

    static _CharacterInfo _character000E0052 =
    {
        0x000E0052,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0052,
        0x000E0052,
        0x000E0052
    };

    static _CharacterInfo _character000E0053 =
    {
        0x000E0053,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0053,
        0x000E0053,
        0x000E0053
    };

    static _CharacterInfo _character000E0054 =
    {
        0x000E0054,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0054,
        0x000E0054,
        0x000E0054
    };

    static _CharacterInfo _character000E0055 =
    {
        0x000E0055,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0055,
        0x000E0055,
        0x000E0055
    };

    static _CharacterInfo _character000E0056 =
    {
        0x000E0056,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0056,
        0x000E0056,
        0x000E0056
    };

    static _CharacterInfo _character000E0057 =
    {
        0x000E0057,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0057,
        0x000E0057,
        0x000E0057
    };

    static _CharacterInfo _character000E0058 =
    {
        0x000E0058,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0058,
        0x000E0058,
        0x000E0058
    };

    static _CharacterInfo _character000E0059 =
    {
        0x000E0059,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0059,
        0x000E0059,
        0x000E0059
    };

    static _CharacterInfo _character000E005A =
    {
        0x000E005A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005A,
        0x000E005A,
        0x000E005A
    };

    static _CharacterInfo _character000E005B =
    {
        0x000E005B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005B,
        0x000E005B,
        0x000E005B
    };

    static _CharacterInfo _character000E005C =
    {
        0x000E005C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005C,
        0x000E005C,
        0x000E005C
    };

    static _CharacterInfo _character000E005D =
    {
        0x000E005D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005D,
        0x000E005D,
        0x000E005D
    };

    static _CharacterInfo _character000E005E =
    {
        0x000E005E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005E,
        0x000E005E,
        0x000E005E
    };

    static _CharacterInfo _character000E005F =
    {
        0x000E005F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E005F,
        0x000E005F,
        0x000E005F
    };

    static _CharacterInfo _character000E0060 =
    {
        0x000E0060,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0060,
        0x000E0060,
        0x000E0060
    };

    static _CharacterInfo _character000E0061 =
    {
        0x000E0061,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0061,
        0x000E0061,
        0x000E0061
    };

    static _CharacterInfo _character000E0062 =
    {
        0x000E0062,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0062,
        0x000E0062,
        0x000E0062
    };

    static _CharacterInfo _character000E0063 =
    {
        0x000E0063,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0063,
        0x000E0063,
        0x000E0063
    };

    static _CharacterInfo _character000E0064 =
    {
        0x000E0064,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0064,
        0x000E0064,
        0x000E0064
    };

    static _CharacterInfo _character000E0065 =
    {
        0x000E0065,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0065,
        0x000E0065,
        0x000E0065
    };

    static _CharacterInfo _character000E0066 =
    {
        0x000E0066,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0066,
        0x000E0066,
        0x000E0066
    };

    static _CharacterInfo _character000E0067 =
    {
        0x000E0067,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0067,
        0x000E0067,
        0x000E0067
    };

    static _CharacterInfo _character000E0068 =
    {
        0x000E0068,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0068,
        0x000E0068,
        0x000E0068
    };

    static _CharacterInfo _character000E0069 =
    {
        0x000E0069,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0069,
        0x000E0069,
        0x000E0069
    };

    static _CharacterInfo _character000E006A =
    {
        0x000E006A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006A,
        0x000E006A,
        0x000E006A
    };

    static _CharacterInfo _character000E006B =
    {
        0x000E006B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006B,
        0x000E006B,
        0x000E006B
    };

    static _CharacterInfo _character000E006C =
    {
        0x000E006C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006C,
        0x000E006C,
        0x000E006C
    };

    static _CharacterInfo _character000E006D =
    {
        0x000E006D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006D,
        0x000E006D,
        0x000E006D
    };

    static _CharacterInfo _character000E006E =
    {
        0x000E006E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006E,
        0x000E006E,
        0x000E006E
    };

    static _CharacterInfo _character000E006F =
    {
        0x000E006F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E006F,
        0x000E006F,
        0x000E006F
    };

    static _CharacterInfo _character000E0070 =
    {
        0x000E0070,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0070,
        0x000E0070,
        0x000E0070
    };

    static _CharacterInfo _character000E0071 =
    {
        0x000E0071,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0071,
        0x000E0071,
        0x000E0071
    };

    static _CharacterInfo _character000E0072 =
    {
        0x000E0072,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0072,
        0x000E0072,
        0x000E0072
    };

    static _CharacterInfo _character000E0073 =
    {
        0x000E0073,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0073,
        0x000E0073,
        0x000E0073
    };

    static _CharacterInfo _character000E0074 =
    {
        0x000E0074,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0074,
        0x000E0074,
        0x000E0074
    };

    static _CharacterInfo _character000E0075 =
    {
        0x000E0075,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0075,
        0x000E0075,
        0x000E0075
    };

    static _CharacterInfo _character000E0076 =
    {
        0x000E0076,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0076,
        0x000E0076,
        0x000E0076
    };

    static _CharacterInfo _character000E0077 =
    {
        0x000E0077,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0077,
        0x000E0077,
        0x000E0077
    };

    static _CharacterInfo _character000E0078 =
    {
        0x000E0078,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0078,
        0x000E0078,
        0x000E0078
    };

    static _CharacterInfo _character000E0079 =
    {
        0x000E0079,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0079,
        0x000E0079,
        0x000E0079
    };

    static _CharacterInfo _character000E007A =
    {
        0x000E007A,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007A,
        0x000E007A,
        0x000E007A
    };

    static _CharacterInfo _character000E007B =
    {
        0x000E007B,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007B,
        0x000E007B,
        0x000E007B
    };

    static _CharacterInfo _character000E007C =
    {
        0x000E007C,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007C,
        0x000E007C,
        0x000E007C
    };

    static _CharacterInfo _character000E007D =
    {
        0x000E007D,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007D,
        0x000E007D,
        0x000E007D
    };

    static _CharacterInfo _character000E007E =
    {
        0x000E007E,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007E,
        0x000E007E,
        0x000E007E
    };

    static _CharacterInfo _character000E007F =
    {
        0x000E007F,
        Iso10646::GeneralCategory_Cf,
        0,
        Iso10646::BidirectionalCategory_BN,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E007F,
        0x000E007F,
        0x000E007F
    };

    static _CharacterInfo _character000E0100 =
    {
        0x000E0100,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0100,
        0x000E0100,
        0x000E0100
    };

    static _CharacterInfo _character000E0101 =
    {
        0x000E0101,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0101,
        0x000E0101,
        0x000E0101
    };

    static _CharacterInfo _character000E0102 =
    {
        0x000E0102,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0102,
        0x000E0102,
        0x000E0102
    };

    static _CharacterInfo _character000E0103 =
    {
        0x000E0103,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0103,
        0x000E0103,
        0x000E0103
    };

    static _CharacterInfo _character000E0104 =
    {
        0x000E0104,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0104,
        0x000E0104,
        0x000E0104
    };

    static _CharacterInfo _character000E0105 =
    {
        0x000E0105,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0105,
        0x000E0105,
        0x000E0105
    };

    static _CharacterInfo _character000E0106 =
    {
        0x000E0106,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0106,
        0x000E0106,
        0x000E0106
    };

    static _CharacterInfo _character000E0107 =
    {
        0x000E0107,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0107,
        0x000E0107,
        0x000E0107
    };

    static _CharacterInfo _character000E0108 =
    {
        0x000E0108,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0108,
        0x000E0108,
        0x000E0108
    };

    static _CharacterInfo _character000E0109 =
    {
        0x000E0109,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0109,
        0x000E0109,
        0x000E0109
    };

    static _CharacterInfo _character000E010A =
    {
        0x000E010A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010A,
        0x000E010A,
        0x000E010A
    };

    static _CharacterInfo _character000E010B =
    {
        0x000E010B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010B,
        0x000E010B,
        0x000E010B
    };

    static _CharacterInfo _character000E010C =
    {
        0x000E010C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010C,
        0x000E010C,
        0x000E010C
    };

    static _CharacterInfo _character000E010D =
    {
        0x000E010D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010D,
        0x000E010D,
        0x000E010D
    };

    static _CharacterInfo _character000E010E =
    {
        0x000E010E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010E,
        0x000E010E,
        0x000E010E
    };

    static _CharacterInfo _character000E010F =
    {
        0x000E010F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E010F,
        0x000E010F,
        0x000E010F
    };

    static _CharacterInfo _character000E0110 =
    {
        0x000E0110,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0110,
        0x000E0110,
        0x000E0110
    };

    static _CharacterInfo _character000E0111 =
    {
        0x000E0111,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0111,
        0x000E0111,
        0x000E0111
    };

    static _CharacterInfo _character000E0112 =
    {
        0x000E0112,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0112,
        0x000E0112,
        0x000E0112
    };

    static _CharacterInfo _character000E0113 =
    {
        0x000E0113,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0113,
        0x000E0113,
        0x000E0113
    };

    static _CharacterInfo _character000E0114 =
    {
        0x000E0114,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0114,
        0x000E0114,
        0x000E0114
    };

    static _CharacterInfo _character000E0115 =
    {
        0x000E0115,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0115,
        0x000E0115,
        0x000E0115
    };

    static _CharacterInfo _character000E0116 =
    {
        0x000E0116,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0116,
        0x000E0116,
        0x000E0116
    };

    static _CharacterInfo _character000E0117 =
    {
        0x000E0117,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0117,
        0x000E0117,
        0x000E0117
    };

    static _CharacterInfo _character000E0118 =
    {
        0x000E0118,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0118,
        0x000E0118,
        0x000E0118
    };

    static _CharacterInfo _character000E0119 =
    {
        0x000E0119,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0119,
        0x000E0119,
        0x000E0119
    };

    static _CharacterInfo _character000E011A =
    {
        0x000E011A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011A,
        0x000E011A,
        0x000E011A
    };

    static _CharacterInfo _character000E011B =
    {
        0x000E011B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011B,
        0x000E011B,
        0x000E011B
    };

    static _CharacterInfo _character000E011C =
    {
        0x000E011C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011C,
        0x000E011C,
        0x000E011C
    };

    static _CharacterInfo _character000E011D =
    {
        0x000E011D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011D,
        0x000E011D,
        0x000E011D
    };

    static _CharacterInfo _character000E011E =
    {
        0x000E011E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011E,
        0x000E011E,
        0x000E011E
    };

    static _CharacterInfo _character000E011F =
    {
        0x000E011F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E011F,
        0x000E011F,
        0x000E011F
    };

    static _CharacterInfo _character000E0120 =
    {
        0x000E0120,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0120,
        0x000E0120,
        0x000E0120
    };

    static _CharacterInfo _character000E0121 =
    {
        0x000E0121,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0121,
        0x000E0121,
        0x000E0121
    };

    static _CharacterInfo _character000E0122 =
    {
        0x000E0122,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0122,
        0x000E0122,
        0x000E0122
    };

    static _CharacterInfo _character000E0123 =
    {
        0x000E0123,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0123,
        0x000E0123,
        0x000E0123
    };

    static _CharacterInfo _character000E0124 =
    {
        0x000E0124,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0124,
        0x000E0124,
        0x000E0124
    };

    static _CharacterInfo _character000E0125 =
    {
        0x000E0125,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0125,
        0x000E0125,
        0x000E0125
    };

    static _CharacterInfo _character000E0126 =
    {
        0x000E0126,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0126,
        0x000E0126,
        0x000E0126
    };

    static _CharacterInfo _character000E0127 =
    {
        0x000E0127,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0127,
        0x000E0127,
        0x000E0127
    };

    static _CharacterInfo _character000E0128 =
    {
        0x000E0128,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0128,
        0x000E0128,
        0x000E0128
    };

    static _CharacterInfo _character000E0129 =
    {
        0x000E0129,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0129,
        0x000E0129,
        0x000E0129
    };

    static _CharacterInfo _character000E012A =
    {
        0x000E012A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012A,
        0x000E012A,
        0x000E012A
    };

    static _CharacterInfo _character000E012B =
    {
        0x000E012B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012B,
        0x000E012B,
        0x000E012B
    };

    static _CharacterInfo _character000E012C =
    {
        0x000E012C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012C,
        0x000E012C,
        0x000E012C
    };

    static _CharacterInfo _character000E012D =
    {
        0x000E012D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012D,
        0x000E012D,
        0x000E012D
    };

    static _CharacterInfo _character000E012E =
    {
        0x000E012E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012E,
        0x000E012E,
        0x000E012E
    };

    static _CharacterInfo _character000E012F =
    {
        0x000E012F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E012F,
        0x000E012F,
        0x000E012F
    };

    static _CharacterInfo _character000E0130 =
    {
        0x000E0130,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0130,
        0x000E0130,
        0x000E0130
    };

    static _CharacterInfo _character000E0131 =
    {
        0x000E0131,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0131,
        0x000E0131,
        0x000E0131
    };

    static _CharacterInfo _character000E0132 =
    {
        0x000E0132,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0132,
        0x000E0132,
        0x000E0132
    };

    static _CharacterInfo _character000E0133 =
    {
        0x000E0133,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0133,
        0x000E0133,
        0x000E0133
    };

    static _CharacterInfo _character000E0134 =
    {
        0x000E0134,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0134,
        0x000E0134,
        0x000E0134
    };

    static _CharacterInfo _character000E0135 =
    {
        0x000E0135,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0135,
        0x000E0135,
        0x000E0135
    };

    static _CharacterInfo _character000E0136 =
    {
        0x000E0136,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0136,
        0x000E0136,
        0x000E0136
    };

    static _CharacterInfo _character000E0137 =
    {
        0x000E0137,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0137,
        0x000E0137,
        0x000E0137
    };

    static _CharacterInfo _character000E0138 =
    {
        0x000E0138,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0138,
        0x000E0138,
        0x000E0138
    };

    static _CharacterInfo _character000E0139 =
    {
        0x000E0139,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0139,
        0x000E0139,
        0x000E0139
    };

    static _CharacterInfo _character000E013A =
    {
        0x000E013A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013A,
        0x000E013A,
        0x000E013A
    };

    static _CharacterInfo _character000E013B =
    {
        0x000E013B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013B,
        0x000E013B,
        0x000E013B
    };

    static _CharacterInfo _character000E013C =
    {
        0x000E013C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013C,
        0x000E013C,
        0x000E013C
    };

    static _CharacterInfo _character000E013D =
    {
        0x000E013D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013D,
        0x000E013D,
        0x000E013D
    };

    static _CharacterInfo _character000E013E =
    {
        0x000E013E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013E,
        0x000E013E,
        0x000E013E
    };

    static _CharacterInfo _character000E013F =
    {
        0x000E013F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E013F,
        0x000E013F,
        0x000E013F
    };

    static _CharacterInfo _character000E0140 =
    {
        0x000E0140,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0140,
        0x000E0140,
        0x000E0140
    };

    static _CharacterInfo _character000E0141 =
    {
        0x000E0141,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0141,
        0x000E0141,
        0x000E0141
    };

    static _CharacterInfo _character000E0142 =
    {
        0x000E0142,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0142,
        0x000E0142,
        0x000E0142
    };

    static _CharacterInfo _character000E0143 =
    {
        0x000E0143,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0143,
        0x000E0143,
        0x000E0143
    };

    static _CharacterInfo _character000E0144 =
    {
        0x000E0144,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0144,
        0x000E0144,
        0x000E0144
    };

    static _CharacterInfo _character000E0145 =
    {
        0x000E0145,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0145,
        0x000E0145,
        0x000E0145
    };

    static _CharacterInfo _character000E0146 =
    {
        0x000E0146,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0146,
        0x000E0146,
        0x000E0146
    };

    static _CharacterInfo _character000E0147 =
    {
        0x000E0147,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0147,
        0x000E0147,
        0x000E0147
    };

    static _CharacterInfo _character000E0148 =
    {
        0x000E0148,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0148,
        0x000E0148,
        0x000E0148
    };

    static _CharacterInfo _character000E0149 =
    {
        0x000E0149,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0149,
        0x000E0149,
        0x000E0149
    };

    static _CharacterInfo _character000E014A =
    {
        0x000E014A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014A,
        0x000E014A,
        0x000E014A
    };

    static _CharacterInfo _character000E014B =
    {
        0x000E014B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014B,
        0x000E014B,
        0x000E014B
    };

    static _CharacterInfo _character000E014C =
    {
        0x000E014C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014C,
        0x000E014C,
        0x000E014C
    };

    static _CharacterInfo _character000E014D =
    {
        0x000E014D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014D,
        0x000E014D,
        0x000E014D
    };

    static _CharacterInfo _character000E014E =
    {
        0x000E014E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014E,
        0x000E014E,
        0x000E014E
    };

    static _CharacterInfo _character000E014F =
    {
        0x000E014F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E014F,
        0x000E014F,
        0x000E014F
    };

    static _CharacterInfo _character000E0150 =
    {
        0x000E0150,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0150,
        0x000E0150,
        0x000E0150
    };

    static _CharacterInfo _character000E0151 =
    {
        0x000E0151,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0151,
        0x000E0151,
        0x000E0151
    };

    static _CharacterInfo _character000E0152 =
    {
        0x000E0152,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0152,
        0x000E0152,
        0x000E0152
    };

    static _CharacterInfo _character000E0153 =
    {
        0x000E0153,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0153,
        0x000E0153,
        0x000E0153
    };

    static _CharacterInfo _character000E0154 =
    {
        0x000E0154,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0154,
        0x000E0154,
        0x000E0154
    };

    static _CharacterInfo _character000E0155 =
    {
        0x000E0155,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0155,
        0x000E0155,
        0x000E0155
    };

    static _CharacterInfo _character000E0156 =
    {
        0x000E0156,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0156,
        0x000E0156,
        0x000E0156
    };

    static _CharacterInfo _character000E0157 =
    {
        0x000E0157,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0157,
        0x000E0157,
        0x000E0157
    };

    static _CharacterInfo _character000E0158 =
    {
        0x000E0158,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0158,
        0x000E0158,
        0x000E0158
    };

    static _CharacterInfo _character000E0159 =
    {
        0x000E0159,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0159,
        0x000E0159,
        0x000E0159
    };

    static _CharacterInfo _character000E015A =
    {
        0x000E015A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015A,
        0x000E015A,
        0x000E015A
    };

    static _CharacterInfo _character000E015B =
    {
        0x000E015B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015B,
        0x000E015B,
        0x000E015B
    };

    static _CharacterInfo _character000E015C =
    {
        0x000E015C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015C,
        0x000E015C,
        0x000E015C
    };

    static _CharacterInfo _character000E015D =
    {
        0x000E015D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015D,
        0x000E015D,
        0x000E015D
    };

    static _CharacterInfo _character000E015E =
    {
        0x000E015E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015E,
        0x000E015E,
        0x000E015E
    };

    static _CharacterInfo _character000E015F =
    {
        0x000E015F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E015F,
        0x000E015F,
        0x000E015F
    };

    static _CharacterInfo _character000E0160 =
    {
        0x000E0160,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0160,
        0x000E0160,
        0x000E0160
    };

    static _CharacterInfo _character000E0161 =
    {
        0x000E0161,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0161,
        0x000E0161,
        0x000E0161
    };

    static _CharacterInfo _character000E0162 =
    {
        0x000E0162,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0162,
        0x000E0162,
        0x000E0162
    };

    static _CharacterInfo _character000E0163 =
    {
        0x000E0163,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0163,
        0x000E0163,
        0x000E0163
    };

    static _CharacterInfo _character000E0164 =
    {
        0x000E0164,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0164,
        0x000E0164,
        0x000E0164
    };

    static _CharacterInfo _character000E0165 =
    {
        0x000E0165,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0165,
        0x000E0165,
        0x000E0165
    };

    static _CharacterInfo _character000E0166 =
    {
        0x000E0166,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0166,
        0x000E0166,
        0x000E0166
    };

    static _CharacterInfo _character000E0167 =
    {
        0x000E0167,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0167,
        0x000E0167,
        0x000E0167
    };

    static _CharacterInfo _character000E0168 =
    {
        0x000E0168,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0168,
        0x000E0168,
        0x000E0168
    };

    static _CharacterInfo _character000E0169 =
    {
        0x000E0169,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0169,
        0x000E0169,
        0x000E0169
    };

    static _CharacterInfo _character000E016A =
    {
        0x000E016A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016A,
        0x000E016A,
        0x000E016A
    };

    static _CharacterInfo _character000E016B =
    {
        0x000E016B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016B,
        0x000E016B,
        0x000E016B
    };

    static _CharacterInfo _character000E016C =
    {
        0x000E016C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016C,
        0x000E016C,
        0x000E016C
    };

    static _CharacterInfo _character000E016D =
    {
        0x000E016D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016D,
        0x000E016D,
        0x000E016D
    };

    static _CharacterInfo _character000E016E =
    {
        0x000E016E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016E,
        0x000E016E,
        0x000E016E
    };

    static _CharacterInfo _character000E016F =
    {
        0x000E016F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E016F,
        0x000E016F,
        0x000E016F
    };

    static _CharacterInfo _character000E0170 =
    {
        0x000E0170,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0170,
        0x000E0170,
        0x000E0170
    };

    static _CharacterInfo _character000E0171 =
    {
        0x000E0171,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0171,
        0x000E0171,
        0x000E0171
    };

    static _CharacterInfo _character000E0172 =
    {
        0x000E0172,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0172,
        0x000E0172,
        0x000E0172
    };

    static _CharacterInfo _character000E0173 =
    {
        0x000E0173,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0173,
        0x000E0173,
        0x000E0173
    };

    static _CharacterInfo _character000E0174 =
    {
        0x000E0174,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0174,
        0x000E0174,
        0x000E0174
    };

    static _CharacterInfo _character000E0175 =
    {
        0x000E0175,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0175,
        0x000E0175,
        0x000E0175
    };

    static _CharacterInfo _character000E0176 =
    {
        0x000E0176,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0176,
        0x000E0176,
        0x000E0176
    };

    static _CharacterInfo _character000E0177 =
    {
        0x000E0177,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0177,
        0x000E0177,
        0x000E0177
    };

    static _CharacterInfo _character000E0178 =
    {
        0x000E0178,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0178,
        0x000E0178,
        0x000E0178
    };

    static _CharacterInfo _character000E0179 =
    {
        0x000E0179,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0179,
        0x000E0179,
        0x000E0179
    };

    static _CharacterInfo _character000E017A =
    {
        0x000E017A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017A,
        0x000E017A,
        0x000E017A
    };

    static _CharacterInfo _character000E017B =
    {
        0x000E017B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017B,
        0x000E017B,
        0x000E017B
    };

    static _CharacterInfo _character000E017C =
    {
        0x000E017C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017C,
        0x000E017C,
        0x000E017C
    };

    static _CharacterInfo _character000E017D =
    {
        0x000E017D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017D,
        0x000E017D,
        0x000E017D
    };

    static _CharacterInfo _character000E017E =
    {
        0x000E017E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017E,
        0x000E017E,
        0x000E017E
    };

    static _CharacterInfo _character000E017F =
    {
        0x000E017F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E017F,
        0x000E017F,
        0x000E017F
    };

    static _CharacterInfo _character000E0180 =
    {
        0x000E0180,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0180,
        0x000E0180,
        0x000E0180
    };

    static _CharacterInfo _character000E0181 =
    {
        0x000E0181,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0181,
        0x000E0181,
        0x000E0181
    };

    static _CharacterInfo _character000E0182 =
    {
        0x000E0182,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0182,
        0x000E0182,
        0x000E0182
    };

    static _CharacterInfo _character000E0183 =
    {
        0x000E0183,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0183,
        0x000E0183,
        0x000E0183
    };

    static _CharacterInfo _character000E0184 =
    {
        0x000E0184,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0184,
        0x000E0184,
        0x000E0184
    };

    static _CharacterInfo _character000E0185 =
    {
        0x000E0185,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0185,
        0x000E0185,
        0x000E0185
    };

    static _CharacterInfo _character000E0186 =
    {
        0x000E0186,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0186,
        0x000E0186,
        0x000E0186
    };

    static _CharacterInfo _character000E0187 =
    {
        0x000E0187,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0187,
        0x000E0187,
        0x000E0187
    };

    static _CharacterInfo _character000E0188 =
    {
        0x000E0188,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0188,
        0x000E0188,
        0x000E0188
    };

    static _CharacterInfo _character000E0189 =
    {
        0x000E0189,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0189,
        0x000E0189,
        0x000E0189
    };

    static _CharacterInfo _character000E018A =
    {
        0x000E018A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018A,
        0x000E018A,
        0x000E018A
    };

    static _CharacterInfo _character000E018B =
    {
        0x000E018B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018B,
        0x000E018B,
        0x000E018B
    };

    static _CharacterInfo _character000E018C =
    {
        0x000E018C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018C,
        0x000E018C,
        0x000E018C
    };

    static _CharacterInfo _character000E018D =
    {
        0x000E018D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018D,
        0x000E018D,
        0x000E018D
    };

    static _CharacterInfo _character000E018E =
    {
        0x000E018E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018E,
        0x000E018E,
        0x000E018E
    };

    static _CharacterInfo _character000E018F =
    {
        0x000E018F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E018F,
        0x000E018F,
        0x000E018F
    };

    static _CharacterInfo _character000E0190 =
    {
        0x000E0190,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0190,
        0x000E0190,
        0x000E0190
    };

    static _CharacterInfo _character000E0191 =
    {
        0x000E0191,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0191,
        0x000E0191,
        0x000E0191
    };

    static _CharacterInfo _character000E0192 =
    {
        0x000E0192,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0192,
        0x000E0192,
        0x000E0192
    };

    static _CharacterInfo _character000E0193 =
    {
        0x000E0193,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0193,
        0x000E0193,
        0x000E0193
    };

    static _CharacterInfo _character000E0194 =
    {
        0x000E0194,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0194,
        0x000E0194,
        0x000E0194
    };

    static _CharacterInfo _character000E0195 =
    {
        0x000E0195,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0195,
        0x000E0195,
        0x000E0195
    };

    static _CharacterInfo _character000E0196 =
    {
        0x000E0196,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0196,
        0x000E0196,
        0x000E0196
    };

    static _CharacterInfo _character000E0197 =
    {
        0x000E0197,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0197,
        0x000E0197,
        0x000E0197
    };

    static _CharacterInfo _character000E0198 =
    {
        0x000E0198,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0198,
        0x000E0198,
        0x000E0198
    };

    static _CharacterInfo _character000E0199 =
    {
        0x000E0199,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E0199,
        0x000E0199,
        0x000E0199
    };

    static _CharacterInfo _character000E019A =
    {
        0x000E019A,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019A,
        0x000E019A,
        0x000E019A
    };

    static _CharacterInfo _character000E019B =
    {
        0x000E019B,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019B,
        0x000E019B,
        0x000E019B
    };

    static _CharacterInfo _character000E019C =
    {
        0x000E019C,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019C,
        0x000E019C,
        0x000E019C
    };

    static _CharacterInfo _character000E019D =
    {
        0x000E019D,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019D,
        0x000E019D,
        0x000E019D
    };

    static _CharacterInfo _character000E019E =
    {
        0x000E019E,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019E,
        0x000E019E,
        0x000E019E
    };

    static _CharacterInfo _character000E019F =
    {
        0x000E019F,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E019F,
        0x000E019F,
        0x000E019F
    };

    static _CharacterInfo _character000E01A0 =
    {
        0x000E01A0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A0,
        0x000E01A0,
        0x000E01A0
    };

    static _CharacterInfo _character000E01A1 =
    {
        0x000E01A1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A1,
        0x000E01A1,
        0x000E01A1
    };

    static _CharacterInfo _character000E01A2 =
    {
        0x000E01A2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A2,
        0x000E01A2,
        0x000E01A2
    };

    static _CharacterInfo _character000E01A3 =
    {
        0x000E01A3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A3,
        0x000E01A3,
        0x000E01A3
    };

    static _CharacterInfo _character000E01A4 =
    {
        0x000E01A4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A4,
        0x000E01A4,
        0x000E01A4
    };

    static _CharacterInfo _character000E01A5 =
    {
        0x000E01A5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A5,
        0x000E01A5,
        0x000E01A5
    };

    static _CharacterInfo _character000E01A6 =
    {
        0x000E01A6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A6,
        0x000E01A6,
        0x000E01A6
    };

    static _CharacterInfo _character000E01A7 =
    {
        0x000E01A7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A7,
        0x000E01A7,
        0x000E01A7
    };

    static _CharacterInfo _character000E01A8 =
    {
        0x000E01A8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A8,
        0x000E01A8,
        0x000E01A8
    };

    static _CharacterInfo _character000E01A9 =
    {
        0x000E01A9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01A9,
        0x000E01A9,
        0x000E01A9
    };

    static _CharacterInfo _character000E01AA =
    {
        0x000E01AA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AA,
        0x000E01AA,
        0x000E01AA
    };

    static _CharacterInfo _character000E01AB =
    {
        0x000E01AB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AB,
        0x000E01AB,
        0x000E01AB
    };

    static _CharacterInfo _character000E01AC =
    {
        0x000E01AC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AC,
        0x000E01AC,
        0x000E01AC
    };

    static _CharacterInfo _character000E01AD =
    {
        0x000E01AD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AD,
        0x000E01AD,
        0x000E01AD
    };

    static _CharacterInfo _character000E01AE =
    {
        0x000E01AE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AE,
        0x000E01AE,
        0x000E01AE
    };

    static _CharacterInfo _character000E01AF =
    {
        0x000E01AF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01AF,
        0x000E01AF,
        0x000E01AF
    };

    static _CharacterInfo _character000E01B0 =
    {
        0x000E01B0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B0,
        0x000E01B0,
        0x000E01B0
    };

    static _CharacterInfo _character000E01B1 =
    {
        0x000E01B1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B1,
        0x000E01B1,
        0x000E01B1
    };

    static _CharacterInfo _character000E01B2 =
    {
        0x000E01B2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B2,
        0x000E01B2,
        0x000E01B2
    };

    static _CharacterInfo _character000E01B3 =
    {
        0x000E01B3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B3,
        0x000E01B3,
        0x000E01B3
    };

    static _CharacterInfo _character000E01B4 =
    {
        0x000E01B4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B4,
        0x000E01B4,
        0x000E01B4
    };

    static _CharacterInfo _character000E01B5 =
    {
        0x000E01B5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B5,
        0x000E01B5,
        0x000E01B5
    };

    static _CharacterInfo _character000E01B6 =
    {
        0x000E01B6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B6,
        0x000E01B6,
        0x000E01B6
    };

    static _CharacterInfo _character000E01B7 =
    {
        0x000E01B7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B7,
        0x000E01B7,
        0x000E01B7
    };

    static _CharacterInfo _character000E01B8 =
    {
        0x000E01B8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B8,
        0x000E01B8,
        0x000E01B8
    };

    static _CharacterInfo _character000E01B9 =
    {
        0x000E01B9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01B9,
        0x000E01B9,
        0x000E01B9
    };

    static _CharacterInfo _character000E01BA =
    {
        0x000E01BA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BA,
        0x000E01BA,
        0x000E01BA
    };

    static _CharacterInfo _character000E01BB =
    {
        0x000E01BB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BB,
        0x000E01BB,
        0x000E01BB
    };

    static _CharacterInfo _character000E01BC =
    {
        0x000E01BC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BC,
        0x000E01BC,
        0x000E01BC
    };

    static _CharacterInfo _character000E01BD =
    {
        0x000E01BD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BD,
        0x000E01BD,
        0x000E01BD
    };

    static _CharacterInfo _character000E01BE =
    {
        0x000E01BE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BE,
        0x000E01BE,
        0x000E01BE
    };

    static _CharacterInfo _character000E01BF =
    {
        0x000E01BF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01BF,
        0x000E01BF,
        0x000E01BF
    };

    static _CharacterInfo _character000E01C0 =
    {
        0x000E01C0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C0,
        0x000E01C0,
        0x000E01C0
    };

    static _CharacterInfo _character000E01C1 =
    {
        0x000E01C1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C1,
        0x000E01C1,
        0x000E01C1
    };

    static _CharacterInfo _character000E01C2 =
    {
        0x000E01C2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C2,
        0x000E01C2,
        0x000E01C2
    };

    static _CharacterInfo _character000E01C3 =
    {
        0x000E01C3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C3,
        0x000E01C3,
        0x000E01C3
    };

    static _CharacterInfo _character000E01C4 =
    {
        0x000E01C4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C4,
        0x000E01C4,
        0x000E01C4
    };

    static _CharacterInfo _character000E01C5 =
    {
        0x000E01C5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C5,
        0x000E01C5,
        0x000E01C5
    };

    static _CharacterInfo _character000E01C6 =
    {
        0x000E01C6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C6,
        0x000E01C6,
        0x000E01C6
    };

    static _CharacterInfo _character000E01C7 =
    {
        0x000E01C7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C7,
        0x000E01C7,
        0x000E01C7
    };

    static _CharacterInfo _character000E01C8 =
    {
        0x000E01C8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C8,
        0x000E01C8,
        0x000E01C8
    };

    static _CharacterInfo _character000E01C9 =
    {
        0x000E01C9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01C9,
        0x000E01C9,
        0x000E01C9
    };

    static _CharacterInfo _character000E01CA =
    {
        0x000E01CA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CA,
        0x000E01CA,
        0x000E01CA
    };

    static _CharacterInfo _character000E01CB =
    {
        0x000E01CB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CB,
        0x000E01CB,
        0x000E01CB
    };

    static _CharacterInfo _character000E01CC =
    {
        0x000E01CC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CC,
        0x000E01CC,
        0x000E01CC
    };

    static _CharacterInfo _character000E01CD =
    {
        0x000E01CD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CD,
        0x000E01CD,
        0x000E01CD
    };

    static _CharacterInfo _character000E01CE =
    {
        0x000E01CE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CE,
        0x000E01CE,
        0x000E01CE
    };

    static _CharacterInfo _character000E01CF =
    {
        0x000E01CF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01CF,
        0x000E01CF,
        0x000E01CF
    };

    static _CharacterInfo _character000E01D0 =
    {
        0x000E01D0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D0,
        0x000E01D0,
        0x000E01D0
    };

    static _CharacterInfo _character000E01D1 =
    {
        0x000E01D1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D1,
        0x000E01D1,
        0x000E01D1
    };

    static _CharacterInfo _character000E01D2 =
    {
        0x000E01D2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D2,
        0x000E01D2,
        0x000E01D2
    };

    static _CharacterInfo _character000E01D3 =
    {
        0x000E01D3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D3,
        0x000E01D3,
        0x000E01D3
    };

    static _CharacterInfo _character000E01D4 =
    {
        0x000E01D4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D4,
        0x000E01D4,
        0x000E01D4
    };

    static _CharacterInfo _character000E01D5 =
    {
        0x000E01D5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D5,
        0x000E01D5,
        0x000E01D5
    };

    static _CharacterInfo _character000E01D6 =
    {
        0x000E01D6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D6,
        0x000E01D6,
        0x000E01D6
    };

    static _CharacterInfo _character000E01D7 =
    {
        0x000E01D7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D7,
        0x000E01D7,
        0x000E01D7
    };

    static _CharacterInfo _character000E01D8 =
    {
        0x000E01D8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D8,
        0x000E01D8,
        0x000E01D8
    };

    static _CharacterInfo _character000E01D9 =
    {
        0x000E01D9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01D9,
        0x000E01D9,
        0x000E01D9
    };

    static _CharacterInfo _character000E01DA =
    {
        0x000E01DA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DA,
        0x000E01DA,
        0x000E01DA
    };

    static _CharacterInfo _character000E01DB =
    {
        0x000E01DB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DB,
        0x000E01DB,
        0x000E01DB
    };

    static _CharacterInfo _character000E01DC =
    {
        0x000E01DC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DC,
        0x000E01DC,
        0x000E01DC
    };

    static _CharacterInfo _character000E01DD =
    {
        0x000E01DD,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DD,
        0x000E01DD,
        0x000E01DD
    };

    static _CharacterInfo _character000E01DE =
    {
        0x000E01DE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DE,
        0x000E01DE,
        0x000E01DE
    };

    static _CharacterInfo _character000E01DF =
    {
        0x000E01DF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01DF,
        0x000E01DF,
        0x000E01DF
    };

    static _CharacterInfo _character000E01E0 =
    {
        0x000E01E0,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E0,
        0x000E01E0,
        0x000E01E0
    };

    static _CharacterInfo _character000E01E1 =
    {
        0x000E01E1,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E1,
        0x000E01E1,
        0x000E01E1
    };

    static _CharacterInfo _character000E01E2 =
    {
        0x000E01E2,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E2,
        0x000E01E2,
        0x000E01E2
    };

    static _CharacterInfo _character000E01E3 =
    {
        0x000E01E3,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E3,
        0x000E01E3,
        0x000E01E3
    };

    static _CharacterInfo _character000E01E4 =
    {
        0x000E01E4,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E4,
        0x000E01E4,
        0x000E01E4
    };

    static _CharacterInfo _character000E01E5 =
    {
        0x000E01E5,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E5,
        0x000E01E5,
        0x000E01E5
    };

    static _CharacterInfo _character000E01E6 =
    {
        0x000E01E6,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E6,
        0x000E01E6,
        0x000E01E6
    };

    static _CharacterInfo _character000E01E7 =
    {
        0x000E01E7,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E7,
        0x000E01E7,
        0x000E01E7
    };

    static _CharacterInfo _character000E01E8 =
    {
        0x000E01E8,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E8,
        0x000E01E8,
        0x000E01E8
    };

    static _CharacterInfo _character000E01E9 =
    {
        0x000E01E9,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01E9,
        0x000E01E9,
        0x000E01E9
    };

    static _CharacterInfo _character000E01EA =
    {
        0x000E01EA,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01EA,
        0x000E01EA,
        0x000E01EA
    };

    static _CharacterInfo _character000E01EB =
    {
        0x000E01EB,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01EB,
        0x000E01EB,
        0x000E01EB
    };

    static _CharacterInfo _character000E01EC =
    {
        0x000E01EC,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01EC,
        0x000E01EC,
        0x000E01EC
    };

    static _CharacterInfo _character000E01ED =
    {
        0x000E01ED,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01ED,
        0x000E01ED,
        0x000E01ED
    };

    static _CharacterInfo _character000E01EE =
    {
        0x000E01EE,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01EE,
        0x000E01EE,
        0x000E01EE
    };

    static _CharacterInfo _character000E01EF =
    {
        0x000E01EF,
        Iso10646::GeneralCategory_Mn,
        0,
        Iso10646::BidirectionalCategory_NSM,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000E01EF,
        0x000E01EF,
        0x000E01EF
    };

    static _CharacterInfo _character000F0000 =
    {
        0x000F0000,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000F0000,
        0x000F0000,
        0x000F0000
    };

    static _CharacterInfo _character000FFFFD =
    {
        0x000FFFFD,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x000FFFFD,
        0x000FFFFD,
        0x000FFFFD
    };

    static _CharacterInfo _character00100000 =
    {
        0x00100000,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x00100000,
        0x00100000,
        0x00100000
    };

    static _CharacterInfo _character0010FFFD =
    {
        0x0010FFFD,
        Iso10646::GeneralCategory_Co,
        0,
        Iso10646::BidirectionalCategory_L,
        Iso10646::DecompositionMappingTag_none,
        0,
        0,
        false,
        0,
        false,
        0,
        false,
        0,
        0,
        false,
        0x0010FFFD,
        0x0010FFFD,
        0x0010FFFD
    };

    static _CharacterInfo * _table300000000[2048] =
    {
        &_character00000000,
        &_character00000001,
        &_character00000002,
        &_character00000003,
        &_character00000004,
        &_character00000005,
        &_character00000006,
        &_character00000007,
        &_character00000008,
        &_character00000009,
        &_character0000000A,
        &_character0000000B,
        &_character0000000C,
        &_character0000000D,
        &_character0000000E,
        &_character0000000F,
        &_character00000010,
        &_character00000011,
        &_character00000012,
        &_character00000013,
        &_character00000014,
        &_character00000015,
        &_character00000016,
        &_character00000017,
        &_character00000018,
        &_character00000019,
        &_character0000001A,
        &_character0000001B,
        &_character0000001C,
        &_character0000001D,
        &_character0000001E,
        &_character0000001F,
        &_character00000020,
        &_character00000021,
        &_character00000022,
        &_character00000023,
        &_character00000024,
        &_character00000025,
        &_character00000026,
        &_character00000027,
        &_character00000028,
        &_character00000029,
        &_character0000002A,
        &_character0000002B,
        &_character0000002C,
        &_character0000002D,
        &_character0000002E,
        &_character0000002F,
        &_character00000030,
        &_character00000031,
        &_character00000032,
        &_character00000033,
        &_character00000034,
        &_character00000035,
        &_character00000036,
        &_character00000037,
        &_character00000038,
        &_character00000039,
        &_character0000003A,
        &_character0000003B,
        &_character0000003C,
        &_character0000003D,
        &_character0000003E,
        &_character0000003F,
        &_character00000040,
        &_character00000041,
        &_character00000042,
        &_character00000043,
        &_character00000044,
        &_character00000045,
        &_character00000046,
        &_character00000047,
        &_character00000048,
        &_character00000049,
        &_character0000004A,
        &_character0000004B,
        &_character0000004C,
        &_character0000004D,
        &_character0000004E,
        &_character0000004F,
        &_character00000050,
        &_character00000051,
        &_character00000052,
        &_character00000053,
        &_character00000054,
        &_character00000055,
        &_character00000056,
        &_character00000057,
        &_character00000058,
        &_character00000059,
        &_character0000005A,
        &_character0000005B,
        &_character0000005C,
        &_character0000005D,
        &_character0000005E,
        &_character0000005F,
        &_character00000060,
        &_character00000061,
        &_character00000062,
        &_character00000063,
        &_character00000064,
        &_character00000065,
        &_character00000066,
        &_character00000067,
        &_character00000068,
        &_character00000069,
        &_character0000006A,
        &_character0000006B,
        &_character0000006C,
        &_character0000006D,
        &_character0000006E,
        &_character0000006F,
        &_character00000070,
        &_character00000071,
        &_character00000072,
        &_character00000073,
        &_character00000074,
        &_character00000075,
        &_character00000076,
        &_character00000077,
        &_character00000078,
        &_character00000079,
        &_character0000007A,
        &_character0000007B,
        &_character0000007C,
        &_character0000007D,
        &_character0000007E,
        &_character0000007F,
        &_character00000080,
        &_character00000081,
        &_character00000082,
        &_character00000083,
        &_character00000084,
        &_character00000085,
        &_character00000086,
        &_character00000087,
        &_character00000088,
        &_character00000089,
        &_character0000008A,
        &_character0000008B,
        &_character0000008C,
        &_character0000008D,
        &_character0000008E,
        &_character0000008F,
        &_character00000090,
        &_character00000091,
        &_character00000092,
        &_character00000093,
        &_character00000094,
        &_character00000095,
        &_character00000096,
        &_character00000097,
        &_character00000098,
        &_character00000099,
        &_character0000009A,
        &_character0000009B,
        &_character0000009C,
        &_character0000009D,
        &_character0000009E,
        &_character0000009F,
        &_character000000A0,
        &_character000000A1,
        &_character000000A2,
        &_character000000A3,
        &_character000000A4,
        &_character000000A5,
        &_character000000A6,
        &_character000000A7,
        &_character000000A8,
        &_character000000A9,
        &_character000000AA,
        &_character000000AB,
        &_character000000AC,
        &_character000000AD,
        &_character000000AE,
        &_character000000AF,
        &_character000000B0,
        &_character000000B1,
        &_character000000B2,
        &_character000000B3,
        &_character000000B4,
        &_character000000B5,
        &_character000000B6,
        &_character000000B7,
        &_character000000B8,
        &_character000000B9,
        &_character000000BA,
        &_character000000BB,
        &_character000000BC,
        &_character000000BD,
        &_character000000BE,
        &_character000000BF,
        &_character000000C0,
        &_character000000C1,
        &_character000000C2,
        &_character000000C3,
        &_character000000C4,
        &_character000000C5,
        &_character000000C6,
        &_character000000C7,
        &_character000000C8,
        &_character000000C9,
        &_character000000CA,
        &_character000000CB,
        &_character000000CC,
        &_character000000CD,
        &_character000000CE,
        &_character000000CF,
        &_character000000D0,
        &_character000000D1,
        &_character000000D2,
        &_character000000D3,
        &_character000000D4,
        &_character000000D5,
        &_character000000D6,
        &_character000000D7,
        &_character000000D8,
        &_character000000D9,
        &_character000000DA,
        &_character000000DB,
        &_character000000DC,
        &_character000000DD,
        &_character000000DE,
        &_character000000DF,
        &_character000000E0,
        &_character000000E1,
        &_character000000E2,
        &_character000000E3,
        &_character000000E4,
        &_character000000E5,
        &_character000000E6,
        &_character000000E7,
        &_character000000E8,
        &_character000000E9,
        &_character000000EA,
        &_character000000EB,
        &_character000000EC,
        &_character000000ED,
        &_character000000EE,
        &_character000000EF,
        &_character000000F0,
        &_character000000F1,
        &_character000000F2,
        &_character000000F3,
        &_character000000F4,
        &_character000000F5,
        &_character000000F6,
        &_character000000F7,
        &_character000000F8,
        &_character000000F9,
        &_character000000FA,
        &_character000000FB,
        &_character000000FC,
        &_character000000FD,
        &_character000000FE,
        &_character000000FF,
        &_character00000100,
        &_character00000101,
        &_character00000102,
        &_character00000103,
        &_character00000104,
        &_character00000105,
        &_character00000106,
        &_character00000107,
        &_character00000108,
        &_character00000109,
        &_character0000010A,
        &_character0000010B,
        &_character0000010C,
        &_character0000010D,
        &_character0000010E,
        &_character0000010F,
        &_character00000110,
        &_character00000111,
        &_character00000112,
        &_character00000113,
        &_character00000114,
        &_character00000115,
        &_character00000116,
        &_character00000117,
        &_character00000118,
        &_character00000119,
        &_character0000011A,
        &_character0000011B,
        &_character0000011C,
        &_character0000011D,
        &_character0000011E,
        &_character0000011F,
        &_character00000120,
        &_character00000121,
        &_character00000122,
        &_character00000123,
        &_character00000124,
        &_character00000125,
        &_character00000126,
        &_character00000127,
        &_character00000128,
        &_character00000129,
        &_character0000012A,
        &_character0000012B,
        &_character0000012C,
        &_character0000012D,
        &_character0000012E,
        &_character0000012F,
        &_character00000130,
        &_character00000131,
        &_character00000132,
        &_character00000133,
        &_character00000134,
        &_character00000135,
        &_character00000136,
        &_character00000137,
        &_character00000138,
        &_character00000139,
        &_character0000013A,
        &_character0000013B,
        &_character0000013C,
        &_character0000013D,
        &_character0000013E,
        &_character0000013F,
        &_character00000140,
        &_character00000141,
        &_character00000142,
        &_character00000143,
        &_character00000144,
        &_character00000145,
        &_character00000146,
        &_character00000147,
        &_character00000148,
        &_character00000149,
        &_character0000014A,
        &_character0000014B,
        &_character0000014C,
        &_character0000014D,
        &_character0000014E,
        &_character0000014F,
        &_character00000150,
        &_character00000151,
        &_character00000152,
        &_character00000153,
        &_character00000154,
        &_character00000155,
        &_character00000156,
        &_character00000157,
        &_character00000158,
        &_character00000159,
        &_character0000015A,
        &_character0000015B,
        &_character0000015C,
        &_character0000015D,
        &_character0000015E,
        &_character0000015F,
        &_character00000160,
        &_character00000161,
        &_character00000162,
        &_character00000163,
        &_character00000164,
        &_character00000165,
        &_character00000166,
        &_character00000167,
        &_character00000168,
        &_character00000169,
        &_character0000016A,
        &_character0000016B,
        &_character0000016C,
        &_character0000016D,
        &_character0000016E,
        &_character0000016F,
        &_character00000170,
        &_character00000171,
        &_character00000172,
        &_character00000173,
        &_character00000174,
        &_character00000175,
        &_character00000176,
        &_character00000177,
        &_character00000178,
        &_character00000179,
        &_character0000017A,
        &_character0000017B,
        &_character0000017C,
        &_character0000017D,
        &_character0000017E,
        &_character0000017F,
        &_character00000180,
        &_character00000181,
        &_character00000182,
        &_character00000183,
        &_character00000184,
        &_character00000185,
        &_character00000186,
        &_character00000187,
        &_character00000188,
        &_character00000189,
        &_character0000018A,
        &_character0000018B,
        &_character0000018C,
        &_character0000018D,
        &_character0000018E,
        &_character0000018F,
        &_character00000190,
        &_character00000191,
        &_character00000192,
        &_character00000193,
        &_character00000194,
        &_character00000195,
        &_character00000196,
        &_character00000197,
        &_character00000198,
        &_character00000199,
        &_character0000019A,
        &_character0000019B,
        &_character0000019C,
        &_character0000019D,
        &_character0000019E,
        &_character0000019F,
        &_character000001A0,
        &_character000001A1,
        &_character000001A2,
        &_character000001A3,
        &_character000001A4,
        &_character000001A5,
        &_character000001A6,
        &_character000001A7,
        &_character000001A8,
        &_character000001A9,
        &_character000001AA,
        &_character000001AB,
        &_character000001AC,
        &_character000001AD,
        &_character000001AE,
        &_character000001AF,
        &_character000001B0,
        &_character000001B1,
        &_character000001B2,
        &_character000001B3,
        &_character000001B4,
        &_character000001B5,
        &_character000001B6,
        &_character000001B7,
        &_character000001B8,
        &_character000001B9,
        &_character000001BA,
        &_character000001BB,
        &_character000001BC,
        &_character000001BD,
        &_character000001BE,
        &_character000001BF,
        &_character000001C0,
        &_character000001C1,
        &_character000001C2,
        &_character000001C3,
        &_character000001C4,
        &_character000001C5,
        &_character000001C6,
        &_character000001C7,
        &_character000001C8,
        &_character000001C9,
        &_character000001CA,
        &_character000001CB,
        &_character000001CC,
        &_character000001CD,
        &_character000001CE,
        &_character000001CF,
        &_character000001D0,
        &_character000001D1,
        &_character000001D2,
        &_character000001D3,
        &_character000001D4,
        &_character000001D5,
        &_character000001D6,
        &_character000001D7,
        &_character000001D8,
        &_character000001D9,
        &_character000001DA,
        &_character000001DB,
        &_character000001DC,
        &_character000001DD,
        &_character000001DE,
        &_character000001DF,
        &_character000001E0,
        &_character000001E1,
        &_character000001E2,
        &_character000001E3,
        &_character000001E4,
        &_character000001E5,
        &_character000001E6,
        &_character000001E7,
        &_character000001E8,
        &_character000001E9,
        &_character000001EA,
        &_character000001EB,
        &_character000001EC,
        &_character000001ED,
        &_character000001EE,
        &_character000001EF,
        &_character000001F0,
        &_character000001F1,
        &_character000001F2,
        &_character000001F3,
        &_character000001F4,
        &_character000001F5,
        &_character000001F6,
        &_character000001F7,
        &_character000001F8,
        &_character000001F9,
        &_character000001FA,
        &_character000001FB,
        &_character000001FC,
        &_character000001FD,
        &_character000001FE,
        &_character000001FF,
        &_character00000200,
        &_character00000201,
        &_character00000202,
        &_character00000203,
        &_character00000204,
        &_character00000205,
        &_character00000206,
        &_character00000207,
        &_character00000208,
        &_character00000209,
        &_character0000020A,
        &_character0000020B,
        &_character0000020C,
        &_character0000020D,
        &_character0000020E,
        &_character0000020F,
        &_character00000210,
        &_character00000211,
        &_character00000212,
        &_character00000213,
        &_character00000214,
        &_character00000215,
        &_character00000216,
        &_character00000217,
        &_character00000218,
        &_character00000219,
        &_character0000021A,
        &_character0000021B,
        &_character0000021C,
        &_character0000021D,
        &_character0000021E,
        &_character0000021F,
        &_character00000220,
        &_character00000221,
        &_character00000222,
        &_character00000223,
        &_character00000224,
        &_character00000225,
        &_character00000226,
        &_character00000227,
        &_character00000228,
        &_character00000229,
        &_character0000022A,
        &_character0000022B,
        &_character0000022C,
        &_character0000022D,
        &_character0000022E,
        &_character0000022F,
        &_character00000230,
        &_character00000231,
        &_character00000232,
        &_character00000233,
        &_character00000234,
        &_character00000235,
        &_character00000236,
        &_character00000237,
        &_character00000238,
        &_character00000239,
        &_character0000023A,
        &_character0000023B,
        &_character0000023C,
        &_character0000023D,
        &_character0000023E,
        &_character0000023F,
        &_character00000240,
        &_character00000241,
        &_character00000242,
        &_character00000243,
        &_character00000244,
        &_character00000245,
        &_character00000246,
        &_character00000247,
        &_character00000248,
        &_character00000249,
        &_character0000024A,
        &_character0000024B,
        &_character0000024C,
        &_character0000024D,
        &_character0000024E,
        &_character0000024F,
        &_character00000250,
        &_character00000251,
        &_character00000252,
        &_character00000253,
        &_character00000254,
        &_character00000255,
        &_character00000256,
        &_character00000257,
        &_character00000258,
        &_character00000259,
        &_character0000025A,
        &_character0000025B,
        &_character0000025C,
        &_character0000025D,
        &_character0000025E,
        &_character0000025F,
        &_character00000260,
        &_character00000261,
        &_character00000262,
        &_character00000263,
        &_character00000264,
        &_character00000265,
        &_character00000266,
        &_character00000267,
        &_character00000268,
        &_character00000269,
        &_character0000026A,
        &_character0000026B,
        &_character0000026C,
        &_character0000026D,
        &_character0000026E,
        &_character0000026F,
        &_character00000270,
        &_character00000271,
        &_character00000272,
        &_character00000273,
        &_character00000274,
        &_character00000275,
        &_character00000276,
        &_character00000277,
        &_character00000278,
        &_character00000279,
        &_character0000027A,
        &_character0000027B,
        &_character0000027C,
        &_character0000027D,
        &_character0000027E,
        &_character0000027F,
        &_character00000280,
        &_character00000281,
        &_character00000282,
        &_character00000283,
        &_character00000284,
        &_character00000285,
        &_character00000286,
        &_character00000287,
        &_character00000288,
        &_character00000289,
        &_character0000028A,
        &_character0000028B,
        &_character0000028C,
        &_character0000028D,
        &_character0000028E,
        &_character0000028F,
        &_character00000290,
        &_character00000291,
        &_character00000292,
        &_character00000293,
        &_character00000294,
        &_character00000295,
        &_character00000296,
        &_character00000297,
        &_character00000298,
        &_character00000299,
        &_character0000029A,
        &_character0000029B,
        &_character0000029C,
        &_character0000029D,
        &_character0000029E,
        &_character0000029F,
        &_character000002A0,
        &_character000002A1,
        &_character000002A2,
        &_character000002A3,
        &_character000002A4,
        &_character000002A5,
        &_character000002A6,
        &_character000002A7,
        &_character000002A8,
        &_character000002A9,
        &_character000002AA,
        &_character000002AB,
        &_character000002AC,
        &_character000002AD,
        &_character000002AE,
        &_character000002AF,
        &_character000002B0,
        &_character000002B1,
        &_character000002B2,
        &_character000002B3,
        &_character000002B4,
        &_character000002B5,
        &_character000002B6,
        &_character000002B7,
        &_character000002B8,
        &_character000002B9,
        &_character000002BA,
        &_character000002BB,
        &_character000002BC,
        &_character000002BD,
        &_character000002BE,
        &_character000002BF,
        &_character000002C0,
        &_character000002C1,
        &_character000002C2,
        &_character000002C3,
        &_character000002C4,
        &_character000002C5,
        &_character000002C6,
        &_character000002C7,
        &_character000002C8,
        &_character000002C9,
        &_character000002CA,
        &_character000002CB,
        &_character000002CC,
        &_character000002CD,
        &_character000002CE,
        &_character000002CF,
        &_character000002D0,
        &_character000002D1,
        &_character000002D2,
        &_character000002D3,
        &_character000002D4,
        &_character000002D5,
        &_character000002D6,
        &_character000002D7,
        &_character000002D8,
        &_character000002D9,
        &_character000002DA,
        &_character000002DB,
        &_character000002DC,
        &_character000002DD,
        &_character000002DE,
        &_character000002DF,
        &_character000002E0,
        &_character000002E1,
        &_character000002E2,
        &_character000002E3,
        &_character000002E4,
        &_character000002E5,
        &_character000002E6,
        &_character000002E7,
        &_character000002E8,
        &_character000002E9,
        &_character000002EA,
        &_character000002EB,
        &_character000002EC,
        &_character000002ED,
        &_character000002EE,
        &_character000002EF,
        &_character000002F0,
        &_character000002F1,
        &_character000002F2,
        &_character000002F3,
        &_character000002F4,
        &_character000002F5,
        &_character000002F6,
        &_character000002F7,
        &_character000002F8,
        &_character000002F9,
        &_character000002FA,
        &_character000002FB,
        &_character000002FC,
        &_character000002FD,
        &_character000002FE,
        &_character000002FF,
        &_character00000300,
        &_character00000301,
        &_character00000302,
        &_character00000303,
        &_character00000304,
        &_character00000305,
        &_character00000306,
        &_character00000307,
        &_character00000308,
        &_character00000309,
        &_character0000030A,
        &_character0000030B,
        &_character0000030C,
        &_character0000030D,
        &_character0000030E,
        &_character0000030F,
        &_character00000310,
        &_character00000311,
        &_character00000312,
        &_character00000313,
        &_character00000314,
        &_character00000315,
        &_character00000316,
        &_character00000317,
        &_character00000318,
        &_character00000319,
        &_character0000031A,
        &_character0000031B,
        &_character0000031C,
        &_character0000031D,
        &_character0000031E,
        &_character0000031F,
        &_character00000320,
        &_character00000321,
        &_character00000322,
        &_character00000323,
        &_character00000324,
        &_character00000325,
        &_character00000326,
        &_character00000327,
        &_character00000328,
        &_character00000329,
        &_character0000032A,
        &_character0000032B,
        &_character0000032C,
        &_character0000032D,
        &_character0000032E,
        &_character0000032F,
        &_character00000330,
        &_character00000331,
        &_character00000332,
        &_character00000333,
        &_character00000334,
        &_character00000335,
        &_character00000336,
        &_character00000337,
        &_character00000338,
        &_character00000339,
        &_character0000033A,
        &_character0000033B,
        &_character0000033C,
        &_character0000033D,
        &_character0000033E,
        &_character0000033F,
        &_character00000340,
        &_character00000341,
        &_character00000342,
        &_character00000343,
        &_character00000344,
        &_character00000345,
        &_character00000346,
        &_character00000347,
        &_character00000348,
        &_character00000349,
        &_character0000034A,
        &_character0000034B,
        &_character0000034C,
        &_character0000034D,
        &_character0000034E,
        &_character0000034F,
        &_character00000350,
        &_character00000351,
        &_character00000352,
        &_character00000353,
        &_character00000354,
        &_character00000355,
        &_character00000356,
        &_character00000357,
        &_character00000358,
        &_character00000359,
        &_character0000035A,
        &_character0000035B,
        &_character0000035C,
        &_character0000035D,
        &_character0000035E,
        &_character0000035F,
        &_character00000360,
        &_character00000361,
        &_character00000362,
        &_character00000363,
        &_character00000364,
        &_character00000365,
        &_character00000366,
        &_character00000367,
        &_character00000368,
        &_character00000369,
        &_character0000036A,
        &_character0000036B,
        &_character0000036C,
        &_character0000036D,
        &_character0000036E,
        &_character0000036F,
        0,
        0,
        0,
        0,
        &_character00000374,
        &_character00000375,
        0,
        0,
        0,
        0,
        &_character0000037A,
        &_character0000037B,
        &_character0000037C,
        &_character0000037D,
        &_character0000037E,
        0,
        0,
        0,
        0,
        0,
        &_character00000384,
        &_character00000385,
        &_character00000386,
        &_character00000387,
        &_character00000388,
        &_character00000389,
        &_character0000038A,
        0,
        &_character0000038C,
        0,
        &_character0000038E,
        &_character0000038F,
        &_character00000390,
        &_character00000391,
        &_character00000392,
        &_character00000393,
        &_character00000394,
        &_character00000395,
        &_character00000396,
        &_character00000397,
        &_character00000398,
        &_character00000399,
        &_character0000039A,
        &_character0000039B,
        &_character0000039C,
        &_character0000039D,
        &_character0000039E,
        &_character0000039F,
        &_character000003A0,
        &_character000003A1,
        0,
        &_character000003A3,
        &_character000003A4,
        &_character000003A5,
        &_character000003A6,
        &_character000003A7,
        &_character000003A8,
        &_character000003A9,
        &_character000003AA,
        &_character000003AB,
        &_character000003AC,
        &_character000003AD,
        &_character000003AE,
        &_character000003AF,
        &_character000003B0,
        &_character000003B1,
        &_character000003B2,
        &_character000003B3,
        &_character000003B4,
        &_character000003B5,
        &_character000003B6,
        &_character000003B7,
        &_character000003B8,
        &_character000003B9,
        &_character000003BA,
        &_character000003BB,
        &_character000003BC,
        &_character000003BD,
        &_character000003BE,
        &_character000003BF,
        &_character000003C0,
        &_character000003C1,
        &_character000003C2,
        &_character000003C3,
        &_character000003C4,
        &_character000003C5,
        &_character000003C6,
        &_character000003C7,
        &_character000003C8,
        &_character000003C9,
        &_character000003CA,
        &_character000003CB,
        &_character000003CC,
        &_character000003CD,
        &_character000003CE,
        0,
        &_character000003D0,
        &_character000003D1,
        &_character000003D2,
        &_character000003D3,
        &_character000003D4,
        &_character000003D5,
        &_character000003D6,
        &_character000003D7,
        &_character000003D8,
        &_character000003D9,
        &_character000003DA,
        &_character000003DB,
        &_character000003DC,
        &_character000003DD,
        &_character000003DE,
        &_character000003DF,
        &_character000003E0,
        &_character000003E1,
        &_character000003E2,
        &_character000003E3,
        &_character000003E4,
        &_character000003E5,
        &_character000003E6,
        &_character000003E7,
        &_character000003E8,
        &_character000003E9,
        &_character000003EA,
        &_character000003EB,
        &_character000003EC,
        &_character000003ED,
        &_character000003EE,
        &_character000003EF,
        &_character000003F0,
        &_character000003F1,
        &_character000003F2,
        &_character000003F3,
        &_character000003F4,
        &_character000003F5,
        &_character000003F6,
        &_character000003F7,
        &_character000003F8,
        &_character000003F9,
        &_character000003FA,
        &_character000003FB,
        &_character000003FC,
        &_character000003FD,
        &_character000003FE,
        &_character000003FF,
        &_character00000400,
        &_character00000401,
        &_character00000402,
        &_character00000403,
        &_character00000404,
        &_character00000405,
        &_character00000406,
        &_character00000407,
        &_character00000408,
        &_character00000409,
        &_character0000040A,
        &_character0000040B,
        &_character0000040C,
        &_character0000040D,
        &_character0000040E,
        &_character0000040F,
        &_character00000410,
        &_character00000411,
        &_character00000412,
        &_character00000413,
        &_character00000414,
        &_character00000415,
        &_character00000416,
        &_character00000417,
        &_character00000418,
        &_character00000419,
        &_character0000041A,
        &_character0000041B,
        &_character0000041C,
        &_character0000041D,
        &_character0000041E,
        &_character0000041F,
        &_character00000420,
        &_character00000421,
        &_character00000422,
        &_character00000423,
        &_character00000424,
        &_character00000425,
        &_character00000426,
        &_character00000427,
        &_character00000428,
        &_character00000429,
        &_character0000042A,
        &_character0000042B,
        &_character0000042C,
        &_character0000042D,
        &_character0000042E,
        &_character0000042F,
        &_character00000430,
        &_character00000431,
        &_character00000432,
        &_character00000433,
        &_character00000434,
        &_character00000435,
        &_character00000436,
        &_character00000437,
        &_character00000438,
        &_character00000439,
        &_character0000043A,
        &_character0000043B,
        &_character0000043C,
        &_character0000043D,
        &_character0000043E,
        &_character0000043F,
        &_character00000440,
        &_character00000441,
        &_character00000442,
        &_character00000443,
        &_character00000444,
        &_character00000445,
        &_character00000446,
        &_character00000447,
        &_character00000448,
        &_character00000449,
        &_character0000044A,
        &_character0000044B,
        &_character0000044C,
        &_character0000044D,
        &_character0000044E,
        &_character0000044F,
        &_character00000450,
        &_character00000451,
        &_character00000452,
        &_character00000453,
        &_character00000454,
        &_character00000455,
        &_character00000456,
        &_character00000457,
        &_character00000458,
        &_character00000459,
        &_character0000045A,
        &_character0000045B,
        &_character0000045C,
        &_character0000045D,
        &_character0000045E,
        &_character0000045F,
        &_character00000460,
        &_character00000461,
        &_character00000462,
        &_character00000463,
        &_character00000464,
        &_character00000465,
        &_character00000466,
        &_character00000467,
        &_character00000468,
        &_character00000469,
        &_character0000046A,
        &_character0000046B,
        &_character0000046C,
        &_character0000046D,
        &_character0000046E,
        &_character0000046F,
        &_character00000470,
        &_character00000471,
        &_character00000472,
        &_character00000473,
        &_character00000474,
        &_character00000475,
        &_character00000476,
        &_character00000477,
        &_character00000478,
        &_character00000479,
        &_character0000047A,
        &_character0000047B,
        &_character0000047C,
        &_character0000047D,
        &_character0000047E,
        &_character0000047F,
        &_character00000480,
        &_character00000481,
        &_character00000482,
        &_character00000483,
        &_character00000484,
        &_character00000485,
        &_character00000486,
        0,
        &_character00000488,
        &_character00000489,
        &_character0000048A,
        &_character0000048B,
        &_character0000048C,
        &_character0000048D,
        &_character0000048E,
        &_character0000048F,
        &_character00000490,
        &_character00000491,
        &_character00000492,
        &_character00000493,
        &_character00000494,
        &_character00000495,
        &_character00000496,
        &_character00000497,
        &_character00000498,
        &_character00000499,
        &_character0000049A,
        &_character0000049B,
        &_character0000049C,
        &_character0000049D,
        &_character0000049E,
        &_character0000049F,
        &_character000004A0,
        &_character000004A1,
        &_character000004A2,
        &_character000004A3,
        &_character000004A4,
        &_character000004A5,
        &_character000004A6,
        &_character000004A7,
        &_character000004A8,
        &_character000004A9,
        &_character000004AA,
        &_character000004AB,
        &_character000004AC,
        &_character000004AD,
        &_character000004AE,
        &_character000004AF,
        &_character000004B0,
        &_character000004B1,
        &_character000004B2,
        &_character000004B3,
        &_character000004B4,
        &_character000004B5,
        &_character000004B6,
        &_character000004B7,
        &_character000004B8,
        &_character000004B9,
        &_character000004BA,
        &_character000004BB,
        &_character000004BC,
        &_character000004BD,
        &_character000004BE,
        &_character000004BF,
        &_character000004C0,
        &_character000004C1,
        &_character000004C2,
        &_character000004C3,
        &_character000004C4,
        &_character000004C5,
        &_character000004C6,
        &_character000004C7,
        &_character000004C8,
        &_character000004C9,
        &_character000004CA,
        &_character000004CB,
        &_character000004CC,
        &_character000004CD,
        &_character000004CE,
        &_character000004CF,
        &_character000004D0,
        &_character000004D1,
        &_character000004D2,
        &_character000004D3,
        &_character000004D4,
        &_character000004D5,
        &_character000004D6,
        &_character000004D7,
        &_character000004D8,
        &_character000004D9,
        &_character000004DA,
        &_character000004DB,
        &_character000004DC,
        &_character000004DD,
        &_character000004DE,
        &_character000004DF,
        &_character000004E0,
        &_character000004E1,
        &_character000004E2,
        &_character000004E3,
        &_character000004E4,
        &_character000004E5,
        &_character000004E6,
        &_character000004E7,
        &_character000004E8,
        &_character000004E9,
        &_character000004EA,
        &_character000004EB,
        &_character000004EC,
        &_character000004ED,
        &_character000004EE,
        &_character000004EF,
        &_character000004F0,
        &_character000004F1,
        &_character000004F2,
        &_character000004F3,
        &_character000004F4,
        &_character000004F5,
        &_character000004F6,
        &_character000004F7,
        &_character000004F8,
        &_character000004F9,
        &_character000004FA,
        &_character000004FB,
        &_character000004FC,
        &_character000004FD,
        &_character000004FE,
        &_character000004FF,
        &_character00000500,
        &_character00000501,
        &_character00000502,
        &_character00000503,
        &_character00000504,
        &_character00000505,
        &_character00000506,
        &_character00000507,
        &_character00000508,
        &_character00000509,
        &_character0000050A,
        &_character0000050B,
        &_character0000050C,
        &_character0000050D,
        &_character0000050E,
        &_character0000050F,
        &_character00000510,
        &_character00000511,
        &_character00000512,
        &_character00000513,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000531,
        &_character00000532,
        &_character00000533,
        &_character00000534,
        &_character00000535,
        &_character00000536,
        &_character00000537,
        &_character00000538,
        &_character00000539,
        &_character0000053A,
        &_character0000053B,
        &_character0000053C,
        &_character0000053D,
        &_character0000053E,
        &_character0000053F,
        &_character00000540,
        &_character00000541,
        &_character00000542,
        &_character00000543,
        &_character00000544,
        &_character00000545,
        &_character00000546,
        &_character00000547,
        &_character00000548,
        &_character00000549,
        &_character0000054A,
        &_character0000054B,
        &_character0000054C,
        &_character0000054D,
        &_character0000054E,
        &_character0000054F,
        &_character00000550,
        &_character00000551,
        &_character00000552,
        &_character00000553,
        &_character00000554,
        &_character00000555,
        &_character00000556,
        0,
        0,
        &_character00000559,
        &_character0000055A,
        &_character0000055B,
        &_character0000055C,
        &_character0000055D,
        &_character0000055E,
        &_character0000055F,
        0,
        &_character00000561,
        &_character00000562,
        &_character00000563,
        &_character00000564,
        &_character00000565,
        &_character00000566,
        &_character00000567,
        &_character00000568,
        &_character00000569,
        &_character0000056A,
        &_character0000056B,
        &_character0000056C,
        &_character0000056D,
        &_character0000056E,
        &_character0000056F,
        &_character00000570,
        &_character00000571,
        &_character00000572,
        &_character00000573,
        &_character00000574,
        &_character00000575,
        &_character00000576,
        &_character00000577,
        &_character00000578,
        &_character00000579,
        &_character0000057A,
        &_character0000057B,
        &_character0000057C,
        &_character0000057D,
        &_character0000057E,
        &_character0000057F,
        &_character00000580,
        &_character00000581,
        &_character00000582,
        &_character00000583,
        &_character00000584,
        &_character00000585,
        &_character00000586,
        &_character00000587,
        0,
        &_character00000589,
        &_character0000058A,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000591,
        &_character00000592,
        &_character00000593,
        &_character00000594,
        &_character00000595,
        &_character00000596,
        &_character00000597,
        &_character00000598,
        &_character00000599,
        &_character0000059A,
        &_character0000059B,
        &_character0000059C,
        &_character0000059D,
        &_character0000059E,
        &_character0000059F,
        &_character000005A0,
        &_character000005A1,
        &_character000005A2,
        &_character000005A3,
        &_character000005A4,
        &_character000005A5,
        &_character000005A6,
        &_character000005A7,
        &_character000005A8,
        &_character000005A9,
        &_character000005AA,
        &_character000005AB,
        &_character000005AC,
        &_character000005AD,
        &_character000005AE,
        &_character000005AF,
        &_character000005B0,
        &_character000005B1,
        &_character000005B2,
        &_character000005B3,
        &_character000005B4,
        &_character000005B5,
        &_character000005B6,
        &_character000005B7,
        &_character000005B8,
        &_character000005B9,
        &_character000005BA,
        &_character000005BB,
        &_character000005BC,
        &_character000005BD,
        &_character000005BE,
        &_character000005BF,
        &_character000005C0,
        &_character000005C1,
        &_character000005C2,
        &_character000005C3,
        &_character000005C4,
        &_character000005C5,
        &_character000005C6,
        &_character000005C7,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000005D0,
        &_character000005D1,
        &_character000005D2,
        &_character000005D3,
        &_character000005D4,
        &_character000005D5,
        &_character000005D6,
        &_character000005D7,
        &_character000005D8,
        &_character000005D9,
        &_character000005DA,
        &_character000005DB,
        &_character000005DC,
        &_character000005DD,
        &_character000005DE,
        &_character000005DF,
        &_character000005E0,
        &_character000005E1,
        &_character000005E2,
        &_character000005E3,
        &_character000005E4,
        &_character000005E5,
        &_character000005E6,
        &_character000005E7,
        &_character000005E8,
        &_character000005E9,
        &_character000005EA,
        0,
        0,
        0,
        0,
        0,
        &_character000005F0,
        &_character000005F1,
        &_character000005F2,
        &_character000005F3,
        &_character000005F4,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000600,
        &_character00000601,
        &_character00000602,
        &_character00000603,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000060B,
        &_character0000060C,
        &_character0000060D,
        &_character0000060E,
        &_character0000060F,
        &_character00000610,
        &_character00000611,
        &_character00000612,
        &_character00000613,
        &_character00000614,
        &_character00000615,
        0,
        0,
        0,
        0,
        0,
        &_character0000061B,
        0,
        0,
        &_character0000061E,
        &_character0000061F,
        0,
        &_character00000621,
        &_character00000622,
        &_character00000623,
        &_character00000624,
        &_character00000625,
        &_character00000626,
        &_character00000627,
        &_character00000628,
        &_character00000629,
        &_character0000062A,
        &_character0000062B,
        &_character0000062C,
        &_character0000062D,
        &_character0000062E,
        &_character0000062F,
        &_character00000630,
        &_character00000631,
        &_character00000632,
        &_character00000633,
        &_character00000634,
        &_character00000635,
        &_character00000636,
        &_character00000637,
        &_character00000638,
        &_character00000639,
        &_character0000063A,
        0,
        0,
        0,
        0,
        0,
        &_character00000640,
        &_character00000641,
        &_character00000642,
        &_character00000643,
        &_character00000644,
        &_character00000645,
        &_character00000646,
        &_character00000647,
        &_character00000648,
        &_character00000649,
        &_character0000064A,
        &_character0000064B,
        &_character0000064C,
        &_character0000064D,
        &_character0000064E,
        &_character0000064F,
        &_character00000650,
        &_character00000651,
        &_character00000652,
        &_character00000653,
        &_character00000654,
        &_character00000655,
        &_character00000656,
        &_character00000657,
        &_character00000658,
        &_character00000659,
        &_character0000065A,
        &_character0000065B,
        &_character0000065C,
        &_character0000065D,
        &_character0000065E,
        0,
        &_character00000660,
        &_character00000661,
        &_character00000662,
        &_character00000663,
        &_character00000664,
        &_character00000665,
        &_character00000666,
        &_character00000667,
        &_character00000668,
        &_character00000669,
        &_character0000066A,
        &_character0000066B,
        &_character0000066C,
        &_character0000066D,
        &_character0000066E,
        &_character0000066F,
        &_character00000670,
        &_character00000671,
        &_character00000672,
        &_character00000673,
        &_character00000674,
        &_character00000675,
        &_character00000676,
        &_character00000677,
        &_character00000678,
        &_character00000679,
        &_character0000067A,
        &_character0000067B,
        &_character0000067C,
        &_character0000067D,
        &_character0000067E,
        &_character0000067F,
        &_character00000680,
        &_character00000681,
        &_character00000682,
        &_character00000683,
        &_character00000684,
        &_character00000685,
        &_character00000686,
        &_character00000687,
        &_character00000688,
        &_character00000689,
        &_character0000068A,
        &_character0000068B,
        &_character0000068C,
        &_character0000068D,
        &_character0000068E,
        &_character0000068F,
        &_character00000690,
        &_character00000691,
        &_character00000692,
        &_character00000693,
        &_character00000694,
        &_character00000695,
        &_character00000696,
        &_character00000697,
        &_character00000698,
        &_character00000699,
        &_character0000069A,
        &_character0000069B,
        &_character0000069C,
        &_character0000069D,
        &_character0000069E,
        &_character0000069F,
        &_character000006A0,
        &_character000006A1,
        &_character000006A2,
        &_character000006A3,
        &_character000006A4,
        &_character000006A5,
        &_character000006A6,
        &_character000006A7,
        &_character000006A8,
        &_character000006A9,
        &_character000006AA,
        &_character000006AB,
        &_character000006AC,
        &_character000006AD,
        &_character000006AE,
        &_character000006AF,
        &_character000006B0,
        &_character000006B1,
        &_character000006B2,
        &_character000006B3,
        &_character000006B4,
        &_character000006B5,
        &_character000006B6,
        &_character000006B7,
        &_character000006B8,
        &_character000006B9,
        &_character000006BA,
        &_character000006BB,
        &_character000006BC,
        &_character000006BD,
        &_character000006BE,
        &_character000006BF,
        &_character000006C0,
        &_character000006C1,
        &_character000006C2,
        &_character000006C3,
        &_character000006C4,
        &_character000006C5,
        &_character000006C6,
        &_character000006C7,
        &_character000006C8,
        &_character000006C9,
        &_character000006CA,
        &_character000006CB,
        &_character000006CC,
        &_character000006CD,
        &_character000006CE,
        &_character000006CF,
        &_character000006D0,
        &_character000006D1,
        &_character000006D2,
        &_character000006D3,
        &_character000006D4,
        &_character000006D5,
        &_character000006D6,
        &_character000006D7,
        &_character000006D8,
        &_character000006D9,
        &_character000006DA,
        &_character000006DB,
        &_character000006DC,
        &_character000006DD,
        &_character000006DE,
        &_character000006DF,
        &_character000006E0,
        &_character000006E1,
        &_character000006E2,
        &_character000006E3,
        &_character000006E4,
        &_character000006E5,
        &_character000006E6,
        &_character000006E7,
        &_character000006E8,
        &_character000006E9,
        &_character000006EA,
        &_character000006EB,
        &_character000006EC,
        &_character000006ED,
        &_character000006EE,
        &_character000006EF,
        &_character000006F0,
        &_character000006F1,
        &_character000006F2,
        &_character000006F3,
        &_character000006F4,
        &_character000006F5,
        &_character000006F6,
        &_character000006F7,
        &_character000006F8,
        &_character000006F9,
        &_character000006FA,
        &_character000006FB,
        &_character000006FC,
        &_character000006FD,
        &_character000006FE,
        &_character000006FF,
        &_character00000700,
        &_character00000701,
        &_character00000702,
        &_character00000703,
        &_character00000704,
        &_character00000705,
        &_character00000706,
        &_character00000707,
        &_character00000708,
        &_character00000709,
        &_character0000070A,
        &_character0000070B,
        &_character0000070C,
        &_character0000070D,
        0,
        &_character0000070F,
        &_character00000710,
        &_character00000711,
        &_character00000712,
        &_character00000713,
        &_character00000714,
        &_character00000715,
        &_character00000716,
        &_character00000717,
        &_character00000718,
        &_character00000719,
        &_character0000071A,
        &_character0000071B,
        &_character0000071C,
        &_character0000071D,
        &_character0000071E,
        &_character0000071F,
        &_character00000720,
        &_character00000721,
        &_character00000722,
        &_character00000723,
        &_character00000724,
        &_character00000725,
        &_character00000726,
        &_character00000727,
        &_character00000728,
        &_character00000729,
        &_character0000072A,
        &_character0000072B,
        &_character0000072C,
        &_character0000072D,
        &_character0000072E,
        &_character0000072F,
        &_character00000730,
        &_character00000731,
        &_character00000732,
        &_character00000733,
        &_character00000734,
        &_character00000735,
        &_character00000736,
        &_character00000737,
        &_character00000738,
        &_character00000739,
        &_character0000073A,
        &_character0000073B,
        &_character0000073C,
        &_character0000073D,
        &_character0000073E,
        &_character0000073F,
        &_character00000740,
        &_character00000741,
        &_character00000742,
        &_character00000743,
        &_character00000744,
        &_character00000745,
        &_character00000746,
        &_character00000747,
        &_character00000748,
        &_character00000749,
        &_character0000074A,
        0,
        0,
        &_character0000074D,
        &_character0000074E,
        &_character0000074F,
        &_character00000750,
        &_character00000751,
        &_character00000752,
        &_character00000753,
        &_character00000754,
        &_character00000755,
        &_character00000756,
        &_character00000757,
        &_character00000758,
        &_character00000759,
        &_character0000075A,
        &_character0000075B,
        &_character0000075C,
        &_character0000075D,
        &_character0000075E,
        &_character0000075F,
        &_character00000760,
        &_character00000761,
        &_character00000762,
        &_character00000763,
        &_character00000764,
        &_character00000765,
        &_character00000766,
        &_character00000767,
        &_character00000768,
        &_character00000769,
        &_character0000076A,
        &_character0000076B,
        &_character0000076C,
        &_character0000076D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000780,
        &_character00000781,
        &_character00000782,
        &_character00000783,
        &_character00000784,
        &_character00000785,
        &_character00000786,
        &_character00000787,
        &_character00000788,
        &_character00000789,
        &_character0000078A,
        &_character0000078B,
        &_character0000078C,
        &_character0000078D,
        &_character0000078E,
        &_character0000078F,
        &_character00000790,
        &_character00000791,
        &_character00000792,
        &_character00000793,
        &_character00000794,
        &_character00000795,
        &_character00000796,
        &_character00000797,
        &_character00000798,
        &_character00000799,
        &_character0000079A,
        &_character0000079B,
        &_character0000079C,
        &_character0000079D,
        &_character0000079E,
        &_character0000079F,
        &_character000007A0,
        &_character000007A1,
        &_character000007A2,
        &_character000007A3,
        &_character000007A4,
        &_character000007A5,
        &_character000007A6,
        &_character000007A7,
        &_character000007A8,
        &_character000007A9,
        &_character000007AA,
        &_character000007AB,
        &_character000007AC,
        &_character000007AD,
        &_character000007AE,
        &_character000007AF,
        &_character000007B0,
        &_character000007B1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000007C0,
        &_character000007C1,
        &_character000007C2,
        &_character000007C3,
        &_character000007C4,
        &_character000007C5,
        &_character000007C6,
        &_character000007C7,
        &_character000007C8,
        &_character000007C9,
        &_character000007CA,
        &_character000007CB,
        &_character000007CC,
        &_character000007CD,
        &_character000007CE,
        &_character000007CF,
        &_character000007D0,
        &_character000007D1,
        &_character000007D2,
        &_character000007D3,
        &_character000007D4,
        &_character000007D5,
        &_character000007D6,
        &_character000007D7,
        &_character000007D8,
        &_character000007D9,
        &_character000007DA,
        &_character000007DB,
        &_character000007DC,
        &_character000007DD,
        &_character000007DE,
        &_character000007DF,
        &_character000007E0,
        &_character000007E1,
        &_character000007E2,
        &_character000007E3,
        &_character000007E4,
        &_character000007E5,
        &_character000007E6,
        &_character000007E7,
        &_character000007E8,
        &_character000007E9,
        &_character000007EA,
        &_character000007EB,
        &_character000007EC,
        &_character000007ED,
        &_character000007EE,
        &_character000007EF,
        &_character000007F0,
        &_character000007F1,
        &_character000007F2,
        &_character000007F3,
        &_character000007F4,
        &_character000007F5,
        &_character000007F6,
        &_character000007F7,
        &_character000007F8,
        &_character000007F9,
        &_character000007FA,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300000800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000901,
        &_character00000902,
        &_character00000903,
        &_character00000904,
        &_character00000905,
        &_character00000906,
        &_character00000907,
        &_character00000908,
        &_character00000909,
        &_character0000090A,
        &_character0000090B,
        &_character0000090C,
        &_character0000090D,
        &_character0000090E,
        &_character0000090F,
        &_character00000910,
        &_character00000911,
        &_character00000912,
        &_character00000913,
        &_character00000914,
        &_character00000915,
        &_character00000916,
        &_character00000917,
        &_character00000918,
        &_character00000919,
        &_character0000091A,
        &_character0000091B,
        &_character0000091C,
        &_character0000091D,
        &_character0000091E,
        &_character0000091F,
        &_character00000920,
        &_character00000921,
        &_character00000922,
        &_character00000923,
        &_character00000924,
        &_character00000925,
        &_character00000926,
        &_character00000927,
        &_character00000928,
        &_character00000929,
        &_character0000092A,
        &_character0000092B,
        &_character0000092C,
        &_character0000092D,
        &_character0000092E,
        &_character0000092F,
        &_character00000930,
        &_character00000931,
        &_character00000932,
        &_character00000933,
        &_character00000934,
        &_character00000935,
        &_character00000936,
        &_character00000937,
        &_character00000938,
        &_character00000939,
        0,
        0,
        &_character0000093C,
        &_character0000093D,
        &_character0000093E,
        &_character0000093F,
        &_character00000940,
        &_character00000941,
        &_character00000942,
        &_character00000943,
        &_character00000944,
        &_character00000945,
        &_character00000946,
        &_character00000947,
        &_character00000948,
        &_character00000949,
        &_character0000094A,
        &_character0000094B,
        &_character0000094C,
        &_character0000094D,
        0,
        0,
        &_character00000950,
        &_character00000951,
        &_character00000952,
        &_character00000953,
        &_character00000954,
        0,
        0,
        0,
        &_character00000958,
        &_character00000959,
        &_character0000095A,
        &_character0000095B,
        &_character0000095C,
        &_character0000095D,
        &_character0000095E,
        &_character0000095F,
        &_character00000960,
        &_character00000961,
        &_character00000962,
        &_character00000963,
        &_character00000964,
        &_character00000965,
        &_character00000966,
        &_character00000967,
        &_character00000968,
        &_character00000969,
        &_character0000096A,
        &_character0000096B,
        &_character0000096C,
        &_character0000096D,
        &_character0000096E,
        &_character0000096F,
        &_character00000970,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000097B,
        &_character0000097C,
        &_character0000097D,
        &_character0000097E,
        &_character0000097F,
        0,
        &_character00000981,
        &_character00000982,
        &_character00000983,
        0,
        &_character00000985,
        &_character00000986,
        &_character00000987,
        &_character00000988,
        &_character00000989,
        &_character0000098A,
        &_character0000098B,
        &_character0000098C,
        0,
        0,
        &_character0000098F,
        &_character00000990,
        0,
        0,
        &_character00000993,
        &_character00000994,
        &_character00000995,
        &_character00000996,
        &_character00000997,
        &_character00000998,
        &_character00000999,
        &_character0000099A,
        &_character0000099B,
        &_character0000099C,
        &_character0000099D,
        &_character0000099E,
        &_character0000099F,
        &_character000009A0,
        &_character000009A1,
        &_character000009A2,
        &_character000009A3,
        &_character000009A4,
        &_character000009A5,
        &_character000009A6,
        &_character000009A7,
        &_character000009A8,
        0,
        &_character000009AA,
        &_character000009AB,
        &_character000009AC,
        &_character000009AD,
        &_character000009AE,
        &_character000009AF,
        &_character000009B0,
        0,
        &_character000009B2,
        0,
        0,
        0,
        &_character000009B6,
        &_character000009B7,
        &_character000009B8,
        &_character000009B9,
        0,
        0,
        &_character000009BC,
        &_character000009BD,
        &_character000009BE,
        &_character000009BF,
        &_character000009C0,
        &_character000009C1,
        &_character000009C2,
        &_character000009C3,
        &_character000009C4,
        0,
        0,
        &_character000009C7,
        &_character000009C8,
        0,
        0,
        &_character000009CB,
        &_character000009CC,
        &_character000009CD,
        &_character000009CE,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000009D7,
        0,
        0,
        0,
        0,
        &_character000009DC,
        &_character000009DD,
        0,
        &_character000009DF,
        &_character000009E0,
        &_character000009E1,
        &_character000009E2,
        &_character000009E3,
        0,
        0,
        &_character000009E6,
        &_character000009E7,
        &_character000009E8,
        &_character000009E9,
        &_character000009EA,
        &_character000009EB,
        &_character000009EC,
        &_character000009ED,
        &_character000009EE,
        &_character000009EF,
        &_character000009F0,
        &_character000009F1,
        &_character000009F2,
        &_character000009F3,
        &_character000009F4,
        &_character000009F5,
        &_character000009F6,
        &_character000009F7,
        &_character000009F8,
        &_character000009F9,
        &_character000009FA,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000A01,
        &_character00000A02,
        &_character00000A03,
        0,
        &_character00000A05,
        &_character00000A06,
        &_character00000A07,
        &_character00000A08,
        &_character00000A09,
        &_character00000A0A,
        0,
        0,
        0,
        0,
        &_character00000A0F,
        &_character00000A10,
        0,
        0,
        &_character00000A13,
        &_character00000A14,
        &_character00000A15,
        &_character00000A16,
        &_character00000A17,
        &_character00000A18,
        &_character00000A19,
        &_character00000A1A,
        &_character00000A1B,
        &_character00000A1C,
        &_character00000A1D,
        &_character00000A1E,
        &_character00000A1F,
        &_character00000A20,
        &_character00000A21,
        &_character00000A22,
        &_character00000A23,
        &_character00000A24,
        &_character00000A25,
        &_character00000A26,
        &_character00000A27,
        &_character00000A28,
        0,
        &_character00000A2A,
        &_character00000A2B,
        &_character00000A2C,
        &_character00000A2D,
        &_character00000A2E,
        &_character00000A2F,
        &_character00000A30,
        0,
        &_character00000A32,
        &_character00000A33,
        0,
        &_character00000A35,
        &_character00000A36,
        0,
        &_character00000A38,
        &_character00000A39,
        0,
        0,
        &_character00000A3C,
        0,
        &_character00000A3E,
        &_character00000A3F,
        &_character00000A40,
        &_character00000A41,
        &_character00000A42,
        0,
        0,
        0,
        0,
        &_character00000A47,
        &_character00000A48,
        0,
        0,
        &_character00000A4B,
        &_character00000A4C,
        &_character00000A4D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000A59,
        &_character00000A5A,
        &_character00000A5B,
        &_character00000A5C,
        0,
        &_character00000A5E,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000A66,
        &_character00000A67,
        &_character00000A68,
        &_character00000A69,
        &_character00000A6A,
        &_character00000A6B,
        &_character00000A6C,
        &_character00000A6D,
        &_character00000A6E,
        &_character00000A6F,
        &_character00000A70,
        &_character00000A71,
        &_character00000A72,
        &_character00000A73,
        &_character00000A74,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000A81,
        &_character00000A82,
        &_character00000A83,
        0,
        &_character00000A85,
        &_character00000A86,
        &_character00000A87,
        &_character00000A88,
        &_character00000A89,
        &_character00000A8A,
        &_character00000A8B,
        &_character00000A8C,
        &_character00000A8D,
        0,
        &_character00000A8F,
        &_character00000A90,
        &_character00000A91,
        0,
        &_character00000A93,
        &_character00000A94,
        &_character00000A95,
        &_character00000A96,
        &_character00000A97,
        &_character00000A98,
        &_character00000A99,
        &_character00000A9A,
        &_character00000A9B,
        &_character00000A9C,
        &_character00000A9D,
        &_character00000A9E,
        &_character00000A9F,
        &_character00000AA0,
        &_character00000AA1,
        &_character00000AA2,
        &_character00000AA3,
        &_character00000AA4,
        &_character00000AA5,
        &_character00000AA6,
        &_character00000AA7,
        &_character00000AA8,
        0,
        &_character00000AAA,
        &_character00000AAB,
        &_character00000AAC,
        &_character00000AAD,
        &_character00000AAE,
        &_character00000AAF,
        &_character00000AB0,
        0,
        &_character00000AB2,
        &_character00000AB3,
        0,
        &_character00000AB5,
        &_character00000AB6,
        &_character00000AB7,
        &_character00000AB8,
        &_character00000AB9,
        0,
        0,
        &_character00000ABC,
        &_character00000ABD,
        &_character00000ABE,
        &_character00000ABF,
        &_character00000AC0,
        &_character00000AC1,
        &_character00000AC2,
        &_character00000AC3,
        &_character00000AC4,
        &_character00000AC5,
        0,
        &_character00000AC7,
        &_character00000AC8,
        &_character00000AC9,
        0,
        &_character00000ACB,
        &_character00000ACC,
        &_character00000ACD,
        0,
        0,
        &_character00000AD0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000AE0,
        &_character00000AE1,
        &_character00000AE2,
        &_character00000AE3,
        0,
        0,
        &_character00000AE6,
        &_character00000AE7,
        &_character00000AE8,
        &_character00000AE9,
        &_character00000AEA,
        &_character00000AEB,
        &_character00000AEC,
        &_character00000AED,
        &_character00000AEE,
        &_character00000AEF,
        0,
        &_character00000AF1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000B01,
        &_character00000B02,
        &_character00000B03,
        0,
        &_character00000B05,
        &_character00000B06,
        &_character00000B07,
        &_character00000B08,
        &_character00000B09,
        &_character00000B0A,
        &_character00000B0B,
        &_character00000B0C,
        0,
        0,
        &_character00000B0F,
        &_character00000B10,
        0,
        0,
        &_character00000B13,
        &_character00000B14,
        &_character00000B15,
        &_character00000B16,
        &_character00000B17,
        &_character00000B18,
        &_character00000B19,
        &_character00000B1A,
        &_character00000B1B,
        &_character00000B1C,
        &_character00000B1D,
        &_character00000B1E,
        &_character00000B1F,
        &_character00000B20,
        &_character00000B21,
        &_character00000B22,
        &_character00000B23,
        &_character00000B24,
        &_character00000B25,
        &_character00000B26,
        &_character00000B27,
        &_character00000B28,
        0,
        &_character00000B2A,
        &_character00000B2B,
        &_character00000B2C,
        &_character00000B2D,
        &_character00000B2E,
        &_character00000B2F,
        &_character00000B30,
        0,
        &_character00000B32,
        &_character00000B33,
        0,
        &_character00000B35,
        &_character00000B36,
        &_character00000B37,
        &_character00000B38,
        &_character00000B39,
        0,
        0,
        &_character00000B3C,
        &_character00000B3D,
        &_character00000B3E,
        &_character00000B3F,
        &_character00000B40,
        &_character00000B41,
        &_character00000B42,
        &_character00000B43,
        0,
        0,
        0,
        &_character00000B47,
        &_character00000B48,
        0,
        0,
        &_character00000B4B,
        &_character00000B4C,
        &_character00000B4D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000B56,
        &_character00000B57,
        0,
        0,
        0,
        0,
        &_character00000B5C,
        &_character00000B5D,
        0,
        &_character00000B5F,
        &_character00000B60,
        &_character00000B61,
        0,
        0,
        0,
        0,
        &_character00000B66,
        &_character00000B67,
        &_character00000B68,
        &_character00000B69,
        &_character00000B6A,
        &_character00000B6B,
        &_character00000B6C,
        &_character00000B6D,
        &_character00000B6E,
        &_character00000B6F,
        &_character00000B70,
        &_character00000B71,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000B82,
        &_character00000B83,
        0,
        &_character00000B85,
        &_character00000B86,
        &_character00000B87,
        &_character00000B88,
        &_character00000B89,
        &_character00000B8A,
        0,
        0,
        0,
        &_character00000B8E,
        &_character00000B8F,
        &_character00000B90,
        0,
        &_character00000B92,
        &_character00000B93,
        &_character00000B94,
        &_character00000B95,
        0,
        0,
        0,
        &_character00000B99,
        &_character00000B9A,
        0,
        &_character00000B9C,
        0,
        &_character00000B9E,
        &_character00000B9F,
        0,
        0,
        0,
        &_character00000BA3,
        &_character00000BA4,
        0,
        0,
        0,
        &_character00000BA8,
        &_character00000BA9,
        &_character00000BAA,
        0,
        0,
        0,
        &_character00000BAE,
        &_character00000BAF,
        &_character00000BB0,
        &_character00000BB1,
        &_character00000BB2,
        &_character00000BB3,
        &_character00000BB4,
        &_character00000BB5,
        &_character00000BB6,
        &_character00000BB7,
        &_character00000BB8,
        &_character00000BB9,
        0,
        0,
        0,
        0,
        &_character00000BBE,
        &_character00000BBF,
        &_character00000BC0,
        &_character00000BC1,
        &_character00000BC2,
        0,
        0,
        0,
        &_character00000BC6,
        &_character00000BC7,
        &_character00000BC8,
        0,
        &_character00000BCA,
        &_character00000BCB,
        &_character00000BCC,
        &_character00000BCD,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000BD7,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000BE6,
        &_character00000BE7,
        &_character00000BE8,
        &_character00000BE9,
        &_character00000BEA,
        &_character00000BEB,
        &_character00000BEC,
        &_character00000BED,
        &_character00000BEE,
        &_character00000BEF,
        &_character00000BF0,
        &_character00000BF1,
        &_character00000BF2,
        &_character00000BF3,
        &_character00000BF4,
        &_character00000BF5,
        &_character00000BF6,
        &_character00000BF7,
        &_character00000BF8,
        &_character00000BF9,
        &_character00000BFA,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000C01,
        &_character00000C02,
        &_character00000C03,
        0,
        &_character00000C05,
        &_character00000C06,
        &_character00000C07,
        &_character00000C08,
        &_character00000C09,
        &_character00000C0A,
        &_character00000C0B,
        &_character00000C0C,
        0,
        &_character00000C0E,
        &_character00000C0F,
        &_character00000C10,
        0,
        &_character00000C12,
        &_character00000C13,
        &_character00000C14,
        &_character00000C15,
        &_character00000C16,
        &_character00000C17,
        &_character00000C18,
        &_character00000C19,
        &_character00000C1A,
        &_character00000C1B,
        &_character00000C1C,
        &_character00000C1D,
        &_character00000C1E,
        &_character00000C1F,
        &_character00000C20,
        &_character00000C21,
        &_character00000C22,
        &_character00000C23,
        &_character00000C24,
        &_character00000C25,
        &_character00000C26,
        &_character00000C27,
        &_character00000C28,
        0,
        &_character00000C2A,
        &_character00000C2B,
        &_character00000C2C,
        &_character00000C2D,
        &_character00000C2E,
        &_character00000C2F,
        &_character00000C30,
        &_character00000C31,
        &_character00000C32,
        &_character00000C33,
        0,
        &_character00000C35,
        &_character00000C36,
        &_character00000C37,
        &_character00000C38,
        &_character00000C39,
        0,
        0,
        0,
        0,
        &_character00000C3E,
        &_character00000C3F,
        &_character00000C40,
        &_character00000C41,
        &_character00000C42,
        &_character00000C43,
        &_character00000C44,
        0,
        &_character00000C46,
        &_character00000C47,
        &_character00000C48,
        0,
        &_character00000C4A,
        &_character00000C4B,
        &_character00000C4C,
        &_character00000C4D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000C55,
        &_character00000C56,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000C60,
        &_character00000C61,
        0,
        0,
        0,
        0,
        &_character00000C66,
        &_character00000C67,
        &_character00000C68,
        &_character00000C69,
        &_character00000C6A,
        &_character00000C6B,
        &_character00000C6C,
        &_character00000C6D,
        &_character00000C6E,
        &_character00000C6F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000C82,
        &_character00000C83,
        0,
        &_character00000C85,
        &_character00000C86,
        &_character00000C87,
        &_character00000C88,
        &_character00000C89,
        &_character00000C8A,
        &_character00000C8B,
        &_character00000C8C,
        0,
        &_character00000C8E,
        &_character00000C8F,
        &_character00000C90,
        0,
        &_character00000C92,
        &_character00000C93,
        &_character00000C94,
        &_character00000C95,
        &_character00000C96,
        &_character00000C97,
        &_character00000C98,
        &_character00000C99,
        &_character00000C9A,
        &_character00000C9B,
        &_character00000C9C,
        &_character00000C9D,
        &_character00000C9E,
        &_character00000C9F,
        &_character00000CA0,
        &_character00000CA1,
        &_character00000CA2,
        &_character00000CA3,
        &_character00000CA4,
        &_character00000CA5,
        &_character00000CA6,
        &_character00000CA7,
        &_character00000CA8,
        0,
        &_character00000CAA,
        &_character00000CAB,
        &_character00000CAC,
        &_character00000CAD,
        &_character00000CAE,
        &_character00000CAF,
        &_character00000CB0,
        &_character00000CB1,
        &_character00000CB2,
        &_character00000CB3,
        0,
        &_character00000CB5,
        &_character00000CB6,
        &_character00000CB7,
        &_character00000CB8,
        &_character00000CB9,
        0,
        0,
        &_character00000CBC,
        &_character00000CBD,
        &_character00000CBE,
        &_character00000CBF,
        &_character00000CC0,
        &_character00000CC1,
        &_character00000CC2,
        &_character00000CC3,
        &_character00000CC4,
        0,
        &_character00000CC6,
        &_character00000CC7,
        &_character00000CC8,
        0,
        &_character00000CCA,
        &_character00000CCB,
        &_character00000CCC,
        &_character00000CCD,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000CD5,
        &_character00000CD6,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000CDE,
        0,
        &_character00000CE0,
        &_character00000CE1,
        &_character00000CE2,
        &_character00000CE3,
        0,
        0,
        &_character00000CE6,
        &_character00000CE7,
        &_character00000CE8,
        &_character00000CE9,
        &_character00000CEA,
        &_character00000CEB,
        &_character00000CEC,
        &_character00000CED,
        &_character00000CEE,
        &_character00000CEF,
        0,
        &_character00000CF1,
        &_character00000CF2,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000D02,
        &_character00000D03,
        0,
        &_character00000D05,
        &_character00000D06,
        &_character00000D07,
        &_character00000D08,
        &_character00000D09,
        &_character00000D0A,
        &_character00000D0B,
        &_character00000D0C,
        0,
        &_character00000D0E,
        &_character00000D0F,
        &_character00000D10,
        0,
        &_character00000D12,
        &_character00000D13,
        &_character00000D14,
        &_character00000D15,
        &_character00000D16,
        &_character00000D17,
        &_character00000D18,
        &_character00000D19,
        &_character00000D1A,
        &_character00000D1B,
        &_character00000D1C,
        &_character00000D1D,
        &_character00000D1E,
        &_character00000D1F,
        &_character00000D20,
        &_character00000D21,
        &_character00000D22,
        &_character00000D23,
        &_character00000D24,
        &_character00000D25,
        &_character00000D26,
        &_character00000D27,
        &_character00000D28,
        0,
        &_character00000D2A,
        &_character00000D2B,
        &_character00000D2C,
        &_character00000D2D,
        &_character00000D2E,
        &_character00000D2F,
        &_character00000D30,
        &_character00000D31,
        &_character00000D32,
        &_character00000D33,
        &_character00000D34,
        &_character00000D35,
        &_character00000D36,
        &_character00000D37,
        &_character00000D38,
        &_character00000D39,
        0,
        0,
        0,
        0,
        &_character00000D3E,
        &_character00000D3F,
        &_character00000D40,
        &_character00000D41,
        &_character00000D42,
        &_character00000D43,
        0,
        0,
        &_character00000D46,
        &_character00000D47,
        &_character00000D48,
        0,
        &_character00000D4A,
        &_character00000D4B,
        &_character00000D4C,
        &_character00000D4D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000D57,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000D60,
        &_character00000D61,
        0,
        0,
        0,
        0,
        &_character00000D66,
        &_character00000D67,
        &_character00000D68,
        &_character00000D69,
        &_character00000D6A,
        &_character00000D6B,
        &_character00000D6C,
        &_character00000D6D,
        &_character00000D6E,
        &_character00000D6F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000D82,
        &_character00000D83,
        0,
        &_character00000D85,
        &_character00000D86,
        &_character00000D87,
        &_character00000D88,
        &_character00000D89,
        &_character00000D8A,
        &_character00000D8B,
        &_character00000D8C,
        &_character00000D8D,
        &_character00000D8E,
        &_character00000D8F,
        &_character00000D90,
        &_character00000D91,
        &_character00000D92,
        &_character00000D93,
        &_character00000D94,
        &_character00000D95,
        &_character00000D96,
        0,
        0,
        0,
        &_character00000D9A,
        &_character00000D9B,
        &_character00000D9C,
        &_character00000D9D,
        &_character00000D9E,
        &_character00000D9F,
        &_character00000DA0,
        &_character00000DA1,
        &_character00000DA2,
        &_character00000DA3,
        &_character00000DA4,
        &_character00000DA5,
        &_character00000DA6,
        &_character00000DA7,
        &_character00000DA8,
        &_character00000DA9,
        &_character00000DAA,
        &_character00000DAB,
        &_character00000DAC,
        &_character00000DAD,
        &_character00000DAE,
        &_character00000DAF,
        &_character00000DB0,
        &_character00000DB1,
        0,
        &_character00000DB3,
        &_character00000DB4,
        &_character00000DB5,
        &_character00000DB6,
        &_character00000DB7,
        &_character00000DB8,
        &_character00000DB9,
        &_character00000DBA,
        &_character00000DBB,
        0,
        &_character00000DBD,
        0,
        0,
        &_character00000DC0,
        &_character00000DC1,
        &_character00000DC2,
        &_character00000DC3,
        &_character00000DC4,
        &_character00000DC5,
        &_character00000DC6,
        0,
        0,
        0,
        &_character00000DCA,
        0,
        0,
        0,
        0,
        &_character00000DCF,
        &_character00000DD0,
        &_character00000DD1,
        &_character00000DD2,
        &_character00000DD3,
        &_character00000DD4,
        0,
        &_character00000DD6,
        0,
        &_character00000DD8,
        &_character00000DD9,
        &_character00000DDA,
        &_character00000DDB,
        &_character00000DDC,
        &_character00000DDD,
        &_character00000DDE,
        &_character00000DDF,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000DF2,
        &_character00000DF3,
        &_character00000DF4,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000E01,
        &_character00000E02,
        &_character00000E03,
        &_character00000E04,
        &_character00000E05,
        &_character00000E06,
        &_character00000E07,
        &_character00000E08,
        &_character00000E09,
        &_character00000E0A,
        &_character00000E0B,
        &_character00000E0C,
        &_character00000E0D,
        &_character00000E0E,
        &_character00000E0F,
        &_character00000E10,
        &_character00000E11,
        &_character00000E12,
        &_character00000E13,
        &_character00000E14,
        &_character00000E15,
        &_character00000E16,
        &_character00000E17,
        &_character00000E18,
        &_character00000E19,
        &_character00000E1A,
        &_character00000E1B,
        &_character00000E1C,
        &_character00000E1D,
        &_character00000E1E,
        &_character00000E1F,
        &_character00000E20,
        &_character00000E21,
        &_character00000E22,
        &_character00000E23,
        &_character00000E24,
        &_character00000E25,
        &_character00000E26,
        &_character00000E27,
        &_character00000E28,
        &_character00000E29,
        &_character00000E2A,
        &_character00000E2B,
        &_character00000E2C,
        &_character00000E2D,
        &_character00000E2E,
        &_character00000E2F,
        &_character00000E30,
        &_character00000E31,
        &_character00000E32,
        &_character00000E33,
        &_character00000E34,
        &_character00000E35,
        &_character00000E36,
        &_character00000E37,
        &_character00000E38,
        &_character00000E39,
        &_character00000E3A,
        0,
        0,
        0,
        0,
        &_character00000E3F,
        &_character00000E40,
        &_character00000E41,
        &_character00000E42,
        &_character00000E43,
        &_character00000E44,
        &_character00000E45,
        &_character00000E46,
        &_character00000E47,
        &_character00000E48,
        &_character00000E49,
        &_character00000E4A,
        &_character00000E4B,
        &_character00000E4C,
        &_character00000E4D,
        &_character00000E4E,
        &_character00000E4F,
        &_character00000E50,
        &_character00000E51,
        &_character00000E52,
        &_character00000E53,
        &_character00000E54,
        &_character00000E55,
        &_character00000E56,
        &_character00000E57,
        &_character00000E58,
        &_character00000E59,
        &_character00000E5A,
        &_character00000E5B,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000E81,
        &_character00000E82,
        0,
        &_character00000E84,
        0,
        0,
        &_character00000E87,
        &_character00000E88,
        0,
        &_character00000E8A,
        0,
        0,
        &_character00000E8D,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000E94,
        &_character00000E95,
        &_character00000E96,
        &_character00000E97,
        0,
        &_character00000E99,
        &_character00000E9A,
        &_character00000E9B,
        &_character00000E9C,
        &_character00000E9D,
        &_character00000E9E,
        &_character00000E9F,
        0,
        &_character00000EA1,
        &_character00000EA2,
        &_character00000EA3,
        0,
        &_character00000EA5,
        0,
        &_character00000EA7,
        0,
        0,
        &_character00000EAA,
        &_character00000EAB,
        0,
        &_character00000EAD,
        &_character00000EAE,
        &_character00000EAF,
        &_character00000EB0,
        &_character00000EB1,
        &_character00000EB2,
        &_character00000EB3,
        &_character00000EB4,
        &_character00000EB5,
        &_character00000EB6,
        &_character00000EB7,
        &_character00000EB8,
        &_character00000EB9,
        0,
        &_character00000EBB,
        &_character00000EBC,
        &_character00000EBD,
        0,
        0,
        &_character00000EC0,
        &_character00000EC1,
        &_character00000EC2,
        &_character00000EC3,
        &_character00000EC4,
        0,
        &_character00000EC6,
        0,
        &_character00000EC8,
        &_character00000EC9,
        &_character00000ECA,
        &_character00000ECB,
        &_character00000ECC,
        &_character00000ECD,
        0,
        0,
        &_character00000ED0,
        &_character00000ED1,
        &_character00000ED2,
        &_character00000ED3,
        &_character00000ED4,
        &_character00000ED5,
        &_character00000ED6,
        &_character00000ED7,
        &_character00000ED8,
        &_character00000ED9,
        0,
        0,
        &_character00000EDC,
        &_character00000EDD,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000F00,
        &_character00000F01,
        &_character00000F02,
        &_character00000F03,
        &_character00000F04,
        &_character00000F05,
        &_character00000F06,
        &_character00000F07,
        &_character00000F08,
        &_character00000F09,
        &_character00000F0A,
        &_character00000F0B,
        &_character00000F0C,
        &_character00000F0D,
        &_character00000F0E,
        &_character00000F0F,
        &_character00000F10,
        &_character00000F11,
        &_character00000F12,
        &_character00000F13,
        &_character00000F14,
        &_character00000F15,
        &_character00000F16,
        &_character00000F17,
        &_character00000F18,
        &_character00000F19,
        &_character00000F1A,
        &_character00000F1B,
        &_character00000F1C,
        &_character00000F1D,
        &_character00000F1E,
        &_character00000F1F,
        &_character00000F20,
        &_character00000F21,
        &_character00000F22,
        &_character00000F23,
        &_character00000F24,
        &_character00000F25,
        &_character00000F26,
        &_character00000F27,
        &_character00000F28,
        &_character00000F29,
        &_character00000F2A,
        &_character00000F2B,
        &_character00000F2C,
        &_character00000F2D,
        &_character00000F2E,
        &_character00000F2F,
        &_character00000F30,
        &_character00000F31,
        &_character00000F32,
        &_character00000F33,
        &_character00000F34,
        &_character00000F35,
        &_character00000F36,
        &_character00000F37,
        &_character00000F38,
        &_character00000F39,
        &_character00000F3A,
        &_character00000F3B,
        &_character00000F3C,
        &_character00000F3D,
        &_character00000F3E,
        &_character00000F3F,
        &_character00000F40,
        &_character00000F41,
        &_character00000F42,
        &_character00000F43,
        &_character00000F44,
        &_character00000F45,
        &_character00000F46,
        &_character00000F47,
        0,
        &_character00000F49,
        &_character00000F4A,
        &_character00000F4B,
        &_character00000F4C,
        &_character00000F4D,
        &_character00000F4E,
        &_character00000F4F,
        &_character00000F50,
        &_character00000F51,
        &_character00000F52,
        &_character00000F53,
        &_character00000F54,
        &_character00000F55,
        &_character00000F56,
        &_character00000F57,
        &_character00000F58,
        &_character00000F59,
        &_character00000F5A,
        &_character00000F5B,
        &_character00000F5C,
        &_character00000F5D,
        &_character00000F5E,
        &_character00000F5F,
        &_character00000F60,
        &_character00000F61,
        &_character00000F62,
        &_character00000F63,
        &_character00000F64,
        &_character00000F65,
        &_character00000F66,
        &_character00000F67,
        &_character00000F68,
        &_character00000F69,
        &_character00000F6A,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00000F71,
        &_character00000F72,
        &_character00000F73,
        &_character00000F74,
        &_character00000F75,
        &_character00000F76,
        &_character00000F77,
        &_character00000F78,
        &_character00000F79,
        &_character00000F7A,
        &_character00000F7B,
        &_character00000F7C,
        &_character00000F7D,
        &_character00000F7E,
        &_character00000F7F,
        &_character00000F80,
        &_character00000F81,
        &_character00000F82,
        &_character00000F83,
        &_character00000F84,
        &_character00000F85,
        &_character00000F86,
        &_character00000F87,
        &_character00000F88,
        &_character00000F89,
        &_character00000F8A,
        &_character00000F8B,
        0,
        0,
        0,
        0,
        &_character00000F90,
        &_character00000F91,
        &_character00000F92,
        &_character00000F93,
        &_character00000F94,
        &_character00000F95,
        &_character00000F96,
        &_character00000F97,
        0,
        &_character00000F99,
        &_character00000F9A,
        &_character00000F9B,
        &_character00000F9C,
        &_character00000F9D,
        &_character00000F9E,
        &_character00000F9F,
        &_character00000FA0,
        &_character00000FA1,
        &_character00000FA2,
        &_character00000FA3,
        &_character00000FA4,
        &_character00000FA5,
        &_character00000FA6,
        &_character00000FA7,
        &_character00000FA8,
        &_character00000FA9,
        &_character00000FAA,
        &_character00000FAB,
        &_character00000FAC,
        &_character00000FAD,
        &_character00000FAE,
        &_character00000FAF,
        &_character00000FB0,
        &_character00000FB1,
        &_character00000FB2,
        &_character00000FB3,
        &_character00000FB4,
        &_character00000FB5,
        &_character00000FB6,
        &_character00000FB7,
        &_character00000FB8,
        &_character00000FB9,
        &_character00000FBA,
        &_character00000FBB,
        &_character00000FBC,
        0,
        &_character00000FBE,
        &_character00000FBF,
        &_character00000FC0,
        &_character00000FC1,
        &_character00000FC2,
        &_character00000FC3,
        &_character00000FC4,
        &_character00000FC5,
        &_character00000FC6,
        &_character00000FC7,
        &_character00000FC8,
        &_character00000FC9,
        &_character00000FCA,
        &_character00000FCB,
        &_character00000FCC,
        0,
        0,
        &_character00000FCF,
        &_character00000FD0,
        &_character00000FD1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300001000[2048] =
    {
        &_character00001000,
        &_character00001001,
        &_character00001002,
        &_character00001003,
        &_character00001004,
        &_character00001005,
        &_character00001006,
        &_character00001007,
        &_character00001008,
        &_character00001009,
        &_character0000100A,
        &_character0000100B,
        &_character0000100C,
        &_character0000100D,
        &_character0000100E,
        &_character0000100F,
        &_character00001010,
        &_character00001011,
        &_character00001012,
        &_character00001013,
        &_character00001014,
        &_character00001015,
        &_character00001016,
        &_character00001017,
        &_character00001018,
        &_character00001019,
        &_character0000101A,
        &_character0000101B,
        &_character0000101C,
        &_character0000101D,
        &_character0000101E,
        &_character0000101F,
        &_character00001020,
        &_character00001021,
        0,
        &_character00001023,
        &_character00001024,
        &_character00001025,
        &_character00001026,
        &_character00001027,
        0,
        &_character00001029,
        &_character0000102A,
        0,
        &_character0000102C,
        &_character0000102D,
        &_character0000102E,
        &_character0000102F,
        &_character00001030,
        &_character00001031,
        &_character00001032,
        0,
        0,
        0,
        &_character00001036,
        &_character00001037,
        &_character00001038,
        &_character00001039,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001040,
        &_character00001041,
        &_character00001042,
        &_character00001043,
        &_character00001044,
        &_character00001045,
        &_character00001046,
        &_character00001047,
        &_character00001048,
        &_character00001049,
        &_character0000104A,
        &_character0000104B,
        &_character0000104C,
        &_character0000104D,
        &_character0000104E,
        &_character0000104F,
        &_character00001050,
        &_character00001051,
        &_character00001052,
        &_character00001053,
        &_character00001054,
        &_character00001055,
        &_character00001056,
        &_character00001057,
        &_character00001058,
        &_character00001059,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000010A0,
        &_character000010A1,
        &_character000010A2,
        &_character000010A3,
        &_character000010A4,
        &_character000010A5,
        &_character000010A6,
        &_character000010A7,
        &_character000010A8,
        &_character000010A9,
        &_character000010AA,
        &_character000010AB,
        &_character000010AC,
        &_character000010AD,
        &_character000010AE,
        &_character000010AF,
        &_character000010B0,
        &_character000010B1,
        &_character000010B2,
        &_character000010B3,
        &_character000010B4,
        &_character000010B5,
        &_character000010B6,
        &_character000010B7,
        &_character000010B8,
        &_character000010B9,
        &_character000010BA,
        &_character000010BB,
        &_character000010BC,
        &_character000010BD,
        &_character000010BE,
        &_character000010BF,
        &_character000010C0,
        &_character000010C1,
        &_character000010C2,
        &_character000010C3,
        &_character000010C4,
        &_character000010C5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000010D0,
        &_character000010D1,
        &_character000010D2,
        &_character000010D3,
        &_character000010D4,
        &_character000010D5,
        &_character000010D6,
        &_character000010D7,
        &_character000010D8,
        &_character000010D9,
        &_character000010DA,
        &_character000010DB,
        &_character000010DC,
        &_character000010DD,
        &_character000010DE,
        &_character000010DF,
        &_character000010E0,
        &_character000010E1,
        &_character000010E2,
        &_character000010E3,
        &_character000010E4,
        &_character000010E5,
        &_character000010E6,
        &_character000010E7,
        &_character000010E8,
        &_character000010E9,
        &_character000010EA,
        &_character000010EB,
        &_character000010EC,
        &_character000010ED,
        &_character000010EE,
        &_character000010EF,
        &_character000010F0,
        &_character000010F1,
        &_character000010F2,
        &_character000010F3,
        &_character000010F4,
        &_character000010F5,
        &_character000010F6,
        &_character000010F7,
        &_character000010F8,
        &_character000010F9,
        &_character000010FA,
        &_character000010FB,
        &_character000010FC,
        0,
        0,
        0,
        &_character00001100,
        &_character00001101,
        &_character00001102,
        &_character00001103,
        &_character00001104,
        &_character00001105,
        &_character00001106,
        &_character00001107,
        &_character00001108,
        &_character00001109,
        &_character0000110A,
        &_character0000110B,
        &_character0000110C,
        &_character0000110D,
        &_character0000110E,
        &_character0000110F,
        &_character00001110,
        &_character00001111,
        &_character00001112,
        &_character00001113,
        &_character00001114,
        &_character00001115,
        &_character00001116,
        &_character00001117,
        &_character00001118,
        &_character00001119,
        &_character0000111A,
        &_character0000111B,
        &_character0000111C,
        &_character0000111D,
        &_character0000111E,
        &_character0000111F,
        &_character00001120,
        &_character00001121,
        &_character00001122,
        &_character00001123,
        &_character00001124,
        &_character00001125,
        &_character00001126,
        &_character00001127,
        &_character00001128,
        &_character00001129,
        &_character0000112A,
        &_character0000112B,
        &_character0000112C,
        &_character0000112D,
        &_character0000112E,
        &_character0000112F,
        &_character00001130,
        &_character00001131,
        &_character00001132,
        &_character00001133,
        &_character00001134,
        &_character00001135,
        &_character00001136,
        &_character00001137,
        &_character00001138,
        &_character00001139,
        &_character0000113A,
        &_character0000113B,
        &_character0000113C,
        &_character0000113D,
        &_character0000113E,
        &_character0000113F,
        &_character00001140,
        &_character00001141,
        &_character00001142,
        &_character00001143,
        &_character00001144,
        &_character00001145,
        &_character00001146,
        &_character00001147,
        &_character00001148,
        &_character00001149,
        &_character0000114A,
        &_character0000114B,
        &_character0000114C,
        &_character0000114D,
        &_character0000114E,
        &_character0000114F,
        &_character00001150,
        &_character00001151,
        &_character00001152,
        &_character00001153,
        &_character00001154,
        &_character00001155,
        &_character00001156,
        &_character00001157,
        &_character00001158,
        &_character00001159,
        0,
        0,
        0,
        0,
        0,
        &_character0000115F,
        &_character00001160,
        &_character00001161,
        &_character00001162,
        &_character00001163,
        &_character00001164,
        &_character00001165,
        &_character00001166,
        &_character00001167,
        &_character00001168,
        &_character00001169,
        &_character0000116A,
        &_character0000116B,
        &_character0000116C,
        &_character0000116D,
        &_character0000116E,
        &_character0000116F,
        &_character00001170,
        &_character00001171,
        &_character00001172,
        &_character00001173,
        &_character00001174,
        &_character00001175,
        &_character00001176,
        &_character00001177,
        &_character00001178,
        &_character00001179,
        &_character0000117A,
        &_character0000117B,
        &_character0000117C,
        &_character0000117D,
        &_character0000117E,
        &_character0000117F,
        &_character00001180,
        &_character00001181,
        &_character00001182,
        &_character00001183,
        &_character00001184,
        &_character00001185,
        &_character00001186,
        &_character00001187,
        &_character00001188,
        &_character00001189,
        &_character0000118A,
        &_character0000118B,
        &_character0000118C,
        &_character0000118D,
        &_character0000118E,
        &_character0000118F,
        &_character00001190,
        &_character00001191,
        &_character00001192,
        &_character00001193,
        &_character00001194,
        &_character00001195,
        &_character00001196,
        &_character00001197,
        &_character00001198,
        &_character00001199,
        &_character0000119A,
        &_character0000119B,
        &_character0000119C,
        &_character0000119D,
        &_character0000119E,
        &_character0000119F,
        &_character000011A0,
        &_character000011A1,
        &_character000011A2,
        0,
        0,
        0,
        0,
        0,
        &_character000011A8,
        &_character000011A9,
        &_character000011AA,
        &_character000011AB,
        &_character000011AC,
        &_character000011AD,
        &_character000011AE,
        &_character000011AF,
        &_character000011B0,
        &_character000011B1,
        &_character000011B2,
        &_character000011B3,
        &_character000011B4,
        &_character000011B5,
        &_character000011B6,
        &_character000011B7,
        &_character000011B8,
        &_character000011B9,
        &_character000011BA,
        &_character000011BB,
        &_character000011BC,
        &_character000011BD,
        &_character000011BE,
        &_character000011BF,
        &_character000011C0,
        &_character000011C1,
        &_character000011C2,
        &_character000011C3,
        &_character000011C4,
        &_character000011C5,
        &_character000011C6,
        &_character000011C7,
        &_character000011C8,
        &_character000011C9,
        &_character000011CA,
        &_character000011CB,
        &_character000011CC,
        &_character000011CD,
        &_character000011CE,
        &_character000011CF,
        &_character000011D0,
        &_character000011D1,
        &_character000011D2,
        &_character000011D3,
        &_character000011D4,
        &_character000011D5,
        &_character000011D6,
        &_character000011D7,
        &_character000011D8,
        &_character000011D9,
        &_character000011DA,
        &_character000011DB,
        &_character000011DC,
        &_character000011DD,
        &_character000011DE,
        &_character000011DF,
        &_character000011E0,
        &_character000011E1,
        &_character000011E2,
        &_character000011E3,
        &_character000011E4,
        &_character000011E5,
        &_character000011E6,
        &_character000011E7,
        &_character000011E8,
        &_character000011E9,
        &_character000011EA,
        &_character000011EB,
        &_character000011EC,
        &_character000011ED,
        &_character000011EE,
        &_character000011EF,
        &_character000011F0,
        &_character000011F1,
        &_character000011F2,
        &_character000011F3,
        &_character000011F4,
        &_character000011F5,
        &_character000011F6,
        &_character000011F7,
        &_character000011F8,
        &_character000011F9,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001200,
        &_character00001201,
        &_character00001202,
        &_character00001203,
        &_character00001204,
        &_character00001205,
        &_character00001206,
        &_character00001207,
        &_character00001208,
        &_character00001209,
        &_character0000120A,
        &_character0000120B,
        &_character0000120C,
        &_character0000120D,
        &_character0000120E,
        &_character0000120F,
        &_character00001210,
        &_character00001211,
        &_character00001212,
        &_character00001213,
        &_character00001214,
        &_character00001215,
        &_character00001216,
        &_character00001217,
        &_character00001218,
        &_character00001219,
        &_character0000121A,
        &_character0000121B,
        &_character0000121C,
        &_character0000121D,
        &_character0000121E,
        &_character0000121F,
        &_character00001220,
        &_character00001221,
        &_character00001222,
        &_character00001223,
        &_character00001224,
        &_character00001225,
        &_character00001226,
        &_character00001227,
        &_character00001228,
        &_character00001229,
        &_character0000122A,
        &_character0000122B,
        &_character0000122C,
        &_character0000122D,
        &_character0000122E,
        &_character0000122F,
        &_character00001230,
        &_character00001231,
        &_character00001232,
        &_character00001233,
        &_character00001234,
        &_character00001235,
        &_character00001236,
        &_character00001237,
        &_character00001238,
        &_character00001239,
        &_character0000123A,
        &_character0000123B,
        &_character0000123C,
        &_character0000123D,
        &_character0000123E,
        &_character0000123F,
        &_character00001240,
        &_character00001241,
        &_character00001242,
        &_character00001243,
        &_character00001244,
        &_character00001245,
        &_character00001246,
        &_character00001247,
        &_character00001248,
        0,
        &_character0000124A,
        &_character0000124B,
        &_character0000124C,
        &_character0000124D,
        0,
        0,
        &_character00001250,
        &_character00001251,
        &_character00001252,
        &_character00001253,
        &_character00001254,
        &_character00001255,
        &_character00001256,
        0,
        &_character00001258,
        0,
        &_character0000125A,
        &_character0000125B,
        &_character0000125C,
        &_character0000125D,
        0,
        0,
        &_character00001260,
        &_character00001261,
        &_character00001262,
        &_character00001263,
        &_character00001264,
        &_character00001265,
        &_character00001266,
        &_character00001267,
        &_character00001268,
        &_character00001269,
        &_character0000126A,
        &_character0000126B,
        &_character0000126C,
        &_character0000126D,
        &_character0000126E,
        &_character0000126F,
        &_character00001270,
        &_character00001271,
        &_character00001272,
        &_character00001273,
        &_character00001274,
        &_character00001275,
        &_character00001276,
        &_character00001277,
        &_character00001278,
        &_character00001279,
        &_character0000127A,
        &_character0000127B,
        &_character0000127C,
        &_character0000127D,
        &_character0000127E,
        &_character0000127F,
        &_character00001280,
        &_character00001281,
        &_character00001282,
        &_character00001283,
        &_character00001284,
        &_character00001285,
        &_character00001286,
        &_character00001287,
        &_character00001288,
        0,
        &_character0000128A,
        &_character0000128B,
        &_character0000128C,
        &_character0000128D,
        0,
        0,
        &_character00001290,
        &_character00001291,
        &_character00001292,
        &_character00001293,
        &_character00001294,
        &_character00001295,
        &_character00001296,
        &_character00001297,
        &_character00001298,
        &_character00001299,
        &_character0000129A,
        &_character0000129B,
        &_character0000129C,
        &_character0000129D,
        &_character0000129E,
        &_character0000129F,
        &_character000012A0,
        &_character000012A1,
        &_character000012A2,
        &_character000012A3,
        &_character000012A4,
        &_character000012A5,
        &_character000012A6,
        &_character000012A7,
        &_character000012A8,
        &_character000012A9,
        &_character000012AA,
        &_character000012AB,
        &_character000012AC,
        &_character000012AD,
        &_character000012AE,
        &_character000012AF,
        &_character000012B0,
        0,
        &_character000012B2,
        &_character000012B3,
        &_character000012B4,
        &_character000012B5,
        0,
        0,
        &_character000012B8,
        &_character000012B9,
        &_character000012BA,
        &_character000012BB,
        &_character000012BC,
        &_character000012BD,
        &_character000012BE,
        0,
        &_character000012C0,
        0,
        &_character000012C2,
        &_character000012C3,
        &_character000012C4,
        &_character000012C5,
        0,
        0,
        &_character000012C8,
        &_character000012C9,
        &_character000012CA,
        &_character000012CB,
        &_character000012CC,
        &_character000012CD,
        &_character000012CE,
        &_character000012CF,
        &_character000012D0,
        &_character000012D1,
        &_character000012D2,
        &_character000012D3,
        &_character000012D4,
        &_character000012D5,
        &_character000012D6,
        0,
        &_character000012D8,
        &_character000012D9,
        &_character000012DA,
        &_character000012DB,
        &_character000012DC,
        &_character000012DD,
        &_character000012DE,
        &_character000012DF,
        &_character000012E0,
        &_character000012E1,
        &_character000012E2,
        &_character000012E3,
        &_character000012E4,
        &_character000012E5,
        &_character000012E6,
        &_character000012E7,
        &_character000012E8,
        &_character000012E9,
        &_character000012EA,
        &_character000012EB,
        &_character000012EC,
        &_character000012ED,
        &_character000012EE,
        &_character000012EF,
        &_character000012F0,
        &_character000012F1,
        &_character000012F2,
        &_character000012F3,
        &_character000012F4,
        &_character000012F5,
        &_character000012F6,
        &_character000012F7,
        &_character000012F8,
        &_character000012F9,
        &_character000012FA,
        &_character000012FB,
        &_character000012FC,
        &_character000012FD,
        &_character000012FE,
        &_character000012FF,
        &_character00001300,
        &_character00001301,
        &_character00001302,
        &_character00001303,
        &_character00001304,
        &_character00001305,
        &_character00001306,
        &_character00001307,
        &_character00001308,
        &_character00001309,
        &_character0000130A,
        &_character0000130B,
        &_character0000130C,
        &_character0000130D,
        &_character0000130E,
        &_character0000130F,
        &_character00001310,
        0,
        &_character00001312,
        &_character00001313,
        &_character00001314,
        &_character00001315,
        0,
        0,
        &_character00001318,
        &_character00001319,
        &_character0000131A,
        &_character0000131B,
        &_character0000131C,
        &_character0000131D,
        &_character0000131E,
        &_character0000131F,
        &_character00001320,
        &_character00001321,
        &_character00001322,
        &_character00001323,
        &_character00001324,
        &_character00001325,
        &_character00001326,
        &_character00001327,
        &_character00001328,
        &_character00001329,
        &_character0000132A,
        &_character0000132B,
        &_character0000132C,
        &_character0000132D,
        &_character0000132E,
        &_character0000132F,
        &_character00001330,
        &_character00001331,
        &_character00001332,
        &_character00001333,
        &_character00001334,
        &_character00001335,
        &_character00001336,
        &_character00001337,
        &_character00001338,
        &_character00001339,
        &_character0000133A,
        &_character0000133B,
        &_character0000133C,
        &_character0000133D,
        &_character0000133E,
        &_character0000133F,
        &_character00001340,
        &_character00001341,
        &_character00001342,
        &_character00001343,
        &_character00001344,
        &_character00001345,
        &_character00001346,
        &_character00001347,
        &_character00001348,
        &_character00001349,
        &_character0000134A,
        &_character0000134B,
        &_character0000134C,
        &_character0000134D,
        &_character0000134E,
        &_character0000134F,
        &_character00001350,
        &_character00001351,
        &_character00001352,
        &_character00001353,
        &_character00001354,
        &_character00001355,
        &_character00001356,
        &_character00001357,
        &_character00001358,
        &_character00001359,
        &_character0000135A,
        0,
        0,
        0,
        0,
        &_character0000135F,
        &_character00001360,
        &_character00001361,
        &_character00001362,
        &_character00001363,
        &_character00001364,
        &_character00001365,
        &_character00001366,
        &_character00001367,
        &_character00001368,
        &_character00001369,
        &_character0000136A,
        &_character0000136B,
        &_character0000136C,
        &_character0000136D,
        &_character0000136E,
        &_character0000136F,
        &_character00001370,
        &_character00001371,
        &_character00001372,
        &_character00001373,
        &_character00001374,
        &_character00001375,
        &_character00001376,
        &_character00001377,
        &_character00001378,
        &_character00001379,
        &_character0000137A,
        &_character0000137B,
        &_character0000137C,
        0,
        0,
        0,
        &_character00001380,
        &_character00001381,
        &_character00001382,
        &_character00001383,
        &_character00001384,
        &_character00001385,
        &_character00001386,
        &_character00001387,
        &_character00001388,
        &_character00001389,
        &_character0000138A,
        &_character0000138B,
        &_character0000138C,
        &_character0000138D,
        &_character0000138E,
        &_character0000138F,
        &_character00001390,
        &_character00001391,
        &_character00001392,
        &_character00001393,
        &_character00001394,
        &_character00001395,
        &_character00001396,
        &_character00001397,
        &_character00001398,
        &_character00001399,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000013A0,
        &_character000013A1,
        &_character000013A2,
        &_character000013A3,
        &_character000013A4,
        &_character000013A5,
        &_character000013A6,
        &_character000013A7,
        &_character000013A8,
        &_character000013A9,
        &_character000013AA,
        &_character000013AB,
        &_character000013AC,
        &_character000013AD,
        &_character000013AE,
        &_character000013AF,
        &_character000013B0,
        &_character000013B1,
        &_character000013B2,
        &_character000013B3,
        &_character000013B4,
        &_character000013B5,
        &_character000013B6,
        &_character000013B7,
        &_character000013B8,
        &_character000013B9,
        &_character000013BA,
        &_character000013BB,
        &_character000013BC,
        &_character000013BD,
        &_character000013BE,
        &_character000013BF,
        &_character000013C0,
        &_character000013C1,
        &_character000013C2,
        &_character000013C3,
        &_character000013C4,
        &_character000013C5,
        &_character000013C6,
        &_character000013C7,
        &_character000013C8,
        &_character000013C9,
        &_character000013CA,
        &_character000013CB,
        &_character000013CC,
        &_character000013CD,
        &_character000013CE,
        &_character000013CF,
        &_character000013D0,
        &_character000013D1,
        &_character000013D2,
        &_character000013D3,
        &_character000013D4,
        &_character000013D5,
        &_character000013D6,
        &_character000013D7,
        &_character000013D8,
        &_character000013D9,
        &_character000013DA,
        &_character000013DB,
        &_character000013DC,
        &_character000013DD,
        &_character000013DE,
        &_character000013DF,
        &_character000013E0,
        &_character000013E1,
        &_character000013E2,
        &_character000013E3,
        &_character000013E4,
        &_character000013E5,
        &_character000013E6,
        &_character000013E7,
        &_character000013E8,
        &_character000013E9,
        &_character000013EA,
        &_character000013EB,
        &_character000013EC,
        &_character000013ED,
        &_character000013EE,
        &_character000013EF,
        &_character000013F0,
        &_character000013F1,
        &_character000013F2,
        &_character000013F3,
        &_character000013F4,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001401,
        &_character00001402,
        &_character00001403,
        &_character00001404,
        &_character00001405,
        &_character00001406,
        &_character00001407,
        &_character00001408,
        &_character00001409,
        &_character0000140A,
        &_character0000140B,
        &_character0000140C,
        &_character0000140D,
        &_character0000140E,
        &_character0000140F,
        &_character00001410,
        &_character00001411,
        &_character00001412,
        &_character00001413,
        &_character00001414,
        &_character00001415,
        &_character00001416,
        &_character00001417,
        &_character00001418,
        &_character00001419,
        &_character0000141A,
        &_character0000141B,
        &_character0000141C,
        &_character0000141D,
        &_character0000141E,
        &_character0000141F,
        &_character00001420,
        &_character00001421,
        &_character00001422,
        &_character00001423,
        &_character00001424,
        &_character00001425,
        &_character00001426,
        &_character00001427,
        &_character00001428,
        &_character00001429,
        &_character0000142A,
        &_character0000142B,
        &_character0000142C,
        &_character0000142D,
        &_character0000142E,
        &_character0000142F,
        &_character00001430,
        &_character00001431,
        &_character00001432,
        &_character00001433,
        &_character00001434,
        &_character00001435,
        &_character00001436,
        &_character00001437,
        &_character00001438,
        &_character00001439,
        &_character0000143A,
        &_character0000143B,
        &_character0000143C,
        &_character0000143D,
        &_character0000143E,
        &_character0000143F,
        &_character00001440,
        &_character00001441,
        &_character00001442,
        &_character00001443,
        &_character00001444,
        &_character00001445,
        &_character00001446,
        &_character00001447,
        &_character00001448,
        &_character00001449,
        &_character0000144A,
        &_character0000144B,
        &_character0000144C,
        &_character0000144D,
        &_character0000144E,
        &_character0000144F,
        &_character00001450,
        &_character00001451,
        &_character00001452,
        &_character00001453,
        &_character00001454,
        &_character00001455,
        &_character00001456,
        &_character00001457,
        &_character00001458,
        &_character00001459,
        &_character0000145A,
        &_character0000145B,
        &_character0000145C,
        &_character0000145D,
        &_character0000145E,
        &_character0000145F,
        &_character00001460,
        &_character00001461,
        &_character00001462,
        &_character00001463,
        &_character00001464,
        &_character00001465,
        &_character00001466,
        &_character00001467,
        &_character00001468,
        &_character00001469,
        &_character0000146A,
        &_character0000146B,
        &_character0000146C,
        &_character0000146D,
        &_character0000146E,
        &_character0000146F,
        &_character00001470,
        &_character00001471,
        &_character00001472,
        &_character00001473,
        &_character00001474,
        &_character00001475,
        &_character00001476,
        &_character00001477,
        &_character00001478,
        &_character00001479,
        &_character0000147A,
        &_character0000147B,
        &_character0000147C,
        &_character0000147D,
        &_character0000147E,
        &_character0000147F,
        &_character00001480,
        &_character00001481,
        &_character00001482,
        &_character00001483,
        &_character00001484,
        &_character00001485,
        &_character00001486,
        &_character00001487,
        &_character00001488,
        &_character00001489,
        &_character0000148A,
        &_character0000148B,
        &_character0000148C,
        &_character0000148D,
        &_character0000148E,
        &_character0000148F,
        &_character00001490,
        &_character00001491,
        &_character00001492,
        &_character00001493,
        &_character00001494,
        &_character00001495,
        &_character00001496,
        &_character00001497,
        &_character00001498,
        &_character00001499,
        &_character0000149A,
        &_character0000149B,
        &_character0000149C,
        &_character0000149D,
        &_character0000149E,
        &_character0000149F,
        &_character000014A0,
        &_character000014A1,
        &_character000014A2,
        &_character000014A3,
        &_character000014A4,
        &_character000014A5,
        &_character000014A6,
        &_character000014A7,
        &_character000014A8,
        &_character000014A9,
        &_character000014AA,
        &_character000014AB,
        &_character000014AC,
        &_character000014AD,
        &_character000014AE,
        &_character000014AF,
        &_character000014B0,
        &_character000014B1,
        &_character000014B2,
        &_character000014B3,
        &_character000014B4,
        &_character000014B5,
        &_character000014B6,
        &_character000014B7,
        &_character000014B8,
        &_character000014B9,
        &_character000014BA,
        &_character000014BB,
        &_character000014BC,
        &_character000014BD,
        &_character000014BE,
        &_character000014BF,
        &_character000014C0,
        &_character000014C1,
        &_character000014C2,
        &_character000014C3,
        &_character000014C4,
        &_character000014C5,
        &_character000014C6,
        &_character000014C7,
        &_character000014C8,
        &_character000014C9,
        &_character000014CA,
        &_character000014CB,
        &_character000014CC,
        &_character000014CD,
        &_character000014CE,
        &_character000014CF,
        &_character000014D0,
        &_character000014D1,
        &_character000014D2,
        &_character000014D3,
        &_character000014D4,
        &_character000014D5,
        &_character000014D6,
        &_character000014D7,
        &_character000014D8,
        &_character000014D9,
        &_character000014DA,
        &_character000014DB,
        &_character000014DC,
        &_character000014DD,
        &_character000014DE,
        &_character000014DF,
        &_character000014E0,
        &_character000014E1,
        &_character000014E2,
        &_character000014E3,
        &_character000014E4,
        &_character000014E5,
        &_character000014E6,
        &_character000014E7,
        &_character000014E8,
        &_character000014E9,
        &_character000014EA,
        &_character000014EB,
        &_character000014EC,
        &_character000014ED,
        &_character000014EE,
        &_character000014EF,
        &_character000014F0,
        &_character000014F1,
        &_character000014F2,
        &_character000014F3,
        &_character000014F4,
        &_character000014F5,
        &_character000014F6,
        &_character000014F7,
        &_character000014F8,
        &_character000014F9,
        &_character000014FA,
        &_character000014FB,
        &_character000014FC,
        &_character000014FD,
        &_character000014FE,
        &_character000014FF,
        &_character00001500,
        &_character00001501,
        &_character00001502,
        &_character00001503,
        &_character00001504,
        &_character00001505,
        &_character00001506,
        &_character00001507,
        &_character00001508,
        &_character00001509,
        &_character0000150A,
        &_character0000150B,
        &_character0000150C,
        &_character0000150D,
        &_character0000150E,
        &_character0000150F,
        &_character00001510,
        &_character00001511,
        &_character00001512,
        &_character00001513,
        &_character00001514,
        &_character00001515,
        &_character00001516,
        &_character00001517,
        &_character00001518,
        &_character00001519,
        &_character0000151A,
        &_character0000151B,
        &_character0000151C,
        &_character0000151D,
        &_character0000151E,
        &_character0000151F,
        &_character00001520,
        &_character00001521,
        &_character00001522,
        &_character00001523,
        &_character00001524,
        &_character00001525,
        &_character00001526,
        &_character00001527,
        &_character00001528,
        &_character00001529,
        &_character0000152A,
        &_character0000152B,
        &_character0000152C,
        &_character0000152D,
        &_character0000152E,
        &_character0000152F,
        &_character00001530,
        &_character00001531,
        &_character00001532,
        &_character00001533,
        &_character00001534,
        &_character00001535,
        &_character00001536,
        &_character00001537,
        &_character00001538,
        &_character00001539,
        &_character0000153A,
        &_character0000153B,
        &_character0000153C,
        &_character0000153D,
        &_character0000153E,
        &_character0000153F,
        &_character00001540,
        &_character00001541,
        &_character00001542,
        &_character00001543,
        &_character00001544,
        &_character00001545,
        &_character00001546,
        &_character00001547,
        &_character00001548,
        &_character00001549,
        &_character0000154A,
        &_character0000154B,
        &_character0000154C,
        &_character0000154D,
        &_character0000154E,
        &_character0000154F,
        &_character00001550,
        &_character00001551,
        &_character00001552,
        &_character00001553,
        &_character00001554,
        &_character00001555,
        &_character00001556,
        &_character00001557,
        &_character00001558,
        &_character00001559,
        &_character0000155A,
        &_character0000155B,
        &_character0000155C,
        &_character0000155D,
        &_character0000155E,
        &_character0000155F,
        &_character00001560,
        &_character00001561,
        &_character00001562,
        &_character00001563,
        &_character00001564,
        &_character00001565,
        &_character00001566,
        &_character00001567,
        &_character00001568,
        &_character00001569,
        &_character0000156A,
        &_character0000156B,
        &_character0000156C,
        &_character0000156D,
        &_character0000156E,
        &_character0000156F,
        &_character00001570,
        &_character00001571,
        &_character00001572,
        &_character00001573,
        &_character00001574,
        &_character00001575,
        &_character00001576,
        &_character00001577,
        &_character00001578,
        &_character00001579,
        &_character0000157A,
        &_character0000157B,
        &_character0000157C,
        &_character0000157D,
        &_character0000157E,
        &_character0000157F,
        &_character00001580,
        &_character00001581,
        &_character00001582,
        &_character00001583,
        &_character00001584,
        &_character00001585,
        &_character00001586,
        &_character00001587,
        &_character00001588,
        &_character00001589,
        &_character0000158A,
        &_character0000158B,
        &_character0000158C,
        &_character0000158D,
        &_character0000158E,
        &_character0000158F,
        &_character00001590,
        &_character00001591,
        &_character00001592,
        &_character00001593,
        &_character00001594,
        &_character00001595,
        &_character00001596,
        &_character00001597,
        &_character00001598,
        &_character00001599,
        &_character0000159A,
        &_character0000159B,
        &_character0000159C,
        &_character0000159D,
        &_character0000159E,
        &_character0000159F,
        &_character000015A0,
        &_character000015A1,
        &_character000015A2,
        &_character000015A3,
        &_character000015A4,
        &_character000015A5,
        &_character000015A6,
        &_character000015A7,
        &_character000015A8,
        &_character000015A9,
        &_character000015AA,
        &_character000015AB,
        &_character000015AC,
        &_character000015AD,
        &_character000015AE,
        &_character000015AF,
        &_character000015B0,
        &_character000015B1,
        &_character000015B2,
        &_character000015B3,
        &_character000015B4,
        &_character000015B5,
        &_character000015B6,
        &_character000015B7,
        &_character000015B8,
        &_character000015B9,
        &_character000015BA,
        &_character000015BB,
        &_character000015BC,
        &_character000015BD,
        &_character000015BE,
        &_character000015BF,
        &_character000015C0,
        &_character000015C1,
        &_character000015C2,
        &_character000015C3,
        &_character000015C4,
        &_character000015C5,
        &_character000015C6,
        &_character000015C7,
        &_character000015C8,
        &_character000015C9,
        &_character000015CA,
        &_character000015CB,
        &_character000015CC,
        &_character000015CD,
        &_character000015CE,
        &_character000015CF,
        &_character000015D0,
        &_character000015D1,
        &_character000015D2,
        &_character000015D3,
        &_character000015D4,
        &_character000015D5,
        &_character000015D6,
        &_character000015D7,
        &_character000015D8,
        &_character000015D9,
        &_character000015DA,
        &_character000015DB,
        &_character000015DC,
        &_character000015DD,
        &_character000015DE,
        &_character000015DF,
        &_character000015E0,
        &_character000015E1,
        &_character000015E2,
        &_character000015E3,
        &_character000015E4,
        &_character000015E5,
        &_character000015E6,
        &_character000015E7,
        &_character000015E8,
        &_character000015E9,
        &_character000015EA,
        &_character000015EB,
        &_character000015EC,
        &_character000015ED,
        &_character000015EE,
        &_character000015EF,
        &_character000015F0,
        &_character000015F1,
        &_character000015F2,
        &_character000015F3,
        &_character000015F4,
        &_character000015F5,
        &_character000015F6,
        &_character000015F7,
        &_character000015F8,
        &_character000015F9,
        &_character000015FA,
        &_character000015FB,
        &_character000015FC,
        &_character000015FD,
        &_character000015FE,
        &_character000015FF,
        &_character00001600,
        &_character00001601,
        &_character00001602,
        &_character00001603,
        &_character00001604,
        &_character00001605,
        &_character00001606,
        &_character00001607,
        &_character00001608,
        &_character00001609,
        &_character0000160A,
        &_character0000160B,
        &_character0000160C,
        &_character0000160D,
        &_character0000160E,
        &_character0000160F,
        &_character00001610,
        &_character00001611,
        &_character00001612,
        &_character00001613,
        &_character00001614,
        &_character00001615,
        &_character00001616,
        &_character00001617,
        &_character00001618,
        &_character00001619,
        &_character0000161A,
        &_character0000161B,
        &_character0000161C,
        &_character0000161D,
        &_character0000161E,
        &_character0000161F,
        &_character00001620,
        &_character00001621,
        &_character00001622,
        &_character00001623,
        &_character00001624,
        &_character00001625,
        &_character00001626,
        &_character00001627,
        &_character00001628,
        &_character00001629,
        &_character0000162A,
        &_character0000162B,
        &_character0000162C,
        &_character0000162D,
        &_character0000162E,
        &_character0000162F,
        &_character00001630,
        &_character00001631,
        &_character00001632,
        &_character00001633,
        &_character00001634,
        &_character00001635,
        &_character00001636,
        &_character00001637,
        &_character00001638,
        &_character00001639,
        &_character0000163A,
        &_character0000163B,
        &_character0000163C,
        &_character0000163D,
        &_character0000163E,
        &_character0000163F,
        &_character00001640,
        &_character00001641,
        &_character00001642,
        &_character00001643,
        &_character00001644,
        &_character00001645,
        &_character00001646,
        &_character00001647,
        &_character00001648,
        &_character00001649,
        &_character0000164A,
        &_character0000164B,
        &_character0000164C,
        &_character0000164D,
        &_character0000164E,
        &_character0000164F,
        &_character00001650,
        &_character00001651,
        &_character00001652,
        &_character00001653,
        &_character00001654,
        &_character00001655,
        &_character00001656,
        &_character00001657,
        &_character00001658,
        &_character00001659,
        &_character0000165A,
        &_character0000165B,
        &_character0000165C,
        &_character0000165D,
        &_character0000165E,
        &_character0000165F,
        &_character00001660,
        &_character00001661,
        &_character00001662,
        &_character00001663,
        &_character00001664,
        &_character00001665,
        &_character00001666,
        &_character00001667,
        &_character00001668,
        &_character00001669,
        &_character0000166A,
        &_character0000166B,
        &_character0000166C,
        &_character0000166D,
        &_character0000166E,
        &_character0000166F,
        &_character00001670,
        &_character00001671,
        &_character00001672,
        &_character00001673,
        &_character00001674,
        &_character00001675,
        &_character00001676,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001680,
        &_character00001681,
        &_character00001682,
        &_character00001683,
        &_character00001684,
        &_character00001685,
        &_character00001686,
        &_character00001687,
        &_character00001688,
        &_character00001689,
        &_character0000168A,
        &_character0000168B,
        &_character0000168C,
        &_character0000168D,
        &_character0000168E,
        &_character0000168F,
        &_character00001690,
        &_character00001691,
        &_character00001692,
        &_character00001693,
        &_character00001694,
        &_character00001695,
        &_character00001696,
        &_character00001697,
        &_character00001698,
        &_character00001699,
        &_character0000169A,
        &_character0000169B,
        &_character0000169C,
        0,
        0,
        0,
        &_character000016A0,
        &_character000016A1,
        &_character000016A2,
        &_character000016A3,
        &_character000016A4,
        &_character000016A5,
        &_character000016A6,
        &_character000016A7,
        &_character000016A8,
        &_character000016A9,
        &_character000016AA,
        &_character000016AB,
        &_character000016AC,
        &_character000016AD,
        &_character000016AE,
        &_character000016AF,
        &_character000016B0,
        &_character000016B1,
        &_character000016B2,
        &_character000016B3,
        &_character000016B4,
        &_character000016B5,
        &_character000016B6,
        &_character000016B7,
        &_character000016B8,
        &_character000016B9,
        &_character000016BA,
        &_character000016BB,
        &_character000016BC,
        &_character000016BD,
        &_character000016BE,
        &_character000016BF,
        &_character000016C0,
        &_character000016C1,
        &_character000016C2,
        &_character000016C3,
        &_character000016C4,
        &_character000016C5,
        &_character000016C6,
        &_character000016C7,
        &_character000016C8,
        &_character000016C9,
        &_character000016CA,
        &_character000016CB,
        &_character000016CC,
        &_character000016CD,
        &_character000016CE,
        &_character000016CF,
        &_character000016D0,
        &_character000016D1,
        &_character000016D2,
        &_character000016D3,
        &_character000016D4,
        &_character000016D5,
        &_character000016D6,
        &_character000016D7,
        &_character000016D8,
        &_character000016D9,
        &_character000016DA,
        &_character000016DB,
        &_character000016DC,
        &_character000016DD,
        &_character000016DE,
        &_character000016DF,
        &_character000016E0,
        &_character000016E1,
        &_character000016E2,
        &_character000016E3,
        &_character000016E4,
        &_character000016E5,
        &_character000016E6,
        &_character000016E7,
        &_character000016E8,
        &_character000016E9,
        &_character000016EA,
        &_character000016EB,
        &_character000016EC,
        &_character000016ED,
        &_character000016EE,
        &_character000016EF,
        &_character000016F0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001700,
        &_character00001701,
        &_character00001702,
        &_character00001703,
        &_character00001704,
        &_character00001705,
        &_character00001706,
        &_character00001707,
        &_character00001708,
        &_character00001709,
        &_character0000170A,
        &_character0000170B,
        &_character0000170C,
        0,
        &_character0000170E,
        &_character0000170F,
        &_character00001710,
        &_character00001711,
        &_character00001712,
        &_character00001713,
        &_character00001714,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001720,
        &_character00001721,
        &_character00001722,
        &_character00001723,
        &_character00001724,
        &_character00001725,
        &_character00001726,
        &_character00001727,
        &_character00001728,
        &_character00001729,
        &_character0000172A,
        &_character0000172B,
        &_character0000172C,
        &_character0000172D,
        &_character0000172E,
        &_character0000172F,
        &_character00001730,
        &_character00001731,
        &_character00001732,
        &_character00001733,
        &_character00001734,
        &_character00001735,
        &_character00001736,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001740,
        &_character00001741,
        &_character00001742,
        &_character00001743,
        &_character00001744,
        &_character00001745,
        &_character00001746,
        &_character00001747,
        &_character00001748,
        &_character00001749,
        &_character0000174A,
        &_character0000174B,
        &_character0000174C,
        &_character0000174D,
        &_character0000174E,
        &_character0000174F,
        &_character00001750,
        &_character00001751,
        &_character00001752,
        &_character00001753,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001760,
        &_character00001761,
        &_character00001762,
        &_character00001763,
        &_character00001764,
        &_character00001765,
        &_character00001766,
        &_character00001767,
        &_character00001768,
        &_character00001769,
        &_character0000176A,
        &_character0000176B,
        &_character0000176C,
        0,
        &_character0000176E,
        &_character0000176F,
        &_character00001770,
        0,
        &_character00001772,
        &_character00001773,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001780,
        &_character00001781,
        &_character00001782,
        &_character00001783,
        &_character00001784,
        &_character00001785,
        &_character00001786,
        &_character00001787,
        &_character00001788,
        &_character00001789,
        &_character0000178A,
        &_character0000178B,
        &_character0000178C,
        &_character0000178D,
        &_character0000178E,
        &_character0000178F,
        &_character00001790,
        &_character00001791,
        &_character00001792,
        &_character00001793,
        &_character00001794,
        &_character00001795,
        &_character00001796,
        &_character00001797,
        &_character00001798,
        &_character00001799,
        &_character0000179A,
        &_character0000179B,
        &_character0000179C,
        &_character0000179D,
        &_character0000179E,
        &_character0000179F,
        &_character000017A0,
        &_character000017A1,
        &_character000017A2,
        &_character000017A3,
        &_character000017A4,
        &_character000017A5,
        &_character000017A6,
        &_character000017A7,
        &_character000017A8,
        &_character000017A9,
        &_character000017AA,
        &_character000017AB,
        &_character000017AC,
        &_character000017AD,
        &_character000017AE,
        &_character000017AF,
        &_character000017B0,
        &_character000017B1,
        &_character000017B2,
        &_character000017B3,
        &_character000017B4,
        &_character000017B5,
        &_character000017B6,
        &_character000017B7,
        &_character000017B8,
        &_character000017B9,
        &_character000017BA,
        &_character000017BB,
        &_character000017BC,
        &_character000017BD,
        &_character000017BE,
        &_character000017BF,
        &_character000017C0,
        &_character000017C1,
        &_character000017C2,
        &_character000017C3,
        &_character000017C4,
        &_character000017C5,
        &_character000017C6,
        &_character000017C7,
        &_character000017C8,
        &_character000017C9,
        &_character000017CA,
        &_character000017CB,
        &_character000017CC,
        &_character000017CD,
        &_character000017CE,
        &_character000017CF,
        &_character000017D0,
        &_character000017D1,
        &_character000017D2,
        &_character000017D3,
        &_character000017D4,
        &_character000017D5,
        &_character000017D6,
        &_character000017D7,
        &_character000017D8,
        &_character000017D9,
        &_character000017DA,
        &_character000017DB,
        &_character000017DC,
        &_character000017DD,
        0,
        0,
        &_character000017E0,
        &_character000017E1,
        &_character000017E2,
        &_character000017E3,
        &_character000017E4,
        &_character000017E5,
        &_character000017E6,
        &_character000017E7,
        &_character000017E8,
        &_character000017E9,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000017F0,
        &_character000017F1,
        &_character000017F2,
        &_character000017F3,
        &_character000017F4,
        &_character000017F5,
        &_character000017F6,
        &_character000017F7,
        &_character000017F8,
        &_character000017F9,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300001800[2048] =
    {
        &_character00001800,
        &_character00001801,
        &_character00001802,
        &_character00001803,
        &_character00001804,
        &_character00001805,
        &_character00001806,
        &_character00001807,
        &_character00001808,
        &_character00001809,
        &_character0000180A,
        &_character0000180B,
        &_character0000180C,
        &_character0000180D,
        &_character0000180E,
        0,
        &_character00001810,
        &_character00001811,
        &_character00001812,
        &_character00001813,
        &_character00001814,
        &_character00001815,
        &_character00001816,
        &_character00001817,
        &_character00001818,
        &_character00001819,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001820,
        &_character00001821,
        &_character00001822,
        &_character00001823,
        &_character00001824,
        &_character00001825,
        &_character00001826,
        &_character00001827,
        &_character00001828,
        &_character00001829,
        &_character0000182A,
        &_character0000182B,
        &_character0000182C,
        &_character0000182D,
        &_character0000182E,
        &_character0000182F,
        &_character00001830,
        &_character00001831,
        &_character00001832,
        &_character00001833,
        &_character00001834,
        &_character00001835,
        &_character00001836,
        &_character00001837,
        &_character00001838,
        &_character00001839,
        &_character0000183A,
        &_character0000183B,
        &_character0000183C,
        &_character0000183D,
        &_character0000183E,
        &_character0000183F,
        &_character00001840,
        &_character00001841,
        &_character00001842,
        &_character00001843,
        &_character00001844,
        &_character00001845,
        &_character00001846,
        &_character00001847,
        &_character00001848,
        &_character00001849,
        &_character0000184A,
        &_character0000184B,
        &_character0000184C,
        &_character0000184D,
        &_character0000184E,
        &_character0000184F,
        &_character00001850,
        &_character00001851,
        &_character00001852,
        &_character00001853,
        &_character00001854,
        &_character00001855,
        &_character00001856,
        &_character00001857,
        &_character00001858,
        &_character00001859,
        &_character0000185A,
        &_character0000185B,
        &_character0000185C,
        &_character0000185D,
        &_character0000185E,
        &_character0000185F,
        &_character00001860,
        &_character00001861,
        &_character00001862,
        &_character00001863,
        &_character00001864,
        &_character00001865,
        &_character00001866,
        &_character00001867,
        &_character00001868,
        &_character00001869,
        &_character0000186A,
        &_character0000186B,
        &_character0000186C,
        &_character0000186D,
        &_character0000186E,
        &_character0000186F,
        &_character00001870,
        &_character00001871,
        &_character00001872,
        &_character00001873,
        &_character00001874,
        &_character00001875,
        &_character00001876,
        &_character00001877,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001880,
        &_character00001881,
        &_character00001882,
        &_character00001883,
        &_character00001884,
        &_character00001885,
        &_character00001886,
        &_character00001887,
        &_character00001888,
        &_character00001889,
        &_character0000188A,
        &_character0000188B,
        &_character0000188C,
        &_character0000188D,
        &_character0000188E,
        &_character0000188F,
        &_character00001890,
        &_character00001891,
        &_character00001892,
        &_character00001893,
        &_character00001894,
        &_character00001895,
        &_character00001896,
        &_character00001897,
        &_character00001898,
        &_character00001899,
        &_character0000189A,
        &_character0000189B,
        &_character0000189C,
        &_character0000189D,
        &_character0000189E,
        &_character0000189F,
        &_character000018A0,
        &_character000018A1,
        &_character000018A2,
        &_character000018A3,
        &_character000018A4,
        &_character000018A5,
        &_character000018A6,
        &_character000018A7,
        &_character000018A8,
        &_character000018A9,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001900,
        &_character00001901,
        &_character00001902,
        &_character00001903,
        &_character00001904,
        &_character00001905,
        &_character00001906,
        &_character00001907,
        &_character00001908,
        &_character00001909,
        &_character0000190A,
        &_character0000190B,
        &_character0000190C,
        &_character0000190D,
        &_character0000190E,
        &_character0000190F,
        &_character00001910,
        &_character00001911,
        &_character00001912,
        &_character00001913,
        &_character00001914,
        &_character00001915,
        &_character00001916,
        &_character00001917,
        &_character00001918,
        &_character00001919,
        &_character0000191A,
        &_character0000191B,
        &_character0000191C,
        0,
        0,
        0,
        &_character00001920,
        &_character00001921,
        &_character00001922,
        &_character00001923,
        &_character00001924,
        &_character00001925,
        &_character00001926,
        &_character00001927,
        &_character00001928,
        &_character00001929,
        &_character0000192A,
        &_character0000192B,
        0,
        0,
        0,
        0,
        &_character00001930,
        &_character00001931,
        &_character00001932,
        &_character00001933,
        &_character00001934,
        &_character00001935,
        &_character00001936,
        &_character00001937,
        &_character00001938,
        &_character00001939,
        &_character0000193A,
        &_character0000193B,
        0,
        0,
        0,
        0,
        &_character00001940,
        0,
        0,
        0,
        &_character00001944,
        &_character00001945,
        &_character00001946,
        &_character00001947,
        &_character00001948,
        &_character00001949,
        &_character0000194A,
        &_character0000194B,
        &_character0000194C,
        &_character0000194D,
        &_character0000194E,
        &_character0000194F,
        &_character00001950,
        &_character00001951,
        &_character00001952,
        &_character00001953,
        &_character00001954,
        &_character00001955,
        &_character00001956,
        &_character00001957,
        &_character00001958,
        &_character00001959,
        &_character0000195A,
        &_character0000195B,
        &_character0000195C,
        &_character0000195D,
        &_character0000195E,
        &_character0000195F,
        &_character00001960,
        &_character00001961,
        &_character00001962,
        &_character00001963,
        &_character00001964,
        &_character00001965,
        &_character00001966,
        &_character00001967,
        &_character00001968,
        &_character00001969,
        &_character0000196A,
        &_character0000196B,
        &_character0000196C,
        &_character0000196D,
        0,
        0,
        &_character00001970,
        &_character00001971,
        &_character00001972,
        &_character00001973,
        &_character00001974,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001980,
        &_character00001981,
        &_character00001982,
        &_character00001983,
        &_character00001984,
        &_character00001985,
        &_character00001986,
        &_character00001987,
        &_character00001988,
        &_character00001989,
        &_character0000198A,
        &_character0000198B,
        &_character0000198C,
        &_character0000198D,
        &_character0000198E,
        &_character0000198F,
        &_character00001990,
        &_character00001991,
        &_character00001992,
        &_character00001993,
        &_character00001994,
        &_character00001995,
        &_character00001996,
        &_character00001997,
        &_character00001998,
        &_character00001999,
        &_character0000199A,
        &_character0000199B,
        &_character0000199C,
        &_character0000199D,
        &_character0000199E,
        &_character0000199F,
        &_character000019A0,
        &_character000019A1,
        &_character000019A2,
        &_character000019A3,
        &_character000019A4,
        &_character000019A5,
        &_character000019A6,
        &_character000019A7,
        &_character000019A8,
        &_character000019A9,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000019B0,
        &_character000019B1,
        &_character000019B2,
        &_character000019B3,
        &_character000019B4,
        &_character000019B5,
        &_character000019B6,
        &_character000019B7,
        &_character000019B8,
        &_character000019B9,
        &_character000019BA,
        &_character000019BB,
        &_character000019BC,
        &_character000019BD,
        &_character000019BE,
        &_character000019BF,
        &_character000019C0,
        &_character000019C1,
        &_character000019C2,
        &_character000019C3,
        &_character000019C4,
        &_character000019C5,
        &_character000019C6,
        &_character000019C7,
        &_character000019C8,
        &_character000019C9,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000019D0,
        &_character000019D1,
        &_character000019D2,
        &_character000019D3,
        &_character000019D4,
        &_character000019D5,
        &_character000019D6,
        &_character000019D7,
        &_character000019D8,
        &_character000019D9,
        0,
        0,
        0,
        0,
        &_character000019DE,
        &_character000019DF,
        &_character000019E0,
        &_character000019E1,
        &_character000019E2,
        &_character000019E3,
        &_character000019E4,
        &_character000019E5,
        &_character000019E6,
        &_character000019E7,
        &_character000019E8,
        &_character000019E9,
        &_character000019EA,
        &_character000019EB,
        &_character000019EC,
        &_character000019ED,
        &_character000019EE,
        &_character000019EF,
        &_character000019F0,
        &_character000019F1,
        &_character000019F2,
        &_character000019F3,
        &_character000019F4,
        &_character000019F5,
        &_character000019F6,
        &_character000019F7,
        &_character000019F8,
        &_character000019F9,
        &_character000019FA,
        &_character000019FB,
        &_character000019FC,
        &_character000019FD,
        &_character000019FE,
        &_character000019FF,
        &_character00001A00,
        &_character00001A01,
        &_character00001A02,
        &_character00001A03,
        &_character00001A04,
        &_character00001A05,
        &_character00001A06,
        &_character00001A07,
        &_character00001A08,
        &_character00001A09,
        &_character00001A0A,
        &_character00001A0B,
        &_character00001A0C,
        &_character00001A0D,
        &_character00001A0E,
        &_character00001A0F,
        &_character00001A10,
        &_character00001A11,
        &_character00001A12,
        &_character00001A13,
        &_character00001A14,
        &_character00001A15,
        &_character00001A16,
        &_character00001A17,
        &_character00001A18,
        &_character00001A19,
        &_character00001A1A,
        &_character00001A1B,
        0,
        0,
        &_character00001A1E,
        &_character00001A1F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001B00,
        &_character00001B01,
        &_character00001B02,
        &_character00001B03,
        &_character00001B04,
        &_character00001B05,
        &_character00001B06,
        &_character00001B07,
        &_character00001B08,
        &_character00001B09,
        &_character00001B0A,
        &_character00001B0B,
        &_character00001B0C,
        &_character00001B0D,
        &_character00001B0E,
        &_character00001B0F,
        &_character00001B10,
        &_character00001B11,
        &_character00001B12,
        &_character00001B13,
        &_character00001B14,
        &_character00001B15,
        &_character00001B16,
        &_character00001B17,
        &_character00001B18,
        &_character00001B19,
        &_character00001B1A,
        &_character00001B1B,
        &_character00001B1C,
        &_character00001B1D,
        &_character00001B1E,
        &_character00001B1F,
        &_character00001B20,
        &_character00001B21,
        &_character00001B22,
        &_character00001B23,
        &_character00001B24,
        &_character00001B25,
        &_character00001B26,
        &_character00001B27,
        &_character00001B28,
        &_character00001B29,
        &_character00001B2A,
        &_character00001B2B,
        &_character00001B2C,
        &_character00001B2D,
        &_character00001B2E,
        &_character00001B2F,
        &_character00001B30,
        &_character00001B31,
        &_character00001B32,
        &_character00001B33,
        &_character00001B34,
        &_character00001B35,
        &_character00001B36,
        &_character00001B37,
        &_character00001B38,
        &_character00001B39,
        &_character00001B3A,
        &_character00001B3B,
        &_character00001B3C,
        &_character00001B3D,
        &_character00001B3E,
        &_character00001B3F,
        &_character00001B40,
        &_character00001B41,
        &_character00001B42,
        &_character00001B43,
        &_character00001B44,
        &_character00001B45,
        &_character00001B46,
        &_character00001B47,
        &_character00001B48,
        &_character00001B49,
        &_character00001B4A,
        &_character00001B4B,
        0,
        0,
        0,
        0,
        &_character00001B50,
        &_character00001B51,
        &_character00001B52,
        &_character00001B53,
        &_character00001B54,
        &_character00001B55,
        &_character00001B56,
        &_character00001B57,
        &_character00001B58,
        &_character00001B59,
        &_character00001B5A,
        &_character00001B5B,
        &_character00001B5C,
        &_character00001B5D,
        &_character00001B5E,
        &_character00001B5F,
        &_character00001B60,
        &_character00001B61,
        &_character00001B62,
        &_character00001B63,
        &_character00001B64,
        &_character00001B65,
        &_character00001B66,
        &_character00001B67,
        &_character00001B68,
        &_character00001B69,
        &_character00001B6A,
        &_character00001B6B,
        &_character00001B6C,
        &_character00001B6D,
        &_character00001B6E,
        &_character00001B6F,
        &_character00001B70,
        &_character00001B71,
        &_character00001B72,
        &_character00001B73,
        &_character00001B74,
        &_character00001B75,
        &_character00001B76,
        &_character00001B77,
        &_character00001B78,
        &_character00001B79,
        &_character00001B7A,
        &_character00001B7B,
        &_character00001B7C,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001D00,
        &_character00001D01,
        &_character00001D02,
        &_character00001D03,
        &_character00001D04,
        &_character00001D05,
        &_character00001D06,
        &_character00001D07,
        &_character00001D08,
        &_character00001D09,
        &_character00001D0A,
        &_character00001D0B,
        &_character00001D0C,
        &_character00001D0D,
        &_character00001D0E,
        &_character00001D0F,
        &_character00001D10,
        &_character00001D11,
        &_character00001D12,
        &_character00001D13,
        &_character00001D14,
        &_character00001D15,
        &_character00001D16,
        &_character00001D17,
        &_character00001D18,
        &_character00001D19,
        &_character00001D1A,
        &_character00001D1B,
        &_character00001D1C,
        &_character00001D1D,
        &_character00001D1E,
        &_character00001D1F,
        &_character00001D20,
        &_character00001D21,
        &_character00001D22,
        &_character00001D23,
        &_character00001D24,
        &_character00001D25,
        &_character00001D26,
        &_character00001D27,
        &_character00001D28,
        &_character00001D29,
        &_character00001D2A,
        &_character00001D2B,
        &_character00001D2C,
        &_character00001D2D,
        &_character00001D2E,
        &_character00001D2F,
        &_character00001D30,
        &_character00001D31,
        &_character00001D32,
        &_character00001D33,
        &_character00001D34,
        &_character00001D35,
        &_character00001D36,
        &_character00001D37,
        &_character00001D38,
        &_character00001D39,
        &_character00001D3A,
        &_character00001D3B,
        &_character00001D3C,
        &_character00001D3D,
        &_character00001D3E,
        &_character00001D3F,
        &_character00001D40,
        &_character00001D41,
        &_character00001D42,
        &_character00001D43,
        &_character00001D44,
        &_character00001D45,
        &_character00001D46,
        &_character00001D47,
        &_character00001D48,
        &_character00001D49,
        &_character00001D4A,
        &_character00001D4B,
        &_character00001D4C,
        &_character00001D4D,
        &_character00001D4E,
        &_character00001D4F,
        &_character00001D50,
        &_character00001D51,
        &_character00001D52,
        &_character00001D53,
        &_character00001D54,
        &_character00001D55,
        &_character00001D56,
        &_character00001D57,
        &_character00001D58,
        &_character00001D59,
        &_character00001D5A,
        &_character00001D5B,
        &_character00001D5C,
        &_character00001D5D,
        &_character00001D5E,
        &_character00001D5F,
        &_character00001D60,
        &_character00001D61,
        &_character00001D62,
        &_character00001D63,
        &_character00001D64,
        &_character00001D65,
        &_character00001D66,
        &_character00001D67,
        &_character00001D68,
        &_character00001D69,
        &_character00001D6A,
        &_character00001D6B,
        &_character00001D6C,
        &_character00001D6D,
        &_character00001D6E,
        &_character00001D6F,
        &_character00001D70,
        &_character00001D71,
        &_character00001D72,
        &_character00001D73,
        &_character00001D74,
        &_character00001D75,
        &_character00001D76,
        &_character00001D77,
        &_character00001D78,
        &_character00001D79,
        &_character00001D7A,
        &_character00001D7B,
        &_character00001D7C,
        &_character00001D7D,
        &_character00001D7E,
        &_character00001D7F,
        &_character00001D80,
        &_character00001D81,
        &_character00001D82,
        &_character00001D83,
        &_character00001D84,
        &_character00001D85,
        &_character00001D86,
        &_character00001D87,
        &_character00001D88,
        &_character00001D89,
        &_character00001D8A,
        &_character00001D8B,
        &_character00001D8C,
        &_character00001D8D,
        &_character00001D8E,
        &_character00001D8F,
        &_character00001D90,
        &_character00001D91,
        &_character00001D92,
        &_character00001D93,
        &_character00001D94,
        &_character00001D95,
        &_character00001D96,
        &_character00001D97,
        &_character00001D98,
        &_character00001D99,
        &_character00001D9A,
        &_character00001D9B,
        &_character00001D9C,
        &_character00001D9D,
        &_character00001D9E,
        &_character00001D9F,
        &_character00001DA0,
        &_character00001DA1,
        &_character00001DA2,
        &_character00001DA3,
        &_character00001DA4,
        &_character00001DA5,
        &_character00001DA6,
        &_character00001DA7,
        &_character00001DA8,
        &_character00001DA9,
        &_character00001DAA,
        &_character00001DAB,
        &_character00001DAC,
        &_character00001DAD,
        &_character00001DAE,
        &_character00001DAF,
        &_character00001DB0,
        &_character00001DB1,
        &_character00001DB2,
        &_character00001DB3,
        &_character00001DB4,
        &_character00001DB5,
        &_character00001DB6,
        &_character00001DB7,
        &_character00001DB8,
        &_character00001DB9,
        &_character00001DBA,
        &_character00001DBB,
        &_character00001DBC,
        &_character00001DBD,
        &_character00001DBE,
        &_character00001DBF,
        &_character00001DC0,
        &_character00001DC1,
        &_character00001DC2,
        &_character00001DC3,
        &_character00001DC4,
        &_character00001DC5,
        &_character00001DC6,
        &_character00001DC7,
        &_character00001DC8,
        &_character00001DC9,
        &_character00001DCA,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001DFE,
        &_character00001DFF,
        &_character00001E00,
        &_character00001E01,
        &_character00001E02,
        &_character00001E03,
        &_character00001E04,
        &_character00001E05,
        &_character00001E06,
        &_character00001E07,
        &_character00001E08,
        &_character00001E09,
        &_character00001E0A,
        &_character00001E0B,
        &_character00001E0C,
        &_character00001E0D,
        &_character00001E0E,
        &_character00001E0F,
        &_character00001E10,
        &_character00001E11,
        &_character00001E12,
        &_character00001E13,
        &_character00001E14,
        &_character00001E15,
        &_character00001E16,
        &_character00001E17,
        &_character00001E18,
        &_character00001E19,
        &_character00001E1A,
        &_character00001E1B,
        &_character00001E1C,
        &_character00001E1D,
        &_character00001E1E,
        &_character00001E1F,
        &_character00001E20,
        &_character00001E21,
        &_character00001E22,
        &_character00001E23,
        &_character00001E24,
        &_character00001E25,
        &_character00001E26,
        &_character00001E27,
        &_character00001E28,
        &_character00001E29,
        &_character00001E2A,
        &_character00001E2B,
        &_character00001E2C,
        &_character00001E2D,
        &_character00001E2E,
        &_character00001E2F,
        &_character00001E30,
        &_character00001E31,
        &_character00001E32,
        &_character00001E33,
        &_character00001E34,
        &_character00001E35,
        &_character00001E36,
        &_character00001E37,
        &_character00001E38,
        &_character00001E39,
        &_character00001E3A,
        &_character00001E3B,
        &_character00001E3C,
        &_character00001E3D,
        &_character00001E3E,
        &_character00001E3F,
        &_character00001E40,
        &_character00001E41,
        &_character00001E42,
        &_character00001E43,
        &_character00001E44,
        &_character00001E45,
        &_character00001E46,
        &_character00001E47,
        &_character00001E48,
        &_character00001E49,
        &_character00001E4A,
        &_character00001E4B,
        &_character00001E4C,
        &_character00001E4D,
        &_character00001E4E,
        &_character00001E4F,
        &_character00001E50,
        &_character00001E51,
        &_character00001E52,
        &_character00001E53,
        &_character00001E54,
        &_character00001E55,
        &_character00001E56,
        &_character00001E57,
        &_character00001E58,
        &_character00001E59,
        &_character00001E5A,
        &_character00001E5B,
        &_character00001E5C,
        &_character00001E5D,
        &_character00001E5E,
        &_character00001E5F,
        &_character00001E60,
        &_character00001E61,
        &_character00001E62,
        &_character00001E63,
        &_character00001E64,
        &_character00001E65,
        &_character00001E66,
        &_character00001E67,
        &_character00001E68,
        &_character00001E69,
        &_character00001E6A,
        &_character00001E6B,
        &_character00001E6C,
        &_character00001E6D,
        &_character00001E6E,
        &_character00001E6F,
        &_character00001E70,
        &_character00001E71,
        &_character00001E72,
        &_character00001E73,
        &_character00001E74,
        &_character00001E75,
        &_character00001E76,
        &_character00001E77,
        &_character00001E78,
        &_character00001E79,
        &_character00001E7A,
        &_character00001E7B,
        &_character00001E7C,
        &_character00001E7D,
        &_character00001E7E,
        &_character00001E7F,
        &_character00001E80,
        &_character00001E81,
        &_character00001E82,
        &_character00001E83,
        &_character00001E84,
        &_character00001E85,
        &_character00001E86,
        &_character00001E87,
        &_character00001E88,
        &_character00001E89,
        &_character00001E8A,
        &_character00001E8B,
        &_character00001E8C,
        &_character00001E8D,
        &_character00001E8E,
        &_character00001E8F,
        &_character00001E90,
        &_character00001E91,
        &_character00001E92,
        &_character00001E93,
        &_character00001E94,
        &_character00001E95,
        &_character00001E96,
        &_character00001E97,
        &_character00001E98,
        &_character00001E99,
        &_character00001E9A,
        &_character00001E9B,
        0,
        0,
        0,
        0,
        &_character00001EA0,
        &_character00001EA1,
        &_character00001EA2,
        &_character00001EA3,
        &_character00001EA4,
        &_character00001EA5,
        &_character00001EA6,
        &_character00001EA7,
        &_character00001EA8,
        &_character00001EA9,
        &_character00001EAA,
        &_character00001EAB,
        &_character00001EAC,
        &_character00001EAD,
        &_character00001EAE,
        &_character00001EAF,
        &_character00001EB0,
        &_character00001EB1,
        &_character00001EB2,
        &_character00001EB3,
        &_character00001EB4,
        &_character00001EB5,
        &_character00001EB6,
        &_character00001EB7,
        &_character00001EB8,
        &_character00001EB9,
        &_character00001EBA,
        &_character00001EBB,
        &_character00001EBC,
        &_character00001EBD,
        &_character00001EBE,
        &_character00001EBF,
        &_character00001EC0,
        &_character00001EC1,
        &_character00001EC2,
        &_character00001EC3,
        &_character00001EC4,
        &_character00001EC5,
        &_character00001EC6,
        &_character00001EC7,
        &_character00001EC8,
        &_character00001EC9,
        &_character00001ECA,
        &_character00001ECB,
        &_character00001ECC,
        &_character00001ECD,
        &_character00001ECE,
        &_character00001ECF,
        &_character00001ED0,
        &_character00001ED1,
        &_character00001ED2,
        &_character00001ED3,
        &_character00001ED4,
        &_character00001ED5,
        &_character00001ED6,
        &_character00001ED7,
        &_character00001ED8,
        &_character00001ED9,
        &_character00001EDA,
        &_character00001EDB,
        &_character00001EDC,
        &_character00001EDD,
        &_character00001EDE,
        &_character00001EDF,
        &_character00001EE0,
        &_character00001EE1,
        &_character00001EE2,
        &_character00001EE3,
        &_character00001EE4,
        &_character00001EE5,
        &_character00001EE6,
        &_character00001EE7,
        &_character00001EE8,
        &_character00001EE9,
        &_character00001EEA,
        &_character00001EEB,
        &_character00001EEC,
        &_character00001EED,
        &_character00001EEE,
        &_character00001EEF,
        &_character00001EF0,
        &_character00001EF1,
        &_character00001EF2,
        &_character00001EF3,
        &_character00001EF4,
        &_character00001EF5,
        &_character00001EF6,
        &_character00001EF7,
        &_character00001EF8,
        &_character00001EF9,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00001F00,
        &_character00001F01,
        &_character00001F02,
        &_character00001F03,
        &_character00001F04,
        &_character00001F05,
        &_character00001F06,
        &_character00001F07,
        &_character00001F08,
        &_character00001F09,
        &_character00001F0A,
        &_character00001F0B,
        &_character00001F0C,
        &_character00001F0D,
        &_character00001F0E,
        &_character00001F0F,
        &_character00001F10,
        &_character00001F11,
        &_character00001F12,
        &_character00001F13,
        &_character00001F14,
        &_character00001F15,
        0,
        0,
        &_character00001F18,
        &_character00001F19,
        &_character00001F1A,
        &_character00001F1B,
        &_character00001F1C,
        &_character00001F1D,
        0,
        0,
        &_character00001F20,
        &_character00001F21,
        &_character00001F22,
        &_character00001F23,
        &_character00001F24,
        &_character00001F25,
        &_character00001F26,
        &_character00001F27,
        &_character00001F28,
        &_character00001F29,
        &_character00001F2A,
        &_character00001F2B,
        &_character00001F2C,
        &_character00001F2D,
        &_character00001F2E,
        &_character00001F2F,
        &_character00001F30,
        &_character00001F31,
        &_character00001F32,
        &_character00001F33,
        &_character00001F34,
        &_character00001F35,
        &_character00001F36,
        &_character00001F37,
        &_character00001F38,
        &_character00001F39,
        &_character00001F3A,
        &_character00001F3B,
        &_character00001F3C,
        &_character00001F3D,
        &_character00001F3E,
        &_character00001F3F,
        &_character00001F40,
        &_character00001F41,
        &_character00001F42,
        &_character00001F43,
        &_character00001F44,
        &_character00001F45,
        0,
        0,
        &_character00001F48,
        &_character00001F49,
        &_character00001F4A,
        &_character00001F4B,
        &_character00001F4C,
        &_character00001F4D,
        0,
        0,
        &_character00001F50,
        &_character00001F51,
        &_character00001F52,
        &_character00001F53,
        &_character00001F54,
        &_character00001F55,
        &_character00001F56,
        &_character00001F57,
        0,
        &_character00001F59,
        0,
        &_character00001F5B,
        0,
        &_character00001F5D,
        0,
        &_character00001F5F,
        &_character00001F60,
        &_character00001F61,
        &_character00001F62,
        &_character00001F63,
        &_character00001F64,
        &_character00001F65,
        &_character00001F66,
        &_character00001F67,
        &_character00001F68,
        &_character00001F69,
        &_character00001F6A,
        &_character00001F6B,
        &_character00001F6C,
        &_character00001F6D,
        &_character00001F6E,
        &_character00001F6F,
        &_character00001F70,
        &_character00001F71,
        &_character00001F72,
        &_character00001F73,
        &_character00001F74,
        &_character00001F75,
        &_character00001F76,
        &_character00001F77,
        &_character00001F78,
        &_character00001F79,
        &_character00001F7A,
        &_character00001F7B,
        &_character00001F7C,
        &_character00001F7D,
        0,
        0,
        &_character00001F80,
        &_character00001F81,
        &_character00001F82,
        &_character00001F83,
        &_character00001F84,
        &_character00001F85,
        &_character00001F86,
        &_character00001F87,
        &_character00001F88,
        &_character00001F89,
        &_character00001F8A,
        &_character00001F8B,
        &_character00001F8C,
        &_character00001F8D,
        &_character00001F8E,
        &_character00001F8F,
        &_character00001F90,
        &_character00001F91,
        &_character00001F92,
        &_character00001F93,
        &_character00001F94,
        &_character00001F95,
        &_character00001F96,
        &_character00001F97,
        &_character00001F98,
        &_character00001F99,
        &_character00001F9A,
        &_character00001F9B,
        &_character00001F9C,
        &_character00001F9D,
        &_character00001F9E,
        &_character00001F9F,
        &_character00001FA0,
        &_character00001FA1,
        &_character00001FA2,
        &_character00001FA3,
        &_character00001FA4,
        &_character00001FA5,
        &_character00001FA6,
        &_character00001FA7,
        &_character00001FA8,
        &_character00001FA9,
        &_character00001FAA,
        &_character00001FAB,
        &_character00001FAC,
        &_character00001FAD,
        &_character00001FAE,
        &_character00001FAF,
        &_character00001FB0,
        &_character00001FB1,
        &_character00001FB2,
        &_character00001FB3,
        &_character00001FB4,
        0,
        &_character00001FB6,
        &_character00001FB7,
        &_character00001FB8,
        &_character00001FB9,
        &_character00001FBA,
        &_character00001FBB,
        &_character00001FBC,
        &_character00001FBD,
        &_character00001FBE,
        &_character00001FBF,
        &_character00001FC0,
        &_character00001FC1,
        &_character00001FC2,
        &_character00001FC3,
        &_character00001FC4,
        0,
        &_character00001FC6,
        &_character00001FC7,
        &_character00001FC8,
        &_character00001FC9,
        &_character00001FCA,
        &_character00001FCB,
        &_character00001FCC,
        &_character00001FCD,
        &_character00001FCE,
        &_character00001FCF,
        &_character00001FD0,
        &_character00001FD1,
        &_character00001FD2,
        &_character00001FD3,
        0,
        0,
        &_character00001FD6,
        &_character00001FD7,
        &_character00001FD8,
        &_character00001FD9,
        &_character00001FDA,
        &_character00001FDB,
        0,
        &_character00001FDD,
        &_character00001FDE,
        &_character00001FDF,
        &_character00001FE0,
        &_character00001FE1,
        &_character00001FE2,
        &_character00001FE3,
        &_character00001FE4,
        &_character00001FE5,
        &_character00001FE6,
        &_character00001FE7,
        &_character00001FE8,
        &_character00001FE9,
        &_character00001FEA,
        &_character00001FEB,
        &_character00001FEC,
        &_character00001FED,
        &_character00001FEE,
        &_character00001FEF,
        0,
        0,
        &_character00001FF2,
        &_character00001FF3,
        &_character00001FF4,
        0,
        &_character00001FF6,
        &_character00001FF7,
        &_character00001FF8,
        &_character00001FF9,
        &_character00001FFA,
        &_character00001FFB,
        &_character00001FFC,
        &_character00001FFD,
        &_character00001FFE,
        0
    };

    static _CharacterInfo * _table300002000[2048] =
    {
        &_character00002000,
        &_character00002001,
        &_character00002002,
        &_character00002003,
        &_character00002004,
        &_character00002005,
        &_character00002006,
        &_character00002007,
        &_character00002008,
        &_character00002009,
        &_character0000200A,
        &_character0000200B,
        &_character0000200C,
        &_character0000200D,
        &_character0000200E,
        &_character0000200F,
        &_character00002010,
        &_character00002011,
        &_character00002012,
        &_character00002013,
        &_character00002014,
        &_character00002015,
        &_character00002016,
        &_character00002017,
        &_character00002018,
        &_character00002019,
        &_character0000201A,
        &_character0000201B,
        &_character0000201C,
        &_character0000201D,
        &_character0000201E,
        &_character0000201F,
        &_character00002020,
        &_character00002021,
        &_character00002022,
        &_character00002023,
        &_character00002024,
        &_character00002025,
        &_character00002026,
        &_character00002027,
        &_character00002028,
        &_character00002029,
        &_character0000202A,
        &_character0000202B,
        &_character0000202C,
        &_character0000202D,
        &_character0000202E,
        &_character0000202F,
        &_character00002030,
        &_character00002031,
        &_character00002032,
        &_character00002033,
        &_character00002034,
        &_character00002035,
        &_character00002036,
        &_character00002037,
        &_character00002038,
        &_character00002039,
        &_character0000203A,
        &_character0000203B,
        &_character0000203C,
        &_character0000203D,
        &_character0000203E,
        &_character0000203F,
        &_character00002040,
        &_character00002041,
        &_character00002042,
        &_character00002043,
        &_character00002044,
        &_character00002045,
        &_character00002046,
        &_character00002047,
        &_character00002048,
        &_character00002049,
        &_character0000204A,
        &_character0000204B,
        &_character0000204C,
        &_character0000204D,
        &_character0000204E,
        &_character0000204F,
        &_character00002050,
        &_character00002051,
        &_character00002052,
        &_character00002053,
        &_character00002054,
        &_character00002055,
        &_character00002056,
        &_character00002057,
        &_character00002058,
        &_character00002059,
        &_character0000205A,
        &_character0000205B,
        &_character0000205C,
        &_character0000205D,
        &_character0000205E,
        &_character0000205F,
        &_character00002060,
        &_character00002061,
        &_character00002062,
        &_character00002063,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000206A,
        &_character0000206B,
        &_character0000206C,
        &_character0000206D,
        &_character0000206E,
        &_character0000206F,
        &_character00002070,
        &_character00002071,
        0,
        0,
        &_character00002074,
        &_character00002075,
        &_character00002076,
        &_character00002077,
        &_character00002078,
        &_character00002079,
        &_character0000207A,
        &_character0000207B,
        &_character0000207C,
        &_character0000207D,
        &_character0000207E,
        &_character0000207F,
        &_character00002080,
        &_character00002081,
        &_character00002082,
        &_character00002083,
        &_character00002084,
        &_character00002085,
        &_character00002086,
        &_character00002087,
        &_character00002088,
        &_character00002089,
        &_character0000208A,
        &_character0000208B,
        &_character0000208C,
        &_character0000208D,
        &_character0000208E,
        0,
        &_character00002090,
        &_character00002091,
        &_character00002092,
        &_character00002093,
        &_character00002094,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000020A0,
        &_character000020A1,
        &_character000020A2,
        &_character000020A3,
        &_character000020A4,
        &_character000020A5,
        &_character000020A6,
        &_character000020A7,
        &_character000020A8,
        &_character000020A9,
        &_character000020AA,
        &_character000020AB,
        &_character000020AC,
        &_character000020AD,
        &_character000020AE,
        &_character000020AF,
        &_character000020B0,
        &_character000020B1,
        &_character000020B2,
        &_character000020B3,
        &_character000020B4,
        &_character000020B5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000020D0,
        &_character000020D1,
        &_character000020D2,
        &_character000020D3,
        &_character000020D4,
        &_character000020D5,
        &_character000020D6,
        &_character000020D7,
        &_character000020D8,
        &_character000020D9,
        &_character000020DA,
        &_character000020DB,
        &_character000020DC,
        &_character000020DD,
        &_character000020DE,
        &_character000020DF,
        &_character000020E0,
        &_character000020E1,
        &_character000020E2,
        &_character000020E3,
        &_character000020E4,
        &_character000020E5,
        &_character000020E6,
        &_character000020E7,
        &_character000020E8,
        &_character000020E9,
        &_character000020EA,
        &_character000020EB,
        &_character000020EC,
        &_character000020ED,
        &_character000020EE,
        &_character000020EF,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002100,
        &_character00002101,
        &_character00002102,
        &_character00002103,
        &_character00002104,
        &_character00002105,
        &_character00002106,
        &_character00002107,
        &_character00002108,
        &_character00002109,
        &_character0000210A,
        &_character0000210B,
        &_character0000210C,
        &_character0000210D,
        &_character0000210E,
        &_character0000210F,
        &_character00002110,
        &_character00002111,
        &_character00002112,
        &_character00002113,
        &_character00002114,
        &_character00002115,
        &_character00002116,
        &_character00002117,
        &_character00002118,
        &_character00002119,
        &_character0000211A,
        &_character0000211B,
        &_character0000211C,
        &_character0000211D,
        &_character0000211E,
        &_character0000211F,
        &_character00002120,
        &_character00002121,
        &_character00002122,
        &_character00002123,
        &_character00002124,
        &_character00002125,
        &_character00002126,
        &_character00002127,
        &_character00002128,
        &_character00002129,
        &_character0000212A,
        &_character0000212B,
        &_character0000212C,
        &_character0000212D,
        &_character0000212E,
        &_character0000212F,
        &_character00002130,
        &_character00002131,
        &_character00002132,
        &_character00002133,
        &_character00002134,
        &_character00002135,
        &_character00002136,
        &_character00002137,
        &_character00002138,
        &_character00002139,
        &_character0000213A,
        &_character0000213B,
        &_character0000213C,
        &_character0000213D,
        &_character0000213E,
        &_character0000213F,
        &_character00002140,
        &_character00002141,
        &_character00002142,
        &_character00002143,
        &_character00002144,
        &_character00002145,
        &_character00002146,
        &_character00002147,
        &_character00002148,
        &_character00002149,
        &_character0000214A,
        &_character0000214B,
        &_character0000214C,
        &_character0000214D,
        &_character0000214E,
        0,
        0,
        0,
        0,
        &_character00002153,
        &_character00002154,
        &_character00002155,
        &_character00002156,
        &_character00002157,
        &_character00002158,
        &_character00002159,
        &_character0000215A,
        &_character0000215B,
        &_character0000215C,
        &_character0000215D,
        &_character0000215E,
        &_character0000215F,
        &_character00002160,
        &_character00002161,
        &_character00002162,
        &_character00002163,
        &_character00002164,
        &_character00002165,
        &_character00002166,
        &_character00002167,
        &_character00002168,
        &_character00002169,
        &_character0000216A,
        &_character0000216B,
        &_character0000216C,
        &_character0000216D,
        &_character0000216E,
        &_character0000216F,
        &_character00002170,
        &_character00002171,
        &_character00002172,
        &_character00002173,
        &_character00002174,
        &_character00002175,
        &_character00002176,
        &_character00002177,
        &_character00002178,
        &_character00002179,
        &_character0000217A,
        &_character0000217B,
        &_character0000217C,
        &_character0000217D,
        &_character0000217E,
        &_character0000217F,
        &_character00002180,
        &_character00002181,
        &_character00002182,
        &_character00002183,
        &_character00002184,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002190,
        &_character00002191,
        &_character00002192,
        &_character00002193,
        &_character00002194,
        &_character00002195,
        &_character00002196,
        &_character00002197,
        &_character00002198,
        &_character00002199,
        &_character0000219A,
        &_character0000219B,
        &_character0000219C,
        &_character0000219D,
        &_character0000219E,
        &_character0000219F,
        &_character000021A0,
        &_character000021A1,
        &_character000021A2,
        &_character000021A3,
        &_character000021A4,
        &_character000021A5,
        &_character000021A6,
        &_character000021A7,
        &_character000021A8,
        &_character000021A9,
        &_character000021AA,
        &_character000021AB,
        &_character000021AC,
        &_character000021AD,
        &_character000021AE,
        &_character000021AF,
        &_character000021B0,
        &_character000021B1,
        &_character000021B2,
        &_character000021B3,
        &_character000021B4,
        &_character000021B5,
        &_character000021B6,
        &_character000021B7,
        &_character000021B8,
        &_character000021B9,
        &_character000021BA,
        &_character000021BB,
        &_character000021BC,
        &_character000021BD,
        &_character000021BE,
        &_character000021BF,
        &_character000021C0,
        &_character000021C1,
        &_character000021C2,
        &_character000021C3,
        &_character000021C4,
        &_character000021C5,
        &_character000021C6,
        &_character000021C7,
        &_character000021C8,
        &_character000021C9,
        &_character000021CA,
        &_character000021CB,
        &_character000021CC,
        &_character000021CD,
        &_character000021CE,
        &_character000021CF,
        &_character000021D0,
        &_character000021D1,
        &_character000021D2,
        &_character000021D3,
        &_character000021D4,
        &_character000021D5,
        &_character000021D6,
        &_character000021D7,
        &_character000021D8,
        &_character000021D9,
        &_character000021DA,
        &_character000021DB,
        &_character000021DC,
        &_character000021DD,
        &_character000021DE,
        &_character000021DF,
        &_character000021E0,
        &_character000021E1,
        &_character000021E2,
        &_character000021E3,
        &_character000021E4,
        &_character000021E5,
        &_character000021E6,
        &_character000021E7,
        &_character000021E8,
        &_character000021E9,
        &_character000021EA,
        &_character000021EB,
        &_character000021EC,
        &_character000021ED,
        &_character000021EE,
        &_character000021EF,
        &_character000021F0,
        &_character000021F1,
        &_character000021F2,
        &_character000021F3,
        &_character000021F4,
        &_character000021F5,
        &_character000021F6,
        &_character000021F7,
        &_character000021F8,
        &_character000021F9,
        &_character000021FA,
        &_character000021FB,
        &_character000021FC,
        &_character000021FD,
        &_character000021FE,
        &_character000021FF,
        &_character00002200,
        &_character00002201,
        &_character00002202,
        &_character00002203,
        &_character00002204,
        &_character00002205,
        &_character00002206,
        &_character00002207,
        &_character00002208,
        &_character00002209,
        &_character0000220A,
        &_character0000220B,
        &_character0000220C,
        &_character0000220D,
        &_character0000220E,
        &_character0000220F,
        &_character00002210,
        &_character00002211,
        &_character00002212,
        &_character00002213,
        &_character00002214,
        &_character00002215,
        &_character00002216,
        &_character00002217,
        &_character00002218,
        &_character00002219,
        &_character0000221A,
        &_character0000221B,
        &_character0000221C,
        &_character0000221D,
        &_character0000221E,
        &_character0000221F,
        &_character00002220,
        &_character00002221,
        &_character00002222,
        &_character00002223,
        &_character00002224,
        &_character00002225,
        &_character00002226,
        &_character00002227,
        &_character00002228,
        &_character00002229,
        &_character0000222A,
        &_character0000222B,
        &_character0000222C,
        &_character0000222D,
        &_character0000222E,
        &_character0000222F,
        &_character00002230,
        &_character00002231,
        &_character00002232,
        &_character00002233,
        &_character00002234,
        &_character00002235,
        &_character00002236,
        &_character00002237,
        &_character00002238,
        &_character00002239,
        &_character0000223A,
        &_character0000223B,
        &_character0000223C,
        &_character0000223D,
        &_character0000223E,
        &_character0000223F,
        &_character00002240,
        &_character00002241,
        &_character00002242,
        &_character00002243,
        &_character00002244,
        &_character00002245,
        &_character00002246,
        &_character00002247,
        &_character00002248,
        &_character00002249,
        &_character0000224A,
        &_character0000224B,
        &_character0000224C,
        &_character0000224D,
        &_character0000224E,
        &_character0000224F,
        &_character00002250,
        &_character00002251,
        &_character00002252,
        &_character00002253,
        &_character00002254,
        &_character00002255,
        &_character00002256,
        &_character00002257,
        &_character00002258,
        &_character00002259,
        &_character0000225A,
        &_character0000225B,
        &_character0000225C,
        &_character0000225D,
        &_character0000225E,
        &_character0000225F,
        &_character00002260,
        &_character00002261,
        &_character00002262,
        &_character00002263,
        &_character00002264,
        &_character00002265,
        &_character00002266,
        &_character00002267,
        &_character00002268,
        &_character00002269,
        &_character0000226A,
        &_character0000226B,
        &_character0000226C,
        &_character0000226D,
        &_character0000226E,
        &_character0000226F,
        &_character00002270,
        &_character00002271,
        &_character00002272,
        &_character00002273,
        &_character00002274,
        &_character00002275,
        &_character00002276,
        &_character00002277,
        &_character00002278,
        &_character00002279,
        &_character0000227A,
        &_character0000227B,
        &_character0000227C,
        &_character0000227D,
        &_character0000227E,
        &_character0000227F,
        &_character00002280,
        &_character00002281,
        &_character00002282,
        &_character00002283,
        &_character00002284,
        &_character00002285,
        &_character00002286,
        &_character00002287,
        &_character00002288,
        &_character00002289,
        &_character0000228A,
        &_character0000228B,
        &_character0000228C,
        &_character0000228D,
        &_character0000228E,
        &_character0000228F,
        &_character00002290,
        &_character00002291,
        &_character00002292,
        &_character00002293,
        &_character00002294,
        &_character00002295,
        &_character00002296,
        &_character00002297,
        &_character00002298,
        &_character00002299,
        &_character0000229A,
        &_character0000229B,
        &_character0000229C,
        &_character0000229D,
        &_character0000229E,
        &_character0000229F,
        &_character000022A0,
        &_character000022A1,
        &_character000022A2,
        &_character000022A3,
        &_character000022A4,
        &_character000022A5,
        &_character000022A6,
        &_character000022A7,
        &_character000022A8,
        &_character000022A9,
        &_character000022AA,
        &_character000022AB,
        &_character000022AC,
        &_character000022AD,
        &_character000022AE,
        &_character000022AF,
        &_character000022B0,
        &_character000022B1,
        &_character000022B2,
        &_character000022B3,
        &_character000022B4,
        &_character000022B5,
        &_character000022B6,
        &_character000022B7,
        &_character000022B8,
        &_character000022B9,
        &_character000022BA,
        &_character000022BB,
        &_character000022BC,
        &_character000022BD,
        &_character000022BE,
        &_character000022BF,
        &_character000022C0,
        &_character000022C1,
        &_character000022C2,
        &_character000022C3,
        &_character000022C4,
        &_character000022C5,
        &_character000022C6,
        &_character000022C7,
        &_character000022C8,
        &_character000022C9,
        &_character000022CA,
        &_character000022CB,
        &_character000022CC,
        &_character000022CD,
        &_character000022CE,
        &_character000022CF,
        &_character000022D0,
        &_character000022D1,
        &_character000022D2,
        &_character000022D3,
        &_character000022D4,
        &_character000022D5,
        &_character000022D6,
        &_character000022D7,
        &_character000022D8,
        &_character000022D9,
        &_character000022DA,
        &_character000022DB,
        &_character000022DC,
        &_character000022DD,
        &_character000022DE,
        &_character000022DF,
        &_character000022E0,
        &_character000022E1,
        &_character000022E2,
        &_character000022E3,
        &_character000022E4,
        &_character000022E5,
        &_character000022E6,
        &_character000022E7,
        &_character000022E8,
        &_character000022E9,
        &_character000022EA,
        &_character000022EB,
        &_character000022EC,
        &_character000022ED,
        &_character000022EE,
        &_character000022EF,
        &_character000022F0,
        &_character000022F1,
        &_character000022F2,
        &_character000022F3,
        &_character000022F4,
        &_character000022F5,
        &_character000022F6,
        &_character000022F7,
        &_character000022F8,
        &_character000022F9,
        &_character000022FA,
        &_character000022FB,
        &_character000022FC,
        &_character000022FD,
        &_character000022FE,
        &_character000022FF,
        &_character00002300,
        &_character00002301,
        &_character00002302,
        &_character00002303,
        &_character00002304,
        &_character00002305,
        &_character00002306,
        &_character00002307,
        &_character00002308,
        &_character00002309,
        &_character0000230A,
        &_character0000230B,
        &_character0000230C,
        &_character0000230D,
        &_character0000230E,
        &_character0000230F,
        &_character00002310,
        &_character00002311,
        &_character00002312,
        &_character00002313,
        &_character00002314,
        &_character00002315,
        &_character00002316,
        &_character00002317,
        &_character00002318,
        &_character00002319,
        &_character0000231A,
        &_character0000231B,
        &_character0000231C,
        &_character0000231D,
        &_character0000231E,
        &_character0000231F,
        &_character00002320,
        &_character00002321,
        &_character00002322,
        &_character00002323,
        &_character00002324,
        &_character00002325,
        &_character00002326,
        &_character00002327,
        &_character00002328,
        &_character00002329,
        &_character0000232A,
        &_character0000232B,
        &_character0000232C,
        &_character0000232D,
        &_character0000232E,
        &_character0000232F,
        &_character00002330,
        &_character00002331,
        &_character00002332,
        &_character00002333,
        &_character00002334,
        &_character00002335,
        &_character00002336,
        &_character00002337,
        &_character00002338,
        &_character00002339,
        &_character0000233A,
        &_character0000233B,
        &_character0000233C,
        &_character0000233D,
        &_character0000233E,
        &_character0000233F,
        &_character00002340,
        &_character00002341,
        &_character00002342,
        &_character00002343,
        &_character00002344,
        &_character00002345,
        &_character00002346,
        &_character00002347,
        &_character00002348,
        &_character00002349,
        &_character0000234A,
        &_character0000234B,
        &_character0000234C,
        &_character0000234D,
        &_character0000234E,
        &_character0000234F,
        &_character00002350,
        &_character00002351,
        &_character00002352,
        &_character00002353,
        &_character00002354,
        &_character00002355,
        &_character00002356,
        &_character00002357,
        &_character00002358,
        &_character00002359,
        &_character0000235A,
        &_character0000235B,
        &_character0000235C,
        &_character0000235D,
        &_character0000235E,
        &_character0000235F,
        &_character00002360,
        &_character00002361,
        &_character00002362,
        &_character00002363,
        &_character00002364,
        &_character00002365,
        &_character00002366,
        &_character00002367,
        &_character00002368,
        &_character00002369,
        &_character0000236A,
        &_character0000236B,
        &_character0000236C,
        &_character0000236D,
        &_character0000236E,
        &_character0000236F,
        &_character00002370,
        &_character00002371,
        &_character00002372,
        &_character00002373,
        &_character00002374,
        &_character00002375,
        &_character00002376,
        &_character00002377,
        &_character00002378,
        &_character00002379,
        &_character0000237A,
        &_character0000237B,
        &_character0000237C,
        &_character0000237D,
        &_character0000237E,
        &_character0000237F,
        &_character00002380,
        &_character00002381,
        &_character00002382,
        &_character00002383,
        &_character00002384,
        &_character00002385,
        &_character00002386,
        &_character00002387,
        &_character00002388,
        &_character00002389,
        &_character0000238A,
        &_character0000238B,
        &_character0000238C,
        &_character0000238D,
        &_character0000238E,
        &_character0000238F,
        &_character00002390,
        &_character00002391,
        &_character00002392,
        &_character00002393,
        &_character00002394,
        &_character00002395,
        &_character00002396,
        &_character00002397,
        &_character00002398,
        &_character00002399,
        &_character0000239A,
        &_character0000239B,
        &_character0000239C,
        &_character0000239D,
        &_character0000239E,
        &_character0000239F,
        &_character000023A0,
        &_character000023A1,
        &_character000023A2,
        &_character000023A3,
        &_character000023A4,
        &_character000023A5,
        &_character000023A6,
        &_character000023A7,
        &_character000023A8,
        &_character000023A9,
        &_character000023AA,
        &_character000023AB,
        &_character000023AC,
        &_character000023AD,
        &_character000023AE,
        &_character000023AF,
        &_character000023B0,
        &_character000023B1,
        &_character000023B2,
        &_character000023B3,
        &_character000023B4,
        &_character000023B5,
        &_character000023B6,
        &_character000023B7,
        &_character000023B8,
        &_character000023B9,
        &_character000023BA,
        &_character000023BB,
        &_character000023BC,
        &_character000023BD,
        &_character000023BE,
        &_character000023BF,
        &_character000023C0,
        &_character000023C1,
        &_character000023C2,
        &_character000023C3,
        &_character000023C4,
        &_character000023C5,
        &_character000023C6,
        &_character000023C7,
        &_character000023C8,
        &_character000023C9,
        &_character000023CA,
        &_character000023CB,
        &_character000023CC,
        &_character000023CD,
        &_character000023CE,
        &_character000023CF,
        &_character000023D0,
        &_character000023D1,
        &_character000023D2,
        &_character000023D3,
        &_character000023D4,
        &_character000023D5,
        &_character000023D6,
        &_character000023D7,
        &_character000023D8,
        &_character000023D9,
        &_character000023DA,
        &_character000023DB,
        &_character000023DC,
        &_character000023DD,
        &_character000023DE,
        &_character000023DF,
        &_character000023E0,
        &_character000023E1,
        &_character000023E2,
        &_character000023E3,
        &_character000023E4,
        &_character000023E5,
        &_character000023E6,
        &_character000023E7,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002400,
        &_character00002401,
        &_character00002402,
        &_character00002403,
        &_character00002404,
        &_character00002405,
        &_character00002406,
        &_character00002407,
        &_character00002408,
        &_character00002409,
        &_character0000240A,
        &_character0000240B,
        &_character0000240C,
        &_character0000240D,
        &_character0000240E,
        &_character0000240F,
        &_character00002410,
        &_character00002411,
        &_character00002412,
        &_character00002413,
        &_character00002414,
        &_character00002415,
        &_character00002416,
        &_character00002417,
        &_character00002418,
        &_character00002419,
        &_character0000241A,
        &_character0000241B,
        &_character0000241C,
        &_character0000241D,
        &_character0000241E,
        &_character0000241F,
        &_character00002420,
        &_character00002421,
        &_character00002422,
        &_character00002423,
        &_character00002424,
        &_character00002425,
        &_character00002426,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002440,
        &_character00002441,
        &_character00002442,
        &_character00002443,
        &_character00002444,
        &_character00002445,
        &_character00002446,
        &_character00002447,
        &_character00002448,
        &_character00002449,
        &_character0000244A,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002460,
        &_character00002461,
        &_character00002462,
        &_character00002463,
        &_character00002464,
        &_character00002465,
        &_character00002466,
        &_character00002467,
        &_character00002468,
        &_character00002469,
        &_character0000246A,
        &_character0000246B,
        &_character0000246C,
        &_character0000246D,
        &_character0000246E,
        &_character0000246F,
        &_character00002470,
        &_character00002471,
        &_character00002472,
        &_character00002473,
        &_character00002474,
        &_character00002475,
        &_character00002476,
        &_character00002477,
        &_character00002478,
        &_character00002479,
        &_character0000247A,
        &_character0000247B,
        &_character0000247C,
        &_character0000247D,
        &_character0000247E,
        &_character0000247F,
        &_character00002480,
        &_character00002481,
        &_character00002482,
        &_character00002483,
        &_character00002484,
        &_character00002485,
        &_character00002486,
        &_character00002487,
        &_character00002488,
        &_character00002489,
        &_character0000248A,
        &_character0000248B,
        &_character0000248C,
        &_character0000248D,
        &_character0000248E,
        &_character0000248F,
        &_character00002490,
        &_character00002491,
        &_character00002492,
        &_character00002493,
        &_character00002494,
        &_character00002495,
        &_character00002496,
        &_character00002497,
        &_character00002498,
        &_character00002499,
        &_character0000249A,
        &_character0000249B,
        &_character0000249C,
        &_character0000249D,
        &_character0000249E,
        &_character0000249F,
        &_character000024A0,
        &_character000024A1,
        &_character000024A2,
        &_character000024A3,
        &_character000024A4,
        &_character000024A5,
        &_character000024A6,
        &_character000024A7,
        &_character000024A8,
        &_character000024A9,
        &_character000024AA,
        &_character000024AB,
        &_character000024AC,
        &_character000024AD,
        &_character000024AE,
        &_character000024AF,
        &_character000024B0,
        &_character000024B1,
        &_character000024B2,
        &_character000024B3,
        &_character000024B4,
        &_character000024B5,
        &_character000024B6,
        &_character000024B7,
        &_character000024B8,
        &_character000024B9,
        &_character000024BA,
        &_character000024BB,
        &_character000024BC,
        &_character000024BD,
        &_character000024BE,
        &_character000024BF,
        &_character000024C0,
        &_character000024C1,
        &_character000024C2,
        &_character000024C3,
        &_character000024C4,
        &_character000024C5,
        &_character000024C6,
        &_character000024C7,
        &_character000024C8,
        &_character000024C9,
        &_character000024CA,
        &_character000024CB,
        &_character000024CC,
        &_character000024CD,
        &_character000024CE,
        &_character000024CF,
        &_character000024D0,
        &_character000024D1,
        &_character000024D2,
        &_character000024D3,
        &_character000024D4,
        &_character000024D5,
        &_character000024D6,
        &_character000024D7,
        &_character000024D8,
        &_character000024D9,
        &_character000024DA,
        &_character000024DB,
        &_character000024DC,
        &_character000024DD,
        &_character000024DE,
        &_character000024DF,
        &_character000024E0,
        &_character000024E1,
        &_character000024E2,
        &_character000024E3,
        &_character000024E4,
        &_character000024E5,
        &_character000024E6,
        &_character000024E7,
        &_character000024E8,
        &_character000024E9,
        &_character000024EA,
        &_character000024EB,
        &_character000024EC,
        &_character000024ED,
        &_character000024EE,
        &_character000024EF,
        &_character000024F0,
        &_character000024F1,
        &_character000024F2,
        &_character000024F3,
        &_character000024F4,
        &_character000024F5,
        &_character000024F6,
        &_character000024F7,
        &_character000024F8,
        &_character000024F9,
        &_character000024FA,
        &_character000024FB,
        &_character000024FC,
        &_character000024FD,
        &_character000024FE,
        &_character000024FF,
        &_character00002500,
        &_character00002501,
        &_character00002502,
        &_character00002503,
        &_character00002504,
        &_character00002505,
        &_character00002506,
        &_character00002507,
        &_character00002508,
        &_character00002509,
        &_character0000250A,
        &_character0000250B,
        &_character0000250C,
        &_character0000250D,
        &_character0000250E,
        &_character0000250F,
        &_character00002510,
        &_character00002511,
        &_character00002512,
        &_character00002513,
        &_character00002514,
        &_character00002515,
        &_character00002516,
        &_character00002517,
        &_character00002518,
        &_character00002519,
        &_character0000251A,
        &_character0000251B,
        &_character0000251C,
        &_character0000251D,
        &_character0000251E,
        &_character0000251F,
        &_character00002520,
        &_character00002521,
        &_character00002522,
        &_character00002523,
        &_character00002524,
        &_character00002525,
        &_character00002526,
        &_character00002527,
        &_character00002528,
        &_character00002529,
        &_character0000252A,
        &_character0000252B,
        &_character0000252C,
        &_character0000252D,
        &_character0000252E,
        &_character0000252F,
        &_character00002530,
        &_character00002531,
        &_character00002532,
        &_character00002533,
        &_character00002534,
        &_character00002535,
        &_character00002536,
        &_character00002537,
        &_character00002538,
        &_character00002539,
        &_character0000253A,
        &_character0000253B,
        &_character0000253C,
        &_character0000253D,
        &_character0000253E,
        &_character0000253F,
        &_character00002540,
        &_character00002541,
        &_character00002542,
        &_character00002543,
        &_character00002544,
        &_character00002545,
        &_character00002546,
        &_character00002547,
        &_character00002548,
        &_character00002549,
        &_character0000254A,
        &_character0000254B,
        &_character0000254C,
        &_character0000254D,
        &_character0000254E,
        &_character0000254F,
        &_character00002550,
        &_character00002551,
        &_character00002552,
        &_character00002553,
        &_character00002554,
        &_character00002555,
        &_character00002556,
        &_character00002557,
        &_character00002558,
        &_character00002559,
        &_character0000255A,
        &_character0000255B,
        &_character0000255C,
        &_character0000255D,
        &_character0000255E,
        &_character0000255F,
        &_character00002560,
        &_character00002561,
        &_character00002562,
        &_character00002563,
        &_character00002564,
        &_character00002565,
        &_character00002566,
        &_character00002567,
        &_character00002568,
        &_character00002569,
        &_character0000256A,
        &_character0000256B,
        &_character0000256C,
        &_character0000256D,
        &_character0000256E,
        &_character0000256F,
        &_character00002570,
        &_character00002571,
        &_character00002572,
        &_character00002573,
        &_character00002574,
        &_character00002575,
        &_character00002576,
        &_character00002577,
        &_character00002578,
        &_character00002579,
        &_character0000257A,
        &_character0000257B,
        &_character0000257C,
        &_character0000257D,
        &_character0000257E,
        &_character0000257F,
        &_character00002580,
        &_character00002581,
        &_character00002582,
        &_character00002583,
        &_character00002584,
        &_character00002585,
        &_character00002586,
        &_character00002587,
        &_character00002588,
        &_character00002589,
        &_character0000258A,
        &_character0000258B,
        &_character0000258C,
        &_character0000258D,
        &_character0000258E,
        &_character0000258F,
        &_character00002590,
        &_character00002591,
        &_character00002592,
        &_character00002593,
        &_character00002594,
        &_character00002595,
        &_character00002596,
        &_character00002597,
        &_character00002598,
        &_character00002599,
        &_character0000259A,
        &_character0000259B,
        &_character0000259C,
        &_character0000259D,
        &_character0000259E,
        &_character0000259F,
        &_character000025A0,
        &_character000025A1,
        &_character000025A2,
        &_character000025A3,
        &_character000025A4,
        &_character000025A5,
        &_character000025A6,
        &_character000025A7,
        &_character000025A8,
        &_character000025A9,
        &_character000025AA,
        &_character000025AB,
        &_character000025AC,
        &_character000025AD,
        &_character000025AE,
        &_character000025AF,
        &_character000025B0,
        &_character000025B1,
        &_character000025B2,
        &_character000025B3,
        &_character000025B4,
        &_character000025B5,
        &_character000025B6,
        &_character000025B7,
        &_character000025B8,
        &_character000025B9,
        &_character000025BA,
        &_character000025BB,
        &_character000025BC,
        &_character000025BD,
        &_character000025BE,
        &_character000025BF,
        &_character000025C0,
        &_character000025C1,
        &_character000025C2,
        &_character000025C3,
        &_character000025C4,
        &_character000025C5,
        &_character000025C6,
        &_character000025C7,
        &_character000025C8,
        &_character000025C9,
        &_character000025CA,
        &_character000025CB,
        &_character000025CC,
        &_character000025CD,
        &_character000025CE,
        &_character000025CF,
        &_character000025D0,
        &_character000025D1,
        &_character000025D2,
        &_character000025D3,
        &_character000025D4,
        &_character000025D5,
        &_character000025D6,
        &_character000025D7,
        &_character000025D8,
        &_character000025D9,
        &_character000025DA,
        &_character000025DB,
        &_character000025DC,
        &_character000025DD,
        &_character000025DE,
        &_character000025DF,
        &_character000025E0,
        &_character000025E1,
        &_character000025E2,
        &_character000025E3,
        &_character000025E4,
        &_character000025E5,
        &_character000025E6,
        &_character000025E7,
        &_character000025E8,
        &_character000025E9,
        &_character000025EA,
        &_character000025EB,
        &_character000025EC,
        &_character000025ED,
        &_character000025EE,
        &_character000025EF,
        &_character000025F0,
        &_character000025F1,
        &_character000025F2,
        &_character000025F3,
        &_character000025F4,
        &_character000025F5,
        &_character000025F6,
        &_character000025F7,
        &_character000025F8,
        &_character000025F9,
        &_character000025FA,
        &_character000025FB,
        &_character000025FC,
        &_character000025FD,
        &_character000025FE,
        &_character000025FF,
        &_character00002600,
        &_character00002601,
        &_character00002602,
        &_character00002603,
        &_character00002604,
        &_character00002605,
        &_character00002606,
        &_character00002607,
        &_character00002608,
        &_character00002609,
        &_character0000260A,
        &_character0000260B,
        &_character0000260C,
        &_character0000260D,
        &_character0000260E,
        &_character0000260F,
        &_character00002610,
        &_character00002611,
        &_character00002612,
        &_character00002613,
        &_character00002614,
        &_character00002615,
        &_character00002616,
        &_character00002617,
        &_character00002618,
        &_character00002619,
        &_character0000261A,
        &_character0000261B,
        &_character0000261C,
        &_character0000261D,
        &_character0000261E,
        &_character0000261F,
        &_character00002620,
        &_character00002621,
        &_character00002622,
        &_character00002623,
        &_character00002624,
        &_character00002625,
        &_character00002626,
        &_character00002627,
        &_character00002628,
        &_character00002629,
        &_character0000262A,
        &_character0000262B,
        &_character0000262C,
        &_character0000262D,
        &_character0000262E,
        &_character0000262F,
        &_character00002630,
        &_character00002631,
        &_character00002632,
        &_character00002633,
        &_character00002634,
        &_character00002635,
        &_character00002636,
        &_character00002637,
        &_character00002638,
        &_character00002639,
        &_character0000263A,
        &_character0000263B,
        &_character0000263C,
        &_character0000263D,
        &_character0000263E,
        &_character0000263F,
        &_character00002640,
        &_character00002641,
        &_character00002642,
        &_character00002643,
        &_character00002644,
        &_character00002645,
        &_character00002646,
        &_character00002647,
        &_character00002648,
        &_character00002649,
        &_character0000264A,
        &_character0000264B,
        &_character0000264C,
        &_character0000264D,
        &_character0000264E,
        &_character0000264F,
        &_character00002650,
        &_character00002651,
        &_character00002652,
        &_character00002653,
        &_character00002654,
        &_character00002655,
        &_character00002656,
        &_character00002657,
        &_character00002658,
        &_character00002659,
        &_character0000265A,
        &_character0000265B,
        &_character0000265C,
        &_character0000265D,
        &_character0000265E,
        &_character0000265F,
        &_character00002660,
        &_character00002661,
        &_character00002662,
        &_character00002663,
        &_character00002664,
        &_character00002665,
        &_character00002666,
        &_character00002667,
        &_character00002668,
        &_character00002669,
        &_character0000266A,
        &_character0000266B,
        &_character0000266C,
        &_character0000266D,
        &_character0000266E,
        &_character0000266F,
        &_character00002670,
        &_character00002671,
        &_character00002672,
        &_character00002673,
        &_character00002674,
        &_character00002675,
        &_character00002676,
        &_character00002677,
        &_character00002678,
        &_character00002679,
        &_character0000267A,
        &_character0000267B,
        &_character0000267C,
        &_character0000267D,
        &_character0000267E,
        &_character0000267F,
        &_character00002680,
        &_character00002681,
        &_character00002682,
        &_character00002683,
        &_character00002684,
        &_character00002685,
        &_character00002686,
        &_character00002687,
        &_character00002688,
        &_character00002689,
        &_character0000268A,
        &_character0000268B,
        &_character0000268C,
        &_character0000268D,
        &_character0000268E,
        &_character0000268F,
        &_character00002690,
        &_character00002691,
        &_character00002692,
        &_character00002693,
        &_character00002694,
        &_character00002695,
        &_character00002696,
        &_character00002697,
        &_character00002698,
        &_character00002699,
        &_character0000269A,
        &_character0000269B,
        &_character0000269C,
        0,
        0,
        0,
        &_character000026A0,
        &_character000026A1,
        &_character000026A2,
        &_character000026A3,
        &_character000026A4,
        &_character000026A5,
        &_character000026A6,
        &_character000026A7,
        &_character000026A8,
        &_character000026A9,
        &_character000026AA,
        &_character000026AB,
        &_character000026AC,
        &_character000026AD,
        &_character000026AE,
        &_character000026AF,
        &_character000026B0,
        &_character000026B1,
        &_character000026B2,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002701,
        &_character00002702,
        &_character00002703,
        &_character00002704,
        0,
        &_character00002706,
        &_character00002707,
        &_character00002708,
        &_character00002709,
        0,
        0,
        &_character0000270C,
        &_character0000270D,
        &_character0000270E,
        &_character0000270F,
        &_character00002710,
        &_character00002711,
        &_character00002712,
        &_character00002713,
        &_character00002714,
        &_character00002715,
        &_character00002716,
        &_character00002717,
        &_character00002718,
        &_character00002719,
        &_character0000271A,
        &_character0000271B,
        &_character0000271C,
        &_character0000271D,
        &_character0000271E,
        &_character0000271F,
        &_character00002720,
        &_character00002721,
        &_character00002722,
        &_character00002723,
        &_character00002724,
        &_character00002725,
        &_character00002726,
        &_character00002727,
        0,
        &_character00002729,
        &_character0000272A,
        &_character0000272B,
        &_character0000272C,
        &_character0000272D,
        &_character0000272E,
        &_character0000272F,
        &_character00002730,
        &_character00002731,
        &_character00002732,
        &_character00002733,
        &_character00002734,
        &_character00002735,
        &_character00002736,
        &_character00002737,
        &_character00002738,
        &_character00002739,
        &_character0000273A,
        &_character0000273B,
        &_character0000273C,
        &_character0000273D,
        &_character0000273E,
        &_character0000273F,
        &_character00002740,
        &_character00002741,
        &_character00002742,
        &_character00002743,
        &_character00002744,
        &_character00002745,
        &_character00002746,
        &_character00002747,
        &_character00002748,
        &_character00002749,
        &_character0000274A,
        &_character0000274B,
        0,
        &_character0000274D,
        0,
        &_character0000274F,
        &_character00002750,
        &_character00002751,
        &_character00002752,
        0,
        0,
        0,
        &_character00002756,
        0,
        &_character00002758,
        &_character00002759,
        &_character0000275A,
        &_character0000275B,
        &_character0000275C,
        &_character0000275D,
        &_character0000275E,
        0,
        0,
        &_character00002761,
        &_character00002762,
        &_character00002763,
        &_character00002764,
        &_character00002765,
        &_character00002766,
        &_character00002767,
        &_character00002768,
        &_character00002769,
        &_character0000276A,
        &_character0000276B,
        &_character0000276C,
        &_character0000276D,
        &_character0000276E,
        &_character0000276F,
        &_character00002770,
        &_character00002771,
        &_character00002772,
        &_character00002773,
        &_character00002774,
        &_character00002775,
        &_character00002776,
        &_character00002777,
        &_character00002778,
        &_character00002779,
        &_character0000277A,
        &_character0000277B,
        &_character0000277C,
        &_character0000277D,
        &_character0000277E,
        &_character0000277F,
        &_character00002780,
        &_character00002781,
        &_character00002782,
        &_character00002783,
        &_character00002784,
        &_character00002785,
        &_character00002786,
        &_character00002787,
        &_character00002788,
        &_character00002789,
        &_character0000278A,
        &_character0000278B,
        &_character0000278C,
        &_character0000278D,
        &_character0000278E,
        &_character0000278F,
        &_character00002790,
        &_character00002791,
        &_character00002792,
        &_character00002793,
        &_character00002794,
        0,
        0,
        0,
        &_character00002798,
        &_character00002799,
        &_character0000279A,
        &_character0000279B,
        &_character0000279C,
        &_character0000279D,
        &_character0000279E,
        &_character0000279F,
        &_character000027A0,
        &_character000027A1,
        &_character000027A2,
        &_character000027A3,
        &_character000027A4,
        &_character000027A5,
        &_character000027A6,
        &_character000027A7,
        &_character000027A8,
        &_character000027A9,
        &_character000027AA,
        &_character000027AB,
        &_character000027AC,
        &_character000027AD,
        &_character000027AE,
        &_character000027AF,
        0,
        &_character000027B1,
        &_character000027B2,
        &_character000027B3,
        &_character000027B4,
        &_character000027B5,
        &_character000027B6,
        &_character000027B7,
        &_character000027B8,
        &_character000027B9,
        &_character000027BA,
        &_character000027BB,
        &_character000027BC,
        &_character000027BD,
        &_character000027BE,
        0,
        &_character000027C0,
        &_character000027C1,
        &_character000027C2,
        &_character000027C3,
        &_character000027C4,
        &_character000027C5,
        &_character000027C6,
        &_character000027C7,
        &_character000027C8,
        &_character000027C9,
        &_character000027CA,
        0,
        0,
        0,
        0,
        0,
        &_character000027D0,
        &_character000027D1,
        &_character000027D2,
        &_character000027D3,
        &_character000027D4,
        &_character000027D5,
        &_character000027D6,
        &_character000027D7,
        &_character000027D8,
        &_character000027D9,
        &_character000027DA,
        &_character000027DB,
        &_character000027DC,
        &_character000027DD,
        &_character000027DE,
        &_character000027DF,
        &_character000027E0,
        &_character000027E1,
        &_character000027E2,
        &_character000027E3,
        &_character000027E4,
        &_character000027E5,
        &_character000027E6,
        &_character000027E7,
        &_character000027E8,
        &_character000027E9,
        &_character000027EA,
        &_character000027EB,
        0,
        0,
        0,
        0,
        &_character000027F0,
        &_character000027F1,
        &_character000027F2,
        &_character000027F3,
        &_character000027F4,
        &_character000027F5,
        &_character000027F6,
        &_character000027F7,
        &_character000027F8,
        &_character000027F9,
        &_character000027FA,
        &_character000027FB,
        &_character000027FC,
        &_character000027FD,
        &_character000027FE,
        &_character000027FF
    };

    static _CharacterInfo * _table300002800[2048] =
    {
        &_character00002800,
        &_character00002801,
        &_character00002802,
        &_character00002803,
        &_character00002804,
        &_character00002805,
        &_character00002806,
        &_character00002807,
        &_character00002808,
        &_character00002809,
        &_character0000280A,
        &_character0000280B,
        &_character0000280C,
        &_character0000280D,
        &_character0000280E,
        &_character0000280F,
        &_character00002810,
        &_character00002811,
        &_character00002812,
        &_character00002813,
        &_character00002814,
        &_character00002815,
        &_character00002816,
        &_character00002817,
        &_character00002818,
        &_character00002819,
        &_character0000281A,
        &_character0000281B,
        &_character0000281C,
        &_character0000281D,
        &_character0000281E,
        &_character0000281F,
        &_character00002820,
        &_character00002821,
        &_character00002822,
        &_character00002823,
        &_character00002824,
        &_character00002825,
        &_character00002826,
        &_character00002827,
        &_character00002828,
        &_character00002829,
        &_character0000282A,
        &_character0000282B,
        &_character0000282C,
        &_character0000282D,
        &_character0000282E,
        &_character0000282F,
        &_character00002830,
        &_character00002831,
        &_character00002832,
        &_character00002833,
        &_character00002834,
        &_character00002835,
        &_character00002836,
        &_character00002837,
        &_character00002838,
        &_character00002839,
        &_character0000283A,
        &_character0000283B,
        &_character0000283C,
        &_character0000283D,
        &_character0000283E,
        &_character0000283F,
        &_character00002840,
        &_character00002841,
        &_character00002842,
        &_character00002843,
        &_character00002844,
        &_character00002845,
        &_character00002846,
        &_character00002847,
        &_character00002848,
        &_character00002849,
        &_character0000284A,
        &_character0000284B,
        &_character0000284C,
        &_character0000284D,
        &_character0000284E,
        &_character0000284F,
        &_character00002850,
        &_character00002851,
        &_character00002852,
        &_character00002853,
        &_character00002854,
        &_character00002855,
        &_character00002856,
        &_character00002857,
        &_character00002858,
        &_character00002859,
        &_character0000285A,
        &_character0000285B,
        &_character0000285C,
        &_character0000285D,
        &_character0000285E,
        &_character0000285F,
        &_character00002860,
        &_character00002861,
        &_character00002862,
        &_character00002863,
        &_character00002864,
        &_character00002865,
        &_character00002866,
        &_character00002867,
        &_character00002868,
        &_character00002869,
        &_character0000286A,
        &_character0000286B,
        &_character0000286C,
        &_character0000286D,
        &_character0000286E,
        &_character0000286F,
        &_character00002870,
        &_character00002871,
        &_character00002872,
        &_character00002873,
        &_character00002874,
        &_character00002875,
        &_character00002876,
        &_character00002877,
        &_character00002878,
        &_character00002879,
        &_character0000287A,
        &_character0000287B,
        &_character0000287C,
        &_character0000287D,
        &_character0000287E,
        &_character0000287F,
        &_character00002880,
        &_character00002881,
        &_character00002882,
        &_character00002883,
        &_character00002884,
        &_character00002885,
        &_character00002886,
        &_character00002887,
        &_character00002888,
        &_character00002889,
        &_character0000288A,
        &_character0000288B,
        &_character0000288C,
        &_character0000288D,
        &_character0000288E,
        &_character0000288F,
        &_character00002890,
        &_character00002891,
        &_character00002892,
        &_character00002893,
        &_character00002894,
        &_character00002895,
        &_character00002896,
        &_character00002897,
        &_character00002898,
        &_character00002899,
        &_character0000289A,
        &_character0000289B,
        &_character0000289C,
        &_character0000289D,
        &_character0000289E,
        &_character0000289F,
        &_character000028A0,
        &_character000028A1,
        &_character000028A2,
        &_character000028A3,
        &_character000028A4,
        &_character000028A5,
        &_character000028A6,
        &_character000028A7,
        &_character000028A8,
        &_character000028A9,
        &_character000028AA,
        &_character000028AB,
        &_character000028AC,
        &_character000028AD,
        &_character000028AE,
        &_character000028AF,
        &_character000028B0,
        &_character000028B1,
        &_character000028B2,
        &_character000028B3,
        &_character000028B4,
        &_character000028B5,
        &_character000028B6,
        &_character000028B7,
        &_character000028B8,
        &_character000028B9,
        &_character000028BA,
        &_character000028BB,
        &_character000028BC,
        &_character000028BD,
        &_character000028BE,
        &_character000028BF,
        &_character000028C0,
        &_character000028C1,
        &_character000028C2,
        &_character000028C3,
        &_character000028C4,
        &_character000028C5,
        &_character000028C6,
        &_character000028C7,
        &_character000028C8,
        &_character000028C9,
        &_character000028CA,
        &_character000028CB,
        &_character000028CC,
        &_character000028CD,
        &_character000028CE,
        &_character000028CF,
        &_character000028D0,
        &_character000028D1,
        &_character000028D2,
        &_character000028D3,
        &_character000028D4,
        &_character000028D5,
        &_character000028D6,
        &_character000028D7,
        &_character000028D8,
        &_character000028D9,
        &_character000028DA,
        &_character000028DB,
        &_character000028DC,
        &_character000028DD,
        &_character000028DE,
        &_character000028DF,
        &_character000028E0,
        &_character000028E1,
        &_character000028E2,
        &_character000028E3,
        &_character000028E4,
        &_character000028E5,
        &_character000028E6,
        &_character000028E7,
        &_character000028E8,
        &_character000028E9,
        &_character000028EA,
        &_character000028EB,
        &_character000028EC,
        &_character000028ED,
        &_character000028EE,
        &_character000028EF,
        &_character000028F0,
        &_character000028F1,
        &_character000028F2,
        &_character000028F3,
        &_character000028F4,
        &_character000028F5,
        &_character000028F6,
        &_character000028F7,
        &_character000028F8,
        &_character000028F9,
        &_character000028FA,
        &_character000028FB,
        &_character000028FC,
        &_character000028FD,
        &_character000028FE,
        &_character000028FF,
        &_character00002900,
        &_character00002901,
        &_character00002902,
        &_character00002903,
        &_character00002904,
        &_character00002905,
        &_character00002906,
        &_character00002907,
        &_character00002908,
        &_character00002909,
        &_character0000290A,
        &_character0000290B,
        &_character0000290C,
        &_character0000290D,
        &_character0000290E,
        &_character0000290F,
        &_character00002910,
        &_character00002911,
        &_character00002912,
        &_character00002913,
        &_character00002914,
        &_character00002915,
        &_character00002916,
        &_character00002917,
        &_character00002918,
        &_character00002919,
        &_character0000291A,
        &_character0000291B,
        &_character0000291C,
        &_character0000291D,
        &_character0000291E,
        &_character0000291F,
        &_character00002920,
        &_character00002921,
        &_character00002922,
        &_character00002923,
        &_character00002924,
        &_character00002925,
        &_character00002926,
        &_character00002927,
        &_character00002928,
        &_character00002929,
        &_character0000292A,
        &_character0000292B,
        &_character0000292C,
        &_character0000292D,
        &_character0000292E,
        &_character0000292F,
        &_character00002930,
        &_character00002931,
        &_character00002932,
        &_character00002933,
        &_character00002934,
        &_character00002935,
        &_character00002936,
        &_character00002937,
        &_character00002938,
        &_character00002939,
        &_character0000293A,
        &_character0000293B,
        &_character0000293C,
        &_character0000293D,
        &_character0000293E,
        &_character0000293F,
        &_character00002940,
        &_character00002941,
        &_character00002942,
        &_character00002943,
        &_character00002944,
        &_character00002945,
        &_character00002946,
        &_character00002947,
        &_character00002948,
        &_character00002949,
        &_character0000294A,
        &_character0000294B,
        &_character0000294C,
        &_character0000294D,
        &_character0000294E,
        &_character0000294F,
        &_character00002950,
        &_character00002951,
        &_character00002952,
        &_character00002953,
        &_character00002954,
        &_character00002955,
        &_character00002956,
        &_character00002957,
        &_character00002958,
        &_character00002959,
        &_character0000295A,
        &_character0000295B,
        &_character0000295C,
        &_character0000295D,
        &_character0000295E,
        &_character0000295F,
        &_character00002960,
        &_character00002961,
        &_character00002962,
        &_character00002963,
        &_character00002964,
        &_character00002965,
        &_character00002966,
        &_character00002967,
        &_character00002968,
        &_character00002969,
        &_character0000296A,
        &_character0000296B,
        &_character0000296C,
        &_character0000296D,
        &_character0000296E,
        &_character0000296F,
        &_character00002970,
        &_character00002971,
        &_character00002972,
        &_character00002973,
        &_character00002974,
        &_character00002975,
        &_character00002976,
        &_character00002977,
        &_character00002978,
        &_character00002979,
        &_character0000297A,
        &_character0000297B,
        &_character0000297C,
        &_character0000297D,
        &_character0000297E,
        &_character0000297F,
        &_character00002980,
        &_character00002981,
        &_character00002982,
        &_character00002983,
        &_character00002984,
        &_character00002985,
        &_character00002986,
        &_character00002987,
        &_character00002988,
        &_character00002989,
        &_character0000298A,
        &_character0000298B,
        &_character0000298C,
        &_character0000298D,
        &_character0000298E,
        &_character0000298F,
        &_character00002990,
        &_character00002991,
        &_character00002992,
        &_character00002993,
        &_character00002994,
        &_character00002995,
        &_character00002996,
        &_character00002997,
        &_character00002998,
        &_character00002999,
        &_character0000299A,
        &_character0000299B,
        &_character0000299C,
        &_character0000299D,
        &_character0000299E,
        &_character0000299F,
        &_character000029A0,
        &_character000029A1,
        &_character000029A2,
        &_character000029A3,
        &_character000029A4,
        &_character000029A5,
        &_character000029A6,
        &_character000029A7,
        &_character000029A8,
        &_character000029A9,
        &_character000029AA,
        &_character000029AB,
        &_character000029AC,
        &_character000029AD,
        &_character000029AE,
        &_character000029AF,
        &_character000029B0,
        &_character000029B1,
        &_character000029B2,
        &_character000029B3,
        &_character000029B4,
        &_character000029B5,
        &_character000029B6,
        &_character000029B7,
        &_character000029B8,
        &_character000029B9,
        &_character000029BA,
        &_character000029BB,
        &_character000029BC,
        &_character000029BD,
        &_character000029BE,
        &_character000029BF,
        &_character000029C0,
        &_character000029C1,
        &_character000029C2,
        &_character000029C3,
        &_character000029C4,
        &_character000029C5,
        &_character000029C6,
        &_character000029C7,
        &_character000029C8,
        &_character000029C9,
        &_character000029CA,
        &_character000029CB,
        &_character000029CC,
        &_character000029CD,
        &_character000029CE,
        &_character000029CF,
        &_character000029D0,
        &_character000029D1,
        &_character000029D2,
        &_character000029D3,
        &_character000029D4,
        &_character000029D5,
        &_character000029D6,
        &_character000029D7,
        &_character000029D8,
        &_character000029D9,
        &_character000029DA,
        &_character000029DB,
        &_character000029DC,
        &_character000029DD,
        &_character000029DE,
        &_character000029DF,
        &_character000029E0,
        &_character000029E1,
        &_character000029E2,
        &_character000029E3,
        &_character000029E4,
        &_character000029E5,
        &_character000029E6,
        &_character000029E7,
        &_character000029E8,
        &_character000029E9,
        &_character000029EA,
        &_character000029EB,
        &_character000029EC,
        &_character000029ED,
        &_character000029EE,
        &_character000029EF,
        &_character000029F0,
        &_character000029F1,
        &_character000029F2,
        &_character000029F3,
        &_character000029F4,
        &_character000029F5,
        &_character000029F6,
        &_character000029F7,
        &_character000029F8,
        &_character000029F9,
        &_character000029FA,
        &_character000029FB,
        &_character000029FC,
        &_character000029FD,
        &_character000029FE,
        &_character000029FF,
        &_character00002A00,
        &_character00002A01,
        &_character00002A02,
        &_character00002A03,
        &_character00002A04,
        &_character00002A05,
        &_character00002A06,
        &_character00002A07,
        &_character00002A08,
        &_character00002A09,
        &_character00002A0A,
        &_character00002A0B,
        &_character00002A0C,
        &_character00002A0D,
        &_character00002A0E,
        &_character00002A0F,
        &_character00002A10,
        &_character00002A11,
        &_character00002A12,
        &_character00002A13,
        &_character00002A14,
        &_character00002A15,
        &_character00002A16,
        &_character00002A17,
        &_character00002A18,
        &_character00002A19,
        &_character00002A1A,
        &_character00002A1B,
        &_character00002A1C,
        &_character00002A1D,
        &_character00002A1E,
        &_character00002A1F,
        &_character00002A20,
        &_character00002A21,
        &_character00002A22,
        &_character00002A23,
        &_character00002A24,
        &_character00002A25,
        &_character00002A26,
        &_character00002A27,
        &_character00002A28,
        &_character00002A29,
        &_character00002A2A,
        &_character00002A2B,
        &_character00002A2C,
        &_character00002A2D,
        &_character00002A2E,
        &_character00002A2F,
        &_character00002A30,
        &_character00002A31,
        &_character00002A32,
        &_character00002A33,
        &_character00002A34,
        &_character00002A35,
        &_character00002A36,
        &_character00002A37,
        &_character00002A38,
        &_character00002A39,
        &_character00002A3A,
        &_character00002A3B,
        &_character00002A3C,
        &_character00002A3D,
        &_character00002A3E,
        &_character00002A3F,
        &_character00002A40,
        &_character00002A41,
        &_character00002A42,
        &_character00002A43,
        &_character00002A44,
        &_character00002A45,
        &_character00002A46,
        &_character00002A47,
        &_character00002A48,
        &_character00002A49,
        &_character00002A4A,
        &_character00002A4B,
        &_character00002A4C,
        &_character00002A4D,
        &_character00002A4E,
        &_character00002A4F,
        &_character00002A50,
        &_character00002A51,
        &_character00002A52,
        &_character00002A53,
        &_character00002A54,
        &_character00002A55,
        &_character00002A56,
        &_character00002A57,
        &_character00002A58,
        &_character00002A59,
        &_character00002A5A,
        &_character00002A5B,
        &_character00002A5C,
        &_character00002A5D,
        &_character00002A5E,
        &_character00002A5F,
        &_character00002A60,
        &_character00002A61,
        &_character00002A62,
        &_character00002A63,
        &_character00002A64,
        &_character00002A65,
        &_character00002A66,
        &_character00002A67,
        &_character00002A68,
        &_character00002A69,
        &_character00002A6A,
        &_character00002A6B,
        &_character00002A6C,
        &_character00002A6D,
        &_character00002A6E,
        &_character00002A6F,
        &_character00002A70,
        &_character00002A71,
        &_character00002A72,
        &_character00002A73,
        &_character00002A74,
        &_character00002A75,
        &_character00002A76,
        &_character00002A77,
        &_character00002A78,
        &_character00002A79,
        &_character00002A7A,
        &_character00002A7B,
        &_character00002A7C,
        &_character00002A7D,
        &_character00002A7E,
        &_character00002A7F,
        &_character00002A80,
        &_character00002A81,
        &_character00002A82,
        &_character00002A83,
        &_character00002A84,
        &_character00002A85,
        &_character00002A86,
        &_character00002A87,
        &_character00002A88,
        &_character00002A89,
        &_character00002A8A,
        &_character00002A8B,
        &_character00002A8C,
        &_character00002A8D,
        &_character00002A8E,
        &_character00002A8F,
        &_character00002A90,
        &_character00002A91,
        &_character00002A92,
        &_character00002A93,
        &_character00002A94,
        &_character00002A95,
        &_character00002A96,
        &_character00002A97,
        &_character00002A98,
        &_character00002A99,
        &_character00002A9A,
        &_character00002A9B,
        &_character00002A9C,
        &_character00002A9D,
        &_character00002A9E,
        &_character00002A9F,
        &_character00002AA0,
        &_character00002AA1,
        &_character00002AA2,
        &_character00002AA3,
        &_character00002AA4,
        &_character00002AA5,
        &_character00002AA6,
        &_character00002AA7,
        &_character00002AA8,
        &_character00002AA9,
        &_character00002AAA,
        &_character00002AAB,
        &_character00002AAC,
        &_character00002AAD,
        &_character00002AAE,
        &_character00002AAF,
        &_character00002AB0,
        &_character00002AB1,
        &_character00002AB2,
        &_character00002AB3,
        &_character00002AB4,
        &_character00002AB5,
        &_character00002AB6,
        &_character00002AB7,
        &_character00002AB8,
        &_character00002AB9,
        &_character00002ABA,
        &_character00002ABB,
        &_character00002ABC,
        &_character00002ABD,
        &_character00002ABE,
        &_character00002ABF,
        &_character00002AC0,
        &_character00002AC1,
        &_character00002AC2,
        &_character00002AC3,
        &_character00002AC4,
        &_character00002AC5,
        &_character00002AC6,
        &_character00002AC7,
        &_character00002AC8,
        &_character00002AC9,
        &_character00002ACA,
        &_character00002ACB,
        &_character00002ACC,
        &_character00002ACD,
        &_character00002ACE,
        &_character00002ACF,
        &_character00002AD0,
        &_character00002AD1,
        &_character00002AD2,
        &_character00002AD3,
        &_character00002AD4,
        &_character00002AD5,
        &_character00002AD6,
        &_character00002AD7,
        &_character00002AD8,
        &_character00002AD9,
        &_character00002ADA,
        &_character00002ADB,
        &_character00002ADC,
        &_character00002ADD,
        &_character00002ADE,
        &_character00002ADF,
        &_character00002AE0,
        &_character00002AE1,
        &_character00002AE2,
        &_character00002AE3,
        &_character00002AE4,
        &_character00002AE5,
        &_character00002AE6,
        &_character00002AE7,
        &_character00002AE8,
        &_character00002AE9,
        &_character00002AEA,
        &_character00002AEB,
        &_character00002AEC,
        &_character00002AED,
        &_character00002AEE,
        &_character00002AEF,
        &_character00002AF0,
        &_character00002AF1,
        &_character00002AF2,
        &_character00002AF3,
        &_character00002AF4,
        &_character00002AF5,
        &_character00002AF6,
        &_character00002AF7,
        &_character00002AF8,
        &_character00002AF9,
        &_character00002AFA,
        &_character00002AFB,
        &_character00002AFC,
        &_character00002AFD,
        &_character00002AFE,
        &_character00002AFF,
        &_character00002B00,
        &_character00002B01,
        &_character00002B02,
        &_character00002B03,
        &_character00002B04,
        &_character00002B05,
        &_character00002B06,
        &_character00002B07,
        &_character00002B08,
        &_character00002B09,
        &_character00002B0A,
        &_character00002B0B,
        &_character00002B0C,
        &_character00002B0D,
        &_character00002B0E,
        &_character00002B0F,
        &_character00002B10,
        &_character00002B11,
        &_character00002B12,
        &_character00002B13,
        &_character00002B14,
        &_character00002B15,
        &_character00002B16,
        &_character00002B17,
        &_character00002B18,
        &_character00002B19,
        &_character00002B1A,
        0,
        0,
        0,
        0,
        0,
        &_character00002B20,
        &_character00002B21,
        &_character00002B22,
        &_character00002B23,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002C00,
        &_character00002C01,
        &_character00002C02,
        &_character00002C03,
        &_character00002C04,
        &_character00002C05,
        &_character00002C06,
        &_character00002C07,
        &_character00002C08,
        &_character00002C09,
        &_character00002C0A,
        &_character00002C0B,
        &_character00002C0C,
        &_character00002C0D,
        &_character00002C0E,
        &_character00002C0F,
        &_character00002C10,
        &_character00002C11,
        &_character00002C12,
        &_character00002C13,
        &_character00002C14,
        &_character00002C15,
        &_character00002C16,
        &_character00002C17,
        &_character00002C18,
        &_character00002C19,
        &_character00002C1A,
        &_character00002C1B,
        &_character00002C1C,
        &_character00002C1D,
        &_character00002C1E,
        &_character00002C1F,
        &_character00002C20,
        &_character00002C21,
        &_character00002C22,
        &_character00002C23,
        &_character00002C24,
        &_character00002C25,
        &_character00002C26,
        &_character00002C27,
        &_character00002C28,
        &_character00002C29,
        &_character00002C2A,
        &_character00002C2B,
        &_character00002C2C,
        &_character00002C2D,
        &_character00002C2E,
        0,
        &_character00002C30,
        &_character00002C31,
        &_character00002C32,
        &_character00002C33,
        &_character00002C34,
        &_character00002C35,
        &_character00002C36,
        &_character00002C37,
        &_character00002C38,
        &_character00002C39,
        &_character00002C3A,
        &_character00002C3B,
        &_character00002C3C,
        &_character00002C3D,
        &_character00002C3E,
        &_character00002C3F,
        &_character00002C40,
        &_character00002C41,
        &_character00002C42,
        &_character00002C43,
        &_character00002C44,
        &_character00002C45,
        &_character00002C46,
        &_character00002C47,
        &_character00002C48,
        &_character00002C49,
        &_character00002C4A,
        &_character00002C4B,
        &_character00002C4C,
        &_character00002C4D,
        &_character00002C4E,
        &_character00002C4F,
        &_character00002C50,
        &_character00002C51,
        &_character00002C52,
        &_character00002C53,
        &_character00002C54,
        &_character00002C55,
        &_character00002C56,
        &_character00002C57,
        &_character00002C58,
        &_character00002C59,
        &_character00002C5A,
        &_character00002C5B,
        &_character00002C5C,
        &_character00002C5D,
        &_character00002C5E,
        0,
        &_character00002C60,
        &_character00002C61,
        &_character00002C62,
        &_character00002C63,
        &_character00002C64,
        &_character00002C65,
        &_character00002C66,
        &_character00002C67,
        &_character00002C68,
        &_character00002C69,
        &_character00002C6A,
        &_character00002C6B,
        &_character00002C6C,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002C74,
        &_character00002C75,
        &_character00002C76,
        &_character00002C77,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002C80,
        &_character00002C81,
        &_character00002C82,
        &_character00002C83,
        &_character00002C84,
        &_character00002C85,
        &_character00002C86,
        &_character00002C87,
        &_character00002C88,
        &_character00002C89,
        &_character00002C8A,
        &_character00002C8B,
        &_character00002C8C,
        &_character00002C8D,
        &_character00002C8E,
        &_character00002C8F,
        &_character00002C90,
        &_character00002C91,
        &_character00002C92,
        &_character00002C93,
        &_character00002C94,
        &_character00002C95,
        &_character00002C96,
        &_character00002C97,
        &_character00002C98,
        &_character00002C99,
        &_character00002C9A,
        &_character00002C9B,
        &_character00002C9C,
        &_character00002C9D,
        &_character00002C9E,
        &_character00002C9F,
        &_character00002CA0,
        &_character00002CA1,
        &_character00002CA2,
        &_character00002CA3,
        &_character00002CA4,
        &_character00002CA5,
        &_character00002CA6,
        &_character00002CA7,
        &_character00002CA8,
        &_character00002CA9,
        &_character00002CAA,
        &_character00002CAB,
        &_character00002CAC,
        &_character00002CAD,
        &_character00002CAE,
        &_character00002CAF,
        &_character00002CB0,
        &_character00002CB1,
        &_character00002CB2,
        &_character00002CB3,
        &_character00002CB4,
        &_character00002CB5,
        &_character00002CB6,
        &_character00002CB7,
        &_character00002CB8,
        &_character00002CB9,
        &_character00002CBA,
        &_character00002CBB,
        &_character00002CBC,
        &_character00002CBD,
        &_character00002CBE,
        &_character00002CBF,
        &_character00002CC0,
        &_character00002CC1,
        &_character00002CC2,
        &_character00002CC3,
        &_character00002CC4,
        &_character00002CC5,
        &_character00002CC6,
        &_character00002CC7,
        &_character00002CC8,
        &_character00002CC9,
        &_character00002CCA,
        &_character00002CCB,
        &_character00002CCC,
        &_character00002CCD,
        &_character00002CCE,
        &_character00002CCF,
        &_character00002CD0,
        &_character00002CD1,
        &_character00002CD2,
        &_character00002CD3,
        &_character00002CD4,
        &_character00002CD5,
        &_character00002CD6,
        &_character00002CD7,
        &_character00002CD8,
        &_character00002CD9,
        &_character00002CDA,
        &_character00002CDB,
        &_character00002CDC,
        &_character00002CDD,
        &_character00002CDE,
        &_character00002CDF,
        &_character00002CE0,
        &_character00002CE1,
        &_character00002CE2,
        &_character00002CE3,
        &_character00002CE4,
        &_character00002CE5,
        &_character00002CE6,
        &_character00002CE7,
        &_character00002CE8,
        &_character00002CE9,
        &_character00002CEA,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002CF9,
        &_character00002CFA,
        &_character00002CFB,
        &_character00002CFC,
        &_character00002CFD,
        &_character00002CFE,
        &_character00002CFF,
        &_character00002D00,
        &_character00002D01,
        &_character00002D02,
        &_character00002D03,
        &_character00002D04,
        &_character00002D05,
        &_character00002D06,
        &_character00002D07,
        &_character00002D08,
        &_character00002D09,
        &_character00002D0A,
        &_character00002D0B,
        &_character00002D0C,
        &_character00002D0D,
        &_character00002D0E,
        &_character00002D0F,
        &_character00002D10,
        &_character00002D11,
        &_character00002D12,
        &_character00002D13,
        &_character00002D14,
        &_character00002D15,
        &_character00002D16,
        &_character00002D17,
        &_character00002D18,
        &_character00002D19,
        &_character00002D1A,
        &_character00002D1B,
        &_character00002D1C,
        &_character00002D1D,
        &_character00002D1E,
        &_character00002D1F,
        &_character00002D20,
        &_character00002D21,
        &_character00002D22,
        &_character00002D23,
        &_character00002D24,
        &_character00002D25,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002D30,
        &_character00002D31,
        &_character00002D32,
        &_character00002D33,
        &_character00002D34,
        &_character00002D35,
        &_character00002D36,
        &_character00002D37,
        &_character00002D38,
        &_character00002D39,
        &_character00002D3A,
        &_character00002D3B,
        &_character00002D3C,
        &_character00002D3D,
        &_character00002D3E,
        &_character00002D3F,
        &_character00002D40,
        &_character00002D41,
        &_character00002D42,
        &_character00002D43,
        &_character00002D44,
        &_character00002D45,
        &_character00002D46,
        &_character00002D47,
        &_character00002D48,
        &_character00002D49,
        &_character00002D4A,
        &_character00002D4B,
        &_character00002D4C,
        &_character00002D4D,
        &_character00002D4E,
        &_character00002D4F,
        &_character00002D50,
        &_character00002D51,
        &_character00002D52,
        &_character00002D53,
        &_character00002D54,
        &_character00002D55,
        &_character00002D56,
        &_character00002D57,
        &_character00002D58,
        &_character00002D59,
        &_character00002D5A,
        &_character00002D5B,
        &_character00002D5C,
        &_character00002D5D,
        &_character00002D5E,
        &_character00002D5F,
        &_character00002D60,
        &_character00002D61,
        &_character00002D62,
        &_character00002D63,
        &_character00002D64,
        &_character00002D65,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002D6F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002D80,
        &_character00002D81,
        &_character00002D82,
        &_character00002D83,
        &_character00002D84,
        &_character00002D85,
        &_character00002D86,
        &_character00002D87,
        &_character00002D88,
        &_character00002D89,
        &_character00002D8A,
        &_character00002D8B,
        &_character00002D8C,
        &_character00002D8D,
        &_character00002D8E,
        &_character00002D8F,
        &_character00002D90,
        &_character00002D91,
        &_character00002D92,
        &_character00002D93,
        &_character00002D94,
        &_character00002D95,
        &_character00002D96,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002DA0,
        &_character00002DA1,
        &_character00002DA2,
        &_character00002DA3,
        &_character00002DA4,
        &_character00002DA5,
        &_character00002DA6,
        0,
        &_character00002DA8,
        &_character00002DA9,
        &_character00002DAA,
        &_character00002DAB,
        &_character00002DAC,
        &_character00002DAD,
        &_character00002DAE,
        0,
        &_character00002DB0,
        &_character00002DB1,
        &_character00002DB2,
        &_character00002DB3,
        &_character00002DB4,
        &_character00002DB5,
        &_character00002DB6,
        0,
        &_character00002DB8,
        &_character00002DB9,
        &_character00002DBA,
        &_character00002DBB,
        &_character00002DBC,
        &_character00002DBD,
        &_character00002DBE,
        0,
        &_character00002DC0,
        &_character00002DC1,
        &_character00002DC2,
        &_character00002DC3,
        &_character00002DC4,
        &_character00002DC5,
        &_character00002DC6,
        0,
        &_character00002DC8,
        &_character00002DC9,
        &_character00002DCA,
        &_character00002DCB,
        &_character00002DCC,
        &_character00002DCD,
        &_character00002DCE,
        0,
        &_character00002DD0,
        &_character00002DD1,
        &_character00002DD2,
        &_character00002DD3,
        &_character00002DD4,
        &_character00002DD5,
        &_character00002DD6,
        0,
        &_character00002DD8,
        &_character00002DD9,
        &_character00002DDA,
        &_character00002DDB,
        &_character00002DDC,
        &_character00002DDD,
        &_character00002DDE,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002E00,
        &_character00002E01,
        &_character00002E02,
        &_character00002E03,
        &_character00002E04,
        &_character00002E05,
        &_character00002E06,
        &_character00002E07,
        &_character00002E08,
        &_character00002E09,
        &_character00002E0A,
        &_character00002E0B,
        &_character00002E0C,
        &_character00002E0D,
        &_character00002E0E,
        &_character00002E0F,
        &_character00002E10,
        &_character00002E11,
        &_character00002E12,
        &_character00002E13,
        &_character00002E14,
        &_character00002E15,
        &_character00002E16,
        &_character00002E17,
        0,
        0,
        0,
        0,
        &_character00002E1C,
        &_character00002E1D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002E80,
        &_character00002E81,
        &_character00002E82,
        &_character00002E83,
        &_character00002E84,
        &_character00002E85,
        &_character00002E86,
        &_character00002E87,
        &_character00002E88,
        &_character00002E89,
        &_character00002E8A,
        &_character00002E8B,
        &_character00002E8C,
        &_character00002E8D,
        &_character00002E8E,
        &_character00002E8F,
        &_character00002E90,
        &_character00002E91,
        &_character00002E92,
        &_character00002E93,
        &_character00002E94,
        &_character00002E95,
        &_character00002E96,
        &_character00002E97,
        &_character00002E98,
        &_character00002E99,
        0,
        &_character00002E9B,
        &_character00002E9C,
        &_character00002E9D,
        &_character00002E9E,
        &_character00002E9F,
        &_character00002EA0,
        &_character00002EA1,
        &_character00002EA2,
        &_character00002EA3,
        &_character00002EA4,
        &_character00002EA5,
        &_character00002EA6,
        &_character00002EA7,
        &_character00002EA8,
        &_character00002EA9,
        &_character00002EAA,
        &_character00002EAB,
        &_character00002EAC,
        &_character00002EAD,
        &_character00002EAE,
        &_character00002EAF,
        &_character00002EB0,
        &_character00002EB1,
        &_character00002EB2,
        &_character00002EB3,
        &_character00002EB4,
        &_character00002EB5,
        &_character00002EB6,
        &_character00002EB7,
        &_character00002EB8,
        &_character00002EB9,
        &_character00002EBA,
        &_character00002EBB,
        &_character00002EBC,
        &_character00002EBD,
        &_character00002EBE,
        &_character00002EBF,
        &_character00002EC0,
        &_character00002EC1,
        &_character00002EC2,
        &_character00002EC3,
        &_character00002EC4,
        &_character00002EC5,
        &_character00002EC6,
        &_character00002EC7,
        &_character00002EC8,
        &_character00002EC9,
        &_character00002ECA,
        &_character00002ECB,
        &_character00002ECC,
        &_character00002ECD,
        &_character00002ECE,
        &_character00002ECF,
        &_character00002ED0,
        &_character00002ED1,
        &_character00002ED2,
        &_character00002ED3,
        &_character00002ED4,
        &_character00002ED5,
        &_character00002ED6,
        &_character00002ED7,
        &_character00002ED8,
        &_character00002ED9,
        &_character00002EDA,
        &_character00002EDB,
        &_character00002EDC,
        &_character00002EDD,
        &_character00002EDE,
        &_character00002EDF,
        &_character00002EE0,
        &_character00002EE1,
        &_character00002EE2,
        &_character00002EE3,
        &_character00002EE4,
        &_character00002EE5,
        &_character00002EE6,
        &_character00002EE7,
        &_character00002EE8,
        &_character00002EE9,
        &_character00002EEA,
        &_character00002EEB,
        &_character00002EEC,
        &_character00002EED,
        &_character00002EEE,
        &_character00002EEF,
        &_character00002EF0,
        &_character00002EF1,
        &_character00002EF2,
        &_character00002EF3,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002F00,
        &_character00002F01,
        &_character00002F02,
        &_character00002F03,
        &_character00002F04,
        &_character00002F05,
        &_character00002F06,
        &_character00002F07,
        &_character00002F08,
        &_character00002F09,
        &_character00002F0A,
        &_character00002F0B,
        &_character00002F0C,
        &_character00002F0D,
        &_character00002F0E,
        &_character00002F0F,
        &_character00002F10,
        &_character00002F11,
        &_character00002F12,
        &_character00002F13,
        &_character00002F14,
        &_character00002F15,
        &_character00002F16,
        &_character00002F17,
        &_character00002F18,
        &_character00002F19,
        &_character00002F1A,
        &_character00002F1B,
        &_character00002F1C,
        &_character00002F1D,
        &_character00002F1E,
        &_character00002F1F,
        &_character00002F20,
        &_character00002F21,
        &_character00002F22,
        &_character00002F23,
        &_character00002F24,
        &_character00002F25,
        &_character00002F26,
        &_character00002F27,
        &_character00002F28,
        &_character00002F29,
        &_character00002F2A,
        &_character00002F2B,
        &_character00002F2C,
        &_character00002F2D,
        &_character00002F2E,
        &_character00002F2F,
        &_character00002F30,
        &_character00002F31,
        &_character00002F32,
        &_character00002F33,
        &_character00002F34,
        &_character00002F35,
        &_character00002F36,
        &_character00002F37,
        &_character00002F38,
        &_character00002F39,
        &_character00002F3A,
        &_character00002F3B,
        &_character00002F3C,
        &_character00002F3D,
        &_character00002F3E,
        &_character00002F3F,
        &_character00002F40,
        &_character00002F41,
        &_character00002F42,
        &_character00002F43,
        &_character00002F44,
        &_character00002F45,
        &_character00002F46,
        &_character00002F47,
        &_character00002F48,
        &_character00002F49,
        &_character00002F4A,
        &_character00002F4B,
        &_character00002F4C,
        &_character00002F4D,
        &_character00002F4E,
        &_character00002F4F,
        &_character00002F50,
        &_character00002F51,
        &_character00002F52,
        &_character00002F53,
        &_character00002F54,
        &_character00002F55,
        &_character00002F56,
        &_character00002F57,
        &_character00002F58,
        &_character00002F59,
        &_character00002F5A,
        &_character00002F5B,
        &_character00002F5C,
        &_character00002F5D,
        &_character00002F5E,
        &_character00002F5F,
        &_character00002F60,
        &_character00002F61,
        &_character00002F62,
        &_character00002F63,
        &_character00002F64,
        &_character00002F65,
        &_character00002F66,
        &_character00002F67,
        &_character00002F68,
        &_character00002F69,
        &_character00002F6A,
        &_character00002F6B,
        &_character00002F6C,
        &_character00002F6D,
        &_character00002F6E,
        &_character00002F6F,
        &_character00002F70,
        &_character00002F71,
        &_character00002F72,
        &_character00002F73,
        &_character00002F74,
        &_character00002F75,
        &_character00002F76,
        &_character00002F77,
        &_character00002F78,
        &_character00002F79,
        &_character00002F7A,
        &_character00002F7B,
        &_character00002F7C,
        &_character00002F7D,
        &_character00002F7E,
        &_character00002F7F,
        &_character00002F80,
        &_character00002F81,
        &_character00002F82,
        &_character00002F83,
        &_character00002F84,
        &_character00002F85,
        &_character00002F86,
        &_character00002F87,
        &_character00002F88,
        &_character00002F89,
        &_character00002F8A,
        &_character00002F8B,
        &_character00002F8C,
        &_character00002F8D,
        &_character00002F8E,
        &_character00002F8F,
        &_character00002F90,
        &_character00002F91,
        &_character00002F92,
        &_character00002F93,
        &_character00002F94,
        &_character00002F95,
        &_character00002F96,
        &_character00002F97,
        &_character00002F98,
        &_character00002F99,
        &_character00002F9A,
        &_character00002F9B,
        &_character00002F9C,
        &_character00002F9D,
        &_character00002F9E,
        &_character00002F9F,
        &_character00002FA0,
        &_character00002FA1,
        &_character00002FA2,
        &_character00002FA3,
        &_character00002FA4,
        &_character00002FA5,
        &_character00002FA6,
        &_character00002FA7,
        &_character00002FA8,
        &_character00002FA9,
        &_character00002FAA,
        &_character00002FAB,
        &_character00002FAC,
        &_character00002FAD,
        &_character00002FAE,
        &_character00002FAF,
        &_character00002FB0,
        &_character00002FB1,
        &_character00002FB2,
        &_character00002FB3,
        &_character00002FB4,
        &_character00002FB5,
        &_character00002FB6,
        &_character00002FB7,
        &_character00002FB8,
        &_character00002FB9,
        &_character00002FBA,
        &_character00002FBB,
        &_character00002FBC,
        &_character00002FBD,
        &_character00002FBE,
        &_character00002FBF,
        &_character00002FC0,
        &_character00002FC1,
        &_character00002FC2,
        &_character00002FC3,
        &_character00002FC4,
        &_character00002FC5,
        &_character00002FC6,
        &_character00002FC7,
        &_character00002FC8,
        &_character00002FC9,
        &_character00002FCA,
        &_character00002FCB,
        &_character00002FCC,
        &_character00002FCD,
        &_character00002FCE,
        &_character00002FCF,
        &_character00002FD0,
        &_character00002FD1,
        &_character00002FD2,
        &_character00002FD3,
        &_character00002FD4,
        &_character00002FD5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00002FF0,
        &_character00002FF1,
        &_character00002FF2,
        &_character00002FF3,
        &_character00002FF4,
        &_character00002FF5,
        &_character00002FF6,
        &_character00002FF7,
        &_character00002FF8,
        &_character00002FF9,
        &_character00002FFA,
        &_character00002FFB,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300003000[2048] =
    {
        &_character00003000,
        &_character00003001,
        &_character00003002,
        &_character00003003,
        &_character00003004,
        &_character00003005,
        &_character00003006,
        &_character00003007,
        &_character00003008,
        &_character00003009,
        &_character0000300A,
        &_character0000300B,
        &_character0000300C,
        &_character0000300D,
        &_character0000300E,
        &_character0000300F,
        &_character00003010,
        &_character00003011,
        &_character00003012,
        &_character00003013,
        &_character00003014,
        &_character00003015,
        &_character00003016,
        &_character00003017,
        &_character00003018,
        &_character00003019,
        &_character0000301A,
        &_character0000301B,
        &_character0000301C,
        &_character0000301D,
        &_character0000301E,
        &_character0000301F,
        &_character00003020,
        &_character00003021,
        &_character00003022,
        &_character00003023,
        &_character00003024,
        &_character00003025,
        &_character00003026,
        &_character00003027,
        &_character00003028,
        &_character00003029,
        &_character0000302A,
        &_character0000302B,
        &_character0000302C,
        &_character0000302D,
        &_character0000302E,
        &_character0000302F,
        &_character00003030,
        &_character00003031,
        &_character00003032,
        &_character00003033,
        &_character00003034,
        &_character00003035,
        &_character00003036,
        &_character00003037,
        &_character00003038,
        &_character00003039,
        &_character0000303A,
        &_character0000303B,
        &_character0000303C,
        &_character0000303D,
        &_character0000303E,
        &_character0000303F,
        0,
        &_character00003041,
        &_character00003042,
        &_character00003043,
        &_character00003044,
        &_character00003045,
        &_character00003046,
        &_character00003047,
        &_character00003048,
        &_character00003049,
        &_character0000304A,
        &_character0000304B,
        &_character0000304C,
        &_character0000304D,
        &_character0000304E,
        &_character0000304F,
        &_character00003050,
        &_character00003051,
        &_character00003052,
        &_character00003053,
        &_character00003054,
        &_character00003055,
        &_character00003056,
        &_character00003057,
        &_character00003058,
        &_character00003059,
        &_character0000305A,
        &_character0000305B,
        &_character0000305C,
        &_character0000305D,
        &_character0000305E,
        &_character0000305F,
        &_character00003060,
        &_character00003061,
        &_character00003062,
        &_character00003063,
        &_character00003064,
        &_character00003065,
        &_character00003066,
        &_character00003067,
        &_character00003068,
        &_character00003069,
        &_character0000306A,
        &_character0000306B,
        &_character0000306C,
        &_character0000306D,
        &_character0000306E,
        &_character0000306F,
        &_character00003070,
        &_character00003071,
        &_character00003072,
        &_character00003073,
        &_character00003074,
        &_character00003075,
        &_character00003076,
        &_character00003077,
        &_character00003078,
        &_character00003079,
        &_character0000307A,
        &_character0000307B,
        &_character0000307C,
        &_character0000307D,
        &_character0000307E,
        &_character0000307F,
        &_character00003080,
        &_character00003081,
        &_character00003082,
        &_character00003083,
        &_character00003084,
        &_character00003085,
        &_character00003086,
        &_character00003087,
        &_character00003088,
        &_character00003089,
        &_character0000308A,
        &_character0000308B,
        &_character0000308C,
        &_character0000308D,
        &_character0000308E,
        &_character0000308F,
        &_character00003090,
        &_character00003091,
        &_character00003092,
        &_character00003093,
        &_character00003094,
        &_character00003095,
        &_character00003096,
        0,
        0,
        &_character00003099,
        &_character0000309A,
        &_character0000309B,
        &_character0000309C,
        &_character0000309D,
        &_character0000309E,
        &_character0000309F,
        &_character000030A0,
        &_character000030A1,
        &_character000030A2,
        &_character000030A3,
        &_character000030A4,
        &_character000030A5,
        &_character000030A6,
        &_character000030A7,
        &_character000030A8,
        &_character000030A9,
        &_character000030AA,
        &_character000030AB,
        &_character000030AC,
        &_character000030AD,
        &_character000030AE,
        &_character000030AF,
        &_character000030B0,
        &_character000030B1,
        &_character000030B2,
        &_character000030B3,
        &_character000030B4,
        &_character000030B5,
        &_character000030B6,
        &_character000030B7,
        &_character000030B8,
        &_character000030B9,
        &_character000030BA,
        &_character000030BB,
        &_character000030BC,
        &_character000030BD,
        &_character000030BE,
        &_character000030BF,
        &_character000030C0,
        &_character000030C1,
        &_character000030C2,
        &_character000030C3,
        &_character000030C4,
        &_character000030C5,
        &_character000030C6,
        &_character000030C7,
        &_character000030C8,
        &_character000030C9,
        &_character000030CA,
        &_character000030CB,
        &_character000030CC,
        &_character000030CD,
        &_character000030CE,
        &_character000030CF,
        &_character000030D0,
        &_character000030D1,
        &_character000030D2,
        &_character000030D3,
        &_character000030D4,
        &_character000030D5,
        &_character000030D6,
        &_character000030D7,
        &_character000030D8,
        &_character000030D9,
        &_character000030DA,
        &_character000030DB,
        &_character000030DC,
        &_character000030DD,
        &_character000030DE,
        &_character000030DF,
        &_character000030E0,
        &_character000030E1,
        &_character000030E2,
        &_character000030E3,
        &_character000030E4,
        &_character000030E5,
        &_character000030E6,
        &_character000030E7,
        &_character000030E8,
        &_character000030E9,
        &_character000030EA,
        &_character000030EB,
        &_character000030EC,
        &_character000030ED,
        &_character000030EE,
        &_character000030EF,
        &_character000030F0,
        &_character000030F1,
        &_character000030F2,
        &_character000030F3,
        &_character000030F4,
        &_character000030F5,
        &_character000030F6,
        &_character000030F7,
        &_character000030F8,
        &_character000030F9,
        &_character000030FA,
        &_character000030FB,
        &_character000030FC,
        &_character000030FD,
        &_character000030FE,
        &_character000030FF,
        0,
        0,
        0,
        0,
        0,
        &_character00003105,
        &_character00003106,
        &_character00003107,
        &_character00003108,
        &_character00003109,
        &_character0000310A,
        &_character0000310B,
        &_character0000310C,
        &_character0000310D,
        &_character0000310E,
        &_character0000310F,
        &_character00003110,
        &_character00003111,
        &_character00003112,
        &_character00003113,
        &_character00003114,
        &_character00003115,
        &_character00003116,
        &_character00003117,
        &_character00003118,
        &_character00003119,
        &_character0000311A,
        &_character0000311B,
        &_character0000311C,
        &_character0000311D,
        &_character0000311E,
        &_character0000311F,
        &_character00003120,
        &_character00003121,
        &_character00003122,
        &_character00003123,
        &_character00003124,
        &_character00003125,
        &_character00003126,
        &_character00003127,
        &_character00003128,
        &_character00003129,
        &_character0000312A,
        &_character0000312B,
        &_character0000312C,
        0,
        0,
        0,
        0,
        &_character00003131,
        &_character00003132,
        &_character00003133,
        &_character00003134,
        &_character00003135,
        &_character00003136,
        &_character00003137,
        &_character00003138,
        &_character00003139,
        &_character0000313A,
        &_character0000313B,
        &_character0000313C,
        &_character0000313D,
        &_character0000313E,
        &_character0000313F,
        &_character00003140,
        &_character00003141,
        &_character00003142,
        &_character00003143,
        &_character00003144,
        &_character00003145,
        &_character00003146,
        &_character00003147,
        &_character00003148,
        &_character00003149,
        &_character0000314A,
        &_character0000314B,
        &_character0000314C,
        &_character0000314D,
        &_character0000314E,
        &_character0000314F,
        &_character00003150,
        &_character00003151,
        &_character00003152,
        &_character00003153,
        &_character00003154,
        &_character00003155,
        &_character00003156,
        &_character00003157,
        &_character00003158,
        &_character00003159,
        &_character0000315A,
        &_character0000315B,
        &_character0000315C,
        &_character0000315D,
        &_character0000315E,
        &_character0000315F,
        &_character00003160,
        &_character00003161,
        &_character00003162,
        &_character00003163,
        &_character00003164,
        &_character00003165,
        &_character00003166,
        &_character00003167,
        &_character00003168,
        &_character00003169,
        &_character0000316A,
        &_character0000316B,
        &_character0000316C,
        &_character0000316D,
        &_character0000316E,
        &_character0000316F,
        &_character00003170,
        &_character00003171,
        &_character00003172,
        &_character00003173,
        &_character00003174,
        &_character00003175,
        &_character00003176,
        &_character00003177,
        &_character00003178,
        &_character00003179,
        &_character0000317A,
        &_character0000317B,
        &_character0000317C,
        &_character0000317D,
        &_character0000317E,
        &_character0000317F,
        &_character00003180,
        &_character00003181,
        &_character00003182,
        &_character00003183,
        &_character00003184,
        &_character00003185,
        &_character00003186,
        &_character00003187,
        &_character00003188,
        &_character00003189,
        &_character0000318A,
        &_character0000318B,
        &_character0000318C,
        &_character0000318D,
        &_character0000318E,
        0,
        &_character00003190,
        &_character00003191,
        &_character00003192,
        &_character00003193,
        &_character00003194,
        &_character00003195,
        &_character00003196,
        &_character00003197,
        &_character00003198,
        &_character00003199,
        &_character0000319A,
        &_character0000319B,
        &_character0000319C,
        &_character0000319D,
        &_character0000319E,
        &_character0000319F,
        &_character000031A0,
        &_character000031A1,
        &_character000031A2,
        &_character000031A3,
        &_character000031A4,
        &_character000031A5,
        &_character000031A6,
        &_character000031A7,
        &_character000031A8,
        &_character000031A9,
        &_character000031AA,
        &_character000031AB,
        &_character000031AC,
        &_character000031AD,
        &_character000031AE,
        &_character000031AF,
        &_character000031B0,
        &_character000031B1,
        &_character000031B2,
        &_character000031B3,
        &_character000031B4,
        &_character000031B5,
        &_character000031B6,
        &_character000031B7,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000031C0,
        &_character000031C1,
        &_character000031C2,
        &_character000031C3,
        &_character000031C4,
        &_character000031C5,
        &_character000031C6,
        &_character000031C7,
        &_character000031C8,
        &_character000031C9,
        &_character000031CA,
        &_character000031CB,
        &_character000031CC,
        &_character000031CD,
        &_character000031CE,
        &_character000031CF,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000031F0,
        &_character000031F1,
        &_character000031F2,
        &_character000031F3,
        &_character000031F4,
        &_character000031F5,
        &_character000031F6,
        &_character000031F7,
        &_character000031F8,
        &_character000031F9,
        &_character000031FA,
        &_character000031FB,
        &_character000031FC,
        &_character000031FD,
        &_character000031FE,
        &_character000031FF,
        &_character00003200,
        &_character00003201,
        &_character00003202,
        &_character00003203,
        &_character00003204,
        &_character00003205,
        &_character00003206,
        &_character00003207,
        &_character00003208,
        &_character00003209,
        &_character0000320A,
        &_character0000320B,
        &_character0000320C,
        &_character0000320D,
        &_character0000320E,
        &_character0000320F,
        &_character00003210,
        &_character00003211,
        &_character00003212,
        &_character00003213,
        &_character00003214,
        &_character00003215,
        &_character00003216,
        &_character00003217,
        &_character00003218,
        &_character00003219,
        &_character0000321A,
        &_character0000321B,
        &_character0000321C,
        &_character0000321D,
        &_character0000321E,
        0,
        &_character00003220,
        &_character00003221,
        &_character00003222,
        &_character00003223,
        &_character00003224,
        &_character00003225,
        &_character00003226,
        &_character00003227,
        &_character00003228,
        &_character00003229,
        &_character0000322A,
        &_character0000322B,
        &_character0000322C,
        &_character0000322D,
        &_character0000322E,
        &_character0000322F,
        &_character00003230,
        &_character00003231,
        &_character00003232,
        &_character00003233,
        &_character00003234,
        &_character00003235,
        &_character00003236,
        &_character00003237,
        &_character00003238,
        &_character00003239,
        &_character0000323A,
        &_character0000323B,
        &_character0000323C,
        &_character0000323D,
        &_character0000323E,
        &_character0000323F,
        &_character00003240,
        &_character00003241,
        &_character00003242,
        &_character00003243,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00003250,
        &_character00003251,
        &_character00003252,
        &_character00003253,
        &_character00003254,
        &_character00003255,
        &_character00003256,
        &_character00003257,
        &_character00003258,
        &_character00003259,
        &_character0000325A,
        &_character0000325B,
        &_character0000325C,
        &_character0000325D,
        &_character0000325E,
        &_character0000325F,
        &_character00003260,
        &_character00003261,
        &_character00003262,
        &_character00003263,
        &_character00003264,
        &_character00003265,
        &_character00003266,
        &_character00003267,
        &_character00003268,
        &_character00003269,
        &_character0000326A,
        &_character0000326B,
        &_character0000326C,
        &_character0000326D,
        &_character0000326E,
        &_character0000326F,
        &_character00003270,
        &_character00003271,
        &_character00003272,
        &_character00003273,
        &_character00003274,
        &_character00003275,
        &_character00003276,
        &_character00003277,
        &_character00003278,
        &_character00003279,
        &_character0000327A,
        &_character0000327B,
        &_character0000327C,
        &_character0000327D,
        &_character0000327E,
        &_character0000327F,
        &_character00003280,
        &_character00003281,
        &_character00003282,
        &_character00003283,
        &_character00003284,
        &_character00003285,
        &_character00003286,
        &_character00003287,
        &_character00003288,
        &_character00003289,
        &_character0000328A,
        &_character0000328B,
        &_character0000328C,
        &_character0000328D,
        &_character0000328E,
        &_character0000328F,
        &_character00003290,
        &_character00003291,
        &_character00003292,
        &_character00003293,
        &_character00003294,
        &_character00003295,
        &_character00003296,
        &_character00003297,
        &_character00003298,
        &_character00003299,
        &_character0000329A,
        &_character0000329B,
        &_character0000329C,
        &_character0000329D,
        &_character0000329E,
        &_character0000329F,
        &_character000032A0,
        &_character000032A1,
        &_character000032A2,
        &_character000032A3,
        &_character000032A4,
        &_character000032A5,
        &_character000032A6,
        &_character000032A7,
        &_character000032A8,
        &_character000032A9,
        &_character000032AA,
        &_character000032AB,
        &_character000032AC,
        &_character000032AD,
        &_character000032AE,
        &_character000032AF,
        &_character000032B0,
        &_character000032B1,
        &_character000032B2,
        &_character000032B3,
        &_character000032B4,
        &_character000032B5,
        &_character000032B6,
        &_character000032B7,
        &_character000032B8,
        &_character000032B9,
        &_character000032BA,
        &_character000032BB,
        &_character000032BC,
        &_character000032BD,
        &_character000032BE,
        &_character000032BF,
        &_character000032C0,
        &_character000032C1,
        &_character000032C2,
        &_character000032C3,
        &_character000032C4,
        &_character000032C5,
        &_character000032C6,
        &_character000032C7,
        &_character000032C8,
        &_character000032C9,
        &_character000032CA,
        &_character000032CB,
        &_character000032CC,
        &_character000032CD,
        &_character000032CE,
        &_character000032CF,
        &_character000032D0,
        &_character000032D1,
        &_character000032D2,
        &_character000032D3,
        &_character000032D4,
        &_character000032D5,
        &_character000032D6,
        &_character000032D7,
        &_character000032D8,
        &_character000032D9,
        &_character000032DA,
        &_character000032DB,
        &_character000032DC,
        &_character000032DD,
        &_character000032DE,
        &_character000032DF,
        &_character000032E0,
        &_character000032E1,
        &_character000032E2,
        &_character000032E3,
        &_character000032E4,
        &_character000032E5,
        &_character000032E6,
        &_character000032E7,
        &_character000032E8,
        &_character000032E9,
        &_character000032EA,
        &_character000032EB,
        &_character000032EC,
        &_character000032ED,
        &_character000032EE,
        &_character000032EF,
        &_character000032F0,
        &_character000032F1,
        &_character000032F2,
        &_character000032F3,
        &_character000032F4,
        &_character000032F5,
        &_character000032F6,
        &_character000032F7,
        &_character000032F8,
        &_character000032F9,
        &_character000032FA,
        &_character000032FB,
        &_character000032FC,
        &_character000032FD,
        &_character000032FE,
        0,
        &_character00003300,
        &_character00003301,
        &_character00003302,
        &_character00003303,
        &_character00003304,
        &_character00003305,
        &_character00003306,
        &_character00003307,
        &_character00003308,
        &_character00003309,
        &_character0000330A,
        &_character0000330B,
        &_character0000330C,
        &_character0000330D,
        &_character0000330E,
        &_character0000330F,
        &_character00003310,
        &_character00003311,
        &_character00003312,
        &_character00003313,
        &_character00003314,
        &_character00003315,
        &_character00003316,
        &_character00003317,
        &_character00003318,
        &_character00003319,
        &_character0000331A,
        &_character0000331B,
        &_character0000331C,
        &_character0000331D,
        &_character0000331E,
        &_character0000331F,
        &_character00003320,
        &_character00003321,
        &_character00003322,
        &_character00003323,
        &_character00003324,
        &_character00003325,
        &_character00003326,
        &_character00003327,
        &_character00003328,
        &_character00003329,
        &_character0000332A,
        &_character0000332B,
        &_character0000332C,
        &_character0000332D,
        &_character0000332E,
        &_character0000332F,
        &_character00003330,
        &_character00003331,
        &_character00003332,
        &_character00003333,
        &_character00003334,
        &_character00003335,
        &_character00003336,
        &_character00003337,
        &_character00003338,
        &_character00003339,
        &_character0000333A,
        &_character0000333B,
        &_character0000333C,
        &_character0000333D,
        &_character0000333E,
        &_character0000333F,
        &_character00003340,
        &_character00003341,
        &_character00003342,
        &_character00003343,
        &_character00003344,
        &_character00003345,
        &_character00003346,
        &_character00003347,
        &_character00003348,
        &_character00003349,
        &_character0000334A,
        &_character0000334B,
        &_character0000334C,
        &_character0000334D,
        &_character0000334E,
        &_character0000334F,
        &_character00003350,
        &_character00003351,
        &_character00003352,
        &_character00003353,
        &_character00003354,
        &_character00003355,
        &_character00003356,
        &_character00003357,
        &_character00003358,
        &_character00003359,
        &_character0000335A,
        &_character0000335B,
        &_character0000335C,
        &_character0000335D,
        &_character0000335E,
        &_character0000335F,
        &_character00003360,
        &_character00003361,
        &_character00003362,
        &_character00003363,
        &_character00003364,
        &_character00003365,
        &_character00003366,
        &_character00003367,
        &_character00003368,
        &_character00003369,
        &_character0000336A,
        &_character0000336B,
        &_character0000336C,
        &_character0000336D,
        &_character0000336E,
        &_character0000336F,
        &_character00003370,
        &_character00003371,
        &_character00003372,
        &_character00003373,
        &_character00003374,
        &_character00003375,
        &_character00003376,
        &_character00003377,
        &_character00003378,
        &_character00003379,
        &_character0000337A,
        &_character0000337B,
        &_character0000337C,
        &_character0000337D,
        &_character0000337E,
        &_character0000337F,
        &_character00003380,
        &_character00003381,
        &_character00003382,
        &_character00003383,
        &_character00003384,
        &_character00003385,
        &_character00003386,
        &_character00003387,
        &_character00003388,
        &_character00003389,
        &_character0000338A,
        &_character0000338B,
        &_character0000338C,
        &_character0000338D,
        &_character0000338E,
        &_character0000338F,
        &_character00003390,
        &_character00003391,
        &_character00003392,
        &_character00003393,
        &_character00003394,
        &_character00003395,
        &_character00003396,
        &_character00003397,
        &_character00003398,
        &_character00003399,
        &_character0000339A,
        &_character0000339B,
        &_character0000339C,
        &_character0000339D,
        &_character0000339E,
        &_character0000339F,
        &_character000033A0,
        &_character000033A1,
        &_character000033A2,
        &_character000033A3,
        &_character000033A4,
        &_character000033A5,
        &_character000033A6,
        &_character000033A7,
        &_character000033A8,
        &_character000033A9,
        &_character000033AA,
        &_character000033AB,
        &_character000033AC,
        &_character000033AD,
        &_character000033AE,
        &_character000033AF,
        &_character000033B0,
        &_character000033B1,
        &_character000033B2,
        &_character000033B3,
        &_character000033B4,
        &_character000033B5,
        &_character000033B6,
        &_character000033B7,
        &_character000033B8,
        &_character000033B9,
        &_character000033BA,
        &_character000033BB,
        &_character000033BC,
        &_character000033BD,
        &_character000033BE,
        &_character000033BF,
        &_character000033C0,
        &_character000033C1,
        &_character000033C2,
        &_character000033C3,
        &_character000033C4,
        &_character000033C5,
        &_character000033C6,
        &_character000033C7,
        &_character000033C8,
        &_character000033C9,
        &_character000033CA,
        &_character000033CB,
        &_character000033CC,
        &_character000033CD,
        &_character000033CE,
        &_character000033CF,
        &_character000033D0,
        &_character000033D1,
        &_character000033D2,
        &_character000033D3,
        &_character000033D4,
        &_character000033D5,
        &_character000033D6,
        &_character000033D7,
        &_character000033D8,
        &_character000033D9,
        &_character000033DA,
        &_character000033DB,
        &_character000033DC,
        &_character000033DD,
        &_character000033DE,
        &_character000033DF,
        &_character000033E0,
        &_character000033E1,
        &_character000033E2,
        &_character000033E3,
        &_character000033E4,
        &_character000033E5,
        &_character000033E6,
        &_character000033E7,
        &_character000033E8,
        &_character000033E9,
        &_character000033EA,
        &_character000033EB,
        &_character000033EC,
        &_character000033ED,
        &_character000033EE,
        &_character000033EF,
        &_character000033F0,
        &_character000033F1,
        &_character000033F2,
        &_character000033F3,
        &_character000033F4,
        &_character000033F5,
        &_character000033F6,
        &_character000033F7,
        &_character000033F8,
        &_character000033F9,
        &_character000033FA,
        &_character000033FB,
        &_character000033FC,
        &_character000033FD,
        &_character000033FE,
        &_character000033FF,
        &_character00003400,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300004800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00004DB5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00004DC0,
        &_character00004DC1,
        &_character00004DC2,
        &_character00004DC3,
        &_character00004DC4,
        &_character00004DC5,
        &_character00004DC6,
        &_character00004DC7,
        &_character00004DC8,
        &_character00004DC9,
        &_character00004DCA,
        &_character00004DCB,
        &_character00004DCC,
        &_character00004DCD,
        &_character00004DCE,
        &_character00004DCF,
        &_character00004DD0,
        &_character00004DD1,
        &_character00004DD2,
        &_character00004DD3,
        &_character00004DD4,
        &_character00004DD5,
        &_character00004DD6,
        &_character00004DD7,
        &_character00004DD8,
        &_character00004DD9,
        &_character00004DDA,
        &_character00004DDB,
        &_character00004DDC,
        &_character00004DDD,
        &_character00004DDE,
        &_character00004DDF,
        &_character00004DE0,
        &_character00004DE1,
        &_character00004DE2,
        &_character00004DE3,
        &_character00004DE4,
        &_character00004DE5,
        &_character00004DE6,
        &_character00004DE7,
        &_character00004DE8,
        &_character00004DE9,
        &_character00004DEA,
        &_character00004DEB,
        &_character00004DEC,
        &_character00004DED,
        &_character00004DEE,
        &_character00004DEF,
        &_character00004DF0,
        &_character00004DF1,
        &_character00004DF2,
        &_character00004DF3,
        &_character00004DF4,
        &_character00004DF5,
        &_character00004DF6,
        &_character00004DF7,
        &_character00004DF8,
        &_character00004DF9,
        &_character00004DFA,
        &_character00004DFB,
        &_character00004DFC,
        &_character00004DFD,
        &_character00004DFE,
        &_character00004DFF,
        &_character00004E00,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300009800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00009FBB,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30000A000[2048] =
    {
        &_character0000A000,
        &_character0000A001,
        &_character0000A002,
        &_character0000A003,
        &_character0000A004,
        &_character0000A005,
        &_character0000A006,
        &_character0000A007,
        &_character0000A008,
        &_character0000A009,
        &_character0000A00A,
        &_character0000A00B,
        &_character0000A00C,
        &_character0000A00D,
        &_character0000A00E,
        &_character0000A00F,
        &_character0000A010,
        &_character0000A011,
        &_character0000A012,
        &_character0000A013,
        &_character0000A014,
        &_character0000A015,
        &_character0000A016,
        &_character0000A017,
        &_character0000A018,
        &_character0000A019,
        &_character0000A01A,
        &_character0000A01B,
        &_character0000A01C,
        &_character0000A01D,
        &_character0000A01E,
        &_character0000A01F,
        &_character0000A020,
        &_character0000A021,
        &_character0000A022,
        &_character0000A023,
        &_character0000A024,
        &_character0000A025,
        &_character0000A026,
        &_character0000A027,
        &_character0000A028,
        &_character0000A029,
        &_character0000A02A,
        &_character0000A02B,
        &_character0000A02C,
        &_character0000A02D,
        &_character0000A02E,
        &_character0000A02F,
        &_character0000A030,
        &_character0000A031,
        &_character0000A032,
        &_character0000A033,
        &_character0000A034,
        &_character0000A035,
        &_character0000A036,
        &_character0000A037,
        &_character0000A038,
        &_character0000A039,
        &_character0000A03A,
        &_character0000A03B,
        &_character0000A03C,
        &_character0000A03D,
        &_character0000A03E,
        &_character0000A03F,
        &_character0000A040,
        &_character0000A041,
        &_character0000A042,
        &_character0000A043,
        &_character0000A044,
        &_character0000A045,
        &_character0000A046,
        &_character0000A047,
        &_character0000A048,
        &_character0000A049,
        &_character0000A04A,
        &_character0000A04B,
        &_character0000A04C,
        &_character0000A04D,
        &_character0000A04E,
        &_character0000A04F,
        &_character0000A050,
        &_character0000A051,
        &_character0000A052,
        &_character0000A053,
        &_character0000A054,
        &_character0000A055,
        &_character0000A056,
        &_character0000A057,
        &_character0000A058,
        &_character0000A059,
        &_character0000A05A,
        &_character0000A05B,
        &_character0000A05C,
        &_character0000A05D,
        &_character0000A05E,
        &_character0000A05F,
        &_character0000A060,
        &_character0000A061,
        &_character0000A062,
        &_character0000A063,
        &_character0000A064,
        &_character0000A065,
        &_character0000A066,
        &_character0000A067,
        &_character0000A068,
        &_character0000A069,
        &_character0000A06A,
        &_character0000A06B,
        &_character0000A06C,
        &_character0000A06D,
        &_character0000A06E,
        &_character0000A06F,
        &_character0000A070,
        &_character0000A071,
        &_character0000A072,
        &_character0000A073,
        &_character0000A074,
        &_character0000A075,
        &_character0000A076,
        &_character0000A077,
        &_character0000A078,
        &_character0000A079,
        &_character0000A07A,
        &_character0000A07B,
        &_character0000A07C,
        &_character0000A07D,
        &_character0000A07E,
        &_character0000A07F,
        &_character0000A080,
        &_character0000A081,
        &_character0000A082,
        &_character0000A083,
        &_character0000A084,
        &_character0000A085,
        &_character0000A086,
        &_character0000A087,
        &_character0000A088,
        &_character0000A089,
        &_character0000A08A,
        &_character0000A08B,
        &_character0000A08C,
        &_character0000A08D,
        &_character0000A08E,
        &_character0000A08F,
        &_character0000A090,
        &_character0000A091,
        &_character0000A092,
        &_character0000A093,
        &_character0000A094,
        &_character0000A095,
        &_character0000A096,
        &_character0000A097,
        &_character0000A098,
        &_character0000A099,
        &_character0000A09A,
        &_character0000A09B,
        &_character0000A09C,
        &_character0000A09D,
        &_character0000A09E,
        &_character0000A09F,
        &_character0000A0A0,
        &_character0000A0A1,
        &_character0000A0A2,
        &_character0000A0A3,
        &_character0000A0A4,
        &_character0000A0A5,
        &_character0000A0A6,
        &_character0000A0A7,
        &_character0000A0A8,
        &_character0000A0A9,
        &_character0000A0AA,
        &_character0000A0AB,
        &_character0000A0AC,
        &_character0000A0AD,
        &_character0000A0AE,
        &_character0000A0AF,
        &_character0000A0B0,
        &_character0000A0B1,
        &_character0000A0B2,
        &_character0000A0B3,
        &_character0000A0B4,
        &_character0000A0B5,
        &_character0000A0B6,
        &_character0000A0B7,
        &_character0000A0B8,
        &_character0000A0B9,
        &_character0000A0BA,
        &_character0000A0BB,
        &_character0000A0BC,
        &_character0000A0BD,
        &_character0000A0BE,
        &_character0000A0BF,
        &_character0000A0C0,
        &_character0000A0C1,
        &_character0000A0C2,
        &_character0000A0C3,
        &_character0000A0C4,
        &_character0000A0C5,
        &_character0000A0C6,
        &_character0000A0C7,
        &_character0000A0C8,
        &_character0000A0C9,
        &_character0000A0CA,
        &_character0000A0CB,
        &_character0000A0CC,
        &_character0000A0CD,
        &_character0000A0CE,
        &_character0000A0CF,
        &_character0000A0D0,
        &_character0000A0D1,
        &_character0000A0D2,
        &_character0000A0D3,
        &_character0000A0D4,
        &_character0000A0D5,
        &_character0000A0D6,
        &_character0000A0D7,
        &_character0000A0D8,
        &_character0000A0D9,
        &_character0000A0DA,
        &_character0000A0DB,
        &_character0000A0DC,
        &_character0000A0DD,
        &_character0000A0DE,
        &_character0000A0DF,
        &_character0000A0E0,
        &_character0000A0E1,
        &_character0000A0E2,
        &_character0000A0E3,
        &_character0000A0E4,
        &_character0000A0E5,
        &_character0000A0E6,
        &_character0000A0E7,
        &_character0000A0E8,
        &_character0000A0E9,
        &_character0000A0EA,
        &_character0000A0EB,
        &_character0000A0EC,
        &_character0000A0ED,
        &_character0000A0EE,
        &_character0000A0EF,
        &_character0000A0F0,
        &_character0000A0F1,
        &_character0000A0F2,
        &_character0000A0F3,
        &_character0000A0F4,
        &_character0000A0F5,
        &_character0000A0F6,
        &_character0000A0F7,
        &_character0000A0F8,
        &_character0000A0F9,
        &_character0000A0FA,
        &_character0000A0FB,
        &_character0000A0FC,
        &_character0000A0FD,
        &_character0000A0FE,
        &_character0000A0FF,
        &_character0000A100,
        &_character0000A101,
        &_character0000A102,
        &_character0000A103,
        &_character0000A104,
        &_character0000A105,
        &_character0000A106,
        &_character0000A107,
        &_character0000A108,
        &_character0000A109,
        &_character0000A10A,
        &_character0000A10B,
        &_character0000A10C,
        &_character0000A10D,
        &_character0000A10E,
        &_character0000A10F,
        &_character0000A110,
        &_character0000A111,
        &_character0000A112,
        &_character0000A113,
        &_character0000A114,
        &_character0000A115,
        &_character0000A116,
        &_character0000A117,
        &_character0000A118,
        &_character0000A119,
        &_character0000A11A,
        &_character0000A11B,
        &_character0000A11C,
        &_character0000A11D,
        &_character0000A11E,
        &_character0000A11F,
        &_character0000A120,
        &_character0000A121,
        &_character0000A122,
        &_character0000A123,
        &_character0000A124,
        &_character0000A125,
        &_character0000A126,
        &_character0000A127,
        &_character0000A128,
        &_character0000A129,
        &_character0000A12A,
        &_character0000A12B,
        &_character0000A12C,
        &_character0000A12D,
        &_character0000A12E,
        &_character0000A12F,
        &_character0000A130,
        &_character0000A131,
        &_character0000A132,
        &_character0000A133,
        &_character0000A134,
        &_character0000A135,
        &_character0000A136,
        &_character0000A137,
        &_character0000A138,
        &_character0000A139,
        &_character0000A13A,
        &_character0000A13B,
        &_character0000A13C,
        &_character0000A13D,
        &_character0000A13E,
        &_character0000A13F,
        &_character0000A140,
        &_character0000A141,
        &_character0000A142,
        &_character0000A143,
        &_character0000A144,
        &_character0000A145,
        &_character0000A146,
        &_character0000A147,
        &_character0000A148,
        &_character0000A149,
        &_character0000A14A,
        &_character0000A14B,
        &_character0000A14C,
        &_character0000A14D,
        &_character0000A14E,
        &_character0000A14F,
        &_character0000A150,
        &_character0000A151,
        &_character0000A152,
        &_character0000A153,
        &_character0000A154,
        &_character0000A155,
        &_character0000A156,
        &_character0000A157,
        &_character0000A158,
        &_character0000A159,
        &_character0000A15A,
        &_character0000A15B,
        &_character0000A15C,
        &_character0000A15D,
        &_character0000A15E,
        &_character0000A15F,
        &_character0000A160,
        &_character0000A161,
        &_character0000A162,
        &_character0000A163,
        &_character0000A164,
        &_character0000A165,
        &_character0000A166,
        &_character0000A167,
        &_character0000A168,
        &_character0000A169,
        &_character0000A16A,
        &_character0000A16B,
        &_character0000A16C,
        &_character0000A16D,
        &_character0000A16E,
        &_character0000A16F,
        &_character0000A170,
        &_character0000A171,
        &_character0000A172,
        &_character0000A173,
        &_character0000A174,
        &_character0000A175,
        &_character0000A176,
        &_character0000A177,
        &_character0000A178,
        &_character0000A179,
        &_character0000A17A,
        &_character0000A17B,
        &_character0000A17C,
        &_character0000A17D,
        &_character0000A17E,
        &_character0000A17F,
        &_character0000A180,
        &_character0000A181,
        &_character0000A182,
        &_character0000A183,
        &_character0000A184,
        &_character0000A185,
        &_character0000A186,
        &_character0000A187,
        &_character0000A188,
        &_character0000A189,
        &_character0000A18A,
        &_character0000A18B,
        &_character0000A18C,
        &_character0000A18D,
        &_character0000A18E,
        &_character0000A18F,
        &_character0000A190,
        &_character0000A191,
        &_character0000A192,
        &_character0000A193,
        &_character0000A194,
        &_character0000A195,
        &_character0000A196,
        &_character0000A197,
        &_character0000A198,
        &_character0000A199,
        &_character0000A19A,
        &_character0000A19B,
        &_character0000A19C,
        &_character0000A19D,
        &_character0000A19E,
        &_character0000A19F,
        &_character0000A1A0,
        &_character0000A1A1,
        &_character0000A1A2,
        &_character0000A1A3,
        &_character0000A1A4,
        &_character0000A1A5,
        &_character0000A1A6,
        &_character0000A1A7,
        &_character0000A1A8,
        &_character0000A1A9,
        &_character0000A1AA,
        &_character0000A1AB,
        &_character0000A1AC,
        &_character0000A1AD,
        &_character0000A1AE,
        &_character0000A1AF,
        &_character0000A1B0,
        &_character0000A1B1,
        &_character0000A1B2,
        &_character0000A1B3,
        &_character0000A1B4,
        &_character0000A1B5,
        &_character0000A1B6,
        &_character0000A1B7,
        &_character0000A1B8,
        &_character0000A1B9,
        &_character0000A1BA,
        &_character0000A1BB,
        &_character0000A1BC,
        &_character0000A1BD,
        &_character0000A1BE,
        &_character0000A1BF,
        &_character0000A1C0,
        &_character0000A1C1,
        &_character0000A1C2,
        &_character0000A1C3,
        &_character0000A1C4,
        &_character0000A1C5,
        &_character0000A1C6,
        &_character0000A1C7,
        &_character0000A1C8,
        &_character0000A1C9,
        &_character0000A1CA,
        &_character0000A1CB,
        &_character0000A1CC,
        &_character0000A1CD,
        &_character0000A1CE,
        &_character0000A1CF,
        &_character0000A1D0,
        &_character0000A1D1,
        &_character0000A1D2,
        &_character0000A1D3,
        &_character0000A1D4,
        &_character0000A1D5,
        &_character0000A1D6,
        &_character0000A1D7,
        &_character0000A1D8,
        &_character0000A1D9,
        &_character0000A1DA,
        &_character0000A1DB,
        &_character0000A1DC,
        &_character0000A1DD,
        &_character0000A1DE,
        &_character0000A1DF,
        &_character0000A1E0,
        &_character0000A1E1,
        &_character0000A1E2,
        &_character0000A1E3,
        &_character0000A1E4,
        &_character0000A1E5,
        &_character0000A1E6,
        &_character0000A1E7,
        &_character0000A1E8,
        &_character0000A1E9,
        &_character0000A1EA,
        &_character0000A1EB,
        &_character0000A1EC,
        &_character0000A1ED,
        &_character0000A1EE,
        &_character0000A1EF,
        &_character0000A1F0,
        &_character0000A1F1,
        &_character0000A1F2,
        &_character0000A1F3,
        &_character0000A1F4,
        &_character0000A1F5,
        &_character0000A1F6,
        &_character0000A1F7,
        &_character0000A1F8,
        &_character0000A1F9,
        &_character0000A1FA,
        &_character0000A1FB,
        &_character0000A1FC,
        &_character0000A1FD,
        &_character0000A1FE,
        &_character0000A1FF,
        &_character0000A200,
        &_character0000A201,
        &_character0000A202,
        &_character0000A203,
        &_character0000A204,
        &_character0000A205,
        &_character0000A206,
        &_character0000A207,
        &_character0000A208,
        &_character0000A209,
        &_character0000A20A,
        &_character0000A20B,
        &_character0000A20C,
        &_character0000A20D,
        &_character0000A20E,
        &_character0000A20F,
        &_character0000A210,
        &_character0000A211,
        &_character0000A212,
        &_character0000A213,
        &_character0000A214,
        &_character0000A215,
        &_character0000A216,
        &_character0000A217,
        &_character0000A218,
        &_character0000A219,
        &_character0000A21A,
        &_character0000A21B,
        &_character0000A21C,
        &_character0000A21D,
        &_character0000A21E,
        &_character0000A21F,
        &_character0000A220,
        &_character0000A221,
        &_character0000A222,
        &_character0000A223,
        &_character0000A224,
        &_character0000A225,
        &_character0000A226,
        &_character0000A227,
        &_character0000A228,
        &_character0000A229,
        &_character0000A22A,
        &_character0000A22B,
        &_character0000A22C,
        &_character0000A22D,
        &_character0000A22E,
        &_character0000A22F,
        &_character0000A230,
        &_character0000A231,
        &_character0000A232,
        &_character0000A233,
        &_character0000A234,
        &_character0000A235,
        &_character0000A236,
        &_character0000A237,
        &_character0000A238,
        &_character0000A239,
        &_character0000A23A,
        &_character0000A23B,
        &_character0000A23C,
        &_character0000A23D,
        &_character0000A23E,
        &_character0000A23F,
        &_character0000A240,
        &_character0000A241,
        &_character0000A242,
        &_character0000A243,
        &_character0000A244,
        &_character0000A245,
        &_character0000A246,
        &_character0000A247,
        &_character0000A248,
        &_character0000A249,
        &_character0000A24A,
        &_character0000A24B,
        &_character0000A24C,
        &_character0000A24D,
        &_character0000A24E,
        &_character0000A24F,
        &_character0000A250,
        &_character0000A251,
        &_character0000A252,
        &_character0000A253,
        &_character0000A254,
        &_character0000A255,
        &_character0000A256,
        &_character0000A257,
        &_character0000A258,
        &_character0000A259,
        &_character0000A25A,
        &_character0000A25B,
        &_character0000A25C,
        &_character0000A25D,
        &_character0000A25E,
        &_character0000A25F,
        &_character0000A260,
        &_character0000A261,
        &_character0000A262,
        &_character0000A263,
        &_character0000A264,
        &_character0000A265,
        &_character0000A266,
        &_character0000A267,
        &_character0000A268,
        &_character0000A269,
        &_character0000A26A,
        &_character0000A26B,
        &_character0000A26C,
        &_character0000A26D,
        &_character0000A26E,
        &_character0000A26F,
        &_character0000A270,
        &_character0000A271,
        &_character0000A272,
        &_character0000A273,
        &_character0000A274,
        &_character0000A275,
        &_character0000A276,
        &_character0000A277,
        &_character0000A278,
        &_character0000A279,
        &_character0000A27A,
        &_character0000A27B,
        &_character0000A27C,
        &_character0000A27D,
        &_character0000A27E,
        &_character0000A27F,
        &_character0000A280,
        &_character0000A281,
        &_character0000A282,
        &_character0000A283,
        &_character0000A284,
        &_character0000A285,
        &_character0000A286,
        &_character0000A287,
        &_character0000A288,
        &_character0000A289,
        &_character0000A28A,
        &_character0000A28B,
        &_character0000A28C,
        &_character0000A28D,
        &_character0000A28E,
        &_character0000A28F,
        &_character0000A290,
        &_character0000A291,
        &_character0000A292,
        &_character0000A293,
        &_character0000A294,
        &_character0000A295,
        &_character0000A296,
        &_character0000A297,
        &_character0000A298,
        &_character0000A299,
        &_character0000A29A,
        &_character0000A29B,
        &_character0000A29C,
        &_character0000A29D,
        &_character0000A29E,
        &_character0000A29F,
        &_character0000A2A0,
        &_character0000A2A1,
        &_character0000A2A2,
        &_character0000A2A3,
        &_character0000A2A4,
        &_character0000A2A5,
        &_character0000A2A6,
        &_character0000A2A7,
        &_character0000A2A8,
        &_character0000A2A9,
        &_character0000A2AA,
        &_character0000A2AB,
        &_character0000A2AC,
        &_character0000A2AD,
        &_character0000A2AE,
        &_character0000A2AF,
        &_character0000A2B0,
        &_character0000A2B1,
        &_character0000A2B2,
        &_character0000A2B3,
        &_character0000A2B4,
        &_character0000A2B5,
        &_character0000A2B6,
        &_character0000A2B7,
        &_character0000A2B8,
        &_character0000A2B9,
        &_character0000A2BA,
        &_character0000A2BB,
        &_character0000A2BC,
        &_character0000A2BD,
        &_character0000A2BE,
        &_character0000A2BF,
        &_character0000A2C0,
        &_character0000A2C1,
        &_character0000A2C2,
        &_character0000A2C3,
        &_character0000A2C4,
        &_character0000A2C5,
        &_character0000A2C6,
        &_character0000A2C7,
        &_character0000A2C8,
        &_character0000A2C9,
        &_character0000A2CA,
        &_character0000A2CB,
        &_character0000A2CC,
        &_character0000A2CD,
        &_character0000A2CE,
        &_character0000A2CF,
        &_character0000A2D0,
        &_character0000A2D1,
        &_character0000A2D2,
        &_character0000A2D3,
        &_character0000A2D4,
        &_character0000A2D5,
        &_character0000A2D6,
        &_character0000A2D7,
        &_character0000A2D8,
        &_character0000A2D9,
        &_character0000A2DA,
        &_character0000A2DB,
        &_character0000A2DC,
        &_character0000A2DD,
        &_character0000A2DE,
        &_character0000A2DF,
        &_character0000A2E0,
        &_character0000A2E1,
        &_character0000A2E2,
        &_character0000A2E3,
        &_character0000A2E4,
        &_character0000A2E5,
        &_character0000A2E6,
        &_character0000A2E7,
        &_character0000A2E8,
        &_character0000A2E9,
        &_character0000A2EA,
        &_character0000A2EB,
        &_character0000A2EC,
        &_character0000A2ED,
        &_character0000A2EE,
        &_character0000A2EF,
        &_character0000A2F0,
        &_character0000A2F1,
        &_character0000A2F2,
        &_character0000A2F3,
        &_character0000A2F4,
        &_character0000A2F5,
        &_character0000A2F6,
        &_character0000A2F7,
        &_character0000A2F8,
        &_character0000A2F9,
        &_character0000A2FA,
        &_character0000A2FB,
        &_character0000A2FC,
        &_character0000A2FD,
        &_character0000A2FE,
        &_character0000A2FF,
        &_character0000A300,
        &_character0000A301,
        &_character0000A302,
        &_character0000A303,
        &_character0000A304,
        &_character0000A305,
        &_character0000A306,
        &_character0000A307,
        &_character0000A308,
        &_character0000A309,
        &_character0000A30A,
        &_character0000A30B,
        &_character0000A30C,
        &_character0000A30D,
        &_character0000A30E,
        &_character0000A30F,
        &_character0000A310,
        &_character0000A311,
        &_character0000A312,
        &_character0000A313,
        &_character0000A314,
        &_character0000A315,
        &_character0000A316,
        &_character0000A317,
        &_character0000A318,
        &_character0000A319,
        &_character0000A31A,
        &_character0000A31B,
        &_character0000A31C,
        &_character0000A31D,
        &_character0000A31E,
        &_character0000A31F,
        &_character0000A320,
        &_character0000A321,
        &_character0000A322,
        &_character0000A323,
        &_character0000A324,
        &_character0000A325,
        &_character0000A326,
        &_character0000A327,
        &_character0000A328,
        &_character0000A329,
        &_character0000A32A,
        &_character0000A32B,
        &_character0000A32C,
        &_character0000A32D,
        &_character0000A32E,
        &_character0000A32F,
        &_character0000A330,
        &_character0000A331,
        &_character0000A332,
        &_character0000A333,
        &_character0000A334,
        &_character0000A335,
        &_character0000A336,
        &_character0000A337,
        &_character0000A338,
        &_character0000A339,
        &_character0000A33A,
        &_character0000A33B,
        &_character0000A33C,
        &_character0000A33D,
        &_character0000A33E,
        &_character0000A33F,
        &_character0000A340,
        &_character0000A341,
        &_character0000A342,
        &_character0000A343,
        &_character0000A344,
        &_character0000A345,
        &_character0000A346,
        &_character0000A347,
        &_character0000A348,
        &_character0000A349,
        &_character0000A34A,
        &_character0000A34B,
        &_character0000A34C,
        &_character0000A34D,
        &_character0000A34E,
        &_character0000A34F,
        &_character0000A350,
        &_character0000A351,
        &_character0000A352,
        &_character0000A353,
        &_character0000A354,
        &_character0000A355,
        &_character0000A356,
        &_character0000A357,
        &_character0000A358,
        &_character0000A359,
        &_character0000A35A,
        &_character0000A35B,
        &_character0000A35C,
        &_character0000A35D,
        &_character0000A35E,
        &_character0000A35F,
        &_character0000A360,
        &_character0000A361,
        &_character0000A362,
        &_character0000A363,
        &_character0000A364,
        &_character0000A365,
        &_character0000A366,
        &_character0000A367,
        &_character0000A368,
        &_character0000A369,
        &_character0000A36A,
        &_character0000A36B,
        &_character0000A36C,
        &_character0000A36D,
        &_character0000A36E,
        &_character0000A36F,
        &_character0000A370,
        &_character0000A371,
        &_character0000A372,
        &_character0000A373,
        &_character0000A374,
        &_character0000A375,
        &_character0000A376,
        &_character0000A377,
        &_character0000A378,
        &_character0000A379,
        &_character0000A37A,
        &_character0000A37B,
        &_character0000A37C,
        &_character0000A37D,
        &_character0000A37E,
        &_character0000A37F,
        &_character0000A380,
        &_character0000A381,
        &_character0000A382,
        &_character0000A383,
        &_character0000A384,
        &_character0000A385,
        &_character0000A386,
        &_character0000A387,
        &_character0000A388,
        &_character0000A389,
        &_character0000A38A,
        &_character0000A38B,
        &_character0000A38C,
        &_character0000A38D,
        &_character0000A38E,
        &_character0000A38F,
        &_character0000A390,
        &_character0000A391,
        &_character0000A392,
        &_character0000A393,
        &_character0000A394,
        &_character0000A395,
        &_character0000A396,
        &_character0000A397,
        &_character0000A398,
        &_character0000A399,
        &_character0000A39A,
        &_character0000A39B,
        &_character0000A39C,
        &_character0000A39D,
        &_character0000A39E,
        &_character0000A39F,
        &_character0000A3A0,
        &_character0000A3A1,
        &_character0000A3A2,
        &_character0000A3A3,
        &_character0000A3A4,
        &_character0000A3A5,
        &_character0000A3A6,
        &_character0000A3A7,
        &_character0000A3A8,
        &_character0000A3A9,
        &_character0000A3AA,
        &_character0000A3AB,
        &_character0000A3AC,
        &_character0000A3AD,
        &_character0000A3AE,
        &_character0000A3AF,
        &_character0000A3B0,
        &_character0000A3B1,
        &_character0000A3B2,
        &_character0000A3B3,
        &_character0000A3B4,
        &_character0000A3B5,
        &_character0000A3B6,
        &_character0000A3B7,
        &_character0000A3B8,
        &_character0000A3B9,
        &_character0000A3BA,
        &_character0000A3BB,
        &_character0000A3BC,
        &_character0000A3BD,
        &_character0000A3BE,
        &_character0000A3BF,
        &_character0000A3C0,
        &_character0000A3C1,
        &_character0000A3C2,
        &_character0000A3C3,
        &_character0000A3C4,
        &_character0000A3C5,
        &_character0000A3C6,
        &_character0000A3C7,
        &_character0000A3C8,
        &_character0000A3C9,
        &_character0000A3CA,
        &_character0000A3CB,
        &_character0000A3CC,
        &_character0000A3CD,
        &_character0000A3CE,
        &_character0000A3CF,
        &_character0000A3D0,
        &_character0000A3D1,
        &_character0000A3D2,
        &_character0000A3D3,
        &_character0000A3D4,
        &_character0000A3D5,
        &_character0000A3D6,
        &_character0000A3D7,
        &_character0000A3D8,
        &_character0000A3D9,
        &_character0000A3DA,
        &_character0000A3DB,
        &_character0000A3DC,
        &_character0000A3DD,
        &_character0000A3DE,
        &_character0000A3DF,
        &_character0000A3E0,
        &_character0000A3E1,
        &_character0000A3E2,
        &_character0000A3E3,
        &_character0000A3E4,
        &_character0000A3E5,
        &_character0000A3E6,
        &_character0000A3E7,
        &_character0000A3E8,
        &_character0000A3E9,
        &_character0000A3EA,
        &_character0000A3EB,
        &_character0000A3EC,
        &_character0000A3ED,
        &_character0000A3EE,
        &_character0000A3EF,
        &_character0000A3F0,
        &_character0000A3F1,
        &_character0000A3F2,
        &_character0000A3F3,
        &_character0000A3F4,
        &_character0000A3F5,
        &_character0000A3F6,
        &_character0000A3F7,
        &_character0000A3F8,
        &_character0000A3F9,
        &_character0000A3FA,
        &_character0000A3FB,
        &_character0000A3FC,
        &_character0000A3FD,
        &_character0000A3FE,
        &_character0000A3FF,
        &_character0000A400,
        &_character0000A401,
        &_character0000A402,
        &_character0000A403,
        &_character0000A404,
        &_character0000A405,
        &_character0000A406,
        &_character0000A407,
        &_character0000A408,
        &_character0000A409,
        &_character0000A40A,
        &_character0000A40B,
        &_character0000A40C,
        &_character0000A40D,
        &_character0000A40E,
        &_character0000A40F,
        &_character0000A410,
        &_character0000A411,
        &_character0000A412,
        &_character0000A413,
        &_character0000A414,
        &_character0000A415,
        &_character0000A416,
        &_character0000A417,
        &_character0000A418,
        &_character0000A419,
        &_character0000A41A,
        &_character0000A41B,
        &_character0000A41C,
        &_character0000A41D,
        &_character0000A41E,
        &_character0000A41F,
        &_character0000A420,
        &_character0000A421,
        &_character0000A422,
        &_character0000A423,
        &_character0000A424,
        &_character0000A425,
        &_character0000A426,
        &_character0000A427,
        &_character0000A428,
        &_character0000A429,
        &_character0000A42A,
        &_character0000A42B,
        &_character0000A42C,
        &_character0000A42D,
        &_character0000A42E,
        &_character0000A42F,
        &_character0000A430,
        &_character0000A431,
        &_character0000A432,
        &_character0000A433,
        &_character0000A434,
        &_character0000A435,
        &_character0000A436,
        &_character0000A437,
        &_character0000A438,
        &_character0000A439,
        &_character0000A43A,
        &_character0000A43B,
        &_character0000A43C,
        &_character0000A43D,
        &_character0000A43E,
        &_character0000A43F,
        &_character0000A440,
        &_character0000A441,
        &_character0000A442,
        &_character0000A443,
        &_character0000A444,
        &_character0000A445,
        &_character0000A446,
        &_character0000A447,
        &_character0000A448,
        &_character0000A449,
        &_character0000A44A,
        &_character0000A44B,
        &_character0000A44C,
        &_character0000A44D,
        &_character0000A44E,
        &_character0000A44F,
        &_character0000A450,
        &_character0000A451,
        &_character0000A452,
        &_character0000A453,
        &_character0000A454,
        &_character0000A455,
        &_character0000A456,
        &_character0000A457,
        &_character0000A458,
        &_character0000A459,
        &_character0000A45A,
        &_character0000A45B,
        &_character0000A45C,
        &_character0000A45D,
        &_character0000A45E,
        &_character0000A45F,
        &_character0000A460,
        &_character0000A461,
        &_character0000A462,
        &_character0000A463,
        &_character0000A464,
        &_character0000A465,
        &_character0000A466,
        &_character0000A467,
        &_character0000A468,
        &_character0000A469,
        &_character0000A46A,
        &_character0000A46B,
        &_character0000A46C,
        &_character0000A46D,
        &_character0000A46E,
        &_character0000A46F,
        &_character0000A470,
        &_character0000A471,
        &_character0000A472,
        &_character0000A473,
        &_character0000A474,
        &_character0000A475,
        &_character0000A476,
        &_character0000A477,
        &_character0000A478,
        &_character0000A479,
        &_character0000A47A,
        &_character0000A47B,
        &_character0000A47C,
        &_character0000A47D,
        &_character0000A47E,
        &_character0000A47F,
        &_character0000A480,
        &_character0000A481,
        &_character0000A482,
        &_character0000A483,
        &_character0000A484,
        &_character0000A485,
        &_character0000A486,
        &_character0000A487,
        &_character0000A488,
        &_character0000A489,
        &_character0000A48A,
        &_character0000A48B,
        &_character0000A48C,
        0,
        0,
        0,
        &_character0000A490,
        &_character0000A491,
        &_character0000A492,
        &_character0000A493,
        &_character0000A494,
        &_character0000A495,
        &_character0000A496,
        &_character0000A497,
        &_character0000A498,
        &_character0000A499,
        &_character0000A49A,
        &_character0000A49B,
        &_character0000A49C,
        &_character0000A49D,
        &_character0000A49E,
        &_character0000A49F,
        &_character0000A4A0,
        &_character0000A4A1,
        &_character0000A4A2,
        &_character0000A4A3,
        &_character0000A4A4,
        &_character0000A4A5,
        &_character0000A4A6,
        &_character0000A4A7,
        &_character0000A4A8,
        &_character0000A4A9,
        &_character0000A4AA,
        &_character0000A4AB,
        &_character0000A4AC,
        &_character0000A4AD,
        &_character0000A4AE,
        &_character0000A4AF,
        &_character0000A4B0,
        &_character0000A4B1,
        &_character0000A4B2,
        &_character0000A4B3,
        &_character0000A4B4,
        &_character0000A4B5,
        &_character0000A4B6,
        &_character0000A4B7,
        &_character0000A4B8,
        &_character0000A4B9,
        &_character0000A4BA,
        &_character0000A4BB,
        &_character0000A4BC,
        &_character0000A4BD,
        &_character0000A4BE,
        &_character0000A4BF,
        &_character0000A4C0,
        &_character0000A4C1,
        &_character0000A4C2,
        &_character0000A4C3,
        &_character0000A4C4,
        &_character0000A4C5,
        &_character0000A4C6,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000A700,
        &_character0000A701,
        &_character0000A702,
        &_character0000A703,
        &_character0000A704,
        &_character0000A705,
        &_character0000A706,
        &_character0000A707,
        &_character0000A708,
        &_character0000A709,
        &_character0000A70A,
        &_character0000A70B,
        &_character0000A70C,
        &_character0000A70D,
        &_character0000A70E,
        &_character0000A70F,
        &_character0000A710,
        &_character0000A711,
        &_character0000A712,
        &_character0000A713,
        &_character0000A714,
        &_character0000A715,
        &_character0000A716,
        &_character0000A717,
        &_character0000A718,
        &_character0000A719,
        &_character0000A71A,
        0,
        0,
        0,
        0,
        0,
        &_character0000A720,
        &_character0000A721,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30000A800[2048] =
    {
        &_character0000A800,
        &_character0000A801,
        &_character0000A802,
        &_character0000A803,
        &_character0000A804,
        &_character0000A805,
        &_character0000A806,
        &_character0000A807,
        &_character0000A808,
        &_character0000A809,
        &_character0000A80A,
        &_character0000A80B,
        &_character0000A80C,
        &_character0000A80D,
        &_character0000A80E,
        &_character0000A80F,
        &_character0000A810,
        &_character0000A811,
        &_character0000A812,
        &_character0000A813,
        &_character0000A814,
        &_character0000A815,
        &_character0000A816,
        &_character0000A817,
        &_character0000A818,
        &_character0000A819,
        &_character0000A81A,
        &_character0000A81B,
        &_character0000A81C,
        &_character0000A81D,
        &_character0000A81E,
        &_character0000A81F,
        &_character0000A820,
        &_character0000A821,
        &_character0000A822,
        &_character0000A823,
        &_character0000A824,
        &_character0000A825,
        &_character0000A826,
        &_character0000A827,
        &_character0000A828,
        &_character0000A829,
        &_character0000A82A,
        &_character0000A82B,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000A840,
        &_character0000A841,
        &_character0000A842,
        &_character0000A843,
        &_character0000A844,
        &_character0000A845,
        &_character0000A846,
        &_character0000A847,
        &_character0000A848,
        &_character0000A849,
        &_character0000A84A,
        &_character0000A84B,
        &_character0000A84C,
        &_character0000A84D,
        &_character0000A84E,
        &_character0000A84F,
        &_character0000A850,
        &_character0000A851,
        &_character0000A852,
        &_character0000A853,
        &_character0000A854,
        &_character0000A855,
        &_character0000A856,
        &_character0000A857,
        &_character0000A858,
        &_character0000A859,
        &_character0000A85A,
        &_character0000A85B,
        &_character0000A85C,
        &_character0000A85D,
        &_character0000A85E,
        &_character0000A85F,
        &_character0000A860,
        &_character0000A861,
        &_character0000A862,
        &_character0000A863,
        &_character0000A864,
        &_character0000A865,
        &_character0000A866,
        &_character0000A867,
        &_character0000A868,
        &_character0000A869,
        &_character0000A86A,
        &_character0000A86B,
        &_character0000A86C,
        &_character0000A86D,
        &_character0000A86E,
        &_character0000A86F,
        &_character0000A870,
        &_character0000A871,
        &_character0000A872,
        &_character0000A873,
        &_character0000A874,
        &_character0000A875,
        &_character0000A876,
        &_character0000A877,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000AC00,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30000D000[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000D7A3,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30000D800[2048] =
    {
        &_character0000D800,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000DB7F,
        &_character0000DB80,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000DBFF,
        &_character0000DC00,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000DFFF
    };

    static _CharacterInfo * _table30000E000[2048] =
    {
        &_character0000E000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30000F800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000F8FF,
        &_character0000F900,
        &_character0000F901,
        &_character0000F902,
        &_character0000F903,
        &_character0000F904,
        &_character0000F905,
        &_character0000F906,
        &_character0000F907,
        &_character0000F908,
        &_character0000F909,
        &_character0000F90A,
        &_character0000F90B,
        &_character0000F90C,
        &_character0000F90D,
        &_character0000F90E,
        &_character0000F90F,
        &_character0000F910,
        &_character0000F911,
        &_character0000F912,
        &_character0000F913,
        &_character0000F914,
        &_character0000F915,
        &_character0000F916,
        &_character0000F917,
        &_character0000F918,
        &_character0000F919,
        &_character0000F91A,
        &_character0000F91B,
        &_character0000F91C,
        &_character0000F91D,
        &_character0000F91E,
        &_character0000F91F,
        &_character0000F920,
        &_character0000F921,
        &_character0000F922,
        &_character0000F923,
        &_character0000F924,
        &_character0000F925,
        &_character0000F926,
        &_character0000F927,
        &_character0000F928,
        &_character0000F929,
        &_character0000F92A,
        &_character0000F92B,
        &_character0000F92C,
        &_character0000F92D,
        &_character0000F92E,
        &_character0000F92F,
        &_character0000F930,
        &_character0000F931,
        &_character0000F932,
        &_character0000F933,
        &_character0000F934,
        &_character0000F935,
        &_character0000F936,
        &_character0000F937,
        &_character0000F938,
        &_character0000F939,
        &_character0000F93A,
        &_character0000F93B,
        &_character0000F93C,
        &_character0000F93D,
        &_character0000F93E,
        &_character0000F93F,
        &_character0000F940,
        &_character0000F941,
        &_character0000F942,
        &_character0000F943,
        &_character0000F944,
        &_character0000F945,
        &_character0000F946,
        &_character0000F947,
        &_character0000F948,
        &_character0000F949,
        &_character0000F94A,
        &_character0000F94B,
        &_character0000F94C,
        &_character0000F94D,
        &_character0000F94E,
        &_character0000F94F,
        &_character0000F950,
        &_character0000F951,
        &_character0000F952,
        &_character0000F953,
        &_character0000F954,
        &_character0000F955,
        &_character0000F956,
        &_character0000F957,
        &_character0000F958,
        &_character0000F959,
        &_character0000F95A,
        &_character0000F95B,
        &_character0000F95C,
        &_character0000F95D,
        &_character0000F95E,
        &_character0000F95F,
        &_character0000F960,
        &_character0000F961,
        &_character0000F962,
        &_character0000F963,
        &_character0000F964,
        &_character0000F965,
        &_character0000F966,
        &_character0000F967,
        &_character0000F968,
        &_character0000F969,
        &_character0000F96A,
        &_character0000F96B,
        &_character0000F96C,
        &_character0000F96D,
        &_character0000F96E,
        &_character0000F96F,
        &_character0000F970,
        &_character0000F971,
        &_character0000F972,
        &_character0000F973,
        &_character0000F974,
        &_character0000F975,
        &_character0000F976,
        &_character0000F977,
        &_character0000F978,
        &_character0000F979,
        &_character0000F97A,
        &_character0000F97B,
        &_character0000F97C,
        &_character0000F97D,
        &_character0000F97E,
        &_character0000F97F,
        &_character0000F980,
        &_character0000F981,
        &_character0000F982,
        &_character0000F983,
        &_character0000F984,
        &_character0000F985,
        &_character0000F986,
        &_character0000F987,
        &_character0000F988,
        &_character0000F989,
        &_character0000F98A,
        &_character0000F98B,
        &_character0000F98C,
        &_character0000F98D,
        &_character0000F98E,
        &_character0000F98F,
        &_character0000F990,
        &_character0000F991,
        &_character0000F992,
        &_character0000F993,
        &_character0000F994,
        &_character0000F995,
        &_character0000F996,
        &_character0000F997,
        &_character0000F998,
        &_character0000F999,
        &_character0000F99A,
        &_character0000F99B,
        &_character0000F99C,
        &_character0000F99D,
        &_character0000F99E,
        &_character0000F99F,
        &_character0000F9A0,
        &_character0000F9A1,
        &_character0000F9A2,
        &_character0000F9A3,
        &_character0000F9A4,
        &_character0000F9A5,
        &_character0000F9A6,
        &_character0000F9A7,
        &_character0000F9A8,
        &_character0000F9A9,
        &_character0000F9AA,
        &_character0000F9AB,
        &_character0000F9AC,
        &_character0000F9AD,
        &_character0000F9AE,
        &_character0000F9AF,
        &_character0000F9B0,
        &_character0000F9B1,
        &_character0000F9B2,
        &_character0000F9B3,
        &_character0000F9B4,
        &_character0000F9B5,
        &_character0000F9B6,
        &_character0000F9B7,
        &_character0000F9B8,
        &_character0000F9B9,
        &_character0000F9BA,
        &_character0000F9BB,
        &_character0000F9BC,
        &_character0000F9BD,
        &_character0000F9BE,
        &_character0000F9BF,
        &_character0000F9C0,
        &_character0000F9C1,
        &_character0000F9C2,
        &_character0000F9C3,
        &_character0000F9C4,
        &_character0000F9C5,
        &_character0000F9C6,
        &_character0000F9C7,
        &_character0000F9C8,
        &_character0000F9C9,
        &_character0000F9CA,
        &_character0000F9CB,
        &_character0000F9CC,
        &_character0000F9CD,
        &_character0000F9CE,
        &_character0000F9CF,
        &_character0000F9D0,
        &_character0000F9D1,
        &_character0000F9D2,
        &_character0000F9D3,
        &_character0000F9D4,
        &_character0000F9D5,
        &_character0000F9D6,
        &_character0000F9D7,
        &_character0000F9D8,
        &_character0000F9D9,
        &_character0000F9DA,
        &_character0000F9DB,
        &_character0000F9DC,
        &_character0000F9DD,
        &_character0000F9DE,
        &_character0000F9DF,
        &_character0000F9E0,
        &_character0000F9E1,
        &_character0000F9E2,
        &_character0000F9E3,
        &_character0000F9E4,
        &_character0000F9E5,
        &_character0000F9E6,
        &_character0000F9E7,
        &_character0000F9E8,
        &_character0000F9E9,
        &_character0000F9EA,
        &_character0000F9EB,
        &_character0000F9EC,
        &_character0000F9ED,
        &_character0000F9EE,
        &_character0000F9EF,
        &_character0000F9F0,
        &_character0000F9F1,
        &_character0000F9F2,
        &_character0000F9F3,
        &_character0000F9F4,
        &_character0000F9F5,
        &_character0000F9F6,
        &_character0000F9F7,
        &_character0000F9F8,
        &_character0000F9F9,
        &_character0000F9FA,
        &_character0000F9FB,
        &_character0000F9FC,
        &_character0000F9FD,
        &_character0000F9FE,
        &_character0000F9FF,
        &_character0000FA00,
        &_character0000FA01,
        &_character0000FA02,
        &_character0000FA03,
        &_character0000FA04,
        &_character0000FA05,
        &_character0000FA06,
        &_character0000FA07,
        &_character0000FA08,
        &_character0000FA09,
        &_character0000FA0A,
        &_character0000FA0B,
        &_character0000FA0C,
        &_character0000FA0D,
        &_character0000FA0E,
        &_character0000FA0F,
        &_character0000FA10,
        &_character0000FA11,
        &_character0000FA12,
        &_character0000FA13,
        &_character0000FA14,
        &_character0000FA15,
        &_character0000FA16,
        &_character0000FA17,
        &_character0000FA18,
        &_character0000FA19,
        &_character0000FA1A,
        &_character0000FA1B,
        &_character0000FA1C,
        &_character0000FA1D,
        &_character0000FA1E,
        &_character0000FA1F,
        &_character0000FA20,
        &_character0000FA21,
        &_character0000FA22,
        &_character0000FA23,
        &_character0000FA24,
        &_character0000FA25,
        &_character0000FA26,
        &_character0000FA27,
        &_character0000FA28,
        &_character0000FA29,
        &_character0000FA2A,
        &_character0000FA2B,
        &_character0000FA2C,
        &_character0000FA2D,
        0,
        0,
        &_character0000FA30,
        &_character0000FA31,
        &_character0000FA32,
        &_character0000FA33,
        &_character0000FA34,
        &_character0000FA35,
        &_character0000FA36,
        &_character0000FA37,
        &_character0000FA38,
        &_character0000FA39,
        &_character0000FA3A,
        &_character0000FA3B,
        &_character0000FA3C,
        &_character0000FA3D,
        &_character0000FA3E,
        &_character0000FA3F,
        &_character0000FA40,
        &_character0000FA41,
        &_character0000FA42,
        &_character0000FA43,
        &_character0000FA44,
        &_character0000FA45,
        &_character0000FA46,
        &_character0000FA47,
        &_character0000FA48,
        &_character0000FA49,
        &_character0000FA4A,
        &_character0000FA4B,
        &_character0000FA4C,
        &_character0000FA4D,
        &_character0000FA4E,
        &_character0000FA4F,
        &_character0000FA50,
        &_character0000FA51,
        &_character0000FA52,
        &_character0000FA53,
        &_character0000FA54,
        &_character0000FA55,
        &_character0000FA56,
        &_character0000FA57,
        &_character0000FA58,
        &_character0000FA59,
        &_character0000FA5A,
        &_character0000FA5B,
        &_character0000FA5C,
        &_character0000FA5D,
        &_character0000FA5E,
        &_character0000FA5F,
        &_character0000FA60,
        &_character0000FA61,
        &_character0000FA62,
        &_character0000FA63,
        &_character0000FA64,
        &_character0000FA65,
        &_character0000FA66,
        &_character0000FA67,
        &_character0000FA68,
        &_character0000FA69,
        &_character0000FA6A,
        0,
        0,
        0,
        0,
        0,
        &_character0000FA70,
        &_character0000FA71,
        &_character0000FA72,
        &_character0000FA73,
        &_character0000FA74,
        &_character0000FA75,
        &_character0000FA76,
        &_character0000FA77,
        &_character0000FA78,
        &_character0000FA79,
        &_character0000FA7A,
        &_character0000FA7B,
        &_character0000FA7C,
        &_character0000FA7D,
        &_character0000FA7E,
        &_character0000FA7F,
        &_character0000FA80,
        &_character0000FA81,
        &_character0000FA82,
        &_character0000FA83,
        &_character0000FA84,
        &_character0000FA85,
        &_character0000FA86,
        &_character0000FA87,
        &_character0000FA88,
        &_character0000FA89,
        &_character0000FA8A,
        &_character0000FA8B,
        &_character0000FA8C,
        &_character0000FA8D,
        &_character0000FA8E,
        &_character0000FA8F,
        &_character0000FA90,
        &_character0000FA91,
        &_character0000FA92,
        &_character0000FA93,
        &_character0000FA94,
        &_character0000FA95,
        &_character0000FA96,
        &_character0000FA97,
        &_character0000FA98,
        &_character0000FA99,
        &_character0000FA9A,
        &_character0000FA9B,
        &_character0000FA9C,
        &_character0000FA9D,
        &_character0000FA9E,
        &_character0000FA9F,
        &_character0000FAA0,
        &_character0000FAA1,
        &_character0000FAA2,
        &_character0000FAA3,
        &_character0000FAA4,
        &_character0000FAA5,
        &_character0000FAA6,
        &_character0000FAA7,
        &_character0000FAA8,
        &_character0000FAA9,
        &_character0000FAAA,
        &_character0000FAAB,
        &_character0000FAAC,
        &_character0000FAAD,
        &_character0000FAAE,
        &_character0000FAAF,
        &_character0000FAB0,
        &_character0000FAB1,
        &_character0000FAB2,
        &_character0000FAB3,
        &_character0000FAB4,
        &_character0000FAB5,
        &_character0000FAB6,
        &_character0000FAB7,
        &_character0000FAB8,
        &_character0000FAB9,
        &_character0000FABA,
        &_character0000FABB,
        &_character0000FABC,
        &_character0000FABD,
        &_character0000FABE,
        &_character0000FABF,
        &_character0000FAC0,
        &_character0000FAC1,
        &_character0000FAC2,
        &_character0000FAC3,
        &_character0000FAC4,
        &_character0000FAC5,
        &_character0000FAC6,
        &_character0000FAC7,
        &_character0000FAC8,
        &_character0000FAC9,
        &_character0000FACA,
        &_character0000FACB,
        &_character0000FACC,
        &_character0000FACD,
        &_character0000FACE,
        &_character0000FACF,
        &_character0000FAD0,
        &_character0000FAD1,
        &_character0000FAD2,
        &_character0000FAD3,
        &_character0000FAD4,
        &_character0000FAD5,
        &_character0000FAD6,
        &_character0000FAD7,
        &_character0000FAD8,
        &_character0000FAD9,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FB00,
        &_character0000FB01,
        &_character0000FB02,
        &_character0000FB03,
        &_character0000FB04,
        &_character0000FB05,
        &_character0000FB06,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FB13,
        &_character0000FB14,
        &_character0000FB15,
        &_character0000FB16,
        &_character0000FB17,
        0,
        0,
        0,
        0,
        0,
        &_character0000FB1D,
        &_character0000FB1E,
        &_character0000FB1F,
        &_character0000FB20,
        &_character0000FB21,
        &_character0000FB22,
        &_character0000FB23,
        &_character0000FB24,
        &_character0000FB25,
        &_character0000FB26,
        &_character0000FB27,
        &_character0000FB28,
        &_character0000FB29,
        &_character0000FB2A,
        &_character0000FB2B,
        &_character0000FB2C,
        &_character0000FB2D,
        &_character0000FB2E,
        &_character0000FB2F,
        &_character0000FB30,
        &_character0000FB31,
        &_character0000FB32,
        &_character0000FB33,
        &_character0000FB34,
        &_character0000FB35,
        &_character0000FB36,
        0,
        &_character0000FB38,
        &_character0000FB39,
        &_character0000FB3A,
        &_character0000FB3B,
        &_character0000FB3C,
        0,
        &_character0000FB3E,
        0,
        &_character0000FB40,
        &_character0000FB41,
        0,
        &_character0000FB43,
        &_character0000FB44,
        0,
        &_character0000FB46,
        &_character0000FB47,
        &_character0000FB48,
        &_character0000FB49,
        &_character0000FB4A,
        &_character0000FB4B,
        &_character0000FB4C,
        &_character0000FB4D,
        &_character0000FB4E,
        &_character0000FB4F,
        &_character0000FB50,
        &_character0000FB51,
        &_character0000FB52,
        &_character0000FB53,
        &_character0000FB54,
        &_character0000FB55,
        &_character0000FB56,
        &_character0000FB57,
        &_character0000FB58,
        &_character0000FB59,
        &_character0000FB5A,
        &_character0000FB5B,
        &_character0000FB5C,
        &_character0000FB5D,
        &_character0000FB5E,
        &_character0000FB5F,
        &_character0000FB60,
        &_character0000FB61,
        &_character0000FB62,
        &_character0000FB63,
        &_character0000FB64,
        &_character0000FB65,
        &_character0000FB66,
        &_character0000FB67,
        &_character0000FB68,
        &_character0000FB69,
        &_character0000FB6A,
        &_character0000FB6B,
        &_character0000FB6C,
        &_character0000FB6D,
        &_character0000FB6E,
        &_character0000FB6F,
        &_character0000FB70,
        &_character0000FB71,
        &_character0000FB72,
        &_character0000FB73,
        &_character0000FB74,
        &_character0000FB75,
        &_character0000FB76,
        &_character0000FB77,
        &_character0000FB78,
        &_character0000FB79,
        &_character0000FB7A,
        &_character0000FB7B,
        &_character0000FB7C,
        &_character0000FB7D,
        &_character0000FB7E,
        &_character0000FB7F,
        &_character0000FB80,
        &_character0000FB81,
        &_character0000FB82,
        &_character0000FB83,
        &_character0000FB84,
        &_character0000FB85,
        &_character0000FB86,
        &_character0000FB87,
        &_character0000FB88,
        &_character0000FB89,
        &_character0000FB8A,
        &_character0000FB8B,
        &_character0000FB8C,
        &_character0000FB8D,
        &_character0000FB8E,
        &_character0000FB8F,
        &_character0000FB90,
        &_character0000FB91,
        &_character0000FB92,
        &_character0000FB93,
        &_character0000FB94,
        &_character0000FB95,
        &_character0000FB96,
        &_character0000FB97,
        &_character0000FB98,
        &_character0000FB99,
        &_character0000FB9A,
        &_character0000FB9B,
        &_character0000FB9C,
        &_character0000FB9D,
        &_character0000FB9E,
        &_character0000FB9F,
        &_character0000FBA0,
        &_character0000FBA1,
        &_character0000FBA2,
        &_character0000FBA3,
        &_character0000FBA4,
        &_character0000FBA5,
        &_character0000FBA6,
        &_character0000FBA7,
        &_character0000FBA8,
        &_character0000FBA9,
        &_character0000FBAA,
        &_character0000FBAB,
        &_character0000FBAC,
        &_character0000FBAD,
        &_character0000FBAE,
        &_character0000FBAF,
        &_character0000FBB0,
        &_character0000FBB1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FBD3,
        &_character0000FBD4,
        &_character0000FBD5,
        &_character0000FBD6,
        &_character0000FBD7,
        &_character0000FBD8,
        &_character0000FBD9,
        &_character0000FBDA,
        &_character0000FBDB,
        &_character0000FBDC,
        &_character0000FBDD,
        &_character0000FBDE,
        &_character0000FBDF,
        &_character0000FBE0,
        &_character0000FBE1,
        &_character0000FBE2,
        &_character0000FBE3,
        &_character0000FBE4,
        &_character0000FBE5,
        &_character0000FBE6,
        &_character0000FBE7,
        &_character0000FBE8,
        &_character0000FBE9,
        &_character0000FBEA,
        &_character0000FBEB,
        &_character0000FBEC,
        &_character0000FBED,
        &_character0000FBEE,
        &_character0000FBEF,
        &_character0000FBF0,
        &_character0000FBF1,
        &_character0000FBF2,
        &_character0000FBF3,
        &_character0000FBF4,
        &_character0000FBF5,
        &_character0000FBF6,
        &_character0000FBF7,
        &_character0000FBF8,
        &_character0000FBF9,
        &_character0000FBFA,
        &_character0000FBFB,
        &_character0000FBFC,
        &_character0000FBFD,
        &_character0000FBFE,
        &_character0000FBFF,
        &_character0000FC00,
        &_character0000FC01,
        &_character0000FC02,
        &_character0000FC03,
        &_character0000FC04,
        &_character0000FC05,
        &_character0000FC06,
        &_character0000FC07,
        &_character0000FC08,
        &_character0000FC09,
        &_character0000FC0A,
        &_character0000FC0B,
        &_character0000FC0C,
        &_character0000FC0D,
        &_character0000FC0E,
        &_character0000FC0F,
        &_character0000FC10,
        &_character0000FC11,
        &_character0000FC12,
        &_character0000FC13,
        &_character0000FC14,
        &_character0000FC15,
        &_character0000FC16,
        &_character0000FC17,
        &_character0000FC18,
        &_character0000FC19,
        &_character0000FC1A,
        &_character0000FC1B,
        &_character0000FC1C,
        &_character0000FC1D,
        &_character0000FC1E,
        &_character0000FC1F,
        &_character0000FC20,
        &_character0000FC21,
        &_character0000FC22,
        &_character0000FC23,
        &_character0000FC24,
        &_character0000FC25,
        &_character0000FC26,
        &_character0000FC27,
        &_character0000FC28,
        &_character0000FC29,
        &_character0000FC2A,
        &_character0000FC2B,
        &_character0000FC2C,
        &_character0000FC2D,
        &_character0000FC2E,
        &_character0000FC2F,
        &_character0000FC30,
        &_character0000FC31,
        &_character0000FC32,
        &_character0000FC33,
        &_character0000FC34,
        &_character0000FC35,
        &_character0000FC36,
        &_character0000FC37,
        &_character0000FC38,
        &_character0000FC39,
        &_character0000FC3A,
        &_character0000FC3B,
        &_character0000FC3C,
        &_character0000FC3D,
        &_character0000FC3E,
        &_character0000FC3F,
        &_character0000FC40,
        &_character0000FC41,
        &_character0000FC42,
        &_character0000FC43,
        &_character0000FC44,
        &_character0000FC45,
        &_character0000FC46,
        &_character0000FC47,
        &_character0000FC48,
        &_character0000FC49,
        &_character0000FC4A,
        &_character0000FC4B,
        &_character0000FC4C,
        &_character0000FC4D,
        &_character0000FC4E,
        &_character0000FC4F,
        &_character0000FC50,
        &_character0000FC51,
        &_character0000FC52,
        &_character0000FC53,
        &_character0000FC54,
        &_character0000FC55,
        &_character0000FC56,
        &_character0000FC57,
        &_character0000FC58,
        &_character0000FC59,
        &_character0000FC5A,
        &_character0000FC5B,
        &_character0000FC5C,
        &_character0000FC5D,
        &_character0000FC5E,
        &_character0000FC5F,
        &_character0000FC60,
        &_character0000FC61,
        &_character0000FC62,
        &_character0000FC63,
        &_character0000FC64,
        &_character0000FC65,
        &_character0000FC66,
        &_character0000FC67,
        &_character0000FC68,
        &_character0000FC69,
        &_character0000FC6A,
        &_character0000FC6B,
        &_character0000FC6C,
        &_character0000FC6D,
        &_character0000FC6E,
        &_character0000FC6F,
        &_character0000FC70,
        &_character0000FC71,
        &_character0000FC72,
        &_character0000FC73,
        &_character0000FC74,
        &_character0000FC75,
        &_character0000FC76,
        &_character0000FC77,
        &_character0000FC78,
        &_character0000FC79,
        &_character0000FC7A,
        &_character0000FC7B,
        &_character0000FC7C,
        &_character0000FC7D,
        &_character0000FC7E,
        &_character0000FC7F,
        &_character0000FC80,
        &_character0000FC81,
        &_character0000FC82,
        &_character0000FC83,
        &_character0000FC84,
        &_character0000FC85,
        &_character0000FC86,
        &_character0000FC87,
        &_character0000FC88,
        &_character0000FC89,
        &_character0000FC8A,
        &_character0000FC8B,
        &_character0000FC8C,
        &_character0000FC8D,
        &_character0000FC8E,
        &_character0000FC8F,
        &_character0000FC90,
        &_character0000FC91,
        &_character0000FC92,
        &_character0000FC93,
        &_character0000FC94,
        &_character0000FC95,
        &_character0000FC96,
        &_character0000FC97,
        &_character0000FC98,
        &_character0000FC99,
        &_character0000FC9A,
        &_character0000FC9B,
        &_character0000FC9C,
        &_character0000FC9D,
        &_character0000FC9E,
        &_character0000FC9F,
        &_character0000FCA0,
        &_character0000FCA1,
        &_character0000FCA2,
        &_character0000FCA3,
        &_character0000FCA4,
        &_character0000FCA5,
        &_character0000FCA6,
        &_character0000FCA7,
        &_character0000FCA8,
        &_character0000FCA9,
        &_character0000FCAA,
        &_character0000FCAB,
        &_character0000FCAC,
        &_character0000FCAD,
        &_character0000FCAE,
        &_character0000FCAF,
        &_character0000FCB0,
        &_character0000FCB1,
        &_character0000FCB2,
        &_character0000FCB3,
        &_character0000FCB4,
        &_character0000FCB5,
        &_character0000FCB6,
        &_character0000FCB7,
        &_character0000FCB8,
        &_character0000FCB9,
        &_character0000FCBA,
        &_character0000FCBB,
        &_character0000FCBC,
        &_character0000FCBD,
        &_character0000FCBE,
        &_character0000FCBF,
        &_character0000FCC0,
        &_character0000FCC1,
        &_character0000FCC2,
        &_character0000FCC3,
        &_character0000FCC4,
        &_character0000FCC5,
        &_character0000FCC6,
        &_character0000FCC7,
        &_character0000FCC8,
        &_character0000FCC9,
        &_character0000FCCA,
        &_character0000FCCB,
        &_character0000FCCC,
        &_character0000FCCD,
        &_character0000FCCE,
        &_character0000FCCF,
        &_character0000FCD0,
        &_character0000FCD1,
        &_character0000FCD2,
        &_character0000FCD3,
        &_character0000FCD4,
        &_character0000FCD5,
        &_character0000FCD6,
        &_character0000FCD7,
        &_character0000FCD8,
        &_character0000FCD9,
        &_character0000FCDA,
        &_character0000FCDB,
        &_character0000FCDC,
        &_character0000FCDD,
        &_character0000FCDE,
        &_character0000FCDF,
        &_character0000FCE0,
        &_character0000FCE1,
        &_character0000FCE2,
        &_character0000FCE3,
        &_character0000FCE4,
        &_character0000FCE5,
        &_character0000FCE6,
        &_character0000FCE7,
        &_character0000FCE8,
        &_character0000FCE9,
        &_character0000FCEA,
        &_character0000FCEB,
        &_character0000FCEC,
        &_character0000FCED,
        &_character0000FCEE,
        &_character0000FCEF,
        &_character0000FCF0,
        &_character0000FCF1,
        &_character0000FCF2,
        &_character0000FCF3,
        &_character0000FCF4,
        &_character0000FCF5,
        &_character0000FCF6,
        &_character0000FCF7,
        &_character0000FCF8,
        &_character0000FCF9,
        &_character0000FCFA,
        &_character0000FCFB,
        &_character0000FCFC,
        &_character0000FCFD,
        &_character0000FCFE,
        &_character0000FCFF,
        &_character0000FD00,
        &_character0000FD01,
        &_character0000FD02,
        &_character0000FD03,
        &_character0000FD04,
        &_character0000FD05,
        &_character0000FD06,
        &_character0000FD07,
        &_character0000FD08,
        &_character0000FD09,
        &_character0000FD0A,
        &_character0000FD0B,
        &_character0000FD0C,
        &_character0000FD0D,
        &_character0000FD0E,
        &_character0000FD0F,
        &_character0000FD10,
        &_character0000FD11,
        &_character0000FD12,
        &_character0000FD13,
        &_character0000FD14,
        &_character0000FD15,
        &_character0000FD16,
        &_character0000FD17,
        &_character0000FD18,
        &_character0000FD19,
        &_character0000FD1A,
        &_character0000FD1B,
        &_character0000FD1C,
        &_character0000FD1D,
        &_character0000FD1E,
        &_character0000FD1F,
        &_character0000FD20,
        &_character0000FD21,
        &_character0000FD22,
        &_character0000FD23,
        &_character0000FD24,
        &_character0000FD25,
        &_character0000FD26,
        &_character0000FD27,
        &_character0000FD28,
        &_character0000FD29,
        &_character0000FD2A,
        &_character0000FD2B,
        &_character0000FD2C,
        &_character0000FD2D,
        &_character0000FD2E,
        &_character0000FD2F,
        &_character0000FD30,
        &_character0000FD31,
        &_character0000FD32,
        &_character0000FD33,
        &_character0000FD34,
        &_character0000FD35,
        &_character0000FD36,
        &_character0000FD37,
        &_character0000FD38,
        &_character0000FD39,
        &_character0000FD3A,
        &_character0000FD3B,
        &_character0000FD3C,
        &_character0000FD3D,
        &_character0000FD3E,
        &_character0000FD3F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FD50,
        &_character0000FD51,
        &_character0000FD52,
        &_character0000FD53,
        &_character0000FD54,
        &_character0000FD55,
        &_character0000FD56,
        &_character0000FD57,
        &_character0000FD58,
        &_character0000FD59,
        &_character0000FD5A,
        &_character0000FD5B,
        &_character0000FD5C,
        &_character0000FD5D,
        &_character0000FD5E,
        &_character0000FD5F,
        &_character0000FD60,
        &_character0000FD61,
        &_character0000FD62,
        &_character0000FD63,
        &_character0000FD64,
        &_character0000FD65,
        &_character0000FD66,
        &_character0000FD67,
        &_character0000FD68,
        &_character0000FD69,
        &_character0000FD6A,
        &_character0000FD6B,
        &_character0000FD6C,
        &_character0000FD6D,
        &_character0000FD6E,
        &_character0000FD6F,
        &_character0000FD70,
        &_character0000FD71,
        &_character0000FD72,
        &_character0000FD73,
        &_character0000FD74,
        &_character0000FD75,
        &_character0000FD76,
        &_character0000FD77,
        &_character0000FD78,
        &_character0000FD79,
        &_character0000FD7A,
        &_character0000FD7B,
        &_character0000FD7C,
        &_character0000FD7D,
        &_character0000FD7E,
        &_character0000FD7F,
        &_character0000FD80,
        &_character0000FD81,
        &_character0000FD82,
        &_character0000FD83,
        &_character0000FD84,
        &_character0000FD85,
        &_character0000FD86,
        &_character0000FD87,
        &_character0000FD88,
        &_character0000FD89,
        &_character0000FD8A,
        &_character0000FD8B,
        &_character0000FD8C,
        &_character0000FD8D,
        &_character0000FD8E,
        &_character0000FD8F,
        0,
        0,
        &_character0000FD92,
        &_character0000FD93,
        &_character0000FD94,
        &_character0000FD95,
        &_character0000FD96,
        &_character0000FD97,
        &_character0000FD98,
        &_character0000FD99,
        &_character0000FD9A,
        &_character0000FD9B,
        &_character0000FD9C,
        &_character0000FD9D,
        &_character0000FD9E,
        &_character0000FD9F,
        &_character0000FDA0,
        &_character0000FDA1,
        &_character0000FDA2,
        &_character0000FDA3,
        &_character0000FDA4,
        &_character0000FDA5,
        &_character0000FDA6,
        &_character0000FDA7,
        &_character0000FDA8,
        &_character0000FDA9,
        &_character0000FDAA,
        &_character0000FDAB,
        &_character0000FDAC,
        &_character0000FDAD,
        &_character0000FDAE,
        &_character0000FDAF,
        &_character0000FDB0,
        &_character0000FDB1,
        &_character0000FDB2,
        &_character0000FDB3,
        &_character0000FDB4,
        &_character0000FDB5,
        &_character0000FDB6,
        &_character0000FDB7,
        &_character0000FDB8,
        &_character0000FDB9,
        &_character0000FDBA,
        &_character0000FDBB,
        &_character0000FDBC,
        &_character0000FDBD,
        &_character0000FDBE,
        &_character0000FDBF,
        &_character0000FDC0,
        &_character0000FDC1,
        &_character0000FDC2,
        &_character0000FDC3,
        &_character0000FDC4,
        &_character0000FDC5,
        &_character0000FDC6,
        &_character0000FDC7,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FDF0,
        &_character0000FDF1,
        &_character0000FDF2,
        &_character0000FDF3,
        &_character0000FDF4,
        &_character0000FDF5,
        &_character0000FDF6,
        &_character0000FDF7,
        &_character0000FDF8,
        &_character0000FDF9,
        &_character0000FDFA,
        &_character0000FDFB,
        &_character0000FDFC,
        &_character0000FDFD,
        0,
        0,
        &_character0000FE00,
        &_character0000FE01,
        &_character0000FE02,
        &_character0000FE03,
        &_character0000FE04,
        &_character0000FE05,
        &_character0000FE06,
        &_character0000FE07,
        &_character0000FE08,
        &_character0000FE09,
        &_character0000FE0A,
        &_character0000FE0B,
        &_character0000FE0C,
        &_character0000FE0D,
        &_character0000FE0E,
        &_character0000FE0F,
        &_character0000FE10,
        &_character0000FE11,
        &_character0000FE12,
        &_character0000FE13,
        &_character0000FE14,
        &_character0000FE15,
        &_character0000FE16,
        &_character0000FE17,
        &_character0000FE18,
        &_character0000FE19,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FE20,
        &_character0000FE21,
        &_character0000FE22,
        &_character0000FE23,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FE30,
        &_character0000FE31,
        &_character0000FE32,
        &_character0000FE33,
        &_character0000FE34,
        &_character0000FE35,
        &_character0000FE36,
        &_character0000FE37,
        &_character0000FE38,
        &_character0000FE39,
        &_character0000FE3A,
        &_character0000FE3B,
        &_character0000FE3C,
        &_character0000FE3D,
        &_character0000FE3E,
        &_character0000FE3F,
        &_character0000FE40,
        &_character0000FE41,
        &_character0000FE42,
        &_character0000FE43,
        &_character0000FE44,
        &_character0000FE45,
        &_character0000FE46,
        &_character0000FE47,
        &_character0000FE48,
        &_character0000FE49,
        &_character0000FE4A,
        &_character0000FE4B,
        &_character0000FE4C,
        &_character0000FE4D,
        &_character0000FE4E,
        &_character0000FE4F,
        &_character0000FE50,
        &_character0000FE51,
        &_character0000FE52,
        0,
        &_character0000FE54,
        &_character0000FE55,
        &_character0000FE56,
        &_character0000FE57,
        &_character0000FE58,
        &_character0000FE59,
        &_character0000FE5A,
        &_character0000FE5B,
        &_character0000FE5C,
        &_character0000FE5D,
        &_character0000FE5E,
        &_character0000FE5F,
        &_character0000FE60,
        &_character0000FE61,
        &_character0000FE62,
        &_character0000FE63,
        &_character0000FE64,
        &_character0000FE65,
        &_character0000FE66,
        0,
        &_character0000FE68,
        &_character0000FE69,
        &_character0000FE6A,
        &_character0000FE6B,
        0,
        0,
        0,
        0,
        &_character0000FE70,
        &_character0000FE71,
        &_character0000FE72,
        &_character0000FE73,
        &_character0000FE74,
        0,
        &_character0000FE76,
        &_character0000FE77,
        &_character0000FE78,
        &_character0000FE79,
        &_character0000FE7A,
        &_character0000FE7B,
        &_character0000FE7C,
        &_character0000FE7D,
        &_character0000FE7E,
        &_character0000FE7F,
        &_character0000FE80,
        &_character0000FE81,
        &_character0000FE82,
        &_character0000FE83,
        &_character0000FE84,
        &_character0000FE85,
        &_character0000FE86,
        &_character0000FE87,
        &_character0000FE88,
        &_character0000FE89,
        &_character0000FE8A,
        &_character0000FE8B,
        &_character0000FE8C,
        &_character0000FE8D,
        &_character0000FE8E,
        &_character0000FE8F,
        &_character0000FE90,
        &_character0000FE91,
        &_character0000FE92,
        &_character0000FE93,
        &_character0000FE94,
        &_character0000FE95,
        &_character0000FE96,
        &_character0000FE97,
        &_character0000FE98,
        &_character0000FE99,
        &_character0000FE9A,
        &_character0000FE9B,
        &_character0000FE9C,
        &_character0000FE9D,
        &_character0000FE9E,
        &_character0000FE9F,
        &_character0000FEA0,
        &_character0000FEA1,
        &_character0000FEA2,
        &_character0000FEA3,
        &_character0000FEA4,
        &_character0000FEA5,
        &_character0000FEA6,
        &_character0000FEA7,
        &_character0000FEA8,
        &_character0000FEA9,
        &_character0000FEAA,
        &_character0000FEAB,
        &_character0000FEAC,
        &_character0000FEAD,
        &_character0000FEAE,
        &_character0000FEAF,
        &_character0000FEB0,
        &_character0000FEB1,
        &_character0000FEB2,
        &_character0000FEB3,
        &_character0000FEB4,
        &_character0000FEB5,
        &_character0000FEB6,
        &_character0000FEB7,
        &_character0000FEB8,
        &_character0000FEB9,
        &_character0000FEBA,
        &_character0000FEBB,
        &_character0000FEBC,
        &_character0000FEBD,
        &_character0000FEBE,
        &_character0000FEBF,
        &_character0000FEC0,
        &_character0000FEC1,
        &_character0000FEC2,
        &_character0000FEC3,
        &_character0000FEC4,
        &_character0000FEC5,
        &_character0000FEC6,
        &_character0000FEC7,
        &_character0000FEC8,
        &_character0000FEC9,
        &_character0000FECA,
        &_character0000FECB,
        &_character0000FECC,
        &_character0000FECD,
        &_character0000FECE,
        &_character0000FECF,
        &_character0000FED0,
        &_character0000FED1,
        &_character0000FED2,
        &_character0000FED3,
        &_character0000FED4,
        &_character0000FED5,
        &_character0000FED6,
        &_character0000FED7,
        &_character0000FED8,
        &_character0000FED9,
        &_character0000FEDA,
        &_character0000FEDB,
        &_character0000FEDC,
        &_character0000FEDD,
        &_character0000FEDE,
        &_character0000FEDF,
        &_character0000FEE0,
        &_character0000FEE1,
        &_character0000FEE2,
        &_character0000FEE3,
        &_character0000FEE4,
        &_character0000FEE5,
        &_character0000FEE6,
        &_character0000FEE7,
        &_character0000FEE8,
        &_character0000FEE9,
        &_character0000FEEA,
        &_character0000FEEB,
        &_character0000FEEC,
        &_character0000FEED,
        &_character0000FEEE,
        &_character0000FEEF,
        &_character0000FEF0,
        &_character0000FEF1,
        &_character0000FEF2,
        &_character0000FEF3,
        &_character0000FEF4,
        &_character0000FEF5,
        &_character0000FEF6,
        &_character0000FEF7,
        &_character0000FEF8,
        &_character0000FEF9,
        &_character0000FEFA,
        &_character0000FEFB,
        &_character0000FEFC,
        0,
        0,
        &_character0000FEFF,
        0,
        &_character0000FF01,
        &_character0000FF02,
        &_character0000FF03,
        &_character0000FF04,
        &_character0000FF05,
        &_character0000FF06,
        &_character0000FF07,
        &_character0000FF08,
        &_character0000FF09,
        &_character0000FF0A,
        &_character0000FF0B,
        &_character0000FF0C,
        &_character0000FF0D,
        &_character0000FF0E,
        &_character0000FF0F,
        &_character0000FF10,
        &_character0000FF11,
        &_character0000FF12,
        &_character0000FF13,
        &_character0000FF14,
        &_character0000FF15,
        &_character0000FF16,
        &_character0000FF17,
        &_character0000FF18,
        &_character0000FF19,
        &_character0000FF1A,
        &_character0000FF1B,
        &_character0000FF1C,
        &_character0000FF1D,
        &_character0000FF1E,
        &_character0000FF1F,
        &_character0000FF20,
        &_character0000FF21,
        &_character0000FF22,
        &_character0000FF23,
        &_character0000FF24,
        &_character0000FF25,
        &_character0000FF26,
        &_character0000FF27,
        &_character0000FF28,
        &_character0000FF29,
        &_character0000FF2A,
        &_character0000FF2B,
        &_character0000FF2C,
        &_character0000FF2D,
        &_character0000FF2E,
        &_character0000FF2F,
        &_character0000FF30,
        &_character0000FF31,
        &_character0000FF32,
        &_character0000FF33,
        &_character0000FF34,
        &_character0000FF35,
        &_character0000FF36,
        &_character0000FF37,
        &_character0000FF38,
        &_character0000FF39,
        &_character0000FF3A,
        &_character0000FF3B,
        &_character0000FF3C,
        &_character0000FF3D,
        &_character0000FF3E,
        &_character0000FF3F,
        &_character0000FF40,
        &_character0000FF41,
        &_character0000FF42,
        &_character0000FF43,
        &_character0000FF44,
        &_character0000FF45,
        &_character0000FF46,
        &_character0000FF47,
        &_character0000FF48,
        &_character0000FF49,
        &_character0000FF4A,
        &_character0000FF4B,
        &_character0000FF4C,
        &_character0000FF4D,
        &_character0000FF4E,
        &_character0000FF4F,
        &_character0000FF50,
        &_character0000FF51,
        &_character0000FF52,
        &_character0000FF53,
        &_character0000FF54,
        &_character0000FF55,
        &_character0000FF56,
        &_character0000FF57,
        &_character0000FF58,
        &_character0000FF59,
        &_character0000FF5A,
        &_character0000FF5B,
        &_character0000FF5C,
        &_character0000FF5D,
        &_character0000FF5E,
        &_character0000FF5F,
        &_character0000FF60,
        &_character0000FF61,
        &_character0000FF62,
        &_character0000FF63,
        &_character0000FF64,
        &_character0000FF65,
        &_character0000FF66,
        &_character0000FF67,
        &_character0000FF68,
        &_character0000FF69,
        &_character0000FF6A,
        &_character0000FF6B,
        &_character0000FF6C,
        &_character0000FF6D,
        &_character0000FF6E,
        &_character0000FF6F,
        &_character0000FF70,
        &_character0000FF71,
        &_character0000FF72,
        &_character0000FF73,
        &_character0000FF74,
        &_character0000FF75,
        &_character0000FF76,
        &_character0000FF77,
        &_character0000FF78,
        &_character0000FF79,
        &_character0000FF7A,
        &_character0000FF7B,
        &_character0000FF7C,
        &_character0000FF7D,
        &_character0000FF7E,
        &_character0000FF7F,
        &_character0000FF80,
        &_character0000FF81,
        &_character0000FF82,
        &_character0000FF83,
        &_character0000FF84,
        &_character0000FF85,
        &_character0000FF86,
        &_character0000FF87,
        &_character0000FF88,
        &_character0000FF89,
        &_character0000FF8A,
        &_character0000FF8B,
        &_character0000FF8C,
        &_character0000FF8D,
        &_character0000FF8E,
        &_character0000FF8F,
        &_character0000FF90,
        &_character0000FF91,
        &_character0000FF92,
        &_character0000FF93,
        &_character0000FF94,
        &_character0000FF95,
        &_character0000FF96,
        &_character0000FF97,
        &_character0000FF98,
        &_character0000FF99,
        &_character0000FF9A,
        &_character0000FF9B,
        &_character0000FF9C,
        &_character0000FF9D,
        &_character0000FF9E,
        &_character0000FF9F,
        &_character0000FFA0,
        &_character0000FFA1,
        &_character0000FFA2,
        &_character0000FFA3,
        &_character0000FFA4,
        &_character0000FFA5,
        &_character0000FFA6,
        &_character0000FFA7,
        &_character0000FFA8,
        &_character0000FFA9,
        &_character0000FFAA,
        &_character0000FFAB,
        &_character0000FFAC,
        &_character0000FFAD,
        &_character0000FFAE,
        &_character0000FFAF,
        &_character0000FFB0,
        &_character0000FFB1,
        &_character0000FFB2,
        &_character0000FFB3,
        &_character0000FFB4,
        &_character0000FFB5,
        &_character0000FFB6,
        &_character0000FFB7,
        &_character0000FFB8,
        &_character0000FFB9,
        &_character0000FFBA,
        &_character0000FFBB,
        &_character0000FFBC,
        &_character0000FFBD,
        &_character0000FFBE,
        0,
        0,
        0,
        &_character0000FFC2,
        &_character0000FFC3,
        &_character0000FFC4,
        &_character0000FFC5,
        &_character0000FFC6,
        &_character0000FFC7,
        0,
        0,
        &_character0000FFCA,
        &_character0000FFCB,
        &_character0000FFCC,
        &_character0000FFCD,
        &_character0000FFCE,
        &_character0000FFCF,
        0,
        0,
        &_character0000FFD2,
        &_character0000FFD3,
        &_character0000FFD4,
        &_character0000FFD5,
        &_character0000FFD6,
        &_character0000FFD7,
        0,
        0,
        &_character0000FFDA,
        &_character0000FFDB,
        &_character0000FFDC,
        0,
        0,
        0,
        &_character0000FFE0,
        &_character0000FFE1,
        &_character0000FFE2,
        &_character0000FFE3,
        &_character0000FFE4,
        &_character0000FFE5,
        &_character0000FFE6,
        0,
        &_character0000FFE8,
        &_character0000FFE9,
        &_character0000FFEA,
        &_character0000FFEB,
        &_character0000FFEC,
        &_character0000FFED,
        &_character0000FFEE,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0000FFF9,
        &_character0000FFFA,
        &_character0000FFFB,
        &_character0000FFFC,
        &_character0000FFFD,
        0,
        0
    };

    static _CharacterInfo * _table300010000[2048] =
    {
        &_character00010000,
        &_character00010001,
        &_character00010002,
        &_character00010003,
        &_character00010004,
        &_character00010005,
        &_character00010006,
        &_character00010007,
        &_character00010008,
        &_character00010009,
        &_character0001000A,
        &_character0001000B,
        0,
        &_character0001000D,
        &_character0001000E,
        &_character0001000F,
        &_character00010010,
        &_character00010011,
        &_character00010012,
        &_character00010013,
        &_character00010014,
        &_character00010015,
        &_character00010016,
        &_character00010017,
        &_character00010018,
        &_character00010019,
        &_character0001001A,
        &_character0001001B,
        &_character0001001C,
        &_character0001001D,
        &_character0001001E,
        &_character0001001F,
        &_character00010020,
        &_character00010021,
        &_character00010022,
        &_character00010023,
        &_character00010024,
        &_character00010025,
        &_character00010026,
        0,
        &_character00010028,
        &_character00010029,
        &_character0001002A,
        &_character0001002B,
        &_character0001002C,
        &_character0001002D,
        &_character0001002E,
        &_character0001002F,
        &_character00010030,
        &_character00010031,
        &_character00010032,
        &_character00010033,
        &_character00010034,
        &_character00010035,
        &_character00010036,
        &_character00010037,
        &_character00010038,
        &_character00010039,
        &_character0001003A,
        0,
        &_character0001003C,
        &_character0001003D,
        0,
        &_character0001003F,
        &_character00010040,
        &_character00010041,
        &_character00010042,
        &_character00010043,
        &_character00010044,
        &_character00010045,
        &_character00010046,
        &_character00010047,
        &_character00010048,
        &_character00010049,
        &_character0001004A,
        &_character0001004B,
        &_character0001004C,
        &_character0001004D,
        0,
        0,
        &_character00010050,
        &_character00010051,
        &_character00010052,
        &_character00010053,
        &_character00010054,
        &_character00010055,
        &_character00010056,
        &_character00010057,
        &_character00010058,
        &_character00010059,
        &_character0001005A,
        &_character0001005B,
        &_character0001005C,
        &_character0001005D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010080,
        &_character00010081,
        &_character00010082,
        &_character00010083,
        &_character00010084,
        &_character00010085,
        &_character00010086,
        &_character00010087,
        &_character00010088,
        &_character00010089,
        &_character0001008A,
        &_character0001008B,
        &_character0001008C,
        &_character0001008D,
        &_character0001008E,
        &_character0001008F,
        &_character00010090,
        &_character00010091,
        &_character00010092,
        &_character00010093,
        &_character00010094,
        &_character00010095,
        &_character00010096,
        &_character00010097,
        &_character00010098,
        &_character00010099,
        &_character0001009A,
        &_character0001009B,
        &_character0001009C,
        &_character0001009D,
        &_character0001009E,
        &_character0001009F,
        &_character000100A0,
        &_character000100A1,
        &_character000100A2,
        &_character000100A3,
        &_character000100A4,
        &_character000100A5,
        &_character000100A6,
        &_character000100A7,
        &_character000100A8,
        &_character000100A9,
        &_character000100AA,
        &_character000100AB,
        &_character000100AC,
        &_character000100AD,
        &_character000100AE,
        &_character000100AF,
        &_character000100B0,
        &_character000100B1,
        &_character000100B2,
        &_character000100B3,
        &_character000100B4,
        &_character000100B5,
        &_character000100B6,
        &_character000100B7,
        &_character000100B8,
        &_character000100B9,
        &_character000100BA,
        &_character000100BB,
        &_character000100BC,
        &_character000100BD,
        &_character000100BE,
        &_character000100BF,
        &_character000100C0,
        &_character000100C1,
        &_character000100C2,
        &_character000100C3,
        &_character000100C4,
        &_character000100C5,
        &_character000100C6,
        &_character000100C7,
        &_character000100C8,
        &_character000100C9,
        &_character000100CA,
        &_character000100CB,
        &_character000100CC,
        &_character000100CD,
        &_character000100CE,
        &_character000100CF,
        &_character000100D0,
        &_character000100D1,
        &_character000100D2,
        &_character000100D3,
        &_character000100D4,
        &_character000100D5,
        &_character000100D6,
        &_character000100D7,
        &_character000100D8,
        &_character000100D9,
        &_character000100DA,
        &_character000100DB,
        &_character000100DC,
        &_character000100DD,
        &_character000100DE,
        &_character000100DF,
        &_character000100E0,
        &_character000100E1,
        &_character000100E2,
        &_character000100E3,
        &_character000100E4,
        &_character000100E5,
        &_character000100E6,
        &_character000100E7,
        &_character000100E8,
        &_character000100E9,
        &_character000100EA,
        &_character000100EB,
        &_character000100EC,
        &_character000100ED,
        &_character000100EE,
        &_character000100EF,
        &_character000100F0,
        &_character000100F1,
        &_character000100F2,
        &_character000100F3,
        &_character000100F4,
        &_character000100F5,
        &_character000100F6,
        &_character000100F7,
        &_character000100F8,
        &_character000100F9,
        &_character000100FA,
        0,
        0,
        0,
        0,
        0,
        &_character00010100,
        &_character00010101,
        &_character00010102,
        0,
        0,
        0,
        0,
        &_character00010107,
        &_character00010108,
        &_character00010109,
        &_character0001010A,
        &_character0001010B,
        &_character0001010C,
        &_character0001010D,
        &_character0001010E,
        &_character0001010F,
        &_character00010110,
        &_character00010111,
        &_character00010112,
        &_character00010113,
        &_character00010114,
        &_character00010115,
        &_character00010116,
        &_character00010117,
        &_character00010118,
        &_character00010119,
        &_character0001011A,
        &_character0001011B,
        &_character0001011C,
        &_character0001011D,
        &_character0001011E,
        &_character0001011F,
        &_character00010120,
        &_character00010121,
        &_character00010122,
        &_character00010123,
        &_character00010124,
        &_character00010125,
        &_character00010126,
        &_character00010127,
        &_character00010128,
        &_character00010129,
        &_character0001012A,
        &_character0001012B,
        &_character0001012C,
        &_character0001012D,
        &_character0001012E,
        &_character0001012F,
        &_character00010130,
        &_character00010131,
        &_character00010132,
        &_character00010133,
        0,
        0,
        0,
        &_character00010137,
        &_character00010138,
        &_character00010139,
        &_character0001013A,
        &_character0001013B,
        &_character0001013C,
        &_character0001013D,
        &_character0001013E,
        &_character0001013F,
        &_character00010140,
        &_character00010141,
        &_character00010142,
        &_character00010143,
        &_character00010144,
        &_character00010145,
        &_character00010146,
        &_character00010147,
        &_character00010148,
        &_character00010149,
        &_character0001014A,
        &_character0001014B,
        &_character0001014C,
        &_character0001014D,
        &_character0001014E,
        &_character0001014F,
        &_character00010150,
        &_character00010151,
        &_character00010152,
        &_character00010153,
        &_character00010154,
        &_character00010155,
        &_character00010156,
        &_character00010157,
        &_character00010158,
        &_character00010159,
        &_character0001015A,
        &_character0001015B,
        &_character0001015C,
        &_character0001015D,
        &_character0001015E,
        &_character0001015F,
        &_character00010160,
        &_character00010161,
        &_character00010162,
        &_character00010163,
        &_character00010164,
        &_character00010165,
        &_character00010166,
        &_character00010167,
        &_character00010168,
        &_character00010169,
        &_character0001016A,
        &_character0001016B,
        &_character0001016C,
        &_character0001016D,
        &_character0001016E,
        &_character0001016F,
        &_character00010170,
        &_character00010171,
        &_character00010172,
        &_character00010173,
        &_character00010174,
        &_character00010175,
        &_character00010176,
        &_character00010177,
        &_character00010178,
        &_character00010179,
        &_character0001017A,
        &_character0001017B,
        &_character0001017C,
        &_character0001017D,
        &_character0001017E,
        &_character0001017F,
        &_character00010180,
        &_character00010181,
        &_character00010182,
        &_character00010183,
        &_character00010184,
        &_character00010185,
        &_character00010186,
        &_character00010187,
        &_character00010188,
        &_character00010189,
        &_character0001018A,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010300,
        &_character00010301,
        &_character00010302,
        &_character00010303,
        &_character00010304,
        &_character00010305,
        &_character00010306,
        &_character00010307,
        &_character00010308,
        &_character00010309,
        &_character0001030A,
        &_character0001030B,
        &_character0001030C,
        &_character0001030D,
        &_character0001030E,
        &_character0001030F,
        &_character00010310,
        &_character00010311,
        &_character00010312,
        &_character00010313,
        &_character00010314,
        &_character00010315,
        &_character00010316,
        &_character00010317,
        &_character00010318,
        &_character00010319,
        &_character0001031A,
        &_character0001031B,
        &_character0001031C,
        &_character0001031D,
        &_character0001031E,
        0,
        &_character00010320,
        &_character00010321,
        &_character00010322,
        &_character00010323,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010330,
        &_character00010331,
        &_character00010332,
        &_character00010333,
        &_character00010334,
        &_character00010335,
        &_character00010336,
        &_character00010337,
        &_character00010338,
        &_character00010339,
        &_character0001033A,
        &_character0001033B,
        &_character0001033C,
        &_character0001033D,
        &_character0001033E,
        &_character0001033F,
        &_character00010340,
        &_character00010341,
        &_character00010342,
        &_character00010343,
        &_character00010344,
        &_character00010345,
        &_character00010346,
        &_character00010347,
        &_character00010348,
        &_character00010349,
        &_character0001034A,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010380,
        &_character00010381,
        &_character00010382,
        &_character00010383,
        &_character00010384,
        &_character00010385,
        &_character00010386,
        &_character00010387,
        &_character00010388,
        &_character00010389,
        &_character0001038A,
        &_character0001038B,
        &_character0001038C,
        &_character0001038D,
        &_character0001038E,
        &_character0001038F,
        &_character00010390,
        &_character00010391,
        &_character00010392,
        &_character00010393,
        &_character00010394,
        &_character00010395,
        &_character00010396,
        &_character00010397,
        &_character00010398,
        &_character00010399,
        &_character0001039A,
        &_character0001039B,
        &_character0001039C,
        &_character0001039D,
        0,
        &_character0001039F,
        &_character000103A0,
        &_character000103A1,
        &_character000103A2,
        &_character000103A3,
        &_character000103A4,
        &_character000103A5,
        &_character000103A6,
        &_character000103A7,
        &_character000103A8,
        &_character000103A9,
        &_character000103AA,
        &_character000103AB,
        &_character000103AC,
        &_character000103AD,
        &_character000103AE,
        &_character000103AF,
        &_character000103B0,
        &_character000103B1,
        &_character000103B2,
        &_character000103B3,
        &_character000103B4,
        &_character000103B5,
        &_character000103B6,
        &_character000103B7,
        &_character000103B8,
        &_character000103B9,
        &_character000103BA,
        &_character000103BB,
        &_character000103BC,
        &_character000103BD,
        &_character000103BE,
        &_character000103BF,
        &_character000103C0,
        &_character000103C1,
        &_character000103C2,
        &_character000103C3,
        0,
        0,
        0,
        0,
        &_character000103C8,
        &_character000103C9,
        &_character000103CA,
        &_character000103CB,
        &_character000103CC,
        &_character000103CD,
        &_character000103CE,
        &_character000103CF,
        &_character000103D0,
        &_character000103D1,
        &_character000103D2,
        &_character000103D3,
        &_character000103D4,
        &_character000103D5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010400,
        &_character00010401,
        &_character00010402,
        &_character00010403,
        &_character00010404,
        &_character00010405,
        &_character00010406,
        &_character00010407,
        &_character00010408,
        &_character00010409,
        &_character0001040A,
        &_character0001040B,
        &_character0001040C,
        &_character0001040D,
        &_character0001040E,
        &_character0001040F,
        &_character00010410,
        &_character00010411,
        &_character00010412,
        &_character00010413,
        &_character00010414,
        &_character00010415,
        &_character00010416,
        &_character00010417,
        &_character00010418,
        &_character00010419,
        &_character0001041A,
        &_character0001041B,
        &_character0001041C,
        &_character0001041D,
        &_character0001041E,
        &_character0001041F,
        &_character00010420,
        &_character00010421,
        &_character00010422,
        &_character00010423,
        &_character00010424,
        &_character00010425,
        &_character00010426,
        &_character00010427,
        &_character00010428,
        &_character00010429,
        &_character0001042A,
        &_character0001042B,
        &_character0001042C,
        &_character0001042D,
        &_character0001042E,
        &_character0001042F,
        &_character00010430,
        &_character00010431,
        &_character00010432,
        &_character00010433,
        &_character00010434,
        &_character00010435,
        &_character00010436,
        &_character00010437,
        &_character00010438,
        &_character00010439,
        &_character0001043A,
        &_character0001043B,
        &_character0001043C,
        &_character0001043D,
        &_character0001043E,
        &_character0001043F,
        &_character00010440,
        &_character00010441,
        &_character00010442,
        &_character00010443,
        &_character00010444,
        &_character00010445,
        &_character00010446,
        &_character00010447,
        &_character00010448,
        &_character00010449,
        &_character0001044A,
        &_character0001044B,
        &_character0001044C,
        &_character0001044D,
        &_character0001044E,
        &_character0001044F,
        &_character00010450,
        &_character00010451,
        &_character00010452,
        &_character00010453,
        &_character00010454,
        &_character00010455,
        &_character00010456,
        &_character00010457,
        &_character00010458,
        &_character00010459,
        &_character0001045A,
        &_character0001045B,
        &_character0001045C,
        &_character0001045D,
        &_character0001045E,
        &_character0001045F,
        &_character00010460,
        &_character00010461,
        &_character00010462,
        &_character00010463,
        &_character00010464,
        &_character00010465,
        &_character00010466,
        &_character00010467,
        &_character00010468,
        &_character00010469,
        &_character0001046A,
        &_character0001046B,
        &_character0001046C,
        &_character0001046D,
        &_character0001046E,
        &_character0001046F,
        &_character00010470,
        &_character00010471,
        &_character00010472,
        &_character00010473,
        &_character00010474,
        &_character00010475,
        &_character00010476,
        &_character00010477,
        &_character00010478,
        &_character00010479,
        &_character0001047A,
        &_character0001047B,
        &_character0001047C,
        &_character0001047D,
        &_character0001047E,
        &_character0001047F,
        &_character00010480,
        &_character00010481,
        &_character00010482,
        &_character00010483,
        &_character00010484,
        &_character00010485,
        &_character00010486,
        &_character00010487,
        &_character00010488,
        &_character00010489,
        &_character0001048A,
        &_character0001048B,
        &_character0001048C,
        &_character0001048D,
        &_character0001048E,
        &_character0001048F,
        &_character00010490,
        &_character00010491,
        &_character00010492,
        &_character00010493,
        &_character00010494,
        &_character00010495,
        &_character00010496,
        &_character00010497,
        &_character00010498,
        &_character00010499,
        &_character0001049A,
        &_character0001049B,
        &_character0001049C,
        &_character0001049D,
        0,
        0,
        &_character000104A0,
        &_character000104A1,
        &_character000104A2,
        &_character000104A3,
        &_character000104A4,
        &_character000104A5,
        &_character000104A6,
        &_character000104A7,
        &_character000104A8,
        &_character000104A9,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300010800[2048] =
    {
        &_character00010800,
        &_character00010801,
        &_character00010802,
        &_character00010803,
        &_character00010804,
        &_character00010805,
        0,
        0,
        &_character00010808,
        0,
        &_character0001080A,
        &_character0001080B,
        &_character0001080C,
        &_character0001080D,
        &_character0001080E,
        &_character0001080F,
        &_character00010810,
        &_character00010811,
        &_character00010812,
        &_character00010813,
        &_character00010814,
        &_character00010815,
        &_character00010816,
        &_character00010817,
        &_character00010818,
        &_character00010819,
        &_character0001081A,
        &_character0001081B,
        &_character0001081C,
        &_character0001081D,
        &_character0001081E,
        &_character0001081F,
        &_character00010820,
        &_character00010821,
        &_character00010822,
        &_character00010823,
        &_character00010824,
        &_character00010825,
        &_character00010826,
        &_character00010827,
        &_character00010828,
        &_character00010829,
        &_character0001082A,
        &_character0001082B,
        &_character0001082C,
        &_character0001082D,
        &_character0001082E,
        &_character0001082F,
        &_character00010830,
        &_character00010831,
        &_character00010832,
        &_character00010833,
        &_character00010834,
        &_character00010835,
        0,
        &_character00010837,
        &_character00010838,
        0,
        0,
        0,
        &_character0001083C,
        0,
        0,
        &_character0001083F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010900,
        &_character00010901,
        &_character00010902,
        &_character00010903,
        &_character00010904,
        &_character00010905,
        &_character00010906,
        &_character00010907,
        &_character00010908,
        &_character00010909,
        &_character0001090A,
        &_character0001090B,
        &_character0001090C,
        &_character0001090D,
        &_character0001090E,
        &_character0001090F,
        &_character00010910,
        &_character00010911,
        &_character00010912,
        &_character00010913,
        &_character00010914,
        &_character00010915,
        &_character00010916,
        &_character00010917,
        &_character00010918,
        &_character00010919,
        0,
        0,
        0,
        0,
        0,
        &_character0001091F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010A00,
        &_character00010A01,
        &_character00010A02,
        &_character00010A03,
        0,
        &_character00010A05,
        &_character00010A06,
        0,
        0,
        0,
        0,
        0,
        &_character00010A0C,
        &_character00010A0D,
        &_character00010A0E,
        &_character00010A0F,
        &_character00010A10,
        &_character00010A11,
        &_character00010A12,
        &_character00010A13,
        0,
        &_character00010A15,
        &_character00010A16,
        &_character00010A17,
        0,
        &_character00010A19,
        &_character00010A1A,
        &_character00010A1B,
        &_character00010A1C,
        &_character00010A1D,
        &_character00010A1E,
        &_character00010A1F,
        &_character00010A20,
        &_character00010A21,
        &_character00010A22,
        &_character00010A23,
        &_character00010A24,
        &_character00010A25,
        &_character00010A26,
        &_character00010A27,
        &_character00010A28,
        &_character00010A29,
        &_character00010A2A,
        &_character00010A2B,
        &_character00010A2C,
        &_character00010A2D,
        &_character00010A2E,
        &_character00010A2F,
        &_character00010A30,
        &_character00010A31,
        &_character00010A32,
        &_character00010A33,
        0,
        0,
        0,
        0,
        &_character00010A38,
        &_character00010A39,
        &_character00010A3A,
        0,
        0,
        0,
        0,
        &_character00010A3F,
        &_character00010A40,
        &_character00010A41,
        &_character00010A42,
        &_character00010A43,
        &_character00010A44,
        &_character00010A45,
        &_character00010A46,
        &_character00010A47,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00010A50,
        &_character00010A51,
        &_character00010A52,
        &_character00010A53,
        &_character00010A54,
        &_character00010A55,
        &_character00010A56,
        &_character00010A57,
        &_character00010A58,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table300012000[2048] =
    {
        &_character00012000,
        &_character00012001,
        &_character00012002,
        &_character00012003,
        &_character00012004,
        &_character00012005,
        &_character00012006,
        &_character00012007,
        &_character00012008,
        &_character00012009,
        &_character0001200A,
        &_character0001200B,
        &_character0001200C,
        &_character0001200D,
        &_character0001200E,
        &_character0001200F,
        &_character00012010,
        &_character00012011,
        &_character00012012,
        &_character00012013,
        &_character00012014,
        &_character00012015,
        &_character00012016,
        &_character00012017,
        &_character00012018,
        &_character00012019,
        &_character0001201A,
        &_character0001201B,
        &_character0001201C,
        &_character0001201D,
        &_character0001201E,
        &_character0001201F,
        &_character00012020,
        &_character00012021,
        &_character00012022,
        &_character00012023,
        &_character00012024,
        &_character00012025,
        &_character00012026,
        &_character00012027,
        &_character00012028,
        &_character00012029,
        &_character0001202A,
        &_character0001202B,
        &_character0001202C,
        &_character0001202D,
        &_character0001202E,
        &_character0001202F,
        &_character00012030,
        &_character00012031,
        &_character00012032,
        &_character00012033,
        &_character00012034,
        &_character00012035,
        &_character00012036,
        &_character00012037,
        &_character00012038,
        &_character00012039,
        &_character0001203A,
        &_character0001203B,
        &_character0001203C,
        &_character0001203D,
        &_character0001203E,
        &_character0001203F,
        &_character00012040,
        &_character00012041,
        &_character00012042,
        &_character00012043,
        &_character00012044,
        &_character00012045,
        &_character00012046,
        &_character00012047,
        &_character00012048,
        &_character00012049,
        &_character0001204A,
        &_character0001204B,
        &_character0001204C,
        &_character0001204D,
        &_character0001204E,
        &_character0001204F,
        &_character00012050,
        &_character00012051,
        &_character00012052,
        &_character00012053,
        &_character00012054,
        &_character00012055,
        &_character00012056,
        &_character00012057,
        &_character00012058,
        &_character00012059,
        &_character0001205A,
        &_character0001205B,
        &_character0001205C,
        &_character0001205D,
        &_character0001205E,
        &_character0001205F,
        &_character00012060,
        &_character00012061,
        &_character00012062,
        &_character00012063,
        &_character00012064,
        &_character00012065,
        &_character00012066,
        &_character00012067,
        &_character00012068,
        &_character00012069,
        &_character0001206A,
        &_character0001206B,
        &_character0001206C,
        &_character0001206D,
        &_character0001206E,
        &_character0001206F,
        &_character00012070,
        &_character00012071,
        &_character00012072,
        &_character00012073,
        &_character00012074,
        &_character00012075,
        &_character00012076,
        &_character00012077,
        &_character00012078,
        &_character00012079,
        &_character0001207A,
        &_character0001207B,
        &_character0001207C,
        &_character0001207D,
        &_character0001207E,
        &_character0001207F,
        &_character00012080,
        &_character00012081,
        &_character00012082,
        &_character00012083,
        &_character00012084,
        &_character00012085,
        &_character00012086,
        &_character00012087,
        &_character00012088,
        &_character00012089,
        &_character0001208A,
        &_character0001208B,
        &_character0001208C,
        &_character0001208D,
        &_character0001208E,
        &_character0001208F,
        &_character00012090,
        &_character00012091,
        &_character00012092,
        &_character00012093,
        &_character00012094,
        &_character00012095,
        &_character00012096,
        &_character00012097,
        &_character00012098,
        &_character00012099,
        &_character0001209A,
        &_character0001209B,
        &_character0001209C,
        &_character0001209D,
        &_character0001209E,
        &_character0001209F,
        &_character000120A0,
        &_character000120A1,
        &_character000120A2,
        &_character000120A3,
        &_character000120A4,
        &_character000120A5,
        &_character000120A6,
        &_character000120A7,
        &_character000120A8,
        &_character000120A9,
        &_character000120AA,
        &_character000120AB,
        &_character000120AC,
        &_character000120AD,
        &_character000120AE,
        &_character000120AF,
        &_character000120B0,
        &_character000120B1,
        &_character000120B2,
        &_character000120B3,
        &_character000120B4,
        &_character000120B5,
        &_character000120B6,
        &_character000120B7,
        &_character000120B8,
        &_character000120B9,
        &_character000120BA,
        &_character000120BB,
        &_character000120BC,
        &_character000120BD,
        &_character000120BE,
        &_character000120BF,
        &_character000120C0,
        &_character000120C1,
        &_character000120C2,
        &_character000120C3,
        &_character000120C4,
        &_character000120C5,
        &_character000120C6,
        &_character000120C7,
        &_character000120C8,
        &_character000120C9,
        &_character000120CA,
        &_character000120CB,
        &_character000120CC,
        &_character000120CD,
        &_character000120CE,
        &_character000120CF,
        &_character000120D0,
        &_character000120D1,
        &_character000120D2,
        &_character000120D3,
        &_character000120D4,
        &_character000120D5,
        &_character000120D6,
        &_character000120D7,
        &_character000120D8,
        &_character000120D9,
        &_character000120DA,
        &_character000120DB,
        &_character000120DC,
        &_character000120DD,
        &_character000120DE,
        &_character000120DF,
        &_character000120E0,
        &_character000120E1,
        &_character000120E2,
        &_character000120E3,
        &_character000120E4,
        &_character000120E5,
        &_character000120E6,
        &_character000120E7,
        &_character000120E8,
        &_character000120E9,
        &_character000120EA,
        &_character000120EB,
        &_character000120EC,
        &_character000120ED,
        &_character000120EE,
        &_character000120EF,
        &_character000120F0,
        &_character000120F1,
        &_character000120F2,
        &_character000120F3,
        &_character000120F4,
        &_character000120F5,
        &_character000120F6,
        &_character000120F7,
        &_character000120F8,
        &_character000120F9,
        &_character000120FA,
        &_character000120FB,
        &_character000120FC,
        &_character000120FD,
        &_character000120FE,
        &_character000120FF,
        &_character00012100,
        &_character00012101,
        &_character00012102,
        &_character00012103,
        &_character00012104,
        &_character00012105,
        &_character00012106,
        &_character00012107,
        &_character00012108,
        &_character00012109,
        &_character0001210A,
        &_character0001210B,
        &_character0001210C,
        &_character0001210D,
        &_character0001210E,
        &_character0001210F,
        &_character00012110,
        &_character00012111,
        &_character00012112,
        &_character00012113,
        &_character00012114,
        &_character00012115,
        &_character00012116,
        &_character00012117,
        &_character00012118,
        &_character00012119,
        &_character0001211A,
        &_character0001211B,
        &_character0001211C,
        &_character0001211D,
        &_character0001211E,
        &_character0001211F,
        &_character00012120,
        &_character00012121,
        &_character00012122,
        &_character00012123,
        &_character00012124,
        &_character00012125,
        &_character00012126,
        &_character00012127,
        &_character00012128,
        &_character00012129,
        &_character0001212A,
        &_character0001212B,
        &_character0001212C,
        &_character0001212D,
        &_character0001212E,
        &_character0001212F,
        &_character00012130,
        &_character00012131,
        &_character00012132,
        &_character00012133,
        &_character00012134,
        &_character00012135,
        &_character00012136,
        &_character00012137,
        &_character00012138,
        &_character00012139,
        &_character0001213A,
        &_character0001213B,
        &_character0001213C,
        &_character0001213D,
        &_character0001213E,
        &_character0001213F,
        &_character00012140,
        &_character00012141,
        &_character00012142,
        &_character00012143,
        &_character00012144,
        &_character00012145,
        &_character00012146,
        &_character00012147,
        &_character00012148,
        &_character00012149,
        &_character0001214A,
        &_character0001214B,
        &_character0001214C,
        &_character0001214D,
        &_character0001214E,
        &_character0001214F,
        &_character00012150,
        &_character00012151,
        &_character00012152,
        &_character00012153,
        &_character00012154,
        &_character00012155,
        &_character00012156,
        &_character00012157,
        &_character00012158,
        &_character00012159,
        &_character0001215A,
        &_character0001215B,
        &_character0001215C,
        &_character0001215D,
        &_character0001215E,
        &_character0001215F,
        &_character00012160,
        &_character00012161,
        &_character00012162,
        &_character00012163,
        &_character00012164,
        &_character00012165,
        &_character00012166,
        &_character00012167,
        &_character00012168,
        &_character00012169,
        &_character0001216A,
        &_character0001216B,
        &_character0001216C,
        &_character0001216D,
        &_character0001216E,
        &_character0001216F,
        &_character00012170,
        &_character00012171,
        &_character00012172,
        &_character00012173,
        &_character00012174,
        &_character00012175,
        &_character00012176,
        &_character00012177,
        &_character00012178,
        &_character00012179,
        &_character0001217A,
        &_character0001217B,
        &_character0001217C,
        &_character0001217D,
        &_character0001217E,
        &_character0001217F,
        &_character00012180,
        &_character00012181,
        &_character00012182,
        &_character00012183,
        &_character00012184,
        &_character00012185,
        &_character00012186,
        &_character00012187,
        &_character00012188,
        &_character00012189,
        &_character0001218A,
        &_character0001218B,
        &_character0001218C,
        &_character0001218D,
        &_character0001218E,
        &_character0001218F,
        &_character00012190,
        &_character00012191,
        &_character00012192,
        &_character00012193,
        &_character00012194,
        &_character00012195,
        &_character00012196,
        &_character00012197,
        &_character00012198,
        &_character00012199,
        &_character0001219A,
        &_character0001219B,
        &_character0001219C,
        &_character0001219D,
        &_character0001219E,
        &_character0001219F,
        &_character000121A0,
        &_character000121A1,
        &_character000121A2,
        &_character000121A3,
        &_character000121A4,
        &_character000121A5,
        &_character000121A6,
        &_character000121A7,
        &_character000121A8,
        &_character000121A9,
        &_character000121AA,
        &_character000121AB,
        &_character000121AC,
        &_character000121AD,
        &_character000121AE,
        &_character000121AF,
        &_character000121B0,
        &_character000121B1,
        &_character000121B2,
        &_character000121B3,
        &_character000121B4,
        &_character000121B5,
        &_character000121B6,
        &_character000121B7,
        &_character000121B8,
        &_character000121B9,
        &_character000121BA,
        &_character000121BB,
        &_character000121BC,
        &_character000121BD,
        &_character000121BE,
        &_character000121BF,
        &_character000121C0,
        &_character000121C1,
        &_character000121C2,
        &_character000121C3,
        &_character000121C4,
        &_character000121C5,
        &_character000121C6,
        &_character000121C7,
        &_character000121C8,
        &_character000121C9,
        &_character000121CA,
        &_character000121CB,
        &_character000121CC,
        &_character000121CD,
        &_character000121CE,
        &_character000121CF,
        &_character000121D0,
        &_character000121D1,
        &_character000121D2,
        &_character000121D3,
        &_character000121D4,
        &_character000121D5,
        &_character000121D6,
        &_character000121D7,
        &_character000121D8,
        &_character000121D9,
        &_character000121DA,
        &_character000121DB,
        &_character000121DC,
        &_character000121DD,
        &_character000121DE,
        &_character000121DF,
        &_character000121E0,
        &_character000121E1,
        &_character000121E2,
        &_character000121E3,
        &_character000121E4,
        &_character000121E5,
        &_character000121E6,
        &_character000121E7,
        &_character000121E8,
        &_character000121E9,
        &_character000121EA,
        &_character000121EB,
        &_character000121EC,
        &_character000121ED,
        &_character000121EE,
        &_character000121EF,
        &_character000121F0,
        &_character000121F1,
        &_character000121F2,
        &_character000121F3,
        &_character000121F4,
        &_character000121F5,
        &_character000121F6,
        &_character000121F7,
        &_character000121F8,
        &_character000121F9,
        &_character000121FA,
        &_character000121FB,
        &_character000121FC,
        &_character000121FD,
        &_character000121FE,
        &_character000121FF,
        &_character00012200,
        &_character00012201,
        &_character00012202,
        &_character00012203,
        &_character00012204,
        &_character00012205,
        &_character00012206,
        &_character00012207,
        &_character00012208,
        &_character00012209,
        &_character0001220A,
        &_character0001220B,
        &_character0001220C,
        &_character0001220D,
        &_character0001220E,
        &_character0001220F,
        &_character00012210,
        &_character00012211,
        &_character00012212,
        &_character00012213,
        &_character00012214,
        &_character00012215,
        &_character00012216,
        &_character00012217,
        &_character00012218,
        &_character00012219,
        &_character0001221A,
        &_character0001221B,
        &_character0001221C,
        &_character0001221D,
        &_character0001221E,
        &_character0001221F,
        &_character00012220,
        &_character00012221,
        &_character00012222,
        &_character00012223,
        &_character00012224,
        &_character00012225,
        &_character00012226,
        &_character00012227,
        &_character00012228,
        &_character00012229,
        &_character0001222A,
        &_character0001222B,
        &_character0001222C,
        &_character0001222D,
        &_character0001222E,
        &_character0001222F,
        &_character00012230,
        &_character00012231,
        &_character00012232,
        &_character00012233,
        &_character00012234,
        &_character00012235,
        &_character00012236,
        &_character00012237,
        &_character00012238,
        &_character00012239,
        &_character0001223A,
        &_character0001223B,
        &_character0001223C,
        &_character0001223D,
        &_character0001223E,
        &_character0001223F,
        &_character00012240,
        &_character00012241,
        &_character00012242,
        &_character00012243,
        &_character00012244,
        &_character00012245,
        &_character00012246,
        &_character00012247,
        &_character00012248,
        &_character00012249,
        &_character0001224A,
        &_character0001224B,
        &_character0001224C,
        &_character0001224D,
        &_character0001224E,
        &_character0001224F,
        &_character00012250,
        &_character00012251,
        &_character00012252,
        &_character00012253,
        &_character00012254,
        &_character00012255,
        &_character00012256,
        &_character00012257,
        &_character00012258,
        &_character00012259,
        &_character0001225A,
        &_character0001225B,
        &_character0001225C,
        &_character0001225D,
        &_character0001225E,
        &_character0001225F,
        &_character00012260,
        &_character00012261,
        &_character00012262,
        &_character00012263,
        &_character00012264,
        &_character00012265,
        &_character00012266,
        &_character00012267,
        &_character00012268,
        &_character00012269,
        &_character0001226A,
        &_character0001226B,
        &_character0001226C,
        &_character0001226D,
        &_character0001226E,
        &_character0001226F,
        &_character00012270,
        &_character00012271,
        &_character00012272,
        &_character00012273,
        &_character00012274,
        &_character00012275,
        &_character00012276,
        &_character00012277,
        &_character00012278,
        &_character00012279,
        &_character0001227A,
        &_character0001227B,
        &_character0001227C,
        &_character0001227D,
        &_character0001227E,
        &_character0001227F,
        &_character00012280,
        &_character00012281,
        &_character00012282,
        &_character00012283,
        &_character00012284,
        &_character00012285,
        &_character00012286,
        &_character00012287,
        &_character00012288,
        &_character00012289,
        &_character0001228A,
        &_character0001228B,
        &_character0001228C,
        &_character0001228D,
        &_character0001228E,
        &_character0001228F,
        &_character00012290,
        &_character00012291,
        &_character00012292,
        &_character00012293,
        &_character00012294,
        &_character00012295,
        &_character00012296,
        &_character00012297,
        &_character00012298,
        &_character00012299,
        &_character0001229A,
        &_character0001229B,
        &_character0001229C,
        &_character0001229D,
        &_character0001229E,
        &_character0001229F,
        &_character000122A0,
        &_character000122A1,
        &_character000122A2,
        &_character000122A3,
        &_character000122A4,
        &_character000122A5,
        &_character000122A6,
        &_character000122A7,
        &_character000122A8,
        &_character000122A9,
        &_character000122AA,
        &_character000122AB,
        &_character000122AC,
        &_character000122AD,
        &_character000122AE,
        &_character000122AF,
        &_character000122B0,
        &_character000122B1,
        &_character000122B2,
        &_character000122B3,
        &_character000122B4,
        &_character000122B5,
        &_character000122B6,
        &_character000122B7,
        &_character000122B8,
        &_character000122B9,
        &_character000122BA,
        &_character000122BB,
        &_character000122BC,
        &_character000122BD,
        &_character000122BE,
        &_character000122BF,
        &_character000122C0,
        &_character000122C1,
        &_character000122C2,
        &_character000122C3,
        &_character000122C4,
        &_character000122C5,
        &_character000122C6,
        &_character000122C7,
        &_character000122C8,
        &_character000122C9,
        &_character000122CA,
        &_character000122CB,
        &_character000122CC,
        &_character000122CD,
        &_character000122CE,
        &_character000122CF,
        &_character000122D0,
        &_character000122D1,
        &_character000122D2,
        &_character000122D3,
        &_character000122D4,
        &_character000122D5,
        &_character000122D6,
        &_character000122D7,
        &_character000122D8,
        &_character000122D9,
        &_character000122DA,
        &_character000122DB,
        &_character000122DC,
        &_character000122DD,
        &_character000122DE,
        &_character000122DF,
        &_character000122E0,
        &_character000122E1,
        &_character000122E2,
        &_character000122E3,
        &_character000122E4,
        &_character000122E5,
        &_character000122E6,
        &_character000122E7,
        &_character000122E8,
        &_character000122E9,
        &_character000122EA,
        &_character000122EB,
        &_character000122EC,
        &_character000122ED,
        &_character000122EE,
        &_character000122EF,
        &_character000122F0,
        &_character000122F1,
        &_character000122F2,
        &_character000122F3,
        &_character000122F4,
        &_character000122F5,
        &_character000122F6,
        &_character000122F7,
        &_character000122F8,
        &_character000122F9,
        &_character000122FA,
        &_character000122FB,
        &_character000122FC,
        &_character000122FD,
        &_character000122FE,
        &_character000122FF,
        &_character00012300,
        &_character00012301,
        &_character00012302,
        &_character00012303,
        &_character00012304,
        &_character00012305,
        &_character00012306,
        &_character00012307,
        &_character00012308,
        &_character00012309,
        &_character0001230A,
        &_character0001230B,
        &_character0001230C,
        &_character0001230D,
        &_character0001230E,
        &_character0001230F,
        &_character00012310,
        &_character00012311,
        &_character00012312,
        &_character00012313,
        &_character00012314,
        &_character00012315,
        &_character00012316,
        &_character00012317,
        &_character00012318,
        &_character00012319,
        &_character0001231A,
        &_character0001231B,
        &_character0001231C,
        &_character0001231D,
        &_character0001231E,
        &_character0001231F,
        &_character00012320,
        &_character00012321,
        &_character00012322,
        &_character00012323,
        &_character00012324,
        &_character00012325,
        &_character00012326,
        &_character00012327,
        &_character00012328,
        &_character00012329,
        &_character0001232A,
        &_character0001232B,
        &_character0001232C,
        &_character0001232D,
        &_character0001232E,
        &_character0001232F,
        &_character00012330,
        &_character00012331,
        &_character00012332,
        &_character00012333,
        &_character00012334,
        &_character00012335,
        &_character00012336,
        &_character00012337,
        &_character00012338,
        &_character00012339,
        &_character0001233A,
        &_character0001233B,
        &_character0001233C,
        &_character0001233D,
        &_character0001233E,
        &_character0001233F,
        &_character00012340,
        &_character00012341,
        &_character00012342,
        &_character00012343,
        &_character00012344,
        &_character00012345,
        &_character00012346,
        &_character00012347,
        &_character00012348,
        &_character00012349,
        &_character0001234A,
        &_character0001234B,
        &_character0001234C,
        &_character0001234D,
        &_character0001234E,
        &_character0001234F,
        &_character00012350,
        &_character00012351,
        &_character00012352,
        &_character00012353,
        &_character00012354,
        &_character00012355,
        &_character00012356,
        &_character00012357,
        &_character00012358,
        &_character00012359,
        &_character0001235A,
        &_character0001235B,
        &_character0001235C,
        &_character0001235D,
        &_character0001235E,
        &_character0001235F,
        &_character00012360,
        &_character00012361,
        &_character00012362,
        &_character00012363,
        &_character00012364,
        &_character00012365,
        &_character00012366,
        &_character00012367,
        &_character00012368,
        &_character00012369,
        &_character0001236A,
        &_character0001236B,
        &_character0001236C,
        &_character0001236D,
        &_character0001236E,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00012400,
        &_character00012401,
        &_character00012402,
        &_character00012403,
        &_character00012404,
        &_character00012405,
        &_character00012406,
        &_character00012407,
        &_character00012408,
        &_character00012409,
        &_character0001240A,
        &_character0001240B,
        &_character0001240C,
        &_character0001240D,
        &_character0001240E,
        &_character0001240F,
        &_character00012410,
        &_character00012411,
        &_character00012412,
        &_character00012413,
        &_character00012414,
        &_character00012415,
        &_character00012416,
        &_character00012417,
        &_character00012418,
        &_character00012419,
        &_character0001241A,
        &_character0001241B,
        &_character0001241C,
        &_character0001241D,
        &_character0001241E,
        &_character0001241F,
        &_character00012420,
        &_character00012421,
        &_character00012422,
        &_character00012423,
        &_character00012424,
        &_character00012425,
        &_character00012426,
        &_character00012427,
        &_character00012428,
        &_character00012429,
        &_character0001242A,
        &_character0001242B,
        &_character0001242C,
        &_character0001242D,
        &_character0001242E,
        &_character0001242F,
        &_character00012430,
        &_character00012431,
        &_character00012432,
        &_character00012433,
        &_character00012434,
        &_character00012435,
        &_character00012436,
        &_character00012437,
        &_character00012438,
        &_character00012439,
        &_character0001243A,
        &_character0001243B,
        &_character0001243C,
        &_character0001243D,
        &_character0001243E,
        &_character0001243F,
        &_character00012440,
        &_character00012441,
        &_character00012442,
        &_character00012443,
        &_character00012444,
        &_character00012445,
        &_character00012446,
        &_character00012447,
        &_character00012448,
        &_character00012449,
        &_character0001244A,
        &_character0001244B,
        &_character0001244C,
        &_character0001244D,
        &_character0001244E,
        &_character0001244F,
        &_character00012450,
        &_character00012451,
        &_character00012452,
        &_character00012453,
        &_character00012454,
        &_character00012455,
        &_character00012456,
        &_character00012457,
        &_character00012458,
        &_character00012459,
        &_character0001245A,
        &_character0001245B,
        &_character0001245C,
        &_character0001245D,
        &_character0001245E,
        &_character0001245F,
        &_character00012460,
        &_character00012461,
        &_character00012462,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character00012470,
        &_character00012471,
        &_character00012472,
        &_character00012473,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30001D000[2048] =
    {
        &_character0001D000,
        &_character0001D001,
        &_character0001D002,
        &_character0001D003,
        &_character0001D004,
        &_character0001D005,
        &_character0001D006,
        &_character0001D007,
        &_character0001D008,
        &_character0001D009,
        &_character0001D00A,
        &_character0001D00B,
        &_character0001D00C,
        &_character0001D00D,
        &_character0001D00E,
        &_character0001D00F,
        &_character0001D010,
        &_character0001D011,
        &_character0001D012,
        &_character0001D013,
        &_character0001D014,
        &_character0001D015,
        &_character0001D016,
        &_character0001D017,
        &_character0001D018,
        &_character0001D019,
        &_character0001D01A,
        &_character0001D01B,
        &_character0001D01C,
        &_character0001D01D,
        &_character0001D01E,
        &_character0001D01F,
        &_character0001D020,
        &_character0001D021,
        &_character0001D022,
        &_character0001D023,
        &_character0001D024,
        &_character0001D025,
        &_character0001D026,
        &_character0001D027,
        &_character0001D028,
        &_character0001D029,
        &_character0001D02A,
        &_character0001D02B,
        &_character0001D02C,
        &_character0001D02D,
        &_character0001D02E,
        &_character0001D02F,
        &_character0001D030,
        &_character0001D031,
        &_character0001D032,
        &_character0001D033,
        &_character0001D034,
        &_character0001D035,
        &_character0001D036,
        &_character0001D037,
        &_character0001D038,
        &_character0001D039,
        &_character0001D03A,
        &_character0001D03B,
        &_character0001D03C,
        &_character0001D03D,
        &_character0001D03E,
        &_character0001D03F,
        &_character0001D040,
        &_character0001D041,
        &_character0001D042,
        &_character0001D043,
        &_character0001D044,
        &_character0001D045,
        &_character0001D046,
        &_character0001D047,
        &_character0001D048,
        &_character0001D049,
        &_character0001D04A,
        &_character0001D04B,
        &_character0001D04C,
        &_character0001D04D,
        &_character0001D04E,
        &_character0001D04F,
        &_character0001D050,
        &_character0001D051,
        &_character0001D052,
        &_character0001D053,
        &_character0001D054,
        &_character0001D055,
        &_character0001D056,
        &_character0001D057,
        &_character0001D058,
        &_character0001D059,
        &_character0001D05A,
        &_character0001D05B,
        &_character0001D05C,
        &_character0001D05D,
        &_character0001D05E,
        &_character0001D05F,
        &_character0001D060,
        &_character0001D061,
        &_character0001D062,
        &_character0001D063,
        &_character0001D064,
        &_character0001D065,
        &_character0001D066,
        &_character0001D067,
        &_character0001D068,
        &_character0001D069,
        &_character0001D06A,
        &_character0001D06B,
        &_character0001D06C,
        &_character0001D06D,
        &_character0001D06E,
        &_character0001D06F,
        &_character0001D070,
        &_character0001D071,
        &_character0001D072,
        &_character0001D073,
        &_character0001D074,
        &_character0001D075,
        &_character0001D076,
        &_character0001D077,
        &_character0001D078,
        &_character0001D079,
        &_character0001D07A,
        &_character0001D07B,
        &_character0001D07C,
        &_character0001D07D,
        &_character0001D07E,
        &_character0001D07F,
        &_character0001D080,
        &_character0001D081,
        &_character0001D082,
        &_character0001D083,
        &_character0001D084,
        &_character0001D085,
        &_character0001D086,
        &_character0001D087,
        &_character0001D088,
        &_character0001D089,
        &_character0001D08A,
        &_character0001D08B,
        &_character0001D08C,
        &_character0001D08D,
        &_character0001D08E,
        &_character0001D08F,
        &_character0001D090,
        &_character0001D091,
        &_character0001D092,
        &_character0001D093,
        &_character0001D094,
        &_character0001D095,
        &_character0001D096,
        &_character0001D097,
        &_character0001D098,
        &_character0001D099,
        &_character0001D09A,
        &_character0001D09B,
        &_character0001D09C,
        &_character0001D09D,
        &_character0001D09E,
        &_character0001D09F,
        &_character0001D0A0,
        &_character0001D0A1,
        &_character0001D0A2,
        &_character0001D0A3,
        &_character0001D0A4,
        &_character0001D0A5,
        &_character0001D0A6,
        &_character0001D0A7,
        &_character0001D0A8,
        &_character0001D0A9,
        &_character0001D0AA,
        &_character0001D0AB,
        &_character0001D0AC,
        &_character0001D0AD,
        &_character0001D0AE,
        &_character0001D0AF,
        &_character0001D0B0,
        &_character0001D0B1,
        &_character0001D0B2,
        &_character0001D0B3,
        &_character0001D0B4,
        &_character0001D0B5,
        &_character0001D0B6,
        &_character0001D0B7,
        &_character0001D0B8,
        &_character0001D0B9,
        &_character0001D0BA,
        &_character0001D0BB,
        &_character0001D0BC,
        &_character0001D0BD,
        &_character0001D0BE,
        &_character0001D0BF,
        &_character0001D0C0,
        &_character0001D0C1,
        &_character0001D0C2,
        &_character0001D0C3,
        &_character0001D0C4,
        &_character0001D0C5,
        &_character0001D0C6,
        &_character0001D0C7,
        &_character0001D0C8,
        &_character0001D0C9,
        &_character0001D0CA,
        &_character0001D0CB,
        &_character0001D0CC,
        &_character0001D0CD,
        &_character0001D0CE,
        &_character0001D0CF,
        &_character0001D0D0,
        &_character0001D0D1,
        &_character0001D0D2,
        &_character0001D0D3,
        &_character0001D0D4,
        &_character0001D0D5,
        &_character0001D0D6,
        &_character0001D0D7,
        &_character0001D0D8,
        &_character0001D0D9,
        &_character0001D0DA,
        &_character0001D0DB,
        &_character0001D0DC,
        &_character0001D0DD,
        &_character0001D0DE,
        &_character0001D0DF,
        &_character0001D0E0,
        &_character0001D0E1,
        &_character0001D0E2,
        &_character0001D0E3,
        &_character0001D0E4,
        &_character0001D0E5,
        &_character0001D0E6,
        &_character0001D0E7,
        &_character0001D0E8,
        &_character0001D0E9,
        &_character0001D0EA,
        &_character0001D0EB,
        &_character0001D0EC,
        &_character0001D0ED,
        &_character0001D0EE,
        &_character0001D0EF,
        &_character0001D0F0,
        &_character0001D0F1,
        &_character0001D0F2,
        &_character0001D0F3,
        &_character0001D0F4,
        &_character0001D0F5,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0001D100,
        &_character0001D101,
        &_character0001D102,
        &_character0001D103,
        &_character0001D104,
        &_character0001D105,
        &_character0001D106,
        &_character0001D107,
        &_character0001D108,
        &_character0001D109,
        &_character0001D10A,
        &_character0001D10B,
        &_character0001D10C,
        &_character0001D10D,
        &_character0001D10E,
        &_character0001D10F,
        &_character0001D110,
        &_character0001D111,
        &_character0001D112,
        &_character0001D113,
        &_character0001D114,
        &_character0001D115,
        &_character0001D116,
        &_character0001D117,
        &_character0001D118,
        &_character0001D119,
        &_character0001D11A,
        &_character0001D11B,
        &_character0001D11C,
        &_character0001D11D,
        &_character0001D11E,
        &_character0001D11F,
        &_character0001D120,
        &_character0001D121,
        &_character0001D122,
        &_character0001D123,
        &_character0001D124,
        &_character0001D125,
        &_character0001D126,
        0,
        0,
        0,
        &_character0001D12A,
        &_character0001D12B,
        &_character0001D12C,
        &_character0001D12D,
        &_character0001D12E,
        &_character0001D12F,
        &_character0001D130,
        &_character0001D131,
        &_character0001D132,
        &_character0001D133,
        &_character0001D134,
        &_character0001D135,
        &_character0001D136,
        &_character0001D137,
        &_character0001D138,
        &_character0001D139,
        &_character0001D13A,
        &_character0001D13B,
        &_character0001D13C,
        &_character0001D13D,
        &_character0001D13E,
        &_character0001D13F,
        &_character0001D140,
        &_character0001D141,
        &_character0001D142,
        &_character0001D143,
        &_character0001D144,
        &_character0001D145,
        &_character0001D146,
        &_character0001D147,
        &_character0001D148,
        &_character0001D149,
        &_character0001D14A,
        &_character0001D14B,
        &_character0001D14C,
        &_character0001D14D,
        &_character0001D14E,
        &_character0001D14F,
        &_character0001D150,
        &_character0001D151,
        &_character0001D152,
        &_character0001D153,
        &_character0001D154,
        &_character0001D155,
        &_character0001D156,
        &_character0001D157,
        &_character0001D158,
        &_character0001D159,
        &_character0001D15A,
        &_character0001D15B,
        &_character0001D15C,
        &_character0001D15D,
        &_character0001D15E,
        &_character0001D15F,
        &_character0001D160,
        &_character0001D161,
        &_character0001D162,
        &_character0001D163,
        &_character0001D164,
        &_character0001D165,
        &_character0001D166,
        &_character0001D167,
        &_character0001D168,
        &_character0001D169,
        &_character0001D16A,
        &_character0001D16B,
        &_character0001D16C,
        &_character0001D16D,
        &_character0001D16E,
        &_character0001D16F,
        &_character0001D170,
        &_character0001D171,
        &_character0001D172,
        &_character0001D173,
        &_character0001D174,
        &_character0001D175,
        &_character0001D176,
        &_character0001D177,
        &_character0001D178,
        &_character0001D179,
        &_character0001D17A,
        &_character0001D17B,
        &_character0001D17C,
        &_character0001D17D,
        &_character0001D17E,
        &_character0001D17F,
        &_character0001D180,
        &_character0001D181,
        &_character0001D182,
        &_character0001D183,
        &_character0001D184,
        &_character0001D185,
        &_character0001D186,
        &_character0001D187,
        &_character0001D188,
        &_character0001D189,
        &_character0001D18A,
        &_character0001D18B,
        &_character0001D18C,
        &_character0001D18D,
        &_character0001D18E,
        &_character0001D18F,
        &_character0001D190,
        &_character0001D191,
        &_character0001D192,
        &_character0001D193,
        &_character0001D194,
        &_character0001D195,
        &_character0001D196,
        &_character0001D197,
        &_character0001D198,
        &_character0001D199,
        &_character0001D19A,
        &_character0001D19B,
        &_character0001D19C,
        &_character0001D19D,
        &_character0001D19E,
        &_character0001D19F,
        &_character0001D1A0,
        &_character0001D1A1,
        &_character0001D1A2,
        &_character0001D1A3,
        &_character0001D1A4,
        &_character0001D1A5,
        &_character0001D1A6,
        &_character0001D1A7,
        &_character0001D1A8,
        &_character0001D1A9,
        &_character0001D1AA,
        &_character0001D1AB,
        &_character0001D1AC,
        &_character0001D1AD,
        &_character0001D1AE,
        &_character0001D1AF,
        &_character0001D1B0,
        &_character0001D1B1,
        &_character0001D1B2,
        &_character0001D1B3,
        &_character0001D1B4,
        &_character0001D1B5,
        &_character0001D1B6,
        &_character0001D1B7,
        &_character0001D1B8,
        &_character0001D1B9,
        &_character0001D1BA,
        &_character0001D1BB,
        &_character0001D1BC,
        &_character0001D1BD,
        &_character0001D1BE,
        &_character0001D1BF,
        &_character0001D1C0,
        &_character0001D1C1,
        &_character0001D1C2,
        &_character0001D1C3,
        &_character0001D1C4,
        &_character0001D1C5,
        &_character0001D1C6,
        &_character0001D1C7,
        &_character0001D1C8,
        &_character0001D1C9,
        &_character0001D1CA,
        &_character0001D1CB,
        &_character0001D1CC,
        &_character0001D1CD,
        &_character0001D1CE,
        &_character0001D1CF,
        &_character0001D1D0,
        &_character0001D1D1,
        &_character0001D1D2,
        &_character0001D1D3,
        &_character0001D1D4,
        &_character0001D1D5,
        &_character0001D1D6,
        &_character0001D1D7,
        &_character0001D1D8,
        &_character0001D1D9,
        &_character0001D1DA,
        &_character0001D1DB,
        &_character0001D1DC,
        &_character0001D1DD,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0001D200,
        &_character0001D201,
        &_character0001D202,
        &_character0001D203,
        &_character0001D204,
        &_character0001D205,
        &_character0001D206,
        &_character0001D207,
        &_character0001D208,
        &_character0001D209,
        &_character0001D20A,
        &_character0001D20B,
        &_character0001D20C,
        &_character0001D20D,
        &_character0001D20E,
        &_character0001D20F,
        &_character0001D210,
        &_character0001D211,
        &_character0001D212,
        &_character0001D213,
        &_character0001D214,
        &_character0001D215,
        &_character0001D216,
        &_character0001D217,
        &_character0001D218,
        &_character0001D219,
        &_character0001D21A,
        &_character0001D21B,
        &_character0001D21C,
        &_character0001D21D,
        &_character0001D21E,
        &_character0001D21F,
        &_character0001D220,
        &_character0001D221,
        &_character0001D222,
        &_character0001D223,
        &_character0001D224,
        &_character0001D225,
        &_character0001D226,
        &_character0001D227,
        &_character0001D228,
        &_character0001D229,
        &_character0001D22A,
        &_character0001D22B,
        &_character0001D22C,
        &_character0001D22D,
        &_character0001D22E,
        &_character0001D22F,
        &_character0001D230,
        &_character0001D231,
        &_character0001D232,
        &_character0001D233,
        &_character0001D234,
        &_character0001D235,
        &_character0001D236,
        &_character0001D237,
        &_character0001D238,
        &_character0001D239,
        &_character0001D23A,
        &_character0001D23B,
        &_character0001D23C,
        &_character0001D23D,
        &_character0001D23E,
        &_character0001D23F,
        &_character0001D240,
        &_character0001D241,
        &_character0001D242,
        &_character0001D243,
        &_character0001D244,
        &_character0001D245,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0001D300,
        &_character0001D301,
        &_character0001D302,
        &_character0001D303,
        &_character0001D304,
        &_character0001D305,
        &_character0001D306,
        &_character0001D307,
        &_character0001D308,
        &_character0001D309,
        &_character0001D30A,
        &_character0001D30B,
        &_character0001D30C,
        &_character0001D30D,
        &_character0001D30E,
        &_character0001D30F,
        &_character0001D310,
        &_character0001D311,
        &_character0001D312,
        &_character0001D313,
        &_character0001D314,
        &_character0001D315,
        &_character0001D316,
        &_character0001D317,
        &_character0001D318,
        &_character0001D319,
        &_character0001D31A,
        &_character0001D31B,
        &_character0001D31C,
        &_character0001D31D,
        &_character0001D31E,
        &_character0001D31F,
        &_character0001D320,
        &_character0001D321,
        &_character0001D322,
        &_character0001D323,
        &_character0001D324,
        &_character0001D325,
        &_character0001D326,
        &_character0001D327,
        &_character0001D328,
        &_character0001D329,
        &_character0001D32A,
        &_character0001D32B,
        &_character0001D32C,
        &_character0001D32D,
        &_character0001D32E,
        &_character0001D32F,
        &_character0001D330,
        &_character0001D331,
        &_character0001D332,
        &_character0001D333,
        &_character0001D334,
        &_character0001D335,
        &_character0001D336,
        &_character0001D337,
        &_character0001D338,
        &_character0001D339,
        &_character0001D33A,
        &_character0001D33B,
        &_character0001D33C,
        &_character0001D33D,
        &_character0001D33E,
        &_character0001D33F,
        &_character0001D340,
        &_character0001D341,
        &_character0001D342,
        &_character0001D343,
        &_character0001D344,
        &_character0001D345,
        &_character0001D346,
        &_character0001D347,
        &_character0001D348,
        &_character0001D349,
        &_character0001D34A,
        &_character0001D34B,
        &_character0001D34C,
        &_character0001D34D,
        &_character0001D34E,
        &_character0001D34F,
        &_character0001D350,
        &_character0001D351,
        &_character0001D352,
        &_character0001D353,
        &_character0001D354,
        &_character0001D355,
        &_character0001D356,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0001D360,
        &_character0001D361,
        &_character0001D362,
        &_character0001D363,
        &_character0001D364,
        &_character0001D365,
        &_character0001D366,
        &_character0001D367,
        &_character0001D368,
        &_character0001D369,
        &_character0001D36A,
        &_character0001D36B,
        &_character0001D36C,
        &_character0001D36D,
        &_character0001D36E,
        &_character0001D36F,
        &_character0001D370,
        &_character0001D371,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0001D400,
        &_character0001D401,
        &_character0001D402,
        &_character0001D403,
        &_character0001D404,
        &_character0001D405,
        &_character0001D406,
        &_character0001D407,
        &_character0001D408,
        &_character0001D409,
        &_character0001D40A,
        &_character0001D40B,
        &_character0001D40C,
        &_character0001D40D,
        &_character0001D40E,
        &_character0001D40F,
        &_character0001D410,
        &_character0001D411,
        &_character0001D412,
        &_character0001D413,
        &_character0001D414,
        &_character0001D415,
        &_character0001D416,
        &_character0001D417,
        &_character0001D418,
        &_character0001D419,
        &_character0001D41A,
        &_character0001D41B,
        &_character0001D41C,
        &_character0001D41D,
        &_character0001D41E,
        &_character0001D41F,
        &_character0001D420,
        &_character0001D421,
        &_character0001D422,
        &_character0001D423,
        &_character0001D424,
        &_character0001D425,
        &_character0001D426,
        &_character0001D427,
        &_character0001D428,
        &_character0001D429,
        &_character0001D42A,
        &_character0001D42B,
        &_character0001D42C,
        &_character0001D42D,
        &_character0001D42E,
        &_character0001D42F,
        &_character0001D430,
        &_character0001D431,
        &_character0001D432,
        &_character0001D433,
        &_character0001D434,
        &_character0001D435,
        &_character0001D436,
        &_character0001D437,
        &_character0001D438,
        &_character0001D439,
        &_character0001D43A,
        &_character0001D43B,
        &_character0001D43C,
        &_character0001D43D,
        &_character0001D43E,
        &_character0001D43F,
        &_character0001D440,
        &_character0001D441,
        &_character0001D442,
        &_character0001D443,
        &_character0001D444,
        &_character0001D445,
        &_character0001D446,
        &_character0001D447,
        &_character0001D448,
        &_character0001D449,
        &_character0001D44A,
        &_character0001D44B,
        &_character0001D44C,
        &_character0001D44D,
        &_character0001D44E,
        &_character0001D44F,
        &_character0001D450,
        &_character0001D451,
        &_character0001D452,
        &_character0001D453,
        &_character0001D454,
        0,
        &_character0001D456,
        &_character0001D457,
        &_character0001D458,
        &_character0001D459,
        &_character0001D45A,
        &_character0001D45B,
        &_character0001D45C,
        &_character0001D45D,
        &_character0001D45E,
        &_character0001D45F,
        &_character0001D460,
        &_character0001D461,
        &_character0001D462,
        &_character0001D463,
        &_character0001D464,
        &_character0001D465,
        &_character0001D466,
        &_character0001D467,
        &_character0001D468,
        &_character0001D469,
        &_character0001D46A,
        &_character0001D46B,
        &_character0001D46C,
        &_character0001D46D,
        &_character0001D46E,
        &_character0001D46F,
        &_character0001D470,
        &_character0001D471,
        &_character0001D472,
        &_character0001D473,
        &_character0001D474,
        &_character0001D475,
        &_character0001D476,
        &_character0001D477,
        &_character0001D478,
        &_character0001D479,
        &_character0001D47A,
        &_character0001D47B,
        &_character0001D47C,
        &_character0001D47D,
        &_character0001D47E,
        &_character0001D47F,
        &_character0001D480,
        &_character0001D481,
        &_character0001D482,
        &_character0001D483,
        &_character0001D484,
        &_character0001D485,
        &_character0001D486,
        &_character0001D487,
        &_character0001D488,
        &_character0001D489,
        &_character0001D48A,
        &_character0001D48B,
        &_character0001D48C,
        &_character0001D48D,
        &_character0001D48E,
        &_character0001D48F,
        &_character0001D490,
        &_character0001D491,
        &_character0001D492,
        &_character0001D493,
        &_character0001D494,
        &_character0001D495,
        &_character0001D496,
        &_character0001D497,
        &_character0001D498,
        &_character0001D499,
        &_character0001D49A,
        &_character0001D49B,
        &_character0001D49C,
        0,
        &_character0001D49E,
        &_character0001D49F,
        0,
        0,
        &_character0001D4A2,
        0,
        0,
        &_character0001D4A5,
        &_character0001D4A6,
        0,
        0,
        &_character0001D4A9,
        &_character0001D4AA,
        &_character0001D4AB,
        &_character0001D4AC,
        0,
        &_character0001D4AE,
        &_character0001D4AF,
        &_character0001D4B0,
        &_character0001D4B1,
        &_character0001D4B2,
        &_character0001D4B3,
        &_character0001D4B4,
        &_character0001D4B5,
        &_character0001D4B6,
        &_character0001D4B7,
        &_character0001D4B8,
        &_character0001D4B9,
        0,
        &_character0001D4BB,
        0,
        &_character0001D4BD,
        &_character0001D4BE,
        &_character0001D4BF,
        &_character0001D4C0,
        &_character0001D4C1,
        &_character0001D4C2,
        &_character0001D4C3,
        0,
        &_character0001D4C5,
        &_character0001D4C6,
        &_character0001D4C7,
        &_character0001D4C8,
        &_character0001D4C9,
        &_character0001D4CA,
        &_character0001D4CB,
        &_character0001D4CC,
        &_character0001D4CD,
        &_character0001D4CE,
        &_character0001D4CF,
        &_character0001D4D0,
        &_character0001D4D1,
        &_character0001D4D2,
        &_character0001D4D3,
        &_character0001D4D4,
        &_character0001D4D5,
        &_character0001D4D6,
        &_character0001D4D7,
        &_character0001D4D8,
        &_character0001D4D9,
        &_character0001D4DA,
        &_character0001D4DB,
        &_character0001D4DC,
        &_character0001D4DD,
        &_character0001D4DE,
        &_character0001D4DF,
        &_character0001D4E0,
        &_character0001D4E1,
        &_character0001D4E2,
        &_character0001D4E3,
        &_character0001D4E4,
        &_character0001D4E5,
        &_character0001D4E6,
        &_character0001D4E7,
        &_character0001D4E8,
        &_character0001D4E9,
        &_character0001D4EA,
        &_character0001D4EB,
        &_character0001D4EC,
        &_character0001D4ED,
        &_character0001D4EE,
        &_character0001D4EF,
        &_character0001D4F0,
        &_character0001D4F1,
        &_character0001D4F2,
        &_character0001D4F3,
        &_character0001D4F4,
        &_character0001D4F5,
        &_character0001D4F6,
        &_character0001D4F7,
        &_character0001D4F8,
        &_character0001D4F9,
        &_character0001D4FA,
        &_character0001D4FB,
        &_character0001D4FC,
        &_character0001D4FD,
        &_character0001D4FE,
        &_character0001D4FF,
        &_character0001D500,
        &_character0001D501,
        &_character0001D502,
        &_character0001D503,
        &_character0001D504,
        &_character0001D505,
        0,
        &_character0001D507,
        &_character0001D508,
        &_character0001D509,
        &_character0001D50A,
        0,
        0,
        &_character0001D50D,
        &_character0001D50E,
        &_character0001D50F,
        &_character0001D510,
        &_character0001D511,
        &_character0001D512,
        &_character0001D513,
        &_character0001D514,
        0,
        &_character0001D516,
        &_character0001D517,
        &_character0001D518,
        &_character0001D519,
        &_character0001D51A,
        &_character0001D51B,
        &_character0001D51C,
        0,
        &_character0001D51E,
        &_character0001D51F,
        &_character0001D520,
        &_character0001D521,
        &_character0001D522,
        &_character0001D523,
        &_character0001D524,
        &_character0001D525,
        &_character0001D526,
        &_character0001D527,
        &_character0001D528,
        &_character0001D529,
        &_character0001D52A,
        &_character0001D52B,
        &_character0001D52C,
        &_character0001D52D,
        &_character0001D52E,
        &_character0001D52F,
        &_character0001D530,
        &_character0001D531,
        &_character0001D532,
        &_character0001D533,
        &_character0001D534,
        &_character0001D535,
        &_character0001D536,
        &_character0001D537,
        &_character0001D538,
        &_character0001D539,
        0,
        &_character0001D53B,
        &_character0001D53C,
        &_character0001D53D,
        &_character0001D53E,
        0,
        &_character0001D540,
        &_character0001D541,
        &_character0001D542,
        &_character0001D543,
        &_character0001D544,
        0,
        &_character0001D546,
        0,
        0,
        0,
        &_character0001D54A,
        &_character0001D54B,
        &_character0001D54C,
        &_character0001D54D,
        &_character0001D54E,
        &_character0001D54F,
        &_character0001D550,
        0,
        &_character0001D552,
        &_character0001D553,
        &_character0001D554,
        &_character0001D555,
        &_character0001D556,
        &_character0001D557,
        &_character0001D558,
        &_character0001D559,
        &_character0001D55A,
        &_character0001D55B,
        &_character0001D55C,
        &_character0001D55D,
        &_character0001D55E,
        &_character0001D55F,
        &_character0001D560,
        &_character0001D561,
        &_character0001D562,
        &_character0001D563,
        &_character0001D564,
        &_character0001D565,
        &_character0001D566,
        &_character0001D567,
        &_character0001D568,
        &_character0001D569,
        &_character0001D56A,
        &_character0001D56B,
        &_character0001D56C,
        &_character0001D56D,
        &_character0001D56E,
        &_character0001D56F,
        &_character0001D570,
        &_character0001D571,
        &_character0001D572,
        &_character0001D573,
        &_character0001D574,
        &_character0001D575,
        &_character0001D576,
        &_character0001D577,
        &_character0001D578,
        &_character0001D579,
        &_character0001D57A,
        &_character0001D57B,
        &_character0001D57C,
        &_character0001D57D,
        &_character0001D57E,
        &_character0001D57F,
        &_character0001D580,
        &_character0001D581,
        &_character0001D582,
        &_character0001D583,
        &_character0001D584,
        &_character0001D585,
        &_character0001D586,
        &_character0001D587,
        &_character0001D588,
        &_character0001D589,
        &_character0001D58A,
        &_character0001D58B,
        &_character0001D58C,
        &_character0001D58D,
        &_character0001D58E,
        &_character0001D58F,
        &_character0001D590,
        &_character0001D591,
        &_character0001D592,
        &_character0001D593,
        &_character0001D594,
        &_character0001D595,
        &_character0001D596,
        &_character0001D597,
        &_character0001D598,
        &_character0001D599,
        &_character0001D59A,
        &_character0001D59B,
        &_character0001D59C,
        &_character0001D59D,
        &_character0001D59E,
        &_character0001D59F,
        &_character0001D5A0,
        &_character0001D5A1,
        &_character0001D5A2,
        &_character0001D5A3,
        &_character0001D5A4,
        &_character0001D5A5,
        &_character0001D5A6,
        &_character0001D5A7,
        &_character0001D5A8,
        &_character0001D5A9,
        &_character0001D5AA,
        &_character0001D5AB,
        &_character0001D5AC,
        &_character0001D5AD,
        &_character0001D5AE,
        &_character0001D5AF,
        &_character0001D5B0,
        &_character0001D5B1,
        &_character0001D5B2,
        &_character0001D5B3,
        &_character0001D5B4,
        &_character0001D5B5,
        &_character0001D5B6,
        &_character0001D5B7,
        &_character0001D5B8,
        &_character0001D5B9,
        &_character0001D5BA,
        &_character0001D5BB,
        &_character0001D5BC,
        &_character0001D5BD,
        &_character0001D5BE,
        &_character0001D5BF,
        &_character0001D5C0,
        &_character0001D5C1,
        &_character0001D5C2,
        &_character0001D5C3,
        &_character0001D5C4,
        &_character0001D5C5,
        &_character0001D5C6,
        &_character0001D5C7,
        &_character0001D5C8,
        &_character0001D5C9,
        &_character0001D5CA,
        &_character0001D5CB,
        &_character0001D5CC,
        &_character0001D5CD,
        &_character0001D5CE,
        &_character0001D5CF,
        &_character0001D5D0,
        &_character0001D5D1,
        &_character0001D5D2,
        &_character0001D5D3,
        &_character0001D5D4,
        &_character0001D5D5,
        &_character0001D5D6,
        &_character0001D5D7,
        &_character0001D5D8,
        &_character0001D5D9,
        &_character0001D5DA,
        &_character0001D5DB,
        &_character0001D5DC,
        &_character0001D5DD,
        &_character0001D5DE,
        &_character0001D5DF,
        &_character0001D5E0,
        &_character0001D5E1,
        &_character0001D5E2,
        &_character0001D5E3,
        &_character0001D5E4,
        &_character0001D5E5,
        &_character0001D5E6,
        &_character0001D5E7,
        &_character0001D5E8,
        &_character0001D5E9,
        &_character0001D5EA,
        &_character0001D5EB,
        &_character0001D5EC,
        &_character0001D5ED,
        &_character0001D5EE,
        &_character0001D5EF,
        &_character0001D5F0,
        &_character0001D5F1,
        &_character0001D5F2,
        &_character0001D5F3,
        &_character0001D5F4,
        &_character0001D5F5,
        &_character0001D5F6,
        &_character0001D5F7,
        &_character0001D5F8,
        &_character0001D5F9,
        &_character0001D5FA,
        &_character0001D5FB,
        &_character0001D5FC,
        &_character0001D5FD,
        &_character0001D5FE,
        &_character0001D5FF,
        &_character0001D600,
        &_character0001D601,
        &_character0001D602,
        &_character0001D603,
        &_character0001D604,
        &_character0001D605,
        &_character0001D606,
        &_character0001D607,
        &_character0001D608,
        &_character0001D609,
        &_character0001D60A,
        &_character0001D60B,
        &_character0001D60C,
        &_character0001D60D,
        &_character0001D60E,
        &_character0001D60F,
        &_character0001D610,
        &_character0001D611,
        &_character0001D612,
        &_character0001D613,
        &_character0001D614,
        &_character0001D615,
        &_character0001D616,
        &_character0001D617,
        &_character0001D618,
        &_character0001D619,
        &_character0001D61A,
        &_character0001D61B,
        &_character0001D61C,
        &_character0001D61D,
        &_character0001D61E,
        &_character0001D61F,
        &_character0001D620,
        &_character0001D621,
        &_character0001D622,
        &_character0001D623,
        &_character0001D624,
        &_character0001D625,
        &_character0001D626,
        &_character0001D627,
        &_character0001D628,
        &_character0001D629,
        &_character0001D62A,
        &_character0001D62B,
        &_character0001D62C,
        &_character0001D62D,
        &_character0001D62E,
        &_character0001D62F,
        &_character0001D630,
        &_character0001D631,
        &_character0001D632,
        &_character0001D633,
        &_character0001D634,
        &_character0001D635,
        &_character0001D636,
        &_character0001D637,
        &_character0001D638,
        &_character0001D639,
        &_character0001D63A,
        &_character0001D63B,
        &_character0001D63C,
        &_character0001D63D,
        &_character0001D63E,
        &_character0001D63F,
        &_character0001D640,
        &_character0001D641,
        &_character0001D642,
        &_character0001D643,
        &_character0001D644,
        &_character0001D645,
        &_character0001D646,
        &_character0001D647,
        &_character0001D648,
        &_character0001D649,
        &_character0001D64A,
        &_character0001D64B,
        &_character0001D64C,
        &_character0001D64D,
        &_character0001D64E,
        &_character0001D64F,
        &_character0001D650,
        &_character0001D651,
        &_character0001D652,
        &_character0001D653,
        &_character0001D654,
        &_character0001D655,
        &_character0001D656,
        &_character0001D657,
        &_character0001D658,
        &_character0001D659,
        &_character0001D65A,
        &_character0001D65B,
        &_character0001D65C,
        &_character0001D65D,
        &_character0001D65E,
        &_character0001D65F,
        &_character0001D660,
        &_character0001D661,
        &_character0001D662,
        &_character0001D663,
        &_character0001D664,
        &_character0001D665,
        &_character0001D666,
        &_character0001D667,
        &_character0001D668,
        &_character0001D669,
        &_character0001D66A,
        &_character0001D66B,
        &_character0001D66C,
        &_character0001D66D,
        &_character0001D66E,
        &_character0001D66F,
        &_character0001D670,
        &_character0001D671,
        &_character0001D672,
        &_character0001D673,
        &_character0001D674,
        &_character0001D675,
        &_character0001D676,
        &_character0001D677,
        &_character0001D678,
        &_character0001D679,
        &_character0001D67A,
        &_character0001D67B,
        &_character0001D67C,
        &_character0001D67D,
        &_character0001D67E,
        &_character0001D67F,
        &_character0001D680,
        &_character0001D681,
        &_character0001D682,
        &_character0001D683,
        &_character0001D684,
        &_character0001D685,
        &_character0001D686,
        &_character0001D687,
        &_character0001D688,
        &_character0001D689,
        &_character0001D68A,
        &_character0001D68B,
        &_character0001D68C,
        &_character0001D68D,
        &_character0001D68E,
        &_character0001D68F,
        &_character0001D690,
        &_character0001D691,
        &_character0001D692,
        &_character0001D693,
        &_character0001D694,
        &_character0001D695,
        &_character0001D696,
        &_character0001D697,
        &_character0001D698,
        &_character0001D699,
        &_character0001D69A,
        &_character0001D69B,
        &_character0001D69C,
        &_character0001D69D,
        &_character0001D69E,
        &_character0001D69F,
        &_character0001D6A0,
        &_character0001D6A1,
        &_character0001D6A2,
        &_character0001D6A3,
        &_character0001D6A4,
        &_character0001D6A5,
        0,
        0,
        &_character0001D6A8,
        &_character0001D6A9,
        &_character0001D6AA,
        &_character0001D6AB,
        &_character0001D6AC,
        &_character0001D6AD,
        &_character0001D6AE,
        &_character0001D6AF,
        &_character0001D6B0,
        &_character0001D6B1,
        &_character0001D6B2,
        &_character0001D6B3,
        &_character0001D6B4,
        &_character0001D6B5,
        &_character0001D6B6,
        &_character0001D6B7,
        &_character0001D6B8,
        &_character0001D6B9,
        &_character0001D6BA,
        &_character0001D6BB,
        &_character0001D6BC,
        &_character0001D6BD,
        &_character0001D6BE,
        &_character0001D6BF,
        &_character0001D6C0,
        &_character0001D6C1,
        &_character0001D6C2,
        &_character0001D6C3,
        &_character0001D6C4,
        &_character0001D6C5,
        &_character0001D6C6,
        &_character0001D6C7,
        &_character0001D6C8,
        &_character0001D6C9,
        &_character0001D6CA,
        &_character0001D6CB,
        &_character0001D6CC,
        &_character0001D6CD,
        &_character0001D6CE,
        &_character0001D6CF,
        &_character0001D6D0,
        &_character0001D6D1,
        &_character0001D6D2,
        &_character0001D6D3,
        &_character0001D6D4,
        &_character0001D6D5,
        &_character0001D6D6,
        &_character0001D6D7,
        &_character0001D6D8,
        &_character0001D6D9,
        &_character0001D6DA,
        &_character0001D6DB,
        &_character0001D6DC,
        &_character0001D6DD,
        &_character0001D6DE,
        &_character0001D6DF,
        &_character0001D6E0,
        &_character0001D6E1,
        &_character0001D6E2,
        &_character0001D6E3,
        &_character0001D6E4,
        &_character0001D6E5,
        &_character0001D6E6,
        &_character0001D6E7,
        &_character0001D6E8,
        &_character0001D6E9,
        &_character0001D6EA,
        &_character0001D6EB,
        &_character0001D6EC,
        &_character0001D6ED,
        &_character0001D6EE,
        &_character0001D6EF,
        &_character0001D6F0,
        &_character0001D6F1,
        &_character0001D6F2,
        &_character0001D6F3,
        &_character0001D6F4,
        &_character0001D6F5,
        &_character0001D6F6,
        &_character0001D6F7,
        &_character0001D6F8,
        &_character0001D6F9,
        &_character0001D6FA,
        &_character0001D6FB,
        &_character0001D6FC,
        &_character0001D6FD,
        &_character0001D6FE,
        &_character0001D6FF,
        &_character0001D700,
        &_character0001D701,
        &_character0001D702,
        &_character0001D703,
        &_character0001D704,
        &_character0001D705,
        &_character0001D706,
        &_character0001D707,
        &_character0001D708,
        &_character0001D709,
        &_character0001D70A,
        &_character0001D70B,
        &_character0001D70C,
        &_character0001D70D,
        &_character0001D70E,
        &_character0001D70F,
        &_character0001D710,
        &_character0001D711,
        &_character0001D712,
        &_character0001D713,
        &_character0001D714,
        &_character0001D715,
        &_character0001D716,
        &_character0001D717,
        &_character0001D718,
        &_character0001D719,
        &_character0001D71A,
        &_character0001D71B,
        &_character0001D71C,
        &_character0001D71D,
        &_character0001D71E,
        &_character0001D71F,
        &_character0001D720,
        &_character0001D721,
        &_character0001D722,
        &_character0001D723,
        &_character0001D724,
        &_character0001D725,
        &_character0001D726,
        &_character0001D727,
        &_character0001D728,
        &_character0001D729,
        &_character0001D72A,
        &_character0001D72B,
        &_character0001D72C,
        &_character0001D72D,
        &_character0001D72E,
        &_character0001D72F,
        &_character0001D730,
        &_character0001D731,
        &_character0001D732,
        &_character0001D733,
        &_character0001D734,
        &_character0001D735,
        &_character0001D736,
        &_character0001D737,
        &_character0001D738,
        &_character0001D739,
        &_character0001D73A,
        &_character0001D73B,
        &_character0001D73C,
        &_character0001D73D,
        &_character0001D73E,
        &_character0001D73F,
        &_character0001D740,
        &_character0001D741,
        &_character0001D742,
        &_character0001D743,
        &_character0001D744,
        &_character0001D745,
        &_character0001D746,
        &_character0001D747,
        &_character0001D748,
        &_character0001D749,
        &_character0001D74A,
        &_character0001D74B,
        &_character0001D74C,
        &_character0001D74D,
        &_character0001D74E,
        &_character0001D74F,
        &_character0001D750,
        &_character0001D751,
        &_character0001D752,
        &_character0001D753,
        &_character0001D754,
        &_character0001D755,
        &_character0001D756,
        &_character0001D757,
        &_character0001D758,
        &_character0001D759,
        &_character0001D75A,
        &_character0001D75B,
        &_character0001D75C,
        &_character0001D75D,
        &_character0001D75E,
        &_character0001D75F,
        &_character0001D760,
        &_character0001D761,
        &_character0001D762,
        &_character0001D763,
        &_character0001D764,
        &_character0001D765,
        &_character0001D766,
        &_character0001D767,
        &_character0001D768,
        &_character0001D769,
        &_character0001D76A,
        &_character0001D76B,
        &_character0001D76C,
        &_character0001D76D,
        &_character0001D76E,
        &_character0001D76F,
        &_character0001D770,
        &_character0001D771,
        &_character0001D772,
        &_character0001D773,
        &_character0001D774,
        &_character0001D775,
        &_character0001D776,
        &_character0001D777,
        &_character0001D778,
        &_character0001D779,
        &_character0001D77A,
        &_character0001D77B,
        &_character0001D77C,
        &_character0001D77D,
        &_character0001D77E,
        &_character0001D77F,
        &_character0001D780,
        &_character0001D781,
        &_character0001D782,
        &_character0001D783,
        &_character0001D784,
        &_character0001D785,
        &_character0001D786,
        &_character0001D787,
        &_character0001D788,
        &_character0001D789,
        &_character0001D78A,
        &_character0001D78B,
        &_character0001D78C,
        &_character0001D78D,
        &_character0001D78E,
        &_character0001D78F,
        &_character0001D790,
        &_character0001D791,
        &_character0001D792,
        &_character0001D793,
        &_character0001D794,
        &_character0001D795,
        &_character0001D796,
        &_character0001D797,
        &_character0001D798,
        &_character0001D799,
        &_character0001D79A,
        &_character0001D79B,
        &_character0001D79C,
        &_character0001D79D,
        &_character0001D79E,
        &_character0001D79F,
        &_character0001D7A0,
        &_character0001D7A1,
        &_character0001D7A2,
        &_character0001D7A3,
        &_character0001D7A4,
        &_character0001D7A5,
        &_character0001D7A6,
        &_character0001D7A7,
        &_character0001D7A8,
        &_character0001D7A9,
        &_character0001D7AA,
        &_character0001D7AB,
        &_character0001D7AC,
        &_character0001D7AD,
        &_character0001D7AE,
        &_character0001D7AF,
        &_character0001D7B0,
        &_character0001D7B1,
        &_character0001D7B2,
        &_character0001D7B3,
        &_character0001D7B4,
        &_character0001D7B5,
        &_character0001D7B6,
        &_character0001D7B7,
        &_character0001D7B8,
        &_character0001D7B9,
        &_character0001D7BA,
        &_character0001D7BB,
        &_character0001D7BC,
        &_character0001D7BD,
        &_character0001D7BE,
        &_character0001D7BF,
        &_character0001D7C0,
        &_character0001D7C1,
        &_character0001D7C2,
        &_character0001D7C3,
        &_character0001D7C4,
        &_character0001D7C5,
        &_character0001D7C6,
        &_character0001D7C7,
        &_character0001D7C8,
        &_character0001D7C9,
        &_character0001D7CA,
        &_character0001D7CB,
        0,
        0,
        &_character0001D7CE,
        &_character0001D7CF,
        &_character0001D7D0,
        &_character0001D7D1,
        &_character0001D7D2,
        &_character0001D7D3,
        &_character0001D7D4,
        &_character0001D7D5,
        &_character0001D7D6,
        &_character0001D7D7,
        &_character0001D7D8,
        &_character0001D7D9,
        &_character0001D7DA,
        &_character0001D7DB,
        &_character0001D7DC,
        &_character0001D7DD,
        &_character0001D7DE,
        &_character0001D7DF,
        &_character0001D7E0,
        &_character0001D7E1,
        &_character0001D7E2,
        &_character0001D7E3,
        &_character0001D7E4,
        &_character0001D7E5,
        &_character0001D7E6,
        &_character0001D7E7,
        &_character0001D7E8,
        &_character0001D7E9,
        &_character0001D7EA,
        &_character0001D7EB,
        &_character0001D7EC,
        &_character0001D7ED,
        &_character0001D7EE,
        &_character0001D7EF,
        &_character0001D7F0,
        &_character0001D7F1,
        &_character0001D7F2,
        &_character0001D7F3,
        &_character0001D7F4,
        &_character0001D7F5,
        &_character0001D7F6,
        &_character0001D7F7,
        &_character0001D7F8,
        &_character0001D7F9,
        &_character0001D7FA,
        &_character0001D7FB,
        &_character0001D7FC,
        &_character0001D7FD,
        &_character0001D7FE,
        &_character0001D7FF
    };

    static _CharacterInfo * _table300020000[2048] =
    {
        &_character00020000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30002A000[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0002A6D6,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30002F800[2048] =
    {
        &_character0002F800,
        &_character0002F801,
        &_character0002F802,
        &_character0002F803,
        &_character0002F804,
        &_character0002F805,
        &_character0002F806,
        &_character0002F807,
        &_character0002F808,
        &_character0002F809,
        &_character0002F80A,
        &_character0002F80B,
        &_character0002F80C,
        &_character0002F80D,
        &_character0002F80E,
        &_character0002F80F,
        &_character0002F810,
        &_character0002F811,
        &_character0002F812,
        &_character0002F813,
        &_character0002F814,
        &_character0002F815,
        &_character0002F816,
        &_character0002F817,
        &_character0002F818,
        &_character0002F819,
        &_character0002F81A,
        &_character0002F81B,
        &_character0002F81C,
        &_character0002F81D,
        &_character0002F81E,
        &_character0002F81F,
        &_character0002F820,
        &_character0002F821,
        &_character0002F822,
        &_character0002F823,
        &_character0002F824,
        &_character0002F825,
        &_character0002F826,
        &_character0002F827,
        &_character0002F828,
        &_character0002F829,
        &_character0002F82A,
        &_character0002F82B,
        &_character0002F82C,
        &_character0002F82D,
        &_character0002F82E,
        &_character0002F82F,
        &_character0002F830,
        &_character0002F831,
        &_character0002F832,
        &_character0002F833,
        &_character0002F834,
        &_character0002F835,
        &_character0002F836,
        &_character0002F837,
        &_character0002F838,
        &_character0002F839,
        &_character0002F83A,
        &_character0002F83B,
        &_character0002F83C,
        &_character0002F83D,
        &_character0002F83E,
        &_character0002F83F,
        &_character0002F840,
        &_character0002F841,
        &_character0002F842,
        &_character0002F843,
        &_character0002F844,
        &_character0002F845,
        &_character0002F846,
        &_character0002F847,
        &_character0002F848,
        &_character0002F849,
        &_character0002F84A,
        &_character0002F84B,
        &_character0002F84C,
        &_character0002F84D,
        &_character0002F84E,
        &_character0002F84F,
        &_character0002F850,
        &_character0002F851,
        &_character0002F852,
        &_character0002F853,
        &_character0002F854,
        &_character0002F855,
        &_character0002F856,
        &_character0002F857,
        &_character0002F858,
        &_character0002F859,
        &_character0002F85A,
        &_character0002F85B,
        &_character0002F85C,
        &_character0002F85D,
        &_character0002F85E,
        &_character0002F85F,
        &_character0002F860,
        &_character0002F861,
        &_character0002F862,
        &_character0002F863,
        &_character0002F864,
        &_character0002F865,
        &_character0002F866,
        &_character0002F867,
        &_character0002F868,
        &_character0002F869,
        &_character0002F86A,
        &_character0002F86B,
        &_character0002F86C,
        &_character0002F86D,
        &_character0002F86E,
        &_character0002F86F,
        &_character0002F870,
        &_character0002F871,
        &_character0002F872,
        &_character0002F873,
        &_character0002F874,
        &_character0002F875,
        &_character0002F876,
        &_character0002F877,
        &_character0002F878,
        &_character0002F879,
        &_character0002F87A,
        &_character0002F87B,
        &_character0002F87C,
        &_character0002F87D,
        &_character0002F87E,
        &_character0002F87F,
        &_character0002F880,
        &_character0002F881,
        &_character0002F882,
        &_character0002F883,
        &_character0002F884,
        &_character0002F885,
        &_character0002F886,
        &_character0002F887,
        &_character0002F888,
        &_character0002F889,
        &_character0002F88A,
        &_character0002F88B,
        &_character0002F88C,
        &_character0002F88D,
        &_character0002F88E,
        &_character0002F88F,
        &_character0002F890,
        &_character0002F891,
        &_character0002F892,
        &_character0002F893,
        &_character0002F894,
        &_character0002F895,
        &_character0002F896,
        &_character0002F897,
        &_character0002F898,
        &_character0002F899,
        &_character0002F89A,
        &_character0002F89B,
        &_character0002F89C,
        &_character0002F89D,
        &_character0002F89E,
        &_character0002F89F,
        &_character0002F8A0,
        &_character0002F8A1,
        &_character0002F8A2,
        &_character0002F8A3,
        &_character0002F8A4,
        &_character0002F8A5,
        &_character0002F8A6,
        &_character0002F8A7,
        &_character0002F8A8,
        &_character0002F8A9,
        &_character0002F8AA,
        &_character0002F8AB,
        &_character0002F8AC,
        &_character0002F8AD,
        &_character0002F8AE,
        &_character0002F8AF,
        &_character0002F8B0,
        &_character0002F8B1,
        &_character0002F8B2,
        &_character0002F8B3,
        &_character0002F8B4,
        &_character0002F8B5,
        &_character0002F8B6,
        &_character0002F8B7,
        &_character0002F8B8,
        &_character0002F8B9,
        &_character0002F8BA,
        &_character0002F8BB,
        &_character0002F8BC,
        &_character0002F8BD,
        &_character0002F8BE,
        &_character0002F8BF,
        &_character0002F8C0,
        &_character0002F8C1,
        &_character0002F8C2,
        &_character0002F8C3,
        &_character0002F8C4,
        &_character0002F8C5,
        &_character0002F8C6,
        &_character0002F8C7,
        &_character0002F8C8,
        &_character0002F8C9,
        &_character0002F8CA,
        &_character0002F8CB,
        &_character0002F8CC,
        &_character0002F8CD,
        &_character0002F8CE,
        &_character0002F8CF,
        &_character0002F8D0,
        &_character0002F8D1,
        &_character0002F8D2,
        &_character0002F8D3,
        &_character0002F8D4,
        &_character0002F8D5,
        &_character0002F8D6,
        &_character0002F8D7,
        &_character0002F8D8,
        &_character0002F8D9,
        &_character0002F8DA,
        &_character0002F8DB,
        &_character0002F8DC,
        &_character0002F8DD,
        &_character0002F8DE,
        &_character0002F8DF,
        &_character0002F8E0,
        &_character0002F8E1,
        &_character0002F8E2,
        &_character0002F8E3,
        &_character0002F8E4,
        &_character0002F8E5,
        &_character0002F8E6,
        &_character0002F8E7,
        &_character0002F8E8,
        &_character0002F8E9,
        &_character0002F8EA,
        &_character0002F8EB,
        &_character0002F8EC,
        &_character0002F8ED,
        &_character0002F8EE,
        &_character0002F8EF,
        &_character0002F8F0,
        &_character0002F8F1,
        &_character0002F8F2,
        &_character0002F8F3,
        &_character0002F8F4,
        &_character0002F8F5,
        &_character0002F8F6,
        &_character0002F8F7,
        &_character0002F8F8,
        &_character0002F8F9,
        &_character0002F8FA,
        &_character0002F8FB,
        &_character0002F8FC,
        &_character0002F8FD,
        &_character0002F8FE,
        &_character0002F8FF,
        &_character0002F900,
        &_character0002F901,
        &_character0002F902,
        &_character0002F903,
        &_character0002F904,
        &_character0002F905,
        &_character0002F906,
        &_character0002F907,
        &_character0002F908,
        &_character0002F909,
        &_character0002F90A,
        &_character0002F90B,
        &_character0002F90C,
        &_character0002F90D,
        &_character0002F90E,
        &_character0002F90F,
        &_character0002F910,
        &_character0002F911,
        &_character0002F912,
        &_character0002F913,
        &_character0002F914,
        &_character0002F915,
        &_character0002F916,
        &_character0002F917,
        &_character0002F918,
        &_character0002F919,
        &_character0002F91A,
        &_character0002F91B,
        &_character0002F91C,
        &_character0002F91D,
        &_character0002F91E,
        &_character0002F91F,
        &_character0002F920,
        &_character0002F921,
        &_character0002F922,
        &_character0002F923,
        &_character0002F924,
        &_character0002F925,
        &_character0002F926,
        &_character0002F927,
        &_character0002F928,
        &_character0002F929,
        &_character0002F92A,
        &_character0002F92B,
        &_character0002F92C,
        &_character0002F92D,
        &_character0002F92E,
        &_character0002F92F,
        &_character0002F930,
        &_character0002F931,
        &_character0002F932,
        &_character0002F933,
        &_character0002F934,
        &_character0002F935,
        &_character0002F936,
        &_character0002F937,
        &_character0002F938,
        &_character0002F939,
        &_character0002F93A,
        &_character0002F93B,
        &_character0002F93C,
        &_character0002F93D,
        &_character0002F93E,
        &_character0002F93F,
        &_character0002F940,
        &_character0002F941,
        &_character0002F942,
        &_character0002F943,
        &_character0002F944,
        &_character0002F945,
        &_character0002F946,
        &_character0002F947,
        &_character0002F948,
        &_character0002F949,
        &_character0002F94A,
        &_character0002F94B,
        &_character0002F94C,
        &_character0002F94D,
        &_character0002F94E,
        &_character0002F94F,
        &_character0002F950,
        &_character0002F951,
        &_character0002F952,
        &_character0002F953,
        &_character0002F954,
        &_character0002F955,
        &_character0002F956,
        &_character0002F957,
        &_character0002F958,
        &_character0002F959,
        &_character0002F95A,
        &_character0002F95B,
        &_character0002F95C,
        &_character0002F95D,
        &_character0002F95E,
        &_character0002F95F,
        &_character0002F960,
        &_character0002F961,
        &_character0002F962,
        &_character0002F963,
        &_character0002F964,
        &_character0002F965,
        &_character0002F966,
        &_character0002F967,
        &_character0002F968,
        &_character0002F969,
        &_character0002F96A,
        &_character0002F96B,
        &_character0002F96C,
        &_character0002F96D,
        &_character0002F96E,
        &_character0002F96F,
        &_character0002F970,
        &_character0002F971,
        &_character0002F972,
        &_character0002F973,
        &_character0002F974,
        &_character0002F975,
        &_character0002F976,
        &_character0002F977,
        &_character0002F978,
        &_character0002F979,
        &_character0002F97A,
        &_character0002F97B,
        &_character0002F97C,
        &_character0002F97D,
        &_character0002F97E,
        &_character0002F97F,
        &_character0002F980,
        &_character0002F981,
        &_character0002F982,
        &_character0002F983,
        &_character0002F984,
        &_character0002F985,
        &_character0002F986,
        &_character0002F987,
        &_character0002F988,
        &_character0002F989,
        &_character0002F98A,
        &_character0002F98B,
        &_character0002F98C,
        &_character0002F98D,
        &_character0002F98E,
        &_character0002F98F,
        &_character0002F990,
        &_character0002F991,
        &_character0002F992,
        &_character0002F993,
        &_character0002F994,
        &_character0002F995,
        &_character0002F996,
        &_character0002F997,
        &_character0002F998,
        &_character0002F999,
        &_character0002F99A,
        &_character0002F99B,
        &_character0002F99C,
        &_character0002F99D,
        &_character0002F99E,
        &_character0002F99F,
        &_character0002F9A0,
        &_character0002F9A1,
        &_character0002F9A2,
        &_character0002F9A3,
        &_character0002F9A4,
        &_character0002F9A5,
        &_character0002F9A6,
        &_character0002F9A7,
        &_character0002F9A8,
        &_character0002F9A9,
        &_character0002F9AA,
        &_character0002F9AB,
        &_character0002F9AC,
        &_character0002F9AD,
        &_character0002F9AE,
        &_character0002F9AF,
        &_character0002F9B0,
        &_character0002F9B1,
        &_character0002F9B2,
        &_character0002F9B3,
        &_character0002F9B4,
        &_character0002F9B5,
        &_character0002F9B6,
        &_character0002F9B7,
        &_character0002F9B8,
        &_character0002F9B9,
        &_character0002F9BA,
        &_character0002F9BB,
        &_character0002F9BC,
        &_character0002F9BD,
        &_character0002F9BE,
        &_character0002F9BF,
        &_character0002F9C0,
        &_character0002F9C1,
        &_character0002F9C2,
        &_character0002F9C3,
        &_character0002F9C4,
        &_character0002F9C5,
        &_character0002F9C6,
        &_character0002F9C7,
        &_character0002F9C8,
        &_character0002F9C9,
        &_character0002F9CA,
        &_character0002F9CB,
        &_character0002F9CC,
        &_character0002F9CD,
        &_character0002F9CE,
        &_character0002F9CF,
        &_character0002F9D0,
        &_character0002F9D1,
        &_character0002F9D2,
        &_character0002F9D3,
        &_character0002F9D4,
        &_character0002F9D5,
        &_character0002F9D6,
        &_character0002F9D7,
        &_character0002F9D8,
        &_character0002F9D9,
        &_character0002F9DA,
        &_character0002F9DB,
        &_character0002F9DC,
        &_character0002F9DD,
        &_character0002F9DE,
        &_character0002F9DF,
        &_character0002F9E0,
        &_character0002F9E1,
        &_character0002F9E2,
        &_character0002F9E3,
        &_character0002F9E4,
        &_character0002F9E5,
        &_character0002F9E6,
        &_character0002F9E7,
        &_character0002F9E8,
        &_character0002F9E9,
        &_character0002F9EA,
        &_character0002F9EB,
        &_character0002F9EC,
        &_character0002F9ED,
        &_character0002F9EE,
        &_character0002F9EF,
        &_character0002F9F0,
        &_character0002F9F1,
        &_character0002F9F2,
        &_character0002F9F3,
        &_character0002F9F4,
        &_character0002F9F5,
        &_character0002F9F6,
        &_character0002F9F7,
        &_character0002F9F8,
        &_character0002F9F9,
        &_character0002F9FA,
        &_character0002F9FB,
        &_character0002F9FC,
        &_character0002F9FD,
        &_character0002F9FE,
        &_character0002F9FF,
        &_character0002FA00,
        &_character0002FA01,
        &_character0002FA02,
        &_character0002FA03,
        &_character0002FA04,
        &_character0002FA05,
        &_character0002FA06,
        &_character0002FA07,
        &_character0002FA08,
        &_character0002FA09,
        &_character0002FA0A,
        &_character0002FA0B,
        &_character0002FA0C,
        &_character0002FA0D,
        &_character0002FA0E,
        &_character0002FA0F,
        &_character0002FA10,
        &_character0002FA11,
        &_character0002FA12,
        &_character0002FA13,
        &_character0002FA14,
        &_character0002FA15,
        &_character0002FA16,
        &_character0002FA17,
        &_character0002FA18,
        &_character0002FA19,
        &_character0002FA1A,
        &_character0002FA1B,
        &_character0002FA1C,
        &_character0002FA1D,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table3000E0000[2048] =
    {
        0,
        &_character000E0001,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000E0020,
        &_character000E0021,
        &_character000E0022,
        &_character000E0023,
        &_character000E0024,
        &_character000E0025,
        &_character000E0026,
        &_character000E0027,
        &_character000E0028,
        &_character000E0029,
        &_character000E002A,
        &_character000E002B,
        &_character000E002C,
        &_character000E002D,
        &_character000E002E,
        &_character000E002F,
        &_character000E0030,
        &_character000E0031,
        &_character000E0032,
        &_character000E0033,
        &_character000E0034,
        &_character000E0035,
        &_character000E0036,
        &_character000E0037,
        &_character000E0038,
        &_character000E0039,
        &_character000E003A,
        &_character000E003B,
        &_character000E003C,
        &_character000E003D,
        &_character000E003E,
        &_character000E003F,
        &_character000E0040,
        &_character000E0041,
        &_character000E0042,
        &_character000E0043,
        &_character000E0044,
        &_character000E0045,
        &_character000E0046,
        &_character000E0047,
        &_character000E0048,
        &_character000E0049,
        &_character000E004A,
        &_character000E004B,
        &_character000E004C,
        &_character000E004D,
        &_character000E004E,
        &_character000E004F,
        &_character000E0050,
        &_character000E0051,
        &_character000E0052,
        &_character000E0053,
        &_character000E0054,
        &_character000E0055,
        &_character000E0056,
        &_character000E0057,
        &_character000E0058,
        &_character000E0059,
        &_character000E005A,
        &_character000E005B,
        &_character000E005C,
        &_character000E005D,
        &_character000E005E,
        &_character000E005F,
        &_character000E0060,
        &_character000E0061,
        &_character000E0062,
        &_character000E0063,
        &_character000E0064,
        &_character000E0065,
        &_character000E0066,
        &_character000E0067,
        &_character000E0068,
        &_character000E0069,
        &_character000E006A,
        &_character000E006B,
        &_character000E006C,
        &_character000E006D,
        &_character000E006E,
        &_character000E006F,
        &_character000E0070,
        &_character000E0071,
        &_character000E0072,
        &_character000E0073,
        &_character000E0074,
        &_character000E0075,
        &_character000E0076,
        &_character000E0077,
        &_character000E0078,
        &_character000E0079,
        &_character000E007A,
        &_character000E007B,
        &_character000E007C,
        &_character000E007D,
        &_character000E007E,
        &_character000E007F,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000E0100,
        &_character000E0101,
        &_character000E0102,
        &_character000E0103,
        &_character000E0104,
        &_character000E0105,
        &_character000E0106,
        &_character000E0107,
        &_character000E0108,
        &_character000E0109,
        &_character000E010A,
        &_character000E010B,
        &_character000E010C,
        &_character000E010D,
        &_character000E010E,
        &_character000E010F,
        &_character000E0110,
        &_character000E0111,
        &_character000E0112,
        &_character000E0113,
        &_character000E0114,
        &_character000E0115,
        &_character000E0116,
        &_character000E0117,
        &_character000E0118,
        &_character000E0119,
        &_character000E011A,
        &_character000E011B,
        &_character000E011C,
        &_character000E011D,
        &_character000E011E,
        &_character000E011F,
        &_character000E0120,
        &_character000E0121,
        &_character000E0122,
        &_character000E0123,
        &_character000E0124,
        &_character000E0125,
        &_character000E0126,
        &_character000E0127,
        &_character000E0128,
        &_character000E0129,
        &_character000E012A,
        &_character000E012B,
        &_character000E012C,
        &_character000E012D,
        &_character000E012E,
        &_character000E012F,
        &_character000E0130,
        &_character000E0131,
        &_character000E0132,
        &_character000E0133,
        &_character000E0134,
        &_character000E0135,
        &_character000E0136,
        &_character000E0137,
        &_character000E0138,
        &_character000E0139,
        &_character000E013A,
        &_character000E013B,
        &_character000E013C,
        &_character000E013D,
        &_character000E013E,
        &_character000E013F,
        &_character000E0140,
        &_character000E0141,
        &_character000E0142,
        &_character000E0143,
        &_character000E0144,
        &_character000E0145,
        &_character000E0146,
        &_character000E0147,
        &_character000E0148,
        &_character000E0149,
        &_character000E014A,
        &_character000E014B,
        &_character000E014C,
        &_character000E014D,
        &_character000E014E,
        &_character000E014F,
        &_character000E0150,
        &_character000E0151,
        &_character000E0152,
        &_character000E0153,
        &_character000E0154,
        &_character000E0155,
        &_character000E0156,
        &_character000E0157,
        &_character000E0158,
        &_character000E0159,
        &_character000E015A,
        &_character000E015B,
        &_character000E015C,
        &_character000E015D,
        &_character000E015E,
        &_character000E015F,
        &_character000E0160,
        &_character000E0161,
        &_character000E0162,
        &_character000E0163,
        &_character000E0164,
        &_character000E0165,
        &_character000E0166,
        &_character000E0167,
        &_character000E0168,
        &_character000E0169,
        &_character000E016A,
        &_character000E016B,
        &_character000E016C,
        &_character000E016D,
        &_character000E016E,
        &_character000E016F,
        &_character000E0170,
        &_character000E0171,
        &_character000E0172,
        &_character000E0173,
        &_character000E0174,
        &_character000E0175,
        &_character000E0176,
        &_character000E0177,
        &_character000E0178,
        &_character000E0179,
        &_character000E017A,
        &_character000E017B,
        &_character000E017C,
        &_character000E017D,
        &_character000E017E,
        &_character000E017F,
        &_character000E0180,
        &_character000E0181,
        &_character000E0182,
        &_character000E0183,
        &_character000E0184,
        &_character000E0185,
        &_character000E0186,
        &_character000E0187,
        &_character000E0188,
        &_character000E0189,
        &_character000E018A,
        &_character000E018B,
        &_character000E018C,
        &_character000E018D,
        &_character000E018E,
        &_character000E018F,
        &_character000E0190,
        &_character000E0191,
        &_character000E0192,
        &_character000E0193,
        &_character000E0194,
        &_character000E0195,
        &_character000E0196,
        &_character000E0197,
        &_character000E0198,
        &_character000E0199,
        &_character000E019A,
        &_character000E019B,
        &_character000E019C,
        &_character000E019D,
        &_character000E019E,
        &_character000E019F,
        &_character000E01A0,
        &_character000E01A1,
        &_character000E01A2,
        &_character000E01A3,
        &_character000E01A4,
        &_character000E01A5,
        &_character000E01A6,
        &_character000E01A7,
        &_character000E01A8,
        &_character000E01A9,
        &_character000E01AA,
        &_character000E01AB,
        &_character000E01AC,
        &_character000E01AD,
        &_character000E01AE,
        &_character000E01AF,
        &_character000E01B0,
        &_character000E01B1,
        &_character000E01B2,
        &_character000E01B3,
        &_character000E01B4,
        &_character000E01B5,
        &_character000E01B6,
        &_character000E01B7,
        &_character000E01B8,
        &_character000E01B9,
        &_character000E01BA,
        &_character000E01BB,
        &_character000E01BC,
        &_character000E01BD,
        &_character000E01BE,
        &_character000E01BF,
        &_character000E01C0,
        &_character000E01C1,
        &_character000E01C2,
        &_character000E01C3,
        &_character000E01C4,
        &_character000E01C5,
        &_character000E01C6,
        &_character000E01C7,
        &_character000E01C8,
        &_character000E01C9,
        &_character000E01CA,
        &_character000E01CB,
        &_character000E01CC,
        &_character000E01CD,
        &_character000E01CE,
        &_character000E01CF,
        &_character000E01D0,
        &_character000E01D1,
        &_character000E01D2,
        &_character000E01D3,
        &_character000E01D4,
        &_character000E01D5,
        &_character000E01D6,
        &_character000E01D7,
        &_character000E01D8,
        &_character000E01D9,
        &_character000E01DA,
        &_character000E01DB,
        &_character000E01DC,
        &_character000E01DD,
        &_character000E01DE,
        &_character000E01DF,
        &_character000E01E0,
        &_character000E01E1,
        &_character000E01E2,
        &_character000E01E3,
        &_character000E01E4,
        &_character000E01E5,
        &_character000E01E6,
        &_character000E01E7,
        &_character000E01E8,
        &_character000E01E9,
        &_character000E01EA,
        &_character000E01EB,
        &_character000E01EC,
        &_character000E01ED,
        &_character000E01EE,
        &_character000E01EF,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table3000F0000[2048] =
    {
        &_character000F0000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table3000FF800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character000FFFFD,
        0,
        0
    };

    static _CharacterInfo * _table300100000[2048] =
    {
        &_character00100000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo * _table30010F800[2048] =
    {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        &_character0010FFFD,
        0,
        0
    };

    static _CharacterInfo ** _table200000000[2048] =
    {
        _table300000000,
        _table300000800,
        _table300001000,
        _table300001800,
        _table300002000,
        _table300002800,
        _table300003000,
        0,
        0,
        _table300004800,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table300009800,
        _table30000A000,
        _table30000A800,
        0,
        0,
        0,
        0,
        _table30000D000,
        _table30000D800,
        _table30000E000,
        0,
        0,
        _table30000F800,
        _table300010000,
        _table300010800,
        0,
        0,
        _table300012000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table30001D000,
        0,
        0,
        0,
        0,
        0,
        _table300020000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table30002A000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table30002F800,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table3000E0000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table3000F0000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table3000FF800,
        _table300100000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        _table30010F800,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
    };

    static _CharacterInfo *** _table1[1024] =
    {
        _table200000000,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
    };
}
#endif  //  __UnicodeData_hpp_included__
//  End of UnicodeData.hpp
